# MathOptInterface

| **Documentation** | **Build Status** |
|:-----------------:|:----------------:|
| [![][docs-stable-img]][docs-stable-url] [![][docs-dev-img]][docs-dev-url] | [![Build Status][build-img]][build-url] [![Codecov branch][codecov-img]][codecov-url] |

An abstraction layer for mathematical optimization solvers.

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-stable-url]: http://jump.dev/MathOptInterface.jl/stable
[docs-dev-url]: http://jump.dev/MathOptInterface.jl/dev

[build-img]: https://github.com/JuMP-dev/MathOptInterface.jl/actions/workflows/ci.yml/badge.svg?branch=master
[build-url]: https://github.com/JuMP-dev/MathOptInterface.jl/actions?query=workflow%3ACI
[codecov-img]: https://codecov.io/gh/JuMP-dev/MathOptInterface.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuMP-dev/MathOptInterface.jl/branch/master

## Citing MathOptInterface

If you find MathOptInterface useful in your work, we kindly request that you cite the
following [paper](https://pubsonline.informs.org/doi/10.1287/ijoc.2021.1067):
```bibtex
@article{legat2021mathoptinterface,
    title={{MathOptInterface}: a data structure for mathematical optimization problems},
    author={Legat, Beno{\^\i}t and Dowson, Oscar and Dias Garcia, Joaquim and Lubin, Miles},
    journal={INFORMS Journal on Computing},
    year={2021},
    volume={34},
    number={2},
    pages={672--689},
    doi={10.1287/ijoc.2021.1067},
    publisher={INFORMS}
}
```
A preprint of this paper is [freely available](https://arxiv.org/abs/2002.03447).

# Tracking the time-to-first-solve

This script is used to benchmark the
[time-to-first-solve issue](https://github.com/jump-dev/MathOptInterface.jl/issues/1313).

It can be run as follows:
```
cd ~/.julia/dev/MathOptInterface/perf/time_to_first_solve
julia --project=. script.jl clp
julia --project=. script.jl clp --no-bridge
julia --project=. script.jl glpk
julia --project=. script.jl glpk --no-bridge
```

# Variable ordering in NL files

This concept continues to befuddle me every time I go to investigate the code,
so here is an attempt to write out how variables are ordered in an NL file.

There are two key resources:

 1. Gay, D. (2005). Writing .nl files. https://ampl.github.io/nlwrite.pdf
 2. Gay, D. (2017). Hooking your solver to AMPL. https://ampl.com/REFS/hooking3.pdf

## A textualist's interpretation

Despite being called "Writing .nl files," the first resource is very sparse in
describing how to write an NL file. It contains the following paragraph:

> Variables are ordered as described in Tables 3 and 4 of [5], because some
> solvers treat linear constraints and variables specially. You only need to
> worry about such permutations if you are using a solver that cares about them.

where [5] means "Hooking your solver to AMPL."

Following the citation leads to a single paragraph and two tables:

> When writing stub.nl, AMPL orders the variables as shown in Tables 3 and 4 and
> the constraints as shown in Table 5. These tables also give expressions for
> how many entities are in each category. Table 4 applies to AMPL versions ≥
> 19930630; `nlvb = – 1` signifies earlier versions. For all versions, the first
> `nlvc` variables appear nonlinearly in at least one constraint. If
> `nlvo > nlvc`, the first `nlvc` variables may or may not appear nonlinearly in
> an objective, but the next `nlvo – nlvc` variables do appear nonlinearly in at
> least one objective. Otherwise all of the first `nlvo` variables appear
> nonlinearly in an objective.

This is a little confusing, but it suggests that the order of the variables
depends on whether `nlvo` is greater than `nlvc`. What are these acronyms?

The three most important are:
 * `nlvc` the number of variables that appear nonlinearly in a constraint
 * `nlvo` the number of variables that appear nonlinearly in an objective
 * `nlvb` the number of variables that appear nonlinearly in an objective and a
   constraint.
These can all appear with a `i` suffix, which means that they are integer. We'll
also see `nwv`, `niv`, and `nbv` for linear network variables, linear integer
variables, and linear binary variables.

Following the citations, Tables 3 and 4 are (Table 5 is unimportant):

Table 3: ordering of variables

| Category                    | Count                                       |
| --------------------------- | ------------------------------------------- |
| nonlinear                   | `max{nlvc, nlvo}`; see Table 4.             |
| linear arcs                 | `nwv`                                       |
| other linear                | `n_var - (max{nlvc,nlvo} + niv + nbv + nwv)`|
| linearly used binary        | `nbv`                                       |
| linearly used other integer | `niv`                                       |

Table 4: ordering of Nonlinear Variables.

| Smoothness | Appearance           | Count                         |
| ---------- | -------------------- | ------------------------------|
| continuous | in an objective and in a constraint | `nlvb - nlbvi` |
| integer    | in an objective and in a constraint | `nlvbi`        |
| continuous | just in constraints  | `nlvc - (nlvb + nlvci)`       |
| integer    | just in constraints  | `nlvci`                       |
| continuous | just in objectives   | `max{0, nlvo - nlvc}`         |
| integer    | just in objectives   | `nlvoi`                       |

## Putting the tables together

The two tables are clearly asking that we do something like this.

| Smoothness | Appearance           | Count                         |
| ---------- | -------------------- | ------------------------------|
| continuous | in an objective and in a constraint | `nlvb - nlbvi` |
| integer    | in an objective and in a constraint | `nlvbi`        |
| continuous | just in constraints  | `nlvc - (nlvb + nlvci)`       |
| integer    | just in constraints  | `nlvci`                       |
| continuous | just in objectives   | `max{0, nlvo - nlvc}`         |
| integer    | just in objectives   | `nlvoi`                       |
| linear arcs                 |     | `nwv`                         |
| other linear                |     | `n_var - (max{nlvc,nlvo} + niv + nbv + nwv)`|
| linearly used binary        |     | `nbv`                         |
| linearly used other integer |     | `niv`                         |

We can drop the "linear arcs" row and `nwv` because MOI doesn't represent
network problems, which leaves us with:

| Smoothness | Appearance           | Count                         |
| ---------- | -------------------- | ------------------------------|
| continuous | in an objective and in a constraint | `nlvb - nlbvi` |
| integer    | in an objective and in a constraint | `nlvbi`        |
| continuous | just in constraints  | `nlvc - (nlvb + nlvci)`       |
| integer    | just in constraints  | `nlvci`                       |
| continuous | just in objectives   | `max{0, nlvo - nlvc}`         |
| integer    | just in objectives   | `nlvoi`                       |
| other linear                |     | `n_var - (max{nlvc,nlvo} + niv + nbv)`|
| linearly used binary        |     | `nbv`                         |
| linearly used other integer |     | `niv`                         |

But does this table make sense? No. Here's the header from `geartrain.nl`:
```
g3 0 1 0	# problem geartrain
 4 0 1 0 0	# vars, constraints, objectives, ranges, eqns
 0 1	# nonlinear constraints, objectives
 0 0	# network constraints: nonlinear, linear
 0 4 0	# nonlinear vars in constraints, objectives, both
 0 0 0 1	# linear network variables; functions; arith, flags
 0 0 0 0 4	# discrete variables: binary, integer, nonlinear (b,c,o)
 0 4	# nonzeros in Jacobian, gradients
 0 0	# max name lengths: constraints, variables
 0 0 0 0 0	# common exprs: b,c,o,c1,o1
```

It has `n_var = 4`, `nlvo = 4`, and `nlvoi = 4` (all others are `0`).

| Smoothness | Appearance           | Count                         | `geartrain.nl`  |
| ---------- | -------------------- | ------------------------------| - |
| continuous | in an objective and in a constraint | `nlvb - nlbvi` | 0 |
| integer    | in an objective and in a constraint | `nlvbi`        | 0 |
| continuous | just in constraints  | `nlvc - (nlvb + nlvci)`       | 0 |
| integer    | just in constraints  | `nlcvi`                       | 0 |
| continuous | just in objectives   | `max{0, nlvo - nlvc}`         | 4 |
| integer    | just in objectives   | `nlvoi`                       | 4 |
| other linear                |     | `n_var - (max{nlvc,nlvo} + niv + nbv)`| 0 |
| linearly used binary        |     | `nbv`                         | 0 |
| linearly used other integer |     | `niv`                         | 0 |

But the rows would sum to give `8`, not `4`!

I think `max{0, nlvo - nlvc}` should be `max{0, nlvo - nlvc - nlvoi}`.

## The meaning of `nlvo`

Even then, the table we have doesn't make sense. Why is the number of nonlinear
variables `max{nlvc, nlvo}` in Table 3? Taken literally, this means that the
number of nonlinear variables is the max of the number of nonlinear variables
that appear in the constraints and the number of nonlinear variables that appear
in the objectives. That can't be true, which means that something is wrong.

Here's a simple AMPL model:
```
var x;
var y;
minimize obj: x^2;
subject to c: y^2 <= 1;
```
It produces the following header:
```
g3 0 1 0	# problem test_simple
 2 1 1 0 0	# vars, constraints, objectives, ranges, eqns
 1 1	# nonlinear constraints, objectives
 0 0	# network constraints: nonlinear, linear
 1 2 0	# nonlinear vars in constraints, objectives, both
 0 0 0 1	# linear network variables; functions; arith, flags
 0 0 0 0 0	# discrete variables: binary, integer, nonlinear (b,c,o)
 1 1	# nonzeros in Jacobian, gradients
 0 0	# max name lengths: constraints, variables
 0 0 0 0 0	# common exprs: b,c,o,c1,o1
```
This clearly says that there are _two_ nonlinear variables in the objectives,
even though there is very clearly only one.

If we tweak the model very slightly:
```
var x;
var y;
minimize obj: x^2;
subject to c: x^2 + y^2 <= 1;
```
we get the following header:
```
g3 0 1 0	# problem test_simple
 2 1 1 0 0	# vars, constraints, objectives, ranges, eqns
 1 1	# nonlinear constraints, objectives
 0 0	# network constraints: nonlinear, linear
 2 1 1	# nonlinear vars in constraints, objectives, both
 0 0 0 1	# linear network variables; functions; arith, flags
 0 0 0 0 0	# discrete variables: binary, integer, nonlinear (b,c,o)
 2 1	# nonzeros in Jacobian, gradients
 0 0	# max name lengths: constraints, variables
 0 0 0 0 0	# common exprs: b,c,o,c1,o1
```
This looks better. There are two nonlinear variables in the constraints, one in
the objective, and one that appears in both.

So what is going on with `nlvo`?

The answer is that despite all claims to the contrary, it does not represent the
number of nonlinear variables that appear in the objective.

If all variables that appear nonlinearly in the objective also appear in a
constraint, then `nlvo = nlvb`, and we can interpret the table as usual.

But, **if a variable appears nonlinearly in the objective but not in a**
**constraint**, then `nlvo` is the total number of variables that appear
nonlinearly in the objective or a constraint.

This solves the issue or `max{nlvc, nlvo}`, because it is now correct in both
cases. It also lets you puzzle out the text description in the papers:

> For all versions, the first `nlvc` variables appear nonlinearly in at least
> one constraint.

Yes, always true in both scenarios.

> If `nlvo > nlvc`, the first `nlvc` variables may or may not appear nonlinearly
> in an objective,

This must be the second scenario. In which case it is true. The first `nlvb`
will appear nonlinearly in an objective, and then `nlvc - nlvb` will appear
nonlinearly in a constraint.

> but the next `nlvo – nlvc` variables do appear nonlinearly in at least one
> objective.

Again, yes, because these are now the variables which appear nonlinearly in an
objective but _not_ in a constraint.

> Otherwise all of the first `nlvo` variables appear nonlinearly in an
> objective.

That means `nlvo <= nlvc`, in which case `nlvo = nlvb` and so the first `nlvo`
variables must appear nonlinearly in an objective.

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    NormSpectralBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`NormSpectralBridge` implements the following reformulation:

  * ``t \\ge \\sigma_1(X)`` into
    ``\\left[\\begin{array}{c c}t\\mathbf{I} & X^\\top \\\\ X & t \\mathbf{I}\\end{array}\\right] \\succeq 0``

## Source node

`NormSpectralBridge` supports:

  * `G` in [`MOI.NormSpectralCone`](@ref)

## Target nodes

`NormSpectralBridge` creates:

  * `F` in [`MOI.PositiveSemidefiniteConeTriangle`](@ref)
"""
struct NormSpectralBridge{T,F,G} <: AbstractBridge
    row_dim::Int
    column_dim::Int
    psd_index::MOI.ConstraintIndex{F,MOI.PositiveSemidefiniteConeTriangle}
end

const NormSpectral{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NormSpectralBridge{T},OT}

function bridge_constraint(
    ::Type{NormSpectralBridge{T,F,G}},
    model::MOI.ModelLike,
    f::G,
    s::MOI.NormSpectralCone,
) where {T,F,G}
    f_scalars = MOI.Utilities.eachscalar(f)
    row_dim, column_dim = s.row_dim, s.column_dim
    psd_set = MOI.PositiveSemidefiniteConeTriangle(row_dim + column_dim)
    psd_func =
        MOI.Utilities.zero_with_output_dimension(F, MOI.dimension(psd_set))
    for i in 1:(row_dim+column_dim)
        k = MOI.Utilities.trimap(i, i)
        MOI.Utilities.operate_output_index!(+, T, k, psd_func, f_scalars[1])
    end
    X_idx = 2
    for j in 1:column_dim, i in (column_dim+1):(row_dim+column_dim)
        k = MOI.Utilities.trimap(i, j)
        MOI.Utilities.operate_output_index!(+, T, k, psd_func, f_scalars[X_idx])
        X_idx += 1
    end
    psd_index = MOI.add_constraint(model, psd_func, psd_set)
    return NormSpectralBridge{T,F,G}(row_dim, column_dim, psd_index)
end

function MOI.supports_constraint(
    ::Type{NormSpectralBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.NormSpectralCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:NormSpectralBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{NormSpectralBridge{T,F,G}},
) where {T,F,G}
    return Tuple{Type,Type}[(F, MOI.PositiveSemidefiniteConeTriangle)]
end

function concrete_bridge_type(
    ::Type{<:NormSpectralBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.NormSpectralCone},
) where {T}
    F = MOI.Utilities.promote_operation(
        vcat,
        T,
        MOI.Utilities.scalar_type(G),
        T,
    )
    return NormSpectralBridge{T,F,G}
end

function MOI.get(
    ::NormSpectralBridge{T,F,G},
    ::MOI.NumberOfConstraints{F,MOI.PositiveSemidefiniteConeTriangle},
)::Int64 where {T,F,G}
    return 1
end

function MOI.get(
    bridge::NormSpectralBridge{T,F,G},
    ::MOI.ListOfConstraintIndices{F,MOI.PositiveSemidefiniteConeTriangle},
) where {T,F,G}
    return [bridge.psd_index]
end

function MOI.delete(model::MOI.ModelLike, bridge::NormSpectralBridge)
    MOI.delete(model, bridge.psd_index)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::NormSpectralBridge{T,F,G},
) where {T,F,G}
    psd_func = MOI.Utilities.eachscalar(
        MOI.get(model, MOI.ConstraintFunction(), bridge.psd_index),
    )
    t = psd_func[1]
    X = psd_func[[
        MOI.Utilities.trimap(i, j) for j in 1:bridge.column_dim for
        i in (bridge.column_dim+1):(bridge.row_dim+bridge.column_dim)
    ]]
    return MOI.Utilities.convert_approx(G, MOI.Utilities.operate(vcat, T, t, X))
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::NormSpectralBridge,
)
    return MOI.NormSpectralCone(bridge.row_dim, bridge.column_dim)
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    ::Type{NormSpectralBridge{T,F,G}},
) where {T,F,G}
    return MOI.supports(
        model,
        attr,
        MOI.ConstraintIndex{F,MOI.PositiveSemidefiniteConeTriangle},
    )
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::NormSpectralBridge,
)
    primal = MOI.get(model, attr, bridge.psd_index)
    if primal === nothing
        return nothing
    end
    t = primal[1]
    side_dim = bridge.row_dim + bridge.column_dim
    X = primal[[
        MOI.Utilities.trimap(i, j) for j in 1:bridge.column_dim for
        i in (bridge.column_dim+1):side_dim
    ]]
    return vcat(t, X)
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintPrimalStart,
    bridge::NormSpectralBridge{T},
    value,
) where {T}
    column_dim = bridge.column_dim
    side_dim = bridge.row_dim + column_dim
    primal = zeros(T, div(side_dim * (side_dim + 1), 2))
    for i in 1:side_dim
        primal[MOI.Utilities.trimap(i, i)] = value[1]
    end
    X_idx = 2
    for j in 1:column_dim, i in (column_dim+1):side_dim
        primal[MOI.Utilities.trimap(i, j)] = value[X_idx]
        X_idx += 1
    end
    MOI.set(model, MOI.ConstraintPrimalStart(), bridge.psd_index, primal)
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintPrimalStart,
    bridge::NormSpectralBridge{T},
    ::Nothing,
) where {T}
    MOI.set(model, MOI.ConstraintPrimalStart(), bridge.psd_index, nothing)
    return
end

# Given [U X'; X V] is dual on PSD constraint, the dual on NormSpectralCone
# constraint is (tr(U) + tr(V), 2X) in NormNuclearCone.
function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    bridge::NormSpectralBridge,
)
    dual = MOI.get(model, attr, bridge.psd_index)
    column_dim = bridge.column_dim
    side_dim = bridge.row_dim + column_dim
    t = sum(dual[MOI.Utilities.trimap(i, i)] for i in 1:side_dim)
    X =
        2 * dual[[
            MOI.Utilities.trimap(i, j) for j in 1:column_dim for
            i in (column_dim+1):side_dim
        ]]
    return vcat(t, X)
end

"""
    NormNuclearBridge{T,F,G,H} <: Bridges.Constraint.AbstractBridge

`NormNuclearBridge` implements the following reformulation:

  * ``t \\ge \\sum_i \\sigma_i (X)`` into
    ``\\left[\\begin{array}{c c}U & X^\\top \\\\ X & V\\end{array}\\right] \\succeq 0``
    and ``2t \\ge tr(U) + tr(V)``.

## Source node

`NormNuclearBridge` supports:

  * `H` in [`MOI.NormNuclearCone`](@ref)

## Target nodes

`NormNuclearBridge` creates:

  * `F` in [`MOI.GreaterThan{T}`](@ref)
  * `G` in [`MOI.PositiveSemidefiniteConeTriangle`](@ref)
"""
struct NormNuclearBridge{T,F,G,H} <: AbstractBridge
    row_dim::Int
    column_dim::Int
    U::Vector{MOI.VariableIndex}
    V::Vector{MOI.VariableIndex}
    ge_index::MOI.ConstraintIndex{F,MOI.GreaterThan{T}}
    psd_index::MOI.ConstraintIndex{G,MOI.PositiveSemidefiniteConeTriangle}
end

const NormNuclear{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NormNuclearBridge{T},OT}

function bridge_constraint(
    ::Type{NormNuclearBridge{T,F,G,H}},
    model::MOI.ModelLike,
    f::H,
    s::MOI.NormNuclearCone,
) where {T,F,G,H}
    f_scalars = MOI.Utilities.eachscalar(f)
    row_dim, column_dim = s.row_dim, s.column_dim
    side_dim = row_dim + column_dim
    U_dim = div(column_dim * (column_dim + 1), 2)
    V_dim = div(row_dim * (row_dim + 1), 2)
    U = MOI.add_variables(model, U_dim)
    V = MOI.add_variables(model, V_dim)
    diag_vars = vcat(
        [U[MOI.Utilities.trimap(i, i)] for i in 1:column_dim],
        [V[MOI.Utilities.trimap(i, i)] for i in 1:row_dim],
    )
    rhs = MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.(one(T), diag_vars),
        zero(T),
    )
    ge_index = MOI.Utilities.normalize_and_add_constraint(
        model,
        MOI.Utilities.operate(
            -,
            T,
            f_scalars[1],
            MOI.Utilities.operate!(/, T, rhs, T(2)),
        ),
        MOI.GreaterThan(zero(T)),
        allow_modify_function = true,
    )
    psd_set = MOI.PositiveSemidefiniteConeTriangle(side_dim)
    psd_func = MOI.VectorOfVariables(U)
    nuc_dim = 1 + row_dim * column_dim
    for i in 1:row_dim
        row_i = (1+i):row_dim:nuc_dim
        psd_func = MOI.Utilities.operate(vcat, T, psd_func, f_scalars[row_i])
        psd_func = MOI.Utilities.operate(
            vcat,
            T,
            psd_func,
            MOI.VectorOfVariables(V[[MOI.Utilities.trimap(i, j) for j in 1:i]]),
        )
    end
    psd_index = MOI.add_constraint(model, psd_func, psd_set)
    return NormNuclearBridge{T,F,G,H}(
        row_dim,
        column_dim,
        U,
        V,
        ge_index,
        psd_index,
    )
end

function MOI.supports_constraint(
    ::Type{NormNuclearBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.NormNuclearCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:NormNuclearBridge},
)
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{NormNuclearBridge{T,F,G,H}},
) where {T,F,G,H}
    return Tuple{Type,Type}[
        (F, MOI.GreaterThan{T}),
        (G, MOI.PositiveSemidefiniteConeTriangle),
    ]
end

function concrete_bridge_type(
    ::Type{<:NormNuclearBridge{T}},
    H::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.NormNuclearCone},
) where {T}
    S = MOI.Utilities.scalar_type(H)
    F = MOI.Utilities.promote_operation(
        -,
        T,
        S,
        MOI.Utilities.promote_operation(
            /,
            T,
            MOI.Utilities.promote_operation(+, T, T, T),
            T,
        ),
    )
    G = MOI.Utilities.promote_operation(vcat, T, MOI.VectorOfVariables, H)
    return NormNuclearBridge{T,F,G,H}
end

function MOI.get(bridge::NormNuclearBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.U) + length(bridge.V)
end

function MOI.get(bridge::NormNuclearBridge, ::MOI.ListOfVariableIndices)
    return vcat(bridge.U, bridge.V)
end

function MOI.get(
    ::NormNuclearBridge{T,F,G,H},
    ::MOI.NumberOfConstraints{F,MOI.GreaterThan{T}},
)::Int64 where {T,F,G,H}
    return 1
end

function MOI.get(
    ::NormNuclearBridge{T,F,G,H},
    ::MOI.NumberOfConstraints{G,MOI.PositiveSemidefiniteConeTriangle},
)::Int64 where {T,F,G,H}
    return 1
end

function MOI.get(
    bridge::NormNuclearBridge{T,F,G,H},
    ::MOI.ListOfConstraintIndices{F,MOI.GreaterThan{T}},
) where {T,F,G,H}
    return [bridge.ge_index]
end

function MOI.get(
    bridge::NormNuclearBridge{T,F,G,H},
    ::MOI.ListOfConstraintIndices{G,MOI.PositiveSemidefiniteConeTriangle},
) where {T,F,G,H}
    return [bridge.psd_index]
end

function MOI.delete(model::MOI.ModelLike, bridge::NormNuclearBridge)
    MOI.delete(model, bridge.ge_index)
    MOI.delete(model, bridge.psd_index)
    MOI.delete(model, bridge.U)
    MOI.delete(model, bridge.V)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::NormNuclearBridge{T,F,G,H},
) where {T,F,G,H}
    ge_func = MOI.get(model, MOI.ConstraintFunction(), bridge.ge_index)
    psd_func = MOI.Utilities.eachscalar(
        MOI.get(model, MOI.ConstraintFunction(), bridge.psd_index),
    )
    column_dim = bridge.column_dim
    side_dim = bridge.row_dim + column_dim
    t = MOI.Utilities.operate(
        +,
        T,
        ge_func,
        MOI.Utilities.operate(
            /,
            T,
            MOI.Utilities.operate(
                +,
                T,
                [psd_func[MOI.Utilities.trimap(i, i)] for i in 1:side_dim]...,
            ),
            T(2),
        ),
    )
    t = MOI.Utilities.remove_variable(
        MOI.Utilities.remove_variable(t, bridge.U),
        bridge.V,
    )
    X = psd_func[[
        MOI.Utilities.trimap(i, j) for j in 1:bridge.column_dim for
        i in (bridge.column_dim+1):side_dim
    ]]
    return MOI.Utilities.convert_approx(H, MOI.Utilities.operate(vcat, T, t, X))
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::NormNuclearBridge,
)
    return MOI.NormNuclearCone(bridge.row_dim, bridge.column_dim)
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    ::Type{NormNuclearBridge{T,F,G,H}},
) where {T,F,G,H}
    ci_1 = MOI.ConstraintIndex{F,MOI.GreaterThan{T}}
    ci_2 = MOI.ConstraintIndex{G,MOI.PositiveSemidefiniteConeTriangle}
    return MOI.supports(model, attr, ci_1) && MOI.supports(model, attr, ci_2)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::NormNuclearBridge,
)
    ge_primal = MOI.get(model, attr, bridge.ge_index)
    psd_primal = MOI.get(model, attr, bridge.psd_index)
    side_dim = bridge.row_dim + bridge.column_dim
    t =
        ge_primal +
        sum(psd_primal[MOI.Utilities.trimap(i, i)] for i in 1:side_dim) / 2
    X = psd_primal[[
        MOI.Utilities.trimap(i, j) for j in 1:bridge.column_dim for
        i in (bridge.column_dim+1):side_dim
    ]]
    return vcat(t, X)
end

# Given t is dual on GreaterThan constraint and [U X'; X V] is dual on PSD
# constraint, the dual on NormNuclearCone constraint is
# (t, 2X) in NormNuclearCone.
function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::NormNuclearBridge,
)
    t = MOI.get(model, attr, bridge.ge_index)
    if t === nothing
        return nothing
    end
    psd_dual = MOI.get(model, attr, bridge.psd_index)
    side_dim = bridge.row_dim + bridge.column_dim
    X =
        2 * psd_dual[[
            MOI.Utilities.trimap(i, j) for j in 1:bridge.column_dim for
            i in (bridge.column_dim+1):side_dim
        ]]
    return vcat(t, X)
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintDualStart,
    bridge::NormNuclearBridge{T},
    value,
) where {T}
    MOI.set(model, MOI.ConstraintDualStart(), bridge.ge_index, value[1])
    column_dim = bridge.column_dim
    side_dim = bridge.row_dim + column_dim
    dual = zeros(T, div(side_dim * (side_dim + 1), 2))
    for i in 1:side_dim
        dual[MOI.Utilities.trimap(i, i)] = value[1]
    end
    X_idx = 2
    for j in 1:column_dim, i in (column_dim+1):side_dim
        dual[MOI.Utilities.trimap(i, j)] = value[X_idx] / 2
        X_idx += 1
    end
    MOI.set(model, MOI.ConstraintDualStart(), bridge.psd_index, dual)
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintDualStart,
    bridge::NormNuclearBridge{T},
    ::Nothing,
) where {T}
    MOI.set(model, MOI.ConstraintDualStart(), bridge.ge_index, nothing)
    MOI.set(model, MOI.ConstraintDualStart(), bridge.psd_index, nothing)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    BinPackingToMILPBridge{T,F} <: Bridges.Constraint.AbstractBridge

`BinPackingToMILPBridge` implements the following reformulation:

  * ``x \\in BinPacking(c, w)`` into a mixed-integer linear program.

## Reformulation

The reformulation is non-trivial, and it depends on the finite domain of each
variable ``x_i``, which we as define ``S_i = \\{l_i,\\ldots,u_i\\}``.

First, we introduce new binary variables ``z_{ij}``, which are ``1`` if variable
``x_i`` takes the value ``j`` in the optimal solution and ``0`` otherwise:
```math
\\begin{aligned}
z_{ij} \\in \\{0, 1\\}                              & \\;\\; \\forall i \\in 1\\ldots d, j \\in S_i  \\\\
x_i - \\sum\\limits_{j\\in S_i} j \\cdot z_{ij} = 0 & \\;\\; \\forall i \\in 1\\ldots d              \\\\
\\sum\\limits_{j\\in S_i} z_{ij} = 1                & \\;\\; \\forall i \\in 1\\ldots d              \\\\
\\end{aligned}
```

Then, we add the capacity constraint for all possible bins ``j``:
```math
\\sum\\limits_{i} w_i z_{ij} \\le c \\forall j \\in \\bigcup_{i=1,\\ldots,d} S_i
```

## Source node

`BinPackingToMILPBridge` supports:

  * `F` in [`MOI.BinPacking{T}`](@ref)

## Target nodes

`BinPackingToMILPBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.LessThan{T}`](@ref)
"""
struct BinPackingToMILPBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
} <: AbstractBridge
    f::F
    s::MOI.BinPacking{T}

    variables::Vector{MOI.VariableIndex}
    less_than::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
    }
    equal_to::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
    }
    bounds::Vector{NTuple{2,T}}
end

const BinPackingToMILP{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{BinPackingToMILPBridge{T},OT}

function bridge_constraint(
    ::Type{BinPackingToMILPBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.BinPacking{T},
) where {T,F}
    return BinPackingToMILPBridge{T,F}(
        f,
        s,
        MOI.VariableIndex[],
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}}[],
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}[],
        NTuple{2,T}[],
    )
end

function MOI.supports_constraint(
    ::Type{<:BinPackingToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.BinPacking{T}},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:BinPackingToMILPBridge},
)
    return Tuple{Type}[(MOI.ZeroOne,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:BinPackingToMILPBridge{T}},
) where {T}
    return Tuple{Type,Type}[
        (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}),
        (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:BinPackingToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.BinPacking{T}},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return BinPackingToMILPBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::BinPackingToMILPBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::BinPackingToMILPBridge,
)
    return bridge.s
end

function MOI.delete(model::MOI.ModelLike, bridge::BinPackingToMILPBridge)
    MOI.delete.(model, bridge.less_than)
    empty!(bridge.less_than)
    MOI.delete.(model, bridge.equal_to)
    empty!(bridge.equal_to)
    MOI.delete.(model, bridge.variables)
    empty!(bridge.variables)
    empty!(bridge.bounds)
    return
end

function MOI.get(bridge::BinPackingToMILPBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.variables)
end

function MOI.get(bridge::BinPackingToMILPBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.variables)
end

function MOI.get(
    bridge::BinPackingToMILPBridge,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64
    return length(bridge.variables)
end

function MOI.get(
    bridge::BinPackingToMILPBridge,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
)
    return [
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}.(z.value) for
        z in bridge.variables
    ]
end

function MOI.get(
    bridge::BinPackingToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return length(bridge.equal_to)
end

function MOI.get(
    bridge::BinPackingToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return copy(bridge.equal_to)
end

function MOI.get(
    bridge::BinPackingToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
)::Int64 where {T}
    return length(bridge.less_than)
end

function MOI.get(
    bridge::BinPackingToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
) where {T}
    return copy(bridge.less_than)
end

MOI.Bridges.needs_final_touch(::BinPackingToMILPBridge) = true

function MOI.Bridges.final_touch(
    bridge::BinPackingToMILPBridge{T,F},
    model::MOI.ModelLike,
) where {T,F}
    S = Dict{T,Vector{Tuple{T,MOI.VariableIndex}}}()
    scalars = collect(MOI.Utilities.eachscalar(bridge.f))
    bounds = Dict{MOI.VariableIndex,NTuple{2,T}}()
    for i in 1:length(scalars)
        x = scalars[i]
        ret = MOI.Utilities.get_bounds(model, bounds, x)
        if ret === nothing
            throw(MOI.Bridges.BridgeRequiresFiniteDomainError(bridge, x))
        end
        if length(bridge.bounds) < i
            # This is the first time calling final_touch
            push!(bridge.bounds, ret)
        elseif bridge.bounds[i] == ret
            # We've called final_touch before, and the bounds match. No need to
            # reformulate a second time.
            continue
        elseif bridge.bounds[i] != ret
            # There is a stored bound, and the current bounds do not match. This
            # means the model has been modified since the previous call to
            # final_touch. We need to delete the bridge and start again.
            MOI.delete(model, bridge)
            MOI.Bridges.final_touch(bridge, model)
            return
        end
        unit_f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], zero(T))
        convex_f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], zero(T))
        for xi in (ret[1]::T):(ret[2]::T)
            new_var, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
            push!(bridge.variables, new_var)
            if !haskey(S, xi)
                S[xi] = Tuple{T,MOI.VariableIndex}[]
            end
            push!(S[xi], (bridge.s.weights[i], new_var))
            push!(unit_f.terms, MOI.ScalarAffineTerm{T}(T(-xi), new_var))
            push!(convex_f.terms, MOI.ScalarAffineTerm{T}(one(T), new_var))
        end
        push!(
            bridge.equal_to,
            MOI.Utilities.normalize_and_add_constraint(
                model,
                MOI.Utilities.operate(+, T, x, unit_f),
                MOI.EqualTo{T}(zero(T));
                allow_modify_function = true,
            ),
        )
        push!(
            bridge.equal_to,
            MOI.add_constraint(model, convex_f, MOI.EqualTo{T}(one(T))),
        )
    end
    # We use a sort so that the model order is deterministic.
    for s in sort!(collect(keys(S)))
        ci = MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction{T}(
                [MOI.ScalarAffineTerm{T}(w, z) for (w, z) in S[s]],
                zero(T),
            ),
            MOI.LessThan{T}(bridge.s.capacity),
        )
        push!(bridge.less_than, ci)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ScalarPenaltyRelaxation(penalty::T) where {T}

A problem modifier that, when passed to [`MOI.modify`](@ref), destructively
modifies the constraint in-place to create a penalized relaxation of the
constraint.

!!! warning
    This is a destructive routine that modifies the constraint in-place. If you
    don't want to modify the original model, use `JuMP.copy_model` to create a
    copy before calling [`MOI.modify`](@ref).

## Reformulation

The penalty relaxation modifies constraints of the form ``f(x) \\in S`` into
``f(x) + y - z \\in S``, where ``y, z \\ge 0``, and then it introduces a penalty
term into the objective of ``a \\times (y + z)`` (if minimizing, else ``-a``),
where ``a`` is `penalty`

When `S` is [`MOI.LessThan`](@ref) or [`MOI.GreaterThan`](@ref), we omit `y` or
`z` respectively as a performance optimization.

## Return value

`MOI.modify(model, ci, ScalarPenaltyRelaxation(penalty))` returns `y + z` as a
[`MOI.ScalarAffineFunction`](@ref). In an optimal solution, query the value of
this function to compute the violation of the constraint.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> c = MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0));

julia> f = MOI.modify(model, c, MOI.Utilities.ScalarPenaltyRelaxation(2.0));

julia> print(model)
Minimize ScalarAffineFunction{Float64}:
 0.0 + 2.0 v[2]

Subject to:

ScalarAffineFunction{Float64}-in-LessThan{Float64}
 0.0 + 1.0 v[1] - 1.0 v[2] <= 2.0

VariableIndex-in-GreaterThan{Float64}
 v[2] >= 0.0

julia> f isa MOI.ScalarAffineFunction{Float64}
true
```
"""
struct ScalarPenaltyRelaxation{T} # <: MOI.AbstractFunctionModification
    # We don't make this a subtype of AbstractFunctionModification to avoid some
    # ambiguities with generic methods in Utilities and Bridges. The underlying
    # reason is that these reformulations can be written using the high-level
    # MOI API, so we don't need special handling for bridges and utilities.
    penalty::T
end

function _change_sense_to_min_if_necessary(
    ::Type{T},
    model::MOI.ModelLike,
) where {T}
    if MOI.get(model, MOI.ObjectiveSense()) != MOI.FEASIBILITY_SENSE
        return
    end
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = zero(MOI.ScalarAffineFunction{T})
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    return
end

function _add_penalty_to_objective(
    model::MOI.ModelLike,
    ::Type{F},
    penalty::MOI.ScalarAffineFunction{T},
) where {
    T,
    F<:Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
    },
}
    f = MOI.get(model, MOI.ObjectiveFunction{F}())
    g = if MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
        MOI.Utilities.operate(+, T, f, penalty)
    else
        MOI.Utilities.operate(-, T, f, penalty)
    end
    MOI.set(model, MOI.ObjectiveFunction{typeof(g)}(), g)
    return
end

function _add_penalty_to_objective(
    ::MOI.ModelLike,
    ::Type{F},
    ::MOI.ScalarAffineFunction,
) where {F}
    return error(
        "Cannot perform `ScalarPenaltyRelaxation` with an objective function of type `$F`",
    )
end

function _relax_constraint(
    ::Type{T},
    model::MOI.ModelLike,
    ci::MOI.ConstraintIndex{F,<:MOI.AbstractScalarSet},
) where {T,F<:Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}}}
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.GreaterThan(zero(T)))
    MOI.modify(model, ci, MOI.ScalarCoefficientChange(x[1], one(T)))
    MOI.modify(model, ci, MOI.ScalarCoefficientChange(x[2], -one(T)))
    return x
end

function _relax_constraint(
    ::Type{T},
    model::MOI.ModelLike,
    ci::MOI.ConstraintIndex{F,MOI.GreaterThan{T}},
) where {T,F<:Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}}}
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(zero(T)))
    MOI.modify(model, ci, MOI.ScalarCoefficientChange(x, one(T)))
    return [x]
end

function _relax_constraint(
    ::Type{T},
    model::MOI.ModelLike,
    ci::MOI.ConstraintIndex{F,MOI.LessThan{T}},
) where {T,F<:Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}}}
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(zero(T)))
    MOI.modify(model, ci, MOI.ScalarCoefficientChange(x, -one(T)))
    return [x]
end

function _relax_constraint(
    ::Type{T},
    model::MOI.ModelLike,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,S},
) where {T,S<:MOI.AbstractScalarSet}
    x, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(zero(T)))
    y, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(zero(T)))
    f = MOI.get(model, MOI.ConstraintFunction(), ci)
    g = MOI.ScalarNonlinearFunction(
        :+,
        Any[f, x, MOI.ScalarNonlinearFunction(:-, Any[y])],
    )
    MOI.set(model, MOI.ConstraintFunction(), ci, g)
    return [x, y]
end

function _relax_constraint(
    ::Type{T},
    model::MOI.ModelLike,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,MOI.GreaterThan{T}},
) where {T}
    x, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(zero(T)))
    f = MOI.get(model, MOI.ConstraintFunction(), ci)
    g = MOI.ScalarNonlinearFunction(:+, [f, x])
    MOI.set(model, MOI.ConstraintFunction(), ci, g)
    return [x]
end

function _relax_constraint(
    ::Type{T},
    model::MOI.ModelLike,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,MOI.LessThan{T}},
) where {T}
    x, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(zero(T)))
    f = MOI.get(model, MOI.ConstraintFunction(), ci)
    g = MOI.ScalarNonlinearFunction(:-, [f, x])
    MOI.set(model, MOI.ConstraintFunction(), ci, g)
    return [x]
end

function MOI.modify(
    model::MOI.ModelLike,
    ci::MOI.ConstraintIndex{F,<:MOI.AbstractScalarSet},
    relax::ScalarPenaltyRelaxation{T},
) where {
    T,
    F<:Union{
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
    },
}
    x = _relax_constraint(T, model, ci)
    p = MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.(relax.penalty, x),
        zero(T),
    )
    _change_sense_to_min_if_necessary(T, model)
    O = MOI.get(model, MOI.ObjectiveFunctionType())
    _add_penalty_to_objective(model, O, p)
    return MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(one(T), x), zero(T))
end

"""
    PenaltyRelaxation(
        penalties = Dict{MOI.ConstraintIndex,Float64}();
        default::Union{Nothing,T} = 1.0,
        warn::Bool = true,
    )

A problem modifier that, when passed to [`MOI.modify`](@ref), destructively
modifies the model in-place to create a penalized relaxation of the constraints.

!!! warning
    This is a destructive routine that modifies the model in-place. If you don't
    want to modify the original model, use `JuMP.copy_model` to create a copy
    before calling [`MOI.modify`](@ref).

## Reformulation

See [`Utilities.ScalarPenaltyRelaxation`](@ref) for details of the
reformulation.

For each constraint `ci`, the penalty passed to [`Utilities.ScalarPenaltyRelaxation`](@ref)
is `get(penalties, ci, default)`. If the value is `nothing`, because `ci` does
not exist in `penalties` and `default = nothing`, then the constraint is
skipped.

## Return value

`MOI.modify(model, PenaltyRelaxation())` returns a
`Dict{MOI.ConstraintIndex,MOI.ScalarAffineFunction}` that maps each constraint
index to the corresponding `y + z` as a [`MOI.ScalarAffineFunction`](@ref). In
an optimal solution, query the value of these functions to compute the violation
of each constraint.

## Relax a subset of constraints

To relax a subset of constraints, pass a `penalties` dictionary and set
`default = nothing`.

## Supported constraint types

The penalty relaxation is currently limited to modifying
[`MOI.ScalarAffineFunction`](@ref) and [`MOI.ScalarQuadraticFunction`](@ref)
constraints in the linear sets [`MOI.LessThan`](@ref), [`MOI.GreaterThan`](@ref),
[`MOI.EqualTo`](@ref) and [`MOI.Interval`](@ref).

It does not include variable bound or integrality constraints, because these
cannot be modified in-place.

To modify variable bounds, rewrite them as linear constraints.

If a constraint cannot be modified, a warning is logged and the
constraint is skipped. The warning can be disabled by setting `warn = false`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> c = MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0));

julia> map = MOI.modify(model, MOI.Utilities.PenaltyRelaxation(default = 2.0));

julia> print(model)
Minimize ScalarAffineFunction{Float64}:
 0.0 + 2.0 v[2]

Subject to:

ScalarAffineFunction{Float64}-in-LessThan{Float64}
 0.0 + 1.0 v[1] - 1.0 v[2] <= 2.0

VariableIndex-in-GreaterThan{Float64}
 v[2] >= 0.0

julia> map[c] isa MOI.ScalarAffineFunction{Float64}
true
```

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> c = MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0));

julia> map = MOI.modify(model, MOI.Utilities.PenaltyRelaxation(Dict(c => 3.0)));

julia> print(model)
Minimize ScalarAffineFunction{Float64}:
 0.0 + 3.0 v[2]

Subject to:

ScalarAffineFunction{Float64}-in-LessThan{Float64}
 0.0 + 1.0 v[1] - 1.0 v[2] <= 2.0

VariableIndex-in-GreaterThan{Float64}
 v[2] >= 0.0

julia> map[c] isa MOI.ScalarAffineFunction{Float64}
true
```
"""
mutable struct PenaltyRelaxation{T}
    default::Union{Nothing,T}
    penalties::Dict{MOI.ConstraintIndex,T}
    warn::Bool

    function PenaltyRelaxation(
        p::Dict{MOI.ConstraintIndex,T};
        default::Union{Nothing,T} = one(T),
        warn::Bool = true,
    ) where {T}
        return new{T}(default, p, warn)
    end
end

function PenaltyRelaxation(; kwargs...)
    return PenaltyRelaxation(Dict{MOI.ConstraintIndex,Float64}(); kwargs...)
end

function PenaltyRelaxation(
    d::Dict{<:MOI.ConstraintIndex,T};
    kwargs...,
) where {T}
    return PenaltyRelaxation(convert(Dict{MOI.ConstraintIndex,T}, d); kwargs...)
end

function MOI.modify(model::MOI.ModelLike, relax::PenaltyRelaxation{T}) where {T}
    map = Dict{MOI.ConstraintIndex,MOI.ScalarAffineFunction{T}}()
    penalty_expr = zero(MOI.ScalarAffineFunction{T})
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        _modify_penalty_relaxation(penalty_expr, map, model, relax, F, S)
    end
    if !isempty(penalty_expr.terms)
        _change_sense_to_min_if_necessary(T, model)
        O = MOI.get(model, MOI.ObjectiveFunctionType())
        _add_penalty_to_objective(model, O, penalty_expr)
    end
    return map
end

function _modify_penalty_relaxation(
    penalty_expr::MOI.ScalarAffineFunction{T},
    map::Dict{MOI.ConstraintIndex,MOI.ScalarAffineFunction{T}},
    model::MOI.ModelLike,
    relax::PenaltyRelaxation,
    ::Type{F},
    ::Type{S},
) where {T,F,S}
    for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        penalty = get(relax.penalties, ci, relax.default)
        if penalty === nothing
            continue
        end
        try
            x = _relax_constraint(T, model, ci)
            map[ci] = MOI.ScalarAffineFunction(
                MOI.ScalarAffineTerm.(one(T), x),
                zero(T),
            )
            append!(penalty_expr.terms, MOI.ScalarAffineTerm{T}.(penalty, x))
        catch err
            if err isa MethodError && err.f == _relax_constraint
                if relax.warn
                    @warn(
                        "Skipping PenaltyRelaxation for ConstraintIndex{$F,$S}"
                    )
                end
                return
            end
            rethrow(err)
        end
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

struct _ParsedScalarAffineTerm{T}
    coefficient::T
    variable::Symbol
end

struct _ParsedScalarAffineFunction{T}
    terms::Vector{_ParsedScalarAffineTerm{T}}
    constant::T
end

struct _ParsedVectorAffineTerm{T}
    output_index::Int64
    scalar_term::_ParsedScalarAffineTerm{T}
end

struct _ParsedVectorAffineFunction{T}
    terms::Vector{_ParsedVectorAffineTerm{T}}
    constant::Vector{T}
end

struct _ParsedScalarQuadraticTerm{T}
    coefficient::T
    variable_1::Symbol
    variable_2::Symbol
end

struct _ParsedScalarQuadraticFunction{T}
    quadratic_terms::Vector{_ParsedScalarQuadraticTerm{T}}
    affine_terms::Vector{_ParsedScalarAffineTerm{T}}
    constant::T
end

struct _ParsedVectorQuadraticTerm{T}
    output_index::Int64
    scalar_term::_ParsedScalarQuadraticTerm{T}
end

struct _ParsedVectorQuadraticFunction{T}
    quadratic_terms::Vector{_ParsedVectorQuadraticTerm{T}}
    affine_terms::Vector{_ParsedVectorAffineTerm{T}}
    constant::Vector{T}
end

struct _ParsedVariableIndex
    variable::Symbol
end

struct _ParsedVectorOfVariables
    variables::Vector{Symbol}
end

# Not written with any considerations for performance
function _parse_function(ex, ::Type{T} = Float64) where {T}
    if isa(ex, Symbol)
        return _ParsedVariableIndex(ex)
    elseif Meta.isexpr(ex, :vect)
        if all(Base.Fix2(isa, Symbol), ex.args)
            return _ParsedVectorOfVariables(copy(ex.args))
        else
            singlefunctions = map(Base.Fix2(_parse_function, T), ex.args)
            affine_terms = _ParsedVectorAffineTerm{T}[]
            quadratic_terms = _ParsedVectorQuadraticTerm{T}[]
            constant = T[]
            for (outindex, f) in enumerate(singlefunctions)
                outindex = Int64(outindex)
                if isa(f, _ParsedVariableIndex)
                    push!(
                        affine_terms,
                        _ParsedVectorAffineTerm{T}(
                            outindex,
                            _ParsedScalarAffineTerm{T}(one(T), f.variable),
                        ),
                    )
                    push!(constant, zero(T))
                elseif isa(f, _ParsedScalarAffineFunction{T})
                    append!(
                        affine_terms,
                        _ParsedVectorAffineTerm{T}.(outindex, f.terms),
                    )
                    push!(constant, f.constant)
                else
                    @assert isa(f, _ParsedScalarQuadraticFunction{T})
                    append!(
                        affine_terms,
                        _ParsedVectorAffineTerm{T}.(outindex, f.affine_terms),
                    )
                    append!(
                        quadratic_terms,
                        _ParsedVectorQuadraticTerm.(
                            outindex,
                            f.quadratic_terms,
                        ),
                    )
                    push!(constant, f.constant)
                end
            end
            if length(quadratic_terms) == 0
                return _ParsedVectorAffineFunction{T}(affine_terms, constant)
            else
                return _ParsedVectorQuadraticFunction{T}(
                    quadratic_terms,
                    affine_terms,
                    constant,
                )
            end
        end
    else
        if Meta.isexpr(ex, :call, 2) && ex.args[1] == :ScalarNonlinearFunction
            return ex
        elseif Meta.isexpr(ex, :call, 2) &&
               ex.args[1] == :VectorNonlinearFunction
            return ex
        end
        # For simplicity, only accept Expr(:call, :+, ...); no recursive
        # expressions
        if Meta.isexpr(ex, :call) && ex.args[1] == :*
            ex = Expr(:call, :+, ex)  # Handle 2x as (+)(2x)
        end
        if ex isa Number
            ex = Expr(:call, :+, ex)
        end
        @assert Meta.isexpr(ex, :call)
        if ex.args[1] != :+
            error(
                "Unsupported operator in `loadfromstring!`: `$(ex.args[1])`. " *
                "The parser is deliberately limited in the syntax it " *
                "accepts. Write `x - y` as `x + -1 * y`,  and `x^2` as " *
                "`x * x`.",
            )
        end
        affine_terms = _ParsedScalarAffineTerm{T}[]
        quadratic_terms = _ParsedScalarQuadraticTerm{T}[]
        constant = zero(T)
        for subex in ex.args[2:end]
            if Meta.isexpr(subex, :call) && subex.args[1] == :*
                if length(subex.args) == 3
                    # constant * variable
                    coef = if isa(subex.args[2], Number)
                        subex.args[2]
                    else
                        Core.eval(Base, subex.args[2])
                    end
                    @assert isa(subex.args[3], Symbol)
                    push!(
                        affine_terms,
                        _ParsedScalarAffineTerm{T}(
                            convert(T, coef),
                            subex.args[3],
                        ),
                    )
                else
                    # constant * variable * variable for quadratic
                    @assert length(subex.args) == 4 "Multiplication with more than three terms not supported"
                    coefficient = if isa(subex.args[2], Number)
                        subex.args[2]
                    else
                        Core.eval(Base, subex.args[2])
                    end
                    @assert isa(subex.args[3], Symbol)
                    @assert isa(subex.args[4], Symbol)
                    if subex.args[3] == subex.args[4]
                        coefficient *= T(2)
                    end
                    push!(
                        quadratic_terms,
                        _ParsedScalarQuadraticTerm{T}(
                            coefficient,
                            subex.args[3],
                            subex.args[4],
                        ),
                    )
                end
            elseif isa(subex, Symbol)
                push!(affine_terms, _ParsedScalarAffineTerm{T}(one(T), subex))
            elseif isa(subex, Number)
                constant += subex
            else
                constant += Core.eval(Base, subex)
            end
        end
        if length(quadratic_terms) == 0
            return _ParsedScalarAffineFunction{T}(affine_terms, constant)
        else
            return _ParsedScalarQuadraticFunction{T}(
                quadratic_terms,
                affine_terms,
                constant,
            )
        end
    end
end

# see tests for examples
function _separate_label(ex)
    if Meta.isexpr(ex, :call) && ex.args[1] == :(:)
        # A line like `variables: x`.
        return ex.args[2], ex.args[3]
    elseif Meta.isexpr(ex, :tuple)
        # A line like `variables: x, y`. _Parsed as `((variables:x), y)`
        ex = copy(ex)
        @assert Meta.isexpr(ex.args[1], :call) && ex.args[1].args[1] == :(:)
        label = ex.args[1].args[2]
        ex.args[1] = ex.args[1].args[3]
        return label, ex
    elseif Meta.isexpr(ex, :call)
        ex = copy(ex)
        if Meta.isexpr(ex.args[2], :call) && ex.args[2].args[1] == :(:)
            # A line like `c: x <= 1`
            label = ex.args[2].args[2]
            ex.args[2] = ex.args[2].args[3]
            return label, ex
        else
            # A line like `x <= 1`
            return Symbol(""), ex
        end
    else
        error("Unrecognized expression $ex")
    end
end

function _parsed_to_moi(model, s::Symbol)
    index = MOI.get(model, MOI.VariableIndex, String(s))
    if index === nothing
        error("Invalid variable name $s.")
    end
    return index
end

# Used for Vector{Symbol}, Vector{_ParsedScalarAffineTerm},
# Vector{_ParsedVectorAffineTerm}, Vector{_ParsedScalarQuadraticTerm} and
# Vector{_ParsedVectorQuadraticTerm}.
_parsed_to_moi(model, s::Vector) = _parsed_to_moi.(model, s)

_parsed_to_moi(model, s::Number) = s

function _parsed_to_moi(model, s::Expr)
    if Meta.isexpr(s, :call, 2) && s.args[1] == :ScalarNonlinearFunction
        return _parsed_scalar_to_moi(model, s.args[2])
    elseif Meta.isexpr(s, :call, 2) && s.args[1] == :VectorNonlinearFunction
        return _parsed_vector_to_moi(model, s.args[2])
    elseif Meta.isexpr(s, :call, 2) && s.args[1] == :esc
        return _parsed_to_moi(model, _parse_function(s.args[2], Float64))
    end
    args = Any[_parsed_to_moi(model, arg) for arg in s.args[2:end]]
    return MOI.ScalarNonlinearFunction(s.args[1], args)
end

function _parsed_scalar_to_moi(model, s::Expr)
    args = Any[_parsed_to_moi(model, arg) for arg in s.args[2:end]]
    return MOI.ScalarNonlinearFunction(s.args[1], args)
end

function _parsed_vector_to_moi(model, s::Expr)
    args = Any[_parsed_to_moi(model, arg) for arg in s.args]
    return MOI.VectorNonlinearFunction(args)
end

for typename in [
    :_ParsedScalarAffineTerm,
    :_ParsedScalarAffineFunction,
    :_ParsedVectorAffineTerm,
    :_ParsedVectorAffineFunction,
    :_ParsedScalarQuadraticTerm,
    :_ParsedScalarQuadraticFunction,
    :_ParsedVectorQuadraticTerm,
    :_ParsedVectorQuadraticFunction,
    :_ParsedVectorOfVariables,
]
    moiname = Meta.parse(replace(string(typename), "_Parsed" => "MOI."))
    fields = fieldnames(eval(typename))
    constructor = Expr(
        :call,
        moiname,
        [
            Expr(
                :call,
                :_parsed_to_moi,
                :model,
                Expr(:., :f, Base.Meta.quot(field)),
            ) for field in fields
        ]...,
    )
    @eval _parsed_to_moi(model, f::$typename) = $constructor
end

function _parsed_to_moi(model, f::_ParsedVariableIndex)
    return _parsed_to_moi(model, f.variable)
end

_walk_expr(f::F, expr) where {F<:Function} = f(expr)

function _walk_expr(f::F, expr::Expr) where {F<:Function}
    for (i, arg) in enumerate(expr.args)
        expr.args[i] = _walk_expr(f, arg)
    end
    return expr
end

function _parse_set(expr::Expr)
    expr = _walk_expr(expr) do arg
        if arg isa Symbol && arg in (:MOI, :MathOptInterface)
            return MOI
        end
        return arg
    end
    @assert Meta.isexpr(expr, :call)
    if expr.args[1] isa Symbol
        # If the set is a Symbol, it must be one of the MOI sets. We need to
        # eval this in the MOI module.
        return Core.eval(MOI, expr)
    elseif Meta.isexpr(expr.args[1], :curly) && expr.args[1].args[1] isa Symbol
        # Something like Indicator{}()
        return Core.eval(MOI, expr)
    end
    # If the set is an expression, it must be something like
    # `SCS.ScaledPSDCone()`. We need to eval this in `Main`.
    return Core.eval(Main, expr)
end

# Ideally, this should be load_from_string
"""
    loadfromstring!(model, s)

A utility function to aid writing tests.

!!! warning
    This function is not intended for widespread use. It is mainly used as a
    tool to simplify writing tests in MathOptInterface. Do not use it as an
    exchange format for storing or transmitting problem instances. Use the
    FileFormats submodule instead.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> MOI.Utilities.loadfromstring!(model, \"\"\"
       variables: x, y, z
       constrainedvariable: [a, b, c] in Nonnegatives(3)
       minobjective::Float64: 2x + 3y
       con1: x + y <= 1.0
       con2: [x, y] in Nonnegatives(2)
       x >= 0.0
       \"\"\")
```

## Notes

Special labels are:

 - variables
 - minobjective
 - maxobjectives

Everything else denotes a constraint with a name.

Append `::T` to use an element type of `T` when parsing the function.

Do not name `VariableIndex` constraints.

## Exceptions

 * `x - y` does NOT currently parse. Instead, write `x + -1.0 * y`.
 * `x^2` does NOT currently parse. Instead, write `x * x`.
"""
function loadfromstring!(model, s)
    for string_line in split(s, "\n")
        line = Meta.parse(string_line)
        if line === nothing
            continue
        end
        label, ex = _separate_label(line)
        T, label = _split_type(label)
        if label == :variables
            if Meta.isexpr(ex, :tuple)
                for v in ex.args
                    vindex = MOI.add_variable(model)
                    MOI.set(model, MOI.VariableName(), vindex, String(v))
                end
            else
                @assert isa(ex, Symbol)
                vindex = MOI.add_variable(model)
                MOI.set(model, MOI.VariableName(), vindex, String(ex))
            end
        elseif label == :constrainedvariable
            @assert length(ex.args) == 3
            @assert ex.args[1] == :in
            set = _parse_set(ex.args[3])
            if isa(ex.args[2], Symbol)
                # constrainedvariable: x in LessThan(1.0)
                x, _ = MOI.add_constrained_variable(model, set)
                MOI.set(model, MOI.VariableName(), x, String(ex.args[2]))
            else
                # constraintedvariable: [a, b, c] in Set
                @assert isa(ex.args[2], Expr)
                @assert ex.args[2].head == :vect
                x, _ = MOI.add_constrained_variables(model, set)
                for i in 1:length(x)
                    name = String(ex.args[2].args[i])
                    MOI.set(model, MOI.VariableName(), x[i], name)
                end
            end
        elseif label == :maxobjective
            f = _parsed_to_moi(model, _parse_function(ex, T))
            MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
            MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
        elseif label == :minobjective
            f = _parsed_to_moi(model, _parse_function(ex, T))
            MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
            MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
        else
            # constraint
            @assert Meta.isexpr(ex, :call)
            f = _parsed_to_moi(model, _parse_function(ex.args[2], T))
            if ex.args[1] == :in
                # Could be safer here
                set = _parse_set(ex.args[3])
            elseif ex.args[1] == :<=
                set = MOI.LessThan(Core.eval(Base, ex.args[3]))
            elseif ex.args[1] == :>=
                set = MOI.GreaterThan(Core.eval(Base, ex.args[3]))
            elseif ex.args[1] == :(==)
                set = MOI.EqualTo(Core.eval(Base, ex.args[3]))
            else
                error("Unrecognized expression $ex")
            end
            F, S = typeof(f), typeof(set)
            if !MOI.supports_constraint(model, F, S)
                throw(MOI.UnsupportedConstraint{F,S}())
            end
            cindex = MOI.add_constraint(model, f, set)
            if F != MOI.VariableIndex
                MOI.set(model, MOI.ConstraintName(), cindex, String(label))
            end
        end
    end
    return
end

_split_type(ex) = Float64, ex

function _split_type(ex::Expr)
    if Meta.isexpr(ex, Symbol("::"), 1)
        return Core.eval(Base, ex.args[1]), Symbol("")
    else
        @assert Meta.isexpr(ex, Symbol("::"), 2)
        return Core.eval(Base, ex.args[2]), ex.args[1]
    end
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestParser

using Test

import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function _struct_isequal(a::T, b::T) where {T}
    return all(f -> getfield(a, f) == getfield(b, f), fieldnames(T))
end

function test__parse_function()
    @test _struct_isequal(
        MOIU._parse_function(:x),
        MOIU._ParsedVariableIndex(:x),
    )
    @test _struct_isequal(
        MOIU._parse_function(:([x, y, z])),
        MOIU._ParsedVectorOfVariables([:x, :y, :z]),
    )

    @test _struct_isequal(
        MOIU._parse_function(:(x + y + 2.0)),
        MOIU._ParsedScalarAffineFunction(
            MOIU._ParsedScalarAffineTerm.([1.0, 1.0], [:x, :y]),
            2.0,
        ),
    )
    @test _struct_isequal(
        MOIU._parse_function(:(x + -3y + 2.0)),
        MOIU._ParsedScalarAffineFunction(
            MOIU._ParsedScalarAffineTerm.([1.0, -3.0], [:x, :y]),
            2.0,
        ),
    )
    @test _struct_isequal(
        MOIU._parse_function(:(2 * x * y + y + 1.0)),
        MOIU._ParsedScalarQuadraticFunction(
            MOIU._ParsedScalarQuadraticTerm.([2.0], [:x], [:y]),
            MOIU._ParsedScalarAffineTerm.([1.0], [:y]),
            1.0,
        ),
    )

    err = ErrorException(
        "Unsupported operator in `loadfromstring!`: `-`. " *
        "The parser is deliberately limited in the syntax it " *
        "accepts. Write `x - y` as `x + -1 * y`,  and `x^2` as " *
        "`x * x`.",
    )
    @test_throws err MOIU._parse_function(:(x - y))

    @test _struct_isequal(
        MOIU._parse_function(:([x, 2x + y + 5.0])),
        MOIU._ParsedVectorAffineFunction(
            MOIU._ParsedVectorAffineTerm.(
                Int64[1, 2, 2],
                MOIU._ParsedScalarAffineTerm.([1.0, 2.0, 1.0], [:x, :x, :y]),
            ),
            [0.0, 5.0],
        ),
    )
    @test _struct_isequal(
        MOIU._parse_function(:([x, 2x + y + 5.0, 1 * x * x])),
        MOIU._ParsedVectorQuadraticFunction(
            MOIU._ParsedVectorQuadraticTerm.(
                Int64[3],
                MOIU._ParsedScalarQuadraticTerm.([2.0], [:x], [:x]),
            ),
            MOIU._ParsedVectorAffineTerm.(
                Int64[1, 2, 2],
                MOIU._ParsedScalarAffineTerm.([1.0, 2.0, 1.0], [:x, :x, :y]),
            ),
            [0.0, 5.0, 0.0],
        ),
    )
    return
end

function test__separate_label()
    @test MOIU._separate_label(:(variables:x)) == (:variables, :x)
    @test MOIU._separate_label(:(variables:x, y)) == (:variables, :((x, y)))
    @test MOIU._separate_label(:(minobjective:(x+y))) ==
          (:minobjective, :(x + y))
    @test MOIU._separate_label(:(con1:2x <= 1)) == (:con1, :(2x <= 1))
    @test MOIU._separate_label(:(con1:[x, y] in S)) == (:con1, :([x, y] in S))
    return
end

function test_one_variable()
    s = """
    variables: x
    x >= 1.0
    """
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    bound = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))

    model2 = MOIU.Model{Float64}()
    MOIU.loadfromstring!(model2, s)
    MOI.Test.util_test_models_equal(
        model,
        model2,
        ["x"],
        String[],
        [("x", MOI.GreaterThan{Float64}(1.0))],
    )
    return
end

function test_linear_constraints()
    s = """
    variables: x, y
    linear1: x + y >= 1.0
    linear2: x + y <= 1.0
    linear3: x + y == 1.0
    """
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.VariableName(), y, "y")
    linear1 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.0, 1.0], [x, y]),
            0.0,
        ),
        MOI.GreaterThan(1.0),
    )
    linear2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.0, 1.0], [x, y]),
            0.0,
        ),
        MOI.LessThan(1.0),
    )
    linear3 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.0, 1.0], [x, y]),
            0.0,
        ),
        MOI.EqualTo(1.0),
    )
    MOI.set(model, MOI.ConstraintName(), linear1, "linear1")
    MOI.set(model, MOI.ConstraintName(), linear2, "linear2")
    MOI.set(model, MOI.ConstraintName(), linear3, "linear3")

    model2 = MOIU.Model{Float64}()
    MOIU.loadfromstring!(model2, s)
    MOI.Test.util_test_models_equal(
        model,
        model2,
        ["x", "y"],
        ["linear1", "linear2", "linear3"],
    )
    return
end

function test_minimization_linear_objective()
    s = """
    variables: x, y
    minobjective: x + -2y + 1.0
    """
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.VariableName(), y, "y")
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.0, -2.0], [x, y]),
            1.0,
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)

    model2 = MOIU.Model{Float64}()
    MOIU.loadfromstring!(model2, s)
    MOI.Test.util_test_models_equal(model, model2, ["x", "y"], String[])
    return
end

function test_maximization_linear_objective()
    s = """
    variables: x, y
    maxobjective: x + -2y + 1.0
    """
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.VariableName(), y, "y")
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.0, -2.0], [x, y]),
            1.0,
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)

    model2 = MOIU.Model{Float64}()
    MOIU.loadfromstring!(model2, s)
    MOI.Test.util_test_models_equal(model, model2, ["x", "y"], String[])
    return
end

function test_SecondOrderCone_constraints()
    s = """
    variables: x, y, z
    varsoc: [x,y,z] in SecondOrderCone(3)
    affsoc: [2x,y+1,-1*z] in SecondOrderCone(3)
    affsoc2: [1.0,2.0,3.0] in SecondOrderCone(3)
    """
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    z = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.VariableName(), y, "y")
    MOI.set(model, MOI.VariableName(), z, "z")
    varsoc = MOI.add_constraint(
        model,
        MOI.VectorOfVariables([x, y, z]),
        MOI.SecondOrderCone(3),
    )
    affsoc = MOI.add_constraint(
        model,
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1, 2, 3],
                MOI.ScalarAffineTerm.([2.0, 1.0, -1.0], [x, y, z]),
            ),
            [0.0, 1.0, 0.0],
        ),
        MOI.SecondOrderCone(3),
    )
    affsoc2 = MOI.add_constraint(
        model,
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm{Float64}[],
            [1.0, 2.0, 3.0],
        ),
        MOI.SecondOrderCone(3),
    )
    MOI.set(model, MOI.ConstraintName(), varsoc, "varsoc")
    MOI.set(model, MOI.ConstraintName(), affsoc, "affsoc")
    MOI.set(model, MOI.ConstraintName(), affsoc2, "affsoc2")

    model2 = MOIU.Model{Float64}()
    MOIU.loadfromstring!(model2, s)
    MOI.Test.util_test_models_equal(
        model,
        model2,
        ["x", "y", "z"],
        ["varsoc", "affsoc", "affsoc2"],
    )
    return
end

function test_Invalid_variable_name()
    s = """
    variables: x
    y >= 1.0
    """
    model = MOIU.Model{Float64}()
    err = ErrorException("Invalid variable name y.")
    @test_throws err MOIU.loadfromstring!(model, s)
    return
end

function test_constrained_variables()
    model = MOI.Utilities.Model{Float64}()
    text = """
    constrainedvariable: [a, b, c] in Nonnegatives(3)
    constrainedvariable: d in LessThan(2.0)
    """
    MOI.Utilities.loadfromstring!(model, text)
    MOI.set(
        model,
        MOI.ConstraintName(),
        MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives}(1),
        "con1",
    )
    model2 = MOI.Utilities.Model{Float64}()
    text2 = """
    variables: a, b, c, d
    con1: [a, b, c] in Nonnegatives(3)
    d <= 2.0
    """
    MOI.Utilities.loadfromstring!(model2, text2)
    MOI.Test.util_test_models_equal(
        model,
        model2,
        ["a", "b", "c", "d"],
        ["con1"],
        [("d", MOI.LessThan{Float64}(2.0))],
    )
    return
end

function test_eltypes_int()
    model = MOI.Utilities.Model{Int}()
    text = """
    variables: x, y
    ::Int: x >= 1
    c::Int: 2 * x <= 3
    d::Int: [x, 4 * y] in Zeros(2)
    e::Int: [2 * x * x] in Nonnegatives(1)
    """
    MOI.Utilities.loadfromstring!(model, text)
    c = MOI.get(model, MOI.ConstraintIndex, "c")
    @test isa(
        MOI.get(model, MOI.ConstraintFunction(), c),
        MOI.ScalarAffineFunction{Int},
    )
    d = MOI.get(model, MOI.ConstraintIndex, "d")
    @test isa(
        MOI.get(model, MOI.ConstraintFunction(), d),
        MOI.VectorAffineFunction{Int},
    )
    e = MOI.get(model, MOI.ConstraintIndex, "e")
    @test isa(
        MOI.get(model, MOI.ConstraintFunction(), e),
        MOI.VectorQuadraticFunction{Int},
    )
    return
end

function test_eltypes_rational_int()
    model = MOI.Utilities.Model{Rational{Int}}()
    text = """
    variables: x, y
    c::Rational{Int}: 2 // 1 * x <= 1 // 3
    d::Rational{Int}: [x, 4 // 2 * y] in Zeros(2)
    e::Rational{Int}: [2 // 2 * x * x] in Nonnegatives(1)
    """
    MOI.Utilities.loadfromstring!(model, text)
    c = MOI.get(model, MOI.ConstraintIndex, "c")
    @test isa(
        MOI.get(model, MOI.ConstraintFunction(), c),
        MOI.ScalarAffineFunction{Rational{Int}},
    )
    d = MOI.get(model, MOI.ConstraintIndex, "d")
    @test isa(
        MOI.get(model, MOI.ConstraintFunction(), d),
        MOI.VectorAffineFunction{Rational{Int}},
    )
    e = MOI.get(model, MOI.ConstraintIndex, "e")
    @test isa(
        MOI.get(model, MOI.ConstraintFunction(), e),
        MOI.VectorQuadraticFunction{Rational{Int}},
    )
    return
end

function test_eltypes_complex_float64()
    # Work-around for https://github.com/jump-dev/MathOptInterface.jl/issues/1947
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    text = """
    variables: x
    c::Complex{Float64}: (2.0 + 1im) * x == 0.0 + 0.0im
    """
    MOI.Utilities.loadfromstring!(model, text)
    x = MOI.get(model, MOI.VariableIndex, "x")
    c = MOI.get(model, MOI.ConstraintIndex, "c")
    f = MOI.get(model, MOI.ConstraintFunction(), c)
    @test f isa MOI.ScalarAffineFunction{Complex{Float64}}
    @test isapprox(
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(2.0 + 1.0im, x)],
            0.0 + 0.0im,
        ),
        f,
    )
    return
end

struct Set2175 <: MOI.AbstractScalarSet end

function test_parse_external_set_constraint()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    MOI.Utilities.loadfromstring!(
        model,
        "variables: x\nx in $(@__MODULE__).Set2175()",
    )
    constraints = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test (MOI.VariableIndex, Set2175) in constraints
    return
end

function test_parse_external_set_constrained_variable()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    MOI.Utilities.loadfromstring!(
        model,
        "constrainedvariable: x in $(@__MODULE__).Set2175()",
    )
    constraints = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test (MOI.VariableIndex, Set2175) in constraints
    return
end

function test_parse_scope()
    @test !isdefined(@__MODULE__, :MathOptInterface)
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    MOI.Utilities.loadfromstring!(
        model,
        "variables: x\nx in MathOptInterface.ZeroOne()",
    )
    attr = MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne}()
    @test MOI.get(model, attr) == 1
    return
end

function test_parse_unrecognized_expression()
    model = MOI.Utilities.Model{Float64}()
    @test_throws(
        ErrorException("Unrecognized expression []"),
        MOI.Utilities.loadfromstring!(model, "[]"),
    )
    @test_throws(
        ErrorException("Unrecognized expression foo(x)"),
        MOI.Utilities.loadfromstring!(model, "variables: x\nfoo(x)"),
    )
    return
end

end  # module

TestParser.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    _ReadCache(model::Model{T}) where {T}

This struct stores a few things to help reading the file:

 * `variable_name_to_index`: this maps variable names to their MOI index
 * `variable_with_default_bound`: by default, variables have a lower bound of
   `0`. When we read through the `Bounds` section, we remove from this set any
   variable that explicitly sets the lower bound, or that has an upper bound
   that is negative. At the end of `read!` we iterate through the remaining
   variables and add a lower bound of `0`.
"""
struct _ReadCache{T}
    model::Model{T}
    variable_name_to_index::Dict{String,MOI.VariableIndex}
    variable_with_default_bound::Set{MOI.VariableIndex}
    function _ReadCache(model::Model{T}) where {T}
        return new{T}(
            model,
            Dict{String,MOI.VariableIndex}(),
            Set{MOI.VariableIndex}(),
        )
    end
end

"""
    Base.read!(io::IO, model::FileFormats.LP.Model)

Read `io` in the LP file format and store the result in `model`.

This reader attempts to follow the CPLEX LP format, because others like the
lpsolve version are very...flexible...in how they accept input.

Read more about the format here:

 * http://lpsolve.sourceforge.net
 * https://web.mit.edu/lpsolve/doc/CPLEX-format.htm
"""
function Base.read!(io::IO, model::Model{T}) where {T}
    if !MOI.is_empty(model)
        error("Cannot read in file because model is not empty.")
    end
    state = _LexerState(io)
    cache = _ReadCache(model)
    keyword = :UNKNOWN
    while (token = peek(state, _Token)) !== nothing
        if token.kind == _TOKEN_KEYWORD
            _ = read(state, _Token)
            keyword = Symbol(token.value)
        elseif token.kind == _TOKEN_NEWLINE
            _ = read(state, _Token, _TOKEN_NEWLINE)
        elseif keyword == :MINIMIZE
            MOI.set(cache.model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
            _parse_objective(state, cache)
            keyword = :UNKNOWN
        elseif keyword == :MAXIMIZE
            MOI.set(cache.model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
            _parse_objective(state, cache)
            keyword = :UNKNOWN
        elseif keyword == :CONSTRAINTS
            _parse_constraint(state, cache)
        elseif keyword == :BINARY
            x = _parse_identifier(state, cache)
            MOI.add_constraint(cache.model, x, MOI.ZeroOne())
        elseif keyword == :INTEGER
            x = _parse_identifier(state, cache)
            MOI.add_constraint(cache.model, x, MOI.Integer())
        elseif keyword == :BOUNDS
            _parse_bound_expression(state, cache)
        elseif keyword == :SOS
            _parse_constraint(state, cache)
        elseif keyword == :END
            _throw_parse_error(
                state,
                token,
                "No file contents are allowed after `end`.",
            )
        else
            if token.kind == _TOKEN_IDENTIFIER
                # We didn't identify the token as an keyword during lexing. But
                # it might be one that is missing surrounding `\n`. Since our
                # alternative at this point is to throw an error, we ,might as
                # well attempt to see it can be interpreted as one.
                kw = _case_insenstive_identifier_to_keyword(token.value)
                if kw !== nothing
                    _ = read(state, _Token, _TOKEN_IDENTIFIER)
                    keyword = Symbol(kw)
                    continue
                elseif _compare_case_insenstive(token.value, "subject")
                    p = peek(state, _Token, 2)
                    if p !== nothing && p.kind == _TOKEN_IDENTIFIER
                        if _compare_case_insenstive(p.value, "to")
                            _ = read(state, _Token, _TOKEN_IDENTIFIER)
                            _ = read(state, _Token, _TOKEN_IDENTIFIER)
                            keyword = :CONSTRAINTS
                            continue
                        end
                    end
                elseif _compare_case_insenstive(token.value, "such")
                    p = peek(state, _Token, 2)
                    if p !== nothing && p.kind == _TOKEN_IDENTIFIER
                        if _compare_case_insenstive(p.value, "that")
                            _ = read(state, _Token, _TOKEN_IDENTIFIER)
                            _ = read(state, _Token, _TOKEN_IDENTIFIER)
                            keyword = :CONSTRAINTS
                            continue
                        end
                    end
                end
            end
            _expect(state, token, _TOKEN_KEYWORD)
        end
    end
    # if keyword != :END
    #     TODO(odow): decide if we should throw an error here.
    # end
    for x in cache.variable_with_default_bound
        MOI.add_constraint(model, x, MOI.GreaterThan(0.0))
    end
    return
end

# We want an efficient way to check if `test` is a case-insensitive version of
# `target`. We won't want `lowercase(test) == target` because this involves
# allocating a new string, and we check many identifiers to see if they are
# keywords.
function _compare_case_insenstive(test::String, target::String)
    if length(test) != length(target)
        return false
    end
    return all(lowercase(a) == b for (a, b) in zip(test, target))
end

function _compare_case_insenstive(input::String, c::Char, args)
    if lowercase(first(input)) != c
        return false
    end
    return any(_compare_case_insenstive(input, arg) for arg in args)
end

const _MAXIMIZE_KEYWORDS = ("max", "maximize", "maximise", "maximum")
const _MINIMIZE_KEYWORDS = ("min", "minimize", "minimise", "minimum")

"""
    _case_insenstive_identifier_to_keyword(input::String)

We need to check if identifiers are case insensitive keywords.

An obvious way to do this is something like `dict[lowercase(identifier)]`, but
this involves a moderately expensive `lowercase` operation and a dict lookup for
every identifier.

This function tries to be a little cleverer and doesn't allocate.
"""
function _case_insenstive_identifier_to_keyword(input::String)
    if !(2 <= length(input) <= 8)
        return nothing  # identifiers outside these lengths are not recognized
    elseif _compare_case_insenstive(input, 'm', _MAXIMIZE_KEYWORDS)
        return "MAXIMIZE"
    elseif _compare_case_insenstive(input, 'm', _MINIMIZE_KEYWORDS)
        return "MINIMIZE"
    elseif _compare_case_insenstive(input, 's', ("st", "s.t.", "st."))
        # `subject to` and `such that` handled in `peek`
        return "CONSTRAINTS"
    elseif _compare_case_insenstive(input, "sos")
        return "SOS"
    elseif _compare_case_insenstive(input, 'b', ("bound", "bounds"))
        return "BOUNDS"
    elseif _compare_case_insenstive(input, 'g', ("gen", "general", "generals"))
        return "INTEGER"
    elseif _compare_case_insenstive(input, 'i', ("integer", "integers"))
        return "INTEGER"
    elseif _compare_case_insenstive(input, 'b', ("bin", "binary", "binaries"))
        return "BINARY"
    elseif _compare_case_insenstive(input, "end")
        return "END"
    end
    return nothing
end

"""
    _TokenKind

This enum is the list of tokens that we might encounter when lexing the file.
Hopefully they're all self-explanatory.
"""
@enum(
    _TokenKind,
    _TOKEN_KEYWORD,
    _TOKEN_IDENTIFIER,
    _TOKEN_NUMBER,
    _TOKEN_ADDITION,
    _TOKEN_SUBTRACTION,
    _TOKEN_MULTIPLICATION,
    _TOKEN_DIVISION,
    _TOKEN_EXPONENT,
    _TOKEN_OPEN_BRACKET,
    _TOKEN_CLOSE_BRACKET,
    _TOKEN_GREATER_THAN,
    _TOKEN_LESS_THAN,
    _TOKEN_EQUAL_TO,
    _TOKEN_COLON,
    _TOKEN_IMPLIES,
    _TOKEN_NEWLINE,
    _TOKEN_UNKNOWN,
)

"""
    const _KIND_TO_MSG::Dict{_TokenKind,String}

This dictionary makes `_TokenKind` to a string that is used when printing error
messages. The string must complete the sentence "We expected this token to be ".
"""
const _KIND_TO_MSG = Dict{_TokenKind,String}(
    _TOKEN_KEYWORD => "a keyword defining a new section",
    _TOKEN_IDENTIFIER => "an identifier",
    _TOKEN_NUMBER => "a number",
    _TOKEN_ADDITION => "the symbol `+`",
    _TOKEN_SUBTRACTION => "the symbol `-`",
    _TOKEN_MULTIPLICATION => "the symbol `*`",
    _TOKEN_DIVISION => "the symbol `/`",
    _TOKEN_EXPONENT => "the symbol `^`",
    _TOKEN_OPEN_BRACKET => "the symbol `[`",
    _TOKEN_CLOSE_BRACKET => "the symbol `]`",
    _TOKEN_GREATER_THAN => "the symbol `>=`",
    _TOKEN_LESS_THAN => "the symbol `<=`",
    _TOKEN_EQUAL_TO => "the symbol `==`",
    _TOKEN_COLON => "the symbol `:`",
    _TOKEN_IMPLIES => "the symbol `->`",
    _TOKEN_NEWLINE => "a new line",
    _TOKEN_UNKNOWN => "a token",
)

"""
    const _OPERATORS::Dict{Char,_TokenKind}

This dictionary is used to simplify the lexer for common operators.

These operators must not contain spaces.
"""
const _OPERATORS = Dict{Char,_TokenKind}(
    '+' => _TOKEN_ADDITION,
    '-' => _TOKEN_SUBTRACTION,
    '*' => _TOKEN_MULTIPLICATION,
    '/' => _TOKEN_DIVISION,
    '^' => _TOKEN_EXPONENT,
    '[' => _TOKEN_OPEN_BRACKET,
    ']' => _TOKEN_CLOSE_BRACKET,
    '>' => _TOKEN_GREATER_THAN,
    '<' => _TOKEN_LESS_THAN,
    '=' => _TOKEN_EQUAL_TO,
    ':' => _TOKEN_COLON,
    '\n' => _TOKEN_NEWLINE,
)

"""
    struct _Token
        kind::_TokenKind
        value::Union{Nothing,String}
        pos::Int
    end

This struct is used to represent each token from the lexer. The `value` is the
unprocessed value.

`pos` is the position of the `io::IO` in the lexer that begins this token. We
use the `pos` to provide nice error messages.
"""
struct _Token
    kind::_TokenKind
    value::Union{Nothing,String}
    pos::Int
end

function _compare_case_insenstive(test::_Token, target::String)
    if test.kind != _TOKEN_IDENTIFIER
        return false
    end
    return _compare_case_insenstive(test.value, target)
end

"""
    mutable struct _LexerState{O<:IO}
        io::O
        line::Int
        peek_char::Union{Nothing,Char}
        peek_tokens::Vector{_Token}
    end

A struct that is used to manage state when lexing. It stores:

 * `io`: the IO object that we are streaming
 * `line`: counts the number of `\n` characters, so that we can provide a nice
   error message to the user on a parse error
 * `peek_char`: the next `Char` in the `io`
 * `peek_tokens`: the list of upcoming tokens that we have already peeked
 * `current_token`: the most recent token that we have `read`
"""
mutable struct _LexerState{O<:IO}
    io::O
    line::Int
    peek_char::Union{Nothing,Char}
    peek_tokens::Vector{_Token}
    current_token::Union{Nothing,_Token}
    _LexerState(io::IO) = new{typeof(io)}(io, 1, nothing, _Token[], nothing)
end

"""
    struct ParseError <: Exception
        line::Int
        msg::String
    end

This error is thrown when we encounter an error parsing the LP file.
"""
struct ParseError <: Exception
    line::Int
    msg::String
end

_is_utf8_start(b::UInt8) = b < 0x80 || (0xC0 <= b <= 0xF7)

function _get_line_about_pos(io::IO, pos::Int, width::Int)
    seek(io, max(0, pos - width))
    # This byte might be an invalid or continuation byte. We need to seek
    # forward until we reach a new valid byte.
    while !_is_utf8_start(peek(io, UInt8))
        read(io, UInt8)
    end
    char = Char[]
    mark = 0
    while !eof(io) && position(io) <= pos + width
        c = read(io, Char)
        if c == '\n'
            if position(io) < pos
                empty!(char)
            else
                break
            end
        elseif c != '\r'
            push!(char, c)
        end
        if position(io) == pos
            mark = length(char)
        end
    end
    if mark == 0
        mark = length(char) + 1
    end
    return String(char), mark
end

function _throw_parse_error(state::_LexerState, token::_Token, msg::String)
    line, mark = _get_line_about_pos(state.io, token.pos, 40)
    help = string(
        line,
        "\n",
        " "^(mark - 1),
        "^\nGot ",
        _KIND_TO_MSG[token.kind],
        _with_value(token.value),
        ". ",
        msg,
    )
    return throw(ParseError(state.line, help))
end

function Base.showerror(io::IO, err::ParseError)
    return print(io, "Error parsing LP file on line $(err.line):\n", err.msg)
end

_with_value(::Nothing) = ""
_with_value(x::String) = string(" with value `", x, "`")

function _expect(state::_LexerState, token::_Token, kind::_TokenKind)
    if token.kind != kind
        _throw_parse_error(
            state,
            token,
            "We expected this token to be $(_KIND_TO_MSG[kind]).",
        )
    end
    return token
end

function Base.peek(state::_LexerState, ::Type{Char})
    if state.peek_char === nothing && !eof(state.io)
        state.peek_char = read(state.io, Char)
    end
    return state.peek_char
end

function Base.read(state::_LexerState, ::Type{Char})
    c = peek(state, Char)
    state.peek_char = nothing
    return c
end

function Base.read(state::_LexerState, ::Type{_Token})
    token = peek(state, _Token, 1)
    if isempty(state.peek_tokens)
        _throw_parse_error(
            state,
            _Token(_TOKEN_UNKNOWN, "EOF", position(state.io)),
            "Unexpected end to the file. We weren't finished yet.",
        )
    end
    popfirst!(state.peek_tokens)
    state.current_token = token
    if token.kind == _TOKEN_NEWLINE
        state.line += 1
    end
    return token
end

function Base.read(state::_LexerState, ::Type{_Token}, kind::_TokenKind)
    token = read(state, _Token)
    return _expect(state, token, kind)
end

_nothing_or_newline(::Nothing) = true
_nothing_or_newline(t::_Token) = t.kind == _TOKEN_NEWLINE

function _prior_token(state::_LexerState)
    if length(state.peek_tokens) <= 1
        return state.current_token
    end
    return state.peek_tokens[end-1]
end

function Base.peek(state::_LexerState, ::Type{_Token}, n::Int = 1)
    @assert n >= 1
    while length(state.peek_tokens) < n
        token = _peek_inner(state)
        if token === nothing
            return nothing
        end
        push!(state.peek_tokens, token)
        if token.kind != _TOKEN_IDENTIFIER
            continue
        end
        # Here we have a _TOKEN_IDENTIFIER. But if it is not preceeded by a
        # _TOKEN_NEWLINE, it cannot be a _TOKEN_KEYWORD.
        if !_nothing_or_newline(_prior_token(state))
            continue
        end
        # It might be a _TOKEN_KEYWORD.
        (kw = _case_insenstive_identifier_to_keyword(token.value))
        if kw !== nothing
            # The token matches a single word keyword. All keywords are followed
            # by a new line, or an EOF.
            t = _peek_inner(state)
            if _nothing_or_newline(t)
                state.peek_tokens[end] = _Token(_TOKEN_KEYWORD, kw, token.pos)
            end
            if t !== nothing
                push!(state.peek_tokens, t)
            end
            continue
        end
        # There are two keyword that contain whitespace: `subject to` and
        # `such that`
        for (a, b) in ("subject" => "to", "such" => "that")
            if !_compare_case_insenstive(token, a)
                continue
            end
            # This _might_ be `subject to`, or it might just be a variable
            # named `subject`, like `obj:\n subject\n`.
            token_b = _peek_inner(state)
            if token_b === nothing
                # The next token is EOF. Nothing to do here.
                break
            elseif !_compare_case_insenstive(token_b, b)
                # The second token doesn't match. Store `token_b` and break
                push!(state.peek_tokens, token_b)
                break
            end
            # We have something that matches (a, b), but a TOKEN_KEYWORD needs
            # to be followed by a new line.
            token_nl = _peek_inner(state)
            if _nothing_or_newline(token_nl)
                state.peek_tokens[end] =
                    _Token(_TOKEN_KEYWORD, "CONSTRAINTS", token.pos)
            else
                push!(state.peek_tokens, token_b)
            end
            if token_nl !== nothing
                push!(state.peek_tokens, token_nl)
            end
            break
        end
    end
    return state.peek_tokens[n]
end

# We're a bit more relaxed than typical, allowing any letter or digit, not just
# ASCII.
function _is_identifier(c::Char)
    return isletter(c) || isdigit(c) || c in "!\"#\$%&()/,.;?@_`'{}|~"
end

function _is_starting_identifier(c::Char)
    return isletter(c) || c in "!\"#\$%&(),;?@_`'{}|~"
end

_is_number(c::Char) = isdigit(c) || c in ('.', 'e', 'E', '+', '-')

function _peek_inner(state::_LexerState)
    while (c = peek(state, Char)) !== nothing
        pos = position(state.io)
        if c == '\n'
            _ = read(state, Char)
            return _Token(_TOKEN_NEWLINE, nothing, pos)
        elseif isspace(c)  # Whitespace
            _ = read(state, Char)
        elseif c == '\\'  # Comment: backslash until newline
            while (c = peek(state, Char)) !== nothing && c != '\n'
                _ = read(state, Char)
            end
        elseif isdigit(c) || (c == '-' && isdigit(peek(state, Char))) # Number
            buf = IOBuffer()
            while (c = peek(state, Char)) !== nothing && _is_number(c)
                write(buf, c)
                _ = read(state, Char)
            end
            return _Token(_TOKEN_NUMBER, String(take!(buf)), pos)
        elseif _is_starting_identifier(c)  # Identifier / keyword
            buf = IOBuffer()
            while (c = peek(state, Char)) !== nothing && _is_identifier(c)
                write(buf, c)
                _ = read(state, Char)
            end
            return _Token(_TOKEN_IDENTIFIER, String(take!(buf)), pos)
        elseif (op = get(_OPERATORS, c, nothing)) !== nothing
            _ = read(state, Char) # Skip c
            if c == '-' && peek(state, Char) == '>'
                _ = read(state, Char)
                return _Token(_TOKEN_IMPLIES, nothing, pos)
            elseif c == '=' && peek(state, Char) in ('<', '>')
                c = read(state, Char) # Allow =< and => as <= and >=
                return _Token(_OPERATORS[c], nothing, pos)
            elseif c in ('<', '>', '=') && peek(state, Char) == '='
                _ = read(state, Char)  # Allow <=, >=, and ==
            end
            return _Token(op, nothing, pos)
        elseif _is_identifier(c) && !_is_starting_identifier(c)
            _throw_parse_error(
                state,
                _Token(_TOKEN_UNKNOWN, "$c", pos),
                "This character is not supported at the start of an identifier.",
            )
        else
            _throw_parse_error(
                state,
                _Token(_TOKEN_UNKNOWN, "$c", pos),
                "This character is not supported in an LP file.",
            )
        end
    end
    return
end

"""
    _next_token_is(state::_LexerState, kind::_TokenKind, n::Int = 1)

A helper function to check if the token in `n` steps is of kind `kind`.
"""
function _next_token_is(state::_LexerState, kind::_TokenKind, n::Int = 1)
    if (t = peek(state, _Token, n)) !== nothing
        return t.kind == kind
    end
    return false
end

function _skip_newlines(state::_LexerState)
    while _next_token_is(state, _TOKEN_NEWLINE)
        _ = read(state, _Token, _TOKEN_NEWLINE)
    end
    return
end

function _next_non_newline(state::_LexerState)
    n = 1
    while true
        t = peek(state, _Token, n)
        if t === nothing
            return nothing
        elseif t.kind != _TOKEN_NEWLINE
            return t
        end
        n += 1
    end
end

# <identifier> :== "string"
#
#   There _are_ rules to what an identifier can be. We handle these when lexing.
#   Anything that makes it here is deemed acceptable.
function _parse_identifier(
    state::_LexerState,
    cache::_ReadCache,
)::MOI.VariableIndex
    _skip_newlines(state)
    token = read(state, _Token, _TOKEN_IDENTIFIER)
    x = get(cache.variable_name_to_index, token.value, nothing)
    if x !== nothing
        return x
    end
    x = MOI.add_variable(cache.model)
    len = get_options(cache.model).maximum_length
    if length(token.value) > len
        _throw_parse_error(
            state,
            token,
            "Name ($(token.value)) exceeds maximum length ($len)",
        )
    end
    MOI.set(cache.model, MOI.VariableName(), x, token.value)
    cache.variable_name_to_index[token.value] = x
    push!(cache.variable_with_default_bound, x)
    return x
end

# <number> :==
#   "+" <number>
#   | "-" <number>
#   | <digit>*[.(<digit>)*][("e" | "E")("+" | "-")(<digit>)+]
#   | i"inf"
#   | i"infinity"
function _parse_number(state::_LexerState, cache::_ReadCache{T})::T where {T}
    _skip_newlines(state)
    token = read(state, _Token)
    if token.kind == _TOKEN_ADDITION
        return _parse_number(state, cache)
    elseif token.kind == _TOKEN_SUBTRACTION
        return -_parse_number(state, cache)
    elseif token.kind == _TOKEN_IDENTIFIER
        if _compare_case_insenstive(token.value, 'i', ("inf", "infinity"))
            return typemax(T)
        end
        _throw_parse_error(state, token, "We expected this to be a number.")
    end
    _expect(state, token, _TOKEN_NUMBER)
    ret = tryparse(T, token.value)
    if ret === nothing
        _throw_parse_error(
            state,
            _Token(_TOKEN_IDENTIFIER, token.value, token.pos),
            "We were unable to parse this as a number.",
        )
    end
    return ret
end

# <quadratic-term> :==
#   "+" <quadratic-term>
#   | "-" <quadratic-term>
#   | [<number> [*]] <identifier> "^" "2"
#   | [<number> [*]] <identifier> "*" <identifier>
function _parse_quadratic_term(
    state::_LexerState,
    cache::_ReadCache{T},
    prefix::T,
) where {T}
    _skip_newlines(state)
    if _next_token_is(state, _TOKEN_ADDITION)
        _ = read(state, _Token)
        return _parse_quadratic_term(state, cache, prefix)
    elseif _next_token_is(state, _TOKEN_SUBTRACTION)
        _ = read(state, _Token)
        return _parse_quadratic_term(state, cache, -prefix)
    end
    coef = prefix
    if _next_token_is(state, _TOKEN_NUMBER)
        coef = prefix * _parse_number(state, cache)
    end
    if _next_token_is(state, _TOKEN_MULTIPLICATION)
        _skip_newlines(state)
        _ = read(state, _Token)  # Skip optional multiplication
    end
    x1 = _parse_identifier(state, cache)
    _skip_newlines(state)
    if _next_token_is(state, _TOKEN_EXPONENT)
        _ = read(state, _Token) # ^
        _skip_newlines(state)
        n = read(state, _Token, _TOKEN_NUMBER)
        if n.value != "2"
            _throw_parse_error(state, n, "Only `^ 2` is supported.")
        end
        return MOI.ScalarQuadraticTerm(T(2) * coef, x1, x1)
    end
    token = read(state, _Token, _TOKEN_MULTIPLICATION)
    x2 = _parse_identifier(state, cache)
    if x1 == x2
        coef *= T(2)
    end
    return MOI.ScalarQuadraticTerm(coef, x1, x2)
end

# <quadratic-expression> :==
#   "[" <quadratic-term> (("+" | "-") <quadratic-term>)* "]" ["/" "2"]
function _parse_quadratic_expression(
    state::_LexerState,
    cache::_ReadCache{T},
    prefix::T,
) where {T}
    token = read(state, _Token, _TOKEN_OPEN_BRACKET)
    f = zero(MOI.ScalarQuadraticFunction{T})
    push!(f.quadratic_terms, _parse_quadratic_term(state, cache, prefix))
    while (p = peek(state, _Token)) !== nothing
        if p.kind == _TOKEN_ADDITION
            p = read(state, _Token)
            push!(
                f.quadratic_terms,
                _parse_quadratic_term(state, cache, prefix),
            )
        elseif p.kind == _TOKEN_SUBTRACTION
            p = read(state, _Token)
            push!(
                f.quadratic_terms,
                _parse_quadratic_term(state, cache, -prefix),
            )
        elseif p.kind == _TOKEN_NEWLINE
            _ = read(state, _Token)
        elseif p.kind == _TOKEN_CLOSE_BRACKET
            _ = read(state, _Token)
            break
        else
            _throw_parse_error(
                state,
                p,
                "We expected this to be a ] to end the quadratic expresssion.",
            )
        end
    end
    t = _next_non_newline(state)
    if t !== nothing && t.kind == _TOKEN_DIVISION
        _skip_newlines(state)
        _ = read(state, _Token, _TOKEN_DIVISION) # /
        # Must be /2
        n = read(state, _Token, _TOKEN_NUMBER)
        if n.value != "2"
            _throw_parse_error(
                state,
                n,
                "The only supported value here is `] / 2`.",
            )
        end
        for (i, term) in enumerate(f.quadratic_terms)
            f.quadratic_terms[i] = MOI.ScalarQuadraticTerm(
                term.coefficient / T(2),
                term.variable_1,
                term.variable_2,
            )
        end
    end
    return f
end

# <term> :==
#     "+" <term>
#   | "-" <term>
#   | <identifier>
#   | <number>
#   | <number> <identifier>
#   | <number> "*" <identifier>
#   | <quadratic-expression>
function _parse_term(
    state::_LexerState,
    cache::_ReadCache{T},
    prefix::T = one(T),
) where {T}
    _skip_newlines(state)
    if _next_token_is(state, _TOKEN_ADDITION)
        # "+" <term>
        _ = read(state, _Token, _TOKEN_ADDITION)
        return _parse_term(state, cache, prefix)
    elseif _next_token_is(state, _TOKEN_SUBTRACTION)
        # "-" <term>
        _ = read(state, _Token, _TOKEN_SUBTRACTION)
        return _parse_term(state, cache, -prefix)
    elseif _next_token_is(state, _TOKEN_IDENTIFIER)
        # <identifier>
        x = _parse_identifier(state, cache)
        return MOI.ScalarAffineTerm(prefix, x)
    elseif _next_token_is(state, _TOKEN_NUMBER)
        coef = prefix * _parse_number(state, cache)
        if _next_token_is(state, _TOKEN_IDENTIFIER)
            # <number> <identifier>
            x = _parse_identifier(state, cache)
            return MOI.ScalarAffineTerm(coef, x)
        elseif _next_token_is(state, _TOKEN_MULTIPLICATION)
            # <number> * <identifier>
            _ = read(state, _Token, _TOKEN_MULTIPLICATION)
            x = _parse_identifier(state, cache)
            return MOI.ScalarAffineTerm(coef, x)
        elseif _next_token_is(state, _TOKEN_NEWLINE)
            # This could either be <number> \nEND-OF-<term>, or it could be a term
            # split by a new line, like `2\nx`.
            t = _next_non_newline(state)
            if t === nothing
                # <number>
                return coef
            elseif t.kind == _TOKEN_MULTIPLICATION
                # <number> \n * [\n] <identifier>
                _skip_newlines(state)
                _ = read(state, _Token, _TOKEN_MULTIPLICATION)
                _skip_newlines(state)
                x = _parse_identifier(state, cache)
                return MOI.ScalarAffineTerm(coef, x)
            elseif t.kind == _TOKEN_IDENTIFIER
                # <number> \n <identifier>
                x = _parse_identifier(state, cache)
                return MOI.ScalarAffineTerm(coef, x)
            end
        end
        # <number>
        return coef
    elseif _next_token_is(state, _TOKEN_OPEN_BRACKET)
        # <quadratic-expression>
        return _parse_quadratic_expression(state, cache, prefix)
    end
    token = peek(state, _Token)
    return _throw_parse_error(
        state,
        token,
        "We expected this to be a new term in the expression.",
    )
end

function _add_to_expression!(f::MOI.ScalarQuadraticFunction{T}, x::T) where {T}
    f.constant += x
    return
end

function _add_to_expression!(
    f::MOI.ScalarQuadraticFunction{T},
    x::MOI.ScalarAffineTerm{T},
) where {T}
    push!(f.affine_terms, x)
    return
end

function _add_to_expression!(
    f::MOI.ScalarQuadraticFunction{T},
    x::MOI.ScalarQuadraticFunction{T},
) where {T}
    MOI.Utilities.operate!(+, T, f, x)
    return
end

# <expression> :== <term> (("+" | "-") <term>)*
function _parse_expression(state::_LexerState, cache::_ReadCache{T}) where {T}
    f = zero(MOI.ScalarQuadraticFunction{T})
    _add_to_expression!(f, _parse_term(state, cache))
    while (p = peek(state, _Token)) !== nothing
        if p.kind == _TOKEN_ADDITION
            p = read(state, _Token)
            _add_to_expression!(f, _parse_term(state, cache))
        elseif p.kind == _TOKEN_SUBTRACTION
            p = read(state, _Token)
            _add_to_expression!(f, _parse_term(state, cache, -one(T)))
        elseif p.kind == _TOKEN_NEWLINE
            if _next_token_is(state, _TOKEN_KEYWORD, 2)
                break
            end
            _ = read(state, _Token)
        else
            break
        end
    end
    if isempty(f.quadratic_terms)
        return MOI.ScalarAffineFunction(f.affine_terms, f.constant)
    end
    return f
end

# <set-suffix> :==
#   "free"
#   | ">=" <number>
#   | "<=" <number>
#   | "==" <number>
#
# There are other inequality operators that are supported, like `>`, `<`, and
# `=`. These are normalized when lexing.
function _parse_set_suffix(state, cache)
    _skip_newlines(state)
    p = read(state, _Token)
    if _compare_case_insenstive(p, "free")
        return nothing
    elseif p.kind == _TOKEN_GREATER_THAN
        rhs = _parse_number(state, cache)
        return MOI.GreaterThan(rhs)
    elseif p.kind == _TOKEN_LESS_THAN
        rhs = _parse_number(state, cache)
        return MOI.LessThan(rhs)
    elseif p.kind == _TOKEN_EQUAL_TO
        rhs = _parse_number(state, cache)
        return MOI.EqualTo(rhs)
    else
        _throw_parse_error(
            state,
            p,
            "We expected this to be an inequality like `>=`, `<=`, or `==`.",
        )
    end
end

# <set-prefix> :==
#   <number> ">="
#   | <number> "<="
#   | <number> "=="
#
# There are other inequality operators that are supported, like `>`, `<`, and
# `=`. These are normalized when lexing.
function _parse_set_prefix(state, cache)
    lhs = _parse_number(state, cache)
    _skip_newlines(state)
    p = read(state, _Token)
    if p.kind == _TOKEN_GREATER_THAN
        return MOI.LessThan(lhs)
    elseif p.kind == _TOKEN_LESS_THAN
        return MOI.GreaterThan(lhs)
    elseif p.kind == _TOKEN_EQUAL_TO
        return MOI.EqualTo(lhs)
    else
        _throw_parse_error(
            state,
            p,
            "We expected this to be an inequality like `>=`, `<=`, or `==`.",
        )
    end
end

# <name> :== [<identifier> :]
function _parse_name(state::_LexerState, cache::_ReadCache)
    _skip_newlines(state)
    if _next_token_is(state, _TOKEN_IDENTIFIER, 1) &&
       _next_token_is(state, _TOKEN_COLON, 2)
        name = read(state, _Token)
        _ = read(state, _Token)  # Skip :
        return name.value
    end
    return nothing
end

# <objective> :== <name> [<expression>]
function _parse_objective(state::_LexerState, cache::_ReadCache)
    _ = _parse_name(state, cache)
    _skip_newlines(state)
    if _next_token_is(state, _TOKEN_KEYWORD)
        return  # A line like `obj:\nsubject to`
    end
    f = _parse_expression(state, cache)
    MOI.set(cache.model, MOI.ObjectiveFunction{typeof(f)}(), f)
    return
end

function _add_bound(
    cache::_ReadCache,
    x::MOI.VariableIndex,
    set::MOI.GreaterThan,
)
    delete!(cache.variable_with_default_bound, x)
    if isfinite(set.lower)
        MOI.add_constraint(cache.model, x, set)
    end
    return
end

function _add_bound(cache::_ReadCache, x::MOI.VariableIndex, set::MOI.LessThan)
    if set.upper < 0
        delete!(cache.variable_with_default_bound, x)
    end
    if isfinite(set.upper)
        MOI.add_constraint(cache.model, x, set)
    end
    return
end

function _add_bound(cache::_ReadCache, x::MOI.VariableIndex, set::MOI.EqualTo)
    delete!(cache.variable_with_default_bound, x)
    MOI.add_constraint(cache.model, x, set)
    return
end

# x free
function _add_bound(cache::_ReadCache, x::MOI.VariableIndex, ::Nothing)
    delete!(cache.variable_with_default_bound, x)
    return
end

# <bound-expression> :==
#   <identifier> <set-suffix>
#   | <set-prefix> <identifier>
#   | <set-prefix> <identifier> <set-suffix>
function _parse_bound_expression(state, cache)
    if _next_token_is(state, _TOKEN_IDENTIFIER)  # `x free` or `x op b`
        x = _parse_identifier(state, cache)
        set = _parse_set_suffix(state, cache)
        _add_bound(cache, x, set)
        return
    end
    # `a op x` or `a op x op b`
    lhs_set = _parse_set_prefix(state, cache)
    x = _parse_identifier(state, cache)
    _add_bound(cache, x, lhs_set)
    if _next_token_is(state, _TOKEN_GREATER_THAN) ||
       _next_token_is(state, _TOKEN_LESS_THAN) ||
       _next_token_is(state, _TOKEN_EQUAL_TO)  # `a op x op b`
        # We don't add MOI.Interval constraints to follow JuMP's convention of
        # separate bounds.
        rhs_set = _parse_set_suffix(state, cache)
        _add_bound(cache, x, rhs_set)
    end
    return
end

function _is_sos_constraint(state)
    return _next_token_is(state, _TOKEN_IDENTIFIER, 1) &&
           _next_token_is(state, _TOKEN_COLON, 2) &&
           _next_token_is(state, _TOKEN_COLON, 3)
end

# <constraint-sos> :==
#     S1:: (<identifier>:<number>)+
#   | S2:: (<identifier>:<number>)+
#
# New lines are not supported within the line.
function _parse_constraint_sos(
    state::_LexerState,
    cache::_ReadCache{T},
) where {T}
    t = read(state, _Token, _TOKEN_IDENTIFIER) # Si
    if !(t.value == "S1" || t.value == "S2")
        _throw_parse_error(
            state,
            t,
            "This must be either `S1` for SOS-I or `S2` for SOS-II.",
        )
    end
    _ = read(state, _Token, _TOKEN_COLON)
    _ = read(state, _Token, _TOKEN_COLON)
    f, w = MOI.VectorOfVariables(MOI.VariableIndex[]), T[]
    while true
        if _next_token_is(state, _TOKEN_NEWLINE)
            t = peek(state, _Token)
            _throw_parse_error(
                state,
                t,
                "SOS constraints cannot be spread across lines.",
            )
        end
        push!(f.variables, _parse_identifier(state, cache))
        _ = read(state, _Token, _TOKEN_COLON)
        push!(w, _parse_number(state, cache))
        if _next_token_is(state, _TOKEN_NEWLINE)
            break
        end
    end
    if t.value == "S1"
        return MOI.add_constraint(cache.model, f, MOI.SOS1(w))
    else
        return MOI.add_constraint(cache.model, f, MOI.SOS2(w))
    end
end

function _is_indicator_constraint(state)
    return _next_token_is(state, _TOKEN_IDENTIFIER, 1) &&
           _next_token_is(state, _TOKEN_EQUAL_TO, 2) &&
           _next_token_is(state, _TOKEN_NUMBER, 3) &&
           _next_token_is(state, _TOKEN_IMPLIES, 4)
end

# <constraint-indicator> :==
#   <identifier> "=" ("0" | "1") "->" <expression> <set-suffix>
function _parse_constraint_indicator(
    state::_LexerState,
    cache::_ReadCache{T},
) where {T}
    z = _parse_identifier(state, cache)
    _ = read(state, _Token, _TOKEN_EQUAL_TO)
    t = read(state, _Token, _TOKEN_NUMBER)
    indicator = if t.value == "0"
        MOI.ACTIVATE_ON_ZERO
    elseif t.value == "1"
        MOI.ACTIVATE_ON_ONE
    else
        _throw_parse_error(state, t, "This must be either `= 0` or `= 1`.")
    end
    _ = read(state, _Token, _TOKEN_IMPLIES)
    f = _parse_expression(state, cache)
    set = _parse_set_suffix(state, cache)
    return MOI.add_constraint(
        cache.model,
        MOI.Utilities.operate(vcat, T, z, f),
        MOI.Indicator{indicator}(set),
    )
end

# <constraint> :==
#     <name> <expression> <set-suffix>
#   | <name> <constraint-sos>
#   | <name> <constraint-indicator>
function _parse_constraint(state::_LexerState, cache::_ReadCache)
    name = _parse_name(state, cache)
    # Check if this is an SOS constraint
    c = if _is_sos_constraint(state)
        _parse_constraint_sos(state, cache)
    elseif _is_indicator_constraint(state)
        _parse_constraint_indicator(state, cache)
    else
        f = _parse_expression(state, cache)
        set = _parse_set_suffix(state, cache)
        MOI.add_constraint(cache.model, f, set)
    end
    if name !== nothing
        MOI.set(cache.model, MOI.ConstraintName(), c, name)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestNonlinearSolFiles

using Test
import MathOptInterface as MOI
const NL = MOI.FileFormats.NL

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function _hs071()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    v = MOI.add_variables(model, 4)
    l = [1.1, 1.2, 1.3, 1.4]
    u = [5.1, 5.2, 5.3, 5.4]
    start = [2.1, 2.2, 2.3, 2.4]
    MOI.add_constraint.(model, v, MOI.GreaterThan.(l))
    MOI.add_constraint.(model, v, MOI.LessThan.(u))
    MOI.set.(model, MOI.VariablePrimalStart(), v, start)
    lb, ub = [25.0, 40.0], [Inf, 40.0]
    evaluator = MOI.Test.HS071(true)
    block_data = MOI.NLPBlockData(MOI.NLPBoundsPair.(lb, ub), evaluator, true)
    MOI.set(model, MOI.NLPBlock(), block_data)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    return model, v
end

"""
    test_sol_hs071()

This function tests the model with a solution as obtained from Ipopt.
"""
function test_sol_hs071()
    model, v = _hs071()
    nl_model = NL.Model()
    index_map = MOI.copy_to(nl_model, model)
    sol = NL.SolFileResults(joinpath(@__DIR__, "data", "hs071.sol"), nl_model)
    @test MOI.get(sol, MOI.ResultCount()) == 1
    @test MOI.get(sol, MOI.RawStatusString()) ==
          "Ipopt 3.14.4: Optimal Solution Found"
    @test MOI.get(sol, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    @test MOI.get(sol, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(sol, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    @test ≈(MOI.get(sol, MOI.ObjectiveValue()), 34.4432046; atol = 1e-6)
    x_p = [1.1, 1.573552, 2.6746838, 5.4]
    for (i, vi) in enumerate(v)
        v_dest = index_map[vi]
        @test ≈(MOI.get(sol, MOI.VariablePrimal(), v_dest), x_p[i]; atol = 1e-6)
    end
    F = MOI.VariableIndex
    for (i, vi) in enumerate(v)
        ci = MOI.ConstraintIndex{F,MOI.GreaterThan{Float64}}(vi.value)
        c_dest = index_map[ci]
        if i == 1
            dual = MOI.get(sol, MOI.ConstraintDual(), c_dest)
            @test ≈(dual, 28.5907038; atol = 1e-6)
        else
            @test ≈(
                MOI.get(sol, MOI.ConstraintDual(), c_dest),
                0.0;
                atol = 1e-6,
            )
        end
        @test ≈(MOI.get(sol, MOI.ConstraintPrimal(), ci), x_p[i]; atol = 1e-6)
        ci = MOI.ConstraintIndex{F,MOI.LessThan{Float64}}(vi.value)
        c_dest = index_map[ci]
        if i == 4
            dual = MOI.get(sol, MOI.ConstraintDual(), c_dest)
            @test ≈(dual, -5.58255055; atol = 1e-6)
        else
            @test ≈(
                MOI.get(sol, MOI.ConstraintDual(), c_dest),
                0.0;
                atol = 1e-6,
            )
        end
        @test ≈(MOI.get(sol, MOI.ConstraintPrimal(), ci), x_p[i]; atol = 1e-6)
    end
    nlp_block_dual = MOI.get(sol, MOI.NLPBlockDual())
    @test ≈(nlp_block_dual, [0.1787618, 0.9850008]; atol = 1e-6)
    return
end

function test_sol_hs071_variable_dual()
    model, v = _hs071()
    for (sign, sense) in [(1, MOI.MIN_SENSE), (-1, MOI.MAX_SENSE)]
        MOI.set(model, MOI.ObjectiveSense(), sense)
        nl_model = NL.Model()
        index_map = MOI.copy_to(nl_model, model)
        sol =
            NL.SolFileResults(joinpath(@__DIR__, "data", "hs071.sol"), nl_model)
        x1 = index_map[v[1]]
        F = MOI.VariableIndex
        dual = sign * 28.590703805487557
        ci = MOI.ConstraintIndex{F,MOI.GreaterThan{Float64}}(x1.value)
        @test ≈(MOI.get(sol, MOI.ConstraintDual(), ci), dual, atol = 1e-8)
        ci = MOI.ConstraintIndex{F,MOI.LessThan{Float64}}(x1.value)
        @test ≈(MOI.get(sol, MOI.ConstraintDual(), ci), 0.0, atol = 1e-8)
        ci = MOI.ConstraintIndex{F,MOI.EqualTo{Float64}}(x1.value)
        @test ≈(MOI.get(sol, MOI.ConstraintDual(), ci), dual, atol = 1e-8)
        ci = MOI.ConstraintIndex{F,MOI.Interval{Float64}}(x1.value)
        @test ≈(MOI.get(sol, MOI.ConstraintDual(), ci), dual, atol = 1e-8)
    end
    return
end

function test_sol_uno_hs071_variable_dual()
    model, v = _hs071()
    for (sign, sense) in [(1, MOI.MIN_SENSE), (-1, MOI.MAX_SENSE)]
        MOI.set(model, MOI.ObjectiveSense(), sense)
        nl_model = NL.Model()
        index_map = MOI.copy_to(nl_model, model)
        sol = NL.SolFileResults(
            joinpath(@__DIR__, "data", "hs071_uno.sol"),
            nl_model,
        )
        x1 = index_map[v[1]]
        F = MOI.VariableIndex
        dual = sign * 28.590703805487557
        ci = MOI.ConstraintIndex{F,MOI.GreaterThan{Float64}}(x1.value)
        @test ≈(MOI.get(sol, MOI.ConstraintDual(), ci), dual, atol = 1e-8)
        ci = MOI.ConstraintIndex{F,MOI.LessThan{Float64}}(x1.value)
        @test ≈(MOI.get(sol, MOI.ConstraintDual(), ci), 0.0, atol = 1e-8)
        ci = MOI.ConstraintIndex{F,MOI.EqualTo{Float64}}(x1.value)
        @test ≈(MOI.get(sol, MOI.ConstraintDual(), ci), dual, atol = 1e-8)
        ci = MOI.ConstraintIndex{F,MOI.Interval{Float64}}(x1.value)
        @test ≈(MOI.get(sol, MOI.ConstraintDual(), ci), dual, atol = 1e-8)
    end
    return
end

function test_sol_lower_bound_dual_args()
    model, v = _hs071()
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    nl_model = NL.Model()
    index_map = MOI.copy_to(nl_model, model)
    sol = NL.SolFileResults(
        joinpath(@__DIR__, "data", "hs071_uno.sol"),
        nl_model;
        suffix_lower_bound_duals = String[],
        suffix_upper_bound_duals = String[],
    )
    @test isempty(sol.zL_out)
    @test isempty(sol.zU_out)
    return
end

"""
    test_sol_hs071_max_sense()

This function tests that the duals are negated if we switch the objective sense.
"""
function test_sol_hs071_max_sense()
    model, v = _hs071()
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    nl_model = NL.Model()
    index_map = MOI.copy_to(nl_model, model)
    sol = NL.SolFileResults(joinpath(@__DIR__, "data", "hs071.sol"), nl_model)
    F = MOI.VariableIndex
    for (i, vi) in enumerate(v)
        ci = MOI.ConstraintIndex{F,MOI.GreaterThan{Float64}}(vi.value)
        c_dest = index_map[ci]
        if i == 1
            dual = MOI.get(sol, MOI.ConstraintDual(), c_dest)
            @test ≈(dual, -28.5907038; atol = 1e-6)
        else
            @test ≈(
                MOI.get(sol, MOI.ConstraintDual(), c_dest),
                0.0;
                atol = 1e-6,
            )
        end
        ci = MOI.ConstraintIndex{F,MOI.LessThan{Float64}}(vi.value)
        c_dest = index_map[ci]
        if i == 4
            dual = MOI.get(sol, MOI.ConstraintDual(), c_dest)
            @test ≈(dual, 5.58255055; atol = 1e-6)
        else
            @test ≈(
                MOI.get(sol, MOI.ConstraintDual(), c_dest),
                0.0;
                atol = 1e-6,
            )
        end
    end
    nlp_block_dual = MOI.get(sol, MOI.NLPBlockDual())
    @test ≈(nlp_block_dual, -[0.1787618, 0.9850008]; atol = 1e-6)
    return
end

function test_sol_quadratic_constraint()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    g = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(2.0, x, x)],
        [MOI.ScalarAffineTerm(1.0, x)],
        3.0,
    )
    c = MOI.add_constraint(model, g, MOI.Interval(1.0, 10.0))
    nl_model = NL.Model()
    index_map = MOI.copy_to(nl_model, model)
    filename = joinpath(@__DIR__, "data", "quadratic.sol")
    sol = NL.SolFileResults(filename, nl_model)
    xv = MOI.get(sol, MOI.VariablePrimal(), index_map[x])
    @test ≈(MOI.get(sol, MOI.ConstraintPrimal(), index_map[c]), xv^2 + xv + 3)
    @test ≈(MOI.get(sol, MOI.ConstraintDual(), index_map[c]), 0.0)
    return
end

function test_sol_linear_constraint()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    g = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.2, x)], 3.0)
    c = MOI.add_constraint(model, g, MOI.Interval(1.0, 10.0))
    nl_model = NL.Model()
    index_map = MOI.copy_to(nl_model, model)
    filename = joinpath(@__DIR__, "data", "quadratic.sol")
    sol = NL.SolFileResults(filename, nl_model)
    xv = MOI.get(sol, MOI.VariablePrimal(), index_map[x])
    @test ≈(MOI.get(sol, MOI.ConstraintPrimal(), index_map[c]), 1.2xv + 3)
    @test ≈(MOI.get(sol, MOI.ConstraintDual(), index_map[c]), 0.0)
    return
end

function test_sol_attr_out_of_bounds()
    model, v = _hs071()
    nl_model = NL.Model()
    index_map = MOI.copy_to(nl_model, model)
    sol = NL.SolFileResults(joinpath(@__DIR__, "data", "hs071.sol"), nl_model)
    @test MOI.get(sol, MOI.PrimalStatus(2)) == MOI.NO_SOLUTION
    @test MOI.get(sol, MOI.DualStatus(2)) == MOI.NO_SOLUTION
    @test_throws MOI.ResultIndexBoundsError MOI.get(sol, MOI.ObjectiveValue(2))
    x = index_map[v[1]]
    @test_throws MOI.ResultIndexBoundsError MOI.get(
        sol,
        MOI.VariablePrimal(2),
        x,
    )
    return
end

function test_sol_infeasible()
    model, _ = _hs071()
    nl_model = NL.Model()
    _ = MOI.copy_to(nl_model, model)
    sol = NL.SolFileResults(
        joinpath(@__DIR__, "data", "hs071_infeasible.sol"),
        nl_model,
    )
    @test MOI.get(sol, MOI.TerminationStatus()) == MOI.LOCALLY_INFEASIBLE
    @test MOI.get(sol, MOI.PrimalStatus()) == MOI.UNKNOWN_RESULT_STATUS
    @test MOI.get(sol, MOI.DualStatus()) == MOI.NO_SOLUTION
    return
end

function test_sol_vbtol()
    model, _ = _hs071()
    nl_model = NL.Model()
    _ = MOI.copy_to(nl_model, model)
    sol = NL.SolFileResults(
        joinpath(@__DIR__, "data", "hs071_vbtol.sol"),
        nl_model,
    )
    @test MOI.get(sol, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    @test MOI.get(sol, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(sol, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    return
end

function test_sol_badsuffix()
    model, _ = _hs071()
    nl_model = NL.Model()
    _ = MOI.copy_to(nl_model, model)
    sol = NL.SolFileResults(
        joinpath(@__DIR__, "data", "hs071_badsuffix.sol"),
        nl_model,
    )
    @test MOI.get(sol, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    @test MOI.get(sol, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(sol, MOI.DualStatus()) == MOI.NO_SOLUTION
    return
end

function test_sol_no_duals()
    model, _ = _hs071()
    nl_model = NL.Model()
    _ = MOI.copy_to(nl_model, model)
    sol = NL.SolFileResults(
        joinpath(@__DIR__, "data", "hs071_noduals.sol"),
        nl_model,
    )
    @test MOI.get(sol, MOI.TerminationStatus()) == MOI.LOCALLY_SOLVED
    @test MOI.get(sol, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(sol, MOI.DualStatus()) == MOI.NO_SOLUTION
    return
end

function test_statuses()
    statuses = Dict(
        (0, "Optimal Solution Found") =>
            (MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT),
        (100, "Optimal Solution Found") =>
            (MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT),
        (200, "Converged to a locally infeasible point.") =>
            (MOI.LOCALLY_INFEASIBLE, MOI.UNKNOWN_RESULT_STATUS),
        (300, "Model is Unbounded") =>
            (MOI.DUAL_INFEASIBLE, MOI.UNKNOWN_RESULT_STATUS),
        (400, "norm limit exceeded") =>
            (MOI.OTHER_LIMIT, MOI.UNKNOWN_RESULT_STATUS),
        (403, "Solver 10.0.1: time limit, feasible solution\n") =>
            (MOI.TIME_LIMIT, MOI.FEASIBLE_POINT),
        (500, "Solver error.") =>
            (MOI.OTHER_ERROR, MOI.UNKNOWN_RESULT_STATUS),
        (-1, "Optimal Solution Found") =>
            (MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT),
        (-1, "Converged to a locally infeasible point.") =>
            (MOI.LOCALLY_INFEASIBLE, MOI.UNKNOWN_RESULT_STATUS),
        (-1, "Model is Unbounded") =>
            (MOI.DUAL_INFEASIBLE, MOI.UNKNOWN_RESULT_STATUS),
        (-1, "norm limit exceeded") =>
            (MOI.OTHER_LIMIT, MOI.UNKNOWN_RESULT_STATUS),
        (-1, "Solver error.") =>
            (MOI.OTHER_ERROR, MOI.UNKNOWN_RESULT_STATUS),
        (-1, "") => (MOI.OTHER_ERROR, MOI.UNKNOWN_RESULT_STATUS),
    )
    for ((a, b), (t, p)) in statuses
        @test NL._interpret_status(a, b) == (t, p)
    end
    return
end

function test_sol_empty()
    sol = NL.SolFileResults("optimize not called", MOI.OPTIMIZE_NOT_CALLED)
    @test MOI.get(sol, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
    @test MOI.get(sol, MOI.PrimalStatus()) == MOI.NO_SOLUTION
    @test MOI.get(sol, MOI.DualStatus()) == MOI.NO_SOLUTION
    return
end

function test_result_count()
    results = NL.SolFileResults("raw", MOI.OTHER_LIMIT)
    @test MOI.get(results, MOI.ResultCount()) == 0
    results.variable_primal[MOI.VariableIndex(1)] = 0.0
    @test MOI.get(results, MOI.ResultCount()) == 1
    return
end

function test_eol()
    model = NL.Model()
    io = IOBuffer()
    @test_throws(
        ErrorException("Reached end of sol file unexpectedly."),
        NL.SolFileResults(io, model),
    )
    return
end

end

TestNonlinearSolFiles.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

function precompile_constraint(model, F, S)
    @warn("This function is deprecated. Use PrecompileTools.jl instead")
    return
end

function precompile_variables(model)
    @warn("This function is deprecated. Use PrecompileTools.jl instead")
    return
end

function precompile_model(model, constraints)
    @warn("This function is deprecated. Use PrecompileTools.jl instead")
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module MathOptInterface

import MutableArithmetics as MA

"""
    ModelLike

Abstract supertype for objects that implement the "Model" interface for defining
an optimization problem.
"""
abstract type ModelLike end

# This allows to use `ModelLike`s in broadcast calls without the need to
# embed it in a `Ref`
Base.broadcastable(model::ModelLike) = Ref(model)

function _try_get(model::ModelLike, attr, default)
    try
        return get(model, attr)
    catch
        return default
    end
end

function Base.show(io::IO, model::ModelLike)
    offset = Base.get(io, :offset, "")
    Utilities.print_with_acronym(io, summary(model))
    println(io)
    # ObjectiveSense
    sense = _try_get(model, ObjectiveSense(), "unknown")
    println(io, offset, "├ ObjectiveSense: $sense")
    # ObjectiveFunctionType
    F = _try_get(model, ObjectiveFunctionType(), "unknown")
    Utilities.print_with_acronym(io, "$(offset)├ ObjectiveFunctionType: $F\n")
    # NumberOfVariables
    n = _try_get(model, NumberOfVariables(), "unknown")
    println(io, offset, "├ NumberOfVariables: $n")
    # NumberOfConstraints
    constraint_types = _try_get(model, ListOfConstraintTypesPresent(), nothing)
    if constraint_types === nothing
        print(io, offset, "└ NumberOfConstraints: unknown")
    else
        constraint_lines, n_total = String[], 0
        for (i, (F, S)) in enumerate(constraint_types)
            m = _try_get(model, NumberOfConstraints{F,S}(), 0)
            n_total += m
            tree = ifelse(i == length(constraint_types), '└', '├')
            push!(constraint_lines, "\n$offset  $tree $F in $S: $m")
        end
        print(io, offset, "└ NumberOfConstraints: $n_total")
        for line in constraint_lines
            Utilities.print_with_acronym(io, line)
        end
    end
    return
end

"""
    AbstractOptimizer <: ModelLike

Abstract supertype for objects representing an instance of an optimization
problem tied to a particular solver. This is typically a solver's in-memory
representation. In addition to `ModelLike`, `AbstractOptimizer` objects let you
solve the model and query the solution.
"""
abstract type AbstractOptimizer <: ModelLike end

"""
    optimize!(optimizer::AbstractOptimizer)

Optimize the problem contained in `optimizer`.

Before calling `optimize!`, the problem should first be constructed using the
incremental interface (see [`supports_incremental_interface`](@ref)) or [`copy_to`](@ref).
"""
function optimize! end

"""
    optimize!(dest::AbstractOptimizer, src::ModelLike)::Tuple{IndexMap,Bool}

A "one-shot" call that copies the problem from `src` into `dest` and then uses
`dest` to optimize the problem.

Returns a tuple of an [`IndexMap`](@ref) and a `Bool` `copied`.

 * The [`IndexMap`](@ref) object translates variable and constraint indices from
   the `src` model to the corresponding indices in the `dest` optimizer. See
   [`copy_to`](@ref) for details.
 * If `copied == true`, `src` was copied to `dest` and then cached, allowing
   incremental modification if supported by the solver.
 * If `copied == false`, a cache of the model was _not_ kept in `dest`.
   Therefore, only the solution information (attributes for which
   [`is_set_by_optimize`](@ref) is true) is available to query.

!!! note
    The main purpose of `optimize!` method with two arguments is for use in
    [`Utilities.CachingOptimizer`](@ref).

## Relationship to the single-argument `optimize!`

The default fallback of `optimize!(dest::AbstractOptimizer, src::ModelLike)` is
```julia
function optimize!(dest::AbstractOptimizer, src::ModelLike)
    index_map = copy_to(dest, src)
    optimize!(dest)
    return index_map, true
end
```
Therefore, subtypes of [`AbstractOptimizer`](@ref) should either implement this
two-argument method, or implement both [`copy_to(::Optimizer, ::ModelLike)`](@ref copy_to)
and `optimize!(::Optimizer)`.
"""
function optimize!(dest, src)
    # The arguments above are untyped to avoid ambiguities.
    index_map = copy_to(dest, src)
    optimize!(dest)
    return index_map, true
end

"""
    compute_conflict!(optimizer::AbstractOptimizer)

Computes a minimal subset of constraints such that the model with the other
constraint removed is still infeasible.

Some solvers call a set of conflicting constraints an Irreducible Inconsistent
Subsystem (IIS).

See also [`ConflictStatus`](@ref) and [`ConstraintConflictStatus`](@ref).

### Note

If the model is modified after a call to `compute_conflict!`, the implementor
is not obliged to purge the conflict. Any calls to the above attributes may
return values for the original conflict without a warning. Similarly, when
modifying the model, the conflict can be discarded.
"""
function compute_conflict!(optimizer::AbstractOptimizer)
    return throw(
        ArgumentError(
            "The optimizer $(typeof(optimizer)) does not support " *
            "`compute_conflict!`",
        ),
    )
end

"""
    write_to_file(model::ModelLike, filename::String; kwargs...)

Write the current model to the file at `filename`.

Supported file types depend on the model type.

Additional keyword arguments are passed to the `Model` constructor of the
relevant file format. See, for example, [`FileFormats.LP.Model`](@ref) and
[`FileFormats.MPS.Model`](@ref).

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Int}();

julia> x, _ = MOI.add_constrained_variable(model, MOI.Interval(2, 3));

julia> MOI.set(model, MOI.VariableName(), x, "x");

julia> filename = joinpath(tempdir(), "model.lp");

julia> MOI.write_to_file(model, filename; coefficient_type = Int);

julia> print(read(filename, String))
minimize
obj:
subject to
Bounds
2 <= x <= 3
End
```
"""
function write_to_file(model::ModelLike, filename::String; kwargs...)
    dest = FileFormats.Model(; filename, kwargs...)
    copy_to(dest, model)
    write_to_file(dest, filename)
    return
end

"""
    read_from_file(model::ModelLike, filename::String; kwargs...)

Read the file `filename` into the model `model`. If `model` is non-empty, this
may throw an error.

Supported file types depend on the model type.

Additional keyword arguments are passed to the `Model` constructor of the
relevant file format. See, for example, [`FileFormats.LP.Model`](@ref) and
[`FileFormats.MPS.Model`](@ref).

### Note

Once the contents of the file are loaded into the model, you can query the
variables via `MOI.get(model, MOI.ListOfVariableIndices())`. However, some
filetypes, such as LP files, do not maintain an explicit ordering of the
variables. Therefore, the returned list may be in an arbitrary order.

To avoid depending on the order of the indices, look up each variable index by
name using `MOI.get(model, MOI.VariableIndex, "name")`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Int}();

julia> x, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(2));

julia> MOI.set(model, MOI.VariableName(), x, "x");

julia> filename = joinpath(tempdir(), "model.lp");

julia> MOI.write_to_file(model, filename; coefficient_type = Int);

julia> new_model = MOI.Utilities.Model{Int}();

julia> MOI.read_from_file(new_model, filename; coefficient_type = Int);

julia> print(new_model)
Minimize ScalarAffineFunction{Int64}:
 (0)

Subject to:

VariableIndex-in-GreaterThan{Int64}
 x >= (2)

julia> MOI.get(new_model, MOI.VariableIndex, "x")
MOI.VariableIndex(1)
```
"""
function read_from_file(model::ModelLike, filename::String; kwargs...)
    src = FileFormats.Model(; filename, kwargs...)
    read_from_file(src, filename)
    copy_to(model, src)
    return
end

"""
    is_empty(model::ModelLike)

Returns `false` if the `model` has any model attribute set or has any variables
or constraints.

Note that an empty model can have optimizer attributes set.
"""
function is_empty end

"""
    empty!(model::ModelLike)

Empty the model, that is, remove all variables, constraints and model attributes
but not optimizer attributes.
"""
function empty! end

"""
    supports_incremental_interface(model::ModelLike)

Return a `Bool` indicating whether `model` supports building incrementally via
[`add_variable`](@ref) and [`add_constraint`](@ref).

The main purpose of this function is to determine whether a model can be loaded
into `model` incrementally or whether it should be cached and copied at once
instead.
"""
supports_incremental_interface(::ModelLike) = false

"""
    copy_to(dest::ModelLike, src::ModelLike)::IndexMap

Copy the model from `src` into `dest`.

The target `dest` is emptied, and all previous indices to variables and
constraints in `dest` are invalidated.

Returns an [`IndexMap`](@ref) object that translates variable and constraint
indices from the `src` model to the corresponding indices in the `dest` model.

## Notes

 * If a constraint that in `src` is not supported by `dest`, then an
   [`UnsupportedConstraint`](@ref) error is thrown.
 * If an [`AbstractModelAttribute`](@ref), [`AbstractVariableAttribute`](@ref),
   or [`AbstractConstraintAttribute`](@ref) is set in `src` but not supported by
   `dest`, then an [`UnsupportedAttribute`](@ref) error is thrown.

[`AbstractOptimizerAttribute`](@ref)s are _not_ copied  to the `dest` model.

## IndexMap

Implementations of `copy_to` must return an [`IndexMap`](@ref). For technical
reasons, this type is defined in the Utilities submodule as
`MOI.Utilities.IndexMap`. However, since it is an integral part of the MOI API,
we provide `MOI.IndexMap` as an alias.

### Example

```julia
# Given empty `ModelLike` objects `src` and `dest`.

x = add_variable(src)

is_valid(src, x)   # true
is_valid(dest, x)  # false (`dest` has no variables)

index_map = copy_to(dest, src)
is_valid(dest, x) # false (unless index_map[x] == x)
is_valid(dest, index_map[x]) # true
```
"""
function copy_to(dest, src)
    return error(
        "`copy_to` is not supported by the solver `$(typeof(dest))`. Did " *
        "you mean to call " *
        "`optimize!(dest::AbstractOptimizer, src::ModelLike)` instead?",
    )
end

"""
    @_documented_enum(args...)

A utility macro for writing `@enum`s with inline documentation strings.

The even arguments are forwarded to the `@enum` macro, and the odd arguments are
used as the docstring for the corresponding even argument.

## Example

```julia
julia> MOI.@_documented_enum(
           \"\"\"
               MyDocumentedEnum

           This is an example for the documentation.
           \"\"\",
           MyDocumentedEnum,
           \"A country down-under\",
           AUSTRALIA,
           \"Another country down-under\",
           NEW_ZEALAND,
       )
MyDocumentedEnum

help?> MyDocumentedEnum
search: MyDocumentedEnum

  MyDocumentedEnum

  This is an example for the documentation.

  Values
  ========

  Possible values are:

    •  AUSTRALIA: A country down-under

    •  NEW_ZEALAND: Another country down-under

help?> AUSTRALIA
search: AUSTRALIA

  AUSTRALIA::MyDocumentedEnum

  An instance of the MyDocumentedEnum enum.

  AUSTRALIA: A country down-under
```
"""
macro _documented_enum(args...)
    @assert iseven(length(args))
    code = quote
        $(Expr(:macrocall, Symbol("@enum"), __source__, args[2:2:end]...))
    end
    main_doc, enum = args[1], args[2]
    main_doc *= "\n## Values\n\n"
    for i in 3:2:length(args)
        docstr, value = args[i], args[i+1]
        doc = """
            $value::$enum

        An instance of the [`$enum`](@ref) enum.

        ## About

        $docstr
        """
        push!(
            code.args,
            Expr(:macrocall, Symbol("@doc"), __source__, doc, Meta.quot(value)),
        )
        new_docstr = join(split(docstr, "\n"), "\n   ")
        main_doc *= "### [`$value`](@ref)\n\n$new_docstr\n"
    end
    push!(
        code.args,
        Expr(
            :macrocall,
            Symbol("@doc"),
            __source__,
            main_doc,
            Meta.quot(args[2]),
        ),
    )
    return esc(code)
end

include("error.jl")
include("indextypes.jl")
include("functions.jl")
include("sets.jl")
include("attributes.jl")
include("constraints.jl")
include("modifications.jl")
include("variables.jl")
include("nlp.jl")

include("precompile.jl")

# submodules
include("Utilities/Utilities.jl") # MOI.Utilities
include("Test/Test.jl")
include("Bridges/Bridges.jl")     # MOI.Bridges
include("Benchmarks/Benchmarks.jl")
include("Nonlinear/Nonlinear.jl")
include("FileFormats/FileFormats.jl")

include("instantiate.jl")

"""
    IndexMap()

The dictionary-like object returned by [`copy_to`](@ref).

## IndexMap

Implementations of [`copy_to`](@ref) must return an [`IndexMap`](@ref). For
technical reasons, the `IndexMap` type is defined in the Utilities submodule as
`MOI.Utilities.IndexMap`. However, since it is an integral part of the MOI API,
we provide this `MOI.IndexMap` as an alias.
"""
const IndexMap = Utilities.IndexMap

import PrecompileTools

PrecompileTools.@setup_workload begin
    PrecompileTools.@compile_workload begin
        model = Utilities.CachingOptimizer(
            Utilities.UniversalFallback(Utilities.Model{Float64}()),
            instantiate(Utilities.MockOptimizer; with_bridge_type = Float64),
        )
        set(model, Silent(), true)
        x = add_variables(model, 3)
        add_constraint(model, x[1], ZeroOne())
        add_constraint(model, x[2], Integer())
        add_constraint(model, x[1], GreaterThan(0.0))
        add_constraint(model, x[2], LessThan(0.0))
        add_constraint(model, x[3], EqualTo(0.0))
        f = 1.0 * x[1] + x[2] + x[3]
        add_constraint(model, f, GreaterThan(0.0))
        add_constraint(model, f, LessThan(0.0))
        add_constraint(model, f, EqualTo(0.0))
        y, _ = add_constrained_variables(model, Nonnegatives(2))
        set(model, ObjectiveSense(), MAX_SENSE)
        set(model, ObjectiveFunction{typeof(f)}(), f)
        optimize!(model)
    end
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ZerosBridge{T} <: Bridges.Variable.AbstractBridge

`ZerosBridge` implements the following reformulation:

* ``x \\in \\{0\\}`` into the substitution rule ``x = 0``,

where `T` is the coefficient type of `0`.

## Source node

`ZerosBridge` supports:

 * [`MOI.VectorOfVariables`](@ref) in [`MOI.Zeros`](@ref)

## Target nodes

`ZerosBridge` does not create target nodes. It replaces all instances of `x`
with `0` via substitution. This means that no variables are created in the
underlying model.

## Caveats

The bridged variables are similar to parameters with zero values. Parameters
with non-zero values can be created with constrained variables in
[`MOI.EqualTo`](@ref) by combining a [`VectorizeBridge`](@ref) and this bridge.

However, functions modified by `ZerosBridge` cannot be unbridged. That is, for a
given function, we cannot determine if the bridged variables were used.

A related implication is that this bridge does not support
[`MOI.ConstraintDual`](@ref). However, if a [`MOI.Utilities.CachingOptimizer`](@ref)
is used, the dual can be determined by the bridged optimizer using
[`MOI.Utilities.get_fallback`](@ref) because the caching optimizer records the
unbridged function.
"""
struct ZerosBridge{T} <: AbstractBridge
    n::Int # Number of variables
end

const Zeros{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{ZerosBridge{T},OT}

function bridge_constrained_variable(
    ::Type{ZerosBridge{T}},
    model::MOI.ModelLike,
    set::MOI.Zeros,
) where {T}
    return ZerosBridge{T}(MOI.dimension(set))
end

function supports_constrained_variable(::Type{<:ZerosBridge}, ::Type{MOI.Zeros})
    return true
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:ZerosBridge})
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(::Type{<:ZerosBridge})
    return Tuple{Type,Type}[]
end

# Attributes, Bridge acting as a model
MOI.get(::ZerosBridge, ::MOI.NumberOfVariables)::Int64 = 0

MOI.get(::ZerosBridge, ::MOI.ListOfVariableIndices) = MOI.VariableIndex[]

# References
MOI.delete(::MOI.ModelLike, ::ZerosBridge) = nothing

# Attributes, Bridge acting as a constraint

function MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, bridge::ZerosBridge)
    return MOI.Zeros(bridge.n)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintPrimal,
    bridge::ZerosBridge{T},
) where {T}
    return zeros(T, bridge.n)
end

function MOI.get(
    ::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    ::ZerosBridge{T},
) where {T}
    msg =
        "Unable to query the dual of a variable bound that was reformulated " *
        "using `ZerosBridge`. This usually arises in conic solvers when a " *
        "variable is fixed to a value. As a work-around, instead of creating " *
        "a fixed variable using variable bounds like `p == 1`, add an affine " *
        "equality constraint like `1 * p == 1` (or `[1 * p - 1,] in Zeros(1)`)."
    return throw(MOI.GetAttributeNotAllowed(attr, msg))
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.VariablePrimal,
    ::ZerosBridge{T},
    ::MOI.Bridges.IndexInVector,
) where {T}
    return zero(T)
end

function MOI.Bridges.bridged_function(
    ::ZerosBridge{T},
    ::MOI.Bridges.IndexInVector,
) where {T}
    return zero(MOI.ScalarAffineFunction{T})
end

function unbridged_map(
    ::ZerosBridge,
    ::MOI.VariableIndex,
    ::MOI.Bridges.IndexInVector,
)
    # The transformation is not recoverable, so we explicitly return `nothing`
    # here. See the docstring of `unbridged_map` for details.
    return nothing
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type ProductOfSets{T} end

Represents a cartesian product of sets of given types.
"""
abstract type ProductOfSets{T} end

set_index(::ProductOfSets, ::Type{S}) where {S<:MOI.AbstractSet} = nothing

function _sets_code(esc_name, T, type_def, set_types...)
    code = Expr(:block, type_def)
    esc_types = esc.(set_types)
    for (i, esc_type) in enumerate(esc_types)
        push!(
            code.args,
            :(
                function $MOI.Utilities.set_index(
                    ::$esc_name{$(T)},
                    ::Type{$(esc_type)},
                ) where {$T}
                    return $i
                end
            ),
        )
    end
    push!(
        code.args,
        :(function $MOI.Utilities.set_types(::$esc_name{$T}) where {$T}
            return [$(esc_types...)]
        end),
    )
    return code
end

"""
    abstract type MixOfScalarSets{T} <: ProductOfSets{T} end

Product of scalar sets in the order the constraints are added, mixing the
constraints of different types.

Use [`@mix_of_scalar_sets`](@ref) to generate a new subtype.
"""
abstract type MixOfScalarSets{T} <: ProductOfSets{T} end

"""
    @mix_of_scalar_sets(name, set_types...)

Generate a new [`MixOfScalarSets`](@ref) subtype.

## Example

```jldoctest
julia> MOI.Utilities.@mix_of_scalar_sets(
           MixedIntegerLinearProgramSets,
           MOI.GreaterThan{T},
           MOI.LessThan{T},
           MOI.EqualTo{T},
           MOI.Integer,
       )
```
"""
macro mix_of_scalar_sets(name, set_types...)
    esc_name = esc(name)
    T = esc(:T)
    type_def =
        :(struct $(esc_name){$(T)} <: $MOI.Utilities.MixOfScalarSets{$(T)}
            """
            `set_ids[i]` maps the row `i` to the corresponding set type.
            """
            set_ids::Vector{Int}

            $(esc_name){$(T)}() where {$(T)} = new(Int[])
        end)
    return _sets_code(esc_name, T, type_def, set_types...)
end

MOI.is_empty(sets::MixOfScalarSets) = isempty(sets.set_ids)

MOI.empty!(sets::MixOfScalarSets) = empty!(sets.set_ids)

MOI.dimension(sets::MixOfScalarSets) = length(sets.set_ids)

rows(::MixOfScalarSets, ci::MOI.ConstraintIndex) = ci.value

function add_set(sets::MixOfScalarSets, i::Int)::Int64
    push!(sets.set_ids, i)
    return length(sets.set_ids)
end

final_touch(::MixOfScalarSets) = nothing

function MOI.get(
    sets::MixOfScalarSets{T},
    ::MOI.ListOfConstraintTypesPresent,
) where {T}
    present = Set(sets.set_ids)
    return Tuple{Type,Type}[
        (_affine_function_type(T, S), S) for
        S in set_types(sets) if set_index(sets, S) in present
    ]
end

function MOI.get(
    sets::MixOfScalarSets,
    ::MOI.NumberOfConstraints{F,S},
) where {F,S}
    i = set_index(sets, S)
    return count(isequal(i), sets.set_ids)
end

function MOI.get(
    sets::MixOfScalarSets,
    ::MOI.ListOfConstraintIndices{F,S},
) where {F,S}
    i = set_index(sets, S)
    return MOI.ConstraintIndex{F,S}[
        MOI.ConstraintIndex{F,S}(ci) for
        (ci, set_type) in enumerate(sets.set_ids) if set_type == i
    ]
end

function MOI.is_valid(
    sets::MixOfScalarSets,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    i = set_index(sets, S)
    if i === nothing
        return false
    end
    return ci.value in eachindex(sets.set_ids) && sets.set_ids[ci.value] == i
end

"""
    abstract type OrderedProductOfSets{T} <: ProductOfSets{T} end

Product of sets in the order the constraints are added, grouping the
constraints of the same types contiguously.

Use [`@product_of_sets`](@ref) to generate new subtypes.
"""
abstract type OrderedProductOfSets{T} <: ProductOfSets{T} end

"""
    @product_of_sets(name, set_types...)

Generate a new [`OrderedProductOfSets`](@ref) subtype.

## Example

```jldoctest
julia> MOI.Utilities.@product_of_sets(
           LinearOrthants,
           MOI.Zeros,
           MOI.Nonnegatives,
           MOI.Nonpositives,
           MOI.ZeroOne,
       )
```
"""
macro product_of_sets(name, set_types...)
    esc_name = esc(name)
    T = esc(:T)
    type_def = :(
        mutable struct $(esc_name){$(T)} <:
                       $MOI.Utilities.OrderedProductOfSets{$(T)}
            """
            `rows[i][j]` corresponds to constraint `j` of set type `i`.

            The value depends on `final_touch`:
             * Before `final_touch`, these are `1:dimension` of the constraint
             * After `final_touch`, these are the 1-indexed rows of the full
               constraint matrix
            """
            rows::Vector{Vector{UnitRange{Int}}}

            """
            A sanity bit to check that we don't call functions out-of-order.
            """
            final_touch::Bool

            function $(esc_name){$(T)}() where {$(T)}
                n = $(length(set_types))
                return new([UnitRange{Int}[] for _ in 1:n], false)
            end
        end
    )
    return _sets_code(esc_name, T, type_def, set_types...)
end

MOI.is_empty(sets::OrderedProductOfSets) = all(isempty, sets.rows)

function MOI.empty!(sets::OrderedProductOfSets)
    map(empty!, sets.rows)
    sets.final_touch = false
    return
end

function MOI.dimension(sets::OrderedProductOfSets)::Int
    @assert sets.final_touch
    for i in reverse(eachindex(sets.rows))
        if !isempty(sets.rows[i])
            return last(sets.rows[i][end])
        end
    end
    return 0  # All rows were empty.
end

# A backwards-compatible method to ensure callers of `sets.num_rows` still
# works.
function Base.getproperty(sets::OrderedProductOfSets, key::Symbol)
    if key == :num_rows
        if sets.final_touch
            return cumsum(num_rows(sets, S) for S in set_types(sets))
        end
        return Int[num_rows(sets, S) for S in set_types(sets)]
    end
    return getfield(sets, key)
end

function rows(
    sets::OrderedProductOfSets{T},
    ci::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},S},
)::Int where {T,S}
    @assert sets.final_touch
    i = set_index(sets, S)::Int
    return only(sets.rows[i][ci.value])
end

function rows(
    sets::OrderedProductOfSets{T},
    ci::MOI.ConstraintIndex{MOI.VectorAffineFunction{T},S},
)::UnitRange{Int} where {T,S}
    @assert sets.final_touch
    i = set_index(sets, S)::Int
    return sets.rows[i][ci.value]
end

function add_set(sets::OrderedProductOfSets, i::Int, dim::Int = 1)::Int64
    @assert !sets.final_touch
    push!(sets.rows[i], 1:dim)
    return length(sets.rows[i])
end

function final_touch(sets::OrderedProductOfSets)::Nothing
    @assert !sets.final_touch
    offset = 0
    for (i, rows) in enumerate(sets.rows)
        for (j, row) in enumerate(rows)
            rows[j] = offset .+ row
            offset += length(row)
        end
    end
    sets.final_touch = true
    return
end

"""
    num_rows(sets::OrderedProductOfSets, ::Type{S}) where {S}

Return the number of rows corresponding to a set of type `S`. That is, it is
the sum of the dimensions of the sets of type `S`.
"""
function num_rows(sets::OrderedProductOfSets, ::Type{S})::Int where {S}
    i = set_index(sets, S)::Int
    rows = sets.rows[i]
    if isempty(rows)
        return 0
    elseif sets.final_touch
        return max(0, last(rows[end]) - first(rows[1]) + 1)
    else
        return mapreduce(length, +, rows)
    end
end

function MOI.get(
    sets::OrderedProductOfSets{T},
    ::MOI.ListOfConstraintTypesPresent,
)::Vector{Tuple{Type,Type}} where {T}
    return Tuple{Type,Type}[
        (_affine_function_type(T, S), S) for
        (i, S) in enumerate(set_types(sets)) if !isempty(sets.rows[i])
    ]
end

function MOI.get(
    sets::OrderedProductOfSets,
    ::MOI.NumberOfConstraints{F,S},
)::Int64 where {F,S}
    i = set_index(sets, S)::Union{Nothing,Int}
    if i == nothing
        return 0
    end
    return length(sets.rows[i])
end

function MOI.get(
    sets::OrderedProductOfSets,
    ::MOI.ListOfConstraintIndices{F,S},
)::Vector{MOI.ConstraintIndex{F,S}} where {F,S}
    i = set_index(sets, S)::Union{Nothing,Int}
    if i == nothing
        return MOI.ConstraintIndex{F,S}[]
    end
    return MOI.ConstraintIndex{F,S}.(1:length(sets.rows[i]))
end

function MOI.is_valid(
    sets::OrderedProductOfSets,
    ci::MOI.ConstraintIndex{F,S},
)::Bool where {F,S}
    i = set_index(sets, S)::Union{Nothing,Int}
    if i == nothing
        return false
    end
    return 1 <= ci.value <= length(sets.rows[i])
end

"""
    RuntimeProductOfSets{T}()

An alternative to [`Utilities.@product_of_sets`](@ref), in which the set types
are decided at runtime using [`Utilities.add_set_type`](@ref).

## Examples

```jldoctest
julia> import MathOptInterface as MOI

julia> sets = MOI.Utilities.RuntimeProductOfSets{Int}();

julia> MOI.Utilities.set_types(sets)
Type[]

julia> MOI.Utilities.add_set_type(sets, MOI.Nonpositives)

julia> MOI.Utilities.set_types(sets)
1-element Vector{Type}:
 MathOptInterface.Nonpositives
```
"""
mutable struct RuntimeProductOfSets{T} <: OrderedProductOfSets{T}
    rows::Vector{Vector{UnitRange{Int}}}
    final_touch::Bool
    set_types::Vector{Type}

    function RuntimeProductOfSets{T}() where {T}
        return new(Vector{UnitRange{Int}}[], false, Type[])
    end
end

function set_index(
    set::RuntimeProductOfSets,
    ::Type{S},
) where {S<:MOI.AbstractSet}
    return findfirst(==(S), set.set_types)
end

set_types(set::RuntimeProductOfSets) = set.set_types

"""
    add_set_type(
        set::RuntimeProductOfSets,
        ::Type{S},
    ) where {S<:MOI.AbstractSet}

Declare that the [`Utilities.RuntimeProductOfSets`](@ref) `set` supports the
[`MOI.AbstractSet`](@ref) `S`.

## Examples

```jldoctest
julia> import MathOptInterface as MOI

julia> sets = MOI.Utilities.RuntimeProductOfSets{Int}();

julia> MOI.Utilities.set_types(sets)
Type[]

julia> MOI.Utilities.add_set_type(sets, MOI.Nonpositives)

julia> MOI.Utilities.set_types(sets)
1-element Vector{Type}:
 MathOptInterface.Nonpositives
```
"""
function add_set_type(
    set::RuntimeProductOfSets,
    ::Type{S},
) where {S<:MOI.AbstractSet}
    if set_index(set, S) === nothing
        push!(set.rows, Vector{UnitRange{Int}}[])
        push!(set.set_types, S)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    supports_constraint(
        model::ModelLike,
        ::Type{F},
        ::Type{S},
    )::Bool where {F<:AbstractFunction,S<:AbstractSet}

Return a `Bool` indicating whether `model` supports `F`-in-`S` constraints, that
is, `copy_to(model, src)` does not throw [`UnsupportedConstraint`](@ref) when
`src` contains `F`-in-`S` constraints. If `F`-in-`S` constraints are only not
supported in specific circumstances, for example, `F`-in-`S` constraints cannot be
combined with another type of constraint, it should still return `true`.
"""
function supports_constraint(
    ::ModelLike,
    F::Type{<:AbstractFunction},
    S::Type{<:AbstractSet},
)
    return false
end

"""
    struct UnsupportedConstraint{F<:AbstractFunction,S<:AbstractSet} <: UnsupportedError
        message::String
    end

An error indicating that constraints of type `F`-in-`S` are not supported by
the model, that is, that [`supports_constraint`](@ref) returns `false`.

```jldoctest
julia> showerror(stdout, MOI.UnsupportedConstraint{MOI.VariableIndex,MOI.ZeroOne}())
UnsupportedConstraint: `MathOptInterface.VariableIndex`-in-`MathOptInterface.ZeroOne` constraints are not supported by the
solver you have chosen, and we could not reformulate your model into a
form that is supported.

To fix this error you must choose a different solver.

```
"""
struct UnsupportedConstraint{F<:AbstractFunction,S<:AbstractSet} <:
       UnsupportedError
    # Human-friendly explanation why the attribute cannot be set
    message::String
end

UnsupportedConstraint{F,S}() where {F,S} = UnsupportedConstraint{F,S}("")

function Base.showerror(io::IO, err::UnsupportedConstraint{F,S}) where {F,S}
    print(
        io,
        """
        UnsupportedConstraint: `$F`-in-`$S` constraints are not supported by the
        solver you have chosen, and we could not reformulate your model into a
        form that is supported.

        To fix this error you must choose a different solver.

        $(err.message)
        """,
    )
    return
end

"""
    struct AddConstraintNotAllowed{F<:AbstractFunction, S<:AbstractSet} <: NotAllowedError
        message::String # Human-friendly explanation why the attribute cannot be set
    end

An error indicating that constraints of type `F`-in-`S` are supported (see
[`supports_constraint`](@ref)) but cannot be added.
"""
struct AddConstraintNotAllowed{F<:AbstractFunction,S<:AbstractSet} <:
       NotAllowedError
    message::String # Human-friendly explanation why the attribute cannot be set
end
AddConstraintNotAllowed{F,S}() where {F,S} = AddConstraintNotAllowed{F,S}("")

function operation_name(::AddConstraintNotAllowed{F,S}) where {F,S}
    return "Adding `$F`-in-`$S` constraints"
end

"""
    struct ScalarFunctionConstantNotZero{T, F, S} <: Exception
        constant::T
    end

An error indicating that the constant part of the function in the constraint
`F`-in-`S` is nonzero.
"""
struct ScalarFunctionConstantNotZero{T,F,S} <: Exception
    constant::T
end

function Base.:(==)(
    x::ScalarFunctionConstantNotZero{T,F,S},
    y::ScalarFunctionConstantNotZero{T,F,S},
) where {T,F,S}
    return x.constant == y.constant
end

function Base.showerror(
    io::IO,
    err::ScalarFunctionConstantNotZero{T,F,S},
) where {T,F,S}
    return print(
        io,
        "In `$F`-in-`$S` constraint: Constant $(err.constant) of the ",
        "function is not zero. The function constant should be moved to the ",
        "set. You can use `MOI.Utilities.normalize_and_add_constraint` which does ",
        "this automatically.",
    )
end

"""
    throw_if_scalar_and_constant_not_zero(func, S::Type)

Throw a `ScalarFunctionConstantNotZero(index)` error `func` is a scalar function
whose constant is not zero.
"""
function throw_if_scalar_and_constant_not_zero(
    func::AbstractScalarFunction,
    ::Type{S},
) where {S<:AbstractScalarSet}
    cst = constant(func)
    if !iszero(cst)
        throw(ScalarFunctionConstantNotZero{typeof(cst),typeof(func),S}(cst))
    end
    return
end

function throw_if_scalar_and_constant_not_zero(
    ::VariableIndex,
    ::Type{S},
) where {S<:AbstractScalarSet}
    return
end

function throw_if_scalar_and_constant_not_zero(
    ::AbstractVectorFunction,
    ::Type{S},
) where {S<:AbstractVectorSet}
    return
end

"""
    add_constraint(model::ModelLike, func::F, set::S)::ConstraintIndex{F,S} where {F,S}

Add the constraint ``f(x) \\in \\mathcal{S}`` where ``f`` is defined by `func`, and ``\\mathcal{S}`` is defined by `set`.

    add_constraint(model::ModelLike, v::VariableIndex, set::S)::ConstraintIndex{VariableIndex,S} where {S}
    add_constraint(model::ModelLike, vec::Vector{VariableIndex}, set::S)::ConstraintIndex{VectorOfVariables,S} where {S}

Add the constraint ``v \\in \\mathcal{S}`` where ``v`` is the variable (or vector of variables) referenced by `v` and ``\\mathcal{S}`` is defined by `set`.

* An [`UnsupportedConstraint`](@ref) error is thrown if `model` does not support
  `F`-in-`S` constraints,
* a [`AddConstraintNotAllowed`](@ref) error is thrown if it supports `F`-in-`S`
  constraints but it cannot add the constraint in its current state and
* a [`ScalarFunctionConstantNotZero`](@ref) error may be thrown if
  `func` is an `AbstractScalarFunction` with nonzero constant and `set`
  is [`EqualTo`](@ref), [`GreaterThan`](@ref), [`LessThan`](@ref) or
  [`Interval`](@ref).
* a [`LowerBoundAlreadySet`](@ref) error is thrown if `F` is a
  [`VariableIndex`](@ref) and a constraint was already added to this variable
  that sets a lower bound.
* a [`UpperBoundAlreadySet`](@ref) error is thrown if `F` is a
  [`VariableIndex`](@ref) and a constraint was already added to this variable
  that sets an upper bound.
"""
function add_constraint(
    model::ModelLike,
    func::AbstractFunction,
    set::AbstractSet,
)
    return throw_add_constraint_error_fallback(model, func, set)
end

# throw_add_constraint_error_fallback checks whether func and set are both
# scalar or both vector. If it is the case, it calls
# `correct_throw_add_constraint_error_fallback`
function throw_add_constraint_error_fallback(
    model::ModelLike,
    func::AbstractScalarFunction,
    set::AbstractScalarSet;
    kwargs...,
)
    return correct_throw_add_constraint_error_fallback(
        model,
        func,
        set;
        kwargs...,
    )
end

function throw_add_constraint_error_fallback(
    model::ModelLike,
    func::AbstractVectorFunction,
    set::AbstractVectorSet;
    kwargs...,
)
    return correct_throw_add_constraint_error_fallback(
        model,
        func,
        set;
        kwargs...,
    )
end

function throw_add_constraint_error_fallback(
    model::ModelLike,
    func::AbstractScalarFunction,
    set::AbstractVectorSet;
    kwargs...,
)
    return error(
        "Cannot add a constraint of the form `ScalarFunction`-in-`VectorSet`",
    )
end

function throw_add_constraint_error_fallback(
    model::ModelLike,
    func::AbstractVectorFunction,
    set::AbstractScalarSet;
    kwargs...,
)
    return error(
        "Cannot add a constraint of the form `VectorFunction`-in-`ScalarSet`",
    )
end

# func and set are both scalar or both vector
function correct_throw_add_constraint_error_fallback(
    model::ModelLike,
    func::AbstractFunction,
    set::AbstractSet;
    error_if_supported = AddConstraintNotAllowed{typeof(func),typeof(set)}(),
)
    if supports_constraint(model, typeof(func), typeof(set))
        throw(error_if_supported)
    else
        throw(UnsupportedConstraint{typeof(func),typeof(set)}())
    end
end

# TODO(odow): remove this?
function add_constraint(
    model::ModelLike,
    v::Vector{VariableIndex},
    set::AbstractVectorSet,
)
    return add_constraint(model, VectorOfVariables(v), set)
end

"""
    add_constraints(model::ModelLike, funcs::Vector{F}, sets::Vector{S})::Vector{ConstraintIndex{F,S}} where {F,S}

Add the set of constraints specified by each function-set pair in `funcs` and `sets`. `F` and `S` should be concrete types.
This call is equivalent to `add_constraint.(model, funcs, sets)` but may be more efficient.
"""
function add_constraints end

# default fallback
function add_constraints(model::ModelLike, funcs, sets)
    return add_constraint.(model, funcs, sets)
end

"""
    LowerBoundAlreadySet{S1, S2}

Error thrown when setting a `VariableIndex`-in-`S2` when a
`VariableIndex`-in-`S1` has already been added and the sets `S1`, `S2` both
set a lower bound, that is, they are [`EqualTo`](@ref), [`GreaterThan`](@ref),
[`Interval`](@ref), [`Semicontinuous`](@ref) or [`Semiinteger`](@ref).
"""
struct LowerBoundAlreadySet{S1,S2} <: Exception
    vi::VariableIndex
end

function Base.showerror(io::IO, err::LowerBoundAlreadySet{S1,S2}) where {S1,S2}
    return print(
        io,
        typeof(err),
        ": Cannot add `VariableIndex`-in-`$(S2)` constraint for variable ",
        "$(err.vi) as a `VariableIndex`-in-`$(S1)` constraint was already ",
        "set for this variable and both constraints set a lower bound.",
    )
end

"""
    UpperBoundAlreadySet{S1, S2}

Error thrown when setting a `VariableIndex`-in-`S2` when a
`VariableIndex`-in-`S1` has already been added and the sets `S1`, `S2` both
set an upper bound, that is, they are [`EqualTo`](@ref), [`LessThan`](@ref),
[`Interval`](@ref), [`Semicontinuous`](@ref) or [`Semiinteger`](@ref).
"""
struct UpperBoundAlreadySet{S1,S2} <: Exception
    vi::VariableIndex
end

function Base.showerror(io::IO, err::UpperBoundAlreadySet{S1,S2}) where {S1,S2}
    return print(
        io,
        typeof(err),
        ": Cannot add `VariableIndex`-in-`$(S2)` constraint for variable ",
        "$(err.vi) as a `VariableIndex`-in-`$(S1)` constraint was already ",
        "set for this variable and both constraints set an upper bound.",
    )
end

"""
    transform(
        model::ModelLike,
        c::ConstraintIndex{F,S1},
        newset::S2,
    )::ConstraintIndex{F,S2}

Replace the set in constraint `c` with `newset`.

The constraint index `c` will no longer be valid, and the function returns a new
constraint index with the correct type.

Solvers may only support a subset of constraint transforms that they perform
efficiently (for example, changing from a `LessThan` to `GreaterThan` set). In
addition, set modification (where `S1 = S2`) should be performed via the
`modify` function.

Typically, the user should delete the constraint and add a new one.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> c = MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0));

julia> print(model)
Feasibility

Subject to:

ScalarAffineFunction{Float64}-in-LessThan{Float64}
 0.0 + 1.0 v[1] <= 2.0

julia> c2 = MOI.transform(model, c, MOI.GreaterThan(0.0))
MathOptInterface.ConstraintIndex{MathOptInterface.ScalarAffineFunction{Float64}, MathOptInterface.GreaterThan{Float64}}(1)

julia> print(model)
Feasibility

Subject to:

ScalarAffineFunction{Float64}-in-GreaterThan{Float64}
 0.0 + 1.0 v[1] >= 0.0

julia> MOI.is_valid(model, c)
false
```
"""
function transform end

# default fallback
function transform(model::ModelLike, c::ConstraintIndex, newset)
    f = get(model, ConstraintFunction(), c)
    delete(model, c)
    return add_constraint(model, f, newset)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    NodeType

An enum describing the possible node types. Each [`Node`](@ref) has a `.index`
field, which should be interpreted as follows:

 * `NODE_CALL_MULTIVARIATE`: the index into `operators.multivariate_operators`
 * `NODE_CALL_UNIVARIATE`: the index into `operators.univariate_operators`
 * `NODE_LOGIC`: the index into `operators.logic_operators`
 * `NODE_COMPARISON`: the index into `operators.comparison_operators`
 * `NODE_MOI_VARIABLE`: the value of `MOI.VariableIndex(index)` in the user's
   space of the model.
 * `NODE_VARIABLE`: the 1-based index of the internal vector
 * `NODE_VALUE`: the index into the `.values` field of `Expression`
 * `NODE_PARAMETER`: the index into `data.parameters`
 * `NODE_SUBEXPRESSION`:  the index into `data.expressions`
"""
@enum(
    NodeType,
    # Index into multivariate operators
    NODE_CALL_MULTIVARIATE,
    # Index into univariate operators
    NODE_CALL_UNIVARIATE,
    # Index into logic operators
    NODE_LOGIC,
    # Index into comparison operators
    NODE_COMPARISON,
    # Index is the value of `MOI.VariableIndex`. This is from the original
    # model, and is not consecutive.
    NODE_MOI_VARIABLE,
    # Index of the internal, consecutive, and ordered `MOI.VariableIndex`.
    NODE_VARIABLE,
    # Index is into the list of constants
    NODE_VALUE,
    # Index is into the list of parameters
    NODE_PARAMETER,
    # Index is into the list of subexpressions
    NODE_SUBEXPRESSION,
)

"""
    struct Node
        type::NodeType
        index::Int
        parent::Int
    end

A single node in a nonlinear expression tree. Used by
[`Expression`](@ref).

See the MathOptInterface documentation for information on how the nodes and
values form an expression tree.
"""
struct Node
    type::NodeType
    index::Int
    parent::Int
end

"""
    struct Expression
        nodes::Vector{Node}
        values::Vector{Float64}
    end

The core type that represents a nonlinear expression. See the MathOptInterface
documentation for information on how the nodes and values form an expression
tree.
"""
struct Expression
    nodes::Vector{Node}
    values::Vector{Float64}
    Expression() = new(Node[], Float64[])
end

function Base.:(==)(x::Expression, y::Expression)
    return x.nodes == y.nodes && x.values == y.values
end

"""
    struct Constraint
        expression::Expression
        set::Union{
            MOI.LessThan{Float64},
            MOI.GreaterThan{Float64},
            MOI.EqualTo{Float64},
            MOI.Interval{Float64},
        }
    end

A type to hold information relating to the nonlinear constraint `f(x) in S`,
where `f(x)` is defined by `.expression`, and `S` is `.set`.
"""
struct Constraint
    expression::Expression
    set::Union{
        MOI.LessThan{Float64},
        MOI.GreaterThan{Float64},
        MOI.EqualTo{Float64},
        MOI.Interval{Float64},
    }
end

"""
    ParameterIndex

An index to a nonlinear parameter that is returned by [`add_parameter`](@ref).
Given `data::Model` and `p::ParameterIndex`, use `data[p]` to retrieve
the current value of the parameter and `data[p] = value` to set a new value.
"""
struct ParameterIndex
    value::Int
end

"""
    ExpressionIndex

An index to a nonlinear expression that is returned by [`add_expression`](@ref).

Given `data::Model` and `ex::ExpressionIndex`, use `data[ex]` to
retrieve the corresponding [`Expression`](@ref).
"""
struct ExpressionIndex
    value::Int
end

"""
    ConstraintIndex

An index to a nonlinear constraint that is returned by [`add_constraint`](@ref).

Given `data::Model` and `c::ConstraintIndex`, use `data[c]` to
retrieve the corresponding [`Constraint`](@ref).
"""
struct ConstraintIndex
    value::Int
end

"""
    Model()

The core datastructure for representing a nonlinear optimization problem.

It has the following fields:
 * `objective::Union{Nothing,Expression}` : holds the nonlinear objective
   function, if one exists, otherwise `nothing`.
 * `expressions::Vector{Expression}` : a vector of expressions in the model.
 * `constraints::OrderedDict{ConstraintIndex,Constraint}` : a map from
   [`ConstraintIndex`](@ref) to the corresponding [`Constraint`](@ref). An
   `OrderedDict` is used instead of a `Vector` to support constraint deletion.
 * `parameters::Vector{Float64}` : holds the current values of the parameters.
 * `operators::OperatorRegistry` : stores the operators used in the model.
"""
mutable struct Model
    objective::Union{Nothing,Expression}
    expressions::Vector{Expression}
    constraints::OrderedDict{ConstraintIndex,Constraint}
    parameters::Vector{Float64}
    operators::OperatorRegistry
    # This is a private field, used only to increment the ConstraintIndex.
    last_constraint_index::Int64
    function Model()
        return new(
            nothing,
            Expression[],
            OrderedDict{ConstraintIndex,Constraint}(),
            Float64[],
            OperatorRegistry(),
            0,
        )
    end
end

"""
    AbstractAutomaticDifferentiation

An abstract type for extending [`Evaluator`](@ref).
"""
abstract type AbstractAutomaticDifferentiation end

function MOI.Utilities.map_indices(
    ::F,
    backend::AbstractAutomaticDifferentiation,
) where {F<:Function}
    return backend
end

"""
    Evaluator(
        model::Model,
        backend::AbstractAutomaticDifferentiation,
        ordered_variables::Vector{MOI.VariableIndex},
    )

Create `Evaluator`, a subtype of `MOI.AbstractNLPEvaluator`, from `Model`.
"""
mutable struct Evaluator{B} <: MOI.AbstractNLPEvaluator
    # The internal datastructure.
    model::Model
    # The abstract-differentiation backend
    backend::B
    # ordered_constraints is needed because `OrderedDict` doesn't support
    # looking up a key by the linear index.
    ordered_constraints::Vector{ConstraintIndex}
    # Storage for the NLPBlockDual, so that we can query the dual of individual
    # constraints without needing to query the full vector each time.
    constraint_dual::Vector{Float64}
    # Timers
    initialize_timer::Float64
    eval_objective_timer::Float64
    eval_constraint_timer::Float64
    eval_objective_gradient_timer::Float64
    eval_constraint_gradient_timer::Float64
    eval_constraint_jacobian_timer::Float64
    eval_hessian_objective_timer::Float64
    eval_hessian_constraint_timer::Float64
    eval_hessian_lagrangian_timer::Float64

    function Evaluator(
        model::Model,
        backend::B = nothing,
    ) where {B<:Union{Nothing,MOI.AbstractNLPEvaluator}}
        return new{B}(
            model,
            backend,
            ConstraintIndex[],
            Float64[],
            0.0,
            0.0,
            0.0,
            0.0,
            0.0,
            0.0,
            0.0,
            0.0,
            0.0,
        )
    end
end

_bound(s::MOI.LessThan) = MOI.NLPBoundsPair(-Inf, s.upper)
_bound(s::MOI.GreaterThan) = MOI.NLPBoundsPair(s.lower, Inf)
_bound(s::MOI.EqualTo) = MOI.NLPBoundsPair(s.value, s.value)
_bound(s::MOI.Interval) = MOI.NLPBoundsPair(s.lower, s.upper)

"""
    MOI.NLPBlockData(evaluator::Evaluator)

Create an [`MOI.NLPBlockData`](@ref) object from an [`Evaluator`](@ref)
object.
"""
function MOI.NLPBlockData(evaluator::Evaluator)
    return MOI.NLPBlockData(
        [_bound(c.set) for (_, c) in evaluator.model.constraints],
        evaluator,
        evaluator.model.objective !== nothing,
    )
end

"""
    ExprGraphOnly() <: AbstractAutomaticDifferentiation

The default implementation of `AbstractAutomaticDifferentiation`. The only
supported feature is `:ExprGraph`.
"""
struct ExprGraphOnly <: AbstractAutomaticDifferentiation end

function Evaluator(model::Model, ::ExprGraphOnly, ::Vector{MOI.VariableIndex})
    return Evaluator(model)
end

"""
    SparseReverseMode() <: AbstractAutomaticDifferentiation

An implementation of `AbstractAutomaticDifferentiation` that uses sparse
reverse-mode automatic differentiation to compute derivatives. Supports all
features in the MOI nonlinear interface.
"""
struct SparseReverseMode <: AbstractAutomaticDifferentiation end

function Evaluator(
    model::Model,
    ::SparseReverseMode,
    ordered_variables::Vector{MOI.VariableIndex},
)
    return Evaluator(model, ReverseAD.NLPEvaluator(model, ordered_variables))
end

"""
    SymbolicMode() <: AbstractAutomaticDifferentiation

A type for setting as the value of the `MOI.AutomaticDifferentiationBackend()`
attribute to enable symbolic automatic differentiation.
"""
struct SymbolicMode <: AbstractAutomaticDifferentiation end

function Evaluator(
    model::Model,
    ::SymbolicMode,
    ordered_variables::Vector{MOI.VariableIndex},
)
    return Evaluator(model, SymbolicAD.Evaluator(model, ordered_variables))
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestErrors

using Test
import MathOptInterface as MOI

include("dummy.jl")

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
end

function test_errors_fallback_AddVariableNotAllowed()
    model = DummyModel()
    @test_throws MOI.AddVariableNotAllowed MOI.add_variable(model)
    try
        MOI.add_variable(model)
    catch err
        contents = sprint(showerror, err)
        @test occursin("$(MOI.AddVariableNotAllowed)", contents)
        @test occursin("Adding variables cannot be performed", contents)
        @test occursin("## Fixing this error", contents)
    end
    @test_throws MOI.AddVariableNotAllowed MOI.add_variables(model, 2)
    return
end

function test_errors_inconsistent_vectorscalar()
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    @test_throws(
        MOI.ErrorException,
        MOI.add_constraint(
            model,
            MOI.VectorOfVariables([vi, vi]),
            MOI.EqualTo(0),
        )
    )
    @test_throws(
        MOI.ErrorException,
        MOI.add_constraint(model, vi, MOI.Nonnegatives(2))
    )
    return
end

function test_errors_UnsupportedConstraint()
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constraint(model, vi, MOI.EqualTo(0)),
    )
    msg = """
    UnsupportedConstraint: `$(MOI.VariableIndex)`-in-`$(MOI.EqualTo{Int})` constraints are not supported by the
    solver you have chosen, and we could not reformulate your model into a
    form that is supported.

    To fix this error you must choose a different solver.


    """
    try
        MOI.add_constraint(model, vi, MOI.EqualTo(0))
    catch err
        @test sprint(showerror, err) == msg
    end
    return
end

function test_errors_UnsupportedConstraint_shortcut()
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    @test_throws MOI.UnsupportedConstraint begin
        MOI.add_constraint(model, vi, MOI.EqualTo(0))
    end
    @test_throws MOI.UnsupportedConstraint begin
        MOI.add_constraint(model, [vi, vi], MOI.Nonnegatives(2))
    end
    @test_throws MOI.UnsupportedConstraint begin
        MOI.add_constraints(model, [vi, vi], [MOI.EqualTo(0), MOI.EqualTo(0)])
    end
end

function test_errors_add_constraint()
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    @test_throws(
        MOI.AddConstraintNotAllowed,
        MOI.add_constraint(model, vi, MOI.EqualTo(0.0)),
    )
    try
        MOI.add_constraint(model, vi, MOI.EqualTo(0.0))
    catch err
        contents = sprint(showerror, err)
        F, S = MOI.VariableIndex, MOI.EqualTo{Float64}
        @test occursin("$(MOI.AddConstraintNotAllowed{F,S})", contents)
        @test occursin(
            "Adding `$F`-in-`$S` constraints cannot be performed",
            contents,
        )
        @test occursin("## Fixing this error", contents)
    end
    @test_throws(
        MOI.AddConstraintNotAllowed,
        MOI.add_constraint(model, vi, MOI.EqualTo(0.0)),
    )
    @test_throws(
        MOI.AddConstraintNotAllowed,
        MOI.add_constraint(model, [vi, vi], MOI.Zeros(2)),
    )
    @test_throws(
        MOI.AddConstraintNotAllowed,
        MOI.add_constraints(
            model,
            [vi, vi],
            [MOI.EqualTo(0.0), MOI.EqualTo(0.0)],
        ),
    )
    return
end

function test_errors_DeleteNotAllowed()
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}(1)
    @test_throws MOI.DeleteNotAllowed{typeof(vi)} MOI.delete(model, vi)
    try
        MOI.delete(model, vi)
    catch err
        contents = sprint(showerror, err)
        @test occursin("$(MOI.DeleteNotAllowed{typeof(vi)})", contents)
        @test occursin("Deleting the index $vi cannot be performed", contents)
        @test occursin("## Fixing this error", contents)
    end
    @test_throws MOI.DeleteNotAllowed{typeof(ci)} MOI.delete(model, ci)
    try
        MOI.delete(model, ci)
    catch err
        contents = sprint(showerror, err)
        @test occursin("$(MOI.DeleteNotAllowed{typeof(ci)})", contents)
        @test occursin("Deleting the index $ci cannot be performed", contents)
        @test occursin("## Fixing this error", contents)
    end
    return
end

function _test_unsupported_attribute(f)
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}(1)
    @test_throws(
        MOI.UnsupportedAttribute,
        f(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), vi),
    )
    @test_throws(
        MOI.UnsupportedAttribute,
        f(model, MOI.ConstraintDualStart(), ci, 0.0),
    )
    return
end

function test_errors_unsupported_attribute()
    _test_unsupported_attribute(MOI.set)
    return
end

function test_errors_SetAttributeNotAllowed()
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}(1)
    model = DummyModel()
    @test_throws(
        MOI.SetAttributeNotAllowed,
        MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE),
    )
    @test_throws(
        MOI.SetAttributeNotAllowed,
        MOI.set(model, MOI.ConstraintPrimalStart(), ci, 0.0),
    )
    return
end

function test_errors_ConstraintFunction_NotAllowed()
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}(1)
    @test_throws(
        MOI.SetAttributeNotAllowed,
        MOI.set(model, MOI.ConstraintFunction(), ci, vi)
    )
    @test_throws(
        MOI.FunctionTypeMismatch{
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{Float64},
        },
        MOI.set(
            model,
            MOI.ConstraintFunction(),
            ci,
            MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, vi)], 0.0),
        ),
    )
    return
end

function test_errors_ConstraintSet_NotAllowed()
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}(1)
    @test_throws(
        MOI.SetAttributeNotAllowed,
        MOI.set(model, MOI.ConstraintSet(), ci, MOI.EqualTo(1.0))
    )
    @test_throws(
        MOI.SetTypeMismatch{MOI.EqualTo{Float64},MOI.EqualTo{Int}},
        MOI.set(model, MOI.ConstraintSet(), ci, MOI.EqualTo(1))
    )
    @test_throws(
        MOI.SetTypeMismatch{MOI.EqualTo{Float64},MOI.GreaterThan{Float64}},
        MOI.set(model, MOI.ConstraintSet(), ci, MOI.GreaterThan(1.0))
    )
end

function test_errors_ModifyNotAllowed_constraint()
    model = DummyModel()
    vi = MOI.VariableIndex(1)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}(1)
    change = MOI.ScalarConstantChange(1.0)
    err = MOI.ModifyConstraintNotAllowed(ci, change)
    @test_throws err MOI.modify(model, ci, change)
    contents = sprint(showerror, err)
    @test occursin("$(typeof(err)):", contents)
    @test occursin(
        "Modifying the constraints $ci with $change cannot be performed",
        contents,
    )
    @test occursin("## Fixing this error", contents)
    return
end

function test_errors_ModifyNotAllowed_objective()
    model = DummyModel()
    change = MOI.ScalarConstantChange(1.0)
    attr = MOI.ObjectiveFunction{MOI.VariableIndex}()
    err = MOI.ModifyObjectiveNotAllowed(change)
    @test_throws err MOI.modify(model, attr, change)
    contents = sprint(showerror, err)
    @test occursin("$(typeof(err)):", contents)
    @test occursin(
        "Modifying the objective function with $change cannot be performed",
        contents,
    )
    @test occursin("## Fixing this error", contents)
    return
end

function test_errors_show_SetAttributeNotAllowed()
    @test sprint(showerror, MOI.UnsupportedAttribute(MOI.Name())) ==
          "$MOI.UnsupportedAttribute{$MOI.Name}:" *
          " Attribute $MOI.Name() is not supported by the model."
    @test sprint(showerror, MOI.UnsupportedAttribute(MOI.Name(), "Message")) ==
          "$MOI.UnsupportedAttribute{$MOI.Name}:" *
          " Attribute $MOI.Name() is not supported by the model: Message"
    contents = sprint(showerror, MOI.SetAttributeNotAllowed(MOI.Name()))
    @test occursin("$MOI.SetAttributeNotAllowed{$MOI.Name}:", contents)
    @test occursin(
        "Setting attribute $(MOI.Name()) cannot be performed",
        contents,
    )
    @test occursin("## Fixing this error", contents)
    err = MOI.SetAttributeNotAllowed(MOI.Name(), "Message")
    contents = sprint(showerror, err)
    @test occursin("$(typeof(err))", contents)
    @test occursin("Message", contents)
    @test occursin(
        "Setting attribute $(MOI.Name()) cannot be performed",
        contents,
    )
    @test occursin("## Fixing this error", contents)
    return
end

function test_errors_ResultIndexBoundsError()
    @test sprint(
        showerror,
        MOI.ResultIndexBoundsError(MOI.VariablePrimal(1), 0),
    ) ==
          "Result index of attribute MathOptInterface.VariablePrimal(1) out of" *
          " bounds. There are currently 0 solution(s) in the model."
end

function test_errors_ConflictIndexBoundsError()
    @test sprint(
        showerror,
        MOI.ConflictIndexBoundsError(MOI.ConstraintConflictStatus(1), 0),
    ) ==
          "Conflict index of attribute " *
          "MathOptInterface.ConstraintConflictStatus(1) out of bounds. " *
          "There are currently 0 conflict(s) in the model."
end

function test_errors_InvalidCalbackUsage()
    @test sprint(
        showerror,
        MOI.InvalidCallbackUsage(MOI.LazyConstraintCallback(), MOI.UserCut(1)),
    ) ==
          "InvalidCallbackUsage: Cannot submit $(MOI.UserCut(1)) inside a MathOptInterface.LazyConstraintCallback()."
end

struct TestCopyToFallback <: MOI.AbstractOptimizer end

function test_errors_copy_to_fallback()
    dest = TestCopyToFallback()
    @test_throws(
        ErrorException(
            "`copy_to` is not supported by the solver `$(typeof(dest))`. Did " *
            "you mean to call " *
            "`optimize!(dest::AbstractOptimizer, src::ModelLike)` instead?",
        ),
        MOI.copy_to(dest, MOI.Utilities.Model{Float64}()),
    )
    return
end

struct Optimizer1697 <: MOI.AbstractOptimizer end

function test_compute_conflict_fallback()
    model = Optimizer1697()
    @test_throws(
        ArgumentError(
            "The optimizer $(typeof(model)) does not support " *
            "`compute_conflict!`",
        ),
        MOI.compute_conflict!(model),
    )
    return
end

function test_get_fallback_error()
    model = MOI.Utilities.Model{Float64}()
    @test_throws(
        MOI.GetAttributeNotAllowed,
        MOI.get(model, MOI.SolveTimeSec()),
    )
    err = MOI.GetAttributeNotAllowed(MOI.SolveTimeSec(), "")
    contents = sprint(showerror, err)
    @test occursin("$(typeof(err)):", contents)
    @test occursin(
        "Getting attribute $(MOI.SolveTimeSec()) cannot be performed",
        contents,
    )
    @test occursin("## Fixing this error", contents)
    return
end

function test_unsupported_nonlinear_operator()
    @test MOI.element_name(MOI.UnsupportedNonlinearOperator(:f)) ==
          "The nonlinear operator `:f`"
    return
end

function test_ScalarFunctionConstantNotZero_equality()
    for T in (Int, Float64, BigFloat)
        F, S = MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}
        w = MOI.ScalarFunctionConstantNotZero{T,F,MOI.LessThan{T}}(zero(T))
        x = MOI.ScalarFunctionConstantNotZero{T,F,S}(zero(T))
        y = MOI.ScalarFunctionConstantNotZero{T,F,S}(zero(T))
        z = MOI.ScalarFunctionConstantNotZero{T,F,S}(one(T))
        @test x == y
        @test x != z
        @test w != x
    end
    return
end

function test_showerror_InvalidIndex()
    x = MOI.VariableIndex(1)
    @test sprint(showerror, MOI.InvalidIndex(x)) ==
          "The index $x is invalid. Note that an index becomes invalid after it has been deleted."
    return
end

struct ModelWithNoIsValid <: MOI.ModelLike end

function test_isvalid_fallback()
    model = ModelWithNoIsValid()
    x = MOI.VariableIndex(1)
    @test !MOI.is_valid(model, x)
    return
end

function test_logs_precompile()
    model = MOI.Utilities.Model{Float64}()
    F, S = MOI.VariableIndex, MOI.ZeroOne
    @test_logs (:warn,) MOI.precompile_constraint(model, F, S)
    @test_logs (:warn,) MOI.precompile_variables(model)
    @test_logs (:warn,) MOI.precompile_model(model, [(F, S)])
    return
end

end  # module

TestErrors.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestSetDot

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_set_dot(T = Int)
    @test MOI.Utilities._set_dot(1, MOI.ZeroOne(), T) == 1
    psd = MOI.PositiveSemidefiniteConeTriangle(2)
    n = 3
    soc = MOI.SecondOrderCone(n)
    a = MOI.Utilities.ZeroVector{T}(n)
    @test eltype(a) == T
    @test length(a) == n
    @test size(a) == (n,)
    for i in 1:n
        b = MOI.Utilities.CanonicalVector{T}(i, n)
        @test eltype(b) == T
        @test length(b) == n
        @test size(b) == (n,)
        c = MOI.Utilities.CanonicalVector{T}(mod1(i + 1, 3), n)
        @test a[i] == 0
        @test b[i] == 1
        @test c[i] == 0
        for set in [psd, soc]
            @test iszero(MOI.Utilities.set_dot(a, b, set))
            @test iszero(MOI.Utilities.set_dot(b, a, set))
            @test iszero(MOI.Utilities.set_dot(b, c, set))
            @test iszero(MOI.Utilities.set_dot(c, b, set))
        end
        @test MOI.Utilities.set_dot(b, b, soc) == 1
        @test MOI.Utilities._set_dot(i, soc, T) == 1
        expected = i == 2 ? 2 : 1
        @test MOI.Utilities.set_dot(b, b, psd) == expected
        @test MOI.Utilities._set_dot(i, psd, T) == expected
    end
end

end

TestSetDot.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    _reverse_mode(d::NLPEvaluator, x)

Run reverse-mode automatic differentiation on `d` given the primal solution `x`.

This function updates many of the data-structures inside `d` in-place.

At a high level, reverse-mode AD has two phases:

In Phase I, we evaluate the problem in `d` at the primal solution `x`, and
stores the primal solution of each expression in the tree and the first-order
partial derivative information for each node with respect to its arguments.

Because the nodes in our data structure are topologically sorted, we can make a
single pass through the tree by iterating backwards through the vector of stored
nodes.

In Phase II, we propagate the partial derivative information back down the tree
to find the derivative of each function with respect to the input.

Because the nodes in our data structure are topologically sorted, we can make a
single pass through the tree by iterating forwards through the vector of stored
nodes.
"""
function _reverse_mode(d::NLPEvaluator, x)
    if d.last_x == x
        # Fail fast if the primal solution has not changed since last call.
        return
    end
    # Phase I
    for k in d.subexpression_order
        d.subexpression_forward_values[k] =
            _forward_eval(d.subexpressions[k], d, x)
    end
    if d.objective !== nothing
        _forward_eval(d.objective::_FunctionStorage, d, x)
    end
    for con in d.constraints
        _forward_eval(con, d, x)
    end
    # Phase II
    for k in d.subexpression_order
        _reverse_eval(d.subexpressions[k])
    end
    if d.objective !== nothing
        _reverse_eval(d.objective::_FunctionStorage)
    end
    for con in d.constraints
        _reverse_eval(con)
    end
    # If a JuMP model uses the legacy nonlinear interface, then JuMP constructs
    # a NLPEvaluator at the start of a call to `JuMP.optimize!` and it passes in
    # the list of variables in the JuMP model to `.ordered_variables`.
    #
    # During `MOI.initialize`, `.last_x` gets filled with `NaN` to match the
    # length of `ordered_variables`, that is, the number of variables in the
    # JuMP model.
    #
    # However, if the model includes a bridge that adds new decision variables
    # then the total number of variables in the optimizer (in `x`) will be
    # larger than the cache in `last_x`.
    #
    # It is safe to resize `last_x` because only the variables in
    # `ordered_variables` can appear in the NLPBlock.
    #
    # I don't think we need any other fixes because callers to things like
    # `eval_objective` can pass in a longer input `x` vector without fear
    # because the excess elements won't be used.
    if length(d.last_x) < length(x)
        resize!(d.last_x, length(x))
    end
    copyto!(d.last_x, x)
    return
end

"""
    _forward_eval(
        f::Union{_FunctionStorage,_SubexpressionStorage},
        d::NLPEvaluator,
        x::AbstractVector{T},
    ) where {T}

Forward-mode evaluation of an expression tree given in `f`.

 * This function assumes that the values of all sub-expressions have already
   been computed and are stored in `d.subexpression_forward_values`.
 * `f.partials_storage[k]` is the partial derivative of `nodes[k].parent` with
   respect to the value of node `k`. It's efficient to compute this at the same
   time as the value of the parent because we use it in reverse mode and in dual
   forward mode. Note that `partials_storage`` makes a subtle assumption that we
   have a tree instead of a general DAG. If we have a DAG, then need to
   associate storage with each edge of the DAG.
"""
function _forward_eval(
    # !!! warning
    #     This Union depends upon _FunctionStorage and _SubexpressionStorage
    #     having similarly named fields.
    f::Union{_FunctionStorage,_SubexpressionStorage},
    d::NLPEvaluator,
    x::AbstractVector{T},
)::T where {T}
    @assert length(f.forward_storage) >= length(f.nodes)
    @assert length(f.partials_storage) >= length(f.nodes)
    operators = d.data.operators
    # f.nodes is already in order such that parents always appear before
    # children, so a backwards pass through f.nodes is a forward pass through
    # the tree.
    children_arr = SparseArrays.rowvals(f.adj)
    for k in length(f.nodes):-1:1
        node = f.nodes[k]
        f.partials_storage[k] = zero(T)
        if node.type == Nonlinear.NODE_VARIABLE
            f.forward_storage[k] = x[node.index]
            # This should never happen, because we will have replaced these by now.
            # elseif node.type == Nonlinear.NODE_MOI_VARIABLE
            #     f.forward_storage[k] = x[node.index]
        elseif node.type == Nonlinear.NODE_VALUE
            f.forward_storage[k] = f.const_values[node.index]
        elseif node.type == Nonlinear.NODE_SUBEXPRESSION
            f.forward_storage[k] = d.subexpression_forward_values[node.index]
        elseif node.type == Nonlinear.NODE_PARAMETER
            f.forward_storage[k] = d.data.parameters[node.index]
        elseif node.type == Nonlinear.NODE_CALL_MULTIVARIATE
            children_indices = SparseArrays.nzrange(f.adj, k)
            N = length(children_indices)
            # TODO(odow);
            # With appropriate benchmarking, the special-cased if-statements can
            # be removed in favor of the generic user-defined function case.
            if node.index == 1 # :+
                tmp_sum = zero(T)
                for c_idx in children_indices
                    @inbounds ix = children_arr[c_idx]
                    @inbounds f.partials_storage[ix] = one(T)
                    @inbounds tmp_sum += f.forward_storage[ix]
                end
                f.forward_storage[k] = tmp_sum
            elseif node.index == 2 # :-
                @assert N == 2
                child1 = first(children_indices)
                @inbounds ix1 = children_arr[child1]
                @inbounds ix2 = children_arr[child1+1]
                @inbounds tmp_sub = f.forward_storage[ix1]
                @inbounds tmp_sub -= f.forward_storage[ix2]
                @inbounds f.partials_storage[ix1] = one(T)
                @inbounds f.partials_storage[ix2] = -one(T)
                f.forward_storage[k] = tmp_sub
            elseif node.index == 3 # :*
                tmp_prod = one(T)
                for c_idx in children_indices
                    @inbounds tmp_prod *= f.forward_storage[children_arr[c_idx]]
                end
                if tmp_prod == zero(T) || N <= 2
                    # This is inefficient if there are a lot of children.
                    # 2 is chosen as a limit because (x*y)/y does not always
                    # equal x for floating-point numbers. This can produce
                    # unexpected error in partials. There's still an error when
                    # multiplying three or more terms, but users are less likely
                    # to complain about it.
                    for c_idx in children_indices
                        prod_others = one(T)
                        for c_idx2 in children_indices
                            (c_idx == c_idx2) && continue
                            ix = children_arr[c_idx2]
                            prod_others *= f.forward_storage[ix]
                        end
                        f.partials_storage[children_arr[c_idx]] = prod_others
                    end
                else
                    # Compute all-minus-one partial derivatives by dividing from
                    # the total product.
                    for c_idx in children_indices
                        ix = children_arr[c_idx]
                        f.partials_storage[ix] =
                            tmp_prod / f.forward_storage[ix]
                    end
                end
                @inbounds f.forward_storage[k] = tmp_prod
            elseif node.index == 4 # :^
                @assert N == 2
                idx1 = first(children_indices)
                idx2 = last(children_indices)
                @inbounds ix1 = children_arr[idx1]
                @inbounds ix2 = children_arr[idx2]
                @inbounds base = f.forward_storage[ix1]
                @inbounds exponent = f.forward_storage[ix2]
                if exponent == 2
                    @inbounds f.forward_storage[k] = base * base
                    @inbounds f.partials_storage[ix1] = 2 * base
                elseif exponent == 1
                    @inbounds f.forward_storage[k] = base
                    @inbounds f.partials_storage[ix1] = 1.0
                else
                    f.forward_storage[k] = pow(base, exponent)
                    f.partials_storage[ix1] = exponent * pow(base, exponent - 1)
                end
                f.partials_storage[ix2] = f.forward_storage[k] * log(base)
            elseif node.index == 5 # :/
                @assert N == 2
                idx1 = first(children_indices)
                idx2 = last(children_indices)
                @inbounds ix1 = children_arr[idx1]
                @inbounds ix2 = children_arr[idx2]
                @inbounds numerator = f.forward_storage[ix1]
                @inbounds denominator = f.forward_storage[ix2]
                recip_denominator = 1 / denominator
                @inbounds f.partials_storage[ix1] = recip_denominator
                f.partials_storage[ix2] =
                    -numerator * recip_denominator * recip_denominator
                f.forward_storage[k] = numerator * recip_denominator
            elseif node.index == 6 # ifelse
                @assert N == 3
                idx1 = first(children_indices)
                @inbounds condition = f.forward_storage[children_arr[idx1]]
                @inbounds lhs = f.forward_storage[children_arr[idx1+1]]
                @inbounds rhs = f.forward_storage[children_arr[idx1+2]]
                @inbounds f.partials_storage[children_arr[idx1+1]] =
                    condition == 1
                @inbounds f.partials_storage[children_arr[idx1+2]] =
                    !(condition == 1)
                f.forward_storage[k] = ifelse(condition == 1, lhs, rhs)
            else
                f_input = _UnsafeVectorView(d.jac_storage, N)
                ∇f = _UnsafeVectorView(d.user_output_buffer, N)
                for (r, i) in enumerate(children_indices)
                    f_input[r] = f.forward_storage[children_arr[i]]
                    ∇f[r] = 0.0
                end
                f.forward_storage[k] = Nonlinear.eval_multivariate_function(
                    operators,
                    operators.multivariate_operators[node.index],
                    f_input,
                )
                Nonlinear.eval_multivariate_gradient(
                    operators,
                    operators.multivariate_operators[node.index],
                    ∇f,
                    f_input,
                )
                for (r, i) in enumerate(children_indices)
                    f.partials_storage[children_arr[i]] = ∇f[r]
                end
            end
        elseif node.type == Nonlinear.NODE_CALL_UNIVARIATE
            child_idx = children_arr[f.adj.colptr[k]]
            ret_f, ret_f′ = Nonlinear.eval_univariate_function_and_gradient(
                operators,
                node.index,
                f.forward_storage[child_idx],
            )
            f.forward_storage[k] = ret_f
            f.partials_storage[child_idx] = ret_f′
        elseif node.type == Nonlinear.NODE_COMPARISON
            children_idx = SparseArrays.nzrange(f.adj, k)
            result = true
            f.partials_storage[children_arr[children_idx[1]]] = zero(T)
            for r in 2:length(children_idx)
                lhs = children_arr[children_idx[r-1]]
                rhs = children_arr[children_idx[r]]
                result &= Nonlinear.eval_comparison_function(
                    operators,
                    operators.comparison_operators[node.index],
                    f.forward_storage[lhs],
                    f.forward_storage[rhs],
                )
                f.partials_storage[rhs] = zero(T)
            end
            f.forward_storage[k] = result
        else
            @assert node.type == Nonlinear.NODE_LOGIC
            children_idx = SparseArrays.nzrange(f.adj, k)
            lhs = children_arr[children_idx[1]]
            rhs = children_arr[children_idx[2]]
            f.forward_storage[k] = Nonlinear.eval_logic_function(
                operators,
                operators.logic_operators[node.index],
                f.forward_storage[lhs] == 1,
                f.forward_storage[rhs] == 1,
            )
            f.partials_storage[lhs] = zero(T)
            f.partials_storage[rhs] = zero(T)
        end
    end
    return f.forward_storage[1]
end

"""
    _reverse_eval(f::Union{_FunctionStorage,_SubexpressionStorage})

Reverse-mode evaluation of an expression tree given in `f`.

 * This function assumes `f.partials_storage` is already updated.
 * This function assumes that `f.reverse_storage` has been initialized with 0.0.
"""
function _reverse_eval(
    # !!! warning
    #     This Union depends upon _FunctionStorage and _SubexpressionStorage
    #     having similarly named fields.
    f::Union{_FunctionStorage,_SubexpressionStorage},
)
    @assert length(f.reverse_storage) >= length(f.nodes)
    @assert length(f.partials_storage) >= length(f.nodes)
    # f.nodes is already in order such that parents always appear before
    # children so a forward pass through nodes is a backwards pass through the
    # tree.
    f.reverse_storage[1] = one(Float64)
    for k in 2:length(f.nodes)
        node = f.nodes[k]
        if node.type == Nonlinear.NODE_VALUE ||
           node.type == Nonlinear.NODE_LOGIC ||
           node.type == Nonlinear.NODE_COMPARISON ||
           node.type == Nonlinear.NODE_PARAMETER
            continue
        end
        rev_parent = f.reverse_storage[node.parent]
        partial = f.partials_storage[k]
        f.reverse_storage[k] = ifelse(
            rev_parent == 0.0 && !isfinite(partial),
            rev_parent,
            rev_parent * partial,
        )
    end
    return
end

"""
    _extract_reverse_pass(
        g::AbstractVector{T},
        d::NLPEvaluator,
        f::_FunctionStorage,
    ) where {T}

Fill the gradient vector `g` with the values from the reverse pass. Assumes you
have already called `_reverse_eval_all(d, x)`.
"""
function _extract_reverse_pass(
    g::AbstractVector{T},
    d::NLPEvaluator,
    f::_FunctionStorage,
) where {T}
    for i in f.dependent_subexpressions
        d.subexpression_reverse_values[i] = 0.0
    end
    _extract_reverse_pass_inner(g, f, d.subexpression_reverse_values, 1.0)
    for i in length(f.dependent_subexpressions):-1:1
        k = f.dependent_subexpressions[i]
        _extract_reverse_pass_inner(
            g,
            d.subexpressions[k],
            d.subexpression_reverse_values,
            d.subexpression_reverse_values[k],
        )
    end
    return
end

function _extract_reverse_pass_inner(
    output::AbstractVector{T},
    # !!! warning
    #     This Union depends upon _FunctionStorage and _SubexpressionStorage
    #     having similarly named fields.
    f::Union{_FunctionStorage,_SubexpressionStorage},
    subexpressions::AbstractVector{T},
    scale::T,
) where {T}
    @assert length(f.reverse_storage) >= length(f.nodes)
    for (k, node) in enumerate(f.nodes)
        if node.type == Nonlinear.NODE_VARIABLE
            output[node.index] += scale * f.reverse_storage[k]
        elseif node.type == Nonlinear.NODE_SUBEXPRESSION
            subexpressions[node.index] += scale * f.reverse_storage[k]
        end
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestFinalTouchOrder

using Test

import MathOptInterface as MOI

function runtests()
    is_test(name) = startswith("$(name)", "test_")
    @testset "$name" for name in filter(is_test, names(@__MODULE__; all = true))
        getfield(@__MODULE__, name)()
    end
    return
end

# The order in which `final_touch` is called on the bridges, as `(tag, id)`
# where `tag` identifies the bridge and `id` the constrained variable.
const RECORD = Tuple{Symbol,Int64}[]

# When `true`, `BridgeA` adds a `SetB` constraint in its `final_touch`. This is
# used to test that a bridge of a *new* type added while `final_touch` is being
# called still gets its own `final_touch`.
const ADD_B = Ref(false)

# When `true`, the next `BridgeA.final_touch` adds another `SetA` constraint (the
# flag is consumed so only one is added). This tests that a bridge of an
# *already-processed* type added while `final_touch` is being called still gets
# its own `final_touch` (MathOptInterface issue #1980).
const ADD_A = Ref(false)

struct SetA <: MOI.AbstractScalarSet end

struct SetB <: MOI.AbstractScalarSet end

# BridgeB: `VariableIndex`-in-`SetB` -> `VariableIndex`-in-`GreaterThan`.
struct BridgeB{T} <: MOI.Bridges.Constraint.AbstractBridge
    x::MOI.VariableIndex
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{T}}
end

function MOI.Bridges.Constraint.bridge_constraint(
    ::Type{BridgeB{T}},
    model::MOI.ModelLike,
    func::MOI.VariableIndex,
    ::SetB,
) where {T}
    ci = MOI.add_constraint(model, func, MOI.GreaterThan(zero(T)))
    return BridgeB{T}(func, ci)
end

function MOI.supports_constraint(
    ::Type{<:BridgeB},
    ::Type{MOI.VariableIndex},
    ::Type{SetB},
)
    return true
end

function MOI.Bridges.Constraint.concrete_bridge_type(
    ::Type{<:BridgeB{T}},
    ::Type{MOI.VariableIndex},
    ::Type{SetB},
) where {T}
    return BridgeB{T}
end

MOI.Bridges.added_constrained_variable_types(::Type{<:BridgeB}) = Tuple{Type}[]

function MOI.Bridges.added_constraint_types(::Type{BridgeB{T}}) where {T}
    return Tuple{Type,Type}[(MOI.VariableIndex, MOI.GreaterThan{T})]
end

function MOI.get(
    ::BridgeB{T},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}},
)::Int64 where {T}
    return 1
end

function MOI.get(
    bridge::BridgeB{T},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.GreaterThan{T}},
) where {T}
    return [bridge.ci]
end

MOI.Bridges.needs_final_touch(::BridgeB) = true

function MOI.Bridges.final_touch(bridge::BridgeB, ::MOI.ModelLike)
    push!(RECORD, (:B, bridge.x.value))
    return
end

MOI.delete(model::MOI.ModelLike, bridge::BridgeB) = MOI.delete(model, bridge.ci)

# BridgeA: `VariableIndex`-in-`SetA`. It optionally adds a `VariableIndex`-in-
# `SetB` constraint in its `final_touch` (which is itself bridged by `BridgeB`).
mutable struct BridgeA{T} <: MOI.Bridges.Constraint.AbstractBridge
    x::MOI.VariableIndex
    ci::Union{Nothing,MOI.ConstraintIndex{MOI.VariableIndex,SetB}}
end

function MOI.Bridges.Constraint.bridge_constraint(
    ::Type{BridgeA{T}},
    ::MOI.ModelLike,
    func::MOI.VariableIndex,
    ::SetA,
) where {T}
    return BridgeA{T}(func, nothing)
end

function MOI.supports_constraint(
    ::Type{<:BridgeA},
    ::Type{MOI.VariableIndex},
    ::Type{SetA},
)
    return true
end

function MOI.Bridges.Constraint.concrete_bridge_type(
    ::Type{<:BridgeA{T}},
    ::Type{MOI.VariableIndex},
    ::Type{SetA},
) where {T}
    return BridgeA{T}
end

MOI.Bridges.added_constrained_variable_types(::Type{<:BridgeA}) = Tuple{Type}[]

function MOI.Bridges.added_constraint_types(::Type{<:BridgeA})
    return Tuple{Type,Type}[(MOI.VariableIndex, SetB)]
end

function MOI.get(
    bridge::BridgeA,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,SetB},
)::Int64
    return bridge.ci === nothing ? 0 : 1
end

function MOI.get(
    bridge::BridgeA,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,SetB},
)
    if bridge.ci === nothing
        return MOI.ConstraintIndex{MOI.VariableIndex,SetB}[]
    end
    return [bridge.ci]
end

MOI.Bridges.needs_final_touch(::BridgeA) = true

function MOI.Bridges.final_touch(bridge::BridgeA, model::MOI.ModelLike)
    push!(RECORD, (:A, bridge.x.value))
    if ADD_B[] && bridge.ci === nothing
        bridge.ci = MOI.add_constraint(model, bridge.x, SetB())
    end
    if ADD_A[]
        ADD_A[] = false  # consume the flag so only one constraint is added
        y = MOI.add_variable(model)
        MOI.add_constraint(model, y, SetA())
    end
    return
end

function MOI.delete(model::MOI.ModelLike, bridge::BridgeA)
    if bridge.ci !== nothing
        MOI.delete(model, bridge.ci)
    end
    return
end

# BridgeC: `VariableIndex`-in-`SetC`. Unlike `BridgeA`, it adds its `SetB`
# constraint in `bridge_constraint` (not `final_touch`), so `BridgeB` is created
# and registered *before* `BridgeC` (registration is post-order). Its
# `final_touch` must still be called *before* `BridgeB`'s, because `BridgeC`
# created the constraint that `BridgeB` bridges. This is the case that motivated
# ordering `final_touch` by creation order.
struct SetC <: MOI.AbstractScalarSet end

struct BridgeC{T} <: MOI.Bridges.Constraint.AbstractBridge
    x::MOI.VariableIndex
    ci::MOI.ConstraintIndex{MOI.VariableIndex,SetB}
end

function MOI.Bridges.Constraint.bridge_constraint(
    ::Type{BridgeC{T}},
    model::MOI.ModelLike,
    func::MOI.VariableIndex,
    ::SetC,
) where {T}
    ci = MOI.add_constraint(model, func, SetB())
    return BridgeC{T}(func, ci)
end

function MOI.supports_constraint(
    ::Type{<:BridgeC},
    ::Type{MOI.VariableIndex},
    ::Type{SetC},
)
    return true
end

function MOI.Bridges.Constraint.concrete_bridge_type(
    ::Type{<:BridgeC{T}},
    ::Type{MOI.VariableIndex},
    ::Type{SetC},
) where {T}
    return BridgeC{T}
end

MOI.Bridges.added_constrained_variable_types(::Type{<:BridgeC}) = Tuple{Type}[]

function MOI.Bridges.added_constraint_types(::Type{<:BridgeC})
    return Tuple{Type,Type}[(MOI.VariableIndex, SetB)]
end

function MOI.get(
    ::BridgeC,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,SetB},
)::Int64
    return 1
end

function MOI.get(
    bridge::BridgeC,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,SetB},
)
    return [bridge.ci]
end

MOI.Bridges.needs_final_touch(::BridgeC) = true

function MOI.Bridges.final_touch(bridge::BridgeC, ::MOI.ModelLike)
    push!(RECORD, (:C, bridge.x.value))
    return
end

MOI.delete(model::MOI.ModelLike, bridge::BridgeC) = MOI.delete(model, bridge.ci)

function _model()
    inner = MOI.Utilities.Model{Float64}()
    b = MOI.Bridges.LazyBridgeOptimizer(inner)
    MOI.Bridges.add_bridge(b, BridgeA{Float64})
    MOI.Bridges.add_bridge(b, BridgeB{Float64})
    MOI.Bridges.add_bridge(b, BridgeC{Float64})
    return b
end

# `final_touch` must be called in the order the bridges were added, not grouped
# by bridge type. Adding `A`, `B`, `A` must give the order `A, B, A` and not
# `A, A, B`.
function test_final_touch_in_addition_order()
    empty!(RECORD)
    ADD_B[] = false
    model = _model()
    x = MOI.add_variables(model, 3)
    MOI.add_constraint(model, x[1], SetA())
    MOI.add_constraint(model, x[2], SetB())
    MOI.add_constraint(model, x[3], SetA())
    MOI.Utilities.final_touch(model, MOI.Utilities.IndexMap())
    @test RECORD == [(:A, x[1].value), (:B, x[2].value), (:A, x[3].value)]
    return
end

# A bridge must get its `final_touch` before the bridges of the constraints it
# created in its `bridge_constraint`, even though those are registered first
# (registration is post-order but `final_touch` follows creation order).
function test_final_touch_parent_before_child()
    empty!(RECORD)
    model = _model()
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, SetC())
    MOI.Utilities.final_touch(model, MOI.Utilities.IndexMap())
    # `BridgeC` created the `SetB` constraint bridged by `BridgeB`, so
    # `BridgeC.final_touch` must run before `BridgeB.final_touch`.
    @test RECORD == [(:C, x.value), (:B, x.value)]
    return
end

# A bridge of a *new* type added while `final_touch` is being iterated must still
# get its `final_touch` called.
function test_final_touch_new_type_added_during_iteration()
    empty!(RECORD)
    ADD_B[] = true
    model = _model()
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, SetA())
    MOI.Utilities.final_touch(model, MOI.Utilities.IndexMap())
    ADD_B[] = false
    # `BridgeA.final_touch` added a `SetB` constraint bridged by `BridgeB`; its
    # `final_touch` must have been called after `BridgeA`'s.
    @test RECORD == [(:A, x.value), (:B, x.value)]
    return
end

# A bridge of an *already-processed* type added while `final_touch` is being
# iterated must still get its `final_touch` called (MathOptInterface issue
# #1980).
function test_final_touch_same_type_added_during_iteration()
    empty!(RECORD)
    ADD_A[] = true
    model = _model()
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, SetA())
    MOI.Utilities.final_touch(model, MOI.Utilities.IndexMap())
    ADD_A[] = false
    # The first `BridgeA.final_touch` added a second `SetA` constraint (a bridge
    # of the same, already-processed type); it must also get its `final_touch`.
    @test length(RECORD) == 2
    @test all(r -> r[1] == :A, RECORD)
    @test RECORD[1][2] != RECORD[2][2]  # two different variables
    return
end

end  # module

TestFinalTouchOrder.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

using Test

@testset "$(file)" for file in readdir(@__DIR__; join = true)
    if !endswith(file, ".jl") || endswith(file, "runtests.jl")
        continue
    end
    include(file)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    IntervalToHyperRectangleBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`IntervalToHyperRectangleBridge` implements the following reformulations:

  * ``l \\le g(x) \\le u`` into ``[g(x)] \\in `` `MOI.HyperRectangle([l], [u])`

where `T` is the coefficient type of `g(x)` and the type of `l` and `u`.

See also [`VectorizeBridge`](@ref) for equality and single-sided bound
constraints.

## Source node

`IntervalToHyperRectangleBridge` supports:

  * `G` in [`MOI.Interval{T}`](@ref)

## Target nodes

`IntervalToHyperRectangleBridge` creates:

  * `F` in [`MOI.HyperRectangle{T}`](@ref).
"""
mutable struct IntervalToHyperRectangleBridge{T,F,G} <: AbstractBridge
    vector_constraint::MOI.ConstraintIndex{F,MOI.HyperRectangle{T}}
end

const IntervalToHyperRectangle{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{IntervalToHyperRectangleBridge{T},OT}

function bridge_constraint(
    ::Type{IntervalToHyperRectangleBridge{T,F,G}},
    model::MOI.ModelLike,
    scalar_f::G,
    set::MOI.Interval{T},
) where {T,F,G}
    MOI.throw_if_scalar_and_constant_not_zero(scalar_f, typeof(set))
    vector_f = MOI.Utilities.operate(vcat, T, scalar_f)
    rect = MOI.HyperRectangle([set.lower], [set.upper])
    vector_constraint = MOI.add_constraint(model, vector_f, rect)
    return IntervalToHyperRectangleBridge{T,F,G}(vector_constraint)
end

function MOI.supports_constraint(
    ::Type{IntervalToHyperRectangleBridge{T}},
    ::Type{F},
    ::Type{MOI.Interval{T}},
) where {T,F<:MOI.AbstractScalarFunction}
    return MOI.Utilities.is_coefficient_type(F, T)
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:IntervalToHyperRectangleBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:IntervalToHyperRectangleBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[(F, MOI.HyperRectangle{T})]
end

function concrete_bridge_type(
    ::Type{<:IntervalToHyperRectangleBridge{T}},
    G::Type{<:MOI.AbstractScalarFunction},
    S::Type{MOI.Interval{T}},
) where {T}
    F = MOI.Utilities.promote_operation(vcat, T, G)
    return IntervalToHyperRectangleBridge{T,F,G}
end

function MOI.get(
    ::IntervalToHyperRectangleBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.HyperRectangle{T}},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    bridge::IntervalToHyperRectangleBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.HyperRectangle{T}},
) where {T,F}
    return [bridge.vector_constraint]
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::IntervalToHyperRectangleBridge,
)
    MOI.delete(model, bridge.vector_constraint)
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{IntervalToHyperRectangleBridge{T,F,G}},
) where {T,F,G}
    return MOI.supports(
        model,
        attr,
        MOI.ConstraintIndex{F,MOI.HyperRectangle{T}},
    )
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::IntervalToHyperRectangleBridge,
)
    x = MOI.get(model, attr, bridge.vector_constraint)
    if isnothing(x)
        return nothing
    end
    return only(x)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::IntervalToHyperRectangleBridge,
    value,
)
    MOI.set(model, attr, bridge.vector_constraint, [value])
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::IntervalToHyperRectangleBridge,
    ::Nothing,
)
    MOI.set(model, attr, bridge.vector_constraint, nothing)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::IntervalToHyperRectangleBridge,
)
    x = MOI.get(model, attr, bridge.vector_constraint)
    if isnothing(x)
        return nothing
    end
    return only(x)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::IntervalToHyperRectangleBridge,
    value,
)
    if isnothing(value)
        MOI.set(model, attr, bridge.vector_constraint, nothing)
    else
        MOI.set(model, attr, bridge.vector_constraint, [value])
    end
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::IntervalToHyperRectangleBridge,
    change::MOI.ScalarCoefficientChange,
)
    MOI.modify(
        model,
        bridge.vector_constraint,
        MOI.MultirowChange(change.variable, [(1, change.new_coefficient)]),
    )
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::IntervalToHyperRectangleBridge,
    new_set::MOI.Interval,
)
    MOI.set(
        model,
        attr,
        bridge.vector_constraint,
        MOI.HyperRectangle([new_set.lower], [new_set.upper]),
    )
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::IntervalToHyperRectangleBridge{T,F,G},
) where {T,F,G}
    return convert(
        G,
        only(
            MOI.Utilities.scalarize(
                MOI.get(model, attr, bridge.vector_constraint),
            ),
        ),
    )
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::IntervalToHyperRectangleBridge,
)
    rect = MOI.get(model, MOI.ConstraintSet(), bridge.vector_constraint)
    return MOI.Interval(only(rect.lower), only(rect.upper))
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestNonlinearRead

using Test
import MathOptInterface as MOI
import MathOptInterface.FileFormats: NL

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_next_int()
    model = NL._CacheModel()
    for i in (1, 9, 10, 11, 99)
        io = IOBuffer()
        print(io, " $i\n")
        seekstart(io)
        @test NL._next(Int, io, model) == i
        @test peek(io) == UInt8('\n')
    end
    return
end

function test_next_float()
    model = NL._CacheModel()
    for (s, x) in [
        ("-1", -1.0),
        ("1", 1.0),
        ("-2.1e+1", -21.0),
        ("2.1e+1", 21.0),
        ("-2.1e-01", -0.21),
        ("2.1e-01", 0.21),
        ("-2.1E-01", -0.21),
        ("2.1E-01", 0.21),
        ("-20.1e+0", -20.1),
        ("20.1e+00", 20.1),
        ("  20.1e+00", 20.1),
    ]
        io = IOBuffer()
        print(io, "$s\n")
        seekstart(io)
        @test NL._next(Float64, io, model) == x
        @test peek(io) == UInt8('\n')
    end
    return
end

function test_parse_expr()
    model = NL._CacheModel()
    io = IOBuffer()
    write(io, "o2\nv0\no2\nn2\no2\nv3\nv1\n")
    # (* x1 (* 2 (* x4 x2)))
    seekstart(io)
    x = MOI.VariableIndex.(1:4)
    @test NL._parse_expr(io, model) ==
          :(*($(x[1]), *(2.0, *($(x[4]), $(x[2])))))
    @test eof(io)
    return
end

function test_parse_expr_nary()
    model = NL._CacheModel()
    io = IOBuffer()
    write(io, "o54\n4\no5\nv0\nn2\no5\nv2\nn2\no5\nv3\nn2\no5\nv1\nn2\n")
    seekstart(io)
    x = MOI.VariableIndex.(1:4)
    @test NL._parse_expr(io, model) ==
          :(+($(x[1])^2.0, $(x[3])^2.0, $(x[4])^2.0, $(x[2])^2.0))
    @test eof(io)
    return
end

function test_parse_expr_minimum()
    model = NL._CacheModel()
    io = IOBuffer()
    write(io, "o11\n3\nv0\nv1\nv2\n")
    seekstart(io)
    x = MOI.VariableIndex.(1:3)
    @test NL._parse_expr(io, model) == :(min($(x[1]), $(x[2]), $(x[3])))
    @test eof(io)
    return
end

function test_parse_expr_maximum()
    model = NL._CacheModel()
    io = IOBuffer()
    write(io, "o12\n3\nv0\nv1\nv2\n")
    seekstart(io)
    x = MOI.VariableIndex.(1:3)
    @test NL._parse_expr(io, model) == :(max($(x[1]), $(x[2]), $(x[3])))
    @test eof(io)
    return
end

function test_parse_header_unsupported_mode()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(io, "z3 1 1 0\n")
    seekstart(io)
    @test_throws(
        ErrorException("Unable to parse NL file : unsupported mode z"),
        NL._parse_header(io, model),
    )
    return
end

function test_parse_expr_atan2()
    model = NL._CacheModel()
    io = IOBuffer()
    write(io, "o48\nv0\nv1\n")
    seekstart(io)
    x = MOI.VariableIndex.(1:2)
    @test NL._parse_expr(io, model) == :(atan($(x[1]), $(x[2])))
    @test eof(io)
    return
end

function test_parse_expr_atan()
    model = NL._CacheModel()
    io = IOBuffer()
    write(io, "o49\nv0\n")
    seekstart(io)
    x = MOI.VariableIndex.(1:1)
    @test NL._parse_expr(io, model) == :(atan($(x[1])))
    @test eof(io)
    return
end

function test_parse_header_assertion_errors()
    model = NL._CacheModel()
    for header in [
        "g4 1 1 0\n3 3 2 0 0 0\n",
        "g4 1 1 0\n3 3 1 0 0 0\n0 2\n",
        "g4 1 1 0\n3 3 1 0 0 0\n0 0\n1 0\n",
        "g4 1 1 0\n3 3 1 0 0 0\n0 0\n0 1\n",
        "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n1 0 0 1\n",
        "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n0 1 0 1\n",
        # "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n0 0 1 1\n",
        "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n0 0 0 1\n0 0 0 2 0\n-1 0\n",
        "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n0 0 0 1\n0 0 0 2 0\n0 -1\n",
    ]
        io = IOBuffer()
        write(io, header)
        seekstart(io)
        @test_throws(AssertionError, NL._parse_header(io, model))
    end
    return
end

function test_parse_header_common_expressions()
    model = NL._CacheModel()
    err = ErrorException(
        "Unable to parse NL file : we don't support common exprs",
    )
    for header in [
        "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n0 0 0 1\n0 0 0 2 0\n8 4\n0 0\n1 0 0 0 0\n",
        "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n0 0 0 1\n0 0 0 2 0\n8 4\n0 0\n0 1 0 0 0\n",
        "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n0 0 0 1\n0 0 0 2 0\n8 4\n0 0\n0 0 1 0 0\n",
        "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n0 0 0 1\n0 0 0 2 0\n8 4\n0 0\n0 0 0 1 0\n",
        "g3 1 1 0\n4 2 1 0 1 0\n2 1\n0 0\n4 0 0\n0 0 0 1\n0 0 0 2 0\n8 4\n0 0\n0 0 0 0 1\n",
    ]
        io = IOBuffer()
        write(io, header)
        seekstart(io)
        @test_throws(err, NL._parse_header(io, model))
    end
    return
end

function test_parse_y_error()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(io, "y\n")
    seekstart(io)
    @test_throws(
        ErrorException("Unable to parse NL file: unhandled header y"),
        NL._parse_section(io, model),
    )
    return
end

function test_parse_O()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(
        io,
        """
O0 0# can stick a comment anywhere
o2
v0  # can stick a comment anywhere
o2
v2
o2
v3
v1
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.sense == MOI.MIN_SENSE
    x = MOI.VariableIndex.(1:4)
    @test model.objective == :($(x[1]) * ($(x[3]) * ($(x[4]) * $(x[2]))))
    return
end

function test_parse_O_max()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(io, "O0 1\nv0\n")
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.sense == MOI.MAX_SENSE
    x = MOI.VariableIndex(1)
    @test model.objective == :(+$x)
    return
end

function test_parse_x()
    model = NL._CacheModel()
    NL._resize_variables(model, 5)
    io = IOBuffer()
    write(
        io,
        """
x3
0 1.1# can stick a comment anywhere
3 2.2
2 3.3  # can stick a comment anywhere
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.variable_primal == [1.1, 0.0, 3.3, 2.2, 0.0]
    return
end

function test_parse_d()
    model = NL._CacheModel()
    io = IOBuffer()
    write(
        io,
        """
d3
0 1.1# can stick a comment anywhere
3 2.2
2 3.3  # can stick a comment anywhere
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    return
end

function test_parse_r()
    model = NL._CacheModel()
    NL._resize_constraints(model, 5)
    io = IOBuffer()
    write(
        io,
        """
        r# can stick a comment anywhere
        1 3.3
         3
        0 1.1 2.2  # can stick a comment anywhere
          4 5.5
        2 4.4# can stick a comment anywhere
        """,
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.constraint_lower == [-Inf, -Inf, 1.1, 5.5, 4.4]
    @test model.constraint_upper == [3.3, Inf, 2.2, 5.5, Inf]
    return
end

function test_parse_b()
    model = NL._CacheModel()
    NL._resize_variables(model, 5)
    io = IOBuffer()
    write(
        io,
        """
        b# can stick a comment anywhere
        1 3.3
          3# can stick a comment anywhere
        0 1.1 2.2
         4 5.5
        2 4.4 # can stick a comment anywhere
        """,
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.variable_lower == [-Inf, -Inf, 1.1, 5.5, 4.4]
    @test model.variable_upper == [3.3, Inf, 2.2, 5.5, Inf]
    return
end

function test_parse_k()
    model = NL._CacheModel()
    NL._resize_variables(model, 3)
    io = IOBuffer()
    write(
        io,
        """
        k2
        2 # can stick a comment anywhere
        4
        """,
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    return
end

function test_parse_J()
    model = NL._CacheModel()
    NL._resize_constraints(model, 3)
    io = IOBuffer()
    write(
        io,
        """
J1 2  # can stick a comment anywhere
2 1.1
3 2.2  # can stick a comment anywhere
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.constraints[1] == :()
    x, y = MOI.VariableIndex(3), MOI.VariableIndex(4)
    @test model.constraints[2] == :(1.1 * $x + 2.2 * $y)
    @test model.constraints[3] == :()
    return
end

function test_parse_J_zeros()
    model = NL._CacheModel()
    NL._resize_constraints(model, 1)
    io = IOBuffer()
    write(
        io,
        """
J0 2
0 0
1 0
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.constraints[1] == :()
    return
end

function test_parse_C_J()
    model = NL._CacheModel()
    NL._resize_constraints(model, 1)
    io = IOBuffer()
    write(
        io,
        """
C0
o2
v0
v1
J0 2
0 1.1
1 2.2
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    NL._parse_section(io, model)
    @test eof(io)
    x, y = MOI.VariableIndex(1), MOI.VariableIndex(2)
    @test model.constraints[1] == :((1.1 * $x + 2.2 * $y) + $x * $y)
    return
end

function test_parse_J_C()
    model = NL._CacheModel()
    NL._resize_constraints(model, 1)
    io = IOBuffer()
    write(
        io,
        """
J0 2
0 1.1
1 2.2
C0
o2
v0
v1
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    NL._parse_section(io, model)
    @test eof(io)
    x, y = MOI.VariableIndex(1), MOI.VariableIndex(2)
    @test model.constraints[1] == :((1.1 * $x + 2.2 * $y) + $x * $y)
    return
end

function test_parse_G()
    model = NL._CacheModel()
    NL._resize_constraints(model, 3)
    io = IOBuffer()
    write(
        io,
        """
G0 2 # can stick a comment anywhere
2 1.1  # can stick a comment anywhere
3 2.2
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    x, y = MOI.VariableIndex(3), MOI.VariableIndex(4)
    @test model.objective == :(1.1 * $x + 2.2 * $y)
    return
end

function test_parse_G_zeros()
    model = NL._CacheModel()
    NL._resize_constraints(model, 3)
    io = IOBuffer()
    write(
        io,
        """
G0 3
0 0
1 0
2 0
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.objective == :()
    return
end

function test_parse_O_G()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(
        io,
        """
O0 0
o2
v0
v1
G0 2
0 1.1
1 2.2
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    NL._parse_section(io, model)
    @test eof(io)
    x, y = MOI.VariableIndex(1), MOI.VariableIndex(2)
    @test model.objective == :((1.1 * $x + 2.2 * $y) + $x * $y)
    return
end

function test_parse_G_O()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(
        io,
        """
G0 2
0 -1.1
1 2.2e+01
O0 0
o2
v0
v1
""",
    )
    seekstart(io)
    NL._parse_section(io, model)
    NL._parse_section(io, model)
    @test eof(io)
    x, y = MOI.VariableIndex(1), MOI.VariableIndex(2)
    @test model.objective == :((-1.1 * $x + 22.0 * $y) + $x * $y)
    return
end

function test_parse_F()
    model = NL._CacheModel()
    io = IOBuffer()
    write(io, "F")
    seekstart(io)
    @test_throws(
        ErrorException(
            "Unable to parse NL file: imported function descriptions ('F' " *
            "sections) are not yet supported. To request support, please open an " *
            "issue at https://github.com/jump-dev/MathOptInterface.jl with a " *
            "reproducible example.",
        ),
        NL._parse_section(io, model),
    )
    return
end

function test_parse_V()
    model = NL._CacheModel()
    io = IOBuffer()
    write(io, "V")
    seekstart(io)
    @test_throws(
        ErrorException(
            "Unable to parse NL file: defined variable definitions ('V' sections)" *
            " are not yet supported. To request support, please open an issue at " *
            "https://github.com/jump-dev/MathOptInterface.jl with a reproducible " *
            "example.",
        ),
        NL._parse_section(io, model),
    )
    return
end

function test_parse_L()
    model = NL._CacheModel()
    io = IOBuffer()
    write(io, "L")
    seekstart(io)
    @test_throws(
        ErrorException(
            "Unable to parse NL file: logical constraints ('L' sections) are not " *
            "yet supported. To request support, please open an issue at " *
            "https://github.com/jump-dev/MathOptInterface.jl with a reproducible " *
            "example.",
        ),
        NL._parse_section(io, model),
    )
    return
end

function test_parse_S()
    model = NL._CacheModel()
    io = IOBuffer()
    write(
        io,
        """
        S0 8 zork
        0 2
        1 6
        2 7
        3 8
        4 9
        5 3
        6 5
        8 4
        """,
    )
    seekstart(io)
    @test_logs(
        (:warn, "Skipping suffix: `S0 8 zork`"),
        NL._parse_section(io, model),
    )
    @test eof(io)
    return
end

function test_parse_S_Float64()
    model = NL._CacheModel()
    io = IOBuffer()
    write(
        io,
        """
        S4 8 zork
        0 2.0
        1 6.0
        2 7.0
        3 8.0
        4 9.0
        5 3.0
        6 5.0
        8 4.0
        """,
    )
    seekstart(io)
    @test_logs(
        (:warn, "Skipping suffix: `S4 8 zork`"),
        NL._parse_section(io, model),
    )
    @test eof(io)
    return
end

function test_hs071()
    model = NL.Model()
    open(joinpath(@__DIR__, "data", "hs071.nl"), "r") do io
        return read!(io, model)
    end
    model_print = sprint(print, model)
    _in_ = @static Sys.iswindows() ? "in" : "∈"
    for line in [
        "(1.1 * v[1] + 1.4 * v[2] + 1.2 * v[3] + 1.3 * v[4]) + +2.0",
        "v[1] >= 1.1",
        "v[2] >= 1.4",
        "v[3] >= 1.2",
        "v[4] >= 1.3",
        "v[1] <= 5.1",
        "v[2] <= 5.4",
        "v[3] <= 1.0",
        "v[4] <= 5.3",
        "v[3] $_in_ ℤ",
        "v[4] $_in_ ℤ",
        "v[1] * (v[3] * (v[4] * v[2])) >= 25.0",
        "v[1] ^ 2.0 + v[3] ^ 2.0 + v[4] ^ 2.0 + v[2] ^ 2.0 == 40.0",
    ]
        @test occursin(line, model_print)
    end
    return
end

function test_parse_header_integrality_obj()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(
        io,
        """g3 0 1 0	# problem test_simple
2 1 1 0 0	# vars, constraints, objectives, ranges, eqns
1 1	# nonlinear constraints, objectives
0 0	# network constraints: nonlinear, linear
1 2 0	# nonlinear vars in constraints, objectives, both
0 0 0 1	# linear network variables; functions; arith, flags
0 0 0 0 0	# discrete variables: binary, integer, nonlinear (b,c,o)
1 1	# nonzeros in Jacobian, gradients
0 0	# max name lengths: constraints, variables
0 0 0 0 0	# common exprs: b,c,o,c1,o1\n""",
    )
    seekstart(io)
    NL._parse_header(io, model)
    @test model.variable_type[1] == NL._CONTINUOUS
    @test model.variable_type[2] == NL._CONTINUOUS
    return
end

function test_parse_header_integrality_obj_int()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(
        io,
        """g3 0 1 0	# problem test_simple
2 1 1 0 0	# vars, constraints, objectives, ranges, eqns
1 1	# nonlinear constraints, objectives
0 0	# network constraints: nonlinear, linear
1 2 0	# nonlinear vars in constraints, objectives, both
0 0 0 1	# linear network variables; functions; arith, flags
0 0 0 0 1	# discrete variables: binary, integer, nonlinear (b,c,o)
1 1	# nonzeros in Jacobian, gradients
0 0	# max name lengths: constraints, variables
0 0 0 0 0	# common exprs: b,c,o,c1,o1\n""",
    )
    seekstart(io)
    NL._parse_header(io, model)
    @test model.variable_type[1] == NL._CONTINUOUS
    @test model.variable_type[2] == NL._INTEGER
    return
end

function test_parse_header_integrality_both()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(
        io,
        """g3 0 1 0	# problem test_simple
2 1 1 0 0	# vars, constraints, objectives, ranges, eqns
1 1	# nonlinear constraints, objectives
0 0	# network constraints: nonlinear, linear
2 1 1	# nonlinear vars in constraints, objectives, both
0 0 0 1	# linear network variables; functions; arith, flags
0 0 0 0 0	# discrete variables: binary, integer, nonlinear (b,c,o)
1 1	# nonzeros in Jacobian, gradients
0 0	# max name lengths: constraints, variables
0 0 0 0 0	# common exprs: b,c,o,c1,o1\n""",
    )
    seekstart(io)
    NL._parse_header(io, model)
    @test model.variable_type[1] == NL._CONTINUOUS
    @test model.variable_type[2] == NL._CONTINUOUS
    return
end

function test_parse_header_integrality_both_int()
    model = NL._CacheModel()
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(
        io,
        """g3 0 1 0	# problem test_simple
2 1 1 0 0	# vars, constraints, objectives, ranges, eqns
1 1	# nonlinear constraints, objectives
0 0	# network constraints: nonlinear, linear
2 1 1	# nonlinear vars in constraints, objectives, both
0 0 0 1	# linear network variables; functions; arith, flags
0 0 1 0 0	# discrete variables: binary, integer, nonlinear (b,c,o)
1 1	# nonzeros in Jacobian, gradients
0 0	# max name lengths: constraints, variables
0 0 0 0 0	# common exprs: b,c,o,c1,o1\n""",
    )
    seekstart(io)
    NL._parse_header(io, model)
    @test model.variable_type[1] == NL._INTEGER
    @test model.variable_type[2] == NL._CONTINUOUS
    return
end

function test_hs071_free_constraint_nlexpr()
    model = NL.Model(; use_nlp_block = false)
    open(joinpath(@__DIR__, "data", "hs071_free_constraint.nl"), "r") do io
        return read!(io, model)
    end
    types = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test length(types) == 2
    @test (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) in types
    @test (MOI.ScalarNonlinearFunction, MOI.Interval{Float64}) in types
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    end
    F, S = MOI.ScalarNonlinearFunction, MOI.Interval{Float64}
    ci = first(MOI.get(model, MOI.ListOfConstraintIndices{F,S}()))
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.Interval(-Inf, Inf)
    return
end

function test_hs071_free_constraint()
    model = NL.Model()
    open(joinpath(@__DIR__, "data", "hs071_free_constraint.nl"), "r") do io
        return read!(io, model)
    end
    block = MOI.get(model, MOI.NLPBlock())
    @test block.constraint_bounds ==
          [MOI.NLPBoundsPair(25.0, Inf), MOI.NLPBoundsPair(-Inf, Inf)]
    return
end

function test_no_objective()
    model = NL.Model()
    open(joinpath(@__DIR__, "data", "hs071_no_objective.nl"), "r") do io
        return read!(io, model)
    end
    @test MOI.get(model, MOI.NumberOfVariables()) == 4
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.FEASIBILITY_SENSE
    return
end

"""
    test_mac_minlp()

This function tests reading the files in Sven Leyffer's MINLP testset, which is
available at: https://wiki.mcs.anl.gov/leyffer/index.php/MacMINLP.

If the folder isn't available locally, the test is skipped.
"""
function test_mac_minlp()
    dir = joinpath(@__DIR__, "MacMINLP")
    if !isdir(dir)
        return
    end
    exclude = [
        # Has subexpressions
        "space-25-r.nl",
        "space-960-ir.nl",
        "space-960-r.nl",
        "top1-15x05.nl",
    ]
    for file in filter(f -> !(f in exclude) && endswith(f, ".nl"), readdir(dir))
        model = NL.Model()
        open(joinpath(dir, file), "r") do io
            return read!(io, model)
        end
    end
    return
end

function test_nl_read_scalar_affine_function()
    for obj_fn in (x -> x, x -> 1.0 * x, x -> 2.0 * x + 3.0)
        src = MOI.Utilities.Model{Float64}()
        x = MOI.add_variable(src)
        MOI.set(src, MOI.ObjectiveSense(), MOI.MIN_SENSE)
        f = obj_fn(x)
        MOI.set(src, MOI.ObjectiveFunction{typeof(f)}(), f)
        MOI.add_constraint(src, f, MOI.LessThan(1.0))
        dest = MOI.FileFormats.NL.Model()
        MOI.copy_to(dest, src)
        io = IOBuffer()
        write(io, dest)
        input = MOI.FileFormats.NL.Model(; use_nlp_block = false)
        seekstart(io)
        read!(io, input)
        model = MOI.Utilities.Model{Float64}()
        MOI.copy_to(model, input)
        y = only(MOI.get(model, MOI.ListOfVariableIndices()))
        g = MOI.Utilities.substitute_variables(
            _ -> y,
            convert(MOI.ScalarAffineFunction{Float64}, f),
        )
        obj = MOI.get(model, MOI.ObjectiveFunction{typeof(g)}())
        @test ≈(obj, g)
        @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) ==
              [(typeof(f), MOI.LessThan{Float64})]
    end
    return
end

function test_binary_next_Float64()
    model = NL._CacheModel()
    model.is_binary = true
    sequence = [0.0, 1.0, -2.0, 1.234, 1e-12]
    io = IOBuffer()
    for s in sequence
        write(io, s)
    end
    seekstart(io)
    for s in sequence
        @test NL._next(Float64, io, model) === s
    end
    return
end

function test_binary_next_Int()
    model = NL._CacheModel()
    model.is_binary = true
    sequence = Int32[0, 1, 2, -3, -5, typemax(Int32), typemin(Int32)]
    io = IOBuffer()
    for s in sequence
        write(io, s)
    end
    seekstart(io)
    for s in sequence
        @test NL._next(Int, io, model) === Int(s)
    end
    return
end

function test_binary_read_til_newline()
    model = NL._CacheModel()
    model.is_binary = true
    io = IOBuffer()
    @test NL._read_til_newline(io, model) === nothing
    @test position(io) == 0
    return
end

function test_parse_header_binary()
    model = NL._CacheModel()
    io = IOBuffer()
    write(
        io,
        """b3 0 1 0	# problem test_simple
        2 1 1 0 0	# vars, constraints, objectives, ranges, eqns
        1 1	# nonlinear constraints, objectives
        0 0	# network constraints: nonlinear, linear
        1 2 0	# nonlinear vars in constraints, objectives, both
        0 0 1 1	# linear network variables; functions; arith, flags
        0 0 0 0 0	# discrete variables: binary, integer, nonlinear (b,c,o)
        1 1	# nonzeros in Jacobian, gradients
        0 0	# max name lengths: constraints, variables
        0 0 0 0 0	# common exprs: b,c,o,c1,o1
        """,
    )
    seekstart(io)
    NL._parse_header(io, model)
    @test model.is_binary
    return
end

function test_binary_parse_O()
    model = NL._CacheModel()
    model.is_binary = true
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(io, Cchar('O'), Int32(0), Int32(0))
    write(io, Cchar('o'), Int32(2))
    write(io, Cchar('v'), Int32(0))
    write(io, Cchar('o'), Int32(2))
    write(io, Cchar('v'), Int32(2))
    write(io, Cchar('o'), Int32(2))
    write(io, Cchar('v'), Int32(3))
    write(io, Cchar('v'), Int32(1))
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.sense == MOI.MIN_SENSE
    x = MOI.VariableIndex.(1:4)
    @test model.objective == :($(x[1]) * ($(x[3]) * ($(x[4]) * $(x[2]))))
    return
end

function test_binary_parse_O_max()
    model = NL._CacheModel()
    model.is_binary = true
    NL._resize_variables(model, 4)
    io = IOBuffer()
    write(io, Cchar('O'), Int32(0), Int32(1), Cchar('v'), Int32(0))
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.sense == MOI.MAX_SENSE
    x = MOI.VariableIndex(1)
    @test model.objective == :(+$x)
    return
end

function test_binary_parse_x()
    model = NL._CacheModel()
    model.is_binary = true
    NL._resize_variables(model, 5)
    io = IOBuffer()
    write(io, Cchar('x'), Int32(3))
    write(io, Int32(0), 1.1)
    write(io, Int32(3), 2.2)
    write(io, Int32(2), 3.3)
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.variable_primal == [1.1, 0.0, 3.3, 2.2, 0.0]
    return
end

function test_binary_parse_d()
    model = NL._CacheModel()
    model.is_binary = true
    io = IOBuffer()
    write(io, Cchar('d'), Int32(3))
    write(io, Int32(0), 1.1)
    write(io, Int32(3), 2.2)
    write(io, Int32(2), 3.3)
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    return
end

function test_binary_parse_r()
    model = NL._CacheModel()
    model.is_binary = true
    NL._resize_constraints(model, 5)
    io = IOBuffer()
    write(io, Cchar('r'))
    write(io, Cchar('1'), 3.3)
    write(io, Cchar('3'))
    write(io, Cchar('0'), 1.1, 2.2)
    write(io, Cchar('4'), 5.5)
    write(io, Cchar('2'), 4.4)
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.constraint_lower == [-Inf, -Inf, 1.1, 5.5, 4.4]
    @test model.constraint_upper == [3.3, Inf, 2.2, 5.5, Inf]
    return
end

function test_binary_parse_b()
    model = NL._CacheModel()
    model.is_binary = true
    NL._resize_variables(model, 5)
    io = IOBuffer()
    write(io, Cchar('b'))
    write(io, Cchar('1'), 3.3)
    write(io, Cchar('3'))
    write(io, Cchar('0'), 1.1, 2.2)
    write(io, Cchar('4'), 5.5)
    write(io, Cchar('2'), 4.4)
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    @test model.variable_lower == [-Inf, -Inf, 1.1, 5.5, 4.4]
    @test model.variable_upper == [3.3, Inf, 2.2, 5.5, Inf]
    return
end

function test_binary_parse_k()
    model = NL._CacheModel()
    model.is_binary = true
    NL._resize_variables(model, 3)
    io = IOBuffer()
    write(io, Cchar('k'), Int32(2))
    write(io, Int32(2))
    write(io, Int32(4))
    seekstart(io)
    NL._parse_section(io, model)
    @test eof(io)
    return
end

function test_binary_parse_S()
    model = NL._CacheModel()
    model.is_binary = true
    io = IOBuffer()
    write(io, Cchar('S'), Int32(0), Int32(8))
    write(io, Int32(4), Cchar('z'), Cchar('o'), Cchar('r'), Cchar('k'))
    write(io, Int32(0), Int32(2))
    write(io, Int32(1), Int32(6))
    write(io, Int32(2), Int32(7))
    write(io, Int32(3), Int32(8))
    write(io, Int32(4), Int32(9))
    write(io, Int32(5), Int32(3))
    write(io, Int32(6), Int32(5))
    write(io, Int32(8), Int32(4))
    seekstart(io)
    @test_logs(
        (:warn, "Skipping suffix: `S0 8 zork`"),
        NL._parse_section(io, model),
    )
    @test eof(io)
    return
end

function test_binary_parse_S_Float64()
    model = NL._CacheModel()
    model.is_binary = true
    io = IOBuffer()
    write(io, Cchar('S'), Int32(4), Int32(8))
    write(io, Int32(4), Cchar('z'), Cchar('o'), Cchar('r'), Cchar('k'))
    write(io, Int32(0), 2.1)
    write(io, Int32(1), 6.1)
    write(io, Int32(2), 7.1)
    write(io, Int32(3), 8.1)
    write(io, Int32(4), 9.1)
    write(io, Int32(5), 3.1)
    write(io, Int32(6), 5.1)
    write(io, Int32(8), 4.1)
    seekstart(io)
    @test_logs(
        (:warn, "Skipping suffix: `S4 8 zork`"),
        NL._parse_section(io, model),
    )
    @test eof(io)
    return
end

function test_try_scalar_affine_function()
    compare(::Nothing, ::Nothing) = true
    compare(x::T, y::T) where {T} = isapprox(x, y)
    compare(x, y) = (@show(x, y, typeof(x), typeof(y)); false)
    x = MOI.VariableIndex(1)
    for (expr, ret) in Any[
        :(2.0)=>2.0,
        :($x)=>x,
        :(2.0*$x)=>2.0*x,
        :($x*2.0)=>2.0*x,
        :(($x+$x))=>2.0*x,
        :(2.0*($x+$x))=>4.0*x,
        :(($x+$x)*2.0)=>4.0*x,
        :(($x+$x)+2.0)=>2.0*x+2.0,
        :(sin($x)*($x+$x))=>nothing,
        :(($x+$x)*sin($x))=>nothing,
        :($x*$x)=>nothing,
    ]
        @test compare(MOI.FileFormats.NL._try_scalar_affine_function(expr), ret)
    end
    return
end

end

TestNonlinearRead.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    NormOneBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`NormOneBridge` implements the following reformulation:

  * ``\\sum |x_i| \\le t`` into
    ``[t - \\sum y_i, y_i - x_i, y_i + x_i] \\in \\mathbb{R}_+``.

## Source node

`NormOneBridge` supports:

  * `G` in [`MOI.NormOneCone{T}`](@ref)

## Target nodes

`NormOneBridge` creates:

  * `F` in [`MOI.Nonnegatives`](@ref)
"""
struct NormOneBridge{T,F,G} <: AbstractBridge
    y::Vector{MOI.VariableIndex}
    nn_index::MOI.ConstraintIndex{F,MOI.Nonnegatives}
end

const NormOne{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{NormOneBridge{T},OT}

function bridge_constraint(
    ::Type{NormOneBridge{T,F,G}},
    model::MOI.ModelLike,
    f::G,
    s::MOI.NormOneCone,
) where {T,F,G}
    f_scalars = MOI.Utilities.eachscalar(f)
    d = MOI.dimension(s)
    y = MOI.add_variables(model, d - 1)
    rhs = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(one(T), y), zero(T))
    ge = MOI.Utilities.operate(-, T, f_scalars[1], rhs)
    lb = f_scalars[2:d]
    ub = MOI.Utilities.operate(-, T, lb)
    lb = MOI.Utilities.operate!(+, T, lb, MOI.VectorOfVariables(y))
    ub = MOI.Utilities.operate!(+, T, ub, MOI.VectorOfVariables(y))
    f_new = MOI.Utilities.operate(vcat, T, ge, ub, lb)
    nn_index = MOI.add_constraint(model, f_new, MOI.Nonnegatives(2d - 1))
    return NormOneBridge{T,F,G}(y, nn_index)
end

function MOI.supports_constraint(
    ::Type{NormOneBridge{T}},
    ::Type{F},
    ::Type{MOI.NormOneCone},
) where {T,F<:MOI.AbstractVectorFunction}
    return MOI.Utilities.is_coefficient_type(F, T) &&
           !MOI.Utilities.is_complex(F)
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:NormOneBridge})
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:NormOneBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[(F, MOI.Nonnegatives)]
end

function concrete_bridge_type(
    ::Type{<:NormOneBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.NormOneCone},
) where {T}
    S = MOI.Utilities.scalar_type(G)
    F = MOI.Utilities.promote_operation(
        vcat,
        T,
        MOI.Utilities.promote_operation(+, T, S, S),
        MOI.Utilities.promote_operation(-, T, S, S),
    )
    return NormOneBridge{T,F,G}
end

MOI.get(b::NormOneBridge, ::MOI.NumberOfVariables)::Int64 = length(b.y)

MOI.get(b::NormOneBridge, ::MOI.ListOfVariableIndices) = copy(b.y)

function MOI.get(
    ::NormOneBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.Nonnegatives},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    b::NormOneBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.Nonnegatives},
) where {T,F}
    return [b.nn_index]
end

function MOI.delete(model::MOI.ModelLike, c::NormOneBridge)
    MOI.delete(model, c.nn_index)
    MOI.delete(model, c.y)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    c::NormOneBridge{T,F,G},
) where {T,F,G}
    nn_f = MOI.get(model, MOI.ConstraintFunction(), c.nn_index)
    nn_func = MOI.Utilities.eachscalar(nn_f)
    sum_nn_func = MOI.Utilities.operate(+, T, nn_func[1], nn_func...)
    t = MOI.Utilities.operate!(/, T, sum_nn_func, T(2))
    d = div(length(nn_func) - 1, 2)
    x = MOI.Utilities.operate!(
        /,
        T,
        MOI.Utilities.operate!(-, T, nn_func[(d+2):end], nn_func[2:(d+1)]),
        T(2),
    )
    return MOI.Utilities.convert_approx(
        G,
        MOI.Utilities.remove_variable(
            MOI.Utilities.operate(vcat, T, t, x),
            c.y,
        ),
    )
end

function MOI.get(model::MOI.ModelLike, ::MOI.ConstraintSet, c::NormOneBridge)
    dim = div(
        MOI.dimension(MOI.get(model, MOI.ConstraintSet(), c.nn_index)) + 1,
        2,
    )
    return MOI.NormOneCone(dim)
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{NormOneBridge{T,F,G}},
) where {T,F,G}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F,MOI.Nonnegatives})
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::NormOneBridge{T},
    value,
) where {T}
    x_value = value[1 .+ (1:length(bridge.y))]
    y_value = abs.(x_value)
    for i in eachindex(bridge.y)
        MOI.set(model, MOI.VariablePrimalStart(), bridge.y[i], y_value[i])
    end
    nn_value = vcat(
        value[1] - reduce(+, y_value, init = zero(T)),
        y_value - x_value,
        y_value + x_value,
    )
    MOI.set(model, attr, bridge.nn_index, nn_value)
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::NormOneBridge{T},
    ::Nothing,
) where {T}
    MOI.set.(model, MOI.VariablePrimalStart(), bridge.y, nothing)
    MOI.set(model, attr, bridge.nn_index, nothing)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::NormOneBridge,
)
    nn_primal = MOI.get(model, attr, bridge.nn_index)
    if nn_primal === nothing
        return nothing
    end
    t = (nn_primal[1] + sum(nn_primal)) / 2
    d = length(bridge.y)
    x = (nn_primal[(d+2):end] - nn_primal[2:(d+1)]) / 2
    return vcat(t, x)
end

# Given a_i is dual on y_i - x_i >= 0 and b_i is dual on y_i + x_i >= 0 and c is
# dual on t - sum(y) >= 0, the dual on (t, x) in NormOneCone is
# (u, v) in NormInfinityCone, where v_i = -a_i + b_i and u = c.
function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::NormOneBridge,
)
    nn_dual = MOI.get(model, attr, bridge.nn_index)
    if nn_dual === nothing
        return nothing
    end
    d = length(bridge.y)
    x = nn_dual[(d+2):end] - nn_dual[2:(d+1)]
    return vcat(nn_dual[1], x)
end

# value[1 + i] = nn_dual[1 + d + i] - nn_dual[1 + i]
# and `nn_dual` is nonnegative. By complementarity slackness, only one of each
# `nn_dual` can be nonzero (except if `x = 0`) so we can set
# depending on the sense of `value[1 + i]`.
function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintDualStart,
    bridge::NormOneBridge,
    value,
)
    d = length(bridge.y)
    nn_dual = zeros(eltype(value), 2d + 1)
    nn_dual[1] = value[1]
    for i in eachindex(bridge.y)
        if value[1+i] < 0
            nn_dual[1+i] = -value[1+i]
        else
            nn_dual[1+d+i] = value[1+i]
        end
    end
    MOI.set(model, MOI.ConstraintDualStart(), bridge.nn_index, nn_dual)
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintDualStart,
    bridge::NormOneBridge,
    ::Nothing,
)
    MOI.set(model, MOI.ConstraintDualStart(), bridge.nn_index, nothing)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestTestBigFloat

using Test
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_bigfloat_tests()
    MOI.Test.runtests(
        MOI.Utilities.MockOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{BigFloat}()),
            BigFloat,
        ),
        MOI.Test.Config(BigFloat),
        exclude = [
            # ========================= Expected failures ======================
            # UniversalFallback supports these tests.
            "test_model_copy_to_UnsupportedAttribute",
            "test_model_copy_to_UnsupportedConstraint",
            "test_model_supports_constraint_ScalarAffineFunction_EqualTo",
            "test_model_supports_constraint_VariableIndex_EqualTo",
            "test_model_supports_constraint_VectorOfVariables_Nonnegatives",
        ],
    )
    return
end

end  # module

TestTestBigFloat.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestBenchmarks

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_suite()
    suite = MOI.Benchmarks.suite() do
        return MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    end
    @test length(suite.data) == length(MOI.Benchmarks.BENCHMARKS)
    suite = MOI.Benchmarks.suite(exclude = [r"delete_"]) do
        return MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    end
    # Note: update this value whenever more benchmarks are added to
    # `src/Benchmarks/Benchmarks.jl`.
    @test 6 <= length(suite.data) <= length(MOI.Benchmarks.BENCHMARKS) - 3
    return
end

function test_baseline()
    params = joinpath(@__DIR__, "baseline_params.json")
    baseline = joinpath(@__DIR__, "baseline_baseline.json")
    @test !isfile(params)
    @test !isfile(baseline)
    suite = MOI.Benchmarks.suite() do
        return MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    end
    @test_throws(
        ErrorException("You create a baseline with `create_baseline` first."),
        MOI.Benchmarks.compare_against_baseline(
            suite,
            "baseline";
            directory = @__DIR__,
            samples = 1,
            verbose = true,
        ),
    )
    MOI.Benchmarks.create_baseline(
        suite,
        "baseline";
        directory = @__DIR__,
        samples = 1,
        verbose = true,
    )
    @test isfile(params)
    @test isfile(baseline)
    suite = MOI.Benchmarks.suite() do
        return MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    end
    MOI.Benchmarks.compare_against_baseline(
        suite,
        "baseline";
        directory = @__DIR__,
        samples = 1,
        verbose = true,
    )
    rm(params)
    rm(baseline)
    report = read(joinpath(@__DIR__, "report.txt"), String)
    @test occursin("=> invariant", report)
    rm(joinpath(@__DIR__, "report.txt"))
    return
end

end

TestBenchmarks.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintNormSpecialCase

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_norm_1()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NormOneConeToNormConeBridge,
        """
        variables: t, x1, x2, x3, x4
        [t, x1, x2, x3, x4] in NormOneCone(5)
        """,
        """
        variables: t, x1, x2, x3, x4
        [t, x1, x2, x3, x4] in NormCone(1.0, 5)
        """,
    )
    return
end

function test_runtests_norm_2()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SecondOrderConeToNormConeBridge,
        """
        variables: t, x1, x2, x3, x4
        [t, x1, x2, x3, x4] in SecondOrderCone(5)
        """,
        """
        variables: t, x1, x2, x3, x4
        [t, x1, x2, x3, x4] in NormCone(2.0, 5)
        """,
    )
    return
end

function test_runtests_norm_inf()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NormInfinityConeToNormConeBridge,
        """
        variables: t, x1, x2, x3, x4
        [t, x1, x2, x3, x4] in NormInfinityCone(5)
        """,
        """
        variables: t, x1, x2, x3, x4
        [t, x1, x2, x3, x4] in NormCone(Inf, 5)
        """,
    )
    return
end

function test_modify_MultirowChange()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.NormOneConeToNormCone{Float64}(inner)
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.vectorize(1.0 .* x)
    c = MOI.add_constraint(model, f, MOI.NormOneCone(2))
    @test ≈(
        MOI.get(model, MOI.ConstraintFunction(), c),
        MOI.Utilities.vectorize([1.0 * x[1], 1.0 * x[2]]),
    )
    MOI.modify(model, c, MOI.MultirowChange(x[2], [(2, 2.0)]))
    @test ≈(
        MOI.get(model, MOI.ConstraintFunction(), c),
        MOI.Utilities.vectorize([1.0 * x[1], 2.0 * x[2]]),
    )
    return
end

end  # module

TestConstraintNormSpecialCase.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestSets

using Test
import MathOptInterface as MOI

include("dummy.jl")

"""
    MutLessThan{T<:Real} <: MOI.AbstractScalarSet

A mutable `LessThan`-like set to test `copy` of indicator set
"""
mutable struct MutLessThan{T<:Real} <: MOI.AbstractScalarSet
    upper::T
    MutLessThan(v::T) where {T<:Real} = new{T}(v)
end

Base.copy(mlt::MutLessThan) = MutLessThan(Base.copy(mlt.upper))

function test_sets_equals()
    # By default, `==` redirects to `===`, it works for bits type
    # but not for `BigInt`s. We define functions creating different
    # instances so that `a() !== a()`.
    a() = big(1)
    b() = big(2)
    @test a() !== a()
    @test b() !== b()
    for S in [
        MOI.LessThan,
        MOI.GreaterThan,
        MOI.EqualTo,
        MOI.PowerCone,
        MOI.DualPowerCone,
    ]
        @test S(a()) == S(a())
        @test S(a()) != S(b())
        @test S(b()) == S(b())
        @test S(b()) != S(a())
    end
    for S in [MOI.Interval, MOI.Semicontinuous, MOI.Semiinteger]
        @test S(a(), b()) == S(a(), b())
        @test S(a(), b()) != S(b(), a())
        @test S(a(), b()) != S(b(), b())
        @test S(a(), b()) != S(a(), a())
        @test S(a(), a()) != S(b(), b())
        @test S(a(), a()) == S(a(), a())
    end
    S = MOI.Indicator
    A() = MOI.LessThan(a())
    B() = MOI.LessThan(b())
    @test S{MOI.ACTIVATE_ON_ZERO}(A()) == S{MOI.ACTIVATE_ON_ZERO}(A())
    @test S{MOI.ACTIVATE_ON_ZERO}(A()) != S{MOI.ACTIVATE_ON_ONE}(A())
    @test S{MOI.ACTIVATE_ON_ZERO}(A()) != S{MOI.ACTIVATE_ON_ZERO}(B())
    @test S{MOI.ACTIVATE_ON_ONE}(A()) != S{MOI.ACTIVATE_ON_ONE}(B())
end

function test_sets_sos1_copy()
    s = MOI.SOS1([1.0])
    s_copy = copy(s)
    s_copy.weights[1] = 2.0
    @test s.weights[1] == 1.0
end

function test_sets_sos2_copy()
    s = MOI.SOS2([1.0])
    s_copy = copy(s)
    s_copy.weights[1] = 2.0
    @test s.weights[1] == 1.0
end

function test_sets_indicator_copy()
    s1 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(4.0))
    s2 = MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.GreaterThan(4.0))
    s1_copy = copy(s1)
    s2_copy = copy(s2)
    @test s1_copy isa MOI.Indicator{MOI.ACTIVATE_ON_ONE}
    @test s1 == s1_copy
    @test s2_copy isa MOI.Indicator{MOI.ACTIVATE_ON_ZERO}
    @test s2 == s2_copy
    s3 = MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MutLessThan(4.0))
    s3_copy = copy(s3)
    @test s3.set.upper ≈ 4.0
    s3_copy.set.upper = 5.0
    @test s3.set.upper ≈ 4.0
    @test s3_copy.set.upper ≈ 5.0
end

function test_sets_broadcast()
    model = DummyModelWithAdd()
    x = MOI.add_variables(model, 3)
    cis = MOI.add_constraint.(model, x, MOI.EqualTo(0.0))
    @test cis isa
          Vector{MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}}
    @test length(cis) == 3
end

function test_sets_dimension()
    @test MOI.dimension(MOI.ExponentialCone()) == 3
    @test MOI.dimension(MOI.DualExponentialCone()) == 3
    @test MOI.dimension(MOI.PowerCone(1 / 2)) == 3
    @test MOI.dimension(MOI.DualPowerCone(1 / 2)) == 3
    @test MOI.dimension(MOI.ScaledPositiveSemidefiniteConeTriangle(5)) == 15
    @test MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(5)) == 15
    @test MOI.dimension(MOI.PositiveSemidefiniteConeSquare(5)) == 25
    @test MOI.dimension(MOI.LogDetConeTriangle(5)) == 17
    @test MOI.dimension(MOI.LogDetConeSquare(5)) == 27
    @test MOI.dimension(MOI.RootDetConeTriangle(5)) == 16
    @test MOI.dimension(MOI.RootDetConeSquare(5)) == 26
    @test MOI.dimension(MOI.SOS1([1.0, 2.0])) == 2
    @test MOI.dimension(MOI.SOS2([1.0, 2.0])) == 2
    @test MOI.dimension(
        MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(1.0)),
    ) == 2
    @test MOI.dimension(MOI.Complements(10)) == 10
end

function test_sets_bin_packing_errors()
    @test_throws DomainError MOI.BinPacking(-1.0, [1.0, 2.0])
    @test_throws DomainError MOI.BinPacking(1.0, [1.0, -2.0])
    return
end

function test_sets_DimensionMismatch()
    for (S, min_dimension) in (
        (MOI.Reals, 0),
        (MOI.Zeros, 0),
        (MOI.Nonnegatives, 0),
        (MOI.Nonpositives, 0),
        (MOI.NormInfinityCone, 1),
        (MOI.NormOneCone, 1),
        (MOI.SecondOrderCone, 1),
        (MOI.RotatedSecondOrderCone, 2),
        (MOI.GeometricMeanCone, 2),
        (MOI.Complements, 0),
        (MOI.RelativeEntropyCone, 1),
        (MOI.ScaledPositiveSemidefiniteConeTriangle, 0),
        (MOI.PositiveSemidefiniteConeTriangle, 0),
        (MOI.PositiveSemidefiniteConeSquare, 0),
        (MOI.LogDetConeTriangle, 0),
        (MOI.LogDetConeSquare, 0),
        (MOI.RootDetConeTriangle, 0),
        (MOI.RootDetConeSquare, 0),
        (MOI.AllDifferent, 0),
        (MOI.CountDistinct, 1),
        (MOI.CountGreaterThan, 2),
        (MOI.Cumulative, 1),
        (MOI.Circuit, 0),
    )
        @test_throws DimensionMismatch S(min_dimension - 1)
        @test S(min_dimension) isa S
    end
    @test_throws DimensionMismatch MOI.NormSpectralCone(-1, 0)
    @test_throws DimensionMismatch MOI.NormSpectralCone(0, -1)
    @test MOI.NormSpectralCone(0, 0) isa MOI.NormSpectralCone
    @test_throws DimensionMismatch MOI.NormNuclearCone(-1, 0)
    @test_throws DimensionMismatch MOI.NormNuclearCone(0, -1)
    @test MOI.NormNuclearCone(0, 0) isa MOI.NormNuclearCone
    # Other dimension checks
    @test_throws DimensionMismatch MOI.RelativeEntropyCone(2)
    @test_throws DimensionMismatch MOI.Complements(-3)
    @test_throws DimensionMismatch MOI.Complements(3)
    @test_throws DimensionMismatch MOI.CountBelongs(0, Set([1, 2]))
    @test_throws DimensionMismatch MOI.CountAtLeast(1, [-1, 2], Set([1, 2]))
    @test_throws DimensionMismatch MOI.NormCone(4, 0)
    @test MOI.NormCone(4, 1) isa MOI.NormCone
    @test_throws ArgumentError MOI.NormCone(0.99, 5)
    @test_throws ArgumentError MOI.NormCone(0.5, 5)
    @test_throws ArgumentError MOI.NormCone(-2, 5)
    return
end

function _dual_set_test(set1, set2)
    @test MOI.dual_set(set1) == set2
    @test MOI.dual_set_type(typeof(set1)) == typeof(set2)
    @test MOI.dual_set(set2) == set1
    @test MOI.dual_set_type(typeof(set2)) == typeof(set1)
end

function _self_dual_set_test(set)
    @test MOI.dual_set(set) == set
    @test MOI.dual_set_type(typeof(set)) == typeof(set)
end

function test_sets_dual_nonpositives()
    nonpositives3 = MOI.Nonpositives(3)
    nonpositives4 = MOI.Nonpositives(4)
    _self_dual_set_test(nonpositives3)
    @test MOI.dual_set(nonpositives3) != nonpositives4
    _self_dual_set_test(nonpositives4)
    return
end

function test_sets_dual_nonnegatives()
    nonnegatives3 = MOI.Nonnegatives(3)
    nonnegatives4 = MOI.Nonnegatives(4)
    _self_dual_set_test(nonnegatives3)
    @test MOI.dual_set(nonnegatives3) != nonnegatives4
    _self_dual_set_test(nonnegatives4)
    return
end

function test_sets_dual_zeroreal()
    zeros3 = MOI.Zeros(3)
    zeros4 = MOI.Zeros(4)
    reals3 = MOI.Reals(3)
    reals4 = MOI.Reals(4)
    _dual_set_test(zeros3, reals3)
    @test MOI.dual_set(reals3) != zeros4
    _dual_set_test(zeros4, reals4)
    @test MOI.dual_set(zeros4) != reals3
    return
end

function test_sets_dual_norm()
    norminf2 = MOI.NormInfinityCone(2)
    norminf3 = MOI.NormInfinityCone(3)
    normone2 = MOI.NormOneCone(2)
    normone3 = MOI.NormOneCone(3)
    _dual_set_test(norminf2, normone2)
    _dual_set_test(norminf3, normone3)
    @test MOI.dual_set(norminf2) != normone3
    @test MOI.dual_set(normone2) != norminf3
    return
end

function test_sets_dual_soc()
    soc2 = MOI.SecondOrderCone(2)
    soc3 = MOI.SecondOrderCone(3)
    _self_dual_set_test(soc2)
    @test MOI.dual_set(soc2) != soc3
    _self_dual_set_test(soc3)
    return
end

function test_sets_dual_rsoc()
    rsoc2 = MOI.RotatedSecondOrderCone(2)
    rsoc3 = MOI.RotatedSecondOrderCone(3)
    _self_dual_set_test(rsoc2)
    @test MOI.dual_set(rsoc2) != rsoc3
    _self_dual_set_test(rsoc3)
    return
end

function test_sets_dual_normspectral()
    normspec22 = MOI.NormSpectralCone(2, 2)
    normspec23 = MOI.NormSpectralCone(2, 3)
    normnuc22 = MOI.NormNuclearCone(2, 2)
    normnuc23 = MOI.NormNuclearCone(2, 3)
    _dual_set_test(normspec23, normnuc23)
    _dual_set_test(normspec22, normnuc22)
    @test MOI.dual_set(normspec22) != normnuc23
    @test MOI.dual_set(normnuc22) != normspec23
    return
end

function _test_sets_dual_psdtriangle(psd2, psd3)
    _self_dual_set_test(psd2)
    @test MOI.dual_set(psd2) != psd3
    _self_dual_set_test(psd3)
    return
end

function test_sets_dual_psdtriangle()
    _test_sets_dual_psdtriangle(
        MOI.PositiveSemidefiniteConeTriangle(2),
        MOI.PositiveSemidefiniteConeTriangle(3),
    )
    _test_sets_dual_psdtriangle(
        MOI.ScaledPositiveSemidefiniteConeTriangle(2),
        MOI.ScaledPositiveSemidefiniteConeTriangle(3),
    )
    _test_sets_dual_psdtriangle(
        MOI.HermitianPositiveSemidefiniteConeTriangle(2),
        MOI.HermitianPositiveSemidefiniteConeTriangle(3),
    )
    _test_sets_dual_psdtriangle(
        MOI.Scaled(MOI.HermitianPositiveSemidefiniteConeTriangle(2)),
        MOI.Scaled(MOI.HermitianPositiveSemidefiniteConeTriangle(3)),
    )
    return
end

function test_sets_dual_exponential()
    exp = MOI.ExponentialCone()
    dual_exp = MOI.DualExponentialCone()
    _dual_set_test(exp, dual_exp)
    @test MOI.dual_set(exp) != exp
    _dual_set_test(dual_exp, exp)
    @test MOI.dual_set(dual_exp) != dual_exp
    return
end

function test_sets_dual_power()
    pow03 = MOI.PowerCone(0.3)
    pow04 = MOI.PowerCone(0.4)
    dual_pow03 = MOI.DualPowerCone(0.3)
    _dual_set_test(pow03, dual_pow03)
    @test MOI.dual_set(pow03) != pow03
    _dual_set_test(dual_pow03, pow03)
    @test MOI.dual_set(dual_pow03) != pow04
    @test MOI.dual_set(dual_pow03) != dual_pow03
    return
end

function test_sets_dual_psdsquare()
    s = MOI.PositiveSemidefiniteConeSquare(4)
    err = ErrorException(
        """Dual of `PositiveSemidefiniteConeSquare` is not defined in MathOptInterface.
            For more details see the comments in `src/Bridges/Constraint/bridges/square.jl`.""",
    )
    @test_throws err MOI.dual_set(s)
    @test_throws err MOI.dual_set_type(MOI.PositiveSemidefiniteConeSquare)
end

function test_sets_dual_nonimplemented()
    s = MOI.LogDetConeTriangle(4)
    err = ErrorException("Dual of $s is not implemented.")
    @test_throws err MOI.dual_set(MOI.LogDetConeTriangle(4))
    err = ErrorException("Dual type of $(typeof(s)) is not implemented.")
    @test_throws err MOI.dual_set_type(MOI.LogDetConeTriangle)
end

function test_sets_Interval()
    @test MOI.Interval(MOI.GreaterThan(1.0)) === MOI.Interval(1.0, Inf)
    @test MOI.Interval(MOI.LessThan(2.0)) === MOI.Interval(-Inf, 2.0)
    @test MOI.Interval(MOI.EqualTo(3.0)) === MOI.Interval(3.0, 3.0)

    @test MOI.Interval(MOI.GreaterThan(1.0f0)) === MOI.Interval(1.0f0, Inf32)
    @test MOI.Interval(MOI.LessThan(2.0f0)) === MOI.Interval(-Inf32, 2.0f0)
    @test MOI.Interval(MOI.EqualTo(3.0f0)) === MOI.Interval(3.0f0, 3.0f0)

    @test_throws MethodError MOI.Interval(MOI.GreaterThan(false))
    @test_throws MethodError MOI.Interval(MOI.LessThan(true))
    @test MOI.Interval(MOI.EqualTo(true)) === MOI.Interval(true, true)

    @test_throws MethodError MOI.Interval(MOI.GreaterThan(1))
    @test_throws MethodError MOI.Interval(MOI.LessThan(2))
    @test MOI.Interval(MOI.EqualTo(3)) === MOI.Interval(3, 3)

    @test MOI.Interval(MOI.Interval(1, 2)) == MOI.Interval(1, 2)
end

function test_sets_hyperrectangle()
    @test_throws ArgumentError MOI.HyperRectangle([1.0], [2.0, 3.0])
    return
end

function test_sets_reified()
    set = MOI.Reified(MOI.AllDifferent(2))
    @test MOI.dimension(set) == 3
    @test set == copy(set)
    set = MOI.Reified(MOI.GreaterThan(1))
    @test MOI.dimension(set) == 2
    @test set == copy(set)
    return
end

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
end

function test_interval_promote()
    for S in (MOI.Interval, MOI.Semiinteger, MOI.Semicontinuous)
        set = S(1.0, π)
        @test set isa S{Float64}
        @test set.lower == 1.0
        @test set.upper ≈ π
        set = S(big(1), 2)
        @test set isa S{BigInt}
        @test set.lower == 1
        @test set.upper == 2
    end
    return
end

mutable struct TestSetNoCopy <: MOI.AbstractVectorSet
    data::BigInt
end

function test_set_not_isbitstype_copy()
    @test !isbitstype(TestSetNoCopy)
    @test_throws(
        ErrorException(
            "Base.copy(::$TestSetNoCopy) is not implemented for this set.",
        ),
        copy(TestSetNoCopy(BigInt(2))),
    )
    return
end

function test_deprecated_PositiveSemidefiniteConeTriangle()
    set = MOI.Scaled(MOI.PositiveSemidefiniteConeTriangle(2))
    @test set.side_dimension == 2
    @test !hasfield(typeof(set), :side_dimension)
    return
end

function test_update_dimension()
    @test !MOI.supports_dimension_update(MOI.ExponentialCone)
    for S in (MOI.Reals, MOI.Zeros, MOI.Nonnegatives, MOI.Nonpositives)
        @test MOI.supports_dimension_update(S)
        set = S(1)
        new_set = MOI.update_dimension(set, 2)
        @test MOI.dimension(set) == 1
        @test MOI.dimension(new_set) == 2
    end
    return
end

function test_VectorNonlinearOracle()
    @test_throws(
        DimensionMismatch,
        MOI.VectorNonlinearOracle(;
            dimension = 3,
            l = [0.0, 0.0, 1.0],
            u = [1.0, 0.0],
            eval_f = (ret, x) -> nothing,
            jacobian_structure = Tuple{Int,Int}[],
            eval_jacobian = (ret, x) -> nothing,
        ),
    )
    set = MOI.VectorNonlinearOracle(;
        dimension = 3,
        l = [0.0, 0.0],
        u = [1.0, 0.0],
        eval_f = (ret, x) -> begin
            ret[1] = x[2]^2
            ret[2] = x[3]^2 + x[4]^3 - x[1]
            return
        end,
        jacobian_structure = [(1, 2), (2, 1), (2, 3), (2, 4)],
        eval_jacobian = (ret, x) -> begin
            ret[1] = 2.0 * x[2]
            ret[2] = -1.0
            ret[3] = 2.0 * x[3]
            ret[4] = 3.0 * x[4]^2
            return
        end,
        hessian_lagrangian_structure = [(2, 2), (3, 3), (4, 4)],
        eval_hessian_lagrangian = (ret, x, u) -> begin
            ret[1] = 2.0 * u[1]
            ret[2] = 2.0 * u[2]
            ret[3] = 6.0 * x[4] * u[2]
            return
        end,
    )
    contents = """
    VectorNonlinearOracle{Float64}(;
        dimension = 3,
        l = [0.0, 0.0],
        u = [1.0, 0.0],
        ...,
    )"""
    @test sprint(show, set) == contents
    return
end

end  # module

TestSets.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Test

import LinearAlgebra
import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

#=
We made a bit of a mistake calling the `Test/Test.jl` submodule "Test" because
it conflicts with the standard library "Test" which is imported by MOI.Test.

In present (and previous) versions of Julia, this has never been a problem.
But every module `Foo` has a self-referential global constant `Foo`:
```julia
julia> module Foo end
Main.Foo

julia> Foo.Foo
Main.Foo
```
MOI has the problematic feature that MOI.Test.Test is not self-referential,
and JET.jl appropriately complains with "invalid redefinition of constant
Test."

The work-around is to pull in only a subset of symbols from `Test` (and not Test
ifself) so that `MOI.Test.Test === MOI.Test`.
=#
using Test: @testset, @test, @test_throws, @inferred

# Be wary of adding new fields to this Config struct. Always think: can it be
# achieved a different way?
mutable struct Config{T<:Real}
    atol::T
    rtol::T
    optimal_status::MOI.TerminationStatusCode
    infeasible_status::MOI.TerminationStatusCode
    exclude::Vector{Any}
end

"""
    Config(
        ::Type{T} = Float64;
        atol::Real = Base.rtoldefault(T),
        rtol::Real = Base.rtoldefault(T),
        optimal_status::MOI.TerminationStatusCode = MOI.OPTIMAL,
        infeasible_status::MOI.TerminationStatusCode = MOI.INFEASIBLE,
        exclude::Vector{Any} = Any[],
    ) where {T}

Return an object that is used to configure various tests.

## Configuration arguments

  * `atol::Real = Base.rtoldefault(T)`: Control the absolute tolerance used
    when comparing solutions.
  * `rtol::Real = Base.rtoldefault(T)`: Control the relative tolerance used
    when comparing solutions.
  * `optimal_status = MOI.OPTIMAL`: Set to `MOI.LOCALLY_SOLVED` if the solver
    cannot prove global optimality.
  * `infeasible_status = MOI.INFEASIBLE`: Set to `MOI.LOCALLY_INFEASIBLE` if the
    solver cannot prove global infeasibility.
  * `exclude = Vector{Any}`: Pass attributes or functions to `exclude` to skip
    parts of tests that require certain functionality. Common arguments include:
     - `MOI.delete` to skip deletion-related tests
     - `MOI.optimize!` to skip optimize-related tests
     - `MOI.ConstraintDual` to skip dual-related tests
     - `MOI.VariableName` to skip setting variable names
     - `MOI.ConstraintName` to skip setting constraint names

## Example

For a nonlinear solver that finds local optima and does not support finding
dual variables or constraint names:

```jldoctest
julia> config = MOI.Test.Config(
           Float64;
           optimal_status = MOI.LOCALLY_SOLVED,
           exclude = Any[
               MOI.ConstraintDual,
               MOI.VariableName,
               MOI.ConstraintName,
               MOI.delete,
           ],
       );
```
"""
function Config(
    ::Type{T} = Float64;
    atol::Real = Base.rtoldefault(T),
    rtol::Real = Base.rtoldefault(T),
    optimal_status::MOI.TerminationStatusCode = MOI.OPTIMAL,
    infeasible_status::MOI.TerminationStatusCode = MOI.INFEASIBLE,
    exclude::Vector{Any} = Any[],
) where {T<:Real}
    return Config{T}(atol, rtol, optimal_status, infeasible_status, exclude)
end

function Base.copy(config::Config{T}) where {T}
    return Config{T}(
        config.atol,
        config.rtol,
        config.optimal_status,
        config.infeasible_status,
        copy(config.exclude),
    )
end

"""
    setup_test(::typeof(f), model::MOI.ModelLike, config::Config)

Overload this method to modify `model` before running the test function `f` on
`model` with `config`. You can also modify the fields in `config` (for example, to
loosen the default tolerances).

This function should either return `nothing`, or return a function which, when
called with zero arguments, undoes the setup to return the model to its
previous state. You do not need to undo any modifications to `config`.

This function is most useful when writing new tests of the tests for MOI, but it
can also be used to set test-specific tolerances, etc.

See also: [`runtests`](@ref)

## Example

```julia
function MOI.Test.setup_test(
    ::typeof(MOI.Test.test_linear_VariablePrimalStart_partial),
    mock::MOIU.MockOptimizer,
    ::MOI.Test.Config,
)
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, [1.0, 0.0]),
    )
    mock.eval_variable_constraint_dual = false

    function reset_function()
        mock.eval_variable_constraint_dual = true
        return
    end
    return reset_function
end
```
"""
setup_test(::Any, ::MOI.ModelLike, ::Config{T}) where {T} = nothing

"""
    version_added(::typeof(function_name))

Returns the version of MOI in which the test `function_name` was added.

This method should be implemented for all new tests.

See the `exclude_tests_after` keyword of [`runtests`](@ref) for more details.
"""
version_added(::F) where {F} = v"0.10.5"  # The default for any unlabeled tests.

"""
    runtests(
        model::MOI.ModelLike,
        config::Config;
        include::Vector{Union{String,Regex}} = String[],
        exclude::Vector{Union{String,Regex}} = String[],
        warn_unsupported::Bool = false,
        exclude_tests_after::VersionNumber = v"999.0.0",
        verbose::Bool = false,
        test_module = MathOptInterface.Test,
    )

Run all tests in `test_module`, which defaults to `MathOptInterface.Test`, on `model`.

## Configuration arguments

 * `config` is a [`Test.Config`](@ref) object that can be used to modify the
   behavior of tests.
 * If `include` is not empty, only run tests if an element from `include`
   `occursin` the name of the test.
 * If `exclude` is not empty, skip tests if an element from `exclude` `occursin`
   the name of the test.
 * `exclude` takes priority over `include`.
 * If `warn_unsupported` is `false`, `runtests` will silently skip tests that
   fail with a `MOI.NotAllowedError`, `MOI.UnsupportedError`, or
   `RequirementUnmet` error. (The latter is thrown when an `@requires` statement
   returns `false`.) When `warn_unsupported` is `true`, a warning will be
   printed. For most cases the default behavior, `false`, is what you want,
   since these tests likely test functionality that is not supported by `model`.
   However, it can be useful to run  `warn_unsupported = true` to check you are
   not skipping tests due to a missing `supports_constraint` method or
   equivalent.
 * `exclude_tests_after` is a version number that excludes any tests to MOI
   added after that version number. This is useful for solvers who can declare a
   fixed set of tests, and not cause their tests to break if a new patch of MOI
   is released with a new test.
 * `verbose` is a `Bool` that controls whether the name of the test is printed
   before executing it. This can be helpful when debugging.
 * `test_module` is a `Module` where all the functions starting with `test_`
   are considered as tests.

See also: [`setup_test`](@ref).

## Example

```julia
config = MathOptInterface.Test.Config()
MathOptInterface.Test.runtests(
    model,
    config;
    include = ["test_linear_", r"^test_model_Name\$"],
    exclude = ["VariablePrimalStart"],
    warn_unsupported = true,
    verbose = true,
    exclude_tests_after = v"0.10.5",
)
```
"""
function runtests(
    model::MOI.ModelLike,
    config::Config;
    include::Vector = String[],
    exclude::Vector = String[],
    warn_unsupported::Bool = false,
    verbose::Bool = false,
    exclude_tests_after::VersionNumber = v"999.0.0",
    test_module = @__MODULE__,
)
    tests = filter(names(test_module; all = true)) do name
        return startswith("$name", "test_")
    end
    test_names = string.(tests)
    for ex in exclude
        if ex in test_names && any(t -> ex != t && occursin(ex, t), test_names)
            @warn(
                "The exclude string \"$ex\" is ambiguous because it exactly " *
                "matches a test, but it also partially matches another. Use " *
                "`r\"^$ex\$\"` to exclude the exactly matching test, or " *
                "`r\"$ex.*\"` to exclude all partially matching tests.",
            )
        end
    end
    for name_sym in tests
        name = string(name_sym)
        if !isempty(include) && !any(s -> occursin(s, name), include)
            continue
        elseif !isempty(exclude) && any(s -> occursin(s, name), exclude)
            continue
        end
        if verbose
            @info "Running $name"
        end
        test_function = getfield(test_module, name_sym)
        if version_added(test_function) > exclude_tests_after
            if verbose
                println("  Skipping test because of `exclude_tests_after`")
            end
            continue
        end
        @testset "$(name)" begin  # COV_EXCL_LINE
            c = copy(config)
            tear_down = setup_test(test_function, model, c)
            # Make sure to empty the model before every test.
            MOI.empty!(model)
            try
                test_function(model, c)
            catch err
                if verbose
                    println("  Test errored with $(typeof(err))")
                end
                _error_handler(err, name, warn_unsupported)
            end
            if tear_down !== nothing
                tear_down()
            end
        end
    end
    return
end

"""
    RequirementUnmet(msg::String) <: Exception

An error for throwing in tests to indicate that the model does not support some
requirement expected by the test function.
"""
struct RequirementUnmet <: Exception
    msg::String
end

function Base.show(io::IO, err::RequirementUnmet)
    print(io, "RequirementUnmet: $(err.msg)")
    return
end

"""
    @requires(x)

Check that the condition `x` is `true`. Otherwise, throw an [`RequirementUnmet`](@ref)
error to indicate that the model does not support something required by the test
function.

## Example

```julia
@requires MOI.supports(model, MOI.Silent())
@test MOI.get(model, MOI.Silent())
```
"""
macro requires(x)
    msg = string(x)
    return quote
        if !$(esc(x))
            throw(RequirementUnmet($msg))
        end
    end
end

function _error_handler(
    err::Union{
        MOI.NotAllowedError,
        MOI.ScalarFunctionConstantNotZero,
        MOI.UnsupportedError,
        RequirementUnmet,
    },
    name::String,
    warn_unsupported::Bool,
)
    if warn_unsupported
        @warn("Skipping $(name): $(err)")
    end
    return
end

_error_handler(err, ::String, ::Bool) = rethrow(err)

###
### The following are helpful utilities for writing tests in MOI.Test.
###

"""
    Base.isapprox(x, y, config::Config)

A three argument version of `isapprox` for use in MOI.Test.
"""
function Base.isapprox(x, y, config::Config{T}) where {T}
    return Base.isapprox(x, y; atol = config.atol, rtol = config.rtol)
end

"""
    _supports(config::Config, attribute::MOI.AnyAttribute)

Return `true` if the `attribute` is supported by the `config`.

This is helpful when writing tests.

## Example

```julia
if MOI.Test._supports(config, MOI.Silent)
    @test MOI.get(model, MOI.Silent()) == true
end
```
"""
_supports(config::Config, T::Any)::Bool = !(T in config.exclude)

"""
    _test_model_solution(
        model::MOI.ModelLike,
        config::Config;
        objective_value = nothing,
        variable_primal = nothing,
        constraint_primal = nothing,
        constraint_dual = nothing,
    )

Solve, and then test, various aspects of a model.

First, check that `TerminationStatus == config.optimal_status`.

If `objective_value` is not nothing, check that the attribute `ObjectiveValue()`
is approximately `objective_value`.

If `variable_primal` is not nothing, check that the attribute  `PrimalStatus` is
`MOI.FEASIBLE_POINT`. Then for each `(index, value)` in `variable_primal`, check
that the primal value of the variable `index` is approximately `value`.

If `constraint_primal` is not nothing, check that the attribute  `PrimalStatus`
is `MOI.FEASIBLE_POINT`. Then for each `(index, value)` in `constraint_primal`,
check that the primal value of the constraint `index` is approximately `value`.

Finally, if `config.duals = true`, and if `constraint_dual` is not nothing,
check that the attribute  `DualStatus` is `MOI.FEASIBLE_POINT`. Then for each
`(index, value)` in `constraint_dual`, check that the dual of the constraint
`index` is approximately `value`.

### Example

```julia
MOIU.loadfromstring!(model, \"\"\"
    variables: x
    minobjective: 2.0x + 1.0
    c: x >= 1.0
\"\"\")
x = MOI.get(model, MOI.VariableIndex, "x")
c = MOI.get(
    model,
    MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}},
    "c",
)
_test_model_solution(
    model,
    config;
    objective_value = 3.0,
    variable_primal = [(x, 1.0)],
    constraint_primal = [(c, 1.0)],
    constraint_dual = [(c, 2.0)],
)
```
"""
function _test_model_solution(
    model::MOI.ModelLike,
    config::Config{T};
    objective_value = nothing,
    variable_primal = nothing,
    constraint_primal = nothing,
    constraint_dual = nothing,
) where {T}
    if !_supports(config, MOI.optimize!)
        return
    end
    MOI.optimize!(model)
    # No need to check supports. Everyone _must_ implement ObjectiveValue.
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    if objective_value !== nothing && _supports(config, MOI.ObjectiveValue())
        @test isapprox(
            MOI.get(model, MOI.ObjectiveValue()),
            objective_value,
            config,
        )
    end
    # No need to check supports. Everyone _must_ implement VariablePrimal.
    if variable_primal !== nothing
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        for (index, solution_value) in variable_primal
            @test isapprox(
                MOI.get(model, MOI.VariablePrimal(), index),
                solution_value,
                config,
            )
        end
    end
    if constraint_primal !== nothing && _supports(config, MOI.ConstraintPrimal)
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        for (index, solution_value) in constraint_primal
            @test isapprox(
                MOI.get(model, MOI.ConstraintPrimal(), index),
                solution_value,
                config,
            )
        end
    end
    if constraint_dual !== nothing && _supports(config, MOI.ConstraintDual)
        @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
        for (index, solution_value) in constraint_dual
            @test isapprox(
                MOI.get(model, MOI.ConstraintDual(), index),
                solution_value,
                config,
            )
        end
    end
    return
end

# TODO(odow): The following are helper functions for testing the value types of
#     different attributes. The following attributes are not tested:
# BarrierIterations()
# CallbackNodeStatus()
# ConflictStatus()
# ConstraintBridgingCost()
# ConstraintConflictStatus()
# LazyConstraintCallback()
# NodeCount
# RelativeGap
# SimplexIterations
# VariableBridgingCost()

function _test_attribute_value_type(
    model::MOI.ModelLike,
    attribute::Union{MOI.AbstractModelAttribute,MOI.AbstractOptimizerAttribute},
)
    T = MOI.attribute_value_type(attribute)
    @test MOI.get(model, attribute) isa T
    return
end

function _test_attribute_value_type(
    @nospecialize(model::MOI.ModelLike),
    @nospecialize(attribute::MOI.AbstractConstraintAttribute),
    @nospecialize(ci::MOI.ConstraintIndex),
)
    T = MOI.attribute_value_type(attribute)
    @test @inferred(T, MOI.get(model, attribute, ci)) isa T
    return
end

function _test_attribute_value_type(
    model::MOI.ModelLike,
    attribute::MOI.AbstractVariableAttribute,
    x::MOI.VariableIndex,
)
    T = MOI.attribute_value_type(attribute)
    @test @inferred(T, MOI.get(model, attribute, x)) isa T
    return
end

function _test_variablenames_equal(model, variable_names)
    seen_name = Dict(name => false for name in variable_names)
    for index in MOI.get(model, MOI.ListOfVariableIndices())
        name = MOI.get(model, MOI.VariableName(), index)
        @test haskey(seen_name, name)
        @test seen_name[name] == false
        seen_name[name] = true
    end
    @test all(values(seen_name))
    return
end

function _test_constraintnames_equal(model, constraint_names)
    seen_name = Dict(name => false for name in constraint_names)
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        if F == MOI.VariableIndex
            continue
        end
        for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
            name = MOI.get(model, MOI.ConstraintName(), index)
            @test haskey(seen_name, name)
            @test seen_name[name] == false
            seen_name[name] = true
        end
    end
    @test all(values(seen_name))
    return
end

"""
    util_test_models_equal(
        model1::ModelLike,
        model2::ModelLike,
        variable_names::Vector{String},
        constraint_names::Vector{String},
        single_variable_constraints::Vector{Tuple{String,<:MOI.AbstractScalarSet}}
    )

Test that `model1` and `model2` are identical using `variable_names` as keys for
the variable names and `constraint_names` as keys for the constraint names.

In addition, it checks that there is a VariableIndex-in-Set constraint for each
`(name, set)` tuple in `single_variable_constraints`, where `name` is the name
of the corresponding variable.

!!! warning
    This is not a generic function that works in all cases. It is mainly
    intended for writing tests in which all variables and constraints have
    unique names.
"""
function util_test_models_equal(
    model1::MOI.ModelLike,
    model2::MOI.ModelLike,
    variable_names::Vector{String},
    constraint_names::Vector{String},
    single_variable_constraints::Vector{<:Tuple} = Tuple[],
)
    for (name, set) in single_variable_constraints
        x1 = MOI.get(model1, MOI.VariableIndex, name)
        ci1 = MOI.ConstraintIndex{MOI.VariableIndex,typeof(set)}(x1.value)
        @test MOI.is_valid(model1, ci1)
        @test MOI.get(model1, MOI.ConstraintSet(), ci1) == set
        x2 = MOI.get(model2, MOI.VariableIndex, name)
        ci2 = MOI.ConstraintIndex{MOI.VariableIndex,typeof(set)}(x2.value)
        @test MOI.is_valid(model2, ci2)
        @test MOI.get(model2, MOI.ConstraintSet(), ci2) == set
    end
    _test_variablenames_equal(model1, variable_names)
    _test_variablenames_equal(model2, variable_names)
    _test_constraintnames_equal(model1, constraint_names)
    _test_constraintnames_equal(model2, constraint_names)
    map_2to1 = Dict{MOI.VariableIndex,MOI.VariableIndex}()
    for name in variable_names
        index2 = MOI.get(model2, MOI.VariableIndex, name)
        map_2to1[index2] = MOI.get(model1, MOI.VariableIndex, name)
    end
    for name in constraint_names
        c1 = MOI.get(model1, MOI.ConstraintIndex, name)
        c2 = MOI.get(model2, MOI.ConstraintIndex, name)
        f1 = MOI.get(model1, MOI.ConstraintFunction(), c1)
        f2 = MOI.get(model2, MOI.ConstraintFunction(), c2)
        @test isapprox(f1, MOI.Utilities.map_indices(map_2to1, f2))
        @test MOI.get(model1, MOI.ConstraintSet(), c1) ==
              MOI.get(model2, MOI.ConstraintSet(), c2)
    end
    attrs1 = MOI.get(model1, MOI.ListOfModelAttributesSet())
    attrs2 = MOI.get(model2, MOI.ListOfModelAttributesSet())
    for attr in union(attrs1, attrs2)
        value1 = MOI.get(model1, attr)
        value2 = MOI.get(model2, attr)
        if value1 isa MOI.AbstractFunction
            @test value2 isa MOI.AbstractFunction
            @test isapprox(value1, MOI.Utilities.map_indices(map_2to1, value2))
        else
            @test !(value2 isa MOI.AbstractFunction)
            @test value1 == value2
        end
    end
    return
end

###
### Include all the test files
###

for file in readdir(@__DIR__)
    if startswith(file, "test_") && endswith(file, ".jl")
        include(file)
    end
end

end # module

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintFlipSign

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_GreaterToLess()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.GreaterToLess{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VariableIndex_GreaterThan",
            "test_basic_ScalarAffineFunction_GreaterThan",
            "test_basic_ScalarQuadraticFunction_GreaterThan",
        ],
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100.0, -100.0]),
    )
    MOI.Test.test_linear_LessThan_and_GreaterThan(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.GreaterThan{Float64},
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, 2.0)
        @test MOI.get(bridged_mock, attr, ci) ≈ 2.0
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        ((MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 1),),
    )
    return
end

function test_LessToGreater()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.LessToGreater{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VariableIndex_LessThan",
            "test_basic_ScalarAffineFunction_LessThan",
            "test_basic_ScalarQuadraticFunction_LessThan",
        ],
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [1.0],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [2.0]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [1.0],
        ),
    )
    MOI.Test.test_modification_set_scalaraffine_lessthan(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [1.0],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [0.5]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [0.5],
        ),
    )
    MOI.Test.test_modification_coef_scalaraffine_lessthan(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.LessThan{Float64},
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, 2.0)
        @test MOI.get(bridged_mock, attr, ci) ≈ 2.0
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        ((MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),),
    )
    return
end

function test_NonnegToNonpos()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.NonnegToNonpos{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariables_Nonnegatives",
            "test_basic_VectorAffineFunction_Nonnegatives",
            "test_basic_VectorQuadraticFunction_Nonnegatives",
        ],
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100.0, -100.0]),
    )
    MOI.Test.test_linear_VectorAffineFunction(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.Nonnegatives,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        ((MOI.VectorAffineFunction{Float64}, MOI.Nonpositives, 1),),
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 0.0, 2.0],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonpositives) =>
                [[0.0, -2.0, 0.0]],
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) =>
                [[-3.0, -1.0]],
        )
    MOI.Test.test_conic_linear_VectorOfVariables(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.Nonnegatives,
            }(),
        ),
    )
    func = MOI.get(bridged_mock, MOI.ConstraintFunction(), ci)
    MOI.delete(bridged_mock, func.variables[2])
    new_func = MOI.VectorOfVariables(func.variables[[1, 3]])
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) == new_func
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.Nonnegatives(2)
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, [1.0, 2.0])
        @test MOI.get(bridged_mock, attr, ci) ≈ [1.0, 2.0]
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        ((MOI.VectorAffineFunction{Float64}, MOI.Nonpositives, 0),),
    )
    return
end

function test_NonposToNonneg()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.NonposToNonneg{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariables_Nonpositives",
            "test_basic_VectorAffineFunction_Nonpositives",
            "test_basic_VectorQuadraticFunction_Nonpositives",
        ],
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100.0, -100.0]),
    )
    MOI.Test.test_linear_VectorAffineFunction(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [0.0, 0.0]),
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0, 0.75]),
        ),
    )
    MOI.Test.test_modification_const_vectoraffine_nonpos(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [0.5]),
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [0.25]),
        ),
    )
    MOI.Test.test_modification_multirow_vectoraffine_nonpos(
        bridged_mock,
        config,
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.Nonpositives,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, [1.0, 2.0])
        @test MOI.get(bridged_mock, attr, ci) ≈ [1.0, 2.0]
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        ((MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 0),),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GreaterToLessBridge,
        """
        variables: x
        x >= 1.0
        """,
        """
        variables: x
        -1.0 * x <= -1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GreaterToLessBridge,
        """
        variables: x
        1.5 * x >= 1.0
        """,
        """
        variables: x
        -1.5 * x <= -1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GreaterToLessBridge,
        """
        variables: x
        ScalarNonlinearFunction(1.5 * x) >= 1.0
        """,
        """
        variables: x
        ScalarNonlinearFunction(-(1.5 * x)) <= -1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.LessToGreaterBridge,
        """
        variables: x
        x <= 1.0
        """,
        """
        variables: x
        -1.0 * x >= -1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.LessToGreaterBridge,
        """
        variables: x
        1.5 * x <= 1.0
        """,
        """
        variables: x
        -1.5 * x >= -1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.LessToGreaterBridge,
        """
        variables: x
        ScalarNonlinearFunction(1.5 * x) <= 1.0
        """,
        """
        variables: x
        ScalarNonlinearFunction(-(1.5 * x)) >= -1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NonnegToNonposBridge,
        """
        variables: x
        [x] in Nonnegatives(1)
        """,
        """
        variables: x
        [-1.0 * x + 0.0] in Nonpositives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NonnegToNonposBridge,
        """
        variables: x
        [2.1 * x + -1.0] in Nonnegatives(1)
        """,
        """
        variables: x
        [-2.1 * x + 1.0] in Nonpositives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NonposToNonnegBridge,
        """
        variables: x
        [x] in Nonpositives(1)
        """,
        """
        variables: x
        [-1.0 * x + 0.0] in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NonposToNonnegBridge,
        """
        variables: x
        [2.1 * x + -1.0] in Nonpositives(1)
        """,
        """
        variables: x
        [-2.1 * x + 1.0] in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NonposToNonnegBridge,
        """
        variables: x
        VectorNonlinearFunction([2.1 * x - 1.0]) in Nonpositives(1)
        """,
        """
        variables: x
        VectorNonlinearFunction([-(2.1 * x - 1.0)]) in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GreaterToLessBridge,
        model -> MOI.add_constraint(
            model,
            zero(MOI.ScalarAffineFunction{Float64}),
            MOI.GreaterThan(1.0),
        ),
        model -> MOI.add_constraint(
            model,
            zero(MOI.ScalarAffineFunction{Float64}),
            MOI.LessThan(-1.0),
        ),
    )
    return
end

end  # module

TestConstraintFlipSign.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestFileFormats

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__, all = true)
        if startswith("$(name)", "test_")
            @testset "$name" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_default_fallbacks()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    set = MOI.GreaterThan(0.0)
    c = MOI.add_constraint(model, x, set)
    MOI.write_to_file(model, "tmp.lp")
    dest = MOI.Utilities.Model{Float64}()
    MOI.read_from_file(dest, "tmp.lp")
    x_dest = MOI.get(dest, MOI.VariableIndex, "x")
    @test MOI.get(dest, MOI.ConstraintSet(), typeof(c)(x_dest.value)) == set
    rm("tmp.lp")
    return
end

function test_CBF()
    return include(joinpath(@__DIR__, "CBF", "CBF.jl"))
end

function test_LP()
    return include(joinpath(@__DIR__, "LP", "LP.jl"))
end

function test_MOF()
    return include(joinpath(@__DIR__, "MOF", "MOF.jl"))
end

function test_MPS()
    return include(joinpath(@__DIR__, "MPS", "MPS.jl"))
end

function test_NL()
    return include(joinpath(@__DIR__, "NL", "NL.jl"))
end

function test_SDPA()
    return include(joinpath(@__DIR__, "SDPA", "SDPA.jl"))
end

function test_copying()
    models = [
        MOI.FileFormats.CBF.Model,
        MOI.FileFormats.LP.Model,
        MOI.FileFormats.MOF.Model,
        MOI.FileFormats.MPS.Model,
        MOI.FileFormats.SDPA.Model,
    ]
    for src in models
        model_src = src()
        for dest in models
            model_dest = dest()
            MOI.copy_to(model_dest, model_src)
            @test !isempty(sprint(write, model_dest))
        end
        model_dest = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
        MOI.copy_to(model_dest, model_src)
    end
end

function test_instantiate()
    models = [
        MOI.FileFormats.CBF.Model,
        MOI.FileFormats.LP.Model,
        MOI.FileFormats.MOF.Model,
        MOI.FileFormats.MPS.Model,
        MOI.FileFormats.SDPA.Model,
    ]
    for src in models
        model = MOI.instantiate(src)
        @test model isa src
        bridged = MOI.instantiate(src; with_bridge_type = Float64)
        @test bridged isa MOI.Bridges.LazyBridgeOptimizer
    end
    return
end

function test_compressed_open()
    for cs in [MOI.FileFormats.Bzip2(), MOI.FileFormats.Gzip()]
        for open_type in ["a", "r+", "w+", "a+"]
            @test_throws ArgumentError MOI.FileFormats.compressed_open(
                (x) -> nothing,
                "dummy.gz",
                open_type,
                cs,
            )
        end
    end
end

function test_compression()
    filename = joinpath(@__DIR__, "MPS", "free_integer.mps")
    model = MOI.FileFormats.Model(filename = filename)
    MOI.read_from_file(model, filename)
    filename = joinpath(@__DIR__, "free_integer.mps")
    MOI.write_to_file(model, filename * ".garbage")
    for ext in ["", ".bz2", ".gz"]
        filename_ext = filename * ext
        MOI.write_to_file(model, filename_ext)
        model2 = MOI.FileFormats.Model(filename = filename_ext)
        MOI.read_from_file(model2, filename_ext)
    end

    sleep(1.0)  # Allow time for unlink to happen.
    for ext in ["", ".garbage", ".bz2", ".gz"]
        rm(filename * ext, force = true)
    end
    return
end

function test_Model()
    for (format, model) in [
        (MOI.FileFormats.FORMAT_CBF, MOI.FileFormats.CBF.Model()),
        (MOI.FileFormats.FORMAT_LP, MOI.FileFormats.LP.Model()),
        (MOI.FileFormats.FORMAT_MOF, MOI.FileFormats.MOF.Model()),
        (MOI.FileFormats.FORMAT_MPS, MOI.FileFormats.MPS.Model()),
        (MOI.FileFormats.FORMAT_NL, MOI.FileFormats.NL.Model()),
        (MOI.FileFormats.FORMAT_SDPA, MOI.FileFormats.SDPA.Model()),
    ]
        @test typeof(
            MOI.FileFormats.Model(format = format, filename = "foo.bar"),
        ) == typeof(model)
    end
    @test_throws(
        ErrorException(
            "When `format==FORMAT_AUTOMATIC` you must pass a `filename`.",
        ),
        MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_AUTOMATIC)
    )
    for (ext, model) in [
        (".cbf", MOI.FileFormats.CBF.Model()),
        (".lp", MOI.FileFormats.LP.Model()),
        (".mof.json", MOI.FileFormats.MOF.Model()),
        (".mps", MOI.FileFormats.MPS.Model()),
        (".nl", MOI.FileFormats.NL.Model()),
        (".sdpa", MOI.FileFormats.SDPA.Model()),
    ]
        @test typeof(MOI.FileFormats.Model(filename = "a$(ext)")) ==
              typeof(model)
        @test typeof(MOI.FileFormats.Model(filename = "a$(ext).gz")) ==
              typeof(model)
    end
    @test_throws(
        ErrorException("Unable to automatically detect format of a.b."),
        MOI.FileFormats.Model(filename = "a.b")
    )
end

function test_generic_names()
    # These methods were added to MOI, but then we changed the REW model to not
    # need them.
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(model, 2)
    MOI.set.(model, MOI.VariableName(), x, "x")
    c = MOI.add_constraint.(model, 1.0 .* x, MOI.EqualTo(1.0))
    MOI.set.(model, MOI.ConstraintName(), c, "c")
    c2 = MOI.add_constraint(model, 1.0 * x[2], MOI.LessThan(1.0))
    MOI.set(model, MOI.ConstraintName(), c2, "R2")
    MOI.FileFormats.create_generic_names(model)
    @test MOI.get.(model, MOI.VariableName(), x) == ["C1", "C2"]
    c_name = MOI.get.(model, MOI.ConstraintName(), c)
    c2_name = MOI.get(model, MOI.ConstraintName(), c2)
    names = vcat(c_name, c2_name)
    # The names depend on the order that the constraints are parsed. Either is
    # okay.
    @test names == ["R1", "R2", "R3"] || names == ["R1", "R3", "R2"]
    return
end

function test_unique_names()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(model, 3)
    MOI.set.(model, MOI.VariableName(), x, "x")
    c = MOI.add_constraint.(model, 1.0 .* x, MOI.EqualTo(1.0))
    MOI.set.(model, MOI.ConstraintName(), c, "c")
    MOI.set(model, MOI.ConstraintName(), c[2], "c_1")
    MOI.FileFormats.create_unique_names(model)
    @test MOI.get.(model, MOI.VariableName(), x) == ["x", "x_1", "x_2"]
    @test MOI.get.(model, MOI.ConstraintName(), c) == ["c", "c_1", "c_2"]
    return
end

end

TestFileFormats.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    test_attribute_NumberThreads(model::MOI.AbstractOptimizer, config::Config)

Test that the [`MOI.NumberOfThreads`](@ref) attribute is implemented for
`model`.
"""
function test_attribute_NumberThreads(model::MOI.AbstractOptimizer, ::Config)
    @requires MOI.supports(model, MOI.NumberOfThreads())
    # Get the current value to restore it at the end of the test
    value = MOI.get(model, MOI.NumberOfThreads())
    MOI.set(model, MOI.NumberOfThreads(), 1)
    @test MOI.get(model, MOI.NumberOfThreads()) == 1
    MOI.set(model, MOI.NumberOfThreads(), 3)
    @test MOI.get(model, MOI.NumberOfThreads()) == 3
    MOI.set(model, MOI.NumberOfThreads(), value)
    @test value == MOI.get(model, MOI.NumberOfThreads())
    _test_attribute_value_type(model, MOI.NumberOfThreads())
    return
end
test_attribute_NumberThreads(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_NumberThreads),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOI.set(model, MOI.NumberOfThreads(), nothing)
    return
end

"""
    test_attribute_RawStatusString(model::MOI.AbstractOptimizer, config::Config)

Test that the [`MOI.RawStatusString`](@ref) attribute is implemented for
`model`.
"""
function test_attribute_RawStatusString(
    model::MOI.AbstractOptimizer,
    config::Config,
)
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.RawStatusString)
    MOI.add_variable(model)
    MOI.optimize!(model)
    _test_attribute_value_type(model, MOI.RawStatusString())
    return
end
test_attribute_RawStatusString(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_RawStatusString),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(
                mock,
                MOI.RawStatusString(),
                "Mock solution set by `mock_optimize!`.",
            )
        end,
    )
    return
end

"""
    test_attribute_Silent(model::MOI.AbstractOptimizer, config::Config)

Test that the [`MOI.Silent`](@ref) attribute is implemented for `model`.
"""
function test_attribute_Silent(model::MOI.AbstractOptimizer, ::Config)
    @requires MOI.supports(model, MOI.Silent())
    # Get the current value to restore it at the end of the test
    value = MOI.get(model, MOI.Silent())
    MOI.set(model, MOI.Silent(), !value)
    @test !value == MOI.get(model, MOI.Silent())
    # Check that `set` does not just take `!` of the current value
    MOI.set(model, MOI.Silent(), !value)
    @test !value == MOI.get(model, MOI.Silent())
    MOI.set(model, MOI.Silent(), value)
    @test value == MOI.get(model, MOI.Silent())
    _test_attribute_value_type(model, MOI.Silent())
    return
end
test_attribute_Silent(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_Silent),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOI.set(model, MOI.Silent(), true)
    return
end

"""
    test_attribute_SolverName(model::MOI.AbstractOptimizer, config::Config)

Test that the [`MOI.SolverName`](@ref) attribute is implemented for `model`.
"""
function test_attribute_SolverName(model::MOI.AbstractOptimizer, config::Config)
    if _supports(config, MOI.SolverName)
        _test_attribute_value_type(model, MOI.SolverName())
    end
    return
end
test_attribute_SolverName(::MOI.ModelLike, ::Config) = nothing

"""
    test_attribute_SolverVersion(model::MOI.AbstractOptimizer, config::Config)

Test that the [`MOI.SolverVersion`](@ref) attribute is implemented for `model`.
"""
function test_attribute_SolverVersion(
    model::MOI.AbstractOptimizer,
    config::Config,
)
    if _supports(config, MOI.SolverVersion)
        _test_attribute_value_type(model, MOI.SolverVersion())
    end
    return
end
test_attribute_SolverVersion(::MOI.ModelLike, ::Config) = nothing

"""
    test_attribute_SolveTimeSec(model::MOI.AbstractOptimizer, config::Config)

Test that the [`MOI.SolveTimeSec`](@ref) attribute is implemented for `model`.
"""
function test_attribute_SolveTimeSec(
    model::MOI.AbstractOptimizer,
    config::Config,
)
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.SolveTimeSec)
    MOI.add_variable(model)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.SolveTimeSec()) >= 0.0
    _test_attribute_value_type(model, MOI.SolveTimeSec())
    return
end
test_attribute_SolveTimeSec(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_SolveTimeSec),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOI.set(mock, MOI.SolveTimeSec(), 0.0),
    )
    return
end

"""
    test_attribute_TimeLimitSec(model::MOI.AbstractOptimizer, config::Config)

Test that the [`MOI.TimeLimitSec`](@ref) attribute is implemented for `model`.
"""
function test_attribute_TimeLimitSec(model::MOI.AbstractOptimizer, ::Config)
    @requires MOI.supports(model, MOI.TimeLimitSec())
    function _get_default(model)
        try
            return MOI.get(model, MOI.TimeLimitSec())
        catch err
            @assert err isa MOI.GetAttributeNotAllowed{MOI.TimeLimitSec}
        end
        return
    end
    # Get the current value to restore it at the end of the test
    value = _get_default(model)
    MOI.set(model, MOI.TimeLimitSec(), 0.0)
    @test MOI.get(model, MOI.TimeLimitSec()) == 0.0
    _test_attribute_value_type(model, MOI.TimeLimitSec())
    MOI.set(model, MOI.TimeLimitSec(), 1.0)
    @test MOI.get(model, MOI.TimeLimitSec()) == 1.0
    MOI.set(model, MOI.TimeLimitSec(), nothing)
    reset_value = _get_default(model)
    @test reset_value === nothing || reset_value == value
    MOI.set(model, MOI.TimeLimitSec(), value)
    return
end
test_attribute_TimeLimitSec(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_TimeLimitSec),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOI.set(model, MOI.TimeLimitSec(), nothing)
    return
end

function test_attribute_ObjectiveLimit(model::MOI.AbstractOptimizer, ::Config)
    @requires MOI.supports(model, MOI.ObjectiveLimit())
    # Get the current value to restore it at the end of the test
    value = MOI.get(model, MOI.ObjectiveLimit())
    MOI.set(model, MOI.ObjectiveLimit(), 0.0)
    @test MOI.get(model, MOI.ObjectiveLimit()) == 0.0
    MOI.set(model, MOI.ObjectiveLimit(), nothing)
    @test MOI.get(model, MOI.ObjectiveLimit()) === nothing
    MOI.set(model, MOI.ObjectiveLimit(), 1.0)
    @test MOI.get(model, MOI.ObjectiveLimit()) == 1.0
    MOI.set(model, MOI.ObjectiveLimit(), value)
    @test value == MOI.get(model, MOI.ObjectiveLimit()) # Equality should hold
    _test_attribute_value_type(model, MOI.ObjectiveLimit())
    return
end
test_attribute_ObjectiveLimit(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_ObjectiveLimit),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOI.set(model, MOI.ObjectiveLimit(), nothing)
    return
end

version_added(::typeof(test_attribute_ObjectiveLimit)) = v"1.20.0"

function test_attribute_SolutionLimit(model::MOI.AbstractOptimizer, ::Config)
    @requires MOI.supports(model, MOI.SolutionLimit())
    # Get the current value to restore it at the end of the test
    value = MOI.get(model, MOI.SolutionLimit())
    MOI.set(model, MOI.SolutionLimit(), 3)
    @test MOI.get(model, MOI.SolutionLimit()) == 3
    MOI.set(model, MOI.SolutionLimit(), nothing)
    @test MOI.get(model, MOI.SolutionLimit()) === nothing
    MOI.set(model, MOI.SolutionLimit(), 1)
    @test MOI.get(model, MOI.SolutionLimit()) == 1
    MOI.set(model, MOI.SolutionLimit(), value)
    _test_attribute_value_type(model, MOI.SolutionLimit())
    return
end

test_attribute_SolutionLimit(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_SolutionLimit),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOI.set(model, MOI.SolutionLimit(), nothing)
    return
end

version_added(::typeof(test_attribute_SolutionLimit)) = v"1.21.0"

function test_attribute_NodeLimit(model::MOI.AbstractOptimizer, ::Config)
    @requires MOI.supports(model, MOI.NodeLimit())
    # Get the current value to restore it at the end of the test
    value = MOI.get(model, MOI.NodeLimit())
    MOI.set(model, MOI.NodeLimit(), 3)
    @test MOI.get(model, MOI.NodeLimit()) == 3
    MOI.set(model, MOI.NodeLimit(), nothing)
    @test MOI.get(model, MOI.NodeLimit()) === nothing
    MOI.set(model, MOI.NodeLimit(), 1)
    @test MOI.get(model, MOI.NodeLimit()) == 1
    MOI.set(model, MOI.NodeLimit(), value)
    _test_attribute_value_type(model, MOI.NodeLimit())
    return
end

test_attribute_NodeLimit(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_NodeLimit),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOI.set(model, MOI.NodeLimit(), nothing)
    return
end

version_added(::typeof(test_attribute_NodeLimit)) = v"1.32.0"

"""
    test_attribute_AbsoluteGapTolerance(model::MOI.AbstractOptimizer, config::Config)

Test that the [`MOI.AbsoluteGapTolerance`](@ref) attribute is implemented for
`model`.
"""
function test_attribute_AbsoluteGapTolerance(
    model::MOI.AbstractOptimizer,
    ::Config,
)
    @requires MOI.supports(model, MOI.AbsoluteGapTolerance())
    # Get the current value to restore it at the end of the test
    value = MOI.get(model, MOI.AbsoluteGapTolerance())
    MOI.set(model, MOI.AbsoluteGapTolerance(), 1e-2)
    @test MOI.get(model, MOI.AbsoluteGapTolerance()) == 1e-2
    MOI.set(model, MOI.AbsoluteGapTolerance(), 100.0)
    @test MOI.get(model, MOI.AbsoluteGapTolerance()) == 100.0
    MOI.set(model, MOI.AbsoluteGapTolerance(), value)
    @test value == MOI.get(model, MOI.AbsoluteGapTolerance())
    _test_attribute_value_type(model, MOI.AbsoluteGapTolerance())
    return
end
test_attribute_AbsoluteGapTolerance(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_AbsoluteGapTolerance),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOI.set(model, MOI.AbsoluteGapTolerance(), nothing)
    return
end

version_added(::typeof(test_attribute_AbsoluteGapTolerance)) = v"1.7.0"

"""
    test_attribute_RelativeGapTolerance(model::MOI.AbstractOptimizer, config::Config)

Test that the [`MOI.RelativeGapTolerance`](@ref) attribute is implemented for
`model`.
"""
function test_attribute_RelativeGapTolerance(
    model::MOI.AbstractOptimizer,
    ::Config,
)
    @requires MOI.supports(model, MOI.RelativeGapTolerance())
    # Get the current value to restore it at the end of the test
    value = MOI.get(model, MOI.RelativeGapTolerance())
    MOI.set(model, MOI.RelativeGapTolerance(), 1e-2)
    @test MOI.get(model, MOI.RelativeGapTolerance()) == 1e-2
    MOI.set(model, MOI.RelativeGapTolerance(), 5e-5)
    @test MOI.get(model, MOI.RelativeGapTolerance()) == 5e-5
    MOI.set(model, MOI.RelativeGapTolerance(), value)
    @test value == MOI.get(model, MOI.RelativeGapTolerance())
    _test_attribute_value_type(model, MOI.RelativeGapTolerance())
    return
end
test_attribute_RelativeGapTolerance(::MOI.ModelLike, ::Config) = nothing

function setup_test(
    ::typeof(test_attribute_RelativeGapTolerance),
    model::MOIU.MockOptimizer,
    ::Config,
)
    MOI.set(model, MOI.RelativeGapTolerance(), nothing)
    return
end

version_added(::typeof(test_attribute_RelativeGapTolerance)) = v"1.7.0"

"""
    test_attribute_after_empty(model::MOI.AbstractOptimizer, config::Config)

Test that optimizer attributes such as `Silent` are not cleared by `MOI.empty!`.
"""
function test_attribute_after_empty(model::MOI.AbstractOptimizer, ::Config)
    @requires MOI.supports(model, MOI.Silent())
    current = MOI.get(model, MOI.Silent())
    for value in (true, false)
        MOI.set(model, MOI.Silent(), value)
        @test MOI.get(model, MOI.Silent()) == value
        MOI.empty!(model)
        @test MOI.get(model, MOI.Silent()) == value
    end
    # Make sure to reset the value before leaving this function
    MOI.set(model, MOI.Silent(), current)
    return
end

test_attribute_after_empty(::MOI.ModelLike, ::Config) = nothing

struct _UnsupportedVectorSet2010 <: MOI.AbstractVectorSet end

"""
    test_attribute_unsupported_constraint(model::MOI.ModelLike, config::Config)

Test that `ListOfConstraintIndices` and `NumberOfConstraints` return the correct
values if the constraint type is unsupported.
"""
function test_attribute_unsupported_constraint(model::MOI.ModelLike, ::Config)
    F, S = MOI.VectorOfVariables, _UnsupportedVectorSet2010
    @requires !MOI.supports_constraint(model, F, S)
    @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) ==
          MOI.ConstraintIndex{F,S}[]
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == Int64(0)
    return
end

version_added(::typeof(test_attribute_unsupported_constraint)) = v"1.9.0"

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    CircuitToMILPBridge{T,F} <: Bridges.Constraint.AbstractBridge

`CircuitToMILPBridge` implements the following reformulation:

  * ``x \\in \\textsf{Circuit}(d)`` to the Miller-Tucker-Zemlin formulation of
    the Traveling Salesperson Problem.

## Source node

`CircuitToMILPBridge` supports:

  * `F` in [`MOI.Circuit`](@ref)

where `F` is [`MOI.VectorOfVariables`](@ref) or
[`MOI.VectorAffineFunction{T}`](@ref).

## Target nodes

`CircuitToMILPBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.VariableIndex`](@ref) in [`MOI.Integer`](@ref)
  * [`MOI.VariableIndex`](@ref) in [`MOI.Interval{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.LessThan{T}`](@ref)
"""
mutable struct CircuitToMILPBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
} <: AbstractBridge
    f::F
    z::Vector{MOI.VariableIndex}
    u::Vector{MOI.VariableIndex}
    equal_to::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
    }
    less_than::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
    }
end

const CircuitToMILP{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{CircuitToMILPBridge{T},OT}

function bridge_constraint(
    ::Type{CircuitToMILPBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.Circuit,
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    n = MOI.dimension(s)
    z = [MOI.add_constrained_variable(model, MOI.ZeroOne())[1] for _ in 1:(n^2)]
    Z = reshape(z, n, n)
    equal_to = MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}[]
    for (i, x) in enumerate(MOI.Utilities.eachscalar(f))
        f_1 = MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(one(T), Z[i, j]) for j in 1:n if i != j],
            zero(T),
        )
        push!(equal_to, MOI.add_constraint(model, f_1, MOI.EqualTo(one(T))))
        f_2 = MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(one(T), Z[j, i]) for j in 1:n if i != j],
            zero(T),
        )
        push!(equal_to, MOI.add_constraint(model, f_2, MOI.EqualTo(one(T))))
        f_3 = MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(T(j), Z[i, j]) for j in 1:n if i != j],
            zero(T),
        )
        ci = MOI.Utilities.normalize_and_add_constraint(
            model,
            MOI.Utilities.operate(-, T, x, f_3),
            MOI.EqualTo(zero(T));
            allow_modify_function = true,
        )
        push!(equal_to, ci)
    end

    u = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 2:n]
    MOI.add_constraint.(model, u, MOI.Interval(T(1), T(n - 1)))
    less_than =
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}}[]
    for i in 2:n, j in 2:n
        if i == j
            continue
        end
        f_4 = MOI.ScalarAffineFunction(
            [
                MOI.ScalarAffineTerm(T(1), u[i-1]),   # handle index offset
                MOI.ScalarAffineTerm(T(-1), u[j-1]),  # handle index offset
                MOI.ScalarAffineTerm(T(n - 1), Z[i, j]),
            ],
            zero(T),
        )
        push!(less_than, MOI.add_constraint(model, f_4, MOI.LessThan(T(n - 2))))
    end
    return CircuitToMILPBridge{T,F}(f, z, u, equal_to, less_than)
end

function MOI.supports_constraint(
    ::Type{<:CircuitToMILPBridge{T}},
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}},
    ::Type{MOI.Circuit},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:CircuitToMILPBridge},
)
    return Tuple{Type}[(MOI.ZeroOne,), (MOI.Integer,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:CircuitToMILPBridge{T}},
) where {T}
    return Tuple{Type,Type}[
        (MOI.VariableIndex, MOI.Interval{T}),
        (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}),
        (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:CircuitToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.Circuit},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return CircuitToMILPBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::CircuitToMILPBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::CircuitToMILPBridge,
)
    return MOI.Circuit(MOI.output_dimension(bridge.f))
end

function MOI.delete(model::MOI.ModelLike, bridge::CircuitToMILPBridge)
    MOI.delete.(model, bridge.less_than)
    MOI.delete.(model, bridge.equal_to)
    MOI.delete.(model, bridge.u)
    MOI.delete.(model, bridge.z)
    return
end

# Variables

function MOI.get(bridge::CircuitToMILPBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.z) + length(bridge.u)
end

function MOI.get(
    bridge::CircuitToMILPBridge,
    ::MOI.ListOfVariableIndices,
)::Vector{MOI.VariableIndex}
    return vcat(bridge.z, bridge.u)
end

# z ∈ {0, 1}

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64 where {T}
    return length(bridge.z)
end

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
) where {T}
    return map(bridge.z) do z
        return MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(z.value)
    end
end

# u ∈ ℤ

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Integer},
)::Int64 where {T}
    return length(bridge.u)
end

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Integer},
) where {T}
    return map(bridge.u) do u
        return MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(u.value)
    end
end

# u ∈ [2, n-1]

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Interval{T}},
)::Int64 where {T}
    return length(bridge.u)
end

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Interval{T}},
) where {T}
    return map(bridge.u) do u
        return MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{T}}(u.value)
    end
end

# f(x) = 0

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return length(bridge.equal_to)
end

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return copy(bridge.equal_to)
end

# f(x) ≤ 0

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
)::Int64 where {T}
    return length(bridge.less_than)
end

function MOI.get(
    bridge::CircuitToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
) where {T}
    return copy(bridge.less_than)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    UniversalFallback

The `UniversalFallback` can be applied on a [`MOI.ModelLike`](@ref)
`model` to create the model `UniversalFallback(model)` supporting *any*
constraint and attribute. This allows to have a specialized implementation in
`model` for performance critical constraints and attributes while still
supporting other attributes with a small performance penalty. Note that `model`
is unaware of constraints and attributes stored by `UniversalFallback` so this
is not appropriate if `model` is an optimizer (for this reason,
[`MOI.optimize!`](@ref) has not been implemented). In that case,
optimizer bridges should be used instead.
"""
mutable struct UniversalFallback{MT} <: MOI.ModelLike
    model::MT
    objective::Union{MOI.AbstractScalarFunction,Nothing}
    # See https://github.com/jump-dev/JuMP.jl/issues/1152 and
    # https://github.com/jump-dev/JuMP.jl/issues/2238 for why we use an
    # `OrderedDict`
    single_variable_constraints::OrderedDict{Type,OrderedDict}
    constraints::OrderedDict{Tuple{Type,Type},VectorOfConstraints}
    con_to_name::Dict{MOI.ConstraintIndex,String}
    name_to_con::Union{Dict{String,MOI.ConstraintIndex},Nothing}
    optattr::Dict{MOI.AbstractOptimizerAttribute,Any}
    modattr::Dict{MOI.AbstractModelAttribute,Any}
    varattr::Dict{MOI.AbstractVariableAttribute,Dict{MOI.VariableIndex,Any}}
    conattr::Dict{MOI.AbstractConstraintAttribute,Dict{MOI.ConstraintIndex,Any}}
    function UniversalFallback{MT}(model::MOI.ModelLike) where {MT}
        return new{typeof(model)}(
            model,
            nothing,
            OrderedDict{Type,OrderedDict}(),
            OrderedDict{Tuple{Type,Type},VectorOfConstraints}(),
            Dict{MOI.ConstraintIndex,String}(),
            nothing,
            Dict{MOI.AbstractOptimizerAttribute,Any}(),
            Dict{MOI.AbstractModelAttribute,Any}(),
            Dict{MOI.AbstractVariableAttribute,Dict{MOI.VariableIndex,Any}}(),
            Dict{
                MOI.AbstractConstraintAttribute,
                Dict{MOI.ConstraintIndex,Any},
            }(),
        )
    end
end

function UniversalFallback(model::MOI.ModelLike)
    return UniversalFallback{typeof(model)}(model)
end

function MOI.is_empty(uf::UniversalFallback)
    return MOI.is_empty(uf.model) &&
           uf.objective === nothing &&
           isempty(uf.single_variable_constraints) &&
           isempty(uf.constraints) &&
           isempty(uf.modattr) &&
           isempty(uf.varattr) &&
           isempty(uf.conattr)
end

function MOI.empty!(uf::UniversalFallback)
    MOI.empty!(uf.model)
    uf.objective = nothing
    empty!(uf.single_variable_constraints)
    empty!(uf.constraints)
    empty!(uf.con_to_name)
    uf.name_to_con = nothing
    empty!(uf.modattr)
    empty!(uf.varattr)
    empty!(uf.conattr)
    return
end

function pass_nonvariable_constraints(
    dest::UniversalFallback,
    src::MOI.ModelLike,
    idxmap::IndexMap,
    constraint_types,
)
    supported_types = eltype(constraint_types)[]
    unsupported_types = eltype(constraint_types)[]
    for (F, S) in constraint_types
        if MOI.supports_constraint(dest.model, F, S)
            push!(supported_types, (F, S))
        else
            push!(unsupported_types, (F, S))
        end
    end
    pass_nonvariable_constraints(dest.model, src, idxmap, supported_types)
    pass_nonvariable_constraints_fallback(dest, src, idxmap, unsupported_types)
    return
end

function MOI.copy_to(dest::UniversalFallback, src::MOI.ModelLike)
    return default_copy_to(dest, src)
end

function MOI.supports_incremental_interface(uf::UniversalFallback)
    return MOI.supports_incremental_interface(uf.model)
end

function final_touch(uf::UniversalFallback, index_map)
    return final_touch(uf.model, index_map)
end

"""
    throw_unsupported(uf::UniversalFallback; excluded_attributes = MOI.AnyAttribute[])

Throws [`MOI.UnsupportedAttribute`](@ref) if there are any model,
variable or constraint attribute such that 1) `is_copyable(attr)` returns
`true`, 2) the attribute was set to `uf` but not to `uf.model` and 3) the
attribute is not in `excluded_attributes`.

Suppose `Optimizer` supports only the constraints and attributes
that `OptimizerCache` supports in addition to
[`MOI.VariablePrimalStart`](@ref).
Then, this function can be used in the implementation of the following method:
```julia
function MOI.copy_to(
    dest::Optimizer,
    src::MOI.Utilities.UniversalFallback{OptimizerCache},
)
    attr = MOI.VariablePrimalStart()
    MOI.Utilities.throw_unsupported(
        src,
        excluded_attributes = MOI.AnyAttribute[attr],
    )
    index_map = MOI.copy_to(dest, src.model)
    if attr in MOI.get(src, MOI.ListOfModelAttributesSet())
        for vi_src in MOI.get(src, MOI.ListOfVariableIndices())
            vi_dest = index_map[vi_src]
            value = MOI.get(src, attr, vi_src)
            MOI.set(dest, attr, vi_dest, value)
        end
    end
    return index_map
end
```
"""
function throw_unsupported(
    uf::UniversalFallback;
    excluded_attributes = MOI.AnyAttribute[],
)
    for attr in keys(uf.modattr)
        if !(attr in excluded_attributes)
            MOI.throw(MOI.UnsupportedAttribute(attr))
        end
    end
    for (attr, val) in uf.varattr
        if !isempty(val) && !(attr in excluded_attributes)
            MOI.throw(MOI.UnsupportedAttribute(attr))
        end
    end
    for (attr, val) in uf.conattr
        if !isempty(val) && !(attr in excluded_attributes)
            MOI.throw(MOI.UnsupportedAttribute(attr))
        end
    end
    for (S, val) in uf.single_variable_constraints
        if !isempty(val)
            throw(MOI.UnsupportedConstraint{MOI.VariableIndex,S}())
        end
    end
    for ((F, S), val) in uf.constraints
        if !MOI.is_empty(val)
            throw(MOI.UnsupportedConstraint{F,S}())
        end
    end
    return
end

# References
function MOI.is_valid(uf::UniversalFallback, vi::MOI.VariableIndex)
    return MOI.is_valid(uf.model, vi)
end

function MOI.is_valid(
    uf::UniversalFallback,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S}
    if MOI.supports_constraint(uf.model, MOI.VariableIndex, S)
        return MOI.is_valid(uf.model, ci)
    end
    return haskey(uf.single_variable_constraints, S) &&
           haskey(uf.single_variable_constraints[S], ci)
end

function MOI.is_valid(
    uf::UniversalFallback,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    if !MOI.supports_constraint(uf.model, F, S) &&
       !haskey(uf.constraints, (F, S))
        return false
    end
    return MOI.is_valid(constraints(uf, ci), ci)
end

function _delete(
    uf::UniversalFallback,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S}
    if MOI.supports_constraint(uf.model, MOI.VariableIndex, S)
        MOI.delete(uf.model, ci)
    else
        MOI.is_valid(uf, ci) || throw(MOI.InvalidIndex(ci))
        delete!(uf.single_variable_constraints[S], ci)
    end
    return
end

function _delete(uf::UniversalFallback, ci::MOI.ConstraintIndex)
    MOI.delete(constraints(uf, ci), ci)
    return
end

function MOI.delete(
    uf::UniversalFallback,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    _delete(uf, ci)
    if !MOI.supports_constraint(uf.model, F, S)
        delete!(uf.con_to_name, ci)
        uf.name_to_con = nothing
    end
    for d in values(uf.conattr)
        delete!(d, ci)
    end
    return
end

function _remove_variable(
    uf::UniversalFallback,
    constraints::OrderedDict{<:MOI.ConstraintIndex{MOI.VariableIndex}},
    vi::MOI.VariableIndex,
)
    MOI.delete(uf, [ci for ci in keys(constraints) if ci.value == vi.value])
    return
end

function MOI.delete(uf::UniversalFallback, vi::MOI.VariableIndex)
    vis = [vi]
    for constraints in values(uf.constraints)
        _throw_if_cannot_delete(constraints, vis, vi)
    end
    MOI.delete(uf.model, vi)
    for d in values(uf.varattr)
        delete!(d, vi)
    end
    if uf.objective !== nothing
        uf.objective = remove_variable(something(uf.objective), vi)
    end
    for constraints in values(uf.single_variable_constraints)
        _remove_variable(uf, constraints, vi)
    end
    for constraints in values(uf.constraints)
        _deleted_constraints(constraints, vi) do ci
            delete!(uf.con_to_name, ci)
            uf.name_to_con = nothing
            for d in values(uf.conattr)
                delete!(d, ci)
            end
        end
    end
    return
end

function MOI.delete(uf::UniversalFallback, vis::Vector{MOI.VariableIndex})
    fast_in_vis = Set(vis)
    for constraints in values(uf.constraints)
        _throw_if_cannot_delete(constraints, vis, fast_in_vis)
    end
    MOI.delete(uf.model, vis)
    for d in values(uf.varattr)
        for vi in vis
            delete!(d, vi)
        end
    end
    if uf.objective !== nothing
        uf.objective = remove_variable(something(uf.objective), vis)
    end
    for constraints in values(uf.single_variable_constraints)
        for vi in vis
            _remove_variable(uf, constraints, vi)
        end
    end
    for constraints in values(uf.constraints)
        _deleted_constraints(constraints, vis) do ci
            delete!(uf.con_to_name, ci)
            uf.name_to_con = nothing
            for d in values(uf.conattr)
                delete!(d, ci)
            end
        end
    end
    return
end

# Attributes
function _get(uf::UniversalFallback, attr::MOI.AbstractOptimizerAttribute)
    return get(uf.optattr, attr, nothing)
end

function _get(uf::UniversalFallback, attr::MOI.AbstractModelAttribute)
    return get(uf.modattr, attr, nothing)
end

function _get(
    uf::UniversalFallback,
    attr::MOI.AbstractVariableAttribute,
    vi::MOI.VariableIndex,
)
    attribute_dict = get(uf.varattr, attr, nothing)
    if attribute_dict === nothing
        # It means the attribute is not set to any variable so in particular, it
        # is not set for `vi`
        return
    end
    return get(attribute_dict, vi, nothing)
end

function _get(
    uf::UniversalFallback,
    attr::MOI.AbstractConstraintAttribute,
    ci::MOI.ConstraintIndex,
)
    attribute_dict = get(uf.conattr, attr, nothing)
    if attribute_dict === nothing
        # It means the attribute is not set to any constraint so in particular,
        # it is not set for `ci`
        return
    end
    return get(attribute_dict, ci, nothing)
end

function _get(
    uf::UniversalFallback,
    attr::MOI.CanonicalConstraintFunction,
    ci::MOI.ConstraintIndex,
)
    return MOI.get_fallback(uf, attr, ci)
end

function _model_supports_attribute(model, attr, index...)
    return !MOI.is_copyable(attr) || MOI.supports(model, attr, index...)
end

function _model_supports_attribute(
    model,
    attr,
    index::Type{MOI.ConstraintIndex{F,S}},
) where {F,S}
    if !MOI.supports_constraint(model, F, S)
        return false
    end
    return !MOI.is_copyable(attr) || MOI.supports(model, attr, index)
end

function MOI.get(
    uf::UniversalFallback,
    attr::Union{MOI.AbstractOptimizerAttribute,MOI.AbstractModelAttribute},
)
    if _model_supports_attribute(uf.model, attr)
        return MOI.get(uf.model, attr)
    end
    return _get(uf, attr)
end

function MOI.get(
    uf::UniversalFallback,
    attr::MOI.AbstractConstraintAttribute,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    if _model_supports_attribute(uf.model, attr, MOI.ConstraintIndex{F,S})
        return MOI.get(uf.model, attr, ci)
    end
    return _get(uf, attr, ci)
end

function MOI.get(
    uf::UniversalFallback,
    attr::MOI.AbstractVariableAttribute,
    vi::MOI.VariableIndex,
)
    if _model_supports_attribute(uf.model, attr, MOI.VariableIndex)
        return MOI.get(uf.model, attr, vi)
    end
    return _get(uf, attr, vi)
end

function MOI.get(
    uf::UniversalFallback,
    attr::MOI.NumberOfConstraints{MOI.VariableIndex,S},
)::Int64 where {S}
    if MOI.supports_constraint(uf.model, MOI.VariableIndex, S)
        return MOI.get(uf.model, attr)
    elseif !haskey(uf.single_variable_constraints, S)
        return 0
    else
        return length(uf.single_variable_constraints[S])
    end
end

function MOI.get(
    uf::UniversalFallback,
    attr::MOI.NumberOfConstraints{F,S},
)::Int64 where {F,S}
    return MOI.get(constraints(uf, F, S), attr)
end

function MOI.get(
    uf::UniversalFallback,
    listattr::MOI.ListOfConstraintIndices{MOI.VariableIndex,S},
) where {S}
    F = MOI.VariableIndex
    if MOI.supports_constraint(uf.model, F, S)
        return MOI.get(uf.model, listattr)
    end
    indices = get(
        uf.single_variable_constraints,
        S,
        OrderedDict{MOI.ConstraintIndex{F,S},S}(),
    )
    return collect(keys(indices))
end

function MOI.get(
    uf::UniversalFallback,
    listattr::MOI.ListOfConstraintIndices{F,S},
) where {F,S}
    return MOI.get(constraints(uf, F, S), listattr)
end

function MOI.get(
    uf::UniversalFallback,
    listattr::MOI.ListOfConstraintTypesPresent,
)
    list = MOI.get(uf.model, listattr)
    for (S, constraints) in uf.single_variable_constraints
        if !isempty(constraints)
            push!(list, (MOI.VariableIndex, S))
        end
    end
    for (FS, constraints) in uf.constraints
        if !MOI.is_empty(constraints)
            push!(list, FS)
        end
    end
    return list
end

function MOI.get(
    uf::UniversalFallback,
    listattr::MOI.ListOfOptimizerAttributesSet,
)
    list = MOI.get(uf.model, listattr)
    for attr in keys(uf.optattr)
        push!(list, attr)
    end
    return list
end

function MOI.get(uf::UniversalFallback, listattr::MOI.ListOfModelAttributesSet)
    list = MOI.get(uf.model, listattr)
    if uf.objective !== nothing
        push!(list, MOI.ObjectiveFunction{typeof(uf.objective)}())
    end
    for attr in keys(uf.modattr)
        push!(list, attr)
    end
    return list
end

function MOI.get(
    uf::UniversalFallback,
    listattr::MOI.ListOfVariableAttributesSet,
)
    list = MOI.get(uf.model, listattr)
    for (attr, dict) in uf.varattr
        if !isempty(dict)
            push!(list, attr)
        end
    end
    return list
end

function MOI.get(
    uf::UniversalFallback,
    listattr::MOI.ListOfConstraintAttributesSet{F,S},
) where {F,S}
    list = MOI.get(uf.model, listattr)
    for (attr, dict) in uf.conattr
        if any(Base.Fix2(isa, MOI.ConstraintIndex{F,S}), keys(dict))
            push!(list, attr)
        end
    end
    # ConstraintName isn't stored in conattr, but in the .con_to_name dictionary
    # instead. Only add it to `list` if it isn't already, and if a constraint
    # of the right type has a name set. This avoids, for example, returning
    # ConstraintName for VariableIndex constraints.
    if !(MOI.ConstraintName() in list)
        if any(k -> k isa MOI.ConstraintIndex{F,S}, keys(uf.con_to_name))
            push!(list, MOI.ConstraintName())
        end
    end
    return list
end

# Objective
function MOI.set(
    uf::UniversalFallback,
    attr::MOI.ObjectiveSense,
    sense::MOI.OptimizationSense,
)
    if sense == MOI.FEASIBILITY_SENSE
        uf.objective = nothing
    end
    MOI.set(uf.model, attr, sense)
    return
end

function MOI.get(uf::UniversalFallback, attr::MOI.ObjectiveFunctionType)
    if uf.objective === nothing
        return MOI.get(uf.model, attr)
    end
    return typeof(uf.objective)
end

function MOI.get(
    uf::UniversalFallback,
    attr::MOI.ObjectiveFunction{F},
)::F where {F}
    if uf.objective === nothing
        return MOI.get(uf.model, attr)
    end
    return something(uf.objective)
end

function MOI.set(
    uf::UniversalFallback,
    attr::MOI.ObjectiveFunction,
    func::MOI.AbstractScalarFunction,
)
    if MOI.supports(uf.model, attr)
        MOI.set(uf.model, attr, func)
        # Clear any fallback objective
        uf.objective = nothing
    else
        uf.objective = copy(func)
        # Clear any `model` objective
        sense = MOI.get(uf.model, MOI.ObjectiveSense())
        MOI.set(uf.model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
        MOI.set(uf.model, MOI.ObjectiveSense(), sense)
    end
    return
end

function MOI.modify(
    uf::UniversalFallback,
    obj::MOI.ObjectiveFunction,
    change::MOI.AbstractFunctionModification,
)
    if uf.objective === nothing
        MOI.modify(uf.model, obj, change)
    else
        uf.objective = modify_function(something(uf.objective), change)
    end
    return
end

# Name
# The names of constraints not supported by `uf.model` need to be handled
function MOI.set(
    uf::UniversalFallback,
    attr::MOI.ConstraintName,
    ci::MOI.ConstraintIndex{F,S},
    name::String,
) where {F,S}
    if MOI.supports_constraint(uf.model, F, S)
        MOI.set(uf.model, attr, ci, name)
    else
        uf.con_to_name[ci] = name
        uf.name_to_con = nothing # Invalidate the name map.
    end
    return
end

function MOI.supports(
    ::UniversalFallback,
    ::MOI.ConstraintName,
    ::Type{<:MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet}},
)
    return throw(MOI.VariableIndexConstraintNameError())
end

function MOI.set(
    ::UniversalFallback,
    ::MOI.ConstraintName,
    ::MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet},
    ::String,
)
    return throw(MOI.VariableIndexConstraintNameError())
end

function MOI.get(
    uf::UniversalFallback,
    attr::MOI.ConstraintName,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    if MOI.supports_constraint(uf.model, F, S)
        return MOI.get(uf.model, attr, ci)
    end
    return get(uf.con_to_name, ci, "")
end

function MOI.get(uf::UniversalFallback, ::Type{MOI.VariableIndex}, name::String)
    return MOI.get(uf.model, MOI.VariableIndex, name)
end

check_type_and_multiple_names(::Type, ::Nothing, ::Nothing, name) = nothing

function check_type_and_multiple_names(
    # >: Needed for MathOptInterface.jl#2159.
    ::Type{>:T},
    value::T,
    ::Nothing,
    name,
) where {T<:MOI.Index}
    return value
end

check_type_and_multiple_names(::Type, ::Any, ::Nothing, name) = nothing

function check_type_and_multiple_names(
    # >: Needed for MathOptInterface.jl#2159.
    ::Type{>:T},
    ::Nothing,
    value::T,
    name,
) where {T<:MOI.Index}
    return value
end

check_type_and_multiple_names(::Type, ::Nothing, ::Any, name) = nothing

function check_type_and_multiple_names(::Type{T}, ::Any, ::Any, name) where {T}
    return throw_multiple_name_error(T, name)
end

function MOI.get(
    uf::UniversalFallback,
    ::Type{MOI.ConstraintIndex{F,S}},
    name::String,
) where {F,S}
    if uf.name_to_con === nothing
        uf.name_to_con = build_name_to_con_map(uf.con_to_name)
    end
    ci = if MOI.supports_constraint(uf.model, F, S)
        MOI.get(uf.model, MOI.ConstraintIndex{F,S}, name)
    else
        # There is no `F`-in-`S` constraint in `b.model`, `ci` is only queried
        # to check for duplicate names.
        MOI.get(uf.model, MOI.ConstraintIndex, name)
    end
    ci_uf = get(something(uf.name_to_con), name, nothing)
    throw_if_multiple_with_name(ci_uf, name)
    c = check_type_and_multiple_names(MOI.ConstraintIndex{F,S}, ci_uf, ci, name)
    return c
end

function MOI.get(
    uf::UniversalFallback,
    ::Type{MOI.ConstraintIndex},
    name::String,
)
    if uf.name_to_con === nothing
        uf.name_to_con = build_name_to_con_map(uf.con_to_name)
    end
    ci_uf = get(something(uf.name_to_con), name, nothing)
    throw_if_multiple_with_name(ci_uf, name)
    return check_type_and_multiple_names(
        MOI.ConstraintIndex,
        ci_uf,
        MOI.get(uf.model, MOI.ConstraintIndex, name),
        name,
    )
end

_set_or_delete(dict, key, value) = (dict[key] = value)
_set_or_delete(dict, key, ::Nothing) = delete!(dict, key)

function _set(
    uf::UniversalFallback,
    attr::MOI.AbstractOptimizerAttribute,
    value,
)
    _set_or_delete(uf.optattr, attr, value)
    return
end

function _set(uf::UniversalFallback, attr::MOI.AbstractModelAttribute, value)
    _set_or_delete(uf.modattr, attr, value)
    return
end

function _set(
    uf::UniversalFallback,
    attr::MOI.AbstractVariableAttribute,
    vi::MOI.VariableIndex,
    value,
)
    if !haskey(uf.varattr, attr)
        uf.varattr[attr] = Dict{MOI.VariableIndex,Any}()
    end
    _set_or_delete(uf.varattr[attr], vi, value)
    return
end

function _set(
    uf::UniversalFallback,
    attr::MOI.AbstractConstraintAttribute,
    ci::MOI.ConstraintIndex,
    value,
)
    if !haskey(uf.conattr, attr)
        uf.conattr[attr] = Dict{MOI.ConstraintIndex,Any}()
    end
    _set_or_delete(uf.conattr[attr], ci, value)
    return
end

function MOI.supports(
    ::UniversalFallback,
    ::Union{MOI.AbstractModelAttribute,MOI.AbstractOptimizerAttribute},
)
    return true
end

function MOI.set(
    uf::UniversalFallback,
    attr::Union{MOI.AbstractOptimizerAttribute,MOI.AbstractModelAttribute},
    value,
)
    if MOI.supports(uf.model, attr)
        MOI.set(uf.model, attr, value)
    else
        _set(uf, attr, value)
    end
    return
end

function MOI.supports(
    ::UniversalFallback,
    ::Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
    ::Type{<:MOI.Index},
)
    return true
end

function MOI.set(
    uf::UniversalFallback,
    attr::MOI.AbstractVariableAttribute,
    vi::MOI.VariableIndex,
    value,
)
    if MOI.supports(uf.model, attr, MOI.VariableIndex)
        MOI.set(uf.model, attr, vi, value)
    else
        _set(uf, attr, vi, value)
    end
    return
end

function MOI.set(
    uf::UniversalFallback,
    attr::MOI.AbstractConstraintAttribute,
    ci::MOI.ConstraintIndex{F,S},
    value,
) where {F,S}
    if _model_supports_attribute(uf.model, attr, MOI.ConstraintIndex{F,S})
        MOI.set(uf.model, attr, ci, value)
    else
        _set(uf, attr, ci, value)
    end
    return
end

# Constraints
function MOI.supports_constraint(
    ::UniversalFallback,
    ::Type{<:MOI.AbstractFunction},
    ::Type{<:MOI.AbstractSet},
)
    return true
end

function constraints(
    uf::UniversalFallback,
    ::Type{F},
    ::Type{S},
    getter::Function = get,
) where {F,S}
    if MOI.supports_constraint(uf.model, F, S)
        return uf.model
    end
    return getter(uf.constraints, (F, S)) do
        return VectorOfConstraints{F,S}()
    end::VectorOfConstraints{F,S}
end

function constraints(
    uf::UniversalFallback,
    ::MOI.ConstraintIndex{F,S},
) where {F,S}
    return constraints(uf, F, S)
end

function MOI.add_constraint(
    uf::UniversalFallback,
    func::MOI.VariableIndex,
    set::S,
) where {S<:MOI.AbstractScalarSet}
    if MOI.supports_constraint(uf.model, MOI.VariableIndex, S)
        return MOI.add_constraint(uf.model, func, set)
    end
    constraints = get!(
        uf.single_variable_constraints,
        S,
    ) do
        return OrderedDict{
            MOI.ConstraintIndex{MOI.VariableIndex,S},
            S,
        }()
    end::OrderedDict{MOI.ConstraintIndex{MOI.VariableIndex,S},S}
    ci = MOI.ConstraintIndex{MOI.VariableIndex,S}(func.value)
    constraints[ci] = set
    return ci
end

function MOI.add_constraint(
    uf::UniversalFallback,
    func::MOI.AbstractFunction,
    set::MOI.AbstractSet,
)
    return MOI.add_constraint(
        constraints(uf, typeof(func), typeof(set), get!),
        func,
        set,
    )
end

function MOI.modify(
    uf::UniversalFallback,
    ci::MOI.ConstraintIndex,
    change::MOI.AbstractFunctionModification,
)
    MOI.modify(constraints(uf, ci), ci, change)
    return
end

function MOI.get(
    uf::UniversalFallback,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    ci::MOI.ConstraintIndex,
)
    return MOI.get(constraints(uf, ci), attr, ci)
end

function MOI.set(
    uf::UniversalFallback,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    ci::MOI.ConstraintIndex,
    func_or_set,
)
    return MOI.set(constraints(uf, ci), attr, ci, func_or_set)
end

function MOI.get(
    uf::UniversalFallback,
    ::MOI.ConstraintFunction,
    ci::MOI.ConstraintIndex{MOI.VariableIndex},
)
    MOI.throw_if_not_valid(uf, ci)
    return MOI.VariableIndex(ci.value)
end

function MOI.get(
    uf::UniversalFallback,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S}
    if MOI.supports_constraint(uf.model, MOI.VariableIndex, S)
        return MOI.get(uf.model, MOI.ConstraintSet(), ci)
    end
    MOI.throw_if_not_valid(uf, ci)
    return uf.single_variable_constraints[S][ci]
end

function MOI.set(
    ::UniversalFallback,
    ::MOI.ConstraintFunction,
    ::MOI.ConstraintIndex{MOI.VariableIndex},
    ::MOI.VariableIndex,
)
    return throw(MOI.SettingVariableIndexNotAllowed())
end

function MOI.set(
    uf::UniversalFallback,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
    set::S,
) where {S}
    if MOI.supports_constraint(uf.model, MOI.VariableIndex, S)
        MOI.set(uf.model, MOI.ConstraintSet(), ci, set)
    else
        MOI.throw_if_not_valid(uf, ci)
        uf.single_variable_constraints[S][ci] = set
    end
    return
end

# Variables

MOI.add_variable(uf::UniversalFallback) = MOI.add_variable(uf.model)

MOI.add_variables(uf::UniversalFallback, n) = MOI.add_variables(uf.model, n)

function MOI.get(
    uf::UniversalFallback,
    attr::MOI.ListOfVariablesWithAttributeSet,
)
    if _model_supports_attribute(uf.model, attr.attr, MOI.VariableIndex)
        return MOI.get(uf.model, attr)
    end
    dict = get(uf.varattr, attr.attr, nothing)
    if dict === nothing
        return MOI.VariableIndex[]
    end
    return collect(keys(dict))
end

_constraint_attribute_dict(uf, ::MOI.ConstraintName) = uf.con_to_name
_constraint_attribute_dict(uf, attr) = get(uf.conattr, attr, nothing)

function MOI.get(
    uf::UniversalFallback,
    attr::MOI.ListOfConstraintsWithAttributeSet{F,S},
) where {F,S}
    if _model_supports_attribute(uf.model, attr.attr, MOI.ConstraintIndex{F,S})
        return MOI.get(uf.model, attr)
    end
    dict = _constraint_attribute_dict(uf, attr.attr)
    if dict === nothing
        return MOI.ConstraintIndex{F,S}[]
    end
    indices = collect(keys(dict))
    return filter(Base.Fix2(isa, MOI.ConstraintIndex{F,S}), indices)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestObjectiveConversion

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

struct VariableDifference <: MOI.AbstractScalarFunction
    x::MOI.VariableIndex
    y::MOI.VariableIndex
end

function MOI.Utilities.is_coefficient_type(
    ::Type{VariableDifference},
    ::Type{T},
) where {T}
    return true
end

function MOI.Bridges.Constraint.conversion_cost(
    ::Type{<:MOI.ScalarAffineFunction},
    ::Type{VariableDifference},
)
    return 1.0
end

function MOI.convert(
    ::Type{MOI.ScalarAffineFunction{T}},
    f::VariableDifference,
) where {T}
    return one(T) * f.x - one(T) * f.y
end

function test_variable_difference(T = Float64)
    F = MOI.ScalarAffineFunction{T}
    B = MOI.Bridges.Objective.FunctionConversionBridge{T,F}
    inner = MOI.Utilities.Model{T}()
    model = MOI.Bridges.Objective.SingleBridgeOptimizer{B}(inner)
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    g = VariableDifference(x, y)
    G = typeof(g)
    MOI.set(model, MOI.ObjectiveFunction{G}(), g)
    f = one(T) * x - one(T) * y
    @test MOI.get(inner, MOI.ObjectiveFunction{F}()) ≈ f
    return
end

end  # module

TestObjectiveConversion.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    mutable struct MatrixOfConstraints{T,AT,BT,ST} <: MOI.ModelLike
        coefficients::AT
        constants::BT
        sets::ST
        caches::Vector{Any}
        are_indices_mapped::Vector{BitSet}
        final_touch::Bool
    end

Represent `ScalarAffineFunction` and `VectorAffinefunction` constraints in a
matrix form where the linear coefficients of the functions are stored in the
`coefficients` field, the constants of the functions or sets are stored in the
`constants` field. Additional information about the sets are stored in the
`sets` field.

This model can only be used as the `constraints` field of a
`MOI.Utilities.AbstractModel`.

When the constraints are added, they are stored in the `caches` field. They are
only loaded in the `coefficients` and `constants` fields once
`MOI.Utilities.final_touch` is called. For this reason, `MatrixOfConstraints`
should not be used by an incremental interface. Use `MOI.copy_to` instead.

The constraints can be added in two different ways:

1) With `add_constraint`, in which case a canonicalized copy of the function is
   stored in `caches`.
2) With `pass_nonvariable_constraints`, in which case the functions and sets are
   stored themselves in `caches` without mapping the variable indices. The
   corresponding index in `caches` is added in `are_indices_mapped`. This avoids
   doing a copy of the function in case the getter of
   `CanonicalConstraintFunction` does not make a copy for the source model,
   for example, this is the case of `VectorOfConstraints`.

We illustrate this with an example. Suppose a model is copied from a
`src::MOI.Utilities.Model` to a bridged model with a `MatrixOfConstraints`. For
all the types that are not bridged, the constraints will be copied with
`pass_nonvariable_constraints`. Hence the functions stored in `caches` are
exactly the same as the ones stored in `src`. This is ok since this is only
during the `copy_to` operation during which `src` cannot be modified. On the
other hand, for the types that are bridged, the functions added may contain
duplicates even if the functions did not contain duplicates in `src` so
duplicates are removed with `MOI.Utilities.canonical`.

## Interface

The `.coefficients::AT` type must implement:
 * `AT()`
 * `MOI.empty(::AT)!`
 * [`MOI.Utilities.add_column`](@ref)
 * [`MOI.Utilities.set_number_of_rows`](@ref)
 * [`MOI.Utilities.allocate_terms`](@ref)
 * [`MOI.Utilities.load_terms`](@ref)
 * [`MOI.Utilities.final_touch`](@ref)

The `.constants::BT` type must implement:

 * `BT()`
 * `Base.empty!(::BT)`
 * `Base.resize(::BT)`
 * [`MOI.Utilities.load_constants`](@ref)
 * [`MOI.Utilities.function_constants`](@ref)
 * [`MOI.Utilities.set_from_constants`](@ref)

The `.sets::ST` type must implement:

 * `ST()`
 * `MOI.is_empty(::ST)`
 * `MOI.empty(::ST)`
 * `MOI.dimension(::ST)`
 * `MOI.is_valid(::ST, ::MOI.ConstraintIndex)`
 * `MOI.get(::ST, ::MOI.ListOfConstraintTypesPresent)`
 * `MOI.get(::ST, ::MOI.NumberOfConstraints)`
 * `MOI.get(::ST, ::MOI.ListOfConstraintIndices)`
 * [`MOI.Utilities.set_types`](@ref)
 * [`MOI.Utilities.set_index`](@ref)
 * [`MOI.Utilities.add_set`](@ref)
 * [`MOI.Utilities.rows`](@ref)
 * [`MOI.Utilities.final_touch`](@ref)
"""
mutable struct MatrixOfConstraints{T,AT,BT,ST} <: MOI.ModelLike
    coefficients::AT
    constants::BT
    sets::ST
    caches::Vector{Any}
    are_indices_mapped::Vector{BitSet}
    final_touch::Bool
    function MatrixOfConstraints{T,AT,BT,ST}() where {T,AT,BT,ST}
        model = new{T,AT,BT,ST}(AT(), BT(), ST(), Any[], BitSet[], false)
        MOI.empty!(model)
        return model
    end
end

###
### Interface for the .coefficients field
###

"""
    add_column(coefficients)::Nothing

Tell `coefficients` to pre-allocate datastructures as needed to store one
column.
"""
function add_column end

"""
    set_number_of_rows(coefficients, n)::Nothing

Tell `coefficients` to pre-allocate datastructures as needed to store `n` rows.
"""
function set_number_of_rows end

"""
    allocate_terms(coefficients, index_map, func)::Nothing

Tell `coefficients` that the terms of the function `func` where the variable
indices are mapped with `index_map` will be loaded with [`load_terms`](@ref).

The function `func` must be canonicalized before calling `allocate_terms`. See
[`is_canonical`](@ref).
"""
function allocate_terms end

"""
    load_terms(coefficients, index_map, func, offset)::Nothing

Loads the terms of `func` to `coefficients`, mapping the variable indices with
`index_map`.

The `i`th dimension of `func` is loaded at the `(offset + i)`th row of
`coefficients`.

The function must be allocated first with [`allocate_terms`](@ref).

The function `func` must be canonicalized, see [`is_canonical`](@ref).
"""
function load_terms end

"""
    final_touch(coefficients)::Nothing

Informs the `coefficients` that all functions have been added with `load_terms`.
No more modification is allowed unless `MOI.empty!` is called.

    final_touch(sets)::Nothing

Informs the `sets` that all functions have been added with `add_set`.
No more modification is allowed unless `MOI.empty!` is called.
"""
function final_touch end

"""
    extract_function(coefficients, row::Integer, constant::T) where {T}

Return the `MOI.ScalarAffineFunction{T}` function corresponding to row `row` in
`coefficients`.

    extract_function(
        coefficients,
        rows::UnitRange,
        constants::Vector{T},
    ) where{T}

Return the `MOI.VectorAffineFunction{T}` function corresponding to rows `rows`
in `coefficients`.
"""
function extract_function end

###
### Interface for the .constants field
###

"""
    load_constants(constants, offset, func_or_set)::Nothing

This function loads the constants of `func_or_set` in `constants` at an offset
of `offset`. Where `offset` is the sum of the dimensions of the constraints
already loaded. The storage should be preallocated with `resize!` before calling
this function.

This function should be implemented to be usable as storage of constants for
[`MatrixOfConstraints`](@ref).

The constants are loaded in three steps:
 1) `Base.empty!` is called.
 2) `Base.resize!` is called with the sum of the dimensions of all constraints.
 3) `MOI.Utilities.load_constants` is called for each function for vector
    constraint or set for scalar constraint.
"""
function load_constants end

"""
    function_constants(constants, rows)

This function returns the function constants that were loaded with
[`load_constants`](@ref) at the rows `rows`.

This function should be implemented to be usable as storage of constants for
[`MatrixOfConstraints`](@ref).
"""
function function_constants end

"""
    set_from_constants(constants, S::Type, rows)::S

This function returns an instance of the set `S` for which the constants where
loaded with [`load_constants`](@ref) at the rows `rows`.

This function should be implemented to be usable as storage of constants for
[`MatrixOfConstraints`](@ref).
"""
function set_from_constants end

"""
    modify_constants(constants, row::Integer, new_constant::T) where {T}
    modify_constants(
        constants,
        rows::AbstractVector{<:Integer},
        new_constants::AbstractVector{T},
    ) where {T}

Modify `constants` in-place to store `new_constant` in the `row` row, or rows
`rows`.

This function must be implemented to enable [`MOI.ScalarConstantChange`](@ref)
and [`MOI.VectorConstantChange`](@ref) for [`MatrixOfConstraints`](@ref).
"""
function modify_constants end

###
### Interface for the .sets field
###

"""
    set_types(sets)::Vector{Type}

Return the list of the types of the sets allowed in `sets`.
"""
function set_types(f::Any)
    # Because these methods get defined in rather obtuse macros, it helps JET to
    # have a default fallback implementation, even if it's identical to what
    # would happen regardless.
    return throw(MethodError(set_types, (typeof(f),)))
end

"""
    set_index(sets, ::Type{S})::Union{Int,Nothing} where {S<:MOI.AbstractSet}

Return an integer corresponding to the index of the set type in the list given
by [`set_types`](@ref).

If `S` is not part of the list, return `nothing`.
"""
function set_index end

"""
    add_set(sets, i)::Int64

Add a scalar set of type index `i`.

    add_set(sets, i, dim)::Int64

Add a vector set of type index `i` and dimension `dim`.

Both methods return a unique `Int64` of the set that can be used to reference
this set.
"""
function add_set end

"""
    rows(sets, ci::MOI.ConstraintIndex)::Union{Int,UnitRange{Int}}

Return the rows in `1:MOI.dimension(sets)` corresponding to the set of id
`ci.value`.

For scalar sets, this returns an `Int`. For vector sets, this returns an
`UnitRange{Int}`.
"""
function rows end

###
### MatrixOfConstraints
###

MOI.is_empty(v::MatrixOfConstraints) = MOI.is_empty(v.sets)

function MOI.empty!(v::MatrixOfConstraints{T}) where {T}
    MOI.empty!(v.coefficients)
    empty!(v.constants)
    MOI.empty!(v.sets)
    v.caches =
        [Tuple{_affine_function_type(T, S),S}[] for S in set_types(v.sets)]
    v.are_indices_mapped = [BitSet() for _ in eachindex(v.caches)]
    v.final_touch = false
    return
end

"""
    rows(model::MatrixOfConstraints, ci::MOI.ConstraintIndex)

Return the rows in `1:MOI.dimension(sets)` corresponding to the set of id
`ci.value`.

For scalar sets, this returns an `Int`. For vector sets, this returns an
`UnitRange{Int}`.
"""
rows(model::MatrixOfConstraints, ci::MOI.ConstraintIndex) = rows(model.sets, ci)

function _affine_function_type(
    ::Type{T},
    ::Type{<:MOI.AbstractScalarSet},
) where {T}
    return MOI.ScalarAffineFunction{T}
end

function _affine_function_type(
    ::Type{T},
    ::Type{<:MOI.AbstractVectorSet},
) where {T}
    return MOI.VectorAffineFunction{T}
end

function MOI.supports_constraint(
    v::MatrixOfConstraints{T},
    ::Type{F},
    ::Type{S},
) where {T,F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    return F == _affine_function_type(T, S) && set_index(v.sets, S) !== nothing
end

function MOI.is_valid(
    v::MatrixOfConstraints{T},
    ci::MOI.ConstraintIndex{F,S},
) where {T,F,S}
    return F == _affine_function_type(T, S) && MOI.is_valid(v.sets, ci)
end

function MOI.get(
    v::MatrixOfConstraints,
    attr::Union{
        MOI.ListOfConstraintTypesPresent,
        MOI.NumberOfConstraints,
        MOI.ListOfConstraintIndices,
    },
)
    return MOI.get(v.sets, attr)
end

_add_set(sets, i, ::MOI.AbstractScalarFunction) = add_set(sets, i)

function _add_set(sets, i, func::MOI.AbstractVectorFunction)
    return add_set(sets, i, MOI.output_dimension(func))
end

const _MATRIXOFCONSTRAINTS_MODIFY_NOT_ALLOWED_ERROR_MESSAGE = """
MatrixOfConstraints does not allow modifications to be made to the model once
`MOI.Utilities.final_touch` has been called. This is called at the end of
`MOI.copy_to` and in `MOI.Utilities.attach_optimizer` (which is called by
`MOI.optimize!` in a `MOI.Utilities.CachingOptimizer`). In order to be able to
apply modifications to this model, you should add a layer
`MOI.Utilities.CachingOptimizer(MOI.Utilities.Model{Float64}(), model)`
where `model` is the current model. This will automatically empty `model` when
modifications are done after `MOI.Utilities.final_touch` is called and copy the
model again in `MOI.Utilities.attach_optimizer`.
"""

function _add_constraint(
    model::MatrixOfConstraints,
    i::Int,
    index_map,
    func::F,
    set::S,
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    allocate_terms(model.coefficients, index_map, func)
    # Without this type annotation, the compiler is unable to know the type
    # of `caches[i]` so this is slower and produce an allocation.
    push!(model.caches[i]::Vector{Tuple{F,S}}, (func, set))
    return MOI.ConstraintIndex{F,S}(_add_set(model.sets, i, func))
end

struct IdentityMap <: AbstractDict{MOI.VariableIndex,MOI.VariableIndex} end

Base.getindex(::IdentityMap, vi::MOI.VariableIndex) = vi

function MOI.add_constraint(
    model::MatrixOfConstraints{T},
    func::F,
    set::S,
) where {T,F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    i = set_index(model.sets, S)
    if i === nothing || F != _affine_function_type(T, S)
        throw(MOI.UnsupportedConstraint{F,S}())
    end
    if model.final_touch
        throw(
            MOI.AddConstraintNotAllowed{F,S}(
                _MATRIXOFCONSTRAINTS_MODIFY_NOT_ALLOWED_ERROR_MESSAGE,
            ),
        )
    end
    if !Utilities.is_canonical(func)
        func = Utilities.canonical(func)
    end
    return _add_constraint(model, i, IdentityMap(), func, set)
end

function _allocate_constraints(
    model::MatrixOfConstraints{T},
    src,
    index_map,
    ::Type{F},
    ::Type{S},
) where {T,F,S}
    i = set_index(model.sets, S)
    if i === nothing || F != _affine_function_type(T, S)
        throw(MOI.UnsupportedConstraint{F,S}())
    end
    cis_src = MOI.get(
        src,
        MOI.ListOfConstraintIndices{_affine_function_type(T, S),S}(),
    )
    for ci_src in cis_src
        func = MOI.get(src, MOI.CanonicalConstraintFunction(), ci_src)
        set = MOI.get(src, MOI.ConstraintSet(), ci_src)
        push!(model.are_indices_mapped[i], length(model.caches[i]) + 1)
        index_map[ci_src] = _add_constraint(model, i, index_map, func, set)
    end
    return
end

function _load_constants(
    constants,
    offset,
    func::MOI.AbstractScalarFunction,
    set::MOI.AbstractScalarSet,
)
    MOI.throw_if_scalar_and_constant_not_zero(func, typeof(set))
    load_constants(constants, offset, set)
    return
end

function _load_constants(
    constants,
    offset,
    func::MOI.AbstractVectorFunction,
    set::MOI.AbstractVectorSet,
)
    load_constants(constants, offset, func)
    load_constants(constants, offset, set)
    return
end

function _load_constraints(
    dest::MatrixOfConstraints,
    index_map,
    offset,
    func_sets,
    are_indices_mapped,
)
    for i in eachindex(func_sets)
        func, set = func_sets[i]
        if i in are_indices_mapped
            load_terms(dest.coefficients, index_map, func, offset)
        else
            load_terms(dest.coefficients, IdentityMap(), func, offset)
        end
        _load_constants(dest.constants, offset, func, set)
        offset += MOI.output_dimension(func)
    end
    return offset
end

_add_variable(model::MatrixOfConstraints) = add_column(model.coefficients)

function _add_variables(model::MatrixOfConstraints, n)
    return add_columns(model.coefficients, n)
end

function pass_nonvariable_constraints(
    dest::MatrixOfConstraints,
    src::MOI.ModelLike,
    index_map::IndexMap,
    constraint_types,
)
    for (F, S) in constraint_types
        _allocate_constraints(dest, src, index_map, F, S)
    end
    return
end

function final_touch(model::MatrixOfConstraints, index_map)
    if model.final_touch
        # If `default_copy_to` calls `final_touch`, then `index_map` is not
        # `nothing` and `final_touch` should be `false`.
        # When `CachingOptimizer` calls this, `index_map` is `nothing`
        # and `final_touch` might be `true`.
        # So we are always in a case where `index_map` is `nothing`.
        @assert index_map === nothing
        return
    end
    final_touch(model.sets)
    num_rows = MOI.dimension(model.sets)
    resize!(model.constants, num_rows)
    set_number_of_rows(model.coefficients, num_rows)
    offset = 0
    for (cache, mapped_indices) in zip(model.caches, model.are_indices_mapped)
        offset =
            _load_constraints(model, index_map, offset, cache, mapped_indices)
    end
    final_touch(model.coefficients)
    empty!(model.caches)
    empty!(model.are_indices_mapped)
    model.final_touch = true
    return
end

# Users of `MatrixOfConstraints` assume variable indices to be `1:n` where `n`
# is the number of columns so we don't support variable deletion.
function _throw_if_cannot_delete(
    ::MatrixOfConstraints,
    ::Vector{MOI.VariableIndex},
    vi::MOI.VariableIndex,
)
    return throw(MOI.DeleteNotAllowed(vi))
end

function _throw_if_cannot_delete(
    ::MatrixOfConstraints,
    vis::Vector{MOI.VariableIndex},
    ::Set{MOI.VariableIndex},
)
    return throw(MOI.DeleteNotAllowed(first(vis)))
end

###
### .constants::Vector
###

# `Base.empty!` is already implemented.
# `Base.resize!` is already implemented.

function load_constants(
    b::Vector{T},
    offset,
    func::MOI.VectorAffineFunction{T},
) where {T}
    copyto!(b, offset + 1, func.constants)
    return
end

load_constants(::Vector, ::Any, ::MOI.AbstractVectorSet) = nothing

function load_constants(
    ::Vector,
    ::Any,
    S::Union{MOI.PowerCone,MOI.DualPowerCone},
)
    return error(
        "`$(typeof(S))` cannot be used with `Vector` as the set type in " *
        "MatrixOfConstraints",
    )
end

function_constants(b::Vector, rows) = b[rows]

"""
    set_with_dimension(::Type{S}, dim) where {S<:MOI.AbstractVectorSet}

Returns the instance of `S` of [`MOI.dimension`](@ref) `dim`.
This needs to be implemented for sets of type `S` to be useable with
[`MatrixOfConstraints`](@ref).
"""
function set_with_dimension(::Type{S}, dim) where {S<:MOI.AbstractVectorSet}
    return S(dim)
end

function set_with_dimension(::Type{MOI.Scaled{S}}, dim) where {S}
    return MOI.Scaled(set_with_dimension(S, dim))
end

function set_with_dimension(
    ::Type{S},
    dim,
) where {S<:MOI.AbstractSymmetricMatrixSetTriangle}
    side_dimension = side_dimension_for_vectorized_dimension(dim)
    return S(side_dimension)
end

function set_with_dimension(
    ::Type{S},
    dim,
) where {S<:MOI.AbstractSymmetricMatrixSetSquare}
    return S(isqrt(dim))
end

function set_with_dimension(
    ::Type{MOI.HermitianPositiveSemidefiniteConeTriangle},
    dim,
)
    # We have `n*(n+1)/2 + n*(n-1)/2 = dim` so
    # `n² + n + n² - n = 2dim` hence `n² = dim`
    # This can be seen geometrically as the vectorization
    # contains the upper triangular followed by the strictly upper triangular.
    return MOI.HermitianPositiveSemidefiniteConeTriangle(isqrt(dim))
end

function set_with_dimension(::Type{MOI.LogDetConeTriangle}, dim)
    side_dimension = side_dimension_for_vectorized_dimension(dim - 2)
    return MOI.LogDetConeTriangle(side_dimension)
end

function set_with_dimension(::Type{MOI.LogDetConeSquare}, dim)
    return MOI.LogDetConeSquare(isqrt(dim - 2))
end

function set_with_dimension(::Type{MOI.RootDetConeTriangle}, dim)
    side_dimension = side_dimension_for_vectorized_dimension(dim - 1)
    return MOI.RootDetConeTriangle(side_dimension)
end

function set_with_dimension(::Type{MOI.RootDetConeSquare}, dim)
    return MOI.RootDetConeSquare(isqrt(dim - 1))
end

function set_with_dimension(::Type{MOI.ExponentialCone}, dim)
    @assert dim == 3
    return MOI.ExponentialCone()
end

function set_with_dimension(::Type{MOI.DualExponentialCone}, dim)
    @assert dim == 3
    return MOI.DualExponentialCone()
end

function set_from_constants(::Vector, ::Type{S}, rows) where {S}
    return set_with_dimension(S, length(rows))
end

function MOI.get(
    model::MatrixOfConstraints,
    ::Union{MOI.CanonicalConstraintFunction,MOI.ConstraintFunction},
    ci::MOI.ConstraintIndex,
)
    @assert model.final_touch
    MOI.throw_if_not_valid(model, ci)
    r = rows(model, ci)
    return extract_function(
        model.coefficients,
        r,
        function_constants(model.constants, r),
    )
end

function MOI.get(
    model::MatrixOfConstraints,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    @assert model.final_touch
    MOI.throw_if_not_valid(model, ci)
    return set_from_constants(model.constants, S, rows(model, ci))
end

function MOI.modify(
    model::MatrixOfConstraints,
    ci::MOI.ConstraintIndex,
    change::Union{MOI.ScalarConstantChange,MOI.VectorConstantChange},
)
    try
        modify_constants(model.constants, rows(model, ci), change.new_constant)
    catch
        throw(MOI.ModifyConstraintNotAllowed(ci, change))
    end
    return
end

function modify_constants(
    b::AbstractVector{T},
    row::Integer,
    new_constant::T,
) where {T}
    b[row] = new_constant
    return
end

function modify_constants(
    b::AbstractVector{T},
    rows::AbstractVector{<:Integer},
    new_constants::AbstractVector{T},
) where {T}
    for (row, new_constant) in zip(rows, new_constants)
        modify_constants(b, row, new_constant)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SingleBridgeOptimizer{BT<:AbstractBridge}(model::MOI.ModelLike)

Return [`MOI.Bridges.AbstractBridgeOptimizer`](@ref) that always bridges any
variables constrained on creation supported by the bridge `BT`.

This is in contrast with the [`MOI.Bridges.LazyBridgeOptimizer`](@ref),
which only bridges the variables constrained on creation if they are supported
by the bridge `BT` and unsupported by `model`.

!!! warning
    Two `SingleBridgeOptimizer`s cannot be used together as both of them assume
    that the underlying model only returns variable indices with nonnegative
    values. Use [`MOI.Bridges.LazyBridgeOptimizer`](@ref) instead.

## Example

```jldoctest var_singlebridgeoptimizer
julia> struct MyNewBridge{T} <: MOI.Bridges.Variable.AbstractBridge end

julia> bridge = MOI.Bridges.Variable.SingleBridgeOptimizer{MyNewBridge{Float64}}(
           MOI.Utilities.Model{Float64}(),
       );
```

## Implementation notes

All bridges should simplify the creation of `SingleBridgeOptimizer`s by defining
a constant that wraps the bridge in a `SingleBridgeOptimizer`.
```jldoctest var_singlebridgeoptimizer
julia> const MyNewBridgeModel{T,OT<:MOI.ModelLike} =
           MOI.Bridges.Variable.SingleBridgeOptimizer{MyNewBridge{T},OT};
```
This enables users to create bridged models as follows:
```jldoctest var_singlebridgeoptimizer
julia> MyNewBridgeModel{Float64}(MOI.Utilities.Model{Float64}());
```
"""
mutable struct SingleBridgeOptimizer{BT<:AbstractBridge,OT<:MOI.ModelLike} <:
               MOI.Bridges.AbstractBridgeOptimizer
    model::OT
    map::Map # index of bridged variable -> variable bridge
    var_to_name::Dict{MOI.VariableIndex,String}
    name_to_var::Union{Dict{String,MOI.VariableIndex},Nothing}
    con_to_name::Dict{MOI.ConstraintIndex,String}
    name_to_con::Union{Dict{String,MOI.ConstraintIndex},Nothing}

    function SingleBridgeOptimizer{BT}(model::OT) where {BT,OT<:MOI.ModelLike}
        return new{BT,OT}(
            model,
            Map(),
            Dict{MOI.VariableIndex,String}(),
            nothing,
            Dict{MOI.ConstraintIndex,String}(),
            nothing,
        )
    end
end

bridges(::MOI.Bridges.AbstractBridgeOptimizer) = EmptyMap()

bridges(bridge::SingleBridgeOptimizer) = bridge.map

MOI.Bridges.supports_constraint_bridges(::SingleBridgeOptimizer) = false

function MOI.Bridges.supports_bridging_constrained_variable(
    ::SingleBridgeOptimizer{BT},
    S::Type{<:MOI.AbstractSet},
) where {BT}
    return supports_constrained_variable(BT, S)
end

function MOI.Bridges.is_variable_bridged(
    ::SingleBridgeOptimizer,
    ::Type{<:MOI.AbstractSet},
)
    return true
end

function MOI.Bridges.is_bridged(
    b::SingleBridgeOptimizer,
    S::Type{<:MOI.AbstractSet},
)
    return MOI.Bridges.supports_bridging_constrained_variable(b, S)
end

function MOI.Bridges.is_bridged(
    ::SingleBridgeOptimizer,
    ::Type{<:MOI.AbstractFunction},
    ::Type{<:MOI.AbstractSet},
)
    return false
end

function MOI.Bridges.is_bridged(
    ::SingleBridgeOptimizer,
    ::Type{<:MOI.AbstractScalarFunction},
)
    return false
end

function MOI.Bridges.bridge_type(
    ::SingleBridgeOptimizer{BT},
    ::Type{<:MOI.AbstractSet},
) where {BT}
    return BT
end

MOI.Bridges.bridging_cost(::SingleBridgeOptimizer, args...) = 1.0

MOI.Bridges.recursive_model(b::SingleBridgeOptimizer) = b.model

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

for sense in (MOI.MIN_SENSE, MOI.MAX_SENSE), offset in (0, 6 // 5)
    o = iszero(offset) ? "" : "_offset"
    f_unbd_name = Symbol("test_unbounded_$(Symbol(sense))$(o)")
    f_infeas_name = Symbol("test_infeasible_$(Symbol(sense))$(o)")
    f_infeas_affine_name = Symbol("test_infeasible_affine_$(Symbol(sense))$(o)")
    @eval begin
        """
        Test the infeasibility certificates of an unbounded model.
        """
        function $(f_unbd_name)(
            model::MOI.ModelLike,
            config::Config{T},
        ) where {T}
            @requires _supports(config, MOI.optimize!)
            x = MOI.add_variable(model)
            MOI.set(model, MOI.ObjectiveSense(), $sense)
            f = T(11 // 5) * x + T($offset)
            MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
            c = if $sense == MOI.MIN_SENSE
                MOI.add_constraint(
                    model,
                    T(13 // 10) * x,
                    MOI.LessThan(T(11 // 10)),
                )
            else
                MOI.add_constraint(
                    model,
                    T(13 // 10) * x,
                    MOI.GreaterThan(T(11 // 10)),
                )
            end
            MOI.optimize!(model)
            @requires(
                MOI.get(model, MOI.TerminationStatus()) == MOI.DUAL_INFEASIBLE,
            )
            @requires(
                MOI.get(model, MOI.PrimalStatus()) ==
                MOI.INFEASIBILITY_CERTIFICATE,
            )
            d = MOI.get(model, MOI.VariablePrimal(), x)
            obj = MOI.get(model, MOI.ObjectiveValue())
            if $sense == MOI.MIN_SENSE
                @test d < -config.atol
                @test obj < -config.atol
            else
                @test d > config.atol
                @test obj > config.atol
            end
            @test isapprox(T(11 // 5) * d, obj, config)
            if _supports(config, MOI.ConstraintPrimal)
                Ad = MOI.get(model, MOI.ConstraintPrimal(), c)
                @test isapprox(T(13 // 10) * d, Ad, config)
            end
            return
        end
        version_added(::typeof($(f_unbd_name))) = v"0.10.6"
        function setup_test(
            ::typeof($(f_unbd_name)),
            mock::MOIU.MockOptimizer,
            config::Config{T},
        ) where {T}
            MOIU.set_mock_optimize!(
                mock,
                (mock::MOIU.MockOptimizer) -> begin
                    MOIU.mock_optimize!(
                        mock,
                        MOI.DUAL_INFEASIBLE,
                        (
                            MOI.INFEASIBILITY_CERTIFICATE,
                            [$sense == MOI.MIN_SENSE ? T(-1) : T(1)],
                        ),
                        MOI.NO_SOLUTION,
                    )
                end,
            )
            return
        end

        """
        Test the infeasibility certificates of an infeasible model.
        """
        function $(f_infeas_name)(
            model::MOI.ModelLike,
            config::Config{T},
        ) where {T}
            @requires _supports(config, MOI.optimize!)
            x = MOI.add_variable(model)
            MOI.set(model, MOI.ObjectiveSense(), $sense)
            f = T(11 // 5) * x + T($offset)
            MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
            cl = MOI.add_constraint(model, x, MOI.GreaterThan(T(5 // 2)))
            cu = MOI.add_constraint(model, T(1) * x, MOI.LessThan(T(7 // 5)))
            MOI.optimize!(model)
            @requires(
                MOI.get(model, MOI.TerminationStatus()) ==
                config.infeasible_status,
            )
            @requires(
                MOI.get(model, MOI.DualStatus()) ==
                MOI.INFEASIBILITY_CERTIFICATE,
            )
            dl = MOI.get(model, MOI.ConstraintDual(), cl)
            du = MOI.get(model, MOI.ConstraintDual(), cu)
            @test dl > config.atol
            @test du < -config.atol
            @test isapprox(dl + du, T(0), config)
            if _supports(config, MOI.DualObjectiveValue)
                obj = MOI.get(model, MOI.DualObjectiveValue())
                target = T(7 // 5) * dl + T(5 // 2) * du
                if $sense == MOI.MIN_SENSE
                    @test obj > config.atol
                    @test isapprox(-target, obj, config)
                else
                    @test obj < -config.atol
                    @test isapprox(target, obj, config)
                end
            end
            return
        end
        version_added(::typeof($(f_infeas_name))) = v"0.10.6"
        function setup_test(
            ::typeof($(f_infeas_name)),
            mock::MOIU.MockOptimizer,
            config::Config{T},
        ) where {T}
            MOIU.set_mock_optimize!(
                mock,
                (mock::MOIU.MockOptimizer) -> begin
                    MOIU.mock_optimize!(
                        mock,
                        MOI.INFEASIBLE,
                        MOI.NO_SOLUTION,
                        MOI.INFEASIBILITY_CERTIFICATE,
                        (MOI.VariableIndex, MOI.GreaterThan{T}) => T[1],
                        (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) =>
                            T[-1],
                    )
                end,
            )
            return
        end

        """
        Test the infeasibility certificates of an infeasible model with affine
        constraints.
        """
        function $(f_infeas_affine_name)(
            model::MOI.ModelLike,
            config::Config{T},
        ) where {T}
            @requires _supports(config, MOI.optimize!)
            x = MOI.add_variable(model)
            MOI.set(model, MOI.ObjectiveSense(), $sense)
            f = T(11 // 5) * x + T($offset)
            MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
            cl = MOI.add_constraint(model, T(1) * x, MOI.GreaterThan(T(5 // 2)))
            cu = MOI.add_constraint(model, x, MOI.LessThan(T(7 // 5)))
            MOI.optimize!(model)
            @requires(
                MOI.get(model, MOI.TerminationStatus()) ==
                config.infeasible_status,
            )
            @requires(
                MOI.get(model, MOI.DualStatus()) ==
                MOI.INFEASIBILITY_CERTIFICATE,
            )
            dl = MOI.get(model, MOI.ConstraintDual(), cl)
            du = MOI.get(model, MOI.ConstraintDual(), cu)
            @test dl > config.atol
            @test du < -config.atol
            @test isapprox(dl + du, T(0), config)
            if _supports(config, MOI.DualObjectiveValue)
                obj = MOI.get(model, MOI.DualObjectiveValue())
                target = T(7 // 5) * dl + T(5 // 2) * du
                if $sense == MOI.MIN_SENSE
                    @test obj > config.atol
                    @test isapprox(-target, obj, config)
                else
                    @test obj < -config.atol
                    @test isapprox(target, obj, config)
                end
            end
            return
        end
        version_added(::typeof($(f_infeas_affine_name))) = v"0.10.6"
        function setup_test(
            ::typeof($(f_infeas_affine_name)),
            mock::MOIU.MockOptimizer,
            config::Config{T},
        ) where {T}
            MOIU.set_mock_optimize!(
                mock,
                (mock::MOIU.MockOptimizer) -> begin
                    MOIU.mock_optimize!(
                        mock,
                        MOI.INFEASIBLE,
                        MOI.NO_SOLUTION,
                        MOI.INFEASIBILITY_CERTIFICATE,
                        (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                            T[1],
                        (MOI.VariableIndex, MOI.LessThan{T}) => T[-1],
                    )
                end,
            )
            return
        end
    end
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type AbstractDistance end

An abstract type used to enable dispatch of
[`Utilities.distance_to_set`](@ref).
"""
abstract type AbstractDistance end

"""
    ProjectionUpperBoundDistance() <: AbstractDistance

An upper bound on the minimum distance between `point` and the closest
feasible point in `set`.

## Definition of distance

The minimum distance is computed as:
```math
d(x, \\mathcal{K}) = \\min_{y \\in \\mathcal{K}} || x - y ||
```
where ``x`` is `point` and ``\\mathcal{K}`` is `set`. The norm is computed as:
```math
||x|| = \\sqrt{f(x, x, \\mathcal{K})}
```
where ``f`` is [`Utilities.set_dot`](@ref).

In the default case, where the set does not have a specialized method for
[`Utilities.set_dot`](@ref), the norm is equivalent to the Euclidean norm
``||x|| = \\sqrt{\\sum x_i^2}``.

## Why an upper bound?

In most cases, `distance_to_set` should return the smallest upper bound, but it
may return a larger value if the smallest upper bound is expensive to compute.

For example, given an epigraph from of a conic set, ``\\{(t, x) | f(x) \\le t\\}``,
it may be simpler to return ``\\delta`` such that ``f(x) \\le t + \\delta``,
rather than computing the nearest projection onto the set.

If the distance is not the smallest upper bound, the docstring of the
appropriate `distance_to_set` method _must_ describe the way that the distance
is computed.
"""
struct ProjectionUpperBoundDistance <: AbstractDistance end

"""
    distance_to_set(
        [d::AbstractDistance = ProjectionUpperBoundDistance()],]
        point::T,
        set::MOI.AbstractScalarSet,
    ) where {T}

    distance_to_set(
        [d::AbstractDistance = ProjectionUpperBoundDistance(),]
        point::AbstractVector{T},
        set::MOI.AbstractVectorSet,
    ) where {T}

Compute the distance between `point` and `set` using the distance metric `d`. If
`point` is in the set `set`, this function _must_ return `zero(T)`.

If `d` is omitted, the default distance is [`Utilities.ProjectionUpperBoundDistance`](@ref).
"""
function distance_to_set(point, set)
    return distance_to_set(ProjectionUpperBoundDistance(), point, set)
end

function distance_to_set(d::AbstractDistance, ::Any, set::MOI.AbstractSet)
    return error(
        "distance_to_set using the distance metric $d for set type " *
        "$(typeof(set)) has not been implemented yet.",
    )
end

###
### MOI.AbstractScalarSets
###

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::T,
    set::MOI.LessThan{T},
) where {T<:Real}
    return max(x - set.upper, zero(T))
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::T,
    set::MOI.GreaterThan{T},
) where {T<:Real}
    return max(set.lower - x, zero(T))
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::T,
    set::MOI.EqualTo{T},
) where {T<:Number}
    return abs(set.value - x)
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::T,
    set::MOI.Parameter{T},
) where {T<:Number}
    return abs(set.value - x)
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::T,
    set::MOI.Interval{T},
) where {T<:Real}
    return max(x - set.upper, set.lower - x, zero(T))
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::T,
    ::MOI.ZeroOne,
) where {T<:Real}
    return min(abs(x - zero(T)), abs(x - one(T)))
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::T,
    ::MOI.Integer,
) where {T<:Real}
    return abs(x - round(x))
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::T,
    set::MOI.Semicontinuous{T},
) where {T<:Real}
    return min(max(x - set.upper, set.lower - x, zero(T)), abs(x))
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::T,
    set::MOI.Semiinteger{T},
) where {T<:Real}
    d = max(ceil(set.lower) - x, x - floor(set.upper), abs(x - round(x)))
    return min(d, abs(x))
end

###
### MOI.AbstractVectorSets
###

function _check_dimension(v::AbstractVector, s)
    if length(v) != MOI.dimension(s)
        throw(DimensionMismatch("Mismatch between value and set"))
    end
    return
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.Nonnegatives,
) where {T<:Real}
    _check_dimension(x, set)
    return LinearAlgebra.norm(max(-xi, zero(T)) for xi in x)
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.Nonpositives,
) where {T<:Real}
    _check_dimension(x, set)
    return LinearAlgebra.norm(max(xi, zero(T)) for xi in x)
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.Zeros,
) where {T<:Number}
    _check_dimension(x, set)
    return LinearAlgebra.norm(x)
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.Reals,
) where {T<:Real}
    _check_dimension(x, set)
    return zero(T)
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.SecondOrderCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    # Projections come from:
    # Parikh, N., & Boyd, S. (2014). Proximal algorithms. Foundations and
    # trends in Optimization, page 184, section 6.3.2.
    t, rhs = x[1], LinearAlgebra.norm(@views x[2:end])
    if t >= rhs
        return zero(T) # The point is feasible
    end
    if rhs <= -t  # Projection to the point (0, [0])
        return LinearAlgebra.norm(x)
    end
    # Projection to the point (t, x) + 0.5 * (|x|_2 - t, (t/|x|_2 - 1) * x)
    return sqrt(2) / 2 * abs(t - rhs)
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, ::MOI.RotatedSecondOrderCone)

Let `(t, u, y...) = x`. Return the 2-norm of the vector `d` such that in `x + d`,
`u` is projected to `1` if `u <= 0`, and `t` is increased such that `x + d`
belongs to the set.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.RotatedSecondOrderCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    u, y = (x[2] <= 0 ? 1 : x[2]), @view(x[3:end])
    element_distance = (
        u - x[2],  # u -> 1
        max(LinearAlgebra.dot(y, y) / (2 * u) - x[1], zero(T)),
    )
    return LinearAlgebra.norm(element_distance, 2)
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, ::MOI.ExponentialCone)

Let `(u, v, w) = x`. If `v > 0`, return the epigraph distance `d` such that
`(u, v, w + d)` belongs to the set.

If `v <= 0` return the 2-norm of the vector `d` such that `x + d = (u, 1, z)`
where `z` satisfies the constraints.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.ExponentialCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    if x[2] <= 0  # Project to x[2] = 1
        element_distance = (x[2] - one(T), max(exp(x[1]) - x[3], zero(T)))
        return LinearAlgebra.norm(element_distance, 2)
    end
    return max(x[2] * exp(x[1] / x[2]) - x[3], zero(T))
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, ::MOI.DualExponentialCone)

Let `(u, v, w) = x`. If `u < 0`, return the epigraph distance `d` such that
`(u, v, w + d)` belongs to the set.

If `u >= 0` return the 2-norm of the vector `d` such that `x + d = (u, -1, z)`
where `z` satisfies the constraints.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.DualExponentialCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    if x[1] >= 0  # Project to x[1] = -1
        element_distance = (x[1] - -one(T), max(exp(-x[2] - 1) - x[3], zero(T)))
        return LinearAlgebra.norm(element_distance, 2)
    end
    return max(-x[1] * exp(x[2] / x[1] - 1) - x[3], zero(T))
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, ::MOI.GeometricMeanCone)

Let `(t, y...) = x`. If all `y` are non-negative, return the epigraph distance
`d` such that `(t + d, y...)` belongs to the set.

If any `y` are strictly negative, return the 2-norm of the vector `d` that
projects negative `y` elements to `0` and `t` to `ℝ₋`.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.GeometricMeanCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    t, xs = x[1], @view(x[2:end])
    if any(<(zero(T)), xs)  # Project to x = 0
        return LinearAlgebra.norm((min.(xs, zero(T)), max(t, zero(T))), 2)
    end
    return max(t - prod(xs)^inv(MOI.dimension(set) - 1), zero(T))
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, ::MOI.PowerCone)

Let `(a, b, c) = x`. If `a` and `b` are non-negative, return the epigraph
distance required to increase `c` such that the constraint is satisfied.

If `a` or `b` is strictly negative, return the 2-norm of the vector `d` such
that in the vector `x + d`: `c`, and any negative `a` and `b` are projected to
`0`.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.PowerCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    α = set.exponent
    if x[1] >= 0 && x[2] >= 0
        return max(abs(x[3]) - x[1]^α * x[2]^(1 - α), zero(T))
    end
    # Project to x = 0
    return LinearAlgebra.norm((min(x[1], zero(T)), min(x[2], zero(T)), x[3]), 2)
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, ::MOI.DualPowerCone)

Let `(a, b, c) = x`. If `a` and `b` are non-negative, return the epigraph
distance required to increase `c` such that the constraint is satisfied.

If `a` or `b` is strictly negative, return the 2-norm of the vector `d` such
that in the vector `x + d`: `c`, and any negative `a` and `b` are projected to
`0`.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.DualPowerCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    α = set.exponent
    if x[1] >= 0 && x[2] >= 0
        return max(abs(x[3]) - (x[1] / α)^α * (x[2] / (1 - α))^(1 - α), zero(T))
    end
    # Project to x = 0
    return LinearAlgebra.norm((min(x[1], zero(T)), min(x[2], zero(T)), x[3]), 2)
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, ::MOI.NormOneCone)

Let `(t, y...) = x`. Return the epigraph distance `d` such that `(t + d, y...)`
belongs to the set.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.NormOneCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    return max(sum(abs, @view(x[2:end])) - x[1], zero(T))
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, ::MOI.NormInfinityCone)

Let `(t, y...) = x`. Return the epigraph distance `d` such that `(t + d, y...)`
belongs to the set.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.NormInfinityCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    return max(maximum(abs, @view(x[2:end])) - x[1], zero(T))
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, ::MOI.RelativeEntropyCone)

Let `(u, v..., w...) = x`. If `v` and `w` are strictly positive, return the
epigraph distance required to increase `u` such that the constraint is satisfied.

If any elements in `v` or `w` are non-positive, return the 2-norm of the vector
`d` such that in the vector `x + d`: any non-positive elements in `v` and `w`
are projected to `1`, and `u` is projected such that the epigraph constraint
holds.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.RelativeEntropyCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    n = div(MOI.dimension(set) - 1, 2)
    u, v, w = x[1], @view(x[2:(n+1)]), @view(x[(n+2):end])
    _to_one(x) = x <= zero(T) ? one(T) : x
    if any(<=(zero(T)), v) || any(<=(zero(T)), w)  # Project to v = w = 1
        v_p, w_p = _to_one.(v), _to_one.(w)
        element_distance = (
            v_p .- v,
            w_p .- w,
            max(
                sum(w_p[i] * log(w_p[i] / v_p[i]) for i in eachindex(w)) - u,
                zero(T),
            ),
        )
        return LinearAlgebra.norm(element_distance, 2)
    end
    return max(sum(w[i] * log(w[i] / v[i]) for i in eachindex(w)) - u, zero(T))
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.HyperRectangle,
) where {T<:Real}
    _check_dimension(x, set)
    element_distance =
        (max.(set.lower .- x, zero(T)), max.(x .- set.upper, zero(T)))
    return LinearAlgebra.norm(element_distance, 2)
end

"""
    distance_to_set(::ProjectionUpperBoundDistance, x, set::MOI.NormCone)

Let `(t, y...) = x`. Return the epigraph distance `d` such that `(t + d, y...)`
belongs to the set.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.NormCone,
) where {T<:Real}
    Base.require_one_based_indexing(x)
    _check_dimension(x, set)
    return max(LinearAlgebra.norm(@view(x[2:end]), set.p) - x[1], zero(T))
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.SOS1,
) where {T<:Real}
    _check_dimension(x, set)
    _, i = findmax(abs, x)
    return LinearAlgebra.norm([x[j] for j in eachindex(x) if j != i], 2)
end

# This is the minimal L2-norm.
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::MOI.SOS2,
) where {T<:Real}
    _check_dimension(x, set)
    p = sortperm(set.weights)
    pairs = collect(zip(p[1:(end-1)], p[2:end]))
    _, k = findmax([abs(x[i]) + abs(x[j]) for (i, j) in pairs])
    elements = [x[i] for i in eachindex(x) if !(i in pairs[k])]
    return LinearAlgebra.norm(elements, 2)
end

function _reshape(x::AbstractVector, set::MOI.PositiveSemidefiniteConeSquare)
    n = MOI.side_dimension(set)
    return reshape(x, (n, n))
end

function _reshape(x::AbstractVector, set::MOI.PositiveSemidefiniteConeTriangle)
    n = MOI.side_dimension(set)
    X = zeros(eltype(x), n, n)
    k = 1
    for i in 1:n
        for j in 1:i
            X[j, i] = X[i, j] = x[k]
            k += 1
        end
    end
    return LinearAlgebra.Symmetric(X)
end

"""
    distance_to_set(
        ::ProjectionUpperBoundDistance,
        x::AbstractVector,
        set::Union{
            MOI.PositiveSemidefiniteConeSquare,
            MOI.PositiveSemidefiniteConeTriangle,
        },
    )

Let ``X`` be `x` reshaped into the appropriate matrix. The returned distance is
``||X - Y||_2^2`` where ``Y`` is the eigen decomposition of ``X`` with negative
eigen values removed.
"""
function distance_to_set(
    ::ProjectionUpperBoundDistance,
    x::AbstractVector{T},
    set::Union{
        MOI.PositiveSemidefiniteConeSquare,
        MOI.PositiveSemidefiniteConeTriangle,
    },
) where {T<:Real}
    _check_dimension(x, set)
    # We should return the norm of `A` defined by:
    # ```julia
    # λ, U = LinearAlgebra.eigen(_reshape(x, set))
    # λ_negative = LinearAlgebra.Diagonal(min.(zero(T), λ))
    # A = LinearAlgebra.Symmetric(U * λ_negative * U')
    # LinearAlgebra.norm(A, 2)
    # ```
    # The norm should correspond to `MOI.Utilities.set_dot` so it's the
    # Frobenius norm, which is the Euclidean norm of the vector of eigenvalues.
    eigvals = LinearAlgebra.eigvals(_reshape(x, set))
    eigvals .= min.(zero(T), eigvals)
    return LinearAlgebra.norm(eigvals, 2)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SetDotScalingBridge{T,S,F,G} <: Bridges.Constraint.AbstractBridge

`SetDotScalingBridge` implements the reformulation from constraints
in `S` to constraints in [`MOI.Scaled{S}`](@ref MOI.Scaled).

## Source node

`SetDotScalingBridge` supports:

  * `G` in `S`

## Target node

`SetDotScalingBridge` creates:

  * `F` in [`MOI.Scaled{S}`](@ref MOI.Scaled)
"""
struct SetDotScalingBridge{T,S<:MOI.AbstractVectorSet,F,G} <:
       SetMapBridge{T,MOI.Scaled{S},S,F,G}
    constraint::MOI.ConstraintIndex{F,MOI.Scaled{S}}
end

const SetDotScaling{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SetDotScalingBridge{T},OT}

function concrete_bridge_type(
    ::Type{<:SetDotScalingBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{S},
) where {T,S<:MOI.AbstractVectorSet}
    F = MOI.Utilities.promote_operation(
        *,
        T,
        LinearAlgebra.Diagonal{T,Vector{T}},
        G,
    )
    return SetDotScalingBridge{T,S,F,G}
end

function MOI.Bridges.map_set(
    ::Type{<:SetDotScalingBridge{T,S}},
    set::S,
) where {T,S<:MOI.AbstractVectorSet}
    return MOI.Scaled(set)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:SetDotScalingBridge{T,S}},
    set::MOI.Scaled{S},
) where {T,S}
    return set.set
end

_length(f::MOI.AbstractVectorFunction) = MOI.output_dimension(f)
_length(f::AbstractVector) = length(f)

function _scale(::Type{T}, ::Type{S}, func) where {T,S}
    set = MOI.Utilities.set_with_dimension(S, _length(func))
    scale = MOI.Utilities.SetDotScalingVector{T}(set)
    return MOI.Utilities.operate(*, T, LinearAlgebra.Diagonal(scale), func)
end

function _inverse_scale(::Type{T}, ::Type{S}, func) where {T,S}
    set = MOI.Utilities.set_with_dimension(S, _length(func))
    scale = MOI.Utilities.SetDotScalingVector{T}(set)
    inv_scale = MOI.Utilities.lazy_map(T, inv, scale)
    return MOI.Utilities.operate(*, T, LinearAlgebra.Diagonal(inv_scale), func)
end

function MOI.Bridges.map_function(
    ::Type{<:SetDotScalingBridge{T,S}},
    func,
) where {T,S}
    return _scale(T, S, func)
end

function MOI.Bridges.inverse_map_function(
    ::Type{<:SetDotScalingBridge{T,S}},
    func,
) where {T,S}
    return _inverse_scale(T, S, func)
end

# Since the map is a diagonal matrix `D`, it is symmetric so one would initially
# expect `adjoint_map_function` to be the same as `map_function`. However, the
# scalar product for the scaled PSD cone is `<x, y>_2 = x'y` but the scalar
# product for the PSD cone additionally scales the offdiagonal entries by `2`
# hence by `D^2` so `<x, y>_1 = x'D^2y`.
# So `<Dx, y>_2 = <x, D^(-1)y>_1` hence the adjoint of `D` is its inverse.
function MOI.Bridges.adjoint_map_function(
    ::Type{<:SetDotScalingBridge{T,S}},
    func,
) where {T,S}
    return _inverse_scale(T, S, func)
end

function MOI.Bridges.inverse_adjoint_map_function(
    ::Type{<:SetDotScalingBridge{T,S}},
    func,
) where {T,S}
    return _scale(T, S, func)
end

"""
    SetDotInverseScalingBridge{T,S,F,G} <: Bridges.Constraint.AbstractBridge

`SetDotInverseScalingBridge` implements the reformulation from constraints
in the `MOI.Scaled{S}` to constraints in the `S`.

## Source node

`SetDotInverseScalingBridge` supports:

  * `G` in [`MOI.Scaled{S}`](@ref MOI.Scaled)

## Target node

`SetDotInverseScalingBridge` creates:

  * `F` in `S`
"""
struct SetDotInverseScalingBridge{T,S<:MOI.AbstractVectorSet,F,G} <:
       SetMapBridge{T,S,MOI.Scaled{S},F,G}
    constraint::MOI.ConstraintIndex{F,S}
end

const SetDotInverseScaling{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SetDotInverseScalingBridge{T},OT}

function concrete_bridge_type(
    ::Type{<:SetDotInverseScalingBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.Scaled{S}},
) where {T,S<:MOI.AbstractVectorSet}
    F = MOI.Utilities.promote_operation(
        *,
        T,
        LinearAlgebra.Diagonal{T,Vector{T}},
        G,
    )
    return SetDotInverseScalingBridge{T,S,F,G}
end

function MOI.Bridges.map_set(
    ::Type{<:SetDotInverseScalingBridge{T,S}},
    set::MOI.Scaled{S},
) where {T,S}
    return set.set
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:SetDotInverseScalingBridge{T,S}},
    set::S,
) where {T,S<:MOI.AbstractVectorSet}
    return MOI.Scaled(set)
end

function MOI.Bridges.map_function(
    ::Type{<:SetDotInverseScalingBridge{T,S}},
    func,
) where {T,S}
    return _inverse_scale(T, S, func)
end

function MOI.Bridges.inverse_map_function(
    ::Type{<:SetDotInverseScalingBridge{T,S}},
    func,
) where {T,S}
    return _scale(T, S, func)
end

function MOI.Bridges.adjoint_map_function(
    ::Type{<:SetDotInverseScalingBridge{T,S}},
    func,
) where {T,S}
    return _scale(T, S, func)
end

function MOI.Bridges.inverse_adjoint_map_function(
    ::Type{<:SetDotInverseScalingBridge{T,S}},
    func,
) where {T,S}
    return _inverse_scale(T, S, func)
end

# Since the set type is not defined, the default `MOI.supports_constraint`
# for `SetMapBridge` does not work
function MOI.supports_constraint(
    ::Type{<:SetDotScalingBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    S::Type{<:MOI.AbstractVectorSet},
) where {T}
    return MOI.Utilities.is_coefficient_type(F, T) && MOI.is_set_dot_scaled(S)
end

function MOI.supports_constraint(
    ::Type{<:SetDotInverseScalingBridge},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.Scaled{S}},
) where {S<:MOI.AbstractVectorSet}
    return true
end

# TODO remove in MOI v2
const SymmetricMatrixScalingBridge = SetDotScalingBridge
const SymmetricMatrixInverseScalingBridge = SetDotInverseScalingBridge

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    VectorSlackBridge{T,F,G}

`VectorSlackBridge` implements the following reformulations:

 * ``\\min\\{f(x)\\}`` into ``\\min\\{y\\;|\\; y - f(x) \\in \\mathbb{R}_+ \\}``
 * ``\\max\\{f(x)\\}`` into ``\\max\\{y\\;|\\; f(x) - y \\in \\mathbb{R}_+ \\}``

where `F` is the type of `f(x) - y`, `G` is the type of `f(x)`, and `T` is the
coefficient type of `f(x)`.

## Source node

`VectorSlackBridge` supports:

 * [`MOI.ObjectiveFunction{G}`](@ref)

## Target nodes

`VectorSlackBridge` creates:

 * One variable node: [`MOI.VectorOfVariables`](@ref) in [`MOI.Reals`](@ref)
 * One objective node: [`MOI.ObjectiveFunction{MOI.VectorOfVariables}`](@ref)
 * One constraint node: `F`-in-[`MOI.Nonnegatives`](@ref)

!!! warning
    When using this bridge, changing the optimization sense is not supported.
    Set the sense to `MOI.FEASIBILITY_SENSE` first to delete the bridge, then
    set [`MOI.ObjectiveSense`](@ref) and re-add the objective.
"""
struct VectorSlackBridge{
    T,
    F<:MOI.AbstractVectorFunction,
    G<:MOI.AbstractVectorFunction,
} <: AbstractBridge
    variables::Vector{MOI.VariableIndex}
    slacked_objectives::Vector{Int}
    constraint::MOI.ConstraintIndex{F,MOI.Nonnegatives}
end

const VectorSlack{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{VectorSlackBridge{T},OT}

function bridge_objective(
    ::Type{VectorSlackBridge{T,F,G}},
    model::MOI.ModelLike,
    func::G,
) where {T,F,G<:MOI.AbstractVectorFunction}
    variables, slacked_objectives = MOI.VariableIndex[], Int[]
    funcs = MOI.Utilities.eachscalar(func)
    for (i, fi) in enumerate(funcs)
        try
            push!(variables, convert(MOI.VariableIndex, fi))
        catch
            push!(variables, MOI.add_variable(model))
            push!(slacked_objectives, i)
        end
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.VectorOfVariables}(),
        MOI.VectorOfVariables(variables),
    )
    sense = MOI.get(model, MOI.ObjectiveSense())
    if sense == MOI.FEASIBILITY_SENSE
        msg = "Set `MOI.ObjectiveSense` before `MOI.ObjectiveFunction` when using `MOI.Bridges.Objective.VectorSlackBridge`."
        throw(MOI.SetAttributeNotAllowed(MOI.ObjectiveFunction{G}(), msg))
    end
    slacks = MOI.VectorOfVariables(variables[slacked_objectives])
    f = if sense == MOI.MIN_SENSE
        MOI.Utilities.operate(-, T, slacks, funcs[slacked_objectives])
    else
        @assert sense == MOI.MAX_SENSE
        MOI.Utilities.operate(-, T, funcs[slacked_objectives], slacks)
    end
    set = MOI.Nonnegatives(length(slacked_objectives))
    ci = MOI.add_constraint(model, f, set)
    return VectorSlackBridge{T,F,G}(variables, slacked_objectives, ci)
end

function supports_objective_function(
    ::Type{<:VectorSlackBridge{T}},
    ::Type{MOI.VectorOfVariables},
) where {T}
    return false
end

function supports_objective_function(
    ::Type{<:VectorSlackBridge{T}},
    ::Type{F},
) where {T,F<:MOI.AbstractVectorFunction}
    return MOI.Utilities.is_coefficient_type(F, T)
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:VectorSlackBridge},
)
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:VectorSlackBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[(F, MOI.Nonnegatives)]
end

function MOI.Bridges.set_objective_function_type(::Type{<:VectorSlackBridge})
    return MOI.VectorOfVariables
end

function concrete_bridge_type(
    ::Type{<:VectorSlackBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
) where {T}
    F = MOI.Utilities.promote_operation(-, T, G, MOI.VectorOfVariables)
    return VectorSlackBridge{T,F,G}
end

function MOI.get(bridge::VectorSlackBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.slacked_objectives)
end

function MOI.get(bridge::VectorSlackBridge, ::MOI.ListOfVariableIndices)
    return bridge.variables[bridge.slacked_objectives]
end

function MOI.get(
    bridge::VectorSlackBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.Nonnegatives},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    bridge::VectorSlackBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.Nonnegatives},
) where {T,F}
    return [bridge.constraint]
end

function MOI.delete(model::MOI.ModelLike, bridge::VectorSlackBridge)
    MOI.delete(model, bridge.constraint)
    MOI.delete(model, MOI.get(bridge, MOI.ListOfVariableIndices()))
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr_g::MOI.Bridges.ObjectiveFunctionValue{G},
    bridge::VectorSlackBridge{T,F,G},
) where {T,F,G}
    N = attr_g.result_index
    attr_f = MOI.Bridges.ObjectiveFunctionValue{MOI.VectorOfVariables}(N)
    objective_value = MOI.get(model, attr_f)
    con_primal = MOI.get(
        model,
        MOI.ConstraintPrimal(attr_g.result_index),
        bridge.constraint,
    )
    sense = MOI.get(model, MOI.ObjectiveSense())
    if sense == MOI.MIN_SENSE
        # con_primal = objective_value - f(x)
        for (i, con_p) in zip(bridge.slacked_objectives, con_primal)
            objective_value[i] -= con_p
        end
    else
        @assert sense == MOI.MAX_SENSE
        # con_primal = f(x) - objective_value
        for (i, con_p) in zip(bridge.slacked_objectives, con_primal)
            objective_value[i] += con_p
        end
    end
    return objective_value
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ObjectiveFunction{G},
    bridge::VectorSlackBridge{T,F,G},
) where {T,F,G<:MOI.AbstractVectorFunction}
    f = MOI.VectorOfVariables(bridge.variables)

    con_f = MOI.get(model, MOI.ConstraintFunction(), bridge.constraint)
    if MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
        # con_f = y - func so we need to negate it. Nothing to do in the
        # MAX_SENSE case.
        con_f = MOI.Utilities.operate(-, T, con_f)
    end
    con_fs = MOI.Utilities.eachscalar(con_f)
    f_map = Dict(i => fi for (i, fi) in zip(bridge.slacked_objectives, con_fs))
    args = [get(f_map, i, x) for (i, x) in enumerate(bridge.variables)]
    g = MOI.Utilities.operate(vcat, T, args...)
    slacks = bridge.variables[bridge.slacked_objectives]
    g = MOI.Utilities.remove_variable(g, slacks)
    return MOI.Utilities.convert_approx(G, g)
end

function MOI.modify(
    ::MOI.ModelLike,
    ::VectorSlackBridge{T},
    change::MOI.VectorConstantChange{T},
) where {T}
    return throw(MOI.ModifyObjectiveNotAllowed(change))
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSetConversion

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

struct Zero <: MOI.AbstractScalarSet end

function MOI.Bridges.Constraint.conversion_cost(
    ::Type{MOI.EqualTo{Float64}},
    ::Type{Zero},
)
    return 1.0
end

Base.convert(::Type{MOI.EqualTo{Float64}}, ::Zero) = MOI.EqualTo(0.0)

function Base.convert(::Type{Zero}, s::MOI.EqualTo)
    if !iszero(s.value)
        throw(InexactError(convert, (Zero, s)))
    end
    return Zero()
end

# Does not make sense that this is convertible but it's
# just to test `conversion_cost`
function MOI.Bridges.Constraint.conversion_cost(
    ::Type{MOI.LessThan{Float64}},
    ::Type{Zero},
)
    return 10.0
end

const EqualToBridge{T,S1,F} =
    MOI.Bridges.Constraint.SetConversionBridge{T,MOI.EqualTo{T},S1,F}

function test_runtests()
    MOI.Bridges.runtests(
        EqualToBridge,
        model -> begin
            x = MOI.add_variable(model)
            MOI.add_constraint(model, x, Zero())
        end,
        model -> begin
            x = MOI.add_variable(model)
            MOI.add_constraint(model, x, MOI.EqualTo(0.0))
        end,
    )
    return
end

function test_conversion_cost(T = Float64)
    model = MOI.Utilities.Model{T}()
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    MOI.Bridges.add_bridge(
        bridged,
        MOI.Bridges.Constraint.SetConversionBridge{T,MOI.LessThan{T}},
    )
    @test MOI.Bridges.bridge_type(bridged, MOI.VariableIndex, Zero) ==
          MOI.Bridges.Constraint.SetConversionBridge{
        T,
        MOI.LessThan{T},
        Zero,
        MOI.VariableIndex,
    }
    MOI.Bridges.add_bridge(
        bridged,
        MOI.Bridges.Constraint.SetConversionBridge{T,MOI.EqualTo{T}},
    )
    @test MOI.Bridges.bridge_type(bridged, MOI.VariableIndex, Zero) ==
          MOI.Bridges.Constraint.SetConversionBridge{
        T,
        MOI.EqualTo{T},
        Zero,
        MOI.VariableIndex,
    }
end

end  # module

TestConstraintSetConversion.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

_parse(::Type{T}, x::AbstractString) where {T} = parse(T, x)
_parse(::Type{String}, x::AbstractString) = String(x)

_read(io::IO, ::Type{T}) where {T} = _parse(T, strip(readline(io)))

function _read(io::IO, args...)
    x = split(strip(readline(io)))
    @assert length(x) == length(args)
    return _parse.(args, x)
end

mutable struct _CBFReadData
    scalar_vars::Vector{MOI.VariableIndex}
    psd_vars::Vector{Vector{MOI.VariableIndex}}
    psd_side_dims::Vector{Int}
    psd_row_starts::Vector{Int}
    psd_row_terms::Vector{Vector{MOI.ScalarAffineTerm{Float64}}}
    psd_row_constants::Vector{Float64}
    obj_terms::Vector{MOI.ScalarAffineTerm{Float64}}
    obj_constant::Float64
    power_cone_alpha::Vector{Vector{Float64}}
    dual_power_cone_alpha::Vector{Vector{Float64}}
    con_cones::Vector{Tuple{String,Int}}
    row_terms::Vector{Vector{MOI.ScalarAffineTerm{Float64}}}
    row_constants::Vector{Float64}

    function _CBFReadData()
        return new(
            MOI.VariableIndex[],
            Vector{MOI.VariableIndex}[],
            Int[],
            Int[],
            Vector{MOI.ScalarAffineTerm{Float64}}[],
            Float64[],
            MOI.ScalarAffineTerm{Float64}[],
            0.0,
            Vector{Float64}[],
            Vector{Float64}[],
            Tuple{String,Int}[],
            Vector{MOI.ScalarAffineTerm{Float64}}[],
            Float64[],
        )
    end
end

# Convert a pair of row and column indices of a symmetric matrix into a vector
# index for the row-wise lower triangle
function _mat_to_vec_idx(i::Int, j::Int)
    if i < j
        return div((j - 1) * j, 2) + i
    else
        return div((i - 1) * i, 2) + j
    end
end

function _cbf_to_moi_cone(
    data::_CBFReadData,
    cone_str::AbstractString,
    cone_dim::Int,
)
    if cone_str == "F"
        return MOI.Reals(cone_dim)
    elseif cone_str == "L="
        return MOI.Zeros(cone_dim)
    elseif cone_str == "L-"
        return MOI.Nonpositives(cone_dim)
    elseif cone_str == "L+"
        return MOI.Nonnegatives(cone_dim)
    elseif cone_str == "Q"
        @assert cone_dim >= 2
        return MOI.SecondOrderCone(cone_dim)
    elseif cone_str == "QR"
        @assert cone_dim >= 3
        return MOI.RotatedSecondOrderCone(cone_dim)
    elseif cone_str == "EXP"
        return MOI.ExponentialCone()
    elseif cone_str == "EXP*"
        return MOI.DualExponentialCone()
    elseif startswith(cone_str, "@")
        raw_powcone_info = split(cone_str[2:end], ":")
        powcone_idx = parse(Int, raw_powcone_info[1]) + 1
        if raw_powcone_info[2] == "POW"
            alpha = data.power_cone_alpha[powcone_idx]
            return MOI.PowerCone{Float64}(first(alpha) / sum(alpha))
        elseif raw_powcone_info[2] == "POW*"
            alpha = data.dual_power_cone_alpha[powcone_idx]
            return MOI.DualPowerCone{Float64}(first(alpha) / sum(alpha))
        end
    end
    return error("CBF cone name $cone_str is not recognized or supported.")
end

function _read_VER(io::IO)
    version = _read(io, Int)
    if !(1 <= version <= 3)
        error("CBF version number $(version) is not yet supported.")
    end
    return
end

function _read_POWCONES(io::IO, model::Model, alpha::Vector{Vector{Float64}})
    num_powcone, num_lines = _read(io, Int, Int)
    alpha_idx = 0
    for _ in 1:num_powcone
        num_alpha = _read(io, Int)
        if num_alpha != 2
            error("Only 3-dimensional power cones are supported.")
        end
        push!(alpha, [_read(io, Float64) for _ in 1:num_alpha])
        alpha_idx += num_alpha
    end
    @assert num_lines == alpha_idx
    return
end

function _read_OBJSENSE(io::IO, model::Model)
    obj_sense = strip(readline(io))
    if obj_sense == "MIN"
        MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    else
        @assert obj_sense == "MAX"
        MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    end
    return
end

function _read_PSDVAR(io::IO, model::Model, data::_CBFReadData)
    for _ in 1:_read(io, Int)
        side_dim = _read(io, Int)
        set = MOI.PositiveSemidefiniteConeTriangle(side_dim)
        x, _ = MOI.add_constrained_variables(model, set)
        push!(data.psd_vars, x)
    end
    return
end

function _read_VAR(io::IO, model::Model, data::_CBFReadData)
    _, num_lines = _read(io, Int, Int)
    for _ in 1:num_lines
        cone_str, cone_dim = _read(io, String, Int)
        set = _cbf_to_moi_cone(data, cone_str, cone_dim)
        if cone_str == "F"
            # Free cones (no constraint).
            append!(data.scalar_vars, MOI.add_variables(model, cone_dim))
        elseif cone_str == "EXP" || cone_str == "EXP*"
            # The convention in CBF is the reverse of MOI
            x, _ = MOI.add_constrained_variables(model, set)
            append!(data.scalar_vars, reverse(x))
        else
            x, _ = MOI.add_constrained_variables(model, set)
            append!(data.scalar_vars, x)
        end
    end
    return
end

function _read_INT(io::IO, model::Model, data::_CBFReadData)
    for _ in 1:_read(io, Int)
        MOI.add_constraint(
            model,
            data.scalar_vars[_read(io, Int)+1],
            MOI.Integer(),
        )
    end
    return
end

function _read_PSDCON(io::IO, data::_CBFReadData)
    idx = 0
    for _ in 1:_read(io, Int)
        side_dim = _read(io, Int)
        push!(data.psd_side_dims, side_dim)
        push!(data.psd_row_starts, idx)
        idx += div(side_dim * (side_dim + 1), 2)
    end
    for _ in 1:idx
        push!(data.psd_row_terms, MOI.ScalarAffineTerm{Float64}[])
        push!(data.psd_row_constants, 0.0)
    end
    return
end

function _read_CON(io::IO, data::_CBFReadData)
    num_rows, num_lines = _read(io, Int, Int)
    row_idx = 0
    for _ in 1:num_lines
        cone_str, cone_dim = _read(io, String, Int)
        push!(data.con_cones, (cone_str, cone_dim))
        row_idx += cone_dim
    end
    for _ in 1:num_rows
        push!(data.row_terms, MOI.ScalarAffineTerm{Float64}[])
        push!(data.row_constants, 0.0)
    end
    return
end

function _read_OBJFCOORD(io::IO, data::_CBFReadData)
    for _ in 1:_read(io, Int)
        psd_var_idx, i, j, coef = _read(io, Int, Int, Int, Float64)
        if i != j
            coef += coef # scale off-diagonals
        end
        push!(
            data.obj_terms,
            MOI.ScalarAffineTerm{Float64}(
                coef,
                data.psd_vars[psd_var_idx+1][_mat_to_vec_idx(i + 1, j + 1)],
            ),
        )
    end
    return
end

function _read_OBJACOORD(io::IO, data::_CBFReadData)
    for _ in 1:_read(io, Int)
        var_idx, coef = _read(io, Int, Float64)
        push!(
            data.obj_terms,
            MOI.ScalarAffineTerm{Float64}(coef, data.scalar_vars[var_idx+1]),
        )
    end
    return
end

function _read_OBJBCOORD(io::IO, data::_CBFReadData)
    data.obj_constant += _read(io, Float64)
    return
end

function _read_FCOORD(io::IO, data::_CBFReadData)
    for _ in 1:_read(io, Int)
        row_idx, psd_var_idx, i, j, coef =
            _read(io, Int, Int, Int, Int, Float64)
        if i != j
            coef += coef # scale off-diagonals
        end
        push!(
            data.row_terms[row_idx+1],
            MOI.ScalarAffineTerm{Float64}(
                coef,
                data.psd_vars[psd_var_idx+1][_mat_to_vec_idx(i + 1, j + 1)],
            ),
        )
    end
    return
end

function _read_ACOORD(io::IO, data::_CBFReadData)
    for _ in 1:_read(io, Int)
        row, col, coef = _read(io, Int, Int, Float64)
        push!(
            data.row_terms[row+1],
            MOI.ScalarAffineTerm{Float64}(coef, data.scalar_vars[col+1]),
        )
    end
    return
end

function _read_BCOORD(io::IO, data::_CBFReadData)
    for _ in 1:_read(io, Int)
        row, coef = _read(io, Int, Float64)
        data.row_constants[row+1] = coef
    end
    return
end

function _read_HCOORD(io::IO, data::_CBFReadData)
    for _ in 1:_read(io, Int)
        psd_idx, var_idx, i, j, coef = _read(io, Int, Int, Int, Int, Float64)
        row_idx = data.psd_row_starts[psd_idx+1] + _mat_to_vec_idx(i + 1, j + 1)
        push!(
            data.psd_row_terms[row_idx],
            MOI.ScalarAffineTerm{Float64}(coef, data.scalar_vars[var_idx+1]),
        )
    end
    return
end

function _read_DCOORD(io::IO, data::_CBFReadData)
    for _ in 1:_read(io, Int)
        psd_idx, i, j, coef = _read(io, Int, Int, Int, Float64)
        row_idx = data.psd_row_starts[psd_idx+1] + _mat_to_vec_idx(i + 1, j + 1)
        data.psd_row_constants[row_idx] += coef
    end
    return
end

"""
    Base.read!(io::IO, model::FileFormats.CBF.Model)

Read `io` in the Conic Benchmark Format and store the result in `model`.
"""
function Base.read!(io::IO, model::Model)
    if !MOI.is_empty(model)
        error("Cannot read in file because model is not empty.")
    end
    data = _CBFReadData()
    while !eof(io)
        line = strip(readline(io))
        if isempty(line) || startswith(line, "#")
            # Skip blank lines and comments.
        elseif line == "VER"
            _read_VER(io)
        elseif line == "POWCONES"
            _read_POWCONES(io, model, data.power_cone_alpha)
        elseif line == "POW*CONES"
            _read_POWCONES(io, model, data.dual_power_cone_alpha)
        elseif line == "OBJSENSE"
            _read_OBJSENSE(io, model)
        elseif line == "PSDVAR"
            _read_PSDVAR(io, model, data)
        elseif line == "VAR"
            _read_VAR(io, model, data)
        elseif line == "INT"
            _read_INT(io, model, data)
        elseif line == "PSDCON"
            _read_PSDCON(io, data)
        elseif line == "CON"
            _read_CON(io, data)
        elseif line == "OBJFCOORD"
            _read_OBJFCOORD(io, data)
        elseif line == "OBJACOORD"
            _read_OBJACOORD(io, data)
        elseif line == "OBJBCOORD"
            _read_OBJBCOORD(io, data)
        elseif line == "FCOORD"
            _read_FCOORD(io, data)
        elseif line == "ACOORD"
            _read_ACOORD(io, data)
        elseif line == "BCOORD"
            _read_BCOORD(io, data)
        elseif line == "HCOORD"
            _read_HCOORD(io, data)
        elseif line == "DCOORD"
            _read_DCOORD(io, data)
        else
            error("Failed to parse CBF file due to corrupted line: $line")
        end
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction(data.obj_terms, data.obj_constant),
    )

    # Non-PSD constraints.
    row_idx = 0
    for (cone_str, cone_dim) in data.con_cones
        con_func = if cone_str == "EXP" || cone_str == "EXP*"
            # Reverse order of indices.
            MOI.VectorAffineFunction(
                [
                    MOI.VectorAffineTerm{Float64}(4 - l, t) for
                    l in 1:cone_dim for t in data.row_terms[row_idx+l]
                ],
                data.row_constants[row_idx .+ (3:-1:1)],
            )
        else
            MOI.VectorAffineFunction(
                [
                    MOI.VectorAffineTerm{Float64}(l, t) for l in 1:cone_dim
                    for t in data.row_terms[row_idx+l]
                ],
                data.row_constants[row_idx .+ (1:cone_dim)],
            )
        end
        con_set = _cbf_to_moi_cone(data, cone_str, cone_dim)
        MOI.add_constraint(model, con_func, con_set)
        row_idx += cone_dim
    end

    # PSD constraints.
    for psd_idx in eachindex(data.psd_side_dims)
        row_start = data.psd_row_starts[psd_idx]
        side_dim = data.psd_side_dims[psd_idx]
        cone_dim = div(side_dim * (side_dim + 1), 2)
        con_func = MOI.VectorAffineFunction(
            [
                MOI.VectorAffineTerm{Float64}(l, t) for l in 1:cone_dim for
                t in data.psd_row_terms[row_start+l]
            ],
            data.psd_row_constants[row_start .+ (1:cone_dim)],
        )
        MOI.add_constraint(
            model,
            con_func,
            MOI.PositiveSemidefiniteConeTriangle(side_dim),
        )
    end

    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestObjectiveVectorFunctionize

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.VectorFunctionizeBridge,
        """
        variables: x, y
        minobjective: [x, y]
        """,
        """
        variables: x, y
        minobjective: [1.0 * x + 0.0, 1.0 * y + 0.0]
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.VectorFunctionizeBridge,
        """
        variables: x, y
        maxobjective: [x, y]
        """,
        """
        variables: x, y
        maxobjective: [1.0 * x + 0.0, 1.0 * y + 0.0]
        """,
    )
    return
end

function test_objective_function_value()
    inner = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Bridges.Objective.VectorFunctionize{Float64}(inner)
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: x, y
        minobjective: [x, y]
        """,
    )
    MOI.Utilities.set_mock_optimize!(
        inner,
        mock -> MOI.Utilities.mock_optimize!(mock, [3.0, 5.6]),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ObjectiveValue()) ≈ [3.0, 5.6]
    return
end

function test_set_objective_sense()
    inner = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Bridges.Objective.VectorFunctionize{Float64}(inner)
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: x, y
        minobjective: [x, y]
        """,
    )
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    return
end

end  # module

TestObjectiveVectorFunctionize.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintCountDistinct

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CountDistinctToMILPBridge,
        """
        variables: a, n, x, y
        [n, x, y] in CountDistinct(3)
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        a in ZeroOne()
        """,
        """
        variables: a, n, x, y, z_x1, z_x2, z_y2, z_y3, a_1, a_2, a_3
        1.0 * x + -1.0 * z_x1 + -2.0 * z_x2 == 0.0
        1.0 * y + -2.0 * z_y2 + -3.0 * z_y3 == 0.0
        -1.0 * n + a_1 + a_2 + a_3 == 0.0
        z_x1 + z_x2 == 1.0
        z_y2 + z_y3 == 1.0
        z_x1 + -1.0 * a_1 <= 0.0
        z_x2 + z_y2 + -2.0 * a_2 <= 0.0
        z_y3 + -1.0 * a_3 <= 0.0
        a_1 + -1.0 * z_x1 <= 0.0
        a_2 + -1.0 * z_x2 + -1.0 * z_y2 <= 0.0
        a_3 + -1.0 * z_y3 <= 0.0
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        z_x1 in ZeroOne()
        z_x2 in ZeroOne()
        z_y2 in ZeroOne()
        z_y3 in ZeroOne()
        a_1 in ZeroOne()
        a_2 in ZeroOne()
        a_3 in ZeroOne()
        a in ZeroOne()
        """,
    )
    return
end

function test_runtests_VectorOfVariables_NotEqualTo()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CountDistinctToMILPBridge,
        """
        variables: n, x, y
        [n, x, y] in CountDistinct(3)
        x in Interval(1.0, 4.0)
        y >= 2.0
        y <= 5.0
        n == 2.0
        """,
        """
        variables: n, x, y, z
        1.0 * x + -1.0 * y + -3.0 * z <= -1.0
        1.0 * y + -1.0 * x + 5.0 * z <= 4.0
        x in Interval(1.0, 4.0)
        y >= 2.0
        y <= 5.0
        n == 2.0
        z in ZeroOne()
        """,
    )
    return
end

function test_runtests_VectorAffineFunction()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CountDistinctToMILPBridge,
        """
        variables: d, x, y
        [d, 2.0 * x + -1.0, y] in CountDistinct(3)
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        """,
        """
        variables: d, x, y, z_x1, z_x2, z_x3, z_y2, z_y3, a_1, a_2, a_3
        2.0 * x + -1.0 * z_x1 + -2.0 * z_x2 + -3.0 * z_x3 == 1.0
        1.0 * y + -2.0 * z_y2 + -3.0 * z_y3 == 0.0
        a_1 + a_2 + a_3 + -1.0 * d == 0.0
        z_x1 + z_x2 + z_x3 == 1.0
        z_y2 + z_y3 == 1.0
        z_x1 + -1.0 * a_1 <= 0.0
        z_x2 + z_y2 + -2.0 * a_2 <= 0.0
        z_x3 + z_y3 + -2.0 * a_3 <= 0.0
        a_1 + -1.0 * z_x1 <= 0.0
        a_2 + -1.0 * z_x2 + -1.0 * z_y2 <= 0.0
        a_3 + -1.0 * z_x3 + -1.0 * z_y3 <= 0.0
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        z_x1 in ZeroOne()
        z_x2 in ZeroOne()
        z_x3 in ZeroOne()
        z_y2 in ZeroOne()
        z_y3 in ZeroOne()
        a_1 in ZeroOne()
        a_2 in ZeroOne()
        a_3 in ZeroOne()
        """,
    )
    return
end

function test_resolve_with_modified()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountDistinctToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint.(model, x, MOI.Interval(0, 2))
    MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.CountDistinct(3))
    @test MOI.get(inner, MOI.NumberOfVariables()) == 3
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 12
    MOI.set(model, MOI.ConstraintSet(), c[3], MOI.Interval(0, 1))
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 11
    return
end

function test_runtests_error_variable()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountDistinctToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    f = MOI.VectorOfVariables(x)
    c = MOI.add_constraint(model, f, MOI.CountDistinct(3))
    BT = typeof(model.map[c])
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,MOI.VariableIndex},
        MOI.Bridges.final_touch(model),
    )
    return
end

function test_runtests_error_affine()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountDistinctToMILP{Int}(inner)
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, Int, 2, 1 * x[1], x[2])
    c = MOI.add_constraint(model, f, MOI.CountDistinct(3))
    BT = typeof(model.map[c])
    F = MOI.ScalarAffineFunction{Int}
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,F},
        MOI.Bridges.final_touch(model),
    )
    return
end

function test_resolve_with_modified_not_equal_to()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountDistinctToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint.(model, x[2:3], MOI.Interval(0, 2))
    MOI.add_constraint(model, x[1], MOI.EqualTo(2))
    MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.CountDistinct(3))
    @test MOI.get(inner, MOI.NumberOfVariables()) == 3
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 4
    MOI.set(model, MOI.ConstraintSet(), c[2], MOI.Interval(0, 1))
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 4
    return
end

end  # module

TestConstraintCountDistinct.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableSOCtoRSOC

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_soc1v()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Variable.SOCtoRSOC{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1 / √2 + 1 / 2, 1 / √2 - 1 / 2, 1 / √2],
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) => [[-√2]],
        )
    MOI.Test.test_conic_SecondOrderCone_VectorOfVariables(
        bridged_mock,
        MOI.Test.Config(),
    )
    ceqs = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Zeros,
        }(),
    )
    @test length(ceqs) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), ceqs[1], "ceq")

    var_names = ["a", "b", "c"]
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    rsocs = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorOfVariables,
            MOI.RotatedSecondOrderCone,
        }(),
    )
    @test length(rsocs) == 1
    MOI.set(mock, MOI.ConstraintName(), rsocs[1], "rsoc")

    invs2 = 1 / √2
    s = """
    variables: a, b, c
    rsoc: [a, b, c] in RotatedSecondOrderCone(3)
    ceq: [$invs2*a + $invs2*b + -1.0] in Zeros(1)
    maxobjective: $invs2*a + -$invs2*b + c
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(mock, model, var_names, ["rsoc", "ceq"])
    var_names = ["x", "y", "z"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    socs = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.SecondOrderCone}(),
    )
    @test length(socs) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), socs[1], "soc")

    s = """
    variables: x, y, z
    soc: [x, y, z] in SecondOrderCone(3)
    ceq: [x + -1.0] in Zeros(1)
    maxobjective: y + z
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["soc", "ceq"],
    )
    xyz = MOI.get(bridged_mock, MOI.ListOfVariableIndices())

    message = string(
        "Cannot delete variable as it is constrained with other",
        " variables in a `MOI.VectorOfVariables`.",
    )
    for i in eachindex(xyz)
        err = MOI.DeleteNotAllowed(xyz[i], message)
        @test_throws err MOI.delete(bridged_mock, xyz[i])
    end

    _test_delete_bridged_variables(
        bridged_mock,
        xyz,
        MOI.SecondOrderCone,
        3,
        ((MOI.VectorOfVariables, MOI.RotatedSecondOrderCone, 0),),
    )
    return
end

function test_dimension_1()
    model =
        MOI.Bridges.Variable.SOCtoRSOC{Float64}(MOI.Utilities.Model{Float64}())
    @test_throws(
        ErrorException,
        MOI.add_constrained_variables(model, MOI.SecondOrderCone(1)),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.SOCtoRSOCBridge,
        """
        constrainedvariable: [t, u, x] in SecondOrderCone(3)
        a: 1.0 * t <= 1.0
        b: 1.0 * u <= 1.0
        c: 1.0 * x <= 1.0
        """,
        """
        constrainedvariable: [t, u, x] in RotatedSecondOrderCone(3)
        a: 0.7071067811865475 * t + 0.7071067811865475 * u <= 1.0
        b: 0.7071067811865475 * t + -0.7071067811865475 * u <= 1.0
        c: 1.0 * x <= 1.0
        """,
    )
    return
end

function test_adjoint_map_function()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.SOCtoRSOC{Float64}(inner)
    x, _ = MOI.add_constrained_variables(model, MOI.SecondOrderCone(3))
    @test MOI.Bridges.adjoint_map_function(model.map[first(x)], [2, 0.5, 1]) ≈
          [2.5 / sqrt(2), +1.5 / sqrt(2), 1.0]
    return
end

function test_ConstraintPrimalStart()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.SOCtoRSOC{Float64}(inner)
    x, ci = MOI.add_constrained_variables(model, MOI.SecondOrderCone(3))
    @test MOI.supports(model, MOI.ConstraintPrimalStart(), typeof(ci))
    MOI.set(model, MOI.ConstraintPrimalStart(), ci, [2, 0.5, 1])
    @test MOI.get(model, MOI.ConstraintPrimalStart(), ci) ≈ [2, 0.5, 1]
    MOI.set(model, MOI.ConstraintPrimalStart(), ci, nothing)
    @test MOI.get(model, MOI.ConstraintPrimalStart(), ci) === nothing
    return
end

function test_ConstraintDualStart()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.SOCtoRSOC{Float64}(inner)
    x, ci = MOI.add_constrained_variables(model, MOI.SecondOrderCone(3))
    @test MOI.supports(model, MOI.ConstraintDualStart(), typeof(ci))
    MOI.set(model, MOI.ConstraintDualStart(), ci, [2, 0.5, 1])
    @test MOI.get(model, MOI.ConstraintDualStart(), ci) ≈ [2, 0.5, 1]
    MOI.set(model, MOI.ConstraintDualStart(), ci, nothing)
    @test MOI.get(model, MOI.ConstraintDualStart(), ci) === nothing
    return
end

end  # module

TestVariableSOCtoRSOC.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintDet

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_LogDet_basic()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.LogDet{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        MOI.Test.Config(),
        include = [
            "test_basic_VectorOfVariables_LogDetCone",
            "test_basic_VectorAffineFunction_LogDetCone",
            "test_basic_VectorQuadraticFunction_LogDetCone",
        ],
    )
    return
end

function _setup_LogDetConeTriangle(
    mock::MOI.Utilities.MockOptimizer,
    ::Type{F},
) where {F}
    var_primal = [0, 1, 0, 1, 1, 0, 1, 0, 0, 1]
    exp_duals = [[-1, -1, 1], [-1, -1, 1]]
    psd_dual = [1, 0, 1, -1, 0, 1, 0, -1, 0, 1]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.VariableIndex, MOI.EqualTo{Float64}) => [2],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [[1, 1]],
            (F, MOI.ExponentialCone) => exp_duals,
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [psd_dual],
        )
    return
end

function test_conic_LogDetConeTriangle()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        eval_variable_constraint_dual = false,
    )
    bridged_mock = MOI.Bridges.Constraint.LogDet{Float64}(mock)
    config = MOI.Test.Config()
    _setup_LogDetConeTriangle(mock, MOI.VectorOfVariables)
    MOI.Test.test_conic_LogDetConeTriangle_VectorOfVariables(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    _setup_LogDetConeTriangle(mock, MOI.VectorAffineFunction{Float64})
    MOI.Test.test_conic_LogDetConeTriangle_VectorAffineFunction(
        bridged_mock,
        config,
    )

    # set primal/dual start is not yet implemented for LogDet bridge
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.LogDetConeTriangle,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        5,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.ExponentialCone, 0),
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
                0,
            ),
        ),
    )
    return
end

function test_conic_LogDetConeTriangle_2()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.LogDet{Float64}(mock)
    var_primal =
        [log(5), 3, 2, 2 / 3, 1, 1 / 3, 2.5, log(3), log(2 / 3), log(2.5)]
    exp_duals = [
        [-1, log(3) - 1, 1 / 3],
        [-1, log(2 / 3) - 1, 3 / 2],
        [-1, log(2.5) - 1, 0.4],
    ]
    psd_dual = [
        1,
        -1,
        1.6,
        0,
        -0.2,
        0.4,
        -1 / 3,
        0,
        0,
        1 / 3,
        1,
        -1.5,
        0,
        0,
        1.5,
        0,
        0.2,
        -0.4,
        0,
        0,
        0.4,
    ]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1.0],
            (MOI.VectorAffineFunction{Float64}, MOI.ExponentialCone) =>
                exp_duals,
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [psd_dual],
        )
    config = MOI.Test.Config()
    MOI.Test.test_conic_LogDetConeTriangle(bridged_mock, config)

    # set primal/dual start is not yet implemented for LogDet bridge
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.LogDetConeTriangle,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.ExponentialCone, 0),
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
                0,
            ),
        ),
    )
    return
end

function test_conic_RootDetConeTriangle()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.RootDet{Float64}(mock)
    var_primal = [1, 1, 0, 1, 1, 0, 1]
    geomean_dual = [-1, 0.5, 0.5]
    psd_dual = [0.5, 0, 0.5, -0.5, 0, 0.5, 0, -0.5, 0, 0.5]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [[0.5, 0.5]],
            (MOI.VectorAffineFunction{Float64}, MOI.GeometricMeanCone) =>
                [geomean_dual],
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [psd_dual],
        )
    config = MOI.Test.Config()
    MOI.Test.test_conic_RootDetConeTriangle_VectorOfVariables(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_conic_RootDetConeTriangle_VectorAffineFunction(
        bridged_mock,
        config,
    )

    # set primal/dual start is not yet implemented for RootDet bridge
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.RootDetConeTriangle,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        4,
        (
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.GeometricMeanCone, 0),
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
                0,
            ),
        ),
    )
    return
end

function test_RootDet_basic()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.RootDet{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        MOI.Test.Config(),
        include = [
            "test_basic_VectorOfVariables_RootDetCone",
            "test_basic_VectorAffineFunction_RootDetCone",
            "test_basic_VectorQuadraticFunction_RootDetCone",
        ],
    )
    return
end

function test_conic_RootDetConeTriangle_2()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.RootDet{Float64}(mock)
    var_primal = [5^inv(3), 3, 2, 2 / 3, 1, 1 / 3, 2.5]
    multiplier = 5^inv(3) / 3
    geomean_dual = vcat(-1, multiplier * [inv(3), 1.5, 0.4])
    psd_dual =
        multiplier * [
            1,
            -1,
            1.6,
            0,
            -0.2,
            0.4,
            -1 / 3,
            0,
            0,
            1 / 3,
            1,
            -1.5,
            0,
            0,
            1.5,
            0,
            0.2,
            -0.4,
            0,
            0,
            0.4,
        ]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.VectorAffineFunction{Float64}, MOI.GeometricMeanCone) =>
                [geomean_dual],
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [psd_dual],
        )
    MOI.Test.test_conic_RootDetConeTriangle(bridged_mock, MOI.Test.Config())

    # set primal/dual start is not yet implemented for RootDet bridge
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.RootDetConeTriangle,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        (
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.GeometricMeanCone, 0),
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
                0,
            ),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.LogDetBridge,
        """
        variables: t, u, x11, x21, x22
        [t, u, x11, x21, x22] in LogDetConeTriangle(2)
        """,
        """
        variables: t, u, x11, x21, x22, v1, v2, v3, v4, v5
        [v4, u, v1] in ExponentialCone()
        [v5, u, v3] in ExponentialCone()
        t + -1.0 * v4 + -1.0 * v5 <= 0.0
        [x11, x21, x22, v1, v2, v1, 0, v3, 0, v3] in PositiveSemidefiniteConeTriangle(4)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.RootDetBridge,
        """
        variables: t, x11, x21, x22
        [t, x11, x21, x22] in RootDetConeTriangle(2)
        """,
        """
        variables: t, x11, x21, x22, v1, v2, v3
        [t, v1, v3] in GeometricMeanCone(3)
        [x11, x21, x22, v1, v2, v1, 0, v3, 0, v3] in PositiveSemidefiniteConeTriangle(4)
        """,
    )
    return
end

end  # module

TestConstraintDet.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module MathOptInterfaceBenchmarkToolsExt

import BenchmarkTools
import MathOptInterface as MOI

function MOI.Benchmarks.suite(
    new_model::Function;
    exclude::Vector{Regex} = Regex[],
)
    group = BenchmarkTools.BenchmarkGroup()
    for (name, func) in MOI.Benchmarks.BENCHMARKS
        if any(occursin.(exclude, Ref(name)))
            continue
        end
        group[name] = BenchmarkTools.@benchmarkable $func($new_model)
    end
    return group
end

function MOI.Benchmarks.create_baseline(
    suite::BenchmarkTools.BenchmarkGroup,
    name::String;
    directory::String = "",
    kwargs...,
)
    BenchmarkTools.tune!(suite)
    BenchmarkTools.save(
        joinpath(directory, name * "_params.json"),
        BenchmarkTools.params(suite),
    )
    results = BenchmarkTools.run(suite; kwargs...)
    BenchmarkTools.save(joinpath(directory, name * "_baseline.json"), results)
    return
end

function MOI.Benchmarks.compare_against_baseline(
    suite::BenchmarkTools.BenchmarkGroup,
    name::String;
    directory::String = "",
    report_filename::String = "report.txt",
    kwargs...,
)
    params_filename = joinpath(directory, name * "_params.json")
    baseline_filename = joinpath(directory, name * "_baseline.json")
    if !isfile(params_filename) || !isfile(baseline_filename)
        error("You create a baseline with `create_baseline` first.")
    end
    BenchmarkTools.loadparams!(
        suite,
        BenchmarkTools.load(params_filename)[1],
        :evals,
        :samples,
    )
    new_results = BenchmarkTools.run(suite; kwargs...)
    old_results = BenchmarkTools.load(baseline_filename)[1]
    open(joinpath(directory, report_filename), "w") do io
        println(stdout, "\n========== Results ==========")
        println(io, "\n========== Results ==========")
        for key in keys(new_results)
            judgement = BenchmarkTools.judge(
                BenchmarkTools.median(new_results[key]),
                BenchmarkTools.median(old_results[key]),
            )
            println(stdout, "\n", key)
            println(io, "\n", key)
            show(stdout, MIME"text/plain"(), judgement)
            show(io, MIME"text/plain"(), judgement)
        end
    end
    return
end

end # module

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    VectorizeBridge{T,S} <: Bridges.Variable.AbstractBridge

`VectorizeBridge` implements the following reformulations:

 * ``x \\ge a`` into ``[y] \\in \\mathbb{R}_+`` with the substitution
   rule ``x = a + y``
 * ``x \\le a`` into ``[y] \\in \\mathbb{R}_-`` with the substitution
   rule ``x = a + y``
 * ``x == a`` into ``[y] \\in \\{0\\}`` with the substitution
   rule ``x = a + y``

where `T` is the coefficient type of `a + y`.

## Source node

`VectorizeBridge` supports:

 * [`MOI.VariableIndex`](@ref) in [`MOI.GreaterThan{T}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.LessThan{T}`](@ref)
 * [`MOI.VariableIndex`](@ref) in [`MOI.EqualTo{T}`](@ref)

## Target nodes

`VectorizeBridge` creates:

 * One variable node: [`MOI.VectorOfVariables`](@ref) in `S`, where `S` is one
   of [`MOI.Nonnegatives`](@ref), [`MOI.Nonpositives`](@ref),
   [`MOI.Zeros`](@ref) depending on the type of ``S``.
"""
mutable struct VectorizeBridge{T,S} <: AbstractBridge
    variable::MOI.VariableIndex
    vector_constraint::MOI.ConstraintIndex{MOI.VectorOfVariables,S}
    set_constant::T # constant in scalar set
end

const Vectorize{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{VectorizeBridge{T},OT}

function bridge_constrained_variable(
    ::Type{VectorizeBridge{T,S}},
    model::MOI.ModelLike,
    set::MOI.Utilities.ScalarLinearSet{T},
) where {T,S}
    set_constant = MOI.constant(set)
    variables, vector_constraint = MOI.add_constrained_variables(model, S(1))
    return VectorizeBridge{T,S}(variables[1], vector_constraint, set_constant)
end

function supports_constrained_variable(
    ::Type{VectorizeBridge{T}},
    ::Type{<:MOI.Utilities.ScalarLinearSet{T}},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{VectorizeBridge{T,S}},
) where {T,S}
    return Tuple{Type}[(S,)]
end

function MOI.Bridges.added_constraint_types(::Type{<:VectorizeBridge})
    return Tuple{Type,Type}[]
end

function concrete_bridge_type(
    ::Type{<:VectorizeBridge{T}},
    S::Type{<:MOI.Utilities.ScalarLinearSet{T}},
) where {T}
    return VectorizeBridge{T,MOI.Utilities.vector_set_type(S)}
end

# Attributes, Bridge acting as a model
MOI.get(::VectorizeBridge, ::MOI.NumberOfVariables)::Int64 = 1

function MOI.get(bridge::VectorizeBridge, ::MOI.ListOfVariableIndices)
    return [bridge.variable]
end

function MOI.get(
    ::VectorizeBridge{T,S},
    ::MOI.NumberOfConstraints{MOI.VectorOfVariables,S},
)::Int64 where {T,S}
    return 1
end

function MOI.get(
    bridge::VectorizeBridge{T,S},
    ::MOI.ListOfConstraintIndices{MOI.VectorOfVariables,S},
) where {T,S}
    return [bridge.vector_constraint]
end

function MOI.delete(model::MOI.ModelLike, bridge::VectorizeBridge)
    # It isn't safe to delete the variable because the constant may appear in
    # other parts of the model (like the objective, or right-hand side sets).
    err = MOI.DeleteNotAllowed(
        bridge.variable,
        "Cannot delete variable because it is bridged by the `VectorizeBridge`.",
    )
    return throw(err)
end

# Attributes, Bridge acting as a constraint

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::VectorizeBridge{T,S},
) where {T,S}
    return MOI.Utilities.scalar_set_type(S, T)(bridge.set_constant)
end

function MOI.set(
    ::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::VectorizeBridge,
    ::MOI.Utilities.ScalarLinearSet,
)
    # This would require modifying any constraint which uses the bridged
    # variable.
    return throw(
        MOI.SetAttributeNotAllowed(
            attr,
            "The variable `$(bridge.variable)` is bridged by the " *
            "`VectorizeBridge`.",
        ),
    )
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::VectorizeBridge,
)
    x = MOI.get(model, attr, bridge.vector_constraint)
    y = only(x)
    status = MOI.get(model, MOI.PrimalStatus(attr.result_index))
    if !MOI.Utilities.is_ray(status)
        # If it is an infeasibility certificate, it is a ray and satisfies the
        # homogenized problem, see https://github.com/jump-dev/MathOptInterface.jl/issues/433
        # Otherwise, we need to add the set constant since the ConstraintPrimal
        # is defined as the value of the function and the set_constant was
        # removed from the original function
        y += bridge.set_constant
    end
    return y
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    bridge::VectorizeBridge,
)
    return only(MOI.get(model, attr, bridge.vector_constraint))
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimal,
    bridge::VectorizeBridge,
)
    value = MOI.get(model, attr, bridge.variable)
    status = MOI.get(model, MOI.PrimalStatus(attr.result_index))
    if MOI.Utilities.is_ray(status)
        return value  # Return the homogenized value.
    end
    return value + bridge.set_constant
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    ::Type{<:VectorizeBridge},
)
    return MOI.supports(model, attr, MOI.VariableIndex)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    bridge::VectorizeBridge,
)
    start = MOI.get(model, attr, bridge.variable)
    if start === nothing
        return nothing
    end
    return start + bridge.set_constant
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    bridge::VectorizeBridge,
    value,
)
    if value === nothing
        MOI.set(model, attr, bridge.variable, value)
    else
        MOI.set(model, attr, bridge.variable, value - bridge.set_constant)
    end
    return
end

function MOI.Bridges.bridged_function(bridge::VectorizeBridge{T}) where {T}
    return MOI.Utilities.operate(+, T, bridge.variable, bridge.set_constant)
end

function unbridged_map(
    bridge::VectorizeBridge{T},
    vi::MOI.VariableIndex,
) where {T}
    func = MOI.Utilities.operate(-, T, vi, bridge.set_constant)
    return (bridge.variable => func,)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

###
### Re-naming utilities
###

"""
    create_unique_names(
        model::MOI.ModelLike;
        warn::Bool = false,
        replacements::Vector{Function} = Function[],
    )

Rename variables in `model` to ensure that all variables and constraints have
a unique name. In addition, loop through `replacements` and replace names with
`f(name)`.

If `warn`, print a warning if a variable or constraint is renamed.
"""
function create_unique_names(
    model::MOI.ModelLike;
    warn::Bool = false,
    replacements::Vector{Function} = Function[],
)
    create_unique_variable_names(model, warn, replacements)
    create_unique_constraint_names(model, warn, replacements)
    return
end

"""
    create_generic_names(model::MOI.ModelLike)

Rename all variables and constraints in `model` to have generic names.

This is helpful for users with proprietary models to avoid leaking information.
"""
function create_generic_names(model::MOI.ModelLike)
    create_generic_variable_names(model)
    create_generic_constraint_names(model)
    return
end

function create_generic_variable_names(model::MOI.ModelLike)
    for (i, x) in enumerate(MOI.get(model, MOI.ListOfVariableIndices()))
        MOI.set(model, MOI.VariableName(), x, "C$i")
    end
    return
end

function create_generic_constraint_names(model::MOI.ModelLike)
    i = 1
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        if F != MOI.VariableIndex
            i = create_generic_constraint_names(model, F, S, i)
        end
    end
    return
end

function create_generic_constraint_names(
    model::MOI.ModelLike,
    ::Type{F},
    ::Type{S},
    i::Int,
) where {F,S}
    for c in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        MOI.set(model, MOI.ConstraintName(), c, "R$i")
        i += 1
    end
    return i
end

function _replace(s::String, replacements::Vector{Function})
    for f in replacements
        s = f(s)
    end
    return s
end

function _create_unique_constraint_names_inner(
    model,
    warn,
    replacements,
    original_names,
    added_names,
    ::Type{MOI.VariableIndex},
    ::Type{S},
) where {S}
    return  # VariableIndex constraints do not need a name.
end

function _create_unique_constraint_names_inner(
    model,
    warn,
    replacements,
    original_names,
    added_names,
    ::Type{F},
    ::Type{S},
) where {F,S}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        original_name = MOI.get(model, MOI.ConstraintName(), index)
        new_name = _replace(
            original_name != "" ? original_name : "c$(index.value)",
            replacements,
        )
        if new_name in added_names
            # We found a duplicate name. We could just append a string like
            # "_", but we're going to be clever and loop through the
            # integers to name them appropriately. Thus, if we have three
            # constraints named c, we'll end up with variables named c, c_1,
            # and c_2.
            i = 1
            tmp_name = string(new_name, "_", i)
            while tmp_name in added_names || tmp_name in original_names
                i += 1
                tmp_name = string(new_name, "_", i)
            end
            new_name = tmp_name
        end
        push!(added_names, new_name)
        if new_name != original_name
            if warn
                if original_name == ""
                    @warn(
                        "Blank name detected for constraint $(index). " *
                        "Renamed to $(new_name)."
                    )
                else
                    @warn(
                        "Duplicate name $(original_name) detected for " *
                        "constraint $(index). Renamed to $(new_name)."
                    )
                end
            end
            MOI.set(model, MOI.ConstraintName(), index, new_name)
        end
    end
    return
end

function _get_original_names_inner(
    model,
    replacements,
    original_names,
    ::Type{F},
    ::Type{S},
) where {F,S}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        name = MOI.get(model, MOI.ConstraintName(), index)
        push!(original_names, _replace(name, replacements))
    end
    return
end

function _get_original_names_inner(
    model,
    replacements,
    original_names,
    ::Type{MOI.VariableIndex},
    ::Type{S},
) where {S}
    return  # VariableIndex constraints do not need a name.
end

function create_unique_constraint_names(
    model::MOI.ModelLike,
    warn::Bool,
    replacements::Vector{Function},
)
    original_names = Set{String}()
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        _get_original_names_inner(model, replacements, original_names, F, S)
    end
    added_names = Set{String}()
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        _create_unique_constraint_names_inner(
            model,
            warn,
            replacements,
            original_names,
            added_names,
            F,
            S,
        )
    end
    return
end

function create_unique_variable_names(
    model::MOI.ModelLike,
    warn::Bool,
    replacements::Vector{Function},
)
    variables = MOI.get(model, MOI.ListOfVariableIndices())
    # This is a list of all of the names currently in the model. We're going to
    # use this to make sure we don't rename a variable to a name that already
    # exists.
    original_names = Set{String}([
        _replace(MOI.get(model, MOI.VariableName(), index), replacements)
        for index in variables
    ])
    # This set of going to store all of the names in the model so that we don't
    # add duplicates.
    added_names = Set{String}()
    for index in variables
        original_name = MOI.get(model, MOI.VariableName(), index)
        new_name = _replace(
            original_name != "" ? original_name : "x$(index.value)",
            replacements,
        )
        if new_name in added_names
            # We found a duplicate name. We could just append a string like "_",
            # but we're going to be clever and loop through the integers to name
            # them appropriately. Thus, if we have three variables named x,
            # we'll end up with variables named x, x_1, and x_2.
            i = 1
            tmp_name = string(new_name, "_", i)
            while tmp_name in added_names || tmp_name in original_names
                i += 1
                tmp_name = string(new_name, "_", i)
            end
            new_name = tmp_name
        end
        push!(added_names, new_name)
        if new_name != original_name
            if warn
                if original_name == ""
                    @warn(
                        "Blank name detected for variable $(index). Renamed to " *
                        "$(new_name)."
                    )
                else
                    @warn(
                        "Duplicate name $(original_name) detected for variable " *
                        "$(index). Renamed to $(new_name)."
                    )
                end
            end
            MOI.set(model, MOI.VariableName(), index, new_name)
        end
    end
end

###
### Compression utilities
###

function error_mode(mode::String)
    return throw(
        ArgumentError("Compressed mode must be \"r\" or \"w\". Got: $mode."),
    )
end

"""
    abstract type AbstractCompressionScheme end

Base type to implement a new compression scheme for MathOptFormat.

To do so, create a concrete subtype (for example, named after the compression scheme)
and implement:

    extension(::Val{:your_scheme_extension}) = YourScheme()
    compressed_open(f::Function, filename::String, mode::String, ::YourScheme)
"""
abstract type AbstractCompressionScheme end

struct NoCompression <: AbstractCompressionScheme end

extension(::Val) = NoCompression()

function compressed_open(
    f::Function,
    filename::String,
    mode::String,
    ::NoCompression,
)
    return Base.open(f, filename, mode)
end

struct Gzip <: AbstractCompressionScheme end

extension(::Val{:gz}) = Gzip()

function compressed_open(f::Function, filename::String, mode::String, ::Gzip)
    if mode == "w"
        return Base.open(f, CodecZlib.GzipCompressorStream, filename, mode)
    elseif mode == "r"
        return Base.open(f, CodecZlib.GzipDecompressorStream, filename, mode)
    end
    return error_mode(mode)
end

struct Bzip2 <: AbstractCompressionScheme end

extension(::Val{:bz2}) = Bzip2()

function compressed_open(f::Function, filename::String, mode::String, ::Bzip2)
    if mode == "w"
        return Base.open(f, CodecBzip2.Bzip2CompressorStream, filename, mode)
    elseif mode == "r"
        return Base.open(f, CodecBzip2.Bzip2DecompressorStream, filename, mode)
    end
    return error_mode(mode)
end

struct AutomaticCompression <: AbstractCompressionScheme end

function compressed_open(
    f::F,
    filename::String,
    mode::String,
    ::AutomaticCompression,
) where {F<:Function}
    ext = Symbol(split(filename, ".")[end])
    return compressed_open(f, filename, mode, extension(Val{ext}()))
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type AbstractBridge end

An abstract type representing a bridged constraint or variable in a
[`MOI.Bridges.AbstractBridgeOptimizer`](@ref).

All bridges must implement:

 * [`added_constrained_variable_types`](@ref)
 * [`added_constraint_types`](@ref)
 * [`MOI.get(::AbstractBridge, ::MOI.NumberOfVariables)`](@ref)
 * [`MOI.get(::AbstractBridge, ::MOI.ListOfVariableIndices)`](@ref)
 * [`MOI.get(::AbstractBridge, ::MOI.NumberOfConstraints)`](@ref)
 * [`MOI.get(::AbstractBridge, ::MOI.ListOfConstraintIndices)`](@ref)

Subtypes of `AbstractBridge` may have additional requirements. Consult their
docstrings for details.

In addition, all subtypes may optionally implement the following constraint
attributes with the bridge in place of the constraint index:

 * [`MOI.ConstraintDual`](@ref)
 * [`MOI.ConstraintPrimal`](@ref)
"""
abstract type AbstractBridge end

"""
    IndexInVector

Index of variable in vector of variables.
"""
struct IndexInVector
    value::Int
end

"""
    MOI.get(b::AbstractBridge, ::MOI.NumberOfVariables)::Int64

Return the number of variables created by the bridge `b` in the model.

See also [`MOI.NumberOfConstraints`](@ref).

## Implementation notes

 * There is a default fallback, so you need only implement this if the bridge
   adds new variables.
"""
MOI.get(::AbstractBridge, ::MOI.NumberOfVariables)::Int64 = 0

"""
    MOI.get(b::AbstractBridge, ::MOI.ListOfVariableIndices)

Return the list of variables created by the bridge `b`.

See also [`MOI.ListOfVariableIndices`](@ref).

## Implementation notes

 * There is a default fallback, so you need only implement this if the bridge
   adds new variables.
"""
MOI.get(::AbstractBridge, ::MOI.ListOfVariableIndices) = MOI.VariableIndex[]

"""
    MOI.get(b::AbstractBridge, ::MOI.NumberOfConstraints{F,S})::Int64 where {F,S}

Return the number of constraints of the type `F`-in-`S` created by the bridge
`b`.

See also [`MOI.NumberOfConstraints`](@ref).

## Implementation notes

 * There is a default fallback, so you need only implement this for the
   constraint types returned by [`added_constraint_types`](@ref).
"""
MOI.get(::AbstractBridge, ::MOI.NumberOfConstraints)::Int64 = 0

"""
    MOI.get(b::AbstractBridge, ::MOI.ListOfConstraintIndices{F,S}) where {F,S}

Return a  `Vector{ConstraintIndex{F,S}}` with indices of all constraints of
type `F`-in-`S` created by the bride `b`.

See also [`MOI.ListOfConstraintIndices`](@ref).

## Implementation notes

 * There is a default fallback, so you need only implement this for the
   constraint types returned by [`added_constraint_types`](@ref).
"""
function MOI.get(
    ::AbstractBridge,
    ::MOI.ListOfConstraintIndices{F,S},
) where {F,S}
    return MOI.ConstraintIndex{F,S}[]
end

"""
    MOI.supports(
        model::MOI.ModelLike,
        attr::MOI.AbstractConstraintAttribute,
        BT::Type{<:AbstractBridge},
    )

Return a `Bool` indicating whether `BT` supports setting `attr` to `model`.
"""
function MOI.supports(
    ::MOI.ModelLike,
    ::MOI.AbstractConstraintAttribute,
    ::Type{<:AbstractBridge},
)
    return false
end

function _attribute_error_message(attr, ::Type{B}, action) where {B}
    return "Bridge of type `$(nameof(B))` does not support " *
           "$action the attribute `$attr`. If you encountered this error " *
           "unexpectedly, it probably means your model has been " *
           "reformulated using the bridge, and you are attempting to query " *
           "an attribute that we haven't implemented yet for this bridge. " *
           "Please open an issue at https://github.com/jump-dev/MathOptInterface.jl/issues/new " *
           "and provide a reproducible example explaining what you were " *
           "trying to do."
end

"""
    function MOI.get(
        model::MOI.ModelLike,
        attr::MOI.AbstractConstraintAttribute,
        bridge::AbstractBridge,
    )

Return the value of the attribute `attr` of the model `model` for the
constraint bridged by `bridge`.
"""
function MOI.get(
    ::MOI.ModelLike,
    attr::MOI.AbstractConstraintAttribute,
    bridge::AbstractBridge,
)
    message = _attribute_error_message(attr, typeof(bridge), "accessing")
    return throw(ArgumentError(message))
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.CanonicalConstraintFunction,
    bridge::AbstractBridge,
)
    return MOI.Utilities.canonical(
        MOI.get(model, MOI.ConstraintFunction(), bridge),
    )
end

"""
    function MOI.set(
        model::MOI.ModelLike,
        attr::MOI.AbstractConstraintAttribute,
        bridge::AbstractBridge,
        value,
    )

Set the value of the attribute `attr` of the model `model` for the
constraint bridged by `bridge`.
"""
function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.AbstractConstraintAttribute,
    bridge::AbstractBridge,
    ::Any,
)
    message =
        _attribute_error_message(attr, typeof(bridge), "setting a value for")
    if MOI.is_copyable(attr) && !MOI.supports(model, attr, typeof(bridge))
        return throw(MOI.UnsupportedAttribute(attr, message))
    else
        return throw(MOI.SetAttributeNotAllowed(attr, message))
    end
end

"""
    added_constrained_variable_types(
        BT::Type{<:AbstractBridge},
    )::Vector{Tuple{Type}}

Return a list of the types of constrained variables that bridges of concrete
type `BT` add.

## Implementation notes

 * This method depends only on the type of the bridge, not the runtime value. If
   the bridge _may_ add a constrained variable, the type _must_ be included in
   the return vector.
 * If the bridge adds a free variable via [`MOI.add_variable`](@ref) or
   [`MOI.add_variables`](@ref), the return vector _must_ include `(MOI.Reals,)`.

## Example

```jldoctest
julia> MOI.Bridges.added_constrained_variable_types(
           MOI.Bridges.Variable.NonposToNonnegBridge{Float64},
       )
1-element Vector{Tuple{Type}}:
 (MathOptInterface.Nonnegatives,)
```
"""
function added_constrained_variable_types end

"""
    added_constraint_types(
        BT::Type{<:AbstractBridge},
    )::Vector{Tuple{Type,Type}}

Return a list of the types of constraints that bridges of concrete type `BT`
add.

## Implementation notes

 * This method depends only on the type of the bridge, not the runtime value. If
   the bridge _may_ add a constraint, the type _must_ be included in the
   return vector.

## Example

```jldoctest
julia> MOI.Bridges.added_constraint_types(
           MOI.Bridges.Constraint.ZeroOneBridge{Float64},
       )
2-element Vector{Tuple{Type, Type}}:
 (MathOptInterface.ScalarAffineFunction{Float64}, MathOptInterface.Interval{Float64})
 (MathOptInterface.VariableIndex, MathOptInterface.Integer)
```
"""
function added_constraint_types end

"""
    set_objective_function_type(
        BT::Type{<:Objective.AbstractBridge},
    )::Type{<:MOI.AbstractFunction}

Return the type of objective function that bridges of concrete type `BT`
set.

## Implementation notes

 * This method depends only on the type of the bridge, not the runtime value.

## Example

```jldoctest
julia> MOI.Bridges.set_objective_function_type(
           MOI.Bridges.Objective.FunctionizeBridge{Float64},
       )
MathOptInterface.ScalarAffineFunction{Float64}
```
"""
function set_objective_function_type end

"""
    needs_final_touch(bridge::AbstractBridge)::Bool

Return whether [`final_touch`](@ref) is implemented by `bridge`.
"""
needs_final_touch(::AbstractBridge) = false

"""
    final_touch(bridge::AbstractBridge, model::MOI.ModelLike)::Nothing

A function that is called immediately prior to [`MOI.optimize!`](@ref) to allow
bridges to modify their reformulations with respect to other variables and
constraints in `model`.

For example, if the correctness of `bridge` depends on the bounds of a variable
or the fact that variables are integer, then the bridge can implement
[`final_touch`](@ref) to check assumptions immediately before a call to
[`MOI.optimize!`](@ref).

If you implement this method, you must also implement
[`needs_final_touch`](@ref).
"""
function final_touch end

"""
    bridging_cost(BT::Type{<:AbstractBridge})::Float64

Return the cost of adding a bridge of type `BT`.

The default implementation for any [`AbstractBridge`](@ref) returns `1.0`, so
this method should only be implemented for bridges returning a cost different
from `1.0`.

## Example

Since the [`Bridges.Constraint.FunctionConversionBridge`](@ref) converts
constraints from a given function type to a function type to a wider one,
we want it to have lower priority.

For example, we want to prioritize bridging a
[`MOI.ScalarAffineFunction`](@ref)-in-[`MOI.LessThan`](@ref) constraint into a
[`MOI.VectorAffineFunction`](@ref)-in-[`MOI.Nonnegatives`](@ref) constraint
over bridging it to a [`MOI.ScalarQuadraticFunction`](@ref)-in-[`MOI.LessThan`](@ref)
constraint.

For this reason, the [`Bridges.Constraint.FunctionConversionBridge`](@ref) is
given a cost of `10`:

```jldoctest
julia> F = MOI.ScalarQuadraticFunction{Float64};

julia> G = MOI.ScalarAffineFunction{Float64};

julia> MOI.Bridges.bridging_cost(
           MOI.Bridges.Constraint.FunctionConversionBridge{Float64,F,G},
       )
10.0
```
"""
bridging_cost(::Type{<:AbstractBridge}) = 1.0

"""
    struct FirstBridge <: MOI.AbstractConstraintAttribute end

Returns the first bridge used to bridge the constraint.

!!! warning
    The indices of the bridge correspond to internal indices and may not
    correspond to indices of the model this attribute is got from.
"""
struct FirstBridge <: MOI.AbstractConstraintAttribute end

MOI.is_set_by_optimize(::FirstBridge) = true

MOI.get(::MOI.ModelLike, ::FirstBridge, b::MOI.Bridges.AbstractBridge) = b

function MOI.Utilities.map_indices(
    ::Any,
    ::FirstBridge,
    b::MOI.Bridges.AbstractBridge,
)
    return b
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestObjectiveToScalarNonlinear

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.ToScalarNonlinearBridge,
        """
        variables: x
        minobjective: 2.0 * x + 1.0
        """,
        """
        variables: x
        minobjective: ScalarNonlinearFunction(2.0 * x + 1.0)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.ToScalarNonlinearBridge,
        """
        variables: x
        maxobjective: 2.0 * x + 1.0
        """,
        """
        variables: x
        maxobjective: ScalarNonlinearFunction(2.0 * x + 1.0)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.ToScalarNonlinearBridge,
        """
        variables: x, y
        minobjective: 1.0 * x * x + 2.0 * x * y + 3.0 * y + 4.0
        """,
        """
        variables: x, y
        minobjective: ScalarNonlinearFunction(1.0 * x * x + 2.0 * x * y + 3.0 * y + 4.0)
        """,
    )
    return
end

function test_supports()
    for T in (Int, Float64)
        model = MOI.instantiate(MOI.Utilities.Model{T}; with_bridge_type = T)
        for (F, flag) in [
            MOI.ScalarNonlinearFunction => true,
            MOI.ScalarAffineFunction{Float64} => (T == Float64),
            MOI.ScalarAffineFunction{Int} => (T == Int),
        ]
            @test MOI.supports(model, MOI.ObjectiveFunction{F}()) == flag
        end
    end
    return
end

end  # module

TestObjectiveToScalarNonlinear.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestPromoteOperation

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_promote_operation_1a()
    T = Int
    F = (
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        Vector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    )
    special_cases = Dict(
        (1, 2) => 3,
        (2, 2) => 3,
        (2, 1) => 3,
        (6, 7) => 8,
        (7, 7) => 8,
        (7, 6) => 8,
    )
    for i in 1:5, j in 1:5
        k = get(special_cases, (i, j), max(i, j))
        @test MOI.Utilities.promote_operation(+, T, F[i], F[j]) == F[k]
    end
    for i in 6:10, j in 6:10
        k = get(special_cases, (i, j), max(i, j))
        @test MOI.Utilities.promote_operation(+, T, F[i], F[j]) == F[k]
    end
    return
end

function test_promote_operation_2a()
    T = Int
    F = (
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        Vector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    )
    special_cases = Dict(2 => 3, 7 => 8)
    for i in 1:10
        j = get(special_cases, i, i)
        @test MOI.Utilities.promote_operation(-, T, F[i]) == F[j]
    end
    return
end

function test_promote_operation_2b()
    T = Int
    F = (
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        Vector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    )
    special_cases = Dict(
        (1, 2) => 3,
        (2, 2) => 3,
        (2, 1) => 3,
        (6, 7) => 8,
        (7, 7) => 8,
        (7, 6) => 8,
    )
    for i in 1:5, j in 1:5
        k = get(special_cases, (i, j), max(i, j))
        @test MOI.Utilities.promote_operation(-, T, F[i], F[j]) == F[k]
    end
    for i in 6:10, j in 6:10
        k = get(special_cases, (i, j), max(i, j))
        @test MOI.Utilities.promote_operation(-, T, F[i], F[j]) == F[k]
    end
    return
end

function test_promote_operation_3a()
    T = Int
    F = (
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        Vector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    )
    special_cases = Dict(2 => 3, 7 => 8)
    for i in 1:10
        j = get(special_cases, i, i)
        @test MOI.Utilities.promote_operation(*, T, T, F[i]) == F[j]
    end
    return
end

function test_promote_operation_3b()
    T = Int
    F = (
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        Vector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    )
    special_cases = Dict(2 => 3, 7 => 8)
    for i in 1:10
        j = get(special_cases, i, i)
        @test MOI.Utilities.promote_operation(*, T, F[i], T) == F[j]
    end
    return
end

function test_promote_operation_4a()
    T = Int
    F = (
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        Vector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    )
    special_cases = Dict(2 => 3, 7 => 8)
    for i in 1:10
        j = get(special_cases, i, i)
        @test MOI.Utilities.promote_operation(/, T, F[i], T) == F[j]
    end
    return
end

function test_promote_operation_5a()
    T = Int
    F = (
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        Vector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    )
    special_cases = Dict(
        (1, 2) => 8,
        (2, 1) => 8,
        (1, 7) => 8,
        (7, 1) => 8,
        (2, 6) => 8,
        (6, 2) => 8,
        (6, 7) => 8,
        (7, 6) => 8,
    )
    for i in 1:10, j in 1:10
        k = max(i <= 5 ? i + 5 : i, j <= 5 ? j + 5 : j)
        k = get(special_cases, (i, j), k)
        @test MOI.Utilities.promote_operation(vcat, T, F[i], F[j]) == F[k]
    end
    return
end

function test_promote_operation_6a()
    T = Int
    @test MOI.Utilities.promote_operation(imag, T, MOI.VariableIndex) ==
          MOI.ScalarAffineFunction{T}
    @test MOI.Utilities.promote_operation(imag, T, MOI.VectorOfVariables) ==
          MOI.VectorAffineFunction{T}
    return
end

end  # module

TestPromoteOperation.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Constraint

import LinearAlgebra
import MutableArithmetics as MA
import MathOptInterface as MOI
import OrderedCollections: OrderedDict, OrderedSet
import SparseArrays

include("bridge.jl")
include("map.jl")
include("set_map.jl")
include("single_bridge_optimizer.jl")

for filename in readdir(joinpath(@__DIR__, "bridges"); join = true)
    if endswith(filename, ".jl")
        include(filename)
    end
end

"""
    add_all_bridges(model, ::Type{T}) where {T}

Add all bridges defined in the `Bridges.Constraint` submodule to `model`.

The coefficient type used is `T`.
"""
function add_all_bridges(model, ::Type{T}) where {T}
    MOI.Bridges.add_bridge(model, AllDifferentToCountDistinctBridge{T})
    MOI.Bridges.add_bridge(model, BinPackingToMILPBridge{T})
    MOI.Bridges.add_bridge(model, CircuitToMILPBridge{T})
    MOI.Bridges.add_bridge(model, ComplexNormInfinityToSecondOrderConeBridge{T})
    MOI.Bridges.add_bridge(model, CountAtLeastToCountBelongsBridge{T})
    MOI.Bridges.add_bridge(model, CountBelongsToMILPBridge{T})
    MOI.Bridges.add_bridge(model, CountDistinctToMILPBridge{T})
    MOI.Bridges.add_bridge(model, CountGreaterThanToMILPBridge{T})
    # * ExponentialConeToScalarNonlinearFunctionBridge{T}
    #      This bridge is not added by default because it starts with a convex
    #      conic constraint and adds a nonlinear constraint that local NLP
    #      solvers like Ipopt can struggle with because of log(x) when x is 0.
    #      In addition, the bridge does not support ConstraintDual.
    #  * FunctionConversionBridge{T}
    #      This bridge is not added because, even though it is not abstract, it
    #      is highly parameterized, and parameterized versions such as
    #      ScalarFunctionizeBridge are added.
    MOI.Bridges.add_bridge(model, GeoMeanBridge{T})
    MOI.Bridges.add_bridge(model, GeoMeanToPowerBridge{T})
    MOI.Bridges.add_bridge(model, GeoMeantoRelEntrBridge{T})
    if T <: AbstractFloat  # See note in docstring of AbstractToIntervalBridge
        MOI.Bridges.add_bridge(model, GreaterToIntervalBridge{T})
    end
    MOI.Bridges.add_bridge(model, GreaterToLessBridge{T})
    MOI.Bridges.add_bridge(model, HermitianToSymmetricPSDBridge{T})
    MOI.Bridges.add_bridge(model, HermitianToComplexSymmetricBridge{T})
    MOI.Bridges.add_bridge(model, IndicatorActiveOnFalseBridge{T})
    MOI.Bridges.add_bridge(model, IndicatorGreaterToLessThanBridge{T})
    MOI.Bridges.add_bridge(model, IndicatorLessToGreaterThanBridge{T})
    #  * IndicatorSetMapBridge{T}
    #      This bridge is not added because, even though it is not abstract, it
    #      is highly parameterized, and parameterized versions such as
    #      IndicatorGreaterToLessThanBridge are added.
    MOI.Bridges.add_bridge(model, IndicatorSOS1Bridge{T})
    MOI.Bridges.add_bridge(model, IndicatorToMILPBridge{T})
    #   * InequalityToComplementsBridge{T}
    #       This bridge is not added because of a bug in Convex.jl:
    #       https://github.com/jump-dev/Convex.jl/blob/ca5324217575af263bfeee20b3e0526bed051887/src/MOI_wrapper.jl#L119-L133
    #       It is also really useful only to PATHSolver.jl, which could add this
    #       to MOI.ListOfRequiredBridges.
    MOI.Bridges.add_bridge(model, IntegerToZeroOneBridge{T})
    MOI.Bridges.add_bridge(model, LessToGreaterBridge{T})
    if T <: AbstractFloat  # See note in docstring of AbstractToIntervalBridge
        MOI.Bridges.add_bridge(model, LessToIntervalBridge{T})
    end
    MOI.Bridges.add_bridge(model, LogDetBridge{T})
    MOI.Bridges.add_bridge(model, NonnegToNonposBridge{T})
    MOI.Bridges.add_bridge(model, NonposToNonnegBridge{T})
    MOI.Bridges.add_bridge(model, NormInfinityBridge{T})
    MOI.Bridges.add_bridge(model, NormInfinityConeToNormConeBridge{T})
    MOI.Bridges.add_bridge(model, NormNuclearBridge{T})
    MOI.Bridges.add_bridge(model, NormOneBridge{T})
    MOI.Bridges.add_bridge(model, NormOneConeToNormConeBridge{T})
    #  * NormSpecialCaseBridge{T}
    #      This bridge is not added because, even though it is not abstract, it
    #      is highly parameterized, and parameterized versions such as
    #      NormOneConeToNormConeBridge are added.
    MOI.Bridges.add_bridge(model, NormSpectralBridge{T})
    MOI.Bridges.add_bridge(model, NormToPowerBridge{T})
    #  * NumberConversionBridge{T}
    #      This bridge is not added by default because it would silently enable
    #      models with mixed precision. In most cases, this is a bug in the
    #      user's code, so we leave this bridge as opt-in.
    MOI.Bridges.add_bridge(model, QuadtoSOCBridge{T})
    MOI.Bridges.add_bridge(model, ReifiedAllDifferentToCountDistinctBridge{T})
    MOI.Bridges.add_bridge(model, ReifiedCountDistinctToMILPBridge{T})
    MOI.Bridges.add_bridge(model, RelativeEntropyBridge{T})
    MOI.Bridges.add_bridge(model, RootDetBridge{T})
    #  * RSOCtoNonConvexQuadBridge{T}
    #      This bridge is not added by default because it starts with a convex
    #      conic constraint and generate a non-convex constraint (in the QCP
    #      interpretation).
    MOI.Bridges.add_bridge(model, RSOCtoPSDBridge{T})
    MOI.Bridges.add_bridge(model, RSOCtoSOCBridge{T})
    MOI.Bridges.add_bridge(model, ScalarFunctionizeBridge{T})
    MOI.Bridges.add_bridge(model, ScalarizeBridge{T})
    MOI.Bridges.add_bridge(model, ScalarSlackBridge{T})
    MOI.Bridges.add_bridge(model, SecondOrderConeToNormConeBridge{T})
    MOI.Bridges.add_bridge(model, SemiToBinaryBridge{T})
    #  * SetConversionBridge{T}
    #      This bridge is not added because, even though it is not abstract, it
    #      is highly parameterized, and it intended for use by MOI extensions.
    MOI.Bridges.add_bridge(model, SetDotInverseScalingBridge{T})
    MOI.Bridges.add_bridge(model, SetDotScalingBridge{T})
    #  * SOCtoNonConvexQuadBridge{T}
    #      This bridge is not added by default because it starts with a convex
    #      conic constraint and generate a non-convex constraint (in the QCP
    #      interpretation).
    #  * SOCtoPSDBridge{T}
    #      This bridge is not added because transforming the `SOC` to `RSOC` and
    #      then to `PSD` produces a smaller SDP constraint. `RSOCtoPSDBridge` is
    #      added by default.
    MOI.Bridges.add_bridge(model, SOCtoRSOCBridge{T})
    MOI.Bridges.add_bridge(model, SOS1ToMILPBridge{T})
    MOI.Bridges.add_bridge(model, SOS2ToMILPBridge{T})
    MOI.Bridges.add_bridge(model, SplitComplexEqualToBridge{T})
    MOI.Bridges.add_bridge(model, SplitComplexZerosBridge{T})
    MOI.Bridges.add_bridge(model, SplitHyperRectangleBridge{T})
    MOI.Bridges.add_bridge(model, SplitIntervalBridge{T})
    MOI.Bridges.add_bridge(model, SquareBridge{T})
    MOI.Bridges.add_bridge(model, TableToMILPBridge{T})
    MOI.Bridges.add_bridge(model, ToScalarNonlinearBridge{T})
    MOI.Bridges.add_bridge(model, ToScalarQuadraticBridge{T})
    MOI.Bridges.add_bridge(model, ToVectorQuadraticBridge{T})
    MOI.Bridges.add_bridge(model, VectorFunctionizeBridge{T})
    MOI.Bridges.add_bridge(model, VectorizeBridge{T})
    MOI.Bridges.add_bridge(model, IntervalToHyperRectangleBridge{T})
    MOI.Bridges.add_bridge(model, VectorSlackBridge{T})
    MOI.Bridges.add_bridge(model, ZeroOneBridge{T})
    return
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableHermitianToSymmetricPSD

using Test

import MathOptInterface as MOI

import LinearAlgebra

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_conic_HermitianPositiveSemidefiniteConeTriangle_1()
    T = Float64
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{T}())
    bridged_mock = MOI.Bridges.Variable.HermitianToSymmetricPSD{T}(mock)
    primal = [
        (T(1) + √T(3)) / T(2),
        -T(1) / T(2),
        (-T(1) + √T(3)) / T(2),
        T(1) / T(2),
    ]
    soc_primal = [
        primal[1] - one(T),
        √T(2) * (primal[2] + one(T)),
        primal[3] + one(T),
        √T(2) * (primal[4] - one(T)),
    ]
    t_value = LinearAlgebra.norm(soc_primal)
    real_primal = [
        primal[1:3]
        zero(T)
        -primal[4]
        primal[1]
        primal[4]
        zero(T)
        primal[2:3]
        t_value
    ]
    dual = [
        (T(3) - √T(3)) / T(6),
        √T(3) / T(6),
        (T(3) + √T(3)) / T(6),
        -√T(3) / T(6),
    ]
    soc_dual = [one(T), -dual[1], -dual[2] * √T(2), -dual[3], -dual[4] * √T(2)]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            real_primal,
            (MOI.VectorAffineFunction{T}, MOI.SecondOrderCone) =>
                [soc_dual],
            (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) => [
                dual[1] / T(2)
                zero(T)
                dual[2]
                -dual[2]
                dual[3] / T(2)
                zero(T)
            ],
        )
    MOI.empty!(bridged_mock)
    MOI.Test.test_conic_HermitianPositiveSemidefiniteConeTriangle_1(
        bridged_mock,
        MOI.Test.Config(),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.HermitianToSymmetricPSDBridge,
        """
        variables: a, b, c
        constrainedvariable: [r11, r12, r22, c12] in HermitianPositiveSemidefiniteConeTriangle(2)
        1.0 * r11 >= 1.0
        1.0 * r12 >= 2.0
        1.0 * r22 >= 3.0
        1.0 * c12 >= 4.0
        [a, b, c] in PositiveSemidefiniteConeTriangle(2)
        """,
        """
        variables: a, b, c
        constrainedvariable: [v11, v12, v22, v13, v23, v33, v14, v24, v34, v44] in PositiveSemidefiniteConeTriangle(4)
        1.0 * v11 >= 1.0
        1.0 * v12 >= 2.0
        1.0 * v22 >= 3.0
        1.0 * v14 >= 4.0
        1.0 * v11 + -1.0 * v33 == 0.0
        1.0 * v13 == 0.0
        1.0 * v12 + -1.0 * v34 == 0.0
        1.0 * v23 + 1.0 * v14 == 0.0
        1.0 * v22 + -1.0 * v44 == 0.0
        1.0 * v24 == 0.0
        [a, b, c] in PositiveSemidefiniteConeTriangle(2)
        """,
    )
    return
end

function test_delete()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Variable.HermitianToSymmetricPSD{Float64}(inner)
    set = MOI.HermitianPositiveSemidefiniteConeTriangle(2)
    x, _ = MOI.add_constrained_variables(model, set)
    MOI.delete(model, x)
    @test MOI.is_empty(inner)
    return
end

function test_set_variable_primal_start()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.HermitianToSymmetricPSD{Float64}(inner)
    set = MOI.HermitianPositiveSemidefiniteConeTriangle(2)
    x, _ = MOI.add_constrained_variables(model, set)
    MOI.set(model, MOI.VariablePrimalStart(), x[1], 1.0)
    @test MOI.get(model, MOI.VariablePrimalStart(), x[1]) == 1.0
    MOI.set(model, MOI.VariablePrimalStart(), x[1], nothing)
    @test MOI.get(model, MOI.VariablePrimalStart(), x[1]) === nothing
    return
end

end  # module

TestVariableHermitianToSymmetricPSD.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestBridgesLazyBridgeOptimizer

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("utilities.jl")
include("sdpa_models.jl")

function test_add_remove_has_bridges()
    T = Int
    model = MOI.Utilities.Model{T}()
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    for BT in [
        MOI.Bridges.Variable.VectorizeBridge{T},
        MOI.Bridges.Constraint.VectorizeBridge{T},
        MOI.Bridges.Objective.FunctionizeBridge{T},
        MOI.Bridges.Constraint.ScalarFunctionizeBridge{T},
        MOI.Bridges.Variable.FreeBridge{T},
    ]
        @test !MOI.Bridges.has_bridge(bridged, BT)
        MOI.Bridges.add_bridge(bridged, BT)
        @test MOI.Bridges.has_bridge(bridged, BT)
        if BT != MOI.Bridges.Variable.FreeBridge{T}
            @test length(MOI.Bridges._bridge_types(bridged, BT)) == 1
        end
        MOI.Bridges.add_bridge(bridged, BT)
        @test MOI.Bridges.has_bridge(bridged, BT)
        if BT != MOI.Bridges.Variable.FreeBridge{T}
            @test length(MOI.Bridges._bridge_types(bridged, BT)) == 1
        end
        MOI.Bridges.remove_bridge(bridged, BT)
        @test !MOI.Bridges.has_bridge(bridged, BT)
        @test isempty(MOI.Bridges._bridge_types(bridged, BT))
        err = ErrorException(
            "Cannot remove bridge `$BT` as it was never added or was already removed.",
        )
        @test_throws err MOI.Bridges.remove_bridge(bridged, BT)
    end
    return
end

function _functionize_error(b, bridge_type, func, name)
    return ErrorException(
        "Need to apply a `$bridge_type` to a `$func` $name because the" *
        " variable is bridged but $name bridges are not supported by" *
        " `$(typeof(b))`.",
    )
end

function _lazy_functionize_error(bridge_type, func, name)
    return ErrorException(
        "Need to apply a `$bridge_type` to a `$func` $name because the variable is" *
        " bridged but no such $name bridge type was added. Add one" *
        " with `add_bridge`.",
    )
end

MOI.Utilities.@model(
    StandardLPModel,
    (),
    (MOI.EqualTo, MOI.Test.UnknownScalarSet),
    (MOI.Nonnegatives,),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (MOI.VectorOfVariables,),
    ()
)

function MOI.supports_constraint(
    ::StandardLPModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{<:Union{MOI.GreaterThan{T},MOI.LessThan{T},MOI.EqualTo{T}}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::StandardLPModel,
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.Reals},
)
    return false
end

function MOI.supports(
    ::StandardLPModel{T},
    ::MOI.ObjectiveFunction{
        <:Union{
            MOI.VariableIndex,
            MOI.ScalarQuadraticFunction{T},
            MOI.ScalarNonlinearFunction,
            MOI.VectorOfVariables,
            MOI.VectorAffineFunction{T},
            MOI.VectorQuadraticFunction{T},
            MOI.VectorNonlinearFunction,
        },
    },
) where {T}
    return false
end

function _test_bridged_variable_in_VariableIndex_constraint(T)
    S = MOI.Test.UnknownScalarSet{T}
    set = S(one(T))
    model = StandardLPModel{T}()
    bridged = MOI.Bridges.Variable.Vectorize{T}(model)
    x, cx = MOI.add_constrained_variable(bridged, MOI.GreaterThan(one(T)))
    err = _functionize_error(
        bridged,
        MOI.Bridges.Constraint.ScalarFunctionizeBridge,
        "VariableIndex",
        "constraint",
    )
    @test_throws err MOI.add_constraint(bridged, x, set)
    @test_throws err MOI.add_constraints(bridged, [x], [set])
    function _bridged()
        model = StandardLPModel{T}()
        bridged = MOI.Bridges.LazyBridgeOptimizer(model)
        MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.VectorizeBridge{T})
        x, cx = MOI.add_constrained_variable(bridged, MOI.GreaterThan(one(T)))
        return model, bridged, x
    end
    _, bridged, x = _bridged()
    err = _lazy_functionize_error(
        MOI.Bridges.Constraint.ScalarFunctionizeBridge,
        "VariableIndex",
        "constraint",
    )
    @test_throws err MOI.add_constraint(bridged, x, set)
    @test_throws err MOI.add_constraints(bridged, [x], [set])
    for i in 1:2
        model, bridged, x = _bridged()
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.ScalarFunctionizeBridge{T},
        )
        if i == 1
            cx = MOI.add_constraint(bridged, x, set)
        else
            cx = MOI.add_constraints(bridged, [x], [set])[1]
        end
        @test MOI.get(bridged, MOI.ConstraintFunction(), cx) == x
        @test MOI.get(bridged, MOI.ConstraintSet(), cx) == set
        a = MOI.get(model, MOI.ListOfVariableIndices())[1]
        ca = MOI.get(
            model,
            MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},S}(),
        )[1]
        @test MOI.get(model, MOI.ConstraintFunction(), ca) ≈
              convert(MOI.ScalarAffineFunction{T}, a)
        @test MOI.get(model, MOI.ConstraintSet(), ca) ==
              MOI.Utilities.shift_constant(set, -one(T))
    end
    return
end

function test_bridged_variable_in_VariableIndex_constraint()
    _test_bridged_variable_in_VariableIndex_constraint(Float64)
    _test_bridged_variable_in_VariableIndex_constraint(Int)
    return
end

function _test_bridged_variable_in_VectorOfVariables_constraint(T)
    set = MOI.Zeros(1)
    model = StandardLPModel{T}()
    bridged = MOI.Bridges.Variable.Vectorize{T}(model)
    x, cx = MOI.add_constrained_variable(bridged, MOI.GreaterThan(one(T)))
    x = MOI.VectorOfVariables([x])
    err = _functionize_error(
        bridged,
        MOI.Bridges.Constraint.VectorFunctionizeBridge,
        "VectorOfVariables",
        "constraint",
    )
    @test_throws err MOI.add_constraint(bridged, x, set)
    @test_throws err MOI.add_constraints(bridged, [x], [set])
    function _bridged()
        model = StandardLPModel{T}()
        bridged = MOI.Bridges.LazyBridgeOptimizer(model)
        MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.VectorizeBridge{T})
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.ScalarizeBridge{T},
        )
        x, cx = MOI.add_constrained_variable(bridged, MOI.GreaterThan(one(T)))
        x = MOI.VectorOfVariables([x])
        return model, bridged, x
    end
    _, bridged, x = _bridged()
    err = _lazy_functionize_error(
        MOI.Bridges.Constraint.VectorFunctionizeBridge,
        "VectorOfVariables",
        "constraint",
    )
    @test_throws err MOI.add_constraint(bridged, x, set)
    @test_throws err MOI.add_constraints(bridged, [x], [set])
    for i in 1:2
        model, bridged, x = _bridged()
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.VectorFunctionizeBridge{T},
        )
        if i == 1
            cx = MOI.add_constraint(bridged, x, set)
        else
            cx = MOI.add_constraints(bridged, [x], [set])[1]
        end
        @test MOI.get(bridged, MOI.ConstraintFunction(), cx) == x
        @test MOI.get(bridged, MOI.ConstraintSet(), cx) == set
        a = MOI.get(model, MOI.ListOfVariableIndices())[1]
        ca = MOI.get(
            model,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{T},
                MOI.EqualTo{T},
            }(),
        )[1]
        @test MOI.get(model, MOI.ConstraintFunction(), ca) ≈
              convert(MOI.ScalarAffineFunction{T}, a)
        @test MOI.get(model, MOI.ConstraintSet(), ca) == MOI.EqualTo(-one(T))
    end
    return
end

function test_bridged_variable_in_VectorOfVariables_constraint()
    _test_bridged_variable_in_VectorOfVariables_constraint(Float64)
    _test_bridged_variable_in_VectorOfVariables_constraint(Int)
    return
end

function _test_bridged_variable_in_VariableIndex_obiective(T)
    model = StandardLPModel{T}()
    bridged = MOI.Bridges.Variable.Vectorize{T}(model)
    x, cx = MOI.add_constrained_variable(bridged, MOI.GreaterThan(one(T)))
    err = _functionize_error(
        bridged,
        MOI.Bridges.Objective.FunctionizeBridge,
        "VariableIndex",
        "objective",
    )
    @test_throws err MOI.set(bridged, MOI.ObjectiveFunction{typeof(x)}(), x)
    model = StandardLPModel{T}()
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.VectorizeBridge{T})
    x, cx = MOI.add_constrained_variable(bridged, MOI.GreaterThan(one(T)))
    err = _lazy_functionize_error(
        MOI.Bridges.Objective.FunctionizeBridge,
        "VariableIndex",
        "objective",
    )
    @test_throws err MOI.set(bridged, MOI.ObjectiveFunction{typeof(x)}(), x)
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Objective.FunctionizeBridge{T})
    MOI.set(bridged, MOI.ObjectiveFunction{typeof(x)}(), x)
    @test MOI.get(bridged, MOI.ObjectiveFunctionType()) == MOI.VariableIndex
    @test MOI.get(bridged, MOI.ObjectiveFunction{MOI.VariableIndex}()) ≈ x
    a = MOI.get(model, MOI.ListOfVariableIndices())[1]
    @test MOI.get(model, MOI.ObjectiveFunctionType()) ==
          MOI.ScalarAffineFunction{T}
    @test MOI.get(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}()) ≈
          a + one(T)
    return
end

function test_bridged_variable_in_VariableIndex_obiective()
    _test_bridged_variable_in_VariableIndex_obiective(Float64)
    _test_bridged_variable_in_VariableIndex_obiective(Int)
    return
end

MOI.Utilities.@model(
    LPModel,
    (),
    (MOI.EqualTo, MOI.GreaterThan, MOI.LessThan),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
)

function test_MOI_runtests_LPModel()
    model = LPModel{Float64}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, Float64)
    MOI.Test.runtests(
        bridged,
        MOI.Test.Config(exclude = Any[MOI.optimize!]);
        include = ["test_model_", "test_constraint_"],
    )
    return
end

function test_MOI_runtests_StandardSDPAModel()
    model =
        MOI.instantiate(StandardSDPAModel{Float64}; with_bridge_type = Float64)
    MOI.Test.runtests(
        model,
        MOI.Test.Config(
            exclude = Any[MOI.optimize!, MOI.SolverName, MOI.SolverVersion],
        ),
    )
    return
end

function test_MOI_runtests_GeometricSDPAModel()
    model =
        MOI.instantiate(GeometricSDPAModel{Float64}; with_bridge_type = Float64)
    MOI.Test.runtests(
        model,
        MOI.Test.Config(
            exclude = Any[MOI.optimize!, MOI.SolverName, MOI.SolverVersion],
        ),
    )
    return
end

function test_get_primal_variable_bridge()
    cache = MOI.Utilities.Model{Float64}()
    x, c1 = MOI.add_constrained_variable(cache, MOI.GreaterThan(1.0))
    c2 = MOI.add_constraint(cache, 1.0x, MOI.EqualTo(2.0))
    inner = MOI.Utilities.MockOptimizer(StandardSDPAModel{Float64}())
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64)
    index_map = MOI.copy_to(model, cache)
    MOI.Utilities.set_mock_optimize!(
        inner,
        mock -> MOI.Utilities.mock_optimize!(mock, [1.0]),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.VariablePrimal(), index_map[x]) == 2.0
    @test MOI.get(model, MOI.ConstraintPrimal(), index_map[c1]) == 2.0
    @test MOI.get(model, MOI.ConstraintPrimal(), index_map[c2]) == 2.0
    return
end

function test_index_constraint_conflict()
    optimizer = StandardSDPAModel{Float64}()
    model = MOI.Bridges.full_bridge_optimizer(optimizer, Float64)
    x, cx = MOI.add_constrained_variables(model, MOI.Nonpositives(1))
    @test MOI.is_valid(model, x[1])
    @test MOI.is_valid(model, cx)
    y, cy = MOI.add_constrained_variables(model, MOI.Nonpositives(1))
    @test MOI.is_valid(model, y[1])
    @test MOI.is_valid(model, cy)
    c = MOI.add_constraint(model, MOI.VectorOfVariables(y), MOI.Nonpositives(1))
    MOI.is_valid(model, c)
    b1 = MOI.Bridges.bridge(model, c)
    b2 = MOI.Bridges.bridge(model, b1.constraint)
    @test c != b2.slack_in_set
    return
end

function _test_index_variable_conflict(set)
    optimizer = StandardSDPAModel{Float64}()
    model = MOI.Bridges.full_bridge_optimizer(optimizer, Float64)
    x = MOI.add_variables(model, MOI.dimension(set))
    c = MOI.add_constraint(model, MOI.VectorOfVariables(x), set)
    @test MOI.is_valid(model, c)
    w, cw = MOI.add_constrained_variables(model, set)
    @test MOI.is_valid(model, cw)
    @test cw != c
    y, cy = MOI.add_constrained_variables(model, set)
    @test MOI.is_valid(model, cy)
    @test cy != c
    z, cz = MOI.add_constrained_variables(model, set)
    @test MOI.is_valid(model, cz)
    @test cz != c
    return
end

function test_index_variable_conflict()
    _test_index_variable_conflict(MOI.Nonpositives(3))
    _test_index_variable_conflict(MOI.SecondOrderCone(3))
    _test_index_variable_conflict(MOI.RotatedSecondOrderCone(3))
    _test_index_variable_conflict(MOI.RotatedSecondOrderCone(2))
    _test_index_variable_conflict(MOI.ScaledPositiveSemidefiniteConeTriangle(2))
    return
end

function test_show_SPDA()
    model = StandardSDPAModel{Float64}()
    model_str = sprint(MOI.Utilities.print_with_acronym, string(typeof(model)))
    bridged = MOI.Bridges.full_bridge_optimizer(model, Float64)
    # no bridges
    ret = """
    MOIB.LazyBridgeOptimizer{$model_str}
    ├ Variable bridges: none
    ├ Constraint bridges: none
    ├ Objective bridges: none
    └ model: $model_str
      ├ ObjectiveSense: FEASIBILITY_SENSE
      ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
      ├ NumberOfVariables: 0
      └ NumberOfConstraints: 0"""
    @test sprint(show, bridged) == ret
    MOI.add_constrained_variable(bridged, MOI.LessThan(1.0))
    # add variable bridges
    ret = """
    MOIB.LazyBridgeOptimizer{$model_str}
    ├ Variable bridges:
    │ ├ MOIB.Variable.NonposToNonnegBridge{Float64}
    │ └ MOIB.Variable.VectorizeBridge{Float64, MOI.Nonpositives}
    ├ Constraint bridges: none
    ├ Objective bridges: none
    └ model: $model_str
      ├ ObjectiveSense: FEASIBILITY_SENSE
      ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
      ├ NumberOfVariables: 1
      └ NumberOfConstraints: 1
        └ MOI.VectorOfVariables in MOI.Nonnegatives: 1"""
    @test sprint(show, bridged) == ret
    return
end

function _test_SDPA_format(T)
    model = StandardSDPAModel{T}()
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    @test !MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Nonpositives,
    )
    @test !MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.Nonpositives,
    )
    @test !MOI.supports_add_constrained_variables(bridged, MOI.Nonpositives)
    MOI.Bridges.add_bridge(
        bridged,
        MOI.Bridges.Variable.NonposToNonnegBridge{T},
    )
    @test !MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.Nonpositives,
    )
    @test MOI.supports_add_constrained_variables(bridged, MOI.Nonpositives)
    @test MOI.Bridges.bridge_type(bridged, MOI.Nonpositives) ==
          MOI.Bridges.Variable.NonposToNonnegBridge{T}
    @test !MOI.supports_constraint(model, MOI.VectorOfVariables, MOI.Zeros)
    @test !MOI.supports_add_constrained_variables(bridged, MOI.Zeros)
    @test !MOI.supports_constraint(bridged, MOI.VectorOfVariables, MOI.Zeros)
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.ZerosBridge{T})
    @test !MOI.supports_constraint(bridged, MOI.VectorOfVariables, MOI.Zeros)
    @test MOI.supports_add_constrained_variables(bridged, MOI.Zeros)
    @test MOI.Bridges.bridge_type(bridged, MOI.Zeros) ==
          MOI.Bridges.Variable.ZerosBridge{T}
    @test !MOI.supports_constraint(model, MOI.VectorOfVariables, MOI.Reals)
    @test !MOI.supports_constraint(bridged, MOI.VectorOfVariables, MOI.Reals)
    @test !MOI.supports_add_constrained_variables(bridged, MOI.Reals)
    @test_throws MOI.UnsupportedConstraint{MOI.VectorOfVariables,MOI.Reals} MOI.add_variable(
        bridged,
    )
    @test_throws MOI.UnsupportedConstraint{MOI.VectorOfVariables,MOI.Reals} MOI.add_variables(
        bridged,
        2,
    )
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.FreeBridge{T})
    @test !MOI.supports_constraint(bridged, MOI.VectorOfVariables, MOI.Reals)
    @test MOI.supports_add_constrained_variables(bridged, MOI.Reals)
    @test MOI.Bridges.bridge_type(bridged, MOI.Reals) ==
          MOI.Bridges.Variable.FreeBridge{T}
    @test !MOI.supports_constraint(model, MOI.VariableIndex, MOI.GreaterThan{T})
    @test !MOI.supports_constraint(
        bridged,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    @test !MOI.supports_add_constrained_variable(bridged, MOI.GreaterThan{T})
    @test !MOI.supports_constraint(model, MOI.VariableIndex, MOI.LessThan{T})
    @test !MOI.supports_constraint(bridged, MOI.VariableIndex, MOI.LessThan{T})
    @test !MOI.supports_add_constrained_variable(bridged, MOI.LessThan{T})
    @test !MOI.supports_constraint(model, MOI.VariableIndex, MOI.EqualTo{T})
    @test !MOI.supports_constraint(bridged, MOI.VariableIndex, MOI.EqualTo{T})
    @test !MOI.supports_add_constrained_variable(bridged, MOI.EqualTo{T})
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.VectorizeBridge{T})
    @test !MOI.supports_constraint(
        bridged,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    @test MOI.supports_add_constrained_variable(bridged, MOI.GreaterThan{T})
    @test MOI.Bridges.bridge_type(bridged, MOI.GreaterThan{T}) ==
          MOI.Bridges.Variable.VectorizeBridge{T,MOI.Nonnegatives}
    @test !MOI.supports_constraint(bridged, MOI.VariableIndex, MOI.LessThan{T})
    @test MOI.supports_add_constrained_variable(bridged, MOI.LessThan{T})
    @test MOI.Bridges.bridge_type(bridged, MOI.LessThan{T}) ==
          MOI.Bridges.Variable.VectorizeBridge{T,MOI.Nonpositives}
    @test !MOI.supports_constraint(bridged, MOI.VariableIndex, MOI.EqualTo{T})
    @test MOI.supports_add_constrained_variable(bridged, MOI.EqualTo{T})
    @test MOI.Bridges.bridge_type(bridged, MOI.EqualTo{T}) ==
          MOI.Bridges.Variable.VectorizeBridge{T,MOI.Zeros}
    @test !MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    )
    @test !MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    )
    @test !MOI.supports_add_constrained_variables(
        bridged,
        MOI.RotatedSecondOrderCone,
    )
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.RSOCtoPSDBridge{T})
    @test !MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    )
    @test !MOI.supports_add_constrained_variables(
        bridged,
        MOI.RotatedSecondOrderCone,
    )
    MOI.Bridges.add_bridge(
        bridged,
        MOI.Bridges.Constraint.ScalarFunctionizeBridge{T},
    )
    @test !MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    )
    @test MOI.supports_add_constrained_variables(
        bridged,
        MOI.RotatedSecondOrderCone,
    )
    @test MOI.Bridges.bridge_type(bridged, MOI.RotatedSecondOrderCone) ==
          MOI.Bridges.Variable.RSOCtoPSDBridge{T}
    x, cx = MOI.add_constrained_variable(bridged, MOI.LessThan(one(T)))
    @test !MOI.supports_constraint(
        bridged,
        MOI.VectorAffineFunction{T},
        MOI.RotatedSecondOrderCone,
    )
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Constraint.VectorSlackBridge{T})
    @test !MOI.supports_constraint(
        bridged,
        MOI.VectorAffineFunction{T},
        MOI.RotatedSecondOrderCone,
    )
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Constraint.ScalarizeBridge{T})
    @test MOI.supports_constraint(
        bridged,
        MOI.VectorAffineFunction{T},
        MOI.RotatedSecondOrderCone,
    )
    @test MOI.Bridges.bridge_type(
        bridged,
        MOI.VectorAffineFunction{T},
        MOI.RotatedSecondOrderCone,
    ) == MOI.Bridges.Constraint.VectorSlackBridge{
        T,
        MOI.VectorAffineFunction{T},
        MOI.RotatedSecondOrderCone,
    }
    @test MOI.supports_constraint(
        bridged,
        MOI.VectorAffineFunction{T},
        MOI.Zeros,
    )
    @test MOI.Bridges.bridge_type(
        bridged,
        MOI.VectorAffineFunction{T},
        MOI.Zeros,
    ) == MOI.Bridges.Constraint.ScalarizeBridge{
        T,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    }
    @test !MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.PositiveSemidefiniteConeSquare,
    )
    @test !MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.PositiveSemidefiniteConeSquare,
    )
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Constraint.SquareBridge{T})
    @test_throws MOI.UnsupportedConstraint{
        MOI.VectorOfVariables,
        MOI.PositiveSemidefiniteConeSquare,
    } MOI.Bridges.bridge_type(bridged, MOI.PositiveSemidefiniteConeSquare)
    @test MOI.Bridges._dist(
        bridged.graph,
        MOI.Bridges.node(bridged, MOI.PositiveSemidefiniteConeSquare),
    ) == MOI.Bridges.INFINITY
    @test sprint(MOI.Bridges.print_graph, bridged) == """
Bridge graph with 1 variable nodes, 0 constraint nodes and 0 objective nodes.
 [1] constrained variables in `MOI.PositiveSemidefiniteConeSquare` are not supported
"""
    @test MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.PositiveSemidefiniteConeSquare,
    )
    @test sprint(MOI.Bridges.print_graph, bridged) ==
          MOI.Utilities.replace_acronym(
        """
Bridge graph with 1 variable nodes, 1 constraint nodes and 0 objective nodes.
 [1] constrained variables in `MOI.PositiveSemidefiniteConeSquare` are not supported
 (1) `MOI.VectorOfVariables`-in-`MOI.PositiveSemidefiniteConeSquare` constraints are bridged (distance 1) by $(MOI.Bridges.Constraint.SquareBridge{T,MOI.VectorOfVariables,MOI.ScalarAffineFunction{T},MOI.PositiveSemidefiniteConeTriangle,MOI.PositiveSemidefiniteConeSquare}).
""",
    )
    MOI.Bridges.add_bridge(
        bridged,
        MOI.Bridges.Constraint.VectorFunctionizeBridge{T},
    )
    @test_throws MOI.UnsupportedConstraint{
        MOI.VectorOfVariables,
        MOI.PositiveSemidefiniteConeSquare,
    } MOI.Bridges.bridge_type(bridged, MOI.PositiveSemidefiniteConeSquare)
    @test MOI.Bridges._dist(
        bridged.graph,
        MOI.Bridges.node(bridged, MOI.PositiveSemidefiniteConeSquare),
    ) == 6
    @test sprint(MOI.Bridges.print_graph, bridged) ==
          MOI.Utilities.replace_acronym(
        """
Bridge graph with 1 variable nodes, 3 constraint nodes and 0 objective nodes.
 [1] constrained variables in `MOI.PositiveSemidefiniteConeSquare` are supported (distance 6) by adding free variables and then constrain them, see (1).
 (1) `MOI.VectorAffineFunction{$T}`-in-`MOI.PositiveSemidefiniteConeSquare` constraints are bridged (distance 3) by $(MOI.Bridges.Constraint.SquareBridge{T,MOI.VectorAffineFunction{T},MOI.ScalarAffineFunction{T},MOI.PositiveSemidefiniteConeTriangle,MOI.PositiveSemidefiniteConeSquare}).
 (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are bridged (distance 1) by $(MOI.Bridges.Constraint.ScalarizeBridge{T,MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}).
 (3) `MOI.VectorAffineFunction{$T}`-in-`MOI.PositiveSemidefiniteConeTriangle` constraints are bridged (distance 2) by $(MOI.Bridges.Constraint.VectorSlackBridge{T,MOI.VectorAffineFunction{T},MOI.PositiveSemidefiniteConeTriangle}).
""",
    )
    @test !MOI.supports_constraint(
        bridged,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Constraint.VectorizeBridge{T})
    @test MOI.supports_constraint(
        bridged,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    @test MOI.Bridges.bridge_type(
        bridged,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    ) == MOI.Bridges.Constraint.VectorizeBridge{
        T,
        MOI.VectorAffineFunction{T},
        MOI.Nonnegatives,
        MOI.ScalarAffineFunction{T},
    }
    @test !MOI.supports_constraint(
        bridged,
        MOI.ScalarQuadraticFunction{T},
        MOI.GreaterThan{T},
    )
    @test !MOI.supports_constraint(
        bridged,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    )
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Constraint.QuadtoSOCBridge{T})
    @test MOI.supports_constraint(
        bridged,
        MOI.ScalarQuadraticFunction{T},
        MOI.GreaterThan{T},
    )
    @test MOI.Bridges.bridge_type(
        bridged,
        MOI.ScalarQuadraticFunction{T},
        MOI.GreaterThan{T},
    ) == MOI.Bridges.Constraint.QuadtoSOCBridge{T}
    @test MOI.supports_constraint(
        bridged,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    )
    @test MOI.Bridges.bridge_type(
        bridged,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    ) == MOI.Bridges.Constraint.QuadtoSOCBridge{T}
    F = MOI.ScalarQuadraticFunction{T}
    attr = MOI.ObjectiveFunction{F}()
    @test !MOI.supports(bridged, MOI.ObjectiveFunction{MOI.VariableIndex}())
    @test !MOI.supports(bridged, attr)
    err = MOI.UnsupportedAttribute(attr)
    @test_throws err MOI.Bridges.bridge_type(bridged, F)
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Objective.SlackBridge{T})
    @test !MOI.supports(bridged, MOI.ObjectiveFunction{MOI.VariableIndex}())
    @test !MOI.supports(bridged, attr)
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Objective.FunctionizeBridge{T})
    @test MOI.supports(bridged, MOI.ObjectiveFunction{MOI.VariableIndex}())
    @test MOI.Bridges.bridge_type(bridged, MOI.VariableIndex) ==
          MOI.Bridges.Objective.FunctionizeBridge{T,MOI.VariableIndex}
    @test MOI.supports(bridged, attr)
    @test MOI.Bridges.bridge_type(bridged, F) ==
          MOI.Bridges.Objective.SlackBridge{T,F,F}
    return
end

function test_SDPA_format()
    _test_SDPA_format(Float64)
    _test_SDPA_format(Int)
    return
end

function test_SDPA_debug()
    _test_SDPA_debug(Float64)
    _test_SDPA_debug(Int)
    return
end

function _test_SDPA_debug(T)
    model = StandardSDPAModel{T}()
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    function debug_string(f, args...)
        return sprint(io -> f(bridged, args...; io = io))
    end
    @testset "LessThan variables" begin
        S = MOI.LessThan{T}
        @test debug_string(
            MOI.Bridges.debug_supports_add_constrained_variable,
            S,
        ) == """
Constrained variables in `MOI.LessThan{$T}` are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.LessThan{$T}` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
"""
        @test sprint(MOI.Bridges.print_graph, bridged) == """
Bridge graph with 1 variable nodes, 0 constraint nodes and 0 objective nodes.
 [1] constrained variables in `MOI.LessThan{$T}` are not supported
"""
        MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.VectorizeBridge{T})
        @test debug_string(
            MOI.Bridges.debug_supports_add_constrained_variable,
            S,
        ) == MOI.Utilities.replace_acronym(
            """
Constrained variables in `MOI.LessThan{$T}` are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.LessThan{$T}` are not supported because:
   Cannot use `$(MOI.Bridges.Variable.VectorizeBridge{T,MOI.Nonpositives})` because:
   [2] constrained variables in `MOI.Nonpositives` are not supported
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 [2] constrained variables in `MOI.Nonpositives` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
""",
        )
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Variable.NonposToNonnegBridge{T},
        )
        @test debug_string(
            MOI.Bridges.debug_supports_add_constrained_variable,
            S,
        ) == "Constrained variables in `MOI.LessThan{$T}` are supported.\n"
        @test sprint(MOI.Bridges.print_graph, bridged) ==
              MOI.Utilities.replace_acronym(
            """
Bridge graph with 2 variable nodes, 0 constraint nodes and 0 objective nodes.
 [1] constrained variables in `MOI.LessThan{$T}` are bridged (distance 2) by $(MOI.Bridges.Variable.VectorizeBridge{T,MOI.Nonpositives}).
 [2] constrained variables in `MOI.Nonpositives` are bridged (distance 1) by $(MOI.Bridges.Variable.NonposToNonnegBridge{T}).
""",
        )
    end
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    @testset "LessThan variables with ScalarFunctionizeBridge" begin
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.ScalarFunctionizeBridge{T},
        )
        S = MOI.LessThan{T}
        @test debug_string(
            MOI.Bridges.debug_supports_add_constrained_variable,
            S,
        ) == """
Constrained variables in `MOI.LessThan{$T}` are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.LessThan{$T}` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because:
   (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
 (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported because no added bridge supports bridging it.
"""
        @test sprint(MOI.Bridges.print_graph, bridged) == """
Bridge graph with 1 variable nodes, 1 constraint nodes and 0 objective nodes.
 [1] constrained variables in `MOI.LessThan{$T}` are not supported
 (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
"""
        MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.VectorizeBridge{T})
        @test debug_string(
            MOI.Bridges.debug_supports_add_constrained_variable,
            S,
        ) == MOI.Utilities.replace_acronym(
            """
Constrained variables in `MOI.LessThan{$T}` are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.LessThan{$T}` are not supported because:
   Cannot use `$(MOI.Bridges.Variable.VectorizeBridge{T,MOI.Nonpositives})` because:
   [2] constrained variables in `MOI.Nonpositives` are not supported
   Cannot add free variables and then constrain them because:
   (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
 [2] constrained variables in `MOI.Nonpositives` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported because no added bridge supports bridging it.
""",
        )
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Variable.NonposToNonnegBridge{T},
        )
        @test debug_string(
            MOI.Bridges.debug_supports_add_constrained_variable,
            S,
        ) == "Constrained variables in `MOI.LessThan{$T}` are supported.\n"
        @test sprint(MOI.Bridges.print_graph, bridged) ==
              MOI.Utilities.replace_acronym(
            """
Bridge graph with 2 variable nodes, 1 constraint nodes and 0 objective nodes.
 [1] constrained variables in `MOI.LessThan{$T}` are bridged (distance 2) by $(MOI.Bridges.Variable.VectorizeBridge{T,MOI.Nonpositives}).
 [2] constrained variables in `MOI.Nonpositives` are bridged (distance 1) by $(MOI.Bridges.Variable.NonposToNonnegBridge{T}).
 (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
""",
        )
    end
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    @testset "Interval constraint" begin
        F = MOI.ScalarAffineFunction{T}
        S = MOI.Interval{T}
        @test debug_string(MOI.Bridges.debug_supports_constraint, F, S) == """
`MOI.ScalarAffineFunction{$T}`-in-`MOI.Interval{$T}` constraints are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.Interval{$T}` constraints are not supported because no added bridge supports bridging it.
"""
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.SplitIntervalBridge{T},
        )
        @test debug_string(MOI.Bridges.debug_supports_constraint, F, S) ==
              MOI.Utilities.replace_acronym(
            """
`MOI.ScalarAffineFunction{$T}`-in-`MOI.Interval{$T}` constraints are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.Interval{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.SplitIntervalBridge{T,MOI.ScalarAffineFunction{T},MOI.Interval{T},MOI.GreaterThan{T},MOI.LessThan{T}})` because:
   (2) `MOI.ScalarAffineFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported
   (3) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
 (2) `MOI.ScalarAffineFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported because no added bridge supports bridging it.
 (3) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported because no added bridge supports bridging it.
""",
        )
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.ScalarSlackBridge{T},
        )
        @test debug_string(MOI.Bridges.debug_supports_constraint, F, S) ==
              MOI.Utilities.replace_acronym(
            """
`MOI.ScalarAffineFunction{$T}`-in-`MOI.Interval{$T}` constraints are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.GreaterThan{$T}` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 [2] constrained variables in `MOI.LessThan{$T}` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 [3] constrained variables in `MOI.Interval{$T}` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.Interval{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.SplitIntervalBridge{T,MOI.ScalarAffineFunction{T},MOI.Interval{T},MOI.GreaterThan{T},MOI.LessThan{T}})` because:
   (2) `MOI.ScalarAffineFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported
   (3) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
   Cannot use `$(MOI.Bridges.Constraint.ScalarSlackBridge{T,MOI.ScalarAffineFunction{T},MOI.Interval{T}})` because:
   [3] constrained variables in `MOI.Interval{$T}` are not supported
 (2) `MOI.ScalarAffineFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.ScalarSlackBridge{T,MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}})` because:
   [1] constrained variables in `MOI.GreaterThan{$T}` are not supported
 (3) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.ScalarSlackBridge{T,MOI.ScalarAffineFunction{T},MOI.LessThan{T}})` because:
   [2] constrained variables in `MOI.LessThan{$T}` are not supported
""",
        )
        MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.VectorizeBridge{T})
        @test debug_string(MOI.Bridges.debug_supports_constraint, F, S) ==
              MOI.Utilities.replace_acronym(
            """
`MOI.ScalarAffineFunction{$T}`-in-`MOI.Interval{$T}` constraints are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 [2] constrained variables in `MOI.LessThan{$T}` are not supported because:
   Cannot use `$(MOI.Bridges.Variable.VectorizeBridge{T,MOI.Nonpositives})` because:
   [3] constrained variables in `MOI.Nonpositives` are not supported
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 [3] constrained variables in `MOI.Nonpositives` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 [4] constrained variables in `MOI.Interval{$T}` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 (1) `MOI.ScalarAffineFunction{$T}`-in-`MOI.Interval{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.SplitIntervalBridge{T,MOI.ScalarAffineFunction{T},MOI.Interval{T},MOI.GreaterThan{T},MOI.LessThan{T}})` because:
   (3) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
   Cannot use `$(MOI.Bridges.Constraint.ScalarSlackBridge{T,MOI.ScalarAffineFunction{T},MOI.Interval{T}})` because:
   [4] constrained variables in `MOI.Interval{$T}` are not supported
 (3) `MOI.ScalarAffineFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.ScalarSlackBridge{T,MOI.ScalarAffineFunction{T},MOI.LessThan{T}})` because:
   [2] constrained variables in `MOI.LessThan{$T}` are not supported
""",
        )
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Variable.NonposToNonnegBridge{T},
        )
        @test debug_string(MOI.Bridges.debug_supports_constraint, F, S) ==
              "`MOI.ScalarAffineFunction{$T}`-in-`MOI.Interval{$T}` constraints are supported.\n"
    end
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    @testset "Quadratic objective" begin
        F = MOI.ScalarQuadraticFunction{T}
        attr = MOI.ObjectiveFunction{F}()
        @test debug_string(MOI.Bridges.debug_supports, attr) == """
Objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported and cannot be bridged into a supported objective function by adding only supported constrained variables and constraints. See details below:
 |1| objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported because no added bridge supports bridging it.
"""
        MOI.Bridges.add_bridge(bridged, MOI.Bridges.Objective.SlackBridge{T})
        @test debug_string(MOI.Bridges.debug_supports, attr) ==
              MOI.Utilities.replace_acronym(
            """
Objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported and cannot be bridged into a supported objective function by adding only supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.Reals` are not supported because no added bridge supports bridging it.
 (1) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported because no added bridge supports bridging it.
 (2) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported because no added bridge supports bridging it.
 |1| objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported because:
   Cannot use `$(MOI.Bridges.Objective.SlackBridge{T,MOI.ScalarQuadraticFunction{T},MOI.ScalarQuadraticFunction{T}})` because:
   [1] constrained variables in `MOI.Reals` are not supported
   (1) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported
   (2) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
   |2| objective function of type `MOI.VariableIndex` is not supported
 |2| objective function of type `MOI.VariableIndex` is not supported because no added bridge supports bridging it.
""",
        )
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Objective.FunctionizeBridge{T},
        )
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.QuadtoSOCBridge{T},
        )
        @test debug_string(MOI.Bridges.debug_supports, attr) ==
              MOI.Utilities.replace_acronym(
            """
Objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported and cannot be bridged into a supported objective function by adding only supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.Reals` are not supported because no added bridge supports bridging it.
 (1) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.QuadtoSOCBridge{T})` because:
   (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are not supported
 (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are not supported because no added bridge supports bridging it.
 (3) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.QuadtoSOCBridge{T})` because:
   (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are not supported
 |1| objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported because:
   Cannot use `$(MOI.Bridges.Objective.SlackBridge{T,MOI.ScalarQuadraticFunction{T},MOI.ScalarQuadraticFunction{T}})` because:
   [1] constrained variables in `MOI.Reals` are not supported
   (1) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported
   (3) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
""",
        )
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.VectorSlackBridge{T},
        )
        @test debug_string(MOI.Bridges.debug_supports, attr) ==
              MOI.Utilities.replace_acronym(
            """
Objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported and cannot be bridged into a supported objective function by adding only supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.Reals` are not supported because no added bridge supports bridging it.
 [2] constrained variables in `MOI.RotatedSecondOrderCone` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 (1) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.QuadtoSOCBridge{T})` because:
   (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are not supported
 (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.VectorSlackBridge{T,MOI.VectorAffineFunction{T},MOI.RotatedSecondOrderCone})` because:
   [2] constrained variables in `MOI.RotatedSecondOrderCone` are not supported
   (3) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are not supported
 (3) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are not supported because no added bridge supports bridging it.
 (4) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.QuadtoSOCBridge{T})` because:
   (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are not supported
 |1| objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported because:
   Cannot use `$(MOI.Bridges.Objective.SlackBridge{T,MOI.ScalarQuadraticFunction{T},MOI.ScalarQuadraticFunction{T}})` because:
   [1] constrained variables in `MOI.Reals` are not supported
   (1) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported
   (4) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
""",
        )
        MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.RSOCtoPSDBridge{T})
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.ScalarFunctionizeBridge{T},
        )
        @test debug_string(MOI.Bridges.debug_supports, attr) ==
              MOI.Utilities.replace_acronym(
            """
Objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported and cannot be bridged into a supported objective function by adding only supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.Reals` are not supported because no added bridge supports bridging it.
 (1) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.QuadtoSOCBridge{T})` because:
   (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are not supported
 (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.VectorSlackBridge{T,MOI.VectorAffineFunction{T},MOI.RotatedSecondOrderCone})` because:
   (4) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are not supported
 (4) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are not supported because no added bridge supports bridging it.
 (5) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.QuadtoSOCBridge{T})` because:
   (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are not supported
 |1| objective function of type `MOI.ScalarQuadraticFunction{$T}` is not supported because:
   Cannot use `$(MOI.Bridges.Objective.SlackBridge{T,MOI.ScalarQuadraticFunction{T},MOI.ScalarQuadraticFunction{T}})` because:
   [1] constrained variables in `MOI.Reals` are not supported
   (1) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are not supported
   (5) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.LessThan{$T}` constraints are not supported
""",
        )
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.ScalarizeBridge{T},
        )
        MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.FreeBridge{T})
        @test debug_string(MOI.Bridges.debug_supports, attr) ==
              "Objective function of type `MOI.ScalarQuadraticFunction{$T}` is supported.\n"
        @test sprint(MOI.Bridges.print_graph, bridged) ==
              MOI.Utilities.replace_acronym(
            """
Bridge graph with 2 variable nodes, 5 constraint nodes and 2 objective nodes.
 [1] constrained variables in `MOI.Reals` are bridged (distance 1) by $(MOI.Bridges.Variable.FreeBridge{T}).
 [2] constrained variables in `MOI.RotatedSecondOrderCone` are bridged (distance 11) by $(MOI.Bridges.Variable.RSOCtoPSDBridge{T}).
 (1) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.GreaterThan{$T}` constraints are bridged (distance 14) by $(MOI.Bridges.Constraint.QuadtoSOCBridge{T}).
 (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.RotatedSecondOrderCone` constraints are bridged (distance 13) by $(MOI.Bridges.Constraint.VectorSlackBridge{T,MOI.VectorAffineFunction{T},MOI.RotatedSecondOrderCone}).
 (3) `MOI.VariableIndex`-in-`MOI.EqualTo{$T}` constraints are bridged (distance 1) by $(MOI.Bridges.Constraint.ScalarFunctionizeBridge{T,MOI.EqualTo{T}}).
 (4) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are bridged (distance 1) by $(MOI.Bridges.Constraint.ScalarizeBridge{T,MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}).
 (5) `MOI.ScalarQuadraticFunction{$T}`-in-`MOI.LessThan{$T}` constraints are bridged (distance 14) by $(MOI.Bridges.Constraint.QuadtoSOCBridge{T}).
 |1| objective function of type `MOI.ScalarQuadraticFunction{$T}` is bridged (distance 31) by $(MOI.Bridges.Objective.SlackBridge{T,MOI.ScalarQuadraticFunction{T},MOI.ScalarQuadraticFunction{T}}).
 |2| objective function of type `MOI.VariableIndex` is bridged (distance 1) by $(MOI.Bridges.Objective.FunctionizeBridge{T,MOI.VariableIndex}).
""",
        )
    end
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    @testset "Exponential constraint" begin
        F = MOI.VectorAffineFunction{T}
        S = MOI.ExponentialCone
        @test debug_string(MOI.Bridges.debug_supports_constraint, F, S) == """
                                                                    `MOI.VectorAffineFunction{$T}`-in-`MOI.ExponentialCone` constraints are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
                                                                     (1) `MOI.VectorAffineFunction{$T}`-in-`MOI.ExponentialCone` constraints are not supported because no added bridge supports bridging it.
                                                                    """
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.VectorSlackBridge{T},
        )
        @test debug_string(MOI.Bridges.debug_supports_constraint, F, S) ==
              MOI.Utilities.replace_acronym(
            """
`MOI.VectorAffineFunction{$T}`-in-`MOI.ExponentialCone` constraints are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.ExponentialCone` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because free variables are bridged but no functionize bridge was added.
 (1) `MOI.VectorAffineFunction{$T}`-in-`MOI.ExponentialCone` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.VectorSlackBridge{T,MOI.VectorAffineFunction{T},MOI.ExponentialCone})` because:
   [1] constrained variables in `MOI.ExponentialCone` are not supported
   (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are not supported
 (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are not supported because no added bridge supports bridging it.
""",
        )
        MOI.Bridges.add_bridge(
            bridged,
            MOI.Bridges.Constraint.VectorFunctionizeBridge{T},
        )
        @test debug_string(MOI.Bridges.debug_supports_constraint, F, S) ==
              MOI.Utilities.replace_acronym(
            """
`MOI.VectorAffineFunction{$T}`-in-`MOI.ExponentialCone` constraints are not supported and cannot be bridged into supported constrained variables and constraints. See details below:
 [1] constrained variables in `MOI.ExponentialCone` are not supported because no added bridge supports bridging it.
   Cannot add free variables and then constrain them because:
   (1) `MOI.VectorAffineFunction{$T}`-in-`MOI.ExponentialCone` constraints are not supported
 (1) `MOI.VectorAffineFunction{$T}`-in-`MOI.ExponentialCone` constraints are not supported because:
   Cannot use `$(MOI.Bridges.Constraint.VectorSlackBridge{T,MOI.VectorAffineFunction{T},MOI.ExponentialCone})` because:
   [1] constrained variables in `MOI.ExponentialCone` are not supported
   (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are not supported
 (2) `MOI.VectorAffineFunction{$T}`-in-`MOI.Zeros` constraints are not supported because no added bridge supports bridging it.
""",
        )
    end
end

function _test_continuous_StandardSDPAModel(T)
    model = StandardSDPAModel{T}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, T)
    # For `ScalarAffineFunction`-in-`GreaterThan`,
    # `Constraint.ScalarSlackBridge` -> `Variable.VectorizeBridge`
    # is equivalent to
    # `Constraint.VectorizeBridge` -> `Constraint.VectorSlackBridge`
    # however, `Variable.VectorizeBridge` do not support modification of the
    # set hence it makes some tests of `contlineartest` fail so we disable it.
    MOI.Bridges.remove_bridge(
        bridged,
        MOI.Bridges.Constraint.ScalarSlackBridge{T},
    )
    MOI.Test.runtests(
        bridged,
        MOI.Test.Config(T; exclude = Any[MOI.optimize!]),
        include = ["test_linear_"],
        exclude = [
            "test_linear_Indicator",
            "test_linear_Semi",
            "test_linear_SOS",
            "test_linear_integer",
        ],
    )
    return
end

function test_continuous_StandardSDPAModel()
    _test_continuous_StandardSDPAModel(Float64)
    _test_continuous_StandardSDPAModel(Rational{Int})
    return
end

function test_StandardSDPAModel_with_bridges_and_caching()
    # This tests that the computation of the reverse dict in the
    # caching optimizer works with negative indices
    cached = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        MOI.Utilities.MANUAL,
    )
    vi_cache = MOI.add_variable(cached)
    f(vi) = 1.0 * vi
    ci_cache = MOI.add_constraint(cached, f(vi_cache), MOI.EqualTo(1.0))
    model = StandardSDPAModel{Float64}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, Float64)
    MOI.Utilities.reset_optimizer(cached, bridged)
    MOI.Utilities.attach_optimizer(cached)
    vi_bridged = first(MOI.get(bridged, MOI.ListOfVariableIndices()))
    @test vi_bridged == MOI.VariableIndex(-1)
    @test cached.model_to_optimizer_map[vi_cache] == vi_bridged
    @test cached.optimizer_to_model_map[vi_bridged] == vi_cache
    vis_sdpa = MOI.get(model, MOI.ListOfVariableIndices())
    F = typeof(f(vi_cache))
    S = MOI.EqualTo{Float64}
    ci_bridged = first(MOI.get(model, MOI.ListOfConstraintIndices{F,S}()))
    attr = MOI.ConstraintFunction()
    @test MOI.get(bridged, attr, ci_bridged) ≈ f(vi_bridged)
    cis = MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
    @test length(cis) == 1
    ci_sdpa = first(cis)
    func = [1.0, -1.0]' * vis_sdpa
    @test MOI.get(model, attr, ci_sdpa) ≈ func
    return
end

function test_conic_StandardSDPAModel()
    model = StandardSDPAModel{Float64}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, Float64)
    MOI.Test.test_conic_PositiveSemidefiniteConeSquare_VectorOfVariables(
        bridged,
        MOI.Test.Config(exclude = Any[MOI.optimize!]),
    )
    return
end

# Model not supporting RotatedSecondOrderCone
MOI.Utilities.@model(
    NoRSOCModel,
    (),
    (MOI.EqualTo, MOI.GreaterThan, MOI.LessThan),
    (
        MOI.Zeros,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.SecondOrderCone,
        MOI.NormInfinityCone,
        MOI.NormOneCone,
        MOI.ExponentialCone,
        MOI.PositiveSemidefiniteConeTriangle,
    ),
    (MOI.PowerCone,),
    (),
    (MOI.ScalarAffineFunction, MOI.ScalarQuadraticFunction),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction, MOI.VectorQuadraticFunction)
)

function _test_constrained_variables_in_RSOC(T)
    bridged = MOI.Bridges.full_bridge_optimizer(NoRSOCModel{T}(), T)
    @test MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    )
    # It should be selected over `MOI.Bridges.Variable.RSOCtoPSDBridge` even if they
    # are tied in terms of number of bridges because it is added first in
    # `MOI.Bridges.full_bridge_optimizer`.
    @test MOI.Bridges.bridge_type(bridged, MOI.RotatedSecondOrderCone) ==
          MOI.Bridges.Variable.RSOCtoSOCBridge{T}
    x, cx =
        MOI.add_constrained_variables(bridged, MOI.RotatedSecondOrderCone(3))
    for i in 1:3
        @test MOI.Bridges.bridge(bridged, x[i]) isa
              MOI.Bridges.Variable.RSOCtoSOCBridge{T}
    end
    @test MOI.Bridges.bridge(bridged, cx) isa
          MOI.Bridges.Variable.RSOCtoSOCBridge{T}
    return
end

function test_constrained_variables_in_RSOC()
    # We only use floating point types as there is √2
    _test_constrained_variables_in_RSOC(Float64)
    _test_constrained_variables_in_RSOC(BigFloat)
    return
end

# Model not supporting VectorOfVariables and VariableIndex
MOI.Utilities.@model(
    NoVariableModel,
    (MOI.ZeroOne, MOI.Integer),
    (MOI.EqualTo, MOI.GreaterThan, MOI.LessThan),
    (MOI.Zeros, MOI.Nonnegatives, MOI.Nonpositives, MOI.SecondOrderCone),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    (MOI.VectorAffineFunction,)
)
function MOI.supports_constraint(
    ::NoVariableModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.Utilities.SUPPORTED_VARIABLE_SCALAR_SETS{T}},
) where {T}
    return false
end

function _test_continuous_conic_with_NoVariableModel(T)
    model = NoVariableModel{T}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, T)
    # The best variable bridge for SOC and RSOC are respectively `SOCtoRSOC` and `RSOCtoSOC`.
    # This forms a cycle because using the variable bridges is not in the shortest path.
    # Therefore they should not be used when calling `add_constrained_variables`.
    # Moreover, the printing should say that the variable bridge is not used.
    @test MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.SecondOrderCone,
    )
    @test MOI.Bridges.bridge_type(bridged, MOI.SecondOrderCone) ==
          MOI.Bridges.Variable.SOCtoRSOCBridge{T}
    @test !MOI.Bridges.is_variable_bridged(bridged, MOI.RotatedSecondOrderCone)
    @test MOI.supports_constraint(
        bridged,
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    )
    @test MOI.Bridges.bridge_type(bridged, MOI.RotatedSecondOrderCone) ==
          MOI.Bridges.Variable.RSOCtoSOCBridge{T}
    @test !MOI.Bridges.is_variable_bridged(bridged, MOI.RotatedSecondOrderCone)
    x, cx = MOI.add_constrained_variables(bridged, MOI.SecondOrderCone(3))
    @test !any(v -> MOI.Bridges.is_bridged(bridged, v), x)
    @test !MOI.Bridges.is_variable_bridged(bridged, cx)
    @test MOI.Bridges.bridge(bridged, cx) isa
          MOI.Bridges.Constraint.VectorFunctionizeBridge{T,MOI.SecondOrderCone}
    y, cy =
        MOI.add_constrained_variables(bridged, MOI.RotatedSecondOrderCone(4))
    @test !any(v -> MOI.Bridges.is_bridged(bridged, v), y)
    @test !MOI.Bridges.is_variable_bridged(bridged, cy)
    @test MOI.Bridges.bridge(bridged, cy) isa
          MOI.Bridges.Constraint.RSOCtoSOCBridge{T}
    graph = sprint(MOI.Bridges.print_graph, bridged)
    # The contents of `graph` can very as new bridges are added. Test that it
    # prints something, and that key features are present.
    # If this test fails in future, run `print(graph)` and update as necessary.
    for needle in (
        "Bridge graph with ",
        "constrained variables in `MOI.NormCone` are not supported",
        "`MOI.VectorOfVariables`-in-`MOI.SecondOrderCone` constraints are bridged",
        "`MOI.VectorOfVariables`-in-`MOI.Scaled{MOI.PositiveSemidefiniteConeTriangle}` constraints are not supported",
    )
        @test occursin(needle, graph)
    end
    return
end

function test_continuous_conic_with_NoVariableModel()
    _test_continuous_conic_with_NoVariableModel(Float64)
    _test_continuous_conic_with_NoVariableModel(Float32)
    return
end

MOI.Utilities.@model(
    OnlyNonnegVAF,
    (),
    (),
    (MOI.Nonnegatives,),
    (),
    (),
    (),
    (),
    (MOI.VectorAffineFunction,)
)

function MOI.supports_constraint(
    ::OnlyNonnegVAF{T},
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.Utilities.SUPPORTED_VARIABLE_SCALAR_SETS{T}},
) where {T}
    return false
end

struct InvariantUnderFunctionConversionAttribute <:
       MOI.AbstractConstraintAttribute end

function MOI.Bridges.Constraint.invariant_under_function_conversion(
    ::InvariantUnderFunctionConversionAttribute,
)
    return true
end

function _dict(model::OnlyNonnegVAF)
    if !haskey(model.ext, :InvariantUnderFunctionConversionAttribute)
        model.ext[:InvariantUnderFunctionConversionAttribute] =
            Dict{MOI.ConstraintIndex,Any}()
    end
    return model.ext[:InvariantUnderFunctionConversionAttribute]
end

function MOI.set(
    model::OnlyNonnegVAF,
    ::InvariantUnderFunctionConversionAttribute,
    ci::MOI.ConstraintIndex,
    value,
)
    return _dict(model)[ci] = value
end

function MOI.get(
    model::OnlyNonnegVAF,
    ::InvariantUnderFunctionConversionAttribute,
    ci::MOI.ConstraintIndex,
)
    return _dict(model)[ci]
end

function _test_context_substitution(T)
    # Two Variable bridge in context
    model = OnlyNonnegVAF{T}()
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    MOI.Bridges.add_bridge(
        bridged,
        MOI.Bridges.Constraint.VectorFunctionizeBridge{T},
    )
    MOI.Bridges.add_bridge(
        bridged,
        MOI.Bridges.Variable.NonposToNonnegBridge{T},
    )
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.VectorizeBridge{T})
    x, cx = MOI.add_constrained_variable(bridged, MOI.LessThan(one(T)))
    vectorize = MOI.Bridges.bridge(bridged, x)
    @test vectorize isa MOI.Bridges.Variable.VectorizeBridge
    y = vectorize.variable
    flip = MOI.Bridges.bridge(bridged, y)
    @test flip isa MOI.Bridges.Variable.NonposToNonnegBridge
    Z = flip.variables
    z = Z[1]
    vov_ci = flip.constraint
    functionize = MOI.Bridges.bridge(bridged, vov_ci)
    @test functionize isa MOI.Bridges.Constraint.VectorFunctionizeBridge
    aff_ci = functionize.constraint
    function f(vi)
        return MOI.Bridges.Variable.unbridged_function(
            MOI.Bridges.Variable.bridges(bridged),
            vi,
        )
    end
    @test f(y) ≈ one(T) * x - one(T)
    @test MOI.Bridges.call_in_context(bridged, x, bridge -> f(y)) === nothing
    @test MOI.Bridges.call_in_context(bridged, y, bridge -> f(y)) === nothing
    @test f(z) ≈ -one(T) * y
    @test MOI.Bridges.call_in_context(bridged, x, bridge -> f(z)) ≈ f(z)
    @test MOI.Bridges.call_in_context(bridged, y, bridge -> f(z)) === nothing
    attr = InvariantUnderFunctionConversionAttribute()
    for func in [T(2) * x, T(2) * y, T(2) * z]
        MOI.set(model, attr, aff_ci, func)
        @test MOI.get(model, attr, aff_ci) ≈ func
        @test MOI.Bridges.call_in_context(
            bridged,
            vov_ci,
            bridge -> MOI.get(bridged, attr, vov_ci),
        ) ≈ func
        @test MOI.Bridges.call_in_context(
            bridged,
            y,
            bridge -> MOI.get(bridged, attr, vov_ci),
        ) ≈ func
        #@test MOI.Bridges.call_in_context(bridged, z, bridge -> MOI.get(bridged, attr, vov_ci)) ≈ func
    end
    # One Variable bridge in context
    model = NoVariableModel{T}()
    bridged = MOI.Bridges.LazyBridgeOptimizer(model)
    MOI.Bridges.add_bridge(bridged, MOI.Bridges.Variable.RSOCtoSOCBridge{T})
    MOI.Bridges.add_bridge(
        bridged,
        MOI.Bridges.Constraint.VectorFunctionizeBridge{T},
    )
    x, cx =
        MOI.add_constrained_variables(bridged, MOI.RotatedSecondOrderCone(4))
    y = MOI.add_variable(bridged)
    @test MOI.get(bridged, MOI.NumberOfVariables()) == 5
    @test MOI.is_valid(bridged, y)
    MOI.delete(bridged, y)
    @test MOI.get(bridged, MOI.NumberOfVariables()) == 4
    @test !MOI.is_valid(bridged, y)
    _test_delete_bridged_variables(
        bridged,
        x,
        MOI.RotatedSecondOrderCone,
        4,
        (
            (MOI.VectorOfVariables, MOI.SecondOrderCone, 0),
            (MOI.VectorAffineFunction{T}, MOI.SecondOrderCone, 0),
        ),
    )
    return
end

function test_context_substitution()
    _test_context_substitution(Float64)
    _test_context_substitution(Float32)
    return
end

# Only supports GreaterThan and Nonnegatives
MOI.Utilities.@model(
    GreaterNonnegModel,
    (),
    (MOI.GreaterThan,),
    (MOI.Nonnegatives,),
    (),
    (),
    (MOI.ScalarAffineFunction, MOI.ScalarQuadraticFunction),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction, MOI.VectorQuadraticFunction)
)

function MOI.supports_constraint(
    ::GreaterNonnegModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{<:Union{MOI.EqualTo{T},MOI.LessThan{T},MOI.Interval{T}}},
) where {T}
    return false
end

MOI.Utilities.@model(
    ModelNoVAFinSOC,
    (),
    (MOI.EqualTo, MOI.GreaterThan, MOI.LessThan, MOI.Interval),
    (
        MOI.Zeros,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.SecondOrderCone,
        MOI.NormInfinityCone,
        MOI.NormOneCone,
        MOI.RotatedSecondOrderCone,
        MOI.GeometricMeanCone,
        MOI.PositiveSemidefiniteConeTriangle,
        MOI.ExponentialCone,
    ),
    (MOI.PowerCone, MOI.DualPowerCone),
    (),
    (MOI.ScalarAffineFunction, MOI.ScalarQuadraticFunction),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction, MOI.VectorQuadraticFunction)
)

function MOI.supports_constraint(
    ::ModelNoVAFinSOC{Float64},
    ::Type{MOI.VectorAffineFunction{Float64}},
    ::Type{MOI.SecondOrderCone},
)
    return false
end

# Model supporting nothing
MOI.Utilities.@model NothingModel () () () () () () () ()

function MOI.supports_constraint(
    ::NothingModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{
        <:Union{
            MOI.EqualTo{T},
            MOI.GreaterThan{T},
            MOI.LessThan{T},
            MOI.Interval{T},
            MOI.Integer,
            MOI.ZeroOne,
        },
    },
) where {T}
    return false
end

struct BridgeAddingNoConstraint{T} <: MOI.Bridges.Constraint.AbstractBridge end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:BridgeAddingNoConstraint},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(::Type{<:BridgeAddingNoConstraint})
    return Tuple{Type,Type}[]
end

function MOI.supports_constraint(
    ::Type{<:BridgeAddingNoConstraint},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.Integer},
)
    return true
end

function MOI.Bridges.Constraint.concrete_bridge_type(
    ::Type{<:BridgeAddingNoConstraint{T}},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.Integer},
) where {T}
    return BridgeAddingNoConstraint{T}
end

const LessThanIndicatorOne{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{T}}

MOI.Utilities.@model(
    ModelNoZeroIndicator,
    (MOI.ZeroOne, MOI.Integer),
    (
        MOI.EqualTo,
        MOI.GreaterThan,
        MOI.LessThan,
        MOI.Interval,
        MOI.Semicontinuous,
        MOI.Semiinteger,
    ),
    (
        MOI.Reals,
        MOI.Zeros,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.NormInfinityCone,
        MOI.NormOneCone,
        MOI.SecondOrderCone,
        MOI.RotatedSecondOrderCone,
        MOI.GeometricMeanCone,
        MOI.ExponentialCone,
        MOI.DualExponentialCone,
        MOI.RelativeEntropyCone,
        MOI.NormSpectralCone,
        MOI.NormNuclearCone,
        MOI.PositiveSemidefiniteConeTriangle,
        MOI.PositiveSemidefiniteConeSquare,
        MOI.RootDetConeTriangle,
        MOI.RootDetConeSquare,
        MOI.LogDetConeTriangle,
        MOI.LogDetConeSquare,
    ),
    (
        MOI.PowerCone,
        MOI.DualPowerCone,
        MOI.SOS1,
        MOI.SOS2,
        LessThanIndicatorOne,
    ),
    (),
    (MOI.ScalarAffineFunction, MOI.ScalarQuadraticFunction),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction, MOI.VectorQuadraticFunction)
)

MOI.Utilities.@model(
    ModelNoIndicator,
    (MOI.ZeroOne, MOI.Integer),
    (
        MOI.EqualTo,
        MOI.GreaterThan,
        MOI.LessThan,
        MOI.Interval,
        MOI.Semicontinuous,
        MOI.Semiinteger,
    ),
    (
        MOI.Reals,
        MOI.Zeros,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.NormInfinityCone,
        MOI.NormOneCone,
        MOI.SecondOrderCone,
        MOI.RotatedSecondOrderCone,
        MOI.GeometricMeanCone,
        MOI.ExponentialCone,
        MOI.DualExponentialCone,
        MOI.RelativeEntropyCone,
        MOI.NormSpectralCone,
        MOI.NormNuclearCone,
        MOI.PositiveSemidefiniteConeTriangle,
        MOI.PositiveSemidefiniteConeSquare,
        MOI.RootDetConeTriangle,
        MOI.RootDetConeSquare,
        MOI.LogDetConeTriangle,
        MOI.LogDetConeSquare,
    ),
    (MOI.PowerCone, MOI.DualPowerCone, MOI.SOS1, MOI.SOS2),
    (),
    (MOI.ScalarAffineFunction, MOI.ScalarQuadraticFunction),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction, MOI.VectorQuadraticFunction)
)

function test_bridge_adding_no_constraint()
    mock = MOI.Utilities.MockOptimizer(NothingModel{Int}())
    bridged = MOI.Bridges.LazyBridgeOptimizer(mock)
    MOI.Bridges.add_bridge(bridged, BridgeAddingNoConstraint{Float64})
    @test MOI.Bridges.supports_bridging_constraint(
        bridged,
        MOI.VariableIndex,
        MOI.Integer,
    )
end

function test_unsupported_constraint_with_cycles()
    # Test that `supports_constraint` works correctly when it is not
    # supported but the bridges forms a cycle
    mock = MOI.Utilities.MockOptimizer(NothingModel{Float64}())
    bridged = MOI.Bridges.full_bridge_optimizer(mock, Float64)
    @test !MOI.supports_constraint(
        bridged,
        MOI.VariableIndex,
        MOI.GreaterThan{Float64},
    )
    @test !MOI.supports_constraint(
        bridged,
        MOI.VectorAffineFunction{Float64},
        MOI.Nonpositives,
    )
end

function test_UnsupportedConstraint_when_it_cannot_be_bridged()
    mock = MOI.Utilities.MockOptimizer(NoRSOCModel{Float64}())
    bridged_mock = MOI.Bridges.LazyBridgeOptimizer(mock)
    x = MOI.add_variables(bridged_mock, 4)
    err = MOI.UnsupportedConstraint{
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    }()
    @test_throws err begin
        MOI.add_constraint(
            bridged_mock,
            MOI.VectorOfVariables(x),
            MOI.RotatedSecondOrderCone(4),
        )
    end
end

function test_MOI_runtests_No_RSOCModel()
    mock = MOI.Utilities.MockOptimizer(NoRSOCModel{Float64}())
    bridged_mock = MOI.Bridges.LazyBridgeOptimizer(mock)

    MOI.Bridges.add_bridge(
        bridged_mock,
        MOI.Bridges.Constraint.SplitIntervalBridge{Float64},
    )
    MOI.Bridges.add_bridge(
        bridged_mock,
        MOI.Bridges.Constraint.RSOCtoPSDBridge{Float64},
    )
    MOI.Bridges.add_bridge(
        bridged_mock,
        MOI.Bridges.Constraint.SOCtoPSDBridge{Float64},
    )
    MOI.Bridges.add_bridge(
        bridged_mock,
        MOI.Bridges.Constraint.RSOCtoSOCBridge{Float64},
    )
    MOI.Test.runtests(
        bridged_mock,
        MOI.Test.Config(),
        include = ["ConstraintName", "VariableName"],
    )
    return
end

function test_bridge_selection()
    mock = MOI.Utilities.MockOptimizer(NoRSOCModel{Float64}())
    bridged_mock = MOI.Bridges.LazyBridgeOptimizer(mock)

    MOI.Bridges.add_bridge(
        bridged_mock,
        MOI.Bridges.Constraint.SplitIntervalBridge{Float64},
    )
    MOI.Bridges.add_bridge(
        bridged_mock,
        MOI.Bridges.Constraint.RSOCtoPSDBridge{Float64},
    )
    MOI.Bridges.add_bridge(
        bridged_mock,
        MOI.Bridges.Constraint.SOCtoPSDBridge{Float64},
    )
    MOI.Bridges.add_bridge(
        bridged_mock,
        MOI.Bridges.Constraint.RSOCtoSOCBridge{Float64},
    )
    @test !(MOI.supports_constraint(
        bridged_mock,
        MOI.VectorAffineFunction{Float64},
        MOI.LogDetConeTriangle,
    ))
    x = MOI.add_variables(bridged_mock, 3)
    err = MOI.UnsupportedConstraint{
        MOI.VectorAffineFunction{Float64},
        MOI.LogDetConeTriangle,
    }()
    @test_throws err begin
        MOI.Bridges.bridge_type(
            bridged_mock,
            MOI.VectorAffineFunction{Float64},
            MOI.LogDetConeTriangle,
        )
    end
    c = MOI.add_constraint(
        bridged_mock,
        MOI.VectorOfVariables(x),
        MOI.RotatedSecondOrderCone(3),
    )
    @test MOI.Bridges.bridge_type(
        bridged_mock,
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    ) == MOI.Bridges.Constraint.RSOCtoSOCBridge{
        Float64,
        MOI.VectorAffineFunction{Float64},
        MOI.VectorOfVariables,
    }
    @test MOI.Bridges.bridge(bridged_mock, c) isa
          MOI.Bridges.Constraint.RSOCtoSOCBridge
    @test bridged_mock.graph.constraint_dist[MOI.Bridges.node(
        bridged_mock,
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    ).index] == 1
    return
end

function test_supports()
    mock = MOI.Utilities.MockOptimizer(NoRSOCModel{Float64}())
    full_bridged_mock = MOI.Bridges.full_bridge_optimizer(mock, Float64)
    for S in [MOI.Nonnegatives, MOI.Nonpositives, MOI.Zeros]
        @test !MOI.supports_constraint(full_bridged_mock, MOI.VariableIndex, S)
    end
    for S in
        [MOI.GreaterThan{Float64}, MOI.LessThan{Float64}, MOI.EqualTo{Float64}]
        @test !MOI.supports_constraint(
            full_bridged_mock,
            MOI.VectorOfVariables,
            S,
        )
    end
    greater_nonneg_mock =
        MOI.Utilities.MockOptimizer(GreaterNonnegModel{Float64}())
    full_bridged_greater_nonneg =
        MOI.Bridges.full_bridge_optimizer(greater_nonneg_mock, Float64)
    for F in [
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    ]
        @test MOI.supports_constraint(
            full_bridged_mock,
            F,
            MOI.Interval{Float64},
        )
        @test !MOI.supports_constraint(
            greater_nonneg_mock,
            F,
            MOI.LessThan{Float64},
        )
        @test MOI.supports_constraint(
            full_bridged_greater_nonneg,
            F,
            MOI.LessThan{Float64},
        )
    end
    for F in [
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{Float64},
        MOI.VectorQuadraticFunction{Float64},
    ]
        @test MOI.supports_constraint(
            full_bridged_mock,
            F,
            MOI.PositiveSemidefiniteConeSquare,
        )
        @test MOI.supports_constraint(
            full_bridged_mock,
            F,
            MOI.GeometricMeanCone,
        )
        @test MOI.supports_constraint(
            full_bridged_mock,
            F,
            MOI.RelativeEntropyCone,
        )
        @test !MOI.supports_constraint(greater_nonneg_mock, F, MOI.Nonpositives)
        @test MOI.supports_constraint(
            full_bridged_greater_nonneg,
            F,
            MOI.Nonnegatives,
        )
    end
    for F in [MOI.VectorOfVariables, MOI.VectorAffineFunction{Float64}]
        # The bridges in this for loop do not support yet
        # VectorQuadraticFunction. See TODO's for the reason.
        # TODO: Missing vcat for quadratic for supporting quadratic.
        @test MOI.supports_constraint(
            full_bridged_mock,
            F,
            MOI.RotatedSecondOrderCone,
        )
        # TODO: Det bridges need to use MOI.Utilities.operate to support quadratic.
        @test MOI.supports_constraint(
            full_bridged_mock,
            F,
            MOI.LogDetConeTriangle,
        )
        @test MOI.supports_constraint(
            full_bridged_mock,
            F,
            MOI.RootDetConeTriangle,
        )
    end
    mock2 = MOI.Utilities.MockOptimizer(ModelNoVAFinSOC{Float64}())
    @test !MOI.supports_constraint(
        mock2,
        MOI.VectorAffineFunction{Float64},
        MOI.SecondOrderCone,
    )
    full_bridged_mock2 = MOI.Bridges.full_bridge_optimizer(mock2, Float64)
    @test MOI.supports_constraint(
        full_bridged_mock2,
        MOI.VectorAffineFunction{Float64},
        MOI.SecondOrderCone,
    )
    mock_indicator =
        MOI.Utilities.MockOptimizer(ModelNoZeroIndicator{Float64}())
    full_bridged_mock_indicator =
        MOI.Bridges.full_bridge_optimizer(mock_indicator, Float64)
    @test !MOI.supports_constraint(
        mock_indicator,
        MOI.VectorAffineFunction{Float64},
        MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.LessThan{Float64}},
    )
    @test MOI.supports_constraint(
        full_bridged_mock_indicator,
        MOI.VectorAffineFunction{Float64},
        MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.LessThan{Float64}},
    )

    mock_sos_indicator =
        MOI.Utilities.MockOptimizer(ModelNoIndicator{Float64}())
    full_bridged_mock_sos_indicator =
        MOI.Bridges.full_bridge_optimizer(mock_sos_indicator, Float64)
    @test !MOI.supports_constraint(
        mock_sos_indicator,
        MOI.VectorAffineFunction{Float64},
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{Float64}},
    )
    @test !MOI.supports_constraint(
        mock_sos_indicator,
        MOI.VectorAffineFunction{Float64},
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.EqualTo{Float64}},
    )
    @test MOI.supports_constraint(
        full_bridged_mock_sos_indicator,
        MOI.VectorAffineFunction{Float64},
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{Float64}},
    )
    @test MOI.supports_constraint(
        full_bridged_mock_sos_indicator,
        MOI.VectorAffineFunction{Float64},
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.EqualTo{Float64}},
    )
    for T in [Float64, Int]
        no_variable_mock = MOI.Utilities.MockOptimizer(NoVariableModel{T}())
        full_bridged_no_variable =
            MOI.Bridges.full_bridge_optimizer(no_variable_mock, T)
        for S in [
            MOI.LessThan{T},
            MOI.GreaterThan{T},
            MOI.EqualTo{T},
            MOI.ZeroOne,
            MOI.Integer,
        ]
            @test MOI.supports_constraint(
                full_bridged_no_variable,
                MOI.VariableIndex,
                S,
            )
        end
        for S in
            [MOI.Nonpositives, MOI.Nonnegatives, MOI.Zeros, MOI.SecondOrderCone]
            @test MOI.supports_constraint(
                full_bridged_no_variable,
                MOI.VectorOfVariables,
                S,
            )
        end
    end
    return
end

struct CustomVectorSet <: MOI.AbstractVectorSet
    dimension::Int
end

struct CustomScalarSet <: MOI.AbstractScalarSet end

function test_wrong_coefficient_1()
    for (S, T) in [(Complex{Float64}, Float64), (Float64, Int)]
        model = MOI.Utilities.Model{T}()
        bridged = MOI.Bridges.full_bridge_optimizer(model, T)
        MOI.Bridges.remove_bridge(
            bridged,
            MOI.Bridges.Constraint.SplitComplexEqualToBridge{T},
        )
        MOI.Bridges.remove_bridge(
            bridged,
            MOI.Bridges.Constraint.SplitComplexZerosBridge{T},
        )
        x = MOI.add_variable(bridged)
        f_scalar = one(S) * x
        f_vector = MOI.Utilities.vectorize([f_scalar])
        function _test(func, set)
            @test_throws(
                MOI.UnsupportedConstraint{typeof(func),typeof(set)},
                MOI.add_constraint(bridged, func, set),
            )
            @test !MOI.supports_constraint(bridged, typeof(func), typeof(set))
            return
        end
        _test(f_scalar, MOI.EqualTo(one(S)))
        _test(f_vector, MOI.Zeros(1))
        _test(f_scalar, CustomScalarSet())
        _test(f_vector, CustomVectorSet(1))
    end
    return
end

struct OptimizerWithBridgeListOfNonstandardBridges <: MOI.AbstractOptimizer end

struct BridgeListOfNonstandardBridges{T} <:
       MOI.Bridges.Constraint.AbstractBridge end

function MOI.get(
    ::OptimizerWithBridgeListOfNonstandardBridges,
    ::MOI.Bridges.ListOfNonstandardBridges{T},
) where {T}
    return Type[BridgeListOfNonstandardBridges{T}]
end

function test_ListOfNonstandardBridges()
    b = MOI.Bridges.full_bridge_optimizer(
        OptimizerWithBridgeListOfNonstandardBridges(),
        Int,
    )
    @test MOI.Bridges.has_bridge(b, BridgeListOfNonstandardBridges{Int})
    @test !MOI.Bridges.has_bridge(b, BridgeListOfNonstandardBridges{Float64})
    attr = MOI.Bridges.ListOfNonstandardBridges{Int}()
    ret = MOI.get(b, attr)
    @test ret isa MOI.attribute_value_type(attr)
    return
end

function test_hermitian(T = Float64)
    model = StandardSDPAModel{T}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, T)
    S = MOI.HermitianPositiveSemidefiniteConeTriangle
    MOI.Bridges.bridge_type(bridged, S) ==
    MOI.Bridges.Variable.HermitianToSymmetricPSDBridge{T}
    # FIXME This would actually better to functionize, slack and do the variable bridge here
    #       but since it is 3 bridges, it does not choose it
    @test MOI.Bridges.bridge_type(bridged, MOI.VectorOfVariables, S) <:
          MOI.Bridges.Constraint.HermitianToSymmetricPSDBridge{T}
    @test MOI.Bridges.bridge_type(bridged, MOI.VectorAffineFunction{T}, S) <:
          MOI.Bridges.Constraint.VectorSlackBridge{T}
    model = GeometricSDPAModel{T}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, T)
    @test !MOI.Bridges.is_variable_bridged(bridged, S)
    for F in [MOI.VectorOfVariables, MOI.VectorAffineFunction{T}]
        @test MOI.Bridges.bridge_type(bridged, F, S) <:
              MOI.Bridges.Constraint.HermitianToSymmetricPSDBridge{T}
    end
end

MOI.Utilities.@model(
    Model2235,
    (),
    (MOI.LessThan,),
    (MOI.Nonnegatives, MOI.RotatedSecondOrderCone),
    (),
    (),
    (MOI.ScalarQuadraticFunction,),
    (),
    (MOI.VectorAffineFunction,),
)

function MOI.supports_constraint(
    ::Model2235,
    ::Type{MOI.VariableIndex},
    ::Type{<:Union{MOI.LessThan,MOI.GreaterThan,MOI.Interval,MOI.EqualTo}},
)
    return false
end

function test_ToScalarQuadraticBridge_used()
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}
    inner = Model2235{Float64}()
    # `FunctionConversionBridge{T,MOI.ScalarQuadraticFunction{T}}` bridge
    # to a supported constraint in 1 bridge but it has a higher bridging cost
    # This tests that the bridging cost is taken into account.
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64)
    @test MOI.Bridges.bridging_cost(model, F, S) == 2.0
    @test MOI.Bridges.bridge_type(model, F, S) <:
          MOI.Bridges.Constraint.LessToGreaterBridge{Float64}
    MOI.Bridges.remove_bridge(
        model,
        MOI.Bridges.Constraint.LessToGreaterBridge{Float64},
    )
    @test MOI.Bridges.bridging_cost(model, F, S) == 2.0
    @test MOI.Bridges.bridge_type(model, F, S) <:
          MOI.Bridges.Constraint.VectorizeBridge{Float64}
    MOI.Bridges.remove_bridge(
        model,
        MOI.Bridges.Constraint.VectorizeBridge{Float64},
    )
    @test MOI.Bridges.bridging_cost(model, F, S) == 3.0
    @test MOI.Bridges.bridge_type(model, F, S) <:
          MOI.Bridges.Constraint.LessToIntervalBridge{Float64}
    MOI.Bridges.remove_bridge(
        model,
        MOI.Bridges.Constraint.LessToIntervalBridge{Float64},
    )
    @test MOI.Bridges.bridging_cost(model, F, S) == 10.0
    @test MOI.Bridges.bridge_type(model, F, S) <:
          MOI.Bridges.Constraint.ToScalarQuadraticBridge{Float64}
    x = MOI.add_variable(model)
    MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0))
    @test MOI.get(inner, MOI.ListOfConstraintTypesPresent()) ==
          [(MOI.ScalarQuadraticFunction{Float64}, MOI.LessThan{Float64})]
    return
end

function test_ToScalarQuadraticBridge_not_used()
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}
    inner = Model2235{Float64}()
    model = MOI.Bridges.LazyBridgeOptimizer(inner)
    @test MOI.Bridges.bridging_cost(model, F, S) == Inf
    MOI.Bridges.add_bridge(
        model,
        MOI.Bridges.Constraint.ToScalarQuadraticBridge{Float64},
    )
    @test MOI.Bridges.bridging_cost(model, F, S) == 10.0
    MOI.Bridges.add_bridge(
        model,
        MOI.Bridges.Constraint.LessToGreaterBridge{Float64},
    )
    MOI.Bridges.add_bridge(
        model,
        MOI.Bridges.Constraint.VectorizeBridge{Float64},
    )
    @test MOI.Bridges.bridging_cost(model, F, S) == 2.0
    x = MOI.add_variable(model)
    MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0))
    @test MOI.get(inner, MOI.ListOfConstraintTypesPresent()) ==
          [(MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives)]
    return
end

function test_ToScalarQuadraticBridge_variable_bounds()
    inner = Model2235{Float64}()
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.LessThan(1.0))
    @test MOI.get(inner, MOI.ListOfConstraintTypesPresent()) ==
          [(MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives)]
    F, S = MOI.VariableIndex, MOI.LessThan{Float64}
    @test MOI.Bridges.bridging_cost(model, F, S) == 2.0
    return
end

MOI.Utilities.@model(
    ModelQuadObj,
    (),
    (),
    (MOI.Nonnegatives, MOI.Zeros),
    (),
    (),
    (),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction,),
)

function MOI.supports(
    ::ModelQuadObj{T},
    ::MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}},
) where {T}
    return false
end

function test_objective_conversion_cost(T = Float64)
    model = ModelQuadObj{T}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, T)
    x = MOI.add_variable(bridged)
    MOI.set(bridged, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(bridged, MOI.ObjectiveFunction{typeof(x)}(), one(T) * x)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == MOI.VariableIndex
    return
end

function test_delete_index_in_vector(T::Type = Float64)
    model = MOI.instantiate(StandardSDPAModel{T}; with_bridge_type = T)
    x = MOI.add_variables(model, 4)
    c = MOI.add_constraint(model, x, MOI.Nonpositives(4))
    @test MOI.is_valid(model, c)
    MOI.delete(model, x[3])
    @test MOI.is_valid(model, c)
    @test MOI.is_valid(model, x[1])
    @test MOI.is_valid(model, x[2])
    @test !MOI.is_valid(model, x[3])
    @test MOI.is_valid(model, x[4])
    @test MOI.get(model, MOI.ConstraintFunction(), c).variables == x[[1, 2, 4]]
    return
end

function test_bridge_complex_normonecone()
    model = MOI.instantiate(
        MOI.Utilities.Model{Float64};
        with_bridge_type = Float64,
    )
    x = MOI.add_variable(model)
    t = MOI.add_variable(model)
    f = (1.0 + 0.0im) * x + 2.0 * im
    g = MOI.Utilities.operate(vcat, Complex{Float64}, t, f)
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constraint(model, g, MOI.NormOneCone(2)),
    )
    return
end

function test_bridge_complex_secondorder()
    model = MOI.instantiate(
        MOI.Utilities.Model{Float64};
        with_bridge_type = Float64,
    )
    x = MOI.add_variable(model)
    t = MOI.add_variable(model)
    f = (1.0 + 0.0im) * x + 2.0 * im
    g = MOI.Utilities.operate(vcat, Complex{Float64}, t, f)
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constraint(model, g, MOI.SecondOrderCone(2)),
    )
    return
end

function test_bridge_complex_nonnegtononpos()
    model = MOI.instantiate(
        MOI.Utilities.Model{Float64};
        with_bridge_type = Float64,
    )
    x = MOI.add_variable(model)
    f = (1.0 + 0.0im) * x + 2.0 * im
    g = MOI.Utilities.operate(vcat, Complex{Float64}, f)
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constraint(model, g, MOI.Nonnegatives(1)),
    )
    return
end

function test_bridge_complex_nonpostononneg()
    model = MOI.instantiate(
        MOI.Utilities.Model{Float64};
        with_bridge_type = Float64,
    )
    x = MOI.add_variable(model)
    f = (1.0 + 0.0im) * x + 2.0 * im
    g = MOI.Utilities.operate(vcat, Complex{Float64}, f)
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constraint(model, g, MOI.Nonpositives(1)),
    )
    return
end

function test_bridge_complex_lesstogreater()
    model = MOI.instantiate(
        MOI.Utilities.Model{Float64};
        with_bridge_type = Float64,
    )
    x = MOI.add_variable(model)
    f = (1.0 + 0.0im) * x + 2.0 * im
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constraint(model, f, MOI.LessThan(1.0)),
    )
    return
end

function test_bridge_complex_greatertoless()
    model = MOI.instantiate(
        MOI.Utilities.Model{Float64};
        with_bridge_type = Float64,
    )
    x = MOI.add_variable(model)
    f = (1.0 + 0.0im) * x + 2.0 * im
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constraint(model, f, MOI.GreaterThan(1.0))
    )
    return
end

function test_issue_2696()
    b = MOI.instantiate(StandardSDPAModel{Float64}; with_bridge_type = Float64)
    x = MOI.add_variables(b, 2)
    c = MOI.add_constraint(b, MOI.VectorOfVariables(x), MOI.Nonpositives(2))
    @test MOI.is_valid(b, c)
    F, S = MOI.VectorOfVariables, MOI.Nonpositives
    # See MathOptInterface.jl#2696
    d = MOI.ConstraintIndex{F,S}(c.value + 1)
    @test_broken !MOI.is_valid(b, d)
    @test MOI.get(b, MOI.ListOfConstraintTypesPresent()) == [(F, S)]
    @test only(MOI.get(b, MOI.ListOfConstraintIndices{F,S}())) == c
    @test MOI.get(b, MOI.NumberOfConstraints{F,S}()) == 1
    return
end

function test_wrong_coefficient_2()
    model = MOI.instantiate(
        MOI.Utilities.Model{Float64},
        with_bridge_type = Float64,
    )
    @test !MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{Int},
        MOI.Nonnegatives,
    )
    @test !MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{Int},
        MOI.PositiveSemidefiniteConeTriangle,
    )
    @test !MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{Int},
        MOI.EqualTo{Int},
    )
    @test !MOI.supports_constraint(
        model,
        MOI.VectorQuadraticFunction{Int},
        MOI.Zeros,
    )
    return
end

MOI.Utilities.@model(
    Model2838,
    (),
    (MOI.GreaterThan,),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
)

function _test_conflicts(model, inner, c)
    ci = MOI.ConstraintIndex[]
    for (F, S) in MOI.get(inner, MOI.ListOfConstraintTypesPresent())
        append!(ci, MOI.get(inner, MOI.ListOfConstraintIndices{F,S}()))
    end
    list = (MOI.NOT_IN_CONFLICT, MOI.IN_CONFLICT, MOI.MAYBE_IN_CONFLICT)
    for a in Iterators.product(ntuple(i -> list, length(ci))...)
        MOI.set(inner, MOI.ConflictCount(), 1)
        MOI.set.(inner, MOI.ConstraintConflictStatus(), ci, a)
        MOI.compute_conflict!(model)
        status = MOI.get(model, MOI.ConstraintConflictStatus(), c)
        @test status == reduce(_cmp, a)
    end
    return
end

function _cmp(
    a::MOI.ConflictParticipationStatusCode,
    b::MOI.ConflictParticipationStatusCode,
)
    if a == MOI.IN_CONFLICT || b == MOI.IN_CONFLICT
        return MOI.IN_CONFLICT
    elseif a == MOI.MAYBE_IN_CONFLICT || b == MOI.MAYBE_IN_CONFLICT
        return MOI.MAYBE_IN_CONFLICT
    else
        return MOI.NOT_IN_CONFLICT
    end
end

function test_issue_2838()
    inner = MOI.Utilities.MockOptimizer(Model2838{Float64}())
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64)
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, Float64, (1.0 * x)...)
    c = MOI.add_constraint(model, f, MOI.Nonnegatives(2))
    _test_conflicts(model, inner, c)
    return
end

function test_issue_2870_scalar_slack()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.ScalarSlack{Float64}(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 2.0 * x, MOI.Interval(1.0, -1.0))
    _test_conflicts(model, inner, c)
    return
end

function test_issue_2870_geomean_to_power()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.GeoMeanToPower{Float64}(inner)
    x = MOI.add_variables(model, 4)
    f = MOI.VectorOfVariables(x)
    c = MOI.add_constraint(model, f, MOI.GeometricMeanCone(4))
    _test_conflicts(model, inner, c)
    return
end

function test_issue_2870_relative_entropy()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.RelativeEntropy{Float64}(inner)
    x = MOI.add_variables(model, 5)
    f = MOI.VectorOfVariables(x)
    c = MOI.add_constraint(model, f, MOI.RelativeEntropyCone(5))
    _test_conflicts(model, inner, c)
    return
end

end  # module

TestBridgesLazyBridgeOptimizer.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    _CBFDataStructure

A helpful datastructure for converting between MOI and CBF.
"""
mutable struct _CBFDataStructure
    num_rows::Int
    power_cones::Int
    dual_power_cones::Int
    psd_side_dims::Vector{Int}
    cones::Vector{Tuple{String,Int}}
    acoord::Vector{Tuple{Int,Int,Float64}}
    bcoord::Vector{Tuple{Int,Float64}}
    hcoord::Vector{Tuple{Int,Int,Int,Int,Float64}}
    dcoord::Vector{Tuple{Int,Int,Int,Float64}}
    variables_with_domain::Set{MOI.VariableIndex}
    variable_cones::Vector{Tuple{Vector{MOI.VariableIndex},String}}
    # This is the identity mapping, except for EXP and EXP* cones,
    # in which (u, v, w) in MOI are swapped to (w, v, u) in CBF.
    scalar_variables::Vector{Int}

    function _CBFDataStructure()
        return new(
            0,
            0,
            0,
            Int[],
            Tuple{String,Int}[],
            Tuple{Int,Int,Float64}[],
            Tuple{Int,Float64}[],
            Tuple{Int,Int,Int,Int,Float64}[],
            Tuple{Int,Int,Int,Float64}[],
            Set{MOI.VariableIndex}(),
            Tuple{Vector{MOI.VariableIndex},String}[],
            Int[],
        )
    end
end

_cone_string(::Any, ::Type{MOI.Zeros}) = "L="
_cone_string(::Any, ::Type{MOI.Reals}) = "F"
_cone_string(::Any, ::Type{MOI.Nonnegatives}) = "L+"
_cone_string(::Any, ::Type{MOI.Nonpositives}) = "L-"
_cone_string(::Any, ::Type{MOI.SecondOrderCone}) = "Q"
_cone_string(::Any, ::Type{MOI.RotatedSecondOrderCone}) = "QR"
_cone_string(::Any, ::Type{MOI.ExponentialCone}) = "EXP"
_cone_string(::Any, ::Type{MOI.DualExponentialCone}) = "EXP*"

function _cone_string(data::_CBFDataStructure, ::Type{MOI.PowerCone{Float64}})
    s = "@$(data.power_cones):POW"
    data.power_cones += 1
    return s
end

function _cone_string(
    data::_CBFDataStructure,
    ::Type{MOI.DualPowerCone{Float64}},
)
    s = "@$(data.dual_power_cones):POW*"
    data.dual_power_cones += 1
    return s
end

function _add_function(data, f::MOI.VectorOfVariables, ::Any)
    for v in f.variables
        data.num_rows += 1
        push!(data.acoord, (data.num_rows, v.value, 1.0))
    end
    return
end

function _add_function(data, f::MOI.VectorAffineFunction, ::Any)
    for term in f.terms
        t = term.scalar_term
        row = data.num_rows + term.output_index
        push!(data.acoord, (row, t.variable.value, t.coefficient))
    end
    for c in f.constants
        data.num_rows += 1
        push!(data.bcoord, (data.num_rows, c))
    end
    return
end

function _add_function(
    data,
    f::MOI.VectorOfVariables,
    ::Type{<:Union{MOI.ExponentialCone,MOI.DualExponentialCone}},
)
    # The Exponential cone in MOI and CBF are reversed
    for v in reverse(f.variables)
        data.num_rows += 1
        push!(data.acoord, (data.num_rows, v.value, 1.0))
    end
    return
end

function _add_function(
    data,
    f::MOI.VectorAffineFunction,
    ::Type{<:Union{MOI.ExponentialCone,MOI.DualExponentialCone}},
)
    # The Exponential cone in MOI and CBF are reversed
    for term in f.terms
        t = term.scalar_term
        row = data.num_rows + 4 - term.output_index
        push!(data.acoord, (row, t.variable.value, t.coefficient))
    end
    for c in reverse(f.constants)
        data.num_rows += 1
        push!(data.bcoord, (data.num_rows, c))
    end
    return
end

function _add_cones(
    data::_CBFDataStructure,
    model::Model,
    ::Type{F},
    ::Type{S},
) where {F,S}
    for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        _add_function(data, f, S)
        set = MOI.get(model, MOI.ConstraintSet(), ci)
        push!(data.cones, (_cone_string(data, S), MOI.dimension(set)))
    end
    return
end

function _add_cones(
    data::_CBFDataStructure,
    model::Model,
    ::Type{F},
    ::Type{S},
) where {F<:MOI.VectorOfVariables,S}
    for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        is_variable_cone = true
        for (i, xi) in enumerate(f.variables)
            if xi in data.variables_with_domain
                is_variable_cone = false
                break
            elseif xi.value != f.variables[1].value + i - 1
                is_variable_cone = false
                break
            end
        end
        str = _cone_string(data, S)
        if !is_variable_cone
            _add_function(data, f, S)
            set = MOI.get(model, MOI.ConstraintSet(), ci)
            push!(data.cones, (str, MOI.dimension(set)))
        else
            for xi in f.variables
                push!(data.variables_with_domain, xi)
            end
            push!(data.variable_cones, (f.variables, str))
        end
    end
    return
end

function _add_cones(
    data::_CBFDataStructure,
    model::Model,
    F::Type{MOI.VectorOfVariables},
    S::Type{MOI.PositiveSemidefiniteConeTriangle},
)
    for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        set = MOI.get(model, MOI.ConstraintSet(), ci)
        push!(data.psd_side_dims, set.side_dimension)
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        k = 0
        for i in 1:set.side_dimension, j in 1:i
            k += 1
            push!(
                data.hcoord,
                (length(data.psd_side_dims), f.variables[k].value, i, j, 1.0),
            )
        end
    end
    return
end

function _add_cones(
    data::_CBFDataStructure,
    model::Model,
    F::Type{MOI.VectorAffineFunction{Float64}},
    S::Type{MOI.PositiveSemidefiniteConeTriangle},
)
    for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        set = MOI.get(model, MOI.ConstraintSet(), ci)
        push!(data.psd_side_dims, set.side_dimension)
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        for term in f.terms
            # Get (i,j) index in symmetric matrix from lower triangle index.
            i = div(1 + isqrt(8 * term.output_index - 7), 2)
            push!(
                data.hcoord,
                (
                    length(data.psd_side_dims),
                    term.scalar_term.variable.value,
                    i,
                    term.output_index - div(i * (i - 1), 2),
                    term.scalar_term.coefficient,
                ),
            )
        end
        k = 0
        for i in 1:set.side_dimension, j in 1:i
            k += 1
            c = f.constants[k]
            if !iszero(c)
                push!(data.dcoord, (length(data.psd_side_dims), i, j, c))
            end
        end
    end
    return
end

function _CBFDataStructure(model::Model)
    data = _CBFDataStructure()
    for S in (
        MOI.Zeros,
        MOI.Reals,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.SecondOrderCone,
        MOI.RotatedSecondOrderCone,
        MOI.ExponentialCone,
        MOI.DualExponentialCone,
        MOI.PowerCone{Float64},
        MOI.DualPowerCone{Float64},
    )
        _add_cones(data, model, MOI.VectorOfVariables, S)
        _add_cones(data, model, MOI.VectorAffineFunction{Float64}, S)
    end
    _add_cones(
        data,
        model,
        MOI.VectorOfVariables,
        MOI.PositiveSemidefiniteConeTriangle,
    )
    _add_cones(
        data,
        model,
        MOI.VectorAffineFunction{Float64},
        MOI.PositiveSemidefiniteConeTriangle,
    )
    return data
end

function _write_VER(io)
    println(io, "VER\n3\n")
    return
end

function _write_OBJSENSE(io::IO, model::Model)
    if MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
        println(io, "OBJSENSE\nMAX\n")
    else
        println(io, "OBJSENSE\nMIN\n")
    end
    return
end

function _write_POWCONES(io::IO, model::Model, S, keyword)
    cons = vcat(
        MOI.get(model, MOI.ListOfConstraintIndices{MOI.VectorOfVariables,S}()),
        MOI.get(
            model,
            MOI.ListOfConstraintIndices{MOI.VectorAffineFunction{Float64},S}(),
        ),
    )
    if isempty(cons)
        return
    end
    println(io, keyword)
    println(io, length(cons), " ", 2 * length(cons))
    for ci in cons
        println(io, 2)
        set = MOI.get(model, MOI.ConstraintSet(), ci)
        println(io, set.exponent)
        println(io, 1.0 - set.exponent)
    end
    println(io)
    return
end

function _write_VAR(io::IO, model::Model, data)
    num_var = MOI.get(model, MOI.NumberOfVariables())
    append!(data.scalar_variables, collect(1:num_var))
    cones = Tuple{String,Int}[]
    current_variable = 0
    for (f, str) in sort!(data.variable_cones; by = x -> first(x[1]).value)
        offset = first(f).value - current_variable - 1
        if offset > 0
            push!(cones, ("F", offset))
        end
        push!(cones, (str, length(f)))
        current_variable = last(f).value
    end
    if current_variable < num_var
        push!(cones, ("F", num_var - current_variable))
    end
    println(io, "VAR")
    println(io, num_var, " ", length(cones))
    offset = 1
    for (K, n) in cones
        println(io, K, " ", n)
        if K == "EXP" || K == "EXP*"
            # The ordering for EXP and EXP* is reversed between MOI and CBF
            tmp = data.scalar_variables[offset]
            data.scalar_variables[offset] = data.scalar_variables[offset+2]
            data.scalar_variables[offset+2] = tmp
        end
        offset += n
    end
    println(io)
    return
end

function _write_INT(io::IO, model::Model, data)
    cons = MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Integer}(),
    )
    if isempty(cons)
        return
    end
    println(io, "INT")
    println(io, length(cons))
    for ci in cons
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        println(io, data.scalar_variables[f.value] - 1)
    end
    println(io)
    return
end

function _write_PSDCON(io::IO, data::_CBFDataStructure)
    if isempty(data.psd_side_dims)
        return
    end
    println(io, "PSDCON\n", length(data.psd_side_dims))
    for side_dim in data.psd_side_dims
        println(io, side_dim)
    end
    println(io)
    return
end

function _write_OBJACOORD(io::IO, model::Model, data)
    f = MOI.get(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
    )
    if !isempty(f.terms)
        println(io, "OBJACOORD\n", length(f.terms))
        for t in f.terms
            column = data.scalar_variables[t.variable.value] - 1
            println(io, column, " ", t.coefficient)
        end
        println(io)
    end
    return f.constant
end

function _write_OBJBCOORD(io::IO, constant::Float64)
    if !iszero(constant)
        println(io, "OBJBCOORD\n", constant, "\n")
    end
    return
end

function _write_CON(io::IO, data::_CBFDataStructure)
    if isempty(data.cones)
        return
    end
    println(io, "CON\n", data.num_rows, " ", length(data.cones))
    for (s, dim) in data.cones
        println(io, s, " ", dim)
    end
    println(io)
    return
end

function _write_ACOORD(io::IO, data::_CBFDataStructure)
    if isempty(data.acoord)
        return
    end
    println(io, "ACOORD\n", length(data.acoord))
    for (row, var, coef) in data.acoord
        column = data.scalar_variables[var] - 1
        println(io, row - 1, " ", column, " ", coef)
    end
    println(io)
    return
end

function _write_BCOORD(io::IO, data::_CBFDataStructure)
    if isempty(data.bcoord)
        return
    end
    println(io, "BCOORD\n", length(data.bcoord))
    for (row, constant) in data.bcoord
        println(io, row - 1, " ", constant)
    end
    println(io)
    return
end

function _write_HCOORD(io::IO, data::_CBFDataStructure)
    if isempty(data.hcoord)
        return
    end
    println(io, "HCOORD\n", length(data.hcoord))
    for (psd_idx, var, i, j, coef) in data.hcoord
        println(
            io,
            psd_idx - 1,
            " ",
            data.scalar_variables[var] - 1,
            " ",
            i - 1,
            " ",
            j - 1,
            " ",
            coef,
        )
    end
    println(io)
    return
end

function _write_DCOORD(io::IO, data::_CBFDataStructure)
    if isempty(data.dcoord)
        return
    end
    println(io, "DCOORD\n", length(data.dcoord))
    for (psd_idx, i, j, constant) in data.dcoord
        println(io, psd_idx - 1, " ", i - 1, " ", j - 1, " ", constant)
    end
    println(io)
    return
end

"""
    Base.write(io::IO, model::FileFormats.CBF.Model)

Write `model` to `io` in the Conic Benchmark Format.
"""
function Base.write(io::IO, model::Model)
    # The CBF file format requires an explicit ordering of the sections.
    # Below, each section is wrapped in a _write_SECTION function.
    # Sections that are currently not supported by the writer are added, but
    # commented out. They should be implemented in the future.

    # The CBF file format splits problem structure and problem data. Use this
    # datastructure to cache results between the different sections.
    #
    # If a section doesn't need cached data, just use `model` directly.
    data = _CBFDataStructure(model)

    ###
    ### File format
    ###
    _write_VER(io)

    ###
    ### Parametric cone specification
    ###
    _write_POWCONES(io, model, MOI.PowerCone{Float64}, "POWCONES")
    _write_POWCONES(io, model, MOI.DualPowerCone{Float64}, "POW*CONES")

    ###
    ### Problem structure
    ###
    _write_OBJSENSE(io, model)
    # _write_PSDVAR
    _write_VAR(io, model, data)
    _write_INT(io, model, data)
    _write_PSDCON(io, data)
    _write_CON(io, data)

    ###
    ### Problem data
    ###
    # _write_OBJFCOORD
    constant = _write_OBJACOORD(io, model, data)
    _write_OBJBCOORD(io, constant)
    # _write_FCOORD
    _write_ACOORD(io, data)
    _write_BCOORD(io, data)
    _write_HCOORD(io, data)
    _write_DCOORD(io, data)
    # _write_CHANGE
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type AbstractFunctionConversionBridge{F,S} <: AbstractBridge end

Abstract type to support writing bridges in which the function changes but the
set does not.

By convention, the transformed function is stored in the `.constraint` field.
"""
abstract type AbstractFunctionConversionBridge{F,S} <: AbstractBridge end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.AbstractConstraintAttribute,
    bridge::AbstractFunctionConversionBridge,
)
    if !invariant_under_function_conversion(attr)
        throw(
            MOI.UnsupportedAttribute(
                attr,
                "Bridge of type `$(typeof(bridge))` does not support getting " *
                "the attribute `$attr` because " *
                "`MOIB.Constraint.invariant_under_function_conversion($attr)` " *
                "returns `false`.",
            ),
        )
    end
    return MOI.get(model, attr, bridge.constraint)
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.CanonicalConstraintFunction,
    bridge::AbstractFunctionConversionBridge,
)
    f = MOI.get(model, MOI.ConstraintFunction(), bridge)
    return MOI.Utilities.canonical(f)
end

# Needed to avoid an ambiguity with the getter for MOI.AbstractConstraintAttribute
function MOI.get(
    ::MOI.ModelLike,
    ::MOI.Bridges.FirstBridge,
    bridge::AbstractFunctionConversionBridge,
)
    return bridge
end

# Needed to avoid an ambiguity with the getter for MOI.Constraint.AbstractBridge
function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintConflictStatus,
    bridge::AbstractFunctionConversionBridge,
)
    ret = MOI.NOT_IN_CONFLICT
    for (F, S) in MOI.Bridges.added_constraint_types(typeof(bridge))
        for ci in MOI.get(bridge, MOI.ListOfConstraintIndices{F,S}())
            status = MOI.get(model, attr, ci)
            if status == MOI.IN_CONFLICT
                return status
            elseif status == MOI.MAYBE_IN_CONFLICT
                ret = status
            end
        end
    end
    return ret
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.AbstractConstraintAttribute,
    ::Type{<:AbstractFunctionConversionBridge{F,S}},
) where {F,S}
    return invariant_under_function_conversion(attr) &&
           MOI.supports(model, attr, MOI.ConstraintIndex{F,S})
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.AbstractConstraintAttribute,
    bridge::AbstractFunctionConversionBridge,
    value,
)
    if !invariant_under_function_conversion(attr)
        throw(
            MOI.UnsupportedAttribute(
                attr,
                "Bridge of type `$(typeof(bridge))` does not support setting " *
                "the attribute `$attr` because " *
                "`MOIB.Constraint.invariant_under_function_conversion($attr)` " *
                "returns `false`.",
            ),
        )
    end
    MOI.set(model, attr, bridge.constraint, value)
    return
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:AbstractFunctionConversionBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:AbstractFunctionConversionBridge{F,S}},
) where {F,S}
    return Tuple{Type,Type}[(F, S)]
end

function MOI.get(
    ::AbstractFunctionConversionBridge{F,S},
    ::MOI.NumberOfConstraints{F,S},
)::Int64 where {F,S}
    return 1
end

function MOI.get(
    b::AbstractFunctionConversionBridge{F,S},
    ::MOI.ListOfConstraintIndices{F,S},
) where {F,S}
    return [b.constraint]
end

function MOI.delete(model::MOI.ModelLike, c::AbstractFunctionConversionBridge)
    MOI.delete(model, c.constraint)
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::AbstractFunctionConversionBridge{F},
    f,
) where {F}
    MOI.set(model, MOI.ConstraintFunction(), bridge.constraint, convert(F, f))
    return
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::AbstractFunctionConversionBridge{F},
    i::MOI.Bridges.IndexInVector,
) where {F<:MOI.AbstractVectorFunction}
    func = MOI.get(model, MOI.ConstraintFunction(), bridge.constraint)
    idx = setdiff(1:MOI.output_dimension(func), i.value)
    new_func = MOI.Utilities.eachscalar(func)[idx]
    set = MOI.get(model, MOI.ConstraintSet(), bridge.constraint)
    new_set = MOI.update_dimension(set, MOI.dimension(set) - 1)
    # If we first do `MOI.delete` and then `MOI.add_constraint`,
    # there might be an issue of `MOI.delete` ends up deleting a
    # bridged variables.
    # Indeed, in that case,
    # `_delete_variables_in_vector_of_variables_constraint` might
    # then try to get `get` `ConstraintFunction` for this bridge
    # which will fail since the `bridge.constraint` is invalid.
    # We avoid this issue by calling `add_constraint` first.
    old_constraint = bridge.constraint
    bridge.constraint = MOI.add_constraint(model, new_func, new_set)
    MOI.delete(model, old_constraint)
    return
end

"""
    invariant_under_function_conversion(attr::MOI.AbstractConstraintAttribute)

Returns whether the value of the attribute does not change if the constraint
`F`-in-`S` is transformed into a constraint `G`-in-`S` where `F` and `G` are
equivalent representations of the same function.

If it returns true, then subtypes of
[`Constraint.AbstractFunctionConversionBridge`](@ref) such as
[`Constraint.ScalarFunctionizeBridge`](@ref) and
[`Constraint.VectorFunctionizeBridge`](@ref) will automatically support
[`MOI.get`](@ref) and [`MOI.set`](@ref) for `attr`.
"""
invariant_under_function_conversion(::MOI.AbstractConstraintAttribute) = false

function invariant_under_function_conversion(
    ::Union{
        MOI.ConstraintSet,
        MOI.ConstraintBasisStatus,
        MOI.ConstraintPrimal,
        MOI.ConstraintPrimalStart,
        MOI.ConstraintDual,
        MOI.ConstraintDualStart,
        MOI.ConstraintConflictStatus,
    },
)
    return true
end

"""
    FunctionConversionBridge{T,F,G,S} <: AbstractFunctionConversionBridge{G,S}

`FunctionConversionBridge` implements the following reformulations:

  * ``g(x) \\in S`` into ``f(x) \\in S``

for these pairs of functions:

 * [`MOI.ScalarAffineFunction`](@ref)` to [`MOI.ScalarQuadraticFunction`](@ref)
 * [`MOI.ScalarQuadraticFunction`](@ref)  to [`MOI.ScalarNonlinearFunction`](@ref)
 * [`MOI.VectorAffineFunction`](@ref) to [`MOI.VectorQuadraticFunction`](@ref)

See also [`SetConversionBridge`](@ref).

## Source node

`FunctionConversionBridge` supports:

  * `G` in `S`

## Target nodes

`FunctionConversionBridge` creates:

  * `F` in `S`
"""
mutable struct FunctionConversionBridge{T,F,G,S} <:
               AbstractFunctionConversionBridge{F,S}
    constraint::MOI.ConstraintIndex{F,S}
end
# The `struct` needs to be mutable if `F <: AbstractVectorFunction`
# in case one row is deleted. See `MOI.delete` above.

function bridge_constraint(
    ::Type{FunctionConversionBridge{T,F,G,S}},
    model::MOI.ModelLike,
    f::G,
    s::S,
) where {T,F,G,S}
    ci = MOI.add_constraint(model, convert(F, f), s)
    return FunctionConversionBridge{T,F,G,S}(ci)
end

"""
    conversion_cost(
        F::Type{<:MOI.AbstractFunction},
        G::Type{<:MOI.AbstractFunction},
    )::Float64

Return a `Float64` returning the cost of converting any function of type `G`
to a function of type `F` with `convert`.

This cost is used to compute [`MOI.Bridges.bridging_cost`](@ref).

The default cost is `Inf`, which means that
[`MOI.Bridges.Constraint.FunctionConversionBridge`](@ref) should not attempt the
conversion.
"""
function conversion_cost(
    ::Type{<:MOI.AbstractFunction},
    ::Type{<:MOI.AbstractFunction},
)
    return Inf
end

function conversion_cost(
    F::Type{<:MOI.AbstractVectorFunction},
    G::Type{<:MOI.AbstractVectorFunction},
)
    return conversion_cost(
        MOI.Utilities.scalar_type(F),
        MOI.Utilities.scalar_type(G),
    )
end

function conversion_cost(
    ::Type{<:MOI.ScalarAffineFunction},
    ::Type{MOI.VariableIndex},
)
    return 1.0
end

function conversion_cost(
    ::Type{MOI.ScalarQuadraticFunction{T}},
    ::Type{<:Union{MOI.VariableIndex,MOI.ScalarAffineFunction{T}}},
) where {T}
    return 10.0
end

function conversion_cost(
    ::Type{MOI.ScalarNonlinearFunction},
    ::Type{
        <:Union{
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{Float64},
            MOI.ScalarQuadraticFunction{Float64},
        },
    },
)
    return 100.0
end

function MOI.supports_constraint(
    ::Type{<:FunctionConversionBridge{T,F}},
    ::Type{G},
    ::Type{<:MOI.AbstractSet},
) where {T,F,G<:MOI.AbstractFunction}
    return MOI.Utilities.is_coefficient_type(G, T) &&
           isfinite(conversion_cost(F, G))
end

function concrete_bridge_type(
    ::Type{<:FunctionConversionBridge{T,F}},
    G::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
) where {T,F}
    return FunctionConversionBridge{T,F,G,S}
end

function MOI.Bridges.bridging_cost(
    ::Type{<:FunctionConversionBridge{T,F,G}},
) where {T,F,G}
    return conversion_cost(F, G)
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    b::FunctionConversionBridge{T,F,G},
) where {T,F,G}
    # TODO(odow): there's a bug _somewhere_ in call_in_context, which means that
    # using CanonicalConstraintFunction here doesn't work. I got too confused
    # trying to track it down, so I explicitly called canonical here instead.
    # We need canonical, because the downstream bridges may have added
    # additional terms that mean it can't be directly converted to G.
    f = MOI.get(model, MOI.ConstraintFunction(), b.constraint)
    return MOI.Utilities.convert_approx(G, MOI.Utilities.canonical(f))
end

"""

    ScalarFunctionizeBridge{T,S} = FunctionConversionBridge{T,MOI.ScalarAffineFunction{T},MOI.VariableIndex,S}

`ScalarFunctionizeBridge` implements the following reformulations:

  * ``x \\in S`` into ``1x + 0 \\in S``

## Source node

`ScalarFunctionizeBridge` supports:

  * [`MOI.VariableIndex`](@ref) in `S`

## Target nodes

`ScalarFunctionizeBridge` creates:

  * [`MOI.ScalarAffineFunction{T}`](@ref) in `S`
"""
const ScalarFunctionizeBridge{T,S} =
    FunctionConversionBridge{T,MOI.ScalarAffineFunction{T},MOI.VariableIndex,S}

const ScalarFunctionize{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ScalarFunctionizeBridge{T},OT}

# VectorOfVariables -> VectorAffineFunction  # Handled by VectorFunctionizeBridge

"""
    VectorFunctionizeBridge{T,S} = FunctionConversionBridge{T,MOI.VectorAffineFunction{T},S}

`VectorFunctionizeBridge` implements the following reformulations:

  * ``x \\in S`` into ``Ix + 0 \\in S``

## Source node

`VectorFunctionizeBridge` supports:

  * [`MOI.VectorOfVariables`](@ref) in `S`

## Target nodes

`VectorFunctionizeBridge` creates:

  * [`MOI.VectorAffineFunction{T}`](@ref) in `S`
"""
const VectorFunctionizeBridge{T,S} = FunctionConversionBridge{
    T,
    MOI.VectorAffineFunction{T},
    MOI.VectorOfVariables,
    S,
}

const VectorFunctionize{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{VectorFunctionizeBridge{T},OT}

# AbstractScalarFunction -> ScalarQuadraticFunction

"""
    ToScalarQuadraticBridge{T,G,S} <: AbstractFunctionConversionBridge{G,S}

`ToScalarQuadraticBridge` implements the following reformulation:

  * ``g(x) \\in S`` into ``f(x) \\in S``

where `g` is an abstract scalar function and `f` is a
[`MOI.ScalarQuadraticFunction`](@ref).

## Source node

`ToScalarQuadraticBridge` supports:

  * `G<:AbstractScalarFunction` in `S`

## Target nodes

`ToScalarQuadraticBridge` creates:

  * [`MOI.ScalarQuadraticFunction`](@ref) in `S`
"""
const ToScalarQuadraticBridge{T,G,S} =
    FunctionConversionBridge{T,MOI.ScalarQuadraticFunction{T},G,S}

const ToScalarQuadratic{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ToScalarQuadraticBridge{T},OT}

# AbstractVectorFunction -> VectorQuadraticFunction

"""
    ToVectorQuadraticBridge{T,G,S} <: AbstractFunctionConversionBridge{G,S}

`ToVectorQuadraticBridge` implements the following reformulation:

  * ``g(x) \\in S`` into ``f(x) \\in S``

where `g` is an abstract vector function and `f` is a
[`MOI.VectorQuadraticFunction`](@ref).

## Source node

`ToVectorQuadraticBridge` supports:

  * `G<:AbstractVectorFunction` in `S`

## Target nodes

`ToVectorQuadraticBridge` creates:

  * [`MOI.VectorQuadraticFunction`](@ref) in `S`
"""
const ToVectorQuadraticBridge{T,G,S} =
    FunctionConversionBridge{T,MOI.VectorQuadraticFunction{T},G,S}

const ToVectorQuadratic{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ToVectorQuadraticBridge{T},OT}

# AbstractScalarFunction -> ScalarNonlinearFunction

"""
    ToScalarNonlinearBridge{T,G,S} <: AbstractFunctionConversionBridge{G,S}

`ToScalarNonlinearBridge` implements the following reformulation:

  * ``g(x) \\in S`` into ``f(x) \\in S``

where `g` is an abstract scalar function and `f` is a
[`MOI.ScalarNonlinearFunction`](@ref).

## Source node

`ToScalarNonlinearBridge` supports:

  * `G<:AbstractScalarFunction` in `S`

## Target nodes

`ToScalarNonlinearBridge` creates:

  * [`MOI.ScalarNonlinearFunction`](@ref) in `S`
"""
const ToScalarNonlinearBridge{T,G,S} =
    FunctionConversionBridge{T,MOI.ScalarNonlinearFunction,G,S}

const ToScalarNonlinear{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ToScalarNonlinearBridge{T},OT}

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintToInterval
# These tests are mostly copies of the flip_sign.jl tests for GreaterToLess

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_GreaterToInterval()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.GreaterToInterval{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_$(F)_GreaterThanThan" for F in
            ["VariableIndex", "ScalarAffineFunction", "ScalarQuadraticFunction"]
        ],
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100.0, -100.0]),
    )
    MOI.Test.test_linear_modify_GreaterThan_and_LessThan_constraints(
        bridged_mock,
        config,
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.GreaterThan{Float64},
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, 2.0)
        @test MOI.get(bridged_mock, attr, ci) ≈ 2.0
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        ((MOI.ScalarAffineFunction{Float64}, MOI.Interval{Float64}, 0),),
    )
    return
end

function test_LessToInterval()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.LessToInterval{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_$(F)_LessThan" for F in
            ["VariableIndex", "ScalarAffineFunction", "ScalarQuadraticFunction"]
        ],
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{Float64}, MOI.Interval{Float64}) =>
                [-1.0],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [2.0]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{Float64}, MOI.Interval{Float64}) =>
                [-1.0],
        ),
    )
    MOI.Test.test_modification_set_scalaraffine_lessthan(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{Float64}, MOI.Interval{Float64}) =>
                [-1.0],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [0.5]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{Float64}, MOI.Interval{Float64}) =>
                [-0.5],
        ),
    )
    MOI.Test.test_modification_coef_scalaraffine_lessthan(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.LessThan{Float64},
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, 2.0)
        @test MOI.get(bridged_mock, attr, ci) ≈ 2.0
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        ((MOI.ScalarAffineFunction{Float64}, MOI.Interval{Float64}, 0),),
    )
    return
end

# Define a dummy optimizer that only supports intervals
# and use it in the below unmocked test
mutable struct Optimizer <: MOI.AbstractOptimizer end

MOI.get(model::Optimizer, ::MOI.SolverName) = "OnlyIntervalOptimizer"
MOI.get(model::Optimizer, ::MOI.SolverVersion) = "v0.1.0"

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.ScalarAffineFunction{Float64}},
    ::Type{MOI.Interval{Float64}},
)
    return true
end

function test_GreaterOrLessToInterval_unmocked()
    # model supports Interval but not LessThan or GreaterThan
    model = Optimizer()
    @test MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{Float64},
        MOI.Interval{Float64},
    )
    @test !MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{Float64},
        MOI.LessThan{Float64},
    )
    @test !MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{Float64},
        MOI.GreaterThan{Float64},
    )

    # bridged model supports all
    bridged = MOI.Bridges.Constraint.GreaterToInterval{Float64}(
        MOI.Bridges.Constraint.LessToInterval{Float64}(model),
    )
    @test MOI.supports_constraint(
        bridged,
        MOI.ScalarAffineFunction{Float64},
        MOI.Interval{Float64},
    )
    @test MOI.supports_constraint(
        bridged,
        MOI.ScalarAffineFunction{Float64},
        MOI.LessThan{Float64},
    )
    @test MOI.supports_constraint(
        bridged,
        MOI.ScalarAffineFunction{Float64},
        MOI.GreaterThan{Float64},
    )

    # bridged model with Bridges.full_bridge_optimizer
    bridged2 = MOI.Bridges.full_bridge_optimizer(model, Float64)
    @test MOI.supports_constraint(
        bridged2,
        MOI.ScalarAffineFunction{Float64},
        MOI.Interval{Float64},
    )
    @test MOI.supports_constraint(
        bridged2,
        MOI.ScalarAffineFunction{Float64},
        MOI.LessThan{Float64},
    )
    @test MOI.supports_constraint(
        bridged2,
        MOI.ScalarAffineFunction{Float64},
        MOI.GreaterThan{Float64},
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GreaterToIntervalBridge,
        """
        variables: x
        x >= 1.0
        """,
        """
        variables: x
        x in Interval(1.0, Inf)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GreaterToIntervalBridge,
        """
        variables: x
        2.0 * x >= 1.0
        """,
        """
        variables: x
        2.0 * x in Interval(1.0, Inf)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.LessToIntervalBridge,
        """
        variables: x
        x <= 1.0
        """,
        """
        variables: x
        x in Interval(-Inf, 1.0)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.LessToIntervalBridge,
        """
        variables: x
        2.0 * x <= 1.0
        """,
        """
        variables: x
        2.0 * x in Interval(-Inf, 1.0)
        """,
    )
    return
end

end  # module

TestConstraintToInterval.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type SetMapBridge{T,S1,S2} <: AbstractBridge end

Consider two type of sets, `S1` and `S2`, and a linear mapping `A` such that
the image of a set of type `S1` under `A` is a set of type `S2`.

A `SetMapBridge{T,S1,S2}` is a bridge that substitutes constrained variables
in `S2` into the image through `A` of constrained variables in `S1`.

The linear map `A` is described by:

 * [`MOI.Bridges.map_set`](@ref)
 * [`MOI.Bridges.map_function`](@ref)

Implementing a method for these two functions is sufficient to bridge
constrained variables. However, in order for the getters and setters of
attributes such as dual solutions and starting values to work as well, a method
for the following functions must be implemented:

 * [`MOI.Bridges.inverse_map_set`](@ref)
 * [`MOI.Bridges.inverse_map_function`](@ref)
 * [`MOI.Bridges.adjoint_map_function`](@ref)
 * [`MOI.Bridges.inverse_adjoint_map_function`](@ref).

See the docstrings of each function to see which feature would be missing if it
was not implemented for a given bridge.

## Fieldnames

If `S1` and `S2` are [`MOI.AbstractScalarSet`], the struct must have fields:

 * `variable::MOI.VariableIndex`
 * `constraint::MOI.ConstraintIndex{MOI.VariableIndex,S1}`

If `S1` and `S2` are [`MOI.AbstractVectorSet`], the struct must have fields:

 * `variable::Vector{MOI.VariableIndex}`
 * `constraint::MOI.ConstraintIndex{MOI.VectorOfVariables,S1}`
"""
abstract type SetMapBridge{T,S1,S2} <: AbstractBridge end

function bridge_constrained_variable(
    BT::Type{<:SetMapBridge{T,S1,S2}},
    model::MOI.ModelLike,
    set::S2,
) where {T,S1,S2}
    # In a Variable.SetMapBridge:
    #  map_set goes from Bridge -> User
    #  inverse_map_set goes from User -> Bridge
    new_set = MOI.Bridges.inverse_map_set(BT, set)
    variables, constraint = _add_constrained_var(model, new_set)
    return BT(variables, constraint)
end

function supports_constrained_variable(
    ::Type{<:SetMapBridge{T,S1,S2}},
    ::Type{S2},
) where {T,S1,S2<:MOI.AbstractSet}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:SetMapBridge{T,S1}},
) where {T,S1}
    return Tuple{Type}[(S1,)]
end

function MOI.Bridges.added_constraint_types(::Type{<:SetMapBridge})
    return Tuple{Type,Type}[]
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{
        MOI.ConstraintFunction,
        MOI.ConstraintPrimal,
        MOI.ConstraintPrimalStart,
    },
    bridge::SetMapBridge,
)
    value = MOI.get(model, attr, bridge.constraint)
    if value === nothing
        return
    end
    # In a Variable.SetMapBridge:
    #  map_function goes from Bridge -> User
    #  inverse_map_function goes from User -> Bridge
    return MOI.Bridges.map_function(bridge, value)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::SetMapBridge,
    value,
)
    if value === nothing
        MOI.set(model, attr, bridge.constraint, nothing)
        return
    end
    # In a Variable.SetMapBridge:
    #  map_function goes from Bridge -> User
    #  inverse_map_function goes from User -> Bridge
    bridged_value = MOI.Bridges.inverse_map_function(bridge, value)
    MOI.set(model, attr, bridge.constraint, bridged_value)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::SetMapBridge,
)
    set = MOI.get(model, attr, bridge.constraint)
    # In a Variable.SetMapBridge:
    #  map_set goes from Bridge -> User
    #  inverse_map_set goes from User -> Bridge
    return MOI.Bridges.map_set(bridge, set)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::SetMapBridge{T,S1},
    set::S1,
) where {T,S1}
    # In a Variable.SetMapBridge:
    #  map_set goes from Bridge -> User
    #  inverse_map_set goes from User -> Bridge
    mapped_set = MOI.Bridges.inverse_map_set(bridge, set)
    MOI.set(model, attr, bridge.constraint, mapped_set)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::SetMapBridge,
)
    value = MOI.get(model, attr, bridge.constraint)
    if value === nothing
        return
    end
    # In a Variable.SetMapBridge:
    #  inverse_adjoint_map_function goes from Bridge -> User
    #  adjoint_map_function goes from User -> Bridge
    return MOI.Bridges.inverse_adjoint_map_function(bridge, value)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::SetMapBridge,
    value,
)
    if value === nothing
        MOI.set(model, attr, bridge.constraint, nothing)
        return
    end
    # In a Variable.SetMapBridge:
    #  inverse_adjoint_map_function goes from Bridge -> User
    #  adjoint_map_function goes from User -> Bridge
    bridged_value = MOI.Bridges.adjoint_map_function(bridge, value)
    MOI.set(model, attr, bridge.constraint, bridged_value)
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    ::Type{<:SetMapBridge},
)
    return MOI.supports(model, attr, MOI.VariableIndex)
end

function unbridged_map(bridge::SetMapBridge{T}, vi::MOI.VariableIndex) where {T}
    F = MOI.ScalarAffineFunction{T}
    # In a Variable.SetMapBridge:
    #  map_function goes from Bridge -> User
    #  inverse_map_function goes from User -> Bridge
    mapped = MOI.Bridges.inverse_map_function(bridge, vi)
    return Pair{MOI.VariableIndex,F}[bridge.variable=>mapped]
end

# MOI.AbstractScalarSet

function _add_constrained_var(model, set::MOI.AbstractScalarSet)
    return MOI.add_constrained_variable(model, set)
end

function MOI.get(
    ::SetMapBridge{T,S1,<:MOI.AbstractScalarSet},
    ::MOI.NumberOfVariables,
)::Int64 where {T,S1}
    return 1
end

function MOI.get(
    bridge::SetMapBridge{T,S1,<:MOI.AbstractScalarSet},
    ::MOI.ListOfVariableIndices,
) where {T,S1}
    return [bridge.variable]
end

function MOI.get(
    ::SetMapBridge{T,S1},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,S1},
)::Int64 where {T,S1<:MOI.AbstractScalarSet}
    return 1
end

function MOI.get(
    bridge::SetMapBridge{T,S1},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,S1},
) where {T,S1<:MOI.AbstractScalarSet}
    return [bridge.constraint]
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::SetMapBridge{T,S1,S2},
) where {T,S1,S2<:MOI.AbstractScalarSet}
    MOI.delete(model, bridge.variable)
    return
end

function MOI.Bridges.bridged_function(
    bridge::SetMapBridge{T,<:MOI.AbstractScalarSet},
) where {T}
    func = MOI.Bridges.map_function(bridge, bridge.variable)
    return convert(MOI.ScalarAffineFunction{T}, func)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.VariablePrimal,MOI.VariablePrimalStart},
    bridge::SetMapBridge,
)
    value = MOI.get(model, attr, bridge.variable)
    if value === nothing
        return
    end
    # In a Variable.SetMapBridge:
    #  map_function goes from Bridge -> User
    #  inverse_map_function goes from User -> Bridge
    return MOI.Bridges.map_function(bridge, value)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    bridge::SetMapBridge,
    value,
)
    if value === nothing
        MOI.set(model, attr, bridge.variable, nothing)
        return
    end
    # In a Variable.SetMapBridge:
    #  map_function goes from Bridge -> User
    #  inverse_map_function goes from User -> Bridge
    bridged_value = MOI.Bridges.inverse_map_function(bridge, value)
    MOI.set(model, attr, bridge.variable, bridged_value)
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{<:SetMapBridge{T,S1}},
) where {T,S1<:MOI.AbstractScalarSet}
    return MOI.supports(model, attr, MOI.ConstraintIndex{MOI.VariableIndex,S1})
end

# MOI.AbstractVectorSet

function _add_constrained_var(model, set::MOI.AbstractVectorSet)
    return MOI.add_constrained_variables(model, set)
end

function MOI.get(bridge::SetMapBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.variables)
end

function MOI.get(bridge::SetMapBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.variables)
end

function MOI.get(
    ::SetMapBridge{T,S1},
    ::MOI.NumberOfConstraints{MOI.VectorOfVariables,S1},
)::Int64 where {T,S1<:MOI.AbstractVectorSet}
    return 1
end

function MOI.get(
    bridge::SetMapBridge{T,S1},
    ::MOI.ListOfConstraintIndices{MOI.VectorOfVariables,S1},
) where {T,S1<:MOI.AbstractVectorSet}
    return [bridge.constraint]
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::SetMapBridge{T,S1,S2},
) where {T,S1,S2<:MOI.AbstractVectorSet}
    MOI.delete(model, bridge.variables)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.VariablePrimal,MOI.VariablePrimalStart},
    bridge::SetMapBridge,
    i::MOI.Bridges.IndexInVector,
)
    value = MOI.get(model, attr, bridge.variables)
    if any(isnothing, value)
        return
    end
    # In a Variable.SetMapBridge:
    #  map_function goes from Bridge -> User
    #  inverse_map_function goes from User -> Bridge
    return MOI.Bridges.map_function(bridge, value, i)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    bridge::SetMapBridge,
    value,
    i::MOI.Bridges.IndexInVector,
)
    if value === nothing
        MOI.set(model, attr, bridge.variables[i.value], nothing)
        return
    end
    # In a Variable.SetMapBridge:
    #  map_function goes from Bridge -> User
    #  inverse_map_function goes from User -> Bridge
    bridged_value = MOI.Bridges.inverse_map_function(bridge, value)
    MOI.set(model, attr, bridge.variables[i.value], bridged_value)
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{<:SetMapBridge{T,S1}},
) where {T,S1<:MOI.AbstractVectorSet}
    CI = MOI.ConstraintIndex{MOI.VectorOfVariables,S1}
    return MOI.supports(model, attr, CI)
end

function MOI.Bridges.bridged_function(
    bridge::SetMapBridge{T},
    i::MOI.Bridges.IndexInVector,
) where {T}
    f = MOI.VectorOfVariables(bridge.variables)
    func = MOI.Bridges.map_function(bridge, f, i)
    return convert(MOI.ScalarAffineFunction{T}, func)
end

function unbridged_map(
    bridge::SetMapBridge{T},
    vis::Vector{MOI.VariableIndex},
) where {T}
    F = MOI.ScalarAffineFunction{T}
    func = MOI.VectorOfVariables(vis)
    # In a Variable.SetMapBridge:
    #  map_function goes from Bridge -> User
    #  inverse_map_function goes from User -> Bridge
    funcs = MOI.Bridges.inverse_map_function(bridge, func)
    scalars = MOI.Utilities.eachscalar(funcs)
    # FIXME not correct for SetDotProducts, it won't recover the dot product variables
    return Pair{MOI.VariableIndex,F}[
        bridge.variables[i] => scalars[i] for i in eachindex(bridge.variables)
    ]
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    IndicatorActiveOnFalseBridge{T,F,S} <: Bridges.Constraint.AbstractBridge

`IndicatorActiveOnFalseBridge` implements the following reformulation:

  * ``\\neg z \\implies {f(x) \\in S}`` into ``y \\implies {f(x) \\in S}``,
    ``z + y = 1``, and ``y \\in \\{0, 1\\}``

## Source node

`IndicatorActiveOnFalseBridge` supports:

  * [`MOI.VectorAffineFunction{T}`](@ref) in
    [`MOI.Indicator{MOI.ACTIVATE_ON_ZERO,S}`](@ref)

## Target nodes

`IndicatorActiveOnFalseBridge` creates:

  * [`MOI.VectorAffineFunction{T}`](@ref) in
    [`MOI.Indicator{MOI.ACTIVATE_ON_ONE,S}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo`](@ref)
  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)

"""
struct IndicatorActiveOnFalseBridge{
    T,
    F<:MOI.AbstractVectorFunction,
    S<:MOI.AbstractScalarSet,
} <: AbstractBridge
    variable::MOI.VariableIndex
    zero_one_cons::MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}
    disjunction_cons::MOI.ConstraintIndex{
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    }
    indicator_cons_index::MOI.ConstraintIndex{
        F,
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,S},
    }
end

const IndicatorActiveOnFalse{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{IndicatorActiveOnFalseBridge{T},OT}

function bridge_constraint(
    ::Type{IndicatorActiveOnFalseBridge{T,F,S}},
    model::MOI.ModelLike,
    f::MOI.VectorAffineFunction{T},
    s::IS,
) where {
    S<:MOI.AbstractScalarSet,
    T<:Real,
    F,
    IS<:MOI.Indicator{MOI.ACTIVATE_ON_ZERO,S},
}
    f_scalars = MOI.Utilities.eachscalar(f)
    z2, zo_cons = MOI.add_constrained_variable(model, MOI.ZeroOne())
    # z1 + z2 == 1
    dcons = MOI.Utilities.normalize_and_add_constraint(
        model,
        MOI.Utilities.operate(+, T, f_scalars[1], z2),
        MOI.EqualTo(one(T)),
    )
    f2 = MOI.Utilities.operate(vcat, T, z2, f_scalars[2])
    ci =
        MOI.add_constraint(model, f2, MOI.Indicator{MOI.ACTIVATE_ON_ONE}(s.set))
    return IndicatorActiveOnFalseBridge{T,F,S}(z2, zo_cons, dcons, ci)
end

function MOI.supports_constraint(
    ::Type{<:IndicatorActiveOnFalseBridge{T}},
    ::Type{<:MOI.VectorAffineFunction},
    ::Type{<:MOI.Indicator{MOI.ACTIVATE_ON_ZERO}},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:IndicatorActiveOnFalseBridge},
)
    return Tuple{Type}[(MOI.ZeroOne,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{IndicatorActiveOnFalseBridge{T,F,S}},
) where {T,F,S}
    return Tuple{Type,Type}[
        (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}),
        (F, MOI.Indicator{MOI.ACTIVATE_ON_ONE,S}),
    ]
end

function concrete_bridge_type(
    ::Type{<:IndicatorActiveOnFalseBridge{T}},
    ::Type{F},
    ::Type{MOI.Indicator{MOI.ACTIVATE_ON_ZERO,S}},
) where {T,F<:MOI.VectorAffineFunction,S<:MOI.AbstractScalarSet}
    return IndicatorActiveOnFalseBridge{T,F,S}
end

function concrete_bridge_type(
    ::Type{<:IndicatorActiveOnFalseBridge},
    ::Type{F},
    ::Type{MOI.Indicator{MOI.ACTIVATE_ON_ZERO,S}},
) where {F<:MOI.VectorAffineFunction,S<:MOI.AbstractScalarSet}
    return IndicatorActiveOnFalseBridge{Float64,F,S}
end

MOI.get(::IndicatorActiveOnFalseBridge, ::MOI.NumberOfVariables)::Int64 = 1

function MOI.get(b::IndicatorActiveOnFalseBridge, ::MOI.ListOfVariableIndices)
    return [b.variable]
end

function MOI.get(
    ::IndicatorActiveOnFalseBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return 1
end

function MOI.get(
    b::IndicatorActiveOnFalseBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return [b.disjunction_cons]
end

function MOI.get(
    ::IndicatorActiveOnFalseBridge{T,F,S},
    ::MOI.NumberOfConstraints{F,MOI.Indicator{MOI.ACTIVATE_ON_ONE,S}},
)::Int64 where {T,F,S}
    return 1
end

function MOI.get(
    b::IndicatorActiveOnFalseBridge{T,F,S},
    ::MOI.ListOfConstraintIndices{F,MOI.Indicator{MOI.ACTIVATE_ON_ONE,S}},
) where {T,F,S}
    return [b.indicator_cons_index]
end

function MOI.get(
    ::IndicatorActiveOnFalseBridge{T},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64 where {T}
    return 1
end

function MOI.get(
    b::IndicatorActiveOnFalseBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
) where {T}
    return [b.zero_one_cons]
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    b::IndicatorActiveOnFalseBridge,
)
    set = MOI.get(model, attr, b.indicator_cons_index)
    return MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(set.set)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    b::IndicatorActiveOnFalseBridge{T},
) where {T}
    f = MOI.get(model, attr, b.indicator_cons_index)
    y, fz = MOI.Utilities.eachscalar(f)
    z_plus_y = MOI.get(model, MOI.ConstraintFunction(), b.disjunction_cons)
    z = MOI.Utilities.operate(-, T, z_plus_y, y)
    MOI.Utilities.canonicalize!(z)
    return MOI.Utilities.operate(vcat, T, z, fz)
end

function MOI.delete(model::MOI.ModelLike, bridge::IndicatorActiveOnFalseBridge)
    MOI.delete(model, bridge.disjunction_cons)
    MOI.delete(model, bridge.indicator_cons_index)
    MOI.delete(model, bridge.variable)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestLP

using Test

import MathOptInterface as MOI
import MathOptInterface.FileFormats: LP

const LP_TEST_FILE = "test.lp"

function runtests()
    for name in names(@__MODULE__, all = true)
        if startswith("$(name)", "test_")
            @testset "$name" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    sleep(1.0)  # Allow time for unlink to happen.
    rm(LP_TEST_FILE, force = true)
    return
end

function test_show()
    @test sprint(summary, LP.Model()) == "MOI.FileFormats.LP.Model"
    return
end

function test_comprehensive_write()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: a, x, y, z
minobjective: x
x >= -1.0
x <= 2.0
y == 3.0
z in Interval(4.0, 5.0)
c5: 1.1x + 0.0 <= 5.1
c6: 1.3x + -1.4 >= -0.1
c7: 1.5a + 1.6 == 0.2
c8: 1.7a + 1.8 in Interval(0.3, 0.4)
x in ZeroOne()
y in Integer()
c11: [x, y, z] in SOS1{Float64}([1.0, 2.0, 3.0])
c12: [x, y, z] in SOS2{Float64}([3.3, 1.1, 2.2])
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: x\n" *
          "subject to\n" *
          "c5: 1.1 x <= 5.1\n" *
          "c6: -1.4 + 1.3 x >= -0.1\n" *
          "c7: 1.6 + 1.5 a = 0.2\n" *
          "c8: 0.3 <= 1.8 + 1.7 a <= 0.4\n" *
          "Bounds\n" *
          "a free\n" *
          "-1 <= x <= 2\n" *
          "y = 3\n" *
          "4 <= z <= 5\n" *
          "General\n" *
          "y\n" *
          "Binary\n" *
          "x\n" *
          "SOS\n" *
          "c11: S1:: x:1.0 y:2.0 z:3.0\n" *
          "c12: S2:: x:3.3 y:1.1 z:2.2\n" *
          "End\n"

    @test !MOI.is_empty(model)
    MOI.empty!(model)
    @test MOI.is_empty(model)
end

function test_name_sanitization_start()
    for starting_letter in [".", "0", "E", "e"]
        model = LP.Model()
        MOI.Utilities.loadfromstring!(
            model,
            """
variables: x
minobjective: x
c1: 1.0 * x >= -1.0
""",
        )
        x = MOI.get(model, MOI.VariableIndex, "x")
        MOI.set(model, MOI.VariableName(), x, starting_letter * "x")
        c = MOI.get(model, MOI.ConstraintIndex, "c1")
        MOI.set(model, MOI.ConstraintName(), c, starting_letter * "c1")
        MOI.write_to_file(model, LP_TEST_FILE)
        @test read(LP_TEST_FILE, String) ==
              "minimize\n" *
              "obj: _$(starting_letter)x\n" *
              "subject to\n" *
              "_$(starting_letter)c1: 1 _$(starting_letter)x >= -1\n" *
              "Bounds\n" *
              "_$(starting_letter)x free\n" *
              "End\n"
    end
end

function test_name_sanitization_illegal()
    for illegal_letter in ["[", "]", "*", "^"]
        model = LP.Model()
        MOI.Utilities.loadfromstring!(
            model,
            """
variables: x
minobjective: x
c1: 1.0 * x >= -1.0
""",
        )
        x = MOI.get(model, MOI.VariableIndex, "x")
        MOI.set(model, MOI.VariableName(), x, "x$(illegal_letter)y")
        c = MOI.get(model, MOI.ConstraintIndex, "c1")
        MOI.set(model, MOI.ConstraintName(), c, "c$(illegal_letter)d")
        MOI.write_to_file(model, LP_TEST_FILE)
        @test read(LP_TEST_FILE, String) ==
              "minimize\n" *
              "obj: x_y\n" *
              "subject to\n" *
              "c_d: 1 x_y >= -1\n" *
              "Bounds\n" *
              "x_y free\n" *
              "End\n"
    end
end

function test_name_sanitization_duplicate()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: a, b, c, d
minobjective: a + b + c + d
c1: a + b + c + d >= -1.0
""",
    )
    variables = MOI.get(model, MOI.ListOfVariableIndices())
    MOI.set.(model, MOI.VariableName(), variables, ["a[", "a]", "a*", "a^"])
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: 1 a_ + 1 a__1 + 1 a__2 + 1 a__3\n" *
          "subject to\n" *
          "c1: 1 a_ + 1 a__1 + 1 a__2 + 1 a__3 >= -1\n" *
          "Bounds\n" *
          "a_ free\n" *
          "a__1 free\n" *
          "a__2 free\n" *
          "a__3 free\n" *
          "End\n"
end

function test_name_sanitization_length()
    model = LP.Model(maximum_length = 3)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "abcdefg")
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: abc\n" *
          "subject to\n" *
          "Bounds\n" *
          "abc free\n" *
          "End\n"
end

function test_name_sanitization_too_long()
    model = LP.Model(maximum_length = 3)
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: abcd, abce
minobjective: abcd + abce
c1: abcd + abce >= -1.0
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: 1 abc + 1 abc_1\n" *
          "subject to\n" *
          "c1: 1 abc + 1 abc_1 >= -1\n" *
          "Bounds\n" *
          "abc free\n" *
          "abc_1 free\n" *
          "End\n"
end

function test_name_sanitization_other()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x
maxobjective: 2.0 * x + -1.0
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "maximize\n" *
          "obj: -1 + 2 x\n" *
          "subject to\n" *
          "Bounds\n" *
          "x free\n" *
          "End\n"
end

function test_free_variables()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x, y, z
maxobjective: x
x in ZeroOne()
y in Integer()
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "maximize\n" *
          "obj: x\n" *
          "subject to\n" *
          "Bounds\n" *
          "y free\n" *
          "z free\n" *
          "General\n" *
          "y\n" *
          "Binary\n" *
          "x\n" *
          "End\n"
end

function test_free_variables_reading()
    for case in ["free", "Free", "FreE", "frEe"]
        io = IOBuffer("Minimize\nobj: x\nsubject to\nBounds\nx $case\nEnd")
        model = MOI.FileFormats.LP.Model()
        read!(io, model)
        out = IOBuffer()
        write(out, model)
        seekstart(out)
        file = read(out, String)
        @test occursin("Bounds\nx free\nEnd", file)
    end
    return
end

function test_integer_variables_reading()
    for case in ["general", "GeneRalS", "Integer", "InTegeRs"]
        io = IOBuffer("Minimize\nobj: x\nsubject to\n$case\nx\nEnd")
        model = MOI.FileFormats.LP.Model()
        read!(io, model)
        out = IOBuffer()
        write(out, model)
        seekstart(out)
        file = read(out, String)
        @test occursin("General\nx\nEnd", file)
    end
    return
end

function test_quadratic_objective_diag()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x
minobjective: 1.0*x*x
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: [ 2 x ^ 2 ]/2\n" *
          "subject to\n" *
          "Bounds\n" *
          "x free\n" *
          "End\n"
    return
end

function test_quadratic_objective_off_diag()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x, y
minobjective: 1.1 * x + 1.2 * y + 1.5*x*y + 1.3
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: 1.3 + 1.1 x + 1.2 y + [ 3 x * y ]/2\n" *
          "subject to\n" *
          "Bounds\n" *
          "x free\n" *
          "y free\n" *
          "End\n"
    return
end

function test_quadratic_objective_complicated()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x, y
minobjective: 1.1 * x + 1.2 * y + -1.1 * x * x + 1.5*x*y + 1.3
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: 1.3 + 1.1 x + 1.2 y + [ -2.2 x ^ 2 + 3 x * y ]/2\n" *
          "subject to\n" *
          "Bounds\n" *
          "x free\n" *
          "y free\n" *
          "End\n"
    return
end

function test_quadratic_constraint_diag()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x
c: 1.0*x*x <= 1.4
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: \n" *
          "subject to\n" *
          "c: [ 1 x ^ 2 ] <= 1.4\n" *
          "Bounds\n" *
          "x free\n" *
          "End\n"
    return
end

function test_quadratic_constraint_off_diag()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x, y
c: 1.1 * x + 1.2 * y + 1.5*x*y + 1.3 == 1.5
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: \n" *
          "subject to\n" *
          "c: 1.3 + 1.1 x + 1.2 y + [ 1.5 x * y ] = 1.5\n" *
          "Bounds\n" *
          "x free\n" *
          "y free\n" *
          "End\n"
    return
end

function test_quadratic_constraint_complicated()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x, y
c: 1.1 * x + 1.2 * y + -1.1 * x * x + 1.5*x*y + 1.3 in Interval(-1.1, 1.4)
""",
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: \n" *
          "subject to\n" *
          "c: -1.1 <= 1.3 + 1.1 x + 1.2 y + [ -1.1 x ^ 2 + 1.5 x * y ] <= 1.4\n" *
          "Bounds\n" *
          "x free\n" *
          "y free\n" *
          "End\n"
    return
end

function test_write_indicator()
    model = LP.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: x, z
        c1: [z, x] in Indicator{ACTIVATE_ON_ONE}(LessThan(0.0))
        c2: [z, x] in Indicator{ACTIVATE_ON_ZERO}(GreaterThan(2.0))
        c3: [z, x] in Indicator{ACTIVATE_ON_ONE}(EqualTo(1.2))

        c4: [z, 2.0 * x] in Indicator{ACTIVATE_ON_ONE}(LessThan(0.0))
        c5: [z, 3.0 * x] in Indicator{ACTIVATE_ON_ZERO}(GreaterThan(2.0))
        c6: [1.0 * z, x] in Indicator{ACTIVATE_ON_ONE}(EqualTo(1.2))
        z in ZeroOne()
        """,
    )
    MOI.write_to_file(model, LP_TEST_FILE)
    @test read(LP_TEST_FILE, String) ==
          "minimize\n" *
          "obj: \n" *
          "subject to\n" *
          "c4:  z = 1 -> 2 x <= 0\n" *
          "c1: z = 1 -> x <= 0\n" *
          "c5:  z = 0 -> 3 x >= 2\n" *
          "c2: z = 0 -> x >= 2\n" *
          "c6:  z = 1 -> 1 x = 1.2\n" *
          "c3: z = 1 -> x = 1.2\n" *
          "Bounds\n" *
          "x free\n" *
          "Binary\n" *
          "z\n" *
          "End\n"
    return
end

###
### Read tests
###

macro test_parse_error(result, expr)
    return quote
        ret = try
            $(esc(expr))
        catch err
            sprint(showerror, err)
        end
        @test ret == $(esc(result))
    end
end

function test_read_invalid()
    dir = joinpath(@__DIR__, "models")
    @test_parse_error(
        """
        Error parsing LP file on line 7:
        C: 1 x <= 2
        ^
        Got an identifier with value `C`. No file contents are allowed after `end`.""",
        MOI.read_from_file(LP.Model(), joinpath(dir, "invalid_after_end.lp")),
    )
    @test_parse_error(
        """
        Error parsing LP file on line 6:
         x1 != 10
            ^
        Got an identifier with value `!`. We expected this to be an inequality like `>=`, `<=`, or `==`.""",
        MOI.read_from_file(LP.Model(), joinpath(dir, "invalid_bound_2.lp")),
    )
    @test_parse_error(
        """
        Error parsing LP file on line 6:
        c2:  2 x1 + x2 + c2: + 3 x3 + x4 >= 15
                           ^
        Got the symbol `:`. We expected this to be an inequality like `>=`, `<=`, or `==`.""",
        MOI.read_from_file(LP.Model(), joinpath(dir, "invalid_constraint.lp")),
    )
    @test_parse_error(
        """
        Error parsing LP file on line 10:
         csos2: S2::
                    ^
        Got a new line. SOS constraints cannot be spread across lines.""",
        MOI.read_from_file(
            LP.Model(),
            joinpath(dir, "invalid_sos_constraint.lp"),
        ),
    )
    @test_parse_error(
        """
        Error parsing LP file on line 10:
         csos2: S3:: V2:2 V4:1 V5:2.5
                ^
        Got an identifier with value `S3`. This must be either `S1` for SOS-I or `S2` for SOS-II.""",
        MOI.read_from_file(LP.Model(), joinpath(dir, "invalid_sos_set.lp")),
    )
    @test_parse_error(
        """
        Error parsing LP file on line 3:
        obj: 3 1x1 + x2 + 5 x3 + x4
               ^
        Got a number with value `1`. We expected this token to be a keyword defining a new section.""",
        MOI.read_from_file(
            LP.Model(),
            joinpath(dir, "invalid_variable_name.lp"),
        ),
    )
    return
end

function test_read_unexpected_line()
    io = IOBuffer("MinimizeSubject to x + y = 0")
    model = LP.Model()
    @test_parse_error(
        """
        Error parsing LP file on line 1:
        MinimizeSubject to x + y = 0
        ^
        Got an identifier with value `MinimizeSubject`. We expected this token to be a keyword defining a new section.""",
        read!(io, model),
    )
    return
end

function test_read_example_lo1()
    model = LP.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "models", "example_lo1.lp"))
    @test MOI.get(model, MOI.NumberOfVariables()) == 4
    constraints = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) in
          constraints
    @test (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) in
          constraints
    @test (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) in
          constraints
    @test (MOI.VariableIndex, MOI.GreaterThan{Float64}) in constraints
    @test (MOI.VariableIndex, MOI.LessThan{Float64}) in constraints
    @test !((MOI.VariableIndex, MOI.Interval{Float64}) in constraints)
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    file = read(io, String)
    @test occursin("maximize", file)
    @test occursin("obj: 3 x1 + 1 x2 + 5 x3 + 1 x4", file)
    @test occursin("c1: 3 x1 + 1 x2 + 2 x3 = 30", file)
    @test occursin("c2: 2 x1 + 1 x2 + 3 x3 + 1 x4 >= 15", file)
    @test occursin("c3: 2 x2 + 3 x4 <= 25", file)
    @test occursin("x1 >= 0", file)
    @test occursin("0 <= x2 <= 10", file)
    @test occursin("x3 >= 0", file)
    @test occursin("x4 >= 0", file)
    return
end

function test_read_model1_tricky()
    model = LP.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "models", "model1_tricky.lp"))
    @test MOI.get(model, MOI.NumberOfVariables()) == 8
    var_names = MOI.get.(model, MOI.VariableName(), MOI.VariableIndex.(1:8))
    @test Set(var_names) ==
          Set(["Var4", "V5", "V1", "V2", "V3", "V6", "V7", "V8"])
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    file = read(io, String)
    @test occursin("maximize", file)
    @test occursin("obj: -1 Var4 + 1 V5 + [ 1 Var4 ^ 2 - 1.2 V5 * V1 ]/2", file)
    @test occursin("CON3: 1 V3 <= 2.5", file)
    @test occursin("CON4: 1 V5 + 1 V6 + 1 V7 <= 1", file)
    @test occursin("CON1: 1 V1 >= 0", file)
    @test occursin("CON5: [ 1 Var4 ^ 2 - 1.2 V5 * V1 ] <= 0", file)
    @test occursin("1 V2 >= 2", file)
    @test occursin("-infinity <= V1 <= 3", file)
    @test occursin("Var4 >= 5.5", file)
    @test occursin("V3 >= -3", file)
    @test occursin("V5 = 1", file)
    @test occursin("0 <= V2 <= 3", file)
    @test occursin("V6 free", file)
    @test occursin("0 <= V7 <= 1", file)
    @test occursin("0 <= V8 <= 1", file)
    @test occursin("\nVar4\n", file)
    @test occursin("\nV5\n", file)
    @test occursin("\nV6\n", file)
    @test occursin("Binary\nV8\n", file)
    @test occursin("sos1: S1:: V1:1.0 V2:2.0 V3:3.0", file)
    @test occursin("sos2: S2:: V1:8.5 V2:10.2 V3:18.3", file)
    return
end

function test_read_model1()
    model = LP.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "models", "model1.lp"))
    constraints = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) in
          constraints
    @test (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) in
          constraints
    @test (MOI.VariableIndex, MOI.GreaterThan{Float64}) in constraints
    @test (MOI.VariableIndex, MOI.LessThan{Float64}) in constraints
    @test !((MOI.VariableIndex, MOI.Interval{Float64}) in constraints)
    @test (MOI.VariableIndex, MOI.Integer) in constraints
    @test (MOI.VariableIndex, MOI.ZeroOne) in constraints
    @test (MOI.VectorOfVariables, MOI.SOS1{Float64}) in constraints
    @test (MOI.VectorOfVariables, MOI.SOS2{Float64}) in constraints
    return
end

function test_read_model2()
    model = LP.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "models", "model2.lp"))
    @test MOI.get(model, MOI.NumberOfVariables()) == 8
    constraints = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) in
          constraints
    @test (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) in
          constraints
    @test (MOI.VariableIndex, MOI.GreaterThan{Float64}) in constraints
    @test (MOI.VariableIndex, MOI.LessThan{Float64}) in constraints
    @test !((MOI.VariableIndex, MOI.Interval{Float64}) in constraints)
    @test (MOI.VariableIndex, MOI.Integer) in constraints
    @test (MOI.VariableIndex, MOI.ZeroOne) in constraints
    @test MOI.get(model, MOI.VariableName(), MOI.VariableIndex(2)) == "V5"
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}}(2)
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.LessThan(1.0)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}}(2)
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.GreaterThan(0.0)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Float64}}(2)
    @test !MOI.is_valid(model, ci)
    @test MOI.get(model, MOI.VariableName(), MOI.VariableIndex(8)) == "V8"
    @test model.variables.lower[8] == -Inf
    @test model.variables.upper[8] == -3
    obj_type = MOI.get(model, MOI.ObjectiveFunctionType())
    obj_func = MOI.get(model, MOI.ObjectiveFunction{obj_type}())
    @test obj_func.constant == 2.5
    return
end

function test_read_objective_sense()
    cases = Dict(
        "max" => MOI.MAX_SENSE,
        "maximize" => MOI.MAX_SENSE,
        "maximise" => MOI.MAX_SENSE,
        "maximum" => MOI.MAX_SENSE,
        "min" => MOI.MIN_SENSE,
        "minimize" => MOI.MIN_SENSE,
        "minimise" => MOI.MIN_SENSE,
        "minimum" => MOI.MIN_SENSE,
    )
    for (sense, result) in cases
        model = LP.Model()
        io = IOBuffer("$sense\nx")
        read!(io, model)
        @test MOI.get(model, MOI.ObjectiveSense()) == result
    end
    return
end

function test_read_nonempty_model()
    filename = joinpath(@__DIR__, "models", "model2.lp")
    model = LP.Model()
    MOI.read_from_file(model, filename)
    @test_throws(
        ErrorException("Cannot read in file because model is not empty."),
        MOI.read_from_file(model, filename),
    )
    return
end

function test_read_maximum_length_error()
    filename = joinpath(@__DIR__, "models", "model2.lp")
    model = LP.Model(; maximum_length = 1)
    contents = try
        MOI.read_from_file(model, filename)
    catch err
        sprint(showerror, err)
    end
    @test contents == """
    Error parsing LP file on line 2:
    obj: - 2 - 1 V4 + 1 V5 + 3 + 2 - 0.5
                 ^
    Got an identifier with value `V4`. Name (V4) exceeds maximum length (1)"""
    return
end

function test_default_bound()
    io = IOBuffer("minimize\nobj: x + y")
    model = LP.Model()
    MOI.read!(io, model)
    x = MOI.get(model, MOI.ListOfVariableIndices())
    F, S = MOI.VariableIndex, MOI.GreaterThan{Float64}
    c = [MOI.ConstraintIndex{F,S}(xi.value) for xi in x]
    sets = MOI.get.(model, MOI.ConstraintSet(), c)
    @test all(s -> s == MOI.GreaterThan(0.0), sets)
    @test length(sets) == 2
    return
end

function test_default_bound_double_bound()
    io = IOBuffer("minimize\nobj: x\nsubject to\nbounds\n x <= -1\n x >= -2")
    model = LP.Model()
    MOI.read!(io, model)
    x = first(MOI.get(model, MOI.ListOfVariableIndices()))
    F = MOI.VariableIndex
    @test MOI.get(
        model,
        MOI.ConstraintSet(),
        MOI.ConstraintIndex{F,MOI.GreaterThan{Float64}}(x.value),
    ) == MOI.GreaterThan(-2.0)
    @test MOI.get(
        model,
        MOI.ConstraintSet(),
        MOI.ConstraintIndex{F,MOI.LessThan{Float64}}(x.value),
    ) == MOI.LessThan(-1.0)
    return
end

function test_infinite_interval()
    model = LP.Model()
    x = MOI.add_variable(model)
    MOI.add_constraint(model, 1.0 * x, MOI.Interval(-Inf, Inf))
    MOI.add_constraint(model, 1.0 * x, MOI.Interval(-Inf, 1.0))
    MOI.add_constraint(model, 1.0 * x, MOI.Interval(2.0, Inf))
    MOI.add_constraint(model, 1.0 * x, MOI.Interval(3.0, 4.0))
    @test sprint(write, model) ==
          "minimize\n" *
          "obj: \n" *
          "subject to\n" *
          "c1: -inf <= 1 x1 <= inf\n" *
          "c2: -inf <= 1 x1 <= 1\n" *
          "c3: 2 <= 1 x1 <= inf\n" *
          "c4: 3 <= 1 x1 <= 4\n" *
          "Bounds\n" *
          "x1 free\n" *
          "End\n"

    return
end

function test_read_tricky_quadratic()
    model = LP.Model()
    filename = joinpath(@__DIR__, "models", "tricky_quadratic.lp")
    MOI.read_from_file(model, filename)
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    file = read(io, String)
    @test occursin("minimize", file)
    @test occursin("obj: [ 2 x ^ 2 + 2 x * y ]/2", file)
    @test occursin("c1: [ 1 x ^ 2 - 1 x * y ] <= 0", file)
    @test occursin("c2: [ 0.5 x ^ 2 - 0.5 x * y ] <= 0", file)
    @test occursin("c3: [ 0.5 x ^ 2 - 0.5 x * y ] <= 0", file)
    @test occursin("x free", file)
    @test occursin("y free", file)
    return
end

function test_quadratic_newline_edge_cases()
    for case in [
        "+\n[ x^2 ]/2",
        "+ [\n x^2 ]/2",
        "+ [ x^2\n]/2",
        "+ [ x^2 ]\n/2",
        "+ [ x^2\n]\n/2",
        "+ \n[ x^2\n]\n/2",
        "+\n[ x^2 ]/2 \\ comment\n",
        "+ [ \\comment\n x^2 ]/2",
        "+ [ x^2\n]/2 \\ comment\n",
        "+ [ x^2 ]\n/2 \\ comment\n",
        "+ [ x^2\n]\n/2 \\ comment\n",
        "+ \n[ x^2\n]\n/2 \\ comment\n",
    ]
        io = IOBuffer("Minimize\nobj: x $(case)\nEnd")
        model = MOI.FileFormats.LP.Model()
        read!(io, model)
        out = IOBuffer()
        write(out, model)
        seekstart(out)
        file = read(out, String)
        @test occursin("obj: 1 x + [ 1 x ^ 2 ]/2", file)
    end
    for case in [
        "+\n[ x^2 ]",
        "+ [\n x^2 ]",
        "+ [ x^2\n]",
        "+ [ x^2 ]",
        "+ [ x^2\n]",
        "+ \n[ x^2\n]",
        "+\n[ x^2 ] \\ comment",
        "+ [ \\comment\n x^2 ]",
        "+ [ x^2\n] \\ comment",
        "+ [ x^2 ] \\ comment",
        "+ [ x^2\n] \\ comment",
        "+ \n[ x^2\n] \\ comment",
    ]
        io = IOBuffer("Minimize\nobj: x $(case)\nEnd")
        model = MOI.FileFormats.LP.Model()
        read!(io, model)
        out = IOBuffer()
        write(out, model)
        seekstart(out)
        file = read(out, String)
        @test occursin("obj: 1 x + [ 2 x ^ 2 ]/2", file)
    end
    return
end

function test_newline_inequality()
    for case in [
        "x + y <= 2",
        "x + y <=\n2",
        "x + y\n<= 2",
        "x +\n y <= 2",
        "x\n+ y <= 2",
    ]
        io = IOBuffer("Minimize\nobj: x\nSubject to\nc1: $(case)\nEnd")
        model = MOI.FileFormats.LP.Model()
        read!(io, model)
        out = IOBuffer()
        write(out, model)
        seekstart(out)
        file = read(out, String)
        @test occursin("c1: 1 x + 1 y <= 2", file)
    end
    return
end

function test_wrong_way_bounds()
    for (case, result) in [
        "x >= 2" => "x >= 2",
        "x <= 2" => "0 <= x <= 2",
        "x == 2" => "x = 2",
        "x > 2" => "x >= 2",
        "x < 2" => "0 <= x <= 2",
        "x = 2" => "x = 2",
        "2 >= x" => "0 <= x <= 2",
        "2 <= x" => "x >= 2",
        "2 == x" => "x = 2",
        "2 > x" => "0 <= x <= 2",
        "2 < x" => "x >= 2",
        "2 = x" => "x = 2",
    ]
        io = IOBuffer("Minimize\nobj: x\nSubject to\nBounds\n$(case)\nEnd")
        model = MOI.FileFormats.LP.Model()
        read!(io, model)
        out = IOBuffer()
        write(out, model)
        seekstart(out)
        file = read(out, String)
        @test occursin("Bounds\n$result", file)
    end
    return
end

function test_variable_coefficient_variable()
    io = IOBuffer("Minimize\nobj: x -1 y\nEnd")
    model = MOI.FileFormats.LP.Model()
    read!(io, model)
    out = IOBuffer()
    write(out, model)
    seekstart(out)
    file = read(out, String)
    @test file ==
          "minimize\nobj: 1 x - 1 y\nsubject to\nBounds\nx >= 0\ny >= 0\nEnd\n"
    return
end

function _test_round_trip(bound, needle)
    model = MOI.FileFormats.LP.Model()
    io = IOBuffer()
    write(io, "Minimize\nobj: x\nBounds\n$bound\nEnd")
    seekstart(io)
    read!(io, model)
    seekstart(io)
    write(io, model)
    seekstart(io)
    file = read(io, String)
    @test occursin(needle, file)
    return
end

function test_reading_bounds()
    # Test lower bound
    _test_round_trip("x >= 1", "Bounds\nx >= 1\nEnd")
    _test_round_trip("x >= 0", "Bounds\nx >= 0\nEnd")
    _test_round_trip("x >= -1", "Bounds\nx >= -1\nEnd")
    _test_round_trip("x > 1", "Bounds\nx >= 1\nEnd")
    _test_round_trip("x > 0", "Bounds\nx >= 0\nEnd")
    _test_round_trip("x > -1", "Bounds\nx >= -1\nEnd")
    # Test reversed lower bound
    _test_round_trip("1 <= x", "Bounds\nx >= 1\nEnd")
    _test_round_trip("0 <= x", "Bounds\nx >= 0\nEnd")
    _test_round_trip("-1 <= x", "Bounds\nx >= -1\nEnd")
    _test_round_trip("1 < x", "Bounds\nx >= 1\nEnd")
    _test_round_trip("0 < x", "Bounds\nx >= 0\nEnd")
    _test_round_trip("-1 < x", "Bounds\nx >= -1\nEnd")
    # Test upper bound
    _test_round_trip("x <= 1", "Bounds\n0 <= x <= 1\nEnd")
    _test_round_trip("x <= 0", "Bounds\nx = 0\nEnd")
    _test_round_trip("x <= -1", "Bounds\n-infinity <= x <= -1\nEnd")
    _test_round_trip("x < 1", "Bounds\n0 <= x <= 1\nEnd")
    _test_round_trip("x < 0", "Bounds\nx = 0\nEnd")
    _test_round_trip("x < -1", "Bounds\n-infinity <= x <= -1\nEnd")
    # Test reversed upper bound
    _test_round_trip("1 >= x", "Bounds\n0 <= x <= 1\nEnd")
    _test_round_trip("0 >= x", "Bounds\nx = 0\nEnd")
    _test_round_trip("-1 >= x", "Bounds\n-infinity <= x <= -1\nEnd")
    _test_round_trip("1 > x", "Bounds\n0 <= x <= 1\nEnd")
    _test_round_trip("0 > x", "Bounds\nx = 0\nEnd")
    _test_round_trip("-1 > x", "Bounds\n-infinity <= x <= -1\nEnd")
    # Test equality
    _test_round_trip("x == 1", "Bounds\nx = 1\nEnd")
    _test_round_trip("x == 0", "Bounds\nx = 0\nEnd")
    _test_round_trip("x == -1", "Bounds\nx = -1\nEnd")
    _test_round_trip("1 = x", "Bounds\nx = 1\nEnd")
    _test_round_trip("0 = x", "Bounds\nx = 0\nEnd")
    _test_round_trip("-1 = x", "Bounds\nx = -1\nEnd")
    # Test interval
    _test_round_trip("0 <= x <= 1", "Bounds\n0 <= x <= 1\nEnd")
    _test_round_trip("-1 <= x <= 1", "Bounds\n-1 <= x <= 1\nEnd")
    _test_round_trip("-2 <= x <= -1", "Bounds\n-2 <= x <= -1\nEnd")
    # Test reversed interval
    _test_round_trip("1 >= x >= 0", "Bounds\n0 <= x <= 1\nEnd")
    _test_round_trip("1 >= x >= -1", "Bounds\n-1 <= x <= 1\nEnd")
    _test_round_trip("-1 >= x >= -2", "Bounds\n-2 <= x <= -1\nEnd")
    # Test double-sided equality
    _test_round_trip("1 <= x <= 1", "Bounds\nx = 1\nEnd")
    _test_round_trip("0 <= x <= 0", "Bounds\nx = 0\nEnd")
    _test_round_trip("-2 <= x <= -2", "Bounds\nx = -2\nEnd")
    # Test upper then lower
    _test_round_trip("x <= 1\nx >= 0", "Bounds\n0 <= x <= 1\nEnd")
    _test_round_trip("x <= 2\nx >= 1", "Bounds\n1 <= x <= 2\nEnd")
    _test_round_trip("x <= 2\nx >= -1", "Bounds\n-1 <= x <= 2\nEnd")
    # Test lower then upper
    _test_round_trip("x >= 0\nx <= 1", "Bounds\n0 <= x <= 1\nEnd")
    _test_round_trip("x >= 1\nx <= 2", "Bounds\n1 <= x <= 2\nEnd")
    _test_round_trip("x >= -1\nx <= 2", "Bounds\n-1 <= x <= 2\nEnd")
    return
end

function _test_read_quadratic(input::String, output::String = input)
    io = IOBuffer()
    input_text = """
    minimize
    obj: $input
    subject to
    Bounds
    x >= 0
    y >= 0
    End
    """
    write(io, input_text)
    model = MOI.FileFormats.LP.Model()
    seekstart(io)
    read!(io, model)
    out = IOBuffer()
    write(out, model)
    seekstart(out)
    output_text = """
    minimize
    obj: $output
    subject to
    Bounds
    x >= 0
    y >= 0
    End
    """
    @test read(out, String) == output_text
    return
end

function test_read_quadratic()
    _test_read_quadratic("1 x + 1 y + [ 1 x * y + 1 y ^ 2 ]/2")
    _test_read_quadratic("1 x + 1 y + [ 2 x * y + 1 y ^ 2 ]/2")
    _test_read_quadratic("1 x + 1 y + [ 1 x * y + 2 y ^ 2 ]/2")
    _test_read_quadratic("1 x + 1 y + [ 2 x * y + 2 y ^ 2 ]/2")
    _test_read_quadratic(
        "1 x + 1 y + [ 1 x * y + 1 y ^ 2 ]",
        "1 x + 1 y + [ 2 x * y + 2 y ^ 2 ]/2",
    )
    _test_read_quadratic(
        "1 x + 1 y + [ 2 x * y + 1 y ^ 2 ]",
        "1 x + 1 y + [ 4 x * y + 2 y ^ 2 ]/2",
    )
    _test_read_quadratic(
        "1 x + 1 y + [ 1 x * y + 2 y ^ 2 ]",
        "1 x + 1 y + [ 2 x * y + 4 y ^ 2 ]/2",
    )
    _test_read_quadratic(
        "1 x + 1 y + [ 2 x * y + 2 y ^ 2 ]",
        "1 x + 1 y + [ 4 x * y + 4 y ^ 2 ]/2",
    )
    _test_read_quadratic(
        "[ 1.0 x^2 \n+ 1.0 x * y\n+ 1.0 y * y ]/2",
        "[ 1 x ^ 2 + 1 x * y + 1 y ^ 2 ]/2",
    )
    _test_read_quadratic(
        "[ 1.0 x^2 \n- 1.0 x * y\n+ 1.0 y * y ]/2",
        "[ 1 x ^ 2 - 1 x * y + 1 y ^ 2 ]/2",
    )
    _test_read_quadratic(
        "[ 1.0 x^2 -\n 1.0 x * y +\n1.0 y * y ]/2",
        "[ 1 x ^ 2 - 1 x * y + 1 y ^ 2 ]/2",
    )
    _test_read_quadratic(
        "[ 1.0 x^2 + 1.0 x * y\n+ 1.0 y * y ]/2",
        "[ 1 x ^ 2 + 1 x * y + 1 y ^ 2 ]/2",
    )
    return
end

function test_read_newline_breaks()
    io = IOBuffer()
    input_text = """
    minimize
    obj: 1 x + 2 y
        + 3 z
    subject to
    c: x -
    y
    + z ==
    0
    Bounds
    x >= 0 -1 <= y
    +1 <= z <= +2
    End
    """
    write(io, input_text)
    model = MOI.FileFormats.LP.Model()
    seekstart(io)
    read!(io, model)
    out = IOBuffer()
    write(out, model)
    seekstart(out)
    output_text = """
    minimize
    obj: 1 x + 2 y + 3 z
    subject to
    c: 1 x - 1 y + 1 z = 0
    Bounds
    x >= 0
    y >= -1
    1 <= z <= 2
    End
    """
    @test read(out, String) == output_text
    return
end

function test_read_variable_bounds()
    io = IOBuffer("""
    maximize
    obj: 1 x1
    subject to
    bounds
    -infinity <= x1 <= +infinity
    -infinity <= x2 <= 1
    -infinity <= x3 <= -1
    -1 <= x4 <= +infinity
    1 <= x5 <= +infinity
    -1 <= x6 <= 1
    1 <= x7 <= 1
    end
    """)
    model = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_LP)
    read!(io, model)
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    @test read(io, String) == """
    maximize
    obj: 1 x1
    subject to
    Bounds
    x1 free
    -infinity <= x2 <= 1
    -infinity <= x3 <= -1
    x4 >= -1
    x5 >= 1
    -1 <= x6 <= 1
    x7 = 1
    End
    """
    return
end

function test_read_indicator()
    io = IOBuffer("""
    minimize
    obj: 1 x
    subject to
    c: z = 1 -> x >= 0
    d: z = 0 -> x - y <= 1.2
    bounds
    x free
    z free
    binary
    z
    end
    """)
    model = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_LP)
    read!(io, model)
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    @test read(io, String) == """
    minimize
    obj: 1 x
    subject to
    d:  z = 0 -> 1 x - 1 y <= 1.2
    c:  z = 1 -> 1 x >= 0
    Bounds
    x free
    y >= 0
    Binary
    z
    End
    """
    return
end

function test_VectorAffineFunction_SOS()
    model = MOI.FileFormats.LP.Model()
    F = MOI.VectorAffineFunction{Float64}
    @test !MOI.supports_constraint(model, F, MOI.SOS1{Float64})
    @test !MOI.supports_constraint(model, F, MOI.SOS2{Float64})
    return
end

function test_invalid_token_in_sos()
    model = LP.Model()
    io = IOBuffer("""
                  minimize
                  obj: x + y
                  subject to
                  SOS
                  c11: S1:: x 1.0 y 2.0
                  """)
    contents = try
        read!(io, model)
    catch err
        sprint(showerror, err)
    end
    @test contents == """
    Error parsing LP file on line 5:
    c11: S1:: x 1.0 y 2.0
                ^
    Got a number with value `1.0`. We expected this token to be the symbol `:`."""
    return
end

function test_unable_to_parse_bound()
    io = IOBuffer("""
                  minimize
                  obj: 1 x
                  subject to
                  bounds
                  x
                  end
                  """)
    model = LP.Model()
    @test_parse_error(
        """
        Error parsing LP file on line 6:
        end
        ^
        Got a keyword defining a new section with value `END`. We expected this to be an inequality like `>=`, `<=`, or `==`.""",
        read!(io, model),
    )
    return
end

function test_unsupported_variable_types()
    model = LP.Model()
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Parameter(2.0)),
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Semicontinuous(2.0, 3.0)),
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Semiinteger(2.0, 3.0)),
    )
    return
end

function _test_int_round_trip(src)
    model = MOI.FileFormats.LP.Model(; coefficient_type = Int)
    io = IOBuffer()
    write(io, src)
    seekstart(io)
    read!(io, model)
    seekstart(io)
    write(io, model)
    seekstart(io)
    file = read(io, String)
    @test file == src
    return
end

function test_int_round_trip()
    for src in [
        """
        minimize
        obj: 1 + 2 x
        subject to
        c: 3 x >= 2
        Bounds
        x >= 0
        End
        """,
        """
        minimize
        obj: 1 x + [ 1 x ^ 2 ]/2
        subject to
        c: [ 1 x ^ 2 ] <= 1
        Bounds
        x >= 0
        End
        """,
        """
        minimize
        obj: [ 2 x ^ 2 ]/2
        subject to
        c: [ 2 x ^ 2 ] <= 1
        Bounds
        x >= 0
        End
        """,
        """
        minimize
        obj: [ 3 x ^ 2 + 4 x * y + 5 y ^ 2 ]/2
        subject to
        c: [ 3 x ^ 2 + 4 x * y + 5 y ^ 2 ] <= 1
        Bounds
        x >= 0
        y >= 1
        End
        """,
    ]
        _test_int_round_trip(src)
    end
    return
end

function test_unsupported_objectives()
    model = LP.Model()
    for (F, ret) in [
        MOI.VariableIndex => true,
        MOI.ScalarAffineFunction{Float64} => true,
        MOI.ScalarQuadraticFunction{Float64} => true,
        MOI.ScalarNonlinearFunction => false,
        MOI.VectorOfVariables => false,
        MOI.VectorAffineFunction{Float64} => false,
        MOI.VectorQuadraticFunction{Float64} => false,
        MOI.VectorNonlinearFunction => false,
    ]
        @test MOI.supports(model, MOI.ObjectiveFunction{F}()) == ret
    end
    return
end

function test_subject_to_name()
    for (case, err) in [
        "subject to" => false,
        "Subject To" => false,
        "such that" => false,
        "Such That" => false,
        "st" => false,
        "s.t." => false,
        "st." => false,
        "subject that" => true,
        "subject\nto" => true,
        "s. t." => true,
        "such to" => true,
    ]
        io = IOBuffer("Minimize\nobj: x\n$case\n2x == 1\nBounds\nx free\nEnd")
        seekstart(io)
        model = MOI.FileFormats.LP.Model()
        if err
            @test_parse_error(
                """
                Error parsing LP file on line 3:
                $(first(split(case, "\n")))
                ^
                Got an identifier with value `$(first(split(case)))`. We expected this token to be a keyword defining a new section.""",
                read!(io, model),
            )
        else
            read!(io, model)
            out = IOBuffer()
            write(out, model)
            seekstart(out)
            file = read(out, String)
            @test occursin("subject to\nc1: 2 x = 1\n", file)
        end
    end
    return
end

function test_parse_identifier()
    cache = LP._ReadCache(LP.Model{Float64}())
    for input in [
        "x",
        "X",
        "e",
        "abc!\"D",
        "π",
        "𝔼1π!~a",
        "x!\"#\$%&()/,.;?@_`'{}|~",
        "aAc2",
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        x = LP._parse_identifier(state, cache)
        @test cache.variable_name_to_index[input] == x
    end
    for input in ["2", "2x"]
        state = LP._LexerState(IOBuffer(input))
        @test_parse_error(
            """
            Error parsing LP file on line 1:
            $(input)
            ^
            Got a number with value `2`. We expected this token to be an identifier.""",
            LP._parse_identifier(state, cache),
        )
    end
    state = LP._LexerState(IOBuffer(".x"))
    @test_parse_error(
        """
        Error parsing LP file on line 1:
        .x
        ^
        Got a token with value `.`. This character is not supported at the start of an identifier.""",
        LP._parse_identifier(state, cache),
    )
    state = LP._LexerState(IOBuffer("❤x"))
    @test_parse_error(
        """
        Error parsing LP file on line 1:
        ❤x
        ^
        Got a token with value `❤`. This character is not supported in an LP file.""",
        LP._parse_identifier(state, cache),
    )
    return
end

function test_parse_number()
    cache = LP._ReadCache(LP.Model{Float64}())
    for (input, result) in [
        "1" => 1.0,
        "02" => 2.0,
        "- 1" => -1.0,
        "- -1" => 1.0,
        "+ 1" => 1.0,
        "+ -1" => -1.0,
        "- + 1" => -1.0,
        "+ + 1" => 1.0,
        "+ - + 1" => -1.0,
        "+ - + -1" => 1.0,
        "inf" => Inf,
        "-inf" => -Inf,
        "- inf" => - Inf,
        "iNf" => Inf,
        "iNfinitY" => Inf,
        "infinity" => Inf,
        "1.23e+01" => 12.3,
        "1.23e-1" => 0.123,
        "1.23E-1" => 0.123,
        "1.23E+3" => 1230.0,
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        @test LP._parse_number(state, cache) == result
    end
    for (input, reason) in [
        "x" => "We expected this to be a number.",
        "abc" => "We expected this to be a number.",
        "ten" => "We expected this to be a number.",
        "1.1.1" => "We were unable to parse this as a number.",
        "1eE1" => "We were unable to parse this as a number.",
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        @test_parse_error(
            """
            Error parsing LP file on line 1:
            $input
            ^
            Got an identifier with value `$input`. $reason""",
            LP._parse_number(state, cache),
        )
    end
    return
end

function test_parse_quad_term()
    cache = LP._ReadCache(LP.Model{Float64}())
    # Diagonal
    for (input, coef) in [
        "x * x" => 2.0,
        "\nx * x" => 2.0,
        "x\n * x" => 2.0,
        "x * \n x" => 2.0,
        "x^2" => 2.0,
        "x ^ 2" => 2.0,
        "+ x * x" => 2.0,
        "+ 2 * x * x" => 4.0,
        "- x * x" => -2.0,
        "- 2 * x * x" => -4.0,
        "-2 x * x" => -4.0,
        "2.2 x * x" => 4.4,
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        term = LP._parse_quadratic_term(state, cache, 1.0)
        x = cache.variable_name_to_index["x"]
        @test term == MOI.ScalarQuadraticTerm(coef, x, x)
        seekstart(io)
        term = LP._parse_quadratic_term(state, cache, -1.0)
        @test term == MOI.ScalarQuadraticTerm(-coef, x, x)
    end
    # Off-diagonal
    for (input, coef) in [
        "x * y" => 1.0,
        "\nx * y" => 1.0,
        "x\n * y" => 1.0,
        "x * \n y" => 1.0,
        "+ x * y" => 1.0,
        "+ 2 * x * y" => 2.0,
        "- x * y" => -1.0,
        "- 2 * x * y" => -2.0,
        "2.2 * x * y" => 2.2,
        "2.2 x * y" => 2.2,
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        term = LP._parse_quadratic_term(state, cache, 1.0)
        x = cache.variable_name_to_index["x"]
        y = cache.variable_name_to_index["y"]
        @test term == MOI.ScalarQuadraticTerm(coef, x, y)
        seekstart(io)
        term = LP._parse_quadratic_term(state, cache, -1.0)
        @test term == MOI.ScalarQuadraticTerm(-coef, x, y)
    end
    for (input, reason) in [
        "x^" => " ^\nGot a token with value `EOF`. Unexpected end to the file. We weren't finished yet.",
        "x^x" => "  ^\nGot an identifier with value `x`. We expected this token to be a number.",
        "x^0" => "  ^\nGot a number with value `0`. Only `^ 2` is supported.",
        "x^1" => "  ^\nGot a number with value `1`. Only `^ 2` is supported.",
        "x^3" => "  ^\nGot a number with value `3`. Only `^ 2` is supported.",
        "x * 2  * x" => "    ^\nGot a number with value `2`. We expected this token to be an identifier.",
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        @test_parse_error(
            """
            Error parsing LP file on line 1:
            $input
            $reason""",
            LP._parse_quadratic_term(state, cache, -1.0),
        )
    end
    return
end

function test_parse_term()
    cache = LP._ReadCache(LP.Model{Float64}())
    for (input, coef) in [
        "x" => 1.0,
        "+ x" => 1.0,
        "- x" => -1.0,
        "- -x" => 1.0,
        "+ -x" => -1.0,
        "2x" => 2.0,
        "2.0 x" => 2.0,
        "3.0 x" => 3.0,
        "2.0 * x" => 2.0,
        "3.2 * x" => 3.2,
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        term = LP._parse_term(state, cache, 1.0)
        x = cache.variable_name_to_index["x"]
        @test term == MOI.ScalarAffineTerm(coef, x)
        seekstart(io)
        term = LP._parse_term(state, cache, -1.0)
        @test term == MOI.ScalarAffineTerm(-coef, x)
    end
    for (input, reason) in [">= 1" => "Got the symbol `>=`."]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        @test_parse_error(
            """
            Error parsing LP file on line 1:
            $input
            ^
            $reason We expected this to be a new term in the expression.""",
            LP._parse_term(state, cache, 1.0),
        )
    end
    return
end

function test_parse_quad_expression()
    cache = LP._ReadCache(LP.Model{Float64}())
    for (input, reason) in [
        "x^2" => "^\nGot an identifier with value `x`. We expected this token to be the symbol `[`.",
        "[ x^2 ]/" => "       ^\nGot a token with value `EOF`. Unexpected end to the file. We weren't finished yet.",
        "[ x^2 ]/3" => "        ^\nGot a number with value `3`. The only supported value here is `] / 2`.",
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        @test_parse_error(
            """
            Error parsing LP file on line 1:
            $input
            $reason""",
            LP._parse_quadratic_expression(state, cache, 1.0),
        )
    end
    return
end

function test_parse_set_prefix()
    cache = LP._ReadCache(LP.Model{Float64}())
    for (input, set) in [
        "1.0 <=" => MOI.GreaterThan(1.0),
        "1.0 <" => MOI.GreaterThan(1.0),
        "1.0 >=" => MOI.LessThan(1.0),
        "1.0 >" => MOI.LessThan(1.0),
        "1.0 ==" => MOI.EqualTo(1.0),
        "1.0 =" => MOI.EqualTo(1.0),
        # Theirs not to reason why, theirs but to do and
        "1.0 =<" => MOI.GreaterThan(1.0),
        "1.0 =>" => MOI.LessThan(1.0),
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        @test LP._parse_set_prefix(state, cache) == set
    end
    io = IOBuffer("1.0 ->")
    state = LP._LexerState(io)
    @test_parse_error(
        """
        Error parsing LP file on line 1:
        1.0 ->
            ^
        Got the symbol `->`. We expected this to be an inequality like `>=`, `<=`, or `==`.""",
        LP._parse_set_prefix(state, cache),
    )
    return
end

function test_parse_set_sufffix()
    cache = LP._ReadCache(LP.Model{Float64}())
    for (input, set) in [
        "free" => nothing,
        "Free" => nothing,
        ">= 1.0" => MOI.GreaterThan(1.0),
        "> 1.0" => MOI.GreaterThan(1.0),
        "<= 1.0" => MOI.LessThan(1.0),
        "< 1.0" => MOI.LessThan(1.0),
        "== 1.0" => MOI.EqualTo(1.0),
        "= 1.0" => MOI.EqualTo(1.0),
        # Theirs not to reason why, theirs but to do and
        "=< 1.0" => MOI.LessThan(1.0),
        "=> 1.0" => MOI.GreaterThan(1.0),
    ]
        io = IOBuffer(input)
        state = LP._LexerState(io)
        @test LP._parse_set_suffix(state, cache) == set
    end
    io = IOBuffer("-> 1")
    state = LP._LexerState(io)
    @test_parse_error(
        """
        Error parsing LP file on line 1:
        -> 1
        ^
        Got the symbol `->`. We expected this to be an inequality like `>=`, `<=`, or `==`.""",
        LP._parse_set_suffix(state, cache),
    )
    return
end

function test_new_line_edge_cases()
    target = "minimize\nobj: 1 x + 1 y\nsubject to\nc: 1 x <= 1\nBounds\nx >= 0\ny >= 0\nEnd\n"
    for input in [
        # Good
        "minimize\nobj: x + y\nsubject to\nc: x <= 1\nend",
        # Blank lines at the start
        "\n\nminimize\nobj: x + y\nsubject to\nc: x <= 1\nend",
        # Blank lines after minimize
        "minimize\n\n\nobj: x + y\nsubject to\nc: x <= 1\nend",
        # Blank lines between obj: and expression
        "minimize\nobj:\n\nx + y\nsubject to\nc: x <= 1\nend",
        # Blank lines throughout objective expression
        "minimize\nobj:\nx \n+ \ny\nsubject to\nc: x <= 1\nend",
        # Blank lines after objective expression
        "minimize\nobj: x + y\n\nsubject to\nc: x <= 1\nend",
        # Blank lines after subject to
        "minimize\nobj: x + y\nsubject to\n\n\nc: x <= 1\nend",
        # Blank lines in constraint
        "minimize\nobj: x + y\nsubject to\nc:\nx\n<=\n1\nend",
        # Blank lines around end
        "minimize\nobj: x + y\nsubject to\nc: x <= 1\n\nend\n\n\n",
        # Comment before newline
        "minimize\\comment\nobj: x + y\nsubject to\nc: x <= 1\nend",
        "minimize\nobj: x + y\\comment\nsubject to\nc: x <= 1\nend",
        "minimize\nobj: x + y\nsubject to\\comment\nc: x <= 1\nend",
        "minimize\nobj: x + y\nsubject to\nc: x <= 1\\comment\nend",
        "minimize\nobj: x + y\nsubject to\nc: x <= 1\nend\\comment",
    ]
        io = IOBuffer(input)
        model = LP.Model()
        MOI.read!(io, model)
        @test sprint(MOI.write, model) == target
    end
    return
end

function test_new_line_edge_cases_sos()
    target = "minimize\nobj: 1 x + 1 y\nsubject to\nBounds\nx >= 0\ny >= 0\nSOS\nc: S1:: x:1.0 y:2.0\nEnd\n"
    for input in [
        "minimize\nobj: x + y\nsubject to\nc: S1:: x:1 y:2\nend",
        "minimize\nobj: x + y\nsubject to\nc: S1:: x:1 y:2\n\nend",
        "minimize\nobj: x + y\nsubject to\n\nc: S1:: x:1 y:2\n\nend",
        "minimize\nobj: x + y\nsubject to\n\nc: S1:: x:1 y:2\\comment\nend",
    ]
        io = IOBuffer(input)
        model = LP.Model()
        MOI.read!(io, model)
        @test sprint(MOI.write, model) == target
    end
    return
end

function test_missing_new_line_edge_cases()
    for input in [
        # No newline between objective sense and objective
        "minimize x",
        "maximize x",
        "maximize c: x",
        # No new line between objective and subject to
        "maximize\nobj: x subject to",
        # No new line between subject to and constraint
        "maximize\nobj: x\nsubject to c: x >= 0",
    ]
        io = IOBuffer(input)
        model = LP.Model()
        MOI.read!(io, model)
        @test MOI.get(model, MOI.VariableIndex, "x") isa MOI.VariableIndex
    end
    return
end

function test_parse_keyword_edge_cases_identifier_is_keyword()
    for name in ["max", "min", "st", "such", "bounds", "obj", "free"]
        io = IOBuffer("""
        maximize
        obj: $name
        subject to
        $name <= 1
        bounds
        $name free
        end
        """)
        model = LP.Model()
        MOI.read!(io, model)
        x = only(MOI.get(model, MOI.ListOfVariableIndices()))
        @test MOI.get(model, MOI.VariableName(), x) == name
    end
    return
end

function test_parse_keyword_subject_to_errors()
    for line in ["subject", "subject too"]
        io = IOBuffer("""
        maximize
        obj: x
        $line
        x <= 1
        bounds
        x free
        end
        """)
        model = LP.Model()
        @test_parse_error(
            """
            Error parsing LP file on line 3:
            $line
            ^
            Got an identifier with value `subject`. We expected this token to be a keyword defining a new section.""",
            MOI.read!(io, model),
        )
    end
    return
end

function test_parse_newline_in_objective_expression()
    for obj in ["2 x", "\n2 x", "2\nx", "2*\nx", "2\n*x", "2\n\n*\n\n\nx\n"]
        io = IOBuffer("""
        maximize
        obj: $obj
        subject to
        bounds
        x free
        end
        """)
        model = LP.Model()
        MOI.read!(io, model)
        x = MOI.get(model, MOI.VariableIndex, "x")
        f = 2.0 * x
        g = MOI.get(model, MOI.ObjectiveFunction{typeof(f)}())
        @test isapprox(f, g)
    end
    return
end

function test_parse_subject_eof()
    io = IOBuffer("maximize\nobj:\nsubject")
    model = LP.Model()
    MOI.read!(io, model)
    x = MOI.get(model, MOI.VariableIndex, "subject")
    @test x isa MOI.VariableIndex
    return
end

function test_parse_expr_eof()
    io = IOBuffer("maximize\nobj: x + 2\n")
    model = LP.Model()
    MOI.read!(io, model)
    x = MOI.get(model, MOI.VariableIndex, "x")
    f = 1.0 * x + 2.0
    g = MOI.get(model, MOI.ObjectiveFunction{typeof(f)}())
    @test isapprox(f, g)
    return
end

function test_parse_quadratic_expr_eof()
    io = IOBuffer("maximize\nobj: [x * x]\n")
    model = LP.Model()
    MOI.read!(io, model)
    x = MOI.get(model, MOI.VariableIndex, "x")
    f = 1.0 * x * x
    g = MOI.get(model, MOI.ObjectiveFunction{typeof(f)}())
    @test isapprox(f, g)
    return
end

function test_ambiguous_case_1()
    # Xpress allows this. We currently do too.
    for kw in ("subject to", "such that", "st")
        io = IOBuffer("maximize obj: x $kw c: x <= 1\nend")
        model = LP.Model()
        MOI.read!(io, model)
        @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
        F, S = MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}
        @test isa(
            MOI.get(model, MOI.ConstraintIndex, "c"),
            MOI.ConstraintIndex{F,S},
        )
    end
    return
end

function test_ambiguous_case_2()
    # Xpress allows this. We currently parse this as two "<keyword-constraint>"
    # sections, and think that there is no objective function.
    io = IOBuffer("min\nst\nst\nst >= 0\nend")
    model = LP.Model()
    MOI.read!(io, model)
    st = MOI.get(model, MOI.VariableIndex, "st")
    @test_broken MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    f = 1.0 * st
    @test_broken isapprox(MOI.get(model, MOI.ObjectiveFunction{typeof(f)}()), f)
    return
end

function test_ambiguous_case_3()
    # Gurobi doesn't allow this, but Xpress does. We do.
    io = IOBuffer("min\nobj: end\nsubject to\nc: end <= 1\nend")
    model = LP.Model()
    MOI.read!(io, model)
    x = MOI.get(model, MOI.VariableIndex, "end")
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    f = 1.0 * x
    @test isapprox(MOI.get(model, MOI.ObjectiveFunction{typeof(f)}()), f)
    return
end

function test_get_line_about_pos()
    for (input, output) in [
        "x" => ("x", 1),
        "\nx" => ("x", 1),
        "x\n" => ("x", 1),
        "x + y\n" => ("x + y", 1),
        "\ny + x\n" => ("y + x", 5),
        "\n❤ + x\n" => ("❤ + x", 5),
        "♡♡♡♡♡♡♡♡♡♡ + x + ♡♡♡♡♡♡♡♡♡♡" => ("♡♡ + x + ♡♡♡", 6),
        "♡♡♡♡♡♡♡♡♡\n♡ + x + ♡\n♡♡♡♡♡♡♡♡♡" => ("♡ + x + ♡", 5),
    ]
        io = IOBuffer(input)
        readuntil(io, 'x')
        pos = position(io)
        @test output == LP._get_line_about_pos(IOBuffer(input), pos, 10)
    end
    return
end

end  # module

TestLP.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableZeros

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.ZerosBridge,
        model -> begin
            x, _ = MOI.add_constrained_variables(model, MOI.Zeros(2))
            MOI.add_constraint(
                model,
                1.0 * x[1] + 2.0 * x[2],
                MOI.EqualTo(3.0),
            )
        end,
        model -> begin
            MOI.add_constraint(
                model,
                zero(MOI.ScalarAffineFunction{Float64}),
                MOI.EqualTo(3.0),
            )
        end;
        cannot_unbridge = true,
    )
    return
end

function test_bridge_error_handler()
    for (err, flag) in (
        ErrorException("abc") => false,
        MOI.GetAttributeNotAllowed(MOI.ObjectiveSense()) => false,
        MOI.GetAttributeNotAllowed(MOI.ConstraintFunction()) => true,
    )
        @test_throws err try
            @assert false
        catch
            MOI.Bridges._runtests_error_handler(err, false)
        end
        if flag
            @test MOI.Bridges._runtests_error_handler(err, true) === nothing
        else
            @test_throws err try
                @assert false
            catch
                MOI.Bridges._runtests_error_handler(err, true)
            end
        end
    end
    return
end

function test_zeros()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Variable.Zeros{Float64}(mock)

    x, cx = MOI.add_constrained_variable(bridged_mock, MOI.GreaterThan(0.0))
    MOI.set(bridged_mock, MOI.VariableName(), x, "x")
    yz, cyz = MOI.add_constrained_variables(bridged_mock, MOI.Zeros(2))
    MOI.set(bridged_mock, MOI.VariableName(), yz, ["y", "z"])
    MOI.set(bridged_mock, MOI.ConstraintName(), cyz, "cyz")
    y, z = yz
    MOI.set(bridged_mock, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(bridged_mock, MOI.ObjectiveFunction{typeof(x)}(), x)
    @test MOI.get(bridged_mock, MOI.ObjectiveFunction{typeof(x)}()) == x

    # Test before adding affine constraints are affine expressions cannot be
    # unbridged when `Variable.ZerosBridge` is used.
    s = """
    variables: x, y, z
    x >= 0.0
    cyz: [y, z] in Zeros(2)
    minobjective: x
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        ["x", "y", "z"],
        ["cyz"],
        [("x", MOI.GreaterThan{Float64}(0.0))],
    )

    c1, c2 = MOI.add_constraints(
        bridged_mock,
        [1.0y + 1.0z, 1.0x + 1.0y + 1.0z],
        [MOI.EqualTo(0.0), MOI.GreaterThan(1.0)],
    )
    MOI.set(bridged_mock, MOI.ConstraintName(), c1, "con1")
    MOI.set(bridged_mock, MOI.ConstraintName(), c2, "con2")
    MOI.set(bridged_mock, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    obj = 1.0x - 1.0y - 1.0z
    MOI.set(bridged_mock, MOI.ObjectiveFunction{typeof(obj)}(), obj)

    @test MOI.Bridges.Variable.unbridged_map(
        MOI.Bridges.bridge(bridged_mock, y),
        y,
        MOI.Bridges.IndexInVector(1),
    ) === nothing
    @test MOI.Bridges.Variable.unbridged_map(
        MOI.Bridges.bridge(bridged_mock, z),
        z,
        MOI.Bridges.IndexInVector(2),
    ) === nothing

    err = MOI.DeleteNotAllowed(
        cyz,
        "Cannot delete constraint index of bridged constrained variables. " *
        "Delete the scalar variable or the vector of variables instead.",
    )
    @test_throws err MOI.delete(bridged_mock, cyz)

    err = MOI.GetAttributeNotAllowed(
        MOI.ConstraintFunction(),
        "Cannot unbridge function because some variables are bridged by" *
        " variable bridges that do not support reverse mapping, for example," *
        " `ZerosBridge`.",
    )
    @test_throws err MOI.get(bridged_mock, MOI.ObjectiveFunction{typeof(obj)}())
    # With `c1`, the function does not contain any variable so it tests that it
    # also throws an error even if it never calls `variable_unbridged_function`
    @test_throws err MOI.get(bridged_mock, MOI.ConstraintFunction(), c1)
    @test_throws err MOI.get(bridged_mock, MOI.ConstraintFunction(), c2)

    err = ArgumentError(
        "Variable bridge of type `MathOptInterface.Bridges.Variable.ZerosBridge{Float64}`" *
        " does not support accessing the attribute `$(MOI.Test.UnknownVariableAttribute())`.",
    )
    @test_throws err MOI.get(
        bridged_mock,
        MOI.Test.UnknownVariableAttribute(),
        y,
    )

    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                0.0,
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                1.0,
        ),
    )
    MOI.optimize!(bridged_mock)
    @test MOI.get(bridged_mock, MOI.VariablePrimal(), x) == 1.0
    @test MOI.get(bridged_mock, MOI.VariablePrimal(), y) == 0.0
    @test MOI.get(bridged_mock, MOI.VariablePrimal(), z) == 0.0

    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), cyz) == zeros(2)

    @test MOI.get(bridged_mock, MOI.ConstraintDual(), cx) == 0.0
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), c1) == 0.0
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), c2) == 1.0
    attr = MOI.ConstraintDual()
    err = MOI.GetAttributeNotAllowed(
        attr,
        "Unable to query the dual of a variable bound that was reformulated " *
        "using `ZerosBridge`. This usually arises in conic solvers when a " *
        "variable is fixed to a value. As a work-around, instead of creating " *
        "a fixed variable using variable bounds like `p == 1`, add an affine " *
        "equality constraint like `1 * p == 1` (or `[1 * p - 1,] in Zeros(1)`).",
    )
    @test_throws err MOI.get(bridged_mock, attr, cyz)

    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), cyz).variables == yz
    @test MOI.get(mock, MOI.NumberOfVariables()) == 1
    @test MOI.get(mock, MOI.ListOfVariableIndices()) == [x]
    @test MOI.get(bridged_mock, MOI.NumberOfVariables()) == 3
    @test MOI.get(bridged_mock, MOI.ListOfVariableIndices()) == [x, y, z]
    @test MOI.get(
        mock,
        MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.Zeros}(),
    ) == 0
    @test MOI.get(
        bridged_mock,
        MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.Zeros}(),
    ) == 1
    @test MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Zeros}(),
    ) == [cyz]

    s = """
    variables: x
    x >= 0.0
    con1: 0.0 == 0.0
    con2: x + 0.0 >= 1.0
    minobjective: x
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        ["x"],
        ["con1", "con2"],
        [("x", MOI.GreaterThan{Float64}(0.0))],
    )

    _test_delete_bridged_variables(
        bridged_mock,
        yz,
        MOI.Zeros,
        3,
        ((MOI.VariableIndex, MOI.GreaterThan{Float64}, 1),),
    )
    @test MOI.is_valid(bridged_mock, x)
    @test !MOI.is_valid(bridged_mock, y)
    @test !MOI.is_valid(bridged_mock, z)
    return
end

end  # module

TestVariableZeros.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    AbstractOptimizerAttribute

Abstract supertype for attribute objects that can be used to set or get
attributes (properties) of the optimizer.

## Notes

The difference between `AbstractOptimizerAttribute` and
[`AbstractModelAttribute`](@ref) lies in the behavior of [`is_empty`](@ref),
[`empty!`](@ref) and [`copy_to`](@ref). Typically optimizer attributes affect
only how the model is solved.
"""
abstract type AbstractOptimizerAttribute end

"""
    AbstractModelAttribute

Abstract supertype for attribute objects that can be used to set or get
attributes (properties) of the model.
"""
abstract type AbstractModelAttribute end

"""
    AbstractVariableAttribute

Abstract supertype for attribute objects that can be used to set or get
attributes (properties) of variables in the model.
"""
abstract type AbstractVariableAttribute end

"""
    AbstractConstraintAttribute

Abstract supertype for attribute objects that can be used to set or get
attributes (properties) of constraints in the model.
"""
abstract type AbstractConstraintAttribute end

# Attributes should not contain any `VariableIndex` or `ConstraintIndex` as the
# set is passed unmodified during `copy_to`.
const AnyAttribute = Union{
    AbstractOptimizerAttribute,
    AbstractModelAttribute,
    AbstractVariableAttribute,
    AbstractConstraintAttribute,
}

# This allows to use attributes in broadcast calls without the need to
# embed it in a `Ref`
Base.broadcastable(attribute::AnyAttribute) = Ref(attribute)

"""
    attribute_value_type(attr::AnyAttribute)

Given an attribute `attr`, return the type of value expected by [`get`](@ref),
or returned by [`set`](@ref).

## Notes

 * Only implement this if it make sense to do so. If un-implemented, the default
   is `Any`.
"""
attribute_value_type(::AnyAttribute) = Any

"""
    struct UnsupportedAttribute{AttrType} <: UnsupportedError
        attr::AttrType
        message::String
    end

An error indicating that the attribute `attr` is not supported by the model,
that is, that [`supports`](@ref) returns `false`.
"""
struct UnsupportedAttribute{AttrType<:AnyAttribute} <: UnsupportedError
    attr::AttrType
    message::String
end

UnsupportedAttribute(attr::AnyAttribute) = UnsupportedAttribute(attr, "")

element_name(err::UnsupportedAttribute) = "Attribute $(err.attr)"

"""
    struct SetAttributeNotAllowed{AttrType} <: NotAllowedError
        attr::AttrType
        message::String
    end

An error indicating that the attribute `attr` is supported (see
[`supports`](@ref)) but cannot be set for some reason (see the error string).
"""
struct SetAttributeNotAllowed{AttrType<:AnyAttribute} <: NotAllowedError
    attr::AttrType
    message::String # Human-friendly explanation why the attribute cannot be set
end

SetAttributeNotAllowed(attr::AnyAttribute) = SetAttributeNotAllowed(attr, "")

operation_name(err::SetAttributeNotAllowed) = "Setting attribute $(err.attr)"

message(err::SetAttributeNotAllowed) = err.message

"""
    struct GetAttributeNotAllowed{AttrType} <: NotAllowedError
        attr::AttrType
        message::String
    end

An error indicating that the attribute `attr` cannot be got for some reason (see
the error string).
"""
struct GetAttributeNotAllowed{AttrType<:AnyAttribute} <: NotAllowedError
    attr::AttrType
    message::String

    function GetAttributeNotAllowed(attr::AnyAttribute, message::String = "")
        return new{typeof(attr)}(attr, message)
    end
end

operation_name(err::GetAttributeNotAllowed) = "Getting attribute $(err.attr)"

message(err::GetAttributeNotAllowed) = err.message

"""
    AbstractSubmittable

Abstract supertype for objects that can be submitted to the model.
"""
abstract type AbstractSubmittable end

# This allows to use submittable in broadcast calls without the need to embed
# it in a `Ref`.
Base.broadcastable(sub::AbstractSubmittable) = Ref(sub)

"""
    struct UnsupportedSubmittable{SubmitType} <: UnsupportedError
        sub::SubmitType
        message::String
    end

An error indicating that the submittable `sub` is not supported by the model,
that is, that [`supports`](@ref) returns `false`.
"""
struct UnsupportedSubmittable{SubmitType<:AbstractSubmittable} <:
       UnsupportedError
    sub::SubmitType
    message::String
end

"""
    struct SubmitNotAllowed{SubmitTyp<:AbstractSubmittable} <: NotAllowedError
        sub::SubmitType
        message::String
    end

An error indicating that the submittable `sub` is supported (see
[`supports`](@ref)) but cannot be added for some reason (see the error string).
"""
struct SubmitNotAllowed{SubmitType<:AbstractSubmittable} <: NotAllowedError
    sub::SubmitType
    message::String # Human-friendly explanation why the attribute cannot be set
end

SubmitNotAllowed(sub::AbstractSubmittable) = SubmitNotAllowed(sub, "")

operation_name(err::SubmitNotAllowed) = "Submitting $(err.sub)"

message(err::SubmitNotAllowed) = err.message

"""
    struct ResultIndexBoundsError{AttrType} <: Exception
        attr::AttrType
        result_count::Int
    end

An error indicating that the requested attribute `attr` could not be retrieved,
because the solver returned too few results compared to what was requested.
For instance, the user tries to retrieve `VariablePrimal(2)` when only one
solution is available, or when the model is infeasible and has no solution.

See also: [`check_result_index_bounds`](@ref).
"""
struct ResultIndexBoundsError{AttrType} <: Exception
    attr::AttrType
    result_count::Int
end

"""
    check_result_index_bounds(model::ModelLike, attr)

This function checks whether enough results are available in the `model` for
the requested `attr`, using its `result_index` field. If the model
does not have sufficient results to answer the query, it throws a
[`ResultIndexBoundsError`](@ref).
"""
function check_result_index_bounds(model::ModelLike, attr)
    result_count = get(model, ResultCount())
    if !(1 <= attr.result_index <= result_count)
        throw(ResultIndexBoundsError(attr, result_count))
    end
    return
end

function Base.showerror(io::IO, err::ResultIndexBoundsError)
    return print(
        io,
        "Result index of attribute $(err.attr) out of bounds. There are " *
        "currently $(err.result_count) solution(s) in the model.",
    )
end

"""
    struct ConflictIndexBoundsError{AttrType} <: Exception
        attr::AttrType
        conflict_count::Int
    end

An error indicating that the requested attribute `attr` could not be retrieved,
because the solver returned too few conflicts compared to what was requested.
For instance, the user tries to retrieve `ConstraintConflictStatus(2)` when
only one conflict is available, or when the model is feasible.

See also: [`check_conflict_index_bounds`](@ref).
"""
struct ConflictIndexBoundsError{AttrType} <: Exception
    attr::AttrType
    conflict_count::Int
end

"""
    check_conflict_index_bounds(model::ModelLike, attr)

This function checks whether enough conflicts are available in the `model` for
the requested `attr`, using its `conflict_index` field. If the model
does not have sufficient conflicts to answer the query, it throws a
[`ConflictIndexBoundsError`](@ref).
"""
function check_conflict_index_bounds(model::ModelLike, attr)
    conflict_count = get(model, ConflictCount())
    if !(1 <= attr.conflict_index <= conflict_count)
        throw(ConflictIndexBoundsError(attr, conflict_count))
    end
    return
end

function Base.showerror(io::IO, err::ConflictIndexBoundsError)
    return print(
        io,
        "Conflict index of attribute $(err.attr) out of bounds. There are " *
        "currently $(err.conflict_count) conflict(s) in the model.",
    )
end

"""
    supports(model::ModelLike, sub::AbstractSubmittable)::Bool

Return a `Bool` indicating whether `model` supports the submittable `sub`.

```julia
supports(model::ModelLike, attr::AbstractOptimizerAttribute)::Bool
```

Return a `Bool` indicating whether `model` supports the optimizer attribute
`attr`. That is, it returns `false` if `copy_to(model, src)` shows a warning in
case `attr` is in the [`ListOfOptimizerAttributesSet`](@ref) of `src`; see
[`copy_to`](@ref) for more details on how unsupported optimizer attributes are
handled in copy.

```julia
supports(model::ModelLike, attr::AbstractModelAttribute)::Bool
```

Return a `Bool` indicating whether `model` supports the model attribute `attr`.
That is, it returns `false` if `copy_to(model, src)` cannot be performed in case
`attr` is in the [`ListOfModelAttributesSet`](@ref) of `src`.

```julia
supports(
    model::ModelLike,
    attr::AbstractVariableAttribute,
    ::Type{VariableIndex},
)::Bool
```

Return a `Bool` indicating whether `model` supports the variable attribute
`attr`. That is, it returns `false` if `copy_to(model, src)` cannot be performed
in case `attr` is in the [`ListOfVariableAttributesSet`](@ref) of `src`.

```julia
supports(
    model::ModelLike,
    attr::AbstractConstraintAttribute,
    ::Type{ConstraintIndex{F,S}},
)::Bool where {F,S}
```

Return a `Bool` indicating whether `model` supports the constraint attribute
`attr` applied to an `F`-in-`S` constraint. That is, it returns `false` if
`copy_to(model, src)` cannot be performed in case `attr` is in the
[`ListOfConstraintAttributesSet`](@ref) of `src`.

For all five methods, if the attribute is only not supported in specific
circumstances, it should still return `true`.

Note that `supports` is only defined for attributes for which
[`is_copyable`](@ref) returns `true` as other attributes do not appear in the
list of attributes set obtained by `ListOfXXXAttributesSet`.
"""
function supports(model::ModelLike, attr::AnyAttribute, args...)
    return supports_fallback(model, attr, args...)
end

supports(::ModelLike, ::AbstractSubmittable) = false

function supports_fallback(
    ::ModelLike,
    attr::Union{AbstractModelAttribute,AbstractOptimizerAttribute},
)
    if !is_copyable(attr)
        throw(
            ArgumentError(
                "`supports` is not defined for $attr, it is only" *
                " defined for attributes such that `is_copyable`" *
                " returns `true`.",
            ),
        )
    end
    return false
end

function supports_fallback(
    ::ModelLike,
    attr::Union{AbstractVariableAttribute,AbstractConstraintAttribute},
    ::Type{<:Index},
)
    if !is_copyable(attr)
        throw(
            ArgumentError(
                "`supports` is not defined for $attr, it is only" *
                " defined for attributes such that `is_copyable`" *
                " returns `true`.",
            ),
        )
    end
    return false
end

"""
    get(optimizer::AbstractOptimizer, attr::AbstractOptimizerAttribute)

Return an attribute `attr` of the optimizer `optimizer`.

```julia
get(model::ModelLike, attr::AbstractModelAttribute)
```

Return an attribute `attr` of the model `model`.

```julia
get(model::ModelLike, attr::AbstractVariableAttribute, v::VariableIndex)
```

If the attribute `attr` is set for the variable `v` in the model `model`, return
its value, return `nothing` otherwise. If the attribute `attr` is not supported
by `model` then an error should be thrown instead of returning `nothing`.

```julia
get(model::ModelLike, attr::AbstractVariableAttribute, v::Vector{VariableIndex})
```

Return a vector of attributes corresponding to each variable in the collection
`v` in the model `model`.

```julia
get(model::ModelLike, attr::AbstractConstraintAttribute, c::ConstraintIndex)
```

If the attribute `attr` is set for the constraint `c` in the model `model`,
return its value, return `nothing` otherwise. If the attribute `attr` is not
supported by `model` then an error should be thrown instead of returning
`nothing`.

```julia
get(
    model::ModelLike,
    attr::AbstractConstraintAttribute,
    c::Vector{ConstraintIndex{F,S}},
) where {F,S}
```

Return a vector of attributes corresponding to each constraint in the collection
`c` in the model `model`.

```julia
get(model::ModelLike, ::Type{VariableIndex}, name::String)
```

If a variable with name `name` exists in the model `model`, return the
corresponding index, otherwise return `nothing`. Errors if two variables
have the same name.

```julia
get(
    model::ModelLike,
    ::Type{ConstraintIndex{F,S}},
    name::String,
) where {F,S}
```

If an `F`-in-`S` constraint with name `name` exists in the model `model`, return
the corresponding index, otherwise return `nothing`. Errors if two constraints
have the same name.

```julia
get(model::ModelLike, ::Type{ConstraintIndex}, name::String)
```

If *any* constraint with name `name` exists in the model `model`, return the
corresponding index, otherwise return `nothing`. This version is available for
convenience but may incur a performance penalty because it is not type stable.
Errors if two constraints have the same name.
"""
function get(model::ModelLike, attr::AnyAttribute, args...)
    return get_fallback(model, attr, args...)
end

# !!! danger
#     We want to avoid being too specific in the type arguments to avoid method
#     ambiguity. For example,
#         get(::ModelLike, ::AbstractVariableAttribute, ::Vector{VariableIndex})
#     would not allow us to define get(::SomeModel, ::AnyAttribute, ::Vector).
function get(model::ModelLike, attr::AnyAttribute, idxs::Vector)
    if isempty(idxs)
        return Vector{attribute_value_type(attr)}()
    end
    return get.(model, attr, idxs)
end

function get_fallback(
    model::ModelLike,
    attr::Union{AbstractModelAttribute,AbstractOptimizerAttribute},
)
    return throw(
        GetAttributeNotAllowed(
            attr,
            "$(typeof(model)) does not support getting the attribute $(attr).",
        ),
    )
end

function get_fallback(
    model::ModelLike,
    attr::AbstractVariableAttribute,
    ::VariableIndex,
)
    return throw(
        GetAttributeNotAllowed(
            attr,
            "$(typeof(model)) does not support getting the attribute $(attr).",
        ),
    )
end

function get_fallback(
    model::ModelLike,
    attr::AbstractConstraintAttribute,
    ::ConstraintIndex,
)
    return throw(
        GetAttributeNotAllowed(
            attr,
            "$(typeof(model)) does not support getting the attribute $(attr).",
        ),
    )
end

function get_fallback(::ModelLike, attr::AnyAttribute, args...)
    return throw(
        GetAttributeNotAllowed(
            attr,
            "Unable to get attribute $(attr): invalid arguments $(args).",
        ),
    )
end

"""
    get!(output, model::ModelLike, args...)

An in-place version of [`get`](@ref).

The signature matches that of [`get`](@ref) except that the result is placed in
the vector `output`.
"""
function get!(output, model::ModelLike, attr::AnyAttribute, args...)
    output .= get(model, attr, args...)
    return
end

"""
    set(optimizer::AbstractOptimizer, attr::AbstractOptimizerAttribute, value)

Assign `value` to the attribute `attr` of the optimizer `optimizer`.

```julia
set(model::ModelLike, attr::AbstractModelAttribute, value)
```

Assign `value` to the attribute `attr` of the model `model`.

```julia
set(model::ModelLike, attr::AbstractVariableAttribute, v::VariableIndex, value)
```

Assign `value` to the attribute `attr` of variable `v` in model `model`.

```julia
set(
    model::ModelLike,
    attr::AbstractVariableAttribute,
    v::Vector{VariableIndex},
    vector_of_values,
)
```

Assign a value respectively to the attribute `attr` of each variable in the
collection `v` in model `model`.

```julia
set(
    model::ModelLike,
    attr::AbstractConstraintAttribute,
    c::ConstraintIndex,
    value,
)
```

Assign a value to the attribute `attr` of constraint `c` in model `model`.

```julia
set(
    model::ModelLike,
    attr::AbstractConstraintAttribute,
    c::Vector{ConstraintIndex{F,S}},
    vector_of_values,
) where {F,S}
```

Assign a value respectively to the attribute `attr` of each constraint in the
collection `c` in model `model`.

An [`UnsupportedAttribute`](@ref) error is thrown if `model` does not support
the attribute `attr` (see [`supports`](@ref)) and a [`SetAttributeNotAllowed`](@ref)
error is thrown if it supports the attribute `attr` but it cannot be set.

```julia
set(
    model::ModelLike,
    ::ConstraintSet,
    c::ConstraintIndex{F,S},
    set::S,
) where {F,S}
```

Change the set of constraint `c` to the new set `set` which should be of the
same type as the original set.

```julia
set(
    model::ModelLike,
    ::ConstraintFunction,
    c::ConstraintIndex{F,S},
    func::F,
) where {F,S}
```

Replace the function in constraint `c` with `func`. `F` must match the original
function type used to define the constraint.

!!! note
    Setting the constraint function is not allowed if `F` is
    [`VariableIndex`](@ref); a [`SettingVariableIndexNotAllowed`](@ref) error is
    thrown instead. This is because, it would require changing the index `c`
    since the index of [`VariableIndex`](@ref) constraints must be the same as
    the index of the variable.
"""
function set(model::ModelLike, attr::AnyAttribute, args...)
    return throw_set_error_fallback(model, attr, args...)
end

# See note with get
function set(
    model::ModelLike,
    attr::Union{AbstractVariableAttribute,AbstractConstraintAttribute},
    idxs::Vector,
    vector_of_values::Vector,
)
    if length(idxs) != length(vector_of_values)
        throw(
            DimensionMismatch(
                "Number of indices ($(length(idxs))) does " *
                "not match the number of values " *
                "($(length(vector_of_values))) set to `$attr`.",
            ),
        )
    end
    return set.(model, attr, idxs, vector_of_values)
end

# throw_set_error_fallback is included so that we can return type-specific error
# messages without needing to overload set and cause ambiguity errors. For
# examples, see ConstraintSet and ConstraintFunction.
#
# throw_set_error_fallback should not be overloaded by users of MOI.
function throw_set_error_fallback(
    model::ModelLike,
    attr::Union{AbstractModelAttribute,AbstractOptimizerAttribute},
    value;
    error_if_supported = SetAttributeNotAllowed(attr),
)
    if supports(model, attr)
        throw(error_if_supported)
    else
        throw(UnsupportedAttribute(attr))
    end
end

function throw_set_error_fallback(
    model::ModelLike,
    attr::Union{AbstractVariableAttribute,AbstractConstraintAttribute},
    index::Index,
    value;
    error_if_supported = SetAttributeNotAllowed(attr),
)
    if supports(model, attr, typeof(index))
        throw(error_if_supported)
    else
        throw(UnsupportedAttribute(attr))
    end
end

"""
    SettingVariableIndexNotAllowed()

Error type that should be thrown when the user calls [`set`](@ref) to change
the [`ConstraintFunction`](@ref) of a [`VariableIndex`](@ref) constraint.
"""
struct SettingVariableIndexNotAllowed <: Exception end

"""
    submit(
        optimizer::AbstractOptimizer,
        sub::AbstractSubmittable,
        values...,
    )::Nothing

Submit `values` to the submittable `sub` of the optimizer `optimizer`.

An [`UnsupportedSubmittable`](@ref) error is thrown if `model` does not support
the attribute `attr` (see [`supports`](@ref)) and a [`SubmitNotAllowed`](@ref)
error is thrown if it supports the submittable `sub` but it cannot be submitted.
"""
function submit(model::ModelLike, sub::AbstractSubmittable, args...)
    if supports(model, sub)
        throw(
            ArgumentError(
                "Submitting $(typeof.(args)) for `$(typeof(sub))` is not valid.",
            ),
        )
    else
        throw(
            UnsupportedSubmittable(
                sub,
                "submit(::$(typeof(model)), ::$(typeof(sub))) is not supported.",
            ),
        )
    end
end

"""
    LazyConstraint(callback_data)

Lazy constraint `func`-in-`set` submitted as `func, set`. The optimal
solution returned by [`VariablePrimal`](@ref) will satisfy all lazy
constraints that have been submitted.

This can be submitted only from the [`LazyConstraintCallback`](@ref). The
field `callback_data` is a solver-specific callback type that is passed as the
argument to the feasible solution callback.

## Example

Suppose `x` and `y` are [`VariableIndex`](@ref)s of `optimizer`. To add a
`LazyConstraint` for `2x + 3y <= 1`, write
```julia
func = 2.0x + 3.0y
set = MOI.LessThan(1.0)
MOI.submit(optimizer, MOI.LazyConstraint(callback_data), func, set)
```
inside a [`LazyConstraintCallback`](@ref) of data `callback_data`.
"""
struct LazyConstraint{CallbackDataType} <: AbstractSubmittable
    callback_data::CallbackDataType
end

@_documented_enum(
    """
        HeuristicSolutionStatus

    An Enum of possible return values for [`submit`](@ref) with
    [`HeuristicSolution`](@ref).

    This status informs whether the heuristic solution was accepted or rejected.
    """,
    HeuristicSolutionStatus,
    "The heuristic solution was accepted.",
    HEURISTIC_SOLUTION_ACCEPTED,
    "The heuristic solution was rejected.",
    HEURISTIC_SOLUTION_REJECTED,
    "No information available on the acceptance.",
    HEURISTIC_SOLUTION_UNKNOWN,
)

"""
    HeuristicSolution(callback_data)

Heuristically obtained feasible solution. The solution is submitted as
`(variables, values)::Tuple{Vector{MOI.VariableIndex},Vector{T}}`, where
`values[i]` gives the value of `variables[i]`.

The [`submit`](@ref) call returns a [`HeuristicSolutionStatus`](@ref) indicating
whether the provided solution was accepted or rejected.

This can be submitted only from the [`HeuristicCallback`](@ref). The
field `callback_data` is a solver-specific callback type that is passed as the
argument to the heuristic callback.

Some solvers require a complete solution, others only partial solutions.
"""
struct HeuristicSolution{CallbackDataType} <: AbstractSubmittable
    callback_data::CallbackDataType
end

"""
    UserCut(callback_data)

Constraint `func`-to-`set` suggested to help the solver detect the solution
given by [`CallbackVariablePrimal`](@ref) as infeasible. The cut is submitted
as the tuple `(func, set)::Tuple{MOI.AbstractFunction,MOI.AbstractSet}`.

Typically [`CallbackVariablePrimal`](@ref) will violate integrality constraints,
and a cut would be of the form [`ScalarAffineFunction`](@ref)-in-[`LessThan`](@ref)
or [`ScalarAffineFunction`](@ref)-in-[`GreaterThan`](@ref).

Note that, as opposed to [`LazyConstraint`](@ref), the provided constraint
must not modify the feasible set. The constraint should be redundant, for
example, it may be a consequence of affine and integrality constraints.

This can be submitted only from the [`UserCutCallback`](@ref). The
field `callback_data` is a solver-specific callback type that is passed as the
argument to the infeasible solution callback.

Note that the solver may silently ignore the provided constraint.
"""
struct UserCut{CallbackDataType} <: AbstractSubmittable
    callback_data::CallbackDataType
end

"""
    struct InvalidCallbackUsage{C, S} <: Exception
        callback::C
        submittable::S
    end

An error indicating that `submittable` cannot be submitted inside `callback`.

For example, [`UserCut`](@ref) cannot be submitted inside
[`LazyConstraintCallback`](@ref).
"""
struct InvalidCallbackUsage{C,S} <: Exception
    callback::C
    submittable::S
end

function Base.showerror(io::IO, err::InvalidCallbackUsage)
    return print(
        io,
        "InvalidCallbackUsage: Cannot submit $(err.submittable) inside a $(err.callback).",
    )
end

@_documented_enum(
    """
        CallbackNodeStatusCode

    An Enum for the value of the [`CallbackNodeStatus`](@ref) attribute.
    """,
    CallbackNodeStatusCode,
    """
    The primal solution available from [`CallbackVariablePrimal`](@ref) is
    integer feasible.
    """,
    CALLBACK_NODE_STATUS_INTEGER,
    """
    The primal solution available from [`CallbackVariablePrimal`](@ref) is
    integer infeasible.
    """,
    CALLBACK_NODE_STATUS_FRACTIONAL,
    """
    The status of the primal solution available from [`CallbackVariablePrimal`](@ref)
    is unknown.
    """,
    CALLBACK_NODE_STATUS_UNKNOWN,
)

"""
    CallbackNodeStatus(callback_data)

An optimizer attribute describing the (in)feasibility of the primal solution
available from [`CallbackVariablePrimal`](@ref) during a callback identified by
`callback_data`.

Returns a [`CallbackNodeStatusCode`](@ref) Enum.
"""
struct CallbackNodeStatus{CallbackDataType} <: AbstractOptimizerAttribute
    callback_data::CallbackDataType
end

is_set_by_optimize(::CallbackNodeStatus) = true

attribute_value_type(::CallbackNodeStatus) = CallbackNodeStatusCode

"""
    ListOfOptimizerAttributesSet()

An [`AbstractOptimizerAttribute`](@ref) for the `Vector{AbstractOptimizerAttribute}`
of all optimizer attributes that were set.

## Implementation

Optimizers should implement the following methods:
```
MOI.get(
    ::Optimizer,
    ::MOI.ListOfOptimizerAttributesSet,
)::Vector{MOI.AbstractOptimizerAttribute}
```

They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ListOfOptimizerAttributesSet <: AbstractOptimizerAttribute end

"""
    SolverName()

An [`AbstractOptimizerAttribute`](@ref) for the string identifying the solver.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.SolverName)::String
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct SolverName <: AbstractOptimizerAttribute end

attribute_value_type(::SolverName) = String

"""
    SolverVersion()

An [`AbstractOptimizerAttribute`](@ref) for the string identifying the version
of the solver.

## Versioning systems

For solvers supporting [semantic versioning](https://semver.org), the
[`SolverVersion`](@ref) should be a string of the form "vMAJOR.MINOR.PATCH", so
that it can be converted to a Julia `VersionNumber` (for example,
`VersionNumber("v1.2.3")).

We do not require Semantic Versioning because some solvers use alternate
versioning systems. For example, CPLEX uses Calendar Versioning, so
[`SolverVersion`](@ref) will return a string like `"202001"`.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.SolverVersion)::String
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct SolverVersion <: AbstractOptimizerAttribute end

attribute_value_type(::SolverVersion) = String

"""
    Silent()

An [`AbstractOptimizerAttribute`](@ref) for silencing the output of an
optimizer.

When `set` to `true`, this attribute takes precedence over any other attribute
controlling verbosity and requires the optimizer to produce no output.

The default value is `false` which has no effect. In this case the verbosity is
controlled by other optimizer-specific attributes.

## Value and default

The provided value must be a `Bool`.

The default value is `false`.

## Note

Every optimizer should have verbosity on by default. For instance, if a solver
has a solver-specific log level attribute, the MOI implementation should set it
to `1` by default. If the user sets `Silent` to `true`, then the log level
should be set to `0`, even if the user specifically sets a value of log level.
If the value of `Silent` is `false` then the log level set to the solver is the
value given by the user for this solver-specific parameter or `1` if none is
given.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.Silent)::Bool
MOI.set(::Optimizer, ::MOI.Silent, ::Bool)::Nothing
MOI.supports(::Optimizer, ::MOI.Silent)::Bool
```
"""
struct Silent <: AbstractOptimizerAttribute end

attribute_value_type(::Silent) = Bool

"""
    TimeLimitSec()

An [`AbstractOptimizerAttribute`](@ref) for setting a time limit (in seconds)
for a call to [`optimize!`](@ref).

## Value and default

The provided limit must be a `Union{Nothing,Real}`.

When `set` to `nothing`, it deactivates the time limit.

The default value is `nothing`.

## TerminationStatus

The optimizer may stop when the [`SolveTimeSec`](@ref) is larger than the
[`TimeLimitSec`](@ref). If stopped because of this limit, the
[`TerminationStatus`](@ref) must be [`TIME_LIMIT`](@ref).

Note that most optimizers do not strictly respect a time limit. Instead, they
terminate at the first convenient time after the time limit has been exceeded.
Thus, you may find that the [`SolveTimeSec`](@ref) exceeds the [`TimeLimitSec`](@ref)
by a few seconds.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.TimeLimitSec)::Union{Nothing,Float64}
MOI.set(::Optimizer, ::MOI.TimeLimitSec, ::Union{Nothing,Real})::Nothing
MOI.supports(::Optimizer, ::MOI.TimeLimitSec)::Bool
```
"""
struct TimeLimitSec <: AbstractOptimizerAttribute end

attribute_value_type(::TimeLimitSec) = Union{Nothing,Float64}

"""
    ObjectiveLimit()

An [`AbstractOptimizerAttribute`](@ref) for setting a limit on the objective
value.

## Value and default

The provided limit must be a `Union{Nothing,Real}`.

When `set` to `nothing`, the limit reverts to the solver's default.

The default value is `nothing`.

## TerminationStatus

The solver may stop when the [`ObjectiveValue`](@ref) is better (lower for
minimization, higher for maximization) than the `ObjectiveLimit`. If stopped,
because of this limit, the [`TerminationStatus`](@ref) should be
[`OBJECTIVE_LIMIT`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.ObjectiveLimit)::Union{Nothing,Float64}
MOI.set(::Optimizer, ::MOI.ObjectiveLimit, ::Union{Nothing,Real})::Nothing
MOI.supports(::Optimizer, ::MOI.ObjectiveLimit)::Bool
```
"""
struct ObjectiveLimit <: AbstractOptimizerAttribute end

"""
    SolutionLimit()

An [`AbstractOptimizerAttribute`](@ref) for setting a limit on the number of
available feasible solutions.

## Value and default

The provided limit must be a `Union{Nothing,Int}`.

When `set` to `nothing`, the limit reverts to the solver's default.

The default value is `nothing`.

## Termination criteria

The solver may stop when the [`ResultCount`](@ref) is larger than or equal to
the [`SolutionLimit`](@ref). If stopped because of this attribute, the
[`TerminationStatus`](@ref) must be [`SOLUTION_LIMIT`](@ref).

## Solution quality

The quality of the available solutions is solver-dependent. The set of resulting
solutions is not guaranteed to contain an optimal solution.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.SolutionLimit)::Union{Nothing,Int}
MOI.set(::Optimizer, ::MOI.SolutionLimit, ::Union{Nothing,Int})::Nothing
MOI.supports(::Optimizer, ::MOI.SolutionLimit)::Bool
```
"""
struct SolutionLimit <: AbstractOptimizerAttribute end

attribute_value_type(::SolutionLimit) = Union{Nothing,Int}

"""
    NodeLimit()

An [`AbstractOptimizerAttribute`](@ref) for setting a limit on the number of
branch-and-bound nodes explored by a mixed-integer program (MIP) solver.

## Value and default

The provided limit must be a `Union{Nothing,Int}`.

When `set` to `nothing`, the limit reverts to the solver's default.

The default value is `nothing`.

## Termination criteria

The solver may stop when the [`NodeCount`](@ref) is larger than or equal to
the [`NodeLimit`](@ref). If stopped because of this attribute, the
[`TerminationStatus`](@ref) must be [`NODE_LIMIT`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.NodeLimit)::Union{Nothing,Int}
MOI.set(::Optimizer, ::MOI.NodeLimit, ::Union{Nothing,Int})::Nothing
MOI.supports(::Optimizer, ::MOI.NodeLimit)::Bool
```
"""
struct NodeLimit <: AbstractOptimizerAttribute end

attribute_value_type(::NodeLimit) = Union{Nothing,Int}

"""
    RawOptimizerAttribute(name::String)

An [`AbstractOptimizerAttribute`](@ref) for the solver-specific parameter
identified by `name`.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.RawOptimizerAttribute)::Any
MOI.set(::Optimizer, ::MOI.RawOptimizerAttribute, ::Any)::Nothing
MOI.supports(::Optimizer, ::MOI.RawOptimizerAttribute)::Bool
```
"""
struct RawOptimizerAttribute <: AbstractOptimizerAttribute
    name::String
end

"""
    NumberOfThreads()

An [`AbstractOptimizerAttribute`](@ref) for setting the number of threads used
for an optimization.

## Value and default

The provided value must be `nothing` or a positive `Int`.

When `set` to `nothing`, the value reverts to the solver's default.

The default value is `nothing`.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.NumberOfThreads)::Union{Nothing,Int}
MOI.set(::Optimizer, ::MOI.NumberOfThreads, ::Union{Nothing,Int})::Nothing
MOI.supports(::Optimizer, ::MOI.NumberOfThreads)::Bool
```
"""
struct NumberOfThreads <: AbstractOptimizerAttribute end

attribute_value_type(::NumberOfThreads) = Union{Nothing,Int}

"""
    RelativeGapTolerance()

An [`AbstractOptimizerAttribute`](@ref) for setting the relative gap tolerance
for an optimization.

## Definition

The mathematical definition of "relative gap" and its allowed range are
solver-dependent. Typically, solvers expect a value between `0.0` and `1.0`.

## Value and default

The provided value must be a `Union{Nothing,Float64}`.

When set to `nothing`, the limit reverts to the solver's default.

## TerminationStatus

The optimizer may stop when the [`RelativeGap`](@ref) is smaller than the
[`RelativeGapTolerance`](@ref). If stopped because of this limit, the
[`TerminationStatus`](@ref) may be [`OPTIMAL`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.RelativeGapTolerance)::Union{Nothing,Float64}
MOI.set(
    ::Optimizer,
    ::MOI.RelativeGapTolerance,
    ::Union{Nothing,Float64},
)::Nothing
MOI.supports(::Optimizer, ::MOI.RelativeGapTolerance)::Bool
```
"""
struct RelativeGapTolerance <: AbstractOptimizerAttribute end

attribute_value_type(::RelativeGapTolerance) = Union{Nothing,Float64}

"""
    AbsoluteGapTolerance()

An [`AbstractOptimizerAttribute`](@ref) for setting the absolute gap tolerance
for an optimization.

## Definition

The mathematical definition of "absolute gap" and its allowed range are
solver-dependent. However, most solvers that implement this attribute will stop
once ``|f - b| ≤ g_{abs}``, where ``b`` is the best bound, ``f`` is the best
feasible objective value, and ``g_{abs}`` is the absolute gap.

## Value and default

The provided value must be a `Union{Nothing,Float64}`.

When set to `nothing`, the limit reverts to the solver's default.

## TerminationStatus

The optimizer may stop when the absolute difference between [`ObjectiveValue`](@ref)
and [`ObjectiveBound`](@ref) is smaller than the [`AbsoluteGapTolerance`](@ref).
If stopped because of this limit, the [`TerminationStatus`](@ref) may be
[`OPTIMAL`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.AbsoluteGapTolerance)::Union{Nothing,Float64}
MOI.set(
    ::Optimizer,
    ::MOI.AbsoluteGapTolerance,
    ::Union{Nothing,Float64},
)::Nothing
MOI.supports(::Optimizer, ::MOI.AbsoluteGapTolerance)::Bool
```
"""
struct AbsoluteGapTolerance <: AbstractOptimizerAttribute end

attribute_value_type(::AbsoluteGapTolerance) = Union{Nothing,Float64}

"""
    struct OptimizeInProgress{AttrType<:AnyAttribute} <: Exception
        attr::AttrType
    end

Error thrown from optimizer when `MOI.get(optimizer, attr)` is called inside an
[`AbstractCallback`](@ref) while it is only defined once [`optimize!`](@ref) has
completed. This can only happen when `is_set_by_optimize(attr)` is `true`.
"""
struct OptimizeInProgress{AttrType<:AnyAttribute} <: Exception
    attr::AttrType
end

function Base.showerror(io::IO, err::OptimizeInProgress)
    return print(
        io,
        typeof(err),
        ": Cannot get result as the `MOI.optimize!` has not",
        " finished.",
    )
end

"""
    abstract type AbstractCallback <: AbstractModelAttribute end

Abstract type for a model attribute representing a callback function. The
value set to subtypes of `AbstractCallback` is a function that may be called
during [`optimize!`](@ref). As [`optimize!`](@ref) is in progress, the result
attributes (that is, the attributes `attr` such that `is_set_by_optimize(attr)`)
may not be accessible from the callback, hence trying to get result attributes
might throw a [`OptimizeInProgress`](@ref) error.

At most one callback of each type can be registered. If an optimizer already has
a function for a callback type, and the user registers a new function, then the
old one is replaced.

The value of the attribute should be a function taking only one argument,
commonly called `callback_data`, that can be used for instance in
[`LazyConstraintCallback`](@ref), [`HeuristicCallback`](@ref) and
[`UserCutCallback`](@ref).
"""
abstract type AbstractCallback <: AbstractModelAttribute end

attribute_value_type(::AbstractCallback) = Function

"""
    LazyConstraintCallback() <: AbstractCallback

The callback can be used to reduce the feasible set given the current primal
solution by submitting a [`LazyConstraint`](@ref). For instance, it may be
called at an incumbent of a mixed-integer problem. Note that there is no
guarantee that the callback is called at *every* feasible primal solution.

The current primal solution is accessed through
[`CallbackVariablePrimal`](@ref). Trying to access other result
attributes will throw [`OptimizeInProgress`](@ref) as discussed in
[`AbstractCallback`](@ref).

## Example

```julia
x = MOI.add_variables(optimizer, 8)
MOI.set(optimizer, MOI.LazyConstraintCallback(), callback_data -> begin
    sol = MOI.get(optimizer, MOI.CallbackVariablePrimal(callback_data), x)
    if # should add a lazy constraint
        func = # computes function
        set = # computes set
        MOI.submit(optimizer, MOI.LazyConstraint(callback_data), func, set)
    end
end)
```
"""
struct LazyConstraintCallback <: AbstractCallback end

"""
    HeuristicCallback() <: AbstractCallback

The callback can be used to submit [`HeuristicSolution`](@ref) given the
current primal solution. For example, it may be called at fractional (that is,
non-integer) nodes in the branch and bound tree of a mixed-integer problem. Note
that there is no guarantee that the callback is called *every* time the solver
has an infeasible solution.

The current primal solution is accessed through [`CallbackVariablePrimal`](@ref).
Trying to access other result attributes will throw [`OptimizeInProgress`](@ref)
as discussed in [`AbstractCallback`](@ref).

## Example

```julia
x = MOI.add_variables(optimizer, 8)
MOI.set(optimizer, MOI.HeuristicCallback(), callback_data -> begin
    sol = MOI.get(optimizer, MOI.CallbackVariablePrimal(callback_data), x)
    if # can find a heuristic solution
        values = # computes heuristic solution
        MOI.submit(optimizer, MOI.HeuristicSolution(callback_data), x,
                   values)
    end
end
```
"""
struct HeuristicCallback <: AbstractCallback end

"""
    UserCutCallback() <: AbstractCallback

The callback can be used to submit [`UserCut`](@ref) given the current primal
solution. For instance, it may be called at fractional (that is, non-integer) nodes
in the branch and bound tree of a mixed-integer problem. Note that there is not
guarantee that the callback is called *everytime* the solver has an infeasible
solution.

The infeasible solution is accessed through [`CallbackVariablePrimal`](@ref).
Trying to access other result attributes will throw [`OptimizeInProgress`](@ref)
as discussed in [`AbstractCallback`](@ref).

## Example

```julia
x = MOI.add_variables(optimizer, 8)
MOI.set(optimizer, MOI.UserCutCallback(), callback_data -> begin
    sol = MOI.get(optimizer, MOI.CallbackVariablePrimal(callback_data), x)
    if # can find a user cut
        func = # computes function
        set = # computes set
        MOI.submit(optimizer, MOI.UserCut(callback_data), func, set)
    end
end
```
"""
struct UserCutCallback <: AbstractCallback end

"""
    ListOfModelAttributesSet()

An [`AbstractModelAttribute`](@ref) for the `Vector{AbstractModelAttribute}` of all model
attributes `attr` such that:

 1. `is_copyable(attr)` returns `true`, and
 2. the attribute was set to the model
"""
struct ListOfModelAttributesSet <: AbstractModelAttribute end

"""
    Name()

An [`AbstractModelAttribute`](@ref) for the string identifying the model.

It has a default value of `""` if not set.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.Name)::String
MOI.set(::Optimizer, ::MOI.Name, ::String)::Nothing
MOI.supports(::Optimizer, ::MOI.Name)::Bool
```
"""
struct Name <: AbstractModelAttribute end

attribute_value_type(::Name) = String

@_documented_enum(
    """
        OptimizationSense

    An Enum for the value of the [`ObjectiveSense`](@ref) attribute.
    """,
    OptimizationSense,
    "The goal is to minimize the objective function.",
    MIN_SENSE,
    "The goal is to maximize the objective function.",
    MAX_SENSE,
    "The model does not have an objective function.",
    FEASIBILITY_SENSE,
)

"""
    ObjectiveSense()

An [`AbstractModelAttribute`](@ref) for the objective sense of the objective
function, which must be an [`OptimizationSense`](@ref).

The default is [`FEASIBILITY_SENSE`](@ref).

## Interaction with [`ObjectiveFunction`](@ref)

Setting the sense to [`FEASIBILITY_SENSE`](@ref) unsets the [`ObjectiveFunction`](@ref)
attribute. That is, if you first set [`ObjectiveFunction`](@ref) and then set
`ObjectiveSense` to be [`FEASIBILITY_SENSE`](@ref), no objective function will
be passed to the solver.

In addition, some reformulations of [`ObjectiveFunction`](@ref) via bridges rely
on the value of [`ObjectiveSense`](@ref). Therefore, you should set
[`ObjectiveSense`](@ref) before setting [`ObjectiveFunction`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.ObjectiveSense)::MOI.OptimizationSense
MOI.set(::Optimizer, ::MOI.ObjectiveSense, ::MOI.OptimizationSense)::Nothing
MOI.supports(::Optimizer, ::MOI.ObjectiveSense)::Bool
```
"""
struct ObjectiveSense <: AbstractModelAttribute end

attribute_value_type(::ObjectiveSense) = OptimizationSense

"""
    NumberOfVariables()

An [`AbstractModelAttribute`](@ref) for the number of variables in the model.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.NumberOfVariables)::Int64
```

They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct NumberOfVariables <: AbstractModelAttribute end

attribute_value_type(::NumberOfVariables) = Int64

"""
    ListOfVariableIndices()

An [`AbstractModelAttribute`](@ref) for querying the `Vector{MOI.VariableIndex}`
of all [`MOI.VariableIndex`] present in the model.

## Order

The variables must be returned in the order in which they were added to the
model.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.ListOfVariableIndices)::Vector{MOI.VariableIndex}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ListOfVariableIndices <: AbstractModelAttribute end

"""
    ListOfConstraintIndices{F,S}()

An [`AbstractModelAttribute`](@ref) for the `Vector{MOI.ConstraintIndex{F,S}}`
of all constraint indices of type `F`-in-`S` in the model.

## Order

The constraints must be returned in the order in which they were added to the
model.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ListOfConstraintIndices{F,S},
)::Vector{MOI.ConstraintIndex{F,S}} where {F<:MOI.AbstractFunction,MOI.AbstractSet}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ListOfConstraintIndices{F,S} <: AbstractModelAttribute end

function get_fallback(
    model::ModelLike,
    ::ListOfConstraintIndices{F,S},
) where {F,S}
    # Throw error here so that we don't return an incorrect value if solvers
    # don't implement this method for some constraints they support.
    if supports_constraint(model, F, S) ||
       (S === VariableIndex && supports_add_constrained_variable(model, S)) ||
       (S === VectorOfVariables && supports_add_constrained_variables(model, S))
        throw(GetAttributeNotAllowed(ListOfConstraintIndices{F,S}()))
    end
    return ConstraintIndex{F,S}[]
end

"""
    NumberOfConstraints{F,S}()

An [`AbstractModelAttribute`](@ref) for querying the number of constraints of
the type `F`-in-`S` present in the model.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.NumberOfConstraints{F,S},
)::Int64 where {F<:MOI.AbstractFunction,MOI.AbstractSet}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct NumberOfConstraints{F,S} <: AbstractModelAttribute end

attribute_value_type(::NumberOfConstraints) = Int64

function get_fallback(model::ModelLike, ::NumberOfConstraints{F,S}) where {F,S}
    # Throw error here so that we don't return an incorrect value if solvers
    # don't implement this method for constraints they support.
    if supports_constraint(model, F, S) ||
       (S === VariableIndex && supports_add_constrained_variable(model, S)) ||
       (S === VectorOfVariables && supports_add_constrained_variables(model, S))
        throw(GetAttributeNotAllowed(NumberOfConstraints{F,S}()))
    end
    return Int64(0)
end

"""
    ListOfConstraintTypesPresent()

An [`AbstractModelAttribute`](@ref) for the list of tuples of the form `(F, S)`,
indicating that the attribute [`NumberOfConstraints{F,S}`](@ref) has a value
greater than zero.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ListOfConstraintTypesPresent,
)::Vector{Tuple{Type,Type}}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ListOfConstraintTypesPresent <: AbstractModelAttribute end

"""
    ObjectiveFunction{F<:AbstractScalarFunction}()

An [`AbstractModelAttribute`](@ref) for the objective function which has a type
`F<:AbstractScalarFunction`.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ObjectiveFunction{F},
)::F where {F<:MOI.AbstractFunction}
MOI.set(
    ::Optimizer,
    ::MOI.ObjectiveFunction{F},
    ::F,
)::F where {F<:MOI.AbstractFunction}
MOI.supports(::Optimizer, ::MOI.ObjectiveFunction{<:MOI.AbstractFunction})::Bool
```

When implementing `get`, `F` may to be equivalent but not necessarily identical
to the function type set by the user. If the objective function cannot be
converted to `F`, an `InexactError` must be thrown.
"""
struct ObjectiveFunction{F<:AbstractFunction} <: AbstractModelAttribute end

attribute_value_type(::ObjectiveFunction{F}) where {F} = F

"""
    ObjectiveFunctionType()

An [`AbstractModelAttribute`](@ref) for the type `F` of the objective function
set using the [`ObjectiveFunction{F}`](@ref) attribute.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ObjectiveFunctionType,
)::Type{<:MOI.AbstractFunction}
```
They should not implement [`set`](@ref) or [`supports`](@ref).

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)

julia> MOI.get(model, MOI.ObjectiveFunctionType())
MathOptInterface.VariableIndex
```
"""
struct ObjectiveFunctionType <: AbstractModelAttribute end

attribute_value_type(::ObjectiveFunctionType) = Type{<:AbstractFunction}

"""
    ObjectiveValue(result_index::Int = 1)

An [`AbstractModelAttribute`](@ref) for the objective value of the primal
solution `result_index`.

## PrimalStatus

Before quering this attribute you should first check [`PrimalStatus`](@ref) to
confirm that a primal solution is avaiable.

If the [`PrimalStatus`](@ref) is [`NO_SOLUTION`](@ref) the result of querying
this attribute is undefined.

## `result_index`

The optimizer may return multiple primal solutions. See [`ResultCount`](@ref)
for information on how the results are ordered.

If the solver does not have a primal value for the objective because the
`result_index` is beyond the available solutions (whose number is indicated by
the [`ResultCount`](@ref) attribute), getting this attribute must throw a
[`ResultIndexBoundsError`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ObjectiveValue,
)::Union{T,Vector{T}} where {T<:Real}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ObjectiveValue <: AbstractModelAttribute
    result_index::Int
    ObjectiveValue(result_index::Int = 1) = new(result_index)
end

"""
    DualObjectiveValue(result_index::Int = 1)

An [`AbstractModelAttribute`](@ref) for the value of the objective function of
the dual solution `result_index`.

## DualStatus

Before quering this attribute you should first check [`DualStatus`](@ref) to
confirm that a dual solution is avaiable.

If the [`DualStatus`](@ref) is [`NO_SOLUTION`](@ref) the result of querying
this attribute is undefined.

## `result_index`

The optimizer may return multiple dual solutions. See [`ResultCount`](@ref)
for information on how the results are ordered.

If the solver does not have a dual value for the objective because the
`result_index` is beyond the available solutions (whose number is indicated by
the [`ResultCount`](@ref) attribute), getting this attribute must throw a
[`ResultIndexBoundsError`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.DualObjectiveValue,
)::Union{T,Vector{T}} where {T<:Real}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct DualObjectiveValue <: AbstractModelAttribute
    result_index::Int
    DualObjectiveValue(result_index::Int = 1) = new(result_index)
end

"""
    ObjectiveBound()

An [`AbstractModelAttribute`](@ref) for the best known bound on the optimal objective value.
"""
struct ObjectiveBound <: AbstractModelAttribute end

"""
    RelativeGap()

An [`AbstractModelAttribute`](@ref) for the final relative optimality gap.

!!! warning
    The definition of this gap is solver-dependent. However, most solvers
    implementing this attribute define the relative gap as some variation of
    ``\\frac{|b-f|}{|f|}``, where ``b`` is the best bound and ``f`` is the best
    feasible objective value.
"""
struct RelativeGap <: AbstractModelAttribute end

attribute_value_type(::RelativeGap) = Float64

"""
    SolveTimeSec()

An [`AbstractModelAttribute`](@ref) for the total elapsed solution time (in seconds) as reported
by the optimizer.
"""
struct SolveTimeSec <: AbstractModelAttribute end

attribute_value_type(::SolveTimeSec) = Float64

"""
    SimplexIterations()

An [`AbstractModelAttribute`](@ref) for the cumulative number of simplex
iterations while solving a problem.

For a mixed-integer program (MIP), the return value is the total simplex
iterations for all nodes.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.SimplexIterations)::Int64
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct SimplexIterations <: AbstractModelAttribute end

attribute_value_type(::SimplexIterations) = Int64

"""
    BarrierIterations()

An [`AbstractModelAttribute`](@ref) for the cumulative number of barrier
iterations while solving a problem.

For a mixed-integer program (MIP), the return value is the total barrier
iterations for all nodes.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.BarrierIterations)::Int64
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct BarrierIterations <: AbstractModelAttribute end

attribute_value_type(::BarrierIterations) = Int64

"""
    NodeCount()

An [`AbstractModelAttribute`](@ref) for the total number of branch-and-bound
nodes explored while solving a mixed-integer program (MIP).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.NodeCount)::Int64
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct NodeCount <: AbstractModelAttribute end

attribute_value_type(::NodeCount) = Int64

"""
    RawSolver()

An [`AbstractModelAttribute`](@ref) for the object that may be used to access a
solver-specific API for this optimizer.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.RawSolver)::Any
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct RawSolver <: AbstractModelAttribute end

"""
    ResultCount()

An [`AbstractModelAttribute`](@ref) for the number of results available.

## Order of solutions

A number of attributes contain an index, `result_index`, which is used to refer
to one of the available results. Thus, `result_index` must be an integer between
`1` and the number of available results.

As a general rule, the first result (`result_index = 1`) is the most important
result (for example, an optimal solution or an infeasibility certificate). Other
results will typically be alternate solutions that the solver found during the
search for the first result.

If a (local) optimal solution is available, that is, [`TerminationStatus`](@ref)
is [`OPTIMAL`](@ref) or [`LOCALLY_SOLVED`](@ref), the first result must
correspond to the (locally) optimal solution. Other results may be alternative
optimal solutions, or they may be other suboptimal solutions; use
[`ObjectiveValue`](@ref) to distinguish between them.

If a primal or dual infeasibility certificate is available, that is,
[`TerminationStatus`](@ref) is [`INFEASIBLE`](@ref) or [`DUAL_INFEASIBLE`](@ref)
and the corresponding [`PrimalStatus`](@ref) or [`DualStatus`](@ref) is
[`INFEASIBILITY_CERTIFICATE`](@ref), then the first result must be a certificate.
Other results may be alternate certificates, or infeasible points.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.ResultCount)::Int
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ResultCount <: AbstractModelAttribute end

attribute_value_type(::ResultCount) = Int

@_documented_enum(
    """
        ConflictStatusCode

    An Enum of possible values for the [`ConflictStatus`](@ref) attribute.

    This attribute is meant to explain the reason why the conflict finder
    stopped executing in the most recent call to [`compute_conflict!`](@ref).
    """,
    ConflictStatusCode,
    """
    The function [`compute_conflict!`](@ref) has not yet been called.
    """,
    COMPUTE_CONFLICT_NOT_CALLED,
    "There is no conflict because the problem is feasible.",
    NO_CONFLICT_EXISTS,
    "The solver could not find a conflict.",
    NO_CONFLICT_FOUND,
    "The solver found a conflict.",
    CONFLICT_FOUND,
)

"""
    ConflictStatus()

An [`AbstractModelAttribute`](@ref) for the [`ConflictStatusCode`](@ref)
explaining why [`compute_conflict!`] stopped when computing the conflict.

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.ConflictStatus)::MOI.ConflictStatusCode
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ConflictStatus <: AbstractModelAttribute end

attribute_value_type(::ConflictStatus) = ConflictStatusCode

"""
    ConflictCount()

An [`AbstractModelAttribute`](@ref) for the number of conflicts found by the
solver in the most recent call to [`compute_conflict!`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.ConflictCount)::Int
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ConflictCount <: AbstractModelAttribute end

attribute_value_type(::ConflictCount) = Int

"""
    ListOfVariableAttributesSet()

An [`AbstractModelAttribute`](@ref) for the `Vector{AbstractVariableAttribute}`
of all variable attributes `attr` such that:

 1. `is_copyable(attr)` returns `true`
 2. the attribute was set for at least one variable in the model

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ListOfVariableAttributesSet,
)::Vector{MOI.AbstractVariableAttribute}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ListOfVariableAttributesSet <: AbstractModelAttribute end

"""
    ListOfVariablesWithAttributeSet(attr::AbstractVariableAttribute)

An [`AbstractModelAttribute`](@ref) for the `Vector{MOI.VariableIndex}` of all
variables with the attribute `attr` set.

The returned list may not be minimal, so some elements may have their default
value set.

## Note

This is an optional attribute to implement. The default fallback is to get
[`ListOfVariableIndices`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ListOfVariablesWithAttributeSet{<:MOI.AbstractVariableAttribute},
)::Vector{MOI.VarialbeIndex}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ListOfVariablesWithAttributeSet{A} <: AbstractModelAttribute
    attr::A
    function ListOfVariablesWithAttributeSet(attr::AbstractVariableAttribute)
        return new{typeof(attr)}(attr)
    end
end

function get_fallback(model::ModelLike, ::ListOfVariablesWithAttributeSet)
    return get(model, ListOfVariableIndices())
end

"""
    VariableName()

An [`AbstractVariableAttribute`](@ref) for a `String` identifying the variable.

The default name is `""` if not set by the user.

## Duplicate names

Two variables may have the same name; however, variables with duplicate names
cannot be looked up using [`get`](@ref).

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> MOI.supports(model, MOI.VariableName(), MOI.VariableIndex)
true

julia> MOI.get(model, MOI.VariableName(), x)
""

julia> MOI.set(model, MOI.VariableName(), x, "x")

julia> MOI.get(model, MOI.VariableName(), x)
"x"
```

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.VariableName, ::MOI.VariableIndex)::String
MOI.set(::Optimizer, ::MOI.VariableName, ::MOI.VariableIndex, ::String)::Nothing
MOI.supports(::Optimizer, ::MOI.VariableName, ::Type{MOI.VariableIndex})::Bool
```
"""
struct VariableName <: AbstractVariableAttribute end

attribute_value_type(::VariableName) = String

"""
    VariablePrimalStart()

An [`AbstractVariableAttribute`](@ref) for the initial assignment to the
variable's primal value that the optimizer may use to warm-start the solve.

May be a number or `nothing` (unset).

## Example

```jldoctest
julia> model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}());

julia> x = MOI.add_variable(model);

julia> MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
true

julia> MOI.get(model, MOI.VariablePrimalStart(), x)

julia> MOI.set(model, MOI.VariablePrimalStart(), x, 1.0)

julia> MOI.get(model, MOI.VariablePrimalStart(), x)
1.0
```

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.VariablePrimalStart, ::MOI.VariableIndex)::Union{Nothing,T}
MOI.set(::Optimizer, ::MOI.VariablePrimalStart, ::MOI.VariableIndex, ::Union{Nothing,T})::Nothing
MOI.supports(::Optimizer, ::MOI.VariablePrimalStart, ::Type{MOI.VariableIndex})::Bool
```
"""
struct VariablePrimalStart <: AbstractVariableAttribute end

"""
    VariablePrimal(result_index::Int = 1)

An [`AbstractVariableAttribute`](@ref) for the variable's primal value in result
`result_index`.

## PrimalStatus

Before quering this attribute you should first check [`PrimalStatus`](@ref) to
confirm that a primal solution is avaiable.

If the [`PrimalStatus`](@ref) is [`NO_SOLUTION`](@ref) the result of querying
this attribute is undefined.

## `result_index`

The optimizer may return multiple primal solutions. See [`ResultCount`](@ref)
for information on how the results are ordered.

If the solver does not have a primal value for the variable because the
`result_index` is beyond the available solutions (whose number is indicated by
the [`ResultCount`](@ref) attribute), getting this attribute must throw a
[`ResultIndexBoundsError`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.VariablePrimal, ::MOI.VariableIndex)::T
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct VariablePrimal <: AbstractVariableAttribute
    result_index::Int
    VariablePrimal(result_index::Int = 1) = new(result_index)
end

"""
    CallbackVariablePrimal(callback_data)

An [`AbstractVariableAttribute`](@ref) for the assignment to the variable's
primal value during the callback identified by `callback_data`.
"""
struct CallbackVariablePrimal{CallbackDataType} <: AbstractVariableAttribute
    callback_data::CallbackDataType
end
is_set_by_optimize(::CallbackVariablePrimal) = true

@_documented_enum(
    """
        BasisStatusCode

    An Enum for the value of the [`ConstraintBasisStatus`](@ref) and
    [`VariableBasisStatus`](@ref) attributes, explaining the status of a given
    element with respect to an optimal solution basis.

    ## Notes

    When queried as part of [`ConstraintBasisStatus`](@ref), [`NONBASIC_AT_LOWER`](@ref)
    and [`NONBASIC_AT_UPPER`](@ref) should be returned only for constraints with
    the [`Interval`](@ref) set. In this case, they are necessary to distinguish
    which side of the constraint is active. One-sided constraints (for example,
    [`LessThan`](@ref) and [`GreaterThan`](@ref)) should use [`NONBASIC`](@ref)
    instead of the `NONBASIC_AT_*` values.

    This restriction does not apply to [`VariableBasisStatus`](@ref), which
    should return `NONBASIC_AT_*` regardless of whether the alternative bound
    exists.
    """,
    BasisStatusCode,
    "The element is in the basis.",
    BASIC,
    "The element is not in the basis.",
    NONBASIC,
    """
    The element is not in the basis and is at its lower bound.
    """,
    NONBASIC_AT_LOWER,
    """
    The element is not in the basis and is at its upper bound.
    """,
    NONBASIC_AT_UPPER,
    """
    The element is not in the basis but is also not at one of its bounds.

    In a linear program, this status occurs when a variable with no bounds is
    not in the basis, for example, because it takes the value `0.0`.
    """,
    SUPER_BASIC,
)

"""
    VariableBasisStatus(result_index::Int = 1)

An [`AbstractVariableAttribute`](@ref) for the [`BasisStatusCode`](@ref) of the
variable in result `result_index`, with respect to a basic solution.

## PrimalStatus

Before quering this attribute you should first check [`PrimalStatus`](@ref) to
confirm that a primal solution is avaiable.

If the [`PrimalStatus`](@ref) is [`NO_SOLUTION`](@ref) the result of querying
this attribute is undefined.

## `result_index`

The optimizer may return multiple primal solutions. See [`ResultCount`](@ref)
for information on how the results are ordered.

If the solver does not have a primal value for the variable because the
`result_index` is beyond the available solutions (whose number is indicated by
the [`ResultCount`](@ref) attribute), getting this attribute must throw a
[`ResultIndexBoundsError`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.VariableBasisStatus, ::MOI.VariableIndex)::MOI.BasisStatusCode
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct VariableBasisStatus <: AbstractVariableAttribute
    result_index::Int
    VariableBasisStatus(result_index::Int = 1) = new(result_index)
end

attribute_value_type(::VariableBasisStatus) = BasisStatusCode

"""
    ListOfConstraintAttributesSet{F, S}()

An [`AbstractModelAttribute`](@ref) for the `Vector{AbstractConstraintAttribute}` of all
constraint attributes `attr` such that:

 1. `is_copyable(attr)` returns `true` and
 2. the attribute was set to `F`-in-`S` constraints.

## Note

The attributes [`ConstraintFunction`](@ref) and [`ConstraintSet`](@ref) should
not be included in the list even if then have been set with [`set`](@ref).
"""
struct ListOfConstraintAttributesSet{F,S} <: AbstractModelAttribute end

"""
    ListOfConstraintsWithAttributeSet{F,S}(attr:AbstractConstraintAttribute)

An [`AbstractModelAttribute`](@ref) for the `Vector{ConstraintIndex{F,S}}` of all constraints with
the attribute `attr` set.

The returned list may not be minimal, so some elements may have their default
value set.

## Note

This is an optional attribute to implement. The default fallback is to get
[`ListOfConstraintIndices`](@ref).
"""
struct ListOfConstraintsWithAttributeSet{F,S,A} <: AbstractModelAttribute
    attr::A
    function ListOfConstraintsWithAttributeSet{F,S}(
        attr::AbstractConstraintAttribute,
    ) where {F,S}
        return new{F,S,typeof(attr)}(attr)
    end
end

function get_fallback(
    model::ModelLike,
    ::ListOfConstraintsWithAttributeSet{F,S},
) where {F,S}
    return get(model, ListOfConstraintIndices{F,S}())
end

"""
    ConstraintName()

An [`AbstractConstraintAttribute`](@ref) for a `String` identifying the
constraint.

The default name is `""` if not set by the user.

## Duplicate names

Two constraints may have the same name; however, constraints with duplicate
names cannot be looked up using [`get`](@ref), regardless of whether they have
the same `F`-in-`S` type.

## VariableIndex connstraints

You should _not_ implement [`ConstraintName`](@ref) for [`VariableIndex`](@ref)
constraints.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> c = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(1.0));

julia> MOI.supports(model, MOI.ConstraintName(), typeof(c))
true

julia> MOI.get(model, MOI.ConstraintName(), c)
""

julia> MOI.set(model, MOI.ConstraintName(), c, "c")

julia> MOI.get(model, MOI.ConstraintName(), c)
"c"

julia> MOI.get(model, MOI.ConstraintIndex, "c")
MathOptInterface.ConstraintIndex{MathOptInterface.ScalarAffineFunction{Float64}, MathOptInterface.EqualTo{Float64}}(1)

julia> F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64};

julia> MOI.get(model, MOI.ConstraintIndex{F,S}, "c")
MathOptInterface.ConstraintIndex{MathOptInterface.ScalarAffineFunction{Float64}, MathOptInterface.EqualTo{Float64}}(1)
```

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(::Optimizer, ::MOI.ConstraintName, ::MOI.ConstraintIndex)::String
MOI.set(::Optimizer, ::MOI.ConstraintName, ::MOI.ConstraintIndex, ::String)::Nothing
MOI.supports(::Optimizer, ::MOI.ConstraintName, ::Type{<:MOI.ConstraintIndex})::Bool
MOI.get(::Optimizer, ::MOI.ConstraintIndex, ::MOI.ConstraintIndex, ::String)::MOI.ConstraintIndex
```
"""
struct ConstraintName <: AbstractConstraintAttribute end

attribute_value_type(::ConstraintName) = String

"""
    VariableIndexConstraintNameError()

An error to be thrown when the user tries to set `ConstraintName` on a
`VariableIndex` constraint.
"""
function VariableIndexConstraintNameError()
    return UnsupportedAttribute(
        ConstraintName(),
        "`ConstraintName`s are not supported for `VariableIndex` constraints.",
    )
end

function supports_fallback(
    ::ModelLike,
    ::ConstraintName,
    ::Type{ConstraintIndex{VariableIndex,S}},
) where {S}
    return throw(VariableIndexConstraintNameError())
end

"""
    ConstraintPrimalStart()

An [`AbstractConstraintAttribute`](@ref) for the initial assignment to the
constraint's [`ConstraintPrimal`](@ref) that the optimizer may use to warm-start
the solve.

May be `nothing` (unset), a number for [`AbstractScalarFunction`](@ref), or a
vector for [`AbstractVectorFunction`](@ref).
"""
struct ConstraintPrimalStart <: AbstractConstraintAttribute end

"""
    ConstraintDualStart()

An [`AbstractConstraintAttribute`](@ref) for the initial assignment to the
constraint's [`ConstraintDual`](@ref) that the optimizer may use to warm-start
the solve.

May be `nothing` (unset), a number for [`AbstractScalarFunction`](@ref), or a
vector for [`AbstractVectorFunction`](@ref).
"""
struct ConstraintDualStart <: AbstractConstraintAttribute end

"""
    ConstraintPrimal(result_index::Int = 1)

An [`AbstractConstraintAttribute`](@ref) for the constraint's primal value in
result `result_index`.

## Definition

If the constraint is ``f(x) \\in S``, then in most cases the [`ConstraintPrimal`](@ref)
is the value of ``f``, evaluated at the corresponding [`VariablePrimal`](@ref)
solution.

However, some conic solvers reformulate ``b - Ax \\in S`` to ``s = b - Ax`` and
``s \\in S``. These solvers may return the value of `s` for [`ConstraintPrimal`](@ref),
rather than `b - Ax`. (Although these are constrained by an equality constraint,
due to numerical tolerances they may not be identical.)

## PrimalStatus

Before quering this attribute you should first check [`PrimalStatus`](@ref) to
confirm that a primal solution is avaiable.

If the [`PrimalStatus`](@ref) is [`NO_SOLUTION`](@ref) the result of querying
this attribute is undefined.

## `result_index`

The optimizer may return multiple primal solutions. See [`ResultCount`](@ref)
for information on how the results are ordered.

If the solver does not have a primal value for the constraint because the
`result_index` is beyond the available solutions (whose number is indicated by
the [`ResultCount`](@ref) attribute), getting this attribute must throw a
[`ResultIndexBoundsError`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ConstraintPrimal,
    ::MOI.ConstraintIndex{<:MOI.AbstractScalarFunction}
)::T
MOI.get(
    ::Optimizer,
    ::MOI.ConstraintPrimal,
    ::MOI.ConstraintIndex{<:MOI.AbstractVectorFunction}
)::Vector{T}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ConstraintPrimal <: AbstractConstraintAttribute
    result_index::Int
    ConstraintPrimal(result_index::Int = 1) = new(result_index)
end

"""
    ConstraintDual(result_index::Int = 1)

An [`AbstractConstraintAttribute`](@ref) for the constraint's dual value in
result `result_index`.

## DualStatus

Before quering this attribute you should first check [`DualStatus`](@ref) to
confirm that a dual solution is avaiable.

If the [`DualStatus`](@ref) is [`NO_SOLUTION`](@ref) the result of querying
this attribute is undefined.

## `result_index`

The optimizer may return multiple dual solutions. See [`ResultCount`](@ref)
for information on how the results are ordered.

If the solver does not have a dual value for the constraint because the
`result_index` is beyond the available solutions (whose number is indicated by
the [`ResultCount`](@ref) attribute), getting this attribute must throw a
[`ResultIndexBoundsError`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ConstraintDual,
    ::MOI.ConstraintIndex{<:MOI.AbstractScalarFunction}
)::T
MOI.get(
    ::Optimizer,
    ::MOI.ConstraintDual,
    ::MOI.ConstraintIndex{<:MOI.AbstractVectorFunction}
)::Vector{T}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ConstraintDual <: AbstractConstraintAttribute
    result_index::Int
    ConstraintDual(result_index::Int = 1) = new(result_index)
end

"""
    ConstraintBasisStatus(result_index::Int = 1)

An [`AbstractConstraintAttribute`](@ref) for the [`BasisStatusCode`](@ref) of
the constraint in result `result_index`, with respect to a basic solution.

If `result_index` is omitted, it is 1 by default.

If the solver does not have a basis status for the constraint because the
`result_index` is beyond the available solutions (whose number is indicated by
the [`ResultCount`](@ref) attribute), getting this attribute must throw a
[`ResultIndexBoundsError`](@ref). Otherwise, if the result is unavailable for
another reason (for instance, only a dual solution is available), the result is
undefined. Users should first check [`PrimalStatus`](@ref) before accessing the
`ConstraintBasisStatus` attribute.

See [`ResultCount`](@ref) for information on how the results are ordered.

## Notes

For the basis status of a variable, query [`VariableBasisStatus`](@ref).

`ConstraintBasisStatus` does not apply to `VariableIndex` constraints. You
can infer the basis status of a [`VariableIndex`](@ref) constraint by looking
at the result of [`VariableBasisStatus`](@ref).
"""
struct ConstraintBasisStatus <: AbstractConstraintAttribute
    result_index::Int
    ConstraintBasisStatus(result_index::Int = 1) = new(result_index)
end

attribute_value_type(::ConstraintBasisStatus) = BasisStatusCode

function get_fallback(
    ::ModelLike,
    ::ConstraintBasisStatus,
    ::ConstraintIndex{VariableIndex,<:AbstractScalarSet},
)
    return error(
        "Querying the basis status of a `VariableIndex` constraint is not ",
        "supported. Use [`VariableBasisStatus`](@ref) instead.",
    )
end

"""
    CanonicalConstraintFunction()

An [`AbstractConstraintAttribute`](@ref) for a canonical representation of the
[`AbstractFunction`](@ref) object used to define the constraint.

Getting this attribute is guaranteed to return a function that is equivalent but
not necessarily identical to the function provided by the user.

## Fallback

By default, `MOI.get(model, MOI.CanonicalConstraintFunction(), ci)` falls back
to `MOI.Utilities.canonical(MOI.get(model, MOI.ConstraintFunction(), ci))`.

However, if `model` knows that the constraint function is canonical then it can
implement a specialized method that directly return the function without calling
[`Utilities.canonical`](@ref). Therefore, the value returned **cannot** be
assumed to be a copy of the function stored in `model`.

Moreover, [`Utilities.Model`](@ref) checks with [`Utilities.is_canonical`](@ref)
whether the function stored internally is already canonical and if it's the case,
then it returns the function stored internally instead of a copy.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> c = MOI.add_constraint(model, 1.0 * x + 1.0 * x, MOI.GreaterThan(0.0));

julia> MOI.get(model, MOI.CanonicalConstraintFunction(), c)
0.0 + 2.0 MOI.VariableIndex(1)
```

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.CanonicalConstraintFunction,
    ::MOI.ConstraintIndex{F,S},
)::F where {F,S}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct CanonicalConstraintFunction <: AbstractConstraintAttribute end

attribute_value_type(::CanonicalConstraintFunction) = AbstractFunction

function get_fallback(
    model::ModelLike,
    ::CanonicalConstraintFunction,
    ci::ConstraintIndex,
)
    func = get(model, ConstraintFunction(), ci)
    # In `Utilities.AbstractModel` and `Utilities.UniversalFallback`,
    # the function is canonicalized in `add_constraint` so it might already
    # be canonical. In other models, the constraint might have been copied from
    # from one of these two model so there is in fact a good chance of the
    # function being canonical in any model type.
    # As `is_canonical` is quite cheap compared to `canonical` which
    # requires a copy and sorting the terms, it is worth checking.
    if Utilities.is_canonical(func)
        return func
    else
        return Utilities.canonical(func)
    end
end

"""
    ConstraintFunction()

An [`AbstractConstraintAttribute`](@ref) for the [`AbstractFunction`](@ref)
object used to define the constraint.

It is guaranteed to be equivalent but not necessarily identical to the function
provided by the user.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> c = MOI.add_constraint(model, 1.0 * x, MOI.GreaterThan(0.0));

julia> MOI.get(model, MOI.ConstraintFunction(), c)
0.0 + 1.0 MOI.VariableIndex(1)

julia> MOI.set(model, MOI.ConstraintFunction(), c, 2.0 * x)

julia> MOI.get(model, MOI.ConstraintFunction(), c)
0.0 + 2.0 MOI.VariableIndex(1)
```

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ConstraintFunction,
    ::MOI.ConstraintIndex{F,S},
)::F where {F,S}
```
If the optimizer supports modifying an existing function, it should implement:
```julia
MOI.set(
    ::Optimizer,
    ::MOI.ConstraintFunction,
    ::MOI.ConstraintIndex{F,S},
    ::F,
)::Nothing where {F,S}
```
It should not implement [`supports`](@ref).
"""
struct ConstraintFunction <: AbstractConstraintAttribute end

attribute_value_type(::ConstraintFunction) = AbstractFunction

struct FunctionTypeMismatch{F1,F2} <: Exception end

function Base.showerror(io::IO, err::FunctionTypeMismatch{F1,F2}) where {F1,F2}
    return print(
        io,
        """$(typeof(err)): Cannot modify functions of different types.
  Constraint type is $F1 while the replacement function is of type $F2.""",
    )
end

function throw_set_error_fallback(
    ::ModelLike,
    attr::ConstraintFunction,
    ::ConstraintIndex{F,S},
    ::F;
    error_if_supported = SetAttributeNotAllowed(attr),
) where {F<:AbstractFunction,S}
    return throw(error_if_supported)
end

func_type(::ConstraintIndex{F,S}) where {F,S} = F

function throw_set_error_fallback(
    ::ModelLike,
    ::ConstraintFunction,
    ci::ConstraintIndex,
    func::AbstractFunction;
    kwargs...,
)
    return throw(FunctionTypeMismatch{func_type(ci),typeof(func)}())
end

"""
    ConstraintSet()

An [`AbstractConstraintAttribute`](@ref) for the [`AbstractSet`](@ref) object
used to define the constraint.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> c = MOI.add_constraint(model, x, MOI.GreaterThan(0.0));

julia> MOI.get(model, MOI.ConstraintSet(), c)
MathOptInterface.GreaterThan{Float64}(0.0)

julia> MOI.set(model, MOI.ConstraintSet(), c, MOI.GreaterThan(1.0))

julia> MOI.get(model, MOI.ConstraintSet(), c)
MathOptInterface.GreaterThan{Float64}(1.0)
```

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ConstraintSet,
    ::MOI.ConstraintIndex{F,S},
)::S where {F,S}
```
If the optimizer supports modifying an existing set, it should implement:
```julia
MOI.set(
    ::Optimizer,
    ::MOI.ConstraintSet,
    ::MOI.ConstraintIndex{F,S},
    ::S,
)::Nothing where {F,S}
```
It should not implement [`supports`](@ref).
"""
struct ConstraintSet <: AbstractConstraintAttribute end

attribute_value_type(::ConstraintSet) = AbstractSet

struct SetTypeMismatch{S1,S2} <: Exception end

function Base.showerror(io::IO, err::SetTypeMismatch{S1,S2}) where {S1,S2}
    return print(
        io,
        """$(typeof(err)): Cannot modify sets of different types. Constraint
  type is $S1 while the replacement set is of type $S2. Use `transform`
  instead.""",
    )
end

function throw_set_error_fallback(
    ::ModelLike,
    attr::ConstraintSet,
    ::ConstraintIndex{F,S},
    ::S;
    error_if_supported = SetAttributeNotAllowed(attr),
) where {F,S<:AbstractSet}
    return throw(error_if_supported)
end

set_type(::ConstraintIndex{F,S}) where {F,S} = S

function throw_set_error_fallback(
    ::ModelLike,
    ::ConstraintSet,
    constraint_index::ConstraintIndex,
    set::AbstractSet;
    kwargs...,
)
    return throw(SetTypeMismatch{set_type(constraint_index),typeof(set)}())
end

@_documented_enum(
    """
        ConflictParticipationStatusCode

    An Enum for the value of the [`ConstraintConflictStatus`](@ref) attribute.

    This attribute is meant to indicate whether a given constraint participates
    or not in the last computed conflict.
    """,
    ConflictParticipationStatusCode,
    "The constraint does not participate in the conflict.",
    NOT_IN_CONFLICT,
    "The constraint participates in the conflict.",
    IN_CONFLICT,
    """
    The solver was not able to prove whether the constraint is required to
    participate in the conflict.
    """,
    MAYBE_IN_CONFLICT,
)

"""
    ConstraintConflictStatus(conflict_index = 1)

A constraint attribute to query the [`ConflictParticipationStatusCode`](@ref)
indicating whether the constraint participates in the conflict.

## `conflict_index`

The optimizer may return multiple conflicts. See [`ConflictCount`](@ref)
for querying the number of conflicts found.

If the solver does not have a conflict because the
`conflict_index` is beyond the available solutions (whose number is indicated by
the [`ConflictCount`](@ref) attribute), then
`MOI.check_result_index_bounds(model, ConstraintConflictStatus(conflict_index))`
will throw a [`ResultIndexBoundsError`](@ref).

## Implementation

Optimizers should implement the following methods:
```julia
MOI.get(
    ::Optimizer,
    ::MOI.ConstraintConflictStatus,
    ::MOI.ConstraintIndex,
)::ConflictParticipationStatusCode
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ConstraintConflictStatus <: AbstractConstraintAttribute
    conflict_index::Int
    ConstraintConflictStatus(conflict_index = 1) = new(conflict_index)
end

function attribute_value_type(::ConstraintConflictStatus)
    return ConflictParticipationStatusCode
end

"""
    UserDefinedFunction(name::Symbol, arity::Int) <: AbstractModelAttribute

Set this attribute to register a user-defined function by the name of `name`
with `arity` arguments.

Once registered, `name` will appear in [`ListOfSupportedNonlinearOperators`](@ref).

You cannot register multiple `UserDefinedFunction`s with the same `name` but
different `arity`.

## Value type

The value to be set is a tuple containing one, two, or three functions to
evaluate the function, the first-order derivative, and the second-order
derivative respectively. Both derivatives are optional, but if you pass the
second-order derivative you must also pass the first-order derivative.

For univariate functions with `arity == 1`, the functions in the tuple must
have the form:

 * `f(x::T)::T`: returns the value of the function at `x`
 * `∇f(x::T)::T`: returns the first-order derivative of `f` with respect to `x`
 * `∇²f(x::T)::T`: returns the second-order derivative of `f` with respect to
   `x`.

For multivariate functions with `arity > 1`, the functions in the tuple must
have the form:

 * `f(x::T...)::T`: returns the value of the function at `x`
 * `∇f(g::AbstractVector{T}, x::T...)::Nothing`: fills the components of `g`,
   with `g[i]` being the first-order partial derivative of `f` with respect to
   `x[i]`
 * `∇²f(H::AbstractMatrix{T}, x::T...)::Nothing`: fills the non-zero components
    of `H`, with `H[i, j]` being the second-order partial derivative of `f` with
    respect to `x[i]` and then `x[j]`. `H` is initialized to the zero matrix,
    so you do not need to set any zero elements.

## Example

```jldoctest
julia> f(x, y) = x^2 + y^2
f (generic function with 1 method)

julia> function ∇f(g, x, y)
           g .= 2 * x, 2 * y
           return
       end
∇f (generic function with 1 method)

julia> function ∇²f(H, x...)
           H[1, 1] = H[2, 2] = 2.0
           return
       end
∇²f (generic function with 1 method)

julia> model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}());

julia> MOI.set(model, MOI.UserDefinedFunction(:f, 2), (f,))

julia> MOI.set(model, MOI.UserDefinedFunction(:g, 2), (f, ∇f))

julia> MOI.set(model, MOI.UserDefinedFunction(:h, 2), (f, ∇f, ∇²f))

julia> x = MOI.add_variables(model, 2)
2-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)

julia> MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)

julia> obj_f = MOI.ScalarNonlinearFunction(:f, Any[x[1], x[2]])
f(MOI.VariableIndex(1), MOI.VariableIndex(2))

julia> MOI.set(model, MOI.ObjectiveFunction{typeof(obj_f)}(), obj_f)

julia> print(model)
Minimize ScalarNonlinearFunction:
 f(v[1], v[2])

Subject to:

```
"""
struct UserDefinedFunction <: AbstractModelAttribute
    name::Symbol
    arity::Int
end

"""
    ListOfSupportedNonlinearOperators() <: AbstractModelAttribute

When queried with [`get`](@ref), return a `Vector{Symbol}` listing the operators
supported by the model. These operators may appear in the `head` field of
[`ScalarNonlinearFunction`](@ref).

## Implementation

Optimizers should implement the following methods:
```
MOI.get(
    ::Optimizer,
    ::MOI.ListOfSupportedNonlinearOperators,
)::Vector{Symbol}
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct ListOfSupportedNonlinearOperators <: AbstractOptimizerAttribute end

@_documented_enum(
    """
        TerminationStatusCode

    An Enum of possible values for the [`TerminationStatus`](@ref) attribute.

    This attribute explains why the optimizer stopped executing in the most
    recent call to [`optimize!`](@ref).
    """,
    TerminationStatusCode,
    "The algorithm has not started.",
    OPTIMIZE_NOT_CALLED,
    # OK
    """
    The algorithm found a globally optimal solution.
    """,
    OPTIMAL,
    """
    The algorithm proved that no primal feasible solution exists.
    """,
    INFEASIBLE,
    """
    The algorithm proved that no dual feasible solution exists.

    To check if the primal problem is feasible, set the objective sense to
    [`FEASIBILITY_SENSE`](@ref) and re-solve the problem.

    If a primal feasible point does not exist, the original problem is both
    primal and dual infeasible.

    If a primal feasible solution exists, this status typically implies that the
    problem is unbounded, with some technical exceptions (for example, if the
    problem is a conic optimization problem in which strong duality does not
    hold).

    The technical exceptions do not apply to linear programs. The combination of
    [`DUAL_INFEASIBLE`](@ref) and a primal feasible point means that the primal
    linear program is unbounded.
    """,
    DUAL_INFEASIBLE,
    """
    The algorithm converged to a stationary point, local optimal solution, could
    not find directions for improvement, or otherwise completed its search
    without global guarantees.
    """,
    LOCALLY_SOLVED,
    """
    The algorithm converged to an infeasible point or otherwise completed its
    search without finding a feasible solution, without guarantees that no
    feasible solution exists.

    If you know a primal feasible solution exists, use
    [`VariablePrimalStart`](@ref) to provide a feasible starting point to the
    solver.
    """,
    LOCALLY_INFEASIBLE,
    """
    The algorithm stopped because it proved that the problem is infeasible or
    unbounded, without distinguishing between the two cases.

    To distinguish between the two cases, set the objective sense to
    [`FEASIBILITY_SENSE`](@ref) and re-solve the problem. If a primal feasible
    point exists, the original problem is unbounded. If a primal feasible point
    does not exist, the original problem is infeasible.
    """,
    INFEASIBLE_OR_UNBOUNDED,
    # Solved to relaxed tolerances
    "The algorithm found a globally optimal solution to relaxed tolerances.",
    ALMOST_OPTIMAL,
    """
    The algorithm concluded that no feasible solution exists within relaxed
    tolerances.
    """,
    ALMOST_INFEASIBLE,
    """
    The algorithm concluded that no dual bound exists for the problem within
    relaxed tolerances.
    """,
    ALMOST_DUAL_INFEASIBLE,
    """
    The algorithm converged to a stationary point, local optimal solution, or
    could not find directions for improvement within relaxed tolerances.
    """,
    ALMOST_LOCALLY_SOLVED,
    # Limits
    """
    An iterative algorithm stopped after conducting the maximum number of
    iterations.
    """,
    ITERATION_LIMIT,
    """
    The algorithm stopped after a user-specified computation time.

    This status may be returned in relation to the [`TimeLimitSec`](@ref)
    attribute, or some other solver-specific attribute.
    """,
    TIME_LIMIT,
    """
    A branch-and-bound algorithm stopped because it explored a maximum number of
    nodes in the branch-and-bound tree.

    This status may be returned in relation to the [`NodeLimit`](@ref)
    attribute, or some other solver-specific attribute.
    """,
    NODE_LIMIT,
    """
    The algorithm stopped because it found the required number of solutions.
    This is often used in MIPs to get the solver to return the first feasible
    solution it encounters.

    This status may be returned in relation to the [`SolutionLimit`](@ref)
    attribute, or some other solver-specific attribute.
    """,
    SOLUTION_LIMIT,
    "The algorithm stopped because it ran out of memory.",
    MEMORY_LIMIT,
    """
    The algorithm stopped because it found a solution better than a minimum
    limit set by the user.

    This status may be returned in relation to the [`ObjectiveLimit`](@ref)
    attribute, or some other solver-specific attribute.
    """,
    OBJECTIVE_LIMIT,
    """
    The algorithm stopped because the norm of an iterate became too large.

    This typically means that the primal problem is unbounded, but that the
    solver could not prove so.
    """,
    NORM_LIMIT,
    """
    The algorithm stopped due to a limit not covered by one of the `_LIMIT_`
    statuses above.
    """,
    OTHER_LIMIT,
    # Problematic
    """
    The algorithm stopped because it was unable to continue making progress
    towards the solution.
    """,
    SLOW_PROGRESS,
    """
    The algorithm stopped because it encountered unrecoverable numerical error.
    """,
    NUMERICAL_ERROR,
    """
    The algorithm stopped because the model is invalid.

    The reason for this return code is solver-specific, but common causes are
    that the problem has zero variables or constraints, or that the problem data
    contains an invalid number such as `NaN`.
    """,
    INVALID_MODEL,
    """
    The algorithm stopped because it was provided an invalid option.
    """,
    INVALID_OPTION,
    """
    The algorithm stopped because of an interrupt signal.

    This typically means that the solver was interrupted by the user with
    `CTRL+C`.
    """,
    INTERRUPTED,
    """
    The algorithm stopped because of an error not covered by one of the statuses
    defined above. Check the solver log for further details.
    """,
    OTHER_ERROR,
)

"""
    AutomaticDifferentiationBackend() <: AbstractOptimizerAttribute

An [`AbstractOptimizerAttribute`](@ref) for setting the automatic
differentiation backend used by the solver.

The value must be a subtype of [`Nonlinear.AbstractAutomaticDifferentiation`](@ref).

## Implementation

Optimizers should implement the following methods:
```
MOI.get(
    ::Optimizer,
    ::MOI.AutomaticDifferentiationBackend,
)::MOI.Nonlinear.AbstractAutomaticDifferentiation
MOI.set(
    ::Optimizer,
    ::MOI.AutomaticDifferentiationBackend,
    ::MOI.Nonlinear.AbstractAutomaticDifferentiation,
)::Nothing
MOI.supports(::Optimizer, ::MOI.AutomaticDifferentiationBackend)::Bool
```
"""
struct AutomaticDifferentiationBackend <: AbstractOptimizerAttribute end

function attribute_value_type(::AutomaticDifferentiationBackend)
    return Nonlinear.AbstractAutomaticDifferentiation
end

"""
    TerminationStatus()

An [`AbstractModelAttribute`](@ref) for the [`TerminationStatusCode`](@ref)
explaining why the optimizer stopped.

## Implementation

Optimizers should implement the following methods:
```
MOI.get(::Optimizer, ::MOI.TerminationStatus)::MOI.TerminationStatusCode
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct TerminationStatus <: AbstractModelAttribute end

attribute_value_type(::TerminationStatus) = TerminationStatusCode

"""
    RawStatusString()

An [`AbstractModelAttribute`](@ref) for a solver specific string explaining why
the optimizer stopped.

## Implementation

Optimizers should implement the following methods:
```
MOI.get(::Optimizer, ::MOI.RawStatusString)::MOI.String
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct RawStatusString <: AbstractModelAttribute end

attribute_value_type(::RawStatusString) = String

@_documented_enum(
    """
        ResultStatusCode

    An Enum of possible values for the [`PrimalStatus`](@ref) and
    [`DualStatus`](@ref) attributes.

    The values indicate how to interpret the result vector.
    """,
    ResultStatusCode,
    "The result vector is empty.",
    NO_SOLUTION,
    "The result vector is a feasible point.",
    FEASIBLE_POINT,
    "The result vector is feasible if some constraint tolerances are relaxed.",
    NEARLY_FEASIBLE_POINT,
    "The result vector is an infeasible point.",
    INFEASIBLE_POINT,
    """
    The result vector is an infeasibility certificate.

    If the [`PrimalStatus`](@ref) is [`INFEASIBILITY_CERTIFICATE`](@ref), then
    the primal result vector is a certificate of dual infeasibility.

    If the [`DualStatus`](@ref) is [`INFEASIBILITY_CERTIFICATE`](@ref), then the
    dual result vector is a proof of primal infeasibility.
    """,
    INFEASIBILITY_CERTIFICATE,
    """
    The result satisfies a relaxed criterion for a certificate of infeasibility.

    If the [`PrimalStatus`](@ref) is [`NEARLY_INFEASIBILITY_CERTIFICATE`](@ref),
    then the primal result vector is a certificate of dual infeasibility.

    If the [`DualStatus`](@ref) is [`NEARLY_INFEASIBILITY_CERTIFICATE`](@ref),
    then the dual result vector is a proof of primal infeasibility.
    """,
    NEARLY_INFEASIBILITY_CERTIFICATE,
    """
    The result vector is an ill-posed certificate; see [this article](https://arxiv.org/abs/1408.4685)
    for details.

    If the [`PrimalStatus`](@ref) is [`REDUCTION_CERTIFICATE`](@ref), then the
    primal result vector is a proof that the dual problem is ill-posed.

    If the [`DualStatus`](@ref) is [`REDUCTION_CERTIFICATE`](@ref), then the
    dual result vector is a proof that the primal is ill-posed.
    """,
    REDUCTION_CERTIFICATE,
    """
    The result satisfies a relaxed criterion for an ill-posed certificate.
    """,
    NEARLY_REDUCTION_CERTIFICATE,
    """
    The result vector contains a solution with an unknown interpretation. Check
    the solver log for more details.
    """,
    UNKNOWN_RESULT_STATUS,
    """
    The result vector contains a solution with an interpretation not covered by
    one of the statuses defined above. Check the solver log for more details.
    """,
    OTHER_RESULT_STATUS,
)

"""
    PrimalStatus(result_index::Int = 1)

An [`AbstractModelAttribute`](@ref) for the [`ResultStatusCode`](@ref) of the
primal result `result_index`.

## `result_index`

If `result_index` is omitted, it defaults to 1.

See [`ResultCount`](@ref) for information on how the results are ordered.

If `result_index` is larger than the value of [`ResultCount`](@ref) then
[`NO_SOLUTION`](@ref) is returned.

## Implementation

Optimizers should implement the following methods:
```
MOI.get(::Optimizer, ::MOI.PrimalStatus)::MOI.ResultStatusCode
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct PrimalStatus <: AbstractModelAttribute
    result_index::Int
    PrimalStatus(result_index::Int = 1) = new(result_index)
end

attribute_value_type(::PrimalStatus) = ResultStatusCode

"""
    DualStatus(result_index::Int = 1)

An [`AbstractModelAttribute`](@ref) for the [`ResultStatusCode`](@ref) of the
dual result `result_index`.

## `result_index`

See [`ResultCount`](@ref) for information on how the results are ordered.

If `result_index` is larger than the value of [`ResultCount`](@ref) then
[`NO_SOLUTION`](@ref) is returned.

## Implementation

Optimizers should implement the following methods:
```
MOI.get(::Optimizer, ::MOI.PrimalStatus)::MOI.ResultStatusCode
```
They should not implement [`set`](@ref) or [`supports`](@ref).
"""
struct DualStatus <: AbstractModelAttribute
    result_index::Int
    DualStatus(result_index::Int = 1) = new(result_index)
end

attribute_value_type(::DualStatus) = ResultStatusCode

# Cost of bridging constrained variable in S
struct VariableBridgingCost{S<:AbstractSet} <: AbstractModelAttribute end

attribute_value_type(::VariableBridgingCost) = Float64

function get_fallback(
    model::ModelLike,
    ::VariableBridgingCost{S},
) where {S<:AbstractScalarSet}
    return supports_add_constrained_variable(model, S) ? 0.0 : Inf
end

function get_fallback(
    model::ModelLike,
    ::VariableBridgingCost{S},
) where {S<:AbstractVectorSet}
    return supports_add_constrained_variables(model, S) ? 0.0 : Inf
end

# Cost of bridging F-in-S constraints
struct ConstraintBridgingCost{F<:AbstractFunction,S<:AbstractSet} <:
       AbstractModelAttribute end

attribute_value_type(::ConstraintBridgingCost) = Float64

function get_fallback(
    model::ModelLike,
    ::ConstraintBridgingCost{F,S},
) where {F<:AbstractFunction,S<:AbstractSet}
    return supports_constraint(model, F, S) ? 0.0 : Inf
end

"""
    LagrangeMultiplier(result_index::Int = 1)

An [`AbstractConstraintAttribute`](@ref) for the Lagrange multiplier associated
with a constraint.

## Relationship to `ConstraintDual`

This attribute differs from [`ConstraintDual`](@ref) in one important case.
When there is a [`VectorNonlinearOracle`](@ref) constraint of the form:
```math
x \\in VectorNonlinearOracle
```
the associated [`ConstraintDual`](@ref) is ``\\mu^\\top \\nabla f(x)``, and the
value of [`LagrangeMultiplier`](@ref) is the vector ``\\mu`` directly.

Both values are useful in different circumstances.

## DualStatus

Before quering this attribute you should first check [`DualStatus`](@ref) to
confirm that a dual solution is avaiable.

If the [`DualStatus`](@ref) is [`NO_SOLUTION`](@ref) the result of querying
this attribute is undefined.

## `result_index`

The optimizer may return multiple dual solutions. See [`ResultCount`](@ref)
for information on how the results are ordered.

If the solver does not have a dual value for the constraint because the
`result_index` is beyond the available solutions (whose number is indicated by
the [`ResultCount`](@ref) attribute), getting this attribute must throw a
[`ResultIndexBoundsError`](@ref).

## Implementation

Optimizers should implement the following methods:
```
MOI.get(::Optimizer, ::MOI.LagrangeMultiplier, ::MOI.ConstraintIndex)
```
They should not implement [`set`](@ref) or [`supports`](@ref).

Solvers should implement [`LagrangeMultiplier`](@ref) only if they also
implement the [`ConstraintDual`](@ref), and only if the two values are
different.
"""
struct LagrangeMultiplier <: AbstractConstraintAttribute
    result_index::Int

    LagrangeMultiplier(result_index::Int = 1) = new(result_index)
end

"""
    LagrangeMultiplierStart()

An [`AbstractConstraintAttribute`](@ref) for the initial assignment to the
constraint's [`LagrangeMultiplier`](@ref) that the optimizer may use to
warm-start the solve.

May be `nothing` (unset), a number for [`AbstractScalarFunction`](@ref), or a
vector for [`AbstractVectorFunction`](@ref).
"""
struct LagrangeMultiplierStart <: AbstractConstraintAttribute end

"""
    is_set_by_optimize(::AnyAttribute)

Return a `Bool` indicating whether the value of the attribute is set during an
[`optimize!`](@ref) call, that is, the attribute is used to query the result of
the optimization.

If an attribute can be set by the user, define [`is_copyable`](@ref) instead.

An attribute cannot be both [`is_copyable`](@ref) and
[`is_set_by_optimize`](@ref).

## Default fallback

This function returns `false` by default so it should be implemented for
attributes that are set by [`optimize!`](@ref).

## Undefined behavior

Querying the value of the attribute that [`is_set_by_optimize`](@ref) before a
call to [`optimize!`](@ref) is undefined and depends on solver-specific behavior.

## Example

```jldoctest
julia> MOI.is_set_by_optimize(MOI.ObjectiveValue())
true

julia> MOI.is_set_by_optimize(MOI.VariableName())
false
```
"""
is_set_by_optimize(::AnyAttribute) = false

function is_set_by_optimize(
    ::Union{
        ObjectiveValue,
        DualObjectiveValue,
        ObjectiveBound,
        RelativeGap,
        SolveTimeSec,
        SimplexIterations,
        BarrierIterations,
        NodeCount,
        RawSolver,
        ResultCount,
        ConflictStatus,
        ConflictCount,
        ConstraintConflictStatus,
        TerminationStatus,
        RawStatusString,
        PrimalStatus,
        DualStatus,
        VariablePrimal,
        ConstraintPrimal,
        ConstraintDual,
        ConstraintBasisStatus,
        VariableBasisStatus,
        LagrangeMultiplier,
    },
)
    return true
end

"""
    is_copyable(::AnyAttribute)

Return a `Bool` indicating whether the value of the attribute may be copied
during [`copy_to`](@ref) using [`set`](@ref).

If an attribute `is_copyable`, then it cannot be modified by the optimizer, and
[`get`](@ref) must always return the value that was [`set`](@ref) by the user.

If an attribute is the result of an optimization, define
[`is_set_by_optimize`](@ref) instead.

An attribute cannot be both [`is_set_by_optimize`](@ref) and `is_copyable`.

## Default fallback

By default `is_copyable(attr)` returns `!is_set_by_optimize(attr)`, which is
most probably `true`.

If an attribute should not be copied, define `is_copyable(::MyAttribute) = false`.
"""
function is_copyable(attr::AnyAttribute)
    return !is_set_by_optimize(attr)
end

function is_copyable(
    ::Union{
        ListOfOptimizerAttributesSet,
        ListOfModelAttributesSet,
        ListOfConstraintAttributesSet,
        ListOfVariableAttributesSet,
        SolverName,
        RawSolver,
        NumberOfVariables,
        ListOfVariableIndices,
        NumberOfConstraints,
        ObjectiveFunctionType,
        ListOfConstraintIndices,
        ListOfConstraintTypesPresent,
        CanonicalConstraintFunction,
        ConstraintFunction,
        ConstraintSet,
        VariableBridgingCost,
        ConstraintBridgingCost,
    },
)
    return false
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

struct _SubexpressionStorage
    nodes::Vector{Nonlinear.Node}
    adj::SparseArrays.SparseMatrixCSC{Bool,Int}
    const_values::Vector{Float64}
    forward_storage::Vector{Float64}
    partials_storage::Vector{Float64}
    reverse_storage::Vector{Float64}
    partials_storage_ϵ::Vector{Float64}
    linearity::Linearity

    function _SubexpressionStorage(
        expr::Nonlinear.Expression,
        subexpression_linearity,
        moi_index_to_consecutive_index,
        want_hess::Bool,
    )
        nodes =
            _replace_moi_variables(expr.nodes, moi_index_to_consecutive_index)
        adj = Nonlinear.adjacency_matrix(nodes)
        N = length(nodes)
        linearity = if want_hess
            _classify_linearity(nodes, adj, subexpression_linearity)[1]
        else
            NONLINEAR
        end
        return new(
            nodes,
            adj,
            expr.values,
            zeros(N),  # forward_storage,
            zeros(N),  # partials_storage,
            zeros(N),  # reverse_storage,
            Float64[],
            linearity,
        )
    end
end

struct _FunctionStorage
    nodes::Vector{Nonlinear.Node}
    adj::SparseArrays.SparseMatrixCSC{Bool,Int}
    const_values::Vector{Float64}
    forward_storage::Vector{Float64}
    partials_storage::Vector{Float64}
    reverse_storage::Vector{Float64}
    grad_sparsity::Vector{Int}
    # Nonzero pattern of Hessian matrix
    hess_I::Vector{Int}
    hess_J::Vector{Int}
    rinfo::Coloring.RecoveryInfo # coloring info for hessians
    seed_matrix::Matrix{Float64}
    linearity::Linearity
    # subexpressions which this function depends on, ordered for forward pass.
    dependent_subexpressions::Vector{Int}

    function _FunctionStorage(
        nodes::Vector{Nonlinear.Node},
        const_values,
        num_variables,
        coloring_storage::Coloring.IndexedSet,
        want_hess::Bool,
        subexpressions::Vector{_SubexpressionStorage},
        dependent_subexpressions,
        subexpression_linearity,
        subexpression_edgelist,
        subexpression_variables,
        moi_index_to_consecutive_index,
    )
        nodes = _replace_moi_variables(nodes, moi_index_to_consecutive_index)
        adj = Nonlinear.adjacency_matrix(nodes)
        N = length(nodes)
        empty!(coloring_storage)
        _compute_gradient_sparsity!(coloring_storage, nodes)
        for k in dependent_subexpressions
            _compute_gradient_sparsity!(
                coloring_storage,
                subexpressions[k].nodes,
            )
        end
        grad_sparsity = sort!(collect(coloring_storage))
        empty!(coloring_storage)
        if want_hess
            linearity = _classify_linearity(nodes, adj, subexpression_linearity)
            edgelist = _compute_hessian_sparsity(
                nodes,
                adj,
                linearity,
                subexpression_edgelist,
                subexpression_variables,
            )
            hess_I, hess_J, rinfo = Coloring.hessian_color_preprocess(
                edgelist,
                num_variables,
                coloring_storage,
            )
            seed_matrix = Coloring.seed_matrix(rinfo)
            return new(
                nodes,
                adj,
                const_values,
                zeros(N),  # forward_storage,
                zeros(N),  # partials_storage,
                zeros(N),  # reverse_storage,
                grad_sparsity,
                hess_I,
                hess_J,
                rinfo,
                seed_matrix,
                linearity[1],
                dependent_subexpressions,
            )
        else
            return new(
                nodes,
                adj,
                const_values,
                zeros(N),  # forward_storage,
                zeros(N),  # partials_storage,
                zeros(N),  # reverse_storage,
                grad_sparsity,
                Int[],
                Int[],
                Coloring.RecoveryInfo(),
                Array{Float64}(undef, 0, 0),
                NONLINEAR,
                dependent_subexpressions,
            )
        end
    end
end

"""
    NLPEvaluator(
        model::Nonlinear.Model,
        ordered_variables::Vector{MOI.VariableIndex},
    )

Return an `NLPEvaluator` object that implements the `MOI.AbstractNLPEvaluator`
interface.

!!! warning
    Before using, you must initialize the evaluator using `MOI.initialize`.
"""
mutable struct NLPEvaluator <: MOI.AbstractNLPEvaluator
    data::Nonlinear.Model
    ordered_variables::Vector{MOI.VariableIndex}

    objective::Union{Nothing,_FunctionStorage}
    constraints::Vector{_FunctionStorage}
    subexpressions::Vector{_SubexpressionStorage}
    subexpression_order::Vector{Int}
    # Storage for the subexpressions in reverse-mode automatic differentiation.
    subexpression_forward_values::Vector{Float64}
    subexpression_reverse_values::Vector{Float64}
    subexpression_linearity::Vector{Linearity}

    # A cache of the last x. This is used to guide whether we need to re-run
    # reverse-mode automatic differentiation.
    last_x::Vector{Float64}

    # Temporary storage for computing Jacobians. This is also used as temporary
    # storage for the input of multivariate functions.
    jac_storage::Vector{Float64}
    # Temporary storage for the gradient of multivariate functions
    user_output_buffer::Vector{Float64}

    # storage for computing hessians
    # these Float64 vectors are reinterpreted to hold multiple epsilon components
    # so the length should be multiplied by the maximum number of epsilon components
    disable_2ndorder::Bool # don't offer Hess or HessVec
    want_hess::Bool
    partials_storage_ϵ::Vector{Float64} # (longest expression excluding subexpressions)
    storage_ϵ::Vector{Float64} # (longest expression including subexpressions)
    input_ϵ::Vector{Float64} # (number of variables)
    output_ϵ::Vector{Float64} # (number of variables)
    subexpression_forward_values_ϵ::Vector{Float64} # (number of subexpressions)
    subexpression_reverse_values_ϵ::Vector{Float64} # (number of subexpressions)
    hessian_sparsity::Vector{Tuple{Int64,Int64}}
    max_chunk::Int # chunk size for which we've allocated storage

    function NLPEvaluator(
        data::Nonlinear.Model,
        ordered_variables::Vector{MOI.VariableIndex},
    )
        return new(data, ordered_variables)
    end
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SOCtoRSOCBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`SOCtoRSOCBridge` implements the following reformulation:

  * ``||x||_2 \\le t`` into ``(t+x_1)(t-x_1)\\ge ||(x_2\\ldots,x_N)||_2^2``

## Assumptions

  * `SOCtoRSOCBridge` assumes that the length of `x` is at least one.

## Source node

`SOCtoRSOCBridge` supports:

  * `G` in [`MOI.SecondOrderCone`](@ref)

## Target node

`SOCtoRSOCBridge` creates:

  * `F` in [`MOI.RotatedSecondOrderCone`](@ref)
"""
struct SOCtoRSOCBridge{T,F,G} <:
       SetMapBridge{T,MOI.RotatedSecondOrderCone,MOI.SecondOrderCone,F,G}
    constraint::MOI.ConstraintIndex{F,MOI.RotatedSecondOrderCone}
end

const SOCR{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{SOCtoRSOCBridge{T},OT}

function concrete_bridge_type(
    ::Type{<:SOCtoRSOCBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.SecondOrderCone},
) where {T}
    S = MOI.Utilities.promote_operation(/, T, MOI.Utilities.scalar_type(G), T)
    Y = MOI.Utilities.promote_operation(-, T, S, S)
    Z = MOI.Utilities.promote_operation(+, T, S, S)
    F = MOI.Utilities.promote_operation(vcat, T, Z, Y, G)
    return SOCtoRSOCBridge{T,F,G}
end

function MOI.Bridges.map_set(
    ::Type{<:SOCtoRSOCBridge},
    set::MOI.SecondOrderCone,
)
    return MOI.RotatedSecondOrderCone(MOI.dimension(set))
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:SOCtoRSOCBridge},
    set::MOI.RotatedSecondOrderCone,
)
    return MOI.SecondOrderCone(MOI.dimension(set))
end

function MOI.Bridges.map_function(::Type{<:SOCtoRSOCBridge{T}}, func) where {T}
    scalars = MOI.Utilities.eachscalar(func)
    if length(scalars) < 2
        err = DimensionMismatch(
            "Unable to reformulate a `SecondOrderCone` into a " *
            "`RotatedSecondOrderCone` because the output dimension is too " *
            "small",
        )
        throw(err)
    end
    t, u, x = scalars[1], scalars[2], scalars[3:end]
    ts = MOI.Utilities.operate!(/, T, t, sqrt(T(2)))
    us = MOI.Utilities.operate!(/, T, u, sqrt(T(2)))
    return MOI.Utilities.operate(
        vcat,
        T,
        MOI.Utilities.operate(+, T, ts, us),
        MOI.Utilities.operate(-, T, ts, us),
        x,
    )
end

# The map is an involution
function MOI.Bridges.inverse_map_function(BT::Type{<:SOCtoRSOCBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is symmetric
function MOI.Bridges.adjoint_map_function(BT::Type{<:SOCtoRSOCBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is a symmetric involution
function MOI.Bridges.inverse_adjoint_map_function(
    BT::Type{<:SOCtoRSOCBridge},
    func,
)
    return MOI.Bridges.map_function(BT, func)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSplitComplexIndicatorEqualTo

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitComplexIndicatorEqualToBridge,
        """
        variables: x, z
        ::Complex{Float64}: [z, (1.0 + 2.0im) * x] in Indicator{ACTIVATE_ON_ONE}(EqualTo(3.0 + 4.0im))
        z in ZeroOne()
        """,
        """
        variables: x, z
        ::Float64: [z, 1.0 * x] in Indicator{ACTIVATE_ON_ONE}(EqualTo(3.0))
        ::Float64: [z, 2.0 * x] in Indicator{ACTIVATE_ON_ONE}(EqualTo(4.0))
        z in ZeroOne()
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitComplexIndicatorEqualToBridge,
        """
        variables: x, z
        ::Complex{Float64}: [z, (1.0 + 2.0im) * x] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(3.0 + 4.0im))
        z in ZeroOne()
        """,
        """
        variables: x, z
        ::Float64: [z, 1.0 * x] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(3.0))
        ::Float64: [z, 2.0 * x] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(4.0))
        z in ZeroOne()
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitComplexIndicatorEqualToBridge,
        """
        variables: x, z
        ::Complex{Float64}: [z, (0.0 + 2.0im) * x] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(0.0 + 4.0im))
        z in ZeroOne()
        """,
        """
        variables: x, z
        ::Float64: [z, 2.0 * x] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(4.0))
        z in ZeroOne()
        """;
        constraint_start = [1.0, 0.0 + 1.2im],
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitComplexIndicatorEqualToBridge,
        """
        variables: x, z
        ::Complex{Float64}: [z, (1.0 + 0.0im) * x] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(3.0 + 0.0im))
        z in ZeroOne()
        """,
        """
        variables: x, z
        ::Float64: [z, 1.0 * x] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(3.0))
        z in ZeroOne()
        """;
        constraint_start = [1.0, 1.2 + 0.0im],
    )
    return
end

end  # module

TestConstraintSplitComplexIndicatorEqualTo.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

using Test

for file in readdir(@__DIR__)
    if file == "runtests.jl"
        continue
    end
    @testset "$(file)" begin
        include(file)
    end
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestObjectiveSlack

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_SlackBridge_ObjectiveSense_error()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], 1.2)
    attr = MOI.ObjectiveFunction{typeof(f)}()
    @test_throws(
        MOI.SetAttributeNotAllowed(
            attr,
            "Set `MOI.ObjectiveSense` before `MOI.ObjectiveFunction` when " *
            "using `MOI.Bridges.Objective.SlackBridge`.",
        ),
        MOI.set(model, attr, f),
    )
    return
end

function test_SlackBridge_ObjectiveSense_modify()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], -1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    @test_throws(
        MOI.SetAttributeNotAllowed,
        MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    @test MOI.get(model, MOI.ObjectiveFunction{typeof(f)}()) ≈ f
    return
end

function test_SlackBridge_ObjectiveFunction_modify()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], -1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    @test MOI.get(model, MOI.ObjectiveFunction{typeof(f)}()) ≈ f
    g = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(-1.1, x)], 1.2)
    MOI.set(model, MOI.ObjectiveFunction{typeof(g)}(), g)
    @test MOI.get(model, MOI.ObjectiveFunction{typeof(g)}()) ≈ g
    return
end

function test_SlackBridge_get_ObjectiveFunction_MIN()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], -1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    @test MOI.get(model, MOI.ObjectiveFunction{typeof(f)}()) ≈ f
    return
end

function test_SlackBridge_get_ObjectiveFunction_MAX()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], -1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    @test MOI.get(model, MOI.ObjectiveFunction{typeof(f)}()) ≈ f
    return
end

function test_SlackBridge_get_ObjectiveSense()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    return
end

function test_SlackBridge_NumberOfVariables()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], 1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    @test MOI.get(inner, MOI.NumberOfVariables()) == 2
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    @test MOI.get(inner, MOI.NumberOfVariables()) == 1
    return
end

function test_SlackBridge_ListOfModelAttributesSet()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], 1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    attr = MOI.get(model, MOI.ListOfModelAttributesSet())
    @test length(attr) == 2
    @test MOI.ObjectiveSense() in attr
    @test MOI.ObjectiveFunction{typeof(f)}() in attr
    attr = MOI.get(inner, MOI.ListOfModelAttributesSet())
    @test length(attr) == 2
    @test MOI.ObjectiveSense() in attr
    @test MOI.ObjectiveFunction{MOI.VariableIndex}() in attr
    return
end

function test_SlackBridge_ListOfVariableIndices()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], 1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [x]
    @test length(MOI.get(inner, MOI.ListOfVariableIndices())) == 2
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [x]
    @test MOI.get(inner, MOI.ListOfVariableIndices()) == [x]
    return
end

function test_SlackBridge_ListOfConstraintTypesPresent()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], 1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) == []
    @test MOI.get(inner, MOI.ListOfConstraintTypesPresent()) ==
          [(MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64})]
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) == []
    @test MOI.get(inner, MOI.ListOfConstraintTypesPresent()) == []
    return
end

function test_SlackBridge_ListOfConstraintIndices()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], 1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    attr = MOI.ListOfConstraintIndices{
        MOI.ScalarAffineFunction{Float64},
        MOI.GreaterThan{Float64},
    }()
    @test MOI.get(model, attr) == []
    @test length(MOI.get(inner, attr)) == 1
    attr = MOI.ListOfConstraintIndices{
        MOI.ScalarAffineFunction{Float64},
        MOI.LessThan{Float64},
    }()
    @test MOI.get(model, attr) == []
    @test length(MOI.get(inner, attr)) == 0
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    @test MOI.get(model, attr) == []
    @test length(MOI.get(inner, attr)) == 0
    return
end

function test_SlackBridge_ObjectiveFunctionValue()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(2.0))
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], -1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.Utilities.set_mock_optimize!(
        inner,
        mock -> MOI.Utilities.mock_optimize!(mock, [2.0, 1.0]),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ObjectiveValue()) ≈ 1.0
    return
end

function test_SlackBridge_ObjectiveFunctionValue_2()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    f = 1.1 * x - 1.2
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.Utilities.set_mock_optimize!(
        inner,
        mock -> begin
            MOI.set(mock, MOI.ResultCount(), 2)
            MOI.set(mock, MOI.TerminationStatus(), MOI.OPTIMAL)
            MOI.set(mock, MOI.PrimalStatus(1), MOI.FEASIBLE_POINT)
            MOI.set(mock, MOI.PrimalStatus(2), MOI.FEASIBLE_POINT)
            y = MOI.get(mock, MOI.ListOfVariableIndices())
            MOI.set.(mock, MOI.VariablePrimal(1), y, [1.0, -0.1])
            MOI.set.(mock, MOI.VariablePrimal(2), y, [2.0, 1.0])
        end,
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ObjectiveValue(1)) ≈ -0.1
    @test MOI.get(model, MOI.VariablePrimal(1), x) ≈ 1.0
    @test MOI.get(model, MOI.ObjectiveValue(2)) ≈ 1.0
    @test MOI.get(model, MOI.VariablePrimal(2), x) ≈ 2.0
    return
end

function test_original()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Objective.Slack{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0, 2.0, 5.0]),
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0, 2.0, 7.0]),
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0, 2.0, 2.0]),
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0, 2.0, 7.0]),
        ),
    )
    MOI.Test.test_objective_qp_ObjectiveFunction_edge_cases(
        bridged_mock,
        MOI.Test.Config(),
    )

    @test MOI.Bridges.is_objective_bridged(bridged_mock)
    @test MOI.get(bridged_mock, MOI.ObjectiveFunctionType()) ==
          MOI.ScalarQuadraticFunction{Float64}
    @test MOI.get(bridged_mock, MOI.ListOfModelAttributesSet()) == [
        MOI.ObjectiveSense(),
        MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{Float64}}(),
    ]

    var_names = ["x", "y"]
    xy = MOI.get(bridged_mock, MOI.ListOfVariableIndices())
    MOI.set(bridged_mock, MOI.VariableName(), xy, var_names)
    abs = MOI.get(mock, MOI.ListOfVariableIndices())
    @test length(abs) == 3
    MOI.set(mock, MOI.VariableName(), abs[3], "s")
    cquad = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarQuadraticFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    MOI.set(bridged_mock, MOI.ConstraintName(), cquad[1], "quad")

    s = """
    variables: x, y, s
    x >= 1.0
    y >= 2.0
    quad: 1.0 * x * x + 1.0 * x * y + 1.0 * y * y + -1.0 * s <= 0.0
    minobjective: s
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        [var_names; "s"],
        ["quad"],
        [
            ("x", MOI.GreaterThan{Float64}(1.0)),
            ("y", MOI.GreaterThan{Float64}(2.0)),
        ],
    )
    bridged_var_names = ["x", "y"]
    s = """
    variables: x, y
    x >= 1.0
    y >= 2.0
    minobjective: 1.0 * x * x + 1.0 * x * y + 1.0 * y * y
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        String[],
        [
            ("x", MOI.GreaterThan{Float64}(1.0)),
            ("y", MOI.GreaterThan{Float64}(2.0)),
        ],
    )
    err = MOI.SetAttributeNotAllowed(
        MOI.ObjectiveSense(),
        "Objective bridge of type `$(MOI.Bridges.Objective.SlackBridge{Float64,MOI.ScalarQuadraticFunction{Float64},MOI.ScalarQuadraticFunction{Float64}})`" *
        " does not support modifying the objective sense. As a workaround, set" *
        " the sense to `MOI.FEASIBILITY_SENSE` to clear the objective function" *
        " and bridges.",
    )
    @test_throws err MOI.set(bridged_mock, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    obj = MOI.get(
        bridged_mock,
        MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{Float64}}(),
    )
    MOI.set(bridged_mock, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    @test !MOI.Bridges.is_objective_bridged(bridged_mock)
    @test MOI.get(bridged_mock, MOI.ObjectiveSense()) == MOI.FEASIBILITY_SENSE
    @test MOI.get(bridged_mock, MOI.ListOfModelAttributesSet()) ==
          [MOI.ObjectiveSense()]
    MOI.set(bridged_mock, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(
        bridged_mock,
        MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{Float64}}(),
        obj,
    )
    abs = MOI.get(mock, MOI.ListOfVariableIndices())
    @test length(abs) == 3
    MOI.set(mock, MOI.VariableName(), abs[3], "s")
    cquad = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarQuadraticFunction{Float64},
            MOI.GreaterThan{Float64},
        }(),
    )
    MOI.set(bridged_mock, MOI.ConstraintName(), cquad[1], "quad")

    s = """
    variables: x, y, s
    x >= 1.0
    y >= 2.0
    quad: 1.0 * x * x + 1.0 * x * y + 1.0 * y * y + -1.0 * s >= 0.0
    maxobjective: s
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        [var_names; "s"],
        ["quad"],
        [
            ("x", MOI.GreaterThan{Float64}(1.0)),
            ("y", MOI.GreaterThan{Float64}(2.0)),
        ],
    )
    s = """
    variables: x, y
    x >= 1.0
    y >= 2.0
    maxobjective: 1.0 * x * x + 1.0 * x * y + 1.0 * y * y
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        String[],
        [
            ("x", MOI.GreaterThan{Float64}(1.0)),
            ("y", MOI.GreaterThan{Float64}(2.0)),
        ],
    )
    _test_delete_objective(
        bridged_mock,
        2,
        (
            (MOI.ScalarQuadraticFunction{Float64}, MOI.GreaterThan{Float64}, 0),
            (MOI.ScalarQuadraticFunction{Float64}, MOI.LessThan{Float64}, 0),
        ),
    )
    return
end

function test_quadratic_integration()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Objective.Slack{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [4 / 7, 3 / 7, 6 / 7, 13 / 7],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [5 / 7, 6 / 7],
        ),
    )
    MOI.Test.test_quadratic_integration(bridged_mock, MOI.Test.Config())
    return
end

function test_quadratic_duplicate_terms()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Objective.Slack{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [4 / 7, 3 / 7, 6 / 7, 13 / 7],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [5 / 7, 6 / 7],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [4 / 7, 3 / 7, 6 / 7, -2 * 13 / 7],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [10 / 7, 12 / 7],
        ),
    )
    MOI.Test.test_quadratic_duplicate_terms(bridged_mock, MOI.Test.Config())
    return
end

function test_quadratic_nonhomogeneous()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Objective.Slack{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1 / 4, 3 / 4, 2.875],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [11 / 4],
            (MOI.ScalarQuadraticFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1.0],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 0.0, 3.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [-2.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [1.0],
        ),
    )
    MOI.Test.test_quadratic_nonhomogeneous(bridged_mock, MOI.Test.Config())
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.SlackBridge,
        """
        variables: x
        minobjective: 1.1 * x + 2.2
        """,
        """
        variables: x, y
        minobjective: y
        1.1 * x + -1.0 * y <= -2.2
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.SlackBridge,
        """
        variables: x
        maxobjective: 1.1 * x + 2.2
        """,
        """
        variables: x, y
        maxobjective: y
        1.1 * x + -1.0 * y >= -2.2
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.SlackBridge,
        """
        variables: x
        maxobjective: ScalarNonlinearFunction(log(x))
        """,
        """
        variables: x, y
        maxobjective: y
        ScalarNonlinearFunction(log(x) - y) >= 0.0
        """,
    )
    return
end

function test_complex_objective()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    for f in ((1.0 + 1.0im) * x, (1.0 + 1.0im) * x * x)
        attr = MOI.ObjectiveFunction{typeof(f)}()
        MOI.set(model, attr, f)
        dest = MOI.Bridges.full_bridge_optimizer(
            MOI.Utilities.Model{Float64}(),
            Float64,
        )
        @test_throws MOI.UnsupportedAttribute(attr) MOI.copy_to(dest, model)
    end
    return
end

function test_deletion_of_variable_in_slacked_objective()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.VariableName(), x, ["x", "y"])
    f = 1.0 * x[1] * x[1] + 1.0 * x[2] * x[2]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.delete(model, x[1])
    @test MOI.get(model, MOI.ObjectiveFunction{typeof(f)}()) ≈ 1.0 * x[2] * x[2]
    return
end

function test_SlackBridgePrimalDualStart_non_slack()
    inner = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    # Should ignore without erroring
    MOI.set(inner, MOI.Bridges.Objective.SlackBridgePrimalDualStart(), nothing)
    model = MOI.Bridges.Objective.Functionize{Float64}(inner)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveFunction{typeof(x)}(), x)
    # Should ignore without erroring
    MOI.set(model, MOI.Bridges.Objective.SlackBridgePrimalDualStart(), nothing)
    return
end

function test_SlackBridgePrimalDualStart()
    inner = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(2.0))
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], -1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.VariablePrimalStart(), x, 2.0)
    attr = MOI.Bridges.Objective.SlackBridgePrimalDualStart()
    @test MOI.supports(model, attr)
    MOI.set(model, attr, nothing)
    vars = MOI.get(inner, MOI.ListOfVariableIndices())
    primal_start = MOI.get.(inner, MOI.VariablePrimalStart(), vars)
    @test primal_start[1] ≈ 2.0
    @test primal_start[2] ≈ 1.1 * 2.0 - 1.2
    F = MOI.ScalarAffineFunction{Float64}
    cis = MOI.get(inner, MOI.ListOfConstraintIndices{F,MOI.LessThan{Float64}}())
    @test length(cis) == 1
    @test MOI.get(inner, MOI.ConstraintPrimalStart(), cis[1]) ≈ 0.0
    @test MOI.get(inner, MOI.ConstraintDualStart(), cis[1]) ≈ -1.0
    return
end

function test_SlackBridgePrimalDualStart_unsupported()
    attr = MOI.Bridges.Objective.SlackBridgePrimalDualStart()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    # Check that setting on blank model doesn't error.
    @test MOI.supports(inner, attr)
    MOI.set(inner, attr, nothing)
    model = MOI.Bridges.Objective.Slack{Float64}(inner)
    @test MOI.supports(model, attr)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.1, x)], -1.2)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    # Unsupported. Should silently skip without error.
    MOI.set(model, attr, nothing)
    return
end

end  # module

TestObjectiveSlack.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    HermitianToComplexSymmetricBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`HermitianToSymmetricBridge` implements the following reformulation:

  * Hermitian positive semidefinite `n x n` represented as a vector of real
    entries with real and imaginary parts on different entries to a vector
    of complex entries.

See also [`MOI.Bridges.Constraint.HermitianToSymmetricPSDBridge`](@ref).

## Source node

`HermitianToComplexSymmetricBridge` supports:

  * `G` in [`MOI.HermitianPositiveSemidefiniteConeTriangle`](@ref)

## Target node

`HermitianToComplexSymmetricBridge` creates:

  * `F` in [`MOI.PositiveSemidefiniteConeTriangle`](@ref)

Note that if `G` is `MOI.VectorAffineFunction{T}` then `F` will be
`MOI.VectorAffineFunction{Complex{T}}`
"""
struct HermitianToComplexSymmetricBridge{T,F,G} <: SetMapBridge{
    T,
    MOI.PositiveSemidefiniteConeTriangle,
    MOI.HermitianPositiveSemidefiniteConeTriangle,
    F,
    G,
}
    constraint::MOI.ConstraintIndex{F,MOI.PositiveSemidefiniteConeTriangle}
end

const HermitianToComplexSymmetric{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{HermitianToComplexSymmetricBridge{T},OT}

# Should be favored over `HermitianToSymmetricPSDBridge`
MOI.Bridges.bridging_cost(::Type{<:HermitianToComplexSymmetricBridge}) = 0.5

function _promote_complex_vcat(::Type{T}, ::Type{G}) where {T<:Real,G}
    S = MOI.Utilities.scalar_type(G)
    if S === T
        M = Complex{T}
    elseif S <: MOI.Utilities.TypedLike{T}
        M = MOI.Utilities.similar_type(S, Complex{T})
    else
        M = MOI.Utilities.promote_operation(*, Complex{T}, Complex{T}, S)
    end
    return MOI.Utilities.promote_operation(vcat, Complex{T}, M)
end

function concrete_bridge_type(
    ::Type{<:HermitianToComplexSymmetricBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.HermitianPositiveSemidefiniteConeTriangle},
) where {T}
    F = _promote_complex_vcat(T, G)
    return HermitianToComplexSymmetricBridge{T,F,G}
end

function MOI.Bridges.map_set(
    ::Type{<:HermitianToComplexSymmetricBridge},
    set::MOI.HermitianPositiveSemidefiniteConeTriangle,
)
    return MOI.PositiveSemidefiniteConeTriangle(set.side_dimension)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:HermitianToComplexSymmetricBridge},
    set::MOI.PositiveSemidefiniteConeTriangle,
)
    return MOI.HermitianPositiveSemidefiniteConeTriangle(set.side_dimension)
end

function MOI.Bridges.map_function(
    ::Type{<:HermitianToComplexSymmetricBridge{T}},
    func,
) where {T}
    complex_scalars = MOI.Utilities.eachscalar(func)
    S = MOI.Utilities.scalar_type(_promote_complex_vcat(T, typeof(func)))
    complex_dim = length(complex_scalars)
    complex_set = MOI.Utilities.set_with_dimension(
        MOI.HermitianPositiveSemidefiniteConeTriangle,
        complex_dim,
    )
    n = complex_set.side_dimension
    real_set = MOI.PositiveSemidefiniteConeTriangle(n)
    real_dim = MOI.dimension(real_set)
    real_scalars = Vector{S}(undef, real_dim)
    real_index = 0
    imag_index = real_dim
    for j in 1:n
        for i in 1:j
            real_index += 1
            if i == j
                real_scalars[real_index] = complex_scalars[real_index]
            else
                imag_index += 1
                real_scalars[real_index] =
                    one(Complex{T}) * complex_scalars[real_index] +
                    (one(T) * im) * complex_scalars[imag_index]
            end
        end
    end
    @assert length(real_scalars) == real_index
    @assert length(complex_scalars) == imag_index
    return MOI.Utilities.vectorize(real_scalars)
end

function MOI.Bridges.inverse_adjoint_map_function(
    BT::Type{<:HermitianToComplexSymmetricBridge},
    func,
)
    return MOI.Bridges.map_function(BT, func)
end

function MOI.Bridges.inverse_map_function(
    ::Type{<:HermitianToComplexSymmetricBridge},
    func,
)
    real_scalars = MOI.Utilities.eachscalar(func)
    real_set = MOI.Utilities.set_with_dimension(
        MOI.PositiveSemidefiniteConeTriangle,
        length(real_scalars),
    )
    n = real_set.side_dimension
    complex_set = MOI.HermitianPositiveSemidefiniteConeTriangle(n)
    complex_scalars = Vector{
        MA.promote_operation(real, MOI.Utilities.scalar_type(typeof(func))),
    }(
        undef,
        MOI.dimension(complex_set),
    )
    real_index = 0
    imag_index = MOI.dimension(real_set)
    for j in 1:n
        for i in 1:j
            real_index += 1
            complex_scalars[real_index] = real(real_scalars[real_index])
            if i != j
                imag_index += 1
                complex_scalars[imag_index] = imag(real_scalars[real_index])
            end
        end
    end
    @assert length(real_scalars) == real_index
    @assert length(complex_scalars) == imag_index
    return MOI.Utilities.vectorize(complex_scalars)
end

function MOI.Bridges.adjoint_map_function(
    BT::Type{<:HermitianToComplexSymmetricBridge},
    func,
)
    return MOI.Bridges.inverse_map_function(BT, func)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSplitComplexZeros

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_complex_zeros()
    T = Float64
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}()),
    )
    bridged_mock = MOI.Bridges.Constraint.SplitComplexZeros{T}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [2 / 3, 1 / 3],
            (MOI.VectorAffineFunction{T}, MOI.Zeros) => [zeros(T, 2)],
        ),
    )
    config = MOI.Test.Config()
    MOI.empty!(bridged_mock)
    MOI.Test.test_linear_complex_Zeros(bridged_mock, config)
    cis = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Complex{T}},
            MOI.Zeros,
        }(),
    )
    @test length(cis) == 0
    cis = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorAffineFunction{T},MOI.Zeros}(),
    )
    @test length(cis) == 1

    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [2],
            (MOI.VectorAffineFunction{T}, MOI.Zeros) => [zeros(T, 1)],
        ),
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_linear_complex_Zeros_duplicate(bridged_mock, config)
    cis = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorAffineFunction{T},MOI.Zeros}(),
    )
    @test length(cis) == 1
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitComplexZerosBridge,
        """
        variables: x
        ::Complex{Float64}: [(1 + 2im) * x + (3 + 4im)] in Zeros(1)
        """,
        """
        variables: x
        ::Float64: [1 * x + 3, 2 * x + 4] in Zeros(2)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitComplexZerosBridge,
        """
        variables: x
        ::Complex{Float64}: [(0 + 2im) * x + (0 + 4im)] in Zeros(1)
        """,
        """
        variables: x
        ::Float64: [2 * x + 4] in Zeros(1)
        """;
        constraint_start = 0.0 + 1.2im,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitComplexZerosBridge,
        """
        variables: x
        ::Complex{Float64}: [(2 + 0im) * x + (4 + 0im)] in Zeros(1)
        """,
        """
        variables: x
        ::Float64: [2 * x + 4] in Zeros(1)
        """;
        constraint_start = 1.2 + 0.0im,
    )
    return
end

end  # module

TestConstraintSplitComplexZeros.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# An Int-valued attribute
struct MockModelAttribute <: MOI.AbstractModelAttribute end

# An Int-valued attribute
struct MockVariableAttribute <: MOI.AbstractVariableAttribute end

# An Int-valued attribute
struct MockConstraintAttribute <: MOI.AbstractConstraintAttribute end

# A mock optimizer used for testing.
"""
    MockOptimizer

`MockOptimizer` is a fake optimizer especially useful for testing. Its main
feature is that it can store the values that should be returned for each
attribute.
"""
mutable struct MockOptimizer{MT<:MOI.ModelLike,T} <: MOI.AbstractOptimizer
    inner_model::MT
    # Flags
    supports_names::Bool # Allows to test with optimizer not supporting names
    add_var_allowed::Bool # If false, the optimizer throws AddVariableNotAllowed
    add_con_allowed::Bool # If false, the optimizer throws AddConstraintNotAllowed
    modify_allowed::Bool # If false, the optimizer throws Modify...NotAllowed
    delete_allowed::Bool # If false, the optimizer throws DeleteNotAllowed
    scalar_function_constant_non_zero::Bool
    # Computes `ObjectiveValue` by evaluating the `ObjectiveFunction` with
    # `VariablePrimal`. See `get_fallback`.
    eval_objective_value::Bool
    # Computes `DualObjectiveValue` using `get_fallback`
    eval_dual_objective_value::Bool
    # Computes `ConstraintDual` of constraints with `VariableIndex` or
    # `VectorOfVariables` functions by evaluating the `ConstraintDual` of
    # constraints having the variable in the function. See `get_fallback`.
    eval_variable_constraint_dual::Bool
    # Attributes
    # The attributes set by `MOI.optimize!` cannot be set to `model`.
    # We detect them with `is_set_by_optimize` and store them in the following:
    optimizer_attributes::Dict{MOI.AbstractOptimizerAttribute,Any}
    model_attributes::Dict{MOI.AbstractModelAttribute,Any}
    submitted::Dict{MOI.AbstractSubmittable,Vector{Tuple}}
    mock_model_attribute::Int
    mock_variable_attribute::Dict{MOI.VariableIndex,Int}
    mock_constraint_attribute::Dict{MOI.ConstraintIndex,Int}
    #
    optimize!::Function
    optimize_called::Bool
    termination_status::MOI.TerminationStatusCode
    result_count::Int
    objective_value::Dict{Int,T}
    dual_objective_value::Dict{Int,T}
    # Primal solution
    primal_status::Dict{Int,MOI.ResultStatusCode}
    variable_primal::Dict{MOI.VariableIndex,Dict{Int,T}}
    callback_variable_primal::Dict{MOI.VariableIndex,T}
    # Dual solution
    dual_status::Dict{Int,MOI.ResultStatusCode}
    constraint_dual::Dict{MOI.ConstraintIndex,Dict{Int,Any}}
    # Constraint conflicts
    compute_conflict_called::Bool
    conflict_status::MOI.ConflictStatusCode
    conflict_count::Int
    constraint_conflict_status::Dict{
        MOI.ConstraintIndex,
        Dict{Int,MOI.ConflictParticipationStatusCode},
    }
    # Basis status
    constraint_basis_status::Dict{
        MOI.ConstraintIndex,
        Dict{Int,MOI.BasisStatusCode},
    }
    variable_basis_status::Dict{MOI.VariableIndex,Dict{Int,MOI.BasisStatusCode}}
    constraint_attributes::Dict{
        MOI.AbstractConstraintAttribute,
        Dict{MOI.ConstraintIndex,Any},
    }
end

function MockOptimizer(
    inner_model::MOI.ModelLike,
    T = Float64;
    supports_names = true,
    add_var_allowed = true,
    add_con_allowed = true,
    eval_objective_value = true,
    eval_dual_objective_value = true,
    eval_variable_constraint_dual = true,
    scalar_function_constant_non_zero = false,
)
    return MockOptimizer{typeof(inner_model),T}(
        inner_model,
        # Flags
        supports_names,
        add_var_allowed,
        add_con_allowed,
        true,
        true,
        scalar_function_constant_non_zero,
        eval_objective_value,
        eval_dual_objective_value,
        eval_variable_constraint_dual,
        # Attributes
        Dict{MOI.AbstractOptimizerAttribute,Any}(),
        Dict{MOI.AbstractModelAttribute,Any}(),
        Dict{MOI.AbstractSubmittable,Vector{Tuple}}(),
        0,
        Dict{MOI.VariableIndex,Int}(),
        Dict{MOI.ConstraintIndex,Int}(),
        #
        (::MockOptimizer) -> nothing,
        false,
        MOI.OPTIMIZE_NOT_CALLED,
        1,
        Dict{Int,T}(),
        Dict{Int,T}(),
        # PrimalStatus
        Dict{Int,MOI.ResultStatusCode}(),
        Dict{MOI.VariableIndex,Dict{Int,T}}(),
        Dict{MOI.VariableIndex,T}(),
        # DualStatus
        Dict{Int,MOI.ResultStatusCode}(),
        Dict{MOI.ConstraintIndex,Dict{Int,Any}}(),
        #
        false,
        MOI.COMPUTE_CONFLICT_NOT_CALLED,
        0,
        Dict{
            MOI.ConstraintIndex,
            Dict{Int,MOI.ConflictParticipationStatusCode},
        }(),
        # Basis status
        Dict{MOI.ConstraintIndex,Dict{Int,MOI.BasisStatusCode}}(),
        Dict{MOI.VariableIndex,Dict{Int,MOI.BasisStatusCode}}(),
        Dict{MOI.AbstractConstraintAttribute,Dict{MOI.ConstraintIndex,Any}}(),
    )
end

function MockOptimizer(::Type{T} = Float64; kwargs...) where {T}
    inner = UniversalFallback(Utilities.Model{T}())
    return MockOptimizer(inner, T; kwargs...)
end

"""
All user-facing indices are xor'd with this mask to produce unusual indices.
This is good at catching bugs in solvers which assume indices are ordered 1, 2,
3, ...
"""
const _INTERNAL_XOR_MASK = Int64(12345678)

function xor_index(vi::MOI.VariableIndex)
    return MOI.VariableIndex(xor(vi.value, _INTERNAL_XOR_MASK))
end

function xor_index(ci::MOI.ConstraintIndex{F,S}) where {F,S}
    return MOI.ConstraintIndex{F,S}(xor(ci.value, _INTERNAL_XOR_MASK))
end

xor_indices(x) = map_indices(xor_index, x)

function MOI.add_variable(mock::MockOptimizer)
    if mock.add_var_allowed
        return xor_index(MOI.add_variable(mock.inner_model))
    else
        throw(MOI.AddVariableNotAllowed())
    end
end

function MOI.add_constraint(
    mock::MockOptimizer,
    func::MOI.AbstractFunction,
    set::MOI.AbstractSet,
)
    if mock.add_con_allowed
        ci = MOI.add_constraint(mock.inner_model, xor_indices(func), set)
        return xor_index(ci)
    else
        throw(MOI.AddConstraintNotAllowed{typeof(func),typeof(set)}())
    end
end

function MOI.add_constraint(
    mock::MockOptimizer,
    func::MOI.ScalarAffineFunction{T},
    set::MOI.AbstractSet,
) where {T}
    if !mock.add_con_allowed
        throw(MOI.AddConstraintNotAllowed{typeof(func),typeof(set)}())
    elseif mock.scalar_function_constant_non_zero
        MOI.throw_if_scalar_and_constant_not_zero(func, typeof(set))
    end
    ci = MOI.add_constraint(mock.inner_model, xor_indices(func), set)
    return xor_index(ci)
end

function MOI.add_constraint(
    mock::MockOptimizer,
    func::MOI.VariableIndex,
    set::MOI.AbstractSet,
)
    if !mock.add_con_allowed
        throw(MOI.AddConstraintNotAllowed{typeof(func),typeof(set)}())
    end
    try
        ci = MOI.add_constraint(mock.inner_model, xor_indices(func), set)
        return xor_index(ci)
    catch err
        if (err isa MOI.LowerBoundAlreadySet) ||
           (err isa MOI.UpperBoundAlreadySet)
            throw(typeof(err)(xor_index(err.vi)))
        else
            rethrow(err)
        end
    end
end

function MOI.optimize!(mock::MockOptimizer)
    mock.optimize_called = true
    mock.optimize!(mock)
    return
end

function MOI.compute_conflict!(model::MockOptimizer)
    model.compute_conflict_called = true
    return
end

function throw_mock_unsupported_names(attr)
    return throw(
        MOI.UnsupportedAttribute(
            attr,
            "The MockOptimizer was configured not to support names for " *
            "testing purpose using the `support_names=false` constructor keyword " *
            "argument.",
        ),
    )
end

function MOI.supports(
    ::MockOptimizer,
    ::Union{MOI.VariablePrimal,MockVariableAttribute},
    ::Type{MOI.VariableIndex},
)
    return true
end

function MOI.supports(
    mock::MockOptimizer,
    attr::MOI.AbstractVariableAttribute,
    IdxT::Type{MOI.VariableIndex},
)
    return MOI.supports(mock.inner_model, attr, IdxT)
end

function MOI.supports(
    ::MockOptimizer,
    ::Union{MOI.ConstraintDual,MockConstraintAttribute},
    ::Type{<:MOI.ConstraintIndex},
)
    return true
end

function MOI.supports(
    mock::MockOptimizer,
    attr::MOI.AbstractConstraintAttribute,
    IdxT::Type{<:MOI.ConstraintIndex},
)
    return MOI.supports(mock.inner_model, attr, IdxT)
end

MOI.supports(mock::MockOptimizer, ::MockModelAttribute) = true

function MOI.set(
    mock::MockOptimizer,
    ::MOI.TerminationStatus,
    value::MOI.TerminationStatusCode,
)
    mock.termination_status = value
    return
end

function MOI.set(mock::MockOptimizer, attr::MOI.ObjectiveValue, value::Real)
    mock.objective_value[attr.result_index] = value
    return
end

function MOI.set(mock::MockOptimizer, attr::MOI.DualObjectiveValue, value::Real)
    mock.dual_objective_value[attr.result_index] = value
    return
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.PrimalStatus,
    value::MOI.ResultStatusCode,
)
    mock.primal_status[attr.result_index] = value
    return
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.DualStatus,
    value::MOI.ResultStatusCode,
)
    mock.dual_status[attr.result_index] = value
    return
end

MOI.get(mock::MockOptimizer, ::MOI.ConflictCount) = mock.conflict_count

function MOI.set(mock::MockOptimizer, ::MOI.ConflictCount, x)
    mock.conflict_count = x
    return
end

function MOI.set(
    mock::MockOptimizer,
    ::MOI.ConflictStatus,
    value::MOI.ConflictStatusCode,
)
    if value == MOI.CONFLICT_FOUND && mock.conflict_count == 0
        # A backwards compatible change for JuMP, which set MOI.ConflictStatus
        # in its tests without setting MOI.ConflictCount (because the test was
        # written prior to the introduction of MOI.ConflictCount).
        mock.conflict_count = 1
    end
    mock.conflict_status = value
    return
end

function MOI.get(mock::MockOptimizer, ::MOI.ConflictStatus)
    if mock.compute_conflict_called
        return mock.conflict_status
    end
    return MOI.COMPUTE_CONFLICT_NOT_CALLED
end

function MOI.set(mock::MockOptimizer, ::MockModelAttribute, value::Integer)
    mock.mock_model_attribute = value
    return
end

function MOI.supports(mock::MockOptimizer, attr::MOI.AbstractOptimizerAttribute)
    # `supports` is not defined if `is_set_by_optimize(attr)` so we pass it to
    # `mock.inner_model`.
    return MOI.supports(mock.inner_model, attr)
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.AbstractOptimizerAttribute,
    value,
)
    if MOI.is_set_by_optimize(attr)
        mock.optimizer_attributes[attr] = value
    else
        MOI.set(mock.inner_model, attr, value)
    end
    return
end

function MOI.supports(mock::MockOptimizer, attr::MOI.AbstractModelAttribute)
    # `supports` is not defined if `is_set_by_optimize(attr)` so we pass it to
    # `mock.inner_model`.
    return MOI.supports(mock.inner_model, attr)
end

function MOI.set(mock::MockOptimizer, attr::MOI.AbstractModelAttribute, value)
    if MOI.is_set_by_optimize(attr)
        mock.model_attributes[attr] = value
    else
        MOI.set(mock.inner_model, attr, xor_indices(value))
    end
    return
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.AbstractVariableAttribute,
    idx::MOI.VariableIndex,
    value,
)
    MOI.set(mock.inner_model, attr, xor_index(idx), xor_indices(value))
    return
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.VariablePrimal,
    idx::MOI.VariableIndex,
    value,
)
    _safe_set_result(mock.variable_primal, attr, idx, value)
    return
end

function MOI.set(
    mock::MockOptimizer,
    ::MOI.CallbackVariablePrimal,
    idx::MOI.VariableIndex,
    value,
)
    mock.callback_variable_primal[xor_index(idx)] = value
    return
end

function MOI.set(
    mock::MockOptimizer,
    ::MockVariableAttribute,
    idx::MOI.VariableIndex,
    value,
)
    mock.mock_variable_attribute[xor_index(idx)] = value
    return
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.AbstractConstraintAttribute,
    idx::MOI.ConstraintIndex,
    value,
)
    if MOI.is_set_by_optimize(attr)
        ret = get!(mock.constraint_attributes, attr) do
            return Dict{MOI.ConstraintIndex,Any}()
        end
        ret[idx] = value
    else
        MOI.set(mock.inner_model, attr, xor_index(idx), value)
    end
    return
end

function MOI.set(
    mock::MockOptimizer,
    ::MockConstraintAttribute,
    idx::MOI.ConstraintIndex,
    value,
)
    mock.mock_constraint_attribute[xor_index(idx)] = value
    return
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.ConstraintDual,
    idx::MOI.ConstraintIndex,
    value,
)
    _safe_set_result(mock.constraint_dual, attr, idx, value)
    return
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.ConstraintBasisStatus,
    idx::MOI.ConstraintIndex,
    value,
)
    _safe_set_result(mock.constraint_basis_status, attr, idx, value)
    return
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.VariableBasisStatus,
    idx::MOI.VariableIndex,
    value,
)
    _safe_set_result(mock.variable_basis_status, attr, idx, value)
    return
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.ConstraintConflictStatus,
    idx::MOI.ConstraintIndex,
    value,
)
    _safe_set_result(mock.constraint_conflict_status, attr, idx, value)
    return
end

MOI.get(mock::MockOptimizer, ::MOI.RawSolver) = mock

function MOI.get(mock::MockOptimizer, attr::MOI.AbstractOptimizerAttribute)
    if MOI.is_set_by_optimize(attr)
        return mock.optimizer_attributes[attr]
    else
        return MOI.get(mock.inner_model, attr)
    end
end

function MOI.get(mock::MockOptimizer, attr::MOI.AbstractModelAttribute)
    if MOI.is_set_by_optimize(attr)
        return mock.model_attributes[attr]
    else
        return xor_indices(MOI.get(mock.inner_model, attr))
    end
end

#####
##### Names
#####

function MOI.supports(mock::MockOptimizer, attr::MOI.Name)
    return mock.supports_names && MOI.supports(mock.inner_model, attr)
end

function MOI.set(mock::MockOptimizer, attr::MOI.Name, value)
    if !mock.supports_names
        throw_mock_unsupported_names(attr)
    end
    MOI.set(mock.inner_model, attr, value)
    return
end

function MOI.supports(
    mock::MockOptimizer,
    attr::MOI.VariableName,
    IdxT::Type{MOI.VariableIndex},
)
    return mock.supports_names && MOI.supports(mock.inner_model, attr, IdxT)
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.VariableName,
    index::MOI.VariableIndex,
    value,
)
    if !mock.supports_names
        throw_mock_unsupported_names(attr)
    end
    MOI.set(mock.inner_model, attr, xor_index(index), value)
    return
end

function MOI.supports(
    mock::MockOptimizer,
    attr::MOI.ConstraintName,
    IdxT::Type{<:MOI.ConstraintIndex},
)
    return mock.supports_names && MOI.supports(mock.inner_model, attr, IdxT)
end

function MOI.set(
    mock::MockOptimizer,
    attr::MOI.ConstraintName,
    index::MOI.ConstraintIndex,
    value,
)
    if !mock.supports_names
        throw_mock_unsupported_names(attr)
    end
    MOI.set(mock.inner_model, attr, xor_index(index), value)
    return
end

function MOI.get(b::MockOptimizer, IdxT::Type{<:MOI.Index}, name::String)
    index = MOI.get(b.inner_model, IdxT, name)
    return index === nothing ? nothing : xor_index(index)
end

#####
##### Results
#####

MOI.get(mock::MockOptimizer, ::MOI.ResultCount) = mock.result_count

function MOI.set(mock::MockOptimizer, ::MOI.ResultCount, x)
    mock.result_count = x
    return
end

MOI.get(mock::MockOptimizer, ::MOI.TerminationStatus) = mock.termination_status

function MOI.get(mock::MockOptimizer, attr::MOI.ObjectiveValue)
    if mock.eval_objective_value
        return get_fallback(mock, attr)
    end
    MOI.check_result_index_bounds(mock, attr)
    return get(mock.objective_value, attr.result_index, NaN)
end

function MOI.get(
    mock::MockOptimizer{<:MOI.ModelLike,T},
    attr::MOI.DualObjectiveValue,
) where {T}
    if mock.eval_dual_objective_value
        return get_fallback(mock, attr, T)
    end
    MOI.check_result_index_bounds(mock, attr)
    return get(mock.dual_objective_value, attr.result_index, NaN)
end

function MOI.get(mock::MockOptimizer, attr::MOI.PrimalStatus)
    if attr.result_index > mock.result_count
        return MOI.NO_SOLUTION
    end
    return get(mock.primal_status, attr.result_index, MOI.NO_SOLUTION)
end

function MOI.get(mock::MockOptimizer, attr::MOI.DualStatus)
    if attr.result_index > mock.result_count
        return MOI.NO_SOLUTION
    end
    return get(mock.dual_status, attr.result_index, MOI.NO_SOLUTION)
end

MOI.get(mock::MockOptimizer, ::MockModelAttribute) = mock.mock_model_attribute

function MOI.get(
    mock::MockOptimizer,
    attr::MOI.AbstractVariableAttribute,
    idx::MOI.VariableIndex,
)
    return xor_indices(MOI.get(mock.inner_model, attr, xor_index(idx)))
end

function MOI.get(
    mock::MockOptimizer,
    ::MockVariableAttribute,
    idx::MOI.VariableIndex,
)
    return mock.mock_variable_attribute[xor_index(idx)]
end

function MOI.get(
    mock::MockOptimizer,
    attr::MOI.VariablePrimal,
    idx::MOI.VariableIndex,
)
    MOI.check_result_index_bounds(mock, attr)
    MOI.throw_if_not_valid(mock, idx)
    return _safe_get_result(mock.variable_primal, attr, idx, "primal")
end

function MOI.get(
    mock::MockOptimizer,
    ::MOI.CallbackVariablePrimal,
    idx::MOI.VariableIndex,
)
    if !MOI.is_valid(mock, idx)
        throw(MOI.InvalidIndex(idx))
    end
    primal = get(mock.callback_variable_primal, xor_index(idx), nothing)
    if primal === nothing
        error("No mock callback primal is set for variable `", idx, "`.")
    end
    return primal
end

function MOI.get(
    mock::MockOptimizer,
    attr::MOI.ConstraintPrimal,
    idx::MOI.ConstraintIndex,
)
    return get_fallback(mock, attr, idx)
end

function MOI.get(
    mock::MockOptimizer,
    attr::MOI.AbstractConstraintAttribute,
    idx::MOI.ConstraintIndex,
)
    # If it is thrown by `mock.inner_model`, the index will be xor'ed.
    MOI.throw_if_not_valid(mock, idx)
    if MOI.is_set_by_optimize(attr)
        return mock.constraint_attributes[attr][idx]
    end
    return MOI.get(mock.inner_model, attr, xor_index(idx))
end

function MOI.get(
    mock::MockOptimizer,
    attr::MOI.CanonicalConstraintFunction,
    idx::MOI.ConstraintIndex,
)
    # If it is thrown by `mock.inner_model`, the index will be xor'ed.
    MOI.throw_if_not_valid(mock, idx)
    # After xoring the indices, the order might not be respected anymore
    return canonical(
        xor_indices(MOI.get(mock.inner_model, attr, xor_index(idx))),
    )
end

function MOI.get(
    mock::MockOptimizer,
    attr::Union{MOI.CanonicalConstraintFunction,MOI.ConstraintFunction},
    idx::MOI.ConstraintIndex,
)
    # If it is thrown by `mock.inner_model`, the index will be xor'ed.
    MOI.throw_if_not_valid(mock, idx)
    return xor_indices(MOI.get(mock.inner_model, attr, xor_index(idx)))
end

function MOI.get(
    mock::MockOptimizer{<:MOI.ModelLike,T},
    attr::MOI.ConstraintDual,
    idx::MOI.ConstraintIndex{F},
) where {T,F}
    MOI.throw_if_not_valid(mock, idx)
    if mock.eval_variable_constraint_dual &&
       (F == MOI.VariableIndex || F == MOI.VectorOfVariables)
        return get_fallback(mock, attr, idx, T)
    else
        MOI.check_result_index_bounds(mock, attr)
        return _safe_get_result(mock.constraint_dual, attr, idx, "dual")
    end
end

function MOI.get(
    mock::MockOptimizer,
    ::MockConstraintAttribute,
    idx::MOI.ConstraintIndex,
)
    return mock.mock_constraint_attribute[xor_index(idx)]
end

function MOI.get(
    mock::MockOptimizer,
    attr::MOI.ConstraintBasisStatus,
    idx::MOI.ConstraintIndex,
)
    MOI.check_result_index_bounds(mock, attr)
    MOI.throw_if_not_valid(mock, idx)
    return _safe_get_result(
        mock.constraint_basis_status,
        attr,
        idx,
        "basis status",
    )
end

function MOI.get(
    mock::MockOptimizer,
    attr::MOI.VariableBasisStatus,
    idx::MOI.VariableIndex,
)
    MOI.check_result_index_bounds(mock, attr)
    MOI.throw_if_not_valid(mock, idx)
    return _safe_get_result(
        mock.variable_basis_status,
        attr,
        idx,
        "basis status",
    )
end

function MOI.get(
    mock::MockOptimizer,
    attr::MOI.ConstraintConflictStatus,
    idx::MOI.ConstraintIndex,
)
    MOI.check_conflict_index_bounds(mock, attr)
    MOI.throw_if_not_valid(mock, idx)
    return _safe_get_result(
        mock.constraint_conflict_status,
        attr,
        idx,
        "conflict status",
    )
end

function _safe_set_result(
    dict::Dict{K,V},
    attr::MOI.AnyAttribute,
    index::K,
    value,
) where {K,V}
    xored = xor_index(index)
    if !haskey(dict, xored)
        dict[xored] = V()
    end
    if hasproperty(attr, :conflict_index)
        return dict[xored][attr.conflict_index] = value
    end
    return dict[xored][attr.result_index] = value
end

function _safe_get_result(
    dict::Dict,
    attr::MOI.AnyAttribute,
    index::MOI.Index,
    name::String,
)
    index_name = index isa MOI.VariableIndex ? "variable" : "constraint"
    result_to_value = get(dict, xor_index(index), nothing)
    if result_to_value === nothing
        error("No mock $name is set for ", index_name, " `", index, "`.")
    end
    data_index = if hasproperty(attr, :conflict_index)
        attr.conflict_index
    else
        attr.result_index
    end
    value = get(result_to_value, data_index, nothing)
    if value === nothing
        error(
            "No mock $name is set for $(index_name) `$(index)` at result " *
            "index `$(data_index)`.",
        )
    end
    return value
end

MOI.get(::MockOptimizer, ::MOI.SolverName) = "Mock"
MOI.get(::MockOptimizer, ::MOI.SolverVersion) = "v0.1.0"

function MOI.empty!(mock::MockOptimizer)
    MOI.empty!(mock.inner_model)
    mock.mock_model_attribute = 0
    empty!(mock.mock_variable_attribute)
    empty!(mock.mock_constraint_attribute)
    mock.optimize_called = false
    mock.termination_status = MOI.OPTIMIZE_NOT_CALLED
    mock.compute_conflict_called = false
    mock.conflict_status = MOI.COMPUTE_CONFLICT_NOT_CALLED
    empty!(mock.constraint_conflict_status)
    empty!(mock.objective_value)
    empty!(mock.dual_objective_value)
    empty!(mock.primal_status)
    empty!(mock.dual_status)
    empty!(mock.variable_primal)
    empty!(mock.callback_variable_primal)
    empty!(mock.constraint_dual)
    empty!(mock.constraint_basis_status)
    empty!(mock.variable_basis_status)
    empty!(mock.optimizer_attributes)
    empty!(mock.model_attributes)
    empty!(mock.submitted)
    return
end

function MOI.is_empty(mock::MockOptimizer)
    # Assumes that variable and constraint attributes can't be set if
    # mock.inner_model is empty.
    # TODO: Default values are currently copied in three places, not good.
    return MOI.is_empty(mock.inner_model) &&
           mock.mock_model_attribute == 0 &&
           !mock.optimize_called &&
           mock.termination_status == MOI.OPTIMIZE_NOT_CALLED &&
           isempty(mock.objective_value) &&
           isempty(mock.dual_objective_value) &&
           isempty(mock.primal_status) &&
           isempty(mock.dual_status) &&
           isempty(mock.constraint_basis_status) &&
           isempty(mock.variable_basis_status) &&
           isempty(mock.optimizer_attributes) &&
           isempty(mock.model_attributes) &&
           isempty(mock.submitted)
end

function MOI.is_valid(mock::MockOptimizer, idx::MOI.Index)
    return MOI.is_valid(mock.inner_model, xor_index(idx))
end

function MOI.delete(mock::MockOptimizer, index::MOI.VariableIndex)
    if !mock.delete_allowed
        throw(MOI.DeleteNotAllowed(index))
    end
    if !MOI.is_valid(mock, index)
        # The index thrown by `mock.inner_model` would be xored
        throw(MOI.InvalidIndex(index))
    end
    MOI.delete(mock.inner_model, xor_index(index))
    delete!(mock.variable_primal, index)
    delete!(mock.callback_variable_primal, index)
    delete!(mock.variable_basis_status, index)
    return
end

function MOI.delete(mock::MockOptimizer, indices::Vector{MOI.VariableIndex})
    if !mock.delete_allowed && !isempty(indices)
        throw(MOI.DeleteNotAllowed(first(indices)))
    end
    for index in indices
        # The index thrown by `mock.inner_model` would be xored
        MOI.throw_if_not_valid(mock, index)
    end
    MOI.delete(mock.inner_model, xor_index.(indices))
    for index in indices
        delete!(mock.variable_primal, index)
        delete!(mock.callback_variable_primal, index)
        delete!(mock.variable_basis_status, index)
    end
    return
end

function MOI.delete(mock::MockOptimizer, index::MOI.ConstraintIndex)
    if !mock.delete_allowed
        throw(MOI.DeleteNotAllowed(index))
    end
    if !MOI.is_valid(mock, index)
        # The index thrown by `mock.inner_model` would be xored
        throw(MOI.InvalidIndex(index))
    end
    MOI.delete(mock.inner_model, xor_index(index))
    delete!(mock.constraint_dual, index)
    delete!(mock.constraint_basis_status, index)
    return
end

function MOI.modify(
    mock::MockOptimizer,
    c::MOI.ConstraintIndex,
    change::MOI.AbstractFunctionModification,
)
    if !mock.modify_allowed
        throw(MOI.ModifyConstraintNotAllowed(c, change))
    end
    MOI.modify(mock.inner_model, xor_index(c), xor_indices(change))
    return
end

function MOI.set(
    mock::MockOptimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{<:MOI.AbstractFunction,S},
    set::S,
) where {S<:MOI.AbstractSet}
    MOI.set(mock.inner_model, MOI.ConstraintSet(), xor_index(c), set)
    return
end

function MOI.set(
    mock::MockOptimizer,
    ::MOI.ConstraintFunction,
    c::MOI.ConstraintIndex{F},
    func::F,
) where {F<:MOI.AbstractFunction}
    MOI.set(
        mock.inner_model,
        MOI.ConstraintFunction(),
        xor_index(c),
        xor_indices(func),
    )
    return
end

function MOI.modify(
    mock::MockOptimizer,
    obj::MOI.ObjectiveFunction,
    change::MOI.AbstractFunctionModification,
)
    if !mock.modify_allowed
        throw(MOI.ModifyObjectiveNotAllowed(change))
    end
    MOI.modify(mock.inner_model, obj, xor_indices(change))
    return
end

MOI.supports(::MockOptimizer, ::MOI.AbstractSubmittable) = true

function MOI.submit(mock::MockOptimizer, sub::MOI.AbstractSubmittable, args...)
    if !haskey(mock.submitted, sub)
        mock.submitted[sub] = Tuple[]
    end
    push!(mock.submitted[sub], args)
    return
end

# TODO: transform

function MOI.supports_constraint(
    mock::MockOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    return MOI.supports_constraint(mock.inner_model, F, S)
end

function MOI.supports_add_constrained_variable(
    mock::MockOptimizer,
    S::Type{<:MOI.AbstractScalarSet},
)
    return MOI.supports_add_constrained_variable(mock.inner_model, S)
end

function MOI.supports_add_constrained_variables(
    mock::MockOptimizer,
    S::Type{<:MOI.AbstractVectorSet},
)
    return MOI.supports_add_constrained_variables(mock.inner_model, S)
end

# Add this method to avoid ambiguity
function MOI.supports_add_constrained_variables(
    mock::MockOptimizer,
    ::Type{MOI.Reals},
)
    return MOI.supports_add_constrained_variables(mock.inner_model, MOI.Reals)
end

function MOI.copy_to(dest::MockOptimizer, src::MOI.ModelLike)
    return default_copy_to(dest, src)
end

function MOI.supports_incremental_interface(mock::MockOptimizer)
    return MOI.supports_incremental_interface(mock.inner_model)
end

function final_touch(uf::MockOptimizer, index_map)
    return final_touch(uf.inner_model, index_map)
end

"""
    set_mock_optimize!(mock::MockOptimizer, opt::Function...)

Sets multiple `optimize!` functions. The first is to be used the first time
`MOI.optimize!(mock)` is called, the second function is to be used the second
time, ...
"""
function set_mock_optimize!(mock::MockOptimizer, opts::Function...)
    mock.optimize! = _recursive_mock_optimize(opts...)
    return
end

_recursive_mock_optimize(optimize::Function) = optimize

function _recursive_mock_optimize(optimize::Function, tail::Function...)
    return (mock::MockOptimizer) -> begin
        optimize(mock)
        mock.optimize! = _recursive_mock_optimize(tail...)
        return
    end
end

"""
    mock_optimize!(
        mock::MockOptimizer,
        termination_status::MOI.TerminationStatusCode,
        primal::Union{
            Tuple{MOI.ResultStatusCode,<:Vector},
            MOI.ResultStatusCode,
            <:Vector,
        }
        dual_status::MOI.ResultStatusCode,
        constraint_duals::Pair{Tuple{DataType,DataType},<:Vector}...;
        constraint_basis_status = Pair{Tuple{DataType,DataType},<:Vector}[],
        variable_basis_status = MOI.BasisStatusCode[],
        constraint_conflict_status = Pair{Tuple{DataType,DataType},<:Vector}[],
    )

Fake the result of a call to `optimize!` in the mock optimizer by storing the
solution.

## Arguments

 * `termination_status`: defaults to `MOI.OPTIMAL` if not provided.

 * `primal`: pass one of the following: a tuple of `(status, result)`
   corresponding to the `MOI.PrimalStatus` and `MOI.VariablePrimal` attributes,
   or pass a `status` with no result vector, or pass only the result vector. If
   the status is omitted, it is assumed to be `MOI.FEASIBLE_POINT`. The `result`
   vector should correspond to the order of the primal values given by
   `MOI.ListOfVariableIndices`.

 * `dual_status`: corresponds to the `MOI.DualStatus` attribute. If not
   provided, it defaults to `MOI.FEASIBLE_POINT` if constraint duals are
   provided and `MOI.NO_SOLUTION` otherwise.

 * `constraint_duals`: the remaining positional arguments are passed as pairs.
   Each pair is of the form `(F, S) => result`, where `result` is the vector
   of `MOI.ConstraintDual` values for the constraints `F`-in-`S` in the order
   returned by `MOI.ListOfConstraintIndices{F,S}`.

 * `constraint_basis_status`: a vector of pairs similar to `constraint_duals`,
   except this time for the `MOI.ConstraintBasisStatus` attribute.

 * `variable_basis_status`: a vector of `MOI.BasisStatusCode`, corresponding to
   the `MOI.VariableBasisStatus` attribute of the variables in the order
   returned by `MOI.ListOfVariableIndices`.

 * `constraint_conflict_status`: a vector of pairs similar to
   `constraint_duals`, except this time for the `MOI.ConstraintConflictStatus`
   attribute.
"""
function mock_optimize!(
    mock::MockOptimizer,
    termination_status::MOI.TerminationStatusCode,
    primal::Union{
        Tuple{MOI.ResultStatusCode,<:Vector},
        MOI.ResultStatusCode,
        <:Vector,
    },
    dual_status_constraint_duals...;
    constraint_basis_status = [],
    variable_basis_status = MOI.BasisStatusCode[],
    constraint_conflict_status = [],
)
    MOI.set(mock, MOI.TerminationStatus(), termination_status)
    MOI.set(mock, MOI.ResultCount(), 1)
    _set_mock_primal(mock, primal)
    _set_mock_dual(mock, dual_status_constraint_duals...)
    for ((F, S), result) in constraint_basis_status
        indices = MOI.get(mock, MOI.ListOfConstraintIndices{F,S}())
        for (i, ci) in enumerate(indices)
            MOI.set(mock, MOI.ConstraintBasisStatus(), ci, result[i])
        end
    end
    if length(constraint_conflict_status) > 0
        MOI.set(mock, MOI.ConflictCount(), 1)
    end
    for ((F, S), result) in constraint_conflict_status
        indices = MOI.get(mock, MOI.ListOfConstraintIndices{F,S}())
        for (i, ci) in enumerate(indices)
            MOI.set(mock, MOI.ConstraintConflictStatus(), ci, result[i])
        end
    end
    if length(variable_basis_status) > 0
        variables = MOI.get(mock, MOI.ListOfVariableIndices())
        @assert length(variable_basis_status) == length(variables)
        MOI.set.(
            mock,
            MOI.VariableBasisStatus(),
            variables,
            variable_basis_status,
        )
    end
    return
end

# The fallback for default termination_status
function mock_optimize!(
    mock::MockOptimizer,
    primal::Union{
        Tuple{MOI.ResultStatusCode,<:Vector},
        MOI.ResultStatusCode,
        <:Vector,
    },
    args...;
    kwargs...,
)
    mock_optimize!(mock, MOI.OPTIMAL, primal, args...; kwargs...)
    return
end

# The fallback if no primal solution is provided
function mock_optimize!(mock::MockOptimizer, status::MOI.TerminationStatusCode)
    MOI.set(mock, MOI.TerminationStatus(), status)
    MOI.set(mock, MOI.ResultCount(), 0)
    return
end

# _set_mock_primal

function _set_mock_primal(
    mock::MockOptimizer,
    primal::Tuple{MOI.ResultStatusCode,<:Vector},
)
    MOI.set(mock, MOI.PrimalStatus(), primal[1])
    x = MOI.get(mock, MOI.ListOfVariableIndices())
    MOI.set(mock, MOI.VariablePrimal(), x, primal[2])
    return
end

function _set_mock_primal(mock::MockOptimizer, primal::MOI.ResultStatusCode)
    MOI.set(mock, MOI.PrimalStatus(), primal)
    return
end

function _set_mock_primal(mock::MockOptimizer, primal::Vector)
    MOI.set(mock, MOI.PrimalStatus(), MOI.FEASIBLE_POINT)
    x = MOI.get(mock, MOI.ListOfVariableIndices())
    MOI.set(mock, MOI.VariablePrimal(), x, primal)
    return
end

# _set_mock_dual

function _set_mock_dual(mock::MockOptimizer)
    MOI.set(mock, MOI.DualStatus(), MOI.NO_SOLUTION)
    return
end

function _set_mock_dual(
    mock::MockOptimizer,
    dual_status::MOI.ResultStatusCode,
    constraint_duals::Pair...,
)
    MOI.set(mock, MOI.DualStatus(), dual_status)
    for ((F, S), result) in constraint_duals
        indices = MOI.get(mock, MOI.ListOfConstraintIndices{F,S}())
        for (i, ci) in enumerate(indices)
            MOI.set(mock, MOI.ConstraintDual(), ci, result[i])
        end
    end
    return
end

# fallback for no status
function _set_mock_dual(mock::MockOptimizer, args::Pair...)
    _set_mock_dual(mock, MOI.FEASIBLE_POINT, args...)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type AbstractBridge <: MOI.Bridges.AbstractBridge end

Subtype of [`MOI.Bridges.AbstractBridge`](@ref) for variable bridges.

In addition to the required implementation described in
[`MOI.Bridges.AbstractBridge`](@ref), subtypes of `AbstractBridge` must
additionally implement:

 * [`supports_constrained_variable`](@ref)
 * [`concrete_bridge_type`](@ref)
 * [`bridge_constrained_variable`](@ref)
"""
abstract type AbstractBridge <: MOI.Bridges.AbstractBridge end

"""
    supports_constrained_variable(
        BT::Type{<:AbstractBridge},
        S::Type{<:MOI.AbstractSet},
    )::Bool

Return a `Bool` indicating whether the bridges of type `BT` support bridging
constrained variables in `S`. That is, it returns `true` if the bridge of type
`BT` converts constrained variables of type `S` into a form supported by the
solver.

## Implementation notes

 * This method depends only on the type of the bridge and set, not the runtime
   values.
 * There is a default fallback, so you need only implement this method for sets
   that the bridge implements.

## Example

```jldoctest
julia> MOI.Bridges.Variable.supports_constrained_variable(
           MOI.Bridges.Variable.NonposToNonnegBridge{Float64},
           MOI.Nonpositives,
       )
true

julia> MOI.Bridges.Variable.supports_constrained_variable(
           MOI.Bridges.Variable.NonposToNonnegBridge{Float64},
           MOI.Nonnegatives,
       )
false
```
"""
function supports_constrained_variable(
    ::Type{<:AbstractBridge},
    ::Type{<:MOI.AbstractSet},
)
    return false
end

"""
    concrete_bridge_type(
        BT::Type{<:AbstractBridge},
        S::Type{<:MOI.AbstractSet},
    )::Type

Return the concrete type of the bridge supporting variables in `S` constraints.

This function can only be called if `MOI.supports_constrained_variable(BT, S)`
is `true`.

## Example

As a variable in [`MOI.GreaterThan`](@ref) is bridged into
variables in [`MOI.Nonnegatives`](@ref) by the
[`VectorizeBridge`](@ref):

```jldoctest
julia> MOI.Bridges.Variable.concrete_bridge_type(
           MOI.Bridges.Variable.VectorizeBridge{Float64},
           MOI.GreaterThan{Float64},
       )
MathOptInterface.Bridges.Variable.VectorizeBridge{Float64, MathOptInterface.Nonnegatives}
```
"""
concrete_bridge_type(::Type{BT}, ::Type{<:MOI.AbstractSet}) where {BT} = BT

function concrete_bridge_type(
    b::MOI.Bridges.AbstractBridgeOptimizer,
    S::Type{<:MOI.AbstractSet},
)
    return concrete_bridge_type(MOI.Bridges.bridge_type(b, S), S)
end

"""
    bridge_constrained_variable(
        BT::Type{<:AbstractBridge},
        model::MOI.ModelLike,
        set::MOI.AbstractSet,
    )::BT

Bridge the constrained variable in `set` using bridge `BT` to `model` and
returns a bridge object of type `BT`.

## Implementation notes

 * The bridge type `BT` must be a concrete type, that is, all the type
   parameters of the bridge must be set.
"""
function bridge_constrained_variable end

function MOI.get(
    ::MOI.ModelLike,
    attr::MOI.AbstractVariableAttribute,
    bridge::AbstractBridge,
)
    return throw(
        ArgumentError(
            "Variable bridge of type `$(typeof(bridge))` does not support " *
            "accessing the attribute `$attr`.",
        ),
    )
end

function MOI.get(
    ::MOI.ModelLike,
    attr::MOI.AbstractVariableAttribute,
    bridge::AbstractBridge,
    ::MOI.Bridges.IndexInVector,
)
    return throw(
        ArgumentError(
            "Variable bridge of type `$(typeof(bridge))` does not support " *
            "accessing the attribute `$attr`.",
        ),
    )
end

function MOI.supports(
    ::MOI.ModelLike,
    ::MOI.AbstractVariableAttribute,
    ::Type{<:AbstractBridge},
)
    return false
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.AbstractVariableAttribute,
    bridge::AbstractBridge,
    value,
    ::MOI.Bridges.IndexInVector...,
)
    if MOI.is_copyable(attr) && !MOI.supports(model, attr, typeof(bridge))
        throw(MOI.UnsupportedAttribute(attr))
    else
        throw(MOI.SetAttributeNotAllowed(attr))
    end
end

"""
    unbridged_map(
       bridge::MOI.Bridges.Variable.AbstractBridge,
        vi::MOI.VariableIndex,
    )

For a bridged variable in a scalar set, return a tuple of pairs mapping the
variables created by the bridge to an affine expression in terms of the
bridged variable `vi`.

```julia
unbridged_map(
    bridge::MOI.Bridges.Variable.AbstractBridge,
    vis::Vector{MOI.VariableIndex},
)
```

For a bridged variable in a vector set, return a tuple of pairs mapping the
variables created by the bridge to an affine expression in terms of the bridged
variable `vis`. If this method is not implemented, it falls back to calling
the following method for every variable of `vis`.

```julia
unbridged_map(
    bridge::MOI.Bridges.Variable.AbstractBridge,
    vi::MOI.VariableIndex,
    i::MOI.Bridges.IndexInVector,
)
```

For a bridged variable in a vector set, return a tuple of pairs mapping the
variables created by the bridge to an affine expression in terms of the bridged
variable `vi` corresponding to the `i`th variable of the vector.

If there is no way to recover the expression in terms of the bridged variable(s)
`vi(s)`, return `nothing`. See [`ZerosBridge`](@ref) for an example of bridge
returning `nothing`.
"""
function unbridged_map end

function unbridged_map(bridge::AbstractBridge, vis::Vector{MOI.VariableIndex})
    mappings = Pair{MOI.VariableIndex,MOI.AbstractScalarFunction}[]
    for (i, vi) in enumerate(vis)
        vi_mappings = unbridged_map(bridge, vi, MOI.Bridges.IndexInVector(i))
        if vi_mappings === nothing
            return
        end
        for mapping in vi_mappings
            push!(mappings, mapping)
        end
    end
    return mappings
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraints

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
end

function _constant_not_zero_test(::Type{T}) where {T}
    S = MOI.EqualTo{T}
    x = MOI.VariableIndex(1)
    @test nothing === MOI.throw_if_scalar_and_constant_not_zero(x, S)
    func1 = one(T) * x + one(T)
    @test_throws MOI.ScalarFunctionConstantNotZero begin
        MOI.throw_if_scalar_and_constant_not_zero(func1, S)
    end
    func2 = one(T) * x
    @test nothing === MOI.throw_if_scalar_and_constant_not_zero(func2, S)
    func = MOI.Utilities.operate(vcat, T, func1, func2)
    @test nothing === MOI.throw_if_scalar_and_constant_not_zero(func, MOI.Zeros)
end

function test_constraints_ConstantNotZero()
    _constant_not_zero_test(Int)
    _constant_not_zero_test(Float64)
    return
end

function test_LowerBoundAlreadySet_error()
    x = MOI.VariableIndex(1)
    S1 = MOI.LessThan{Int}
    S2 = MOI.Interval{Int}
    err = MOI.LowerBoundAlreadySet{S1,S2}(x)
    @test err isa Exception
    @test sprint(showerror, err) ==
          "$(typeof(err)): Cannot add `VariableIndex`-in-`$(S2)` constraint " *
          "for variable $(x) as a `VariableIndex`-in-`$(S1)` constraint was " *
          "already set for this variable and both constraints set a lower bound."
    return
end

function test_UpperBoundAlreadySet_error()
    x = MOI.VariableIndex(1)
    S1 = MOI.GreaterThan{Int}
    S2 = MOI.Interval{Int}
    err = MOI.UpperBoundAlreadySet{S1,S2}(x)
    @test err isa Exception
    @test sprint(showerror, err) ==
          "$(typeof(err)): Cannot add `VariableIndex`-in-`$(S2)` constraint " *
          "for variable $(x) as a `VariableIndex`-in-`$(S1)` constraint was " *
          "already set for this variable and both constraints set an upper bound."
    return
end

function test_ScalarFunctionConstantNotZero_error()
    x = MOI.VariableIndex(1)
    T = Int
    F = MOI.ScalarAffineFunction{T}
    S = MOI.EqualTo{T}
    err = MOI.ScalarFunctionConstantNotZero{T,F,S}(one(T))
    @test sprint(showerror, err) ==
          "In `$F`-in-`$S` constraint: Constant $(one(T)) of the function is " *
          "not zero. The function constant should be moved to the set. You can " *
          "use `MOI.Utilities.normalize_and_add_constraint` which does this " *
          "automatically."
    return
end

function test_scalar_nonlinear_function_add_constraint()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(
        :+,
        Any[x, MOI.ScalarNonlinearFunction(:sin, Any[x])],
    )
    c = MOI.add_constraint(model, f, MOI.EqualTo(0.0))
    @test isapprox(MOI.get(model, MOI.ConstraintFunction(), c), f)
    return
end

end

TestConstraints.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    HermitianToSymmetricPSDBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`HermitianToSymmetricPSDBridge` implements the following reformulation:

  * Hermitian positive semidefinite `n x n` complex matrix to a symmetric
    positive semidefinite `2n x 2n` real matrix.

See also [`MOI.Bridges.Variable.HermitianToSymmetricPSDBridge`](@ref).

## Source node

`HermitianToSymmetricPSDBridge` supports:

  * `G` in [`MOI.HermitianPositiveSemidefiniteConeTriangle`](@ref)

## Target node

`HermitianToSymmetricPSDBridge` creates:

  * `F` in [`MOI.PositiveSemidefiniteConeTriangle`](@ref)

## Reformulation

The reformulation is best described by example.

The Hermitian matrix:
```math
\\begin{bmatrix}
  x_{11}            & x_{12} + y_{12}im & x_{13} + y_{13}im\\\\
  x_{12} - y_{12}im & x_{22}            & x_{23} + y_{23}im\\\\
  x_{13} - y_{13}im & x_{23} - y_{23}im & x_{33}
\\end{bmatrix}
```
is positive semidefinite if and only if the symmetric matrix:
```math
\\begin{bmatrix}
    x_{11} & x_{12} & x_{13} & 0       & y_{12}  & y_{13} \\\\
           & x_{22} & x_{23} & -y_{12} & 0       & y_{23} \\\\
           &        & x_{33} & -y_{13} & -y_{23} & 0      \\\\
           &        &        & x_{11}  & x_{12}  & x_{13} \\\\
           &        &        &         & x_{22}  & x_{23} \\\\
           &        &        &         &         & x_{33}
\\end{bmatrix}
```
is positive semidefinite.

The bridge achieves this reformulation by constraining the above matrix to
belong to the `MOI.PositiveSemidefiniteConeTriangle(6)`.
"""
struct HermitianToSymmetricPSDBridge{T,F,G} <: SetMapBridge{
    T,
    MOI.PositiveSemidefiniteConeTriangle,
    MOI.HermitianPositiveSemidefiniteConeTriangle,
    F,
    G,
}
    constraint::MOI.ConstraintIndex{F,MOI.PositiveSemidefiniteConeTriangle}
end

const HermitianToSymmetricPSD{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{HermitianToSymmetricPSDBridge{T},OT}

function _promote_minus_vcat(::Type{T}, ::Type{G}) where {T,G}
    S = MOI.Utilities.scalar_type(G)
    M = MOI.Utilities.promote_operation(-, T, S)
    F = MOI.Utilities.promote_operation(vcat, T, S, M, T)
    return F
end

function concrete_bridge_type(
    ::Type{<:HermitianToSymmetricPSDBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.HermitianPositiveSemidefiniteConeTriangle},
) where {T}
    F = _promote_minus_vcat(T, G)
    return HermitianToSymmetricPSDBridge{T,F,G}
end

function MOI.Bridges.map_set(
    ::Type{<:HermitianToSymmetricPSDBridge},
    set::MOI.HermitianPositiveSemidefiniteConeTriangle,
)
    return MOI.PositiveSemidefiniteConeTriangle(2set.side_dimension)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:HermitianToSymmetricPSDBridge},
    set::MOI.PositiveSemidefiniteConeTriangle,
)
    dim = set.side_dimension
    @assert iseven(dim)
    return MOI.HermitianPositiveSemidefiniteConeTriangle(div(dim, 2))
end

function MOI.Bridges.map_function(
    ::Type{<:HermitianToSymmetricPSDBridge{T}},
    func,
) where {T}
    complex_scalars = MOI.Utilities.eachscalar(func)
    S = MOI.Utilities.scalar_type(_promote_minus_vcat(T, typeof(func)))
    complex_dim = length(complex_scalars)
    complex_set = MOI.Utilities.set_with_dimension(
        MOI.HermitianPositiveSemidefiniteConeTriangle,
        complex_dim,
    )
    n = complex_set.side_dimension
    real_set = MOI.PositiveSemidefiniteConeTriangle(2n)
    real_dim = MOI.dimension(real_set)
    real_scalars = Vector{S}(undef, real_dim)
    complex_index = 0
    half_real_set = MOI.PositiveSemidefiniteConeTriangle(n)
    half_real_dim = MOI.dimension(half_real_set)
    real_index_1 = 0
    # `+ n` is for jumping over the indices corresponding to the imaginary part
    real_index_2 = half_real_dim + n
    for j in 1:n
        for i in 1:j
            complex_index += 1
            real_index_1 += 1
            real_scalars[real_index_1] = complex_scalars[complex_index]
            real_index_2 += 1
            real_scalars[real_index_2] = complex_scalars[complex_index]
            if i == j
                # We are at the end of a column so we do `+ n` for jumping over
                # the indices corresponding to the imaginary part
                real_index_2 += n
            end
        end
    end
    # Index corresponding to the upper triangular part
    real_index_1 = half_real_dim
    for j in 1:n
        for i in 1:(j-1)
            complex_index += 1
            real_index_1 += 1
            real_scalars[real_index_1] = complex_scalars[complex_index]
            real_scalars[MOI.Utilities.trimap(j, n + i)] =
                MOI.Utilities.operate(-, T, complex_scalars[complex_index])
        end
        real_scalars[real_index_1+1] = zero(S)
        # jump over the lower triangular part and the (2, 2) block
        real_index_1 += n + 1
    end
    @assert length(complex_scalars) == complex_index
    return MOI.Utilities.vectorize(real_scalars)
end

function MOI.Bridges.inverse_map_function(
    ::Type{<:HermitianToSymmetricPSDBridge},
    func,
)
    real_scalars = MOI.Utilities.eachscalar(func)
    real_set = MOI.Utilities.set_with_dimension(
        MOI.PositiveSemidefiniteConeTriangle,
        length(real_scalars),
    )
    @assert iseven(real_set.side_dimension)
    n = div(real_set.side_dimension, 2)
    complex_set = MOI.HermitianPositiveSemidefiniteConeTriangle(n)
    complex_scalars =
        Vector{eltype(real_scalars)}(undef, MOI.dimension(complex_set))
    real_index = 0
    complex_index = 0
    for j in 1:n
        for i in 1:j
            complex_index += 1
            real_index += 1
            complex_scalars[complex_index] = real_scalars[real_index]
        end
    end
    for j in 1:n
        for i in 1:(j-1)
            complex_index += 1
            real_index += 1
            complex_scalars[complex_index] = real_scalars[real_index]
        end
        real_index += n + 1
    end
    @assert length(complex_scalars) == complex_index
    return MOI.Utilities.vectorize(complex_scalars)
end

function MOI.Bridges.adjoint_map_function(
    BT::Type{<:HermitianToSymmetricPSDBridge},
    func,
)
    real_scalars = MOI.Utilities.eachscalar(func)
    real_dim = length(real_scalars)
    real_set = MOI.Utilities.set_with_dimension(
        MOI.PositiveSemidefiniteConeTriangle,
        real_dim,
    )
    @assert iseven(real_set.side_dimension)
    n = div(real_set.side_dimension, 2)
    complex_set = MOI.HermitianPositiveSemidefiniteConeTriangle(n)
    complex_scalars =
        Vector{eltype(real_scalars)}(undef, MOI.dimension(complex_set))
    complex_index = 0
    half_real_set = MOI.PositiveSemidefiniteConeTriangle(n)
    half_real_dim = MOI.dimension(half_real_set)
    real_index_1 = 0
    real_index_2 = half_real_dim + n
    for j in 1:n
        for i in 1:j
            complex_index += 1
            real_index_1 += 1
            real_index_2 += 1
            complex_scalars[complex_index] =
                real_scalars[real_index_1] + real_scalars[real_index_2]
            if i == j
                real_index_2 += n
            end
        end
    end
    real_index_1 = half_real_dim
    for j in 1:n
        for i in 1:(j-1)
            complex_index += 1
            real_index_1 += 1
            complex_scalars[complex_index] =
                real_scalars[real_index_1] -
                real_scalars[MOI.Utilities.trimap(j, i + n)]
        end
        real_index_1 += n + 1
    end
    @assert length(complex_scalars) == complex_index
    return MOI.Utilities.vectorize(complex_scalars)
end

# FIXME
# It's not so clear how to do this one since the adjoint is not invertible
# and it's not obvious how to generate a PSD matrix in the preimage.
# The following heuristic may not be the best:
function MOI.Bridges.inverse_adjoint_map_function(
    BT::Type{<:HermitianToSymmetricPSDBridge{T}},
    func,
) where {T}
    complex_scalars = MOI.Utilities.eachscalar(func)
    S = MOI.Utilities.scalar_type(_promote_minus_vcat(T, typeof(func)))
    complex_dim = length(complex_scalars)
    complex_set = MOI.Utilities.set_with_dimension(
        MOI.HermitianPositiveSemidefiniteConeTriangle,
        complex_dim,
    )
    n = complex_set.side_dimension
    real_set = MOI.PositiveSemidefiniteConeTriangle(2n)
    real_dim = MOI.dimension(real_set)
    real_scalars = Vector{S}(undef, real_dim)
    complex_index = 0
    half_real_set = MOI.PositiveSemidefiniteConeTriangle(n)
    half_real_dim = MOI.dimension(half_real_set)
    real_index_1 = 0
    real_index_2 = half_real_dim + n
    for j in 1:n
        for i in 1:j
            complex_index += 1
            real_index_1 += 1
            real_scalars[real_index_1] = complex_scalars[complex_index] / 2
            real_index_2 += 1
            real_scalars[real_index_2] = complex_scalars[complex_index] / 2
            if i == j
                real_index_2 += n
            end
        end
    end
    real_index_1 = half_real_dim
    for j in 1:n
        for i in 1:(j-1)
            complex_index += 1
            real_index_1 += 1
            real_scalars[real_index_1] = complex_scalars[complex_index]
            real_scalars[MOI.Utilities.trimap(j, i + n)] = zero(S)
        end
        real_scalars[real_index_1+1] = zero(S)
        real_index_1 += n + 1
    end
    @assert length(complex_scalars) == complex_index
    return MOI.Utilities.vectorize(real_scalars)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestCachingOptimizerRuntests

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_MOI_Test()
    # It seems like these loops might take a while. But the first one takes
    # _forever_, and then the rest are really quick (like 140s vs 0.4s).
    for state in (
        MOI.Utilities.NO_OPTIMIZER,
        MOI.Utilities.EMPTY_OPTIMIZER,
        MOI.Utilities.ATTACHED_OPTIMIZER,
    )
        for mode in (MOI.Utilities.MANUAL, MOI.Utilities.AUTOMATIC)
            _test_caching_optimizer(state, mode)
        end
    end
    return
end

function _test_caching_optimizer(state, mode)
    model = MOI.Utilities.CachingOptimizer(MOI.Utilities.Model{Float64}(), mode)
    if state != MOI.Utilities.NO_OPTIMIZER
        optimizer = MOI.Utilities.MockOptimizer(
            MOI.Utilities.Model{Float64}(),
            supports_names = false,
        )
        MOI.Utilities.reset_optimizer(model, optimizer)
        if state == MOI.Utilities.ATTACHED_OPTIMIZER
            MOI.Utilities.attach_optimizer(model)
        end
    end
    @test MOI.Utilities.state(model) == state
    @test MOI.Utilities.mode(model) == mode
    MOI.Test.runtests(
        model,
        MOI.Test.Config(exclude = Any[MOI.optimize!]),
        exclude = ["test_attribute_SolverName", "test_attribute_SolverVersion"],
    )
    return
end

end  # module

TestCachingOptimizerRuntests.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ExponentialConeToScalarNonlinearFunctionBridge{T,F} <:
        Bridges.Constraint.AbstractBridge

`ExponentialConeToScalarNonlinearFunctionBridge` implements the following
reformulation:

  * ``(x, y, z) \\in \\textsf{ExponentialCone}()`` to
    ``y \\cdot exp(x / y)) - z \\le 0``, ``y \\ge 0``.

## Source node

`ExponentialConeToScalarNonlinearFunctionBridge` supports:

  * `F` in [`MOI.ExponentialCone`](@ref)

## Target nodes

`ExponentialConeToScalarNonlinearFunctionBridge` creates:

  * [`MOI.ScalarNonlinearFunction`](@ref) in [`MOI.LessThan{T}`](@ref)
  * [`MOI.ScalarAffineFunction`](@ref) in [`MOI.GreaterThan{T}`](@ref)
"""
mutable struct ExponentialConeToScalarNonlinearFunctionBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
} <: AbstractBridge
    f::F
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,MOI.LessThan{T}}
    ci_y::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}}
end

const ExponentialConeToScalarNonlinearFunction{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ExponentialConeToScalarNonlinearFunctionBridge{T},OT}

function bridge_constraint(
    ::Type{ExponentialConeToScalarNonlinearFunctionBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.ExponentialCone,
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    x, y, z = MOI.Utilities.scalarize(f)
    g_x_div_y = MOI.ScalarNonlinearFunction(:/, Any[x, y])
    g_exp_x_div_y = MOI.ScalarNonlinearFunction(:exp, Any[g_x_div_y])
    g = MOI.ScalarNonlinearFunction(
        :-,
        Any[MOI.ScalarNonlinearFunction(:*, Any[y, g_exp_x_div_y]), z],
    )
    ci = MOI.add_constraint(model, g, MOI.LessThan(zero(T)))
    # We add this as a constraint to avoid conflicting with existing variable
    # bounds, of which there can be at most one of.
    ci_y = MOI.add_constraint(model, one(T) * y, MOI.GreaterThan(zero(T)))
    return ExponentialConeToScalarNonlinearFunctionBridge{T,F}(f, ci, ci_y)
end

function MOI.supports_constraint(
    ::Type{<:ExponentialConeToScalarNonlinearFunctionBridge{T}},
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}},
    ::Type{MOI.ExponentialCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{ExponentialConeToScalarNonlinearFunctionBridge{T,F}},
) where {T,F}
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{ExponentialConeToScalarNonlinearFunctionBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[
        (MOI.ScalarNonlinearFunction, MOI.LessThan{T}),
        (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:ExponentialConeToScalarNonlinearFunctionBridge{T}},
    ::Type{F},
    ::Type{MOI.ExponentialCone},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return ExponentialConeToScalarNonlinearFunctionBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::ExponentialConeToScalarNonlinearFunctionBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    ::ExponentialConeToScalarNonlinearFunctionBridge,
)
    return MOI.ExponentialCone()
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::ExponentialConeToScalarNonlinearFunctionBridge,
)
    MOI.delete(model, bridge.ci)
    MOI.delete(model, bridge.ci_y)
    return
end

function MOI.get(
    ::ExponentialConeToScalarNonlinearFunctionBridge,
    ::MOI.NumberOfVariables,
)::Int64
    return 0
end

function MOI.get(
    ::ExponentialConeToScalarNonlinearFunctionBridge,
    ::MOI.ListOfVariableIndices,
)::Vector{MOI.VariableIndex}
    return MOI.VariableIndex[]
end

function MOI.get(
    ::ExponentialConeToScalarNonlinearFunctionBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarNonlinearFunction,MOI.LessThan{T}},
)::Int64 where {T}
    return 1
end

function MOI.get(
    bridge::ExponentialConeToScalarNonlinearFunctionBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarNonlinearFunction,MOI.LessThan{T}},
) where {T}
    return [bridge.ci]
end

function MOI.get(
    ::ExponentialConeToScalarNonlinearFunctionBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}},
)::Int64 where {T}
    return 1
end

function MOI.get(
    bridge::ExponentialConeToScalarNonlinearFunctionBridge{T},
    ::MOI.ListOfConstraintIndices{
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    },
) where {T}
    return [bridge.ci_y]
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableParameter

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.ParameterToEqualToBridge,
        """
        constrainedvariable: x in Parameter(2.0)
        minobjective: 1.0 * x + 2.0
        """,
        """
        constrainedvariable: x in EqualTo(2.0)
        minobjective: 1.0 * x + 2.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.ParameterToEqualToBridge,
        """
        constrainedvariable: x in Parameter(-2.0)
        minobjective: 1.0 * x + 2.0
        """,
        """
        constrainedvariable: x in EqualTo(-2.0)
        minobjective: 1.0 * x + 2.0
        """,
    )
    return
end

function test_delete()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Variable.ParameterToEqualTo{Float64}(inner)
    x, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test !MOI.is_empty(inner)
    MOI.delete(model, x)
    @test MOI.is_empty(inner)
    @test MOI.is_empty(model)
    x, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test_throws MOI.DeleteNotAllowed MOI.delete(model, ci)
    return
end

function test_constraint_function()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Variable.ParameterToEqualTo{Float64}(inner)
    x, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    y, bridge = first(model.map)
    @test y == x
    x_inner = MOI.get(model, MOI.ConstraintFunction(), bridge)
    @test MOI.get(inner, MOI.ListOfVariableIndices()) == [x_inner]
    return
end

function test_list_of_constraint_indices()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Variable.ParameterToEqualTo{Float64}(inner)
    x, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    F, S = MOI.VariableIndex, MOI.EqualTo{Float64}
    @test isempty(MOI.get(model, MOI.ListOfConstraintIndices{F,S}()))
    return
end

function test_VariablePrimalStart()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.ParameterToEqualTo{Float64}(inner)
    x, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
    MOI.set(model, MOI.VariablePrimalStart(), x, 2.0)
    @test MOI.get(model, MOI.VariablePrimalStart(), x) == 2.0
    MOI.set(model, MOI.VariablePrimalStart(), x, nothing)
    @test MOI.get(model, MOI.VariablePrimalStart(), x) === nothing
    return
end

function test_ConstraintPrimalStart()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.ParameterToEqualTo{Float64}(inner)
    x, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test MOI.supports(model, MOI.ConstraintPrimalStart(), typeof(ci))
    MOI.set(model, MOI.ConstraintPrimalStart(), ci, 2.0)
    @test MOI.get(model, MOI.ConstraintPrimalStart(), ci) == 2.0
    MOI.set(model, MOI.ConstraintPrimalStart(), ci, nothing)
    @test MOI.get(model, MOI.ConstraintPrimalStart(), ci) === nothing
    return
end

function test_ConstraintDualStart()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.ParameterToEqualTo{Float64}(inner)
    x, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.0))
    @test MOI.supports(model, MOI.ConstraintDualStart(), typeof(ci))
    MOI.set(model, MOI.ConstraintDualStart(), ci, 2.0)
    @test MOI.get(model, MOI.ConstraintDualStart(), ci) == 2.0
    MOI.set(model, MOI.ConstraintDualStart(), ci, nothing)
    @test MOI.get(model, MOI.ConstraintDualStart(), ci) === nothing
    return
end

end  # module

TestVariableParameter.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintGeomean

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_GeoMean_basic()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.GeoMean{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        MOI.Test.Config(),
        include = [
            "test_basic_VectorOfVariables_GeometricMeanCone",
            "test_basic_VectorAffineFunction_GeometricMeanCone",
            "test_basic_VectorQuadraticFunction_GeometricMeanCone",
        ],
    )
    return
end

function test_conic_GeometricMeanCone_VectorAffineFunction()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.GeoMean{Float64}(mock)
    var_primal = vcat(ones(4), 2, √2, √2)
    rsoc_duals = [[√2, √2, -2] / 3, [1, 1, -√2] / 3, [1, 1, -√2] / 3]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1, -inv(3)],
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone) => rsoc_duals,
        )
    MOI.Test.test_conic_GeometricMeanCone_VectorOfVariables(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_conic_GeometricMeanCone_VectorAffineFunction(
        bridged_mock,
        config,
    )
    var_names = ["t", "x", "y", "z", "x21", "x11", "x12"]
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    lessthan = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(lessthan) == 2
    MOI.set.(mock, MOI.ConstraintName(), lessthan, ["lessthan1", "lessthan2"])
    rsoc = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.RotatedSecondOrderCone,
        }(),
    )
    @test length(rsoc) == 3
    MOI.set.(mock, MOI.ConstraintName(), rsoc, ["rsoc21", "rsoc11", "rsoc12"])
    s = """
    variables: t, x, y, z, x21, x11, x12
    lessthan1: t + -0.5 * x21 in LessThan(0.0)
    lessthan2: x + y + z in LessThan(3.0)
    rsoc11: [1.0x, y, x11] in RotatedSecondOrderCone(3)
    rsoc12: [z, 0.5 * x21, x12] in RotatedSecondOrderCone(3)
    rsoc21: [1.0x11, x12, x21] in RotatedSecondOrderCone(3)
    maxobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        var_names,
        ["lessthan1", "lessthan2", "rsoc11", "rsoc12", "rsoc21"],
    )
    var_names = ["t", "x", "y", "z"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    lessthan = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(lessthan) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), lessthan[1], "lessthan")
    geomean = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.GeometricMeanCone,
        }(),
    )
    @test length(geomean) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), geomean[1], "geomean")
    s = """
    variables: t, x, y, z
    lessthan: x + y + z in LessThan(3.0)
    geomean: [1.0t, x, y, z] in GeometricMeanCone(4)
    maxobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["lessthan", "geomean"],
    )
    # set primal/dual start is not yet implemented for GeoMean bridge
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.GeometricMeanCone,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        4,
        (
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 1),
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 0),
        ),
    )
    return
end

function test_conic_GeometricMeanCone_VectorAffineFunction_2()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.GeoMean{Float64}(mock)
    var_primal = vcat(ones(10), 4.0, fill(2 * √2, 2), fill(2, 4), fill(√2, 8))
    rsoc_duals = vcat(
        [[1 / √2, 1 / √2, -1] * 4 / 9],
        fill([1, 1, -√2] * 2 / 9, 2),
        fill([1 / √2, 1 / √2, -1] * 2 / 9, 4),
        fill([1, 1, -√2] * 1 / 9, 8),
    )
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                fill(-inv(9), 9),
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone) => rsoc_duals,
        )
    MOI.Test.test_conic_GeometricMeanCone_VectorOfVariables_2(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_conic_GeometricMeanCone_VectorAffineFunction_2(
        bridged_mock,
        config,
    )
    x_names = ["x$(i)" for i in 1:9]
    l1_names = ["x1$(i)" for i in 1:8]
    l2_names = ["x2$(i)" for i in 1:4]
    l3_names = ["x3$(i)" for i in 1:2]
    var_names = vcat("t", x_names, "x41", l3_names, l2_names, l1_names)
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    lessthan = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(lessthan) == 1
    MOI.set(mock, MOI.ConstraintName(), lessthan[1], "lessthan")
    equalto = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.EqualTo{Float64},
        }(),
    )
    @test length(equalto) == 9
    equalto_names = ["equalto$(i)" for i in 1:9]
    MOI.set.(mock, MOI.ConstraintName(), equalto, equalto_names)
    rsoc = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.RotatedSecondOrderCone,
        }(),
    )
    @test length(rsoc) == 15
    rsoc_names = vcat(
        "rsoc41",
        ["rsoc3$(i)" for i in 1:2],
        ["rsoc2$(i)" for i in 1:4],
        ["rsoc1$(i)" for i in 1:8],
    )
    MOI.set.(mock, MOI.ConstraintName(), rsoc, rsoc_names)
    varnames_str = vcat("t", [", " * v for v in var_names[2:end]])
    s = """
    variables: $(varnames_str...)
    lessthan: t + -0.25 * x41 in LessThan(0.0)
    equalto1: 1.0x1 in EqualTo(1.0)
    equalto2: 1.0x2 in EqualTo(1.0)
    equalto3: 1.0x3 in EqualTo(1.0)
    equalto4: 1.0x4 in EqualTo(1.0)
    equalto5: 1.0x5 in EqualTo(1.0)
    equalto6: 1.0x6 in EqualTo(1.0)
    equalto7: 1.0x7 in EqualTo(1.0)
    equalto8: 1.0x8 in EqualTo(1.0)
    equalto9: 1.0x9 in EqualTo(1.0)
    rsoc41: [1.0x31, x32, x41] in RotatedSecondOrderCone(3)
    rsoc31: [1.0x21, x22, x31] in RotatedSecondOrderCone(3)
    rsoc32: [1.0x23, x24, x32] in RotatedSecondOrderCone(3)
    rsoc21: [1.0x11, x12, x21] in RotatedSecondOrderCone(3)
    rsoc22: [1.0x13, x14, x22] in RotatedSecondOrderCone(3)
    rsoc23: [1.0x15, x16, x23] in RotatedSecondOrderCone(3)
    rsoc24: [1.0x17, x18, x24] in RotatedSecondOrderCone(3)
    rsoc11: [1.0x1, x2, x11] in RotatedSecondOrderCone(3)
    rsoc12: [1.0x3, x4, x12] in RotatedSecondOrderCone(3)
    rsoc13: [1.0x5, x6, x13] in RotatedSecondOrderCone(3)
    rsoc14: [1.0x7, x8, x14] in RotatedSecondOrderCone(3)
    rsoc15: [1.0x9, 0.25 * x41, x15] in RotatedSecondOrderCone(3)
    rsoc16: [0.25 * x41, 0.25 * x41, x16] in RotatedSecondOrderCone(3)
    rsoc17: [0.25 * x41, 0.25 * x41, x17] in RotatedSecondOrderCone(3)
    rsoc18: [0.25 * x41, 0.25 * x41, x18] in RotatedSecondOrderCone(3)
    maxobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        var_names,
        vcat("lessthan", equalto_names, rsoc_names),
    )
    var_names = vcat("t", ["x$(i)" for i in 1:9])
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    equalto = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.EqualTo{Float64},
        }(),
    )
    @test length(equalto) == 9
    equalto_names = ["equalto$(i)" for i in 1:9]
    MOI.set.(bridged_mock, MOI.ConstraintName(), equalto, equalto_names)
    geomean = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.GeometricMeanCone,
        }(),
    )
    @test length(geomean) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), geomean[1], "geomean")

    s = """
    variables: t, x1, x2, x3, x4, x5, x6, x7, x8, x9
    equalto1: 1.0x1 in EqualTo(1.0)
    equalto2: 1.0x2 in EqualTo(1.0)
    equalto3: 1.0x3 in EqualTo(1.0)
    equalto4: 1.0x4 in EqualTo(1.0)
    equalto5: 1.0x5 in EqualTo(1.0)
    equalto6: 1.0x6 in EqualTo(1.0)
    equalto7: 1.0x7 in EqualTo(1.0)
    equalto8: 1.0x8 in EqualTo(1.0)
    equalto9: 1.0x9 in EqualTo(1.0)
    geomean: [1.0t, x1, x2, x3, x4, x5, x6, x7, x8, x9] in GeometricMeanCone(10)
    maxobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        vcat(equalto_names, "geomean"),
    )
    # set primal/dual start is not yet implemented for GeoMean bridge
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.GeometricMeanCone,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        10,
        (
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 0),
        ),
    )
    return
end

function test_conic_GeometricMeanCone_VectorAffineFunction_3()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.GeoMean{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [2, 2],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-2, -2],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) => [[0]],
        )
    MOI.Test.test_conic_GeometricMeanCone_VectorOfVariables_3(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_conic_GeometricMeanCone_VectorAffineFunction_3(
        bridged_mock,
        config,
    )
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        ["t", "x"],
    )
    lessthan = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(lessthan) == 2
    MOI.set.(mock, MOI.ConstraintName(), lessthan, ["lessthan1", "lessthan2"])
    rsoc = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.RotatedSecondOrderCone,
        }(),
    )
    @test isempty(rsoc)
    nonneg = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Nonnegatives,
        }(),
    )
    @test length(nonneg) == 1
    MOI.set(mock, MOI.ConstraintName(), nonneg[1], "nonneg")

    s = """
    variables: t, x
    lessthan1: t + -1.0x in LessThan(0.0)
    lessthan2: 1.0x in LessThan(2.0)
    nonneg: [1.0x] in Nonnegatives(1)
    maxobjective: 2.0 * t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        ["t", "x"],
        ["lessthan1", "lessthan2", "nonneg"],
    )
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        ["t", "x"],
    )
    lessthan = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(lessthan) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), lessthan[1], "lessthan")
    geomean = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.GeometricMeanCone,
        }(),
    )
    @test length(geomean) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), geomean[1], "geomean")

    s = """
    variables: t, x
    lessthan: 1.0x in LessThan(2.0)
    geomean: [1.0t, x] in GeometricMeanCone(2)
    maxobjective: 2.0 * t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        ["t", "x"],
        ["lessthan", "geomean"],
    )
    # set primal/dual start is not yet implemented for GeoMean bridge
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.GeometricMeanCone,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 1),
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 0),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GeoMeanBridge,
        """
        variables: t, x1, x2, x3
        [t, x1, x2, x3] in GeometricMeanCone(4)
        """,
        """
        variables: t, x1, x2, x3, y1, y2, y3
        1.0 * t + -0.5 * y1 <= 0.0
        [1.0 * y2, 1.0 * y3, 1.0 * y1] in RotatedSecondOrderCone(3)
        [1.0 * x1, 1.0 * x2, 1.0 * y2] in RotatedSecondOrderCone(3)
        [1.0 * x3, 0.5 * y1, 1.0 * y3] in RotatedSecondOrderCone(3)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GeoMeanBridge,
        """
        variables: t, x1
        [t, x1] in GeometricMeanCone(2)
        """,
        """
        variables: t, x1
        1.0 * t + -1.0 * x1 <= 0.0
        [x1] in Nonnegatives(1)
        """,
    )
    return
end

end  # module

TestConstraintGeomean.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestUtilitiesSets

using SparseArrays
using Test
import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_diagonal_element()
    k = 0
    for j in 1:10
        for i in 1:j
            k += 1
            @test MOIU.is_diagonal_vectorized_index(k) == (i == j)
        end
    end
    for side_dim in 1:10
        set = MOI.PositiveSemidefiniteConeTriangle(side_dim)
        vec_dim = MOI.dimension(set)
        @test MOIU.side_dimension_for_vectorized_dimension(vec_dim) == side_dim
    end
    # There is an alternative way to compute it so let's check that
    # they match.
    # We have `d*(d+1)/2 = n` so
    # `d² + d - 2n = 0` hence `d = (-1 ± √(1 + 8n)) / 2`
    # The integer `√(1 + 8n)` is odd and `√(1 + 8n) - 1` is even.
    # We can drop the `- 1` as `div` already discards it.
    for n in 1:100
        @test div(isqrt(1 + 8n), 2) ==
              MOIU.side_dimension_for_vectorized_dimension(n)
    end
    return
end

function test_side_dimension()
    for side_dim in 1:10
        set = MOI.PositiveSemidefiniteConeTriangle(side_dim)
        vec_dim = MOI.dimension(set)
        @test MOIU.side_dimension_for_vectorized_dimension(vec_dim) == side_dim
    end
    return
end

function test_shifts()
    @test MOIU.supports_shift_constant(MOI.EqualTo{Int})
    @test MOIU.shift_constant(MOI.EqualTo(3), 1) == MOI.EqualTo(4)
    @test MOIU.shift_constant(MOI.EqualTo(3), im) == MOI.EqualTo(3 + im)
    @test MOIU.supports_shift_constant(MOI.GreaterThan{Int})
    @test MOIU.shift_constant(MOI.GreaterThan(6), -1) == MOI.GreaterThan(5)
    @test MOIU.shift_constant(MOI.GreaterThan(6), -1.0) == MOI.GreaterThan(5.0)
    @test MOIU.supports_shift_constant(MOI.LessThan{Int})
    @test MOIU.shift_constant(MOI.LessThan(2), 2) == MOI.LessThan(4)
    @test MOIU.shift_constant(MOI.LessThan(2), 2.0) == MOI.LessThan(4.0)
    @test MOIU.supports_shift_constant(MOI.Interval{Int})
    @test MOIU.shift_constant(MOI.Interval(-2, 3), 1) == MOI.Interval(-1, 4)
    @test MOIU.supports_shift_constant(MOI.ZeroOne) == false
    @test_throws MethodError MOIU.shift_constant(MOI.ZeroOne(), 1.0)
    @test MOIU.supports_shift_constant(MOI.Parameter{Int})
    @test MOIU.shift_constant(MOI.Parameter(3), 1) == MOI.Parameter(4)
    return
end

function test_set_dot()
    vec = zeros(6)
    @test MOIU.set_dot(vec, vec, MOI.SecondOrderCone(6)) == 0
    @test MOIU.set_dot(vec, vec, MOI.PositiveSemidefiniteConeTriangle(3)) == 0
    @test MOIU.set_dot(vec, vec, MOI.PositiveSemidefiniteConeSquare(3)) == 0
    vec[5] = 1
    @test MOIU.set_dot(vec, vec, MOI.SecondOrderCone(6)) == 1
    @test MOIU.set_dot(vec, vec, MOI.PositiveSemidefiniteConeTriangle(3)) == 2
    @test MOIU.set_dot(vec, vec, MOI.PositiveSemidefiniteConeSquare(3)) == 1
    vec[5] = 0
    vec[3] = 1
    @test MOIU.set_dot(vec, vec, MOI.SecondOrderCone(6)) == 1
    @test MOIU.set_dot(vec, vec, MOI.PositiveSemidefiniteConeTriangle(3)) == 1
    @test MOIU.set_dot(vec, vec, MOI.PositiveSemidefiniteConeSquare(3)) == 1

    vec = zeros(7)
    @test MOIU.set_dot(vec, vec, MOI.RootDetConeTriangle(3)) == 0
    vec[5] = 1
    @test MOIU.set_dot(vec, vec, MOI.RootDetConeTriangle(3)) == 2
    vec = zeros(8)
    @test MOIU.set_dot(vec, vec, MOI.LogDetConeTriangle(3)) == 0
    vec[5] = 1
    @test MOIU.set_dot(vec, vec, MOI.LogDetConeTriangle(3)) == 1

    sp_vec = spzeros(6)
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.SecondOrderCone(6)) == 0
    @test MOIU.set_dot(
        sp_vec,
        sp_vec,
        MOI.PositiveSemidefiniteConeTriangle(3),
    ) == 0
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.PositiveSemidefiniteConeSquare(3)) ==
          0
    sp_vec[5] = 1
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.SecondOrderCone(6)) == 1
    @test MOIU.set_dot(
        sp_vec,
        sp_vec,
        MOI.PositiveSemidefiniteConeTriangle(3),
    ) == 2
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.PositiveSemidefiniteConeSquare(3)) ==
          1
    sp_vec[5] = 0
    sp_vec[3] = 1
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.SecondOrderCone(6)) == 1
    @test MOIU.set_dot(
        sp_vec,
        sp_vec,
        MOI.PositiveSemidefiniteConeTriangle(3),
    ) == 1
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.PositiveSemidefiniteConeSquare(3)) ==
          1

    sp_vec = spzeros(7)
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.RootDetConeTriangle(3)) == 0
    sp_vec[5] = 1
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.RootDetConeTriangle(3)) == 2
    sp_vec = spzeros(8)
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.LogDetConeTriangle(3)) == 0
    sp_vec[5] = 1
    @test MOIU.set_dot(sp_vec, sp_vec, MOI.LogDetConeTriangle(3)) == 1
end

function test_dot_coefficients()
    vec = zeros(6)
    @test MOIU.dot_coefficients(vec, MOI.SecondOrderCone(6)) == vec
    @test MOIU.dot_coefficients(vec, MOI.PositiveSemidefiniteConeTriangle(3)) ==
          vec
    vec[5] = 1
    @test MOIU.dot_coefficients(vec, MOI.SecondOrderCone(6)) == vec
    @test MOIU.dot_coefficients(vec, MOI.PositiveSemidefiniteConeTriangle(3)) ==
          vec ./ 2
    vec[5] = 0
    vec[3] = 1
    @test MOIU.dot_coefficients(vec, MOI.SecondOrderCone(6)) == vec
    @test MOIU.dot_coefficients(vec, MOI.PositiveSemidefiniteConeTriangle(3)) ==
          vec

    vec = zeros(7)
    @test MOIU.dot_coefficients(vec, MOI.RootDetConeTriangle(3)) == vec
    vec[5] = 1
    @test MOIU.dot_coefficients(vec, MOI.RootDetConeTriangle(3)) == vec ./ 2
    vec = zeros(8)
    @test MOIU.dot_coefficients(vec, MOI.LogDetConeTriangle(3)) == vec
    vec[5] = 1
    @test MOIU.dot_coefficients(vec, MOI.LogDetConeTriangle(3)) == vec

    sp_vec = spzeros(6)
    @test MOIU.dot_coefficients(sp_vec, MOI.SecondOrderCone(6)) == sp_vec
    @test MOIU.dot_coefficients(
        sp_vec,
        MOI.PositiveSemidefiniteConeTriangle(3),
    ) == sp_vec
    sp_vec[5] = 1
    @test MOIU.dot_coefficients(sp_vec, MOI.SecondOrderCone(6)) == sp_vec
    @test MOIU.dot_coefficients(
        sp_vec,
        MOI.PositiveSemidefiniteConeTriangle(3),
    ) == sp_vec ./ 2
    sp_vec[5] = 0
    sp_vec[3] = 1
    @test MOIU.dot_coefficients(sp_vec, MOI.SecondOrderCone(6)) == sp_vec
    @test MOIU.dot_coefficients(
        sp_vec,
        MOI.PositiveSemidefiniteConeTriangle(3),
    ) == sp_vec

    sp_vec = spzeros(7)
    @test MOIU.dot_coefficients(sp_vec, MOI.RootDetConeTriangle(3)) == sp_vec
    sp_vec[5] = 1
    @test MOIU.dot_coefficients(sp_vec, MOI.RootDetConeTriangle(3)) ==
          sp_vec ./ 2
    sp_vec = spzeros(8)
    @test MOIU.dot_coefficients(sp_vec, MOI.LogDetConeTriangle(3)) == sp_vec
    sp_vec[5] = 1
    @test MOIU.dot_coefficients(sp_vec, MOI.LogDetConeTriangle(3)) == sp_vec
end

function test_trimap()
    @test MOIU.trimap(1, 1) == 1
    @test MOIU.trimap(1, 2) == 2
    @test MOIU.trimap(2, 1) == 2
    @test MOIU.trimap(2, 2) == 3
    @test MOIU.trimap(3, 1) == 4
    @test MOIU.trimap(1, 3) == 4
    @test MOIU.trimap(3, 2) == 5
    @test MOIU.trimap(2, 3) == 5
    @test MOIU.trimap(3, 3) == 6
    return
end

function test_inverse_trimap(n = 10)
    for j in 1:n
        for i in 1:j
            I, J = MOI.Utilities.inverse_trimap(MOIU.trimap(i, j))
            @test I == i
            @test J == j
        end
    end
    return
end

function test_set_dot_scaling(n = 10)
    N = div(n * (n + 1), 2)
    M = N + div(n * (n - 1), 2)
    v = MOI.Utilities.SymmetricMatrixScalingVector{Float64}(1.5, 0.5, N)
    @test size(v) == (N,)
    w = MOI.Utilities.SymmetricMatrixScalingVector{Float64}(1.5, N)
    s = MOI.Utilities.symmetric_matrix_scaling_vector(Float64, N)
    s32 = MOI.Utilities.symmetric_matrix_scaling_vector(Float32, N)
    is = MOI.Utilities.symmetric_matrix_inverse_scaling_vector(Float64, N)
    is32 = MOI.Utilities.symmetric_matrix_inverse_scaling_vector(Float32, N)
    hpsd = MOI.HermitianPositiveSemidefiniteConeTriangle(n)
    hermitian = MOI.Utilities.SetDotScalingVector{Float64}(hpsd)
    k = 0
    imag_k = 0
    for j in 1:n
        for i in 1:(j-1)
            k += 1
            imag_k += 1
            @test v[k] == 1.5
            @test w[k] == 1.5
            @test s[k] == √2
            @test s32[k] == √Float32(2)
            @test is[k] == inv(√2)
            @test is32[k] == inv(√Float32(2))
            @test hermitian[k] == √2
            @test hermitian[N+imag_k] == √2
        end
        k += 1
        @test v[k] == 0.5
        @test w[k] == 1
        @test isone(s[k])
        @test isone(s32[k])
        @test isone(is[k])
        @test isone(is32[k])
        @test isone(hermitian[k])
    end
    return
end

end  # module

TestUtilitiesSets.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
# Copyright (c) 2024: Guillaume Dalle and Alexis Montoison
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# The code in this file was taken from
# https://github.com/gdalle/SparseMatrixColorings.jl/blob/main/src/Forest.jl
#
# It was copied at the suggestion of Alexis in his JuMP-dev 2025 talk.
#
# @odow made minor changes to match MOI coding styles.
#
# x-ref https://github.com/gdalle/SparseMatrixColorings.jl/pull/190

mutable struct _IntDisjointSet
    # current number of distinct trees in the S
    number_of_trees::Int
    # vector storing the index of a parent in the tree for each edge, used in
    # union-find operations
    parents::Vector{Int}
    # vector approximating the depth of each tree to optimize path compression
    ranks::Vector{Int}

    _IntDisjointSet(n::Integer) = new(n, collect(1:n), zeros(Int, n))
end

function _find_root!(S::_IntDisjointSet, x::Integer)
    p = S.parents[x]
    if S.parents[p] != p
        S.parents[x] = p = _find_root!(S, p)
    end
    return p
end

function _root_union!(S::_IntDisjointSet, x::Int, y::Int)
    rank1, rank2 = S.ranks[x], S.ranks[y]
    if rank1 < rank2
        x, y = y, x
    elseif rank1 == rank2
        S.ranks[x] += 1
    end
    S.parents[y] = x
    S.number_of_trees -= 1
    return
end

function _union!(S, x::Int, y::Int)
    root_x = _find_root!(S, x)
    root_y = _find_root!(S, y)
    if root_x != root_y
        _root_union!(S, root_x, root_y)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

include("graph.jl")

"""
    LazyBridgeOptimizer(model::MOI.ModelLike)

The `LazyBridgeOptimizer` is a bridge optimizer that supports multiple bridges,
and only bridges things which are not supported by the internal model.

Internally, the `LazyBridgeOptimizer` solves a shortest hyper-path problem to
determine which bridges to use.

In general, you should use [`full_bridge_optimizer`](@ref) instead of this
constructor because [`full_bridge_optimizer`](@ref) automatically adds a large
number of supported bridges.

See also: [`add_bridge`](@ref), [`remove_bridge`](@ref), [`has_bridge`](@ref)
and [`full_bridge_optimizer`](@ref).

## Example

```jldoctest
julia> model = MOI.Bridges.LazyBridgeOptimizer(MOI.Utilities.Model{Float64}());

julia> MOI.Bridges.add_bridge(model, MOI.Bridges.Variable.FreeBridge{Float64})

julia> MOI.Bridges.has_bridge(model, MOI.Bridges.Variable.FreeBridge{Float64})
true
```
"""
mutable struct LazyBridgeOptimizer{OT<:MOI.ModelLike} <: AbstractBridgeOptimizer
    # Internal model
    model::OT
    # Bridged variables
    variable_map::Variable.Map
    var_to_name::Dict{MOI.VariableIndex,String}
    name_to_var::Union{Dict{String,MOI.VariableIndex},Nothing}
    # Bridged constraints
    constraint_map::Constraint.Map
    con_to_name::Dict{MOI.ConstraintIndex,String}
    name_to_con::Union{Dict{String,MOI.ConstraintIndex},Nothing}
    # Bridged objective
    objective_map::Objective.Map
    # Bellman-Ford graph
    graph::Graph
    # List of types of available bridges
    variable_bridge_types::Vector{Any}
    variable_node::OrderedDict{Tuple{Type},VariableNode}
    variable_types::Vector{Tuple{Type}}
    # List of types of available bridges
    constraint_bridge_types::Vector{Any}
    constraint_node::OrderedDict{Tuple{Type,Type},ConstraintNode}
    constraint_types::Vector{Tuple{Type,Type}}
    # List of types of available bridges
    objective_bridge_types::Vector{Any}
    objective_node::OrderedDict{Tuple{Type},ObjectiveNode}
    objective_types::Vector{Tuple{Type}}
    # Cache for (F, S) -> BridgeType. Avoids having to look up
    # `concrete_bridge_type` at runtime, which is slow.
    cached_bridge_type::Dict{Any,Type}

    function LazyBridgeOptimizer(model::MOI.ModelLike)
        return new{typeof(model)}(
            model,
            Variable.Map(),
            Dict{MOI.VariableIndex,String}(),
            nothing,
            Constraint.Map(),
            Dict{MOI.ConstraintIndex,String}(),
            nothing,
            Objective.Map(),
            Graph(),
            Any[],
            OrderedDict{Tuple{Type},VariableNode}(),
            Tuple{Type}[],
            Any[],
            OrderedDict{Tuple{Type,Type},ConstraintNode}(),
            Tuple{Type,Type}[],
            Any[],
            OrderedDict{Tuple{Type},ObjectiveNode}(),
            Tuple{Type}[],
            Dict{Any,Type}(),
        )
    end
end

Variable.bridges(bridge::LazyBridgeOptimizer) = bridge.variable_map

Constraint.bridges(bridge::LazyBridgeOptimizer) = bridge.constraint_map

Objective.bridges(b::LazyBridgeOptimizer) = b.objective_map

function _print_bridges_from_map(io, map)
    bridges = values(map)
    if isempty(bridges)
        println(io, " none")
        return
    end
    println(io)
    offset = get(io, :offset, "")
    bridge_strings = sort(string.(unique(typeof.(bridges))))
    for (i, bridge) in enumerate(bridge_strings)
        tree = ifelse(i == length(bridge_strings), '└', '├')
        MOI.Utilities.print_with_acronym(io, "$(offset)│ $tree $bridge\n")
    end
    return
end

function Base.show(io::IO, model::LazyBridgeOptimizer)
    offset = get(io, :offset, "")
    MOI.Utilities.print_with_acronym(io, summary(model))
    println(io)
    print(io, offset, "├ Variable bridges:")
    _print_bridges_from_map(io, model.variable_map)
    print(io, offset, "├ Constraint bridges:")
    _print_bridges_from_map(io, model.constraint_map)
    print(io, offset, "├ Objective bridges:")
    _print_bridges_from_map(io, model.objective_map)
    print(io, offset, "└ model: ")
    show(IOContext(io, :offset => offset * "  "), model.model)
    return
end

"""
    _reset_bridge_graph(b::LazyBridgeOptimizer)

Reset the hyper-graph maintained by the [LazyBridgeOptimizer](@ref), but do not
remove the bridges that have been added.

We need to reset the graph whenever we add or delete bridges from `b`, because
it might change the optimal hyper-paths. Recomputing from scratch is a lot of
work, but it will only happen if we interleave calls to [`add_bridge`](@ref),
[`remove_bridge`](@ref), and model builders like [`MOI.add_constraint`](@ref).
"""
function _reset_bridge_graph(b::LazyBridgeOptimizer)
    empty!(b.variable_node)
    empty!(b.variable_types)
    empty!(b.constraint_node)
    empty!(b.constraint_types)
    empty!(b.objective_node)
    empty!(b.objective_types)
    empty!(b.graph)
    empty!(b.cached_bridge_type)
    return
end

"""
    _variable_nodes(b::LazyBridgeOptimizer, ::Type{BT}) where {BT}

Return the list of `VariableNode` that would be added if `BT` is used in `b`.
"""
function _variable_nodes(
    @nospecialize(b::LazyBridgeOptimizer),
    @nospecialize(BT),
)
    return map(added_constrained_variable_types(BT)) do (S,)
        return node(b, S)::VariableNode
    end
end

"""
    _constraint_nodes(b::LazyBridgeOptimizer, ::Type{BT}) where {BT}

Return the list of `ConstraintNode` that would be added if `BT` is used in `b`.
"""
function _constraint_nodes(
    @nospecialize(b::LazyBridgeOptimizer),
    @nospecialize(BT),
)
    return ConstraintNode[
        node(b, F, S) for (F, S) in added_constraint_types(BT)
    ]
end

"""
    _edge(b::LazyBridgeOptimizer, index::Int, BT::Type{<:AbstractBridge})

Return the `Edge` or `ObjectiveEdge` in the hyper-graph associated with the
bridge `BT`, where `index` is the index of `BT` in the list of bridges.
"""
function _edge(
    @nospecialize(b::LazyBridgeOptimizer),
    @nospecialize(index::Int),
    @nospecialize(BT::Type{<:AbstractBridge}),
)
    return Edge(
        index,
        _variable_nodes(b, BT),
        _constraint_nodes(b, BT),
        bridging_cost(BT),
    )
end

# Method for objective bridges because they produce ObjectiveEdge.
function _edge(
    b::LazyBridgeOptimizer,
    index::Int,
    BT::Type{<:Objective.AbstractBridge},
)
    return ObjectiveEdge(
        index,
        _variable_nodes(b, BT)::Vector{VariableNode},
        _constraint_nodes(b, BT)::Vector{ConstraintNode},
        node(b, set_objective_function_type(BT))::ObjectiveNode,
        bridging_cost(BT)::Float64,
    )
end

_functionized_type(::Nothing) = nothing

function _functionized_type(
    ::Type{<:Constraint.ScalarFunctionizeBridge{T}},
) where {T}
    return MOI.ScalarAffineFunction{T}
end

function _functionized_type(
    ::Type{<:Constraint.VectorFunctionizeBridge{T}},
) where {T}
    return MOI.VectorAffineFunction{T}
end

function _functionized_type(b::LazyBridgeOptimizer, ::Type{MOI.VariableIndex})
    return _functionized_type(
        _first_functionize_bridge(
            b.constraint_bridge_types,
            Constraint.ScalarFunctionizeBridge,
        ),
    )
end

function _functionized_type(
    b::LazyBridgeOptimizer,
    ::Type{MOI.VectorOfVariables},
)
    return _functionized_type(
        _first_functionize_bridge(
            b.constraint_bridge_types,
            Constraint.VectorFunctionizeBridge,
        ),
    )
end

"""
    node(b::LazyBridgeOptimizer, S::Type{<:MOI.AbstractSet})

Return the `VariableNode` associated with set `S` in `b`.
"""
function node(
    @nospecialize(b::LazyBridgeOptimizer),
    @nospecialize(S::Type{<:MOI.AbstractSet}),
)
    # If we support the set, the node is 0.
    if (
        S <: MOI.AbstractScalarSet &&
        MOI.supports_add_constrained_variable(b.model, S)
    ) || (
        S <: MOI.AbstractVectorSet &&
        MOI.supports_add_constrained_variables(b.model, S)
    )
        return VariableNode(0)
    end
    # If (S,) is stored in .variable_node, we've already added the node
    # previously.
    variable_node = get(b.variable_node, (S,), nothing)
    if variable_node !== nothing
        return variable_node
    end
    # This is a new (S,). We need to add it to the graph.
    variable_node = add_node(b.graph, VariableNode)
    b.variable_node[(S,)] = variable_node
    push!(b.variable_types, (S,))
    F = MOI.Utilities.variable_function_type(S)
    if is_bridged(b, MOI.Reals)
        # The solver doesn't support adding free variables.
        FF = _functionized_type(b, F)
        if FF !== nothing
            # The cost is `3` because we assume the distance of the variable
            # node `MOI.Reals` is `1` (that is, it is bridged by
            # `Variable.FreeBridge`. We also use the functionize bridge which
            # has cost 1. And we add `+1` as we treat constrained variables as
            # constraints.
            set_variable_constraint_node(
                b.graph,
                variable_node,
                node(b, FF, S),
                3,
            )
        end
    else
        # We add `+1` as we treat constrained variables as constraints.
        set_variable_constraint_node(b.graph, variable_node, node(b, F, S), 1)
    end
    for (i, BT) in enumerate(b.variable_bridge_types)
        if Variable.supports_constrained_variable(BT, S)
            edge = _edge(b, i, Variable.concrete_bridge_type(BT, S))::Edge
            add_edge(b.graph, variable_node, edge)
        end
    end
    return variable_node
end

"""
    node(b::LazyBridgeOptimizer, ::Type{F}, ::Type{S})

Return the `ConstraintNode` associated with constraint `F`-in-`S` in `b`.
"""
function node(
    @nospecialize(b::LazyBridgeOptimizer),
    @nospecialize(F::Type{<:MOI.AbstractFunction}),
    @nospecialize(S::Type{<:MOI.AbstractSet}),
)
    # If we support the constraint type, the node is 0.
    if MOI.supports_constraint(b.model, F, S)
        return ConstraintNode(0)
    end
    # If (F, S) is stored in .constraint_node, we've already added the node
    # previously.
    constraint_node = get(b.constraint_node, (F, S), nothing)
    if constraint_node !== nothing
        return constraint_node
    end
    # This is a new (F, S). We need to add it to the graph.
    constraint_node = add_node(b.graph, ConstraintNode)
    b.constraint_node[(F, S)] = constraint_node
    push!(b.constraint_types, (F, S))
    for (i, BT) in enumerate(b.constraint_bridge_types)
        if MOI.supports_constraint(BT, F, S)
            edge = _edge(b, i, Constraint.concrete_bridge_type(BT, F, S))::Edge
            add_edge(b.graph, constraint_node, edge)
        end
    end
    return constraint_node
end

"""
    node(b::LazyBridgeOptimizer, ::Type{F})

Return the `ObjectiveNode` associated with constraint `F` in `b`.
"""
function node(b::LazyBridgeOptimizer, ::Type{F}) where {F<:MOI.AbstractFunction}
    # If we support the objective function, the node is 0.
    if MOI.supports(b.model, MOI.ObjectiveFunction{F}())
        return ObjectiveNode(0)
    end
    # If (f,) is stored in .objective_node, we've already added the node
    # previously.
    objective_node = get(b.objective_node, (F,), nothing)
    if objective_node !== nothing
        return objective_node
    end
    # This is a new (F,). We need to add it to the graph.
    objective_node = add_node(b.graph, ObjectiveNode)
    b.objective_node[(F,)] = objective_node
    push!(b.objective_types, (F,))
    for (i, BT) in enumerate(b.objective_bridge_types)
        if Objective.supports_objective_function(BT, F)
            bridge_type = Objective.concrete_bridge_type(
                BT,
                F,
            )::Type{<:Objective.AbstractBridge}
            edge = _edge(b, i, bridge_type)::ObjectiveEdge
            add_edge(b.graph, objective_node, edge)
        end
    end
    return objective_node
end

"""
    _bridge_types(b::LazyBridgeOptimizer, BT::Type{<:AbstractBridge}),

A fallback helper to return the correct list of bridges given the type of `BT`.
"""
function _bridge_types(
    b::LazyBridgeOptimizer,
    ::Type{<:Variable.AbstractBridge},
)
    return b.variable_bridge_types
end

function _bridge_types(
    @nospecialize(b::LazyBridgeOptimizer),
    @nospecialize(BT::Type{<:Constraint.AbstractBridge}),
)
    return b.constraint_bridge_types
end

function _bridge_types(
    b::LazyBridgeOptimizer,
    ::Type{<:Objective.AbstractBridge},
)
    return b.objective_bridge_types
end

"""
    add_bridge(b::LazyBridgeOptimizer, BT::Type{<:AbstractBridge})

Enable the use of the bridges of type `BT` by `b`.
"""
function add_bridge(
    @nospecialize(b::LazyBridgeOptimizer),
    @nospecialize(BT::Type{<:AbstractBridge}),
)
    if !has_bridge(b, BT)
        push!(_bridge_types(b, BT), BT)
        _reset_bridge_graph(b)
    end
    return
end

"""
    remove_bridge(b::LazyBridgeOptimizer, BT::Type{<:AbstractBridge})

Disable the use of the bridges of type `BT` by `b`.
"""
function remove_bridge(b::LazyBridgeOptimizer, BT::Type{<:AbstractBridge})
    bridge_types = _bridge_types(b, BT)
    i = findfirst(isequal(BT), bridge_types)
    if i === nothing
        error(
            "Cannot remove bridge `$BT` as it was never added or was already",
            " removed.",
        )
    end
    deleteat!(bridge_types, i)
    _reset_bridge_graph(b)
    return
end

"""
    has_bridge(b::LazyBridgeOptimizer, BT::Type{<:AbstractBridge})

Return a `Bool` indicating whether the bridges of type `BT` are used by `b`.
"""
function has_bridge(
    @nospecialize(b::LazyBridgeOptimizer),
    @nospecialize(BT::Type{<:AbstractBridge}),
)::Bool
    return findfirst(isequal(BT), _bridge_types(b, BT)) !== nothing
end

# It only bridges when the constraint is not supporting, hence the name "Lazy"
function is_bridged(b::LazyBridgeOptimizer, S::Type{<:MOI.AbstractScalarSet})
    return !MOI.supports_add_constrained_variable(b.model, S)
end

function is_bridged(b::LazyBridgeOptimizer, S::Type{<:MOI.AbstractVectorSet})
    return !MOI.supports_add_constrained_variables(b.model, S)
end

function is_bridged(
    b::LazyBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    return !MOI.supports_constraint(b.model, F, S)
end

function is_bridged(b::LazyBridgeOptimizer, F::Type{<:MOI.AbstractFunction})
    return !MOI.supports(b.model, MOI.ObjectiveFunction{F}())
end

function bridge_index(b::LazyBridgeOptimizer, S::Type{<:MOI.AbstractSet})
    return bridge_index(b.graph, node(b, S))
end

function bridge_index(
    b::LazyBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    return bridge_index(b.graph, node(b, F, S))
end

function bridge_index(b::LazyBridgeOptimizer, F::Type{<:MOI.AbstractFunction})
    return bridge_index(b.graph, node(b, F))
end

supports_constraint_bridges(::LazyBridgeOptimizer) = true

function supports_bridging_constrained_variable(
    b::LazyBridgeOptimizer,
    S::Type{<:MOI.AbstractSet},
)
    variable_node = node(b, S)
    if !iszero(bridge_index(b.graph, variable_node))
        return true
    end
    constraint_node = b.graph.variable_constraint_node[variable_node.index]
    return constraint_node.index != INVALID_NODE_INDEX &&
           !iszero(bridge_index(b.graph, constraint_node))
end

function supports_bridging_constraint(
    b::LazyBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    return !iszero(bridge_index(b, F, S))
end

function supports_bridging_objective_function(
    b::LazyBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
)
    return !iszero(bridge_index(b, F))
end

function is_variable_bridged(b::LazyBridgeOptimizer, S::Type{<:MOI.AbstractSet})
    return is_bridged(b, S) && is_variable_edge_best(b.graph, node(b, S))
end

function bridge_type(b::LazyBridgeOptimizer, S::Type{<:MOI.AbstractSet})
    bt = get(b.cached_bridge_type, (S,), nothing)
    if bt !== nothing
        return bt::Type
    end
    index = bridge_index(b, S)
    if iszero(index)
        F = MOI.Utilities.variable_function_type(S)
        throw(MOI.UnsupportedConstraint{F,S}())
    end
    new_bt = Variable.concrete_bridge_type(b.variable_bridge_types[index], S)
    b.cached_bridge_type[(S,)] = new_bt
    return new_bt::Type
end

function bridge_type(
    b::LazyBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    bt = get(b.cached_bridge_type, (F, S), nothing)
    if bt !== nothing
        return bt::Type
    end
    index = bridge_index(b, F, S)
    if iszero(index)
        throw(MOI.UnsupportedConstraint{F,S}())
    end
    new_bt =
        Constraint.concrete_bridge_type(b.constraint_bridge_types[index], F, S)
    b.cached_bridge_type[(F, S)] = new_bt
    return new_bt::Type
end

function bridge_type(b::LazyBridgeOptimizer, F::Type{<:MOI.AbstractFunction})
    bt = get(b.cached_bridge_type, (F,), nothing)
    if bt !== nothing
        return bt::Type
    end
    index = bridge_index(b, F)
    if iszero(index)
        throw(MOI.UnsupportedAttribute(MOI.ObjectiveFunction{F}()))
    end
    new_bt = Objective.concrete_bridge_type(b.objective_bridge_types[index], F)
    b.cached_bridge_type[(F,)] = new_bt
    return new_bt::Type
end

function _func_name(::Type{Constraint.ScalarFunctionizeBridge})
    return "VariableIndex", "constraint"
end

function _func_name(::Type{Constraint.VectorFunctionizeBridge})
    return "VectorOfVariables", "constraint"
end

_func_name(::Type{Objective.FunctionizeBridge}) = "VariableIndex", "objective"

function _first_functionize_bridge(bridge_types, target_type)
    index = findfirst(bridge_type -> bridge_type <: target_type, bridge_types)
    if index === nothing
        return nothing
    end
    return bridge_types[index]
end

function _functionize_bridge(bridge_types, target_type)
    bridge_type = _first_functionize_bridge(bridge_types, target_type)
    if bridge_type === nothing
        func, name = _func_name(target_type)
        error(
            "Need to apply a `$target_type` to a `$func` $name because the " *
            "variable is bridged but no such $name bridge type was added. " *
            "Add one with `add_bridge`.",
        )
    end
    return bridge_type
end

function constraint_vector_functionize_bridge(b::LazyBridgeOptimizer)
    return _functionize_bridge(
        b.constraint_bridge_types,
        Constraint.VectorFunctionizeBridge,
    )
end

function constraint_scalar_functionize_bridge(b::LazyBridgeOptimizer)
    return _functionize_bridge(
        b.constraint_bridge_types,
        Constraint.ScalarFunctionizeBridge,
    )
end

function objective_functionize_bridge(b::LazyBridgeOptimizer)
    return _functionize_bridge(
        b.objective_bridge_types,
        Objective.FunctionizeBridge,
    )
end

function bridging_cost(b::LazyBridgeOptimizer, args...)
    return bridging_cost(b.graph, node(b, args...))
end

recursive_model(b::LazyBridgeOptimizer) = b

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Dummy bridges used for testing
module IdentityBridges

import MathOptInterface as MOI

const F{T} = MOI.ScalarAffineFunction{T}
const S{T} = MOI.EqualTo{T}

struct VariableBridge{T} <: MOI.Bridges.Variable.SetMapBridge{T,S{T},S{T}}
    variable::MOI.VariableIndex
    constraint::MOI.ConstraintIndex{MOI.VariableIndex,S{T}}
end

struct ConstraintBridge{T} <:
       MOI.Bridges.Constraint.SetMapBridge{T,S{T},S{T},F{T},F{T}}
    constraint::MOI.ConstraintIndex{F{T},S{T}}
end

const IdentityBridge{T} = Union{VariableBridge{T},ConstraintBridge{T}}

MOI.Bridges.map_set(::Type{<:IdentityBridge}, set::S) = set
MOI.Bridges.inverse_map_set(::Type{<:IdentityBridge}, set::S) = set
MOI.Bridges.map_function(::Type{<:IdentityBridge}, func) = func
MOI.Bridges.inverse_map_function(::Type{<:IdentityBridge}, func) = func
MOI.Bridges.adjoint_map_function(::Type{<:IdentityBridge}, func) = func
MOI.Bridges.inverse_adjoint_map_function(::Type{<:IdentityBridge}, func) = func

struct ObjectiveBridge{T} <: MOI.Bridges.Objective.AbstractBridge end

function MOI.Bridges.Objective.bridge_objective(
    ::Type{ObjectiveBridge{T}},
    model::MOI.ModelLike,
    func::F{T},
) where {T}
    MOI.set(model, MOI.ObjectiveFunction{F}(), func)
    return ObjectiveBridge{T}()
end

function MOI.Bridges.Objective.supports_objective_function(
    ::Type{ObjectiveBridge{T}},
    ::Type{F{T}},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:ObjectiveBridge})
    return Tuple{DataType}[]
end

function MOI.Bridges.added_constraint_types(::Type{<:ObjectiveBridge})
    return Tuple{DataType,DataType}[]
end

function MOI.Bridges.set_objective_function_type(
    ::Type{ObjectiveBridge{T}},
) where {T}
    return F{T}
end

# Attributes, Bridge acting as a model
function MOI.get(::ObjectiveBridge, ::MOI.NumberOfVariables)
    return 0
end

function MOI.get(::ObjectiveBridge, ::MOI.ListOfVariableIndices)
    return MOI.VariableIndex[]
end

# No variables or constraints are created in this bridge so there is nothing to
# delete.
MOI.delete(model::MOI.ModelLike, bridge::ObjectiveBridge) = nothing

function MOI.set(
    ::MOI.ModelLike,
    ::MOI.ObjectiveSense,
    ::ObjectiveBridge,
    ::MOI.OptimizationSense,
)
    # `ObjectiveBridge` is sense agnostic, therefore, we don't need to change
    # anything.
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{
        MOI.Bridges.ObjectiveFunctionValue{F{T}},
        MOI.ObjectiveFunction{F{T}},
    },
    ::ObjectiveBridge{T},
) where {T}
    return MOI.get(model, attr)
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    _soc_to_psd_matrix(
        ::Type{T},
        f::MOI.VectorAffineFunction{T},
        g::MOI.ScalarAffineFunction{T},
    )

Builds a VectorAffineFunction representing the upper (or lower) triangular part
of the matrix:

    [ f[1]     f[2:end]' ]
    [ f[2:end] g * I     ]
"""
function _soc_to_psd_matrix(
    ::Type{T},
    f::Union{MOI.AbstractVectorFunction,AbstractVector},
    g::Union{MOI.AbstractScalarFunction,T},
) where {T}
    F = MOI.Utilities.promote_operation(vcat, T, typeof(g), T)
    f_scalars = MOI.Utilities.eachscalar(f)
    dim = length(f_scalars)
    n = div(dim * (dim + 1), 2)
    h = MOI.Utilities.zero_with_output_dimension(F, n)
    row = MOI.Utilities.trimap(1, 1)
    MOI.Utilities.operate_output_index!(+, T, row, h, f_scalars[1])
    for i in 2:dim
        row = MOI.Utilities.trimap(1, i)
        MOI.Utilities.operate_output_index!(+, T, row, h, f_scalars[i])
        diag = MOI.Utilities.trimap(i, i)
        MOI.Utilities.operate_output_index!(+, T, diag, h, g)
    end
    return h
end

"""
    SOCtoPSDBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`SOCtoPSDBridge` implements the following reformulation:

  * ``||x||_2 \\le t`` into
    ``\\left[\\begin{array}{c c}t & x^\\top \\\\ x & t \\mathbf{I}\\end{array}\\right]\\succeq 0``

!!! warning
    This bridge is not added by default by [`MOI.Bridges.full_bridge_optimizer`](@ref)
    because bridging second order cone constraints to semidefinite constraints
    can be achieved by the [`SOCtoRSOCBridge`](@ref) followed by the
    [`RSOCtoPSDBridge`](@ref), while creating a smaller semidefinite constraint.

## Source node

`SOCtoPSDBridge` supports:

  * `G` in [`MOI.SecondOrderCone`](@ref)

## Target nodes

`SOCtoPSDBridge` creates:

  * `F` in [`MOI.PositiveSemidefiniteConeTriangle`](@ref)
"""
struct SOCtoPSDBridge{T,F,G} <: SetMapBridge{
    T,
    MOI.PositiveSemidefiniteConeTriangle,
    MOI.SecondOrderCone,
    F,
    G,
}
    constraint::MOI.ConstraintIndex{F,MOI.PositiveSemidefiniteConeTriangle}
end

const SOCtoPSD{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SOCtoPSDBridge{T},OT}

# This bridge destorys a lot of structure and adding PSD variables is almost
# always undesirable. We give this bridge a high cost so that it is used only if
# necessary.
MOI.Bridges.bridging_cost(::Type{<:SOCtoPSDBridge}) = 10.0

function concrete_bridge_type(
    ::Type{<:SOCtoPSDBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.SecondOrderCone},
) where {T}
    SG = MOI.Utilities.scalar_type(G)
    F = MOI.Utilities.promote_operation(vcat, T, SG, T)
    return SOCtoPSDBridge{T,F,G}
end

function MOI.Bridges.map_set(::Type{<:SOCtoPSDBridge}, set::MOI.SecondOrderCone)
    return MOI.PositiveSemidefiniteConeTriangle(MOI.dimension(set))
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:SOCtoPSDBridge},
    set::MOI.PositiveSemidefiniteConeTriangle,
)
    return MOI.SecondOrderCone(MOI.side_dimension(set))
end

function MOI.Bridges.map_function(::Type{<:SOCtoPSDBridge{T}}, func) where {T}
    # func is (t, x), and we need [t x'; x tI]
    return _soc_to_psd_matrix(T, func, MOI.Utilities.eachscalar(func)[1])
end

function MOI.Bridges.inverse_map_function(::Type{<:SOCtoPSDBridge}, func)
    scalars = MOI.Utilities.eachscalar(func)
    dim = MOI.Utilities.side_dimension_for_vectorized_dimension(length(scalars))
    # The inverse function is the top row of [t x'; x tI]
    return scalars[[MOI.Utilities.trimap(1, i) for i in 1:dim]]
end

function MOI.Bridges.adjoint_map_function(
    ::Type{<:SOCtoPSDBridge{T}},
    func,
) where {T}
    scalars = MOI.Utilities.eachscalar(func)
    dim = MOI.Utilities.side_dimension_for_vectorized_dimension(length(scalars))
    return MOI.Utilities.operate(
        vcat,
        T,
        # The dual of `t` variable is the sum of the diagonal
        sum(func[MOI.Utilities.trimap(i, i)] for i in 1:dim),
        # The dual of `x` is the top row or first column, excluding (1, 1).
        # There's a factor of 2 as well.
        [2 * func[MOI.Utilities.trimap(i, 1)] for i in 2:dim],
    )
end

# func is (t, x) such that x'x ≤ t^2 and we need to find a PSD matrix
#   [a   x'/2]
#   [x/2 Q   ]
# such that
#   a + tr(Q) == t
# By choosing
#   a = t/2 and Q = t/(2x'x) * xx',
# we get
#   a + tr(Q) = t/2 + t/(2x'x) * tr(xx') = t/2 + t/(2x'x) * tr(x'x) = t
# Moreover, by the Schur complement, the matrix is PSD iff
#   xx'/(2t) ⪯ t/(2x'x) * xx'
#   1/(2t) ≤ t/(2x'x)
#   x'x ≤ t^2
# which is the SOC inequality,
function MOI.Bridges.inverse_adjoint_map_function(
    ::Type{<:SOCtoPSDBridge{T}},
    func,
) where {T}
    t, x = func[1], func[2:end]
    Q = [t / 2; t; x]
    return MOI.Bridges.inverse_adjoint_map_function(RSOCtoPSDBridge{T}, Q)
end

"""
    RSOCtoPSDBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`RSOCtoPSDBridge` implements the following reformulation:

  * ``||x||_2^2 \\le 2t\\cdot u`` into
    ``\\left[\\begin{array}{c c}t & x^\\top \\\\ x & 2tu \\mathbf{I}\\end{array}\\right]\\succeq 0``

## Source node

`RSOCtoPSDBridge` supports:

  * `G` in [`MOI.RotatedSecondOrderCone`](@ref)

## Target nodes

`RSOCtoPSDBridge` creates:

  * `F` in [`MOI.PositiveSemidefiniteConeTriangle`](@ref)
"""
struct RSOCtoPSDBridge{T,F,G} <: SetMapBridge{
    T,
    MOI.PositiveSemidefiniteConeTriangle,
    MOI.RotatedSecondOrderCone,
    F,
    G,
}
    constraint::Union{
        MOI.ConstraintIndex{F,MOI.PositiveSemidefiniteConeTriangle},
        MOI.ConstraintIndex{G,MOI.Nonnegatives},
    }
end

const RSOCtoPSD{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{RSOCtoPSDBridge{T},OT}

# This bridge destorys a lot of structure and adding PSD variables is almost
# always undesirable. We give this bridge a high cost so that it is used only if
# necessary.
MOI.Bridges.bridging_cost(::Type{<:RSOCtoPSDBridge}) = 10.0

function concrete_bridge_type(
    ::Type{<:RSOCtoPSDBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.RotatedSecondOrderCone},
) where {T}
    S = MOI.Utilities.scalar_type(G)
    H = MOI.Utilities.promote_operation(*, T, T, S)
    F = MOI.Utilities.promote_operation(vcat, T, S, H, T)
    return RSOCtoPSDBridge{T,F,G}
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:RSOCtoPSDBridge{T,F,G}},
) where {T,F,G}
    return Tuple{Type,Type}[
        (F, MOI.PositiveSemidefiniteConeTriangle),
        (G, MOI.Nonnegatives),
    ]
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{<:RSOCtoPSDBridge{T,F,G}},
) where {T,F,G}
    return MOI.supports(
        model,
        attr,
        MOI.ConstraintIndex{F,MOI.PositiveSemidefiniteConeTriangle},
    ) || MOI.supports(model, attr, MOI.ConstraintIndex{G,MOI.Nonnegatives})
end

function MOI.Bridges.map_set(
    ::Type{<:RSOCtoPSDBridge},
    set::MOI.RotatedSecondOrderCone,
)
    d = MOI.dimension(set)
    if d == 2
        return MOI.Nonnegatives(2)
    else
        return MOI.PositiveSemidefiniteConeTriangle(d - 1)
    end
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:RSOCtoPSDBridge},
    set::MOI.PositiveSemidefiniteConeTriangle,
)
    return MOI.RotatedSecondOrderCone(MOI.side_dimension(set) + 1)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:RSOCtoPSDBridge},
    ::MOI.Nonnegatives,
)
    return MOI.RotatedSecondOrderCone(2)
end

function MOI.Bridges.map_function(::Type{<:RSOCtoPSDBridge{T}}, func) where {T}
    scalars = MOI.Utilities.eachscalar(func)
    # We cannot construct MOI.RotatedSecondOrderCone(1)
    @assert length(scalars) >= 2
    if length(scalars) == 2
        return func
    end
    # Input is (t, u, x), and we need [t x'; x 2uI]
    h = MOI.Utilities.operate!(*, T, scalars[2], convert(T, 2))
    return _soc_to_psd_matrix(T, scalars[[1; 3:length(scalars)]], h)
end

function MOI.Bridges.inverse_map_function(
    ::Type{<:RSOCtoPSDBridge{T}},
    func,
) where {T}
    scalars = MOI.Utilities.eachscalar(func)
    if length(scalars) == 2
        return func
    end
    dim = MOI.Utilities.side_dimension_for_vectorized_dimension(length(scalars))
    t = scalars[1]
    # scalars[3] is 2u, so it needs to be divided by 2 to get u.
    u = MOI.Utilities.operate!(/, T, scalars[3], convert(T, 2))
    # x is the top row of the func, excluding (1, 1)
    x = scalars[[MOI.Utilities.trimap(1, i) for i in 2:dim]]
    return MOI.Utilities.operate(vcat, T, t, u, x)
end

function MOI.Bridges.adjoint_map_function(
    ::Type{<:RSOCtoPSDBridge{T}},
    func,
) where {T}
    scalars = MOI.Utilities.eachscalar(func)
    if length(scalars) == 2
        return func
    end
    dim = MOI.Utilities.side_dimension_for_vectorized_dimension(length(scalars))
    return MOI.Utilities.operate(
        vcat,
        T,
        # `t` is the (1, 1) element
        func[1],
        # `u` is sum of diagonals
        2 * sum(func[MOI.Utilities.trimap(i, i)] for i in 2:dim),
        # x is the first column, excluding (1, 1)
        [2 * func[MOI.Utilities.trimap(i, 1)] for i in 2:dim],
    )
end

# func is (t, u, x) such that x'x ≤ 2tu and we need to find a PSD matrix
#   [t   x'/2]
#   [x/2 Q   ]
# such that
#   2tr(Q) == u
# By choosing
#   Q = u/(2x'x) * xx',
# we get
#   2tr(Q) = u/(x'x) * tr(xx') = u/(x'x) * tr(x'x) = u
# Moreover, by the Schur complement, the matrix is PSD iff
#   xx'/(4t) ⪯ u/(2x'x) * xx'
#   1/(4t) ≤ u/(2x'x)
#   x'x ≤ 2tu
# which is the RSOC inequality
function MOI.Bridges.inverse_adjoint_map_function(
    ::Type{<:RSOCtoPSDBridge{T}},
    func,
) where {T}
    if length(func) == 2
        return func
    end
    t, u, x = func[1], func[2], func[3:end]
    Q = (u / (2 * (x' * x))) * (x * x')
    M = [t x'/2; x/2 Q]
    return [M[i, j] for j in axes(M, 2) for i in 1:j]
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module MOF

import ..FileFormats
import JSON3
import MathOptInterface as MOI

"""
    SCHEMA_PATH::String

The path to the latest version of the MathOptFormat schema supported by
MathOptInterface.
"""
const SCHEMA_PATH = joinpath(@__DIR__, "mof.schema.json")

const _SUPPORTED_VERSIONS = (
    v"1.7",
    v"1.6",
    v"1.5",
    v"1.4",
    v"1.3",
    v"1.2",
    v"1.1",
    v"1.0",
    v"0.6",
    v"0.5",
    v"0.4",
)

function _parse_mof_version(version)
    return VersionNumber(version["major"], version["minor"])
end

struct Nonlinear <: MOI.AbstractScalarFunction
    expr::Expr
end
Base.copy(nonlinear::Nonlinear) = Nonlinear(copy(nonlinear.expr))
MOI.Utilities.canonicalize!(nonlinear::Nonlinear) = nonlinear

MOI.Utilities.@model(
    InnerModel,
    (MOI.ZeroOne, MOI.Integer),
    (
        MOI.EqualTo,
        MOI.GreaterThan,
        MOI.LessThan,
        MOI.Interval,
        MOI.Semicontinuous,
        MOI.Semiinteger,
        MOI.Parameter,
    ),
    (
        MOI.Reals,
        MOI.Zeros,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.HyperRectangle,
        MOI.SecondOrderCone,
        MOI.RotatedSecondOrderCone,
        MOI.GeometricMeanCone,
        MOI.ExponentialCone,
        MOI.DualExponentialCone,
        MOI.NormOneCone,
        MOI.NormInfinityCone,
        MOI.NormCone,
        MOI.NormSpectralCone,
        MOI.NormNuclearCone,
        MOI.RelativeEntropyCone,
        MOI.RootDetConeTriangle,
        MOI.RootDetConeSquare,
        MOI.LogDetConeTriangle,
        MOI.LogDetConeSquare,
        MOI.PositiveSemidefiniteConeTriangle,
        MOI.Scaled{MOI.PositiveSemidefiniteConeTriangle},
        MOI.PositiveSemidefiniteConeSquare,
        MOI.HermitianPositiveSemidefiniteConeTriangle,
        MOI.AllDifferent,
        MOI.Circuit,
        MOI.CountAtLeast,
        MOI.CountBelongs,
        MOI.CountDistinct,
        MOI.CountGreaterThan,
        MOI.Cumulative,
        MOI.Path,
    ),
    (
        MOI.PowerCone,
        MOI.DualPowerCone,
        MOI.SOS1,
        MOI.SOS2,
        MOI.BinPacking,
        MOI.Table,
    ),
    (Nonlinear, MOI.ScalarNonlinearFunction),
    (MOI.ScalarAffineFunction, MOI.ScalarQuadraticFunction),
    (MOI.VectorOfVariables, MOI.VectorNonlinearFunction),
    (MOI.VectorAffineFunction, MOI.VectorQuadraticFunction)
)

# Indicator is handled by UniversalFallback.
# Reified is handled by UniversalFallback.
# Scaled is handled by UniversalFallback.

const Model{T} = MOI.Utilities.UniversalFallback{InnerModel{T}}

struct Options
    print_compact::Bool
    warn::Bool
    differentiation_backend::MOI.Nonlinear.AbstractAutomaticDifferentiation
    use_nlp_block::Union{Bool,Nothing}
end

function get_options(m::Model)
    return get(
        m.model.ext,
        :MOF_OPTIONS,
        Options(false, false, MOI.Nonlinear.SparseReverseMode(), nothing),
    )
end

"""
    Model(;
        print_compact::Bool = false,
        warn::Bool = false,
        differentiation_backend::MOI.Nonlinear.AbstractAutomaticDifferentiation =
            MOI.Nonlinear.SparseReverseMode(),
        use_nlp_block::Union{Bool,Nothing} = nothing,
        coefficient_type::Type{T} = Float64,
    ) where {T}

Create an empty instance of FileFormats.MOF.Model.

Keyword arguments are:

 - `print_compact::Bool=false`: print the JSON file in a compact format without
   spaces or newlines.

 - `warn::Bool=false`: print a warning when variables or constraints are renamed

 - `differentiation_backend::MOI.Nonlinear.AbstractAutomaticDifferentiation = MOI.Nonlinear.SparseReverseMode()`:
   automatic differentiation backend to use when reading models with nonlinear
   constraints and objectives.

  `use_nlp_block::Bool=true`: if `true` parse `"ScalarNonlinearFunction"`
   into an `MOI.NLPBlock`. If `false`, `"ScalarNonlinearFunction"` are parsed as
   `MOI.ScalarNonlinearFunction` functions.

 - `coefficient_type::Type{T} = Float64`: the supported type to use when reading
   and writing files.
"""
function Model(;
    print_compact::Bool = false,
    warn::Bool = false,
    differentiation_backend::MOI.Nonlinear.AbstractAutomaticDifferentiation = MOI.Nonlinear.SparseReverseMode(),
    use_nlp_block::Union{Bool,Nothing} = nothing,
    coefficient_type::Type{T} = Float64,
) where {T}
    model = MOI.Utilities.UniversalFallback(InnerModel{T}())
    model.model.ext[:MOF_OPTIONS] =
        Options(print_compact, warn, differentiation_backend, use_nlp_block)
    return model
end

Base.summary(io::IO, ::Model) = print(io, "MOI.FileFormats.MOF.Model")

include("read.jl")
include("write.jl")

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestUtilitiesFunctions

using Test

import MathOptInterface as MOI
import MutableArithmetics as MA

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

const w = MOI.VariableIndex(0)
const x = MOI.VariableIndex(1)
const y = MOI.VariableIndex(2)
const z = MOI.VariableIndex(3)

function test_Vectorization_vectorize()
    g = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.([3, 1], MOI.ScalarAffineTerm.([5, 2], [y, x])),
        [3, 1, 4],
    )
    g1 = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(2, x)], 3)
    g2 = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{Int}[], 1)
    g3 = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(5, y)], 4)
    @test g ≈ MOI.Utilities.vectorize([g1, g2, g3])
    vov = MOI.Utilities.vectorize(MOI.VariableIndex[])
    @test MOI.output_dimension(vov) == 0
    @test vov isa MOI.VectorOfVariables
    aff = MOI.Utilities.vectorize(MOI.ScalarAffineFunction{Int}[])
    @test MOI.output_dimension(aff) == 0
    @test aff isa MOI.VectorAffineFunction{Int}
    quad = MOI.Utilities.vectorize(MOI.ScalarQuadraticFunction{Int}[])
    @test MOI.output_dimension(quad) == 0
    @test quad isa MOI.VectorQuadraticFunction{Int}
    return
end

function test_Vectorization_operate_vcat()
    for T in [Int, Float64]
        a = one(T)
        b = zero(T)
        c = 2a
        x = [b, c]
        @test MOI.Utilities.promote_operation(vcat, T, T, Vector{T}, T) ==
              Vector{T}
        @test MOI.Utilities.operate(vcat, T, a, x, b) == vcat(a, x, b)
        @test MOI.Utilities.promote_operation(vcat, T, T) == Vector{T}
        @test MOI.Utilities.operate(vcat, T, a) == [a]
        @test MOI.Utilities.promote_operation(vcat, T, Vector{T}) == Vector{T}
        @test MOI.Utilities.operate(vcat, T, x) == x
    end
    g = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.([3, 1], MOI.ScalarAffineTerm.([5, 2], [y, x])),
        [3, 1, 4],
    )
    v = MOI.VectorOfVariables([y, w])
    for T in [Int, Float64]
        @test MOI.VectorOfVariables == MOI.Utilities.promote_operation(
            vcat,
            T,
            typeof(w),
            typeof(v),
            typeof(x),
        )
        vov = MOI.Utilities.operate(vcat, T, w, v, x)
        @test vov.variables == [w, y, w, x]
        @test MOI.VectorOfVariables == MOI.Utilities.promote_operation(
            vcat,
            T,
            typeof(v),
            typeof(w),
            typeof(x),
        )
        vov = MOI.Utilities.operate(vcat, T, v, w, x)
        @test vov.variables == [y, w, w, x]
        @test MOI.VectorOfVariables == MOI.Utilities.promote_operation(
            vcat,
            T,
            typeof(w),
            typeof(x),
            typeof(v),
        )
        vov = MOI.Utilities.operate(vcat, T, w, x, v)
        @test vov.variables == [w, x, y, w]
    end
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([2, 4], [x, z]), 5)
    g = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.([3, 1], MOI.ScalarAffineTerm.([5, 2], [y, x])),
        [3, 1, 4],
    )
    @test MOI.Utilities.promote_operation(
        vcat,
        Int,
        typeof(w),
        typeof(f),
        typeof(v),
        Int,
        typeof(g),
        typeof(x),
        Int,
    ) == MOI.VectorAffineFunction{Int}
    F = MOI.Utilities.operate(vcat, Int, w, f, v, 3, g, x, -4)
    expected_terms = MOI.VectorAffineTerm.(
        [1, 2, 2, 3, 4, 8, 6, 9],
        MOI.ScalarAffineTerm.(
            [1, 2, 4, 1, 1, 5, 2, 1],
            [w, x, z, y, w, y, x, x],
        ),
    )
    expected_constants = [0, 5, 0, 0, 3, 3, 1, 4, 0, -4]
    F = MOI.Utilities.operate(vcat, Int, w, f, v, 3, g, x, -4)
    @test F.terms == expected_terms
    @test F.constants == expected_constants
    return
end

function test_promote_operation_Quadratic()
    @test MOI.Utilities.promote_operation(
        vcat,
        Int,
        MOI.VectorQuadraticFunction{Int},
        MOI.VariableIndex,
        MOI.ScalarQuadraticFunction{Int},
        MOI.VectorOfVariables,
        Int,
        MOI.ScalarQuadraticFunction{Int},
        MOI.VectorQuadraticFunction{Int},
        MOI.VariableIndex,
        Int,
    ) == MOI.VectorQuadraticFunction{Int}
    for T in (Float64, Int)
        for TV in (MOI.ScalarAffineFunction{T}, MOI.ScalarQuadraticFunction{T})
            @test promote_type(TV, MOI.VariableIndex) == TV
        end
    end
    return
end

function test_MultirowChange_construction()
    chg1 = MOI.MultirowChange(w, [(Int32(2), 2.0), (Int32(1), 3.0)])
    chg2 = MOI.MultirowChange(w, [(Int64(2), 2.0), (Int64(1), 3.0)])
    @test chg1.variable == chg2.variable
    @test chg1.new_coefficients == chg2.new_coefficients
    return
end

function test_VectorAffineTerm_VectorQuadraticTerm_construction()
    scalaraffine = MOI.ScalarAffineTerm(2.0, z)
    @test MOI.VectorAffineTerm(Int32(3), scalaraffine) ===
          MOI.VectorAffineTerm(Int64(3), scalaraffine)
    @test MOI.VectorAffineTerm{Float64}(Int32(3), scalaraffine) ===
          MOI.VectorAffineTerm(Int64(3), scalaraffine)
    scalarquad = MOI.ScalarQuadraticTerm(2.0, y, z)
    @test MOI.VectorQuadraticTerm(Int32(3), scalarquad) ===
          MOI.VectorQuadraticTerm(Int64(3), scalarquad)
    @test MOI.VectorQuadraticTerm{Float64}(Int32(3), scalarquad) ===
          MOI.VectorQuadraticTerm(Int64(3), scalarquad)
    return
end

function test_eval_variables()
    # We do tests twice to make sure the function is not modified
    vals = Dict(w => 0, x => 3, y => 1, z => 5)
    @test MOI.output_dimension(z) == 1
    @test MOI.Utilities.eval_variables(vi -> vals[vi], z) ≈ 5
    @test MOI.Utilities.eval_variables(vi -> vals[vi], z) ≈ 5
    fvv = MOI.VectorOfVariables([x, z, y])
    @test MOI.output_dimension(fvv) == 3
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fvv) ≈ [3, 5, 1]
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fvv) ≈ [3, 5, 1]
    fsa = MOI.ScalarAffineFunction(
        [
            MOI.ScalarAffineTerm(1.0, x),
            MOI.ScalarAffineTerm(3.0, z),
            MOI.ScalarAffineTerm(2.0, y),
        ],
        2.0,
    )
    @test MOI.output_dimension(fsa) == 1
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fsa) ≈ 22
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fsa) ≈ 22
    fva = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(
            [2, 1, 2],
            MOI.ScalarAffineTerm.([1.0, 3.0, 2.0], [x, z, y]),
        ),
        [-3.0, 2.0],
    )
    @test MOI.output_dimension(fva) == 2
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fva) ≈ [12, 7]
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fva) ≈ [12, 7]
    fsq = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.(1.0, [x, w, w], [z, z, y]),
        MOI.ScalarAffineTerm.(1.0, [x, y]),
        -3.0,
    )
    @test MOI.output_dimension(fsq) == 1
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fsq) ≈ 16
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fsq) ≈ 16
    fvq = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            [1, 2, 2],
            MOI.ScalarQuadraticTerm.(1.0, [x, w, w], [z, z, y]),
        ),
        MOI.VectorAffineTerm.([2, 1], MOI.ScalarAffineTerm.(1.0, [x, y])),
        [-3.0, -2.0],
    )
    @test MOI.output_dimension(fvq) == 2
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fvq) ≈ [13, 1]
    @test MOI.Utilities.eval_variables(vi -> vals[vi], fvq) ≈ [13, 1]
    return
end

function test_eval_variables_scalar_nonlinear_function()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    @test MOI.Utilities.eval_variables(xi -> 0.5, model, f) ≈ log(0.5)
    f = MOI.ScalarNonlinearFunction(:*, Any[x, 2.0*x, 1.0*x+2.0])
    @test MOI.Utilities.eval_variables(xi -> 0.5, model, f) ≈
          0.5 * (2.0 * 0.5) * (1.0 * 0.5 + 2.0)
    f = MOI.ScalarNonlinearFunction(
        :ifelse,
        Any[MOI.ScalarNonlinearFunction(:<, Any[x, 1.0]), 0.0, x],
    )
    @test MOI.Utilities.eval_variables(xi -> 0.5, model, f) ≈ 0.0
    @test MOI.Utilities.eval_variables(xi -> 1.5, model, f) ≈ 1.5
    f = MOI.ScalarNonlinearFunction(
        :||,
        Any[
            MOI.ScalarNonlinearFunction(:<, Any[x, 0.0]),
            MOI.ScalarNonlinearFunction(:>, Any[x, 1.0]),
        ],
    )
    @test MOI.Utilities.eval_variables(xi -> 0.5, model, f) ≈ 0.0
    @test MOI.Utilities.eval_variables(xi -> 1.5, model, f) ≈ 1.0
    @test MOI.Utilities.eval_variables(xi -> -0.5, model, f) ≈ 1.0
    my_square(x, y) = (x - y)^2
    MOI.set(model, MOI.UserDefinedFunction(:my_square, 2), (my_square,))
    f = MOI.ScalarNonlinearFunction(:my_square, Any[x, 1.0])
    @test MOI.Utilities.eval_variables(xi -> 0.5, model, f) ≈ (0.5 - 1.0)^2
    f = MOI.ScalarNonlinearFunction(:bad_f, Any[x, 1.0])
    @test_throws(
        MOI.UnsupportedNonlinearOperator(:bad_f),
        MOI.Utilities.eval_variables(xi -> 0.5, model, f)
    )
    return
end

function test_eval_variables_vector_nonlinear_function()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    g = MOI.VectorNonlinearFunction(Any[1.0, x, 2.0*x, f])
    @test ≈(
        MOI.Utilities.eval_variables(xi -> 0.5, model, g),
        [1.0, 0.5, 1.0, log(0.5)],
    )
    return
end

function test_substitute_variables()
    # We do tests twice to make sure the function is not modified
    subs = Dict(w => 1.0y + 1.0z, x => 2.0y + 1.0, y => 1.0y, z => -1.0w)
    vals = Dict(w => 0.0, x => 3.0, y => 1.0, z => 5.0)
    subs_vals = Dict(w => 6.0, x => 3.0, y => 1.0, z => 0.0)
    fsa = x + 3.0z + 2.0y + 2.0
    subs_sa = -3.0w + 4.0y + 3.0
    @test MOI.Utilities.eval_variables(vi -> subs_vals[vi], fsa) ==
          MOI.Utilities.eval_variables(vi -> vals[vi], subs_sa)
    @test MOI.Utilities.substitute_variables(vi -> subs[vi], fsa) ≈ subs_sa
    @test MOI.Utilities.substitute_variables(vi -> subs[vi], fsa) ≈ subs_sa
    fva = MOI.Utilities.operate(vcat, Float64, 3.0z - 3.0, x + 2.0y + 2.0)
    subs_va = MOI.Utilities.operate(vcat, Float64, -3.0w - 3.0, 4.0y + 3.0)
    @test MOI.Utilities.eval_variables(vi -> subs_vals[vi], fva) ==
          MOI.Utilities.eval_variables(vi -> vals[vi], subs_va)
    @test MOI.Utilities.substitute_variables(vi -> subs[vi], fva) ≈ subs_va
    @test MOI.Utilities.substitute_variables(vi -> subs[vi], fva) ≈ subs_va
    fsq = 1.0x + 1.0y + 1.0x * z + 1.0w * z + 1.0w * y + 2.0w * w - 3.0
    #     2y + 1 +     y - 2yw - w    + (y + z) * (-w) + (y + z) * y  + 2 (y + z) * (y + z) - 3
    #     2y     +     y - 2yw - w    - yw - zw        + y^2 + zy     + 2y^2 + 2z^2 + 4yz   - 2
    #     3y - w + 3y^2 + 2z^2 - 3yw - zw + 5yz - 2
    subs_sq =
        3.0y - 1.0w + 3.0y * y + 2.0z * z - 3.0y * w - 1.0z * w + 5.0y * z - 2.0
    @test MOI.Utilities.eval_variables(vi -> subs_vals[vi], fsq) ==
          MOI.Utilities.eval_variables(vi -> vals[vi], subs_sq)
    @test MOI.Utilities.substitute_variables(vi -> subs[vi], fsq) ≈ subs_sq
    @test MOI.Utilities.substitute_variables(vi -> subs[vi], fsq) ≈ subs_sq
    fvq = MOI.Utilities.operate(
        vcat,
        Float64,
        1.0y + 1.0x * z - 3.0,
        1.0x + 1.0w * z + 1.0w * y - 2.0,
    )
    subs_vq = MOI.Utilities.operate(
        vcat,
        Float64,
        1.0y - w - 2.0y * w - 3.0,
        2.0y + 1.0y * y - 1.0w * y - 1.0w * z + 1.0y * z - 1.0,
    )
    @test MOI.Utilities.eval_variables(vi -> subs_vals[vi], fvq) ==
          MOI.Utilities.eval_variables(vi -> vals[vi], subs_vq)
    @test MOI.Utilities.substitute_variables(vi -> subs[vi], fvq) ≈ subs_vq
    @test MOI.Utilities.substitute_variables(vi -> subs[vi], fvq) ≈ subs_vq

    complex_aff = 2.0im * y
    # Test that variables can be substituted for `MOI.ScalarAffineFunction{S}`
    # in a `MOI.ScalarAffineFunction{T}` where `S != T`.
    @test MOI.Utilities.substitute_variables(vi -> 1.5x, complex_aff) ≈
          3.0im * x
    float_aff = 2.0 * y
    @test MOI.Utilities.substitute_variables(vi -> 3x, float_aff) ≈ 6.0 * x
    complex_quad = 1.5im * y * y
    @test MOI.Utilities.substitute_variables(vi -> 2x, complex_quad) ≈
          6.0im * x * x
    int_quad = 3 * y * x
    @test MOI.Utilities.substitute_variables(vi -> true * y, int_quad) ≈
          3 * y * y
    return
end

function test_substitute_variables_vector_nonlinear_function()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    g = MOI.VectorNonlinearFunction(Any[1.0, x, 2.0*x, f])
    @test ≈(
        MOI.Utilities.substitute_variables(x -> 1.5 * x, g),
        MOI.VectorNonlinearFunction([
            MOI.ScalarNonlinearFunction(:+, Any[1.0]),
            MOI.ScalarNonlinearFunction(:+, Any[1.5*x]),
            MOI.ScalarNonlinearFunction(
                :+,
                Any[MOI.ScalarNonlinearFunction(:*, Any[2.0, 1.5*x])],
            ),
            MOI.ScalarNonlinearFunction(:log, Any[1.5*x]),
        ]),
    )
    return
end

function test_canonicalize_vector_nonlinear_function()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[1.0*x+2.0*x])
    fi = 1.0 * x + 1.0 * x
    @test length(fi.terms) == 2
    g = MOI.VectorNonlinearFunction(Any[1.0, x, fi, f])
    @test g.rows[4] === f
    MOI.Utilities.canonicalize!(g)
    @test g.rows[4] === f
    @test length(f.args[1].terms) == 1
    return
end

function test_eachscalar_vector_nonlinear_function()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[1.0*x+2.0*x])
    g = MOI.VectorNonlinearFunction(Any[1.0, x, 2.0*x, f])
    scalars = MOI.Utilities.eachscalar(g)
    @test eltype(scalars) == MOI.ScalarNonlinearFunction
    @test ≈(scalars[1], MOI.ScalarNonlinearFunction(:+, Any[1.0]))
    @test ≈(scalars[2], MOI.ScalarNonlinearFunction(:+, Any[x]))
    @test ≈(scalars[3], convert(MOI.ScalarNonlinearFunction, 2.0 * x))
    @test ≈(scalars[4], f)
    @test ≈(scalars[2:3], MOI.VectorNonlinearFunction(Any[x, 2.0*x]))
    return
end

function test_map_indices()
    fsq = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.(1.0, [x, w, w], [z, z, y]),
        MOI.ScalarAffineTerm.(1.0, [x, y]),
        -3.0,
    )
    index_map = Dict(x => y, y => z, w => w, z => x)
    gsq = MOI.Utilities.map_indices(index_map, fsq)
    sats = MOI.ScalarAffineTerm.(1.0, [y, z])
    sqts = MOI.ScalarQuadraticTerm.(1.0, [y, w, w], [x, x, z])
    @test gsq.affine_terms == sats
    @test gsq.quadratic_terms == sqts
    @test gsq.constant == -3.0
    fvq = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            [1, 2, 2],
            MOI.ScalarQuadraticTerm.(1.0, [x, w, w], [z, z, y]),
        ),
        MOI.VectorAffineTerm.([2, 1], MOI.ScalarAffineTerm.(1.0, [x, y])),
        [-3.0, -2.0],
    )
    gvq = MOI.Utilities.map_indices(index_map, fvq)
    @test gvq.affine_terms == MOI.VectorAffineTerm.([2, 1], sats)
    @test gvq.quadratic_terms == MOI.VectorQuadraticTerm.([1, 2, 2], sqts)
    @test MOI.Utilities.constant_vector(gvq) == [-3.0, -2.0]
    @test MOI.Utilities.map_indices(index_map, :s) == :s
    @test MOI.Utilities.map_indices(index_map, [:a, :b]) == [:a, :b]
    @test MOI.Utilities.map_indices(index_map, "s") == "s"
    @test MOI.Utilities.map_indices(index_map, ["a", "b"]) == ["a", "b"]
    return
end

function test_Conversion_VectorOfVariables_VectorAffineFunction()
    f = MOI.VectorAffineFunction{Int}(MOI.VectorOfVariables([z, x, y]))
    @test f isa MOI.VectorAffineFunction{Int}
    @test f.terms == MOI.VectorAffineTerm.(
        1:3,
        MOI.ScalarAffineTerm.(ones(Int, 3), [z, x, y]),
    )
    @test all(iszero.(MOI.Utilities.constant_vector(f)))
    f = MOI.VectorAffineFunction{Float64}(MOI.VectorOfVariables([x, w]))
    @test f isa MOI.VectorAffineFunction{Float64}
    @test f.terms ==
          MOI.VectorAffineTerm.(1:2, MOI.ScalarAffineTerm.(1.0, [x, w]))
    @test all(iszero.(MOI.Utilities.constant_vector(f)))
    return
end

function test_iteration_and_indexing_on_VectorOfVariables()
    f = MOI.VectorOfVariables([z, w, x, y])
    it = MOI.Utilities.eachscalar(f)
    @test it isa AbstractVector{MOI.VariableIndex}
    @test size(it) == (4,)
    @test length(it) == 4
    @test eltype(it) == MOI.VariableIndex
    @test collect(it) == [z, w, x, y]
    @test it[2] == w
    @test it[end] == y
    return
end

function test_indexing_on_VectorAffineFunction()
    f = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(
            [2, 1, 3, 2, 2, 1, 3, 1, 2],
            MOI.ScalarAffineTerm.(
                [1, 7, 2, 9, 3, 1, 6, 4, 1],
                [x, y, z, z, y, z, x, x, y],
            ),
        ),
        [2, 7, 5],
    )
    it = MOI.Utilities.eachscalar(f)
    @test it isa AbstractVector{MOI.ScalarAffineFunction{Int}}
    @test size(it) == (3,)
    @test length(it) == 3
    @test eltype(it) == MOI.ScalarAffineFunction{Int}
    g = it[2]
    @test g isa MOI.ScalarAffineFunction
    @test g.terms == MOI.ScalarAffineTerm.([1, 9, 3, 1], [x, z, y, y])
    @test g.constant == 7
    g = it[1]
    @test g isa MOI.ScalarAffineFunction
    @test g.terms == MOI.ScalarAffineTerm.([7, 1, 4], [y, z, x])
    @test g.constant == 2
    g = it[end]
    @test g isa MOI.ScalarAffineFunction
    @test g.terms == MOI.ScalarAffineTerm.([2, 6], [z, x])
    @test g.constant == 5
    h = it[[3, 1]]
    @test h isa MOI.VectorAffineFunction
    @test sort(h.terms, by = t -> t.output_index) == MOI.VectorAffineTerm.(
        [1, 1, 2, 2, 2],
        MOI.ScalarAffineTerm.([2, 6, 7, 1, 4], [z, x, y, z, x]),
    )
    @test MOI.Utilities.constant_vector(h) == [5, 2]
    F = MOI.Utilities.operate(vcat, Int, it[[1, 2]], it[3])
    @test F isa MOI.VectorAffineFunction{Int}
    @test sort(F.terms, by = t -> t.output_index) == MOI.VectorAffineTerm.(
        [1, 1, 1, 2, 2, 2, 2, 3, 3],
        MOI.ScalarAffineTerm.(
            [7, 1, 4, 1, 9, 3, 1, 2, 6],
            [y, z, x, x, z, y, y, z, x],
        ),
    )
    @test MOI.Utilities.constant_vector(F) == MOI.Utilities.constant_vector(f)
    return
end

function test_indexing_on_VectorQuadraticFunction()
    f = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            [2, 3, 1, 2],
            MOI.ScalarQuadraticTerm.([1, 6, 4, 3], [z, x, x, y], [y, z, z, y]),
        ),
        MOI.VectorAffineTerm.(
            [2, 1, 3, 2, 2],
            MOI.ScalarAffineTerm.([1, 7, 2, 9, 3], [x, y, z, z, y]),
        ),
        [2, 7, 5],
    )
    it = MOI.Utilities.eachscalar(f)
    @test length(it) == 3
    @test eltype(it) == MOI.ScalarQuadraticFunction{Int}
    g = it[2]
    @test g isa MOI.ScalarQuadraticFunction
    @test g.affine_terms == MOI.ScalarAffineTerm.([1, 9, 3], [x, z, y])
    @test g.quadratic_terms == MOI.ScalarQuadraticTerm.([1, 3], [z, y], [y, y])
    @test g.constant == 7
    g = it[end]
    @test g isa MOI.ScalarQuadraticFunction
    @test g.affine_terms == MOI.ScalarAffineTerm.([2], [z])
    @test g.quadratic_terms == MOI.ScalarQuadraticTerm.([6], [x], [z])
    @test g.constant == 5
    return
end

function test_Scalar_Variable_isone()
    f = MOI.VariableIndex(0)
    g = MOI.VariableIndex(1)
    @test !isone(f)
    @test !isone(g)
    return
end

function test_Scalar_Variable_iszero()
    f = MOI.VariableIndex(0)
    g = MOI.VariableIndex(1)
    @test !iszero(f)
    @test !iszero(g)
    @test f + 1 ≈ 1 + f
    @test (f + 1.0) - 1.0 ≈ (2.0f) / 2.0
    @test (f - 1.0) + 1.0 ≈ (2.0f) / 2.0
    @test (1.0 + f) - 1.0 ≈ (f * 2.0) / 2.0
    @test 1.0 - (1.0 - f) ≈ (f / 2.0) * 2.0
    return
end

function test_Scalar_Variable_complex()
    f = MOI.VariableIndex(0)
    @test real(f) === f
    @test MA.promote_operation(real, typeof(f)) == typeof(f)
    for T in [Int, Int32, Float64]
        z = MOI.Utilities.operate(imag, T, f)
        @test z isa MOI.ScalarAffineFunction{T}
        @test iszero(z)
        @test MOI.Utilities.promote_operation(imag, T, typeof(f)) == typeof(z)
    end
    @test conj(f) === f
    @test MA.promote_operation(conj, typeof(f)) == typeof(f)
    return
end

function test_Scalar_Affine_zero()
    f = @inferred MOI.Utilities.zero(MOI.ScalarAffineFunction{Float64})
    @test iszero(f)
    @test MOI.Utilities.isapprox_zero(f, 1e-16)
    return
end

function test_Scalar_Affine_complex()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    r = 3x + 4y
    c = 2x + 5y
    f = (1 + 0im) * r + c * im
    @test real(f) ≈ r
    @test MOI.Utilities.operate(imag, Int, f) ≈ c
    @test imag(f) ≈ c
    @test conj(f) ≈ (1 + 0im) * r - c * im
    @test MA.promote_operation(real, typeof(f)) == typeof(r)
    @test MA.promote_operation(imag, typeof(f)) == typeof(c)
    @test MA.promote_operation(conj, typeof(f)) == typeof(f)
    return
end

function test_Scalar_Affine_promote_operation()
    @test MOI.Utilities.promote_operation(-, Int, MOI.VariableIndex) ==
          MOI.ScalarAffineFunction{Int}
    @test MOI.Utilities.promote_operation(
        -,
        Int,
        MOI.ScalarAffineFunction{Int},
    ) == MOI.ScalarAffineFunction{Int}
    @test MOI.Utilities.promote_operation(
        +,
        Float64,
        MOI.VariableIndex,
        MOI.VariableIndex,
    ) == MOI.ScalarAffineFunction{Float64}
    @test MOI.Utilities.promote_operation(
        +,
        Float64,
        MOI.ScalarAffineFunction{Float64},
        Float64,
    ) == MOI.ScalarAffineFunction{Float64}
    @test MOI.Utilities.promote_operation(
        +,
        Int,
        MOI.ScalarAffineFunction{Int},
        MOI.ScalarAffineFunction{Int},
    ) == MOI.ScalarAffineFunction{Int}
    return
end

function test_Scalar_Affine_comparison()
    @test MOI.Utilities.operate(+, Float64, x, z) + 1.0 ≈
          MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.([1, 1e-7, 1], [x, y, z]),
        1.0,
    ) atol = 1e-6
    f1 = MOI.ScalarAffineFunction(
        [MOI.ScalarAffineTerm(1.0, x), MOI.ScalarAffineTerm(1e-7, y)],
        1.0,
    )
    f2 = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 1.0)
    @test f1 ≈ f2 atol = 1e-6
    fdiff = f1 - f2
    @test !iszero(fdiff)
    @test iszero(f1 - f1)
    @test iszero(f2 - f2)
    MOI.Utilities.canonicalize!(fdiff)
    @test !MOI.Utilities.isapprox_zero(fdiff, 1e-8)
    @test MOI.Utilities.isapprox_zero(fdiff, 1e-6)
    return
end

function test_Scalar_Affine_canonical()
    f = MOI.Utilities.canonical(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([2, 1, 3, -2, -3], [y, x, z, x, z]),
            5,
        ),
    )
    @test MOI.output_dimension(f) == 1
    @test f.terms == MOI.ScalarAffineTerm.([-1, 2], [x, y])
    @test f.constant == 5
    f = MOI.Utilities.canonical(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1, 3, 1, 2, -3, 2], [w, y, w, x, x, z]),
            2,
        ) + MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([-1, -2, -2, 3, 2], [y, z, w, x, y]),
            3,
        ),
    )
    @test f.terms == MOI.ScalarAffineTerm.([2, 4], [x, y])
    @test f.constant == 5
end

function test_Scalar_Affine_convert()
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([1.0, 0.5], [x, y]), 0.5)
    @test_throws InexactError convert(MOI.VariableIndex, f)
    @test_throws InexactError MOI.Utilities.convert_approx(MOI.VariableIndex, f)
    @test MOI.Utilities.convert_approx(MOI.VariableIndex, f, tol = 0.5) == x
    @test convert(typeof(f), f) === f
    quad_f = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm{Float64}[],
        f.terms,
        f.constant,
    )
    @test convert(MOI.ScalarQuadraticFunction{Float64}, f) ≈ quad_f
    for g in [
        convert(MOI.ScalarAffineFunction{Float64}, x),
        convert(MOI.ScalarAffineFunction{Float64}, 1x),
    ]
        @test g isa MOI.ScalarAffineFunction{Float64}
        @test convert(MOI.VariableIndex, g) == x
        @test MOI.Utilities.convert_approx(MOI.VariableIndex, g) == x
    end
    return
end

function test_Scalar_Affine_operate_with_Float_coefficient()
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([1.0, 4.0], [x, y]), 5.0)
    @test f ≈ 2.0f / 2.0
    return
end

function test_Scalar_Affine_operate_with_Int_coefficient()
    f = MOI.Utilities.canonical(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1, 3, 1, 2, -3, 2], [w, y, w, x, x, z]),
            2,
        ) + MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([-1, -2, -2, 3, 2], [y, z, w, x, y]),
            3,
        ),
    )
    @test f === +f
    @test f ≈
          x + MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([1, 4], [x, y]), 5)
    @test f ≈ f * 1
    @test f ≈
          MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([1, 2], [x, y]), 2) *
          2 + 1
    @test f ≈
          x -
          MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([-1, -4], [x, y]), -5)
    @test f ≈
          MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([3, 4], [x, y]), 5) - x
    return
end

function test_Scalar_Affine_modification()
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([2, 4], [x, y]), 0)
    f = MOI.Utilities.modify_function(f, MOI.ScalarConstantChange(6))
    @test f.constant == 6
    g = deepcopy(f)
    @test g ≈ f
    f = MOI.Utilities.modify_function(f, MOI.ScalarCoefficientChange(y, 3))
    @test !(g ≈ f)
    @test g.terms == MOI.ScalarAffineTerm.([2, 4], [x, y])
    @test f.terms == MOI.ScalarAffineTerm.([2, 3], [x, y])
    f = MOI.Utilities.modify_function(f, MOI.ScalarCoefficientChange(x, 0))
    @test f.terms == MOI.ScalarAffineTerm.([3], [y])
    return
end

function test_Scalar_Quadratic_zero()
    f = @inferred MOI.Utilities.zero(MOI.ScalarQuadraticFunction{Float64})
    @test MOI.Utilities.isapprox_zero(f, 1e-16)
    return
end

function test_Scalar_Quadratic_promote_operation()
    @test MOI.Utilities.promote_operation(
        -,
        Int,
        MOI.ScalarQuadraticFunction{Int},
    ) == MOI.ScalarQuadraticFunction{Int}
    @test MOI.Utilities.promote_operation(
        +,
        Int,
        MOI.ScalarQuadraticFunction{Int},
        MOI.ScalarQuadraticFunction{Int},
    ) == MOI.ScalarQuadraticFunction{Int}
    @test MOI.Utilities.promote_operation(
        +,
        Int,
        MOI.ScalarQuadraticFunction{Int},
        MOI.ScalarAffineFunction{Int},
    ) == MOI.ScalarQuadraticFunction{Int}
    @test MOI.Utilities.promote_operation(
        +,
        Int,
        MOI.ScalarAffineFunction{Int},
        MOI.ScalarQuadraticFunction{Int},
    ) == MOI.ScalarQuadraticFunction{Int}
    @test MOI.Utilities.promote_operation(
        *,
        Int,
        MOI.VariableIndex,
        MOI.VariableIndex,
    ) == MOI.ScalarQuadraticFunction{Int}
    @test MOI.Utilities.promote_operation(
        *,
        Float64,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{Float64},
    ) == MOI.ScalarQuadraticFunction{Float64}
    @test MOI.Utilities.promote_operation(
        *,
        Int,
        MOI.ScalarAffineFunction{Int},
        MOI.VariableIndex,
    ) == MOI.ScalarQuadraticFunction{Int}
    @test MOI.Utilities.promote_operation(
        *,
        Float64,
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarAffineFunction{Float64},
    ) == MOI.ScalarQuadraticFunction{Float64}
    @test MOI.Utilities.promote_operation(
        /,
        Float64,
        MOI.ScalarQuadraticFunction{Float64},
        Float64,
    ) == MOI.ScalarQuadraticFunction{Float64}
    return
end

function test_Scalar_Quadratic_Comparison_With_iszero()
    f = 7 + 3x + 1x * x + 2y * y + 3x * y
    MOI.Utilities.canonicalize!(f)
    @test !iszero(f)
    @test iszero(0 * f)
    @test iszero(f - f)
    return
end

function test_Scalar_Quadratic_Comparison_With_tolerance()
    f = 7 + 3x + 1x * x + 2y * y + 3x * y
    MOI.Utilities.canonicalize!(f)
    @test !MOI.Utilities.isapprox_zero(f, 1e-8)
    # Test isapprox_zero with zero terms
    @test MOI.Utilities.isapprox_zero(0 * f, 1e-8)
    g = 1.0x * y - (1 + 1e-6) * y * x
    MOI.Utilities.canonicalize!(g)
    @test MOI.Utilities.isapprox_zero(g, 1e-5)
    @test !MOI.Utilities.isapprox_zero(g, 1e-7)
    return
end

function test_Scalar_Quadratic_convert()
    f = 7 + 3x + 1x * x + 2y * y + 3x * y
    MOI.Utilities.canonicalize!(f)
    @test_throws InexactError convert(MOI.VariableIndex, f)
    @test_throws InexactError convert(MOI.ScalarAffineFunction{Int}, f)
    g = convert(MOI.ScalarQuadraticFunction{Float64}, x)
    @test convert(MOI.VariableIndex, g) == x
    return
end

function test_Scalar_Quadratic_Power_Affine()
    f = 7 + 3x + 1x * x + 2y * y + 3x * y
    aff = 1x + 2 + y
    @test isone(@inferred aff^0)
    @test convert(typeof(f), aff) ≈ @inferred aff^1
    @test aff * aff ≈ @inferred aff^2
    err = ArgumentError("Cannot take $(typeof(aff)) to the power 3.")
    @test_throws err aff^3
    return
end

function test_Scalar_Quadratic_Power_Quadratic()
    f = 7 + 3x + 1x * x + 2y * y + 3x * y
    @test isone(@inferred f^0)
    @test f ≈ @inferred f^1
    err = ArgumentError("Cannot take $(typeof(f)) to the power 2.")
    @test_throws err f^2
    return
end

function test_Scalar_Quadratic_no_zero_affine_term()
    # Test that no affine 0y term is created when multiplying 1x by y
    for xy in [1x * y, x * 1y]
        @test isempty(xy.affine_terms)
        @test length(xy.quadratic_terms) == 1
        @test xy.quadratic_terms[1] == MOI.ScalarQuadraticTerm(1, x, y) ||
              xy.quadratic_terms[1] == MOI.ScalarQuadraticTerm(1, y, x)
    end
    for xx in [1x * x, x * 1x]
        @test isempty(xx.affine_terms)
        @test length(xx.quadratic_terms) == 1
        @test xx.quadratic_terms[1] == MOI.ScalarQuadraticTerm(2, x, x)
    end
    return
end

function test_Scalar_Quadratic_operate!()
    q = 1.0x + 1.0y + (1.0x) * z + (1.0w) * z
    @test q ≈ 1.0x + 1.0y + (1.0w) * z + (1.0x) * z
    # This calls
    aff = 1.0x + 1.0y
    # which tries to mutate `aff`, gets a quadratic expression
    # and mutate it with the remaining term
    @test MOI.Utilities.operate!(+, Float64, aff, (1.0x) * z, (1.0w) * z) ≈ q
    return
end

function test_Scalar_Quadratic_operate()
    f = 7 + 3x + 1x * x + 2y * y + 3x * y
    @test f ≈ 7 + (x + 2y) * (1x + y) + 3x
    @test f ≈ -(-7 - 3x) + (x + 2y) * (1x + y)
    @test f ≈ -((x + 2y) * (MOI.Utilities.operate(-, Int, x) - y)) + 3x + 7
    @test f ≈ 7 + MOI.Utilities.operate(*, Int, x, x) + 3x * (y + 1) + 2y * y
    @test f ≈ (x + 2) * (x + 1) + (y + 1) * (2y + 3x) + (5 - 3x - 2y)
    @test f ≈ begin
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.([2], [x], [x]),
            [MOI.ScalarAffineTerm(3, x)],
            4,
        ) + MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.([4, 3], [y, x], [y, y]),
            MOI.ScalarAffineTerm{Int}[],
            3,
        )
    end
    @test f ≈ begin
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.([2], [x], [x]),
            [MOI.ScalarAffineTerm(3, x)],
            10,
        ) - MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.([-4, -3], [y, x], [y, y]),
            MOI.ScalarAffineTerm{Int}[],
            3,
        )
    end
    @test f ≈ begin
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(3, x)], 5) +
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.([2, 4, 3], [x, y, x], [x, y, y]),
            MOI.ScalarAffineTerm{Int}[],
            2,
        )
    end
    @test f ≈ begin
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(3, x)], 5) -
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.([-2, -4, -3], [x, y, x], [x, y, y]),
            MOI.ScalarAffineTerm{Int}[],
            -2,
        )
    end
    @test f ≈ begin
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.([2, 4, 3], [x, y, x], [x, y, y]),
            MOI.ScalarAffineTerm{Int}[],
            2,
        ) + MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(3, x)], 5)
    end
    @test f ≈ begin
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.([2, 4, 3], [x, y, x], [x, y, y]),
            MOI.ScalarAffineTerm{Int}[],
            12,
        ) - MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(-3, x)], 5)
    end
    @test f ≈ begin
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.([2, 4, 3], [x, y, x], [x, y, y]),
            MOI.ScalarAffineTerm.([2], [x]),
            7,
        ) + x
    end
    @test f ≈
          MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.([2, 4, 3], [x, y, x], [x, y, y]),
        MOI.ScalarAffineTerm.([3], [x]),
        10,
    ) - 3
    @test f ≈
          2.0 * MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.([2.0, 4.0, 3.0], [x, y, x], [x, y, y]),
        MOI.ScalarAffineTerm.([3.0], [x]),
        7.0,
    ) / 2.0
    return
end

function test_Scalar_Quadratic_modification()
    f = 7 + 3x + 1x * x + 2y * y + 3x * y
    f = MOI.Utilities.modify_function(f, MOI.ScalarConstantChange(9))
    @test f.constant == 9
    f = MOI.Utilities.modify_function(f, MOI.ScalarCoefficientChange(y, 0))
    @test f.affine_terms == MOI.ScalarAffineTerm.([3], [x])
    g = deepcopy(f)
    @test f ≈ g
    f = MOI.Utilities.modify_function(f, MOI.ScalarCoefficientChange(y, 2))
    @test !(f ≈ g)
    @test g.affine_terms == MOI.ScalarAffineTerm.([3], [x])
    @test f.affine_terms == MOI.ScalarAffineTerm.([3, 2], [x, y])
    return
end

function test_Vector_Variable()
    f = MOI.VectorOfVariables([MOI.VariableIndex(1), MOI.VariableIndex(2)])
    @test real(f) === f
    @test MA.promote_operation(real, typeof(f)) == typeof(f)
    for T in [Int, Int32, Float64]
        z = MOI.Utilities.operate(imag, T, f)
        @test z isa MOI.VectorAffineFunction{T}
        @test isempty(z.terms)
        @test all(iszero, z.constants)
        @test MOI.output_dimension(z) == MOI.output_dimension(f)
        @test MOI.Utilities.promote_operation(imag, T, typeof(f)) == typeof(z)
    end
    @test conj(f) === f
    @test MA.promote_operation(conj, typeof(f)) == typeof(f)
end

function test_Vector_Affine_complex()
    x = MOI.VectorOfVariables([MOI.VariableIndex(1)])
    y = MOI.VectorOfVariables([MOI.VariableIndex(2)])
    r = 3x + 4y
    c = 2x + 5y
    f = (1 + 0im) * r + c * im
    @test real(f) ≈ r
    @test MOI.Utilities.operate(imag, Int, f) ≈ c
    @test imag(f) ≈ c
    @test conj(f) ≈ (1 + 0im) * r - c * im
    @test MA.promote_operation(real, typeof(f)) == typeof(r)
    @test MA.promote_operation(imag, typeof(f)) == typeof(c)
    @test MA.promote_operation(conj, typeof(f)) == typeof(f)
    return
end

function test_Vector_Affine()
    f = MOI.Utilities.canonical(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [2, 1, 2, 1, 1, 2, 2, 2, 2, 1, 1, 2, 1, 2],
                MOI.ScalarAffineTerm.(
                    [3, 2, 3, -3, -1, -2, 3, -2, 1, 3, 5, -2, 0, -1],
                    [x, x, z, y, y, x, y, z, x, y, y, x, x, z],
                ),
            ),
            [5, 7],
        ),
    )
    @test MOI.output_dimension(f) == 2
    @test f.terms == MOI.VectorAffineTerm.(
        [1, 1, 2],
        MOI.ScalarAffineTerm.([2, 4, 3], [x, y, y]),
    )
    @test MOI.Utilities.constant_vector(f) == [5, 7]
    f = MOI.Utilities.modify_function(f, MOI.VectorConstantChange([6, 8]))
    @test MOI.Utilities.constant_vector(f) == [6, 8]
    g = deepcopy(f)
    @test f ≈ g
    f = MOI.Utilities.modify_function(f, MOI.MultirowChange(y, [(2, 9)]))
    @test !(f ≈ g)
    @test f.terms == MOI.VectorAffineTerm.(
        [1, 1, 2],
        MOI.ScalarAffineTerm.([2, 4, 9], [x, y, y]),
    )
    @test g.terms == MOI.VectorAffineTerm.(
        [1, 1, 2],
        MOI.ScalarAffineTerm.([2, 4, 3], [x, y, y]),
    )
    f = MOI.Utilities.modify_function(f, MOI.MultirowChange(y, [(1, 0)]))
    @test f.terms ==
          MOI.VectorAffineTerm.([1, 2], MOI.ScalarAffineTerm.([2, 9], [x, y]))
    return
end

function test_Vector_Quadratic()
    f = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            [1, 1, 2],
            MOI.ScalarQuadraticTerm.([1, 2, 3], [x, y, x], [x, y, y]),
        ),
        MOI.VectorAffineTerm.(
            [1, 2, 2],
            MOI.ScalarAffineTerm.([3, 1, 2], [x, x, y]),
        ),
        [7, 3, 4],
    )
    @test MOI.output_dimension(f) == 3
    f = MOI.Utilities.modify_function(f, MOI.VectorConstantChange([10, 11, 12]))
    @test MOI.Utilities.constant_vector(f) == [10, 11, 12]
    f = MOI.Utilities.modify_function(
        f,
        MOI.MultirowChange(y, [(2, 0), (1, 1)]),
    )
    @test f.affine_terms == MOI.VectorAffineTerm.(
        [1, 2, 1],
        MOI.ScalarAffineTerm.([3, 1, 1], [x, x, y]),
    )
    g = deepcopy(f)
    f = MOI.Utilities.modify_function(
        f,
        MOI.MultirowChange(x, [(1, 0), (3, 4)]),
    )
    @test f.affine_terms == MOI.VectorAffineTerm.(
        [2, 1, 3],
        MOI.ScalarAffineTerm.([1, 1, 4], [x, y, x]),
    )
    @test g.affine_terms == MOI.VectorAffineTerm.(
        [1, 2, 1],
        MOI.ScalarAffineTerm.([3, 1, 1], [x, x, y]),
    )
    return
end

function _isapprox_ordered(
    f1::T,
    f2::T,
) where {T<:Union{MOI.ScalarAffineFunction,MOI.VectorAffineFunction}}
    return (
        (MOI.term_indices.(f1.terms) == MOI.term_indices.(f2.terms)) &&
        (MOI.constant(f1) ≈ MOI.constant(f2)) &&
        (MOI.coefficient.(f1.terms) ≈ MOI.coefficient.(f2.terms))
    )
end

function _isapprox_ordered(
    f1::T,
    f2::T,
) where {T<:Union{MOI.ScalarQuadraticFunction,MOI.VectorQuadraticFunction}}
    return (
        (
            MOI.term_indices.(f1.affine_terms) ==
            MOI.term_indices.(f2.affine_terms)
        ) &&
        (
            MOI.term_indices.(f1.quadratic_terms) ==
            MOI.term_indices.(f2.quadratic_terms)
        ) &&
        (MOI.constant(f1) ≈ MOI.constant(f2)) &&
        (
            MOI.coefficient.(f1.affine_terms) ≈
            MOI.coefficient.(f2.affine_terms)
        ) &&
        (
            MOI.coefficient.(f1.quadratic_terms) ≈
            MOI.coefficient.(f2.quadratic_terms)
        )
    )
end

function _test_canonicalization(
    f::T,
    expected::T,
) where {
    T<:Union{
        MOI.ScalarAffineFunction,
        MOI.VectorAffineFunction,
        MOI.ScalarQuadraticFunction,
        MOI.VectorQuadraticFunction,
    },
}
    @test MOI.Utilities.is_canonical(expected)
    g = @inferred(MOI.Utilities.canonical(f))
    @test _isapprox_ordered(g, expected)
    @test MOI.Utilities.is_canonical(g)
    @test MOI.Utilities.is_canonical(expected)
    @test _isapprox_ordered(MOI.Utilities.canonical(g), g)
    @test MOI.Utilities.canonical(g) !== g
    # There are some changes to sorting in Julia v1.9 that now mean sorting
    # allocates.
    if VERSION < v"1.9.0-DEV"
        @test @allocated(MOI.Utilities.canonicalize!(f)) == 0
    end
    return
end

function test_canonical_ScalarAffine()
    @test MOI.Utilities.is_canonical(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex.(Int[])),
            1.0,
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([0.0], MOI.VariableIndex.([1])),
            1.0,
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.0, 2.0], MOI.VariableIndex.([2, 1])),
            2.0,
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.0, 0.0], MOI.VariableIndex.([1, 2])),
            2.0,
        ),
    )

    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex[]),
            1.5,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex[]),
            1.5,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([0.0], [MOI.VariableIndex(1)]),
            -2.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex[]),
            -2.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([0.0], [MOI.VariableIndex(2)]),
            -2.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex[]),
            -2.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([3.0], [MOI.VariableIndex(2)]),
            1.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([3.0], [MOI.VariableIndex(2)]),
            1.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([3.0, 4.0], MOI.VariableIndex.([2, 1])),
            0.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([4.0, 3.0], MOI.VariableIndex.([1, 2])),
            0.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.0, 0.1], MOI.VariableIndex.([1, 1])),
            5.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.1], MOI.VariableIndex.([1])),
            5.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(
                [1.0, 0.5, 2.0],
                MOI.VariableIndex.([1, 3, 1]),
            ),
            5.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([3.0, 0.5], MOI.VariableIndex.([1, 3])),
            5.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(
                [1.0, 0.5, 2.0],
                MOI.VariableIndex.([1, 3, 1]),
            ),
            5.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([3.0, 0.5], MOI.VariableIndex.([1, 3])),
            5.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(
                [1.0, 2.0, 3.0, 4.0, 5.0],
                MOI.VariableIndex.([1, 3, 1, 3, 2]),
            ),
            5.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(
                [4.0, 5.0, 6.0],
                MOI.VariableIndex.([1, 2, 3]),
            ),
            5.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([1.0, -1.0], MOI.VariableIndex.([7, 7])),
            5.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex.(Int[])),
            5.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(
                [1.0, -1.0, 0.5],
                MOI.VariableIndex.([7, 7, 2]),
            ),
            5.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([0.5], MOI.VariableIndex.([2])),
            5.0,
        ),
    )
    _test_canonicalization(
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(
                [1.0, -0.5, 0.5, -0.5],
                MOI.VariableIndex.([7, 7, 2, 7]),
            ),
            5.0,
        ),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.([0.5], MOI.VariableIndex.([2])),
            5.0,
        ),
    )
    return
end

function test_canonical_VectorAffine()
    @test MOI.Utilities.is_canonical(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                Int[],
                MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex.(Int[])),
            ),
            Float64[],
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1],
                MOI.ScalarAffineTerm.([0.0], MOI.VariableIndex.([1])),
            ),
            [1.0],
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1, 2],
                MOI.ScalarAffineTerm.([0.0, 1.0], MOI.VariableIndex.([1, 2])),
            ),
            [1.0],
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [2, 1],
                MOI.ScalarAffineTerm.([1.0, 1.0], MOI.VariableIndex.([1, 2])),
            ),
            [1.0],
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1, 1],
                MOI.ScalarAffineTerm.([1.0, -1.0], MOI.VariableIndex.([1, 1])),
            ),
            [1.0],
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1, 1],
                MOI.ScalarAffineTerm.([1.0, 1.0], MOI.VariableIndex.([1, 1])),
            ),
            [1.0],
        ),
    )

    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                Int[],
                MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex.(Int[])),
            ),
            Float64[],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                Int[],
                MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex.(Int[])),
            ),
            Float64[],
        ),
    )
    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [3],
                MOI.ScalarAffineTerm.([0.0], MOI.VariableIndex.([5])),
            ),
            [1.0],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                Int[],
                MOI.ScalarAffineTerm.(Float64[], MOI.VariableIndex.(Int[])),
            ),
            [1.0],
        ),
    )
    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [3, 2],
                MOI.ScalarAffineTerm.([1.0, 2.0], MOI.VariableIndex.([5, 6])),
            ),
            [1.0, 2.0, 3.0],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [2, 3],
                MOI.ScalarAffineTerm.([2.0, 1.0], MOI.VariableIndex.([6, 5])),
            ),
            [1.0, 2.0, 3.0],
        ),
    )
    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [3, 3],
                MOI.ScalarAffineTerm.([1.0, 2.0], MOI.VariableIndex.([6, 5])),
            ),
            [1.0, 2.0, 3.0],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [3, 3],
                MOI.ScalarAffineTerm.([2.0, 1.0], MOI.VariableIndex.([5, 6])),
            ),
            [1.0, 2.0, 3.0],
        ),
    )
    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [3, 3],
                MOI.ScalarAffineTerm.([1.0, 2.0], MOI.VariableIndex.([1, 1])),
            ),
            [1.0, 2.0, 3.0],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [3],
                MOI.ScalarAffineTerm.([3.0], MOI.VariableIndex.([1])),
            ),
            [1.0, 2.0, 3.0],
        ),
    )
    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1, 1, 1],
                MOI.ScalarAffineTerm.(
                    [1.0, 2.0, 3.0],
                    MOI.VariableIndex.([1, 2, 1]),
                ),
            ),
            [4.0, 5.0, 6.0],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1, 1],
                MOI.ScalarAffineTerm.([4.0, 2.0], MOI.VariableIndex.([1, 2])),
            ),
            [4.0, 5.0, 6.0],
        ),
    )
    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1, 1, 1],
                MOI.ScalarAffineTerm.(
                    [1.0, 2.0, 3.0],
                    MOI.VariableIndex.([2, 1, 1]),
                ),
            ),
            [4.0, 5.0, 6.0],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1, 1],
                MOI.ScalarAffineTerm.([5.0, 1.0], MOI.VariableIndex.([1, 2])),
            ),
            [4.0, 5.0, 6.0],
        ),
    )
    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [2, 3, 3],
                MOI.ScalarAffineTerm.(
                    [1.0, 2.0, 3.0],
                    MOI.VariableIndex.([1, 1, 1]),
                ),
            ),
            [4.0, 5.0, 6.0],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [2, 3],
                MOI.ScalarAffineTerm.([1.0, 5.0], MOI.VariableIndex.([1, 1])),
            ),
            [4.0, 5.0, 6.0],
        ),
    )
    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [2, 3, 3],
                MOI.ScalarAffineTerm.(
                    [1.0, -3.0, 3.0],
                    MOI.VariableIndex.([1, 1, 1]),
                ),
            ),
            [4.0, 5.0, 6.0],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [2],
                MOI.ScalarAffineTerm.([1.0], MOI.VariableIndex.([1])),
            ),
            [4.0, 5.0, 6.0],
        ),
    )
    _test_canonicalization(
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [2, 3, 3, 3],
                MOI.ScalarAffineTerm.(
                    [1.0, 3.0, -1.0, -2.0],
                    MOI.VariableIndex.([1, 1, 1, 1]),
                ),
            ),
            [4.0, 5.0, 6.0],
        ),
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [2],
                MOI.ScalarAffineTerm.([1.0], MOI.VariableIndex.([1])),
            ),
            [4.0, 5.0, 6.0],
        ),
    )
    return
end

function test_canonical_ScalarQuadratic()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    @test MOI.Utilities.is_canonical(
        convert(MOI.ScalarQuadraticFunction{Float64}, 1.0),
    )
    @test !MOI.Utilities.is_canonical(1.0x * y + 2.0x * x + 2.0)
    @test !MOI.Utilities.is_canonical(1.0x * x + 0.0x * y + 2.0)

    _test_canonicalization(
        convert(MOI.ScalarQuadraticFunction{Float64}, 1.5),
        convert(MOI.ScalarQuadraticFunction{Float64}, 1.5),
    )
    _test_canonicalization(
        0.0x * y - 2.0,
        convert(MOI.ScalarQuadraticFunction{Float64}, -2.0),
    )
    _test_canonicalization(3.0x * y + 4.0x * x + 0.0, 4.0x * x + 3.0x * y + 0.0)
    _test_canonicalization(1.0x * y + 0.1x * y + 5.0, 1.1x * y + 5.0)
    return
end

function test_canonical_VectorQuadratic()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    @test MOI.Utilities.is_canonical(
        MOI.Utilities.operate(
            vcat,
            Float64,
            convert(MOI.ScalarQuadraticFunction{Float64}, 1.0),
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.Utilities.operate(vcat, Float64, 1.0x * y + 2.0x * x + 2.0),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.Utilities.operate(vcat, Float64, 1.0x * x + 0.0x * y + 2.0),
    )

    _test_canonicalization(
        MOI.Utilities.operate(
            vcat,
            Float64,
            1.5,
            0.0x * y - 2.0,
            3.0x * y + 4.0x * x + 0.0,
            1.0x * y + 0.1x * y + 5.0,
        ),
        MOI.Utilities.operate(
            vcat,
            Float64,
            1.5,
            -2.0,
            4.0x * x + 3.0x * y + 0.0,
            1.1x * y + 5.0,
        ),
    )
    return
end

function test_vector_terms()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    at = MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(10.0, x))
    qt = MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(6.0, x, y))
    @test MOI.Utilities.operate_term(*, 3.0, at) ==
          MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(30.0, x))
    @test MOI.Utilities.operate_term(*, at, at) ==
          MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(200.0, x, x))
    @test MOI.Utilities.operate_term(*, 3.0, qt) ==
          MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(18.0, x, y))
    @test MOI.Utilities.operate_term(/, at, 2.0) ==
          MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(5.0, x))
    @test MOI.Utilities.operate_term(/, qt, 3.0) ==
          MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(2.0, x, y))
end

function test_vector_promote()
    T = Float64
    for t1 in [MOI.VectorAffineFunction{T}, MOI.VectorOfVariables, Vector{T}]
        for t2 in [MOI.VectorAffineFunction{T}, MOI.VectorOfVariables]
            @test MOI.Utilities.promote_operation(+, T, t1, t2) ==
                  MOI.VectorAffineFunction{T}
            @test MOI.Utilities.promote_operation(-, T, t1, t2) ==
                  MOI.VectorAffineFunction{T}
        end
    end
    for t1 in [
        MOI.VectorQuadraticFunction{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorOfVariables,
        Vector{T},
    ]
        for t2 in [MOI.VectorQuadraticFunction{T}]
            @test MOI.Utilities.promote_operation(+, T, t1, t2) ==
                  MOI.VectorQuadraticFunction{T}
            @test MOI.Utilities.promote_operation(-, T, t1, t2) ==
                  MOI.VectorQuadraticFunction{T}
        end
    end
    for t in [MOI.VectorOfVariables, MOI.VectorAffineFunction{T}]
        @test MOI.Utilities.promote_operation(-, T, t) ==
              MOI.VectorAffineFunction{T}
    end
    t = MOI.VectorQuadraticFunction{T}
    @test MOI.Utilities.promote_operation(-, T, t) ==
          MOI.VectorQuadraticFunction{T}
end

function test_vector_plus_and_neg()
    w = MOI.VariableIndex(0)
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    α = [1, 2, 3]
    v = MOI.VectorOfVariables([y, w, y])
    g = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.([3, 1], MOI.ScalarAffineTerm.([5, 2], [y, x])),
        [3, 1, 4],
    )
    f = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            [1, 1, 2],
            MOI.ScalarQuadraticTerm.([1, 2, 3], [x, y, x], [x, y, y]),
        ),
        MOI.VectorAffineTerm.(
            [1, 2, 2],
            MOI.ScalarAffineTerm.([3, 1, 2], [x, x, y]),
        ),
        [7, 3, 4],
    )
    v_plus_g = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(
            [3, 1, 1, 2, 3],
            MOI.ScalarAffineTerm.([5, 2, 1, 1, 1], [y, x, y, w, y]),
        ),
        [3, 1, 4],
    )
    g_plus_α = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.([3, 1], MOI.ScalarAffineTerm.([5, 2], [y, x])),
        [4, 3, 7],
    )
    α_minus_v = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(
            [1, 2, 3],
            MOI.ScalarAffineTerm.([-1, -1, -1], [y, w, y]),
        ),
        [1, 2, 3],
    )
    v_minus_v_plus_v = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(
            [1, 2, 3, 1, 2, 3, 1, 2, 3],
            MOI.ScalarAffineTerm.(
                [1, 1, 1, -1, -1, -1, 1, 1, 1],
                [y, w, y, y, w, y, y, w, y],
            ),
        ),
        [0, 0, 0],
    )
    f_plus_α = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            [1, 1, 2],
            MOI.ScalarQuadraticTerm.([1, 2, 3], [x, y, x], [x, y, y]),
        ),
        MOI.VectorAffineTerm.(
            [1, 2, 2],
            MOI.ScalarAffineTerm.([3, 1, 2], [x, x, y]),
        ),
        [8, 5, 7],
    )
    f_minus_g = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            [1, 1, 2],
            MOI.ScalarQuadraticTerm.([1, 2, 3], [x, y, x], [x, y, y]),
        ),
        MOI.VectorAffineTerm.(
            [1, 2, 2, 3, 1],
            MOI.ScalarAffineTerm.([3, 1, 2, -5, -2], [x, x, y, y, x]),
        ),
        [4, 2, 0],
    )
    @test v + g ≈ v_plus_g
    @test g + α ≈ g_plus_α
    @test α + g ≈ g_plus_α
    @test α - v ≈ α_minus_v
    @test MOI.Utilities.operate(
        +,
        Int,
        MOI.Utilities.operate(-, Int, v, v),
        v,
    ) ≈ v_minus_v_plus_v
    @test f + α ≈ f_plus_α
    @test f - g ≈ f_minus_g
    @test f - f + f - g ≈ f_minus_g
    @test v + f + α - v ≈ f_plus_α
    @test v - f - α - v ≈ -f_plus_α
    @test MOI.Utilities.operate!(-, Int, v, f) - v ≈ -f
    @test (g + v + g + v + f) - (v + g + v + g) ≈ f
    @test v - α ≈ -α_minus_v
    @test g - f ≈ -f_minus_g
    return
end

function test_vector_mult_and_div()
    w = MOI.VariableIndex(0)
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    v = MOI.VectorOfVariables([y, w, y])
    v2 = MOI.Utilities.operate(vcat, Float64, 2.0y, 2.0w, 2.0y)
    f = MOI.Utilities.operate(
        vcat,
        Float64,
        2.0x + 3.0y + 1.0,
        3.0x + 2.0y + 3.0,
    )
    f2 = MOI.Utilities.operate(
        vcat,
        Float64,
        4.0x + 6.0y + 2.0,
        6.0x + 4.0y + 6.0,
    )
    g = MOI.Utilities.operate(
        vcat,
        Float64,
        7.0x * y + 2.0x + 3.0y + 1.0,
        6.0x * x + 5.0y * y + 3.0x + 2.0y + 3.0,
    )
    g2 = MOI.Utilities.operate(
        vcat,
        Float64,
        14.0x * y + 4.0x + 6.0y + 2.0,
        12.0x * x + 10.0y * y + 6.0x + 4.0y + 6.0,
    )
    for (a, a2) in [(v, v2), (f, f2), (g, g2)]
        @test a * 2.0 ≈ a2
        @test 2.0 * a ≈ a2
        @test a / 0.5 ≈ a2
    end
    return
end

function test_modifycoefficient_duplicates()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction(
        [MOI.ScalarAffineTerm(1.0, x), MOI.ScalarAffineTerm(1.0, x)],
        0.0,
    )
    new_f =
        MOI.Utilities.modify_function(f, MOI.ScalarCoefficientChange(x, 3.0))
    @test new_f ≈ MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(3.0, x)], 0.0)
    return
end

function test_modifycoefficients_duplicates()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x)),
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(1.0, x)),
            MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(1.0, x)),
        ],
        [0.0, 0.0, 0.0],
    )
    new_f = MOI.Utilities.modify_function(
        f,
        MOI.MultirowChange(x, [(1, 3.0), (2, 0.5)]),
    )
    @test new_f ≈ MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(3.0, x)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(0.5, x)),
            MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(1.0, x)),
        ],
        [0.0, 0.0, 0.0],
    )
    return
end

function test_zero_with_output_dimension()
    f = MOI.Utilities.zero_with_output_dimension(Vector{Int}, 2)
    @test f == [0, 0]
    @test f isa Vector{Int}

    g = MOI.Utilities.zero_with_output_dimension(Vector{Float64}, 2)
    @test g == [0.0, 0.0]
    @test g isa Vector{Float64}

    h = MOI.Utilities.zero_with_output_dimension(
        MOI.VectorAffineFunction{Int},
        2,
    )
    @test MOI.output_dimension(h) == 2
    @test isapprox(
        h,
        MOI.VectorAffineFunction{Int}(MOI.VectorAffineTerm{Int}[], [0, 0]),
    )
    @test h isa MOI.VectorAffineFunction{Int}

    i = MOI.Utilities.zero_with_output_dimension(
        MOI.VectorQuadraticFunction{Int},
        2,
    )
    @test MOI.output_dimension(i) == 2
    @test isapprox(
        i,
        MOI.VectorQuadraticFunction{Int}(
            MOI.VectorQuadraticTerm{Int}[],
            MOI.VectorAffineTerm{Int}[],
            [0, 0],
        ),
    )
    @test i isa MOI.VectorQuadraticFunction{Int}
    return
end

"""
    test_SingleVariable_operators()

Test the three Base.:(op) fallbacks for pure SingleVariable operations.
"""
function test_SingleVariable_operators()
    x = MOI.VariableIndex(1)
    @test_throws ErrorException x + x
    @test_throws ErrorException x - x
    @test_throws ErrorException x * x
    return
end

function test_value_type()
    T = Float64
    @test MOI.Utilities.value_type(T, MOI.VariableIndex) == T
    @test MOI.Utilities.value_type(T, MOI.VectorOfVariables) == Vector{T}
    @test MOI.Utilities.value_type(T, MOI.ScalarAffineFunction{Int}) == T
    @test MOI.Utilities.value_type(T, MOI.ScalarAffineFunction{T}) == T
    @test MOI.Utilities.value_type(T, MOI.ScalarAffineFunction{Complex{Int}}) ==
          Complex{T}
    @test MOI.Utilities.value_type(T, MOI.ScalarAffineFunction{Complex{T}}) ==
          Complex{T}
    @test MOI.Utilities.value_type(T, MOI.ScalarQuadraticFunction{Int}) == T
    @test MOI.Utilities.value_type(T, MOI.ScalarQuadraticFunction{T}) == T
    @test MOI.Utilities.value_type(
        T,
        MOI.ScalarQuadraticFunction{Complex{Int}},
    ) == Complex{T}
    @test MOI.Utilities.value_type(T, MOI.ScalarNonlinearFunction) == T
    @test MOI.Utilities.value_type(
        T,
        MOI.ScalarQuadraticFunction{Complex{T}},
    ) == Complex{T}
    @test MOI.Utilities.value_type(T, MOI.VectorAffineFunction{Int}) ==
          Vector{T}
    @test MOI.Utilities.value_type(T, MOI.VectorAffineFunction{T}) == Vector{T}
    @test MOI.Utilities.value_type(T, MOI.VectorAffineFunction{Complex{Int}}) ==
          Vector{Complex{T}}
    @test MOI.Utilities.value_type(T, MOI.VectorAffineFunction{Complex{T}}) ==
          Vector{Complex{T}}
    @test MOI.Utilities.value_type(T, MOI.VectorQuadraticFunction{Int}) ==
          Vector{T}
    @test MOI.Utilities.value_type(T, MOI.VectorQuadraticFunction{T}) ==
          Vector{T}
    @test MOI.Utilities.value_type(
        T,
        MOI.VectorQuadraticFunction{Complex{Int}},
    ) == Vector{Complex{T}}
    @test MOI.Utilities.value_type(
        T,
        MOI.VectorQuadraticFunction{Complex{T}},
    ) == Vector{Complex{T}}
    return
end

function test_filter_variables_scalarnonlinearfunction()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f = MOI.ScalarNonlinearFunction(:+, Any[x, 2, y])
    new_f = MOI.Utilities.filter_variables(xi -> xi != x, f)
    @test new_f ≈ MOI.ScalarNonlinearFunction(:+, Any[2, y])
    f = MOI.ScalarNonlinearFunction(:-, Any[x, 2, y])
    new_f = MOI.Utilities.filter_variables(xi -> xi != x, f)
    @test new_f ≈ MOI.ScalarNonlinearFunction(:-, Any[0, 2, y])
    f = MOI.ScalarNonlinearFunction(:-, Any[2, x, y])
    new_f = MOI.Utilities.filter_variables(xi -> xi != x, f)
    @test new_f ≈ MOI.ScalarNonlinearFunction(:-, Any[2, y])
    f = MOI.ScalarNonlinearFunction(:-, Any[2, x])
    new_f = MOI.Utilities.filter_variables(xi -> xi != x, f)
    @test new_f ≈ 2
    f = MOI.ScalarNonlinearFunction(:+, Any[x, 2, y])
    f2 = MOI.ScalarNonlinearFunction(:+, Any[2, y])
    g = MOI.ScalarNonlinearFunction(:-, Any[f, x, 2])
    new_g = MOI.Utilities.filter_variables(xi -> xi != x, g)
    @test new_g ≈ MOI.ScalarNonlinearFunction(:-, Any[f2, 2])
    return
end

function test_filter_variables_vectornonlinearfunction()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f = MOI.ScalarNonlinearFunction(:+, Any[x, 2, y])
    g = MOI.ScalarNonlinearFunction(:-, Any[x, 2, y])
    fg = MOI.VectorNonlinearFunction([f, g])
    new_f = MOI.ScalarNonlinearFunction(:+, Any[2, y])
    new_g = MOI.ScalarNonlinearFunction(:-, Any[0, 2, y])
    new_fg = MOI.VectorNonlinearFunction([new_f, new_g])
    @test new_fg ≈ MOI.Utilities.filter_variables(xi -> xi != x, fg)
    return
end

function test_ScalarNonlinearFunction_count_map_indices_and_print()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Bool}(),
        MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Bool}()),
    )
    MOI.Utilities.attach_optimizer(model)
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:!, Any[x])
    g = MOI.ScalarNonlinearFunction(:count, Any[Any[x, f]])
    @test sprint(io -> show(io, MIME("text/plain"), g)) ==
          "count([MOI.VariableIndex(1), !(MOI.VariableIndex(1))])"
    c = MOI.add_constraint(model, g, MOI.EqualTo(true))
    @test MOI.get(model, MOI.ConstraintFunction(), c) ≈ g
    return
end

function test_ScalarNonlinearFunction_map_indices()
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(src)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    c = MOI.add_constraint(src, f, MOI.LessThan(1.0))
    dest = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    index_map = MOI.copy_to(dest, src)
    new_f = MOI.Utilities.map_indices(index_map, f)
    @test new_f ≈ MOI.ScalarNonlinearFunction(:log, Any[index_map[x]])
    return
end

function test_ScalarNonlinearFunction_map_indices_nested()
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(src, 5)
    f = MOI.ScalarNonlinearFunction(
        :+,
        Any[
            x[1],
            MOI.ScalarNonlinearFunction(
                :+,
                Any[MOI.ScalarNonlinearFunction(:+, Any[x[2], x[3]]), x[4]],
            ),
            x[5],
        ],
    )
    c = MOI.add_constraint(src, f, MOI.LessThan(1.0))
    dest = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    index_map = MOI.copy_to(dest, src)
    new_f = MOI.Utilities.map_indices(index_map, f)
    y = [index_map[xi] for xi in x]
    @test new_f ≈ MOI.ScalarNonlinearFunction(
        :+,
        Any[
            y[1],
            MOI.ScalarNonlinearFunction(
                :+,
                Any[MOI.ScalarNonlinearFunction(:+, Any[y[2], y[3]]), y[4]],
            ),
            y[5],
        ],
    )
    return
end

function test_ScalarNonlinearFunction_map_indices_deep_recursion()
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(src)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    for _ in 1:50_000
        f = MOI.ScalarNonlinearFunction(:log, Any[f])
    end
    c = MOI.add_constraint(src, f, MOI.LessThan(1.0))
    dest = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    index_map = MOI.copy_to(dest, src)
    new_f = MOI.Utilities.map_indices(index_map, f)
    g = new_f
    for _ in 1:50_000
        g = g.args[1]
    end
    @test g ≈ MOI.ScalarNonlinearFunction(:log, Any[index_map[x]])
    return
end

function test_ScalarNonlinearFunction_substitute_variables()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:log, Any[1.0*x])
    new_f = MOI.Utilities.substitute_variables(x -> -2.0 * x, f)
    @test new_f ≈ MOI.ScalarNonlinearFunction(:log, Any[-2.0*x])
    return
end

function test_ScalarNonlinearFunction_is_canonical()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:log, Any[1.0*x])
    @test MOI.Utilities.is_canonical(f)
    g = MOI.ScalarNonlinearFunction(:log, Any[1.0*x+1.0*x])
    @test !MOI.Utilities.is_canonical(g)
    MOI.Utilities.canonicalize!(g)
    @test MOI.Utilities.is_canonical(g)
    @test g.args[1] ≈ 2.0 * x
    f = MOI.ScalarNonlinearFunction(:^, Any[x, 2])
    @test MOI.Utilities.is_canonical(f)
    # Test deep recursion
    for _ in 1:100_000
        f = MOI.ScalarNonlinearFunction(:sin, Any[f])
    end
    @test MOI.Utilities.is_canonical(f)
    return
end

function test_vector_type()
    for T in (Int, Float64)
        @test MOI.Utilities.vector_type(T) == Vector{T}
        @test MOI.Utilities.vector_type(MOI.VariableIndex) ==
              MOI.VectorOfVariables
        @test MOI.Utilities.vector_type(MOI.ScalarAffineFunction{T}) ==
              MOI.VectorAffineFunction{T}
        @test MOI.Utilities.vector_type(MOI.ScalarQuadraticFunction{T}) ==
              MOI.VectorQuadraticFunction{T}
    end
    return
end

function _test_base_op_scalar(op)
    x = MOI.VariableIndex(1)
    F = (
        1,
        x,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(2, x)], 3),
        MOI.ScalarQuadraticFunction(
            [MOI.ScalarQuadraticTerm(2, x, x)],
            [MOI.ScalarAffineTerm(2, x)],
            3,
        ),
    )
    for f in F, g in F
        if f == g == x
            @test_throws ErrorException op(f, g)
            continue
        end
        @test op(f, g) ≈ MOI.Utilities.operate(op, Int, f, g)
        if op === +
            for h in F
                @test op(f, g, h) ≈ MOI.Utilities.operate(op, Int, f, g, h)
            end
        end
    end
    return
end

function _test_base_op_vector(op)
    x = MOI.VariableIndex(1)
    F = (
        [1],
        MOI.VectorOfVariables([x]),
        MOI.VectorAffineFunction(
            [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2, x))],
            [3],
        ),
        MOI.VectorQuadraticFunction(
            [MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(2, x, x))],
            [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2, x))],
            [3],
        ),
    )
    for f in F, g in F
        if f == g == MOI.VectorOfVariables([x])
            @test_throws ErrorException op(f, g)
            continue
        end
        @test op(f, g) ≈ MOI.Utilities.operate(op, Int, f, g)
        if op === +
            for h in F
                @test op(f, g, h) ≈ MOI.Utilities.operate(op, Int, f, g, h)
            end
        end
    end
    return
end

test_base_plus_scalar() = _test_base_op_scalar(+)

test_base_minus_scalar() = _test_base_op_scalar(-)

test_base_plus_vector() = _test_base_op_vector(+)

test_base_minus_vector() = _test_base_op_vector(-)

function test_base_divide()
    x = MOI.VariableIndex(1)
    F = (
        x,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(2.0, x)], 3.0),
        MOI.ScalarQuadraticFunction(
            [MOI.ScalarQuadraticTerm(2.0, x, x)],
            [MOI.ScalarAffineTerm(2.0, x)],
            3.0,
        ),
        MOI.VectorOfVariables([x]),
        MOI.VectorAffineFunction(
            [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2.0, x))],
            [3.0],
        ),
        MOI.VectorQuadraticFunction(
            [MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(2.0, x, x))],
            [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2.0, x))],
            [3.0],
        ),
    )
    for f in F
        @test f / 2.0 ≈ MOI.Utilities.operate(/, Float64, f, 2.0)
    end
    return
end

function test_deprecated_constant_vector()
    x = MOI.VariableIndex(1)
    f, g = 1.0 * x + 2.0, 1.0 * x * x + 2.0
    @test MOI.Utilities.constant_vector(f) == [2.0]
    @test MOI.Utilities.constant_vector(g) == [2.0]
    @test MOI.Utilities.constant_vector(MOI.Utilities.vectorize([f])) == [2.0]
    @test MOI.Utilities.constant_vector(MOI.Utilities.vectorize([g])) == [2.0]
    return
end

function test_deprecated_eval_term()
    x = MOI.VariableIndex(1)
    term = MOI.ScalarAffineTerm(2.0, x)
    @test MOI.Utilities.eval_term(x -> 1.4, term) ≈ 2.0 * 1.4
    return
end

function test_VectorAffineFunction_row_constructor()
    x = MOI.VariableIndex(1)
    f = MOI.VectorAffineFunction([1.0 * x + 2.0, 3.0 * x + 4.0])
    g = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm{Float64}[
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(3.0, x)),
        ],
        [2.0, 4.0],
    )
    @test f ≈ g
    return
end

function test_VectorQuadraticFunction_row_constructor()
    x, y = MOI.VariableIndex.(1:2)
    row1 = 1.0 * x * x + 1.0 * y * y + 2.0 * x + 3.0 * y + 4.2
    row2 = 3.0 * x * x + 3.0 * y * y + 1.0 * x + 3.0 * y + 1.2
    f = MOI.VectorQuadraticFunction([row1, row2])
    @test f ≈ MOI.Utilities.vectorize([row1, row2])
    @test f ≈ MOI.VectorQuadraticFunction(
        [
            MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(2.0, x, x)),
            MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(2.0, y, y)),
            MOI.VectorQuadraticTerm(2, MOI.ScalarQuadraticTerm(6.0, x, x)),
            MOI.VectorQuadraticTerm(2, MOI.ScalarQuadraticTerm(6.0, y, y)),
        ],
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2.0, x)),
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(3.0, y)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(1.0, x)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(3.0, y)),
        ],
        [4.2, 1.2],
    )
    return
end

function test_cannonicalize_Variable()
    x = MOI.VariableIndex.(1:2)
    f = MOI.VectorOfVariables(x)
    @test MOI.Utilities.canonicalize!(x[1]) === x[1]
    @test MOI.Utilities.canonicalize!(f) === f
    return
end

function test_filter_variables_variable_index()
    f = MOI.VariableIndex(1)
    @test MOI.Utilities.filter_variables(x -> x.value == 1, f) === f
    @test_throws(
        ErrorException(
            "Cannot remove variable from a `VariableIndex` function of the " *
            "same variable.",
        ),
        MOI.Utilities.filter_variables(x -> x.value == 0, f),
    )
    return
end

function test_filter_variables_vector_of_variables()
    f = MOI.VectorOfVariables(MOI.VariableIndex.(1:2))
    s = MOI.Zeros(2)
    g, new_s = MOI.Utilities.filter_variables(x -> x.value != 1, f, s)
    @test g == MOI.VectorOfVariables([MOI.VariableIndex(2)])
    @test new_s == MOI.Zeros(1)
    return
end

function test_mult_bool()
    f = 1.0 * MOI.VariableIndex(1) + 2.0
    @test *(f, false) ≈ zero(MOI.ScalarAffineFunction{Float64})
    return
end

function test_is_complex()
    @test !MOI.Utilities.is_complex(MOI.ScalarAffineFunction{Float64})
    @test !MOI.Utilities.is_complex(MOI.ScalarQuadraticFunction{Float64})
    @test !MOI.Utilities.is_complex(MOI.VectorAffineFunction{Float64})
    @test !MOI.Utilities.is_complex(MOI.VectorQuadraticFunction{Float64})
    @test MOI.Utilities.is_complex(MOI.ScalarAffineFunction{ComplexF64})
    @test MOI.Utilities.is_complex(MOI.ScalarQuadraticFunction{ComplexF64})
    @test MOI.Utilities.is_complex(MOI.VectorAffineFunction{ComplexF64})
    @test MOI.Utilities.is_complex(MOI.VectorQuadraticFunction{ComplexF64})
    return
end

function test_ndims()
    x = MOI.VariableIndex(1)
    @test ndims(1.0 * x) == 0
    @test ndims(MOI.ScalarAffineFunction{Float64}) == 0
    return
end

end  # module

TestUtilitiesFunctions.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestOperate

using Test

import LinearAlgebra
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

# f(x) = a + bx + cx^2
function _test_function(coefficients::NTuple{3,T}) where {T}
    a, b, c = coefficients
    x = MOI.VariableIndex(1)
    if !iszero(c)
        return MOI.ScalarQuadraticFunction(
            [MOI.ScalarQuadraticTerm(c, x, x)],
            [MOI.ScalarAffineTerm(b, x)],
            a,
        )
    end
    if !iszero(b)
        return MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(b, x)], a)
    end
    if !iszero(a)
        return a
    end
    return x
end

function _test_function(coefficients::Vector{NTuple{3,T}}) where {T}
    return MOI.Utilities.operate(vcat, T, _test_function.(coefficients)...)
end

function _test_function(pair::Pair{Symbol,<:Any})
    head, arg = pair
    if arg isa Vector
        args = Any[_test_function(a) for a in arg]
        return MOI.ScalarNonlinearFunction(head, args)
    else
        return MOI.ScalarNonlinearFunction(head, Any[_test_function(arg)])
    end
end

function _test_function(pairs::Vector{<:Any})
    return MOI.VectorNonlinearFunction(Any[_test_function(f) for f in pairs])
end

function test_operate_1a()
    for coef in (
        (0, 0, 0),
        (1, 0, 0),
        (0, 1, 0),
        (0, 0, 1),
        (1, 1, 1),
        :log => (0, 0, 0),
        [(0, 0, 0)],
        [(1, 0, 0)],
        [(0, 1, 0)],
        [(0, 0, 1)],
        [(1, 1, 1)],
        [:log => (0, 0, 0)],
    )
        f = _test_function(coef)
        @test MOI.Utilities.operate(+, Int, f) == f
        @test MOI.Utilities.operate!(+, Int, f) == f
    end
    return
end

function test_operate_1b()
    F = (
        (0, 0, 0),
        (1, 0, 0),
        (0, 1, 0),
        (0, 0, 1),
        (1, 1, 1),
        :log => (0, 0, 0),
        [(0, 0, 0)],
        [(1, 0, 0)],
        [(0, 1, 0)],
        [(0, 0, 1)],
        [(1, 1, 1)],
        [:log => (0, 0, 0)],
    )
    special_cases = Dict((0, 0, 0) => (0, 1, 0))
    for i in 1:6, j in 1:6
        fi, fj = _test_function(F[i]), _test_function(F[j])
        Fi = get(special_cases, F[i], F[i])
        Fj = get(special_cases, F[j], F[j])
        if i == 6 || j == 6
            fk = MOI.ScalarNonlinearFunction(:+, Any[fi, fj])
        else
            fk = _test_function(Fi .+ Fj)
        end
        @test MOI.Utilities.operate(+, Int, fi, fj) ≈ fk
        @test MOI.Utilities.operate!(+, Int, fi, fj) ≈ fk
    end
    for i in 7:12, j in 7:12
        fi, fj = _test_function(F[i]), _test_function(F[j])
        if i == 12 || j == 12
            args = Any[]
            for (fi_, fj_) in zip(F[i], F[j])
                push!(
                    args,
                    MOI.Utilities.operate(
                        +,
                        Int,
                        _test_function(fi_),
                        _test_function(fj_),
                    ),
                )
            end
            fk = MOI.VectorNonlinearFunction(args)
        else
            k = map(zip(F[i], F[j])) do (x, y)
                return get(special_cases, x, x) .+ get(special_cases, y, y)
            end
            fk = _test_function(k)
        end
        @test MOI.Utilities.operate(+, Int, fi, fj) ≈ fk
        @test MOI.Utilities.operate!(+, Int, fi, fj) ≈ fk
    end
    return
end

function test_operate_1b_scalarnonlinearfunction_specialcase()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:+, Any[x])
    g = MOI.Utilities.operate!(+, Float64, f, x)
    @test g === f
    @test g ≈ MOI.ScalarNonlinearFunction(:+, Any[x, x])
    return
end

function test_operate_1c()
    for coef in (
        (0, 0, 0),
        (1, 0, 0),
        (0, 1, 0),
        (0, 0, 1),
        (1, 1, 1),
        [(0, 0, 0)],
        [(1, 0, 0)],
        [(0, 1, 0)],
        [(0, 0, 1)],
        [(1, 1, 1)],
    )
        f = _test_function(coef)
        @test MOI.Utilities.operate(+, Int, f, f, f) ≈
              MOI.Utilities.operate(*, Int, f, 3)
        g = _test_function(coef)
        @test MOI.Utilities.operate!(+, Int, g, f, f) ≈
              MOI.Utilities.operate(*, Int, f, 3)
    end
    return
end

function test_operate_1c_many_arguments()
    x = [i + i * MOI.VariableIndex(i) for i in 1:1_000]
    y = MOI.Utilities.operate(+, Int, x...)
    f = MOI.ScalarAffineFunction(
        [MOI.ScalarAffineTerm(i, MOI.VariableIndex(i)) for i in 1:1_000],
        sum(i for i in 1:1_000),
    )
    @test ≈(y, f)
    z = zero(MOI.ScalarAffineFunction{Int})
    z = MOI.Utilities.operate!(+, Int, z, x...)
    @test ≈(z, f)
    return
end

function test_operate_2a()
    T = Int
    for (f, g) in (
        (0, 0, 0) => (0, -1, 0),
        (1, 0, 0) => (-1, 0, 0),
        (0, 1, 0) => (0, -1, 0),
        (0, 0, 1) => (0, 0, -1),
        (1, 1, 1) => (-1, -1, -1),
        (:log => (0, 0, 0)) => (:- => (:log => (0, 0, 0))),
        [(0, 0, 0)] => [(0, -1, 0)],
        [(1, 0, 0)] => [(-1, 0, 0)],
        [(0, 1, 0)] => [(0, -1, 0)],
        [(0, 0, 1)] => [(0, 0, -1)],
        [(1, 1, 1)] => [(-1, -1, -1)],
        [(:log => (0, 0, 0))] => [(:- => (:log => (0, 0, 0)))],
    )
        @test MOI.Utilities.operate(-, T, _test_function(f)) ≈ _test_function(g)
        @test MOI.Utilities.operate!(-, T, _test_function(f)) ≈
              _test_function(g)
    end
    return
end

function test_operate_2a_scalarnonlinearfunction_specialcase()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    g = MOI.ScalarNonlinearFunction(:-, Any[f])
    h = MOI.Utilities.operate!(-, Float64, g)
    @test h === f
    @test h ≈ MOI.ScalarNonlinearFunction(:log, Any[x])
    return
end

function test_operate_2b()
    F = (
        (0, 0, 0),
        (1, 0, 0),
        (0, 1, 0),
        (0, 0, 1),
        (1, 1, 1),
        :log => (0, 0, 0),
        [(0, 0, 0)],
        [(1, 0, 0)],
        [(0, 1, 0)],
        [(0, 0, 1)],
        [(1, 1, 1)],
        [:log => (0, 0, 0)],
    )
    special_cases = Dict((0, 0, 0) => (0, 1, 0))
    for i in 1:6, j in 1:6
        if i == 6 || j == 6
            fi = _test_function(F[i])
            fj = _test_function(F[j])
            fk = MOI.ScalarNonlinearFunction(:-, Any[fi, fj])
        else
            fi = _test_function(2 .* F[i])
            fj = _test_function(F[j])
            Fi = get(special_cases, 2 .* F[i], 2 .* F[i])
            Fj = get(special_cases, F[j], F[j])
            Fk = Fi .- Fj
            fk = _test_function(get(special_cases, Fk, Fk))
            if (i, j) in ((1, 1), (1, 3))
                fk = zero(MOI.ScalarAffineFunction{Int})
            end
        end
        @test MOI.Utilities.operate(-, Int, fi, fj) ≈ fk
        @test MOI.Utilities.operate!(-, Int, fi, fj) ≈ fk
    end
    for i in 7:12, j in 7:12
        fi, fj = _test_function(F[i]), _test_function(F[j])
        if i == 12 || j == 12
            args = Any[]
            for (fi_, fj_) in zip(F[i], F[j])
                push!(
                    args,
                    MOI.Utilities.operate(
                        -,
                        Int,
                        _test_function(fi_),
                        _test_function(fj_),
                    ),
                )
            end
            fk = MOI.VectorNonlinearFunction(args)
        else
            F2 = [2 .* fi for fi in F[i]]
            fi, fj = _test_function(F2), _test_function(F[j])
            k = map(zip(F2, F[j])) do (x, y)
                return get(special_cases, x, x) .- get(special_cases, y, y)
            end
            fk = _test_function(k)
            if (i, j) in ((7, 7), (7, 9))
                fk = MOI.VectorAffineFunction(MOI.VectorAffineTerm{Int}[], [0])
            end
        end
        @test MOI.Utilities.operate(-, Int, fi, fj) ≈ fk
        @test MOI.Utilities.operate!(-, Int, fi, fj) ≈ fk
    end
    return
end

function test_operate_3a()
    T = Int
    for (f, g) in (
        (0, 0, 0) => (0, 3, 0),
        (1, 0, 0) => (3, 0, 0),
        (0, 1, 0) => (0, 3, 0),
        (0, 0, 1) => (0, 0, 3),
        (1, 1, 1) => (3, 3, 3),
        (:log => (0, 0, 0)) => (:* => [(3, 0, 0), (:log => (0, 0, 0))]),
        [(0, 0, 0)] => [(0, 3, 0)],
        [(1, 0, 0)] => [(3, 0, 0)],
        [(0, 1, 0)] => [(0, 3, 0)],
        [(0, 0, 1)] => [(0, 0, 3)],
        [(1, 1, 1)] => [(3, 3, 3)],
        [(:log => (0, 0, 0))] => [(:* => [(3, 0, 0), (:log => (0, 0, 0))])],
    )
        f = _test_function(f)
        @test MOI.Utilities.operate(*, T, 3, f) ≈ _test_function(g)
        @test MOI.Utilities.operate!(*, T, 3, f) ≈ _test_function(g)
    end
    return
end

function test_operate_3b()
    T = Int
    for (f, g) in (
        (0, 0, 0) => (0, 3, 0),
        (1, 0, 0) => (3, 0, 0),
        (0, 1, 0) => (0, 3, 0),
        (0, 0, 1) => (0, 0, 3),
        (1, 1, 1) => (3, 3, 3),
        (:log => (0, 0, 0)) => (:* => [(:log => (0, 0, 0)), (3, 0, 0)]),
        [(0, 0, 0)] => [(0, 3, 0)],
        [(1, 0, 0)] => [(3, 0, 0)],
        [(0, 1, 0)] => [(0, 3, 0)],
        [(0, 0, 1)] => [(0, 0, 3)],
        [(1, 1, 1)] => [(3, 3, 3)],
        [(:log => (0, 0, 0))] => [(:* => [(:log => (0, 0, 0)), (3, 0, 0)])],
    )
        f = _test_function(f)
        @test MOI.Utilities.operate(*, T, f, 3) ≈ _test_function(g)
        @test MOI.Utilities.operate!(*, T, f, 3) ≈ _test_function(g)
    end
    return
end

function test_operate_3b_scalarnonlinearfunction_specialcase()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:*, Any[x])
    g = MOI.Utilities.operate!(*, Float64, f, 3.0)
    @test g === f
    @test g ≈ MOI.ScalarNonlinearFunction(:*, Any[x, 3.0])
    return
end

function test_operate_3c()
    x = MOI.VariableIndex(1)
    f = 1.0 * x + 2.0
    g = MOI.Utilities.operate(*, Float64, f, x)
    @test g ≈ 1.0 * x * x + 2.0 * x
    return
end

function test_operate_4a()
    T = Float64
    for (f, g) in (
        (0.0, 0.0, 0.0) => (0.0, 0.5, 0.0),
        (1.0, 0.0, 0.0) => (0.5, 0.0, 0.0),
        (0.0, 1.0, 0.0) => (0.0, 0.5, 0.0),
        (0.0, 0.0, 1.0) => (0.0, 0.0, 0.5),
        (1.0, 1.0, 1.0) => (0.5, 0.5, 0.5),
        (:log => (0, 0, 0)) => (:/ => [(:log => (0, 0, 0)), (2.0, 0.0, 0.0)]),
        [(0.0, 0.0, 0.0)] => [(0.0, 0.5, 0.0)],
        [(1.0, 0.0, 0.0)] => [(0.5, 0.0, 0.0)],
        [(0.0, 1.0, 0.0)] => [(0.0, 0.5, 0.0)],
        [(0.0, 0.0, 1.0)] => [(0.0, 0.0, 0.5)],
        [(1.0, 1.0, 1.0)] => [(0.5, 0.5, 0.5)],
        [(:log => (0, 0, 0))] =>
            [(:/ => [(:log => (0, 0, 0)), (2.0, 0.0, 0.0)])],
    )
        f = _test_function(f)
        @test MOI.Utilities.operate(/, T, f, 2.0) ≈ _test_function(g)
        @test MOI.Utilities.operate!(/, T, f, 2.0) ≈ _test_function(g)
    end
    return
end

function test_operate_5a()
    T = Float64
    F = (
        (0.0, 0.0, 0.0),
        (1.0, 0.0, 0.0),
        (0.0, 1.0, 0.0),
        (0.0, 0.0, 1.0),
        (1.0, 1.0, 1.0),
        (:log => (0, 0, 0)),
        [(0.0, 0.0, 0.0)],
        [(1.0, 0.0, 0.0)],
        [(0.0, 1.0, 0.0)],
        [(0.0, 0.0, 1.0)],
        [(1.0, 1.0, 1.0)],
        [:log => (0, 0, 0)],
    )
    for f in F, g in F
        h = vcat(f, g)
        args = (_test_function(f), _test_function(g))
        @test MOI.Utilities.operate(vcat, T, args...) ≈ _test_function(h)
        args = (_test_function(f), _test_function(g))
        @test MOI.Utilities.operate!(vcat, T, args...) ≈ _test_function(h)
    end
    @test MOI.Utilities.operate(vcat, T) == T[]
    return
end

function test_operate_5a_VectorNonlinearFunction()
    x = MOI.ScalarNonlinearFunction(:+, Any[])
    f = MOI.VectorNonlinearFunction([x])
    g = MOI.Utilities.operate(vcat, Float64, f, f, x)
    rows = [MOI.ScalarNonlinearFunction(:+, Any[]) for _ in 1:3]
    h = MOI.VectorNonlinearFunction(rows)
    @test g ≈ h
    push!(x.args, 0.0)
    @test g ≈ h
    @test g.rows[1] !== g.rows[2]
    @test g.rows[1] !== g.rows[3]
    @test g.rows[2] !== g.rows[3]
    rows = [MOI.ScalarNonlinearFunction(:+, Any[0.0])]
    f_new = MOI.VectorNonlinearFunction(rows)
    @test f ≈ f_new
    return
end

function test_operate_6a()
    T = Float64
    @test MOI.Utilities.operate(imag, T, _test_function((0.0, 0.0, 0.0))) ≈
          zero(MOI.ScalarAffineFunction{T})
    @test MOI.Utilities.operate(imag, T, _test_function([(0.0, 0.0, 0.0)])) ≈
          MOI.VectorAffineFunction(MOI.VectorAffineTerm{T}[], [0.0])
    @test MOI.Utilities.operate!(imag, T, _test_function((0.0, 0.0, 0.0))) ≈
          zero(MOI.ScalarAffineFunction{T})
    @test MOI.Utilities.operate!(imag, T, _test_function([(0.0, 0.0, 0.0)])) ≈
          MOI.VectorAffineFunction(MOI.VectorAffineTerm{T}[], [0.0])
    return
end

function test_operate_term_1a()
    x = MOI.VariableIndex(1)
    for f in (
        MOI.ScalarAffineTerm(1.0, x),
        MOI.ScalarQuadraticTerm(1.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(1.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(1.0, x, x)),
    )
        @test MOI.Utilities.operate_term(+, f) == f
    end
    return
end

function test_operate_term_2a()
    x = MOI.VariableIndex(1)
    for (f, g) in (
        MOI.ScalarAffineTerm(1.0, x) => MOI.ScalarAffineTerm(-1.0, x),
        MOI.ScalarQuadraticTerm(1.0, x, x) =>
            MOI.ScalarQuadraticTerm(-1.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(1.0, x)) =>
            MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(-1.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(1.0, x, x)) =>
            MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(-1.0, x, x)),
    )
        @test MOI.Utilities.operate_term(-, f) == g
    end
    return
end

function test_operate_term_3a()
    x = MOI.VariableIndex(1)
    for (f, g) in (
        MOI.ScalarAffineTerm(2.0, x) => MOI.ScalarAffineTerm(-4.0, x),
        MOI.ScalarQuadraticTerm(2.0, x, x) =>
            MOI.ScalarQuadraticTerm(-4.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(2.0, x)) =>
            MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(-4.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(2.0, x, x)) =>
            MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(-4.0, x, x)),
    )
        @test MOI.Utilities.operate_term(*, -2.0, f) == g
    end
    return
end

function test_operate_term_3b()
    x = MOI.VariableIndex(1)
    for (f, g) in (
        MOI.ScalarAffineTerm(2.0, x) => MOI.ScalarAffineTerm(-4.0, x),
        MOI.ScalarQuadraticTerm(2.0, x, x) =>
            MOI.ScalarQuadraticTerm(-4.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(2.0, x)) =>
            MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(-4.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(2.0, x, x)) =>
            MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(-4.0, x, x)),
    )
        @test MOI.Utilities.operate_term(*, f, -2.0) == g
    end
    return
end

function test_operate_term_3c()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f = MOI.ScalarAffineTerm(2.0, x)
    g = MOI.ScalarAffineTerm(2.0, y)
    @test MOI.Utilities.operate_term(*, f, f) ==
          MOI.ScalarQuadraticTerm(8.0, x, x)
    @test MOI.Utilities.operate_term(*, f, g) ==
          MOI.ScalarQuadraticTerm(4.0, x, y)
    h = MOI.VectorAffineTerm(1, f)
    i = MOI.VectorAffineTerm(1, g)
    @test MOI.Utilities.operate_term(*, h, h) ==
          MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(8.0, x, x))
    @test MOI.Utilities.operate_term(*, h, i) ==
          MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(4.0, x, y))
    return
end

function test_operate_term_3d()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarAffineTerm(2.0, x)
    @test MOI.Utilities.operate_term(*, 0.5, f, 0.4) ==
          MOI.ScalarAffineTerm(0.5 * 2.0 * 0.4, x)
    g = MOI.ScalarQuadraticTerm(8.0, x, x)
    @test MOI.Utilities.operate_term(*, 0.5, g, 0.4) ==
          MOI.ScalarQuadraticTerm(0.5 * 8.0 * 0.4, x, x)
    return
end

function test_operate_term_3e()
    D = LinearAlgebra.Diagonal([0.5, 0.6])
    x = MOI.VariableIndex(1)
    f = MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2.0, x))
    @test MOI.Utilities.operate_term(*, D, f) ==
          MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(0.5 * 2.0, x))
    g = MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(2.0, x))
    @test MOI.Utilities.operate_term(*, D, g) ==
          MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(0.6 * 2.0, x))
    f = MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(2.0, x, x))
    @test MOI.Utilities.operate_term(*, D, f) ==
          MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(0.5 * 2.0, x, x))
    g = MOI.VectorQuadraticTerm(2, MOI.ScalarQuadraticTerm(2.0, x, x))
    @test MOI.Utilities.operate_term(*, D, g) ==
          MOI.VectorQuadraticTerm(2, MOI.ScalarQuadraticTerm(0.6 * 2.0, x, x))
    return
end

function test_operate_term_4a()
    x = MOI.VariableIndex(1)
    for (f, g) in (
        MOI.ScalarAffineTerm(2.0, x) => MOI.ScalarAffineTerm(-4.0, x),
        MOI.ScalarQuadraticTerm(2.0, x, x) =>
            MOI.ScalarQuadraticTerm(-4.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(2.0, x)) =>
            MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(-4.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(2.0, x, x)) =>
            MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(-4.0, x, x)),
    )
        @test MOI.Utilities.operate_term(/, f, -0.5) == g
    end
    return
end

function test_operate_term_5a()
    x = MOI.VariableIndex(1)
    for f in (
        MOI.ScalarAffineTerm(1.0, x),
        MOI.ScalarQuadraticTerm(1.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(1.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(1.0, x, x)),
    )
        @test MOI.Utilities.operate_term(t -> -(t), f) ==
              MOI.Utilities.operate_term(-, f)
    end
    return
end

function test_operate_terms_1a()
    x = MOI.VariableIndex(1)
    for term in (
        MOI.ScalarAffineTerm(2.0, x),
        MOI.ScalarQuadraticTerm(2.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(2.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(2.0, x, x)),
    )
        @test MOI.Utilities.operate_terms(+, [term]) == [term]
    end
    return
end

function test_operate_terms_2a()
    x = MOI.VariableIndex(1)
    for term in (
        MOI.ScalarAffineTerm(2.0, x),
        MOI.ScalarQuadraticTerm(2.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(2.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(2.0, x, x)),
    )
        @test MOI.Utilities.operate_terms(-, [term]) ==
              [MOI.Utilities.operate_term(-, term)]
    end
    return
end

function test_operate_terms_3a()
    D = LinearAlgebra.Diagonal([0.5, 0.6])
    x = MOI.VariableIndex(1)
    terms = [
        MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2.0, x)),
        MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(2.0, x)),
    ]
    @test MOI.Utilities.operate_terms(*, D, terms) == [
        MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(0.5 * 2.0, x)),
        MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(0.6 * 2.0, x)),
    ]
    terms = [
        MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(2.0, x, x)),
        MOI.VectorQuadraticTerm(2, MOI.ScalarQuadraticTerm(2.0, x, x)),
    ]
    @test MOI.Utilities.operate_terms(*, D, terms) == [
        MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(0.5 * 2.0, x, x)),
        MOI.VectorQuadraticTerm(2, MOI.ScalarQuadraticTerm(0.6 * 2.0, x, x)),
    ]
    return
end

function test_operate_terms!_1a()
    x = MOI.VariableIndex(1)
    terms = [MOI.ScalarAffineTerm(2.0, x)]
    ret = MOI.Utilities.operate_terms!(-, terms)
    @test ret === terms
    @test ret == [MOI.ScalarAffineTerm(-2.0, x)]
    terms = [MOI.ScalarQuadraticTerm(2.0, x, x)]
    ret = MOI.Utilities.operate_terms!(-, terms)
    @test ret === terms
    @test ret == [MOI.ScalarQuadraticTerm(-2.0, x, x)]
    return
end

function test_operate_output_index_1a()
    T = Float64
    F = (
        (0.0, 0.0, 0.0),
        (1.0, 0.0, 0.0),
        (0.0, 1.0, 0.0),
        (0.0, 0.0, 1.0),
        (1.0, 1.0, 1.0),
        :log => (0, 0, 0),
    )
    for i in 2:6
        for j in 1:i
            if (i, j) == (2, 1)
                continue
            end
            f = _test_function(vcat(F[i], F[i]))
            fi, fj = _test_function(F[i]), _test_function(F[j])
            fij = MOI.Utilities.operate(+, T, fi, fj)
            g = MOI.Utilities.operate(vcat, T, fi, fij)
            @test MOI.Utilities.operate_output_index!(+, T, 2, f, fj) ≈ g
        end
    end
    return
end

function test_operate_coefficient()
    x = MOI.VariableIndex(1)
    for f in (
        MOI.ScalarAffineTerm(1.0, x),
        MOI.ScalarQuadraticTerm(1.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(1.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(1.0, x, x)),
    )
        @test MOI.Utilities.operate_coefficient(t -> -(t), f) ==
              MOI.Utilities.operate_term(-, f)
    end
    return
end

function test_operate_coefficients_term()
    x = MOI.VariableIndex(1)
    for f in (
        MOI.ScalarAffineTerm(1.0, x),
        MOI.ScalarQuadraticTerm(1.0, x, x),
        MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(1.0, x)),
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(1.0, x, x)),
    )
        @test MOI.Utilities.operate_coefficients(t -> -(t), [f]) ==
              MOI.Utilities.operate_terms(-, [f])
    end
    return
end

function test_operate_coefficients_functions()
    T = Float64
    F = ((0.0, 1.0, 0.0), (0.0, 0.0, 1.0), (1.0, 1.0, 1.0))
    op(x) = -x
    for coef in F
        f, g = _test_function(coef), _test_function(op.(coef))
        @test MOI.Utilities.operate_coefficients(op, f) ≈ g
        f, g = _test_function([coef]), _test_function([op.(coef)])
        @test MOI.Utilities.operate_coefficients(op, f) ≈ g
    end
    return
end

function test_operate_int32()
    x = MOI.VariableIndex(1)
    y = one(Int32) * x
    @test y isa MOI.ScalarAffineFunction{Int32}
    q1 = MOI.Utilities.operate(*, Int32, x, x)
    q2 = MOI.Utilities.operate(*, Int32, y, x)
    @test q1 isa MOI.ScalarQuadraticFunction{Int32}
    @test isapprox(q1, q2)
    return
end

end  # module

TestOperate.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestNonlinear

using Test
import MathOptInterface as MOI
import ForwardDiff
import LinearAlgebra

const Nonlinear = MOI.Nonlinear

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

_hessian(f, x) = LinearAlgebra.LowerTriangular(ForwardDiff.hessian(f, x))

function test_copy()
    model = Nonlinear.Model()
    @test_throws(
        ErrorException("Copying nonlinear problems not yet implemented"),
        copy(model),
    )
    return
end

function test_parse_unable()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    input = :(f($x))
    @test_throws(
        MOI.UnsupportedNonlinearOperator(:f),
        Nonlinear.set_objective(model, input),
    )
    return
end

function test_parse_sin()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    Nonlinear.set_objective(model, :(sin($x)))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :(sin(x[$x]))
    return
end

function test_parse_sin_squared()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    Nonlinear.set_objective(model, :(sin($x)^2))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :(sin(x[$x])^2.0)
    return
end

function test_parse_ifelse()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    Nonlinear.set_objective(model, :(ifelse($x, 1, 2)))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :(ifelse(x[$x], 1.0, 2.0))
    return
end

function test_parse_ifelse_inequality_less()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    Nonlinear.set_objective(model, :(ifelse($x < 1, $x - 1, $x + 1)))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) ==
          :(ifelse(x[$x] < 1.0, x[$x] - 1.0, x[$x] + 1.0))
    return
end

function test_parse_ifelse_inequality_greater()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    Nonlinear.set_objective(model, :(ifelse($x > 1, $x - 1, $x + 1)))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) ==
          :(ifelse(x[$x] > 1.0, x[$x] - 1.0, x[$x] + 1.0))
    return
end

function test_parse_ifelse_comparison()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    Nonlinear.set_objective(model, :(ifelse(0 <= $x <= 1, $x - 1, $x + 1)))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) ==
          :(ifelse(0.0 <= x[$x] <= 1.0, x[$x] - 1.0, x[$x] + 1.0))
    return
end

function test_parse_ifelse_logic_inequality()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    expr = :(ifelse($x < 1.0 || $x > 2.0, $x - 1.0, $x + 1.0))
    Nonlinear.set_objective(model, expr)
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) ==
          :(ifelse(x[$x] < 1.0 || x[$x] > 2.0, x[$x] - 1.0, x[$x] + 1.0))
    return
end

function test_parse_splat_prod()
    model = Nonlinear.Model()
    x = MOI.VariableIndex.(1:3)
    Nonlinear.set_objective(model, :(*($x...)))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) ==
          :(x[$(x[1])] * x[$(x[2])] * x[$(x[3])])
    return
end

function test_parse_splat_top_level()
    model = Nonlinear.Model()
    x = MOI.VariableIndex.(1:3)
    @test_throws(
        ErrorException(
            "Unsupported use of the splatting operator. This is only " *
            "supported in the arguments of a function call.",
        ),
        Nonlinear.set_objective(model, :(x...)),
    )
    return
end

function test_parse_splat_expr()
    model = Nonlinear.Model()
    x = MOI.VariableIndex.(1:3)
    @test_throws(
        ErrorException(
            "Unsupported use of the splatting operator. JuMP supports " *
            "splatting only symbols. For example, `x...` is ok, but " *
            "`(x + 1)...`, `[x; y]...` and `g(f(y)...)` are not.",
        ),
        Nonlinear.set_objective(model, :(*((x ./ 2)...))),
    )
    return
end

function test_parse_univariate_prod()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    Nonlinear.set_objective(model, :(*($x)))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :(*(x[$x]))
    return
end

function test_parse_string()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    @test_throws(
        ErrorException(
            "Unexpected object abc of type String in nonlinear expression.",
        ),
        Nonlinear.set_objective(model, :($x + "abc")),
    )
    return
end

function test_parse_array()
    model = Nonlinear.Model()
    x = [MOI.VariableIndex(1)]
    c = [1.0]
    @test_throws(
        ErrorException(
            "Unexpected array $(c') in nonlinear expression. Nonlinear " *
            "expressions may contain only scalar expressions.",
        ),
        Nonlinear.set_objective(model, :($(c') * $x)),
    )
    return
end

function test_parse_unsupported_expression()
    model = Nonlinear.Model()
    x = (y = 1,)
    @test_throws(
        ErrorException("Unsupported expression: $(:(x.y))"),
        Nonlinear.set_objective(model, :(x.y)),
    )
    return
end

function test_moi_variable_parse()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    expr = Nonlinear.parse_expression(model, :($x))
    @test expr.nodes == [Nonlinear.Node(Nonlinear.NODE_MOI_VARIABLE, 1, -1)]
    @test isempty(expr.values)
    return
end

function test_expression_parse()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    ex = Nonlinear.add_expression(model, :(sin($x)^2))
    @test model[ex] isa Nonlinear.Expression
    return
end

function test_parameter_parse()
    model = Nonlinear.Model()
    p = Nonlinear.add_parameter(model, 1.2)
    expr = Nonlinear.parse_expression(model, :($p))
    @test expr.nodes == [Nonlinear.Node(Nonlinear.NODE_PARAMETER, 1, -1)]
    @test isempty(expr.values)
    @test model.parameters == [1.2]
    return
end

function test_parameter_set()
    model = Nonlinear.Model()
    p = Nonlinear.add_parameter(model, 1.2)
    @test model.parameters == [1.2]
    @test model[p] == 1.2
    model[p] = 2.1
    @test model.parameters == [2.1]
    @test model[p] == 2.1
    return
end

function test_set_objective()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    input = :($x^2 + 1)
    Nonlinear.set_objective(model, input)
    @test model.objective == Nonlinear.parse_expression(model, input)
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :(x[$x]^2.0 + 1.0)
    return
end

function test_set_objective_subexpression()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    input = :($x^2 + 1)
    expr = Nonlinear.add_expression(model, input)
    Nonlinear.set_objective(model, :($expr^2))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :((x[$x]^2.0 + 1.0)^2.0)
    return
end

function test_set_objective_nested_subexpression()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    input = :($x^2 + 1)
    expr = Nonlinear.add_expression(model, input)
    expr_2 = Nonlinear.add_expression(model, :($expr^2))
    Nonlinear.set_objective(model, :($expr_2^2))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :(((x[$x]^2.0 + 1.0)^2.0)^2.0)
    return
end

function test_set_objective_parameter()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    p = Nonlinear.add_parameter(model, 1.2)
    Nonlinear.set_objective(model, :($x^2 + $p))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :(x[$x]^2.0 + 1.2)
    return
end

function test_add_constraint_less_than()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    func = :($x^2 + 1)
    set = MOI.LessThan(1.0)
    c = Nonlinear.add_constraint(model, func, set)
    @test model[c].set == set
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.constraint_expr(evaluator, 1) == :(x[$x]^2.0 + 1.0 <= 1.0)
    return
end

function test_add_constraint_delete()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    c1 = Nonlinear.add_constraint(model, :($x^2 + 1), MOI.LessThan(1.0))
    _ = Nonlinear.add_constraint(model, :(sqrt($x)), MOI.LessThan(1.0))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.constraint_expr(evaluator, 1) == :(x[$x]^2.0 + 1.0 <= 1.0)
    @test MOI.constraint_expr(evaluator, 2) == :(sqrt(x[$x]) <= 1.0)
    Nonlinear.delete(model, c1)
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.constraint_expr(evaluator, 1) == :(sqrt(x[$x]) <= 1.0)
    @test_throws BoundsError MOI.constraint_expr(evaluator, 2)
    return
end

function test_add_constraint_greater_than()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    func = :($x^2 + 1)
    set = MOI.GreaterThan(1.0)
    c = Nonlinear.add_constraint(model, func, set)
    @test model[c].set == set
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.constraint_expr(evaluator, 1) == :(x[$x]^2.0 + 1.0 >= 1.0)
    return
end

function test_add_constraint_equal_to()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    func, set = :($x^2 + 1), MOI.EqualTo(1.0)
    c = Nonlinear.add_constraint(model, func, set)
    @test model[c].set == set
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.constraint_expr(evaluator, 1) == :(x[$x]^2.0 + 1.0 == 1.0)
    return
end

function test_add_constraint_interval()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    func, set = :($x^2 + 1), MOI.Interval(-1.0, 1.0)
    c = Nonlinear.add_constraint(model, func, set)
    @test model[c].set == set
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.constraint_expr(evaluator, 1) == :(-1.0 <= x[$x]^2.0 + 1.0 <= 1.0)
    return
end

function test_eval_univariate_function()
    r = Nonlinear.OperatorRegistry()
    for (op, x, y) in [
        (:+, 1.0, 1.0),
        (:-, 1.0, -1.0),
        (:abs, -1.1, 1.1),
        (:abs, 1.1, 1.1),
        (:sin, 1.1, sin(1.1)),
    ]
        id = r.univariate_operator_to_id[op]
        @test Nonlinear.eval_univariate_function(r, op, x) == y
        @test Nonlinear.eval_univariate_function(r, id, x) == y
    end
    return
end

function test_eval_univariate_missing_hessian()
    r = Nonlinear.OperatorRegistry()
    x = 2.0
    @test Nonlinear.eval_univariate_function(r, :asec, x) ≈ asec(x)
    @test Nonlinear.eval_univariate_gradient(r, :asec, x) ≈
          1 / (abs(x) * sqrt(x^2 - 1))
    @test_throws(
        ErrorException("Hessian is not defined for operator asec"),
        Nonlinear.eval_univariate_hessian(r, :asec, x),
    )
    return
end

function test_eval_univariate_hessian_bad_id()
    r = Nonlinear.OperatorRegistry()
    err = ErrorException("Invalid id for univariate operator: -1")
    @test_throws err Nonlinear.eval_univariate_function(r, -1, 1.0)
    @test_throws err Nonlinear.eval_univariate_gradient(r, -1, 1.0)
    @test_throws err Nonlinear.eval_univariate_hessian(r, -1, 1.0)
    return
end

function test_eval_univariate_gradient()
    r = Nonlinear.OperatorRegistry()
    for (op, x, y) in [
        (:+, 1.2, 1.0),
        (:-, 1.2, -1.0),
        (:abs, -1.1, -1.0),
        (:abs, 1.1, 1.0),
        (:sin, 1.1, cos(1.1)),
    ]
        id = r.univariate_operator_to_id[op]
        @test Nonlinear.eval_univariate_gradient(r, op, x) == y
        @test Nonlinear.eval_univariate_gradient(r, id, x) == y
    end
    return
end

function test_eval_univariate_function_and_gradient()
    r = Nonlinear.OperatorRegistry()
    for (op, x, y) in [
        (:+, 1.2, (1.2, 1.0)),
        (:-, 1.2, (-1.2, -1.0)),
        (:abs, -1.1, (1.1, -1.0)),
        (:abs, 1.1, (1.1, 1.0)),
        (:sin, 1.1, (sin(1.1), cos(1.1))),
    ]
        id = r.univariate_operator_to_id[op]
        @test Nonlinear.eval_univariate_function_and_gradient(r, op, x) == y
        @test Nonlinear.eval_univariate_function_and_gradient(r, id, x) == y
    end
    return
end

function test_eval_univariate_hessian()
    r = Nonlinear.OperatorRegistry()
    for (op, x, y) in [
        (:+, 1.2, 0.0),
        (:-, 1.2, 0.0),
        (:abs, -1.1, 0.0),
        (:abs, 1.1, 0.0),
        (:sin, 1.0, -sin(1.0)),
    ]
        id = r.univariate_operator_to_id[op]
        @test Nonlinear.eval_univariate_hessian(r, op, x) == y
        @test Nonlinear.eval_univariate_hessian(r, id, x) == y
    end
    return
end

function test_eval_univariate_function_registered_method_error()
    r = Nonlinear.Model()
    f(x::Float64) = sin(x)^2
    @test_throws ErrorException Nonlinear.register_operator(r, :f, 1, f)
    return
end

function test_univariate_function_register_twice()
    r = Nonlinear.Model()
    f(x) = x
    Nonlinear.register_operator(r, :f, 1, f)
    @test_throws(
        ErrorException("Operator f is already registered."),
        Nonlinear.register_operator(r, :f, 1, f),
    )
    @test_throws(
        ErrorException("Operator f is already registered."),
        Nonlinear.register_operator(r, :f, 2, f),
    )
    return
end

function test_multivariate_function_register_twice()
    r = Nonlinear.Model()
    f(x, y) = x + y
    Nonlinear.register_operator(r, :f, 2, f)
    @test_throws(
        ErrorException("Operator f is already registered."),
        Nonlinear.register_operator(r, :f, 1, f),
    )
    @test_throws(
        ErrorException("Operator f is already registered."),
        Nonlinear.register_operator(r, :f, 2, f),
    )
    return
end

function test_auto_register()
    r = Nonlinear.OperatorRegistry()
    f(x, y) = x + y
    @test_throws ErrorException Nonlinear.assert_registered(r, :f, 2)
    @test_logs (:warn,) Nonlinear.register_operator_if_needed(r, :f, 2, f)
    Nonlinear.assert_registered(r, :f, 2)
    return
end

function test_register_univariate_function_return_type()
    r = Nonlinear.OperatorRegistry()
    f(x) = x < 1 ? "x" : x
    @test_throws(
        ErrorException(
            "Expected return type of `Float64` from the user-defined " *
            "function :f, but got `String`.",
        ),
        Nonlinear.register_operator(r, :f, 1, f),
    )
    return
end

function test_eval_univariate_function_return_type()
    r = Nonlinear.OperatorRegistry()
    f(x) = x < 1 ? x : "x"
    Nonlinear.register_operator(r, :f, 1, f)
    @test_throws(
        ErrorException(
            "Expected return type of Float64 from a user-defined function, " *
            "but got String.",
        ),
        Nonlinear.eval_univariate_function(r, :f, 1.2),
    )
    return
end

function test_eval_univariate_function_registered()
    r = Nonlinear.OperatorRegistry()
    f(x) = sin(x)^2
    grad_calls = 0
    f′(x) = (grad_calls += 1; 2 * sin(x) * cos(x))
    hess_calls = 0
    f′′(x) = (hess_calls += 1; 2 * (cos(x)^2 - sin(x)^2))
    Nonlinear.register_operator(r, :f, 1, f)
    x = 1.2
    @test Nonlinear.eval_univariate_function(r, :f, x) ≈ f(x)
    @test Nonlinear.eval_univariate_gradient(r, :f, x) ≈ f′(x)
    @test grad_calls == 1
    @test Nonlinear.eval_univariate_hessian(r, :f, x) ≈ f′′(x)
    @test hess_calls == 1
    return
end

function test_eval_univariate_function_registered_grad()
    r = Nonlinear.OperatorRegistry()
    f(x) = sin(x)^2
    grad_calls = 0
    f′(x) = (grad_calls += 1; 2 * sin(x) * cos(x))
    hess_calls = 0
    f′′(x) = (hess_calls += 1; 2 * (cos(x)^2 - sin(x)^2))
    Nonlinear.register_operator(r, :f, 1, f, f′)
    @test grad_calls == 2
    x = 1.2
    @test Nonlinear.eval_univariate_function(r, :f, x) ≈ f(x)
    @test Nonlinear.eval_univariate_gradient(r, :f, x) ≈ f′(x)
    @test grad_calls == 4
    @test Nonlinear.eval_univariate_hessian(r, :f, x) ≈ f′′(x)
    @test hess_calls == 1
    return
end

function test_eval_univariate_function_registered_grad_hess()
    r = Nonlinear.OperatorRegistry()
    f(x) = sin(x)^2
    grad_calls = 0
    f′(x) = (grad_calls += 1; 2 * sin(x) * cos(x))
    hess_calls = 0
    f′′(x) = (hess_calls += 1; 2 * (cos(x)^2 - sin(x)^2))
    Nonlinear.register_operator(r, :f, 1, f, f′, f′′)
    x = 1.2
    @test Nonlinear.eval_univariate_function(r, :f, x) ≈ f(x)
    @test Nonlinear.eval_univariate_gradient(r, :f, x) ≈ f′(x)
    @test grad_calls == 2
    @test Nonlinear.eval_univariate_hessian(r, :f, x) ≈ f′′(x)
    @test hess_calls == 2
    return
end

function test_eval_multivariate_function()
    r = Nonlinear.OperatorRegistry()
    x = [1.1, 2.2]
    @test Nonlinear.eval_multivariate_function(r, :+, x) ≈ 3.3
    @test Nonlinear.eval_multivariate_function(r, :-, x) ≈ -1.1
    @test Nonlinear.eval_multivariate_function(r, :*, x) ≈ 1.1 * 2.2
    @test Nonlinear.eval_multivariate_function(r, :^, x) ≈ 1.1^2.2
    @test Nonlinear.eval_multivariate_function(r, :/, x) ≈ 1.1 / 2.2
    @test Nonlinear.eval_multivariate_function(r, :ifelse, [1; x]) == 1.1
    @test Nonlinear.eval_multivariate_function(r, :ifelse, [0; x]) == 2.2
    return
end

function test_eval_multivariate_gradient()
    r = Nonlinear.OperatorRegistry()
    x = [1.1, 2.2]
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :+, g, x)
    @test g == [1.0, 1.0]
    Nonlinear.eval_multivariate_gradient(r, :-, g, x)
    @test g == [1.0, -1.0]
    Nonlinear.eval_multivariate_gradient(r, :*, g, x)
    @test g ≈ [2.2, 1.1]
    Nonlinear.eval_multivariate_gradient(r, :^, g, x)
    @test g ≈ [2.2 * 1.1^1.2, 1.1^2.2 * log(1.1)]
    Nonlinear.eval_multivariate_gradient(r, :^, g, [1.1, 1.0])
    @test g ≈ [1.0, 1.1 * log(1.1)]
    Nonlinear.eval_multivariate_gradient(r, :^, g, [1.1, 2.0])
    @test g ≈ [2.0 * 1.1, 1.1^2.0 * log(1.1)]
    Nonlinear.eval_multivariate_gradient(r, :^, g, [-1.1, 2.0])
    @test g[1] ≈ 2.0 * -1.1
    @test isnan(g[2])
    Nonlinear.eval_multivariate_gradient(r, :/, g, x)
    @test g ≈ [1 / 2.2, -1.1 / 2.2^2]
    g = zeros(3)
    Nonlinear.eval_multivariate_gradient(r, :ifelse, g, [1; x])
    @test g ≈ [0.0, 1.0, 0.0]
    Nonlinear.eval_multivariate_gradient(r, :ifelse, g, [0; x])
    @test g ≈ [0.0, 0.0, 1.0]
    return
end

function test_eval_multivariate_gradient_mult()
    r = Nonlinear.OperatorRegistry()
    x = [1.1, 0.0, 2.2]
    g = zeros(3)
    Nonlinear.eval_multivariate_gradient(r, :*, g, x)
    @test g ≈ [0.0, 1.1 * 2.2, 0.0]
    x = [1.1, 3.3, 2.2]
    Nonlinear.eval_multivariate_gradient(r, :*, g, x)
    @test g ≈ [3.3 * 2.2, 1.1 * 2.2, 1.1 * 3.3]
    return
end

function test_eval_multivariate_gradient_univariate_mult()
    r = Nonlinear.OperatorRegistry()
    x = [1.1]
    g = zeros(1)
    Nonlinear.eval_multivariate_gradient(r, :*, g, x)
    @test g == [1.0]
    return
end

function test_eval_multivariate_hessian_shortcut()
    r = Nonlinear.OperatorRegistry()
    x = [1.1]
    H = LinearAlgebra.LowerTriangular(zeros(1, 1))
    for op in (:+, :-, :ifelse)
        @test !MOI.Nonlinear.eval_multivariate_hessian(r, op, H, x)
    end
    return
end

function test_eval_multivariate_hessian_prod()
    r = Nonlinear.OperatorRegistry()
    # 1-arg *
    x = [1.1]
    H = LinearAlgebra.LowerTriangular(zeros(1, 1))
    @test Nonlinear.eval_multivariate_hessian(r, :*, H, x)
    @test H ≈ _hessian(x -> *(x[1]), x)
    # 2-arg *
    x = [1.1, 2.2]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :*, H, x)
    @test H ≈ _hessian(x -> x[1] * x[2], x)
    # 3-arg *
    x = [1.1, 2.2, 3.3]
    H = LinearAlgebra.LowerTriangular(zeros(3, 3))
    @test Nonlinear.eval_multivariate_hessian(r, :*, H, x)
    @test H ≈ _hessian(x -> x[1] * x[2] * x[3], x)
    return
end

function test_eval_multivariate_hessian_prod_allocated()
    r = Nonlinear.OperatorRegistry()
    x = [1.1, 2.2]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    Nonlinear.eval_multivariate_hessian(r, :*, H, x)  # ensure precompiled
    @test (@allocated Nonlinear.eval_multivariate_hessian(r, :*, H, x)) == 0
    return
end

function test_eval_multivariate_hessian_exponentiation()
    r = Nonlinear.OperatorRegistry()
    # ^1.0
    x = [1.1, 1.0]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :^, H, x)
    @test H ≈ _hessian(x -> x[1]^x[2], x)
    # ^2.0
    x = [1.1, 2.0]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :^, H, x)
    @test H ≈ _hessian(x -> x[1]^x[2], x)
    # 2-arg ^
    x = [1.1, 2.2]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :^, H, x)
    @test H ≈ _hessian(x -> x[1]^x[2], x)
    return
end

function test_eval_multivariate_hessian_exponentiation_allocated()
    r = Nonlinear.OperatorRegistry()
    # ^1.0
    x = [1.1, 1.0]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :^, H, x)
    for x2 in [1.0, 2.0, 2.2]
        x[2] = x2
        @test (@allocated Nonlinear.eval_multivariate_hessian(r, :^, H, x)) == 0
    end
    return
end

function test_eval_multivariate_hessian_division()
    r = Nonlinear.OperatorRegistry()
    # 2-arg /
    x = [1.1, 2.2]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :/, H, x)
    @test H ≈ _hessian(x -> x[1] / x[2], x)
    return
end

function test_eval_multivariate_hessian_division_allocated()
    r = Nonlinear.OperatorRegistry()
    x = [1.1, 2.2]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    Nonlinear.eval_multivariate_hessian(r, :/, H, x)  # ensure precompiled
    @test (@allocated Nonlinear.eval_multivariate_hessian(r, :/, H, x)) == 0
    return
end

function test_eval_multivariate_function_registered()
    r = Nonlinear.OperatorRegistry()
    f(x...) = x[1]^2 + x[1] * x[2] + x[2]^2
    Nonlinear.register_operator(r, :f, 2, f)
    x = [1.1, 2.2]
    @test Nonlinear.eval_multivariate_function(r, :f, x) ≈ f(x...)
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :f, g, x)
    @test g ≈ [2 * x[1] + x[2], x[1] + 2 * x[2]]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test_throws(
        ErrorException,
        Nonlinear.eval_multivariate_hessian(r, :f, H, x),
    )
    return
end

function test_eval_multivariate_function_registered_log()
    r = Nonlinear.OperatorRegistry()
    f(x...) = log(x[1] - 1)
    Nonlinear.register_operator(r, :f, 2, f)
    x = [1.1, 2.2]
    @test Nonlinear.eval_multivariate_function(r, :f, x) ≈ f(x...)
    x = [0.0, 0.0]
    g = zeros(2)
    @test_throws DomainError Nonlinear.eval_multivariate_gradient(r, :f, g, x)
    return
end

function test_eval_multivariate_function_method_error()
    r = Nonlinear.OperatorRegistry()
    function f(x...)
        if x[1] > 1
            y = zeros(Float64, 1)
            y[1] = x[1]
            return y[1]^2
        end
        return x[1]^2 + x[1] * x[2] + x[2]^2
    end
    Nonlinear.register_operator(r, :f, 2, f)
    x = [1.1, 2.2]
    g = [0.0, 0.0]
    @test_throws(
        ErrorException,
        Nonlinear.eval_multivariate_gradient(r, :f, g, x),
    )
    return
end

function test_eval_multivariate_function_registered_grad()
    r = Nonlinear.OperatorRegistry()
    f(x...) = x[1]^2 + x[1] * x[2] + x[2]^2
    grad_calls = 0
    function ∇f(g, x...)
        grad_calls += 1
        g[1] = 2 * x[1] + x[2]
        g[2] = x[1] + 2 * x[2]
        return
    end
    Nonlinear.register_operator(r, :f, 2, f, ∇f)
    x = [1.1, 2.2]
    @test Nonlinear.eval_multivariate_function(r, :f, x) ≈ f(x...)
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :f, g, x)
    @test g ≈ [2 * x[1] + x[2], x[1] + 2 * x[2]]
    @test grad_calls == 1
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test_throws(
        ErrorException("Hessian is not defined for operator f"),
        Nonlinear.eval_multivariate_hessian(r, :f, H, x),
    )
    return
end

function test_eval_multivariate_function_registered_hessian()
    r = Nonlinear.OperatorRegistry()
    f(x...) = x[1]^2 + x[1] * x[2] + x[2]^2
    grad_calls = 0
    function ∇f(g, x...)
        grad_calls += 1
        g[1] = 2 * x[1] + x[2]
        g[2] = x[1] + 2 * x[2]
        return
    end
    hess_calls = 0
    function ∇²f(H, x...)
        hess_calls += 1
        H[1, 1] = 2.0
        H[2, 1] = 1.0
        H[2, 2] = 2.0
        return
    end
    Nonlinear.register_operator(r, :f, 2, f, ∇f, ∇²f)
    x = [1.1, 2.2]
    @test Nonlinear.eval_multivariate_function(r, :f, x) ≈ f(x...)
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :f, g, x)
    @test g ≈ [2 * x[1] + x[2], x[1] + 2 * x[2]]
    @test grad_calls == 1
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :f, H, x) == true
    @test H == [2.0 0.0; 1.0 2.0]
    @test hess_calls == 1
    return
end

function test_eval_logic_function()
    r = Nonlinear.OperatorRegistry()
    for lhs in (true, false), rhs in (true, false)
        @test Nonlinear.eval_logic_function(r, :&&, lhs, rhs) == (lhs && rhs)
        @test Nonlinear.eval_logic_function(r, :||, lhs, rhs) == (lhs || rhs)
        @test_throws(
            AssertionError,
            Nonlinear.eval_logic_function(r, :⊻, lhs, rhs),
        )
    end
    return
end

function test_eval_comprison_function()
    r = Nonlinear.OperatorRegistry()
    for lhs in (true, false), rhs in (true, false)
        @test Nonlinear.eval_comparison_function(r, :<=, lhs, rhs) ==
              (lhs <= rhs)
        @test Nonlinear.eval_comparison_function(r, :>=, lhs, rhs) ==
              (lhs >= rhs)
        @test Nonlinear.eval_comparison_function(r, :(==), lhs, rhs) ==
              (lhs == rhs)
        @test Nonlinear.eval_comparison_function(r, :<, lhs, rhs) == (lhs < rhs)
        @test Nonlinear.eval_comparison_function(r, :>, lhs, rhs) == (lhs > rhs)
        @test_throws(
            AssertionError,
            Nonlinear.eval_comparison_function(r, :⊻, lhs, rhs),
        )
    end
    return
end

function test_features_available()
    model = Nonlinear.Model()
    evaluator = Nonlinear.Evaluator(model)
    @test MOI.features_available(evaluator) == [:ExprGraph]
    return
end

function test_features_available_Default()
    model = Nonlinear.Model()
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.ExprGraphOnly(),
        MOI.VariableIndex[],
    )
    @test MOI.features_available(evaluator) == [:ExprGraph]
    return
end

function test_add_constraint_ordinal_index()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    constraints = [
        Nonlinear.add_constraint(model, :($x), MOI.LessThan(1.0 * i)) for
        i in 1:4
    ]
    for i in 1:4
        @test MOI.is_valid(model, constraints[i])
    end
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, Symbol[])
    for i in 1:4
        @test Nonlinear.ordinal_index(evaluator, constraints[i]) == i
    end
    Nonlinear.delete(model, constraints[1])
    Nonlinear.delete(model, constraints[3])
    @test !MOI.is_valid(model, constraints[1])
    @test MOI.is_valid(model, constraints[2])
    @test !MOI.is_valid(model, constraints[3])
    @test MOI.is_valid(model, constraints[4])
    MOI.initialize(evaluator, Symbol[])
    @test Nonlinear.ordinal_index(evaluator, constraints[2]) == 1
    @test_throws(
        ErrorException("Invalid constraint index $(constraints[3])"),
        Nonlinear.ordinal_index(evaluator, constraints[3]),
    )
    @test Nonlinear.ordinal_index(evaluator, constraints[4]) == 2
    return
end

function test_show()
    model = Nonlinear.Model()
    evaluator = Nonlinear.Evaluator(model)
    @test occursin(":ExprGraph", sprint(show, evaluator))
    return
end

function test_evaluate_comparison()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    ex = Nonlinear.add_expression(model, :(ifelse($x < 1, -1.0, 1.0)))
    @test Nonlinear.evaluate(Dict(x => 1.1), model, ex) == 1.0
    @test Nonlinear.evaluate(Dict(x => 0.9), model, ex) == -1.0
    return
end

function test_evaluate_domain_error()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    ex = Nonlinear.add_expression(model, :(ifelse($x > 0, log($x), 0.0)))
    @test Nonlinear.evaluate(Dict(x => 1.1), model, ex) == log(1.1)
    @test Nonlinear.evaluate(Dict(x => 0.0), model, ex) == 0.0
    ex = Nonlinear.add_expression(model, :(ifelse($x > 0, $x^1.5, -(-$x)^1.5)))
    @test Nonlinear.evaluate(Dict(x => 1.1), model, ex) ≈ 1.1^1.5
    @test Nonlinear.evaluate(Dict(x => -1.1), model, ex) ≈ -(1.1^1.5)
    return
end

function test_evaluate_logic()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    ex = Nonlinear.add_expression(model, :(ifelse($x < 0 || $x > 1, -1.0, 1.0)))
    @test Nonlinear.evaluate(Dict(x => 1.1), model, ex) == -1.0
    @test Nonlinear.evaluate(Dict(x => 0.9), model, ex) == 1.0
    @test Nonlinear.evaluate(Dict(x => -0.9), model, ex) == -1.0
    return
end

function test_evaluate_subexpressions()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    p = Nonlinear.add_parameter(model, 1.23)
    ex = Nonlinear.add_expression(model, :(*($p, $x, $x)))
    ex = Nonlinear.add_expression(model, :($ex + sqrt($ex)))
    ex_v = 1.23 * 1.1 * 1.1
    @test Nonlinear.evaluate(Dict(x => 1.1), model, ex) ≈ ex_v + sqrt(ex_v)
    model[p] = 3.21
    ex_v = 3.21 * 1.2 * 1.2
    @test Nonlinear.evaluate(Dict(x => 1.2), model, ex) ≈ ex_v + sqrt(ex_v)
    return
end

function test_evaluate_manny_arguments()
    model = MOI.Nonlinear.Model()
    x = MOI.VariableIndex.(1:20)
    v = Dict(xi => xi.value for xi in x)
    expr = MOI.Nonlinear.add_expression(
        model,
        Expr(:call, :+, [:(sqrt($(x[i]))) for i in 1:20]...),
    )
    @test Nonlinear.evaluate(v, model, expr) ≈ sum(sqrt(i) for i in 1:20)
    return
end

function test_NLPBlockData()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    evaluator = Nonlinear.Evaluator(model, Nonlinear.ExprGraphOnly(), [x])
    block = MOI.NLPBlockData(evaluator)
    @test block.has_objective == false
    @test length(block.constraint_bounds) == 0
    return
end

function test_parse_atan2()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    θ = π / 4
    Nonlinear.add_constraint(model, :(atan($x, $y)), MOI.LessThan(θ))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.constraint_expr(evaluator, 1) == :(atan(x[$x], x[$y]) <= $θ)
    return
end

function test_eval_atan2()
    r = Nonlinear.OperatorRegistry()
    x = [1.1, 2.2]
    @test Nonlinear.eval_multivariate_function(r, :atan, x) ≈ atan(x[1], x[2])
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :atan, g, x)
    @test g[1] ≈ x[2] / (x[1]^2 + x[2]^2)
    @test g[2] ≈ -x[1] / (x[1]^2 + x[2]^2)
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :atan, H, x)
    @test H[1, 1] ≈ -2 * x[2] * x[1] / (x[1]^2 + x[2]^2)^2
    @test H[2, 1] ≈ (x[1]^2 - x[2]^2) / (x[1]^2 + x[2]^2)^2
    @test H[2, 2] ≈ 2 * x[2] * x[1] / (x[1]^2 + x[2]^2)^2
    return
end

function test_deep_recursion()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    y = Expr(:call, :sin, x)
    for _ in 1:20_000
        y = Expr(:call, :^, Expr(:call, :sqrt, y), 2)
    end
    start = time()
    @test Nonlinear.parse_expression(model, y) isa Nonlinear.Expression
    # A conservative bound to check we're not doing something expensive.
    @test time() - start < 1.0
    return
end

function test_min_operator()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    Nonlinear.set_objective(model, :(min($x, $y)))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :(min(x[$x], x[$y]))

    r = Nonlinear.OperatorRegistry()
    x = [1.1, 2.2]
    @test Nonlinear.eval_multivariate_function(r, :min, x) == 1.1
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :min, g, x)
    @test g == [1.0, 0.0]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :min, H, x)
    @test H[1, 1] == 1.0
    @test H[2, 1] == H[2, 2] == 0.0

    x = [1.1, -2.2]
    @test Nonlinear.eval_multivariate_function(r, :min, x) == -2.2
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :min, g, x)
    @test g == [0.0, 1.0]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :min, H, x)
    @test H[2, 2] == 1.0
    @test H[1, 1] == H[2, 1] == 0.0
    return
end

function test_max_operator()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    Nonlinear.set_objective(model, :(max($x, $y)))
    evaluator = Nonlinear.Evaluator(model)
    MOI.initialize(evaluator, [:ExprGraph])
    @test MOI.objective_expr(evaluator) == :(max(x[$x], x[$y]))

    r = Nonlinear.OperatorRegistry()
    x = [1.1, -2.2]
    @test Nonlinear.eval_multivariate_function(r, :max, x) == 1.1
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :max, g, x)
    @test g == [1.0, 0.0]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :max, H, x)
    @test H[1, 1] == 1.0
    @test H[2, 1] == H[2, 2] == 0.0

    x = [1.1, 2.2]
    @test Nonlinear.eval_multivariate_function(r, :max, x) == 2.2
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :max, g, x)
    @test g == [0.0, 1.0]
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    @test Nonlinear.eval_multivariate_hessian(r, :max, H, x)
    @test H[2, 2] == 1.0
    @test H[1, 1] == H[2, 1] == 0.0
    return
end

function test_pow_complex_result()
    r = Nonlinear.OperatorRegistry()
    x = [-1.0, 1.5]
    @test isnan(Nonlinear.eval_multivariate_function(r, :^, x))
    g = zeros(2)
    Nonlinear.eval_multivariate_gradient(r, :^, g, x)
    @test all(isnan, g)
    H = LinearAlgebra.LowerTriangular(zeros(2, 2))
    Nonlinear.eval_multivariate_hessian(r, :^, H, x)
    @test all(iszero, H)
    @test Nonlinear.eval_multivariate_function(r, :^, Int[-2, 3]) == -8
    return
end

struct _NoReverse{T} <: AbstractArray{T,1}
    data::Vector{T}
end

Base.eachindex(x::_NoReverse) = eachindex(x.data)
Base.getindex(x::_NoReverse, args...) = getindex(x.data, args...)

function test_parse_splat_no_reverse()
    model = Nonlinear.Model()
    x = MOI.VariableIndex.(1:2)
    y = _NoReverse(x)
    expr = Nonlinear.parse_expression(model, :(+($y...)))
    @test expr == Nonlinear.parse_expression(model, :(+($(x[1]), $(x[2]))))
    return
end

function test_scalar_nonlinear_function_parse_expression()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(
        :+,
        Any[x, MOI.ScalarNonlinearFunction(:sin, Any[x])],
    )
    nlp_model = MOI.Nonlinear.Model()
    e1 = MOI.Nonlinear.add_expression(nlp_model, f)
    e2 = MOI.Nonlinear.add_expression(nlp_model, :($x + sin($x)))
    @test nlp_model[e1] == nlp_model[e2]
    return
end

function test_scalar_nonlinear_function_parse_scalaraffinefunction()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    terms = MOI.ScalarAffineTerm{Float64}[]
    for (f, expr) in (
        MOI.ScalarAffineFunction(terms, 0.0) => :(0.0),
        MOI.ScalarAffineFunction(terms, 1.0) => :(1.0),
        (1.0 * x + 2.0) => :($x + 2.0),
        (2.0 * x + 2.0) => :(2.0 * $x + 2.0),
        (2.0 * x + -3.0 * y) => :(2.0 * $x + -3.0 * $y),
        (2.0 * x) => :(2.0 * $x),
        (1.0 * x) => :($x),
    )
        nlp_model = MOI.Nonlinear.Model()
        f1 = MOI.Nonlinear.add_expression(nlp_model, f)
        f2 = MOI.Nonlinear.add_expression(nlp_model, expr)
        @test nlp_model[f1] == nlp_model[f2]
    end
    return
end

function test_scalar_nonlinear_function_parse_scalarquadraticfunction()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    terms = MOI.ScalarAffineTerm{Float64}[]
    qterms = MOI.ScalarQuadraticTerm{Float64}[]
    aterm = MOI.ScalarAffineTerm(2.0, x)
    for (f, expr) in (
        MOI.ScalarQuadraticFunction(qterms, terms, 0.0) => :(0.0),
        MOI.ScalarQuadraticFunction(qterms, terms, 1.0) => :(1.0),
        MOI.ScalarQuadraticFunction(qterms, [aterm], 0.0) => :(2.0 * $x),
        (1.0 * x * x + 1.0 * x + 1.0) => :($x^2 + $x + 1),
        (1.0 * x * x + 1.0 * x) => :($x^2 + $x),
        (1.0 * x * x + 2.0 * x) => :($x^2 + 2.0 * $x),
        (2.0 * x * x + 2.0 * x) => :(2.0 * $x^2 + 2.0 * $x),
        (1.0 * x * x) => :($x^2),
        (1.5 * x * x + 2.5 * x * y + 3.5 * x + 2.0) =>
            :(1.5 * $x^2 + 2.5 * $x * $y + 3.5 * $x + 2.0),
    )
        nlp_model = MOI.Nonlinear.Model()
        f1 = MOI.Nonlinear.add_expression(nlp_model, f)
        f2 = MOI.Nonlinear.add_expression(nlp_model, expr)
        @test nlp_model[f1] == nlp_model[f2]
    end
    return
end

function test_scalar_nonlinear_function_parse_logic_or()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:||, Any[x, x])
    nlp_model = MOI.Nonlinear.Model()
    e1 = MOI.Nonlinear.add_expression(nlp_model, f)
    e2 = MOI.Nonlinear.add_expression(nlp_model, :($x || $x))
    @test nlp_model[e1] == nlp_model[e2]
    return
end

function test_scalar_nonlinear_function_parse_logic_and()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:&&, Any[x, x])
    nlp_model = MOI.Nonlinear.Model()
    e1 = MOI.Nonlinear.add_expression(nlp_model, f)
    e2 = MOI.Nonlinear.add_expression(nlp_model, :($x && $x))
    @test nlp_model[e1] == nlp_model[e2]
    return
end

function test_scalar_nonlinear_function_parse_comparison()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:<, Any[x, 1])
    nlp_model = MOI.Nonlinear.Model()
    e1 = MOI.Nonlinear.add_expression(nlp_model, f)
    e2 = MOI.Nonlinear.add_expression(nlp_model, :($x < 1))
    @test nlp_model[e1] == nlp_model[e2]
    return
end

function test_scalar_nonlinear_function_parse_unknown()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:foo, Any[x, 1])
    nlp_model = MOI.Nonlinear.Model()
    @test_throws(
        MOI.UnsupportedNonlinearOperator(:foo),
        MOI.Nonlinear.add_expression(nlp_model, f),
    )
    return
end

function test_ListOfSupportedNonlinearOperators()
    model = MOI.Nonlinear.Model()
    ops = MOI.get(model, MOI.ListOfSupportedNonlinearOperators())
    @test ops isa Vector{Symbol}
    @test length(ops) > 70
    @test :|| in ops
    @test :sin in ops
    @test :> in ops
    @test :ifelse in ops
    return
end

function test_parse_univariate_splatting()
    model = MOI.Nonlinear.Model()
    MOI.Nonlinear.register_operator(model, :f, 1, x -> 2x)
    x = [MOI.VariableIndex(1)]
    @test MOI.Nonlinear.parse_expression(model, :(f($x...))) ==
          MOI.Nonlinear.parse_expression(model, :(f($(x[1]))))
    return
end

function test_parse_unsupported_operator()
    model = MOI.Nonlinear.Model()
    x = [MOI.VariableIndex(1)]
    @test_throws(
        MOI.UnsupportedNonlinearOperator(:f),
        MOI.Nonlinear.parse_expression(model, :(f($x...))),
    )
    return
end

function test_is_empty()
    model = MOI.Nonlinear.Model()
    @test MOI.is_empty(model)
    x = MOI.VariableIndex(1)
    Nonlinear.set_objective(model, :(log($x)))
    @test !MOI.is_empty(model)
    MOI.empty!(model)
    @test MOI.is_empty(model)
    Nonlinear.add_constraint(model, :(log($x)), MOI.GreaterThan(1.0))
    @test !MOI.is_empty(model)
    MOI.empty!(model)
    @test MOI.is_empty(model)
    Nonlinear.add_expression(model, :(sin($x)^2))
    @test !MOI.is_empty(model)
    MOI.empty!(model)
    @test MOI.is_empty(model)
    Nonlinear.add_parameter(model, 1.2)
    @test !MOI.is_empty(model)
    MOI.empty!(model)
    @test MOI.is_empty(model)
    f(x) = log(x + 1)
    Nonlinear.register_operator(model, :f, 1, f)
    @test !MOI.is_empty(model)
    MOI.empty!(model)
    @test MOI.is_empty(model)
    return
end

function test_unsupported_features_expr_graph_only()
    evaluator = Nonlinear.Evaluator(
        Nonlinear.Model(),
        Nonlinear.ExprGraphOnly(),
        MOI.VariableIndex[],
    )
    @test_throws(
        ErrorException(
            "Unable to initialize `Nonlinear.Evaluator` because the " *
            "following features are not supported: $([:Grad])",
        ),
        MOI.initialize(evaluator, [:ExprGraph, :Grad]),
    )
    return
end

function test_automatic_differentiation_backend()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        MOI.Utilities.MockOptimizer(inner),
    )
    MOI.set(
        model,
        MOI.AutomaticDifferentiationBackend(),
        MOI.Nonlinear.ExprGraphOnly(),
    )
    @test MOI.get(inner, MOI.AutomaticDifferentiationBackend()) ==
          MOI.Nonlinear.ExprGraphOnly()
    return
end

function test_univariate_sign()
    f(y, p) = sign(y) * abs(y)^p
    ∇f(y, p) = p * abs(y)^(p - 1)
    ∇²f(y, p) = sign(y) * p * (p - 1) * abs(y)^(p - 2)
    for p in (-0.5, 0.5, 2.0)
        x = MOI.VariableIndex(1)
        model = MOI.Nonlinear.Model()
        MOI.Nonlinear.set_objective(model, :(sign($x) * abs($x)^$p))
        evaluator = MOI.Nonlinear.Evaluator(
            model,
            MOI.Nonlinear.SparseReverseMode(),
            [x],
        )
        MOI.initialize(evaluator, [:Grad, :Hess])
        for y in (-10.0, -1.2, 1.2, 10.0)
            @test MOI.eval_objective(evaluator, [y]) ≈ f(y, p)
            g = [NaN]
            MOI.eval_objective_gradient(evaluator, g, [y])
            @test g[1] ≈ ∇f(y, p)
            H = zeros(length(MOI.hessian_objective_structure(evaluator)))
            MOI.eval_hessian_objective(evaluator, H, [y])
            @test H[1] ≈ ∇²f(y, p)
        end
    end
end

function test_show_Model()
    model = MOI.Nonlinear.Model()
    @test sprint(show, model) ==
          "A Nonlinear.Model with:\n 0 objectives\n 0 parameters\n 0 expressions\n 0 constraints"
    p = MOI.Nonlinear.add_parameter(model, 2.0)
    @test sprint(show, model) ==
          "A Nonlinear.Model with:\n 0 objectives\n 1 parameter\n 0 expressions\n 0 constraints"
    return
end

function test_set_objective_nothing()
    model = MOI.Nonlinear.Model()
    x = MOI.VariableIndex(1)
    MOI.Nonlinear.set_objective(model, :(sin($x)))
    @test sprint(show, model) ==
          "A Nonlinear.Model with:\n 1 objective\n 0 parameters\n 0 expressions\n 0 constraints"
    MOI.Nonlinear.set_objective(model, nothing)
    @test sprint(show, model) ==
          "A Nonlinear.Model with:\n 0 objectives\n 0 parameters\n 0 expressions\n 0 constraints"
    return
end

function test_copy_evaluator()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    evaluator = Nonlinear.Evaluator(model, Nonlinear.ExprGraphOnly(), [x])
    @test_throws(
        ErrorException("Copying nonlinear problems not yet implemented"),
        copy(evaluator),
    )
    return
end

function test_no_objective()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    evaluator = Nonlinear.Evaluator(model, Nonlinear.ExprGraphOnly(), [x])
    @test_throws(
        ErrorException(
            "Unable to query objective_expr because no nonlinear objective was set",
        ),
        MOI.objective_expr(evaluator),
    )
    return
end

function test_convert_to_expr()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    expr = MOI.Nonlinear.add_expression(model, :(sin($x)))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.ExprGraphOnly(), [x])
    @test MOI.Nonlinear.convert_to_expr(
        evaluator,
        model[expr];
        moi_output_format = true,
    ) == :(sin(x[$x]))
    @test MOI.Nonlinear.convert_to_expr(
        evaluator,
        model[expr];
        moi_output_format = false,
    ) == :(sin($x))
    return
end

function test_create_binary_switch()
    target = Expr(
        :if,
        Expr(:call, :(<=), :id, 2),
        Expr(
            :if,
            Expr(:call, :(==), :id, 1),
            :a,
            Expr(:if, Expr(:call, :(==), :id, 2), :b),
        ),
        Expr(
            :if,
            Expr(:call, :(==), :id, 3),
            :c,
            Expr(:if, Expr(:call, :(==), :id, 4), :d),
        ),
    )
    @test MOI.Nonlinear._create_binary_switch(1:4, [:a, :b, :c, :d]) == target
    # Just test that these functions don't error. We'll test their contents by
    # evaluating the actual fuctions that are `@eval`ed.
    MOI.Nonlinear._generate_eval_univariate()
    MOI.Nonlinear._generate_eval_univariate_2nd_deriv()
    return
end

function test_intercept_ForwardDiff_MethodError()
    r = Nonlinear.OperatorRegistry()
    f(x::Float64) = sin(x)^2
    g(x) = x > 1 ? f(x) : zero(x)
    Nonlinear.register_operator(r, :g, 1, g)
    @test Nonlinear.eval_univariate_function(r, :g, 0.0) == 0.0
    @test Nonlinear.eval_univariate_function(r, :g, 2.0) ≈ sin(2.0)^2
    @test Nonlinear.eval_univariate_gradient(r, :g, 0.0) == 0.0
    @test_throws ErrorException Nonlinear.eval_univariate_gradient(r, :g, 2.0)
    return
end

end  # TestNonlinear

TestNonlinear.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module MathOptInterfaceCliqueTreesExt

import CliqueTrees
import LinearAlgebra
import MathOptInterface as MOI
import SparseArrays

MOI.Bridges.Constraint.is_defined(::MOI.Bridges.Constraint._CliqueTrees) = true

function MOI.Bridges.Constraint._compute_sparse_sqrt(
    ::MOI.Bridges.Constraint._CliqueTrees,
    Q::AbstractMatrix,
)
    G = LinearAlgebra.cholesky!(
        CliqueTrees.Multifrontal.ChordalCholesky(Q),
        LinearAlgebra.RowMaximum(),
    )
    U = SparseArrays.sparse(G.U) * G.P
    # Verify the factorization reconstructs Q. We don't have something like
    # LinearAlgebra.issuccess(G)
    if !isapprox(Q, U' * U; atol = 1e-10)
        return nothing
    end
    return SparseArrays.findnz(U)
end

end  # module

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariables

using Test

import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_get_bounds_Float64()
    T = Float64
    model = MOIU.Model{T}()

    x = MOI.add_variable(model)
    y_v, y_c = MOI.add_constrained_variable(model, MOI.GreaterThan{T}(1.0))
    z_v, z_c = MOI.add_constrained_variable(model, MOI.LessThan{T}(-1.0))
    w_v, w_c = MOI.add_constrained_variable(model, MOI.Interval{T}(-2.0, 3.0))
    u_v, u_c =
        MOI.add_constrained_variable(model, MOI.Semicontinuous{T}(1.0, 3.5))
    v_v, v_c =
        MOI.add_constrained_variable(model, MOI.Semiinteger{T}(-1.0, 2.5))
    e_v, e_c = MOI.add_constrained_variable(model, MOI.EqualTo(1.35))

    @test -Inf == @inferred MOIU.get_bounds(model, T, x)[1]
    @test Inf == @inferred MOIU.get_bounds(model, T, x)[2]

    @test 1.0 == @inferred MOIU.get_bounds(model, T, y_v)[1]
    @test Inf == @inferred MOIU.get_bounds(model, T, y_v)[2]

    @test -Inf == @inferred MOIU.get_bounds(model, T, z_v)[1]
    @test -1.0 == @inferred MOIU.get_bounds(model, T, z_v)[2]

    @test -2.0 == @inferred MOIU.get_bounds(model, T, w_v)[1]
    @test 3.0 == @inferred MOIU.get_bounds(model, T, w_v)[2]

    @test 0.0 == @inferred MOIU.get_bounds(model, T, u_v)[1]
    @test 3.5 == @inferred MOIU.get_bounds(model, T, u_v)[2]

    @test -1.0 == @inferred MOIU.get_bounds(model, T, v_v)[1]
    @test 2.5 == @inferred MOIU.get_bounds(model, T, v_v)[2]

    @test 1.35 == @inferred MOIU.get_bounds(model, T, e_v)[1]
    @test 1.35 == @inferred MOIU.get_bounds(model, T, e_v)[2]

    MOI.add_constraint(model, y_v, MOI.LessThan{T}(3.6))

    @test 1.0 == @inferred MOIU.get_bounds(model, T, y_v)[1]
    @test 3.6 == @inferred MOIU.get_bounds(model, T, y_v)[2]
    return
end

function test_get_bounds_UInt128()
    T = UInt128
    model = MOIU.Model{T}()

    x = MOI.add_variable(model)
    y_v, y_c = MOI.add_constrained_variable(model, MOI.GreaterThan{T}(1))
    z_v, z_c = MOI.add_constrained_variable(model, MOI.LessThan{T}(1))
    w_v, w_c = MOI.add_constrained_variable(model, MOI.Interval{T}(2, 3))
    u_v, u_c = MOI.add_constrained_variable(model, MOI.Semicontinuous{T}(1, 3))
    v_v, v_c = MOI.add_constrained_variable(model, MOI.Semiinteger{T}(4, 7))

    @test typemin(T) == @inferred MOIU.get_bounds(model, T, x)[1]
    @test typemax(T) == @inferred MOIU.get_bounds(model, T, x)[2]

    @test 1 == @inferred MOIU.get_bounds(model, T, y_v)[1]
    @test typemax(T) == @inferred MOIU.get_bounds(model, T, y_v)[2]

    @test typemin(T) == @inferred MOIU.get_bounds(model, T, z_v)[1]
    @test 1 == @inferred MOIU.get_bounds(model, T, z_v)[2]

    @test 2 == @inferred MOIU.get_bounds(model, T, w_v)[1]
    @test 3 == @inferred MOIU.get_bounds(model, T, w_v)[2]

    @test 0 == @inferred MOIU.get_bounds(model, T, u_v)[1]
    @test 3 == @inferred MOIU.get_bounds(model, T, u_v)[2]

    @test 0 == @inferred MOIU.get_bounds(model, T, v_v)[1]
    @test 7 == @inferred MOIU.get_bounds(model, T, v_v)[2]

    MOI.add_constraint(model, y_v, MOI.LessThan{T}(5))

    @test 1 == @inferred MOIU.get_bounds(model, T, y_v)[1]
    @test 5 == @inferred MOIU.get_bounds(model, T, y_v)[2]
end

function test_get_bounds_scalar_affine()
    model = MOI.Utilities.Model{Float64}()
    x, _ = MOI.add_constrained_variable(model, MOI.Interval(1.0, 2.0))
    y = MOI.add_variable(model)
    z, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
    cache = Dict{MOI.VariableIndex,NTuple{2,Float64}}()
    @test MOI.Utilities.get_bounds(model, cache, x) == (1.0, 2.0)
    @test MOI.Utilities.get_bounds(model, cache, y) == nothing
    @test MOI.Utilities.get_bounds(model, cache, z) == (0.0, 1.0)
    @test MOI.Utilities.get_bounds(model, cache, 2.0 * x + 1.0) == (3.0, 5.0)
    @test MOI.Utilities.get_bounds(model, cache, 2.0 * x + x) == (3.0, 6.0)
    @test MOI.Utilities.get_bounds(model, cache, x - 2.0 * x) == (-2.0, -1.0)
    @test MOI.Utilities.get_bounds(model, cache, -1.0 * x) == (-2.0, -1.0)
    @test MOI.Utilities.get_bounds(model, cache, 1.5 * x + z) == (1.5, 4.0)
    @test MOI.Utilities.get_bounds(model, cache, -1.0 * y) == nothing
    @test MOI.Utilities.get_bounds(model, cache, 1.0 * x + y) == nothing
    MOI.add_constraint(model, y, MOI.GreaterThan(2.0))
    @test MOI.Utilities.get_bounds(model, cache, y) == nothing
    MOI.add_constraint(model, y, MOI.LessThan(3.0))
    @test MOI.Utilities.get_bounds(model, cache, y) == (2.0, 3.0)
    return
end

end  # module

TestVariables.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Hygiene

using Test

import MathOptInterface as MOI

# Dict is used in the @model macro but setting Dict in the outer scope
# should not affect it
Dict = nothing

MOI.Utilities.@model(
    LPModel,                      # Name of model
    (),                                                         # untyped scalar sets
    (MOI.EqualTo, MOI.GreaterThan, MOI.LessThan, MOI.Interval), #   typed scalar sets
    (MOI.Zeros, MOI.Nonnegatives, MOI.Nonpositives),            # untyped vector sets
    (),                                                         #   typed vector sets
    (),                                                         # untyped scalar functions
    (MOI.ScalarAffineFunction,),                                #   typed scalar functions
    (MOI.VectorOfVariables,),                                   # untyped vector functions
    (MOI.VectorAffineFunction,)
)                                #   typed vector functions

model = LPModel{Float64}()

@test model isa MOI.ModelLike
@test model isa MOI.Utilities.AbstractModel{Float64}

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableVectorize

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_get_scalar_constraint()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    x, cx = MOI.add_constrained_variable(bridged_mock, MOI.GreaterThan(1.0))
    func = 2.0 * x
    set = MOI.GreaterThan(5.0)
    err =
        MOI.ScalarFunctionConstantNotZero{Float64,typeof(func),typeof(set)}(1.0)
    @test_throws err MOI.add_constraint(bridged_mock, func + 1.0, set)

    c = MOI.add_constraint(bridged_mock, func, set)
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), c) ≈ func
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), c) == set
    MOI.set(bridged_mock, MOI.ConstraintName(), c, "c")

    @testset "Mock model" begin
        MOI.set(
            mock,
            MOI.VariableName(),
            MOI.get(mock, MOI.ListOfVariableIndices()),
            ["y"],
        )
        MOI.set(
            mock,
            MOI.ConstraintName(),
            MOI.get(
                mock,
                MOI.ListOfConstraintIndices{
                    MOI.VectorOfVariables,
                    MOI.Nonnegatives,
                }(),
            ),
            ["cy"],
        )
        s = """
        variables: y
        cy: [y] in Nonnegatives(1)
        c: 2.0y >= 3.0
        """
        model = MOI.Utilities.Model{Float64}()
        MOI.Utilities.loadfromstring!(model, s)
        MOI.Test.util_test_models_equal(mock, model, ["y"], ["cy", "c"])
    end
    @testset "Bridged model" begin
        MOI.set(bridged_mock, MOI.VariableName(), x, "x")
        s = """
        variables: x
        x >= 1.0
        c: 2.0x >= 5.0
        """
        model = MOI.Utilities.Model{Float64}()
        MOI.Utilities.loadfromstring!(model, s)
        MOI.Test.util_test_models_equal(
            bridged_mock,
            model,
            ["x"],
            ["c"],
            [("x", MOI.GreaterThan{Float64}(1.0))],
        )
    end
end

function test_exp3_with_add_constrained_variable_y()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [log(5), 0.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [0.0],
            (MOI.VectorAffineFunction{Float64}, MOI.ExponentialCone) =>
                [[-1.0, log(5) - 1, 1 / 5]],
        )

    MOI.empty!(bridged_mock)
    x = MOI.add_variable(bridged_mock)
    @test MOI.get(bridged_mock, MOI.NumberOfVariables()) == 1
    xc = MOI.add_constraint(bridged_mock, 2.0x, MOI.LessThan(4.0))
    y, yc = MOI.add_constrained_variable(bridged_mock, MOI.LessThan(5.0))
    @test yc.value == y.value == -1
    @test MOI.get(bridged_mock, MOI.NumberOfVariables()) == 2
    @test length(MOI.get(bridged_mock, MOI.ListOfVariableIndices())) == 2
    @test Set(MOI.get(bridged_mock, MOI.ListOfVariableIndices())) == Set([x, y])
    ec = MOI.add_constraint(
        bridged_mock,
        MOI.Utilities.operate(vcat, Float64, x, 1.0, y),
        MOI.ExponentialCone(),
    )

    MOI.optimize!(bridged_mock)
    @test MOI.get(bridged_mock, MOI.VariablePrimal(), x) ≈ log(5)
    @test MOI.get(bridged_mock, MOI.VariablePrimal(), y) ≈ 5.0
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), xc) ≈ 2log(5)
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), yc) ≈ 5
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), ec) ≈ [log(5), 1.0, 5.0]
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), xc) ≈ 0.0
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), yc) ≈ -1 / 5
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), ec) ≈
          [-1.0, log(5) - 1, 1 / 5]

    err = MOI.AddConstraintNotAllowed{MOI.VariableIndex,MOI.LessThan{Float64}}(
        "Cannot add two `VariableIndex`-in-`MathOptInterface.LessThan{Float64}`" *
        " on the same variable MOI.VariableIndex(-1).",
    )
    @test_throws err MOI.add_constraint(bridged_mock, y, MOI.LessThan(4.0))

    cis = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.ExponentialCone,
        }(),
    )
    @test length(cis) == 1

    err = ArgumentError(
        "Variable bridge of type `$(MOI.Bridges.Variable.VectorizeBridge{Float64,MOI.Nonpositives})`" *
        " does not support accessing the attribute `$(MOI.Test.UnknownVariableAttribute())`.",
    )
    @test_throws err MOI.get(
        bridged_mock,
        MOI.Test.UnknownVariableAttribute(),
        y,
    )
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}}(y.value)
    attr = MOI.ConstraintSet()
    err = MOI.SetAttributeNotAllowed(
        attr,
        "The variable `MOI.VariableIndex(12345676)` is bridged by the `VectorizeBridge`.",
    )
    @test_throws err MOI.set(bridged_mock, attr, ci, MOI.LessThan(4.0))

    change = MOI.MultirowChange(y, [(3, 0.0)])
    message =
        "The change $change" *
        " contains variables bridged into a function with nonzero constant."
    err = MOI.ModifyConstraintNotAllowed(cis[1], change, message)
    @test_throws err MOI.modify(bridged_mock, cis[1], change)

    change = MOI.ScalarCoefficientChange(y, 0.0)
    attr = MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}()
    message =
        "The change MathOptInterface.ScalarCoefficientChange{Float64}(MOI.VariableIndex(-1), 0.0)" *
        " contains variables bridged into a function with nonzero constant."
    err = MOI.ModifyObjectiveNotAllowed(change, message)
    @test_throws err MOI.modify(bridged_mock, attr, change)

    MOI.set(bridged_mock, MOI.VariableName(), x, "x")
    MOI.set(bridged_mock, MOI.ConstraintName(), xc, "xc")
    MOI.set(bridged_mock, MOI.ConstraintName(), ec, "ec")
    z = MOI.get(mock, MOI.ListOfVariableIndices())[2]

    MOI.set(mock, MOI.VariableName(), z, "z")
    MOI.set(
        mock,
        MOI.ConstraintName(),
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.Nonpositives,
            }(),
        ),
        ["zc"],
    )
    s = """
    variables: x, z
    zc: [z] in Nonpositives(1)
    xc: 2.0x <= 4.0
    ec: [x, 1.0, z + 5.0] in ExponentialCone()
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(mock, model, ["x", "z"], ["zc", "xc", "ec"])

    MOI.set(bridged_mock, MOI.VariableName(), y, "y")
    s = """
    variables: x, y
    y <= 5.0
    xc: 2.0x <= 4.0
    ec: [x, 1.0, y] in ExponentialCone()
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        ["x", "y"],
        ["xc", "ec"],
        [("y", MOI.LessThan{Float64}(5.0))],
    )

    @test MOI.supports(
        bridged_mock,
        MOI.VariablePrimalStart(),
        MOI.VariableIndex,
    )
    @test MOI.supports(
        bridged_mock,
        MOI.VariablePrimalStart(),
        typeof(MOI.Bridges.bridge(bridged_mock, y)),
    )
    MOI.set(bridged_mock, MOI.VariablePrimalStart(), y, 1.0)
    @test MOI.get(mock, MOI.VariablePrimalStart(), z) == -4
    @test MOI.get(bridged_mock, MOI.VariablePrimalStart(), y) == 1
    return
end

function test_delete_variable()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.Vectorize{Float64}(inner)
    x, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(1.0))
    @test_throws MOI.DeleteNotAllowed{MOI.VariableIndex} MOI.delete(model, x)
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.VectorizeBridge,
        """
        constrainedvariable: x in GreaterThan(2.0)
        minobjective: 1.0 * x
        c: 2.0 * x <= 1.0
        """,
        """
        constrainedvariable: [x] in Nonnegatives(1)
        minobjective: 2.0 + 1.0 * x
        c: 2.0 * x <= -3.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.VectorizeBridge,
        """
        constrainedvariable: x in LessThan(2.0)
        minobjective: 1.0 * x
        c: 2.0 * x <= 1.0
        """,
        """
        constrainedvariable: [x] in Nonpositives(1)
        minobjective: 2.0 + 1.0 * x
        c: 2.0 * x <= -3.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.VectorizeBridge,
        """
        constrainedvariable: x in EqualTo(2.0)
        minobjective: 1.0 * x
        c: 2.0 * x <= 1.0
        """,
        """
        constrainedvariable: [x] in Zeros(1)
        minobjective: 2.0 + 1.0 * x
        c: 2.0 * x <= -3.0
        """,
    )
    return
end

function test_list_of_constraint_indices()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.Vectorize{Float64}(inner)
    x, _ = MOI.add_constrained_variable(model, MOI.EqualTo(1.0))
    attr = MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Zeros}()
    @test isempty(MOI.get(model, attr))
    return
end

function test_variable_primal_ray()
    inner = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Bridges.Variable.Vectorize{Float64}(inner)
    x, _ = MOI.add_constrained_variable(model, MOI.EqualTo(1.0))
    MOI.set(inner, MOI.PrimalStatus(), MOI.INFEASIBILITY_CERTIFICATE)
    y = only(MOI.get(inner, MOI.ListOfVariableIndices()))
    MOI.set(inner, MOI.VariablePrimal(), y, 1.23)
    @test MOI.get(model, MOI.VariablePrimal(), x) == 1.23
    MOI.set(inner, MOI.PrimalStatus(), MOI.FEASIBLE_POINT)
    @test MOI.get(model, MOI.VariablePrimal(), x) == 2.23
    return
end

end  # module

TestVariableVectorize.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintIndicatorActiveOnFalse

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

"""
    test_indicator_activate_on_zero()

Linear problem with indicator constraint, similar to indicator1_test with
reversed z1.
```
max  2x1 + 3x2
s.t. x1 + x2 <= 10
     z1 == 0 ==> x2 <= 8
     z2 == 1 ==> x2 + x1/5 <= 9
     (1-z1) + z2 >= 1 <=> z2 - z1 >= 0
```
"""
function test_indicator_activate_on_zero()
    model = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    x1 = MOI.add_variable(model)
    x2 = MOI.add_variable(model)
    z1 = MOI.add_variable(model)
    z2 = MOI.add_variable(model)
    vc1 = MOI.add_constraint(model, z1, MOI.ZeroOne())
    @test vc1.value == z1.value
    vc2 = MOI.add_constraint(model, z2, MOI.ZeroOne())
    @test vc2.value == z2.value
    f1 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, z1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(1.0, x2)),
        ],
        [0.0, 0.0],
    )
    iset1 = MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.LessThan(8.0))
    BT = MOI.Bridges.Constraint.concrete_bridge_type(
        MOI.Bridges.Constraint.IndicatorActiveOnFalseBridge{Float64},
        typeof(f1),
        typeof(iset1),
    )
    BT2 = MOI.Bridges.Constraint.concrete_bridge_type(
        MOI.Bridges.Constraint.IndicatorActiveOnFalseBridge,
        typeof(f1),
        typeof(iset1),
    )
    bridge = MOI.Bridges.Constraint.bridge_constraint(BT, model, f1, iset1)
    @test BT === BT2
    @test bridge isa BT
    z1comp = bridge.variable
    @test MOI.get(model, MOI.ConstraintFunction(), bridge.zero_one_cons) ==
          z1comp
    @test MOI.get(model, MOI.ConstraintSet(), bridge.disjunction_cons) ==
          MOI.EqualTo(1.0)
    disjunction_cons =
        MOI.get(model, MOI.ConstraintFunction(), bridge.disjunction_cons)
    for t in disjunction_cons.terms
        @test t.variable == z1 || t.variable == z1comp
        @test t.coefficient ≈ 1.0
    end
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorActiveOnFalseBridge,
        """
        variables: x, z
        [z, 2.0 * x] in Indicator{ACTIVATE_ON_ZERO}(LessThan(2.0))
        z in ZeroOne()
        """,
        """
        variables: x, z, y
        [y, 2.0 * x] in Indicator{ACTIVATE_ON_ONE}(LessThan(2.0))
        z + y == 1.0
        z in ZeroOne()
        y in ZeroOne()
        """,
    )
    return
end

end  # module

TestConstraintIndicatorActiveOnFalse.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintGeomeanToPower

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_dimension_5()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GeoMeanToPowerBridge,
        """
        variables: t, x1, x2, x3, x4
        [t, x1, x2, x3, x4] in GeometricMeanCone(5)
        """,
        """
        variables: t, x1, x2, x3, x4
        constrainedvariable: [y1, y2] in Nonnegatives(2)
        [x1, y1, t] in PowerCone(0.25)
        [x2, y2, y1] in PowerCone(0.3333333333333333)
        [x3, x4, y2] in PowerCone(0.5)
        """,
    )
    return
end

function test_runtests_dimension_4()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GeoMeanToPowerBridge,
        """
        variables: a, t, x1, x2, x3
        [t, x1, x2, x3] in GeometricMeanCone(4)
        [a] in Nonnegatives(1)
        """,
        """
        variables: a, t, x1, x2, x3
        constrainedvariable: [y] in Nonnegatives(1)
        [a] in Nonnegatives(1)
        [x1, y, t] in PowerCone(0.3333333333333333)
        [x2, x3, y] in PowerCone(0.5)
        """,
    )
    return
end

function test_runtests_dimension_3()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GeoMeanToPowerBridge,
        """
        variables: a, t, x1, x2
        [t, x1, x2] in GeometricMeanCone(3)
        [a] in Nonnegatives(1)
        """,
        """
        variables: a, t, x1, x2
        [x1, x2, t] in PowerCone(0.5)
        [a] in Nonnegatives(1)
        """,
    )
    return
end

function test_runtests_dimension_2()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GeoMeanToPowerBridge,
        """
        variables: a, t, x1
        [t, x1] in GeometricMeanCone(2)
        [a] in Nonnegatives(1)
        """,
        """
        variables: a, t, x1
        [x1, x1, t] in PowerCone(0.5)
        [a] in Nonnegatives(1)
        """,
    )
    return
end

end  # module

TestConstraintGeomeanToPower.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

function _create_binary_switch(ids, exprs)
    if length(exprs) <= 3
        out = Expr(:if, Expr(:call, :(==), :id, ids[1]), exprs[1])
        if length(exprs) > 1
            push!(out.args, _create_binary_switch(ids[2:end], exprs[2:end]))
        end
        return out
    end
    mid = length(exprs) >>> 1
    return Expr(
        :if,
        Expr(:call, :(<=), :id, ids[mid]),
        _create_binary_switch(ids[1:mid], exprs[1:mid]),
        _create_binary_switch(ids[(mid+1):end], exprs[(mid+1):end]),
    )
end

function _generate_eval_univariate()
    exprs = map(SYMBOLIC_UNIVARIATE_EXPRESSIONS) do arg
        return :(return $(arg[1])(x), $(arg[2]))
    end
    return _create_binary_switch(1:length(exprs), exprs)
end

@eval @inline function _eval_univariate(id, x::T) where {T}
    $(_generate_eval_univariate())
    return error("Invalid id for univariate operator: $id")
end

function _generate_eval_univariate_2nd_deriv()
    exprs = map(arg -> :(return $(arg[3])), SYMBOLIC_UNIVARIATE_EXPRESSIONS)
    return _create_binary_switch(1:length(exprs), exprs)
end

@eval @inline function _eval_univariate_2nd_deriv(id, x::T) where {T}
    $(_generate_eval_univariate_2nd_deriv())
    return error("Invalid id for univariate operator: $id")
end

struct _UnivariateOperator{F,F′,F′′}
    f::F
    f′::F′
    f′′::F′′
    function _UnivariateOperator(
        f::Function,
        f′::Function,
        f′′::Union{Nothing,Function} = nothing,
    )
        return new{typeof(f),typeof(f′),typeof(f′′)}(f, f′, f′′)
    end
end

function eval_univariate_function(operator::_UnivariateOperator, x::T) where {T}
    ret = operator.f(x)
    check_return_type(T, ret)
    return ret::T
end

function eval_univariate_gradient(operator::_UnivariateOperator, x::T) where {T}
    ret = operator.f′(x)
    check_return_type(T, ret)
    return ret::T
end

function eval_univariate_hessian(operator::_UnivariateOperator, x::T) where {T}
    ret = operator.f′′(x)
    check_return_type(T, ret)
    return ret::T
end

function eval_univariate_function_and_gradient(
    operator::_UnivariateOperator,
    x::T,
) where {T}
    ret_f = eval_univariate_function(operator, x)
    ret_f′ = eval_univariate_gradient(operator, x)
    return ret_f, ret_f′
end

struct _MultivariateOperator{F,F′,F′′}
    N::Int
    f::F
    ∇f::F′
    ∇²f::F′′
    function _MultivariateOperator{N}(
        f::Function,
        ∇f::Function,
        ∇²f::Union{Nothing,Function} = nothing,
    ) where {N}
        return new{typeof(f),typeof(∇f),typeof(∇²f)}(N, f, ∇f, ∇²f)
    end
end

"""
    DEFAULT_UNIVARIATE_OPERATORS

The list of univariate operators that are supported by default.

## Example

```jldoctest
julia> MOI.Nonlinear.DEFAULT_UNIVARIATE_OPERATORS
73-element Vector{Symbol}:
 :+
 :-
 :abs
 :sign
 :sqrt
 :cbrt
 :abs2
 :inv
 :log
 :log10
 ⋮
 :airybi
 :airyaiprime
 :airybiprime
 :besselj0
 :besselj1
 :bessely0
 :bessely1
 :erfcx
 :dawson
```
"""
const DEFAULT_UNIVARIATE_OPERATORS = first.(SYMBOLIC_UNIVARIATE_EXPRESSIONS)

"""
    DEFAULT_MULTIVARIATE_OPERATORS

The list of multivariate operators that are supported by default.

## Example

```jldoctest
julia> MOI.Nonlinear.DEFAULT_MULTIVARIATE_OPERATORS
9-element Vector{Symbol}:
 :+
 :-
 :*
 :^
 :/
 :ifelse
 :atan
 :min
 :max
```
"""
const DEFAULT_MULTIVARIATE_OPERATORS =
    [:+, :-, :*, :^, :/, :ifelse, :atan, :min, :max]

"""
    OperatorRegistry()

Create a new `OperatorRegistry` to store and evaluate univariate and
multivariate operators.
"""
struct OperatorRegistry
    # NODE_CALL_UNIVARIATE
    univariate_operators::Vector{Symbol}
    univariate_operator_to_id::Dict{Symbol,Int}
    univariate_user_operator_start::Int
    registered_univariate_operators::Vector{_UnivariateOperator}
    # NODE_CALL_MULTIVARIATE
    multivariate_operators::Vector{Symbol}
    multivariate_operator_to_id::Dict{Symbol,Int}
    multivariate_user_operator_start::Int
    registered_multivariate_operators::Vector{_MultivariateOperator}
    # NODE_LOGIC
    logic_operators::Vector{Symbol}
    logic_operator_to_id::Dict{Symbol,Int}
    # NODE_COMPARISON
    comparison_operators::Vector{Symbol}
    comparison_operator_to_id::Dict{Symbol,Int}
    function OperatorRegistry()
        univariate_operators = copy(DEFAULT_UNIVARIATE_OPERATORS)
        multivariate_operators = copy(DEFAULT_MULTIVARIATE_OPERATORS)
        logic_operators = [:&&, :||]
        comparison_operators = [:<=, :(==), :>=, :<, :>]
        return new(
            # NODE_CALL_UNIVARIATE
            univariate_operators,
            Dict{Symbol,Int}(
                op => i for (i, op) in enumerate(univariate_operators)
            ),
            length(univariate_operators),
            _UnivariateOperator[],
            # NODE_CALL
            multivariate_operators,
            Dict{Symbol,Int}(
                op => i for (i, op) in enumerate(multivariate_operators)
            ),
            length(multivariate_operators),
            _MultivariateOperator[],
            # NODE_LOGIC
            logic_operators,
            Dict{Symbol,Int}(op => i for (i, op) in enumerate(logic_operators)),
            # NODE_COMPARISON
            comparison_operators,
            Dict{Symbol,Int}(
                op => i for (i, op) in enumerate(comparison_operators)
            ),
        )
    end
end

function MOI.get(
    registry::OperatorRegistry,
    ::MOI.ListOfSupportedNonlinearOperators,
)
    ops = vcat(
        registry.univariate_operators,
        registry.multivariate_operators,
        registry.logic_operators,
        registry.comparison_operators,
    )
    return unique(ops)
end

const _FORWARD_DIFF_METHOD_ERROR_HELPER = raw"""
Common reasons for this include:

 * The function takes `f(x::Vector)` as input, instead of the splatted
   `f(x...)`.
 * The function assumes `Float64` will be passed as input, it must work for any
   generic `Real` type.
 * The function allocates temporary storage using `zeros(3)` or similar. This
   defaults to `Float64`, so use `zeros(T, 3)` instead.

As examples, instead of:
```julia
my_function(x::Vector) = sum(x.^2)
```
use:
```julia
my_function(x::T...) where {T<:Real} = sum(x[i]^2 for i in 1:length(x))
```

Instead of:
```julia
function my_function(x::Float64...)
    y = zeros(length(x))
    for i in 1:length(x)
        y[i] = x[i]^2
    end
    return sum(y)
end
```
use:
```julia
function my_function(x::T...) where {T<:Real}
    y = zeros(T, length(x))
    for i in 1:length(x)
        y[i] = x[i]^2
    end
    return sum(y)
end
```

Review the stacktrace below for more information, but it can often be hard to
understand why and where your function is failing. You can also debug this
outside of JuMP as follows:
```julia
import ForwardDiff

# If the input dimension is 1
x = 1.0
my_function(a) = a^2
ForwardDiff.derivative(my_function, x)

# If the input dimension is more than 1
x = [1.0, 2.0]
my_function(a, b) = a^2 + b^2
ForwardDiff.gradient(x -> my_function(x...), x)
```
"""

_intercept_ForwardDiff_MethodError(err, ::Symbol) = rethrow(err)

function _intercept_ForwardDiff_MethodError(::MethodError, op::Symbol)
    return error(
        "JuMP's autodiff of the user-defined function $(op) failed with a " *
        "MethodError.\n\n$(_FORWARD_DIFF_METHOD_ERROR_HELPER)",
    )
end

function _checked_derivative(f::F, op::Symbol) where {F}
    return function (x)
        try
            return ForwardDiff.derivative(f, x)
        catch err
            _intercept_ForwardDiff_MethodError(err, op)
        end
    end
end

"""
    _validate_register_assumptions(
        f::Function,
        name::Symbol,
        dimension::Integer,
    )

A function that attempts to check if `f` is suitable for registration via
[`register`](@ref) and throws an informative error if it is not.

Because we don't know the domain of `f`, this function may encounter false
negatives. But it should catch the majority of cases in which users supply
non-differentiable functions that rely on `::Float64` assumptions.
"""
function _validate_register_assumptions(
    f::Function,
    name::Symbol,
    dimension::Integer,
)
    # Assumption 1: check that `f` can be called with `Float64` arguments.
    y = 0.0
    try
        if dimension == 1
            y = f(0.0)
        else
            y = f(zeros(dimension)...)
        end
    catch
        # We hit some other error, perhaps we called a function like log(-1).
        # Ignore for now, and hope that a useful error is shown to the user
        # during the solve.
    end
    if !(y isa Real)
        error(
            "Expected return type of `Float64` from the user-defined " *
            "function :$(name), but got `$(typeof(y))`.",
        )
    end
    # Assumption 2: check that `f` can be differentiated using `ForwardDiff`.
    try
        if dimension == 1
            ForwardDiff.derivative(f, 0.0)
        else
            ForwardDiff.gradient(x -> f(x...), zeros(dimension))
        end
    catch err
        if err isa MethodError
            error(
                "Unable to register the function :$name.\n\n" *
                _FORWARD_DIFF_METHOD_ERROR_HELPER,
            )
        end
        # We hit some other error, perhaps we called a function like log(-1).
        # Ignore for now, and hope that a useful error is shown to the user
        # during the solve.
    end
    return
end

function _UnivariateOperator(op::Symbol, f::Function)
    _validate_register_assumptions(f, op, 1)
    f′ = _checked_derivative(f, op)
    return _UnivariateOperator(op, f, f′)
end

function _UnivariateOperator(op::Symbol, f::Function, f′::Function)
    try
        _validate_register_assumptions(f′, op, 1)
        f′′ = _checked_derivative(f′, op)
        return _UnivariateOperator(f, f′, f′′)
    catch
        return _UnivariateOperator(f, f′, nothing)
    end
end

function _UnivariateOperator(::Symbol, f::Function, f′::Function, f′′::Function)
    return _UnivariateOperator(f, f′, f′′)
end

function _MultivariateOperator{N}(op::Symbol, f::Function) where {N}
    _validate_register_assumptions(f, op, N)
    g = x -> f(x...)
    ∇f = function (ret, x)
        try
            ForwardDiff.gradient!(ret, g, x)
        catch err
            _intercept_ForwardDiff_MethodError(err, op)
        end
        return
    end
    return _MultivariateOperator{N}(g, ∇f)
end

function _MultivariateOperator{N}(::Symbol, f::Function, ∇f::Function) where {N}
    return _MultivariateOperator{N}(x -> f(x...), (g, x) -> ∇f(g, x...))
end

function _MultivariateOperator{N}(
    ::Symbol,
    f::Function,
    ∇f::Function,
    ∇²f::Function,
) where {N}
    return _MultivariateOperator{N}(
        x -> f(x...),
        (g, x) -> ∇f(g, x...),
        (H, x) -> ∇²f(H, x...),
    )
end

function register_operator(
    registry::OperatorRegistry,
    op::Symbol,
    nargs::Int,
    f::Function...,
)
    if nargs == 1
        if haskey(registry.univariate_operator_to_id, op)
            error("Operator $op is already registered.")
        elseif haskey(registry.multivariate_operator_to_id, op)
            error("Operator $op is already registered.")
        end
        operator = _UnivariateOperator(op, f...)
        push!(registry.univariate_operators, op)
        push!(registry.registered_univariate_operators, operator)
        registry.univariate_operator_to_id[op] =
            length(registry.univariate_operators)
    else
        if haskey(registry.multivariate_operator_to_id, op)
            error("Operator $op is already registered.")
        elseif haskey(registry.univariate_operator_to_id, op)
            error("Operator $op is already registered.")
        end
        operator = _MultivariateOperator{nargs}(op, f...)
        push!(registry.multivariate_operators, op)
        push!(registry.registered_multivariate_operators, operator)
        registry.multivariate_operator_to_id[op] =
            length(registry.multivariate_operators)
    end
    return
end

function _is_registered(registry::OperatorRegistry, op::Symbol, nargs::Int)
    if op in (:<=, :>=, :(==), :<, :>, :&&, :||)
        return true
    end
    if nargs == 1 && haskey(registry.univariate_operator_to_id, op)
        return true
    end
    return haskey(registry.multivariate_operator_to_id, op)
end

function _warn_auto_register(op::Symbol, nargs::Int)
    @warn("""Function $op automatically registered with $nargs arguments.

    Calling the function with a different number of arguments will result in an
    error.

    While you can safely ignore this warning, we recommend that you manually
    register the function as follows:
    ```Julia
    model = Model()
    register(model, :$op, $nargs, $op; autodiff = true)
    ```""")
    return
end

"""
    register_operator_if_needed(
        registry::OperatorRegistry,
        op::Symbol,
        nargs::Int,
        f::Function;
    )

Similar to [`register_operator`](@ref), but this function warns if the function
is not registered, and skips silently if it already is.
"""
function register_operator_if_needed(
    registry::OperatorRegistry,
    op::Symbol,
    nargs::Int,
    f::Function,
)
    if !_is_registered(registry, op, nargs)
        register_operator(registry, op, nargs, f)
        _warn_auto_register(op, nargs)
    end
    return
end

"""
    assert_registered(registry::OperatorRegistry, op::Symbol, nargs::Int)

Throw an error if `op` is not registered in `registry` with `nargs` arguments.
"""
function assert_registered(registry::OperatorRegistry, op::Symbol, nargs::Int)
    if !_is_registered(registry, op, nargs)
        msg = """
        Unrecognized function \"$(op)\" used in nonlinear expression.

        You must register it as a user-defined function before building
        the model. For example, replacing `N` with the appropriate number
        of arguments, do:
        ```julia
        model = Model()
        register(model, :$(op), N, $(op), autodiff=true)
        # ... variables and constraints ...
        ```
        """
        error(msg)
    end
    return
end

"""
    check_return_type(::Type{T}, ret::S) where {T,S}

Overload this method for new types `S` to throw an informative error if a
user-defined function returns the type `S` instead of `T`.
"""
check_return_type(::Type{T}, ret::T) where {T} = nothing

function check_return_type(::Type{T}, ret) where {T}
    return error(
        "Expected return type of $T from a user-defined function, but got " *
        "$(typeof(ret)).",
    )
end

"""
    eval_univariate_function(
        registry::OperatorRegistry,
        op::Union{Symbol,Integer},
        x::T,
    ) where {T}

Evaluate the operator `op(x)::T`, where `op` is a univariate function in
`registry`.

If `op isa Integer`, then `op` is the index in
`registry.univariate_operators[op]`.

## Example

```jldoctest
julia> r = MOI.Nonlinear.OperatorRegistry();

julia> MOI.Nonlinear.eval_univariate_function(r, :abs, -1.2)
1.2

julia> r.univariate_operators[3]
:abs

julia> MOI.Nonlinear.eval_univariate_function(r, 3, -1.2)
1.2
```
"""
function eval_univariate_function(
    registry::OperatorRegistry,
    op::Symbol,
    x::T,
) where {T}
    id = registry.univariate_operator_to_id[op]
    return eval_univariate_function(registry, id, x)
end

function eval_univariate_function(
    registry::OperatorRegistry,
    id::Integer,
    x::T,
) where {T}
    if id <= registry.univariate_user_operator_start
        f, _ = _eval_univariate(id, x)
        return f::T
    end
    offset = id - registry.univariate_user_operator_start
    operator = registry.registered_univariate_operators[offset]
    return eval_univariate_function(operator, x)
end

"""
    eval_univariate_gradient(
        registry::OperatorRegistry,
        op::Union{Symbol,Integer},
        x::T,
    ) where {T}

Evaluate the first-derivative of the operator `op(x)::T`, where `op` is a
univariate function in `registry`.

If `op isa Integer`, then `op` is the index in
`registry.univariate_operators[op]`.

## Example

```jldoctest
julia> r = MOI.Nonlinear.OperatorRegistry();

julia> MOI.Nonlinear.eval_univariate_gradient(r, :abs, -1.2)
-1.0

julia> r.univariate_operators[3]
:abs

julia> MOI.Nonlinear.eval_univariate_gradient(r, 3, -1.2)
-1.0
```
"""
function eval_univariate_gradient(
    registry::OperatorRegistry,
    op::Symbol,
    x::T,
) where {T}
    id = registry.univariate_operator_to_id[op]
    return eval_univariate_gradient(registry, id, x)
end

function eval_univariate_gradient(
    registry::OperatorRegistry,
    id::Integer,
    x::T,
) where {T}
    if id <= registry.univariate_user_operator_start
        _, f′ = _eval_univariate(id, x)
        return f′::T
    end
    offset = id - registry.univariate_user_operator_start
    operator = registry.registered_univariate_operators[offset]
    return eval_univariate_gradient(operator, x)
end

"""
    eval_univariate_function_and_gradient(
        registry::OperatorRegistry,
        op::Union{Symbol,Integer},
        x::T,
    )::Tuple{T,T} where {T}

Evaluate the function and first-derivative of the operator `op(x)::T`, where
`op` is a univariate function in `registry`.

If `op isa Integer`, then `op` is the index in
`registry.univariate_operators[op]`.

## Example

```jldoctest
julia> r = MOI.Nonlinear.OperatorRegistry();

julia> MOI.Nonlinear.eval_univariate_function_and_gradient(r, :abs, -1.2)
(1.2, -1.0)

julia> r.univariate_operators[3]
:abs

julia> MOI.Nonlinear.eval_univariate_function_and_gradient(r, 3, -1.2)
(1.2, -1.0)
```
"""
function eval_univariate_function_and_gradient(
    registry::OperatorRegistry,
    op::Symbol,
    x::T,
) where {T}
    id = registry.univariate_operator_to_id[op]
    return eval_univariate_function_and_gradient(registry, id, x)
end

function eval_univariate_function_and_gradient(
    registry::OperatorRegistry,
    id::Integer,
    x::T,
) where {T}
    if id <= registry.univariate_user_operator_start
        return _eval_univariate(id, x)::Tuple{T,T}
    end
    offset = id - registry.univariate_user_operator_start
    operator = registry.registered_univariate_operators[offset]
    return eval_univariate_function_and_gradient(operator, x)
end

"""
    eval_univariate_hessian(
        registry::OperatorRegistry,
        op::Union{Symbol,Integer},
        x::T,
    ) where {T}

Evaluate the second-derivative of the operator `op(x)::T`, where `op` is a
univariate function in `registry`.

If `op isa Integer`, then `op` is the index in
`registry.univariate_operators[op]`.

## Example

```jldoctest
julia> r = MOI.Nonlinear.OperatorRegistry();

julia> MOI.Nonlinear.eval_univariate_hessian(r, :sin, 1.0)
-0.8414709848078965

julia> r.univariate_operators[16]
:sin

julia> MOI.Nonlinear.eval_univariate_hessian(r, 16, 1.0)
-0.8414709848078965

julia> -sin(1.0)
-0.8414709848078965
```
"""
function eval_univariate_hessian(
    registry::OperatorRegistry,
    op::Symbol,
    x::T,
) where {T}
    id = registry.univariate_operator_to_id[op]
    return eval_univariate_hessian(registry, id, x)
end

function eval_univariate_hessian(
    registry::OperatorRegistry,
    id::Integer,
    x::T,
) where {T}
    if id <= registry.univariate_user_operator_start
        ret = _eval_univariate_2nd_deriv(id, x)
        if ret === nothing
            op = registry.univariate_operators[id]
            error("Hessian is not defined for operator $op")
        end
        return ret::T
    end
    offset = id - registry.univariate_user_operator_start
    operator = registry.registered_univariate_operators[offset]
    return eval_univariate_hessian(operator, x)
end

"""
    _nan_pow(x, y)

An alternative for `x^y` that avoids throwing an error in common situations like
`(-1.0)^1.5`. This optimization applies only to Float32 and Float64 inputs; if
a different type is provided as input we fallback to `x^y`.
"""
_nan_pow(x::T, y::T) where {T<:Union{Float32,Float64}} = pow(x, y)
_nan_pow(x, y) = x^y

"""
    eval_multivariate_function(
        registry::OperatorRegistry,
        op::Symbol,
        x::AbstractVector{T},
    ) where {T}

Evaluate the operator `op(x)::T`, where `op` is a multivariate function in
`registry`.
"""
function eval_multivariate_function(
    registry::OperatorRegistry,
    op::Symbol,
    x::AbstractVector{T},
)::T where {T}
    if op == :+
        return sum(x; init = zero(T))
    elseif op == :-
        @assert length(x) == 2
        return x[1] - x[2]
    elseif op == :*
        return prod(x; init = one(T))
    elseif op == :^
        @assert length(x) == 2
        # Use _nan_pow here to avoid throwing an error in common situations like
        # (-1.0)^1.5.
        return _nan_pow(x[1], x[2])
    elseif op == :/
        @assert length(x) == 2
        return x[1] / x[2]
    elseif op == :ifelse
        @assert length(x) == 3
        return ifelse(Bool(x[1]), x[2], x[3])
    elseif op == :atan
        @assert length(x) == 2
        return atan(x[1], x[2])
    elseif op == :min
        return minimum(x)
    elseif op == :max
        return maximum(x)
    end
    id = registry.multivariate_operator_to_id[op]
    offset = id - registry.multivariate_user_operator_start
    operator = registry.registered_multivariate_operators[offset]
    @assert length(x) == operator.N
    ret = operator.f(x)
    check_return_type(T, ret)
    return ret::T
end

"""
    eval_multivariate_gradient(
        registry::OperatorRegistry,
        op::Symbol,
        g::AbstractVector{T},
        x::AbstractVector{T},
    ) where {T}

Evaluate the gradient of operator `g .= ∇op(x)`, where `op` is a multivariate
function in `registry`.
"""
function eval_multivariate_gradient(
    registry::OperatorRegistry,
    op::Symbol,
    g::AbstractVector{T},
    x::AbstractVector{T},
) where {T}
    @assert length(g) == length(x)
    if op == :+
        fill!(g, one(T))
    elseif op == :-
        g[1] = one(T)
        g[2] = -one(T)
    elseif op == :*
        # Special case performance optimizations for common cases.
        if length(x) == 1
            g[1] = one(T)
        elseif length(x) == 2
            g[1] = x[2]
            g[2] = x[1]
        else
            total = prod(x)
            if iszero(total)
                for i in eachindex(x)
                    g[i] = prod(x[j] for j in eachindex(x) if i != j)
                end
            else
                for i in eachindex(x)
                    g[i] = total / x[i]
                end
            end
        end
    elseif op == :^
        @assert length(x) == 2
        if x[2] == one(T)
            g[1] = one(T)
        elseif x[2] == T(2)
            g[1] = T(2) * x[1]
        else
            g[1] = x[2] * _nan_pow(x[1], x[2] - one(T))
        end
        if x[1] > zero(T)
            g[2] = _nan_pow(x[1], x[2]) * log(x[1])
        else
            g[2] = T(NaN)
        end
    elseif op == :/
        @assert length(x) == 2
        g[1] = one(T) / x[2]
        g[2] = -x[1] / x[2]^2
    elseif op == :ifelse
        @assert length(x) == 3
        g[1] = zero(T)  # It doesn't matter what this is.
        g[2] = x[1] == one(T)
        g[3] = x[1] == zero(T)
    elseif op == :atan
        @assert length(x) == 2
        base = x[1]^2 + x[2]^2
        g[1] = x[2] / base
        g[2] = -x[1] / base
    elseif op == :min
        fill!(g, zero(T))
        _, i = findmin(x)
        g[i] = one(T)
    elseif op == :max
        fill!(g, zero(T))
        _, i = findmax(x)
        g[i] = one(T)
    else
        id = registry.multivariate_operator_to_id[op]
        offset = id - registry.multivariate_user_operator_start
        operator = registry.registered_multivariate_operators[offset]
        @assert length(x) == operator.N
        operator.∇f(g, x)
    end
    return
end

_nan_to_zero(x) = isnan(x) ? 0.0 : x

"""
    eval_multivariate_hessian(
        registry::OperatorRegistry,
        op::Symbol,
        H::AbstractMatrix,
        x::AbstractVector{T},
    )::Bool where {T}

Evaluate the Hessian of operator `∇²op(x)`, where `op` is a multivariate
function in `registry`.

The Hessian is stored in the lower-triangular part of the matrix `H`.

Returns a `Bool` indicating whether non-zeros were stored in the matrix.

!!! note
    Implementations of the Hessian operators will not fill structural zeros.
    Therefore, before calling this function you should pre-populate the matrix
    `H` with `0`.
"""
function eval_multivariate_hessian(
    registry::OperatorRegistry,
    op::Symbol,
    H,
    x::AbstractVector{T},
) where {T}
    if op in (:+, :-, :ifelse)
        return false
    end
    if op == :*
        # f(x)    = *(x[i] for i in 1:N)
        #
        # ∇fᵢ(x)  = *(x[j] for j in 1:N if i != j)
        #
        # ∇fᵢⱼ(x) = *(x[k] for k in 1:N if i != k & j != k)
        N = length(x)
        if N == 1
            # Hessian is zero
        elseif N == 2
            H[2, 1] = one(T)
        else
            for i in 1:N, j in (i+1):N
                H[j, i] =
                    prod(x[k] for k in 1:N if k != i && k != j; init = one(T))
            end
        end
    elseif op == :^
        # f(x)   = x[1]^x[2]
        #
        # ∇f(x)  = x[2]*x[1]^(x[2]-1)
        #          x[1]^x[2]*log(x[1])
        #
        # ∇²f(x) = x[2]*(x[2]-1)*x[1]^(x[2]-2)
        #          x[1]^(x[2]-1)*(x[2]*log(x[1])+1) x[1]^x[2]*log(x[1])^2
        ln = x[1] > 0 ? log(x[1]) : NaN
        if x[2] == one(T)
            H[2, 1] = _nan_to_zero(ln + one(T))
            H[2, 2] = _nan_to_zero(x[1] * ln^2)
        elseif x[2] == T(2)
            H[1, 1] = T(2)
            H[2, 1] = _nan_to_zero(x[1] * (T(2) * ln + one(T)))
            H[2, 2] = _nan_to_zero(ln^2 * x[1]^2)
        else
            H[1, 1] = _nan_to_zero(x[2] * (x[2] - 1) * _nan_pow(x[1], x[2] - 2))
            H[2, 1] = _nan_to_zero(_nan_pow(x[1], x[2] - 1) * (x[2] * ln + 1))
            H[2, 2] = _nan_to_zero(ln^2 * _nan_pow(x[1], x[2]))
        end
    elseif op == :/
        # f(x)  = x[1]/x[2]
        #
        # ∇f(x) = 1/x[2]
        #         -x[1]/x[2]^2
        #
        # ∇²(x) = 0.0
        #         -1/x[2]^2 2x[1]/x[2]^3
        d = 1 / x[2]^2
        H[2, 1] = -d
        H[2, 2] = 2 * x[1] * d / x[2]
    elseif op == :atan
        # f(x)  = atan(y, x)
        #
        # ∇f(x) = +x/(x^2+y^2)
        #         -y/(x^2+y^2)
        #
        # ∇²(x) = -(2xy)/(x^2+y^2)^2
        #         (y^2-x^2)/(x^2+y^2)^2 (2xy)/(x^2+y^2)^2
        base = (x[1]^2 + x[2]^2)^2
        H[1, 1] = -2 * x[2] * x[1] / base
        H[2, 1] = (x[1]^2 - x[2]^2) / base
        H[2, 2] = 2 * x[2] * x[1] / base
    elseif op == :min
        _, i = findmin(x)
        H[i, i] = one(T)
    elseif op == :max
        _, i = findmax(x)
        H[i, i] = one(T)
    else
        id = registry.multivariate_operator_to_id[op]
        offset = id - registry.multivariate_user_operator_start
        operator = registry.registered_multivariate_operators[offset]
        if operator.∇²f === nothing
            error("Hessian is not defined for operator $op")
        end
        @assert length(x) == operator.N
        operator.∇²f(H, x)
    end
    return true
end

"""
    eval_logic_function(
        registry::OperatorRegistry,
        op::Symbol,
        lhs::T,
        rhs::T,
    )::Bool where {T}

Evaluate `(lhs op rhs)::Bool`, where `op` is a logic operator in `registry`.
"""
function eval_logic_function(
    ::OperatorRegistry,
    op::Symbol,
    lhs::T,
    rhs::T,
)::Bool where {T}
    if op == :&&
        return lhs && rhs
    else
        @assert op == :||
        return lhs || rhs
    end
end

"""
    eval_comparison_function(
        registry::OperatorRegistry,
        op::Symbol,
        lhs::T,
        rhs::T,
    )::Bool where {T}

Evaluate `(lhs op rhs)::Bool`, where `op` is a comparison operator in
`registry`.
"""
function eval_comparison_function(
    ::OperatorRegistry,
    op::Symbol,
    lhs::T,
    rhs::T,
)::Bool where {T}
    if op == :<=
        return lhs <= rhs
    elseif op == :>=
        return lhs >= rhs
    elseif op == :(==)
        return lhs == rhs
    elseif op == :<
        return lhs < rhs
    else
        @assert op == :>
        return lhs > rhs
    end
end

# This method is implemented here because it needs the OperatorRegistry type from
# the Nonlinear, which doesn't exist when the Utilities submodule is defined.

function MOI.Utilities.eval_variables(
    value_fn::F,
    model::MOI.ModelLike,
    f::MOI.ScalarNonlinearFunction,
) where {F}
    registry = OperatorRegistry()
    return _evaluate_expr(registry, value_fn, model, f)
end

function _evaluate_expr(
    ::OperatorRegistry,
    value_fn::Function,
    model::MOI.ModelLike,
    f::MOI.AbstractFunction,
)
    return MOI.Utilities.eval_variables(value_fn, model, f)
end

function _evaluate_expr(
    ::OperatorRegistry,
    ::Function,
    ::MOI.ModelLike,
    f::Number,
)
    return f
end

function _evaluate_expr(
    registry::OperatorRegistry,
    value_fn::Function,
    model::MOI.ModelLike,
    expr::MOI.ScalarNonlinearFunction,
)
    op = expr.head
    if !_is_registered(registry, op, length(expr.args))
        udf = MOI.get(model, MOI.UserDefinedFunction(op, length(expr.args)))
        if udf === nothing
            throw(MOI.UnsupportedNonlinearOperator(op))
        end
        args = map(expr.args) do arg
            return _evaluate_expr(registry, value_fn, model, arg)
        end
        return first(udf)(args...)
    end
    if length(expr.args) == 1 && haskey(registry.univariate_operator_to_id, op)
        arg = _evaluate_expr(registry, value_fn, model, expr.args[1])
        return eval_univariate_function(registry, op, arg)
    elseif haskey(registry.multivariate_operator_to_id, op)
        args = map(expr.args) do arg
            return _evaluate_expr(registry, value_fn, model, arg)
        end
        return eval_multivariate_function(registry, op, args)
    elseif haskey(registry.logic_operator_to_id, op)
        @assert length(expr.args) == 2
        x = _evaluate_expr(registry, value_fn, model, expr.args[1])
        y = _evaluate_expr(registry, value_fn, model, expr.args[2])
        return eval_logic_function(registry, op, x, y)
    else
        @assert haskey(registry.comparison_operator_to_id, op)
        @assert length(expr.args) == 2
        x = _evaluate_expr(registry, value_fn, model, expr.args[1])
        y = _evaluate_expr(registry, value_fn, model, expr.args[2])
        return eval_comparison_function(registry, op, x, y)
    end
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# ==============================================================================
#
#   `Base.read!`
#
# Here is a template for an MPS file, reproduced from
# http://lpsolve.sourceforge.net/5.5/mps-format.htm.
#
# Field:    1           2          3         4         5         6
# Columns:  2-3        5-12      15-22     25-36     40-47     50-61
#           NAME   problem name
#           ROWS
#            type     name
#           COLUMNS
#                     column      row       value     row      value
#           RHS
#                     rhs         row       value     row      value
#           RANGES
#                     range       row       value     row      value
#           BOUNDS
#            type     bound       column    value
#           SOS
#            type     CaseName    SOSName   SOSpriority
#                     CaseName    VarName1  VarWeight1
#                     CaseName    VarName2  VarWeight2
#                     CaseName    VarNameN  VarWeightN
#           ENDATA
# ==============================================================================

@enum(Sense, SENSE_N, SENSE_G, SENSE_L, SENSE_E, SENSE_UNKNOWN)

function Sense(s)
    if s == "G"
        return SENSE_G
    elseif s == "L"
        return SENSE_L
    elseif s == "E"
        return SENSE_E
    elseif s == "N"
        return SENSE_N
    else
        return SENSE_UNKNOWN
    end
end

struct _SOSConstraint{T}
    type::Int
    weights::Vector{T}
    columns::Vector{String}
end

mutable struct TempMPSModel{T}
    lines::Int
    contents::String
    name::String
    is_minimization::Bool
    obj_name::String
    c::Vector{T}
    obj_constant::T
    col_lower::Vector{T}
    col_upper::Vector{T}
    col_bounds_default::Vector{Bool}
    row_lower::Vector{T}
    row_upper::Vector{T}
    sense::Vector{Sense}
    A::Vector{Vector{Tuple{Int,T}}}
    vtype::Vector{VType}
    name_to_col::Dict{String,Int}
    col_to_name::Vector{String}
    name_to_row::Dict{String,Int}
    row_to_name::Vector{String}
    intorg_flag::Bool  # A flag used to parse COLUMNS section.
    sos_constraints::Vector{_SOSConstraint{T}}
    quad_obj::Vector{Tuple{String,String,T}}
    qc_matrix::Dict{String,Vector{Tuple{String,String,T}}}
    current_qc_matrix::String
    indicators::Dict{String,Tuple{String,MOI.ActivationCondition}}

    function TempMPSModel{T}() where {T}
        return new{T}(
            0,        # line
            "",       # contents
            "",       # name
            true,     # is_minimization
            "",       # obj_name
            T[],      # c
            zero(T),  # obj_constant
            T[],      # col_lower
            T[],      # col_upper
            Bool[],   # col_bounds_default
            T[],      # row_lower
            T[],      # row_upper
            Sense[],  # sense
            Vector{Tuple{Int,T}}[],  # A
            VType[],
            Dict{String,Int}(),
            String[],
            Dict{String,Int}(),
            String[],
            false,
            _SOSConstraint{T}[],
            Tuple{String,String,T}[],
            Dict{String,Vector{Tuple{String,String,T}}}(),
            "",
            Dict{String,Tuple{String,MOI.ActivationCondition}}(),
        )
    end
end

"""
    struct ParseError <: Exception
        line::Int
        msg::String
    end

This error is thrown when we encounter an error parsing the MPS file.
"""
struct ParseError <: Exception
    line::Int
    msg::String
end

function _throw_parse_error(data, msg)
    counters = "1234567890"
    counter_line = counters ^ ceil(Int, length(data.contents) / 10)
    counter_line = counter_line[1:length(data.contents)]
    msg = string(data.contents, "\n", counter_line, "\n\n", msg)
    return throw(ParseError(data.lines, msg))
end

function Base.showerror(io::IO, err::ParseError)
    return print(io, "Error parsing MPS file on line $(err.line):\n\n", err.msg)
end

@enum(
    Headers,
    HEADER_NAME,
    HEADER_OBJSENSE,
    HEADER_ROWS,
    HEADER_COLUMNS,
    HEADER_RHS,
    HEADER_RANGES,
    HEADER_BOUNDS,
    HEADER_SOS,
    HEADER_ENDATA,
    HEADER_UNKNOWN,
    HEADER_QUADOBJ,
    HEADER_QMATRIX,
    HEADER_QCMATRIX,
    HEADER_QSECTION,
    HEADER_INDICATORS,
)

# `Headers` gets called _alot_ (on every line), so we try very hard to be
# efficient.
function Headers(s)
    N = length(s)
    x = first(s)
    if N == 3
        if (x == 'R' || x == 'r') && uppercase(s) == "RHS"
            return HEADER_RHS
        elseif (x == 'S' || x == 's') && uppercase(s) == "SOS"
            return HEADER_SOS
        end
    elseif N == 4
        if (x == 'R' || x == 'r') && uppercase(s) == "ROWS"
            return HEADER_ROWS
        end
    elseif N == 6
        if (x == 'R' || x == 'r') && uppercase(s) == "RANGES"
            return HEADER_RANGES
        elseif (x == 'B' || x == 'b') && uppercase(s) == "BOUNDS"
            return HEADER_BOUNDS
        elseif (x == 'E' || x == 'e') && uppercase(s) == "ENDATA"
            return HEADER_ENDATA
        end
    elseif N == 7
        if (x == 'C' || x == 'c') && (uppercase(s) == "COLUMNS")
            return HEADER_COLUMNS
        elseif (x == 'Q' || x == 'q')
            header = uppercase(s)
            if header == "QUADOBJ"
                return HEADER_QUADOBJ
            elseif header == "QMATRIX"
                return HEADER_QMATRIX
            end
        end
    elseif N >= 8
        if (x == 'O' || x == 'o') && startswith(uppercase(s), "OBJSENSE")
            return HEADER_OBJSENSE
        elseif (x == 'Q' || x == 'q')
            header = uppercase(s)
            if startswith(header, "QCMATRIX")
                return HEADER_QCMATRIX
            elseif startswith(header, "QSECTION")
                return HEADER_QSECTION
            end
        elseif N == 10
            if (x == 'I' || x == 'i') && uppercase(s) == "INDICATORS"
                return HEADER_INDICATORS
            end
        end
    end
    return HEADER_UNKNOWN
end

function line_to_items(line)
    # Split on any whitespace characters. We can't split only on `' '` because
    # at least one models in MIPLIB has `\t` as a separator.
    #
    # This decision assumes that we are parsing a free MPS file, where
    # whitespace is disallowed in names. If this ever becomes a problem, we
    # could change to the fixed MPS format, where the files are split at the
    # usual offsets.
    return split(line, r"\s"; keepempty = false)
end

"""
    Base.read!(io::IO, model::FileFormats.MPS.Model)

Read `io` in the MPS file format and store the result in `model`.
"""
function Base.read!(io::IO, model::Model{T}) where {T}
    if !MOI.is_empty(model)
        error("Cannot read in file because model is not empty.")
    end
    data = TempMPSModel{T}()
    header = HEADER_NAME
    while !eof(io) && header != HEADER_ENDATA
        data.contents = readline(io)
        data.lines += 1
        if startswith(data.contents, '*')
            continue  # Lines starting with `*` are comments
        end
        line = string(strip(data.contents))
        if isempty(line)
            continue  # Skip blank lines
        end
        h = Headers(line)
        if h == HEADER_OBJSENSE
            items = line_to_items(line)
            if length(items) == 2
                sense = uppercase(items[2])
                if !(sense in ("MIN", "MAX"))
                    _throw_parse_error(
                        data,
                        "The objective sense must be MIN or MAX.",
                    )
                end
                data.is_minimization = sense == "MIN"
            else
                header = HEADER_OBJSENSE
            end
            continue
        elseif h == HEADER_QCMATRIX || h == HEADER_QSECTION
            items = line_to_items(line)
            if length(items) != 2
                _throw_parse_error(
                    data,
                    "The header for a quadratic matrix must have two fields, where the second field is the name of the Q matrix.",
                )
            end
            data.current_qc_matrix = String(items[2])
            header = h
            data.qc_matrix[data.current_qc_matrix] = Tuple{String,String,T}[]
            continue
        elseif h != HEADER_UNKNOWN
            header = h
            continue
        end
        # Otherwise, carry on with the previous header
        # TODO: split into hard fields based on column indices.
        items = line_to_items(line)
        if header == HEADER_NAME
            parse_name_line(data, line)
        elseif header == HEADER_OBJSENSE
            sense = uppercase(only(items))
            if !(sense in ("MIN", "MAX"))
                _throw_parse_error(
                    data,
                    "The objective sense must be MIN or MAX.",
                )
            end
            data.is_minimization = sense == "MIN"
        elseif header == HEADER_ROWS
            parse_rows_line(data, items)
        elseif header == HEADER_COLUMNS
            parse_columns_line(data, items)
        elseif header == HEADER_RHS
            parse_rhs_line(data, items)
        elseif header == HEADER_RANGES
            parse_ranges_line(data, items)
        elseif header == HEADER_BOUNDS
            parse_bounds_line(data, items)
        elseif header == HEADER_SOS
            parse_sos_line(data, items)
        elseif header == HEADER_QUADOBJ
            parse_quadobj_line(data, items)
        elseif header == HEADER_QMATRIX
            parse_qmatrix_line(data, items)
        elseif header == HEADER_QCMATRIX
            parse_qcmatrix_line(data, items)
        elseif header == HEADER_QSECTION
            parse_qsection_line(data, items)
        elseif header == HEADER_INDICATORS
            parse_indicators_line(data, items)
        else
            # This really is an assert, not an opportunity for a ParseError.
            @assert header == HEADER_ENDATA
        end
    end
    copy_to(model, data)
    return
end

function bounds_to_set(lower::T, upper::T) where {T}
    if typemin(T) < lower < upper < typemax(T)
        return MOI.Interval(lower, upper)
    elseif typemin(T) < lower && upper == typemax(T)
        return MOI.GreaterThan(lower)
    elseif typemin(T) == lower && upper < typemax(T)
        return MOI.LessThan(upper)
    elseif lower == upper
        return MOI.EqualTo(upper)
    end
    return  # free variable
end

function copy_to(model::Model, data::TempMPSModel{T}) where {T}
    MOI.set(model, MOI.Name(), data.name)
    variable_map = Dict{String,MOI.VariableIndex}()
    for (i, name) in enumerate(data.col_to_name)
        _add_variable(model, data, variable_map, i, name)
    end
    _add_objective(model, data, variable_map)
    for (j, c_name) in enumerate(data.row_to_name)
        set = bounds_to_set(data.row_lower[j], data.row_upper[j])
        if set === nothing
            free_set = MOI.Interval(typemin(T), typemax(T))
            _add_constraint(model, data, variable_map, j, c_name, free_set)
        else
            _add_constraint(model, data, variable_map, j, c_name, set)
        end
    end
    for sos in data.sos_constraints
        MOI.add_constraint(
            model,
            MOI.VectorOfVariables([variable_map[x] for x in sos.columns]),
            sos.type == 1 ? MOI.SOS1(sos.weights) : MOI.SOS2(sos.weights),
        )
    end
    return
end

function _add_variable(model::Model{T}, data, variable_map, i, name) where {T}
    x = MOI.add_variable(model)
    variable_map[name] = x
    MOI.set(model, MOI.VariableName(), x, name)
    set = bounds_to_set(data.col_lower[i], data.col_upper[i])
    if set isa MOI.Interval
        # Do not add MOI.Interval constraints because we want to follow JuMP's
        # convention of adding separate lower and upper bounds.
        MOI.add_constraint(model, x, MOI.GreaterThan(set.lower::T))
        MOI.add_constraint(model, x, MOI.LessThan(set.upper::T))
    elseif set !== nothing
        MOI.add_constraint(model, x, set)
    end
    if data.vtype[i] == VTYPE_INTEGER
        MOI.add_constraint(model, x, MOI.Integer())
    elseif data.vtype[i] == VTYPE_BINARY
        MOI.add_constraint(model, x, MOI.ZeroOne())
    end
    return
end

function _add_objective(model::Model{T}, data, variable_map) where {T}
    if data.is_minimization
        MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    else
        MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    end
    affine_terms = MOI.ScalarAffineTerm{T}[
        MOI.ScalarAffineTerm(data.c[i], variable_map[v]) for
        (i, v) in enumerate(data.col_to_name) if !iszero(data.c[i])
    ]
    q_terms = MOI.ScalarQuadraticTerm{T}[]
    for (i, j, q) in data.quad_obj
        x = variable_map[i]
        y = variable_map[j]
        push!(q_terms, MOI.ScalarQuadraticTerm(q, x, y))
    end
    obj = if length(q_terms) == 0
        MOI.ScalarAffineFunction(affine_terms, -data.obj_constant)
    else
        MOI.ScalarQuadraticFunction(q_terms, affine_terms, -data.obj_constant)
    end

    MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
    return
end

function _add_constraint(model, data, variable_map, j, c_name, set)
    if haskey(data.qc_matrix, c_name)
        _add_quad_constraint(model, data, variable_map, j, c_name, set)
    elseif haskey(data.indicators, c_name)
        _add_indicator_constraint(model, data, variable_map, j, c_name, set)
    else
        _add_linear_constraint(model, data, variable_map, j, c_name, set)
    end
    return
end

function _add_indicator_constraint(
    model::Model{T},
    data,
    variable_map,
    j,
    c_name,
    set,
) where {T}
    z, activate = data.indicators[c_name]
    terms = MOI.VectorAffineTerm{T}[MOI.VectorAffineTerm(
        1,
        MOI.ScalarAffineTerm(one(T), variable_map[z]),
    ),]
    for (i, coef) in data.A[j]
        scalar = MOI.ScalarAffineTerm(coef, variable_map[data.col_to_name[i]])
        push!(terms, MOI.VectorAffineTerm(2, scalar))
    end
    f = MOI.VectorAffineFunction(terms, zeros(T, 2))
    c = MOI.add_constraint(model, f, MOI.Indicator{activate}(set))
    MOI.set(model, MOI.ConstraintName(), c, c_name)
    return
end

function _add_linear_constraint(
    model::Model{T},
    data,
    variable_map,
    j,
    c_name,
    set,
) where {T}
    terms = MOI.ScalarAffineTerm{T}[
        MOI.ScalarAffineTerm(coef, variable_map[data.col_to_name[i]]) for
        (i, coef) in data.A[j]
    ]
    c = MOI.add_constraint(model, MOI.ScalarAffineFunction(terms, zero(T)), set)
    MOI.set(model, MOI.ConstraintName(), c, c_name)
    return
end

function _add_quad_constraint(
    model::Model{T},
    data,
    variable_map,
    j,
    c_name,
    set,
) where {T}
    aff_terms = MOI.ScalarAffineTerm{T}[
        MOI.ScalarAffineTerm(coef, variable_map[data.col_to_name[i]]) for
        (i, coef) in data.A[j]
    ]
    quad_terms = MOI.ScalarQuadraticTerm{T}[]
    options = get_options(model)
    scale = 1
    if options.quadratic_format == kQuadraticFormatGurobi
        # Gurobi does NOT have a /2 as part of the quadratic matrix. Why oh why
        # would you break precedent with all other formats.
        scale = 2
    end
    for (x_name, y_name, q) in data.qc_matrix[c_name]
        x, y = variable_map[x_name], variable_map[y_name]
        push!(quad_terms, MOI.ScalarQuadraticTerm(scale * q, x, y))
    end
    f = MOI.ScalarQuadraticFunction(quad_terms, aff_terms, zero(T))
    c = MOI.add_constraint(model, f, set)
    MOI.set(model, MOI.ConstraintName(), c, c_name)
    return
end

# ==============================================================================
#   NAME
# ==============================================================================

function parse_name_line(data::TempMPSModel, line)
    m = match(r"^\s*NAME(.*)"i, line)
    if m === nothing
        _throw_parse_error(
            data,
            "This line must be  of the form `NAME <problem name>`.",
        )
    end
    data.name = strip(m[1])
    return
end

# ==============================================================================
#   ROWS
# ==============================================================================

function parse_rows_line(data::TempMPSModel{T}, items::Vector) where {T}
    if length(items) < 2
        _throw_parse_error(
            data,
            "A `ROWS` line must have two fields, where the first is the sense (`N`, `G`, `L`, or `E`) and the second is the name of the row.",
        )
    end
    # if length(items) > 2
    #     We could throw an error here, but it seems like other solvers just
    #     happily ignore the extra fields.
    #
    #     See https://github.com/jump-dev/MathOptInterface.jl/issues/2792
    #
    #     Oscar dislikes the poorly standardized nature of MPS.
    # end
    sense, name = Sense(items[1]), items[2]
    if haskey(data.name_to_row, name)
        _throw_parse_error(
            data,
            "There are two ROWS with a duplicate name: $name.",
        )
    elseif sense == SENSE_UNKNOWN
        _throw_parse_error(
            data,
            "This row sense is invalid: $(items[1]). It must be `N`, `G`, `L`, or `E`.",
        )
    end
    if sense == SENSE_N
        if data.obj_name == ""
            # The first N row is the objective
            data.obj_name = name
            return
        end
    end
    if name == data.obj_name
        _throw_parse_error(
            data,
            "Encountered a row with same name as the objective: $name.",
        )
    end
    # Add some default bounds for the constraints.
    push!(data.row_to_name, name)
    row = length(data.row_to_name)
    data.name_to_row[name] = row
    push!(data.sense, sense)
    push!(data.A, Tuple{Int,T}[])
    if sense == SENSE_G
        push!(data.row_lower, zero(T))
        push!(data.row_upper, typemax(T))
        data.row_upper[row] = typemax(T)
    elseif sense == SENSE_L
        push!(data.row_lower, typemin(T))
        push!(data.row_upper, zero(T))
    elseif sense == SENSE_E
        push!(data.row_lower, zero(T))
        push!(data.row_upper, zero(T))
    else
        # This really is an assert, not an opportunity for a ParseError
        @assert sense == SENSE_N
        push!(data.row_lower, typemin(T))
        push!(data.row_upper, typemax(T))
    end
    return
end

# ==============================================================================
#   COLUMNS
# ==============================================================================

function parse_single_coefficient(data, row_name, column::Int, value)
    if row_name == data.obj_name
        data.c[column] += value
        return
    end
    row = get(data.name_to_row, row_name, nothing)
    if row === nothing
        _throw_parse_error(
            data,
            "The ROW name $(row_name) not recognised. If a row appears in the COLUMNS section, it must first be declared in the ROWS section.",
        )
    end
    push!(data.A[row], (column, value))
    return
end

function _add_new_column(data::TempMPSModel{T}, column_name) where {T}
    if haskey(data.name_to_col, column_name)
        return
    end
    push!(data.col_to_name, column_name)
    data.name_to_col[column_name] = length(data.col_to_name)
    push!(data.c, zero(T))
    push!(data.col_lower, zero(T))
    push!(data.col_upper, typemax(T))
    push!(data.col_bounds_default, true)
    push!(data.vtype, VTYPE_CONTINUOUS)
    return
end

function _set_intorg(data::TempMPSModel{T}, column, column_name) where {T}
    if data.intorg_flag
        data.vtype[column] = VTYPE_INTEGER
        # The default upper bound for variables in INTORG is `1`, not `Inf`...
        data.col_upper[column] = one(T)
    elseif data.vtype[column] != VTYPE_CONTINUOUS
        _throw_parse_error(
            data,
            "The variable $(column_name) appeared in COLUMNS outside an `INTORG`-`INTEND` marker after already being declared as integer.",
        )
    end
    return
end

function parse_columns_line(data::TempMPSModel{T}, items::Vector) where {T}
    if length(items) == 3
        # [column name] [row name] [value]
        column_name, row_name, value = items
        if row_name == "'MARKER'"
            if value == "'INTORG'"
                data.intorg_flag = true
                return
            elseif value == "'INTEND'"
                data.intorg_flag = false
                return
            end
        end
        _add_new_column(data, column_name)
        column = data.name_to_col[column_name]
        parse_single_coefficient(data, row_name, column, parse(T, value))
        _set_intorg(data, column, column_name)
    elseif length(items) == 5
        # [column name] [row name] [value] [row name 2] [value 2]
        column_name, row_name_1, value_1, row_name_2, value_2 = items
        _add_new_column(data, column_name)
        column = data.name_to_col[column_name]
        parse_single_coefficient(data, row_name_1, column, parse(T, value_1))
        parse_single_coefficient(data, row_name_2, column, parse(T, value_2))
        _set_intorg(data, column, column_name)
    else
        _throw_parse_error(
            data,
            "Malformed COLUMNS line. This line must have 3 or 5 fields.",
        )
    end
    return
end

# ==============================================================================
#   RHS
# ==============================================================================

function parse_single_rhs(data, row_name, value, items::Vector)
    if row_name == data.obj_name
        data.obj_constant = value
        return
    end
    row = get(data.name_to_row, row_name, nothing)
    if row === nothing
        _throw_parse_error(
            data,
            "The ROW name $(row_name) not recognised. If a row appears in the RHS section, it must previously have been declared in the ROWS section.",
        )
    end
    if data.sense[row] == SENSE_E
        data.row_upper[row] = value
        data.row_lower[row] = value
    elseif data.sense[row] == SENSE_G
        data.row_lower[row] = value
    elseif data.sense[row] == SENSE_L
        data.row_upper[row] = value
    else
        # This really is an assert, not an opportunity for a ParseError.
        @assert data.sense[row] == SENSE_N
        _throw_parse_error(
            data,
            "A row sense `N` cannot have a right-hand side value.",
        )
    end
    return
end

# TODO: handle multiple RHS vectors.
function parse_rhs_line(data::TempMPSModel{T}, items::Vector) where {T}
    if length(items) == 3
        # [rhs name] [row name] [value]
        rhs_name, row_name, value = items
        parse_single_rhs(data, row_name, parse(T, value), items)
    elseif length(items) == 5
        # [rhs name] [row name 1] [value 1] [row name 2] [value 2]
        rhs_name, row_name_1, value_1, row_name_2, value_2 = items
        parse_single_rhs(data, row_name_1, parse(T, value_1), items)
        parse_single_rhs(data, row_name_2, parse(T, value_2), items)
    else
        _throw_parse_error(
            data,
            "Malformed RHS line: expected three or five fields.",
        )
    end
    return
end

# ==============================================================================
#  RANGES
#
# Here is how RANGE information is encoded. (We repeat this comment because it
# is so non-trivial.)
#
#     Row type | Range value |  lower bound  |  upper bound
#     ------------------------------------------------------
#         G    |     +/-     |     rhs       | rhs + |range|
#         L    |     +/-     | rhs - |range| |     rhs
#         E    |      +      |     rhs       | rhs + range
#         E    |      -      | rhs + range   |     rhs
# ==============================================================================

function parse_single_range(data, row_name, value)
    row = get(data.name_to_row, row_name, nothing)
    if row === nothing
        _throw_parse_error(
            data,
            "The ROW name $(row_name) not recognised. If a row appears in the RHS section, it must previously have been declared in the ROWS section.",
        )
    end
    if data.sense[row] == SENSE_G
        data.row_upper[row] = data.row_lower[row] + abs(value)
    elseif data.sense[row] == SENSE_L
        data.row_lower[row] = data.row_upper[row] - abs(value)
    elseif data.sense[row] == SENSE_E
        if value > 0
            data.row_upper[row] = data.row_lower[row] + value
        else
            data.row_lower[row] = data.row_upper[row] + value
        end
    end
    return
end

# TODO: handle multiple RANGES vectors.
function parse_ranges_line(data::TempMPSModel{T}, items::Vector) where {T}
    if length(items) == 3
        # [rhs name] [row name] [value]
        _, row_name, value = items
        parse_single_range(data, row_name, parse(T, value))
    elseif length(items) == 5
        # [rhs name] [row name] [value] [row name 2] [value 2]
        _, row_name_1, value_1, row_name_2, value_2 = items
        parse_single_range(data, row_name_1, parse(T, value_1))
        parse_single_range(data, row_name_2, parse(T, value_2))
    else
        _throw_parse_error(
            data,
            "Malformed RANGES line: expected three or five fields.",
        )
    end
    return
end

# ==============================================================================
#   BOUNDS
# ==============================================================================

function _parse_single_bound(
    data::TempMPSModel{T},
    column_name,
    bound_type,
) where {T}
    col = get(data.name_to_col, column_name, nothing)
    if col === nothing
        _throw_parse_error(
            data,
            "The column name $(column_name) was not recognized. If a column appears in the BOUNDS section, it must have previously appeared in the COLUMNS section.",
        )
    end
    if data.col_bounds_default[col] && data.vtype[col] == VTYPE_INTEGER
        # This column was part of an INTORG...INTEND block, so it gets a default
        # bound of [0, 1]. However, since it now has a bound, it reverts to a
        # default of [0, inf).
        data.col_upper[col] = typemax(T)
    end
    data.col_bounds_default[col] = false
    if bound_type == "PL"
        data.col_upper[col] = typemax(T)
    elseif bound_type == "MI"
        data.col_lower[col] = typemin(T)
    elseif bound_type == "FR"
        data.col_lower[col] = typemin(T)
        data.col_upper[col] = typemax(T)
    elseif bound_type == "BV"
        data.col_lower[col] = typemin(T)
        data.col_upper[col] = typemax(T)
        data.vtype[col] = VTYPE_BINARY
    else
        _throw_parse_error(
            data,
            "The bound type $bound_type is invalid when there are three fields.",
        )
    end
end

function _parse_single_bound(
    data::TempMPSModel{T},
    column_name,
    bound_type,
    value::T,
) where {T}
    col = get(data.name_to_col, column_name, nothing)
    if col === nothing
        _throw_parse_error(
            data,
            "The column name $(column_name) was not recognized. If a column appears in the BOUNDS section, it must have previously appeared in the COLUMNS section.",
        )
    end
    if data.col_bounds_default[col] && data.vtype[col] == VTYPE_INTEGER
        # This column was part of an INTORG...INTEND block, so it gets a default
        # bound of [0, 1]. However, since it now has a bound, it reverts to a
        # default of [0, inf).
        data.col_upper[col] = typemax(T)
    end
    data.col_bounds_default[col] = false
    if bound_type == "FX"
        data.col_lower[col] = value
        data.col_upper[col] = value
    elseif bound_type == "UP"
        data.col_upper[col] = value
    elseif bound_type == "LO"
        data.col_lower[col] = value
    elseif bound_type == "LI"
        data.col_lower[col] = value
        data.vtype[col] = VTYPE_INTEGER
    elseif bound_type == "UI"
        data.col_upper[col] = value
        data.vtype[col] = VTYPE_INTEGER
    elseif bound_type == "FR"
        # So even though FR bounds should be of the form:
        #  FR BOUND1    VARNAME
        # there are cases in MIPLIB2017 (for example, leo1 and leo2) like so:
        #  FR BOUND1    C0000001       .000000
        # In these situations, just ignore the value.
        data.col_lower[col] = typemin(T)
        data.col_upper[col] = typemax(T)
    elseif bound_type == "BV"
        # A similar situation happens with BV bounds in leo1 and leo2.
        data.col_lower[col] = typemin(T)
        data.col_upper[col] = typemax(T)
        data.vtype[col] = VTYPE_BINARY
    else
        _throw_parse_error(
            data,
            "The bound type $bound_type is invalid when there are four fields.",
        )
    end
end

function parse_bounds_line(data::TempMPSModel{T}, items::Vector) where {T}
    if length(items) == 3
        bound_type, _, column_name = items
        _parse_single_bound(data, column_name, bound_type)
    elseif length(items) == 4
        bound_type, _, column_name, value = items
        _parse_single_bound(data, column_name, bound_type, parse(T, value))
    else
        _throw_parse_error(
            data,
            "Malformed BOUNDS line: expected three or four fields.",
        )
    end
    return
end

# ==============================================================================
#   SOS
# ==============================================================================

function parse_sos_line(data::TempMPSModel{T}, items) where {T}
    if length(items) != 2
        _throw_parse_error(data, "Malformed SOS line: expected two fields.")
    elseif items[1] == "S1"
        push!(data.sos_constraints, _SOSConstraint(1, T[], String[]))
    elseif items[1] == "S2"
        push!(data.sos_constraints, _SOSConstraint(2, T[], String[]))
    else
        sos = data.sos_constraints[end]
        push!(sos.columns, items[1])
        push!(sos.weights, parse(T, items[2]))
    end
    return
end

# ==============================================================================
#   QUADOBJ
# ==============================================================================

function parse_quadobj_line(data::TempMPSModel{T}, items) where {T}
    if length(items) != 3
        _throw_parse_error(
            data,
            "Malformed QUADOBJ line: expected three fields.",
        )
    end
    push!(data.quad_obj, (items[1], items[2], parse(T, items[3])))
    return
end

# ==============================================================================
#   QMATRIX
# ==============================================================================

function parse_qmatrix_line(data::TempMPSModel{T}, items) where {T}
    if length(items) != 3
        _throw_parse_error(
            data,
            "Malformed QMATRIX line: expected three fields.",
        )
    end
    if data.name_to_col[items[1]] <= data.name_to_col[items[2]]
        # Off-diagonals have duplicate entries. We don't need to store both
        # triangles.
        push!(data.quad_obj, (items[1], items[2], parse(T, items[3])))
    end
    return
end

# ==============================================================================
#   QMATRIX
# ==============================================================================

function parse_qcmatrix_line(data::TempMPSModel{T}, items) where {T}
    if length(items) != 3
        _throw_parse_error(
            data,
            "Malformed QCMATRIX line: expected three fields.",
        )
    end
    if data.name_to_col[items[1]] <= data.name_to_col[items[2]]
        # Off-diagonals have duplicate entries. We don't need to store both
        # triangles.
        push!(
            data.qc_matrix[data.current_qc_matrix],
            (items[1], items[2], parse(T, items[3])),
        )
    end
    return
end

# ==============================================================================
#   QSECTION
# ==============================================================================

function parse_qsection_line(data::TempMPSModel{T}, items) where {T}
    if length(items) != 3
        _throw_parse_error(
            data,
            "Malformed QSECTION line: expected three fields.",
        )
    end
    if data.current_qc_matrix == "OBJ"
        push!(data.quad_obj, (items[1], items[2], parse(T, items[3])))
    else
        push!(
            data.qc_matrix[data.current_qc_matrix],
            (items[1], items[2], parse(T, items[3])),
        )
    end
    return
end

# ==============================================================================
#   INDICATORS
# ==============================================================================

function parse_indicators_line(data, items)
    if length(items) != 4
        _throw_parse_error(
            data,
            "Malformed INDICATORS line: expected four fields.",
        )
    end
    condition = if items[4] == "0"
        MOI.ACTIVATE_ON_ZERO
    elseif items[4] == "1"
        MOI.ACTIVATE_ON_ONE
    else
        _throw_parse_error(
            data,
            "The value in field four of an indicator constraint must be either `0` or `1`.",
        )
    end
    data.indicators[items[2]] = (items[3], condition)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    test_quadratic_integration(model::MOI.ModelLike, config::Config{T}) where {T}

Test the problem:
```
Min x^2 + xy + y^2 + yz + z^2
st  x + 2y + 3z >= 4 (c1)
    x +  y      >= 1 (c2)
    x, y, z in R
```
"""
function test_quadratic_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    v = MOI.add_variables(model, 3)
    @test MOI.get(model, MOI.NumberOfVariables()) == 3
    cf1 = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[1, 2, 3], v), T(0))
    c1 = MOI.add_constraint(model, cf1, MOI.GreaterThan(T(4)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.GreaterThan{T},
            }(),
        ) == 1
    end
    c2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T(1), [v[1], v[2]]),
            T(0),
        ),
        MOI.GreaterThan(T(1)),
    )
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.GreaterThan{T},
            }(),
        ) == 2
    end
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    obj = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.(
            T[2, 1, 2, 1, 2],
            v[[1, 1, 2, 2, 3]],
            v[[1, 2, 2, 3, 3]],
        ),
        MOI.ScalarAffineTerm{T}[],
        T(0),
    )
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(), obj)
    if _supports(config, MOI.ObjectiveFunction)
        @test obj ≈ MOI.get(
            model,
            MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(),
        )
        @test cf1 ≈ MOI.get(model, MOI.ConstraintFunction(), c1)
        @test MOI.GreaterThan(T(4)) == MOI.get(model, MOI.ConstraintSet(), c1)
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(13 // 7), config)
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), v),
            T[4//7, 3//7, 6//7],
            config,
        )
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            # The dual constraint gives
            # [λ_c1 + λ_c2, 2λ_c1 + λ_c2, 3λ_c1] = [2 1 0; 1 2 1; 0 1 2] * x
            #                                    = [11, 16, 15] // 7
            # hence λ_c1 = 5/7 and λ_c2 = 6/7.
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c1), T(5 // 7), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c2), T(6 // 7), config)
        end
    end
    return
end

function setup_test(
    ::typeof(test_quadratic_integration),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[4//7, 3//7, 6//7],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                T[5//7, 6//7],
        ),
    )
    return
end

"""
    test_quadratic_duplicate_terms(model::MOI.ModelLike, config::Config{T}) where {T}

Test the problem:
```
Min x^2 + xy + y^2 + yz + z^2
st  x + 2y + 3z >= 4 (c1)
    x +  y      >= 1 (c2)
    x, y, z in R
```
"""
function test_quadratic_duplicate_terms(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    v = MOI.add_variables(model, 3)
    @test MOI.get(model, MOI.NumberOfVariables()) == 3
    c1f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[1, 2, 3], v), T(0))
    c1 = MOI.add_constraint(model, c1f, MOI.GreaterThan(T(4)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.GreaterThan{T},
            }(),
        ) == 1
    end
    c2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T(1), [v[1], v[2]]),
            T(0),
        ),
        MOI.GreaterThan(T(1)),
    )
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.GreaterThan{T},
            }(),
        ) == 2
    end
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    obj = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.(
            T[2, 1//2, 1//2, 2, 1, 1, 1],
            [v[1], v[1], v[1], v[2], v[2], v[3], v[3]],
            [v[1], v[2], v[2], v[2], v[3], v[3], v[3]],
        ),
        MOI.ScalarAffineTerm.(T(0), v),
        T(0),
    )
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(), obj)
    if _supports(config, MOI.ObjectiveFunction)
        @test obj ≈ MOI.get(
            model,
            MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(),
        )
        @test c1f ≈ MOI.get(model, MOI.ConstraintFunction(), c1)
        @test MOI.GreaterThan(T(4)) == MOI.get(model, MOI.ConstraintSet(), c1)
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(13 // 7), config)
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), v),
            T[4//7, 3//7, 6//7],
            config,
        )
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c1), T(5 // 7), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c2), T(6 // 7), config)
        end
    end
    # change objective to Max -2(x^2 + xy + y^2 + yz + z^2)
    # First clear the objective, this is needed if a `Bridges.Objective.SlackBridge` is used.
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    obj2 = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.(
            T[-4, -1, -1, -4, -2, -2, -2],
            [v[1], v[1], v[1], v[2], v[2], v[3], v[3]],
            [v[1], v[2], v[2], v[2], v[3], v[3], v[3]],
        ),
        MOI.ScalarAffineTerm.(T(0), v),
        T(0),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(),
        obj2,
    )
    if _supports(config, MOI.ObjectiveFunction)
        @test obj2 ≈ MOI.get(
            model,
            MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(),
        )
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(-2 * 13 // 7), config)
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), v),
            T[4//7, 3//7, 6//7],
            config,
        )
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test ≈(
                MOI.get(model, MOI.ConstraintDual(), c1),
                T(10 // 7),
                config,
            )
            @test ≈(
                MOI.get(model, MOI.ConstraintDual(), c2),
                T(12 // 7),
                config,
            )
        end
    end
    return
end

function setup_test(
    ::typeof(test_quadratic_duplicate_terms),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[4//7, 3//7, 6//7],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                T[5//7, 6//7],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[4//7, 3//7, 6//7],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                T[10//7, 12//7],
        ),
    )
    return
end

"""
    test_quadratic_nonhomogeneous(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test the problem:
```
minimize 2 x^2 + y^2 + xy + x + y + 1
    s.t.  x, y >= 0
          x + y = 1
```
"""
function test_quadratic_nonhomogeneous(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    c1 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x, y]), T(0)),
        MOI.EqualTo(T(1)),
    )
    vc1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    # We test this after the creation of every `VariableIndex` constraint
    # to ensure a good coverage of corner cases.
    @test vc1.value == x.value
    vc2 = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    @test vc2.value == y.value
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    obj = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.(T[4, 2, 1], [x, y, x], [x, y, y]),
        MOI.ScalarAffineTerm.(T(1), [x, y]),
        T(1),
    )
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(), obj)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(23 // 8), config)
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), [x, y]),
            T[1//4, 3//4],
            config,
        )
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc1), T(1 // 4), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc2), T(3 // 4), config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            # The dual constraint gives
            # [λ_vc1 + λ_c1, λ_vc2 + λ_c1] = [4 1; 1 2] * x + [1, 1] = [11, 11] / 4
            # since `vc1` and `vc2` are not active, `λ_vc1` and `λ_vc2` are
            # zero so `λ_c1 = 11/4`.
            @test ≈(
                MOI.get(model, MOI.ConstraintDual(), c1),
                T(11 // 4),
                config,
            )
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc1), T(0), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc2), T(0), config)
        end
    end
    # change back to linear
    #        max 2x + y + 1
    #       s.t.  x, y >= 0
    #             x + y = 1
    # (x,y) = (1,0), obj = 3
    # First clear the objective, this is needed if a
    # `Bridges.Objective.SlackBridge` is used.
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    objf =
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[2, 1], [x, y]), T(1))
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(3), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), [x, y]), T[1, 0], config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc1), T(1), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc2), T(0), config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c1), T(-2), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc1), T(0), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc2), T(1), config)
        end
    end
    return
end

function setup_test(
    ::typeof(test_quadratic_nonhomogeneous),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1//4, 3//4],
            (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) => T[11//4],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1, 0],
            (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) => T[-2],
        ),
    )
    return
end

"""
    test_quadratic_constraint_integration(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test the problem:
```
Max x  + y
st -x  + y >= 0 (c1[1])
    x  + y >= 0 (c1[2])
    x² + y <= 2 (c2)
Optimal solution
x = 1/2, y = 7/4
```
"""
function test_quadratic_constraint_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Nonnegatives,
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    c1 = MOI.add_constraint(
        model,
        MOI.VectorAffineFunction(
            MOI.VectorAffineTerm.(
                [1, 1, 2, 2],
                MOI.ScalarAffineTerm.(T[-1, 1, 1, 1], [x, y, x, y]),
            ),
            T[0, 0],
        ),
        MOI.Nonnegatives(2),
    )
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.VectorAffineFunction{T},
                MOI.Nonnegatives,
            }(),
        ) == 1
    end
    c2f = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(T(2), x, x)],
        [MOI.ScalarAffineTerm(T(1), y)],
        T(0),
    )
    c2 = MOI.add_constraint(model, c2f, MOI.LessThan(T(2)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarQuadraticFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x, y]), T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    if _supports(config, MOI.ConstraintFunction)
        @test ≈(MOI.get(model, MOI.ConstraintFunction(), c2), c2f, config)
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(9 // 4), config)
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), [x, y]),
            T[1//2, 7//4],
            config,
        )
        @test ≈(
            MOI.get(model, MOI.ConstraintPrimal(), c1),
            T[5//4, 9//4],
            config,
        )
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c2), 2, config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            # The dual constraint gives
            # [-1, -1] = [-λ_c1[1] + λ_c1[2], λ_c1[1] + λ_c1[2]] + λ_c2 * ([2 0; 0 0] * x + [0, 1])
            #          = [-λ_c1[1] + λ_c1[2] + λ_c2, λ_c1[1] + λ_c1[2] + λ_c2]
            # By complementary slackness, we have `λ_c1 = [0, 0]` so
            # `λ_c2 = -1`.
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c1), T[0, 0], config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c2), T(-1), config)
        end
    end
    # try delete quadratic constraint and go back to linear
    # FIXME why is this commented ?
    # MOI.delete(model, c2)
    #
    # MOI.optimize!(model)
    #
    # @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    #
    # @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    #
    # @test MOI.get(model, MOI.ObjectiveValue()), 0.0 atol=atol rtol=rtol
    return
end

function setup_test(
    ::typeof(test_quadratic_constraint_integration),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1//2, 7//4],
            (MOI.VectorAffineFunction{T}, MOI.Nonnegatives) => [T[0, 0]],
            (MOI.ScalarQuadraticFunction{T}, MOI.LessThan{T}) => T[-1],
        ),
    )
    return
end

"""
    test_quadratic_constraint_basic(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test the problem:
```
 Max x
s.t. x^2 <= 2 (c)
```
"""
function test_quadratic_constraint_basic(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    cf = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(T(2), x, x)],
        [MOI.ScalarAffineTerm(T(0), x)],
        T(0),
    )
    c = MOI.add_constraint(model, cf, MOI.LessThan(T(2)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarQuadraticFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    if _supports(config, MOI.ConstraintFunction)
        @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), cf, config)
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), sqrt(T(2)), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), sqrt(T(2)), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), 2, config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            # The dual constraint gives
            # -1 = λ * (2 * x) = λ * 2sqrt(T(2))
            # hence λ = -1/(2sqrt(T(2))).
            @test ≈(
                MOI.get(model, MOI.ConstraintDual(), c),
                T(-1) / (2 * sqrt(T(2))),
                config,
            )
        end
    end
    return
end

function setup_test(
    ::typeof(test_quadratic_constraint_basic),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            [sqrt(T(2))],
            (MOI.ScalarQuadraticFunction{T}, MOI.LessThan{T}) =>
                [T(-1) / (2 * sqrt(T(2)))],
        ),
    )
    return
end

"""
    test_quadratic_constraint_minimize(
        model::MOI.ModelLike,
        config::Config,
    )

Test the problem:
```
 Min -x
s.t.  x^2 <= 2
```
"""
function test_quadratic_constraint_minimize(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    cf = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(T(2), x, x)],
        MOI.ScalarAffineTerm{T}[],
        T(0),
    )
    c = MOI.add_constraint(model, cf, MOI.LessThan(T(2)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarQuadraticFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(-1), x)], T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    if _supports(config, MOI.ConstraintFunction)
        @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), cf, config)
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
        end
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), -sqrt(T(2)), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), sqrt(T(2)), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), 2, config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            # The dual constraint gives
            # -1 = λ * (2 * x) = λ * 2sqrt(T(2))
            # hence λ = -1/(2sqrt(T(2))).
            @test ≈(
                MOI.get(model, MOI.ConstraintDual(), c),
                T(-1) / (2 * sqrt(T(2))),
                config,
            )
        end
    end
    return
end

function setup_test(
    ::typeof(test_quadratic_constraint_minimize),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            [sqrt(T(2))],
            (MOI.ScalarQuadraticFunction{T}, MOI.LessThan{T}) =>
                [T(-1) / (2 * sqrt(T(2)))],
        ),
    )
    return
end

"""
Max  x
s.t. x^2 + x * y + y^2 <= 3 (c)
     y == 1
"""
function _test_quadratic_constraint_helper(
    model::MOI.ModelLike,
    config::Config{T},
    less_than::Bool,
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    quad_set = less_than ? MOI.LessThan(T(3)) : MOI.GreaterThan(T(-3))
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarQuadraticFunction{T},
        typeof(quad_set),
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    vc = MOI.add_constraint(model, y, MOI.EqualTo(T(1)))
    @test vc.value == y.value
    cf = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.(T[2, 1, 2], [x, x, y], [x, y, y]),
        [MOI.ScalarAffineTerm(T(0), x)],
        T(0),
    )
    if !less_than
        MOIU.operate!(-, T, cf)
    end
    c = MOI.add_constraint(model, cf, quad_set)
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarQuadraticFunction{T},
                typeof(quad_set),
            }(),
        ) == 1
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    if _supports(config, MOI.ConstraintFunction)
        @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), cf, config)
        @test quad_set == MOI.get(model, MOI.ConstraintSet(), c)
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(1), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(1), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(1), config)
        @test ≈(
            MOI.get(model, MOI.ConstraintPrimal(), c),
            MOI.constant(quad_set),
            config,
        )
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc), T(1), config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            # The dual constraint gives
            # [-1, 0] = λ_c * [2 1; 1 2] * x + [0, λ_vc]
            #         = [3λ_c, 3λ_c + λ_vc]
            # hence `λ_c = -1/3` and `λ_vc = 1`.
            λ_c = less_than ? T(-1 // 3) : T(1 // 3)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c), λ_c, config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc), 1, config)
        end
    end
    return
end

function test_quadratic_constraint_LessThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    _test_quadratic_constraint_helper(model, config, true)
    return
end

function setup_test(
    ::typeof(test_quadratic_constraint_LessThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1, 1],
            (MOI.ScalarQuadraticFunction{T}, MOI.LessThan{T}) => T[-1//3],
        ),
    )
    return
end

function test_quadratic_constraint_GreaterThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    _test_quadratic_constraint_helper(model, config, false)
    return
end

function setup_test(
    ::typeof(test_quadratic_constraint_GreaterThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1, 1],
            (MOI.ScalarQuadraticFunction{T}, MOI.GreaterThan{T}) => T[1//3],
        ),
    )
    return
end

"""
    test_quadratic_nonconvex_constraint_integration(
        model::MOI.ModelLike,
        config::Config,
    )

Test the problem:
```
Max 2x + y
s.t. x * y <= 4 (c)
     x, y >= 1
```
"""
function test_quadratic_nonconvex_constraint_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    vc1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    @test vc1.value == x.value
    vc2 = MOI.add_constraint(model, y, MOI.GreaterThan(T(1)))
    @test vc2.value == y.value
    cf = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(T(1), x, y)],
        [MOI.ScalarAffineTerm(T(0), x)],
        T(0),
    )
    c = MOI.add_constraint(model, cf, MOI.LessThan(T(4)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarQuadraticFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[2, 1], [x, y]), T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    if _supports(config, MOI.ConstraintFunction)
        @test cf ≈ MOI.get(model, MOI.ConstraintFunction(), c)
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(9), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(1), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(4), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc1), T(4), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc2), T(1), config)
    end
    return
end

function setup_test(
    ::typeof(test_quadratic_nonconvex_constraint_integration),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, T[4, 1], MOI.FEASIBLE_POINT),
    )
    return
end

"""
    test_quadratic_nonconvex_constraint_basic(
        model::MOI.ModelLike,
        config::Config,
    )

Test the problem:
```
Find x, y
s.t. x * y == 4 (c)
     x * x == 4 (c2)
     x, y >= 0
```
"""
function test_quadratic_nonconvex_constraint_basic(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarQuadraticFunction{T},
        MOI.EqualTo{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    vc1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test vc1.value == x.value
    vc2 = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    @test vc2.value == y.value
    cf = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(T(1), x, y)],
        [MOI.ScalarAffineTerm(T(0), x)],
        T(0),
    )
    c = MOI.add_constraint(model, cf, MOI.EqualTo(T(4)))
    cf2 = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(T(2), x, x)],
        [MOI.ScalarAffineTerm(T(0), x)],
        T(0),
    )
    c2 = MOI.add_constraint(model, cf2, MOI.EqualTo(T(4)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarQuadraticFunction{T},
                MOI.EqualTo{T},
            }(),
        ) == 2
    end
    if _supports(config, MOI.ConstraintFunction)
        @test cf ≈ MOI.get(model, MOI.ConstraintFunction(), c)
        @test cf2 ≈ MOI.get(model, MOI.ConstraintFunction(), c2)
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(2), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(2), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(4), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c2), T(4), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc1), T(2), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc2), T(2), config)
    end
    return
end

function setup_test(
    ::typeof(test_quadratic_nonconvex_constraint_basic),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, T[2, 2], MOI.FEASIBLE_POINT),
    )
    return
end

"""
    test_quadratic_SecondOrderCone_basic(model::MOI.ModelLike, config::Config{T}) where {T}

Test the non-convex formulation of a SecondOrderCone constraint:
```
min t
s.t. x + y >= 1 (c1)
     x^2 + y^2 <= t^2 (c2)
     t >= 0 (bound)
```

This is a useful test because some solvers have support for detecting that it is
actually a convex problem due to the `t >= 0` bound.

If your solver does not have this support (and therefore fails this test), you
can safely exclude it.
"""
function test_quadratic_SecondOrderCone_basic(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    t = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 3
    c1f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x, y]), T(0))
    c1 = MOI.add_constraint(model, c1f, MOI.GreaterThan(T(1)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.GreaterThan{T},
            }(),
        ) == 1
    end
    c2f = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.(T[2, 2, -2], [x, y, t], [x, y, t]),
        MOI.ScalarAffineTerm{T}[],
        T(0),
    )
    c2 = MOI.add_constraint(model, c2f, MOI.LessThan(T(0)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarQuadraticFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    bound = MOI.add_constraint(model, t, MOI.GreaterThan(T(0)))
    @test bound.value == t.value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 1
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), t)], T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    if _supports(config, MOI.ConstraintFunction)
        @test c1f ≈ MOI.get(model, MOI.ConstraintFunction(), c1)
        @test c2f ≈ MOI.get(model, MOI.ConstraintFunction(), c2)
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), 1 / sqrt(T(2)), config)
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), [x, y, t]),
            T[1//2, 1//2, 1/sqrt(T(2))],
            config,
        )
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), [t, x, y, t]),
            T[1/sqrt(T(2)), 1//2, 1//2, 1/sqrt(T(2))],
            config,
        )
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            # The dual constraint gives
            # [1, 0, 0] = [λ_bound, λ_c1, λ_c1] + λ_c2 * [-2 0 0; 0 2 0; 0 0 2] * x
            #           = [λ_bound - sqrt(T(2))*λ_c2, λ_c1 + λ_c2, λ_c1 + λ_c2]
            # and since `bound` is not active, `λ_bound = 0`.
            # This gives `λ_c2 = -1/sqrt(T(2))` and `λ_c1 = 1/sqrt(T(2))`.
            @test ≈(
                MOI.get(model, MOI.ConstraintDual(), c1),
                1 / sqrt(T(2)),
                config,
            )
            @test ≈(
                MOI.get(model, MOI.ConstraintDual(), c2),
                -1 / sqrt(T(2)),
                config,
            )
            @test ≈(MOI.get(model, MOI.ConstraintDual(), bound), T(0), config)
        end
    end
    return
end

function setup_test(
    ::typeof(test_quadratic_SecondOrderCone_basic),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1//2, 1//2, 1/sqrt(T(2))],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                [1 / sqrt(T(2))],
            (MOI.ScalarQuadraticFunction{T}, MOI.LessThan{T}) =>
                [-1 / sqrt(T(2))],
        ),
    )
    return
end

"""
    test_quadratic_Integer_SecondOrderCone(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Run an integration test on the problem:
```
 min    - 2y - 1z
s.t.   x           == 1
      [x,  y,   z] in SecondOrderCone()
           y,   z  in ZeroOne()
```
"""
function test_quadratic_Integer_SecondOrderCone(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Zeros,
    )
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.SecondOrderCone,
    )
    x, y, z = MOI.add_variables(model, 3)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[-2, -1], [y, z]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.add_constraint(
        model,
        MOI.VectorAffineFunction(
            [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x))],
            T[-1],
        ),
        MOI.Zeros(1),
    )
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables([x, y, z]),
        MOI.SecondOrderCone(3),
    )
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VectorAffineFunction{T},MOI.Zeros}(),
        ) == 1
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.SecondOrderCone}(),
        ) == 1
    end
    loc = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test length(loc) == 2
    @test (MOI.VectorAffineFunction{T}, MOI.Zeros) in loc
    @test (MOI.VectorOfVariables, MOI.SecondOrderCone) in loc
    bin1 = MOI.add_constraint(model, y, MOI.ZeroOne())
    # We test this after the creation of every `VariableIndex` constraint
    # to ensure a good coverage of corner cases.
    @test bin1.value == y.value
    bin2 = MOI.add_constraint(model, z, MOI.ZeroOne())
    @test bin2.value == z.value
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), -2, config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), 1, config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), 1, config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z), 0, config)
    end
    return
end

function setup_test(
    ::typeof(test_quadratic_Integer_SecondOrderCone),
    model::MOI.Utilities.MockOptimizer,
    config::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[1, 1, 0]),
    )
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintIntervalToHyperRectangle

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name) $T" for T in [Float32, Float64]
                getfield(@__MODULE__, name)(T)
            end
        end
    end
    return
end

include("../utilities.jl")

function test_ScalarFunctionConstantNotZero(T)
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}()),
    )
    bridged_mock = MOI.Bridges.Constraint.IntervalToHyperRectangle{T}(mock)
    config = MOI.Test.Config(T)
    MOI.Test.test_model_ScalarFunctionConstantNotZero(bridged_mock, config)
    return
end

function test_basic(T)
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}()),
    )
    bridged_mock = MOI.Bridges.Constraint.IntervalToHyperRectangle{T}(mock)
    config = MOI.Test.Config()
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = ["test_basic_ScalarAffineFunction_Interval"],
    )
    return
end

function test_linear_integration(T)
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}()),
    )
    bridged_mock = MOI.Bridges.Constraint.IntervalToHyperRectangle{T}(mock)
    config = MOI.Test.Config(T, exclude = Any[MOI.ConstraintBasisStatus])
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            T[5, 5],
            (MOI.VectorAffineFunction{T}, MOI.HyperRectangle{T}) => [T[-1]],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            T[5//2, 5//2],
            (MOI.VectorAffineFunction{T}, MOI.HyperRectangle{T}) => [T[1]],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            T[1, 1],
            (MOI.VectorAffineFunction{T}, MOI.HyperRectangle{T}) => [T[1]],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            T[6, 6],
            (MOI.VectorAffineFunction{T}, MOI.HyperRectangle{T}) => [T[-1]],
        ),
    )
    MOI.Test.test_linear_integration_Interval(bridged_mock, config)
    return
end

function test_runtests(T)
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IntervalToHyperRectangleBridge,
        model -> begin
            x = MOI.add_variable(model)
            MOI.add_constraint(model, x, MOI.Interval{T}(3, 5))
        end,
        model -> begin
            x = MOI.add_variable(model)
            MOI.add_constraint(
                model,
                MOI.VectorOfVariables([x]),
                MOI.HyperRectangle(T[3], T[5]),
            )
        end,
        eltype = T,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IntervalToHyperRectangleBridge,
        model -> begin
            x = MOI.add_variable(model)
            MOI.add_constraint(model, T(2) * x, MOI.Interval{T}(3, 5))
        end,
        model -> begin
            x = MOI.add_variable(model)
            MOI.add_constraint(
                model,
                MOI.Utilities.vectorize([T(2) * x]),
                MOI.HyperRectangle(T[3], T[5]),
            )
        end,
        eltype = T,
    )
    return
end

function test_modify_ScalarCoefficientChange(T)
    inner = MOI.Utilities.Model{T}()
    model = MOI.Bridges.Constraint.IntervalToHyperRectangle{T}(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, T(1) * x, MOI.Interval(T(0), T(1)))
    @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), T(1) * x)
    MOI.modify(model, c, MOI.ScalarCoefficientChange(x, T(2)))
    @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), T(2) * x)
    return
end

end  # module

TestConstraintIntervalToHyperRectangle.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module SDPA

# See http://plato.asu.edu/ftp/sdpa_format.txt

import ..FileFormats
import MathOptInterface as MOI

MOI.Utilities.@model(
    Model,
    (),
    (),
    (MOI.Nonnegatives, MOI.PositiveSemidefiniteConeTriangle),
    (),
    (),
    (),
    (),
    (MOI.VectorAffineFunction,)
)

function MOI.supports_constraint(
    ::Model{T},
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.Utilities.SUPPORTED_VARIABLE_SCALAR_SETS{T}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::Model,
    ::Type{MOI.VariableIndex},
    ::Type{MOI.Integer},
)
    return true
end

MOI.supports(::Model, ::MOI.ObjectiveFunction) = false

function MOI.supports(
    ::Model{T},
    ::MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}},
) where {T}
    return true
end

struct Options end

get_options(m::Model) = get(m.ext, :SDPA_OPTIONS, Options())

"""
    Model(; coefficient_type::Type{T} = Float64) where {T}

Create an empty instance of `FileFormats.SDPA.Model{T}`.

It is important to be aware that the SDPA file format is interpreted in
*geometric* form and not *standard conic* form.
The *standard conic* form and *geometric conic* form are two dual standard forms
for semidefinite programs (SDPs).
The *geometric conic* form of an SDP is as follows:
```math
\\begin{align}
& \\min_{y \\in \\mathbb{R}^m} & b^T y
\\\\
& \\;\\;\\text{s.t.} & \\sum_{i=1}^m A_i y_i - C & \\in \\mathbb{K}
\\end{align}
```
where ``\\mathcal{K}`` is a cartesian product of nonnegative orthant and
positive semidefinite matrices that align with a block diagonal structure
shared with the matrices `A_i` and `C`.

In other words, the geometric conic form contains free variables and affine
constraints in either the nonnegative orthant or the positive semidefinite cone.
That is, in the MathOptInterface's terminology,
[`MOI.VectorAffineFunction`](@ref)-in-[`MOI.Nonnegatives`](@ref)
and
[`MOI.VectorAffineFunction`](@ref)-in-[`MOI.PositiveSemidefiniteConeTriangle`](@ref)
constraints.

The corresponding *standard conic* form of the dual SDP is as follows:
```math
\\begin{align}
& \\max_{X \\in \\mathbb{K}} & \\text{tr}(CX)
\\\\
& \\;\\;\\text{s.t.} & \\text{tr}(A_iX) & = b_i & i = 1, \\ldots, m.
\\end{align}
```

In other words, the standard conic form contains nonnegative and positive
semidefinite variables with equality constraints.
That is, in the MathOptInterface's terminology,
[`MOI.VectorOfVariables`](@ref)-in-[`MOI.Nonnegatives`](@ref),
[`MOI.VectorOfVariables`](@ref)-in-[`MOI.PositiveSemidefiniteConeTriangle`](@ref)
and
[`MOI.ScalarAffineFunction`](@ref)-in-[`MOI.EqualTo`](@ref)
constraints.

If a model is in standard conic form, use `Dualization.jl` to transform it into
the geometric conic form before writting it. Otherwise, the nonnegative (resp.
positive semidefinite) variables will be bridged into free variables with
affine constraints constraining them to belong to the nonnegative orthant
(resp. positive semidefinite cone) by the
[`MOI.Bridges.Constraint.VectorFunctionizeBridge`](@ref). Moreover, equality
constraints will be bridged into pairs of affine constraints in the nonnegative
orthant by the
[`MOI.Bridges.Constraint.SplitIntervalBridge`](@ref)
and then the
[`MOI.Bridges.Constraint.VectorizeBridge`](@ref).

If a solver is in standard conic form, use `Dualization.jl` to transform the
model read into standard conic form before copying it to the solver. Otherwise,
the free variables will be bridged into pairs of variables in the nonnegative
orthant by the
[`MOI.Bridges.Variable.FreeBridge`](@ref)
and affine constraints will be bridged into equality constraints
by creating a slack variable by the
[`MOI.Bridges.Constraint.VectorSlackBridge`](@ref).
"""
function Model(;
    number_type::Type{T} = Float64,
    coefficient_type::Type{S} = number_type,
) where {T,S}
    model = Model{S}()
    model.ext[:SDPA_OPTIONS] = Options()
    return model
end

Base.summary(io::IO, ::Model) = print(io, "MOI.FileFormats.SDPA.Model")

# ==============================================================================
#
#   Base.write
#
# ==============================================================================

"""
    Base.write(io::IO, model::FileFormats.SDPA.Model)

Write `model` to `io` in the SemiDefinite Programming Application file format.
"""
function Base.write(io::IO, model::Model{T}) where {T}
    options = get_options(model)
    # Helper functions for MOI constraints.
    function model_cons(con_func, con_set)
        return MOI.get(model, MOI.ListOfConstraintIndices{con_func,con_set}())
    end
    con_function(con_idx) = MOI.get(model, MOI.ConstraintFunction(), con_idx)
    con_set(con_idx) = MOI.get(model, MOI.ConstraintSet(), con_idx)

    # Model name
    model_name = MOI.get(model, MOI.Name())
    if !isempty(model_name)
        # Lines starting with `"` are comments that should be ignored by a reader.
        println(io, '"', model_name)
    end

    num_vars = MOI.get(model, MOI.NumberOfVariables())
    println(io, num_vars)
    function _check_variable(vi::MOI.VariableIndex)
        if vi.value > num_vars
            error(
                "Non-contiguous variable indices not supported. This might " *
                "be due to deleted variables.",
            )
        end
    end

    nonneg = model_cons(MOI.VectorAffineFunction{T}, MOI.Nonnegatives)
    psd = model_cons(
        MOI.VectorAffineFunction{T},
        MOI.PositiveSemidefiniteConeTriangle,
    )
    println(io, length(nonneg) + length(psd))

    for block in eachindex(nonneg)
        print(io, -MOI.dimension(con_set(nonneg[block])))
        if block != length(nonneg) || !isempty(psd)
            print(io, " ")
        end
    end
    max_dim = 0
    for i in eachindex(psd)
        dim = MOI.side_dimension(con_set(psd[i]))
        max_dim = max(max_dim, dim)
        print(io, dim)
        if i != length(psd)
            print(io, " ")
        end
    end
    println(io)

    c = zeros(T, num_vars)
    sense = MOI.get(model, MOI.ObjectiveSense())
    if sense != MOI.FEASIBILITY_SENSE
        obj =
            MOI.get(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}())
        if !iszero(MOI.constant(obj))
            error(
                "Nonzero constant in objective function not supported. Note " *
                "that the constant may be added by the substitution of a " *
                "bridged variable.",
            )
        end
        for term in obj.terms
            _check_variable(term.variable)
            c[term.variable.value] = term.coefficient
        end
        if sense == MOI.MAX_SENSE
            for i in eachindex(c)
                c[i] = -c[i]
            end
        end
    end
    for i in eachindex(c)
        print(io, c[i])
        if i != length(c)
            print(io, " ")
        end
    end
    println(io)

    max_index_dim = MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(max_dim))
    index_map = Vector{Tuple{Int,Int}}(undef, max_index_dim)
    k = 0
    for col in 1:max_dim
        for row in 1:col
            k += 1
            index_map[k] = (row, col)
        end
    end

    function _print_entry(matrix, block, psd, k, value)
        if psd
            row, col = index_map[k]
        else
            row = k
            col = k
        end
        return println(io, matrix, ' ', block, ' ', row, ' ', col, ' ', value)
    end
    function _print_constraint(block, psd, ci::MOI.ConstraintIndex)
        func = MOI.Utilities.canonical(con_function(ci))
        F0 = MOI.constant(func)
        for k in eachindex(F0)
            if !iszero(F0[k])
                _print_entry(0, block, psd, k, -F0[k])
            end
        end
        for term in func.terms
            vi = term.scalar_term.variable
            _check_variable(vi)
            α = term.scalar_term.coefficient
            if !iszero(α)
                _print_entry(vi.value, block, psd, term.output_index, α)
            end
        end
    end
    for block in eachindex(nonneg)
        _print_constraint(block, false, nonneg[block])
    end
    for i in eachindex(psd)
        _print_constraint(length(nonneg) + i, true, psd[i])
    end

    # Integrality constraints.
    # Based on the extension: http://www.opt.tu-darmstadt.de/scipsdp/downloads/data_format.txt
    integer_cons = model_cons(MOI.VariableIndex, MOI.Integer)
    if length(integer_cons) > 0
        println(io, "*INTEGER")
        for con_idx in integer_cons
            println(io, "*$(con_function(con_idx).value)")
        end
    end
    return
end

# ==============================================================================
#
#   `Base.read!`
#
# ==============================================================================

# Convert a pair of row and column indices of a symmetric matrix into a vector
# index for the col-wise upper triangle
function mat_to_vec_idx(i::Int, j::Int)
    if i > j
        return mat_to_vec_idx(j, i)
    else
        return div((j - 1) * j, 2) + i
    end
end

function _dim_to_set(s::AbstractString)
    block_dim = parse(Int, s)
    if block_dim > 0
        return MOI.PositiveSemidefiniteConeTriangle(block_dim)
    else
        return MOI.Nonnegatives(-block_dim)
    end
end

function _split(line)
    # In some variations of SDPA, there is the comment:
    #
    # The special characters `,`, `(`, `)`, `{`, and `}` can be used as
    # punctuation and are ignored.
    #
    # As one example, see https://github.com/vsdp/SDPLIB
    line = replace(line, r"[,{}\(\)]"=>' ')
    return split(line)
end

"""
    Base.read!(io::IO, model::FileFormats.SDPA.Model)

Read `io` in the SDPA file format and store the result in `model`.
"""
function Base.read!(io::IO, model::Model{T}) where {T<:Real}
    if !MOI.is_empty(model)
        error("Cannot read in file because model is not empty.")
    end
    num_variables_read = false
    num_blocks = nothing
    block_sets = Union{MOI.PositiveSemidefiniteConeTriangle,MOI.Nonnegatives}[]
    block_sets_read = false
    objective_read = false
    integer_read = false
    scalar_vars = MOI.VariableIndex[]
    intvar_idx = Int[]
    c = nothing
    funcs = MOI.VectorAffineFunction{T}[]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    while !eof(io)
        line = strip(readline(io))
        # Skip blank lines and comments (SDPA comments start with `"`).
        if startswith(line, '"')
            continue
        end
        # The lines starting with * should also be skipped
        # according to http://plato.asu.edu/ftp/sdpa_format.txt.
        if startswith(line, '*')
            # Exceptions for integer variables
            if startswith(line, "*INTEGER")
                integer_read = true
            elseif integer_read
                if !num_variables_read
                    error(
                        "The number of variables should be given before *INTEGER section.",
                    )
                end
                push!(intvar_idx, parse(Int, strip(line[2:end])))
            end
            continue
        end
        if !num_variables_read
            if isempty(line)
                continue
            end
            num_variables_read = true
            # According to http://plato.asu.edu/ftp/sdpa_format.txt,
            # additional text after the number of variables should be ignored.
            scalar_vars =
                MOI.add_variables(model, parse(Int, first(_split(line))))
        elseif num_blocks === nothing
            if isempty(line)
                continue
            end
            # According to http://plato.asu.edu/ftp/sdpa_format.txt,
            # additional text after the number of blocks should be ignored.
            num_blocks = parse(Int, first(_split(line)))
        elseif !block_sets_read
            if isempty(line) && !iszero(num_blocks)
                continue
            end
            block_sets = _dim_to_set.(_split(line))
            block_sets_read = true
            if length(block_sets) != num_blocks
                error(
                    "The number of blocks ($num_blocks) does not match the length of the list of blocks dimensions ($(length(block_sets))).",
                )
            end
            for i in 1:num_blocks
                push!(
                    funcs,
                    MOI.VectorAffineFunction(
                        MOI.VectorAffineTerm{T}[],
                        zeros(T, MOI.dimension(block_sets[i])),
                    ),
                )
            end
        elseif !objective_read
            num_vars = MOI.get(model, MOI.NumberOfVariables())
            if isempty(line) && !iszero(num_vars)
                continue
            end
            objective_read = true
            c = parse.(T, _split(line))
            if length(c) != num_vars
                error(
                    "The number of variables ($num_vars) does not match the length of the list of coefficients for the objective function vector of coefficients ($(length(c))).",
                )
            end
            obj = zero(MOI.ScalarAffineFunction{T})
            for i in eachindex(c)
                if !iszero(c[i])
                    push!(obj.terms, MOI.ScalarAffineTerm(c[i], scalar_vars[i]))
                end
            end
            MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
        else
            if isempty(line)
                continue
            end
            values = _split(line)
            if length(values) != 5
                error(
                    "Invalid line specifying entry: $line. There are $(length(values)) values instead of 5.",
                )
            end
            matrix = parse(Int, values[1])
            block = parse(Int, values[2])
            row = parse(Int, values[3])
            col = parse(Int, values[4])
            if block_sets[block] isa MOI.PositiveSemidefiniteConeTriangle
                k = mat_to_vec_idx(row, col)
            else
                if row != col
                    error(
                        "Invalid line specifying entry: $line. `$row != $col` while block $block has dimension $(MOI.dimension(block_sets[block])) so it is a diagonal block.",
                    )
                end
                k = row
            end
            coef = parse(T, values[5])
            if iszero(matrix)
                if !iszero(coef)
                    funcs[block].constants[k] -= coef
                end
            else
                if !iszero(coef)
                    push!(
                        funcs[block].terms,
                        MOI.VectorAffineTerm(
                            k,
                            MOI.ScalarAffineTerm(coef, scalar_vars[matrix]),
                        ),
                    )
                end
            end
        end
    end
    for block in 1:(num_blocks::Int)
        MOI.add_constraint(model, funcs[block], block_sets[block])
    end
    for var_idx in intvar_idx
        MOI.add_constraint(model, scalar_vars[var_idx], MOI.Integer())
    end
    return
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    CountGreaterThanToMILPBridge{T,F} <: Bridges.Constraint.AbstractBridge

`CountGreaterThanToMILPBridge` implements the following reformulation:

  * ``(c, y, x) \\in CountGreaterThan()`` into a mixed-integer linear program.

## Source node

`CountGreaterThanToMILPBridge` supports:

  * `F` in [`MOI.CountGreaterThan`](@ref)

## Target nodes

`CountGreaterThanToMILPBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.GreaterThan{T}`](@ref)
"""
struct CountGreaterThanToMILPBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
} <: AbstractBridge
    f::F
    s::MOI.CountGreaterThan
    variables::Vector{MOI.VariableIndex}
    greater_than::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}},
    }
    equal_to::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
    }
    bounds::Vector{NTuple{2,T}}
end

const CountGreaterThanToMILP{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{CountGreaterThanToMILPBridge{T},OT}

function bridge_constraint(
    ::Type{CountGreaterThanToMILPBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.CountGreaterThan,
) where {T,F}
    return CountGreaterThanToMILPBridge{T,F}(
        f,
        s,
        MOI.VariableIndex[],
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}}[],
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}[],
        NTuple{2,T}[],
    )
end

function MOI.supports_constraint(
    ::Type{<:CountGreaterThanToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.CountGreaterThan},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:CountGreaterThanToMILPBridge},
)
    return Tuple{Type}[(MOI.ZeroOne,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:CountGreaterThanToMILPBridge{T}},
) where {T}
    return Tuple{Type,Type}[
        (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}),
        (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:CountGreaterThanToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.CountGreaterThan},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return CountGreaterThanToMILPBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::CountGreaterThanToMILPBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::CountGreaterThanToMILPBridge,
)
    return bridge.s
end

function MOI.delete(model::MOI.ModelLike, bridge::CountGreaterThanToMILPBridge)
    MOI.delete.(model, bridge.greater_than)
    empty!(bridge.greater_than)
    MOI.delete.(model, bridge.equal_to)
    empty!(bridge.equal_to)
    MOI.delete.(model, bridge.variables)
    empty!(bridge.variables)
    empty!(bridge.bounds)
    return
end

function MOI.get(
    bridge::CountGreaterThanToMILPBridge,
    ::MOI.NumberOfVariables,
)::Int64
    return length(bridge.variables)
end

function MOI.get(
    bridge::CountGreaterThanToMILPBridge,
    ::MOI.ListOfVariableIndices,
)
    return copy(bridge.variables)
end

function MOI.get(
    bridge::CountGreaterThanToMILPBridge,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64
    return length(bridge.variables)
end

function MOI.get(
    bridge::CountGreaterThanToMILPBridge,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
)
    return [
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}.(z.value) for
        z in bridge.variables
    ]
end

function MOI.get(
    bridge::CountGreaterThanToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return length(bridge.equal_to)
end

function MOI.get(
    bridge::CountGreaterThanToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return copy(bridge.equal_to)
end

function MOI.get(
    bridge::CountGreaterThanToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}},
)::Int64 where {T}
    return length(bridge.greater_than)
end

function MOI.get(
    bridge::CountGreaterThanToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    },
) where {T}
    return copy(bridge.greater_than)
end

MOI.Bridges.needs_final_touch(::CountGreaterThanToMILPBridge) = true

function _add_unit_expansion(
    bridge::CountGreaterThanToMILPBridge{T,F},
    model::MOI.ModelLike,
    S,
    bounds,
    x,
    i,
) where {T,F}
    ret = MOI.Utilities.get_bounds(model, bounds, x)
    if ret === nothing
        throw(MOI.Bridges.BridgeRequiresFiniteDomainError(bridge, x))
    end
    if length(bridge.bounds) < i
        # This is the first time calling final_touch
        push!(bridge.bounds, ret)
    elseif bridge.bounds[i] == ret
        # We've called final_touch before, and the bounds match. No need to
        # reformulate a second time.
        return
    elseif bridge.bounds[i] != ret
        # There is a stored bound, and the current bounds do not match. This
        # means the model has been modified since the previous call to
        # final_touch. We need to delete the bridge and start again.
        MOI.delete(model, bridge)
        MOI.Bridges.final_touch(bridge, model)
        return
    end
    unit_f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], zero(T))
    convex_f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], zero(T))
    for xi in (ret[1]::T):(ret[2]::T)
        new_var, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
        push!(bridge.variables, new_var)
        if !haskey(S, xi)
            S[xi] = Tuple{T,MOI.VariableIndex}[]
        end
        push!(S[xi], new_var)
        push!(unit_f.terms, MOI.ScalarAffineTerm(T(-xi), new_var))
        push!(convex_f.terms, MOI.ScalarAffineTerm(one(T), new_var))
    end
    push!(
        bridge.equal_to,
        MOI.Utilities.normalize_and_add_constraint(
            model,
            MOI.Utilities.operate(+, T, x, unit_f),
            MOI.EqualTo(zero(T));
            allow_modify_function = true,
        ),
    )
    push!(
        bridge.equal_to,
        MOI.add_constraint(model, convex_f, MOI.EqualTo(one(T))),
    )
    return
end

function MOI.Bridges.final_touch(
    bridge::CountGreaterThanToMILPBridge{T,F},
    model::MOI.ModelLike,
) where {T,F}
    Sx = Dict{T,Vector{MOI.VariableIndex}}()
    Sy = Dict{T,Vector{MOI.VariableIndex}}()
    scalars = collect(MOI.Utilities.eachscalar(bridge.f))
    bounds = Dict{MOI.VariableIndex,NTuple{2,T}}()
    _add_unit_expansion(bridge, model, Sy, bounds, scalars[2], 1)
    for i in 3:length(scalars)
        _add_unit_expansion(bridge, model, Sx, bounds, scalars[i], i - 1)
    end
    # We use a sort so that the model order is deterministic.
    for s in sort!(collect(keys(Sy)))
        if haskey(Sx, s)
            M = length(Sx[s])
            terms = [MOI.ScalarAffineTerm(one(T), x) for x in Sx[s]]
            push!(terms, MOI.ScalarAffineTerm(T(M), first(Sy[s])))
            f = MOI.Utilities.operate(
                -,
                T,
                scalars[1],
                MOI.ScalarAffineFunction(terms, zero(T)),
            )
            ci = MOI.Utilities.normalize_and_add_constraint(
                model,
                f,
                MOI.GreaterThan(T(1 - M));
                allow_modify_function = true,
            )
            push!(bridge.greater_than, ci)
        end
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    IntegerToZeroOneBridge{T} <: Bridges.Constraint.AbstractBridge

`IntegerToZeroOneBridge` implements the following reformulation:

  * ``x \\in \\mathbf{Z}`` into ``y_i \\in \\{0, 1\\}``,
    ``x == lb + \\sum 2^{i-1} y_i``.

## Source node

`IntegerToZeroOneBridge` supports:

  * `VariableIndex` in [`MOI.Integer`](@ref)

## Target nodes

`IntegerToZeroOneBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo{T}`](@ref)

## Developer note

This bridge is implemented as a constraint bridge instead of a variable bridge
because we don't want to substitute the linear combination of `y` for every
instance of `x`. Doing so would be expensive and greatly reduce the sparsity of
the constraints.
"""
mutable struct IntegerToZeroOneBridge{T} <: AbstractBridge
    x::MOI.VariableIndex
    y::Vector{MOI.VariableIndex}
    ci::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}
    last_bounds::Union{Nothing,NTuple{2,T}}

    function IntegerToZeroOneBridge{T}(x::MOI.VariableIndex) where {T}
        return new{T}(
            x,
            MOI.VariableIndex[],
            MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}(0),
            nothing,
        )
    end
end

const IntegerToZeroOne{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{IntegerToZeroOneBridge{T},OT}

function bridge_constraint(
    ::Type{IntegerToZeroOneBridge{T}},
    ::MOI.ModelLike,
    x::MOI.VariableIndex,
    ::MOI.Integer,
) where {T}
    # !!! info
    #     Postpone creation until final_touch.
    return IntegerToZeroOneBridge{T}(x)
end

function MOI.supports_constraint(
    ::Type{IntegerToZeroOneBridge{T}},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.Integer},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:IntegerToZeroOneBridge},
)
    return Tuple{Type}[(MOI.ZeroOne,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{IntegerToZeroOneBridge{T}},
) where {T}
    return Tuple{Type,Type}[(MOI.ScalarAffineFunction{T}, MOI.EqualTo{T})]
end

function concrete_bridge_type(
    ::Type{IntegerToZeroOneBridge{T}},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.Integer},
) where {T}
    return IntegerToZeroOneBridge{T}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::IntegerToZeroOneBridge,
)
    return bridge.x
end

function MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, ::IntegerToZeroOneBridge)
    return MOI.Integer()
end

function MOI.delete(model::MOI.ModelLike, bridge::IntegerToZeroOneBridge)
    MOI.delete(model, bridge.ci)
    MOI.delete(model, bridge.y)
    return
end

function MOI.get(bridge::IntegerToZeroOneBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.y)
end

function MOI.get(bridge::IntegerToZeroOneBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.y)
end

function MOI.get(
    bridge::IntegerToZeroOneBridge,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64
    return length(bridge.y)
end

function MOI.get(
    bridge::IntegerToZeroOneBridge,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
)
    return map(bridge.y) do y
        return MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(y.value)
    end
end

function MOI.get(
    bridge::IntegerToZeroOneBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return 1
end

function MOI.get(
    bridge::IntegerToZeroOneBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return [bridge.ci]
end

MOI.Bridges.needs_final_touch(::IntegerToZeroOneBridge) = true

function MOI.Bridges.final_touch(
    bridge::IntegerToZeroOneBridge{T},
    model::MOI.ModelLike,
) where {T}
    ret = MOI.Utilities.get_bounds(model, T, bridge.x)
    if ret === bridge.last_bounds
        return nothing  # final_touch already called
    elseif ret[1] == typemin(T) || ret[2] == typemax(T)
        throw(MOI.Bridges.BridgeRequiresFiniteDomainError(bridge, bridge.x))
    end
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), bridge.x)], T(0))
    lb, ub = ceil(Int, ret[1]), floor(Int, ret[2])
    N = floor(Int, log2(ub - lb)) + 1
    for i in 1:N
        y, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
        push!(bridge.y, y)
        push!(f.terms, MOI.ScalarAffineTerm(-(T(2)^(i - 1)), y))
    end
    bridge.ci = MOI.add_constraint(model, f, MOI.EqualTo{T}(lb))
    bridge.last_bounds = ret
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestMOF

using Test

import JSON3
import JSONSchema
import MathOptInterface as MOI

const MOF = MOI.FileFormats.MOF

const TEST_MOF_FILE = "test.mof.json"

const SCHEMA = JSONSchema.Schema(
    JSON3.read(read(MOI.FileFormats.MOF.SCHEMA_PATH, String), Dict{String,Any}),
)

function runtests()
    for name in names(@__MODULE__, all = true)
        if startswith("$(name)", "test_")
            @testset "$name" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    sleep(1.0)  # allow time for unlink to happen
    rm(TEST_MOF_FILE, force = true)
    rm(TEST_MOF_FILE * ".gz", force = true)
    return
end

function _validate(filename::String)
    MOI.FileFormats.compressed_open(
        filename,
        "r",
        MOI.FileFormats.AutomaticCompression(),
    ) do io
        object = JSON3.read(io, Dict{String,Any})
        ret = JSONSchema.validate(SCHEMA, object)
        if ret !== nothing
            error(
                "Unable to read file because it does not conform to the MOF " *
                "schema: ",
                ret,
            )
        end
        return
    end
    return
end

struct UnsupportedSet <: MOI.AbstractSet end

struct UnsupportedFunction <: MOI.AbstractFunction end

function _test_model_equality(
    model_string,
    variables,
    constraints;
    suffix = "",
    kwargs...,
)
    model = MOF.Model(; kwargs...)
    MOI.Utilities.loadfromstring!(model, model_string)
    MOI.write_to_file(model, TEST_MOF_FILE * suffix)
    model_2 = MOF.Model(; kwargs...)
    MOI.read_from_file(model_2, TEST_MOF_FILE * suffix)
    MOI.Test.util_test_models_equal(model, model_2, variables, constraints)
    _validate(TEST_MOF_FILE * suffix)
    return
end

# hs071
# min x1 * x4 * (x1 + x2 + x3) + x3
# st  x1 * x2 * x3 * x4 >= 25
#     x1^2 + x2^2 + x3^2 + x4^2 = 40
#     1 <= x1, x2, x3, x4 <= 5
struct ExprEvaluator <: MOI.AbstractNLPEvaluator
    objective::Expr
    constraints::Vector{Expr}
end
MOI.features_available(::ExprEvaluator) = [:ExprGraph]
MOI.initialize(::ExprEvaluator, features) = nothing
MOI.objective_expr(evaluator::ExprEvaluator) = evaluator.objective
MOI.constraint_expr(evaluator::ExprEvaluator, i::Int) = evaluator.constraints[i]

function HS071(x::Vector{MOI.VariableIndex})
    x1, x2, x3, x4 = x
    return MOI.NLPBlockData(
        MOI.NLPBoundsPair.([25, 40], [Inf, 40]),
        ExprEvaluator(
            :(x[$x1] * x[$x4] * (x[$x1] + x[$x2] + x[$x3]) + x[$x3]),
            [
                :(x[$x1] * x[$x2] * x[$x3] * x[$x4] >= 25.0),
                :(x[$x1]^2.0 + x[$x2]^2.0 + x[$x3]^2.0 + x[$x4]^2.0 == 40.0),
            ],
        ),
        true,
    )
end

function test_HS071()
    model = MOF.Model()
    x = MOI.add_variables(model, 4)
    for (index, variable) in enumerate(x)
        MOI.set(model, MOI.VariableName(), variable, "var_$(index)")
    end
    MOI.add_constraints(model, x, Ref(MOI.Interval(1.0, 5.0)))
    MOI.set(model, MOI.NLPBlock(), HS071(x))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.write_to_file(model, TEST_MOF_FILE)
    target = read(joinpath(@__DIR__, "nlp.mof.json"), String)
    target = replace(target, r"\s" => "")
    target = replace(target, "MathOptFormatModel" => "MathOptFormat Model")
    # Normalize .0 floats and integer representations in JSON
    normalize(x) = replace(x, ".0" => "")
    @test normalize(read(TEST_MOF_FILE, String)) == normalize(target)
    _validate(TEST_MOF_FILE)
    return
end

function test_read_HS071()
    model = MOF.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "nlp.mof.json"))
    @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) ==
          Tuple{Type,Type}[(MOI.VariableIndex, MOI.Interval{Float64})]
    x = MOI.get(model, MOI.ListOfVariableIndices())
    @test length(x) == 4
    @test MOI.get(model, MOI.VariableName(), x) == ["var_$i" for i in 1:4]
    block = MOI.get(model, MOI.NLPBlock())
    evaluator = block.evaluator
    MOI.initialize(evaluator, [:ExprGraph])
    hs071_block = HS071(x)
    hs071 = hs071_block.evaluator
    @test MOI.objective_expr(evaluator) == MOI.objective_expr(hs071)
    for i in 1:2
        @test MOI.constraint_expr(evaluator, i) == MOI.constraint_expr(hs071, i)
    end
    return
end

function test_nonlinear_error_handling()
    node_list = Dict{String,Any}[]
    string_to_variable = Dict{String,MOI.VariableIndex}()
    variable_to_string = Dict{MOI.VariableIndex,String}()
    # Test unsupported function for Expr -> MOF.
    @test_throws Exception MOF._convert_nonlinear_to_mof(
        :(not_supported_function(x)),
        node_list,
        variable_to_string,
    )
    # Test n-ary function with no arguments.
    @test_throws Exception MOF._convert_nonlinear_to_mof(
        :(min()),
        node_list,
        variable_to_string,
    )
    # Test unary function with two arguments.
    @test_throws Exception MOF._convert_nonlinear_to_mof(
        :(sin(x, y)),
        node_list,
        variable_to_string,
    )
    # Test binary function with one arguments.
    @test_throws Exception MOF._convert_nonlinear_to_mof(
        :(^(x)),
        node_list,
        variable_to_string,
    )
    # An expression with something other than :call as the head.
    @test_throws Exception MOF._convert_nonlinear_to_mof(
        :(a <= b <= c),
        node_list,
        variable_to_string,
    )
    # Hit the default fallback with an un-interpolated complex number.
    @test_throws Exception MOF._convert_nonlinear_to_mof(
        :(1 + 2im),
        node_list,
        variable_to_string,
    )
    # Invalid number of variables.
    @test_throws Exception MOF.substitute_variables(
        :(x[1] * x[2]),
        [MOI.VariableIndex(1)],
    )
    # Function-in-Set
    @test_throws Exception MOF.extract_function_and_set(:(foo in set))
    # Not a constraint.
    @test_throws Exception MOF.extract_function_and_set(:(x^2))
    # Two-sided constraints
    @test MOF.extract_function_and_set(:(1 <= x <= 2)) ==
          MOF.extract_function_and_set(:(2 >= x >= 1)) ==
          (:x, MOI.Interval(1, 2))
    # Less-than constraint.
    @test MOF.extract_function_and_set(:(x <= 2)) == (:x, MOI.LessThan(2))
end

function _convert_mof_to_expr(
    node::String,
    ::Vector,
    name_map::Dict{String,MOI.VariableIndex},
)
    return name_map[node]
end

function _convert_mof_to_expr(
    node::Real,
    ::Vector,
    ::Dict{String,MOI.VariableIndex},
)
    return node
end

function _convert_mof_to_expr(
    node::T,
    node_list::Vector{T},
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    head = haskey(node, :type) ? node[:type] : node[:head]
    if head == "real"
        return node[:value]
    elseif head == "complex"
        return Complex(node[:real], node[:imag])
    elseif head == "variable"
        return name_map[node[:name]]
    elseif head == "node"
        return _convert_mof_to_expr(
            node_list[node[:index]],
            node_list,
            name_map,
        )
    else
        expr = Expr(:call, Symbol(head))
        for arg in node[:args]
            push!(expr.args, _convert_mof_to_expr(arg, node_list, name_map))
        end
        return expr
    end
end

function test_Roundtrip_nonlinear_expressions()
    x = MOI.VariableIndex(123)
    y = MOI.VariableIndex(456)
    z = MOI.VariableIndex(789)
    string_to_var = Dict{String,MOI.VariableIndex}("x" => x, "y" => y, "z" => z)
    var_to_string = Dict{MOI.VariableIndex,String}(x => "x", y => "y", z => "z")
    for expr in [
        2,
        2.34,
        2 + 3im,
        x,
        :(1 + $x),
        :($x - 1),
        :($x + $y),
        :($x + $y - $z),
        :(2 * $x),
        :($x * $y),
        :($x / 2),
        :(2 / $x),
        :($x / $y),
        :($x / $y / $z),
        :(2^$x),
        :($x^2),
        :($x^$y),
        :($x^(2 * $y + 1)),
        :(sin($x)),
        :(sin($x + $y)),
        :(2 * $x + sin($x)^2 + $y),
        :(sin($(3im))^2 + cos($(3im))^2),
        :($(1 + 2im) * $x),
        :(ceil($x)),
        :(floor($x)),
        :($x < $y),
        :($x <= $y),
        :($x > $y),
        :($x >= $y),
        :($x == $y),
        :($x != $y),
        # :($x && $y), :($x || $y),
        :(ifelse($x > 0, 1, $y)),
    ]
        node_list = Any[]
        object = MOF._convert_nonlinear_to_mof(expr, node_list, var_to_string)
        @test _convert_mof_to_expr(object, node_list, string_to_var) == expr
    end
    return
end

function test_nonlinear_readingwriting()
    model = MOF.Model()
    (x, y) = MOI.add_variables(model, 2)
    MOI.set(model, MOI.VariableName(), x, "var_x")
    MOI.set(model, MOI.VariableName(), y, "y")
    con = MOI.add_constraint(
        model,
        MOF.Nonlinear(:(2 * $x + sin($x)^2 - $y)),
        MOI.EqualTo(1.0),
    )
    MOI.set(model, MOI.ConstraintName(), con, "con")
    MOI.write_to_file(model, TEST_MOF_FILE)
    # Read the model back in.
    model2 = MOF.Model()
    MOI.read_from_file(model2, TEST_MOF_FILE)
    block = MOI.get(model2, MOI.NLPBlock())
    MOI.initialize(block.evaluator, [:ExprGraph])
    @test MOI.constraint_expr(block.evaluator, 1) ==
          :(2.0 * x[$x] + sin(x[$x])^2.0 - x[$y] == 1.0)
    _validate(TEST_MOF_FILE)
    return
end

function test_show()
    @test sprint(summary, MOF.Model()) == "MOI.FileFormats.MOF.Model"
end

function test_nonempty_model()
    model = MOF.Model(warn = true)
    MOI.add_variable(model)
    @test !MOI.is_empty(model)
    exception = ErrorException(
        "Cannot read model from file as destination model is not empty.",
    )
    @test_throws exception MOI.read_from_file(
        model,
        joinpath(@__DIR__, "empty_model.mof.json"),
    )
    options = MOF.get_options(model)
    @test options.warn
    MOI.empty!(model)
    @test MOI.is_empty(model)
    MOI.read_from_file(model, joinpath(@__DIR__, "empty_model.mof.json"))
    options2 = MOF.get_options(model)
    @test options2.warn
end

function test_failing_models()
    @testset "$(filename)" for filename in filter(
        f -> endswith(f, ".mof.json"),
        readdir(joinpath(@__DIR__, "failing_models")),
    )
        @test_throws Exception MOI.read_from_file(
            MOF.Model(),
            joinpath(@__DIR__, "failing_models", filename),
        )
    end
end

function test_Blank_variable_name()
    model = MOF.Model()
    variable = MOI.add_variable(model)
    @test_throws Exception MOF.moi_to_object(variable, model)
    MOI.FileFormats.create_unique_names(model, warn = true)
    @test MOF.moi_to_object(variable, model) == (name = "x1",)
end

function test_Duplicate_variable_name()
    model = MOF.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), y, "x")
    @test MOF.moi_to_object(x, model) == (name = "x",)
    @test MOF.moi_to_object(y, model) == (name = "x",)
    MOI.FileFormats.create_unique_names(model, warn = true)
    @test MOF.moi_to_object(x, model) == (name = "x",)
    @test MOF.moi_to_object(y, model) == (name = "x_1",)
end

function test_Blank_constraint_name()
    model = MOF.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0)
    c = MOI.add_constraint(model, f, MOI.ZeroOne())
    name_map = Dict(x => "x")
    MOI.FileFormats.create_unique_names(model, warn = true)
    @test MOF.moi_to_object(c, model, name_map)[:name] == "c1"
end

function test_Duplicate_constraint_name()
    model = MOF.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0)
    c1 = MOI.add_constraint(model, f, MOI.LessThan(1.0))
    c2 = MOI.add_constraint(model, f, MOI.GreaterThan(0.0))
    MOI.set(model, MOI.ConstraintName(), c1, "c")
    MOI.set(model, MOI.ConstraintName(), c2, "c")
    name_map = Dict(x => "x")
    @test MOF.moi_to_object(c1, model, name_map)[:name] == "c"
    @test MOF.moi_to_object(c2, model, name_map)[:name] == "c"
    MOI.FileFormats.create_unique_names(model, warn = true)
    @test MOF.moi_to_object(c1, model, name_map)[:name] == "c_1"
    @test MOF.moi_to_object(c2, model, name_map)[:name] == "c"
end

function test_empty_model()
    model = MOF.Model()
    MOI.write_to_file(model, TEST_MOF_FILE)
    model_2 = MOF.Model()
    MOI.read_from_file(model_2, TEST_MOF_FILE)
    return MOI.Test.util_test_models_equal(model, model_2, String[], String[])
end

function test_FEASIBILITY_SENSE()
    model = MOF.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    MOI.write_to_file(model, TEST_MOF_FILE)
    model_2 = MOF.Model()
    MOI.read_from_file(model_2, TEST_MOF_FILE)
    return MOI.Test.util_test_models_equal(model, model_2, ["x"], String[])
end

function test_empty_function_term()
    model = MOF.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{Float64}[], 0.0),
        MOI.GreaterThan(1.0),
    )
    MOI.set(model, MOI.ConstraintName(), c, "c")
    MOI.write_to_file(model, TEST_MOF_FILE)
    model_2 = MOF.Model()
    MOI.read_from_file(model_2, TEST_MOF_FILE)
    return MOI.Test.util_test_models_equal(model, model_2, ["x"], ["c"])
end

function test_min_objective()
    return _test_model_equality(
        """
variables: x
minobjective: x
""",
        ["x"],
        String[],
    )
end

function test_max_objective()
    return _test_model_equality(
        """
variables: x
maxobjective: x
""",
        ["x"],
        String[],
        suffix = ".gz",
    )
end

function test_min_scalaraffine()
    return _test_model_equality(
        """
variables: x
minobjective: 1.2x + 0.5
""",
        ["x"],
        String[],
    )
end

function test_max_scalaraffine()
    return _test_model_equality(
        """
variables: x
maxobjective: 1.2x + 0.5
""",
        ["x"],
        String[],
        suffix = ".gz",
    )
end

function test_min_vector_of_variables()
    return _test_model_equality(
        """
variables: x, y
minobjective: [x, y]
""",
        ["x", "y"],
        String[],
    )
end

function test_max_vector_affine()
    return _test_model_equality(
        """
variables: x, y
maxobjective: [1.0 * x, 2.0 * y, 3.0 * x + 4.0 * y + 5.0]
""",
        ["x", "y"],
        String[],
    )
end

function test_max_vector_quadratic()
    return _test_model_equality(
        """
variables: x, y
maxobjective: [1.0 * x * x + 2.0 * x * y]
""",
        ["x", "y"],
        String[],
    )
end

function test_singlevariable_in_lower()
    return _test_model_equality(
        """
variables: x
minobjective: 1.2x + 0.5
x >= 1.0
""",
        ["x"],
        String[],
    )
end

function test_singlevariable_in_upper()
    return _test_model_equality(
        """
variables: x
maxobjective: 1.2x + 0.5
x <= 1.0
""",
        ["x"],
        String[],
        suffix = ".gz",
    )
end

function test_singlevariable_in_interval()
    return _test_model_equality(
        """
variables: x
minobjective: 1.2x + 0.5
x in Interval(1.0, 2.0)
""",
        ["x"],
        String[],
    )
end

function test_singlevariable_in_equalto()
    return _test_model_equality(
        """
variables: x
minobjective: 1.2x + 0.5
x == 1.0
""",
        ["x"],
        String[],
    )
end

function test_singlevariable_in_zeroone()
    return _test_model_equality(
        """
variables: x
minobjective: 1.2x + 0.5
x in ZeroOne()
""",
        ["x"],
        String[],
    )
end

function test_singlevariable_in_integer()
    return _test_model_equality(
        """
variables: x
minobjective: 1.2x + 0.5
x in Integer()
""",
        ["x"],
        String[],
    )
end

function test_singlevariable_in_Semicontinuous()
    return _test_model_equality(
        """
variables: x
minobjective: 1.2x + 0.5
x in Semicontinuous(1.0, 2.0)
""",
        ["x"],
        String[],
    )
end

function test_singlevariable_in_Semiinteger()
    return _test_model_equality(
        """
variables: x
minobjective: 1.2x + 0.5
x in Semiinteger(1.0, 2.0)
""",
        ["x"],
        String[],
    )
end

function test_scalarquadratic_objective()
    return _test_model_equality(
        """
variables: x
minobjective: 1.0*x*x + -2.0x + 1.0
""",
        ["x"],
        String[],
    )
end

function test_SOS1()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in SOS1([1.0, 2.0, 3.0])
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_SOS2()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in SOS2([1.0, 2.0, 3.0])
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_Reals()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in Reals(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_Zeros()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in Zeros(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_Nonnegatives()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in Nonnegatives(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_Nonpositives()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in Nonpositives(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_PowerCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in PowerCone(2.0)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_DualPowerCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in DualPowerCone(0.5)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_GeometricMeanCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in GeometricMeanCone(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_Complements()
    return _test_model_equality(
        "variables: x, y\nc1: [x, y] in Complements(2)",
        ["x", "y"],
        ["c1"],
    )
end

function test_vectoraffine_in_zeros()
    return _test_model_equality(
        """
variables: x, y
minobjective: x
c1: [1.0x + -3.0, 2.0y + -4.0] in Zeros(2)
""",
        ["x", "y"],
        ["c1"],
    )
end

function test_vectorquadratic_in_nonnegatives()
    return _test_model_equality(
        """
variables: x, y
minobjective: x
c1: [1.0*x*x + -2.0x + 1.0, 2.0y + -4.0] in Nonnegatives(2)
""",
        ["x", "y"],
        ["c1"],
    )
end

function test_scalarnonlinearfunction_objective()
    return _test_model_equality(
        """
variables: x
minobjective: ScalarNonlinearFunction(exp(x))
""",
        ["x"],
        String[],
    )
end

function test_scalarnonlinearfunction_constraint()
    return _test_model_equality(
        """
variables: x
c1: ScalarNonlinearFunction(exp(x)^2) <= 1.0
""",
        ["x"],
        ["c1"],
    )
end

function test_vectornonlinearfunction_objective()
    return _test_model_equality(
        """
variables: x
minobjective: VectorNonlinearFunction([exp(x), sin(x)^2])
""",
        ["x"],
        String[],
    )
end

function test_vectornonlinearfunction_constraint()
    return _test_model_equality(
        """
variables: x
c1: VectorNonlinearFunction([exp(x), x]) in Complements(2)
""",
        ["x"],
        ["c1"],
    )
end

function test_ExponentialCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in ExponentialCone()
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_DualExponentialCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in DualExponentialCone()
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_SecondOrderCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in SecondOrderCone(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_RotatedSecondOrderCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in RotatedSecondOrderCone(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_PositiveSemidefiniteConeTriangle()
    return _test_model_equality(
        """
variables: x1, x2, x3
minobjective: x1
c1: [x1, x2, x3] in PositiveSemidefiniteConeTriangle(2)
""",
        ["x1", "x2", "x3"],
        ["c1"],
    )
end

function test_ScaledPositiveSemidefiniteConeTriangle()
    return _test_model_equality(
        """
variables: x1, x2, x3
minobjective: x1
c1: [x1, x2, x3] in ScaledPositiveSemidefiniteConeTriangle(2)
""",
        ["x1", "x2", "x3"],
        ["c1"],
    )
end

function test_Scaled_PositiveSemidefiniteConeTriangle()
    return _test_model_equality(
        """
variables: x1, x2, x3
minobjective: x1
c1: [x1, x2, x3] in Scaled(PositiveSemidefiniteConeTriangle(2))
""",
        ["x1", "x2", "x3"],
        ["c1"],
    )
end

function test_PositiveSemidefiniteConeSquare()
    return _test_model_equality(
        """
variables: x1, x2, x3, x4
minobjective: x1
c1: [x1, x2, x3, x4] in PositiveSemidefiniteConeSquare(2)
""",
        ["x1", "x2", "x3", "x4"],
        ["c1"],
    )
end

function test_HermitianPositiveSemidefiniteConeTriangle()
    return _test_model_equality(
        """
variables: x1, x2, x3, x4
c1: [x1, x2, x3, x4] in HermitianPositiveSemidefiniteConeTriangle(2)
""",
        ["x1", "x2", "x3", "x4"],
        ["c1"],
    )
end

function test_LogDetConeTriangle()
    return _test_model_equality(
        """
variables: t, u, x1, x2, x3
minobjective: x1
c1: [t, u, x1, x2, x3] in LogDetConeTriangle(2)
""",
        ["t", "u", "x1", "x2", "x3"],
        ["c1"],
    )
end

function test_LogDetConeSquare()
    return _test_model_equality(
        """
variables: t, u, x1, x2, x3, x4
minobjective: x1
c1: [t, u, x1, x2, x3, x4] in LogDetConeSquare(2)
""",
        ["t", "u", "x1", "x2", "x3", "x4"],
        ["c1"],
    )
end

function test_RootDetConeTriangle()
    return _test_model_equality(
        """
variables: t, x1, x2, x3
minobjective: x1
c1: [t, x1, x2, x3] in RootDetConeTriangle(2)
""",
        ["t", "x1", "x2", "x3"],
        ["c1"],
    )
end

function test_RootDetConeSquare()
    return _test_model_equality(
        """
variables: t, x1, x2, x3, x4
minobjective: x1
c1: [t, x1, x2, x3, x4] in RootDetConeSquare(2)
""",
        ["t", "x1", "x2", "x3", "x4"],
        ["c1"],
    )
end

function test_Indicator()
    _test_model_equality(
        """
variables: x, y
minobjective: x
c1: [x, y] in Indicator{ACTIVATE_ON_ONE}(GreaterThan(1.0))
""",
        ["x", "y"],
        ["c1"],
    )

    return _test_model_equality(
        """
variables: x, y
minobjective: x
c1: [x, y] in Indicator{ACTIVATE_ON_ZERO}(GreaterThan(1.0))
""",
        ["x", "y"],
        ["c1"],
    )
end

function test_NormOneCone()
    return _test_model_equality(
        """
variables: x, y
minobjective: x
c1: [x, y] in NormOneCone(2)
""",
        ["x", "y"],
        ["c1"],
    )
end

function test_NormInfinityCone()
    return _test_model_equality(
        """
variables: x, y
minobjective: x
c1: [x, y] in NormInfinityCone(2)
""",
        ["x", "y"],
        ["c1"],
    )
end

function test_NormCone()
    return _test_model_equality(
        """
variables: x, y
minobjective: x
c1: [x, y] in NormCone(1.5, 2)
""",
        ["x", "y"],
        ["c1"],
    )
end

function test_RelativeEntropyCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in RelativeEntropyCone(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_NormSpectralCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in NormSpectralCone(1, 2)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_NormNuclearCone()
    return _test_model_equality(
        """
variables: x, y, z
minobjective: x
c1: [x, y, z] in NormNuclearCone(1, 2)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_v04()
    model = MOF.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "v0.4.mof.json"))
    model_2 = MOF.Model()
    MOI.Utilities.loadfromstring!(
        model_2,
        """
variables: x, y
minobjective: x
c: x + y >= 1.0
x in Interval(0.0, 1.0)
y in ZeroOne()
""",
    )
    MOI.Test.util_test_models_equal(model, model_2, ["x", "y"], ["c"])
    return
end

function test_AllDifferent()
    return _test_model_equality(
        """
variables: x, y, z
c1: [x, y, z] in AllDifferent(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_BinPacking()
    return _test_model_equality(
        """
variables: x, y, z
c1: [x, y, z] in BinPacking(3.0, [1.0, 2.0, 3.0])
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_Circuit()
    return _test_model_equality(
        """
variables: x, y, z
c1: [x, y, z] in Circuit(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_CountAtLeast()
    return _test_model_equality(
        """
variables: x, y, z
c1: [x, y, y, z] in CountAtLeast(1, [2, 2], Set([3]))
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_CountBelongs()
    return _test_model_equality(
        """
variables: x, y, z
c1: [x, y, z] in CountBelongs(3, Set([3, 4, 5]))
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_CountDistinct()
    return _test_model_equality(
        """
variables: x, y, z
c1: [x, y, z] in CountDistinct(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_CountGreaterThan()
    return _test_model_equality(
        """
variables: x, y, z
c1: [x, y, z] in CountGreaterThan(3)
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_Cumulative()
    return _test_model_equality(
        """
variables: a, b, c, d, e, f, g, h, i, j
c1: [a, b, c, d, e, f, g, h, i, j] in Cumulative(10)
""",
        ["a", "b", "c", "d", "e", "f", "g", "h", "i", "j"],
        ["c1"],
    )
end

function test_Path()
    return _test_model_equality(
        """
variables: s, t, n1, n2, n3, n4, e1, e2, e3, e4, e5
c1: [s, t, n1, n2, n3, n4, e1, e2, e3, e4, e5] in Path([1, 1, 2, 2, 3], [2, 3, 3, 4, 4])
""",
        ["s", "t", "n1", "n2", "n3", "n4", "e1", "e2", "e3", "e4", "e5"],
        ["c1"],
    )
end

function test_Table()
    return _test_model_equality(
        """
variables: x, y, z
c1: [x, y, z] in Table([1.0 1.0 0.0; 0.0 0.0 0.0])
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_Parameter()
    return _test_model_equality(
        """
constrainedvariable: x in Parameter(2.0)
""",
        ["x"],
        String[],
    )
end

function test_HyperRectangle()
    return _test_model_equality(
        """
variables: x, y, z
c1: [x, y, z] in HyperRectangle([1.0, 2.0, 3.0], [1.1, 2.2, 3.3])
""",
        ["x", "y", "z"],
        ["c1"],
    )
end

function test_Reified()
    return _test_model_equality(
        """
variables: x, y
minobjective: x
c1: [x, y] in Reified(GreaterThan(1.0))
""",
        ["x", "y"],
        ["c1"],
    )
end

function test_VariablePrimalStart()
    target = ("x" => nothing, "y" => 1.0, "z" => 1.23)
    model_w = MOF.Model()
    for (name, value) in target
        xi = MOI.add_variable(model_w)
        MOI.set(model_w, MOI.VariableName(), xi, name)
        MOI.set(model_w, MOI.VariablePrimalStart(), xi, value)
    end
    MOI.write_to_file(model_w, TEST_MOF_FILE)
    _validate(TEST_MOF_FILE)
    model_r = MOF.Model()
    MOI.read_from_file(model_r, TEST_MOF_FILE)
    for (name, value) in target
        xi = MOI.get(model_r, MOI.VariableIndex, name)
        @test MOI.get(model_r, MOI.VariablePrimalStart(), xi) === value
    end
    return
end

function test_constraint_start_scalar()
    target = Dict(
        "c1" => (nothing, nothing),
        "c2" => (1.23, 1.0),
        "c3" => (1.0, 1.23),
    )
    model_w = MOF.Model()
    x = MOI.add_variable(model_w)
    MOI.set(model_w, MOI.VariableName(), x, "x")
    for (name, (primal, dual)) in target
        c = MOI.add_constraint(model_w, 1.0 * x, MOI.LessThan(1.0))
        MOI.set(model_w, MOI.ConstraintName(), c, name)
        MOI.set(model_w, MOI.ConstraintPrimalStart(), c, primal)
        MOI.set(model_w, MOI.ConstraintDualStart(), c, dual)
    end
    MOI.write_to_file(model_w, TEST_MOF_FILE)
    _validate(TEST_MOF_FILE)
    model_r = MOF.Model()
    MOI.read_from_file(model_r, TEST_MOF_FILE)
    for (name, (primal, dual)) in target
        ci = MOI.get(model_r, MOI.ConstraintIndex, name)
        @test MOI.get(model_r, MOI.ConstraintPrimalStart(), ci) === primal
        @test MOI.get(model_r, MOI.ConstraintDualStart(), ci) === dual
    end
    return
end

function test_constraint_start_vector()
    target = Dict(
        "c1" => (nothing, nothing),
        "c2" => ([1.23, 4.56], [1.0, 2.0]),
        "c3" => ([3.0, 4.0], [7.89, -1.23]),
    )
    model_w = MOF.Model()
    x = MOI.add_variables(model_w, 2)
    MOI.set.(model_w, MOI.VariableName(), x, ["x", "y"])
    f = MOI.VectorOfVariables(x)
    for (name, (primal, dual)) in target
        c = MOI.add_constraint(model_w, f, MOI.Nonnegatives(2))
        MOI.set(model_w, MOI.ConstraintName(), c, name)
        MOI.set(model_w, MOI.ConstraintPrimalStart(), c, primal)
        MOI.set(model_w, MOI.ConstraintDualStart(), c, dual)
    end
    MOI.write_to_file(model_w, TEST_MOF_FILE)
    _validate(TEST_MOF_FILE)
    model_r = MOF.Model()
    MOI.read_from_file(model_r, TEST_MOF_FILE)
    _cmp(::Nothing, ::Nothing) = true
    _cmp(x::Vector{Float64}, y::Vector{Float64}) = x == y
    for (name, (primal, dual)) in target
        ci = MOI.get(model_r, MOI.ConstraintIndex, name)
        @test _cmp(MOI.get(model_r, MOI.ConstraintPrimalStart(), ci), primal)
        @test _cmp(MOI.get(model_r, MOI.ConstraintDualStart(), ci), dual)
    end
    return
end

function test_parse_int_coefficient_scalaraffineterm()
    x = MOI.VariableIndex(1)
    object = Dict{String,Any}("coefficient" => 2, "variable" => "x")
    @test MOF.parse_scalar_affine_term(Float64, object, Dict("x" => x)) ==
          MOI.ScalarAffineTerm{Float64}(2.0, x)
    return
end

function test_parse_int_coefficient_scalaraffinefunction()
    x = MOI.VariableIndex(1)
    object = Dict{String,Any}(
        "type" => "ScalarAffineFunction",
        "terms" => [],
        "constant" => 2,
    )
    @test MOF.function_to_moi(Float64, object, Dict("x" => x)) ≈
          MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{Float64}[], 2.0)
    return
end

function test_parse_int_coefficient_scalarquadraticterm()
    x = MOI.VariableIndex(1)
    object = Dict{String,Any}(
        "coefficient" => 2,
        "variable_1" => "x",
        "variable_2" => "x",
    )
    @test MOF.parse_scalar_quadratic_term(Float64, object, Dict("x" => x)) ==
          MOI.ScalarQuadraticTerm{Float64}(2.0, x, x)
    return
end

function test_parse_int_coefficient_scalarquadraticfunction()
    x = MOI.VariableIndex(1)
    object = Dict{String,Any}(
        "type" => "ScalarQuadraticFunction",
        "quadratic_terms" => [],
        "affine_terms" => [],
        "constant" => 2,
    )
    f = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm{Float64}[],
        MOI.ScalarAffineTerm{Float64}[],
        2.0,
    )
    @test MOF.function_to_moi(Float64, object, Dict("x" => x)) ≈ f
    return
end

function test_parse_constraintname_variable()
    io = IOBuffer()
    print(
        io,
        """{
    "version": {"major": 1, "minor": 2},
    "variables": [{"name": "x", "primal_start": 0.0}],
    "objective": {"sense": "min", "function": {"type": "Variable", "name": "x"}},
    "constraints": [{
        "name": "x >= 1",
        "function": {
            "type": "ScalarAffineFunction",
            "terms": [{"coefficient": 1, "variable": "x"}],
            "constant": 0
        },
        "set": {"type": "GreaterThan", "lower": 1},
        "primal_start": 1,
        "dual_start": 0
    }, {
        "name": "x ∈ [0, 1]",
        "function": {"type": "Variable", "name": "x"},
        "set": {"type": "Interval", "lower": 0, "upper": 1}
    }]
}""",
    )
    seekstart(io)
    model = MOF.Model()
    read!(io, model)
    x = MOI.get(model, MOI.VariableIndex, "x")
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    @test MOI.get(model, MOI.VariablePrimalStart(), x) == 0.0
    F, S = MOI.VariableIndex, MOI.Interval{Float64}
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    ci = first(MOI.get(model, MOI.ListOfConstraintIndices{F,S}()))
    @test MOI.get(model, MOI.ConstraintFunction(), ci) == x
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.Interval(0.0, 1.0)
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}
    @test isa(
        MOI.get(model, MOI.ConstraintIndex, "x >= 1"),
        MOI.ConstraintIndex{F,S},
    )
    return
end

function test_parse_nonlinear_objective_only()
    io = IOBuffer()
    print(
        io,
        """{
    "version": {"major": 1, "minor": 2},
    "variables": [{"name": "x"}],
    "objective": {
        "sense": "min",
        "function": {
            "type": "ScalarNonlinearFunction",
            "root": {"type": "node", "index": 1},
            "node_list": [{"type": "sin", "args": [{"type": "variable", "name": "x"}]}]
        }
    },
    "constraints": []
}""",
    )
    seekstart(io)
    model = MOF.Model()
    read!(io, model)
    block = MOI.get(model, MOI.NLPBlock())
    @test block isa MOI.NLPBlockData
    @test block.has_objective
    MOI.initialize(block.evaluator, Symbol[])
    @test MOI.eval_objective(block.evaluator, [2.0]) ≈ sin(2.0)
    return
end

function test_integer_coefficients()
    x = MOI.VariableIndex(1)
    names = Dict(x => "x")
    f = 2 * x * x + 3 * x + 4
    @test MOF.moi_to_object(f, names) == (
        type = "ScalarQuadraticFunction",
        affine_terms = [(coefficient = 3, variable = "x")],
        quadratic_terms = [(
            coefficient = 4,
            variable_1 = "x",
            variable_2 = "x",
        ),],
        constant = 4,
    )
    return
end

function test_ScaledPositiveSemidefiniteConeTriangle_set_to_moi()
    object = Dict(
        "type" => "ScaledPositiveSemidefiniteConeTriangle",
        "side_dimension" => 2,
    )
    @test MOF.set_to_moi(Int, object) ==
          MOI.Scaled(MOI.PositiveSemidefiniteConeTriangle(2))
    return
end

function test_nonlinear_variable_real_nodes()
    x = MOI.VariableIndex(1)
    object = Dict{String,Any}(
        "type" => "ScalarNonlinearFunction",
        "root" => MOF.Dict{String,Any}(
            "type" => "^",
            "args" => Any[
                Dict{String,Any}("type" => "node", "index" => 1),
                Dict{String,Any}("type" => "node", "index" => 2),
            ],
        ),
        "node_list" => Any[
            Dict{String,Any}("type" => "variable", "name" => "x"),
            Dict{String,Any}("type" => "real", "value" => 2.0),
        ],
    )
    f = MOI.ScalarNonlinearFunction(:^, Any[x, 2.0])
    @test MOF.function_to_moi(Float64, object, Dict("x" => x)) ≈ f
    return
end

function test_nonlinear_variable_complex_nodes()
    x = MOI.VariableIndex(1)
    object = Dict{String,Any}(
        "type" => "ScalarNonlinearFunction",
        "root" => MOF.Dict{String,Any}(
            "type" => "^",
            "args" => Any[
                Dict{String,Any}("type" => "node", "index" => 1),
                Dict{String,Any}("type" => "node", "index" => 2),
            ],
        ),
        "node_list" => Any[
            Dict{String,Any}("type" => "variable", "name" => "x"),
            Dict{String,Any}("type" => "complex", "real" => 2.0, "imag" => 3.0),
        ],
    )
    f = MOI.ScalarNonlinearFunction(:^, Any[x, 2.0+3im])
    @test MOF.function_to_moi(Float64, object, Dict("x" => x)) ≈ f
    return
end

function test_mof_scalaraffinefunction()
    x = MOI.VariableIndex(1)
    f = 1.0 * x + 2.0
    g = MOI.ScalarNonlinearFunction(:log, Any[f])
    name_map = Dict(x => "x")
    object = MOF.moi_to_object(g, name_map)
    object_dest = (
        type = "ScalarNonlinearFunction",
        root = (type = "node", index = 3),
        node_list = Any[
            (type = "*", args = [1.0, "x"]),
            (type = "+", args = [(type = "node", index = 1), 2.0]),
            (type = "log", args = Any[(type = "node", index = 2)]),
        ],
    )
    @test object == object_dest
    return
end

function test_mof_scalarquadraticfunction()
    x = MOI.VariableIndex(1)
    f = 1.0 * x * x + 2.0
    g = MOI.ScalarNonlinearFunction(:log, Any[f])
    name_map = Dict(x => "x")
    object = MOF.moi_to_object(g, name_map)
    object_dest = (
        type = "ScalarNonlinearFunction",
        root = (type = "node", index = 3),
        node_list = Any[
            (type = "*", args = [1.0, "x", "x"]),
            (type = "+", args = [(type = "node", index = 1), 2.0]),
            (type = "log", args = Any[(type = "node", index = 2)]),
        ],
    )
    @test object == object_dest
    return
end

function test_nonlinear_expression_not_call()
    model = MOF.Model()
    x = MOI.add_variable(model)
    expr = :($x[1])
    con = MOI.add_constraint(model, MOF.Nonlinear(expr), MOI.EqualTo(1.0))
    io = IOBuffer()
    @test_throws(
        ErrorException(
            "Expected an expression that was a function. Got $expr.",
        ),
        write(io, model),
    )
    return
end

function test_write_NLPBlock_no_objective()
    model = MOF.Model()
    x = MOI.add_variables(model, 4)
    for (index, variable) in enumerate(x)
        MOI.set(model, MOI.VariableName(), variable, "var_$(index)")
    end
    MOI.add_constraints(model, x, Ref(MOI.Interval(1.0, 5.0)))
    block = HS071(x)
    new_block =
        MOI.NLPBlockData(block.constraint_bounds, block.evaluator, false)
    MOI.set(model, MOI.NLPBlock(), new_block)
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    contents = read(io, String)
    @test occursin(""""objective":{"sense":"feasibility"}""", contents)
    return
end

function test_use_nlp_block()
    model = MOF.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    object = JSON3.read(io, Dict{String,Any})
    @test object["has_scalar_nonlinear"] == true
    @test JSONSchema.validate(SCHEMA, object) === nothing
    # Test (; use_nlp_block = nothing)
    seekstart(io)
    model = MOF.Model()
    read!(io, model)
    @test MOI.get(model, MOI.NLPBlock()) === nothing
    @test MOI.get(model, MOI.ObjectiveFunctionType()) ==
          MOI.ScalarNonlinearFunction
    # Test (; use_nlp_block = false)
    seekstart(io)
    model = MOF.Model(; use_nlp_block = false)
    read!(io, model)
    @test MOI.get(model, MOI.NLPBlock()) === nothing
    @test MOI.get(model, MOI.ObjectiveFunctionType()) ==
          MOI.ScalarNonlinearFunction
    # Test (; use_nlp_block = true)
    seekstart(io)
    model = MOF.Model(; use_nlp_block = true)
    read!(io, model)
    block = MOI.get(model, MOI.NLPBlock())
    @test block isa MOI.NLPBlockData
    @test block.has_objective == true
    @test MOI.get(model, MOI.ObjectiveFunctionType()) ==
          MOI.ScalarAffineFunction{Float64}
    return
end

function test_AAA_int()
    _test_model_equality(
        """
        variables: x, y
        minobjective::Int: 2 * x + 1
        c1::Int: x + 2 * y <= 3
        c2::Int: 1 * x * x + 3 * x * y + 4 * y * y >= 5
        c3::Int: [2 * x + 3, 4 * y] in MOI.SOS1([1, 2])
        """,
        ["x", "y"],
        ["c1", "c2", "c3"];
        coefficient_type = Int,
    )
    return
end

function test_unsupported_objectives()
    model = MOF.Model()
    for (F, ret) in [
        MOI.VariableIndex => true,
        MOI.ScalarAffineFunction{Float64} => true,
        MOI.ScalarQuadraticFunction{Float64} => true,
        MOI.ScalarNonlinearFunction => true,
        MOI.VectorOfVariables => true,
        MOI.VectorAffineFunction{Float64} => true,
        MOI.VectorQuadraticFunction{Float64} => true,
        MOI.VectorNonlinearFunction => true,
    ]
        @test MOI.supports(model, MOI.ObjectiveFunction{F}()) == ret
    end
    return
end

end

TestMOF.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Test with a bridge for which the map is defined on the bridge value and not
# the bridge type
module TestAbstractBridge

using Test

import MathOptInterface as MOI

# A minimal constraint bridge that doesn't implement ConstraintFunction getter.
# Used to test that `cannot_unbridge = true` works with the default bridge
# `MOI.get` (which throws `GetAttributeNotAllowed`).
struct _NoUnbridgeTestBridge{T} <: MOI.Bridges.Constraint.AbstractBridge
    ci::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}
end

function MOI.Bridges.Constraint.bridge_constraint(
    ::Type{_NoUnbridgeTestBridge{T}},
    model::MOI.ModelLike,
    f::MOI.ScalarAffineFunction{T},
    ::MOI.GreaterThan{T},
) where {T}
    ci = MOI.add_constraint(model, f, MOI.EqualTo(zero(T)))
    return _NoUnbridgeTestBridge{T}(ci)
end

function MOI.supports_constraint(
    ::Type{_NoUnbridgeTestBridge{T}},
    ::Type{MOI.ScalarAffineFunction{T}},
    ::Type{MOI.GreaterThan{T}},
) where {T}
    return true
end

function MOI.Bridges.Constraint.concrete_bridge_type(
    ::Type{_NoUnbridgeTestBridge{T}},
    ::Type{MOI.ScalarAffineFunction{T}},
    ::Type{MOI.GreaterThan{T}},
) where {T}
    return _NoUnbridgeTestBridge{T}
end

function MOI.Bridges.added_constraint_types(
    ::Type{_NoUnbridgeTestBridge{T}},
) where {T}
    return Tuple{Type,Type}[(MOI.ScalarAffineFunction{T}, MOI.EqualTo{T})]
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:_NoUnbridgeTestBridge},
)
    return Tuple{Type}[]
end

function MOI.get(
    ::_NoUnbridgeTestBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return 1
end

function MOI.get(
    bridge::_NoUnbridgeTestBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return [bridge.ci]
end

function MOI.delete(model::MOI.ModelLike, bridge::_NoUnbridgeTestBridge)
    MOI.delete(model, bridge.ci)
    return
end

# Note: ConstraintFunction and ConstraintSet getters are NOT implemented.
# The default MOI.get on AbstractBridge throws GetAttributeNotAllowed.

function test_cannot_unbridge_with_default_getter()
    # This test verifies that `cannot_unbridge = true` works when a constraint
    # bridge does not implement `ConstraintFunction` getter. Before the fix,
    # the default bridge `MOI.get` threw `ArgumentError` which was not caught
    # by `_runtests_error_handler`.
    MOI.Bridges.runtests(
        _NoUnbridgeTestBridge,
        model -> begin
            x = MOI.add_variable(model)
            MOI.add_constraint(model, 1.0 * x, MOI.GreaterThan(0.0))
        end,
        model -> begin
            x = MOI.add_variable(model)
            MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(0.0))
        end;
        cannot_unbridge = true,
    )
    return
end

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

end

TestAbstractBridge.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestAttributes

using Test
import MathOptInterface as MOI

include("dummy.jl")

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
end

function test_attributes_is_set_by_optimize()
    @test MOI.is_set_by_optimize(MOI.TerminationStatus())
    @test !MOI.is_set_by_optimize(MOI.ConstraintSet())
    @test !MOI.is_set_by_optimize(MOI.ObjectiveSense())
    @test MOI.is_set_by_optimize(MOI.CallbackNodeStatus(1))
end

function test_attributes_is_copyable()
    @test !MOI.is_copyable(MOI.TerminationStatus())
    @test !MOI.is_copyable(MOI.ConstraintSet())
    @test MOI.is_copyable(MOI.ObjectiveSense())
end

function test_attributes_supports()
    model = DummyModel()
    @test_throws ArgumentError MOI.supports(model, MOI.TerminationStatus())
    @test_throws ArgumentError begin
        MOI.supports(
            model,
            MOI.ConstraintSet(),
            MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}},
        )
    end
    @test MOI.supports(model, MOI.ObjectiveSense())
end

function test_attributes_set_vector()
    attr = MOI.VariablePrimalStart()
    err = DimensionMismatch(
        "Number of indices (1) does not match the " *
        "number of values (2) set to `$attr`.",
    )
    model = DummyModel()
    x = MOI.VariableIndex(1)
    @test_throws err MOI.set(model, MOI.VariablePrimalStart(), [x], ones(2))
end

function test_attributes_integration_compute_conflict_1()
    optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        MOI.Bridges.full_bridge_optimizer(optimizer, Float64),
    )
    x = MOI.add_variable(model)
    c1 = MOI.add_constraint(model, x, MOI.LessThan(0.0))
    c2 = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    MOI.optimize!(model)
    @test MOI.get(optimizer, MOI.ConflictStatus()) ==
          MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.set(optimizer, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
    MOI.set(optimizer, MOI.ConflictCount(), 1)
    MOI.set(
        optimizer,
        MOI.ConstraintConflictStatus(),
        MOI.get(
            optimizer,
            MOI.ListOfConstraintIndices{
                MOI.VariableIndex,
                MOI.LessThan{Float64},
            }(),
        )[1],
        MOI.NOT_IN_CONFLICT,
    )
    MOI.set(
        optimizer,
        MOI.ConstraintConflictStatus(),
        MOI.get(
            optimizer,
            MOI.ListOfConstraintIndices{
                MOI.VariableIndex,
                MOI.GreaterThan{Float64},
            }(),
        )[1],
        MOI.IN_CONFLICT,
    )
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    @test MOI.get(model, MOI.ConflictCount()) == 1
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c1) ==
          MOI.NOT_IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c2) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(1), c1) ==
          MOI.NOT_IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(1), c2) == MOI.IN_CONFLICT
    @test_throws MOI.ConflictIndexBoundsError MOI.get(
        model,
        MOI.ConstraintConflictStatus(2),
        c1,
    )
    @test_throws MOI.ConflictIndexBoundsError MOI.get(
        model,
        MOI.ConstraintConflictStatus(2),
        c2,
    )
end

MOI.Utilities.@model(
    OnlyScalarConstraints,
    (),
    (MOI.GreaterThan, MOI.LessThan),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
)

function test_attributes_integration_compute_conflict_2()
    optimizer = MOI.Utilities.MockOptimizer(OnlyScalarConstraints{Float64}())
    model = MOI.Bridges.full_bridge_optimizer(optimizer, Float64)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
        MOI.Interval(0.0, 1.0),
    )
    MOI.optimize!(model)
    @test MOI.get(optimizer, MOI.ConflictStatus()) ==
          MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.set(optimizer, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
    MOI.set(optimizer, MOI.ConflictCount(), 1)
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    @test MOI.get(model, MOI.ConflictCount()) == 1
    return
end

struct _NoConstraintName <: MOI.AbstractOptimizer end

function test_no_constraint_name()
    model = _NoConstraintName()
    @test_throws(
        MOI.VariableIndexConstraintNameError(),
        MOI.supports(
            model,
            MOI.ConstraintName(),
            MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne},
        ),
    )
    @test_throws(
        MOI.VariableIndexConstraintNameError(),
        MOI.set(
            model,
            MOI.ConstraintName(),
            MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(1),
            "name",
        ),
    )
end

function test_get_fallback()
    model = DummyModelWithAdd()
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.EqualTo(0.0))
    @test_throws(
        MOI.GetAttributeNotAllowed(
            MOI.SolveTimeSec(),
            "$(typeof(model)) does not support getting the attribute " *
            "$(MOI.SolveTimeSec()).",
        ),
        MOI.get(model, MOI.SolveTimeSec()),
    )
    output = Ref{Cdouble}()
    @test_throws(
        MOI.GetAttributeNotAllowed(
            MOI.SolveTimeSec(),
            "$(typeof(model)) does not support getting the attribute " *
            "$(MOI.SolveTimeSec()).",
        ),
        MOI.get!(output, model, MOI.SolveTimeSec()),
    )
    @test_throws(
        MOI.GetAttributeNotAllowed(
            MOI.VariablePrimal(),
            "$(typeof(model)) does not support getting the attribute " *
            "$(MOI.VariablePrimal()).",
        ),
        MOI.get(model, MOI.VariablePrimal(), x),
    )
    @test_throws(
        MOI.GetAttributeNotAllowed(
            MOI.ConstraintPrimal(),
            "$(typeof(model)) does not support getting the attribute " *
            "$(MOI.ConstraintPrimal()).",
        ),
        MOI.get(model, MOI.ConstraintPrimal(), c),
    )
    @test_throws(
        MOI.GetAttributeNotAllowed(
            MOI.VariablePrimal(),
            "Unable to get attribute $(MOI.VariablePrimal()): invalid " *
            "arguments $((c,)).",
        ),
        MOI.get(model, MOI.VariablePrimal(), c),
    )
    return
end

function test_ConstraintBasisStatus_fallback()
    model = DummyModelWithAdd()
    c = MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}(1)
    @test_throws(
        ErrorException(
            "Querying the basis status of a `VariableIndex` constraint is " *
            "not supported. Use [`VariableBasisStatus`](@ref) instead.",
        ),
        MOI.get(model, MOI.ConstraintBasisStatus(), c),
    )
end

function test_UnsupportedSubmittable()
    model = DummyModelWithAdd()
    sub = MOI.LazyConstraint{Int}(1)
    @test_throws(
        MOI.UnsupportedSubmittable(
            sub,
            "submit(::$(typeof(model)), ::$(typeof(sub))) is not supported.",
        ),
        MOI.submit(model, sub, 1),
    )
end

function test_attribute_value_type()
    @test MOI.attribute_value_type(MOI.CallbackNodeStatus(1)) ==
          MOI.CallbackNodeStatusCode
    @test MOI.attribute_value_type(MOI.LazyConstraintCallback()) == Function
    @test MOI.attribute_value_type(MOI.RelativeGap()) == Float64
    @test MOI.attribute_value_type(MOI.SimplexIterations()) == Int64
    @test MOI.attribute_value_type(MOI.BarrierIterations()) == Int64
    @test MOI.attribute_value_type(MOI.NodeCount()) == Int64
    @test MOI.attribute_value_type(
        MOI.ConstraintBridgingCost{MOI.VariableIndex,MOI.ZeroOne}(),
    ) == Float64
    @test MOI.attribute_value_type(MOI.VariableBridgingCost{MOI.ZeroOne}()) ==
          Float64
end

MOI.Utilities.@model(
    _Model1777,
    (),
    (MOI.LessThan,),
    (MOI.Nonnegatives,),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (MOI.VectorOfVariables,),
    ()
)

function MOI.supports_constraint(
    ::_Model1777,
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.Reals},
)
    return false
end

function MOI.supports_add_constrained_variables(
    ::_Model1777,
    ::Type{MOI.Nonnegatives},
)
    return true
end

MOI.supports_add_constrained_variables(::_Model1777, ::Type{MOI.Reals}) = false

function MOI.get(
    model::_Model1777,
    attr::MOI.ConstraintFunction,
    ci::MOI.ConstraintIndex,
)
    return MOI.get_fallback(model, attr, ci)
end

function test_issue_1777()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        MOI.Bridges.full_bridge_optimizer(_Model1777{Float64}(), Float64),
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.LessThan(1.0))
    MOI.Utilities.attach_optimizer(model)
    MOI.set(model, MOI.ConstraintSet(), c, MOI.LessThan(2.0))
    @test MOI.get(model, MOI.ConstraintSet(), c) == MOI.LessThan(2.0)
    @test MOI.Utilities.state(model) == MOI.Utilities.EMPTY_OPTIMIZER
    return
end

function test_scalar_nonlinear_function_ConstraintName()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(
        :+,
        Any[x, MOI.ScalarNonlinearFunction(:sin, Any[x])],
    )
    c = MOI.add_constraint(model, f, MOI.EqualTo(0.0))
    MOI.set(model, MOI.ConstraintName(), c, "c")
    @test MOI.get(model, MOI.ConstraintName(), c) == "c"
    return
end

function test_scalar_nonlinear_function_set_objective()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(
        :+,
        Any[x, MOI.ScalarNonlinearFunction(:sin, Any[x])],
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    attr = MOI.ObjectiveFunction{typeof(f)}()
    MOI.set(model, attr, f)
    @test isapprox(MOI.get(model, attr), f)
    return
end

function test_attributes_AutomaticDifferentiationBackend()
    @test MOI.attribute_value_type(MOI.AutomaticDifferentiationBackend()) ==
          MOI.Nonlinear.AbstractAutomaticDifferentiation
    return
end

function test_empty_vector_attribute()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.get(model, MOI.ListOfVariableIndices())
    @test typeof(x) == Vector{MOI.VariableIndex}
    ret = MOI.get(model, MOI.VariablePrimalStart(), x)
    @test typeof(ret) == Vector{Any}
    ret = MOI.get(model, MOI.VariableName(), x)
    @test typeof(ret) == Vector{String}
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    c = MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
    ret = MOI.get(model, MOI.ConstraintPrimalStart(), c)
    @test typeof(ret) == Vector{Any}
    ret = MOI.get(model, MOI.ConstraintName(), c)
    @test typeof(ret) == Vector{String}
    return
end

function test_broadcastable_submittable()
    submit = MOI.LazyConstraint(1)
    b = Base.broadcastable(submit)
    @test b isa Base.RefValue
    @test b[] == submit
    return
end

function test_submit_not_allowed()
    submit = MOI.LazyConstraint(1)
    @test MOI.SubmitNotAllowed(submit) == MOI.SubmitNotAllowed(submit, "")
    err = MOI.SubmitNotAllowed(submit, "msg")
    contents = sprint(showerror, err)
    @test occursin("Submitting $submit cannot be performed", contents)
    @test occursin("msg", contents)
    return
end

struct ModelWithSupportedSubmittable <: MOI.ModelLike end

MOI.supports(::ModelWithSupportedSubmittable, ::MOI.LazyConstraint) = true

function test_submit_argument_error()
    model = ModelWithSupportedSubmittable()
    submit = MOI.LazyConstraint(1)
    @test MOI.supports(model, submit)
    @test_throws ArgumentError MOI.submit(model, submit, false)
    return
end

function test_showerror_OptimizeInProgress()
    err = MOI.OptimizeInProgress(MOI.VariablePrimal())
    @test sprint(showerror, err) ==
          "$(typeof(err)): Cannot get result as the `MOI.optimize!` has not finished."
    return
end

function test_showerror_FunctionTypeMismatch()
    F, G = MOI.VariableIndex, MOI.VectorOfVariables
    contents = sprint(showerror, MOI.FunctionTypeMismatch{F,G}())
    @test occursin("Cannot modify functions of different types", contents)
    return
end

function test_showerror_SetTypeMismatch()
    F, G = MOI.ZeroOne, MOI.Integer
    contents = sprint(showerror, MOI.SetTypeMismatch{F,G}())
    @test occursin("Cannot modify sets of different types", contents)
    return
end

function test_NLPBlockDual_is_set_by_optimize()
    @test MOI.is_set_by_optimize(MOI.NLPBlockDual())
    return
end

function test_CallbackVariablePrimal_is_set_by_optimize()
    @test MOI.is_set_by_optimize(MOI.CallbackVariablePrimal(nothing))
    return
end

function test_get_bang()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(model, 2)
    MOI.set.(model, MOI.VariableName(), x, ["x", "y"])
    output = ["", ""]
    @test MOI.get!(output, model, MOI.VariableName(), x) === nothing
    @test output == ["x", "y"]
    return
end

end  # module

TestAttributes.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintAllDifferent

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.AllDifferentToCountDistinctBridge,
        """
        variables: x, y, z
        [x, y, z] in AllDifferent(3)
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        z == 2.0
        """,
        """
        variables: x, y, z, n
        [n, x, y, z] in CountDistinct(4)
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        z == 2.0
        n == 3.0
        """;
        print_inner_model = true,
    )
    return
end

function test_runtests_VectorAffineFunction()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.AllDifferentToCountDistinctBridge,
        """
        variables: x, y, z
        [2.0 * x + -1.0, y, z] in AllDifferent(3)
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        z == 2.0
        """,
        """
        variables: x, y, z
        [3.0, 2.0 * x + -1.0, y, z] in CountDistinct(4)
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        z == 2.0
        """,
    )
    return
end

end  # module

TestConstraintAllDifferent.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    UnsupportedError <: Exception

Abstract type for error thrown when an element is not supported by the model.
"""
abstract type UnsupportedError <: Exception end

"""
    element_name(err::UnsupportedError)

Return the name of the element that is not supported.
"""
function element_name end

function Base.showerror(io::IO, err::UnsupportedError)
    print(
        io,
        typeof(err),
        ": ",
        element_name(err),
        " is not supported by the model",
    )
    m = message(err)
    if Base.isempty(m)
        print(io, ".")
    else
        print(io, ": ", m)
    end
end

"""
    NotAllowedError <: Exception

Abstract type for error thrown when an operation is supported but cannot be
applied in the current state of the model.
"""
abstract type NotAllowedError <: Exception end

"""
    operation_name(err::NotAllowedError)

Return the name of the operation throwing the error in a gerund (that is, -ing
form).
"""
function operation_name end

function Base.showerror(io::IO, err::NotAllowedError)
    println(io, typeof(err), ":\n")
    println(io, "## Cause\n")
    print(io, operation_name(err), " cannot be performed")
    m = message(err)
    if isempty(m)
        println(io)
    else
        println(io, " because:\n\n", m)
    end
    println(io)
    print(
        io,
        """
        ## Fixing this error

        An `MOI.NotAllowedError` error occurs when you have tried to do something that
        is not implemented by the solver.

        The most common way to fix this error is to wrap the optimizer in a
        `MOI.Utilities.CachingOptimizer`.

        For example, if you are using `JuMP.Model` or `JuMP.set_optimizer`, do:
        ```julia
        model = JuMP.Model(optimizer; with_cache_type = Float64)
        model = JuMP.GenericModel{T}(optimizer; with_cache_type = T)
        JuMP.set_optimizer(model, optimizer; with_cache_type = Float64)
        ```
        Similarly, if you are using `MOI.instantiate`, do:
        ```julia
        model = MOI.instantiate(optimizer; with_cache_type = Float64)
        ```
        """,
    )
    return
end

"""
    message(err::Union{UnsupportedError, NotAllowedError})

Return a `String` containing a human-friendly explanation of why the operation
is not supported/cannot be performed. It is printed in the error message if it
is not empty. By convention, it should be stored in the `message` field; if
this is the case, the `message` method does not have to be implemented.
"""
message(err::Union{UnsupportedError,NotAllowedError}) = err.message

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SplitComplexEqualToBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`SplitComplexEqualToBridge` implements the following reformulation:

  * ``f(x) + g(x) * im = a + b * im`` into ``f(x) = a`` and ``g(x) = b``

## Source node

`SplitComplexEqualToBridge` supports:

  * `G` in [`MOI.EqualTo{Complex{T}}`](@ref)

where `G` is a function with `Complex` coefficients.

## Target nodes

`SplitComplexEqualToBridge` creates:

  * `F` in [`MOI.EqualTo{T}`](@ref)

where `F` is the type of the real/imaginary part of `G`.
"""
struct SplitComplexEqualToBridge{
    T,
    F<:MOI.Utilities.TypedScalarLike{T},
    G<:MOI.Utilities.TypedScalarLike{Complex{T}},
} <: AbstractBridge
    real_constraint::Union{Nothing,MOI.ConstraintIndex{F,MOI.EqualTo{T}}}
    imag_constraint::Union{Nothing,MOI.ConstraintIndex{F,MOI.EqualTo{T}}}
end

const SplitComplexEqualTo{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SplitComplexEqualToBridge{T},OT}

function _add_constraint_if_nonzero(model, func, set)
    if iszero(func) && iszero(MOI.constant(set))
        return nothing
    end
    return MOI.add_constraint(model, func, set)
end

function bridge_constraint(
    ::Type{SplitComplexEqualToBridge{T,F,G}},
    model::MOI.ModelLike,
    func::G,
    set::MOI.EqualTo,
) where {T,F,G}
    real_func = real(func)
    imag_func = MOI.Utilities.operate(imag, T, func)
    real_set = MOI.EqualTo(real(MOI.constant(set)))
    imag_set = MOI.EqualTo(imag(MOI.constant(set)))
    real_ci = _add_constraint_if_nonzero(model, real_func, real_set)
    imag_ci = _add_constraint_if_nonzero(model, imag_func, imag_set)
    return SplitComplexEqualToBridge{T,F,G}(real_ci, imag_ci)
end

# We don't support `MOI.VariableIndex` as it would be a self-loop in the bridge
# graph.
function MOI.supports_constraint(
    ::Type{<:SplitComplexEqualToBridge{T}},
    ::Type{<:MOI.Utilities.TypedLike{Complex{T}}},
    ::Type{<:MOI.EqualTo},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:SplitComplexEqualToBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{SplitComplexEqualToBridge{T,F,G}},
) where {T,F,G}
    return Tuple{Type,Type}[(F, MOI.EqualTo{T})]
end

function concrete_bridge_type(
    ::Type{<:SplitComplexEqualToBridge{T}},
    G::Type{<:MOI.Utilities.TypedLike},
    ::Type{<:MOI.EqualTo},
) where {T}
    F = MA.promote_operation(imag, G)
    return SplitComplexEqualToBridge{T,F,G}
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::SplitComplexEqualToBridge{T,F,G},
) where {T,F,G}
    g = zero(G)
    if bridge.real_constraint !== nothing
        f = MOI.get(model, attr, bridge.real_constraint)
        g = MOI.Utilities.operate!(+, Complex{T}, g, convert(G, f))
    end
    if bridge.imag_constraint !== nothing
        f = MOI.get(model, attr, bridge.imag_constraint)
        g = MOI.Utilities.operate!(+, Complex{T}, g, im * f)
    end
    return g
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::SplitComplexEqualToBridge{T},
) where {T}
    rhs = zero(T) + zero(T) * im
    if bridge.real_constraint !== nothing
        set = MOI.get(model, MOI.ConstraintSet(), bridge.real_constraint)
        rhs += set.value
    end
    if bridge.imag_constraint !== nothing
        set = MOI.get(model, MOI.ConstraintSet(), bridge.imag_constraint)
        rhs += set.value * im
    end
    return MOI.EqualTo(rhs)
end

function MOI.get(
    bridge::SplitComplexEqualToBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.EqualTo{T}},
)::Int64 where {T,F}
    return Int64(bridge.real_constraint !== nothing) +
           Int64(bridge.imag_constraint !== nothing)
end

function MOI.get(
    bridge::SplitComplexEqualToBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.EqualTo{T}},
) where {T,F}
    list = MOI.ConstraintIndex{F,MOI.EqualTo{T}}[]
    if bridge.real_constraint !== nothing
        push!(list, bridge.real_constraint)
    end
    if bridge.imag_constraint !== nothing
        push!(list, bridge.imag_constraint)
    end
    return list
end

function MOI.delete(model::MOI.ModelLike, bridge::SplitComplexEqualToBridge)
    if bridge.real_constraint !== nothing
        MOI.delete(model, bridge.real_constraint)
    end
    if bridge.imag_constraint !== nothing
        MOI.delete(model, bridge.imag_constraint)
    end
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{<:SplitComplexEqualToBridge{T,F}},
) where {T,F}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F,MOI.EqualTo{T}})
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{
        MOI.ConstraintPrimal,
        MOI.ConstraintPrimalStart,
        MOI.ConstraintDual,
        MOI.ConstraintDualStart,
    },
    bridge::SplitComplexEqualToBridge{T},
) where {T}
    real_value, imag_value = zero(T), zero(T)
    if bridge.real_constraint !== nothing
        real_value = MOI.get(model, attr, bridge.real_constraint)
        if real_value === nothing
            return nothing
        end
    end
    if bridge.imag_constraint !== nothing
        imag_value = MOI.get(model, attr, bridge.imag_constraint)
        if imag_value === nothing
            return nothing
        end
    end
    return real_value + imag_value * im
end

function MOI.set(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    bridge::SplitComplexEqualToBridge{T},
    value,
) where {T}
    if bridge.real_constraint !== nothing
        MOI.set(model, attr, bridge.real_constraint, real(value))
    end
    if bridge.imag_constraint !== nothing
        MOI.set(model, attr, bridge.imag_constraint, imag(value))
    end
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    bridge::SplitComplexEqualToBridge,
    ::Nothing,
)
    if bridge.real_constraint !== nothing
        MOI.set(model, attr, bridge.real_constraint, nothing)
    end
    if bridge.imag_constraint !== nothing
        MOI.set(model, attr, bridge.imag_constraint, nothing)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintNumberConversion

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NumberConversionBridge,
        """
        variables: x
        ::Int: 1 * x + 2 in GreaterThan(2)
        """,
        """
        variables: x
        ::Float64: 1.0 * x + 2.0 in GreaterThan(2.0)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NumberConversionBridge,
        """
        variables: x
        ::Int: 1 * x in EqualTo(2)
        """,
        """
        variables: x
        ::Float64: 1.0 * x in EqualTo(2.0)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NumberConversionBridge,
        """
        variables: x
        ::Int: 1 * x in Interval(2, 3)
        """,
        """
        variables: x
        ::Float64: 1.0 * x in Interval(2.0, 3.0)
        """,
    )
    # VariableIndex
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NumberConversionBridge,
        # We add ::String here to double check that we're making VariableIndex
        # Anything else would error
        """
        variables: x
        ::String: x in LessThan(2)
        """,
        """
        variables: x
        ::String: x in LessThan(2.0)
        """,
    )
    # ScalarAffineFunction
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NumberConversionBridge,
        """
        variables: x
        ::Int: 1 * x in ZeroOne()
        """,
        """
        variables: x
        ::Float64: 1.0 * x in ZeroOne()
        """,
    )
    # ScalarQuadraticFunction
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NumberConversionBridge,
        """
        variables: x
        ::Int: 1 * x * x + 2 * x in ZeroOne()
        """,
        """
        variables: x
        ::Float64: 1.0 * x * x + 2.0 * x in ZeroOne()
        """,
    )
    # VectorOfVariables
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NumberConversionBridge,
        """
        variables: x
        ::Int: [x, x] in Zeros(2)
        """,
        """
        variables: x
        ::Float64: [x, x] in Zeros(2)
        """,
    )
    # VectorAffineFunction
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NumberConversionBridge,
        """
        variables: x
        ::Int: [1 * x, 2 * x] in Nonnegatives(2)
        """,
        """
        variables: x
        ::Float64: [1.0 * x, 2.0 * x] in Nonnegatives(2)
        """,
    )
    # VectorQuadraticFunction
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NumberConversionBridge,
        """
        variables: x
        ::Int: [1 * x * x, 2 * x] in Nonnegatives(2)
        """,
        """
        variables: x
        ::Float64: [1.0 * x * x, 2.0 * x] in Nonnegatives(2)
        """,
    )
    return
end

end  # module

TestConstraintNumberConversion.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# IndexMap is defined here because there is a boostrapping problem.
#  * IndexMap requires `Utilities.CleverDicts` and `Utilities.DoubleDicts`, so
#    if it were to be defined in MOI proper, it must be included after
#    Utilities.
#  * However, Utilities requires IndexMap, so it must be defined before
#    Utilities.jl is included.
# To work around this issue, we define `IndexMap` here.

struct IndexMap <: AbstractDict{MOI.Index,MOI.Index}
    var_map::CleverDicts.CleverDict{
        MOI.VariableIndex,
        MOI.VariableIndex,
        typeof(CleverDicts.key_to_index),
        typeof(CleverDicts.index_to_key),
    }
    con_map::DoubleDicts.IndexDoubleDict
end

"""
    IndexMap()

The dictionary-like object returned by [`MOI.copy_to`](@ref).
"""
function IndexMap()
    var_map = CleverDicts.CleverDict{MOI.VariableIndex,MOI.VariableIndex}()
    con_map = DoubleDicts.IndexDoubleDict()
    return IndexMap(var_map, con_map)
end

function _identity_constraints_map(
    model,
    map::DoubleDicts.IndexDoubleDictInner{F,S},
) where {F,S}
    for c in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        map[c] = c
    end
    return
end

"""
    identity_index_map(model::MOI.ModelLike)

Return an [`IndexMap`](@ref) that maps all variable and constraint indices of
`model` to themselves.
"""
function identity_index_map(model::MOI.ModelLike)
    variables = MOI.get(model, MOI.ListOfVariableIndices())
    map = IndexMap()
    for x in variables
        map[x] = x
    end
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        _identity_constraints_map(model, map.con_map[F, S])
    end
    return map
end

Base.getindex(map::IndexMap, key::MOI.VariableIndex) = map.var_map[key]

function Base.getindex(map::IndexMap, key::MOI.ConstraintIndex{F,S}) where {F,S}
    return map.con_map[key]::MOI.ConstraintIndex{F,S}
end

function Base.getindex(map::IndexMap, ::Type{F}, ::Type{S}) where {F,S}
    return map.con_map[F, S]
end

function Base.setindex!(
    map::IndexMap,
    value::MOI.VariableIndex,
    key::MOI.VariableIndex,
)
    return map.var_map[key] = value
end

function Base.setindex!(
    map::IndexMap,
    value::MOI.ConstraintIndex{F,S},
    key::MOI.ConstraintIndex{F,S},
) where {F,S}
    return map.con_map[key] = value
end

Base.delete!(map::IndexMap, x::MOI.VariableIndex) = delete!(map.var_map, x)

Base.delete!(map::IndexMap, c::MOI.ConstraintIndex) = delete!(map.con_map, c)

Base.haskey(map::IndexMap, c::MOI.ConstraintIndex) = haskey(map.con_map, c)

Base.haskey(map::IndexMap, x::MOI.VariableIndex) = haskey(map.var_map, x)

function Base.keys(map::IndexMap)
    return Iterators.flatten((keys(map.var_map), keys(map.con_map)))
end

Base.length(map::IndexMap) = length(map.var_map) + length(map.con_map)

function Base.iterate(map::IndexMap, args...)
    return iterate(Base.Iterators.flatten((map.var_map, map.con_map)), args...)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    GeoMeanBridge{T,F,G,H} <: Bridges.Constraint.AbstractBridge

`GeoMeanBridge` implements a reformulation from [`MOI.GeometricMeanCone`](@ref)
into [`MOI.RotatedSecondOrderCone`](@ref).

The reformulation is best described in an example.

Consider the cone of dimension 4:
```math
t \\le \\sqrt[3]{x_1 x_2 x_3}
```
This can be rewritten as ``\\exists y \\ge 0`` such that:
```math
\\begin{align*}
  t & \\le y,\\\\
  y^4 & \\le x_1 x_2 x_3 y.
\\end{align*}
```
Note that we need to create ``y`` and not use ``t^4`` directly because ``t`` is
not allowed to be negative.

This is equivalent to:
```math
\\begin{align*}
    t & \\le \\frac{y_1}{\\sqrt{4}},\\\\
    y_1^2 & \\le 2y_2 y_3,\\\\
    y_2^2 & \\le 2x_1 x_2, \\\\
    y_3^2 & \\le 2x_3(y_1/\\sqrt{4}) \\\\
    y     & \\ge 0.
\\end{align*}
```

More generally, you can show how the geometric mean code is recursively expanded
into a set of new variables ``y`` in [`MOI.Nonnegatives`](@ref), a set of
[`MOI.RotatedSecondOrderCone`](@ref) constraints, and a [`MOI.LessThan`](@ref)
constraint between ``t`` and ``y_1``.

## Source node

`GeoMeanBridge` supports:

  * `H` in [`MOI.GeometricMeanCone`](@ref)

## Target nodes

`GeoMeanBridge` creates:

  * `F` in [`MOI.LessThan{T}`](@ref)
  * `G` in [`MOI.RotatedSecondOrderCone`](@ref)
  * `G` in [`MOI.Nonnegatives`](@ref)
"""
struct GeoMeanBridge{T,F,G,H} <: AbstractBridge
    d::Int
    xij::Vector{MOI.VariableIndex}
    t_upper_bound_constraint::MOI.ConstraintIndex{F,MOI.LessThan{T}}
    rsoc_constraints::Vector{MOI.ConstraintIndex{G,MOI.RotatedSecondOrderCone}}
    # In the case that `d > 2`, this is `Nothing` because the new variables are
    # non-negative due to the RotatedSecondOrderCone constraint.
    x_nonnegative_constraint::Union{
        Nothing,
        MOI.ConstraintIndex{H,MOI.Nonnegatives},
    }

    function GeoMeanBridge{T,F,G,H}(
        d,
        xij,
        t_upper_bound_constraint,
        rsoc,
        x_nonnegative_constraint,
    ) where {T,F,G,H}
        return new{T,F,G,H}(
            d,
            xij,
            t_upper_bound_constraint,
            rsoc,
            x_nonnegative_constraint,
        )
    end
end

const GeoMean{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{GeoMeanBridge{T},OT}

_ilog2(n, i = 0) = n <= (1 << i) ? i : _ilog2(n, i + 1)

function bridge_constraint(
    ::Type{GeoMeanBridge{T,F,G,H}},
    model,
    f::MOI.AbstractVectorFunction,
    s::MOI.GeometricMeanCone,
) where {T,F,G,H}
    d = MOI.dimension(s)
    f_scalars = MOI.Utilities.eachscalar(f)
    if d == 2
        # We have a special case for two-dimensional set, because this doesn't
        # require adding a rotated second order cone.
        return GeoMeanBridge{T,F,G,H}(
            d,
            MOI.VariableIndex[],
            MOI.Utilities.normalize_and_add_constraint(
                model,
                MOI.Utilities.operate!(-, T, f_scalars[1], f_scalars[2]),
                MOI.LessThan(zero(T));
                allow_modify_function = true,
            ),
            MOI.ConstraintIndex{G,MOI.RotatedSecondOrderCone}[],
            MOI.add_constraint(model, f_scalars[2:2], MOI.Nonnegatives(1)),
        )
    end
    t = f_scalars[1]
    SG = MOI.Utilities.scalar_type(G)
    n = d - 1
    l = _ilog2(n)
    N = 1 << l
    rsoc_constraints =
        Vector{MOI.ConstraintIndex{G,MOI.RotatedSecondOrderCone}}(undef, N - 1)
    xij = MOI.add_variables(model, N - 1)
    xl1 = xij[1]
    sN = one(T) / sqrt(N)
    _getx(i)::SG = i > n ? sN * xl1 : f_scalars[1+i]

    # With sqrt(2)^l*t - xl1, we should scale both the ConstraintPrimal and
    # ConstraintDual
    t_upper_bound_constraint = MOI.Utilities.normalize_and_add_constraint(
        model,
        MOI.Utilities.operate!(+, T, t, -sN * xl1),
        MOI.LessThan(zero(T)),
        allow_modify_function = true,
    )
    offset = 0
    for i in 1:l
        num_lvars = 1 << (i - 1)
        offset_next = offset + num_lvars
        for j in 1:num_lvars
            if i == l
                a = _getx(2j - 1)
                b = _getx(2j)
            else
                a = convert(SG, xij[offset_next+2j-1])
                b = convert(SG, xij[offset_next+2j])
            end
            c = xij[offset+j]
            rsoc_constraints[offset+j] = MOI.add_constraint(
                model,
                MOI.Utilities.operate(vcat, T, a, b, c),
                MOI.RotatedSecondOrderCone(3),
            )
        end
        offset = offset_next
    end
    @assert offset == length(rsoc_constraints)
    return GeoMeanBridge{T,F,G,H}(
        d,
        xij,
        t_upper_bound_constraint,
        rsoc_constraints,
        nothing,
    )
end

function MOI.supports_constraint(
    ::Type{GeoMeanBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.GeometricMeanCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:GeoMeanBridge})
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:GeoMeanBridge{T,F,G}},
) where {T,F,G}
    return Tuple{Type,Type}[
        (F, MOI.LessThan{T}),
        (G, MOI.RotatedSecondOrderCone),
        (G, MOI.Nonnegatives),
    ]
end

function concrete_bridge_type(
    ::Type{<:GeoMeanBridge{T}},
    H::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.GeometricMeanCone},
) where {T}
    S = MOI.Utilities.scalar_type(H)
    A = MOI.Utilities.promote_operation(*, T, T, MOI.VariableIndex)
    F = MOI.Utilities.promote_operation(+, T, S, A)
    G = MOI.Utilities.promote_operation(vcat, T, A, S, MOI.VariableIndex)
    return GeoMeanBridge{T,F,G,H}
end

# Attributes, Bridge acting as a model
MOI.get(b::GeoMeanBridge, ::MOI.NumberOfVariables)::Int64 = length(b.xij)

MOI.get(b::GeoMeanBridge, ::MOI.ListOfVariableIndices) = copy(b.xij)

function MOI.get(
    ::GeoMeanBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.LessThan{T}},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    b::GeoMeanBridge{T,F,G},
    ::MOI.NumberOfConstraints{G,MOI.RotatedSecondOrderCone},
)::Int64 where {T,F,G}
    return length(b.rsoc_constraints)
end

function MOI.get(
    b::GeoMeanBridge{T,F,G,H},
    ::MOI.NumberOfConstraints{H,MOI.Nonnegatives},
)::Int64 where {T,F,G,H}
    return b.d > 2 ? 0 : 1
end

function MOI.get(
    b::GeoMeanBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.LessThan{T}},
) where {T,F}
    return [b.t_upper_bound_constraint]
end

function MOI.get(
    b::GeoMeanBridge{T,F,G},
    ::MOI.ListOfConstraintIndices{G,MOI.RotatedSecondOrderCone},
) where {T,F,G}
    return copy(b.rsoc_constraints)
end

function MOI.get(
    b::GeoMeanBridge{T,F,G,H},
    ::MOI.ListOfConstraintIndices{H,MOI.Nonnegatives},
) where {T,F,G,H}
    if b.d > 2
        return MOI.ConstraintIndex{H,MOI.Nonnegatives}[]
    end
    return [b.x_nonnegative_constraint]
end

function MOI.delete(model::MOI.ModelLike, bridge::GeoMeanBridge)
    MOI.delete(model, bridge.xij)
    MOI.delete(model, bridge.t_upper_bound_constraint)
    MOI.delete(model, bridge.rsoc_constraints)
    if bridge.d == 2
        MOI.delete(model, bridge.x_nonnegative_constraint)
    end
    return
end

# Attributes, Bridge acting as a constraint
function MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, bridge::GeoMeanBridge)
    return MOI.GeometricMeanCone(bridge.d)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::GeoMeanBridge{T,F,G,H},
) where {T,F,G,H}
    d = bridge.d
    f_scalars = Vector{MOI.Utilities.scalar_type(H)}(undef, bridge.d)
    tub = MOI.get(model, attr, bridge.t_upper_bound_constraint)
    rhs = MOI.constant(
        MOI.get(model, MOI.ConstraintSet(), bridge.t_upper_bound_constraint),
    )
    tub = MOI.Utilities.operate(-, T, tub, rhs)
    if d == 2
        x = MOI.get(model, attr, bridge.x_nonnegative_constraint)
        f_scalars[2] = MOI.Utilities.eachscalar(x)[1]
        f_scalars[1] = MOI.Utilities.convert_approx(
            MOI.Utilities.scalar_type(H),
            MOI.Utilities.operate(+, T, tub, f_scalars[2]),
        )
    else
        t = MOI.Utilities.remove_variable(tub, bridge.xij[1])
        f_scalars[1] = t
        n = d - 1
        l = _ilog2(n)
        num_lvars = 1 << (l - 1)
        offset = num_lvars - 1
        for j in 1:num_lvars
            if 2j <= bridge.d
                func = MOI.get(model, attr, bridge.rsoc_constraints[offset+j])
                func_scalars = MOI.Utilities.eachscalar(func)
                # Numerical issues can arise when a VectorOfVariables function
                # is turned into a VectorAffineFunction, because the RSOC
                # constraints might return something like `0.999999999x` instead
                # of exactly `1.0x`. To counteract this, use `convert_approx`.
                f_scalars[2j] = MOI.Utilities.convert_approx(
                    MOI.Utilities.scalar_type(H),
                    func_scalars[1],
                )
                if 2j + 1 <= bridge.d
                    f_scalars[2j+1] = MOI.Utilities.convert_approx(
                        MOI.Utilities.scalar_type(H),
                        func_scalars[2],
                    )
                end
            end
        end
    end
    return MOI.Utilities.vectorize(f_scalars)
end

function _get_attribute(model, attr, bridge::GeoMeanBridge{T}) where {T}
    output = Vector{T}(undef, bridge.d)
    ret = MOI.get(model, attr, bridge.t_upper_bound_constraint)
    if ret === nothing
        return ret
    end
    output[1] = ret
    if bridge.d == 2
        output[2] = MOI.get(model, attr, bridge.x_nonnegative_constraint)[1]
    else
        N = length(bridge.xij) + 1
        # div(N, 2) gets layer before original problem variables are involved
        offset = div(N, 2) - 1 # 1 + 2 + ... + n/4
        for i in 1:(bridge.d-1)
            j = ((i - 1) >> 1) + 1
            k = i - 2(j - 1)
            output[1+i] =
                MOI.get(model, attr, bridge.rsoc_constraints[offset+j])[k]
        end
    end
    return output
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    ::Type{GeoMeanBridge{T,F,G,H}},
) where {T,F,G,H}
    FS, GS = MOI.LessThan{T}, MOI.RotatedSecondOrderCone
    return MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex) &&
           MOI.supports(model, attr, MOI.ConstraintIndex{F,FS}) &&
           MOI.supports(model, attr, MOI.ConstraintIndex{G,GS}) &&
           MOI.supports(model, attr, MOI.ConstraintIndex{H,MOI.Nonnegatives})
end

function _variable_attribute(attr::MOI.ConstraintPrimal)
    return MOI.VariablePrimal(attr.result_index)
end

function _variable_attribute(attr::MOI.ConstraintPrimalStart)
    return MOI.VariablePrimalStart()
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::GeoMeanBridge,
)
    output = _get_attribute(model, attr, bridge)
    if output === nothing
        return nothing
    end
    N = length(bridge.xij) + 1
    # the constraint is t - x_l1/sqrt(2^l) ≤ 0, we need to add the value of x_l1
    if bridge.d == 2
        output[1] += MOI.get(model, attr, bridge.x_nonnegative_constraint)[1]
    else
        output[1] +=
            MOI.get(model, _variable_attribute(attr), bridge.xij[1]) / sqrt(N)
    end
    return output
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::GeoMeanBridge{T},
    value,
) where {T}
    if bridge.d == 2
        new_value = value[1] - value[2]
        MOI.set(model, attr, bridge.t_upper_bound_constraint, new_value)
        MOI.set(model, attr, bridge.x_nonnegative_constraint, [value[2]])
        return
    end
    n = bridge.d - 1
    l = _ilog2(n)
    N = 1 << l
    sN = one(T) / sqrt(N)
    xl1 = prod(value[2:end])^(1 / n) / sN
    xij = zeros(T, N - 1)
    xij[1] = xl1
    _get_x(i) = i > n ? sN * xl1 : value[1+i]
    # With sqrt(2)^l*t - xl1, we should scale both the ConstraintPrimal and
    # ConstraintDual
    MOI.set(model, attr, bridge.t_upper_bound_constraint, value[1] - sN * xl1)
    offset = length(bridge.rsoc_constraints)
    for i in l:-1:1
        offset_next = offset
        num_lvars = 1 << (i - 1)
        offset -= num_lvars
        for j in 1:num_lvars
            a, b = if i == l
                _get_x(2j - 1), _get_x(2j)
            else
                xij[offset_next+2j-1], xij[offset_next+2j]
            end
            c = sqrt(2a * b)
            xij[offset+j] = c
            MOI.set(model, attr, bridge.rsoc_constraints[offset+j], [a, b, c])
        end
    end
    @assert offset == 0
    MOI.set(model, _variable_attribute(attr), bridge.xij, xij)
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::GeoMeanBridge,
    ::Nothing,
)
    MOI.set(model, attr, bridge.t_upper_bound_constraint, nothing)
    if bridge.x_nonnegative_constraint !== nothing
        MOI.set(model, attr, bridge.x_nonnegative_constraint, nothing)
    end
    for ci in bridge.rsoc_constraints
        MOI.set(model, attr, ci, nothing)
    end
    for vi in bridge.xij
        MOI.set(model, _variable_attribute(attr), vi, nothing)
    end
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    bridge::GeoMeanBridge,
)
    output = _get_attribute(model, attr, bridge)
    if bridge.d == 2
        # The transformation is:
        # [t]                [1 -1] [t]
        # [x] in GeoMean <=> [0  1] [x] in R- x R+
        # Hence the dual transformation is
        # [ 1 0] [u]                 [u]
        # [-1 1] [v] in GeoMean* <=> [v] in R- x R+
        output[2] -= MOI.get(model, attr, bridge.t_upper_bound_constraint)
    end
    # Otherwise, the transformation is:
    # [t]                                  [t]
    # [x] in GeoMean <=> exists xij s.t. A [x] + B xij in R- x RSOC^(N-1)
    # Hence the dual transformation is
    # A' y in GeoMean* <=>
    # B' y = 0         <=> y in R- x RSOC^(N-1)
    # Here A has at most one nonzero entry by line and column and this entry is 1.
    # Therefore we can A' = inv(A) hence we can use the same `getconstrattr` function
    # than for getting the `ConstraintPrimal`.
    # We don't need to use B' y = 0.
    return output
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    InequalityToComplementsBridge{T,F,S,G} <: Bridges.Constraint.AbstractBridge

`InequalityToComplementsBridge` implements the following reformulations:

  * ``f(x) \\ge b`` into ``\\exists y`` such that ``f(x) - b \\perp y \\ge 0``
  * ``f(x) \\le b`` into ``f(x) - b \\perp y \\le 0``
  * ``f(x) = b`` into ``f(x) - b \\perp y``

## Source node

`InequalityToComplementsBridge` supports:

  * `F` in [`MOI.GreaterThan{T}`](@ref)
  * `F` in [`MOI.LessThan{T}`](@ref)
  * `F` in [`MOI.EqualTo`](@ref)

## Target nodes

`InequalityToComplementsBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.LessThan{T}`](@ref)
  * [`MOI.VariableIndex`](@ref) in [`MOI.GreaterThan{T}`](@ref)
  * `G` in [`MOI.Complements`](@ref)
"""
mutable struct InequalityToComplementsBridge{
    T,
    F<:MOI.AbstractScalarFunction,
    S<:Union{MOI.GreaterThan{T},MOI.LessThan{T},MOI.EqualTo{T}},
    G<:MOI.AbstractVectorFunction,
} <: AbstractBridge
    y::MOI.VariableIndex
    set::S
    ci::MOI.ConstraintIndex{G,MOI.Complements}
end

const InequalityToComplements{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{InequalityToComplementsBridge{T},OT}

function _add_y_variable(model, ::MOI.GreaterThan{T}) where {T}
    return MOI.add_constrained_variable(model, MOI.GreaterThan(zero(T)))[1]
end

function _add_y_variable(model, ::MOI.LessThan{T}) where {T}
    return MOI.add_constrained_variable(model, MOI.LessThan(zero(T)))[1]
end

_add_y_variable(model, ::MOI.EqualTo) = MOI.add_variable(model)

function bridge_constraint(
    ::Type{InequalityToComplementsBridge{T,F,S,G}},
    model::MOI.ModelLike,
    f::F,
    set::S,
) where {T,F,S<:Union{MOI.GreaterThan{T},MOI.LessThan{T},MOI.EqualTo{T}},G}
    y = _add_y_variable(model, set)
    f_set = MOI.Utilities.operate(-, T, f, MOI.constant(set))
    g = MOI.Utilities.operate(vcat, T, f_set, y)
    ci = MOI.add_constraint(model, g, MOI.Complements(2))
    return InequalityToComplementsBridge{T,F,S,G}(y, set, ci)
end

function MOI.supports_constraint(
    ::Type{<:InequalityToComplementsBridge{T}},
    ::Type{F},
    ::Type{<:Union{MOI.GreaterThan{T},MOI.LessThan{T},MOI.EqualTo{T}}},
) where {T,F<:MOI.AbstractScalarFunction}
    return MOI.Utilities.is_coefficient_type(F, T) &&
           !MOI.Utilities.is_complex(F)
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{InequalityToComplementsBridge{T,F,S,G}},
) where {T,F,S<:Union{MOI.GreaterThan{T},MOI.LessThan{T}},G}
    return Tuple{Type}[(S,)]
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{InequalityToComplementsBridge{T,F,MOI.EqualTo{T},G}},
) where {T,F,G}
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{InequalityToComplementsBridge{T,F,S,G}},
) where {T,F,S,G}
    return Tuple{Type,Type}[(G, MOI.Complements)]
end

function concrete_bridge_type(
    ::Type{<:InequalityToComplementsBridge},
    F::Type{<:MOI.AbstractScalarFunction},
    S::Type{<:Union{MOI.GreaterThan{T},MOI.LessThan{T},MOI.EqualTo{T}}},
) where {T}
    G = MOI.Utilities.promote_operation(vcat, T, F, MOI.VariableIndex)
    return InequalityToComplementsBridge{T,F,S,G}
end

function MOI.get(::InequalityToComplementsBridge, ::MOI.NumberOfVariables)
    return Int64(1)
end

function MOI.get(
    bridge::InequalityToComplementsBridge,
    ::MOI.ListOfVariableIndices,
)
    return [bridge.y]
end

function MOI.get(
    ::InequalityToComplementsBridge{T,F,S,G},
    ::MOI.NumberOfConstraints{G,MOI.Complements},
)::Int64 where {T,F,S,G}
    return 1
end

function MOI.get(
    bridge::InequalityToComplementsBridge{T,F,S,G},
    ::MOI.ListOfConstraintIndices{G,MOI.Complements},
) where {T,F,S,G}
    return [bridge.ci]
end

function MOI.delete(model::MOI.ModelLike, bridge::InequalityToComplementsBridge)
    MOI.delete(model, bridge.y)
    MOI.delete(model, bridge.ci)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::InequalityToComplementsBridge{T},
) where {T}
    g = MOI.get(model, attr, bridge.ci)
    f_set = first(MOI.Utilities.scalarize(g))
    return MOI.Utilities.operate(+, T, f_set, MOI.constant(bridge.set))
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::InequalityToComplementsBridge,
)
    return bridge.set
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    CountBelongsToMILPBridge{T,F} <: Bridges.Constraint.AbstractBridge

`CountBelongsToMILPBridge` implements the following reformulation:

  * ``(n, x) \\in \\textsf{CountBelongs}(1+d, \\mathcal{S})`` into a
    mixed-integer linear program.

## Reformulation

The reformulation is non-trivial, and it depends on the finite domain of each
variable ``x_i``, which we as define ``S_i = \\{l_i,\\ldots,u_i\\}``.

First, we introduce new binary variables ``z_{ij}``, which are ``1`` if variable
``x_i`` takes the value ``j`` in the optimal solution and ``0`` otherwise:
```math
\\begin{aligned}
z_{ij} \\in \\{0, 1\\}                              & \\;\\; \\forall i \\in 1\\ldots d, j \\in S_i  \\\\
x_i - \\sum\\limits_{j\\in S_i} j \\cdot z_{ij} = 0 & \\;\\; \\forall i \\in 1\\ldots d              \\\\
\\sum\\limits_{j\\in S_i} z_{ij} = 1                & \\;\\; \\forall i \\in 1\\ldots d              \\\\
\\end{aligned}
```

Finally, ``n`` is constrained to be the number of ``z_{ij}`` elements that are
in ``\\mathcal{S}``:
```math
n - \\sum\\limits_{i\\in 1\\ldots d, j \\in \\mathcal{S}} z_{ij} = 0
```

## Source node

`CountBelongsToMILPBridge` supports:

  * `F` in [`MOI.CountBelongs`](@ref)

where `F` is [`MOI.VectorOfVariables`](@ref) or
[`MOI.VectorAffineFunction{T}`](@ref).

## Target nodes

`CountBelongsToMILPBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo{T}`](@ref)
"""
mutable struct CountBelongsToMILPBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
} <: AbstractBridge
    f::F
    set::MOI.CountBelongs
    variables::Vector{MOI.VariableIndex}
    equal_to::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
    }
    bounds::Vector{NTuple{2,T}}
    function CountBelongsToMILPBridge{T}(
        f::Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
        s::MOI.CountBelongs,
    ) where {T}
        return new{T,typeof(f)}(
            f,
            s,
            MOI.VariableIndex[],
            MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}[],
            NTuple{2,T}[],
        )
    end
end

const CountBelongsToMILP{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{CountBelongsToMILPBridge{T},OT}

function bridge_constraint(
    ::Type{CountBelongsToMILPBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.CountBelongs,
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    # !!! info
    #     Postpone creation until final_touch.
    return CountBelongsToMILPBridge{T}(f, s)
end

function MOI.supports_constraint(
    ::Type{<:CountBelongsToMILPBridge{T}},
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}},
    ::Type{MOI.CountBelongs},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:CountBelongsToMILPBridge},
)
    return Tuple{Type}[(MOI.ZeroOne,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:CountBelongsToMILPBridge{T}},
) where {T}
    return Tuple{Type,Type}[(MOI.ScalarAffineFunction{T}, MOI.EqualTo{T})]
end

function concrete_bridge_type(
    ::Type{<:CountBelongsToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.CountBelongs},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return CountBelongsToMILPBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::CountBelongsToMILPBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::CountBelongsToMILPBridge,
)
    return bridge.set
end

function MOI.delete(model::MOI.ModelLike, bridge::CountBelongsToMILPBridge)
    for ci in bridge.equal_to
        MOI.delete(model, ci)
    end
    empty!(bridge.equal_to)
    for x in bridge.variables
        MOI.delete(model, x)
    end
    empty!(bridge.variables)
    empty!(bridge.bounds)
    return
end

function MOI.get(
    bridge::CountBelongsToMILPBridge,
    ::MOI.NumberOfVariables,
)::Int64
    return length(bridge.variables)
end

function MOI.get(bridge::CountBelongsToMILPBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.variables)
end

function MOI.get(
    bridge::CountBelongsToMILPBridge,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64
    return length(bridge.variables)
end

function MOI.get(
    bridge::CountBelongsToMILPBridge,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
)
    return MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}[
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(x.value) for
        x in bridge.variables
    ]
end

function MOI.get(
    bridge::CountBelongsToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return length(bridge.equal_to)
end

function MOI.get(
    bridge::CountBelongsToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return copy(bridge.equal_to)
end

MOI.Bridges.needs_final_touch(::CountBelongsToMILPBridge) = true

"""
    _unit_expansion(
        ::CountBelongsToMILPBridge{T},
        model::MOI.ModelLike,
        f::Vector{<:Union{MOI.VariableIndex,MOI.ScalarAffineFunction{T}}}
    ) where {T}

Reformulates a vector of input functions ``f`` into a binary unit expansion.
This is useful when writing constraint programming bridges.
"""
function _unit_expansion(
    bridge::CountBelongsToMILPBridge{T},
    model::MOI.ModelLike,
    f::Vector{<:Union{MOI.VariableIndex,MOI.ScalarAffineFunction{T}}},
) where {T}
    S = Dict{T,Vector{MOI.VariableIndex}}()
    bounds = Dict{MOI.VariableIndex,Tuple{T,T}}()
    ci = MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}[]
    for i in 1:length(f)
        ret = MOI.Utilities.get_bounds(model, bounds, f[i])
        if ret === nothing
            throw(MOI.Bridges.BridgeRequiresFiniteDomainError(bridge, f[i]))
        end
        if length(bridge.bounds) < i
            # This is the first time calling final_touch
            push!(bridge.bounds, ret)
        elseif bridge.bounds[i] == ret
            # We've called final_touch before, and the bounds match. No need to
            # reformulate a second time.
            continue
        elseif bridge.bounds[i] != ret
            # There is a stored bound, and the current bounds do not match. This
            # means the model has been modified since the previous call to
            # final_touch. We need to delete the bridge and start again.
            MOI.delete(model, bridge)
            MOI.Bridges.final_touch(bridge, model)
            break
        end
        unit_f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], zero(T))
        convex_f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], zero(T))
        for xi in ret[1]:ret[2]
            z, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
            if !haskey(S, xi)
                S[xi] = MOI.VariableIndex[]
            end
            push!(S[xi], z)
            push!(unit_f.terms, MOI.ScalarAffineTerm(T(-xi), z))
            push!(convex_f.terms, MOI.ScalarAffineTerm(one(T), z))
        end
        push!(
            ci,
            MOI.Utilities.normalize_and_add_constraint(
                model,
                MOI.Utilities.operate(+, T, f[i], unit_f),
                MOI.EqualTo(zero(T));
                allow_modify_function = true,
            ),
        )
        push!(ci, MOI.add_constraint(model, convex_f, MOI.EqualTo(one(T))))
    end
    return S, ci
end

function MOI.Bridges.final_touch(
    bridge::CountBelongsToMILPBridge{T,F},
    model::MOI.ModelLike,
) where {T,F}
    scalars = collect(MOI.Utilities.eachscalar(bridge.f))
    S, ci = _unit_expansion(bridge, model, scalars[2:end])
    if isempty(S) && isempty(ci)
        return # Nothing to bridge. We must have already called final_touch.
    end
    append!(bridge.equal_to, ci)
    for (_, s) in S
        append!(bridge.variables, s)
    end
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], zero(T))
    for s in bridge.set.set
        if haskey(S, s)
            for x in S[s]
                push!(f.terms, MOI.ScalarAffineTerm(one(T), x))
            end
        end
    end
    f = MOI.Utilities.operate!(-, T, f, scalars[1])
    push!(
        bridge.equal_to,
        MOI.Utilities.normalize_and_add_constraint(
            model,
            f,
            MOI.EqualTo(zero(T));
            allow_modify_function = true,
        ),
    )
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ComplexNormInfinityToSecondOrderConeBridge{T} <: Bridges.Constraint.AbstractBridge

`ComplexNormInfinityToSecondOrderConeBridge` implements the following
reformulation:

  * ``(t, x) \\in NormInfinity(1+d)`` into ``(t, real(x_i), imag(x_i)) \\in SecondOrderCone()``
    for all ``i``.

## Source node

`ComplexNormInfinityToSecondOrderConeBridge` supports:

  * [`MOI.VectorAffineFunction{Complex{T}}`](@ref) in [`MOI.NormInfinityCone`](@ref)

## Target nodes

`ComplexNormInfinityToSecondOrderConeBridge` creates:

  * [`MOI.VectorAffineFunction{T}`](@ref) in [`MOI.SecondOrderCone`](@ref)
"""
struct ComplexNormInfinityToSecondOrderConeBridge{T} <: AbstractBridge
    ci::Vector{
        MOI.ConstraintIndex{MOI.VectorAffineFunction{T},MOI.SecondOrderCone},
    }
end

const ComplexNormInfinityToSecondOrderCone{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ComplexNormInfinityToSecondOrderConeBridge{T},OT}

function bridge_constraint(
    ::Type{ComplexNormInfinityToSecondOrderConeBridge{T}},
    model::MOI.ModelLike,
    f::MOI.VectorAffineFunction{Complex{T}},
    s::MOI.NormInfinityCone,
) where {T}
    fi_s = MOI.Utilities.scalarize(f)
    if !iszero(imag(fi_s[1]))
        msg = "The epigraph variable `t` in `[t; x] in NormInfinityCone()` must be real. It is: $(fi_s[1])"
        throw(MOI.AddConstraintNotAllowed{typeof(f),typeof(s)}(msg))
    end
    t = real(fi_s[1])
    cis = MOI.ConstraintIndex{MOI.VectorAffineFunction{T},MOI.SecondOrderCone}[]
    for fi in fi_s[2:end]
        ci = MOI.add_constraint(
            model,
            MOI.Utilities.operate(vcat, T, t, real(fi), imag(fi)),
            MOI.SecondOrderCone(3),
        )
        push!(cis, ci)
    end
    return ComplexNormInfinityToSecondOrderConeBridge{T}(cis)
end

function MOI.supports_constraint(
    ::Type{<:ComplexNormInfinityToSecondOrderConeBridge{T}},
    ::Type{MOI.VectorAffineFunction{Complex{T}}},
    ::Type{MOI.NormInfinityCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:ComplexNormInfinityToSecondOrderConeBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:ComplexNormInfinityToSecondOrderConeBridge{T}},
) where {T}
    return Tuple{Type,Type}[(MOI.VectorAffineFunction{T}, MOI.SecondOrderCone)]
end

function concrete_bridge_type(
    ::Type{<:ComplexNormInfinityToSecondOrderConeBridge{T}},
    ::Type{MOI.VectorAffineFunction{Complex{T}}},
    ::Type{MOI.NormInfinityCone},
) where {T}
    return ComplexNormInfinityToSecondOrderConeBridge{T}
end

function MOI.get(
    ::ComplexNormInfinityToSecondOrderConeBridge,
    ::MOI.NumberOfVariables,
)::Int64
    return 0
end

function MOI.get(
    bridge::ComplexNormInfinityToSecondOrderConeBridge{T},
    ::MOI.NumberOfConstraints{MOI.VectorAffineFunction{T},MOI.SecondOrderCone},
)::Int64 where {T}
    return length(bridge.ci)
end

function MOI.get(
    bridge::ComplexNormInfinityToSecondOrderConeBridge{T},
    ::MOI.ListOfConstraintIndices{
        MOI.VectorAffineFunction{T},
        MOI.SecondOrderCone,
    },
) where {T}
    return copy(bridge.ci)
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::ComplexNormInfinityToSecondOrderConeBridge,
)
    MOI.delete(model, bridge.ci)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::ComplexNormInfinityToSecondOrderConeBridge{T},
) where {T}
    elements = MOI.ScalarAffineFunction{Complex{T}}[]
    for ci in bridge.ci
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        fi_s = MOI.Utilities.scalarize(f)
        if isempty(elements)
            push!(elements, fi_s[1])
        end
        fi = MOI.Utilities.operate(
            +,
            Complex{T},
            (one(T) + zero(T) * im) * fi_s[2],
            (zero(T) + one(T) * im) * fi_s[3],
        )
        push!(elements, fi)
    end
    return MOI.Utilities.operate(vcat, Complex{T}, elements...)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::ComplexNormInfinityToSecondOrderConeBridge,
)
    return MOI.NormInfinityCone(1 + length(bridge.ci))
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module NL

import MathOptInterface as MOI
import NaNMath

include("NLExpr.jl")

### ============================================================================
### Nonlinear constraints
### ============================================================================

struct _NLConstraint
    lower::Float64
    upper::Float64
    opcode::Int
    expr::_NLExpr
end

"""
    _NLConstraint(expr::Expr, bound::MOI.NLPBoundsPair)

Convert a constraint in the form of a `expr` into a `_NLConstraint` object.

See `MOI.constraint_expr` for details on the format.

As a validation step, the right-hand side of each constraint must be a constant
term that is given by the `bound`. (If the constraint is an interval constraint,
both the left-hand and right-hand sides must be constants.)

The six NL constraint types are:

    l <= g(x) <= u : 0
         g(x) >= l : 1
         g(x) <= u : 2
         g(x)      : 3
         g(x) == c : 4
     x ⟂ g(x)      : 5  # TODO(odow): Complementarity constraints
"""
function _NLConstraint(expr::Expr, bound::MOI.NLPBoundsPair)
    if expr.head == :comparison
        @assert length(expr.args) == 5
        if !(expr.args[1] ≈ bound.lower && bound.upper ≈ expr.args[5])
            _warn_invalid_bound(expr, bound)
        end
        return _NLConstraint(
            expr.args[1],
            expr.args[5],
            0,
            _NLExpr(expr.args[3]),
        )
    else
        @assert expr.head == :call
        @assert length(expr.args) == 3
        if expr.args[1] == :(<=)
            if !(-Inf ≈ bound.lower && bound.upper ≈ expr.args[3])
                _warn_invalid_bound(expr, bound)
            end
            return _NLConstraint(-Inf, expr.args[3], 1, _NLExpr(expr.args[2]))
        elseif expr.args[1] == :(>=)
            if !(expr.args[3] ≈ bound.lower && bound.upper ≈ Inf)
                _warn_invalid_bound(expr, bound)
            end
            return _NLConstraint(expr.args[3], Inf, 2, _NLExpr(expr.args[2]))
        else
            @assert expr.args[1] == :(==)
            if !(expr.args[3] ≈ bound.lower ≈ bound.upper)
                _warn_invalid_bound(expr, bound)
            end
            return _NLConstraint(
                expr.args[3],
                expr.args[3],
                4,
                _NLExpr(expr.args[2]),
            )
        end
    end
end

function _warn_invalid_bound(expr::Expr, bound::MOI.NLPBoundsPair)
    return @warn(
        "Invalid bounds detected in nonlinear constraint. Expected " *
        "`$(bound.lower) <= g(x) <= $(bound.upper)`, but got the constraint " *
        "$(expr)",
    )
end

### ============================================================================
### Nonlinear models
### ============================================================================

@enum(_VariableType, _BINARY, _INTEGER, _CONTINUOUS)

mutable struct _VariableInfo
    # Variable lower bound.
    lower::Float64
    # Variable upper bound.
    upper::Float64
    # Whether variable is binary or integer.
    type::_VariableType
    # Primal start of the variable.
    start::Union{Float64,Nothing}
    # Number of constraints that the variable appears in.
    jacobian_count::Int
    # If the variable appears in the objective.
    in_nonlinear_objective::Bool
    # If the variable appears in a nonlinear constraint.
    in_nonlinear_constraint::Bool
    # The 0-indexed column of the variable. Computed right at the end.
    order::Int
    function _VariableInfo()
        return new(-Inf, Inf, _CONTINUOUS, nothing, 0, false, false, 0)
    end
end

"""
    Model(; use_nlp_block::Bool = true)

Create a new Optimizer object.
"""
mutable struct Model <: MOI.ModelLike
    # Store MOI.Name().
    name::String
    # The objective expression.
    f::_NLExpr
    sense::MOI.OptimizationSense
    # Number of nonlinear constraints in NLPBlock
    nlpblock_dim::Int
    # A vector of nonlinear constraints
    g::Vector{_NLConstraint}
    # A vector of linear constraints
    h::Vector{_NLConstraint}
    # A dictionary of info for the variables.
    x::Dict{MOI.VariableIndex,_VariableInfo}
    # A struct to help sort the mess that is variable ordering in NL files.
    types::Vector{Vector{MOI.VariableIndex}}
    # A vector of the final ordering of the variables.
    order::Vector{MOI.VariableIndex}
    model::Union{
        Nothing,
        MOI.Utilities.UniversalFallback{MOI.Utilities.Model{Float64}},
    }
    use_nlp_block::Bool

    function Model(; use_nlp_block::Bool = true)
        return new(
            "",
            _NLExpr(false, _NLTerm[], Dict{MOI.VariableIndex,Float64}(), 0.0),
            MOI.FEASIBILITY_SENSE,
            0,
            _NLConstraint[],
            _NLConstraint[],
            Dict{MOI.VariableIndex,_VariableInfo}(),
            [MOI.VariableIndex[] for _ in 1:9],
            MOI.VariableIndex[],
            nothing,
            use_nlp_block,
        )
    end
end

Base.summary(io::IO, ::Model) = print(io, "MOI.FileFormats.NL.Model")

MOI.get(model::Model, ::MOI.SolverName) = "AmplNLWriter"

MOI.supports(::Model, ::MOI.NLPBlock) = true

MOI.supports(::Model, ::MOI.Name) = true
MOI.get(model::Model, ::MOI.Name) = model.name
MOI.set(model::Model, ::MOI.Name, name::String) = (model.name = name)

function MOI.empty!(model::Model)
    model.f = _NLExpr(false, _NLTerm[], Dict{MOI.VariableIndex,Float64}(), 0.0)
    empty!(model.g)
    model.nlpblock_dim = 0
    empty!(model.h)
    empty!(model.x)
    for i in 1:9
        empty!(model.types[i])
    end
    empty!(model.order)
    model.model = nothing
    return
end

function MOI.is_empty(model::Model)
    return isempty(model.g) && isempty(model.h) && isempty(model.x)
end

const _SCALAR_FUNCTIONS = Union{
    MOI.VariableIndex,
    MOI.ScalarAffineFunction{Float64},
    MOI.ScalarQuadraticFunction{Float64},
    MOI.ScalarNonlinearFunction,
}

const _SCALAR_SETS = Union{
    MOI.LessThan{Float64},
    MOI.GreaterThan{Float64},
    MOI.EqualTo{Float64},
    MOI.Interval{Float64},
}

function MOI.supports_constraint(
    ::Model,
    ::Type{<:_SCALAR_FUNCTIONS},
    ::Type{<:_SCALAR_SETS},
)
    return true
end

function MOI.supports_constraint(
    ::Model,
    ::Type{MOI.VariableIndex},
    ::Type{<:Union{MOI.ZeroOne,MOI.Integer}},
)
    return true
end

MOI.supports(::Model, ::MOI.ObjectiveSense) = true
MOI.supports(::Model, ::MOI.ObjectiveFunction{<:_SCALAR_FUNCTIONS}) = true

# ==============================================================================

function MOI.supports(
    ::Model,
    ::MOI.VariablePrimalStart,
    ::Type{MOI.VariableIndex},
)
    return true
end

function MOI.set(
    model::Model,
    ::MOI.VariablePrimalStart,
    x::MOI.VariableIndex,
    v::Union{Nothing,Real},
)
    model.x[x].start = v === nothing ? nothing : convert(Float64, v)::Float64
    return
end

# ==============================================================================

function MOI.copy_to(dest::Model, model::MOI.ModelLike)
    if !MOI.is_empty(dest)
        MOI.empty!(dest)
    end
    mapping = MOI.Utilities.IndexMap()
    has_nlp_objective = false
    for attr in MOI.get(model, MOI.ListOfModelAttributesSet())
        if attr == MOI.NLPBlock()
            nlp_block = MOI.get(model, MOI.NLPBlock())
            if !(:ExprGraph in MOI.features_available(nlp_block.evaluator))
                error(
                    "Unable to use AmplNLWriter because the nonlinear " *
                    "evaluator does not supply expression graphs.",
                )
            end
            MOI.initialize(nlp_block.evaluator, [:ExprGraph])
            if nlp_block.has_objective
                dest.f = _NLExpr(MOI.objective_expr(nlp_block.evaluator))
            end
            has_nlp_objective = nlp_block.has_objective
            for (i, bound) in enumerate(nlp_block.constraint_bounds)
                expr = MOI.constraint_expr(nlp_block.evaluator, i)
                push!(dest.g, _NLConstraint(expr, bound))
            end
            dest.nlpblock_dim = length(dest.g)
        elseif attr == MOI.ObjectiveSense()
            dest.sense = MOI.get(model, MOI.ObjectiveSense())
        elseif !has_nlp_objective && attr isa MOI.ObjectiveFunction
            dest.f = _NLExpr(MOI.get(model, attr))
        elseif attr == MOI.Name()
            dest.name = MOI.get(model, MOI.Name())
        else
            throw(MOI.UnsupportedAttribute(attr))
        end
    end
    x_src = MOI.get(model, MOI.ListOfVariableIndices())
    for x in x_src
        dest.x[x] = _VariableInfo()
        mapping[x] = x
    end
    MOI.Utilities.pass_attributes(dest, model, mapping, x_src)
    resize!(dest.order, length(dest.x))
    # Now deal with the normal MOI constraints.
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        if !MOI.supports_constraint(dest, F, S)
            throw(MOI.UnsupportedConstraint{F,S}())
        end
        _process_constraint(dest, model, F, S, mapping)
    end
    # Correct bounds of binary variables. Mainly because AMPL doesn't have the
    # concept of binary nonlinear variables, but it does have binary linear
    # variables. How annoying.
    for (_, v) in dest.x
        if v.type == _BINARY
            v.lower = max(0.0, v.lower)
            v.upper = min(1.0, v.upper)
        end
    end
    # Jacobian counts. The zero terms for nonlinear constraints should have
    # been added when the expression was constructed.
    for g in dest.g, v in keys(g.expr.linear_terms)
        dest.x[v].jacobian_count += 1
    end
    for h in dest.h, v in keys(h.expr.linear_terms)
        dest.x[v].jacobian_count += 1
    end
    # Now comes the confusing part.
    #
    # AMPL, in all its wisdom, orders variables in a _very_ specific way.
    # The only hint in "Writing NL files" is the line "Variables are ordered as
    # described in Tables 3 and 4 of [5]".
    #
    # Reading these
    #
    # https://cfwebprod.sandia.gov/cfdocs/CompResearch/docs/nlwrite20051130.pdf
    # https://ampl.com/REFS/hooking2.pdf
    #
    # leads us to the following order
    #
    # 1) Continuous variables that appear in a
    #       nonlinear objective AND a nonlinear constraint
    # 2) Discrete variables that appear in a
    #       nonlinear objective AND a nonlinear constraint
    # 3) Continuous variables that appear in a
    #       nonlinear constraint, but NOT a nonlinear objective
    # 4) Discrete variables that appear in a
    #       nonlinear constraint, but NOT a nonlinear objective
    # 5) Continuous variables that appear in a
    #       nonlinear objective, but NOT a nonlinear constraint
    # 6) Discrete variables that appear in a
    #       nonlinear objective, but NOT a nonlinear constraint
    # 7) Continuous variables that DO NOT appear in a
    #       nonlinear objective or a nonlinear constraint
    # 8) Binary variables that DO NOT appear in a
    #       nonlinear objective or a nonlinear constraint
    # 9) Integer variables that DO NOT appear in a
    #       nonlinear objective or a nonlinear constraint
    #
    # Yes, nonlinear variables are broken into continuous/discrete, but linear
    # variables are partitioned into continuous, binary, and integer. (See also,
    # the need to modify bounds for binary variables.)
    if !dest.f.is_linear
        for x in keys(dest.f.linear_terms)
            dest.x[x].in_nonlinear_objective = true
        end
        for x in dest.f.nonlinear_terms
            if x isa MOI.VariableIndex
                dest.x[x].in_nonlinear_objective = true
            end
        end
    end
    for con in dest.g
        for x in keys(con.expr.linear_terms)
            dest.x[x].in_nonlinear_constraint = true
        end
        for x in con.expr.nonlinear_terms
            if x isa MOI.VariableIndex
                dest.x[x].in_nonlinear_constraint = true
            end
        end
    end
    # This ordering is quite confusing. Consult the README for details.
    types = dest.types
    for (x, v) in dest.x
        if v.in_nonlinear_constraint && v.in_nonlinear_objective
            push!(v.type == _CONTINUOUS ? types[1] : types[2], x)
        elseif v.in_nonlinear_constraint
            push!(v.type == _CONTINUOUS ? types[3] : types[4], x)
        elseif v.in_nonlinear_objective
            push!(v.type == _CONTINUOUS ? types[5] : types[6], x)
        elseif v.type == _CONTINUOUS
            push!(types[7], x)
        elseif v.type == _BINARY
            push!(types[8], x)
        else
            @assert v.type == _INTEGER
            push!(types[9], x)
        end
    end
    # Now we can order the variables.
    n = 0
    for i in 1:9
        # Since variables come from a dictionary, there may be differences in
        # the order depending on platform and Julia version. Sort by creation
        # time for consistency.
        for x in sort!(types[i]; by = y -> y.value)
            dest.x[x].order = n
            dest.order[n+1] = x
            n += 1
        end
    end
    return mapping
end

function _set_to_bounds(set::MOI.Interval)
    if set.lower == -Inf && set.upper == Inf
        return (3, set.lower, set.upper)
    elseif set.lower == -Inf
        return (1, set.lower, set.upper)
    elseif set.upper == Inf
        return (2, set.lower, set.upper)
    else
        return (0, set.lower, set.upper)
    end
end

_set_to_bounds(set::MOI.LessThan) = (1, -Inf, set.upper)
_set_to_bounds(set::MOI.GreaterThan) = (2, set.lower, Inf)
_set_to_bounds(set::MOI.EqualTo) = (4, set.value, set.value)

function _process_constraint(
    dest::Model,
    model,
    ::Type{F},
    ::Type{S},
    mapping,
) where {F,S}
    ci_src = MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
    for ci in ci_src
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        s = MOI.get(model, MOI.ConstraintSet(), ci)
        op, l, u = _set_to_bounds(s)
        con = _NLConstraint(l, u, op, _NLExpr(f))
        if isempty(con.expr.linear_terms) && isempty(con.expr.nonlinear_terms)
            if !(l <= con.expr.constant <= u)
                error(
                    "Malformed constraint. There are no variables and the " *
                    "function constant $(con.expr.constant) is not in [$l, $u]",
                )
            end
            # Just use a placeholder for the constraint index. It's not going to
            # be used.
            mapping[ci] = MOI.ConstraintIndex{F,S}(-abs(ci.value))
        elseif con.expr.is_linear
            push!(dest.h, con)
            mapping[ci] = MOI.ConstraintIndex{F,S}(length(dest.h))
        else
            push!(dest.g, con)
            mapping[ci] = MOI.ConstraintIndex{F,S}(length(dest.g))
        end
    end
    MOI.Utilities.pass_attributes(dest, model, mapping, ci_src)
    return
end

function _process_constraint(
    dest::Model,
    model,
    F::Type{MOI.VariableIndex},
    S::Type{<:_SCALAR_SETS},
    mapping,
)
    ci_src = MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
    for ci in ci_src
        mapping[ci] = ci
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        s = MOI.get(model, MOI.ConstraintSet(), ci)
        _, l, u = _set_to_bounds(s)
        if l > -Inf
            dest.x[f].lower = l
        end
        if u < Inf
            dest.x[f].upper = u
        end
    end
    MOI.Utilities.pass_attributes(dest, model, mapping, ci_src)
    return
end

function _process_constraint(
    dest::Model,
    model,
    F::Type{MOI.VariableIndex},
    S::Type{<:Union{MOI.ZeroOne,MOI.Integer}},
    mapping,
)
    ci_src = MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
    for ci in ci_src
        mapping[ci] = ci
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        dest.x[f].type = S == MOI.ZeroOne ? _BINARY : _INTEGER
    end
    MOI.Utilities.pass_attributes(dest, model, mapping, ci_src)
    return
end

function _str(x::Float64)
    if isinteger(x) && (typemin(Int) <= x <= typemax(Int))
        return string(round(Int, x))
    end
    return string(x)
end

_write_term(io::IO, ::Model, x::Float64) = println(io, "n", _str(x))

_write_term(io::IO, ::Model, x::Int) = println(io, "o", x)

function _write_term(io::IO, model::Model, x::MOI.VariableIndex)
    return println(io, "v", model.x[x].order)
end

_is_nary(x::Int) = x in _NARY_OPCODES

_is_nary(x) = false

function _write_nlexpr(io::IO, expr::_NLExpr, model::Model)
    if expr.is_linear || length(expr.nonlinear_terms) == 0
        # If the expression is linear, just write out the constant term.
        _write_term(io, model, expr.constant)
        return
    end
    if !iszero(expr.constant)
        # If the constant term is non-zero, we need to write it out.
        _write_term(io, model, OPPLUS)
        _write_term(io, model, expr.constant)
    end
    last_nary = false
    for term in expr.nonlinear_terms
        if last_nary
            println(io, term::Int)
            last_nary = false
        else
            _write_term(io, model, term)
            last_nary = _is_nary(term)
        end
    end
    return
end

function _write_linear_block(io::IO, expr::_NLExpr, model::Model)
    elements = [(c, model.x[v].order) for (v, c) in expr.linear_terms]
    for (c, x) in sort!(elements; by = i -> i[2])
        println(io, x, " ", _str(c))
    end
    return
end

function Base.write(io::IO, model::Model)
    # ==========================================================================
    # Header
    # Line 1: Always the same
    # Notes:
    #  * I think these are magic bytes used by AMPL internally for stuff.
    #  * The first "1" is if the next row includes the number of logical
    #    constraints.
    println(io, "g3 1 1 0")

    # Line 2: vars, constraints, objectives, ranges, eqns, logical constraints
    # Notes:
    #  * We assume there is always one objective, even if it is just `min 0`.
    n_con, n_ranges, n_eqns = 0, 0, 0
    for cons in (model.g, model.h), c in cons
        n_con += 1
        if c.opcode == 0
            n_ranges += 1
        elseif c.opcode == 4
            n_eqns += 1
        end
    end
    println(io, " $(length(model.x)) $(n_con) 1 $(n_ranges) $(n_eqns) 0")

    # Line 3: nonlinear constraints, objectives
    # Notes:
    #  * We assume there is always one objective, even if it is just `min 0`.
    n_nlcon = length(model.g)
    println(io, " ", n_nlcon, " ", 1)

    # Line 4: network constraints: nonlinear, linear
    # Notes:
    #  * We don't support network constraints. I don't know how they are
    #    represented.
    println(io, " 0 0")

    # Line 5: nonlinear vars in constraints, objectives, both
    # Notes:
    #  * This order is confusingly different to the standard "b, c, o" order.
    #  * It's also confusing because nlvo doesn't mean what you think it means.
    #    Consult the README for details.
    nlvb = length(model.types[1]) + length(model.types[2])
    nlvc = nlvb + length(model.types[3]) + length(model.types[4])
    nlvo = nlvb + length(model.types[5]) + length(model.types[6])
    if nlvo == nlvb
        println(io, " ", nlvc, " ", nlvo, " ", nlvb)
    else
        nl_total = nlvo + nlvc - nlvb
        println(io, " ", nlvc, " ", nl_total, " ", nlvb)
    end

    # Line 6: linear network variables; functions; arith, flags
    # Notes:
    #  * I don't know what this line means. It is what it is. Apparently `flags`
    #    is set to 1 to get suffixes in .sol file.
    println(io, " 0 0 0 1")

    # Line 7: discrete variables: binary, integer, nonlinear (b,c,o)
    # Notes:
    #  * The order is
    #    - binary variables in linear only
    #    - integer variables in linear only
    #    - binary or integer variables in nonlinear objective and constraint
    #    - binary or integer variables in nonlinear constraint
    #    - binary or integer variables in nonlinear objective
    nbv = length(model.types[8])
    niv = length(model.types[9])
    nl_both = length(model.types[2])
    nl_cons = length(model.types[4])
    nl_obj = length(model.types[6])
    println(io, " ", nbv, " ", niv, " ", nl_both, " ", nl_cons, " ", nl_obj)

    # Line 8: nonzeros in Jacobian, gradients
    # Notes:
    #  * Make sure to include a 0 element for every variable that appears in an
    #    objective or constraint, even if the linear coefficient is 0.
    nnz_jacobian = 0
    for g in model.g
        nnz_jacobian += length(g.expr.linear_terms)
    end
    for h in model.h
        nnz_jacobian += length(h.expr.linear_terms)
    end
    nnz_gradient = length(model.f.linear_terms)
    println(io, " ", nnz_jacobian, " ", nnz_gradient)

    # Line 9: max name lengths: constraints, variables
    # Notes:
    #  * We don't add names, so this is just 0, 0.
    println(io, " 0 0")

    # Line 10: common exprs: b,c,o,c1,o1
    # Notes:
    #  * We don't add common subexpressions (that is, V blocks).
    #  * I assume the notation means
    #     - b = in nonlinear objective and constraint
    #     - c = in nonlinear constraint
    #     - o = in nonlinear objective
    #     - c1 = in linear constraint
    #     - o1 = in linear objective
    println(io, " 0 0 0 0 0")
    # ==========================================================================
    # Constraints
    # Notes:
    #  * Nonlinear constraints first, then linear.
    #  * For linear constraints, write out the constant term here.
    for (i, g) in enumerate(model.g)
        println(io, "C", i - 1)
        _write_nlexpr(io, g.expr, model)
    end
    for (i, h) in enumerate(model.h)
        println(io, "C", i - 1 + n_nlcon)
        _write_nlexpr(io, h.expr, model)
    end
    # ==========================================================================
    # Objective
    # Notes:
    #  * NL files support multiple objectives, but we're just going to write 1,
    #    so it's always `O0`.
    #  * For linear objectives, write out the constant term here.
    println(io, "O0 ", model.sense == MOI.MAX_SENSE ? "1" : "0")
    _write_nlexpr(io, model.f, model)
    # ==========================================================================
    # VariablePrimalStart
    # Notes:
    #  * Make sure to write out the variables in order.
    println(io, "x", length(model.x))
    for (i, x) in enumerate(model.order)
        start = model.x[x].start
        println(io, i - 1, " ", start === nothing ? 0 : _str(start))
    end
    # ==========================================================================
    # Constraint bounds
    # Notes:
    #  * Nonlinear constraints go first, then linear.
    #  * The constant term for linear constraints gets written out in the
    #    "C" block.
    if n_con > 0
        println(io, "r")
        # Nonlinear constraints
        for g in model.g
            print(io, g.opcode)
            if g.opcode == 0
                println(io, " ", _str(g.lower), " ", _str(g.upper))
            elseif g.opcode == 1
                println(io, " ", _str(g.upper))
            elseif g.opcode == 2
                println(io, " ", _str(g.lower))
            elseif g.opcode == 3
                println(io)
            else
                @assert g.opcode == 4
                println(io, " ", _str(g.lower))
            end
        end
        # Linear constraints
        for h in model.h
            print(io, h.opcode)
            if h.opcode == 0
                println(io, " ", _str(h.lower), " ", _str(h.upper))
            elseif h.opcode == 1
                println(io, " ", _str(h.upper))
            elseif h.opcode == 2
                println(io, " ", _str(h.lower))
            elseif h.opcode == 3
                println(io)
            else
                @assert h.opcode == 4
                println(io, " ", _str(h.lower))
            end
        end
    end
    # ==========================================================================
    # Variable bounds
    # Notes:
    #  * Not much to note, other than to make sure you iterate the variables in
    #    the correct order.
    println(io, "b")
    for x in model.order
        v = model.x[x]
        if v.lower == v.upper
            println(io, "4 ", _str(v.lower))
        elseif -Inf < v.lower && v.upper < Inf
            println(io, "0 ", _str(v.lower), " ", _str(v.upper))
        elseif -Inf == v.lower && v.upper < Inf
            println(io, "1 ", _str(v.upper))
        elseif -Inf < v.lower && v.upper == Inf
            println(io, "2 ", _str(v.lower))
        else
            println(io, "3")
        end
    end
    # ==========================================================================
    # Jacobian block
    # Notes:
    #  * If a variable appears in a constraint, it needs to have a corresponding
    #    entry in the Jacobian block, even if the linear coefficient is zero.
    #    AMPL uses this to determine the Jacobian sparsity.
    #  * As before, nonlinear constraints go first, then linear.
    #  * Don't write out the `k` entry for the last variable, because it can be
    #    inferred from the total number of elements in the Jacobian as given in
    #    the header.
    if n_con > 0
        println(io, "k", length(model.x) - 1)
        total = 0
        for i in 1:(length(model.order)-1)
            total += model.x[model.order[i]].jacobian_count
            println(io, total)
        end
        for (i, g) in enumerate(model.g)
            println(io, "J", i - 1, " ", length(g.expr.linear_terms))
            _write_linear_block(io, g.expr, model)
        end
        for (i, h) in enumerate(model.h)
            println(io, "J", i - 1 + n_nlcon, " ", length(h.expr.linear_terms))
            _write_linear_block(io, h.expr, model)
        end
    end
    # ==========================================================================
    # Gradient block
    # Notes:
    #  * You only need to write this out if there are linear terms in the
    #    objective.
    if nnz_gradient > 0
        println(io, "G0 ", nnz_gradient)
        _write_linear_block(io, model.f, model)
    end
    return model
end

include("read.jl")
include("sol.jl")

function _assert_has_model(::Nothing, attr)
    return error(
        "Unable get attribute $attr because `NL.Model` only supports getting " *
        "attributes when the model was read from a file.",
    )
end

_assert_has_model(model::MOI.Utilities.UniversalFallback, ::Any) = model

function MOI.get(model::Model, attr::MOI.AbstractModelAttribute)
    inner = _assert_has_model(model.model, attr)
    return MOI.get(inner, attr)
end

function MOI.get(
    model::Model,
    attr::MOI.AbstractConstraintAttribute,
    ci::MOI.ConstraintIndex,
)
    inner = _assert_has_model(model.model, attr)
    return MOI.get(inner, attr, ci)
end

function MOI.get(
    model::Model,
    attr::MOI.AbstractVariableAttribute,
    x::MOI.VariableIndex,
)
    inner = _assert_has_model(model.model, attr)
    return MOI.get(inner, attr, x)
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ReifiedCountDistinctToMILPBridge{T,F} <: Bridges.Constraint.AbstractBridge

`ReifiedCountDistinctToMILPBridge` implements the following reformulation:

  * ``r \\iff (n, x) \\in \\textsf{CountDistinct}(1+d)`` into a mixed-integer
    linear program.

## Reformulation

The reformulation is non-trivial, and it depends on the finite domain of each
variable ``x_i``, which we as define ``S_i = \\{l_i,\\ldots,u_i\\}``.

First, we introduce new binary variables ``z_{ij}``, which are ``1`` if variable
``x_i`` takes the value ``j`` in the optimal solution and ``0`` otherwise:
```math
\\begin{aligned}
z_{ij} \\in \\{0, 1\\}                              & \\;\\; \\forall i \\in 1\\ldots d, j \\in S_i  \\\\
x_i - \\sum\\limits_{j\\in S_i} j \\cdot z_{ij} = 0 & \\;\\; \\forall i \\in 1\\ldots d              \\\\
\\sum\\limits_{j\\in S_i} z_{ij} = 1                & \\;\\; \\forall i \\in 1\\ldots d              \\\\
\\end{aligned}
```

Then, we introduce new binary variables ``y_j``, which are ``1`` if a variable
takes the value ``j`` in the optimal solution and ``0`` otherwise.
```math
\\begin{aligned}
y_{j} \\in \\{0, 1\\}                        & \\;\\; \\forall j \\in \\bigcup_{i=1,\\ldots,d} S_i \\\\
y_j \\le \\sum\\limits_{i \\in 1\\ldots d: j \\in S_i} z_{ij} \\le M y_j & \\;\\; \\forall j \\in \\bigcup_{i=1,\\ldots,d} S_i\\\\
\\end{aligned}
```

Finally, ``n`` is constrained to be the number of ``y_j`` elements that are
non-zero, with some slack:
```math
n - \\sum\\limits_{j \\in \\bigcup_{i=1,\\ldots,d} S_i} y_{j} = \\delta^+ - \\delta^-
```
And then the slack is constrained to respect the reif variable ``r``:
```math
\\begin{aligned}
d_1 \\le \\delta^+ \\le M d_1 \\\\
d_2 \\le \\delta^- \\le M d_s \\\\
d_1 + d_2 + r = 1             \\\\
d_1, d_2 \\in \\{0, 1\\}
\\end{aligned}
```

## Source node

`ReifiedCountDistinctToMILPBridge` supports:

  * `F` in [`MOI.Reified{MOI.CountDistinct}`](@ref)

where `F` is [`MOI.VectorOfVariables`](@ref) or
[`MOI.VectorAffineFunction{T}`](@ref).

## Target nodes

`ReifiedCountDistinctToMILPBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.LessThan{T}`](@ref)
"""
mutable struct ReifiedCountDistinctToMILPBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
} <: AbstractBridge
    f::F
    # A mix of z and α, which are added as needed. We need to store the vector
    # so we can delete them later. The exact structure of which index maps to
    # which variable doesn't matter.
    variables::Vector{MOI.VariableIndex}
    # ∑_j a_j + -1.0 * n - δ == 0.0
    # x_i - ∑_j z_ij = 0 ∀i
    # ∑_j z_ij = 1 ∀i
    equal_to::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
    }
    # ∑_i z_ij - |I| α_j <= 0 ∀j
    # α_j - ∑_i z_ij <= 0 ∀j
    #  δ + M * r <= M
    # -δ + M * r <= M
    less_than::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
    }
    bounds::Vector{NTuple{2,T}}
    function ReifiedCountDistinctToMILPBridge{T}(
        f::Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
    ) where {T}
        return new{T,typeof(f)}(
            f,
            MOI.VariableIndex[],
            MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}[],
            MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}}[],
            NTuple{2,T}[],
        )
    end
end

const ReifiedCountDistinctToMILP{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ReifiedCountDistinctToMILPBridge{T},OT}

function bridge_constraint(
    ::Type{ReifiedCountDistinctToMILPBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.Reified{MOI.CountDistinct},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    # !!! info
    #     Postpone creation until final_touch.
    return ReifiedCountDistinctToMILPBridge{T}(f)
end

function MOI.supports_constraint(
    ::Type{<:ReifiedCountDistinctToMILPBridge{T}},
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}},
    ::Type{MOI.Reified{MOI.CountDistinct}},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:ReifiedCountDistinctToMILPBridge},
)
    return Tuple{Type}[(MOI.Reals,), (MOI.ZeroOne,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:ReifiedCountDistinctToMILPBridge{T}},
) where {T}
    return Tuple{Type,Type}[
        (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}),
        (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:ReifiedCountDistinctToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.Reified{MOI.CountDistinct}},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return ReifiedCountDistinctToMILPBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::ReifiedCountDistinctToMILPBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::ReifiedCountDistinctToMILPBridge,
)
    return MOI.Reified(MOI.CountDistinct(MOI.output_dimension(bridge.f) - 1))
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::ReifiedCountDistinctToMILPBridge,
)
    for ci in bridge.equal_to
        MOI.delete(model, ci)
    end
    empty!(bridge.equal_to)
    for ci in bridge.less_than
        MOI.delete(model, ci)
    end
    empty!(bridge.less_than)
    for x in bridge.variables
        MOI.delete(model, x)
    end
    empty!(bridge.variables)
    empty!(bridge.bounds)
    return
end

function MOI.get(
    bridge::ReifiedCountDistinctToMILPBridge,
    ::MOI.NumberOfVariables,
)::Int64
    return length(bridge.variables)
end

function MOI.get(
    bridge::ReifiedCountDistinctToMILPBridge,
    ::MOI.ListOfVariableIndices,
)
    return copy(bridge.variables)
end

function MOI.get(
    bridge::ReifiedCountDistinctToMILPBridge,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64
    return length(bridge.variables) - 2
end

function MOI.get(
    bridge::ReifiedCountDistinctToMILPBridge,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
)
    return MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}[
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(x.value) for
        x in bridge.variables[1:(end-2)]
    ]
end

function MOI.get(
    bridge::ReifiedCountDistinctToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return length(bridge.equal_to)
end

function MOI.get(
    bridge::ReifiedCountDistinctToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return copy(bridge.equal_to)
end

function MOI.get(
    bridge::ReifiedCountDistinctToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
)::Int64 where {T}
    return length(bridge.less_than)
end

function MOI.get(
    bridge::ReifiedCountDistinctToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
) where {T}
    return copy(bridge.less_than)
end

MOI.Bridges.needs_final_touch(::ReifiedCountDistinctToMILPBridge) = true

function MOI.Bridges.final_touch(
    bridge::ReifiedCountDistinctToMILPBridge{T,F},
    model::MOI.ModelLike,
) where {T,F}
    S = Dict{T,Vector{MOI.VariableIndex}}()
    scalars = collect(MOI.Utilities.eachscalar(bridge.f))
    bounds = Dict{MOI.VariableIndex,NTuple{2,T}}()
    for i in 3:length(scalars)
        x = scalars[i]
        ret = MOI.Utilities.get_bounds(model, bounds, x)
        if ret === nothing
            throw(MOI.Bridges.BridgeRequiresFiniteDomainError(bridge, x))
        end
        if length(bridge.bounds) < i - 2
            # This is the first time calling final_touch
            push!(bridge.bounds, ret)
        elseif bridge.bounds[i-2] == ret
            # We've called final_touch before, and the bounds match. No need to
            # reformulate a second time.
            continue
        elseif bridge.bounds[i-2] != ret
            # There is a stored bound, and the current bounds do not match. This
            # means the model has been modified since the previous call to
            # final_touch. We need to delete the bridge and start again.
            MOI.delete(model, bridge)
            MOI.Bridges.final_touch(bridge, model)
            return
        end
        unit_f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], zero(T))
        convex_f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], zero(T))
        for xi in (ret[1]::T):(ret[2]::T)
            new_var, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
            push!(bridge.variables, new_var)
            if !haskey(S, xi)
                S[xi] = MOI.VariableIndex[]
            end
            push!(S[xi], new_var)
            push!(unit_f.terms, MOI.ScalarAffineTerm(T(-xi), new_var))
            push!(convex_f.terms, MOI.ScalarAffineTerm(one(T), new_var))
        end
        push!(
            bridge.equal_to,
            MOI.Utilities.normalize_and_add_constraint(
                model,
                MOI.Utilities.operate(+, T, x, unit_f),
                MOI.EqualTo(zero(T));
                allow_modify_function = true,
            ),
        )
        push!(
            bridge.equal_to,
            MOI.add_constraint(model, convex_f, MOI.EqualTo(one(T))),
        )
    end
    if isempty(S)
        return  # Nothing to bridge. We must have already called final_touch.
    end
    count_terms = MOI.ScalarAffineTerm{T}[]
    # We use a sort so that the model order is deterministic.
    for s in sort!(collect(keys(S)))
        terms = S[s]
        new_var, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
        push!(bridge.variables, new_var)
        push!(count_terms, MOI.ScalarAffineTerm(one(T), new_var))
        big_M_terms = [MOI.ScalarAffineTerm(T(1), z) for z in terms]
        push!(big_M_terms, MOI.ScalarAffineTerm(T(-length(terms)), new_var))
        push!(
            bridge.less_than,
            MOI.add_constraint(
                model,
                MOI.ScalarAffineFunction(big_M_terms, zero(T)),
                MOI.LessThan(zero(T)),
            ),
        )
        big_M_terms_upper = [MOI.ScalarAffineTerm(T(-1), z) for z in terms]
        push!(big_M_terms_upper, MOI.ScalarAffineTerm(T(1), new_var))
        push!(
            bridge.less_than,
            MOI.add_constraint(
                model,
                MOI.ScalarAffineFunction(big_M_terms_upper, zero(T)),
                MOI.LessThan(zero(T)),
            ),
        )
    end
    z = MOI.add_variables(model, 4)
    append!(bridge.variables, z)
    MOI.add_constraint(model, z[1], MOI.ZeroOne())
    MOI.add_constraint(model, z[2], MOI.ZeroOne())
    # ∑y - n - δ⁺ + δ⁻ = 0
    f_0 = MOI.ScalarAffineFunction(count_terms, zero(T))
    f_0 = MOI.Utilities.operate!(-, T, f_0, scalars[2])
    f_0 = MOI.Utilities.operate!(-, T, f_0, z[3])
    f_0 = MOI.Utilities.operate!(+, T, f_0, z[4])
    push!(
        bridge.equal_to,
        MOI.Utilities.normalize_and_add_constraint(
            model,
            f_0,
            MOI.EqualTo(zero(T));
            allow_modify_function = true,
        ),
    )
    M = T(length(scalars) - 2)
    # δ⁺ <= M * z₁
    f_1 = MOI.Utilities.operate(-, T, z[3], M * z[1])
    push!(bridge.less_than, MOI.add_constraint(model, f_1, MOI.LessThan(T(0))))
    # z₁ <= δ⁺
    f_2 = MOI.Utilities.operate(-, T, z[1], z[3])
    push!(bridge.less_than, MOI.add_constraint(model, f_2, MOI.LessThan(T(0))))
    # δ⁻ <= M * z₂
    f_3 = MOI.Utilities.operate(-, T, z[4], M * z[2])
    push!(bridge.less_than, MOI.add_constraint(model, f_3, MOI.LessThan(T(0))))
    # z₁ <= δ⁺
    f_4 = MOI.Utilities.operate(-, T, z[2], z[4])
    push!(bridge.less_than, MOI.add_constraint(model, f_4, MOI.LessThan(T(0))))
    # z₁ + z₂ + r == 1
    f_4 = MOI.Utilities.operate(+, T, z[1], z[2], scalars[1])
    push!(bridge.equal_to, MOI.add_constraint(model, f_4, MOI.EqualTo(T(1))))
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

abstract type _AbstractSOCtoNonConvexQuadBridge{T} <: AbstractBridge end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    b::_AbstractSOCtoNonConvexQuadBridge{T},
) where {T}
    return MOI.VectorOfVariables(copy(b.vars))
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:_AbstractSOCtoNonConvexQuadBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:_AbstractSOCtoNonConvexQuadBridge{T}},
) where {T}
    return Tuple{Type,Type}[
        (MOI.ScalarQuadraticFunction{T}, MOI.LessThan{T}),
        (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}),
    ]
end

function MOI.get(
    ::_AbstractSOCtoNonConvexQuadBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarQuadraticFunction{T},MOI.LessThan{T}},
)::Int64 where {T}
    return 1
end

function MOI.get(
    bridge::_AbstractSOCtoNonConvexQuadBridge{T},
    ::MOI.ListOfConstraintIndices{
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    },
) where {T}
    return [bridge.quad]
end

function MOI.get(
    bridge::_AbstractSOCtoNonConvexQuadBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}},
)::Int64 where {T}
    return length(bridge.var_pos)
end

function MOI.get(
    bridge::_AbstractSOCtoNonConvexQuadBridge{T},
    ::MOI.ListOfConstraintIndices{
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    },
) where {T}
    return copy(bridge.var_pos)
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::_AbstractSOCtoNonConvexQuadBridge,
)
    MOI.delete(model, bridge.quad)
    MOI.delete.(model, bridge.var_pos)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::_AbstractSOCtoNonConvexQuadBridge,
)
    return MOI.get.(model, MOI.VariablePrimal(attr.result_index), bridge.vars)
end

"""
    SOCtoNonConvexQuadBridge{T} <: Bridges.Constraint.AbstractBridge

`SOCtoNonConvexQuadBridge` implements the following reformulations:

  * ``||x||_2 \\le t`` into ``\\sum x^2 - t^2 \\le 0`` and ``1t + 0 \\ge 0``

The [`MOI.ScalarAffineFunction`](@ref) ``1t + 0`` is used in case the variable
has other bound constraints.

!!! warning
    This transformation starts from a convex constraint and creates a
    non-convex constraint. Unless the solver has explicit support for detecting
    second-order cones in quadratic form, this may (wrongly) be interpreted by
    the solver as being non-convex. Therefore, this bridge is not added
    automatically by [`MOI.Bridges.full_bridge_optimizer`](@ref). Care is
    recommended when adding this bridge to a optimizer.

## Source node

`SOCtoNonConvexQuadBridge` supports:

  * [`MOI.VectorOfVariables`](@ref) in [`MOI.SecondOrderCone`](@ref)

## Target nodes

`SOCtoNonConvexQuadBridge` creates:

  * [`MOI.ScalarQuadraticFunction{T}`](@ref) in [`MOI.LessThan{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.GreaterThan{T}`](@ref)
"""
struct SOCtoNonConvexQuadBridge{T} <: _AbstractSOCtoNonConvexQuadBridge{T}
    quad::MOI.ConstraintIndex{MOI.ScalarQuadraticFunction{T},MOI.LessThan{T}}
    var_pos::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}},
    }
    vars::Vector{MOI.VariableIndex}
end

const SOCtoNonConvexQuad{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SOCtoNonConvexQuadBridge{T},OT}

function bridge_constraint(
    ::Type{SOCtoNonConvexQuadBridge{T}},
    model,
    func::MOI.VectorOfVariables,
    set::MOI.SecondOrderCone,
) where {T}
    t, x = func.variables[1], func.variables[2:end]
    a_terms = MOI.ScalarAffineTerm{T}[]
    q_terms = MOI.ScalarQuadraticTerm.(T(2), x, x)
    push!(q_terms, MOI.ScalarQuadraticTerm(-T(2), t, t))
    fq = MOI.ScalarQuadraticFunction(q_terms, a_terms, zero(T))
    quad = MOI.add_constraint(model, fq, MOI.LessThan(zero(T)))
    fp = convert(MOI.ScalarAffineFunction{T}, t)
    var_pos = MOI.add_constraint(model, fp, MOI.GreaterThan(zero(T)))
    return SOCtoNonConvexQuadBridge(quad, [var_pos], func.variables)
end

function MOI.supports_constraint(
    ::Type{<:SOCtoNonConvexQuadBridge},
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.SecondOrderCone},
)
    return true
end

function concrete_bridge_type(
    ::Type{SOCtoNonConvexQuadBridge{T}},
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.SecondOrderCone},
) where {T}
    return SOCtoNonConvexQuadBridge{T}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    b::SOCtoNonConvexQuadBridge,
)
    return MOI.SecondOrderCone(length(b.vars))
end

"""
    RSOCtoNonConvexQuadBridge{T} <: Bridges.Constraint.AbstractBridge

`RSOCtoNonConvexQuadBridge` implements the following reformulations:

  * ``||x||_2^2 \\le 2tu`` into ``\\sum x^2 - 2tu \\le 0``,
    ``1t + 0 \\ge 0``, and ``1u + 0 \\ge 0``.

The [`MOI.ScalarAffineFunction`](@ref)s ``1t + 0`` and ``1u + 0`` are used
in case the variables have other bound constraints.

!!! warning
    This transformation starts from a convex constraint and creates a
    non-convex constraint. Unless the solver has explicit support for detecting
    rotated second-order cones in quadratic form, this may (wrongly) be
    interpreted by the solver as being non-convex. Therefore, this bridge is not
    added automatically by [`MOI.Bridges.full_bridge_optimizer`](@ref). Care is
    recommended when adding this bridge to a optimizer.

## Source node

`RSOCtoNonConvexQuadBridge` supports:

  * [`MOI.VectorOfVariables`](@ref) in [`MOI.RotatedSecondOrderCone`](@ref)

## Target nodes

`RSOCtoNonConvexQuadBridge` creates:

  * [`MOI.ScalarQuadraticFunction{T}`](@ref) in [`MOI.LessThan{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.GreaterThan{T}`](@ref)
"""
struct RSOCtoNonConvexQuadBridge{T} <: _AbstractSOCtoNonConvexQuadBridge{T}
    quad::MOI.ConstraintIndex{MOI.ScalarQuadraticFunction{T},MOI.LessThan{T}}
    var_pos::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}},
    }
    vars::Vector{MOI.VariableIndex}
end

const RSOCtoNonConvexQuad{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{RSOCtoNonConvexQuadBridge{T},OT}

function bridge_constraint(
    ::Type{RSOCtoNonConvexQuadBridge{T}},
    model,
    func::MOI.VectorOfVariables,
    set::MOI.RotatedSecondOrderCone,
) where {T}
    t, u, x = func.variables[1], func.variables[2], func.variables[3:end]
    a_terms = MOI.ScalarAffineTerm{T}[]
    q_terms = MOI.ScalarQuadraticTerm.(T(2), x, x)
    push!(q_terms, MOI.ScalarQuadraticTerm(-T(2), t, u))
    fq = MOI.ScalarQuadraticFunction(q_terms, a_terms, zero(T))
    quad = MOI.add_constraint(model, fq, MOI.LessThan(zero(T)))
    fp1 = convert(MOI.ScalarAffineFunction{T}, t)
    var_pos1 = MOI.add_constraint(model, fp1, MOI.GreaterThan(zero(T)))
    fp2 = convert(MOI.ScalarAffineFunction{T}, u)
    var_pos2 = MOI.add_constraint(model, fp2, MOI.GreaterThan(zero(T)))
    return RSOCtoNonConvexQuadBridge(quad, [var_pos1, var_pos2], func.variables)
end

function MOI.supports_constraint(
    ::Type{<:RSOCtoNonConvexQuadBridge},
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.RotatedSecondOrderCone},
)
    return true
end

function concrete_bridge_type(
    ::Type{RSOCtoNonConvexQuadBridge{T}},
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.RotatedSecondOrderCone},
) where {T}
    return RSOCtoNonConvexQuadBridge{T}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    b::RSOCtoNonConvexQuadBridge,
)
    return MOI.RotatedSecondOrderCone(length(b.vars))
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableFlipSign

using Test

import MathOptInterface as MOI

include("../utilities.jl")

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_NonposToNonneg()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Variable.NonposToNonneg{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [-4, 3, 16, 0],
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) => [[7, 2, -4]],
        )
    MOI.Test.test_conic_linear_VectorOfVariables_2(
        bridged_mock,
        MOI.Test.Config(),
    )
    @test MOI.get(mock, MOI.NumberOfVariables()) == 4
    @test MOI.get(bridged_mock, MOI.NumberOfVariables()) == 4
    # Variables are ordered
    #   x in R^1, y in R_-^1, z in R^1, s in R^1
    vis = MOI.get(bridged_mock, MOI.ListOfVariableIndices())
    y = vis[2]
    @test y.value == -1

    @test MOI.supports(
        bridged_mock,
        MOI.VariablePrimalStart(),
        MOI.VariableIndex,
    )
    @test MOI.supports(
        bridged_mock,
        MOI.VariablePrimalStart(),
        typeof(MOI.Bridges.bridge(bridged_mock, y)),
    )
    MOI.set(bridged_mock, MOI.VariablePrimalStart(), y, 1.0)
    x, y_flipped, z, s = MOI.get(mock, MOI.ListOfVariableIndices())
    @test MOI.get(mock, MOI.VariablePrimalStart(), y_flipped) == -1
    @test MOI.get(bridged_mock, MOI.VariablePrimalStart(), y) == 1

    var_names = ["x", "y", "z", "w"]
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    con_w = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Zeros}(),
    )[1]
    con_yz = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonnegatives}(),
    )
    con_ex = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Zeros,
        }(),
    )[1]

    MOI.set(mock, MOI.ConstraintName(), con_w, "cw")
    MOI.set(mock, MOI.ConstraintName(), con_yz[1], "cy")
    MOI.set(mock, MOI.ConstraintName(), con_yz[2], "cz")
    MOI.set(mock, MOI.ConstraintName(), con_ex, "cex")

    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices())[2],
        "v",
    )
    con_v = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonpositives}(),
    )[1]
    MOI.set(bridged_mock, MOI.ConstraintName(), con_v, "cv")
    s = """
    variables: x, y, z, w
    cw: [w] in Zeros(1)
    cy: [y] in Nonnegatives(1)
    cz: [z] in Nonnegatives(1)
    cex: [1*x + -1*w + 4.0, -1*y + 3.0, 1*x + 1*z + -12.0] in Zeros(3)
    minobjective: 3*x + -2*y + -4*z
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        var_names,
        ["cw", "cy", "cz", "cex"],
    )
    s = """
    variables: x, z, w, v
    cv: [v] in Nonpositives(1)
    cw: [w] in Zeros(1)
    cz: [z] in Nonnegatives(1)
    cex: [1*x + -1*w + 4.0, 1*v + 3.0, 1*x + 1*z + -12.0] in Zeros(3)
    minobjective: 3*x + 2*v + -4*z
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        ["x", "z", "w", "v"],
        ["cv", "cw", "cz", "cex"],
    )
    return
end

function test_conic_linear_INFEASIBLE_2()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Variable.NonposToNonneg{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            MOI.INFEASIBLE_POINT,
            MOI.INFEASIBILITY_CERTIFICATE,
        ),
    )
    MOI.Test.test_conic_linear_INFEASIBLE_2(bridged_mock, MOI.Test.Config())
    @test MOI.get(mock, MOI.NumberOfVariables()) == 1
    @test length(MOI.get(mock, MOI.ListOfVariableIndices())) == 1
    @test first(MOI.get(mock, MOI.ListOfVariableIndices())).value ≥ 0
    @test MOI.get(bridged_mock, MOI.NumberOfVariables()) == 1
    vis = MOI.get(bridged_mock, MOI.ListOfVariableIndices())
    @test vis == [MOI.VariableIndex(-1)]
    _test_delete_bridged_variable(
        bridged_mock,
        vis[1],
        MOI.Nonpositives,
        1,
        ((MOI.VectorOfVariables, MOI.Nonnegatives, 0),),
    )
    return
end

function test_delete_in_vector()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Variable.NonposToNonneg{Float64}(mock)
    vis, _ = MOI.add_constrained_variables(bridged_mock, MOI.Nonpositives(4))
    _test_delete_bridged_variable(
        bridged_mock,
        vis[2],
        MOI.Nonpositives,
        4,
        ((MOI.VectorOfVariables, MOI.Nonnegatives, 0),),
        used_bridges = 0,
        used_constraints = 0,
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.NonposToNonnegBridge,
        """
        constrainedvariable: [x, y] in Nonpositives(2)
        minobjective: x + y
        c: 2.0 * x + -3.0 * y <= 1.0
        """,
        """
        constrainedvariable: [x, y] in Nonnegatives(2)
        minobjective: -1.0 * x + -1.0 * y
        c: -2.0 * x + 3.0 * y <= 1.0
        """,
    )
    return
end

function test_adjoint_map_function()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.NonposToNonneg{Float64}(inner)
    x, _ = MOI.add_constrained_variables(model, MOI.Nonpositives(1))
    @test MOI.Bridges.adjoint_map_function(model.map[only(x)], 1.23) == -1.23
    return
end

end  # module

TestVariableFlipSign.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Tips for writing type stable code in this file.
#
# Because the .optimizer field can by an abstract type (for example, JuMP uses
# AbstractOptimizer), referring to `.optimizer` in a function is not always
# type-stable. To help the compiler, always annotate the return type of a
# function that uses `.optimizer`. For example:
# `MOI.supports(model.optimizer, F, S)::Bool`.

MOI.@_documented_enum(
    """
        CachingOptimizerState

    A [`Utilities.CachingOptimizer`](@ref) may be in one of three possible
    states.
    """,
    CachingOptimizerState,
    "The CachingOptimizer does not have any optimizer.",
    NO_OPTIMIZER,
    """
    The CachingOptimizer has an optimizer. The optimizer is empty and it is not
    synchronized with the cached model.
    """,
    EMPTY_OPTIMIZER,
    """
    The CachingOptimizer has an optimizer, and it is synchronized with the
    cached model.
    """,
    ATTACHED_OPTIMIZER,
)
MOI.@_documented_enum(
    """
        CachingOptimizerMode

    A [`Utilities.CachingOptimizer`](@ref) has two modes of operation.
    """,
    CachingOptimizerMode,
    """
    The only methods that change the state of the `CachingOptimizer`
    are [`Utilities.reset_optimizer`](@ref), [`Utilities.drop_optimizer`](@ref),
    and [`Utilities.attach_optimizer`](@ref).

    Attempting to perform an operation in the incorrect state results in an
    error.
    """,
    MANUAL,
    """
    The [`Utilities.CachingOptimizer`](@ref) changes its state when necessary.
    For example, [`MOI.optimize!`](@ref) will automatically call
    [`Utilities.attach_optimizer`](@ref) (an optimizer must have been previously
    set). Attempting to add a constraint or perform a modification not supported
    by the optimizer results in a drop to the [`EMPTY_OPTIMIZER`](@ref) state.
    """,
    AUTOMATIC,
)

"""
    CachingOptimizer

`CachingOptimizer` is an intermediate layer that stores a cache of the model and
links it with an optimizer. It supports incremental model construction and
modification even when the optimizer doesn't.

## Mode

A [`Utilities.CachingOptimizer`](@ref) has two modes of operation:
[`Utilities.AUTOMATIC`](@ref) and [`Utilities.MANUAL`](@ref). See their
docstrings for details.

Use [`Utilities.mode`](@ref) to query the mode of a
[`Utilities.CachingOptimizer`](@ref).

## State

A [`Utilities.CachingOptimizer`](@ref) may be in one of three possible states:
[`NO_OPTIMIZER`](@ref), [`Utilities.EMPTY_OPTIMIZER`](@ref), and
[`Utilities.ATTACHED_OPTIMIZER`](@ref). See their docstrings for details.

Use [`Utilities.state`](@ref) to query the state of a
[`Utilities.CachingOptimizer`](@ref).

## Constructor with optimizer

```julia
    CachingOptimizer(cache::MOI.ModelLike, optimizer::AbstractOptimizer)
```

Creates a `CachingOptimizer` in [`AUTOMATIC`](@ref) mode, with the optimizer
`optimizer`.

The type of the optimizer returned is
`CachingOptimizer{typeof(optimizer),typeof(cache)}` so it does not support the
function [`Utilities.reset_optimizer(::CachingOptimizer, new_optimizer)`](@ref)
if the type of `new_optimizer` is different from the type of `optimizer`.

## Constructor without optimizer

```julia
    CachingOptimizer(cache::MOI.ModelLike, mode::CachingOptimizerMode)
```

Creates a `CachingOptimizer` in the [`NO_OPTIMIZER`](@ref)
[`Utilities.CachingOptimizerState`](@ref) and the
[`Utilities.CachingOptimizerMode`](@ref) `mode`.

The type of the optimizer returned is
`CachingOptimizer{MOI.AbstractOptimizer,typeof(cache)}` so it _does_ support the
function `reset_optimizer(::CachingOptimizer, new_optimizer)` if the type of
`new_optimizer` is different from the type of `optimizer`.
"""
mutable struct CachingOptimizer{O,M<:MOI.ModelLike} <: MOI.AbstractOptimizer
    optimizer::Union{Nothing,O}
    model_cache::M
    state::CachingOptimizerState
    mode::CachingOptimizerMode
    model_to_optimizer_map::IndexMap
    optimizer_to_model_map::IndexMap
    # CachingOptimizer externally uses the same variable and constraint indices
    # as the model_cache. model_to_optimizer_map maps from the model_cache
    # indices to the optimizer indices.

    function CachingOptimizer(cache::MOI.ModelLike, mode::CachingOptimizerMode)
        return new{MOI.AbstractOptimizer,typeof(cache)}(
            nothing,
            cache,
            NO_OPTIMIZER,
            mode,
            IndexMap(),
            IndexMap(),
        )
    end

    function CachingOptimizer(cache::MOI.ModelLike, optimizer::MOI.ModelLike)
        @assert MOI.is_empty(optimizer)
        model = new{typeof(optimizer),typeof(cache)}(
            optimizer,
            cache,
            EMPTY_OPTIMIZER,
            AUTOMATIC,
            IndexMap(),
            IndexMap(),
        )
        # Optimizer attributes should be copied now. Other attributes are copied
        # later during `copy_to`.
        _copy_optimizer_attributes(model)
        return model
    end
end

function Base.show(io::IO, model::CachingOptimizer)
    offset = Base.get(io, :offset, "")
    println(io, "MOIU.CachingOptimizer")
    println(io, offset, "├ state: $(model.state)")
    println(io, offset, "├ mode: $(model.mode)")
    print_with_acronym(io, "$(offset)├ model_cache: ")
    show(IOContext(io, :offset => offset * "│ "), model.model_cache)
    print_with_acronym(io, "\n$(offset)└ optimizer: ")
    if model.optimizer === nothing
        print(io, "nothing")
    else
        show(IOContext(io, :offset => offset * "  "), model.optimizer)
    end
    return
end

function _copy_optimizer_attributes(m::CachingOptimizer)
    @assert m.state == EMPTY_OPTIMIZER
    for attr in MOI.get(m.model_cache, MOI.ListOfOptimizerAttributesSet())
        # Skip attributes which don't apply to the new optimizer.
        if attr isa MOI.RawOptimizerAttribute
            # Even if the optimizer claims to `supports` `attr`, the value
            # might have a different meaning (for example, two solvers with `logLevel`
            # as a RawOptimizerAttribute). To be on the safe side, just skip all
            # raw parameters.
            continue
        elseif !MOI.is_copyable(attr) || !MOI.supports(m.optimizer, attr)::Bool
            continue
        end
        value = MOI.get(m.model_cache, attr)
        optimizer_value = map_indices(m.model_to_optimizer_map, attr, value)
        MOI.set(m.optimizer, attr, optimizer_value)
    end
    return
end

## Methods for managing the state of CachingOptimizer.

"""
    state(m::CachingOptimizer)::CachingOptimizerState

Returns the state of the CachingOptimizer `m`.

See [`Utilities.CachingOptimizer`](@ref).
"""
state(m::CachingOptimizer) = m.state

"""
    mode(m::CachingOptimizer)::CachingOptimizerMode

Returns the operating mode of the CachingOptimizer `m`.

See [`Utilities.CachingOptimizer`](@ref).
"""
mode(m::CachingOptimizer) = m.mode

"""
    reset_optimizer(m::CachingOptimizer, optimizer::MOI.AbstractOptimizer)

Sets or resets `m` to have the given empty optimizer `optimizer`.

Can be called from any state. An assertion error will be thrown if `optimizer`
is not empty.

The `CachingOptimizer` `m` will be in state `EMPTY_OPTIMIZER` after the call.
"""
function reset_optimizer(m::CachingOptimizer, optimizer::MOI.AbstractOptimizer)
    @assert MOI.is_empty(optimizer)
    m.optimizer = optimizer
    m.state = EMPTY_OPTIMIZER
    _copy_optimizer_attributes(m)
    return
end

"""
    reset_optimizer(m::CachingOptimizer)

Detaches and empties the current optimizer. Can be called from `ATTACHED_OPTIMIZER`
or `EMPTY_OPTIMIZER` state. The `CachingOptimizer` will be in state `EMPTY_OPTIMIZER`
after the call.
"""
function reset_optimizer(m::CachingOptimizer)
    m.state == EMPTY_OPTIMIZER && return
    @assert m.state == ATTACHED_OPTIMIZER
    MOI.empty!(m.optimizer)
    m.state = EMPTY_OPTIMIZER
    return
end

"""
    drop_optimizer(m::CachingOptimizer)

Drops the optimizer, if one is present. Can be called from any state.
The `CachingOptimizer` will be in state `NO_OPTIMIZER` after the call.
"""
function drop_optimizer(m::CachingOptimizer)
    m.optimizer = nothing
    m.state = NO_OPTIMIZER
    return
end

"""
    attach_optimizer(model::CachingOptimizer)

Attaches the optimizer to `model`, copying all model data into it. Can be called
only from the `EMPTY_OPTIMIZER` state. If the copy succeeds, the
`CachingOptimizer` will be in state `ATTACHED_OPTIMIZER` after the call,
otherwise an error is thrown; see [`MOI.copy_to`](@ref) for more details on which
errors can be thrown.
"""
function attach_optimizer(model::CachingOptimizer)
    @assert model.state == EMPTY_OPTIMIZER
    final_touch(model, nothing)
    indexmap = MOI.copy_to(model.optimizer, model.model_cache)::IndexMap
    model.state = ATTACHED_OPTIMIZER
    model.model_to_optimizer_map = indexmap
    model.optimizer_to_model_map = _reverse_index_map(indexmap)
    return
end

function _reverse_index_map(src::IndexMap)
    dest = IndexMap()
    sizehint!(dest.var_map, length(src.var_map))
    _reverse_dict(dest.var_map, src.var_map)
    _reverse_dict(dest.con_map, src.con_map)
    return dest
end

function _reverse_dict(dest::AbstractDict, src::AbstractDict)
    for (k, v) in src
        dest[v] = k
    end
    return
end

function _reverse_dict(
    dest::DoubleDicts.IndexDoubleDict,
    src::DoubleDicts.IndexDoubleDict,
)
    for (key, value) in src.dict
        dest.dict[key] = MOI.Utilities._reverse_dict(value)
    end
    return
end

function _reverse_dict(src::D) where {D<:Dict}
    return D(values(src) .=> keys(src))
end

function pass_nonvariable_constraints(
    dest::CachingOptimizer,
    src::MOI.ModelLike,
    idxmap::IndexMap,
    constraint_types,
)
    # This method gets called during default_copy_to, so the dest cannot be
    # attached at that point.
    @assert dest.state != ATTACHED_OPTIMIZER
    pass_nonvariable_constraints(
        dest.model_cache,
        src,
        idxmap,
        constraint_types,
    )
    return
end

function final_touch(m::CachingOptimizer, index_map)
    return final_touch(m.model_cache, index_map)
end

function MOI.copy_to(m::CachingOptimizer, src::MOI.ModelLike)
    if m.state == ATTACHED_OPTIMIZER
        reset_optimizer(m)
    end
    return MOI.copy_to(m.model_cache, src)
end

function MOI.supports_incremental_interface(model::CachingOptimizer)
    return MOI.supports_incremental_interface(model.model_cache)
end

function MOI.empty!(m::CachingOptimizer)
    MOI.empty!(m.model_cache)
    if m.state != NO_OPTIMIZER
        # We call `empty!` even if the state is already `EMPTY_OPTIMIZER`
        # because we may have used to two-argument `optimize!` for a single-shot
        # solver.
        MOI.empty!(m.optimizer)
        m.state = EMPTY_OPTIMIZER
    end
    m.model_to_optimizer_map = IndexMap()
    m.optimizer_to_model_map = IndexMap()
    return
end

MOI.is_empty(m::CachingOptimizer) = MOI.is_empty(m.model_cache)

# Optimizing and adding/modifying constraints and variables.

function MOI.optimize!(m::CachingOptimizer)
    if m.mode == AUTOMATIC && m.state == EMPTY_OPTIMIZER
        final_touch(m.model_cache, nothing)
        # Here is a special case for callbacks: we can't use the two-argument
        # call to `optimize!` because we need the `optimizer_to_model_map` to be
        # set _prior_ to starting the optimization process. Therefore, we need
        # to check if we have an `AbstractCallback` set and attach the optimizer
        # before recalling `MOI.optimize!`.
        for attr in MOI.get(m, MOI.ListOfModelAttributesSet())
            if attr isa MOI.AbstractCallback
                attach_optimizer(m)
                MOI.optimize!(m)
                return
            end
        end
        indexmap, copied = MOI.optimize!(m.optimizer, m.model_cache)
        if copied
            m.state = ATTACHED_OPTIMIZER
        end
        m.model_to_optimizer_map = indexmap
        m.optimizer_to_model_map = _reverse_index_map(indexmap)
    else
        # TODO: better error message if no optimizer is set
        @assert m.state == ATTACHED_OPTIMIZER
        MOI.optimize!(m.optimizer)
    end
    return
end

function MOI.add_variable(m::CachingOptimizer)
    if m.state == ATTACHED_OPTIMIZER
        if m.mode == AUTOMATIC
            try
                vindex_optimizer =
                    MOI.add_variable(m.optimizer)::MOI.VariableIndex
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            vindex_optimizer = MOI.add_variable(m.optimizer)::MOI.VariableIndex
        end
    end
    vindex = MOI.add_variable(m.model_cache)
    if m.state == ATTACHED_OPTIMIZER
        m.model_to_optimizer_map[vindex] = vindex_optimizer
        m.optimizer_to_model_map[vindex_optimizer] = vindex
    end
    return vindex
end

function MOI.add_variables(m::CachingOptimizer, n)
    if m.state == ATTACHED_OPTIMIZER
        if m.mode == AUTOMATIC
            try
                vindices_optimizer =
                    MOI.add_variables(m.optimizer, n)::Vector{MOI.VariableIndex}
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            vindices_optimizer =
                MOI.add_variables(m.optimizer, n)::Vector{MOI.VariableIndex}
        end
    end
    vindices = MOI.add_variables(m.model_cache, n)
    if m.state == ATTACHED_OPTIMIZER
        for (vindex, vindex_optimizer) in zip(vindices, vindices_optimizer)
            m.model_to_optimizer_map[vindex] = vindex_optimizer
            m.optimizer_to_model_map[vindex_optimizer] = vindex
        end
    end
    return vindices
end

function MOI.supports_add_constrained_variable(
    m::CachingOptimizer,
    S::Type{<:MOI.AbstractScalarSet},
)
    return MOI.supports_add_constrained_variable(m.model_cache, S) && (
        m.state == NO_OPTIMIZER ||
        MOI.supports_add_constrained_variable(m.optimizer, S)::Bool
    )
end

function MOI.add_constrained_variable(
    m::CachingOptimizer,
    set::S,
) where {S<:MOI.AbstractScalarSet}
    if m.state == ATTACHED_OPTIMIZER
        if m.mode == AUTOMATIC
            try
                vindex_optimizer, cindex_optimizer =
                    MOI.add_constrained_variable(
                        m.optimizer,
                        set,
                    )::Tuple{
                        MOI.VariableIndex,
                        MOI.ConstraintIndex{MOI.VariableIndex,S},
                    }
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            vindex_optimizer, cindex_optimizer = MOI.add_constrained_variable(
                m.optimizer,
                set,
            )::Tuple{
                MOI.VariableIndex,
                MOI.ConstraintIndex{MOI.VariableIndex,S},
            }
        end
    end
    vindex, cindex = MOI.add_constrained_variable(m.model_cache, set)
    if m.state == ATTACHED_OPTIMIZER
        m.model_to_optimizer_map[vindex] = vindex_optimizer
        m.optimizer_to_model_map[vindex_optimizer] = vindex
        m.model_to_optimizer_map[cindex] = cindex_optimizer
        m.optimizer_to_model_map[cindex_optimizer] = cindex
    end
    return vindex, cindex
end

function _supports_add_constrained_variables(
    m::CachingOptimizer,
    S::Type{<:MOI.AbstractVectorSet},
)
    return MOI.supports_add_constrained_variables(m.model_cache, S) && (
        m.state == NO_OPTIMIZER ||
        MOI.supports_add_constrained_variables(m.optimizer, S)::Bool
    )
end

# Split in two to solve ambiguity
function MOI.supports_add_constrained_variables(
    m::CachingOptimizer,
    ::Type{MOI.Reals},
)
    return _supports_add_constrained_variables(m, MOI.Reals)
end

function MOI.supports_add_constrained_variables(
    m::CachingOptimizer,
    S::Type{<:MOI.AbstractVectorSet},
)
    return _supports_add_constrained_variables(m, S)
end

function MOI.add_constrained_variables(
    m::CachingOptimizer,
    set::S,
) where {S<:MOI.AbstractVectorSet}
    if m.state == ATTACHED_OPTIMIZER
        if m.mode == AUTOMATIC
            try
                vindices_optimizer, cindex_optimizer =
                    MOI.add_constrained_variables(
                        m.optimizer,
                        set,
                    )::Tuple{
                        Vector{MOI.VariableIndex},
                        MOI.ConstraintIndex{MOI.VectorOfVariables,S},
                    }
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            vindices_optimizer, cindex_optimizer =
                MOI.add_constrained_variables(
                    m.optimizer,
                    set,
                )::Tuple{
                    Vector{MOI.VariableIndex},
                    MOI.ConstraintIndex{MOI.VectorOfVariables,S},
                }
        end
    end
    vindices, cindex = MOI.add_constrained_variables(m.model_cache, set)
    if m.state == ATTACHED_OPTIMIZER
        for (vindex, vindex_optimizer) in zip(vindices, vindices_optimizer)
            m.model_to_optimizer_map[vindex] = vindex_optimizer
            m.optimizer_to_model_map[vindex_optimizer] = vindex
        end
        m.model_to_optimizer_map[cindex] = cindex_optimizer
        m.optimizer_to_model_map[cindex_optimizer] = cindex
    end
    return vindices, cindex
end

function MOI.supports_constraint(
    m::CachingOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    return MOI.supports_constraint(m.model_cache, F, S) && (
        m.state == NO_OPTIMIZER ||
        MOI.supports_constraint(m.optimizer, F, S)::Bool
    )
end

function MOI.add_constraint(
    m::CachingOptimizer,
    func::F,
    set::S,
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    if m.state == ATTACHED_OPTIMIZER
        if m.mode == AUTOMATIC
            try
                cindex_optimizer = MOI.add_constraint(
                    m.optimizer,
                    map_indices(m.model_to_optimizer_map, func),
                    set,
                )::MOI.ConstraintIndex{F,S}
            catch err
                _rethrow_if_not_NotAllowedError(err)
                # It could be MOI.AddConstraintNotAllowed{F', S'} with F' != F
                # or S' != S if, for example, the `F`-in-`S` constraint is bridged
                # to other constraints in `m.optimizer`
                reset_optimizer(m)
            end
        else
            cindex_optimizer = MOI.add_constraint(
                m.optimizer,
                map_indices(m.model_to_optimizer_map, func),
                set,
            )::MOI.ConstraintIndex{F,S}
        end
    end
    cindex = MOI.add_constraint(m.model_cache, func, set)
    if m.state == ATTACHED_OPTIMIZER
        m.model_to_optimizer_map[cindex] = cindex_optimizer
        m.optimizer_to_model_map[cindex_optimizer] = cindex
    end
    return cindex
end

function MOI.modify(
    m::CachingOptimizer,
    cindex::MOI.ConstraintIndex,
    change::MOI.AbstractFunctionModification,
)
    if m.state == ATTACHED_OPTIMIZER
        cindex_optimizer = m.model_to_optimizer_map[cindex]
        change_optimizer = map_indices(m.model_to_optimizer_map, change)
        if m.mode == AUTOMATIC
            try
                MOI.modify(m.optimizer, cindex_optimizer, change_optimizer)
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            MOI.modify(m.optimizer, cindex_optimizer, change_optimizer)
        end
    end
    MOI.modify(m.model_cache, cindex, change)
    return
end

# This function avoids duplicating code in the MOI.set methods for
# ConstraintSet and ConstraintFunction methods, but allows us to strongly type
# the third and fourth arguments of the set methods so that we only support
# setting the same type of set or function.
function _replace_constraint_function_or_set(
    m::CachingOptimizer,
    attr,
    cindex,
    replacement,
)
    if m.state == ATTACHED_OPTIMIZER
        replacement_optimizer =
            map_indices(m.model_to_optimizer_map, replacement)
        if m.mode == AUTOMATIC
            try
                MOI.set(
                    m.optimizer,
                    attr,
                    m.model_to_optimizer_map[cindex],
                    replacement_optimizer,
                )
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            MOI.set(
                m.optimizer,
                attr,
                m.model_to_optimizer_map[cindex],
                replacement_optimizer,
            )
        end
    end
    MOI.set(m.model_cache, attr, cindex, replacement)
    return
end

function MOI.set(
    m::CachingOptimizer,
    ::MOI.ConstraintSet,
    cindex::MOI.ConstraintIndex{F,S},
    set::S,
) where {F,S}
    _replace_constraint_function_or_set(m, MOI.ConstraintSet(), cindex, set)
    return
end

function MOI.set(
    model::CachingOptimizer,
    ::MOI.ConstraintFunction,
    cindex::MOI.ConstraintIndex{F,S},
    func::F,
) where {F,S}
    _replace_constraint_function_or_set(
        model,
        MOI.ConstraintFunction(),
        cindex,
        func,
    )
    return
end

function MOI.set(
    ::CachingOptimizer,
    ::MOI.ConstraintFunction,
    ::MOI.ConstraintIndex{MOI.VariableIndex,S},
    ::MOI.VariableIndex,
) where {S}
    return throw(MOI.SettingVariableIndexNotAllowed())
end

function MOI.modify(
    m::CachingOptimizer,
    obj::MOI.ObjectiveFunction,
    change::MOI.AbstractFunctionModification,
)
    if m.state == ATTACHED_OPTIMIZER
        change_optimizer = map_indices(m.model_to_optimizer_map, change)
        if m.mode == AUTOMATIC
            try
                MOI.modify(m.optimizer, obj, change_optimizer)
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            MOI.modify(m.optimizer, obj, change_optimizer)
        end
    end
    MOI.modify(m.model_cache, obj, change)
    return
end

function MOI.is_valid(m::CachingOptimizer, index::MOI.Index)
    return MOI.is_valid(m.model_cache, index)
end

function MOI.delete(m::CachingOptimizer, index::MOI.Index)
    if m.state == ATTACHED_OPTIMIZER
        if !MOI.is_valid(m, index)
            # The index thrown by m.model_cache would be xored
            throw(MOI.InvalidIndex(index))
        end
        index_optimizer = m.model_to_optimizer_map[index]
        if m.mode == AUTOMATIC
            try
                MOI.delete(m.optimizer, index_optimizer)
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            MOI.delete(m.optimizer, index_optimizer)
        end
    end
    # The state may have changed in AUTOMATIC mode since reset_optimizer is
    # called in case the deletion is not supported
    if m.state == ATTACHED_OPTIMIZER
        delete!(m.optimizer_to_model_map, m.model_to_optimizer_map[index])
        delete!(m.model_to_optimizer_map, index)
    end
    MOI.delete(m.model_cache, index)
    return
end

function MOI.delete(m::CachingOptimizer, indices::Vector{<:MOI.Index})
    if m.state == ATTACHED_OPTIMIZER
        for index in indices
            if !MOI.is_valid(m, index)
                # The index thrown by m.model_cache would be xored
                throw(MOI.InvalidIndex(index))
            end
        end
        indices_optimizer =
            [m.model_to_optimizer_map[index] for index in indices]
        if m.mode == AUTOMATIC
            try
                MOI.delete(m.optimizer, indices_optimizer)
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            MOI.delete(m.optimizer, indices_optimizer)
        end
    end
    # The state may have changed in AUTOMATIC mode since reset_optimizer is
    # called in case the deletion is not supported
    if m.state == ATTACHED_OPTIMIZER
        for index in indices
            delete!(m.optimizer_to_model_map, m.model_to_optimizer_map[index])
            delete!(m.model_to_optimizer_map, index)
        end
    end
    MOI.delete(m.model_cache, indices)
    return
end

# TODO: add_constraints, transform

## CachingOptimizer get and set attributes

# Attributes are mapped through `map_indices` (defined in functions.jl) before
# they are sent to the optimizer and when they are returned from the optimizer.
# As a result, values of attributes must implement `map_indices`.

function MOI.set(m::CachingOptimizer, attr::MOI.AbstractModelAttribute, value)
    if m.state == ATTACHED_OPTIMIZER
        optimizer_value = map_indices(m.model_to_optimizer_map, attr, value)
        if m.mode == AUTOMATIC
            try
                MOI.set(m.optimizer, attr, optimizer_value)
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            MOI.set(m.optimizer, attr, optimizer_value)
        end
    end
    MOI.set(m.model_cache, attr, value)
    return
end

function MOI.set(
    m::CachingOptimizer,
    attr::Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
    index::MOI.Index,
    value,
)
    if m.state == ATTACHED_OPTIMIZER
        optimizer_index = m.model_to_optimizer_map[index]
        optimizer_value = map_indices(m.model_to_optimizer_map, attr, value)
        if m.mode == AUTOMATIC
            try
                MOI.set(m.optimizer, attr, optimizer_index, optimizer_value)
            catch err
                _rethrow_if_not_NotAllowedError(err)
                reset_optimizer(m)
            end
        else
            MOI.set(m.optimizer, attr, optimizer_index, optimizer_value)
        end
    end
    MOI.set(m.model_cache, attr, index, value)
    return
end

function MOI.supports(
    m::CachingOptimizer,
    attr::Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
    IndexType::Type{<:MOI.Index},
)
    return MOI.supports(m.model_cache, attr, IndexType) && (
        m.state == NO_OPTIMIZER ||
        MOI.supports(m.optimizer, attr, IndexType)::Bool
    )
end

function MOI.supports(
    m::CachingOptimizer,
    attr::Union{MOI.AbstractModelAttribute,MOI.AbstractOptimizerAttribute},
)
    return MOI.supports(m.model_cache, attr) &&
           (m.state == NO_OPTIMIZER || MOI.supports(m.optimizer, attr)::Bool)
end

_rethrow_if_not_NotAllowedError(err) = rethrow(err)

_rethrow_if_not_NotAllowedError(::MOI.NotAllowedError) = nothing

function _get_model_attribute(model::CachingOptimizer, attr::MOI.ObjectiveValue)
    try
        return MOI.get(model.optimizer, attr)
    catch err
        _rethrow_if_not_NotAllowedError(err)
        return get_fallback(model, attr)
    end
end

function _get_model_attribute(
    model::CachingOptimizer,
    attr::MOI.DualObjectiveValue,
)
    try
        return MOI.get(model.optimizer, attr)
    catch err
        _rethrow_if_not_NotAllowedError(err)
        MOI.check_result_index_bounds(model, attr)
        # We don't know what coefficient type to use, so just use whatever the
        # objective value type is. This is slightly inefficient, but it
        # shouldn't be a bottleneck.
        obj = _get_model_attribute(model, MOI.ObjectiveValue(attr.result_index))
        return get_fallback(model, attr, typeof(obj))
    end
end

function _get_model_attribute(
    model::CachingOptimizer,
    attr::MOI.AbstractModelAttribute,
)
    return map_indices(
        model.optimizer_to_model_map,
        attr,
        MOI.get(model.optimizer, attr)::MOI.attribute_value_type(attr),
    )
end

function _throw_if_get_attribute_not_allowed(
    model::CachingOptimizer,
    attr;
    needs_optimizer_map::Bool,
)
    # If the state(model) == EMPTY_OPTIMIZER, then
    # `model.model_to_optimizer_map[index]` might be empty (because copy_to
    # has not been called yet), or it might be full, if optimize!(dest, src)
    # did not leave a copy in `dest`.
    missing_map = needs_optimizer_map && isempty(model.model_to_optimizer_map)
    if state(model) == NO_OPTIMIZER || missing_map
        msg =
            "Cannot query $(attr) from `Utilities.CachingOptimizer` " *
            "because no optimizer is attached (the state is `$(state(model))`)."
        throw(MOI.GetAttributeNotAllowed(attr, msg))
    end
    return
end

function MOI.get(model::CachingOptimizer, attr::MOI.AbstractModelAttribute)
    if !MOI.is_set_by_optimize(attr)
        return MOI.get(model.model_cache, attr)
    end
    _throw_if_get_attribute_not_allowed(
        model,
        attr;
        needs_optimizer_map = false,
    )
    return _get_model_attribute(model, attr)
end

function MOI.get(
    model::CachingOptimizer,
    attr::MOI.TerminationStatus,
)::MOI.TerminationStatusCode
    if state(model) == NO_OPTIMIZER
        return MOI.OPTIMIZE_NOT_CALLED
    end
    return MOI.get(model.optimizer, attr)
end

function MOI.get(
    model::CachingOptimizer,
    attr::Union{MOI.PrimalStatus,MOI.DualStatus},
)::MOI.ResultStatusCode
    if state(model) == NO_OPTIMIZER
        return MOI.NO_SOLUTION
    end
    return MOI.get(model.optimizer, attr)
end

_has_fallback(::MOI.AnyAttribute, ::Type{<:MOI.Index}) = false

function MOI.get(
    model::CachingOptimizer,
    attr::Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
    index::MOI.Index,
)
    if !MOI.is_set_by_optimize(attr)
        return MOI.get(model.model_cache, attr, index)
    end
    _throw_if_get_attribute_not_allowed(model, attr; needs_optimizer_map = true)
    if _has_fallback(attr, typeof(index))
        return _get_fallback(model, attr, index)
    end
    value = MOI.get(
        model.optimizer,
        attr,
        model.model_to_optimizer_map[index],
    )::MOI.attribute_value_type(attr)
    return map_indices(model.optimizer_to_model_map, attr, value)
end

function MOI.get(
    model::CachingOptimizer,
    attr::Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
    indices::Vector{I},
) where {I<:MOI.Index}
    if !MOI.is_set_by_optimize(attr)
        return MOI.get(model.model_cache, attr, indices)
    end
    _throw_if_get_attribute_not_allowed(model, attr; needs_optimizer_map = true)
    if _has_fallback(attr, I)
        return _get_fallback(model, attr, indices)
    end
    value = MOI.get(
        model.optimizer,
        attr,
        map(Base.Fix1(getindex, model.model_to_optimizer_map), indices),
    )::Vector{<:MOI.attribute_value_type(attr)}
    return map_indices(model.optimizer_to_model_map, attr, value)
end

###
### MOI.ConstraintPrimal and MOI.ConstraintDual
###

# `ConstraintPrimal` is slightly unique for CachingOptimizer because if the solver
# doesn't support the attribute directly, we can use the fallback to query the
# function from the cache and the variable value from the optimizer.
# The `ConstraintDual` of a `VariableIndex` or `VectorOfVariables` can
# also be computed from the `ConstraintDual` of the other constraints.

_has_fallback(::MOI.ConstraintPrimal, ::Type{<:MOI.ConstraintIndex}) = true

function _has_fallback(
    ::MOI.ConstraintDual,
    ::Type{<:MOI.ConstraintIndex{F}},
) where {F<:Union{MOI.VariableIndex,MOI.VectorOfVariables}}
    return true
end

function _get_fallback(
    model::CachingOptimizer,
    attr::MOI.AbstractConstraintAttribute,
    index::MOI.ConstraintIndex,
)
    try
        return MOI.get(
            model.optimizer,
            attr,
            model.model_to_optimizer_map[index],
        )
    catch err
        _rethrow_if_not_NotAllowedError(err)
        return get_fallback(model, attr, index)
    end
end

function _get_fallback(
    model::CachingOptimizer,
    attr::MOI.AbstractConstraintAttribute,
    indices::Vector{<:MOI.ConstraintIndex},
)
    try
        return MOI.get(
            model.optimizer,
            attr,
            [model.model_to_optimizer_map[i] for i in indices],
        )
    catch err
        _rethrow_if_not_NotAllowedError(err)
        return [get_fallback(model, attr, i) for i in indices]
    end
end

#####
##### Names
#####

function MOI.supports(
    model::CachingOptimizer,
    attr::Union{MOI.VariableName,MOI.ConstraintName},
    IndexType::Type{<:MOI.Index},
)
    return MOI.supports(model.model_cache, attr, IndexType)
end

function MOI.set(
    model::CachingOptimizer,
    attr::Union{MOI.VariableName,MOI.ConstraintName},
    index::MOI.Index,
    value,
)
    MOI.set(model.model_cache, attr, index, value)
    return
end

function MOI.supports(m::CachingOptimizer, attr::MOI.Name)
    return MOI.supports(m.model_cache, attr)
end

function MOI.set(model::CachingOptimizer, attr::MOI.Name, value)
    MOI.set(model.model_cache, attr, value)
    return
end

function MOI.get(m::CachingOptimizer, IdxT::Type{<:MOI.Index}, name::String)
    return MOI.get(m.model_cache, IdxT, name)
end

function MOI.set(
    model::CachingOptimizer,
    attr::MOI.AbstractOptimizerAttribute,
    value,
)
    optimizer_value = map_indices(model.model_to_optimizer_map, attr, value)
    if model.optimizer !== nothing
        MOI.set(model.optimizer, attr, optimizer_value)
    end
    MOI.set(model.model_cache, attr, value)
    return
end

function MOI.get(model::CachingOptimizer, attr::MOI.AbstractOptimizerAttribute)
    # TODO: Copyable attributes (for example, `Silent`, `TimeLimitSec`,
    # `NumberOfThreads`) should also be stored in the cache so we could
    # return the value stored in the cache instead. However, for
    # non-copyable attributes( for example, `SolverName`) the error is appropriate.
    _throw_if_get_attribute_not_allowed(
        model,
        attr;
        needs_optimizer_map = false,
    )
    return map_indices(
        model.optimizer_to_model_map,
        attr,
        MOI.get(model.optimizer, attr)::MOI.attribute_value_type(attr),
    )
end

# Force users to specify whether the attribute should be queried from the
# model_cache or the optimizer. Maybe we could consider a small whitelist of
# attributes to handle automatically.

# These are expert methods to get or set attributes directly in the model_cache
# or optimizer.

struct AttributeFromModelCache{T<:MOI.AnyAttribute}
    attr::T
end

struct AttributeFromOptimizer{T<:MOI.AnyAttribute}
    attr::T
end

function MOI.get(
    m::CachingOptimizer,
    attr::AttributeFromModelCache{T},
) where {T<:MOI.AbstractModelAttribute}
    return MOI.get(m.model_cache, attr.attr)
end

function MOI.get(
    m::CachingOptimizer,
    attr::AttributeFromModelCache{T},
    idx,
) where {
    T<:Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
}
    return MOI.get(m.model_cache, attr.attr, idx)
end

function MOI.get(
    m::CachingOptimizer,
    attr::AttributeFromOptimizer{T},
) where {T<:MOI.AbstractModelAttribute}
    @assert m.state == ATTACHED_OPTIMIZER
    return map_indices(
        m.optimizer_to_model_map,
        attr.attr,
        MOI.get(m.optimizer, attr.attr)::MOI.attribute_value_type(attr.attr),
    )
end

function MOI.get(
    m::CachingOptimizer,
    attr::AttributeFromOptimizer{T},
    idx::MOI.Index,
) where {
    T<:Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
}
    @assert m.state == ATTACHED_OPTIMIZER
    return map_indices(
        m.optimizer_to_model_map,
        attr.attr,
        MOI.get(
            m.optimizer,
            attr.attr,
            m.model_to_optimizer_map[idx],
        )::MOI.attribute_value_type(attr.attr),
    )
end

function MOI.get(
    m::CachingOptimizer,
    attr::AttributeFromOptimizer{T},
    idx::Vector{<:MOI.Index},
) where {
    T<:Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
}
    @assert m.state == ATTACHED_OPTIMIZER
    return map_indices(
        m.optimizer_to_model_map,
        attr.attr,
        MOI.get(
            m.optimizer,
            attr.attr,
            map_indices_to_optimizer(m, idx),
        )::Vector{<:MOI.attribute_value_type(attr.attr)},
    )
end

function MOI.set(
    m::CachingOptimizer,
    attr::AttributeFromModelCache{T},
    v,
) where {T<:MOI.AbstractModelAttribute}
    MOI.set(m.model_cache, attr.attr, v)
    return
end

function MOI.set(
    m::CachingOptimizer,
    attr::AttributeFromModelCache{T},
    idx,
    v,
) where {
    T<:Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
}
    MOI.set(m.model_cache, attr.attr, idx, v)
    return
end

function MOI.set(
    m::CachingOptimizer,
    attr::AttributeFromOptimizer{T},
    v,
) where {T<:MOI.AbstractModelAttribute}
    @assert m.state == ATTACHED_OPTIMIZER
    MOI.set(
        m.optimizer,
        attr.attr,
        map_indices(m.model_to_optimizer_map, attr.attr, v),
    )
    return
end

# Map vector of indices into vector of indices or one index into one index
function map_indices_to_optimizer(m::CachingOptimizer, idx::MOI.Index)
    return m.model_to_optimizer_map[idx]
end

function map_indices_to_optimizer(
    m::CachingOptimizer,
    indices::Vector{<:MOI.Index},
)
    return getindex.(Ref(m.model_to_optimizer_map), indices)
end

function MOI.set(
    m::CachingOptimizer,
    attr::AttributeFromOptimizer{T},
    idx,
    v,
) where {
    T<:Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
}
    @assert m.state == ATTACHED_OPTIMIZER
    MOI.set(
        m.optimizer,
        attr.attr,
        map_indices_to_optimizer(m, idx),
        map_indices(m.model_to_optimizer_map, attr.attr, v),
    )
    return
end

function MOI.supports(
    m::CachingOptimizer,
    attr::AttributeFromModelCache{T},
) where {T<:MOI.AbstractModelAttribute}
    return MOI.supports(m.model_cache, attr.attr)
end

function MOI.supports(
    m::CachingOptimizer,
    attr::AttributeFromModelCache{T},
    idxtype::Type{<:MOI.Index},
) where {
    T<:Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
}
    return MOI.supports(m.model_cache, attr.attr, idxtype)
end

function MOI.supports(
    m::CachingOptimizer,
    attr::AttributeFromOptimizer{T},
) where {T<:MOI.AbstractModelAttribute}
    @assert m.state == ATTACHED_OPTIMIZER
    return MOI.supports(m.optimizer, attr.attr)::Bool
end

function MOI.supports(
    m::CachingOptimizer,
    attr::AttributeFromOptimizer{T},
    idxtype::Type{<:MOI.Index},
) where {
    T<:Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
}
    @assert m.state == ATTACHED_OPTIMIZER
    return MOI.supports(m.optimizer, attr.attr, idxtype)::Bool
end

function MOI.supports(
    caching_opt::CachingOptimizer,
    sub::MOI.AbstractSubmittable,
)
    return caching_opt.optimizer !== nothing &&
           MOI.supports(caching_opt.optimizer, sub)::Bool
end

function MOI.submit(
    caching_opt::CachingOptimizer,
    sub::MOI.AbstractSubmittable,
    args...,
)
    return MOI.submit(
        caching_opt.optimizer,
        sub,
        map_indices.(Ref(caching_opt.model_to_optimizer_map), args)...,
    )
end

# TODO: get and set methods to look up/set name strings

function MOI.compute_conflict!(model::CachingOptimizer)
    MOI.compute_conflict!(model.optimizer)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    struct MapNotInvertible <: Exception
        message::String
    end

An error thrown by [`inverse_map_function`](@ref) or
[`inverse_adjoint_map_function`](@ref) indicating that the linear map `A`
defined in [`Variable.SetMapBridge`](@ref) and [`Constraint.SetMapBridge`](@ref)
is not invertible.
"""
struct MapNotInvertible <: Exception
    message::String
end

"""
    map_set(bridge::MOI.Bridges.AbstractBridge, set)
    map_set(::Type{BT}, set) where {BT}

Return the image of `set` through the linear map `A` defined in
[`Variable.SetMapBridge`](@ref) and [`Constraint.SetMapBridge`](@ref).

This function is used for bridging the constraint and setting the
[`MOI.ConstraintSet`](@ref).
"""
map_set(bridge::AbstractBridge, set) = map_set(typeof(bridge), set)

"""
    inverse_map_set(bridge::MOI.Bridges.AbstractBridge, set)
    inverse_map_set(::Type{BT}, set) where {BT}

Return the preimage of `set` through the linear map `A` defined in
[`Variable.SetMapBridge`](@ref) and [`Constraint.SetMapBridge`](@ref).

This function is used for getting the [`MOI.ConstraintSet`](@ref).

The method can alternatively be defined on the bridge type. This legacy
interface is kept for backward compatibility.
"""
function inverse_map_set(bridge::AbstractBridge, set)
    return inverse_map_set(typeof(bridge), set)
end

"""
    map_function(bridge::MOI.Bridges.AbstractBridge, func)
    map_function(::Type{BT}, func) where {BT}

Return the image of `func` through the linear map `A` defined in
[`Variable.SetMapBridge`](@ref) and [`Constraint.SetMapBridge`](@ref).

This function is used for getting the [`MOI.ConstraintPrimal`](@ref) of variable
bridges. For constraint bridges, this is used for bridging the constraint,
setting the [`MOI.ConstraintFunction`](@ref) and [`MOI.ConstraintPrimalStart`](@ref)
and modifying the function with [`MOI.modify`](@ref).

The default implementation of [`Constraint.bridge_constraint`](@ref) uses
[`map_function`](@ref) with the bridge type so if this function is defined
on the bridge type, [`Constraint.bridge_constraint`](@ref) does not need
to be implemented.
"""
function map_function(bridge::AbstractBridge, func)
    return map_function(typeof(bridge), func)
end

"""
    map_function(::Type{BT}, func, i::IndexInVector) where {BT}

Return the scalar function at the `i`th index of the vector function that
would be returned by `map_function(BT, func)` except that it may compute the
`i`th element. This is used by [`bridged_function`](@ref) and for getting
the [`MOI.VariablePrimal`](@ref) and
[`MOI.VariablePrimalStart`](@ref) of variable bridges.
"""
function map_function(::Type{BT}, func, i::IndexInVector) where {BT}
    return MOI.Utilities.eachscalar(map_function(BT, func))[i.value]
end

function map_function(bridge::AbstractBridge, func, i::IndexInVector)
    return map_function(typeof(bridge), func, i)
end

"""
    inverse_map_function(bridge::MOI.Bridges.AbstractBridge, func)
    inverse_map_function(::Type{BT}, func) where {BT}

Return the image of `func` through the inverse of the linear map `A` defined in
[`Variable.SetMapBridge`](@ref) and [`Constraint.SetMapBridge`](@ref).

This function is used by [`Variable.unbridged_map`](@ref) and for setting the
[`MOI.VariablePrimalStart`](@ref) of variable bridges and for getting the
[`MOI.ConstraintFunction`](@ref), the [`MOI.ConstraintPrimal`](@ref) and the
[`MOI.ConstraintPrimalStart`](@ref) of constraint bridges.

If the linear map `A` is not invertible, the error [`MapNotInvertible`](@ref) is
thrown.

The method can alternatively be defined on the bridge type. This legacy
interface is kept for backward compatibility.
"""
function inverse_map_function(bridge::AbstractBridge, func)
    return inverse_map_function(typeof(bridge), func)
end

"""
    adjoint_map_function(bridge::MOI.Bridges.AbstractBridge, func)
    adjoint_map_function(::Type{BT}, func) where {BT}

Return the image of `func` through the adjoint of the linear map `A` defined in
[`Variable.SetMapBridge`](@ref) and [`Constraint.SetMapBridge`](@ref).

This function is used for getting the [`MOI.ConstraintDual`](@ref) and
[`MOI.ConstraintDualStart`](@ref) of constraint bridges.

The method can alternatively be defined on the bridge type. This legacy
interface is kept for backward compatibility.
"""
function adjoint_map_function(bridge::AbstractBridge, func)
    return adjoint_map_function(typeof(bridge), func)
end

"""
    inverse_adjoint_map_function(bridge::MOI.Bridges.AbstractBridge, func)
    inverse_adjoint_map_function(::Type{BT}, func) where {BT}

Return the image of `func` through the inverse of the adjoint of the linear map
`A` defined in [`Variable.SetMapBridge`](@ref) and [`Constraint.SetMapBridge`](@ref).

This function is used for getting the [`MOI.ConstraintDual`](@ref) of variable
bridges and setting the [`MOI.ConstraintDualStart`](@ref) of constraint bridges.

If the linear map `A` is not invertible, the error [`MapNotInvertible`](@ref) is
thrown.

The method can alternatively be defined on the bridge type. This legacy
interface is kept for backward compatibility.
"""
function inverse_adjoint_map_function(bridge::AbstractBridge, func)
    return inverse_adjoint_map_function(typeof(bridge), func)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    test_linear_integration(model::MOI.ModelLike, config::Config{T}) where {T}

This test checks the integration of a sequence of common operations for linear
programs, including adding and deleting variables, and modifying variable
bounds and the objective function.
"""
function test_linear_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.EqualTo{T})
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    v = MOI.add_variables(model, 2)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    cf = MOI.ScalarAffineFunction{T}(MOI.ScalarAffineTerm{T}.(T(1), v), T(0))
    c = MOI.add_constraint(model, cf, MOI.LessThan(T(1)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    vc1 = MOI.add_constraint(model, v[1], MOI.GreaterThan(T(0)))
    # We test this after the creation of every `VariableIndex` constraint
    # to ensure a good coverage of corner cases.
    @test vc1.value == v[1].value
    # test fallback
    vc2 = MOI.add_constraint(model, v[2], MOI.GreaterThan(T(0)))
    @test vc2.value == v[2].value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 2
    end
    # Note: adding some redundant zero coefficients to catch solvers that don't
    # handle duplicate coefficients correctly:
    objf = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T[0, 0, -1, 0, 0, 0], [v; v; v]),
        T(0),
    )
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    if _supports(config, MOI.ConstraintFunction)
        vrs = MOI.get(model, MOI.ListOfVariableIndices())
        @test vrs == v || vrs == reverse(v)
        @test objf ≈ MOI.get(
            model,
            MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        )
        @test cf ≈ MOI.get(model, MOI.ConstraintFunction(), c)
        s = MOI.get(model, MOI.ConstraintSet(), c)
        @test s == MOI.LessThan(T(1))
        s = MOI.get(model, MOI.ConstraintSet(), vc1)
        @test s == MOI.GreaterThan(T(0))
        s = MOI.get(model, MOI.ConstraintSet(), vc2)
        @test s == MOI.GreaterThan(T(0))
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(-1), config)
        if _supports(config, MOI.DualObjectiveValue)
            @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(-1), config)
        end
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[1, 0], config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(1), config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c), T(-1), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc1), T(0), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc2), T(1), config)
        end
    end
    # change objective to Max +x
    objf =
        MOI.ScalarAffineFunction{T}(MOI.ScalarAffineTerm{T}.(T[1, 0], v), T(0))
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.ObjectiveFunction)
        @test objf ≈ MOI.get(
            model,
            MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        )
    end
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(1), config)
        if _supports(config, MOI.DualObjectiveValue)
            @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(1), config)
        end
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[1, 0], config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c), T(-1), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc1), T(0), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc2), T(1), config)
        end
    end
    # add new variable to get :
    # max x + 2z
    # s.t. x + y + z <= 1
    # x,y,z >= 0
    z = MOI.add_variable(model)
    push!(v, z)
    @test v[3] == z
    if _supports(config, MOI.ObjectiveFunction)
        # Test that the modification of v has not affected the model
        vars = map(
            t -> t.variable,
            MOI.get(model, MOI.ConstraintFunction(), c).terms,
        )
        @test vars == [v[1], v[2]] || vars == [v[2], v[1]]
        @test MOI.ScalarAffineFunction{T}(
            [MOI.ScalarAffineTerm{T}(T(1), v[1])],
            T(0),
        ) ≈ MOI.get(
            model,
            MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        )
    end
    vc3 = MOI.add_constraint(model, v[3], MOI.GreaterThan(T(0)))
    @test vc3.value == v[3].value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 3
    end
    if _supports(config, MOI.ScalarCoefficientChange)
        MOI.modify(model, c, MOI.ScalarCoefficientChange{T}(z, T(1)))
    else
        MOI.delete(model, c)
        cf =
            MOI.ScalarAffineFunction{T}(MOI.ScalarAffineTerm{T}.(T(1), v), T(0))
        c = MOI.add_constraint(model, cf, MOI.LessThan(T(1)))
    end
    MOI.modify(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarCoefficientChange{T}(z, T(2)),
    )
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 3
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus(1)) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(2), config)
        if _supports(config, MOI.DualObjectiveValue)
            @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(2), config)
        end
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), [0, 0, 1], config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(1), config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c), T(-2), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc1), T(1), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc2), T(2), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc3), T(0), config)
        end
    end
    # setting lb of x to -1 to get :
    # max x + 2z
    # s.t. x + y + z <= 1
    # x >= -1
    # y,z >= 0
    MOI.set(model, MOI.ConstraintSet(), vc1, MOI.GreaterThan(T(-1)))
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(3), config)
        if _supports(config, MOI.DualObjectiveValue)
            @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(3), config)
        end
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[-1, 0, 2], config)
    end
    # put lb of x back to 0 and fix z to zero to get :
    # max x + 2z
    # s.t. x + y + z <= 1
    # x, y >= 0, z = 0 (vc3)
    MOI.set(model, MOI.ConstraintSet(), vc1, MOI.GreaterThan(T(0)))
    MOI.delete(model, vc3)
    vc3 = MOI.add_constraint(model, v[3], MOI.EqualTo(T(0)))
    @test vc3.value == v[3].value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 2
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(1), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[1, 0, 0], config)
    end
    # modify affine linear constraint set to be == 2 to get :
    # max x + 2z
    # s.t. x + y + z == 2 (c)
    # x,y >= 0, z = 0
    MOI.delete(model, c)
    # Note: adding some redundant zero coefficients to catch solvers that don't
    # handle duplicate coefficients correctly:
    cf = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T[0, 0, 0, 1, 1, 1, 0, 0, 0], [v; v; v]),
        T(0),
    )
    c = MOI.add_constraint(model, cf, MOI.EqualTo(T(2)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 0
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.EqualTo{T},
            }(),
        ) == 1
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(2), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[2, 0, 0], config)
    end
    # modify objective function to x + 2y to get :
    # max x + 2y
    # s.t. x + y + z == 2 (c)
    # x,y >= 0, z = 0
    objf = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T[1, 2, 0], v),
        T(0),
    )
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.ObjectiveFunction)
        @test objf ≈ MOI.get(
            model,
            MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        )
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[0, 2, 0], config)
    end
    # add constraint x - y >= 0 (c2) to get :
    # max x+2y
    # s.t. x + y + z == 2 (c)
    # x - y >= 0 (c2)
    # x,y >= 0 (vc1,vc2), z = 0 (vc3)
    cf2 = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T[1, -1, 0], v),
        T(0),
    )
    c2 = MOI.add_constraint(model, cf2, MOI.GreaterThan(T(0)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.EqualTo{T},
            }(),
        ) == 1
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.GreaterThan{T},
            }(),
        ) == 1
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 0
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.EqualTo{T}}(),
        ) == 1
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 2
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.LessThan{T}}(),
        ) == 0
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(3), config)
        if _supports(config, MOI.DualObjectiveValue)
            @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(3), config)
        end
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[1, 1, 0], config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(2), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c2), T(0), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc1), T(1), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc2), T(1), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), vc3), T(0), config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus(1)) == MOI.FEASIBLE_POINT
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c), T(-3 // 2), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c2), T(1 // 2), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc1), T(0), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), vc2), T(0), config)
            @test ≈(
                MOI.get(model, MOI.ConstraintDual(), vc3),
                T(3 // 2),
                config,
            )
        end
    end
    if _supports(config, MOI.ConstraintFunction)
        @test MOI.get(model, MOI.ConstraintFunction(), c2) ≈ cf2
    end
    # delete variable x to get :
    # max 2y
    # s.t. y + z == 2
    # - y >= 0
    # y >= 0, z = 0
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 2
    end
    MOI.delete(model, v[1])
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 1
    end
    if _supports(config, MOI.ConstraintFunction)
        err = MOI.InvalidIndex(vc1)
        # vc1 should have been deleted with `v[1]`.
        @test_throws err MOI.get(model, MOI.ConstraintFunction(), vc1)
        @test_throws err MOI.get(model, MOI.ConstraintSet(), vc1)
        @test MOI.get(model, MOI.ConstraintFunction(), c2) ≈
              MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[-1, 0], [v[2], z]),
            T(0),
        )
        vrs = MOI.get(model, MOI.ListOfVariableIndices())
        @test vrs == [v[2], z] || vrs == [z, v[2]]
        @test MOI.get(
            model,
            MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        ) ≈ MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[2, 0], [v[2], z]),
            T(0),
        )
    end
end

function setup_test(
    ::typeof(test_linear_integration),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1, 0],
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1, 0],
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[0, 0, 1],
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-2],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[-1, 0, 2]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[1, 0, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[2, 0, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[0, 2, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1, 1, 0],
            (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) => T[-3//2],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) => T[1//2],
        ),
    )
    return
end

"""
    test_linear_program(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving a simple linear program.
"""
function test_linear_integration_2(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    # Min -x
    # s.t. x + y <= 1
    # x, y >= 0
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    cf = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T(1), [x, y]),
        T(0),
    )
    c = MOI.add_constraint(model, cf, MOI.LessThan(T(1)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    vc1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test vc1.value == x.value
    vc2 = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    @test vc2.value == y.value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 2
    end
    objf = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T[-1, 0], [x, y]),
        T(0),
    )
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(-1) atol = atol rtol =
            rtol
        if _supports(config, MOI.DualObjectiveValue)
            @test MOI.get(model, MOI.DualObjectiveValue()) ≈ T(-1) atol = atol rtol =
                rtol
        end
        @test MOI.get(model, MOI.VariablePrimal(), x) ≈ T(1) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), y) ≈ T(0) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.ConstraintPrimal(), c) ≈ T(1) atol = atol rtol =
            rtol
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test MOI.get(model, MOI.ConstraintDual(), c) ≈ T(-1) atol = atol rtol =
                rtol
            @test MOI.get(model, MOI.ConstraintDual(), vc1) ≈ T(0) atol = atol rtol =
                rtol
            @test MOI.get(model, MOI.ConstraintDual(), vc2) ≈ T(1) atol = atol rtol =
                rtol
        end
        if _supports(config, MOI.ConstraintBasisStatus)
            @test MOI.get(model, MOI.VariableBasisStatus(), x) == MOI.BASIC
            @test MOI.get(model, MOI.VariableBasisStatus(), y) ==
                  MOI.NONBASIC_AT_LOWER
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c) == MOI.NONBASIC
            _test_attribute_value_type(model, MOI.ConstraintBasisStatus(), c)
            _test_attribute_value_type(model, MOI.VariableBasisStatus(), x)
        end
    end
end

function setup_test(
    ::typeof(test_linear_integration_2),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1, 0],
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) =>
                    [MOI.NONBASIC],
            ],
            variable_basis_status = [MOI.BASIC, MOI.NONBASIC_AT_LOWER],
        ),
    )
    return
end

"""
    test_linear_inactive_bounds(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

This test checks solving a linear program with bounds that are not binding.
"""
function test_linear_inactive_bounds(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    # min  x
    # s.t. x >= 0
    #      x >= 3
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.LessThan{T})
    x = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    vc = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test vc.value == x.value
    cf = MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm{T}(T(1), x)], T(0))
    c = MOI.add_constraint(model, cf, MOI.GreaterThan(T(3)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 1
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.GreaterThan{T},
            }(),
        ) == 1
    end
    objf = MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm{T}(T(1), x)], T(0))
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ 3 atol = atol rtol = rtol
        @test MOI.get(model, MOI.VariablePrimal(), x) ≈ 3 atol = atol rtol =
            rtol
        if _supports(config, MOI.ConstraintBasisStatus)
            @test MOI.get(model, MOI.VariableBasisStatus(), x) == MOI.BASIC
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c) == MOI.NONBASIC
        end
    end
    # max  x
    # s.t. x <= 0
    #      x <= 3
    MOI.empty!(model)
    @test MOI.is_empty(model)
    x = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    vc = MOI.add_constraint(model, x, MOI.LessThan(T(0)))
    @test vc.value == x.value
    cf = MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm{T}(T(1), x)], T(0))
    c = MOI.add_constraint(model, cf, MOI.LessThan(T(3)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.LessThan{T}}(),
        ) == 1
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    objf = MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm{T}(T(1), x)], T(0))
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(0) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), x) ≈ T(0) atol = atol rtol =
            rtol
        if _supports(config, MOI.ConstraintBasisStatus)
            @test MOI.get(model, MOI.VariableBasisStatus(), x) ==
                  MOI.NONBASIC_AT_UPPER
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c) == MOI.BASIC
        end
    end
end

function setup_test(
    ::typeof(test_linear_inactive_bounds),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            [3],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                    [MOI.NONBASIC],
            ],
            variable_basis_status = [MOI.BASIC],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            [0],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) =>
                    [MOI.BASIC],
            ],
            variable_basis_status = [MOI.NONBASIC_AT_UPPER],
        ),
    )
    return
end

"""
    test_linear_LessThan_and_GreaterThan(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving a linear program with ScalarAffineFunction-in-LessThan and
GreaterThan constraints.
"""
function test_linear_LessThan_and_GreaterThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    # Min  x - y
    # s.t. T(0) <= x          (c1)
    #             y <= T(0)   (c2)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[1, -1], [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    fx = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    c1 = MOI.add_constraint(model, fx, MOI.GreaterThan(T(0)))
    fy = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), y)], T(0))
    c2 = MOI.add_constraint(model, fy, MOI.LessThan(T(0)))
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(0) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), x) ≈ T(0) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), y) ≈ T(0) atol = atol rtol =
            rtol
    end
    # Min  x - y
    # s.t. T(100) <= x
    #               y <= T(0)
    MOI.set(model, MOI.ConstraintSet(), c1, MOI.GreaterThan(T(100)))
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(100) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), x) ≈ T(100) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), y) ≈ T(0) atol = atol rtol =
            rtol
    end
    # Min  x - y
    # s.t. T(100) <= x
    #               y <= T(-100)
    MOI.set(model, MOI.ConstraintSet(), c2, MOI.LessThan(T(-100)))
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(200) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), x) ≈ T(100) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), y) ≈ T(-100) atol = atol rtol =
            rtol
    end
    return
end

function setup_test(
    ::typeof(test_linear_LessThan_and_GreaterThan),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[0, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[100, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[100, -100]),
    )
    return
end

"""
    test_linear_integration_modification(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a range of problem modifications for a linear program.
"""
function test_linear_integration_modification(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    # Start from simple LP
    # Solve it
    # Copy and solve again
    # Chg coeff, solve, change back solve
    # del constr and solve
    # del var and solve
    #   maximize x + y
    #
    #   s.t. 2 x + 1 y <= 4
    #        1 x + 2 y <= 4
    #        x >= 0, y >= 0
    #
    #   solution: x = 1.3333333, y = 1.3333333, objv = 2.66666666
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    cf1 = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T[2, 1], [x, y]),
        T(0),
    )
    cf2 = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T[1, 2], [x, y]),
        T(0),
    )
    c1 = MOI.add_constraint(model, cf1, MOI.LessThan(T(4)))
    c2 = MOI.add_constraint(model, cf2, MOI.LessThan(T(4)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 2
    end
    vc1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test vc1.value == x.value
    vc2 = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    @test vc2.value == y.value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ) == 2
    end
    objf = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T(1), [x, y]),
        T(0),
    )
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(8 // 3) atol = atol rtol =
            rtol
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), [x, y]),
            T[4//3, 4//3],
            config,
        )
    end
    # copy and solve again
    # missing test
    # change coeff
    #   maximize x + y
    #
    #   s.t. 2 x + 3 y <= 4
    #        1 x + 2 y <= 4
    #        x >= 0, y >= 0
    #
    #   solution: x = 2, y = 0, objv = 2
    if _supports(config, MOI.ScalarCoefficientChange)
        MOI.modify(model, c1, MOI.ScalarCoefficientChange(y, T(3)))
    else
        MOI.delete(model, c1)
        cf1 = MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[2, 3], [x, y]),
            T(0),
        )
        c1 = MOI.add_constraint(model, cf1, MOI.LessThan(T(4)))
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(2), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), [x, y]), T[2, 0], config)
    end
    # delconstrs and solve
    #   maximize x + y
    #
    #   s.t. 1 x + 2 y <= 4
    #        x >= 0, y >= 0
    #
    #   solution: x = 4, y = 0, objv = 4
    MOI.delete(model, c1)
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), 4, config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), [x, y]), T[4, 0], config)
    end
    # delvars and solve
    #   maximize y
    #
    #   s.t.  2 y <= 4
    #           y >= 0
    #
    #   solution: y = 2, objv = 2
    MOI.delete(model, x)
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(2) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), y) ≈ T(2) atol = atol rtol =
            rtol
    end
end

function setup_test(
    ::typeof(test_linear_integration_modification),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[4//3, 4//3]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[2, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[4, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[2]),
    )
    return
end

"""
    test_linear_modify_GreaterThan_and_LessThan_constraints(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test modifying linear constraints.
"""
function test_linear_modify_GreaterThan_and_LessThan_constraints(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    # Min  x - y
    # s.t. T(0) <= x          (c1)
    #             y <= T(0)   (c2)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[1, -1], [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    fx = convert(MOI.ScalarAffineFunction{T}, x)
    c1 = MOI.add_constraint(model, fx, MOI.GreaterThan(T(0)))
    fy = convert(MOI.ScalarAffineFunction{T}, y)
    c2 = MOI.add_constraint(model, fy, MOI.LessThan(T(0)))
    if _supports(config, MOI.ConstraintFunction)
        @test MOI.get(model, MOI.ConstraintFunction(), c1) ≈ fx
        @test MOI.get(model, MOI.ConstraintSet(), c1) == MOI.GreaterThan(T(0))
        @test MOI.get(model, MOI.ConstraintFunction(), c2) ≈ fy
        @test MOI.get(model, MOI.ConstraintSet(), c2) == MOI.LessThan(T(0))
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(0), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(0), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(0), config)
    end
    # Min  x - y
    # s.t. T(100) <= x
    #               y <= T(0)
    MOI.set(model, MOI.ConstraintSet(), c1, MOI.GreaterThan(T(100)))
    if _supports(config, MOI.ConstraintFunction)
        @test MOI.get(model, MOI.ConstraintFunction(), c1) ≈ fx
        @test MOI.get(model, MOI.ConstraintSet(), c1) == MOI.GreaterThan(T(100))
        @test MOI.get(model, MOI.ConstraintFunction(), c2) ≈ fy
        @test MOI.get(model, MOI.ConstraintSet(), c2) == MOI.LessThan(T(0))
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(100), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(100), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(0), config)
    end
    # Min  x - y
    # s.t. T(100) <= x
    #               y <= T(-100)
    MOI.set(model, MOI.ConstraintSet(), c2, MOI.LessThan(T(-100)))
    if _supports(config, MOI.ConstraintFunction)
        @test MOI.get(model, MOI.ConstraintFunction(), c1) ≈ fx
        @test MOI.get(model, MOI.ConstraintSet(), c1) == MOI.GreaterThan(T(100))
        @test MOI.get(model, MOI.ConstraintFunction(), c2) ≈ fy
        @test MOI.get(model, MOI.ConstraintSet(), c2) == MOI.LessThan(T(-100))
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(200), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(100), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(-100), config)
    end
end

function setup_test(
    ::typeof(test_linear_modify_GreaterThan_and_LessThan_constraints),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[0, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[100, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[100, -100]),
    )
    return
end

"""
    test_linear_VectorAffineFunction(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving a linear program provided in vector-form.
"""
function test_linear_VectorAffineFunction(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    # Min  x - y
    # s.t. bx <= x          (c1)
    #             y <= by   (c2)
    #
    # or, in more detail,
    #
    # Min    1 x - 1 y
    # s.t. - 1 x       <= - bx  (z)   (c1)
    #              1 y <=   by  (w)   (c2)
    #
    # with generic dual
    #
    # Max  - bx z + by w
    # s.t. -    z        == - 1     (c1)
    #                  w ==   1     (c2)
    # that is, z == w == 1
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Nonnegatives,
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Nonpositives,
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    # Min  x - y
    # s.t. T(0) <= x          (c1)
    #             y <= T(0)   (c2)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[1, -1], [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    c1 = MOI.add_constraint(
        model,
        MOI.VectorAffineFunction{T}(
            [MOI.VectorAffineTerm{T}(1, MOI.ScalarAffineTerm{T}(T(1), x))],
            T[0],
        ),
        MOI.Nonnegatives(1),
    )
    c2 = MOI.add_constraint(
        model,
        MOI.VectorAffineFunction{T}(
            [MOI.VectorAffineTerm{T}(1, MOI.ScalarAffineTerm{T}(T(1), y))],
            T[0],
        ),
        MOI.Nonpositives(1),
    )
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(0), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(0), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(0), config)
    end
    # Min  x - y
    # s.t. T(100) <= x
    #               y <= T(0)
    if _supports(config, MOI.VectorConstantChange)
        MOI.modify(model, c1, MOI.VectorConstantChange(T[-100]))
    else
        MOI.delete(model, c1)
        c1 = MOI.add_constraint(
            model,
            MOI.VectorAffineFunction{T}(
                [MOI.VectorAffineTerm{T}(1, MOI.ScalarAffineTerm{T}(T(1), x))],
                T[-100],
            ),
            MOI.Nonnegatives(1),
        )
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(100), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(100), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(0), config)
    end
    # Min  x - y
    # s.t. T(100) <= x
    #               y <= T(-100)
    if _supports(config, MOI.VectorConstantChange)
        MOI.modify(model, c2, MOI.VectorConstantChange(T[100]))
    else
        MOI.delete(model, c2)
        c2 = MOI.add_constraint(
            model,
            MOI.VectorAffineFunction{T}(
                [MOI.VectorAffineTerm{T}(1, MOI.ScalarAffineTerm{T}(T(1), y))],
                T[100],
            ),
            MOI.Nonpositives(1),
        )
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(200), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(100), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(-100), config)
    end
end

function setup_test(
    ::typeof(test_linear_VectorAffineFunction),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[0, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[100, 0]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[100, -100]),
    )
    return
end

"""
    test_linear_INFEASIBLE(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving an infeasible linear program.
"""
function test_linear_INFEASIBLE(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    # min x
    # s.t. 2x+y <= -1
    # x,y >= 0
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[2, 1], [x, y]),
            T(0),
        ),
        MOI.LessThan(T(-1)),
    )
    bndx = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test bndx.value == x.value
    bndy = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    @test bndy.value == y.value
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm{T}(T(1), x)], T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) in
              (config.infeasible_status, MOI.INFEASIBLE_OR_UNBOUNDED)
        has_certificate =
            MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
        if _supports(config, MOI.ConstraintDual) && has_certificate
            # solver returned an infeasibility ray
            @test MOI.get(model, MOI.ResultCount()) >= 1
            cd = MOI.get(model, MOI.ConstraintDual(), c)
            @test cd < -atol
            # TODO: farkas dual on bounds - see #127
            # xd = MOI.get(model, MOI.ConstraintDual(), bndx)
            # yd = MOI.get(model, MOI.ConstraintDual(), bndy)
            # @test xd > atol
            # @test yd > atol
            # @test yd ≈ -cd atol=atol rtol=rtol
            # @test xd ≈ -2cd atol=atol rtol=rtol
        end
    end
end

function setup_test(
    ::typeof(test_linear_INFEASIBLE),
    mock::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            MOI.NO_SOLUTION,
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
        ),
    )
    return
end

"""
    test_linear_DUAL_INFEASIBLE(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving a problem that is dual infeasible (unbounded).
"""
function test_linear_DUAL_INFEASIBLE(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    # min -x-y
    # s.t. -x+2y <= 0
    # x,y >= 0
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[-1, 2], [x, y]),
            T(0),
        ),
        MOI.LessThan(T(0)),
    )
    vc1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test vc1.value == x.value
    vc2 = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    @test vc2.value == y.value
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T(-1), [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        status = MOI.get(model, MOI.TerminationStatus())
        @test in(
            status,
            (MOI.DUAL_INFEASIBLE, MOI.NORM_LIMIT, MOI.INFEASIBLE_OR_UNBOUNDED),
        )
        if MOI.get(model, MOI.PrimalStatus()) == MOI.INFEASIBILITY_CERTIFICATE
            # solver returned an unbounded ray
            @test MOI.get(model, MOI.ResultCount()) >= 1
        end
    end
end

function setup_test(
    ::typeof(test_linear_DUAL_INFEASIBLE),
    mock::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.DUAL_INFEASIBLE,
            MOI.INFEASIBILITY_CERTIFICATE,
        ),
    )
    return
end

"""
    test_linear_DUAL_INFEASIBLE_2(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving a linear program that is dual infeasible (unbounded).
"""
function test_linear_DUAL_INFEASIBLE_2(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    # min -x-y
    # s.t. x-y == 0
    # x,y >= 0
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[1, -1], [x, y]),
            T(0),
        ),
        MOI.EqualTo(T(0)),
    )
    vc1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test vc1.value == x.value
    vc2 = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    @test vc2.value == y.value
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T(-1), [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        status = MOI.get(model, MOI.TerminationStatus())
        @test in(
            status,
            (MOI.DUAL_INFEASIBLE, MOI.NORM_LIMIT, MOI.INFEASIBLE_OR_UNBOUNDED),
        )
        if MOI.get(model, MOI.PrimalStatus()) == MOI.INFEASIBILITY_CERTIFICATE
            # solver returned an unbounded ray
            @test MOI.get(model, MOI.ResultCount()) >= 1
            ray = MOI.get(model, MOI.VariablePrimal(), [x, y])
            @test ray[1] ≈ ray[2] atol = atol rtol = rtol
        end
    end
end

function setup_test(
    ::typeof(test_linear_DUAL_INFEASIBLE_2),
    mock::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.DUAL_INFEASIBLE,
            (MOI.INFEASIBILITY_CERTIFICATE, T[1, 1]),
        ),
    )
    return
end

"""
    test_linear_add_constraints(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving a linear program constructed using the plural `add_constraints`
function.
"""
function test_linear_add_constraints(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    #   maximize 1000 x + 350 y
    #
    #       s.t.                x >= 30
    #                           y >= 0
    #                 x -   1.5 y >= 0
    #            12   x +   8   y <= 1000
    #            1000 x + 300   y <= 70000
    #
    #   solution: (59.0909, 36.3636)
    #   objv: 71818.1818
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    vc12 = MOI.add_constraints(
        model,
        [x, y],
        [MOI.GreaterThan(T(30)), MOI.GreaterThan(T(0))],
    )
    @test vc12[1].value == x.value
    @test vc12[2].value == y.value
    c1 = MOI.add_constraints(
        model,
        [
            MOI.ScalarAffineFunction{T}(
                MOI.ScalarAffineTerm{T}.(T[1, -3//2], [x, y]),
                T(0),
            ),
        ],
        [MOI.GreaterThan(T(0))],
    )
    c23 = MOI.add_constraints(
        model,
        [
            MOI.ScalarAffineFunction{T}(
                MOI.ScalarAffineTerm{T}.(T[12, 8], [x, y]),
                T(0),
            ),
            MOI.ScalarAffineFunction{T}(
                MOI.ScalarAffineTerm{T}.(T[1_000, 300], [x, y]),
                T(0),
            ),
        ],
        [MOI.LessThan(T(1_000)), MOI.LessThan(T(70_000))],
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[1_000, 350], [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(790_000 // 11), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(650 // 11), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(400 // 11), config)
        if _supports(config, MOI.ConstraintBasisStatus)
            @test MOI.get(model, MOI.VariableBasisStatus(), x) == MOI.BASIC
            @test MOI.get(model, MOI.VariableBasisStatus(), y) == MOI.BASIC
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c1[1]) ==
                  MOI.BASIC
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c23[1]) ==
                  MOI.NONBASIC
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c23[2]) ==
                  MOI.NONBASIC
        end
    end
end

function setup_test(
    ::typeof(test_linear_add_constraints),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[650//11, 400//11],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) =>
                    [MOI.NONBASIC, MOI.NONBASIC],
                (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                    [MOI.BASIC],
            ],
            variable_basis_status = [MOI.BASIC, MOI.BASIC],
        ),
    )
    return
end

"""
    test_linear_integration_Interval(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

This test checks a variety of properties of a model with
ScalarAffineFunction-in-Interval constraints.
"""
function test_linear_integration_Interval(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    #   maximize x + y
    #
    #       s.t.  5 <= x + y <= 10
    #                  x,  y >= 0
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.Interval{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    vc = MOI.add_constraints(
        model,
        [x, y],
        [MOI.GreaterThan(T(0)), MOI.GreaterThan(T(0))],
    )
    @test vc[1].value == x.value
    @test vc[2].value == y.value
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T(1), [x, y]),
            T(0),
        ),
        MOI.Interval(T(5), T(10)),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T(1), [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(10), config)
        if _supports(config, MOI.DualObjectiveValue)
            @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(10), config)
        end
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(10), config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.ResultCount()) >= 1
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c), T(-1), config)
        end
        if _supports(config, MOI.ConstraintBasisStatus)
            # There are multiple optimal bases. Either x or y can be in the
            # optimal basis.
            @test (
                MOI.get(model, MOI.VariableBasisStatus(), x) == MOI.BASIC ||
                MOI.get(model, MOI.VariableBasisStatus(), y) == MOI.BASIC
            )
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c) ==
                  MOI.NONBASIC_AT_UPPER
        end
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T(1), [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(5) atol = atol rtol =
            rtol
        if _supports(config, MOI.DualObjectiveValue)
            @test MOI.get(model, MOI.DualObjectiveValue()) ≈ T(5) atol = atol rtol =
                rtol
        end
        @test MOI.get(model, MOI.ConstraintPrimal(), c) ≈ 5 atol = atol rtol =
            rtol
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.ResultCount()) >= 1
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test MOI.get(model, MOI.ConstraintDual(), c) ≈ T(1) atol = atol rtol =
                rtol
        end
        if _supports(config, MOI.ConstraintBasisStatus)
            # There are multiple optimal bases. Either x or y can be in the
            # optimal basis.
            @test (
                MOI.get(model, MOI.VariableBasisStatus(), x) == MOI.BASIC ||
                MOI.get(model, MOI.VariableBasisStatus(), y) == MOI.BASIC
            )
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c) ==
                  MOI.NONBASIC_AT_LOWER
        end
    end
    MOI.set(model, MOI.ConstraintSet(), c, MOI.Interval(T(2), T(12)))
    if _supports(config, MOI.ConstraintSet)
        @test MOI.get(model, MOI.ConstraintSet(), c) ==
              MOI.Interval(T(2), T(12))
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(2) atol = atol rtol =
            rtol
        if _supports(config, MOI.DualObjectiveValue)
            @test MOI.get(model, MOI.DualObjectiveValue()) ≈ T(2) atol = atol rtol =
                rtol
        end
        @test MOI.get(model, MOI.ConstraintPrimal(), c) ≈ T(2) atol = atol rtol =
            rtol
        if _supports(config, MOI.ConstraintBasisStatus)
            # There are multiple optimal bases. Either x or y can be in the
            # optimal basis.
            @test (
                MOI.get(model, MOI.VariableBasisStatus(), x) == MOI.BASIC ||
                MOI.get(model, MOI.VariableBasisStatus(), y) == MOI.BASIC
            )
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c) ==
                  MOI.NONBASIC_AT_LOWER
        end
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.ResultCount()) >= 1
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test MOI.get(model, MOI.ConstraintDual(), c) ≈ T(1) atol = atol rtol =
                rtol
        end
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T(1), [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(12) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.ConstraintPrimal(), c) ≈ 12 atol = atol rtol =
            rtol
        if _supports(config, MOI.ConstraintBasisStatus)
            # There are multiple optimal bases. Either x or y can be in the
            # optimal basis.
            @test (
                MOI.get(model, MOI.VariableBasisStatus(), x) == MOI.BASIC ||
                MOI.get(model, MOI.VariableBasisStatus(), y) == MOI.BASIC
            )
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c) ==
                  MOI.NONBASIC_AT_UPPER
        end
    end
end

function setup_test(
    ::typeof(test_linear_integration_Interval),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[5, 5],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) =>
                    [MOI.NONBASIC_AT_UPPER],
            ],
            variable_basis_status = [MOI.BASIC, MOI.BASIC],
            (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) => T[-1],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[5//2, 5//2],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) =>
                    [MOI.NONBASIC_AT_LOWER],
            ],
            variable_basis_status = [MOI.BASIC, MOI.BASIC],
            (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) => T[1],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1, 1],
            (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) => T[1],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) =>
                    [MOI.NONBASIC_AT_LOWER],
            ],
            variable_basis_status = [MOI.BASIC, MOI.BASIC],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[6, 6],
            (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) => T[-1],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) =>
                    [MOI.NONBASIC_AT_UPPER],
            ],
            variable_basis_status = [MOI.BASIC, MOI.BASIC],
        ),
    )
    return
end

"""
    test_linear_Interval_inactive(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

This test checks linear programs with a non-binding
ScalarAffineFunction-in-Interval constraint.
"""
function test_linear_Interval_inactive(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    #   minimize x + y
    #
    #       s.t.  -1 <= x + y <= 10
    #                   x,  y >= 0
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.Interval{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    vc = MOI.add_constraints(
        model,
        [x, y],
        [MOI.GreaterThan(T(0)), MOI.GreaterThan(T(0))],
    )
    @test vc[1].value == x.value
    @test vc[2].value == y.value
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T(1), [x, y]),
            T(0),
        ),
        MOI.Interval(T(-1), T(10)),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T(1), [x, y]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(0) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.ConstraintPrimal(), c) ≈ T(0) atol = atol rtol =
            rtol
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.ResultCount()) >= 1
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test MOI.get(model, MOI.ConstraintDual(), c) ≈ T(0) atol = atol rtol =
                rtol
            @test MOI.get(model, MOI.ConstraintDual(), vc[1]) ≈ T(1) atol = atol rtol =
                rtol
            @test MOI.get(model, MOI.ConstraintDual(), vc[2]) ≈ T(1) atol = atol rtol =
                rtol
        end
        if _supports(config, MOI.ConstraintBasisStatus)
            @test (
                MOI.get(model, MOI.VariableBasisStatus(), x) ==
                MOI.NONBASIC_AT_LOWER
            )
            @test (
                MOI.get(model, MOI.VariableBasisStatus(), y) ==
                MOI.NONBASIC_AT_LOWER
            )
            @test MOI.get(model, MOI.ConstraintBasisStatus(), c) == MOI.BASIC
        end
    end
end

function setup_test(
    ::typeof(test_linear_Interval_inactive),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[0, 0],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) =>
                    [MOI.BASIC],
            ],
            variable_basis_status = [
                MOI.NONBASIC_AT_LOWER,
                MOI.NONBASIC_AT_LOWER,
            ],
            (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) => [0],
        ),
    )
    return
end

"""
    test_linear_transform(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

This test checks calling `MOI.transform` to flip the sense of constraints.

It starts with:
```
min x + y
st   x + y >= 1
     x + y >= 2
     sol: x+y = 2 (degenerate)
```
with the dual problem:
```
max  w + 2z
st   w +  z == 1
     w +  z == 1
     w, z >= 0
sol: z = 1, w = 0
```
Then it tranforms problem into:
```
min x + y
st   x + y >= 1
     x + y <= 2
sol: x+y = 1 (degenerate)
```
with the dual problem:
```
max  w + 2z
st   w +  z == 1
     w +  z == 1
     w >= 0, z <= 0
sol: w = 1, z = 0
```
"""
function test_linear_transform(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    v = MOI.add_variables(model, 2)
    c1 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(MOI.ScalarAffineTerm{T}.(T(1), v), T(0)),
        MOI.GreaterThan(T(1)),
    )
    c2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(MOI.ScalarAffineTerm{T}.(T(1), v), T(0)),
        MOI.GreaterThan(T(2)),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(MOI.ScalarAffineTerm{T}.(T(1), v), T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(2) atol = atol rtol =
            rtol
    end
    c3 = MOI.transform(model, c2, MOI.LessThan(T(2)))
    @test isa(
        c3,
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
    )
    @test MOI.is_valid(model, c2) == false
    @test MOI.is_valid(model, c3) == true
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(1) atol = atol rtol =
            rtol
    end
end

function setup_test(
    ::typeof(test_linear_transform),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[1, 1]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[1//2, 1//2]),
    )
    return
end

"""
    test_linear_INFEASIBLE_2(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving an infeasible linear program.

The model is
```
 min  x
s.t. 2x - 3y <= -7
           y <=  2
      x,   y >= 0
```
"""
function test_linear_INFEASIBLE_2(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    c1 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[2, -3], [x, y]),
            T(0),
        ),
        MOI.LessThan(T(-7)),
    )
    c2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm{T}(T(1), y)], T(0)),
        MOI.LessThan(T(2)),
    )
    bndx = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test bndx.value == x.value
    bndy = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    @test bndy.value == y.value
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm{T}(T(1), x)], T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) in
              (config.infeasible_status, MOI.INFEASIBLE_OR_UNBOUNDED)
        has_certificate =
            MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
        if _supports(config, MOI.ConstraintDual) && has_certificate
            @test MOI.get(model, MOI.ResultCount()) >= 1
            cd1 = MOI.get(model, MOI.ConstraintDual(), c1)
            cd2 = MOI.get(model, MOI.ConstraintDual(), c2)
            bndxd = MOI.get(model, MOI.ConstraintDual(), bndx)
            bndyd = MOI.get(model, MOI.ConstraintDual(), bndy)
            @test cd1 < -atol
            @test cd2 < -atol
            @test -3 * cd1 + cd2 ≈ -bndyd atol = atol rtol = rtol
            @test 2 * cd1 ≈ -bndxd atol = atol rtol = rtol
            @test -7 * cd1 + 2 * cd2 > atol
        end
    end
end

function setup_test(
    ::typeof(test_linear_INFEASIBLE_2),
    mock::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            MOI.NO_SOLUTION,
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1, -1],
        ),
    )
    return
end

"""
    test_linear_FEASIBILITY_SENSE(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving a linear program with no objective function.

The problem is
```
Find x, y
s.t. 2x + 3y >= 1
     x - y == 0
```
"""
function test_linear_FEASIBILITY_SENSE(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    c1 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[2, 3], [x, y]),
            T(0),
        ),
        MOI.GreaterThan(T(1)),
    )
    c2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[1, -1], [x, y]),
            T(0),
        ),
        MOI.EqualTo(T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.FEASIBILITY_SENSE
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.ResultCount()) > 0
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        xsol = MOI.get(model, MOI.VariablePrimal(), x)
        ysol = MOI.get(model, MOI.VariablePrimal(), y)
        c1sol = 2 * xsol + 3 * ysol
        @test c1sol >= 1 || isapprox(c1sol, T(1), atol = atol, rtol = rtol)
        @test xsol - ysol ≈ T(0) atol = atol rtol = rtol
        c1primval = MOI.get(model, MOI.ConstraintPrimal(), c1)
        @test c1primval >= 1 || isapprox(c1sol, T(1), atol = atol, rtol = rtol)
        @test MOI.get(model, MOI.ConstraintPrimal(), c2) ≈ T(0) atol = atol rtol =
            rtol
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test MOI.get(model, MOI.ConstraintDual(), c1) ≈ T(0) atol = atol rtol =
                rtol
            @test MOI.get(model, MOI.ConstraintDual(), c2) ≈ T(0) atol = atol rtol =
                rtol
        end
    end
end

function setup_test(
    ::typeof(test_linear_FEASIBILITY_SENSE),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1//5, 1//5],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) => T[0],
            (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) => T[0],
        ),
    )
    return
end

"""
    test_linear_integration_delete_variables(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

This function tests calling `delete(::ModelLike, ::Vector{VariableIndex})`.
"""
function test_linear_integration_delete_variables(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    # max x + 2y + 3z + 4
    # s.t. 3x + 2y + z <= 2
    #      x, y, z >= 0
    #      z <= 1
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.LessThan{T})
    x, y, z = MOI.add_variables(model, 3)
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[3, 2, 1], [x, y, z]),
            T(0),
        ),
        MOI.LessThan(T(2)),
    )
    clbx = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test clbx.value == x.value
    clby = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    @test clby.value == y.value
    clbz = MOI.add_constraint(model, z, MOI.GreaterThan(T(0)))
    @test clbz.value == z.value
    cubz = MOI.add_constraint(model, z, MOI.LessThan(T(1)))
    @test cubz.value == z.value
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(
            MOI.ScalarAffineTerm{T}.(T[1, 2, 3], [x, y, z]),
            T(4),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(8), config)
        if _supports(config, MOI.DualObjectiveValue)
            @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(8), config)
        end
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(0), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(1 // 2), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z), T(1), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(2), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), clbx), T(0), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), clby), T(1 // 2), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), clbz), T(1), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), cubz), T(1), config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test ≈(MOI.get(model, MOI.ConstraintDual(), c), T(-1), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), clbx), T(2), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), clby), T(0), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), clbz), T(0), config)
            @test ≈(MOI.get(model, MOI.ConstraintDual(), cubz), T(-2), config)
            if _supports(config, MOI.ConstraintBasisStatus)
                @test MOI.get(model, MOI.VariableBasisStatus(), x) ==
                      MOI.NONBASIC_AT_LOWER
                @test MOI.get(model, MOI.VariableBasisStatus(), y) == MOI.BASIC
                @test MOI.get(model, MOI.VariableBasisStatus(), z) ==
                      MOI.NONBASIC_AT_UPPER
                @test MOI.get(model, MOI.ConstraintBasisStatus(), c) ==
                      MOI.NONBASIC
            end
        end
    end
    MOI.delete(model, [x, z])
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ 6 atol = atol rtol = rtol
        if _supports(config, MOI.DualObjectiveValue)
            @test MOI.get(model, MOI.DualObjectiveValue()) ≈ 6 atol = atol rtol =
                rtol
        end
        @test MOI.get(model, MOI.VariablePrimal(), y) ≈ T(1) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.ConstraintPrimal(), c) ≈ T(2) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.ConstraintPrimal(), clby) ≈ T(1) atol = atol rtol =
            rtol
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
            @test MOI.get(model, MOI.ConstraintDual(), c) ≈ T(-1) atol = atol rtol =
                rtol
            @test MOI.get(model, MOI.ConstraintDual(), clby) ≈ T(0) atol = atol rtol =
                rtol
        end
    end
end

function setup_test(
    ::typeof(test_linear_integration_delete_variables),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[0, 1//2, 1],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) =>
                    [MOI.NONBASIC],
            ],
            variable_basis_status = [
                MOI.NONBASIC_AT_LOWER,
                MOI.BASIC,
                MOI.NONBASIC_AT_UPPER,
            ],
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[2, 0, 0],
            (MOI.VariableIndex, MOI.LessThan{T}) => T[-2],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[1],
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[0],
        ),
    )
    # test_linear_integration_delete_variables has double variable bounds for
    # the z variable
    mock.eval_variable_constraint_dual = false
    function reset_function()
        mock.eval_variable_constraint_dual = true
        return
    end
    return reset_function
end

"""
    test_linear_VectorAffineFunction_empty_row(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

This test checks solving a problem given a `VectorAffineFunction` with an empty
row equivalent to `0 == 0`.

Models not supporting `VectorAffineFunction`-in-`Zeros` should use a bridge.
"""
function test_linear_VectorAffineFunction_empty_row(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Zeros,
    )
    x = MOI.add_variables(model, 1)
    # Create a VectorAffineFunction with two rows, but only one term, belonging
    # to the second row. The first row, which is empty, is essentially a
    # constraint that 0 == 0.
    c = MOI.add_constraint(
        model,
        MOI.VectorAffineFunction{T}(
            MOI.VectorAffineTerm{T}.(2, MOI.ScalarAffineTerm{T}.(T[1], x)),
            zeros(T, 2),
        ),
        MOI.Zeros(2),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction{T}(MOI.ScalarAffineTerm{T}.(T[0], x), T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(0), config)
        if _supports(config, MOI.DualObjectiveValue)
            @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(0), config)
        end
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x[1]), T(0), config)
        if _supports(config, MOI.ConstraintDual)
            @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
        end
    end
end

function setup_test(
    ::typeof(test_linear_VectorAffineFunction_empty_row),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            T[0],
            (MOI.VectorAffineFunction{T}, MOI.Zeros) => [T[0, 0]],
        ),
    )
    return
end

"""
    test_linear_VariablePrimalStart_partial(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

This test checks solving a problem with a partial solution provided via
VariablePrimalStart.

This test can be passed by solvers that don't support VariablePrimalStart
because copy_to drops start information with a warning.

The problem is
```
 max 2x + y
s.t. x + y <= 1
     x, y >= 0
```
where `x` starts at `T(1)`. Start point for `y` is unspecified.
"""
function test_linear_VariablePrimalStart_partial(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    atol = config.atol
    rtol = config.rtol
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariablePrimalStart(), x, T(1))
    MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    obj = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T[2, 1], [x, y]),
        T(0),
    )
    MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    x_plus_y = MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}.(T(1), [x, y]),
        T(0),
    )
    MOI.add_constraint(model, x_plus_y, MOI.LessThan(T(1)))
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ T(2) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), x) ≈ T(1) atol = atol rtol =
            rtol
        @test MOI.get(model, MOI.VariablePrimal(), y) ≈ T(0) atol = atol rtol =
            rtol
    end
end

function setup_test(
    ::typeof(test_linear_VariablePrimalStart_partial),
    mock::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        mock,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[1, 0]),
    )
    return
end

"""
    test_linear_integer_integration(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Run an integration test on the MILP:
```
maximize 1.1x + 2 y + 5 z
s.t.  x + y + z <= 10
      x + 2 y + z <= 15
      x is continuous: 0 <= x <= 5
      y is integer: 0 <= y <= 10
      z is binary
```
"""
function test_linear_integer_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.Integer)
    v = MOI.add_variables(model, 3)
    @test MOI.get(model, MOI.NumberOfVariables()) == 3
    cf = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), v), T(0))
    c = MOI.add_constraint(model, cf, MOI.LessThan(T(10)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    cf2 = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[1, 2, 1], v), T(0))
    c2 = MOI.add_constraint(model, cf2, MOI.LessThan(T(15)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 2
    end
    vc1 = MOI.add_constraint(model, v[1], MOI.Interval(T(0), T(5)))
    # We test this after the creation of every `VariableIndex` constraint
    # to ensure a good coverage of corner cases.
    @test vc1.value == v[1].value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Interval{T}}(),
        ) == 1
    end
    vc2 = MOI.add_constraint(model, v[2], MOI.Interval(T(0), T(10)))
    @test vc2.value == v[2].value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Interval{T}}(),
        ) == 2
    end
    vc3 = MOI.add_constraint(model, v[2], MOI.Integer())
    @test vc3.value == v[2].value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Integer}(),
        ) == 1
    end
    vc4 = MOI.add_constraint(model, v[3], MOI.ZeroOne())
    @test vc4.value == v[3].value
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne}(),
        ) == 1
    end
    objf = MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.(T[11//10, 2, 5], v),
        T(0),
    )
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) in
              [MOI.FEASIBLE_POINT, MOI.NEARLY_FEASIBLE_POINT]
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(97 // 5), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[4, 5, 1], config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(10), config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c2), T(15), config)
        @test MOI.get(model, MOI.ObjectiveBound()) >= T(97 // 5) - config.atol
        # FIXME the following are currently not implemented in MockOptimizer
        #        @test MOI.get(model, MOI.RelativeGap()) >= T(0)
        #        @test MOI.get(model, MOI.SolveTimeSec()) >= T(0)
        #        @test MOI.get(model, MOI.SimplexIterations()) >= 0
        #        @test MOI.get(model, MOI.BarrierIterations()) >= 0
        #        @test MOI.get(model, MOI.NodeCount()) >= 0
    end
    return
end

function setup_test(
    ::typeof(test_linear_integer_integration),
    model::MOI.Utilities.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(20))
            MOIU.mock_optimize!(mock, T[4, 5, 1])
        end,
    )
    return
end

"""
    test_linear_SOS1_integration(model::MOI.ModelLike, config::Config{T}) where {T}

Test Special Ordered Sets of type 1.
"""
function test_linear_SOS1_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(model, MOI.VectorOfVariables, MOI.SOS1{T})
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.LessThan{T})
    v = MOI.add_variables(model, 3)
    MOI.add_constraint.(model, v, MOI.GreaterThan(zero(T)))
    @test MOI.get(model, MOI.NumberOfVariables()) == 3
    vc1 = MOI.add_constraint(model, v[1], MOI.LessThan(T(1)))
    @test vc1.value == v[1].value
    vc2 = MOI.add_constraint(model, v[2], MOI.LessThan(T(1)))
    @test vc2.value == v[2].value
    vc3 = MOI.add_constraint(model, v[3], MOI.LessThan(T(2)))
    @test vc3.value == v[3].value
    c1 = MOI.add_constraint(
        model,
        MOI.VectorOfVariables([v[1], v[2]]),
        MOI.SOS1(T[1, 2]),
    )
    c2 = MOI.add_constraint(
        model,
        MOI.VectorOfVariables([v[1], v[3]]),
        MOI.SOS1(T[1, 2]),
    )
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.SOS1{T}}(),
        ) == 2
    end
    #=
        To allow for permutations in the sets and variable vectors
        we're going to sort according to the weights
    =#
    cs_sos = MOI.get(model, MOI.ConstraintSet(), c2)
    cf_sos = MOI.get(model, MOI.ConstraintFunction(), c2)
    p = sortperm(cs_sos.weights)
    @test ≈(cs_sos.weights[p], T[1, 2], config)
    @test cf_sos.variables[p] == v[[1, 3]]
    objf = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[2, 1, 1], v), T(0))
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(3), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[0, 1, 2], config)
    end
    MOI.delete(model, c1)
    MOI.delete(model, c2)
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(5), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[1, 1, 2], config)
    end
    return
end

function setup_test(
    ::typeof(test_linear_SOS1_integration),
    model::MOI.Utilities.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[0, 1, 2]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[1, 1, 2]),
    )
    return
end

"""
    test_linear_SOS2_integration(model::MOI.ModelLike, config::Config{T}) where {T}

Test Special Ordered Sets of type 2.
"""
function test_linear_SOS2_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(model, MOI.VectorOfVariables, MOI.SOS1{T})
    @requires MOI.supports_constraint(model, MOI.VectorOfVariables, MOI.SOS2{T})
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    v = MOI.add_variables(model, 10)
    @test MOI.get(model, MOI.NumberOfVariables()) == 10
    bin_constraints = []
    for i in 1:8
        vc = MOI.add_constraint(model, v[i], MOI.Interval(T(0), T(2)))
        @test vc.value == v[i].value
        push!(bin_constraints, MOI.add_constraint(model, v[i], MOI.ZeroOne()))
        @test bin_constraints[i].value == v[i].value
    end
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[1, 2, 3, -1], v[[1, 2, 3, 9]]),
            T(0),
        ),
        MOI.EqualTo(T(0)),
    )
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[5, 4, 7, 2, 1, -1], v[[4, 5, 6, 7, 8, 10]]),
            T(0),
        ),
        MOI.EqualTo(T(0)),
    )
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(v[[1, 2, 3]]),
        MOI.SOS1(T[1, 2, 3]),
    )
    vv = MOI.VectorOfVariables(v[[4, 5, 6, 7, 8]])
    sos2 = MOI.SOS2(T[5, 4, 7, 2, 1])
    c = MOI.add_constraint(model, vv, sos2)
    #=
        To allow for permutations in the sets and variable vectors
        we're going to sort according to the weights
    =#
    cs_sos = MOI.get(model, MOI.ConstraintSet(), c)
    cf_sos = MOI.get(model, MOI.ConstraintFunction(), c)
    p = sortperm(cs_sos.weights)
    @test ≈(cs_sos.weights[p], T[1, 2, 4, 5, 7], config)
    @test cf_sos.variables[p] == v[[8, 7, 5, 4, 6]]
    objf = MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.(T(1), [v[9], v[10]]),
        T(0),
    )
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(15), config)
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), v),
            T[0, 0, 1, 1, 0, 1, 0, 0, 3, 12],
            config,
        )
    end
    for cref in bin_constraints
        MOI.delete(model, cref)
    end
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(30), config)
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), v),
            T[0, 0, 2, 2, 0, 2, 0, 0, 6, 24],
            config,
        )
    end
    return
end

function setup_test(
    ::typeof(test_linear_SOS2_integration),
    model::MOI.Utilities.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, T[0, 0, 1, 1, 0, 1, 0, 0, 3, 12]),
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, T[0, 0, 2, 2, 0, 2, 0, 0, 6, 24]),
    )
    return
end

"""
    test_linear_integer_solve_twice(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test solving a model twice on the integer knapsack problem.
The problem is:
```
max   z - 0.5 ( b1 + b2 + b3) / 40
s.t.  0 <= z - 0.5 eᵀ b / 40 <= 0.999
      b1, b2, ... b10 ∈ {0, 1}
      z in {0, 1, 2, ..., 100}
```
"""
function test_linear_integer_solve_twice(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.Integer)
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.Interval{T})
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.Interval{T},
    )
    z = MOI.add_variable(model)
    vc1 = MOI.add_constraint(model, z, MOI.Integer())
    @test vc1.value == z.value
    vc2 = MOI.add_constraint(model, z, MOI.Interval(T(0), T(100)))
    @test vc2.value == z.value
    b = MOI.add_variables(model, 10)
    for bi in b
        vc = MOI.add_constraint(model, bi, MOI.ZeroOne())
        @test vc.value == bi.value
    end
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(
                vcat(T(1), fill(T(-1 // 80), 10)),
                vcat(z, b),
            ),
            T(0),
        ),
        MOI.Interval(T(0), T(999 // 1_000)),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(
                vcat(T(1), fill(T(-1 // 80), 3)),
                vcat(z, b[1:3]),
            ),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(1), config)
        # test for CPLEX.jl #76
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(1), config)
    end
    return
end

function setup_test(
    ::typeof(test_linear_integer_solve_twice),
    model::MOI.Utilities.MockOptimizer,
    ::Config{T},
) where {T}
    # FIXME [1, 0...] is not the correct optimal solution but it passes the test
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, [T(1); zeros(T, 10)]),
    )
    return
end

"""
    test_linear_integer_knapsack(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test the integer knapsack problem
```
max 5a + 3b + 2c + 7d + 4e
st  2a + 8b + 4c + 2d + 5e <= 10
     a,   b,   c,   d,   e ∈ binary
```
"""
function test_linear_integer_knapsack(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    v = MOI.add_variables(model, 5)
    @test MOI.get(model, MOI.NumberOfVariables()) == 5
    for vi in v
        vc = MOI.add_constraint(model, vi, MOI.ZeroOne())
        @test vc.value == vi.value
    end
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne}(),
        ) == 5
    end
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[2, 8, 4, 2, 5], v),
            T(0),
        ),
        MOI.LessThan(T(10)),
    )
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.LessThan{T},
            }(),
        ) == 1
    end
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[5, 3, 2, 7, 4], v),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
        MOI.set(model, MOI.VariablePrimalStart(), v, zeros(T, 5))
    end
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) in
              [MOI.FEASIBLE_POINT, MOI.NEARLY_FEASIBLE_POINT]
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(16), config)
        @test ≈(
            MOI.get(model, MOI.VariablePrimal(), v),
            T[1, 0, 0, 1, 1],
            config,
        )
    end
    return
end

function setup_test(
    ::typeof(test_linear_integer_knapsack),
    model::MOI.Utilities.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, T[1, 0, 0, 1, 1]),
    )
    return
end

"""
    test_linear_Indicator_integration(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test the problem:
```
max  2x1 + 3x2
s.t. x1 + x2 <= 10
     z1 ==> x2 <= 8
     z2 ==> x2 + x1/5 <= 9
     z1 + z2 >= 1
```
"""
function test_linear_Indicator_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.Interval{T})
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.Interval{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{T}},
    )
    x1 = MOI.add_variable(model)
    x2 = MOI.add_variable(model)
    z1 = MOI.add_variable(model)
    z2 = MOI.add_variable(model)
    MOI.add_constraint(model, x1, MOI.Interval(T(0), T(10)))
    MOI.add_constraint(model, x2, MOI.Interval(T(0), T(10)))
    MOI.add_constraint(model, z1, MOI.ZeroOne())
    MOI.add_constraint(model, z2, MOI.ZeroOne())
    f1 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), z1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1), x2)),
        ],
        T[0, 0],
    )
    iset1 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(T(8)))
    MOI.add_constraint(model, f1, iset1)
    f2 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), z2)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1 // 5), x1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1), x2)),
        ],
        T[0, 0],
    )
    iset2 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(T(9)))
    MOI.add_constraint(model, f2, iset2)
    # Additional regular constraint.
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(T(1), x1), MOI.ScalarAffineTerm(T(1), x2)],
            T(0),
        ),
        MOI.LessThan(T(10)),
    )
    # Disjunction z1 ⋁ z2
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(T(1), z1), MOI.ScalarAffineTerm(T(1), z2)],
            T(0),
        ),
        MOI.GreaterThan(T(1)),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[2, 3], [x1, x2]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(115 // 4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x1), T(5 // 4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x2), T(35 // 4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z1), T(0), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z2), T(1), config)
    end
    return
end

function setup_test(
    ::typeof(test_linear_Indicator_integration),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, T[5//4, 35//4, 0, 1]),
    )
    return
end

"""
    test_linear_Indicator_ON_ONE(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test the problem:
```
max  2x1 + 3x2 - 30 z2
s.t. x1 + x2 <= 10
     z1 ==> x2 <= 8
     z2 ==> x2 + x1/5 <= 9
     z1 + z2 >= 1
```
"""
function test_linear_Indicator_ON_ONE(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x1 = MOI.add_variable(model)
    x2 = MOI.add_variable(model)
    z1 = MOI.add_variable(model)
    z2 = MOI.add_variable(model)
    MOI.add_constraint(model, x1, MOI.Interval(T(0), T(10)))
    MOI.add_constraint(model, x2, MOI.Interval(T(0), T(10)))
    MOI.add_constraint(model, z1, MOI.ZeroOne())
    MOI.add_constraint(model, z2, MOI.ZeroOne())
    f1 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), z1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1), x2)),
        ],
        T[0, 0],
    )
    iset1 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(T(8)))
    MOI.add_constraint(model, f1, iset1)
    f2 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), z2)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1 // 5), x1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1), x2)),
        ],
        T[0, 0],
    )
    iset2 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(T(9)))
    MOI.add_constraint(model, f2, iset2)
    # additional regular constraint
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(T(1), x1), MOI.ScalarAffineTerm(T(1), x2)],
            T(0),
        ),
        MOI.LessThan(T(10)),
    )
    # disjunction z1 ⋁ z2
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(T(1), z1), MOI.ScalarAffineTerm(T(1), z2)],
            T(0),
        ),
        MOI.GreaterThan(T(1)),
    )
    # objective penalized on z2
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[2, 3, -30], [x1, x2, z2]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(28), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x1), T(2), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x2), T(8), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z1), T(1), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z2), T(0), config)
    end
    return
end

function setup_test(
    ::typeof(test_linear_Indicator_ON_ONE),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[2, 8, 1, 0]),
    )
    return
end

"""
    test_linear_Indicator_ON_ZERO(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test the problem:
```
max  2x1 + 3x2
s.t. x1 + x2 <= 10
     z1 == 0 ==> x2 <= 8
     z2 == 1 ==> x2 + x1/5 <= 9
     (1-z1) + z2 >= 1 <=> z2 - z1 >= 0
```
"""
function test_linear_Indicator_ON_ZERO(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.Interval{T})
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.Interval{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{T}},
    )
    x1 = MOI.add_variable(model)
    x2 = MOI.add_variable(model)
    z1 = MOI.add_variable(model)
    z2 = MOI.add_variable(model)
    MOI.add_constraint(model, x1, MOI.Interval(T(0), T(10)))
    MOI.add_constraint(model, x2, MOI.Interval(T(0), T(10)))
    vc1 = MOI.add_constraint(model, z1, MOI.ZeroOne())
    @test vc1.value == z1.value
    vc2 = MOI.add_constraint(model, z2, MOI.ZeroOne())
    @test vc2.value == z2.value
    f1 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), z1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1), x2)),
        ],
        T[0, 0],
    )
    iset1 = MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.LessThan(T(8)))
    MOI.add_constraint(model, f1, iset1)
    f2 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), z2)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1 // 5), x1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1), x2)),
        ],
        T[0, 0],
    )
    iset2 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(T(9)))
    MOI.add_constraint(model, f2, iset2)
    # Additional regular constraint.
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(T(1), x1), MOI.ScalarAffineTerm(T(1), x2)],
            T(0),
        ),
        MOI.LessThan(T(10)),
    )
    # Disjunction (1-z1) ⋁ z2
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(T(-1), z1), MOI.ScalarAffineTerm(T(1), z2)],
            T(0),
        ),
        MOI.GreaterThan(T(0)),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[2, 3], [x1, x2]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(115 // 4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x1), T(5 // 4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x2), T(35 // 4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z1), T(1), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z2), T(1), config)
    end
    return
end

function setup_test(
    ::typeof(test_linear_Indicator_ON_ZERO),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, T[5//4, 35//4, 1, 1]),
    )
    return
end

"""
    test_linear_Indicator_constant_term(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test Indicator constraints with a constant term on the left-hand side. The
problem is:
```
max  2x1 + 3x2
s.t. x1 + x2 <= 10
     z1 ==> x2 - 1 <= 7
     z2 ==> x2 + x1/5 + 1 <= 10
     z1 + z2 >= 1
```
"""
function test_linear_Indicator_constant_term(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.Interval{T})
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.Interval{T},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{T}},
    )
    x1 = MOI.add_variable(model)
    x2 = MOI.add_variable(model)
    z1 = MOI.add_variable(model)
    z2 = MOI.add_variable(model)
    MOI.add_constraint(model, x1, MOI.Interval(T(0), T(10)))
    MOI.add_constraint(model, x2, MOI.Interval(T(0), T(10)))
    MOI.add_constraint(model, z1, MOI.ZeroOne())
    MOI.add_constraint(model, z2, MOI.ZeroOne())
    f1 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), z1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1), x2)),
        ],
        T[0, -1],
    )
    iset1 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(T(7)))
    MOI.add_constraint(model, f1, iset1)
    f2 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), z2)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1 // 5), x1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(1), x2)),
        ],
        T[0, 1],
    )
    iset2 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(T(10)))
    MOI.add_constraint(model, f2, iset2)
    # Additional regular constraint.
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(T(1), x1), MOI.ScalarAffineTerm(T(1), x2)],
            T(0),
        ),
        MOI.LessThan(T(10)),
    )
    # Disjunction z1 ⋁ z2
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            [MOI.ScalarAffineTerm(T(1), z1), MOI.ScalarAffineTerm(T(1), z2)],
            T(0),
        ),
        MOI.GreaterThan(T(1)),
    )
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[2, 3], [x1, x2]),
            T(0),
        ),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(115 // 4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x1), T(5 // 4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), x2), T(35 // 4), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z1), T(0), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), z2), T(1), config)
    end
    return
end

function setup_test(
    ::typeof(test_linear_Indicator_constant_term),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, T[5//4, 35//4, 0, 1]),
    )
    return
end

"""
2 variables

min  x
st   x >= y
     if !int
          x ∈ {0.0} U [2.0,3.0]
     if int
          x ∈ {0.0} U {2.0} U {3.0}
     y = 0.0
"""
function _test_linear_SemiXXX_integration(
    model::MOI.ModelLike,
    config::Config{T},
    use_semiinteger::Bool,
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
    )
    @requires MOI.supports(model, MOI.ObjectiveSense())
    if use_semiinteger
        @requires MOI.supports_constraint(
            model,
            MOI.VariableIndex,
            MOI.Semiinteger{T},
        )
    else
        @requires MOI.supports_constraint(
            model,
            MOI.VariableIndex,
            MOI.Semicontinuous{T},
        )
    end
    v = MOI.add_variables(model, 2)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    if !use_semiinteger
        vc1 = MOI.add_constraint(model, v[1], MOI.Semicontinuous(T(2), T(3)))
        if _supports(config, MOI.NumberOfConstraints)
            @test MOI.get(
                model,
                MOI.NumberOfConstraints{
                    MOI.VariableIndex,
                    MOI.Semicontinuous{T},
                }(),
            ) == 1
        end
    else
        vc1 = MOI.add_constraint(model, v[1], MOI.Semiinteger(T(2), T(3)))
        if _supports(config, MOI.NumberOfConstraints)
            @test MOI.get(
                model,
                MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Semiinteger{T}}(),
            ) == 1
        end
    end
    vc2 = MOI.add_constraint(model, v[2], MOI.EqualTo(T(0)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{MOI.VariableIndex,MOI.EqualTo{T}}(),
        ) == 1
    end
    cf =
        MOI.ScalarAffineFunction{T}(MOI.ScalarAffineTerm{T}.(T[1, -1], v), T(0))
    c = MOI.add_constraint(model, cf, MOI.GreaterThan(T(0)))
    if _supports(config, MOI.NumberOfConstraints)
        @test MOI.get(
            model,
            MOI.NumberOfConstraints{
                MOI.ScalarAffineFunction{T},
                MOI.GreaterThan{T},
            }(),
        ) == 1
    end
    objf = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[1, 0], v), T(0))
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), objf)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    if _supports(config, MOI.optimize!)
        @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) in
              [MOI.FEASIBLE_POINT, MOI.NEARLY_FEASIBLE_POINT]
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(0), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[0, 0], config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(0), config)
        @test MOI.get(model, MOI.ObjectiveBound()) <= T(0) + config.atol
    end
    # Change y fixed value
    MOI.set(model, MOI.ConstraintSet(), vc2, MOI.EqualTo(T(1)))
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(2), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[2, 1], config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(1), config)
        @test MOI.get(model, MOI.ObjectiveBound()) <= T(2) + config.atol
    end
    MOI.set(model, MOI.ConstraintSet(), vc2, MOI.EqualTo(T(2)))
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(2), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[2, 2], config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(0), config)
        @test MOI.get(model, MOI.ObjectiveBound()) <= T(2) + config.atol
    end
    MOI.set(model, MOI.ConstraintSet(), vc2, MOI.EqualTo(T(5 // 2)))
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        if !use_semiinteger
            @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(5 // 2), config)
            @test ≈(
                MOI.get(model, MOI.VariablePrimal(), v),
                T[5//2, 5//2],
                config,
            )
            @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(0), config)
            @test MOI.get(model, MOI.ObjectiveBound()) <=
                  T(5 // 2) + config.atol
        else
            @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(3), config)
            @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[3, 5//2], config)
            @test ≈(
                MOI.get(model, MOI.ConstraintPrimal(), c),
                T(1 // 2),
                config,
            )
            @test MOI.get(model, MOI.ObjectiveBound()) <= T(3) + config.atol
        end
    end
    MOI.set(model, MOI.ConstraintSet(), vc2, MOI.EqualTo(T(3)))
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
        @test MOI.get(model, MOI.ResultCount()) >= 1
        @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
        @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(3), config)
        @test ≈(MOI.get(model, MOI.VariablePrimal(), v), T[3, 3], config)
        @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), T(0), config)
        @test MOI.get(model, MOI.ObjectiveBound()) <= T(3) + config.atol
    end
    MOI.set(model, MOI.ConstraintSet(), vc2, MOI.EqualTo(T(4)))
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test MOI.get(model, MOI.TerminationStatus()) in
              (config.infeasible_status, MOI.INFEASIBLE_OR_UNBOUNDED)
    end
    return
end

"""
    test_linear_Semicontinuous_integration(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Run an integration test on Semicontinuous constraints.
"""
function test_linear_Semicontinuous_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    _test_linear_SemiXXX_integration(model, config, false)
    return
end

function setup_test(
    ::typeof(test_linear_Semicontinuous_integration),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(0))
            MOIU.mock_optimize!(mock, T[0, 0])
        end,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(2))
            MOIU.mock_optimize!(mock, T[2, 1])
        end,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(2))
            MOIU.mock_optimize!(mock, T[2, 2])
        end,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(5 // 2))
            MOIU.mock_optimize!(mock, T[5//2, 5//2])
        end,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(3))
            MOIU.mock_optimize!(mock, T[3, 3])
        end,
        (mock::MOIU.MockOptimizer) ->
            MOI.set(mock, MOI.TerminationStatus(), MOI.INFEASIBLE),
    )
    return
end

"""
    test_linear_Semiinteger_integration(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Run an integration test on Semiinteger constraints.
"""
function test_linear_Semiinteger_integration(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    _test_linear_SemiXXX_integration(model, config, true)
    return
end

function setup_test(
    ::typeof(test_linear_Semiinteger_integration),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(0))
            MOIU.mock_optimize!(mock, T[0, 0])
        end,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(2))
            MOIU.mock_optimize!(mock, T[2, 1])
        end,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(2))
            MOIU.mock_optimize!(mock, T[2, 2])
        end,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(3))
            MOIU.mock_optimize!(mock, T[3, 5//2])
        end,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(3))
            MOIU.mock_optimize!(mock, T[3, 3])
        end,
        (mock::MOIU.MockOptimizer) ->
            MOI.set(mock, MOI.TerminationStatus(), MOI.INFEASIBLE),
    )
    return
end

"""
    test_linear_complex_Zeros(model::MOI.ModelLike, config::Config{T}) where {T}

Run an integration test on complex-valued affine constraints in Zeros.
"""
function test_linear_complex_Zeros(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{Complex{T}},
        MOI.Zeros,
    )
    x, cx = MOI.add_constrained_variables(model, MOI.Nonnegatives(2))
    scalar_f =
        (T(1) + T(2) * im) * x[1] + (T(1) - T(1) * im) * x[2] -
        (T(1) + T(1) * im)
    vector_f = MOI.Utilities.operate(vcat, Complex{T}, scalar_f)
    c = MOI.add_constraint(model, vector_f, MOI.Zeros(1))
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    primal = [T(2) / T(3), T(1) / T(3)]
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), primal, config)
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), cx), primal, config)
    z = [zero(Complex{T})]
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), z, config)
    if _supports(config, MOI.ConstraintDual)
        @test ≈(MOI.get(model, MOI.ConstraintDual(), cx), T[0, 0], config)
        @test ≈(MOI.get(model, MOI.ConstraintDual(), c), z, config)
    end
    return
end

function setup_test(
    ::typeof(test_linear_complex_Zeros),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOIU.mock_optimize!(
                mock,
                [T(2) / T(3), T(1) / T(3)],
                (MOI.VectorAffineFunction{Complex{T}}, MOI.Zeros) =>
                    [zeros(Complex{T}, 1)],
            )
        end,
    )
    return
end

version_added(::typeof(test_linear_complex_Zeros)) = v"1.7.0"

"""
    test_linear_complex_Zeros_duplicate(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Run an integration test on complex-valued affine constraints in Zeros.
"""
function test_linear_complex_Zeros_duplicate(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{Complex{T}},
        MOI.Zeros,
    )
    x, cx = MOI.add_constrained_variables(model, MOI.Nonnegatives(1))
    scalar_f =
        (T(1) + T(0) * im) * x[1] + T(1) * im * x[1] - T(2) * im -
        (T(1) + T(0) * im) * x[1]
    vector_f = MOI.Utilities.operate(vcat, Complex{T}, scalar_f)
    c = MOI.add_constraint(model, vector_f, MOI.Zeros(1))
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T[2], config)
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), cx), T[2], config)
    z = [zero(Complex{T})]
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), z, config)
    if _supports(config, MOI.ConstraintDual)
        @test ≈(MOI.get(model, MOI.ConstraintDual(), cx), T[0], config)
        @test ≈(MOI.get(model, MOI.ConstraintDual(), c), z, config)
    end
    return
end

function setup_test(
    ::typeof(test_linear_complex_Zeros_duplicate),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOIU.mock_optimize!(
                mock,
                T[2],
                (MOI.VectorAffineFunction{Complex{T}}, MOI.Zeros) =>
                    [zeros(Complex{T}, 1)],
            )
        end,
    )
    return
end

version_added(::typeof(test_linear_complex_Zeros_duplicate)) = v"1.7.0"

"""
    test_linear_open_intervals(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test that the solver supports open-intervals like `(-Inf, u]`, `[l, Inf)`, and
`(-Inf, Inf)`.
"""
function test_linear_open_intervals(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.Interval{T},
    )
    x = MOI.add_variables(model, 3)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x[1] + T(-1) * x[2] + T(1) * x[3]
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.add_constraint(model, T(1) * x[1], MOI.Interval(typemin(T), T(1)))
    MOI.add_constraint(model, T(1) * x[2], MOI.Interval(T(-1), typemax(T)))
    MOI.add_constraint(model, T(1) * x[3], MOI.Interval(typemin(T), typemax(T)))
    MOI.add_constraint(model, x[3], MOI.LessThan(T(1)))
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T[1, -1, 1], config)
    return
end

function setup_test(
    ::typeof(test_linear_open_intervals),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[1, -1, 1]),
    )
    return
end

version_added(::typeof(test_linear_open_intervals)) = v"1.7.0"

"""
    test_linear_variable_open_intervals(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test that the solver supports open-intervals like `(-Inf, u]`, `[l, Inf)`, and
`(-Inf, Inf)`.
"""
function test_linear_variable_open_intervals(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.Interval{T})
    x = MOI.add_variables(model, 3)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x[1] + T(-1) * x[2] + T(1) * x[3]
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.add_constraint(model, x[1], MOI.Interval(typemin(T), T(1)))
    MOI.add_constraint(model, x[2], MOI.Interval(T(-1), typemax(T)))
    MOI.add_constraint(model, x[3], MOI.Interval(T(-1), T(1)))
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T[1, -1, 1], config)
    return
end

function setup_test(
    ::typeof(test_linear_variable_open_intervals),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[1, -1, 1]),
    )
    return
end

version_added(::typeof(test_linear_variable_open_intervals)) = v"1.14.0"

"""
    test_linear_HyperRectangle_VectorOfVariables(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Run an integration test on HyperRectangle constraints.
"""
function test_linear_HyperRectangle_VectorOfVariables(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.HyperRectangle{T},
    )
    @requires _supports(config, MOI.optimize!)
    set = MOI.HyperRectangle(T[-1, -2], T[3, 4])
    x, _ = MOI.add_constrained_variables(model, set)
    f = T(1) * x[1] + T(-1) * x[2]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), [T(-1), T(4)], config)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), [T(3), T(-2)], config)
    return
end

function setup_test(
    ::typeof(test_linear_HyperRectangle_VectorOfVariables),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[-1, 4]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[3, -2]),
    )
    return
end

version_added(::typeof(test_linear_HyperRectangle_VectorOfVariables)) = v"1.8.0"

"""
    test_linear_HyperRectangle_VectorAffinneFunction(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Run an integration test on HyperRectangle constraints.
"""
function test_linear_HyperRectangle_VectorAffineFunction(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.HyperRectangle{T},
    )
    @requires _supports(config, MOI.optimize!)
    set = MOI.HyperRectangle(T[-1, -2], T[3, 4])
    x = MOI.add_variables(model, 2)
    fx = MOI.Utilities.operate(vcat, T, T(1) * x[1], T(1) * x[2])
    MOI.add_constraint(model, fx, set)
    f = T(1) * x[1] + T(-1) * x[2]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), [T(-1), T(4)], config)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), [T(3), T(-2)], config)
    return
end

function setup_test(
    ::typeof(test_linear_HyperRectangle_VectorAffineFunction),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[-1, 4]),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, T[3, -2]),
    )
    return
end

function version_added(
    ::typeof(test_linear_HyperRectangle_VectorAffineFunction),
)
    return v"1.8.0"
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    DualRelativeEntropyBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`DualRelativeEntropyBridge` implements the following reformulation that converts a
[`MOI.DualRelativeEntropyCone`](@ref) into an [`MOI.DualExponentialCone`](@ref):

  * ``w_i \\ge u \\left(\\log \\left(\\frac{u}{v_i}\\right) - 1\\right)`` into
    ``(-u, w_i, v_i) \\in DualExponentialCone``.

## Source node

`DualRelativeEntropyBridge` supports:

  * `G` in [`MOI.DualRelativeEntropyCone`](@ref)

## Target nodes

`DualRelativeEntropyBridge` creates:

  * `F` in [`MOI.DualExponentialCone`](@ref)
"""
struct DualRelativeEntropyBridge{T,F,G} <: AbstractBridge
    exp_indices::Vector{MOI.ConstraintIndex{F,MOI.DualExponentialCone}}
end

const DualRelativeEntropy{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{DualRelativeEntropyBridge{T},OT}

function bridge_constraint(
    ::Type{DualRelativeEntropyBridge{T,F,G}},
    model::MOI.ModelLike,
    f::G,
    s::MOI.DualRelativeEntropyCone,
) where {T,F,G}
    f_scalars = MOI.Utilities.eachscalar(f)
    d = MOI.dimension(s)
    v_dim = div(d - 1, 2)
    exp_indices = MOI.ConstraintIndex{F,MOI.DualExponentialCone}[]
    for i in 1:v_dim
        fi = MOI.Utilities.operate(
            vcat,
            T,
            MOI.Utilities.operate(-, T, f_scalars[1]), # -u
            f_scalars[1+i+v_dim],                      # w_i
            f_scalars[1+i],                            # v_i
        )
        push!(
            exp_indices,
            MOI.add_constraint(model, fi, MOI.DualExponentialCone()),
        )
    end
    return DualRelativeEntropyBridge{T,F,G}(exp_indices)
end

function MOI.supports_constraint(
    ::Type{DualRelativeEntropyBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.DualRelativeEntropyCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:DualRelativeEntropyBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{DualRelativeEntropyBridge{T,F,G}},
) where {T,F,G}
    return Tuple{Type,Type}[(F, MOI.DualExponentialCone)]
end

function concrete_bridge_type(
    ::Type{<:DualRelativeEntropyBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.DualRelativeEntropyCone},
) where {T}
    S = MOI.Utilities.scalar_type(G)
    U = MOI.Utilities.promote_operation(-, T, S, S)
    F = MOI.Utilities.promote_operation(vcat, T, U, S)
    return DualRelativeEntropyBridge{T,F,G}
end

function MOI.get(
    bridge::DualRelativeEntropyBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.DualExponentialCone},
)::Int64 where {T,F}
    return length(bridge.exp_indices)
end

function MOI.get(
    bridge::DualRelativeEntropyBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.DualExponentialCone},
) where {T,F}
    return copy(bridge.exp_indices)
end

function MOI.delete(model::MOI.ModelLike, bridge::DualRelativeEntropyBridge)
    for exp_index_i in bridge.exp_indices
        MOI.delete(model, exp_index_i)
    end
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::DualRelativeEntropyBridge{T,F,G},
) where {T,F,G}
    d = length(bridge.exp_indices)
    func = MOI.Utilities.zero_with_output_dimension(F, 1 + 2 * d)
    exp_1 = MOI.Utilities.eachscalar(
        MOI.get(model, MOI.ConstraintFunction(), bridge.exp_indices[begin]),
    )
    MOI.Utilities.operate_output_index!(-, T, 1, func, exp_1[1])
    for i in eachindex(bridge.exp_indices)
        exp_i = MOI.Utilities.eachscalar(
            MOI.get(model, MOI.ConstraintFunction(), bridge.exp_indices[i]),
        )
        MOI.Utilities.operate_output_index!(+, T, 1 + i, func, exp_i[3])
        MOI.Utilities.operate_output_index!(+, T, 1 + d + i, func, exp_i[2])
    end
    return MOI.Utilities.convert_approx(G, func)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::DualRelativeEntropyBridge,
)
    return MOI.DualRelativeEntropyCone(1 + 2 * length(bridge.exp_indices))
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::DualRelativeEntropyBridge{T},
) where {T}
    d = length(bridge.exp_indices)
    primal = zeros(T, 1 + 2d)
    primal[1] = -MOI.get(model, attr, bridge.exp_indices[begin])[1]
    for i in eachindex(bridge.exp_indices)
        primal_i = MOI.get(model, attr, bridge.exp_indices[i])
        primal[1+i] = primal_i[3]
        primal[1+i+d] = primal_i[2]
    end
    return primal
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    bridge::DualRelativeEntropyBridge{T},
) where {T}
    d = length(bridge.exp_indices)
    dual = zeros(T, 1 + 2d)
    for (i, ci) in enumerate(bridge.exp_indices)
        dual_i = MOI.get(model, attr, ci)
        dual[1] -= dual_i[1]
        dual[1+i] = dual_i[3]
        dual[1+i+d] = dual_i[2]
    end
    return dual
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    GeoMeantoRelEntrBridge{T,F,G,H} <: Bridges.Constraint.AbstractBridge

`GeoMeantoRelEntrBridge` implements the following reformulation:

  * ``(u, w) \\in GeometricMeanCone`` into
    ``(0, w, (u + y)\\mathbf{1})\\in RelativeEntropyCone`` and ``y \\ge 0``

## Source node

`GeoMeantoRelEntrBridge` supports:

  * `H` in [`MOI.GeometricMeanCone`](@ref)

## Target nodes

`GeoMeantoRelEntrBridge` creates:

  * `G` in [`MOI.RelativeEntropyCone`](@ref)
  * `F` in [`MOI.Nonnegatives`](@ref)

## Derivation

The derivation of the bridge is as follows:

```math
\\begin{aligned}
(u, w) \\in GeometricMeanCone \\iff & u \\le \\left(\\prod_{i=1}^n w_i\\right)^{1/n} \\\\
\\iff & 0 \\le u + y \\le \\left(\\prod_{i=1}^n w_i\\right)^{1/n}, y \\ge 0 \\\\
\\iff & 1 \\le \\frac{\\left(\\prod_{i=1}^n w_i\\right)^{1/n}}{u + y}, y \\ge 0 \\\\
\\iff & 1 \\le \\left(\\prod_{i=1}^n \\frac{w_i}{u + y}\\right)^{1/n}, y \\ge 0 \\\\
\\iff & 0 \\le \\sum_{i=1}^n \\log\\left(\\frac{w_i}{u + y}\\right), y \\ge 0 \\\\
\\iff & 0 \\ge \\sum_{i=1}^n \\log\\left(\\frac{u + y}{w_i}\\right), y \\ge 0 \\\\
\\iff & 0 \\ge \\sum_{i=1}^n (u + y) \\log\\left(\\frac{u + y}{w_i}\\right), y \\ge 0 \\\\
\\iff & (0, w, (u + y)\\mathbf{1}) \\in RelativeEntropyCone, y \\ge 0 \\\\
\\end{aligned}
```

This derivation assumes that ``u + y > 0``, which is enforced by the relative
entropy cone.
"""
struct GeoMeantoRelEntrBridge{T,F,G,H} <: AbstractBridge
    y::MOI.VariableIndex
    nn_index::MOI.ConstraintIndex{F,MOI.Nonnegatives} # for y >= 0
    relentr_index::MOI.ConstraintIndex{G,MOI.RelativeEntropyCone}
end

const GeoMeantoRelEntr{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{GeoMeantoRelEntrBridge{T},OT}

function bridge_constraint(
    ::Type{GeoMeantoRelEntrBridge{T,F,G,H}},
    model::MOI.ModelLike,
    f::H,
    s::MOI.GeometricMeanCone,
) where {T,F,G,H}
    f_scalars = MOI.Utilities.eachscalar(f)
    (y, nn_index) = MOI.add_constrained_variables(model, MOI.Nonnegatives(1))
    w_func = MOI.Utilities.vectorize(
        fill(
            MOI.Utilities.operate(+, T, f_scalars[1], y[1]),
            MOI.dimension(s) - 1,
        ),
    )
    relentr_func = MOI.Utilities.operate(
        vcat,
        T,
        zero(MOI.ScalarAffineFunction{Float64}),
        f_scalars[2:end],
        w_func,
    )
    relentr_index = MOI.add_constraint(
        model,
        relentr_func,
        MOI.RelativeEntropyCone(MOI.output_dimension(relentr_func)),
    )
    return GeoMeantoRelEntrBridge{T,F,G,H}(y[1], nn_index, relentr_index)
end

function MOI.supports_constraint(
    ::Type{<:GeoMeantoRelEntrBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.GeometricMeanCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:GeoMeantoRelEntrBridge},
)
    return Tuple{Type}[(MOI.Nonnegatives,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:GeoMeantoRelEntrBridge{T,F,G}},
) where {T,F,G}
    return Tuple{Type,Type}[(G, MOI.RelativeEntropyCone)]
end

function concrete_bridge_type(
    ::Type{<:GeoMeantoRelEntrBridge{T}},
    H::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.GeometricMeanCone},
) where {T}
    F = MOI.VectorOfVariables
    S = MOI.Utilities.scalar_type(H)
    G = MOI.Utilities.promote_operation(
        vcat,
        T,
        T,
        S,
        MOI.Utilities.promote_operation(+, T, S, MOI.VariableIndex),
    )
    return GeoMeantoRelEntrBridge{T,F,G,H}
end

MOI.get(::GeoMeantoRelEntrBridge, ::MOI.NumberOfVariables)::Int64 = 1

function MOI.get(bridge::GeoMeantoRelEntrBridge, ::MOI.ListOfVariableIndices)
    return [bridge.y]
end

function MOI.get(
    ::GeoMeantoRelEntrBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.Nonnegatives},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    ::GeoMeantoRelEntrBridge{T,F,G},
    ::MOI.NumberOfConstraints{G,MOI.RelativeEntropyCone},
)::Int64 where {T,F,G}
    return 1
end

function MOI.get(
    bridge::GeoMeantoRelEntrBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.Nonnegatives},
) where {T,F}
    return [bridge.nn_index]
end

function MOI.get(
    bridge::GeoMeantoRelEntrBridge{T,F,G},
    ::MOI.ListOfConstraintIndices{G,MOI.RelativeEntropyCone},
) where {T,F,G}
    return [bridge.relentr_index]
end

function MOI.delete(model::MOI.ModelLike, bridge::GeoMeantoRelEntrBridge)
    MOI.delete(model, bridge.relentr_index)
    MOI.delete(model, bridge.nn_index)
    MOI.delete(model, bridge.y)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::GeoMeantoRelEntrBridge{T,F,G,H},
) where {T,F,G,H}
    relentr_func = MOI.Utilities.eachscalar(
        MOI.get(model, MOI.ConstraintFunction(), bridge.relentr_index),
    )
    d = div(length(relentr_func) - 1, 2)
    u_func = MOI.Utilities.remove_variable(
        MOI.Utilities.operate(-, T, relentr_func[end], bridge.y),
        bridge.y,
    )
    w_func = relentr_func[2:(1+d)]
    return MOI.Utilities.convert_approx(
        H,
        MOI.Utilities.operate(vcat, T, u_func, w_func),
    )
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::GeoMeantoRelEntrBridge,
)
    return MOI.GeometricMeanCone(
        1 + div(
            MOI.dimension(
                MOI.get(model, MOI.ConstraintSet(), bridge.relentr_index),
            ) - 1,
            2,
        ),
    )
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{GeoMeantoRelEntrBridge{T,F,G,H}},
) where {T,F,G,H}
    ci_1 = MOI.ConstraintIndex{F,MOI.Nonnegatives}
    ci_2 = MOI.ConstraintIndex{G,MOI.RelativeEntropyCone}
    return MOI.supports(model, attr, ci_1) && MOI.supports(model, attr, ci_2)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::GeoMeantoRelEntrBridge,
)
    relentr_primal = MOI.get(model, attr, bridge.relentr_index)
    if relentr_primal === nothing
        return nothing
    end
    d = div(length(relentr_primal) - 1, 2)
    y_val = MOI.get(model, attr, bridge.nn_index)[1]
    u_val = sum(relentr_primal[(2+d):end]) / d - y_val
    return vcat(u_val, relentr_primal[2:(1+d)])
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::GeoMeantoRelEntrBridge,
    value,
)
    u_val = value[1]
    u_pos = -min(zero(u_val), u_val)
    d = length(value) - 1
    MOI.set(model, MOI.VariablePrimalStart(), bridge.y, u_pos)
    MOI.set(model, attr, bridge.nn_index, [u_pos])
    MOI.set(
        model,
        attr,
        bridge.relentr_index,
        vcat(0, value[2:end], fill(u_pos + u_val, d)),
    )
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::GeoMeantoRelEntrBridge,
    ::Nothing,
)
    MOI.set(model, MOI.VariablePrimalStart(), bridge.y, nothing)
    MOI.set(model, attr, bridge.nn_index, nothing)
    MOI.set(model, attr, bridge.relentr_index, nothing)
    return
end

# Given a is dual on y >= 0 and (b, c, d) is dual on RelativeEntropyCone
# constraint, dual on (u, w) in GeometricMeanCone is (-a, c). Note that
# sum(d) = -a, so we could instead use (sum(d), c).
function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::GeoMeantoRelEntrBridge,
)
    nn_attr = MOI.get(model, attr, bridge.nn_index)
    if nn_attr === nothing
        return nothing
    end
    relentr_dual = MOI.get(model, attr, bridge.relentr_index)
    d = div(length(relentr_dual) - 1, 2)
    w_dual = relentr_dual[2:(d+1)]
    return vcat(-nn_attr[1], w_dual)
end

# Given GeometricMeanCone constraint dual start of (u, w), constraint dual on
# y >= 0 is -u and on RelativeEntropyCone constraint is
# (-u/n, w, u/n * (log.(w/geomean(w)) .+ 1)).
# Note log.(w/geomean(w)) = log.(w) .- sum(log, w) / n.
function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintDualStart,
    bridge::GeoMeantoRelEntrBridge,
    value,
)
    d = length(value) - 1
    u = value[1]
    w = value[2:end]
    MOI.set(model, MOI.ConstraintDualStart(), bridge.nn_index, [-u])
    relentr_dual =
        vcat(-u / d, value[2:end], u / d * (log.(w) .+ (1 - sum(log, w) / d)))
    MOI.set(
        model,
        MOI.ConstraintDualStart(),
        bridge.relentr_index,
        relentr_dual,
    )
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::GeoMeantoRelEntrBridge,
    ::Nothing,
)
    MOI.set(model, attr, bridge.nn_index, nothing)
    MOI.set(model, attr, bridge.relentr_index, nothing)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestCachingOptimizer

using Test

import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

###
### Helper structs
###

struct DummyModelAttribute <: MOI.AbstractModelAttribute end

struct DummyEvaluator <: MOI.AbstractNLPEvaluator end

struct DummyVariableAttribute <: MOI.AbstractVariableAttribute end

struct DummyConstraintAttribute <: MOI.AbstractConstraintAttribute end

mutable struct NoFreeVariables <: MOI.AbstractOptimizer
    inner::MOIU.Model{Float64}
    NoFreeVariables() = new(MOIU.Model{Float64}())
end

MOI.is_empty(model::NoFreeVariables) = MOI.is_empty(model.inner)

MOI.empty!(model::NoFreeVariables) = MOI.empty!(model.inner)

function MOI.get(model::NoFreeVariables, attr::MOI.AnyAttribute, idx::Vector)
    return MOI.get(model.inner, attr, idx)
end

function MOI.get(model::NoFreeVariables, attr::MOI.AnyAttribute, args...)
    return MOI.get(model.inner, attr, args...)
end

function MOI.supports_add_constrained_variables(
    ::NoFreeVariables,
    ::Type{MOI.Reals},
)
    return false
end

function MOI.supports_add_constrained_variable(
    ::NoFreeVariables,
    ::Type{<:MOI.AbstractScalarSet},
)
    return true
end

function MOI.add_constrained_variable(
    model::NoFreeVariables,
    set::MOI.AbstractScalarSet,
)
    return MOI.add_constrained_variable(model.inner, set)
end

function MOI.supports_add_constrained_variables(
    ::NoFreeVariables,
    ::Type{<:MOI.AbstractVectorSet},
)
    return true
end

function MOI.add_constrained_variables(
    model::NoFreeVariables,
    set::MOI.AbstractVectorSet,
)
    return MOI.add_constrained_variables(model.inner, set)
end

MOI.supports_incremental_interface(::NoFreeVariables) = true

function MOI.copy_to(dest::NoFreeVariables, src::MOI.ModelLike; kwargs...)
    return MOI.Utilities.default_copy_to(dest, src; kwargs...)
end

###
### The tests
###

function test_MOI_Test()
    # It seems like these loops might take a while. But the first one takes
    # _forever_, and then the rest are really quick (like 140s vs 0.4s).
    for state in
        (MOIU.NO_OPTIMIZER, MOIU.EMPTY_OPTIMIZER, MOIU.ATTACHED_OPTIMIZER)
        for mode in (MOIU.MANUAL, MOIU.AUTOMATIC)
            model = MOIU.CachingOptimizer(MOIU.Model{Float64}(), mode)
            if state != MOIU.NO_OPTIMIZER
                optimizer = MOIU.MockOptimizer(
                    MOIU.Model{Float64}(),
                    supports_names = false,
                )
                MOIU.reset_optimizer(model, optimizer)
                if state == MOIU.ATTACHED_OPTIMIZER
                    MOIU.attach_optimizer(model)
                end
            end
            @test MOIU.state(model) == state
            @test MOIU.mode(model) == mode
            MOI.Test.runtests(
                model,
                MOI.Test.Config(exclude = Any[MOI.optimize!]),
                exclude = [
                    "test_attribute_SolverName",
                    "test_attribute_SolverVersion",
                ],
            )
        end
    end
    return
end

# !!! warning
#     This is some type piracy. To enable CachingOptimizer to pass some MOI.Test
#     functions with MockOptimizer, we overload `setup_test` to setup the inner
#     mock optimizer.
#
#     This is pretty fragile. It requires the inner optimizer to be attached,
#     amongst other things. It's used by `test_compute_conflict` below, but not
#     by test_MOI_Test above (test_MOI_Test has `exclude = Any[MOI.optimize!]`).
function MOI.Test.setup_test(
    f::Any,
    model::MOI.Utilities.CachingOptimizer{
        MOI.Utilities.MockOptimizer{
            MOI.Utilities.UniversalFallback{MOI.Utilities.Model{Float64}},
            Float64,
        },
        MOI.Utilities.Model{Float64},
    },
    config::MOI.Test.Config,
)
    MOI.Test.setup_test(f, model.optimizer, config)
    return
end

function test_compute_conflict()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Utilities.CachingOptimizer(MOI.Utilities.Model{Float64}(), mock)
    MOI.Test.runtests(
        model,
        MOI.Test.Config(),
        include = ["test_solve_conflict"],
    )
    return
end

"""
Without an optimizer attached (that is, `MOI.state(model) == NO_OPTIMIZER`) we
need throw nice errors for attributes that are based on the optimizer. For
`AbstractModelAttribute`s that `is_set_by_optimize` returns `true` for, we
overload `TerminationStatus`, `PrimalStatus`, or `DualStatus` to return
sane default values. Otherwise we throw a nice error.
"""
function test_default_attributes()
    model = MOIU.CachingOptimizer(MOIU.Model{Float64}(), MOIU.MANUAL)
    @test MOIU.state(model) == MOIU.NO_OPTIMIZER

    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.NO_SOLUTION
    @test MOI.get(model, MOI.DualStatus()) == MOI.NO_SOLUTION
    x = MOI.add_variables(model, 2)
    @test_throws(
        MOI.GetAttributeNotAllowed{MOI.VariablePrimal},
        MOI.get(model, MOI.VariablePrimal(), x[1]),
    )
    @test_throws(
        MOI.GetAttributeNotAllowed{MOI.VariablePrimal},
        MOI.get(model, MOI.VariablePrimal(), x),
    )
    for attr in (
        MOI.SolverName(),
        MOI.Silent(),
        MOI.TimeLimitSec(),
        MOI.ObjectiveLimit(),
        MOI.NumberOfThreads(),
        MOI.ResultCount(),
    )
        @test_throws(
            MOI.GetAttributeNotAllowed{typeof(attr)},
            MOI.get(model, attr),
        )
    end
    return
end

function test_copyable_solver_attributes()
    cache = MOIU.UniversalFallback(MOIU.Model{Float64}())
    cached = MOIU.CachingOptimizer(cache, MOIU.MANUAL)
    MOI.set(cached, MOI.Silent(), true)
    MOI.set(cached, MOI.TimeLimitSec(), 0.0)
    MOI.set(cached, MOI.ObjectiveLimit(), 42.0)
    MOI.set(cached, MOI.NumberOfThreads(), 1)
    mock = MOIU.MockOptimizer(MOIU.UniversalFallback(MOIU.Model{Float64}()))
    MOIU.reset_optimizer(cached, mock)
    @test MOI.get(mock, MOI.Silent())
    @test MOI.get(cached, MOI.Silent())
    @test MOI.get(mock, MOI.TimeLimitSec()) == 0.0
    @test MOI.get(cached, MOI.TimeLimitSec()) == 0.0
    @test MOI.get(mock, MOI.ObjectiveLimit()) == 42.0
    @test MOI.get(cached, MOI.ObjectiveLimit()) == 42.0
    @test MOI.get(mock, MOI.NumberOfThreads()) == 1
    @test MOI.get(cached, MOI.NumberOfThreads()) == 1
    MOI.set(cached, MOI.Silent(), false)
    MOI.set(cached, MOI.TimeLimitSec(), 1.0)
    MOI.set(cached, MOI.ObjectiveLimit(), 1.0)
    MOI.set(cached, MOI.NumberOfThreads(), 2)
    @test !MOI.get(mock, MOI.Silent())
    @test !MOI.get(cached, MOI.Silent())
    @test MOI.get(mock, MOI.TimeLimitSec()) ≈ 1.0
    @test MOI.get(mock, MOI.ObjectiveLimit()) ≈ 1.0
    @test MOI.get(cached, MOI.TimeLimitSec()) ≈ 1.0
    @test MOI.get(cached, MOI.ObjectiveLimit()) ≈ 1.0
    @test MOI.get(mock, MOI.NumberOfThreads()) == 2
    @test MOI.get(cached, MOI.NumberOfThreads()) == 2
    mock = MOIU.MockOptimizer(MOIU.UniversalFallback(MOIU.Model{Float64}()))
    MOIU.reset_optimizer(cached, mock)
    @test !MOI.get(mock, MOI.Silent())
    @test !MOI.get(cached, MOI.Silent())
    @test MOI.get(mock, MOI.TimeLimitSec()) ≈ 1.0
    @test MOI.get(cached, MOI.TimeLimitSec()) ≈ 1.0
    @test MOI.get(mock, MOI.ObjectiveLimit()) ≈ 1.0
    @test MOI.get(cached, MOI.ObjectiveLimit()) ≈ 1.0
    @test MOI.get(mock, MOI.NumberOfThreads()) == 2
    @test MOI.get(cached, MOI.NumberOfThreads()) == 2
    MOI.set(cached, MOI.Silent(), true)
    MOI.set(cached, MOI.TimeLimitSec(), 0.0)
    MOI.set(cached, MOI.NumberOfThreads(), 1)
    @test MOI.get(mock, MOI.Silent())
    @test MOI.get(cached, MOI.Silent())
    @test MOI.get(mock, MOI.TimeLimitSec()) == 0.0
    @test MOI.get(cached, MOI.TimeLimitSec()) == 0.0
    @test MOI.get(mock, MOI.NumberOfThreads()) == 1
    @test MOI.get(cached, MOI.NumberOfThreads()) == 1
    mock = MOIU.MockOptimizer(MOIU.UniversalFallback(MOIU.Model{Float64}()))
    MOIU.reset_optimizer(cached, mock)
    @test MOI.get(mock, MOI.Silent())
    @test MOI.get(cached, MOI.Silent())
    @test MOI.get(mock, MOI.TimeLimitSec()) == 0.0
    @test MOI.get(cached, MOI.TimeLimitSec()) == 0.0
    @test MOI.get(mock, MOI.NumberOfThreads()) == 1
    @test MOI.get(cached, MOI.NumberOfThreads()) == 1
    return
end

function test_mapping_of_variables()
    mock = MOIU.MockOptimizer(MOIU.UniversalFallback(MOIU.Model{Float64}()))
    model = MOIU.CachingOptimizer(
        MOIU.UniversalFallback(MOIU.Model{Float64}()),
        mock,
    )
    MOIU.attach_optimizer(model)
    x = MOI.add_variable(model)
    y = first(MOI.get(mock, MOI.ListOfVariableIndices()))
    @test x != y # Otherwise, these tests will trivially pass
    @test !MOI.is_valid(model, y)
    @test !MOI.is_valid(mock, x)
    cx = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    cy = first(
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.VariableIndex,
                MOI.GreaterThan{Float64},
            }(),
        ),
    )
    @test !MOI.is_valid(model, cy)
    @test !MOI.is_valid(mock, cx)
    @test MOI.get(mock, MOI.ConstraintFunction(), cy) == y

    c2x = MOI.add_constraint(model, 2.0x, MOI.GreaterThan(1.0))
    c2y = first(
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.GreaterThan{Float64},
            }(),
        ),
    )
    @test !MOI.is_valid(model, c2y)
    @test !MOI.is_valid(mock, c2x)
    @test MOI.get(model, MOI.ConstraintFunction(), c2x) ≈ 2.0x
    @test MOI.get(model, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(1.0)
    @test MOI.get(mock, MOI.ConstraintFunction(), c2y) ≈ 2.0y
    @test MOI.get(mock, MOI.ConstraintSet(), c2y) == MOI.GreaterThan(1.0)

    MOI.set(model, MOI.ConstraintSet(), c2x, MOI.GreaterThan(2.0))
    @test MOI.get(model, MOI.ConstraintFunction(), c2x) ≈ 2.0x
    @test MOI.get(model, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(2.0)
    @test MOI.get(mock, MOI.ConstraintFunction(), c2y) ≈ 2.0y
    @test MOI.get(mock, MOI.ConstraintSet(), c2y) == MOI.GreaterThan(2.0)

    MOI.set(model, MOI.ConstraintFunction(), c2x, 3.0x)
    @test MOI.get(model, MOI.ConstraintFunction(), c2x) ≈ 3.0x
    @test MOI.get(model, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(2.0)
    @test MOI.get(mock, MOI.ConstraintFunction(), c2y) ≈ 3.0y
    @test MOI.get(mock, MOI.ConstraintSet(), c2y) == MOI.GreaterThan(2.0)

    MOI.set(model, MOI.ConstraintSet(), c2x, MOI.GreaterThan(4.0))
    @test MOI.get(model, MOI.ConstraintFunction(), c2x) ≈ 3.0x
    @test MOI.get(model, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(4.0)
    @test MOI.get(mock, MOI.ConstraintFunction(), c2y) ≈ 3.0y
    @test MOI.get(mock, MOI.ConstraintSet(), c2y) == MOI.GreaterThan(4.0)

    MOI.set(model, MOI.ObjectiveFunction{typeof(x)}(), x)
    @test MOI.get(mock, MOI.ObjectiveFunction{typeof(y)}()) == y

    MOI.set(model, MOI.ObjectiveFunction{typeof(2.0x)}(), 2.0x)
    @test MOI.get(mock, MOI.ObjectiveFunction{typeof(2.0y)}()) ≈ 2.0y

    MOI.set(model, DummyModelAttribute(), 2.0x + 1.0)
    @test MOI.get(model, DummyModelAttribute()) ≈ 2.0x + 1.0
    @test MOI.get(mock, DummyModelAttribute()) ≈ 2.0y + 1.0

    for (attr, cache_index, optimizer_index) in
        [(DummyVariableAttribute(), x, y), (DummyConstraintAttribute(), cx, cy)]
        MOI.set(model, attr, cache_index, 1.0x)
        @test MOI.get(model, attr, cache_index) ≈ 1.0x
        @test MOI.get(mock, attr, optimizer_index) ≈ 1.0y

        MOI.set(model, attr, [cache_index], [3.0x])
        @test MOI.get(model, attr, [cache_index])[1] ≈ 3.0x
        @test MOI.get(mock, attr, [optimizer_index])[1] ≈ 3.0y
    end

    @testset "RawSolver" begin
        MOI.get(model, MOI.RawSolver()) === mock
    end

    @testset "HeuristicCallback" begin
        attr = MOI.HeuristicCallback()
        f(callback_data) = nothing
        MOI.set(model, attr, f)
        @test MOI.get(model, attr) === f
    end

    @testset "CallbackVariablePrimal" begin
        attr = MOI.CallbackVariablePrimal(nothing)
        err =
            ErrorException("No mock callback primal is set for variable `$y`.")
        @test_throws err MOI.get(model, attr, x)
        MOI.set(mock, attr, y, 1.0)
        @test_throws MOI.InvalidIndex(x) MOI.get(mock, attr, x)
        @test MOI.get(mock, attr, y) == 1.0
        @test MOI.get(model, attr, x) == 1.0
    end

    @testset "LazyConstraint" begin
        sub = MOI.LazyConstraint(nothing)
        @test MOI.supports(model, sub)
        MOI.submit(model, sub, 2.0x, MOI.GreaterThan(1.0))
        @test mock.submitted[sub][1][1] ≈ 2.0y
        @test mock.submitted[sub][1][2] == MOI.GreaterThan(1.0)
    end
    @testset "HeuristicSolution" begin
        sub = MOI.HeuristicSolution(nothing)
        @test MOI.supports(model, sub)
        MOI.submit(model, sub, [x], [1.0])
        @test mock.submitted[sub][1][1] == [y]
        @test mock.submitted[sub][1][2] == [1.0]
    end

    nlp_data =
        MOI.NLPBlockData([MOI.NLPBoundsPair(1.0, 2.0)], DummyEvaluator(), false)
    MOI.set(model, MOI.NLPBlock(), nlp_data)
    for nlp_data in
        [MOI.get(model, MOI.NLPBlock()), MOI.get(mock, MOI.NLPBlock())]
        @test nlp_data.constraint_bounds == [MOI.NLPBoundsPair(1.0, 2.0)]
        @test nlp_data.evaluator isa DummyEvaluator
        @test nlp_data.has_objective == false
    end
    return
end

function test_CachingOptimizer_MANUAL_mode()
    m = MOIU.CachingOptimizer(MOIU.Model{Float64}(), MOIU.MANUAL)
    @test MOIU.state(m) == MOIU.NO_OPTIMIZER

    s = MOIU.MockOptimizer(MOIU.Model{Float64}(), supports_names = false)
    @test MOI.is_empty(s)
    MOIU.reset_optimizer(m, s)
    @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER

    v = MOI.add_variable(m)
    x = MOI.add_variables(m, 2)
    saf = MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.([1.0, 2.0, 3.0], [v; x]),
        0.0,
    )
    @test MOI.supports(m, MOI.ObjectiveFunction{typeof(saf)}())
    MOI.set(m, MOI.ObjectiveFunction{typeof(saf)}(), saf)
    @test MOI.get(
        m,
        MOIU.AttributeFromModelCache(MOI.ObjectiveFunction{typeof(saf)}()),
    ) ≈ saf
    @test MOI.get(m, MOI.ObjectiveFunction{typeof(saf)}()) ≈ saf

    @test_throws AssertionError MOI.optimize!(m)

    MOIU.attach_optimizer(m)
    @test MOIU.state(m) == MOIU.ATTACHED_OPTIMIZER
    @test MOI.get(
        m,
        MOIU.AttributeFromOptimizer(MOI.ObjectiveFunction{typeof(saf)}()),
    ) ≈ saf

    @test MOI.supports(m, MOI.ObjectiveSense())
    MOI.set(m, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(m, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    @test MOI.get(m, MOIU.AttributeFromModelCache(MOI.ObjectiveSense())) ==
          MOI.MAX_SENSE
    @test MOI.get(m, MOIU.AttributeFromOptimizer(MOI.ObjectiveSense())) ==
          MOI.MAX_SENSE

    @test MOI.supports(
        m,
        MOIU.AttributeFromOptimizer(MOIU.MockModelAttribute()),
    )
    MOI.set(m, MOIU.AttributeFromOptimizer(MOIU.MockModelAttribute()), 10)
    @test MOI.get(m, MOIU.AttributeFromOptimizer(MOIU.MockModelAttribute())) ==
          10

    MOI.set(m, MOIU.AttributeFromOptimizer(MOI.ResultCount()), 1)
    @test MOI.supports(
        m,
        MOIU.AttributeFromOptimizer(MOI.VariablePrimal()),
        typeof(v),
    )
    MOI.set(m, MOIU.AttributeFromOptimizer(MOI.VariablePrimal()), v, 3.0)
    MOI.set(s, MOI.TerminationStatus(), MOI.OPTIMAL)
    MOI.optimize!(m)

    @test MOI.get(m, MOI.VariablePrimal(), v) == 3.0
    @test MOI.get(m, MOI.VariablePrimal(), [v]) == [3.0]
    @test MOI.get(m, MOIU.AttributeFromOptimizer(MOI.VariablePrimal()), v) ==
          3.0

    @test MOI.supports_constraint(
        m.model_cache,
        MOI.VariableIndex,
        MOI.LessThan{Float64},
    )
    @test MOI.supports_constraint(
        m.optimizer.inner_model,
        MOI.VariableIndex,
        MOI.LessThan{Float64},
    )
    @test MOI.supports_constraint(
        m.optimizer,
        MOI.VariableIndex,
        MOI.LessThan{Float64},
    )
    @test MOI.supports_constraint(m, MOI.VariableIndex, MOI.LessThan{Float64})
    lb = MOI.add_constraint(m, v, MOI.LessThan(10.0))
    MOI.set(m, MOI.ConstraintSet(), lb, MOI.LessThan(11.0))
    @test MOI.get(m, MOI.ConstraintSet(), lb) == MOI.LessThan(11.0)
    @test MOI.get(m, MOI.ConstraintFunction(), lb) == v

    MOIU.drop_optimizer(m)
    @test MOIU.state(m) == MOIU.NO_OPTIMIZER

    MOI.set(m, MOI.ConstraintSet(), lb, MOI.LessThan(12.0))
    @test MOI.get(m, MOI.ConstraintSet(), lb) == MOI.LessThan(12.0)

    MOI.delete(m, x[2])
    @test_throws MOI.InvalidIndex{typeof(x[2])} MOI.delete(m, x[2])
    @test !MOI.is_valid(m, x[2])

    # TODO: test more constraint modifications

    show_str = sprint(show, m)
    @test occursin("NO_OPTIMIZER", show_str)
    @test occursin("MANUAL", show_str)

    MOI.empty!(s)
    MOIU.reset_optimizer(m, s)
    @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
    MOIU.attach_optimizer(m)
    @test MOIU.state(m) == MOIU.ATTACHED_OPTIMIZER
    MOI.empty!(m)
    @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
end

function test_CachingOptimizer_AUTOMATIC_mode()
    m = MOIU.CachingOptimizer(MOIU.Model{Float64}(), MOIU.AUTOMATIC)
    @test MOIU.state(m) == MOIU.NO_OPTIMIZER

    v = MOI.add_variable(m)
    @test MOI.supports(m, MOI.VariableName(), typeof(v))
    MOI.set(m, MOI.VariableName(), v, "v")
    @test MOI.get(m, MOI.VariableName(), v) == "v"

    s = MOIU.MockOptimizer(MOIU.Model{Float64}(), supports_names = false)
    @test MOI.is_empty(s)
    MOIU.reset_optimizer(m, s)
    @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER

    saf = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, v)], 0.0)
    @test MOI.supports(m, MOI.ObjectiveFunction{typeof(saf)}())
    MOI.set(m, MOI.ObjectiveFunction{typeof(saf)}(), saf)
    @test MOI.get(
        m,
        MOIU.AttributeFromModelCache(MOI.ObjectiveFunction{typeof(saf)}()),
    ) ≈ saf

    MOI.optimize!(m)
    @test MOIU.state(m) == MOIU.ATTACHED_OPTIMIZER
    @test MOI.get(m, MOIU.AttributeFromOptimizer(MOI.TerminationStatus())) ==
          MOI.OPTIMIZE_NOT_CALLED

    @test MOI.get(m, MOI.VariableName(), v) == "v"
    @test MOI.get(m, MOIU.AttributeFromModelCache(MOI.VariableName()), v) == "v"
    # The caching optimizer does not copy names
    @test MOI.get(m, MOIU.AttributeFromOptimizer(MOI.VariableName()), v) == ""

    @test MOI.supports(m, MOI.ObjectiveSense())
    MOI.set(m, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(m, MOIU.AttributeFromModelCache(MOI.ObjectiveSense())) ==
          MOI.MAX_SENSE
    @test MOI.get(m, MOIU.AttributeFromOptimizer(MOI.ObjectiveSense())) ==
          MOI.MAX_SENSE

    @test MOI.supports(
        m,
        MOIU.AttributeFromOptimizer(MOIU.MockModelAttribute()),
    )
    MOI.set(m, MOIU.AttributeFromOptimizer(MOIU.MockModelAttribute()), 10)
    @test MOI.get(m, MOIU.AttributeFromOptimizer(MOIU.MockModelAttribute())) ==
          10

    MOI.set(m, MOIU.AttributeFromOptimizer(MOI.ResultCount()), 1)
    @test MOI.supports(
        m,
        MOIU.AttributeFromOptimizer(MOI.VariablePrimal()),
        typeof(v),
    )
    MOI.set(m, MOIU.AttributeFromOptimizer(MOI.VariablePrimal()), v, 3.0)

    MOI.optimize!(m)

    @test MOI.get(m, MOIU.AttributeFromOptimizer(MOI.VariablePrimal()), v) ==
          3.0

    @testset "Modify not allowed" begin
        s.modify_allowed = false
        MOI.modify(
            m,
            MOI.ObjectiveFunction{typeof(saf)}(),
            MOI.ScalarConstantChange(1.0),
        )
        s.modify_allowed = true
        @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
        MOIU.attach_optimizer(m)
        @test MOIU.state(m) == MOIU.ATTACHED_OPTIMIZER
        ci = MOI.add_constraint(m, saf, MOI.EqualTo(0.0))
        s.modify_allowed = false
        MOI.modify(m, ci, MOI.ScalarCoefficientChange(v, 1.0))
        s.modify_allowed = true
        @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
        MOIU.attach_optimizer(m)
        @test MOIU.state(m) == MOIU.ATTACHED_OPTIMIZER
    end

    # Simulate that constraints cannot be added
    @testset "Add constraint not allowed" begin
        s.add_con_allowed = false
        MOI.add_constraint(
            m,
            MOI.VectorOfVariables([v]),
            MOI.SecondOrderCone(1),
        )
        s.add_con_allowed = true
        @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
        MOI.empty!(m)
        @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
    end

    @testset "Add variable not allowed" begin
        s.add_var_allowed = false # Simulate optimizer that cannot add variables incrementally
        MOI.add_variable(m)
        @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
        @test_throws MOI.AddVariableNotAllowed MOIU.attach_optimizer(m)
        @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER

        s.add_var_allowed = true
        MOIU.attach_optimizer(m)
        @test MOIU.state(m) == MOIU.ATTACHED_OPTIMIZER
        s.add_var_allowed = false
        MOI.add_variables(m, 2)
        s.add_var_allowed = true
        @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
    end

    @testset "Delete not allowed" begin
        vi = MOI.add_variable(m)
        s.delete_allowed = false # Simulate optimizer that cannot delete variable
        MOI.delete(m, vi)
        s.delete_allowed = true
        @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
        MOIU.attach_optimizer(m)
        @test MOIU.state(m) == MOIU.ATTACHED_OPTIMIZER

        vi = MOI.add_variable(m)
        ci = MOI.add_constraint(m, vi, MOI.EqualTo(0.0))
        s.delete_allowed = false # Simulate optimizer that cannot delete constraint
        MOI.delete(m, ci)
        s.delete_allowed = true
        @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
        MOIU.attach_optimizer(m)
        @test MOIU.state(m) == MOIU.ATTACHED_OPTIMIZER
    end
    @test occursin("AUTOMATIC", sprint(show, m))
    MOI.empty!(m)
    @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
    return
end

function test_empty_model_and_optimizer()
    s = MOIU.MockOptimizer(MOIU.Model{Float64}(), supports_names = false)
    model = MOIU.Model{Float64}()
    m = MOIU.CachingOptimizer(model, s)
    @test m isa MOIU.CachingOptimizer{typeof(s),typeof(model)}
    @test MOI.is_empty(m)
    @test MOIU.state(m) == MOIU.EMPTY_OPTIMIZER
    @test MOIU.mode(m) == MOIU.AUTOMATIC
    @test MOI.get(m, MOI.SolverName()) == "Mock"
    @test occursin("EMPTY_OPTIMIZER", sprint(show, m))
    return
end

function test_empty_model_nonempty_optimizer()
    s = MOIU.MockOptimizer(MOIU.Model{Float64}(), supports_names = false)
    MOI.add_variable(s)
    model = MOIU.Model{Float64}()
    @test MOI.is_empty(model)
    @test !MOI.is_empty(s)
    @test_throws AssertionError MOIU.CachingOptimizer(model, s)
    return
end

function test_nonempty_model()
    s = MOIU.MockOptimizer(MOIU.Model{Float64}(), supports_names = false)
    model = MOIU.Model{Float64}()
    MOI.add_variable(model)
    @test !MOI.is_empty(model)
    @test MOI.is_empty(s)
    @test MOIU.CachingOptimizer(model, s) isa MOIU.CachingOptimizer
    return
end

function _constrained_variables_test(model)
    @test !MOI.supports_add_constrained_variables(model, MOI.Reals)
    @test MOI.supports_add_constrained_variable(model, MOI.ZeroOne)
    @test !MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @test MOI.supports_add_constrained_variables(model, MOI.Nonnegatives)
    @test !MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Nonnegatives,
    )
    scalar_set = MOI.ZeroOne()
    x, cx = MOI.add_constrained_variable(model, scalar_set)
    vector_set = MOI.Nonnegatives(2)
    y, cy = MOI.add_constrained_variables(model, vector_set)
    constraint_types = Set([
        (MOI.VariableIndex, MOI.ZeroOne),
        (MOI.VectorOfVariables, MOI.Nonnegatives),
    ])
    @test Set(MOI.get(model.model_cache, MOI.ListOfConstraintTypesPresent())) ==
          constraint_types
    if MOIU.state(model) == MOIU.EMPTY_OPTIMIZER
        MOIU.attach_optimizer(model)
    end
    @test Set(MOI.get(model.optimizer, MOI.ListOfConstraintTypesPresent())) ==
          constraint_types
    return
end

function test_constrained_variables()
    cache = NoFreeVariables()
    optimizer = NoFreeVariables()
    model = MOIU.CachingOptimizer(cache, optimizer)
    _constrained_variables_test(model)
    return
end

function test_constrained_variables_AUTOMATIC()
    cache = NoFreeVariables()
    optimizer = NoFreeVariables()
    model = MOIU.CachingOptimizer(cache, MOIU.AUTOMATIC)
    MOIU.reset_optimizer(model, optimizer)
    _constrained_variables_test(model)
    return
end

struct Issue1220 <: MOI.AbstractOptimizer
    optimizer_attributes::Dict{Any,Any}
    Issue1220() = new(Dict{Any,Any}())
end

MOI.is_empty(model::Issue1220) = isempty(model.optimizer_attributes)

function MOI.get(model::Issue1220, ::MOI.ListOfOptimizerAttributesSet)
    return collect(keys(model.optimizer_attributes))
end

MOI.supports(::Issue1220, ::MOI.AbstractOptimizerAttribute) = true

MOI.supports(::Issue1220, ::MOI.NumberOfThreads) = false

function MOI.get(model::Issue1220, attr::MOI.AbstractOptimizerAttribute)
    return model.optimizer_attributes[attr]
end

function MOI.set(model::Issue1220, attr::MOI.AbstractOptimizerAttribute, value)
    model.optimizer_attributes[attr] = value
    return
end

function test_issue1220_dont_pass_raw_parameter()
    model = MOIU.CachingOptimizer(Issue1220(), Issue1220())
    MOI.set(model, MOI.Silent(), true)
    MOI.set(model, MOI.RawOptimizerAttribute("foo"), "bar")
    MOI.set(model, MOI.NumberOfThreads(), 1)
    MOIU.reset_optimizer(model, Issue1220())
    @test MOI.get(model, MOI.Silent()) == true
    @test_throws KeyError MOI.get(model, MOI.RawOptimizerAttribute("foo"))
    @test_throws KeyError MOI.get(model, MOI.NumberOfThreads())
    return
end

function test_status_codes()
    optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        optimizer,
    )
    MOI.Utilities.attach_optimizer(model)
    MOI.set(optimizer, MOI.TerminationStatus(), MOI.OPTIMAL)
    MOI.set(optimizer, MOI.PrimalStatus(), MOI.FEASIBLE_POINT)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMAL
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    return
end

mutable struct CopyToAndOptimizer <: MOI.AbstractOptimizer
    is_dirty::Bool
end

function MOI.empty!(x::CopyToAndOptimizer)
    x.is_dirty = false
    return
end

MOI.is_empty(x::CopyToAndOptimizer) = !x.is_dirty

function MOI.optimize!(x::CopyToAndOptimizer, ::MOI.ModelLike)
    x.is_dirty = true
    return MOI.Utilities.IndexMap(), false
end

function test_copy_to_and_optimize!()
    optimizer = CopyToAndOptimizer(false)
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        optimizer,
    )
    MOI.optimize!(model)
    @test MOI.Utilities.state(model) == MOI.Utilities.EMPTY_OPTIMIZER
    @test !MOI.is_empty(optimizer)
    MOI.empty!(model)
    @test MOI.is_empty(optimizer)
    @test MOI.Utilities.state(model) == MOI.Utilities.EMPTY_OPTIMIZER
    return
end

###
### Test get_fallback in CachingOptimizer.
###
### It's a bit complicated because we need an optimizer with the minimal set of
### methods needed to test the fallbacks.
###

struct _GetFallbackModel1310 <: MOI.AbstractOptimizer end

MOI.is_empty(::_GetFallbackModel1310) = true

MOI.get(::_GetFallbackModel1310, ::MOI.ListOfModelAttributesSet) = []

MOI.get(::_GetFallbackModel1310, ::MOI.PrimalStatus) = MOI.FEASIBLE_POINT

MOI.get(::_GetFallbackModel1310, ::MOI.DualStatus) = MOI.FEASIBLE_POINT

MOI.get(::_GetFallbackModel1310, ::MOI.TerminationStatus) = MOI.OTHER_ERROR

MOI.get(::_GetFallbackModel1310, ::MOI.ResultCount) = 1

function MOI.optimize!(::_GetFallbackModel1310, model::MOI.ModelLike)
    index_map = MOI.IndexMap()
    for x in MOI.get(model, MOI.ListOfVariableIndices())
        index_map[x] = x
    end
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
            index_map[ci] = ci
        end
    end
    return index_map, false
end

function MOI.get(
    ::_GetFallbackModel1310,
    ::MOI.VariablePrimal,
    ::MOI.VariableIndex,
)
    return 1.2
end

function test_ConstraintPrimal_fallback()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        _GetFallbackModel1310(),
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ConstraintPrimal(), c) == 1.2
    @test MOI.get(model, MOI.ConstraintPrimal(), [c]) == [1.2]
    @test_throws(
        MOI.ResultIndexBoundsError(MOI.ConstraintPrimal(2), 1),
        MOI.get(model, MOI.ConstraintPrimal(2), c),
    )
    @test_throws(
        MOI.ResultIndexBoundsError(MOI.ConstraintPrimal(2), 1),
        MOI.get(model, MOI.ConstraintPrimal(2), [c]),
    )
    return
end

function test_ConstraintDual_variable_fallback()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        _GetFallbackModel1310(),
    )
    x = MOI.add_variable(model)
    cx = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ConstraintDual(), cx) == 1.0
    @test_throws(
        MOI.ResultIndexBoundsError(MOI.ConstraintDual(2), 1),
        MOI.get(model, MOI.ConstraintDual(2), cx),
    )
    @test_throws(
        MOI.ResultIndexBoundsError(MOI.ConstraintDual(2), 1),
        MOI.get(model, MOI.ConstraintDual(2), [cx]),
    )
    return
end

function test_ConstraintDual_nonvariable_nofallback()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        _GetFallbackModel1310(),
    )
    x = MOI.add_variable(model)
    cx = MOI.add_constraint(model, x + 1.0, MOI.GreaterThan(1.0))
    MOI.optimize!(model)
    @test_throws(
        MOI.GetAttributeNotAllowed,
        MOI.get(model, MOI.ConstraintDual(), cx),
    )
    return
end

function test_ConstraintPrimal_fallback_error()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        MOI.Utilities.AUTOMATIC,
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    @test_throws(
        MOI.GetAttributeNotAllowed{MOI.ConstraintPrimal},
        MOI.get(model, MOI.ConstraintPrimal(), c),
    )
    @test_throws(
        MOI.GetAttributeNotAllowed{MOI.ConstraintPrimal},
        MOI.get(model, MOI.ConstraintPrimal(), [c]),
    )
    return
end

function test_ObjectiveValue_fallback()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        _GetFallbackModel1310(),
    )
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(x)}(), x)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ObjectiveValue()) == 1.2
    @test_throws(
        MOI.ResultIndexBoundsError(MOI.ObjectiveValue(2), 1),
        MOI.get(model, MOI.ObjectiveValue(2)),
    )
    return
end

function test_DualObjectiveValue_fallback()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.Model{Float64}(),
        _GetFallbackModel1310(),
    )
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(x)}(), x)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.DualObjectiveValue()) == 1.0
    @test_throws(
        MOI.ResultIndexBoundsError(MOI.DualObjectiveValue(2), 1),
        MOI.get(model, MOI.DualObjectiveValue(2)),
    )
    return
end

struct _OptimizerAttributeValue1670 end

function test_map_indices_issue_1670()
    optimizer = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        optimizer,
    )
    MOI.Utilities.attach_optimizer(model)
    MOI.set(
        model,
        MOI.RawOptimizerAttribute("1670"),
        _OptimizerAttributeValue1670(),
    )
    @test MOI.get(optimizer, MOI.RawOptimizerAttribute("1670")) ==
          _OptimizerAttributeValue1670()
    return
end

function test_copy_optimizer_attributes_2887()
    cache() = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    optimizer() = MOI.Utilities.MockOptimizer(cache())
    # Test without calling Silent
    model = cache()
    opt = optimizer()
    model = MOI.Utilities.CachingOptimizer(model, opt)
    @test MOI.get(opt, MOI.Silent()) === nothing
    # Test with Silent => true
    model = cache()
    MOI.set(model, MOI.Silent(), true)
    opt = optimizer()
    model = MOI.Utilities.CachingOptimizer(model, opt)
    @test MOI.get(opt, MOI.Silent()) == true
    # Test with Silent => false
    model = cache()
    MOI.set(model, MOI.Silent(), false)
    opt = optimizer()
    model = MOI.Utilities.CachingOptimizer(model, opt)
    @test MOI.get(opt, MOI.Silent()) == false
    return
end

mutable struct FinalTouchDetector <: MOI.ModelLike
    index_map::Any
end

function MOI.Utilities.final_touch(model::FinalTouchDetector, index_map)
    model.index_map = index_map
    return
end

function MOI.copy_to(::MOI.Utilities.MockOptimizer, ::FinalTouchDetector)
    return MOI.Utilities.IndexMap()
end

function MOI.get(::FinalTouchDetector, ::MOI.ListOfOptimizerAttributesSet)
    return MOI.AbstractOptimizerAttribute[]
end

function MOI.get(::FinalTouchDetector, ::MOI.ListOfModelAttributesSet)
    return MOI.AbstractModelAttribute[]
end

function test_final_touch_optimize()
    model = MOI.Utilities.CachingOptimizer(
        FinalTouchDetector(missing),
        MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}()),
    )
    MOI.Utilities.attach_optimizer(model)
    @test model.model_cache.index_map === nothing
    MOI.Utilities.final_touch(model, missing)
    @test model.model_cache.index_map === missing
    MOI.Utilities.reset_optimizer(model)
    MOI.optimize!(model)
    @test model.model_cache.index_map === nothing
end

function test_multiple_modifications()
    m = MOIU.CachingOptimizer(MOIU.Model{Float64}(), MOIU.AUTOMATIC)

    x = MOI.add_variables(m, 3)

    saf = MOI.ScalarAffineFunction(
        [
            MOI.ScalarAffineTerm(1.0, x[1]),
            MOI.ScalarAffineTerm(1.0, x[2]),
            MOI.ScalarAffineTerm(1.0, x[3]),
        ],
        0.0,
    )
    ci1 = MOI.add_constraint(m, saf, MOI.LessThan(1.0))
    ci2 = MOI.add_constraint(m, saf, MOI.LessThan(2.0))

    MOI.set(m, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(), saf)

    fc1 = MOI.get(m, MOI.ConstraintFunction(), ci1)
    @test MOI.coefficient.(fc1.terms) == [1.0, 1.0, 1.0]
    fc2 = MOI.get(m, MOI.ConstraintFunction(), ci2)
    @test MOI.coefficient.(fc2.terms) == [1.0, 1.0, 1.0]
    obj = MOI.get(m, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}())
    @test MOI.coefficient.(obj.terms) == [1.0, 1.0, 1.0]

    changes_cis = [
        MOI.ScalarCoefficientChange(MOI.VariableIndex(1), 4.0)
        MOI.ScalarCoefficientChange(MOI.VariableIndex(1), 0.5)
        MOI.ScalarCoefficientChange(MOI.VariableIndex(3), 2.0)
    ]
    MOI.modify(m, [ci1, ci2, ci2], changes_cis)

    fc1 = MOI.get(m, MOI.ConstraintFunction(), ci1)
    @test MOI.coefficient.(fc1.terms) == [4.0, 1.0, 1.0]
    fc2 = MOI.get(m, MOI.ConstraintFunction(), ci2)
    @test MOI.coefficient.(fc2.terms) == [0.5, 1.0, 2.0]

    changes_obj = [
        MOI.ScalarCoefficientChange(MOI.VariableIndex(1), 4.0)
        MOI.ScalarCoefficientChange(MOI.VariableIndex(2), 10.0)
        MOI.ScalarCoefficientChange(MOI.VariableIndex(3), 2.0)
    ]
    MOI.modify(
        m,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        changes_obj,
    )

    obj = MOI.get(m, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}())
    @test MOI.coefficient.(obj.terms) == [4.0, 10.0, 2.0]
end

function test_show()
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: x, y
        minobjective: 2.0 * x
        c1: x >= 0.0
        c2: 1.0 * x + 2.0 * y <= 3.0
        c2: 1.0 * x + 3.0 * y <= 2.0
        """,
    )
    cache = MOI.Utilities.CachingOptimizer(model, MOI.Utilities.MANUAL)
    output = """
    MOIU.CachingOptimizer
    ├ state: NO_OPTIMIZER
    ├ mode: MANUAL
    ├ model_cache: MOIU.Model{Float64}
    │ ├ ObjectiveSense: MIN_SENSE
    │ ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
    │ ├ NumberOfVariables: 2
    │ └ NumberOfConstraints: 3
    │   ├ MOI.ScalarAffineFunction{Float64} in MOI.LessThan{Float64}: 2
    │   └ MOI.VariableIndex in MOI.GreaterThan{Float64}: 1
    └ optimizer: nothing"""
    @test sprint(show, cache) == output
    return
end

function test_add_variable()
    for mode in (MOI.Utilities.AUTOMATIC, MOI.Utilities.MANUAL)
        cache = MOI.Utilities.Model{Float64}()
        optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
        model = MOI.Utilities.CachingOptimizer(cache, mode)
        MOI.Utilities.reset_optimizer(model, optimizer)
        MOI.Utilities.attach_optimizer(model)
        x = MOI.add_variable(model)
        @test MOI.is_valid(optimizer, model.model_to_optimizer_map[x])
    end
    return
end

function test_add_variables()
    for mode in (MOI.Utilities.AUTOMATIC, MOI.Utilities.MANUAL)
        cache = MOI.Utilities.Model{Float64}()
        optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
        model = MOI.Utilities.CachingOptimizer(cache, mode)
        MOI.Utilities.reset_optimizer(model, optimizer)
        MOI.Utilities.attach_optimizer(model)
        x = MOI.add_variables(model, 2)
        for xi in x
            @test MOI.is_valid(optimizer, model.model_to_optimizer_map[xi])
        end
    end
    return
end

function test_add_constrained_variable()
    for mode in (MOI.Utilities.AUTOMATIC, MOI.Utilities.MANUAL)
        cache = MOI.Utilities.Model{Float64}()
        optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
        model = MOI.Utilities.CachingOptimizer(cache, mode)
        MOI.Utilities.reset_optimizer(model, optimizer)
        MOI.Utilities.attach_optimizer(model)
        x, c = MOI.add_constrained_variable(model, MOI.ZeroOne())
        @test MOI.is_valid(optimizer, model.model_to_optimizer_map[x])
        @test MOI.is_valid(optimizer, model.model_to_optimizer_map[c])
    end
    return
end

function test_add_constrained_variables()
    for mode in (MOI.Utilities.AUTOMATIC, MOI.Utilities.MANUAL)
        cache = MOI.Utilities.Model{Float64}()
        optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
        model = MOI.Utilities.CachingOptimizer(cache, mode)
        MOI.Utilities.reset_optimizer(model, optimizer)
        MOI.Utilities.attach_optimizer(model)
        x, c = MOI.add_constrained_variables(model, MOI.Zeros(2))
        for xi in x
            @test MOI.is_valid(optimizer, model.model_to_optimizer_map[xi])
        end
        @test MOI.is_valid(optimizer, model.model_to_optimizer_map[c])
    end
    return
end

function test_modify_constraint()
    for mode in (MOI.Utilities.AUTOMATIC, MOI.Utilities.MANUAL)
        cache = MOI.Utilities.Model{Float64}()
        optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
        model = MOI.Utilities.CachingOptimizer(cache, mode)
        MOI.Utilities.reset_optimizer(model, optimizer)
        MOI.Utilities.attach_optimizer(model)
        x = MOI.add_variable(model)
        c = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(1.0))
        c_opt = model.model_to_optimizer_map[c]
        f = MOI.get(optimizer, MOI.ConstraintFunction(), c_opt)
        @test f ≈ 1.0 * model.model_to_optimizer_map[x]
        MOI.modify(model, c, MOI.ScalarCoefficientChange(x, 2.0))
        c_opt = model.model_to_optimizer_map[c]
        f = MOI.get(optimizer, MOI.ConstraintFunction(), c_opt)
        @test f ≈ 2.0 * model.model_to_optimizer_map[x]
    end
    return
end

function test_modify_objective()
    for mode in (MOI.Utilities.AUTOMATIC, MOI.Utilities.MANUAL)
        cache = MOI.Utilities.Model{Float64}()
        optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
        model = MOI.Utilities.CachingOptimizer(cache, mode)
        MOI.Utilities.reset_optimizer(model, optimizer)
        MOI.Utilities.attach_optimizer(model)
        x = MOI.add_variable(model)
        f = 1.0 * x
        attr = MOI.ObjectiveFunction{typeof(f)}()
        MOI.set(model, attr, f)
        @test MOI.get(optimizer, attr) ≈ 1.0 * model.model_to_optimizer_map[x]
        MOI.modify(model, attr, MOI.ScalarCoefficientChange(x, 2.0))
        @test MOI.get(optimizer, attr) ≈ 2.0 * model.model_to_optimizer_map[x]
    end
    return
end

function test_delete_invalid_index()
    for mode in (MOI.Utilities.AUTOMATIC, MOI.Utilities.MANUAL)
        cache = MOI.Utilities.Model{Float64}()
        optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
        model = MOI.Utilities.CachingOptimizer(cache, mode)
        MOI.Utilities.reset_optimizer(model, optimizer)
        MOI.Utilities.attach_optimizer(model)
        x = MOI.add_variable(model)
        @test MOI.is_valid(optimizer, model.model_to_optimizer_map[x])
        MOI.delete(model, x)
        @test_throws(KeyError, model.model_to_optimizer_map[x])
        @test_throws(MOI.InvalidIndex, MOI.delete(model, x))
    end
    return
end

function test_delete_variables()
    for mode in (MOI.Utilities.AUTOMATIC, MOI.Utilities.MANUAL)
        cache = MOI.Utilities.Model{Float64}()
        optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
        model = MOI.Utilities.CachingOptimizer(cache, mode)
        MOI.Utilities.reset_optimizer(model, optimizer)
        MOI.Utilities.attach_optimizer(model)
        x, y = MOI.add_variables(model, 2)
        @test MOI.is_valid(optimizer, model.model_to_optimizer_map[x])
        @test MOI.is_valid(optimizer, model.model_to_optimizer_map[y])
        MOI.delete(model, [x])
        @test_throws KeyError model.model_to_optimizer_map[x]
        @test MOI.is_valid(optimizer, model.model_to_optimizer_map[y])
        @test_throws(MOI.InvalidIndex, MOI.delete(model, x))
    end
    return
end

function test_set_attribute()
    for mode in (MOI.Utilities.AUTOMATIC, MOI.Utilities.MANUAL)
        cache = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
        optimizer = MOI.Utilities.MockOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        )
        model = MOI.Utilities.CachingOptimizer(cache, mode)
        MOI.Utilities.reset_optimizer(model, optimizer)
        MOI.Utilities.attach_optimizer(model)
        x = MOI.add_variable(model)
        @test MOI.is_valid(optimizer, model.model_to_optimizer_map[x])
        attr = MOI.VariablePrimalStart()
        MOI.set(model, attr, x, 1.23)
        opt_attr = MOI.Utilities.AttributeFromOptimizer(attr)
        cache_attr = MOI.Utilities.AttributeFromModelCache(attr)
        @test MOI.get(model, opt_attr, x) == 1.23
        @test MOI.get(model, cache_attr, x) == 1.23
    end
    return
end

function test_get_AttributeFromOptimizer()
    cache = MOI.Utilities.Model{Float64}()
    optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Utilities.CachingOptimizer(cache, optimizer)
    x = MOI.add_variable(model)
    MOI.Utilities.attach_optimizer(model)
    attr = MOI.VariableName()
    optimizer_attr = MOI.Utilities.AttributeFromOptimizer(attr)
    @test MOI.supports(model, optimizer_attr, MOI.VariableIndex)
    MOI.set(model, optimizer_attr, x, "x")
    @test MOI.get(model, attr, x) == ""
    @test MOI.get(model, optimizer_attr, x) == "x"
    @test MOI.get(model, optimizer_attr, [x]) == ["x"]
    return
end

function test_get_AttributeFromModelCache()
    cache = MOI.Utilities.Model{Float64}()
    optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Utilities.CachingOptimizer(cache, optimizer)
    x = MOI.add_variable(model)
    MOI.Utilities.attach_optimizer(model)
    # VariableName
    attr = MOI.VariableName()
    cache_attr = MOI.Utilities.AttributeFromModelCache(attr)
    MOI.set(model, cache_attr, x, "x")
    @test MOI.supports(model, cache_attr, MOI.VariableIndex)
    @test MOI.get(model, attr, x) == "x"
    @test MOI.get(model, cache_attr, x) == "x"
    @test MOI.get(model, MOI.Utilities.AttributeFromOptimizer(attr), x) == ""
    # Name
    attr = MOI.Name()
    cache_attr = MOI.Utilities.AttributeFromModelCache(attr)
    MOI.set(model, cache_attr, "m")
    @test MOI.supports(model, cache_attr)
    @test MOI.get(model, attr) == "m"
    @test MOI.get(model, cache_attr) == "m"
    @test MOI.get(model, MOI.Utilities.AttributeFromOptimizer(attr)) == ""
    return
end

function test_copy_to_attached()
    cache = MOI.Utilities.Model{Float64}()
    optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Utilities.CachingOptimizer(cache, optimizer)
    x = MOI.add_variable(model)
    MOI.Utilities.attach_optimizer(model)
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(src)
    index_map = MOI.copy_to(model, src)
    @test model.state == MOI.Utilities.EMPTY_OPTIMIZER
    @test MOI.get(model.model_cache, MOI.NumberOfVariables()) == 1
    return
end

function test_add_variable_not_allowed()
    cache = MOI.Utilities.Model{Float64}()
    optimizer = MOI.Utilities.MockOptimizer(
        MOI.Utilities.Model{Float64}();
        add_var_allowed = false,
    )
    model = MOI.Utilities.CachingOptimizer(cache, optimizer)
    MOI.Utilities.attach_optimizer(model)
    @test model.state == MOI.Utilities.ATTACHED_OPTIMIZER
    x = MOI.add_variable(model)
    @test model.state == MOI.Utilities.EMPTY_OPTIMIZER
    @test MOI.get(model.model_cache, MOI.NumberOfVariables()) == 1
    return
end

function test_add_variables_not_allowed()
    cache = MOI.Utilities.Model{Float64}()
    optimizer = MOI.Utilities.MockOptimizer(
        MOI.Utilities.Model{Float64}();
        add_var_allowed = false,
    )
    model = MOI.Utilities.CachingOptimizer(cache, optimizer)
    MOI.Utilities.attach_optimizer(model)
    @test model.state == MOI.Utilities.ATTACHED_OPTIMIZER
    x = MOI.add_variables(model, 2)
    @test model.state == MOI.Utilities.EMPTY_OPTIMIZER
    @test MOI.get(model.model_cache, MOI.NumberOfVariables()) == 2
    return
end

function test_add_constrained_variable_not_allowed()
    cache = MOI.Utilities.Model{Float64}()
    optimizer = MOI.Utilities.MockOptimizer(
        MOI.Utilities.Model{Float64}();
        add_var_allowed = false,
    )
    model = MOI.Utilities.CachingOptimizer(cache, optimizer)
    MOI.Utilities.attach_optimizer(model)
    @test model.state == MOI.Utilities.ATTACHED_OPTIMIZER
    x, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
    @test model.state == MOI.Utilities.EMPTY_OPTIMIZER
    @test MOI.get(model.model_cache, MOI.NumberOfVariables()) == 1
    return
end

function test_add_constrained_variables_not_allowed()
    cache = MOI.Utilities.Model{Float64}()
    optimizer = MOI.Utilities.MockOptimizer(
        MOI.Utilities.Model{Float64}();
        add_var_allowed = false,
    )
    model = MOI.Utilities.CachingOptimizer(cache, optimizer)
    MOI.Utilities.attach_optimizer(model)
    @test model.state == MOI.Utilities.ATTACHED_OPTIMIZER
    x, _ = MOI.add_constrained_variables(model, MOI.Zeros(2))
    @test model.state == MOI.Utilities.EMPTY_OPTIMIZER
    @test MOI.get(model.model_cache, MOI.NumberOfVariables()) == 2
    return
end

function test_delete_not_allowed()
    cache = MOI.Utilities.Model{Float64}()
    optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    optimizer.delete_allowed = false
    model = MOI.Utilities.CachingOptimizer(cache, optimizer)
    MOI.Utilities.attach_optimizer(model)
    @test model.state == MOI.Utilities.ATTACHED_OPTIMIZER
    x, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
    @test model.state == MOI.Utilities.ATTACHED_OPTIMIZER
    MOI.delete(model, [x])
    @test model.state == MOI.Utilities.EMPTY_OPTIMIZER
    @test MOI.get(model.model_cache, MOI.NumberOfVariables()) == 0
    return
end

function test_pass_nonvariable_constraints()
    cache = MOI.Utilities.Model{Float64}()
    optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    dest = MOI.Utilities.CachingOptimizer(cache, optimizer)
    MOI.Utilities.attach_optimizer(dest)
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(src)
    MOI.add_constraint(src, 1.0 * x, MOI.GreaterThan(1.0))
    index_map = MOI.Utilities.default_copy_to(dest, src)
    @test sprint(print, dest) == sprint(print, src)
    return
end

function test_optimize_abstract_callback()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    optimizer = MOI.Utilities.MockOptimizer(inner)
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        optimizer,
    )
    x, _ = MOI.add_constrained_variable(model, MOI.Integer())
    function callback_fn(cb_data)
        _ = MOI.submit(model, MOI.HeuristicSolution(cb_data), [x], [1.0])
        return
    end
    MOI.set(model, MOI.HeuristicCallback(), callback_fn)
    MOI.optimize!(model)
    @test model.state == MOI.Utilities.ATTACHED_OPTIMIZER
    @test optimizer.optimize_called
    return
end

struct ErrorOnSetAttributeModel <: MOI.ModelLike end

MOI.is_empty(::ErrorOnSetAttributeModel) = true

function MOI.copy_to(::ErrorOnSetAttributeModel, src::MOI.ModelLike)
    return MOI.Utilities.identity_index_map(src)
end

function MOI.set(
    ::ErrorOnSetAttributeModel,
    ::MOI.ObjectiveSense,
    ::MOI.OptimizationSense,
)
    return error("Something other than unsupported model attribute")
end

function MOI.set(
    ::ErrorOnSetAttributeModel,
    ::MOI.VariablePrimalStart,
    ::MOI.VariableIndex,
    ::Float64,
)
    return error("Something other than unsupported variable attribute")
end

function test_rethrow_set_model_attribute()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        ErrorOnSetAttributeModel(),
    )
    x = MOI.add_variable(model)
    MOI.Utilities.attach_optimizer(model)
    @test_throws(
        ErrorException("Something other than unsupported model attribute"),
        MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE),
    )
    @test_throws(
        ErrorException("Something other than unsupported variable attribute"),
        MOI.set(model, MOI.VariablePrimalStart(), x, 1.0),
    )
    return
end

end  # module

TestCachingOptimizer.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

struct NormSpecialCaseBridge{S,T,F} <: SetMapBridge{T,MOI.NormCone,S,F,F}
    constraint::MOI.ConstraintIndex{F,MOI.NormCone}
end

MOI.Bridges.map_function(::Type{<:NormSpecialCaseBridge}, f) = f

MOI.Bridges.inverse_map_function(::Type{<:NormSpecialCaseBridge}, f) = f

MOI.Bridges.adjoint_map_function(::Type{<:NormSpecialCaseBridge}, f) = f

MOI.Bridges.inverse_adjoint_map_function(::Type{<:NormSpecialCaseBridge}, f) = f

function MOI.Bridges.map_set(
    ::Type{<:NormSpecialCaseBridge{S}},
    set::S,
) where {S}
    return MOI.NormCone(set)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:NormSpecialCaseBridge{S}},
    set::MOI.NormCone,
) where {S}
    return S(MOI.dimension(set))
end

function concrete_bridge_type(
    ::Type{<:NormSpecialCaseBridge{S,T}},
    F::Type{<:MOI.AbstractVectorFunction},
    ::Type{S},
) where {T,S<:Union{MOI.NormOneCone,MOI.SecondOrderCone,MOI.NormInfinityCone}}
    return NormSpecialCaseBridge{S,T,F}
end

"""
    NormOneConeToNormConeBridge{T,F} <: Bridges.Constraint.AbstractBridge

`NormOneConeToNormConeBridge` implements the following reformulations:

  * ``(t, x) in NormOneCone(d)`` into ``(t, x) in NormCone(1, d)``

## Source node

`NormOneConeToNormConeBridge` supports:

  * `F` in [`MOI.NormOneCone`](@ref)

## Target nodes

`NormOneConeToNormConeBridge` creates:

  * `F` in [`MOI.NormCone`](@ref)
"""
const NormOneConeToNormConeBridge{T,F} =
    NormSpecialCaseBridge{MOI.NormOneCone,T,F}

const NormOneConeToNormCone{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NormOneConeToNormConeBridge{T},OT}

"""
    SecondOrderConeToNormConeBridge{T,F} <: Bridges.Constraint.AbstractBridge

`SecondOrderConeToNormConeBridge` implements the following reformulations:

  * ``(t, x) in SecondOrderCone(d)`` into ``(t, x) in NormCone(2, d)``

## Source node

`SecondOrderConeToNormConeBridge` supports:

  * `F` in [`MOI.SecondOrderCone`](@ref)

## Target nodes

`SecondOrderConeToNormConeBridge` creates:

  * `F` in [`MOI.NormCone`](@ref)
"""
const SecondOrderConeToNormConeBridge{T,F} =
    NormSpecialCaseBridge{MOI.SecondOrderCone,T,F}

const SecondOrderConeToNormCone{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SecondOrderConeToNormConeBridge{T},OT}

"""
    NormInfinityConeToNormConeBridge{T,F} <: Bridges.Constraint.AbstractBridge

`NormInfinityConeToNormConeBridge` implements the following reformulations:

  * ``(t, x) in NormInfinityCone(d)`` into ``(t, x) in NormCone(Inf, d)``

## Source node

`NormInfinityConeToNormConeBridge` supports:

  * `F` in [`MOI.NormInfinityCone`](@ref)

## Target nodes

`NormInfinityConeToNormConeBridge` creates:

  * `F` in [`MOI.NormCone`](@ref)
"""
const NormInfinityConeToNormConeBridge{T,F} =
    NormSpecialCaseBridge{MOI.NormInfinityCone,T,F}

const NormInfinityConeToNormCone{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NormInfinityConeToNormConeBridge{T},OT}

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

import Clp
import GLPK
import MathOptInterface as MOI

function example_diet(optimizer, bridge)
    category_data = [
        1800.0 2200.0
        91.0 Inf
        0.0 65.0
        0.0 1779.0
    ]
    cost = [2.49, 2.89, 1.50, 1.89, 2.09, 1.99, 2.49, 0.89, 1.59]
    food_data = [
        410 24 26 730
        420 32 10 1190
        560 20 32 1800
        380 4 19 270
        320 12 10 930
        320 15 12 820
        320 31 12 1230
        100 8 2.5 125
        330 8 10 180
    ]
    bridge_model = if bridge
        MOI.instantiate(optimizer; with_bridge_type = Float64)
    else
        MOI.instantiate(optimizer)
    end
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        MOI.Utilities.AUTOMATIC,
    )
    MOI.Utilities.reset_optimizer(model, bridge_model)
    MOI.set(model, MOI.Silent(), true)
    nutrition = MOI.add_variables(model, size(category_data, 1))
    for (i, v) in enumerate(nutrition)
        MOI.add_constraint(model, v, MOI.GreaterThan(category_data[i, 1]))
        MOI.add_constraint(model, v, MOI.LessThan(category_data[i, 2]))
    end
    buy = MOI.add_variables(model, size(food_data, 1))
    MOI.add_constraint.(model, buy, MOI.GreaterThan(0.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(cost, buy), 0.0)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    for (j, n) in enumerate(nutrition)
        f = MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(food_data[:, j], buy),
            0.0,
        )
        push!(f.terms, MOI.ScalarAffineTerm(-1.0, n))
        MOI.add_constraint(model, f, MOI.EqualTo(0.0))
    end
    MOI.optimize!(model)
    term_status = MOI.get(model, MOI.TerminationStatus())
    @assert term_status == MOI.OPTIMAL
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(1.0, [buy[end-1], buy[end]]),
            0.0,
        ),
        MOI.LessThan(6.0),
    )
    MOI.optimize!(model)
    @assert MOI.get(model, MOI.TerminationStatus()) == MOI.INFEASIBLE
    return
end

if length(ARGS) > 0
    bridge = get(ARGS, 2, "") != "--no-bridge"
    println("Running: $(ARGS[1]) $(get(ARGS, 2, ""))")
    if ARGS[1] == "clp"
        @time example_diet(Clp.Optimizer, bridge)
        @time example_diet(Clp.Optimizer, bridge)
    else
        @assert ARGS[1] == "glpk"
        @time example_diet(GLPK.Optimizer, bridge)
        @time example_diet(GLPK.Optimizer, bridge)
    end
    exit(0)
end

# using SnoopCompileCore
# tinf = @snoopi_deep example_diet(Clp.Optimizer, true)
# using SnoopCompile, ProfileView
# fg = flamegraph(tinf)
# ProfileView.view(fg)

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

function print_node(io::IO, b::LazyBridgeOptimizer, node::VariableNode)
    S, = b.variable_types[node.index]
    MOI.Utilities.print_with_acronym(
        io,
        "[$(node.index)] constrained variables in `$S` are",
    )
    return
end

function print_node(io::IO, b::LazyBridgeOptimizer, node::ConstraintNode)
    F, S = b.constraint_types[node.index]
    MOI.Utilities.print_with_acronym(
        io,
        "($(node.index)) `$F`-in-`$S` constraints are",
    )
    return
end

function print_node(io::IO, b::LazyBridgeOptimizer, node::ObjectiveNode)
    F, = b.objective_types[node.index]
    MOI.Utilities.print_with_acronym(
        io,
        "|$(node.index)| objective function of type `$F` is",
    )
    return
end

function print_node_info(
    io::IO,
    b::LazyBridgeOptimizer,
    node::AbstractNode;
    debug_unsupported = false,
)
    print(io, " ")
    print_node(io, b, node)
    d = _dist(b.graph, node)
    if d == INFINITY
        print(io, " not supported")
        if debug_unsupported
            print(io, " because")
            print_unsupported(io, b, node)
        else
            println(io)
        end
    else
        index = bridge_index(b.graph, node)
        if iszero(index) ||
           (node isa VariableNode && !is_variable_edge_best(b.graph, node))
            @assert node isa VariableNode
            dist = isinteger(d) ? round(Int, d) : d
            println(
                io,
                " supported (distance $dist) by adding free variables and then constrain them, see ($(b.graph.variable_constraint_node[node.index].index)).",
            )
        else
            dist = isinteger(d) ? round(Int, d) : d
            print(io, " bridged (distance $dist) by ")
            MOI.Utilities.print_with_acronym(
                io,
                string(_bridge_type(b, node, index)),
            )
            println(io, ".")
        end
    end
    return
end

function print_graph(b::LazyBridgeOptimizer; kwargs...)
    print_graph(Base.stdout, b; kwargs...)
    return
end

"""
    print_graph([io::IO = stdout,] b::LazyBridgeOptimizer)

Print the hyper-graph containing all variable, constraint, and objective types
that could be obtained by bridging the variables, constraints, and objectives
that are present in the model by all the bridges added to `b`.

Each node in the hyper-graph corresponds to a variable, constraint, or objective
type.

 * Variable nodes are indicated by `[ ]`
 * Constraint nodes are indicated by `( )`
 * Objective nodes are indicated by `| |`

The number inside each pair of brackets is an index of the node in the
hyper-graph.

Note that this hyper-graph is the full list of possible transformations. When
the bridged model is created, we select the shortest hyper-path from this
graph, so many nodes may be un-used.

To see which nodes are used, call [`print_active_bridges`](@ref).

For more information, see Legat, B., Dowson, O., Garcia, J., and Lubin, M.
(2020).  "MathOptInterface: a data structure for mathematical optimization
problems." [URL](https://arXiv.org/abs/2002.03447)
"""
function print_graph(io::IO, b::LazyBridgeOptimizer; kwargs...)
    println(io, b.graph)
    print_nodes(
        io,
        b,
        VariableNode.(eachindex(b.graph.variable_best)),
        ConstraintNode.(eachindex(b.graph.constraint_best)),
        ObjectiveNode.(eachindex(b.graph.objective_best));
        kwargs...,
    )
    return
end

function print_nodes(
    io::IO,
    b::LazyBridgeOptimizer,
    variable_nodes,
    constraint_nodes,
    objective_nodes;
    kwargs...,
)
    for node in variable_nodes
        print_node_info(io, b, node; kwargs...)
    end
    for node in constraint_nodes
        print_node_info(io, b, node; kwargs...)
    end
    for node in objective_nodes
        print_node_info(io, b, node; kwargs...)
    end
    return
end

function print_if_unsupported(
    io::IO,
    b::LazyBridgeOptimizer,
    node::AbstractNode,
)
    if _dist(b.graph, node) != INFINITY
        return
    end
    print(io, "   ")
    print_node(io, b, node)
    print(io, " not supported\n")
    return
end

function print_unsupported(io::IO, b::LazyBridgeOptimizer, edge::Edge)
    for node in edge.added_variables
        print_if_unsupported(io, b, node)
    end
    for node in edge.added_constraints
        print_if_unsupported(io, b, node)
    end
    return
end

function print_unsupported(io::IO, b::LazyBridgeOptimizer, edge::ObjectiveEdge)
    for node in edge.added_variables
        print_if_unsupported(io, b, node)
    end
    for node in edge.added_constraints
        print_if_unsupported(io, b, node)
    end
    print_if_unsupported(io, b, edge.added_objective)
    return
end

function print_unsupported(
    io::IO,
    b::LazyBridgeOptimizer,
    edges::Vector,
    index_to_bridge::Function,
)
    no_bridge = true
    for edge in edges
        if no_bridge
            println(io, ":")
            no_bridge = false
        end
        MOI.Utilities.print_with_acronym(
            io,
            "   Cannot use `$(index_to_bridge(edge.bridge_index))` because:\n",
        )
        print_unsupported(io, b, edge)
    end
    if no_bridge
        println(io, " no added bridge supports bridging it.")
    end
    return
end

function _bridge_type(
    b::LazyBridgeOptimizer,
    node::VariableNode,
    bridge_index::Int,
)
    return Variable.concrete_bridge_type(
        b.variable_bridge_types[bridge_index],
        b.variable_types[node.index]...,
    )
end

function _bridge_type(
    b::LazyBridgeOptimizer,
    node::ConstraintNode,
    bridge_index::Int,
)
    return Constraint.concrete_bridge_type(
        b.constraint_bridge_types[bridge_index],
        b.constraint_types[node.index]...,
    )
end

function _bridge_type(
    b::LazyBridgeOptimizer,
    node::ObjectiveNode,
    bridge_index::Int,
)
    return Objective.concrete_bridge_type(
        b.objective_bridge_types[bridge_index],
        b.objective_types[node.index]...,
    )
end

function print_unsupported(io::IO, b::LazyBridgeOptimizer, node::VariableNode)
    print_unsupported(
        io,
        b,
        b.graph.variable_edges[node.index],
        bridge_index -> _bridge_type(b, node, bridge_index),
    )
    if b.variable_types[node.index] == (MOI.Reals,)
        return
    end
    print(io, "   Cannot add free variables and then constrain them because")
    constraint_node = b.graph.variable_constraint_node[node.index]
    if constraint_node.index == -1
        println(
            io,
            " free variables are bridged but no functionize bridge was added.",
        )
    else
        println(io, ":")
        print_if_unsupported(io, b, constraint_node)
    end
    return
end

function print_unsupported(io::IO, b::LazyBridgeOptimizer, node::ConstraintNode)
    print_unsupported(
        io,
        b,
        b.graph.constraint_edges[node.index],
        bridge_index -> _bridge_type(b, node, bridge_index),
    )
    return
end

function print_unsupported(io::IO, b::LazyBridgeOptimizer, node::ObjectiveNode)
    print_unsupported(
        io,
        b,
        b.graph.objective_edges[node.index],
        bridge_index -> _bridge_type(b, node, bridge_index),
    )
    return
end

function add_unsupported(
    graph::Graph,
    edges::Vector{Edge},
    variables,
    constraints,
    objectives,
)
    for edge in edges
        for node in edge.added_variables
            add_unsupported(graph, node, variables, constraints, objectives)
        end
        for node in edge.added_constraints
            add_unsupported(graph, node, variables, constraints, objectives)
        end
    end
    return
end

function add_unsupported(
    graph::Graph,
    edges::Vector{ObjectiveEdge},
    variables,
    constraints,
    objectives,
)
    for edge in edges
        for node in edge.added_variables
            add_unsupported(graph, node, variables, constraints, objectives)
        end
        for node in edge.added_constraints
            add_unsupported(graph, node, variables, constraints, objectives)
        end
        add_unsupported(
            graph,
            edge.added_objective,
            variables,
            constraints,
            objectives,
        )
    end
    return
end

function add_unsupported(
    graph::Graph,
    node::VariableNode,
    variables,
    constraints,
    objectives,
)
    if _dist(graph, node) != INFINITY || node in variables
        return
    end
    push!(variables, node)
    add_unsupported(
        graph,
        graph.variable_edges[node.index],
        variables,
        constraints,
        objectives,
    )
    constraint_node = graph.variable_constraint_node[node.index]
    if constraint_node.index != -1
        add_unsupported(
            graph,
            graph.variable_constraint_node[node.index],
            variables,
            constraints,
            objectives,
        )
    end
    return
end

function add_unsupported(
    graph::Graph,
    node::ConstraintNode,
    variables,
    constraints,
    objectives,
)
    if _dist(graph, node) != INFINITY || node in constraints
        return
    end
    push!(constraints, node)
    add_unsupported(
        graph,
        graph.constraint_edges[node.index],
        variables,
        constraints,
        objectives,
    )
    return
end

function add_unsupported(
    graph::Graph,
    node::ObjectiveNode,
    variables,
    constraints,
    objectives,
)
    if _dist(graph, node) != INFINITY || node in objectives
        return
    end
    push!(objectives, node)
    add_unsupported(
        graph,
        graph.objective_edges[node.index],
        variables,
        constraints,
        objectives,
    )
    return
end

function _sort(nodes::Set)
    vector = collect(nodes)
    sort!(vector, by = node -> node.index)
    return vector
end

function debug_unsupported(io::IO, b::LazyBridgeOptimizer, node::AbstractNode)
    variables = Set{VariableNode}()
    constraints = Set{ConstraintNode}()
    objectives = Set{ObjectiveNode}()
    add_unsupported(b.graph, node, variables, constraints, objectives)
    print_nodes(
        io,
        b,
        _sort(variables),
        _sort(constraints),
        _sort(objectives),
        debug_unsupported = true,
    )
    return
end

const UNSUPPORTED_MESSAGE =
    " are not supported and cannot be bridged into supported" *
    " constrained variables and constraints. See details below:"

function debug(
    b::LazyBridgeOptimizer,
    S::Type{<:MOI.AbstractSet};
    io::IO = Base.stdout,
)
    if (
        S <: MOI.AbstractScalarSet &&
        MOI.supports_add_constrained_variable(b, S)
    ) || (
        S <: MOI.AbstractVectorSet &&
        MOI.supports_add_constrained_variables(b, S)
    )
        MOI.Utilities.print_with_acronym(
            io,
            "Constrained variables in `$S` are supported.\n",
        )
    else
        MOI.Utilities.print_with_acronym(io, "Constrained variables in `$S`")
        println(io, UNSUPPORTED_MESSAGE)
        debug_unsupported(io, b, node(b, S))
    end
    return
end

"""
    debug_supports_add_constrained_variable(
        b::LazyBridgeOptimizer,
        S::Type{<:MOI.AbstractSet};
        io::IO = Base.stdout
    )

Prints to `io` explanations for the value of
[`MOI.supports_add_constrained_variable`](@ref) with the same arguments.
"""
function debug_supports_add_constrained_variable(
    b::LazyBridgeOptimizer,
    S::Type{<:MOI.AbstractSet};
    kwargs...,
)
    debug(b, S; kwargs...)
    return
end

function debug(
    b::LazyBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet};
    io::IO = Base.stdout,
)
    if MOI.supports_constraint(b, F, S)
        MOI.Utilities.print_with_acronym(
            io,
            "`$F`-in-`$S` constraints are supported.\n",
        )
    else
        MOI.Utilities.print_with_acronym(io, "`$F`-in-`$S` constraints")
        println(io, UNSUPPORTED_MESSAGE)
        debug_unsupported(io, b, node(b, F, S))
    end
    return
end

"""
    debug_supports_constraint(
        b::LazyBridgeOptimizer,
        F::Type{<:MOI.AbstractFunction},
        S::Type{<:MOI.AbstractSet};
        io::IO = Base.stdout,
    )

Prints to `io` explanations for the value of [`MOI.supports_constraint`](@ref)
with the same arguments.
"""
function debug_supports_constraint(
    b::LazyBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet};
    kwargs...,
)
    return debug(b, F, S; kwargs...)
end

function debug(
    b::LazyBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction};
    io::IO = Base.stdout,
)
    MOI.Utilities.print_with_acronym(io, "Objective function of type `$F` is")
    if supports_bridging_objective_function(b, F)
        MOI.Utilities.print_with_acronym(io, " supported.\n")
    else
        MOI.Utilities.print_with_acronym(
            io,
            " not supported and cannot be bridged" *
            " into a supported objective function by adding only supported" *
            " constrained variables and constraints. See details below:\n",
        )
        debug_unsupported(io, b, node(b, F))
    end
    return
end

"""
    debug_supports(
        b::LazyBridgeOptimizer,
        ::MOI.ObjectiveFunction{F};
        io::IO = Base.stdout,
    ) where F

Prints to `io` explanations for the value of [`MOI.supports`](@ref) with the
same arguments.
"""
function debug_supports(
    b::LazyBridgeOptimizer,
    ::MOI.ObjectiveFunction{F};
    kwargs...,
) where {F}
    debug(b, F; kwargs...)
    return
end

"""
    print_active_bridges([io::IO=stdout,] b::MOI.Bridges.LazyBridgeOptimizer)

Print the set of bridges that are active in the model `b`.
"""
function print_active_bridges(io::IO, b::MOI.Bridges.LazyBridgeOptimizer)
    F = MOI.get(b, MOI.ObjectiveFunctionType())
    print_active_bridges(io, b, F)
    types = MOI.get(b, MOI.ListOfConstraintTypesPresent())
    # We add a sort here to make the order reproducible, and to group similar
    # constraints together.
    for (F, S) in sort(types; by = string)
        print_active_bridges(io, b, F, S)
    end
    return
end

function print_active_bridges(b::MOI.Bridges.LazyBridgeOptimizer, args...)
    return print_active_bridges(stdout, b, args...)
end

function _print_supported(io, arg...)
    s = sprint(MOI.Utilities.print_with_acronym, arg...)
    return Printf.printstyled(io, s; bold = false, color = :green)
end

function _print_unsupported(io, arg...)
    s = sprint(MOI.Utilities.print_with_acronym, arg...)
    return Printf.printstyled(io, s; bold = false, color = :red)
end

function _print_bridge(io, b, ::Type{BT}, offset) where {BT}
    new_offset = offset * " |  "
    for (F, S) in MOI.Bridges.added_constraint_types(BT)
        print_active_bridges(io, b, F, S, new_offset)
    end
    for (S,) in MOI.Bridges.added_constrained_variable_types(BT)
        print_active_bridges(io, b, S, new_offset)
    end
    return
end

"""
    print_active_bridges(
        [io::IO=stdout,]
        b::MOI.Bridges.LazyBridgeOptimizer,
        F::Type{<:MOI.AbstractFunction}
    )

Print the set of bridges required for an objective function of type `F`.
"""
function print_active_bridges(
    io::IO,
    b::MOI.Bridges.LazyBridgeOptimizer,
    ::Type{F},
    offset::String = "",
) where {F<:MOI.AbstractFunction}
    if !MOI.supports(b, MOI.ObjectiveFunction{F}())
        throw(
            MOI.UnsupportedAttribute(
                MOI.ObjectiveFunction{F}(),
                "The objective function cannot be bridged using the set of " *
                "available bridges.",
            ),
        )
    end
    if !MOI.Bridges.is_bridged(b, F)
        print(io, offset, " * ")
        _print_supported(io, "Supported objective: $F\n")
        return
    end
    print(io, offset, " * ")
    _print_unsupported(io, "Unsupported objective: $F\n")
    index = MOI.Bridges.bridge_index(b.graph, b.objective_node[(F,)])
    B = b.objective_bridge_types[index]
    BT = MOI.Bridges.Objective.concrete_bridge_type(B, F)
    println(io, offset, " |  bridged by:")
    print(io, offset, " |   ")
    MOI.Utilities.print_with_acronym(io, "$BT\n")
    println(io, offset, " |  may introduce:")
    G = MOI.Bridges.set_objective_function_type(BT)
    print_active_bridges(io, b, G, offset * " |  ")
    _print_bridge(io, b, BT, offset)
    return
end

"""
    print_active_bridges(
        [io::IO=stdout,]
        b::MOI.Bridges.LazyBridgeOptimizer,
        F::Type{<:MOI.AbstractFunction},
        S::Type{<:MOI.AbstractSet},
    )

Print the set of bridges required for a constraint of type `F`-in-`S`.
"""
function print_active_bridges(
    io::IO,
    b::MOI.Bridges.LazyBridgeOptimizer,
    ::Type{F},
    ::Type{S},
    offset::String = "",
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    if !MOI.supports_constraint(b, F, S)
        throw(
            MOI.UnsupportedConstraint{F,S}(
                "The constraint cannot be bridged using the set of available " *
                "bridges.",
            ),
        )
    end
    if !MOI.Bridges.is_bridged(b, F, S)
        print(io, offset, " * ")
        _print_supported(io, "Supported constraint: $F-in-$S\n")
        return
    end
    is_constraint_bridged = true
    c_node = b.constraint_node[(F, S)]
    if F == MOI.VariableIndex || F == MOI.VectorOfVariables
        # Call `MOI.supports_` here to build the necessary nodes in the bridging
        # graph.
        if F == MOI.VariableIndex
            MOI.supports_add_constrained_variable(b, S)
        else
            MOI.supports_add_constrained_variables(b, S)
        end
        v_node = b.variable_node[(S,)]
        if bridging_cost(b.graph, v_node) <= bridging_cost(b.graph, c_node)
            is_constraint_bridged = false
        end
    end
    if is_constraint_bridged
        index = MOI.Bridges.bridge_index(b.graph, c_node)
        B = b.constraint_bridge_types[index]
        BT = MOI.Bridges.Constraint.concrete_bridge_type(B, F, S)
        print(io, offset, " * ")
        _print_unsupported(io, "Unsupported constraint: $F-in-$S\n")
        println(io, offset, " |  bridged by:")
        print(io, offset, " |   ")
        MOI.Utilities.print_with_acronym(io, "$BT\n")
        println(io, offset, " |  may introduce:")
        _print_bridge(io, b, BT, offset)
    else
        print_active_bridges(io, b, S, offset)
    end
    return
end

"""
    print_active_bridges(
        [io::IO=stdout,]
        b::MOI.Bridges.LazyBridgeOptimizer,
        S::Type{<:MOI.AbstractSet}
    )

Print the set of bridges required for a variable constrained to set `S`.
"""
function print_active_bridges(
    io::IO,
    b::MOI.Bridges.LazyBridgeOptimizer,
    ::Type{S},
    offset::String = "",
) where {S<:MOI.AbstractSet}
    if S <: MOI.AbstractScalarSet
        if !MOI.supports_add_constrained_variable(b, S)
            throw(
                MOI.UnsupportedConstraint{MOI.VariableIndex,S}(
                    "The variable cannot be bridged using the set of " *
                    "available bridges.",
                ),
            )
        end
    else
        @assert S <: MOI.AbstractVectorSet
        if !MOI.supports_add_constrained_variables(b, S)
            throw(
                MOI.UnsupportedConstraint{MOI.VectorOfVariables,S}(
                    "The variables cannot be bridged using the set of " *
                    "available bridges.",
                ),
            )
        end
    end
    if !MOI.Bridges.is_bridged(b, S)
        print(io, offset, " * ")
        _print_supported(io, "Supported variable: $S\n")
        return
    end
    if MOI.Bridges.is_variable_edge_best(b.graph, b.variable_node[(S,)])
        index = MOI.Bridges.bridge_index(b.graph, b.variable_node[(S,)])
        B = b.variable_bridge_types[index]
        BT = MOI.Bridges.Variable.concrete_bridge_type(B, S)
        print(io, offset, " * ")
        _print_unsupported(io, "Unsupported variable: $S\n")
        println(io, offset, " |  bridged by:")
        print(io, offset, " |    ")
        MOI.Utilities.print_with_acronym(io, "$BT\n")
        println(io, offset, " |  may introduce:")
        _print_bridge(io, b, BT, offset)
    else
        print(io, offset, " * ")
        _print_unsupported(io, "Unsupported variable: $S\n")
        println(io, offset, " |  adding as constraint:")
        offset = offset * " |  "
        MOI.Bridges.print_active_bridges(io, b, MOI.Reals, offset)
        F = MOI.Utilities.variable_function_type(S)
        MOI.Bridges.print_active_bridges(io, b, F, S, offset)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestModel

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

###
### Test helpers
###

"""
    TestExternalModel

We need to define this in a module at the top level because it can't be
defined in a testset. If it runs without error, then we're okay.
"""
module TestExternalModel

import MathOptInterface as MOI

struct NewSet <: MOI.AbstractScalarSet end

struct NewFunction <: MOI.AbstractScalarFunction end

MOI.Utilities.canonicalize!(f::NewFunction) = f

Base.copy(::NewFunction) = NewFunction()

Base.copy(::NewSet) = NewSet()

MOI.Utilities.@model(
    ExternalModel,
    (MOI.ZeroOne, NewSet),
    (),
    (),
    (),
    (NewFunction,),
    (MOI.ScalarAffineFunction,),
    (),
    (),
)

MOI.Utilities.@model(
    ExternalOptimizer,
    (MOI.ZeroOne, NewSet),
    (),
    (),
    (),
    (NewFunction,),
    (),
    (),
    (),
    true,
)

end

struct DummyFunction <: MOI.AbstractScalarFunction end

struct DummySet <: MOI.AbstractScalarSet end

# We create a new function and set to test catching errors if users create their
# own sets and functions
struct FunctionNotSupportedBySolvers <: MOI.AbstractScalarFunction
    x::MOI.VariableIndex
end

struct SetNotSupportedBySolvers <: MOI.AbstractSet end

###
### The tests start here.
###

function test_MOI_Test()
    MOI.Test.runtests(
        MOI.Utilities.Model{Float64}(),
        MOI.Test.Config(exclude = Any[MOI.optimize!,]),
    )
    return
end

function test_TestExternalModel_fields()
    @test isdefined(TestExternalModel, :ExternalModelScalarConstraints)
    @test !isdefined(TestExternalModel, :ExternalModelVectorConstraints)
    @test isdefined(TestExternalModel, :ExternalModelFunctionConstraints)
    @test isdefined(TestExternalModel, :ExternalOptimizerScalarConstraints)
    @test !isdefined(TestExternalModel, :ExternalOptimizerVectorConstraints)
    @test !isdefined(TestExternalModel, :ExternalOptimizerFunctionConstraints)
    @test TestExternalModel.ExternalModel{Int} == MOI.Utilities.GenericModel{
        Int,
        MOI.Utilities.ObjectiveContainer{Int},
        MOI.Utilities.VariablesContainer{Int},
        TestExternalModel.ExternalModelFunctionConstraints{Int},
    }
    model = MOI.Utilities.GenericOptimizer{
        Int,
        MOI.Utilities.ObjectiveContainer{Int},
        MOI.Utilities.VariablesContainer{Int},
        TestExternalModel.ExternalOptimizerScalarConstraints{
            Int,
            MOI.Utilities.VectorOfConstraints{
                TestExternalModel.NewFunction,
                MOI.ZeroOne,
            },
            MOI.Utilities.VectorOfConstraints{
                TestExternalModel.NewFunction,
                TestExternalModel.NewSet,
            },
        },
    }
    @test TestExternalModel.ExternalOptimizer{Int} == model

    return
end

function test_TestExternalModel_supertypes()
    model = TestExternalModel.ExternalModel{Float64}()
    optimizer = TestExternalModel.ExternalOptimizer{Float64}()
    @test isa(model, MOI.Utilities.AbstractModelLike{Float64})
    @test !isa(model, MOI.Utilities.AbstractOptimizer{Float64})
    @test !isa(model, MOI.AbstractOptimizer)
    @test !isa(optimizer, MOI.Utilities.AbstractModelLike{Float64})
    @test isa(optimizer, MOI.Utilities.AbstractOptimizer{Float64})
    @test isa(optimizer, MOI.AbstractOptimizer)
    return
end

function test_TestExternalModel()
    model = TestExternalModel.ExternalModel{Float64}()
    c = MOI.add_constraint(
        model,
        TestExternalModel.NewFunction(),
        TestExternalModel.NewSet(),
    )
    @test typeof(c) == MOI.ConstraintIndex{
        TestExternalModel.NewFunction,
        TestExternalModel.NewSet,
    }
    c2 = MOI.add_constraint(
        model,
        TestExternalModel.NewFunction(),
        MOI.ZeroOne(),
    )
    @test typeof(c2) ==
          MOI.ConstraintIndex{TestExternalModel.NewFunction,MOI.ZeroOne}
    return
end

function _test_ObjectiveFunction(T)
    model = MOI.Utilities.Model{T}()
    @test !MOI.supports(model, MOI.ObjectiveFunction{DummyFunction}())
    for F in [
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    ]
        @test MOI.supports(model, MOI.ObjectiveFunction{F}())
    end
    U = Float32
    for F in [MOI.ScalarAffineFunction{U}, MOI.ScalarQuadraticFunction{U}]
        @test !MOI.supports(model, MOI.ObjectiveFunction{F}())
    end
    return
end

function test_ObjectiveFunction()
    _test_ObjectiveFunction(Float64)
    _test_ObjectiveFunction(Int)
    return
end

function _test_VariableIndex(T)
    model = MOI.Utilities.Model{T}()
    @test !MOI.supports_constraint(model, DummyFunction, DummySet)
    @test !MOI.supports_constraint(model, MOI.VariableIndex, DummySet)
    @test !MOI.supports_add_constrained_variable(model, DummySet)
    for S in [
        MOI.EqualTo{T},
        MOI.GreaterThan{T},
        MOI.LessThan{T},
        MOI.Interval{T},
        MOI.Integer,
        MOI.ZeroOne,
        MOI.Semicontinuous{T},
        MOI.Semiinteger{T},
    ]
        @test MOI.supports_constraint(model, MOI.VariableIndex, S)
        @test MOI.supports_add_constrained_variable(model, S)
    end
    U = Float32
    for S in [
        MOI.EqualTo{U},
        MOI.GreaterThan{U},
        MOI.LessThan{U},
        MOI.Interval{U},
        MOI.Semicontinuous{U},
        MOI.Semiinteger{U},
    ]
        @test !MOI.supports_constraint(model, MOI.VariableIndex, S)
        @test !MOI.supports_add_constrained_variable(model, S)
    end
    return
end

function test_VariableIndex()
    _test_VariableIndex(Float64)
    _test_VariableIndex(Int)
    return
end

function test_quadratic_functions()
    model = MOI.Utilities.Model{Int}()
    x, y = MOI.add_variables(model, 2)
    @test 2 == @inferred MOI.get(model, MOI.NumberOfVariables())
    f1 = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.([1, 2, 3], [x, y, x], [x, y, y]),
        MOI.ScalarAffineTerm.([3], [x]),
        7,
    )
    c1 = MOI.add_constraint(model, f1, MOI.Interval(-1, 1))
    @test 1 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{
            MOI.ScalarQuadraticFunction{Int},
            MOI.Interval{Int},
        }(),
    )
    @test (@inferred MOI.get(
        model,
        MOI.ListOfConstraintIndices{
            MOI.ScalarQuadraticFunction{Int},
            MOI.Interval{Int},
        }(),
    )) == [c1]
    f2 = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            [1, 1, 2],
            MOI.ScalarQuadraticTerm.([1, 2, 3], [x, y, x], [x, y, y]),
        ),
        MOI.VectorAffineTerm.(
            [1, 2, 2],
            MOI.ScalarAffineTerm.([3, 1, 2], [x, x, y]),
        ),
        [7, 3, 4],
    )
    c2 = MOI.add_constraint(model, f2, MOI.PositiveSemidefiniteConeTriangle(3))
    @test 1 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{
            MOI.VectorQuadraticFunction{Int},
            MOI.PositiveSemidefiniteConeTriangle,
        }(),
    )
    @test (@inferred MOI.get(
        model,
        MOI.ListOfConstraintIndices{
            MOI.VectorQuadraticFunction{Int},
            MOI.PositiveSemidefiniteConeTriangle,
        }(),
    )) == [c2]
    loc = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test length(loc) == 2
    @test (
        MOI.VectorQuadraticFunction{Int},
        MOI.PositiveSemidefiniteConeTriangle,
    ) in loc
    @test (
        MOI.VectorQuadraticFunction{Int},
        MOI.PositiveSemidefiniteConeTriangle,
    ) in loc
    c3 = MOI.add_constraint(model, f1, MOI.Interval(-1, 1))
    change_1 = MOI.ScalarConstantChange(9)
    f3 = MOI.Utilities.modify_function(f1, change_1)
    change_2 = MOI.ScalarCoefficientChange(y, 2)
    f3 = MOI.Utilities.modify_function(f3, change_2)
    @test !(MOI.get(model, MOI.ConstraintFunction(), c1) ≈ f3)
    @test !(MOI.get(model, MOI.ConstraintFunction(), c3) ≈ f3)
    MOI.set(model, MOI.ConstraintFunction(), c1, f3)
    MOI.modify(model, c3, change_1)
    MOI.modify(model, c3, change_2)
    F1 = MOI.get(model, MOI.CanonicalConstraintFunction(), c1)
    @test F1 ≈ f3
    @test F1 !== MOI.get(model, MOI.ConstraintFunction(), c1)
    @test MOI.Utilities.is_canonical(F1)
    F3 = MOI.get(model, MOI.CanonicalConstraintFunction(), c3)
    @test F3 ≈ f3
    @test F3 ≈ MOI.get(model, MOI.ConstraintFunction(), c3)
    @test MOI.Utilities.is_canonical(F3)
    @test MOI.get(model, MOI.CanonicalConstraintFunction(), c1) ≈ f3
    @test MOI.Utilities.is_canonical(
        MOI.get(model, MOI.CanonicalConstraintFunction(), c1),
    )
    f4 = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(
            [1, 1, 2],
            MOI.ScalarAffineTerm.([2, 4, 3], [x, y, y]),
        ),
        [5, 7],
    )
    c4 = MOI.add_constraint(model, f4, MOI.SecondOrderCone(2))
    @test 1 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{
            MOI.VectorAffineFunction{Int},
            MOI.SecondOrderCone,
        }(),
    )
    f5 = MOI.VectorOfVariables([x, x])
    c5 = MOI.add_constraint(model, f5, MOI.RotatedSecondOrderCone(2))
    @test 1 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{
            MOI.VectorOfVariables,
            MOI.RotatedSecondOrderCone,
        }(),
    )
    f6 = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.([1, 2], MOI.ScalarAffineTerm.([2, 9], [x, y])),
        [6, 8],
    )
    c6 = MOI.add_constraint(model, f6, MOI.SecondOrderCone(2))
    @test 2 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{
            MOI.VectorAffineFunction{Int},
            MOI.SecondOrderCone,
        }(),
    )
    f7 = MOI.VectorOfVariables([x, y])
    c7 = MOI.add_constraint(model, f7, MOI.Nonpositives(2))
    @test 1 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.Nonpositives}(),
    )

    f8 = MOI.VectorOfVariables([x, y])
    c8 = MOI.add_constraint(model, f8, MOI.SecondOrderCone(2))
    @test 1 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.SecondOrderCone}(),
    )
    loc1 = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    loc2 = Vector{Tuple{Type,Type}}()
    function _pushloc(v::MOI.Utilities.VectorOfConstraints{F,S}) where {F,S}
        if !MOI.is_empty(v)
            push!(loc2, (F, S))
        end
    end
    _pushloc(::Nothing) = nothing
    function _pushloc(model::MOI.Utilities.StructOfConstraints)
        return MOI.Utilities.broadcastcall(_pushloc, model)
    end
    MOI.Utilities.broadcastcall(_pushloc, model.constraints)
    for loc in (loc1, loc2)
        @test length(loc) == 6
        @test (
            MOI.VectorQuadraticFunction{Int},
            MOI.PositiveSemidefiniteConeTriangle,
        ) in loc
        @test (
            MOI.VectorQuadraticFunction{Int},
            MOI.PositiveSemidefiniteConeTriangle,
        ) in loc
        @test (MOI.VectorOfVariables, MOI.RotatedSecondOrderCone) in loc
        @test (MOI.VectorAffineFunction{Int}, MOI.SecondOrderCone) in loc
        @test (MOI.VectorOfVariables, MOI.Nonpositives) in loc
    end
    @test MOI.is_valid(model, c4)
    MOI.delete(model, c4)
    @test !MOI.is_valid(model, c4)

    @test 1 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{
            MOI.VectorAffineFunction{Int},
            MOI.SecondOrderCone,
        }(),
    )
    @test MOI.get(model, MOI.ConstraintFunction(), c6).constants == f6.constants
    obj = 1x + 2y
    MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
    message = string(
        "Cannot delete variable as it is constrained with other",
        " variables in a `MOI.VectorOfVariables`.",
    )
    err = MOI.DeleteNotAllowed(y, message)
    @test_throws err MOI.delete(model, y)
    @test MOI.get(model, MOI.ObjectiveFunction{typeof(obj)}()) ≈ 1x + 2y
    @test MOI.is_valid(model, c8)
    MOI.delete(model, c8)
    @test !MOI.is_valid(model, c8)
    @test 0 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.SecondOrderCone}(),
    )
    MOI.delete(model, y)
    @test MOI.get(model, MOI.ObjectiveFunction{typeof(obj)}()) ≈ 1x
    f = MOI.get(model, MOI.ConstraintFunction(), c2)
    @test f.affine_terms ==
          MOI.VectorAffineTerm.([1, 2], MOI.ScalarAffineTerm.([3, 1], [x, x]))
    @test f.quadratic_terms ==
          MOI.VectorQuadraticTerm.([1], MOI.ScalarQuadraticTerm.([1], [x], [x]))
    @test f.constants == [7, 3, 4]
    f = MOI.get(model, MOI.ConstraintFunction(), c6)
    @test f.terms == MOI.VectorAffineTerm.([1], MOI.ScalarAffineTerm.([2], [x]))
    @test f.constants == [6, 8]
    @test 1 == @inferred MOI.get(
        model,
        MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.Nonpositives}(),
    )
    @test [c7] == @inferred MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonpositives}(),
    )
    f = MOI.get(model, MOI.ConstraintFunction(), c7)
    @test f.variables == [x]
    s = MOI.get(model, MOI.ConstraintSet(), c7)
    @test MOI.dimension(s) == 1
end

function test_default_fallbacks()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    func = convert(MOI.ScalarAffineFunction{Float64}, x)
    c = MOI.add_constraint(model, func, MOI.LessThan(0.0))
    @test !MOI.supports_constraint(
        model,
        FunctionNotSupportedBySolvers,
        SetNotSupportedBySolvers,
    )

    # set of different type
    @test_throws Exception MOI.set(
        model,
        MOI.ConstraintSet(),
        c,
        MOI.GreaterThan(0.0),
    )
    # set not implemented
    @test_throws Exception MOI.set(
        model,
        MOI.ConstraintSet(),
        c,
        SetNotSupportedBySolvers(),
    )

    # function of different type
    @test_throws Exception MOI.set(
        model,
        MOI.ConstraintFunction(),
        c,
        MOI.VectorOfVariables([x]),
    )
    # function not implemented
    @test_throws Exception MOI.set(
        model,
        MOI.ConstraintFunction(),
        c,
        FunctionNotSupportedBySolvers(x),
    )
end

function test_extension_dictionary()
    model = MOI.Utilities.Model{Float64}()
    model.ext[:my_store] = 1
    @test model.ext[:my_store] == 1
    MOI.empty!(model)
    @test model.ext[:my_store] == 1
    model.ext[:my_store] = 2
    dest = MOI.Utilities.Model{Float64}()
    MOI.copy_to(dest, model)
    @test !haskey(dest.ext, :my_store)
    @test model.ext[:my_store] == 2
    return
end

struct _UnsupportedSetIssue2005 <: MOI.AbstractScalarSet end

function test_get_unsupported_constraint()
    model = MOI.Utilities.Model{Float64}()
    S = _UnsupportedSetIssue2005
    for F in (MOI.VariableIndex, MOI.ScalarAffineFunction{Float64})
        @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 0
        @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) ==
              MOI.ConstraintIndex{F,S}[]
    end
    return
end

function test_vector_of_constraints_list_of_constraint_attributes_set()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(1.0))
    inner = model.constraints.moi_scalaraffinefunction.moi_equalto
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    @test MOI.get(inner, MOI.ListOfConstraintAttributesSet{F,S}()) ==
          MOI.AbstractConstraintAttribute[]
    return
end

function test_copy_to_unsupported_scalar_variable()
    F, S = MOI.VariableIndex, MOI.GreaterThan{Float64}
    model = MOI.Utilities.Model{Float64}()
    x, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(1.0))
    dest = MOI.FileFormats.CBF.Model()
    @test_throws(MOI.UnsupportedConstraint{F,S}, MOI.copy_to(dest, model))
    return
end

function test_copy_to_unsupported_vector_variables()
    F, S = MOI.VectorOfVariables, MOI.AllDifferent
    model = MOI.Utilities.Model{Float64}()
    x, _ = MOI.add_constrained_variables(model, MOI.AllDifferent(3))
    dest = MOI.FileFormats.CBF.Model()
    @test_throws(MOI.UnsupportedConstraint{F,S}, MOI.copy_to(dest, model))
    return
end

function test_copy_to_unsupported_scalar_function()
    F, S = MOI.ScalarNonlinearFunction, MOI.EqualTo{Float64}
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.add_constraint(model, f, MOI.EqualTo(0.0))
    dest = MOI.FileFormats.CBF.Model()
    @test_throws(MOI.UnsupportedConstraint{F,S}, MOI.copy_to(dest, model))
    return
end

function test_indicator_constraints()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    z, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
    f = MOI.Utilities.operate(vcat, Float64, 1.0 * x, z)
    for si in (MOI.LessThan(1.0), MOI.GreaterThan(1.0), MOI.EqualTo(1.0))
        for a in (MOI.ACTIVATE_ON_ONE, MOI.ACTIVATE_ON_ZERO)
            s = MOI.Indicator{a}(si)
            MOI.supports_constraint(model, typeof(f), typeof(s))
            ci = MOI.add_constraint(model, f, s)
            @test MOI.is_valid(model, ci)
            @test MOI.get(model, MOI.ConstraintFunction(), ci) ≈ f
            @test MOI.get(model, MOI.ConstraintSet(), ci) == s
        end
    end
    return
end

function test_set_unsupported_objective()
    model = MOI.Utilities.Model{Float64}()
    f = FunctionNotSupportedBySolvers(MOI.VariableIndex(1))
    attr = MOI.ObjectiveFunction{typeof(f)}()
    @test_throws(MOI.UnsupportedAttribute(attr), MOI.set(model, attr, f))
    return
end

function test_variable_coefficient_VectorQuadraticFunction()
    x = MOI.VariableIndex.(1:2)
    fs = [
        1.0 * x[1] * x[1] + 2.0 * x[1] * x[2] + 3.0 * x[2] + 0.5,
        1.0 * x[2] * x[2],
    ]
    f = MOI.Utilities.vectorize(fs)
    for xi in x
        @test MOI.Utilities._variable_coefficient(f, xi, y -> sin(y.value)) ≈
              MOI.Utilities._variable_coefficient.(fs, xi, y -> sin(y.value))
    end
    return
end

function test_constraints_invalid_index()
    model = MOI.Utilities.Model{Float64}()
    F, S = FunctionNotSupportedBySolvers, MOI.ZeroOne
    ci = MOI.ConstraintIndex{F,S}(1)
    @test_throws(
        MOI.InvalidIndex(ci),
        MOI.Utilities.constraints(model.constraints, ci),
    )
    return
end

MOI.Utilities.@struct_of_constraints_by_set_types(
    Set4802,
    Union{MOI.LessThan{T},MOI.GreaterThan{T}},
    MOI.EqualTo{T},
    MOI.ZeroOne,
    Int,
)

function test_struct_of_constraints_by_set_types()
    set = Set4802{Float64,Vector{Float64},Vector{Float64},Vector{Bool},Int}()
    @test set.num_variables == 0
    @test set.int === nothing
    set.int = 1
    @test set.moi_zeroone === nothing
    set.moi_zeroone = Bool[]
    @test set.moi_equalto === nothing
    set.moi_equalto = Float64[]
    @test set.moi_lessthan === nothing
    set.moi_lessthan = Float64[]
    return
end

MOI.Utilities.@model(EmptyModel, (), (), (), (), (), (), (), ())

function test_empty_model()
    model = EmptyModel{Float64}()
    @test MOI.is_empty(model)
    @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) ==
          Tuple{Type,Type}[]
    return
end

end  # module

TestModel.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    operate(
        op::Function,
        ::Type{T},
        args::Union{T,MOI.AbstractFunction}...,
    )::MOI.AbstractFunction where {T<:Number}

Returns an `MOI.AbstractFunction` representing the function resulting from the
operation `op(args...)` on functions of coefficient type `T`.

No argument can be modified.

## Methods

 1. `+`
    a. `operate(::typeof(+), ::Type{T}, ::F1)`
    b. `operate(::typeof(+), ::Type{T}, ::F1, ::F2)`
    c. `operate(::typeof(+), ::Type{T}, ::F1...)`
 2. `-`
    a. `operate(::typeof(-), ::Type{T}, ::F)`
    b. `operate(::typeof(-), ::Type{T}, ::F1, ::F2)`
 3. `*`
    a. `operate(::typeof(*), ::Type{T}, ::T, ::F)`
    b. `operate(::typeof(*), ::Type{T}, ::F, ::T)`
    c. `operate(::typeof(*), ::Type{T}, ::F1, ::F2)`
       where `F1` and `F2` are `VariableIndex` or `ScalarAffineFunction`
    d. `operate(::typeof(*), ::Type{T}, ::Diagonal{T}, ::F)`
 4. `/`
    a. `operate(::typeof(/), ::Type{T}, ::F, ::T)`
 5. `vcat`
    a. `operate(::typeof(vcat), ::Type{T}, ::F...)`
 6. `imag`
    a. `operate(::typeof(imag), ::Type{T}, ::F)`
       where `F` is `VariableIndex` or `VectorOfVariables`

One assumption is that the element type `T` is invariant under each operation.
That is, `op(::T, ::T)::T` where `op` is a `+`, `-`, `*`, and `/`.

In each case, `F` (or `F1` and `F2`) is one of the ten supported types, with
a restriction that the mathematical operation makes sense, for example, we don't
define `promote_operation(-, T, F1, F2)` where `F1` is a scalar-valued function
and  `F2` is a vector-valued function. The ten supported types are:

 1. ::T
 2. ::VariableIndex
 3. ::ScalarAffineFunction{T}
 4. ::ScalarQuadraticFunction{T}
 5. ::ScalarNonlinearFunction
 6. ::AbstractVector{T}
 7. ::VectorOfVariables
 8. ::VectorAffineFunction{T}
 9. ::VectorQuadraticFunction{T}
10. ::VectorNonlinearFunction
"""
function operate end

### Special case: a generic fallback for operations on numbers only.

function operate(
    op::F,
    ::Type{T},
    f::Union{T,AbstractVector{T}},
) where {T<:Number,F<:Function}
    return op(f)
end

function operate(
    op::F,
    ::Type{T},
    f::Union{T,AbstractVector{T}},
    g::Union{T,AbstractVector{T}},
) where {T<:Number,F<:Function}
    return op(f, g)
end

### 1a: operate(::typeof(+), ::Type{T}, ::F1)

operate(::typeof(+), ::Type{T}, f::MOI.AbstractFunction) where {T<:Number} = f

operate(::typeof(+), ::Type{T}, f::T) where {T<:Number} = f

### 1b: operate(::typeof(+), ::Type{T}, ::F1, ::F2)

function operate(
    ::typeof(+),
    ::Type{T},
    f::T,
    g::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    },
) where {T<:Number}
    return operate(+, T, g, f)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VariableIndex,
    g::T,
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm(one(T), f)], g)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VariableIndex,
    g::MOI.VariableIndex,
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}(
        [MOI.ScalarAffineTerm(one(T), f), MOI.ScalarAffineTerm(one(T), g)],
        zero(T),
    )
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VariableIndex,
    g::Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
) where {T<:Number}
    return operate(+, T, g, f)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.ScalarAffineFunction{T},
    g::Union{T,MOI.VariableIndex,MOI.ScalarAffineFunction{T}},
) where {T<:Number}
    return operate!(+, T, copy(f), g)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.ScalarAffineFunction{T},
    g::MOI.ScalarQuadraticFunction{T},
) where {T<:Number}
    return operate(+, T, g, f)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.ScalarQuadraticFunction{T},
    g::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    },
) where {T<:Number}
    return operate!(+, T, copy(f), g)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.ScalarNonlinearFunction,
    g::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
    },
) where {T<:Number}
    return MOI.ScalarNonlinearFunction(:+, Any[f, g])
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
    },
    g::MOI.ScalarNonlinearFunction,
) where {T<:Number}
    return MOI.ScalarNonlinearFunction(:+, Any[f, g])
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.ScalarNonlinearFunction,
    g::MOI.ScalarNonlinearFunction,
) where {T<:Number}
    return MOI.ScalarNonlinearFunction(:+, Any[f, g])
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::AbstractVector{T},
    g::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return operate(+, T, g, f)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorOfVariables,
    g::Vector{T},
) where {T<:Number}
    d = MOI.output_dimension(f)
    @assert length(g) == d
    scalar_terms = MOI.ScalarAffineTerm.(one(T), f.variables)
    vector_terms = MOI.VectorAffineTerm.(1:d, scalar_terms)
    return MOI.VectorAffineFunction{T}(vector_terms, g)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorOfVariables,
    g::MOI.VectorOfVariables,
) where {T<:Number}
    d = MOI.output_dimension(f)
    @assert MOI.output_dimension(g) == d
    fs = MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(one(T), f.variables))
    gs = MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(one(T), g.variables))
    return MOI.VectorAffineFunction{T}(vcat(fs, gs), zeros(T, d))
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorOfVariables,
    g::Union{MOI.VectorAffineFunction{T},MOI.VectorQuadraticFunction{T}},
) where {T<:Number}
    return operate(+, T, g, f)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorAffineFunction{T},
    g::Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
    },
) where {T<:Number}
    return operate!(+, T, copy(f), g)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorAffineFunction{T},
    g::MOI.VectorQuadraticFunction{T},
) where {T<:Number}
    return operate(+, T, g, f)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorQuadraticFunction{T},
    g::Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return operate!(+, T, copy(f), g)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorNonlinearFunction,
    g::Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    },
) where {T<:Number}
    args = Any[
        operate(+, T, fi, gi) for (fi, gi) in zip(scalarize(f), scalarize(g))
    ]
    return MOI.VectorNonlinearFunction(args)
end

function operate(
    ::typeof(+),
    ::Type{T},
    f::Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::MOI.VectorNonlinearFunction,
) where {T<:Number}
    args = Any[
        operate(+, T, fi, gi) for (fi, gi) in zip(scalarize(f), scalarize(g))
    ]
    return MOI.VectorNonlinearFunction(args)
end

### 1c: operate(+, T, args...)

function operate(::typeof(+), ::Type{T}, f, g, h, args...) where {T<:Number}
    return operate!(+, T, operate(+, T, f, g), h, args...)
end

### 2a: operate(::typeof(-), ::Type{T}, ::F)

function operate(::typeof(-), ::Type{T}, f::MOI.VariableIndex) where {T<:Number}
    return MOI.ScalarAffineFunction{T}(
        [MOI.ScalarAffineTerm(-one(T), f)],
        zero(T),
    )
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorOfVariables,
) where {T<:Number}
    d = MOI.output_dimension(f)
    return MOI.VectorAffineFunction{T}(
        MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(-one(T), f.variables)),
        zeros(T, d),
    )
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::Union{
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return operate_coefficients(-, f)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.ScalarNonlinearFunction,
) where {T<:Number}
    if f.head == :- && length(f.args) == 1
        # A simplification for -(-(f)) into f, but only if f is an SNF.
        if f.args[1] isa MOI.ScalarNonlinearFunction
            return f.args[1]
        end
    end
    return MOI.ScalarNonlinearFunction(:-, Any[f])
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorNonlinearFunction,
) where {T<:Number}
    return MOI.VectorNonlinearFunction(Any[operate(-, T, fi) for fi in f.rows])
end

### 2b: operate(::typeof(-), ::Type{T}, ::F1, ::F2)

function operate(
    ::typeof(-),
    ::Type{T},
    f::T,
    g::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    },
) where {T<:Number}
    return operate!(+, T, operate(-, T, g), f)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VariableIndex,
    g::T,
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm(one(T), f)], -g)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VariableIndex,
    g::MOI.VariableIndex,
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}(
        [MOI.ScalarAffineTerm(one(T), f), MOI.ScalarAffineTerm(-one(T), g)],
        zero(T),
    )
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VariableIndex,
    g::Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
) where {T<:Number}
    return operate!(+, T, operate(-, T, g), f)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.ScalarAffineFunction{T},
    g::Union{T,MOI.VariableIndex,MOI.ScalarAffineFunction{T}},
) where {T<:Number}
    return operate!(-, T, copy(f), g)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.ScalarAffineFunction{T},
    g::MOI.ScalarQuadraticFunction{T},
) where {T<:Number}
    return MOI.ScalarQuadraticFunction{T}(
        operate_terms(-, g.quadratic_terms),
        vcat(f.terms, operate_terms(-, g.affine_terms)),
        f.constant .- g.constant,
    )
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.ScalarQuadraticFunction{T},
    g::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    },
) where {T<:Number}
    return operate!(-, T, copy(f), g)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.ScalarNonlinearFunction,
    g::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
    },
) where {T<:Number}
    return MOI.ScalarNonlinearFunction(:-, Any[f, g])
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
    },
    g::MOI.ScalarNonlinearFunction,
) where {T<:Number}
    return MOI.ScalarNonlinearFunction(:-, Any[f, g])
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.ScalarNonlinearFunction,
    g::MOI.ScalarNonlinearFunction,
) where {T<:Number}
    return MOI.ScalarNonlinearFunction(:-, Any[f, g])
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::AbstractVector{T},
    g::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return operate!(+, T, operate(-, T, g), f)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorOfVariables,
    g::AbstractVector{T},
) where {T<:Number}
    d = MOI.output_dimension(f)
    @assert length(g) == d
    scalar_terms = MOI.ScalarAffineTerm.(one(T), f.variables)
    vector_terms = MOI.VectorAffineTerm.(1:d, scalar_terms)
    return MOI.VectorAffineFunction{T}(vector_terms, -g)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorOfVariables,
    g::MOI.VectorOfVariables,
) where {T<:Number}
    d = MOI.output_dimension(f)
    @assert MOI.output_dimension(g) == d
    fs = MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(one(T), f.variables))
    gs = MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(-one(T), g.variables))
    return MOI.VectorAffineFunction{T}(vcat(fs, gs), zeros(T, d))
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorOfVariables,
    g::Union{MOI.VectorAffineFunction{T},MOI.VectorQuadraticFunction{T}},
) where {T<:Number}
    return operate!(+, T, operate(-, T, g), f)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorAffineFunction{T},
    g::Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
    },
) where {T<:Number}
    return operate!(-, T, copy(f), g)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorAffineFunction{T},
    g::MOI.VectorQuadraticFunction{T},
) where {T<:Number}
    return MOI.VectorQuadraticFunction{T}(
        operate_terms(-, g.quadratic_terms),
        MOI.VectorAffineTerm{T}[f.terms; operate_terms(-, g.affine_terms)],
        f.constants .- g.constants,
    )
end

function operate(
    op::typeof(-),
    ::Type{T},
    f::MOI.VectorQuadraticFunction{T},
    g::Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return operate!(op, T, copy(f), g)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorNonlinearFunction,
    g::Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    },
) where {T<:Number}
    args = Any[
        operate(-, T, fi, gi) for (fi, gi) in zip(scalarize(f), scalarize(g))
    ]
    return MOI.VectorNonlinearFunction(args)
end

function operate(
    ::typeof(-),
    ::Type{T},
    f::Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::MOI.VectorNonlinearFunction,
) where {T<:Number}
    args = Any[
        operate(-, T, fi, gi) for (fi, gi) in zip(scalarize(f), scalarize(g))
    ]
    return MOI.VectorNonlinearFunction(args)
end

### 3a: operate(::typeof(*), ::Type{T}, ::T, ::F)

function operate(
    ::typeof(*),
    ::Type{T},
    f::T,
    g::MOI.VariableIndex,
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}([MOI.ScalarAffineTerm(f, g)], zero(T))
end

function operate(
    ::typeof(*),
    ::Type{T},
    f::T,
    g::MOI.VectorOfVariables,
) where {T<:Number}
    d = MOI.output_dimension(g)
    terms = MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(f, g.variables))
    return MOI.VectorAffineFunction{T}(terms, zeros(T, d))
end

function operate(
    ::typeof(*),
    ::Type{T},
    f::T,
    g::Union{
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return operate!(*, T, copy(g), f)
end

function operate(
    ::typeof(*),
    ::Type{T},
    f::T,
    g::MOI.ScalarNonlinearFunction,
) where {T<:Number}
    return MOI.ScalarNonlinearFunction(:*, Any[f, g])
end

function operate(
    ::typeof(*),
    ::Type{T},
    f::T,
    g::MOI.VectorNonlinearFunction,
) where {T<:Number}
    return MOI.VectorNonlinearFunction(Any[operate(*, T, f, h) for h in g.rows])
end

### 3b: operate(::typeof(*), ::Type{T}, ::F,  ::T)

function operate(
    ::typeof(*),
    ::Type{T},
    f::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::T,
) where {T<:Number}
    return operate(*, T, g, f)
end

function operate(
    ::typeof(*),
    ::Type{T},
    f::MOI.ScalarNonlinearFunction,
    g::T,
) where {T<:Number}
    return MOI.ScalarNonlinearFunction(:*, Any[f, g])
end

function operate(
    ::typeof(*),
    ::Type{T},
    f::MOI.VectorNonlinearFunction,
    g::T,
) where {T<:Number}
    return MOI.VectorNonlinearFunction(Any[operate(*, T, h, g) for h in f.rows])
end

### 3c: operate(::typeof(*), ::Type{T}, ::F1, ::F2)

function operate(
    ::typeof(*),
    ::Type{T},
    f::MOI.VariableIndex,
    g::MOI.ScalarAffineFunction{T},
) where {T<:Number}
    return operate(*, T, g, f)
end

function operate(
    ::typeof(*),
    ::Type{T},
    f::MOI.ScalarAffineFunction{T},
    g::MOI.ScalarAffineFunction{T},
) where {T<:Number}
    nfterms = length(f.terms)
    ngterms = length(g.terms)
    quad_terms = Vector{MOI.ScalarQuadraticTerm{T}}(undef, nfterms * ngterms)
    k = 0
    for t1 in f.terms
        for t2 in g.terms
            k += 1
            quad_terms[k] = operate_term(*, t1, t2)
        end
    end
    @assert k == length(quad_terms)
    if iszero(f.constant)
        if iszero(g.constant)
            aff_terms = MOI.ScalarAffineTerm{T}[]
        else
            aff_terms = operate_term.(*, g.constant, f.terms)
        end
    else
        if iszero(g.constant)
            aff_terms = operate_term.(*, f.constant, g.terms)
        else
            aff_terms =
                Vector{MOI.ScalarAffineTerm{T}}(undef, nfterms + ngterms)
            map!(t -> operate_term(*, g.constant, t), aff_terms, f.terms)
            for i in 1:ngterms
                aff_terms[nfterms+i] = operate_term(*, f.constant, g.terms[i])
            end
        end
    end
    constant = f.constant * g.constant
    return MOI.ScalarQuadraticFunction{T}(quad_terms, aff_terms, constant)
end

function operate(
    ::typeof(*),
    ::Type{T},
    f::MOI.VariableIndex,
    g::MOI.VariableIndex,
) where {T<:Number}
    return MOI.ScalarQuadraticFunction{T}(
        [MOI.ScalarQuadraticTerm{T}(f == g ? T(2) : one(T), f, g)],
        MOI.ScalarAffineTerm{T}[],
        zero(T),
    )
end

function operate(
    ::typeof(*),
    ::Type{T},
    f::MOI.ScalarAffineFunction{T},
    g::MOI.VariableIndex,
) where {T<:Number}
    aff_terms = MOI.ScalarAffineTerm{T}[]
    if !iszero(f.constant)
        push!(aff_terms, MOI.ScalarAffineTerm{T}(f.constant, g))
    end
    quad_terms = map(f.terms) do t
        scale = t.variable == g ? T(2) : one(T)
        return MOI.ScalarQuadraticTerm{T}(scale * t.coefficient, t.variable, g)
    end
    return MOI.ScalarQuadraticFunction{T}(quad_terms, aff_terms, zero(T))
end

### 3d: operate(::typeof(*), ::Type{T}, ::Diagonal{T}, ::F)

function operate(
    ::typeof(*),
    ::Type{T},
    D::LinearAlgebra.Diagonal{T},
    func::MOI.VectorQuadraticFunction{T},
) where {T<:Number}
    return MOI.VectorQuadraticFunction{T}(
        operate_terms(*, D, func.quadratic_terms),
        operate_terms(*, D, func.affine_terms),
        operate(*, T, D, func.constants),
    )
end

function operate(
    ::typeof(*),
    ::Type{T},
    D::LinearAlgebra.Diagonal{T},
    func::MOI.VectorAffineFunction{T},
) where {T<:Number}
    return MOI.VectorAffineFunction{T}(
        operate_terms(*, D, func.terms),
        operate(*, T, D, func.constants),
    )
end

function operate(
    ::typeof(*),
    ::Type{T},
    D::LinearAlgebra.Diagonal{T},
    func::MOI.VectorOfVariables,
) where {T<:Number}
    return MOI.VectorAffineFunction{T}(
        MOI.VectorAffineTerm{T}[
            MOI.VectorAffineTerm(
                i,
                MOI.ScalarAffineTerm(D.diag[i], func.variables[i]),
            ) for i in eachindex(func.variables)
        ],
        zeros(T, length(func.variables)),
    )
end

function operate(
    ::typeof(*),
    ::Type{T},
    D::LinearAlgebra.Diagonal{T},
    v::AbstractVector{T},
) where {T<:Number}
    return T[D.diag[i] * v[i] for i in eachindex(v)]
end

### 4a: `operate(::typeof(/), ::Type{T}, ::F, ::T)

function operate(
    ::typeof(/),
    ::Type{T},
    f::Union{MOI.VariableIndex,MOI.VectorOfVariables},
    g::T,
) where {T<:Number}
    return operate(*, T, inv(g), f)
end

function operate(
    ::typeof(/),
    ::Type{T},
    f::Union{
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::T,
) where {T<:Number}
    return operate!(/, T, copy(f), g)
end

function operate(
    ::typeof(/),
    ::Type{T},
    f::MOI.ScalarNonlinearFunction,
    g::T,
) where {T<:Number}
    return MOI.ScalarNonlinearFunction(:/, Any[f, g])
end

function operate(
    ::typeof(/),
    ::Type{T},
    f::MOI.VectorNonlinearFunction,
    g::T,
) where {T<:Number}
    return MOI.VectorNonlinearFunction(Any[operate(/, T, h, g) for h in f.rows])
end

### 5a: operate(::typeof(vcat), ::Type{T}, ::F...)

operate(::typeof(vcat), ::Type{T}) where {T<:Number} = T[]

function operate(
    ::typeof(vcat),
    ::Type{T},
    f::Union{T,AbstractVector{T}}...,
) where {T<:Number}
    return vcat(f...)
end

function operate(
    ::typeof(vcat),
    ::Type{T},
    f::Union{MOI.VariableIndex,MOI.VectorOfVariables}...,
) where {T<:Number}
    x = Vector{MOI.VariableIndex}(undef, sum(f -> output_dim(T, f), f))
    fill_vector(x, T, 0, 0, fill_variables, output_dim, f...)
    return MOI.VectorOfVariables(x)
end

function operate(
    ::typeof(vcat),
    ::Type{T},
    f::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
    }...,
) where {T<:Number}
    num_aterms = sum(f -> number_of_affine_terms(T, f), f)
    aterms = Vector{MOI.VectorAffineTerm{T}}(undef, num_aterms)
    fill_vector(aterms, T, 0, 0, fill_terms, number_of_affine_terms, f...)
    constants = zeros(T, sum(f -> output_dim(T, f), f))
    fill_vector(constants, T, 0, 0, fill_constant, output_dim, f...)
    return MOI.VectorAffineFunction{T}(aterms, constants)
end

function operate(
    ::typeof(vcat),
    ::Type{T},
    f::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    }...,
) where {T<:Number}
    num_aterms = sum(func -> number_of_affine_terms(T, func), f)
    aterms = Vector{MOI.VectorAffineTerm{T}}(undef, num_aterms)
    fill_vector(aterms, T, 0, 0, fill_terms, number_of_affine_terms, f...)
    num_qterms = sum(func -> number_of_quadratic_terms(T, func), f)
    qterms = Vector{MOI.VectorQuadraticTerm{T}}(undef, num_qterms)
    fill_vector(qterms, T, 0, 0, fill_terms, number_of_quadratic_terms, f...)
    constants = zeros(T, sum(f -> output_dim(T, f), f))
    fill_vector(constants, T, 0, 0, fill_constant, output_dim, f...)
    return MOI.VectorQuadraticFunction{T}(qterms, aterms, constants)
end

function operate(
    ::typeof(vcat),
    ::Type{T},
    args::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    }...,
) where {T<:Number}
    out = Any[]
    for a in args
        if a isa T
            push!(out, a)
        elseif a isa AbstractVector{T}
            append!(out, a)
        elseif a isa MOI.AbstractScalarFunction
            push!(out, a)
        else
            append!(out, scalarize(a))
        end
    end
    _to_new_snf(f::MOI.ScalarNonlinearFunction) = copy(f)
    _to_new_snf(f) = convert(MOI.ScalarNonlinearFunction, f)
    # We need to `copy` the ScalarNonlinearFunction rows here, everything else
    # will be `convert(ScalarNonlinearFunction, row)` into a new object, but the
    # ScalarNonlinearFunction rows won't be, so mutating the return value of
    # this `operate` method will mutate the inputs. This _is_ what Base.vcat
    # does, but it doesn't fit with the general assumption that
    # `Utilities.operate(` returns a new object.
    return MOI.VectorNonlinearFunction(_to_new_snf.(out))
end

### 6a: operate(::typeof(imag), ::Type{T}, ::F)

function operate(
    ::typeof(imag),
    ::Type{T},
    ::MOI.VariableIndex,
) where {T<:Number}
    return zero(MOI.ScalarAffineFunction{T})
end

function operate(
    ::typeof(imag),
    ::Type{T},
    f::MOI.VectorOfVariables,
) where {T<:Number}
    return zero_with_output_dimension(
        MOI.VectorAffineFunction{T},
        MOI.output_dimension(f),
    )
end

function operate(
    ::typeof(imag),
    ::Type{T},
    f::Union{
        MOI.ScalarAffineFunction{S},
        MOI.ScalarQuadraticFunction{S},
        MOI.VectorAffineFunction{S},
        MOI.VectorQuadraticFunction{S},
    },
) where {T,S<:Union{T,Complex{T}}}
    return imag(f)
end

"""
    operate!(
        op::Function,
        ::Type{T},
        args::Union{T,MOI.AbstractFunction}...,
    )::MOI.AbstractFunction where {T<:Number}

Returns an `MOI.AbstractFunction` representing the function resulting from the
operation `op(args...)` on functions of coefficient type `T`.

The first argument may be modified, in which case the return value is identical
to the first argument. For operations which cannot be implemented in-place, this
function returns a new object.
"""
operate!(op, ::Type{T}, args...) where {T<:Number} = operate(op, T, args...)

### 1a: operate!(::typeof(+), ::Type{T}, ::F1)

### 1b: operate!(::typeof(+), ::Type{T}, ::F1, ::F2)

function operate!(
    ::typeof(+),
    ::Type{T},
    f::MOI.ScalarAffineFunction{T},
    g::Union{T,MOI.VariableIndex,MOI.ScalarAffineFunction{T}},
) where {T<:Number}
    return MA.operate!(+, f, g)
end

function operate!(
    ::typeof(+),
    ::Type{T},
    f::MOI.ScalarQuadraticFunction{T},
    g::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    },
) where {T<:Number}
    return MA.operate!(+, f, g)
end

function operate!(
    ::typeof(+),
    ::Type{T},
    f::MOI.ScalarNonlinearFunction,
    g::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
    },
) where {T<:Number}
    if f.head == :+
        push!(f.args, g)
        return f
    end
    return operate(+, T, f, g)
end

function operate!(
    ::typeof(+),
    ::Type{T},
    f::Union{MOI.VectorAffineFunction{T},MOI.VectorQuadraticFunction{T}},
    g::AbstractVector{T},
) where {T<:Number}
    @assert MOI.output_dimension(f) == length(g)
    f.constants .+= g
    return f
end

function operate!(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorAffineFunction{T},
    g::MOI.VectorOfVariables,
) where {T<:Number}
    d = MOI.output_dimension(g)
    @assert MOI.output_dimension(f) == d
    append!(
        f.terms,
        MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(one(T), g.variables)),
    )
    return f
end

function operate!(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorAffineFunction{T},
    g::MOI.VectorAffineFunction{T},
) where {T<:Number}
    append!(f.terms, g.terms)
    f.constants .+= g.constants
    return f
end

function operate!(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorQuadraticFunction{T},
    g::MOI.VectorOfVariables,
) where {T<:Number}
    d = MOI.output_dimension(g)
    @assert MOI.output_dimension(f) == d
    append!(
        f.affine_terms,
        MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(one(T), g.variables)),
    )
    return f
end

function operate!(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorQuadraticFunction{T},
    g::MOI.VectorAffineFunction{T},
) where {T<:Number}
    append!(f.affine_terms, g.terms)
    f.constants .+= g.constants
    return f
end

function operate!(
    ::typeof(+),
    ::Type{T},
    f::MOI.VectorQuadraticFunction{T},
    g::MOI.VectorQuadraticFunction{T},
) where {T<:Number}
    append!(f.affine_terms, g.affine_terms)
    append!(f.quadratic_terms, g.quadratic_terms)
    f.constants .+= g.constants
    return f
end

### 1c: operate!(+, T, args...)

function operate!(::typeof(+), ::Type{T}, f, g, h, args...) where {T<:Number}
    # In order to improve performance and avoid a `StackOverflow` if there are
    # too many arguments, `foldl` does not do recursion and fall back to a
    # `for` loop if there are too many arguments.
    return foldl((x, y) -> operate!(+, T, x, y), (f, g, h, args...))
end

### 2a: operate!(::typeof(-), ::Type{T}, ::F)

function operate!(
    op::typeof(-),
    ::Type{T},
    f::Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
) where {T<:Number}
    return MA.operate!(-, f)
end

### 2b: operate!(::typeof(-), ::Type{T}, ::F1, ::F2)

function operate!(
    ::typeof(-),
    ::Type{T},
    f::MOI.ScalarAffineFunction{T},
    g::Union{T,MOI.VariableIndex,MOI.ScalarAffineFunction{T}},
) where {T<:Number}
    return MA.operate!(-, f, g)
end

function operate!(
    ::typeof(-),
    ::Type{T},
    f::MOI.ScalarQuadraticFunction{T},
    g::Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    },
) where {T<:Number}
    return MA.operate!(-, f, g)
end

function operate!(
    ::typeof(-),
    ::Type{T},
    f::Union{MOI.VectorAffineFunction{T},MOI.VectorQuadraticFunction{T}},
    g::AbstractVector{T},
) where {T<:Number}
    @assert MOI.output_dimension(f) == length(g)
    f.constants .-= g
    return f
end

function operate!(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorAffineFunction{T},
    g::MOI.VectorOfVariables,
) where {T<:Number}
    d = MOI.output_dimension(g)
    @assert MOI.output_dimension(f) == d
    append!(
        f.terms,
        MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(-one(T), g.variables)),
    )
    return f
end

function operate!(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorAffineFunction{T},
    g::MOI.VectorAffineFunction{T},
) where {T<:Number}
    append!(f.terms, operate_terms(-, g.terms))
    f.constants .-= g.constants
    return f
end

function operate!(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorQuadraticFunction{T},
    g::MOI.VectorOfVariables,
) where {T<:Number}
    d = MOI.output_dimension(g)
    @assert MOI.output_dimension(f) == d
    append!(
        f.affine_terms,
        MOI.VectorAffineTerm.(1:d, MOI.ScalarAffineTerm.(-one(T), g.variables)),
    )
    return f
end

function operate!(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorQuadraticFunction{T},
    g::MOI.VectorAffineFunction{T},
) where {T<:Number}
    append!(f.affine_terms, operate_terms(-, g.terms))
    f.constants .-= g.constants
    return f
end

function operate!(
    ::typeof(-),
    ::Type{T},
    f::MOI.VectorQuadraticFunction{T},
    g::MOI.VectorQuadraticFunction{T},
) where {T<:Number}
    append!(f.affine_terms, operate_terms(-, g.affine_terms))
    append!(f.quadratic_terms, operate_terms(-, g.quadratic_terms))
    f.constants .-= g.constants
    return f
end

### 3a: operate!(::typeof(*), ::Type{T}, ::T, ::F)

### 3b: operate!(::typeof(*), ::Type{T}, ::F, ::T)

function operate!(
    ::typeof(*),
    ::Type{T},
    f::Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
    g::T,
) where {T<:Number}
    map_terms!(term -> operate_term(*, term, g), f)
    f.constant *= g
    return f
end

function operate!(
    ::typeof(*),
    ::Type{T},
    f::MOI.ScalarNonlinearFunction,
    g::T,
) where {T<:Number}
    if f.head == :*
        push!(f.args, g)
        return f
    end
    return operate(*, T, f, g)
end

function operate!(
    ::typeof(*),
    ::Type{T},
    f::Union{MOI.VectorAffineFunction{T},MOI.VectorQuadraticFunction{T}},
    g::T,
) where {T<:Number}
    map_terms!(term -> operate_term(*, term, g), f)
    f.constants .*= g
    return f
end

### 3c: operate!(::typeof(*), ::Type{T}, ::F1, ::F2)

### 3d: operate!(::typeof(*), ::Type{T}, ::Diagonal{T}, ::F)

### 4a: operate!(::typeof(/), ::Type{T}, ::F, ::T)

function operate!(
    ::typeof(/),
    ::Type{T},
    f::Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
    g::T,
) where {T<:Number}
    map_terms!(term -> operate_term(/, term, g), f)
    f.constant /= g
    return f
end

function operate!(
    ::typeof(/),
    ::Type{T},
    f::Union{MOI.VectorAffineFunction{T},MOI.VectorQuadraticFunction{T}},
    g::T,
) where {T<:Number}
    map_terms!(term -> operate_term(/, term, g), f)
    f.constants ./= g
    return f
end

### 5a: operate!(::typeof(vcat), ::Type{T}, ::F...)

### 6a: operate!(::typeof(imag), ::Type{T}, ::F)

"""
    operate_term(op::Function, args...)

Compute `op(args...)`, where at least one element of `args` is one of
[`MOI.ScalarAffineTerm`](@ref), [`MOI.ScalarQuadraticTerm`](@ref),
[`MOI.VectorAffineTerm`](@ref), or [`MOI.VectorQuadraticTerm`](@ref).

## Methods

 1. `+`
    a. `operate_term(::typeof(+), ::Term)`
 2. `-`
    a. `operate_term(::typeof(-), ::Term)`
 3. `*`
    a. `operate_term(::typeof(*), ::T, ::Term)`
    b. `operate_term(::typeof(*), ::Term, ::T)`
    c. `operate_term(::typeof(*), ::AffineTerm, ::AffineTerm)`
    d. `operate_term(::typeof(*), ::T, ::ScalarTerm, ::T)`
    e. `operate_term(::typeof(*), ::Diagonal, ::VectorTerm)`
 4. `/`
    a. `operate_term(::typeof(/), ::Term, ::T)`
 5. User-defined function
    a. `operate_term(::Function, ::Term)`
"""
function operate_term end

### 1a: operate_term(::typeof(+), ::Term)

# Works automatically via 5a fallback.

### 2a: operate_term(::typeof(-), ::Term)

# Works automatically via 5a fallback.

### 3a: operate_term(::typeof(*), ::T, ::Term)

function operate_term(
    ::typeof(*),
    f::T,
    g::Union{
        MOI.ScalarAffineTerm{T},
        MOI.ScalarQuadraticTerm{T},
        MOI.VectorAffineTerm{T},
        MOI.VectorQuadraticTerm{T},
    },
) where {T<:Number}
    return operate_term(Base.Fix1(*, f), g)
end

### 3b: operate_term(::typeof(*), ::Term, ::T)

function operate_term(
    ::typeof(*),
    f::Union{
        MOI.ScalarAffineTerm{T},
        MOI.ScalarQuadraticTerm{T},
        MOI.VectorAffineTerm{T},
        MOI.VectorQuadraticTerm{T},
    },
    g::T,
) where {T<:Number}
    return operate_term(*, g, f)
end

### 3c: operate_term(::typeof(*), ::Term, ::Term)

function operate_term(
    ::typeof(*),
    t1::MOI.ScalarAffineTerm,
    t2::MOI.ScalarAffineTerm,
)
    coef = t1.coefficient * t2.coefficient
    if t1.variable == t2.variable
        return MOI.ScalarQuadraticTerm(2 * coef, t1.variable, t2.variable)
    end
    return MOI.ScalarQuadraticTerm(coef, t1.variable, t2.variable)
end

function operate_term(
    ::typeof(*),
    t1::MOI.VectorAffineTerm,
    t2::MOI.VectorAffineTerm,
)
    @assert t1.output_index == t2.output_index
    return MOI.VectorQuadraticTerm(
        t1.output_index,
        operate_term(*, t1.scalar_term, t2.scalar_term),
    )
end

### 3d: operate_term(::typeof(*), ::T, ::ScalarTerm, ::T)

function operate_term(
    ::typeof(*),
    f::T,
    g::Union{MOI.ScalarAffineTerm{T},MOI.ScalarQuadraticTerm{T}},
    h::T,
) where {T<:Number}
    return operate_term(Base.Fix1(*, f * h), g)
end

### 3e: operate_term(::typeof(*), ::Diagonal, ::Vector)

function operate_term(
    ::typeof(*),
    f::LinearAlgebra.Diagonal,
    g::MOI.VectorAffineTerm,
)
    return MOI.VectorAffineTerm(
        g.output_index,
        operate_term(*, f.diag[g.output_index], g.scalar_term),
    )
end

function operate_term(
    ::typeof(*),
    f::LinearAlgebra.Diagonal,
    g::MOI.VectorQuadraticTerm,
)
    return MOI.VectorQuadraticTerm(
        g.output_index,
        operate_term(*, f.diag[g.output_index], g.scalar_term),
    )
end

### 4a: operate_term(::typeof(/), ::Term, ::T)

function operate_term(
    ::typeof(/),
    f::Union{
        MOI.ScalarAffineTerm{T},
        MOI.ScalarQuadraticTerm{T},
        MOI.VectorAffineTerm{T},
        MOI.VectorQuadraticTerm{T},
    },
    g::T,
) where {T<:Number}
    return operate_term(Base.Fix2(/, g), f)
end

### 5a: operate_term(::Function, ::Term)

function operate_term(op::F, f::MOI.ScalarAffineTerm) where {F<:Function}
    return MOI.ScalarAffineTerm(op(f.coefficient), f.variable)
end

function operate_term(op::F, f::MOI.ScalarQuadraticTerm) where {F<:Function}
    coef = op(f.coefficient)
    return MOI.ScalarQuadraticTerm(coef, f.variable_1, f.variable_2)
end

function operate_term(op::F, f::MOI.VectorAffineTerm) where {F<:Function}
    return MOI.VectorAffineTerm(f.output_index, operate_term(op, f.scalar_term))
end

function operate_term(op::F, f::MOI.VectorQuadraticTerm) where {F<:Function}
    return MOI.VectorQuadraticTerm(
        f.output_index,
        operate_term(op, f.scalar_term),
    )
end

"""
    operate_terms(op::Function, args...)

Compute `op(args...)`, where at least one element of `args` is a vector of
[`MOI.ScalarAffineTerm`](@ref), [`MOI.ScalarQuadraticTerm`](@ref),
[`MOI.VectorAffineTerm`](@ref), or [`MOI.VectorQuadraticTerm`](@ref).

## Methods

 1. `+`
    a. `operate_term(::typeof(+), ::Vector{<:Term})`
 2. `-`
    a. `operate_term(::typeof(-), ::Vector{<:Term})`
 3. `*`
    a. `operate_term(::typeof(*), ::Diagonal, ::Vector{<:VectorTerm})`
 4. User-defined function
    a. `operate_term(::Function, ::Vector{<:Term})`
"""
function operate_terms end

### 1a: operate_term(::typeof(+), ::Vector{<:Term})

function operate_terms(
    ::typeof(+),
    terms::Vector{
        <:Union{
            MOI.ScalarAffineTerm,
            MOI.ScalarQuadraticTerm,
            MOI.VectorAffineTerm,
            MOI.VectorQuadraticTerm,
        },
    },
)
    return terms
end

### 2a: operate_term(::typeof(-), ::Vector{<:Term})

# Works automatically by 4a fallback.

### 3a: operate_term(::typeof(*), ::Diagonal, ::Vector{<:VectorTerm})

function operate_terms(::typeof(*), D::LinearAlgebra.Diagonal, terms)
    return map(term -> operate_term(*, D, term), terms)
end

### 4a: operate_term(::Function, ::Vector{<:Term})

function operate_terms(
    op::F,
    f::Vector{
        <:Union{
            MOI.ScalarAffineTerm,
            MOI.ScalarQuadraticTerm,
            MOI.VectorAffineTerm,
            MOI.VectorQuadraticTerm,
        },
    },
) where {F}
    return map(Base.Fix1(operate_term, op), f)
end

"""
    operate_terms!(op::Function, args...)

Compute `op(args...)`, where at least one element of `args` is a vector of
[`MOI.ScalarAffineTerm`](@ref), [`MOI.ScalarQuadraticTerm`](@ref),
[`MOI.VectorAffineTerm`](@ref), or [`MOI.VectorQuadraticTerm`](@ref).

!!! warning
    This method is deprecated and may be removed in MathOptInterface v2.0.

## Methods

 1. `-`
    a. `operate_term(::typeof(-), ::Vector{<:ScalarTerm})`
"""
function operate_terms!(
    ::typeof(-),
    terms::Vector{<:Union{MOI.ScalarAffineTerm,MOI.ScalarQuadraticTerm}},
)
    map!(Base.Fix1(operate_term, -), terms, terms)
    return terms
end

"""
    operate_output_index!(
        op::Union{typeof(+),typeof(-)},
        ::Type{T},
        output_index::Integer,
        f::Union{AbstractVector{T},MOI.AbstractVectorFunction}
        g::Union{T,MOI.AbstractScalarFunction}...
    ) where {T<:Number}

Return an `MOI.AbstractVectorFunction` in which the scalar function in row
`output_index` is the result of `op(f[output_index], g)`.

The functions at output index different to `output_index` are the same as the
functions at the same output index in `func`. The first argument may be
modified.

## Methods

 1. `+`
    a. `operate_output_index!(+, ::Type{T}, ::Int, ::VectorF, ::ScalarF)`
 2. `-`
    a. `operate_output_index!(-, ::Type{T}, ::Int, ::VectorF, ::ScalarF)`
"""
function operate_output_index! end

function operate_output_index!(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    output_index::Integer,
    f::AbstractVector{T},
    g::T,
) where {T<:Number}
    f[output_index] = op(f[output_index], g)
    return f
end

function operate_output_index!(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    output_index::Integer,
    f::MOI.VectorAffineFunction{T},
    g::T,
) where {T<:Number}
    f.constants[output_index] = op(f.constants[output_index], g)
    return f
end

function operate_output_index!(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    output_index::Integer,
    f::MOI.VectorAffineFunction{T},
    g::MOI.VariableIndex,
) where {T<:Number}
    push!(
        f.terms,
        MOI.VectorAffineTerm(output_index, MOI.ScalarAffineTerm(op(one(T)), g)),
    )
    return f
end

function operate_output_index!(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    output_index::Integer,
    f::MOI.VectorAffineFunction{T},
    g::MOI.ScalarAffineFunction{T},
) where {T<:Number}
    append!(
        f.terms,
        MOI.VectorAffineTerm.(output_index, operate_terms(op, g.terms)),
    )
    operate_output_index!(op, T, output_index, f, MOI.constant(g))
    return f
end

function operate_output_index!(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    output_index::Integer,
    f::MOI.VectorQuadraticFunction{T},
    g::T,
) where {T<:Number}
    f.constants[output_index] = op(f.constants[output_index], g)
    return f
end

function operate_output_index!(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    output_index::Integer,
    f::MOI.VectorQuadraticFunction{T},
    g::MOI.VariableIndex,
) where {T<:Number}
    push!(
        f.affine_terms,
        MOI.VectorAffineTerm(output_index, MOI.ScalarAffineTerm(op(one(T)), g)),
    )
    return f
end

function operate_output_index!(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    output_index::Integer,
    f::MOI.VectorQuadraticFunction{T},
    g::MOI.ScalarAffineFunction{T},
) where {T<:Number}
    append!(
        f.affine_terms,
        MOI.VectorAffineTerm.(output_index, operate_terms(op, g.terms)),
    )
    operate_output_index!(op, T, output_index, f, MOI.constant(g))
    return f
end

function operate_output_index!(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    output_index::Integer,
    f::MOI.VectorQuadraticFunction{T},
    g::MOI.ScalarQuadraticFunction{T},
) where {T<:Number}
    append!(
        f.affine_terms,
        MOI.VectorAffineTerm.(output_index, operate_terms(op, g.affine_terms)),
    )
    append!(
        f.quadratic_terms,
        MOI.VectorQuadraticTerm.(
            output_index,
            operate_terms(op, g.quadratic_terms),
        ),
    )
    operate_output_index!(op, T, output_index, f, MOI.constant(g))
    return f
end

function operate_output_index!(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    output_index::Integer,
    f::MOI.VectorNonlinearFunction,
    g::Union{T,MOI.AbstractScalarFunction},
) where {T<:Number}
    f.rows[output_index] = operate!(op, T, f.rows[output_index], g)
    return f
end

"""
    operate_coefficient(
        op::Function,
        f::Union{
            MOI.ScalarAffineTerm,
            MOI.ScalarQuadraticTerm,
            MOI.VectorAffineTerm,
            MOI.VectorQuadraticTerm,
        },
    )

Return a new term, which is the result of calling `op(coefficient)` for on the
coefficient of the term `f`.

!!! warning
    This method is deprecated and may be removed in MathOptInterface v2.0. Use
    `operate_term(op, f)` instead.
"""
operate_coefficient(op::F, f) where {F} = operate_term(op, f)

"""
    operate_coefficients(
        op::F,
        f::Union{
            MOI.ScalarAffineFunction,
            MOI.ScalarQuadraticFunction,
            MOI.VectorAffineFunction,
            MOI.VectorQuadraticFunction,
        },
    ) where {F}
"""
function operate_coefficients end

operate_coefficients(op::F, f) where {F} = operate_terms(op, f)

function operate_coefficients(op::F, f::MOI.ScalarAffineFunction) where {F}
    return MOI.ScalarAffineFunction(operate_terms(op, f.terms), op(f.constant))
end

function operate_coefficients(op::F, f::MOI.ScalarQuadraticFunction) where {F}
    return MOI.ScalarQuadraticFunction(
        operate_terms(op, f.quadratic_terms),
        operate_terms(op, f.affine_terms),
        op(f.constant),
    )
end

function operate_coefficients(op::F, f::MOI.VectorAffineFunction) where {F}
    return MOI.VectorAffineFunction(
        operate_terms(op, f.terms),
        op.(f.constants),
    )
end

function operate_coefficients(op::F, f::MOI.VectorQuadraticFunction) where {F}
    return MOI.VectorQuadraticFunction(
        operate_terms(op, f.quadratic_terms),
        operate_terms(op, f.affine_terms),
        map(op, f.constants),
    )
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# This API is imported from MathProgBase and is meant to be transitional.
# A more ideal API would pass expressions (with vector-valued nodes) directly
# let the solver call out to AD tools.

# NLP = Nonlinear Programming.
# The non-MOI-like name is intentional because this part of the API is not
# MOI-like.

"""
    AbstractNLPEvaluator

Abstract supertype for the callback object that is used to query function
values, derivatives, and expression graphs.

It is used in [`NLPBlockData`](@ref).

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> supertype(typeof(evaluator))
MathOptInterface.AbstractNLPEvaluator
```
"""
abstract type AbstractNLPEvaluator end

"""
    NLPBlock()

An [`AbstractModelAttribute`](@ref) that stores an [`NLPBlockData`](@ref),
representing a set of nonlinear constraints, and optionally a nonlinear
objective.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}());

julia> block = MOI.NLPBlockData(
           MOI.NLPBoundsPair.([25.0, 40.0], [Inf, 40.0]),
           MOI.Test.HS071(true),
           true,
       );

julia> MOI.set(model, MOI.NLPBlock(), block)
```
"""
struct NLPBlock <: AbstractModelAttribute end

"""
    NLPBlockDual(result_index::Int = 1)

An [`AbstractModelAttribute`](@ref) for the Lagrange multipliers on the
constraints from the [`NLPBlock`](@ref) in result `result_index`.

If `result_index` is omitted, it is `1` by default.

## Example

```jldoctest
julia> MOI.NLPBlockDual()
MathOptInterface.NLPBlockDual(1)

julia> MOI.NLPBlockDual(2)
MathOptInterface.NLPBlockDual(2)
```
"""
struct NLPBlockDual <: AbstractModelAttribute
    result_index::Int
    NLPBlockDual(result_index::Int = 1) = new(result_index)
end

is_set_by_optimize(::NLPBlockDual) = true

"""
    NLPBlockDualStart()

An [`AbstractModelAttribute`](@ref) for the initial assignment of the Lagrange
multipliers on the constraints from the [`NLPBlock`](@ref) that the solver may
use to warm-start the solve.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}());

julia> block = MOI.NLPBlockData(
           MOI.NLPBoundsPair.([25.0, 40.0], [Inf, 40.0]),
           MOI.Test.HS071(true),
           true,
       );

julia> MOI.set(model, MOI.NLPBlock(), block)

julia> MOI.set(model, MOI.NLPBlockDualStart(), [1.0, 2.0])
```
"""
struct NLPBlockDualStart <: AbstractModelAttribute end

"""
    NLPBoundsPair(lower::Float64, upper::Float64)

A struct holding a pair of lower and upper bounds.

`-Inf` and `Inf` can be used to indicate no lower or upper bound, respectively.

## Example

```jldoctest
julia> bounds = MOI.NLPBoundsPair.([25.0, 40.0], [Inf, 40.0])
2-element Vector{MathOptInterface.NLPBoundsPair}:
 MathOptInterface.NLPBoundsPair(25.0, Inf)
 MathOptInterface.NLPBoundsPair(40.0, 40.0)
```
"""
struct NLPBoundsPair
    lower::Float64
    upper::Float64
end

"""
    struct NLPBlockData
        constraint_bounds::Vector{NLPBoundsPair}
        evaluator::AbstractNLPEvaluator
        has_objective::Bool
    end

A struct encoding a set of nonlinear constraints of the form
``lb \\le g(x) \\le ub`` and, if `has_objective == true`, a nonlinear objective
function ``f(x)``.

Nonlinear objectives *override* any objective set by using the
[`ObjectiveFunction`](@ref) attribute.

The `evaluator` is a callback object that is used to query function values,
derivatives, and expression graphs. If `has_objective == false`, then it is an
error to query properties of the objective function, and in
Hessian-of-the-Lagrangian queries, `σ` must be set to zero.

!!! note
    Throughout the evaluator, all variables are ordered according to
    [`ListOfVariableIndices`](@ref). Hence, MOI copies of nonlinear problems
    must not re-order variables.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}());

julia> block = MOI.NLPBlockData(
           MOI.NLPBoundsPair.([25.0, 40.0], [Inf, 40.0]),
           MOI.Test.HS071(true),
           true,
       );

julia> MOI.set(model, MOI.NLPBlock(), block)
```
"""
struct NLPBlockData
    constraint_bounds::Vector{NLPBoundsPair}
    evaluator::AbstractNLPEvaluator
    has_objective::Bool
end

"""
    initialize(
        d::AbstractNLPEvaluator,
        requested_features::Vector{Symbol},
    )::Nothing

Initialize `d` with the set of features in `requested_features`. Check
[`features_available`](@ref) before calling `initialize` to see what features
are supported by `d`.

!!! warning
    This method must be called before any other methods.

## Features

The following features are defined:

 * `:Grad`: enables [`eval_objective_gradient`](@ref)
 * `:Jac`: enables [`eval_constraint_jacobian`](@ref) and
   [`eval_constraint_gradient`](@ref)
 * `:JacVec`: enables [`eval_constraint_jacobian_product`](@ref) and
   [`eval_constraint_jacobian_transpose_product`](@ref)
 * `:Hess`: enables [`eval_hessian_lagrangian`](@ref)
 * `:HessVec`: enables [`eval_hessian_lagrangian_product`](@ref)
 * `:ExprGraph`: enables [`objective_expr`](@ref) and [`constraint_expr`](@ref).

In all cases, including when `requested_features` is empty,
[`eval_objective`](@ref) and [`eval_constraint`](@ref) are supported.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, [:Grad, :Jac])
```
"""
function initialize end

"""
    features_available(d::AbstractNLPEvaluator)::Vector{Symbol}

Returns the subset of features available for this problem instance.

See [`initialize`](@ref) for the list of defined features.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true, true);

julia> MOI.features_available(evaluator)
6-element Vector{Symbol}:
 :Grad
 :Jac
 :JacVec
 :ExprGraph
 :Hess
 :HessVec
```
"""
function features_available end

"""
    eval_objective(d::AbstractNLPEvaluator, x::AbstractVector{T})::T where {T}

Evaluate the objective ``f(x)``, returning a scalar value.

## Initialize

Before calling this function, you must call [`initialize`](@ref), but you do not
need to pass a value.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[])

julia> MOI.eval_objective(evaluator, [1.0, 2.0, 3.0, 4.0])
27.0
```
"""
function eval_objective end

"""
    eval_constraint(
        d::AbstractNLPEvaluator,
        g::AbstractVector{T},
        x::AbstractVector{T},
    )::Nothing where {T}

Given a set of vector-valued constraints ``l \\le g(x) \\le u``, evaluate the
constraint function ``g(x)``, storing the result in the vector `g`.

## Initialize

Before calling this function, you must call [`initialize`](@ref), but you do not
need to pass a value.

## Implementation notes

When implementing this method, you must not assume that `g` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[])

julia> g = fill(NaN, 2);

julia> MOI.eval_constraint(evaluator, g, [1.0, 2.0, 3.0, 4.0])

julia> g
2-element Vector{Float64}:
 24.0
 30.0
```
"""
function eval_constraint end

"""
    eval_objective_gradient(
        d::AbstractNLPEvaluator,
        grad::AbstractVector{T},
        x::AbstractVector{T},
    )::Nothing where {T}

Evaluate the gradient of the objective function ``grad = \\nabla f(x)`` as a
dense vector, storing the result in the vector `grad`.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Grad`.

## Implementation notes

When implementing this method, you must not assume that `grad` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Grad])

julia> grad = fill(NaN, 4);

julia> MOI.eval_objective_gradient(evaluator, grad, [1.0, 2.0, 3.0, 4.0])

julia> grad
4-element Vector{Float64}:
 28.0
  4.0
  5.0
  6.0
```
"""
function eval_objective_gradient end

"""
    jacobian_structure(d::AbstractNLPEvaluator)::Vector{Tuple{Int64,Int64}}

Returns a vector of tuples, `(row, column)`, where each indicates the position
of a structurally nonzero element in the Jacobian matrix:
``J_g(x) = \\left[ \\begin{array}{c} \\nabla g_1(x) \\\\ \\nabla g_2(x) \\\\ \\vdots \\\\ \\nabla g_m(x) \\end{array}\\right],``
where ``g_i`` is the ``i\\text{th}`` component of the nonlinear constraints
``g(x)``.

The indices are not required to be sorted and can contain duplicates, in which
case the solver should combine the corresponding elements by adding them
together.

The sparsity structure is assumed to be independent of the point ``x``.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Jac`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Jac])

julia> MOI.jacobian_structure(evaluator)
8-element Vector{Tuple{Int64, Int64}}:
 (1, 1)
 (1, 2)
 (1, 3)
 (1, 4)
 (2, 1)
 (2, 2)
 (2, 3)
 (2, 4)
```
"""
function jacobian_structure end

"""
    hessian_objective_structure(
        d::AbstractNLPEvaluator,
    )::Vector{Tuple{Int64,Int64}}

Returns a vector of tuples, `(row, column)`, where each indicates the position
of a structurally nonzero element in the Hessian matrix:
``\\nabla^2 f(x)``.

The indices are not required to be sorted and can contain duplicates, in which
case the solver should combine the corresponding elements by adding them
together.

Any mix of lower and upper-triangular indices is valid. Elements `(i, j)` and
`(j, i)`, if both present, should be treated as duplicates.

The sparsity structure is assumed to be independent of the point ``x``.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Hess`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Hess])

julia> MOI.hessian_objective_structure(evaluator)
6-element Vector{Tuple{Int64, Int64}}:
 (1, 1)
 (2, 1)
 (3, 1)
 (4, 1)
 (4, 2)
 (4, 3)
```
"""
function hessian_objective_structure end

"""
    hessian_constraint_structure(
        d::AbstractNLPEvaluator,
        i::Int64,
    )::Vector{Tuple{Int64,Int64}}

Returns a vector of tuples, `(row, column)`, where each indicates the position
of a structurally nonzero element in the Hessian matrix:
``\\nabla^2 g_i(x)``.

The indices are not required to be sorted and can contain duplicates, in which
case the solver should combine the corresponding elements by adding them
together.

Any mix of lower and upper-triangular indices is valid. Elements `(i, j)` and
`(j, i)`, if both present, should be treated as duplicates.

The sparsity structure is assumed to be independent of the point ``x``.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Hess`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Hess])

julia> MOI.hessian_constraint_structure(evaluator, 1)
6-element Vector{Tuple{Int64, Int64}}:
 (2, 1)
 (3, 1)
 (3, 2)
 (4, 1)
 (4, 2)
 (4, 3)

julia> MOI.hessian_constraint_structure(evaluator, 2)
4-element Vector{Tuple{Int64, Int64}}:
 (1, 1)
 (2, 2)
 (3, 3)
 (4, 4)
```
"""
function hessian_constraint_structure end

"""
    hessian_lagrangian_structure(
        d::AbstractNLPEvaluator,
    )::Vector{Tuple{Int64,Int64}}

Returns a vector of tuples, `(row, column)`, where each indicates the position
of a structurally nonzero element in the Hessian-of-the-Lagrangian matrix:
``\\nabla^2 f(x) + \\sum_{i=1}^m \\nabla^2 g_i(x)``.

The indices are not required to be sorted and can contain duplicates, in which
case the solver should combine the corresponding elements by adding them
together.

Any mix of lower and upper-triangular indices is valid. Elements `(i, j)` and
`(j, i)`, if both present, should be treated as duplicates.

The sparsity structure is assumed to be independent of the point ``x``.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Hess`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Hess])

julia> MOI.hessian_lagrangian_structure(evaluator)
10-element Vector{Tuple{Int64, Int64}}:
 (1, 1)
 (2, 1)
 (2, 2)
 (3, 1)
 (3, 2)
 (3, 3)
 (4, 1)
 (4, 2)
 (4, 3)
 (4, 4)
```
"""
function hessian_lagrangian_structure end

"""
    constraint_gradient_structure(d::AbstractNLPEvaluator, i::Int)::Vector{Int64}

Returns a vector of indices, where each element indicates the position of a
structurally nonzero element in the gradient of constraint ``\\nabla g_i(x)``.

The indices are not required to be sorted and can contain duplicates, in which
case the solver should combine the corresponding elements by adding them
together.

The sparsity structure is assumed to be independent of the point ``x``.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Jac`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Jac])

julia> indices = MOI.constraint_gradient_structure(evaluator, 1)
4-element Vector{Int64}:
 1
 2
 3
 4
```
"""
function constraint_gradient_structure end

"""
    eval_constraint_gradient(
        d::AbstractNLPEvaluator,
        ∇g::AbstractVector{T},
        x::AbstractVector{T},
        i::Int,
    )::Nothing where {T}

Evaluate the gradient of constraint `i`, ``\\nabla g_i(x)``, and store the
non-zero values in `∇g`, corresponding to the structure returned by
[`constraint_gradient_structure`](@ref).

## Implementation notes

When implementing this method, you must not assume that `∇g` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Jac`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Jac])

julia> indices = MOI.constraint_gradient_structure(evaluator, 1);

julia> ∇g = zeros(length(indices));

julia> MOI.eval_constraint_gradient(evaluator, ∇g, [1.0, 2.0, 3.0, 4.0], 1)

julia> ∇g
4-element Vector{Float64}:
 24.0
 12.0
  8.0
  6.0
```
"""
function eval_constraint_gradient end

"""
    eval_constraint_jacobian(
        d::AbstractNLPEvaluator,
        J::AbstractVector{T},
        x::AbstractVector{T},
    )::Nothing where {T}

Evaluates the sparse Jacobian matrix
``J_g(x) = \\left[ \\begin{array}{c} \\nabla g_1(x) \\\\ \\nabla g_2(x) \\\\ \\vdots \\\\ \\nabla g_m(x) \\end{array}\\right]``.

The result is stored in the vector `J` in the same order as the indices returned
by [`jacobian_structure`](@ref).

## Implementation notes

When implementing this method, you must not assume that `J` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Hess`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Jac])

julia> J_indices = MOI.jacobian_structure(evaluator);

julia> J = zeros(length(J_indices));

julia> MOI.eval_constraint_jacobian(evaluator, J, [1.0, 2.0, 3.0, 4.0])

julia> J
8-element Vector{Float64}:
 24.0
 12.0
  8.0
  6.0
  2.0
  4.0
  6.0
  8.0
```
"""
function eval_constraint_jacobian end

"""
    eval_constraint_jacobian_product(
        d::AbstractNLPEvaluator,
        y::AbstractVector{T},
        x::AbstractVector{T},
        w::AbstractVector{T},
    )::Nothing where {T}

Computes the Jacobian-vector product ``y = J_g(x)w``, storing the result in the
vector `y`.

The vectors have dimensions such that `length(w) == length(x)`, and `length(y)`
is the number of nonlinear constraints.

## Implementation notes

When implementing this method, you must not assume that `y` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:JacVec`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Jac, :JacVec])

julia> y = zeros(2);

julia> x = [1.0, 2.0, 3.0, 4.0];

julia> w = [1.5, 2.5, 3.5, 4.5];

julia> MOI.eval_constraint_jacobian_product(evaluator, y, x, w)

julia> y
2-element Vector{Float64}:
 121.0
  70.0
```
"""
function eval_constraint_jacobian_product end

"""
    eval_constraint_jacobian_transpose_product(
        d::AbstractNLPEvaluator,
        y::AbstractVector{T},
        x::AbstractVector{T},
        w::AbstractVector{T},
    )::Nothing where {T}

Computes the Jacobian-transpose-vector product ``y = J_g(x)^Tw``, storing the
result in the vector `y`.

The vectors have dimensions such that `length(y) == length(x)`, and `length(w)`
is the number of nonlinear constraints.

## Implementation notes

When implementing this method, you must not assume that `y` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:JacVec`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Jac, :JacVec])

julia> y = zeros(4);

julia> x = [1.0, 2.0, 3.0, 4.0];

julia> w = [1.5, 2.5];

julia> MOI.eval_constraint_jacobian_transpose_product(evaluator, y, x, w)

julia> y
4-element Vector{Float64}:
 41.0
 28.0
 27.0
 29.0
```
"""
function eval_constraint_jacobian_transpose_product end

"""
    eval_hessian_lagrangian_product(
        d::AbstractNLPEvaluator,
        h::AbstractVector{T},
        x::AbstractVector{T},
        v::AbstractVector{T},
        σ::T,
        μ::AbstractVector{T},
    )::Nothing where {T}

Given scalar weight `σ` and vector of constraint weights `μ`,
computes the Hessian-of-the-Lagrangian-vector product
``h = \\left(\\sigma\\nabla^2 f(x) + \\sum_{i=1}^m \\mu_i \\nabla^2 g_i(x)\\right)v``,
storing the result in the vector `h`.

The vectors have dimensions such that `length(h) == length(x) == length(v)`.

## Implementation notes

When implementing this method, you must not assume that `h` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:HessVec`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true, true);

julia> MOI.initialize(evaluator, Symbol[:HessVec])

julia> H = fill(NaN, 4);

julia> x = [1.0, 2.0, 3.0, 4.0];

julia> v = [1.5, 2.5, 3.5, 4.5];

julia> σ = 1.0;

julia> μ = [1.0, 1.0];

julia> MOI.eval_hessian_lagrangian_product(evaluator, H, x, v, σ, μ)

julia> H
4-element Vector{Float64}:
 155.5
  61.0
  48.5
  49.0
```
"""
function eval_hessian_lagrangian_product end

"""
    eval_hessian_objective(
        d::AbstractNLPEvaluator,
        H::AbstractVector{T},
        x::AbstractVector{T},
    )::Nothing where {T}

This function computes the sparse Hessian matrix:
``\\nabla^2 f(x)``,
storing the result in the vector `H` in the same order as the indices
returned by [`hessian_objective_structure`](@ref).

## Implementation notes

When implementing this method, you must not assume that `H` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Hess`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true, true);

julia> MOI.initialize(evaluator, Symbol[:Hess])

julia> indices = MOI.hessian_objective_structure(evaluator);

julia> H = zeros(length(indices));

julia> x = [1.0, 2.0, 3.0, 4.0];

julia> MOI.eval_hessian_objective(evaluator, H, x)

julia> H
6-element Vector{Float64}:
 8.0
 4.0
 4.0
 7.0
 1.0
 1.0
```
"""
function eval_hessian_objective end

"""
    eval_hessian_constraint(
        d::AbstractNLPEvaluator,
        H::AbstractVector{T},
        x::AbstractVector{T},
        i::Int64,
    )::Nothing where {T}

This function computes the sparse Hessian matrix:
``\\nabla^2 g_i(x)``,
storing the result in the vector `H` in the same order as the indices
returned by [`hessian_constraint_structure`](@ref).

## Implementation notes

When implementing this method, you must not assume that `H` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Hess`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true, true);

julia> MOI.initialize(evaluator, Symbol[:Hess])

julia> indices = MOI.hessian_constraint_structure(evaluator, 1);

julia> H = zeros(length(indices));

julia> x = [1.0, 2.0, 3.0, 4.0];

julia> MOI.eval_hessian_constraint(evaluator, H, x, 1)

julia> H
6-element Vector{Float64}:
 12.0
  8.0
  4.0
  6.0
  3.0
  2.0
```
"""
function eval_hessian_constraint end

"""
    eval_hessian_lagrangian(
        d::AbstractNLPEvaluator,
        H::AbstractVector{T},
        x::AbstractVector{T},
        σ::T,
        μ::AbstractVector{T},
    )::Nothing where {T}

Given scalar weight `σ` and vector of constraint weights `μ`, this function
computes the sparse Hessian-of-the-Lagrangian matrix:
``\\sigma\\nabla^2 f(x) + \\sum_{i=1}^m \\mu_i \\nabla^2 g_i(x)``,
storing the result in the vector `H` in the same order as the indices
returned by [`hessian_lagrangian_structure`](@ref).

## Implementation notes

When implementing this method, you must not assume that `H` is
`Vector{Float64}`, but you may assume that it supports `setindex!` and `length`.
For example, it may be the `view` of a vector.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with `:Hess`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, Symbol[:Hess])

julia> indices = MOI.hessian_lagrangian_structure(evaluator);

julia> H = zeros(length(indices));

julia> x = [1.0, 2.0, 3.0, 4.0];

julia> σ = 1.0;

julia> μ = [1.0, 1.0];

julia> MOI.eval_hessian_lagrangian(evaluator, H, x, σ, μ)

julia> H
10-element Vector{Float64}:
 10.0
 16.0
  2.0
 12.0
  4.0
  2.0
 13.0
  4.0
  3.0
  2.0
```
"""
function eval_hessian_lagrangian end

"""
    objective_expr(d::AbstractNLPEvaluator)::Expr

Returns a Julia `Expr` object representing the expression graph of the objective
function.

## Format

The expression has a number of limitations, compared with arbitrary Julia
expressions:

 * All sums and products are flattened out as simple `Expr(:+, ...)` and
   `Expr(:*, ...)` objects.
 * All decision variables must be of the form
   `Expr(:ref, :x, MOI.VariableIndex(i))`, where `i` is the ``i``th variable in
   [`ListOfVariableIndices`](@ref).
 * There are currently no restrictions on recognized functions; typically these
   will be built-in Julia functions like `^`, `exp`, `log`, `cos`, `tan`, `sqrt`,
   etc., but modeling interfaces may choose to extend these basic functions, or
   error if they encounter unsupported functions.

## Initialize

Before calling this function, you must call [`initialize`](@ref) with
`:ExprGraph`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, [:ExprGraph])

julia> MOI.objective_expr(evaluator)
:(x[MOI.VariableIndex(1)] * x[MOI.VariableIndex(4)] * (x[MOI.VariableIndex(1)] + x[MOI.VariableIndex(2)] + x[MOI.VariableIndex(3)]) + x[MOI.VariableIndex(3)])
```
"""
function objective_expr end

"""
    constraint_expr(d::AbstractNLPEvaluator, i::Integer)::Expr

Returns a Julia `Expr` object representing the expression graph for the
``i\\text{th}`` nonlinear constraint.

## Format

The format is the same as [`objective_expr`](@ref), with an additional
comparison operator indicating the sense of and bounds on the constraint.

For single-sided comparisons, the body of the constraint must be on the
left-hand side, and the right-hand side must be a constant.

For double-sided comparisons (that is, ``l \\le g(x) \\le u``), the body of the
constraint must be in the middle, and the left- and right-hand sides must be
constants.

The bounds on the constraints must match the [`NLPBoundsPair`](@ref)s passed to
[`NLPBlockData`](@ref).

## Initialize

Before calling this function, you must call [`initialize`](@ref) with
`:ExprGraph`.

## Example

This example uses the [`Test.HS071`](@ref) evaluator.

```jldoctest
julia> evaluator = MOI.Test.HS071(true);

julia> MOI.initialize(evaluator, [:ExprGraph])

julia> MOI.constraint_expr(evaluator, 1)
:(x[MOI.VariableIndex(1)] * x[MOI.VariableIndex(2)] * x[MOI.VariableIndex(3)] * x[MOI.VariableIndex(4)] >= 25.0)

julia> MOI.constraint_expr(evaluator, 2)
:(x[MOI.VariableIndex(1)] ^ 2 + x[MOI.VariableIndex(2)] ^ 2 + x[MOI.VariableIndex(3)] ^ 2 + x[MOI.VariableIndex(4)] ^ 2 == 40.0)
```
"""
function constraint_expr end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintCountGreaterThan

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CountGreaterThanToMILPBridge,
        """
        variables: c, y, a, b
        [c, y, a, b] in CountGreaterThan(4)
        a in Interval(1.0, 3.0)
        b in Interval(1.0, 3.0)
        y >= 1.0
        y <= 2.0
        """,
        """
        variables: c, y, a, b, y1, y2, a1, a2, a3, b1, b2, b3
        y + -1.0 * y1 + -2.0 * y2 == 0.0
        y1 + y2 == 1.0
        a + -1.0 * a1 + -2.0 * a2 + -3.0 * a3 == 0.0
        a1 + a2 + a3 == 1.0
        b + -1.0 * b1 + -2.0 * b2 + -3.0 * b3 == 0.0
        b1 + b2 + b3 == 1.0
        c + -1.0 * a1 + -1.0 * b1 + -2.0 * y1 >= -1.0
        c + -1.0 * a2 + -1.0 * b2 + -2.0 * y2 >= -1.0
        y1 in ZeroOne()
        y2 in ZeroOne()
        a1 in ZeroOne()
        a2 in ZeroOne()
        a3 in ZeroOne()
        b1 in ZeroOne()
        b2 in ZeroOne()
        b3 in ZeroOne()
        a in Interval(1.0, 3.0)
        b in Interval(1.0, 3.0)
        y >= 1.0
        y <= 2.0

        """,
    )
    return
end

function test_runtests_VectorAffineFunction()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CountGreaterThanToMILPBridge,
        """
        variables: z, c, y, a, b
        [2.0, y, a, b] in CountGreaterThan(4)
        a in Interval(1.0, 3.0)
        b in Interval(1.0, 3.0)
        y >= 1.0
        y <= 2.0
        z in ZeroOne()
        """,
        """
        variables: z, c, y, a, b, y1, y2, a1, a2, a3, b1, b2, b3
        y + -1.0 * y1 + -2.0 * y2 == 0.0
        y1 + y2 == 1.0
        a + -1.0 * a1 + -2.0 * a2 + -3.0 * a3 == 0.0
        a1 + a2 + a3 == 1.0
        b + -1.0 * b1 + -2.0 * b2 + -3.0 * b3 == 0.0
        b1 + b2 + b3 == 1.0
        -1.0 * a1 + -1.0 * b1 + -2.0 * y1 >= -3.0
        -1.0 * a2 + -1.0 * b2 + -2.0 * y2 >= -3.0
        y1 in ZeroOne()
        y2 in ZeroOne()
        a1 in ZeroOne()
        a2 in ZeroOne()
        a3 in ZeroOne()
        b1 in ZeroOne()
        b2 in ZeroOne()
        b3 in ZeroOne()
        a in Interval(1.0, 3.0)
        b in Interval(1.0, 3.0)
        y >= 1.0
        y <= 2.0
        z in ZeroOne()
        """,
    )
    return
end

function test_resolve_with_modified()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountGreaterThanToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint.(model, x, MOI.Interval(0, 2))
    MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.CountGreaterThan(3))
    @test MOI.get(inner, MOI.NumberOfVariables()) == 3
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 9
    MOI.set(model, MOI.ConstraintSet(), c[3], MOI.Interval(0, 1))
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 8
    return
end

function test_runtests_error_variable()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountGreaterThanToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    f = MOI.VectorOfVariables(x)
    c = MOI.add_constraint(model, f, MOI.CountGreaterThan(3))
    BT = typeof(model.map[c])
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,MOI.VariableIndex},
        MOI.Bridges.final_touch(model),
    )
    return
end

function test_runtests_error_affine()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountGreaterThanToMILP{Int}(inner)
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, Int, 2, x[1], 1 * x[1], x[2])
    c = MOI.add_constraint(model, f, MOI.CountGreaterThan(3))
    BT = typeof(model.map[c])
    F = MOI.ScalarAffineFunction{Int}
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,F},
        MOI.Bridges.final_touch(model),
    )
    return
end

end  # module

TestConstraintCountGreaterThan.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestObjectiveMap

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

struct ObjectiveDummyBridge <: MOI.Bridges.Objective.AbstractBridge
    id::Int
end

function _test_empty(map)
    @test isempty(map)
    @test length(map) == 0
    @test isempty(values(map))
    @test iterate(map) === nothing
    @test MOI.Bridges.Objective.function_type(map) === nothing
end

function test_Map()
    map = MOI.Bridges.Objective.Map()
    _test_empty(map)
    x = MOI.VariableIndex(1)
    MOI.Bridges.Objective.add_key_for_bridge(map, ObjectiveDummyBridge(1), x)
    @test MOI.Bridges.Objective.root_bridge(map) == ObjectiveDummyBridge(1)
    func = 1.0x
    MOI.Bridges.Objective.add_key_for_bridge(map, ObjectiveDummyBridge(2), func)
    @test MOI.Bridges.Objective.root_bridge(map) == ObjectiveDummyBridge(2)
    empty!(map)
    _test_empty(map)
    return
end

function test_EmptyMap()
    map = MOI.Bridges.Objective.EmptyMap()
    _test_empty(map)
    empty!(map)
    _test_empty(map)
    @test sprint(show, map) == ""
    return
end

end  # module

TestObjectiveMap.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

using Test

files_to_exclude =
    ["runtests.jl", "sdpa_models.jl", "utilities.jl", "identity_bridge.jl"]
@testset "$(file)" for file in readdir(@__DIR__; join = true)
    if !endswith(file, ".jl") || any(f -> endswith(file, f), files_to_exclude)
        continue
    end
    include(file)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestMPS

using Test

import MathOptInterface as MOI
import MathOptInterface.FileFormats: MPS
import OrderedCollections: OrderedDict

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$name" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function _test_write_to_file(input::String, output::String; kwargs...)
    model = MPS.Model(; kwargs...)
    MOI.Utilities.loadfromstring!(model, input)
    data = sprint(write, model)
    if data != output
        print(data)
    end
    @test data == output
    return model
end

function _test_model_equality(
    model_string,
    variables,
    constraints,
    args...;
    kwargs...,
)
    model = MPS.Model(; kwargs...)
    MOI.Utilities.loadfromstring!(model, model_string)
    io = IOBuffer()
    write(io, model)
    model_2 = MPS.Model(; kwargs...)
    seekstart(io)
    read!(io, model_2)
    MOI.Test.util_test_models_equal(
        model,
        model_2,
        variables,
        constraints,
        args...,
    )
    return
end

function test_show()
    @test sprint(summary, MPS.Model()) == "MOI.FileFormats.MPS.Model"
    return
end

function test_nonempty()
    model = MPS.Model()
    @test MOI.is_empty(model)
    MOI.add_variable(model)
    @test !MOI.is_empty(model)
    MOI.empty!(model)
    @test MOI.is_empty(model)
    MOI.add_variable(model)
    @test_throws(
        ErrorException("Cannot read in file because model is not empty."),
        MOI.read_from_file(model, joinpath(@__DIR__, "free_integer.mps")),
    )
    return
end

function test_failing_models()
    dir = joinpath(@__DIR__, "failing_models")
    @testset "$file" for file in filter(endswith(".mps"), readdir(dir))
        @test_throws(
            MPS.ParseError,
            MOI.read_from_file(MPS.Model(), joinpath(dir, file))
        )
        @info file
        try
            MOI.read_from_file(MPS.Model(), joinpath(dir, file))
        catch err
            showerror(stdout, err)
        end
        println()
    end
    return
end

function test_empty_row_name()
    model = MPS.Model()
    x = MOI.add_variable(model)
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
        MOI.LessThan(1.0),
    )
    @test_throws Exception sprint(MPS.write_rows, model)
    return
end

function test_sos()
    model = MPS.Model()
    x = MOI.add_variables(model, 3)
    names = Dict{MOI.VariableIndex,Int}()
    for i in 1:3
        MOI.set(model, MOI.VariableName(), x[i], "x$(i)")
        names[x[i]] = i
    end
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.SOS1([1.5, 2.5, 3.5]),
    )
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.SOS2([1.25, 2.25, 3.25]),
    )
    @test sprint(MPS.write_sos, model, names) ==
          "SOS\n" *
          " S1 SOS1\n" *
          "    x1        1.5\n" *
          "    x2        2.5\n" *
          "    x3        3.5\n" *
          " S2 SOS2\n" *
          "    x1        1.25\n" *
          "    x2        2.25\n" *
          "    x3        3.25\n"
    return
end

function test_maximization()
    model = MPS.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    @test sprint(MPS.write_columns, model, true, OrderedDict(x => 1)) ==
          "COLUMNS\n    x         OBJ       -1\n"
    return
end

function test_maximization_objsense_false()
    model = MPS.Model(; print_objsense = true)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    @test sprint(MPS.write_columns, model, false, OrderedDict(x => 1)) ==
          "COLUMNS\n    x         OBJ       1\n"
    return
end

function test_stacked_data()
    model = MPS.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "stacked_data.mps"))
    model_2 = MPS.Model()
    MOI.Utilities.loadfromstring!(
        model_2,
        """
        variables: x, y, z
        maxobjective: x + y + z + 2.5
        blank_obj: 1.0 * x + 2.0 * y in Interval(-Inf, Inf)
        con1: 1.0 * x in Interval(1.0, 5.0)
        con2: 1.0 * x in Interval(2.0, 6.0)
        con3: 1.0 * x in Interval(3.0, 7.0)
        con4: 2.0 * x in Interval(4.0, 8.0)
        y in Integer()
        y >= 1.0
        y <= 4.0
        z in ZeroOne()
        """,
    )
    MOI.set(model_2, MOI.Name(), "stacked_data")
    MOI.Test.util_test_models_equal(
        model,
        model_2,
        ["x", "y", "z"],
        ["blank_obj", "con1", "con2", "con3", "con4"],
        [
            ("y", MOI.Integer()),
            ("y", MOI.GreaterThan{Float64}(1.0)),
            ("y", MOI.LessThan{Float64}(4.0)),
            ("z", MOI.ZeroOne()),
        ],
    )
    return
end

function test_integer_default_bounds()
    model = MPS.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "integer_default_bounds.mps"))
    x = only(MOI.get(model, MOI.ListOfVariableIndices()))
    ci =
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}}(x.value)
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.GreaterThan(0.0)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}}(x.value)
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.LessThan(1.0)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Float64}}(x.value)
    @test !MOI.is_valid(model, ci)
    return
end

function test_integer_default_bounds_LI()
    model = MPS.Model()
    filename = joinpath(@__DIR__, "integer_default_bounds_LI.mps")
    MOI.read_from_file(model, filename)
    x = only(MOI.get(model, MOI.ListOfVariableIndices()))
    c_types = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test length(c_types) == 2
    @test (MOI.VariableIndex, MOI.Integer) in c_types
    F, S = MOI.VariableIndex, MOI.GreaterThan{Float64}
    @test (F, S) in c_types
    ci = MOI.ConstraintIndex{F,S}(x.value)
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.GreaterThan(1.0)
    return
end

function test_integer_default_bounds_MI()
    model = MPS.Model()
    filename = joinpath(@__DIR__, "integer_default_bounds_MI.mps")
    MOI.read_from_file(model, filename)
    @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) ==
          [(MOI.VariableIndex, MOI.Integer)]
    return
end

function test_integer_default_bounds_PL()
    model = MPS.Model()
    filename = joinpath(@__DIR__, "integer_default_bounds_PL.mps")
    MOI.read_from_file(model, filename)
    x = only(MOI.get(model, MOI.ListOfVariableIndices()))
    c_types = MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test length(c_types) == 2
    @test (MOI.VariableIndex, MOI.Integer) in c_types
    F, S = MOI.VariableIndex, MOI.GreaterThan{Float64}
    @test (F, S) in c_types
    ci = MOI.ConstraintIndex{F,S}(x.value)
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.GreaterThan(0.0)
    return
end

function test_free_integer()
    model = MPS.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "free_integer.mps"))
    model_2 = MPS.Model()
    MOI.Utilities.loadfromstring!(
        model_2,
        """
        variables: x
        minobjective: x
        con1: 1.0 * x >= 1.0
        x in Integer()
        """,
    )
    MOI.Test.util_test_models_equal(
        model,
        model_2,
        ["x"],
        ["con1"],
        [("x", MOI.Integer())],
    )
    return
end

function test_min_objective()
    _test_model_equality(
        """
        variables: x
        minobjective: x
        """,
        ["x"],
        String[],
    )
    return
end

function test_objconst()
    _test_model_equality(
        """
        variables: x
        minobjective: 1.1 * x + 1.2
        """,
        ["x"],
        String[],
    )
    return
end

function test_default_rhs_greater()
    _test_model_equality(
        """
        variables: x
        minobjective: x
        c1: 2.0 * x >= 0.0
        """,
        ["x"],
        ["c1"],
    )
    return
end

function test_default_rhs_less()
    _test_model_equality(
        """
        variables: x
        minobjective: x
        c1: 2.0 * x <= 0.0
        """,
        ["x"],
        ["c1"],
    )
    return
end

function test_default_rhs_equal()
    _test_model_equality(
        """
        variables: x
        minobjective: x
        c1: 2.0 * x == 0.0
        """,
        ["x"],
        ["c1"],
    )
    return
end

function test_min_scalaraffine()
    _test_model_equality(
        """
        variables: x
        minobjective: 1.2x
        """,
        ["x"],
        String[],
    )
    return
end

function test_scalaraffine_greaterthan()
    _test_model_equality(
        """
        variables: x
        minobjective: 1.2x
        c1: 1.1 * x >= 2.0
        """,
        ["x"],
        ["c1"],
    )
    return
end

function test_scalaraffine_lessthan()
    _test_model_equality(
        """
        variables: x
        minobjective: 1.2x
        c1: 1.1 * x <= 2.0
        """,
        ["x"],
        ["c1"],
    )
    return
end

function test_scalaraffine_equalto()
    _test_model_equality(
        """
        variables: x
        minobjective: 1.2x
        c1: 1.1 * x == 2.0
        """,
        ["x"],
        ["c1"],
    )
    return
end

function test_scalaraffine_interval()
    _test_model_equality(
        """
        variables: x
        minobjective: 1.2x
        c1: 1.1 * x in Interval(1.0, 2.0)
        """,
        ["x"],
        ["c1"],
    )
    return
end

function test_objsense_max()
    _test_model_equality(
        """
        variables: x
        maxobjective: 1.2x
        c1: 1.0 * x >= 0.0
        """,
        ["x"],
        ["c1"];
        print_objsense = true,
    )
    _test_model_equality(
        """
        variables: x
        minobjective: 1.2x
        c1: 1.0 * x >= 0.0
        """,
        ["x"],
        ["c1"];
        print_objsense = true,
    )
    return
end

function test_MARKER_INT()
    model = MPS.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: x, y, z
        minobjective: x + y + z
        x in Integer()
        c2: 2 * x + -1.0 * z <= 1.0
        z in ZeroOne()
        x >= 1.0
        """,
    )
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    model_2 = MPS.Model()
    read!(io, model_2)
    MOI.Test.util_test_models_equal(
        model,
        model_2,
        ["x", "y", "z"],
        ["c2"],
        [
            ("x", MOI.Integer()),
            ("z", MOI.ZeroOne()),
            ("x", MOI.GreaterThan(1.0)),
        ],
    )
    return
end

function test_zero_variable_bounds()
    model = MPS.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: x, y, z
        minobjective: x + y + z
        x >= 0.0
        y <= 0.0
        """,
    )
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    model_2 = MPS.Model()
    read!(io, model_2)
    MOI.Test.util_test_models_equal(
        model,
        model_2,
        ["x", "y", "z"],
        String[],
        [
            ("x", MOI.GreaterThan{Float64}(0.0)),
            ("y", MOI.LessThan{Float64}(0.0)),
        ],
    )
    return
end

function test_nonzero_variable_bounds()
    model = MPS.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: w, x, y, z
        minobjective: w + x + y + z
        x == 1.0
        y >= 2.0
        z <= 3.0
        w >= 4.0
        w <= 5.0
        """,
    )
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    model_2 = MPS.Model()
    read!(io, model_2)
    MOI.Test.util_test_models_equal(
        model,
        model_2,
        ["w", "x", "y", "z"],
        String[],
        [
            ("x", MOI.EqualTo{Float64}(1.0)),
            ("y", MOI.GreaterThan{Float64}(2.0)),
            ("z", MOI.LessThan{Float64}(3.0)),
            ("w", MOI.GreaterThan{Float64}(4.0)),
            ("w", MOI.LessThan{Float64}(5.0)),
        ],
    )
    return
end

function test_multiple_variable_bounds()
    _test_write_to_file(
        """
        variables: a_really_long_name
        minobjective: a_really_long_name
        a_really_long_name >= 1.0
        a_really_long_name <= 2.0
        """,
        """
        NAME
        ROWS
         N  OBJ
        COLUMNS
            a_really_long_name OBJ 1
        RHS
        RANGES
        BOUNDS
         LO bounds    a_really_long_name 1
         UP bounds    a_really_long_name 2
        ENDATA
        """,
    )
    return
end

function test_unused_variable()
    # In this test, `x` will be written to the file with a 0 objective
    # coefficient since it does not appear in the objective or in the
    # constraints.
    model = MPS.Model()
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: x, y
        minobjective: y
        c1: 2.0 * y >= 1.0
        x >= 0.0
        """,
    )
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    model_2 = MPS.Model()
    read!(io, model_2)
    @test MOI.get(model_2, MOI.NumberOfVariables()) == 2
    return
end

function test_names_with_spaces()
    model = MPS.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x[1, 2]")
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
        MOI.EqualTo(1.0),
    )
    MOI.set(model, MOI.ConstraintName(), c, "c c")
    @test sprint(write, model) ==
          "NAME\n" *
          "ROWS\n" *
          " N  OBJ\n" *
          " E  c_c\n" *
          "COLUMNS\n" *
          "    x[1,_2]   c_c       1\n" *
          "RHS\n" *
          "    rhs       c_c       1\n" *
          "RANGES\n" *
          "BOUNDS\n" *
          " FR bounds    x[1,_2]\n" *
          "ENDATA\n"
    return
end

function test_objsense_default()
    _test_write_to_file(
        """
        variables: x
        maxobjective: x
        """,
        """
        NAME
        ROWS
         N  OBJ
        COLUMNS
            x         OBJ       -1
        RHS
        RANGES
        BOUNDS
         FR bounds    x
        ENDATA
        """,
    )
    return
end

function test_objsense_true()
    _test_write_to_file(
        """
        variables: x
        maxobjective: x
        """,
        """
        NAME
        OBJSENSE
            MAX
        ROWS
         N  OBJ
        COLUMNS
            x         OBJ       1
        RHS
        RANGES
        BOUNDS
         FR bounds    x
        ENDATA
        """;
        print_objsense = true,
    )
    return
end

function test_sos_constraints()
    model = _test_write_to_file(
        """
        variables: x1, x2, x3
        [x1, x2, x3] in SOS1([1.0, 2.0, 3.0])
        [x3, x2, x1] in SOS2([1.2, 2.3, 3.4])
        """,
        """
        NAME
        ROWS
         N  OBJ
        COLUMNS
            x1        OBJ       0
            x2        OBJ       0
            x3        OBJ       0
        RHS
        RANGES
        BOUNDS
         FR bounds    x1
         FR bounds    x2
         FR bounds    x3
        SOS
         S1 SOS1
            x1        1
            x2        2
            x3        3
         S2 SOS2
            x3        1.2
            x2        2.3
            x1        3.4
        ENDATA
        """,
    )
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    new_model = MPS.Model()
    Base.read!(io, new_model)
    constraints = MOI.get(new_model, MOI.ListOfConstraintTypesPresent())
    @test (MOI.VectorOfVariables, MOI.SOS1{Float64}) in constraints
    @test (MOI.VectorOfVariables, MOI.SOS2{Float64}) in constraints
    return
end

function test_generic_names()
    _test_write_to_file(
        """
        variables: x, y
        c: x + y == 1.0
        y >= 2.0
        """,
        """
        NAME
        ROWS
         N  OBJ
         E  R1
        COLUMNS
            C1        R1        1
            C2        R1        1
        RHS
            rhs       R1        1
        RANGES
        BOUNDS
         FR bounds    C1
         LO bounds    C2        2
         PL bounds    C2
        ENDATA
        """;
        generic_names = true,
    )
    return
end

function test_rew_filename()
    model = MOI.FileFormats.Model(; filename = "test.rew")
    @test model isa MPS.Model
    @test model.ext[:MPS_OPTIONS].generic_names == true
    return
end

function test_rew_format()
    model = MOI.FileFormats.Model(; format = MOI.FileFormats.FORMAT_REW)
    @test model isa MPS.Model
    @test model.ext[:MPS_OPTIONS].generic_names == true
    return
end

function test_infinite_interval()
    _test_write_to_file(
        """
        variables: x1
        1.0 * x1 in Interval(-Inf, Inf)
        1.0 * x1 in Interval(-Inf, 1.0)
        1.0 * x1 in Interval(2.0, Inf)
        1.0 * x1 in Interval(3.0, 4.0)
        """,
        """
        NAME
        ROWS
         N  OBJ
         N  c1
         L  c2
         G  c3
         L  c4
        COLUMNS
            x1        c1        1
            x1        c2        1
            x1        c3        1
            x1        c4        1
        RHS
            rhs       c2        1
            rhs       c3        2
            rhs       c4        4
        RANGES
            rhs       c4        1
        BOUNDS
         FR bounds    x1
        ENDATA
        """,
    )
    return
end

function test_quadobj_gurobi()
    _test_write_to_file(
        """
        variables: x, y
        minobjective: x + y + 5.0 * x * x + 1.0 * x * y + 1.0 * y * x + 1.2 * y * y
        """,
        """
        NAME
        ROWS
         N  OBJ
        COLUMNS
            x         OBJ       1
            y         OBJ       1
        RHS
        RANGES
        BOUNDS
         FR bounds    x
         FR bounds    y
        QUADOBJ
            x         x         10
            x         y         2
            y         y         2.4
        ENDATA
        """,
    )
    return
end

function test_quadobj_cplex()
    _test_write_to_file(
        """
        variables: x, y
        minobjective: x + y + 5.0 * x * x + 1.0 * x * y + 1.0 * y * x + 1.2 * y * y
        """,
        """
        NAME
        ROWS
         N  OBJ
        COLUMNS
            x         OBJ       1
            y         OBJ       1
        RHS
        RANGES
        BOUNDS
         FR bounds    x
         FR bounds    y
        QUADOBJ
            x         x         10
            x         y         2
            y         y         2.4
        ENDATA
        """;
        quadratic_format = MPS.kQuadraticFormatCPLEX,
    )
    return
end

function test_quadcon_gurobi()
    _test_write_to_file(
        """
        variables: x, y
        c1: x + y + 5.0 * x * x + 1.0 * x * y + 1.0 * y * x + 1.2 * y * y <= 1.0
        """,
        """
        NAME
        ROWS
         N  OBJ
         L  c1
        COLUMNS
            x         c1        1
            y         c1        1
        RHS
            rhs       c1        1
        RANGES
        BOUNDS
         FR bounds    x
         FR bounds    y
        QCMATRIX   c1
            x         x         5
            x         y         1
            y         x         1
            y         y         1.2
        ENDATA
        """,
    )
    return
end

function test_quadcon_cplex()
    _test_write_to_file(
        """
        variables: x, y
        c1: x + y + 5.0 * x * x + 1.0 * x * y + 1.0 * y * x + 1.2 * y * y <= 1.0
        """,
        """
        NAME
        ROWS
         N  OBJ
         L  c1
        COLUMNS
            x         c1        1
            y         c1        1
        RHS
            rhs       c1        1
        RANGES
        BOUNDS
         FR bounds    x
         FR bounds    y
        QCMATRIX   c1
            x         x         10
            x         y         2
            y         x         2
            y         y         2.4
        ENDATA
        """;
        quadratic_format = MPS.kQuadraticFormatCPLEX,
    )
    return
end

function test_round_trip_quadobj_gurobi()
    _test_model_equality(
        """
        variables: x, y
        minobjective: 1.2x + 2.1 * x * x + 1.2 * x * y + 0.2 * y * x + 0.5 * y * y
        """,
        ["x", "y"],
        String[],
    )
    return
end

function test_round_trip_qmatrix_cplex()
    _test_model_equality(
        """
        variables: x, y
        minobjective: 1.2x + 2.1 * x * x + 1.2 * x * y + 0.2 * y * x + 0.5 * y * y
        """,
        ["x", "y"],
        String[];
        quadratic_format = MPS.kQuadraticFormatCPLEX,
    )
    return
end

function test_round_trip_qcmatrix_gurobi()
    _test_model_equality(
        """
        variables: x, y
        minobjective: 1.3 * x * x + 0.5 * x * y
        c1: 1.2x + 2.1 * x * x + 1.2 * x * y + 0.2 * y * x + 0.5 * y * y <= 1.0
        """,
        ["x", "y"],
        ["c1"],
    )
    return
end

function test_round_trip_qcmatrix_cplex()
    _test_model_equality(
        """
        variables: x, y
        minobjective: 1.3 * x * x + 0.5 * x * y
        c1: 1.2x + 2.1 * x * x + 1.2 * x * y + 0.2 * y * x + 0.5 * y * y <= 1.0
        """,
        ["x", "y"],
        ["c1"];
        quadratic_format = MPS.kQuadraticFormatCPLEX,
    )
    return
end

function test_round_trip_qcmatrix_mosek()
    _test_model_equality(
        """
        variables: x, y
        minobjective: 1.3 * x * x + 0.5 * x * y
        c1: 1.2x + 2.1 * x * x + 1.2 * x * y + 0.2 * y * x + 0.5 * y * y <= 1.0
        """,
        ["x", "y"],
        ["c1"];
        quadratic_format = MPS.kQuadraticFormatMosek,
    )
    return
end

function test_round_trip_indicator_lessthan()
    _test_model_equality(
        """
        variables: x, y, z
        minobjective: 1.0 * x + y + z
        z in ZeroOne()
        c1: [z, 1.0 * x + 1.0 * y] in Indicator{ACTIVATE_ON_ONE}(LessThan(1.0))
        """,
        ["x", "y", "z"],
        ["c1"],
        [("z", MOI.ZeroOne())],
    )
    return
end

function test_round_trip_indicator_greaterthan()
    _test_model_equality(
        """
        variables: x, y, z
        minobjective: 1.0 * x + y + z
        z in ZeroOne()
        c1: [z, 1.0 * x + 1.0 * y] in Indicator{ACTIVATE_ON_ONE}(GreaterThan(1.0))
        """,
        ["x", "y", "z"],
        ["c1"],
        [("z", MOI.ZeroOne())],
    )
    return
end

function test_round_trip_indicator_equalto()
    _test_model_equality(
        """
        variables: x, y, z
        minobjective: 1.0 * x + y + z
        z in ZeroOne()
        c1: [z, 1.0 * x + 1.0 * y] in Indicator{ACTIVATE_ON_ONE}(EqualTo(1.0))
        """,
        ["x", "y", "z"],
        ["c1"],
        [("z", MOI.ZeroOne())],
    )
    return
end

function test_round_trip_indicator_lessthan_false()
    _test_model_equality(
        """
        variables: x, y, z
        minobjective: 1.0 * x + y + z
        z in ZeroOne()
        c1: [z, 1.0 * x + 1.0 * y] in Indicator{ACTIVATE_ON_ZERO}(LessThan(1.0))
        """,
        ["x", "y", "z"],
        ["c1"],
        [("z", MOI.ZeroOne())],
    )
    return
end

function test_round_trip_indicator_greaterthan_false()
    _test_model_equality(
        """
        variables: x, y, z
        minobjective: 1.0 * x + y + z
        z in ZeroOne()
        c1: [z, 1.0 * x + 1.0 * y] in Indicator{ACTIVATE_ON_ZERO}(GreaterThan(1.0))
        """,
        ["x", "y", "z"],
        ["c1"],
        [("z", MOI.ZeroOne())],
    )
    return
end

function test_round_trip_indicator_equalto_false()
    _test_model_equality(
        """
        variables: x, y, z
        minobjective: 1.0 * x + y + z
        z in ZeroOne()
        c1: [z, 1.0 * x + 1.0 * y] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(1.0))
        """,
        ["x", "y", "z"],
        ["c1"],
        [("z", MOI.ZeroOne())],
    )
    return
end

function test_vector_supports_constraint()
    model = MPS.Model()
    @test !MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{Float64}},
    )
    @test !MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{Float64},
        MOI.SOS1{Float64},
    )
    return
end

function test_objsense_next_line()
    for (sense, enum) in [("MIN", MOI.MIN_SENSE), ("MAX", MOI.MAX_SENSE)]
        io = IOBuffer()
        write(
            io,
            """
            NAME          model
            OBJSENSE
                $sense
            ROWS
            N  Obj
            """,
        )
        seekstart(io)
        model = MPS.Model()
        Base.read!(io, model)
        @test MOI.get(model, MOI.ObjectiveSense()) == enum
    end
    for (sense, enum) in [("MIN", MOI.MIN_SENSE), ("MAX", MOI.MAX_SENSE)]
        io = IOBuffer()
        write(
            io,
            """
            NAME          model
            OBJSENSE $sense
            ROWS
            N  Obj
            """,
        )
        seekstart(io)
        model = MPS.Model()
        Base.read!(io, model)
        @test MOI.get(model, MOI.ObjectiveSense()) == enum
    end
    for (sense, enum) in [("MIN", MOI.MIN_SENSE), ("MAX", MOI.MAX_SENSE)]
        io = IOBuffer()
        write(
            io,
            """
            NAME          model
            OBJSENSE      $sense
            ROWS
            N  Obj
            """,
        )
        seekstart(io)
        model = MPS.Model()
        Base.read!(io, model)
        @test MOI.get(model, MOI.ObjectiveSense()) == enum
    end
    return
end

function test_parse_name_line()
    data = MPS.TempMPSModel{Float64}()
    for (line, name) in (
        "NAME" => "",
        "NAME   " => "",
        "NAME   \n" => "",
        "NAmE" => "",
        "NaME   " => "",
        "name   \n" => "",
        "name abc" => "abc",
        "NAME PILOTNOV (PILOTS) INTEGRATED MODEL -- NOVEMBER 1979" => "PILOTNOV (PILOTS) INTEGRATED MODEL -- NOVEMBER 1979",
        "Na d" => nothing,
        "the name" => nothing,
        " NAME" => "",
        " NAME foo" => "foo",
        "" => nothing,
    )
        data.name = "_"
        if name === nothing
            @test_throws MPS.ParseError MPS.parse_name_line(data, line)
        else
            MPS.parse_name_line(data, line)
            @test data.name == name
        end
    end
    return
end

function test_binary_with_unneeded_bounds()
    target = """
    NAME
    ROWS
     N  OBJ
    COLUMNS
        MARKER    'MARKER'                 'INTORG'
        x         OBJ       1
        MARKER    'MARKER'                 'INTEND'
    RHS
    RANGES
    BOUNDS
     BV bounds    x
    ENDATA
    """
    for test in [
        """
        variables: x
        minobjective: 1.0 * x
        x in ZeroOne()
        """,
        """
        variables: x
        minobjective: 1.0 * x
        x in ZeroOne()
        x >= 0.0
        x <= 1.0
        """,
        """
        variables: x
        minobjective: 1.0 * x
        x in ZeroOne()
        x in Interval(-0.1, 1.2)
        """,
    ]
        _test_write_to_file(test, target)
    end
    return
end

function test_binary_with_restrictive_bounds()
    target = """
    NAME
    ROWS
     N  OBJ
    COLUMNS
        MARKER    'MARKER'                 'INTORG'
        x         OBJ       1
        MARKER    'MARKER'                 'INTEND'
    RHS
    RANGES
    BOUNDS
     FX bounds    x         1
    ENDATA
    """
    for test in [
        """
        variables: x
        minobjective: 1.0 * x
        x in ZeroOne()
        x >= 0.5
        """,
        """
        variables: x
        minobjective: 1.0 * x
        x in ZeroOne()
        x >= 0.1
        x <= 1.0
        """,
        """
        variables: x
        minobjective: 1.0 * x
        x in ZeroOne()
        x in Interval(0.2, 1.2)
        """,
    ]
        _test_write_to_file(test, target)
    end
    return
end

function test_binary_with_infeasible_bounds()
    target = """
    NAME
    ROWS
     N  OBJ
    COLUMNS
        MARKER    'MARKER'                 'INTORG'
        x         OBJ       1
        MARKER    'MARKER'                 'INTEND'
    RHS
    RANGES
    BOUNDS
     LI bounds    x         1
     UI bounds    x         0
    ENDATA
    """
    for test in [
        """
        variables: x
        minobjective: 1.0 * x
        x in ZeroOne()
        x >= 0.5
        x <= 0.1
        """,
        """
        variables: x
        minobjective: 1.0 * x
        x in ZeroOne()
        x >= 1.0
        x <= 0.0
        """,
        """
        variables: x
        minobjective: 1.0 * x
        x in ZeroOne()
        x in Interval(0.9, 0.1)
        """,
    ]
        _test_write_to_file(test, target)
    end
    return
end

function test_issue_2538()
    model = MPS.Model()
    x = MOI.add_variables(model, 2)
    f = 1.0 * x[1] + 2.0 * x[2] + 3.0 * x[1] * x[2] + 4.0 * x[2] * x[2]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    io = IOBuffer()
    write(io, model)
    model_2 = MPS.Model()
    seekstart(io)
    read!(io, model_2)
    MOI.get(model_2, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    y = MOI.get(model_2, MOI.ListOfVariableIndices())
    g = MOI.get(model_2, MOI.ObjectiveFunction{typeof(f)}())
    @test isapprox(
        g,
        -1.0 * y[1] - 2.0 * y[2] - 3.0 * y[1] * y[2] - 4.0 * y[2] * y[2],
    )
    return
end

function test_qmatrix_objective()
    file = """
    NAME
    ROWS
        N  OBJ
    COLUMNS
        x         OBJ        1
        y         OBJ        1
    RHS
    RANGES
    BOUNDS
        FR bounds    x
        FR bounds    y
    QMATRIX
        x         x         10
        x         y         2.0
        y         x         2.0
        y         y         2.0
    ENDATA
    """
    io = IOBuffer()
    print(io, file)
    seekstart(io)
    model = MPS.Model()
    read!(io, model)
    x, y = MOI.get.(model, MOI.VariableIndex, ["x", "y"])
    F = MOI.ScalarQuadraticFunction{Float64}
    @test isapprox(
        MOI.get(model, MOI.ObjectiveFunction{F}()),
        1.0 * x + 1.0 * y + 5.0 * x * x + 2.0 * x * y + 1.0 * y * y,
    )
    return
end

function test_qsection_objective()
    file = """
    NAME
    ROWS
        N  OBJ
    COLUMNS
        x         OBJ        1
        y         OBJ        1
    RHS
    RANGES
    BOUNDS
        FR bounds    x
        FR bounds    y
    QSECTION      OBJ
        x         x         10
        x         y         2.0
        y         y         2.0
    ENDATA
    """
    io = IOBuffer()
    print(io, file)
    seekstart(io)
    model = MPS.Model()
    read!(io, model)
    x, y = MOI.get.(model, MOI.VariableIndex, ["x", "y"])
    F = MOI.ScalarQuadraticFunction{Float64}
    @test isapprox(
        MOI.get(model, MOI.ObjectiveFunction{F}()),
        1.0 * x + 1.0 * y + 5.0 * x * x + 2.0 * x * y + 1.0 * y * y,
    )
    return
end

function test_qsection_row()
    file = """
    NAME
    ROWS
        N  OBJ
        L  c1
    COLUMNS
        x         c1        1
        y         c1        1
    RHS
        rhs       c1        1
    RANGES
    BOUNDS
        FR bounds    x
        FR bounds    y
    QSECTION      c1
        x         x         10
        x         y         2.0
        y         y         2.0
    ENDATA
    """
    io = IOBuffer()
    print(io, file)
    seekstart(io)
    model = MPS.Model()
    read!(io, model)
    x, y = MOI.get.(model, MOI.VariableIndex, ["x", "y"])
    c1 = MOI.get(model, MOI.ConstraintIndex, "c1")
    @test isapprox(
        MOI.get(model, MOI.ConstraintFunction(), c1),
        1.0 * x + 1.0 * y + 10.0 * x * x + 4.0 * x * y + 2.0 * y * y,
    )
    return
end

function test_qcmatrix_read_gurobi()
    file = """
    NAME
    ROWS
        N  OBJ
        L  c1
    COLUMNS
        x         c1        1
        y         c1        1
    RHS
        rhs       c1        1
    RANGES
    BOUNDS
        FR bounds    x
        FR bounds    y
    QCMATRIX   c1
        x         x         10
        x         y         2.0
        y         x         2.0
        y         y         2.0
    ENDATA
    """
    io = IOBuffer()
    print(io, file)
    seekstart(io)
    model = MPS.Model()
    read!(io, model)
    x, y = MOI.get.(model, MOI.VariableIndex, ["x", "y"])
    c1 = MOI.get(model, MOI.ConstraintIndex, "c1")
    @test isapprox(
        MOI.get(model, MOI.ConstraintFunction(), c1),
        1.0 * x + 1.0 * y + 10.0 * x * x + 4.0 * x * y + 2.0 * y * y,
    )
    return
end

function test_qcmatrix_read_cplex()
    file = """
    NAME
    ROWS
        N  OBJ
        L  c1
    COLUMNS
        x         c1        1
        y         c1        1
    RHS
        rhs       c1        1
    RANGES
    BOUNDS
        FR bounds    x
        FR bounds    y
    QCMATRIX   c1
        x         x         1.0
        x         y         2.0
        y         x         2.0
        y         y         7.0
    ENDATA
    """
    io = IOBuffer()
    print(io, file)
    seekstart(io)
    model = MPS.Model(; quadratic_format = MPS.kQuadraticFormatCPLEX)
    read!(io, model)
    x, y = MOI.get.(model, MOI.VariableIndex, ["x", "y"])
    c1 = MOI.get(model, MOI.ConstraintIndex, "c1")
    @test isapprox(
        MOI.get(model, MOI.ConstraintFunction(), c1),
        1.0 * x + 1.0 * y + 0.5 * x * x + 2.0 * x * y + 3.5 * y * y,
    )
    return
end

function test_model_Name()
    model = MPS.Model()
    MOI.set(model, MOI.Name(), "TestFoo")
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    contents = read(io, String)
    @test occursin("NAME          TestFoo", contents)
    return
end

function test_model_large_integer()
    model = MPS.Model()
    x = MOI.add_constrained_variable(model, MOI.GreaterThan(123.0))
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    contents = read(io, String)
    @test occursin("LO bounds    x1        123", contents)
    return
end

function test_model_not_empty()
    model = MPS.Model()
    x = MOI.add_variable(model)
    io = IOBuffer()
    @test_throws(
        ErrorException("Cannot read in file because model is not empty."),
        read!(io, model),
    )
    return
end

function test_rhs_free_row()
    io = IOBuffer("""
    NAME
    ROWS
        N  OBJ
        N  c
    COLUMNS
        x         OBJ        1
        x         c          1
    RHS
        rhs       c          1
    RANGES
    BOUNDS
        FR bounds x
    ENDATA
    """)
    model = MPS.Model()
    @test_throws MPS.ParseError read!(io, model)
    return
end

function test_malformed_indicator()
    io = IOBuffer("""
    NAME
    ROWS
        N  OBJ
    COLUMNS
        x         OBJ        1
        y         OBJ        1
    RHS
    RANGES
    BOUNDS
        FR bounds x
        BV bounds y
    INDICATORS
     IF c1        y
    ENDATA
    """)
    model = MPS.Model()
    @test_throws MPS.ParseError read!(io, model)
    return
end

function test_unsupported_variable_types()
    model = MPS.Model()
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Parameter(2.0)),
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Semicontinuous(2.0, 3.0)),
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Semiinteger(2.0, 3.0)),
    )
    return
end

function _test_int_round_trip(src)
    model = MOI.FileFormats.MPS.Model(; coefficient_type = Int)
    io = IOBuffer()
    write(io, src)
    seekstart(io)
    read!(io, model)
    seekstart(io)
    write(io, model)
    seekstart(io)
    file = read(io, String)
    @test file == src
    return
end

function test_int_round_trip()
    for src in [
        """
        NAME
        ROWS
         N  OBJ
         G  c
        COLUMNS
            x         c         3
            x         OBJ       2
        RHS
            rhs       c         2
            rhs       OBJ       -3
        RANGES
        BOUNDS
         LO bounds    x         1
         PL bounds    x
        ENDATA
        """,
        """
        NAME
        ROWS
         N  OBJ
         L  c1
        COLUMNS
            x         c1        1
            y         c1        1
        RHS
            rhs       c1        1
        RANGES
        BOUNDS
         FR bounds    x
         FR bounds    y
        QCMATRIX   c1
            x         x         1
            x         y         2
            y         x         2
            y         y         7
        ENDATA
        """,
    ]
        _test_int_round_trip(src)
    end
    return
end

function test_obj_constant_min()
    model = MOI.FileFormats.MPS.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = 1.0 * x + 2.0
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    io = IOBuffer()
    write(io, model)
    dest = MOI.FileFormats.MPS.Model()
    seekstart(io)
    read!(io, dest)
    g = MOI.get(dest, MOI.ObjectiveFunction{typeof(f)}())
    @test g.constant == 2.0
    @test MOI.get(dest, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    return
end

function test_obj_constant_max_to_min()
    model = MOI.FileFormats.MPS.Model()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = 1.0 * x + 2.0
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    io = IOBuffer()
    write(io, model)
    dest = MOI.FileFormats.MPS.Model()
    seekstart(io)
    read!(io, dest)
    g = MOI.get(dest, MOI.ObjectiveFunction{typeof(f)}())
    @test g.constant == -2.0
    @test MOI.get(dest, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    return
end

function test_obj_constant_max_to_max()
    model = MOI.FileFormats.MPS.Model(; print_objsense = true)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = 1.0 * x + 2.0
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    io = IOBuffer()
    write(io, model)
    dest = MOI.FileFormats.MPS.Model()
    seekstart(io)
    read!(io, dest)
    g = MOI.get(dest, MOI.ObjectiveFunction{typeof(f)}())
    @test g.constant == 2.0
    @test MOI.get(dest, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    return
end

function test_duplicate_coefficient()
    model = MPS.Model()
    MOI.read_from_file(model, joinpath(@__DIR__, "duplicate_coefficient.mps"))
    dest = MOI.Utilities.Model{Float64}()
    MOI.copy_to(dest, model)
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    x = only(MOI.get(dest, MOI.ListOfVariableIndices()))
    c = only(MOI.get(dest, MOI.ListOfConstraintIndices{F,S}()))
    f = MOI.get(dest, MOI.ConstraintFunction(), c)
    @test isapprox(f, 2.0 * x)
    @test MOI.get(dest, MOI.ConstraintSet(), c) == MOI.EqualTo(1.0)
    return
end

function test_issue_2792()
    src = """
    NAME
    ROWS
     N  OBJ       \$t3       0
    COLUMNS
        x         OBJ       2
    RHS
        rhs       OBJ       -3
    BOUNDS
     LO bounds    x         1
     PL bounds    x
    ENDATA
    """
    model = MPS.Model()
    read!(IOBuffer(src), model)
    dest = MOI.Utilities.Model{Float64}()
    MOI.copy_to(dest, model)
    @test MOI.get(dest, MOI.ListOfConstraintTypesPresent()) ==
          [(MOI.VariableIndex, MOI.GreaterThan{Float64})]
    x = only(MOI.get(dest, MOI.ListOfVariableIndices()))
    F = MOI.get(dest, MOI.ObjectiveFunctionType())
    f = MOI.get(dest, MOI.ObjectiveFunction{F}())
    @test isapprox(f, 2.0 * x + 3.0)
    return
end

function test_issue_2797_tab()
    @test MPS.line_to_items("a b") == ["a", "b"]
    @test MPS.line_to_items(" a b") == ["a", "b"]
    @test MPS.line_to_items("a\tb") == ["a", "b"]
    @test MPS.line_to_items("a\tb") == ["a", "b"]
    @test MPS.line_to_items("a\t b") == ["a", "b"]
    @test MPS.line_to_items(" a \t b      c ") == ["a", "b", "c"]
    return
end

function test_unsupported_objectives()
    model = MPS.Model()
    for (F, ret) in [
        MOI.VariableIndex => true,
        MOI.ScalarAffineFunction{Float64} => true,
        MOI.ScalarQuadraticFunction{Float64} => true,
        MOI.ScalarNonlinearFunction => false,
        MOI.VectorOfVariables => false,
        MOI.VectorAffineFunction{Float64} => false,
        MOI.VectorQuadraticFunction{Float64} => false,
        MOI.VectorNonlinearFunction => false,
    ]
        @test MOI.supports(model, MOI.ObjectiveFunction{F}()) == ret
    end
    return
end

end  # TestMPS

TestMPS.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    IndicatorToMILPBridge{T,F,A,S} <: Bridges.Constraint.AbstractBridge

`IndicatorToMILPBridge` implements the following reformulation:

  * ``x \\in \\textsf{Indicator}(s)`` into a mixed-integer linear program.

## Source node

`IndicatorToMILPBridge` supports:

  * `F` in [`MOI.Indicator{A,S}`](@ref)

where `F` is [`MOI.VectorOfVariables`](@ref) or
[`MOI.VectorAffineFunction{T}`](@ref).

## Target nodes

`IndicatorToMILPBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in `S`
"""
mutable struct IndicatorToMILPBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
    A,
    S<:Union{MOI.LessThan{T},MOI.GreaterThan{T},MOI.EqualTo{T}},
} <: AbstractBridge
    f::F
    s::MOI.Indicator{A,S}
    slack::Union{Nothing,MOI.VariableIndex}
    constraint::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},S}
    slack_bounds::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
    }
    bounds::NTuple{2,T}
    function IndicatorToMILPBridge{T}(
        f::Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
        s::MOI.Indicator{A,S},
    ) where {T,A,S}
        return new{T,typeof(f),A,S}(
            f,
            s,
            nothing,
            MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},S}(0),
            MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}}[],
            (typemin(T), typemax(T)),
        )
    end
end

const IndicatorToMILP{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{IndicatorToMILPBridge{T},OT}

function bridge_constraint(
    ::Type{IndicatorToMILPBridge{T,F,A,S}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.Indicator{A,S},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},A,S}
    # !!! info
    #     Postpone rest of creation until final_touch.
    return IndicatorToMILPBridge{T}(f, s)
end

function MOI.supports_constraint(
    ::Type{<:IndicatorToMILPBridge{T}},
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}},
    ::Type{<:MOI.Indicator{A,S}},
) where {T,A,S<:Union{MOI.LessThan{T},MOI.GreaterThan{T},MOI.EqualTo{T}}}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:IndicatorToMILPBridge},
)
    return Tuple{Type}[(MOI.Reals,), (MOI.ZeroOne,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:IndicatorToMILPBridge{T,F,A,S}},
) where {T,F,A,S}
    return Tuple{Type,Type}[
        (MOI.ScalarAffineFunction{T}, S),
        (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:IndicatorToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.Indicator{A,S}},
) where {
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
    A,
    S<:Union{MOI.LessThan{T},MOI.GreaterThan{T},MOI.EqualTo{T}},
}
    return IndicatorToMILPBridge{T,F,A,S}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::IndicatorToMILPBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::IndicatorToMILPBridge,
)
    return bridge.s
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::IndicatorToMILPBridge{T},
) where {T}
    if bridge.slack === nothing
        return  # We're deleting the bridge before final_touch
    end
    MOI.delete.(model, bridge.slack_bounds)
    MOI.delete(model, bridge.constraint)
    MOI.delete(model, bridge.slack::MOI.VariableIndex)
    bridge.slack = nothing
    empty(bridge.slack_bounds)
    bridge.bounds = (typemin(T), typemax(T))
    return
end

MOI.get(bridge::IndicatorToMILPBridge, ::MOI.NumberOfVariables)::Int64 = 1

function MOI.get(bridge::IndicatorToMILPBridge, ::MOI.ListOfVariableIndices)
    return [bridge.slack::MOI.VariableIndex]
end

function MOI.get(
    bridge::IndicatorToMILPBridge{T,F,A,S},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},S},
)::Int64 where {T,F,A,S<:Union{MOI.GreaterThan,MOI.EqualTo}}
    return 1
end

function MOI.get(
    bridge::IndicatorToMILPBridge{T,F,A,S},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},S},
) where {T,F,A,S}
    return [bridge.constraint]
end

function MOI.get(
    bridge::IndicatorToMILPBridge{T,F,A,<:Union{MOI.GreaterThan,MOI.EqualTo}},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
)::Int64 where {T,F,A}
    return length(bridge.slack_bounds)
end

function MOI.get(
    bridge::IndicatorToMILPBridge{T,F,A,<:Union{MOI.GreaterThan,MOI.EqualTo}},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
) where {T,F,A}
    return copy(bridge.slack_bounds)
end

function MOI.get(
    bridge::IndicatorToMILPBridge{T,F,A,MOI.LessThan{T}},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
)::Int64 where {T,F,A}
    return 1 + length(bridge.slack_bounds)
end

function MOI.get(
    bridge::IndicatorToMILPBridge{T,F,A,MOI.LessThan{T}},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
) where {T,F,A}
    return vcat(bridge.constraint, bridge.slack_bounds)
end

MOI.Bridges.needs_final_touch(::IndicatorToMILPBridge) = true

function _is_binary(model::MOI.ModelLike, f::MOI.AbstractScalarFunction)
    x = convert(MOI.VariableIndex, f)
    return _is_binary(model, x)
end

function _is_binary(model::MOI.ModelLike, x::MOI.VariableIndex)
    return MOI.is_valid(
        model,
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(x.value),
    )
end

function MOI.Bridges.final_touch(
    bridge::IndicatorToMILPBridge{T,F,A,S},
    model::MOI.ModelLike,
) where {T,F,A,S}
    bounds = Dict{MOI.VariableIndex,NTuple{2,T}}()
    scalars = collect(MOI.Utilities.eachscalar(bridge.f))
    fi = scalars[2]
    ret = MOI.Utilities.get_bounds(model, bounds, fi)
    if ret === nothing
        throw(MOI.Bridges.BridgeRequiresFiniteDomainError(bridge, fi))
    elseif !_is_binary(model, scalars[1])
        msg = "Unable to reformulate indicator constraint to a MILP. The indicator variable must be binary."
        throw(MOI.AddConstraintNotAllowed{F,MOI.Indicator{A,S}}(msg))
    end
    if bridge.slack === nothing
        # This is the first time calling final_touch
        bridge.bounds = ret
    elseif bridge.bounds == ret
        # We've called final_touch before, and the bounds match. No need to
        # reformulate a second time.
        return
    elseif bridge.bounds != ret
        # There is a stored bound, and the current bounds do not match. This
        # means the model has been modified since the previous call to
        # final_touch. We need to delete the bridge and start again.
        MOI.delete(model, bridge)
        MOI.Bridges.final_touch(bridge, model)
        return
    end
    bridge.slack = MOI.add_variable(model)
    bridge.constraint = MOI.Utilities.normalize_and_add_constraint(
        model,
        MOI.Utilities.operate(+, T, fi, bridge.slack),
        bridge.s.set;
        allow_modify_function = true,
    )
    _bound_slack(model, bridge, scalars[1], bridge.s)
    return
end

function _to_rhs(A::MOI.ActivationCondition, ::Type{T}, z) where {T}
    if A == MOI.ACTIVATE_ON_ZERO
        return z
    end
    return MOI.Utilities.operate(-, T, one(T), z)
end

function _bound_slack(
    model::MOI.ModelLike,
    bridge::IndicatorToMILPBridge{T},
    z,
    set::MOI.Indicator{A,MOI.GreaterThan{T}},
) where {T,A}
    # {f(x) + y >= b} => {y <= (b - ⌊f(x)⌋)₊ * rhs}
    M = max(zero(T), set.set.lower - bridge.bounds[1])
    c = MOI.Utilities.normalize_and_add_constraint(
        model,
        MOI.Utilities.operate(-, T, bridge.slack, M * _to_rhs(A, T, z)),
        MOI.LessThan(zero(T));
        allow_modify_function = true,
    )
    push!(bridge.slack_bounds, c)
    return
end

function _bound_slack(
    model::MOI.ModelLike,
    bridge::IndicatorToMILPBridge{T},
    z,
    set::MOI.Indicator{A,MOI.LessThan{T}},
) where {T,A}
    # {f(x) + y <= b} => {y >= (b - ⌈f(x)⌉)₋ * rhs}
    M = min(zero(T), set.set.upper - bridge.bounds[2])
    c = MOI.Utilities.normalize_and_add_constraint(
        model,
        MOI.Utilities.operate!(-, T, M * _to_rhs(A, T, z), bridge.slack),
        MOI.LessThan(zero(T));
        allow_modify_function = true,
    )
    push!(bridge.slack_bounds, c)
    return
end

function _bound_slack(
    model::MOI.ModelLike,
    bridge::IndicatorToMILPBridge{T},
    z,
    set::MOI.Indicator{A,MOI.EqualTo{T}},
) where {T,A}
    b = set.set.value
    _bound_slack(model, bridge, z, MOI.Indicator{A}(MOI.LessThan(b)))
    _bound_slack(model, bridge, z, MOI.Indicator{A}(MOI.GreaterThan(b)))
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

function test_multiobjective_vector_of_variables(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorOfVariables
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.VectorOfVariables(x)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) == f
    return
end

version_added(::typeof(test_multiobjective_vector_of_variables)) = v"1.12.0"

function test_multiobjective_vector_of_variables_delete(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorOfVariables
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.VectorOfVariables(x)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) == f
    MOI.delete(model, x[1])
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ==
          MOI.VectorOfVariables([x[2]])
    return
end

function version_added(::typeof(test_multiobjective_vector_of_variables_delete))
    return v"1.12.0"
end

function test_multiobjective_vector_of_variables_delete_all(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorOfVariables
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.VectorOfVariables(x)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) == f
    MOI.delete(model, x[1])
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ==
          MOI.VectorOfVariables([x[2]])
    MOI.delete(model, x[2])
    # ObjectiveFunction no longer set because we deleted all the variables
    attributes = MOI.get(model, MOI.ListOfModelAttributesSet())
    @test !(MOI.ObjectiveFunction{F}() in attributes)
    return
end

function version_added(
    ::typeof(test_multiobjective_vector_of_variables_delete_all),
)
    return v"1.12.0"
end

function test_multiobjective_vector_of_variables_delete_vector(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorOfVariables
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.VectorOfVariables(x)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) == f
    attributes = MOI.get(model, MOI.ListOfModelAttributesSet())
    @test MOI.ObjectiveFunction{F}() in attributes
    MOI.delete(model, x)
    # ObjectiveFunction no longer set because we deleted all the variables
    attributes = MOI.get(model, MOI.ListOfModelAttributesSet())
    @test !(MOI.ObjectiveFunction{F}() in attributes)
    return
end

function version_added(
    ::typeof(test_multiobjective_vector_of_variables_delete_vector),
)
    return v"1.12.0"
end

function test_multiobjective_vector_affine_function(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorAffineFunction{T}
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, T, T(1) * x[1], T(2) * x[2] + T(3))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    return
end

version_added(::typeof(test_multiobjective_vector_affine_function)) = v"1.12.0"

function test_multiobjective_vector_affine_function_modify(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorAffineFunction{T}
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, T, T(1) * x[1], T(2) * x[2] + T(3))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    MOI.modify(
        model,
        MOI.ObjectiveFunction{F}(),
        MOI.VectorConstantChange(T[4, 5]),
    )
    f.constants .= T[4, 5]
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    return
end

function version_added(
    ::typeof(test_multiobjective_vector_affine_function_modify),
)
    return v"1.12.0"
end

function test_multiobjective_vector_affine_function_delete(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorAffineFunction{T}
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, T, T(1) * x[1], T(2) * x[2] + T(3))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    MOI.delete(model, x[1])
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈
          MOI.Utilities.operate(vcat, T, T(0), T(2) * x[2] + T(3))
    return
end

function version_added(
    ::typeof(test_multiobjective_vector_affine_function_delete),
)
    return v"1.12.0"
end

function test_multiobjective_vector_affine_function_delete_vector(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorAffineFunction{T}
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, T, T(1) * x[1], T(2) * x[2] + T(3))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    MOI.delete(model, x)
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈
          MOI.VectorAffineFunction{T}(MOI.VectorAffineTerm{T}[], T[0, 3])
    return
end

function version_added(
    ::typeof(test_multiobjective_vector_affine_function_delete_vector),
)
    return v"1.12.0"
end

function test_multiobjective_vector_quadratic_function(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorQuadraticFunction{T}
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, T, (T(1) .* x .* x)...)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    return
end

function version_added(::typeof(test_multiobjective_vector_quadratic_function))
    return v"1.12.0"
end

function test_multiobjective_vector_quadratic_function_modify(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorQuadraticFunction{T}
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, T, (T(1) .* x .* x)...)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    MOI.modify(
        model,
        MOI.ObjectiveFunction{F}(),
        MOI.VectorConstantChange(T[4, 5]),
    )
    f.constants .= T[4, 5]
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    return
end

function version_added(
    ::typeof(test_multiobjective_vector_quadratic_function_modify),
)
    return v"1.12.0"
end

function test_multiobjective_vector_quadratic_function_delete(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorQuadraticFunction{T}
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, T, (T(1) .* x .* x)...)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    MOI.delete(model, x[1])
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈
          MOI.Utilities.operate(vcat, T, T(0), T(1) * x[2] * x[2])
    return
end

function version_added(
    ::typeof(test_multiobjective_vector_quadratic_function_delete),
)
    return v"1.12.0"
end

function test_multiobjective_vector_quadratic_function_delete_vector(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorQuadraticFunction{T}
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, T, (T(1) .* x .* x)...)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    MOI.delete(model, x)
    new_f = MOI.VectorQuadraticFunction{T}(
        MOI.VectorQuadraticTerm{T}[],
        MOI.VectorAffineTerm{T}[],
        zeros(T, 2),
    )
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ new_f
    return
end

function version_added(
    ::typeof(test_multiobjective_vector_quadratic_function_delete_vector),
)
    return v"1.12.0"
end

function test_multiobjective_vector_nonlinear(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    f = MOI.VectorNonlinearFunction(
        Any[MOI.ScalarNonlinearFunction(:^, Any[x[1], 2]), x[2]],
    )  # [x[1]^2, x[2]]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    return
end

version_added(::typeof(test_multiobjective_vector_nonlinear)) = v"1.19.0"

function test_multiobjective_vector_nonlinear_delete(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    f = MOI.VectorNonlinearFunction(
        Any[MOI.ScalarNonlinearFunction(:^, Any[x[1], 2]), x[2]],
    )  # [x[1]^2, x[2]]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    @test_throws MOI.DeleteNotAllowed MOI.delete(model, x[1])
    return
end

version_added(::typeof(test_multiobjective_vector_nonlinear_delete)) = v"1.19.0"

function test_multiobjective_vector_nonlinear_delete_vector(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    f = MOI.VectorNonlinearFunction(
        Any[MOI.ScalarNonlinearFunction(:^, Any[x[1], 2]), x[2]],
    )  # [x[1]^2, x[2]]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, MOI.ObjectiveFunction{F}()) ≈ f
    @test_throws MOI.DeleteNotAllowed MOI.delete(model, x)
    return
end

function version_added(
    ::typeof(test_multiobjective_vector_nonlinear_delete_vector),
)
    return v"1.19.0"
end

function test_multiobjective_vector_nonlinear_modify(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VectorNonlinearFunction
    attr = MOI.ObjectiveFunction{F}()
    @requires MOI.supports(model, attr)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    f = MOI.VectorNonlinearFunction(
        Any[MOI.ScalarNonlinearFunction(:^, Any[x[1], 2]), x[2]],
    )  # [x[1]^2, x[2]]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, attr, f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    @test MOI.get(model, attr) ≈ f
    @test_throws(
        MOI.ModifyObjectiveNotAllowed,
        MOI.modify(model, attr, MOI.VectorConstantChange(T[1, 2])),
    )
    return
end

version_added(::typeof(test_multiobjective_vector_nonlinear_modify)) = v"1.19.0"

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestSDPA

using Test

import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU
import MathOptInterface.FileFormats: SDPA

const SDPA_TEST_FILE = "test.sdpa"
const SDPA_MODELS_DIR = joinpath(@__DIR__, "models")

function runtests()
    for name in names(@__MODULE__, all = true)
        if startswith("$(name)", "test_")
            @testset "$name" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    sleep(1.0)  # Allow time for unlink to happen.
    rm(SDPA_TEST_FILE, force = true)
    return
end

function _set_var_and_con_names(model::MOI.ModelLike)
    variable_names = String[]
    for j in MOI.get(model, MOI.ListOfVariableIndices())
        var_name_j = "v" * string(j.value)
        push!(variable_names, var_name_j)
        MOI.set(model, MOI.VariableName(), j, var_name_j)
    end

    idx = 0
    constraint_names = String[]
    single_variable_constraints = Tuple[]
    for i in MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Integer}(),
    )
        idx += 1
        x = MOI.get(model, MOI.VariableName(), MOI.VariableIndex(i.value))
        push!(single_variable_constraints, (x, MOI.Integer()))
    end
    for i in Iterators.flatten((
        MOI.get(
            model,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.Nonnegatives,
            }(),
        ),
        MOI.get(
            model,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            }(),
        ),
    ))
        idx += 1
        con_name_i = "c" * string(idx)
        push!(constraint_names, con_name_i)
        MOI.set(model, MOI.ConstraintName(), i, con_name_i)
    end

    return variable_names, constraint_names, single_variable_constraints
end

function _test_write_then_read(model_string::String)
    model1 = SDPA.Model()
    MOIU.loadfromstring!(model1, model_string)
    args = _set_var_and_con_names(model1)

    MOI.write_to_file(model1, SDPA_TEST_FILE)
    model2 = SDPA.Model()
    MOI.read_from_file(model2, SDPA_TEST_FILE)
    _set_var_and_con_names(model2)
    if MOI.get(model1, MOI.ObjectiveSense()) == MOI.MAX_SENSE
        MOI.set(model2, MOI.ObjectiveSense(), MOI.MAX_SENSE)
        attr = MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}()
        obj = MOI.get(model2, attr)
        MOI.set(model2, attr, MOIU.operate(-, Float64, obj))
    end

    return MOI.Test.util_test_models_equal(model1, model2, args...)
end

function _test_read(filename::String, model_string::String)
    model1 = MOI.FileFormats.Model(filename = filename)
    MOIU.loadfromstring!(model1, model_string)
    args = _set_var_and_con_names(model1)
    model2 = SDPA.Model()
    MOI.read_from_file(model2, filename)
    _set_var_and_con_names(model2)
    return MOI.Test.util_test_models_equal(model1, model2, args...)
end

function test_show()
    @test sprint(summary, SDPA.Model()) == "MOI.FileFormats.SDPA.Model"
    return
end

function test_support()
    for set in [
        MOI.EqualTo(1.0),
        MOI.LessThan(1.0),
        MOI.GreaterThan(1.0),
        MOI.Interval(1.0, 2.0),
        MOI.Semiinteger(1.0, 2.0),
        MOI.Semicontinuous(1.0, 2.0),
        MOI.ZeroOne(),
    ]
        model_string = """
        variables: x
        minobjective: 1x
        x in $set
        """
        model = SDPA.Model()
        @test !MOI.supports_constraint(model, MOI.VariableIndex, typeof(set))
        err = MOI.UnsupportedConstraint{MOI.VariableIndex,typeof(set)}
        @test_throws err MOIU.loadfromstring!(model, model_string)
    end
end

function test_delete()
    for T in [Int, Float64]
        model = SDPA.Model(; number_type = T)
        x = MOI.add_variable(model)
        MOI.delete(model, x)
        y = MOI.add_variable(model)
        MOI.add_constraint(
            model,
            MOIU.vectorize([one(T) * y]),
            MOI.Nonnegatives(1),
        )
        err = ErrorException(
            "Non-contiguous variable indices not supported. This might be due to deleted variables.",
        )
        @test_throws err MOI.write_to_file(model, SDPA_TEST_FILE)
    end
end

function test_objective()
    for T in [Int, Float64]
        model = SDPA.Model(; number_type = T)
        @test !MOI.supports(model, MOI.ObjectiveFunction{MOI.VariableIndex}())
        @test !MOI.supports(
            model,
            MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(),
        )
        model = SDPA.Model(; coefficient_type = T)
        @test !MOI.supports(model, MOI.ObjectiveFunction{MOI.VariableIndex}())
        @test !MOI.supports(
            model,
            MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}(),
        )
    end
end

function test_nonempty()
    model = SDPA.Model()
    MOI.add_variable(model)
    err = ErrorException("Cannot read in file because model is not empty.")
    @test_throws err MOI.read_from_file(
        model,
        joinpath(SDPA_MODELS_DIR, "example_A.dat-s"),
    )
end

function test_bad_blocks()
    model = SDPA.Model()
    err = ErrorException(
        "The number of blocks (3) does not match the length of the list of blocks dimensions (2).",
    )
    @test_throws err MOI.read_from_file(
        model,
        joinpath(SDPA_MODELS_DIR, "bad_blocks.sdpa"),
    )
end

function test_bad_number_variables()
    model = SDPA.Model()
    err = ErrorException(
        "The number of variables (3) does not match the length of the list of coefficients for the objective function vector of coefficients (2).",
    )
    @test_throws err MOI.read_from_file(
        model,
        joinpath(SDPA_MODELS_DIR, "bad_vars.sdpa"),
    )
end

function test_wrong_number_of_values_in_entry()
    model = SDPA.Model()
    err = ErrorException(
        "Invalid line specifying entry: 0 1 2 2. There are 4 values instead of 5.",
    )
    @test_throws err MOI.read_from_file(
        model,
        joinpath(SDPA_MODELS_DIR, "bad_entry.sdpa"),
    )
end

function test_nondiagonal_entry()
    model = SDPA.Model()
    err = ErrorException(
        "Invalid line specifying entry: 0 1 1 2 1.0. `1 != 2` while block 1 has dimension 2 so it is a diagonal block.",
    )
    @test_throws err MOI.read_from_file(
        model,
        joinpath(SDPA_MODELS_DIR, "bad_diag.sdpa"),
    )
end

function test_nonzero_in_objective()
    model = SDPA.Model()
    MOIU.loadfromstring!(
        model,
        """
variables: x
minobjective: x + 1
""",
    )
    err = ErrorException(
        "Nonzero constant in objective function not supported. Note that " *
        "the constant may be added by the substitution of a bridged variable.",
    )
    @test_throws err MOI.write_to_file(model, SDPA_TEST_FILE)
end

function test_model_name()
    model = SDPA.Model()
    MOI.set(model, MOI.Name(), "FooBar")
    MOI.write_to_file(model, SDPA_TEST_FILE)
    @test readlines(SDPA_TEST_FILE) == ["\"FooBar", "0", "0", "", ""]
end

const _WRITE_READ_MODELS = [
    (
        "min ScalarAffine",
        """
    variables: x, y
    minobjective: 1.2x + -1y
""",
    ),
    (
        "max ScalarAffine",
        """
    variables: x, y
    maxobjective: 1.2x + -1y
""",
    ),
    (
        "VectorAffineFunction in Nonnegatives",
        """
    variables: x, y
    minobjective: 1.2x
    c1: [1.1 * x, y + 1] in Nonnegatives(2)
""",
    ),
    (
        "VectorAffineFunction in PositiveSemidefiniteConeTriangle",
        """
    variables: x, y, z
    minobjective: 1.2x
    c1: [1.1x, y + 1, 2x + z] in PositiveSemidefiniteConeTriangle(2)
""",
    ),
]

function test_write_read_models()
    for (model_name, model_string) in _WRITE_READ_MODELS
        _test_write_then_read(model_string)
    end
end

const _EXAMPLE_MODELS = [
    (
        "example_A.dat-s",
        """
    variables: x, y
    minobjective: 10x + 20y
    c1: [x + -1, 0, x + y + -2] in PositiveSemidefiniteConeTriangle(2)
    c2: [5y + -3, 2y, 6y + -4] in PositiveSemidefiniteConeTriangle(2)
""",
    ),
    (
        "example_B.sdpa",
        """
    variables: x
    minobjective: 1x
    c1: [0, 1x + -1, 0] in PositiveSemidefiniteConeTriangle(2)
""",
    ),
    (
        "example_integer.sdpa",
        """
    variables: x, y, z
    minobjective: 1x + -2y + -1z
    c1: [1x, 1y, 1z] in PositiveSemidefiniteConeTriangle(2)
    c2: [1z, 1x, 2.1] in PositiveSemidefiniteConeTriangle(2)
    c3: [1x + 1y + 1z + -1, -1x + -1y + -1z + 8] in Nonnegatives(2)
    x in Integer()
    y in Integer()
    z in Integer()
""",
    ),
    (
        "issue_1541.dat-s",
        """
    variables: x, y, z
    minobjective: -1y + -2z
    c1: [-1x + -1y + -1z + 1, 1x, 1y, 1z] in Nonnegatives(4)
    c2: [1x + 3y, 4y + 2z, -1z] in PositiveSemidefiniteConeTriangle(2)
""",
    ),
]

function test_examples()
    for (model_name, model_string) in _EXAMPLE_MODELS
        _test_read(joinpath(SDPA_MODELS_DIR, model_name), model_string)
        _test_write_then_read(model_string)
    end
end

# See https://github.com/jump-dev/MathOptInterface.jl/issues/1541
_spacer(char) = [" ", "$char", " $char", "$char ", " $char "]

function test_dim_reader()
    fn(line) = SDPA._dim_to_set.(SDPA._split(line))
    for (a, b) in ['{' => '}', '(' => ')']
        for pre in _spacer(a), sep in _spacer(','), suf in _spacer(b)
            @test fn("$(pre)-4$(sep)2$suf") ==
                  [MOI.Nonnegatives(4), MOI.PositiveSemidefiniteConeTriangle(2)]
            @test fn("$(pre)2$(sep)-4$suf") ==
                  [MOI.PositiveSemidefiniteConeTriangle(2), MOI.Nonnegatives(4)]
        end
    end
    return
end

function test_integer_before_variables()
    file = """
    *INTEGER
    *1
    """
    io = IOBuffer()
    print(io, file)
    seekstart(io)
    model = SDPA.Model()
    @test_throws(
        ErrorException(
            "The number of variables should be given before *INTEGER section.",
        ),
        read!(io, model),
    )
    return
end

function test_unsupported_variable_types()
    model = SDPA.Model()
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Parameter(2.0)),
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Semicontinuous(2.0, 3.0)),
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Semiinteger(2.0, 3.0)),
    )
    return
end

function test_example_A_integer_coefficients()
    filename = joinpath(SDPA_MODELS_DIR, "example_A_int.dat-s")
    model = MOI.FileFormats.SDPA.Model(; coefficient_type = Int)
    MOI.read_from_file(model, filename)
    for xi in MOI.get(model, MOI.ListOfVariableIndices())
        MOI.set(model, MOI.VariableName(), xi, "v$(xi.value)")
    end
    F, S = MOI.VectorAffineFunction{Int}, MOI.PositiveSemidefiniteConeTriangle
    for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        MOI.set(model, MOI.ConstraintName(), ci, "c$(ci.value)")
    end
    input = """
    variables: v1, v2
    minobjective::Int: 10v1 + 20v2
    c1::Int: [v1 + -1, 0, v1 + v2 + -2] in PositiveSemidefiniteConeTriangle(2)
    c2::Int: [5v2 + -3, 2v2, 6v2 + -4] in PositiveSemidefiniteConeTriangle(2)
    """
    target = MOI.Utilities.Model{Int}()
    MOI.Utilities.loadfromstring!(target, input)
    MOI.Test.util_test_models_equal(model, target, ["v1", "v2"], ["c1", "c2"])
    return
end

function test_unsupported_objectives()
    model = SDPA.Model()
    for (F, ret) in [
        MOI.VariableIndex => false,
        MOI.ScalarAffineFunction{Float64} => true,
        MOI.ScalarQuadraticFunction{Float64} => false,
        MOI.ScalarNonlinearFunction => false,
        MOI.VectorOfVariables => false,
        MOI.VectorAffineFunction{Float64} => false,
        MOI.VectorQuadraticFunction{Float64} => false,
        MOI.VectorNonlinearFunction => false,
    ]
        @test MOI.supports(model, MOI.ObjectiveFunction{F}()) == ret
    end
    return
end

end  # module

TestSDPA.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestInstantiate

using Test
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
end

struct DummyOptimizer <: MOI.AbstractOptimizer end

MOI.is_empty(::DummyOptimizer) = true

function MOI.default_cache(::DummyOptimizer, ::Type{T}) where {T}
    return MOI.Utilities.Model{T}()
end

function _test_instantiate(T)
    function f()
        return MOI.Utilities.MockOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}()),
        )
    end
    optimizer_constructor =
        MOI.OptimizerWithAttributes(f, MOI.Silent() => true, "a" => 1, "b" => 2)
    optimizer = MOI.instantiate(optimizer_constructor)
    @test optimizer isa MOI.Utilities.MockOptimizer{
        MOI.Utilities.UniversalFallback{MOI.Utilities.Model{T}},
        Float64,
    }
    @test MOI.get(optimizer, MOI.Silent())
    optimizer = MOI.instantiate(optimizer_constructor, with_bridge_type = T)
    @test optimizer isa MOI.Bridges.LazyBridgeOptimizer{
        MOI.Utilities.MockOptimizer{
            MOI.Utilities.UniversalFallback{MOI.Utilities.Model{T}},
            Float64,
        },
    }
    @test MOI.get(optimizer, MOI.Silent())
    @test MOI.get(optimizer, MOI.RawOptimizerAttribute("a")) == 1
    @test MOI.get(optimizer, MOI.RawOptimizerAttribute("b")) == 2

    optimizer_constructor = MOI.OptimizerWithAttributes(DummyOptimizer, [])
    optimizer = MOI.instantiate(optimizer_constructor)
    @test optimizer isa DummyOptimizer
    optimizer = MOI.instantiate(optimizer_constructor, with_bridge_type = T)
    @test optimizer isa MOI.Bridges.LazyBridgeOptimizer{
        MOI.Utilities.CachingOptimizer{DummyOptimizer,MOI.Utilities.Model{T}},
    }
    err = ErrorException(
        "The provided `optimizer_constructor` returned a non-empty optimizer.",
    )
    function g()
        model = f()
        MOI.add_variable(model)
        return model
    end
    @test_throws err MOI.instantiate(g)
    @test_throws err MOI.instantiate(g, with_bridge_type = T)
    optimizer_constructor = MOI.OptimizerWithAttributes(g)
    @test_throws err MOI.instantiate(optimizer_constructor)
    @test_throws err MOI.instantiate(
        optimizer_constructor,
        with_bridge_type = T,
    )

    err = ErrorException(MOI._INSTANTIATE_NOT_CALLABLE_MESSAGE)
    @test_throws err MOI.OptimizerWithAttributes(1)
    @test_throws err MOI.OptimizerWithAttributes(1, MOI.Silent() => true)
    @test_throws err MOI.instantiate(1)
    @test_throws err MOI.instantiate(1, with_bridge_type = T)

    err = ErrorException(
        "The provided `optimizer_constructor` returned an object of type " *
        "$Int. Expected a MathOptInterface.ModelLike.",
    )
    h() = 1
    @test_throws err MOI.instantiate(h)
    @test_throws err MOI.instantiate(h, with_bridge_type = T)
    optimizer_constructor = MOI.OptimizerWithAttributes(h)
    @test_throws err MOI.instantiate(optimizer_constructor)
    @test_throws err MOI.instantiate(
        optimizer_constructor,
        with_bridge_type = T,
    )
end

function test_instantiate_Float64()
    _test_instantiate(Float64)
    return
end

function test_instantiate_Int()
    _test_instantiate(Int)
    return
end

function test_get_set_Optimizer_with_attributes()
    opt = MOI.OptimizerWithAttributes() do
        return MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    end
    @test MOI.get(opt, MOI.Silent()) === nothing
    MOI.set(opt, MOI.Silent(), true)
    @test MOI.get(opt, MOI.Silent()) == true
    @test MOI.get(opt, MOI.RawOptimizerAttribute("a")) === nothing
    MOI.set(opt, MOI.RawOptimizerAttribute("a"), 1.0)
    @test MOI.get(opt, MOI.RawOptimizerAttribute("a")) == 1.0
    MOI.set(opt, MOI.RawOptimizerAttribute("a"), 2.0)
    @test MOI.get(opt, MOI.RawOptimizerAttribute("a")) == 2.0
    return
end

function test_instantiate_with_cache_type()
    function f(::Type{T}) where {T}
        return MOI.Utilities.MockOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}()),
        )
    end
    function inner_type(::Type{T}) where {T}
        return MOI.Utilities.UniversalFallback{MOI.Utilities.Model{T}}
    end
    function mock_type(::Type{T}) where {T}
        return MOI.Utilities.MockOptimizer{inner_type(T),Float64}
    end
    for T in (Int, Float64)
        mock, inner = mock_type(T), inner_type(T)
        # Check with no arguments provided
        model = MOI.instantiate(() -> f(T))
        @test typeof(model) == mock
        # Check with only with_bridge_type
        model = MOI.instantiate(() -> f(T); with_bridge_type = T)
        @test typeof(model) == MOI.Bridges.LazyBridgeOptimizer{mock}
        # Check with only with_cache_type
        model = MOI.instantiate(() -> f(T); with_cache_type = T)
        @test typeof(model) == MOI.Utilities.CachingOptimizer{mock,inner}
        # Check with both with_cache_type and with_bridge_type
        model = MOI.instantiate(; with_cache_type = T, with_bridge_type = T) do
            return f(T)
        end
        @test typeof(model) == MOI.Bridges.LazyBridgeOptimizer{
            MOI.Utilities.CachingOptimizer{mock,inner},
        }
    end
    @test_throws(
        ErrorException(
            "If both provided, `with_bridge_type` and `with_cache_type` must " *
            "be the same type. Got `with_bridge_type = $Float64` and " *
            "`with_cache_type = $Int`",
        ),
        MOI.instantiate(; with_cache_type = Int, with_bridge_type = Float64) do
            return f(Int)
        end
    )
    return
end

function test_to_param_OptimizerWithAttributes()
    @test_throws(
        ErrorException(
            "Expected an optimizer attribute or a string, got `1` which is a `$(Int)`.",
        ),
        MOI.OptimizerWithAttributes(MOI.Utilities.Model{Float64}, 1 => 2),
    )
    return
end

end

TestInstantiate.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    IndicatorSetMapBridge{T,A,S1,S2} <: Bridges.Constraint.AbstractBridge

`IndicatorSetMapBridge` implements the following reformulations:

  * ``z \\implies {f(x) \\ge l}`` into ``z \\implies {-f(x) \\le -l}``
  * ``z \\implies {f(x) \\le u}`` into ``z \\implies {-f(x) \\ge -u}``

## Source node

`IndicatorSetMapBridge` supports:

  * [`MOI.VectorAffineFunction{T}`](@ref) in [`MOI.Indicator{A,S1}`](@ref)

## Target nodes

`IndicatorSetMapBridge` creates:

  * [`MOI.VectorAffineFunction{T}`](@ref) in [`MOI.Indicator{A,S2}`](@ref)
"""
struct IndicatorSetMapBridge{T,B,S1,S2,A} <: AbstractBridge
    ci::MOI.ConstraintIndex{MOI.VectorAffineFunction{T},MOI.Indicator{A,S2}}
end

function bridge_constraint(
    ::Type{IndicatorSetMapBridge{T,B,S1,S2,A}},
    model::MOI.ModelLike,
    func::MOI.VectorAffineFunction{T},
    s::MOI.Indicator{A,S1},
) where {T,B,S1,S2,A}
    f = MOI.Utilities.eachscalar(func)
    f2 = MOI.Bridges.map_function(B, f[2])
    g = MOI.Utilities.operate(vcat, T, f[1], f2)
    s2 = MOI.Bridges.map_set(B, s.set)
    ci = MOI.add_constraint(model, g, MOI.Indicator{A}(s2))
    return IndicatorSetMapBridge{T,B,S1,S2,A}(ci)
end

function MOI.supports_constraint(
    ::Type{<:IndicatorSetMapBridge{T,B,S1,S2}},
    ::Type{MOI.VectorAffineFunction{T}},
    ::Type{MOI.Indicator{A,S1}},
) where {T,B,S1,S2,A}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:IndicatorSetMapBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{IndicatorSetMapBridge{T,B,S1,S2,A}},
) where {T,B,S1,S2,A}
    return Tuple{Type,Type}[(MOI.VectorAffineFunction{T}, MOI.Indicator{A,S2})]
end

function concrete_bridge_type(
    ::Type{<:IndicatorSetMapBridge{T,B,S1,S2}},
    ::Type{MOI.VectorAffineFunction{T}},
    ::Type{MOI.Indicator{A,S1}},
) where {T,B,S1,S2,A}
    return IndicatorSetMapBridge{T,B,S1,S2,A}
end

function MOI.delete(model::MOI.ModelLike, bridge::IndicatorSetMapBridge)
    MOI.delete(model, bridge.ci)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::IndicatorSetMapBridge{T,B,S1,S2,A},
) where {T,B,S1,S2,A}
    set = MOI.get(model, attr, bridge.ci)
    return MOI.Indicator{A}(MOI.Bridges.inverse_map_set(B, set.set))
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::IndicatorSetMapBridge{T,B},
) where {T,B}
    func = MOI.get(model, attr, bridge.ci)
    f = MOI.Utilities.eachscalar(func)
    f2 = MOI.Bridges.inverse_map_function(B, f[2])
    return MOI.Utilities.operate(vcat, T, f[1], f2)
end

function MOI.get(
    ::IndicatorSetMapBridge{T,B,S1,S2,A},
    ::MOI.NumberOfConstraints{MOI.VectorAffineFunction{T},MOI.Indicator{A,S2}},
)::Int64 where {T,B,S1,S2,A}
    return 1
end

function MOI.get(
    bridge::IndicatorSetMapBridge{T,B,S1,S2,A},
    ::MOI.ListOfConstraintIndices{
        MOI.VectorAffineFunction{T},
        MOI.Indicator{A,S2},
    },
) where {T,B,S1,S2,A}
    return [bridge.ci]
end

"""
    IndicatorGreaterToLessThanBridge{T,A} <: Bridges.Constraint.AbstractBridge

`IndicatorGreaterToLessThanBridge` implements the following reformulation:

  * ``z \\implies {f(x) \\ge l}`` into ``z \\implies {-f(x) \\le -l}``

## Source node

`IndicatorGreaterToLessThanBridge` supports:

  * [`MOI.VectorAffineFunction{T}`](@ref) in
    [`MOI.Indicator{A,MOI.GreaterThan{T}}`](@ref)

## Target nodes

`IndicatorGreaterToLessThanBridge` creates:

  * [`MOI.VectorAffineFunction{T}`](@ref) in
    [`MOI.Indicator{A,MOI.LessThan{T}}`](@ref)
"""
const IndicatorGreaterToLessThanBridge{T,A} = IndicatorSetMapBridge{
    T,
    MOI.Bridges.Constraint.GreaterToLessBridge{
        T,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarAffineFunction{T},
    },
    MOI.GreaterThan{T},
    MOI.LessThan{T},
    A,
}

const IndicatorGreaterToLessThan{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{IndicatorGreaterToLessThanBridge{T},OT}

"""
    IndicatorLessToGreaterThanBridge{T,A} <: Bridges.Constraint.AbstractBridge

`IndicatorLessToGreaterThanBridge` implements the following reformulations:

  * ``z \\implies {f(x) \\le u}`` into ``z \\implies {-f(x) \\ge -u}``

## Source node

`IndicatorLessToGreaterThanBridge` supports:

  * [`MOI.VectorAffineFunction{T}`](@ref) in
    [`MOI.Indicator{A,MOI.LessThan{T}}`](@ref)

## Target nodes

`IndicatorLessToGreaterThanBridge` creates:

  * [`MOI.VectorAffineFunction{T}`](@ref) in
    [`MOI.Indicator{A,MOI.GreaterThan{T}}`](@ref)
"""
const IndicatorLessToGreaterThanBridge{T,A} = IndicatorSetMapBridge{
    T,
    MOI.Bridges.Constraint.LessToGreaterBridge{
        T,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarAffineFunction{T},
    },
    MOI.LessThan{T},
    MOI.GreaterThan{T},
    A,
}

const IndicatorLessToGreaterThan{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{IndicatorLessToGreaterThanBridge{T},OT}

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestTestFloat64

using Test
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    # Some tests are excluded because UniversalFallback accepts absolutely
    # everything.
    MOI.Test.runtests(
        MOI.Utilities.MockOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        ),
        MOI.Test.Config(),
        exclude = [
            r"^test_model_ScalarFunctionConstantNotZero$",
            "test_model_copy_to_UnsupportedAttribute",
            "test_model_copy_to_UnsupportedConstraint",
            "test_model_supports_constraint_ScalarAffineFunction_EqualTo",
            "test_model_supports_constraint_VariableIndex_EqualTo",
            "test_model_supports_constraint_VectorOfVariables_Nonnegatives",
        ],
        warn_unsupported = true,
        verbose = true,
    )
    # Run the previously excluded tests, this time without UniversalFallback.
    MOI.Test.runtests(
        MOI.Utilities.MockOptimizer(
            MOI.Utilities.Model{Float64}(),
            scalar_function_constant_non_zero = true,
        ),
        MOI.Test.Config();
        include = [
            r"^test_model_ScalarFunctionConstantNotZero$",
            "test_model_copy_to_UnsupportedAttribute",
            "test_model_copy_to_UnsupportedConstraint",
            "test_model_supports_constraint_ScalarAffineFunction_EqualTo",
            "test_model_supports_constraint_VariableIndex_EqualTo",
            "test_model_supports_constraint_VectorOfVariables_Nonnegatives",
        ],
        verbose = true,
    )
    return
end

end  # module

TestTestFloat64.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintInequalityToComplements

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_GreaterThan()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.InequalityToComplementsBridge,
        """
        variables: x
        1.0 * x >= 0.0
        """,
        """
        variables: x, y
        [1.0 * x, y] in Complements(2)
        y >= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.InequalityToComplementsBridge,
        """
        variables: x
        2.0 * x >= 3.0
        """,
        """
        variables: x, y
        [2.0 * x + -3.0, y] in Complements(2)
        y >= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.InequalityToComplementsBridge,
        """
        variables: x
        2.0 * x * x >= 3.0
        """,
        """
        variables: x, y
        [2.0 * x * x + -3.0, y] in Complements(2)
        y >= 0.0
        """,
    )
    return
end

function test_runtests_LessThan()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.InequalityToComplementsBridge,
        """
        variables: x
        1.0 * x <= 0.0
        """,
        """
        variables: x, y
        [1.0 * x, y] in Complements(2)
        y <= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.InequalityToComplementsBridge,
        """
        variables: x
        2.0 * x <= 3.0
        """,
        """
        variables: x, y
        [2.0 * x + -3.0, y] in Complements(2)
        y <= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.InequalityToComplementsBridge,
        """
        variables: x
        2.0 * x * x <= 3.0
        """,
        """
        variables: x, y
        [2.0 * x * x + -3.0, y] in Complements(2)
        y <= 0.0
        """,
    )
    return
end

function test_runtests_EqualTo()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.InequalityToComplementsBridge,
        """
        variables: x
        1.0 * x == 0.0
        """,
        """
        variables: x, y
        [1.0 * x, y] in Complements(2)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.InequalityToComplementsBridge,
        """
        variables: x
        2.0 * x == 3.0
        """,
        """
        variables: x, y
        [2.0 * x + -3.0, y] in Complements(2)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.InequalityToComplementsBridge,
        """
        variables: x
        2.0 * x * x == 3.0
        """,
        """
        variables: x, y
        [2.0 * x * x + -3.0, y] in Complements(2)
        """,
    )
    return
end

function test_ScalarNonlinearFunction()
    # We can't use the standard runtests because ScalarNonlinearFunction does
    # not preserve f(x) ≈ (f(x) - g(x)) + g(x)
    for set in (MOI.EqualTo(1.0), MOI.LessThan(1.0), MOI.GreaterThan(1.0))
        inner = MOI.Utilities.Model{Float64}()
        model = MOI.Bridges.Constraint.InequalityToComplements{Float64}(inner)
        x = MOI.add_variable(model)
        f = MOI.ScalarNonlinearFunction(:sin, Any[x])
        c = MOI.add_constraint(model, f, set)
        F, S = MOI.VectorNonlinearFunction, MOI.Complements
        indices = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())
        @test length(indices) == 1
        inner_variables = MOI.get(inner, MOI.ListOfVariableIndices())
        @test length(inner_variables) == 2
        u, v = inner_variables
        u_sin = MOI.ScalarNonlinearFunction(:sin, Any[u])
        g = MOI.VectorNonlinearFunction([
            MOI.ScalarNonlinearFunction(:-, Any[u_sin, 1.0]),
            MOI.ScalarNonlinearFunction(:+, Any[v]),
        ])
        @test ≈(MOI.get(inner, MOI.ConstraintFunction(), indices[1]), g)
        h = MOI.ScalarNonlinearFunction(
            :+,
            Any[MOI.ScalarNonlinearFunction(:-, Any[f, 1.0]), 1.0],
        )
        @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), h)
    end
    return
end

end  # module

TestConstraintInequalityToComplements.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Nonlinear

import ForwardDiff
import ..MathOptInterface as MOI
import OrderedCollections: OrderedDict
import SparseArrays

using SpecialFunctions

# Override basic math functions to return NaN instead of throwing errors.
# This is what NLP solvers expect, and sometimes the results aren't needed
# anyway, because the code may compute derivatives wrt constants.
import NaNMath:
    sin,
    cos,
    tan,
    asin,
    acos,
    acosh,
    atanh,
    log,
    log2,
    log10,
    lgamma,
    log1p,
    pow,
    sqrt

include("univariate_expressions.jl")
include("operators.jl")
include("types.jl")
include("parse.jl")
include("model.jl")
include("evaluator.jl")

include("ReverseAD/ReverseAD.jl")
include("SymbolicAD/SymbolicAD.jl")

end  # module

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SplitIntervalBridge{T,F,S,LS,US} <: Bridges.Constraint.AbstractBridge

`SplitIntervalBridge` implements the following reformulations:

  * ``l \\le f(x) \\le u`` into ``f(x) \\ge l`` and ``f(x) \\le u``
  * ``f(x) = b`` into ``f(x) \\ge b`` and ``f(x) \\le b``
  * ``f(x) \\in \\{0\\}`` into ``f(x) \\in \\mathbb{R}_+`` and
    ``f(x) \\in \\mathbb{R}_-``

## Source node

`SplitIntervalBridge` supports:

  * `F` in [`MOI.Interval{T}`](@ref)
  * `F` in [`MOI.EqualTo{T}`](@ref)
  * `F` in [`MOI.Zeros`](@ref)

## Target nodes

`SplitIntervalBridge` creates:

  * `F` in [`MOI.LessThan{T}`](@ref)
  * `F` in [`MOI.GreaterThan{T}`](@ref)

or

  * `F` in [`MOI.Nonnegatives`](@ref)
  * `F` in [`MOI.Nonpositives`](@ref)


!!! note
    If `T<:AbstractFloat` and `S` is `MOI.Interval{T}` then no lower (resp.
    upper) bound constraint is created if the lower (resp. upper) bound is
    `typemin(T)` (resp. `typemax(T)`). Similarly, when
    [`MOI.ConstraintSet`](@ref) is set, a lower or upper bound
    constraint may be deleted or created accordingly.
"""
mutable struct SplitIntervalBridge{
    T,
    F<:MOI.AbstractFunction,
    S<:MOI.AbstractSet,
    LS<:MOI.AbstractSet,
    US<:MOI.AbstractSet,
} <: AbstractBridge
    lower::Union{Nothing,MOI.ConstraintIndex{F,LS}}
    upper::Union{Nothing,MOI.ConstraintIndex{F,US}}
    # To allow the user to do
    # ```jl
    # x = MOI.add_variable(model)
    # c = MOI.add_constraint(model, x, MOI.Interval(-Inf, Inf))
    # MOI.set(model, MOI.ConstraintSet(), c, MOI.Interval(0.0, Inf))
    # ```
    # we need to store the function to create the lower bound constraint.
    func::Union{Nothing,F}
end

const SplitInterval{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SplitIntervalBridge{T},OT}

_lower_set(set::MOI.Interval) = MOI.GreaterThan(set.lower)
_upper_set(set::MOI.Interval) = MOI.LessThan(set.upper)

function _lower_set(
    set::MOI.Interval{T},
) where {T<:Union{AbstractFloat,Rational}}
    if set.lower == typemin(T)
        return nothing
    end
    return MOI.GreaterThan(set.lower)
end

function _upper_set(
    set::MOI.Interval{T},
) where {T<:Union{AbstractFloat,Rational}}
    if set.upper == typemax(T)
        return nothing
    end
    return MOI.LessThan(set.upper)
end

_lower_set(set::MOI.EqualTo) = MOI.GreaterThan(set.value)
_upper_set(set::MOI.EqualTo) = MOI.LessThan(set.value)

_lower_set(set::MOI.Zeros) = MOI.Nonnegatives(set.dimension)
_upper_set(set::MOI.Zeros) = MOI.Nonpositives(set.dimension)

function bridge_constraint(
    ::Type{SplitIntervalBridge{T,F,S,LS,US}},
    model::MOI.ModelLike,
    f::F,
    set::S,
) where {T,F,S,LS,US}
    lower, upper, func = nothing, nothing, nothing
    lower_set, upper_set = _lower_set(set), _upper_set(set)
    if lower_set !== nothing
        lower = MOI.add_constraint(model, f, lower_set)
    end
    if upper_set !== nothing
        upper = MOI.add_constraint(model, f, upper_set)
    end
    if lower === nothing && upper === nothing
        func = f
    end
    return SplitIntervalBridge{T,F,S,LS,US}(lower, upper, func)
end

function MOI.supports_constraint(
    ::Type{SplitIntervalBridge{T}},
    ::Type{<:MOI.AbstractScalarFunction},
    ::Type{<:Union{MOI.Interval{T},MOI.EqualTo{T}}},
) where {T}
    return true
end

function MOI.supports_constraint(
    ::Type{SplitIntervalBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.Zeros},
) where {T}
    return MOI.Utilities.is_coefficient_type(F, T)
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:SplitIntervalBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{SplitIntervalBridge{T,F,S,LS,US}},
) where {T,F,S,LS,US}
    return Tuple{Type,Type}[(F, LS), (F, US)]
end

function concrete_bridge_type(
    ::Type{<:SplitIntervalBridge},
    F::Type{<:MOI.AbstractScalarFunction},
    S::Type{<:Union{MOI.Interval{T},MOI.EqualTo{T}}},
) where {T}
    return SplitIntervalBridge{T,F,S,MOI.GreaterThan{T},MOI.LessThan{T}}
end

function concrete_bridge_type(
    ::Type{<:SplitIntervalBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.Zeros},
) where {T}
    return SplitIntervalBridge{T,F,MOI.Zeros,MOI.Nonnegatives,MOI.Nonpositives}
end

function MOI.get(
    bridge::SplitIntervalBridge{T,F,S,LS},
    ::MOI.NumberOfConstraints{F,LS},
)::Int64 where {T,F,S,LS}
    if bridge.lower === nothing
        return 0
    else
        return 1
    end
end

function MOI.get(
    bridge::SplitIntervalBridge{T,F,S,LS,US},
    ::MOI.NumberOfConstraints{F,US},
)::Int64 where {T,F,S,LS,US}
    if bridge.upper === nothing
        return 0
    else
        return 1
    end
end

function MOI.get(
    bridge::SplitIntervalBridge{T,F,S,LS},
    ::MOI.ListOfConstraintIndices{F,LS},
) where {T,F,S,LS}
    if bridge.lower === nothing
        return MOI.ConstraintIndex{F,LS}[]
    else
        return [bridge.lower]
    end
end

function MOI.get(
    bridge::SplitIntervalBridge{T,F,S,LS,US},
    ::MOI.ListOfConstraintIndices{F,US},
) where {T,F,S,LS,US}
    if bridge.upper === nothing
        return MOI.ConstraintIndex{F,US}[]
    else
        return [bridge.upper]
    end
end

function MOI.delete(model::MOI.ModelLike, bridge::SplitIntervalBridge)
    if bridge.lower !== nothing
        MOI.delete(model, bridge.lower)
    end
    if bridge.upper !== nothing
        MOI.delete(model, bridge.upper)
    end
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{SplitIntervalBridge{T,F,S,LS,US}},
) where {T,F,S,LS,US}
    ci_1 = MOI.ConstraintIndex{F,LS}
    ci_2 = MOI.ConstraintIndex{F,US}
    return MOI.supports(model, attr, ci_1) && MOI.supports(model, attr, ci_2)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::SplitIntervalBridge,
)
    if bridge.lower !== nothing
        return MOI.get(model, attr, bridge.lower)
    end
    if bridge.upper !== nothing
        return MOI.get(model, attr, bridge.upper)
    end
    msg = "Cannot get `$attr` for a constraint in the interval `[-Inf, Inf]`."
    return throw(MOI.GetAttributeNotAllowed(attr, msg))
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::SplitIntervalBridge,
    value,
)
    if bridge.lower !== nothing
        MOI.set(model, attr, bridge.lower, value)
    end
    if bridge.upper !== nothing
        MOI.set(model, attr, bridge.upper, value)
    end
    return
end

# The map is:
#   x ∈ S <=> [1 1]' * x ∈ LS × US
# So the adjoint map is
#   [1 1] * y ∈ S* <=> y ∈ (LS × US)*
# where
#   [1 1] * y = y[1] + y[2]
# so we can just sum the dual values.
function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::SplitIntervalBridge{T},
) where {T}
    if bridge.lower === nothing && bridge.upper === nothing
        return zero(T)
    elseif bridge.lower === nothing
        return MOI.get(model, attr, bridge.upper)
    elseif bridge.upper === nothing
        return MOI.get(model, attr, bridge.lower)
    else
        lower = MOI.get(model, attr, bridge.lower)
        if lower === nothing
            return nothing
        end
        return lower + MOI.get(model, attr, bridge.upper)
    end
end

_split_dual_start(::Nothing) = nothing, nothing

function _split_dual_start(value)
    if value < 0
        return zero(value), value
    else
        return value, zero(value)
    end
end

function _split_dual_start(value::Vector{T}) where {T}
    lower, upper = similar(value), similar(value)
    for i in eachindex(value)
        lower[i], upper[i] = _split_dual_start(value[i])
    end
    return lower, upper
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::SplitIntervalBridge{T},
    value,
) where {T}
    if bridge.lower === nothing
        if bridge.upper !== nothing
            MOI.set(model, attr, bridge.upper, value)
        end
    else
        if bridge.upper === nothing
            MOI.set(model, attr, bridge.lower, value)
        else
            lower, upper = _split_dual_start(value)
            MOI.set(model, attr, bridge.lower, lower)
            MOI.set(model, attr, bridge.upper, upper)
        end
    end
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintBasisStatus,
    bridge::SplitIntervalBridge,
)
    if bridge.upper !== nothing
        upper_stat = MOI.get(model, attr, bridge.upper)
        if upper_stat == MOI.NONBASIC
            return MOI.NONBASIC_AT_UPPER
        end
    end
    if bridge.lower === nothing
        if bridge.upper === nothing
            # The only case where the interval `[-∞, ∞]` is allowed is for
            # `VariableIndex` constraints but `ConstraintBasisStatus` is not
            # defined for `VariableIndex` constraints.
            msg = "Cannot get `$attr` for a constraint in the interval `[-Inf, Inf]`."
            throw(MOI.GetAttributeNotAllowed(attr, msg))
        end
        return upper_stat
    end
    lower_stat = MOI.get(model, attr, bridge.lower)
    if lower_stat == MOI.NONBASIC
        return MOI.NONBASIC_AT_LOWER
    end
    # Both statuses must be BASIC or SUPER_BASIC, so just return the lower.
    return lower_stat
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::SplitIntervalBridge,
    change::MOI.AbstractFunctionModification,
)
    if bridge.lower !== nothing
        MOI.modify(model, bridge.lower, change)
    end
    if bridge.upper !== nothing
        MOI.modify(model, bridge.upper, change)
    end
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::SplitIntervalBridge{T,F},
    func::F,
) where {T,F}
    if bridge.lower !== nothing
        MOI.set(model, MOI.ConstraintFunction(), bridge.lower, func)
    end
    if bridge.upper !== nothing
        MOI.set(model, MOI.ConstraintFunction(), bridge.upper, func)
    end
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::SplitIntervalBridge{T,F,S},
    change::S,
) where {T,F,S}
    lower_set, upper_set = _lower_set(change), _upper_set(change)
    if lower_set === nothing && upper_set === nothing
        # The constraints are going to be deleted, we store the function before
        # it is lost.
        bridge.func = MOI.get(model, MOI.ConstraintFunction(), bridge)
    end
    if bridge.lower === nothing
        if lower_set !== nothing
            func = MOI.get(model, MOI.ConstraintFunction(), bridge)
            bridge.lower = MOI.add_constraint(model, func, lower_set)
        end
    else
        if lower_set === nothing
            MOI.delete(model, bridge.lower)
            bridge.lower = nothing
        else
            MOI.set(model, MOI.ConstraintSet(), bridge.lower, lower_set)
        end
    end
    if bridge.upper === nothing
        if upper_set !== nothing
            func = MOI.get(model, MOI.ConstraintFunction(), bridge)
            bridge.upper = MOI.add_constraint(model, func, upper_set)
        end
    else
        if upper_set === nothing
            MOI.delete(model, bridge.upper)
            bridge.upper = nothing
        else
            MOI.set(model, MOI.ConstraintSet(), bridge.upper, upper_set)
        end
    end
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::SplitIntervalBridge,
)
    if bridge.lower !== nothing
        return MOI.get(model, attr, bridge.lower)
    end
    if bridge.upper !== nothing
        return MOI.get(model, attr, bridge.upper)
    end
    return copy(bridge.func)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::SplitIntervalBridge{T,F,MOI.Interval{T}},
) where {T,F}
    lower, upper = typemin(T), typemax(T)
    if bridge.lower !== nothing
        lower = MOI.get(model, attr, bridge.lower).lower
    end
    if bridge.upper !== nothing
        upper = MOI.get(model, attr, bridge.upper).upper
    end
    return MOI.Interval(lower, upper)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::SplitIntervalBridge{T,F,MOI.EqualTo{T}},
) where {T,F}
    return MOI.EqualTo(MOI.get(model, attr, bridge.lower).lower)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::SplitIntervalBridge{T,F,MOI.Zeros},
) where {T,F}
    return MOI.Zeros(MOI.get(model, attr, bridge.lower).dimension)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    TableToMILPBridge{T,F} <: Bridges.Constraint.AbstractBridge

`TableToMILPBridge` implements the following reformulation:

  * ``x \\in Table(t)`` into
    ```math
    \\begin{aligned}
    z_{j} \\in \\{0, 1\\}                     & \\quad \\forall i, j \\\\
    \\sum\\limits_{j=1}^n z_{j} = 1                           \\\\
    \\sum\\limits_{j=1}^n t_{ij} z_{j} = x_i & \\quad \\forall i
    \\end{aligned}
    ```

## Source node

`TableToMILPBridge` supports:

  * `F` in [`MOI.Table{T}`](@ref)

## Target nodes

`TableToMILPBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo{T}`](@ref)
"""
struct TableToMILPBridge{T,F<:MOI.AbstractVectorFunction} <: AbstractBridge
    z::Vector{MOI.VariableIndex}
    unity::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}
    assignment::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
    }
    # Cache to simplify MOI.get
    f::F
    s::MOI.Table{T}
end

const TableToMILP{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{TableToMILPBridge{T},OT}

function bridge_constraint(
    ::Type{TableToMILPBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.Table{T},
) where {T,F}
    m = size(s.table, 1)
    z = MOI.add_variables(model, m)
    MOI.add_constraint.(model, z, MOI.ZeroOne())
    # ∑z_j = 1
    unity = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(one(T), z), zero(T)),
        MOI.EqualTo(one(T)),
    )
    # ∑t_ij z_j == f_i
    assignment =
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}[]
    for (i, fi) in enumerate(MOI.Utilities.eachscalar(f))
        terms = MOI.ScalarAffineTerm{T}[]
        for j in 1:m
            if !iszero(s.table[j, i])
                push!(terms, MOI.ScalarAffineTerm(s.table[j, i], z[j]))
            end
        end
        assign_f = MOI.ScalarAffineFunction(terms, zero(T))
        assign_f = MOI.Utilities.operate!(-, T, assign_f, fi)
        ci = MOI.Utilities.normalize_and_add_constraint(
            model,
            assign_f,
            MOI.EqualTo(zero(T)),
        )
        push!(assignment, ci)
    end
    return TableToMILPBridge{T,F}(z, unity, assignment, f, s)
end

function MOI.supports_constraint(
    ::Type{<:TableToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.Table{T}},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:TableToMILPBridge},
)
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{TableToMILPBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[
        (MOI.VariableIndex, MOI.ZeroOne),
        (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:TableToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.Table{T}},
) where {T,F<:MOI.AbstractVectorFunction}
    return TableToMILPBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::TableToMILPBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::TableToMILPBridge,
)
    return bridge.s
end

function MOI.delete(model::MOI.ModelLike, bridge::TableToMILPBridge)
    MOI.delete(model, bridge.assignment)
    MOI.delete(model, bridge.unity)
    MOI.delete(model, bridge.z)
    return
end

function MOI.get(bridge::TableToMILPBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.z)
end

function MOI.get(bridge::TableToMILPBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.z)
end

function MOI.get(
    bridge::TableToMILPBridge,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64
    return length(bridge.z)
end

function MOI.get(
    bridge::TableToMILPBridge,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
)
    return [
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(z.value) for
        z in bridge.z
    ]
end

function MOI.get(
    bridge::TableToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return length(bridge.assignment) + 1
end

function MOI.get(
    bridge::TableToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return vcat(bridge.assignment, bridge.unity)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestLazyIterators

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function _test_EmptyVector(T)
    v = MOI.Utilities.EmptyVector{T}()
    @test size(v) == (0,)
    @test length(v) == 0
    @test isempty(v)
    @test eltype(v) == T
    @test iterate(v) === nothing
    c = collect(v)
    @test c isa Vector{T}
    @test isempty(c)
    return
end

test_EmptyVector_Int() = _test_EmptyVector(Int)
test_EmptyVector_Float64() = _test_EmptyVector(Float64)

function _test_lazy_map(T)
    for (M{T}, a) in [
        (MOI.Utilities.LazyMap, Iterators.drop(1:3, 1)),
        (MOI.Utilities.VectorLazyMap, [2, 3]),
    ]
        v = MOI.Utilities.lazy_map(T, x -> x^2, a)
        @test v isa M
        @test length(v) == 2
        @test !isempty(v)
        @test eltype(v) == T
        c = collect(v)
        @test c isa Vector{T}
        @test c == [4, 9]
        if a isa AbstractVector
            @test size(v) == (2,)
            @test v[1] == 4
            @test v[2] == 9
            @test collect(Iterators.reverse(v)) == [9, 4]
        end
    end
    return
end

test_lazy_map_Int() = _test_lazy_map(Int)
test_lazy_map_Float64() = _test_lazy_map(Float64)

end  # module

TestLazyIterators.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    AbstractFunction

Abstract supertype for function objects.

## Required methods

All functions must implement:

 * `Base.copy`
 * `Base.isapprox`
 * [`constant`](@ref)

Abstract subtypes of `AbstractFunction` may require additional methods to be
implemented.
"""
abstract type AbstractFunction <: MA.AbstractMutable end

"""
    abstract type AbstractScalarFunction <: AbstractFunction

Abstract supertype for scalar-valued [`AbstractFunction`](@ref)s.
"""
abstract type AbstractScalarFunction <: AbstractFunction end

Base.broadcastable(f::AbstractScalarFunction) = Ref(f)

Base.ndims(::Type{<:AbstractScalarFunction}) = 0

Base.ndims(::AbstractScalarFunction) = 0

"""
    VariableIndex

A type-safe wrapper for `Int64` for use in referencing variables in a model.
To allow for deletion, indices need not be consecutive.
"""
struct VariableIndex <: AbstractScalarFunction
    value::Int64
end

"""
    ConstraintIndex{F,S}

A type-safe wrapper for `Int64` for use in referencing `F`-in-`S` constraints in
a model.

The parameter `F` is the type of the function in the constraint, and the
parameter `S` is the type of set in the constraint.

To allow for deletion, indices need not be consecutive.

Indices within a constraint type (that is, `F`-in-`S`) must be unique, but
non-unique indices across different constraint types are allowed.

If `F` is [`VariableIndex`](@ref) then the index is equal to the index of the
variable. That is for an `index::ConstraintIndex{VariableIndex}`, we always
have
```julia
index.value == MOI.get(model, MOI.ConstraintFunction(), index).value
```
"""
struct ConstraintIndex{F,S}
    value::Int64
end

# The default hash is slow. It's important for the performance of dictionaries
# of VariableIndices to define our own.
# https://github.com/JuliaLang/julia/issues/10208
Base.hash(v::VariableIndex, h::UInt) = hash(v.value, h)

# No need to define isequal because the default matches our implementation of
# hash.

const Index = Union{ConstraintIndex,VariableIndex}

"""
    struct InvalidIndex{IndexType<:Index} <: Exception
        index::IndexType
    end

An error indicating that the index `index` is invalid.
"""
struct InvalidIndex{IndexType<:Index} <: Exception
    index::IndexType
end

function Base.showerror(io::IO, err::InvalidIndex)
    return print(
        io,
        "The index $(err.index) is invalid. Note that an index becomes invalid after it has been deleted.",
    )
end

"""
    is_valid(model::ModelLike, index::Index)::Bool

Return a `Bool` indicating whether this index refers to a valid object in the model `model`.
"""
is_valid(model::ModelLike, ref::Index) = false

"""
    throw_if_not_valid(model::ModelLike, index::Index)

Throw an `InvalidIndex(index)` error if `MOI.is_valid(model, index)` returns
`false`.
"""
function throw_if_not_valid(model::ModelLike, index::Index)
    if !is_valid(model, index)
        throw(InvalidIndex(index))
    end
end

"""
    struct DeleteNotAllowed{IndexType <: Index} <: NotAllowedError
        index::IndexType
        message::String
    end

An error indicating that the index `index` cannot be deleted.
"""
struct DeleteNotAllowed{IndexType<:Index} <: NotAllowedError
    index::IndexType
    message::String
end
DeleteNotAllowed(index::Index) = DeleteNotAllowed(index, "")

function operation_name(err::DeleteNotAllowed)
    return "Deleting the index $(err.index)"
end

"""
    delete(model::ModelLike, index::Index)

Delete the referenced object from the model. Throw [`DeleteNotAllowed`](@ref) if
if `index` cannot be deleted.

The following modifications also take effect if `Index` is [`VariableIndex`](@ref):
* If `index` used in the objective function, it is removed from the function,
  that is, it is substituted for zero.
* For each `func`-in-`set` constraint of the model:
  - If `func isa VariableIndex` and `func == index` then the
    constraint is deleted.
  - If `func isa VectorOfVariables` and `index in func.variables` then
    * if `length(func.variables) == 1` is one, the constraint is deleted;
    * if `length(func.variables) > 1` and `supports_dimension_update(set)` then
      then the variable is removed from `func` and `set` is replaced by
      `update_dimension(set, MOI.dimension(set) - 1)`.
    * Otherwise, a [`DeleteNotAllowed`](@ref) error is thrown.
  - Otherwise, the variable is removed from `func`, that is, it is substituted for
    zero.
"""
delete(model::ModelLike, index::Index) = throw(DeleteNotAllowed(index))

"""
    delete(model::ModelLike, indices::Vector{R<:Index}) where {R}

Delete the referenced objects in the vector `indices` from the model.
It may be assumed that `R` is a concrete type. The default fallback sequentially
deletes the individual items in `indices`, although specialized implementations
may be more efficient.
"""
function delete(model::ModelLike, indices::Vector{<:Index})
    for index in indices
        delete(model, index)
    end
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

function MOI.empty!(model::Model)
    model.objective = nothing
    empty!(model.expressions)
    empty!(model.constraints)
    empty!(model.parameters)
    model.operators = OperatorRegistry()
    model.last_constraint_index = 0
    return
end

function MOI.is_empty(model::Model)
    return model.objective === nothing &&
           isempty(model.expressions) &&
           isempty(model.constraints) &&
           isempty(model.parameters) &&
           isempty(model.operators.registered_univariate_operators) &&
           isempty(model.operators.registered_multivariate_operators) &&
           model.last_constraint_index === Int64(0)
end

function Base.copy(::Model)
    return error("Copying nonlinear problems not yet implemented")
end

function Base.show(io::IO, model::Model)
    println(io, "A Nonlinear.Model with:")
    _plural(s, n) = n == 1 ? " 1 $s" : " $n $(s)s"
    println(io, _plural("objective", model.objective !== nothing ? 1 : 0))
    println(io, _plural("parameter", length(model.parameters)))
    println(io, _plural("expression", length(model.expressions)))
    return print(io, _plural("constraint", length(model.constraints)))
end

"""
    set_objective(model::Model, obj)::Nothing

Parse `obj` into a [`Expression`](@ref) and set as the objective
function of `model`.

`obj` must be a type that is supported by [`parse_expression`](@ref).

To remove the objective, pass `nothing`.

## Example

```jldoctest
julia> model = MOI.Nonlinear.Model()
A Nonlinear.Model with:
 0 objectives
 0 parameters
 0 expressions
 0 constraints

julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> MOI.Nonlinear.set_objective(model, :(\$x^2 + 1))

julia> MOI.Nonlinear.set_objective(model, x)

julia> MOI.Nonlinear.set_objective(model, nothing)
```
"""
function set_objective(model::Model, obj)
    model.objective = parse_expression(model, obj)
    return
end

function set_objective(model::Model, ::Nothing)
    model.objective = nothing
    return
end

"""
    add_expression(model::Model, expr)::ExpressionIndex

Parse `expr` into a [`Expression`](@ref) and add to `model`. Returns an
[`ExpressionIndex`](@ref) that can be interpolated into other input expressions.

`expr` must be a type that is supported by [`parse_expression`](@ref).

## Example

```jldoctest
julia> model = MOI.Nonlinear.Model();

julia> x = MOI.VariableIndex(1);

julia> ex = MOI.Nonlinear.add_expression(model, :(\$x^2 + 1))
MathOptInterface.Nonlinear.ExpressionIndex(1)

julia> MOI.Nonlinear.set_objective(model, :(sqrt(\$ex)))
```
"""
function add_expression(model::Model, expr)
    push!(model.expressions, parse_expression(model, expr))
    return ExpressionIndex(length(model.expressions))
end

function Base.getindex(model::Model, index::ExpressionIndex)
    return model.expressions[index.value]
end

"""
    add_constraint(
        model::Model,
        func,
        set::Union{
            MOI.GreaterThan{Float64},
            MOI.LessThan{Float64},
            MOI.Interval{Float64},
            MOI.EqualTo{Float64},
        },
    )

Parse `func` and `set` into a [`Constraint`](@ref) and add to `model`. Returns a
[`ConstraintIndex`](@ref) that can be used to delete the constraint or query
solution information.

## Example

```jldoctest
julia> model = MOI.Nonlinear.Model();

julia> x = MOI.VariableIndex(1);

julia> c = MOI.Nonlinear.add_constraint(model, :(\$x^2), MOI.LessThan(1.0))
MathOptInterface.Nonlinear.ConstraintIndex(1)
```
"""
function add_constraint(
    model::Model,
    func,
    set::Union{
        MOI.GreaterThan{Float64},
        MOI.LessThan{Float64},
        MOI.Interval{Float64},
        MOI.EqualTo{Float64},
    },
)
    f = parse_expression(model, func)
    model.last_constraint_index += 1
    index = ConstraintIndex(model.last_constraint_index)
    model.constraints[index] = Constraint(f, set)
    return index
end

"""
    delete(model::Model, c::ConstraintIndex)::Nothing

Delete the constraint index `c` from `model`.

## Example

```jldoctest
julia> model = MOI.Nonlinear.Model()
A Nonlinear.Model with:
 0 objectives
 0 parameters
 0 expressions
 0 constraints

julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> c = MOI.Nonlinear.add_constraint(model, :(\$x^2), MOI.LessThan(1.0))
MathOptInterface.Nonlinear.ConstraintIndex(1)

julia> model
A Nonlinear.Model with:
 0 objectives
 0 parameters
 0 expressions
 1 constraint

julia> MOI.Nonlinear.delete(model, c)

julia> model
A Nonlinear.Model with:
 0 objectives
 0 parameters
 0 expressions
 0 constraints
```
"""
function delete(model::Model, c::ConstraintIndex)
    delete!(model.constraints, c)
    return
end

function Base.getindex(model::Model, index::ConstraintIndex)
    return model.constraints[index]
end

function MOI.is_valid(model::Model, index::ConstraintIndex)
    return haskey(model.constraints, index)
end

"""
    add_parameter(model::Model, value::Float64)::ParameterIndex

Add a new parameter to `model` with the default value `value`. Returns a
[`ParameterIndex`](@ref) that can be interpolated into other input expressions
and used to modify the value of the parameter.

## Example

```jldoctest
julia> model = MOI.Nonlinear.Model()
A Nonlinear.Model with:
 0 objectives
 0 parameters
 0 expressions
 0 constraints

julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> p = MOI.Nonlinear.add_parameter(model, 1.2)
MathOptInterface.Nonlinear.ParameterIndex(1)

julia> c = MOI.Nonlinear.add_constraint(model, :(\$x^2 - \$p), MOI.LessThan(0.0))
MathOptInterface.Nonlinear.ConstraintIndex(1)
```
"""
function add_parameter(model::Model, value::Float64)
    push!(model.parameters, value)
    return ParameterIndex(length(model.parameters))
end

function Base.getindex(model::Model, p::ParameterIndex)
    return model.parameters[p.value]
end

function Base.setindex!(model::Model, value::Real, p::ParameterIndex)
    return model.parameters[p.value] = convert(Float64, value)::Float64
end

"""
    register_operator(
        model::Model,
        op::Symbol,
        nargs::Int,
        f::Function,
        [∇f::Function],
        [∇²f::Function],
    )

Register the user-defined operator `op` with `nargs` input arguments in `model`.

## Univariate functions

 * `f(x::T)::T` must be a function that takes a single input argument `x` and
   returns the function evaluated at `x`. If `∇f` and `∇²f` are not provided,
   `f` must support any `Real` input type `T`.
 * `∇f(x::T)::T` is a function that takes a single input argument `x` and
   returns the first derivative of `f` with respect to `x`. If `∇²f` is not
   provided, `∇f` must support any `Real` input type `T`.
 * `∇²f(x::T)::T` is a function that takes a single input argument `x` and
   returns the second derivative of `f` with respect to `x`.

## Multivariate functions

* `f(x::T...)::T` must be a function that takes a `nargs` input arguments `x`
  and returns the function evaluated at `x`. If `∇f` and `∇²f` are not provided,
  `f` must support any `Real` input type `T`.
* `∇f(g::AbstractVector{T}, x::T...)::T` is a function that takes a cache vector
  `g` of length `length(x)`, and fills each element `g[i]` with the partial
  derivative of `f` with respect to `x[i]`.
* `∇²f(H::AbstractMatrix, x::T...)::T` is a function that takes a matrix `H` and
  fills the lower-triangular components `H[i, j]` with the Hessian of `f` with
  respect to `x[i]` and `x[j]` for `i >= j`.

### Notes for multivariate Hessians

 * `H` has `size(H) == (length(x), length(x))`, but you must not access
   elements `H[i, j]` for `i > j`.
 * `H` is dense, but you do not need to fill structural zeros.
"""
function register_operator(model::Model, op::Symbol, nargs::Int, f::Function...)
    return register_operator(model.operators, op, nargs, f...)
end

"""
    evaluate(
        f::AbstractDict,
        model::Model,
        index::ExpressionIndex,
    )

Evaluate the nonlinear expression `index`, where `f[x]` returns the primal value
of decision variable `x::MOI.VariableIndex`.
"""
function evaluate(
    f::AbstractDict,
    model::Model,
    index::ExpressionIndex;
    kwargs...,
)
    return evaluate(f, model, model[index]; kwargs...)
end

"""
    evaluate(
        f::AbstractDict,
        model::Model,
        expr::Expression,
    )

Evaluate the nonlinear expression `expr`, where `f[x]` returns the primal value
of decision variable `x::MOI.VariableIndex`.
"""
function evaluate(
    f::AbstractDict,
    model::Model,
    expr::Expression;
    evaluated_expressions = Dict{Int,Float64}(),
)
    storage = zeros(length(expr.nodes))
    adj = adjacency_matrix(expr.nodes)
    children_arr = SparseArrays.rowvals(adj)
    # An arbitrary limit on the potential input size of a multivariate
    # operation. This will get resized if need-be.
    input_cache = zeros(10)
    for k in length(expr.nodes):-1:1
        node = expr.nodes[k]
        if node.type == NODE_MOI_VARIABLE
            storage[k] = f[MOI.VariableIndex(node.index)]
        elseif node.type == NODE_VALUE
            storage[k] = expr.values[node.index]
        elseif node.type == NODE_SUBEXPRESSION
            if !haskey(evaluated_expressions, node.index)
                evaluated_expressions[node.index] = evaluate(
                    f,
                    model,
                    ExpressionIndex(node.index);
                    evaluated_expressions = evaluated_expressions,
                )
            end
            storage[k] = evaluated_expressions[node.index]
        elseif node.type == NODE_PARAMETER
            storage[k] = model.parameters[node.index]
        elseif node.type == NODE_CALL_MULTIVARIATE
            children_indices = SparseArrays.nzrange(adj, k)
            N = length(children_indices)
            if length(input_cache) < N
                resize!(input_cache, N)
            end
            f_input = view(input_cache, 1:N)
            for (r, i) in enumerate(children_indices)
                f_input[r] = storage[children_arr[i]]
            end
            storage[k] = eval_multivariate_function(
                model.operators,
                model.operators.multivariate_operators[node.index],
                f_input,
            )
        elseif node.type == NODE_CALL_UNIVARIATE
            child_idx = children_arr[adj.colptr[k]]
            storage[k] = eval_univariate_function(
                model.operators,
                node.index,
                storage[child_idx],
            )
        elseif node.type == NODE_COMPARISON
            children_idx = SparseArrays.nzrange(adj, k)
            result = true
            for r in 2:length(children_idx)
                lhs = children_arr[children_idx[r-1]]
                rhs = children_arr[children_idx[r]]
                result &= eval_comparison_function(
                    model.operators,
                    model.operators.comparison_operators[node.index],
                    storage[lhs],
                    storage[rhs],
                )
            end
            storage[k] = result
        else
            @assert node.type == NODE_LOGIC
            children_idx = SparseArrays.nzrange(adj, k)
            lhs = children_arr[children_idx[1]]
            rhs = children_arr[children_idx[2]]
            storage[k] = eval_logic_function(
                model.operators,
                model.operators.logic_operators[node.index],
                storage[lhs] == 1,
                storage[rhs] == 1,
            )
        end
    end
    return storage[1]
end

function MOI.get(model::Model, attr::MOI.ListOfSupportedNonlinearOperators)
    return MOI.get(model.operators, attr)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SingleBridgeOptimizer{BT<:AbstractBridge}(model::MOI.ModelLike)

Return `AbstractBridgeOptimizer` that always bridges any objective function
supported by the bridge `BT`.

This is in contrast with the [`MOI.Bridges.LazyBridgeOptimizer`](@ref),
which only bridges the objective function if it is supported by the bridge `BT`
and unsupported by `model`.

## Example

```jldoctest con_singlebridgeoptimizer
julia> struct MyNewBridge{T} <: MOI.Bridges.Constraint.AbstractBridge end

julia> bridge = MOI.Bridges.Constraint.SingleBridgeOptimizer{MyNewBridge{Float64}}(
           MOI.Utilities.Model{Float64}(),
       )
MOIB.Constraint.SingleBridgeOptimizer{MyNewBridge{Float64}, MOIU.Model{Float64}}
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

## Implementation notes

All bridges should simplify the creation of `SingleBridgeOptimizer`s by defining
a constant that wraps the bridge in a `SingleBridgeOptimizer`.
```jldoctest con_singlebridgeoptimizer
julia> const MyNewBridgeModel{T,OT<:MOI.ModelLike} =
           MOI.Bridges.Constraint.SingleBridgeOptimizer{MyNewBridge{T},OT};
```
This enables users to create bridged models as follows:
```jldoctest con_singlebridgeoptimizer
julia> MyNewBridgeModel{Float64}(MOI.Utilities.Model{Float64}());
```
"""
mutable struct SingleBridgeOptimizer{BT<:AbstractBridge,OT<:MOI.ModelLike} <:
               MOI.Bridges.AbstractBridgeOptimizer
    model::OT
    map::Map # index of bridged constraint -> constraint bridge
    con_to_name::Dict{MOI.ConstraintIndex,String}
    name_to_con::Union{Dict{String,MOI.ConstraintIndex},Nothing}
end

function SingleBridgeOptimizer{BT}(model::OT) where {BT,OT<:MOI.ModelLike}
    return SingleBridgeOptimizer{BT,OT}(
        model,
        Map(),
        Dict{MOI.ConstraintIndex,String}(),
        nothing,
    )
end

bridges(::MOI.Bridges.AbstractBridgeOptimizer) = EmptyMap()

bridges(bridge::SingleBridgeOptimizer) = bridge.map

MOI.Bridges.supports_constraint_bridges(::SingleBridgeOptimizer) = true

# If `BT` bridges `MOI.Reals` (such as `Constraint.FunctionizeBridge` bridge,
# without this method, it creates a `StackOverflow` with `is_bridged`,
# `supports_bridging_constrained_variable` and `supports_add_constrained_variables`.
MOI.Bridges.is_bridged(::SingleBridgeOptimizer, ::Type{MOI.Reals}) = false

function MOI.Bridges.is_bridged(
    b::SingleBridgeOptimizer,
    S::Type{<:MOI.AbstractSet},
)
    return MOI.Bridges.supports_bridging_constrained_variable(b, S)
end

MOI.Bridges.is_bridged(::SingleBridgeOptimizer, ::MOI.VariableIndex) = false

function MOI.Bridges.is_bridged(
    b::SingleBridgeOptimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S}
    return MOI.Bridges.is_bridged(b, MOI.VariableIndex, S) &&
           haskey(Constraint.bridges(b), ci)
end

function MOI.Bridges.is_bridged(
    b::SingleBridgeOptimizer,
    ci::MOI.ConstraintIndex{MOI.VectorOfVariables,S},
) where {S}
    return MOI.Bridges.is_bridged(b, MOI.VectorOfVariables, S) &&
           haskey(Constraint.bridges(b), ci)
end

function MOI.Bridges.supports_bridging_constrained_variable(
    b::SingleBridgeOptimizer,
    S::Type{<:MOI.AbstractSet},
)
    F = MOI.Utilities.variable_function_type(S)
    return MOI.Bridges.supports_bridging_constraint(b, F, S) &&
           MOI.supports_add_constrained_variables(b, MOI.Reals)
end

function MOI.Bridges.supports_bridging_constraint(
    @nospecialize(b::SingleBridgeOptimizer{BT}),
    @nospecialize(F::Type{<:MOI.AbstractFunction}),
    @nospecialize(S::Type{<:MOI.AbstractSet}),
) where {BT}
    return MOI.supports_constraint(BT, F, S)
end

function MOI.Bridges.is_bridged(
    b::SingleBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    return MOI.Bridges.supports_bridging_constraint(b, F, S)
end

function MOI.Bridges.is_bridged(
    ::SingleBridgeOptimizer,
    ::Type{<:MOI.AbstractFunction},
)
    return false
end

function MOI.Bridges.bridge_type(
    ::SingleBridgeOptimizer{BT},
    ::Type{<:MOI.AbstractFunction},
    ::Type{<:MOI.AbstractSet},
) where {BT}
    return BT
end

MOI.Bridges.bridging_cost(::SingleBridgeOptimizer, args...) = 1.0

MOI.Bridges.recursive_model(b::SingleBridgeOptimizer) = b.model

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestMutableArithmetics

using Test

import MutableArithmetics as MA
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

_zero(::Type{MOI.VariableIndex}, T::Type) = zero(MOI.ScalarAffineFunction{T})
_zero(x, ::Type) = zero(x)

function _promote_operation_test(op::Function, T, x::Type, y::Type)
    f() = MA.promote_operation(op, x, y)
    @test typeof(op(_zero(x, T), _zero(y, T))) == f()
    @test 0 == @allocated f()
end

function _test_promote_operation_allocation(T)
    AffType = MOI.ScalarAffineFunction{T}
    QuadType = MOI.ScalarQuadraticFunction{T}
    for op in [+, -, *]
        _promote_operation_test(op, T, T, MOI.VariableIndex)
        _promote_operation_test(op, T, MOI.VariableIndex, T)
        _promote_operation_test(op, T, T, AffType)
        _promote_operation_test(op, T, AffType, T)
        _promote_operation_test(op, T, T, QuadType)
        _promote_operation_test(op, T, QuadType, T)
        _promote_operation_test(op, T, MOI.VariableIndex, AffType)
        _promote_operation_test(op, T, AffType, MOI.VariableIndex)
        if op != *
            _promote_operation_test(op, T, MOI.VariableIndex, QuadType)
            _promote_operation_test(op, T, QuadType, MOI.VariableIndex)
            _promote_operation_test(op, T, AffType, QuadType)
            _promote_operation_test(op, T, QuadType, AffType)
        end
    end
    return
end

function test_promote_operation_allocation_Int()
    return _test_promote_operation_allocation(Int)
end

function test_promote_operation_allocation_Float64()
    return _test_promote_operation_allocation(Float64)
end

function test_promote_operation_allocation_Float32()
    return _test_promote_operation_allocation(Float32)
end

function _test_promote_operation(T)
    @test MA.promote_operation(*, MOI.VariableIndex, T) ==
          MOI.ScalarAffineFunction{T}
    @test MA.promote_operation(*, T, MOI.VariableIndex) ==
          MOI.ScalarAffineFunction{T}
    @test MA.promote_operation(*, MOI.ScalarAffineFunction{T}, T) ==
          MOI.ScalarAffineFunction{T}
    @test MA.promote_operation(*, T, MOI.ScalarAffineFunction{T}) ==
          MOI.ScalarAffineFunction{T}
    @test MA.promote_operation(*, MOI.ScalarQuadraticFunction{T}, T) ==
          MOI.ScalarQuadraticFunction{T}
    @test MA.promote_operation(*, T, MOI.ScalarQuadraticFunction{T}) ==
          MOI.ScalarQuadraticFunction{T}
    return
end

test_promote_operation_Int() = _test_promote_operation(Int)
test_promote_operation_Float64() = _test_promote_operation(Float64)
test_promote_operation_Float32() = _test_promote_operation(Float32)

function _test_scaling(T)
    x = MOI.VariableIndex(1)
    @test T(3) == MA.scaling(T(0)x + T(3))
    f = T(2)x + T(3)
    err = InexactError(:convert, T, f)
    @test_throws err MA.scaling(f)
end

test_scaling_Float64() = _test_scaling(Float64)
test_scaling_Float32() = _test_scaling(Float32)

function test_unary_minus()
    for T in [Float64, Float32]
        x = MOI.VariableIndex(1)
        for f in [T(2)x + T(3), T(4) * x * x + T(2)x + T(3)]
            g = -f
            @test g ≈ MA.operate!(-, f)
            @test g ≈ f
            @test -g ≈ MA.operate!(-, f)
            @test -g ≈ f
        end
    end
    return
end

function _run_all_tests(T::Type, a, b, c, d, e, f, g)
    exclude = ["scalar_uniform_scaling", "cube"]
    @testset "Scalar" begin
        MA.Test.scalar_test(a, exclude = exclude)
        MA.Test.scalar_test(b, exclude = exclude)
        MA.Test.scalar_test(c, exclude = exclude)
        MA.Test.scalar_test(d, exclude = exclude)
        MA.Test.scalar_test(e, exclude = exclude)
        MA.Test.scalar_test(f, exclude = exclude)
        MA.Test.scalar_test(g, exclude = exclude)
    end
    if !(a isa MOI.ScalarQuadraticFunction)
        exclude = String[]
        if T <: Integer
            push!(exclude, "quadratic_division")
        end
        @testset "Quadratic" begin
            MA.Test.quadratic_test(a, b, c, d, exclude = exclude)
            MA.Test.quadratic_test(b, c, d, e, exclude = exclude)
            MA.Test.quadratic_test(c, d, e, f, exclude = exclude)
            MA.Test.quadratic_test(d, e, f, g, exclude = exclude)
            MA.Test.quadratic_test(e, f, g, a, exclude = exclude)
            MA.Test.quadratic_test(f, g, a, b, exclude = exclude)
            MA.Test.quadratic_test(g, a, b, c, exclude = exclude)
        end
    end
    exclude = String[]
    if a isa MOI.ScalarQuadraticFunction
        push!(exclude, "sparse_quadratic")
    end
    @testset "Sparse" begin
        MA.Test.sparse_test(a, b, [a b c; b c a; a b a], exclude = exclude)
    end
    exclude = String[]
    if a isa MOI.ScalarQuadraticFunction
        push!(exclude, "matrix_vector")
        push!(exclude, "dot")
    end
    @testset "Vector" begin
        MA.Test.array_test([a, b, c], exclude = exclude)
        MA.Test.array_test([b, c, d], exclude = exclude)
        MA.Test.array_test([c, d, e], exclude = exclude)
        MA.Test.array_test([d, e, a], exclude = exclude)
        MA.Test.array_test([e, a, b], exclude = exclude)
    end
    exclude = [
        "broadcast_division",
        "matrix_uniform_scaling",
        "symmetric_matrix_uniform_scaling",
        "matrix_vector_division",
    ]
    if a isa MOI.ScalarQuadraticFunction
        push!(exclude, "dot")
        push!(exclude, "broadcast_multiplication")
        push!(exclude, "sum_multiplication")
    end
    @testset "Matrix" begin
        MA.Test.array_test([a b; c d], exclude = exclude)
        MA.Test.array_test([c e; e d], exclude = exclude)
        MA.Test.array_test([a b c; b c a; a b a], exclude = exclude)
        MA.Test.array_test([d b c; d c e; e b a], exclude = exclude)
    end
    return
end

function test_VariableIndex()
    x = MOI.VariableIndex(1)
    a = 2x
    MA.Test.@test_rewrite(a + x)
    MA.Test.@test_rewrite(a + 3 * x)
    MA.Test.@test_rewrite(a + x * 4)
    MA.Test.@test_rewrite(a + 3 * x * 4)
    MA.Test.@test_rewrite(x + a)
    MA.Test.@test_rewrite(a - x)
    MA.Test.@test_rewrite(a - 3 * x)
    MA.Test.@test_rewrite(a - x * 4)
    MA.Test.@test_rewrite(a - 3 * x * 4)
    MA.Test.@test_rewrite(x - a)
end

function test_ScalarAffineFunction()
    T = Int
    MA.Test.int_test(
        MOI.ScalarAffineFunction{T},
        exclude = ["int_mul", "int_add_mul"],
    )
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    a = T(2) * x + T(1)
    b = T(4) * y + T(2)
    c = T(3) * x - T(2) * y - T(3)
    d = T(3) * x - T(2) * y + T(4) * x
    e = T(5) * x - T(5)
    f = T(1) * y - T(2) * x + T(2)
    g = T(2) * x + T(3) * x
    _run_all_tests(T, a, b, c, d, e, f, g)
    return
end

function test_ScalarQuadraticFunction()
    T = Int
    MA.Test.int_test(
        MOI.ScalarQuadraticFunction{T},
        exclude = ["int_mul", "int_add_mul"],
    )
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    a = T(2) * x + T(1) + T(4) * x * y
    b = T(4) * y + T(3) * y * y - T(3) * y * x + T(2)
    c = T(2) * x * x + T(3) * x - T(2) * y - T(3)
    d = T(2) * x * x + T(3) * x - T(2) * y + T(4) * x - T(1) * y * y
    e = T(5) * x - T(5) - T(4) * x * y
    f = T(1) * y + T(2) * y * y - T(2) * x + T(2)
    g = T(2) * x + T(3) * x + T(3) * x * y
    _run_all_tests(T, a, b, c, d, e, f, g)
    return
end

end  # module

TestMutableArithmetics.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module CleverDicts

# The following two functions are overloaded for `MOI.VariableIndex` here
# it is the original use-case for `CleverDict`, and it would be type-piracy for
# solvers using `CleverDicts` to implement it themselves.

import MathOptInterface as MOI
import OrderedCollections: OrderedDict

"""
    index_to_key(::Type{K}, index::Int)

Create a new key associated with the integer value `index`.
"""
function index_to_key end

"""
    key_to_index(key::K)

Map `key` to an integer valued index, assuming that there have been no
deletions.
"""
function key_to_index end

function index_to_key(::Type{MOI.VariableIndex}, index::Int64)
    return MOI.VariableIndex(index)
end

function index_to_key(
    ::Type{MOI.ConstraintIndex{F,S}},
    index::Int64,
) where {F,S}
    return MOI.ConstraintIndex{F,S}(index)
end

key_to_index(key::MOI.Index) = key.value

# Now, on with `CleverDicts`.

"""
    CleverDict{K, V}

A smart storage type for managing sequential objects with non-decreasing integer
indices. Note that the integers are `Int64`s.

Provided no keys are deleted, the backing storage is a `Vector{V}`. Once a key
has been deleted, the backing storage switches to an `OrderedDict{K, V}`.

Use the `add_item` to enforce adding item in sequence. Once an object is added
out of order `add_item` does not work anymore and the storage is switched to
`OrderedDict{K, V}` if it is not one already.

The i'th ordered element can be obtained with `c[LinearIndex(i)]`.

Note that querying a `LinearIndex` immediately after deleting a key via
`delete!` is very slow. (It requires a rebuild of an ordered list of variables.)

Store an item `val` using `add_item(c::CleverDict, val)`. `add_item` returns a
key corresponding to the stored item.

Overload the functions `index_to_key` and `key_to_index` to enable mappings
between the integer index of the vector and the dictionary key.

## Example

```julia
struct MyKey
    x::Int64
end
index_to_key(::Type{MyKey}, i::Int64) = MyKey(i)
key_to_index(key::MyKey) = key.x
```
"""
mutable struct CleverDict{K,V,F<:Function,I<:Function} <: AbstractDict{K,V}
    last_index::Int64
    hash::F
    inverse_hash::I
    is_dense::Bool
    vector::Vector{V}
    dict::OrderedDict{K,V}
    function CleverDict{K,V}(
        hash::F = key_to_index,
        inverse_hash::I = index_to_key,
    ) where {K,V,F<:Function,I<:Function}
        return new{K,V,F,I}(
            0,
            hash,
            inverse_hash,
            true,
            V[],
            OrderedDict{K,V}(),
        )
    end
end

_is_dense(c::CleverDict) = c.is_dense

function _inverse_hash(c::CleverDict{K}, index::Integer) where {K}
    return c.inverse_hash(Int64(index))::K
end

function _inverse_hash(
    ::CleverDict{K,V,F,typeof(index_to_key)},
    index::Integer,
) where {K,V,F<:Function}
    return index_to_key(K, Int64(index))::K
end

"""
    add_item(c::CleverDict{K, V}, val::Val)::K where {K, V}

Set `val` in the next available key, and return that key.
"""
function add_item(c::CleverDict{K,V}, val::V)::K where {K,V}
    if c.last_index == -1
        error(
            "Keys were added out of order. `add_item` requires that keys are always added in order.",
        )
    end
    # adding a key in order
    key = _inverse_hash(c, c.last_index + 1)
    c[key] = val
    return key
end

function Base.empty!(c::CleverDict)
    empty!(c.vector)
    empty!(c.dict)
    c.last_index = 0
    c.is_dense = true
    return
end

function Base.length(c::CleverDict)
    return _is_dense(c) ? length(c.vector) : length(c.dict)
end

function Base.haskey(c::CleverDict{K}, key::K) where {K}
    if _is_dense(c)
        return 1 <= c.hash(key)::Int64 <= length(c.vector)
    end
    return haskey(c.dict, key)
end

function Base.get(c::CleverDict, key, default)
    if _is_dense(c)
        if !haskey(c, key)
            return default
        end
        return c.vector[c.hash(key)::Int64]
    end
    return get(c.dict, key, default)
end

function Base.getindex(c::CleverDict{K,V}, key::K) where {K,V}
    if _is_dense(c)
        if !haskey(c, key)
            throw(KeyError(key))
        end
        return c.vector[c.hash(key)::Int64]
    end
    return c.dict[key]
end

function Base.setindex!(c::CleverDict{K,V}, value::V, key::K)::V where {K,V}
    h = c.hash(key)::Int64
    if c.last_index != -1
        if h == c.last_index + 1
            c.last_index = h
        elseif h <= 0 || h > c.last_index
            c.last_index = -1
        end
    end
    if 1 <= h <= length(c.vector) && _is_dense(c)
        c.vector[h] = value
    elseif h == length(c.vector) + 1 && _is_dense(c)
        push!(c.vector, value)
    else
        if _is_dense(c)
            _rehash(c)
        end
        c.dict[key] = value
        # If there is a vector (for example, because it has been rebuilt for
        # `LinearIndex`), clear it.
        if !isempty(c.vector)
            empty!(c.vector)
        end
    end
    return value
end

function _rehash(c::CleverDict{K}) where {K}
    sizehint!(c.dict, length(c.vector))
    @assert _is_dense(c)
    # Since c is currently dense, iterator protocol from CleverDict is used.
    for (k, v) in c
        c.dict[k] = v
    end
    empty!(c.vector)
    c.is_dense = false
    return
end

function Base.delete!(c::CleverDict{K}, k::K) where {K}
    if _is_dense(c)
        _rehash(c)
    end
    delete!(c.dict, k)
    if !isempty(c.vector)
        empty!(c.vector)
    end
    return c
end

struct LinearIndex
    i::Int64
end

function Base.getindex(c::CleverDict{K,V}, index::LinearIndex)::V where {K,V}
    if !(1 <= index.i <= length(c))
        throw(KeyError(index))
    end
    # Get the `index` linear element. If `c.vector` is currently `nothing`
    # (that is, there has been a deletion), rebuild `c.vector`. This is a
    # trade-off: We could ensure `c.vector` is always updated, but this requires
    # a `splice!` in `delete!`, making deletions costly. However, it makes this
    # `getindex` operation trivial because we would never have to rebuild the
    # vector.
    # The current implemented approach offers quick deletions, but an expensive
    # rebuild the first time you query a `LinearIndex` after a deletion or a new
    # key is added. Once the rebuild is done, there are quick queries until the
    # next deletion or addition. Thus, the worst-case is a user repeatedly
    # deleting a key and then querying a LinearIndex (for example, getting the MOI
    # objective function).
    if !_is_dense(c) && length(c.dict) != length(c.vector)
        c.vector = Vector{V}(undef, length(c))
        for (i, val) in enumerate(values(c.dict))
            c.vector[i] = val
        end
    end
    return c.vector[index.i]::V
end

function Base.isempty(c::CleverDict)
    return _is_dense(c) ? isempty(c.vector) : isempty(c.dict)
end

Base.haskey(::CleverDict, key) = false

function Base.iterate(c::CleverDict{K,V}) where {K,V}
    if _is_dense(c)
        itr = iterate(c.vector)
        if itr === nothing
            return
        end
        return _inverse_hash(c, 1) => itr[1]::V, itr[2]::Int
    end
    itr = iterate(c.dict)
    if itr === nothing
        return
    end
    return convert(Pair{K,V}, itr[1]), itr[2]
end

function Base.iterate(c::CleverDict{K,V}, s::Int) where {K,V}
    if _is_dense(c)
        itr = iterate(c.vector, s)
        if itr === nothing
            return
        end
        return _inverse_hash(c, s) => itr[1]::V, itr[2]::Int
    end
    itr = iterate(c.dict, s)
    if itr === nothing
        return
    end
    return convert(Pair{K,V}, itr[1]), itr[2]
end

# we do not have to implement values and keys functions because they can rely
# on `Base`s fallback that uses the iterator protocol

function Base.sizehint!(c::CleverDict{K,V}, n) where {K,V}
    if _is_dense(c)
        sizehint!(c.vector, n)
    else
        sizehint!(c.dict, n)
    end
    return
end

function Base.resize!(c::CleverDict{K,V}, n) where {K,V}
    if _is_dense(c)
        if n < length(c.vector)
            error(
                "CleverDict cannot be resized to a size smaller than the current",
            )
        end
        resize!(c.vector, n)
    else
        sizehint!(c.dict, n)
    end
    return
end

# TODO `map!(f, values(dict::AbstractDict))` requires Julia 1.2 or later,
#      use `map_values` once we drop Julia 1.1 and earlier.
function map_values!(f::Function, d::CleverDict)
    if _is_dense(d)
        map!(f, d.vector, d.vector)
    else
        for (k, v) in d.dict
            d.dict[k] = f(v)
        end
    end
    return
end

function Base.convert(
    ::Type{CleverDict{K,V,typeof(key_to_index),typeof(index_to_key)}},
    d::CleverDict{K,V,typeof(key_to_index),typeof(index_to_key)},
) where {K,V}
    return d
end

function Base.convert(
    ::Type{CleverDict{K,V,typeof(key_to_index),typeof(index_to_key)}},
    src::AbstractDict{K,V},
) where {K,V}
    dest = CleverDict{K,V}()
    for key in sort(collect(keys(src)), by = dest.hash)
        dest[key] = src[key]
    end
    return dest
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type FlipSignBridge{T,S1,S2} <: SetMapBridge{T,S2,S1} end

An abstract type that simplifies the creation of other bridges.
"""
abstract type FlipSignBridge{T,S1<:MOI.AbstractSet,S2<:MOI.AbstractSet} <:
              SetMapBridge{T,S2,S1} end

function MOI.Bridges.map_function(::Type{<:FlipSignBridge{T}}, func) where {T}
    return MOI.Utilities.operate(-, T, func)
end

# The map is an involution
function MOI.Bridges.inverse_map_function(BT::Type{<:FlipSignBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is symmetric
function MOI.Bridges.adjoint_map_function(BT::Type{<:FlipSignBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is a symmetric involution
function MOI.Bridges.inverse_adjoint_map_function(
    BT::Type{<:FlipSignBridge},
    func,
)
    return MOI.Bridges.map_function(BT, func)
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::FlipSignBridge,
    i::MOI.Bridges.IndexInVector,
)
    MOI.delete(model, bridge.variables[i.value])
    deleteat!(bridge.variables, i.value)
    return
end

"""
    NonposToNonnegBridge{T} <: Bridges.Variable.AbstractBridge

`NonposToNonnegBridge` implements the following reformulation:

* ``x \\in \\mathbb{R}_-`` into ``y \\in \\mathbb{R}_+`` with the substitution
  rule ``x = -y``,

where `T` is the coefficient type of `-y`.

## Source node

`NonposToNonnegBridge` supports:

* [`MOI.VectorOfVariables`](@ref) in [`MOI.Nonpositives`](@ref)

## Target nodes

`NonposToNonnegBridge` creates:

* One variable node: [`MOI.VectorOfVariables`](@ref) in [`MOI.Nonnegatives`](@ref),
"""
struct NonposToNonnegBridge{T} <:
       FlipSignBridge{T,MOI.Nonpositives,MOI.Nonnegatives}
    variables::Vector{MOI.VariableIndex}
    constraint::MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives}
end

const NonposToNonneg{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NonposToNonnegBridge{T},OT}

function MOI.Bridges.map_set(
    ::Type{<:NonposToNonnegBridge},
    set::MOI.Nonnegatives,
)
    return MOI.Nonpositives(set.dimension)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:NonposToNonnegBridge},
    set::MOI.Nonpositives,
)
    return MOI.Nonnegatives(set.dimension)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintGeomeanToRelentr

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_GeoMeantoRelEntr()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.GeoMeantoRelEntr{Float64}(mock)
    MOI.Test.test_basic_VectorOfVariables_GeometricMeanCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_basic_VectorAffineFunction_GeometricMeanCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    return MOI.Test.test_basic_VectorQuadraticFunction_GeometricMeanCone(
        bridged_mock,
        config,
    )
end

function test_conic_GeometricMeanCone_VectorAffineFunction()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.GeoMeantoRelEntr{Float64}(mock)
    var_primal = [1, 1, 1, 1, 0]
    relentr_dual = [1, 1, 1, 1, -1, -1, -1] / 3
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-inv(3)],
            (MOI.VectorOfVariables, MOI.Nonnegatives) => [[1]],
            (MOI.VectorAffineFunction{Float64}, MOI.RelativeEntropyCone) =>
                [relentr_dual],
        )

    MOI.Test.test_conic_GeometricMeanCone_VectorAffineFunction(
        bridged_mock,
        config,
    )
    var_names = ["t", "x", "y", "z"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    nonneg = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonnegatives}(),
    )
    relentr = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.RelativeEntropyCone,
        }(),
    )
    aux = MOI.get(mock, MOI.ListOfVariableIndices())[end]
    MOI.set(mock, MOI.VariableName(), aux, "aux")
    @test length(nonneg) == 1
    MOI.set(mock, MOI.ConstraintName(), nonneg[1], "nonneg")
    @test length(relentr) == 1
    MOI.set(mock, MOI.ConstraintName(), relentr[1], "relentr")
    less = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(less) == 1
    MOI.set(mock, MOI.ConstraintName(), less[1], "less")

    s = """
    variables: t, x, y, z, aux
    less: x + y + z in LessThan(3.0)
    nonneg: [aux] in Nonnegatives(1)
    relentr: [0.0, x, y, z, t + aux, t + aux, t + aux] in RelativeEntropyCone(7)
    maxobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        vcat(var_names, "aux"),
        ["less", "nonneg", "relentr"],
    )
    geomean = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.GeometricMeanCone,
        }(),
    )
    @test length(geomean) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), geomean[1], "geomean")
    less = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(less) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), less[1], "less")

    s = """
    variables: t, x, y, z
    less: x + y + z in LessThan(3.0)
    geomean: [1.0t, x, y, z] in GeometricMeanCone(4)
    maxobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["less", "geomean"],
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.GeometricMeanCone,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value =
            (attr isa MOI.ConstraintPrimalStart) ? ones(4) :
            vcat(-1, fill(inv(3), 3))
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
        if attr isa MOI.ConstraintPrimalStart
            @test MOI.get(mock, MOI.VariablePrimalStart(), aux) == 0
            @test MOI.get(mock, attr, nonneg[1]) == [0]
            @test MOI.get(mock, attr, relentr[1]) == [0, 1, 1, 1, 1, 1, 1]
        else
            @test MOI.get(mock, attr, nonneg[1]) == [1]
            @test MOI.get(mock, attr, relentr[1]) ≈ relentr_dual
        end
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        4,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 1),
            (MOI.VectorOfVariables, MOI.Nonnegatives, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.RelativeEntropyCone, 0),
        ),
    )
    return
end

function test_conic_GeometricMeanCone_VectorAffineFunction_2()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.GeoMeantoRelEntr{Float64}(mock)
    var_primal = vcat(ones(10), 0)
    relentr_dual = vcat(fill(inv(9), 10), fill(-inv(9), 9))
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                fill(-inv(9), 9),
            (MOI.VectorOfVariables, MOI.Nonnegatives) => [[1]],
            (MOI.VectorAffineFunction{Float64}, MOI.RelativeEntropyCone) =>
                [relentr_dual],
        )

    MOI.Test.test_conic_GeometricMeanCone_VectorAffineFunction_2(
        bridged_mock,
        config,
    )
    var_names = vcat("t", ["x$(i)" for i in 1:9])
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    nonneg = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonnegatives}(),
    )
    relentr = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.RelativeEntropyCone,
        }(),
    )
    aux = MOI.get(mock, MOI.ListOfVariableIndices())[end]
    MOI.set(mock, MOI.VariableName(), aux, "aux")
    @test length(nonneg) == 1
    MOI.set(mock, MOI.ConstraintName(), nonneg[1], "nonneg")
    @test length(relentr) == 1
    MOI.set(mock, MOI.ConstraintName(), relentr[1], "relentr")
    equalto = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.EqualTo{Float64},
        }(),
    )
    @test length(equalto) == 9
    equalto_names = ["equalto$(i)" for i in 1:9]
    MOI.set.(bridged_mock, MOI.ConstraintName(), equalto, equalto_names)

    s = """
    variables: t, x1, x2, x3, x4, x5, x6, x7, x8, x9, aux
    equalto1: 1.0x1 in EqualTo(1.0)
    equalto2: 1.0x2 in EqualTo(1.0)
    equalto3: 1.0x3 in EqualTo(1.0)
    equalto4: 1.0x4 in EqualTo(1.0)
    equalto5: 1.0x5 in EqualTo(1.0)
    equalto6: 1.0x6 in EqualTo(1.0)
    equalto7: 1.0x7 in EqualTo(1.0)
    equalto8: 1.0x8 in EqualTo(1.0)
    equalto9: 1.0x9 in EqualTo(1.0)
    nonneg: [aux] in Nonnegatives(1)
    relentr: [0.0, x1, x2, x3, x4, x5, x6, x7, x8, x9, t + aux, t + aux, t + aux, t + aux, t + aux, t + aux, t + aux, t + aux, t + aux] in RelativeEntropyCone(19)
    maxobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        vcat(var_names, "aux"),
        vcat(equalto_names, "nonneg", "relentr"),
    )
    geomean = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.GeometricMeanCone,
        }(),
    )
    @test length(geomean) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), geomean[1], "geomean")
    equalto = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.EqualTo{Float64},
        }(),
    )
    @test length(equalto) == 9
    equalto_names = ["equalto$(i)" for i in 1:9]
    MOI.set.(bridged_mock, MOI.ConstraintName(), equalto, equalto_names)

    s = """
    variables: t, x1, x2, x3, x4, x5, x6, x7, x8, x9
    equalto1: 1.0x1 in EqualTo(1.0)
    equalto2: 1.0x2 in EqualTo(1.0)
    equalto3: 1.0x3 in EqualTo(1.0)
    equalto4: 1.0x4 in EqualTo(1.0)
    equalto5: 1.0x5 in EqualTo(1.0)
    equalto6: 1.0x6 in EqualTo(1.0)
    equalto7: 1.0x7 in EqualTo(1.0)
    equalto8: 1.0x8 in EqualTo(1.0)
    equalto9: 1.0x9 in EqualTo(1.0)
    geomean: [1.0t, x1, x2, x3, x4, x5, x6, x7, x8, x9] in GeometricMeanCone(10)
    maxobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        vcat(equalto_names, "geomean"),
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.GeometricMeanCone,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value =
            (attr isa MOI.ConstraintPrimalStart) ? ones(10) :
            vcat(-1, fill(inv(9), 9))
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
        if attr isa MOI.ConstraintPrimalStart
            @test MOI.get(mock, MOI.VariablePrimalStart(), aux) == 0
            @test MOI.get(mock, attr, nonneg[1]) == [0]
            @test MOI.get(mock, attr, relentr[1]) == vcat(0, ones(18))
        else
            @test MOI.get(mock, attr, nonneg[1]) == [1]
            @test MOI.get(mock, attr, relentr[1]) ≈ relentr_dual
        end
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        10,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}, 9),
            (MOI.VectorOfVariables, MOI.Nonnegatives, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.RelativeEntropyCone, 0),
        ),
    )
    return
end

function test_conic_GeometricMeanCone_VectorAffineFunction_3()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.GeoMeantoRelEntr{Float64}(mock)
    var_primal = [2, 2, 0]
    relentr_dual = [2, 2, -2]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-2],
            (MOI.VectorOfVariables, MOI.Nonnegatives) => [[2]],
            (MOI.VectorAffineFunction{Float64}, MOI.RelativeEntropyCone) =>
                [relentr_dual],
        )

    MOI.Test.test_conic_GeometricMeanCone_VectorAffineFunction_3(
        bridged_mock,
        config,
    )
    var_names = ["t", "x"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    nonneg = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonnegatives}(),
    )
    relentr = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.RelativeEntropyCone,
        }(),
    )
    aux = MOI.get(mock, MOI.ListOfVariableIndices())[end]
    MOI.set(mock, MOI.VariableName(), aux, "aux")
    @test length(nonneg) == 1
    MOI.set(mock, MOI.ConstraintName(), nonneg[1], "nonneg")
    @test length(relentr) == 1
    MOI.set(mock, MOI.ConstraintName(), relentr[1], "relentr")
    less = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(less) == 1
    MOI.set(mock, MOI.ConstraintName(), less[1], "less")
    s = """
    variables: t, x, aux
    less: 1.0x in LessThan(2.0)
    nonneg: [aux] in Nonnegatives(1)
    relentr: [0.0, x, t + aux] in RelativeEntropyCone(3)
    maxobjective: 2.0t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        vcat(var_names, "aux"),
        ["less", "nonneg", "relentr"],
    )
    geomean = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.GeometricMeanCone,
        }(),
    )
    @test length(geomean) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), geomean[1], "geomean")
    less = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(less) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), less[1], "less")

    s = """
    variables: t, x
    less: 1.0x in LessThan(2.0)
    geomean: [1.0t, x] in GeometricMeanCone(2)
    maxobjective: 2.0t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["less", "geomean"],
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.GeometricMeanCone,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value = (attr isa MOI.ConstraintPrimalStart) ? [2, 2] : [-2, 2]
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
        if attr isa MOI.ConstraintPrimalStart
            @test MOI.get(mock, MOI.VariablePrimalStart(), aux) == 0
            @test MOI.get(mock, attr, nonneg[1]) == [0]
            @test MOI.get(mock, attr, relentr[1]) == [0, 2, 2]
        else
            @test MOI.get(mock, attr, nonneg[1]) == [2]
            @test MOI.get(mock, attr, relentr[1]) ≈ relentr_dual
        end
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 1),
            (MOI.VectorOfVariables, MOI.Nonnegatives, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.RelativeEntropyCone, 0),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.GeoMeantoRelEntrBridge,
        """
        variables: u, w1, w2
        [u, w1, w2] in GeometricMeanCone(3)
        """,
        """
        variables: u, w1, w2, y
        [0, w1, w2, u + y, u + y] in RelativeEntropyCone(5)
        [y] in Nonnegatives(1)
        """,
    )
    return
end

end  # module

TestConstraintGeomeanToRelentr.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

abstract type _AbstractSlackBridge{T,VF,ZS,F,S} <: AbstractBridge end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:_AbstractSlackBridge{T,VF,ZS,F,S}},
) where {T,VF,ZS,F,S}
    return Tuple{Type}[(S,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:_AbstractSlackBridge{T,VF,ZS,F}},
) where {T,VF,ZS,F}
    return Tuple{Type,Type}[(F, ZS)]
end

function MOI.get(
    ::_AbstractSlackBridge{T,VF,ZS,F},
    ::MOI.NumberOfConstraints{F,ZS},
)::Int64 where {T,VF,ZS,F}
    return 1
end

function MOI.get(
    bridge::_AbstractSlackBridge{T,VF,ZS,F},
    ::MOI.ListOfConstraintIndices{F,ZS},
) where {T,VF,ZS,F}
    return [bridge.equality]
end

function MOI.get(
    ::_AbstractSlackBridge{T,VF,ZS,F,S},
    ::MOI.NumberOfConstraints{VF,S},
)::Int64 where {T,VF,ZS,F,S}
    return 1
end

function MOI.get(
    bridge::_AbstractSlackBridge{T,VF,ZS,F,S},
    ::MOI.ListOfConstraintIndices{VF,S},
) where {T,VF,ZS,F,S}
    return [bridge.slack_in_set]
end

function MOI.get(
    ::_AbstractSlackBridge{T,VF,S,F,S},
    ::MOI.NumberOfConstraints{VF,S},
)::Int64 where {T,VF,F,S}
    # This method is needed to resolve a possible ambiguity reported by
    # Test.detect_ambiguities. It can't happen in practice because it would mean
    # that the original set was the same as the slacked set.
    return error(
        "Internal error: this method should never be called because it " *
        "represents an invalid state. Please open an issue to report.",
    )
end

function MOI.get(
    bridge::_AbstractSlackBridge{T,VF,S,F,S},
    ::MOI.ListOfConstraintIndices{VF,S},
) where {T,VF,S,F}
    # This method is needed to resolve a possible ambiguity reported by
    # Test.detect_ambiguities. It can't happen in practice because it would mean
    # that the original set was the same as the slacked set.
    return error(
        "Internal error: this method should never be called because it " *
        "represents an invalid state. Please open an issue to report.",
    )
end

function MOI.delete(model::MOI.ModelLike, bridge::_AbstractSlackBridge)
    MOI.delete(model, bridge.equality)
    MOI.delete(model, bridge.slack)
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{<:_AbstractSlackBridge{T,VF,ZS,F,S}},
) where {T,VF,ZS,F,S}
    ret = true
    if attr isa MOI.ConstraintPrimalStart
        ret = MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
    end
    # .slack_in_set field is {VF,S}
    # .equality field is {F,ZS}
    return ret &&
           MOI.supports(model, attr, MOI.ConstraintIndex{VF,S}) &&
           MOI.supports(model, attr, MOI.ConstraintIndex{F,ZS})
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::_AbstractSlackBridge,
)
    # Due to equality, slack should have the same value as original affine
    # function.
    return MOI.get(model, attr, bridge.slack_in_set)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::_AbstractSlackBridge,
    value,
)
    if bridge isa ScalarSlackBridge
        MOI.set(model, MOI.VariablePrimalStart(), bridge.slack, value)
    else
        MOI.set.(model, MOI.VariablePrimalStart(), bridge.slack, value)
    end
    MOI.set(model, attr, bridge.slack_in_set, value)
    start = value === nothing ? nothing : zero(value)
    MOI.set(model, attr, bridge.equality, start)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    a::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::_AbstractSlackBridge{T},
) where {T}
    # The dual constraint on slack (since it is free) is
    # `-dual_slack_in_set + dual_equality = 0` so the two duals are
    # equal (modulo a rescaling for things like symmetric matrices) and we can
    # return either one of them.
    #
    # We decide to use the dual of the equality constraints because the
    # `slack_in_set` constraint might be bridged by a variable bridge that does
    # not support `ConstraintDual`. This is the case if the adjoint of the
    # linear map on which the bridge is based is not invertible, for example,
    # `Variable.ZerosBridge` or `SumOfSquares.Bridges.Variable.KernelBridge`.
    dual = MOI.get(model, a, bridge.equality)
    if dual === nothing
        return nothing
    elseif dual isa AbstractVector
        # The equality constraints gives the term <dual, primal> with the
        # standard inner product but <dual, primal>_PSD is like scaling each
        # entry of dual and primal by the entry of SetDotScalingVector. To undo,
        # we need to divide by the square.
        scale = MOI.Utilities.SetDotScalingVector{T}(bridge.set)
        return dual ./ scale .^ 2
    end
    return dual
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::_AbstractSlackBridge{T},
    value,
) where {T}
    # See comments in MOI.get for why we need to rescale, etc.
    MOI.set(model, attr, bridge.slack_in_set, value)
    if value isa AbstractVector
        scale = MOI.Utilities.SetDotScalingVector{T}(bridge.set)
        MOI.set(model, attr, bridge.equality, value .* scale .^ 2)
    else
        MOI.set(model, attr, bridge.equality, value)
    end
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::_AbstractSlackBridge,
    change::MOI.AbstractFunctionModification,
)
    MOI.modify(model, bridge.equality, change)
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::_AbstractSlackBridge{T,VF,ZS,F,S},
    change::S,
) where {T,VF,ZS,F,S}
    MOI.set(model, MOI.ConstraintSet(), bridge.slack_in_set, change)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::_AbstractSlackBridge,
)
    return MOI.Utilities.remove_variable(
        MOI.get(model, attr, bridge.equality),
        bridge.slack,
    )
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::_AbstractSlackBridge,
)
    return MOI.get(model, attr, bridge.slack_in_set)
end

"""
    ScalarSlackBridge{T,F,S} <: Bridges.Constraint.AbstractBridge

`ScalarSlackBridge` implements the following reformulation:

  * ``f(x) \\in S`` into ``f(x) - y == 0`` and ``y \\in S``

## Source node

`ScalarSlackBridge` supports:

  * `G` in `S`, where `G` is not [`MOI.VariableIndex`](@ref) and `S` is not
    [`MOI.EqualTo`](@ref)

## Target nodes

`ScalarSlackBridge` creates:

  * `F` in [`MOI.EqualTo{T}`](@ref)
  * [`MOI.VariableIndex`](@ref) in `S`
"""
struct ScalarSlackBridge{T,F,S} <:
       _AbstractSlackBridge{T,MOI.VariableIndex,MOI.EqualTo{T},F,S}
    slack::MOI.VariableIndex
    set::S
    slack_in_set::MOI.ConstraintIndex{MOI.VariableIndex,S}
    equality::MOI.ConstraintIndex{F,MOI.EqualTo{T}}
end

const ScalarSlack{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ScalarSlackBridge{T},OT}

function bridge_constraint(
    ::Type{ScalarSlackBridge{T,F,S}},
    model,
    f::MOI.AbstractScalarFunction,
    s::S,
) where {T,F,S}
    MOI.throw_if_scalar_and_constant_not_zero(f, typeof(s))
    slack, slack_in_set = MOI.add_constrained_variable(model, s)
    new_f = MOI.Utilities.operate(-, T, f, slack)
    equality = MOI.add_constraint(model, new_f, MOI.EqualTo(zero(T)))
    return ScalarSlackBridge{T,F,S}(slack, s, slack_in_set, equality)
end

# Start by allowing all scalar constraints:

function MOI.supports_constraint(
    ::Type{ScalarSlackBridge{T}},
    F::Type{<:MOI.AbstractScalarFunction},
    ::Type{<:MOI.AbstractScalarSet},
) where {T}
    return MOI.Utilities.is_coefficient_type(F, T)
end

# Then restrict, being careful with method ambiguities

function MOI.supports_constraint(
    ::Type{ScalarSlackBridge{T}},
    ::Type{<:MOI.VariableIndex},
    ::Type{<:MOI.EqualTo},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::Type{ScalarSlackBridge{T}},
    ::Type{<:MOI.VariableIndex},
    ::Type{<:MOI.AbstractScalarSet},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::Type{ScalarSlackBridge{T}},
    ::Type{<:MOI.AbstractScalarFunction},
    ::Type{<:MOI.EqualTo},
) where {T}
    return false
end

function concrete_bridge_type(
    ::Type{<:ScalarSlackBridge{T}},
    F::Type{<:MOI.AbstractScalarFunction},
    S::Type{<:MOI.AbstractScalarSet},
) where {T}
    F2 = MOI.Utilities.promote_operation(-, T, F, MOI.VariableIndex)
    return ScalarSlackBridge{T,F2,S}
end

MOI.get(b::ScalarSlackBridge, ::MOI.NumberOfVariables)::Int64 = 1

MOI.get(b::ScalarSlackBridge, ::MOI.ListOfVariableIndices) = [b.slack]

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintBasisStatus,
    bridge::ScalarSlackBridge{T,F,S},
) where {T,F,S<:MOI.Interval}
    return MOI.get(
        model,
        MOI.VariableBasisStatus(),
        MOI.VariableIndex(bridge.slack_in_set.value),
    )
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintBasisStatus,
    bridge::ScalarSlackBridge,
)
    status = MOI.get(
        model,
        MOI.VariableBasisStatus(),
        MOI.VariableIndex(bridge.slack_in_set.value),
    )
    if status == MOI.NONBASIC_AT_LOWER || status == MOI.NONBASIC_AT_UPPER
        return MOI.NONBASIC
    end
    return status
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::ScalarSlackBridge{T,F,S},
    func::F,
) where {T,F,S}
    new_func = MOI.Utilities.operate(-, T, func, bridge.slack)
    MOI.set(model, MOI.ConstraintFunction(), bridge.equality, new_func)
    return
end

"""
    VectorSlackBridge{T,F,S} <: Bridges.Constraint.AbstractBridge

`VectorSlackBridge` implements the following reformulation:

  * ``f(x) \\in S`` into ``f(x) - y \\in \\{0\\}`` and ``y \\in S``

## Source node

`VectorSlackBridge` supports:

  * `G` in `S`, where `G` is not [`MOI.VectorOfVariables`](@ref) and `S` is not
    [`MOI.Zeros`](@ref)

## Target nodes

`VectorSlackBridge` creates:

  * `F` in [`MOI.Zeros`](@ref)
  * [`MOI.VectorOfVariables`](@ref) in `S`
"""
struct VectorSlackBridge{T,F,S} <:
       _AbstractSlackBridge{T,MOI.VectorOfVariables,MOI.Zeros,F,S}
    slack::Vector{MOI.VariableIndex}
    set::S
    slack_in_set::MOI.ConstraintIndex{MOI.VectorOfVariables,S}
    equality::MOI.ConstraintIndex{F,MOI.Zeros}
end

const VectorSlack{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{VectorSlackBridge{T},OT}

function bridge_constraint(
    ::Type{VectorSlackBridge{T,F,S}},
    model,
    f::MOI.AbstractVectorFunction,
    s::S,
) where {T,F,S}
    d = MOI.dimension(s)
    slack, slack_in_set = MOI.add_constrained_variables(model, s)
    new_f = MOI.Utilities.operate(-, T, f, MOI.VectorOfVariables(slack))
    equality = MOI.add_constraint(model, new_f, MOI.Zeros(d))
    return VectorSlackBridge{T,F,S}(slack, s, slack_in_set, equality)
end

function MOI.supports_constraint(
    ::Type{VectorSlackBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    ::Type{<:MOI.AbstractVectorSet},
) where {T}
    return MOI.Utilities.is_coefficient_type(F, T)
end

function MOI.supports_constraint(
    ::Type{VectorSlackBridge{T}},
    ::Type{<:MOI.VectorOfVariables},
    ::Type{<:MOI.Zeros},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::Type{VectorSlackBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{<:MOI.Zeros},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::Type{VectorSlackBridge{T}},
    ::Type{<:MOI.VectorOfVariables},
    ::Type{<:MOI.AbstractVectorSet},
) where {T}
    return false
end

function concrete_bridge_type(
    ::Type{<:VectorSlackBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    S::Type{<:MOI.AbstractVectorSet},
) where {T}
    F2 = MOI.Utilities.promote_operation(-, T, F, MOI.VectorOfVariables)
    return VectorSlackBridge{T,F2,S}
end

MOI.get(b::VectorSlackBridge, ::MOI.NumberOfVariables)::Int64 = length(b.slack)

MOI.get(b::VectorSlackBridge, ::MOI.ListOfVariableIndices) = copy(b.slack)

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::VectorSlackBridge{T,F,S},
    func::F,
) where {T,F,S}
    slack = MOI.VectorAffineFunction{T}(MOI.VectorOfVariables(bridge.slack))
    new_func = MOI.Utilities.operate(-, T, func, slack)
    MOI.set(model, MOI.ConstraintFunction(), bridge.equality, new_func)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSOS1ToMILP

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SOS1ToMILPBridge,
        """
        variables: x, y
        [x, y] in SOS1([1.0, 2.0])
        x in Interval(0.0, 2.0)
        y >= -1.0
        y <= 3.0
        """,
        """
        variables: x, y, z1, z2
        1.0 * z1 + 1.0 * z2 == 1.0
        x in Interval(0.0, 2.0)
        y >= -1.0
        y <= 3.0
        -1.0 * x <= 0.0
        1.0 * x + -2.0 * z1 <= 0.0
        -1.0 * y + -1.0 * z2 <= 0.0
        1.0 * y + -3.0 * z2 <= 0.0
        z1 in ZeroOne()
        z2 in ZeroOne()
        """,
    )
    return
end

function test_runtests_VectorAffineFunction()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SOS1ToMILPBridge,
        """
        variables: x, y
        [1.0 * x + 2.0, y] in SOS1([1.0, 2.0])
        x in ZeroOne()
        y in ZeroOne()
        """,
        """
        variables: x, y, z1, z2
        1.0 * z1 + 1.0 * z2 == 1.0
        -1.0 * x + 2.0 * z1 <= 2.0
        1.0 * x + -3.0 * z1 <= -2.0
        -1.0 * y <= 0.0
        1.0 * y + -1.0 * z2 <= 0.0
        x in ZeroOne()
        y in ZeroOne()
        z1 in ZeroOne()
        z2 in ZeroOne()
        """,
    )
    return
end

function test_resolve_with_modified()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.SOS1ToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint.(model, x, MOI.Interval(0, 2))
    MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.SOS1([1, 2, 3]))
    @test MOI.get(inner, MOI.NumberOfVariables()) == 3
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 6
    MOI.set(model, MOI.ConstraintSet(), c[3], MOI.Interval(0, 1))
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 6
    return
end

function test_runtests_error_variable()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.SOS1ToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.SOS1([1, 2, 3]))
    BT = typeof(model.map[c])
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,MOI.VariableIndex},
        MOI.Bridges.final_touch(model),
    )
    return
end

function test_runtests_error_affine()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.SOS1ToMILP{Int}(inner)
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, Int, 2, 1 * x[1], x[2])
    c = MOI.add_constraint(model, f, MOI.SOS1([1, 2, 3]))
    BT = typeof(model.map[c])
    F = MOI.ScalarAffineFunction{Int}
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,F},
        MOI.Bridges.final_touch(model),
    )
    return
end

function test_delete_before_final_touch()
    model = MOI.Bridges.Constraint.SOS1ToMILP{Float64}(
        MOI.Utilities.Model{Float64}(),
    )
    x = MOI.add_variables(model, 2)
    c = MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.SOS1([1.0, 2.0]),
    )
    MOI.delete(model, c)
    @test !MOI.is_valid(model, c)
    return
end

MOI.Utilities.@model(
    Model2722,
    (),
    (MOI.EqualTo,),
    (MOI.Zeros,),
    (MOI.SOS1,),
    (),
    (MOI.ScalarAffineFunction,),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction,),
)

function MOI.supports_constraint(
    ::Model2722{T},
    ::Type{MOI.VectorAffineFunction{T}},
    ::Type{MOI.SOS1{T}},
) where {T}
    return false
end

function test_bridge_does_not_apply_if_vector_slack_exists()
    inner = Model2722{Float64}()
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64)
    x = MOI.add_variables(model, 3)
    f = MOI.Utilities.vectorize(1.0 .* x)
    c = MOI.add_constraint(model, f, MOI.SOS1([1.0, 2.0, 3.0]))
    @test model.constraint_map[c] isa MOI.Bridges.Constraint.VectorSlackBridge
    F, S = MOI.VectorOfVariables, MOI.SOS1{Float64}
    @test (F, S) in MOI.get(inner, MOI.ListOfConstraintTypesPresent())
    return
end

end  # module

TestConstraintSOS1ToMILP.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintIntegerToZeroOne

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IntegerToZeroOneBridge,
        """
        variables: x, z
        x in Integer()
        x in Interval(1.0, 3.0)
        z in ZeroOne()
        """,
        """
        variables: x, z, y1, y2
        y1 in ZeroOne()
        y2 in ZeroOne()
        x + -1.0 * y1 + -2.0 * y2 == 1.0
        x in Interval(1.0, 3.0)
        z in ZeroOne()
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IntegerToZeroOneBridge,
        """
        variables: x
        x in Integer()
        x in Interval(-1.0, 2.0)
        """,
        """
        variables: x, y1, y2
        y1 in ZeroOne()
        y2 in ZeroOne()
        x + -1.0 * y1 + -2.0 * y2 == -1.0
        x in Interval(-1.0, 2.0)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IntegerToZeroOneBridge,
        """
        variables: x
        x in Integer()
        x in Interval(-2.0, 2.0)
        """,
        """
        variables: x, y1, y2, y3
        y1 in ZeroOne()
        y2 in ZeroOne()
        y3 in ZeroOne()
        x + -1.0 * y1 + -2.0 * y2 + -4.0 * y3 == -2.0
        x in Interval(-2.0, 2.0)
        """,
    )
    return
end

function test_finite_domain_error()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.IntegerToZeroOne{Int}(inner)
    x, _ = MOI.add_constrained_variable(model, MOI.Integer())
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError,
        MOI.Bridges.final_touch(model),
    )
    return
end

function test_final_touch_twice()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.IntegerToZeroOne{Int}(inner)
    x, _ = MOI.add_constrained_variable(model, MOI.Integer())
    MOI.add_constraint(model, x, MOI.Interval(1, 3))
    MOI.Bridges.final_touch(model)
    MOI.Bridges.final_touch(model)
    return
end

end  # module

TestConstraintIntegerToZeroOne.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# See https://github.com/jump-dev/MathOptInterface.jl/issues/321,
#     https://github.com/jump-dev/MathOptInterface.jl/pull/323 and
#     https://github.com/jump-dev/MathOptInterface.jl/pull/390

using BenchmarkTools
import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

MOIU.@model Model () (MOI.Interval,) () () () (MOI.ScalarAffineFunction,) () ()
optimizer = MOIU.MockOptimizer(Model{Float64}())
caching_optimizer = MOIU.CachingOptimizer(Model{Float64}(), optimizer)
MOIU.reset_optimizer(caching_optimizer) # detach optimizer
v = MOI.add_variables(caching_optimizer, 2)
cf = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([0.0, 0.0], v), 0.0)
c = MOI.add_constraint(caching_optimizer, cf, MOI.Interval(-Inf, 1.0))
@btime MOI.set(
    $caching_optimizer,
    $(MOI.ConstraintSet()),
    $c,
    $(MOI.Interval(0.0, 2.0)),
)
MOIU.attach_optimizer(caching_optimizer)
@btime MOI.set(
    $caching_optimizer,
    $(MOI.ConstraintSet()),
    $c,
    $(MOI.Interval(0.0, 2.0)),
)
@btime MOI.set(
    $(caching_optimizer.model_cache),
    $(MOI.ConstraintSet()),
    $c,
    $(MOI.Interval(0.0, 2.0)),
)
@btime MOI.set(
    $(caching_optimizer.optimizer),
    $(MOI.ConstraintSet()),
    $(caching_optimizer.model_to_optimizer_map[c]),
    $(MOI.Interval(0.0, 2.0)),
)

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    Base.read!(io::IO, model::FileFormats.MOF.Model)

Read `io` in the MathOptFormat file format and store the result in `model`.
"""
function Base.read!(io::IO, model::Model)
    if !MOI.is_empty(model)
        error("Cannot read model from file as destination model is not empty.")
    end
    object = JSON3.read(io, Dict{String,Any})
    file_version = _parse_mof_version(object["version"]::Dict{String,Any})
    if !(file_version in _SUPPORTED_VERSIONS)
        version = _SUPPORTED_VERSIONS[1]
        error(
            "Sorry, the file can't be read because this library supports " *
            "v$version of MathOptFormat, but the file you are trying to " *
            "read is v$(file_version).",
        )
    end
    name_map = read_variables(model, object)
    read_objective(model, object, name_map)
    read_constraints(model, object, name_map)
    options = get_options(model)
    # We should convert to NLPBlock if...
    #                                        |  options.use_nlp_block
    #                                        | true    false   nothing
    # object["has_scalar_nonlinear"] = false |   1       0        1
    #                                = true  |   1       0        0
    if something(
        options.use_nlp_block,
        !get(object, "has_scalar_nonlinear", false),
    )
        _convert_to_nlpblock(model)
    end
    return
end

function _convert_to_nlpblock(model::Model{T}) where {T}
    needs_nlp_block = false
    nlp_model = MOI.Nonlinear.Model()
    F = MOI.ScalarNonlinearFunction
    for S in
        (MOI.LessThan{T}, MOI.GreaterThan{T}, MOI.EqualTo{T}, MOI.Interval{T})
        for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
            f = MOI.get(model, MOI.ConstraintFunction(), ci)
            set = MOI.get(model, MOI.ConstraintSet(), ci)
            MOI.Nonlinear.add_constraint(nlp_model, f, set)
            # We don't need this in `model` any more.
            MOI.delete(model, ci)
            needs_nlp_block = true
        end
    end
    if MOI.get(model, MOI.ObjectiveFunctionType()) == F
        obj = MOI.get(model, MOI.ObjectiveFunction{F}())
        MOI.Nonlinear.set_objective(nlp_model, obj)
        MOI.set(
            model,
            MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
            zero(MOI.ScalarAffineFunction{T}),
        )
        needs_nlp_block = true
    end
    if needs_nlp_block
        options = get_options(model)
        evaluator = MOI.Nonlinear.Evaluator(
            nlp_model,
            options.differentiation_backend,
            MOI.get(model, MOI.ListOfVariableIndices()),
        )
        MOI.set(model, MOI.NLPBlock(), MOI.NLPBlockData(evaluator))
    end
    return
end

function read_variables(model::Model{T}, object::Dict) where {T}
    name_map = Dict{String,MOI.VariableIndex}()
    for variable::typeof(object) in object["variables"]
        name = get(variable, "name", "")::String
        if isempty(name)
            error(
                "Variable name is `\"\"`. MathOptFormat variable names must " *
                "be unique and non-empty.",
            )
        end
        name_map[name] = index = MOI.add_variable(model)
        MOI.set(model, MOI.VariableName(), index, name)
        if haskey(variable, "primal_start")
            MOI.set(
                model,
                MOI.VariablePrimalStart(),
                index,
                convert(T, variable["primal_start"]),
            )
        end
    end
    return name_map
end

function read_objective(
    model::Model{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    obj = object["objective"]::typeof(object)
    sense = read_objective_sense(obj["sense"]::String)
    MOI.set(model, MOI.ObjectiveSense(), sense)
    if sense == MOI.FEASIBILITY_SENSE
        return
    end
    func = function_to_moi(T, obj["function"]::typeof(object), name_map)
    MOI.set(model, MOI.ObjectiveFunction{typeof(func)}(), func)
    return
end

_to_T(::Type{T}, x::Number) where {T} = convert(T, x)
_to_T(::Type{T}, x::AbstractVector) where {T} = convert(Vector{T}, x)

function _add_constraint(
    model::Model{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    f = function_to_moi(T, object["function"]::typeof(object), name_map)
    s = set_to_moi(T, object["set"]::typeof(object))
    index = MOI.add_constraint(model, f, s)
    if haskey(object, "name") && typeof(f) != MOI.VariableIndex
        MOI.set(model, MOI.ConstraintName(), index, object["name"]::String)
    end
    if haskey(object, "dual_start")
        MOI.set(
            model,
            MOI.ConstraintDualStart(),
            index,
            _to_T(T, object["dual_start"]),
        )
    end
    if haskey(object, "primal_start")
        MOI.set(
            model,
            MOI.ConstraintPrimalStart(),
            index,
            _to_T(T, object["primal_start"]),
        )
    end
    return
end

function read_constraints(
    model::Model,
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
)
    for constraint::typeof(object) in object["constraints"]::Vector
        _add_constraint(model, constraint, name_map)
    end
end

function read_objective_sense(sense::String)
    if sense == "min"
        return MOI.MIN_SENSE
    elseif sense == "max"
        return MOI.MAX_SENSE
    else
        @assert sense == "feasibility"
        return MOI.FEASIBILITY_SENSE
    end
end

macro head_to_val(f, arg1, args...)
    head = gensym()
    body = Expr(
        :if,
        Expr(:call, :(==), head, string(arg1)),
        Expr(:return, Val(arg1)),
    )
    leaf = body
    for arg in args
        new_expr = Expr(
            :elseif,
            Expr(:call, :(==), head, string(arg)),
            Expr(:return, Val(arg)),
        )
        push!(leaf.args, new_expr)
        leaf = new_expr
    end
    push!(leaf.args, Expr(:return, Val(head)))
    quote
        function $(esc(f))($head::String)
            return $body
        end
    end
end

@head_to_val(
    head_to_function,
    SingleVariable,     # Required for v0.6
    Variable,           # Required for v1.0
    VectorOfVariables,
    ScalarAffineFunction,
    ScalarQuadraticFunction,
    VectorAffineFunction,
    VectorQuadraticFunction,
    ScalarNonlinearFunction,
    VectorNonlinearFunction,
)

"""
    function_to_moi(
        ::Type{T},
        x::Dict,
        name_map::Dict{String,MOI.VariableIndex},
    ) where {T}

Convert `x` from an MOF representation into a MOI representation.
"""
function function_to_moi(
    ::Type{T},
    x::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    head = if haskey(x, "type")
        x["type"]::String
    else
        x["head"]::String  # Required for v0.4
    end
    return function_to_moi(head_to_function(head), T, x, name_map)
end

function function_to_moi(
    ::Val{FunctionSymbol},
    ::Type{T},
    ::Dict,
    ::Dict{String,MOI.VariableIndex},
) where {FunctionSymbol,T}
    return error(
        "Version $(_SUPPORTED_VERSIONS[1]) of MathOptFormat does not support " *
        "the function: $(FunctionSymbol).",
    )
end

# ========== Non-typed scalar functions ==========

# Required for v0.6
function function_to_moi(
    ::Val{:SingleVariable},
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return name_map[object["variable"]::String]
end

# Required for v1.0
function function_to_moi(
    ::Val{:Variable},
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return name_map[object["name"]::String]
end

function function_to_moi(
    ::Val{:ScalarNonlinearFunction},
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return _parse_scalar_nonlinear_function(
        T,
        object["root"],
        object["node_list"],
        name_map,
    )::MOI.ScalarNonlinearFunction
end

function _parse_scalar_nonlinear_function(
    ::Type{T},
    node::Real,
    ::Vector,
    ::Dict{String,MOI.VariableIndex},
) where {T}
    return node
end

function _parse_scalar_nonlinear_function(
    ::Type{T},
    node::String,
    ::Vector,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return name_map[node]
end

function _parse_scalar_nonlinear_function(
    ::Type{T},
    node::Dict,
    node_list::Vector,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    head = node["type"]
    if head == "real"
        # Required for v1.6 and earlier
        return node["value"]
    elseif head == "complex"
        return Complex{T}(node["real"], node["imag"])
    elseif head == "variable"
        # Required for v1.6 and earlier
        return name_map[node["name"]]
    elseif head == "node"
        return _parse_scalar_nonlinear_function(
            T,
            node_list[node["index"]],
            node_list,
            name_map,
        )
    end
    f = MOI.ScalarNonlinearFunction(Symbol(head), Any[])
    for arg in node["args"]
        push!(
            f.args,
            _parse_scalar_nonlinear_function(T, arg, node_list, name_map),
        )
    end
    return f
end

# ========== Typed scalar functions ==========

# Here, we deal with a special case: ScalarAffineTerm, ScalarQuadraticTerm,
# VectorAffineTerm, and VectorQuadraticTerm do not contain a "type" field
# (because it is unnecessary at the JSON level).

function parse_scalar_affine_term(
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return MOI.ScalarAffineTerm{T}(
        convert(T, object["coefficient"]),
        name_map[object["variable"]::String],
    )
end

function function_to_moi(
    ::Val{:ScalarAffineFunction},
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return MOI.ScalarAffineFunction{T}(
        parse_scalar_affine_term.(T, object["terms"], Ref(name_map)),
        convert(T, object["constant"]),
    )
end

function parse_scalar_quadratic_term(
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return MOI.ScalarQuadraticTerm{T}(
        convert(T, object["coefficient"]),
        name_map[object["variable_1"]::String],
        name_map[object["variable_2"]::String],
    )
end

function function_to_moi(
    ::Val{:ScalarQuadraticFunction},
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return MOI.ScalarQuadraticFunction{T}(
        parse_scalar_quadratic_term.(
            T,
            object["quadratic_terms"],
            Ref(name_map),
        ),
        parse_scalar_affine_term.(T, object["affine_terms"], Ref(name_map)),
        convert(T, object["constant"]),
    )
end

# ========== Non-typed vector functions ==========

function function_to_moi(
    ::Val{:VectorOfVariables},
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return MOI.VectorOfVariables(
        MOI.VariableIndex[
            name_map[variable] for variable::String in object["variables"]
        ],
    )
end

function function_to_moi(
    ::Val{:VectorNonlinearFunction},
    ::Type{T},
    object::Dict{String,Any},
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    node_list = Dict{String,Any}.(object["node_list"])
    rows = map(object["rows"]) do r
        return _parse_scalar_nonlinear_function(T, r, node_list, name_map)
    end
    return MOI.VectorNonlinearFunction(rows)
end

# ========== Typed vector functions ==========

function parse_vector_affine_term(
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return MOI.VectorAffineTerm{T}(
        object["output_index"],
        parse_scalar_affine_term(
            T,
            object["scalar_term"]::typeof(object),
            name_map,
        ),
    )
end

function function_to_moi(
    ::Val{:VectorAffineFunction},
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return MOI.VectorAffineFunction{T}(
        parse_vector_affine_term.(T, object["terms"], Ref(name_map)),
        convert(Vector{T}, object["constants"]),
    )
end

function parse_vector_quadratic_term(
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return MOI.VectorQuadraticTerm{T}(
        object["output_index"],
        parse_scalar_quadratic_term(T, object["scalar_term"], name_map),
    )
end

function function_to_moi(
    ::Val{:VectorQuadraticFunction},
    ::Type{T},
    object::Dict,
    name_map::Dict{String,MOI.VariableIndex},
) where {T}
    return MOI.VectorQuadraticFunction{T}(
        parse_vector_quadratic_term.(
            T,
            object["quadratic_terms"],
            Ref(name_map),
        ),
        parse_vector_affine_term.(T, object["affine_terms"], Ref(name_map)),
        convert(Vector{T}, object["constants"]),
    )
end

# ========== Default fallback ==========

@head_to_val(
    head_to_set,
    ZeroOne,
    Integer,
    LessThan,
    GreaterThan,
    EqualTo,
    Interval,
    Semiinteger,
    Semicontinuous,
    Parameter,
    Zeros,
    Reals,
    Nonnegatives,
    Nonpositives,
    HyperRectangle,
    SecondOrderCone,
    RotatedSecondOrderCone,
    GeometricMeanCone,
    NormOneCone,
    NormInfinityCone,
    NormCone,
    RelativeEntropyCone,
    NormSpectralCone,
    NormNuclearCone,
    RootDetConeTriangle,
    RootDetConeSquare,
    LogDetConeTriangle,
    LogDetConeSquare,
    PositiveSemidefiniteConeTriangle,
    ScaledPositiveSemidefiniteConeTriangle, # Required for v1.4
    Scaled,                                 # Required for v1.5
    PositiveSemidefiniteConeSquare,
    HermitianPositiveSemidefiniteConeTriangle,
    ExponentialCone,
    DualExponentialCone,
    PowerCone,
    DualPowerCone,
    SOS1,
    SOS2,
    IndicatorSet,   # Required for v0.6
    Indicator,      # Required for v1.0
    Reified,
    Complements,
    AllDifferent,
    Circuit,
    CountAtLeast,
    CountBelongs,
    CountDistinct,
    CountGreaterThan,
    Cumulative,
    Path,
    BinPacking,
    Table,
)

"""
    set_to_moi(::Type{T}, x::Dict) where {T}

Convert `x` from a Dict representation into a MOI representation.
"""
function set_to_moi(::Type{T}, x::Dict) where {T}
    head = if haskey(x, "type")
        x["type"]::String
    else
        x["head"]::String  # Required for <v0.4
    end
    return set_to_moi(head_to_set(head), T, x)
end

set_to_moi(v::Val, ::Type{T}, object::Dict) where {T} = set_to_moi(v, object)

# ========== Non-typed scalar sets ==========

set_to_moi(::Val{:ZeroOne}, ::Dict) = MOI.ZeroOne()

set_to_moi(::Val{:Integer}, ::Dict) = MOI.Integer()

# ========== Typed scalar sets ==========

function set_to_moi(::Val{:LessThan}, ::Type{T}, object::Dict) where {T}
    return MOI.LessThan{T}(object["upper"])
end

function set_to_moi(::Val{:GreaterThan}, ::Type{T}, object::Dict) where {T}
    return MOI.GreaterThan{T}(object["lower"])
end

function set_to_moi(::Val{:EqualTo}, ::Type{T}, object::Dict) where {T}
    return MOI.EqualTo{T}(object["value"])
end

function set_to_moi(::Val{:Interval}, ::Type{T}, object::Dict) where {T}
    return MOI.Interval{T}(object["lower"], object["upper"])
end

function set_to_moi(::Val{:Semiinteger}, ::Type{T}, object::Dict) where {T}
    return MOI.Semiinteger{T}(object["lower"], object["upper"])
end

function set_to_moi(::Val{:Semicontinuous}, ::Type{T}, object::Dict) where {T}
    return MOI.Semicontinuous{T}(object["lower"], object["upper"])
end

function set_to_moi(::Val{:Parameter}, ::Type{T}, object::Dict) where {T}
    return MOI.Parameter{T}(object["value"])
end

# ========== Non-typed vector sets ==========

function set_to_moi(::Val{:Zeros}, object::Dict)
    return MOI.Zeros(object["dimension"])
end

function set_to_moi(::Val{:Reals}, object::Dict)
    return MOI.Reals(object["dimension"])
end

function set_to_moi(::Val{:Nonnegatives}, object::Dict)
    return MOI.Nonnegatives(object["dimension"])
end

function set_to_moi(::Val{:Nonpositives}, object::Dict)
    return MOI.Nonpositives(object["dimension"])
end

function set_to_moi(::Val{:SecondOrderCone}, object::Dict)
    return MOI.SecondOrderCone(object["dimension"])
end

function set_to_moi(::Val{:RotatedSecondOrderCone}, object::Dict)
    return MOI.RotatedSecondOrderCone(object["dimension"])
end

function set_to_moi(::Val{:GeometricMeanCone}, object::Dict)
    return MOI.GeometricMeanCone(object["dimension"])
end

function set_to_moi(::Val{:NormOneCone}, object::Dict)
    return MOI.NormOneCone(object["dimension"])
end

function set_to_moi(::Val{:NormInfinityCone}, object::Dict)
    return MOI.NormInfinityCone(object["dimension"])
end

function set_to_moi(::Val{:NormCone}, object::Dict)
    return MOI.NormCone(object["p"], object["dimension"])
end

function set_to_moi(::Val{:RelativeEntropyCone}, object::Dict)
    return MOI.RelativeEntropyCone(object["dimension"])
end

function set_to_moi(::Val{:NormSpectralCone}, object::Dict)
    return MOI.NormSpectralCone(object["row_dim"], object["column_dim"])
end

function set_to_moi(::Val{:NormNuclearCone}, object::Dict)
    return MOI.NormNuclearCone(object["row_dim"], object["column_dim"])
end

function set_to_moi(::Val{:RootDetConeTriangle}, object::Dict)
    return MOI.RootDetConeTriangle(object["side_dimension"])
end

function set_to_moi(::Val{:RootDetConeSquare}, object::Dict)
    return MOI.RootDetConeSquare(object["side_dimension"])
end

function set_to_moi(::Val{:LogDetConeTriangle}, object::Dict)
    return MOI.LogDetConeTriangle(object["side_dimension"])
end

function set_to_moi(::Val{:LogDetConeSquare}, object::Dict)
    return MOI.LogDetConeSquare(object["side_dimension"])
end

function set_to_moi(::Val{:PositiveSemidefiniteConeTriangle}, object::Dict)
    return MOI.PositiveSemidefiniteConeTriangle(object["side_dimension"])
end

function set_to_moi(
    ::Val{:ScaledPositiveSemidefiniteConeTriangle},
    object::Dict,
)
    d = object["side_dimension"]
    return MOI.Scaled(MOI.PositiveSemidefiniteConeTriangle(d))
end

function set_to_moi(::Val{:Scaled}, ::Type{T}, object::Dict) where {T}
    return MOI.Scaled(set_to_moi(T, object["set"]))
end

function set_to_moi(::Val{:PositiveSemidefiniteConeSquare}, object::Dict)
    return MOI.PositiveSemidefiniteConeSquare(object["side_dimension"])
end

function set_to_moi(
    ::Val{:HermitianPositiveSemidefiniteConeTriangle},
    object::Dict,
)
    side_dimension = object["side_dimension"]
    return MOI.HermitianPositiveSemidefiniteConeTriangle(side_dimension)
end

function set_to_moi(::Val{:ExponentialCone}, object::Dict)
    return MOI.ExponentialCone()
end

function set_to_moi(::Val{:DualExponentialCone}, object::Dict)
    return MOI.DualExponentialCone()
end

function set_to_moi(::Val{:Complements}, object::Dict)
    return MOI.Complements(object["dimension"])
end

function set_to_moi(::Val{:AllDifferent}, object::Dict)
    return MOI.AllDifferent(object["dimension"])
end

function set_to_moi(::Val{:Circuit}, object::Dict)
    return MOI.Circuit(object["dimension"])
end

function set_to_moi(::Val{:CountAtLeast}, object::Dict)
    return MOI.CountAtLeast(
        object["n"],
        convert(Vector{Int}, object["partitions"]),
        Set{Int}(object["set"]),
    )
end

function set_to_moi(::Val{:CountBelongs}, object::Dict)
    return MOI.CountBelongs(object["dimension"], Set{Int}(object["set"]))
end

function set_to_moi(::Val{:CountDistinct}, object::Dict)
    return MOI.CountDistinct(object["dimension"])
end

function set_to_moi(::Val{:CountGreaterThan}, object::Dict)
    return MOI.CountGreaterThan(object["dimension"])
end

function set_to_moi(::Val{:Cumulative}, object::Dict)
    return MOI.Cumulative(object["dimension"])
end

function set_to_moi(::Val{:Path}, object::Dict)
    return MOI.Path(Int.(object["from"]), Int.(object["to"]))
end

# ========== Typed vector sets ==========

function set_to_moi(::Val{:PowerCone}, ::Type{T}, object::Dict) where {T}
    return MOI.PowerCone{T}(object["exponent"])
end

function set_to_moi(::Val{:DualPowerCone}, ::Type{T}, object::Dict) where {T}
    return MOI.DualPowerCone{T}(object["exponent"])
end

function set_to_moi(::Val{:SOS1}, ::Type{T}, object::Dict) where {T}
    return MOI.SOS1(convert(Vector{T}, object["weights"]))
end

function set_to_moi(::Val{:SOS2}, ::Type{T}, object::Dict) where {T}
    return MOI.SOS2(convert(Vector{T}, object["weights"]))
end

function set_to_moi(::Val{:HyperRectangle}, ::Type{T}, object::Dict) where {T}
    return MOI.HyperRectangle(
        convert(Vector{T}, object["lower"]),
        convert(Vector{T}, object["upper"]),
    )
end

# :IndicatorSet is required for v0.6
# :Indicator is required for v1.0
function set_to_moi(
    ::Union{Val{:Indicator},Val{:IndicatorSet}},
    ::Type{T},
    object::Dict,
) where {T}
    set = set_to_moi(T, object["set"]::typeof(object))
    if object["activate_on"]::String == "one"
        return MOI.Indicator{MOI.ACTIVATE_ON_ONE}(set)
    else
        @assert object["activate_on"]::String == "zero"
        return MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(set)
    end
end

function set_to_moi(::Val{:Reified}, ::Type{T}, object::Dict) where {T}
    return MOI.Reified(set_to_moi(T, object["set"]::typeof(object)))
end

function set_to_moi(::Val{:BinPacking}, ::Type{T}, object::Dict) where {T}
    return MOI.BinPacking(
        convert(T, object["capacity"]),
        convert(Vector{T}, object["weights"]),
    )
end

function set_to_moi(::Val{:Table}, ::Type{T}, object::Dict) where {T}
    table = convert(Matrix{T}, vcat([t' for t in object["table"]]...))
    return MOI.Table(table)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    Map <: AbstractDict{MOI.ObjectiveFunction,AbstractBridge}

A mapping from a bridged objective function type to the bridge responsible for
bridging that type of objective function.
"""
mutable struct Map <: AbstractDict{MOI.ObjectiveFunction,AbstractBridge}
    bridges::Dict{MOI.ObjectiveFunction,AbstractBridge}
    function_type::Union{Nothing,Type{<:MOI.AbstractFunction}}
end

Map() = Map(Dict{MOI.ObjectiveFunction,AbstractBridge}(), nothing)

# Implementation of `AbstractDict` interface.

Base.isempty(map::Map) = isempty(map.bridges)

function Base.empty!(map::Map)
    empty!(map.bridges)
    map.function_type = nothing
    return map
end

function Base.haskey(map::Map, attr::MOI.ObjectiveFunction)
    return haskey(map.bridges, attr)
end

function Base.getindex(map::Map, attr::MOI.ObjectiveFunction)
    return map.bridges[attr]
end

Base.length(map::Map) = length(map.bridges)

Base.values(map::Map) = values(map.bridges)

Base.iterate(map::Map, args...) = iterate(map.bridges, args...)

# Custom interface for information needed by `AbstractBridgeOptimizer`s that is
# not part of the `AbstractDict` interface.

"""
    function_type(map::Map)

Return the function type of the [`root_bridge`](@ref) or `nothing` if `map` is
empty.
"""
function_type(map::Map) = map.function_type

"""
    root_bridge(map::Map)

Return the last bridge added.
"""
function root_bridge(map::Map)
    attr = MOI.ObjectiveFunction{function_type(map)}()
    return map[attr]
end

"""
    add_key_for_bridge(
        map::Map,
        bridge::AbstractBridge,
        ::F,
    ) where {F<:MOI.AbstractFunction}

Stores the mapping `attr => bridge` where `attr` is
`MOI.ObjectiveFunction{F}()` and set [`function_type`](@ref) to `F`.
"""
function add_key_for_bridge(
    map::Map,
    bridge::AbstractBridge,
    ::F,
) where {F<:MOI.AbstractFunction}
    attr = MOI.ObjectiveFunction{F}()
    map.function_type = F
    map.bridges[attr] = bridge
    return
end

"""
    EmptyMap <: AbstractDict{MOI.ObjectiveFunction,AbstractBridge}

Empty version of [`Map`](@ref).

It is used by
[`MOI.Bridges.Variable.SingleBridgeOptimizer`](@ref) and
[`MOI.Bridges.Constraint.SingleBridgeOptimizer`](@ref) as they do not bridge any
objective function.
"""
struct EmptyMap <: AbstractDict{MOI.ObjectiveFunction,AbstractBridge} end

Base.show(::IO, ::EmptyMap) = nothing

Base.isempty(::EmptyMap) = true

Base.empty!(::EmptyMap) = nothing

Base.length(::EmptyMap) = 0

Base.haskey(::EmptyMap, ::MOI.ObjectiveFunction) = false

Base.values(::EmptyMap) = MOI.Utilities.EmptyVector{AbstractBridge}()

Base.iterate(::EmptyMap) = nothing

function_type(::EmptyMap) = nothing

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestCleverDicts

using Test

import MathOptInterface as MOI
import MathOptInterface.Utilities.CleverDicts

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

# Note: `MyKey` is just for testing. You wouldn't want to use it in practice
# because the key type of the dictionary isn't a concrete type.
struct MyKey{X}
    MyKey(x) = new{Int64(x)}()
end

CleverDicts.key_to_index(::MyKey{X}) where {X} = X
CleverDicts.index_to_key(::Type{MyKey}, index::Int64) = MyKey(index)

function test_MyKey()
    d = CleverDicts.CleverDict{MyKey,String}()
    key = CleverDicts.add_item(d, "first")
    @test key == MyKey(1)
    @test d[MyKey(1)] == "first"
end

function test_Abstract_Value()
    d = CleverDicts.CleverDict{MOI.VariableIndex,Any}()
    key = CleverDicts.add_item(d, :a)
    @test key == MOI.VariableIndex(1)
    @test d[MOI.VariableIndex(1)] == :a
    key = CleverDicts.add_item(d, "b")
    @test key == MOI.VariableIndex(2)
    @test d[MOI.VariableIndex(2)] == "b"
    for (k, v) in d
        if k.value == 1
            @test v == :a
        else
            @test k.value == 2
            @test v == "b"
        end
    end
    return
end

function test_get_set()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    key = CleverDicts.add_item(d, "first")
    @test key == MOI.VariableIndex(1)
    @test get(d, key, nothing) == "first"
    @test get(d, MOI.VariableIndex(2), nothing) === nothing
    @test Dict(key => "first") == d
    @test Dict(key => "second") != d
    sizehint!(d, 1)
    @test d[key] == "first"
    @test haskey(d, key) == true
    @test_throws KeyError d[MOI.VariableIndex(2)]
    delete!(d, key)
    sizehint!(d, 2)
    @test_throws KeyError d[key]
    # set index is valid now
    # @test_throws KeyError d[key] = "key"
    @test haskey(d, key) == false
    key2 = CleverDicts.add_item(d, "second")
    @test key2 == MOI.VariableIndex(2)
    @test d[key2] == "second"
    d[key2] = "third"
    @test d[key2] == "third"
    @test get(d, key, nothing) === nothing
    @test get(d, key2, nothing) === "third"
    @test Dict(key2 => "second") != d
    @test Dict(key2 => "third") == d

    empty!(d)

    key = CleverDicts.add_item(d, "first")
    @test key == MOI.VariableIndex(1)
    @test d[key] == "first"
    d[key] = "zeroth"
    @test d[key] == "zeroth"
    @test haskey(d, key) == true
    @test_throws KeyError d[MOI.VariableIndex(2)]
    delete!(d, key)
    @test_throws KeyError d[key]
    # set index is valid now
    # @test_throws KeyError d[key] = "key"
    @test haskey(d, key) == false
    key2 = CleverDicts.add_item(d, "second")
    @test key2 == MOI.VariableIndex(2)
    @test d[key2] == "second"
    return
end

function test_LinearIndex()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    key = CleverDicts.add_item(d, "first")
    @test d[CleverDicts.LinearIndex(1)] == "first"
    key2 = CleverDicts.add_item(d, "second")
    @test d[CleverDicts.LinearIndex(2)] == "second"
    @test length(d) == 2
    delete!(d, key)
    @test d[CleverDicts.LinearIndex(1)] == "second"
    @test_throws KeyError d[CleverDicts.LinearIndex(2)]
    @test length(d) == 1
    return
end

function test_keys_values()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    key = CleverDicts.add_item(d, "first")
    key2 = CleverDicts.add_item(d, "second")
    @test collect(keys(d)) == [MOI.VariableIndex(1), MOI.VariableIndex(2)]
    @test collect(values(d)) == ["first", "second"]
    delete!(d, key)
    key3 = CleverDicts.add_item(d, "third")
    @test collect(keys(d)) == [MOI.VariableIndex(2), MOI.VariableIndex(3)]
    @test collect(values(d)) == ["second", "third"]
    return
end

function test_iterate()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    key = CleverDicts.add_item(d, "first")
    key2 = CleverDicts.add_item(d, "second")
    my_keys = MOI.VariableIndex[]
    my_values = String[]
    for (k, v) in d
        push!(my_keys, k)
        push!(my_values, v)
    end
    @test my_keys == [MOI.VariableIndex(1), MOI.VariableIndex(2)]
    @test my_values == ["first", "second"]
    delete!(d, key)
    key3 = CleverDicts.add_item(d, "third")
    my_keys = MOI.VariableIndex[]
    my_values = String[]
    for (k, v) in d
        push!(my_keys, k)
        push!(my_values, v)
    end
    @test my_keys == [MOI.VariableIndex(2), MOI.VariableIndex(3)]
    @test my_values == ["second", "third"]
    return
end

function test_iterate_2()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    key = CleverDicts.add_item(d, "first")
    key2 = CleverDicts.add_item(d, "second")
    my_keys = MOI.VariableIndex[]
    my_values = String[]
    for (k, v) in d
        push!(my_keys, k)
        push!(my_values, v)
    end
    @test my_keys == [MOI.VariableIndex(1), MOI.VariableIndex(2)]
    @test my_values == ["first", "second"]
    delete!(d, key)
    @test d[CleverDicts.LinearIndex(1)] == "second"
    key3 = CleverDicts.add_item(d, "third")
    my_keys = MOI.VariableIndex[]
    my_values = String[]
    for (k, v) in d
        push!(my_keys, k)
        push!(my_values, v)
    end
    @test my_keys == [MOI.VariableIndex(2), MOI.VariableIndex(3)]
    @test my_values == ["second", "third"]
    return
end

function test_iterate_3()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    y = 0
    for (k, v) in d
        y += 1
    end
    @test y == 0
    return
end

function test_haskey()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    @test !haskey(d, 1)
    k = CleverDicts.add_item(d, "a")
    @test haskey(d, k)
    j = CleverDicts.add_item(d, "b")
    @test haskey(d, j)
    delete!(d, k)
    @test !haskey(d, k)
    @test haskey(d, j)
    return
end

function test_isempty()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    @test isempty(d) == true
    k = CleverDicts.add_item(d, "a")
    @test isempty(d) == false
    delete!(d, k)
    @test isempty(d) == true
    j = CleverDicts.add_item(d, "b")
    @test isempty(d) == false
    return
end

function test_delete!()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    @test length(d) == 0
    @test delete!(d, MOI.VariableIndex(0)) == d
    k1 = CleverDicts.add_item(d, "a")
    k2 = CleverDicts.add_item(d, "b")
    d[CleverDicts.LinearIndex(2)] == "b"
    delete!(d, k1)
    d[CleverDicts.LinearIndex(1)] == "b"
    k3 = CleverDicts.add_item(d, "c")
    @test d[k3] == "c"
    @test d[CleverDicts.LinearIndex(1)] == "b"
    @test d[CleverDicts.LinearIndex(2)] == "c"
    return
end

function test_negative_index()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    d[MOI.VariableIndex(-3)] = "a"
    @test d[MOI.VariableIndex(-3)] == "a"
    @test_throws ErrorException CleverDicts.add_item(d, "b")
    d[MOI.VariableIndex(0)] = "b"
    @test d[MOI.VariableIndex(-3)] == "a"
    @test d[MOI.VariableIndex(0)] == "b"
    @test_throws ErrorException CleverDicts.add_item(d, "c")
    return
end

function test_convert()
    vals = [MOI.VariableIndex(-i) for i in 1:10]
    d = Dict(MOI.VariableIndex(i) => vals[i] for i in 1:10)
    T = CleverDicts.CleverDict{
        MOI.VariableIndex,
        MOI.VariableIndex,
        typeof(CleverDicts.key_to_index),
        typeof(CleverDicts.index_to_key),
    }
    c = convert(T, d)
    @test c isa T
    @test c.is_dense
    @test c.last_index == 10
    @test c.vector == vals
    @test c === convert(T, c)
    return
end

function test_inverse_hash()
    d = CleverDicts.CleverDict{Int64,String}(identity, identity)
    key = CleverDicts.add_item(d, "a")
    @test d[key] == "a"
    return
end

function test_resize()
    d = CleverDicts.CleverDict{MOI.VariableIndex,String}()
    resize!(d, 1)
    @test length(d.vector) == 1
    x = CleverDicts.add_item(d, "a")
    @test_throws(
        ErrorException(
            "CleverDict cannot be resized to a size smaller than the current",
        ),
        resize!(d, 0),
    )
    delete!(d, x)
    resize!(d, 0)
    return
end

end  # module

TestCleverDicts.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintIndicatorFlipSign

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_lesstogreaterthan()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorLessToGreaterThanBridge,
        """
        variables: x, z
        [z, 2.0 * x] in Indicator{ACTIVATE_ON_ONE}(LessThan(2.0))
        z in ZeroOne()
        """,
        """
        variables: x, z
        [z, -2.0 * x] in Indicator{ACTIVATE_ON_ONE}(GreaterThan(-2.0))
        z in ZeroOne()
        """,
    )
    return
end

function test_runtests_greatertolessthann()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorGreaterToLessThanBridge,
        """
        variables: x, z
        [z, 2.0 * x] in Indicator{ACTIVATE_ON_ONE}(GreaterThan(2.0))
        z in ZeroOne()
        """,
        """
        variables: x, z
        [z, -2.0 * x] in Indicator{ACTIVATE_ON_ONE}(LessThan(-2.0))
        z in ZeroOne()
        """,
    )
    return
end

end  # module

TestConstraintIndicatorFlipSign.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSOCtoNonConvexQuad

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_RSOCtoNonConvexQuad()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config(
        exclude = Any[MOI.ConstraintDual, MOI.DualObjectiveValue],
    )
    @test MOI.Bridges.Constraint.RSOCtoNonConvexQuadBridge{Float64} ==
          MOI.Bridges.Constraint.concrete_bridge_type(
        MOI.Bridges.Constraint.RSOCtoNonConvexQuadBridge{Float64},
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    )
    @test MOI.supports_constraint(
        MOI.Bridges.Constraint.RSOCtoNonConvexQuadBridge{Float64},
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    )
    @test !MOI.supports_constraint(
        MOI.Bridges.Constraint.RSOCtoNonConvexQuadBridge{Float64},
        MOI.ScalarAffineFunction{Float64},
        MOI.RotatedSecondOrderCone,
    )
    bridged_mock = MOI.Bridges.Constraint.RSOCtoNonConvexQuad{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = ["test_basic_VectorOfVariables_RotatedSecondOrderCone"],
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0.5, 1.0, 1 / √2, 1 / √2])
    MOI.Test.test_conic_RotatedSecondOrderCone_VectorOfVariables(
        bridged_mock,
        config,
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.RotatedSecondOrderCone,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        4,
        (
            (MOI.ScalarQuadraticFunction{Float64}, MOI.LessThan{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),
        ),
    )
    return
end

function test_SOCtoNonConvexQuad()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config(
        exclude = Any[MOI.ConstraintDual, MOI.DualObjectiveValue],
    )
    @test MOI.Bridges.Constraint.SOCtoNonConvexQuadBridge{Float64} ==
          MOI.Bridges.Constraint.concrete_bridge_type(
        MOI.Bridges.Constraint.SOCtoNonConvexQuadBridge{Float64},
        MOI.VectorOfVariables,
        MOI.SecondOrderCone,
    )
    @test MOI.supports_constraint(
        MOI.Bridges.Constraint.SOCtoNonConvexQuadBridge{Float64},
        MOI.VectorOfVariables,
        MOI.SecondOrderCone,
    )
    @test !MOI.supports_constraint(
        MOI.Bridges.Constraint.SOCtoNonConvexQuadBridge{Float64},
        MOI.ScalarAffineFunction{Float64},
        MOI.SecondOrderCone,
    )
    bridged_mock = MOI.Bridges.Constraint.SOCtoNonConvexQuad{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = ["test_basic_VectorOfVariables_SecondOrderCone"],
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [1.0, 1 / √2, 1 / √2])
    MOI.Test.test_conic_SecondOrderCone_VectorOfVariables(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.SecondOrderCone,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        (
            (MOI.ScalarQuadraticFunction{Float64}, MOI.LessThan{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SOCtoNonConvexQuadBridge,
        """
        variables: t, x, y
        [t, x, y] in SecondOrderCone(3)
        """,
        """
        variables: t, x, y
        1.0 * x * x + 1.0 * y * y + -1.0 * t * t <= 0.0
        1.0 * t >= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.RSOCtoNonConvexQuadBridge,
        """
        variables: t, u, x
        [t, u, x] in RotatedSecondOrderCone(3)
        """,
        """
        variables: t, u, x
        1.0 * x * x + -2.0 * t * u <= 0.0
        1.0 * t >= 0.0
        1.0 * u >= 0.0
        """,
    )
    return
end

end  # module

TestConstraintSOCtoNonConvexQuad.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableBridge

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

struct DummyVariableBridge <: MOI.Bridges.Variable.AbstractBridge end

function test_AbstractBridge()
    model = MOI.Utilities.Model{Float64}()
    bridge = DummyVariableBridge()
    attr = MOI.VariablePrimalStart()
    @test !MOI.supports(model, attr, typeof(bridge))
    i = MOI.Bridges.IndexInVector(1)
    @test_throws MOI.UnsupportedAttribute(attr) MOI.set(
        model,
        attr,
        bridge,
        1.0,
    )
    @test_throws MOI.UnsupportedAttribute(attr) MOI.set(
        model,
        attr,
        bridge,
        1.0,
        i,
    )
    attr = MOI.VariablePrimal()
    err = MOI.SetAttributeNotAllowed(attr)
    @test_throws err MOI.set(model, attr, bridge, 1.0)
    @test_throws err MOI.set(model, attr, bridge, 1.0, i)
    return
end

function test_bridging_cost()
    model = MOI.Bridges.Variable.SingleBridgeOptimizer{DummyVariableBridge}(
        MOI.Utilities.Model{Float64}(),
    )
    @test MOI.Bridges.bridging_cost(model) == 1.0
    @test MOI.Bridges.bridging_cost(model, MOI.ZeroOne) == 1.0
    return
end

end  # module

TestVariableBridge.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ZeroOneBridge{T} <: Bridges.Constraint.AbstractBridge

`ZeroOneBridge` implements the following reformulation:

  * ``x \\in \\{0, 1\\}`` into ``x \\in \\mathbb{Z}``, ``1x \\in [0, 1]``.

!!! note
    `ZeroOneBridge` adds a linear constraint instead of adding variable bounds
    to avoid conflicting with bounds set by the user.

## Source node

`ZeroOneBridge` supports:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)

## Target nodes

`ZeroOneBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.Integer`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.Interval{T}`](@ref)
"""
struct ZeroOneBridge{T} <: AbstractBridge
    interval_index::MOI.ConstraintIndex{
        MOI.ScalarAffineFunction{T},
        MOI.Interval{T},
    }
    integer_index::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}
end

const ZeroOne{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{ZeroOneBridge{T},OT}

function bridge_constraint(
    ::Type{ZeroOneBridge{T}},
    model::MOI.ModelLike,
    x::MOI.VariableIndex,
    ::MOI.ZeroOne,
) where {T<:Real}
    f = convert(MOI.ScalarAffineFunction{T}, x)
    interval = MOI.add_constraint(model, f, MOI.Interval{T}(zero(T), one(T)))
    integer = MOI.add_constraint(model, x, MOI.Integer())
    return ZeroOneBridge{T}(interval, integer)
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:ZeroOneBridge{T}},
) where {T}
    return Tuple{Type,Type}[
        (MOI.ScalarAffineFunction{T}, MOI.Interval{T}),
        (MOI.VariableIndex, MOI.Integer),
    ]
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:ZeroOneBridge})
    return Tuple{Type}[]
end

function concrete_bridge_type(
    ::Type{<:ZeroOneBridge{T}},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.ZeroOne},
) where {T}
    return ZeroOneBridge{T}
end

function MOI.supports_constraint(
    ::Type{<:ZeroOneBridge},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.ZeroOne},
)
    return true
end

MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, ::ZeroOneBridge) = MOI.ZeroOne()

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::ZeroOneBridge,
)
    return MOI.get(model, attr, bridge.integer_index)
end

function MOI.delete(model::MOI.ModelLike, bridge::ZeroOneBridge)
    MOI.delete(model, bridge.interval_index)
    MOI.delete(model, bridge.integer_index)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal},
    bridge::ZeroOneBridge,
)
    return MOI.get(model, attr, bridge.integer_index)
end

function MOI.get(
    ::ZeroOneBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.Interval{T}},
)::Int64 where {T}
    return 1
end

function MOI.get(
    ::ZeroOneBridge,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Integer},
)::Int64
    return 1
end

function MOI.get(
    bridge::ZeroOneBridge,
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.Interval{T}},
) where {T}
    return [bridge.interval_index]
end

function MOI.get(
    bridge::ZeroOneBridge,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Integer},
)
    return [bridge.integer_index]
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ReifiedAllDifferentToCountDistinctBridge{T,F} <:
    Bridges.Constraint.AbstractBridge

`ReifiedAllDifferentToCountDistinctBridge` implements the following
reformulations:

  * ``r \\iff x \\in \\textsf{AllDifferent}(d)`` to
    ``r \\iff (n, x) \\in \\textsf{CountDistinct}(1+d)`` and ``n = d``
  * ``r \\iff f(x) \\in \\textsf{AllDifferent}(d)`` to
    ``r \\iff (d, f(x)) \\in \\textsf{CountDistinct}(1+d)``

## Source node

`ReifiedAllDifferentToCountDistinctBridge` supports:

  * `F` in [`MOI.Reified{MOI.AllDifferent}`](@ref)

where `F` is [`MOI.VectorOfVariables`](@ref) or
[`MOI.VectorAffineFunction{T}`](@ref).

## Target nodes

`ReifiedAllDifferentToCountDistinctBridge` creates:

  * `F` in [`MOI.Reified{MOI.CountDistinct}`](@ref)
  * [`MOI.VariableIndex`](@ref) in [`MOI.EqualTo{T}`](@ref)
"""
mutable struct ReifiedAllDifferentToCountDistinctBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
} <: AbstractBridge
    f::F
    y::Union{Nothing,MOI.VariableIndex}
    ci::MOI.ConstraintIndex{F,MOI.Reified{MOI.CountDistinct}}

    function ReifiedAllDifferentToCountDistinctBridge{T}(
        f::MOI.VectorOfVariables,
        y::MOI.VariableIndex,
        ci::MOI.ConstraintIndex{
            MOI.VectorOfVariables,
            MOI.Reified{MOI.CountDistinct},
        },
    ) where {T}
        return new{T,MOI.VectorOfVariables}(f, y, ci)
    end

    function ReifiedAllDifferentToCountDistinctBridge{T}(
        f::MOI.VectorAffineFunction{T},
        ci::MOI.ConstraintIndex{
            MOI.VectorAffineFunction{T},
            MOI.Reified{MOI.CountDistinct},
        },
    ) where {T}
        return new{T,MOI.VectorAffineFunction{T}}(f, nothing, ci)
    end
end

const ReifiedAllDifferentToCountDistinct{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ReifiedAllDifferentToCountDistinctBridge{T},OT}

function bridge_constraint(
    ::Type{ReifiedAllDifferentToCountDistinctBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.Reified{MOI.AllDifferent},
) where {T,F<:MOI.VectorOfVariables}
    d = MOI.output_dimension(f)
    y, _ = MOI.add_constrained_variable(model, MOI.EqualTo(T(d - 1)))
    scalars = MOI.Utilities.eachscalar(f)
    ci = MOI.add_constraint(
        model,
        MOI.Utilities.operate(vcat, T, scalars[1], y, scalars[2:end]),
        MOI.Reified(MOI.CountDistinct(d)),
    )
    return ReifiedAllDifferentToCountDistinctBridge{T}(f, y, ci)
end

function bridge_constraint(
    ::Type{ReifiedAllDifferentToCountDistinctBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.Reified{MOI.AllDifferent},
) where {T,F<:MOI.VectorAffineFunction{T}}
    d = MOI.output_dimension(f)
    scalars = MOI.Utilities.eachscalar(f)
    ci = MOI.add_constraint(
        model,
        MOI.Utilities.operate(vcat, T, scalars[1], T(d - 1), scalars[2:end]),
        MOI.Reified(MOI.CountDistinct(d)),
    )
    return ReifiedAllDifferentToCountDistinctBridge{T}(f, ci)
end

function MOI.supports_constraint(
    ::Type{<:ReifiedAllDifferentToCountDistinctBridge{T}},
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}},
    ::Type{MOI.Reified{MOI.AllDifferent}},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{ReifiedAllDifferentToCountDistinctBridge{T,MOI.VectorOfVariables}},
) where {T}
    return Tuple{Type}[(MOI.EqualTo{T},)]
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{
        ReifiedAllDifferentToCountDistinctBridge{T,MOI.VectorAffineFunction{T}},
    },
) where {T}
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{ReifiedAllDifferentToCountDistinctBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[(F, MOI.Reified{MOI.CountDistinct}),]
end

function concrete_bridge_type(
    ::Type{<:ReifiedAllDifferentToCountDistinctBridge{T}},
    ::Type{F},
    ::Type{MOI.Reified{MOI.AllDifferent}},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return ReifiedAllDifferentToCountDistinctBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::ReifiedAllDifferentToCountDistinctBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::ReifiedAllDifferentToCountDistinctBridge,
)
    return MOI.Reified(MOI.AllDifferent(MOI.output_dimension(bridge.f) - 1))
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::ReifiedAllDifferentToCountDistinctBridge,
)
    MOI.delete(model, bridge.ci)
    if bridge.y !== nothing
        MOI.delete(model, bridge.y)
    end
    return
end

function MOI.get(
    bridge::ReifiedAllDifferentToCountDistinctBridge,
    ::MOI.NumberOfVariables,
)::Int64
    if bridge.y === nothing
        return 0
    end
    return 1
end

function MOI.get(
    bridge::ReifiedAllDifferentToCountDistinctBridge,
    ::MOI.ListOfVariableIndices,
)
    if bridge.y === nothing
        return MOI.VariableIndex[]
    end
    return MOI.VariableIndex[something(bridge.y)]
end

function MOI.get(
    bridge::ReifiedAllDifferentToCountDistinctBridge{T},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.EqualTo{T}},
)::Int64 where {T}
    if bridge.y === nothing
        return 0
    end
    return 1
end

function MOI.get(
    bridge::ReifiedAllDifferentToCountDistinctBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.EqualTo{T}},
) where {T}
    F, S = MOI.VariableIndex, MOI.EqualTo{T}
    ret = MOI.ConstraintIndex{F,S}[]
    if bridge.y !== nothing
        push!(ret, MOI.ConstraintIndex{F,S}(something(bridge.y).value))
    end
    return ret
end

function MOI.get(
    ::ReifiedAllDifferentToCountDistinctBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.Reified{MOI.CountDistinct}},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    bridge::ReifiedAllDifferentToCountDistinctBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.Reified{MOI.CountDistinct}},
) where {T,F}
    return [bridge.ci]
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

const _NUM_TO_STRING = [string(i) for i in -10:10]

function _to_string(x::Real)
    if isinteger(x)
        if -10 <= x <= 10
            # Optimize some very common cases. It seems annoying to do this, but
            # the lookup is faster than `string(::Int)`, and many models contain
            # small integer constants like -1, 0, or 1.
            return _NUM_TO_STRING[Int(x)+11]
        elseif typemin(Int) <= x <= typemax(Int)
            return string(round(Int, x))
        end
    end
    return string(x)
end

# The card logic is as follows: where possible, try to fit within the strict MPS
# field limits. That means fields start at columns 2, 5, 15, 25, 40, and 50.
# However, since most readers default to loose MPS, make sure each field is
# separated by at least one space.

struct Card
    f1::String
    f2::String
    f3::String
    f4::String
    f5::String

    function Card(;
        f1::String = "",
        f2::String = "",
        f3::String = "",
        f4::String = "",
        f5::String = "",
    )
        return new(f1, f2, f3, f4, f5)
    end
end

function print_offset(io, offset, field, min_start)
    n = max(1, min_start - offset - 1)
    for _ in 1:n
        print(io, ' ')
    end
    print(io, field)
    return offset + n + length(field)
end

function Base.show(io::IO, card::Card)
    offset = print_offset(io, 0, card.f1, 2)
    offset = print_offset(io, offset, card.f2, 5)
    if !isempty(card.f3)
        offset = print_offset(io, offset, card.f3, 15)
    end
    if !isempty(card.f4)
        offset = print_offset(io, offset, card.f4, 25)
    end
    if !isempty(card.f5)
        offset = print_offset(io, offset, card.f5, 40)
    end
    return
end

"""
    Base.write(io::IO, model::FileFormats.MPS.Model)

Write `model` to `io` in the MPS file format.
"""
function Base.write(io::IO, model::Model)
    options = get_options(model)
    if options.generic_names
        # Generic variable names handled in this writer.
        FileFormats.create_generic_constraint_names(model)
    else
        FileFormats.create_unique_names(
            model;
            warn = options.warn,
            replacements = Function[s->replace(s, ' '=>'_')],
        )
    end
    variables = MOI.get(model, MOI.ListOfVariableIndices())
    var_to_column = OrderedDict{MOI.VariableIndex,Int}()
    for (i, x) in enumerate(variables)
        var_to_column[x] = i
    end
    write_model_name(io, model)
    flip_obj = false
    if options.objsense
        if MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
            println(io, "OBJSENSE\n    MAX")
        else
            println(io, "OBJSENSE\n    MIN")
        end
    else
        flip_obj = MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    end
    write_rows(io, model)
    obj_const, indicators = write_columns(io, model, flip_obj, var_to_column)
    write_rhs(io, model, obj_const)
    write_ranges(io, model)
    write_bounds(io, model, var_to_column)
    write_quadobj(io, model, flip_obj, var_to_column)
    if options.quadratic_format != kQuadraticFormatCPLEX
        # Gurobi needs qcons _after_ quadobj and _before_ SOS.
        write_quadcons(io, model, var_to_column)
    end
    write_sos(io, model, var_to_column)
    if options.quadratic_format == kQuadraticFormatCPLEX
        # CPLEX needs qcons _after_ SOS.
        write_quadcons(io, model, var_to_column)
    end
    write_indicators(io, indicators)
    println(io, "ENDATA")
    return
end

# ==============================================================================
#   Model name
# ==============================================================================

function write_model_name(io::IO, model::Model)
    model_name = MOI.get(model, MOI.Name())
    if isempty(model_name)
        println(io, "NAME")
    else
        println(io, rpad("NAME", 14), model_name)
    end
    return
end

# ==============================================================================
#   ROWS
# ==============================================================================

function _write_rows(io, model, ::Type{F}, ::Type{S}, sense_char) where {F,S}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        row_name = MOI.get(model, MOI.ConstraintName(), index)
        if row_name == ""
            error("Row name is empty: $(index).")
        end
        println(io, Card(f1 = sense_char, f2 = row_name))
    end
    return
end

function _write_rows(
    io,
    model::Model{T},
    ::Type{F},
    ::Type{S},
    ::Any,
) where {T,F,S<:MOI.Interval}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        row_name = MOI.get(model, MOI.ConstraintName(), index)
        set = MOI.get(model, MOI.ConstraintSet(), index)
        if set.lower == typemin(T) && set.upper == typemax(T)
            println(io, Card(f1 = "N", f2 = row_name))
        elseif set.upper == typemax(T)
            println(io, Card(f1 = "G", f2 = row_name))
        elseif set.lower == typemin(T)
            println(io, Card(f1 = "L", f2 = row_name))
        else
            println(io, Card(f1 = "L", f2 = row_name))
        end
    end
    return
end

function write_rows(io::IO, model::Model{T}) where {T}
    println(io, "ROWS")
    println(io, Card(f1 = "N", f2 = "OBJ"))
    SAF = MOI.ScalarAffineFunction{T}
    SQF = MOI.ScalarQuadraticFunction{T}
    _write_rows(io, model, SAF, MOI.LessThan{T}, "L")
    _write_rows(io, model, SQF, MOI.LessThan{T}, "L")
    _write_rows(io, model, SAF, MOI.GreaterThan{T}, "G")
    _write_rows(io, model, SQF, MOI.GreaterThan{T}, "G")
    _write_rows(io, model, SAF, MOI.EqualTo{T}, "E")
    _write_rows(io, model, SQF, MOI.EqualTo{T}, "E")
    _write_rows(io, model, SAF, MOI.Interval{T}, "L")
    _write_rows(io, model, SQF, MOI.Interval{T}, "L")
    VAF = MOI.VectorAffineFunction{T}
    _write_rows(io, model, VAF, IndicatorLessThanTrue{T}, "L")
    _write_rows(io, model, VAF, IndicatorLessThanFalse{T}, "L")
    _write_rows(io, model, VAF, IndicatorGreaterThanTrue{T}, "G")
    _write_rows(io, model, VAF, IndicatorGreaterThanFalse{T}, "G")
    _write_rows(io, model, VAF, IndicatorEqualToTrue{T}, "E")
    _write_rows(io, model, VAF, IndicatorEqualToFalse{T}, "E")
    return
end

# ==============================================================================
#   COLUMNS
# ==============================================================================

function _list_of_integer_variables(
    model,
    var_to_column,
    integer_variables,
    ::Type{S},
) where {S}
    for index in
        MOI.get(model, MOI.ListOfConstraintIndices{MOI.VariableIndex,S}())
        v_index = MOI.get(model, MOI.ConstraintFunction(), index)
        push!(integer_variables, var_to_column[v_index])
    end
    return
end

function list_of_integer_variables(model::Model, var_to_column)
    set = Set{Int}()
    _list_of_integer_variables(model, var_to_column, set, MOI.ZeroOne)
    _list_of_integer_variables(model, var_to_column, set, MOI.Integer)
    return set
end

function _extract_terms(
    var_to_column::OrderedDict{MOI.VariableIndex,Int},
    coefficients::Vector{Vector{Tuple{String,T}}},
    row_name::String,
    func::MOI.ScalarAffineFunction,
    flip_sign::Bool = false,
) where {T}
    for term in func.terms
        column = var_to_column[term.variable]
        coef = flip_sign ? -term.coefficient : term.coefficient
        push!(coefficients[column], (row_name, coef))
    end
    return
end

function _extract_terms(
    var_to_column::OrderedDict{MOI.VariableIndex,Int},
    coefficients::Vector{Vector{Tuple{String,T}}},
    row_name::String,
    func::MOI.ScalarQuadraticFunction,
    flip_sign::Bool = false,
) where {T}
    for term in func.affine_terms
        column = var_to_column[term.variable]
        coef = flip_sign ? -term.coefficient : term.coefficient
        push!(coefficients[column], (row_name, coef))
    end
    return
end

function _collect_coefficients(
    model,
    ::Type{F},
    ::Type{S},
    var_to_column::OrderedDict{MOI.VariableIndex,Int},
    coefficients::Vector{Vector{Tuple{String,T}}},
) where {T,F,S}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        row_name = MOI.get(model, MOI.ConstraintName(), index)
        func = MOI.get(model, MOI.ConstraintFunction(), index)
        _extract_terms(var_to_column, coefficients, row_name, func)
    end
    return
end

_activation_condition(::Type{<:MOI.Indicator{A}}) where {A} = A

function _collect_indicator(
    model::Model{T},
    ::Type{S},
    var_to_column,
    coefficients,
    indicators,
) where {T,S}
    options = get_options(model)
    F = MOI.VectorAffineFunction{T}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        row_name = MOI.get(model, MOI.ConstraintName(), index)
        func = MOI.get(model, MOI.ConstraintFunction(), index)
        funcs = MOI.Utilities.eachscalar(func)
        z = convert(MOI.VariableIndex, funcs[1])
        _extract_terms(var_to_column, coefficients, row_name, funcs[2])
        condition = _activation_condition(S)
        var_name = _var_name(model, z, var_to_column[z], options.generic_names)
        push!(indicators, (row_name, var_name, condition))
    end
    return
end

function _get_objective(model::Model{T}) where {T}
    F = MOI.get(model, MOI.ObjectiveFunctionType())
    f = MOI.get(model, MOI.ObjectiveFunction{F}())
    return convert(MOI.ScalarQuadraticFunction{T}, f)
end

function _extract_terms_objective(model, var_to_column, coefficients, flip_obj)
    obj_func = _get_objective(model)
    _extract_terms(var_to_column, coefficients, "OBJ", obj_func, flip_obj)
    return flip_obj ? -obj_func.constant : obj_func.constant
end

function _var_name(
    model::Model,
    variable::MOI.VariableIndex,
    column::Int,
    generic_name::Bool,
)::String
    if generic_name
        return "C$column"
    else
        return MOI.get(model, MOI.VariableName(), variable)
    end
end

function write_columns(
    io::IO,
    model::Model{T},
    flip_obj,
    var_to_column,
) where {T}
    options = get_options(model)
    indicators = Tuple{String,String,MOI.ActivationCondition}[]
    coefficients = Vector{Tuple{String,T}}[
        Tuple{String,T}[] for _ in 1:length(var_to_column)
    ]
    # Build constraint coefficients
    # The functions and sets are given explicitly so that this function is
    # type-stable.
    SAF = MOI.ScalarAffineFunction{T}
    SQF = MOI.ScalarQuadraticFunction{T}
    LT, GT = MOI.LessThan{T}, MOI.GreaterThan{T}
    ET, IT = MOI.EqualTo{T}, MOI.Interval{T}
    _collect_coefficients(model, SAF, LT, var_to_column, coefficients)
    _collect_coefficients(model, SQF, LT, var_to_column, coefficients)
    _collect_coefficients(model, SAF, GT, var_to_column, coefficients)
    _collect_coefficients(model, SQF, GT, var_to_column, coefficients)
    _collect_coefficients(model, SAF, ET, var_to_column, coefficients)
    _collect_coefficients(model, SQF, ET, var_to_column, coefficients)
    _collect_coefficients(model, SAF, IT, var_to_column, coefficients)
    _collect_coefficients(model, SQF, IT, var_to_column, coefficients)
    _collect_indicator(
        model,
        IndicatorLessThanTrue{T},
        var_to_column,
        coefficients,
        indicators,
    )
    _collect_indicator(
        model,
        IndicatorLessThanFalse{T},
        var_to_column,
        coefficients,
        indicators,
    )
    _collect_indicator(
        model,
        IndicatorGreaterThanTrue{T},
        var_to_column,
        coefficients,
        indicators,
    )
    _collect_indicator(
        model,
        IndicatorGreaterThanFalse{T},
        var_to_column,
        coefficients,
        indicators,
    )
    _collect_indicator(
        model,
        IndicatorEqualToTrue{T},
        var_to_column,
        coefficients,
        indicators,
    )
    _collect_indicator(
        model,
        IndicatorEqualToFalse{T},
        var_to_column,
        coefficients,
        indicators,
    )
    # Build objective
    constant =
        _extract_terms_objective(model, var_to_column, coefficients, flip_obj)
    integer_variables = list_of_integer_variables(model, var_to_column)
    println(io, "COLUMNS")
    int_open = false
    for (variable, column) in var_to_column
        var_name = _var_name(model, variable, column, options.generic_names)
        is_int = column in integer_variables
        if is_int && !int_open
            println(io, Card(f2 = "MARKER", f3 = "'MARKER'", f5 = "'INTORG'"))
            int_open = true
        elseif !is_int && int_open
            println(io, Card(f2 = "MARKER", f3 = "'MARKER'", f5 = "'INTEND'"))
            int_open = false
        end
        if length(coefficients[column]) == 0
            # Every variable must appear in the COLUMNS section. Add a 0
            # objective coefficient instead.
            println(io, Card(f2 = var_name, f3 = "OBJ", f4 = "0"))
        end
        for (constraint, coefficient) in coefficients[column]
            println(
                io,
                Card(
                    f2 = var_name,
                    f3 = constraint,
                    f4 = _to_string(coefficient),
                ),
            )
        end
    end
    if int_open
        println(io, Card(f2 = "MARKER", f3 = "'MARKER'", f5 = "'INTEND'"))
    end
    return constant, indicators
end

# ==============================================================================
#   RHS
# ==============================================================================

_value(set::MOI.LessThan) = set.upper
_value(set::MOI.GreaterThan) = set.lower
_value(set::MOI.EqualTo) = set.value
_value(set::MOI.Indicator) = _value(set.set)

function _write_rhs(io, model, ::Type{F}, ::Type{S}) where {F,S}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        row_name = MOI.get(model, MOI.ConstraintName(), index)
        set = MOI.get(model, MOI.ConstraintSet(), index)
        println(
            io,
            Card(f2 = "rhs", f3 = row_name, f4 = _to_string(_value(set))),
        )
    end
    return
end

function _write_rhs(
    io,
    model::Model{T},
    ::Type{F},
    ::Type{S},
) where {T,F,S<:MOI.Interval}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        row_name = MOI.get(model, MOI.ConstraintName(), index)
        set = MOI.get(model, MOI.ConstraintSet(), index)
        if set.lower == typemin(T) && set.upper == typemax(T)
            # No RHS. Free row
        elseif set.upper == typemax(T)
            value = _to_string(set.lower)
            println(io, Card(f2 = "rhs", f3 = row_name, f4 = value))
        elseif set.lower == typemin(T)
            value = _to_string(set.upper)
            println(io, Card(f2 = "rhs", f3 = row_name, f4 = value))
        else
            value = _to_string(set.upper)
            println(io, Card(f2 = "rhs", f3 = row_name, f4 = value))
        end
    end
    return
end

function write_rhs(io::IO, model::Model{T}, obj_const) where {T}
    println(io, "RHS")
    SAF = MOI.ScalarAffineFunction{T}
    SQF = MOI.ScalarQuadraticFunction{T}
    _write_rhs(io, model, SAF, MOI.LessThan{T})
    _write_rhs(io, model, SQF, MOI.LessThan{T})
    _write_rhs(io, model, SAF, MOI.GreaterThan{T})
    _write_rhs(io, model, SQF, MOI.GreaterThan{T})
    _write_rhs(io, model, SAF, MOI.EqualTo{T})
    _write_rhs(io, model, SQF, MOI.EqualTo{T})
    _write_rhs(io, model, SAF, MOI.Interval{T})
    _write_rhs(io, model, SQF, MOI.Interval{T})
    VAF = MOI.VectorAffineFunction{T}
    _write_rhs(io, model, VAF, IndicatorLessThanTrue{T})
    _write_rhs(io, model, VAF, IndicatorLessThanFalse{T})
    _write_rhs(io, model, VAF, IndicatorGreaterThanTrue{T})
    _write_rhs(io, model, VAF, IndicatorGreaterThanFalse{T})
    _write_rhs(io, model, VAF, IndicatorEqualToTrue{T})
    _write_rhs(io, model, VAF, IndicatorEqualToFalse{T})
    # Objective constants are added to the RHS as a negative offset.
    # https://www.ibm.com/docs/en/icos/20.1.0?topic=standard-records-in-mps-format
    if !iszero(obj_const)
        println(io, Card(f2 = "rhs", f3 = "OBJ", f4 = _to_string(-obj_const)))
    end
    return
end

# ==============================================================================
#  RANGES
#
# Here is how RANGE information is encoded.
#
#     Row type | Range value |  lower bound  |  upper bound
#     ------------------------------------------------------
#         G    |     +/-     |     rhs       | rhs + |range|
#         L    |     +/-     | rhs - |range| |     rhs
#         E    |      +      |     rhs       | rhs + range
#         E    |      -      | rhs + range   |     rhs
#
# We elect to write out F-in-Interval constraints in terms of LessThan (L)
# constraints with a range shift. The RHS term is set to the upper bound, and
# the RANGE term to upper - lower.
# ==============================================================================

function _write_ranges(io::IO, model::Model{T}, ::Type{F}) where {T,F}
    cis = MOI.get(model, MOI.ListOfConstraintIndices{F,MOI.Interval{T}}())
    for index in cis
        set = MOI.get(model, MOI.ConstraintSet(), index)::MOI.Interval{T}
        if isfinite(set.upper - set.lower)
            # We only need to write the range if the bounds are both finite
            row_name = MOI.get(model, MOI.ConstraintName(), index)
            range = _to_string(set.upper - set.lower)
            println(io, Card(f2 = "rhs", f3 = row_name, f4 = range))
        end
    end
    return
end

function write_ranges(io::IO, model::Model{T}) where {T}
    println(io, "RANGES")
    _write_ranges(io, model, MOI.ScalarAffineFunction{T})
    _write_ranges(io, model, MOI.ScalarQuadraticFunction{T})
    return
end

# ==============================================================================
#   BOUNDS
#
# Variables default to [0, ∞), or [0, 1] if the variable appears in INTORG and
# does not appear in BOUNDS.
#
#     FX    fixed variable     x == b
#     FR    free variable      -∞ < x < ∞
#     MI    lower bound -inf   -∞ < x
#     LO    lower bound        b <= x
#     LI    integer variable   b <= x
#     PL    upper bound +inf        x < ∞
#     UP    upper bound             x <= b
#     UI    integer variable        x <= b
#     BV    binary variable    x = 0 or 1
#
#  Not yet implemented:
#
#     SC    semi-cont variable x = 0 or l <= x <= b
#           l is the lower bound on the variable. If none set then defaults to 1
# ==============================================================================

function write_single_bound(
    io::IO,
    var_name::String,
    lower::T,
    upper::T,
    vtype,
) where {T}
    if lower == upper
        println(
            io,
            Card(
                f1 = "FX",
                f2 = "bounds",
                f3 = var_name,
                f4 = _to_string(lower),
            ),
        )
    elseif lower == typemin(T) && upper == typemax(T)
        println(io, Card(f1 = "FR", f2 = "bounds", f3 = var_name))
    else
        if lower == typemin(T)
            println(io, Card(f1 = "MI", f2 = "bounds", f3 = var_name))
        else
            println(
                io,
                Card(
                    f1 = vtype == VTYPE_CONTINUOUS ? "LO" : "LI",
                    f2 = "bounds",
                    f3 = var_name,
                    f4 = _to_string(lower),
                ),
            )
        end
        if upper == typemax(T)
            println(io, Card(f1 = "PL", f2 = "bounds", f3 = var_name))
        else
            println(
                io,
                Card(
                    f1 = vtype == VTYPE_CONTINUOUS ? "UP" : "UI",
                    f2 = "bounds",
                    f3 = var_name,
                    f4 = _to_string(upper),
                ),
            )
        end
    end
    return
end

update_bounds(x, set::MOI.GreaterThan) = (max(x[1], set.lower), x[2], x[3])

update_bounds(x, set::MOI.LessThan) = (x[1], min(x[2], set.upper), x[3])

update_bounds(x, set::MOI.Interval) = (set.lower, set.upper, x[3])

update_bounds(x, set::MOI.EqualTo) = (set.value, set.value, x[3])

update_bounds(x, set::MOI.ZeroOne) = (x[1], x[2], VTYPE_BINARY)

function _collect_bounds(bounds, model, ::Type{S}, var_to_column) where {S}
    for index in
        MOI.get(model, MOI.ListOfConstraintIndices{MOI.VariableIndex,S}())
        func = MOI.get(model, MOI.ConstraintFunction(), index)
        set = MOI.get(model, MOI.ConstraintSet(), index)::S
        column = var_to_column[func]
        bounds[column] = update_bounds(bounds[column], set)
    end
    return
end

function write_bounds(io::IO, model::Model{T}, var_to_column) where {T}
    options = get_options(model)
    println(io, "BOUNDS")
    bounds = [
        (typemin(T), typemax(T), VTYPE_CONTINUOUS) for
        _ in 1:length(var_to_column)
    ]
    _collect_bounds(bounds, model, MOI.LessThan{T}, var_to_column)
    _collect_bounds(bounds, model, MOI.GreaterThan{T}, var_to_column)
    _collect_bounds(bounds, model, MOI.EqualTo{T}, var_to_column)
    _collect_bounds(bounds, model, MOI.Interval{T}, var_to_column)
    _collect_bounds(bounds, model, MOI.ZeroOne, var_to_column)
    for (variable, column) in var_to_column
        var_name = _var_name(model, variable, column, options.generic_names)
        lower, upper, vtype = bounds[column]
        if vtype == VTYPE_BINARY
            if lower <= 0 && upper >= 1
                println(io, Card(f1 = "BV", f2 = "bounds", f3 = var_name))
            else
                lower = max(0, lower)
                if lower > 0
                    lower = one(T)
                end
                upper = min(1, upper)
                if upper < 1
                    upper = zero(T)
                end
                write_single_bound(io, var_name, lower, upper, vtype)
            end
        else
            write_single_bound(io, var_name, lower, upper, vtype)
        end
    end
    return
end

# ==============================================================================
#   QUADRATIC OBJECTIVE
# ==============================================================================

function write_quadobj(io::IO, model::Model, flip_obj::Bool, var_to_column)
    f = _get_objective(model)
    if isempty(f.quadratic_terms)
        return
    end
    options = get_options(model)
    # Here we always write out QUADOBJ sections for the quadratic objective. All
    # solvers can read these, even if CPLEX writes QMATRIX by default and Mosek
    # writes QSECTION OBJ.
    println(io, "QUADOBJ")
    _write_q_matrix(
        io,
        model,
        f,
        var_to_column;
        flip_coef = flip_obj,
        generic_names = options.generic_names,
        # In QUADOBJ, we need only to specific the ij term:
        include_ij_and_ji = false,
        # And all solvers interpret QUADOBJ to include /2:
        include_div_2 = true,
    )
    return
end

function _write_q_matrix(
    io::IO,
    model::Model{T},
    f::MOI.ScalarQuadraticFunction,
    var_to_column;
    flip_coef::Bool,
    generic_names::Bool,
    include_ij_and_ji::Bool,
    include_div_2::Bool,
) where {T}
    terms = Dict{Tuple{MOI.VariableIndex,MOI.VariableIndex},T}()
    scale = flip_coef ? -one(T) : one(T)
    if !include_div_2
        scale /= 2
    end
    for term in f.quadratic_terms
        x = term.variable_1
        y = term.variable_2
        if var_to_column[x] > var_to_column[y]
            x, y = y, x
        end
        if haskey(terms, (x, y))
            terms[(x, y)] += term.coefficient
        else
            terms[(x, y)] = term.coefficient
        end
    end
    # Use sort for reproducibility, and so the Q matrix is given in order.
    for (x, y) in sort!(
        collect(keys(terms)),
        by = ((x, y),) -> (var_to_column[x], var_to_column[y]),
    )
        x_name = _var_name(model, x, var_to_column[x], generic_names)
        y_name = _var_name(model, y, var_to_column[y], generic_names)
        coef = scale * terms[(x, y)]
        println(io, Card(f2 = x_name, f3 = y_name, f4 = _to_string(coef)))
        if x != y && include_ij_and_ji
            println(io, Card(f2 = y_name, f3 = x_name, f4 = _to_string(coef)))
        end
    end
    return
end

# ==============================================================================
#   QUADRATIC CONSTRAINTS
# ==============================================================================

function write_quadcons(io::IO, model::Model{T}, var_to_column) where {T}
    options = get_options(model)
    F = MOI.ScalarQuadraticFunction{T}
    for S in
        (MOI.LessThan{T}, MOI.GreaterThan{T}, MOI.EqualTo{T}, MOI.Interval{T})
        for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
            name = MOI.get(model, MOI.ConstraintName(), ci)
            println(io, "QCMATRIX   $name")
            f = MOI.get(model, MOI.ConstraintFunction(), ci)
            _write_q_matrix(
                io,
                model,
                f,
                var_to_column;
                generic_names = options.generic_names,
                # flip_coef is needed only for maximization objectives
                flip_coef = false,
                # All solvers interpret QCMATRIX to require both (i,j) and (j,i)
                # terms.
                include_ij_and_ji = true,
                # In Gurobi's QCMATRIX there is no factor of /2. This is
                # different to both CPLEX and Mosek.
                include_div_2 = options.quadratic_format !=
                                kQuadraticFormatGurobi,
            )
        end
    end
    return
end

# ==============================================================================
#   SOS
# ==============================================================================

function write_sos_constraint(io::IO, model::Model, index, var_to_column)
    options = get_options(model)
    func = MOI.get(model, MOI.ConstraintFunction(), index)
    set = MOI.get(model, MOI.ConstraintSet(), index)
    for (variable, weight) in zip(func.variables, set.weights)
        var_name = _var_name(
            model,
            variable,
            var_to_column[variable],
            options.generic_names,
        )
        println(io, Card(f2 = var_name, f3 = _to_string(weight)))
    end
end

function write_sos(io::IO, model::Model{T}, var_to_column) where {T}
    sos1_indices = MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.SOS1{T}}(),
    )
    sos2_indices = MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.SOS2{T}}(),
    )
    if length(sos1_indices) + length(sos2_indices) > 0
        println(io, "SOS")
        idx = 1
        for (sos_type, indices) in enumerate([sos1_indices, sos2_indices])
            for index in indices
                println(io, Card(f1 = "S$(sos_type)", f2 = "SOS$(idx)"))
                write_sos_constraint(io, model, index, var_to_column)
                idx += 1
            end
        end
    end
    return
end

# ==============================================================================
#   INDICATORS
# ==============================================================================

function write_indicators(io::IO, indicators)
    if isempty(indicators)
        return
    end
    println(io, "INDICATORS")
    for (row, var, condition) in indicators
        if condition == MOI.ACTIVATE_ON_ONE
            println(io, Card(f1 = "IF", f2 = row, f3 = var, f4 = "1"))
        else
            println(io, Card(f1 = "IF", f2 = row, f3 = var, f4 = "0"))
        end
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    test_solve_ObjectiveBound_MIN_SENSE_IP(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a variety of edge cases related to the ObjectiveBound attribute.
"""
function test_solve_ObjectiveBound_MIN_SENSE_IP(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ObjectiveBound)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(T(3 // 2)))
    MOI.add_constraint(model, x, MOI.Integer())
    f = T(2) * x + T(-1)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    _test_model_solution(
        model,
        config;
        objective_value = T(3),
        variable_primal = [(x, T(2))],
    )
    @test MOI.get(model, MOI.ObjectiveBound()) <= T(3)
    return
end

function setup_test(
    ::typeof(test_solve_ObjectiveBound_MIN_SENSE_IP),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(3))
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[2]))
        end,
    )
    return
end

"""
    test_solve_ObjectiveBound_MAX_SENSE_IP(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a variety of edge cases related to the ObjectiveBound attribute.
"""
function test_solve_ObjectiveBound_MAX_SENSE_IP(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ObjectiveBound)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.LessThan(T(3 // 2)))
    MOI.add_constraint(model, x, MOI.Integer())
    f = T(2) * x + T(1)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    _test_model_solution(
        model,
        config;
        objective_value = T(3),
        variable_primal = [(x, T(1))],
    )
    @test MOI.get(model, MOI.ObjectiveBound()) >= T(3)
    return
end

function setup_test(
    ::typeof(test_solve_ObjectiveBound_MAX_SENSE_IP),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(3))
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1]))
        end,
    )
    return
end

"""
    test_solve_ObjectiveBound_MIN_SENSE_LP(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a variety of edge cases related to the ObjectiveBound attribute.
"""
function test_solve_ObjectiveBound_MIN_SENSE_LP(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ObjectiveBound)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(T(3 // 2)))
    f = T(2) * x + T(-1)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    _test_model_solution(
        model,
        config;
        objective_value = T(2),
        variable_primal = [(x, T(3 // 2))],
    )
    @test MOI.get(model, MOI.ObjectiveBound()) <= T(2)
end

function setup_test(
    ::typeof(test_solve_ObjectiveBound_MIN_SENSE_LP),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(2))
            MOIU.mock_optimize!(
                mock,
                MOI.OPTIMAL,
                (MOI.FEASIBLE_POINT, T[3//2]),
            )
        end,
    )
    return
end

"""
    test_solve_ObjectiveBound_MIN_SENSE_LP(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a variety of edge cases related to the ObjectiveBound attribute.
"""
function test_solve_ObjectiveBound_MAX_SENSE_LP(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ObjectiveBound)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.LessThan(T(3 // 2)))
    f = T(2) * x + T(1)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    _test_model_solution(
        model,
        config;
        objective_value = T(4),
        variable_primal = [(x, T(3 // 2))],
    )
    @test MOI.get(model, MOI.ObjectiveBound()) >= T(4)
    return
end

function setup_test(
    ::typeof(test_solve_ObjectiveBound_MAX_SENSE_LP),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), T(4))
            MOIU.mock_optimize!(
                mock,
                MOI.OPTIMAL,
                (MOI.FEASIBLE_POINT, T[3//2]),
            )
        end,
    )
    return
end

"""
    test_solve_TerminationStatus_DUAL_INFEASIBLE(
        model::MOI.ModelLike,
        config::Config,
    )

Test an unbounded linear program.
"""
function test_solve_TerminationStatus_DUAL_INFEASIBLE(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variables(model, 5)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), x), T(0)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.optimize!(model)
    status = MOI.get(model, MOI.TerminationStatus())
    @test in(
        status,
        (MOI.DUAL_INFEASIBLE, MOI.NORM_LIMIT, MOI.INFEASIBLE_OR_UNBOUNDED),
    )
    return
end

function setup_test(
    ::typeof(test_solve_TerminationStatus_DUAL_INFEASIBLE),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.DUAL_INFEASIBLE),
    )
    return
end

"""
    test_solve_VariableIndex_ConstraintDual_MIN_SENSE(
        model::MOI.ModelLike,
        config::Config,
    )

Test `ConstraintDual` of a `VariableIndex` constraint when minimizing.
"""
function test_solve_VariableIndex_ConstraintDual_MIN_SENSE(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variable(model)
    xl = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    xu = MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(1), atol = config.atol)
    sl = MOI.get(model, MOI.ConstraintDual(), xl)
    su = MOI.get(model, MOI.ConstraintDual(), xu)
    @test ≈(sl + su, T(1), atol = config.atol)
    @test sl >= -config.atol
    @test su <= config.atol
    return
end

function setup_test(
    ::typeof(test_solve_VariableIndex_ConstraintDual_MIN_SENSE),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    flag = model.eval_variable_constraint_dual
    model.eval_variable_constraint_dual = false
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[1],
            (MOI.VariableIndex, MOI.LessThan{T}) => T[0],
        ),
    )
    return () -> model.eval_variable_constraint_dual = flag
end

"""
    test_solve_VariableIndex_ConstraintDual_MAX_SENSE(
        model::MOI.ModelLike,
        config::Config,
    )

Test `ConstraintDual` of a `VariableIndex` constraint when maximizing.
"""
function test_solve_VariableIndex_ConstraintDual_MAX_SENSE(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variable(model)
    xl = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    xu = MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(1), atol = config.atol)
    sl = MOI.get(model, MOI.ConstraintDual(), xl)
    su = MOI.get(model, MOI.ConstraintDual(), xu)
    @test ≈(sl + su, T(-1), atol = config.atol)
    @test sl >= -config.atol
    @test su <= config.atol
    return
end

function setup_test(
    ::typeof(test_solve_VariableIndex_ConstraintDual_MAX_SENSE),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    flag = model.eval_variable_constraint_dual
    model.eval_variable_constraint_dual = false
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[0],
            (MOI.VariableIndex, MOI.LessThan{T}) => T[-1],
        ),
    )
    return () -> model.eval_variable_constraint_dual = flag
end

"""
    test_solve_result_index(model::MOI.ModelLike, config::Config{T}) where {T}

Test that various attributes implement `.result_index` correctly.
"""
function test_solve_result_index(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    atol = config.atol
    rtol = config.rtol
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.optimize!(model)
    result_count = MOI.get(model, MOI.ResultCount())
    _test_attribute_value_type(model, MOI.ResultCount())
    function result_err(attr)
        return MOI.ResultIndexBoundsError{typeof(attr)}(attr, result_count)
    end
    result_index = result_count + 1
    @test ≈(MOI.get(model, MOI.ObjectiveValue(1)), T(1), config)
    @test_throws result_err(MOI.ObjectiveValue(result_index)) MOI.get(
        model,
        MOI.ObjectiveValue(result_index),
    )
    if _supports(config, MOI.DualObjectiveValue)
        @test ≈(MOI.get(model, MOI.DualObjectiveValue(1)), T(1), config)
        @test_throws(
            result_err(MOI.DualObjectiveValue(result_index)),
            MOI.get(model, MOI.DualObjectiveValue(result_index)),
        )
    end
    @test MOI.get(model, MOI.PrimalStatus(1)) == MOI.FEASIBLE_POINT
    @test MOI.get(model, MOI.PrimalStatus(result_index)) == MOI.NO_SOLUTION
    @test MOI.get(model, MOI.VariablePrimal(1), x) ≈ T(1) atol = atol rtol =
        rtol
    @test_throws result_err(MOI.VariablePrimal(result_index)) MOI.get(
        model,
        MOI.VariablePrimal(result_index),
        x,
    )
    @test MOI.get(model, MOI.ConstraintPrimal(1), c) ≈ T(1) atol = atol rtol =
        rtol
    @test_throws result_err(MOI.ConstraintPrimal(result_index)) MOI.get(
        model,
        MOI.ConstraintPrimal(result_index),
        c,
    )
    if _supports(config, MOI.ConstraintDual)
        @test MOI.get(model, MOI.DualStatus(1)) == MOI.FEASIBLE_POINT
        @test MOI.get(model, MOI.DualStatus(result_index)) == MOI.NO_SOLUTION
        @test MOI.get(model, MOI.ConstraintDual(1), c) ≈ T(1) atol = atol rtol =
            rtol
        @test_throws result_err(MOI.ConstraintDual(result_index)) MOI.get(
            model,
            MOI.ConstraintDual(result_index),
            c,
        )
    end
    return
end

function setup_test(
    ::typeof(test_solve_result_index),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[1],
        ),
    )
    return
end

"""
    test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper(
        model::MOI.ModelLike,
        config::Config,
    )

Test the Farkas dual of an equality constraint violated above.
"""
function test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variables(model, 2)
    clb = MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[2, 1], x), T(0)),
        MOI.EqualTo(T(-1)),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    @requires MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
    clb_dual = MOI.get.(model, MOI.ConstraintDual(), clb)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test clb_dual[1] > config.atol
    @test clb_dual[2] > config.atol
    @test c_dual[1] < -config.atol
    @test clb_dual ≈ [2, 1] .* -c_dual atol = config.atol rtol = config.rtol
    return
end

function setup_test(
    ::typeof(test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            (MOI.NO_SOLUTION, [NaN, NaN]),
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[2, 1],
            (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) => T[-1],
        ),
    )
    return
end

"""
    test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper(
        model::MOI.ModelLike,
        config::Config,
    )

Test the Farkas dual of an equality constraint violated below.
"""
function test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_lower(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variables(model, 2)
    clb = MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[-2, -1], x), T(0)),
        MOI.EqualTo(T(1)),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    @requires MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
    clb_dual = MOI.get.(model, MOI.ConstraintDual(), clb)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test clb_dual[1] > config.atol
    @test clb_dual[2] > config.atol
    @test c_dual[1] > config.atol
    @test clb_dual ≈ [2, 1] .* c_dual atol = config.atol rtol = config.rtol
end

function setup_test(
    ::typeof(test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_lower),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            MOI.NO_SOLUTION,
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[2, 1],
            (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) => T[1],
        ),
    )
    return
end

"""
    test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper(
        model::MOI.ModelLike,
        config::Config,
    )

Test the Farkas dual of a less-than constraint.
"""
function test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_LessThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variables(model, 2)
    clb = MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[2, 1], x), T(0)),
        MOI.LessThan(T(-1)),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    @requires MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
    clb_dual = MOI.get.(model, MOI.ConstraintDual(), clb)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test clb_dual[1] > config.atol
    @test clb_dual[2] > config.atol
    @test c_dual[1] < -config.atol
    @test clb_dual ≈ [2, 1] .* -c_dual atol = config.atol rtol = config.rtol
    return
end

function setup_test(
    ::typeof(test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_LessThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            (MOI.NO_SOLUTION, [NaN, NaN]),
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[2, 1],
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
        ),
    )
    return
end

"""
    test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper(
        model::MOI.ModelLike,
        config::Config,
    )

Test the Farkas dual of a greater-than constraint.
"""
function test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_GreaterThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variables(model, 2)
    clb = MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[-2, -1], x), T(0)),
        MOI.GreaterThan(T(1)),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    @requires MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
    clb_dual = MOI.get.(model, MOI.ConstraintDual(), clb)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test clb_dual[1] > config.atol
    @test clb_dual[2] > config.atol
    @test c_dual[1] > config.atol
    @test clb_dual ≈ [2, 1] .* c_dual atol = config.atol rtol = config.rtol
    return
end

function setup_test(
    ::typeof(test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_GreaterThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            (MOI.NO_SOLUTION, [NaN, NaN]),
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[2, 1],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) => T[1],
        ),
    )
    return
end

"""
    test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper(
        model::MOI.ModelLike,
        config::Config,
    )

Test the Farkas dual of an interval constraint violated above.
"""
function test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_Interval_upper(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variables(model, 2)
    clb = MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[2, 1], x), T(0)),
        MOI.Interval(T(-2), T(-1)),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    @requires MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
    clb_dual = MOI.get.(model, MOI.ConstraintDual(), clb)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test clb_dual[1] > config.atol
    @test clb_dual[2] > config.atol
    @test c_dual[1] < -config.atol
    @test clb_dual ≈ [2, 1] .* -c_dual atol = config.atol rtol = config.rtol
    return
end

function setup_test(
    ::typeof(test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_Interval_upper),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            (MOI.NO_SOLUTION, [NaN, NaN]),
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[2, 1],
            (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) => T[-1],
        ),
    )
    return
end

"""
    test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper(
        model::MOI.ModelLike,
        config::Config,
    )

Test the Farkas dual of an interval constraint violated below.
"""
function test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_Interval_lower(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variables(model, 2)
    clb = MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[-2, -1], x), T(0)),
        MOI.Interval(T(1), T(2)),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    @requires MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
    clb_dual = MOI.get.(model, MOI.ConstraintDual(), clb)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test clb_dual[1] > config.atol
    @test clb_dual[2] > config.atol
    @test c_dual[1] > config.atol
    @test clb_dual ≈ [2, 1] .* c_dual atol = config.atol rtol = config.rtol
    return
end

function setup_test(
    ::typeof(test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_Interval_lower),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            (MOI.NO_SOLUTION, [NaN, NaN]),
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[2, 1],
            (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) => T[1],
        ),
    )
    return
end

"""
    test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper(
        model::MOI.ModelLike,
        config::Config,
    )

Test the Farkas dual of a variable upper bound violated above when minimizing.
"""
function test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_VariableIndex_LessThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variables(model, 2)
    clb = MOI.add_constraint.(model, x, MOI.LessThan(T(0)))
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[2, 1], x), T(0)),
        MOI.GreaterThan(T(1)),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    @requires MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
    clb_dual = MOI.get.(model, MOI.ConstraintDual(), clb)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test clb_dual[1] < -config.atol
    @test clb_dual[2] < -config.atol
    @test c_dual[1] > config.atol
    @test clb_dual ≈ [2, 1] .* -c_dual atol = config.atol rtol = config.rtol
    return
end

function setup_test(
    ::typeof(
        test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_VariableIndex_LessThan,
    ),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            (MOI.NO_SOLUTION, [NaN, NaN]),
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.VariableIndex, MOI.LessThan{T}) => T[-2, -1],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) => T[1],
        ),
    )
    return
end

"""
    test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_EqualTo_upper(
        model::MOI.ModelLike,
        config::Config,
    )

Test the Farkas dual of a variable upper bound violated above when maximizing.
"""
function test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_VariableIndex_LessThan_max(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    x = MOI.add_variables(model, 2)
    clb = MOI.add_constraint.(model, x, MOI.LessThan(T(0)))
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[2, 1], x), T(0)),
        MOI.GreaterThan(T(1)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x[1])
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    @requires MOI.get(model, MOI.DualStatus()) == MOI.INFEASIBILITY_CERTIFICATE
    clb_dual = MOI.get.(model, MOI.ConstraintDual(), clb)
    c_dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test clb_dual[1] < -config.atol
    @test clb_dual[2] < -config.atol
    @test c_dual[1] > config.atol
    @test clb_dual ≈ [2, 1] .* -c_dual atol = config.atol rtol = config.rtol
    return
end

function setup_test(
    ::typeof(
        test_solve_DualStatus_INFEASIBILITY_CERTIFICATE_VariableIndex_LessThan_max,
    ),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.INFEASIBLE,
            (MOI.NO_SOLUTION, [NaN, NaN]),
            MOI.INFEASIBILITY_CERTIFICATE,
            (MOI.VariableIndex, MOI.LessThan{T}) => T[-2, -1],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) => T[1],
        ),
    )
    return
end

"""
    test_solve_optimize_twice(
        model::MOI.ModelLike,
        config::Config,
    )

Test that calling `optimize!` twice in succession does not error.
"""
function test_solve_optimize_twice(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.optimize!(model)
    MOI.optimize!(model)
    MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    MOI.get(model, MOI.VariablePrimal(), x) == T(1)
    return
end

function setup_test(
    ::typeof(test_solve_optimize_twice),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
    )
    return
end

"""
    test_solve_conflict_bound_bound(model::MOI.ModelLike, config::Config{T}) where {T}

Test the ConflictStatus API when two variable bounds are in the conflict.
"""
function test_solve_conflict_bound_bound(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.compute_conflict!)
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    c1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(2)))
    c2 = MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    status = MOI.get(model, MOI.ConflictStatus())
    @test status == MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c1) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c2) == MOI.IN_CONFLICT
    return
end

function setup_test(
    ::typeof(test_solve_conflict_bound_bound),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock::MOIU.MockOptimizer -> begin
            MOIU.mock_optimize!(
                mock,
                MOI.INFEASIBLE,
                MOI.NO_SOLUTION,
                MOI.NO_SOLUTION;
                constraint_conflict_status = [
                    (MOI.VariableIndex, MOI.LessThan{T}) =>
                        [MOI.IN_CONFLICT],
                    (MOI.VariableIndex, MOI.GreaterThan{T}) =>
                        [MOI.IN_CONFLICT],
                ],
            )
            MOI.set(mock, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
        end,
    )
    return
end

"""
    test_solve_conflict_two_affine(model::MOI.ModelLike, config::Config{T}) where {T}

Test the ConflictStatus API when two affine constraints are in the conflict.
"""
function test_solve_conflict_two_affine(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.compute_conflict!)
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    c1 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x]), T(0)),
        MOI.GreaterThan(T(2)),
    )
    c2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x]), T(0)),
        MOI.LessThan(T(1)),
    )
    status = MOI.get(model, MOI.ConflictStatus())
    @test status == MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c1) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c2) == MOI.IN_CONFLICT
    return
end

function setup_test(
    ::typeof(test_solve_conflict_two_affine),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock::MOIU.MockOptimizer -> begin
            MOIU.mock_optimize!(
                mock,
                MOI.INFEASIBLE,
                MOI.NO_SOLUTION,
                MOI.NO_SOLUTION;
                constraint_conflict_status = [
                    (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) =>
                        [MOI.IN_CONFLICT],
                    (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                        [MOI.IN_CONFLICT],
                ],
            )
            MOI.set(mock, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
        end,
    )
    return
end

"""
    test_solve_conflict_invalid_interval(model::MOI.ModelLike, config::Config{T}) where {T}

Test the ConflictStatus API when an interval bound has upper < lower.
"""
function test_solve_conflict_invalid_interval(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.compute_conflict!)
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    c1 = MOI.add_constraint(model, x, MOI.Interval(T(1), T(0)))
    status = MOI.get(model, MOI.ConflictStatus())
    @test status == MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c1) == MOI.IN_CONFLICT
    return
end

function setup_test(
    ::typeof(test_solve_conflict_invalid_interval),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock::MOIU.MockOptimizer -> begin
            MOIU.mock_optimize!(
                mock,
                MOI.INFEASIBLE,
                MOI.NO_SOLUTION,
                MOI.NO_SOLUTION;
                constraint_conflict_status = [
                    (MOI.VariableIndex, MOI.Interval{T}) =>
                        [MOI.IN_CONFLICT],
                ],
            )
            MOI.set(mock, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
        end,
    )
    return
end

"""
    test_solve_conflict_affine_affine(model::MOI.ModelLike, config::Config{T}) where {T}

Test the ConflictStatus API when two constraints are in the conflict.
"""
function test_solve_conflict_affine_affine(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.compute_conflict!)
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    b1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    b2 = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    cf1 = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x, y]), T(0))
    c1 = MOI.add_constraint(model, cf1, MOI.LessThan(T(-1)))
    cf2 =
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[1, -1], [x, y]), T(0))
    c2 = MOI.add_constraint(model, cf2, MOI.GreaterThan(T(1)))
    status = MOI.get(model, MOI.ConflictStatus())
    @test status == MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    @test MOI.get(model, MOI.ConstraintConflictStatus(), b1) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), b2) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c1) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c2) ==
          MOI.NOT_IN_CONFLICT
    return
end

function setup_test(
    ::typeof(test_solve_conflict_affine_affine),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock::MOIU.MockOptimizer -> begin
            MOIU.mock_optimize!(
                mock,
                MOI.INFEASIBLE,
                MOI.NO_SOLUTION,
                MOI.NO_SOLUTION;
                constraint_conflict_status = [
                    (MOI.VariableIndex, MOI.GreaterThan{T}) =>
                        [MOI.IN_CONFLICT, MOI.IN_CONFLICT],
                    (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) =>
                        [MOI.IN_CONFLICT],
                    (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                        [MOI.NOT_IN_CONFLICT],
                ],
            )
            MOI.set(mock, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
        end,
    )
    return
end

"""
    test_solve_conflict_EqualTo(model::MOI.ModelLike, config::Config{T}) where {T}

Test the ConflictStatus API when some constraints are EqualTo.
"""
function test_solve_conflict_EqualTo(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.compute_conflict!)
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    b1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    b2 = MOI.add_constraint(model, y, MOI.GreaterThan(T(0)))
    cf1 = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x, y]), T(0))
    c1 = MOI.add_constraint(model, cf1, MOI.EqualTo(T(-1)))
    cf2 =
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[1, -1], [x, y]), T(0))
    c2 = MOI.add_constraint(model, cf2, MOI.GreaterThan(T(1)))
    status = MOI.get(model, MOI.ConflictStatus())
    @test status == MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    @test MOI.get(model, MOI.ConstraintConflictStatus(), b1) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), b2) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c1) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c2) ==
          MOI.NOT_IN_CONFLICT
    return
end

function setup_test(
    ::typeof(test_solve_conflict_EqualTo),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock::MOIU.MockOptimizer -> begin
            MOIU.mock_optimize!(
                mock,
                MOI.INFEASIBLE,
                MOI.NO_SOLUTION,
                MOI.NO_SOLUTION;
                constraint_conflict_status = [
                    (MOI.VariableIndex, MOI.GreaterThan{T}) =>
                        [MOI.IN_CONFLICT, MOI.IN_CONFLICT],
                    (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) =>
                        [MOI.IN_CONFLICT],
                    (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                        [MOI.NOT_IN_CONFLICT],
                ],
            )
            MOI.set(mock, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
        end,
    )
    return
end

"""
    test_solve_conflict_NOT_IN_CONFLICT(model::MOI.ModelLike, config::Config{T}) where {T}

Test the ConflictStatus API when some constraints are not in the conflict.
"""
function test_solve_conflict_NOT_IN_CONFLICT(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.compute_conflict!)
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    z = MOI.add_variable(model)
    S = MOI.GreaterThan(T(0))
    b1 = MOI.add_constraint(model, x, S)
    b2 = MOI.add_constraint(model, y, S)
    b3 = MOI.add_constraint(model, z, S)
    cf1 = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x, y]), T(0))
    c1 = MOI.add_constraint(model, cf1, MOI.LessThan(T(-1)))
    cf2 = MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.(T[1, -1, 1], [x, y, z]),
        T(0),
    )
    c2 = MOI.add_constraint(model, cf2, MOI.GreaterThan(T(1)))
    status = MOI.get(model, MOI.ConflictStatus())
    @test status == MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    @test MOI.get(model, MOI.ConstraintConflictStatus(), b1) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), b2) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), b3) ==
          MOI.NOT_IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c1) == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c2) ==
          MOI.NOT_IN_CONFLICT
    return
end

function setup_test(
    ::typeof(test_solve_conflict_NOT_IN_CONFLICT),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock::MOIU.MockOptimizer -> begin
            MOIU.mock_optimize!(
                mock,
                MOI.INFEASIBLE,
                MOI.NO_SOLUTION,
                MOI.NO_SOLUTION;
                constraint_conflict_status = [
                    (MOI.VariableIndex, MOI.GreaterThan{T}) => [
                        MOI.IN_CONFLICT,
                        MOI.IN_CONFLICT,
                        MOI.NOT_IN_CONFLICT,
                    ],
                    (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) =>
                        [MOI.IN_CONFLICT],
                    (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                        [MOI.NOT_IN_CONFLICT],
                ],
            )
            MOI.set(mock, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
        end,
    )
    return
end

"""
    test_solve_conflict_feasible(model::MOI.ModelLike, config::Config{T}) where {T}

Test the ConflictStatus API when the problem is feasible.
"""
function test_solve_conflict_feasible(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.compute_conflict!)
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    _ = MOI.add_constraint(model, f, MOI.GreaterThan(T(1)))
    _ = MOI.add_constraint(model, f, MOI.LessThan(T(2)))
    status = MOI.get(model, MOI.ConflictStatus())
    @test status == MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.NO_CONFLICT_EXISTS
    return
end

function setup_test(
    ::typeof(test_solve_conflict_feasible),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock::MOIU.MockOptimizer -> begin
            MOIU.mock_optimize!(
                mock,
                MOI.OPTIMAL,
                MOI.NO_SOLUTION,
                MOI.NO_SOLUTION,
            )
            MOI.set(mock, MOI.ConflictStatus(), MOI.NO_CONFLICT_EXISTS)
        end,
    )
    return
end

"""
    test_solve_conflict_zeroone(model::MOI.ModelLike, config::Config{T}) where {T}

Test the ConflictStatus API when an integrality is in the conflict.
"""
function test_solve_conflict_zeroone(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.compute_conflict!)
    @requires _supports(config, MOI.optimize!)
    x, c1 = MOI.add_constrained_variable(model, MOI.ZeroOne())
    c2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x]), T(0)),
        MOI.GreaterThan(T(2)),
    )
    status = MOI.get(model, MOI.ConflictStatus())
    @test status == MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    zeroone_conflict = MOI.get(model, MOI.ConstraintConflictStatus(), c1)
    @test zeroone_conflict == MOI.MAYBE_IN_CONFLICT ||
          zeroone_conflict == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c2) == MOI.IN_CONFLICT
    return
end

function setup_test(
    ::typeof(test_solve_conflict_zeroone),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock::MOIU.MockOptimizer -> begin
            MOIU.mock_optimize!(
                mock,
                MOI.INFEASIBLE,
                MOI.NO_SOLUTION,
                MOI.NO_SOLUTION;
                constraint_conflict_status = [
                    (MOI.VariableIndex, MOI.ZeroOne) =>
                        [MOI.MAYBE_IN_CONFLICT],
                    (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                        [MOI.IN_CONFLICT],
                ],
            )
            MOI.set(mock, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
        end,
    )
    return
end

"""
    test_solve_conflict_zeroone_2(model::MOI.ModelLike, config::Config{T}) where {T}

Test the ConflictStatus API when an integrality is in the conflict.
In this test, integrality is the conflict and no the upper bound == 1.
"""
function test_solve_conflict_zeroone_2(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires (T(1) / T(2)) isa T
    @requires _supports(config, MOI.compute_conflict!)
    @requires _supports(config, MOI.optimize!)
    x, c1 = MOI.add_constrained_variable(model, MOI.ZeroOne())
    c2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x]), T(0)),
        MOI.EqualTo(T(1) / T(2)),
    )
    status = MOI.get(model, MOI.ConflictStatus())
    @test status == MOI.COMPUTE_CONFLICT_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    MOI.compute_conflict!(model)
    @test MOI.get(model, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
    zeroone_conflict = MOI.get(model, MOI.ConstraintConflictStatus(), c1)
    @test zeroone_conflict == MOI.MAYBE_IN_CONFLICT ||
          zeroone_conflict == MOI.IN_CONFLICT
    @test MOI.get(model, MOI.ConstraintConflictStatus(), c2) == MOI.IN_CONFLICT
    return
end

version_added(::typeof(test_solve_conflict_zeroone_2)) = v"0.10.6"

function setup_test(
    ::typeof(test_solve_conflict_zeroone_2),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock::MOIU.MockOptimizer -> begin
            MOIU.mock_optimize!(
                mock,
                MOI.INFEASIBLE,
                MOI.NO_SOLUTION,
                MOI.NO_SOLUTION;
                constraint_conflict_status = [
                    (MOI.VariableIndex, MOI.ZeroOne) => [MOI.IN_CONFLICT],
                    (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) =>
                        [MOI.IN_CONFLICT],
                ],
            )
            MOI.set(mock, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
        end,
    )
    return
end

function test_solve_SOS2_add_and_delete(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports_constraint(model, MOI.VectorOfVariables, MOI.SOS2{T})
    function _add_SOS2(model, x, y, xp, yp)
        λ = MOI.add_variables(model, length(xp))
        # 0 <= λ <= 1
        MOI.add_constraint.(model, λ, MOI.LessThan(T(1)))
        MOI.add_constraint.(model, λ, MOI.GreaterThan(T(0)))
        # Σλᵢ == 1
        MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), λ), T(0)),
            MOI.EqualTo(T(1)),
        )
        # Σλᵢxᵢ - x == 0
        MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction(
                MOI.ScalarAffineTerm.([xp; T(-1)], [λ; x]),
                T(0),
            ),
            MOI.EqualTo(T(0)),
        )
        # Σλᵢyᵢ - y  == 0
        MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction(
                MOI.ScalarAffineTerm.([yp; T(-1)], [λ; y]),
                T(0),
            ),
            MOI.EqualTo(T(0)),
        )
        # λ ∈ SOS2()
        c = MOI.add_constraint(
            model,
            MOI.VectorOfVariables(λ),
            MOI.SOS2{T}(collect(T(1):length(xp))),
        )
        return λ, c
    end
    x = MOI.add_variables(model, 2)
    y = MOI.add_variables(model, 2)
    # !!! warning
    #     Make sure the variable returned from `_add_SOS2` is named something
    #     other than λ to avoid Julia's `Box`ing issue with closed over
    #     variables.
    vλ, c1 = _add_SOS2(model, x[1], y[1], T[1, 2, 3], T[2, 2, 1])
    MOI.add_constraint(model, x[1], MOI.LessThan(T(5 // 2)))
    vη, c2 = _add_SOS2(model, x[2], y[2], T[1, 2, 3, 4], T[1//2, 1, 1//5, 2])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), y), T(0))
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    attr = MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.SOS2{T}}()
    @test MOI.get(model, attr) == 2
    MOI.optimize!(model)
    #  x[1] == 2.5
    #  y[1] == 1.5
    #  x[2] == 3.0
    #  y[2] == 0.2
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x[1]), T(5 // 2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x[2]), T(3), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y[1]), T(3 // 2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y[2]), T(1 // 5), config)
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(17 // 10), config)
    MOI.delete(model, c1)
    MOI.delete(model, c2)
    @test MOI.get(model, attr) == 0
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x[1]), T(5 // 2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x[2]), T(3), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y[1]), T(5 // 4), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y[2]), T(1 // 5), config)
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(29 // 20), config)
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(vλ),
        MOI.SOS2{T}(T[1, 2, 3]),
    )
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(vη),
        MOI.SOS2{T}(T[1, 2, 3, 4]),
    )
    @test MOI.get(model, attr) == 2
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x[1]), T(5 // 2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x[2]), T(3), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y[1]), T(3 // 2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y[2]), T(1 // 5), config)
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(17 // 10), config)
    return
end

function setup_test(
    ::typeof(test_solve_SOS2_add_and_delete),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            T[5//2, 3, 3//2, 1//5, 0, 1//2, 1//2, 0, 0, 1, 0],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            T[5//2, 3, 5//4, 1//5, 1//4, 0, 3//4, 0, 0, 1, 0],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            T[5//2, 3, 3//2, 1//5, 0, 1//2, 1//2, 0, 0, 1, 0],
        ),
    )
    return
end

function _test_matrix_norm_cone(
    model::MOI.ModelLike,
    config::Config{T},
    set::Union{MOI.NormSpectralCone,MOI.NormNuclearCone},
    b::Union{Nothing,Vector{T}},
) where {T}
    @requires _supports(config, MOI.optimize!)
    F = b == nothing ? MOI.VectorOfVariables : MOI.VectorAffineFunction{T}
    @requires MOI.supports_constraint(model, F, typeof(set))
    t = MOI.add_variable(model)
    X = MOI.add_variables(model, 6)
    f = if b === nothing
        MOI.VectorOfVariables([t; X])
    else
        fx = MOI.Utilities.operate.(+, T, X, b)
        MOI.Utilities.operate(vcat, T, t, fx...)
    end
    MOI.add_constraint(model, f, set)
    for i in 1:6
        MOI.add_constraint(model, X[i], MOI.EqualTo{T}(i))
    end
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), t)
    MOI.optimize!(model)
    x_result = MOI.get(model, MOI.VariablePrimal(), X)
    @test ≈(x_result, 1:6, config)
    Y = reshape(x_result .+ something(b, T(0)), set.row_dim, set.column_dim)
    # svdvals doesn't work for BigFloat etc. So don't use `T` as the element
    # type when computing the singular values.
    σ = LinearAlgebra.svdvals(convert(Matrix{Float64}, Y))
    result = set isa MOI.NormSpectralCone ? maximum(σ) : sum(σ)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), t), result, config)
    return
end

function test_NormSpectralCone_VectorOfVariables_without_transform(
    model::MOI.ModelLike,
    config::Config,
)
    _test_matrix_norm_cone(model, config, MOI.NormSpectralCone(3, 2), nothing)
    return
end

function setup_test(
    ::typeof(test_NormSpectralCone_VectorOfVariables_without_transform),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    # svdvals doesn't work for BigFloat etc. So don't use `T` as the element
    # type when computing the result.
    result = [1, 2, 3, 4, 5, 6]
    t = LinearAlgebra.opnorm(reshape(result, 3, 2))
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, T[t; result]),
    )
    return
end

function version_added(
    ::typeof(test_NormSpectralCone_VectorOfVariables_without_transform),
)
    return v"1.17.0"
end

function test_NormSpectralCone_VectorOfVariables_with_transform(
    model::MOI.ModelLike,
    config::Config,
)
    _test_matrix_norm_cone(model, config, MOI.NormSpectralCone(2, 3), nothing)
    return
end

function setup_test(
    ::typeof(test_NormSpectralCone_VectorOfVariables_with_transform),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    # svdvals doesn't work for BigFloat etc. So don't use `T` as the element
    # type when computing the result.
    result = [1, 2, 3, 4, 5, 6]
    t = LinearAlgebra.opnorm(reshape(result, 2, 3))
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, T[t; result]),
    )
    return
end

function version_added(
    ::typeof(test_NormSpectralCone_VectorOfVariables_with_transform),
)
    return v"1.17.0"
end

function test_NormSpectralCone_VectorAffineFunction_without_transform(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    b = convert(Vector{T}, 7:12)
    _test_matrix_norm_cone(model, config, MOI.NormSpectralCone(3, 2), b)
    return
end

function setup_test(
    ::typeof(test_NormSpectralCone_VectorAffineFunction_without_transform),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    # svdvals doesn't work for BigFloat etc. So don't use `T` as the element
    # type when computing the result.
    result = [1, 2, 3, 4, 5, 6]
    t = LinearAlgebra.opnorm(reshape(result + collect(7:12), 3, 2))
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, T[t; result]),
    )
    return
end

function version_added(
    ::typeof(test_NormSpectralCone_VectorAffineFunction_without_transform),
)
    return v"1.17.0"
end

function test_NormSpectralCone_VectorAffineFunction_with_transform(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    b = convert(Vector{T}, 7:12)
    _test_matrix_norm_cone(model, config, MOI.NormSpectralCone(2, 3), b)
    return
end

function setup_test(
    ::typeof(test_NormSpectralCone_VectorAffineFunction_with_transform),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    # svdvals doesn't work for BigFloat etc. So don't use `T` as the element
    # type when computing the result.
    result = [1, 2, 3, 4, 5, 6]
    t = LinearAlgebra.opnorm(reshape(result + collect(7:12), 2, 3))
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, T[t; result]),
    )
    return
end

function version_added(
    ::typeof(test_NormSpectralCone_VectorAffineFunction_with_transform),
)
    return v"1.17.0"
end

function test_NormNuclearCone_VectorOfVariables_without_transform(
    model::MOI.ModelLike,
    config::Config,
)
    _test_matrix_norm_cone(model, config, MOI.NormNuclearCone(3, 2), nothing)
    return
end

function setup_test(
    ::typeof(test_NormNuclearCone_VectorOfVariables_without_transform),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    # svdvals doesn't work for BigFloat etc. So don't use `T` as the element
    # type when computing the result.
    result = [1, 2, 3, 4, 5, 6]
    t = sum(LinearAlgebra.svdvals(reshape(result, 3, 2)))
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, T[t; result]),
    )
    return
end

function version_added(
    ::typeof(test_NormNuclearCone_VectorOfVariables_without_transform),
)
    return v"1.17.0"
end

function test_NormNuclearCone_VectorOfVariables_with_transform(
    model::MOI.ModelLike,
    config::Config,
)
    _test_matrix_norm_cone(model, config, MOI.NormNuclearCone(2, 3), nothing)
    return
end

function setup_test(
    ::typeof(test_NormNuclearCone_VectorOfVariables_with_transform),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    # svdvals doesn't work for BigFloat etc. So don't use `T` as the element
    # type when computing the result.
    result = [1, 2, 3, 4, 5, 6]
    t = sum(LinearAlgebra.svdvals(reshape(result, 2, 3)))
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, T[t; result]),
    )
    return
end

function version_added(
    ::typeof(test_NormNuclearCone_VectorOfVariables_with_transform),
)
    return v"1.17.0"
end

function test_NormNuclearCone_VectorAffineFunction_without_transform(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    b = convert(Vector{T}, 7:12)
    _test_matrix_norm_cone(model, config, MOI.NormNuclearCone(3, 2), b)
    return
end

function setup_test(
    ::typeof(test_NormNuclearCone_VectorAffineFunction_without_transform),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    # svdvals doesn't work for BigFloat etc. So don't use `T` as the element
    # type when computing the result.
    result = [1, 2, 3, 4, 5, 6]
    t = sum(LinearAlgebra.svdvals(reshape(result + collect(7:12), 3, 2)))
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, T[t; result]),
    )
    return
end

function version_added(
    ::typeof(test_NormNuclearCone_VectorAffineFunction_without_transform),
)
    return v"1.17.0"
end

function test_NormNuclearCone_VectorAffineFunction_with_transform(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    b = convert(Vector{T}, 7:12)
    _test_matrix_norm_cone(model, config, MOI.NormNuclearCone(2, 3), b)
    return
end

function setup_test(
    ::typeof(test_NormNuclearCone_VectorAffineFunction_with_transform),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    # svdvals doesn't work for BigFloat etc. So don't use `T` as the element
    # type when computing the result.
    result = [1, 2, 3, 4, 5, 6]
    t = sum(LinearAlgebra.svdvals(reshape(result + collect(7:12), 2, 3)))
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, T[t; result]),
    )
    return
end

function version_added(
    ::typeof(test_NormNuclearCone_VectorAffineFunction_with_transform),
)
    return v"1.17.0"
end

function test_HermitianPSDCone_basic(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    S = MOI.HermitianPositiveSemidefiniteConeTriangle
    @requires MOI.supports_constraint(model, MOI.VectorAffineFunction{T}, S)
    x = MOI.add_variables(model, 9)
    for i in eachindex(x)
        MOI.add_constraint(model, x[i], MOI.EqualTo{T}(i))
    end
    b = T[12, 0, 12, 0, 0, 12, 0, 0, 0]
    f = MOI.Utilities.operate(vcat, T, MOI.Utilities.operate.(+, T, x, b)...)
    set = MOI.HermitianPositiveSemidefiniteConeTriangle(3)
    MOI.add_constraint(model, f, set)
    MOI.optimize!(model)
    MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), 1:9, config)
    return
end

function setup_test(
    ::typeof(test_HermitianPSDCone_basic),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            T[1, 2, 3, 4, 5, 6, 7, 8, 9],
        ),
    )
    return
end

version_added(::typeof(test_HermitianPSDCone_basic)) = v"1.17.0"

function test_HermitianPSDCone_min_t(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    S = MOI.HermitianPositiveSemidefiniteConeTriangle
    @requires MOI.supports_constraint(model, MOI.VectorAffineFunction{T}, S)
    t = MOI.add_variable(model)
    x = MOI.add_variables(model, 9)
    for (i, xi) in enumerate(x)
        MOI.add_constraint(model, xi, MOI.EqualTo{T}(i))
    end
    bt = Union{MOI.VariableIndex,T}[t, T(0), t, T(0), T(0), t, T(0), T(0), T(0)]
    f = MOI.Utilities.operate(vcat, T, MOI.Utilities.operate.(+, T, x, bt)...)
    set = MOI.HermitianPositiveSemidefiniteConeTriangle(3)
    MOI.add_constraint(model, f, set)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), t)
    MOI.optimize!(model)
    MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    x_result = MOI.get(model, MOI.VariablePrimal(), x)
    @test ≈(x_result, 1:9, config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), t), 11.034899152582094, config)
    return
end

function setup_test(
    ::typeof(test_HermitianPSDCone_min_t),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    x = T[11.034899152582094, 1, 2, 3, 4, 5, 6, 7, 8, 9]
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, MOI.OPTIMAL, x),
    )
    return
end

version_added(::typeof(test_HermitianPSDCone_min_t)) = v"1.17.0"

function test_DualObjectiveValue_Min_VariableIndex_GreaterThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.DualObjectiveValue)
    x, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(T(2)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = T(3) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(6), config)
    return
end

function setup_test(
    ::typeof(test_DualObjectiveValue_Min_VariableIndex_GreaterThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2]),
            MOI.FEASIBLE_POINT,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[3],
        ),
    )
    return
end

function version_added(
    ::typeof(test_DualObjectiveValue_Min_VariableIndex_GreaterThan),
)
    return v"1.35.0"
end

function test_DualObjectiveValue_Max_VariableIndex_LessThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.DualObjectiveValue)
    x, _ = MOI.add_constrained_variable(model, MOI.LessThan(T(2)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(3) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(6), config)
    return
end

function setup_test(
    ::typeof(test_DualObjectiveValue_Max_VariableIndex_LessThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2]),
            MOI.FEASIBLE_POINT,
            (MOI.VariableIndex, MOI.LessThan{T}) => T[-3],
        ),
    )
    return
end

function version_added(
    ::typeof(test_DualObjectiveValue_Max_VariableIndex_LessThan),
)
    return v"1.35.0"
end

function test_DualObjectiveValue_Min_ScalarAffine_GreaterThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.DualObjectiveValue)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, one(T) * x, MOI.GreaterThan(T(2)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = T(3) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(6), config)
    return
end

function setup_test(
    ::typeof(test_DualObjectiveValue_Min_ScalarAffine_GreaterThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) => T[3],
        ),
    )
    return
end

function version_added(
    ::typeof(test_DualObjectiveValue_Min_ScalarAffine_GreaterThan),
)
    return v"1.35.0"
end

function test_DualObjectiveValue_Max_ScalarAffine_LessThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.DualObjectiveValue)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, one(T) * x, MOI.LessThan(T(2)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(3) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    @test ≈(MOI.get(model, MOI.DualObjectiveValue()), T(6), config)
    return
end

function setup_test(
    ::typeof(test_DualObjectiveValue_Max_ScalarAffine_LessThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        mock -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-3],
        ),
    )
    return
end

function version_added(
    ::typeof(test_DualObjectiveValue_Max_ScalarAffine_LessThan),
)
    return v"1.35.0"
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

abstract type AbstractDummyModel <: MOI.ModelLike end

function MOI.empty!(::AbstractDummyModel) end

function MOI.copy_to(dest::AbstractDummyModel, src::MOI.ModelLike)
    return MOIU.default_copy_to(dest, src)
end

MOI.supports_incremental_interface(::AbstractDummyModel) = true

MOI.supports(::AbstractDummyModel, ::MOI.ObjectiveSense) = true

function MOI.supports(
    ::AbstractDummyModel,
    ::MOI.ConstraintPrimalStart,
    ::Type{<:MOI.ConstraintIndex},
)
    return true
end

function MOI.supports_constraint(
    ::AbstractDummyModel,
    ::Type{MOI.VariableIndex},
    ::Type{MOI.EqualTo{Float64}},
)
    return true
end

function MOI.supports_constraint(
    ::AbstractDummyModel,
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.Zeros},
)
    return true
end

struct DummyModel <: AbstractDummyModel end

# Implements add_variable and add_constraint
struct DummyModelWithAdd <: AbstractDummyModel end
MOI.add_variable(::DummyModelWithAdd) = MOI.VariableIndex(0)
MOI.add_variables(::DummyModelWithAdd, n) = fill(MOI.VariableIndex(0), n)
function MOI.add_constraint(
    ::DummyModelWithAdd,
    ::MOI.VariableIndex,
    ::MOI.EqualTo{Float64},
)
    return MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}(0)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    Map <: AbstractDict{MOI.VariableIndex,AbstractBridge}

Mapping between bridged constraints and the bridge that bridged the constraint.
"""
struct Map <: AbstractDict{MOI.ConstraintIndex,AbstractBridge}
    # Constraint Index of bridged constraint -> Bridge.
    # It is set to `nothing` when the constraint is deleted.
    bridges::Vector{Union{Nothing,AbstractBridge}}
    # Constraint Index of bridged constraint -> Constraint type.
    constraint_types::Vector{Tuple{Type,Type}}
    # The order of the keys is used in `keys_of_type` which is used by
    # `ListOfConstraintIndices`. Therefore they need to be in the order
    # of creation so we need `OrderedDict` and not `Dict`.
    # For `VariableIndex` constraints: (variable, set type) -> bridge
    single_variable_constraints::OrderedDict{Tuple{Int64,Type},AbstractBridge}
    needs_final_touch::OrderedDict{Type,OrderedSet}

    function Map()
        return new(
            Union{Nothing,AbstractBridge}[],
            Tuple{Type,Type}[],
            OrderedDict{Tuple{Int64,Type},AbstractBridge}(),
            OrderedDict{Type,OrderedSet}(),
        )
    end
end

# Implementation of `AbstractDict` interface.

function Base.isempty(map::Map)
    return all(bridge -> bridge === nothing, map.bridges) &&
           isempty(map.single_variable_constraints)
end

function Base.empty!(map::Map)
    empty!(map.bridges)
    empty!(map.constraint_types)
    empty!(map.single_variable_constraints)
    empty!(map.needs_final_touch)
    return map
end

function Base.length(map::Map)
    return count(bridge -> bridge !== nothing, map.bridges) +
           length(map.single_variable_constraints)
end

_index(ci::MOI.ConstraintIndex) = ci.value

_index(ci::MOI.ConstraintIndex{MOI.VectorOfVariables}) = -ci.value

function Base.haskey(map::Map, ci::MOI.ConstraintIndex{F,S}) where {F,S}
    return 1 <= _index(ci) <= length(map.bridges) &&
           map.bridges[_index(ci)] !== nothing &&
           (F, S) == map.constraint_types[_index(ci)]
end

Base.getindex(map::Map, ci::MOI.ConstraintIndex) = map.bridges[_index(ci)]

function Base.haskey(
    map::Map,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S}
    return haskey(map.single_variable_constraints, (ci.value, S))
end

function Base.getindex(
    map::Map,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S}
    return map.single_variable_constraints[(ci.value, S)]
end

function Base.delete!(map::Map, ci::MOI.ConstraintIndex)
    _unregister_for_final_touch(map, map.bridges[_index(ci)]::AbstractBridge)
    map.bridges[_index(ci)] = nothing
    return map
end

function Base.delete!(
    map::Map,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S}
    bridge = map.single_variable_constraints[(ci.value, S)]
    _unregister_for_final_touch(map, bridge)
    delete!(map.single_variable_constraints, (ci.value, S))
    return map
end

function Base.values(map::Map)
    return Base.Iterators.flatten((
        # See comment in `values(::Variable.Map)`.
        Base.Iterators.Filter(bridge -> bridge !== nothing, map.bridges),
        values(map.single_variable_constraints),
    ))
end

# Implementation of iterate: it should combine non-`VariableIndex` constraints
# and `VariableIndex` constraints.
function _iterate_sv(
    map::Map,
    elem_state = iterate(map.single_variable_constraints),
)
    if elem_state === nothing
        return nothing
    end
    (i, S), bridge = elem_state[1]
    ci = MOI.ConstraintIndex{MOI.VariableIndex,S}(i)
    return ci => bridge, (2, elem_state[2])
end

_index(index, F, S) = MOI.ConstraintIndex{F,S}(index)

function _index(index, F::Type{MOI.VectorOfVariables}, S)
    return MOI.ConstraintIndex{F,S}(-index)
end

function _iterate(map::Map, state = 1)
    while state ≤ length(map.bridges) && map.bridges[state] === nothing
        state += 1
    end
    if state > length(map.bridges)
        return _iterate_sv(map)
    end
    F, S = map.constraint_types[state]
    return _index(state, F, S) => map.bridges[state], (1, state + 1)
end

Base.iterate(map::Map) = _iterate(map)

function Base.iterate(map::Map, state)
    if state[1] == 1
        return _iterate(map, state[2])
    end
    return _iterate_sv(map, iterate(map.single_variable_constraints, state[2]))
end

# Custom interface for information needed by `AbstractBridgeOptimizer`s that is
# not part of the `AbstractDict` interface.

"""
    number_of_type(map::Map, C::Type{<:MOI.ConstraintIndex})

Return the number of keys of type `C` in `map`.
"""
function number_of_type(map::Map, ::Type{MOI.ConstraintIndex{F,S}}) where {F,S}
    return count(i -> haskey(map, _index(i, F, S)), eachindex(map.bridges))
end

function number_of_type(
    map::Map,
    ::Type{MOI.ConstraintIndex{MOI.VariableIndex,S}},
) where {S}
    ret = 0
    for (_, key) in keys(map.single_variable_constraints)
        ret += Int(key == S)
    end
    return ret
end

"""
    keys_of_type(map::Map, C::Type{<:MOI.ConstraintIndex})

Return a list of all the keys of type `C` in `map` in order in which they
were created with `add_key_for_bridge`.
"""
function keys_of_type(map::Map, C::Type{MOI.ConstraintIndex{F,S}}) where {F,S}
    return Base.Iterators.Filter(
        ci -> haskey(map, ci),
        MOI.Utilities.lazy_map(C, i -> _index(i, F, S), eachindex(map.bridges)),
    )
end

function keys_of_type(
    map::Map,
    C::Type{MOI.ConstraintIndex{MOI.VariableIndex,S}},
) where {S}
    return MOI.Utilities.lazy_map(
        C,
        key -> C(key[1]),
        Base.Iterators.Filter(
            key -> key[2] == S,
            keys(map.single_variable_constraints),
        ),
    )
end

"""
    list_of_key_types(map::Map)

Return a list of all the different concrete type of keys in `map`.
"""
function list_of_key_types(map::Map)
    list = Set{Tuple{Type,Type}}()
    for i in eachindex(map.bridges)
        if map.bridges[i] !== nothing
            push!(list, map.constraint_types[i])
        end
    end
    for (_, key) in keys(map.single_variable_constraints)
        push!(list, (MOI.VariableIndex, key))
    end
    return list
end

"""
    variable_constraints(map::Map, vi::MOI.VariableIndex)

Return the list of all keys corresponding to [`MOI.VariableIndex`](@ref)
constraints on the variable `vi`.
"""
function variable_constraints(map::Map, vi::MOI.VariableIndex)
    cis = MOI.ConstraintIndex{MOI.VariableIndex}[]
    for key in keys(map.single_variable_constraints)
        if key[1] == vi.value
            push!(cis, MOI.ConstraintIndex{MOI.VariableIndex,key[2]}(vi.value))
        end
    end
    return cis
end

"""
    vector_of_variables_constraints(map::Map)

Return the list of all keys that correspond to
[`MOI.VectorOfVariables`](@ref) constraints.
"""
function vector_of_variables_constraints(map::Map)
    return MOI.Utilities.lazy_map(
        MOI.ConstraintIndex{MOI.VectorOfVariables},
        i -> MOI.ConstraintIndex{map.constraint_types[i]...}(-i),
        Base.Iterators.Filter(
            i ->
                map.bridges[i] !== nothing &&
                map.constraint_types[i][1] == MOI.VectorOfVariables,
            eachindex(map.bridges),
        ),
    )
end

"""
    has_bridges(map::Map)::Bool

Return a `Bool` indicating whether any bridge was added yet.

Note that it returns `false` even if all bridges were deleted while `isempty`
would return `true`.

It is computed in `O(1)` while `isempty` needs `O(n)` hence it is used by
[`MOI.Bridges.AbstractBridgeOptimizer`](@ref) to shortcut operations in case
variable bridges are not used.
"""
function has_bridges(map::Map)
    return !isempty(map.bridges) || !isempty(map.single_variable_constraints)
end

"""
    add_key_for_bridge(
        map::Map,
        bridge::AbstractBridge,
        func::MOI.AbstractFunction,
        set::MOI.AbstractSet,
        is_available::Function,
    )

Return a new constraint index `ci` and store the mapping `ci => bridge`.
If `func isa MOI.VectorOfVariables` then `ci` is such that `is_available(ci)`,
otherwise, `is_available` is ignored because there can only be a clash of
indices between variable and constraint bridge mapping for `MOI.VectorOfVariables`.
"""
function add_key_for_bridge end

_ensure_available(::Map, ::Type, ::Type, ::Function) = nothing
function _ensure_available(
    map::Map,
    F::Type{MOI.VectorOfVariables},
    ::Type{S},
    is_available::Function,
) where {S}
    while !is_available(MOI.ConstraintIndex{F,S}(-length(map.bridges) - 1))
        push!(map.bridges, nothing)
        push!(map.constraint_types, (F, S))
    end
    return
end

function add_key_for_bridge(
    map::Map,
    bridge::AbstractBridge,
    ::F,
    ::S,
    is_available::Function,
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    _register_for_final_touch(map, bridge)
    _ensure_available(map, F, S, is_available)
    push!(map.bridges, bridge)
    push!(map.constraint_types, (F, S))
    return _index(length(map.bridges), F, S)
end

function add_key_for_bridge(
    map::Map,
    bridge::AbstractBridge,
    func::MOI.VariableIndex,
    ::S,
    ::Function,
) where {S<:MOI.AbstractScalarSet}
    _register_for_final_touch(map, bridge)
    map.single_variable_constraints[(func.value, S)] = bridge
    return MOI.ConstraintIndex{MOI.VariableIndex,S}(func.value)
end

function _register_for_final_touch(map::Map, bridge::BT) where {BT}
    if MOI.Bridges.needs_final_touch(bridge)
        if !haskey(map.needs_final_touch, BT)
            map.needs_final_touch[BT] = OrderedSet{BT}()
        end
        push!(map.needs_final_touch[BT], bridge)
    end
    return
end

function _unregister_for_final_touch(b::Map, bridge::BT) where {BT}
    if MOI.Bridges.needs_final_touch(bridge)
        delete!(b.needs_final_touch[BT], bridge)
    end
    return
end

# Function barrier to iterate over bridges of the same type in an efficient way.
function _final_touch(bridges, model)
    for bridge in bridges
        MOI.Bridges.final_touch(bridge, model)
    end
    return
end

function MOI.Bridges.final_touch(map::Map, model::MOI.ModelLike)
    for bridges in values(map.needs_final_touch)
        _final_touch(bridges, model)
    end
    return
end

"""
    EmptyMap <: AbstractDict{MOI.ConstraintIndex, AbstractBridge}

Empty version of [`Map`](@ref). It is used by
[`MOI.Bridges.Variable.SingleBridgeOptimizer`](@ref) as it does
not bridge any constraint.
"""
struct EmptyMap <: AbstractDict{MOI.VariableIndex,AbstractBridge} end

Base.show(::IO, ::EmptyMap) = nothing

Base.isempty(::EmptyMap) = true

Base.empty!(::EmptyMap) = nothing

Base.keys(::EmptyMap) = MOI.Utilities.EmptyVector{MOI.VariableIndex}()

Base.values(::EmptyMap) = MOI.Utilities.EmptyVector{AbstractBridge}()

has_bridges(::EmptyMap) = false

number_of_type(::EmptyMap, ::Type{<:MOI.ConstraintIndex}) = 0

MOI.Bridges.final_touch(::EmptyMap, ::MOI.ModelLike) = nothing

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintCountAtLeast

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CountAtLeastToCountBelongsBridge,
        """
        variables: a, b, c
        [a, b, b, c] in CountAtLeast(1, [2, 2], Set([3]))
        a in Interval(1.0, 3.0)
        b in Interval(1.0, 3.0)
        c >= 1.0
        c <= 3.0
        """,
        """
        variables: a, b, c, y1, y2
        [y1, a, b] in CountBelongs(3, Set([3]))
        [y2, b, c] in CountBelongs(3, Set([3]))
        y1 >= 1.0
        y2 >= 1.0
        a in Interval(1.0, 3.0)
        b in Interval(1.0, 3.0)
        c >= 1.0
        c <= 3.0
        """,
    )
    return
end

function test_runtests_VectorAffineFunction()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CountAtLeastToCountBelongsBridge,
        """
        variables: a, b, c
        [1.0 * a, b + 1.0, b, c] in CountAtLeast(1, [2, 2], Set([3]))
        a in Interval(1.0, 3.0)
        b in Interval(1.0, 3.0)
        c in Interval(1.0, 3.0)
        """,
        """
        variables: a, b, c, y1, y2
        [y1, 1.0 * a, b + 1.0] in CountBelongs(3, Set([3]))
        [y2, 1.0 * b, 1.0 * c] in CountBelongs(3, Set([3]))
        y1 >= 1.0
        y2 >= 1.0
        a in Interval(1.0, 3.0)
        b in Interval(1.0, 3.0)
        c in Interval(1.0, 3.0)
        """,
    )
    return
end

end  # module

TestConstraintCountAtLeast.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SemiToBinaryBridge{T,S} <: Bridges.Constraint.AbstractBridge

`SemiToBinaryBridge` implements the following reformulations:

  * ``x \\in \\{0\\} \\cup [l, u]`` into
    ```math
    \\begin{aligned}
    x \\leq z u \\\\
    x \\geq z l \\\\
    z \\in \\{0, 1\\}
    \\end{aligned}
    ```
  * ``x \\in \\{0\\} \\cup \\{l, \\ldots, u\\}`` into
    ```math
    \\begin{aligned}
    x \\leq z u \\\\
    x \\geq z l \\\\
    z \\in \\{0, 1\\} \\\\
    x \\in \\mathbb{Z}
    \\end{aligned}
    ```

## Source node

`SemiToBinaryBridge` supports:

  * [`MOI.VariableIndex`](@ref) in [`MOI.Semicontinuous{T}`](@ref)
  * [`MOI.VariableIndex`](@ref) in [`MOI.Semiinteger{T}`](@ref)

## Target nodes

`SemiToBinaryBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.LessThan{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.GreaterThan{T}`](@ref)
  * [`MOI.VariableIndex{T}`](@ref) in [`MOI.Integer`](@ref) (if `S` is
    [`MOI.Semiinteger{T}`](@ref)
"""
mutable struct SemiToBinaryBridge{
    T,
    S<:Union{MOI.Semicontinuous{T},MOI.Semiinteger{T}},
} <: AbstractBridge
    semi_set::S
    variable::MOI.VariableIndex
    binary_variable::MOI.VariableIndex
    binary_constraint_index::MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}
    lower_bound_index::MOI.ConstraintIndex{
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    }
    upper_bound_index::MOI.ConstraintIndex{
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    }
    integer_index::Union{
        Nothing,
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer},
    }
end

const SemiToBinary{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SemiToBinaryBridge{T},OT}

function bridge_constraint(
    ::Type{SemiToBinaryBridge{T,S}},
    model::MOI.ModelLike,
    f::MOI.VariableIndex,
    s::S,
) where {T<:Real,S<:Union{MOI.Semicontinuous{T},MOI.Semiinteger{T}}}
    binary, binary_con = MOI.add_constrained_variable(model, MOI.ZeroOne())
    # var - LB * bin >= 0
    lb = MOI.Utilities.operate(*, T, -s.lower, binary)
    lb = MOI.Utilities.operate!(+, T, lb, f)
    lb_ci = MOI.add_constraint(model, lb, MOI.GreaterThan{T}(zero(T)))
    # var - UB * bin <= 0
    ub = MOI.Utilities.operate(*, T, -s.upper, binary)
    ub = MOI.Utilities.operate!(+, T, ub, f)
    ub_ci = MOI.add_constraint(model, ub, MOI.LessThan{T}(zero(T)))
    if s isa MOI.Semiinteger{T}
        int_ci = MOI.add_constraint(model, f, MOI.Integer())
    else
        int_ci = nothing
    end
    return SemiToBinaryBridge{T,S}(
        s,
        f,
        binary,
        binary_con,
        lb_ci,
        ub_ci,
        int_ci,
    )
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:SemiToBinaryBridge{T,S}},
) where {T,S}
    return Tuple{Type}[(MOI.ZeroOne,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:SemiToBinaryBridge{T,S}},
) where {T,S<:MOI.Semicontinuous{T}}
    return Tuple{Type,Type}[
        (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}),
        (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}),
    ]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:SemiToBinaryBridge{T,S}},
) where {T,S<:MOI.Semiinteger{T}}
    return Tuple{Type,Type}[
        (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}),
        (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}),
        (MOI.VariableIndex, MOI.Integer),
    ]
end

function concrete_bridge_type(
    ::Type{<:SemiToBinaryBridge{T}},
    ::Type{MOI.VariableIndex},
    ::Type{S},
) where {T,S<:Union{MOI.Semicontinuous{T},MOI.Semiinteger{T}}}
    return SemiToBinaryBridge{T,S}
end

function MOI.supports_constraint(
    ::Type{<:SemiToBinaryBridge{T}},
    ::Type{MOI.VariableIndex},
    ::Type{<:Union{MOI.Semicontinuous{T},MOI.Semiinteger{T}}},
) where {T}
    return true
end

function MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, b::SemiToBinaryBridge)
    return b.semi_set
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::SemiToBinaryBridge{T,S},
    set::S,
) where {T,S}
    bridge.semi_set = set
    MOI.modify(
        model,
        bridge.upper_bound_index,
        MOI.ScalarCoefficientChange(bridge.binary_variable, -set.upper),
    )
    MOI.modify(
        model,
        bridge.lower_bound_index,
        MOI.ScalarCoefficientChange(bridge.binary_variable, -set.lower),
    )
    return
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    b::SemiToBinaryBridge{T},
) where {T}
    return b.variable
end

function MOI.delete(model::MOI.ModelLike, bridge::SemiToBinaryBridge)
    if bridge.integer_index !== nothing
        MOI.delete(model, bridge.integer_index)
    end
    MOI.delete(model, bridge.upper_bound_index)
    MOI.delete(model, bridge.lower_bound_index)
    MOI.delete(model, bridge.binary_variable)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::SemiToBinaryBridge,
)
    return MOI.get(
        model,
        MOI.VariablePrimal(attr.result_index),
        bridge.variable,
    )
end

function MOI.supports(
    model::MOI.ModelLike,
    ::MOI.ConstraintPrimalStart,
    ::Type{SemiToBinaryBridge{T,S}},
) where {T,S}
    ci_1 = MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}}
    ci_2 = MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}}
    return MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex) &&
           MOI.supports(model, MOI.ConstraintPrimalStart(), ci_1) &&
           MOI.supports(model, MOI.ConstraintPrimalStart(), ci_2)
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintPrimalStart,
    bridge::SemiToBinaryBridge,
)
    return MOI.get(model, MOI.VariablePrimalStart(), bridge.variable)
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintPrimalStart,
    bridge::SemiToBinaryBridge{T},
    value,
) where {T}
    MOI.set(model, MOI.VariablePrimalStart(), bridge.variable, value)
    bin_value = iszero(value) ? zero(T) : one(T)
    MOI.set(model, MOI.VariablePrimalStart(), bridge.binary_variable, bin_value)
    MOI.set(
        model,
        MOI.ConstraintPrimalStart(),
        bridge.upper_bound_index,
        value - bridge.semi_set.upper * bin_value,
    )
    MOI.set(
        model,
        MOI.ConstraintPrimalStart(),
        bridge.lower_bound_index,
        value - bridge.semi_set.lower * bin_value,
    )
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintPrimalStart,
    bridge::SemiToBinaryBridge{T},
    ::Nothing,
) where {T}
    MOI.set(model, MOI.VariablePrimalStart(), bridge.variable, nothing)
    MOI.set(model, MOI.VariablePrimalStart(), bridge.binary_variable, nothing)
    MOI.set(
        model,
        MOI.ConstraintPrimalStart(),
        bridge.upper_bound_index,
        nothing,
    )
    MOI.set(
        model,
        MOI.ConstraintPrimalStart(),
        bridge.lower_bound_index,
        nothing,
    )
    return
end

MOI.get(::SemiToBinaryBridge, ::MOI.NumberOfVariables)::Int64 = 1

function MOI.get(b::SemiToBinaryBridge, ::MOI.ListOfVariableIndices)
    return [b.binary_variable]
end

function MOI.get(
    ::SemiToBinaryBridge{T,S},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64 where {T,S}
    return 1
end

function MOI.get(
    ::SemiToBinaryBridge{T,S},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Integer},
)::Int64 where {T,S<:MOI.Semiinteger}
    return 1
end

function MOI.get(
    ::SemiToBinaryBridge{T,S},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}},
)::Int64 where {T,S}
    return 1
end

function MOI.get(
    ::SemiToBinaryBridge{T,S},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
)::Int64 where {T,S}
    return 1
end

function MOI.get(
    b::SemiToBinaryBridge{T,S},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
) where {T,S}
    return [b.binary_constraint_index]
end

function MOI.get(
    b::SemiToBinaryBridge{T,S},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Integer},
) where {T,S<:MOI.Semiinteger}
    return [b.integer_index]
end

function MOI.get(
    b::SemiToBinaryBridge{T,S},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
) where {T,S}
    return [b.upper_bound_index]
end

function MOI.get(
    b::SemiToBinaryBridge{T,S},
    ::MOI.ListOfConstraintIndices{
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    },
) where {T,S}
    return [b.lower_bound_index]
end

MOI.Bridges.needs_final_touch(b::SemiToBinaryBridge) = true

function MOI.Bridges.final_touch(
    b::SemiToBinaryBridge{T,S},
    model::MOI.ModelLike,
) where {T,S}
    F, f = MOI.VariableIndex, b.variable
    if MOI.is_valid(model, MOI.ConstraintIndex{F,MOI.GreaterThan{T}}(f.value))
        throw(MOI.LowerBoundAlreadySet{S,MOI.GreaterThan{T}}(f))
    end
    if MOI.is_valid(model, MOI.ConstraintIndex{F,MOI.LessThan{T}}(f.value))
        throw(MOI.UpperBoundAlreadySet{S,MOI.LessThan{T}}(f))
    end
    if MOI.is_valid(model, MOI.ConstraintIndex{F,MOI.EqualTo{T}}(f.value))
        throw(MOI.LowerBoundAlreadySet{S,MOI.EqualTo{T}}(f))
    end
    if MOI.is_valid(model, MOI.ConstraintIndex{F,MOI.Interval{T}}(f.value))
        throw(MOI.LowerBoundAlreadySet{S,MOI.Interval{T}}(f))
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintTable

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.TableToMILPBridge,
        """
        variables: x, y, z
        [x, y, z] in Table(Float64[1 1 0; 0 1 1; 1 0 1; 1 1 1])
        """,
        """
        variables: x, y, z, a1, a2, a3, a4
        a1 + a2 + a3 + a4 == 1.0
        a1 +      a3 + a4 + -1.0 * x == 0.0
        a1 + a2 +      a4 + -1.0 * y == 0.0
             a2 + a3 + a4 + -1.0 * z == 0.0
        a1 in ZeroOne()
        a2 in ZeroOne()
        a3 in ZeroOne()
        a4 in ZeroOne()
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.TableToMILPBridge,
        """
        variables: x, y
        [x, y, 1] in Table(Float64[1 1 0; 0 1 1; 1 0 1; 1 1 1])
        """,
        """
        variables: x, y, a1, a2, a3, a4
        a1 + a2 + a3 + a4 == 1.0
        a1 +      a3 + a4 + -1.0 * x == 0.0
        a1 + a2 +      a4 + -1.0 * y == 0.0
             a2 + a3 + a4            == 1.0
        a1 in ZeroOne()
        a2 in ZeroOne()
        a3 in ZeroOne()
        a4 in ZeroOne()
        """,
    )
    return
end

end  # module

TestConstraintTable.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

const TAG = :ReverseAD

"""
    const MAX_CHUNK::Int = 10

An upper bound on the chunk sie for forward-over-reverse. Increasing this could
improve performance at the cost of extra memory allocation. It has been 10 for a
long time, and nobody seems to have complained.
"""
const MAX_CHUNK = 10

"""
    _eval_hessian(
        d::NLPEvaluator,
        f::_FunctionStorage,
        H::AbstractVector{Float64},
        λ::Float64,
        offset::Int,
    )::Int

Evaluate the hessian matrix of the function `f` and store the result, scaled by
`λ`, in `H`, beginning at element `offset+1`. This function assumes that
`_reverse_mode(d, x)` has already been called.

Returns the number of non-zeros in the computed Hessian, which will be used to
update the offset for the next call.
"""
function _eval_hessian(
    d::NLPEvaluator,
    ex::_FunctionStorage,
    H::AbstractVector{Float64},
    scale::Float64,
    nzcount::Int,
)::Int
    if ex.linearity == LINEAR
        @assert length(ex.hess_I) == 0
        return 0
    end
    chunk = min(size(ex.seed_matrix, 2), d.max_chunk)
    Coloring.prepare_seed_matrix!(ex.seed_matrix, ex.rinfo)
    # Compute hessian-vector products
    num_products = size(ex.seed_matrix, 2) # number of hessian-vector products
    num_chunks = div(num_products, chunk)
    @assert size(ex.seed_matrix, 1) == length(ex.rinfo.local_indices)
    for offset in 1:chunk:(chunk*num_chunks)
        _eval_hessian_chunk(d, ex, offset, chunk, chunk)
    end
    # leftover chunk
    remaining = num_products - chunk * num_chunks
    if remaining > 0
        offset = chunk * num_chunks + 1
        _eval_hessian_chunk(d, ex, offset, remaining, chunk)
    end
    want, got = nzcount + length(ex.hess_I), length(H)
    if want > got
        error(
            "Vector provided for Hessian storage has too few elements. Got " *
            "$got, want $want.",
        )
    end
    # TODO(odow): consider reverting to a view.
    output_slice = _UnsafeVectorView(nzcount, length(ex.hess_I), pointer(H))
    Coloring.recover_from_matmat!(
        output_slice,
        ex.seed_matrix,
        ex.rinfo,
        d.output_ϵ,
    )
    for i in 1:length(output_slice)
        output_slice[i] *= scale
    end
    return length(ex.hess_I)
end

function _eval_hessian_chunk(
    d::NLPEvaluator,
    ex::_FunctionStorage,
    offset::Int,
    chunk::Int,
    chunk_size::Int,
)
    for r in eachindex(ex.rinfo.local_indices)
        # set up directional derivatives
        @inbounds idx = ex.rinfo.local_indices[r]
        # load up ex.seed_matrix[r,k,k+1,...,k+remaining-1] into input_ϵ
        for s in 1:chunk
            # If `chunk < chunk_size`, leaves junk in the unused components
            d.input_ϵ[(idx-1)*chunk_size+s] = ex.seed_matrix[r, offset+s-1]
            # Ensure the output is clear in preparation for the chunk
            d.output_ϵ[(idx-1)*chunk_size+s] = 0.0
        end
    end
    _hessian_slice_inner(d, ex, chunk_size)
    # collect directional derivatives
    for r in eachindex(ex.rinfo.local_indices)
        @inbounds idx = ex.rinfo.local_indices[r]
        # load output_ϵ into ex.seed_matrix[r,k,k+1,...,k+remaining-1]
        for s in 1:chunk
            ex.seed_matrix[r, offset+s-1] = d.output_ϵ[(idx-1)*chunk_size+s]
            # Reset the input in preparation for the next chunk
            d.input_ϵ[(idx-1)*chunk_size+s] = 0.0
        end
    end
    return
end

# A wrapper function to avoid dynamic dispatch.
function _generate_hessian_slice_inner()
    exprs = map(1:MAX_CHUNK) do id
        T = ForwardDiff.Partials{id,Float64}
        return :(return _hessian_slice_inner(d, ex, $T))
    end
    return MOI.Nonlinear._create_binary_switch(1:MAX_CHUNK, exprs)
end

@eval function _hessian_slice_inner(d, ex, id::Int)
    $(_generate_hessian_slice_inner())
    return error("Invalid chunk size: $id")
end

function _hessian_slice_inner(d, ex, ::Type{T}) where {T}
    output_ϵ = _reinterpret_unsafe(T, d.output_ϵ)
    subexpr_forward_values_ϵ =
        _reinterpret_unsafe(T, d.subexpression_forward_values_ϵ)
    for i in ex.dependent_subexpressions
        subexpr = d.subexpressions[i]
        subexpr_forward_values_ϵ[i] = _forward_eval_ϵ(
            d,
            subexpr,
            _reinterpret_unsafe(T, subexpr.partials_storage_ϵ),
        )
    end
    _forward_eval_ϵ(d, ex, _reinterpret_unsafe(T, d.partials_storage_ϵ))
    # do a reverse pass
    subexpr_reverse_values_ϵ =
        _reinterpret_unsafe(T, d.subexpression_reverse_values_ϵ)
    for i in ex.dependent_subexpressions
        subexpr_reverse_values_ϵ[i] = zero(T)
        d.subexpression_reverse_values[i] = 0.0
    end
    _reverse_eval_ϵ(
        output_ϵ,
        ex,
        _reinterpret_unsafe(T, d.storage_ϵ),
        _reinterpret_unsafe(T, d.partials_storage_ϵ),
        d.subexpression_reverse_values,
        subexpr_reverse_values_ϵ,
        1.0,
        zero(T),
    )
    for i in length(ex.dependent_subexpressions):-1:1
        j = ex.dependent_subexpressions[i]
        subexpr = d.subexpressions[j]
        _reverse_eval_ϵ(
            output_ϵ,
            subexpr,
            _reinterpret_unsafe(T, d.storage_ϵ),
            _reinterpret_unsafe(T, subexpr.partials_storage_ϵ),
            d.subexpression_reverse_values,
            subexpr_reverse_values_ϵ,
            d.subexpression_reverse_values[j],
            subexpr_reverse_values_ϵ[j],
        )
    end
    return
end

"""
    _forward_eval_ϵ(
        d::NLPEvaluator,
        ex::Union{_FunctionStorage,_SubexpressionStorage},
        partials_storage_ϵ::AbstractVector{ForwardDiff.Partials{N,T}},
    ) where {N,T}

Evaluate the directional derivatives of the expression tree in `ex`.

This is equivalent to evaluating the expression tree using DualNumbers or
ForwardDiff, but instead we keep the `ex.forward_storage` for the epsilon
components separate so that we don't need to recompute the real components.

This assumes that `_reverse_model(d, x)` has already been called.
"""
function _forward_eval_ϵ(
    d::NLPEvaluator,
    ex::Union{_FunctionStorage,_SubexpressionStorage},
    partials_storage_ϵ::AbstractVector{P},
) where {N,T,P<:ForwardDiff.Partials{N,T}}
    storage_ϵ = _reinterpret_unsafe(P, d.storage_ϵ)
    x_values_ϵ = _reinterpret_unsafe(P, d.input_ϵ)
    subexpression_values_ϵ =
        _reinterpret_unsafe(P, d.subexpression_forward_values_ϵ)
    @assert length(storage_ϵ) >= length(ex.nodes)
    @assert length(partials_storage_ϵ) >= length(ex.nodes)
    zero_ϵ = zero(P)
    # ex.nodes is already in order such that parents always appear before children
    # so a backwards pass through ex.nodes is a forward pass through the tree
    children_arr = SparseArrays.rowvals(ex.adj)
    for k in length(ex.nodes):-1:1
        node = ex.nodes[k]
        partials_storage_ϵ[k] = zero_ϵ
        if node.type == Nonlinear.NODE_VARIABLE
            storage_ϵ[k] = x_values_ϵ[node.index]
        elseif node.type == Nonlinear.NODE_VALUE
            storage_ϵ[k] = zero_ϵ
        elseif node.type == Nonlinear.NODE_SUBEXPRESSION
            storage_ϵ[k] = subexpression_values_ϵ[node.index]
        elseif node.type == Nonlinear.NODE_PARAMETER
            storage_ϵ[k] = zero_ϵ
        else
            @assert node.type != Nonlinear.NODE_MOI_VARIABLE
            ϵtmp = zero_ϵ
            @inbounds children_idx = SparseArrays.nzrange(ex.adj, k)
            for c_idx in children_idx
                @inbounds ix = children_arr[c_idx]
                @inbounds partial = ex.partials_storage[ix]
                @inbounds storage_val = storage_ϵ[ix]
                # TODO: This "if" statement can take 8% of the hessian
                # evaluation time. Find a more efficient way.
                if !isfinite(partial) && storage_val == zero_ϵ
                    continue
                end
                ϵtmp += storage_val * ex.partials_storage[ix]
            end
            storage_ϵ[k] = ϵtmp
            if node.type == Nonlinear.NODE_CALL_MULTIVARIATE
                # TODO(odow): consider how to refactor this into Nonlinear.
                op = node.index
                n_children = length(children_idx)
                if op == 3 # :*
                    # Lazy approach for now.
                    anyzero = false
                    tmp_prod = one(ForwardDiff.Dual{TAG,T,N})
                    for c_idx in children_idx
                        ix = children_arr[c_idx]
                        sval = ex.forward_storage[ix]
                        gnum = ForwardDiff.Dual{TAG}(sval, storage_ϵ[ix])
                        tmp_prod *= gnum
                        anyzero = ifelse(sval * sval == zero(T), true, anyzero)
                    end
                    # By a quirk of floating-point numbers, we can have
                    # anyzero == true && ForwardDiff.value(tmp_prod) != zero(T)
                    if anyzero || n_children <= 2
                        for c_idx in children_idx
                            prod_others = one(ForwardDiff.Dual{TAG,T,N})
                            for c_idx2 in children_idx
                                (c_idx == c_idx2) && continue
                                ix = children_arr[c_idx2]
                                gnum = ForwardDiff.Dual{TAG}(
                                    ex.forward_storage[ix],
                                    storage_ϵ[ix],
                                )
                                prod_others *= gnum
                            end
                            partials_storage_ϵ[children_arr[c_idx]] =
                                ForwardDiff.partials(prod_others)
                        end
                    else
                        for c_idx in children_idx
                            ix = children_arr[c_idx]
                            prod_others =
                                tmp_prod / ForwardDiff.Dual{TAG}(
                                    ex.forward_storage[ix],
                                    storage_ϵ[ix],
                                )
                            partials_storage_ϵ[ix] =
                                ForwardDiff.partials(prod_others)
                        end
                    end
                elseif op == 4 # :^
                    @assert n_children == 2
                    idx1 = first(children_idx)
                    idx2 = last(children_idx)
                    @inbounds ix1 = children_arr[idx1]
                    @inbounds ix2 = children_arr[idx2]
                    @inbounds base = ex.forward_storage[ix1]
                    @inbounds base_ϵ = storage_ϵ[ix1]
                    @inbounds exponent = ex.forward_storage[ix2]
                    @inbounds exponent_ϵ = storage_ϵ[ix2]
                    base_gnum = ForwardDiff.Dual{TAG}(base, base_ϵ)
                    exponent_gnum = ForwardDiff.Dual{TAG}(exponent, exponent_ϵ)
                    if exponent == 2
                        partials_storage_ϵ[ix1] = 2 * base_ϵ
                    elseif exponent == 1
                        partials_storage_ϵ[ix1] = zero_ϵ
                    else
                        partials_storage_ϵ[ix1] = ForwardDiff.partials(
                            exponent_gnum * pow(base_gnum, exponent_gnum - 1),
                        )
                    end
                    result_gnum = ForwardDiff.Dual{TAG}(
                        ex.forward_storage[k],
                        storage_ϵ[k],
                    )
                    # TODO(odow): fix me to use NaNMath.jl instead
                    log_base_gnum = base_gnum < 0 ? NaN : log(base_gnum)
                    partials_storage_ϵ[ix2] =
                        ForwardDiff.partials(result_gnum * log_base_gnum)
                elseif op == 5 # :/
                    @assert n_children == 2
                    idx1 = first(children_idx)
                    idx2 = last(children_idx)
                    @inbounds ix1 = children_arr[idx1]
                    @inbounds ix2 = children_arr[idx2]
                    @inbounds numerator = ex.forward_storage[ix1]
                    @inbounds numerator_ϵ = storage_ϵ[ix1]
                    @inbounds denominator = ex.forward_storage[ix2]
                    @inbounds denominator_ϵ = storage_ϵ[ix2]
                    recip_denominator =
                        1 / ForwardDiff.Dual{TAG}(denominator, denominator_ϵ)
                    partials_storage_ϵ[ix1] =
                        ForwardDiff.partials(recip_denominator)
                    partials_storage_ϵ[ix2] = ForwardDiff.partials(
                        -ForwardDiff.Dual{TAG}(numerator, numerator_ϵ) *
                        recip_denominator *
                        recip_denominator,
                    )
                elseif op > 6
                    f_input = _UnsafeVectorView(d.jac_storage, n_children)
                    for (i, c) in enumerate(children_idx)
                        f_input[i] = ex.forward_storage[children_arr[c]]
                    end
                    H = _UnsafeLowerTriangularMatrixView(
                        d.user_output_buffer,
                        n_children,
                    )
                    has_hessian = Nonlinear.eval_multivariate_hessian(
                        d.data.operators,
                        d.data.operators.multivariate_operators[node.index],
                        H,
                        f_input,
                    )
                    # This might be `false` if we extend this code to all
                    # multivariate functions.
                    @assert has_hessian
                    for col in 1:n_children
                        dual = zero(P)
                        for row in 1:n_children
                            # Make sure we get the lower-triangular component.
                            h = row >= col ? H[row, col] : H[col, row]
                            # Performance optimization: hessians can be quite
                            # sparse
                            if !iszero(h)
                                i = children_arr[children_idx[row]]
                                dual += h * storage_ϵ[i]
                            end
                        end
                        i = children_arr[children_idx[col]]
                        partials_storage_ϵ[i] = dual
                    end
                end
            elseif node.type == Nonlinear.NODE_CALL_UNIVARIATE
                @inbounds child_idx = children_arr[ex.adj.colptr[k]]
                f′′ = Nonlinear.eval_univariate_hessian(
                    d.data.operators,
                    node.index,
                    ex.forward_storage[child_idx],
                )
                partials_storage_ϵ[child_idx] = f′′ * storage_ϵ[child_idx]
            end
        end
    end
    return storage_ϵ[1]
end

# Compute directional derivatives of the reverse pass, goes with _forward_eval_ϵ
# to compute hessian-vector products.
function _reverse_eval_ϵ(
    output_ϵ::AbstractVector{ForwardDiff.Partials{N,T}},
    ex::Union{_FunctionStorage,_SubexpressionStorage},
    reverse_storage_ϵ,
    partials_storage_ϵ,
    subexpression_output,
    subexpression_output_ϵ,
    scale::T,
    scale_ϵ::ForwardDiff.Partials{N,T},
) where {N,T}
    @assert length(reverse_storage_ϵ) >= length(ex.nodes)
    @assert length(partials_storage_ϵ) >= length(ex.nodes)
    if ex.nodes[1].type == Nonlinear.NODE_VARIABLE
        @inbounds output_ϵ[ex.nodes[1].index] += scale_ϵ
        return
    elseif ex.nodes[1].type == Nonlinear.NODE_SUBEXPRESSION
        @inbounds subexpression_output[ex.nodes[1].index] +=
            scale * ex.reverse_storage[1]
        @inbounds subexpression_output_ϵ[ex.nodes[1].index] += scale_ϵ
        return
    end
    reverse_storage_ϵ[1] = scale_ϵ
    for k in 2:length(ex.nodes)
        @inbounds node = ex.nodes[k]
        if node.type == Nonlinear.NODE_VALUE ||
           node.type == Nonlinear.NODE_LOGIC ||
           node.type == Nonlinear.NODE_COMPARISON ||
           node.type == Nonlinear.NODE_PARAMETER
            continue
        end
        parent_value = scale * ex.reverse_storage[node.parent]
        if !isfinite(ex.partials_storage[k]) && iszero(parent_value)
            reverse_storage_ϵ[k] = zero(ForwardDiff.Partials{N,T})
        else
            reverse_storage_ϵ[k] = ForwardDiff._mul_partials(
                partials_storage_ϵ[k],
                reverse_storage_ϵ[node.parent],
                parent_value,
                ex.partials_storage[k],
            )
        end
        if node.type == Nonlinear.NODE_VARIABLE
            @inbounds output_ϵ[node.index] += reverse_storage_ϵ[k]
        elseif node.type == Nonlinear.NODE_SUBEXPRESSION
            @inbounds subexpression_output[node.index] +=
                scale * ex.reverse_storage[k]
            @inbounds subexpression_output_ϵ[node.index] += reverse_storage_ϵ[k]
        end
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableRSOCtoPSD

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

# Can come from a SOC of dimension 2 which makes more sense
# FIXME should it be moved to contconic or is RSOC of dimension 2 too exotic ?
function test_RSOC_of_dimension_2()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Variable.RSOCtoPSD{Float64}(mock)
    xy, cxy = MOI.add_constrained_variables(
        bridged_mock,
        MOI.RotatedSecondOrderCone(2),
    )
    x, y = xy
    c = MOI.add_constraint(bridged_mock, 1.0x + 1.0y, MOI.LessThan(1.0))
    obj = 1.0y
    MOI.set(bridged_mock, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(bridged_mock, MOI.ObjectiveFunction{typeof(obj)}(), obj)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [0.0, 2.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1.0],
        )
    MOI.optimize!(bridged_mock)
    @test MOI.get(bridged_mock, MOI.ObjectiveValue()) == 1.0
    @test MOI.get(bridged_mock, MOI.DualObjectiveValue()) == 1.0
    @test MOI.get(bridged_mock, MOI.VariablePrimal(), xy) == [0.0, 1.0]
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), cxy) == [0.0, 1.0]
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), cxy) == [1.0, 0.0]
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), c) == 1.0
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), c) == -1.0
    MOI.set(mock, MOI.ConstraintName(), c, "c")
    var_names = ["a", "b"]
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    nonneg = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonnegatives}(),
    )
    @test length(nonneg) == 1
    MOI.set(mock, MOI.ConstraintName(), nonneg[1], "cab")
    s = """
    variables: a, b
    cab: [a, b] in Nonnegatives(2)
    c: a + 0.5b <= 1.0
    maxobjective: 0.5b
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(mock, model, var_names, ["cab", "c"])
    var_names = ["x", "y"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    MOI.set(bridged_mock, MOI.ConstraintName(), cxy, "cxy")
    s = """
    variables: x, y
    cxy: [x, y] in RotatedSecondOrderCone(2)
    c: x + y <= 1.0
    maxobjective: 1.0y
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["cxy", "c"],
    )
    _test_delete_bridged_variables(
        bridged_mock,
        xy,
        MOI.RotatedSecondOrderCone,
        2,
        (
            (MOI.VectorOfVariables, MOI.Nonnegatives, 0),
            (MOI.VectorOfVariables, MOI.PositiveSemidefiniteConeTriangle, 0),
            (MOI.VariableIndex, MOI.EqualTo{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 1),
        ),
    )
    return
end

function test_RSOC4()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Variable.RSOCtoPSD{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 1.0, 2.0, 1.0, 0.0, 2.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [0.25],
            (MOI.VariableIndex, MOI.EqualTo{Float64}) => [-0.5],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1.0],
            (MOI.VectorOfVariables, MOI.PositiveSemidefiniteConeTriangle) =>
                [[1.0, -0.5, 0.25, -0.5, 0.25, 0.25]],
        )
    mock.eval_variable_constraint_dual = false
    MOI.Test.test_conic_RotatedSecondOrderCone_out_of_order(
        bridged_mock,
        MOI.Test.Config(),
    )
    mock.eval_variable_constraint_dual = true
    var_names = ["Q$i$j" for j in 1:3 for i in 1:j]
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    psd = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorOfVariables,
            MOI.PositiveSemidefiniteConeTriangle,
        }(),
    )
    @test length(psd) == 1
    MOI.set(mock, MOI.ConstraintName(), psd[1], "psd")
    off_diag = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.EqualTo{Float64}}(),
    )
    @test length(off_diag) == 1
    diag = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.EqualTo{Float64},
        }(),
    )
    @test length(diag) == 1
    MOI.set(mock, MOI.ConstraintName(), diag[1], "diag33")
    c = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(c) == 1
    MOI.set(mock, MOI.ConstraintName(), c[1], "c")

    s = """
    variables: Q11, Q12, Q13, Q22, Q23, Q33
    psd: [Q11, Q12, Q22, Q13, Q23, Q33] in PositiveSemidefiniteConeTriangle(3)
    Q23 == 0.0
    diag33: Q22 + -1.0Q33 == 0.0
    c: Q11 + 0.5Q22 <= 2.0
    maxobjective: Q12 + Q13
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        var_names,
        ["psd", "diag33", "c"],
        [("Q23", MOI.EqualTo{Float64}(0.0))],
    )

    var_names = ["t", "u", "x", "y"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    rsoc = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorOfVariables,
            MOI.RotatedSecondOrderCone,
        }(),
    )
    @test length(rsoc) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), rsoc[1], "rsoc")
    c = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(c) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), c[1], "c")

    s = """
    variables: t, u, x, y
    rsoc: [t, u, x, y] in RotatedSecondOrderCone(4)
    c: t + u <= 2.0
    maxobjective: x + y
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["rsoc", "c"],
    )

    v = MOI.get(bridged_mock, MOI.ListOfVariableIndices())
    @test length(v) == 4

    message = string(
        "Cannot delete variable as it is constrained with other",
        " variables in a `MOI.VectorOfVariables`.",
    )
    for i in 1:4
        err = MOI.DeleteNotAllowed(v[i], message)
        @test_throws err MOI.delete(bridged_mock, v[i])
    end

    _test_delete_bridged_variables(
        bridged_mock,
        v,
        MOI.RotatedSecondOrderCone,
        4,
        (
            (MOI.VectorOfVariables, MOI.Nonnegatives, 0),
            (MOI.VectorOfVariables, MOI.PositiveSemidefiniteConeTriangle, 0),
            (MOI.VariableIndex, MOI.EqualTo{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}, 0),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.RSOCtoPSDBridge,
        """
        constrainedvariable: [t, u, x] in RotatedSecondOrderCone(3)
        c: t + u + x <= 1.0
        """,
        """
        constrainedvariable: [t, x, u] in PositiveSemidefiniteConeTriangle(2)
        c: t + 0.5 * u + x <= 1.0
        """,
    )
    return
end

end  # module

TestVariableRSOCtoPSD.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    NormInfinityBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`NormInfinityBridge` implements the following reformulation:

  * ``|x|_\\infty \\le t`` into ``[t - x_i, t + x_i] \\in \\mathbb{R}_+``.

## Source node

`NormInfinityBridge` supports:

  * `G` in [`MOI.NormInfinityCone{T}`](@ref)

## Target nodes

`NormInfinityBridge` creates:

  * `F` in [`MOI.Nonnegatives`](@ref)
"""
struct NormInfinityBridge{T,F,G} <:
       SetMapBridge{T,MOI.Nonnegatives,MOI.NormInfinityCone,F,G}
    constraint::MOI.ConstraintIndex{F,MOI.Nonnegatives}
end

const NormInfinity{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NormInfinityBridge{T},OT}

function concrete_bridge_type(
    ::Type{<:NormInfinityBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.NormInfinityCone},
) where {T}
    F = MOI.Utilities.promote_operation(+, T, G, G)
    return NormInfinityBridge{T,F,G}
end

function MOI.Bridges.map_set(
    ::Type{<:NormInfinityBridge},
    set::MOI.NormInfinityCone,
)
    return MOI.Nonnegatives(2 * (MOI.dimension(set) - 1))
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:NormInfinityBridge},
    set::MOI.Nonnegatives,
)
    return MOI.NormInfinityCone(div(MOI.dimension(set), 2) + 1)
end

function MOI.Bridges.map_function(
    ::Type{<:NormInfinityBridge{T}},
    func,
) where {T}
    scalars = MOI.Utilities.eachscalar(func)
    t, x = scalars[1], scalars[2:end]
    # Create f_new = [-x; x].
    f_new = MOI.Utilities.operate(vcat, T, MOI.Utilities.operate(-, T, x), x)
    # Add +t to each row of x
    for i in 1:(2*(length(scalars)-1))
        MOI.Utilities.operate_output_index!(+, T, i, f_new, t)
    end
    return f_new
end

function MOI.Bridges.inverse_map_function(
    ::Type{<:NormInfinityBridge{T}},
    func,
) where {T}
    # func is [t - x; t + x]
    scalars = MOI.Utilities.eachscalar(func)
    sum_f = MOI.Utilities.operate(+, T, scalars...)
    # Get t by `(t - x) + (t + x)`, then dividing by the number of rows.
    t = MOI.Utilities.operate!(/, T, sum_f, T(length(scalars)))
    d = div(length(scalars), 2)
    # Get x by (t + x) - (t - x) = 2x
    x = MOI.Utilities.operate!(-, T, scalars[(d+1):end], scalars[1:d])
    x = MOI.Utilities.operate!(/, T, x, T(2))
    return MOI.Utilities.operate(vcat, T, t, x)
end

# Given a_i is dual on t - x_i >= 0 and b_i is dual on t + x_i >= 0,
# the dual on (t, x) in NormInfinityCone is (u, v) in NormOneCone, where
# v_i = -a_i + b_i and u = sum(a) + sum(b).
function MOI.Bridges.adjoint_map_function(::Type{<:NormInfinityBridge}, func)
    scalars = MOI.Utilities.eachscalar(func)
    t = sum(scalars)
    d = div(length(scalars), 2)
    x = scalars[(d+1):end] - scalars[1:d]
    return vcat(t, x)
end

function MOI.Bridges.inverse_adjoint_map_function(
    ::Type{<:NormInfinityBridge{T}},
    func::AbstractVector{T},
) where {T}
    # This is used by `MOI.ConstraintDualStart`.
    # The result should belong to `MOI.Nonnegatives` and the sum of the elements
    # should be `t`.
    # Only one of dual of the upper and lower bound should be active so one of
    # the two duals is zero. We know which one since they should be nonnegative.
    # Then if `t = sum abs(x_i)`, we will indeed have only one of them being
    # zero.
    t, y = func[1], func[2:end]
    lb = [x > 0 ? x : zero(x) for x in y]
    ub = [x < 0 ? -x : zero(x) for x in y]
    x = [ub; lb]
    return x .+ (t - sum(x)) / length(x)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintRSOC

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_RSOC()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.RSOC{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariables_RotatedSecondOrderCone",
            "test_basic_VectorAffineFunction_RotatedSecondOrderCone",
            "test_basic_VectorQuadraticFunction_RotatedSecondOrderCone",
        ],
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [0.5, 1.0, 1 / √2, 1 / √2],
            (MOI.VariableIndex, MOI.EqualTo{Float64}) => [-√2, -1 / √2],
            (MOI.VectorAffineFunction{Float64}, MOI.SecondOrderCone) =>
                [[3 / 2, 1 / 2, -1.0, -1.0]],
        )
    MOI.Test.test_conic_RotatedSecondOrderCone_VectorOfVariables(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1 / √2, 1 / √2],
            (MOI.VectorAffineFunction{Float64}, MOI.SecondOrderCone) =>
                [[3 / 2, 1 / 2, -1.0, -1.0]],
        )
    MOI.Test.test_conic_RotatedSecondOrderCone_VectorAffineFunction(
        bridged_mock,
        config,
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.RotatedSecondOrderCone,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value = [√2, 1 / √2, -1.0, -1.0]
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        ((MOI.VectorAffineFunction{Float64}, MOI.SecondOrderCone, 0),),
    )
    return
end

function test_SOCR()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.SOCR{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariables_SecondOrderCone",
            "test_basic_VectorAffineFunction_SecondOrderCone",
            "test_basic_VectorQuadraticFunction_SecondOrderCone",
        ],
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 1 / √2, 1 / √2],
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone) => [[1 - 1 / √2, 1 + 1 / √2, -1]],
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) => [[-√2]],
        )
    MOI.Test.test_conic_SecondOrderCone_VectorOfVariables(bridged_mock, config)
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 1 / √2, 1 / √2],
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone) => [[1 - 1 / √2, 1 + 1 / √2, -1]],
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) => [[-√2]],
        )
    MOI.Test.test_conic_SecondOrderCone_VectorAffineFunction(
        bridged_mock,
        config,
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.SecondOrderCone,
            }(),
        ),
    )
    @test !MOI.Utilities.is_canonical(
        MOI.get(bridged_mock, MOI.ConstraintFunction(), ci),
    )
    @test MOI.Utilities.is_canonical(
        MOI.get(bridged_mock, MOI.CanonicalConstraintFunction(), ci),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value = [√2, 1 / √2, -1.0, -1.0]
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        ((MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone, 0),),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SOCtoRSOCBridge,
        """
        variables: t, x, y
        [t, x, y] in SecondOrderCone(3)
        """,
        """
        variables: t, x, y
        [0.7071067811865475 * t + 0.7071067811865475 * x, 0.7071067811865475 * t + -0.7071067811865475 * x, y] in RotatedSecondOrderCone(3)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.RSOCtoSOCBridge,
        """
        variables: t, u, x
        [t, u, x] in RotatedSecondOrderCone(3)
        """,
        """
        variables: t, u, x
        [0.7071067811865475 * t + 0.7071067811865475 * u, 0.7071067811865475 * t + -0.7071067811865475 * u, x] in SecondOrderCone(3)
        """,
    )
    return
end

function test_dimension_mismatch_SOCR()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.SOCR{Float64}(inner)
    @test_throws(
        DimensionMismatch,
        MOI.add_constrained_variables(model, MOI.SecondOrderCone(1)),
    )
    return
end

function test_dimension_mismatch_RSOC()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.RSOC{Float64}(inner)
    @test_throws(
        DimensionMismatch,
        MOI.add_constrained_variables(model, MOI.RotatedSecondOrderCone(1)),
    )
    return
end

end  # module

TestConstraintRSOC.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ParameterToEqualToBridge{T} <: Bridges.Variable.AbstractBridge

`ParameterToEqualToBridge` implements the following reformulation:

* ``x \\in Parameter(v)`` into ``x == v``

## Source node

`ParameterToEqualToBridge` supports:

 * [`MOI.VariableIndex`](@ref) in [`MOI.Parameter`](@ref)

## Target nodes

`ParameterToEqualToBridge` creates:

 * One variable node: [`MOI.VariableIndex`](@ref) in [`MOI.EqualTo{T}`](@ref)
"""
struct ParameterToEqualToBridge{T} <:
       SetMapBridge{T,MOI.EqualTo{T},MOI.Parameter{T}}
    variable::MOI.VariableIndex
    constraint::MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{T}}
end

const ParameterToEqualTo{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ParameterToEqualToBridge{T},OT}

function MOI.Bridges.map_set(
    ::Type{<:ParameterToEqualToBridge{T}},
    set::MOI.EqualTo{T},
) where {T}
    return MOI.Parameter{T}(set.value)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:ParameterToEqualToBridge{T}},
    set::MOI.Parameter{T},
) where {T}
    return MOI.EqualTo{T}(set.value)
end

MOI.Bridges.map_function(::Type{<:ParameterToEqualToBridge}, f) = f

MOI.Bridges.inverse_map_function(::Type{<:ParameterToEqualToBridge}, f) = f

MOI.Bridges.adjoint_map_function(::Type{<:ParameterToEqualToBridge}, f) = f

function MOI.Bridges.inverse_adjoint_map_function(
    ::Type{<:ParameterToEqualToBridge},
    f,
)
    return f
end

function MOI.supports(
    ::MOI.ModelLike,
    ::MOI.VariableName,
    ::Type{<:ParameterToEqualToBridge},
)
    return true
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.VariableName,
    bridge::ParameterToEqualToBridge,
)
    return MOI.get(model, attr, bridge.variable)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.VariableName,
    bridge::ParameterToEqualToBridge,
    name::String,
)
    MOI.set(model, attr, bridge.variable, name)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintHermitianToComplexSymmetric

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_dimension_2()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.HermitianToComplexSymmetricBridge,
        model -> begin
            a, b, c = MOI.add_variables(model, 3)
            MOI.add_constraint(
                model,
                MOI.Utilities.vectorize([
                    1.0 * a + 2.0 * b,
                    3.0 * c,
                    4.0 * b,
                    5.0 * a,
                ]),
                MOI.HermitianPositiveSemidefiniteConeTriangle(2),
            )
        end,
        model -> begin
            a, b, c = MOI.add_variables(model, 3)
            MOI.add_constraint(
                model,
                MOI.Utilities.vectorize([
                    Complex(1.0) * a + Complex(2.0) * b,
                    Complex(3.0) * c + 5.0 * im * a,
                    Complex(4.0) * b,
                ]),
                MOI.PositiveSemidefiniteConeTriangle(2),
            )
        end,
    )
    return
end

function test_dimension_3()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.HermitianToComplexSymmetricBridge,
        model -> begin
            x = MOI.add_variables(model, 9)
            MOI.add_constraint(
                model,
                MOI.VectorOfVariables(x),
                MOI.HermitianPositiveSemidefiniteConeTriangle(3),
            )
        end,
        model -> begin
            x = MOI.add_variables(model, 9)
            MOI.add_constraint(
                model,
                MOI.Utilities.vectorize([
                    Complex(1.0) * x[1],
                    Complex(1.0) * x[2] + 1.0 * im * x[7],
                    Complex(1.0) * x[3],
                    Complex(1.0) * x[4] + 1.0 * im * x[8],
                    Complex(1.0) * x[5] + 1.0 * im * x[9],
                    Complex(1.0) * x[6],
                ]),
                MOI.PositiveSemidefiniteConeTriangle(3),
            )
        end,
    )
    return
end

end  # module

TestConstraintHermitianToComplexSymmetric.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module DoubleDicts

import MathOptInterface as MOI

abstract type AbstractDoubleDict{V} <: AbstractDict{MOI.ConstraintIndex,V} end

abstract type AbstractDoubleDictInner{F,S,V} <:
              AbstractDict{MOI.ConstraintIndex{F,S},V} end

"""
    typed_value(dict::AbstractDoubleDictInner{F,S,V}, value) where {F,S,V}

Convert the `value` stored inside `dict` to the equivalent on the outer
`DoubleDict`. This is useful when the value type `V` of the inner dict is
different to the outer dict. (See, for example, [`IndexDoubleDict`](@ref).)
"""
typed_value(::AbstractDoubleDictInner, value) = value

"""
    DoubleDict{V}

An optimized dictionary to map `MOI.ConstraintIndex` to values of type `V`.

Works as a `AbstractDict{MOI.ConstraintIndex,V}` with minimal differences.

If `V` is also a `MOI.ConstraintIndex`, use [`IndexDoubleDict`](@ref).

Note that `MOI.ConstraintIndex` is not a concrete type, opposed to
`MOI.ConstraintIndex{MOI.VariableIndex, MOI.Integers}`, which is a concrete
type.

When looping through multiple keys of the same Function-in-Set type, use
```julia
inner = dict[F, S]
```
to return a type-stable [`DoubleDictInner`](@ref).
"""
struct DoubleDict{V} <: AbstractDoubleDict{V}
    dict::Dict{Tuple{Type,Type},Dict{Int64,V}}
    function DoubleDict{V}() where {V}
        return new{V}(Dict{Tuple{Type,Type},Dict{Int64,V}}())
    end
end

"""
    DoubleDictInner{F,S,V}

A type stable inner dictionary of [`DoubleDict`](@ref).
"""
mutable struct DoubleDictInner{F,S,V} <: AbstractDoubleDictInner{F,S,V}
    dict::Dict{Int64,V}
    function DoubleDictInner{F,S}(d::DoubleDict{V}) where {F,S,V}
        if !haskey(d.dict, (F, S))
            d.dict[(F, S)] = Dict{Int64,V}()
        end
        return new{F,S,V}(d.dict[(F, S)])
    end
end

function Base.getindex(d::DoubleDict, ::Type{F}, ::Type{S}) where {F,S}
    return DoubleDictInner{F,S}(d)
end

"""
    IndexDoubleDict

A specialized version of [`DoubleDict`] in which the values are of type
`MOI.ConstraintIndex`

When looping through multiple keys of the same Function-in-Set type, use
```julia
inner = dict[F, S]
```
to return a type-stable [`IndexDoubleDictInner`](@ref).
"""
struct IndexDoubleDict <: AbstractDoubleDict{MOI.ConstraintIndex}
    dict::Dict{Tuple{Type,Type},Dict{Int64,Int64}}
    function IndexDoubleDict()
        return new(Dict{Tuple{Type,Type},Dict{Int64,Int64}}())
    end
end

"""
    IndexDoubleDictInner{F,S}

A type stable inner dictionary of [`IndexDoubleDict`](@ref).
"""
mutable struct IndexDoubleDictInner{F,S} <:
               AbstractDoubleDictInner{F,S,MOI.ConstraintIndex{F,S}}
    dict::Dict{Int64,Int64}
    function IndexDoubleDictInner{F,S}(d::IndexDoubleDict) where {F,S}
        if !haskey(d.dict, (F, S))
            d.dict[(F, S)] = Dict{Int64,Int64}()
        end
        return new{F,S}(d.dict[(F, S)])
    end
end

function Base.getindex(d::IndexDoubleDict, ::Type{F}, ::Type{S}) where {F,S}
    return IndexDoubleDictInner{F,S}(d)
end

function typed_value(::IndexDoubleDictInner{F,S}, v::Int64) where {F,S}
    return MOI.ConstraintIndex{F,S}(v)
end

# `Base.sizehint!`

function Base.sizehint!(::AbstractDoubleDict, ::Integer)
    return throw(
        ErrorException(
            "sizehint!(d::DoubleDict, ::Integer) has no proper" *
            " meaning for DoubleDict, use sizehint!(d[F,S], n::Integer) " *
            "instead.",
        ),
    )
end

function Base.sizehint!(d::AbstractDoubleDictInner, n::Integer)
    return sizehint!(d.dict, n)
end

# Base.length

function Base.length(d::AbstractDoubleDict)
    len = 0
    for inner in values(d.dict)
        len += length(inner)
    end
    return len
end

Base.length(d::AbstractDoubleDictInner) = length(d.dict)

# Base.haskey

function Base.haskey(
    d::AbstractDoubleDict,
    key::MOI.ConstraintIndex{F,S},
) where {F,S}
    return haskey(d[F, S], key)
end

function Base.haskey(
    d::AbstractDoubleDictInner{F,S},
    key::MOI.ConstraintIndex{F,S},
) where {F,S}
    return haskey(d.dict, key.value)
end

# Base.get

function Base.get(
    d::AbstractDoubleDict,
    key::MOI.ConstraintIndex{F,S},
    default,
) where {F,S}
    inner = d[F, S]
    return get(inner, key, default)
end

function Base.get(
    d::AbstractDoubleDictInner,
    key::MOI.ConstraintIndex{F,S},
    default,
) where {F,S}
    return typed_value(d, get(d.dict, key.value, default))
end

# Base.getindex

function Base.getindex(
    d::AbstractDoubleDict,
    key::MOI.ConstraintIndex{F,S},
) where {F,S}
    inner = d[F, S]
    return inner[key]
end

function Base.getindex(
    d::AbstractDoubleDictInner{F,S},
    key::MOI.ConstraintIndex{F,S},
) where {F,S}
    x = get(d.dict, key.value) do
        return throw(KeyError(key))
    end
    return typed_value(d, x)
end

# `Base.setindex!`

function Base.setindex!(
    d::AbstractDoubleDict{V},
    value::V,
    key::MOI.ConstraintIndex{F,S},
) where {F,S,V}
    inner = d[F, S]
    inner[key] = value
    return value
end

function Base.setindex!(
    d::AbstractDoubleDictInner{F,S,V},
    value::V,
    key::MOI.ConstraintIndex{F,S},
) where {F,S,V}
    d.dict[key.value] = value
    return value
end

function Base.setindex!(
    d::IndexDoubleDict,
    value::MOI.ConstraintIndex{F,S},
    key::MOI.ConstraintIndex{F,S},
) where {F,S}
    inner = d[F, S]
    inner[key] = value
    return value
end

function Base.setindex!(
    d::IndexDoubleDictInner{F,S},
    value::MOI.ConstraintIndex{F,S},
    key::MOI.ConstraintIndex{F,S},
) where {F,S}
    d.dict[key.value] = value.value
    return value
end

# `Base.empty!`

function Base.empty!(d::AbstractDoubleDict)
    Base.empty!(d.dict)
    return d
end

function Base.empty!(d::AbstractDoubleDictInner)
    empty!(d.dict)
    return d
end

# `Base.delete!`

function Base.delete!(
    d::AbstractDoubleDict,
    key::MOI.ConstraintIndex{F,S},
) where {F,S}
    delete!(d[F, S], key)
    return d
end

function Base.delete!(
    d::AbstractDoubleDictInner{F,S},
    key::MOI.ConstraintIndex{F,S},
) where {F,S}
    delete!(d.dict, key.value)
    return d
end

# Base.isempty

function Base.isempty(d::AbstractDoubleDict)
    return isempty(d.dict) || all(isempty, values(d.dict))
end

Base.isempty(d::AbstractDoubleDictInner) = isempty(d.dict)

# Base.values

function Base.values(d::AbstractDoubleDict{V}) where {V}
    out = V[]
    for (F, S) in keys(d.dict)
        append!(out, values(d[F, S]))
    end
    return out
end

Base.values(d::AbstractDoubleDictInner) = typed_value.(Ref(d), values(d.dict))

# Base.keys

function Base.keys(d::AbstractDoubleDict)
    out = MOI.ConstraintIndex[]
    for (F, S) in keys(d.dict)
        append!(out, keys(d[F, S]))
    end
    return out
end

function Base.keys(d::AbstractDoubleDictInner{F,S}) where {F,S}
    return MOI.ConstraintIndex{F,S}.(keys(d.dict))
end

"""
    outer_keys(d::AbstractDoubleDict)

Return an iterator over the outer keys of the `AbstractDoubleDict` `d`.
Each outer key is a `Tuple{Type,Type}` so that a double loop can
be easily used:
```julia
for (F, S) in DoubleDicts.outer_keys(dict)
    for (k, v) in dict[F, S]
        # ...
    end
end
```

For performance, it is recommended that the inner loop lies in a separate
function to guarantee type-stability.
Some outer keys `(F, S)` might lead to an empty `dict[F, S]`.
If you want only nonempty `dict[F, S]`, use [`nonempty_outer_keys`](@ref).
"""
outer_keys(d::AbstractDoubleDict) = keys(d.dict)

"""
    nonempty_outer_keys(d::AbstractDoubleDict)

Return a vector of outer keys of the `AbstractDoubleDict` `d`.

Only outer keys that have a nonempty set of inner keys will be returned.

Each outer key is a `Tuple{Type,Type}` so that a double loop can
be easily used
```julia
for (F, S) in DoubleDicts.nonempty_outer_keys(dict)
    for (k, v) in dict[F, S]
        # ...
    end
end
For performance, it is recommended that the inner loop lies in a separate
function to guarantee type-stability.

If you want an iterator of all current outer keys, use [`outer_keys`](@ref).
```
"""
function nonempty_outer_keys(d::AbstractDoubleDict)
    return Base.Iterators.Filter(
        fs -> length(d[fs[1], fs[2]]) > 0,
        outer_keys(d),
    )
end

# Base.iterate

function Base.iterate(d::AbstractDoubleDict)
    outer_next = iterate(d.dict)
    if outer_next === nothing
        return  # There are no keys.
    end
    # The result is a (F,S)=>inner pair.
    ((F, S), inner), outer_state = outer_next
    inner_next = iterate(inner)
    while inner_next === nothing
        # It may be that the inner dictionary is empty. If so, we should go to
        # the next element in the outer dictionary.
        outer_next = iterate(d.dict, outer_state)
        if outer_next === nothing
            return
        end
        ((F, S), inner), outer_state = outer_next
        # Start iterating from scratch on this new `inner` object.
        inner_next = iterate(inner)
    end
    (k, v), inner_state = inner_next
    result = MOI.ConstraintIndex{F,S}(k) => typed_value(d[F, S], v)
    return result, (inner_state, outer_next)
end

function Base.iterate(d::AbstractDoubleDictInner{F,S}) where {F,S}
    next = iterate(d.dict)
    if next === nothing
        return
    end
    (k, v), inner_state = next
    result = MOI.ConstraintIndex{F,S}(k) => typed_value(d, v)
    return result, (d.dict, inner_state)
end

function Base.iterate(d::AbstractDoubleDict, state)
    inner_state, outer_next = state
    ((F, S), inner), outer_state = outer_next
    inner_next = iterate(inner, inner_state)
    while inner_next === nothing
        # We may have reached the end of this inner dictionary. Get the next
        # element of the outer dictionary:
        outer_next = iterate(d.dict, outer_state)
        if outer_next === nothing
            return
        end
        ((F, S), inner), outer_state = outer_next
        # Start iterating from scratch on this new `inner` object.
        inner_next = iterate(inner)
    end
    (k, v), inner_state = inner_next
    result = MOI.ConstraintIndex{F,S}(k) => typed_value(d[F, S], v)
    return result, (inner_state, outer_next)
end

function Base.iterate(d::AbstractDoubleDictInner{F,S}, state) where {F,S}
    inner, inner_state = state
    next = iterate(inner, inner_state)
    if next === nothing
        return
    end
    ((k, v), next_inner_state) = next
    result = MOI.ConstraintIndex{F,S}(k) => typed_value(d, v)
    return result, (inner, next_inner_state)
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestNLModel

using Test

import MathOptInterface as MOI
import MathOptInterface.FileFormats: NL

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function _test_nlexpr(
    expr::NL._NLExpr,
    nonlinear_terms,
    linear_terms,
    constant;
    force_nonlinear::Bool = false,
)
    if force_nonlinear
        @test expr.is_linear == false
    else
        @test expr.is_linear == (length(nonlinear_terms) == 0)
    end
    @test expr.nonlinear_terms == nonlinear_terms
    @test expr.linear_terms == linear_terms
    @test expr.constant == constant
    return
end

function _test_nlexpr(x, args...; kwargs...)
    return _test_nlexpr(NL._NLExpr(x), args...; kwargs...)
end

function test_nlexpr_singlevariable()
    x = MOI.VariableIndex(1)
    _test_nlexpr(x, NL._NLTerm[], Dict(x => 1.0), 0.0)
    return
end

function test_nlexpr_scalaraffine()
    x = MOI.VariableIndex.(1:3)
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 4.0)
    return _test_nlexpr(f, NL._NLTerm[], Dict(x .=> 1), 4.0)
end

function test_nlexpr_scalarquadratic_0()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm{Float64}[],
        [MOI.ScalarAffineTerm(1.1, x)],
        3.0,
    )
    return _test_nlexpr(
        f,
        NL._NLTerm[],
        Dict(x => 1.1),
        3.0;
        force_nonlinear = true,
    )
end

function test_nlexpr_scalarquadratic_1a()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(2.0, x, x)],
        [MOI.ScalarAffineTerm(1.1, x)],
        3.0,
    )
    terms = [NL.OPMULT, x, x]
    return _test_nlexpr(f, terms, Dict(x => 1.1), 3.0)
end

function test_nlexpr_scalarquadratic_1b()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(2.5, x, x)],
        [MOI.ScalarAffineTerm(1.1, x)],
        3.0,
    )
    terms = [NL.OPMULT, 1.25, NL.OPMULT, x, x]
    return _test_nlexpr(f, terms, Dict(x => 1.1), 3.0)
end

function test_nlexpr_scalarquadratic_1c()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(1.0, x, y)],
        [MOI.ScalarAffineTerm(1.1, x)],
        3.0,
    )
    terms = [NL.OPMULT, x, y]
    return _test_nlexpr(f, terms, Dict(x => 1.1, y => 0.0), 3.0)
end

function test_nlexpr_scalarquadratic_2()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f = MOI.ScalarQuadraticFunction(
        [
            MOI.ScalarQuadraticTerm(2.0, x, x),
            MOI.ScalarQuadraticTerm(1.0, x, y),
        ],
        [MOI.ScalarAffineTerm(1.1, x)],
        3.0,
    )
    terms = [NL.OPPLUS, NL.OPMULT, x, x, NL.OPMULT, x, y]
    return _test_nlexpr(f, terms, Dict(x => 1.1, y => 0.0), 3.0)
end

function test_nlexpr_scalarquadratic_3()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    f = MOI.ScalarQuadraticFunction(
        [
            MOI.ScalarQuadraticTerm(2.0, x, x),
            MOI.ScalarQuadraticTerm(0.5, x, y),
            MOI.ScalarQuadraticTerm(4.0, x, z),
        ],
        [MOI.ScalarAffineTerm(1.1, x)],
        3.0,
    )
    terms = [
        NL.OPSUMLIST,
        3,
        NL.OPMULT,
        x,
        x,
        NL.OPMULT,
        0.5,
        NL.OPMULT,
        x,
        y,
        NL.OPMULT,
        4.0,
        NL.OPMULT,
        x,
        z,
    ]
    return _test_nlexpr(f, terms, Dict(x => 1.1, y => 0.0, z => 0.0), 3.0)
end

function test_nlexpr_scalarnonlinearfunction_unary_special_case()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:cbrt, Any[x])
    expr = NL._NLExpr(:(cbrt($x)))
    _test_nlexpr(f, expr.nonlinear_terms, Dict(x => 0), 0.0)
    return
end

function test_nlexpr_scalarnonlinearfunction_unary_special_case_sign()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:sign, Any[x])
    expr = NL._NLExpr(:(ifelse($x >= 0, 1, -1)))
    _test_nlexpr(f, expr.nonlinear_terms, Dict(x => 0.0), 0.0)
    return
end

function test_nlexpr_scalarnonlinearfunction_binary_special_case()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:\, Any[x, 1])
    expr = NL._NLExpr(:(\($x, 1)))
    _test_nlexpr(f, expr.nonlinear_terms, Dict(x => 0), 0.0)
    return
end

function test_nlexpr_scalarnonlinearfunction_ternary_multiplication()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:*, Any[x, x, x])
    expr = NL._NLExpr(:(*($x, $x, $x)))
    _test_nlexpr(f, expr.nonlinear_terms, Dict(x => 0), 0.0)
    return
end

function test_nlexpr_scalarnonlinearfunction_inner_functions()
    x = MOI.VariableIndex(1)
    f = 1.0 * x + 1.0
    g = 2.0 * x * x + 3.0 * x + 4.0
    f = MOI.ScalarNonlinearFunction(:*, Any[2.0, x, f, g])
    ex = Expr(
        :call,
        :*,
        2.0,
        x,
        :(1.0 * $x + 1.0),
        :(2.0 * $x * $x + 3.0 * $x + 4.0),
    )
    expr = NL._NLExpr(ex)
    _test_nlexpr(f, expr.nonlinear_terms, Dict(x => 0), 0.0)
    return
end

function test_nlexpr_unary_addition()
    x = MOI.VariableIndex(1)
    return _test_nlexpr(:(+$x), [x], Dict(x => 0), 0.0)
end

function test_nlexpr_binary_addition()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    return _test_nlexpr(
        :($x + $y),
        [NL.OPPLUS, x, y],
        Dict(x => 0.0, y => 0.0),
        0.0,
    )
end

function test_nlexpr_nary_addition()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    return _test_nlexpr(
        :($x + $y + 1.0),
        [NL.OPSUMLIST, 3, x, y, 1.0],
        Dict(x => 0.0, y => 0.0),
        0.0,
    )
end

function test_nlexpr_unary_subtraction()
    x = MOI.VariableIndex(1)
    return _test_nlexpr(:(-$x), [NL.OPUMINUS, x], Dict(x => 0.0), 0.0)
end

function test_nlexpr_nary_multiplication()
    x = MOI.VariableIndex(1)
    return _test_nlexpr(
        :($x * $x * 2.0),
        [NL.OPMULT, x, NL.OPMULT, x, 2.0],
        Dict(x => 0.0),
        0.0,
    )
end

function test_nlexpr_unary_multiplication()
    x = MOI.VariableIndex(1)
    return _test_nlexpr(:(*($x)), [x], Dict(x => 0), 0.0)
end

function test_nlexpr_unary_specialcase()
    x = MOI.VariableIndex(1)
    return _test_nlexpr(
        :(cbrt($x)),
        [NL.OPPOW, x, NL.OPDIV, 1, 3],
        Dict(x => 0.0),
        0.0,
    )
end

function test_nlexpr_binary_specialcase()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    return _test_nlexpr(
        :(\($x, $y)),
        [NL.OPDIV, y, x],
        Dict(x => 0.0, y => 0.0),
        0.0,
    )
end

function test_nlexpr_atan_and_atan2()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    _test_nlexpr(:(atan($x)), [NL.OP_atan, x], Dict(x => 0.0), 0.0)
    _test_nlexpr(
        :(atan($x, $y)),
        [NL.OP_atan2, x, y],
        Dict(x => 0.0, y => 0.0),
        0.0,
    )
    return
end

function test_nlexpr_unsupportedoperation()
    x = MOI.VariableIndex(1)
    @test_throws MOI.UnsupportedNonlinearOperator(:foo) NL._NLExpr(:(foo($x)))
    return
end

function test_nlexpr_unsupportedexpression()
    x = MOI.VariableIndex(1)
    expr = :(1 <= $x <= 2)
    err = ErrorException("Unsupported expression: $(expr)")
    @test_throws err NL._NLExpr(expr)
    return
end

function test_nlexpr_ref()
    x = MOI.VariableIndex(1)
    return _test_nlexpr(:(x[$x]), [x], Dict(x => 0.0), 0.0)
end

function test_nlexpr_empty()
    return _test_nlexpr(
        :(),
        NL._NLTerm[],
        Dict{MOI.VariableIndex,Float64}(),
        0.0;
        force_nonlinear = true,
    )
end

function test_nlconstraint_interval()
    x = MOI.VariableIndex(1)
    expr = :(1.0 <= $x <= 2.0)
    con = NL._NLConstraint(expr, MOI.NLPBoundsPair(1.0, 2.0))
    @test con.lower == 1
    @test con.upper == 2
    @test con.opcode == 0
    @test con.expr == NL._NLExpr(expr.args[3])
end

function test_nlconstraint_lessthan()
    x = MOI.VariableIndex(1)
    expr = :($x <= 2.0)
    con = NL._NLConstraint(expr, MOI.NLPBoundsPair(-Inf, 2.0))
    @test con.lower == -Inf
    @test con.upper == 2
    @test con.opcode == 1
    @test con.expr == NL._NLExpr(expr.args[2])
end

function test_nlconstraint_greaterthan()
    x = MOI.VariableIndex(1)
    expr = :($x >= 2.0)
    con = NL._NLConstraint(expr, MOI.NLPBoundsPair(2.0, Inf))
    @test con.lower == 2
    @test con.upper == Inf
    @test con.opcode == 2
    @test con.expr == NL._NLExpr(expr.args[2])
end

function test_nlconstraint_equalto()
    x = MOI.VariableIndex(1)
    expr = :($x == 2.0)
    con = NL._NLConstraint(expr, MOI.NLPBoundsPair(2.0, 2.0))
    @test con.lower == 2
    @test con.upper == 2
    @test con.opcode == 4
    @test con.expr == NL._NLExpr(expr.args[2])
end

function test_nlconstraint_interval_warn()
    x = MOI.VariableIndex(1)
    expr = :(2.0 <= $x <= 1.0)
    @test_logs (:warn,) NL._NLConstraint(expr, MOI.NLPBoundsPair(1.0, 2.0))
end

function test_nlconstraint_lessthan_warn()
    x = MOI.VariableIndex(1)
    expr = :($x <= 1.0)
    @test_logs (:warn,) NL._NLConstraint(expr, MOI.NLPBoundsPair(-Inf, 2.0))
end

function test_nlconstraint_greaterthan_warn()
    x = MOI.VariableIndex(1)
    expr = :($x >= 0.0)
    @test_logs (:warn,) NL._NLConstraint(expr, MOI.NLPBoundsPair(1.0, Inf))
end

function test_nlconstraint_equalto_warn()
    x = MOI.VariableIndex(1)
    expr = :($x == 2.0)
    @test_logs (:warn,) NL._NLConstraint(expr, MOI.NLPBoundsPair(1.0, 1.0))
end

function test_nlmodel_hs071()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    v = MOI.add_variables(model, 4)
    l = [1.1, 1.2, 1.3, 1.4]
    u = [5.1, 5.2, 5.3, 5.4]
    start = [2.1, 2.2, 2.3, 2.4]
    MOI.add_constraint.(model, v, MOI.GreaterThan.(l))
    MOI.add_constraint.(model, v, MOI.LessThan.(u))
    MOI.set.(model, MOI.VariablePrimalStart(), v, start)
    lb, ub = [25.0, 40.0], [Inf, 40.0]
    evaluator = MOI.Test.HS071(true)
    block_data = MOI.NLPBlockData(MOI.NLPBoundsPair.(lb, ub), evaluator, true)
    MOI.set(model, MOI.NLPBlock(), block_data)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    n = NL.Model()
    @test MOI.supports(n, MOI.NLPBlock())
    @test MOI.supports(n, MOI.ObjectiveSense())
    @test MOI.is_empty(n)
    MOI.copy_to(n, model)
    @test !MOI.is_empty(n)
    @test n.sense == MOI.MIN_SENSE
    @test n.f == NL._NLExpr(MOI.objective_expr(evaluator))
    _test_nlexpr(
        n.g[1].expr,
        [NL.OPMULT, v[1], NL.OPMULT, v[2], NL.OPMULT, v[3], v[4]],
        Dict(v .=> 0.0),
        0.0,
    )
    @test n.g[1].lower == 25.0
    @test n.g[1].upper == Inf
    @test n.g[1].opcode == 2
    _test_nlexpr(
        n.g[2].expr,
        [
            NL.OPSUMLIST,
            4,
            NL.OPPOW,
            v[1],
            2,
            NL.OPPOW,
            v[2],
            2,
            NL.OPPOW,
            v[3],
            2,
            NL.OPPOW,
            v[4],
            2,
        ],
        Dict(v .=> 0.0),
        0.0,
    )
    @test n.g[2].lower == 40.0
    @test n.g[2].upper == 40.0
    @test n.g[2].opcode == 4
    @test length(n.h) == 0
    for i in 1:4
        @test n.x[v[i]].lower == l[i]
        @test n.x[v[i]].upper == u[i]
        @test n.x[v[i]].type == NL._CONTINUOUS
        @test n.x[v[i]].jacobian_count == 2
        @test n.x[v[i]].in_nonlinear_constraint
        @test n.x[v[i]].in_nonlinear_objective
        @test 0 <= n.x[v[i]].order <= 3
    end
    @test length(n.types[1]) == 4
    @test sprint(write, n) == """
    g3 1 1 0
     4 2 1 0 1 0
     2 1
     0 0
     4 4 4
     0 0 0 1
     0 0 0 0 0
     8 4
     0 0
     0 0 0 0 0
    C0
    o2
    v0
    o2
    v1
    o2
    v2
    v3
    C1
    o54
    4
    o5
    v0
    n2
    o5
    v1
    n2
    o5
    v2
    n2
    o5
    v3
    n2
    O0 0
    o0
    o2
    v0
    o2
    v3
    o54
    3
    v0
    v1
    v2
    v2
    x4
    0 2.1
    1 2.2
    2 2.3
    3 2.4
    r
    2 25
    4 40
    b
    0 1.1 5.1
    0 1.2 5.2
    0 1.3 5.3
    0 1.4 5.4
    k3
    2
    4
    6
    J0 4
    0 0
    1 0
    2 0
    3 0
    J1 4
    0 0
    1 0
    2 0
    3 0
    G0 4
    0 0
    1 0
    2 0
    3 0
    """
    return
end

function test_nlmodel_hs071_linear_obj()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    v = MOI.add_variables(model, 4)
    l = [1.1, 1.2, 1.3, 1.4]
    u = [5.1, 5.2, 5.3, 5.4]
    start = [2.1, 2.2, 2.3, 2.4]
    MOI.add_constraint.(model, v, MOI.GreaterThan.(l))
    MOI.add_constraint.(model, v, MOI.LessThan.(u))
    MOI.add_constraint(model, v[2], MOI.ZeroOne())
    MOI.add_constraint(model, v[3], MOI.Integer())
    MOI.set.(model, MOI.VariablePrimalStart(), v, start)
    lb, ub = [25.0, 40.0], [Inf, 40.0]
    evaluator = MOI.Test.HS071(true)
    block_data = MOI.NLPBlockData(MOI.NLPBoundsPair.(lb, ub), evaluator, false)
    MOI.set(model, MOI.NLPBlock(), block_data)
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(l, v), 2.0)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    n = NL.Model()
    @test MOI.supports(n, MOI.VariablePrimalStart(), MOI.VariableIndex)
    @test MOI.supports(n, MOI.ObjectiveFunction{typeof(f)}())
    index_map = MOI.copy_to(n, model)
    @test n.sense == MOI.MAX_SENSE
    @test n.f == NL._NLExpr(f)
    _test_nlexpr(
        n.g[1].expr,
        [NL.OPMULT, v[1], NL.OPMULT, v[2], NL.OPMULT, v[3], v[4]],
        Dict(v .=> 0.0),
        0.0,
    )
    @test n.g[1].lower == 25.0
    @test n.g[1].upper == Inf
    @test n.g[1].opcode == 2
    _test_nlexpr(
        n.g[2].expr,
        [
            NL.OPSUMLIST,
            4,
            NL.OPPOW,
            v[1],
            2,
            NL.OPPOW,
            v[2],
            2,
            NL.OPPOW,
            v[3],
            2,
            NL.OPPOW,
            v[4],
            2,
        ],
        Dict(v .=> 0.0),
        0.0,
    )
    @test n.g[2].lower == 40.0
    @test n.g[2].upper == 40.0
    @test n.g[2].opcode == 4
    @test length(n.h) == 0
    types = [NL._CONTINUOUS, NL._BINARY, NL._INTEGER, NL._CONTINUOUS]
    u[2] = 1.0
    for i in 1:4
        @test n.x[v[i]].start == start[i]
        @test n.x[v[i]].lower == l[i]
        @test n.x[v[i]].upper == u[i]
        @test n.x[v[i]].type == types[i]
        @test n.x[v[i]].jacobian_count == 2
        @test n.x[v[i]].in_nonlinear_constraint
        @test !n.x[v[i]].in_nonlinear_objective
        @test 0 <= n.x[v[i]].order <= 3
    end
    @test length(n.types[3]) == 2
    @test length(n.types[4]) == 2
    @test v[1] in n.types[3]
    @test v[2] in n.types[4]
    @test v[3] in n.types[4]
    @test v[4] in n.types[3]
    @test sprint(write, n) == """
    g3 1 1 0
     4 2 1 0 1 0
     2 1
     0 0
     4 0 0
     0 0 0 1
     0 0 0 2 0
     8 4
     0 0
     0 0 0 0 0
    C0
    o2
    v0
    o2
    v2
    o2
    v3
    v1
    C1
    o54
    4
    o5
    v0
    n2
    o5
    v2
    n2
    o5
    v3
    n2
    o5
    v1
    n2
    O0 1
    n2
    x4
    0 2.1
    1 2.4
    2 2.2
    3 2.3
    r
    2 25
    4 40
    b
    0 1.1 5.1
    0 1.4 5.4
    0 1.2 1
    0 1.3 5.3
    k3
    2
    4
    6
    J0 4
    0 0
    1 0
    2 0
    3 0
    J1 4
    0 0
    1 0
    2 0
    3 0
    G0 4
    0 1.1
    1 1.4
    2 1.2
    3 1.3
    """
    return
end

function test_nlmodel_linear_quadratic()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variables(model, 4)
    MOI.add_constraint.(model, x, MOI.GreaterThan(0.0))
    MOI.add_constraint.(model, x, MOI.LessThan(2.0))
    MOI.add_constraint(model, x[2], MOI.ZeroOne())
    MOI.add_constraint(model, x[3], MOI.Integer())
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x[2:4]), 2.0)
    g = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(2.0, x[1], x[2])],
        [MOI.ScalarAffineTerm(1.0, x[1])],
        3.0,
    )
    h = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(1.0, x[1], x[2])],
        [MOI.ScalarAffineTerm(1.0, x[3])],
        0.0,
    )
    MOI.add_constraint(model, f, MOI.Interval(1.0, 10.0))
    MOI.add_constraint(model, g, MOI.LessThan(5.0))
    MOI.set(model, MOI.ObjectiveFunction{typeof(h)}(), h)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    n = NL.Model()
    MOI.copy_to(n, model)
    @test n.sense == MOI.MAX_SENSE
    @test n.f == NL._NLExpr(h)
    terms = [NL.OPMULT, 2.0, NL.OPMULT, x[1], x[2]]
    _test_nlexpr(n.g[1].expr, terms, Dict(x[1] => 1.0, x[2] => 0.0), 3.0)
    @test n.g[1].opcode == 1
    @test n.g[1].lower == -Inf
    @test n.g[1].upper == 5.0
    @test n.h[1].expr == NL._NLExpr(f)
    @test n.h[1].opcode == 0
    @test n.h[1].lower == 1.0
    @test n.h[1].upper == 10.0
    @test n.types[1] == [x[1]]  # Continuous in both
    @test n.types[2] == [x[2]]  # Discrete in both
    @test n.types[6] == [x[3]]  # Discrete in objective only
    @test n.types[7] == [x[4]]  # Continuous in linear
    @test sprint(write, n) == """
    g3 1 1 0
     4 2 1 1 0 0
     1 1
     0 0
     2 3 2
     0 0 0 1
     0 0 1 0 1
     5 3
     0 0
     0 0 0 0 0
    C0
    o0
    n3
    o2
    n2
    o2
    v0
    v1
    C1
    n2
    O0 1
    o2
    v0
    v1
    x4
    0 0
    1 0
    2 0
    3 0
    r
    1 5
    0 1 10
    b
    0 0 2
    0 0 1
    0 0 2
    0 0 2
    k3
    1
    3
    4
    J0 2
    0 1
    1 0
    J1 3
    1 1
    2 1
    3 1
    G0 3
    0 0
    1 0
    2 1
    """
    return
end

function test_nlmodel_quadratic_interval()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    g = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(2.0, x, x)],
        [MOI.ScalarAffineTerm(1.0, x)],
        3.0,
    )
    MOI.add_constraint(model, g, MOI.Interval(1.0, 10.0))
    n = NL.Model()
    MOI.copy_to(n, model)
    @test sprint(write, n) == """
    g3 1 1 0
     1 1 1 1 0 0
     1 1
     0 0
     1 0 0
     0 0 0 1
     0 0 0 0 0
     1 0
     0 0
     0 0 0 0 0
    C0
    o0
    n3
    o2
    v0
    v0
    O0 0
    n0
    x1
    0 0
    r
    0 1 10
    b
    3
    k0
    J0 1
    0 1
    """
    return
end

function test_nlmodel_scalar_nonlinear_function_model()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    g = MOI.ScalarNonlinearFunction(
        :+,
        Any[
            MOI.ScalarNonlinearFunction(:*, Any[x, x]),
            MOI.ScalarNonlinearFunction(:*, Any[1.0, x]),
            3.0,
        ],
    )
    MOI.add_constraint(model, g, MOI.Interval(1.0, 10.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction}(),
        MOI.ScalarNonlinearFunction(:log, Any[x]),
    )
    n = NL.Model()
    MOI.copy_to(n, model)
    @test sprint(write, n) == """
    g3 1 1 0
     1 1 1 1 0 0
     1 1
     0 0
     1 1 1
     0 0 0 1
     0 0 0 0 0
     1 1
     0 0
     0 0 0 0 0
    C0
    o54
    3
    o2
    v0
    v0
    o2
    n1
    v0
    n3
    O0 1
    o43
    v0
    x1
    0 0
    r
    0 1 10
    b
    3
    k0
    J0 1
    0 0
    G0 1
    0 0
    """
    return
end

function test_read_nlmodel_nlpblock_model()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    nlp = MOI.Nonlinear.Model()
    MOI.Nonlinear.add_constraint(nlp, :(log($x)), MOI.LessThan(1.0))
    MOI.Nonlinear.add_constraint(nlp, :(log($x)), MOI.GreaterThan(2.0))
    MOI.Nonlinear.add_constraint(nlp, :(log($x)), MOI.EqualTo(3.0))
    MOI.Nonlinear.add_constraint(nlp, :(log($x)), MOI.Interval(4.0, 5.0))
    evaluator =
        MOI.Nonlinear.Evaluator(nlp, MOI.Nonlinear.SparseReverseMode(), [x])
    block = MOI.NLPBlockData(evaluator)
    MOI.set(model, MOI.NLPBlock(), block)
    src = NL.Model()
    MOI.copy_to(src, model)
    text = sprint(write, src)
    # Now test reading back in
    dest = NL.Model(; use_nlp_block = true)
    io = IOBuffer(text)
    MOI.read!(io, dest)
    nlp_block = MOI.get(dest, MOI.NLPBlock())
    @test length(nlp_block.constraint_bounds) == 4
    @test nlp_block.constraint_bounds == [
        MOI.NLPBoundsPair(-Inf, 1.0),
        MOI.NLPBoundsPair(2.0, Inf),
        MOI.NLPBoundsPair(3.0, 3.0),
        MOI.NLPBoundsPair(4.0, 5.0),
    ]
    return
end

function test_read_nlmodel_scalar_nonlinear_function_model()
    function build_model(x)
        objective = MOI.ScalarNonlinearFunction(:log, Any[x])
        g = MOI.ScalarNonlinearFunction(
            :+,
            Any[
                MOI.ScalarNonlinearFunction(:*, Any[x, x]),
                MOI.ScalarNonlinearFunction(:*, Any[1.0, x]),
                3.0,
            ],
        )
        constraints = [
            g => MOI.Interval(1.0, 10.0),
            MOI.ScalarNonlinearFunction(:*, Any[x, x]) => MOI.EqualTo(0.0),
            MOI.ScalarNonlinearFunction(:/, Any[1, x]) => MOI.LessThan(1.0),
            MOI.ScalarNonlinearFunction(:sin, Any[x]) =>
                MOI.GreaterThan(0.0),
        ]
        return objective, constraints
    end
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    obj, cons = build_model(x)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
    for (f, s) in cons
        MOI.add_constraint(model, f, s)
    end
    src = NL.Model()
    MOI.copy_to(src, model)
    text = sprint(write, src)
    # Now test reading back in
    dest = NL.Model(; use_nlp_block = false)
    io = IOBuffer(text)
    MOI.read!(io, dest)
    v = MOI.get(dest, MOI.ListOfVariableIndices())
    @test length(v) == 1
    x = v[1]
    obj, cons = build_model(x)
    @test isapprox(MOI.get(dest, MOI.ObjectiveFunction{typeof(obj)}()), obj)
    for (f, s) in cons
        F, S = typeof(f), typeof(s)
        indices = MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        @test length(indices) == 1
        @test isapprox(MOI.get(model, MOI.ConstraintFunction(), indices[1]), f)
        @test MOI.get(model, MOI.ConstraintSet(), indices[1]) == s
    end
    return
end

function test_read_nlmodel_scalar_nonlinear_function_model_no_objective()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    MOI.add_constraint(
        model,
        MOI.ScalarNonlinearFunction(:log, Any[x]),
        MOI.LessThan(1.0),
    )
    src = NL.Model()
    MOI.copy_to(src, model)
    text = sprint(write, src)
    # Now test reading back in
    dest = NL.Model(; use_nlp_block = false)
    io = IOBuffer(text)
    MOI.read!(io, dest)
    v = MOI.get(dest, MOI.ListOfVariableIndices())
    @test length(v) == 1
    x = v[1]
    @test !in(
        MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction}(),
        MOI.get(model, MOI.ListOfModelAttributesSet()),
    )
    return
end

function test_eval_singlevariable()
    x = MOI.VariableIndex(1)
    f = NL._NLExpr(x)
    @test NL._evaluate(f, Dict(x => 1.2)) == 1.2
end

function test_eval_scalaraffine()
    x = MOI.VariableIndex.(1:3)
    f = NL._NLExpr(MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 4.0))
    @test NL._evaluate(f, Dict(x[i] => Float64(i) for i in 1:3)) == 10.0
end

function test_eval_scalarquadratic()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(2.0, x, x)],
        [MOI.ScalarAffineTerm(1.1, x)],
        3.0,
    )
    @test NL._evaluate(NL._NLExpr(f), Dict(x => 1.1)) == 5.42
end

function test_eval_unary_addition()
    x = MOI.VariableIndex(1)
    @test NL._evaluate(NL._NLExpr(:(+$x)), Dict(x => 1.1)) == 1.1
end

function test_eval_binary_addition()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    @test NL._evaluate(NL._NLExpr(:($x + $y)), Dict(x => 1.1, y => 2.2)) ≈ 3.3
end

function test_eval_nary_addition()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    @test NL._evaluate(NL._NLExpr(:($x + $y + 1.0)), Dict(x => 1.1, y => 2.2)) ≈
          4.3
end

function test_eval_unary_subtraction()
    x = MOI.VariableIndex(1)
    @test NL._evaluate(NL._NLExpr(:(-$x)), Dict(x => 1.1)) == -1.1
end

function test_eval_nary_multiplication()
    x = MOI.VariableIndex(1)
    @test NL._evaluate(NL._NLExpr(:($x * $x * 2.0)), Dict(x => 1.1)) ≈ 2.42
end

function test_eval_unary_specialcases()
    x = MOI.VariableIndex(1)
    S = [:acoth, :asec, :acsc, :acot, :asecd, :acscd, :acotd]
    for (k, v) in NL._UNARY_SPECIAL_CASES
        expr = NL._NLExpr(:($k($x)))
        xv = k in S ? 1.49 : 0.49
        @test NL._evaluate(expr, Dict(x => xv)) ≈ getfield(Main, k)(xv)
    end
end

function test_eval_binary_specialcases()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    for (k, v) in NL._BINARY_SPECIAL_CASES
        expr = NL._NLExpr(:($k($x, $y)))
        target = getfield(Main, k)(1.0, 2.0)
        @test NL._evaluate(expr, Dict(x => 1.0, y => 2.0)) ≈ target
    end
end

function test_evaluate_domain_error()
    x = MOI.VariableIndex(1)
    expr = NL._NLExpr(:(ifelse($x > 0, log($x), 0.0)))
    @test NL._evaluate(expr, Dict(x => 1.1)) == log(1.1)
    @test NL._evaluate(expr, Dict(x => 0.0)) == 0.0
    expr = NL._NLExpr(:(ifelse($x > 0, $x^1.5, -(-$x)^1.5)))
    @test NL._evaluate(expr, Dict(x => 1.1)) ≈ 1.1^1.5
    @test NL._evaluate(expr, Dict(x => -1.1)) ≈ -(1.1^1.5)
    return
end

"""
    test_issue_79()

Test the problem

    min (z - 0.5)^2 = z^2 - z + 1/4
    s.t. x * z <= 0
         z ∈ {0, 1}
"""
function test_issue_79()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    z = MOI.add_variable(model)
    MOI.add_constraint(model, z, MOI.ZeroOne())
    f = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(1.0, z, z)],
        [MOI.ScalarAffineTerm(-1.0, z)],
        0.25,
    )
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.add_constraint(
        model,
        MOI.ScalarQuadraticFunction(
            [MOI.ScalarQuadraticTerm(1.0, x, z)],
            MOI.ScalarAffineTerm{Float64}[],
            0.0,
        ),
        MOI.LessThan(0.0),
    )
    n = NL.Model()
    MOI.copy_to(n, model)
    # x is continuous in a nonlinear constraint             [Priority 3]
    # z is discrete in a nonlinear constraint and objective [Priority 2]
    @test n.x[x].order == 1
    @test n.x[z].order == 0
end

function test_empty_constraint()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    ci = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{Float64}[], 1.0),
        MOI.LessThan(2.0),
    )
    n = NL.Model()
    mapping = MOI.copy_to(n, model)
    @test haskey(mapping, ci)
end

function test_writing_free_constraint()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.add_constraint(model, f, MOI.Interval(-Inf, Inf))
    n = NL.Model()
    _ = MOI.copy_to(n, model)
    @test occursin("r\n3\nb", sprint(write, n))
    return
end

function test_malformed_constraint_error()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{Float64}[], 1.0),
        MOI.LessThan(0.0),
    )
    n = NL.Model()
    @test_throws ErrorException MOI.copy_to(n, model)
end

struct NoExprGraph <: MOI.AbstractNLPEvaluator end
MOI.features_available(::NoExprGraph) = Symbol[]

function test_noexpr_graph()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    block_data = MOI.NLPBlockData(MOI.NLPBoundsPair[], NoExprGraph(), false)
    MOI.set(model, MOI.NLPBlock(), block_data)
    n = NL.Model()
    @test_throws ErrorException MOI.copy_to(n, model)
end

function test_Name()
    model = NL.Model()
    @test MOI.supports(model, MOI.Name())
    MOI.set(model, MOI.Name(), "MyModel")
    @test MOI.get(model, MOI.Name()) == "MyModel"
end

function test_SolverName()
    model = NL.Model()
    @test MOI.get(model, MOI.SolverName()) == "AmplNLWriter"
end

function test_show()
    @test sprint(summary, NL.Model()) == "MOI.FileFormats.NL.Model"
    return
end

function test_linear_constraint_types()
    model = MOI.Utilities.Model{Float64}()
    n = NL.Model()
    y = MOI.add_variables(model, 3)
    MOI.add_constraint(model, y[1], MOI.ZeroOne())
    MOI.add_constraint(model, y[2], MOI.Integer())
    @test MOI.supports_constraint(n, MOI.VariableIndex, MOI.ZeroOne)
    @test MOI.supports_constraint(n, MOI.VariableIndex, MOI.Integer)
    for set in [
        MOI.GreaterThan(0.0),
        MOI.LessThan(1.0),
        MOI.EqualTo(2.0),
        MOI.Interval(3.0, 4.0),
    ]
        x = MOI.add_variable(model)
        @test MOI.supports_constraint(n, MOI.VariableIndex, typeof(set))
        @test MOI.supports_constraint(
            n,
            MOI.ScalarAffineFunction{Float64},
            typeof(set),
        )
        MOI.add_constraint(model, x, set)
        MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
            set,
        )
    end
    map = MOI.copy_to(n, model)
    @test length(n.g) == 0
    @test length(n.h) == 4
    @test length(n.x) == 7
    @test n.order == [
        MOI.VariableIndex(3),
        MOI.VariableIndex(4),
        MOI.VariableIndex(5),
        MOI.VariableIndex(6),
        MOI.VariableIndex(7),
        MOI.VariableIndex(1),
        MOI.VariableIndex(2),
    ]
    @test sprint(Base.write, n) == """
    g3 1 1 0
     7 4 1 1 1 0
     0 1
     0 0
     0 0 0
     0 0 0 1
     1 1 0 0 0
     4 0
     0 0
     0 0 0 0 0
    C0
    n0
    C1
    n0
    C2
    n0
    C3
    n0
    O0 0
    n0
    x7
    0 0
    1 0
    2 0
    3 0
    4 0
    5 0
    6 0
    r
    4 2
    2 0
    1 1
    0 3 4
    b
    3
    2 0
    1 1
    4 2
    0 3 4
    0 0 1
    3
    k6
    0
    1
    2
    3
    4
    4
    J0 1
    3 1
    J1 1
    1 1
    J2 1
    2 1
    J3 1
    4 1
    """
    return
end

function test_empty()
    model = MOI.Utilities.Model{Float64}()
    y = MOI.add_variables(model, 3)
    n = NL.Model()
    map = MOI.copy_to(n, model)
    @test !MOI.is_empty(n)
    MOI.empty!(n)
    @test MOI.is_empty(n)
end

function test_moi()
    MOI.Test.runtests(
        NL.Model(),
        MOI.Test.Config(exclude = Any[MOI.optimize!]),
        include = ["test_model_copy_to_Unsupported"],
    )
    return
end

function test_float_rounding()
    @test NL._str(1.0) == "1"
    @test NL._str(1.2) == "1.2"
    @test NL._str(1e50) == "1.0e50"
    @test NL._str(-1e50) == "-1.0e50"
    return
end

function test_attribute_error()
    model = NL.Model()
    attr = MOI.ObjectiveSense()
    @test_throws(
        ErrorException(
            "Unable get attribute $attr because `NL.Model` only supports " *
            "getting attributes when the model was read from a file.",
        ),
        MOI.get(model, attr),
    )
    return
end

function test_infinite_interval()
    model = NL.Model()
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(src)
    MOI.add_constraint(src, 1.0 * x, MOI.Interval(-Inf, Inf))
    MOI.add_constraint(src, 1.0 * x, MOI.Interval(-Inf, 1.0))
    MOI.add_constraint(src, 1.0 * x, MOI.Interval(2.0, Inf))
    MOI.add_constraint(src, 1.0 * x, MOI.Interval(3.0, 4.0))
    MOI.copy_to(model, src)
    @test sprint(write, model) == """
g3 1 1 0
 1 4 1 1 0 0
 0 1
 0 0
 0 0 0
 0 0 0 1
 0 0 0 0 0
 4 0
 0 0
 0 0 0 0 0
C0
n0
C1
n0
C2
n0
C3
n0
O0 0
n0
x1
0 0
r
3
1 1
2 2
0 3 4
b
3
k0
J0 1
0 1
J1 1
0 1
J2 1
0 1
J3 1
0 1
"""
    return
end

function test_copy_name_issue_2445()
    src = MOI.Utilities.Model{Float64}()
    MOI.set(src, MOI.Name(), "TestModel")
    dest = NL.Model()
    MOI.copy_to(dest, src)
    @test MOI.get(dest, MOI.Name()) == "TestModel"
    return
end

function test_unsupported_variable_types()
    for set in (
        MOI.Parameter(2.0),
        MOI.Semicontinuous(2.0, 3.0),
        MOI.Semiinteger(2.0, 3.0),
    )
        src = MOI.Utilities.Model{Float64}()
        MOI.add_constrained_variable(src, set)
        dest = NL.Model()
        @test_throws MOI.UnsupportedConstraint MOI.copy_to(dest, src)
    end
    return
end

function test_unsupported_objectives()
    model = NL.Model()
    for (F, ret) in [
        MOI.VariableIndex => true,
        MOI.ScalarAffineFunction{Float64} => true,
        MOI.ScalarQuadraticFunction{Float64} => true,
        MOI.ScalarNonlinearFunction => true,
        MOI.VectorOfVariables => false,
        MOI.VectorAffineFunction{Float64} => false,
        MOI.VectorQuadraticFunction{Float64} => false,
        MOI.VectorNonlinearFunction => false,
    ]
        @test MOI.supports(model, MOI.ObjectiveFunction{F}()) == ret
    end
    return
end

end

TestNLModel.runtests()

include("read.jl")
include("sol.jl")

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ObjectiveContainer{T}

A helper struct to simplify the handling of objective functions in
Utilities.Model.
"""
mutable struct ObjectiveContainer{T} <: MOI.ModelLike
    is_sense_set::Bool
    sense::MOI.OptimizationSense
    is_function_set::Bool
    single_variable::Union{Nothing,MOI.VariableIndex}
    scalar_affine::Union{Nothing,MOI.ScalarAffineFunction{T}}
    scalar_quadratic::Union{Nothing,MOI.ScalarQuadraticFunction{T}}
    scalar_nonlinear::Union{Nothing,MOI.ScalarNonlinearFunction}
    vector_variables::Union{Nothing,MOI.VectorOfVariables}
    vector_affine::Union{Nothing,MOI.VectorAffineFunction{T}}
    vector_quadratic::Union{Nothing,MOI.VectorQuadraticFunction{T}}
    vector_nonlinear::Union{Nothing,MOI.VectorNonlinearFunction}
    function ObjectiveContainer{T}() where {T}
        o = new{T}()
        MOI.empty!(o)
        return o
    end
end

function MOI.empty!(o::ObjectiveContainer{T}) where {T}
    o.is_sense_set = false
    o.sense = MOI.FEASIBILITY_SENSE
    o.is_function_set = false
    o.single_variable = nothing
    o.scalar_affine = nothing
    o.scalar_quadratic = nothing
    o.scalar_nonlinear = nothing
    o.vector_variables = nothing
    o.vector_affine = nothing
    o.vector_quadratic = nothing
    o.vector_nonlinear = nothing
    return
end

function MOI.is_empty(o::ObjectiveContainer)
    return !o.is_sense_set && !o.is_function_set
end

###
### ObjectiveSense
###

MOI.supports(::ObjectiveContainer, ::MOI.ObjectiveSense) = true

MOI.get(o::ObjectiveContainer, ::MOI.ObjectiveSense) = o.sense

function MOI.set(o::ObjectiveContainer, ::MOI.ObjectiveSense, value)
    if value == MOI.FEASIBILITY_SENSE
        MOI.empty!(o)
    end
    o.is_sense_set = true
    o.sense = value
    return
end

###
### ObjectiveFunctionType
###

function MOI.get(
    o::ObjectiveContainer{T},
    ::MOI.ObjectiveFunctionType,
) where {T}
    if o.scalar_affine !== nothing
        return MOI.ScalarAffineFunction{T}
    elseif o.single_variable !== nothing
        return MOI.VariableIndex
    elseif o.scalar_quadratic !== nothing
        return MOI.ScalarQuadraticFunction{T}
    elseif o.scalar_nonlinear !== nothing
        return MOI.ScalarNonlinearFunction
    elseif o.vector_variables !== nothing
        return MOI.VectorOfVariables
    elseif o.vector_affine !== nothing
        return MOI.VectorAffineFunction{T}
    elseif o.vector_quadratic !== nothing
        return MOI.VectorQuadraticFunction{T}
    elseif o.vector_nonlinear !== nothing
        return MOI.VectorNonlinearFunction
    end
    # The default if no objective is set.
    return MOI.ScalarAffineFunction{T}
end

###
### ObjectiveFunction
###

function MOI.supports(
    ::ObjectiveContainer{T},
    ::MOI.ObjectiveFunction{
        <:Union{
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{T},
            MOI.ScalarQuadraticFunction{T},
            MOI.ScalarNonlinearFunction,
            MOI.VectorOfVariables,
            MOI.VectorAffineFunction{T},
            MOI.VectorQuadraticFunction{T},
            MOI.VectorNonlinearFunction,
        },
    },
) where {T}
    return true
end

function MOI.get(
    o::ObjectiveContainer{T},
    attr::MOI.ObjectiveFunction{F},
) where {
    T,
    F<:Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction,
        MOI.ScalarQuadraticFunction,
        MOI.ScalarNonlinearFunction,
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction,
        MOI.VectorQuadraticFunction,
        MOI.VectorNonlinearFunction,
    },
}
    if o.scalar_affine !== nothing
        return convert(F, something(o.scalar_affine))
    elseif o.single_variable !== nothing
        return convert(F, something(o.single_variable))
    elseif o.scalar_quadratic !== nothing
        return convert(F, something(o.scalar_quadratic))
    elseif o.scalar_nonlinear !== nothing
        return convert(F, something(o.scalar_nonlinear))
    elseif o.vector_variables !== nothing
        return convert(F, something(o.vector_variables))
    elseif o.vector_affine !== nothing
        return convert(F, something(o.vector_affine))
    elseif o.vector_quadratic !== nothing
        return convert(F, something(o.vector_quadratic))
    elseif o.vector_nonlinear !== nothing
        return convert(F, something(o.vector_nonlinear))
    end
    # The default if no objective is set.
    return convert(F, zero(MOI.ScalarAffineFunction{T}))
end

function _empty_keeping_sense(o::ObjectiveContainer)
    sense, is_sense_set = o.sense, o.is_sense_set
    MOI.empty!(o)
    o.sense, o.is_sense_set = sense, is_sense_set
    return
end

function MOI.set(
    o::ObjectiveContainer,
    ::MOI.ObjectiveFunction{MOI.VariableIndex},
    f::MOI.VariableIndex,
)
    _empty_keeping_sense(o)
    o.is_function_set = true
    o.single_variable = copy(f)
    return
end

function MOI.set(
    o::ObjectiveContainer{T},
    ::MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}},
    f::MOI.ScalarAffineFunction{T},
) where {T}
    _empty_keeping_sense(o)
    o.is_function_set = true
    o.scalar_affine = copy(f)
    return
end

function MOI.set(
    o::ObjectiveContainer{T},
    ::MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}},
    f::MOI.ScalarQuadraticFunction{T},
) where {T}
    _empty_keeping_sense(o)
    o.is_function_set = true
    o.scalar_quadratic = copy(f)
    return
end

function MOI.set(
    o::ObjectiveContainer,
    ::MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction},
    f::MOI.ScalarNonlinearFunction,
)
    _empty_keeping_sense(o)
    o.is_function_set = true
    o.scalar_nonlinear = copy(f)
    return
end

function MOI.set(
    o::ObjectiveContainer,
    ::MOI.ObjectiveFunction{MOI.VectorOfVariables},
    f::MOI.VectorOfVariables,
)
    _empty_keeping_sense(o)
    o.is_function_set = true
    o.vector_variables = copy(f)
    return
end

function MOI.set(
    o::ObjectiveContainer{T},
    ::MOI.ObjectiveFunction{MOI.VectorAffineFunction{T}},
    f::MOI.VectorAffineFunction{T},
) where {T}
    _empty_keeping_sense(o)
    o.is_function_set = true
    o.vector_affine = copy(f)
    return
end

function MOI.set(
    o::ObjectiveContainer{T},
    ::MOI.ObjectiveFunction{MOI.VectorQuadraticFunction{T}},
    f::MOI.VectorQuadraticFunction{T},
) where {T}
    _empty_keeping_sense(o)
    o.is_function_set = true
    o.vector_quadratic = copy(f)
    return
end

function MOI.set(
    o::ObjectiveContainer,
    ::MOI.ObjectiveFunction{MOI.VectorNonlinearFunction},
    f::MOI.VectorNonlinearFunction,
)
    _empty_keeping_sense(o)
    o.is_function_set = true
    o.vector_nonlinear = copy(f)
    return
end

###
### MOI.ListOfModelAttributesSet
###

function MOI.get(o::ObjectiveContainer, ::MOI.ListOfModelAttributesSet)
    ret = MOI.AbstractModelAttribute[]
    if o.is_sense_set
        push!(ret, MOI.ObjectiveSense())
    end
    if o.is_function_set
        F = MOI.get(o, MOI.ObjectiveFunctionType())
        push!(ret, MOI.ObjectiveFunction{F}())
    end
    return ret
end

###
### MOI.modify
###

function MOI.modify(
    o::ObjectiveContainer{T},
    ::MOI.ObjectiveFunction,
    change::MOI.AbstractFunctionModification,
) where {T}
    if o.single_variable !== nothing
        throw(
            MOI.ModifyObjectiveNotAllowed(
                change,
                "Cannot modify objective when there is a " *
                "`VariableIndex` objective.",
            ),
        )
    elseif o.scalar_affine !== nothing
        o.scalar_affine = modify_function!(something(o.scalar_affine), change)
    elseif o.scalar_quadratic !== nothing
        o.scalar_quadratic =
            modify_function!(something(o.scalar_quadratic), change)
    elseif o.scalar_nonlinear !== nothing
        throw(
            MOI.ModifyObjectiveNotAllowed(
                change,
                "Cannot modify objective when there is a " *
                "`ScalarNonlinearFunction` objective.",
            ),
        )
    elseif o.vector_variables !== nothing
        throw(
            MOI.ModifyObjectiveNotAllowed(
                change,
                "Cannot modify objective when there is a " *
                "`VectorOfVariables` objective.",
            ),
        )
    elseif o.vector_quadratic !== nothing
        o.vector_quadratic =
            modify_function!(something(o.vector_quadratic), change)
    elseif o.vector_affine !== nothing
        o.vector_affine = modify_function!(something(o.vector_affine), change)
    elseif o.vector_nonlinear !== nothing
        throw(
            MOI.ModifyObjectiveNotAllowed(
                change,
                "Cannot modify objective when there is a " *
                "`VectorNonlinearFunction` objective.",
            ),
        )
    else
        # If no objective is set, modify a ScalarAffineFunction by default.
        f = zero(MOI.ScalarAffineFunction{T})
        o.scalar_affine = modify_function!(f, change)
        o.is_function_set = true
    end
    return
end

###
### MOI.delete
###

function MOI.delete(o::ObjectiveContainer, x::MOI.VariableIndex)
    if o.single_variable !== nothing
        if x == something(o.single_variable)
            _empty_keeping_sense(o)
        end
    elseif o.scalar_affine !== nothing
        o.scalar_affine = remove_variable(something(o.scalar_affine), x)
    elseif o.scalar_quadratic !== nothing
        o.scalar_quadratic = remove_variable(something(o.scalar_quadratic), x)
    elseif o.scalar_nonlinear !== nothing
        throw(
            MOI.DeleteNotAllowed(
                x,
                "Cannot delete variable when there is a " *
                "`ScalarNonlinearFunction` objective",
            ),
        )
    elseif o.vector_variables !== nothing
        o.vector_variables = remove_variable(something(o.vector_variables), x)
        if isempty(something(o.vector_variables).variables)
            _empty_keeping_sense(o)
        end
    elseif o.vector_affine !== nothing
        o.vector_affine = remove_variable(something(o.vector_affine), x)
    elseif o.vector_quadratic !== nothing
        o.vector_quadratic = remove_variable(something(o.vector_quadratic), x)
    elseif o.vector_nonlinear !== nothing
        throw(
            MOI.DeleteNotAllowed(
                x,
                "Cannot delete variable when there is a " *
                "`VectorNonlinearFunction` objective",
            ),
        )
    end
    return
end

function MOI.delete(o::ObjectiveContainer, x::Vector{MOI.VariableIndex})
    keep = v -> !(v in x)
    if o.single_variable !== nothing
        if something(o.single_variable) in x
            _empty_keeping_sense(o)
        end
    elseif o.scalar_affine !== nothing
        o.scalar_affine = filter_variables(keep, something(o.scalar_affine))
    elseif o.scalar_quadratic !== nothing
        o.scalar_quadratic =
            filter_variables(keep, something(o.scalar_quadratic))
    elseif o.scalar_nonlinear !== nothing
        throw(
            MOI.DeleteNotAllowed(
                first(x),
                "Cannot delete variable when there is a " *
                "`ScalarNonlinearFunction` objective",
            ),
        )
    elseif o.vector_variables !== nothing
        o.vector_variables =
            filter_variables(keep, something(o.vector_variables))
        if isempty(something(o.vector_variables).variables)
            _empty_keeping_sense(o)
        end
    elseif o.vector_affine !== nothing
        o.vector_affine = filter_variables(keep, something(o.vector_affine))
    elseif o.vector_quadratic !== nothing
        o.vector_quadratic =
            filter_variables(keep, something(o.vector_quadratic))
    elseif o.vector_nonlinear !== nothing
        throw(
            MOI.DeleteNotAllowed(
                first(x),
                "Cannot delete variable when there is a " *
                "`VectorNonlinearFunction` objective",
            ),
        )
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    IndicatorSOS1Bridge{T,S} <: Bridges.Constraint.AbstractBridge

`IndicatorSOS1Bridge` implements the following reformulation:

  * ``z \\implies {f(x) \\in S}`` into ``f(x) + y \\in S``,
    ``SOS1(y, z)``

!!! warning
    This bridge assumes that the solver supports [`MOI.SOS1{T}`](@ref)
    constraints in which one of the variables (``y``) is continuous.

## Source node

`IndicatorSOS1Bridge` supports:

  * [`MOI.VectorAffineFunction{T}`](@ref) in
    [`MOI.Indicator{MOI.ACTIVATE_ON_ONE,S}`](@ref)

## Target nodes

`IndicatorSOS1Bridge` creates:

  * [`MOI.ScalarAffineFunction{T}`](@ref) in `S`
  * [`MOI.VectorOfVariables`](@ref) in [`MOI.SOS1{T}`](@ref)
"""
struct IndicatorSOS1Bridge{T,S<:MOI.AbstractScalarSet} <: AbstractBridge
    slack::MOI.VariableIndex
    z::MOI.VariableIndex
    sos_index::MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.SOS1{T}}
    affine_index::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},S}
end

const IndicatortoSOS1{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{IndicatorSOS1Bridge{T},OT}

function bridge_constraint(
    ::Type{IndicatorSOS1Bridge{T,S}},
    model::MOI.ModelLike,
    f::MOI.VectorAffineFunction{T},
    s::MOI.Indicator{MOI.ACTIVATE_ON_ONE,S},
) where {T<:Real,S}
    f_scalars = MOI.Utilities.eachscalar(f)
    z = convert(MOI.VariableIndex, f_scalars[1])
    slack = MOI.add_variable(model)
    sos_index = MOI.add_constraint(
        model,
        MOI.VectorOfVariables([slack, z]),
        MOI.SOS1{T}([0.4, 0.6]),  # This weight vector is arbitrary
    )
    new_f = MOI.Utilities.operate(+, T, f_scalars[2], slack)
    affine_index = MOI.add_constraint(model, new_f, s.set)
    return IndicatorSOS1Bridge{T,S}(slack, z, sos_index, affine_index)
end

function MOI.supports_constraint(
    ::Type{<:IndicatorSOS1Bridge{T}},
    ::Type{MOI.VectorAffineFunction{T}},
    ::Type{<:MOI.Indicator{MOI.ACTIVATE_ON_ONE,<:MOI.AbstractScalarSet}},
) where {T}
    return true
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    b::IndicatorSOS1Bridge,
)
    set = MOI.get(model, attr, b.affine_index)
    return MOI.Indicator{MOI.ACTIVATE_ON_ONE}(set)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    b::IndicatorSOS1Bridge{T},
) where {T}
    f = MOI.get(model, attr, b.affine_index)
    terms = MOI.VectorAffineTerm{T}[
        MOI.VectorAffineTerm(2, t) for t in f.terms if t.variable != b.slack
    ]
    push!(terms, MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(one(T), b.z)))
    return MOI.VectorAffineFunction(terms, [zero(T), f.constant])
end

function MOI.delete(model::MOI.ModelLike, bridge::IndicatorSOS1Bridge)
    MOI.delete(model, bridge.sos_index)
    MOI.delete(model, bridge.affine_index)
    MOI.delete(model, bridge.slack)
    return
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:IndicatorSOS1Bridge},
)
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:IndicatorSOS1Bridge{T,S}},
) where {T,S}
    return Tuple{Type,Type}[
        (MOI.VectorOfVariables, MOI.SOS1{T}),
        (MOI.ScalarAffineFunction{T}, S),
    ]
end

function concrete_bridge_type(
    ::Type{<:IndicatorSOS1Bridge{T}},
    ::Type{MOI.VectorAffineFunction{T}},
    ::Type{MOI.Indicator{MOI.ACTIVATE_ON_ONE,S}},
) where {T,S}
    return IndicatorSOS1Bridge{T,S}
end

MOI.get(::IndicatorSOS1Bridge, ::MOI.NumberOfVariables)::Int64 = 1

function MOI.get(b::IndicatorSOS1Bridge, ::MOI.ListOfVariableIndices)
    return [b.slack]
end

function MOI.get(
    ::IndicatorSOS1Bridge,
    ::MOI.NumberOfConstraints{MOI.VectorOfVariables,<:MOI.SOS1},
)::Int64
    return 1
end

function MOI.get(
    ::IndicatorSOS1Bridge{T,S},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},S},
)::Int64 where {T,S}
    return 1
end

function MOI.get(
    b::IndicatorSOS1Bridge{T},
    ::MOI.ListOfConstraintIndices{MOI.VectorOfVariables,<:MOI.SOS1},
) where {T}
    return [b.sos_index]
end

function MOI.get(
    b::IndicatorSOS1Bridge{T,S},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},S},
) where {T,S}
    return [b.affine_index]
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::IndicatorSOS1Bridge,
)
    z = MOI.get(model, MOI.VariablePrimal(attr.result_index), bridge.z)
    w = MOI.get(model, MOI.VariablePrimal(attr.result_index), bridge.slack)
    f = MOI.get(model, attr, bridge.affine_index)
    return [z, f - w]
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    ::Type{IndicatorSOS1Bridge{T,S}},
) where {T,S}
    ci = MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},S}
    return MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex) &&
           MOI.supports(model, attr, ci)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::IndicatorSOS1Bridge,
)
    z = MOI.get(model, MOI.VariablePrimalStart(), bridge.z)
    w = MOI.get(model, MOI.VariablePrimalStart(), bridge.slack)
    f = MOI.get(model, attr, bridge.affine_index)
    if any(isnothing, (z, w, f))
        return nothing
    end
    return [z, f - w]
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::IndicatorSOS1Bridge{T},
    value,
) where {T}
    @assert length(value) == 2
    MOI.set(model, MOI.VariablePrimalStart(), bridge.z, value[1])
    MOI.set(model, MOI.VariablePrimalStart(), bridge.slack, zero(T))
    MOI.set(model, attr, bridge.affine_index, value[2])
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::IndicatorSOS1Bridge{T},
    ::Nothing,
) where {T}
    MOI.set(model, MOI.VariablePrimalStart(), bridge.z, nothing)
    MOI.set(model, MOI.VariablePrimalStart(), bridge.slack, nothing)
    MOI.set(model, attr, bridge.affine_index, nothing)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintBridge

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

struct DummyBridge <: MOI.Bridges.Constraint.AbstractBridge end

function test_AbstractBridge()
    model = MOI.Utilities.Model{Float64}()
    bridge = DummyBridge()
    @test !MOI.supports(model, MOI.ConstraintPrimalStart(), typeof(bridge))
    message = MOI.Bridges._attribute_error_message(
        MOI.ConstraintPrimalStart(),
        DummyBridge,
        "setting a value for",
    )
    @test_throws(
        MOI.UnsupportedAttribute(MOI.ConstraintPrimalStart(), message),
        MOI.set(model, MOI.ConstraintPrimalStart(), bridge, 1.0),
    )
    message = MOI.Bridges._attribute_error_message(
        MOI.ConstraintSet(),
        DummyBridge,
        "setting a value for",
    )
    @test_throws(
        MOI.SetAttributeNotAllowed(MOI.ConstraintSet(), message),
        MOI.set(model, MOI.ConstraintSet(), bridge, MOI.EqualTo(1.0)),
    )
    return
end

end  # module

TestConstraintBridge.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintScalarize

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_scalarize()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.Scalarize{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_$(F)_$(S)" for F in [
                "VectorOfVariables",
                "VectorAffineFunction",
                "VectorQuadraticFunction",
            ] for S in ["Nonnegatives", "Nonpositives", "Zeros"]
        ],
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 0.0, 2.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [-3, -1],
        )
    MOI.Test.test_conic_linear_VectorOfVariables(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.Zeros,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}, 0),
            (MOI.VariableIndex, MOI.GreaterThan{Float64}, 0),
        ),
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.Nonnegatives,
            }(),
        ),
    )
    func = MOI.get(bridged_mock, MOI.ConstraintFunction(), ci)
    MOI.delete(bridged_mock, func.variables[2])
    new_func = MOI.VectorOfVariables(func.variables[[1, 3]])
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) == new_func
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.Nonnegatives(2)
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        values = [1.0, 2.0]
        MOI.set(bridged_mock, attr, ci, values)
        @test MOI.get(bridged_mock, attr, ci) == values
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}, 0),
            (MOI.VariableIndex, MOI.GreaterThan{Float64}, 0),
        ),
    )
    MOI.empty!(bridged_mock)
    # VectorAffineFunction-in-Nonnegatives
    # VectorAffineFunction-in-Zeros
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 0.0, 2.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [0, 2, 0],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [-3, -1],
        )
    MOI.Test.test_conic_linear_VectorAffineFunction(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.Zeros,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        values = [1.0, -2.0]
        MOI.set(bridged_mock, attr, ci, values)
        @test MOI.get(bridged_mock, attr, ci) == values
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),
        ),
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.Nonnegatives,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        values = [1.0, -2.0, 3.0]
        MOI.set(bridged_mock, attr, ci, values)
        @test MOI.get(bridged_mock, attr, ci) == values
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),
        ),
    )
    MOI.empty!(bridged_mock)
    # Test setting VectorAffineFunction with nonzero constants
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [1.0, 0.75]),
    )
    MOI.Test.test_modification_func_vectoraffine_nonneg(bridged_mock, config)
    MOI.empty!(bridged_mock)
    # VectorOfVariables-in-Nonnegatives
    # VectorOfVariables-in-Nonpositives
    # VectorOfVariables-in-Zeros
    # VectorAffineFunction-in-Zeros
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [-4, -3, 16, 0],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [7, 2, -4],
        )
    MOI.Test.test_conic_linear_VectorOfVariables_2(bridged_mock, config)
    MOI.empty!(bridged_mock)
    # VectorAffineFunction-in-Nonnegatives
    # VectorAffineFunction-in-Nonpositives
    # VectorAffineFunction-in-Zeros
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [-4, -3, 16, 0],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [0],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [0],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [7, 2, -4, 7],
        )
    MOI.Test.test_conic_linear_VectorAffineFunction_2(bridged_mock, config)
    MOI.Test.test_constraint_ConstraintPrimalStart(
        bridged_mock,
        MOI.Test.Config(),
    )
    MOI.Test.test_constraint_ConstraintDualStart(
        bridged_mock,
        MOI.Test.Config(),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ScalarizeBridge,
        """
        variables: x
        [2.0 * x + -1.0] in Nonnegatives(1)
        [3.0 * x + 1.0] in Nonpositives(1)
        [4.0 * x + -5.0] in Zeros(1)
        """,
        """
        variables: x
        2.0 * x >= 1.0
        3.0 * x <= -1.0
        4.0 * x == 5.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ScalarizeBridge,
        """
        variables: x
        VectorNonlinearFunction([2.0 * x - 1.0]) in Nonnegatives(1)
        VectorNonlinearFunction([3.0 * x + 1.0]) in Nonpositives(1)
        VectorNonlinearFunction([4.0 * x - 5.0]) in Zeros(1)
        """,
        """
        variables: x
        ScalarNonlinearFunction(2.0 * x - 1.0) >= 0.0
        ScalarNonlinearFunction(3.0 * x + 1.0) <= 0.0
        ScalarNonlinearFunction(4.0 * x - 5.0) == 0.0
        """,
    )
    return
end

function test_VectorNonlinearFunction_mixed_type()
    # We can't use the standard runtests because ScalarNonlinearFunction does
    # not preserve f(x) ≈ (f(x) - g(x)) + g(x)
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.Scalarize{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    g = MOI.VectorNonlinearFunction(Any[1.0, x, 2.0*x-1.0, f])
    c = MOI.add_constraint(model, g, MOI.Nonnegatives(4))
    F, S = MOI.ScalarNonlinearFunction, MOI.GreaterThan{Float64}
    indices = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())
    @test length(indices) == 4
    inner_variables = MOI.get(inner, MOI.ListOfVariableIndices())
    @test length(inner_variables) == 1
    y = inner_variables[1]
    out = convert.(MOI.ScalarNonlinearFunction, Any[1.0, y, 2.0*y-1.0])
    push!(out, MOI.ScalarNonlinearFunction(:log, Any[y]))
    for (input, output) in zip(indices, out)
        @test ≈(MOI.get(inner, MOI.ConstraintFunction(), input), output)
    end
    new_g = MOI.VectorNonlinearFunction(Any[f, 2.0*x-1.0, 1.0, x])
    MOI.set(model, MOI.ConstraintFunction(), c, new_g)
    out = vcat(
        MOI.ScalarNonlinearFunction(:log, Any[y]),
        convert.(MOI.ScalarNonlinearFunction, Any[2.0*y-1.0, 1.0, y]),
    )
    for (input, output) in zip(indices, out)
        @test ≈(MOI.get(inner, MOI.ConstraintFunction(), input), output)
    end
    return
end

end  # module

TestConstraintScalarize.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    get_bounds(model::MOI.ModelLike, ::Type{T}, x::MOI.VariableIndex)

Return a tuple `(lb, ub)` of type `Tuple{T, T}`, where `lb` and `ub` are lower
 and upper bounds, respectively, imposed on `x` in `model`.
"""
function get_bounds(
    model::MOI.ModelLike,
    ::Type{T},
    x::F,
) where {T,F<:MOI.VariableIndex}
    # MOI.Interval
    c_interval = MOI.ConstraintIndex{F,MOI.Interval{T}}(x.value)
    if MOI.is_valid(model, c_interval)
        s_interval = MOI.get(model, MOI.ConstraintSet(), c_interval)
        return s_interval.lower, s_interval.upper
    end
    # MOI.EqualTo
    c_equal_to = MOI.ConstraintIndex{F,MOI.EqualTo{T}}(x.value)
    if MOI.is_valid(model, c_equal_to)
        s_equal_to = MOI.get(model, MOI.ConstraintSet(), c_equal_to)
        return s_equal_to.value, s_equal_to.value
    end
    # MOI.Semicontinuous
    c_semicontinuous = MOI.ConstraintIndex{F,MOI.Semicontinuous{T}}(x.value)
    if MOI.is_valid(model, c_semicontinuous)
        s_semicontinuous = MOI.get(model, MOI.ConstraintSet(), c_semicontinuous)
        l = min(zero(T), s_semicontinuous.lower)
        u = max(zero(T), s_semicontinuous.upper)
        return l, u
    end
    # MOI.Semiinteger
    c_si = MOI.ConstraintIndex{F,MOI.Semiinteger{T}}(x.value)
    if MOI.is_valid(model, c_si)
        si::MOI.Semiinteger{T} = MOI.get(model, MOI.ConstraintSet(), c_si)
        return min(zero(T), si.lower), max(zero(T), si.upper)
    end
    l, u = typemin(T), typemax(T)
    # MOI.LessThan
    c_less_than = MOI.ConstraintIndex{F,MOI.LessThan{T}}(x.value)
    if MOI.is_valid(model, c_less_than)
        s_less_than = MOI.get(model, MOI.ConstraintSet(), c_less_than)
        u = min(u, s_less_than.upper)
    end
    # MOI.GreaterThan
    c_greater_than = MOI.ConstraintIndex{F,MOI.GreaterThan{T}}(x.value)
    if MOI.is_valid(model, c_greater_than)
        s_greater_than = MOI.get(model, MOI.ConstraintSet(), c_greater_than)
        l = max(l, s_greater_than.lower)
    end
    return l, u
end

"""
    get_bounds(
        model::MOI.ModelLike,
        bounds_cache::Dict{MOI.VariableIndex,NTuple{2,T}},
        f::MOI.ScalarAffineFunction{T},
    ) where {T} --> Union{Nothing,NTuple{2,T}}

Return the lower and upper bound of `f` as a tuple. If the domain is not bounded,
return `nothing`.
"""
function get_bounds(
    model::MOI.ModelLike,
    bounds_cache::Dict{MOI.VariableIndex,NTuple{2,T}},
    f::MOI.ScalarAffineFunction{T},
) where {T}
    if !is_canonical(f)
        f = canonical(f)
    end
    lb = ub = f.constant
    for term in f.terms
        ret = get_bounds(model, bounds_cache, term.variable)
        if ret === nothing
            return nothing
        end
        if term.coefficient >= 0
            lb += term.coefficient * ret[1]
            ub += term.coefficient * ret[2]
        else
            lb += term.coefficient * ret[2]
            ub += term.coefficient * ret[1]
        end
    end
    return lb, ub
end

"""
    get_bounds(
        model::MOI.ModelLike,
        bounds_cache::Dict{MOI.VariableIndex,NTuple{2,T}},
        x::MOI.VariableIndex,
    ) where {T} --> Union{Nothing,NTuple{2,T}}

Return the lower and upper bound of `x` as a tuple. If the domain is not bounded,
return `nothing`.

Similar to `get_bounds(::MOI.ModelLike, ::Type{T}, ::MOI.VariableIndex)`, except
that the second argument is a cache which maps variables to their bounds and
avoids repeated lookups.
"""
function get_bounds(
    model::MOI.ModelLike,
    bounds_cache::Dict{MOI.VariableIndex,NTuple{2,T}},
    x::MOI.VariableIndex,
) where {T}
    if haskey(bounds_cache, x)
        return bounds_cache[x]
    end
    l, u = get_bounds(model, T, x)
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(x.value)
    if MOI.is_valid(model, ci)
        l, u = max(l, zero(T)), min(u, one(T))
    end
    if l == typemin(T) || u == typemax(T)
        return nothing
    end
    bounds_cache[x] = (l, u)
    return (l, u)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    Base.write(io::IO, model::FileFormats.MOF.Model)

Write `model` to `io` in the MathOptFormat file format.
"""
function Base.write(io::IO, model::Model)
    options = get_options(model)
    FileFormats.create_unique_names(model, warn = options.warn)
    variables, constraints = NamedTuple[], NamedTuple[]
    name_map = _write_variables(variables, model)
    objective = _write_nlpblock(constraints, model, name_map)
    has_scalar_nonlinear = false
    if objective === nothing
        objective, has_scalar_nonlinear = _write_objective(model, name_map)
    end
    has_scalar_nonlinear |= _write_constraints(constraints, model, name_map)
    object = (;
        name = "MathOptFormat Model",
        version = (
            major = Int(_SUPPORTED_VERSIONS[1].major),
            minor = Int(_SUPPORTED_VERSIONS[1].minor),
        ),
        variables = variables,
        objective = objective,
        constraints = constraints,
    )
    if has_scalar_nonlinear
        object = (; has_scalar_nonlinear = true, object...)
    end
    JSON3.write(io, object)
    return
end

function _write_variables(variables::Vector{NamedTuple}, model::Model)
    name_map = Dict{MOI.VariableIndex,String}()
    for index in MOI.get(model, MOI.ListOfVariableIndices())
        variable = moi_to_object(index, model)
        name_map[index] = variable[:name]
        push!(variables, variable)
    end
    return name_map
end

function _lift_variable_indices(expr::Expr)
    if expr.head == :ref && length(expr.args) == 2 && expr.args[1] == :x
        return expr.args[2]
    else
        for (index, arg) in enumerate(expr.args)
            expr.args[index] = _lift_variable_indices(arg)
        end
    end
    return expr
end

_lift_variable_indices(arg) = arg  # Recursion fallback.

# TODO(odow): Used by PolyJuMP. Make private in future.
function extract_function_and_set(expr::Expr)
    if expr.head == :call  # One-sided constraint or foo-in-set.
        @assert length(expr.args) == 3
        if expr.args[1] == :in
            # return expr.args[2], expr.args[3]
            error("Constraints of the form foo-in-set aren't supported yet.")
        elseif expr.args[1] == :(<=)
            return expr.args[2], MOI.LessThan(expr.args[3])
        elseif expr.args[1] == :(>=)
            return expr.args[2], MOI.GreaterThan(expr.args[3])
        elseif expr.args[1] == :(==)
            return expr.args[2], MOI.EqualTo(expr.args[3])
        end
    elseif expr.head == :comparison  # Two-sided constraint.
        @assert length(expr.args) == 5
        if expr.args[2] == expr.args[4] == :(<=)
            return expr.args[3], MOI.Interval(expr.args[1], expr.args[5])
        elseif expr.args[2] == expr.args[4] == :(>=)
            return expr.args[3], MOI.Interval(expr.args[5], expr.args[1])
        end
    end
    return error("Oops. The constraint $(expr) wasn't recognised.")
end

function _write_nlpblock(
    constraints::Vector{NamedTuple},
    model::Model,
    name_map::Dict{MOI.VariableIndex,String},
)
    nlp_block = MOI.get(model, MOI.NLPBlock())
    if nlp_block === nothing
        return
    end
    MOI.initialize(nlp_block.evaluator, [:ExprGraph])
    variables = MOI.get(model, MOI.ListOfVariableIndices())
    for (row, bounds) in enumerate(nlp_block.constraint_bounds)
        constraint = MOI.constraint_expr(nlp_block.evaluator, row)
        (func, set) = extract_function_and_set(constraint)
        func = _lift_variable_indices(func)
        push!(
            constraints,
            (;
                :function => moi_to_object(Nonlinear(func), name_map),
                :set => moi_to_object(set, name_map),
            ),
        )
    end
    if nlp_block.has_objective
        objective = MOI.objective_expr(nlp_block.evaluator)
        objective = _lift_variable_indices(objective)
        sense = MOI.get(model, MOI.ObjectiveSense())
        return (;
            :sense => moi_to_object(sense),
            :function => moi_to_object(Nonlinear(objective), name_map),
        )
    end
    return
end

function _write_objective(
    model::Model,
    name_map::Dict{MOI.VariableIndex,String},
)
    sense = MOI.get(model, MOI.ObjectiveSense())
    if sense == MOI.FEASIBILITY_SENSE
        return (; :sense => moi_to_object(sense)), false
    end
    F = MOI.get(model, MOI.ObjectiveFunctionType())
    objective_function = MOI.get(model, MOI.ObjectiveFunction{F}())
    object = (;
        :sense => moi_to_object(sense),
        :function => moi_to_object(objective_function, name_map),
    )
    return object, (F == MOI.ScalarNonlinearFunction)
end

function _write_constraints(
    constraints::Vector{NamedTuple},
    model::Model,
    name_map::Dict{MOI.VariableIndex,String},
)
    has_scalar_nonlinear = false
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        has_scalar_nonlinear |= (F == MOI.ScalarNonlinearFunction)
        for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
            push!(constraints, moi_to_object(index, model, name_map))
        end
    end
    return has_scalar_nonlinear
end

"""
    moi_to_object(x, model::Model)

Convert `x` into a NamedTuple representation.
"""
function moi_to_object end

function moi_to_object(index::MOI.VariableIndex, model::Model)
    name = MOI.get(model, MOI.VariableName(), index)
    primal_start = MOI.get(model, MOI.VariablePrimalStart(), index)
    if name == ""
        error("Variable name for $(index) cannot be blank in an MOF file.")
    elseif isnothing(primal_start)
        return (name = name,)
    else
        return (name = name, primal_start = primal_start)
    end
end

function moi_to_object(
    index::MOI.ConstraintIndex{F,S},
    model::Model,
    name_map::Dict{MOI.VariableIndex,String},
) where {F,S}
    func = MOI.get(model, MOI.ConstraintFunction(), index)
    set = MOI.get(model, MOI.ConstraintSet(), index)
    dual_start = MOI.get(model, MOI.ConstraintDualStart(), index)
    primal_start = MOI.get(model, MOI.ConstraintPrimalStart(), index)
    pairs = Pair{Symbol,Any}[]
    if F != MOI.VariableIndex
        name = MOI.get(model, MOI.ConstraintName(), index)
        if name != ""
            push!(pairs, :name => name)
        end
    end
    push!(pairs, :function => moi_to_object(func, name_map))
    push!(pairs, :set => moi_to_object(set, name_map))
    if !isnothing(dual_start)
        push!(pairs, :dual_start => dual_start)
    end
    if !isnothing(primal_start)
        push!(pairs, :primal_start => primal_start)
    end
    return NamedTuple(pairs)
end

function moi_to_object(sense::MOI.OptimizationSense)
    if sense == MOI.MIN_SENSE
        return "min"
    elseif sense == MOI.MAX_SENSE
        return "max"
    else
        @assert sense == MOI.FEASIBILITY_SENSE
        return "feasibility"
    end
end

# ========== Non-typed scalar functions ==========

function moi_to_object(
    foo::MOI.VariableIndex,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (type = "Variable", name = name_map[foo])
end

function _convert_nonlinear_to_mof(
    expr::Expr,
    node_list::Vector{Any},
    name_map::Dict{MOI.VariableIndex,String},
)
    if expr.head != :call
        error("Expected an expression that was a function. Got $(expr).")
    end
    node = (type = string(expr.args[1]), args = Any[])
    for i in 2:length(expr.args)
        push!(
            node[:args],
            _convert_nonlinear_to_mof(expr.args[i], node_list, name_map),
        )
    end
    push!(node_list, node)
    return (type = "node", index = length(node_list))
end

function _convert_nonlinear_to_mof(
    f::MOI.ScalarNonlinearFunction,
    node_list::Vector{Any},
    name_map::Dict{MOI.VariableIndex,String},
)
    node = (type = string(f.head), args = Any[])
    for arg in f.args
        push!(node[:args], _convert_nonlinear_to_mof(arg, node_list, name_map))
    end
    push!(node_list, node)
    return (type = "node", index = length(node_list))
end

function _convert_nonlinear_to_mof(
    variable::MOI.VariableIndex,
    ::Vector{Any},
    name_map::Dict{MOI.VariableIndex,String},
)
    return name_map[variable]
end

function _convert_nonlinear_to_mof(
    f::MOI.AbstractScalarFunction,
    node_list::Vector{Any},
    name_map::Dict{MOI.VariableIndex,String},
)
    return _convert_nonlinear_to_mof(
        convert(MOI.ScalarNonlinearFunction, f),
        node_list,
        name_map,
    )
end

function _convert_nonlinear_to_mof(
    value::Real,
    ::Vector{Any},
    ::Dict{MOI.VariableIndex,String},
)
    return value
end

function _convert_nonlinear_to_mof(
    value::Complex,
    ::Vector{Any},
    ::Dict{MOI.VariableIndex,String},
)
    return (type = "complex", real = real(value), imag = imag(value))
end

function moi_to_object(foo::Nonlinear, name_map::Dict{MOI.VariableIndex,String})
    node_list = Any[]
    root = _convert_nonlinear_to_mof(foo.expr, node_list, name_map)
    return (
        type = "ScalarNonlinearFunction",
        root = root,
        node_list = node_list,
    )
end

function moi_to_object(
    foo::MOI.ScalarNonlinearFunction,
    name_map::Dict{MOI.VariableIndex,String},
)
    node_list = Any[]
    root = _convert_nonlinear_to_mof(foo, node_list, name_map)
    return (
        type = "ScalarNonlinearFunction",
        root = root,
        node_list = node_list,
    )
end

# ========== Typed scalar functions ==========

function moi_to_object(
    foo::MOI.ScalarAffineTerm,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (coefficient = foo.coefficient, variable = name_map[foo.variable])
end

function moi_to_object(
    foo::MOI.ScalarAffineFunction,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (
        type = "ScalarAffineFunction",
        terms = moi_to_object.(foo.terms, Ref(name_map)),
        constant = foo.constant,
    )
end

function moi_to_object(
    foo::MOI.ScalarQuadraticTerm,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (
        coefficient = foo.coefficient,
        variable_1 = name_map[foo.variable_1],
        variable_2 = name_map[foo.variable_2],
    )
end

function moi_to_object(
    foo::MOI.ScalarQuadraticFunction,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (
        type = "ScalarQuadraticFunction",
        affine_terms = moi_to_object.(foo.affine_terms, Ref(name_map)),
        quadratic_terms = moi_to_object.(foo.quadratic_terms, Ref(name_map)),
        constant = foo.constant,
    )
end

# ========== Non-typed vector functions ==========

function moi_to_object(
    foo::MOI.VectorOfVariables,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (
        type = "VectorOfVariables",
        variables = [name_map[variable] for variable in foo.variables],
    )
end

function moi_to_object(
    foo::MOI.VectorNonlinearFunction,
    name_map::Dict{MOI.VariableIndex,String},
)
    node_list = Any[]
    rows = map(foo.rows) do f
        return _convert_nonlinear_to_mof(f, node_list, name_map)
    end
    return (
        type = "VectorNonlinearFunction",
        rows = rows,
        node_list = node_list,
    )
end

# ========== Typed vector functions ==========

function moi_to_object(
    foo::MOI.VectorAffineTerm,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (
        output_index = foo.output_index,
        scalar_term = moi_to_object(foo.scalar_term, name_map),
    )
end

function moi_to_object(
    foo::MOI.VectorAffineFunction,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (
        type = "VectorAffineFunction",
        terms = moi_to_object.(foo.terms, Ref(name_map)),
        constants = foo.constants,
    )
end

function moi_to_object(
    foo::MOI.VectorQuadraticTerm,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (
        output_index = foo.output_index,
        scalar_term = moi_to_object(foo.scalar_term, name_map),
    )
end

function moi_to_object(
    foo::MOI.VectorQuadraticFunction,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (
        type = "VectorQuadraticFunction",
        affine_terms = moi_to_object.(foo.affine_terms, Ref(name_map)),
        quadratic_terms = moi_to_object.(foo.quadratic_terms, Ref(name_map)),
        constants = foo.constants,
    )
end

# ========== Default ==========
"""
    head_name(::Type{SetType}) where SetType <: MOI.AbstractSet

Return the string that is stored in the `"type"` field of the MOF object for a
set of type `SetType`.
"""
function head_name end
# We don't need a fallback that throws an error because it is impossible for
# this to be called for a set that is not defined in the MOIU Model constructor.

# Add every field as the field is named in MathOptInterface.
function moi_to_object(
    set::SetType,
    ::Dict{MOI.VariableIndex,String},
) where {SetType}
    pairs = Pair{Symbol,Any}[:type=>head_name(SetType)]
    for key in fieldnames(SetType)
        push!(pairs, Symbol(string(key)) => getfield(set, key))
    end
    return NamedTuple(pairs)
end

# ========== Non-typed scalar sets ==========
head_name(::Type{MOI.ZeroOne}) = "ZeroOne"
head_name(::Type{MOI.Integer}) = "Integer"

# ========== Typed scalar sets ==========
head_name(::Type{<:MOI.LessThan}) = "LessThan"
head_name(::Type{<:MOI.GreaterThan}) = "GreaterThan"
head_name(::Type{<:MOI.EqualTo}) = "EqualTo"
head_name(::Type{<:MOI.Interval}) = "Interval"
head_name(::Type{<:MOI.Semiinteger}) = "Semiinteger"
head_name(::Type{<:MOI.Semicontinuous}) = "Semicontinuous"
head_name(::Type{<:MOI.Parameter}) = "Parameter"

# ========== Non-typed vector sets ==========
head_name(::Type{MOI.Zeros}) = "Zeros"
head_name(::Type{MOI.Reals}) = "Reals"
head_name(::Type{MOI.Nonnegatives}) = "Nonnegatives"
head_name(::Type{MOI.Nonpositives}) = "Nonpositives"
head_name(::Type{MOI.SecondOrderCone}) = "SecondOrderCone"
head_name(::Type{MOI.RotatedSecondOrderCone}) = "RotatedSecondOrderCone"
head_name(::Type{MOI.GeometricMeanCone}) = "GeometricMeanCone"
head_name(::Type{MOI.ExponentialCone}) = "ExponentialCone"
head_name(::Type{MOI.DualExponentialCone}) = "DualExponentialCone"
head_name(::Type{MOI.NormOneCone}) = "NormOneCone"
head_name(::Type{MOI.NormInfinityCone}) = "NormInfinityCone"
head_name(::Type{MOI.NormCone}) = "NormCone"
head_name(::Type{MOI.RelativeEntropyCone}) = "RelativeEntropyCone"
head_name(::Type{MOI.NormSpectralCone}) = "NormSpectralCone"
head_name(::Type{MOI.NormNuclearCone}) = "NormNuclearCone"
head_name(::Type{MOI.RootDetConeTriangle}) = "RootDetConeTriangle"
head_name(::Type{MOI.RootDetConeSquare}) = "RootDetConeSquare"
head_name(::Type{MOI.LogDetConeTriangle}) = "LogDetConeTriangle"
head_name(::Type{MOI.LogDetConeSquare}) = "LogDetConeSquare"
function head_name(::Type{MOI.PositiveSemidefiniteConeTriangle})
    return "PositiveSemidefiniteConeTriangle"
end

function head_name(::Type{MOI.PositiveSemidefiniteConeSquare})
    return "PositiveSemidefiniteConeSquare"
end
head_name(::Type{MOI.Complements}) = "Complements"
function head_name(::Type{MOI.HermitianPositiveSemidefiniteConeTriangle})
    return "HermitianPositiveSemidefiniteConeTriangle"
end

head_name(::Type{MOI.AllDifferent}) = "AllDifferent"
head_name(::Type{MOI.Circuit}) = "Circuit"
head_name(::Type{MOI.CountAtLeast}) = "CountAtLeast"
head_name(::Type{MOI.CountBelongs}) = "CountBelongs"
head_name(::Type{MOI.CountDistinct}) = "CountDistinct"
head_name(::Type{MOI.CountGreaterThan}) = "CountGreaterThan"
head_name(::Type{MOI.Cumulative}) = "Cumulative"
head_name(::Type{MOI.Path}) = "Path"

# ========== Typed vector sets ==========
head_name(::Type{<:MOI.PowerCone}) = "PowerCone"
head_name(::Type{<:MOI.DualPowerCone}) = "DualPowerCone"
head_name(::Type{<:MOI.SOS1}) = "SOS1"
head_name(::Type{<:MOI.SOS2}) = "SOS2"
head_name(::Type{<:MOI.BinPacking}) = "BinPacking"
head_name(::Type{<:MOI.HyperRectangle}) = "HyperRectangle"

function moi_to_object(
    set::MOI.Indicator{I,S},
    name_map::Dict{MOI.VariableIndex,String},
) where {I,S}
    @assert I == MOI.ACTIVATE_ON_ONE || I == MOI.ACTIVATE_ON_ZERO
    return (
        type = "Indicator",
        set = moi_to_object(set.set, name_map),
        activate_on = (I == MOI.ACTIVATE_ON_ONE) ? "one" : "zero",
    )
end

function moi_to_object(
    set::MOI.Reified,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (type = "Reified", set = moi_to_object(set.set, name_map))
end

function moi_to_object(
    set::MOI.Table{T},
    ::Dict{MOI.VariableIndex,String},
) where {T}
    return (
        type = "Table",
        table = [set.table[i, :] for i in 1:size(set.table, 1)],
    )
end

function moi_to_object(
    set::MOI.Scaled,
    name_map::Dict{MOI.VariableIndex,String},
)
    return (type = "Scaled", set = moi_to_object(set.set, name_map))
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    promote_operation(
        op::Function,
        ::Type{T},
        ArgsTypes::Type{<:Union{T,AbstractVector{T},MOI.AbstractFunction}}...,
    ) where {T<:Number}

Compute the return type of the call `operate(op, T, args...)`, where the types
of the arguments `args` are `ArgsTypes`.

One assumption is that the element type `T` is invariant under each operation.
That is, `op(::T, ::T)::T` where `op` is a `+`, `-`, `*`, and `/`.

There are six methods for which we implement `Utilities.promote_operation`:

 1. `+`
    a. `promote_operation(::typeof(+), ::Type{T}, ::Type{F1}, ::Type{F2})`
 2. `-`
    a. `promote_operation(::typeof(-), ::Type{T}, ::Type{F})`
    b. `promote_operation(::typeof(-), ::Type{T}, ::Type{F1}, ::Type{F2})`
 3. `*`
    a. `promote_operation(::typeof(*), ::Type{T}, ::Type{T}, ::Type{F})`
    b. `promote_operation(::typeof(*), ::Type{T}, ::Type{F}, ::Type{T})`
    c. `promote_operation(::typeof(*), ::Type{T}, ::Type{F1}, ::Type{F2})`
       where `F1` and `F2` are `VariableIndex` or `ScalarAffineFunction`
    d. `promote_operation(::typeof(*), ::Type{T}, ::Type{<:Diagonal{T}}, ::Type{F}`
 4. `/`
    a. `promote_operation(::typeof(/), ::Type{T}, ::Type{F}, ::Type{T})`
 5. `vcat`
    a. `promote_operation(::typeof(vcat), ::Type{T}, ::Type{F}...)`
 6. `imag`
    a. `promote_operation(::typeof(imag), ::Type{T}, ::Type{F})`
       where `F` is `VariableIndex` or `VectorOfVariables`

In each case, `F` (or `F1` and `F2`) is one of the ten supported types, with
a restriction that the mathematical operation makes sense, for example, we don't
define `promote_operation(-, T, F1, F2)` where `F1` is a scalar-valued function
and  `F2` is a vector-valued function. The ten supported types are:

 1. ::T
 2. ::VariableIndex
 3. ::ScalarAffineFunction{T}
 4. ::ScalarQuadraticFunction{T}
 5. ::ScalarNonlinearFunction
 6. ::AbstractVector{T}
 7. ::VectorOfVariables
 8. ::VectorAffineFunction{T}
 9. ::VectorQuadraticFunction{T}
 10. ::VectorNonlinearFunction
"""
function promote_operation end

### Method 1a and 2b

function promote_operation(
    ::Union{typeof(+),typeof(-)},
    ::Type{T},
    ::Type{T},
    ::Type{T},
) where {T<:Number}
    return T
end

function promote_operation(
    ::Union{typeof(+),typeof(-)},
    ::Type{T},
    ::Type{<:F},
    ::Type{<:F},
) where {T,F<:Union{T,MOI.VariableIndex,MOI.ScalarAffineFunction{T}}}
    return MOI.ScalarAffineFunction{T}
end

function promote_operation(
    ::Union{typeof(+),typeof(-)},
    ::Type{T},
    ::Type{<:F},
    ::Type{<:F},
) where {
    T,
    F<:Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    },
}
    return MOI.ScalarQuadraticFunction{T}
end

function promote_operation(
    ::Union{typeof(+),typeof(-)},
    ::Type{T},
    ::Type{<:F},
    ::Type{<:F},
) where {
    T,
    F<:Union{
        T,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
    },
}
    return MOI.ScalarNonlinearFunction
end

function promote_operation(
    op::Union{typeof(+),typeof(-)},
    ::Type{T},
    ::Type{F1},
    ::Type{F2},
) where {
    T,
    F1<:Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    },
    F2<:Union{
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
        MOI.VectorNonlinearFunction,
    },
}
    S = promote_operation(op, T, scalar_type(F1), scalar_type(F2))
    return vector_type(S)
end

### Method 2a

function promote_operation(
    ::typeof(-),
    ::Type{T},
    ::Type{F},
) where {
    T,
    F<:Union{
        T,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        AbstractVector{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
}
    return F
end

function promote_operation(
    ::typeof(-),
    ::Type{T},
    ::Type{MOI.VariableIndex},
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}
end

function promote_operation(
    ::typeof(-),
    ::Type{T},
    ::Type{MOI.VectorOfVariables},
) where {T<:Number}
    return MOI.VectorAffineFunction{T}
end

function promote_operation(
    ::typeof(-),
    ::Type{T},
    ::Type{MOI.VectorNonlinearFunction},
) where {T<:Number}
    return vector_type(promote_operation(-, T, MOI.ScalarNonlinearFunction))
end

### Method 3a

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{T},
    ::Type{F},
) where {
    T<:Number,
    F<:Union{
        # T,  # Stackoverflow if included
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        AbstractVector{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
}
    return F
end

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{T},
    ::Type{T},
) where {T<:Number}
    return T
end

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{T},
    ::Type{MOI.VariableIndex},
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}
end

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{T},
    ::Type{MOI.VectorOfVariables},
) where {T<:Number}
    return MOI.VectorAffineFunction{T}
end

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{T},
    ::Type{MOI.VectorNonlinearFunction},
) where {T<:Number}
    return vector_type(promote_operation(*, T, T, MOI.ScalarNonlinearFunction))
end

### Method 3b

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{F},
    ::Type{T},
) where {
    T<:Number,
    F<:Union{
        # T,  # Stackoverflow if included
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        AbstractVector{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
}
    return F
end

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{MOI.VariableIndex},
    ::Type{T},
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}
end

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{MOI.VectorOfVariables},
    ::Type{T},
) where {T<:Number}
    return MOI.VectorAffineFunction{T}
end

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{MOI.VectorNonlinearFunction},
    ::Type{T},
) where {T<:Number}
    return vector_type(promote_operation(*, T, MOI.ScalarNonlinearFunction, T))
end

### Method 3c

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{<:Union{MOI.VariableIndex,MOI.ScalarAffineFunction{T}}},
    ::Type{<:Union{MOI.VariableIndex,MOI.ScalarAffineFunction{T}}},
) where {T<:Number}
    return MOI.ScalarQuadraticFunction{T}
end

### Method 3d

function promote_operation(
    ::typeof(*),
    ::Type{T},
    ::Type{<:LinearAlgebra.Diagonal{T}},
    ::Type{F},
) where {T,F}
    U = promote_operation(*, T, T, scalar_type(F))
    return promote_operation(vcat, T, U)
end

### Method 4a

function promote_operation(
    ::typeof(/),
    ::Type{T},
    ::Type{F},
    ::Type{T},
) where {
    T,
    F<:Union{
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.ScalarNonlinearFunction,
        AbstractVector{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
}
    return F
end

function promote_operation(
    ::typeof(/),
    ::Type{T},
    ::Type{T},
    ::Type{T},
) where {T<:Number}
    return T
end

function promote_operation(
    ::typeof(/),
    ::Type{T},
    ::Type{MOI.VariableIndex},
    ::Type{T},
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}
end

function promote_operation(
    ::typeof(/),
    ::Type{T},
    ::Type{MOI.VectorOfVariables},
    ::Type{T},
) where {T<:Number}
    return MOI.VectorAffineFunction{T}
end

function promote_operation(
    ::typeof(/),
    ::Type{T},
    ::Type{MOI.VectorNonlinearFunction},
    ::Type{T},
) where {T}
    return vector_type(promote_operation(/, T, MOI.ScalarNonlinearFunction, T))
end

### Method 5a

function promote_operation(
    ::typeof(vcat),
    ::Type{T},
    ::Type{<:Union{T,AbstractVector{T}}},
    ::Type{<:Union{T,AbstractVector{T}}}...,
) where {T<:Number}
    return Vector{T}
end

function promote_operation(
    ::typeof(vcat),
    ::Type{T},
    ::Type{<:Union{MOI.VariableIndex,MOI.VectorOfVariables}},
    ::Type{<:Union{MOI.VariableIndex,MOI.VectorOfVariables}}...,
) where {T<:Number}
    return MOI.VectorOfVariables
end

function promote_operation(
    ::typeof(vcat),
    ::Type{T},
    ::Type{
        <:Union{
            T,
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{T},
            AbstractVector{T},
            MOI.VectorOfVariables,
            MOI.VectorAffineFunction{T},
        },
    }...,
) where {T<:Number}
    return MOI.VectorAffineFunction{T}
end

function promote_operation(
    ::typeof(vcat),
    ::Type{T},
    ::Type{
        <:Union{
            T,
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{T},
            MOI.ScalarQuadraticFunction{T},
            AbstractVector{T},
            MOI.VectorOfVariables,
            MOI.VectorAffineFunction{T},
            MOI.VectorQuadraticFunction{T},
        },
    }...,
) where {T<:Number}
    return MOI.VectorQuadraticFunction{T}
end

function promote_operation(
    ::typeof(vcat),
    ::Type{T},
    ::Type{
        <:Union{
            T,
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{T},
            MOI.ScalarQuadraticFunction{T},
            MOI.ScalarNonlinearFunction,
            AbstractVector{T},
            MOI.VectorOfVariables,
            MOI.VectorAffineFunction{T},
            MOI.VectorQuadraticFunction{T},
            MOI.VectorNonlinearFunction,
        },
    }...,
) where {T<:Number}
    return MOI.VectorNonlinearFunction
end

### Method 6a

function promote_operation(
    ::typeof(imag),
    ::Type{T},
    ::Type{MOI.VariableIndex},
) where {T<:Number}
    return MOI.ScalarAffineFunction{T}
end

function promote_operation(
    ::typeof(imag),
    ::Type{T},
    ::Type{MOI.VectorOfVariables},
) where {T<:Number}
    return MOI.VectorAffineFunction{T}
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

import Documenter
import MathOptInterface

# Pass --fix` to rebuild the doctests.
const _FIX = findfirst(isequal("--fix"), ARGS) !== nothing

# A flag to check if we are running in a GitHub action.
const _IS_GITHUB_ACTIONS = get(ENV, "GITHUB_ACTIONS", "false") == "true"

# Pass --pdf to build the PDF. On GitHub actions, we always build the PDF.
const _PDF = findfirst(isequal("--pdf"), ARGS) !== nothing || _IS_GITHUB_ACTIONS

# ==============================================================================
#  Documentation structure
# ==============================================================================

const _PAGES = [
    "Introduction" => ["index.md", "background/motivation.md"],
    "Tutorials" => [
        "tutorials/example.md",
        "tutorials/implementing.md",
        "tutorials/mathprogbase.md",
        "tutorials/bridging_constraint.md",
        "tutorials/manipulating_expressions.md",
        "tutorials/latency.md",
    ],
    "Manual" => [
        "manual/standard_form.md",
        "manual/models.md",
        "manual/variables.md",
        "manual/constraints.md",
        "manual/solutions.md",
        "manual/modification.md",
    ],
    "Background" => [
        "background/duality.md",
        "background/infeasibility_certificates.md",
        "background/naming_conventions.md",
    ],
    "API Reference" => [
        "reference/standard_form.md",
        "reference/models.md",
        "reference/variables.md",
        "reference/constraints.md",
        "reference/modification.md",
        "reference/nonlinear.md",
        "reference/callbacks.md",
        "reference/errors.md",
    ],
    "Submodules" => [
        "Benchmarks" => [
            "Overview" => "submodules/Benchmarks/overview.md",
            "API Reference" => "submodules/Benchmarks/reference.md",
        ],
        "Bridges" => [
            "Overview" => "submodules/Bridges/overview.md",
            "Implementation" => "submodules/Bridges/implementation.md",
            "List of bridges" => "submodules/Bridges/list_of_bridges.md",
            "API Reference" => "submodules/Bridges/reference.md",
        ],
        "FileFormats" => [
            "Overview" => "submodules/FileFormats/overview.md",
            "API Reference" => "submodules/FileFormats/reference.md",
            "The LP file format" => "submodules/FileFormats/LP.md",
        ],
        "Nonlinear" => [
            "Overview" => "submodules/Nonlinear/overview.md",
            "SymbolicAD" => "submodules/Nonlinear/SymbolicAD.md",
            "API Reference" => "submodules/Nonlinear/reference.md",
        ],
        "Utilities" => [
            "Overview" => "submodules/Utilities/overview.md",
            "API Reference" => "submodules/Utilities/reference.md",
        ],
        "Test" => [
            "Overview" => "submodules/Test/overview.md",
            "API Reference" => "submodules/Test/reference.md",
        ],
    ],
    "Developer Docs" => [
        "developer/checklists.md",
        "developer/contributing.md",
        "developer/defining_a_new_set.md",
    ],
    "Release notes" => "release_notes.md",
]

# ==============================================================================
#  Modify the release notes
# ==============================================================================

function fix_release_line(
    line::String,
    url::String = "https://github.com/jump-dev/MathOptInterface.jl",
)
    # (#XXXX) -> ([#XXXX](url/issue/XXXX))
    while (m = match(r"\(\#([0-9]+)\)", line)) !== nothing
        id = m.captures[1]
        line = replace(line, m.match => "([#$id]($url/issues/$id))")
    end
    # ## vX.Y.Z -> [vX.Y.Z](url/releases/tag/vX.Y.Z)
    while (m = match(r"\#\# (v[0-9]+.[0-9]+.[0-9]+)", line)) !== nothing
        tag = m.captures[1]
        line = replace(line, m.match => "## [$tag]($url/releases/tag/$tag)")
    end
    return line
end

open(joinpath(@__DIR__, "src", "changelog.md"), "r") do in_io
    open(joinpath(@__DIR__, "src", "release_notes.md"), "w") do out_io
        for line in readlines(in_io; keep = true)
            write(out_io, fix_release_line(line))
        end
    end
end

# ==============================================================================
#  Build the HTML docs
# ==============================================================================

# Needed to make Documenter think that there is a PDF in the right place when
# link checking. Inn production we replace this by running the LaTeX build.
write(joinpath(@__DIR__, "src", "MathOptInterface.pdf"), "")

Documenter.DocMeta.setdocmeta!(
    MathOptInterface,
    :DocTestSetup,
    :(import MathOptInterface as MOI);
    recursive = true,
)

@time Documenter.makedocs(
    sitename = "MathOptInterface",
    authors = "The JuMP core developers and contributors",
    format = Documenter.HTML(
        # See https://github.com/JuliaDocs/Documenter.jl/issues/868
        prettyurls = get(ENV, "CI", nothing) == "true",
        mathengine = Documenter.MathJax2(),
        collapselevel = 1,
        # Do no check for large pages.
        size_threshold_ignore = [
            "changelog.md",
            "release_notes.md",
            "reference/models.md",
            "reference/standard_form.md",
            "submodules/Bridges/list_of_bridges.md",
            "submodules/Bridges/reference.md",
            "submodules/Utilities/reference.md",
        ],
    ),
    clean = true,
    linkcheck = true,
    linkcheck_ignore = [
        # Ignore the PDF link, because it hasn't been built yet.
        "MathOptInterface.pdf",
        # Ignore the very many GitHub links
        r"https://github.com/jump-dev/.+",
        "https://arxiv.org/abs/2002.03447",
        # https://github.com/JuliaDocs/Documenter.jl/issues/2834
        "https://lpsolve.sourceforge.net/5.5/CPLEX-format.htm",
    ],
    modules = [MathOptInterface],
    checkdocs = :exports,
    doctest = _FIX ? :fix : true,
    pages = _PAGES,
)

# ==============================================================================
#  Build the LaTeX docs (if needed)
# ==============================================================================

if _PDF
    latex_platform = _IS_GITHUB_ACTIONS ? "docker" : "native"
    # Remove the Release Notes; we don't need them in the PDF.
    pop!(_PAGES)
    @time Documenter.makedocs(
        sitename = "MathOptInterface",
        authors = "The JuMP core developers and contributors",
        format = Documenter.LaTeX(platform = latex_platform),
        build = "latex_build",
        pages = _PAGES,
    )
    # Hack for deploying: copy the PDF (and only the PDF) into the HTML build
    # directory. We don't want to copy everything in `latex_build` because it
    # includes lots of extraneous LaTeX files.
    cp(
        joinpath(@__DIR__, "latex_build", "MathOptInterface.pdf"),
        joinpath(@__DIR__, "build", "MathOptInterface.pdf");
        force = true,
    )
end

# ==============================================================================
#  Deploy everything in `build`
# ==============================================================================

Documenter.deploydocs(
    repo = "github.com/jump-dev/MathOptInterface.jl.git",
    push_preview = true,
)

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintIndicatorSOS1

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_indicator_by_SOS1()
    # linear problem with indicator constraints
    # max  2x1 + 3x2
    # s.t. x1 + x2 <= 10
    #      z1 == 1 ==> x2 <= 8
    #      z2 == 1 ==> x1 + x2 == 9
    #      z3 == 1 ==> x1 >= 5
    #      z1 + z2 >= 1
    model = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    x1 = MOI.add_variable(model)
    x2 = MOI.add_variable(model)
    z1 = MOI.add_variable(model)
    z2 = MOI.add_variable(model)
    z3 = MOI.add_variable(model)

    vc2 = MOI.add_constraint(model, z2, MOI.ZeroOne())
    vc1 = MOI.add_constraint(model, z1, MOI.ZeroOne())
    vc3 = MOI.add_constraint(model, z3, MOI.ZeroOne())
    f1 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, z1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(1.0, x2)),
        ],
        [0.0, 0.0],
    )
    iset1 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(8.0))

    f2 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, z2)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(1.0, x1)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(1.0, x2)),
        ],
        [0.0, 0.0],
    )
    iset2 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.EqualTo(9.0))

    f3 = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, z3)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(1.0, x1)),
        ],
        [0.0, 0.0],
    )
    iset3 = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.GreaterThan(5.0))

    BT1 = MOI.Bridges.Constraint.concrete_bridge_type(
        MOI.Bridges.Constraint.IndicatorSOS1Bridge{Float64},
        typeof(f1),
        typeof(iset1),
    )
    bridge1 = MOI.Bridges.Constraint.bridge_constraint(BT1, model, f1, iset1)
    @test BT1 <:
          MOI.Bridges.Constraint.IndicatorSOS1Bridge{Float64,<:MOI.LessThan}
    @test bridge1 isa BT1

    BT2 = MOI.Bridges.Constraint.concrete_bridge_type(
        MOI.Bridges.Constraint.IndicatorSOS1Bridge{Float64},
        typeof(f2),
        typeof(iset2),
    )
    bridge2 = MOI.Bridges.Constraint.bridge_constraint(BT2, model, f2, iset2)
    @test BT2 <:
          MOI.Bridges.Constraint.IndicatorSOS1Bridge{Float64,<:MOI.EqualTo}
    @test bridge2 isa BT2

    BT3 = MOI.Bridges.Constraint.concrete_bridge_type(
        MOI.Bridges.Constraint.IndicatorSOS1Bridge{Float64},
        typeof(f3),
        typeof(iset3),
    )
    bridge3 = MOI.Bridges.Constraint.bridge_constraint(BT3, model, f3, iset3)
    @test BT3 <:
          MOI.Bridges.Constraint.IndicatorSOS1Bridge{Float64,<:MOI.GreaterThan}
    @test bridge3 isa BT3

    w1 = bridge1.slack
    @test MOI.get(model, MOI.ConstraintFunction(), bridge1.sos_index) ==
          MOI.VectorOfVariables([w1, z1])
    lin_cons1 = bridge1.affine_index
    lin_func1 = MOI.get(model, MOI.ConstraintFunction(), lin_cons1)
    @test lin_func1 ≈ MOI.ScalarAffineFunction(
        [MOI.ScalarAffineTerm(1.0, x2), MOI.ScalarAffineTerm(1.0, w1)],
        0.0,
    )
    @test MOI.get(model, MOI.ConstraintSet(), lin_cons1) == MOI.LessThan(8.0)

    w2 = bridge2.slack
    @test MOI.get(model, MOI.ConstraintFunction(), bridge2.sos_index) ==
          MOI.VectorOfVariables([w2, z2])
    lin_cons2 = bridge2.affine_index
    lin_func2 = MOI.get(model, MOI.ConstraintFunction(), lin_cons2)
    @test lin_func2 ≈ MOI.ScalarAffineFunction(
        [
            MOI.ScalarAffineTerm(1.0, x1),
            MOI.ScalarAffineTerm(1.0, x2),
            MOI.ScalarAffineTerm(1.0, w2),
        ],
        0.0,
    )
    @test MOI.get(model, MOI.ConstraintSet(), lin_cons2) == MOI.EqualTo(9.0)

    w3 = bridge3.slack
    MOI.GreaterThan(0.0)
    @test MOI.get(model, MOI.ConstraintFunction(), bridge3.sos_index) ==
          MOI.VectorOfVariables([w3, z3])
    lin_cons3 = bridge3.affine_index
    lin_func3 = MOI.get(model, MOI.ConstraintFunction(), lin_cons3)
    @test lin_func3 ≈ MOI.ScalarAffineFunction(
        [MOI.ScalarAffineTerm(1.0, x1), MOI.ScalarAffineTerm(1.0, w3)],
        0.0,
    )
    @test MOI.get(model, MOI.ConstraintSet(), lin_cons3) == MOI.GreaterThan(5.0)

    ## MOI.get on bridge
    @test MOI.get(model, MOI.ConstraintSet(), bridge3) == iset3
    @test MOI.get(model, MOI.ConstraintFunction(), bridge3) ≈ f3
    return
end

function test_basic()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    MOI.Test.test_basic_VectorAffineFunction_Indicator_GreaterThan(
        MOI.Bridges.Constraint.IndicatortoSOS1{Float64}(mock),
        MOI.Test.Config(),
    )
    MOI.Test.test_basic_VectorAffineFunction_Indicator_LessThan(
        MOI.Bridges.Constraint.IndicatortoSOS1{Float64}(mock),
        MOI.Test.Config(),
    )
    return
end

function test_model_equality()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.IndicatortoSOS1{Float64}(mock)
    z, _ = MOI.add_constrained_variable(bridged_mock, MOI.ZeroOne())
    MOI.set(bridged_mock, MOI.VariableName(), z, "z")
    x = MOI.add_variable(bridged_mock)
    MOI.set(bridged_mock, MOI.VariableName(), x, "x")
    var_names = ["z", "x", "w"]
    f = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, z)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(1.0, x)),
        ],
        [0.0, 0.0],
    )
    iset = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(8.0))
    ci = MOI.add_constraint(bridged_mock, f, iset)
    @test length(MOI.get(mock, MOI.ListOfVariableIndices())) == 3
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    sos_cons_list = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.SOS1{Float64}}(),
    )
    @test length(sos_cons_list) == 1
    MOI.set(mock, MOI.ConstraintName(), sos_cons_list[1], "sos1")
    inequality_list = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(inequality_list) == 1
    MOI.set(mock, MOI.ConstraintName(), inequality_list[1], "ineq")
    MOI.set(mock, MOI.ObjectiveFunction{MOI.VariableIndex}(), z)
    MOI.set(mock, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    s = """
    variables: z, x, w
    maxobjective: z
    sos1: [w, z] in SOS1([0.4, 0.6])
    ineq: x + w <= 8.0
    z in ZeroOne()
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        var_names,
        ["sos1", "ineq"],
        [("z", MOI.ZeroOne())],
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.VariableIndex, MOI.ZeroOne, 1),
            (MOI.VectorOfVariables, MOI.SOS1{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 0),
        ),
        used_bridges = 1,
        num_bridged = 1,
    )

    model = MOI.Utilities.Model{Float64}()
    sbridged = """
    variables: x, z
    z in ZeroOne()
    maxobjective: z
    """
    MOI.Utilities.loadfromstring!(model, sbridged)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        ["z", "x"],
        String[],
        [("z", MOI.ZeroOne())],
    )
    return
end

function test_getting_primal_attributes()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    z, _ = MOI.add_constrained_variable(mock, MOI.ZeroOne())
    x = MOI.add_variable(mock)
    f = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, z)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(1.0, x)),
        ],
        [0.0, 0.0],
    )
    iset = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(8.0))
    BT = MOI.Bridges.Constraint.concrete_bridge_type(
        MOI.Bridges.Constraint.IndicatorSOS1Bridge{Float64},
        typeof(f),
        typeof(iset),
    )
    bridge1 = MOI.Bridges.Constraint.bridge_constraint(BT, mock, f, iset)
    # w value should be defaulted to 0
    MOI.set(mock, MOI.VariablePrimalStart(), bridge1.slack, 0.0)
    affine_value = 6.0
    MOI.set(mock, MOI.ConstraintPrimalStart(), bridge1, [1.0, affine_value])
    @test MOI.get(mock, MOI.VariablePrimalStart(), z) ≈ 1.0
    @test MOI.get(mock, MOI.ConstraintPrimalStart(), bridge1.affine_index) ≈ 6.0

    # after setting the w value
    w_value = 3.0
    MOI.set(mock, MOI.VariablePrimalStart(), bridge1.slack, w_value)
    # linear function should not move
    @test all(
        MOI.get(mock, MOI.ConstraintPrimalStart(), bridge1) .≈
        (1.0, affine_value - w_value),
    )
    iseteq = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.EqualTo(8.0))
    BT = MOI.Bridges.Constraint.concrete_bridge_type(
        MOI.Bridges.Constraint.IndicatorSOS1Bridge{Float64},
        typeof(f),
        typeof(iseteq),
    )
    bridge_eq = MOI.Bridges.Constraint.bridge_constraint(BT, mock, f, iseteq)
    @test MOI.get(
        bridge_eq,
        MOI.NumberOfConstraints{
            MOI.ScalarAffineFunction{Float64},
            MOI.EqualTo{Float64},
        }(),
    ) == 1
    @test MOI.supports(
        mock,
        MOI.ConstraintPrimalStart(),
        MOI.Bridges.Constraint.IndicatorSOS1Bridge{
            Float64,
            MOI.LessThan{Float64},
        },
    )
    # VariablePrimal
    MOI.set(mock, MOI.VariablePrimal(), bridge1.slack, 33.0)
    z_value = 1.0
    MOI.set(mock, MOI.VariablePrimal(), bridge1.z, z_value)
    MOI.set(mock, MOI.VariablePrimal(), x, affine_value)

    # linear function should not move
    @test all(
        MOI.get(mock, MOI.ConstraintPrimal(), bridge1) .≈ (1.0, affine_value),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorSOS1Bridge,
        """
        variables: x, z
        [z, 2.0 * x] in Indicator{ACTIVATE_ON_ONE}(LessThan(2.0))
        z in ZeroOne()
        """,
        """
        variables: x, z, y
        2.0 * x + 1.0 * y <= 2.0
        z in ZeroOne()
        [y, z] in SOS1([0.4, 0.6])
        """,
    )
    # Test that the bridge does nothing for VectorQuadraticFunctions
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorSOS1Bridge,
        """
        variables: x, z
        [z, 2.0 * x * x] in Indicator{ACTIVATE_ON_ONE}(LessThan(2.0))
        z in ZeroOne()
        """,
        """
        variables: x, z
        [z, 2.0 * x * x] in Indicator{ACTIVATE_ON_ONE}(LessThan(2.0))
        z in ZeroOne()
        """,
    )
    return
end

end  # module

TestConstraintIndicatorSOS1.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestBridgeOptimizer

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("utilities.jl")

struct DummyModelAttribute <: MOI.AbstractModelAttribute end

struct DummyEvaluator <: MOI.AbstractNLPEvaluator end

struct DummyVariableAttribute <: MOI.AbstractVariableAttribute end

struct DummyConstraintAttribute <: MOI.AbstractConstraintAttribute end

function test_subsitution_of_variables_constant()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    x, _ = MOI.add_constrained_variable(bridged, MOI.GreaterThan(1.0))
    f, s = 2.0x + 1.0, MOI.Integer()
    @test_throws(
        MOI.ScalarFunctionConstantNotZero{Float64,typeof(f),typeof(s)}(1.0),
        MOI.add_constraint(bridged, f, s),
    )
    return
end

function test_subsitution_of_variables()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    x, cx = MOI.add_constrained_variable(bridged, MOI.GreaterThan(1.0))
    y = MOI.get(mock, MOI.ListOfVariableIndices())[1]
    c2x = MOI.add_constraint(bridged, 2.0x, MOI.GreaterThan(1.0))
    @test MOI.get(bridged, MOI.ConstraintFunction(), c2x) ≈ 2.0x
    @test MOI.get(bridged, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(1.0)
    # The constant was moved to the set
    @test MOI.get(mock, MOI.ConstraintFunction(), c2x) ≈ 2.0y
    @test MOI.get(mock, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(-1.0)

    MOI.set(bridged, MOI.ConstraintSet(), c2x, MOI.GreaterThan(2.0))
    @test MOI.get(bridged, MOI.ConstraintFunction(), c2x) ≈ 2.0x
    @test MOI.get(bridged, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(2.0)
    @test MOI.get(mock, MOI.ConstraintFunction(), c2x) ≈ 2.0y
    @test MOI.get(mock, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(0.0)

    MOI.set(bridged, MOI.ConstraintFunction(), c2x, 3.0x)
    @test MOI.get(bridged, MOI.ConstraintFunction(), c2x) ≈ 3.0x
    @test MOI.get(bridged, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(2.0)
    @test MOI.get(mock, MOI.ConstraintFunction(), c2x) ≈ 3.0y
    @test MOI.get(mock, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(-1.0)

    MOI.set(bridged, MOI.ConstraintSet(), c2x, MOI.GreaterThan(4.0))
    @test MOI.get(bridged, MOI.ConstraintFunction(), c2x) ≈ 3.0x
    @test MOI.get(bridged, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(4.0)
    @test MOI.get(mock, MOI.ConstraintFunction(), c2x) ≈ 3.0y
    @test MOI.get(mock, MOI.ConstraintSet(), c2x) == MOI.GreaterThan(1.0)

    MOI.set(bridged, MOI.ObjectiveFunction{typeof(2.0x)}(), 2.0x)
    @test MOI.get(mock, MOI.ObjectiveFunction{typeof(2.0y)}()) ≈ 2.0y + 2.0

    MOI.set(bridged, DummyModelAttribute(), 2.0x + 1.0)
    @test MOI.get(bridged, DummyModelAttribute()) ≈ 2.0x + 1.0
    @test MOI.get(mock, DummyModelAttribute()) ≈ 2.0y + 3.0

    z = MOI.add_variable(bridged)
    for (attr, index) in
        [(DummyVariableAttribute(), z), (DummyConstraintAttribute(), c2x)]
        MOI.set(bridged, attr, index, 1.0x)
        @test MOI.get(bridged, attr, index) ≈ 1.0x
        @test MOI.get(mock, attr, index) ≈ 1.0y + 1.0

        MOI.set(bridged, attr, [index], [3.0x + 1.0z])
        @test MOI.get(bridged, attr, [index])[1] ≈ 3.0x + 1.0z
        @test MOI.get(mock, attr, [index])[1] ≈ 3.0y + 1.0z + 3.0
    end
    return
end

function test_raw_solver()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    return MOI.get(bridged, MOI.RawSolver()) === mock
end

function test_HeuristicCallback()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    attr = MOI.HeuristicCallback()
    f(::Any) = nothing
    MOI.set(bridged, attr, f)
    @test MOI.get(bridged, attr) === f
    return
end

function test_CallbackVariablePrimal()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    x, _ = MOI.add_constrained_variable(bridged, MOI.GreaterThan(1.0))
    y = MOI.get(mock, MOI.ListOfVariableIndices())[1]
    z = MOI.add_variable(bridged)
    attr = MOI.CallbackVariablePrimal(nothing)
    @test_throws(
        ErrorException("No mock callback primal is set for variable `$z`."),
        MOI.get(bridged, attr, z),
    )
    MOI.set(mock, attr, y, 1.0)
    MOI.set(mock, attr, z, 2.0)
    @test MOI.get(bridged, attr, z) == 2.0
    err = ArgumentError(
        "Variable bridge of type `$(typeof(MOI.Bridges.bridge(bridged, x)))` " *
        "does not support accessing the attribute `$attr`.",
    )
    @test_throws err MOI.get(bridged, attr, x)
    return
end

function test_LazyConstraint()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    x, _ = MOI.add_constrained_variable(bridged, MOI.GreaterThan(1.0))
    y = MOI.get(mock, MOI.ListOfVariableIndices())[1]
    sub = MOI.LazyConstraint(nothing)
    @test MOI.supports(bridged, sub)
    MOI.submit(bridged, sub, 2.0x, MOI.GreaterThan(1.0))
    mock.submitted[sub][1][1] ≈ 2.0y + 2.0
    mock.submitted[sub][1][2] == MOI.GreaterThan(1.0)
    return
end

function test_HeuristicSolution()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    x, _ = MOI.add_constrained_variable(bridged, MOI.GreaterThan(1.0))
    y = MOI.get(mock, MOI.ListOfVariableIndices())[1]
    z = MOI.add_variable(bridged)
    sub = MOI.HeuristicSolution(nothing)
    @test MOI.supports(bridged, sub)
    MOI.submit(bridged, sub, [z], [1.0])
    mock.submitted[sub][1][1] == [z]
    mock.submitted[sub][1][2] == [1.0]
    err = ErrorException(
        "Cannot substitute `$x` as it is bridged into `$(1.0y + 1.0)`.",
    )
    @test_throws err MOI.submit(bridged, sub, [x], [1.0])
    return
end

function test_NLPBlock()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged = MOI.Bridges.Variable.Vectorize{Float64}(mock)
    nlp_data =
        MOI.NLPBlockData([MOI.NLPBoundsPair(1.0, 2.0)], DummyEvaluator(), false)
    MOI.set(bridged, MOI.NLPBlock(), nlp_data)
    for nlp_data in
        [MOI.get(bridged, MOI.NLPBlock()), MOI.get(mock, MOI.NLPBlock())]
        @test nlp_data.constraint_bounds == [MOI.NLPBoundsPair(1.0, 2.0)]
        @test nlp_data.evaluator isa DummyEvaluator
        @test nlp_data.has_objective == false
    end
    return
end

# Model not supporting Interval
MOI.Utilities.@model(
    NoIntervalModel,
    (),
    (MOI.EqualTo, MOI.GreaterThan, MOI.LessThan, MOI.Interval),
    (
        MOI.Zeros,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.NormInfinityCone,
        MOI.NormOneCone,
        MOI.SecondOrderCone,
        MOI.RotatedSecondOrderCone,
        MOI.GeometricMeanCone,
        MOI.RelativeEntropyCone,
        MOI.NormSpectralCone,
        MOI.NormNuclearCone,
        MOI.PositiveSemidefiniteConeTriangle,
        MOI.ExponentialCone,
    ),
    (MOI.PowerCone, MOI.DualPowerCone),
    (),
    (MOI.ScalarAffineFunction, MOI.ScalarQuadraticFunction),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction, MOI.VectorQuadraticFunction)
)

struct AttributeNotAllowed <: MOI.AbstractConstraintAttribute end

function MOI.supports(
    ::MOI.ModelLike,
    ::AttributeNotAllowed,
    ::Type{<:MOI.Bridges.Constraint.SplitIntervalBridge},
)
    return true
end

function test_unsupported_constraint_attribute()
    mock = MOI.Utilities.MockOptimizer(NoIntervalModel{Float64}())
    bridged_mock = MOI.Bridges.Constraint.LessToGreater{Float64}(
        MOI.Bridges.Constraint.SplitInterval{Float64}(mock),
    )
    bridge = MOI.Bridges.Constraint.SplitIntervalBridge{
        Float64,
        MOI.VariableIndex,
        MOI.Interval{Float64},
        MOI.GreaterThan{Float64},
        MOI.LessThan{Float64},
    }
    attr = MOI.Test.UnknownConstraintAttribute()
    message(action) = MOI.Bridges._attribute_error_message(attr, bridge, action)
    x = MOI.add_variable(bridged_mock)
    ci = MOI.add_constraint(bridged_mock, x, MOI.Interval(0.0, 1.0))
    @test !MOI.Bridges.is_bridged(bridged_mock, ci)
    @test MOI.Bridges.is_bridged(bridged_mock.model, ci)
    @test !MOI.supports(bridged_mock, attr, typeof(ci))
    err = ArgumentError(message("accessing"))
    @test_throws err MOI.get(bridged_mock, attr, ci)
    err = MOI.UnsupportedAttribute(attr, message("setting a value for"))
    @test_throws err MOI.set(bridged_mock, attr, ci, 1)
    attr = AttributeNotAllowed()
    err = MOI.SetAttributeNotAllowed(attr, message("setting a value for"))
    @test_throws err MOI.set(bridged_mock, attr, ci, 1)
    return
end

function test_issue_453()
    mock = MOI.Utilities.MockOptimizer(NoIntervalModel{Float64}())
    bridged_mock = MOI.Bridges.Constraint.LessToGreater{Float64}(
        MOI.Bridges.Constraint.SplitInterval{Float64}(mock),
    )
    MOI.Utilities.loadfromstring!(
        bridged_mock,
        """
    variables: x
    maxobjective: 3.0x
    c: 2.0x in Interval(1.0, 4.0)
    x in LessThan(1.5)
""",
    )
    x = MOI.get(bridged_mock, MOI.VariableIndex, "x")
    @test isa(x, MOI.VariableIndex)
    c1 = MOI.get(
        bridged_mock,
        MOI.ConstraintIndex{
            MOI.ScalarAffineFunction{Float64},
            MOI.Interval{Float64},
        },
        "c",
    )
    @test isa(
        c1,
        MOI.ConstraintIndex{
            MOI.ScalarAffineFunction{Float64},
            MOI.Interval{Float64},
        },
    )
    c2 = MOI.get(bridged_mock, MOI.ConstraintIndex, "c")
    @test c1 == c2
    @test MOI.is_valid(
        bridged_mock,
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}}(x.value),
    )
    return
end

function test_custom_test()
    model = MOI.Bridges.Constraint.SplitInterval{Int}(NoIntervalModel{Int}())
    @test !MOI.Bridges.supports_bridging_constraint(
        model,
        MOI.VectorAffineFunction{Float64},
        MOI.Interval{Float64},
    )

    x, y = MOI.add_variables(model, 2)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2

    f1 = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(3, x)], 7)
    c1 = MOI.add_constraint(model, f1, MOI.Interval(-1, 1))

    @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) ==
          [(MOI.ScalarAffineFunction{Int}, MOI.Interval{Int})]
    _test_num_constraints(
        model,
        MOI.ScalarAffineFunction{Int},
        MOI.GreaterThan{Int},
        0,
    )
    _test_num_constraints(
        model,
        MOI.ScalarAffineFunction{Int},
        MOI.Interval{Int},
        1,
    )
    @test (@inferred MOI.get(
        model,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Int},
            MOI.Interval{Int},
        }(),
    )) == [c1]

    f2 = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([2, -1], [x, y]), 2)
    c2 = MOI.add_constraint(model, f1, MOI.GreaterThan(-2))

    @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) == [
        (MOI.ScalarAffineFunction{Int}, MOI.GreaterThan{Int}),
        (MOI.ScalarAffineFunction{Int}, MOI.Interval{Int}),
    ]
    _test_num_constraints(
        model,
        MOI.ScalarAffineFunction{Int},
        MOI.GreaterThan{Int},
        1,
    )
    _test_num_constraints(
        model,
        MOI.ScalarAffineFunction{Int},
        MOI.Interval{Int},
        1,
    )
    @test (@inferred MOI.get(
        model,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Int},
            MOI.Interval{Int},
        }(),
    )) == [c1]
    @test (@inferred MOI.get(
        model,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Int},
            MOI.GreaterThan{Int},
        }(),
    )) == [c2]

    n = 4
    z = MOI.add_variables(model, n)
    scon_indices = MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Int}}[]
    for (i, v) in enumerate([x; y; z])
        f = v
        c = MOI.add_constraint(model, f, MOI.Interval(i, 2i))
        push!(scon_indices, c)

        @test Set(MOI.get(model, MOI.ListOfConstraintTypesPresent())) == Set([
            (MOI.ScalarAffineFunction{Int}, MOI.GreaterThan{Int}),
            (MOI.ScalarAffineFunction{Int}, MOI.Interval{Int}),
            (MOI.VariableIndex, MOI.Interval{Int}),
        ])
        _test_num_constraints(
            model,
            MOI.ScalarAffineFunction{Int},
            MOI.GreaterThan{Int},
            1,
        )
        _test_num_constraints(
            model,
            MOI.ScalarAffineFunction{Int},
            MOI.Interval{Int},
            1,
        )
        _test_num_constraints(model, MOI.VariableIndex, MOI.Interval{Int}, i)
        @test (@inferred MOI.get(
            model,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Int},
                MOI.Interval{Int},
            }(),
        )) == [c1]
        @test (@inferred MOI.get(
            model,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Int},
                MOI.GreaterThan{Int},
            }(),
        )) == [c2]
        # The indices should be returned in order of creation
        @test (@inferred MOI.get(
            model,
            MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Interval{Int}}(),
        )) == scon_indices
    end

    vcon_indices = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives}[]
    for (i, v) in enumerate(z)
        f = MOI.VectorOfVariables([v])
        c = MOI.add_constraint(model, f, MOI.Nonnegatives(1))
        push!(vcon_indices, c)

        @test Set(MOI.get(model, MOI.ListOfConstraintTypesPresent())) == Set([
            (MOI.ScalarAffineFunction{Int}, MOI.GreaterThan{Int}),
            (MOI.ScalarAffineFunction{Int}, MOI.Interval{Int}),
            (MOI.VariableIndex, MOI.Interval{Int}),
            (MOI.VectorOfVariables, MOI.Nonnegatives),
        ])
        _test_num_constraints(
            model,
            MOI.ScalarAffineFunction{Int},
            MOI.GreaterThan{Int},
            1,
        )
        _test_num_constraints(
            model,
            MOI.ScalarAffineFunction{Int},
            MOI.Interval{Int},
            1,
        )
        _test_num_constraints(
            model,
            MOI.VariableIndex,
            MOI.Interval{Int},
            n + 2,
        )
        _test_num_constraints(model, MOI.VectorOfVariables, MOI.Nonnegatives, i)
        @test (@inferred MOI.get(
            model,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Int},
                MOI.Interval{Int},
            }(),
        )) == [c1]
        @test (@inferred MOI.get(
            model,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Int},
                MOI.GreaterThan{Int},
            }(),
        )) == [c2]
        # The indices should be returned in order of creation
        @test (@inferred MOI.get(
            model,
            MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Interval{Int}}(),
        )) == scon_indices
        @test (@inferred MOI.get(
            model,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.Nonnegatives,
            }(),
        )) == vcon_indices
    end

    @test MOI.is_valid(model, c2)
    MOI.delete(model, c2)

    @test Set(MOI.get(model, MOI.ListOfConstraintTypesPresent())) == Set([
        (MOI.ScalarAffineFunction{Int}, MOI.Interval{Int}),
        (MOI.VariableIndex, MOI.Interval{Int}),
        (MOI.VectorOfVariables, MOI.Nonnegatives),
    ])
    _test_num_constraints(
        model,
        MOI.ScalarAffineFunction{Int},
        MOI.GreaterThan{Int},
        0,
    )
    _test_num_constraints(
        model,
        MOI.ScalarAffineFunction{Int},
        MOI.Interval{Int},
        1,
    )
    _test_num_constraints(model, MOI.VariableIndex, MOI.Interval{Int}, n + 2)
    _test_num_constraints(model, MOI.VectorOfVariables, MOI.Nonnegatives, n)
    @test (@inferred MOI.get(
        model,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Int},
            MOI.Interval{Int},
        }(),
    )) == [c1]
    # The indices should be returned in order of creation
    @test (@inferred MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Interval{Int}}(),
    )) == scon_indices
    @test (@inferred MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonnegatives}(),
    )) == vcon_indices
    return
end

function test_MOI_Test()
    mock = MOI.Utilities.MockOptimizer(NoIntervalModel{Float64}())
    bridged_mock = MOI.Bridges.Constraint.LessToGreater{Float64}(
        MOI.Bridges.Constraint.SplitInterval{Float64}(mock),
    )
    MOI.Test.runtests(
        bridged_mock,
        MOI.Test.Config(exclude = Any[MOI.optimize!]),
        include = ["test_linear_", "test_model_"],
        exclude = [
            "test_model_LowerBoundAlreadySet",
            "test_model_UpperBoundAlreadySet",
            "test_model_ListOfConstraintAttributesSet",
        ],
    )
    return
end

MOI.Utilities.@model(
    AffineOnlyModel,
    (),
    (MOI.Interval,),
    (MOI.PositiveSemidefiniteConeTriangle,),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    (MOI.VectorAffineFunction,),
    true
)

function MOI.supports_constraint(
    ::AffineOnlyModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.LessThan{T}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::AffineOnlyModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.Interval{T}},
) where {T}
    return false
end

function test_double_deletion_scalar()
    # The variable is bridged to `VariableIndex`-in-`Interval` and then `ScalarAffineFunction`-in-`Interval`.
    # Hence there is two bridged `VariableIndex` constraints on the same variables and we need to be
    # careful not to delete the second one twice, see https://github.com/jump-dev/MathOptInterface.jl/issues/1231
    model =
        MOI.instantiate(AffineOnlyModel{Float64}, with_bridge_type = Float64)
    # If LessToGreaterBridge exists, this goes from:
    #   VariableIndex(x) in LessThan(1.0)
    #   ScalarAffineFunction(-1.0x) in GreaterThan(-1.0)     (LessToGreater)
    #   ScalarAffineFunction(-1.0x) in Interval(-1.0, Inf)   (GreaterToInterval)
    # we want instead
    #   VariableIndex(x) in LessThan(1.0)
    #   VariableIndex(x) in Interval(-Inf, 1.0)             (LessToInterval)
    #   ScalarAffineFunction(1.0x) in Interval(-Inf, 1.0)   (FunctionConversion)
    # To check that we handle the LessThan and Interval sets on the same
    # VariableIndex correctly.
    MOI.Bridges.remove_bridge(
        model,
        MOI.Bridges.Constraint.LessToGreaterBridge{Float64},
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.LessThan(1.0))
    # Need to test the bridging to make sure it's not functionized first as otherwise,
    # this test would not cover the case we want to test
    b1 = MOI.Bridges.bridge(model, c)
    @test b1 isa MOI.Bridges.Constraint.LessToIntervalBridge
    b2 = MOI.Bridges.bridge(model, b1.constraint)
    @test b2 isa MOI.Bridges.Constraint.ScalarFunctionizeBridge
    @test !MOI.Bridges.is_bridged(model, b2.constraint)
    MOI.delete(model, x)
    @test !MOI.is_valid(model, x)
    @test MOI.is_empty(model)
    return
end

function test_double_deletion_vector()
    model =
        MOI.instantiate(AffineOnlyModel{Float64}, with_bridge_type = Float64)
    x = MOI.add_variables(model, 4)
    c = MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.PositiveSemidefiniteConeSquare(2),
    )
    b1 = MOI.Bridges.bridge(model, c)
    @test b1 isa MOI.Bridges.Constraint.SquareBridge
    b2 = MOI.Bridges.bridge(model, b1.triangle)
    @test b2 isa MOI.Bridges.Constraint.VectorFunctionizeBridge
    @test !MOI.Bridges.is_bridged(model, b2.constraint)
    MOI.delete(model, x)
    @test all(vi -> !MOI.is_valid(model, vi), x)
    @test MOI.is_empty(model)
    return
end

function test_nesting_SingleBridgeOptimizer()
    T = Float64
    model = MOI.Utilities.Model{T}()
    b0 = MOI.Bridges.Variable.Free{T}(model)
    b1 = MOI.Bridges.Constraint.ScalarFunctionize{T}(b0)
    b2 = MOI.Bridges.Constraint.VectorFunctionize{T}(b1)
    b = MOI.Bridges.Objective.Functionize{T}(b2)
    x = MOI.add_variable(b)
    @test MOI.is_valid(b, x)
    @test !MOI.Bridges.is_bridged(b, x)
    @test MOI.is_valid(b2, x)
    @test !MOI.Bridges.is_bridged(b2, x)
    @test MOI.is_valid(b1, x)
    @test !MOI.Bridges.is_bridged(b1, x)
    @test MOI.is_valid(b0, x)
    @test MOI.Bridges.is_bridged(b0, x)
    @test !MOI.is_valid(model, x)
    clt = MOI.add_constraint(b, x, MOI.LessThan(one(T)))
    @test MOI.is_valid(b, clt)
    @test !MOI.Bridges.is_bridged(b, clt)
    @test MOI.is_valid(b2, clt)
    @test !MOI.Bridges.is_bridged(b2, clt)
    @test MOI.is_valid(b1, clt)
    @test MOI.Bridges.is_bridged(b1, clt)
    @test !MOI.is_valid(b0, clt)
    @test !MOI.is_valid(model, clt)
    cnn =
        MOI.add_constraint(b, MOI.Utilities.vectorize([x]), MOI.Nonnegatives(1))
    @test MOI.is_valid(b, cnn)
    @test !MOI.Bridges.is_bridged(b, cnn)
    @test MOI.is_valid(b2, cnn)
    @test MOI.Bridges.is_bridged(b2, cnn)
    @test !MOI.is_valid(b1, cnn)
    @test !MOI.is_valid(b0, cnn)
    @test !MOI.is_valid(model, cnn)
    obj = x
    attr = MOI.ObjectiveFunction{typeof(obj)}()
    MOI.set(b, attr, obj)
    @test MOI.Bridges.is_bridged(b, attr)
    obj = one(T) * x
    attr = MOI.ObjectiveFunction{typeof(obj)}()
    MOI.set(b, attr, obj)
    @test !MOI.Bridges.is_bridged(b, attr)
    @test !MOI.Bridges.is_bridged(b2, attr)
    @test !MOI.Bridges.is_bridged(b1, attr)
    @test !MOI.Bridges.is_bridged(b0, attr)
    return
end

struct UnsupportedSet <: MOI.AbstractScalarSet end

function test_supports_bridging_constrained_variable()
    model = MOI.Bridges.Constraint.SplitInterval{Int}(NoIntervalModel{Int}())
    @test !MOI.Bridges.supports_bridging_constrained_variable(
        model,
        UnsupportedSet,
    )
    return
end

function test_supports_add_constrained_variable()
    model = MOI.Bridges.Constraint.SplitInterval{Int}(NoIntervalModel{Int}())
    @test !MOI.supports_add_constrained_variable(model, UnsupportedSet)
    return
end

function test_supports_bridging_constraint()
    model = MOI.Bridges.Constraint.SplitInterval{Int}(NoIntervalModel{Int}())
    @test !MOI.Bridges.supports_bridging_constraint(
        model,
        MOI.VariableIndex,
        UnsupportedSet,
    )
    return
end

function test_supports_bridging_objective_function()
    model = MOI.Bridges.Constraint.SplitInterval{Int}(NoIntervalModel{Int}())
    @test !MOI.Bridges.supports_bridging_objective_function(
        model,
        MOI.VariableIndex,
    )
    return
end

function test_get_ObjectiveFunctionType()
    model = MOI.Bridges.Constraint.SplitInterval{Int}(NoIntervalModel{Int}())
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == MOI.VariableIndex
    return
end

include("identity_bridge.jl")

function test_recursive_model_variable(::Type{T} = Int) where {T}
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}())
    BT = IdentityBridges.VariableBridge{T}
    b = MOI.Bridges.Variable.SingleBridgeOptimizer{BT}(model)
    x, cx = MOI.add_constrained_variable(b, MOI.EqualTo(one(T)))
    @test MOI.Bridges.is_bridged(b, x)
    @test MOI.Bridges.is_bridged(b, cx)
    @test MOI.get(b, MOI.ConstraintFunction(), cx) == x
    @test MOI.get(b, MOI.ConstraintSet(), cx) == MOI.EqualTo(one(T))
    MOI.set(b, MOI.ConstraintSet(), cx, MOI.EqualTo(zero(T)))
    @test MOI.get(b, MOI.ConstraintSet(), cx) == MOI.EqualTo(zero(T))
    @test MOI.is_valid(b, x)
    MOI.delete(b, x)
    @test !MOI.is_valid(b, x)
    MOI.Bridges.runtests(
        IdentityBridges.VariableBridge,
        """
        constrainedvariable: x in EqualTo(1.0)
        minobjective: 1.0 * x + 2.0
        """,
        """
        constrainedvariable: x in EqualTo(1.0)
        minobjective: 1.0 * x + 2.0
        """,
    )
    return
end

function test_recursive_model_constraint(::Type{T} = Int) where {T}
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}())
    BT = IdentityBridges.ConstraintBridge{T}
    b = MOI.Bridges.Constraint.SingleBridgeOptimizer{BT}(model)
    x = MOI.add_variable(b)
    func = one(T) * x
    set = MOI.EqualTo(zero(T))
    c = MOI.add_constraint(b, func, set)
    @test MOI.Bridges.is_bridged(b, c)
    @test MOI.get(b, MOI.ConstraintFunction(), c) ≈ func
    new_func = T(2) * x
    MOI.set(b, MOI.ConstraintFunction(), c, new_func)
    @test MOI.get(b, MOI.ConstraintFunction(), c) ≈ new_func
    MOI.modify(b, c, MOI.ScalarCoefficientChange(x, T(3)))
    @test MOI.get(b, MOI.ConstraintFunction(), c) ≈ T(3) * x
    MOI.modify(b, c, MOI.ScalarConstantChange(T(-1)))
    @test MOI.get(b, MOI.ConstraintFunction(), c) ≈ T(3) * x + T(-1)
    @test MOI.get(b, MOI.ConstraintSet(), c) == set
    new_set = MOI.EqualTo(one(T))
    MOI.set(b, MOI.ConstraintSet(), c, new_set)
    @test MOI.get(b, MOI.ConstraintSet(), c) == new_set
    MOI.set(b, MOI.ConstraintDualStart(), c, one(T))
    @test MOI.get(b, MOI.ConstraintDualStart(), c) == one(T)
    @test MOI.is_valid(b, c)
    MOI.delete(b, c)
    @test !MOI.is_valid(b, c)
    return
end

function test_recursive_model_objective(::Type{T} = Int) where {T}
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}())
    BT = IdentityBridges.ObjectiveBridge{T}
    b = MOI.Bridges.Objective.SingleBridgeOptimizer{BT}(model)
    x = MOI.add_variable(b)
    func = one(T) * x
    MOI.set(b, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test !MOI.Bridges.is_objective_bridged(b)
    attr = MOI.ObjectiveFunction{typeof(func)}()
    MOI.set(b, attr, func)
    @test MOI.Bridges.is_objective_bridged(b)
    @test MOI.get(b, attr) ≈ func
    attr = MOI.ObjectiveFunction{typeof(x)}()
    MOI.set(b, attr, x)
    @test !MOI.Bridges.is_objective_bridged(b)
    @test MOI.get(b, attr) ≈ x
end

function test_invalid_modifications()
    model = MOI.Bridges.full_bridge_optimizer(
        MOI.Utilities.Model{Float64}(),
        Float64,
    )
    config = MOI.Test.Config()
    MOI.Test.test_modification_set_function_single_variable(model, config)
    MOI.empty!(model)
    MOI.Test.test_modification_incorrect(model, config)
    MOI.empty!(model)
    MOI.Test.test_modification_incorrect_VariableIndex(model, config)
    return
end

function test_ListOfConstraintAttributesSet()
    model = MOI.Bridges.Constraint.SplitInterval{Float64}(
        MOI.Utilities.Model{Float64}(),
    )
    x = MOI.add_variable(model)
    f = 1.0 * x
    s = MOI.Interval(0.0, 1.0)
    c = MOI.add_constraint(model, f, s)
    MOI.set(model, MOI.ConstraintName(), c, "c")
    @test MOI.get(
        model,
        MOI.ListOfConstraintAttributesSet{typeof(f),typeof(s)}(),
    ) == [MOI.ConstraintName()]
    return
end

function test_constant_modification_with_affine_variable_bridge()
    model = MOI.Utilities.Model{Float64}()
    b = MOI.Bridges.Variable.Vectorize{Float64}(model)
    x, cx = MOI.add_constrained_variable(b, MOI.GreaterThan(1.0))
    func = MOI.Utilities.vectorize([3.0x + 2.0])
    ci = MOI.add_constraint(b, func, MOI.Zeros(1))
    obj_func = 4.0x - 1.0
    obj = MOI.ObjectiveFunction{typeof(obj_func)}()
    MOI.set(b, obj, obj_func)
    y = MOI.Bridges.bridged_variable_function(b, x)
    attr = MOI.ConstraintFunction()
    MOI.modify(b, ci, MOI.VectorConstantChange([-1.0]))
    new_func = MOI.Utilities.vectorize([3.0x - 1.0])
    new_inner_func = MOI.Utilities.vectorize([3.0y - 1.0])
    @test MOI.get(b, MOI.ConstraintFunction(), ci) ≈ new_func
    @test MOI.get(model, MOI.ConstraintFunction(), ci) ≈ new_inner_func
    MOI.modify(b, obj, MOI.ScalarConstantChange(1.0))
    new_obj = 4.0x + 1.0
    new_inner_obj = 4.0y + 1.0
    @test MOI.get(b, obj) ≈ new_obj
    @test MOI.get(model, obj) ≈ new_inner_obj
end

struct _IssueIpopt333 <: MOI.AbstractOptimizer end

function MOI.supports(
    ::_IssueIpopt333,
    ::MOI.ConstraintDualStart,
    ::Type{MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}}},
)
    return true
end

function MOI.supports_constraint(
    ::_IssueIpopt333,
    ::Type{MOI.VariableIndex},
    ::Type{MOI.GreaterThan{Float64}},
)
    return true
end

function test_IssueIpopt333_supports_ConstraintDualStart_VariableIndex()
    model = MOI.Bridges.full_bridge_optimizer(_IssueIpopt333(), Float64)
    attr = MOI.ConstraintDualStart()
    IndexType = MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}}
    @test MOI.supports(model, attr, IndexType)
    return
end

mutable struct _Issue1992 <: MOI.AbstractOptimizer
    supports::Bool
    variables::Int
    constraints::Int
    _Issue1992(flag) = new(flag, 0, 0)
end

function MOI.supports_add_constrained_variables(
    ::_Issue1992,
    ::Type{<:Union{MOI.Nonpositives,MOI.Nonnegatives}},
)
    return true
end

function MOI.add_constrained_variables(
    model::_Issue1992,
    set::S,
) where {S<:Union{MOI.Nonpositives,MOI.Nonnegatives}}
    model.variables += 1
    ci = MOI.ConstraintIndex{MOI.VectorOfVariables,S}(model.variables)
    return MOI.VariableIndex.(1:set.dimension), ci
end

function MOI.add_constraint(
    model::_Issue1992,
    ::F,
    ::S,
) where {F<:MOI.VectorAffineFunction{Float64},S<:MOI.Nonnegatives}
    model.constraints += 1
    return MOI.ConstraintIndex{F,S}(model.constraints)
end

function MOI.supports_constraint(
    ::_Issue1992,
    ::Type{MOI.VectorAffineFunction{Float64}},
    ::Type{MOI.Nonnegatives},
)
    return true
end

function MOI.supports(
    model::_Issue1992,
    ::MOI.ConstraintDualStart,
    ::Type{MOI.ConstraintIndex{F,MOI.Nonnegatives}},
) where {F<:MOI.VectorAffineFunction{Float64}}
    return model.supports
end

function test_Issue1992_supports_ConstraintDualStart_VariableIndex()
    # supports should be false
    model = MOI.Bridges.full_bridge_optimizer(_Issue1992(false), Float64)
    x, _ = MOI.add_constrained_variables(model, MOI.Nonpositives(1))
    c = MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Nonnegatives(1))
    @test !MOI.supports(model, MOI.ConstraintDualStart(), typeof(c))
    # supports should be true
    model = MOI.Bridges.full_bridge_optimizer(_Issue1992(true), Float64)
    x, _ = MOI.add_constrained_variables(model, MOI.Nonpositives(1))
    c = MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Nonnegatives(1))
    # !!! warning
    #     This test is broken with a false negative. See the discussion in
    #     PR#1992.
    @test_broken MOI.supports(model, MOI.ConstraintDualStart(), typeof(c))
    return
end

function test_bridge_supports_issue_1992()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.NonposToNonneg{Float64}(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.VectorOfVariables([x]),
        MOI.Nonpositives(1),
    )
    @test MOI.supports(model, MOI.ConstraintDualStart(), typeof(c))
    @test MOI.get(model, MOI.ConstraintDualStart(), c) === nothing
    MOI.set(model, MOI.ConstraintDualStart(), c, [1.0])
    @test MOI.get(model, MOI.ConstraintDualStart(), c) == [1.0]
    return
end

function test_delete_constraint_vector()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.GreaterToLess{Float64}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint.(model, 1.0 .* x, MOI.GreaterThan.(1.0:3.0))
    c_eq = MOI.add_constraint.(model, 1.0 .* x, MOI.EqualTo.(1.0:3.0))
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 3
    MOI.delete(model, c)
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 0
    c = MOI.add_constraint.(model, 1.0 .* x, MOI.GreaterThan.(1.0:3.0))
    MOI.delete(model, [c[1], c[3]])
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    @test MOI.get(model, MOI.ConstraintSet(), c[2]) == MOI.GreaterThan(2.0)
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 3
    MOI.delete(model, c_eq)
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 0
    c_eq = MOI.add_constraint.(model, 1.0 .* x, MOI.EqualTo.(1.0:3.0))
    MOI.delete(model, [c_eq[1], c_eq[3]])
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    @test MOI.get(model, MOI.ConstraintSet(), c_eq[2]) == MOI.EqualTo(2.0)
    return
end

function test_deleting_variable_in_bridged_objective()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Objective.VectorFunctionize{Float64}(inner)
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    attr = MOI.ObjectiveFunction{MOI.VectorOfVariables}()
    MOI.set(model, attr, MOI.VectorOfVariables(x))
    MOI.delete(model, x[1])
    @test MOI.get(model, attr) == MOI.VectorOfVariables([x[2]])
    return
end

function test_deleting_variables_in_bridged_objective()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Objective.VectorFunctionize{Float64}(inner)
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    attr = MOI.ObjectiveFunction{MOI.VectorOfVariables}()
    MOI.set(model, attr, MOI.VectorOfVariables(x))
    MOI.delete(model, [x[1]])
    @test MOI.get(model, attr) == MOI.VectorOfVariables([x[2]])
    return
end

function test_deleting_all_variables_in_bridged_objective()
    # We need to make sure that the bridges have the same functionality as the
    # base Utilities.Model.
    model_1 = MOI.Utilities.Model{Float64}()
    model_2 = MOI.Bridges.Objective.VectorFunctionize{Float64}(
        MOI.Utilities.Model{Float64}(),
    )
    for model in (model_1, model_2)
        x = MOI.add_variable(model)
        f = MOI.VectorOfVariables([x])
        MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
        MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
        MOI.delete(model, x)
        attrs = MOI.get(model, MOI.ListOfModelAttributesSet())
        @test length(attrs) == 1
        @test attrs[1] == MOI.ObjectiveSense()
    end
    return
end

function test_deleting_all_vector_variables_in_bridged_objective()
    # We need to make sure that the bridges have the same functionality as the
    # base Utilities.Model.
    model_1 = MOI.Utilities.Model{Float64}()
    model_2 = MOI.Bridges.Objective.VectorFunctionize{Float64}(
        MOI.Utilities.Model{Float64}(),
    )
    for model in (model_1, model_2)
        x = MOI.add_variable(model)
        f = MOI.VectorOfVariables([x])
        MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
        MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
        MOI.delete(model, [x])
        attrs = MOI.get(model, MOI.ListOfModelAttributesSet())
        @test length(attrs) == 1
        @test attrs[1] == MOI.ObjectiveSense()
    end
    return
end

function test_deleting_all_variables_in_bridged_functionize_objective()
    # We need to make sure that the bridges have the same functionality as the
    # base Utilities.Model.
    model_1 = MOI.Utilities.Model{Float64}()
    model_2 = MOI.Bridges.Objective.Functionize{Float64}(
        MOI.Utilities.Model{Float64}(),
    )
    for model in (model_1, model_2)
        x = MOI.add_variable(model)
        MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
        MOI.set(model, MOI.ObjectiveFunction{typeof(x)}(), x)
        MOI.delete(model, x)
        attrs = MOI.get(model, MOI.ListOfModelAttributesSet())
        @test length(attrs) == 1
        @test MOI.ObjectiveSense() in attrs
    end
    return
end

function test_modify_objective_scalar_quadratic_coefficient_change()
    T = Float64
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}())
    model = MOI.Bridges.Objective.Slack{T}(inner)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    attr = MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}()
    MOI.set(model, attr, T(1) * x * x + T(2) * x + T(3))
    change = MOI.ScalarQuadraticCoefficientChange(x, x, T(4))
    @test_throws(
        MOI.Bridges.ModifyBridgeNotAllowed,
        MOI.modify(model, attr, change),
    )
    return
end

function test_modify_variable_scalar_quadratic_coefficient_change()
    T = Float64
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}())
    model = MOI.Bridges.Variable.Free{T}(inner)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    attr = MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}()
    MOI.set(model, attr, T(1) * x * x + T(2) * x + T(3))
    change = MOI.ScalarQuadraticCoefficientChange(x, x, T(4))
    @test_throws MOI.ModifyObjectiveNotAllowed MOI.modify(model, attr, change)
    return
end

function test_modify_constraint_scalar_quadratic_coefficient_change()
    T = Float64
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}())
    model = MOI.Bridges.Constraint.QuadtoSOC{T}(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, T(1) * x * x + T(2) * x, MOI.LessThan(T(1)))
    change = MOI.ScalarQuadraticCoefficientChange(x, x, T(4))
    @test_throws(
        MOI.Bridges.ModifyBridgeNotAllowed,
        MOI.modify(model, c, change),
    )
    return
end

function test_show_modify_bridge_not_allowed()
    x = MOI.VariableIndex(1)
    change = MOI.ScalarQuadraticCoefficientChange(x, x, 2.0)
    err = MOI.Bridges.ModifyBridgeNotAllowed(change)
    @test occursin("cannot be performed", sprint(showerror, err))
    return
end

function test_list_of_constraints_with_attribute_set()
    config = MOI.Test.Config()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64)
    MOI.Test.test_model_ListOfConstraintsWithAttributeSet(model, config)
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.Vectorize{Float64}(inner)
    MOI.Test.test_model_ListOfConstraintsWithAttributeSet(model, config)
    return
end

function test_first_bridge()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    bridge = MOI.Bridges.Constraint.ZeroOne{Float64}(inner)
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        bridge,
    )
    x = MOI.add_variable(model)
    ci = MOI.add_constraint(model, x, MOI.ZeroOne())
    MOI.Utilities.attach_optimizer(model)
    b = MOI.get(model, MOI.Bridges.FirstBridge(), ci)
    @test b isa MOI.Bridges.Constraint.ZeroOneBridge
    y = MOI.add_variable(model)
    ci = MOI.add_constraint(model, y, MOI.Integer())
    @test_throws(
        MOI.GetAttributeNotAllowed{MOI.Bridges.FirstBridge},
        MOI.get(model, MOI.Bridges.FirstBridge(), ci),
    )
    return
end

function test_variable_bridge_constraint_attribute()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Bridges.Variable.NonposToNonneg{Float64}(mock)
    x, cx = MOI.add_constrained_variables(model, MOI.Nonpositives(2))
    y, cy = MOI.add_constrained_variables(model, MOI.Nonpositives(2))
    @test MOI.Bridges.bridge(model, x[1]) === MOI.Bridges.bridge(model, cx)
    @test MOI.Bridges.bridge(model, x[2]) === MOI.Bridges.bridge(model, cx)
    @test MOI.Bridges.bridge(model, y[1]) === MOI.Bridges.bridge(model, cy)
    @test MOI.Bridges.bridge(model, y[2]) === MOI.Bridges.bridge(model, cy)
    var = [x; y]
    val = float.(collect(1:4))
    mock_var = MOI.get(mock, MOI.ListOfVariableIndices())
    MOI.set(mock, MOI.VariablePrimal(), mock_var, -val)
    @test MOI.get(model, MOI.VariablePrimal(), var) == val
    @test MOI.get(model, MOI.ConstraintPrimal(), cx) == val[1:2]
    @test MOI.get(model, MOI.ConstraintPrimal(), cy) == val[3:4]
    for v in var
        @test MOI.is_valid(model, v)
    end
    @test MOI.is_valid(model, cx)
    @test MOI.is_valid(model, cy)
    MOI.delete(model, x)
    @test !MOI.is_valid(model, cx)
    @test MOI.is_valid(model, cy)
    return
end

function test_ListOfVariablesWithAttributeSet(T = Float64)
    uf = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}())
    model = MOI.Bridges.full_bridge_optimizer(uf, T)
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.VariableName(), x[1], "x")
    # Passed through to Model with no special support
    attr = MOI.ListOfVariablesWithAttributeSet(MOI.VariableName())
    @test MOI.get(model, attr) == x
    # Handled by UniversalFallback
    attr = MOI.ListOfVariablesWithAttributeSet(MOI.VariablePrimalStart())
    # no attributes set
    @test MOI.get(model, attr) == MOI.VariableIndex[]
    # one attribute set
    MOI.set(model, MOI.VariablePrimalStart(), x[2], 1.0)
    @test MOI.get(model, attr) == [x[2]]
    return
end

function test_cannot_unbridge_variable_function()
    model = MOI.Bridges.Variable.Zeros{Float64}(MOI.Utilities.Model{Float64}())
    x, c = MOI.add_constrained_variables(model, MOI.Zeros(1))
    c2 = MOI.add_constraint(model, 1.0 * x[1], MOI.EqualTo(1.0))
    @test_throws(
        MOI.GetAttributeNotAllowed{MOI.ConstraintFunction},
        MOI.get(model, MOI.ConstraintFunction(), c2),
    )
    return
end

MOI.Utilities.@model(
    Model2452,
    (),
    (),
    (MOI.Nonnegatives, MOI.Zeros),
    (),
    (),
    (),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction,)
)

function MOI.supports_constraint(
    ::Model2452{T},
    ::Type{MOI.VariableIndex},
    ::Type{
        <:Union{
            MOI.GreaterThan{T},
            MOI.LessThan{T},
            MOI.EqualTo{T},
            MOI.Interval{T},
            MOI.ZeroOne,
        },
    },
) where {T}
    return false
end

function MOI.supports_constraint(
    ::Model2452{T},
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.Reals},
) where {T}
    return false
end

function test_issue_2452_multiple_variable_bridges()
    src = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(src)
    MOI.add_constraint(src, x, MOI.LessThan(1.0))
    c = MOI.add_constraint(src, 2.0 * x, MOI.EqualTo(3.0))
    dest = MOI.instantiate(Model2452{Float64}; with_bridge_type = Float64)
    index_map = MOI.copy_to(dest, src)
    set = MOI.get(dest, MOI.ConstraintSet(), index_map[c])
    @test set == MOI.EqualTo(3.0)
    @test_throws(
        MOI.SetAttributeNotAllowed,
        MOI.set(dest, MOI.ConstraintSet(), index_map[c], set),
    )
    return
end

function test_2452()
    F, S = MOI.VectorAffineFunction{Float64}, MOI.Zeros
    src = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(src)
    MOI.add_constraint(src, x, MOI.GreaterThan(1.0))
    set = MOI.EqualTo(3.0)
    c = MOI.add_constraint(src, 2.0 * x, set)
    dest = MOI.instantiate(Model2452{Float64}; with_bridge_type = Float64)
    index_map = MOI.copy_to(dest, src)
    y = only(MOI.get(dest.model, MOI.ListOfVariableIndices()))
    ci = only(MOI.get(dest.model, MOI.ListOfConstraintIndices{F,S}()))
    @test MOI.get(dest, MOI.ConstraintSet(), index_map[c]) == set
    @test ≈(
        MOI.get(dest.model, MOI.ConstraintFunction(), ci),
        MOI.Utilities.operate(vcat, Float64, -1.0 + 2.0 * y),
    )
    @test MOI.get(dest.model, MOI.ConstraintSet(), ci) == MOI.Zeros(1)
    @test_throws(
        MOI.SetAttributeNotAllowed,
        MOI.set(dest, MOI.ConstraintSet(), index_map[c], set),
    )
    return
end

function test_issue_2452_with_constant()
    src = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(src)
    MOI.add_constraint(src, x, MOI.GreaterThan(1.0))
    MOI.add_constraint(src, 2.0 * x + 1.0, MOI.EqualTo(3.0))
    dest = MOI.instantiate(Model2452{Float64}; with_bridge_type = Float64)
    @test_throws MOI.ScalarFunctionConstantNotZero MOI.copy_to(dest, src)
    return
end

function test_issue_2452_integer()
    src = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(src)
    MOI.add_constraint(src, x, MOI.GreaterThan(1.0))
    y = MOI.add_variable(src)
    c = MOI.add_constraint(src, 1.0 * y, MOI.Integer())
    dest = MOI.instantiate(Model2452{Float64}; with_bridge_type = Float64)
    index_map = MOI.copy_to(dest, src)
    @test MOI.get(dest, MOI.ConstraintSet(), index_map[c]) == MOI.Integer()
    return
end

struct EmptyBridgeOptimizer <: MOI.Bridges.AbstractBridgeOptimizer end

function test_supports_bridging_constrained_variable_fallback()
    @test !MOI.Bridges.supports_bridging_constrained_variable(
        EmptyBridgeOptimizer(),
        MOI.ZeroOne,
    )
    return
end

function test_supports_bridging_constraint_fallback()
    @test !MOI.Bridges.supports_bridging_constraint(
        EmptyBridgeOptimizer(),
        MOI.ScalarAffineFunction{Float64},
        MOI.EqualTo{Float64},
    )
    return
end

function test_delete_variable_from_bridged_objective()
    model = MOI.Utilities.Model{Float64}()
    b = MOI.Bridges.Objective.VectorFunctionize{Float64}(model)
    x = MOI.add_variables(b, 2)
    y = MOI.add_variable(b)
    f = MOI.VectorOfVariables(x)
    MOI.set(b, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(b, MOI.ObjectiveFunction{typeof(f)}(), f)
    G = MOI.VectorAffineFunction{Float64}
    g = MOI.get(model, MOI.ObjectiveFunction{G}())
    MOI.delete(b, y)
    @test g ≈ MOI.get(model, MOI.ObjectiveFunction{G}())
    MOI.delete(b, x[1])
    @test ≈(
        MOI.Utilities.vectorize([MOI.Utilities.scalarize(g)[2]]),
        MOI.get(model, MOI.ObjectiveFunction{G}()),
    )
    MOI.delete(b, x[2])
    @test ≈(
        MOI.Utilities.vectorize([zero(MOI.ScalarAffineFunction{Float64})]),
        MOI.get(model, MOI.ObjectiveFunction{G}()),
    )
    return
end

function test_get_ObjectiveFunctionValue()
    model = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    b = MOI.Bridges.full_bridge_optimizer(model, Float64)
    x = MOI.add_variable(b)
    MOI.set(b, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(b, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    y = only(MOI.get(model, MOI.ListOfVariableIndices()))
    MOI.set(model, MOI.VariablePrimal(1), y, 1.23)
    @test MOI.get(b, MOI.Bridges.ObjectiveFunctionValue{typeof(x)}(1)) == 1.23
    return
end

function test_bridged_function()
    model = MOI.Utilities.Model{Float64}()
    b = MOI.Bridges.Variable.Free{Float64}(model)
    x = MOI.add_variable(b)
    y, _ = MOI.add_constrained_variable(b, MOI.GreaterThan(1.0))
    @test_throws(
        ErrorException("Using bridged variable in `VariableIndex` function."),
        MOI.Bridges.bridged_function(b, x),
    )
    @test MOI.Bridges.bridged_function(b, y) == y
    return
end

function test_bridged_constraint_function_no_variable_bridges()
    model = MOI.Utilities.Model{Float64}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, Float64)
    x = MOI.add_variable(bridged)
    set = MOI.ZeroOne()
    @test MOI.Bridges.bridged_constraint_function(bridged, x, set) == (x, set)
    return
end

function test_bridged_constraint_function_with_variable_bridges()
    model = MOI.Utilities.Model{Float64}()
    b = MOI.Bridges.Variable.Free{Float64}(model)
    x = MOI.add_variable(b)
    set = MOI.ZeroOne()
    f, set = MOI.Bridges.bridged_constraint_function(b, 1.0 * x, set)
    @test set == MOI.ZeroOne()
    y = MOI.get(model, MOI.ListOfVariableIndices())
    @test f ≈ 1.0 * y[1] - 1.0 * y[2]
    return
end

struct EmptyObjectiveBridge <: MOI.Bridges.Objective.AbstractBridge end

function test_fallback_bridge_objective()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    @test_throws(
        MOI.UnsupportedAttribute(MOI.ObjectiveFunction{MOI.VariableIndex}()),
        MOI.Bridges.Objective.bridge_objective(EmptyObjectiveBridge, model, x),
    )
    return
end

function test_fallback_set_objective_sense()
    model = MOI.Utilities.Model{Float64}()
    bridge = EmptyObjectiveBridge()
    @test_throws(
        MOI.SetAttributeNotAllowed{MOI.ObjectiveSense},
        MOI.set(model, MOI.ObjectiveSense(), bridge, MOI.MIN_SENSE),
    )
    return
end

function test_fallback_get_objective_function()
    model = MOI.Utilities.Model{Float64}()
    attr = MOI.ObjectiveFunction{MOI.VariableIndex}()
    @test_throws(
        MOI.GetAttributeNotAllowed{typeof(attr)},
        MOI.get(model, attr, EmptyObjectiveBridge()),
    )
    return
end

function test_fallback_delete_objective_bridge()
    model = MOI.Utilities.Model{Float64}()
    @test_throws ArgumentError MOI.delete(model, EmptyObjectiveBridge())
    return
end

struct Model2714 <: MOI.ModelLike
    dimensions::Vector{Int}
    Model2714() = new(Int[])
end

MOI.is_empty(model::Model2714) = isempty(model.dimensions)

function MOI.supports_add_constrained_variables(
    ::Model2714,
    ::Type{MOI.Nonnegatives},
)
    return true
end

function MOI.add_constrained_variables(model::Model2714, set::MOI.Nonnegatives)
    n = MOI.dimension(set)
    x = MOI.VariableIndex(sum(model.dimensions) .+ (1:n))
    push!(model.dimensions, n)
    F, S = MOI.VectorOfVariables, MOI.Nonnegatives
    return x, MOI.ConstraintIndex{F,S}(length(model.dimensions))
end

function test_issue_2714()
    model = MOI.instantiate(Model2714; with_bridge_type = Float64)
    t, _ = MOI.add_constrained_variable(model, MOI.LessThan(10.0))
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [t]
    return
end

function test_BridgeRequiresFiniteDomainError()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.SOS1ToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.SOS1([1, 2, 3]))
    err = MOI.Bridges.BridgeRequiresFiniteDomainError(model.map[c], x[1])
    contents = sprint(showerror, err)
    @test occursin("To fix this error, add a lower and upper bound", contents)
    return
end

MOI.Utilities.@model(
    Model2817a,
    (),
    (),
    (MOI.Nonnegatives,),
    (),
    (),
    (),
    (),
    (MOI.VectorAffineFunction,)
);

function MOI.supports_constraint(
    ::Model2817a,
    ::Type{MOI.VariableIndex},
    ::Type{S},
) where {S<:MOI.AbstractScalarSet}
    return false
end

function test_issue_2817a()
    inner = Model2817a{Float64}()
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64);
    x, c = MOI.add_constrained_variable(model, MOI.Interval(0.0, 1.0));
    @test isa(
        model.constraint_map[c],
        MOI.Bridges.Constraint.IntervalToHyperRectangleBridge,
    )
    MOI.delete(model, x)
    @test !MOI.is_valid(model, x)
    @test MOI.is_empty(model)
    @test MOI.is_empty(inner)
    @test isempty(model.constraint_map)
    return
end

MOI.Utilities.@model(
    Model2817b,
    (),
    (MOI.LessThan,),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
);

function MOI.supports_constraint(
    ::Model2817b,
    ::Type{MOI.VariableIndex},
    ::Type{S},
) where {S<:MOI.AbstractScalarSet}
    return false
end

function test_issue_2817b()
    inner = Model2817b{Float64}()
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64);
    x, c = MOI.add_constrained_variables(model, MOI.Nonpositives(1))
    @test isa(model.constraint_map[c], MOI.Bridges.Constraint.ScalarizeBridge)
    MOI.delete(model, x)
    @test !MOI.is_valid(model, x[1])
    @test MOI.is_empty(model)
    @test MOI.is_empty(inner)
    @test isempty(model.constraint_map)
    return
end

MOI.Utilities.@model(
    Model2817c,
    (),
    (MOI.GreaterThan, MOI.LessThan),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
);

function MOI.supports_constraint(
    ::Model2817c,
    ::Type{MOI.VariableIndex},
    ::Type{S},
) where {S<:Union{MOI.ZeroOne,MOI.Semiinteger,MOI.Semicontinuous}}
    return false
end

function test_issue_2817c()
    inner = Model2817c{Float64}()
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64);
    x, c = MOI.add_constrained_variable(model, MOI.Semiinteger(2.0, 3.0))
    @test isa(
        model.constraint_map[c],
        MOI.Bridges.Constraint.SemiToBinaryBridge,
    )
    MOI.delete(model, x)
    @test !MOI.is_valid(model, x)
    @test MOI.is_empty(model)
    @test MOI.is_empty(inner)
    @test isempty(model.constraint_map)
    return
end

function test_issue_2762_success()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Variable.ParameterToEqualTo{Float64}(inner)
    p, _ = MOI.add_constrained_variable(model, MOI.Parameter(1.0))
    MOI.set(model, MOI.VariableName(), p, "p")
    @test MOI.get(model, MOI.VariableName(), p) == "p"
    x = only(MOI.get(inner, MOI.ListOfVariableIndices()))
    @test MOI.get(inner, MOI.VariableName(), x) == "p"
    return
end

function test_issue_2762_fail()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Variable.NonposToNonneg{Float64}(inner)
    y, _ = MOI.add_constrained_variables(model, MOI.Nonpositives(2))
    MOI.set(model, MOI.VariableName(), y[1], "y1")
    @test MOI.get(model, MOI.VariableName(), y[1]) == "y1"
    x = MOI.get(inner, MOI.ListOfVariableIndices())
    @test all(isempty, MOI.get(inner, MOI.VariableName(), x))
    return
end

end  # module

TestBridgeOptimizer.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    QuadtoSOCBridge{T} <: Bridges.Constraint.AbstractBridge

`QuadtoSOCBridge` converts quadratic inequalities
```math
\\frac{1}{2}x^T Q x + a^T x \\le ub
```
into [`MOI.RotatedSecondOrderCone`](@ref) constraints, but it only applies when
``Q`` is positive definite.

This is because, if `Q` is positive definite, there exists `U` such that
``Q = U^T U``, and so the inequality can then be rewritten as;
```math
\\|U x\\|_2^2 \\le 2 (-a^T x + ub)
```

Therefore, `QuadtoSOCBridge` implements the following reformulations:

  * ``\\frac{1}{2}x^T Q x + a^T x \\le ub`` into
    ``(1, -a^T x + ub, Ux) \\in RotatedSecondOrderCone``
    where ``Q = U^T U``
  * ``\\frac{1}{2}x^T Q x + a^T x \\ge lb`` into
    ``(1, a^T x - lb, Ux) \\in RotatedSecondOrderCone``
    where ``-Q = U^T U``

## Source node

`QuadtoSOCBridge` supports:

  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.LessThan{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.GreaterThan{T}`](@ref)

## Target nodes

`RelativeEntropyBridge` creates:

  * [`MOI.VectorAffineFunction{T}`](@ref) in [`MOI.RotatedSecondOrderCone`](@ref)

## Errors

This bridge errors if `Q` is not positive definite.
"""
struct QuadtoSOCBridge{T} <: AbstractBridge
    soc::MOI.ConstraintIndex{
        MOI.VectorAffineFunction{T},
        MOI.RotatedSecondOrderCone,
    }
    dimension::Int  # dimension of the SOC constraint
    less_than::Bool # whether the constraint was ≤ or ≥
    set_constant::T # the constant that was on the set
    index_to_variable_map::Vector{MOI.VariableIndex}
end

const QuadtoSOC{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{QuadtoSOCBridge{T},OT}

function bridge_constraint(
    ::Type{QuadtoSOCBridge{T}},
    model,
    func::MOI.ScalarQuadraticFunction{T},
    set::Union{MOI.LessThan{T},MOI.GreaterThan{T}},
) where {T}
    less_than = set isa MOI.LessThan{T}
    scale = less_than ? -1 : 1
    Q, index_to_variable_map =
        _matrix_from_quadratic_terms(func.quadratic_terms)
    if !less_than
        LinearAlgebra.rmul!(Q, -1)
    end
    F = try
        LinearAlgebra.cholesky(LinearAlgebra.Symmetric(Q))
    catch
        throw(
            MOI.UnsupportedConstraint{typeof(func),typeof(set)}(
                "Unable to transform a quadratic constraint into a " *
                "second-order cone constraint because the quadratic " *
                "constraint is not strongly convex.\n\nConvex constraints " *
                "that are not strongly convex (that is, the matrix is positive " *
                "semidefinite but not positive definite) are not supported " *
                "yet.\n\nNote that a quadratic equality constraint is " *
                "non-convex.",
            ),
        )
    end
    # Construct the VectorAffineFunction. We're aiming for:
    #  |          1  |
    #  | -a^T x + ub | ∈ RotatedSecondOrderCone()
    #  |     Ux + 0  |
    # Start with the -a^T x terms...
    vector_terms = MOI.VectorAffineTerm{T}[
        MOI.VectorAffineTerm(
            2,
            MOI.ScalarAffineTerm(scale * term.coefficient, term.variable),
        ) for term in func.affine_terms
    ]
    # Note that `L = U'` so we add the terms of L'x
    L, p = SparseArrays.sparse(F.L), F.p
    I, J, V = SparseArrays.findnz(L)
    for i in 1:length(V)
        # Cholesky is a pivoted decomposition, so L × L' == Q[p, p].
        # To get the variable, we need the row of L, I[i], then to map that
        # through the permutation vector, so `p[I[i]]`, and then through the
        # index_to_variable_map.
        xi = index_to_variable_map[p[I[i]]]
        push!(
            vector_terms,
            MOI.VectorAffineTerm(J[i] + 2, MOI.ScalarAffineTerm(V[i], xi)),
        )
    end
    # This is the [1, ub, 0] vector...
    set_constant = MOI.constant(set)
    MOI.throw_if_scalar_and_constant_not_zero(func, typeof(set))
    vector_constant = vcat(one(T), -scale * set_constant, zeros(T, size(L, 1)))
    f = MOI.VectorAffineFunction(vector_terms, vector_constant)
    dimension = MOI.output_dimension(f)
    soc = MOI.add_constraint(model, f, MOI.RotatedSecondOrderCone(dimension))
    return QuadtoSOCBridge(
        soc,
        dimension,
        less_than,
        set_constant,
        index_to_variable_map,
    )
end

function _matrix_from_quadratic_terms(
    terms::Vector{MOI.ScalarQuadraticTerm{T}},
) where {T}
    variable_to_index_map = Dict{MOI.VariableIndex,Int}()
    index_to_variable_map = MOI.VariableIndex[]
    for term in terms
        for variable in (term.variable_1, term.variable_2)
            if !(variable in keys(variable_to_index_map))
                push!(index_to_variable_map, variable)
                variable_to_index_map[variable] = length(index_to_variable_map)
            end
        end
    end
    I, J, V = Int[], Int[], T[]
    for term in terms
        i = variable_to_index_map[term.variable_1]
        j = variable_to_index_map[term.variable_2]
        push!(I, i)
        push!(J, j)
        push!(V, term.coefficient)
        if i != j
            push!(I, j)
            push!(J, i)
            push!(V, term.coefficient)
        end
    end
    # Duplicate terms are summed together in `sparse`
    n = length(index_to_variable_map)
    return SparseArrays.sparse(I, J, V, n, n), index_to_variable_map
end

function MOI.supports_constraint(
    ::Type{QuadtoSOCBridge{T}},
    ::Type{MOI.ScalarQuadraticFunction{T}},
    ::Type{<:Union{MOI.LessThan{T},MOI.GreaterThan{T}}},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:QuadtoSOCBridge})
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{QuadtoSOCBridge{T}},
) where {T}
    return Tuple{Type,Type}[(
        MOI.VectorAffineFunction{T},
        MOI.RotatedSecondOrderCone,
    ),]
end

function concrete_bridge_type(
    ::Type{<:QuadtoSOCBridge{T}},
    ::Type{MOI.ScalarQuadraticFunction{T}},
    ::Type{<:Union{MOI.LessThan{T},MOI.GreaterThan{T}}},
) where {T}
    return QuadtoSOCBridge{T}
end

# Attributes, Bridge acting as a model
function MOI.get(
    ::QuadtoSOCBridge{T},
    ::MOI.NumberOfConstraints{
        MOI.VectorAffineFunction{T},
        MOI.RotatedSecondOrderCone,
    },
)::Int64 where {T}
    return 1
end

function MOI.get(
    bridge::QuadtoSOCBridge{T},
    ::MOI.ListOfConstraintIndices{
        MOI.VectorAffineFunction{T},
        MOI.RotatedSecondOrderCone,
    },
) where {T}
    return [bridge.soc]
end

# References
function MOI.delete(model::MOI.ModelLike, bridge::QuadtoSOCBridge)
    MOI.delete(model, bridge.soc)
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{QuadtoSOCBridge{T}},
) where {T}
    F, S = MOI.VectorAffineFunction{T}, MOI.RotatedSecondOrderCone
    return MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex) &&
           MOI.supports(model, attr, MOI.ConstraintIndex{F,S})
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::QuadtoSOCBridge{T},
) where {T}
    # The constraint primal is x'Qx/2 + a'x
    # If `less_than` then `Q = U'U` and we have the value of
    # `Ux` and `-a'x + ub`, so we get it with
    # `(Ux)'Ux / 2 - (-a'x + ub) + ub`
    # Otherwise, `Q = -U'U` and we have the value of
    # `Ux` and `a'x - ub`, so we get it with
    # `-(Ux)'Ux / 2 + (a'x - lb) + lb`
    soc = MOI.get(model, attr, bridge.soc)
    if soc === nothing
        return nothing
    end
    output = sum(soc[i]^2 for i in 3:bridge.dimension; init = zero(T))
    output /= 2
    output -= soc[1] * soc[2]
    if !bridge.less_than
        output = -output
    end
    output += bridge.set_constant
    return output
end

function _primal_start_or_error(model, attr, v)
    var_attr = MOI.VariablePrimalStart()
    value = MOI.get(model, MOI.VariablePrimalStart(), v)
    if isnothing(value)
        msg =
            "In order to set the `$attr`, the " *
            "`MOI.Bridges.Constraint.QuadtoSOCBridge` needs to get the " *
            "`$var_attr` but it is not set. Set the `$var_attr` first before " *
            "setting the `$attr` in order to fix this."
        throw(MOI.SetAttributeNotAllowed(attr, msg))
    end
    return value
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::QuadtoSOCBridge{T},
    value,
) where {T}
    # `value` represent `x'Qx/2 + a'x + ε` where `ε` is
    # the difference between the value of the slack variable and the value of the function.
    # That is, if `less_than`, we set
    # |       1       |
    # | -a'x - ε + ub |
    # |     U * x     |
    # which is obtained as
    # |          1          |
    # | x'Qx/2 - value + ub |
    # |        U * x        |
    # Otherwise, we set
    # |       1       |
    # |  a'x + ε - lb |
    # |     U * x     |
    # which is obtained as
    # |          1          |
    # | value - x'Qx/2 - lb |
    # |        U * x        |
    # where we compute `x'Qx/2` and `U * x` using the starting values of the variable.
    soc = MOI.get(model, MOI.ConstraintFunction(), bridge.soc)
    f = MOI.Utilities.eachscalar(soc)[3:end]
    Ux = MOI.Utilities.eval_variables(model, f) do v
        return _primal_start_or_error(model, attr, v)
    end
    if bridge.less_than
        s2 = Ux'Ux / 2 - value + bridge.set_constant
    else
        s2 = Ux'Ux / 2 + value - bridge.set_constant
    end
    MOI.set(model, attr, bridge.soc, [1; s2; Ux])
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::QuadtoSOCBridge,
    ::Nothing,
)
    MOI.set(model, attr, bridge.soc, nothing)
    return
end

# Lemma: If (1, s, x), (v, u, y) in RotatedSecondOrderCone and
#        (1, s, x) ⋅ (v, u, y) = 0, then we have
#        y = -u*x, v = u*||x||_2^2/2.
# Proof: We have
#        (1, s, x) ⋅ (v, u, y) = v + s * u + x ⋅ y
#        (Cauchy-Schwarz)      ≥ v + s * u - ||x||_2 * ||y||_2
#        (RotatedSOC)          ≥ v + s * u - 2 * √(s * u * v)
#        (AM-GM)               ≥ v + s * u - 2 * (v + s * u) / 2
#                              = 0
#        By assumption, the left-hand side is zero, hence all inequalities
#        are equalities. By Cauchy-Schwarz, this means that ∃σ ≥ 0 such
#        that `y = -σ*x`. By AM-GM, we have `v = s * u`.
#        By RotatedSOC, we have either:
#        1) `||y||_2^2 < 2 * u * v` and `||x||_2^2 = 2 * s = 0`: That implies
#           that `v = 0 * u = 0` hence `||y||_2^2 < 0` which is impossible.
#        2) `||x||_2^2 < 2 * s` and `||y||_2^2 = 2 * u * v = 0`: we have either:
#           a) `u = 0`: hence `v = s * u = 0` or
#           b) `v = 0`: since `s > 0`, `u = v / s = 0`.
#           In any case, `y = 0` and `u = v = 0` hence the statement holds.
#        3) `||x||_2^2 = 2 * s` and `||y||_2^2 = 2 * u * v`: we have
#           `σ^2 * ||x||_2^2 = ||y||_2^2 = 2 * u * v = 2 * u^2 * s` hence
#           `u = σ`. It follows that at `v = s * u = σ * ||x||_2^2/2`.         □
#
# It follows from the Lemma that
# (1, s, x) ⋅ (v, u, y) = u * (1, s, x) ⋅ (||x||_2^2/2, 1, -x)
#                       = u * (||x||_2^2/2 + s - ||x||_2^2)
#                       = u * (-||x||_2^2/2 + s)
# Given a constraint `z^T Q z/2 + a^T z + b ≤ 0` that was transformed,
# where Q = U^T * U$, we have `x = U * z` and `s = -a^T z - b` hence, we have
#                       = -u * (z^T Q z/2 + a^T z + b)
# So the dual of the quadratic constraint is `-u`, so that the contribution
# to the Lagrangian function of both the quadratic and RotatedSOC formulation
# is exactly the same.
function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::QuadtoSOCBridge,
)
    dual = MOI.get(model, attr, bridge.soc)
    if dual === nothing
        return nothing
    end
    λ = dual[2]
    return bridge.less_than ? -λ : λ
end

# Let `(v, u, y)` be the dual of the RSOC and `λ` be the dual of the quadratic.
# From same reasoning as above, we know that `u` is `-λ`.
# From the Lemma above, we have ``
# `y = -u * x`, `v = u*||x||_2^2/2`
function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::QuadtoSOCBridge{T},
    λ,
) where {T}
    u = bridge.less_than ? -λ : λ
    x = T[
        _primal_start_or_error(model, attr, xi) for
        xi in bridge.index_to_variable_map
    ]
    v = u * sum(x .^ 2) / 2
    y = -u * x
    MOI.set(model, attr, bridge.soc, [v; u; y])
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::QuadtoSOCBridge,
    ::Nothing,
)
    MOI.set(model, attr, bridge.soc, nothing)
    return
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    b::QuadtoSOCBridge{T},
) where {T}
    if b.less_than
        return MOI.LessThan(b.set_constant)
    else
        return MOI.GreaterThan(b.set_constant)
    end
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    b::QuadtoSOCBridge{T},
) where {T}
    f = MOI.get(model, attr, b.soc)
    fs = MOI.Utilities.eachscalar(f)
    q = zero(MOI.ScalarQuadraticFunction{T})
    for i in 3:MOI.output_dimension(f)
        term = MOI.Utilities.operate(*, T, fs[i], fs[i])
        term = MOI.Utilities.operate!(/, T, term, 2 * one(T))
        q = MOI.Utilities.operate!(+, T, q, term)
    end
    q = MOI.Utilities.operate!(-, T, q, fs[2])
    if !b.less_than
        q = MOI.Utilities.operate!(-, T, q)
    end
    q.constant += b.set_constant
    return q
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSOCtoPSD

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_SOCtoPSD()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.SOCtoPSD{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariabless_SecondOrderCone",
            "test_basic_VectorAffineFunction_SecondOrderCone",
            "test_basic_VectorQuadraticFunction_SecondOrderCone",
        ],
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 1 / √2, 1 / √2],
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [[√2 / 2, -1 / 2, √2 / 4, -1 / 2, √2 / 4, √2 / 4]],
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) => [[-√2]],
        )
    MOI.Test.test_conic_SecondOrderCone_VectorOfVariables(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Test.test_conic_SecondOrderCone_VectorAffineFunction(
        bridged_mock,
        config,
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.SecondOrderCone,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value = [√2, -1.0, -1.0]
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        ((
            MOI.VectorAffineFunction{Float64},
            MOI.PositiveSemidefiniteConeTriangle,
            0,
        ),),
    )
    return
end

function test_RSOCtoPSD()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.RSOCtoPSD{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariabless_RotatedSecondOrderCone",
            "test_basic_VectorAffineFunction_RotatedSecondOrderCone",
            "test_basic_VectorQuadraticFunction_RotatedSecondOrderCone",
        ],
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [0.5, 1.0, 1 / √2, 1 / √2],
            (MOI.VariableIndex, MOI.EqualTo{Float64}) => [-√2, -1 / √2],
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [[√2, -1 / 2, √2 / 8, -1 / 2, √2 / 8, √2 / 8]],
        )
    MOI.Test.test_conic_RotatedSecondOrderCone_VectorOfVariables(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1 / √2, 1 / √2],
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [[√2, -1 / 2, √2 / 8, -1 / 2, √2 / 8, √2 / 8]],
        )
    MOI.Test.test_conic_RotatedSecondOrderCone_VectorAffineFunction(
        bridged_mock,
        config,
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.RotatedSecondOrderCone,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value = [√2, √2 / 4, -1.0, -1.0]
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
                0,
            ),
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 0),
        ),
    )
    return
end

function test_rsoc_to_psd_dimension_2()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.RSOCtoPSD{Float64}(inner)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.RotatedSecondOrderCone(2),
    )
    @test MOI.get(
        inner,
        MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.Nonnegatives}(),
    ) == 1
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SOCtoPSDBridge,
        """
        variables: t, x, y
        [t, x, y] in SecondOrderCone(3)
        """,
        """
        variables: t, x, y
        [t, x, t, y, 0.0, t] in PositiveSemidefiniteConeTriangle(3)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.RSOCtoPSDBridge,
        """
        variables: t, u, x
        [t, u, x] in RotatedSecondOrderCone(3)
        """,
        """
        variables: t, u, x
        [t, x, 2u] in PositiveSemidefiniteConeTriangle(2)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.RSOCtoPSDBridge,
        """
        variables: t, u
        [t, u] in RotatedSecondOrderCone(2)
        """,
        """
        variables: t, u
        [t, u] in Nonnegatives(2)
        """,
    )
    return
end

function test_bridging_cost_SOCtoPSD()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.SOCtoPSD{Float64}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint(model, x, MOI.SecondOrderCone(3))
    bridge = model.map[c]
    MOI.Bridges.bridging_cost(typeof(bridge)) == 10.0
    return
end

function test_bridging_cost_RSOCtoPSD()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.RSOCtoPSD{Float64}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint(model, x, MOI.RotatedSecondOrderCone(3))
    bridge = model.map[c]
    MOI.Bridges.bridging_cost(typeof(bridge)) == 10.0
    return
end

function test_dimension_mismatch_RSOC_to_PSD()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.RSOCtoPSD{Float64}(inner)
    @test_throws(
        DimensionMismatch,
        MOI.add_constrained_variables(model, MOI.RotatedSecondOrderCone(1)),
    )
    return
end

end  # module

TestConstraintSOCtoPSD.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintMap

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

struct ConstraintDummyBridge <: MOI.Bridges.Constraint.AbstractBridge
    id::Int
end

function test_map()
    map = MOI.Bridges.Constraint.Map()

    @test isempty(map)
    @test !MOI.Bridges.Constraint.has_bridges(map)

    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    b1 = ConstraintDummyBridge(1)
    c1 = MOI.Bridges.Constraint.add_key_for_bridge(
        map,
        b1,
        x,
        MOI.EqualTo(0.0),
        ci -> true,
    )

    @test c1.value == x.value
    @test haskey(map, c1)
    @test map[c1] == b1
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c1)) == 1
    @test collect(MOI.Bridges.Constraint.keys_of_type(map, typeof(c1))) == [c1]

    @test length(map) == 1
    @test !isempty(map)
    @test MOI.Bridges.Constraint.has_bridges(map)

    b2 = ConstraintDummyBridge(2)
    vov = MOI.VectorOfVariables([x, y])
    c2 = MOI.Bridges.Constraint.add_key_for_bridge(
        map,
        b2,
        vov,
        MOI.SecondOrderCone(2),
        ci -> true,
    )
    @test c2.value == -1
    @test haskey(map, c2)
    @test map[c2] == b2
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c2)) == 1
    @test collect(MOI.Bridges.Constraint.keys_of_type(map, typeof(c2))) == [c2]

    @test length(map) == 2
    @test !isempty(map)
    @test MOI.Bridges.Constraint.has_bridges(map)

    b3 = ConstraintDummyBridge(3)
    c3 = MOI.Bridges.Constraint.add_key_for_bridge(
        map,
        b3,
        1.0x + 2.0,
        MOI.EqualTo(0.0),
        ci -> true,
    )
    @test haskey(map, c3)
    @test map[c3] == b3
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c3)) == 1
    @test collect(MOI.Bridges.Constraint.keys_of_type(map, typeof(c3))) == [c3]

    @test length(map) == 3
    @test !isempty(map)
    @test MOI.Bridges.Constraint.has_bridges(map)

    bridges = collect(values(map))
    @test sort([b.id for b in bridges]) == 1:3
    elements = sort(collect(map), by = el -> el.second.id)
    @test elements[1].first == c1
    @test elements[1].second == b1
    @test elements[2].first == c2
    @test elements[2].second == b2
    @test elements[3].first == c3
    @test elements[3].second == b3

    @test MOI.Bridges.Constraint.list_of_key_types(map) == Set([
        (MOI.VectorOfVariables, MOI.SecondOrderCone),
        (MOI.VariableIndex, MOI.EqualTo{Float64}),
        (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}),
    ])
    @test MOI.Bridges.Constraint.variable_constraints(map, x) == [c1]
    @test isempty(MOI.Bridges.Constraint.variable_constraints(map, y))

    delete!(map, c1)
    @test length(map) == 2
    @test !isempty(map)
    @test MOI.Bridges.Constraint.has_bridges(map)

    @test MOI.Bridges.Constraint.list_of_key_types(map) == Set([
        (MOI.VectorOfVariables, MOI.SecondOrderCone),
        (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}),
    ])
    @test isempty(MOI.Bridges.Constraint.variable_constraints(map, x))
    @test isempty(MOI.Bridges.Constraint.variable_constraints(map, y))
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c1)) == 0
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c2)) == 1
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c3)) == 1

    delete!(map, c2)
    @test length(map) == 1
    @test !isempty(map)
    @test MOI.Bridges.Constraint.has_bridges(map)

    @test MOI.Bridges.Constraint.list_of_key_types(map) ==
          Set([(MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64})])
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c1)) == 0
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c2)) == 0
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c3)) == 1

    delete!(map, c3)
    @test length(map) == 0
    @test isempty(map)
    @test MOI.Bridges.Constraint.has_bridges(map)

    @test isempty(MOI.Bridges.Constraint.list_of_key_types(map))
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c1)) == 0
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c2)) == 0
    @test MOI.Bridges.Constraint.number_of_type(map, typeof(c3)) == 0

    @test isempty(collect(map))

    map = MOI.Bridges.Constraint.EmptyMap()
    empty!(map)
    @test isempty(map)
    @test isempty(keys(map))
    @test isempty(values(map))
    @test !MOI.Bridges.Constraint.has_bridges(map)
    @test iszero(MOI.Bridges.Constraint.number_of_type(map, typeof(c1)))
    @test iszero(MOI.Bridges.Constraint.number_of_type(map, typeof(c2)))
    @test iszero(MOI.Bridges.Constraint.number_of_type(map, typeof(c3)))
    @test sprint(show, map) == ""
end

end  # module

TestConstraintMap.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SOCtoRSOCBridge{T} <: Bridges.Variable.AbstractBridge

`SOCtoRSOCBridge` implements the following reformulation:

 * ``||x||_2 \\le t`` into ``2uv \\ge ||w||_2^2``, with the substitution rules
   ``t = \\frac{u}{\\sqrt 2} + \\frac{v}{\\sqrt 2}``,
   ``x = (\\frac{u}{\\sqrt 2} - \\frac{v}{\\sqrt 2}, w)``.

## Assumptions

 * `SOCtoRSOCBridge` assumes that ``|x| \\ge 1``.

## Source node

`SOCtoRSOCBridge` supports:

 * [`MOI.VectorOfVariables`](@ref) in [`MOI.SecondOrderCone`](@ref)

## Target node

`SOCtoRSOCBridge` creates:

 * [`MOI.VectorOfVariables`](@ref) in [`MOI.RotatedSecondOrderCone`](@ref)
"""
struct SOCtoRSOCBridge{T} <:
       SetMapBridge{T,MOI.RotatedSecondOrderCone,MOI.SecondOrderCone}
    variables::Vector{MOI.VariableIndex}
    constraint::MOI.ConstraintIndex{
        MOI.VectorOfVariables,
        MOI.RotatedSecondOrderCone,
    }
end

const SOCtoRSOC{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SOCtoRSOCBridge{T},OT}

function MOI.Bridges.map_set(
    ::Type{<:SOCtoRSOCBridge},
    set::MOI.RotatedSecondOrderCone,
)
    return MOI.SecondOrderCone(MOI.dimension(set))
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:SOCtoRSOCBridge},
    set::MOI.SecondOrderCone,
)
    if MOI.dimension(set) == 1
        error(
            "Unable to reformulate a `SecondOrderCone` into a " *
            "`RotatedSecondOrderCone` because the dimension of `1` is too " *
            "small",
        )
    end
    return MOI.RotatedSecondOrderCone(MOI.dimension(set))
end

function MOI.Bridges.map_function(
    ::Type{<:SOCtoRSOCBridge{T}},
    func,
    i::MOI.Bridges.IndexInVector,
) where {T}
    scalars = MOI.Utilities.eachscalar(func)
    if i.value > 2
        return scalars[i.value]
    end
    t, u = scalars[1], scalars[2]
    ts = MOI.Utilities.operate!(/, T, t, sqrt(T(2)))
    us = MOI.Utilities.operate!(/, T, u, sqrt(T(2)))
    if i.value == 1
        return MOI.Utilities.operate!(+, T, ts, us)
    else
        return MOI.Utilities.operate!(-, T, ts, us)
    end
end

function MOI.Bridges.map_function(::Type{<:SOCtoRSOCBridge{T}}, func) where {T}
    scalars = MOI.Utilities.eachscalar(func)
    t, u, x = scalars[1], scalars[2], scalars[3:end]
    ts = MOI.Utilities.operate!(/, T, t, sqrt(T(2)))
    us = MOI.Utilities.operate!(/, T, u, sqrt(T(2)))
    return MOI.Utilities.operate(vcat, T, ts + us, ts - us, x)
end

# The map is an involution
function MOI.Bridges.inverse_map_function(BT::Type{<:SOCtoRSOCBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is symmetric
function MOI.Bridges.adjoint_map_function(BT::Type{<:SOCtoRSOCBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is a symmetric involution
function MOI.Bridges.inverse_adjoint_map_function(
    BT::Type{<:SOCtoRSOCBridge},
    func,
)
    return MOI.Bridges.map_function(BT, func)
end

function MOI.supports(
    ::MOI.ModelLike,
    ::MOI.VariablePrimalStart,
    ::Type{<:SOCtoRSOCBridge},
)
    # https://github.com/jump-dev/MathOptInterface.jl/issues/2117
    return false
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    shift_constant(set::MOI.AbstractScalarSet, offset)

Returns a new scalar set `new_set` such that `func`-in-`set` is equivalent to
`func + offset`-in-`new_set`.

Use [`supports_shift_constant`](@ref) to check if the set supports shifting:
```Julia
if MOI.Utilities.supports_shift_constant(typeof(set))
    new_set = MOI.Utilities.shift_constant(set, -func.constant)
    func.constant = 0
    MOI.add_constraint(model, func, new_set)
else
    MOI.add_constraint(model, func, set)
end
```

## Note for developers

Only define this function if it makes sense and you have implemented
[`supports_shift_constant`](@ref) to return `true`.

## Example

```jldoctest
julia> set = MOI.Interval(-2.0, 3.0)
MathOptInterface.Interval{Float64}(-2.0, 3.0)

julia> MOI.Utilities.supports_shift_constant(typeof(set))
true

julia> MOI.Utilities.shift_constant(set, 1.0)
MathOptInterface.Interval{Float64}(-1.0, 4.0)
```
"""
function shift_constant end

"""
    supports_shift_constant(::Type{S}) where {S<:MOI.AbstractSet}

Return `true` if [`shift_constant`](@ref) is defined for set `S`.

See also [`shift_constant`](@ref).

## Example

```jldoctest
julia> MOI.Utilities.supports_shift_constant(MOI.Interval{Float64})
true

julia> MOI.Utilities.supports_shift_constant(MOI.ZeroOne)
false
```
"""
supports_shift_constant(::Type{S}) where {S<:MOI.AbstractSet} = false

function shift_constant(set::MOI.LessThan, offset)
    return MOI.LessThan(MOI.constant(set) + offset)
end

supports_shift_constant(::Type{<:MOI.LessThan}) = true

function shift_constant(set::MOI.GreaterThan, offset)
    return MOI.GreaterThan(MOI.constant(set) + offset)
end

supports_shift_constant(::Type{<:MOI.GreaterThan}) = true

function shift_constant(set::MOI.EqualTo, offset)
    return MOI.EqualTo(MOI.constant(set) + offset)
end

supports_shift_constant(::Type{<:MOI.EqualTo}) = true

function shift_constant(set::MOI.Interval, offset)
    return MOI.Interval(set.lower + offset, set.upper + offset)
end

supports_shift_constant(::Type{<:MOI.Interval}) = true

function shift_constant(set::MOI.Parameter, offset)
    return MOI.Parameter(MOI.constant(set) + offset)
end

supports_shift_constant(::Type{<:MOI.Parameter}) = true

"""
    ScalarLinearSet{T}

The union of scalar-valued linear sets with element type `T`.

This is used in the vectorize and scalarize bridges.

See also: [`VectorLinearSet`](@ref).
"""
const ScalarLinearSet{T} =
    Union{MOI.EqualTo{T},MOI.LessThan{T},MOI.GreaterThan{T}}

"""
    VectorLinearSet

The union of vector-valued linear cones.

This is used in the vectorize and scalarize bridges.

See also: [`ScalarLinearSet`](@ref).
"""
const VectorLinearSet = Union{MOI.Zeros,MOI.Nonnegatives,MOI.Nonpositives}

"""
    vector_set_type(::Type{S}) where {S}

A utility function to map scalar sets `S` to their vector equivalents.

This is used in the vectorize and scalarize bridges.

See also: [`scalar_set_type`](@ref).
"""
vector_set_type(::Type{<:MOI.EqualTo}) = MOI.Zeros
vector_set_type(::Type{<:MOI.LessThan}) = MOI.Nonpositives
vector_set_type(::Type{<:MOI.GreaterThan}) = MOI.Nonnegatives

"""
    scalar_set_type(::Type{S}, ::Type{T}) where {S,T}

A utility function to map vector sets `S` to their scalar equivalents with
element type `T`.

This is used in the vectorize and scalarize bridges.

See also: [`vector_set_type`](@ref).
"""
scalar_set_type(::Type{<:MOI.Zeros}, T::Type) = MOI.EqualTo{T}
scalar_set_type(::Type{<:MOI.Nonpositives}, T::Type) = MOI.LessThan{T}
scalar_set_type(::Type{<:MOI.Nonnegatives}, T::Type) = MOI.GreaterThan{T}

"""
    is_diagonal_vectorized_index(index::Base.Integer)

Return whether `index` is the index of a diagonal element in a
[`MOI.AbstractSymmetricMatrixSetTriangle`](@ref) set.
"""
function is_diagonal_vectorized_index(index::Base.Integer)
    # See https://en.wikipedia.org/wiki/Triangular_number#Triangular_roots_and_tests_for_triangular_numbers
    perfect_square = 1 + 8index
    return isqrt(perfect_square)^2 == perfect_square
end

# We have `d*(d+1)/2 = n` so `2n = d^2 + d` hence
# `d^2 ≤ 2n < d^2 + 2d + 1 = (d + 1)^2`
# this means that `d` is the largest natural number `d`
# such that `d^2 ≤ 2n` hence `d = isqrt(2n)`.
"""
    side_dimension_for_vectorized_dimension(n::Integer)

Return the dimension `d` such that
`MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(d))` is `n`.
"""
side_dimension_for_vectorized_dimension(n::Base.Integer) = isqrt(2n)

"""
    trimap(row::Integer, column::Integer)

Convert between the row and column indices of a matrix, to the linear index of
the corresponding element in the triangular representation.

This is most useful when mapping between `ConeSquare` and `ConeTriangle` sets,
for example, as part of an [`MOI.AbstractSymmetricMatrixSetTriangle`](@ref) set.

!!! note
    Use [`inverse_trimap`](@ref) for the reverse mapping.
"""
function trimap(row::Integer, column::Integer)
    if row < column
        return trimap(column, row)
    end
    return div((row - 1) * row, 2) + column
end

"""
    inverse_trimap(index::Integer)

Convert between the linear index of a
[`MathOptInterface.AbstractSymmetricMatrixSetTriangle`] to the row and column
indices of upper triangular part of the corresponding matrix.

!!! note
    Use [`trimap`](@ref) for the reverse mapping.
"""
function inverse_trimap(index::Integer)
    # Because `isqrt` and `div` are monotone functions
    # because `index` is between `trimap(j - 1, j - 1)` and
    # `trimap(j, j)`,`
    # `side_dimension_for_vectorized_dimension(index)` is between `j - 1`
    # and `j`.
    j = side_dimension_for_vectorized_dimension(index)
    n = trimap(j, j)
    if index <= n
        j -= 1
        n = trimap(j, j)
    end
    i = index - n
    return i, j + 1
end

similar_type(::Type{<:MOI.LessThan}, ::Type{T}) where {T} = MOI.LessThan{T}

function similar_type(::Type{<:MOI.GreaterThan}, ::Type{T}) where {T}
    return MOI.GreaterThan{T}
end

similar_type(::Type{<:MOI.EqualTo}, ::Type{T}) where {T} = MOI.EqualTo{T}

similar_type(::Type{<:MOI.Interval}, ::Type{T}) where {T} = MOI.Interval{T}

function convert_approx(::Type{MOI.LessThan{T}}, set::MOI.LessThan) where {T}
    return MOI.LessThan{T}(set.upper)
end

function convert_approx(
    ::Type{MOI.GreaterThan{T}},
    set::MOI.GreaterThan,
) where {T}
    return MOI.GreaterThan{T}(set.lower)
end

function convert_approx(::Type{MOI.EqualTo{T}}, set::MOI.EqualTo) where {T}
    return MOI.EqualTo{T}(set.value)
end

function convert_approx(::Type{MOI.Interval{T}}, set::MOI.Interval) where {T}
    return MOI.Interval{T}(set.lower, set.upper)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Benchmarks

import BenchmarkTools
import MathOptInterface as MOI

const BENCHMARKS = Dict{String,Function}()

"""
    suite(
        new_model::Function;
        exclude::Vector{Regex} = Regex[]
    )

Create a suite of benchmarks. `new_model` should be a function that takes no
arguments, and returns a new instance of the optimizer you wish to benchmark.

Use `exclude` to exclude a subset of benchmarks.

## Example

```julia
julia> MOI.Benchmarks.suite() do
           return GLPK.Optimizer()
       end

julia> MOI.Benchmarks.suite(; exclude = [r"delete"]) do
           return Gurobi.Optimizer()
       end
```
"""
function suite(new_model::Function; exclude::Vector{Regex} = Regex[])
    group = BenchmarkTools.BenchmarkGroup()
    for (name, func) in BENCHMARKS
        any(occursin.(exclude, Ref(name))) && continue
        group[name] = BenchmarkTools.@benchmarkable $func($new_model)
    end
    return group
end

"""
    create_baseline(suite, name::String; directory::String = ""; kwargs...)

Run all benchmarks in `suite` and save to files called `name` in `directory`.

Extra `kwargs` are based to `BenchmarkTools.run`.

## Example

```julia
julia> import GLPK

julia> my_suite = MOI.Benchmarks.suite(() -> GLPK.Optimizer());

julia> MOI.Benchmarks.create_baseline(
           my_suite,
           "glpk_master";
           directory = "/tmp",
           verbose = true,
       )
```
"""
function create_baseline(
    suite::BenchmarkTools.BenchmarkGroup,
    name::String;
    directory::String = "",
    kwargs...,
)
    BenchmarkTools.tune!(suite)
    BenchmarkTools.save(
        joinpath(directory, name * "_params.json"),
        BenchmarkTools.params(suite),
    )
    results = BenchmarkTools.run(suite; kwargs...)
    BenchmarkTools.save(joinpath(directory, name * "_baseline.json"), results)
    return
end

"""
    compare_against_baseline(
        suite, name::String; directory::String = "",
        report_filename::String = "report.txt"
    )

Run all benchmarks in `suite` and compare against files called `name` in
`directory` that were created by a call to `create_baseline`.

A report summarizing the comparison is written to `report_filename` in
`directory`.

Extra `kwargs` are based to `BenchmarkTools.run`.

## Example

```julia
julia> import GLPK

julia> my_suite = MOI.Benchmarks.suite(() -> GLPK.Optimizer());

julia> MOI.Benchmarks.compare_against_baseline(
           my_suite,
           "glpk_master";
           directory = "/tmp",
           verbose = true,
       )
```
"""
function compare_against_baseline(
    suite::BenchmarkTools.BenchmarkGroup,
    name::String;
    directory::String = "",
    report_filename::String = "report.txt",
    kwargs...,
)
    params_filename = joinpath(directory, name * "_params.json")
    baseline_filename = joinpath(directory, name * "_baseline.json")
    if !isfile(params_filename) || !isfile(baseline_filename)
        error("You create a baseline with `create_baseline` first.")
    end
    BenchmarkTools.loadparams!(
        suite,
        BenchmarkTools.load(params_filename)[1],
        :evals,
        :samples,
    )
    new_results = BenchmarkTools.run(suite; kwargs...)
    old_results = BenchmarkTools.load(baseline_filename)[1]
    open(joinpath(directory, report_filename), "w") do io
        println(stdout, "\n========== Results ==========")
        println(io, "\n========== Results ==========")
        for key in keys(new_results)
            judgement = BenchmarkTools.judge(
                BenchmarkTools.median(new_results[key]),
                BenchmarkTools.median(old_results[key]),
            )
            println(stdout, "\n", key)
            println(io, "\n", key)
            show(stdout, MIME"text/plain"(), judgement)
            show(io, MIME"text/plain"(), judgement)
        end
    end
    return
end

###
### Benchmarks
###

macro add_benchmark(f)
    name = f.args[1].args[1]
    return quote
        $(esc(f))
        BENCHMARKS[String($(Base.Meta.quot(name)))] = $(esc(name))
    end
end

@add_benchmark function add_variable(new_model)
    model = new_model()
    for i in 1:10_000
        MOI.add_variable(model)
    end
    return model
end

@add_benchmark function add_variables(new_model)
    model = new_model()
    MOI.add_variables(model, 10_000)
    return model
end

@add_benchmark function add_variable_constraint(new_model)
    model = new_model()
    x = MOI.add_variables(model, 10_000)
    for (i, xi) in enumerate(x)
        MOI.add_constraint(model, xi, MOI.LessThan(1.0 * i))
    end
    return model
end

@add_benchmark function add_variable_constraints(new_model)
    model = new_model()
    x = MOI.add_variables(model, 10_000)
    MOI.add_constraints(model, x, MOI.LessThan.(1.0:10_000.0))
    return model
end

@add_benchmark function delete_variable(new_model)
    model = new_model()
    x = MOI.add_variables(model, 1_000)
    MOI.add_constraint.(model, x, Ref(MOI.LessThan(1.0)))
    MOI.delete.(model, x)
    return model
end

@add_benchmark function delete_variable_constraint(new_model)
    model = new_model()
    x = MOI.add_variables(model, 1_000)
    cons = MOI.add_constraint.(model, x, Ref(MOI.LessThan(1.0)))
    for con in cons
        MOI.delete(model, con)
    end
    cons = MOI.add_constraint.(model, x, Ref(MOI.LessThan(1.0)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.0),
    )
    MOI.optimize!(model)
    for con in cons
        MOI.delete(model, con)
    end
    return model
end

@add_benchmark function add_constraint(new_model)
    model = new_model()
    index = MOI.add_variables(model, 10_000)
    for (i, x) in enumerate(index)
        MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
            MOI.LessThan(1.0 * i),
        )
    end
    return model
end

@add_benchmark function add_constraints(new_model)
    model = new_model()
    x = MOI.add_variables(model, 10_000)
    MOI.add_constraints(
        model,
        MOI.ScalarAffineFunction{Float64}[
            MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, xi)], 0.0) for
            xi in x
        ],
        MOI.LessThan.(1:1.0:10_000),
    )
    return model
end

@add_benchmark function delete_constraint(new_model)
    model = new_model()
    index = MOI.add_variables(model, 1_000)
    cons = Vector{
        MOI.ConstraintIndex{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        },
    }(
        undef,
        1_000,
    )
    for (i, x) in enumerate(index)
        cons[i] = MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
            MOI.LessThan(1.0 * i),
        )
    end
    for con in cons
        MOI.delete(model, con)
    end
    return model
end

@add_benchmark function copy_model(new_model)
    model = new_model()
    index = MOI.add_variables(model, 1_000)
    cons = Vector{
        MOI.ConstraintIndex{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        },
    }(
        undef,
        1_000,
    )
    for (i, x) in enumerate(index)
        cons[i] = MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
            MOI.LessThan(1.0 * i),
        )
    end

    model2 = new_model()
    MOI.copy_to(model2, model)
    # MOI.copy_to(model2, model, filter_constraints=(x) -> x in cons[1:500])

    return model2
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    _replace_moi_variables(
        nodes::Vector{Nonlinear.Node},
        moi_index_to_consecutive_index::Dict{MOI.VariableIndex,Int},
    )

Return a new `Vector{Nonlinear.Node}` where all occurences of
`NODE_MOI_VARIABLE` are replaced by `NODE_VARIABLE` that is 1-indexed and
ordered.
"""
function _replace_moi_variables(
    nodes::Vector{Nonlinear.Node},
    moi_index_to_consecutive_index::Dict{MOI.VariableIndex,Int},
)
    new_nodes = Vector{Nonlinear.Node}(undef, length(nodes))
    for (i, node) in enumerate(nodes)
        if node.type == Nonlinear.NODE_MOI_VARIABLE
            new_nodes[i] = Nonlinear.Node(
                Nonlinear.NODE_VARIABLE,
                moi_index_to_consecutive_index[MOI.VariableIndex(node.index)],
                node.parent,
            )
        else
            new_nodes[i] = node
        end
    end
    return new_nodes
end

@enum(Linearity, CONSTANT, LINEAR, PIECEWISE_LINEAR, NONLINEAR)

"""
    _classify_linearity(
        nodes::Vector{Nonlinear.Node},
        adj::SparseArrays.SparseMatrixCSC,
        subexpression_linearity::Vector{Linearity},
    )

Classify the nodes in a tree as constant, linear, or nonlinear with respect to
the input.
"""
function _classify_linearity(
    nodes::Vector{Nonlinear.Node},
    adj::SparseArrays.SparseMatrixCSC,
    subexpression_linearity::Vector{Linearity},
)
    linearity = Array{Linearity}(undef, length(nodes))
    children_arr = SparseArrays.rowvals(adj)
    for k in length(nodes):-1:1
        node = nodes[k]
        if node.type == Nonlinear.NODE_VARIABLE
            linearity[k] = LINEAR
            continue
        elseif node.type == Nonlinear.NODE_VALUE
            linearity[k] = CONSTANT
            continue
        elseif node.type == Nonlinear.NODE_PARAMETER
            linearity[k] = CONSTANT
            continue
        elseif node.type == Nonlinear.NODE_SUBEXPRESSION
            linearity[k] = subexpression_linearity[node.index]
            continue
        end
        children_idx = SparseArrays.nzrange(adj, k)
        num_constant_children, any_nonlinear = 0, false
        for r in children_idx
            if linearity[children_arr[r]] == NONLINEAR
                any_nonlinear = true
                break
            elseif linearity[children_arr[r]] == CONSTANT
                num_constant_children += 1
            end
        end
        if any_nonlinear
            # If any children are nonlinear, then we're nonlinear...
            linearity[k] = NONLINEAR
            # ...except in the case of ifelse. If the operands are linear then
            # we're piecewise linear.
            op = get(
                Nonlinear.DEFAULT_MULTIVARIATE_OPERATORS,
                node.index,
                nothing,
            )
            if (
                node.type == Nonlinear.NODE_CALL_MULTIVARIATE &&
                op == :ifelse &&
                linearity[children_arr[children_idx[2]]] == LINEAR &&
                linearity[children_arr[children_idx[3]]] == LINEAR
            )
                linearity[k] = PIECEWISE_LINEAR
            end
            continue
        elseif num_constant_children == length(children_idx)
            # If all children are constant, then we're constant.
            linearity[k] = CONSTANT
            continue
        end
        # By this point, some children are constant and some are linear, so if
        # the operator is nonlinear, then we're nonlinear.
        if node.type == Nonlinear.NODE_CALL_UNIVARIATE
            op =
                get(Nonlinear.DEFAULT_UNIVARIATE_OPERATORS, node.index, nothing)
            if op == :+ || op == :-
                linearity[k] = LINEAR
            else
                linearity[k] = NONLINEAR
            end
        elseif node.type == Nonlinear.NODE_CALL_MULTIVARIATE
            op = get(
                Nonlinear.DEFAULT_MULTIVARIATE_OPERATORS,
                node.index,
                nothing,
            )
            if op == :+
                linearity[k] = LINEAR
            elseif op == :-
                linearity[k] = LINEAR
            elseif op == :*
                # Multiplication is linear if there is one non-constant term.
                one_op = num_constant_children == length(children_idx) - 1
                linearity[k] = one_op ? LINEAR : NONLINEAR
            elseif op == :^
                linearity[k] = NONLINEAR
            elseif op == :/
                if linearity[children_arr[children_idx[2]]] == CONSTANT
                    # If the denominator is constant, we're linear.
                    linearity[k] = LINEAR
                else
                    linearity[k] = NONLINEAR
                end
            elseif op == :ifelse
                linearity[k] = NONLINEAR
            else  # User-defined functions
                linearity[k] = NONLINEAR
            end
        elseif node.type == Nonlinear.NODE_LOGIC
            linearity[k] = NONLINEAR
        else
            @assert node.type == Nonlinear.NODE_COMPARISON
            linearity[k] = NONLINEAR
        end
    end
    return linearity
end

"""
    _compute_gradient_sparsity!(
        indices::Coloring.IndexedSet,
        nodes::Vector{Nonlinear.Node},
    )

Compute the sparsity pattern of the gradient of an expression (that is, a list of
which variable indices are present).
"""
function _compute_gradient_sparsity!(
    indices::Coloring.IndexedSet,
    nodes::Vector{Nonlinear.Node},
)
    for node in nodes
        if node.type == Nonlinear.NODE_VARIABLE
            push!(indices, node.index)
        elseif node.type == Nonlinear.NODE_MOI_VARIABLE
            error(
                "Internal error: Invalid to compute sparsity if Nonlinear.NODE_MOI_VARIABLE " *
                "nodes are present.",
            )
        end
    end
    return
end

"""
    _get_nonlinear_child_interactions(
        node::Nonlinear.Node,
        num_children::Int,
    )

Get the list of nonlinear child interaction pairs for a node.
Returns empty list of tuples `(i, j)` where `i` and `j` are child indices (1-indexed)
that have nonlinear interactions.

For example, for `*` with 2 children, the result is `[(1, 2)]` because children 1
and 2 interact nonlinearly, but children 1 and 1, or 2 and 2, do not.

For functions like `+` or `-`, the result is `[]` since there are no nonlinear
interactions between children.
"""
function _get_nonlinear_child_interactions(
    node::Nonlinear.Node,
    num_children::Int,
)::Vector{Tuple{Int,Int}}
    if node.type == Nonlinear.NODE_CALL_UNIVARIATE
        @assert num_children == 1
        op = get(Nonlinear.DEFAULT_UNIVARIATE_OPERATORS, node.index, nothing)
        # Univariate operators :+ and :- don't create interactions
        if op in (:+, :-)
            return Tuple{Int,Int}[]
        else
            return [(1, 1)]
        end
    elseif node.type == Nonlinear.NODE_CALL_MULTIVARIATE
        op = get(Nonlinear.DEFAULT_MULTIVARIATE_OPERATORS, node.index, nothing)
        if op in (:+, :-, :ifelse, :min, :max)
            # No nonlinear interactions between children
            return Tuple{Int,Int}[]
        elseif op == :*
            # All pairs of distinct children interact nonlinearly
            result = Tuple{Int,Int}[]
            for i in 1:num_children
                for j in 1:(i-1)
                    push!(result, (j, i))
                end
            end
            return result
        elseif op == :/
            @assert num_children == 2
            # The numerator doesn't have a nonlinear interaction with itself.
            return [(1, 2), (2, 2)]
        else
            # Conservative: assume all pairs interact
            result = Tuple{Int,Int}[]
            for i in 1:num_children
                for j in 1:i
                    push!(result, (j, i))
                end
            end
            return result
        end
    else
        # Logic and comparison nodes don't generate hessian terms.
        # Subexpression nodes are special cased.
        return Tuple{Int,Int}[]
    end
end

"""
    _compute_hessian_sparsity(
        nodes::Vector{Nonlinear.Node},
        adj,
        input_linearity::Vector{Linearity},
        subexpression_edgelist::Vector{Set{Tuple{Int,Int}}},
        subexpression_variables::Vector{Vector{Int}},
    )

Compute the sparsity pattern the Hessian of an expression.

 * `input_linearity` is the linearity with respect to the input, computed by
   `_classify_linearity`
 * `subexpression_edgelist` is the edge_list of each subexpression
 * `subexpression_variables` is the list of all variables which appear in a
   subexpression (including recursively).

Returns a `Set{Tuple{Int,Int}}` containing the nonzero entries of the Hessian.
"""
function _compute_hessian_sparsity(
    nodes::Vector{Nonlinear.Node},
    adj,
    input_linearity::Vector{Linearity},
    subexpression_edgelist::Vector{Set{Tuple{Int,Int}}},
    subexpression_variables::Vector{Vector{Int}},
)
    edge_list = Set{Tuple{Int,Int}}()
    children_arr = SparseArrays.rowvals(adj)
    # Stack entry: (node_index, child_group_index)
    stack = Tuple{Int,Int}[]
    # Map from child_group_index to variable indices
    child_group_variables = Dict{Int,Set{Int}}()
    for (k, node) in enumerate(nodes)
        @assert node.type != Nonlinear.NODE_MOI_VARIABLE
        if input_linearity[k] == CONSTANT
            continue  # No hessian contribution from constant nodes
        end
        # Check if this node has nonlinear child interactions
        children_idx = SparseArrays.nzrange(adj, k)
        num_children = length(children_idx)
        interactions = _get_nonlinear_child_interactions(node, num_children)
        if !isempty(interactions)
            # This node has nonlinear child interactions, so collect variables
            # from its children
            empty!(child_group_variables)
            # DFS from all children, tracking child index
            for (child_position, cidx) in enumerate(children_idx)
                child_node_idx = children_arr[cidx]
                push!(stack, (child_node_idx, child_position))
            end
            while length(stack) > 0
                r, child_group_idx = pop!(stack)
                # Don't traverse into logical conditions or comparisons
                if nodes[r].type == Nonlinear.NODE_LOGIC ||
                   nodes[r].type == Nonlinear.NODE_COMPARISON
                    continue
                end
                r_children_idx = SparseArrays.nzrange(adj, r)
                for cidx in r_children_idx
                    push!(stack, (children_arr[cidx], child_group_idx))
                end
                if nodes[r].type == Nonlinear.NODE_VARIABLE
                    if !haskey(child_group_variables, child_group_idx)
                        child_group_variables[child_group_idx] = Set{Int}()
                    end
                    push!(
                        child_group_variables[child_group_idx],
                        nodes[r].index,
                    )
                elseif nodes[r].type == Nonlinear.NODE_SUBEXPRESSION
                    sub_vars = subexpression_variables[nodes[r].index]
                    if !haskey(child_group_variables, child_group_idx)
                        child_group_variables[child_group_idx] = Set{Int}()
                    end
                    union!(child_group_variables[child_group_idx], sub_vars)
                end
            end
            _add_hessian_edges!(edge_list, interactions, child_group_variables)
        elseif node.type == Nonlinear.NODE_SUBEXPRESSION
            for ij in subexpression_edgelist[node.index]
                push!(edge_list, ij)
            end
        end
    end
    return edge_list
end

"""
    _add_hessian_edges!(
        edge_list::Set{Tuple{Int,Int}},
        interactions::Vector{Tuple{Int,Int}},
        child_variables::Dict{Int,Set{Int}},
    )

Add hessian edges based on the operator's nonlinear interaction pattern.
"""
function _add_hessian_edges!(
    edge_list::Set{Tuple{Int,Int}},
    interactions::Vector{Tuple{Int,Int}},
    child_variables::Dict{Int,Set{Int}},
)
    for (child_i, child_j) in interactions
        if child_i == child_j
            # Within-child interactions: add all pairs from a single child
            if haskey(child_variables, child_i)
                vars = child_variables[child_i]
                for vi in vars
                    for vj in vars
                        i, j = minmax(vi, vj)
                        push!(edge_list, (j, i))
                    end
                end
            end
        else
            # Between-child interactions: add pairs from different children
            if haskey(child_variables, child_i) &&
               haskey(child_variables, child_j)
                vars_i = child_variables[child_i]
                vars_j = child_variables[child_j]
                for vi in vars_i
                    for vj in vars_j
                        i, j = minmax(vi, vj)
                        push!(edge_list, (j, i))
                    end
                end
            end
        end
    end
    return
end

"""
    _list_subexpressions(nodes::Vector{Nonlinear.Node})

Returns the list of subexpressions which a given tape depends on directly
"""
function _list_subexpressions(nodes::Vector{Nonlinear.Node})
    indices = Set{Int}(
        n.index for n in nodes if n.type == Nonlinear.NODE_SUBEXPRESSION
    )
    return sort(collect(indices))
end

"""
    _topological_sort(
        starts::Vector{Int},
        subexpressions::Vector{Vector{Nonlinear.Node}},
        subexpression_dependency_graph::Vector{Vector{Int}} =
            Vector{Vector{Int}}(undef, length(subexpressions)),
    )

Return a topologically sorted list of the integer subexpression indices that
need to be computed to evaluate `subexpressions[s]` for all `s in starts`.

`starts` should be ordered, and not contain duplicates.

`subexpression_dependency_graph[i]` is a lazily computed list of "out" edges
from node `i`, in terms of the integer-valued subexpression index (that is,
`node.index`). This list should be unique and ordered.

If calling `_topological_sort` a single time, you may omit the
`subexpression_dependency_graph` argument.

However, if calling `_topological_sort` multiple times on the _same_ vector of
subexpressions, you should create `subexpression_dependency_graph` once (either
as the uninitialized vector, or by explicitly computing the full
`subexpression_dependency_graph`), and pass it in.

## Notes

* It is important to not use recursion here, because expressions may have
  arbitrary levels of nesting.
* This function assumes `subexpressions` is acyclic.
"""
function _topological_sort(
    starts,
    subexpressions::Vector{Vector{Nonlinear.Node}},
    subexpression_dependency_graph::Vector{Vector{Int}} = Vector{Vector{Int}}(
        undef,
        length(subexpressions),
    ),
)
    ordered = Int[]
    in_order = fill(false, length(subexpressions))
    stack = Tuple{Int,Bool}[]
    for s in starts
        if in_order[s]
            continue  # s is already in `ordered`.
        end
        push!(stack, (s, true))
        while !isempty(stack)
            node, needs_checking = pop!(stack)
            if !needs_checking
                # We must be returning to this node for a second time, and we
                # have already checked all of the children. Therefore, we can
                # add it to the set of ordered nodes.
                push!(ordered, node)
                in_order[node] = true
                continue
            elseif in_order[node]
                continue  # This node has already been added to `ordered`.
            end
            # Re-add the node to the stack, but set the `false` flag this time
            # so next time we visit it, it will go on the `ordered` list
            # instead.
            push!(stack, (node, false))
            if !isassigned(subexpression_dependency_graph, node)
                subexpression_dependency_graph[node] =
                    _list_subexpressions(subexpressions[node])
            end
            for child in subexpression_dependency_graph[node]
                if !in_order[child]
                    push!(stack, (child, true))
                end
            end
        end
    end
    return ordered
end

"""
    _order_subexpressions(
        main_expressions::Vector{Vector{Nonlinear.Node}},
        subexpressions::Vector{Vector{Nonlinear.Node}};
    )

Topologically sort the subexpression needed to evaluate `main_expressions`.

Returns two things:

 * A `Vector{Int}` containing the ordered list of subexpression-indices that
   need to be evaluated to compute all `main_expressions`
 * A `Vector{Vector{Int}}`, containing a list of ordered lists of
   subexpression-indices that need to be evaluated to compute
   `main_expressions[i]`.

**Warning:** This doesn't handle cyclic expressions. But this should be fine
because we can't compute them in JuMP anyway.
"""
function _order_subexpressions(
    main_expressions::Vector{Vector{Nonlinear.Node}},
    subexpressions::Vector{Vector{Nonlinear.Node}},
)
    # The graph of node dependencies. Constructed lazily.
    subexpression_dependency_graph =
        Vector{Vector{Int}}(undef, length(subexpressions))
    # Node dependencies of the main expressions.
    starts = Set{Int}()
    individual_sorts = Vector{Int}[]
    for expression in main_expressions
        s = _list_subexpressions(expression)
        union!(starts, s)
        push!(
            individual_sorts,
            _topological_sort(
                s,
                subexpressions,
                subexpression_dependency_graph,
            ),
        )
    end
    full_sort = _topological_sort(
        starts,
        subexpressions,
        subexpression_dependency_graph,
    )
    return full_sort, individual_sorts
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

abstract type AbstractVectorBounds end

function set_from_constants(
    b::AbstractVectorBounds,
    ::Type{<:MOI.EqualTo},
    index,
)
    return MOI.EqualTo(b.lower[index])
end

function set_from_constants(
    b::AbstractVectorBounds,
    S::Type{<:Union{MOI.GreaterThan,MOI.EqualTo}},
    index,
)
    # Lower and upper bounds are equal for `EqualTo`, we can take either of them.
    return S(b.lower[index])
end

function set_from_constants(
    b::AbstractVectorBounds,
    S::Type{<:MOI.LessThan},
    index,
)
    return S(b.upper[index])
end

function set_from_constants(
    b::AbstractVectorBounds,
    S::Type{<:Union{MOI.Interval,MOI.Semicontinuous,MOI.Semiinteger}},
    index,
)
    return S(b.lower[index], b.upper[index])
end

function set_from_constants(
    ::AbstractVectorBounds,
    S::Type{<:Union{MOI.Integer,MOI.ZeroOne}},
    index,
)
    return S()
end

function set_from_constants(
    b::AbstractVectorBounds,
    ::Type{<:MOI.Parameter},
    index,
)
    return MOI.Parameter(b.lower[index])
end

"""
    SUPPORTED_VARIABLE_SCALAR_SETS{T}

The union of scalar sets for `VariableIndex` constraints supported by
`Utilities.Hyperrectangle` and `Utilities.VariablesContainer`.
"""
const SUPPORTED_VARIABLE_SCALAR_SETS{T} = Union{
    MOI.EqualTo{T},
    MOI.GreaterThan{T},
    MOI.LessThan{T},
    MOI.Interval{T},
    MOI.Integer,
    MOI.ZeroOne,
    MOI.Semicontinuous{T},
    MOI.Semiinteger{T},
    MOI.Parameter{T},
}

# 0x01cb = 0x0080 | 0x0040 | 0x0008 | 0x0002 | 0x0001 | 0x0100
const _LOWER_BOUND_MASK = 0x01cb
# 0x01cd = 0x0080 | 0x0040 | 0x0008 | 0x0004 | 0x0001 | 0x0100
const _UPPER_BOUND_MASK = 0x01cd

const _DELETED_VARIABLE = 0x8000

_single_variable_flag(::Type{<:MOI.EqualTo}) = 0x0001
_single_variable_flag(::Type{<:MOI.GreaterThan}) = 0x0002
_single_variable_flag(::Type{<:MOI.LessThan}) = 0x0004
_single_variable_flag(::Type{<:MOI.Interval}) = 0x0008
_single_variable_flag(::Type{MOI.Integer}) = 0x0010
_single_variable_flag(::Type{MOI.ZeroOne}) = 0x0020
_single_variable_flag(::Type{<:MOI.Semicontinuous}) = 0x0040
_single_variable_flag(::Type{<:MOI.Semiinteger}) = 0x0080
_single_variable_flag(::Type{<:MOI.Parameter}) = 0x0100

function _flag_to_set_type(flag::UInt16, ::Type{T}) where {T}
    if flag == 0x0001
        return MOI.EqualTo{T}
    elseif flag == 0x0002
        return MOI.GreaterThan{T}
    elseif flag == 0x0004
        return MOI.LessThan{T}
    elseif flag == 0x0008
        return MOI.Interval{T}
    elseif flag == 0x0010
        return MOI.Integer
    elseif flag == 0x0020
        return MOI.ZeroOne
    elseif flag == 0x0040
        return MOI.Semicontinuous{T}
    elseif flag == 0x0080
        return MOI.Semiinteger{T}
    else
        @assert flag == 0x0100
        return MOI.Parameter{T}
    end
end

# Julia doesn't infer `S1` correctly, so we use a function barrier to improve
# inference.
function _throw_if_lower_bound_set_inner(variable, S2, mask, T)
    S1 = _flag_to_set_type(mask, T)
    return throw(MOI.LowerBoundAlreadySet{S1,S2}(variable))
end

function _throw_if_lower_bound_set(variable, S2, mask, T)
    lower_mask = mask & _LOWER_BOUND_MASK
    if iszero(lower_mask)
        return  # No lower bound set.
    elseif iszero(_single_variable_flag(S2) & _LOWER_BOUND_MASK)
        return  # S2 isn't related to the lower bound.
    end
    return _throw_if_lower_bound_set_inner(variable, S2, lower_mask, T)
end

# Julia doesn't infer `S1` correctly, so we use a function barrier to improve
# inference.
function _throw_if_upper_bound_set_inner(variable, S2, mask, T)
    S1 = _flag_to_set_type(mask, T)
    return throw(MOI.UpperBoundAlreadySet{S1,S2}(variable))
end

function _throw_if_upper_bound_set(variable, S2, mask, T)
    upper_mask = mask & _UPPER_BOUND_MASK
    if iszero(upper_mask)
        return  # No upper bound set.
    elseif iszero(_single_variable_flag(S2) & _UPPER_BOUND_MASK)
        return  # S2 isn't related to the upper bound.
    end
    return _throw_if_upper_bound_set_inner(variable, S2, upper_mask, T)
end

function _lower_bound(
    set::Union{MOI.GreaterThan,MOI.Interval,MOI.Semicontinuous,MOI.Semiinteger},
)
    return set.lower
end

_lower_bound(set::Union{MOI.EqualTo,MOI.Parameter}) = set.value

function _upper_bound(
    set::Union{MOI.LessThan,MOI.Interval,MOI.Semicontinuous,MOI.Semiinteger},
)
    return set.upper
end

_upper_bound(set::Union{MOI.EqualTo,MOI.Parameter}) = set.value

# Use `-Inf` and `Inf` for `AbstractFloat` subtypes.
_no_lower_bound(::Type{T}) where {T} = zero(T)
_no_lower_bound(::Type{T}) where {T<:AbstractFloat} = typemin(T)
_no_upper_bound(::Type{T}) where {T} = zero(T)
_no_upper_bound(::Type{T}) where {T<:AbstractFloat} = typemax(T)

###
### VariablesContainer
###
### For use in MOI.Utilities.Model
###

"""
    struct VariablesContainer{T} <: AbstractVectorBounds
        set_mask::Vector{UInt16}
        lower::Vector{T}
        upper::Vector{T}
    end

A struct for storing variables and VariableIndex-related constraints. Used in
`MOI.Utilities.Model` by default.
"""
mutable struct VariablesContainer{T} <: AbstractVectorBounds
    set_mask::Vector{UInt16}
    lower::Vector{T}
    upper::Vector{T}
end

function VariablesContainer{T}() where {T}
    return VariablesContainer{T}(UInt16[], T[], T[])
end

function Base.:(==)(a::VariablesContainer, b::VariablesContainer)
    return a.set_mask == b.set_mask && a.lower == b.lower && a.upper == b.upper
end

function MOI.empty!(b::VariablesContainer)
    empty!(b.set_mask)
    empty!(b.lower)
    empty!(b.upper)
    return b
end

function MOI.is_empty(b::VariablesContainer)
    if length(b.set_mask) == 0
        return true
    end
    return all(isequal(_DELETED_VARIABLE), b.set_mask)
end

function Base.resize!(b::VariablesContainer, n)
    resize!(b.set_mask, n)
    resize!(b.lower, n)
    resize!(b.upper, n)
    return
end

function MOI.add_variable(b::VariablesContainer{T}) where {T}
    push!(b.set_mask, 0x0000)
    push!(b.lower, _no_lower_bound(T))
    push!(b.upper, _no_upper_bound(T))
    x = MOI.VariableIndex(length(b.set_mask))
    return x
end

function MOI.get(b::VariablesContainer, ::MOI.ListOfVariableIndices)
    return MOI.VariableIndex[
        MOI.VariableIndex(i) for
        i in 1:length(b.set_mask) if b.set_mask[i] != _DELETED_VARIABLE
    ]
end

function MOI.is_valid(b::VariablesContainer, x::MOI.VariableIndex)
    mask = get(b.set_mask, x.value, _DELETED_VARIABLE)
    return mask != _DELETED_VARIABLE
end

function MOI.get(b::VariablesContainer, ::MOI.NumberOfVariables)::Int64
    if length(b.set_mask) == 0
        return 0
    end
    return sum(x != _DELETED_VARIABLE for x in b.set_mask)
end

function MOI.supports_constraint(
    ::VariablesContainer{T},
    ::Type{MOI.VariableIndex},
    ::Type{<:SUPPORTED_VARIABLE_SCALAR_SETS{T}},
) where {T}
    return true
end

function MOI.add_constraint(
    b::VariablesContainer{T},
    f::MOI.VariableIndex,
    set::S,
) where {T,S<:SUPPORTED_VARIABLE_SCALAR_SETS}
    flag = _single_variable_flag(S)
    mask = b.set_mask[f.value]
    _throw_if_lower_bound_set(f, S, mask, T)
    _throw_if_upper_bound_set(f, S, mask, T)
    if !iszero(flag & _LOWER_BOUND_MASK)
        b.lower[f.value] = _lower_bound(set)
    end
    if !iszero(flag & _UPPER_BOUND_MASK)
        b.upper[f.value] = _upper_bound(set)
    end
    b.set_mask[f.value] = mask | flag
    return MOI.ConstraintIndex{MOI.VariableIndex,S}(f.value)
end

function MOI.delete(
    b::VariablesContainer{T},
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {T,S<:SUPPORTED_VARIABLE_SCALAR_SETS{T}}
    MOI.throw_if_not_valid(b, ci)
    flag = _single_variable_flag(S)
    b.set_mask[ci.value] &= ~flag
    if !iszero(flag & _LOWER_BOUND_MASK)
        b.lower[ci.value] = _no_lower_bound(T)
    end
    if !iszero(flag & _UPPER_BOUND_MASK)
        b.upper[ci.value] = _no_upper_bound(T)
    end
    return
end

function MOI.delete(b::VariablesContainer, x::MOI.VariableIndex)
    MOI.throw_if_not_valid(b, x)
    b.set_mask[x.value] = _DELETED_VARIABLE
    return
end

function MOI.is_valid(
    b::VariablesContainer{T},
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {T,S<:SUPPORTED_VARIABLE_SCALAR_SETS{T}}
    if !(1 <= ci.value <= length(b.set_mask))
        return false
    end
    return !iszero(b.set_mask[ci.value] & _single_variable_flag(S))
end

MOI.is_valid(::VariablesContainer, ::MOI.ConstraintIndex) = false

function MOI.get(
    model::VariablesContainer,
    ::MOI.ConstraintFunction,
    ci::MOI.ConstraintIndex{MOI.VariableIndex},
)
    MOI.throw_if_not_valid(model, ci)
    return MOI.VariableIndex(ci.value)
end

function MOI.set(
    ::VariablesContainer,
    ::MOI.ConstraintFunction,
    ::MOI.ConstraintIndex{MOI.VariableIndex},
    ::MOI.VariableIndex,
)
    return throw(MOI.SettingVariableIndexNotAllowed())
end

function MOI.get(
    model::VariablesContainer{T},
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {T,S<:SUPPORTED_VARIABLE_SCALAR_SETS{T}}
    MOI.throw_if_not_valid(model, ci)
    return set_from_constants(model, S, ci.value)
end

function MOI.set(
    model::VariablesContainer{T},
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
    set::S,
) where {T,S<:SUPPORTED_VARIABLE_SCALAR_SETS{T}}
    MOI.throw_if_not_valid(model, ci)
    flag = _single_variable_flag(S)
    if !iszero(flag & _LOWER_BOUND_MASK)
        model.lower[ci.value] = _lower_bound(set)
    end
    if !iszero(flag & _UPPER_BOUND_MASK)
        model.upper[ci.value] = _upper_bound(set)
    end
    return
end

function MOI.get(
    b::VariablesContainer{T},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,S},
)::Int64 where {T,S<:SUPPORTED_VARIABLE_SCALAR_SETS{T}}
    flag = _single_variable_flag(S)
    return count(mask -> !iszero(flag & mask), b.set_mask)
end

function _add_constraint_type(
    list,
    b::VariablesContainer,
    S::Type{<:MOI.AbstractScalarSet},
)
    flag = _single_variable_flag(S)::UInt16
    if any(mask -> !iszero(flag & mask), b.set_mask)
        push!(list, (MOI.VariableIndex, S))
    end
    return
end

function MOI.get(
    b::VariablesContainer{T},
    ::MOI.ListOfConstraintTypesPresent,
) where {T}
    list = Tuple{Type,Type}[]
    _add_constraint_type(list, b, MOI.EqualTo{T})
    _add_constraint_type(list, b, MOI.GreaterThan{T})
    _add_constraint_type(list, b, MOI.LessThan{T})
    _add_constraint_type(list, b, MOI.Interval{T})
    _add_constraint_type(list, b, MOI.Semicontinuous{T})
    _add_constraint_type(list, b, MOI.Semiinteger{T})
    _add_constraint_type(list, b, MOI.Integer)
    _add_constraint_type(list, b, MOI.ZeroOne)
    _add_constraint_type(list, b, MOI.Parameter{T})
    return list
end

function MOI.get(
    b::VariablesContainer{T},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,S},
) where {T,S<:SUPPORTED_VARIABLE_SCALAR_SETS{T}}
    list = MOI.ConstraintIndex{MOI.VariableIndex,S}[]
    flag = _single_variable_flag(S)
    for (index, mask) in enumerate(b.set_mask)
        if !iszero(mask & flag)
            push!(list, MOI.ConstraintIndex{MOI.VariableIndex,S}(index))
        end
    end
    return list
end

# These `MOI.ModelLike` fallbacks have to be redefined here as
# `VariablesContainer` is not a subtype of `MOI.ModelLike`

function MOI.throw_if_not_valid(b::VariablesContainer, index)
    if !MOI.is_valid(b, index)
        throw(MOI.InvalidIndex(index))
    end
end

function MOI.set(
    ::VariablesContainer,
    ::MOI.ConstraintFunction,
    ci::MOI.ConstraintIndex,
    func,
)
    return throw(MOI.FunctionTypeMismatch{MOI.func_type(ci),typeof(func)}())
end

function MOI.set(
    ::VariablesContainer,
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex},
    set,
)
    return throw(MOI.SetTypeMismatch{MOI.set_type(ci),typeof(set)}())
end

function MOI.supports_constraint(
    ::VariablesContainer,
    ::Type{<:MOI.AbstractFunction},
    ::Type{<:MOI.AbstractSet},
)
    return false
end

function MOI.add_constraint(
    ::VariablesContainer,
    func::MOI.AbstractFunction,
    set::MOI.AbstractSet,
)
    return throw(MOI.UnsupportedConstraint{typeof(func),typeof(set)}())
end

###
### Hyperrectangle
###

"""
    struct Hyperrectangle{T} <: AbstractVectorBounds
        lower::Vector{T}
        upper::Vector{T}
    end

A struct for the .constants field in MatrixOfConstraints.
"""
struct Hyperrectangle{T} <: AbstractVectorBounds
    lower::Vector{T}
    upper::Vector{T}
end

Hyperrectangle{T}() where {T} = Hyperrectangle{T}(T[], T[])

function Base.:(==)(a::Hyperrectangle, b::Hyperrectangle)
    return a.lower == b.lower && a.upper == b.upper
end

function Base.empty!(b::Hyperrectangle)
    empty!(b.lower)
    empty!(b.upper)
    return b
end

function Base.resize!(b::Hyperrectangle, n)
    resize!(b.lower, n)
    resize!(b.upper, n)
    return
end

function load_constants(
    b::Hyperrectangle{T},
    offset,
    set::SUPPORTED_VARIABLE_SCALAR_SETS{T},
) where {T}
    flag = _single_variable_flag(typeof(set))
    if iszero(flag & _LOWER_BOUND_MASK)
        b.lower[offset+1] = _no_lower_bound(T)
    else
        b.lower[offset+1] = _lower_bound(set)
    end
    if iszero(flag & _UPPER_BOUND_MASK)
        b.upper[offset+1] = _no_upper_bound(T)
    else
        b.upper[offset+1] = _upper_bound(set)
    end
    return
end

function_constants(::Hyperrectangle{T}, row) where {T} = zero(T)

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Julia 1.6 removes Grisu from Base. Previously, we went
#   _print_shortest(io, x) = Base.Grisu.print_shortest(io, x)
# To avoid adding Grisu as a dependency, use the following printing heuristic.
# TODO(odow): consider printing 1.0 as 1.0 instead of 1, that is, without the
# rounding branch.
function _print_shortest(io::IO, x::Float64)
    if x == -Inf
        print(io, "-inf")
    elseif x == Inf
        print(io, "inf")
    elseif isinteger(x) && (typemin(Int) <= x <= typemax(Int))
        print(io, round(Int, x))
    else
        print(io, x)
    end
    return
end

_print_shortest(io::IO, x::Integer) = print(io, x)

const _START_REG = r"^([\.0-9eE])"
const _NAME_REG = r"([^a-zA-Z0-9\!\"\#\$\%\&\(\)\/\,\.\;\?\@\_\`\'\{\}\|\~])"

function _write_function(
    io::IO,
    ::Model,
    func::MOI.VariableIndex,
    variable_names::Dict{MOI.VariableIndex,String};
    kwargs...,
)
    print(io, variable_names[func])
    return
end

function _write_function(
    io::IO,
    ::Model,
    func::MOI.ScalarAffineFunction,
    variable_names::Dict{MOI.VariableIndex,String};
    print_one::Bool = true,
    kwargs...,
)
    is_first_item = true
    if !iszero(func.constant)
        _print_shortest(io, func.constant)
        is_first_item = false
    end
    for term in func.terms
        if !iszero(term.coefficient)
            if is_first_item
                if print_one || !isone(term.coefficient)
                    _print_shortest(io, term.coefficient)
                end
                is_first_item = false
            else
                print(io, term.coefficient < 0 ? " - " : " + ")
                _print_shortest(io, abs(term.coefficient))
            end
            print(io, " ", variable_names[term.variable])
        end
    end
    return
end

function _write_function(
    io::IO,
    ::Model,
    func::MOI.ScalarQuadraticFunction,
    variable_names::Dict{MOI.VariableIndex,String};
    print_half::Bool = true,
    kwargs...,
)
    is_first_item = true
    if !iszero(func.constant)
        _print_shortest(io, func.constant)
        is_first_item = false
    end
    for term in func.affine_terms
        if !iszero(term.coefficient)
            if is_first_item
                _print_shortest(io, term.coefficient)
                is_first_item = false
            else
                print(io, term.coefficient < 0 ? " - " : " + ")
                _print_shortest(io, abs(term.coefficient))
            end
            print(io, " ", variable_names[term.variable])
        end
    end
    if length(func.quadratic_terms) > 0
        if is_first_item
            print(io, "[ ")
        else
            print(io, " + [ ")
        end
        is_first_item = true
        for term in func.quadratic_terms
            coefficient = term.coefficient
            if !print_half && term.variable_1 == term.variable_2
                coefficient /= 2
            end
            if print_half && term.variable_1 != term.variable_2
                coefficient *= 2
            end
            if is_first_item
                _print_shortest(io, coefficient)
                is_first_item = false
            else
                print(io, coefficient < 0 ? " - " : " + ")
                _print_shortest(io, abs(coefficient))
            end
            print(io, " ", variable_names[term.variable_1])
            if term.variable_1 == term.variable_2
                print(io, " ^ 2")
            else
                print(io, " * ", variable_names[term.variable_2])
            end
        end
        if print_half
            print(io, " ]/2")
        else
            print(io, " ]")
        end
    end
    return
end

function _write_constraint_suffix(io::IO, set::MOI.LessThan)
    print(io, " <= ")
    _print_shortest(io, set.upper)
    println(io)
    return
end

function _write_constraint_suffix(io::IO, set::MOI.GreaterThan)
    print(io, " >= ")
    _print_shortest(io, set.lower)
    println(io)
    return
end

function _write_constraint_suffix(io::IO, set::MOI.EqualTo)
    print(io, " = ")
    _print_shortest(io, set.value)
    println(io)
    return
end

function _write_constraint_suffix(io::IO, set::MOI.Interval)
    print(io, " <= ")
    _print_shortest(io, set.upper)
    println(io)
    return
end

function _write_constraint_prefix(io::IO, set::MOI.Interval)
    _print_shortest(io, set.lower)
    print(io, " <= ")
    return
end

_write_constraint_prefix(::IO, ::Any) = nothing

function _write_constraint(
    io::IO,
    model::Model,
    index::MOI.ConstraintIndex,
    variable_names::Dict{MOI.VariableIndex,String};
    write_name::Bool = true,
)
    func = MOI.get(model, MOI.ConstraintFunction(), index)
    set = MOI.get(model, MOI.ConstraintSet(), index)
    if write_name
        print(io, MOI.get(model, MOI.ConstraintName(), index), ": ")
    end
    _write_constraint_prefix(io, set)
    _write_function(io, model, func, variable_names; print_half = false)
    _write_constraint_suffix(io, set)
    return
end

function _write_sense(io::IO, model::Model)
    if MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
        println(io, "maximize")
    else
        println(io, "minimize")
    end
    return
end

function _write_objective(
    io::IO,
    model::Model,
    variable_names::Dict{MOI.VariableIndex,String},
)
    print(io, "obj: ")
    F = MOI.get(model, MOI.ObjectiveFunctionType())
    f = MOI.get(model, MOI.ObjectiveFunction{F}())
    _write_function(io, model, f, variable_names)
    println(io)
    return
end

function _write_integrality(
    io::IO,
    model::Model,
    key::String,
    ::Type{S},
    variable_names::Dict{MOI.VariableIndex,String},
) where {S}
    indices = MOI.get(model, MOI.ListOfConstraintIndices{MOI.VariableIndex,S}())
    if length(indices) == 0
        return
    end
    println(io, key)
    for index in indices
        f = MOI.get(model, MOI.ConstraintFunction(), index)
        _write_function(io, model, f, variable_names)
        println(io)
    end
    return
end

function _write_constraints(io, model::Model{T}, S, variable_names) where {T}
    F = MOI.ScalarAffineFunction{T}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        _write_constraint(io, model, index, variable_names; write_name = true)
    end
    F = MOI.ScalarQuadraticFunction{T}
    for index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        _write_constraint(io, model, index, variable_names; write_name = true)
    end
    return
end

function _write_sos_constraints(io, model::Model{T}, variable_names) where {T}
    F = MOI.VectorOfVariables
    sos1_indices = MOI.get(model, MOI.ListOfConstraintIndices{F,MOI.SOS1{T}}())
    sos2_indices = MOI.get(model, MOI.ListOfConstraintIndices{F,MOI.SOS2{T}}())
    if length(sos1_indices) + length(sos2_indices) == 0
        return
    end
    println(io, "SOS")
    for index in sos1_indices
        _write_constraint(io, model, index, variable_names)
    end
    for index in sos2_indices
        _write_constraint(io, model, index, variable_names)
    end
    return
end

_to_string(::Type{<:MOI.SOS1}) = "S1::"
_to_string(::Type{<:MOI.SOS2}) = "S2::"

function _write_constraint(
    io::IO,
    model::Model,
    index::MOI.ConstraintIndex{MOI.VectorOfVariables,S},
    variable_names::Dict{MOI.VariableIndex,String},
) where {S<:Union{MOI.SOS1,MOI.SOS2}}
    f = MOI.get(model, MOI.ConstraintFunction(), index)
    s = MOI.get(model, MOI.ConstraintSet(), index)
    name = MOI.get(model, MOI.ConstraintName(), index)
    if name !== nothing && !isempty(name)
        print(io, name, ": ")
    end
    print(io, _to_string(S))
    for (w, x) in zip(s.weights, f.variables)
        print(io, " ", variable_names[x], ":", w)
    end
    println(io)
    return
end

function _write_indicator_constraints(
    io,
    model::Model{T},
    ::Type{S},
    variable_names,
) where {T,S}
    F = MOI.VectorAffineFunction{T}
    for A in (MOI.ACTIVATE_ON_ONE, MOI.ACTIVATE_ON_ZERO)
        Set = MOI.Indicator{A,S}
        for index in MOI.get(model, MOI.ListOfConstraintIndices{F,Set}())
            _write_constraint(
                io,
                model,
                index,
                variable_names;
                write_name = true,
            )
        end
    end
    F = MOI.VectorOfVariables
    for A in (MOI.ACTIVATE_ON_ONE, MOI.ACTIVATE_ON_ZERO)
        Set = MOI.Indicator{A,S}
        for index in MOI.get(model, MOI.ListOfConstraintIndices{F,Set}())
            _write_constraint(
                io,
                model,
                index,
                variable_names;
                write_name = true,
            )
        end
    end
    return
end

function _write_constraint(
    io::IO,
    model::Model{T},
    index::MOI.ConstraintIndex{F,MOI.Indicator{A,S}},
    variable_names::Dict{MOI.VariableIndex,String};
    write_name::Bool = true,
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},A,S}
    func = MOI.get(model, MOI.ConstraintFunction(), index)
    set = MOI.get(model, MOI.ConstraintSet(), index)
    if write_name
        print(io, MOI.get(model, MOI.ConstraintName(), index), ": ")
    end
    z, f = MOI.Utilities.scalarize(func)
    flag = A == MOI.ACTIVATE_ON_ONE ? 1 : 0
    _write_function(io, model, z, variable_names; print_one = false)
    print(io, " = ", flag, " -> ")
    _write_function(io, model, f, variable_names)
    _write_constraint_suffix(io, set.set)
    return
end

"""
    Base.write(io::IO, model::FileFormats.LP.Model)

Write `model` to `io` in the LP file format.
"""
function Base.write(io::IO, model::Model{T}) where {T}
    options = get_options(model)
    FileFormats.create_unique_names(
        model,
        warn = options.warn,
        replacements = [
            s -> match(_START_REG, s) !== nothing ? "_" * s : s,
            s -> replace(s, _NAME_REG => "_"),
            s -> s[1:min(length(s), options.maximum_length)],
        ],
    )
    variable_names = Dict{MOI.VariableIndex,String}(
        index => MOI.get(model, MOI.VariableName(), index) for
        index in MOI.get(model, MOI.ListOfVariableIndices())
    )
    free_variables = Set(keys(variable_names))
    _write_sense(io, model)
    _write_objective(io, model, variable_names)
    println(io, "subject to")
    _write_constraints(io, model, MOI.LessThan{T}, variable_names)
    _write_indicator_constraints(io, model, MOI.LessThan{T}, variable_names)
    _write_constraints(io, model, MOI.GreaterThan{T}, variable_names)
    _write_indicator_constraints(io, model, MOI.GreaterThan{T}, variable_names)
    _write_constraints(io, model, MOI.EqualTo{T}, variable_names)
    _write_indicator_constraints(io, model, MOI.EqualTo{T}, variable_names)
    _write_constraints(io, model, MOI.Interval{T}, variable_names)
    _write_indicator_constraints(io, model, MOI.Interval{T}, variable_names)
    println(io, "Bounds")
    CI = MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}
    for x in MOI.get(model, MOI.ListOfVariableIndices())
        lb, ub = MOI.Utilities.get_bounds(model, T, x)
        if lb == typemin(T) && ub == typemax(T)
            if MOI.is_valid(model, CI(x.value))
                # If a variable is binary, it should not be listed as `free` in
                # the bounds section.
                continue
            end
            print(io, variable_names[x], " free")
        elseif lb == ub
            print(io, variable_names[x], " = ")
            _print_shortest(io, lb)
        elseif lb == typemin(T)
            print(io, "-infinity <= ", variable_names[x], " <= ")
            _print_shortest(io, ub)
        elseif ub == typemax(T)
            print(io, variable_names[x], " >= ")
            _print_shortest(io, lb)
        else
            _print_shortest(io, lb)
            print(io, " <= ", variable_names[x], " <= ")
            _print_shortest(io, ub)
        end
        println(io)
    end
    _write_integrality(io, model, "General", MOI.Integer, variable_names)
    _write_integrality(io, model, "Binary", MOI.ZeroOne, variable_names)
    _write_sos_constraints(io, model, variable_names)
    println(io, "End")
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintDualGeoMean

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_DualGeoMean()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.DualGeoMean{Float64}(mock)
    MOI.Test.test_basic_VectorOfVariables_DualGeometricMeanCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_basic_VectorAffineFunction_DualGeometricMeanCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_basic_VectorQuadraticFunction_DualGeometricMeanCone(
        bridged_mock,
        config,
    )
    return
end

function test_conic_DualGeometricMeanCone_VectorAffineFunction()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.DualGeoMean{Float64}(mock)
    var_primal = [-3, 1, 1, 1]
    geomean_dual = copy(var_primal)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) => [[0]],
            (MOI.VectorAffineFunction{Float64}, MOI.GeometricMeanCone) =>
                [geomean_dual],
        )

    MOI.Test.test_conic_DualGeometricMeanCone_VectorAffineFunction(
        bridged_mock,
        config,
    )
    var_names = ["t", "x", "y", "z"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    nonneg = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Nonnegatives,
        }(),
    )
    geomean = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.GeometricMeanCone,
        }(),
    )
    @test length(nonneg) == 1
    MOI.set(mock, MOI.ConstraintName(), nonneg[1], "nonneg")
    @test length(geomean) == 1
    MOI.set(mock, MOI.ConstraintName(), geomean[1], "geomean")
    less = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(less) == 1
    MOI.set(mock, MOI.ConstraintName(), less[1], "less")

    s = """
    variables: t, x, y, z
    less: x + y + z in LessThan(3.0)
    nonneg: [-1 * t] in Nonnegatives(1)
    geomean: [-1/3 * t, x, y, z] in GeometricMeanCone(4)
    minobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        var_names,
        ["less", "nonneg", "geomean"],
    )
    dualgeomean = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.DualGeometricMeanCone,
        }(),
    )
    @test length(dualgeomean) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), dualgeomean[1], "dualgeomean")
    less = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(less) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), less[1], "less")

    s = """
    variables: t, x, y, z
    less: x + y + z in LessThan(3.0)
    dualgeomean: [1.0t, x, y, z] in DualGeometricMeanCone(4)
    minobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["less", "dualgeomean"],
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.DualGeometricMeanCone,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        4,
        (
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.GeometricMeanCone, 0),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.DualGeoMeanBridge,
        """
        variables: u, w1, w2
        [u, w1, w2] in DualGeometricMeanCone(3)
        """,
        """
        variables: u, w1, w2
        [-1/2 * u, w1, w2] in GeometricMeanCone(3)
        [-1 * u] in Nonnegatives(1)
        """,
    )
    return
end

end  # module

TestConstraintDualGeoMean.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    RelativeEntropyBridge{T,F,G,H} <: Bridges.Constraint.AbstractBridge

`RelativeEntropyBridge` implements the following reformulation that converts a
[`MOI.RelativeEntropyCone`](@ref) into an [`MOI.ExponentialCone`](@ref):

  * ``u \\ge \\sum_{i=1}^n w_i \\log \\left(\\frac{w_i}{v_i}\\right)`` into
    ``y_i \\ge 0``, ``u \\ge \\sum_{i=1}^n y_i``, and
    ``(-y_i, w_i, v_i) \\in ExponentialCone``.

## Source node

`RelativeEntropyBridge` supports:

  * `H` in [`MOI.RelativeEntropyCone`](@ref)

## Target nodes

`RelativeEntropyBridge` creates:

  * `F` in [`MOI.GreaterThan{T}`](@ref)
  * `G` in [`MOI.ExponentialCone`](@ref)
"""
struct RelativeEntropyBridge{T,F,G,H} <: AbstractBridge
    y::Vector{MOI.VariableIndex}
    ge_index::MOI.ConstraintIndex{F,MOI.GreaterThan{T}}
    exp_indices::Vector{MOI.ConstraintIndex{G,MOI.ExponentialCone}}
end

const RelativeEntropy{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{RelativeEntropyBridge{T},OT}

function bridge_constraint(
    ::Type{RelativeEntropyBridge{T,F,G,H}},
    model::MOI.ModelLike,
    f::H,
    s::MOI.RelativeEntropyCone,
) where {T,F,G,H}
    f_scalars = MOI.Utilities.eachscalar(f)
    d = MOI.dimension(s)
    v_dim = div(d - 1, 2)
    y = MOI.add_variables(model, v_dim)
    rhs = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(one(T), y), zero(T))
    ge_index = MOI.Utilities.normalize_and_add_constraint(
        model,
        MOI.Utilities.operate(-, T, f_scalars[1], rhs),
        MOI.GreaterThan(zero(T));
        allow_modify_function = true,
    )
    exp_indices = MOI.ConstraintIndex{G,MOI.ExponentialCone}[]
    for i in 1:v_dim
        fi = MOI.Utilities.operate(
            vcat,
            T,
            MOI.Utilities.operate(-, T, y[i]), # -y
            f_scalars[1+i+v_dim],              # u
            f_scalars[1+i],                    # v
        )
        push!(exp_indices, MOI.add_constraint(model, fi, MOI.ExponentialCone()))
    end
    return RelativeEntropyBridge{T,F,G,H}(y, ge_index, exp_indices)
end

function MOI.supports_constraint(
    ::Type{RelativeEntropyBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.RelativeEntropyCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:RelativeEntropyBridge},
)
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{RelativeEntropyBridge{T,F,G,H}},
) where {T,F,G,H}
    return Tuple{Type,Type}[(F, MOI.GreaterThan{T}), (G, MOI.ExponentialCone)]
end

function concrete_bridge_type(
    ::Type{<:RelativeEntropyBridge{T}},
    H::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.RelativeEntropyCone},
) where {T}
    S = MOI.Utilities.scalar_type(H)
    F = MOI.Utilities.promote_operation(-, T, S, S)
    Y = MOI.Utilities.promote_operation(-, T, MOI.VariableIndex)
    G = MOI.Utilities.promote_operation(vcat, T, Y, S)
    return RelativeEntropyBridge{T,F,G,H}
end

function MOI.get(bridge::RelativeEntropyBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.y)
end

function MOI.get(bridge::RelativeEntropyBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.y)
end

function MOI.get(
    ::RelativeEntropyBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.GreaterThan{T}},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    bridge::RelativeEntropyBridge{T,F,G},
    ::MOI.NumberOfConstraints{G,MOI.ExponentialCone},
)::Int64 where {T,F,G}
    return length(bridge.y)
end

function MOI.get(
    bridge::RelativeEntropyBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.GreaterThan{T}},
) where {T,F}
    return [bridge.ge_index]
end

function MOI.get(
    bridge::RelativeEntropyBridge{T,F,G},
    ::MOI.ListOfConstraintIndices{G,MOI.ExponentialCone},
) where {T,F,G}
    return copy(bridge.exp_indices)
end

function MOI.delete(model::MOI.ModelLike, bridge::RelativeEntropyBridge)
    for exp_index_i in bridge.exp_indices
        MOI.delete(model, exp_index_i)
    end
    MOI.delete(model, bridge.ge_index)
    MOI.delete(model, bridge.y)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::RelativeEntropyBridge{T,F,G,H},
) where {T,F,G,H}
    func = MOI.Utilities.zero_with_output_dimension(G, 1 + 2 * length(bridge.y))
    sum_y = MOI.get(model, MOI.ConstraintFunction(), bridge.ge_index)
    MOI.Utilities.operate_output_index!(+, T, 1, func, sum_y)
    w_start = 1 + length(bridge.y)
    for i in eachindex(bridge.y)
        exp_func_i = MOI.Utilities.eachscalar(
            MOI.get(model, MOI.ConstraintFunction(), bridge.exp_indices[i]),
        )
        MOI.Utilities.operate_output_index!(-, T, 1, func, exp_func_i[1])
        MOI.Utilities.operate_output_index!(+, T, 1 + i, func, exp_func_i[3])
        MOI.Utilities.operate_output_index!(
            +,
            T,
            w_start + i,
            func,
            exp_func_i[2],
        )
    end
    f = MOI.Utilities.remove_variable(func, bridge.y)
    return MOI.Utilities.convert_approx(H, f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::RelativeEntropyBridge,
)
    return MOI.RelativeEntropyCone(1 + 2 * length(bridge.y))
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{RelativeEntropyBridge{T,F,G,H}},
) where {T,F,G,H}
    ci_1 = MOI.ConstraintIndex{F,MOI.GreaterThan{T}}
    ci_2 = MOI.ConstraintIndex{G,MOI.ExponentialCone}
    return MOI.supports(model, attr, ci_1) && MOI.supports(model, attr, ci_2)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::RelativeEntropyBridge{T},
) where {T}
    start = MOI.get(model, attr, bridge.ge_index)
    if start === nothing
        return nothing
    end
    primal = zeros(T, 1 + 2 * length(bridge.y))
    primal[1] = start
    for i in eachindex(bridge.y)
        primal_i = MOI.get(model, attr, bridge.exp_indices[i])
        primal[1] -= primal_i[1]
        primal[1+i] = primal_i[3]
        primal[1+i+length(bridge.y)] = primal_i[2]
    end
    return primal
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::RelativeEntropyBridge{T},
    value,
) where {T}
    v_dim = length(bridge.y)
    v = value[2:(v_dim+1)]
    w = value[(v_dim+2):end]
    y = [w_i * log(w_i / v_i) for (v_i, w_i) in zip(v, w)]
    MOI.set(model, attr, bridge.ge_index, value[1] - sum(y))
    for i in 1:v_dim
        start = [-y[i], w[i], v[i]]
        MOI.set(model, attr, bridge.exp_indices[i], start)
        MOI.set(model, MOI.VariablePrimalStart(), bridge.y[i], y[i])
    end
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::RelativeEntropyBridge{T},
    ::Nothing,
) where {T}
    MOI.set(model, attr, bridge.ge_index, nothing)
    for i in 1:length(bridge.exp_indices)
        MOI.set(model, attr, bridge.exp_indices[i], nothing)
        MOI.set(model, MOI.VariablePrimalStart(), bridge.y[i], nothing)
    end
    return
end

# Given a is dual on u - sum(y) >= 0 and (b_i, c_i, d_i) is dual on
# (-y_i, w_i, v_i) in ExponentialCone, the dual on
# (u, v, w) in RelativeEntropyCone is (a, d_i, c_i).
function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::RelativeEntropyBridge{T},
) where {T}
    value = MOI.get(model, attr, bridge.ge_index)
    if value === nothing
        return nothing
    end
    dual = zeros(T, 1 + 2 * length(bridge.y))
    dual[1] = value[1]
    for (i, ci) in enumerate(bridge.exp_indices)
        dual_i = MOI.get(model, attr, ci)
        dual[1+i] = dual_i[3]
        dual[1+i+length(bridge.y)] = dual_i[2]
    end
    return dual
end

# Given constraint dual start of (u, v, w), constraint dual on GreaterThan is u
# and on exponential cone constraint i is (r_i, w_i, v_i), but since y_i is
# free, its dual is 0, so we have -r_i + u == 0 hence r_i = u.
# Note: alternatively, we could use the Lambert W function to calculate
# r_i = exp(W(-w_i / (-v_i * e))) * (-v_i * e), but this is more complicated.
function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::RelativeEntropyBridge,
    value,
)
    MOI.set(model, attr, bridge.ge_index, value[1])
    for i in eachindex(bridge.y)
        start = [value[1], value[1+i+length(bridge.y)], value[1+i]]
        MOI.set(model, attr, bridge.exp_indices[i], start)
    end
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::RelativeEntropyBridge,
    ::Nothing,
)
    MOI.set(model, attr, bridge.ge_index, nothing)
    for ci in bridge.exp_indices
        MOI.set(model, attr, ci, nothing)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

import SparseArrays
using BenchmarkTools

import MathOptInterface as MOI

# Inspired from MatrixOfConstraints
MOI.Utilities.@product_of_sets(_EqualTos, MOI.EqualTo{T},)

a = 1

function _equality_constraints(
    A::AbstractMatrix{T},
    b::AbstractVector{T},
) where {T}
    sets = _EqualTos{T}()
    for _ in eachindex(b)
        MOI.Utilities.add_set(
            sets,
            MOI.Utilities.set_index(sets, MOI.EqualTo{T}),
        )
    end
    MOI.Utilities.final_touch(sets)
    constants = MOI.Utilities.Hyperrectangle(b, b)
    model = MOI.Utilities.MatrixOfConstraints{T}(A, constants, sets)
    model.final_touch = true
    return model
end

function _free_variables(n, ::Type{T}) where {T}
    model = MOI.Utilities.VariablesContainer{T}()
    for _ in 1:n
        MOI.add_variable(model)
    end
    return model
end

function lp_standard_form(m, n; p = 0.1, tr = false)
    T = Float64
    A = SparseArrays.sprand(T, m, n, p)
    if tr
        A = copy(A')'
    end
    b = rand(m)
    return MOI.Utilities.GenericModel{T}(
        MOI.Utilities.ObjectiveContainer{T}(),
        _free_variables(n, T),
        _equality_constraints(A, b),
    )
end

function bench(m, args...; kws...)
    T = Float64
    model = lp_standard_form(m, args...; kws...)
    ci = MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}(
        rand(1:m),
    )
    return @benchmark MOI.get($model, MOI.ConstraintFunction(), $ci)
end

bench(10, 100000)
bench(10, 100000, tr = true)

function prof(m, args...)
    T = Float64
    model = lp_standard_form(m, args...)
    return @profview for i in 1:m
        ci = MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}(
            rand(1:m),
        )
        MOI.get(model, MOI.ConstraintFunction(), ci)
    end
end

prof(10, 100000)

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

import Ipopt
import JuMP
import MathOptInterface as MOI
import PGLib
import PowerModels

model = JuMP.direct_model(Ipopt.Optimizer())
pm = PowerModels.instantiate_model(
    PGLib.pglib("pglib_opf_case10000_goc"),
    PowerModels.ACPPowerModel,
    PowerModels.build_opf;
    jump_model = model,
);

ipopt = JuMP.backend(model)
x = MOI.get(ipopt, MOI.ListOfVariableIndices())
m, n = length(ipopt.nlp_model.constraints), length(x)

evaluator = MOI.Nonlinear.Evaluator(
    ipopt.nlp_model,
    MOI.Nonlinear.SparseReverseMode(),
    x,
)
MOI.initialize(evaluator, [:Grad, :Jac, :Hess])

H_struct = MOI.hessian_lagrangian_structure(evaluator)
H = zeros(length(H_struct))
μ = rand(m)
σ = 0.0
v = rand(n)
@time MOI.eval_hessian_lagrangian(evaluator, H, v, σ, μ)

using BenchmarkTools
@benchmark MOI.eval_hessian_lagrangian($evaluator, $H, $v, $σ, $μ) seconds = 100

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

_drop_moi(s) = replace(string(s), "MathOptInterface." => "")

_escape_braces(s) = replace(replace(s, "{" => "\\{"), "}" => "\\}")

struct _PrintOptions{T<:MIME}
    simplify_coefficients::Bool
    default_name::String
    print_types::Bool

    """
        _PrintOptions(
            mime::MIME;
            simplify_coefficients::Bool = false,
            default_name::String = "v",
            print_types::Bool = true,
        )

    A struct to control options for printing.

    ## Arguments

     * `simplify_coefficients` : Simplify coefficients if possible by omitting
       them or removing trailing zeros.
     * `default_name` : The name given to variables with an empty name.
     * `print_types` : Print the MOI type of each function and set for clarity.
    """
    function _PrintOptions(
        mime::MIME;
        simplify_coefficients::Bool = false,
        default_name::String = "v",
        print_types::Bool = true,
    )
        return new{typeof(mime)}(
            simplify_coefficients,
            default_name,
            print_types,
        )
    end
end

function _to_string(mime::MIME, args...; kwargs...)
    return _to_string(_PrintOptions(mime), args...; kwargs...)
end

#------------------------------------------------------------------------
# Math Symbols
#------------------------------------------------------------------------

# REPL-specific symbols
# Anything here: https://en.wikipedia.org/wiki/Windows-1252
# should probably work fine on Windows

_to_string(::_PrintOptions, ::typeof(*)) = "*"
_to_string(::_PrintOptions{MIME"text/latex"}, ::typeof(*)) = "\\times "

function _to_string(::_PrintOptions, ::typeof(^), n::Int)
    return n == 2 ? "²" : string('^', n)
end

function _to_string(::_PrintOptions{MIME"text/latex"}, ::typeof(^), n::Int)
    return string('^', n)
end

_to_string(::_PrintOptions, ::typeof(in)) = @static Sys.iswindows() ? "in" : "∈"

#------------------------------------------------------------------------
# Functions
#------------------------------------------------------------------------

function _to_string(options::_PrintOptions, model::MOI.ModelLike, x::Vector)
    args = [_to_string(options, model, xi) for xi in x]
    return string("[", join(args, ", "), "]")
end

function _to_string(options::_PrintOptions, ::MOI.ModelLike, c::Real)
    return _shorten(options, c)
end

function _to_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    v::MOI.VariableIndex,
)
    var_name = MOI.get(model, MOI.VariableName(), v)
    if isempty(var_name)
        return string(options.default_name, "[", v.value, "]")
    else
        return var_name
    end
end

function _to_string(
    options::_PrintOptions{MIME"text/latex"},
    model::MOI.ModelLike,
    v::MOI.VariableIndex,
)
    var_name = MOI.get(model, MOI.VariableName(), v)
    if isempty(var_name)
        return string(options.default_name, "_{", v.value, "}")
    end
    # We need to escape latex math characters that appear in the name.
    # However, it's probably impractical to catch everything, so let's just
    # escape the common ones:
    # Escape underscores to prevent them being treated as subscript markers.
    var_name = replace(var_name, "_" => "\\_")
    # Escape carets to prevent them being treated as superscript markers.
    var_name = replace(var_name, "^" => "\\^")
    # Convert any x[args] to x_{args} so that indices on x print as subscripts.
    m = match(r"^(.*)\[(.+)\]$", var_name)
    if m === nothing
        return var_name
    end
    return string(m[1]::AbstractString, "_{", m[2]::AbstractString, "}")
end

function _shorten(options::_PrintOptions, x::Float64)
    if options.simplify_coefficients && isinteger(x)
        return string(round(Int, x))
    end
    return string(x)
end

_shorten(::_PrintOptions, x) = string("(", x, ")")

"""
    _to_string(options::_PrintOptions, c::Real, x::String)

Write a coefficient-name pair to string. There are a few cases to handle.

          | is_first | !is_first
    -----------------------------
    +2.1x | "2.1 x"  | " + 2.1 x"
    -2.1x | "-2.1 x" | " - 2.1 x"
    -----------------------------
    +2.0x | "2 x"    | " + 2 x"
    -2.0x | "-2 x"   | " - 2 x"
    +1.0x | "x"      | " + x"
    -1.0x | "-x"     | " - x"
"""
function _to_string(options::_PrintOptions, c::Real, x::String; is_first::Bool)
    prefix = if is_first
        c < 0 ? "-" : ""
    else
        c < 0 ? " - " : " + "
    end
    s = _shorten(options, abs(c))
    if options.simplify_coefficients && s == "1"
        return string(prefix, x)
    else
        return string(prefix, s, " ", x)
    end
end

function _to_string(
    options::_PrintOptions,
    c::Number,
    x::String;
    is_first::Bool,
)
    return string(is_first ? "" : " + ", _shorten(options, c), " ", x)
end

function _to_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    term::MOI.ScalarAffineTerm;
    is_first::Bool,
)
    name = _to_string(options, model, term.variable)
    return _to_string(options, term.coefficient, name; is_first = is_first)
end

function _to_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    f::MOI.ScalarAffineFunction,
)
    s = _shorten(options, f.constant)
    if options.simplify_coefficients && iszero(f.constant)
        s = ""
    end
    is_first = isempty(s)
    for term in f.terms
        s *= _to_string(options, model, term; is_first = is_first)
        is_first = false
    end
    return s
end

function _to_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    term::MOI.ScalarQuadraticTerm;
    is_first::Bool,
)
    name_1 = _to_string(options, model, term.variable_1)
    name_2 = _to_string(options, model, term.variable_2)
    # Be careful here when printing the coefficient. ScalarQuadraticFunction
    # assumes an additional 0.5 factor.
    coef = term.coefficient
    name = if term.variable_1 == term.variable_2
        coef /= 2
        string(name_1, _to_string(options, ^, 2))
    else
        string(name_1, _to_string(options, *), name_2)
    end
    return _to_string(options, coef, name; is_first = is_first)
end

function _to_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    f::MOI.ScalarQuadraticFunction,
)
    s = _shorten(options, f.constant)
    if options.simplify_coefficients && iszero(f.constant)
        s = ""
    end
    is_first = isempty(s)
    for term in f.affine_terms
        s *= _to_string(options, model, term; is_first = is_first)
        is_first = false
    end
    for term in f.quadratic_terms
        s *= _to_string(options, model, term; is_first = is_first)
        is_first = false
    end
    return s
end

function _to_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    f::MOI.ScalarNonlinearFunction,
)
    io, stack, is_open = IOBuffer(), Any[f], true
    while !isempty(stack)
        arg = pop!(stack)
        if !is_open && arg != ')'
            print(io, ", ")
        end
        if arg isa MOI.ScalarNonlinearFunction
            print(io, arg.head, "(")
            push!(stack, ')')
            for i in length(arg.args):-1:1
                push!(stack, arg.args[i])
            end
        elseif arg isa Char
            print(io, arg)
        else
            print(io, _to_string(options, model, arg))
        end
        is_open = arg isa MOI.ScalarNonlinearFunction
    end
    seekstart(io)
    return read(io, String)
end

function _to_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    f::MOI.AbstractVectorFunction,
)
    rows = map(fi -> _to_string(options, model, fi), scalarize(f))
    max_length = maximum(length.(rows))
    s = join(map(r -> string("│", rpad(r, max_length), "│"), rows), '\n')
    return string(
        "┌",
        rpad("", max_length),
        "┐\n",
        s,
        "\n└",
        rpad("", max_length),
        "┘",
    )
end

function _to_string(
    options::_PrintOptions{MIME"text/latex"},
    model::MOI.ModelLike,
    f::MOI.AbstractVectorFunction,
)
    return string(
        "\\begin{bmatrix}\n",
        join(map(fi -> _to_string(options, model, fi), scalarize(f)), "\\\\\n"),
        "\\end{bmatrix}",
    )
end

#------------------------------------------------------------------------
# Sets
#------------------------------------------------------------------------

function _to_string(options::_PrintOptions, set::MOI.LessThan)
    return string("<= ", _shorten(options, set.upper))
end

function _to_string(options::_PrintOptions{MIME"text/latex"}, set::MOI.LessThan)
    return string("\\le ", _shorten(options, set.upper))
end

function _to_string(options::_PrintOptions, set::MOI.GreaterThan)
    return string(">= ", _shorten(options, set.lower))
end

function _to_string(
    options::_PrintOptions{MIME"text/latex"},
    set::MOI.GreaterThan,
)
    return string("\\ge ", _shorten(options, set.lower))
end

function _to_string(options::_PrintOptions, set::MOI.EqualTo)
    return string("== ", _shorten(options, set.value))
end

function _to_string(options::_PrintOptions{MIME"text/latex"}, set::MOI.EqualTo)
    return string("= ", _shorten(options, set.value))
end

function _to_string(options::_PrintOptions, set::MOI.Interval)
    return string(
        _to_string(options, in),
        " [",
        _shorten(options, set.lower),
        ", ",
        _shorten(options, set.upper),
        "]",
    )
end

function _to_string(options::_PrintOptions{MIME"text/latex"}, set::MOI.Interval)
    return string(
        "\\in [",
        _shorten(options, set.lower),
        ", ",
        _shorten(options, set.upper),
        "]",
    )
end

function _to_string(options::_PrintOptions, ::MOI.ZeroOne)
    return string(_to_string(options, in), " {0, 1}")
end

_to_string(::_PrintOptions{MIME"text/latex"}, ::MOI.ZeroOne) = "\\in \\{0, 1\\}"

function _to_string(options::_PrintOptions, ::MOI.Integer)
    return string(_to_string(options, in), " ℤ")
end

function _to_string(::_PrintOptions{MIME"text/latex"}, ::MOI.Integer)
    return "\\in \\mathbb{Z}"
end

function _to_string(options::_PrintOptions, set::MOI.AbstractSet)
    return string(_to_string(options, in), " ", _drop_moi(set))
end

function _to_string(::_PrintOptions{MIME"text/latex"}, set::MOI.AbstractSet)
    return string("\\in \\text{", _escape_braces(_drop_moi(set)), "}")
end

#------------------------------------------------------------------------
# Constraints
#------------------------------------------------------------------------

function _get_name_or_empty(model, cref::MOI.ConstraintIndex)
    if !MOI.supports(model, MOI.ConstraintName(), typeof(cref))
        return ""
    end
    return MOI.get(model, MOI.ConstraintName(), cref)
end

_get_name_or_empty(::Any, ::MOI.ConstraintIndex{MOI.VariableIndex}) = ""

function _name_suffix(
    options::_PrintOptions{MIME"text/plain"},
    model::MOI.ModelLike,
    cref::MOI.ConstraintIndex,
)
    name = _get_name_or_empty(model, cref)
    if isempty(name)
        return ""
    end
    return string("  (", name, ")")
end

_name_suffix(::_PrintOptions, ::MOI.ModelLike, ::MOI.ConstraintIndex) = ""

function _to_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    cref::MOI.ConstraintIndex,
)
    f = MOI.get(model, MOI.ConstraintFunction(), cref)
    s = MOI.get(model, MOI.ConstraintSet(), cref)
    f_str = _to_string(options, model, f)
    s_str = _to_string(options, s)
    return string(f_str, " ", s_str, _name_suffix(options, model, cref))
end

#------------------------------------------------------------------------
# Nonlinear constraints
#------------------------------------------------------------------------

"""
    _VariableNode

A type used to work-around the default printing of Julia expressions.

Without this type, if we substituted the variable names into the expression
and then converted to a string, each variable would be printed with enclosing
`"`.

To work-around this, create a new type and overload `show`.
"""
struct _VariableNode
    x::String
end
Base.show(io::IO, x::_VariableNode) = print(io, x.x)

_replace_names(::_PrintOptions, ::MOI.ModelLike, x, ::Any) = x
function _replace_names(
    options::_PrintOptions,
    model::MOI.ModelLike,
    x::Expr,
    lookup,
)
    if x.head == :ref
        return get!(lookup, x.args[2]) do
            return _VariableNode(_to_string(options, model, x.args[2]))
        end
    else
        for (i, arg) in enumerate(x.args)
            x.args[i] = _replace_names(options, model, arg, lookup)
        end
    end
    return x
end

function _replace_nonlinear_latex(::_PrintOptions{MIME"text/latex"}, s::String)
    s = replace(s, " * " => " \\times ")
    s = replace(s, " >= " => " \\ge ")
    s = replace(s, " <= " => " \\le ")
    s = replace(s, " == " => " = ")
    return s
end
_replace_nonlinear_latex(::_PrintOptions, s::String) = s

function _print_nonlinear_constraints(
    io::IO,
    options::_PrintOptions{MIME"text/plain"},
    model::MOI.ModelLike,
    block::MOI.NLPBlockData,
)
    lookup = Dict{MOI.VariableIndex,_VariableNode}()
    if options.print_types
        println(io, "\nNonlinear")
    end
    has_expr = :ExprGraph in MOI.features_available(block.evaluator)
    for (i, bound) in enumerate(block.constraint_bounds)
        if has_expr
            ex = MOI.constraint_expr(block.evaluator, i)
            println(io, " ", _replace_names(options, model, ex, lookup))
        else
            println(io, " ", bound.lower, " <= g_$(i)(x) <= ", bound.upper)
        end
    end
end

function _print_nonlinear_constraints(
    io::IO,
    options::_PrintOptions{MIME"text/latex"},
    model::MOI.ModelLike,
    block::MOI.NLPBlockData,
)
    lookup = Dict{MOI.VariableIndex,_VariableNode}()
    if options.print_types
        println(io, " & \\text{Nonlinear} \\\\")
    end
    has_expr = :ExprGraph in MOI.features_available(block.evaluator)
    for (i, bound) in enumerate(block.constraint_bounds)
        if has_expr
            ex = MOI.constraint_expr(block.evaluator, i)
            nl_c = string(_replace_names(options, model, ex, lookup))
            println(io, " & ", _replace_nonlinear_latex(options, nl_c), " \\\\")
        else
            println(
                io,
                "& ",
                bound.lower,
                " \\le g_$(i)(x) \\le ",
                bound.upper,
                " \\\\",
            )
        end
    end
end

function _print_nonlinear_constraints(
    ::IO,
    ::_PrintOptions,
    ::MOI.ModelLike,
    ::Nothing,
)
    return
end

#------------------------------------------------------------------------
# ObjectiveFunction
#------------------------------------------------------------------------

function _objective_function_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    ::Nothing,
)
    F = MOI.get(model, MOI.ObjectiveFunctionType())
    f = MOI.get(model, MOI.ObjectiveFunction{F}())
    return _drop_moi(F), _to_string(options, model, f)
end

function _objective_function_string(
    options::_PrintOptions,
    model::MOI.ModelLike,
    block::MOI.NLPBlockData,
)
    lookup = Dict{MOI.VariableIndex,_VariableNode}()
    if block.has_objective
        f = "f(x)"
        if :ExprGraph in MOI.features_available(block.evaluator)
            ex = MOI.objective_expr(block.evaluator)
            f = string(_replace_names(options, model, ex, lookup))
            f = _replace_nonlinear_latex(options, f)
        end
        return "Nonlinear", f
    else
        return _objective_function_string(options, model, nothing)
    end
end

#------------------------------------------------------------------------
# MOI.ModelLike
#------------------------------------------------------------------------

function _nlp_block(model::MOI.ModelLike)
    try
        block = MOI.get(model, MOI.NLPBlock())
        if block === nothing
            return
        end
        if :ExprGraph in MOI.features_available(block.evaluator)
            MOI.initialize(block.evaluator, [:ExprGraph])
        end
        return block
    catch
        return nothing
    end
end

"""
    _print_model(
        io::IO,
        options::_PrintOptions{MIME"text/plain"},
        model::MOI.ModelLike,
    )

Print a plain-text formulation of `model` to `io`.
"""
function _print_model(
    io::IO,
    options::_PrintOptions{MIME"text/plain"},
    model::MOI.ModelLike,
)
    nlp_block = _nlp_block(model)
    sense = MOI.get(model, MOI.ObjectiveSense())
    if sense == MOI.FEASIBILITY_SENSE
        println(io, "Feasibility")
    else
        F, f = _objective_function_string(options, model, nlp_block)
        sense_s = sense == MOI.MIN_SENSE ? "Minimize" : "Maximize"
        if options.print_types
            println(io, sense_s, " ", F, ":\n ", f)
        else
            println(io, sense_s, ": ", f)
        end
    end
    println(io, "\nSubject to:")
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        if options.print_types
            println(io, "\n$(_drop_moi(F))-in-$(_drop_moi(S))")
        end
        for cref in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
            s = _to_string(options, model, cref)
            println(io, " ", replace(s, '\n' => "\n "))
        end
    end
    _print_nonlinear_constraints(io, options, model, nlp_block)
    return
end

"""
    _print_model(
        io::IO,
        options::_PrintOptions{MIME"text/latex"},
        model::MOI.ModelLike,
    )

Print a LaTeX formulation of `model` to `io`.
"""
function _print_model(
    io::IO,
    options::_PrintOptions{MIME"text/latex"},
    model::MOI.ModelLike,
)
    nlp_block = _nlp_block(model)
    println(io, "\$\$ \\begin{aligned}")
    sense = MOI.get(model, MOI.ObjectiveSense())
    if sense == MOI.FEASIBILITY_SENSE
        println(io, "\\text{feasibility}\\\\")
    else
        F, f = _objective_function_string(options, model, nlp_block)
        sense_s = sense == MOI.MIN_SENSE ? "min" : "max"
        println(io, "\\", sense_s, "\\quad & ", f, " \\\\")
    end
    println(io, "\\text{Subject to}\\\\")
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        if options.print_types
            f_str = _escape_braces(_drop_moi(F))
            s_str = _escape_braces(_drop_moi(S))
            println(io, " & \\text{$f_str-in-$s_str} \\\\")
        end
        for cref in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
            println(io, " & ", _to_string(options, model, cref), " \\\\")
        end
    end
    _print_nonlinear_constraints(io, options, model, nlp_block)
    return print(io, "\\end{aligned} \$\$")
end

#------------------------------------------------------------------------
# Latex
#------------------------------------------------------------------------

struct _LatexModel{T<:MOI.ModelLike}
    model::T
    kwargs::Any
end

"""
    latex_formulation(model::MOI.ModelLike; kwargs...)

Wrap `model` in a type so that it can be pretty-printed as `text/latex` in a
notebook like IJulia, or in Documenter.

To render the model, end the cell with `latex_formulation(model)`, or call
`display(latex_formulation(model))` in to force the display of the model from
inside a function.

Possible keyword arguments are:

 * `simplify_coefficients` : Simplify coefficients if possible by omitting
   them or removing trailing zeros.
 * `default_name` : The name given to variables with an empty name.
 * `print_types` : Print the MOI type of each function and set for clarity.
"""
latex_formulation(model::MOI.ModelLike; kwargs...) = _LatexModel(model, kwargs)

function Base.show(io::IO, model::_LatexModel)
    return _print_model(
        io,
        _PrintOptions(MIME("text/latex"); model.kwargs...),
        model.model,
    )
end

Base.show(io::IO, ::MIME"text/latex", model::_LatexModel) = show(io, model)

function _get_ijulia_latex_display()
    for d in Base.Multimedia.displays
        if Base.Multimedia.displayable(d, "text/latex") &&
           startswith("$(typeof(d))", "IJulia.")
            return d
        end
    end
    return
end

function Base.print(
    model::MOI.ModelLike;
    _latex_display = _get_ijulia_latex_display(),
    kwargs...,
)
    if _latex_display !== nothing
        formulation = latex_formulation(model; kwargs...)
        return display(_latex_display, "text/latex", formulation)
    end
    return print(stdout, model; kwargs...)
end

function Base.print(io::IO, model::MOI.ModelLike; kwargs...)
    return _print_model(io, _PrintOptions(MIME("text/plain"); kwargs...), model)
end

struct _NoVariableNameModel{M} <: MOI.ModelLike end

function MOI.get(
    ::_NoVariableNameModel{MIME"text/plain"},
    ::MOI.VariableName,
    x::MOI.VariableIndex,
)
    return "MOI.VariableIndex($(x.value))"
end

function MOI.get(
    ::_NoVariableNameModel{MIME"text/latex"},
    ::MOI.VariableName,
    ::MOI.VariableIndex,
)
    return ""  # Leave as default
end

function Base.show(io::IO, f::MOI.AbstractFunction)
    return show(io, MIME("text/plain"), f)
end

function Base.show(io::IO, mime::MIME"text/plain", f::MOI.AbstractFunction)
    model = _NoVariableNameModel{MIME"text/plain"}()
    print(io, _to_string(_PrintOptions(mime), model, f))
    return
end

function Base.show(io::IO, mime::MIME"text/latex", f::MOI.AbstractFunction)
    model = _NoVariableNameModel{MIME"text/latex"}()
    print(io, _to_string(_PrintOptions(mime), model, f))
    return
end

# Modified from Graphs.jl.
# Workaround for edge_index not being O(1) on SimpleGraph.
# edge_index was only needed to test for cycles, so
# this implementation skips that check.

# Graphs.jl is licensed under the MIT License:
#
# Copyright (c) 2012: John Myles White and other contributors.
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

mutable struct _TopologicalSortVisitor
    vertices::Vector{Int}
    parents::Vector{Int}

    function _TopologicalSortVisitor(n::Int)
        vs = Int[]
        sizehint!(vs, n)
        return new(vs, zeros(Int, n))
    end
end

function _traverse_graph(
    adjlist,
    offsets,
    s,
    visitor::_TopologicalSortVisitor,
    vertexcolormap,
    vertex_stack,
    index_stack,
)
    vertexcolormap[s] = 1
    resize!(vertex_stack, 1)
    vertex_stack[1] = s
    resize!(index_stack, 1)
    index_stack[1] = 1
    while !isempty(vertex_stack)
        u = pop!(vertex_stack)
        out_idx = pop!(index_stack)
        len_uegs = offsets[u+1] - offsets[u]
        found_new_vertex = false
        while out_idx <= len_uegs && !found_new_vertex
            v = adjlist[offsets[u]+out_idx-1]
            out_idx += 1
            v_color = vertexcolormap[v]
            if v_color == 0
                found_new_vertex = true
                vertexcolormap[v] = 1
                push!(vertex_stack, u)
                push!(index_stack, out_idx)
                visitor.parents[v] = u
                push!(vertex_stack, v)
                push!(index_stack, 1)
            end
        end
        if !found_new_vertex
            push!(visitor.vertices, u)
            vertexcolormap[u] = 2
        end
    end
    return
end

function reverse_topological_sort_by_dfs(
    adjlist,
    offsets,
    num_vertices,
    cmap::Vector{Int},
    vertex_stack::Vector{Int} = Int[],
    index_stack::Vector{Int} = Int[],
)
    @assert length(cmap) == num_vertices
    fill!(cmap, 0)
    visitor = _TopologicalSortVisitor(num_vertices)
    for s in 1:num_vertices
        if cmap[s] == 0
            _traverse_graph(
                adjlist,
                offsets,
                s,
                visitor,
                cmap,
                vertex_stack,
                index_stack,
            )
        end
    end
    return visitor.vertices, visitor.parents
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintQuadToSOC

import LinearAlgebra
import SparseArrays
using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_error_for_nonconvex_quadratic_constraints()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Constraint.QuadtoSOC{Float64}(mock)
    x = MOI.add_variable(bridged_mock)
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constraint(
            bridged_mock,
            MOI.ScalarQuadraticFunction(
                [MOI.ScalarQuadraticTerm(1.0, x, x)],
                MOI.ScalarAffineTerm{Float64}[],
                0.0,
            ),
            MOI.GreaterThan(0.0),
        )
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constraint(
            bridged_mock,
            MOI.ScalarQuadraticFunction(
                [MOI.ScalarQuadraticTerm(-1.0, x, x)],
                MOI.ScalarAffineTerm{Float64}[],
                0.0,
            ),
            MOI.LessThan(0.0),
        )
    )
    return
end

function test_quadratic_constraints_with_2_variables()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.QuadtoSOC{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [0.5, 0.5]),
        ),
    )
    MOI.Test.test_constraint_qcp_duplicate_diagonal(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [0.5, (√13 - 1) / 4]),
        ),
    )
    MOI.Test.test_constraint_qcp_duplicate_off_diagonal(bridged_mock, config)
    ci = first(
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.RotatedSecondOrderCone,
            }(),
        ),
    )
    x, y = MOI.get(mock, MOI.ListOfVariableIndices())
    # The matrix is
    # 2 1
    # 1 2
    # for which the Cholesky factorization is U' * U with U =
    # √2 √2/2
    #  . √3/√2
    expected = MOI.VectorAffineFunction{Float64}(
        MOI.VectorAffineTerm.(
            [3, 3, 4],
            MOI.ScalarAffineTerm.([√2, √2 / 2, √3 / √2], [x, y, y]),
        ),
        [1.0, 1.0, 0.0, 0.0],
    )
    @test MOI.get(mock, MOI.ConstraintFunction(), ci) ≈ expected
end

function test_qcp()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    mock = MOI.Utilities.MockOptimizer(model)
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.QuadtoSOC{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1 / 2, 7 / 4],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [zeros(2)],
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone) => [[0.25, 1.0, -1 / √2]],
        ),
    )
    MOI.Test.test_quadratic_constraint_integration(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [√2],
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone) => [[1 / √2, 1 / (2 * √2), -1 / √2]],
        ),
    )
    MOI.Test.test_quadratic_constraint_basic(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Test.test_quadratic_constraint_minimize(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarQuadraticFunction{Float64},
                MOI.LessThan{Float64},
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        ((MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone, 0),),
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 1.0],
            (MOI.VectorAffineFunction{Float64}, MOI.RotatedSecondOrderCone) => [[1.0, 1 / 3, -1 / √2, -1 / √6]],
        ),
    )
    MOI.Test.test_quadratic_constraint_LessThan(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Test.test_quadratic_constraint_GreaterThan(bridged_mock, config)
    F = MOI.ScalarQuadraticFunction{Float64}
    S = MOI.GreaterThan{Float64}
    ci = first(MOI.get(bridged_mock, MOI.ListOfConstraintIndices{F,S}()))
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        msg = "In order to set the `$attr`, the `MOI.Bridges.Constraint.QuadtoSOCBridge` needs to get the `MathOptInterface.VariablePrimalStart()` but it is not set. Set the `MathOptInterface.VariablePrimalStart()` first before setting the `$attr` in order to fix this."
        err = MOI.SetAttributeNotAllowed(attr, msg)
        @test_throws err MOI.set(bridged_mock, attr, ci, 0.0)
    end
    return
end

function test_fill_reducing_permutation()
    model = MOI.Utilities.Model{Float64}()
    bridge = MOI.Bridges.Constraint.QuadtoSOC{Float64}(model)
    x = MOI.add_variables(bridge, 3)
    Q = Float64[2 1 1; 1 2 0; 1 0 2]
    f = 0.5 * x' * Q * x
    MOI.add_constraint(bridge, f, MOI.LessThan(2.0))
    indices = MOI.get(
        model,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.RotatedSecondOrderCone,
        }(),
    )
    F = LinearAlgebra.cholesky(Q)
    # Test that the sparse Cholesky pivot is permuted
    SF = LinearAlgebra.cholesky(SparseArrays.sparse(Q))
    @test SF.p == [3, 2, 1]
    U = Matrix(F.U)
    @test MOI.get(model, MOI.ConstraintFunction(), indices[1]) ≈
          MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(U[1, 1], x[1])),
            MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(U[1, 2], x[2])),
            MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(U[1, 3], x[3])),
            MOI.VectorAffineTerm(4, MOI.ScalarAffineTerm(U[2, 2], x[2])),
            MOI.VectorAffineTerm(4, MOI.ScalarAffineTerm(U[2, 3], x[3])),
            MOI.VectorAffineTerm(5, MOI.ScalarAffineTerm(U[3, 3], x[3])),
        ],
        [1.0, 2.0, 0.0, 0.0, 0.0],
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.QuadtoSOCBridge,
        """
        variables: x, y
        2.0 * x * x + 2.0 * y * y <= 0.0
        """,
        """
        variables: x, y
        [1.0, 0.0, 2.0 * x, 2.0 * y] in RotatedSecondOrderCone(4)
        """,
        variable_start = 0.0,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.QuadtoSOCBridge,
        """
        variables: x, y
        -2.0 * x * x + -2.0 * y * y >= 0.0
        """,
        """
        variables: x, y
        [1.0, 0.0, 2.0 * x, 2.0 * y] in RotatedSecondOrderCone(4)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.QuadtoSOCBridge,
        """
        variables: x, y
        2.0 * x * x + 0.5 * y * y + 2.0 * x <= 3.0
        """,
        """
        variables: x, y
        [1.0, -2.0 * x + 3.0, 2.0 * x, 1.0 * y] in RotatedSecondOrderCone(4)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.QuadtoSOCBridge,
        """
        variables: x, y, z
        -2.0 * x * x + -1.0 * y * y + -2.0 * x * y + 3.0 * z >= 4.0
        """,
        """
        variables: x, y, z
        [1.0, 3.0 * z + -4.0, 2.0 * x + 1.0 * y, 1.0 * y] in RotatedSecondOrderCone(4)
        """,
    )
    return
end

"""
    test_copy_to_start()

Tests that `copy_to` copies the variable starting values first and the
constraint primal and dual starting values second as is needed by the
[`MOI.Bridges.Constraint.QuadtoSOCBridge`](@ref).
"""
function test_copy_to_start()
    src = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(src)
    c = MOI.add_constraint(src, 1.0x * x + 2.0x, MOI.LessThan(-1.0))
    MOI.set(src, MOI.ConstraintPrimalStart(), c, 1.0)
    MOI.set(src, MOI.ConstraintDualStart(), c, -1.0)
    MOI.set(src, MOI.VariablePrimalStart(), x, -1.0)

    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    dest = MOI.Bridges.Constraint.QuadtoSOC{Float64}(model)
    index_map = MOI.copy_to(dest, src)
    @test MOI.get(dest, MOI.ConstraintPrimalStart(), index_map[c]) == 1.0
    @test MOI.get(dest, MOI.ConstraintDualStart(), index_map[c]) == -1.0
    @test MOI.get(dest, MOI.VariablePrimalStart(), index_map[x]) == -1.0
end

function test_deletion_of_variable_in_bridged_constraint()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.QuadtoSOC{Float64}(inner)
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.VariableName(), x, ["x", "y"])
    f = 1.0 * x[1] * x[1] + 1.0 * x[2] * x[2]
    c = MOI.add_constraint(model, f, MOI.LessThan(1.0))
    MOI.delete(model, x[1])
    @test MOI.get(model, MOI.ConstraintFunction(), c) ≈ 1.0 * x[2] * x[2]
    return
end

MOI.Utilities.@model(
    Model2153,
    (),
    (MOI.EqualTo,),
    (MOI.RotatedSecondOrderCone,),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (MOI.VectorOfVariables,),
    (),
)

function MOI.supports(
    ::Model2153{T},
    ::MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}},
) where {T}
    return false
end

function test_deletion_of_variable_in_bridged_slacked_objective()
    model = MOI.Bridges.full_bridge_optimizer(Model2153{Float64}(), Float64)
    MOI.Bridges.add_bridge(
        model,
        MOI.Bridges.Constraint.QuadtoSOCBridge{Float64},
    )
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.VariableName(), x, ["x", "y"])
    f = 1.0 * x[1] * x[1] + 1.0 * x[2] * x[2]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.delete(model, x[1])
    @test MOI.get(model, MOI.ObjectiveFunction{typeof(f)}()) ≈ 1.0 * x[2] * x[2]
    return
end

function test_constraint_primal_no_quad_terms()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.QuadtoSOC{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm{Float64}[],
        [MOI.ScalarAffineTerm(1.0, x)],
        0.0,
    )
    c = MOI.add_constraint(model, f, MOI.LessThan(1.0))
    MOI.set(model, MOI.ConstraintPrimalStart(), c, 1.0)
    @test MOI.get(model, MOI.ConstraintPrimalStart(), c) == 1.0
    return
end

end  # module

TestConstraintQuadToSOC.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestMathOptSymbolicAD

using Test

import MathOptInterface as MOI
import MathOptInterface: Nonlinear

const SymbolicAD = Nonlinear.SymbolicAD

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            Test.@testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

op(head, args...) = MOI.ScalarNonlinearFunction(head, Any[args...])
op(head, arg::Vector{Any}) = MOI.ScalarNonlinearFunction(head, arg)

function test_derivative()
    x, y, z = MOI.VariableIndex.(1:3)
    sin_x = op(:sin, x)
    cos_x = op(:cos, x)
    @testset "$f" for (f, fp) in Any[
        # derivative(::Real, ::MOI.VariableIndex)
        1.0=>0.0,
        1.23=>0.0,
        # derivative(f::MOI.VariableIndex, x::MOI.VariableIndex)
        x=>1.0,
        y=>0.0,
        # derivative(f::MOI.ScalarAffineFunction{T}, x::MOI.VariableIndex)
        1.0*x=>1.0,
        1.0*x+2.0=>1.0,
        2.0*x+2.0=>2.0,
        2.0*x+y+2.0=>2.0,
        2.0*x+y+z+2.0=>2.0,
        # derivative(f::MOI.ScalarQuadraticFunction{T}, x::MOI.VariableIndex)
        convert(MOI.ScalarQuadraticFunction{Float64}, 1.0*x)=>1.0,
        convert(MOI.ScalarQuadraticFunction{Float64}, 1.0*x+0.0*y)=>1.0,
        1.0*x*y=>y,
        1.0*y*x=>y,
        1.0*x*x=>2.0*x,
        1.0*x*x+3.0*x+4.0=>2.0*x+3.0,
        2.0*x*x-2.0*x+1.0=>4.0*x-2.0,
        9.0*x*x+6.0*x+1.0=>18.0*x+6.0,
        # Univariate
        #   f.head == :+
        op(:+, x)=>1,
        op(:+, sin_x)=>cos_x,
        #   f.head == :-
        op(:-, sin_x)=>op(:-, cos_x),
        #   f.head == :abs
        op(:abs, sin_x)=>op(:*, op(:ifelse, op(:(>=), sin_x, 0), 1, -1), cos_x),
        #   f.head == :sign
        op(:sign, x)=>false,
        #   f.head == :deg2rad
        op(:deg2rad, x)=>deg2rad(1),
        #   f.head == :rad2deg
        op(:rad2deg, x)=>rad2deg(1),
        # SYMBOLIC_UNIVARIATE_EXPRESSIONS
        sin_x=>cos_x,
        cos_x=>op(:-, sin_x),
        op(:log, x)=>op(:/, 1, x),
        op(:log, 2.0*x)=>op(:*, op(:/, 1, 2.0*x), 2.0),
        # f.head == :+
        op(:+, sin_x, cos_x)=>op(:-, cos_x, sin_x),
        # f.head == :-
        op(:-, sin_x, cos_x)=>op(:+, cos_x, sin_x),
        # f.head == :*
        op(:*, x, y, z)=>1.0*y*z,
        op(:*, y, x, z)=>1.0*y*z,
        op(:*, y, z, x)=>1.0*y*z,
        # :^
        op(:^, sin_x, 2)=>op(:*, 2.0, sin_x, cos_x),
        op(:^, sin_x, 1)=>cos_x,
        op(
            :^,
            x,
            x,
        )=>op(:+, op(:*, x, op(:^, x, x-1)), op(:*, op(:^, x, x), op(:log, x))),
        op(:^, x, 3)=>3.0*x*x,
        # :/
        op(:/, x, 2)=>0.5,
        op(
            :/,
            op(:^, x, 2),
            op(:+, x, 1),
        )=>op(
            :/,
            op(:-, op(:*, 2, x, op(:+, x, 1)), op(:^, x, 2)),
            op(:^, op(:+, x, 1), 2),
        ),
        # :ifelse
        op(:ifelse, z, 1.0*x*x, x)=>op(:ifelse, z, 2.0*x, 1.0),
        # :atan
        op(
            :atan,
            x,
            sin_x,
        )=>op(
            :/,
            op(:+, op(:*, x, cos_x), sin_x),
            op(:+, op(:^, x, 2), op(:^, sin_x, 2)),
        ),
        # :min
        op(
            :min,
            x,
            1.0*x*x,
        )=>op(:ifelse, op(:(<=), x, op(:min, x, 1.0*x*x)), 1.0, 2.0*x),
        # :max
        op(
            :max,
            x,
            1.0*x*x,
        )=>op(:ifelse, op(:(>=), x, op(:max, x, 1.0*x*x)), 1.0, 2.0*x),
        # comparisons
        op(:(>=), x, y)=>false,
        op(:(==), x, y)=>false,
    ]
        @test SymbolicAD.simplify!(SymbolicAD.derivative(f, x)) ≈ fp
    end
    return
end

function test_derivative_univariate_simplification()
    x = MOI.VariableIndex(1)
    @test SymbolicAD.derivative(op(:sin, x), x) ≈ op(:cos, x)
    return
end

function test_derivative_error()
    x = MOI.VariableIndex(1)
    f = op(:foo, x, x)
    @test_throws(MOI.UnsupportedNonlinearOperator, SymbolicAD.derivative(f, x),)
    return
end

function test_variable()
    x, y, z = MOI.VariableIndex.(1:3)
    @testset "$f" for (f, fp) in Any[
        # ::Real
        1.0=>[],
        # ::VariableRef,
        x=>[x],
        # ::AffExpr
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{Float64}[], 2.0)=>[],
        x+1.0=>[x],
        2.0*x+1.0=>[x],
        2.0*x+y+1.0=>[x, y],
        y+1.0+z=>[y, z],
        # ::QuadExpr
        zero(MOI.ScalarQuadraticFunction{Float64})=>[],
        convert(MOI.ScalarQuadraticFunction{Float64}, 1.0*x+1.0)=>[x],
        convert(MOI.ScalarQuadraticFunction{Float64}, 1.0*x+1.0+y)=>[x, y],
        1.0*x*x=>[x],
        1.0*x*x+x=>[x],
        1.0*x*x+y=>[x, y],
        1.0*x*y=>[x, y],
        1.0*y*x=>[x, y],
        # ::NonlinearExpr
        op(:sin, x)=>[x],
        op(:sin, 1.0*x+y)=>[x, y],
        op(:*, op(:sin, x), op(:sin, y))=>[x, y],
        op(:^, op(:log, x), 2)=>[x],
    ]
        @test SymbolicAD.variables(f) == fp
    end
    return
end

function test_simplify_VariableIndex()
    x = MOI.VariableIndex(1)
    @test SymbolicAD.simplify(x) === x
    @test SymbolicAD.simplify(1.0) === 1.0
    return
end

function test_simplify_ScalarAffineFunction()
    f = zero(MOI.ScalarAffineFunction{Float64})
    @test SymbolicAD.simplify(f) == 0.0
    f = MOI.ScalarAffineFunction{Float64}(MOI.ScalarAffineTerm{Float64}[], 2.0)
    @test SymbolicAD.simplify(f) == 2.0
    x = MOI.VariableIndex(1)
    @test SymbolicAD.simplify(1.0 * x + 1.0) ≈ 1.0 * x + 1.0
    @test SymbolicAD.simplify(1.0 * x + 2.0 * x + 1.0) ≈ 3.0 * x + 1.0
    @test SymbolicAD.simplify(1.0 * x) == x
    @test SymbolicAD.simplify(2.0 * x) ≈ 2.0 * x
    return
end

function test_simplify_ScalarQuadraticFunction()
    x = MOI.VariableIndex(1)
    terms = MOI.ScalarQuadraticTerm{Float64}[]
    f = MOI.ScalarQuadraticFunction(terms, [MOI.ScalarAffineTerm(1.0, x)], 1.0)
    @test SymbolicAD.simplify(f) ≈ 1.0 * x + 1.0
    f = MOI.ScalarQuadraticFunction(terms, [MOI.ScalarAffineTerm(2.0, x)], 0.0)
    @test SymbolicAD.simplify(f) ≈ 2.0 * x + 0.0
    f = MOI.ScalarQuadraticFunction(terms, [MOI.ScalarAffineTerm(1.0, x)], 0.0)
    @test SymbolicAD.simplify(f) == x
    f = MOI.ScalarQuadraticFunction(terms, MOI.ScalarAffineTerm{Float64}[], 2.0)
    @test SymbolicAD.simplify(f) === 2.0
    @test SymbolicAD.simplify(1.0 * x * x + 1.0) ≈ 1.0 * x * x + 1.0
    g = 1.0 * x * x + 2.0 * x * x + 1.0
    @test SymbolicAD.simplify(g) ≈ 3.0 * x * x + 1.0
    return
end

function test_simplify_ScalarNonlinearFunction()
    x = MOI.VariableIndex(1)
    # sin(3 * (x^0)) -> sin(3)
    f = op(:^, x, 0)
    g = op(:*, 3, f)
    h = op(:sin, g)
    @test SymbolicAD.simplify(h) ≈ sin(3)
    # sin(log(x)) -> sin(log(x))
    f = op(:log, x)
    g = op(:sin, f)
    @test SymbolicAD.simplify(g) ≈ g
    return
end

# simplify(::Val{:*}, f::MOI.ScalarNonlinearFunction)
function test_simplify_ScalarNonlinearFunction_multiplication()
    x, y, z = MOI.VariableIndex.(1:3)
    sinx = op(:sin, x)
    # *(x, *(y, z)) -> *(x, y, z)
    @test ≈(SymbolicAD.simplify(op(:*, x, op(:*, y, z))), op(:*, x, y, z))
    # *(x, *(y, z, *(x, 2))) -> *(x, y, z, x, 2)
    f = op(:*, x, 2)
    @test ≈(
        SymbolicAD.simplify(op(:*, x, op(:*, y, z, f))),
        op(:*, x, y, z, x, 2),
    )
    # *(x, 3, 2) -> *(x, 6)
    @test ≈(SymbolicAD.simplify(op(:*, x, 3, 2)), 6.0 * x)
    @test ≈(SymbolicAD.simplify(op(:*, sinx, 3, 2)), op(:*, sinx, 6))
    # *(3, x, 2) -> *(6, x)
    @test ≈(SymbolicAD.simplify(op(:*, 3, x, 2)), 6.0 * x)
    @test ≈(SymbolicAD.simplify(op(:*, 3, sinx, 2)), op(:*, 6, sinx))
    # *(x, 1) -> x
    ret = op(:*, x, 1)
    @test ≈(SymbolicAD.simplify(ret), x)
    # *(x, 0) -> 0
    ret = op(:*, x, 0)
    @test ≈(SymbolicAD.simplify(ret), 0)
    # *(-(x, x), 1) -> 0
    f = op(:-, x, x)
    ret = op(:*, f, 1)
    @test ≈(SymbolicAD.simplify(ret), 0)
    # *() -> true
    ret = op(:*, Any[])
    @test ≈(SymbolicAD.simplify(ret), 1)
    return
end

# simplify(::Val{:+}, f::MOI.ScalarNonlinearFunction)
function test_simplify_ScalarNonlinearFunction_addition()
    x, y, z = MOI.VariableIndex.(1:3)
    sinx = op(:sin, x)
    cosx = op(:cos, x)
    # (+(x, +(y, z)))=>(+(x, y, z)),
    @test ≈(SymbolicAD.simplify(op(:+, sinx, op(:+, y, z))), op(:+, sinx, y, z))
    @test ≈(
        SymbolicAD.simplify(op(:+, x, op(:+, y, z))),
        1.0 * x + 1.0 * y + 1.0 * z,
    )
    # +(sin(x), -cos(x))=>sin(x)-cos(x),
    @test ≈(SymbolicAD.simplify(op(:+, sinx, op(:-, cosx))), op(:-, sinx, cosx))
    # (+(x, 1, 2))=>(+(x, 3)),
    @test ≈(SymbolicAD.simplify(op(:+, x, 1, 2)), x + 3.0)
    @test ≈(SymbolicAD.simplify(op(:+, sinx, 1, 2)), op(:+, sinx, 3))
    # (+(1, x, 2))=>(+(3, x)),ret =
    @test ≈(SymbolicAD.simplify(op(:+, 1, x, 2)), x + 3.0)
    @test ≈(SymbolicAD.simplify(op(:+, 1, sinx, 2)), op(:+, 3, sinx))
    # +(x, 0) -> x
    @test SymbolicAD.simplify(op(:+, x, 0)) ≈ x
    # +(0, x) -> x
    @test SymbolicAD.simplify(op(:+, 0, x)) ≈ x
    # +(-(x, x), 0) -> 0
    @test SymbolicAD.simplify(op(:+, op(:-, x, x), 0)) === false
    return
end

# simplify(::Val{:-}, f::MOI.ScalarNonlinearFunction)
function test_simplify_ScalarNonlinearFunction_subtraction()
    x, y = MOI.VariableIndex(1), MOI.VariableIndex(2)
    sinx = op(:sin, x)
    f = op(:-, x)
    # -x -> -x
    @test SymbolicAD.simplify(op(:-, x)) ≈ -1.0 * x
    @test SymbolicAD.simplify(op(:-, sinx)) ≈ op(:-, sinx)
    # -(-(x)) -> x
    ret = op(:-, f)
    @test SymbolicAD.simplify(ret) ≈ x
    # -(x, 0) -> x
    ret = op(:-, x, 0)
    @test SymbolicAD.simplify(ret) ≈ x
    # -(0, x) -> -x
    @test SymbolicAD.simplify(op(:-, 0, sinx)) ≈ op(:-, sinx)
    # -(x, x) -> 0
    ret = op(:-, x, x)
    @test SymbolicAD.simplify(ret) ≈ 0
    # -(x, -y) -> +(x, y)
    @test SymbolicAD.simplify(op(:-, x, op(:-, y))) ≈ 1.0 * x + 1.0 * y
    @test SymbolicAD.simplify(op(:-, sinx, op(:-, y))) ≈ op(:+, sinx, y)
    # -(x, y) -> -(x, y)
    @test SymbolicAD.simplify(op(:-, sinx, y)) ≈ op(:-, sinx, y)
    @test SymbolicAD.simplify(op(:-, x, y)) ≈ 1.0 * x - 1.0 * y
    return
end

# simplify(::Val{:^}, f::MOI.ScalarNonlinearFunction)
function test_simplify_ScalarNonlinearFunction_power()
    x, y = MOI.VariableIndex(1), MOI.VariableIndex(2)
    # x^0 -> 1
    f = op(:^, x, 0)
    @test SymbolicAD.simplify(f) == 1
    # x^1 -> x
    f = op(:^, x, 1)
    @test SymbolicAD.simplify(f) == x
    # 0^x -> 0
    f = op(:^, 0, x)
    @test SymbolicAD.simplify(f) == 0
    # 1^x -> 1
    f = op(:^, 1, x)
    @test SymbolicAD.simplify(f) == 1
    # x^y -> x^y
    f = op(:^, x, y)
    @test SymbolicAD.simplify(f) ≈ f
    return
end

# simplify(::Val{:ifelse}, f::MOI.ScalarNonlinearFunction)
function test_simplify_ScalarNonlinearFunction_ifelse()
    x, y, z = MOI.VariableIndex(1), MOI.VariableIndex(2), MOI.VariableIndex(3)
    f = op(:ifelse, false, x, y)
    @test SymbolicAD.simplify(f) == y
    f = op(:ifelse, true, x, y)
    @test SymbolicAD.simplify(f) == x
    f = op(:ifelse, y, x, x)
    @test SymbolicAD.simplify(f) == x
    f = op(:ifelse, x, y, z)
    @test SymbolicAD.simplify(f) ≈ f
    return
end

function test_simplify_VectorAffineFunction()
    f = MOI.VectorAffineFunction{Float64}(
        MOI.VectorAffineTerm{Float64}[],
        [0.0, 1.0, 2.0],
    )
    @test SymbolicAD.simplify(f) == [0.0, 1.0, 2.0]
    x = MOI.VariableIndex(1)
    f = MOI.Utilities.operate(vcat, Float64, 1.0, x, 2.0 * x + 1.0 * x)
    @test SymbolicAD.simplify(f) ≈ f
    return
end

function test_simplify_VectorQuadraticFunction()
    f = MOI.VectorQuadraticFunction{Float64}(
        MOI.VectorQuadraticTerm{Float64}[],
        MOI.VectorAffineTerm{Float64}[],
        [0.0, 1.0, 2.0],
    )
    @test SymbolicAD.simplify(f) == [0.0, 1.0, 2.0]
    x = MOI.VariableIndex(1)
    f = MOI.VectorQuadraticFunction{Float64}(
        MOI.VectorQuadraticTerm{Float64}[],
        [MOI.VectorAffineTerm{Float64}(2, MOI.ScalarAffineTerm(3.0, x))],
        [1.0, 0.0],
    )
    g = MOI.Utilities.operate(vcat, Float64, 1.0, 3.0 * x)
    @test SymbolicAD.simplify(f) ≈ g
    f = MOI.Utilities.operate(vcat, Float64, 1.0, 2.0 * x * x)
    @test SymbolicAD.simplify(f) ≈ f
    return
end

function test_simplify_VectorNonlinearFunction()
    x = MOI.VariableIndex.(1:3)
    y = op(:+, Any[op(:^, xi, 2) for xi in x])
    x_plus = [op(:+, xi) for xi in x]
    function wrap(f)
        return op(:+, op(:-, f, 0.0), 0.0)
    end
    f = MOI.VectorNonlinearFunction(wrap.([y; x_plus]))
    g = MOI.Utilities.vectorize([sum(1.0 .* x .* x); x])
    @test SymbolicAD.simplify(f) ≈ g
    return
end

function test_simplify_VectorNonlinearFunction_abstract()
    x = MOI.VariableIndex(1)
    f = MOI.VectorNonlinearFunction([x, 1.0 * x, op(:sin, x)])
    g = MOI.VectorNonlinearFunction([x, x, op(:sin, x)])
    @test SymbolicAD.simplify(f) ≈ g
    return
end

function test_simplify_deep()
    N = 10_000
    x = MOI.VariableIndex.(1:N)
    f = op(:^, x[1], 1)
    for i in 2:N
        g = op(:^, x[i], 1)
        f = op(:+, f, g)
    end
    ret = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.0)
    @test ≈(SymbolicAD.simplify(f), ret)
    return
end

function test_simplify_shared_false()
    x = MOI.VariableIndex(1)
    f = op(:^, x, 1)
    g = op(:+, f, f)
    h = op(:-, g, g)
    @test ≈(SymbolicAD.simplify!(h), false)
    return
end

function test_simplify_shared_node()
    x = MOI.VariableIndex(1)
    f1 = op(:^, x, 1)
    f2 = op(:sin, f1)
    f3 = op(:cos, f1)
    f4 = op(:+, f2, f3)
    g1 = op(:sin, x)
    g2 = op(:cos, x)
    g3 = op(:+, g1, g2)
    @test ≈(SymbolicAD.simplify!(f4), g3)
    return
end

function test_SymbolicAD_Evaluator()
    x = MOI.VariableIndex.(1:4)
    model = MOI.Nonlinear.Model()
    for i in 1:3
        MOI.Nonlinear.add_constraint(
            model,
            :($(x[4]) * log($(x[i]) + $i)),
            MOI.LessThan(2.0),
        )
    end
    MOI.Nonlinear.add_constraint(model, :($(x[1]) * $(x[2])), MOI.LessThan(2.0))
    MOI.Nonlinear.set_objective(model, :($(x[1]) * $(x[2])))
    evaluator = MOI.Nonlinear.Evaluator(model, Nonlinear.SymbolicMode(), x)
    @test MOI.features_available(evaluator) == [:Grad, :Jac, :Hess, :ExprGraph]
    @test_throws AssertionError MOI.initialize(evaluator, [:Foo])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    x = [1.0, 2.0, 3.0, 4.0]
    f = MOI.eval_objective(evaluator, x)
    @test f == 2.0
    ∇f = zeros(4)
    MOI.eval_objective_gradient(evaluator, ∇f, x)
    @test ∇f == [2.0, 1.0, 0.0, 0.0]
    g = zeros(4)
    MOI.eval_constraint(evaluator, g, x)
    @test g == [4 * log(1 + 1), 4 * log(2 + 2), 4 * log(3 + 3), 1 * 2]
    J_s = MOI.jacobian_structure(evaluator)
    J = zeros(length(J_s))
    p = sortperm(J_s)
    MOI.eval_constraint_jacobian(evaluator, J, x)
    @test J[p] == [2.0, log(2), 1.0, log(4), 2 / 3, log(6), 2.0, 1.0]
    H_s = MOI.hessian_lagrangian_structure(evaluator)
    H = zeros(length(H_s))
    MOI.eval_hessian_lagrangian(evaluator, H, x, 1.5, [1.1, 1.2, 1.3, 1.4])
    p = sortperm(H_s)
    @test H[p] == [
        -1.1,                   # dg(1) / d(1, 1)
        1.5,                    # df    / d(1, 2)
        1.4,                    # dg(4) / d(1, 2)
        -0.3,                   # dg(2) / d(2, 2)
        -0.14444444444444443,   # dg(3) / d(3, 3)
        0.55,                   # dg(1) / d(4, 1)
        0.3,                    # dg(2) / d(4, 2)
        0.21666666666666667,    # dg(3) / d(4, 3)
    ]
    return
end

function test_SymbolicAD_Evaluator_squared()
    x = MOI.VariableIndex(1)
    model = MOI.Nonlinear.Model()
    MOI.Nonlinear.set_objective(model, :($x^2))
    evaluator = MOI.Nonlinear.Evaluator(model, Nonlinear.SymbolicMode(), [x])
    @test MOI.features_available(evaluator) == [:Grad, :Jac, :Hess, :ExprGraph]
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    x = [3.0]
    f = MOI.eval_objective(evaluator, x)
    @test f == 3.0^2
    ∇f = zeros(1)
    MOI.eval_objective_gradient(evaluator, ∇f, x)
    @test ∇f == [6.0]
    H_s = MOI.hessian_lagrangian_structure(evaluator)
    @test H_s == [(1, 1)]
    H = zeros(1)
    MOI.eval_hessian_lagrangian(evaluator, H, x, 1.25, [])
    @test H == [2.5]
    return
end

function test_SymbolicAD_Evaluator_ifelse()
    x = MOI.VariableIndex(1)
    model = MOI.Nonlinear.Model()
    MOI.Nonlinear.set_objective(model, :(ifelse($x > 0, $x, -$x)))
    evaluator = MOI.Nonlinear.Evaluator(model, Nonlinear.SymbolicMode(), [x])
    @test MOI.features_available(evaluator) == [:Grad, :Jac, :Hess, :ExprGraph]
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    x = [3.0]
    f = MOI.eval_objective(evaluator, x)
    @test f == 3.0
    x = [-4.0]
    f = MOI.eval_objective(evaluator, x)
    @test f == 4.0
    ∇f = zeros(1)
    MOI.eval_objective_gradient(evaluator, ∇f, x)
    @test ∇f == [-1.0]
    H_s = MOI.hessian_lagrangian_structure(evaluator)
    @test isempty(H_s)
    return
end

function test_SymbolicAD_Evaluator_comparison()
    x = MOI.VariableIndex(1)
    model = MOI.Nonlinear.Model()
    MOI.Nonlinear.set_objective(model, :(ifelse(($x < -1) || ($x > 1), $x, 0)))
    evaluator = MOI.Nonlinear.Evaluator(model, Nonlinear.SymbolicMode(), [x])
    @test MOI.features_available(evaluator) == [:Grad, :Jac, :Hess, :ExprGraph]
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    x = zeros(1)
    ∇f = zeros(1)
    for (xi, f, df) in [
        (-2.0, -2.0, 1.0),
        (-1.01, -1.01, 1.0),
        (-1.0, 0.0, 0.0),
        (1.0, 0.0, 0.0),
        (1.01, 1.01, 1.0),
        (2.0, 2.0, 1.0),
    ]
        x[1] = xi
        @test MOI.eval_objective(evaluator, x) == f
        MOI.eval_objective_gradient(evaluator, ∇f, x)
        @test only(∇f) == df
    end
    return
end

function test_packed_operator_bit_fiddling()
    registry = MOI.Nonlinear.OperatorRegistry()
    for op in registry.univariate_operators
        operator = SymbolicAD._op_nargs_to_operator(registry, op, 1)
        type, id, nargs = SymbolicAD._operator_to_type_id_nargs(operator)
        @test type == :univariate
        @test id == registry.univariate_operator_to_id[op]
        @test nargs == 1
    end
    for op in registry.multivariate_operators, n in 2:5
        operator = SymbolicAD._op_nargs_to_operator(registry, op, n)
        type, id, nargs = SymbolicAD._operator_to_type_id_nargs(operator)
        @test type == :multivariate
        @test id == registry.multivariate_operator_to_id[op]
        @test nargs == n
    end
    for op in registry.logic_operators
        operator = SymbolicAD._op_nargs_to_operator(registry, op, 2)
        type, id, nargs = SymbolicAD._operator_to_type_id_nargs(operator)
        @test type == :logic
        @test id == registry.logic_operator_to_id[op]
        @test nargs == 2
    end
    for op in registry.comparison_operators
        operator = SymbolicAD._op_nargs_to_operator(registry, op, 2)
        type, id, nargs = SymbolicAD._operator_to_type_id_nargs(operator)
        @test type == :comparison
        @test id == registry.comparison_operator_to_id[op]
        @test nargs == 2
    end
    MOI.Nonlinear.register_operator(registry, :op_foo, 1, x -> x^2)
    D = SymbolicAD.__DERIVATIVE__
    for (prefix, ret_type) in (
        "" => :univariate,
        D => :univariate_derivative,
        (D * D) => :univariate_second_derivative,
    )
        op = Symbol("$(prefix)op_foo")
        operator = SymbolicAD._op_nargs_to_operator(registry, op, 1)
        type, id, nargs = SymbolicAD._operator_to_type_id_nargs(operator)
        @test type == ret_type
        @test id == registry.univariate_operator_to_id[:op_foo]
        @test id >= registry.univariate_user_operator_start
        @test nargs == 1
    end
    return
end

function test_SymbolicAD_show()
    x = MOI.VariableIndex.(1:4)
    model = MOI.Nonlinear.Model()
    for i in 1:3
        MOI.Nonlinear.add_constraint(
            model,
            :($(x[4]) * log($(x[i]) + $i)),
            MOI.LessThan(2.0),
        )
    end
    evaluator = MOI.Nonlinear.Evaluator(model, Nonlinear.SymbolicMode(), x)
    _, dag = only(evaluator.backend.dag)
    contents = sprint(show, dag)
    @test occursin("# x[1]", contents)
    @test occursin("# p[1]", contents)
    @test occursin("# multivariate(op = 1, children = 1:2)", contents)
    @test occursin("children", contents)
    return
end

function test_SymbolicAD_subexpressions()
    x = MOI.VariableIndex.(1:2)
    model = MOI.Nonlinear.Model()
    expr = MOI.Nonlinear.add_expression(model, :($(x[1]) * $(x[2])))
    MOI.Nonlinear.add_constraint(model, expr, MOI.LessThan(2.0))
    @test_throws(
        ErrorException("Subexpressions not supported"),
        MOI.Nonlinear.Evaluator(model, Nonlinear.SymbolicMode(), x),
    )
    return
end

function test_SymbolicAD_parameters()
    x = MOI.VariableIndex(1)
    model = MOI.Nonlinear.Model()
    p = MOI.Nonlinear.add_parameter(model, 1.0)
    MOI.Nonlinear.add_constraint(model, :($x * $p), MOI.LessThan(2.0))
    @test_throws(
        ErrorException("Parameters not supported"),
        MOI.Nonlinear.Evaluator(model, Nonlinear.SymbolicMode(), [x]),
    )
    return
end

function test_gradient_and_hessian()
    x = MOI.VariableIndex.(1:2)
    sin_x = op(:sin, x[1])
    for (f, ret) in Any[
        (2.0*x[1]*x[2])=>(x, Any[2.0*x[2], 2.0*x[1]], [(1, 2)], [2.0]),
        (2.0*x[2]*x[1])=>(x, Any[2.0*x[2], 2.0*x[1]], [(1, 2)], [2.0]),
        op(:*, x[1], x[2])=>(x, Any[x[2], x[1]], [(1, 2)], [true]),
        sin_x=>([x[1]], Any[op(:cos, x[1])], [(1, 1)], Any[op(:-, sin_x)]),
    ]
        x, ∇f, H, ∇²f = SymbolicAD.gradient_and_hessian(f)
        @test ret[1] == x
        @test all(ret[2] .≈ ∇f)
        @test ret[3] == H
        @test all(ret[4] .≈ ∇²f)
    end
    return
end

function test_gradient_and_hessian_filter()
    x = MOI.VariableIndex.(1:2)
    sin_x = op(:sin, x[1])
    for (f, ret) in Any[
        op(:*, x[1], x[2])=>([x[1]], Any[x[2]], [], []),
        sin_x=>([x[1]], Any[op(:cos, x[1])], [(1, 1)], Any[op(:-, sin_x)]),
    ]
        x, ∇f, H, ∇²f = SymbolicAD.gradient_and_hessian(x -> x.value == 1, f)
        @test ret[1] == x
        @test all(ret[2] .≈ ∇f)
        @test ret[3] == H
        @test all(ret[4] .≈ ∇²f)
    end
    return
end

function test_SymbolicAD_DAG()
    registry = MOI.Nonlinear.OperatorRegistry()
    x = MOI.VariableIndex(1)
    f = Any[3.0, x, 1.0*x+1.0, 2.0*x*x+3.0*x+4.0, op(:sin, x)]
    dag = SymbolicAD._DAG(registry, f)
    @test SymbolicAD._evaluate!(dag, [2.5], Float64[]) === nothing
    @test dag.result[dag.indices] == [3.0, 2.5, 3.5, 24.0, sin(2.5)]
    return
end

function test_SymbolicAD_univariate_registered()
    x = MOI.VariableIndex(1)
    model = MOI.Nonlinear.Model()
    MOI.Nonlinear.register_operator(model, :op_foo, 1, x -> x^2)
    MOI.Nonlinear.set_objective(model, :(op_foo($x - 0.5)))
    evaluator = MOI.Nonlinear.Evaluator(model, Nonlinear.SymbolicMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    x = [1.0]
    @test MOI.eval_objective(evaluator, x) == 0.25
    return
end

function test_simplify_if_quadratic()
    x = MOI.VariableIndex(1)
    for (f, ret) in Any[
        # Constants
        op(:*, 2)=>2,
        op(:*, 2//3)=>2/3,
        op(:*, 2, 3)=>6,
        op(:+, 2, 3)=>5,
        op(:-, 2)=>-2,
        op(:-, 2, 3)=>-1,
        # Affine
        op(:*, 2, x, 3)=>6*x,
        op(:-, x)=>-1*x,
        op(:-, x, 2)=>1.0*x-2.0,
        op(:-, 2, x)=>2.0+-1.0*x,
        op(:+, 2, x)=>2+x,
        op(:+, x, x)=>2.0*x,
        op(:+, x, 2, x)=>2.0*x+2.0,
        op(:+, x, 2, op(:+, x))=>2.0*x+2.0,
        op(:+, 1.0*x, 1.0*x+2.0)=>2.0*x+2.0,
        op(:-, 1.0*x+2.0)=>-1.0*x-2.0,
        op(:*, 2, 1.0*x+2.0, 3)=>6.0*x+12.0,
        # Quadratic
        op(:+, 1.0*x*x)=>1.0*x*x,
        op(:*, 2, x, 3, x)=>6.0*x*x,
        op(:*, 2, x, 3, 1.0*x)=>6.0*x*x,
        op(:*, 2, x, 3, 1.0*x+2.0)=>6.0*x*x+12.0*x,
        op(:*, 2, 1.0*x+2.0, 3, x)=>6.0*x*x+12.0*x,
        op(:*, 1.0*x+2.0, 1.0*x)=>1.0*x*x+2.0*x,
        op(:*, 1.0*x+2.0, 1.0*x+1.0)=>1.0*x*x+3.0*x+2.0,
        # Power
        op(:^, x, 2)=>1.0*x*x,
        op(:^, 1.0*x, 2)=>1.0*x*x,
        op(:^, 1.0*x+1.0, 2)=>1.0*x*x+2.0*x+1.0,
        op(:^, -2.0*x-2.0, 2)=>4.0*x*x+8.0*x+4.0,
        # Divide
        op(:/, x, 2)=>0.5*x,
        op(:/, 1.0*x, 2)=>0.5*x,
        op(:/, 2.0*x, 2)=>x,
        op(:/, 2.0*x*x, 2)=>1.0*x*x,
        # Early termination because not affine
        op(:+, op(:sin, x))=>nothing,
        op(:-, op(:sin, x))=>nothing,
        op(:-, op(:sin, x), 1)=>nothing,
        op(:-, x, op(:sin, x))=>nothing,
        op(:*, 2, 3, op(:sin, x))=>nothing,
        op(:log, x)=>nothing,
        op(:+, big(1)*x*x, big(2))=>nothing,
        op(:+, big(1)*x, big(2))=>nothing,
        op(:+, x, big(2))=>nothing,
        op(:+, x, 1+2im)=>nothing,
    ]
        @test SymbolicAD._simplify_if_quadratic!(f) ≈ something(ret, f)
    end
    return
end

end  # module

TestMathOptSymbolicAD.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableFree

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_modification_multirow_vectoraffine_nonpos()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Variable.Free{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [0.5, 0.0]),
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [0.25, 0.0]),
        ),
    )
    MOI.Test.test_modification_multirow_vectoraffine_nonpos(
        bridged_mock,
        MOI.Test.Config(),
    )
    MOI.set(
        bridged_mock,
        MOI.ConstraintName(),
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.Nonpositives,
            }(),
        ),
        ["c"],
    )
    var_names = ["xpos", "xneg"]
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        ["x"],
    )
    MOI.set(
        bridged_mock,
        MOI.ConstraintName(),
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.Nonnegatives,
            }(),
        ),
        ["nonneg"],
    )
    s = """
    variables: xpos, xneg
    nonneg: [xpos, xneg] in Nonnegatives(2)
    c: [4.0xpos + -4.0xneg + -1.0, 3.0xpos + -3.0xneg + -1.0] in Nonpositives(2)
    maxobjective: xpos + -1.0xneg
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(mock, model, var_names, ["nonneg", "c"])
    s = """
    variables: x
    c: [4.0x + -1.0, 3.0x + -1.0] in Nonpositives(2)
    maxobjective: 1.0x
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(bridged_mock, model, ["x"], ["c"])
    return
end

function test_linear_LessThan_and_GreaterThan()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Variable.Free{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0, 0, 0, 0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100, 0, 0, 0]),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [100, 0, 0, 100],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [1.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1.0],
        ),
    )
    MOI.Test.test_linear_LessThan_and_GreaterThan(
        bridged_mock,
        MOI.Test.Config(),
    )

    loc = MOI.get(bridged_mock, MOI.ListOfConstraintTypesPresent())
    @test length(loc) == 2
    @test !((MOI.VectorOfVariables, MOI.Reals) in loc)
    @test (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) in loc
    @test (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) in loc
    @test MOI.get(mock, MOI.NumberOfVariables()) == 4
    @test MOI.get(bridged_mock, MOI.NumberOfVariables()) == 2
    vis = MOI.get(bridged_mock, MOI.ListOfVariableIndices())
    @test vis == MOI.VariableIndex.([-1, -2])

    cx = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Reals}(vis[1].value)
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), cx) == [100.0]
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), cx) == [0.0]
    cy = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Reals}(vis[2].value)
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), cy) == [-100.0]
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), cy) == [0.0]

    _test_delete_bridged_variable(
        bridged_mock,
        vis[1],
        MOI.Reals,
        2,
        (
            (MOI.VectorOfVariables, MOI.Nonnegatives, 0),
            (MOI.VectorOfVariables, MOI.Nonpositives, 0),
        ),
    )
    _test_delete_bridged_variable(
        bridged_mock,
        vis[2],
        MOI.Reals,
        1,
        (
            (MOI.VectorOfVariables, MOI.Nonnegatives, 0),
            (MOI.VectorOfVariables, MOI.Nonpositives, 0),
        ),
    )
    return
end

function test_linear_integration_modification()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Variable.Free{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0, 0, 0, 0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100, 0, 0, 0]),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [100, 0, 0, 100],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [[1.0]],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonpositives) =>
                [[-1.0]],
        ),
    )
    MOI.Test.test_linear_VectorAffineFunction(bridged_mock, MOI.Test.Config())

    x, y = MOI.get(bridged_mock, MOI.ListOfVariableIndices())

    cx = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Reals}(x.value)
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), cx) == [100.0]
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), cx) == [0.0]
    cy = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Reals}(y.value)
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), cy) == [-100.0]
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), cy) == [0.0]

    @test MOI.supports(
        bridged_mock,
        MOI.VariablePrimalStart(),
        MOI.VariableIndex,
    )
    @test MOI.supports(
        bridged_mock,
        MOI.VariablePrimalStart(),
        typeof(MOI.Bridges.bridge(bridged_mock, x)),
    )
    MOI.set(bridged_mock, MOI.VariablePrimalStart(), [x, y], [1.0, -1.0])
    xa, xb, ya, yb = MOI.get(mock, MOI.ListOfVariableIndices())
    @test MOI.get(mock, MOI.VariablePrimalStart(), [xa, xb, ya, yb]) ==
          [1.0, 0.0, 0.0, 1.0]
    @test MOI.get(bridged_mock, MOI.VariablePrimalStart(), x) == 1
    @test MOI.get(bridged_mock, MOI.VariablePrimalStart(), y) == -1
    return
end

function test_linear_transform()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Variable.Free{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [1.0, 1.0, 0.0, 0.0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0.5, 0.5, 0.0, 0.0]),
    )
    MOI.Test.test_linear_transform(bridged_mock, MOI.Test.Config())

    vis = MOI.get(bridged_mock, MOI.ListOfVariableIndices())
    @test vis == MOI.VariableIndex.([-1, -2])

    MOI.set(
        bridged_mock,
        MOI.ConstraintName(),
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.GreaterThan{Float64},
            }(),
        ),
        ["c1"],
    )
    MOI.set(
        bridged_mock,
        MOI.ConstraintName(),
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.LessThan{Float64},
            }(),
        ),
        ["c2"],
    )

    var_names = ["v1pos", "v2pos", "v1neg", "v2neg"]
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    MOI.set(
        bridged_mock,
        MOI.ConstraintName(),
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.Nonnegatives,
            }(),
        ),
        ["nonneg"],
    )
    s = """
    variables: v1pos, v2pos, v1neg, v2neg
    nonneg: [v1pos, v2pos, v1neg, v2neg] in Nonnegatives(4)
    c1: v1pos + -1.0v1neg + v2pos + -1.0v2neg >= 1.0
    c2: v1pos + -1.0v1neg + v2pos + -1.0v2neg <= 2.0
    minobjective: v1pos + -1.0v1neg + v2pos + -1.0v2neg
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        var_names,
        ["nonneg", "c1", "c2"],
    )
    var_names = ["v1", "v2"]
    MOI.set(bridged_mock, MOI.VariableName(), vis, var_names)
    s = """
    variables: v1, v2
    c1: v1 + v2 >= 1.0
    c2: v1 + v2 <= 2.0
    minobjective: v1 + v2
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["c1", "c2"],
    )
    _test_delete_bridged_variable(
        bridged_mock,
        vis[1],
        MOI.Reals,
        2,
        (
            (MOI.VectorOfVariables, MOI.Nonnegatives, 0),
            (MOI.VectorOfVariables, MOI.Nonpositives, 0),
        ),
        used_bridges = 0,
        used_constraints = 0,
    )
    _test_delete_bridged_variable(
        bridged_mock,
        vis[2],
        MOI.Reals,
        1,
        (
            (MOI.VectorOfVariables, MOI.Nonnegatives, 0),
            (MOI.VectorOfVariables, MOI.Nonpositives, 0),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.FreeBridge,
        """
        variables: x
        minobjective: 1.0 * x
        c: 2.0 * x <= 1.0
        """,
        """
        constrainedvariable: [x, y] in Nonnegatives(2)
        minobjective: 1.0 * x + -1.0 * y
        c: 2.0 * x + -2.0 * y <= 1.0
        """,
    )
    return
end

end  # module

TestVariableFree.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    GeoMeanToPowerBridge{T,F} <: Bridges.Constraint.AbstractBridge

`GeoMeanToPowerBridge` implements the following reformulation:

  * ``(y, x...) \\in GeometricMeanCone(1+d)`` into
    ``(x_1, t, y) \\in PowerCone(1/d)`` and ``(t, x_2, ..., x_d) in GeometricMeanCone(d)``,
    which is then recursively expanded into more `PowerCone` constraints.

## Source node

`GeoMeanToPowerBridge` supports:

  * `F` in [`MOI.GeometricMeanCone`](@ref)

## Target nodes

`GeoMeanToPowerBridge` creates:

  * `F` in [`MOI.PowerCone{T}`](@ref)
  * [`MOI.VectorOfVariables`](@ref) in [`MOI.Nonnegatives`](@ref)
"""
struct GeoMeanToPowerBridge{T,F} <: AbstractBridge
    power::Vector{MOI.ConstraintIndex{F,MOI.PowerCone{T}}}
    t::Vector{MOI.VariableIndex}
    nn::Union{
        Nothing,
        MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives},
    }
    dimension::Int
end

const GeoMeanToPower{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{GeoMeanToPowerBridge{T},OT}

function bridge_constraint(
    ::Type{GeoMeanToPowerBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.GeometricMeanCone,
) where {T,F}
    d = MOI.dimension(s)
    fi_s = MOI.Utilities.eachscalar(f)
    if d == 2
        # We could do something cleverer here, but this is a weird constraint,
        # and we don't want to overcomplicate the bridge.
        # t <= 1√(x_1) <=> t <= √(x_1 * x_1)
        ci = MOI.add_constraint(model, fi_s[[2, 2, 1]], MOI.PowerCone(T(1 / 2)))
        return GeoMeanToPowerBridge{T,F}([ci], MOI.VariableIndex[], nothing, d)
    elseif d == 3
        # t <= √(x_1 * x_2)
        ci = MOI.add_constraint(model, fi_s[[2, 3, 1]], MOI.PowerCone(T(1 / 2)))
        return GeoMeanToPowerBridge{T,F}([ci], MOI.VariableIndex[], nothing, d)
    else
        ts, nn = MOI.add_constrained_variables(model, MOI.Nonnegatives(d - 3))
        cis = MOI.ConstraintIndex{F,MOI.PowerCone{T}}[]
        z, x, n = fi_s[1], fi_s[2], d - 1
        for i in 1:(d-3)
            y = ts[i]
            fi = MOI.Utilities.operate(vcat, T, x, y, z)
            push!(cis, MOI.add_constraint(model, fi, MOI.PowerCone(T(1 / n))))
            n -= 1
            x, z = fi_s[2+i], y
        end
        fi = MOI.Utilities.operate(vcat, T, fi_s[end-1], fi_s[end], ts[end])
        push!(cis, MOI.add_constraint(model, fi, MOI.PowerCone(T(1 / 2))))
        return GeoMeanToPowerBridge{T,F}(cis, ts, nn, d)
    end
end

function MOI.supports_constraint(
    ::Type{<:GeoMeanToPowerBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.GeometricMeanCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:GeoMeanToPowerBridge},
)
    return Tuple{Type}[(MOI.Nonnegatives,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:GeoMeanToPowerBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[(F, MOI.PowerCone{T})]
end

function concrete_bridge_type(
    ::Type{<:GeoMeanToPowerBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.GeometricMeanCone},
) where {T}
    return GeoMeanToPowerBridge{T,F}
end

function MOI.get(bridge::GeoMeanToPowerBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.t)
end

function MOI.get(bridge::GeoMeanToPowerBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.t)
end

function MOI.get(
    bridge::GeoMeanToPowerBridge,
    ::MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.Nonnegatives},
)::Int64
    if bridge.nn === nothing
        return 0
    end
    return 1
end

function MOI.get(
    bridge::GeoMeanToPowerBridge,
    ::MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonnegatives},
)
    if bridge.nn === nothing
        return MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives}[]
    end
    return [bridge.nn]
end

function MOI.get(
    bridge::GeoMeanToPowerBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.PowerCone{T}},
)::Int64 where {T,F}
    return length(bridge.power)
end

function MOI.get(
    bridge::GeoMeanToPowerBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.PowerCone{T}},
) where {T,F}
    return copy(bridge.power)
end

function MOI.delete(model::MOI.ModelLike, bridge::GeoMeanToPowerBridge)
    MOI.delete(model, bridge.power)
    if bridge.nn !== nothing
        MOI.delete(model, bridge.nn)
        MOI.delete(model, bridge.t)
    end
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::GeoMeanToPowerBridge{T,F},
) where {T,F}
    f = MOI.get(model, MOI.ConstraintFunction(), bridge.power[1])
    fi_s = MOI.Utilities.eachscalar(f)
    if bridge.dimension == 2
        return fi_s[[3, 1]]
    elseif bridge.dimension == 3
        return fi_s[[3, 1, 2]]
    end
    g = fi_s[[3, 1]]
    for i in 2:(length(bridge.power)-1)
        fi = MOI.get(model, MOI.ConstraintFunction(), bridge.power[i])
        fi_s = first(MOI.Utilities.eachscalar(fi))
        g = MOI.Utilities.operate(vcat, T, g, fi_s)
    end
    fi = MOI.get(model, MOI.ConstraintFunction(), bridge.power[end])
    fi_s = MOI.Utilities.eachscalar(fi)
    return MOI.Utilities.operate(vcat, T, g, fi_s[1:2])
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::GeoMeanToPowerBridge,
)
    return MOI.GeometricMeanCone(bridge.dimension)
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    ::Type{GeoMeanToPowerBridge{T,F}},
) where {T,F}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F,MOI.PowerCone{T}})
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintPrimal},
    bridge::GeoMeanToPowerBridge{T,F},
) where {T,F}
    fi_s = MOI.get(model, attr, bridge.power[1])
    if fi_s === nothing
        return nothing
    end
    if bridge.dimension == 2
        return fi_s[[3, 1]]
    elseif bridge.dimension == 3
        return fi_s[[3, 1, 2]]
    end
    g = fi_s[[3, 1]]
    for i in 2:(length(bridge.power)-1)
        fi_s = MOI.get(model, attr, bridge.power[i])
        push!(g, fi_s[1])
    end
    fi_s = MOI.get(model, attr, bridge.power[end])
    append!(g, fi_s[1:2])
    return g
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::GeoMeanToPowerBridge{T,F},
    start::AbstractVector{T},
) where {T,F}
    if bridge.dimension == 2
        MOI.set(model, attr, bridge.power[1], start[[2, 2, 1]])
        return
    elseif bridge.dimension == 3
        MOI.set(model, attr, bridge.power[1], start[[2, 3, 1]])
        return
    end
    # [x, y, z] in PowerCone(a)
    # ⟺ x^a * y^(1-a) >= z
    # ⟺ y = (z / x^a)^(1 / (1-a))
    z, x = start[1:2]
    y = zero(T)
    for i in 1:(length(bridge.power)-1)
        ci = bridge.power[i]
        set = MOI.get(model, MOI.ConstraintSet(), ci)
        y = (z / x^set.exponent)^inv(1 - set.exponent)
        MOI.set(model, attr, ci, [x, y, z])
        z, x = y, start[i+2]
    end
    MOI.set(model, attr, bridge.power[end], [start[end-1], start[end], y])
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::GeoMeanToPowerBridge,
    ::Nothing,
)
    for ci in bridge.power
        MOI.set(model, attr, ci, nothing)
    end
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    ::Type{GeoMeanToPowerBridge{T,F}},
) where {T,F}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F,MOI.PowerCone{T}})
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDualStart,MOI.ConstraintDual},
    bridge::GeoMeanToPowerBridge{T,F},
) where {T,F}
    fi_s = MOI.get(model, attr, bridge.power[1])
    if fi_s === nothing
        return nothing
    end
    if bridge.dimension == 2
        # Power constraint is [x, x, t] in PowerCone(0.5), so we need to sum the
        # first two elements to get the dual of x.
        return [fi_s[3], fi_s[1] + fi_s[2]]
    elseif bridge.dimension == 3
        return fi_s[[3, 1, 2]]
    end
    g = fi_s[[3, 1]]
    for i in 2:(length(bridge.power)-1)
        fi_s = MOI.get(model, attr, bridge.power[i])
        push!(g, fi_s[1])
    end
    fi_s = MOI.get(model, attr, bridge.power[end])
    append!(g, fi_s[1:2])
    return g
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::GeoMeanToPowerBridge{T,F},
    start::AbstractVector{T},
) where {T,F}
    if bridge.dimension == 2
        new_start = [start[2] / 2, start[2] / 2, start[1]]
        MOI.set(model, attr, bridge.power[1], new_start)
        return
    elseif bridge.dimension == 3
        MOI.set(model, attr, bridge.power[1], start[[2, 3, 1]])
        return
    end
    # [x, y, z] in PowerCone(a)
    # [u, v, w] in PowerCone*(a)
    # ⟺ (u/a)^a * (v / (1-a))^(1-a) >= |w|
    # ⟺ (v / (1-a))^(1-a) >= |w| / (u/a)^a
    # ⟺ v / (1-a) >= (|w| / (u/a)^a)^(1/(1-a))
    # ⟺ v = (1-a) * (|w| / (u/a)^a)^(1/(1-a))
    w, u = start[1:2]
    v = zero(T)
    for i in 1:(length(bridge.power)-1)
        ci = bridge.power[i]
        set = MOI.get(model, MOI.ConstraintSet(), ci)
        a = set.exponent
        v = (1 - a) * (abs(w) / (u / a)^a)^inv(1 - a)
        MOI.set(model, attr, ci, [u, v, w])
        w, u = v, start[i+2]
    end
    MOI.set(model, attr, bridge.power[end], [start[end-1], start[end], v])
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::GeoMeanToPowerBridge,
    ::Nothing,
)
    for ci in bridge.power
        MOI.set(model, attr, ci, nothing)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestCBF

using Test

import MathOptInterface as MOI
import MathOptInterface.FileFormats: CBF

const MODELS_DIR = joinpath(@__DIR__, "models")

function runtests()
    for name in names(@__MODULE__, all = true)
        if startswith("$(name)", "test_")
            @testset "$name" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function _set_var_and_con_names(model::MOI.ModelLike)
    variable_names = String[]
    for xi in MOI.get(model, MOI.ListOfVariableIndices())
        push!(variable_names, "v$(xi.value)")
        MOI.set(model, MOI.VariableName(), xi, "v$(xi.value)")
    end
    idx = 0
    constraint_names, single_variable_constraints = String[], Tuple[]
    attr = MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Integer}()
    for ci in MOI.get(model, attr)
        idx += 1
        x = MOI.get(model, MOI.VariableName(), MOI.VariableIndex(ci.value))
        push!(single_variable_constraints, (x, MOI.Integer()))
    end
    for S in (
        MOI.Reals,
        MOI.Zeros,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.SecondOrderCone,
        MOI.RotatedSecondOrderCone,
        MOI.PositiveSemidefiniteConeTriangle,
        MOI.ExponentialCone,
        MOI.DualExponentialCone,
        MOI.PowerCone{Float64},
        MOI.DualPowerCone{Float64},
    )
        for F in (MOI.VectorOfVariables, MOI.VectorAffineFunction{Float64})
            for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
                idx += 1
                push!(constraint_names, "c$idx")
                MOI.set(model, MOI.ConstraintName(), ci, "c$idx")
            end
        end
    end
    return variable_names, constraint_names, single_variable_constraints
end

function _test_write_then_read(model_string::String)
    model1 = CBF.Model()
    MOI.Utilities.loadfromstring!(model1, model_string)
    args = _set_var_and_con_names(model1)
    io = IOBuffer()
    write(io, model1)
    model2 = CBF.Model()
    seekstart(io)
    read!(io, model2)
    _set_var_and_con_names(model2)
    return MOI.Test.util_test_models_equal(model1, model2, args...)
end

function _test_read(filename::String, model_string::String)
    model1 = CBF.Model()
    MOI.Utilities.loadfromstring!(model1, model_string)
    args = _set_var_and_con_names(model1)
    model2 = CBF.Model()
    MOI.read_from_file(model2, filename)
    _set_var_and_con_names(model2)
    MOI.Test.util_test_models_equal(model1, model2, args...)
    return
end

function test_show()
    @test sprint(summary, CBF.Model()) == "MOI.FileFormats.CBF.Model"
    return
end

function test_support_errors()
    for set in (
        MOI.EqualTo(1.0),
        MOI.LessThan(1.0),
        MOI.GreaterThan(1.0),
        MOI.Interval(1.0, 2.0),
        MOI.Semiinteger(1.0, 2.0),
        MOI.Semicontinuous(1.0, 2.0),
        MOI.ZeroOne(),
    )
        model_string = """
        variables: x
        minobjective: x
        x in $set
        """
        model = CBF.Model()
        err = MOI.UnsupportedConstraint{MOI.VariableIndex,typeof(set)}
        @test_throws err MOI.Utilities.loadfromstring!(model, model_string)
    end
    return
end

function test_read_nonempty()
    model = CBF.Model()
    MOI.add_variable(model)
    @test_throws(
        ErrorException("Cannot read in file because model is not empty."),
        MOI.read_from_file(model, joinpath(MODELS_DIR, "example_A.cbf")),
    )
    return
end

function test_read_incompatible()
    model = CBF.Model()
    @test_throws Exception MOI.read_from_file(
        model,
        joinpath(MODELS_DIR, "incompatible_version.cbf"),
    )
    return
end

function test_read_badcones()
    for filename in [
        "bad_cone_string_A.cbf",
        "bad_cone_string_B.cbf",
        "bad_cone_string_C.cbf",
        "bad_cone_string_D.cbf",
    ]
        model = CBF.Model()
        @test_throws Exception MOI.read_from_file(
            model,
            joinpath(MODELS_DIR, filename),
        )
    end
    return
end

function test_read_badpowerdim()
    for filename in ["bad_power_dim_A.cbf", "bad_power_dim_B.cbf"]
        model = CBF.Model()
        @test_throws Exception MOI.read_from_file(
            model,
            joinpath(MODELS_DIR, filename),
        )
    end
    return
end

function test_read_corrupt()
    for filename in [
        "corrupt_line_A.cbf",
        "corrupt_line_B.cbf",
        "corrupt_line_C.cbf",
        "corrupt_line_D.cbf",
        "corrupt_line_E.cbf",
    ]
        model = CBF.Model()
        @test_throws Exception MOI.read_from_file(
            model,
            joinpath(MODELS_DIR, filename),
        )
    end
    return
end

const _WRITE_READ_MODELS = [
    (
        "min VariableIndex",
        """
        variables: x
        minobjective: x
        """,
    ),
    (
        "min ScalarAffine",
        """
        variables: x, y
        minobjective: 1.2x + -1y + 1
        """,
    ),
    (
        "max VariableIndex",
        """
        variables: x
        maxobjective: x
        """,
    ),
    (
        "max ScalarAffine",
        """
        variables: x, y
        maxobjective: 1.2x + -1y + 1
        """,
    ),
    (
        "VariableIndex in Integer",
        """
        variables: x, y
        minobjective: 1.2x
        y in Integer()
        """,
    ),
    (
        "VectorOfVariables in Zeros",
        """
        variables: x, y
        minobjective: x
        c1: [x, y] in Zeros(2)
        """,
    ),
    (
        "VectorOfVariables in Nonnegatives",
        """
        variables: x, y
        minobjective: x
        c1: [x, y] in Nonnegatives(2)
        """,
    ),
    (
        "VectorOfVariables in Nonpositives",
        """
        variables: x, y
        minobjective: x
        c1: [y, x] in Nonpositives(2)
        """,
    ),
    (
        "VectorAffineFunction in Zeros",
        """
        variables: x, y
        minobjective: 1.2x
        c1: [x + 2y + -1.1, 0] in Zeros(2)
        """,
    ),
    (
        "VectorAffineFunction in Reals",
        """
        variables: x, y
        minobjective: 1.2x
        c1: [1x, 2y] in Reals(2)
        """,
    ),
    (
        "VectorAffineFunction in Nonnegatives",
        """
        variables: x, y
        minobjective: 1.2x
        c1: [1.1 * x, y + 1] in Nonnegatives(2)
        """,
    ),
    (
        "VectorAffineFunction in Nonpositives",
        """
        variables: x
        minobjective: 1.2x
        c1: [-1.1 * x + 1] in Nonpositives(1)
        """,
    ),
    (
        "VectorOfVariables in SecondOrderCone",
        """
        variables: x, y, z
        minobjective: x
        c1: [x, y, z] in SecondOrderCone(3)
        """,
    ),
    (
        "VectorOfVariables in RotatedSecondOrderCone",
        """
        variables: x, y, z
        minobjective: x
        c1: [x, y, z] in RotatedSecondOrderCone(3)
        """,
    ),
    (
        "VectorOfVariables in ExponentialCone",
        """
        variables: x, y, z
        minobjective: x
        c1: [x, y, z] in ExponentialCone()
        """,
    ),
    (
        "VectorOfVariables as function in ExponentialCone",
        """
        variables: x, y, z
        minobjective: x
        c0: [x, y, z] in Nonnegatives(3)
        c1: [x, y, z] in ExponentialCone()
        """,
    ),
    (
        "VectorOfVariables in DualExponentialCone",
        """
        variables: x, y, z
        minobjective: x
        c1: [x, y, z] in DualExponentialCone()
        """,
    ),
    (
        "VectorOfVariables as function in DualExponentialCone",
        """
        variables: x, y, z
        minobjective: x
        c0: [x, y, z] in Nonnegatives(3)
        c1: [x, y, z] in DualExponentialCone()
        """,
    ),
    (
        "VectorOfVariables in PowerCone",
        """
        variables: x, y, z
        minobjective: x
        c1: [x, y, z] in PowerCone(2.0)
        """,
    ),
    (
        "VectorOfVariables in DualPowerCone",
        """
        variables: x, y, z
        minobjective: x
        c1: [x, y, z] in DualPowerCone(2.0)
        """,
    ),
    (
        "VectorOfVariables in PositiveSemidefiniteConeTriangle",
        """
        variables: x, y, z
        minobjective: x
        c1: [x, y, z] in PositiveSemidefiniteConeTriangle(2)
        """,
    ),
    (
        "VectorAffineFunction in SecondOrderCone",
        """
        variables: x, y, z
        minobjective: 1.2x
        c1: [1.1x, y + 1, 2x + z] in SecondOrderCone(3)
        """,
    ),
    (
        "VectorAffineFunction in RotatedSecondOrderCone",
        """
        variables: x, y, z
        minobjective: 1.2x
        c1: [1.1x, y + 1, 2x + z] in RotatedSecondOrderCone(3)
        """,
    ),
    (
        "VectorAffineFunction in ExponentialCone",
        """
        variables: x, y, z
        minobjective: 1.2x
        c1: [1.1x, y + 1, 2x + z] in ExponentialCone()
        """,
    ),
    (
        "VectorAffineFunction in DualExponentialCone",
        """
        variables: x, y, z
        minobjective: 1.2x
        c1: [1.1x, y + 1, 2x + z] in DualExponentialCone()
        """,
    ),
    (
        "VectorAffineFunction in PowerCone",
        """
        variables: x, y, z
        minobjective: 1.2x
        c1: [1.1x, y + 1, 2x + z] in PowerCone(2.0)
        """,
    ),
    (
        "VectorAffineFunction in DualPowerCone",
        """
        variables: x, y, z
        minobjective: 1.2x
        c1: [1.1x, y + 1, 2x + z] in DualPowerCone(2.0)
        """,
    ),
    (
        "VectorAffineFunction in PositiveSemidefiniteConeTriangle",
        """
        variables: x, y, z
        minobjective: 1.2x
        c1: [1.1x, y + 1, 2x + z] in PositiveSemidefiniteConeTriangle(2)
        """,
    ),
]

function test_write_read_models()
    for (model_name, model_string) in _WRITE_READ_MODELS
        _test_write_then_read(model_string)
    end
    return
end

const _EXAMPLE_MODELS = [
    (
        "example_A.cbf",
        """
        variables: U, V, W, X, Y, Z, x, y, z
        minobjective: y + 2U + 2V + 2W + 2Y + 2Z
        c1: [U, V, W, X, Y, Z] in PositiveSemidefiniteConeTriangle(3)
        c2: [y + U + W + Z + -1, x + z + U + 2V + W + 2X + 2Y + Z + -0.5] in Zeros(2)
        c3: [y, x, z] in SecondOrderCone(3)
        """,
    ),
    (
        "example_B.cbf",
        """
        variables: X, Y, Z, x, y
        minobjective: 1 + x + y + X + Z
        c1: [X, Y, Z] in PositiveSemidefiniteConeTriangle(2)
        c2: [2Y + -1x + -1y] in Nonnegatives(1)
        c3: [3y + -1, x + y, 3x + -1] in PositiveSemidefiniteConeTriangle(2)
        """,
    ),
    (
        "example_C.cbf",
        """
        variables: a, b, c, d, e, f, g, h, i, j
        maxobjective: a + b + c + d + e + f + g + h + i + j + -1
        c1: [b] in Zeros(1)
        c2: [c] in Nonnegatives(1)
        c3: [d] in Nonpositives(1)
        c4: [e, f, g] in SecondOrderCone(3)
        c5: [h, i, j] in RotatedSecondOrderCone(3)
        """,
    ),
    (
        "example_D.cbf",
        """
        variables: u, v, w, x, y, z
        maxobjective: w + z
        c1: [u, v, w] in PowerCone(0.5)
        c2: [x, y, z] in DualPowerCone(0.1)
        c3: [1, u, u + v] in PowerCone(0.8)
        c4: [1, y, x + y] in DualPowerCone(0.75)
        u in Integer()
        w in Integer()
        y in Integer()
        """,
    ),
]

function test_example_models()
    for (model_name, model_string) in _EXAMPLE_MODELS
        _test_read(joinpath(MODELS_DIR, model_name), model_string)
        _test_write_then_read(model_string)
    end
    return
end

function test_write_variable_cones()
    model = CBF.Model()
    for set in (
        MOI.Zeros(2),
        MOI.Nonnegatives(3),
        MOI.PowerCone(0.74),
        MOI.Nonpositives(1),
        MOI.DualPowerCone(0.25),
        MOI.Nonnegatives(3),
        MOI.PowerCone(0.5),
        MOI.SecondOrderCone(3),
    )
        _ = MOI.add_constrained_variables(model, set)
    end
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    @test read(io, String) == """
    VER
    3

    POWCONES
    2 4
    2
    0.74
    0.26
    2
    0.5
    0.5

    POW*CONES
    1 2
    2
    0.25
    0.75

    OBJSENSE
    MIN

    VAR
    21 8
    L= 2
    L+ 3
    @0:POW 3
    L- 1
    @0:POW* 3
    L+ 3
    @1:POW 3
    Q 3

    """
    return
end

function test_write_variable_cones_with_conflicting_sets()
    model = CBF.Model()
    x, _ = MOI.add_constrained_variables(model, MOI.Nonnegatives(2))
    y = MOI.add_variable(model)
    f = MOI.VectorOfVariables([y, x[2]])
    # The choice of Nonnegatives and Nonpositives is explicitly chosen because
    # Nonnegatives are parsed before Nonpositives, and it tests that we can skip
    # over a function containing `y`, and then constrain it in a later set.
    MOI.add_constraint(model, f, MOI.Nonnegatives(2))
    MOI.add_constraint(model, MOI.VectorOfVariables([y]), MOI.Nonpositives(1))
    g = 1.0 * x[1] + 2.0 * x[2] + 3.0 * y
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(g)}(), g)
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    @test read(io, String) == """
    VER
    3

    OBJSENSE
    MIN

    VAR
    3 2
    L+ 2
    L- 1

    CON
    2 1
    L+ 2

    OBJACOORD
    3
    0 1.0
    1 2.0
    2 3.0

    ACOORD
    2
    0 2 1.0
    1 1 1.0

    """
    return
end

function test_roundtrip_ExponentialCone()
    model = CBF.Model()
    x, _ = MOI.add_constrained_variables(model, MOI.ExponentialCone())
    f = 1.0 * x[1] + 2.0 * x[2] + 3.0 * x[3]
    MOI.add_constraint(model, x[1], MOI.Integer())
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables([x[1], x[2], x[1]]),
        MOI.PositiveSemidefiniteConeTriangle(2),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    g = MOI.Utilities.operate(vcat, Float64, f)
    MOI.add_constraint(model, g, MOI.Zeros(1))
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    @test read(io, String) == """
    VER
    3

    OBJSENSE
    MIN

    VAR
    3 1
    EXP 3

    INT
    1
    2

    PSDCON
    1
    2

    CON
    1 1
    L= 1

    OBJACOORD
    3
    2 1.0
    1 2.0
    0 3.0

    ACOORD
    3
    0 2 1.0
    0 1 2.0
    0 0 3.0

    BCOORD
    1
    0 0.0

    HCOORD
    3
    0 2 0 0 1.0
    0 1 1 0 1.0
    0 2 1 1 1.0

    """
    seekstart(io)
    model2 = CBF.Model()
    read!(io, model2)
    y = MOI.get(model2, MOI.ListOfVariableIndices())
    obj_y = MOI.get(model2, MOI.ObjectiveFunction{typeof(f)}())
    @test ≈(obj_y, 1.0 * y[1] + 2.0 * y[2] + 3.0 * y[3])
    ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}.(1:3)
    @test MOI.is_valid.(model2, ci) == [true, false, false]
    return
end

function test_roundtrip_DualExponentialCone()
    model = CBF.Model()
    x, _ = MOI.add_constrained_variables(model, MOI.DualExponentialCone())
    f = 1.0 * x[1] + 2.0 * x[2] + 3.0 * x[3]
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    g = MOI.Utilities.operate(vcat, Float64, f)
    MOI.add_constraint(model, g, MOI.Zeros(1))
    io = IOBuffer()
    write(io, model)
    seekstart(io)
    @test read(io, String) == """
    VER
    3

    OBJSENSE
    MIN

    VAR
    3 1
    EXP* 3

    CON
    1 1
    L= 1

    OBJACOORD
    3
    2 1.0
    1 2.0
    0 3.0

    ACOORD
    3
    0 2 1.0
    0 1 2.0
    0 0 3.0

    BCOORD
    1
    0 0.0

    """
    seekstart(io)
    model2 = CBF.Model()
    read!(io, model2)
    y = MOI.get(model2, MOI.ListOfVariableIndices())
    obj_y = MOI.get(model2, MOI.ObjectiveFunction{typeof(f)}())
    @test ≈(obj_y, 1.0 * y[1] + 2.0 * y[2] + 3.0 * y[3])
    return
end

function test_unsupported_objectives()
    model = CBF.Model()
    for (F, ret) in [
        MOI.VariableIndex => true,
        MOI.ScalarAffineFunction{Float64} => true,
        MOI.ScalarQuadraticFunction{Float64} => false,
        MOI.ScalarNonlinearFunction => false,
        MOI.VectorOfVariables => false,
        MOI.VectorAffineFunction{Float64} => false,
        MOI.VectorQuadraticFunction{Float64} => false,
        MOI.VectorNonlinearFunction => false,
    ]
        @test MOI.supports(model, MOI.ObjectiveFunction{F}()) == ret
    end
    return
end

function test_unsupported_variable_types()
    model = CBF.Model()
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Parameter(2.0)),
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Semicontinuous(2.0, 3.0)),
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.add_constrained_variable(model, MOI.Semiinteger(2.0, 3.0)),
    )
    return
end

end  # module

TestCBF.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestObjectiveFunctionize

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_solve_singlevariable_obj()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Objective.Functionize{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [1.0], MOI.FEASIBLE_POINT),
    )
    MOI.Test.test_objective_ObjectiveFunction_VariableIndex(
        bridged_mock,
        MOI.Test.Config(),
    )
    @test MOI.get(mock, MOI.ObjectiveFunctionType()) ==
          MOI.ScalarAffineFunction{Float64}
    @test MOI.get(bridged_mock, MOI.ObjectiveFunctionType()) ==
          MOI.VariableIndex
    @test MOI.get(mock, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    @test MOI.get(bridged_mock, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    vis = MOI.get(bridged_mock, MOI.ListOfVariableIndices())
    func = vis[1]
    @test MOI.get(
        mock,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
    ) ≈ convert(MOI.ScalarAffineFunction{Float64}, func)
    @test MOI.get(bridged_mock, MOI.ObjectiveFunction{MOI.VariableIndex}()) ==
          func
    MOI.set(bridged_mock, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(mock, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    @test MOI.get(bridged_mock, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    _test_delete_objective(bridged_mock, 1, tuple())
    return
end

function test_solve_result_index()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Objective.Functionize{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0]),
            MOI.FEASIBLE_POINT,
            (MOI.VariableIndex, MOI.GreaterThan{Float64}) => [1.0],
        ),
    )
    return MOI.Test.test_solve_result_index(bridged_mock, MOI.Test.Config())
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.FunctionizeBridge,
        """
        variables: x
        minobjective: x
        """,
        """
        variables: x
        minobjective: 1.0 * x + 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.FunctionizeBridge,
        """
        variables: x
        maxobjective: x
        """,
        """
        variables: x
        maxobjective: 1.0 * x + 0.0
        """,
    )
    return
end

end  # module

TestObjectiveFunctionize.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestDoubleDicts

using Test

import MathOptInterface as MOI
import MathOptInterface.Utilities.DoubleDicts

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function _test_iterator(dict)
    kk, vv = [], []
    for (k, v) in dict
        push!(kk, k)
        push!(vv, v)
    end
    @test length(kk) == length(keys(dict))
    @test isempty(setdiff(kk, keys(dict)))
    @test length(vv) == length(values(dict))
    @test isempty(setdiff(vv, values(dict)))
    @test dict == Dict(kk .=> vv)
    return
end

function _test_basic_functionality(dict, k_values, v_values)
    @test_throws ErrorException sizehint!(dict, 1)

    @test isempty(dict)
    @test length(dict) == 0
    _test_iterator(dict)

    dict[k_values[1]] = v_values[1]
    delete!(dict, k_values[1])
    _test_iterator(dict)

    dict[k_values[3]] = v_values[3]
    _test_iterator(dict)

    empty!(dict)
    @test isempty(dict)
    @test !haskey(dict, k_values[1])

    dict[k_values[1]] = v_values[1]
    @test haskey(dict, k_values[1])
    @test values(dict) == [v_values[1]]
    @test keys(dict) == [k_values[1]]
    @test dict[k_values[1]] == v_values[1]
    @test get(dict, k_values[1], nothing) == v_values[1]
    @test get(dict, k_values[1], v_values[2]) == v_values[1]
    for i in eachindex(k_values)
        if i != 1
            @test get(dict, k_values[i], nothing) === nothing
            # Test that the implementation does not only work with `nothing`
            @test get(dict, k_values[i], v_values[i]) == v_values[i]
        end
    end

    _test_iterator(dict)

    delete!(dict, k_values[1])
    @test !haskey(dict, k_values[1])
    for i in eachindex(k_values)
        @test get(dict, k_values[i], nothing) === nothing
        # Test that the implementation does not only work with `nothing`
        @test get(dict, k_values[i], v_values[i]) == v_values[i]
    end
    @test isempty(dict)

    dict[k_values[1]] = v_values[1]
    @test length(dict) == 1

    for (k, v) in zip(k_values, v_values)
        dict[k] = v
    end

    _test_iterator(dict)

    empty!(dict)
    @test isempty(dict)
    @test length(dict) == 0

    dict[k_values[1]] = v_values[1]
    idict = dict[MOI.VariableIndex, MOI.Integer]
    bdict = dict[MOI.VariableIndex, MOI.ZeroOne]
    idict_ = dict[MOI.VariableIndex, MOI.Integer]
    @test idict.dict === idict_.dict
    sizehint!(idict, 2)
    @test length(idict) == 1
    @test length(bdict) == 0
    @test values(bdict) == typeof(v_values[3])[]
    @test keys(bdict) == typeof(k_values[3])[]

    @test haskey(idict, k_values[1])
    @test !haskey(idict, k_values[2])
    @test !haskey(bdict, k_values[3])

    @test values(idict) == [v_values[1]]
    @test keys(idict) == [k_values[1]]
    @test idict[k_values[1]] == v_values[1]

    idict[k_values[2]] = v_values[2]
    @test haskey(idict, k_values[2])
    _test_iterator(idict)

    delete!(idict, k_values[2])
    @test !haskey(idict, k_values[2])
    _test_iterator(idict)

    @test !isempty(idict)
    @test isempty(bdict)
    empty!(idict)
    empty!(bdict)
    @test isempty(idict)
    @test isempty(bdict)

    bdict[k_values[3]] = v_values[3]
    length(bdict) == 1

    edict = dict[MOI.VariableIndex, MOI.EqualTo{Bool}]
    ek = MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Bool}}(1)
    delete!(edict, ek)
    @test_throws KeyError edict[ek]
    sizehint!(edict, 0)
    @test length(edict) == 0
    @test_throws KeyError edict[ek]
    delete!(edict, ek)
    _test_iterator(edict)
    return
end

function test_DoubleDict()
    dict = DoubleDicts.DoubleDict{Float64}()
    keys = [
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(1),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(2),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(1),
    ]
    vals = [1.0, 2.0, 1.0]
    _test_basic_functionality(dict, keys, vals)
    return
end

function test_IndexDoubleDict()
    dict = DoubleDicts.IndexDoubleDict()
    keys = [
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(1),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(2),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(1),
    ]
    vals = keys
    _test_basic_functionality(dict, keys, vals)
    src = DoubleDicts.IndexDoubleDict()
    for (k, v) in zip(keys, vals)
        dict[k] = v
    end
    dest = DoubleDicts.IndexDoubleDict()
    MOI.Utilities._reverse_dict(dest, src)
    for (k, v) in src
        @test dest[v] == k
    end
    return
end

function test_IndexDoubleDict_double_loop()
    dict = DoubleDicts.IndexDoubleDict()
    keys = [
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(1),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(2),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(1),
    ]
    vals = keys
    for (k, v) in zip(keys, vals)
        dict[k] = v
    end
    # outer_keys
    number_elements = 0
    number_outer_pairs = 0
    for (F, S) in DoubleDicts.outer_keys(dict)
        number_outer_pairs += 1
        for (k, v) in dict[F, S]
            @test dict[k] == v
            number_elements += 1
        end
    end
    @test number_elements == 3
    @test number_outer_pairs == 2
    # nonempty_outer_keys
    number_elements = 0
    number_outer_pairs = 0
    for (F, S) in DoubleDicts.nonempty_outer_keys(dict)
        number_outer_pairs += 1
        for (k, v) in dict[F, S]
            @test dict[k] == v
            number_elements += 1
        end
    end
    @test number_elements == 3
    @test number_outer_pairs == 2
    return
end

function test_IndexDoubleDict_double_loop_with_delete()
    dict = DoubleDicts.IndexDoubleDict()
    keys = [
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(1),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(2),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(1),
    ]
    vals = keys
    for (k, v) in zip(keys, vals)
        dict[k] = v
    end
    delete!(dict, MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(1))
    # outer_keys
    number_elements = 0
    number_outer_pairs = 0
    for (F, S) in DoubleDicts.outer_keys(dict)
        number_outer_pairs += 1
        for (k, v) in dict[F, S]
            @test dict[k] == v
            number_elements += 1
        end
    end
    @test number_elements == 2
    @test number_outer_pairs == 2
    # nonempty_outer_keys
    number_elements = 0
    number_outer_pairs = 0
    for (F, S) in DoubleDicts.nonempty_outer_keys(dict)
        number_outer_pairs += 1
        for (k, v) in dict[F, S]
            @test dict[k] == v
            number_elements += 1
        end
    end
    @test number_elements == 2
    @test number_outer_pairs == 1
    return
end

end  # module

TestDoubleDicts.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    _extract_eigenvalues(
        model,
        f::MOI.AbstractVectorFunction,
        d::Int,
        offset::Int,
        ::Type{T},
    ) where {T}

The vector `f` contains `t` (if `offset = 1`) or `(t, u)` (if `offset = 2`)
followed by the matrix `X` of dimension `d`.

This functions extracts the eigenvalues of `X` and returns a vector containing
`t` or `(t, u)`, a vector `MOI.VariableIndex` containing the eigenvalues of `X`,
the variables created and the index of the constraint created to extract the
eigenvalues.
"""
function _extract_eigenvalues(
    model,
    f::MOI.AbstractVectorFunction,
    d::Int,
    offset::Int,
    ::Type{T},
) where {T}
    f_scalars = MOI.Utilities.eachscalar(f)
    tu = [f_scalars[i] for i in 1:offset]
    n = MOI.Utilities.trimap(d, d)
    X = f_scalars[offset .+ (1:n)]
    N = MOI.Utilities.trimap(2d, 2d)
    Δ = MOI.add_variables(model, n)
    Z = [zero(MOI.ScalarAffineFunction{T}) for i in 1:(N-n)]
    for j in 1:d
        for i in j:d
            Z[MOI.Utilities.trimap(i, d+j)-n] = Δ[MOI.Utilities.trimap(i, j)]
        end
        Z[MOI.Utilities.trimap(d+j, d+j)-n] = Δ[MOI.Utilities.trimap(j, j)]
    end
    Y = MOI.Utilities.operate(vcat, T, X, MOI.Utilities.vectorize(Z))
    set = MOI.PositiveSemidefiniteConeTriangle(2d)
    sdindex = MOI.add_constraint(model, Y, set)
    D = Δ[MOI.Utilities.trimap.(1:d, 1:d)]
    return tu, D, Δ, sdindex
end

"""
    LogDetBridge{T,F,G,H,I} <: Bridges.Constraint.AbstractBridge

The [`MOI.LogDetConeTriangle`](@ref) is representable by
[`MOI.PositiveSemidefiniteConeTriangle`](@ref) and [`MOI.ExponentialCone`](@ref)
constraints.

Indeed, ``\\log\\det(X) = \\sum\\limits_{i=1}^n \\log(\\delta_i)`` where
``\\delta_i`` are the eigenvalues of ``X``.

Adapting the method from [1, p. 149], we see that ``t \\le u \\log(\\det(X/u))``
for ``u > 0`` if and only if there exists a lower triangular matrix ``Δ`` such
that
```math
\\begin{align*}
  \\begin{pmatrix}
    X & Δ\\\\
    Δ^\\top & \\mathrm{Diag}(Δ)
  \\end{pmatrix} & \\succeq 0\\\\
  t - \\sum_{i=1}^n u \\log\\left(\\frac{Δ_{ii}}{u}\\right) & \\le 0
\\end{align*}
```
Which we reformulate further into
```math
\\begin{align*}
  \\begin{pmatrix}
    X & Δ\\\\
    Δ^\\top & \\mathrm{Diag}(Δ)
  \\end{pmatrix} & \\succeq 0\\\\
  (l_i, u , Δ_{ii}) & \\in ExponentialCone\\quad \\forall i \\\\
  t - \\sum_{i=1}^n l_i & \\le 0
\\end{align*}
```

## Source node

`LogDetBridge` supports:

  * `I` in [`MOI.LogDetConeTriangle`](@ref)

## Target nodes

`LogDetBridge` creates:

  * `F` in [`MOI.PositiveSemidefiniteConeTriangle`](@ref)
  * `G` in [`MOI.ExponentialCone`](@ref)
  * `H` in [`MOI.LessThan{T}`](@ref)

[1] Ben-Tal, Aharon, and Arkadi Nemirovski. *Lectures on modern convex
    optimization: analysis, algorithms, and engineering applications*. Society
    for Industrial and Applied Mathematics, 2001.
"""
struct LogDetBridge{T,F,G,H,I} <: AbstractBridge
    Δ::Vector{MOI.VariableIndex}
    l::Vector{MOI.VariableIndex}
    sdindex::MOI.ConstraintIndex{F,MOI.PositiveSemidefiniteConeTriangle}
    lcindex::Vector{MOI.ConstraintIndex{G,MOI.ExponentialCone}}
    tlindex::MOI.ConstraintIndex{H,MOI.LessThan{T}}
end

const LogDet{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{LogDetBridge{T},OT}

function bridge_constraint(
    ::Type{LogDetBridge{T,F,G,H,I}},
    model,
    f::I,
    s::MOI.LogDetConeTriangle,
) where {T,F,G,H,I}
    d = s.side_dimension
    tu, D, Δ, sdindex = _extract_eigenvalues(model, f, d, 2, T)
    t, u = tu
    l = MOI.add_variables(model, d)
    lcindex = MOI.ConstraintIndex{G,MOI.ExponentialCone}[]
    for i in eachindex(l)
        fi = MOI.Utilities.operate(vcat, T, l[i], u, D[i])
        push!(lcindex, MOI.add_constraint(model, fi, MOI.ExponentialCone()))
    end
    rhs = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(one(T), l), zero(T))
    tlindex = MOI.Utilities.normalize_and_add_constraint(
        model,
        MOI.Utilities.operate!(-, T, t, rhs),
        MOI.LessThan(zero(T));
        allow_modify_function = true,
    )
    return LogDetBridge{T,F,G,H,I}(Δ, l, sdindex, lcindex, tlindex)
end

function MOI.supports_constraint(
    ::Type{LogDetBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.LogDetConeTriangle},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:LogDetBridge})
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:LogDetBridge{T,F,G,H}},
) where {T,F,G,H}
    return Tuple{Type,Type}[
        (F, MOI.PositiveSemidefiniteConeTriangle),
        (G, MOI.ExponentialCone),
        (H, MOI.LessThan{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:LogDetBridge{T}},
    I::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.LogDetConeTriangle},
) where {T}
    S = MOI.Utilities.scalar_type(I)
    G = MOI.Utilities.promote_operation(vcat, T, S, MOI.VariableIndex)
    F = MOI.Utilities.promote_operation(vcat, T, G, T)
    H = MOI.Utilities.promote_operation(+, T, S, MOI.ScalarAffineFunction{T})
    return LogDetBridge{T,F,G,H,I}
end

function MOI.get(b::LogDetBridge, ::MOI.NumberOfVariables)::Int64
    return length(b.Δ) + length(b.l)
end

MOI.get(b::LogDetBridge, ::MOI.ListOfVariableIndices) = [b.Δ; b.l]

function MOI.get(
    ::LogDetBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.PositiveSemidefiniteConeTriangle},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    b::LogDetBridge{T,F,G},
    ::MOI.NumberOfConstraints{G,MOI.ExponentialCone},
)::Int64 where {T,F,G}
    return length(b.lcindex)
end

function MOI.get(
    ::LogDetBridge{T,F,G,H},
    ::MOI.NumberOfConstraints{H,MOI.LessThan{T}},
)::Int64 where {T,F,G,H}
    return 1
end

function MOI.get(
    b::LogDetBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.PositiveSemidefiniteConeTriangle},
) where {T,F}
    return [b.sdindex]
end

function MOI.get(
    b::LogDetBridge{T,F,G},
    ::MOI.ListOfConstraintIndices{G,MOI.ExponentialCone},
) where {T,F,G}
    return copy(b.lcindex)
end

function MOI.get(
    b::LogDetBridge{T,F,G,H},
    ::MOI.ListOfConstraintIndices{H,MOI.LessThan{T}},
) where {T,F,G,H}
    return [b.tlindex]
end

function MOI.delete(model::MOI.ModelLike, bridge::LogDetBridge)
    MOI.delete(model, bridge.tlindex)
    MOI.delete(model, bridge.lcindex)
    MOI.delete(model, bridge.sdindex)
    MOI.delete(model, bridge.l)
    MOI.delete(model, bridge.Δ)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::LogDetBridge,
)
    t =
        MOI.get(model, attr, bridge.tlindex) +
        sum(MOI.get(model, attr, ci)[1] for ci in bridge.lcindex)
    u = MOI.get(model, attr, first(bridge.lcindex))[2]
    x = MOI.get(model, attr, bridge.sdindex)[1:length(bridge.Δ)]
    return vcat(t, u, x)
end

# [X Δ; Δ' Diag(Δ)] in PSD
# t - sum(l) >= 0
# (l_i, u, Δ_ii) in Exp
# (t, u, x) in LogDet <=>
# exists Δ, l such that At + Bu + Cx + DΔ + El in (PSD, >=, Exp_i)
# so LogDet* = [A'; B'; C'] (PSD, >=, Exp_i)*
# and 0 = [D'; E'] (PSD, >=, Exp_i)*
# where
# A = [0, 0, 0, 1, 0, 0, 0]
# B = [0, 0, 0, 0, 0, 1, 0]
# C = [I, 0, 0, 0, 0, 0, 0]
# D = [0, I, I(i=j), 0, 0, 0, I(i=j)]
# E = [0, 0, 0, 1, I, 0, 0]
# so given dual q = (a, b, c, d, e, f, g), we get
# t = A' q = d => t = d
# u = B' q = f => u = sum(f)
# x = C' q = a => x = a
# offdiag(b) = 0
# 0 = D' q = diag(b) + diag(c) + g => g = -diag(b) - diag(c)
# let b = 0, so g_i = -c_i
# 0 = E' q = d + e => d = -e
function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::LogDetBridge,
)
    t_dual = MOI.get(model, attr, bridge.tlindex)
    u_dual =
        sum(MOI.get(model, attr, lcindex_i)[2] for lcindex_i in bridge.lcindex)
    x_dual = MOI.get(model, attr, bridge.sdindex)[1:length(bridge.Δ)]
    return vcat(t_dual, u_dual, x_dual)
end

function MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, bridge::LogDetBridge)
    return MOI.LogDetConeTriangle(length(bridge.l))
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::LogDetBridge{T,F,G,H,I},
) where {T,F,G,H,I}
    n = length(bridge.Δ)
    Y = MOI.get(model, attr, bridge.sdindex)::F
    X = MOI.Utilities.convert_approx(I, MOI.Utilities.eachscalar(Y)[1:n])
    slog = MOI.get(model, attr, first(bridge.lcindex))::G
    u = MOI.Utilities.eachscalar(slog)[2]
    ssu = MOI.get(model, attr, bridge.tlindex)::H
    taff = MOI.Utilities.remove_variable(ssu, bridge.l)
    SI = MOI.Utilities.scalar_type(I)
    t = MOI.Utilities.convert_approx(SI, taff)
    return MOI.Utilities.operate(vcat, T, t, u, X)::I
end

"""
    RootDetBridge{T,F,G,H} <: Bridges.Constraint.AbstractBridge

The [`MOI.RootDetConeTriangle`](@ref) is representable by
[`MOI.PositiveSemidefiniteConeTriangle`](@ref) and [`MOI.GeometricMeanCone`](@ref)
constraints, see [1, p. 149].

Indeed, ``t \\le \\det(X)^{1/n}`` if and only if there exists a lower triangular
matrix ``Δ`` such that:
```math
\\begin{align*}
  \\begin{pmatrix}
    X & Δ\\\\
    Δ^\\top & \\mathrm{Diag}(Δ)
  \\end{pmatrix} & \\succeq 0\\\\
  (t, \\mathrm{Diag}(Δ)) & \\in GeometricMeanCone
\\end{align*}
```

## Source node

`RootDetBridge` supports:

  * `I` in [`MOI.RootDetConeTriangle`](@ref)

## Target nodes

`RootDetBridge` creates:

  * `F` in [`MOI.PositiveSemidefiniteConeTriangle`](@ref)
  * `G` in [`MOI.GeometricMeanCone`](@ref)

[1] Ben-Tal, Aharon, and Arkadi Nemirovski. *Lectures on modern convex
    optimization: analysis, algorithms, and engineering applications*. Society
    for Industrial and Applied Mathematics, 2001.
"""
struct RootDetBridge{T,F,G,H} <: AbstractBridge
    Δ::Vector{MOI.VariableIndex}
    sdindex::MOI.ConstraintIndex{F,MOI.PositiveSemidefiniteConeTriangle}
    gmindex::MOI.ConstraintIndex{G,MOI.GeometricMeanCone}
end

const RootDet{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{RootDetBridge{T},OT}

function bridge_constraint(
    ::Type{RootDetBridge{T,F,G,H}},
    model,
    f::G,
    s::MOI.RootDetConeTriangle,
) where {T,F,G,H}
    d = s.side_dimension
    tu, D, Δ, sdindex = _extract_eigenvalues(model, f, d, 1, T)
    t = tu[1]
    DF = MOI.VectorOfVariables(D)
    gmindex = MOI.add_constraint(
        model,
        MOI.Utilities.operate(vcat, T, t, DF),
        MOI.GeometricMeanCone(d + 1),
    )
    return RootDetBridge{T,F,G,H}(Δ, sdindex, gmindex)
end

function MOI.supports_constraint(
    ::Type{<:RootDetBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.RootDetConeTriangle},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:RootDetBridge})
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:RootDetBridge{T,F,G}},
) where {T,F,G}
    return Tuple{Type,Type}[
        (F, MOI.PositiveSemidefiniteConeTriangle),
        (G, MOI.GeometricMeanCone),
    ]
end

function concrete_bridge_type(
    ::Type{<:RootDetBridge{T}},
    H::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.RootDetConeTriangle},
) where {T}
    S = MOI.Utilities.scalar_type(H)
    G = MOI.Utilities.promote_operation(vcat, T, S, MOI.VariableIndex)
    F = MOI.Utilities.promote_operation(vcat, T, G, T)
    return RootDetBridge{T,F,G,H}
end

MOI.get(b::RootDetBridge, ::MOI.NumberOfVariables)::Int64 = length(b.Δ)

MOI.get(b::RootDetBridge, ::MOI.ListOfVariableIndices) = copy(b.Δ)

function MOI.get(
    ::RootDetBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.PositiveSemidefiniteConeTriangle},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    ::RootDetBridge{T,F,G},
    ::MOI.NumberOfConstraints{G,MOI.GeometricMeanCone},
)::Int64 where {T,F,G}
    return 1
end

function MOI.get(
    b::RootDetBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.PositiveSemidefiniteConeTriangle},
) where {T,F}
    return [b.sdindex]
end

function MOI.get(
    b::RootDetBridge{T,F,G},
    ::MOI.ListOfConstraintIndices{G,MOI.GeometricMeanCone},
) where {T,F,G}
    return [b.gmindex]
end

function MOI.delete(model::MOI.ModelLike, bridge::RootDetBridge)
    MOI.delete(model, bridge.gmindex)
    MOI.delete(model, bridge.sdindex)
    MOI.delete(model, bridge.Δ)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::RootDetBridge,
)
    t = MOI.get(model, attr, bridge.gmindex)[1]
    x = MOI.get(model, attr, bridge.sdindex)[1:length(bridge.Δ)]
    return vcat(t, x)
end

# (t, x) in RootDet <=> exists Δ such that At + Bx + CΔ in (PSD, GeoMean)
# so RootDet* = [A'; B'] (PSD, GeoMean)*
# and 0 = [C'] (PSD, GeoMean)*
# where
# A = [0, 0, 0, 1, 0]
# B = [I, 0, 0, 0, 0]
# C = [0, I, I(i=j), 0, I(i=j)]
# so given dual q = (a, b, c, d, e), we get
# t = A' q = d => t = d
# x = B' q = a => x = a
# offdiag(b) = 0
# 0 = C' q = diag(b) + diag(c) + e => e = -diag(b) - diag(c)
# let b = 0, so e_i = -c_i
function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual},
    bridge::RootDetBridge,
)
    t_dual = MOI.get(model, attr, bridge.gmindex)[1]
    x_dual = MOI.get(model, attr, bridge.sdindex)[1:length(bridge.Δ)]
    return vcat(t_dual, x_dual)
end

function MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, bridge::RootDetBridge)
    n = length(bridge.Δ)
    d = MOI.Utilities.side_dimension_for_vectorized_dimension(n)
    return MOI.RootDetConeTriangle(d)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::RootDetBridge{T,F,G,H},
) where {T,F,G,H}
    n = length(bridge.Δ)
    Y = MOI.get(model, attr, bridge.sdindex)::F
    X = MOI.Utilities.convert_approx(H, MOI.Utilities.eachscalar(Y)[1:n])
    func = MOI.get(model, attr, bridge.gmindex)::G
    t = MOI.Utilities.eachscalar(func)[1]
    return MOI.Utilities.operate(vcat, T, t, X)::H
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestReverseAD

using Test
import LinearAlgebra
import MathOptInterface as MOI
import SparseArrays

import MathOptInterface.Nonlinear
import MathOptInterface.Nonlinear.ReverseAD
import MathOptInterface.Nonlinear.ReverseAD.Coloring

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_objective_quadratic_univariate()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :($x^2 + 1))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.eval_objective(evaluator, [1.2]) == 1.2^2 + 1
    g = [NaN]
    MOI.eval_objective_gradient(evaluator, g, [1.2])
    @test g == [2.4]
    @test MOI.hessian_objective_structure(evaluator) == [(1, 1)]
    H = [NaN]
    MOI.eval_hessian_objective(evaluator, H, [1.2])
    @test H == [2.0]
    @test MOI.hessian_lagrangian_structure(evaluator) == [(1, 1)]
    H = [NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, [1.2], 1.5, Float64[])
    @test H == 1.5 .* [2.0]
    MOI.eval_hessian_lagrangian_product(
        evaluator,
        H,
        [1.2],
        [1.2],
        1.5,
        Float64[],
    )
    @test H == [1.5 * 2.0 * 1.2]
    return
end

function test_objective_and_constraints_quadratic_univariate()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :($x^2 + 1))
    Nonlinear.add_constraint(model, :($x^2), MOI.LessThan(2.0))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.eval_objective(evaluator, [1.2]) == 1.2^2 + 1
    g = [NaN]
    MOI.eval_objective_gradient(evaluator, g, [1.2])
    @test g == [2.4]
    @test MOI.hessian_objective_structure(evaluator) == [(1, 1)]
    H = [NaN]
    MOI.eval_hessian_objective(evaluator, H, [1.2])
    @test H == [2.0]
    @test MOI.hessian_constraint_structure(evaluator, 1) == [(1, 1)]
    H = [NaN]
    MOI.eval_hessian_constraint(evaluator, H, [1.3], 1)
    @test H == [2.0]
    @test MOI.hessian_lagrangian_structure(evaluator) == [(1, 1), (1, 1)]
    H = [NaN, NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, [1.2], 1.5, Float64[1.3])
    @test H == [1.5, 1.3] .* [2.0, 2.0]
    Hp = [NaN]
    MOI.eval_hessian_lagrangian_product(
        evaluator,
        Hp,
        [1.2],
        [1.2],
        1.5,
        Float64[1.3],
    )
    @test Hp == [1.5 * 2.0 * 1.2 + 1.3 * 2.0 * 1.2]
    return
end

function test_objective_quadratic_multivariate()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :($x^2 + $x * $y + $y^2))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.eval_objective(evaluator, [1.2, 2.3]) == 1.2^2 + 1.2 * 2.3 + 2.3^2
    g = [NaN, NaN]
    MOI.eval_objective_gradient(evaluator, g, [1.2, 2.3])
    @test g == [2 * 1.2 + 2.3, 1.2 + 2 * 2.3]
    @test MOI.hessian_objective_structure(evaluator) == [(1, 1), (2, 2), (2, 1)]
    H = [NaN, NaN, NaN]
    MOI.eval_hessian_objective(evaluator, H, [1.2, 2.3])
    @test H == [2.0, 2.0, 1.0]
    @test MOI.hessian_lagrangian_structure(evaluator) ==
          [(1, 1), (2, 2), (2, 1)]
    H = [NaN, NaN, NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, [1.2, 2.3], 1.5, Float64[])
    @test H == 1.5 .* [2.0, 2.0, 1.0]
    v = [0.3, 0.4]
    hv = [NaN, NaN]
    MOI.eval_hessian_lagrangian_product(
        evaluator,
        hv,
        [1.2, 2.3],
        v,
        1.5,
        Float64[],
    )
    @test hv ≈ 1.5 .* [2 1; 1 2] * v
    return
end

function test_objective_quadratic_multivariate_subexpressions()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    ex = Nonlinear.add_expression(model, :($x^2))
    ey = Nonlinear.add_expression(model, :($y^2))
    exy = Nonlinear.add_expression(model, :($ex + $x * $y))
    Nonlinear.set_objective(model, :($exy + $ey))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    val = [1.2, 2.3]
    @test MOI.eval_objective(evaluator, val) == 1.2^2 + 1.2 * 2.3 + 2.3^2
    @test 0 == @allocated MOI.eval_objective(evaluator, val)
    g = [NaN, NaN]
    MOI.eval_objective_gradient(evaluator, g, val)
    @test g == [2 * 1.2 + 2.3, 1.2 + 2 * 2.3]
    @test 0 == @allocated MOI.eval_objective_gradient(evaluator, g, val)
    @test MOI.hessian_objective_structure(evaluator) == [(1, 1), (2, 2), (2, 1)]
    H = [NaN, NaN, NaN]
    MOI.eval_hessian_objective(evaluator, H, val)
    @test H == [2.0, 2.0, 1.0]
    @test evaluator.backend.max_chunk == 2
    @test 0 == @allocated MOI.eval_hessian_objective(evaluator, H, val)
    @test MOI.hessian_lagrangian_structure(evaluator) ==
          [(1, 1), (2, 2), (2, 1)]
    H = [NaN, NaN, NaN]
    μ = Float64[]
    MOI.eval_hessian_lagrangian(evaluator, H, val, 1.5, μ)
    @test 0 == @allocated MOI.eval_hessian_lagrangian(evaluator, H, val, 1.5, μ)
    @test H == 1.5 .* [2.0, 2.0, 1.0]
    v = [0.3, 0.4]
    hv = [NaN, NaN]
    MOI.eval_hessian_lagrangian_product(evaluator, hv, val, v, 1.5, μ)
    @test hv ≈ 1.5 .* [2 1; 1 2] * v
    @test 0 == @allocated MOI.eval_hessian_lagrangian_product(
        evaluator,
        hv,
        val,
        v,
        1.5,
        μ,
    )
    return
end

function test_objective_ifelse_comparison()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(ifelse(1 <= $x <= 2, $x^2, $y^2)))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.eval_objective(evaluator, [1.2, 2.3]) == 1.2^2
    @test MOI.eval_objective(evaluator, [2.2, 2.3]) == 2.3^2
    g = [NaN, NaN]
    MOI.eval_objective_gradient(evaluator, g, [1.2, 2.3])
    @test g == [2 * 1.2, 0.0]
    MOI.eval_objective_gradient(evaluator, g, [2.2, 2.3])
    @test g == [0.0, 2 * 2.3]
    return
end

function test_objective_ifelse_logic()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(ifelse(1 <= $x && $x <= 2, $x^2, $y^2)))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.eval_objective(evaluator, [1.2, 2.3]) == 1.2^2
    @test MOI.eval_objective(evaluator, [2.2, 2.3]) == 2.3^2
    g = [NaN, NaN]
    MOI.eval_objective_gradient(evaluator, g, [1.2, 2.3])
    @test g == [2 * 1.2, 0.0]
    MOI.eval_objective_gradient(evaluator, g, [2.2, 2.3])
    @test g == [0.0, 2 * 2.3]
    return
end

function test_objective_parameter()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    p = Nonlinear.add_parameter(model, 1.2)
    Nonlinear.set_objective(model, :($p * $x))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.eval_objective(evaluator, [1.3]) == 1.2 * 1.3
    g = [NaN]
    MOI.eval_objective_gradient(evaluator, g, [1.3])
    @test g == [1.2]
    return
end

function test_objective_subexpression()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    input = :($x^2 + 1)
    expr = Nonlinear.add_expression(model, input)
    expr_2 = Nonlinear.add_expression(model, :($expr^2))
    Nonlinear.set_objective(model, :($expr_2^2))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad])
    @test MOI.eval_objective(evaluator, [1.3]) == ((1.3^2 + 1)^2)^2
    g = [NaN]
    MOI.eval_objective_gradient(evaluator, g, [1.3])
    @test g ≈ [2 * (1.3^2 + 1)^2 * (2 * (1.3^2 + 1)) * 2 * 1.3]
    return
end

function test_constraint_quadratic_univariate()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.add_constraint(model, :($x^2), MOI.LessThan(2.0))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    g = [NaN]
    x_val = [1.2]
    MOI.eval_constraint(evaluator, g, x_val)
    @test g == x_val .^ 2
    @test MOI.jacobian_structure(evaluator) == [(1, 1)]
    J = [NaN]
    MOI.eval_constraint_jacobian(evaluator, J, x_val)
    @test J == 2 .* x_val
    @test MOI.hessian_constraint_structure(evaluator, 1) == [(1, 1)]
    H = [NaN]
    MOI.eval_hessian_constraint(evaluator, H, x_val, 1)
    @test H == [2.0]
    @test MOI.hessian_lagrangian_structure(evaluator) == [(1, 1)]
    H = [NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, x_val, 0.0, [1.5])
    @test H == 1.5 .* [2.0]
    return
end

function test_constraint_quadratic_multivariate()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    Nonlinear.add_constraint(model, :($x^2 + $x * $y + $y^2), MOI.LessThan(2.0))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    g = [NaN]
    x_val = [1.2, 2.3]
    MOI.eval_constraint(evaluator, g, x_val)
    @test g == [x_val[1]^2 + x_val[1] * x_val[2] + x_val[2]^2]
    @test MOI.jacobian_structure(evaluator) == [(1, 1), (1, 2)]
    J = [NaN, NaN]
    MOI.eval_constraint_jacobian(evaluator, J, x_val)
    @test J == [2 * x_val[1] + x_val[2], x_val[1] + 2 * x_val[2]]
    @test MOI.hessian_lagrangian_structure(evaluator) ==
          [(1, 1), (2, 2), (2, 1)]
    H = [NaN, NaN, NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, x_val, 0.0, [1.5])
    @test H == 1.5 .* [2.0, 2.0, 1.0]
    return
end

function test_constraint_quadratic_multivariate_subexpressions()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    ex = Nonlinear.add_expression(model, :($x^2))
    ey = Nonlinear.add_expression(model, :($y^2))
    exy = Nonlinear.add_expression(model, :($ex + $x * $y))
    Nonlinear.add_constraint(model, :($exy + $ey), MOI.LessThan(2.0))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    g = [NaN]
    x_val = [1.2, 2.3]
    MOI.eval_constraint(evaluator, g, x_val)
    @test g ≈ [x_val[1]^2 + x_val[1] * x_val[2] + x_val[2]^2]
    # Jacobian
    @test MOI.jacobian_structure(evaluator) == [(1, 1), (1, 2)]
    J = [NaN, NaN]
    MOI.eval_constraint_jacobian(evaluator, J, x_val)
    @test J ≈ [2 * x_val[1] + x_val[2], x_val[1] + 2 * x_val[2]]
    # Jv
    y, w = [NaN], [1.1, 2.2]
    MOI.eval_constraint_jacobian_product(evaluator, y, x_val, w)
    @test y ≈ [(2 * x_val[1] + x_val[2]) (x_val[1] + 2 * x_val[2])] * w
    # v'J
    y, w = [NaN, NaN], [1.1]
    MOI.eval_constraint_jacobian_transpose_product(evaluator, y, x_val, w)
    wJ = w' * [(2 * x_val[1] + x_val[2]) (x_val[1] + 2 * x_val[2])]
    @test y ≈ wJ[:]
    # Hessian-Lagrangian
    @test MOI.hessian_lagrangian_structure(evaluator) ==
          [(1, 1), (2, 2), (2, 1)]
    H = [NaN, NaN, NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, x_val, 0.0, [1.5])
    @test H ≈ 1.5 .* [2.0, 2.0, 1.0]
    return
end

function test_hessian_sparsity_registered_function()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    f(x, y) = x^2 + y^2
    function ∇f(g, x...)
        g[1] = 2x[1]
        g[2] = 2x[2]
        return
    end
    function ∇²f(H, x...)
        H[1, 1] = 2
        H[2, 2] = 2
        return
    end
    model = Nonlinear.Model()
    Nonlinear.register_operator(model, :f, 2, f, ∇f, ∇²f)
    Nonlinear.set_objective(model, :(f($x, $z) + $y^2))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y, z])
    @test :Hess in MOI.features_available(evaluator)
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.hessian_lagrangian_structure(evaluator) ==
          [(1, 1), (2, 2), (3, 3), (3, 1)]
    H = fill(NaN, 4)
    MOI.eval_hessian_lagrangian(evaluator, H, rand(3), 1.5, Float64[])
    @test H == 1.5 .* [2.0, 2.0, 2.0, 0.0]
    return
end

function test_hessian_sparsity_registered_rosenbrock()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f(x...) = (1 - x[1])^2 + 100 * (x[2] - x[1]^2)^2
    function ∇f(g, x...)
        g[1] = 400 * x[1]^3 - 400 * x[1] * x[2] + 2 * x[1] - 2
        g[2] = 200 * (x[2] - x[1]^2)
        return
    end
    function ∇²f(H, x...)
        @assert size(H) == (2, 2)
        H[1, 1] = 1200 * x[1]^2 - 400 * x[2] + 2
        H[2, 1] = -400 * x[1]
        H[2, 2] = 200.0
        return
    end
    model = Nonlinear.Model()
    Nonlinear.register_operator(model, :rosenbrock, 2, f, ∇f, ∇²f)
    Nonlinear.set_objective(model, :(rosenbrock($x, $y)))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y])
    @test :Hess in MOI.features_available(evaluator)
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.hessian_lagrangian_structure(evaluator) ==
          [(1, 1), (2, 2), (2, 1)]
    H = fill(NaN, 3)
    MOI.eval_hessian_lagrangian(evaluator, H, [1.0, 1.0], 1.5, Float64[])
    @test H == 1.5 .* [802.0, 200.0, -400.0]
    return
end

function test_hessian_registered_error()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f(x...) = (1 - x[1])^2 + 100 * (x[2] - x[1]^2)^2
    function ∇f(g, x...)
        g[1] = 400 * x[1]^3 - 400 * x[1] * x[2] + 2 * x[1] - 2
        g[2] = 200 * (x[2] - x[1]^2)
        return
    end
    function ∇²f(H, x...)
        H[1, 1] = 1200 * x[1]^2 - 400 * x[2] + 2
        # Wrong index. Should be [2, 1]
        H[1, 2] = -400 * x[1]
        H[2, 2] = 200.0
        return
    end
    model = Nonlinear.Model()
    Nonlinear.register_operator(model, :rosenbrock, 2, f, ∇f, ∇²f)
    Nonlinear.set_objective(model, :(rosenbrock($x, $y)))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    H = fill(NaN, 3)
    @test_throws(
        ErrorException("Unable to access upper-triangular component: (1, 2)"),
        MOI.eval_hessian_lagrangian(evaluator, H, [1.0, 1.0], 1.5, Float64[]),
    )
    return
end

struct _ColoringGraph
    num_vertices::Int
    edges::Vector{Tuple{Int,Int}}
end

function to_adjlist(graph::_ColoringGraph)
    I = [i for (i, _) in graph.edges]
    J = [j for (_, j) in graph.edges]
    return Coloring.UndirectedGraph(I, J, graph.num_vertices)
end

function test_coloring_edge_free_graph()
    graph = _ColoringGraph(10, [])
    _, numcolors = Coloring.acyclic_coloring(to_adjlist(graph))
    @test numcolors == 1
    return
end

function test_coloring_one_edge_graph()
    graph = _ColoringGraph(10, [(2, 4)])
    color, numcolors = Coloring.acyclic_coloring(to_adjlist(graph))
    @test numcolors == 2
    @test color[2] != color[4]
    return
end

function test_coloring_two_edge_graph()
    graph = _ColoringGraph(10, [(2, 4), (2, 3)])
    color, numcolors = Coloring.acyclic_coloring(to_adjlist(graph))
    @test numcolors == 2
    @test color[3] == color[4]
    return
end

function test_coloring_three_edge_graph()
    graph = _ColoringGraph(10, [(2, 4), (2, 3), (3, 4)])
    color, numcolors = Coloring.acyclic_coloring(to_adjlist(graph))
    @test numcolors == 3
    # TODO: What is this testing?
    Coloring.recovery_preprocess(to_adjlist(graph), color, numcolors, Int[])
    return
end

function test_coloring_two_edge_three_vertex_graph()
    graph = _ColoringGraph(3, [(1, 3), (2, 3)])
    _, numcolors = Coloring.acyclic_coloring(to_adjlist(graph))
    @test numcolors == 2
    return
end

function test_coloring_four_edge_four_vertex_graph()
    graph = _ColoringGraph(4, [(1, 2), (2, 3), (3, 4), (4, 1)])
    _, numcolors = Coloring.acyclic_coloring(to_adjlist(graph))
    @test numcolors == 3
    return
end

function test_coloring_topological_sort()
    # graph = _ColoringGraph(6, [(1, 2), (1, 3), (1, 6), (2, 4), (2, 5)])
    vec = [3, 6, 2, 1, 4, 5, 1, 2, 2, 1]
    offset = [1, 4, 7, 8, 9, 10, 11]
    v = Coloring.reverse_topological_sort_by_dfs(vec, offset, 6, zeros(Int, 6))
    @test v[1] == [3, 6, 4, 5, 2, 1]
    @test v[2] == [0, 1, 1, 2, 2, 1]
    return
end

function test_coloring_end_to_end_hessian_coloring_and_recovery()
    I, J, rinfo = Coloring.hessian_color_preprocess(Set([(1, 2)]), 2)
    R = Coloring.seed_matrix(rinfo)
    Coloring.prepare_seed_matrix!(R, rinfo)
    @test I == [1, 2, 2]
    @test J == [1, 2, 1]
    @test R == [1.0 0.0; 0.0 1.0]
    hess = [3.4 2.1; 2.1 1.3]
    matmat = hess * R
    V = zeros(3)
    Coloring.recover_from_matmat!(V, matmat, rinfo, zeros(3))
    @test V == [3.4, 1.3, 2.1]
    return
end

function test_derivatives()
    a = MOI.VariableIndex(1)
    b = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(sin($a^2) + cos($b * 4) / 5 - 2.0))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [a, b])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    x = [2.0, 3.0]
    @test MOI.eval_objective(evaluator, x) ==
          sin(x[1]^2) + cos(x[2] * 4) / 5 - 2.0
    g = [NaN, NaN]
    MOI.eval_objective_gradient(evaluator, g, x)
    @test g ≈ [2 * x[1] * cos(x[1]^2), -4 * sin(x[2] * 4) / 5]
    @test MOI.hessian_lagrangian_structure(evaluator) == [(1, 1), (2, 2)]
    H = [NaN, NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, x, 1.5, Float64[])
    H_exact = [
        -4 * x[1]^2 * sin(x[1]^2) + 2 * cos(x[1]^2),
        -4 / 5 * 4 * cos(x[2] * 4),
    ]
    @test H == 1.5 .* H_exact
    return
end

function test_NLPBlockData()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    Nonlinear.add_constraint(model, :($x - 1), MOI.LessThan(0.0))
    Nonlinear.add_constraint(model, :($x - 2), MOI.GreaterThan(0.0))
    Nonlinear.add_constraint(model, :($x - 3), MOI.EqualTo(0.0))
    Nonlinear.add_constraint(model, :($x), MOI.Interval(4.0, 5.0))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    block = MOI.NLPBlockData(evaluator)
    @test block.constraint_bounds == [
        MOI.NLPBoundsPair(-Inf, 0.0),
        MOI.NLPBoundsPair(0.0, Inf),
        MOI.NLPBoundsPair(0.0, 0.0),
        MOI.NLPBoundsPair(4.0, 5.0),
    ]
    @test block.has_objective == false
    return
end

function test_linearity()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    variables = Dict(x => 1, y => 2, z => 3)
    function _test_linearity(input, test_value, IJ = [], indices = [])
        model = Nonlinear.Model()
        ex = Nonlinear.add_expression(model, input)
        expr = model[ex]
        adj = Nonlinear.adjacency_matrix(expr.nodes)
        nodes = ReverseAD._replace_moi_variables(expr.nodes, variables)
        ret = ReverseAD._classify_linearity(nodes, adj, ReverseAD.Linearity[])
        @test ret[1] == test_value
        indexed_set = Coloring.IndexedSet(100)
        edge_list = ReverseAD._compute_hessian_sparsity(
            nodes,
            adj,
            ret,
            Set{Tuple{Int,Int}}[],
            Vector{Int}[],
        )
        if ret[1] != ReverseAD.NONLINEAR
            @test length(edge_list) == 0
        elseif length(IJ) > 0
            @test IJ == edge_list
        end
        if length(indices) > 0
            empty!(indexed_set)
            ReverseAD._compute_gradient_sparsity!(indexed_set, nodes)
            ix = sort(collect(indexed_set))
            @test indices == ix
        end
        return
    end
    _test_linearity(
        :(sin($x^2) + cos($y * 4) - 2.0),
        ReverseAD.NONLINEAR,
        Set([(2, 2), (1, 1)]),
        [1, 2],
    )
    _test_linearity(:(3 * 4 * ($x + $y)), ReverseAD.LINEAR)
    _test_linearity(:($z * $y), ReverseAD.NONLINEAR, Set([(3, 2)]), [2, 3])
    _test_linearity(:(3 + 4), ReverseAD.CONSTANT)
    _test_linearity(:(sin(3) + $x), ReverseAD.LINEAR)
    _test_linearity(
        :(cos($z) * sin(3) + $x),
        ReverseAD.NONLINEAR,
        Set([(3, 3)]),
        [1, 3],
    )
    _test_linearity(:($x - 3 * $y), ReverseAD.LINEAR)
    _test_linearity(:(-$x), ReverseAD.LINEAR)
    _test_linearity(:(+$x), ReverseAD.LINEAR)
    _test_linearity(
        :($x^$y),
        ReverseAD.NONLINEAR,
        Set([(2, 2), (1, 1), (2, 1)]),
        [1, 2],
    )
    _test_linearity(:($x / 3 + $y), ReverseAD.LINEAR)
    _test_linearity(
        :(3 / ($x * $y)),
        ReverseAD.NONLINEAR,
        Set([(2, 2), (1, 1), (2, 1)]),
        [1, 2],
    )
    _test_linearity(:(1 / ($x + 3)), ReverseAD.NONLINEAR, Set([(1, 1)]), [1])
    _test_linearity(
        :(ifelse($x <= 1, $x, $y)),
        ReverseAD.PIECEWISE_LINEAR,
        Set([]),
        [],
    )
    _test_linearity(
        :(ifelse($x <= 1, $x^2, $y)),
        ReverseAD.NONLINEAR,
        Set([(1, 1)]),
        [1, 2],
    )
    _test_linearity(:(ifelse(1 <= 1, 2, 3)), ReverseAD.CONSTANT)
    _test_linearity(
        :(1 / ifelse($x < 1, $x, 0)),
        ReverseAD.NONLINEAR,
        Set([(1, 1)]),
        [1],
    )
    _test_linearity(
        :(($x + $y)/$z),
        ReverseAD.NONLINEAR,
        Set([(3, 3), (3, 2), (3, 1)]),
        [1, 2, 3],
    )
    return
end

function test_linearity_no_hess()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    ex = Nonlinear.add_expression(model, :($x + 1))
    Nonlinear.set_objective(model, ex)
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac])
    # We initialized without the need for the hessian so
    # the linearity shouldn't be computed.
    @test only(evaluator.backend.subexpressions).linearity ==
          ReverseAD.NONLINEAR
    return
end

function test_dual_forward()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    function _test_dual_forward(input, x_input, test_value)
        model = Nonlinear.Model()
        Nonlinear.set_objective(model, input)
        evaluator = Nonlinear.Evaluator(
            model,
            Nonlinear.SparseReverseMode(),
            MOI.VariableIndex[x, y],
        )
        MOI.initialize(evaluator, [:Grad])
        ∇f = fill(NaN, 2)
        MOI.eval_objective_gradient(evaluator, ∇f, x_input)
        @test isapprox(∇f, test_value, atol = 1e-10)
        return
    end
    _test_dual_forward(
        :(sin($x^2) + cos($y * 4) / 5 - 2.0),
        [1.0, 2.0],
        [1.0806046117362795, -0.7914865972987055],
    )
    _test_dual_forward(
        :(sin($x^$y) + cos($y * 4) / 5 - 2.0),
        [1.0, 2.0],
        [1.0806046117362795, -0.7914865972987055],
    )
    _test_dual_forward(
        :(sin($x^3) + cos($x * $y * 4) / 5 - 2.0),
        [1.0, 0.0],
        [1.6209069176044193, 0.0],
    )
    _test_dual_forward(
        :($x * $y),
        [3.427139283036299e-206, 1.0],
        [1.0, 3.427139283036299e-206],
    )
    return
end

function test_gradient_registered_function()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    model = Nonlinear.Model()
    f(x, y) = (1 / 3) * y^3 - 2x^2
    function ∇f(g, x, y)
        g[1] = -4x
        g[2] = y^2
        return
    end
    Nonlinear.register_operator(model, :Φ, 2, f, ∇f)
    Nonlinear.register_operator(model, :c, 1, cos, x -> -sin(x), x -> -cos(x))
    Nonlinear.set_objective(model, :(Φ($y, $x - 1) * c($z)))
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x, y, z],
    )
    MOI.initialize(evaluator, [:Grad])
    ∇f = fill(NaN, 3)
    x_input = [2.0, 3.0, 4.0]
    @test MOI.eval_objective(evaluator, x_input) == f(3.0, 2.0 - 1) * cos(4.0)
    MOI.eval_objective_gradient(evaluator, ∇f, [2.0, 3.0, 4.0])
    @test ∇f ≈ [
        cos(x_input[3]) * (x_input[1] - 1)^2,
        -4cos(x_input[3]) * x_input[2],
        -sin(x_input[3]) * f(x_input[2], x_input[1] - 1),
    ]
    return
end

function test_gradient_jump_855()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(
        model,
        :(ifelse($x <= 3.0, ($x - 2.0)^2, 2 * log($x - 2.0) + 1.0)),
    )
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x],
    )
    MOI.initialize(evaluator, [:Grad])
    ∇f = fill(NaN, 1)
    MOI.eval_objective_gradient(evaluator, ∇f, [-1.0])
    @test ∇f ≈ [-6.0]
    MOI.eval_objective_gradient(evaluator, ∇f, [2.0])
    @test ∇f ≈ [0.0]
    return
end

function test_gradient_abs()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(abs($x)))
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x],
    )
    MOI.initialize(evaluator, [:Grad])
    ∇f = fill(NaN, 1)
    MOI.eval_objective_gradient(evaluator, ∇f, [2.0])
    @test ∇f ≈ [1.0]
    MOI.eval_objective_gradient(evaluator, ∇f, [-2.0])
    @test ∇f ≈ [-1.0]
    return
end

function test_gradient_trig()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(sin($x^2) + cos($y * 4) / 5 - 2.0))
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x, y],
    )
    MOI.initialize(evaluator, [:Grad])
    ∇f = fill(NaN, 2)
    MOI.eval_objective_gradient(evaluator, ∇f, [2.0, 3.0])
    @test ∇f ≈ [2 * 2.0 * cos(2.0^2), -4 * sin(3.0 * 4) / 5]
    return
end

function test_gradient_logical()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :($x > 0.5 && $x < 0.9))
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x],
    )
    MOI.initialize(evaluator, [:Grad])
    @test MOI.eval_objective(evaluator, [1.5]) == 0.0
    ∇f = fill(NaN, 1)
    MOI.eval_objective_gradient(evaluator, ∇f, [1.5])
    @test iszero(∇f)
    return
end

function test_gradient_ifelse()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(ifelse($x >= 0.5 || $x < 0.1, $x, 5)))
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x],
    )
    MOI.initialize(evaluator, [:Grad])
    @test MOI.eval_objective(evaluator, [1.5]) == 1.5
    ∇f = fill(NaN, 1)
    MOI.eval_objective_gradient(evaluator, ∇f, [1.5])
    @test ∇f ≈ [1.0]
    @test MOI.eval_objective(evaluator, [-0.1]) == -0.1
    MOI.eval_objective_gradient(evaluator, ∇f, [-0.1])
    @test ∇f ≈ [1.0]
    @test MOI.eval_objective(evaluator, [0.2]) == 5
    MOI.eval_objective_gradient(evaluator, ∇f, [0.2])
    @test ∇f ≈ [0.0]
    return
end

function test_gradient_sqrt_nan()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(sqrt($x)))
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x],
    )
    MOI.initialize(evaluator, [:Grad])
    @test isnan(MOI.eval_objective(evaluator, [-1.5]))
    ∇f = fill(Inf, 1)
    MOI.eval_objective_gradient(evaluator, ∇f, [-1.5])
    @test isnan(∇f[1])
    return
end

function test_gradient_variable_power()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :((1 / $x)^$y - $z))
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x, y, z],
    )
    MOI.initialize(evaluator, [:Grad])
    x_input = [2.5, 3.5, 1.0]
    @test MOI.eval_objective(evaluator, x_input) == (1 / 2.5)^3.5 - 1.0
    ∇f = fill(Inf, 3)
    MOI.eval_objective_gradient(evaluator, ∇f, x_input)
    @test ∇f ≈ [
        -x_input[2] * x_input[1]^(-x_input[2] - 1),
        -((1 / x_input[1])^x_input[2]) * log(x_input[1]),
        -1,
    ]
    return
end

function test_single_parameter()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    p = Nonlinear.add_parameter(model, 105.2)
    Nonlinear.set_objective(model, :($p))
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x],
    )
    MOI.initialize(evaluator, [:Grad])
    @test MOI.eval_objective(evaluator, [-0.1]) == 105.2
    return
end

function test_gradient_nested_subexpressions()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    ex1 = Nonlinear.add_expression(model, :(sin($x^2) + cos($y * 4) / 5 - 2.0))
    ex2 = Nonlinear.add_expression(model, :($ex1))
    Nonlinear.set_objective(model, ex2)
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x, y],
    )
    MOI.initialize(evaluator, [:Grad])
    ∇f = fill(NaN, 2)
    MOI.eval_objective_gradient(evaluator, ∇f, [2.0, 3.0])
    @test ∇f ≈ [2 * 2.0 * cos(2.0^2), -4 * sin(3.0 * 4) / 5]
    return
end

function test_gradient_view()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(($x - 1)^2 + 4 * ($y - $x^2)^2))
    evaluator = Nonlinear.Evaluator(
        model,
        Nonlinear.SparseReverseMode(),
        MOI.VariableIndex[x, y],
    )
    MOI.initialize(evaluator, [:Grad])
    X_input = [0.0; 1.0; 2.0; 3.0]
    for idx in [1:2, 3:4, [1, 3], 4:-2:2]
        x_input = view(X_input, idx)
        x_vec = Vector(x_input)
        ∇f = fill(Inf, 2)
        ∇fv = fill(Inf, 2)
        MOI.eval_objective_gradient(evaluator, ∇f, x_input)
        MOI.eval_objective_gradient(evaluator, ∇fv, x_vec)
        @test ∇f == ∇fv
        ∇f = fill(Inf, 2)
        ∇fv = view(fill(Inf, 4), idx)
        MOI.eval_objective_gradient(evaluator, ∇f, x_input)
        MOI.eval_objective_gradient(evaluator, ∇fv, x_input)
        @test ∇f == ∇fv
    end
    return
end

function _dense_hessian(hessian_sparsity, V, n)
    I = [i for (i, _) in hessian_sparsity]
    J = [j for (_, j) in hessian_sparsity]
    raw = SparseArrays.sparse(I, J, V, n, n)
    return Matrix(
        raw + raw' -
        SparseArrays.sparse(LinearAlgebra.diagm(0 => LinearAlgebra.diag(raw))),
    )
end

# This covers the code that computes Hessians in odd chunks of Hess-vec
# products.
function test_odd_chunks_Hessian_products()
    for i in 1:18
        _test_odd_chunks_Hessian_products(i)
    end
    return
end

function _test_odd_chunks_Hessian_products(N)
    model = Nonlinear.Model()
    x = MOI.VariableIndex.(1:N)
    Nonlinear.set_objective(model, Expr(:call, :*, x...))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), x)
    MOI.initialize(evaluator, [:Hess])
    hessian_sparsity = MOI.hessian_lagrangian_structure(evaluator)
    V = zeros(length(hessian_sparsity))
    values = ones(N)
    MOI.eval_hessian_lagrangian(evaluator, V, values, 1.0, Float64[])
    H = _dense_hessian(hessian_sparsity, V, N)
    @test H ≈ (ones(N, N) - LinearAlgebra.diagm(0 => ones(N)))
    values[1] = 0.5
    MOI.eval_hessian_lagrangian(evaluator, V, values, 1.0, Float64[])
    H = _dense_hessian(hessian_sparsity, V, N)
    H_22 = (ones(N - 1, N - 1) - LinearAlgebra.diagm(0 => ones(N - 1))) / 2
    @test H ≈ [0 ones(N - 1)'; ones(N - 1) H_22]
    return
end

function _dense_jacobian(jacobian_sparsity, V, m, n)
    I = [i for (i, j) in jacobian_sparsity]
    J = [j for (i, j) in jacobian_sparsity]
    raw = SparseArrays.sparse(I, J, V, m, n)
    return Matrix(raw)
end

function test_jacobians_and_jacvec()
    model = Nonlinear.Model()
    x = MOI.VariableIndex.(1:3)
    a, b, c = x
    Nonlinear.set_objective(model, :($a * $b + $c^2))
    Nonlinear.add_constraint(model, :($c * $b), MOI.LessThan(1.0))
    Nonlinear.add_constraint(model, :($a^2 / 2), MOI.LessThan(1.0))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), x)
    MOI.initialize(evaluator, [:Jac, :JacVec])
    values = [1.0, 2.0, 3.0] # For a, b, c.
    jacobian_sparsity = MOI.jacobian_structure(evaluator)
    V = zeros(length(jacobian_sparsity))
    MOI.eval_constraint_jacobian(evaluator, V, values)
    correct_jacobian = [0.0 3.0 2.0; 1.0 0.0 0.0]
    @test _dense_jacobian(jacobian_sparsity, V, 2, 3) ≈ correct_jacobian
    v = [2.4, 3.5, 1.2]
    product_storage = zeros(2)
    MOI.eval_constraint_jacobian_product(evaluator, product_storage, values, v)
    @test product_storage ≈ correct_jacobian * v
    w = [0.6, 4.3]
    product_storage = zeros(3)
    MOI.eval_constraint_jacobian_transpose_product(
        evaluator,
        product_storage,
        values,
        w,
    )
    @test product_storage ≈ correct_jacobian' * w
    return
end

function test_jacobians_and_jacvec_with_subexpressions()
    model = Nonlinear.Model()
    x = MOI.VariableIndex.(1:3)
    a, b, c = x
    bc = Nonlinear.add_expression(model, :($b * $c))
    Nonlinear.set_objective(model, :($a * $b + $c^2))
    Nonlinear.add_constraint(model, :($bc), MOI.LessThan(1.0))
    Nonlinear.add_constraint(model, :($a^2 / 2), MOI.LessThan(1.0))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), x)
    MOI.initialize(evaluator, [:Jac, :JacVec])
    values = [1.0, 2.0, 3.0] # For a, b, c.
    jacobian_sparsity = MOI.jacobian_structure(evaluator)
    V = zeros(length(jacobian_sparsity))
    MOI.eval_constraint_jacobian(evaluator, V, values)
    correct_jacobian = [0.0 3.0 2.0; 1.0 0.0 0.0]
    @test _dense_jacobian(jacobian_sparsity, V, 2, 3) ≈ correct_jacobian
    v = [2.4, 3.5, 1.2]
    product_storage = zeros(2)
    MOI.eval_constraint_jacobian_product(evaluator, product_storage, values, v)
    @test product_storage ≈ correct_jacobian * v
    w = [0.6, 4.3]
    product_storage = zeros(3)
    MOI.eval_constraint_jacobian_transpose_product(
        evaluator,
        product_storage,
        values,
        w,
    )
    @test product_storage ≈ correct_jacobian' * w
    return
end

function test_pow_complex_result()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(ifelse($x > 0, $x^1.5, -(-$x)^1.5)))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    x = [-2.0]
    @test MOI.eval_objective(evaluator, x) ≈ -(2^1.5)
    g = [NaN]
    MOI.eval_objective_gradient(evaluator, g, x)
    @test g ≈ [1.5 * 2.0^0.5]
    @test MOI.hessian_lagrangian_structure(evaluator) == [(1, 1)]
    H = [NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, x, 1.5, Float64[])
    @test H ≈ 1.5 .* [-0.5 * 1.5 / sqrt(2.0)]
    return
end

function test_constraint_gradient()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = Nonlinear.Model()
    Nonlinear.add_constraint(model, :($x^2 + $x * $y + $y^2), MOI.LessThan(2.0))
    Nonlinear.add_constraint(model, :(cos($y)), MOI.LessThan(2.0))
    evaluator =
        Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x, y])
    MOI.initialize(evaluator, [:Grad, :Jac])
    @test MOI.constraint_gradient_structure(evaluator, 1) == [1, 2]
    @test MOI.constraint_gradient_structure(evaluator, 2) == [2]
    x_val = [1.2, 2.3]
    ∇g = [NaN, NaN]
    MOI.eval_constraint_gradient(evaluator, ∇g, x_val, 1)
    @test ∇g ≈ [2 * x_val[1] + x_val[2], x_val[1] + 2 * x_val[2]]
    x_val = [1.2, 2.3]
    ∇g = [NaN]
    MOI.eval_constraint_gradient(evaluator, ∇g, x_val, 2)
    @test ∇g ≈ [-sin(x_val[2])]
    return
end

function test_hessian_length()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(log($x)))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Hess])
    H = Float64[]
    got, want = 0, 1
    @test_throws(
        ErrorException(
            "Vector provided for Hessian storage has too few elements. Got " *
            "$got, want $want.",
        ),
        MOI.eval_hessian_lagrangian(evaluator, H, [1.0], 1.0, [1.0]),
    )
    return
end

function test_jacobian_length()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.add_constraint(model, :(sin($x)), MOI.LessThan(0.5))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Jac])
    J = Float64[]
    @test_throws BoundsError MOI.eval_constraint_jacobian(evaluator, J, [1.0])
    return
end

function test_timers()
    x = MOI.VariableIndex(1)
    model = Nonlinear.Model()
    Nonlinear.set_objective(model, :(log($x)))
    Nonlinear.add_constraint(model, :(sin($x)), MOI.LessThan(0.5))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    y = [1.2]
    g = [NaN]
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    MOI.eval_objective(evaluator, y)
    MOI.eval_constraint(evaluator, g, y)
    MOI.eval_objective_gradient(evaluator, g, y)
    MOI.eval_constraint_gradient(evaluator, g, y, 1)
    J = zeros(length(MOI.jacobian_structure(evaluator)))
    MOI.eval_constraint_jacobian(evaluator, J, y)
    H = zeros(length(MOI.hessian_objective_structure(evaluator)))
    MOI.eval_hessian_objective(evaluator, H, y)
    H = zeros(length(MOI.hessian_constraint_structure(evaluator, 1)))
    MOI.eval_hessian_constraint(evaluator, H, y, 1)
    H = zeros(length(MOI.hessian_lagrangian_structure(evaluator)))
    MOI.eval_hessian_lagrangian(evaluator, H, y, 1.0, [1.0])
    timers = [
        evaluator.initialize_timer,
        evaluator.eval_objective_timer,
        evaluator.eval_constraint_timer,
        evaluator.eval_objective_gradient_timer,
        evaluator.eval_constraint_gradient_timer,
        evaluator.eval_constraint_jacobian_timer,
        evaluator.eval_hessian_objective_timer,
        evaluator.eval_hessian_constraint_timer,
        evaluator.eval_hessian_lagrangian_timer,
    ]
    @test all(>=(0.0), timers)
    if !Sys.iswindows()
        # Windows times only in milliseconds, which can be too coarse to
        # accurately measure and test.
        @test sum(timers) > 0.0
    end
    return
end

function test_varying_length_x()
    model = MOI.Nonlinear.Model()
    x = MOI.VariableIndex(1)
    MOI.Nonlinear.set_objective(model, :(sin($x)))
    evaluator =
        MOI.Nonlinear.Evaluator(model, MOI.Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, Symbol[:Jac])
    ∇f = [NaN]
    MOI.eval_objective_gradient(evaluator, ∇f, [1.0, 2.0])
    @test length(∇f) == 1
    @test ∇f[1] ≈ cos(1.0)
    return
end

function test_univariate_operator_with_no_second_order()
    f(x::Float64) = x^2
    df(x::Float64) = 2 * x
    model = MOI.Nonlinear.Model()
    MOI.Nonlinear.register_operator(model, :op_f, 1, f, df)
    x = MOI.VariableIndex(1)
    MOI.Nonlinear.add_constraint(model, :(op_f($x)), MOI.LessThan(2.0))
    evaluator =
        MOI.Nonlinear.Evaluator(model, MOI.Nonlinear.SparseReverseMode(), [x])
    @test !(:Hess in MOI.features_available(evaluator))
    MOI.initialize(evaluator, [:Grad, :Jac])
    J = zeros(length(MOI.jacobian_structure(evaluator)))
    MOI.eval_constraint_jacobian(evaluator, J, [2.0])
    @test J == [4.0]
    return
end

function test_no_objective()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad])
    @test_throws(
        ErrorException("No nonlinear objective."),
        MOI.eval_objective(evaluator, [1.0]),
    )
    g = [0.0]
    @test_throws(
        ErrorException("No nonlinear objective."),
        MOI.eval_objective_gradient(evaluator, g, [1.0]),
    )
    return
end

function test_x_power_1()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    MOI.Nonlinear.set_objective(model, :($x^1))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Hess])
    @test MOI.eval_objective(evaluator, [2.0]) ≈ 2.0
    H = [NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, [2.0], 1.5, Float64[])
    @test H == [0.0]
    return
end

function test_variable_first_node_in_tape()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    expr = MOI.Nonlinear.add_expression(model, :($x))
    MOI.Nonlinear.set_objective(model, :(sin($expr)))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    H = [NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, [2.0], 1.5, [])
    @test H ≈ [-1.5 * sin(2.0)]
    return
end

function test_subexpression_first_node_in_tape()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    expr = MOI.Nonlinear.add_expression(model, :($x))
    expr2 = MOI.Nonlinear.add_expression(model, :($expr))
    MOI.Nonlinear.set_objective(model, :(sin($expr2)))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    H = [NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, [2.0], 1.5, [])
    @test H ≈ [-1.5 * sin(2.0)]
    return
end

function test_parameter_in_hessian()
    model = Nonlinear.Model()
    x = MOI.VariableIndex(1)
    p = MOI.Nonlinear.add_parameter(model, 3.0)
    MOI.Nonlinear.set_objective(model, :(sin($x + $p)))
    evaluator = Nonlinear.Evaluator(model, Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    H = [NaN]
    MOI.eval_hessian_lagrangian(evaluator, H, [2.0], 1.5, [])
    @test H ≈ [-1.5 * sin(2.0 + 3.0)]
    return
end

function test_unsafe_vector_view()
    x = Float64[]
    GC.@preserve x begin
        view = MOI.Nonlinear.ReverseAD._UnsafeVectorView(x, 3)
        @test length(x) == 3
        view[2] = 1.0
        @test x[2] == 1.0
    end
    return
end

function test_classify_linearity_ifelse()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = MOI.Nonlinear.Model()
    MOI.Nonlinear.set_objective(model, :(ifelse($y, $x, 1)))
    evaluator = MOI.Nonlinear.Evaluator(
        model,
        MOI.Nonlinear.SparseReverseMode(),
        [x, y],
    )
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.eval_objective(evaluator, [1.2, 1.0]) == 1.2
    @test MOI.eval_objective(evaluator, [1.2, 0.0]) == 1.0
    @test isempty(MOI.hessian_lagrangian_structure(evaluator))
    return
end

function test_classify_linearity_logic()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = MOI.Nonlinear.Model()
    MOI.Nonlinear.set_objective(model, :($x && $y))
    evaluator = MOI.Nonlinear.Evaluator(
        model,
        MOI.Nonlinear.SparseReverseMode(),
        [x, y],
    )
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    @test MOI.eval_objective(evaluator, [1.0, 1.0]) == 1.0
    @test MOI.eval_objective(evaluator, [0.0, 1.0]) == 0.0
    @test MOI.eval_objective(evaluator, [1.0, 0.0]) == 0.0
    @test MOI.eval_objective(evaluator, [0.0, 0.0]) == 0.0
    @test isempty(MOI.hessian_lagrangian_structure(evaluator))
    return
end

function test_hessian_sparsity_with_subexpressions()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    model = MOI.Nonlinear.Model()
    expr = MOI.Nonlinear.add_expression(model, :($x * $y))
    expr2 = MOI.Nonlinear.add_expression(model, :($expr))
    MOI.Nonlinear.set_objective(model, :(sin($expr2)))
    evaluator = MOI.Nonlinear.Evaluator(
        model,
        MOI.Nonlinear.SparseReverseMode(),
        [x, y],
    )
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    MOI.hessian_lagrangian_structure(evaluator)
    return
end

function test_toposort_subexpressions()
    x = MOI.VariableIndex(1)
    model = MOI.Nonlinear.Model()
    a = MOI.Nonlinear.add_expression(model, :($x))
    b = MOI.Nonlinear.add_expression(model, :($x))
    c = MOI.Nonlinear.add_expression(model, :($a + $b))
    d = MOI.Nonlinear.add_expression(model, :($c + $b))
    MOI.Nonlinear.add_constraint(model, :($d), MOI.LessThan(1.0))
    MOI.Nonlinear.add_constraint(model, :($c), MOI.LessThan(1.0))
    evaluator =
        MOI.Nonlinear.Evaluator(model, MOI.Nonlinear.SparseReverseMode(), [x])
    MOI.initialize(evaluator, [:Grad, :Jac, :Hess])
    g = [NaN, NaN]
    MOI.eval_constraint(evaluator, g, [2.0])
    @test g == [6.0, 4.0]
    return
end

function test_eval_user_defined_operator_ForwardDiff_gradient!()
    model = MOI.Nonlinear.Model()
    x = MOI.VariableIndex.(1:4)
    p = MOI.Nonlinear.add_parameter(model, 2.0)
    ex = MOI.Nonlinear.add_expression(model, :($p * $(x[1])))
    ψ(x) = sin(x)
    t(x, y) = x + 3y
    MOI.Nonlinear.register_operator(model, :ψ, 1, ψ)
    MOI.Nonlinear.register_operator(model, :t, 2, t)
    MOI.Nonlinear.add_constraint(
        model,
        :($ex^3 + sin($(x[2])) / ψ($(x[2])) + t($(x[3]), $(x[4]))),
        MOI.LessThan(0.0),
    )
    d = MOI.Nonlinear.Evaluator(model, MOI.Nonlinear.SparseReverseMode(), x)
    MOI.initialize(d, [:Jac])
    X = [1.1, 1.2, 1.3, 1.4]
    g = [NaN]
    MOI.eval_constraint(d, g, X)
    @test only(g) ≈ 17.148
    @test MOI.jacobian_structure(d) == [(1, 1), (1, 2), (1, 3), (1, 4)]
    J = [NaN, NaN, NaN, NaN]
    MOI.eval_constraint_jacobian(d, J, X)
    @test J ≈ [2.0^3 * 3.0 * 1.1^2, 0.0, 1.0, 3.0]
    return
end

function test_eval_user_defined_operator_type_mismatch()
    model = MOI.Nonlinear.Model()
    x = MOI.VariableIndex.(1:4)
    p = MOI.Nonlinear.add_parameter(model, 2.0)
    ex = MOI.Nonlinear.add_expression(model, :($p * $(x[1])))
    ψ(x) = sin(x)
    t(x, y) = x + 3y
    function ∇t(ret, x, y)
        ret[1] = 1      # These are intentionally the wrong type
        ret[2] = 3 // 1 # These are intentionally the wrong type
        return
    end
    MOI.Nonlinear.register_operator(model, :ψ, 1, ψ, cos)
    MOI.Nonlinear.register_operator(model, :t, 2, t, ∇t)
    MOI.Nonlinear.add_constraint(
        model,
        :($ex^3 + sin($(x[2])) / ψ($(x[2])) + t($(x[3]), $(x[4]))),
        MOI.LessThan(0.0),
    )
    d = MOI.Nonlinear.Evaluator(model, MOI.Nonlinear.SparseReverseMode(), x)
    MOI.initialize(d, [:Jac])
    X = [1.1, 1.2, 1.3, 1.4]
    g = [NaN]
    MOI.eval_constraint(d, g, X)
    @test only(g) ≈ 17.148
    @test MOI.jacobian_structure(d) == [(1, 1), (1, 2), (1, 3), (1, 4)]
    J = [NaN, NaN, NaN, NaN]
    MOI.eval_constraint_jacobian(d, J, X)
    @test J ≈ [2.0^3 * 3.0 * 1.1^2, 0.0, 1.0, 3.0]
    return
end

function test_generate_hessian_slice_inner()
    # Test that it evaluates without error. The code contents are tested
    # elsewhere.
    MOI.Nonlinear.ReverseAD._generate_hessian_slice_inner()
    d = ex = nothing  # These arguments are untyped and not needed for this test
    for id in [0, MOI.Nonlinear.ReverseAD.MAX_CHUNK + 1]
        @test_throws(
            ErrorException("Invalid chunk size: $id"),
            MOI.Nonlinear.ReverseAD._hessian_slice_inner(d, ex, id),
        )
    end
    return
end

function test_hessian_reinterpret_unsafe()
    model = MOI.Nonlinear.Model()
    x = MOI.VariableIndex.(1:5)
    MOI.Nonlinear.add_constraint(
        model,
        :(($(x[1]) + $(x[2])) * $(x[3])),
        MOI.EqualTo(0.0),
    )
    MOI.Nonlinear.add_constraint(model, :($(x[4]) * $(x[5])), MOI.EqualTo(1.0))
    evaluator =
        MOI.Nonlinear.Evaluator(model, MOI.Nonlinear.SparseReverseMode(), x)
    MOI.initialize(evaluator, [:Hess])
    H_s = MOI.hessian_lagrangian_structure(evaluator)
    H = zeros(length(H_s))
    x_v = ones(5)
    MOI.eval_hessian_lagrangian(evaluator, H, x_v, 0.0, [1.0, 1.0])
    @test count(isapprox.(H, 1.0; atol = 1e-8)) == 3
    @test count(isapprox.(H, 0.0; atol = 1e-8)) == 5
    @test sort(H_s[round.(Bool, H)]) == [(3, 1), (3, 2), (5, 4)]
    return
end

function test_IntDisjointSet()
    for case in [
        [(1, 2) => [1, 1, 3], (1, 3) => [1, 1, 1]],
        [(1, 2) => [1, 1, 3], (3, 1) => [1, 1, 1]],
        [(2, 1) => [2, 2, 3], (1, 3) => [2, 2, 2]],
        [(2, 1) => [2, 2, 3], (3, 1) => [3, 2, 3]],
        [(1, 3) => [1, 2, 1], (2, 3) => [1, 2, 2]],
        [(1, 3) => [1, 2, 1], (3, 2) => [1, 1, 1]],
        [(3, 1) => [3, 2, 3], (2, 3) => [3, 3, 3]],
        [(3, 1) => [3, 2, 3], (3, 2) => [3, 3, 3]],
        [(2, 3) => [1, 2, 2], (1, 3) => [1, 2, 1]],
        [(2, 3) => [1, 2, 2], (3, 1) => [2, 2, 2]],
        [(3, 2) => [1, 3, 3], (1, 3) => [3, 3, 3]],
        [(3, 2) => [1, 3, 3], (3, 1) => [3, 3, 3]],
    ]
        S = Coloring._IntDisjointSet(3)
        @test Coloring._find_root!.((S,), [1, 2, 3]) == [1, 2, 3]
        @test S.number_of_trees == 3
        for (i, (union, result)) in enumerate(case)
            Coloring._root_union!(S, union[1], union[2])
            @test Coloring._find_root!.((S,), [1, 2, 3]) == result
            @test S.number_of_trees == 3 - i
        end
    end
    return
end

function test_issue_2897()
    I = [4, 5, 4, 6, 5, 6]
    J = [2, 1, 1, 2, 3, 3]
    g = Coloring.UndirectedGraph(I, J, length(I))
    color, num_colors = Coloring.acyclic_coloring(g)
    @test color == [1, 1, 1, 2, 2, 3]
    @test num_colors == 3
    return
end

end  # module

TestReverseAD.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    FunctionConversionBridge{T,F,G} <: AbstractBridge

`FunctionConversionBridge` implements the following reformulations:

 * ``\\min \\{g(x)\\}`` into ``\\min\\{f(x)\\}``
 * ``\\max \\{g(x)\\}`` into ``\\max\\{f(x)\\}``

for these pairs of functions:

 * [`MOI.ScalarAffineFunction`](@ref) to [`MOI.ScalarQuadraticFunction`](@ref)
 * [`MOI.ScalarQuadraticFunction`](@ref)  to [`MOI.ScalarNonlinearFunction`](@ref)
 * [`MOI.VectorAffineFunction`](@ref) to [`MOI.VectorQuadraticFunction`](@ref)

## Source node

`FunctionConversionBridge` supports:

 * [`MOI.ObjectiveFunction{G}`](@ref)

## Target nodes

`FunctionConversionBridge` creates:

 * One objective node: [`MOI.ObjectiveFunction{F}`](@ref)
"""
struct FunctionConversionBridge{T,F,G} <: AbstractBridge end

function bridge_objective(
    ::Type{FunctionConversionBridge{T,F,G}},
    model::MOI.ModelLike,
    func::G,
) where {T,F,G<:MOI.AbstractFunction}
    MOI.set(model, MOI.ObjectiveFunction{F}(), convert(F, func))
    return FunctionConversionBridge{T,F,G}()
end

function supports_objective_function(
    ::Type{<:FunctionConversionBridge{T,F}},
    ::Type{G},
) where {T,F,G<:MOI.AbstractFunction}
    return MOI.Utilities.is_coefficient_type(G, T) &&
           isfinite(MOI.Bridges.Constraint.conversion_cost(F, G))
end

function MOI.Bridges.bridging_cost(
    ::Type{FunctionConversionBridge{T,F,G}},
) where {T,F,G}
    return MOI.Bridges.Constraint.conversion_cost(F, G)
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:FunctionConversionBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(::Type{<:FunctionConversionBridge})
    return Tuple{Type,Type}[]
end

function MOI.Bridges.set_objective_function_type(
    ::Type{<:FunctionConversionBridge{T,F}},
) where {T,F}
    return F
end

function concrete_bridge_type(
    ::Type{<:FunctionConversionBridge{T,F}},
    ::Type{G},
) where {T,F,G<:MOI.AbstractFunction}
    return FunctionConversionBridge{T,F,G}
end

# Attributes, Bridge acting as a model
MOI.get(::FunctionConversionBridge, ::MOI.NumberOfVariables)::Int64 = 0

function MOI.get(::FunctionConversionBridge, ::MOI.ListOfVariableIndices)
    return MOI.VariableIndex[]
end

# No variables or constraints are created in this bridge so there is nothing to
# delete.
MOI.delete(::MOI.ModelLike, ::FunctionConversionBridge) = nothing

function MOI.set(
    ::MOI.ModelLike,
    ::MOI.ObjectiveSense,
    ::FunctionConversionBridge,
    ::MOI.OptimizationSense,
)
    # `FunctionConversionBridge` is sense agnostic, therefore, we don't need to
    # change anything.
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.Bridges.ObjectiveFunctionValue{G},
    ::FunctionConversionBridge{T,F,G},
) where {T,F,G}
    attr_f = MOI.Bridges.ObjectiveFunctionValue{F}(attr.result_index)
    return MOI.get(model, attr_f)
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ObjectiveFunction{G},
    ::FunctionConversionBridge{T,F,G},
) where {T,F,G<:MOI.AbstractFunction}
    func = MOI.get(model, MOI.ObjectiveFunction{F}())
    return MOI.Utilities.convert_approx(G, func)
end

"""
    FunctionizeBridge{T,G} <: FunctionConversionBridge{T,MOI.ScalarAffineFunction{T},G}

`FunctionizeBridge` implements the following reformulations:

 * ``\\min \\{x\\}`` into ``\\min\\{1x + 0\\}``
 * ``\\max \\{x\\}`` into ``\\max\\{1x + 0\\}``

where `T` is the coefficient type of `1` and `0`.

## Source node

`FunctionizeBridge` supports:

 * [`MOI.ObjectiveFunction{G}`](@ref)

## Target nodes

`FunctionizeBridge` creates:

 * One objective node: [`MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}`](@ref)
"""
const FunctionizeBridge{T,G} =
    FunctionConversionBridge{T,MOI.ScalarAffineFunction{T},G}

const Functionize{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{FunctionizeBridge{T},OT}

"""
    QuadratizeBridge{T,G} <: FunctionConversionBridge{T,MOI.ScalarQuadraticFunction{T},G}

`QuadratizeBridge` implements the following reformulations:

 * ``\\min \\{a^\\top x + b\\}`` into ``\\min\\{x^\\top \\mathbf{0} x + a^\\top x + b\\}``
 * ``\\max \\{a^\\top x + b\\}`` into ``\\max\\{x^\\top \\mathbf{0} x + a^\\top x + b\\}``

where `T` is the coefficient type of `0`.

## Source node

`QuadratizeBridge` supports:

 * [`MOI.ObjectiveFunction{G}`](@ref)

## Target nodes

`QuadratizeBridge` creates:

 * One objective node: [`MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}`](@ref)
"""
const QuadratizeBridge{T,G} =
    FunctionConversionBridge{T,MOI.ScalarQuadraticFunction{T},G}

const Quadratize{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{QuadratizeBridge{T},OT}

"""
    ToScalarNonlinearBridge{T,G} <: FunctionConversionBridge{T,MOI.ScalarNonlinearFunction,G}

`ToScalarNonlinearBridge` implements the following reformulations:

 * ``\\min\\{x^\\top \\mathbf{𝑄} x + a^\\top x + b\\}`` into ``\\min\\{f(x)\\}``
 * ``\\max\\{x^\\top \\mathbf{𝑄} x + a^\\top x + b\\}`` into ``\\max\\{f(x)\\}``

where `f(x)` is a `MOI.ScalarNonlinearFunction`.

## Source node

`ToScalarNonlinearBridge` supports:

 * [`MOI.ObjectiveFunction{G}`](@ref)

## Target nodes

`ToScalarNonlinearBridge` creates:

 * One objective node: [`MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction}`](@ref)
"""
const ToScalarNonlinearBridge{T,G} =
    FunctionConversionBridge{T,MOI.ScalarNonlinearFunction,G}

const ToScalarNonlinear{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ToScalarNonlinearBridge{T},OT}

"""
    VectorFunctionizeBridge{T,G} <: FunctionConversionBridge{T,MOI.VectorAffineFunction{T},G}

`VectorFunctionizeBridge` implements the following reformulations:

 * ``\\min \\{x\\}`` into ``\\min\\{1x + 0\\}``
 * ``\\max \\{x\\}`` into ``\\max\\{1x + 0\\}``

where `T` is the coefficient type of `1` and `0`.

## Source node

`VectorFunctionizeBridge` supports:

 * [`MOI.ObjectiveFunction{G}`](@ref)

## Target nodes

`VectorFunctionizeBridge` creates:

 * One objective node: [`MOI.ObjectiveFunction{MOI.VectorAffineFunction{T}}`](@ref)
"""
const VectorFunctionizeBridge{T,G} =
    FunctionConversionBridge{T,MOI.VectorAffineFunction{T},G}

const VectorFunctionize{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{VectorFunctionizeBridge{T},OT}

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# !!! info "COV_EXCL_LINE"
#
#     The Julia coverage check is not perfect, particularly when it comes to
#     macros that produce code that is not executed. To work around
#     false-negatives, some lines in this file are excluded from coverage with
#     `# COV_EXCL_LINE`. (In most of the excluded cases, the default is for the
#     tests to pass, so the failure case of the testset macro is not executed,
#     and so no code is executed that can be tied back to the excluded lines.

module Bridges

import MathOptInterface as MOI
import OrderedCollections: OrderedDict
import Printf
import Test

include("bridge.jl")
include("set_map.jl")
include("bridge_optimizer.jl")

include("Variable/Variable.jl")
include("Constraint/Constraint.jl")
include("Objective/Objective.jl")

include("lazy_bridge_optimizer.jl")
include("debug.jl")

"""
    full_bridge_optimizer(model::MOI.ModelLike, ::Type{T}) where {T}

Returns a [`LazyBridgeOptimizer`](@ref) bridging `model` for every bridge
defined in this package (see below for the few exceptions) and for the
coefficient type `T`, as well as the bridges in the list returned by the
[`ListOfNonstandardBridges`](@ref) attribute.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> bridged_model = MOI.Bridges.full_bridge_optimizer(model, Float64);
```

## Exceptions

The following bridges are not added by `full_bridge_optimizer`, except if
they are in the list returned by the [`ListOfNonstandardBridges`](@ref) attribute:

 * [`Constraint.SOCtoNonConvexQuadBridge`](@ref)
 * `Constraint.RSOCtoNonConvexQuadBridge`](@ref)
 * [`Constraint.SOCtoPSDBridge`](@ref)
 * If `T` is not a subtype of `AbstractFloat`, subtypes of
   [`Constraint.AbstractToIntervalBridge`](@ref)
    * [`Constraint.GreaterToIntervalBridge`](@ref)
    * [`Constraint.LessToIntervalBridge`](@ref))

See the docstring of the each bridge for the reason they are not added.
"""
function full_bridge_optimizer(model::MOI.ModelLike, ::Type{T}) where {T}
    bridged_model = LazyBridgeOptimizer(model)
    for BT in MOI.get(model, ListOfNonstandardBridges{T}())
        add_bridge(bridged_model, BT)
    end
    Variable.add_all_bridges(bridged_model, T)
    Constraint.add_all_bridges(bridged_model, T)
    Objective.add_all_bridges(bridged_model, T)
    return bridged_model
end

"""
    ListOfNonstandardBridges{T}() <: MOI.AbstractOptimizerAttribute

Any optimizer can be wrapped in a [`LazyBridgeOptimizer`](@ref) using
[`full_bridge_optimizer`](@ref). However, by default [`LazyBridgeOptimizer`](@ref)
uses a limited set of bridges that are:

  1. implemented in `MOI.Bridges`
  2. generally applicable for all optimizers.

For some optimizers however, it is useful to add additional bridges, such as
those that are implemented in external packages (for example, within the solver package
itself) or only apply in certain circumstances (for example,
[`Constraint.SOCtoNonConvexQuadBridge`](@ref)).

Such optimizers should implement the `ListOfNonstandardBridges` attribute to
return a vector of bridge types that are added by [`full_bridge_optimizer`](@ref)
in addition to the list of default bridges.

Note that optimizers implementing `ListOfNonstandardBridges` may require
package-specific functions or sets to be used if the non-standard bridges
are not added. Therefore, you are recommended to use
`model = MOI.instantiate(Package.Optimizer; with_bridge_type = T)` instead of
`model = MOI.instantiate(Package.Optimizer)`. See
[`MOI.instantiate`](@ref).

## Example

### An optimizer using a non-default bridge in `MOI.Bridges`

Solvers supporting [`MOI.ScalarQuadraticFunction`](@ref) can support
[`MOI.SecondOrderCone`](@ref) and [`MOI.RotatedSecondOrderCone`](@ref) by
defining:
```julia
function MOI.get(::MyQuadraticOptimizer, ::ListOfNonstandardBridges{Float64})
    return Type[
        MOI.Bridges.Constraint.SOCtoNonConvexQuadBridge{Float64},
        MOI.Bridges.Constraint.RSOCtoNonConvexQuadBridge{Float64},
    ]
end
```

### An optimizer defining an internal bridge

Suppose an optimizer can exploit specific structure of a constraint, for example, it
can exploit the structure of the matrix `A` in the linear system of equations
`A * x = b`.

The optimizer can define the function:
```julia
struct MatrixAffineFunction{T} <: MOI.AbstractVectorFunction
    A::SomeStructuredMatrixType{T}
    b::Vector{T}
end
```
and then a bridge
```julia
struct MatrixAffineFunctionBridge{T} <: MOI.Constraint.AbstractBridge
    # ...
end
# ...
```
from `VectorAffineFunction{T}` to the `MatrixAffineFunction`. Finally, it
defines:
```julia
function MOI.get(::Optimizer{T}, ::ListOfNonstandardBridges{T}) where {T}
    return Type[MatrixAffineFunctionBridge{T}]
end
```
"""
struct ListOfNonstandardBridges{T} <: MOI.AbstractOptimizerAttribute end

# This should be Vector{Type}, but MOI <=v1.37.0 had a bug that meant this was
# not implemented. To maintain backwards compatibility, we make this `Vector`.
MOI.attribute_value_type(::ListOfNonstandardBridges) = Vector

MOI.is_copyable(::ListOfNonstandardBridges) = false

MOI.get_fallback(::MOI.ModelLike, ::ListOfNonstandardBridges) = Type[]

function _test_structural_identical(
    a::MOI.ModelLike,
    b::MOI.ModelLike;
    cannot_unbridge::Bool = false,
)
    # Test that the variables are the same. We make the strong assumption that
    # the variables are added in the same order to both models.
    a_x = MOI.get(a, MOI.ListOfVariableIndices())
    b_x = MOI.get(b, MOI.ListOfVariableIndices())
    Test.@testset "Test NumberOfVariables" begin                                # COV_EXCL_LINE
        Test.@test MOI.get(a, MOI.NumberOfVariables()) ==
                   MOI.get(b, MOI.NumberOfVariables())
    end
    Test.@testset "Test length ListOfVariableIndices" begin                     # COV_EXCL_LINE
        Test.@test length(a_x) == length(b_x)
    end
    # A dictionary that maps things from `b`-space to `a`-space.
    x_map = Dict(bx => a_x[i] for (i, bx) in enumerate(b_x))
    # To check that the constraints, we need to first cache all of the
    # constraints in `a`.
    constraints = Dict{Any,Any}()
    a_constraint_types = MOI.get(a, MOI.ListOfConstraintTypesPresent())
    b_constraint_types = MOI.get(b, MOI.ListOfConstraintTypesPresent())
    _name(F, S) = MOI.Utilities._drop_moi("$F-in-$S")
    Test.@testset "get $(_name(F, S))" for (F, S) in a_constraint_types
        Test.@test MOI.supports_constraint(a, F, S)
        constraints[(F, S)] =
            map(MOI.get(a, MOI.ListOfConstraintIndices{F,S}())) do ci
                return (
                    MOI.get(a, MOI.ConstraintFunction(), ci),
                    MOI.get(a, MOI.ConstraintSet(), ci),
                )
            end
        # There may be constraint types reported in `a` that are not in `b`, but
        # have zero constraints in `a`.
        Test.@test (F, S) in b_constraint_types ||
                   MOI.get(a, MOI.NumberOfConstraints{F,S}()) == 0
    end                                                                         # COV_EXCL_LINE
    Test.@testset "$(_name(F, S))" for (F, S) in b_constraint_types
        Test.@test haskey(constraints, (F, S))
        # Check that the same number of constraints are present
        Test.@test MOI.get(a, MOI.NumberOfConstraints{F,S}()) ==
                   MOI.get(b, MOI.NumberOfConstraints{F,S}())
        # Check that supports_constraint is implemented
        Test.@test MOI.supports_constraint(b, F, S)
        # Check that each function in `b` matches a function in `a`
        for ci in MOI.get(b, MOI.ListOfConstraintIndices{F,S}())
            f_b = try
                MOI.get(b, MOI.ConstraintFunction(), ci)
            catch err
                _runtests_error_handler(err, cannot_unbridge)
                continue
            end
            f_b = MOI.Utilities.map_indices(x_map, f_b)
            s_b = MOI.get(b, MOI.ConstraintSet(), ci)
            # We don't care about the order that constraints are added, only
            # that one matches.
            Test.@test any(constraints[(F, S)]) do (f, s)
                return s_b == s && isapprox(f, f_b) && typeof(f) == typeof(f_b)
            end
        end
    end                                                                         # COV_EXCL_LINE
    # Test model attributes are set, like ObjectiveSense and ObjectiveFunction.
    a_attrs = MOI.get(a, MOI.ListOfModelAttributesSet())
    b_attrs = MOI.get(b, MOI.ListOfModelAttributesSet())
    Test.@testset "Test length ListOfModelAttributesSet" begin                  # COV_EXCL_LINE
        Test.@test length(a_attrs) == length(b_attrs)
    end
    Test.@testset "$attr" for attr in b_attrs
        Test.@test attr in a_attrs
        if attr == MOI.ObjectiveSense()
            # map_indices isn't defined for `OptimizationSense`
            Test.@test MOI.get(a, attr) == MOI.get(b, attr)
        else
            attr_b = MOI.Utilities.map_indices(x_map, MOI.get(b, attr))
            Test.@test isapprox(MOI.get(a, attr), attr_b)
        end
    end                                                                         # COV_EXCL_LINE
    return
end

_runtests_error_handler(err, ::Bool) = rethrow(err)

function _runtests_error_handler(
    err::Union{
        MOI.GetAttributeNotAllowed{MOI.ConstraintFunction},
        MOI.GetAttributeNotAllowed{MOI.ConstraintPrimalStart},
    },
    cannot_unbridge::Bool,
)
    if cannot_unbridge
        return  # This error is expected. Do nothing.
    end
    return rethrow(err)
end

"""
    runtests(
        Bridge::Type{<:AbstractBridge},
        input_fn::Function,
        output_fn::Function;
        variable_start = 1.2,
        constraint_start = 1.2,
        eltype = Float64,
        cannot_unbridge::Bool = false,
    )

Run a series of tests that check the correctness of `Bridge`.

`input_fn` and `output_fn` are functions such that `input_fn(model)`
and `output_fn(model)` load the corresponding model into `model`.

Set `cannot_unbridge` to `true` if the bridge transformation is not invertible.
If `Bridge` is a variable bridge this allows [`Variable.unbridged_map`](@ref)
to returns `nothing` so that the tests allow errors that can be raised due to this.
If `Bridge` is a constraint bridge this allows the getter of [`MOI.ConstraintFunction`](@ref)
and [`MOI.ConstraintPrimalStart`](@ref) to throw [`MOI.GetAttributeNotAllowed`](@ref).

## Example

```jldoctest; filter=[r"[0-9.]+s", r"\\s+Time"]
julia> MOI.Bridges.runtests(
           MOI.Bridges.Constraint.ZeroOneBridge,
           model -> MOI.add_constrained_variable(model, MOI.ZeroOne()),
           model -> begin
               x, _ = MOI.add_constrained_variable(model, MOI.Integer())
               MOI.add_constraint(model, 1.0 * x, MOI.Interval(0.0, 1.0))
           end,
       )
Test Summary:    | Pass  Total  Time
Bridges.runtests |   32     32  0.8s
```
"""
function runtests(args...; kwargs...)
    Test.@testset "Bridges.runtests" begin
        _runtests(args...; kwargs...)
    end
    return
end

function _runtests(
    Bridge::Type{<:AbstractBridge},
    input_fn::Function,
    output_fn::Function;
    variable_start = 1.2,
    constraint_start = 1.2,
    eltype = Float64,
    model_eltype = eltype,
    print_inner_model::Bool = false,
    cannot_unbridge::Bool = false,
)
    # Load model and bridge it
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{model_eltype}())
    model = _bridged_model(Bridge{eltype}, inner)
    input_fn(model)
    final_touch(model)
    # Should be able to call final_touch multiple times.
    final_touch(model)
    if print_inner_model
        print(inner)
    end
    Test.@testset "Test outer bridged model appears like the input" begin       # COV_EXCL_LINE
        test =
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{model_eltype}())
        input_fn(test)
        _test_structural_identical(
            test,
            model;
            cannot_unbridge = cannot_unbridge,
        )
    end
    Test.@testset "Test inner bridged model appears like the target" begin      # COV_EXCL_LINE
        target =
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{model_eltype}())
        output_fn(target)
        _test_structural_identical(target, inner)
    end
    Test.@testset "Test MOI.VariablePrimalStart" begin                          # COV_EXCL_LINE
        attr = MOI.VariablePrimalStart()
        bridge_supported = all(values(Variable.bridges(model))) do bridge
            return MOI.supports(model, attr, typeof(bridge))
        end
        if MOI.supports(model, attr, MOI.VariableIndex) && bridge_supported
            x = MOI.get(model, MOI.ListOfVariableIndices())
            MOI.set(model, attr, x, fill(nothing, length(x)))
            Test.@test all(isnothing, MOI.get(model, attr, x))
            primal_start = fill(variable_start, length(x))
            MOI.set(model, attr, x, primal_start)
            if !isempty(x)
                # ≈ does not work if x is empty because the return of get is Any[]
                Test.@test MOI.get(model, attr, x) ≈ primal_start
            end
        end
    end
    Test.@testset "Test ConstraintPrimalStart and ConstraintDualStart" begin    # COV_EXCL_LINE
        list_of_constraints = MOI.get(model, MOI.ListOfConstraintTypesPresent())
        Test.@testset "$F-in-$S" for (F, S) in list_of_constraints
            for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
                set = try
                    MOI.get(model, MOI.ConstraintSet(), ci)
                catch err
                    _runtests_error_handler(err, cannot_unbridge)
                    continue
                end
                attrs = (MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart())
                Test.@testset "$attr" for attr in attrs
                    if !MOI.supports(model, attr, MOI.ConstraintIndex{F,S})
                        continue
                    end
                    MOI.set(model, attr, ci, nothing)
                    Test.@test MOI.get(model, attr, ci) === nothing
                    start = _fake_start(constraint_start, set)
                    MOI.set(model, attr, ci, start)
                    returned_start = try
                        MOI.get(model, attr, ci)
                    catch err
                        # For a Constraint bridge for which the map is not
                        # invertible, the constraint primal cannot be inverted
                        _runtests_error_handler(
                            err,
                            Bridge <: MOI.Bridges.Constraint.AbstractBridge &&
                                cannot_unbridge,
                        )
                        continue
                    end
                    Test.@test returned_start ≈ start
                end                                                             # COV_EXCL_LINE
            end
        end                                                                     # COV_EXCL_LINE
    end
    Test.@testset "Test general bridge tests" begin                             # COV_EXCL_LINE
        Test.@testset "Constraint" begin                                        # COV_EXCL_LINE
            for b in values(Constraint.bridges(model))
                _general_bridge_tests(something(b))
            end
        end
        Test.@testset "Objective" begin                                         # COV_EXCL_LINE
            for b in values(Objective.bridges(model))
                _general_bridge_tests(something(b))
            end
        end
        Test.@testset "Variable" begin                                          # COV_EXCL_LINE
            for b in values(Variable.bridges(model))
                _general_bridge_tests(something(b))
            end
        end
    end
    Test.@testset "Test delete" begin                                           # COV_EXCL_LINE
        _test_delete(Bridge, model, inner)
    end
    return
end

"""
    runtests(
        Bridge::Type{<:AbstractBridge},
        input::String,
        output::String;
        variable_start = 1.2,
        constraint_start = 1.2,
        eltype = Float64,
    )

Run a series of tests that check the correctness of `Bridge`.

`input` and `output` are models in the style of
[`MOI.Utilities.loadfromstring!`](@ref).

## Example

```jldoctest; filter=[r"[0-9.]+s", r"\\s+Time"]
julia> MOI.Bridges.runtests(
           MOI.Bridges.Constraint.ZeroOneBridge,
           \"\"\"
           variables: x
           x in ZeroOne()
           \"\"\",
           \"\"\"
           variables: x
           x in Integer()
           1.0 * x in Interval(0.0, 1.0)
           \"\"\",
       )
Test Summary:    | Pass  Total  Time
Bridges.runtests |   32     32  0.0s
```
"""
function runtests(
    Bridge::Type{<:AbstractBridge},
    input::String,
    output::String;
    kwargs...,
)
    runtests(
        Bridge,
        model -> MOI.Utilities.loadfromstring!(model, input),
        model -> MOI.Utilities.loadfromstring!(model, output);
        kwargs...,
    )
    return
end

_test_delete(::Type{<:Variable.AbstractBridge}, model, inner) = nothing

function _test_delete(Bridge, model, inner)
    # Test deletion of things in the bridge.
    #  * We reset the objective
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    #  * and delete all constraints
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        MOI.delete.(model, MOI.get(model, MOI.ListOfConstraintIndices{F,S}()))
    end
    #  * So now there should be no constraints in the problem
    Test.@test isempty(MOI.get(inner, MOI.ListOfConstraintTypesPresent()))
    #  * And there should be the same number of variables
    attr = MOI.NumberOfVariables()
    Test.@test MOI.get(inner, attr) == MOI.get(model, attr)
    return
end

_fake_start(value, ::MOI.AbstractScalarSet) = value

_fake_start(value, set::MOI.AbstractVectorSet) = fill(value, MOI.dimension(set))

_fake_start(value::AbstractVector, ::MOI.AbstractVectorSet) = value

function _bridged_model(Bridge::Type{<:Constraint.AbstractBridge}, inner)
    return Constraint.SingleBridgeOptimizer{Bridge}(inner)
end

function _bridged_model(Bridge::Type{<:Objective.AbstractBridge}, inner)
    return Objective.SingleBridgeOptimizer{Bridge}(inner)
end

function _bridged_model(Bridge::Type{<:Variable.AbstractBridge}, inner)
    return Variable.SingleBridgeOptimizer{Bridge}(inner)
end

function _general_bridge_tests(bridge::B) where {B<:AbstractBridge}
    Test.@test added_constrained_variable_types(B) isa Vector{Tuple{Type}}
    for (F, S) in added_constraint_types(B)
        Test.@test(
            length(MOI.get(bridge, MOI.ListOfConstraintIndices{F,S}())) ==
            MOI.get(bridge, MOI.NumberOfConstraints{F,S}())
        )
    end
    Test.@test(
        length(MOI.get(bridge, MOI.ListOfVariableIndices())) ==
        MOI.get(bridge, MOI.NumberOfVariables())
    )
    if MOI.get(bridge, MOI.NumberOfVariables()) > 0
        Test.@test !isempty(added_constrained_variable_types(B))
    end
    if B <: Objective.AbstractBridge
        Test.@test set_objective_function_type(B) <: MOI.AbstractFunction
    end
    return
end

"""
    BridgeRequiresFiniteDomainError{
        B<:AbstractBridge,
        F<:MOI.AbstractFunction,
    } <: Exception

An error thrown when the bridge requires the input function to have a finite
variable domain.
"""
struct BridgeRequiresFiniteDomainError{
    B<:AbstractBridge,
    F<:MOI.AbstractFunction,
} <: Exception
    bridge::B
    f::F
end

function Base.showerror(io::IO, err::BridgeRequiresFiniteDomainError)
    return print(
        io,
        """
        $(typeof(err)):

        There was an error reformulating your model into a form supported by the
        solver because one of the bridges requires that all variables have a
        finite domain.

        To fix this error, add a lower and upper bound to all variables in your
        model.

        If you have double checked that all variables have finite bounds and you
        are still encountering this issue, please open a GitHub issue at
        https://github.com/jump-dev/MathOptInterface.jl

        ## Common mistakes

        A common mistake is to add the variable bounds as affine constraints. For
        example, if you are using JuMP, do not use `@constraint` to add variable
        bounds:
        ```julia
        using JuMP
        model = Model()
        @variable(model, x)
        @constraint(model, x >= 0)
        @constraint(model, x <= 1)
        ```
        do instead:
        ```julia
        using JuMP
        model = Model()
        @variable(model, 0 <= x <= 1)
        ```

        ## Large bound values

        Do not add arbitrarily large variable bounds to fix this error. Doing so
        will likely result in a reformulation that takes a long time to build
        and solve. Use domain knowledge to find the tightest valid bounds.

        Alternatively, use a solver that has native support for the constraint
        types you are using so that you do not need to use the bridging system.
        """,
    )
end

end  # module Bridges

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SlackBridge{T,F,G}

`SlackBridge` implements the following reformulations:

 * ``\\min\\{f(x)\\}`` into ``\\min\\{y\\;|\\; f(x) - y \\le 0\\}``
 * ``\\max\\{f(x)\\}`` into ``\\max\\{y\\;|\\; f(x) - y \\ge 0\\}``

where `F` is the type of `f(x) - y`, `G` is the type of `f(x)`, and `T` is the
coefficient type of `f(x)`.

## Source node

`SlackBridge` supports:

 * [`MOI.ObjectiveFunction{G}`](@ref)

## Target nodes

`SlackBridge` creates:

 * One variable node: [`MOI.VariableIndex`](@ref) in [`MOI.Reals`](@ref)
 * One objective node: [`MOI.ObjectiveFunction{MOI.VariableIndex}`](@ref)
 * One constraint node, that depends on the [`MOI.ObjectiveSense`](@ref):
   * `F`-in-[`MOI.LessThan`](@ref) if `MIN_SENSE`
   * `F`-in-[`MOI.GreaterThan`](@ref) if `MAX_SENSE`

!!! warning
    When using this bridge, changing the optimization sense is not supported.
    Set the sense to `MOI.FEASIBILITY_SENSE` first to delete the bridge, then
    set [`MOI.ObjectiveSense`](@ref) and re-add the objective.
"""
struct SlackBridge{
    T,
    F<:MOI.AbstractScalarFunction,
    G<:MOI.AbstractScalarFunction,
} <: AbstractBridge
    slack::MOI.VariableIndex
    constraint::Union{
        MOI.ConstraintIndex{F,MOI.LessThan{T}},
        MOI.ConstraintIndex{F,MOI.GreaterThan{T}},
    }
    constant::T
end

const Slack{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{SlackBridge{T},OT}

function bridge_objective(
    ::Type{SlackBridge{T,F,G}},
    model::MOI.ModelLike,
    func::G,
) where {T,F,G<:MOI.AbstractScalarFunction}
    slack = MOI.add_variable(model)
    f = MOI.Utilities.operate(-, T, func, slack)
    sense = MOI.get(model, MOI.ObjectiveSense())
    if sense == MOI.FEASIBILITY_SENSE
        msg = "Set `MOI.ObjectiveSense` before `MOI.ObjectiveFunction` when using `MOI.Bridges.Objective.SlackBridge`."
        throw(MOI.SetAttributeNotAllowed(MOI.ObjectiveFunction{G}(), msg))
    end
    set = if sense == MOI.MIN_SENSE
        MOI.LessThan(zero(T))
    else
        @assert sense == MOI.MAX_SENSE
        MOI.GreaterThan(zero(T))
    end
    constraint = MOI.Utilities.normalize_and_add_constraint(model, f, set)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), slack)
    return SlackBridge{T,F,G}(slack, constraint, MOI.constant(f, T))
end

function supports_objective_function(
    ::Type{<:SlackBridge{T}},
    ::Type{MOI.VariableIndex},
) where {T}
    return false
end

function supports_objective_function(
    ::Type{<:SlackBridge{T}},
    ::Type{F},
) where {T,F<:MOI.AbstractScalarFunction}
    return MOI.Utilities.is_coefficient_type(F, T)
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:SlackBridge})
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:SlackBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[(F, MOI.GreaterThan{T}), (F, MOI.LessThan{T})]
end

function MOI.Bridges.set_objective_function_type(::Type{<:SlackBridge})
    return MOI.VariableIndex
end

function concrete_bridge_type(
    ::Type{<:SlackBridge{T}},
    G::Type{<:MOI.AbstractScalarFunction},
) where {T}
    F = MOI.Utilities.promote_operation(-, T, G, MOI.VariableIndex)
    return SlackBridge{T,F,G}
end

# Attributes, Bridge acting as a model
MOI.get(::SlackBridge, ::MOI.NumberOfVariables)::Int64 = 1

function MOI.get(bridge::SlackBridge, ::MOI.ListOfVariableIndices)
    return [bridge.slack]
end

function MOI.get(
    bridge::SlackBridge{T,F},
    ::MOI.NumberOfConstraints{F,S},
)::Int64 where {T,F,S<:Union{MOI.GreaterThan{T},MOI.LessThan{T}}}
    return bridge.constraint isa MOI.ConstraintIndex{F,S} ? 1 : 0
end

function MOI.get(
    bridge::SlackBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,S},
) where {T,F,S<:Union{MOI.GreaterThan{T},MOI.LessThan{T}}}
    if bridge.constraint isa MOI.ConstraintIndex{F,S}
        return [bridge.constraint]
    else
        return MOI.ConstraintIndex{F,S}[]
    end
end

function MOI.delete(model::MOI.ModelLike, bridge::SlackBridge)
    MOI.delete(model, bridge.constraint)
    MOI.delete(model, bridge.slack)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.Bridges.ObjectiveFunctionValue{G},
    bridge::SlackBridge{T,F,G},
) where {T,F,G}
    slack = MOI.get(
        model,
        MOI.Bridges.ObjectiveFunctionValue{MOI.VariableIndex}(
            attr.result_index,
        ),
    )
    # There may be a gap between the value of the original objective `g` and the
    # value of `bridge.slack`. Since `bridge.constraint` is `g - slack`, we can
    # get the value of the original objective by summing the value of `slack`
    # with the `ConstraintPrimal` of the constraint.
    obj_slack_constant = MOI.get(
        model,
        MOI.ConstraintPrimal(attr.result_index),
        bridge.constraint,
    )
    return obj_slack_constant + slack + bridge.constant
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ObjectiveFunction{G},
    bridge::SlackBridge{T,F,G},
) where {T,F,G<:MOI.AbstractScalarFunction}
    func = MOI.get(model, MOI.ConstraintFunction(), bridge.constraint)
    f = if !iszero(bridge.constant)
        MOI.Utilities.operate(+, T, func, bridge.constant)
    else
        func
    end
    g = MOI.Utilities.remove_variable(f, bridge.slack)
    return MOI.Utilities.convert_approx(G, g)
end

"""
    struct SlackBridgePrimalDualStart <: MOI.AbstractModelAttribute end

[`Bridges.Objective.SlackBridge`](@ref) introduces a new constraint into the
problem. However, because it is not a constraint bridge, it cannot intercept
calls to set [`ConstraintDualStart`](@ref) or [`ConstraintPrimalStart`](@ref).

As a work-around, set this attribute to `nothing` to set the primal and dual
start for the new constraint. This attribute must be set after
[`VariablePrimalStart`](@ref).
"""
struct SlackBridgePrimalDualStart <: MOI.AbstractModelAttribute end

function MOI.throw_set_error_fallback(
    ::MOI.ModelLike,
    ::SlackBridgePrimalDualStart,
    ::Nothing,
)
    return # Silently ignore if the model does not support.
end

# Pretend that every model supports, and silently skip in set if unsupported
MOI.supports_fallback(::MOI.ModelLike, ::SlackBridgePrimalDualStart) = true

function MOI.throw_set_error_fallback(
    ::MOI.ModelLike,
    ::SlackBridgePrimalDualStart,
    ::AbstractBridge,
    ::Nothing,
)
    return # Silently ignore for other bridges
end

function MOI.set(
    model::MOI.ModelLike,
    ::SlackBridgePrimalDualStart,
    b::SlackBridge{T},
    ::Nothing,
) where {T}
    # !!! note
    #     This attribute should silently skip if the `model` does not support it.
    #     For other attributes, we set `supports(...) = false`, but this would
    #     cause `copy_to` to throw an `UnsupportedAttributeError`, which we don't
    #     want. The solution is to check `supports(model, ...)` in this method,
    #     and bail if not supported.
    # ConstraintDual: if the objective function had a dual, it would be `-1` for
    # the Lagrangian function to be the same.
    if MOI.supports(model, MOI.ConstraintDualStart(), typeof(b.constraint))
        MOI.set(model, MOI.ConstraintDualStart(), b.constraint, -one(T))
    end
    # ConstraintPrimal: we should set the slack of f(x) - y to be 0, and the
    # start of y to be f(x).
    if !MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex) ||
       !MOI.supports(model, MOI.ConstraintPrimalStart(), typeof(b.constraint))
        return
    end
    MOI.set(model, MOI.VariablePrimalStart(), b.slack, zero(T))
    f = MOI.get(model, MOI.ConstraintFunction(), b.constraint)
    f_val = MOI.Utilities.eval_variables(model, f) do v
        return MOI.get(model, MOI.VariablePrimalStart(), v)
    end
    f_val -= MOI.constant(MOI.get(model, MOI.ConstraintSet(), b.constraint))
    MOI.set(model, MOI.VariablePrimalStart(), b.slack, f_val)
    MOI.set(model, MOI.ConstraintPrimalStart(), b.constraint, zero(T))
    return
end

function MOI.set(
    b::MOI.Bridges.AbstractBridgeOptimizer,
    attr::SlackBridgePrimalDualStart,
    ::Nothing,
)
    # TODO(odow): this might fail if the SlackBridge is not the first bridge in
    # the chain, but it should be for our current setup of bridges, so we
    # choose to simplify this implementation.
    if MOI.Bridges.is_objective_bridged(b)
        obj_attr = MOI.ObjectiveFunction{function_type(bridges(b))}()
        if MOI.Bridges.is_bridged(b, obj_attr)
            bridge = MOI.Bridges.bridge(b, obj_attr)
            MOI.set(MOI.Bridges.recursive_model(b), attr, bridge, nothing)
        end
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintNormOne

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_NormOne()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.NormOne{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariables_NormOneCone",
            "test_basic_VectorAffineFunction_NormOneCone",
            "test_basic_VectorQuadraticFunction_NormOneCone",
            "test_basic_VectorNonlinearFunction_NormOneCone",
        ],
    )
    return
end

function test_conic_NormOneCone_VectorOfVariables()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.NormOne{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 0.5, 0.5, 0.5, 0.5],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [[1.0, 1.0, 1.0, 0.0, 0.0]],
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) => [[-1], [0]],
        )
    MOI.Test.test_conic_NormOneCone_VectorOfVariables(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Test.test_conic_NormOneCone_VectorAffineFunction(bridged_mock, config)
    var_names = ["x", "y", "z"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    nonneg = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Nonnegatives,
        }(),
    )
    u, v = MOI.get(mock, MOI.ListOfVariableIndices())[4:5]
    MOI.set(mock, MOI.VariableName(), u, "u")
    MOI.set(mock, MOI.VariableName(), v, "v")
    @test length(nonneg) == 1
    MOI.set(mock, MOI.ConstraintName(), nonneg[1], "nonneg")
    zeros = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Zeros,
        }(),
    )
    @test length(zeros) == 2
    MOI.set(mock, MOI.ConstraintName(), zeros[1], "x_eq")
    MOI.set(mock, MOI.ConstraintName(), zeros[2], "y_eq")

    s = """
    variables: x, y, z, u, v
    nonneg: [x + -1.0u + -1.0v, u + -1.0y, v + -1.0z, u + y, v + z] in Nonnegatives(5)
    x_eq: [-1.0 + x] in Zeros(1)
    y_eq: [-0.5 + y] in Zeros(1)
    maxobjective: y + z
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        [var_names; "u"; "v"],
        ["nonneg", "x_eq", "y_eq"],
    )
    normone = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.NormOneCone,
        }(),
    )
    @test length(normone) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), normone[1], "normone")
    zeros = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Zeros,
        }(),
    )
    @test length(zeros) == 2
    MOI.set(bridged_mock, MOI.ConstraintName(), zeros[1], "x_eq")
    MOI.set(bridged_mock, MOI.ConstraintName(), zeros[2], "y_eq")

    s = """
    variables: x, y, z
    normone: [1.0x, y, z] in NormOneCone(3)
    x_eq: [-1.0 + x] in Zeros(1)
    y_eq: [-0.5 + y] in Zeros(1)
    maxobjective: y + z
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["normone", "x_eq", "y_eq"],
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.NormOneCone,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value = [4.0, 1.0, -2.0]
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
        if attr isa MOI.ConstraintPrimalStart
            @test MOI.get(mock, MOI.VariablePrimalStart(), u) == 1
            @test MOI.get(mock, MOI.VariablePrimalStart(), v) == 2
            @test MOI.get(mock, attr, nonneg[1]) == Float64[1, 0, 4, 2, 0]
        else
            @test MOI.get(mock, attr, nonneg[1]) == Float64[4, 0, 2, 1, 0]
        end
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        ((MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 0),),
    )
    return
end

function test_conic_NormOneCone()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.NormOne{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [4, -1, -1, -1, 1, 1, 1],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [vcat(ones(4), zeros(3)), ones(3)],
        )
    MOI.Test.test_conic_NormOneCone(bridged_mock, config)
    var_names = ["x", "y1", "y2", "y3"]
    var_names_all = vcat(var_names, "z1", "z2", "z3")
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names_all,
    )
    nonneg = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Nonnegatives,
        }(),
    )
    @test length(nonneg) == 2
    MOI.set(mock, MOI.ConstraintName(), nonneg[1], "nonneg1")
    MOI.set(mock, MOI.ConstraintName(), nonneg[2], "nonneg2")
    s = """
    variables: x, y1, y2, y3, z1, z2, z3
    nonneg1: [x + -1.0 + -1.0z1 + -1.0z2 + -1.0z3, z1 + -1.0y1 + -2.0, z2 + -1.0y2 + -2.0, z3 + -1.0y3 + -2.0, z1 + y1 + 2.0, z2 + y2 + 2.0, z3 + y3 + 2.0] in Nonnegatives(7)
    nonneg2: [y1 + 1.0, y2 + 1.0, y3 + 1.0] in Nonnegatives(3)
    minobjective: x
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        var_names_all,
        ["nonneg1", "nonneg2"],
    )
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    normone = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.NormOneCone,
        }(),
    )
    @test length(normone) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), normone[1], "normone")
    nonneg = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Nonnegatives,
        }(),
    )
    @test length(nonneg) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), nonneg[1], "nonneg")
    s = """
    variables: x, y1, y2, y3
    normone: [x + -1.0, y1 + 2.0, y2 + 2.0, y3 + 2.0] in NormOneCone(4)
    nonneg: [y1 + 1.0, y2 + 1.0, y3 + 1.0] in Nonnegatives(3)
    minobjective: x
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["normone", "nonneg"],
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.NormOneCone,
            }(),
        ),
    )
    nonneg = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Nonnegatives,
        }(),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value = (
            attr isa MOI.ConstraintPrimalStart ? vcat(3, ones(3)) :
            vcat(1, fill(-1, 3))
        )
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
        nonneg_value = (
            attr isa MOI.ConstraintPrimalStart ?
            vcat(zeros(4), fill(2.0, 3)) : vcat(ones(4), zeros(3))
        )
        @test MOI.get(mock, attr, nonneg[1]) ≈ nonneg_value
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        4,
        ((MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 1),),
    )
    return
end

function test_runtests_vector_of_variables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NormOneBridge,
        """
        variables: t, x
        [t, x] in NormOneCone(2)
        """,
        """
        variables: t, x, y
        [t + -1.0 * y, y + -1.0 * x, y + x] in Nonnegatives(3)
        """,
    )
    return
end

function test_runtests_vector_affine_function()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NormOneBridge,
        """
        variables: t, x
        [t, 2.0 * x + 1.0] in NormOneCone(2)
        """,
        """
        variables: t, x, y
        [t + -1.0 * y, y + -2.0 * x + -1.0, y + 2.0 * x + 1.0] in Nonnegatives(3)
        """,
    )
    return
end

function test_NormOne_VectorNonlinearFunction()
    # We can't use the standard runtests because ScalarNonlinearFunction does
    # not preserve f(x) ≈ (f(x) - g(x)) + g(x)
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.NormOne{Float64}(inner)
    t = MOI.add_variable(model)
    x = MOI.add_variable(model)
    f = MOI.VectorNonlinearFunction([
        MOI.ScalarNonlinearFunction(:+, Any[t]),
        MOI.ScalarNonlinearFunction(:sin, Any[x]),
    ])
    c = MOI.add_constraint(model, f, MOI.NormOneCone(2))
    F, S = MOI.VectorNonlinearFunction, MOI.Nonnegatives
    indices = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())
    @test length(indices) == 1
    inner_variables = MOI.get(inner, MOI.ListOfVariableIndices())
    @test length(inner_variables) == 3
    u, v, w = inner_variables
    v_sin = MOI.ScalarNonlinearFunction(:sin, Any[v])
    g = MOI.VectorNonlinearFunction([
        MOI.ScalarNonlinearFunction(
            :-,
            Any[MOI.ScalarNonlinearFunction(:+, Any[u]), 0.0+1.0*w],
        ),
        MOI.ScalarNonlinearFunction(
            :+,
            Any[MOI.ScalarNonlinearFunction(:-, Any[v_sin]), w],
        ),
        MOI.ScalarNonlinearFunction(:+, Any[v_sin, w]),
    ])
    @test ≈(MOI.get(inner, MOI.ConstraintFunction(), indices[1]), g)
    return
end

end  # module

TestConstraintNormOne.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Issue980

import MathOptInterface as MOI

abstract type StaticArray end
(::Type{SA})(x...) where {SA<:StaticArray} = SA(x)

function crash()
    model = MOI.Utilities.Model{Float64}()
    bridged = MOI.Bridges.LazyBridgeOptimizer(MOI.Utilities.Model{Float64}())
    return MOI.copy_to(bridged, model)
end

crash()

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    Map <: AbstractDict{MOI.VariableIndex, AbstractBridge}

Mapping between bridged variables and the bridge that bridged the variable.
"""
mutable struct Map <: AbstractDict{MOI.VariableIndex,AbstractBridge}
    # Bridged constrained variables
    # `i` ->  `0`: `VariableIndex(-i)` was added with `add_constrained_variable`.
    # `i` -> `-j`: `VariableIndex(-i)` was the first variable of
    #              `add_constrained_variables` with a
    #              `ConstraintIndex{MOI.VectorOfVariables}(-j)`.
    # `i` ->  `j`: `VariableIndex(-i)` was the `j`th  variable of
    #             ` add_constrained_variables`.
    info::Vector{Int64}
    # `i` ->  `-1`: `VariableIndex(-i)` was deleted.
    # `i` ->  `0`: `VariableIndex(-i)` was added with `add_constrained_variable`.
    # `i` ->  `j`: `VariableIndex(-i)` is the `j`th  variable of a constrained
    #               vector of variables, taking deletion into account.
    index_in_vector::Vector{Int64}
    # `i` -> `bridge`: `VariableIndex(-i)` was bridged by `bridge`.
    bridges::Vector{Union{Nothing,AbstractBridge}}
    sets::Vector{Union{Nothing,Type}}
    # If `nothing`, it cannot be computed because some bridges does not support it
    unbridged_function::Union{
        Nothing,
        Dict{MOI.VariableIndex,Tuple{Int64,MOI.AbstractScalarFunction}},
    }
    # Bridge that created this bridge, 0 if it is no bridge.
    parent_index::Vector{Int64}
    # Current bridge, 0 otherwise.
    current_context::Int64
    # Context of constraint bridged by constraint bridges
    constraint_context::Dict{MOI.ConstraintIndex,Int64}
    # `(ci::ConstraintIndex{MOI.VectorOfVariables}).value` ->
    # the first variable index
    # and `0` if it is the index of a constraint bridge
    vector_of_variables_map::Vector{Int64}
    # `(ci::ConstraintIndex{MOI.VectorOfVariables}).value` ->
    # the dimension of the set
    vector_of_variables_length::Vector{Int64}
    # Same as in `MOI.Utilities.VariablesContainer`
    set_mask::Vector{UInt16}
end

function Map()
    return Map(
        Int64[],
        Int64[],
        Union{Nothing,AbstractBridge}[],
        Union{Nothing,Type}[],
        Dict{MOI.VariableIndex,MOI.AbstractScalarFunction}(),
        Int64[],
        0,
        Dict{MOI.ConstraintIndex,Int64}(),
        Int64[],
        Int64[],
        UInt16[],
    )
end

# Implementation of `AbstractDict` interface.

Base.isempty(map::Map) = all(bridge -> bridge === nothing, map.bridges)

function Base.empty!(map::Map)
    empty!(map.info)
    empty!(map.index_in_vector)
    empty!(map.bridges)
    empty!(map.sets)
    if map.unbridged_function === nothing
        map.unbridged_function =
            Dict{MOI.VariableIndex,Tuple{Int64,MOI.AbstractScalarFunction}}()
    else
        empty!(something(map.unbridged_function))
    end
    empty!(map.parent_index)
    map.current_context = 0
    empty!(map.constraint_context)
    empty!(map.vector_of_variables_map)
    empty!(map.vector_of_variables_length)
    empty!(map.set_mask)
    return map
end

function bridge_index(map::Map, vi::MOI.VariableIndex)
    index = map.info[-vi.value]
    if index ≤ 0
        return -vi.value
    else
        return -vi.value - index + 1
    end
end

function Base.haskey(map::Map, vi::MOI.VariableIndex)
    return -length(map.bridges) ≤ vi.value ≤ -1 &&
           map.bridges[bridge_index(map, vi)] !== nothing &&
           map.index_in_vector[-vi.value] != -1
end

function Base.getindex(map::Map, vi::MOI.VariableIndex)
    return map.bridges[bridge_index(map, vi)]
end

function Base.delete!(map::Map, vi::MOI.VariableIndex)
    if iszero(map.info[-vi.value])
        # Delete scalar variable
        index = bridge_index(map, vi)
        map.bridges[index] = nothing
        map.sets[index] = nothing
    elseif has_keys(map, [vi])
        # Delete whole vector
        delete!(map, [vi])
    else
        # Delete variable in vector and resize vector
        map.vector_of_variables_length[-map.info[bridge_index(map, vi)]] -= 1
        for i in (-vi.value):length(map.index_in_vector)
            if map.index_in_vector[i] == -1
                continue
            elseif bridge_index(map, vi) !=
                   bridge_index(map, MOI.VariableIndex(-i))
                break
            end
            map.index_in_vector[i] -= 1
        end
    end
    map.set_mask[-vi.value] = MOI.Utilities._DELETED_VARIABLE
    map.index_in_vector[-vi.value] = -1
    return map
end

function Base.delete!(map::Map, vis::Vector{MOI.VariableIndex})
    if !has_keys(map, vis)
        throw(
            ArgumentError(
                "`$vis` is not a valid key vector as returned by `add_keys_for_bridge`.",
            ),
        )
    end
    for vi in vis
        map.set_mask[-vi.value] = MOI.Utilities._DELETED_VARIABLE
        map.index_in_vector[-vi.value] = -1
    end
    map.bridges[bridge_index(map, first(vis))] = nothing
    map.sets[bridge_index(map, first(vis))] = nothing
    return map
end

function Base.keys(map::Map)
    return Base.Iterators.Filter(
        vi -> haskey(map, vi),
        MOI.Utilities.lazy_map(
            MOI.VariableIndex,
            i -> MOI.VariableIndex(-i),
            eachindex(map.bridges),
        ),
    )
end

Base.length(map::Map) = count(bridge -> bridge !== nothing, map.bridges)

function number_of_variables(map::Map)
    num = 0
    for i in eachindex(map.bridges)
        if map.bridges[i] !== nothing
            if iszero(map.info[i])
                num += 1
            else
                num += length_of_vector_of_variables(map, MOI.VariableIndex(-i))
            end
        end
    end
    return num
end

function Base.values(map::Map)
    # We don't use `filter` as it would compute the resulting array which
    # is not necessary if the caller just wants to iterater over `values`.
    return Base.Iterators.Filter(bridge -> bridge !== nothing, map.bridges)
end

function Base.iterate(map::Map, state = 1)
    while state ≤ length(map.bridges) && map.bridges[state] === nothing
        state += 1
    end
    if state > length(map.bridges)
        return nothing
    else
        return MOI.VariableIndex(-state) => map.bridges[state], state + 1
    end
end

# Custom interface for information needed by `AbstractBridgeOptimizer`s that is
# not part of the `AbstractDict` interface.

"""
    constrained_set(map::Map, vi::MOI.VariableIndex)

Return the set type in which the bridged variable `vi` was added when it was
bridged.
"""
function constrained_set(map::Map, vi::MOI.VariableIndex)
    return map.sets[bridge_index(map, vi)]
end

"""
    number_with_set(map::Map, S::Type{<:MOI.AbstractSet})

Return the number of bridged variables in `S`. Note that if `S` is a vector set,
bridging a vector of `n` variables only counts as 1.
"""
function number_with_set(map::Map, S::Type{<:MOI.AbstractSet})
    return count(isequal(S), map.sets)
end

"""
    first_variable(::Map, ci::MOI.ConstraintIndex{MOI.VariableIndex})

Return the `MOI.VariableIndex` of the `MOI.ConstraintFunction` of `ci`.
"""
function first_variable(::Map, ci::MOI.ConstraintIndex{MOI.VariableIndex})
    return MOI.VariableIndex(ci.value)
end

"""
    first_variable(::Map, ci::MOI.ConstraintIndex{MOI.VariableIndex})

Return the first `MOI.VariableIndex` of the `MOI.ConstraintFunction` of `ci`.
"""
function first_variable(
    map::Map,
    ci::MOI.ConstraintIndex{MOI.VectorOfVariables},
)
    return MOI.VariableIndex(map.vector_of_variables_map[-ci.value])
end

function constraint(map::Map, vi::MOI.VariableIndex)
    S = constrained_set(map, vi)::Type{<:MOI.AbstractSet}
    F = MOI.Utilities.variable_function_type(S)
    index = bridge_index(map, vi)
    constraint_index = map.info[index]
    if iszero(constraint_index)
        constraint_index = -index
    end
    return MOI.ConstraintIndex{F,S}(constraint_index)
end

function MOI.is_valid(
    map::Map,
    ci::MOI.ConstraintIndex{MOI.VectorOfVariables,S},
) where {S}
    if !(-ci.value in eachindex(map.vector_of_variables_map))
        return false
    end
    index = -map.vector_of_variables_map[-ci.value]
    return index in eachindex(map.bridges) &&
           !isnothing(map.bridges[index]) &&
           map.sets[index] === S
end

function MOI.is_valid(
    map::Map,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S}
    index = -ci.value
    return index in eachindex(map.bridges) &&
           !isnothing(map.bridges[index]) &&
           map.sets[index] === S
end

"""
    MOI.add_constraint(map::Map, vi::MOI.VariableIndex, set::MOI.AbstractScalarSet)

Record that a constraint `vi`-in-`set` is added and throws if a lower or upper bound
is set by this constraint and such bound has already been set for `vi`.
"""
function MOI.add_constraint(::Map, ::MOI.VariableIndex, ::MOI.AbstractScalarSet)
    # Nothing to do as this is not recognized as setting a lower or upper bound
    return
end

# We cannot use `SUPPORTED_VARIABLE_SCALAR_SETS` because
# `Integer` and `ZeroOne` do not define `T` and we need `T`
# for `_throw_if_lower_bound_set`.
const _BOUNDED_VARIABLE_SCALAR_SETS{T} = Union{
    MOI.EqualTo{T},
    MOI.GreaterThan{T},
    MOI.LessThan{T},
    MOI.Interval{T},
    MOI.Semicontinuous{T},
    MOI.Semiinteger{T},
    MOI.Parameter{T},
}

function MOI.add_constraint(
    map::Map,
    vi::MOI.VariableIndex,
    ::S,
) where {T,S<:_BOUNDED_VARIABLE_SCALAR_SETS{T}}
    flag = MOI.Utilities._single_variable_flag(S)
    index = -vi.value
    mask = map.set_mask[index]
    MOI.Utilities._throw_if_lower_bound_set(vi, S, mask, T)
    MOI.Utilities._throw_if_upper_bound_set(vi, S, mask, T)
    map.set_mask[index] = mask | flag
    return
end

"""
    delete(map::Map, ci::MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet})

Record that the constraint `vi`-in-`S` is deleted.
"""
function MOI.delete(
    ::Map,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet},
)
    # Nothing to do as this is not recognized as setting a lower or upper bound
    return
end

function MOI.delete(
    map::Map,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {T,S<:_BOUNDED_VARIABLE_SCALAR_SETS{T}}
    flag = MOI.Utilities._single_variable_flag(S)
    map.set_mask[-ci.value] &= ~flag
    return
end

"""
    constraints_with_set(map::Map, S::Type{<:MOI.AbstractSet})

Return the list of constraints corresponding to bridged variables in `S`.
"""
function constraints_with_set(map::Map, S::Type{<:MOI.AbstractSet})
    F = MOI.Utilities.variable_function_type(S)
    return MOI.ConstraintIndex{F,S}[
        constraint(map, MOI.VariableIndex(-i)) for
        i in eachindex(map.sets) if map.sets[i] == S
    ]
end

"""
    list_of_constraint_types(map::Map)

Return a list of all the different types `(F, S)` of `F`-in-`S` constraints in
`map`.
"""
function list_of_constraint_types(map::Map)
    list = Set{Tuple{Type,Type}}()
    for i in eachindex(map.bridges)
        if map.bridges[i] === nothing
            continue
        end
        S = map.sets[i]
        if S === nothing || S == MOI.Reals
            continue
        end
        push!(list, (MOI.Utilities.variable_function_type(S), S))
    end
    return list
end

"""
    has_keys(map::Map, vis::Vector{MOI.VariableIndex})::Bool

Return a `Bool` indicating whether `vis` was returned by
[`add_keys_for_bridge`](@ref) and has not been deleted yet.
"""
function has_keys(map::Map, vis::Vector{MOI.VariableIndex})
    return isempty(vis) || (
        length_of_vector_of_variables(map, first(vis)) == length(vis) &&
        all(
            vi -> bridge_index(map, vi) == bridge_index(map, first(vis)),
            vis,
        ) &&
        all(vi -> haskey(map, vi), vis) &&
        all(i -> vis[i].value < vis[i-1].value, 2:length(vis))
    )
end

"""
    length_of_vector_of_variables(map::Map, vi::MOI.VariableIndex)

If `vi` was bridged in a scalar set, it returns 0. Otherwise, it
returns the dimension of the set.
"""
function length_of_vector_of_variables(map::Map, vi::MOI.VariableIndex)
    info = map.info[bridge_index(map, vi)]
    if iszero(info)
        return 0
    else
        return map.vector_of_variables_length[-info]
    end
end

"""
    index_in_vector_of_variables(
        map::Map,
        vi::MOI.VariableIndex,
    )::MOI.Bridges.IndexInVector

Return the index of `vi` in the vector of variables in which it was bridged.
"""
function index_in_vector_of_variables(map::Map, vi::MOI.VariableIndex)
    return MOI.Bridges.IndexInVector(map.index_in_vector[-vi.value])
end

"""
    has_bridges(map::Map)::Bool

Return a `Bool` indicating whether any bridge was added yet. Note that it
returns `false` even if all bridges were deleted while `isempty` would return
`true`. It is computed in `O(1)` while `isempty` needs `O(n)` hence it is used
by [`MOI.Bridges.AbstractBridgeOptimizer`](@ref) to shortcut
operations in case variable bridges are not used.
"""
has_bridges(map::Map) = !isempty(map.info)

"""
    add_key_for_bridge(map::Map, bridge_fun::Function,
                       set::MOI.AbstractScalarSet)

Create a new variable index `vi`, store the mapping `vi => bridge` and
associate `vi` to `typeof(set)`. It returns a tuple with `vi` and the
constraint index
`MOI.ConstraintIndex{MOI.VariableIndex, typeof(set)}(vi.value)`.
"""
function add_key_for_bridge(
    map::Map,
    bridge_fun::Function,
    set::MOI.AbstractScalarSet,
)
    push!(map.parent_index, map.current_context)
    bridge_index = Int64(length(map.parent_index))
    push!(map.info, 0)
    push!(map.index_in_vector, 0)
    push!(map.bridges, nothing)
    push!(map.sets, typeof(set))
    push!(map.set_mask, 0x0000)
    map.bridges[bridge_index] = call_in_context(map, bridge_index, bridge_fun)
    index = -bridge_index
    variable = MOI.VariableIndex(index)
    if map.unbridged_function !== nothing
        mappings = unbridged_map(something(map.bridges[bridge_index]), variable)
        if mappings === nothing
            map.unbridged_function = nothing
        else
            for mapping in mappings
                push!(
                    something(map.unbridged_function),
                    mapping.first => (bridge_index, mapping.second),
                )
            end
        end
    end
    MOI.add_constraint(map, variable, set)
    return variable, MOI.ConstraintIndex{MOI.VariableIndex,typeof(set)}(index)
end

"""
    function add_keys_for_bridge(
        map::Map,
        bridge_fun::Function,
        set::MOI.AbstractVectorSet,
        is_available::Function,
    )

Create vector of variable indices `variables`, stores the mapping
`vi => bridge` for each `vi ∈ variables` and associate `variables` to
`typeof(set)`. It returns a tuple with `variables` and a constraint index
`ci::MOI.ConstraintIndex{MOI.VectorOfVariables, typeof(set)}` such that
`is_available(ci)`.
"""
function add_keys_for_bridge(
    map::Map,
    bridge_fun::Function,
    set::S,
    is_available::Function,
) where {S<:MOI.AbstractVectorSet}
    if iszero(MOI.dimension(set))
        return MOI.VariableIndex[],
        MOI.ConstraintIndex{MOI.VectorOfVariables,typeof(set)}(0)
    end
    push!(map.parent_index, map.current_context)
    bridge_index = Int64(length(map.parent_index))
    F = MOI.VectorOfVariables
    while !is_available(
        MOI.ConstraintIndex{F,S}(-length(map.vector_of_variables_map) - 1),
    )
        push!(map.vector_of_variables_map, 0)
        push!(map.vector_of_variables_length, 0)
    end
    push!(map.vector_of_variables_map, -bridge_index)
    push!(map.vector_of_variables_length, MOI.dimension(set))
    constraint_index = -length(map.vector_of_variables_map)
    push!(map.info, constraint_index)
    push!(map.index_in_vector, 1)
    push!(map.bridges, nothing)
    push!(map.sets, typeof(set))
    push!(map.set_mask, 0x0000)
    for i in 2:MOI.dimension(set)
        push!(map.parent_index, 0)
        push!(map.info, i)
        push!(map.index_in_vector, i)
        push!(map.bridges, nothing)
        push!(map.sets, nothing)
        push!(map.set_mask, 0x0000)
    end
    map.bridges[bridge_index] = call_in_context(map, bridge_index, bridge_fun)
    variables = MOI.VariableIndex[
        MOI.VariableIndex(-(bridge_index - 1 + i)) for i in 1:MOI.dimension(set)
    ]
    if map.unbridged_function !== nothing
        mappings =
            unbridged_map(something(map.bridges[bridge_index]), variables)
        if mappings === nothing
            map.unbridged_function = nothing
        else
            for mapping in mappings
                push!(
                    something(map.unbridged_function),
                    mapping.first => (bridge_index, mapping.second),
                )
            end
        end
    end
    return variables, MOI.ConstraintIndex{F,S}(constraint_index)
end

"""
    function_for(map::Map, ci::MOI.ConstraintIndex{MOI.VariableIndex})

Return `vi` where `vi` is the bridged variable
corresponding to `ci`.
"""
function function_for(::Map, ci::MOI.ConstraintIndex{MOI.VariableIndex})
    return MOI.VariableIndex(ci.value)
end

"""
    function_for(map::Map, ci::MOI.ConstraintIndex{MOI.VectorOfVariables})

Return `MOI.VectorOfVariables(vis)` where `vis` is the vector of bridged
variables corresponding to `ci`.
"""
function function_for(map::Map, ci::MOI.ConstraintIndex{MOI.VectorOfVariables})
    index = map.vector_of_variables_map[-ci.value]
    variables = MOI.VariableIndex[]
    for i in index:-1:(-length(map.bridges))
        vi = MOI.VariableIndex(i)
        if map.index_in_vector[-vi.value] == -1
            continue
        elseif bridge_index(map, vi) == -index
            push!(variables, vi)
        else
            break
        end
    end
    return MOI.VectorOfVariables(variables)
end

"""
    throw_if_cannot_unbridge(map::Map)

Throw an error if some bridged variables do not have any reverse mapping.
"""
function throw_if_cannot_unbridge(map::Map)
    if map.unbridged_function === nothing
        err = MOI.GetAttributeNotAllowed(
            MOI.ConstraintFunction(),
            "Cannot unbridge function because some variables are bridged by " *
            "variable bridges that do not support reverse mapping, for " *
            "example, `ZerosBridge`.",
        )
        throw(err)
    end
end

"""
    unbridged_function(map::Map, vi::MOI.VariableIndex)

Return the expression of `vi` in terms of bridged variables.
"""
function unbridged_function(map::Map, vi::MOI.VariableIndex)
    throw_if_cannot_unbridge(map)
    context_func = get(something(map.unbridged_function), vi, nothing)
    if context_func === nothing
        return nothing
    end
    bridge_index, func = context_func
    # If the bridge bridging `vi` has index `bridge_index` or directly or
    # indirectly created this bridge then we don't unbridge the variable.
    context = map.current_context
    while !iszero(context)
        if bridge_index == context
            return nothing
        end
        context = map.parent_index[context]
    end
    return func
end

"""
    call_in_context(map::Map, bridge_index::Int64, f::Function)

Call function `f` in the context of the variable bridge of index `bridge_index`.
That is, the variable indices bridged by this bridge or the bridges that
created it will not be unbridged in [`unbridged_function`](@ref).
"""
function call_in_context(map::Map, bridge_index::Int64, f::Function)
    # This is a shortcut that is used in particular in the common case where
    # no variable bridge is used.
    if iszero(bridge_index) && iszero(map.current_context)
        return f()
    end
    previous_context = map.current_context
    map.current_context = bridge_index
    output = nothing
    try
        output = f()
    finally
        map.current_context = previous_context
    end
    return output
end

"""
    call_in_context(map::Map, vi::MOI.VariableIndex, f::Function)

Shortcut for `call_in_context(map, bridge_index, () -> f(bridge))` where
`vi` is bridged by `bridge` with index `bridge_index`.
"""
function call_in_context(map::Map, vi::MOI.VariableIndex, f::Function)
    idx = bridge_index(map, vi)
    return call_in_context(map, idx, () -> f(map.bridges[idx]))
end

"""
    call_in_context(map::Map, ci::MOI.ConstraintIndex, f::Function)

Shortcut for `call_in_context(map, bridge_index, f)` where `bridge_index` is the
variable bridge that created `ci` (directly or indirectly) or 0 otherwise.
"""
function call_in_context(map::Map, ci::MOI.ConstraintIndex, f::Function)
    return call_in_context(map, get(map.constraint_context, ci, Int64(0)), f)
end

"""
    register_context(map::Map, ci::MOI.ConstraintIndex)

Register the current context as the variable bridge that created `ci` (directly
or indirectly) or 0 otherwise.
"""
function register_context(map::Map, ci::MOI.ConstraintIndex)
    if !iszero(map.current_context)
        # By only storing non-zero values, we avoid any dictionary access for
        # constraint not created (directly or indirectly) by variable bridges.
        # This ensures that there is no performance hit of the bridge layer when
        # no variable bridge is used.
        map.constraint_context[ci] = map.current_context
    end
    return
end

"""
    EmptyMap <: AbstractDict{MOI.VariableIndex, AbstractBridge}

Empty version of [`Map`](@ref). It is used by
[`MOI.Bridges.Constraint.SingleBridgeOptimizer`](@ref) as it does
not bridge any variable.
"""
struct EmptyMap <: AbstractDict{MOI.VariableIndex,AbstractBridge} end

Base.show(::IO, ::EmptyMap) = nothing

Base.isempty(::EmptyMap) = true

function Base.empty!(::EmptyMap) end

Base.length(::EmptyMap) = 0

Base.keys(::EmptyMap) = MOI.Utilities.EmptyVector{MOI.VariableIndex}()

Base.values(::EmptyMap) = MOI.Utilities.EmptyVector{AbstractBridge}()

Base.iterate(::EmptyMap) = nothing

has_bridges(::EmptyMap) = false

number_of_variables(::EmptyMap) = 0

number_with_set(::EmptyMap, ::Type{<:MOI.AbstractSet}) = 0

function constraints_with_set(::EmptyMap, S::Type{<:MOI.AbstractSet})
    return MOI.ConstraintIndex{MOI.Utilities.variable_function_type(S),S}[]
end

register_context(::EmptyMap, ::MOI.ConstraintIndex) = nothing

call_in_context(::EmptyMap, ::MOI.ConstraintIndex, f::Function) = f()

MOI.is_valid(::EmptyMap, ::MOI.ConstraintIndex) = false

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    _UnsafeVectorView(offset, len, ptr)

Lightweight unsafe view for vectors.

## Motivation

`_UnsafeVectorView` is needed as an allocation-free equivalent of `view`. Other
alternatives, like `view(x, 1:len)` or a struct like
```
struct _SafeView{T}
    x::Vector{T}
    len::Int
end
```
will allocate so that `x` can be tracked by Julia's GC.

`_UnsafeVectorView` relies on the fact that the use-cases of `_UnsafeVectorView`
only temporarily wrap a long-lived vector like `d.jac_storage` so that we don't
have to worry about the GC removing `d.jac_storage` while `_UnsafeVectorView`
exists. This lets us use a `Ptr{T}` and create a struct that is `isbitstype` and
therefore does not allocate.

## Example

Instead of `view(x, 1:10)`, use `_UnsafeVectorView(0, 10, pointer(x))`.

## Unsafe behavior

`_UnsafeVectorView` is unsafe because it assumes that the vector `x` that the
pointer `ptr` refers to remains valid during the usage of `_UnsafeVectorView`.
"""
struct _UnsafeVectorView{T} <: DenseVector{T}
    offset::Int
    len::Int
    ptr::Ptr{T}
end

function Base.getindex(x::_UnsafeVectorView, i::Integer)
    return unsafe_load(x.ptr, i + x.offset)
end

Base.getindex(x::_UnsafeVectorView, i::CartesianIndex{1}) = getindex(x, i[1])

function Base.setindex!(x::_UnsafeVectorView, value, i::Integer)
    # We don't need to worry about `value` being the right type here because
    # x.ptr is a `::Ptr{T}`, so even though it is called `unsafe_store!`, there
    # is still a type convertion that happens so that we're not just chucking
    # the bits of value into `x.ptr`.
    unsafe_store!(x.ptr, value, i + x.offset)
    return value
end

function Base.setindex!(x::_UnsafeVectorView, value, i::CartesianIndex{1})
    return setindex!(x, value, i[1])
end

Base.length(v::_UnsafeVectorView) = v.len

Base.size(v::_UnsafeVectorView) = (v.len,)

"""
    _UnsafeVectorView(x::Vector, N::Int)

Create a new [`_UnsafeVectorView`](@ref) from `x`, and resize `x` if needed to
ensure it has a length of at least `N`.

## Unsafe behavior

In addition to the usafe behavior of `_UnsafeVectorView`, this constructor is
additionally unsafe because it may resize `x`. Only call it if you are sure that
the usage of `_UnsafeVectorView(x, N)` is short-lived, and that there are no
other views to `x` while the returned value is within scope.
"""
function _UnsafeVectorView(x::Vector, N::Int)
    if length(x) < N
        resize!(x, N)
    end
    return _UnsafeVectorView(0, N, pointer(x))
end

"""
    _UnsafeLowerTriangularMatrixView(x, N)

Lightweight unsafe view that converts a vector `x` into the lower-triangular
component of a symmetric `N`-by-`N` matrix.

## Motivation

`_UnsafeLowerTriangularMatrixView` is needed as an allocation-free equivalent of
`view`. Other alternatives, like `reshape(view(x, 1:N^2), N, N)` or a struct
like
```julia
struct _SafeView{T}
    x::Vector{T}
    len::Int
end
```
will allocate so that `x` can be tracked by Julia's GC.
`_UnsafeLowerTriangularMatrixView` relies on the fact that the use-cases of
`_UnsafeLowerTriangularMatrixView` only temporarily wrap a long-lived vector
like `d.jac_storage` so that we don't have to worry about the GC removing
`d.jac_storage` while `_UnsafeLowerTriangularMatrixView` exists. This lets us
use a `Ptr{T}` and create a struct that is `isbitstype` and therefore does not
allocate.

## Unsafe behavior

`_UnsafeLowerTriangularMatrixView` is unsafe because it assumes that the vector
`x` remains valid during the usage of `_UnsafeLowerTriangularMatrixView`.
"""
struct _UnsafeLowerTriangularMatrixView <: AbstractMatrix{Float64}
    N::Int
    ptr::Ptr{Float64}
end

Base.size(x::_UnsafeLowerTriangularMatrixView) = (x.N, x.N)

function _linear_index(row, col)
    if row < col
        error("Unable to access upper-triangular component: ($row, $col)")
    end
    return div((row - 1) * row, 2) + col
end

function Base.getindex(x::_UnsafeLowerTriangularMatrixView, i, j)
    return unsafe_load(x.ptr, _linear_index(i, j))
end

function Base.setindex!(x::_UnsafeLowerTriangularMatrixView, value, i, j)
    unsafe_store!(x.ptr, value, _linear_index(i, j))
    return value
end

"""
    _UnsafeLowerTriangularMatrixView(x::Vector{Float64}, N::Int)

Create a new [`_UnsafeLowerTriangularMatrixView`](@ref) from `x`, zero the
elements in `x`, and resize `x` if needed to ensure it has a length of at least
`N * (N + 1) / 2`.

## Unsafe behavior

In addition to the usafe behavior of `_UnsafeLowerTriangularMatrixView`, this
constructor is additionally unsafe because it may resize `x`. Only call it if
you are sure that the usage of `_UnsafeLowerTriangularMatrixView(x, N)` is
short-lived, and that there are no other views to `x` while the returned value
is within scope.
"""
function _UnsafeLowerTriangularMatrixView(x::Vector{Float64}, N::Int)
    z = div(N * (N + 1), 2)
    if length(x) < z
        resize!(x, z)
    end
    for i in 1:z
        x[i] = 0.0
    end
    return _UnsafeLowerTriangularMatrixView(N, pointer(x))
end

"""
    _reinterpret_unsafe(::Type{T}, x::Vector{R}) where {T,R}

Return an `_UnsafeVectorView` that act as a vector of element type
`T` over the same bytes as `x`. Note that if `length(x) * sizeof(R)` is not
a multiple of `sizeof(T)`, the last bits will be ignored. This is a key
difference with `reinterpret` which errors in that case.

Given a vector of `Float64` of length equal to the maximum number of nodes of a
set of expressions time the maximum chunk size, this function is used to
reinterpret it as a vector of `ForwardDiff.Partials{N,T}` where `N` is the
chunk size of one of the expressions of the set. In that case, we know that
the vector has enough bytes and we don't care about the leftover bytes at the
end.

## Examples

```jldoctest
julia> x = [(1, 2, 3), (4, 5, 6), (7, 8, 9)]
3-element Vector{Tuple{Int64, Int64, Int64}}:
 (1, 2, 3)
 (4, 5, 6)
 (7, 8, 9)

julia> MOI.Nonlinear.ReverseAD._reinterpret_unsafe(NTuple{2,Int}, x)
4-element MathOptInterface.Nonlinear.ReverseAD._UnsafeVectorView{Tuple{Int64, Int64}}:
 (1, 2)
 (3, 4)
 (5, 6)
 (7, 8)
```
"""
function _reinterpret_unsafe(::Type{T}, x::Vector{R}) where {T,R}
    @assert isbitstype(T) && isbitstype(R)
    # how many T's fit into x?
    len = length(x) * sizeof(R)
    p = reinterpret(Ptr{T}, pointer(x))
    return _UnsafeVectorView(0, div(len, sizeof(T)), p)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintCircuit

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CircuitToMILPBridge,
        """
        variables: x_bin, x_int, a, b, c
        [a, b, c] in Circuit(3)
        x_bin in ZeroOne()
        x_int in Integer()
        """,
        """
        variables: x_bin, x_int, a, b, c, z11, z21, z31, z12, z22, z32, z13, z23, z33, u2, u3
        1.0 * a + -2.0 * z12 + -3.0 * z13 == 0.0
        1.0 * b + -1.0 * z21 + -3.0 * z23 == 0.0
        1.0 * c + -1.0 * z31 + -2.0 * z32 == 0.0
        z12 + z13 == 1.0
        z21 + z23 == 1.0
        z31 + z32 == 1.0
        z21 + z31 == 1.0
        z12 + z32 == 1.0
        z13 + z23 == 1.0
        1.0 * u2 + -1.0 * u3 + 2.0 * z23 <= 1.0
        1.0 * u3 + -1.0 * u2 + 2.0 * z32 <= 1.0
        z11 in ZeroOne()
        z12 in ZeroOne()
        z13 in ZeroOne()
        z21 in ZeroOne()
        z22 in ZeroOne()
        z23 in ZeroOne()
        z31 in ZeroOne()
        z32 in ZeroOne()
        z33 in ZeroOne()
        u2 in Integer()
        u3 in Integer()
        u2 in Interval(1.0, 2.0)
        u3 in Interval(1.0, 2.0)
        x_bin in ZeroOne()
        x_int in Integer()
        """,
    )
    return
end

function test_runtests_VectorAffineFunction()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CircuitToMILPBridge,
        """
        variables: b, c
        [2.0, b, c] in Circuit(3)
        """,
        """
        variables: b, c, z11, z21, z31, z12, z22, z32, z13, z23, z33, u2, u3
        -2.0 * z12 + -3.0 * z13 == -2.0
        1.0 * b + -1.0 * z21 + -3.0 * z23 == 0.0
        1.0 * c + -1.0 * z31 + -2.0 * z32 == 0.0
        z12 + z13 == 1.0
        z21 + z23 == 1.0
        z31 + z32 == 1.0
        z21 + z31 == 1.0
        z12 + z32 == 1.0
        z13 + z23 == 1.0
        1.0 * u2 + -1.0 * u3 + 2.0 * z23 <= 1.0
        1.0 * u3 + -1.0 * u2 + 2.0 * z32 <= 1.0
        z11 in ZeroOne()
        z12 in ZeroOne()
        z13 in ZeroOne()
        z21 in ZeroOne()
        z22 in ZeroOne()
        z23 in ZeroOne()
        z31 in ZeroOne()
        z32 in ZeroOne()
        z33 in ZeroOne()
        u2 in Integer()
        u3 in Integer()
        u2 in Interval(1.0, 2.0)
        u3 in Interval(1.0, 2.0)
        """,
    )
    return
end

end  # module

TestConstraintCircuit.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    VectorizeBridge{T,F,S,G} <: Bridges.Constraint.AbstractBridge

`VectorizeBridge` implements the following reformulations:

  * ``g(x) \\ge a`` into ``[g(x) - a] \\in \\mathbb{R}_+``
  * ``g(x) \\le a`` into ``[g(x) - a] \\in \\mathbb{R}_-``
  * ``g(x) == a`` into ``[g(x) - a] \\in \\{0\\}``

where `T` is the coefficient type of `g(x) - a`.

See also [`IntervalToHyperRectangleBridge`](@ref) for double-sided bound
constraints.

## Source node

`VectorizeBridge` supports:

  * `G` in [`MOI.GreaterThan{T}`](@ref)
  * `G` in [`MOI.LessThan{T}`](@ref)
  * `G` in [`MOI.EqualTo{T}`](@ref)

## Target nodes

`VectorizeBridge` creates:

  * `F` in `S`, where `S` is one of [`MOI.Nonnegatives`](@ref),
    [`MOI.Nonpositives`](@ref), [`MOI.Zeros`](@ref) depending on the type of the
    input set.
"""
mutable struct VectorizeBridge{T,F,S,G} <: AbstractBridge
    vector_constraint::MOI.ConstraintIndex{F,S}
    set_constant::T # constant in scalar set
end

const Vectorize{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{VectorizeBridge{T},OT}

function bridge_constraint(
    ::Type{VectorizeBridge{T,F,S,G}},
    model::MOI.ModelLike,
    scalar_f::G,
    set::MOI.Utilities.ScalarLinearSet{T},
) where {T,F,S,G}
    MOI.throw_if_scalar_and_constant_not_zero(scalar_f, typeof(set))
    set_const = MOI.constant(set)
    vector_f = MOI.Utilities.operate(
        vcat,
        T,
        MOI.Utilities.operate(-, T, scalar_f, set_const),
    )
    vector_constraint = MOI.add_constraint(model, vector_f, S(1))
    return VectorizeBridge{T,F,S,G}(vector_constraint, set_const)
end

function MOI.supports_constraint(
    ::Type{VectorizeBridge{T}},
    ::Type{F},
    ::Type{<:MOI.Utilities.ScalarLinearSet{T}},
) where {T,F<:MOI.AbstractScalarFunction}
    return MOI.Utilities.is_coefficient_type(F, T)
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:VectorizeBridge})
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:VectorizeBridge{T,F,S}},
) where {T,F,S}
    return Tuple{Type,Type}[(F, S)]
end

function concrete_bridge_type(
    ::Type{<:VectorizeBridge{T}},
    G::Type{<:MOI.AbstractScalarFunction},
    S::Type{<:MOI.Utilities.ScalarLinearSet{T}},
) where {T}
    H = MOI.Utilities.promote_operation(-, T, G, T)
    F = MOI.Utilities.promote_operation(vcat, T, H)
    return VectorizeBridge{T,F,MOI.Utilities.vector_set_type(S),G}
end

function MOI.get(
    ::VectorizeBridge{T,F,S},
    ::MOI.NumberOfConstraints{F,S},
)::Int64 where {T,F,S}
    return 1
end

function MOI.get(
    bridge::VectorizeBridge{T,F,S},
    ::MOI.ListOfConstraintIndices{F,S},
) where {T,F,S}
    return [bridge.vector_constraint]
end

function MOI.delete(model::MOI.ModelLike, bridge::VectorizeBridge)
    MOI.delete(model, bridge.vector_constraint)
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{VectorizeBridge{T,F,S,G}},
) where {T,F,S,G}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F,S})
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::VectorizeBridge,
)
    x = MOI.get(model, attr, bridge.vector_constraint)
    if x === nothing
        return nothing
    end
    return only(x) + bridge.set_constant
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::VectorizeBridge,
)
    x = MOI.get(model, attr, bridge.vector_constraint)
    if MOI.Utilities.is_ray(MOI.get(model, MOI.PrimalStatus(attr.result_index)))
        # If it is an infeasibility certificate, it is a ray and satisfies the
        # homogenized problem, see https://github.com/jump-dev/MathOptInterface.jl/issues/433
        return only(x)
    else
        # Otherwise, we need to add the set constant since the ConstraintPrimal
        # is defined as the value of the function and the set_constant was
        # removed from the original function
        return only(x) + bridge.set_constant
    end
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::VectorizeBridge,
    value,
)
    MOI.set(
        model,
        attr,
        bridge.vector_constraint,
        [value - bridge.set_constant],
    )
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::VectorizeBridge,
    ::Nothing,
)
    MOI.set(model, attr, bridge.vector_constraint, nothing)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::VectorizeBridge,
)
    x = MOI.get(model, attr, bridge.vector_constraint)
    if x === nothing
        return nothing
    end
    return only(x)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::VectorizeBridge,
    value,
)
    if value === nothing
        MOI.set(model, attr, bridge.vector_constraint, nothing)
    else
        MOI.set(model, attr, bridge.vector_constraint, [value])
    end
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::VectorizeBridge,
    change::MOI.ScalarCoefficientChange,
)
    MOI.modify(
        model,
        bridge.vector_constraint,
        MOI.MultirowChange(change.variable, [(1, change.new_coefficient)]),
    )
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::VectorizeBridge,
    new_set::MOI.Utilities.ScalarLinearSet,
)
    bridge.set_constant = MOI.constant(new_set)
    MOI.modify(
        model,
        bridge.vector_constraint,
        MOI.VectorConstantChange([-bridge.set_constant]),
    )
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::VectorizeBridge{T,F,S,G},
) where {T,F,S,G}
    f = MOI.Utilities.scalarize(
        MOI.get(model, attr, bridge.vector_constraint),
        true,
    )
    return convert(G, only(f))
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::VectorizeBridge{T,F,S},
) where {T,F,S}
    return MOI.Utilities.scalar_set_type(S, T)(bridge.set_constant)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SingleBridgeOptimizer{BT<:AbstractBridge}(model::MOI.ModelLike)

Return `AbstractBridgeOptimizer` that always bridges any objective function
supported by the bridge `BT`.

This is in contrast with the [`MOI.Bridges.LazyBridgeOptimizer`](@ref),
which only bridges the objective function if it is supported by the bridge `BT`
and unsupported by `model`.

## Example

```jldoctest obj_singlebridgeoptimizer
julia> struct MyNewBridge{T} <: MOI.Bridges.Objective.AbstractBridge end

julia> bridge = MOI.Bridges.Objective.SingleBridgeOptimizer{MyNewBridge{Float64}}(
           MOI.Utilities.Model{Float64}(),
       );
```

## Implementation notes

All bridges should simplify the creation of `SingleBridgeOptimizer`s by defining
a constant that wraps the bridge in a `SingleBridgeOptimizer`.
```jldoctest obj_singlebridgeoptimizer
julia> const MyNewBridgeModel{T,OT<:MOI.ModelLike} =
           MOI.Bridges.Objective.SingleBridgeOptimizer{MyNewBridge{T},OT};
```
This enables users to create bridged models as follows:
```jldoctest obj_singlebridgeoptimizer
julia> MyNewBridgeModel{Float64}(MOI.Utilities.Model{Float64}());
```
"""
mutable struct SingleBridgeOptimizer{BT<:AbstractBridge,OT<:MOI.ModelLike} <:
               MOI.Bridges.AbstractBridgeOptimizer
    model::OT
    map::Map # `MOI.ObjectiveFunction` -> objective bridge
end

function SingleBridgeOptimizer{BT}(model::OT) where {BT,OT<:MOI.ModelLike}
    return SingleBridgeOptimizer{BT,OT}(model, Map())
end

bridges(::MOI.Bridges.AbstractBridgeOptimizer) = EmptyMap()

bridges(bridge::SingleBridgeOptimizer) = bridge.map

MOI.Bridges.supports_constraint_bridges(::SingleBridgeOptimizer) = false

function MOI.Bridges.is_bridged(
    ::SingleBridgeOptimizer,
    ::Type{<:MOI.AbstractSet},
)
    return false
end

function MOI.Bridges.is_bridged(
    ::SingleBridgeOptimizer,
    ::Type{<:MOI.AbstractFunction},
    ::Type{<:MOI.AbstractSet},
)
    return false
end

MOI.Bridges.is_bridged(::SingleBridgeOptimizer, ::MOI.VariableIndex) = false

# We need the next two methods to remove method ambiguities.

function MOI.Bridges.is_bridged(
    ::SingleBridgeOptimizer,
    ::MOI.ConstraintIndex{MOI.VariableIndex},
)
    return false
end

function MOI.Bridges.is_bridged(
    ::SingleBridgeOptimizer,
    ::MOI.ConstraintIndex{MOI.VectorOfVariables},
)
    return false
end

function MOI.Bridges.supports_bridging_objective_function(
    ::SingleBridgeOptimizer{BT},
    F::Type{<:MOI.AbstractFunction},
) where {BT}
    return supports_objective_function(BT, F)
end

function MOI.Bridges.is_bridged(
    bridge::SingleBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
)
    return MOI.Bridges.supports_bridging_objective_function(bridge, F)
end

function MOI.Bridges.bridge_type(
    ::SingleBridgeOptimizer{BT},
    ::Type{<:MOI.AbstractFunction},
) where {BT}
    return BT
end

MOI.Bridges.recursive_model(bridge::SingleBridgeOptimizer) = bridge.model

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SOS1ToMILPBridge{T,F} <: Bridges.Constraint.AbstractBridge

`SOS1ToMILPBridge` implements the following reformulation:

  * ``x \\in \\textsf{SOS1}(d)`` into a mixed-integer linear program.

## Source node

`SOS1ToMILPBridge` supports:

  * `F` in [`MOI.SOS1`](@ref)

where `F` is [`MOI.VectorOfVariables`](@ref) or
[`MOI.VectorAffineFunction{T}`](@ref).

## Target nodes

`SOS1ToMILPBridge` creates:

  * [`MOI.VariableIndex`](@ref) in [`MOI.ZeroOne`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo{T}`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.LessThan{T}`](@ref)
"""
mutable struct SOS1ToMILPBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
} <: AbstractBridge
    f::F
    s::MOI.SOS1{T}
    variables::Vector{MOI.VariableIndex}
    # ∑_i z_i == 1
    equal_to::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}
    # x_i - u_i z_i <= 0 ∀i
    # l_i z_i - x_i <= 0 ∀i
    less_than::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
    }
    bounds::Vector{NTuple{2,T}}
    function SOS1ToMILPBridge{T}(
        f::Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
        s::MOI.SOS1{T},
    ) where {T}
        return new{T,typeof(f)}(
            f,
            s,
            MOI.VariableIndex[],
            MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}(0),
            MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}}[],
            NTuple{2,T}[],
        )
    end
end

const SOS1ToMILP{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SOS1ToMILPBridge{T},OT}

# We need to weight this bridge such that `VectorAffineFunction-in-SOS1` is
# bridged (if possible) by `VectorSlack + VectorOfVariables-in-SOS1`.
#
# See MathOptInterface#2722 for details.
MOI.Bridges.bridging_cost(::Type{<:SOS1ToMILPBridge}) = 10.0

function bridge_constraint(
    ::Type{SOS1ToMILPBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.SOS1,
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    # !!! info
    #     Postpone rest of creation until final_touch.
    return SOS1ToMILPBridge{T}(f, s)
end

function MOI.supports_constraint(
    ::Type{<:SOS1ToMILPBridge{T}},
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}},
    ::Type{MOI.SOS1{T}},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:SOS1ToMILPBridge},
)
    return Tuple{Type}[(MOI.ZeroOne,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:SOS1ToMILPBridge{T}},
) where {T}
    return Tuple{Type,Type}[
        (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}),
        (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:SOS1ToMILPBridge{T}},
    ::Type{F},
    ::Type{MOI.SOS1{T}},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return SOS1ToMILPBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::SOS1ToMILPBridge,
)
    return copy(bridge.f)
end

function MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, bridge::SOS1ToMILPBridge)
    return bridge.s
end

function MOI.delete(model::MOI.ModelLike, bridge::SOS1ToMILPBridge)
    if isempty(bridge.variables)
        return  # We're deleting the bridge before final_touch
    end
    MOI.delete(model, bridge.equal_to)
    for ci in bridge.less_than
        MOI.delete(model, ci)
    end
    empty!(bridge.less_than)
    for x in bridge.variables
        MOI.delete(model, x)
    end
    empty!(bridge.variables)
    empty!(bridge.bounds)
    return
end

function MOI.get(bridge::SOS1ToMILPBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.variables)
end

function MOI.get(bridge::SOS1ToMILPBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.variables)
end

function MOI.get(
    bridge::SOS1ToMILPBridge,
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne},
)::Int64
    return length(bridge.variables)
end

function MOI.get(
    bridge::SOS1ToMILPBridge,
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne},
)
    return MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}[
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.ZeroOne}(x.value) for
        x in bridge.variables
    ]
end

function MOI.get(
    bridge::SOS1ToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return 1
end

function MOI.get(
    bridge::SOS1ToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return [bridge.equal_to]
end

function MOI.get(
    bridge::SOS1ToMILPBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
)::Int64 where {T}
    return length(bridge.less_than)
end

function MOI.get(
    bridge::SOS1ToMILPBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
) where {T}
    return copy(bridge.less_than)
end

MOI.Bridges.needs_final_touch(::SOS1ToMILPBridge) = true

function MOI.Bridges.final_touch(
    bridge::SOS1ToMILPBridge{T,F},
    model::MOI.ModelLike,
) where {T,F}
    bounds = Dict{MOI.VariableIndex,NTuple{2,T}}()
    scalars = collect(MOI.Utilities.eachscalar(bridge.f))
    new_bounds = false
    for (i, x) in enumerate(scalars)
        ret = MOI.Utilities.get_bounds(model, bounds, x)
        if ret === nothing
            throw(MOI.Bridges.BridgeRequiresFiniteDomainError(bridge, x))
        end
        if length(bridge.bounds) < i
            # This is the first time calling final_touch
            push!(bridge.bounds, ret)
            new_bounds = true
        elseif bridge.bounds[i] == ret
            # We've called final_touch before, and the bounds match. No need to
            # reformulate a second time.
            continue
        elseif bridge.bounds[i] != ret
            # There is a stored bound, and the current bounds do not match. This
            # means the model has been modified since the previous call to
            # final_touch. We need to delete the bridge and start again.
            MOI.delete(model, bridge)
            MOI.Bridges.final_touch(bridge, model)
            return
        end
    end
    if new_bounds === false
        return  # Already called
    end
    terms = MOI.ScalarAffineTerm{T}[]
    for i in 1:MOI.output_dimension(bridge.f)
        z, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
        push!(bridge.variables, z)
        push!(terms, MOI.ScalarAffineTerm(one(T), z))
    end
    g = MOI.ScalarAffineFunction(terms, zero(T))
    bridge.equal_to = MOI.add_constraint(model, g, MOI.EqualTo(one(T)))
    for (fi, (l, u), z) in zip(scalars, bridge.bounds, bridge.variables)
        push!(
            bridge.less_than,
            MOI.Utilities.normalize_and_add_constraint(
                model,
                MOI.Utilities.operate!(-, T, l * z, fi),
                MOI.LessThan(zero(T));
                allow_modify_function = true,
            ),
        )
        push!(
            bridge.less_than,
            MOI.Utilities.normalize_and_add_constraint(
                model,
                MOI.Utilities.operate(-, T, fi, u * z),
                MOI.LessThan(zero(T));
                allow_modify_function = true,
            ),
        )
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

_no_hessian(op::MOI.Nonlinear._UnivariateOperator) = op.f′′ === nothing
_no_hessian(op::MOI.Nonlinear._MultivariateOperator) = op.∇²f === nothing

function MOI.features_available(d::NLPEvaluator)
    # Check if we are missing any hessians for user-defined operators, in which
    # case we need to disable :Hess and :HessVec.
    d.disable_2ndorder =
        any(_no_hessian, d.data.operators.registered_univariate_operators) ||
        any(_no_hessian, d.data.operators.registered_multivariate_operators)
    if d.disable_2ndorder
        return [:Grad, :Jac, :JacVec]
    end
    return [:Grad, :Jac, :JacVec, :Hess, :HessVec]
end

function MOI.initialize(d::NLPEvaluator, requested_features::Vector{Symbol})
    # Check that we support the features requested by the user.
    available_features = MOI.features_available(d)
    for feature in requested_features
        if !(feature in available_features)
            error("Unsupported feature $feature")
        end
    end
    moi_index_to_consecutive_index =
        Dict(x => i for (i, x) in enumerate(d.ordered_variables))
    N = length(moi_index_to_consecutive_index)
    #
    largest_user_input_dimension = 1
    for op in d.data.operators.registered_multivariate_operators
        largest_user_input_dimension = max(largest_user_input_dimension, op.N)
    end
    d.objective = nothing
    d.user_output_buffer = zeros(largest_user_input_dimension)
    d.jac_storage = zeros(max(N, largest_user_input_dimension))
    d.constraints = _FunctionStorage[]
    d.last_x = fill(NaN, N)
    d.want_hess = :Hess in requested_features
    want_hess_storage = (:HessVec in requested_features) || d.want_hess
    coloring_storage = Coloring.IndexedSet(N)
    max_expr_length = 0
    max_expr_with_sub_length = 0
    #
    main_expressions = [c.expression.nodes for (_, c) in d.data.constraints]
    if d.data.objective !== nothing
        pushfirst!(main_expressions, something(d.data.objective).nodes)
    end
    d.subexpression_order, individual_order = _order_subexpressions(
        main_expressions,
        [expr.nodes for expr in d.data.expressions],
    )
    num_subexpressions = length(d.data.expressions)
    d.subexpression_linearity = Vector{Linearity}(undef, num_subexpressions)
    subexpression_variables = Vector{Vector{Int}}(undef, num_subexpressions)
    subexpression_edgelist =
        Vector{Set{Tuple{Int,Int}}}(undef, num_subexpressions)
    d.subexpressions = Vector{_SubexpressionStorage}(undef, num_subexpressions)
    d.subexpression_forward_values = zeros(num_subexpressions)
    d.subexpression_reverse_values = zeros(num_subexpressions)
    for k in d.subexpression_order
        # Only load expressions which actually are used
        d.subexpression_forward_values[k] = NaN
        subex = _SubexpressionStorage(
            d.data.expressions[k],
            d.subexpression_linearity,
            moi_index_to_consecutive_index,
            d.want_hess,
        )
        d.subexpressions[k] = subex
        d.subexpression_linearity[k] = subex.linearity
        max_expr_with_sub_length =
            max(max_expr_with_sub_length, length(subex.nodes))
        if d.want_hess
            empty!(coloring_storage)
            _compute_gradient_sparsity!(coloring_storage, subex.nodes)
            # union with all dependent expressions
            for idx in _list_subexpressions(subex.nodes)
                union!(coloring_storage, subexpression_variables[idx])
            end
            subexpression_variables[k] = collect(coloring_storage)
            empty!(coloring_storage)
            linearity = _classify_linearity(
                subex.nodes,
                subex.adj,
                d.subexpression_linearity,
            )
            edgelist = _compute_hessian_sparsity(
                subex.nodes,
                subex.adj,
                linearity,
                subexpression_edgelist,
                subexpression_variables,
            )
            subexpression_edgelist[k] = edgelist
        end
    end
    max_chunk = 1
    if d.data.objective !== nothing
        objective = _FunctionStorage(
            main_expressions[1],
            something(d.data.objective).values,
            N,
            coloring_storage,
            d.want_hess,
            d.subexpressions,
            individual_order[1],
            d.subexpression_linearity,
            subexpression_edgelist,
            subexpression_variables,
            moi_index_to_consecutive_index,
        )
        max_expr_length = max(max_expr_length, length(objective.nodes))
        max_chunk = max(max_chunk, size(objective.seed_matrix, 2))
        d.objective = objective
    end
    for (k, (_, constraint)) in enumerate(d.data.constraints)
        idx = d.data.objective !== nothing ? k + 1 : k
        push!(
            d.constraints,
            _FunctionStorage(
                main_expressions[idx],
                constraint.expression.values,
                N,
                coloring_storage,
                d.want_hess,
                d.subexpressions,
                individual_order[idx],
                d.subexpression_linearity,
                subexpression_edgelist,
                subexpression_variables,
                moi_index_to_consecutive_index,
            ),
        )
        max_expr_length = max(max_expr_length, length(d.constraints[end].nodes))
        max_chunk = max(max_chunk, size(d.constraints[end].seed_matrix, 2))
    end
    max_chunk = min(max_chunk, MAX_CHUNK)
    max_expr_with_sub_length = max(max_expr_with_sub_length, max_expr_length)
    if d.want_hess || want_hess_storage
        d.input_ϵ = zeros(max_chunk * N)
        d.output_ϵ = zeros(max_chunk * N)
        #
        d.partials_storage_ϵ = zeros(max_chunk * max_expr_length)
        d.storage_ϵ = zeros(max_chunk * max_expr_with_sub_length)
        #
        len = max_chunk * length(d.subexpressions)
        d.subexpression_forward_values_ϵ = zeros(len)
        d.subexpression_reverse_values_ϵ = zeros(len)
        #
        for k in d.subexpression_order
            len = max_chunk * length(d.subexpressions[k].nodes)
            resize!(d.subexpressions[k].partials_storage_ϵ, len)
            fill!(d.subexpressions[k].partials_storage_ϵ, 0.0)
        end
        d.max_chunk = max_chunk
        if d.want_hess
            d.hessian_sparsity = Tuple{Int64,Int64}[]
            obj = d.objective
            if obj !== nothing
                append!(d.hessian_sparsity, zip(obj.hess_I, obj.hess_J))
            end
            for c in d.constraints
                append!(d.hessian_sparsity, zip(c.hess_I, c.hess_J))
            end
        end
    end
    return
end

function MOI.eval_objective(d::NLPEvaluator, x)
    if d.objective === nothing
        error("No nonlinear objective.")
    end
    _reverse_mode(d, x)
    return something(d.objective).forward_storage[1]
end

function MOI.eval_objective_gradient(d::NLPEvaluator, g, x)
    if d.objective === nothing
        error("No nonlinear objective.")
    end
    _reverse_mode(d, x)
    fill!(g, 0.0)
    _extract_reverse_pass(g, d, something(d.objective))
    return
end

function MOI.eval_constraint(d::NLPEvaluator, g, x)
    _reverse_mode(d, x)
    for i in 1:length(d.constraints)
        g[i] = d.constraints[i].forward_storage[1]
    end
    return
end

function MOI.jacobian_structure(d::NLPEvaluator)
    J = Tuple{Int64,Int64}[]
    for (row, constraint) in enumerate(d.constraints)
        for col in constraint.grad_sparsity
            push!(J, (row, col))
        end
    end
    return J
end

function MOI.constraint_gradient_structure(d::NLPEvaluator, i)
    return copy(d.constraints[i].grad_sparsity)
end

function MOI.eval_constraint_gradient(d::NLPEvaluator, ∇g, x, i)
    _reverse_mode(d, x)
    for k in d.constraints[i].grad_sparsity
        d.jac_storage[k] = 0.0
    end
    _extract_reverse_pass(d.jac_storage, d, d.constraints[i])
    for (j, k) in enumerate(d.constraints[i].grad_sparsity)
        ∇g[j] = d.jac_storage[k]
    end
    return
end

function MOI.eval_constraint_jacobian(d::NLPEvaluator, J, x)
    _reverse_mode(d, x)
    fill!(J, 0.0)
    offset = 0
    for ex in d.constraints
        for i in ex.grad_sparsity
            d.jac_storage[i] = 0.0
        end
        _extract_reverse_pass(d.jac_storage, d, ex)
        for (k, idx) in enumerate(ex.grad_sparsity)
            J[offset+k] = d.jac_storage[idx]
        end
        offset += length(ex.grad_sparsity)
    end
    return
end

function MOI.eval_constraint_jacobian_product(d::NLPEvaluator, y, x, w)
    _reverse_mode(d, x)
    fill!(y, 0.0)
    for (row, expr) in enumerate(d.constraints)
        for col in expr.grad_sparsity
            d.jac_storage[col] = 0.0
        end
        _extract_reverse_pass(d.jac_storage, d, expr)
        for col in expr.grad_sparsity
            y[row] += d.jac_storage[col] * w[col]
        end
    end
    return
end

function MOI.eval_constraint_jacobian_transpose_product(
    d::NLPEvaluator,
    y::AbstractVector{Float64},
    x::AbstractVector{Float64},
    w::AbstractVector{Float64},
)
    _reverse_mode(d, x)
    fill!(y, 0.0)
    for (row, expr) in enumerate(d.constraints)
        for col in expr.grad_sparsity
            d.jac_storage[col] = 0.0
        end
        _extract_reverse_pass(d.jac_storage, d, expr)
        for col in expr.grad_sparsity
            y[col] += d.jac_storage[col] * w[row]
        end
    end
    return
end

function MOI.hessian_objective_structure(d::NLPEvaluator)
    @assert d.want_hess
    ret = Tuple{Int64,Int64}[]
    obj = d.objective
    if obj !== nothing
        for (i, j) in zip(obj.hess_I, obj.hess_J)
            push!(ret, (i, j))
        end
    end
    return ret
end

function MOI.hessian_constraint_structure(d::NLPEvaluator, c::Integer)
    @assert d.want_hess
    con = d.constraints[c]
    return Tuple{Int64,Int64}[(i, j) for (i, j) in zip(con.hess_I, con.hess_J)]
end

function MOI.hessian_lagrangian_structure(d::NLPEvaluator)
    @assert d.want_hess
    return d.hessian_sparsity
end

function MOI.eval_hessian_objective(d::NLPEvaluator, H, x)
    @assert d.want_hess
    _reverse_mode(d, x)
    fill!(d.input_ϵ, 0.0)
    if d.objective !== nothing
        _eval_hessian(d, something(d.objective), H, 1.0, 0)
    end
    return
end

function MOI.eval_hessian_constraint(d::NLPEvaluator, H, x, i)
    @assert d.want_hess
    _reverse_mode(d, x)
    fill!(d.input_ϵ, 0.0)
    _eval_hessian(d, d.constraints[i], H, 1.0, 0)
    return
end

function MOI.eval_hessian_lagrangian(d::NLPEvaluator, H, x, σ, μ)
    @assert d.want_hess
    _reverse_mode(d, x)
    fill!(d.input_ϵ, 0.0)
    offset = 0
    if d.objective !== nothing
        offset += _eval_hessian(d, something(d.objective), H, σ, offset)::Int
    end
    for (i, ex) in enumerate(d.constraints)
        offset += _eval_hessian(d, ex, H, μ[i], offset)::Int
    end
    return
end

function MOI.eval_hessian_lagrangian_product(d::NLPEvaluator, h, x, v, σ, μ)
    _reverse_mode(d, x)
    fill!(h, 0.0)
    T = ForwardDiff.Partials{1,Float64}
    input_ϵ = reinterpret(T, d.input_ϵ)
    output_ϵ = reinterpret(T, d.output_ϵ)
    for i in 1:length(x)
        input_ϵ[i] = ForwardDiff.Partials((v[i],))
    end
    # forward evaluate all subexpressions once
    subexpr_forward_values_ϵ = reinterpret(T, d.subexpression_forward_values_ϵ)
    for i in d.subexpression_order
        subexpr = d.subexpressions[i]
        subexpr_forward_values_ϵ[i] = _forward_eval_ϵ(
            d,
            subexpr,
            reinterpret(T, subexpr.partials_storage_ϵ),
        )
    end
    # we only need to do one reverse pass through the subexpressions as well
    subexpr_reverse_values_ϵ = reinterpret(T, d.subexpression_reverse_values_ϵ)
    fill!(subexpr_reverse_values_ϵ, zero(T))
    fill!(d.subexpression_reverse_values, 0.0)
    fill!(d.storage_ϵ, 0.0)
    fill!(output_ϵ, zero(T))
    if d.objective !== nothing
        _forward_eval_ϵ(
            d,
            something(d.objective),
            reinterpret(T, d.partials_storage_ϵ),
        )
        _reverse_eval_ϵ(
            output_ϵ,
            something(d.objective),
            reinterpret(T, d.storage_ϵ),
            reinterpret(T, d.partials_storage_ϵ),
            d.subexpression_reverse_values,
            subexpr_reverse_values_ϵ,
            σ,
            zero(T),
        )
    end
    for (i, con) in enumerate(d.constraints)
        _forward_eval_ϵ(d, con, reinterpret(T, d.partials_storage_ϵ))
        _reverse_eval_ϵ(
            output_ϵ,
            con,
            reinterpret(T, d.storage_ϵ),
            reinterpret(T, d.partials_storage_ϵ),
            d.subexpression_reverse_values,
            subexpr_reverse_values_ϵ,
            μ[i],
            zero(T),
        )
    end
    for i in length(d.subexpression_order):-1:1
        j = d.subexpression_order[i]
        subexpr = d.subexpressions[j]
        _reverse_eval_ϵ(
            output_ϵ,
            subexpr,
            reinterpret(T, d.storage_ϵ),
            reinterpret(T, subexpr.partials_storage_ϵ),
            d.subexpression_reverse_values,
            subexpr_reverse_values_ϵ,
            d.subexpression_reverse_values[j],
            subexpr_reverse_values_ϵ[j],
        )
    end
    for i in 1:length(x)
        h[i] += output_ϵ[i].values[1]
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# We fake the supertype to aid method dispatch
struct SolFileResults <: MOI.ModelLike
    model::Union{Nothing,Model}
    raw_status_string::String
    termination_status::MOI.TerminationStatusCode
    primal_status::MOI.ResultStatusCode
    dual_status::MOI.ResultStatusCode
    objective_value::Float64
    variable_primal::Dict{MOI.VariableIndex,Float64}
    constraint_dual::Vector{Float64}
    zL_out::Dict{MOI.VariableIndex,Float64}
    zU_out::Dict{MOI.VariableIndex,Float64}
end

"""
    SolFileResults(
        filename::String,
        model::Model;
        suffix_lower_bound_duals::Vector{String} =
            ["ipopt_zL_out", "lower_bound_duals"],
        suffix_uuper_bound_duals::Vector{String} =
            ["ipopt_zU_out", "upper_bound_duals"],
    )

Parse the `.sol` file `filename` created by solving `model` and return a
`SolFileResults` struct.

The returned struct supports the `MOI.get` API for querying result attributes
such as [`MOI.TerminationStatus`](@ref), [`MOI.VariablePrimal`](@ref), and
[`MOI.ConstraintDual`](@ref).
"""
function SolFileResults(filename::String, model::Model; kwargs...)
    return open(io -> SolFileResults(io, model; kwargs...), filename, "r")
end

"""
    SolFileResults(
        raw_status::String,
        termination_status::MOI.TerminationStatusCode,
    )

Return a `SolFileResults` struct with [`MOI.RawStatusString`](@ref) set to
`raw_status`, [`MOI.TerminationStatus`](@ref) set to `termination_status`, and
[`MOI.PrimalStatus`](@ref) and [`MOI.DualStatus`](@ref) set to `NO_SOLUTION`.

All other attributes are un-set.
"""
function SolFileResults(
    raw_status::String,
    termination_status::MOI.TerminationStatusCode;
    kwargs...,
)
    return SolFileResults(
        nothing,
        raw_status,
        termination_status,
        MOI.NO_SOLUTION,
        MOI.NO_SOLUTION,
        NaN,
        Dict{MOI.VariableIndex,Float64}(),
        Float64[],
        Dict{MOI.VariableIndex,Float64}(),
        Dict{MOI.VariableIndex,Float64}(),
    )
end

function MOI.get(sol::SolFileResults, ::MOI.ResultCount)
    return isempty(sol.variable_primal) ? 0 : 1
end

function MOI.get(sol::SolFileResults, ::MOI.RawStatusString)
    return sol.raw_status_string
end

function MOI.get(sol::SolFileResults, ::MOI.TerminationStatus)
    return sol.termination_status
end

function MOI.get(sol::SolFileResults, attr::MOI.PrimalStatus)
    if attr.result_index != 1
        return MOI.NO_SOLUTION
    end
    return sol.primal_status
end

function MOI.get(sol::SolFileResults, attr::MOI.DualStatus)
    if attr.result_index != 1
        return MOI.NO_SOLUTION
    end
    return sol.dual_status
end

function MOI.get(sol::SolFileResults, attr::MOI.ObjectiveValue)
    MOI.check_result_index_bounds(sol, attr)
    return sol.objective_value
end

function MOI.get(
    sol::SolFileResults,
    attr::MOI.VariablePrimal,
    x::MOI.VariableIndex,
)
    MOI.check_result_index_bounds(sol, attr)
    return sol.variable_primal[x]
end

function MOI.get(
    sol::SolFileResults,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{<:MOI.VariableIndex},
)
    MOI.check_result_index_bounds(sol, attr)
    return sol.variable_primal[MOI.VariableIndex(ci.value)]
end

# Helper function to assert that the model is not nothing
_model(sol::SolFileResults) = sol.model::Model

function MOI.get(
    sol::SolFileResults,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{<:MOI.ScalarAffineFunction},
)
    MOI.check_result_index_bounds(sol, attr)
    return _evaluate(_model(sol).h[ci.value].expr, sol.variable_primal)
end

function MOI.get(
    sol::SolFileResults,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{F},
) where {F<:Union{MOI.ScalarQuadraticFunction,MOI.ScalarNonlinearFunction}}
    MOI.check_result_index_bounds(sol, attr)
    return _evaluate(_model(sol).g[ci.value].expr, sol.variable_primal)
end

function MOI.get(
    sol::SolFileResults,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}},
)
    MOI.check_result_index_bounds(sol, attr)
    dual = get(sol.zU_out, MOI.VariableIndex(ci.value), 0.0)
    return _model(sol).sense == MOI.MIN_SENSE ? dual : -dual
end

function MOI.get(
    sol::SolFileResults,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}},
)
    MOI.check_result_index_bounds(sol, attr)
    dual = get(sol.zL_out, MOI.VariableIndex(ci.value), 0.0)
    return _model(sol).sense == MOI.MIN_SENSE ? dual : -dual
end

function MOI.get(
    sol::SolFileResults,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}},
)
    MOI.check_result_index_bounds(sol, attr)
    x = MOI.VariableIndex(ci.value)
    dual = get(sol.zL_out, x, 0.0) + get(sol.zU_out, x, 0.0)
    return _model(sol).sense == MOI.MIN_SENSE ? dual : -dual
end

function MOI.get(
    sol::SolFileResults,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Float64}},
)
    MOI.check_result_index_bounds(sol, attr)
    x = MOI.VariableIndex(ci.value)
    dual = get(sol.zL_out, x, 0.0) + get(sol.zU_out, x, 0.0)
    return _model(sol).sense == MOI.MIN_SENSE ? dual : -dual
end

function MOI.get(
    sol::SolFileResults,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{<:MOI.ScalarAffineFunction},
)
    MOI.check_result_index_bounds(sol, attr)
    dual = sol.constraint_dual[length(_model(sol).g)+ci.value]
    return _model(sol).sense == MOI.MIN_SENSE ? dual : -dual
end

function MOI.get(
    sol::SolFileResults,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{F},
) where {F<:Union{MOI.ScalarQuadraticFunction,MOI.ScalarNonlinearFunction}}
    MOI.check_result_index_bounds(sol, attr)
    dual = sol.constraint_dual[ci.value]
    return _model(sol).sense == MOI.MIN_SENSE ? dual : -dual
end

function MOI.get(sol::SolFileResults, attr::MOI.NLPBlockDual)
    MOI.check_result_index_bounds(sol, attr)
    dual = sol.constraint_dual[1:_model(sol).nlpblock_dim]
    return _model(sol).sense == MOI.MIN_SENSE ? dual : -dual
end

"""
    _interpret_status(solve_result_num::Int, raw_status_string::String)

Convert the `solve_result_num` and `raw_status_string` into MOI-type statuses.

For the primal status, assume a solution is present. Other code is responsible
for returning `MOI.NO_SOLUTION` if no primal solution is present.
"""
function _interpret_status(solve_result_num::Int, raw_status_string::String)
    message = lowercase(raw_status_string)
    # Handle some status strings that are, in most cases, solver-specific.
    if occursin("time limit, feasible solution", message)
        return MOI.TIME_LIMIT, MOI.FEASIBLE_POINT
    end
    # No handle the solve status codes. These are solver-specific, although they
    # should be grouped into XYZ codes, where the first digit is a generic
    # group (optimal, infeasible, limit, etc), and the YZ are solver-specific
    # codes with more meaning.
    if 0 <= solve_result_num < 100
        # Solved, and nothing went wrong. Even though we say `LOCALLY_SOLVED`,
        # some solvers like SHOT use this status to represent problems that are
        # provably globally optimal.
        return MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT
    elseif 100 <= solve_result_num < 200
        # Solved, but the solver can't be sure for some reason. for example, SHOT
        # uses this for non-convex problems it isn't sure is the global optima.
        return MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT
    elseif 200 <= solve_result_num < 300
        return MOI.LOCALLY_INFEASIBLE, MOI.UNKNOWN_RESULT_STATUS
    elseif 300 <= solve_result_num < 400
        return MOI.DUAL_INFEASIBLE, MOI.UNKNOWN_RESULT_STATUS
    elseif 400 <= solve_result_num < 500
        return MOI.OTHER_LIMIT, MOI.UNKNOWN_RESULT_STATUS
    elseif 500 <= solve_result_num < 600
        return MOI.OTHER_ERROR, MOI.UNKNOWN_RESULT_STATUS
    end
    # If all else fails, attempt to infer the status from `raw_status_string`.
    if occursin("optimal", message)
        return MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT
    elseif occursin("infeasible", message)
        return MOI.LOCALLY_INFEASIBLE, MOI.UNKNOWN_RESULT_STATUS
    elseif occursin("unbounded", message)
        return MOI.DUAL_INFEASIBLE, MOI.UNKNOWN_RESULT_STATUS
    elseif occursin("limit", message)
        return MOI.OTHER_LIMIT, MOI.UNKNOWN_RESULT_STATUS
    elseif occursin("error", message)
        return MOI.OTHER_ERROR, MOI.UNKNOWN_RESULT_STATUS
    else
        return MOI.OTHER_ERROR, MOI.UNKNOWN_RESULT_STATUS
    end
end

function _readline(io::IO)
    if eof(io)
        error("Reached end of sol file unexpectedly.")
    end
    return strip(readline(io))
end

_readline(io::IO, T) = parse(T, _readline(io))

function SolFileResults(
    io::IO,
    model::Model;
    suffix_lower_bound_duals::Vector{String} = [
        "ipopt_zL_out",
        "lower_bound_duals",
    ],
    suffix_upper_bound_duals::Vector{String} = [
        "ipopt_zU_out",
        "upper_bound_duals",
    ],
)
    # This function is based on a Julia translation of readsol.c, available at
    # https://github.com/ampl/asl/blob/64919f75fa7a438f4b41bce892dcbe2ae38343ee/src/solvers/readsol.c
    # and under the following license:
    #
    # Copyright (C) 2017 AMPL Optimization, Inc.; written by David M. Gay.
    # Permission to use, copy, modify, and distribute this software and its
    # documentation for any purpose and without fee is hereby granted,
    # provided that the above copyright notice appear in all copies and that
    # both that the copyright notice and this permission notice and warranty
    # disclaimer appear in supporting documentation.
    #
    # The author and AMPL Optimization, Inc. disclaim all warranties with
    # regard to this software, including all implied warranties of
    # merchantability and fitness.  In no event shall the author be liable
    # for any special, indirect or consequential damages or any damages
    # whatsoever resulting from loss of use, data or profits, whether in an
    # action of contract, negligence or other tortious action, arising out
    # of or in connection with the use or performance of this software.
    raw_status_string = ""
    line = ""
    while !startswith(line, "Options")
        raw_status_string *= line
        line = _readline(io)
    end
    # Read through all the options. Direct copy of reference implementation.
    @assert startswith(line, "Options")
    num_options = _readline(io, Int)
    need_vbtol = false
    if num_options > 0
        @assert 3 <= num_options <= 9
        _readline(io, Int)  # Skip this line
        if _readline(io, Int) == 3
            num_options -= 2
            need_vbtol = true
        end
        for _ in 3:num_options
            _readline(io, Int)  # Skip the rest of the option lines
        end
    end
    # Read number of constraints
    num_cons = _readline(io, Int)
    @assert(num_cons == length(model.g) + length(model.h))
    # Read number of dual solutions to read in
    num_duals_to_read = _readline(io, Int)
    @assert(num_duals_to_read == 0 || num_duals_to_read == num_cons)
    # Read number of variables
    num_vars = _readline(io, Int)
    @assert(num_vars == length(model.x))
    # Read number of primal solutions to read in
    num_vars_to_read = _readline(io, Int)
    @assert(num_vars_to_read == 0 || num_vars_to_read == num_vars)
    # Skip over vbtol line if present
    if need_vbtol
        _readline(io)
    end
    # Read dual solutions
    constraint_dual =
        Float64[_readline(io, Float64) for _ in 1:num_duals_to_read]
    # Read primal solutions
    variable_primal = Dict{MOI.VariableIndex,Float64}()
    if num_vars_to_read > 0
        for xi in model.order
            variable_primal[xi] = _readline(io, Float64)
        end
    end
    # Check for status code
    solve_result_num = -1
    while !eof(io)
        linevals = split(_readline(io), " ")
        if length(linevals) > 0 && linevals[1] == "objno"
            @assert parse(Int, linevals[2]) == 0
            solve_result_num = parse(Int, linevals[3])
            break
        end
    end
    zL_out = Dict{MOI.VariableIndex,Float64}()
    zU_out = Dict{MOI.VariableIndex,Float64}()
    while !eof(io)
        line = _readline(io)
        if startswith(line, "suffix")
            items = split(line, " ")
            n_suffix = parse(Int, items[3])
            suffix = _readline(io)
            for i in 1:n_suffix
                if suffix in suffix_upper_bound_duals
                    items = split(_readline(io), " ")
                    x = model.order[parse(Int, items[1])+1]
                    zU_out[x] = parse(Float64, items[2])
                elseif suffix in suffix_lower_bound_duals
                    items = split(_readline(io), " ")
                    x = model.order[parse(Int, items[1])+1]
                    zL_out[x] = parse(Float64, items[2])
                else
                    _ = _readline(io)
                end
            end
        end
    end
    termination_status, primal_status =
        _interpret_status(solve_result_num, raw_status_string)
    objective_value = NaN
    if length(variable_primal) > 0
        # .sol files don't seem to be able to return the objective
        # value. Evaluate it here instead.
        objective_value = _evaluate(model.f, variable_primal)
    end
    n_duals = length(constraint_dual) + length(zL_out) + length(zU_out)
    dual_status = if n_duals == 0 || termination_status != MOI.LOCALLY_SOLVED
        MOI.NO_SOLUTION
    else
        MOI.FEASIBLE_POINT
    end
    return SolFileResults(
        model,
        raw_status_string,
        termination_status,
        length(variable_primal) > 0 ? primal_status : MOI.NO_SOLUTION,
        dual_status,
        objective_value,
        variable_primal,
        constraint_dual,
        zL_out,
        zU_out,
    )
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintDualRelativeEntropy

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_DualRelativeEntropy()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.DualRelativeEntropy{Float64}(mock)
    MOI.Test.test_basic_VectorOfVariables_DualRelativeEntropyCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_basic_VectorAffineFunction_DualRelativeEntropyCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_basic_VectorQuadraticFunction_DualRelativeEntropyCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    var_primal = [2.0, 3/5, log(1/2)-1, log(5/3)-1]
    exps_duals = [[2log(1/2), 2.0, 1.0], [3log(5/3), 3.0, 5.0]]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.VectorAffineFunction{Float64}, MOI.DualExponentialCone) =>
                exps_duals,
        )

    MOI.Test.test_conic_DualRelativeEntropyCone(bridged_mock, config)
    var_names = ["v1", "v2", "w1", "w2"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    exps = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.DualExponentialCone,
        }(),
    )
    @test length(exps) == 2
    MOI.set(mock, MOI.ConstraintName(), exps[1], "exps1")
    MOI.set(mock, MOI.ConstraintName(), exps[2], "exps2")

    s = """
    variables: v1, v2, w1, w2
    exps1: [-1.0, w1, v1] in DualExponentialCone()
    exps2: [-1.0, w2, v2] in DualExponentialCone()
    maxobjective: -1.0v1 + -5.0v2 + -2.0w1 + -3.0w2
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(mock, model, var_names, ["exps1", "exps2"])
    relentr = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.DualRelativeEntropyCone,
        }(),
    )
    @test length(relentr) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), relentr[1], "relentr")

    s = """
    variables: v1, v2, w1, w2
    relentr: [1.0, v1, v2, w1, w2] in DualRelativeEntropyCone(5)
    maxobjective: -1.0v1 + -5.0v2 + -2.0w1 + -3.0w2
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(bridged_mock, model, var_names, ["relentr"])
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.DualRelativeEntropyCone,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        4,
        ((MOI.VectorAffineFunction{Float64}, MOI.DualExponentialCone, 0),),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.DualRelativeEntropyBridge,
        """
        variables: u, v1, v2, w1, w2
        [u, v1, v2, w1, w2] in DualRelativeEntropyCone(5)
        """,
        """
        variables: u, v1, v2, w1, w2
        [-1.0 * u, w1, v1] in DualExponentialCone()
        [-1.0 * u, w2, v2] in DualExponentialCone()
        """,
    )
    return
end

end  # module

TestConstraintDualRelativeEntropy.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintCountBelongs

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CountBelongsToMILPBridge,
        """
        variables: a, n, x, y
        [n, x, y] in CountBelongs(3, Set([2, 4]))
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        a in ZeroOne()
        """,
        """
        variables: a, n, x, y, z_x1, z_x2, z_y2, z_y3
        1.0 * x + -1.0 * z_x1 + -2.0 * z_x2 == 0.0
        1.0 * y + -2.0 * z_y2 + -3.0 * z_y3 == 0.0
        z_x1 + z_x2 == 1.0
        z_y2 + z_y3 == 1.0
        -1.0 * n + z_x2 + z_y2 == 0.0
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        z_x1 in ZeroOne()
        z_x2 in ZeroOne()
        z_y2 in ZeroOne()
        z_y3 in ZeroOne()
        a in ZeroOne()
        """,
    )
    return
end

function test_runtests_VectorAffineFunction()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.CountBelongsToMILPBridge,
        """
        variables: x, y
        [2.0, 2.0 * x + -1.0, y] in CountBelongs(3, Set([2, 4]))
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        """,
        """
        variables: x, y, z_x1, z_x2, z_x3, z_y2, z_y3
        2.0 * x + -1.0 * z_x1 + -2.0 * z_x2 + -3.0 * z_x3 == 1.0
        1.0 * y + -2.0 * z_y2 + -3.0 * z_y3 == 0.0
        z_x2 + z_y2 == 2.0
        z_x1 + z_x2 + z_x3 == 1.0
        z_y2 + z_y3 == 1.0
        x in Interval(1.0, 2.0)
        y >= 2.0
        y <= 3.0
        z_x1 in ZeroOne()
        z_x2 in ZeroOne()
        z_x3 in ZeroOne()
        z_y2 in ZeroOne()
        z_y3 in ZeroOne()
        """,
    )
    return
end

function test_resolve_with_modified()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountBelongsToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint.(model, x, MOI.Interval(1, 2))
    f = MOI.VectorOfVariables(x)
    MOI.add_constraint(model, f, MOI.CountBelongs(3, Set([2, 4])))
    @test MOI.get(inner, MOI.NumberOfVariables()) == 3
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 7
    MOI.set(model, MOI.ConstraintSet(), c[2], MOI.Interval(1, 3))
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 8
    return
end

function test_runtests_error_variable()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountBelongsToMILP{Int}(inner)
    x = MOI.add_variables(model, 3)
    f = MOI.VectorOfVariables(x)
    c = MOI.add_constraint(model, f, MOI.CountBelongs(3, Set([2, 4])))
    BT = typeof(model.map[c])
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,MOI.VariableIndex},
        MOI.Bridges.final_touch(model),
    )
    return
end

function test_runtests_error_affine()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.CountBelongsToMILP{Int}(inner)
    x = MOI.add_variables(model, 2)
    f = MOI.Utilities.operate(vcat, Int, 2, 1 * x[1], x[2])
    c = MOI.add_constraint(model, f, MOI.CountBelongs(3, Set([2, 4])))
    BT = typeof(model.map[c])
    F = MOI.ScalarAffineFunction{Int}
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,F},
        MOI.Bridges.final_touch(model),
    )
    return
end

end  # module

TestConstraintCountBelongs.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

mutable struct _CacheModel
    is_binary::Bool
    cache::Vector{UInt8}
    variable_type::Vector{_VariableType}
    variable_primal::Vector{Float64}
    variable_lower::Vector{Float64}
    variable_upper::Vector{Float64}
    constraints::Vector{Expr}
    constraint_lower::Vector{Float64}
    constraint_upper::Vector{Float64}
    objective::Expr
    sense::MOI.OptimizationSense
    function _CacheModel()
        return new(
            false,
            zeros(UInt8, 64),
            _VariableType[],
            Float64[],
            Float64[],
            Float64[],
            Expr[],
            Float64[],
            Float64[],
            :(),
            MOI.FEASIBILITY_SENSE,
        )
    end
end

function Base.read!(io::IO, model::Model)
    cache = _CacheModel()
    _parse_header(io, cache)
    while !eof(io)
        _parse_section(io, cache)
    end
    model.model = _to_model(cache; use_nlp_block = model.use_nlp_block)
    return
end

function _resize_variables(model::_CacheModel, n::Int)
    resize!(model.variable_type, n)
    fill!(model.variable_type, _CONTINUOUS)
    resize!(model.variable_lower, n)
    fill!(model.variable_lower, -Inf)
    resize!(model.variable_upper, n)
    fill!(model.variable_upper, Inf)
    resize!(model.variable_primal, n)
    fill!(model.variable_primal, 0.0)
    return
end

function _resize_constraints(model::_CacheModel, n::Int)
    resize!(model.constraint_lower, n)
    fill!(model.constraint_lower, -Inf)
    resize!(model.constraint_upper, n)
    fill!(model.constraint_upper, Inf)
    resize!(model.constraints, n)
    for i in 1:n
        model.constraints[i] = :()
    end
    return
end

_is_valid_number(::Type{Int}, x::UInt8) = UInt8('0') <= x <= UInt8('9')

function _is_valid_number(::Type{Float64}, x::UInt8)
    if _is_valid_number(Int, x)
        return true
    elseif x == UInt8('+') || x == UInt8('-')
        return true
    elseif x == UInt8('.') || x == UInt8('e') || x == UInt8('E')
        return true
    end
    return false
end

function _next_token(::Type{T}, io::IO, cache::Vector{UInt8}) where {T}
    # Skip all spaces
    byte = UInt8(' ')
    while byte == UInt8(' ')
        byte = read(io, UInt8)
    end
    @assert _is_valid_number(T, byte)
    cache[1] = byte
    i = 1
    while _is_valid_number(T, peek(io, UInt8))
        i += 1
        cache[i] = read(io, UInt8)
    end
    return i
end

function _next(::Type{Float64}, io::IO, model::_CacheModel)
    if model.is_binary
        return read(io, Float64)
    end
    nnz = _next_token(Float64, io, model.cache)
    @assert nnz > 0
    return parse(Float64, String(model.cache[1:nnz]))
end

function _next(::Type{Int}, io::IO, model::_CacheModel)
    if model.is_binary
        return convert(Int, read(io, Int32))
    end
    nnz = _next_token(Int, io, model.cache)
    @assert nnz > 0
    y = 0
    mult = 1
    for i in nnz:-1:1
        y += mult * (model.cache[i] - UInt8('0'))
        mult *= 10
    end
    return y
end

function _next(::Type{Cchar}, io::IO, model::_CacheModel)
    if model.is_binary
        return read(io, Cchar)
    end
    byte = UInt8(' ')
    while byte == UInt8(' ')
        byte = read(io, UInt8)
    end
    return Cchar(byte)
end

"""
    _read_til_newline(io::IO, model::_CacheModel)

This function reads until it finds a new line character. This is useful for
skipping comments.
"""
function _read_til_newline(io::IO, model::_CacheModel)
    if model.is_binary
        return
    end
    while read(io, UInt8) != UInt8('\n')
    end
    return
end

_force_expr(expr::Expr) = expr
_force_expr(expr) = Expr(:call, :+, expr)

function _parse_expr(io::IO, model::_CacheModel)
    char = Char(read(io, UInt8))
    if char == 'o'
        opcode = _next(Int, io, model)
        _read_til_newline(io, model)
        arity, op_func = _AMPL_TO_JULIA[opcode]
        op_sym = Symbol(op_func)
        if arity == -1
            arity = _next(Int, io, model)
            _read_til_newline(io, model)
            if op_sym == :sum
                op_sym = :+
            elseif op_sym == :minimum
                op_sym = :min
            elseif op_sym == :maximum
                op_sym = :max
            end
        end
        parent = Expr(:call, op_sym)
        for _ in 1:arity
            child = _parse_expr(io, model)
            push!(parent.args, child)
        end
        return parent
    elseif char == 'v'
        index = _next(Int, io, model)
        _read_til_newline(io, model)
        return MOI.VariableIndex(index + 1)
    else
        @assert char == 'n'
        ret = _next(Float64, io, model)
        _read_til_newline(io, model)
        return ret
    end
end

function _to_model(data::_CacheModel; use_nlp_block::Bool)
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variables(model, length(data.variable_primal))
    for (xi, lb, ub) in zip(x, data.variable_lower, data.variable_upper)
        if lb > -Inf
            MOI.add_constraint(model, xi, MOI.GreaterThan(lb))
        end
        if ub < Inf
            MOI.add_constraint(model, xi, MOI.LessThan(ub))
        end
    end
    for (xi, type) in zip(x, data.variable_type)
        if type == _INTEGER
            MOI.add_constraint(model, xi, MOI.Integer())
        elseif type == _BINARY
            MOI.add_constraint(model, xi, MOI.ZeroOne())
        end
    end
    MOI.set.(model, MOI.VariablePrimalStart(), x, data.variable_primal)
    if data.objective != :()
        MOI.set(model, MOI.ObjectiveSense(), data.sense)
    end
    if use_nlp_block
        nlp = MOI.Nonlinear.Model()
        if data.objective != :()
            MOI.Nonlinear.set_objective(nlp, data.objective)
        end
        for (i, expr) in enumerate(data.constraints)
            lb, ub = data.constraint_lower[i], data.constraint_upper[i]
            if lb == ub
                MOI.Nonlinear.add_constraint(nlp, expr, MOI.EqualTo(lb))
            elseif -Inf == lb && ub < Inf
                MOI.Nonlinear.add_constraint(nlp, expr, MOI.LessThan(ub))
            elseif -Inf < lb && ub == Inf
                MOI.Nonlinear.add_constraint(nlp, expr, MOI.GreaterThan(lb))
            else
                MOI.Nonlinear.add_constraint(nlp, expr, MOI.Interval(lb, ub))
            end
        end
        evaluator =
            MOI.Nonlinear.Evaluator(nlp, MOI.Nonlinear.SparseReverseMode(), x)
        block = MOI.NLPBlockData(evaluator)
        MOI.set(model, MOI.NLPBlock(), block)
    else
        if data.objective != :()
            obj = _expr_to_function(data.objective)
            MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
        end
        for (i, expr) in enumerate(data.constraints)
            lb, ub = data.constraint_lower[i], data.constraint_upper[i]
            f = _expr_to_function(expr)
            if lb == ub
                MOI.add_constraint(model, f, MOI.EqualTo(lb))
            elseif -Inf == lb && ub < Inf
                MOI.add_constraint(model, f, MOI.LessThan(ub))
            elseif -Inf < lb && ub == Inf
                MOI.add_constraint(model, f, MOI.GreaterThan(lb))
            else
                MOI.add_constraint(model, f, MOI.Interval(lb, ub))
            end
        end
    end
    return model
end

_expr_to_function(expr) = expr

function _expr_to_function(expr::Expr)
    @assert Meta.isexpr(expr, :call)
    f = _try_scalar_affine_function(expr)
    if f !== nothing
        return convert(MOI.ScalarAffineFunction{Float64}, f)
    end
    return MOI.ScalarNonlinearFunction(
        expr.args[1],
        Any[_expr_to_function(arg) for arg in expr.args[2:end]],
    )
end

_try_scalar_affine_function(x::Float64) = x

_try_scalar_affine_function(x::MOI.VariableIndex) = x

function _try_scalar_affine_function(expr::Expr)
    if expr.args[1] == :+
        args = _try_scalar_affine_function.(expr.args[2:end])
        if any(isnothing, args)
            return nothing
        end
        return MOI.Utilities.operate(+, Float64, args...)
    elseif expr.args[1] == :*
        args = _try_scalar_affine_function.(expr.args[2:end])
        if any(isnothing, args)
            return nothing
        end
        n_affine_terms = 0
        for arg in args
            n_affine_terms += arg isa MOI.VariableIndex
            n_affine_terms += arg isa MOI.ScalarAffineFunction{Float64}
        end
        if n_affine_terms <= 1
            return MOI.Utilities.operate(*, Float64, args...)
        end
    end
    return nothing
end

function _parse_header(io::IO, model::_CacheModel)
    # Line 1
    byte = read(io, UInt8)
    # Detect the format. We delay setting `model.is_binary` until the end of
    # this function because the header is _not_ in binary format.
    is_binary = false
    if byte == UInt8('b')
        is_binary = true
    elseif byte != UInt8('g')
        error("Unable to parse NL file : unsupported mode $(Char(byte))")
    end
    # L1 has some magic bytes for AMPL internals (to quote David, "The numbers
    # on the first line matter to AMPL; for other uses, it is best simply to
    # supply the ones shown above.")
    _read_til_newline(io, model)
    # Line 2
    # The number of variables
    n_var = _next(Int, io, model)
    _resize_variables(model, n_var)
    # The number of constraints
    _resize_constraints(model, _next(Int, io, model))
    # The number of linear objectives
    @assert 0 <= _next(Int, io, model) <= 1
    # The number of range constraints
    @assert _next(Int, io, model) >= 0
    # The number of equations
    @assert _next(Int, io, model) >= 0
    # The number of logical constraints. This one is optional, so just read til
    # the end of the line.
    # @assert _next(Int, io, model) == 0
    _read_til_newline(io, model)
    # Line 3
    # The number of nonlinear constraints
    @assert _next(Int, io, model) >= 0
    # The number of nonlinear objectives
    @assert 0 <= _next(Int, io, model) <= 1
    _read_til_newline(io, model)
    # Line 4
    # The number of nonlinear network constraints
    @assert _next(Int, io, model) == 0
    # The number of linear network constraints
    @assert _next(Int, io, model) == 0
    _read_til_newline(io, model)
    # Line 5
    # The number of nonlienar variables in constraints
    nlvc = _next(Int, io, model)
    # The number of nonlienar variables in objectives
    nlvo = _next(Int, io, model)
    # The number of nonlienar variables in constraints and objectives (both)
    nlvb = _next(Int, io, model)
    _read_til_newline(io, model)
    # Line 6
    # The number of linear network variables
    @assert _next(Int, io, model) == 0
    # The number of user-defined functions
    @assert _next(Int, io, model) == 0
    # The number of "arith"
    # TODO(odow): I don't know what this is.
    _next(Int, io, model)
    # The "flags" entry. This is mainly used for specifying that we want duals.
    # Ignore when reading.
    _next(Int, io, model)
    _read_til_newline(io, model)
    # Line 7
    # Number of binary variables
    nbv = _next(Int, io, model)
    # Number of integer variables
    niv = _next(Int, io, model)
    # Number of integer variables in nonlinear constraints AND objectives
    nlvbi = _next(Int, io, model)
    # Number of integer variables in nonlinear constraints
    nlvci = _next(Int, io, model)
    # Number of integer variables in nonlinear objectives
    nlvoi = _next(Int, io, model)
    _read_til_newline(io, model)
    # Line 8
    # Read the number of nonzeros in Jacobian and gradient, but don't do
    # anything with that information.
    @assert _next(Int, io, model) >= 0
    @assert _next(Int, io, model) >= 0
    _read_til_newline(io, model)
    # Line 9
    # We don't support reading variable and constraint names, so just ignore
    # them
    _read_til_newline(io, model)
    # Line 10
    # We don't support reading common subexpressions
    for _ in 1:5
        if _next(Int, io, model) > 0
            error("Unable to parse NL file : we don't support common exprs")
        end
    end
    _read_til_newline(io, model)
    # ==========================================================================
    # Deal with the integrality of variables. This is quite complicated, so go
    # read the README in this folder.
    offsets = [
        nlvb - nlvbi,
        nlvbi,
        nlvc - (nlvb + nlvci),
        nlvci,
        max(0, nlvo - nlvc - nlvoi),
        nlvoi,
        n_var - (max(nlvc, nlvo) + nbv + niv),
        nbv,
        niv,
    ]
    types = [
        _CONTINUOUS,
        _INTEGER,
        _CONTINUOUS,
        _INTEGER,
        _CONTINUOUS,
        _INTEGER,
        _CONTINUOUS,
        _BINARY,
        _INTEGER,
    ]
    offset = 0
    for i in 1:9
        for _ in 1:offsets[i]
            offset += 1
            model.variable_type[offset] = types[i]
        end
    end
    # Delay setting is_binary until the end of the header section
    model.is_binary = is_binary
    return
end

function _parse_section(io::IO, model::_CacheModel)
    char = Char(read(io, UInt8))
    _parse_section(io, Val(char), model)
    return
end

function _parse_section(::IO, ::Val{T}, ::_CacheModel) where {T}
    return error("Unable to parse NL file: unhandled header $T")
end

function _parse_section(::IO, ::Val{'F'}, ::_CacheModel)
    return error(
        "Unable to parse NL file: imported function descriptions ('F' " *
        "sections) are not yet supported. To request support, please open an " *
        "issue at https://github.com/jump-dev/MathOptInterface.jl with a " *
        "reproducible example.",
    )
end

function _parse_section(io::IO, ::Val{'S'}, model::_CacheModel)
    k = _next(Int, io, model)
    n = _next(Int, io, model)
    suffix_name = if model.is_binary
        len = _next(Int, io, model)
        String(read(io, len))
    else
        strip(readline(io))
    end
    @warn("Skipping suffix: `S$k $n $suffix_name`")
    # The “4” bit of k indicates whether the suﬃx is real (that is, double)
    # valued or integer valued: (k&4) != 0 --> real valued.
    T = ifelse(k & 4 != 0, Float64, Int)
    for _ in 1:n
        _ = _next(Int, io, model)
        _ = _next(T, io, model)
        _read_til_newline(io, model)
    end
    return
end

function _parse_section(::IO, ::Val{'V'}, ::_CacheModel)
    return error(
        "Unable to parse NL file: defined variable definitions ('V' sections)" *
        " are not yet supported. To request support, please open an issue at " *
        "https://github.com/jump-dev/MathOptInterface.jl with a reproducible " *
        "example.",
    )
end

function _parse_section(::IO, ::Val{'L'}, ::_CacheModel)
    return error(
        "Unable to parse NL file: logical constraints ('L' sections) are not " *
        "yet supported. To request support, please open an issue at " *
        "https://github.com/jump-dev/MathOptInterface.jl with a reproducible " *
        "example.",
    )
end

function _parse_section(io::IO, ::Val{'C'}, model::_CacheModel)
    index = _next(Int, io, model) + 1
    _read_til_newline(io, model)
    expr = _force_expr(_parse_expr(io, model))
    current = model.constraints[index]
    if current == :()
        model.constraints[index] = expr
    else
        model.constraints[index] = Expr(:call, :+, current, expr)
    end
    return
end

function _parse_section(io::IO, ::Val{'O'}, model::_CacheModel)
    @assert _next(Int, io, model) == 0
    sense = _next(Int, io, model)
    if sense == 1
        model.sense = MOI.MAX_SENSE
    else
        @assert sense == 0
        model.sense = MOI.MIN_SENSE
    end
    _read_til_newline(io, model)
    expr = _force_expr(_parse_expr(io, model))
    if model.objective == :()
        model.objective = expr
    else
        model.objective = Expr(:call, :+, model.objective, expr)
    end
    return
end

function _parse_section(io::IO, ::Val{'x'}, model::_CacheModel)
    index = _next(Int, io, model)
    _read_til_newline(io, model)
    for _ in 1:index
        xi = _next(Int, io, model) + 1
        v = _next(Float64, io, model)
        model.variable_primal[xi] = v
        _read_til_newline(io, model)
    end
    return
end

# TODO(odow): we don't read in dual starts.
function _parse_section(io::IO, ::Val{'d'}, model::_CacheModel)
    n = _next(Int, io, model)
    _read_til_newline(io, model)
    for _ in 1:n
        _ = _next(Int, io, model)
        _ = _next(Float64, io, model)
        _read_til_newline(io, model)
    end
    return
end

function _parse_section(io::IO, ::Val{'r'}, model::_CacheModel)
    _read_til_newline(io, model)
    for i in 1:length(model.constraint_lower)
        type = _next(Cchar, io, model)
        if type == Cchar('0')
            model.constraint_lower[i] = _next(Float64, io, model)
            model.constraint_upper[i] = _next(Float64, io, model)
        elseif type == Cchar('1')
            model.constraint_upper[i] = _next(Float64, io, model)
        elseif type == Cchar('2')
            model.constraint_lower[i] = _next(Float64, io, model)
        elseif type == Cchar('3')
            # Free constraint
        else
            @assert type == Cchar('4')
            value = _next(Float64, io, model)
            model.constraint_lower[i] = value
            model.constraint_upper[i] = value
        end
        _read_til_newline(io, model)
    end
    return
end

function _parse_section(io::IO, ::Val{'b'}, model::_CacheModel)
    _read_til_newline(io, model)
    for i in 1:length(model.variable_lower)
        type = _next(Cchar, io, model)
        if type == Cchar('0')
            model.variable_lower[i] = _next(Float64, io, model)
            model.variable_upper[i] = _next(Float64, io, model)
        elseif type == Cchar('1')
            model.variable_upper[i] = _next(Float64, io, model)
        elseif type == Cchar('2')
            model.variable_lower[i] = _next(Float64, io, model)
        elseif type == Cchar('3')
            # Free variable
        else
            @assert type == Cchar('4')
            value = _next(Float64, io, model)
            model.variable_lower[i] = value
            model.variable_upper[i] = value
        end
        _read_til_newline(io, model)
    end
    return
end

# We ignore jacobian counts for now
function _parse_section(io::IO, ::Val{'k'}, model::_CacheModel)
    n = _next(Int, io, model)
    _read_til_newline(io, model)
    for _ in 1:n
        _ = _next(Int, io, model)
        _read_til_newline(io, model)
    end
    return
end

function _parse_section(io::IO, ::Val{'J'}, model::_CacheModel)
    i = _next(Int, io, model) + 1
    nnz = _next(Int, io, model)
    _read_til_newline(io, model)
    expr = Expr(:call, :+)
    for _ in 1:nnz
        x = _next(Int, io, model)
        c = _next(Float64, io, model)
        if !iszero(c)
            push!(expr.args, Expr(:call, :*, c, MOI.VariableIndex(x + 1)))
        end
        _read_til_newline(io, model)
    end
    if length(expr.args) == 1
        # Linear part is just zeros
    elseif model.constraints[i] == :()
        model.constraints[i] = expr
    else
        model.constraints[i] = Expr(:call, :+, expr, model.constraints[i])
    end
    return
end

function _parse_section(io::IO, ::Val{'G'}, model::_CacheModel)
    i = _next(Int, io, model) + 1
    nnz = _next(Int, io, model)
    _read_til_newline(io, model)
    expr = Expr(:call, :+)
    for _ in 1:nnz
        x = _next(Int, io, model)
        c = _next(Float64, io, model)
        if !iszero(c)
            push!(expr.args, Expr(:call, :*, c, MOI.VariableIndex(x + 1)))
        end
        _read_til_newline(io, model)
    end
    if length(expr.args) == 1
        # Linear part is just zeros
    elseif model.objective == :()
        model.objective = expr
    else
        model.objective = Expr(:call, :+, expr, model.objective)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    ScalarizeBridge{T,F,S}

`ScalarizeBridge` implements the following reformulations:

  * ``f(x) - a \\in \\mathbb{R}_+`` into ``f_i(x) \\ge a_i`` for all ``i``
  * ``f(x) - a \\in \\mathbb{R}_-`` into ``f_i(x) \\le a_i`` for all ``i``
  * ``f(x) - a \\in \\{0\\}`` into ``f_i(x) == a_i`` for all ``i``

## Source node

`ScalarizeBridge` supports:

  * `G` in [`MOI.Nonnegatives{T}`](@ref)
  * `G` in [`MOI.Nonpositives{T}`](@ref)
  * `G` in [`MOI.Zeros{T}`](@ref)

## Target nodes

`ScalarizeBridge` creates:

  * `F` in `S`, where `S` is one of [`MOI.GreaterThan{T}`](@ref),
    [`MOI.LessThan{T}`](@ref), and [`MOI.EqualTo{T}`](@ref), depending on the
    type of the input set.
"""
mutable struct ScalarizeBridge{T,F,S} <: AbstractBridge
    scalar_constraints::Vector{MOI.ConstraintIndex{F,S}}
    constants::Vector{T}
end

const Scalarize{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{ScalarizeBridge{T},OT}

function bridge_constraint(
    ::Type{ScalarizeBridge{T,F,S}},
    model::MOI.ModelLike,
    f::MOI.AbstractVectorFunction,
    set::MOI.Utilities.VectorLinearSet,
) where {T,F,S}
    constraints = MOI.ConstraintIndex{F,S}[
        MOI.Utilities.normalize_and_add_constraint(model, fi, S(zero(T)))
        for fi in MOI.Utilities.eachscalar(f)
    ]
    return ScalarizeBridge{T,F,S}(constraints, MOI.constant(f, T))
end

function MOI.supports_constraint(
    ::Type{ScalarizeBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    S::Type{<:MOI.Utilities.VectorLinearSet},
) where {T}
    # If `F` is `MOI.VectorAffineFunction{Complex{Float64}}`, `S` is `MOI.Zeros`
    # and `T` is `Float64`, it would create a set `MOI.EqualTo{Float64}` which
    # is incorrect hence we say we only support it if the coefficient type of
    # `F` is `T`.
    # If `S` is `MOI.Nonnegatives` or `MOI.Nonpositives` then `T` must be
    # `Real` as otherwise, `scalar_set_type` will fail in `concrete_bridge_type`.
    return MOI.Utilities.is_coefficient_type(F, T) &&
           (S === MOI.Zeros || (T <: Real))
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:ScalarizeBridge})
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{ScalarizeBridge{T,F,S}},
) where {T,F,S}
    return Tuple{Type,Type}[(F, S)]
end

function concrete_bridge_type(
    ::Type{<:ScalarizeBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    S::Type{<:MOI.Utilities.VectorLinearSet},
) where {T}
    return ScalarizeBridge{
        T,
        MOI.Utilities.scalar_type(F),
        MOI.Utilities.scalar_set_type(S, T),
    }
end

function MOI.get(
    bridge::ScalarizeBridge{T,F,S},
    ::MOI.NumberOfConstraints{F,S},
)::Int64 where {T,F,S}
    return length(bridge.scalar_constraints)
end

function MOI.get(
    bridge::ScalarizeBridge{T,F,S},
    ::MOI.ListOfConstraintIndices{F,S},
) where {T,F,S}
    return copy(bridge.scalar_constraints)
end

function MOI.delete(model::MOI.ModelLike, bridge::ScalarizeBridge)
    for ci in bridge.scalar_constraints
        MOI.delete(model, ci)
    end
    return
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::ScalarizeBridge,
    i::MOI.Bridges.IndexInVector,
)
    MOI.delete(model, bridge.scalar_constraints[i.value])
    deleteat!(bridge.scalar_constraints, i.value)
    deleteat!(bridge.constants, i.value)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::ScalarizeBridge{T},
) where {T}
    func = MOI.Utilities.vectorize(
        MOI.get.(model, attr, bridge.scalar_constraints),
    )
    if func isa MOI.VectorOfVariables
        return func
    end
    # `func` is in terms of bridged variables here while in `bridge_constraint`
    # it was in terms of the solver variables so `MOI.constant(set)` might be
    # different than `bridge.constants[i]`.
    for i in eachindex(bridge.scalar_constraints)
        set = MOI.get(model, MOI.ConstraintSet(), bridge.scalar_constraints[i])
        rhs = MOI.constant(set)
        if !iszero(rhs)
            func = MOI.Utilities.operate_output_index!(-, T, i, func, rhs)
        end
    end
    return func
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::ScalarizeBridge{T,F,S},
) where {T,F,S}
    return MOI.Utilities.vector_set_type(S)(length(bridge.scalar_constraints))
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{ScalarizeBridge{T,F,S}},
) where {T,F,S}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F,S})
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::ScalarizeBridge,
)
    return MOI.get.(model, attr, bridge.scalar_constraints) .+ bridge.constants
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::ScalarizeBridge,
)
    values = MOI.get.(model, attr, bridge.scalar_constraints)
    if any(isnothing, values)
        return
    end
    return values .+ bridge.constants
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::ScalarizeBridge,
    ::Nothing,
)
    for ci in bridge.scalar_constraints
        MOI.set(model, attr, ci, nothing)
    end
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::ScalarizeBridge,
    value,
)
    MOI.set.(model, attr, bridge.scalar_constraints, value .- bridge.constants)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    bridge::ScalarizeBridge,
)
    return MOI.get.(model, attr, bridge.scalar_constraints)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::ScalarizeBridge,
)
    values = MOI.get.(model, attr, bridge.scalar_constraints)
    if any(isnothing, values)
        return
    end
    return values
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::ScalarizeBridge,
    value,
)
    MOI.set.(model, attr, bridge.scalar_constraints, value)
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::ScalarizeBridge{T,F,S},
    change::MOI.VectorConstantChange{T},
) where {T,F,S}
    bridge.constants = change.new_constant
    MOI.set.(
        model,
        MOI.ConstraintSet(),
        bridge.scalar_constraints,
        S.(-change.new_constant),
    )
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::ScalarizeBridge,
    change::MOI.MultirowChange{T},
) where {T}
    for (index, value) in change.new_coefficients
        MOI.modify(
            model,
            bridge.scalar_constraints[index],
            MOI.ScalarCoefficientChange{T}(change.variable, value),
        )
    end
    return
end

function MOI.set(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::ScalarizeBridge{T,F,S},
    func,
) where {T,F,S}
    bridge.constants = MOI.constant(func, T)
    for (i, fi) in enumerate(MOI.Utilities.eachscalar(func))
        ci = bridge.scalar_constraints[i]
        if !iszero(bridge.constants[i])
            fi = MOI.Utilities.operate!(-, T, fi, bridge.constants[i])
        end
        MOI.set(model, MOI.ConstraintFunction(), ci, fi)
        MOI.set(model, MOI.ConstraintSet(), ci, S(-bridge.constants[i]))
    end
    return
end

# TODO implement transform

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestMatrixOfConstraints

using Test

import MathOptInterface as MOI
import SparseArrays

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

MOI.Utilities.@product_of_sets(
    ScalarSets,
    MOI.EqualTo{T},
    MOI.GreaterThan{T},
    MOI.LessThan{T},
    MOI.Interval{T},
)

function _new_ScalarSets()
    return MOI.Utilities.GenericOptimizer{
        Float64,
        MOI.Utilities.ObjectiveContainer{Float64},
        MOI.Utilities.VariablesContainer{Float64},
        MOI.Utilities.MatrixOfConstraints{
            Float64,
            MOI.Utilities.MutableSparseMatrixCSC{
                Float64,
                Int,
                MOI.Utilities.ZeroBasedIndexing,
            },
            MOI.Utilities.Hyperrectangle{Float64},
            ScalarSets{Float64},
        },
    }()
end

MOI.Utilities.@product_of_sets(
    VectorSets,
    MOI.Nonnegatives,
    MOI.Nonpositives,
    MOI.SecondOrderCone,
)

function _new_VectorSets(V = VectorSets)
    return MOI.Utilities.GenericOptimizer{
        Int,
        MOI.Utilities.ObjectiveContainer{Int},
        MOI.Utilities.FreeVariables,
        MOI.Utilities.MatrixOfConstraints{
            Int,
            MOI.Utilities.MutableSparseMatrixCSC{
                Int,
                Int,
                MOI.Utilities.OneBasedIndexing,
            },
            Vector{Int},
            V{Int},
        },
    }()
end

function test_ScalarSets_basic()
    model = _new_ScalarSets()
    @test MOI.is_empty(model)
    src = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(
        src,
        """
variables: x, y
minobjective: x + y
x >= 1.0
y == 2.1
c: x + 2.0 * y <= 3.0
""",
    )
    index_map = MOI.copy_to(model, src)
    @test MOI.is_empty(model) == false
    for (k, v) in index_map
        @test MOI.is_valid(src, k)
        @test MOI.is_valid(model, v)
    end
    @test length(MOI.get(src, MOI.ListOfConstraintTypesPresent())) == 3
    MOI.empty!(model)
    @test MOI.is_empty(model)
    return
end

function test_VectorSets_basic()
    model = _new_VectorSets()
    @test MOI.is_empty(model)
    src = MOI.Utilities.Model{Int}()
    x = MOI.add_variables(src, 2)
    c = MOI.add_constraint(
        src,
        MOI.VectorAffineFunction{Int}(
            MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.(1, x)),
            [1, 3],
        ),
        MOI.SecondOrderCone(2),
    )
    index_map = MOI.copy_to(model, src)
    @test MOI.is_empty(model) == false
    for (k, v) in index_map
        @test MOI.is_valid(src, k)
        @test MOI.is_valid(model, v)
    end
    @test length(MOI.get(model, MOI.ListOfConstraintTypesPresent())) == 1
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    @test MOI.get(model, MOI.ListOfVariableIndices()) == MOI.VariableIndex.(1:2)
    MOI.empty!(model)
    @test MOI.is_empty(model)
    return
end

function test_ScalarSets_supports_constraint()
    model = _new_ScalarSets()
    @test MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{Float64},
        MOI.LessThan{Float64},
    )
    @test !MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{Float64},
        MOI.Nonnegatives,
    )
    return
end

function test_VectorSets_supports_constraint()
    model = _new_VectorSets()
    @test !MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{Float64},
        MOI.LessThan{Float64},
    )
    @test MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{Int},
        MOI.Nonnegatives,
    )
    return
end

function test_delete()
    model = _new_ScalarSets()
    x = MOI.add_variable(model)
    @test_throws MOI.DeleteNotAllowed MOI.delete(model, x)
    @test_throws MOI.DeleteNotAllowed MOI.delete(model, [x])
    return
end

function test_ScalarSets_get_ConstraintFunction()
    model = _new_ScalarSets()
    src = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(
        src,
        """
variables: x, y
minobjective: x + y
c: x + 2.0 * y <= 3.0
""",
    )
    index_map = MOI.copy_to(model, src)
    c = MOI.get(model, MOI.ConstraintIndex, "c")
    c_f = MOI.get(model, MOI.ConstraintFunction(), c)
    @test MOI.Utilities.map_indices(c_f) do x
        return index_map[x]
    end ≈ MOI.get(src, MOI.ConstraintFunction(), index_map[c])
    return
end

function test_VectorSets_get_ConstraintFunction()
    model = _new_VectorSets()
    src = MOI.Utilities.Model{Int}()
    x = MOI.add_variables(src, 2)
    c = MOI.add_constraint(
        src,
        MOI.VectorAffineFunction{Int}(
            MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.(1, x)),
            [1, 3],
        ),
        MOI.SecondOrderCone(2),
    )
    index_map = MOI.copy_to(model, src)
    c_f = MOI.get(model, MOI.ConstraintFunction(), c)
    @test MOI.Utilities.map_indices(c_f) do x
        return index_map[x]
    end ≈ MOI.get(src, MOI.ConstraintFunction(), index_map[c])
    return
end

function test_ScalarSets_get_ConstraintSet()
    model = _new_ScalarSets()
    src = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(
        src,
        """
variables: x, y
minobjective: x + y
c: 2.0 * x + y >= 4.0
""",
    )
    index_map = MOI.copy_to(model, src)
    c = MOI.get(model, MOI.ConstraintIndex, "c")
    c_set = MOI.get(model, MOI.ConstraintSet(), c)
    @test c_set == MOI.get(src, MOI.ConstraintSet(), index_map[c])
    return
end

function test_VectorSets_get_ConstraintSet()
    model = _new_VectorSets()
    src = MOI.Utilities.Model{Int}()
    x = MOI.add_variables(src, 2)
    c = MOI.add_constraint(
        src,
        MOI.VectorAffineFunction{Int}(
            MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.(1, x)),
            [1, 3],
        ),
        MOI.SecondOrderCone(2),
    )
    index_map = MOI.copy_to(model, src)
    c_set = MOI.get(model, MOI.ConstraintSet(), c)
    @test c_set == MOI.get(src, MOI.ConstraintSet(), index_map[c])
    return
end

function test_add_after_final_touch()
    model = _new_ScalarSets()
    @test MOI.is_empty(model)
    src = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(
        src,
        """
variables: x, y
minobjective: x + y
x >= 1.0
y == 2.1
c: x + 2.0 * y <= 3.0
""",
    )
    index_map = MOI.copy_to(model, src)
    x = MOI.get(src, MOI.VariableIndex, "x")
    @test_throws(
        MOI.AddConstraintNotAllowed,
        MOI.add_constraint(
            model,
            MOI.ScalarAffineFunction(
                [MOI.ScalarAffineTerm(1.0, index_map[x])],
                0.0,
            ),
            MOI.LessThan(2.0),
        ),
    )
    return
end

function test_UnsupportedConstraint()
    model = _new_ScalarSets()
    src = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(
        src,
        """
variables: x, y
c: [x, y] in Nonnegatives(2)
""",
    )
    @test_throws MOI.UnsupportedConstraint MOI.copy_to(model, src)
    return
end

function test_ScalarSets()
    optimizer = MOI.Utilities.GenericOptimizer{
        Float64,
        MOI.Utilities.ObjectiveContainer{Float64},
        MOI.Utilities.VariablesContainer{Float64},
        MOI.Utilities.MatrixOfConstraints{
            Float64,
            MOI.Utilities.MutableSparseMatrixCSC{
                Float64,
                Int,
                MOI.Utilities.ZeroBasedIndexing,
            },
            MOI.Utilities.Hyperrectangle{Float64},
            ScalarSets{Float64},
        },
    }()
    MOI.Test.runtests(
        optimizer,
        MOI.Test.Config(exclude = Any[MOI.optimize!]),
        include = ["test_model_", "test_objective_", "test_variable_"],
        exclude = [
            "test_model_ScalarFunctionConstantNotZero",
            "test_model_default_DualStatus",
            "test_model_default_PrimalStatus",
            "test_model_default_TerminationStatus",
        ],
    )
    return
end

function test_modify()
    model = MOI.Utilities.GenericOptimizer{
        Int,
        MOI.Utilities.ObjectiveContainer{Int},
        MOI.Utilities.VariablesContainer{Int},
        MOI.Utilities.MatrixOfConstraints{
            Int,
            MOI.Utilities.MutableSparseMatrixCSC{
                Int,
                Int,
                MOI.Utilities.OneBasedIndexing,
            },
            MOI.Utilities.Hyperrectangle{Int},
            ScalarSets{Int},
        },
    }()
    x = MOI.add_variable(model)
    func = 2x
    set = MOI.EqualTo(1)
    c = MOI.add_constraint(model, func, set)
    MOI.Utilities.final_touch(model, nothing)
    @test_throws MOI.DeleteNotAllowed(c) MOI.delete(model, c)
    err = MOI.AddConstraintNotAllowed{typeof(func),typeof(set)}(
        MOI.Utilities._MATRIXOFCONSTRAINTS_MODIFY_NOT_ALLOWED_ERROR_MESSAGE,
    )
    @test_throws err MOI.add_constraint(model, func, set)
    return
end

MOI.Utilities.@struct_of_constraints_by_set_types(
    ZerosOrNot,
    MOI.Zeros,
    Union{MOI.Nonnegatives,MOI.Nonpositives},
)

MOI.Utilities.@product_of_sets(Zeros, MOI.Zeros)

function test_multicone()
    T = Int
    Indexing = MOI.Utilities.OneBasedIndexing
    model = MOI.Utilities.GenericOptimizer{
        T,
        MOI.Utilities.ObjectiveContainer{T},
        MOI.Utilities.VariablesContainer{T},
        ZerosOrNot{T}{
            MOI.Utilities.MatrixOfConstraints{
                T,
                MOI.Utilities.MutableSparseMatrixCSC{T,Int,Indexing},
                Vector{T},
                Zeros{T},
            },
            MOI.Utilities.MatrixOfConstraints{
                T,
                MOI.Utilities.MutableSparseMatrixCSC{T,Int,Indexing},
                Vector{T},
                VectorSets{T},
            },
        },
    }()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.add_constraint(
        model,
        MOI.Utilities.vectorize([T(5) * x + T(2)]),
        MOI.Zeros(1),
    )
    MOI.add_constraint(
        model,
        MOI.Utilities.vectorize([T(3) * y + T(1)]),
        MOI.Nonnegatives(1),
    )
    MOI.add_constraint(
        model,
        MOI.Utilities.vectorize([T(6), T(7) * x, T(4)]),
        MOI.Nonpositives(1),
    )
    MOI.Utilities.final_touch(model, nothing)
    @test convert(
        SparseArrays.SparseMatrixCSC{T,Int},
        model.constraints.moi_zeros.coefficients,
    ) == [T(5) zero(T)]
    @test model.constraints.moi_zeros.constants == T[2]
    @test convert(
        SparseArrays.SparseMatrixCSC{T,Int},
        model.constraints.moi_nonnegatives.coefficients,
    ) == [zero(T) T(3); zero(T) zero(T); T(7) zero(T); zero(T) zero(T)]
    @test model.constraints.moi_nonnegatives.constants == T[1, 6, 0, 4]
    return
end

MOI.Utilities.@product_of_sets(
    MatrixSets,
    MOI.PositiveSemidefiniteConeTriangle,
    MOI.PositiveSemidefiniteConeSquare,
    MOI.LogDetConeTriangle,
    MOI.LogDetConeSquare,
    MOI.RootDetConeTriangle,
    MOI.RootDetConeSquare,
)

function test_matrix_sets(::Type{T} = Int) where {T}
    model = MOI.Utilities.GenericOptimizer{
        T,
        MOI.Utilities.ObjectiveContainer{T},
        MOI.Utilities.VariablesContainer{T},
        MOI.Utilities.MatrixOfConstraints{
            T,
            MOI.Utilities.MutableSparseMatrixCSC{
                T,
                T,
                MOI.Utilities.OneBasedIndexing,
            },
            Vector{T},
            MatrixSets{T},
        },
    }()
    function test_set(set)
        MOI.empty!(model)
        func = MOI.Utilities.zero_with_output_dimension(
            MOI.VectorAffineFunction{T},
            MOI.dimension(set),
        )
        ci = MOI.add_constraint(model, func, set)
        MOI.Utilities.final_touch(model, nothing)
        @test MOI.get(model, MOI.ConstraintSet(), ci) == set
    end
    test_set(MOI.PositiveSemidefiniteConeTriangle(2))
    test_set(MOI.PositiveSemidefiniteConeSquare(2))
    test_set(MOI.LogDetConeTriangle(2))
    test_set(MOI.LogDetConeSquare(2))
    test_set(MOI.RootDetConeTriangle(2))
    test_set(MOI.RootDetConeSquare(2))
    return
end

MOI.Utilities.@product_of_sets(
    PowerSets,
    MOI.PowerCone{T},
    MOI.DualPowerCone{T},
)

function test_power_cone_error()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(model, 3)
    f = MOI.Utilities.operate(vcat, Float64, 1.0 .* x...)
    s = MOI.PowerCone(0.2)
    MOI.add_constraint(model, f, s)
    cache = MOI.Utilities.GenericOptimizer{
        Float64,
        MOI.Utilities.ObjectiveContainer{Float64},
        MOI.Utilities.VariablesContainer{Float64},
        MOI.Utilities.MatrixOfConstraints{
            Float64,
            MOI.Utilities.MutableSparseMatrixCSC{
                Float64,
                Int,
                MOI.Utilities.OneBasedIndexing,
            },
            Vector{Float64},
            PowerSets{Float64},
        },
    }()
    @test_throws(
        ErrorException(
            "`$(typeof(s))` cannot be used with `Vector` as the set type in " *
            "MatrixOfConstraints",
        ),
        MOI.copy_to(cache, model),
    )
    return
end

function test_dual_power_cone_error()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(model, 3)
    f = MOI.Utilities.operate(vcat, Float64, 1.0 .* x...)
    s = MOI.DualPowerCone(0.2)
    MOI.add_constraint(model, f, s)
    cache = MOI.Utilities.GenericOptimizer{
        Float64,
        MOI.Utilities.ObjectiveContainer{Float64},
        MOI.Utilities.VariablesContainer{Float64},
        MOI.Utilities.MatrixOfConstraints{
            Float64,
            MOI.Utilities.MutableSparseMatrixCSC{
                Float64,
                Int,
                MOI.Utilities.OneBasedIndexing,
            },
            Vector{Float64},
            PowerSets{Float64},
        },
    }()
    @test_throws(
        ErrorException(
            "`$(typeof(s))` cannot be used with `Vector` as the set type in " *
            "MatrixOfConstraints",
        ),
        MOI.copy_to(cache, model),
    )
    return
end

struct _SetConstants{T}
    b::Vector{T}
    power_coefficients::Dict{Int,T}
    _SetConstants{T}() where {T} = new{T}(T[], Dict{Int,T}())
end

function Base.empty!(x::_SetConstants)
    empty!(x.b)
    empty!(x.power_coefficients)
    return x
end

Base.resize!(x::_SetConstants, n) = resize!(x.b, n)

function MOI.Utilities.load_constants(x::_SetConstants, offset, f)
    MOI.Utilities.load_constants(x.b, offset, f)
    return
end

function MOI.Utilities.load_constants(
    x::_SetConstants{T},
    offset,
    set::Union{MOI.PowerCone{T},MOI.DualPowerCone{T}},
) where {T}
    x.power_coefficients[offset+1] = set.exponent
    return
end

function MOI.Utilities.function_constants(x::_SetConstants, rows)
    return MOI.Utilities.function_constants(x.b, rows)
end

function MOI.Utilities.set_from_constants(x::_SetConstants, S, rows)
    return MOI.Utilities.set_from_constants(x.b, S, rows)
end

function MOI.Utilities.set_from_constants(
    x::_SetConstants{T},
    ::Type{S},
    rows,
) where {T,S<:Union{MOI.PowerCone{T},MOI.DualPowerCone{T}}}
    @assert length(rows) == 3
    return S(x.power_coefficients[first(rows)])
end

function test_dual_power_cone()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(model, 3)
    f = MOI.Utilities.operate(vcat, Float64, 1.0 .* x...)
    p_cone = MOI.PowerCone(0.1)
    p_ref = MOI.add_constraint(model, f, p_cone)
    d_cone = MOI.DualPowerCone(0.2)
    d_ref = MOI.add_constraint(model, f, d_cone)
    cache = MOI.Utilities.GenericOptimizer{
        Float64,
        MOI.Utilities.ObjectiveContainer{Float64},
        MOI.Utilities.VariablesContainer{Float64},
        MOI.Utilities.MatrixOfConstraints{
            Float64,
            MOI.Utilities.MutableSparseMatrixCSC{
                Float64,
                Int,
                MOI.Utilities.OneBasedIndexing,
            },
            _SetConstants{Float64},
            PowerSets{Float64},
        },
    }()
    map = MOI.copy_to(cache, model)
    @test MOI.get(cache, MOI.ConstraintSet(), map[p_ref]) == p_cone
    @test MOI.get(cache, MOI.ConstraintSet(), map[d_ref]) == d_cone
    return
end

function test_duplicate()
    model = _new_ScalarSets()
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0x + 2.0x, MOI.EqualTo(-1.0))
    MOI.Utilities.final_touch(model, nothing)
    @test MOI.get(model, MOI.ConstraintFunction(), c) ≈ 3.0x
    @test MOI.get(model, MOI.ConstraintSet(), c) == MOI.EqualTo(-1.0)
    return
end

function test_set_with_dimension()
    for S in (MOI.ExponentialCone, MOI.DualExponentialCone)
        @test MOI.Utilities.set_with_dimension(S, 3) == S()
        @test_throws AssertionError MOI.Utilities.set_with_dimension(S, 2)
        @test_throws AssertionError MOI.Utilities.set_with_dimension(S, 4)
    end
    S = MOI.PositiveSemidefiniteConeTriangle
    set = MOI.Utilities.set_with_dimension(MOI.Scaled{S}, 3)
    @test MOI.side_dimension(set) == 2
    S = MOI.HermitianPositiveSemidefiniteConeTriangle
    set = MOI.Utilities.set_with_dimension(MOI.Scaled{S}, 4)
    @test MOI.side_dimension(set) == 2
    return
end

MOI.Utilities.@product_of_sets(EmptyProductOfSets)

function test_empty_product_of_sets(T = Int)
    model = _new_VectorSets(EmptyProductOfSets)
    x = MOI.add_variable(model)
    MOI.Utilities.final_touch(model, nothing)
    A = convert(
        SparseArrays.SparseMatrixCSC{T,Int},
        model.constraints.coefficients,
    )
    @test size(A) == (0, 1)
    return
end

function test_set_types_fallback()
    @test_throws MethodError MOI.Utilities.set_types(1)
    return
end

function test_modify_vectorsets()
    model = _new_VectorSets()
    src = MOI.Utilities.Model{Int}()
    x = MOI.add_variables(src, 2)
    c = MOI.add_constraint(
        src,
        MOI.VectorAffineFunction{Int}(
            MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.(1, x)),
            [1, 3],
        ),
        MOI.SecondOrderCone(2),
    )
    index_map = MOI.copy_to(model, src)
    f_c = MOI.get(model, MOI.ConstraintFunction(), index_map[c])
    @test f_c.constants == [1, 3]
    MOI.modify(model, index_map[c], MOI.VectorConstantChange([4, 5]))
    f_c = MOI.get(model, MOI.ConstraintFunction(), index_map[c])
    @test f_c.constants == [4, 5]
    return
end

function test_modify_set_constants()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(model, 3)
    f = MOI.Utilities.operate(vcat, Float64, 1.0 .* x...)
    p_cone = MOI.PowerCone(0.1)
    p_ref = MOI.add_constraint(model, f, p_cone)
    d_cone = MOI.DualPowerCone(0.2)
    d_ref = MOI.add_constraint(model, f, d_cone)
    cache = MOI.Utilities.GenericOptimizer{
        Float64,
        MOI.Utilities.ObjectiveContainer{Float64},
        MOI.Utilities.VariablesContainer{Float64},
        MOI.Utilities.MatrixOfConstraints{
            Float64,
            MOI.Utilities.MutableSparseMatrixCSC{
                Float64,
                Int,
                MOI.Utilities.OneBasedIndexing,
            },
            _SetConstants{Float64},
            PowerSets{Float64},
        },
    }()
    index_map = MOI.copy_to(cache, model)
    ci = index_map[p_ref]
    change = MOI.VectorConstantChange([4.0, 5.0, 6.0])
    @test_throws(
        MOI.ModifyConstraintNotAllowed(ci, change),
        MOI.modify(cache, ci, change),
    )
    return
end

function test_unsupported_constraint()
    model = _new_ScalarSets()
    x = MOI.VariableIndex(1)
    @test_throws(
        MOI.UnsupportedConstraint{MOI.VariableIndex,MOI.ZeroOne}(),
        MOI.add_constraint(model.constraints, x, MOI.ZeroOne()),
    )
    src = MOI.Utilities.Model{Float64}()
    index_map = MOI.Utilities.IndexMap()
    @test_throws(
        MOI.UnsupportedConstraint{MOI.VariableIndex,MOI.ZeroOne}(),
        MOI.Utilities._allocate_constraints(
            model.constraints,
            src,
            index_map,
            MOI.VariableIndex,
            MOI.ZeroOne,
        ),
    )
    MOI.Utilities.final_touch(model, index_map)
    @test_throws AssertionError MOI.Utilities.final_touch(model, index_map)
    MOI.Utilities.final_touch(model, nothing)
    return
end

end

TestMatrixOfConstraints.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestPenaltyRelaxation

using Test
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function _test_roundtrip(src_str, relaxed_str)
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, src_str)
    map = MOI.modify(model, MOI.Utilities.PenaltyRelaxation())
    for (c, v) in map
        @test v isa MOI.ScalarAffineFunction{Float64}
    end
    dest = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(dest, relaxed_str)
    MOI.Bridges._test_structural_identical(model, dest)
    return
end

function test_relax_bounds()
    src_str = """
    variables: x, y
    minobjective: x + y
    x >= 0.0
    y <= 0.0
    x in ZeroOne()
    y in Integer()
    """
    relaxed_str = """
    variables: x, y
    minobjective: x + y
    x >= 0.0
    y <= 0.0
    x in ZeroOne()
    y in Integer()
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, src_str)
    @test_logs(
        (:warn,),
        (:warn,),
        (:warn,),
        (:warn,),
        MOI.modify(model, MOI.Utilities.PenaltyRelaxation()),
    )
    dest = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(dest, relaxed_str)
    MOI.Bridges._test_structural_identical(model, dest)
    return
end

function test_relax_no_warn()
    input = """
    variables: x, y
    minobjective: x + y
    x >= 0.0
    y <= 0.0
    x in ZeroOne()
    y in Integer()
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, input)
    relaxation = MOI.Utilities.PenaltyRelaxation(; warn = false)
    @test_logs MOI.modify(model, relaxation)
    dest = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(dest, input)
    MOI.Bridges._test_structural_identical(model, dest)
    return
end

function test_relax_variable_index_objective()
    _test_roundtrip(
        """
        variables: x, y
        minobjective: x
        c1: x + y <= 1.0
        """,
        """
        variables: x, y, a
        minobjective: 1.0 * x + 1.0 * a
        c1: x + y + -1.0 * a <= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_scalar_nonlinear_objective()
    _test_roundtrip(
        """
        variables: x, y
        minobjective: ScalarNonlinearFunction(exp(x))
        c1: x + y <= 1.0
        """,
        """
        variables: x, y, a
        minobjective: ScalarNonlinearFunction(+(exp(x), esc(1.0 * a)))
        c1: x + y + -1.0 * a <= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_affine_lessthan()
    _test_roundtrip(
        """
        variables: x, y
        minobjective: x + y
        c1: x + y <= 1.0
        """,
        """
        variables: x, y, a
        minobjective: x + y + a
        c1: x + y + -1.0 * a <= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_affine_lessthan_max()
    _test_roundtrip(
        """
        variables: x, y
        maxobjective: x + y
        c1: x + y <= 1.0
        """,
        """
        variables: x, y, a
        maxobjective: x + y + -1.0 * a
        c1: x + y + -1.0 * a <= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_affine_lessthan_no_objective()
    _test_roundtrip(
        """
        variables: x, y
        c1: x + y <= 1.0
        """,
        """
        variables: x, y, a
        minobjective: 1.0 * a
        c1: x + y + -1.0 * a <= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_affine_lessthan_quad_objective()
    _test_roundtrip(
        """
        variables: x, y
        maxobjective: 1.0 * x * y
        c1: x + y <= 1.0
        """,
        """
        variables: x, y, a
        maxobjective: 1.0 * x * y + -1.0 * a
        c1: x + y + -1.0 * a <= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_affine_greaterthan()
    _test_roundtrip(
        """
        variables: x, y
        minobjective: x + y
        c1: x + y >= 1.0
        """,
        """
        variables: x, y, a
        minobjective: x + y + a
        c1: x + y + 1.0 * a >= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_affine_equalto()
    _test_roundtrip(
        """
        variables: x, y
        minobjective: x + y
        c1: x + y == 1.0
        """,
        """
        variables: x, y, a, b
        minobjective: x + y + a + b
        c1: x + y + 1.0 * a + -1.0 * b == 1.0
        a >= 0.0
        b >= 0.0
        """,
    )
    return
end

function test_relax_affine_interval()
    _test_roundtrip(
        """
        variables: x, y
        minobjective: x + y
        c1: x + y in Interval(5.0, 6.0)
        """,
        """
        variables: x, y, a, b
        minobjective: x + y + a + b
        c1: x + y + 1.0 * a + -1.0 * b in Interval(5.0, 6.0)
        a >= 0.0
        b >= 0.0
        """,
    )
    return
end

function test_relax_quadratic_lessthan()
    _test_roundtrip(
        """
        variables: x, y
        maxobjective: x + y
        c1: 1.0 * x * x + 2.0 * x * y <= 1.0
        """,
        """
        variables: x, y, a
        maxobjective: x + y + -1.0 * a
        c1: 1.0 * x * x + 2.0 * x * y + -1.0 * a <= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_quadratic_greaterthanthan()
    _test_roundtrip(
        """
        variables: x, y
        maxobjective: x + y
        c1: 1.0 * x * x + 2.0 * x * y >= 1.0
        """,
        """
        variables: x, y, a
        maxobjective: x + y + -1.0 * a
        c1: 1.0 * x * x + 2.0 * x * y + 1.0 * a >= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_scalarnonlinear_lessthan()
    _test_roundtrip(
        """
        variables: x
        maxobjective: 1.0 * x
        c1: ScalarNonlinearFunction(log(x)) <= 1.0
        """,
        """
        variables: x, a
        maxobjective: 1.0 * x + -1.0 * a
        c1: ScalarNonlinearFunction(log(x) - a) <= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_scalarnonlinear_greaterthan()
    _test_roundtrip(
        """
        variables: x
        maxobjective: 1.0 * x
        c1: ScalarNonlinearFunction(log(x)) >= 1.0
        """,
        """
        variables: x, a
        maxobjective: 1.0 * x + -1.0 * a
        c1: ScalarNonlinearFunction(log(x) + a) >= 1.0
        a >= 0.0
        """,
    )
    return
end

function test_relax_scalarnonlinear_equalto()
    _test_roundtrip(
        """
        variables: x
        minobjective: 1.0 * x
        c1: ScalarNonlinearFunction(log(x)) == 1.0
        """,
        """
        variables: x, a, b
        minobjective: 1.0 * x + 1.0 * a + 1.0 * b
        c1: ScalarNonlinearFunction(+(log(x), a, -b)) == 1.0
        a >= 0.0
        b >= 0.0
        """,
    )
    return
end

function test_penalty_dict()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(2.0))
    map = MOI.modify(model, MOI.Utilities.PenaltyRelaxation(Dict(c => 2.0)))
    @test map[c] isa MOI.ScalarAffineFunction{Float64}
    @test sprint(print, model) === """
    Minimize ScalarAffineFunction{Float64}:
     0.0 + 2.0 v[2] + 2.0 v[3]

    Subject to:

    ScalarAffineFunction{Float64}-in-EqualTo{Float64}
     0.0 + 1.0 v[1] + 1.0 v[2] - 1.0 v[3] == 2.0

    VariableIndex-in-GreaterThan{Float64}
     v[2] >= 0.0
     v[3] >= 0.0
    """
    return
end

function test_default()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(2.0))
    map = MOI.modify(model, MOI.Utilities.PenaltyRelaxation(default = 2.0))
    @test map[c] isa MOI.ScalarAffineFunction{Float64}
    @test sprint(print, model) === """
    Minimize ScalarAffineFunction{Float64}:
     0.0 + 2.0 v[2] + 2.0 v[3]

    Subject to:

    ScalarAffineFunction{Float64}-in-EqualTo{Float64}
     0.0 + 1.0 v[1] + 1.0 v[2] - 1.0 v[3] == 2.0

    VariableIndex-in-GreaterThan{Float64}
     v[2] >= 0.0
     v[3] >= 0.0
    """
    return
end

function test_default_nothing()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(2.0))
    map = MOI.modify(model, MOI.Utilities.PenaltyRelaxation(default = nothing))
    @test !haskey(map, c)
    @test sprint(print, model) === """
    Feasibility

    Subject to:

    ScalarAffineFunction{Float64}-in-EqualTo{Float64}
     0.0 + 1.0 v[1] == 2.0
    """
    return
end

function test_brige_optimizer()
    model = MOI.instantiate(
        MOI.Utilities.Model{Float64};
        with_bridge_type = Float64,
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(2.0))
    map = MOI.modify(model, MOI.Utilities.PenaltyRelaxation(default = 2.0))
    @test map[c] isa MOI.ScalarAffineFunction{Float64}
    @test sprint(print, model) === """
    Minimize ScalarAffineFunction{Float64}:
     0.0 + 2.0 v[2] + 2.0 v[3]

    Subject to:

    ScalarAffineFunction{Float64}-in-EqualTo{Float64}
     0.0 + 1.0 v[1] + 1.0 v[2] - 1.0 v[3] == 2.0

    VariableIndex-in-GreaterThan{Float64}
     v[2] >= 0.0
     v[3] >= 0.0
    """
    return
end

function test_caching_optimizer()
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        MOI.Bridges.full_bridge_optimizer(
            MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}()),
            Float64,
        ),
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(2.0))
    map = MOI.modify(model, MOI.Utilities.PenaltyRelaxation(default = 2.0))
    @test map[c] isa MOI.ScalarAffineFunction{Float64}
    @test sprint(print, model) === """
    Minimize ScalarAffineFunction{Float64}:
     0.0 + 2.0 v[2] + 2.0 v[3]

    Subject to:

    ScalarAffineFunction{Float64}-in-EqualTo{Float64}
     0.0 + 1.0 v[1] + 1.0 v[2] - 1.0 v[3] == 2.0

    VariableIndex-in-GreaterThan{Float64}
     v[2] >= 0.0
     v[3] >= 0.0
    """
    return
end

function test_scalar_penalty_relaxation()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0))
    f = MOI.modify(model, c, MOI.Utilities.ScalarPenaltyRelaxation(2.0))
    @test f isa MOI.ScalarAffineFunction{Float64}
    @test sprint(print, model) === """
    Minimize ScalarAffineFunction{Float64}:
     0.0 + 2.0 v[2]

    Subject to:

    ScalarAffineFunction{Float64}-in-LessThan{Float64}
     0.0 + 1.0 v[1] - 1.0 v[2] <= 2.0

    VariableIndex-in-GreaterThan{Float64}
     v[2] >= 0.0
    """
    return
end

function test_scalar_penalty_relaxation_vector_objective()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = MOI.VectorOfVariables([x])
    MOI.set(model, MOI.ObjectiveFunction{MOI.VectorOfVariables}(), f)
    @test_throws(
        ErrorException(
            "Cannot perform `ScalarPenaltyRelaxation` with an objective function of type `$(typeof(f))`",
        ),
        MOI.modify(model, c, MOI.Utilities.ScalarPenaltyRelaxation(2.0)),
    )
    return
end

end  # module

TestPenaltyRelaxation.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    test_constraint_get_ConstraintIndex(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test getting constraints by name.
"""
function test_constraint_get_ConstraintIndex(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    x = MOI.add_variable(model)
    f = T(1) * x
    CI = MOI.ConstraintIndex{typeof(f),MOI.GreaterThan{T}}
    @requires MOI.supports(model, MOI.ConstraintName(), CI)
    c1 = MOI.add_constraint(model, f, MOI.GreaterThan(T(1)))
    MOI.set(model, MOI.ConstraintName(), c1, "c1")
    c2 = MOI.add_constraint(model, f, MOI.LessThan(T(2)))
    MOI.set(model, MOI.ConstraintName(), c2, "c2")
    F = MOI.ScalarAffineFunction{T}
    @test MOI.get(model, MOI.ConstraintIndex, "c3") === nothing
    @test MOI.get(model, MOI.ConstraintIndex{F,MOI.LessThan{T}}, "c1") ===
          nothing
    @test MOI.get(model, MOI.ConstraintIndex{F,MOI.GreaterThan{T}}, "c2") ===
          nothing
    c1 = MOI.get(model, MOI.ConstraintIndex{F,MOI.GreaterThan{T}}, "c1")
    @test MOI.get(model, MOI.ConstraintIndex, "c1") == c1
    @test MOI.is_valid(model, c1)
    c2 = MOI.get(model, MOI.ConstraintIndex{F,MOI.LessThan{T}}, "c2")
    @test MOI.get(model, MOI.ConstraintIndex, "c2") == c2
    @test MOI.is_valid(model, c2)
    return
end

"""
    test_constraint_ScalarAffineFunction_LessThan(
        model::MOI.ModelLike,
        config::Config,
    )

Add an ScalarAffineFunction-in-LessThan constraint.
"""
function test_constraint_ScalarAffineFunction_LessThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(0)),
        MOI.LessThan(T(1)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0)),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 2),
        variable_primal = [(x, T(1 // 2))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(-1 // 2))],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_ScalarAffineFunction_LessThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1//2],
        ),
    )
    return
end

"""
    test_constraint_ScalarAffineFunction_GreaterThan(
        model::MOI.ModelLike,
        config::Config,
    )

Add an ScalarAffineFunction-in-GreaterThan constraint.
"""
function test_constraint_ScalarAffineFunction_GreaterThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.GreaterThan{T},
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(0)),
        MOI.GreaterThan(T(1)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0)),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 2),
        variable_primal = [(x, T(1 // 2))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(1 // 2))],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_ScalarAffineFunction_GreaterThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) => T[1//2],
        ),
    )
    return
end

"""
    test_constraint_ScalarAffineFunction_EqualTo(
        model::MOI.ModelLike,
        config::Config,
    )

Add an ScalarAffineFunction-in-EqualTo constraint.
"""
function test_constraint_ScalarAffineFunction_EqualTo(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(0)),
        MOI.EqualTo(T(1)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0)),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 2),
        variable_primal = [(x, T(1 // 2))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(1 // 2))],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_ScalarAffineFunction_EqualTo),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}) => T[1//2],
        ),
    )
    return
end

"""
    test_constraint_ScalarAffineFunction_Interval(
        model::MOI.ModelLike,
        config::Config,
    )

Add an ScalarAffineFunction-in-Interval constraint.
"""
function test_constraint_ScalarAffineFunction_Interval(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.Interval{T},
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(0)),
        MOI.Interval(T(1), T(4)),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(3), x)], T(0)),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(6),
        variable_primal = [(x, T(2))],
        constraint_primal = [(c, T(4))],
        constraint_dual = [(c, T(-3 // 2))],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_ScalarAffineFunction_Interval),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.Interval{T}) => T[-3//2],
        ),
    )
    return
end

"""
    test_constraint_ScalarAffineFunction_duplicate(
        model::MOI.ModelLike,
        config::Config,
    )

Add a `ScalarAffineFunction`-in-`LessThan` constraint with duplicate terms in
the function.

Taken from https://github.com/JuliaOpt/MathOptInterfaceMosek.jl/issues/41
"""
function test_constraint_ScalarAffineFunction_duplicate(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    objective_function =
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    MOI.set(
        model,
        MOI.ObjectiveFunction{typeof(objective_function)}(),
        objective_function,
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), [x, x]), T(0))
    c = MOI.add_constraint(model, f, MOI.LessThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 2),
        variable_primal = [(x, T(1 // 2))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(-1 // 2))],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_ScalarAffineFunction_duplicate),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1//2],
        ),
    )
    return
end

"""
    test_constraint_VectorAffineFunction_duplicate(
        model::MOI.ModelLike,
        config::Config,
    )

Add a `VectorAffineFunction`-in-`Nonpositives` constraint with duplicate terms
in the function.
"""
function test_constraint_VectorAffineFunction_duplicate(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    objective_function =
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    MOI.set(
        model,
        MOI.ObjectiveFunction{typeof(objective_function)}(),
        objective_function,
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.(T(1), [x, x])),
        T[-1],
    )
    c = MOI.add_constraint(model, f, MOI.Nonpositives(1))
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 2),
        variable_primal = [(x, T(1 // 2))],
        constraint_primal = [(c, T[0])],
        constraint_dual = [(c, T[-1//2])],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_VectorAffineFunction_duplicate),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2]),
            MOI.FEASIBLE_POINT,
            (MOI.VectorAffineFunction{T}, MOI.Nonpositives) => [T[-1//2]],
        ),
    )
    return
end

"""
    test_constraint_qcp_duplicate_diagonal(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a QCP problem with a duplicate diagonal term.

The problem is `max x + 2y | y + x^2 + x^2 <= 1, x >= 0.5, y >= 0.5`.
"""
function test_constraint_qcp_duplicate_diagonal(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[1, 2], x), T(0)),
    )
    vc1 = MOI.add_constraint(model, x[1], MOI.GreaterThan(T(1 // 2)))
    # We test this after the creation of every `VariableIndex` constraint
    # to ensure a good coverage of corner cases.
    @test vc1.value == x[1].value
    vc2 = MOI.add_constraint(model, x[2], MOI.GreaterThan(T(1 // 2)))
    @test vc2.value == x[2].value
    MOI.add_constraint(
        model,
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.(T(2), [x[1], x[1]], [x[1], x[1]]),  # quad
            MOI.ScalarAffineTerm.(T(1), [x[2]]),  # affine terms
            T(0),  # constant
        ),
        MOI.LessThan(T(1)),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(3 // 2),
        variable_primal = [(x[1], T(1 // 2)), (x[2], T(1 // 2))],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_qcp_duplicate_diagonal),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2, 1//2]),
        ),
    )
    return
end

"""
    test_constraint_qcp_duplicate_off_diagonal(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a QCP problem with a duplicate off-diagonal term.

The problem is
`max x + 2y | x^2 + 0.25y*x + 0.25x*y + 0.5x*y + y^2 <= 1, x >= 0.5, y >= 0.5`.

!!! warn
    This problem has an irrational solution. Solvers using rational arithmetic
    should exclude it.
"""
function test_constraint_qcp_duplicate_off_diagonal(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarQuadraticFunction{T},
        MOI.LessThan{T},
    )
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[1, 2], x), T(0)),
    )
    vc1 = MOI.add_constraint(model, x[1], MOI.GreaterThan{T}(T(1 // 2)))
    @test vc1.value == x[1].value
    vc2 = MOI.add_constraint(model, x[2], MOI.GreaterThan{T}(T(1 // 2)))
    @test vc2.value == x[2].value
    MOI.add_constraint(
        model,
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.(
                T[2, 1//4, 1//4, 1//2, 2],
                [x[1], x[1], x[2], x[1], x[2]],
                [x[1], x[2], x[1], x[2], x[2]],
            ),  # quad
            MOI.ScalarAffineTerm{T}[],  # affine terms
            T(0),  # constant
        ),
        MOI.LessThan(T(1)),
    )
    x2_solution = (sqrt(T(13)) - T(1)) / T(4)
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 2) + T(2) * x2_solution,
        variable_primal = [(x[1], T(1 // 2)), (x[2], x2_solution)],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_qcp_duplicate_off_diagonal),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2, (sqrt(T(13))-T(1))/T(4)]),
        ),
    )
    return
end

"""
    test_constraint_ZeroOne_bounds(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a problem with a bounded ZeroOne variable.
"""
function test_constraint_ZeroOne_bounds(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.ZeroOne())
    MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(2) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    _test_model_solution(
        model,
        config;
        objective_value = T(2),
        variable_primal = [(x, T(1))],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_ZeroOne_bounds),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
    )
    return
end

"""
    test_constraint_ZeroOne_bounds_2(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a problem with a ZeroOne and binding fractional upper bound.
"""
function test_constraint_ZeroOne_bounds_2(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.ZeroOne())
    MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    MOI.add_constraint(model, x, MOI.LessThan(T(1 // 2)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(2) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    _test_model_solution(
        model,
        config;
        objective_value = T(0),
        variable_primal = [(x, T(0))],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_ZeroOne_bounds_2),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[0])),
    )
    return
end

"""
    test_constraint_ZeroOne_bounds_3(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test a problem with a ZeroOne and infeasible fractional bounds.
"""
function test_constraint_ZeroOne_bounds_3(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.ZeroOne)
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.ZeroOne())
    MOI.add_constraint(model, x, MOI.GreaterThan(T(1 // 5)))
    MOI.add_constraint(model, x, MOI.LessThan(T(1 // 2)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(2) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.infeasible_status
    return
end

function setup_test(
    ::typeof(test_constraint_ZeroOne_bounds_3),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(mock, MOI.INFEASIBLE),
    )
    return
end

"""
    test_constraint_PrimalStart_DualStart_SecondOrderCone(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test combining the [`MOI.VariablePrimalStart`](@ref),
[`MOI.ConstraintPrimalStart`](@ref) and [`MOI.ConstraintDualStart`](@ref)
attributes with a `MOI.VectorAffineFunction{T}`-in-`MOI.SecondOrderCone`.
"""
function test_constraint_PrimalStart_DualStart_SecondOrderCone(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.SecondOrderCone,
    )
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOIU.operate(vcat, T, x, T(1)),
        MOI.SecondOrderCone(2),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    if MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
        MOI.set(model, MOI.VariablePrimalStart(), x, T(2))
    end
    if MOI.supports(model, MOI.ConstraintPrimalStart(), typeof(c))
        MOI.set(model, MOI.ConstraintPrimalStart(), c, T[2, 2])
    end
    if MOI.supports(model, MOI.ConstraintDualStart(), typeof(c))
        MOI.set(model, MOI.ConstraintDualStart(), c, T[2, -2])
    end
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T[1, 1])],
        constraint_dual = [(c, T[1, -1])],
    )
    return
end

function setup_test(
    ::typeof(test_constraint_PrimalStart_DualStart_SecondOrderCone),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.VectorAffineFunction{T}, MOI.SecondOrderCone) =>
                [T[1, -1]],
        ),
    )
    return
end

"""
    test_constraint_ConstraintPrimalStart(
        model::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Test the `ConstraintPrimalStart` attribute.
"""
function test_constraint_ConstraintPrimalStart(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Nonnegatives,
    )
    @requires MOI.supports(
        model,
        MOI.ConstraintPrimalStart(),
        MOI.ConstraintIndex{MOI.VectorAffineFunction{T},MOI.Nonnegatives},
    )
    x = MOI.add_variable(model)
    f = MOI.VectorAffineFunction(
        [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x))],
        T[0],
    )
    c = MOI.add_constraint(model, f, MOI.Nonnegatives(1))
    @test MOI.get(model, MOI.ConstraintPrimalStart(), c) === nothing
    MOI.set(model, MOI.ConstraintPrimalStart(), c, T[-1])
    @test MOI.get(model, MOI.ConstraintPrimalStart(), c) == T[-1]
    MOI.set(model, MOI.ConstraintPrimalStart(), c, nothing)
    @test MOI.get(model, MOI.ConstraintPrimalStart(), c) === nothing
    return
end

"""
    test_constraint_ConstraintDualStart(
        model::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Test the `ConstraintDualStart` attribute.
"""
function test_constraint_ConstraintDualStart(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Nonnegatives,
    )
    @requires MOI.supports(
        model,
        MOI.ConstraintDualStart(),
        MOI.ConstraintIndex{MOI.VectorAffineFunction{T},MOI.Nonnegatives},
    )
    x = MOI.add_variable(model)
    f = MOI.VectorAffineFunction(
        [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x))],
        T[0],
    )
    c = MOI.add_constraint(model, f, MOI.Nonnegatives(1))
    @test MOI.get(model, MOI.ConstraintDualStart(), c) === nothing
    MOI.set(model, MOI.ConstraintDualStart(), c, T[-1])
    @test MOI.get(model, MOI.ConstraintDualStart(), c) == T[-1]
    MOI.set(model, MOI.ConstraintDualStart(), c, nothing)
    @test MOI.get(model, MOI.ConstraintDualStart(), c) === nothing
    return
end

"""
    test_constraint_Indicator_ConstraintName(
        model::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Test ConstraintName for indicator sets.
"""
function test_constraint_Indicator_ConstraintName(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires(
        MOI.supports_constraint(
            model,
            MOI.VectorAffineFunction{T},
            MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.GreaterThan{T}},
        ),
    )
    x = MOI.add_variables(model, 2)
    MOI.add_constraint(model, x[1], MOI.ZeroOne())
    f = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x[1])),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(2), x[2])),
        ],
        T[0, 0],
    )
    s = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.GreaterThan(T(1)))
    c = MOI.add_constraint(model, f, s)
    MOI.set(model, MOI.ConstraintName(), c, "my_indicator")
    @test MOI.get(model, MOI.ConstraintName(), c) == "my_indicator"
    return
end

"""
    test_constraint_Indicator_ACTIVATE_ON_ONE(
        model::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Test ACTIVATE_ON_ONE for indicator sets.
"""
function test_constraint_Indicator_ACTIVATE_ON_ONE(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires(
        MOI.supports_constraint(
            model,
            MOI.VectorAffineFunction{T},
            MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.GreaterThan{T}},
        ),
    )
    x = MOI.add_variables(model, 2)
    MOI.add_constraint(model, x[1], MOI.ZeroOne())
    f = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x[1])),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(2), x[2])),
        ],
        T[0, 0],
    )
    s = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.GreaterThan(T(1)))
    c = MOI.add_constraint(model, f, s)
    @test MOI.get(model, MOI.ConstraintSet(), c) == s
    @test isapprox(MOI.get(model, MOI.ConstraintFunction(), c), f)
    return
end

"""
    test_constraint_Indicator_ACTIVATE_ON_ZERO(
        model::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Test ACTIVATE_ON_ZERO for indicator sets.
"""
function test_constraint_Indicator_ACTIVATE_ON_ZERO(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires(
        MOI.supports_constraint(
            model,
            MOI.VectorAffineFunction{T},
            MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.GreaterThan{T}},
        ),
    )
    x = MOI.add_variables(model, 2)
    MOI.add_constraint(model, x[1], MOI.ZeroOne())
    f = MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x[1])),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(2), x[2])),
        ],
        T[0, 0],
    )
    s = MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.GreaterThan(T(1)))
    c = MOI.add_constraint(model, f, s)
    @test MOI.get(model, MOI.ConstraintSet(), c) == s
    @test isapprox(MOI.get(model, MOI.ConstraintFunction(), c), f)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Variable

import MathOptInterface as MOI

include("bridge.jl")
include("map.jl")
include("set_map.jl")
include("single_bridge_optimizer.jl")

for filename in readdir(joinpath(@__DIR__, "bridges"); join = true)
    if endswith(filename, ".jl")
        include(filename)
    end
end

"""
    add_all_bridges(model, ::Type{T}) where {T}

Add all bridges defined in the `Bridges.Variable` submodule to `model`.

The coefficient type used is `T`.
"""
function add_all_bridges(model, ::Type{T}) where {T}
    MOI.Bridges.add_bridge(model, FreeBridge{T})
    MOI.Bridges.add_bridge(model, HermitianToSymmetricPSDBridge{T})
    MOI.Bridges.add_bridge(model, NonposToNonnegBridge{T})
    MOI.Bridges.add_bridge(model, ParameterToEqualToBridge{T})
    MOI.Bridges.add_bridge(model, RSOCtoPSDBridge{T})
    MOI.Bridges.add_bridge(model, RSOCtoSOCBridge{T})
    MOI.Bridges.add_bridge(model, SOCtoRSOCBridge{T})
    MOI.Bridges.add_bridge(model, VectorizeBridge{T})
    MOI.Bridges.add_bridge(model, ZerosBridge{T})
    return
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableRSOCtoSOC

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_rotatedsoc4()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    bridged_mock = MOI.Bridges.Variable.RSOCtoSOC{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [√2, 0.0, 1.0, 1.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1.0],
        )
    MOI.Test.test_conic_RotatedSecondOrderCone_out_of_order(
        bridged_mock,
        MOI.Test.Config(),
    )

    ceqs = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(ceqs) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), ceqs[1], "c")

    var_names = ["a", "b", "c", "d"]
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    socs = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.SecondOrderCone}(),
    )
    @test length(socs) == 1
    MOI.set(mock, MOI.ConstraintName(), socs[1], "soc")

    s2 = √2
    s = """
    variables: a, b, c, d
    soc: [a, b, c, d] in SecondOrderCone(4)
    c: $s2*a <= 2.0
    maxobjective: c + d
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(mock, model, var_names, ["soc", "c"])
    var_names = ["t", "u", "x", "y"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    rsocs = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorOfVariables,
            MOI.RotatedSecondOrderCone,
        }(),
    )
    @test length(rsocs) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), rsocs[1], "rsoc")

    s = """
    variables: t, u, x, y
    rsoc: [t, u, x, y] in RotatedSecondOrderCone(4)
    c: t + u <= 2.0
    maxobjective: x + y
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        var_names,
        ["rsoc", "c"],
    )

    tuxy = MOI.get(bridged_mock, MOI.ListOfVariableIndices())

    message = string(
        "Cannot delete variable as it is constrained with other",
        " variables in a `MOI.VectorOfVariables`.",
    )
    for i in eachindex(tuxy)
        err = MOI.DeleteNotAllowed(tuxy[i], message)
        @test_throws err MOI.delete(bridged_mock, tuxy[i])
    end

    _test_delete_bridged_variables(
        bridged_mock,
        tuxy,
        MOI.RotatedSecondOrderCone,
        4,
        ((MOI.VectorOfVariables, MOI.SecondOrderCone, 0),),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Variable.RSOCtoSOCBridge,
        """
        constrainedvariable: [t, u, x] in RotatedSecondOrderCone(3)
        a: 1.0 * t <= 1.0
        b: 1.0 * u <= 1.0
        c: 1.0 * x <= 1.0
        """,
        """
        constrainedvariable: [t, u, x] in SecondOrderCone(3)
        a: 0.7071067811865475 * t + 0.7071067811865475 * u <= 1.0
        b: 0.7071067811865475 * t + -0.7071067811865475 * u <= 1.0
        c: 1.0 * x <= 1.0
        """,
    )
    return
end

function test_adjoint_map_function()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.RSOCtoSOC{Float64}(inner)
    x, _ = MOI.add_constrained_variables(model, MOI.RotatedSecondOrderCone(3))
    @test MOI.Bridges.adjoint_map_function(model.map[first(x)], [2, 0.5, 1]) ≈
          [2.5 / sqrt(2), +1.5 / sqrt(2), 1.0]
    return
end

function test_ConstraintPrimalStart()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.RSOCtoSOC{Float64}(inner)
    x, ci = MOI.add_constrained_variables(model, MOI.RotatedSecondOrderCone(3))
    @test MOI.supports(model, MOI.ConstraintPrimalStart(), typeof(ci))
    MOI.set(model, MOI.ConstraintPrimalStart(), ci, [2, 0.5, 1])
    @test MOI.get(model, MOI.ConstraintPrimalStart(), ci) ≈ [2, 0.5, 1]
    MOI.set(model, MOI.ConstraintPrimalStart(), ci, nothing)
    @test MOI.get(model, MOI.ConstraintPrimalStart(), ci) === nothing
    return
end

function test_ConstraintDualStart()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Variable.RSOCtoSOC{Float64}(inner)
    x, ci = MOI.add_constrained_variables(model, MOI.RotatedSecondOrderCone(3))
    @test MOI.supports(model, MOI.ConstraintDualStart(), typeof(ci))
    MOI.set(model, MOI.ConstraintDualStart(), ci, [2, 0.5, 1])
    @test MOI.get(model, MOI.ConstraintDualStart(), ci) ≈ [2, 0.5, 1]
    MOI.set(model, MOI.ConstraintDualStart(), ci, nothing)
    @test MOI.get(model, MOI.ConstraintDualStart(), ci) === nothing
    return
end

end  # module

TestVariableRSOCtoSOC.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SplitComplexIndicatorEqualToBridge{T,F,G,A} <:
    Bridges.Constraint.AbstractBridge

`SplitComplexIndicatorEqualToBridge` implements the following reformulation:

  * ``z \\implies f(x) + g(x) * im = a + b * im`` into ``z \\implies f(x) = a``
    and ``z \\implies g(x) = b``

## Source node

`SplitComplexIndicatorEqualToBridge` supports:

  * `G` in `MOI.Indicator{A,MOI.EqualTo{Complex{T}}`

where `G` is a function with `Complex` coefficients.

## Target nodes

`SplitComplexIndicatorEqualToBridge` creates:

  * `F` in `MOI.Indicator{A,MOI.EqualTo{T}}`

where `F` is the type of the real/imaginary part of `G`.
"""
struct SplitComplexIndicatorEqualToBridge{
    T,
    F<:MOI.Utilities.TypedVectorLike{T},
    G<:MOI.Utilities.TypedVectorLike{Complex{T}},
    A,
} <: AbstractBridge
    real_constraint::Union{
        Nothing,
        MOI.ConstraintIndex{F,MOI.Indicator{A,MOI.EqualTo{T}}},
    }
    imag_constraint::Union{
        Nothing,
        MOI.ConstraintIndex{F,MOI.Indicator{A,MOI.EqualTo{T}}},
    }
end

const SplitComplexIndicatorEqualTo{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SplitComplexIndicatorEqualToBridge{T},OT}

function _add_constraint_if_nonzero(model, A, f, x, rhs::T) where {T}
    if iszero(f) && iszero(rhs)
        return nothing
    end
    g = MOI.Utilities.operate(vcat, T, x, f)
    return MOI.add_constraint(model, g, MOI.Indicator{A}(MOI.EqualTo(rhs)))
end

function bridge_constraint(
    ::Type{SplitComplexIndicatorEqualToBridge{T,F,G,A}},
    model::MOI.ModelLike,
    func::G,
    set::MOI.Indicator{A,MOI.EqualTo{Complex{T}}},
) where {T,F,G,A}
    @assert MOI.output_dimension(func) == 2
    scalars = MOI.Utilities.scalarize(func)
    x, f = convert(MOI.VariableIndex, scalars[1]), scalars[2]
    rhs = set.set.value
    real_ci = _add_constraint_if_nonzero(model, A, real(f), x, real(rhs))
    imag_f = MOI.Utilities.operate(imag, T, f)
    imag_ci = _add_constraint_if_nonzero(model, A, imag_f, x, imag(rhs))
    return SplitComplexIndicatorEqualToBridge{T,F,G,A}(real_ci, imag_ci)
end

function MOI.supports_constraint(
    ::Type{<:SplitComplexIndicatorEqualToBridge{T}},
    ::Type{<:MOI.Utilities.TypedVectorLike{Complex{T}}},
    ::Type{MOI.Indicator{A,MOI.EqualTo{Complex{T}}}},
) where {T,A}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:SplitComplexIndicatorEqualToBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{SplitComplexIndicatorEqualToBridge{T,F,G,A}},
) where {T,F,G,A}
    return Tuple{Type,Type}[(F, MOI.Indicator{A,MOI.EqualTo{T}})]
end

function concrete_bridge_type(
    ::Type{<:SplitComplexIndicatorEqualToBridge{T}},
    G::Type{<:MOI.Utilities.TypedLike},
    ::Type{MOI.Indicator{A,MOI.EqualTo{Complex{T}}}},
) where {T,A}
    F = MA.promote_operation(imag, G)
    return SplitComplexIndicatorEqualToBridge{T,F,G,A}
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::SplitComplexIndicatorEqualToBridge{T,F,G,A},
) where {T,F,G,A}
    H = MOI.Utilities.scalar_type(G)
    h = zero(H)
    x = nothing
    if bridge.real_constraint !== nothing
        f = MOI.get(model, attr, bridge.real_constraint)
        f_scalars = MOI.Utilities.scalarize(f)
        x = convert(MOI.VariableIndex, f_scalars[1])
        MOI.Utilities.operate!(+, Complex{T}, h, convert(H, f_scalars[2]))
    end
    if bridge.imag_constraint !== nothing
        f = MOI.get(model, attr, bridge.imag_constraint)
        f_scalars = MOI.Utilities.scalarize(f)
        x = convert(MOI.VariableIndex, f_scalars[1])
        MOI.Utilities.operate!(+, Complex{T}, h, im * f_scalars[2])
    end
    return MOI.Utilities.operate(vcat, Complex{T}, x, h)
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::SplitComplexIndicatorEqualToBridge{T,F,G,A},
) where {T,F,G,A}
    rhs = zero(T) + zero(T) * im
    if bridge.real_constraint !== nothing
        set = MOI.get(model, MOI.ConstraintSet(), bridge.real_constraint)
        rhs += set.set.value
    end
    if bridge.imag_constraint !== nothing
        set = MOI.get(model, MOI.ConstraintSet(), bridge.imag_constraint)
        rhs += set.set.value * im
    end
    return MOI.Indicator{A}(MOI.EqualTo(rhs))
end

function MOI.get(
    bridge::SplitComplexIndicatorEqualToBridge{T,F,G,A},
    ::MOI.NumberOfConstraints{F,MOI.Indicator{A,MOI.EqualTo{T}}},
)::Int64 where {T,F,G,A}
    return Int64(bridge.real_constraint !== nothing) +
           Int64(bridge.imag_constraint !== nothing)
end

function MOI.get(
    bridge::SplitComplexIndicatorEqualToBridge{T,F,G,A},
    ::MOI.ListOfConstraintIndices{F,MOI.Indicator{A,MOI.EqualTo{T}}},
) where {T,F,G,A}
    list = MOI.ConstraintIndex{F,MOI.Indicator{A,MOI.EqualTo{T}}}[]
    if bridge.real_constraint !== nothing
        push!(list, bridge.real_constraint)
    end
    if bridge.imag_constraint !== nothing
        push!(list, bridge.imag_constraint)
    end
    return list
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::SplitComplexIndicatorEqualToBridge,
)
    if bridge.real_constraint !== nothing
        MOI.delete(model, bridge.real_constraint)
    end
    if bridge.imag_constraint !== nothing
        MOI.delete(model, bridge.imag_constraint)
    end
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    ::Type{SplitComplexIndicatorEqualToBridge{T,F,G,A}},
) where {T,F,G,A}
    return MOI.supports(
        model,
        attr,
        MOI.ConstraintIndex{F,MOI.Indicator{A,MOI.EqualTo{T}}},
    )
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::SplitComplexIndicatorEqualToBridge{T},
) where {T}
    ret = zeros(Complex{T}, 2)
    if bridge.real_constraint !== nothing
        value = MOI.get(model, attr, bridge.real_constraint)
        if value == nothing
            return nothing
        end
        ret[1] = value[1]
        ret[2] += value[2]
    end
    if bridge.imag_constraint !== nothing
        value = MOI.get(model, attr, bridge.imag_constraint)
        if value == nothing
            return nothing
        end
        ret[1] = value[1]
        ret[2] += value[2] * im
    end
    return ret
end

_pass_nothing(f::Function, x::AbstractVector) = [x[1], f(x[2])]
_pass_nothing(::Any, ::Nothing) = nothing

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::SplitComplexIndicatorEqualToBridge{T},
    value,
) where {T}
    if bridge.real_constraint !== nothing
        MOI.set(model, attr, bridge.real_constraint, _pass_nothing(real, value))
    end
    if bridge.imag_constraint !== nothing
        MOI.set(model, attr, bridge.imag_constraint, _pass_nothing(imag, value))
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type AbstractBridgeOptimizer <: MOI.AbstractOptimizer end

An abstract type that implements generic functions for bridges.

## Implementation notes

By convention, the inner optimizer should be stored in a `model` field. If not,
the optimizer must implement [`MOI.optimize!`](@ref).
"""
abstract type AbstractBridgeOptimizer <: MOI.AbstractOptimizer end

# AbstractBridgeOptimizer interface

"""
    recursive_model(b::AbstractBridgeOptimizer)

If a variable, constraint, or objective is bridged, return the context of the
inner variables. For most optimizers, this should be `b.model`.
"""
function recursive_model end

"""
    supports_constraint_bridges(b::AbstractBridgeOptimizer)::Bool

Return a `Bool` indicating if `b` supports
[`MOI.Bridges.Constraint.AbstractBridge`](@ref).
"""
function supports_constraint_bridges end

"""
    is_bridged(
        b::AbstractBridgeOptimizer,
        F::Type{<:MOI.AbstractFunction},
        S::Type{<:MOI.AbstractSet},
    )::Bool

Return a `Bool` indicating whether `b` tries to bridge `F`-in-`S` constraints
instead of passing it as is to its internal model.

    is_bridged(b::AbstractBridgeOptimizer, S::Type{<:MOI.AbstractSet})::Bool

Return a `Bool` indicating whether `b` tries to bridge constrained variables in
`S` instead of passing it as is to its internal model.

    is_bridged(
        b::AbstractBridgeOptimizer,
        F::Type{<:MOI.AbstractFunction},
    )::Bool

Return a `Bool` indicating whether `b` tries to bridge objective functions of
type `F` instead of passing it as is to its internal model.
"""
function is_bridged end

"""
    is_bridged(b::AbstractBridgeOptimizer, vi::MOI.VariableIndex)

Return a `Bool` indicating whether `vi` is bridged. The variable is said to be
bridged if it is a variable of `b` but not a variable of `b.model`.
"""
is_bridged(::AbstractBridgeOptimizer, vi::MOI.VariableIndex) = vi.value < 0

"""
    is_bridged(b::AbstractBridgeOptimizer, ci::MOI.ConstraintIndex)

Return a `Bool` indicating whether `ci` is bridged. The constraint is said to be
bridged if it is a constraint of `b` but not a constraint of `b.model`.
"""
function is_bridged(
    b::AbstractBridgeOptimizer,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    return is_bridged(b, F, S)
end

function is_bridged(
    b::AbstractBridgeOptimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
) where {S}
    # There are a few cases for which we should return `false`:
    # 1) It was added as variables constrained on creation to `b.model`,
    #    In this case, `is_bridged(b, S)` is `false` and `ci.value >= 0`.
    # 2) It was added as constraint on a non-bridged variable to `b.model`,
    #    In this case, `is_bridged(b, F, S)` is `false` and `ci.value >= 0`.
    # and a few cases for which we should return `true`:
    # 3) It was added with a variable bridge,
    #    In this case, `is_bridged(b, S)` is `true` and `ci.value < 0`.
    # 4) It was added as constraint on a bridged variable so it was force-bridged,
    #    In this case, `ci.value < 0`.
    # 5) It was added with a constraint bridge,
    #    In this case, `is_bridged(b, F, S)` is `true` and  `ci.value >= 0` (the variable is non-bridged, otherwise, the constraint would have been force-bridged).
    # So
    # * if, `ci.value < 0` then it is case 3) or 4) and we return `true`.
    # * Otherwise,
    #   - if `is_bridged(b, S)` and `is_bridged(b, F, S)` then 1) and 2) are
    #     not possible so we are in case 5) and we return `true`.
    #   - if `!is_bridged(b, F, S)`, then 5) is not possible and we return `false`.
    #   - if `!is_bridged(b, S)` and `is_bridged(b, F, S)`, then it is either case 1)
    #     or 5). They cannot both be the cases as one cannot add two `VariableIndex`
    #     with the same set type on the same variable (this is ensured by
    #     `_check_double_single_variable`). Therefore, we can safely determine
    #     whether it is bridged with `haskey(Constraint.bridges(b), ci)`.
    return ci.value < 0 || (
        is_bridged(b, MOI.VariableIndex, S) &&
        (is_bridged(b, S) || haskey(Constraint.bridges(b), ci))
    )
end

function is_bridged(
    ::AbstractBridgeOptimizer,
    ci::MOI.ConstraintIndex{MOI.VectorOfVariables,S},
) where {S}
    return ci.value < 0
end

"""
    is_bridged(b::AbstractBridgeOptimizer, attr::MOI.ObjectiveFunction)

Return a `Bool` indicating whether `attr` is bridged. The objective function is
said to be bridged the objective function attribute passed to `b.model` is
different to `attr`.
"""
function is_bridged(b::AbstractBridgeOptimizer, attr::MOI.ObjectiveFunction)
    return haskey(Objective.bridges(b), attr)
end

"""
    supports_bridging_constrained_variable(
        ::AbstractBridgeOptimizer,
        ::Type{<:MOI.AbstractSet},
    )

Return a `Bool` indicating whether `b` supports bridging constrained variable in
`S`.
"""
function supports_bridging_constrained_variable(
    ::AbstractBridgeOptimizer,
    ::Type{<:MOI.AbstractSet},
)
    return false
end

"""
    is_variable_bridged(
        b::AbstractBridgeOptimizer,
        S::Type{<:MOI.AbstractSet},
    )

Return a `Bool` indicating whether `b` bridges constrained variable in
`S` using a variable bridge, assuming `is_bridged(b, S)`. If it returns `false`,
it means that free variables and a constraint on these variables should be
added instead. The constraint is then bridged by a constraint bridge.
"""
function is_variable_bridged(
    ::AbstractBridgeOptimizer,
    ::Type{<:MOI.AbstractSet},
)
    return false
end

"""
    is_variable_bridged(b::AbstractBridgeOptimizer, ci::MOI.ConstraintIndex)

Returns whether `ci` is the constraint of a bridged constrained variable. That
is, if it was returned by `Variable.add_key_for_bridge` or
`Variable.add_keys_for_bridge`. Note that it is not equivalent to
`ci.value < 0` as, it can also simply be a constraint on a bridged variable.
"""
is_variable_bridged(::AbstractBridgeOptimizer, ::MOI.ConstraintIndex) = false

function is_variable_bridged(
    b::AbstractBridgeOptimizer,
    ci::MOI.ConstraintIndex{<:Union{MOI.VariableIndex,MOI.VectorOfVariables}},
)
    # It can be a constraint corresponding to bridged constrained variables so
    # we `check` with `haskey(Constraint.bridges(b), ci)` whether this is the
    # case.
    return ci.value < 0 && !haskey(Constraint.bridges(b), ci)
end

"""
    supports_bridging_constraint(
        b::AbstractBridgeOptimizer,
        F::Type{<:MOI.AbstractFunction},
        S::Type{<:MOI.AbstractSet},
    )::Bool

Return a `Bool` indicating whether `b` supports bridging `F`-in-`S` constraints.
"""
function supports_bridging_constraint(
    ::AbstractBridgeOptimizer,
    ::Type{<:MOI.AbstractFunction},
    ::Type{<:MOI.AbstractSet},
)
    return false
end

"""
    supports_bridging_objective_function(
        b::AbstractBridgeOptimizer,
        F::Type{<:MOI.AbstractFunction},
    )::Bool

Return a `Bool` indicating whether `b` supports bridging objective functions of
type `F`.
"""
function supports_bridging_objective_function(
    ::AbstractBridgeOptimizer,
    ::Type{<:MOI.AbstractFunction},
)
    return false
end

"""
    bridge_type(
        b::AbstractBridgeOptimizer,
        F::Type{<:MOI.AbstractFunction},
        S::Type{<:MOI.AbstractSet},
    )

Return the `AbstractBridge` type to be used to bridge `F`-in-`S` constraints.
This function should only be called if `is_bridged(b, F, S)`.
"""
function bridge_type end

"""
    bridge(b::AbstractBridgeOptimizer, vi::MOI.VariableIndex)

Return the `Variable.AbstractBridge` used to bridge the variable with index
`vi`.
"""
function bridge(b::AbstractBridgeOptimizer, vi::MOI.VariableIndex)
    map = Variable.bridges(b)::Variable.Map
    return map[vi]
end

"""
    bridge(b::AbstractBridgeOptimizer, ci::MOI.ConstraintIndex)

Return the `AbstractBridge` used to bridge the constraint with index `ci`.
"""
function bridge(b::AbstractBridgeOptimizer, ci::MOI.ConstraintIndex)
    if is_variable_bridged(b, ci)
        map = Variable.bridges(b)::Variable.Map
        return bridge(b, Variable.first_variable(map, ci))
    else
        return Constraint.bridges(b)[ci]
    end
end

"""
    bridge(b::AbstractBridgeOptimizer, attr::MOI.ObjectiveFunction)

Return the `Objective.AbstractBridge` used to bridge the objective function
`attr`.
"""
function bridge(b::AbstractBridgeOptimizer, attr::MOI.ObjectiveFunction)
    map = Objective.bridges(b)::Objective.Map
    return map[attr]
end

"""
    call_in_context(
        b::AbstractBridgeOptimizer,
        vi::MOI.VariableIndex,
        f::Function,
    )

Call `f(bridge)` where `vi` is bridged by `bridge` in its context, see
[`Variable.call_in_context`](@ref).
"""
function call_in_context(
    b::AbstractBridgeOptimizer,
    vi::MOI.VariableIndex,
    f::Function,
)
    return Variable.call_in_context(Variable.bridges(b)::Variable.Map, vi, f)
end

"""
    call_in_context(
        b::AbstractBridgeOptimizer,
        ci::MOI.ConstraintIndex,
        f::Function,
    )

Call `f(bridge)` where `ci` is bridged by `bridge` in its context, see
[`Variable.call_in_context`](@ref).
"""
function call_in_context(
    b::AbstractBridgeOptimizer,
    ci::MOI.ConstraintIndex,
    f::Function,
)
    if is_variable_bridged(b, ci)
        map = Variable.bridges(b)::Variable.Map
        return call_in_context(b, Variable.first_variable(map, ci), f)
    else
        return Variable.call_in_context(
            Variable.bridges(b),
            ci,
            () -> f(Constraint.bridges(b)[ci]),
        )
    end
end

function call_in_context(
    f::F,
    b::AbstractBridgeOptimizer,
    index::MOI.Index,
    attr::MOI.AnyAttribute,
    args::Vararg{Any,N},
) where {F<:Union{typeof(MOI.get),typeof(MOI.set)},N}
    return call_in_context(
        b,
        index,
        bridge -> f(recursive_model(b), attr, bridge, args...),
    )
end

function call_in_context(
    f::F,
    b::AbstractBridgeOptimizer,
    index::MOI.Index,
    args::Vararg{Any,N},
) where {F<:Function,N}
    return call_in_context(
        b,
        index,
        bridge -> f(recursive_model(b), bridge, args...),
    )
end

function _functionize_bridge(b::AbstractBridgeOptimizer, bridge_type)
    func, name = _func_name(bridge_type)
    return error(
        "Need to apply a `$bridge_type` to a `$func` $name because the",
        " variable is bridged but $name bridges are not supported by",
        " `$(typeof(b))`.",
    )
end

function constraint_scalar_functionize_bridge(b::AbstractBridgeOptimizer)
    return _functionize_bridge(b, Constraint.ScalarFunctionizeBridge)
end

function constraint_vector_functionize_bridge(b::AbstractBridgeOptimizer)
    return _functionize_bridge(b, Constraint.VectorFunctionizeBridge)
end

function objective_functionize_bridge(b::AbstractBridgeOptimizer)
    return _functionize_bridge(b, Objective.FunctionizeBridge)
end

# Implementation of the MOI interface for AbstractBridgeOptimizer

# By convention, the model should be stored in a `model` field
function MOI.optimize!(b::AbstractBridgeOptimizer)
    final_touch(b)
    MOI.optimize!(b.model)
    return
end

function MOI.compute_conflict!(b::AbstractBridgeOptimizer)
    MOI.compute_conflict!(b.model)
    return
end

function MOI.is_empty(b::AbstractBridgeOptimizer)
    return isempty(Variable.bridges(b)) &&
           isempty(Constraint.bridges(b)) &&
           MOI.is_empty(b.model)
end

function MOI.empty!(b::AbstractBridgeOptimizer)
    MOI.empty!(b.model)
    if Variable.has_bridges(Variable.bridges(b))
        empty!(b.var_to_name)
        b.name_to_var = nothing
    end
    if Variable.has_bridges(Variable.bridges(b)) ||
       Constraint.has_bridges(Constraint.bridges(b))
        empty!(b.con_to_name)
        b.name_to_con = nothing
    end
    empty!(Variable.bridges(b))
    empty!(Constraint.bridges(b))
    empty!(Objective.bridges(b))
    return
end

function MOI.supports(
    b::AbstractBridgeOptimizer,
    attr::Union{MOI.AbstractModelAttribute,MOI.AbstractOptimizerAttribute},
)
    return MOI.supports(b.model, attr)
end

function MOI.Utilities.pass_nonvariable_constraints(
    dest::AbstractBridgeOptimizer,
    src::MOI.ModelLike,
    idxmap::MOI.Utilities.IndexMap,
    constraint_types,
)
    if Variable.has_bridges(Variable.bridges(dest))
        # The functions may contain bridged variables which needs to be
        # substituted so we use the fallback.
        MOI.Utilities.pass_nonvariable_constraints_fallback(
            dest,
            src,
            idxmap,
            constraint_types,
        )
        return
    end
    not_bridged_types = eltype(constraint_types)[]
    bridged_types = eltype(constraint_types)[]
    for (F, S) in constraint_types
        if is_bridged(dest, F, S)
            push!(bridged_types, (F, S))
        else
            push!(not_bridged_types, (F, S))
        end
    end
    MOI.Utilities.pass_nonvariable_constraints(
        dest.model,
        src,
        idxmap,
        not_bridged_types,
    )
    MOI.Utilities.pass_nonvariable_constraints_fallback(
        dest,
        src,
        idxmap,
        bridged_types,
    )
    return
end

function MOI.copy_to(dest::AbstractBridgeOptimizer, src::MOI.ModelLike)
    return MOI.Utilities.default_copy_to(dest, src)
end

function MOI.supports_incremental_interface(b::AbstractBridgeOptimizer)
    return MOI.supports_incremental_interface(b.model)
end

function final_touch(b::AbstractBridgeOptimizer)
    final_touch(Constraint.bridges(b), recursive_model(b))
    return
end

function MOI.Utilities.final_touch(b::AbstractBridgeOptimizer, index_map)
    final_touch(b)
    MOI.Utilities.final_touch(b.model, index_map)
    return
end

# References
function MOI.is_valid(b::AbstractBridgeOptimizer, vi::MOI.VariableIndex)
    if is_bridged(b, vi)
        return haskey(Variable.bridges(b), vi)
    else
        return MOI.is_valid(b.model, vi)
    end
end

function MOI.is_valid(
    b::AbstractBridgeOptimizer,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    if is_bridged(b, ci)
        if is_variable_bridged(b, ci)
            v_map = Variable.bridges(b)::Variable.Map
            return MOI.is_valid(v_map, ci)
        else
            # This return value has the potential to be a false positive: it
            # doesn't discriminate between constraints that the user added, and
            # constraints that a bridge added that were themselves bridged.
            #
            # "Fixing" this particular call has a number of wide reaching
            # effects because bridges need this to be "true" so that they can
            # query attributes of the constraint from `b`.
            #
            # In most cases a false positive doesn't matter, because we really
            # do support querying stuff about it. And also the user needs some
            # way of obtaining the correct index, which they won't have except
            # by luck/enumeration.
            #
            # The main place that this is problematic is when we come to delete
            # constraints, and in particular VariableIndex constraints, because we
            # triviallly have their `.value` field from the `.value` of the
            # VariableIndex.
            #
            # Instead of fixing everything though, we implement some extra
            # checks when deleting, and we leave the false-positive as-is for
            # now. If you, future reader, hit this comment while debugging, we
            # might need to revisit this decision.
            #
            # x-ref https://github.com/jump-dev/MathOptInterface.jl/issues/2696
            # x-ref https://github.com/jump-dev/MathOptInterface.jl/issues/2817
            # x-ref https://github.com/jump-dev/MathOptInterface.jl/pull/2818
            return haskey(Constraint.bridges(b), ci)
        end
    else
        return MOI.is_valid(b.model, ci)
    end
end

function _delete_variables_in_vector_of_variables_constraint(
    b::AbstractBridgeOptimizer,
    vis::Vector{MOI.VariableIndex},
    ci::MOI.ConstraintIndex{MOI.VectorOfVariables,S},
) where {S}
    func = MOI.get(b, MOI.ConstraintFunction(), ci)
    if vis == func.variables
        MOI.delete(b, ci)
    else
        variables = copy(func.variables)
        for vi in vis
            i = findfirst(isequal(vi), variables)
            if i !== nothing
                if MOI.supports_dimension_update(S)
                    call_in_context(MOI.delete, b, ci, IndexInVector(i))
                else
                    MOI.Utilities.throw_delete_variable_in_vov(vi)
                end
            end
        end
    end
    return
end

"""
    _is_added_by_bridge(
        c_map,
        cache::Dict{Any,Set{Int64}},
        ci::MOI.ConstraintIndex{F,S},
    ) where {F,S}

Return `true` if `ci` was added by one of the bridges in `c_map`.

For performance reasons, we store the index values associated with
`MOI.ListOfConstraintIndices{F,S}` in `cache` so that we don't have to keep
looping through the bridges.
"""
function _is_added_by_bridge(
    c_map,
    cache::Dict{Any,Set{Int64}},
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    ret = get!(cache, (F, S)) do
        set = Set{Int64}()
        for bridge in values(c_map)
            for ci in MOI.get(
                bridge,
                MOI.ListOfConstraintIndices{F,S}(),
            )
                push!(set, ci.value)
            end
        end
        return set
    end::Set{Int64}
    return ci.value in ret
end

"""
    _delete_variables_in_variables_constraints(
        b::AbstractBridgeOptimizer,
        vis::Vector{MOI.VariableIndex},
    )

The point of this function is to delete constraints associated with the
variables in `vis`.

## Warning

Because of the false positive potential in
`is_valid(::AbstractBridgeOptimizer, MOI.ConstraintIndex)`, we need to ensure
that we delete constraints only if they were not added by a different constraint
bridge, otherwise when we come to delete the parent constraint we'll hit a
runtime error where we have already deleted part of the bridged constraint.

x-ref https://github.com/jump-dev/MathOptInterface.jl/issues/2817
x-ref https://github.com/jump-dev/MathOptInterface.jl/pull/2818
"""
function _delete_variables_in_variables_constraints(
    b::AbstractBridgeOptimizer,
    vis::Vector{MOI.VariableIndex},
)
    c_map = Constraint.bridges(b)::Constraint.Map
    cache = Dict{Any,Set{Int64}}()
    for vi in vis
        for ci in Constraint.variable_constraints(c_map, vi)
            if !_is_added_by_bridge(c_map, cache, ci)
                MOI.delete(b, ci)
            end
        end
    end
    for ci in Constraint.vector_of_variables_constraints(c_map)
        if !_is_added_by_bridge(c_map, cache, ci)
            _delete_variables_in_vector_of_variables_constraint(b, vis, ci)
        end
    end
    return
end

function _delete_variables_in_bridged_objective(
    b::AbstractBridgeOptimizer,
    vis::Vector{MOI.VariableIndex},
)
    F = MOI.get(b, MOI.ObjectiveFunctionType())
    _delete_variables_in_bridged_objective(b, vis, F)
    return
end

function _delete_variables_in_bridged_objective(
    b::AbstractBridgeOptimizer,
    vis::Vector{MOI.VariableIndex},
    ::Type{MOI.VectorOfVariables},
)
    obj_f = MOI.get(b, MOI.ObjectiveFunction{MOI.VectorOfVariables}())
    discard = Base.Fix2(in, vis)
    if !any(discard, obj_f.variables)
        # There are no variables in the objective function to delete, so we
        # don't need to do anything.
        return
    end
    new_obj_f = MOI.VectorOfVariables(filter(!discard, obj_f.variables))
    if MOI.output_dimension(new_obj_f) == 0
        # We've deleted all variables in the objective. Zero the objective by
        # setting FEASIBILITY_SENSE, but restore the sense afterwards.
        sense = MOI.get(b, MOI.ObjectiveSense())
        MOI.set(b, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
        MOI.set(b, MOI.ObjectiveSense(), sense)
    else
        MOI.set(b, MOI.ObjectiveFunction{MOI.VectorOfVariables}(), new_obj_f)
    end
    return
end

function _delete_variables_in_bridged_objective(
    b::AbstractBridgeOptimizer,
    vis::Vector{MOI.VariableIndex},
    ::Type{MOI.VariableIndex},
)
    obj_f = MOI.get(b, MOI.ObjectiveFunction{MOI.VariableIndex}())
    if obj_f in vis
        sense = MOI.get(b, MOI.ObjectiveSense())
        MOI.set(b, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
        MOI.set(b, MOI.ObjectiveSense(), sense)
    end
    return
end

function _delete_variables_in_bridged_objective(
    ::AbstractBridgeOptimizer,
    ::Vector{MOI.VariableIndex},
    ::Type{F},
) where {F}
    # Nothing to do here. The variables can be deleted without changing the type
    # of the objective, or whether one exists.
    return
end

function MOI.delete(b::AbstractBridgeOptimizer, vis::Vector{MOI.VariableIndex})
    if is_objective_bridged(b)
        _delete_variables_in_bridged_objective(b, vis)
    end
    if Constraint.has_bridges(Constraint.bridges(b))
        _delete_variables_in_variables_constraints(b, vis)
    end
    if any(vi -> is_bridged(b, vi), vis)
        for vi in vis
            MOI.throw_if_not_valid(b, vi)
        end
        if all(vi -> is_bridged(b, vi), vis) &&
           Variable.has_keys(Variable.bridges(b)::Variable.Map, vis)
            call_in_context(MOI.delete, b, first(vis))
            b.name_to_var = nothing
            for vi in vis
                delete!(b.var_to_name, vi)
            end
            ci = Variable.constraint(
                Variable.bridges(b)::Variable.Map,
                first(vis),
            )
            b.name_to_con = nothing
            delete!(b.con_to_name, ci)
            delete!(Variable.bridges(b)::Variable.Map, vis)
        else
            for vi in vis
                MOI.delete(b, vi)
            end
        end
    else
        MOI.delete(b.model, vis)
    end
    return
end

function MOI.delete(b::AbstractBridgeOptimizer, vi::MOI.VariableIndex)
    if is_objective_bridged(b)
        _delete_variables_in_bridged_objective(b, [vi])
    end
    if Constraint.has_bridges(Constraint.bridges(b))
        _delete_variables_in_variables_constraints(b, [vi])
    end
    if is_bridged(b, vi)
        MOI.throw_if_not_valid(b, vi)
        v_map = Variable.bridges(b)::Variable.Map
        if Variable.length_of_vector_of_variables(v_map, vi) > 1
            set = Variable.constrained_set(v_map, vi)
            if MOI.supports_dimension_update(set)
                call_in_context(MOI.delete, b, vi, _index(b, vi)...)
            else
                MOI.Utilities.throw_delete_variable_in_vov(vi)
            end
        else
            call_in_context(MOI.delete, b, vi)
            ci = Variable.constraint(v_map, vi)
            b.name_to_con = nothing
            delete!(b.con_to_name, ci)
        end
        delete!(v_map, vi)
        b.name_to_var = nothing
        delete!(b.var_to_name, vi)
    else
        MOI.delete(b.model, vi)
    end
    return
end

function MOI.delete(
    b::AbstractBridgeOptimizer,
    ci::MOI.ConstraintIndex{F},
) where {F}
    if is_bridged(b, ci)
        MOI.throw_if_not_valid(b, ci)
        br = bridge(b, ci)
        if is_variable_bridged(b, ci)
            throw(
                MOI.DeleteNotAllowed(
                    ci,
                    "Cannot delete constraint index of bridged constrained " *
                    "variables. Delete the scalar variable or the vector of " *
                    "variables instead.",
                ),
            )
        else
            delete!(Constraint.bridges(b)::Constraint.Map, ci)
        end
        if F === MOI.VariableIndex && ci.value < 0
            # Constraint on a bridged variable so we need to remove the flag
            # if it is a bound
            MOI.delete(Variable.bridges(b), ci)
        end
        Variable.call_in_context(
            Variable.bridges(b),
            ci,
            () -> MOI.delete(recursive_model(b), br),
        )
        b.name_to_con = nothing
        delete!(b.con_to_name, ci)
    else
        MOI.delete(b.model, ci)
    end
    return
end

function MOI.delete(
    b::AbstractBridgeOptimizer,
    ci::Vector{<:MOI.ConstraintIndex},
)
    if any(c -> is_bridged(b, c), ci)
        # This is a potentially complicated case, so default to the slow case of
        # deleting each constraint one-by-one.
        MOI.delete.(b, ci)
    else
        MOI.delete(b.model, ci)
    end
    return
end

# Attributes

function _get_all_including_bridged(
    b::AbstractBridgeOptimizer,
    attr::MOI.ListOfVariableIndices,
)
    # `inner_to_outer` is going to map variable indices in `b.model` to their
    # bridged variable indices. If the bridge adds multiple variables, we need
    # only to map the first variable, and we can skip the rest. To mark this
    # distinction, the tail variables are set to `nothing`.
    map = Variable.bridges(b)
    inner_to_outer = Dict{MOI.VariableIndex,Union{Nothing,MOI.VariableIndex}}()
    # These are variables which appear in `b` but do NOT appear in `b.model`.
    # One reason might be the Zero bridge in which they are replaced by `0.0`.
    user_only_variables = MOI.VariableIndex[]
    for (user_variable, bridge) in map
        variables = MOI.get(bridge, MOI.ListOfVariableIndices())
        if isempty(variables)
            # This bridge maps `user_variable` to constants in `b.model`. We
            # still need to report back `user_variable` to the user. In
            # addition, it might represent the start of a VectorOfVariables
            # function, so we may need to report multiple variables.
            push!(user_only_variables, user_variable)
            n = Variable.length_of_vector_of_variables(map, user_variable)
            for i in 1:(n-1)
                push!(
                    user_only_variables,
                    MOI.VariableIndex(user_variable.value - i),
                )
            end
        else
            # This bridge maps `user_variable` to a list of `variables`. We need
            # to swap out only the `first` variable. The others can be flagged
            # with `nothing`. To simplify the first/tail loop, we set
            # `first(variables)` twice; first to `nothing` and then to
            # `user_variable`.
            for bridged_variable in variables
                inner_to_outer[bridged_variable] = nothing
            end
            inner_to_outer[first(variables)] = user_variable
        end
    end
    # We're about to loop over the variables in `.model`, ordered by when they
    # were added to the model. We need to return a list of the original
    # user-space variables in the order that they were added. To do so, we need
    # to undo any Variable.bridges transformations.
    ret = MOI.VariableIndex[]
    for inner_variable in MOI.get(b.model, attr)
        outer_variable = get(inner_to_outer, inner_variable, missing)
        # If there is a chain of variable bridges, the `outer_variable` may need
        # to be mapped.
        while haskey(inner_to_outer, outer_variable)
            outer_variable = inner_to_outer[outer_variable]
        end
        if ismissing(outer_variable)
            # inner_variable does not exist in inner_to_outer, which means that
            # it is not bridged. Pass through unchanged.
            push!(ret, inner_variable)
        elseif isnothing(outer_variable)
            # inner_variable exists in inner_to_outer, but it is set to `nothing`
            # which means that it is not the first variable in the bridge. Skip
            # it because it should be hidden from the user.
        else
            # inner_variable exists in inner_to_outer. It must be the first
            # variable in the bridge. Report it back to the user.
            push!(ret, outer_variable)
            # `outer_variable` might represent the start of a VectorOfVariables
            # if multiple user-variables were bridged. Add them all.
            n = Variable.length_of_vector_of_variables(map, outer_variable)
            for i in 1:(n-1)
                push!(ret, MOI.VariableIndex(outer_variable.value - i))
            end
        end
    end
    # Since these were replaced by constants, we don't actually know when they
    # were added to the model. Tack them on at the end...
    #
    # If you, future reader, find this troublesome, come up with a better
    # solution.
    append!(ret, user_only_variables)
    return ret
end

function _get_all_including_bridged(
    b::AbstractBridgeOptimizer,
    attr::MOI.ListOfConstraintIndices{F,S},
) where {F,S}
    list = MOI.ConstraintIndex{F,S}[]
    is_variable_function = F == MOI.Utilities.variable_function_type(S)
    # A `F`-in-`S` constraint could be added to the model either if it this
    # constraint is not bridged or if variables constrained on creations to `S`
    # are not bridged and `F` is `VariableIndex` or `VectorOfVariables`.
    if !is_bridged(b, F, S) || (is_variable_function && !is_bridged(b, S))
        append!(list, MOI.get(b.model, attr))
    end
    # If variable bridged, get the indices from the variable bridges.
    if is_variable_function && is_bridged(b, S) && is_variable_bridged(b, S)
        append!(list, Variable.constraints_with_set(Variable.bridges(b), S))
    end
    # If constraint bridged, get the indices from the constraint bridges.
    if is_bridged(b, F, S) ||
       (is_variable_function && supports_constraint_bridges(b))
        append!(
            list,
            Constraint.keys_of_type(
                Constraint.bridges(b)::Constraint.Map,
                MOI.ConstraintIndex{F,S},
            ),
        )
    end
    return list
end

function _remove_bridged(list, bridge, attr)
    for c in MOI.get(bridge, attr)
        i = findfirst(isequal(c), list)
        if i !== nothing
            MOI.deleteat!(list, i)
        end
    end
    return
end

# The tactic for this function is to first query all possible indices, and then
# to filter out the indices that have been bridged.
#
# TODO(odow): this seems slightly inefficient, but no one seems to have
# complained that it is a bottleneck.
function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::Union{MOI.ListOfConstraintIndices,MOI.ListOfVariableIndices},
)
    list = _get_all_including_bridged(b, attr)
    for bridge in values(Variable.bridges(b))
        _remove_bridged(list, bridge, attr)
    end
    for bridge in values(Constraint.bridges(b))
        _remove_bridged(list, bridge, attr)
    end
    for bridge in values(Objective.bridges(b))
        _remove_bridged(list, bridge, attr)
    end
    return list
end

function MOI.get(b::AbstractBridgeOptimizer, attr::MOI.NumberOfVariables)::Int64
    s = MOI.get(b.model, attr)
    s += Variable.number_of_variables(Variable.bridges(b))
    for bridge in values(Variable.bridges(b))
        s -= MOI.get(bridge, attr)
    end
    for bridge in values(Constraint.bridges(b))
        s -= MOI.get(bridge, attr)
    end
    for bridge in values(Objective.bridges(b))
        s -= MOI.get(bridge, attr)
    end
    return s
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.NumberOfConstraints{F,S},
)::Int64 where {F,S}
    num = Int64(0)
    is_variable_function = F == MOI.Utilities.variable_function_type(S)
    # A `F`-in-`S` constraint could be added to the model either if it this
    # constraint is not bridged or if variables constrained on creations to `S`
    # are not bridged and `F` is `VariableIndex` or `VectorOfVariables`.
    if !is_bridged(b, F, S) || (is_variable_function && !is_bridged(b, S))
        num += MOI.get(b.model, attr)
    end
    # If variable bridged, get the indices from the variable bridges.
    if is_variable_function && is_bridged(b, S) && is_variable_bridged(b, S)
        num += Variable.number_with_set(Variable.bridges(b), S)
    end
    # If constraint bridged, get the indices from the constraint bridges.
    if is_bridged(b, F, S) ||
       (is_variable_function && supports_constraint_bridges(b))
        num += Constraint.number_of_type(
            Constraint.bridges(b),
            MOI.ConstraintIndex{F,S},
        )
    end
    for bridge in values(Variable.bridges(b))
        num -= MOI.get(bridge, attr)
    end
    for bridge in values(Constraint.bridges(b))
        num -= MOI.get(bridge, attr)
    end
    for bridge in values(Objective.bridges(b))
        num -= MOI.get(bridge, attr)
    end
    return num
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ListOfConstraintTypesPresent,
)
    list_of_types = MOI.get(b.model, attr)
    if Constraint.has_bridges(Constraint.bridges(b))
        append!(
            list_of_types,
            Constraint.list_of_key_types(Constraint.bridges(b)::Constraint.Map),
        )
    end
    if Variable.has_bridges(Variable.bridges(b))
        append!(
            list_of_types,
            Variable.list_of_constraint_types(
                Variable.bridges(b)::Variable.Map,
            ),
        )
    end
    unique!(list_of_types)
    # Some constraint types show up in `list_of_types` including when all the
    # constraints of that type have been created by bridges and not by the user.
    # The code in `NumberOfConstraints` takes care of removing these constraints
    # from the counter so we can rely on it to remove these constraint types.
    filter!(list_of_types) do (F, S)
        return MOI.get(b, MOI.NumberOfConstraints{F,S}()) > 0
    end
    return list_of_types
end

# Model an optimizer attributes
function MOI.get(b::AbstractBridgeOptimizer, attr::MOI.ListOfModelAttributesSet)
    list = MOI.get(b.model, attr)
    if is_objective_bridged(b)
        list = copy(list)
        # There should be a `MOI.ObjectiveFunction` in `list` otherwise
        # `is_objective_bridged` would return `false`.
        deleteat!(list, findfirst(attr -> attr isa MOI.ObjectiveFunction, list))
        push!(
            list,
            MOI.ObjectiveFunction{MOI.get(b, MOI.ObjectiveFunctionType())}(),
        )
    end
    return unbridged_function(b, list)
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::Union{MOI.AbstractModelAttribute,MOI.AbstractOptimizerAttribute},
)
    return unbridged_function(b, MOI.get(b.model, attr))
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ListOfVariablesWithAttributeSet,
)
    if Variable.has_bridges(Variable.bridges(b))
        # If there are variable bridges, `MOI.get(b.model, attr)`
        # will return a list containing solver variables that do not
        # correspond to any user variables.
        # We choose the easy option of simply returning all variables
        # for now.
        return MOI.get(b, MOI.ListOfVariableIndices())
    else
        return unbridged_function(b, MOI.get(b.model, attr))
    end
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ListOfConstraintsWithAttributeSet{F,S,MOI.ConstraintName},
) where {F,S}
    if !is_bridged(b, F, S) &&
       MOI.supports(b.model, MOI.ConstraintName(), MOI.ConstraintIndex{F,S})
        return MOI.get(b.model, attr)
    end
    return MOI.ConstraintIndex{F,S}[
        ci for ci in keys(b.con_to_name) if ci isa MOI.ConstraintIndex{F,S}
    ]
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ListOfConstraintAttributesSet{F,S},
) where {F,S}
    list = unbridged_function(b, MOI.get(b.model, attr))
    if !(MOI.ConstraintName() in list)
        for key in keys(b.con_to_name)
            if key isa MOI.ConstraintIndex{F,S}
                push!(list, MOI.ConstraintName())
                break
            end
        end
    end
    return list
end

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::Union{MOI.AbstractModelAttribute,MOI.AbstractOptimizerAttribute},
    value,
)
    MOI.set(b.model, attr, bridged_function(b, value))
    return
end

"""
    bridging_cost(b::AbstractBridgeOptimizer, S::Type{<:MOI.AbstractSet}})

Return the cost of bridging variables constrained in `S` on creation,
`is_bridged(b, S)` is assumed to be `true`.

    bridging_cost(
        b::AbstractBridgeOptimizer,
        F::Type{<:MOI.AbstractFunction},
        S::Type{<:MOI.AbstractSet},
    )

Return the cost of bridging `F`-in-`S` constraints.

`is_bridged(b, S)` is assumed to be `true`.
"""
function bridging_cost end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.VariableBridgingCost{S},
) where {S}
    if is_bridged(b, S)
        return bridging_cost(b, S)
    else
        return MOI.get(b.model, attr)
    end
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintBridgingCost{F,S},
) where {F,S}
    if is_bridged(b, F, S)
        return bridging_cost(b, F, S)
    else
        return MOI.get(b.model, attr)
    end
end

"""
    _bridged_function(b::AbstractBridgeOptimizer, ::Union{MOI.ObjectiveFunction, MOI.ConstraintIndex})

Returns the objective function (resp constraint function) as seen by the
objective bridge (resp. constraint bridge) if it is bridged or by the inner
model otherwise. That is, all the bridged variables (except those created by the
bridge or by one of the bridges downstream of this bridge) have been
substituted.

This function cannot be called for a constraint index that is variable bridged.
"""
function _bridged_function end

function _bridged_function(
    b::AbstractBridgeOptimizer,
    attr::MOI.ObjectiveFunction,
)
    if is_bridged(b, attr)
        return MOI.get(recursive_model(b), attr, bridge(b, attr))
    else
        return MOI.get(b.model, attr)
    end
end

function _bridged_function(b::AbstractBridgeOptimizer, ci::MOI.ConstraintIndex)
    attr = MOI.ConstraintFunction()
    if is_bridged(b, ci)
        @assert !is_variable_bridged(b, ci)
        return call_in_context(MOI.get, b, ci, MOI.ConstraintFunction())
    else
        return MOI.get(b.model, attr, ci)
    end
end

"""
    _bridged_function(b::AbstractBridgeOptimizer, ::Union{MOI.ObjectiveFunction, MOI.ConstraintIndex})

Returns the objective function (resp constraint function) as seen by the
user. That is, none of the bridged variables (except those created by any
bridge upstream) have been substituted.
"""
function _unbridged_function end

_unbridged_function(b, obj::MOI.ObjectiveFunction) = MOI.get(b, obj)

function _unbridged_function(b, ci::MOI.ConstraintIndex)
    return MOI.get(b, MOI.ConstraintFunction(), ci)
end

# Objective

"""
    is_objective_bridged(b::AbstractBridgeOptimizer)

Return a `Bool` indicating whether the objective is bridged. The objective is
said to be bridged if the value of `MOI.ObjectiveFunctionType` is different for
`b` and `b.model`.
"""
is_objective_bridged(b) = !isempty(Objective.bridges(b))

function _delete_objective_bridges(b)
    MOI.delete(b, Objective.root_bridge(Objective.bridges(b)::Objective.Map))
    empty!(Objective.bridges(b))
    return
end

function MOI.supports(
    b::AbstractBridgeOptimizer,
    attr::MOI.ObjectiveFunction{F},
) where {F}
    if is_bridged(b, F)
        return supports_bridging_objective_function(b, F)
    else
        return MOI.supports(b.model, attr)
    end
end

"""
    struct ObjectiveFunctionValue{F<:MOI.AbstractFunction} end

Attribute for the value of the objective function of type `F`. If the objective
of the objective function does not depend on `F`, the type `F` determines
whether the computation is redirected to an objective bridge or to the
underlying model.
"""
struct ObjectiveFunctionValue{F<:MOI.AbstractFunction}
    result_index::Int
end

# `recursive_model(b::Objective.SingleBridgeOptimizer)` returns
# `b.model` so any model should implement `ObjectiveFunctionValue`.
function MOI.get(model::MOI.ModelLike, attr::ObjectiveFunctionValue)
    return MOI.get(model, MOI.ObjectiveValue(attr.result_index))
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::ObjectiveFunctionValue{F},
) where {F<:MOI.AbstractFunction} # Need `<:` to avoid ambiguity
    obj_attr = MOI.ObjectiveFunction{F}()
    if is_bridged(b, obj_attr)
        return MOI.get(recursive_model(b), attr, bridge(b, obj_attr))
    else
        return MOI.get(b.model, MOI.ObjectiveValue(attr.result_index))
    end
end

function MOI.get(b::AbstractBridgeOptimizer, attr::MOI.ObjectiveValue)
    if is_objective_bridged(b)
        F = Objective.function_type(Objective.bridges(b))
        return MOI.get(b, ObjectiveFunctionValue{F}(attr.result_index))
    else
        return MOI.get(b.model, attr)
    end
end

function MOI.get(b::AbstractBridgeOptimizer, attr::MOI.ObjectiveFunctionType)
    if is_objective_bridged(b)
        return Objective.function_type(Objective.bridges(b))
    else
        return MOI.get(b.model, attr)
    end
end

function MOI.get(b::AbstractBridgeOptimizer, attr::MOI.ObjectiveSense)
    return MOI.get(b.model, attr)
end

function MOI.get(b::AbstractBridgeOptimizer, attr::MOI.ObjectiveFunction)
    return unbridged_function(b, _bridged_function(b, attr))
end

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.ObjectiveSense,
    value::MOI.OptimizationSense,
)
    MOI.set(b.model, attr, value)
    if is_objective_bridged(b)
        if value == MOI.FEASIBILITY_SENSE
            _delete_objective_bridges(b)
        else
            for bridge in values(Objective.bridges(b))
                MOI.set(recursive_model(b), attr, bridge, value)
            end
        end
    end
    return
end

function _bridge_objective(b, BridgeType, f)
    bridge = Objective.bridge_objective(BridgeType, recursive_model(b), f)
    Objective.add_key_for_bridge(Objective.bridges(b)::Objective.Map, bridge, f)
    return
end

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.ObjectiveFunction,
    func::MOI.AbstractFunction,
)
    if is_objective_bridged(b)
        # Clear objective function by setting sense to `MOI.FEASIBILITY_SENSE`
        # first. This is needed if the objective function of `b.model` is
        # `slack` where `slack` is the slack variable
        # created by `Objective.SlackBridge`.
        sense = MOI.get(b.model, MOI.ObjectiveSense())
        MOI.set(b.model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
        _delete_objective_bridges(b)
        if sense != MOI.FEASIBILITY_SENSE
            MOI.set(b.model, MOI.ObjectiveSense(), sense)
        end
    end
    if Variable.has_bridges(Variable.bridges(b))
        if func isa MOI.VariableIndex
            if is_bridged(b, func)
                BridgeType = Objective.concrete_bridge_type(
                    objective_functionize_bridge(b),
                    typeof(func),
                )
                _bridge_objective(b, BridgeType, func)
                return
            end
        else
            func = bridged_function(b, func)::typeof(func)
        end
    end
    if is_bridged(b, typeof(func))
        BridgeType = Objective.concrete_bridge_type(b, typeof(func))
        _bridge_objective(b, BridgeType, func)
    else
        MOI.set(b.model, attr, func)
    end
    return
end

struct ModifyBridgeNotAllowed{C<:MOI.AbstractFunctionModification} <:
       MOI.NotAllowedError
    change::C
    message::String

    function ModifyBridgeNotAllowed(
        change::MOI.AbstractFunctionModification,
        msg::String = "",
    )
        return new{typeof(change)}(change, msg)
    end
end

function MOI.operation_name(err::ModifyBridgeNotAllowed)
    return "Modifying the bridge with $(err.change)"
end

function MOI.modify(
    ::MOI.ModelLike,
    ::AbstractBridge,
    change::MOI.AbstractFunctionModification,
)
    return throw(ModifyBridgeNotAllowed(change))
end

function _modify_bridged_function(
    b::AbstractBridgeOptimizer,
    ci_or_obj,
    change::MOI.AbstractFunctionModification,
)
    if is_bridged(b, ci_or_obj)
        MOI.modify(recursive_model(b), bridge(b, ci_or_obj), change)
    else
        MOI.modify(b.model, ci_or_obj, change)
    end
    return
end

function MOI.modify(
    b::AbstractBridgeOptimizer,
    obj::MOI.ObjectiveFunction,
    change::MOI.AbstractFunctionModification,
)
    if is_bridged(b, change)
        modify_bridged_change(b, obj, change)
    else
        _modify_bridged_function(b, obj, change)
    end
    return
end

# Variable attributes
function _index(b::AbstractBridgeOptimizer, vi::MOI.VariableIndex)
    map = Variable.bridges(b)::Variable.Map
    i = Variable.index_in_vector_of_variables(map, vi)
    if iszero(i.value)
        return tuple()
    else
        return (i,)
    end
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.AbstractVariableAttribute,
    index::MOI.VariableIndex,
)
    if is_bridged(b, index)
        value = call_in_context(MOI.get, b, index, attr, _index(b, index)...)
    else
        value = MOI.get(b.model, attr, index)
    end
    return unbridged_function(b, value)
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.AbstractVariableAttribute,
    indices::Vector{MOI.VariableIndex},
)
    # `Variable.has_bridges` is used as a shortcut to speedup in case no variable bridge is used
    if Variable.has_bridges(Variable.bridges(b)) &&
       any(index -> is_bridged(b, index), indices)
        return MOI.get.(b, attr, indices)
    else
        return unbridged_function.(b, MOI.get(b.model, attr, indices))
    end
end

function MOI.supports(
    b::AbstractBridgeOptimizer,
    attr::MOI.AbstractVariableAttribute,
    ::Type{MOI.VariableIndex},
)
    # `supports` should only return `false` in case `MOI.set` always errors.
    # If some variables are bridged by bridges that do not support `attr`, we
    # should therefore still return `true`.
    return MOI.supports(b.model, attr, MOI.VariableIndex)
end

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.AbstractVariableAttribute,
    index::MOI.VariableIndex,
    value,
)
    value = bridged_function(b, value)
    if is_bridged(b, index)
        call_in_context(MOI.set, b, index, attr, value, _index(b, index)...)
    else
        MOI.set(b.model, attr, index, value)
    end
    return
end

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.AbstractVariableAttribute,
    indices::Vector{MOI.VariableIndex},
    values::Vector,
)
    if any(index -> is_bridged(b, index), indices)
        MOI.set.(b, attr, indices, values)
    else
        MOI.set(b.model, attr, indices, bridged_function.(b, values))
    end
    return
end

## MOI.ConstraintFunction

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintFunction,
    ci::MOI.ConstraintIndex{F},
    func,
) where {F}
    if !(func isa F)
        throw(MOI.FunctionTypeMismatch{F,typeof(func)}())
    end
    # If there are variable bridges, the function we are setting might need
    # to be mapped through the bridge substitution. This includes moving
    # constants into the set.
    if Variable.has_bridges(Variable.bridges(b))
        set = MOI.get(b, MOI.ConstraintSet(), ci)
        # This moves any constant in func over to set, and returns new functions
        # and sets.
        new_func, new_set = bridged_constraint_function(b, func, set)
        _set_substituted(b, attr, ci, new_func)
        if new_set !== set
            # We only need to update the set if it has changed.
            _set_substituted(b, MOI.ConstraintSet(), ci, new_set)
        end
    else
        _set_substituted(b, attr, ci, func)
    end
    return
end

"""
    _set_substituted(
        b::AbstractBridgeOptimizer,
        attr::MOI.AbstractConstraintAttribute,
        ci::MOI.ConstraintIndex,
        value,
    )

A helpful wrapper that calls `call_in_context` if `ci` is bridged, and `MOI.set`
if not.
"""
function _set_substituted(
    b::AbstractBridgeOptimizer,
    attr::MOI.AbstractConstraintAttribute,
    ci::MOI.ConstraintIndex,
    value,
)
    if is_bridged(b, ci)
        MOI.throw_if_not_valid(b, ci)
        call_in_context(MOI.set, b, ci, attr, value)
    else
        MOI.set(b.model, attr, ci, value)
    end
    return
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintFunction,
    ci::MOI.ConstraintIndex,
)
    if is_bridged(b, ci)
        MOI.throw_if_not_valid(b, ci)
        if is_variable_bridged(b, ci)
            # If it is a variable bridge, we can get the original variable quite
            # easily.
            return Variable.function_for(Variable.bridges(b)::Variable.Map, ci)
        else
            # Otherwise, we need to query ConstraintFunction in the context of
            # the bridge...
            func = call_in_context(MOI.get, b, ci, attr)
            # and then unbridge this function (because it may contain variables
            # that are themselves bridged).
            return unbridged_constraint_function(b, func)
        end
    else
        # This constraint is not bridged, but it might contain variables that
        # are.
        return unbridged_constraint_function(b, MOI.get(b.model, attr, ci))
    end
end

## MOI.ConstraintSet

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
    value,
) where {S<:MOI.AbstractScalarSet}
    if !(value isa S)
        throw(MOI.SetTypeMismatch{S,typeof(value)}())
    end
    _set_substituted(b, attr, ci, value)
    return
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex},
)
    if is_bridged(b, ci)
        MOI.throw_if_not_valid(b, ci)
        return call_in_context(MOI.get, b, ci, attr)
    else
        return MOI.get(b.model, attr, ci)
    end
end

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{<:MOI.AbstractScalarFunction,S},
    set,
) where {S<:MOI.AbstractScalarSet}
    if !(set isa S)
        throw(MOI.SetTypeMismatch{S,typeof(set)}())
    end
    # If there are variable bridges, the set we are setting might need to be
    # mapped through the bridge substitution. This includes moving constants
    # into the set.
    if Variable.has_bridges(Variable.bridges(b))
        if is_bridged(b, ci)
            # If `ci` is also ConstraintBridged, then we give up as the current code path is known to contain unresolved issues, see https://github.com/jump-dev/MathOptInterface.jl/issues/2452
            throw(MOI.SetAttributeNotAllowed(attr))
        end
        func = MOI.get(b, MOI.ConstraintFunction(), ci)
        # Updating the set will not modify the function, so we don't care about
        # the first argument. We only care about the new set.
        _, set = bridged_constraint_function(b, func, set)
    end
    _set_substituted(b, attr, ci, set)
    return
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{<:MOI.AbstractScalarFunction,S},
) where {S}
    set = if is_bridged(b, ci)
        MOI.throw_if_not_valid(b, ci)
        call_in_context(MOI.get, b, ci, attr)
    else
        MOI.get(b.model, attr, ci)
    end
    # This is a scalar function, so if there are variable bridges, it might
    # contain constants that have been moved into the set.
    if !Variable.has_bridges(Variable.bridges(b))
        # If there are no variable bridges, return the set.
        return set
    elseif !MOI.Utilities.supports_shift_constant(S)
        # If it doesn't support shift_constant, then return the set
        return set
    end
    # When the constraint is added with function `f` and set `set_f`,
    # the function is bridged into `g` with set `set` by
    # `g, set = bridged_constraint_function(b, f, set_f)`.
    # By doing so, the function constant of the bridged function (if it exists)
    # was moved to `set`, we need to remove it to recover `set_f`.
    # The function `f` contains the variables in the context of `ci`
    # (which should match `Variable.bridges(b).current_context` since no code
    # outside of that context has references to `ci`) and
    # the constraint `g` contains the variables of `b.model`.
    # The following line recovers `f` in the context of
    # `Variables.map(b).current_context`.
    f = MOI.get(b, MOI.ConstraintFunction(), ci)
    # We need to substitute the variable bridges to recover the function `g`
    # that was given at the creation of the bridge.
    g = bridged_function(b, f)
    # Since `bridged_constraint_function(b, f, set_f)` used
    # `set = shift_constant(set_f, -MOI.constant(g))`, we need
    # to do the opposite to recover `set_f`.
    return MOI.Utilities.shift_constant(set, MOI.constant(g))
end

## Other constraint attributes

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.AbstractConstraintAttribute,
    ci::MOI.ConstraintIndex,
)
    func = if is_bridged(b, ci)
        MOI.throw_if_not_valid(b, ci)
        call_in_context(MOI.get, b, ci, attr)
    else
        MOI.get(b.model, attr, ci)
    end
    return unbridged_function(b, func)
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex{F,S},
) where {F<:MOI.AbstractScalarFunction,S<:MOI.AbstractScalarSet}
    if is_bridged(b, ci)
        MOI.throw_if_not_valid(b, ci)
        return call_in_context(MOI.get, b, ci, attr)
    end
    if Variable.has_bridges(Variable.bridges(b))
        # In this case, the scalar constraint might contain bridged variables
        # that include constants, like `x >= 1` being mapped to `y >= 0`,
        # `x := y + 1`. If this is true, then `normalize_and_add_constraint`
        # may move the constants into the set, and querying `ConstraintPrimal`
        # from `b.model` will return the value of `y`, not `y + 1`. As a
        # work-around, we use `get_fallback`, which first queries
        # `ConstraintFunction` and then evaluates the function at the point
        # defined by `VariablePrimal`. Querying `ConstraintFunction` accounts
        # for the case where constants were moved to the set, so we return the
        # correct value.
        return MOI.Utilities.get_fallback(b, attr, ci)
    end
    return MOI.get(b.model, attr, ci)
end

function MOI.supports(
    b::AbstractBridgeOptimizer,
    attr::MOI.AbstractConstraintAttribute,
    ::Type{MOI.ConstraintIndex{F,S}},
) where {F,S}
    # !!! warning
    #     This function is slightly confusing, because we need to account for
    #     the different ways in which a constraint might be added.
    if F == MOI.Utilities.variable_function_type(S)
        # These are VariableIndex and VectorOfVariable constraints.
        if is_bridged(b, S)
            # If S needs to be bridged, it usually means that either there is a
            # variable bridge, or that there is a free variable followed by a
            # constraint bridge (that is, the two cases handled below).
            #
            # However, it might be the case, like the tests in
            # Variable/flip_sign.jl, that the model supports F-in-S constraints,
            # but force-bridges S sets. If so, we might be in the unusual
            # situation where we support the attribute if the index was added
            # via add_constraint, but not if it was added via
            # add_constrained_variable. Because MOI lacks the ability to tell
            # which happened just based on the type, we're going to default to
            # asking the variable bridge, at the risk of a false negative.
            if is_variable_bridged(b, S)
                bridge = Variable.concrete_bridge_type(b, S)
                return MOI.supports(recursive_model(b), attr, bridge)
            else
                bridge = Constraint.concrete_bridge_type(b, F, S)
                return MOI.supports(recursive_model(b), attr, bridge)
            end
        else
            # If S doesn't need to be bridged, it usually means that either the
            # solver supports add_constrained_variable, or it supports free
            # variables and add_constraint.
            #
            # In some cases, it might be that the solver supports
            # add_constrained_variable, but ends up bridging add_constraint.
            # Because MOI lacks the ability to tell which one was called based
            # on the index type, asking the model might give a false negative
            # (we support the attribute via add_constrained_variable, but the
            # bridge doesn't via add_constraint because it will be bridged).
            return MOI.supports(b.model, attr, MOI.ConstraintIndex{F,S})
        end
    else
        # These are normal add_constraints, so we just check if they are
        # bridged.
        if is_bridged(b, F, S)
            bridge = Constraint.concrete_bridge_type(b, F, S)
            return MOI.supports(recursive_model(b), attr, bridge)
        else
            return MOI.supports(b.model, attr, MOI.ConstraintIndex{F,S})
        end
    end
end

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.AbstractConstraintAttribute,
    ci::MOI.ConstraintIndex,
    value,
)
    _set_substituted(b, attr, ci, bridged_function(b, value))
    return
end

function MOI.set(
    ::AbstractBridgeOptimizer,
    ::MOI.ConstraintFunction,
    ::MOI.ConstraintIndex{MOI.VariableIndex},
    ::MOI.VariableIndex,
)
    return throw(MOI.SettingVariableIndexNotAllowed())
end

_f_type(::Type{S}) where {S<:MOI.AbstractScalarSet} = MOI.VariableIndex
_f_type(::Type{S}) where {S<:MOI.AbstractVectorSet} = MOI.VectorOfVariables

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintConflictStatus,
    bridge::AbstractBridge,
)
    ret = MOI.NOT_IN_CONFLICT
    for (F, S) in MOI.Bridges.added_constraint_types(typeof(bridge))
        for ci in MOI.get(bridge, MOI.ListOfConstraintIndices{F,S}())
            status = MOI.get(model, attr, ci)
            if status == MOI.IN_CONFLICT
                return status
            elseif status == MOI.MAYBE_IN_CONFLICT
                ret = status
            end
        end
    end
    for (S,) in MOI.Bridges.added_constrained_variable_types(typeof(bridge))
        F = _f_type(S)
        for ci in MOI.get(bridge, MOI.ListOfConstraintIndices{F,S}())
            status = MOI.get(model, attr, ci)
            if status == MOI.IN_CONFLICT
                return status
            elseif status == MOI.MAYBE_IN_CONFLICT
                ret = status
            end
        end
    end
    return ret
end

## Getting and Setting names
function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.VariableName,
    vi::MOI.VariableIndex,
)
    if is_bridged(b, vi)
        bridge_ = bridge(b, vi)
        if MOI.supports(b, MOI.VariableName(), typeof(bridge_))
            return MOI.get(b, MOI.VariableName(), bridge_)
        end
        return get(b.var_to_name, vi, "")
    else
        return MOI.get(b.model, attr, vi)
    end
end

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.VariableName,
    vi::MOI.VariableIndex,
    name::String,
)
    if is_bridged(b, vi)
        bridge_ = bridge(b, vi)
        if MOI.supports(b, MOI.VariableName(), typeof(bridge_))
            MOI.set(b, MOI.VariableName(), bridge_, name)
        else
            b.var_to_name[vi] = name
            b.name_to_var = nothing # Invalidate the name map.
        end
    else
        MOI.set(b.model, attr, vi, name)
    end
    return
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintName,
    constraint_index::MOI.ConstraintIndex,
)
    if is_bridged(b, constraint_index)
        return get(b.con_to_name, constraint_index, "")
    else
        return MOI.get(b.model, attr, constraint_index)
    end
end

function MOI.supports(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintName,
    Index::Type{MOI.ConstraintIndex{F,S}},
) where {F,S}
    return is_bridged(b, F, S) || MOI.supports(b.model, attr, Index)
end

function MOI.set(
    b::AbstractBridgeOptimizer,
    attr::MOI.ConstraintName,
    constraint_index::MOI.ConstraintIndex,
    name::String,
)
    if is_bridged(b, constraint_index)
        b.con_to_name[constraint_index] = name
        b.name_to_con = nothing # Invalidate the name map.
    else
        MOI.set(b.model, attr, constraint_index, name)
    end
    return
end

function MOI.supports(
    ::AbstractBridgeOptimizer,
    ::MOI.ConstraintName,
    ::Type{MOI.ConstraintIndex{MOI.VariableIndex,S}},
) where {S}
    return throw(MOI.VariableIndexConstraintNameError())
end

function MOI.set(
    ::AbstractBridgeOptimizer,
    ::MOI.ConstraintName,
    ::MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet},
    ::String,
)
    return throw(MOI.VariableIndexConstraintNameError())
end

# Query index from name (similar to `UniversalFallback`)
function MOI.get(
    b::AbstractBridgeOptimizer,
    ::Type{MOI.VariableIndex},
    name::String,
)
    vi = MOI.get(b.model, MOI.VariableIndex, name)
    if !Variable.has_bridges(Variable.bridges(b))
        return vi
    end
    if b.name_to_var === nothing
        b.name_to_var = MOI.Utilities.build_name_to_var_map(b.var_to_name)
    end
    vi_bridged = get(b.name_to_var, name, nothing)
    MOI.Utilities.throw_if_multiple_with_name(vi_bridged, name)
    return MOI.Utilities.check_type_and_multiple_names(
        MOI.VariableIndex,
        vi_bridged,
        vi,
        name,
    )
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    IdxT::Type{MOI.ConstraintIndex{F,S}},
    name::String,
) where {F,S}
    if !Constraint.has_bridges(Constraint.bridges(b)) &&
       !Variable.has_bridges(Variable.bridges(b))
        # `name_to_con` is not defined for `Objective.SingleBridgeOptimizer`.
        return MOI.get(b.model, IdxT, name)
    end
    if b.name_to_con === nothing
        b.name_to_con = MOI.Utilities.build_name_to_con_map(b.con_to_name)
    end
    if is_bridged(b, F, S)
        # There is no `F`-in-`S` constraint in `b.model`, `ci` is only got
        # to check for duplicate names.
        ci = MOI.get(b.model, MOI.ConstraintIndex, name)
    else
        ci = MOI.get(b.model, IdxT, name)
    end
    ci_bridged = get(b.name_to_con, name, nothing)
    MOI.Utilities.throw_if_multiple_with_name(ci_bridged, name)
    return MOI.Utilities.check_type_and_multiple_names(
        IdxT,
        ci_bridged,
        ci,
        name,
    )
end

function MOI.get(
    b::AbstractBridgeOptimizer,
    IdxT::Type{MOI.ConstraintIndex},
    name::String,
)
    if !Constraint.has_bridges(Constraint.bridges(b)) &&
       !Variable.has_bridges(Variable.bridges(b))
        # `name_to_con` is not defined for `Objective.SingleBridgeOptimizer`.
        return MOI.get(b.model, IdxT, name)
    end
    if b.name_to_con === nothing
        b.name_to_con = MOI.Utilities.build_name_to_con_map(b.con_to_name)
    end
    ci_bridged = get(b.name_to_con, name, nothing)
    MOI.Utilities.throw_if_multiple_with_name(ci_bridged, name)
    return MOI.Utilities.check_type_and_multiple_names(
        IdxT,
        ci_bridged,
        MOI.get(b.model, IdxT, name),
        name,
    )
end

# Constraints
function MOI.supports_constraint(
    b::AbstractBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    if is_bridged(b, F, S)
        return supports_bridging_constraint(b, F, S)
    else
        return MOI.supports_constraint(b.model, F, S)
    end
end

function add_bridged_constraint(b, BridgeType, f, s)
    bridge = Constraint.bridge_constraint(BridgeType, recursive_model(b), f, s)
    # `MOI.VectorOfVariables` constraint indices have negative indices
    # to distinguish between the indices of the inner model.
    # However, they can clash between the indices created by the variable
    # so we use the last argument to inform the constraint bridge mapping about
    # indices already taken by variable bridges.
    ci = Constraint.add_key_for_bridge(
        Constraint.bridges(b)::Constraint.Map,
        bridge,
        f,
        s,
        !Base.Fix1(MOI.is_valid, Variable.bridges(b)),
    )
    Variable.register_context(Variable.bridges(b), ci)
    return ci
end

function _throw_if_bound_already_set(b, x, ::S2, ::Type{S1}) where {S1,S2}
    ErrorType = _bound_error_type(S1, S2)
    if ErrorType === nothing
        return
    end
    ci = MOI.ConstraintIndex{MOI.VariableIndex,S1}(x.value)
    if (is_bridged(b, S1) && MOI.is_valid(b, ci)) || MOI.is_valid(b.model, ci)
        throw(ErrorType(x))
    end
    return
end

function _bound_error_type(
    ::Type{S1},
    ::Type{S2},
) where {S1<:MOI.LessThan,S2<:MOI.LessThan}
    return MOI.UpperBoundAlreadySet{S1,S2}
end

function _bound_error_type(::Type{S1}, ::Type{S2}) where {S1<:MOI.LessThan,S2}
    return MOI.UpperBoundAlreadySet{S1,S2}
end

function _bound_error_type(::Type{S1}, ::Type{S2}) where {S1,S2<:MOI.LessThan}
    return MOI.UpperBoundAlreadySet{S1,S2}
end

function _bound_error_type(::Type{S1}, ::Type{S2}) where {S1,S2}
    return MOI.LowerBoundAlreadySet{S1,S2}
end

_bound_error_type(::Type{<:MOI.LessThan}, ::Type{<:MOI.GreaterThan}) = nothing

_bound_error_type(::Type{<:MOI.GreaterThan}, ::Type{<:MOI.LessThan}) = nothing

function _check_double_single_variable(
    b::AbstractBridgeOptimizer,
    x::MOI.VariableIndex,
    s::S,
) where {
    T,
    S<:Union{
        MOI.Interval{T},
        MOI.EqualTo{T},
        MOI.Semicontinuous{T},
        MOI.Semiinteger{T},
        MOI.LessThan{T},
        MOI.GreaterThan{T},
    },
}
    # !!! warning
    #     The order here is _very_ important because an Interval constraint
    #     might get re-written into a LessThan and GreaterThan. To throw the
    #     appropriate error, we _must_ check sets like `Interval` and `EqualTo`
    #     _before_ `LessThan` and `GreaterThan`.
    _throw_if_bound_already_set(b, x, s, MOI.Interval{T})
    _throw_if_bound_already_set(b, x, s, MOI.EqualTo{T})
    _throw_if_bound_already_set(b, x, s, MOI.Semicontinuous{T})
    _throw_if_bound_already_set(b, x, s, MOI.Semiinteger{T})
    _throw_if_bound_already_set(b, x, s, MOI.LessThan{T})
    _throw_if_bound_already_set(b, x, s, MOI.GreaterThan{T})
    return
end

_check_double_single_variable(::AbstractBridgeOptimizer, ::Any, ::Any) = nothing

function MOI.add_constraint(
    b::AbstractBridgeOptimizer,
    f::F,
    s::S,
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    if Variable.has_bridges(Variable.bridges(b))
        if F <: MOI.VariableIndex
            if is_bridged(b, f)
                ci = MOI.ConstraintIndex{MOI.VariableIndex,S}(f.value)
                if MOI.is_valid(b, ci)
                    # The other constraint could have been through a variable bridge.
                    msg = "Cannot add two `VariableIndex`-in-`$S` on the same variable $f."
                    throw(MOI.AddConstraintNotAllowed{F,S}(msg))
                end
                BridgeType = Constraint.concrete_bridge_type(
                    constraint_scalar_functionize_bridge(b),
                    F,
                    S,
                )
                MOI.add_constraint(Variable.bridges(b), f, s)
                return add_bridged_constraint(b, BridgeType, f, s)
            end
        elseif F <: MOI.VectorOfVariables
            if any(vi -> is_bridged(b, vi), f.variables)
                BridgeType = Constraint.concrete_bridge_type(
                    constraint_vector_functionize_bridge(b),
                    F,
                    S,
                )
                return add_bridged_constraint(b, BridgeType, f, s)
            end
        else
            f, s = bridged_constraint_function(b, f, s)
        end
    end
    if is_bridged(b, F, S)
        _check_double_single_variable(b, f, s)
        # We compute `BridgeType` first as `concrete_bridge_type` calls
        # `bridge_type` which might throw an `UnsupportedConstraint` error in
        # which case, we do not want any modification to have been done
        BridgeType = Constraint.concrete_bridge_type(b, F, S)
        # `add_constraint` might throw an `UnsupportedConstraint` but no
        # modification has been done in the previous line
        return add_bridged_constraint(b, BridgeType, f, s)
    else
        return MOI.add_constraint(b.model, f, s)
    end
end

function MOI.add_constraints(
    b::AbstractBridgeOptimizer,
    f::Vector{F},
    s::Vector{S},
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    if is_bridged(b, F, S)
        return MOI.add_constraint.(b, f, s)
    end
    if Variable.has_bridges(Variable.bridges(b))
        if F == MOI.VariableIndex
            if any(func -> is_bridged(b, func), f)
                return MOI.add_constraint.(b, f, s)
            end
        elseif F == MOI.VectorOfVariables
            if any(func -> any(vi -> is_bridged(b, vi), func.variables), f)
                return MOI.add_constraint.(b, f, s)
            end
        else
            f = F[bridged_function(b, func)::F for func in f]
        end
    end
    return MOI.add_constraints(b.model, f, s)
end

function is_bridged(
    b::AbstractBridgeOptimizer,
    ::Union{MOI.ScalarConstantChange,MOI.VectorConstantChange},
)
    return Variable.has_bridges(Variable.bridges(b))
end

function is_bridged(
    b::AbstractBridgeOptimizer,
    change::Union{MOI.ScalarCoefficientChange,MOI.MultirowChange},
)
    return is_bridged(b, change.variable)
end

function is_bridged(
    b::AbstractBridgeOptimizer,
    change::MOI.ScalarQuadraticCoefficientChange,
)
    return is_bridged(b, change.variable_1) || is_bridged(b, change.variable_2)
end

function modify_bridged_change(
    b::AbstractBridgeOptimizer,
    ci,
    change::MOI.MultirowChange,
)
    func =
        bridged_variable_function(b, change.variable)::MOI.ScalarAffineFunction
    if !iszero(func.constant)
        # We would need to get the constant in the function, and the
        # coefficient of `change.variable` to remove its contribution
        # to the constant and then modify the constant.
        MOI.throw_modify_not_allowed(
            ci,
            change,
            "The change $change contains variables bridged into" *
            " a function with nonzero constant.",
        )
    end
    for t in func.terms
        coefs =
            [(i, coef * t.coefficient) for (i, coef) in change.new_coefficients]
        MOI.modify(b, ci, MOI.MultirowChange(t.variable, coefs))
    end
    return
end

_constant_change(new_constant) = MOI.ScalarConstantChange(new_constant)
_constant_change(new_constant::Vector) = MOI.VectorConstantChange(new_constant)

function modify_bridged_change(
    b::AbstractBridgeOptimizer,
    ci_or_obj,
    change::Union{MOI.ScalarConstantChange,MOI.VectorConstantChange},
)
    bridged_func = _bridged_function(b, ci_or_obj)
    unbridged_func = _unbridged_function(b, ci_or_obj)
    bridged_const =
        MOI.constant(bridged_func) + change.new_constant -
        MOI.constant(unbridged_func)
    bridged_change = _constant_change(bridged_const)
    _modify_bridged_function(b, ci_or_obj, bridged_change)
    return
end

function modify_bridged_change(
    b::AbstractBridgeOptimizer,
    ci_or_obj,
    change::MOI.ScalarCoefficientChange,
)
    func =
        bridged_variable_function(b, change.variable)::MOI.ScalarAffineFunction
    if !iszero(func.constant)
        # We would need to get the constant in the set, and the
        # coefficient of `change.variable` to remove its contribution
        # to the constant and then modify the constant.
        MOI.throw_modify_not_allowed(
            ci_or_obj,
            change,
            "The change $change contains variables bridged into" *
            " a function with nonzero constant.",
        )
    end
    for t in func.terms
        coef = t.coefficient * change.new_coefficient
        MOI.modify(b, ci_or_obj, MOI.ScalarCoefficientChange(t.variable, coef))
    end
    return
end

function modify_bridged_change(
    b::AbstractBridgeOptimizer,
    ci_or_obj,
    change::MOI.ScalarQuadraticCoefficientChange,
)
    return MOI.throw_modify_not_allowed(
        ci_or_obj,
        change,
        "Cannot bridge `ScalarQuadraticCoefficientChange`.",
    )
end

function MOI.modify(
    b::AbstractBridgeOptimizer,
    ci::MOI.ConstraintIndex,
    change::MOI.AbstractFunctionModification,
)
    if is_bridged(b, change)
        modify_bridged_change(b, ci, change)
    else
        if is_bridged(b, ci)
            call_in_context(MOI.modify, b, ci, change)
        else
            MOI.modify(b.model, ci, change)
        end
    end
    return
end

# Variables
function MOI.add_variable(b::AbstractBridgeOptimizer)
    if is_bridged(b, MOI.Reals)
        variables, constraint = MOI.add_constrained_variables(b, MOI.Reals(1))
        @assert isone(length(variables))
        return first(variables)
    else
        return MOI.add_variable(b.model)
    end
end

function MOI.add_variables(b::AbstractBridgeOptimizer, n)
    if is_bridged(b, MOI.Reals)
        variables, constraint = MOI.add_constrained_variables(b, MOI.Reals(n))
        return variables
    else
        return MOI.add_variables(b.model, n)
    end
end

# Split in two to avoid ambiguity
function MOI.supports_add_constrained_variables(
    b::AbstractBridgeOptimizer,
    ::Type{MOI.Reals},
)
    if is_bridged(b, MOI.Reals)
        return supports_bridging_constrained_variable(b, MOI.Reals)
    else
        return MOI.supports_add_constrained_variables(b.model, MOI.Reals)
    end
end

function MOI.supports_add_constrained_variables(
    b::AbstractBridgeOptimizer,
    S::Type{<:MOI.AbstractVectorSet},
)
    if is_bridged(b, S)
        return supports_bridging_constrained_variable(b, S)
    else
        return MOI.supports_add_constrained_variables(b.model, S)
    end
end

function MOI.add_constrained_variables(
    b::AbstractBridgeOptimizer,
    set::MOI.AbstractVectorSet,
)
    if !is_bridged(b, typeof(set))
        return MOI.add_constrained_variables(b.model, set)
    end
    if set isa MOI.Reals || is_variable_bridged(b, typeof(set))
        BridgeType = Variable.concrete_bridge_type(b, typeof(set))
        # `MOI.VectorOfVariables` constraint indices have negative indices
        # to distinguish between the indices of the inner model.
        # However, they can clash between the indices created by the variable
        # so we use the last argument to inform the variable bridge mapping about
        # indices already taken by constraint bridges.
        return Variable.add_keys_for_bridge(
            Variable.bridges(b)::Variable.Map,
            () -> Variable.bridge_constrained_variable(BridgeType, b, set),
            set,
            !Base.Fix1(haskey, Constraint.bridges(b)),
        )
    else
        variables = MOI.add_variables(b, MOI.dimension(set))
        constraint =
            MOI.add_constraint(b, MOI.VectorOfVariables(variables), set)
        return variables, constraint
    end
end

function MOI.supports_add_constrained_variable(
    b::AbstractBridgeOptimizer,
    S::Type{<:MOI.AbstractScalarSet},
)
    if is_bridged(b, S)
        return supports_bridging_constrained_variable(b, S)
    else
        return MOI.supports_add_constrained_variable(b.model, S)
    end
end

function MOI.add_constrained_variable(
    b::AbstractBridgeOptimizer,
    set::MOI.AbstractScalarSet,
)
    if !is_bridged(b, typeof(set))
        return MOI.add_constrained_variable(b.model, set)
    end
    if is_variable_bridged(b, typeof(set))
        BridgeType = Variable.concrete_bridge_type(b, typeof(set))
        return Variable.add_key_for_bridge(
            Variable.bridges(b)::Variable.Map,
            () -> Variable.bridge_constrained_variable(
                BridgeType,
                recursive_model(b),
                set,
            ),
            set,
        )
    else
        variable = MOI.add_variable(b)
        constraint = MOI.add_constraint(b, variable, set)
        return variable, constraint
    end
end

function MOI.supports(b::AbstractBridgeOptimizer, sub::MOI.AbstractSubmittable)
    return MOI.supports(b.model, sub)
end

function MOI.submit(
    b::AbstractBridgeOptimizer,
    sub::MOI.AbstractSubmittable,
    args...,
)
    return MOI.submit(b.model, sub, bridged_function.(b, args)...)
end

"""
    bridged_variable_function(
        b::AbstractBridgeOptimizer,
        vi::MOI.VariableIndex,
    )

Return a `MOI.AbstractScalarFunction` of variables of `b.model` that equals
`vi`. That is, if the variable `vi` is bridged, it returns its expression in
terms of the variables of `b.model`. Otherwise, it returns
`vi`.
"""
function bridged_variable_function(
    b::AbstractBridgeOptimizer,
    vi::MOI.VariableIndex,
)
    if is_bridged(b, vi)
        func = bridged_function(
            bridge(b, vi)::Variable.AbstractBridge,
            _index(b, vi)...,
        )
        # If two variable bridges are chained, `func` may still contain
        # bridged variables.
        return bridged_function(b, func)
    else
        return vi
    end
end

"""
    bridged_function(b::AbstractBridgeOptimizer, value)::typeof(value)

Substitute any bridged [`MOI.VariableIndex`](@ref) in `value` by an equivalent
expression in terms of variables of `b.model`.
"""
function bridged_function(bridge::AbstractBridgeOptimizer, value)
    if !Variable.has_bridges(Variable.bridges(bridge))
        # Shortcut, this allows performance to be unaltered when no variable
        # bridges are used.
        return value
    end
    # We assume that the type of `value` is not altered. This restricts
    # variable bridges to only return `ScalarAffineFunction` but otherwise,
    # the performance would be bad.
    return MOI.Utilities.substitute_variables(
        vi -> bridged_variable_function(bridge, vi),
        value,
    )::typeof(value)
end

function bridged_function(b::AbstractBridgeOptimizer, func::MOI.VariableIndex)
    # Should not be called by `add_constraint` as it force-bridges it
    # but could be called by attributes
    if is_bridged(b, func)
        # It could be solved by force-bridging the attribues (for example, objective).
        error("Using bridged variable in `VariableIndex` function.")
    end
    return func
end

"""
    unbridged_variable_function(
        b::AbstractBridgeOptimizer,
        vi::MOI.VariableIndex,
    )

Return a `MOI.AbstractScalarFunction` of variables of `b` that equals `vi`.
That is, if the variable `vi` is an internal variable of `b.model` created by a
bridge but not visible to the user, it returns its expression in terms of the
variables of bridged variables. Otherwise, it returns `vi`.
"""
function unbridged_variable_function(
    b::AbstractBridgeOptimizer,
    vi::MOI.VariableIndex,
)
    func = Variable.unbridged_function(Variable.bridges(b)::Variable.Map, vi)
    if func === nothing
        return vi
    else
        # If two variable bridges are chained, `func` may still contain
        # variables to unbridge.
        return unbridged_function(b, func)
    end
end

"""
    unbridged_function(b::AbstractBridgeOptimizer, value)::typeof(value)

Substitute any internal [`MOI.VariableIndex`](@ref) of `b.model` created by a
variable bridge but not visible to the user in `value` by an equivalent
expression in terms of bridged variables.
"""
function unbridged_function(b::AbstractBridgeOptimizer, value)
    if !Variable.has_bridges(Variable.bridges(b))
        return value
    end
    # If `value` does not contain any variable, this will never call
    # `unbridged_variable_function` hence it might silently return an incorrect
    # value so we call `throw_if_cannot_unbridge` here.
    Variable.throw_if_cannot_unbridge(Variable.bridges(b)::Variable.Map)
    return MOI.Utilities.substitute_variables(
        vi -> unbridged_variable_function(b, vi),
        value,
    )::typeof(value)
end

function unbridged_function(
    ::AbstractBridgeOptimizer,
    func::Union{MOI.VariableIndex,MOI.VectorOfVariables},
)
    return func # bridged variables are not allowed in non-bridged constraints
end

# Shortcut to avoid `Variable.throw_if_cannot_unbridge(Variable.bridges(b))`
function unbridged_function(
    ::AbstractBridgeOptimizer,
    value::MOI.Utilities.ObjectOrTupleOrArrayWithoutIndex,
)
    return value
end

"""
    bridged_constraint_function(
       b::AbstractBridgeOptimizer,
       func::MOI.AbstractFunction,
       set::MOI.AbstractSet
    )

Similar to `bridged_function(b, func)` but move function constant to the set if
it is scalar. Also return the modified set.
"""
function bridged_constraint_function end

function bridged_constraint_function(
    b::AbstractBridgeOptimizer,
    func::MOI.AbstractVectorFunction,
    set::MOI.AbstractVectorSet,
)
    return bridged_function(b, func), set
end

function bridged_constraint_function(
    b::AbstractBridgeOptimizer,
    func::MOI.AbstractScalarFunction,
    set::MOI.AbstractScalarSet,
)
    if !Variable.has_bridges(Variable.bridges(b))
        return func, set
    end
    # We use the fact that the initial function constant was zero to
    # implement getters for `MOI.ConstraintFunction` and `MOI.ConstraintSet`.
    #
    # See `unbridged_constraint_function` for more details.
    MOI.throw_if_scalar_and_constant_not_zero(func, typeof(set))
    f = bridged_function(b, func)::typeof(func)
    return MOI.Utilities.normalize_constant(f, set)
end

"""
    unbridged_constraint_function(
       b::AbstractBridgeOptimizer,
       func::MOI.AbstractFunction
    )

Similar to `unbridged_function(b, func)` but zero the function constant if it is
scalar.
"""
function unbridged_constraint_function end

# The purpose of unbridged_constraint_function is to convert the result of
# ConstraintFunction into the un-bridged form. Since variable bridges create
# substitution rules which are scalar functions, for example, `x => y_1 - y_2`, if the
# result is a VariableIndex or an AbstractVectorFunction we can return the
# unbridged function:

function unbridged_constraint_function(
    b::AbstractBridgeOptimizer,
    func::MOI.VariableIndex,
)
    return unbridged_function(b, func)
end

function unbridged_constraint_function(
    b::AbstractBridgeOptimizer,
    func::MOI.AbstractVectorFunction,
)
    return unbridged_function(b, func)
end

# (These are separate methods to avoid ambiguity issues.)

# But if the result is an AbstractScalarFunction, we need to be more careful.

function unbridged_constraint_function(
    b::AbstractBridgeOptimizer,
    func::MOI.AbstractScalarFunction,
)
    # If `b` has no variable bridges, no substitution can occur, so we return
    # func.
    if !Variable.has_bridges(Variable.bridges(b))
        return func
    end
    # Otherwise, first unbridge the function:
    f = unbridged_function(b, func)::typeof(func)
    # But now we have to deal with an issue. Something like x in [1, ∞) might
    # get bridged into y in R₊, with x => y + 1, so if the original constraint is
    # 2x >= 1, the bridged function is 2y >= -1. Unbridging this with y = x - 1
    # gives 2x - 2, but we only care about 2x. Where did the -2 come from? It
    # was moved into the set. This gets handled separately, so for
    # ConstraintFunction it is sufficient to drop any non-zero constant terms.
    #
    # It's also safe to do this because ScalarFunctionConstantNotZero will be
    # thrown if we can't move the constant into the set, and there is a test to
    # catch this.
    c = MOI.constant(f)
    if !iszero(c)
        f = MOI.Utilities.operate(-, typeof(c), f, c)
    end
    return f
end

# TODO add transform

# Copyright (c) 2017: Miles Lubin and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module SymbolicAD

import MathOptInterface as MOI

###
### simplify
###

"""
    simplify(f)

Return a simplified copy of the function `f`.

!!! warning
    This function is not type stable by design.

## Example

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> f = MOI.ScalarNonlinearFunction(:^, Any[x, 1])
^(MOI.VariableIndex(1), (1))

julia> MOI.Nonlinear.SymbolicAD.simplify(f)
MOI.VariableIndex(1)
```
"""
simplify(f) = simplify!(copy(f))

###
### `simplify!`
###

"""
    simplify!(f)

Simplify the function `f` in-place and return either the function `f` or a
new object if `f` can be represented in a simpler type.

!!! warning
    This function is not type stable by design.

## Example

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> f = MOI.ScalarNonlinearFunction(
           :+,
           Any[MOI.ScalarNonlinearFunction(:+, Any[1.0, x]), 2.0 * x + 3.0],
       )
+(+(1.0, MOI.VariableIndex(1)), 3.0 + 2.0 MOI.VariableIndex(1))

julia> MOI.Nonlinear.SymbolicAD.simplify!(f)
4.0 + 3.0 MOI.VariableIndex(1)

julia> f
+(1.0, MOI.VariableIndex(1), 3.0 + 2.0 MOI.VariableIndex(1))
```
"""
simplify!(f) = f

function simplify!(f::MOI.ScalarAffineFunction{T}) where {T}
    f = MOI.Utilities.canonicalize!(f)
    if isempty(f.terms)
        return f.constant
    end
    if iszero(f.constant) && length(f.terms) == 1
        term = only(f.terms)
        if isone(term.coefficient)
            return term.variable
        end
    end
    return f
end

function simplify!(f::MOI.ScalarQuadraticFunction{T}) where {T}
    f = MOI.Utilities.canonicalize!(f)
    if isempty(f.quadratic_terms)
        return simplify!(MOI.ScalarAffineFunction(f.affine_terms, f.constant))
    end
    return f
end

function simplify!(f::MOI.ScalarNonlinearFunction)
    stack, result_stack = Any[f], Any[]
    while !isempty(stack)
        arg = pop!(stack)
        if arg isa MOI.ScalarNonlinearFunction
            # We need some sort of hint so that the next time we see this on the
            # stack we evaluate it using the args in `result_stack`. One option
            # would be a custom type. Or we can just wrap in (,) and then check
            # for a Tuple, which isn't (curretly) a valid argument.
            push!(stack, (arg,))
            for child in arg.args
                push!(stack, child)
            end
        elseif arg isa Tuple{<:MOI.ScalarNonlinearFunction}
            result = only(arg)
            for i in eachindex(result.args)
                result.args[i] = pop!(result_stack)
            end
            # simplify!(::Val, ::Any) does not use recursion so this is safe.
            result = simplify!(Val(result.head), result)
            result = _eval_if_constant(result)
            push!(result_stack, result)
        else
            push!(result_stack, arg)
        end
    end
    return _simplify_if_quadratic!(only(result_stack))
end

function simplify!(f::MOI.VectorAffineFunction{T}) where {T}
    f = MOI.Utilities.canonicalize!(f)
    if isempty(f.terms)
        return f.constants
    end
    return f
end

function simplify!(f::MOI.VectorQuadraticFunction{T}) where {T}
    f = MOI.Utilities.canonicalize!(f)
    if isempty(f.quadratic_terms)
        if isempty(f.affine_terms)
            return f.constants
        end
        return MOI.VectorAffineFunction(f.affine_terms, f.constants)
    end
    return f
end

function simplify!(f::MOI.VectorNonlinearFunction)
    rows = simplify!.(f.rows)
    Y = reduce(promote_type, typeof.(rows))
    if isconcretetype(Y)
        return MOI.Utilities.vectorize(convert(Vector{Y}, rows))
    end
    return MOI.VectorNonlinearFunction(rows)
end

# If a ScalarNonlinearFunction has only constant arguments, we should return
# the value.

_isnum(::Any) = false

_isnum(::Union{Bool,Integer,Float64}) = true

function _eval_if_constant(f::MOI.ScalarNonlinearFunction)
    if all(_isnum, f.args) && hasproperty(Base, f.head)
        return getproperty(Base, f.head)(f.args...)
    end
    return f
end

_eval_if_constant(f) = f

_iszero(x::Any)::Bool = _isnum(x) && iszero(x)

_isone(x::Any)::Bool = _isnum(x) && isone(x)

"""
    _isexpr(f::Any, head::Symbol[, n::Int])

Return `true` if `f` is a `ScalarNonlinearFunction` with head `head` and, if
specified, `n` arguments.
"""
_isexpr(::Any, ::Symbol, n::Int = 0) = false

_isexpr(f::MOI.ScalarNonlinearFunction, head::Symbol) = f.head == head

function _isexpr(f::MOI.ScalarNonlinearFunction, head::Symbol, n::Int)
    return _isexpr(f, head) && length(f.args) == n
end

"""
    simplify!(::Val{head}, f::MOI.ScalarNonlinearFunction)

Simplify the function `f` in-place and return either the function `f` or a
new object if `f` can be represented in a simpler type.

## Val

The `head` in `Val{head}` is taken from `f.head`. This function should be called
as:
```julia
f = simplify!(Val(f.head), f)
```

Implementing a method that dispatches on `head` enables custom simplification
rules for different operators without needing a giant switch statement.

## Note

It is important that this function does not recursively call `simplify!`. Deal
only with the immediate operator. The children arguments will already be
simplified.
"""
simplify!(::Val, f::MOI.ScalarNonlinearFunction) = f

function simplify!(::Val{:*}, f::MOI.ScalarNonlinearFunction)
    new_args = Any[]
    first_constant = 0
    for arg in f.args
        if _isexpr(arg, :*)
            # If the child is a :*, lift its arguments to the parent
            append!(new_args, arg.args)
        elseif _iszero(arg)
            # If any argument is zero, the entire expression must be false
            return false
        elseif _isone(arg)
            # Skip any arguments that are one
        elseif arg isa Real
            # Collect all constant arguments into a single value
            if first_constant == 0
                push!(new_args, arg)
                first_constant = length(new_args)
            else
                new_args[first_constant] *= arg
            end
        else
            push!(new_args, arg)
        end
    end
    if length(new_args) == 0
        # *() -> true
        return true
    elseif length(new_args) == 1
        # *(x) -> x
        return only(new_args)
    end
    resize!(f.args, length(new_args))
    copyto!(f.args, new_args)
    return f
end

function simplify!(::Val{:+}, f::MOI.ScalarNonlinearFunction)
    new_args = Any[]
    first_affine_term = 0
    for arg in f.args
        if _isexpr(arg, :+)
            # If a child is a :+, lift its arguments to the parent
            append!(new_args, arg.args)
        elseif _iszero(arg)
            # Skip any zero arguments
        elseif arg isa Real
            # Collect all affine arguments into a single value
            if first_affine_term == 0
                push!(new_args, arg)
                first_affine_term = length(new_args)
            else
                new_args[first_affine_term] += arg
            end
        else
            push!(new_args, arg)
        end
    end
    if length(new_args) == 0
        # +() -> false
        return false
    elseif length(new_args) == 1
        # +(x) -> x
        return only(new_args)
    elseif length(f.args) == 2 && _isexpr(f.args[2], :-, 1)
        # +(x, -y) -> -(x, y)
        return MOI.ScalarNonlinearFunction(
            :-,
            Any[f.args[1], f.args[2].args[1]],
        )
    end
    resize!(f.args, length(new_args))
    copyto!(f.args, new_args)
    return f
end

function simplify!(::Val{:-}, f::MOI.ScalarNonlinearFunction)
    if length(f.args) == 1
        if _isexpr(f.args[1], :-, 1)
            # -(-(x)) => x
            return f.args[1].args[1]
        end
    elseif length(f.args) == 2
        if f.args[1] == f.args[2]
            # x - x => 0
            return false
        elseif _iszero(f.args[1])
            # 0 - x => -x
            popfirst!(f.args)
            return f
        elseif _iszero(f.args[2])
            # x - 0 => x
            return f.args[1]
        elseif _isexpr(f.args[2], :-, 1)
            # x - -(y) => x + y
            return MOI.ScalarNonlinearFunction(
                :+,
                Any[f.args[1], f.args[2].args[1]],
            )
        end
    end
    return f
end

function simplify!(::Val{:^}, f::MOI.ScalarNonlinearFunction)
    if _iszero(f.args[2])
        # x^0 => 1
        return true
    elseif _isone(f.args[2])
        # x^1 => x
        return f.args[1]
    elseif _iszero(f.args[1])
        # 0^x => 0
        return false
    elseif _isone(f.args[1])
        # 1^x => 1
        return true
    end
    return f
end

function simplify!(::Val{:ifelse}, f::MOI.ScalarNonlinearFunction)
    if f.args[1] == true
        # ifelse(true, x, y) => x
        return f.args[2]
    elseif f.args[1] == false
        # ifelse(false, x, y) => y
        return f.args[3]
    elseif f.args[2] == f.args[3]
        # ifelse(y, x, x) => x
        return f.args[2]
    end
    return f
end

###
### variables
###

"""
    variables(f::Union{Real,MOI.AbstractScalarFunction})

Return a sorted list of the `MOI.VariableIndex` present in the function `f`.

## Example

```jldoctest
julia> x = MOI.VariableIndex.(1:3)
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)

julia> f = MOI.ScalarNonlinearFunction(:atan, Any[x[3], 2.0 * x[1]])
atan(MOI.VariableIndex(3), 0.0 + 2.0 MOI.VariableIndex(1))

julia> MOI.Nonlinear.SymbolicAD.variables(f)
2-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(3)
```
"""
function variables(f::MOI.AbstractScalarFunction)
    ret = MOI.VariableIndex[]
    _variables(ret, f)
    return sort!(ret; by = x -> x.value)
end

variables(::Real) = MOI.VariableIndex[]

_variables(::Vector{MOI.VariableIndex}, ::Real) = nothing

function _variables(ret::Vector{MOI.VariableIndex}, f::MOI.VariableIndex)
    if !(f in ret)
        push!(ret, f)
    end
    return
end

function _variables(ret::Vector{MOI.VariableIndex}, f::MOI.ScalarAffineTerm)
    _variables(ret, f.variable)
    return
end

function _variables(ret::Vector{MOI.VariableIndex}, f::MOI.ScalarAffineFunction)
    for term in f.terms
        _variables(ret, term)
    end
    return
end

function _variables(ret::Vector{MOI.VariableIndex}, f::MOI.ScalarQuadraticTerm)
    _variables(ret, f.variable_1)
    _variables(ret, f.variable_2)
    return
end

function _variables(
    ret::Vector{MOI.VariableIndex},
    f::MOI.ScalarQuadraticFunction,
)
    for term in f.affine_terms
        _variables(ret, term)
    end
    for q_term in f.quadratic_terms
        _variables(ret, q_term)
    end
    return
end

function _variables(
    ret::Vector{MOI.VariableIndex},
    f::MOI.ScalarNonlinearFunction,
)
    stack = Any[f]
    while !isempty(stack)
        arg = pop!(stack)
        if arg isa MOI.ScalarNonlinearFunction
            # We need to push the args on in reverse order so that we iterate
            # across the tree from left to right.
            for i in reverse(1:length(arg.args))
                push!(stack, arg.args[i])
            end
        else
            _variables(ret, arg)
        end
    end
    return
end

###
### derivative
###

"""
    derivative(f::Union{Real,MOI.AbstractScalarFunction}, x::MOI.VariableIndex)

Return an expression representing the partial derivative of `f` with respect to
`x`.

## Expression swelling

With few exceptions, the algorithm used to compute the derivative does not
perform simplications. As a result, the returned expression may contain terms
like `*(false, g)` that can be trivially simplified to `false`.

In most cases, you should call `simplify!(derivative(f, x))` to return a
simplified expression of the derivative.

## Example

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> f = MOI.ScalarNonlinearFunction(:sin, Any[x])
sin(MOI.VariableIndex(1))

julia> df_dx = MOI.Nonlinear.SymbolicAD.derivative(f, x)
cos(MOI.VariableIndex(1))
```
"""
derivative(::Real, ::MOI.VariableIndex) = false

function derivative(f::MOI.VariableIndex, x::MOI.VariableIndex)
    return ifelse(f == x, true, false)
end

function derivative(
    f::MOI.ScalarAffineFunction{T},
    x::MOI.VariableIndex,
) where {T}
    ret = zero(T)
    for term in f.terms
        if term.variable == x
            ret += term.coefficient
        end
    end
    return ret
end

function derivative(
    f::MOI.ScalarQuadraticFunction{T},
    x::MOI.VariableIndex,
) where {T}
    constant = zero(T)
    for term in f.affine_terms
        if term.variable == x
            constant += term.coefficient
        end
    end
    aff_terms = MOI.ScalarAffineTerm{T}[]
    for q_term in f.quadratic_terms
        if q_term.variable_1 == q_term.variable_2 == x
            push!(aff_terms, MOI.ScalarAffineTerm(q_term.coefficient, x))
        elseif q_term.variable_1 == x
            push!(
                aff_terms,
                MOI.ScalarAffineTerm(q_term.coefficient, q_term.variable_2),
            )
        elseif q_term.variable_2 == x
            push!(
                aff_terms,
                MOI.ScalarAffineTerm(q_term.coefficient, q_term.variable_1),
            )
        end
    end
    return MOI.ScalarAffineFunction(aff_terms, constant)
end

function _replace_expression(node::Expr, u)
    for (i, arg) in enumerate(node.args)
        node.args[i] = _replace_expression(arg, u)
    end
    @assert Meta.isexpr(node, :call)
    op, args = node.args[1], node.args[2:end]
    return MOI.ScalarNonlinearFunction(op, args)
end

_replace_expression(node::Any, u) = node

function _replace_expression(node::Symbol, u)
    if node == :x
        return u
    end
    return node
end

"""
    __DERIVATIVE__ = "__DERIVATIVE__"

This constant is prefixed to the name of univariate operators to indicate
that we should compute their derivative.

If `f.head` is itself a __DERIVATIVE__, then this will create a second
derivative like `__DERIVATIVE____DERIVATIVE__\$(f.head)`.

Munging the `.head` field like this seems a bit hacky, but it is simpler than
the alternatives like `SNF(:derivative, Any[SNF(:f, Any[x]])])`, because this
would require changes to the already complicated expression walker for
evaluating the expression.

The String value of this constant is arbitrary. It just needs to be something
that the user would never write themselves.
"""
const __DERIVATIVE__ = "__DERIVATIVE__"

# This function helps simplify df_du * du_dx in the commonn case that `du_dx`
# is `true` (when u = x), or `false` (when x ∉ u).
function _univariate_chain_rule(df_du, du_dx)
    return MOI.ScalarNonlinearFunction(:*, Any[df_du, du_dx])
end

_univariate_chain_rule(df_du, du_dx::Bool) = ifelse(du_dx, df_du, du_dx)

function derivative(f::MOI.ScalarNonlinearFunction, x::MOI.VariableIndex)
    if length(f.args) == 1
        u = only(f.args)
        du_dx = derivative(u, x)
        if f.head == :+
            return du_dx
        elseif f.head == :-
            return MOI.ScalarNonlinearFunction(:-, Any[du_dx])
        elseif f.head == :abs
            df_du = MOI.ScalarNonlinearFunction(
                :ifelse,
                Any[MOI.ScalarNonlinearFunction(:>=, Any[u, 0]), 1, -1],
            )
            return _univariate_chain_rule(df_du, du_dx)
        elseif f.head == :sign
            return false
        elseif f.head == :deg2rad
            df_du = deg2rad(1)
            return _univariate_chain_rule(df_du, du_dx)
        elseif f.head == :rad2deg
            df_du = rad2deg(1)
            return _univariate_chain_rule(df_du, du_dx)
        end
        for (key, df, _) in MOI.Nonlinear.SYMBOLIC_UNIVARIATE_EXPRESSIONS
            if key == f.head
                # The chain rule: d(f(g(x))) / dx = f'(g(x)) * g'(x)
                df_du = _replace_expression(copy(df), u)
                return _univariate_chain_rule(df_du, du_dx)
            end
        end
        # Delay derivative until evaluation. This may result in a later
        # UnsupportedNonlinearOperator error, but we can't tell just yet.
        d_op = Symbol(__DERIVATIVE__ * "$(f.head)")
        df_du = MOI.ScalarNonlinearFunction(d_op, Any[u])
        return _univariate_chain_rule(df_du, du_dx)
    end
    if f.head == :+
        # d/dx(+(args...)) = +(d/dx args)
        args = Any[]
        for arg in f.args
            d_arg_dx = derivative(arg, x)
            if _iszero(d_arg_dx)
                # Special case: common situation where the arugment doesn't
                # depend on x
                continue
            end
            push!(args, d_arg_dx)
        end
        # A few special case handlers. We don't call the full `simplify!`
        # because that will allocate more, and we don't really care about
        # disaggregated constants.
        if isempty(args)
            return false
        elseif length(args) == 1
            return only(args)
        end
        return MOI.ScalarNonlinearFunction(:+, args)
    elseif f.head == :-
        # d/dx(-(args...)) = -(d/dx args)
        # Note that - is not unary here because that wouuld be caught above.
        args = Any[derivative(arg, x) for arg in f.args]
        return MOI.ScalarNonlinearFunction(:-, args)
    elseif f.head == :*
        # Product rule: d/dx(*(args...)) = sum(d{i}/dx * args\{i})
        sum_terms = Any[]
        for i in eachindex(f.args)
            g = MOI.ScalarNonlinearFunction(:*, copy(f.args))
            g.args[i] = derivative(f.args[i], x)
            if any(_iszero, g.args)
                # Special case: common situation where an argument doesn't
                # depend on x
                continue
            end
            # We call `simplify!` here to clean up any issues like *(y, true)
            # or *(y).
            push!(sum_terms, simplify!(Val(:*), g))
        end
        return simplify!(Val(:+), MOI.ScalarNonlinearFunction(:+, sum_terms))
    elseif f.head == :^
        # d/dx(u^p) = p*u^(p-1)*(du/dx) + u^p*log(u)*(dp/dx))
        @assert length(f.args) == 2
        u, p = f.args
        du_dx = derivative(u, x)
        dp_dx = derivative(p, x)
        term_1 = MOI.ScalarNonlinearFunction(
            :*,
            Any[p, MOI.ScalarNonlinearFunction(:^, Any[u, p-1]), du_dx],
        )
        if _iszero(dp_dx)  # p is constant and does not depend on x
            return term_1
        end
        term_2 = MOI.ScalarNonlinearFunction(
            :*,
            Any[
                MOI.ScalarNonlinearFunction(:^, Any[u, p]),
                MOI.ScalarNonlinearFunction(:log, Any[u]),
                dp_dx,
            ],
        )
        return MOI.ScalarNonlinearFunction(:+, Any[term_1, term_2])
    elseif f.head == :/
        # Quotient rule: d/dx(u / v) = (du/dx)*v - u*(dv/dx)) / v^2
        @assert length(f.args) == 2
        u, v = f.args
        du_dx, dv_dx = derivative(u, x), derivative(v, x)
        return MOI.ScalarNonlinearFunction(
            :/,
            Any[
                MOI.ScalarNonlinearFunction(
                    :-,
                    Any[
                        MOI.ScalarNonlinearFunction(:*, Any[du_dx, v]),
                        MOI.ScalarNonlinearFunction(:*, Any[u, dv_dx]),
                    ],
                ),
                MOI.ScalarNonlinearFunction(:^, Any[v, 2]),
            ],
        )
    elseif f.head == :ifelse
        @assert length(f.args) == 3
        # Pick the derivative of the active branch
        return MOI.ScalarNonlinearFunction(
            :ifelse,
            Any[f.args[1], derivative(f.args[2], x), derivative(f.args[3], x)],
        )
    elseif f.head == :atan
        @assert length(f.args) == 2
        u, v = f.args
        du_dx, dv_dx = derivative(u, x), derivative(v, x)
        u_2 = MOI.ScalarNonlinearFunction(:^, Any[u, 2])
        v_2 = MOI.ScalarNonlinearFunction(:^, Any[v, 2])
        u_dv_dx = MOI.ScalarNonlinearFunction(:*, Any[u, dv_dx])
        v_du_dx = MOI.ScalarNonlinearFunction(:*, Any[v, du_dx])
        return MOI.ScalarNonlinearFunction(
            :/,
            Any[
                MOI.ScalarNonlinearFunction(:+, Any[u_dv_dx, v_du_dx]),
                MOI.ScalarNonlinearFunction(:+, Any[u_2, v_2]),
            ],
        )
    elseif f.head == :min
        g = derivative(f.args[end], x)
        for i in (length(f.args)-1):-1:1
            g = MOI.ScalarNonlinearFunction(
                :ifelse,
                Any[
                    MOI.ScalarNonlinearFunction(:(<=), Any[f.args[i], f]),
                    derivative(f.args[i], x),
                    g,
                ],
            )
        end
        return g
    elseif f.head == :max
        g = derivative(f.args[end], x)
        for i in (length(f.args)-1):-1:1
            g = MOI.ScalarNonlinearFunction(
                :ifelse,
                Any[
                    MOI.ScalarNonlinearFunction(:(>=), Any[f.args[i], f]),
                    derivative(f.args[i], x),
                    g,
                ],
            )
        end
        return g
    elseif f.head in (:(>=), :(<=), :(<), :(>), :(==))
        return false
    end
    err = MOI.UnsupportedNonlinearOperator(
        f.head,
        "the operator does not support symbolic differentiation",
    )
    return throw(err)
end

###
### gradient_and_hessian
###

"""
    gradient_and_hessian(
        [filter_fn::Function = x -> true,]
        f::MOI.AbstractScalarFunction,
    )

Compute the symbolic gradient and Hessian of `f`, and return the result as a
tuple of four elements:

 1. `x::Vector{MOI.VariableIndex}`: the list of variables that appear in `f`
 2. `∇f::Vector{Any}`: a vector for the first partial derivative of `f` with
    respect to each element in `x`
 3. `H::Vector{Tuple{Int,Int}}`: a vector of `(row, column)` tuples that list
    the non-zero entries in the Hessian of `f`
 4. `∇²f::Vector{Any}`: a vector of expressions, in the same order as `H`, for
    the non-zero entries in the Hessian of `f`

## `filter_fn`

This argument is a function, `filter_fn(::MOI.VariableIndex)::Bool` that returns
`true` if the gradient and Hessian of `f` should be computed with respect to it.

Use this argument to filter out constant parameters from decision variables.
"""
function gradient_and_hessian(
    filter_fn::F,
    f::MOI.AbstractScalarFunction,
) where {F<:Function}
    x = filter!(filter_fn, variables(f))
    n = length(x)
    ∇f = Vector{Any}(undef, n)
    H_by_x, ∇²f_by_x = [Tuple{Int,Int}[] for _ in 1:n], [Any[] for _ in 1:n]
    for i in eachindex(x)
        xi = x[i]
        ∇fi = simplify!(derivative(f, xi))
        ∇f[i] = ∇fi
        for xj in filter!(filter_fn, variables(∇fi))
            j = findfirst(==(xj), x)
            if i > j
                continue  # Don't need lower triangle
            end
            dfij = simplify!(derivative(∇fi, xj))
            if dfij != false
                push!(∇²f_by_x[i], dfij)
                push!(H_by_x[i], (i, j))
            end
        end
    end
    return x, ∇f, reduce(vcat, H_by_x), reduce(vcat, ∇²f_by_x)
end

function gradient_and_hessian(f::MOI.AbstractScalarFunction)
    return gradient_and_hessian(x -> true, f)
end

###
### DAG
###

# operator is a (mask ⊻ id, nargs)::Tuple{Int32,Int32}, packed into an Int64
# This is based on the assumptions that:
#  1. we don't have more than typemax(Int32) >> 4 operators
#  2. we don't have more than typemax(Int32) input arguments
# both of these seem quite sensible.
function _mask_id_nargs_to_operator(mask::UInt32, id::Int, nargs::Int)
    @assert nargs <= typemax(Int32)
    @assert id <= (typemax(Int32) >> 4)
    return xor(Int64(mask ⊻ Int32(id)) << 32, Int64(nargs))
end

function _op_nargs_to_operator(
    reg::MOI.Nonlinear.OperatorRegistry,
    op::Symbol,
    nargs::Int,
)
    if nargs == 1
        op_to_id = reg.univariate_operator_to_id
        if (ret = get(op_to_id, op, nothing)) !== nothing
            return _mask_id_nargs_to_operator(:0x00000000, ret, nargs)
        end
        str_op = string(op)
        prefix_hessian = __DERIVATIVE__ * __DERIVATIVE__
        if startswith(str_op, prefix_hessian)
            f_op = Symbol(replace(str_op, prefix_hessian => ""))
            if (ret = get(op_to_id, f_op, nothing)) !== nothing
                return _mask_id_nargs_to_operator(:0x20000000, ret, nargs)
            end
        elseif startswith(str_op, __DERIVATIVE__)
            f_op = Symbol(replace(str_op, __DERIVATIVE__ => ""))
            if (ret = get(op_to_id, f_op, nothing)) !== nothing
                return _mask_id_nargs_to_operator(:0x10000000, ret, nargs)
            end
        end
    end
    if (ret = get(reg.multivariate_operator_to_id, op, nothing)) !== nothing
        return _mask_id_nargs_to_operator(:0x30000000, ret, nargs)
    end
    if (ret = get(reg.logic_operator_to_id, op, nothing)) !== nothing
        return _mask_id_nargs_to_operator(0x40000000, ret, nargs)
    end
    ret = reg.comparison_operator_to_id[op]
    return _mask_id_nargs_to_operator(0x50000000, ret, nargs)
end

function _operator_to_type_id_nargs(operator::Int64)::Tuple{Symbol,UInt32,Int64}
    @assert operator > 0
    type_id = Int32(operator >> 32)
    type = type_id & 0x70000000
    id = type_id - type
    nargs = operator - (Int64(type_id) << 32)
    if type == 0x00000000
        return :univariate, id, nargs
    elseif type == 0x10000000
        return :univariate_derivative, id, nargs
    elseif type == 0x20000000
        return :univariate_second_derivative, id, nargs
    elseif type == 0x30000000
        return :multivariate, id, nargs
    elseif type == 0x40000000
        return :logic, id, nargs
    else
        @assert type == 0x50000000
        return :comparison, id, nargs
    end
end

const _kNODE_PARAMETER = -1
const _kNODE_VARIABLE = -2
const _kNODE_VALUE = -3

"""
See the docstring of [`_DAG`](@ref).
"""
struct _Node
    operator::Int64
    data::Int64
end

function Base.show(io::IO, n::_Node)
    print(io, "_Node(", n.operator, ", ", n.data, ")\t")
    if n.operator == _kNODE_PARAMETER
        print(io, "\t\t# p[", n.data, "]")
    elseif n.operator == _kNODE_VARIABLE
        print(io, "\t\t# x[", n.data, "]")
    elseif n.operator == _kNODE_VALUE
        print(io, "# ", reinterpret(Float64, n.data))
    else
        type, op, nargs = _operator_to_type_id_nargs(n.operator)
        children = n.data .+ (0:(nargs-1))
        print(io, "# $type(op = $op, children = $children)")
    end
end

"""
    _DAG(registry::MOI.Nonlinear.OperatorRegistry)

The [`_DAG`](@ref) represents a vector-valued function `f(x, p)`.

## Fields

### `tape::Vector{_Node}`

The list of nodes in the DAG. A `_Node` is the struct:
```julia
struct _Node
    operator::Int64
    data::Int64
end
```
with the following interpretation:

 * If `operator == _kNODE_PARAMETER == -1`, then the `data` is the index in the
   input `p` vector
 * If `operator == _kNODE_VARIABLE == -2`, then the `data` is the index in the
   input `x` vector`
 * If `operator == _kNODE_VALUE == -3`, then the `data` is a `Float64`, encoded
   as an `Int64`. Access it with `reinterpret(Float64, node.data)`.
 * If `operator > 0`, then the operator is an operator from the
   `MOI.Nonlinear.OperatorRegistry` in the DAG. Use
   ```julia
   type, op, nargs = _operator_to_type_id_nargs(node.operator)
   ```
   to retrieve the type, op-code, and the number of arguments. The `data`
   field is the index of the first child in the `.children` array of the DAG.

### `nodes::Dict{UInt64,Int}`

A mapping of hash values to the index in `.tape`. This data structure is used to
de-duplicate nodes as the DAG is being built.

### `children::Vector{Int}`

An ordered list of the children for operator nodes in `tape`.

We could have stored these as a separate vector of children for each node in the
tape, where each element in the children vector is the index of the child in
`tape`. To minimize the number of unique vectors, we instead store here the
concatenation of all children vectors. The `node.data` value of an operator node
is the index in `.children` of the first child. More concretely, given an
operator node, the child nodes can be computed as:
```julia
type, op, nargs = _operator_to_type_id_nargs(node.operator)
children_indices = dag.children[node.data:node.data+nargs-1]
children_nodes = dag.tape[children_indices]
```

### `registry::MOI.Nonlinear.OperatorRegistry`

The registry containing operator information. The registry is used to evaluate
each operator via the corresponding methods in `MOI.Nonlinear`.

### `indices::Vector{Int}`

The indices of `.tape` that represent the output of the function `f(x, p)`.
These indices are mostly used when querying the result of an evaluated DAG via
`dag.result[dag.indices]`.

### `input::Vector{Float64}`

A cache for storing the input x when evaluating the DAG. This cache is useful
because the DAG's input variables are typically a subset of the full decision
vector. We could use a `view`, but instead we use this cache. The main reason is
to keep the input types as simple as possible (`Vector{Float64}` where
possible). At the cost of copying the values, we also avoid a set of
double-lookups when indexing into the full `x` via a `view`.

### `result::Vector{Float64}`

A cache for storing the result of evaluating the DAG. There is one element for
each element in `.tape`.

See also the `indices` field.

### `cache::Vector{Float64}`

A cache for evaluating multivariate operators. This will be sized such that its
length is the largest multivariate operator that may be called. Other operators
take views of the first nargs elements.

The main reason for this vector is to avoid a complicated `view` into the
`result` vector when evaluating multivariate operators.
"""
struct _DAG
    tape::Vector{_Node}
    nodes::Dict{UInt64,Int}
    children::Vector{Int}
    registry::MOI.Nonlinear.OperatorRegistry
    indices::Vector{Int}
    input::Vector{Float64}
    result::Vector{Float64}
    cache::Vector{Float64}

    function _DAG(registry)
        return new(
            _Node[],
            Dict{UInt64,Int}(),
            Int[],
            registry,
            Int[],
            Float64[],
            Float64[],
            Float64[],
        )
    end
end

function Base.show(io::IO, dag::_DAG)
    println(io, "DAG")
    println(io, "  tape")
    for (i, node) in enumerate(dag.tape)
        println(io, "    [$i]: ", node)
    end
    println(io, "  children")
    for (i, child) in enumerate(dag.children)
        println(io, "    [$i]: ", child)
    end
    return
end

function _DAG(registry::MOI.Nonlinear.OperatorRegistry, f::Vector)
    dag = _DAG(registry)
    stack, result_stack = Any[], Int[]
    for fi in f
        push!(stack, fi)
        while !isempty(stack)
            arg = pop!(stack)
            if arg isa MOI.ScalarAffineFunction
                push!(stack, convert(MOI.ScalarNonlinearFunction, arg))
            elseif arg isa MOI.ScalarQuadraticFunction
                push!(stack, convert(MOI.ScalarNonlinearFunction, arg))
            elseif arg isa MOI.ScalarNonlinearFunction
                push!(stack, (arg,))
                for child in arg.args
                    push!(stack, child)
                end
            else
                _add_node_to_dag(result_stack, dag, arg)
            end
        end
        @assert length(result_stack) == 1
        push!(dag.indices, pop!(result_stack))
    end
    resize!(dag.result, length(dag.tape))
    return dag
end

function _add_node_to_dag(result_stack, dag::_DAG, x::Real)
    _add_node_to_dag(result_stack, dag, convert(Float64, x))
    return
end

function _add_node_to_dag(result_stack, dag::_DAG, x::Float64)
    h = hash(x)
    result = get!(dag.nodes, h) do
        data = reinterpret(Int64, convert(Float64, x))
        node = _Node(_kNODE_VALUE, data)
        push!(dag.tape, node)
        dag.nodes[h] = length(dag.tape)
        return length(dag.tape)
    end
    push!(result_stack, result)
    return
end

function _add_node_to_dag(result_stack, dag::_DAG, x::MOI.VariableIndex)
    h = hash(x, hash(MOI.VariableIndex))
    result = get!(dag.nodes, h) do
        node = if x.value > 0
            _Node(_kNODE_VARIABLE, x.value)
        else
            @assert x.value < 0
            _Node(_kNODE_PARAMETER, -x.value)
        end
        push!(dag.tape, node)
        dag.nodes[h] = length(dag.tape)
        return length(dag.tape)
    end
    push!(result_stack, result)
    return
end

function _add_node_to_dag(
    result_stack,
    dag::_DAG,
    f::MOI.ScalarNonlinearFunction,
)
    op, nargs = f.head, length(f.args)
    children = Int[pop!(result_stack) for _ in 1:nargs]
    h = hash(children, hash(op))
    result = get!(dag.nodes, h) do
        data = length(dag.children) + 1
        append!(dag.children, children)
        operator = _op_nargs_to_operator(dag.registry, op, nargs)
        node = _Node(operator, data)
        if length(dag.cache) < nargs
            resize!(dag.cache, nargs)
        end
        push!(dag.tape, node)
        dag.nodes[h] = length(dag.tape)
        return length(dag.tape)
    end
    push!(result_stack, result)
    return
end

function _add_node_to_dag(
    result_stack,
    dag::_DAG,
    f::Tuple{MOI.ScalarNonlinearFunction},
)
    return _add_node_to_dag(result_stack, dag, only(f))
end

function _evaluate!(dag::_DAG, x::AbstractVector{Float64}, p::Vector{Float64})
    reg = dag.registry
    for (i, node) in enumerate(dag.tape)
        @inbounds dag.result[i] = if node.operator == _kNODE_PARAMETER
            p[node.data]
        elseif node.operator == _kNODE_VARIABLE
            x[node.data]
        elseif node.operator == _kNODE_VALUE
            reinterpret(Float64, node.data)
        else
            @assert node.operator > 0
            type, op, nargs = _operator_to_type_id_nargs(node.operator)
            if type == :univariate
                @assert nargs == 1
                MOI.Nonlinear.eval_univariate_function(
                    reg,
                    op,
                    dag.result[dag.children[node.data]],
                )
            elseif type == :univariate_derivative
                @assert nargs == 1
                MOI.Nonlinear.eval_univariate_gradient(
                    reg,
                    op,
                    dag.result[dag.children[node.data]],
                )
            elseif type == :univariate_second_derivative
                @assert nargs == 1
                MOI.Nonlinear.eval_univariate_hessian(
                    reg,
                    op,
                    dag.result[dag.children[node.data]],
                )
            elseif type == :multivariate
                for j in 1:nargs
                    dag.cache[j] = dag.result[dag.children[node.data+j-1]]
                end
                MOI.Nonlinear.eval_multivariate_function(
                    reg,
                    reg.multivariate_operators[op],
                    view(dag.cache, 1:nargs),
                )
            elseif type == :logic
                @assert nargs == 2
                MOI.Nonlinear.eval_logic_function(
                    reg,
                    reg.logic_operators[op],
                    dag.result[dag.children[node.data]] ≈ 1.0,
                    dag.result[dag.children[node.data+1]] ≈ 1.0,
                )
            else
                @assert type == :comparison
                @assert nargs == 2
                MOI.Nonlinear.eval_comparison_function(
                    reg,
                    reg.comparison_operators[op],
                    dag.result[dag.children[node.data]],
                    dag.result[dag.children[node.data+1]],
                )
            end
        end
    end
    return
end

struct _SymbolicInstance
    hash::UInt64
    x::Vector{Int}
    p::Vector{Float64}
    result::Vector{Float64}
    jac_offset::Int
    hess_offset::Int
end

function _evaluate!(dag::_DAG, g::_SymbolicInstance, x)
    if length(dag.input) != length(g.x)
        resize!(dag.input, length(g.x))
    end
    for (i, j) in enumerate(g.x)
        dag.input[i] = x[j]
    end
    _evaluate!(dag, dag.input, g.p)
    for (i, j) in enumerate(dag.indices)
        g.result[i] = dag.result[j]
    end
    return
end

###
### MOI.AbstractNLPEvaluator
###

struct Evaluator <: MOI.AbstractNLPEvaluator
    dag::Dict{UInt64,_DAG}
    H::Dict{UInt64,Vector{Tuple{Int64,Int64}}}
    objective::Union{Nothing,_SymbolicInstance}
    constraints::Vector{_SymbolicInstance}
    constraint_index_by_hash::Dict{UInt64,Vector{Int}}
    x::Vector{Float64}
end

"""
    _to_symbolic_form(
        nlp::MOI.Nonlinear.Model,
        expr::MOI.Nonlinear.Expression,
        variable_to_column::Dict{Int64,Int},
    )

Take an `expr` from `nlp` and convert it into a symbolic template.

`variable_to_column` is a dictionary that maps the `value` of
`MOI.VariableIndex(value)` to the 1-based index of the variable as it appears in
the MOI evaluators.

## Returns

Returns a `NamedTuple` with the following fields:

### `f::MOI.ScalarNonlinearFunction`

A `MOI.ScalarNonlinearFunction` that represents `expr`, with two subtleties:

 1. Each decision variable `MOI.VariableIndex(value)` in `expr` is translated to
    the column index via `variable_to_column[value]` and the column index is
    appended to `ordered_variables` (if it isn't already). Then, when
    `MOI.VariableIndex(i)` (where `i > 0`) appears in `f`, it means that the
    variable in `expr` corresponded to the column `ordered_variables[i]`.

 2. When `MOI.VariableIndex(-i)` (where `i < 0`) appears in `f`, it means that
    the value in `expr` was `data[i]`.

### `hash::UInt64`

A unique hash of the function `f`, which ignores the particular values of
`ordered_variables` and `data`.

### `ordered_variables::Vector{MOI.VariableIndex}`

A list of the decision variables that appear in `expr`, in the order that they
were traversed.

See `f` for details.

### `data::Vector{Float64}`

A list of the constants that appear in `expr`, in the order that they were
traversed.

See `f` for details.
"""
function _to_symbolic_form(
    nlp::MOI.Nonlinear.Model,
    expr::MOI.Nonlinear.Expression,
    variable_to_column::Dict{Int64,Int},
)
    list_of_variables = Int[]
    tree = Any[]
    h = hash(length(expr.nodes))
    for node in expr.nodes
        node_expr = if node.type == MOI.Nonlinear.NODE_MOI_VARIABLE
            xi = variable_to_column[node.index]
            m = findfirst(==(xi), list_of_variables)
            if m === nothing
                push!(list_of_variables, xi)
                m = length(list_of_variables)
            end
            h = hash((node.type, m), h)
            MOI.VariableIndex(m)
        elseif node.type == MOI.Nonlinear.NODE_VALUE
            h = hash((node.type, node.index), h)
            MOI.VariableIndex(-node.index)
        elseif node.type == MOI.Nonlinear.NODE_CALL_MULTIVARIATE
            op = nlp.operators.multivariate_operators[node.index]
            h = hash(op, h)
            MOI.ScalarNonlinearFunction(op, Any[])
        elseif node.type == MOI.Nonlinear.NODE_CALL_UNIVARIATE
            op = nlp.operators.univariate_operators[node.index]
            h = hash(op, h)
            MOI.ScalarNonlinearFunction(op, Any[])
        elseif node.type == MOI.Nonlinear.NODE_LOGIC
            op = nlp.operators.logic_operators[node.index]
            h = hash(op, h)
            MOI.ScalarNonlinearFunction(op, Any[])
        elseif node.type == MOI.Nonlinear.NODE_COMPARISON
            op = nlp.operators.comparison_operators[node.index]
            h = hash(op, h)
            MOI.ScalarNonlinearFunction(op, Any[])
        elseif node.type == MOI.Nonlinear.NODE_SUBEXPRESSION
            error("Subexpressions not supported")
        else
            @assert node.type == MOI.Nonlinear.NODE_PARAMETER
            error("Parameters not supported")
        end
        if 1 <= node.parent <= length(tree)
            h = hash(node.parent, h)
            push!(tree[node.parent].args, node_expr)
        end
        push!(tree, node_expr)
    end
    return (;
        f = tree[1],
        hash = h,
        ordered_variables = list_of_variables,
        data = copy(expr.values),
    )
end

function Evaluator(
    model::MOI.Nonlinear.Model,
    ordered_variables::Vector{MOI.VariableIndex},
)
    variable_to_column =
        Dict(x.value => i for (i, x) in enumerate(ordered_variables))
    hash_to_dag = Dict{UInt64,_DAG}()
    hash_to_H = Dict{UInt64,Vector{Tuple{Int64,Int64}}}()
    objective = nothing
    constraints = _SymbolicInstance[]
    constraint_index_by_hash = Dict{UInt64,Vector{Int}}()
    jac_offset, hess_offset = 0, 0
    if model.objective !== nothing
        o_sym = _to_symbolic_form(model, model.objective, variable_to_column)
        x, ∇f, H, ∇²f = gradient_and_hessian(x -> x.value > 0, o_sym.f)
        dag = _DAG(model.operators, Any[o_sym.f; ∇f; ∇²f])
        hash_to_dag[o_sym.hash] = dag
        hash_to_H[o_sym.hash] = H
        objective = _SymbolicInstance(
            o_sym.hash,
            o_sym.ordered_variables,
            o_sym.data,
            zeros(Float64, length(dag.indices)),
            jac_offset,
            hess_offset,
        )
        hess_offset += length(H)
    end
    for (i, c) in model.constraints
        c_sym = _to_symbolic_form(model, c.expression, variable_to_column)
        if !haskey(hash_to_dag, c_sym.hash)
            x, ∇f, H, ∇²f = gradient_and_hessian(x -> x.value > 0, c_sym.f)
            hash_to_dag[c_sym.hash] =
                _DAG(model.operators, Any[c_sym.f; ∇f; ∇²f])
            hash_to_H[c_sym.hash] = H
        end
        dag = hash_to_dag[c_sym.hash]
        H = hash_to_H[c_sym.hash]
        g_i = _SymbolicInstance(
            c_sym.hash,
            c_sym.ordered_variables,
            c_sym.data,
            zeros(Float64, length(dag.indices)),
            jac_offset,
            hess_offset,
        )
        jac_offset += length(c_sym.ordered_variables)
        hess_offset += length(H)
        push!(constraints, g_i)
        if !haskey(constraint_index_by_hash, c_sym.hash)
            constraint_index_by_hash[c_sym.hash] = Int[length(constraints)]
        else
            push!(constraint_index_by_hash[c_sym.hash], length(constraints))
        end
    end
    return Evaluator(
        hash_to_dag,
        hash_to_H,
        objective,
        constraints,
        constraint_index_by_hash,
        Float64[],
    )
end

function _evaluate!(model::Evaluator, x)
    if x == model.x
        return
    end
    if length(x) != length(model.x)
        resize!(model.x, length(x))
    end
    copyto!(model.x, x)
    o = model.objective
    if o !== nothing
        _evaluate!(model.dag[o.hash], o, x)
    end
    for h in collect(keys(model.constraint_index_by_hash))
        dag = model.dag[h]
        for i in model.constraint_index_by_hash[h]
            _evaluate!(dag, model.constraints[i], x)
        end
    end
    return
end

MOI.features_available(::Evaluator) = [:Grad, :Jac, :Hess]

function MOI.initialize(model::Evaluator, features::Vector{Symbol})
    @assert all(f in MOI.features_available(model) for f in features)
    return
end

function MOI.eval_objective(model::Evaluator, x)
    _evaluate!(model, x)
    return model.objective.result[1]
end

function MOI.eval_objective_gradient(model::Evaluator, ∇f, x)
    _evaluate!(model, x)
    fill!(∇f, 0.0)
    for i in eachindex(model.objective.x)
        xi = model.objective.x[i]
        ∇f[xi] = model.objective.result[1+i]
    end
    return
end

function MOI.eval_constraint(model::Evaluator, g, x)
    _evaluate!(model, x)
    for i in eachindex(model.constraints)
        g[i] = model.constraints[i].result[1]
    end
    return
end

function MOI.jacobian_structure(model::Evaluator)
    d = last(model.constraints)
    J = Vector{Tuple{Int,Int}}(undef, d.jac_offset + length(d.x))
    for i in eachindex(model.constraints)
        c = model.constraints[i]
        for (j, xj) in enumerate(c.x)
            J[c.jac_offset+j] = (i, xj)
        end
    end
    return J
end

function MOI.eval_constraint_jacobian(model::Evaluator, J, x)
    _evaluate!(model, x)
    for c in model.constraints
        for j in eachindex(c.x)
            J[c.jac_offset+j] = c.result[1+j]
        end
    end
    return
end

function MOI.hessian_lagrangian_structure(model::Evaluator)
    o = model.objective
    n = if !isempty(model.constraints)
        d = last(model.constraints)
        d.hess_offset + length(d.result) - length(d.x) - 1
    elseif o !== nothing
        length(model.H[o.hash])
    else
        0  # No constraints and no objective
    end
    H = Vector{Tuple{Int,Int}}(undef, n)
    if o !== nothing
        for (k, (hi, hj)) in enumerate(model.H[o.hash])
            H[k] = (o.x[hi], o.x[hj])
        end
    end
    for c in model.constraints
        for (k, (hi, hj)) in enumerate(model.H[c.hash])
            H[c.hess_offset+k] = (c.x[hi], c.x[hj])
        end
    end
    return H
end

function MOI.eval_hessian_lagrangian(model::Evaluator, H, x, σ, μ)
    _evaluate!(model, x)
    o = model.objective
    if o !== nothing
        offset = o.hess_offset - length(o.x) - 1
        for j in (2+length(o.x)):length(o.result)
            H[offset+j] = σ * o.result[j]
        end
    end
    for i in eachindex(model.constraints)
        c = model.constraints[i]
        # It is important that `offset_c` does not shadow `offset` from the
        # objective block. If we use the same name, Julia creates a Core.Box
        offset_c = c.hess_offset - length(c.x) - 1
        for j in (2+length(c.x)):length(c.result)
            H[offset_c+j] = μ[i] * c.result[j]
        end
    end
    return
end

# A default fallback for all types
_add_to_quadratic!(::Any, ::Real, ::Any) = nothing
_add_to_quadratic!(::Any, ::Real, ::Any, ::Any) = nothing

# The creation of `ret::MOI.ScalarQuadraticFunction` has been delayed until now.
function _add_to_quadratic!(
    ::Missing,
    scale::T,
    f::Union{
        Real,
        MOI.VariableIndex,
        MOI.ScalarAffineFunction,
        MOI.ScalarQuadraticFunction,
    }...,
) where {T<:Real}
    return _add_to_quadratic!(zero(MOI.ScalarQuadraticFunction{T}), scale, f...)
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    x::S,
) where {T<:Real,S<:Real}
    if promote_type(T, S) != T
        return  # We can't store `S` in `T`.
    end
    ret.constant += scale * convert(T, x)
    return ret
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    f::MOI.ScalarAffineTerm{S},
) where {T<:Real,S}
    @assert promote_type(T, S) == T
    push!(
        ret.affine_terms,
        MOI.ScalarAffineTerm{T}(scale * f.coefficient, f.variable),
    )
    return ret
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    f::MOI.ScalarQuadraticTerm{S},
) where {T<:Real,S}
    @assert promote_type(T, S) == T
    push!(
        ret.quadratic_terms,
        MOI.ScalarQuadraticTerm{T}(
            scale * f.coefficient,
            f.variable_1,
            f.variable_2,
        ),
    )
    return ret
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    x::MOI.VariableIndex,
) where {T<:Real}
    return _add_to_quadratic!(ret, scale, MOI.ScalarAffineTerm(one(T), x))
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    f::MOI.ScalarAffineFunction{S},
) where {T<:Real,S}
    if promote_type(T, S) != T
        return  # We can't store `S` in `T`.
    end
    ret = _add_to_quadratic!(ret, scale, f.constant)
    for term in f.terms
        ret = _add_to_quadratic!(ret, scale, term)
    end
    return ret
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    f::MOI.ScalarQuadraticFunction{S},
) where {T<:Real,S}
    if promote_type(T, S) != T
        return  # We can't store `S` in `T`.
    end
    ret = _add_to_quadratic!(ret, scale, f.constant)
    for term in f.affine_terms
        ret = _add_to_quadratic!(ret, scale, term)
    end
    for q_term in f.quadratic_terms
        ret = _add_to_quadratic!(ret, scale, q_term)
    end
    return ret
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    f::MOI.VariableIndex,
    g::MOI.VariableIndex,
) where {T<:Real}
    return _add_to_quadratic!(ret, scale, one(T) * f * g)
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    f::MOI.ScalarAffineFunction{F},
    g::MOI.ScalarAffineFunction{G},
) where {T<:Real,F,G}
    H = MOI.ScalarAffineFunction{promote_type(F, G)}
    return _add_to_quadratic!(ret, scale, convert(H, f) * convert(H, g))
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    f::MOI.VariableIndex,
    g::MOI.ScalarAffineFunction,
) where {T<:Real}
    return _add_to_quadratic!(ret, scale, f * g)
end

function _add_to_quadratic!(
    ret::MOI.ScalarQuadraticFunction{T},
    scale::T,
    f::MOI.ScalarAffineFunction,
    g::MOI.VariableIndex,
) where {T<:Real}
    return _add_to_quadratic!(ret, scale, g, f)
end

function _add_to_quadratic!(
    ret::Union{Missing,MOI.ScalarQuadraticFunction{T}},
    scale::T,
    f::MOI.ScalarNonlinearFunction,
) where {T<:Real}
    if f.head == :+
        for arg in f.args
            ret = _add_to_quadratic!(ret, scale, arg)
            if ret === nothing
                return
            end
        end
        return ret
    elseif f.head == :-
        if length(f.args) == 1
            return _add_to_quadratic!(ret, -scale, only(f.args))
        end
        @assert length(f.args) == 2
        ret = _add_to_quadratic!(ret, scale, f.args[1])
        if ret === nothing
            return
        end
        return _add_to_quadratic!(ret, -scale, f.args[2])
    elseif f.head == :*
        y1, y2 = nothing, nothing
        for arg in f.args
            if arg isa Real
                scale *= arg
            elseif y1 === nothing
                y1 = arg
            elseif y2 === nothing
                y2 = arg
            else
                return # We already have a `y`. Can't multiple factors.
            end
        end
        if y1 === nothing
            @assert y2 === nothing
            return _add_to_quadratic!(ret, one(T), scale)
        elseif y2 === nothing
            return _add_to_quadratic!(ret, scale, y1)
        else
            return _add_to_quadratic!(ret, scale, y1, y2)
        end
    elseif f.head == :^ && f.args[2] isa Real && f.args[2] == 2
        return _add_to_quadratic!(ret, scale, f.args[1], f.args[1])
    elseif f.head == :/ && f.args[2] isa Real
        return _add_to_quadratic!(ret, convert(T, scale / f.args[2]), f.args[1])
    end
    return  # An unsupported f.head
end

function _simplify_if_quadratic!(f::MOI.ScalarNonlinearFunction)
    ret = _add_to_quadratic!(missing, 1.0, f)
    if ret === nothing
        return f
    end
    return simplify!(ret::MOI.ScalarQuadraticFunction{Float64})
end

_simplify_if_quadratic!(f::Any) = f

end  # module

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    test_modification_set_function_single_variable(
        model::MOI.ModelLike,
        config::Config,
    )

Test that modifying the function of a `VariableIndex`-in-`LessThan` constraint
throws a [`SettingVariableIndexNotAllowed`](@ref) error.
"""
function test_modification_set_function_single_variable(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    x, y = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x + T(1) * y
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    err = MOI.SettingVariableIndexNotAllowed()
    @test_throws err MOI.set(model, MOI.ConstraintFunction(), c, y)
    return
end

"""
    test_modification_set_singlevariable_lessthan(
        model::MOI.ModelLike,
        config::Config,
    )

Test set modification VariableIndex-in-LessThan constraint. If
`config.solve=true` confirm that it solves correctly, and if
`config.duals=true`, check that the duals are computed correctly.
"""
function test_modification_set_singlevariable_lessthan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(-1))],
    )
    MOI.set(model, MOI.ConstraintSet(), c, MOI.LessThan(T(2)))
    @test MOI.get(model, MOI.ConstraintSet(), c) == MOI.LessThan(T(2))
    _test_model_solution(
        model,
        config;
        objective_value = T(2),
        variable_primal = [(x, T(2))],
        constraint_primal = [(c, T(2))],
        constraint_dual = [(c, T(-1))],
    )
    return
end

function setup_test(
    ::typeof(test_modification_set_singlevariable_lessthan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2]),
            MOI.FEASIBLE_POINT,
        ),
    )
    return
end

"""
    test_modification_transform_singlevariable_lessthan(
        model::MOI.ModelLike,
        config::Config,
    )

Test set transformation of a VariableIndex-in-LessThan constraint. If
`config.solve=true` confirm that it solves correctly, and if
`config.duals=true`, check that the duals are computed correctly.
"""
function test_modification_transform_singlevariable_lessthan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(-1))],
    )
    c2 = MOI.transform(model, c, MOI.GreaterThan(T(2)))
    @test !MOI.is_valid(model, c)
    @test MOI.is_valid(model, c2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    _test_model_solution(
        model,
        config;
        objective_value = T(2),
        variable_primal = [(x, T(2))],
        constraint_primal = [(c2, T(2))],
        constraint_dual = [(c2, T(1))],
    )
    return
end

function setup_test(
    ::typeof(test_modification_transform_singlevariable_lessthan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2]),
            MOI.FEASIBLE_POINT,
        ),
    )
    return
end

"""
    test_modification_set_scalaraffine_lessthan(
        model::MOI.ModelLike,
        config::Config,
    )

Test modifying set of ScalarAffineFunction-in-LessThan constraint. If
`config.solve=true` confirm that it solves correctly, and if
`config.duals=true`, check that the duals are computed correctly.
"""
function test_modification_set_scalaraffine_lessthan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(model, f, MOI.LessThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(-1))],
    )
    MOI.set(model, MOI.ConstraintSet(), c, MOI.LessThan(T(2)))
    @test MOI.get(model, MOI.ConstraintSet(), c) == MOI.LessThan(T(2))
    _test_model_solution(
        model,
        config;
        objective_value = T(2),
        variable_primal = [(x, T(2))],
        constraint_primal = [(c, T(2))],
        constraint_dual = [(c, T(-1))],
    )
    return
end

function setup_test(
    ::typeof(test_modification_set_scalaraffine_lessthan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
        ),
    )
    return
end

"""
    test_modification_coef_scalaraffine_lessthan(
        model::MOI.ModelLike,
        config::Config,
    )

Test modifying a variable coefficient in a ScalarAffineFunction-in-LessThan
constraint. If `config.solve=true` confirm that it solves correctly, and if
`config.duals=true`, check that the duals are computed correctly.
"""
function test_modification_coef_scalaraffine_lessthan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(model, f, MOI.LessThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(-1))],
    )
    MOI.modify(model, c, MOI.ScalarCoefficientChange(x, T(2)))
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 2),
        variable_primal = [(x, T(1 // 2))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(-1 // 2))],
    )
    return
end

function setup_test(
    ::typeof(test_modification_coef_scalaraffine_lessthan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1//2],
        ),
    )
    return
end

"""
    test_modification_func_scalaraffine_lessthan(
        model::MOI.ModelLike,
        config::Config,
    )

Test setting the function in a ScalarAffineFunction-in-LessThan
constraint. If `config.solve=true` confirm that it solves correctly, and if
`config.duals=true`, check that the duals are computed correctly.
"""
function test_modification_func_scalaraffine_lessthan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(model, f, MOI.LessThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(-1))],
    )
    MOI.set(
        model,
        MOI.ConstraintFunction(),
        c,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(0)),
    )
    foo = MOI.get(model, MOI.ConstraintFunction(), c)
    @test foo ≈ MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(0))
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 2),
        variable_primal = [(x, T(1 // 2))],
        # constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(-1 // 2))],
    )
    return
end

function setup_test(
    ::typeof(test_modification_func_scalaraffine_lessthan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1],
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2]),
            MOI.FEASIBLE_POINT,
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => T[-1//2],
        ),
    )
    return
end

"""
    test_modification_func_vectoraffine_nonneg(
        model::MOI.ModelLike,
        config::Config,
    )

Test setting the function in a VectorAffineFunction-in-Nonnegatives
constraint. If `config.solve=true` confirm that it solves correctly, and if
`config.duals=true`, check that the duals are computed correctly.
"""
function test_modification_func_vectoraffine_nonneg(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x, y = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = T(1) * x + T(2) * y
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    g = MOI.Utilities.operate(vcat, T, T(1) * x, T(2) * y)
    c = MOI.add_constraint(model, g, MOI.Nonnegatives(2))
    _test_model_solution(
        model,
        config;
        objective_value = T(0),
        variable_primal = [(x, T(0)), (y, T(0))],
        constraint_primal = [(c, T[0, 0])],
    )
    MOI.set(
        model,
        MOI.ConstraintFunction(),
        c,
        MOI.VectorAffineFunction(
            [
                MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x)),
                MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(2), y)),
            ],
            T[-1, -3//2],
        ),
    )
    foo = MOI.get(model, MOI.ConstraintFunction(), c)
    @test foo ≈ MOI.VectorAffineFunction(
        [
            MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x)),
            MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(2), y)),
        ],
        T[-1, -3//2],
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(5 // 2),
        variable_primal = [(x, T(1)), (y, T(3 // 4))],
        constraint_primal = [(c, T[0, 0])],
    )
    return
end

function setup_test(
    ::typeof(test_modification_func_vectoraffine_nonneg),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[0, 0]),
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 3//4]),
        ),
    )
    return
end

"""
    test_modification_const_vectoraffine_zeros(
        model::MOI.ModelLike,
        config::Config,
    )

Test modifying the constant term in a VectorAffineFunction-in-Zeros constraint.
If `config.solve=true` confirm that it solves correctly, and if
`config.duals=true`, check that the duals are computed correctly.
"""
function test_modification_const_vectoraffine_zeros(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x, y = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x + T(2) * y
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(
        model,
        MOI.VectorAffineFunction(
            [
                MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x)),
                MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(2), y)),
            ],
            T[0, 0],
        ),
        MOI.Zeros(2),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(0),
        variable_primal = [(x, T(0)), (y, T(0))],
        constraint_primal = [(c, T[0, 0])],
    )
    MOI.modify(model, c, MOI.VectorConstantChange(T[-1, -3//2]))
    _test_model_solution(
        model,
        config;
        objective_value = T(5 // 2),
        variable_primal = [(x, T(1)), (y, T(3 // 4))],
        constraint_primal = [(c, T[0, 0])],
    )
    return
end

version_added(::typeof(test_modification_const_vectoraffine_zeros)) = v"0.10.7"

function setup_test(
    ::typeof(test_modification_const_vectoraffine_zeros),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[0, 0]),
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 3//4]),
        ),
    )
    return
end

"""
    test_modification_const_vectoraffine_nonpos(
        model::MOI.ModelLike,
        config::Config,
    )

Test modifying the constant term in a VectorAffineFunction-in-Nonpositives
constraint. If `config.solve=true` confirm that it solves correctly, and if
`config.duals=true`, check that the duals are computed correctly.
"""
function test_modification_const_vectoraffine_nonpos(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x, y = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x + T(2) * y
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(
        model,
        MOI.VectorAffineFunction(
            [
                MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x)),
                MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(2), y)),
            ],
            T[0, 0],
        ),
        MOI.Nonpositives(2),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(0),
        variable_primal = [(x, T(0)), (y, T(0))],
        constraint_primal = [(c, T[0, 0])],
    )
    MOI.modify(model, c, MOI.VectorConstantChange(T[-1, -3//2]))
    _test_model_solution(
        model,
        config;
        objective_value = T(5 // 2),
        variable_primal = [(x, T(1)), (y, T(3 // 4))],
        constraint_primal = [(c, T[0, 0])],
    )
    return
end

function setup_test(
    ::typeof(test_modification_const_vectoraffine_nonpos),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[0, 0]),
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 3//4]),
        ),
    )
    return
end

"""
    test_modification_multirow_vectoraffine_nonpos(
        model::MOI.ModelLike,
        config::Config,
    )

Test modifying the variable coefficients in a
VectorAffineFunction-in-Nonpositives constraint. If `config.solve=true` confirm
that it solves correctly.
"""
function test_modification_multirow_vectoraffine_nonpos(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    c = MOI.add_constraint(
        model,
        MOI.VectorAffineFunction(
            [
                MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x)),
                MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(T(2), x)),
            ],
            T[-1, -1],
        ),
        MOI.Nonpositives(2),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 2),
        variable_primal = [(x, T(1 // 2))],
        constraint_primal = [(c, T[-1//2, 0])],
    )
    MOI.modify(model, c, MOI.MultirowChange(x, [(1, T(4)), (2, T(3))]))
    _test_model_solution(
        model,
        config;
        objective_value = T(1 // 4),
        variable_primal = [(x, T(1 // 4))],
        constraint_primal = [(c, T[0, -1//4])],
    )
    return
end

function setup_test(
    ::typeof(test_modification_multirow_vectoraffine_nonpos),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//2]),
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1//4]),
        ),
    )
    return
end

"""
    test_modification_const_scalar_objective(
        model::MOI.ModelLike,
        config::Config,
    )

Test the constant of a ScalarAffineFunction objective. If `config.solve=true`
confirm that it solves correctly.
"""
function test_modification_const_scalar_objective(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(2))
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(3),
        variable_primal = [(x, T(1))],
    )
    MOI.modify(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarConstantChange(T(3)),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(4),
        variable_primal = [(x, T(1))],
    )
    return
end

function setup_test(
    ::typeof(test_modification_const_scalar_objective),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
    )
    return
end

"""
    test_modification_coef_scalar_objective(
        model::MOI.ModelLike,
        config::Config
    )

Test modifying a variable coefficient in a scalaraffine objective. If
`config.solve=true` confirm that it solves correctly.
"""
function test_modification_coef_scalar_objective(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
    )
    MOI.modify(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarCoefficientChange(x, T(3)),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(3),
        variable_primal = [(x, T(1))],
    )
    return
end

function setup_test(
    ::typeof(test_modification_coef_scalar_objective),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
    )
    return
end

"""
    test_modification_delete_variable_with_single_variable_obj(
        model::MOI.ModelLike,
        config::Config,
    )

Test deleting a variable that is the objective function.
"""
function test_modification_delete_variable_with_single_variable_obj(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    MOI.delete(model, y)
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(1))],
    )
    return
end

function setup_test(
    ::typeof(test_modification_delete_variable_with_single_variable_obj),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[1],
        ),
    )
    return
end

"""
    test_modification_delete_variables_in_a_batch(
        model::MOI.ModelLike,
        config::Config,
    )

Test deleting many variables in a batch (that is, using the delete method which
takes a vector of variable references). If `config.solve=true` confirm that it
solves correctly.
"""
function test_modification_delete_variables_in_a_batch(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x, y, z = MOI.add_variables(model, 3)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = T(1) * x + T(2) * y + T(3) * z
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.add_constraint.(model, [x, y, z], MOI.GreaterThan(T(1)))
    @test MOI.is_valid(model, x)
    @test MOI.is_valid(model, y)
    @test MOI.is_valid(model, z)
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test isapprox(MOI.get(model, MOI.ObjectiveValue()), T(6), config)
    end
    MOI.delete(model, [x, z])
    @test !MOI.is_valid(model, x)
    @test MOI.is_valid(model, y)
    @test !MOI.is_valid(model, z)
    if _supports(config, MOI.optimize!)
        MOI.optimize!(model)
        @test isapprox(MOI.get(model, MOI.ObjectiveValue()), T(2), config)
    end
    return
end

function setup_test(
    ::typeof(test_modification_delete_variables_in_a_batch),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 1, 1]),
            MOI.FEASIBLE_POINT,
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
        ),
    )
    return
end

"""
    test_modification_affine_deletion_edge_cases(
        model::MOI.ModelLike,
        config::Config,
    )

Test various edge cases relating to deleting affine constraints. This requires
    + ScalarAffineFunction-in-LessThan; and
    + VectorAffineFunction-in-Nonpositives.
"""
function test_modification_affine_deletion_edge_cases(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    # helpers. The function 1.0x + 0.0
    saf = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    vaf = MOI.VectorAffineFunction(
        [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x))],
        T[0],
    )
    vaf2 = MOI.VectorAffineFunction(
        [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(T(1), x))],
        T[-2],
    )
    # max x
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(), saf)
    # test adding a VectorAffineFunction -in- LessThan
    c1 = MOI.add_constraint(model, vaf, MOI.Nonpositives(1))
    _test_model_solution(
        model,
        config;
        objective_value = T(0),
        constraint_primal = [(c1, T[0])],
    )
    # test adding a ScalarAffineFunction -in- LessThan
    c2 = MOI.add_constraint(model, saf, MOI.LessThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(0),
        constraint_primal = [(c1, T[0]), (c2, T(0))],
    )
    # now delete the VectorAffineFunction
    MOI.delete(model, c1)
    @test_throws MOI.InvalidIndex{typeof(c1)} MOI.delete(model, c1)
    try
        MOI.delete(model, c1)
    catch err
        @test err.index == c1
    end
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        constraint_primal = [(c2, T(1))],
    )
    # add a different VectorAffineFunction constraint
    c3 = MOI.add_constraint(model, vaf2, MOI.Nonpositives(1))
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        constraint_primal = [(c2, T(1)), (c3, T[-1])],
    )
    # delete the ScalarAffineFunction
    MOI.delete(model, c2)
    _test_model_solution(
        model,
        config;
        objective_value = T(2),
        constraint_primal = [(c3, T[0])],
    )
    return
end

function setup_test(
    ::typeof(test_modification_affine_deletion_edge_cases),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[0])),
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[0])),
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[2])),
    )
    return
end

"""
    test_modification_incorrect(model::MOI.ModelLike, config::Config{T}) where {T}

Test that constraint sets and functions cannot be set for the wrong type.
"""
function test_modification_incorrect(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0)),
        MOI.EqualTo(T(1)),
    )
    @test_throws(
        MOI.SetTypeMismatch{MOI.EqualTo{T},MOI.LessThan{T}},
        MOI.set(model, MOI.ConstraintSet(), c, MOI.LessThan(T(1))),
    )
    @test_throws(
        MOI.FunctionTypeMismatch{MOI.ScalarAffineFunction{T},MOI.VariableIndex},
        MOI.set(model, MOI.ConstraintFunction(), c, x),
    )
    return
end

"""
    test_modification_incorrect_VariableIndex(
        model::MOI.ModelLike,
        config::Config,
    )

Test that constraint sets cannot be set for the wrong set type, and that
VariableIndex functions cannot be modified.
"""
function test_modification_incorrect_VariableIndex(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.LessThan{T})
    @requires(
        MOI.supports_constraint(model, MOI.VariableIndex, MOI.GreaterThan{T}),
    )
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test_throws(
        MOI.SetTypeMismatch{MOI.GreaterThan{T},MOI.LessThan{T}},
        MOI.set(model, MOI.ConstraintSet(), c, MOI.LessThan(T(1))),
    )
    @test_throws(
        MOI.FunctionTypeMismatch{MOI.VariableIndex,MOI.ScalarAffineFunction{T}},
        MOI.set(model, MOI.ConstraintFunction(), c, T(1) * x),
    )
    y = MOI.add_variable(model)
    @test_throws(
        MOI.SettingVariableIndexNotAllowed(),
        MOI.set(model, MOI.ConstraintFunction(), c, y),
    )
    return
end

function test_modification_objective_scalarquadraticcoefficientchange(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    attr = MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}()
    @requires MOI.supports(model, attr)
    @requires _supports(config, MOI.modify)
    @requires _supports(config, MOI.ScalarQuadraticCoefficientChange)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, attr, T(1) * x * x + T(2) * x + T(3))
    @test ≈(MOI.get(model, attr), T(1) * x * x + T(2) * x + T(3), config)
    MOI.modify(model, attr, MOI.ScalarQuadraticCoefficientChange(x, x, T(4)))
    @test ≈(MOI.get(model, attr), T(2) * x * x + T(2) * x + T(3), config)
    y = MOI.add_variable(model)
    MOI.set(model, attr, T(1) * x * x + T(2) * x * y)
    @test ≈(MOI.get(model, attr), T(1) * x * x + T(2) * x * y, config)
    MOI.modify(model, attr, MOI.ScalarQuadraticCoefficientChange(x, y, T(4)))
    @test ≈(MOI.get(model, attr), T(1) * x * x + T(4) * x * y, config)
    MOI.modify(model, attr, MOI.ScalarQuadraticCoefficientChange(y, x, T(6)))
    @test ≈(MOI.get(model, attr), T(1) * x * x + T(6) * x * y, config)
    return
end

function version_added(
    ::typeof(test_modification_objective_scalarquadraticcoefficientchange),
)
    return v"1.21.0"
end

function test_modification_constraint_scalarquadraticcoefficientchange(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    F, S = MOI.ScalarQuadraticFunction{T}, MOI.LessThan{T}
    @requires MOI.supports_constraint(model, F, S)
    @requires _supports(config, MOI.modify)
    @requires _supports(config, MOI.ScalarQuadraticCoefficientChange)
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    f = T(1) * x * x + T(1) * x * x - T(1) * x * y + T(2) * y * y - T(1) * x * y
    c = MOI.add_constraint(model, f, MOI.LessThan(T(1)))
    @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), f, config)
    g = T(1) * x * x + T(-3) * x * y + T(2) * y * y
    MOI.modify(model, c, MOI.ScalarQuadraticCoefficientChange(x, x, T(2)))
    MOI.modify(model, c, MOI.ScalarQuadraticCoefficientChange(x, y, -T(3)))
    @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), g, config)
    MOI.modify(model, c, MOI.ScalarQuadraticCoefficientChange(y, x, -T(3)))
    @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), g, config)
    return
end

function version_added(
    ::typeof(test_modification_constraint_scalarquadraticcoefficientchange),
)
    return v"1.21.0"
end

function test_modification_mathoptinterface_issue_2452(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    F, S = MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}
    @requires MOI.supports_constraint(model, F, S)
    x, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(T(1)))
    c = MOI.add_constraint(model, T(2) * x, MOI.EqualTo(T(3)))
    @test ≈(MOI.get(model, MOI.ConstraintFunction(), c), T(2) * x, config)
    @test MOI.get(model, MOI.ConstraintSet(), c) == MOI.EqualTo(T(3))
    MOI.set(model, MOI.ConstraintSet(), c, MOI.EqualTo(T(2)))
    @test MOI.get(model, MOI.ConstraintSet(), c) == MOI.EqualTo(T(2))
    return
end

function version_added(::typeof(test_modification_mathoptinterface_issue_2452))
    return v"1.28.0"
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type MultiSetMapBridge{T,S1,G} <: AbstractBridge end

Same as `SetMapBridge` but the output constraint type does not only depend on
the input constraint type.

When subtyping `MultiSetMapBridge`, `added_constraint_types` and `supports`
should additionally be implemented by the bridge.

For example, if a bridge `BridgeType` may create either a constraint of type
`F2`-in-`S2` or `F3`-in-`S3`, these methods should be implemented as follows:
```julia
function MOI.Bridges.added_constraint_types(
    ::Type{<:BridgeType{T,F2,F3}},
) where {T,F2,F3}
    return Tuple{Type,Type}[(F2, S2), (F3, S3)]
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{<:BridgeType{T,F2,F3}},
) where {T,F2,F3}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F2,S2}) ||
           MOI.supports(model, attr, MOI.ConstraintIndex{F3,S3})
end
```
"""
abstract type MultiSetMapBridge{T,S1,G} <: AbstractBridge end

function bridge_constraint(
    BT::Type{<:MultiSetMapBridge{T,S1,G}},
    model::MOI.ModelLike,
    func::G,
    set::S1,
) where {T,S1,G}
    mapped_func = MOI.Bridges.map_function(BT, func)
    mapped_set = MOI.Bridges.map_set(BT, set)
    constraint = MOI.add_constraint(model, mapped_func, mapped_set)
    return BT(constraint)
end

function MOI.supports_constraint(
    ::Type{<:MultiSetMapBridge{T,S1}},
    ::Type{F},
    ::Type{S1},
) where {T,S1<:MOI.AbstractScalarSet,F<:MOI.AbstractScalarFunction}
    return MOI.Utilities.is_coefficient_type(F, T)
end

function MOI.supports_constraint(
    ::Type{<:MultiSetMapBridge{T,S1}},
    ::Type{F},
    ::Type{S1},
) where {T,S1<:MOI.AbstractVectorSet,F<:MOI.AbstractVectorFunction}
    return MOI.Utilities.is_coefficient_type(F, T)
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:MultiSetMapBridge},
)
    return Tuple{Type}[]
end

# Attributes, Bridge acting as a model

function MOI.get(
    bridge::MultiSetMapBridge,
    ::MOI.NumberOfConstraints{F,S},
)::Int64 where {F,S}
    return bridge.constraint isa MOI.ConstraintIndex{F,S} ? 1 : 0
end

function MOI.get(
    bridge::MultiSetMapBridge,
    ::MOI.ListOfConstraintIndices{F,S},
) where {F,S}
    if bridge.constraint isa MOI.ConstraintIndex{F,S}
        return MOI.ConstraintIndex{F,S}[bridge.constraint]
    end
    return MOI.ConstraintIndex{F,S}[]
end

# References

function MOI.delete(model::MOI.ModelLike, bridge::MultiSetMapBridge)
    MOI.delete(model, bridge.constraint)
    return
end

# Attributes, Bridge acting as a constraint

# MapNotInvertible is thrown if the bridge does not support inverting the
# function. The user doesn't need to know this, only that they cannot get the
# attribute. Throwing `GetAttributeNotAllowed` allows `CachingOptimizer` to fall
# back to using the cache.
function _not_invertible_error_message(attr, message)
    return "Cannot get `$attr` as the constraint is reformulated through a linear transformation that is not invertible. $message"
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::MultiSetMapBridge{T,S1,G},
) where {T,S1,G}
    mapped_func = MOI.get(model, attr, bridge.constraint)
    func = try
        MOI.Bridges.inverse_map_function(bridge, mapped_func)
    catch err
        if err isa MOI.Bridges.MapNotInvertible
            msg = _not_invertible_error_message(attr, err.message)
            throw(MOI.GetAttributeNotAllowed(attr, msg))
        end
        rethrow(err)
    end
    return MOI.Utilities.convert_approx(G, func)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::MultiSetMapBridge{T,S1,G},
    func::G,
) where {T,S1,G}
    new_f = MOI.Bridges.map_function(typeof(bridge), func)
    MOI.set(model, attr, bridge.constraint, new_f)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::MultiSetMapBridge,
)
    set = MOI.get(model, attr, bridge.constraint)
    return MOI.Bridges.inverse_map_set(bridge, set)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::MultiSetMapBridge{T,S1},
    set::S1,
) where {T,S1}
    new_set = MOI.Bridges.map_set(bridge, set)
    MOI.set(model, attr, bridge.constraint, new_set)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::MultiSetMapBridge,
)
    value = MOI.get(model, attr, bridge.constraint)
    if value === nothing
        return nothing
    end
    try
        return MOI.Bridges.inverse_map_function(bridge, value)
    catch err
        # MapNotInvertible is thrown if the bridge does not support inverting
        # the function. The user doesn't need to know this, only that they
        # cannot get the attribute.
        if err isa MOI.Bridges.MapNotInvertible
            msg = _not_invertible_error_message(attr, err.message)
            throw(MOI.GetAttributeNotAllowed(attr, msg))
        end
        rethrow(err)
    end
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::MultiSetMapBridge,
    value,
)
    if value === nothing
        MOI.set(model, attr, bridge.constraint, nothing)
    else
        mapped_value = MOI.Bridges.map_function(bridge, value)
        MOI.set(model, attr, bridge.constraint, mapped_value)
    end
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::MultiSetMapBridge,
)
    value = MOI.get(model, attr, bridge.constraint)
    if value === nothing
        return nothing
    end
    return MOI.Bridges.adjoint_map_function(bridge, value)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::BT,
    value,
) where {BT<:MultiSetMapBridge}
    if value === nothing
        MOI.set(model, attr, bridge.constraint, nothing)
    else
        mapped_value = try
            MOI.Bridges.inverse_adjoint_map_function(bridge, value)
        catch err
            if err isa MOI.Bridges.MapNotInvertible
                msg = _not_invertible_error_message(attr, err.message)
                throw(MOI.SetAttributeNotAllowed(attr, msg))
            end
            rethrow(err)
        end
        MOI.set(model, attr, bridge.constraint, mapped_value)
    end
    return
end

# By linearity of the map, we can just change the constant/coefficient

function MOI.modify(
    model::MOI.ModelLike,
    bridge::BT,
    change::MOI.ScalarConstantChange,
) where {BT<:MultiSetMapBridge}
    new_constant = MOI.Bridges.map_function(BT, change.new_constant)
    MOI.modify(model, bridge.constraint, MOI.ScalarConstantChange(new_constant))
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::BT,
    change::MOI.VectorConstantChange,
) where {BT<:MultiSetMapBridge}
    new_constant = MOI.Bridges.map_function(BT, change.new_constant)
    MOI.modify(model, bridge.constraint, MOI.VectorConstantChange(new_constant))
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::BT,
    change::MOI.ScalarCoefficientChange,
) where {BT<:MultiSetMapBridge}
    new_coefficient = MOI.Bridges.map_function(BT, change.new_coefficient)
    new_change = MOI.ScalarCoefficientChange(change.variable, new_coefficient)
    MOI.modify(model, bridge.constraint, new_change)
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::BT,
    change::MOI.MultirowChange{T},
) where {T,BT<:MultiSetMapBridge{T}}
    # It is important here that `change.new_coefficients` contains the complete
    # new sparse column associated to the variable. Calling modify twice with
    # part of the column won't work since  the linear map might reset all the
    # column each time.
    n = MOI.dimension(MOI.get(model, MOI.ConstraintSet(), bridge.constraint))
    dense = zeros(T, n)
    for (row, value) in change.new_coefficients
        dense[row] += value
    end
    map_dense = MOI.Bridges.map_function(BT, dense)
    sparse = Tuple{Int64,T}[rv for rv in enumerate(map_dense) if !iszero(rv[2])]
    new_change = MOI.MultirowChange(change.variable, sparse)
    MOI.modify(model, bridge.constraint, new_change)
    return
end

"""
    abstract type SetMapBridge{T,S2,S1,F,G} <: MultiSetMapBridge{T,S1,G} end

Consider two type of sets, `S1` and `S2`, and a linear mapping `A` such that
the image of a set of type `S1` under `A` is a set of type `S2`.

A `SetMapBridge{T,S2,S1,F,G}` is a bridge that maps `G`-in-`S1` constraints
into `F`-in-`S2` by mapping the function through `A`.

The linear map `A` is described by;

 * [`MOI.Bridges.map_set`](@ref)
 * [`MOI.Bridges.map_function`](@ref).

Implementing a method for these two functions is sufficient to bridge
constraints. However, in order for the getters and setters of attributes such as
dual solutions and starting values to work as well, a method for the following
functions must be implemented:

 * [`MOI.Bridges.inverse_map_set`](@ref)
 * [`MOI.Bridges.inverse_map_function`](@ref)
 * [`MOI.Bridges.adjoint_map_function`](@ref)
 * [`MOI.Bridges.inverse_adjoint_map_function`](@ref)

See the docstrings of each function to see which feature would be missing if it
was not implemented for a given bridge.
"""
abstract type SetMapBridge{T,S2,S1,F,G} <: MultiSetMapBridge{T,S1,G} end

function MOI.Bridges.added_constraint_types(
    ::Type{<:SetMapBridge{T,S2,S1,F}},
) where {T,S2,S1,F}
    return Tuple{Type,Type}[(F, S2)]
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{<:SetMapBridge{T,S2,S1,F}},
) where {T,S2,S1,F}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F,S2})
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestTest

using Test
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    # Some tests are excluded because UniversalFallback accepts absolutely
    # everything.
    MOI.Test.runtests(
        MOI.Utilities.MockOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        ),
        MOI.Test.Config(),
        exclude = [
            r"^test_model_ScalarFunctionConstantNotZero$",
            "test_model_copy_to_UnsupportedAttribute",
            "test_model_copy_to_UnsupportedConstraint",
            "test_model_supports_constraint_ScalarAffineFunction_EqualTo",
            "test_model_supports_constraint_VariableIndex_EqualTo",
            "test_model_supports_constraint_VectorOfVariables_Nonnegatives",
        ],
        warn_unsupported = true,
        verbose = true,
    )
    # Run the previously excluded tests, this time without UniversalFallback.
    MOI.Test.runtests(
        MOI.Utilities.MockOptimizer(
            MOI.Utilities.Model{Float64}(),
            scalar_function_constant_non_zero = true,
        ),
        MOI.Test.Config();
        include = [
            r"^test_model_ScalarFunctionConstantNotZero$",
            "test_model_copy_to_UnsupportedAttribute",
            "test_model_copy_to_UnsupportedConstraint",
            "test_model_supports_constraint_ScalarAffineFunction_EqualTo",
            "test_model_supports_constraint_VariableIndex_EqualTo",
            "test_model_supports_constraint_VectorOfVariables_Nonnegatives",
        ],
        verbose = true,
    )
    return
end

function test_issue_1757()
    MOI.Test.test_model_ScalarFunctionConstantNotZero(
        MOI.Utilities.MockOptimizer(
            MOI.Utilities.Model{Float64}(),
            scalar_function_constant_non_zero = false,
        ),
        MOI.Test.Config(exclude = Any[MOI.ConstraintFunction]),
    )
    return
end

struct IncompleteOptimizer <: MOI.AbstractOptimizer end

# Test exclude_tests_after. This should work despite no methods being added for
# IncompleteOptimizer because every test should get skipped.
function test_exclude_tests_after()
    MOI.Test.runtests(
        IncompleteOptimizer(),
        MOI.Test.Config();
        exclude_tests_after = v"0.0.1",
        verbose = true,
    )
    return
end

# Non-Float64 tests

function test_bigfloat_tests()
    MOI.Test.runtests(
        MOI.Utilities.MockOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{BigFloat}()),
            BigFloat,
        ),
        MOI.Test.Config(BigFloat),
        exclude = [
            # ========================= Expected failures ======================
            # UniversalFallback supports these tests.
            "test_model_copy_to_UnsupportedAttribute",
            "test_model_copy_to_UnsupportedConstraint",
            "test_model_supports_constraint_ScalarAffineFunction_EqualTo",
            "test_model_supports_constraint_VariableIndex_EqualTo",
            "test_model_supports_constraint_VectorOfVariables_Nonnegatives",
        ],
    )
    return
end

# Special test for issue #2010

struct _UnsupportedModel <: MOI.ModelLike end

function MOI.supports_constraint(
    ::_UnsupportedModel,
    ::Type{MOI.VariableIndex},
    ::Type{MOI.ZeroOne},
)
    return true
end

function test_issue_2010()
    MOI.Test.test_attribute_unsupported_constraint(
        _UnsupportedModel(),
        MOI.Test.Config(),
    )
    return
end

function test_attribute_unsupported_constraint_fallback()
    model = _UnsupportedModel()
    F, S = MOI.VariableIndex, MOI.ZeroOne
    attr = MOI.ListOfConstraintIndices{F,S}()
    @test_throws MOI.GetAttributeNotAllowed(attr) MOI.get(model, attr)
    attr = MOI.NumberOfConstraints{F,S}()
    @test_throws MOI.GetAttributeNotAllowed(attr) MOI.get(model, attr)
    return
end

function test_warning_on_ambiguous()
    model = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    # `test_model_Name`` is our target of interest, `test_` is just to avoid
    # running any tests.
    exclude = ["test_model_Name", r"test_.+"]
    @test_logs (:warn,) MOI.Test.runtests(model, config; exclude = exclude)
    exclude = [r"^test_model_Name$", r"test_.+"]
    @test_logs MOI.Test.runtests(model, config; exclude = exclude)
    return
end

function test_FeasibilitySenseEvaluator()
    evaluator = MOI.Test.FeasibilitySenseEvaluator(true)
    @test MOI.features_available(evaluator) == [:Grad, :Jac, :Hess, :ExprGraph]
    @test MOI.hessian_lagrangian_structure(evaluator) == [(1, 1)]
    evaluator = MOI.Test.FeasibilitySenseEvaluator(false)
    @test MOI.features_available(evaluator) == [:Grad, :Jac, :ExprGraph]
    @test_throws AssertionError MOI.hessian_lagrangian_structure(evaluator)
    return
end

function test_HS071_evaluator()
    evaluator = MOI.Test.HS071(true, true)
    features = [:Grad, :Jac, :JacVec, :ExprGraph, :Hess, :HessVec]
    @test MOI.features_available(evaluator) == features
    @test_throws(
        ErrorException("Unsupported feature foo"),
        MOI.initialize(evaluator, [:foo]),
    )
    MOI.initialize(evaluator, features)
    x = [1.0, 2.0, 3.0, 4.0]
    @test MOI.eval_objective(evaluator, x) == 27.0
    g = fill(NaN, 2)
    MOI.eval_constraint(evaluator, g, x)
    @test g == [24.0, 30.0]
    grad = fill(NaN, 4)
    MOI.eval_objective_gradient(evaluator, grad, x)
    @test grad == [28.0, 4.0, 5.0, 6.0]
    @test MOI.jacobian_structure(evaluator) ==
          [(1, 1), (1, 2), (1, 3), (1, 4), (2, 1), (2, 2), (2, 3), (2, 4)]
    @test MOI.hessian_objective_structure(evaluator) ==
          [(1, 1), (2, 1), (3, 1), (4, 1), (4, 2), (4, 3)]
    @test MOI.hessian_constraint_structure(evaluator, 1) ==
          [(2, 1), (3, 1), (3, 2), (4, 1), (4, 2), (4, 3)]
    @test MOI.hessian_constraint_structure(evaluator, 2) ==
          [(1, 1), (2, 2), (3, 3), (4, 4)]
    @test MOI.hessian_lagrangian_structure(evaluator) == vcat(
        [(1, 1), (2, 1), (2, 2), (3, 1), (3, 2), (3, 3)],
        [(4, 1), (4, 2), (4, 3), (4, 4)],
    )
    @test MOI.constraint_gradient_structure(evaluator, 1) == [1, 2, 3, 4]
    @test MOI.constraint_gradient_structure(evaluator, 2) == [1, 2, 3, 4]
    ∇g = zeros(4)
    MOI.eval_constraint_gradient(evaluator, ∇g, x, 1)
    @test ∇g == [24.0, 12.0, 8.0, 6.0]
    MOI.eval_constraint_gradient(evaluator, ∇g, x, 2)
    @test ∇g == [2.0, 4.0, 6.0, 8.0]
    J = zeros(8)
    MOI.eval_constraint_jacobian(evaluator, J, x)
    @test J == [24.0, 12.0, 8.0, 6.0, 2.0, 4.0, 6.0, 8.0]
    y = zeros(2)
    w = [1.5, 2.5, 3.5, 4.5]
    MOI.eval_constraint_jacobian_product(evaluator, y, x, w)
    @test y == [121.0, 70.0]
    y = zeros(4)
    w2 = @view(w[1:2])
    MOI.eval_constraint_jacobian_transpose_product(evaluator, y, x, w2)
    @test y == [41.0, 28.0, 27.0, 29.0]
    σ = 1.0
    μ = [1.0, 1.0]
    H = zeros(4)
    MOI.eval_hessian_lagrangian_product(evaluator, H, x, w, σ, μ)
    @test H == [155.5, 61.0, 48.5, 49.0]
    H = zeros(6)
    MOI.eval_hessian_objective(evaluator, H, x)
    @test H == [8.0, 4.0, 4.0, 7.0, 1.0, 1.0]
    MOI.eval_hessian_constraint(evaluator, H, x, 1)
    @test H == [12.0, 8.0, 4.0, 6.0, 3.0, 2.0]
    H = zeros(4)
    MOI.eval_hessian_constraint(evaluator, H, x, 2)
    @test H == [2.0, 2.0, 2.0, 2.0]
    H = zeros(10)
    MOI.eval_hessian_lagrangian(evaluator, H, x, σ, μ)
    @test H == [10.0, 16.0, 2.0, 12.0, 4.0, 2.0, 13.0, 4.0, 3.0, 2.0]
    x = Expr.(:ref, :x, MOI.VariableIndex.(1:4))
    @test MOI.objective_expr(evaluator) ==
          :($(x[1]) * $(x[4]) * ($(x[1]) + $(x[2]) + $(x[3])) + $(x[3]))
    @test MOI.constraint_expr(evaluator, 1) ==
          :($(x[1]) * $(x[2]) * $(x[3]) * $(x[4]) >= 25.0)
    @test MOI.constraint_expr(evaluator, 2) ==
          :($(x[1])^2 + $(x[2])^2 + $(x[3])^2 + $(x[4])^2 == 40.0)
    return
end

function test_error_handler()
    err = ErrorException("error")
    @test_throws err try
        @assert false
    catch
        MOI.Test._error_handler(err, "test_foo", true)
    end
    err = MOI.AddVariableNotAllowed()
    @test_logs (:warn,) MOI.Test._error_handler(err, "test_foo", true)
    @test_nowarn MOI.Test._error_handler(err, "test_foo", false)
    return
end

"Test a model that errors getting time limit unless it was previously set"
mutable struct ModelTimeLimitSecErrorIfNotSet <: MOI.AbstractOptimizer
    time_limit::Union{Missing,Nothing,Float64}
end

MOI.supports(::ModelTimeLimitSecErrorIfNotSet, ::MOI.TimeLimitSec) = true

function MOI.get(model::ModelTimeLimitSecErrorIfNotSet, attr::MOI.TimeLimitSec)
    if model.time_limit === missing
        throw(MOI.GetAttributeNotAllowed(attr))
    end
    return model.time_limit::Union{Nothing,Float64}
end

function MOI.set(model::ModelTimeLimitSecErrorIfNotSet, ::MOI.TimeLimitSec, v)
    model.time_limit = v
    return
end

function test_attribute_TimeLimitSec()
    model = ModelTimeLimitSecErrorIfNotSet(missing)
    MOI.Test.test_attribute_TimeLimitSec(model, MOI.Test.Config())
    return
end

end  # module

TestTest.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintComplexNormInfinityToSecondOrderCone

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ComplexNormInfinityToSecondOrderConeBridge,
        """
        variables: t, x
        ::Complex{Float64}: [t, (1 + 2im) * x + (3 + 4im)] in NormInfinityCone(2)
        """,
        """
        variables: t, x
        ::Float64: [t, 1 * x + 3, 2 * x + 4] in SecondOrderCone(3)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ComplexNormInfinityToSecondOrderConeBridge,
        """
        variables: t, x, y
        ::Complex{Float64}: [2.0 * t + 3.0, x + im * y] in NormInfinityCone(2)
        """,
        """
        variables: t, x, y
        ::Float64: [2.0 * t + 3.0, 1.0 * x, 1.0 * y] in SecondOrderCone(3)
        """,
    )
    return
end

function test_imag_t()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model =
        MOI.Bridges.Constraint.ComplexNormInfinityToSecondOrderCone{Float64}(
            inner,
        )
    x = MOI.add_variables(model, 2)
    f_t = (1.0 + 2.0im) * x[1]
    f_x = (1.0 + 2.0im) * x[2] + (3.0 + 4.0im)
    f = MOI.Utilities.operate(vcat, Complex{Float64}, f_t, f_x)
    @test_throws(
        MOI.AddConstraintNotAllowed{typeof(f),MOI.NormInfinityCone}(
            "The epigraph variable `t` in `[t; x] in NormInfinityCone()` " *
            "must be real. It is: $f_t",
        ),
        MOI.add_constraint(model, f, MOI.NormInfinityCone(2))
    )
    return
end

end  # module

TestConstraintComplexNormInfinityToSecondOrderCone.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

function Base.copy(::Evaluator)
    return error("Copying nonlinear problems not yet implemented")
end

"""
    ordinal_index(evaluator::Evaluator, c::ConstraintIndex)::Int

Return the 1-indexed value of the constraint index `c` in `evaluator`.

## Example

```jldoctest
julia> model = MOI.Nonlinear.Model()
A Nonlinear.Model with:
 0 objectives
 0 parameters
 0 expressions
 0 constraints

julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> c1 = MOI.Nonlinear.add_constraint(model, :(\$x^2), MOI.LessThan(1.0))
MathOptInterface.Nonlinear.ConstraintIndex(1)

julia> c2 = MOI.Nonlinear.add_constraint(model, :(\$x^2), MOI.LessThan(1.0))
MathOptInterface.Nonlinear.ConstraintIndex(2)

julia> evaluator = MOI.Nonlinear.Evaluator(model)
Nonlinear.Evaluator with available features:
  * :ExprGraph

julia> MOI.initialize(evaluator, Symbol[])

julia> MOI.Nonlinear.ordinal_index(evaluator, c2)  # Returns 2
2

julia> MOI.Nonlinear.delete(model, c1)

julia> evaluator = MOI.Nonlinear.Evaluator(model)
Nonlinear.Evaluator with available features:
  * :ExprGraph

julia> MOI.initialize(evaluator, Symbol[])

julia> MOI.Nonlinear.ordinal_index(evaluator, c2)  # Returns 1
1
```
"""
function ordinal_index(evaluator::Evaluator, c::ConstraintIndex)
    # TODO(odow): replace with a cache that maps indices to their 1-indexed
    # row in the constraint matrix. But failing that, since we know that
    # constraints are added in increasing order and that they can be deleted, we
    # know that index `i` must appear as constraint `1` to `i`. So we start at
    # `i` and backtrack (to account for deleted constraints) until we find it.
    # In the typical case with no deletion, there should be no overhead.
    for i in min(c.value, length(evaluator.ordered_constraints)):-1:1
        if evaluator.ordered_constraints[i] == c
            return i
        end
    end
    return error("Invalid constraint index $(c)")
end

function MOI.features_available(evaluator::Evaluator)
    features = Symbol[]
    if evaluator.backend !== nothing
        append!(features, MOI.features_available(evaluator.backend))
    end
    if !(:ExprGraph in features)
        push!(features, :ExprGraph)
    end
    return features
end

function Base.show(io::IO, evaluator::Evaluator)
    Base.print(io, "Nonlinear.Evaluator with available features:")
    for feature in MOI.features_available(evaluator)
        print(io, "\n  * :", feature)
    end
    return
end

function MOI.initialize(evaluator::Evaluator, features::Vector{Symbol})
    start_time = time()
    empty!(evaluator.ordered_constraints)
    evaluator.eval_objective_timer = 0.0
    evaluator.eval_objective_gradient_timer = 0.0
    evaluator.eval_constraint_timer = 0.0
    evaluator.eval_constraint_gradient_timer = 0.0
    evaluator.eval_constraint_jacobian_timer = 0.0
    evaluator.eval_hessian_objective_timer = 0.0
    evaluator.eval_hessian_constraint_timer = 0.0
    evaluator.eval_hessian_lagrangian_timer = 0.0
    append!(evaluator.ordered_constraints, keys(evaluator.model.constraints))
    # Every backend supports :ExprGraph, so don't forward it.
    filter!(f -> f != :ExprGraph, features)
    if evaluator.backend !== nothing
        MOI.initialize(evaluator.backend, features)
    elseif !isempty(features)
        @assert evaluator.backend === nothing  # ==> ExprGraphOnly used
        error(
            "Unable to initialize `Nonlinear.Evaluator` because the " *
            "following features are not supported: $features",
        )
    end
    evaluator.initialize_timer = time() - start_time
    return
end

function MOI.objective_expr(evaluator::Evaluator)
    if evaluator.model.objective === nothing
        error(
            "Unable to query objective_expr because no nonlinear objective " *
            "was set",
        )
    end
    return convert_to_expr(
        evaluator,
        something(evaluator.model.objective);
        moi_output_format = true,
    )
end

function MOI.constraint_expr(evaluator::Evaluator, i::Int)
    constraint = evaluator.model[evaluator.ordered_constraints[i]]
    f = convert_to_expr(
        evaluator,
        constraint.expression;
        moi_output_format = true,
    )
    set = constraint.set
    if set isa MOI.LessThan
        return :($f <= $(set.upper))
    elseif set isa MOI.GreaterThan
        return :($f >= $(set.lower))
    elseif set isa MOI.EqualTo
        return :($f == $(set.value))
    else
        @assert set isa MOI.Interval
        return :($(set.lower) <= $f <= $(set.upper))
    end
end

function MOI.eval_objective(evaluator::Evaluator, x)
    start = time()
    obj = MOI.eval_objective(evaluator.backend, x)
    evaluator.eval_objective_timer += time() - start
    return obj
end

function MOI.eval_objective_gradient(evaluator::Evaluator, g, x)
    start = time()
    MOI.eval_objective_gradient(evaluator.backend, g, x)
    evaluator.eval_objective_gradient_timer += time() - start
    return
end

function MOI.eval_constraint(evaluator::Evaluator, g, x)
    start = time()
    MOI.eval_constraint(evaluator.backend, g, x)
    evaluator.eval_constraint_timer += time() - start
    return
end

function MOI.eval_constraint_gradient(evaluator::Evaluator, ∇g, x, i)
    start = time()
    MOI.eval_constraint_gradient(evaluator.backend, ∇g, x, i)
    evaluator.eval_constraint_gradient_timer += time() - start
    return
end

function MOI.constraint_gradient_structure(evaluator::Evaluator, i)
    return MOI.constraint_gradient_structure(evaluator.backend, i)
end

function MOI.jacobian_structure(evaluator::Evaluator)
    return MOI.jacobian_structure(evaluator.backend)
end

function MOI.eval_constraint_jacobian(evaluator::Evaluator, J, x)
    start = time()
    MOI.eval_constraint_jacobian(evaluator.backend, J, x)
    evaluator.eval_constraint_jacobian_timer += time() - start
    return
end

function MOI.hessian_objective_structure(evaluator::Evaluator)
    return MOI.hessian_objective_structure(evaluator.backend)
end

function MOI.hessian_constraint_structure(evaluator::Evaluator, i)
    return MOI.hessian_constraint_structure(evaluator.backend, i)
end

function MOI.hessian_lagrangian_structure(evaluator::Evaluator)
    return MOI.hessian_lagrangian_structure(evaluator.backend)
end

function MOI.eval_hessian_objective(evaluator::Evaluator, H, x)
    start = time()
    MOI.eval_hessian_objective(evaluator.backend, H, x)
    evaluator.eval_hessian_objective_timer += time() - start
    return
end

function MOI.eval_hessian_constraint(evaluator::Evaluator, H, x, i)
    start = time()
    MOI.eval_hessian_constraint(evaluator.backend, H, x, i)
    evaluator.eval_hessian_constraint_timer += time() - start
    return
end

function MOI.eval_hessian_lagrangian(evaluator::Evaluator, H, x, σ, μ)
    start = time()
    MOI.eval_hessian_lagrangian(evaluator.backend, H, x, σ, μ)
    evaluator.eval_hessian_lagrangian_timer += time() - start
    return
end

function MOI.eval_constraint_jacobian_product(evaluator::Evaluator, y, x, w)
    start = time()
    MOI.eval_constraint_jacobian_product(evaluator.backend, y, x, w)
    evaluator.eval_constraint_jacobian_timer += time() - start
    return
end

function MOI.eval_constraint_jacobian_transpose_product(
    evaluator::Evaluator,
    y,
    x,
    w,
)
    start = time()
    MOI.eval_constraint_jacobian_transpose_product(evaluator.backend, y, x, w)
    evaluator.eval_constraint_jacobian_timer += time() - start
    return
end

function MOI.eval_hessian_lagrangian_product(
    evaluator::Evaluator,
    H,
    x,
    v,
    σ,
    μ,
)
    start = time()
    MOI.eval_hessian_lagrangian_product(evaluator.backend, H, x, v, σ, μ)
    evaluator.eval_hessian_lagrangian_timer += time() - start
    return
end

"""
    adjacency_matrix(nodes::Vector{Node})

Compute the sparse adjacency matrix describing the parent-child relationships in
`nodes`.

The element `(i, j)` is `true` if there is an edge *from* `node[j]` to
`node[i]`. Since we get a column-oriented matrix, this gives us a fast way to
look up the edges leaving any node (that is, the children).
"""
function adjacency_matrix(nodes::Vector{Node})
    N = length(nodes)
    I, J = Vector{Int}(undef, N), Vector{Int}(undef, N)
    numnz = 0
    for (i, node) in enumerate(nodes)
        if node.parent < 0
            continue
        end
        numnz += 1
        I[numnz] = i
        J[numnz] = node.parent
    end
    resize!(I, numnz)
    resize!(J, numnz)
    return SparseArrays.sparse(I, J, ones(Bool, numnz), N, N)
end

"""
    convert_to_expr(
        evaluator::Evaluator,
        expr::Expression;
        moi_output_format::Bool,
    )

Convert the [`Expression`](@ref) `expr` into a Julia `Expr`.

If `moi_output_format = true`:
 * subexpressions will be converted to Julia `Expr` and substituted into the
   output expression.
 * the current value of each parameter will be interpolated into the expression
 * variables will be represented in the form `x[MOI.VariableIndex(i)]`

If `moi_output_format = false`:
 * subexpressions will be represented by a [`ExpressionIndex`](@ref) object.
 * parameters will be represented by a [`ParameterIndex`](@ref) object.
 * variables will be represented by an [`MOI.VariableIndex`](@ref) object.

!!! warning
    To use `moi_output_format = true`, you must have first called
    [`MOI.initialize`](@ref) with `:ExprGraph` as a requested feature.
"""
function convert_to_expr(
    evaluator::Evaluator,
    expression::Expression;
    moi_output_format::Bool,
)
    expr = convert_to_expr(evaluator.model, expression)
    if moi_output_format
        return _convert_to_moi_format(evaluator, expr)
    end
    return expr
end

_convert_to_moi_format(::Evaluator, x::MOI.VariableIndex) = :(x[$x])

function _convert_to_moi_format(evaluator::Evaluator, p::ParameterIndex)
    return evaluator.model[p]
end

function _convert_to_moi_format(evaluator::Evaluator, x::ExpressionIndex)
    return convert_to_expr(
        evaluator,
        evaluator.model.expressions[x.value];
        moi_output_format = true,
    )
end

_convert_to_moi_format(::Evaluator, x) = x

function _convert_to_moi_format(evaluator::Evaluator, x::Expr)
    for i in 1:length(x.args)
        x.args[i] = _convert_to_moi_format(evaluator, x.args[i])
    end
    return x
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    DualGeoMeanBridge{T,G,H} <: Bridges.Constraint.AbstractBridge

`DualGeoMeanBridge` implements the following reformulation:

  * ``(u, v) \\in DualGeometricMeanCone`` into
    ``(-u/length(v), v) \\in GeometricMeanCone`` and ``u \\le 0``

## Source node

`DualGeoMeanBridge` supports:

  * `H` in [`MOI.DualGeometricMeanCone`](@ref)

## Target nodes

`DualGeoMeanBridge` creates:

  * `G` in [`MOI.GeometricMeanCone`](@ref)
  * `G` in [`MOI.Nonnegatives`](@ref)
"""
struct DualGeoMeanBridge{T,G,H} <: AbstractBridge
    nn_index::MOI.ConstraintIndex{G,MOI.Nonnegatives}
    geomean_index::MOI.ConstraintIndex{G,MOI.GeometricMeanCone}
end

const DualGeoMean{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{DualGeoMeanBridge{T},OT}

function bridge_constraint(
    ::Type{DualGeoMeanBridge{T,G,H}},
    model::MOI.ModelLike,
    f::H,
    s::MOI.DualGeometricMeanCone,
) where {T,G,H}
    f_scalars = MOI.Utilities.eachscalar(f)
    u_neg = MOI.Utilities.vectorize([MOI.Utilities.operate(-, T, f_scalars[1])])
    nn_index = MOI.add_constraint(model, u_neg, MOI.Nonnegatives(1))
    u_n = MOI.Utilities.operate(/, T, f_scalars[1], -T(MOI.dimension(s) - 1))
    ci = MOI.add_constraint(
        model,
        MOI.Utilities.operate(vcat, T, u_n, f_scalars[2:end]),
        MOI.GeometricMeanCone(MOI.dimension(s)),
    )
    return DualGeoMeanBridge{T,G,H}(nn_index, ci)
end

function MOI.supports_constraint(
    ::Type{<:DualGeoMeanBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.DualGeometricMeanCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:DualGeoMeanBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:DualGeoMeanBridge{T,G}},
) where {T,G}
    return Tuple{Type,Type}[(G, MOI.Nonnegatives), (G, MOI.GeometricMeanCone)]
end

function concrete_bridge_type(
    ::Type{<:DualGeoMeanBridge{T}},
    ::Type{H},
    ::Type{MOI.DualGeometricMeanCone},
) where {T,H<:MOI.AbstractVectorFunction}
    S = MOI.Utilities.scalar_type(H)
    TS = MOI.Utilities.promote_operation(+, T, S, MOI.VariableIndex)
    G = MOI.Utilities.promote_operation(vcat, T, T, S, TS)
    return DualGeoMeanBridge{T,G,H}
end

function MOI.get(
    ::DualGeoMeanBridge{T,G},
    ::MOI.NumberOfConstraints{G,MOI.Nonnegatives},
)::Int64 where {T,G}
    return 1
end

function MOI.get(
    bridge::DualGeoMeanBridge{T,G},
    ::MOI.ListOfConstraintIndices{G,MOI.Nonnegatives},
) where {T,G}
    return [bridge.nn_index]
end

function MOI.get(
    ::DualGeoMeanBridge{T,G},
    ::MOI.NumberOfConstraints{G,MOI.GeometricMeanCone},
)::Int64 where {T,G}
    return 1
end

function MOI.get(
    bridge::DualGeoMeanBridge{T,G},
    ::MOI.ListOfConstraintIndices{G,MOI.GeometricMeanCone},
) where {T,G}
    return [bridge.geomean_index]
end

function MOI.delete(model::MOI.ModelLike, bridge::DualGeoMeanBridge)
    MOI.delete(model, bridge.geomean_index)
    MOI.delete(model, bridge.nn_index)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::DualGeoMeanBridge{T,G,H},
) where {T,G,H}
    g = MOI.get(model, MOI.ConstraintFunction(), bridge.geomean_index)
    scalars = MOI.Utilities.eachscalar(g)
    n = -T(length(scalars) - 1)
    u = MOI.Utilities.operate(*, T, scalars[1], n)
    f = MOI.Utilities.operate(vcat, T, u, scalars[2:end])
    return MOI.Utilities.convert_approx(H, f)
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::DualGeoMeanBridge,
)
    set = MOI.get(model, MOI.ConstraintSet(), bridge.geomean_index)
    return MOI.DualGeometricMeanCone(MOI.dimension(set))
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::DualGeoMeanBridge,
)
    primal = MOI.get(model, attr, bridge.geomean_index)
    primal[1] *= -(length(primal) - 1)
    return primal
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    bridge::DualGeoMeanBridge,
)
    dual = MOI.get(model, attr, bridge.geomean_index)
    dual[1] /= -(length(dual) - 1)
    return dual
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

abstract type AbstractModelLike{T} <: MOI.ModelLike end

"""
    mutable struct GenericModel{T,O,V,C} <: AbstractModelLike{T}

Implements a model supporting coefficients of type `T` and:

 * An objective function stored in `.objective::O`
 * Variables and `VariableIndex` constraints stored in `.variable_bounds::V`
 * `F`-in-`S` constraints (excluding `VariableIndex` constraints) stored in
   `.constraints::C`

All interactions take place via the MOI interface, so the types `O`, `V`, and
`C` must implement the API as needed for their functionality.
"""
mutable struct GenericModel{T,O,V,C} <: AbstractModelLike{T}
    name::String
    objective::O
    variables::V
    constraints::C
    var_to_name::Dict{MOI.VariableIndex,String}
    # If `nothing`, the dictionary hasn't been constructed yet.
    name_to_var::Union{Dict{String,MOI.VariableIndex},Nothing}
    con_to_name::Dict{MOI.ConstraintIndex,String}
    name_to_con::Union{Dict{String,MOI.ConstraintIndex},Nothing}
    # A useful dictionary for extensions to store things. These are
    # _not_ copied between models.
    ext::Dict{Symbol,Any}
    function GenericModel{T,O,V,C}() where {T,O,V,C}
        return new{T,O,V,C}(
            "",
            O(),
            V(),
            C(),
            Dict{MOI.VariableIndex,String}(),
            nothing,
            Dict{MOI.ConstraintIndex,String}(),
            nothing,
            Dict{Symbol,Any}(),
        )
    end
end

abstract type AbstractOptimizer{T} <: MOI.AbstractOptimizer end

"""
    mutable struct GenericOptimizer{T,O,V,C} <: AbstractOptimizer{T}

Implements a model supporting coefficients of type `T` and:

 * An objective function stored in `.objective::O`
 * Variables and `VariableIndex` constraints stored in `.variable_bounds::V`
 * `F`-in-`S` constraints (excluding `VariableIndex` constraints) stored in
   `.constraints::C`

All interactions take place via the MOI interface, so the types `O`, `V`, and
`C` must implement the API as needed for their functionality.
"""
mutable struct GenericOptimizer{T,O,V,C} <: AbstractOptimizer{T}
    name::String
    objective::O
    variables::V
    constraints::C
    var_to_name::Dict{MOI.VariableIndex,String}
    # If `nothing`, the dictionary hasn't been constructed yet.
    name_to_var::Union{Dict{String,MOI.VariableIndex},Nothing}
    con_to_name::Dict{MOI.ConstraintIndex,String}
    name_to_con::Union{Dict{String,MOI.ConstraintIndex},Nothing}
    # A useful dictionary for extensions to store things. These are
    # _not_ copied between models.
    ext::Dict{Symbol,Any}
    function GenericOptimizer{T,O,V,C}() where {T,O,V,C}
        return new{T,O,V,C}(
            "",
            O(),
            V(),
            C(),
            Dict{MOI.VariableIndex,String}(),
            nothing,
            Dict{MOI.ConstraintIndex,String}(),
            nothing,
            Dict{Symbol,Any}(),
        )
    end
end

const AbstractModel{T} = Union{AbstractModelLike{T},AbstractOptimizer{T}}

# `AbstractModel` fields `.variables` and `.constraints` act like a
# `StructOfConstraints` where `.variables` contains the `VariableIndex`-in-`S`
# constraints and `.constraints` contains the other constraints.
function constraints(
    model::AbstractModel,
    ::MOI.ConstraintIndex{MOI.VariableIndex},
)
    return model.variables
end

constraints(model::AbstractModel, ::MOI.ConstraintIndex) = model.constraints

function MOI.is_empty(model::AbstractModel)
    return isempty(model.name) &&
           MOI.is_empty(model.objective) &&
           MOI.is_empty(model.constraints) &&
           MOI.is_empty(model.variables)
end

function MOI.empty!(model::AbstractModel{T}) where {T}
    model.name = ""
    MOI.empty!(model.objective)
    MOI.empty!(model.variables)
    MOI.empty!(model.constraints)
    empty!(model.var_to_name)
    model.name_to_var = nothing
    empty!(model.con_to_name)
    model.name_to_con = nothing
    return
end

function MOI.copy_to(dest::AbstractModel, src::MOI.ModelLike)
    return default_copy_to(dest, src)
end

MOI.supports_incremental_interface(::AbstractModel) = true

function final_touch(model::AbstractModel, index_map)
    return final_touch(model.constraints, index_map)
end

# MOI.ListOfXXXAttributesSet

function MOI.get(::AbstractModel, ::MOI.ListOfOptimizerAttributesSet)
    return MOI.AbstractOptimizerAttribute[]
end

function MOI.get(
    model::AbstractModel,
    attr::MOI.ListOfModelAttributesSet,
)::Vector{MOI.AbstractModelAttribute}
    ret = MOI.AbstractModelAttribute[]
    append!(ret, MOI.get(model.objective, attr))
    if !isempty(model.name)
        push!(ret, MOI.Name())
    end
    return ret
end

function MOI.get(model::AbstractModel, ::MOI.ListOfVariableAttributesSet)
    ret = MOI.AbstractVariableAttribute[]
    if !isempty(model.var_to_name)
        push!(ret, MOI.VariableName())
    end
    return ret
end

function MOI.get(
    model::AbstractModel,
    ::MOI.ListOfConstraintAttributesSet{F,S},
) where {F,S}
    ret = MOI.AbstractConstraintAttribute[]
    if any(Base.Fix2(isa, MOI.ConstraintIndex{F,S}), keys(model.con_to_name))
        push!(ret, MOI.ConstraintName())
    end
    return ret
end

# MOI.Name

MOI.supports(::AbstractModel, ::MOI.Name) = true

function MOI.set(model::AbstractModel, ::MOI.Name, name::String)
    model.name = name
    return
end

MOI.get(model::AbstractModel, ::MOI.Name) = model.name

# MOI.add_variable

"""
    function _add_variable end

This is called by `AbstractModel` to inform the `constraints` field that a
variable has been added. This is similar to
[`MOI.add_variable`](@ref) except that it should return `nothing`.
"""
function _add_variable end

_add_variable(::Nothing) = nothing

_add_variables(::Nothing, ::Int64) = nothing

function MOI.add_variable(model::AbstractModel)
    x = MOI.add_variable(model.variables)
    _add_variable(model.constraints)
    return x
end

function MOI.is_valid(model::AbstractModel, x::MOI.VariableIndex)
    return MOI.is_valid(model.variables, x)
end

# MOI.NumberOfVariables

function MOI.get(model::AbstractModel, attr::MOI.NumberOfVariables)::Int64
    return MOI.get(model.variables, attr)
end

# MOI.ListOfVariableIndices

function MOI.get(model::AbstractModel, attr::MOI.ListOfVariableIndices)
    return MOI.get(model.variables, attr)
end

# MOI.VariableName

function MOI.supports(
    ::AbstractModel,
    ::MOI.VariableName,
    ::Type{MOI.VariableIndex},
)
    return true
end

function MOI.set(
    model::AbstractModel,
    ::MOI.VariableName,
    vi::MOI.VariableIndex,
    name::String,
)
    model.var_to_name[vi] = name
    model.name_to_var = nothing # Invalidate the name map.
    return
end

function MOI.get(
    model::AbstractModel,
    ::MOI.VariableName,
    vi::MOI.VariableIndex,
)
    return get(model.var_to_name, vi, "")
end

# MOI.get(::AbstractModel, ::Type{MOI.VariableIndex}, ::String)

"""
    build_name_to_var_map(con_to_name::Dict{MOI.VariableIndex, String})

Create and return a reverse map from name to variable index, given a map from
variable index to name. The special value `MOI.VariableIndex(0)` is used to
indicate that multiple variables have the same name.
"""
function build_name_to_var_map(var_to_name::Dict{MOI.VariableIndex,String})
    name_to_var = Dict{String,MOI.VariableIndex}()
    for (var, var_name) in var_to_name
        if haskey(name_to_var, var_name)
            # 0 is a special value that means this string does not map to
            # a unique variable name.
            name_to_var[var_name] = MOI.VariableIndex(0)
        else
            name_to_var[var_name] = var
        end
    end
    return name_to_var
end

function throw_multiple_name_error(::Type{MOI.VariableIndex}, name::String)
    return error("Multiple variables have the name $name.")
end

function throw_multiple_name_error(::Type{<:MOI.ConstraintIndex}, name::String)
    return error("Multiple constraints have the name $name.")
end

function throw_if_multiple_with_name(::Nothing, ::String) end

function throw_if_multiple_with_name(index::MOI.Index, name::String)
    if iszero(index.value)
        throw_multiple_name_error(typeof(index), name)
    end
    return
end

function MOI.get(model::AbstractModel, ::Type{MOI.VariableIndex}, name::String)
    if model.name_to_var === nothing
        model.name_to_var = build_name_to_var_map(model.var_to_name)
    end
    result = get(model.name_to_var, name, nothing)
    throw_if_multiple_with_name(result, name)
    return result
end

# Constraints

function MOI.is_valid(model::AbstractModel, ci::MOI.ConstraintIndex)
    return MOI.is_valid(constraints(model, ci), ci)
end

function MOI.supports_constraint(
    model::AbstractModel,
    ::Type{F},
    ::Type{S},
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    return MOI.supports_constraint(model.constraints, F, S)
end

function MOI.add_constraint(
    model::AbstractModel,
    func::F,
    set::S,
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    # We check supports_constraint here because it is a common practice for
    # AbstractModels to declare that they do not support particular constraints,
    # even though the underlying `.constraints` object does. See, for example,
    # the various models in MOI.FileFormats.
    if !MOI.supports_constraint(model, F, S)
        throw(MOI.UnsupportedConstraint{F,S}())
    end
    return MOI.add_constraint(model.constraints, func, set)
end

function MOI.supports_constraint(
    model::AbstractModel,
    ::Type{MOI.VariableIndex},
    ::Type{S},
) where {S<:MOI.AbstractScalarSet}
    return MOI.supports_constraint(model.variables, MOI.VariableIndex, S)
end

function MOI.add_constraint(
    model::AbstractModel,
    func::MOI.VariableIndex,
    set::S,
) where {S<:MOI.AbstractScalarSet}
    # We check supports_constraint here because it is a common practice for
    # AbstractModels to declare that they do not support particular constraints,
    # even though the underlying `.constraints` object does. See, for example,
    # the various models in MOI.FileFormats.
    if !MOI.supports_constraint(model, MOI.VariableIndex, S)
        throw(MOI.UnsupportedConstraint{MOI.VariableIndex,S}())
    end
    return MOI.add_constraint(model.variables, func, set)
end

# MOI.NumberOfConstraints

function MOI.get(
    model::AbstractModel,
    attr::MOI.NumberOfConstraints{MOI.VariableIndex,S},
)::Int64 where {S<:MOI.AbstractScalarSet}
    if !MOI.supports_constraint(model, MOI.VariableIndex, S)
        return 0
    end
    return MOI.get(model.variables, attr)
end

function MOI.get(model::AbstractModel, attr::MOI.NumberOfConstraints)::Int64
    return MOI.get(model.constraints, attr)
end

# MOI.ListOfConstraintTypesPresent

function MOI.get(
    model::AbstractModel{T},
    attr::MOI.ListOfConstraintTypesPresent,
)::Vector{Tuple{Type,Type}} where {T}
    return vcat(
        MOI.get(model.constraints, attr),
        MOI.get(model.variables, attr),
    )
end

# MOI.ListOfConstraintIndices

function MOI.get(
    model::AbstractModel,
    attr::MOI.ListOfConstraintIndices{MOI.VariableIndex,S},
) where {S<:MOI.AbstractScalarSet}
    if !MOI.supports_constraint(model, MOI.VariableIndex, S)
        return MOI.ConstraintIndex{MOI.VariableIndex,S}[]
    end
    return MOI.get(model.variables, attr)
end

function MOI.get(model::AbstractModel, attr::MOI.ListOfConstraintIndices)
    return MOI.get(model.constraints, attr)
end

# MOI.ConstraintFunction/MOI.ConstraintSet

function MOI.get(
    model::AbstractModel,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    ci::MOI.ConstraintIndex,
)
    return MOI.get(constraints(model, ci), attr, ci)
end

function MOI.set(
    model::AbstractModel,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    ci::MOI.ConstraintIndex,
    value,
)
    MOI.set(constraints(model, ci), attr, ci, value)
    return
end

# MOI.ConstraintName

function MOI.supports(
    ::AbstractModel,
    ::MOI.ConstraintName,
    ::Type{<:MOI.ConstraintIndex},
)
    return true
end

function MOI.set(
    model::AbstractModel,
    ::MOI.ConstraintName,
    ci::MOI.ConstraintIndex,
    name::String,
)
    model.con_to_name[ci] = name
    model.name_to_con = nothing # Invalidate the name map.
    return
end

function MOI.get(
    model::AbstractModel,
    ::MOI.ConstraintName,
    ci::MOI.ConstraintIndex,
)
    return get(model.con_to_name, ci, "")
end

function MOI.supports(
    ::AbstractModel,
    ::MOI.ConstraintName,
    ::Type{<:MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet}},
)
    return throw(MOI.VariableIndexConstraintNameError())
end

function MOI.set(
    ::AbstractModel,
    ::MOI.ConstraintName,
    ::MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet},
    ::String,
)
    return throw(MOI.VariableIndexConstraintNameError())
end

# MOI.get(::AbstractModel, ::Type{MOI.ConstraintIndex}, ::String)

"""
    build_name_to_con_map(con_to_name::Dict{MOI.ConstraintIndex, String})

Create and return a reverse map from name to constraint index, given a map from
constraint index to name. The special value
`MOI.ConstraintIndex{Nothing, Nothing}(0)` is used to indicate that multiple
constraints have the same name.
"""
function build_name_to_con_map(con_to_name::Dict{<:MOI.ConstraintIndex,String})
    name_to_con = Dict{String,MOI.ConstraintIndex}()
    for (con, con_name) in con_to_name
        if haskey(name_to_con, con_name)
            name_to_con[con_name] = MOI.ConstraintIndex{Nothing,Nothing}(0)
        else
            name_to_con[con_name] = con
        end
    end
    return name_to_con
end

function MOI.get(
    model::AbstractModel,
    ::Type{ConType},
    name::String,
) where {ConType<:MOI.ConstraintIndex}
    if model.name_to_con === nothing
        model.name_to_con = build_name_to_con_map(model.con_to_name)
    end
    ci = get(model.name_to_con, name, nothing)
    throw_if_multiple_with_name(ci, name)
    return ci isa ConType ? ci : nothing
end

# MOI.ObjectiveFunctionType

function MOI.get(model::AbstractModel, attr::MOI.ObjectiveFunctionType)
    return MOI.get(model.objective, attr)
end

# MOI.ObjectiveSense

function MOI.supports(model::AbstractModel, attr::MOI.ObjectiveSense)
    return MOI.supports(model.objective, attr)
end

function MOI.get(model::AbstractModel, attr::MOI.ObjectiveSense)
    return MOI.get(model.objective, attr)
end

function MOI.set(
    model::AbstractModel,
    attr::MOI.ObjectiveSense,
    sense::MOI.OptimizationSense,
)
    MOI.set(model.objective, attr, sense)
    return
end

# MOI.ObjectiveFunction

function MOI.supports(model::AbstractModel, attr::MOI.ObjectiveFunction)
    return MOI.supports(model.objective, attr)
end

function MOI.get(model::AbstractModel, attr::MOI.ObjectiveFunction)
    return MOI.get(model.objective, attr)
end

function MOI.set(
    model::AbstractModel,
    attr::MOI.ObjectiveFunction{F},
    f::F,
) where {F<:MOI.AbstractFunction}
    if !MOI.supports(model, attr)
        throw(MOI.UnsupportedAttribute(attr))
    end
    MOI.set(model.objective, attr, f)
    return
end

# MOI.modify

function MOI.modify(
    model::AbstractModel,
    attr::MOI.ObjectiveFunction,
    change::MOI.AbstractFunctionModification,
)
    MOI.modify(model.objective, attr, change)
    return
end

function MOI.modify(
    model::AbstractModel,
    ci::MOI.ConstraintIndex,
    change::MOI.AbstractFunctionModification,
)
    MOI.modify(model.constraints, ci, change)
    return
end

# MOI.delete

function MOI.delete(model::AbstractModel, ci::MOI.ConstraintIndex)
    MOI.delete(constraints(model, ci), ci)
    model.name_to_con = nothing
    delete!(model.con_to_name, ci)
    return
end

function MOI.delete(model::AbstractModel, vi::MOI.VariableIndex)
    _throw_if_cannot_delete(model.constraints, [vi], vi)
    MOI.delete(model.variables, vi)
    delete!(model.var_to_name, vi)
    _deleted_constraints(model.constraints, vi) do ci
        return delete!(model.con_to_name, ci)
    end
    MOI.delete(model.objective, vi)
    model.name_to_var = nothing
    model.name_to_con = nothing
    return
end

function MOI.delete(model::AbstractModel, vis::Vector{MOI.VariableIndex})
    if isempty(vis)
        return
    end
    _throw_if_cannot_delete(model.constraints, vis, Set(vis))
    _deleted_constraints(model.constraints, vis) do ci
        return delete!(model.con_to_name, ci)
    end
    for vi in vis
        MOI.delete(model.variables, vi)
        delete!(model.var_to_name, vi)
    end
    MOI.delete(model.objective, vis)
    model.name_to_var = nothing
    model.name_to_con = nothing
    return
end

# A copy utility

function pass_nonvariable_constraints(
    dest::AbstractModel,
    src::MOI.ModelLike,
    idxmap::IndexMap,
    constraint_types,
)
    pass_nonvariable_constraints(
        dest.constraints,
        src,
        idxmap,
        constraint_types,
    )
    return
end

# Macro to generate Model

function _struct_of_constraints_type(name, subtypes, parametrized_type)
    if length(subtypes) == 1
        # Only one type, no need for a `StructOfConstraints`.
        return subtypes[1]
    end
    expr = Expr(:curly, name, esc(:T))
    if parametrized_type
        append!(expr.args, subtypes)
    end
    return expr
end

# This macro is for expert/internal use only. Prefer the concrete Model type
# instantiated below.
"""
    macro model(
        model_name,
        scalar_sets,
        typed_scalar_sets,
        vector_sets,
        typed_vector_sets,
        scalar_functions,
        typed_scalar_functions,
        vector_functions,
        typed_vector_functions,
        is_optimizer = false
    )

Creates a type `model_name` implementing the MOI model interface and supporting
all combinations of the provided functions and sets.

Each `typed_` `scalar`/`vector` `sets`/`functions` argument is a tuple of types.
A type is "typed" if it has a coefficient `{T}` as the first type parameter.

## Tuple syntax

To give no set/function, write `()`.
To give one set or function `X`, write `(X,)`.

## `is_optimizer`

If `is_optimizer = true`, the resulting struct is a of [`GenericOptimizer`](@ref),
which is a subtype of [`MOI.AbstractOptimizer`](@ref), otherwise, it is a
[`GenericModel`](@ref), which is a subtype of [`MOI.ModelLike`](@ref).

## VariableIndex

 * The function [`MOI.VariableIndex`](@ref) must not be given in
   `scalar_functions`.
 * The model supports [`MOI.VariableIndex`](@ref)-in-`S` constraints where `S`
   is [`MOI.EqualTo`](@ref), [`MOI.GreaterThan`](@ref), [`MOI.LessThan`](@ref),
   [`MOI.Interval`](@ref), [`MOI.Integer`](@ref), [`MOI.ZeroOne`](@ref),
   [`MOI.Semicontinuous`](@ref) or [`MOI.Semiinteger`](@ref).
 * The sets supported with [`MOI.VariableIndex`](@ref) cannot be controlled from
   the macro; use [`UniversalFallback`](@ref) to support more sets.

## Example

The model describing a linear program would be:
```julia
@model(
    LPModel,                                          # model_name
    (),                                               # untyped scalar sets
    (MOI.EqualTo, MOI.GreaterThan, MOI.LessThan, MOI.Interval), #   typed scalar sets
    (MOI.Zeros, MOI.Nonnegatives, MOI.Nonpositives),  # untyped vector sets
    (),                                               #   typed vector sets
    (),                                               # untyped scalar functions
    (MOI.ScalarAffineFunction,),                      #   typed scalar functions
    (MOI.VectorOfVariables,),                         # untyped vector functions
    (MOI.VectorAffineFunction,),                      #   typed vector functions
    false,                                            # is_optimizer
)
```
"""
macro model(
    model_name,
    scalar_sets,
    typed_scalar_sets,
    vector_sets,
    typed_vector_sets,
    scalar_functions,
    typed_scalar_functions,
    vector_functions,
    typed_vector_functions,
    is_optimizer = false,
)
    scalar_sets = vcat(
        SymbolSet.(scalar_sets.args, false),
        SymbolSet.(typed_scalar_sets.args, true),
    )
    vector_sets = vcat(
        SymbolSet.(vector_sets.args, false),
        SymbolSet.(typed_vector_sets.args, true),
    )
    scalar_funs = vcat(
        SymbolFun.(scalar_functions.args, false),
        SymbolFun.(typed_scalar_functions.args, true),
    )
    vector_funs = vcat(
        SymbolFun.(vector_functions.args, false),
        SymbolFun.(typed_vector_functions.args, true),
    )
    scname = esc(Symbol("$(model_name)ScalarConstraints"))
    vcname = esc(Symbol("$(model_name)VectorConstraints"))
    funs = [scalar_funs; vector_funs]
    set_struct_types = map(eachindex(funs)) do i
        cname, sets = if i <= length(scalar_funs)
            scname, scalar_sets
        else
            vcname, vector_sets
        end
        voc = map(sets) do set
            return :(VectorOfConstraints{$(_typed(funs[i])),$(_typed(set))})
        end
        return _struct_of_constraints_type(cname, voc, true)
    end
    func_name = esc(Symbol("$(model_name)FunctionConstraints"))
    expr = quote end
    if length(scalar_sets) >= 2
        push!(expr.args, struct_of_constraint_code(scname, scalar_sets))
    end
    if length(vector_sets) >= 2
        push!(expr.args, struct_of_constraint_code(vcname, vector_sets))
    end
    if length(funs) != 1
        push!(
            expr.args,
            struct_of_constraint_code(func_name, funs, set_struct_types),
        )
    end
    func_typed = _struct_of_constraints_type(func_name, set_struct_types, false)
    T = esc(:T)
    generic = is_optimizer ? GenericOptimizer : GenericModel
    push!(
        expr.args,
        quote
            const $(esc(model_name)){$T} = $generic{
                $T,
                ObjectiveContainer{$T},
                VariablesContainer{$T},
                $func_typed,
            }
        end,
    )
    return expr
end

const LessThanIndicatorOne{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{T}}

const LessThanIndicatorZero{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.LessThan{T}}

const GreaterThanIndicatorOne{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.GreaterThan{T}}

const GreaterThanIndicatorZero{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.GreaterThan{T}}

const EqualToIndicatorOne{T} = MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.EqualTo{T}}

const EqualToIndicatorZero{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.EqualTo{T}}

@model(
    Model,
    (MOI.ZeroOne, MOI.Integer),
    (
        MOI.EqualTo,
        MOI.GreaterThan,
        MOI.LessThan,
        MOI.Interval,
        MOI.Semicontinuous,
        MOI.Semiinteger,
        MOI.Parameter,
    ),
    (
        MOI.Reals,
        MOI.Zeros,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.Complements,
        MOI.NormInfinityCone,
        MOI.NormOneCone,
        MOI.NormCone,
        MOI.SecondOrderCone,
        MOI.RotatedSecondOrderCone,
        MOI.GeometricMeanCone,
        MOI.ExponentialCone,
        MOI.DualExponentialCone,
        MOI.RelativeEntropyCone,
        MOI.NormSpectralCone,
        MOI.NormNuclearCone,
        MOI.PositiveSemidefiniteConeTriangle,
        MOI.PositiveSemidefiniteConeSquare,
        MOI.HermitianPositiveSemidefiniteConeTriangle,
        MOI.Scaled{MOI.PositiveSemidefiniteConeTriangle},
        MOI.RootDetConeTriangle,
        MOI.RootDetConeSquare,
        MOI.LogDetConeTriangle,
        MOI.LogDetConeSquare,
        MOI.AllDifferent,
        MOI.CountDistinct,
        MOI.CountBelongs,
        MOI.CountAtLeast,
        MOI.CountGreaterThan,
        MOI.Circuit,
        MOI.Cumulative,
        MOI.Path,
    ),
    (
        MOI.PowerCone,
        MOI.DualPowerCone,
        MOI.SOS1,
        MOI.SOS2,
        LessThanIndicatorOne,
        LessThanIndicatorZero,
        GreaterThanIndicatorOne,
        GreaterThanIndicatorZero,
        EqualToIndicatorOne,
        EqualToIndicatorZero,
        MOI.Table,
        MOI.BinPacking,
        MOI.HyperRectangle,
        MOI.VectorNonlinearOracle,
    ),
    (MOI.ScalarNonlinearFunction,),
    (MOI.ScalarAffineFunction, MOI.ScalarQuadraticFunction),
    (MOI.VectorOfVariables, MOI.VectorNonlinearFunction),
    (MOI.VectorAffineFunction, MOI.VectorQuadraticFunction)
)

@doc raw"""
    MOI.Utilities.Model{T}() where {T}

An implementation of `ModelLike` that supports all functions and sets defined
in MOI. It is parameterized by the coefficient type.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}()
MOIU.Model{Float64}
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```
"""
Model

# This export makes the type be printed as:
# ```julia
# julia> Base.show(IOContext(stdout, :compact => true), MathOptInterface.Utilities.Model)
# Model{T} where T
#
# julia> print(MathOptInterface.Utilities.Model)
# MathOptInterface.Utilities.Model{T} where T
#
# julia> MathOptInterface.Utilities.Model
# MathOptInterface.Utilities.Model{T} where T (alias for MathOptInterface.Utilities.GenericModel{T, MathOptInterface.Utilities.ObjectiveContainer{T}, MathOptInterface.Utilities.VariablesContainer{T}, MathOptInterface.Utilities.ModelFunctionConstraints{T}} where T)
# ```
# As MOI is not doing `using .Utilities` and is not exporting `Model`, the user
# still needs to do `MOI.Utilities.Model` unless he does
# `using MathOptInterface.Utilities`.
export Model

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module FileFormats

import MathOptInterface as MOI

import CodecBzip2
import CodecZlib

include("utils.jl")

include("CBF/CBF.jl")
include("LP/LP.jl")
include("MOF/MOF.jl")
include("MPS/MPS.jl")
include("NL/NL.jl")
include("SDPA/SDPA.jl")

MOI.@_documented_enum(
    """
        FileFormat

    List of accepted export formats.
    """,
    FileFormat,
    """
    Try to detect the file format based on the file name.
    """,
    FORMAT_AUTOMATIC,
    """
    The Conic Benchmark format.

    See [`FileFormats.CBF.Model`](@ref) for more details.
    """,
    FORMAT_CBF,
    """
    The LP file format.

    See [`FileFormats.LP.Model`](@ref) for more details.
    """,
    FORMAT_LP,
    """
    The MathOptFormat file format.

    See [`FileFormats.MOF.Model`](@ref) for more details.
    """,
    FORMAT_MOF,
    """
    The MPS file format.

    See [`FileFormats.MPS.Model`](@ref) for more details.
    """,
    FORMAT_MPS,
    """
    The AMPL .nl file format.

    See [`FileFormats.NL.Model`](@ref) for more details.
    """,
    FORMAT_NL,
    """
    The .rew file format, which is equivalent to the MPS format
    ([`FileFormats.FORMAT_MPS`](@ref)) with the `generic_names = true` keyword
    argument set by default.

    See [`FileFormats.MPS.Model`](@ref) for more details.
    """,
    FORMAT_REW,
    """
    The SemiDefinite Programming Algorithm format.

    See [`FileFormats.SDPA.Model`](@ref) for more details.
    """,
    FORMAT_SDPA,
)

"""
    Model(;
        format::FileFormat = FORMAT_AUTOMATIC,
        filename::Union{Nothing, String} = nothing,
        kwargs...
    )

Return model corresponding to the [`FileFormats.FileFormat`](@ref) `format`, or,
if `format == FORMAT_AUTOMATIC`, guess the format from `filename`.

The `filename` argument is only needed if `format == FORMAT_AUTOMATIC`.

`kwargs` are passed to the underlying model constructor.
"""
function Model(;
    format::FileFormat = FORMAT_AUTOMATIC,
    filename::Union{Nothing,String} = nothing,
    kwargs...,
)
    if format == FORMAT_CBF
        return CBF.Model(; kwargs...)
    elseif format == FORMAT_LP
        return LP.Model(; kwargs...)
    elseif format == FORMAT_MOF
        return MOF.Model(; kwargs...)
    elseif format == FORMAT_MPS
        return MPS.Model(; kwargs...)
    elseif format == FORMAT_NL
        return NL.Model(; kwargs...)
    elseif format == FORMAT_REW
        return MPS.Model(; generic_names = true, kwargs...)
    elseif format == FORMAT_SDPA
        return SDPA.Model(; kwargs...)
    else
        @assert format == FORMAT_AUTOMATIC
        if filename === nothing
            error("When `format==FORMAT_AUTOMATIC` you must pass a `filename`.")
        end
        for (ext, model) in [
            (".cbf", CBF.Model),
            (".lp", LP.Model),
            (".mof.json", MOF.Model),
            (".mps", MPS.Model),
            (
                ".rew",
                (; kwargs...) -> MPS.Model(; generic_names = true, kwargs...),
            ),
            (".nl", NL.Model),
            (".dat-s", SDPA.Model),
            (".sdpa", SDPA.Model),
        ]
            if endswith(filename, ext) || occursin("$(ext).", filename)
                return model(; kwargs...)
            end
        end
        error("Unable to automatically detect format of $(filename).")
    end
end

const MATH_OPT_FORMATS =
    Union{CBF.Model,LP.Model,MOF.Model,MPS.Model,NL.Model,SDPA.Model}

function MOI.write_to_file(model::MATH_OPT_FORMATS, filename::String)
    compressed_open(filename, "w", AutomaticCompression()) do io
        return write(io, model)
    end
end

function MOI.read_from_file(model::MATH_OPT_FORMATS, filename::String)
    compressed_open(filename, "r", AutomaticCompression()) do io
        return read!(io, model)
    end
end

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# To try and speed up the tests, MOI uses a `MOI_TEST_MODULES` environment
# variable. This environment variable may be missing, or it may be a subset of
# the following, concatenated with `;` as a separator:
#
#  * General
#  * Benchmarks
#  * Bridges/General
#  * Bridges/Constraint
#  * Bridges/Objective
#  * Bridges/Variable
#  * FileFormats
#  * Nonlinear
#  * Test
#  * Utilities
#
# If present, the tests run only those submodules defined above. `General` is
# not a submodule, but it runs all of the top-level tests in MOI.

# This file gets called first. If it doesn't crash, all is well.
include("issue980.jl")

MODULES_TO_TEST = get(
    ENV,
    "MOI_TEST_MODULES",
    "General;Benchmarks;Bridges/General;Bridges/Constraint;Bridges/Objective;Bridges/Variable;FileFormats;Nonlinear;Test;Utilities",
)

is_test_file(f) = startswith(f, "test_") && endswith(f, ".jl")

testsuite = Dict{String,Expr}()
for submodule in split(MODULES_TO_TEST, ";")
    for (root, dirs, files) in walkdir(submodule)
        for file in joinpath.(root, filter(is_test_file, files))
            testsuite[file] = :(include($file))
        end
    end
end

import MathOptInterface
import ParallelTestRunner
import Test

ParallelTestRunner.runtests(MathOptInterface, ARGS; testsuite)

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# TODO The mutability of the coefficient type `T` is currently not exploited yet.
#      We first need to make sure that it is copied with `MA.copy_if_mutable` when it
#      is passed from one function to a mutable one.

MA.mutability(::Type{<:TypedLike}) = MA.IsMutable()

function MA.mutable_copy(func::MOI.ScalarAffineFunction)
    terms = [
        MOI.ScalarAffineTerm(MA.copy_if_mutable(t.coefficient), t.variable)
        for t in func.terms
    ]
    return MOI.ScalarAffineFunction(terms, MA.copy_if_mutable(func.constant))
end

function MA.mutable_copy(func::MOI.ScalarQuadraticFunction)
    affine_terms = [
        MOI.ScalarAffineTerm(MA.copy_if_mutable(t.coefficient), t.variable)
        for t in func.affine_terms
    ]
    quadratic_terms = [
        MOI.ScalarQuadraticTerm(
            MA.copy_if_mutable(t.coefficient),
            t.variable_1,
            t.variable_2,
        ) for t in func.quadratic_terms
    ]
    return MOI.ScalarQuadraticFunction(
        quadratic_terms,
        affine_terms,
        MA.copy_if_mutable(func.constant),
    )
end

function MA.isequal_canonical(
    f::F,
    g::F,
) where {
    F<:Union{
        MOI.ScalarAffineFunction,
        MOI.ScalarQuadraticFunction,
        MOI.VectorAffineFunction,
        MOI.VectorQuadraticFunction,
    },
}
    return MA.isequal_canonical(MOI.constant(f), MOI.constant(g)) && all(
        MOI.dict_compare.(MOI._dicts(f), MOI._dicts(g), MA.isequal_canonical),
    )
end

function MA.iszero!!(f::TypedScalarLike{T}) where {T}
    return iszero(MOI.constant(f, T)) && _is_constant(canonicalize!(f))
end

function MA.scaling(f::TypedScalarLike{T}) where {T}
    g = canonical(f)
    if !_is_constant(g)
        throw(InexactError(:convert, T, f))
    end
    return MA.scaling(MOI.constant(g, T))
end

function MA.promote_operation(
    ::Union{typeof(zero),typeof(one)},
    F::Type{<:TypedScalarLike},
)
    return F
end

const PROMOTE_IMPLEMENTED_OP = Union{typeof(+),typeof(-),typeof(*),typeof(/)}

function MA.promote_operation(
    op::PROMOTE_IMPLEMENTED_OP,
    F::Type{<:TypedScalarLike{T}},
    G::Type{MOI.VariableIndex},
) where {T}
    return promote_operation(op, T, F, G)
end

function MA.promote_operation(
    op::PROMOTE_IMPLEMENTED_OP,
    F::Type{MOI.VariableIndex},
    G::Type{<:TypedScalarLike{T}},
) where {T}
    return promote_operation(op, T, F, G)
end

function MA.promote_operation(
    op::PROMOTE_IMPLEMENTED_OP,
    F::Type{<:TypedScalarLike{T}},
    G::Type{<:TypedScalarLike{T}},
) where {T}
    return promote_operation(op, T, F, G)
end

function MA.promote_operation(
    op::PROMOTE_IMPLEMENTED_OP,
    F::Type{T},
    G::Type{<:TypedLike{T}},
) where {T<:Number}
    return promote_operation(op, T, F, G)
end

function MA.promote_operation(
    op::PROMOTE_IMPLEMENTED_OP,
    F::Type{<:TypedLike{T}},
    G::Type{T},
) where {T<:Number}
    return promote_operation(op, T, F, G)
end

function MA.promote_operation(
    op::PROMOTE_IMPLEMENTED_OP,
    F::Type{<:Number},
    G::Type{<:Union{MOI.VariableIndex,MOI.VectorOfVariables}},
)
    return promote_operation(op, F, F, G)
end

function MA.promote_operation(
    op::PROMOTE_IMPLEMENTED_OP,
    F::Type{<:Union{MOI.VariableIndex,MOI.VectorOfVariables}},
    G::Type{<:Number},
)
    return promote_operation(op, G, F, G)
end

function MA.operate!(
    op::Union{typeof(zero),typeof(one)},
    f::MOI.ScalarAffineFunction,
)
    empty!(f.terms)
    f.constant = op(f.constant)
    return f
end

function MA.operate!(
    op::Union{typeof(zero),typeof(one)},
    f::MOI.ScalarQuadraticFunction,
)
    empty!(f.affine_terms)
    empty!(f.quadratic_terms)
    f.constant = op(f.constant)
    return f
end

function MA.operate!(
    ::typeof(-),
    f::Union{MOI.ScalarAffineFunction,MOI.ScalarQuadraticFunction},
)
    map_terms!(Base.Fix1(operate_term, -), f)
    f.constant = -f.constant
    return f
end

function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    f::MOI.ScalarAffineFunction{T},
    g::T,
) where {T}
    f.constant = op(f.constant, g)
    return f
end

function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    f::MOI.ScalarAffineFunction{T},
    g::MOI.VariableIndex,
) where {T}
    push!(f.terms, MOI.ScalarAffineTerm(op(one(T)), g))
    return f
end

function MA.operate_to!(
    output::MOI.ScalarAffineFunction{T},
    op::Union{typeof(+),typeof(-)},
    f::MOI.ScalarAffineFunction{T},
    g::MOI.ScalarAffineFunction{T},
) where {T}
    empty!(output.terms)
    append!(output.terms, f.terms)
    append!(output.terms, operate_terms(op, g.terms))
    output.constant = op(f.constant, g.constant)
    return output
end

function MA.operate_to!(
    output::MOI.ScalarQuadraticFunction{T},
    op::Union{typeof(+),typeof(-)},
    f::MOI.ScalarQuadraticFunction{T},
    g::MOI.ScalarQuadraticFunction{T},
) where {T}
    empty!(output.affine_terms)
    append!(output.affine_terms, f.affine_terms)
    append!(output.affine_terms, operate_terms(op, g.affine_terms))
    empty!(output.quadratic_terms)
    append!(output.quadratic_terms, f.quadratic_terms)
    append!(output.quadratic_terms, operate_terms(op, g.quadratic_terms))
    output.constant = op(f.constant, g.constant)
    return output
end

function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    f::MOI.ScalarAffineFunction{T},
    g::MOI.ScalarAffineFunction{T},
) where {T}
    append!(f.terms, operate_terms(op, g.terms))
    f.constant = op(f.constant, g.constant)
    return f
end

function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    f::MOI.ScalarQuadraticFunction{T},
    g::T,
) where {T}
    f.constant = op(f.constant, g)
    return f
end

function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    f::MOI.ScalarQuadraticFunction{T},
    g::MOI.VariableIndex,
) where {T}
    push!(f.affine_terms, MOI.ScalarAffineTerm(op(one(T)), g))
    return f
end

function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    f::MOI.ScalarQuadraticFunction{T},
    g::MOI.ScalarAffineFunction{T},
) where {T}
    append!(f.affine_terms, operate_terms(op, g.terms))
    f.constant = op(f.constant, g.constant)
    return f
end

function MA.operate!(
    op::Union{typeof(+),typeof(-)},
    f::MOI.ScalarQuadraticFunction{T},
    g::MOI.ScalarQuadraticFunction{T},
) where {T}
    append!(f.affine_terms, operate_terms(op, g.affine_terms))
    append!(f.quadratic_terms, operate_terms(op, g.quadratic_terms))
    f.constant = op(f.constant, g.constant)
    return f
end

_constant(::Type{T}, α::T) where {T} = α

_constant(::Type{T}, ::MOI.VariableIndex) where {T} = zero(T)

_constant(::Type{T}, func::TypedScalarLike{T}) where {T} = MOI.constant(func, T)

_affine_terms(f::MOI.ScalarAffineFunction) = f.terms

_affine_terms(f::MOI.ScalarQuadraticFunction) = f.affine_terms

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    α::T,
    f::MOI.VariableIndex,
    β::T,
) where {T<:Number}
    push!(terms, MOI.ScalarAffineTerm(op(α * β), f))
    return
end

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    f::MOI.VariableIndex,
    β::T,
) where {T<:Number}
    push!(terms, MOI.ScalarAffineTerm(op(β), f))
    return
end

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    α::T,
    f::MOI.VariableIndex,
) where {T}
    push!(terms, MOI.ScalarAffineTerm(op(α), f))
    return
end

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    f::MOI.VariableIndex,
) where {T}
    push!(terms, MOI.ScalarAffineTerm(op(one(T)), f))
    return
end

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    α::T,
    f::TypedScalarLike{T},
    β::T,
) where {T}
    for t in _affine_terms(f)
        push!(terms, operate_term(op, operate_term(*, α, t, β)))
    end
    return
end

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    f::TypedScalarLike{T},
    β::T,
) where {T}
    for t in _affine_terms(f)
        push!(terms, operate_term(op, operate_term(*, t, β)))
    end
    return
end

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    α::T,
    f::TypedScalarLike{T},
) where {T}
    for t in _affine_terms(f)
        push!(terms, operate_term(op, operate_term(*, α, t)))
    end
    return
end

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    f::TypedScalarLike{T},
) where {T}
    append!(terms, operate_terms(op, _affine_terms(f)))
    return
end

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    args::Vararg{T,N},
) where {T,N}
    return
end

function _add_sub_affine_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarAffineTerm{T}},
    α::T,
    β::T,
    args::Vararg{ScalarQuadraticLike,N},
) where {T,N}
    _add_sub_affine_terms(op, terms, α * β, args...)
    return
end

function MA.operate!(
    op::MA.AddSubMul,
    f::MOI.ScalarAffineFunction{T},
    args::Vararg{ScalarAffineLike{T},N},
) where {T,N}
    f.constant = op(f.constant, _constant.(T, args)...)
    _add_sub_affine_terms(MA.add_sub_op(op), f.terms, args...)
    return f
end

function _add_quadratic_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarQuadraticTerm{T}},
    α::ScalarAffineLike{T},
    f::MOI.ScalarQuadraticFunction{T},
    β::ScalarAffineLike{T},
) where {T}
    for t in f.quadratic_terms
        push!(
            terms,
            operate_term(
                op,
                operate_term(*, _constant(T, α), t, _constant(T, β)),
            ),
        )
    end
    return
end

function _add_quadratic_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarQuadraticTerm{T}},
    f::MOI.ScalarQuadraticFunction{T},
    β::ScalarAffineLike{T},
) where {T}
    for t in f.quadratic_terms
        push!(terms, operate_term(op, operate_term(*, t, _constant(T, β))))
    end
    return
end

function _add_quadratic_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarQuadraticTerm{T}},
    α::ScalarAffineLike{T},
    f::MOI.ScalarQuadraticFunction{T},
) where {T}
    for t in f.quadratic_terms
        push!(terms, operate_term(op, operate_term(*, _constant(T, α), t)))
    end
    return
end

function _add_quadratic_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarQuadraticTerm{T}},
    f::MOI.ScalarQuadraticFunction{T},
) where {T}
    append!(terms, operate_terms(op, f.quadratic_terms))
    return
end

function _add_quadratic_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarQuadraticTerm{T}},
    # Compiler fails in StackOverflowError on Julia v1.1
    #args::Vararg{ScalarAffineLike{T}, N}) where {T, N}
    args::ScalarAffineLike{T},
) where {T}
    return
end

function _merge_constants(
    ::Type{T},
    α::ScalarAffineLike{T},
    β::ScalarAffineLike{T},
    args::Vararg{Any,N},
) where {T,N}
    return (_constant(T, α) * _constant(T, β), args...)
end

function _add_quadratic_terms(
    op::Union{typeof(+),typeof(-)},
    terms::Vector{MOI.ScalarQuadraticTerm{T}},
    args::Vararg{Any,N},
) where {T,N}
    _add_quadratic_terms(op, terms, _merge_constants(T, args...)...)
    return
end

_num_function_with_terms(::Type{T}, ::T) where {T} = 0

_num_function_with_terms(::Type{T}, ::ScalarLike{T}) where {T} = 1

function _num_function_with_terms(
    ::Type{T},
    f::ScalarQuadraticLike{T},
    args::Vararg{ScalarQuadraticLike{T},N},
) where {T,N}
    return _num_function_with_terms(T, f) + _num_function_with_terms(T, args...)
end

function MA.operate!(
    op::MA.AddSubMul,
    f::MOI.ScalarQuadraticFunction{T},
    args::Vararg{ScalarQuadraticLike{T},N},
) where {T,N}
    if isone(_num_function_with_terms(T, args...))
        f.constant = op(f.constant, _constant.(T, args)...)
        _add_sub_affine_terms(MA.add_sub_op(op), f.affine_terms, args...)
        _add_quadratic_terms(MA.add_sub_op(op), f.quadratic_terms, args...)
        return f
    else
        return MA.operate!(MA.add_sub_op(op), f, *(args...))
    end
end

# `args` could be `(x', a)` where `a` is a vector of constants and `x` a vector
# of affine functions for instance.
function MA.operate!(
    op::MA.AddSubMul,
    f::TypedScalarLike,
    args::Vararg{Any,N},
) where {N}
    return MA.operate!(MA.add_sub_op(op), f, *(args...))
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type AbstractBridge <: MOI.Bridges.AbstractBridge end

Subtype of [`MOI.Bridges.AbstractBridge`](@ref) for objective bridges.

In addition to the required implementation described in
[`MOI.Bridges.AbstractBridge`](@ref), subtypes of `AbstractBridge` must
additionally implement:

 * [`supports_objective_function`](@ref)
 * [`concrete_bridge_type`](@ref)
 * [`bridge_objective`](@ref)
 * [`MOI.Bridges.set_objective_function_type`](@ref)
"""
abstract type AbstractBridge <: MOI.Bridges.AbstractBridge end

"""
    supports_objective_function(
        BT::Type{<:MOI.Bridges.Objective.AbstractBridge},
        F::Type{<:MOI.AbstractFunction},
    )::Bool

Return a `Bool` indicating whether the bridges of type `BT` support bridging
objective functions of type `F`.

## Implementation notes

 * This method depends only on the type of the inputs, not the runtime values.
 * There is a default fallback, so you need only implement this method For
   objective functions that the bridge implements.
"""
function supports_objective_function(
    ::Type{<:AbstractBridge},
    ::Type{<:MOI.AbstractFunction},
)
    return false
end

"""
    concrete_bridge_type(
        BT::Type{<:MOI.Bridges.Objective.AbstractBridge},
        F::Type{<:MOI.AbstractFunction},
    )::Type

Return the concrete type of the bridge supporting objective functions of type
`F`.

This function can only be called if `MOI.supports_objective_function(BT, F)` is
`true`.
"""
function concrete_bridge_type(
    ::Type{BT},
    ::Type{<:MOI.AbstractFunction},
) where {BT}
    return BT
end

function concrete_bridge_type(
    b::MOI.Bridges.AbstractBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
)
    return concrete_bridge_type(MOI.Bridges.bridge_type(b, F), F)
end

"""
    bridge_objective(
        BT::Type{<:MOI.Bridges.Objective.AbstractBridge},
        model::MOI.ModelLike,
        func::MOI.AbstractFunction,
    )::BT

Bridge the objective function `func` using bridge `BT` to `model` and returns
a bridge object of type `BT`.

## Implementation notes

 * The bridge type `BT` must be a concrete type, that is, all the type
   parameters of the bridge must be set.
"""
function bridge_objective(
    ::Type{<:AbstractBridge},
    ::MOI.ModelLike,
    func::MOI.AbstractFunction,
)
    return throw(
        MOI.UnsupportedAttribute(MOI.ObjectiveFunction{typeof(func)}()),
    )
end

function MOI.set(
    ::MOI.ModelLike,
    attr::MOI.ObjectiveSense,
    bridge::AbstractBridge,
    ::MOI.OptimizationSense,
)
    return throw(
        MOI.SetAttributeNotAllowed(
            attr,
            "Objective bridge of type `$(typeof(bridge))` does not support " *
            "modifying the objective sense. As a workaround, set the sense " *
            "to `MOI.FEASIBILITY_SENSE` to clear the objective function and " *
            "bridges.",
        ),
    )
end

function MOI.get(
    ::MOI.ModelLike,
    attr::MOI.ObjectiveFunction,
    bridge::AbstractBridge,
)
    return throw(
        MOI.GetAttributeNotAllowed(
            attr,
            "ObjectiveFunction bridge of type `$(typeof(bridge))` does not" *
            " support getting the objective function.",
        ),
    )
end

function MOI.delete(::MOI.ModelLike, bridge::AbstractBridge)
    return throw(
        ArgumentError(
            "`MOI.delete` not implemented for `ObjectiveFunction` bridges of " *
            "type `$(typeof(bridge))`",
        ),
    )
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type AbstractIndexing end

Indexing to be used for storing the row and column indices of
`MutableSparseMatrixCSC`. See [`ZeroBasedIndexing`](@ref) and
[`OneBasedIndexing`](@ref).
"""
abstract type AbstractIndexing end

"""
    struct ZeroBasedIndexing <: AbstractIndexing end

Zero-based indexing: the `i`th row or column has index `i - 1`. This is useful
when the vectors of row and column indices need to be communicated to a
library using zero-based indexing such as C libraries.
"""
struct ZeroBasedIndexing <: AbstractIndexing end

"""
    struct ZeroBasedIndexing <: AbstractIndexing end

One-based indexing: the `i`th row or column has index `i`. This enables an
allocation-free conversion of [`MutableSparseMatrixCSC`](@ref) to
`SparseArrays.SparseMatrixCSC`.
"""
struct OneBasedIndexing <: AbstractIndexing end

_first_index(::Type{T}, ::ZeroBasedIndexing) where {T} = T(0)
_first_index(::Type{T}, ::OneBasedIndexing) where {T} = T(1)

_shift(x, ::T, ::T) where {T<:AbstractIndexing} = x
_shift(x::Integer, ::ZeroBasedIndexing, ::OneBasedIndexing) = x + 1
_shift(x::Integer, ::OneBasedIndexing, ::ZeroBasedIndexing) = x - 1
_shift(x::Array{<:Integer}, ::ZeroBasedIndexing, ::OneBasedIndexing) = x .+ 1

"""
    mutable struct MutableSparseMatrixCSC{Tv,Ti<:Integer,I<:AbstractIndexing}
        indexing::I
        m::Int
        n::Int
        colptr::Vector{Ti}
        rowval::Vector{Ti}
        nzval::Vector{Tv}
        nz_added::Vector{Ti}
    end

Matrix type loading sparse matrices in the Compressed Sparse Column format.
The indexing used is `indexing`, see [`AbstractIndexing`](@ref). The other
fields have the same meaning than for `SparseArrays.SparseMatrixCSC` except
that the indexing is different unless `indexing` is `OneBasedIndexing`. In
addition, `nz_added` is used to cache the number of non-zero terms that have
been added to each column due to the incremental nature of `load_terms`.

The matrix is loaded in 5 steps:
1) `MOI.empty!` is called.
2) `MOI.Utilities.add_column` and `MOI.Utilities.allocate_terms` are called in
   any order.
3) `MOI.Utilities.set_number_of_rows` is called.
4) `MOI.Utilities.load_terms` is called for each affine function.
5) `MOI.Utilities.final_touch` is called.
"""
mutable struct MutableSparseMatrixCSC{Tv,Ti<:Integer,I<:AbstractIndexing}
    indexing::I
    m::Int # Number of rows
    n::Int # Number of columns
    colptr::Vector{Ti}
    rowval::Vector{Ti}
    nzval::Vector{Tv}
    nz_added::Vector{Ti}
    function MutableSparseMatrixCSC{Tv,Ti,I}() where {Tv,Ti<:Integer,I}
        indexing = I()
        colptr = [_first_index(Ti, indexing)]
        return new{Tv,Ti,I}(indexing, 0, 0, colptr, Ti[], Tv[], Ti[])
    end
end

function SparseArrays.nzrange(A::MutableSparseMatrixCSC, col)
    start = _shift(A.colptr[col], A.indexing, OneBasedIndexing())
    stop = _shift(A.colptr[col+1], A.indexing, ZeroBasedIndexing())
    return start:stop
end

function MOI.empty!(A::MutableSparseMatrixCSC{Tv,Ti}) where {Tv,Ti}
    A.m = 0
    A.n = 0
    resize!(A.colptr, 1)
    A.colptr[1] = _first_index(Ti, A.indexing)
    empty!(A.rowval)
    empty!(A.nzval)
    empty!(A.nz_added)
    return
end

function add_column(A::MutableSparseMatrixCSC{Tv,Ti}) where {Tv,Ti}
    A.n += 1
    push!(A.colptr, _first_index(Ti, A.indexing))
    push!(A.nz_added, Ti(0))
    return
end

function add_columns(A::MutableSparseMatrixCSC{Tv,Ti}, n) where {Tv,Ti}
    for _ in 1:n
        add_column(A)
    end
    return
end

function set_number_of_rows(A::MutableSparseMatrixCSC, num_rows)
    A.m = num_rows
    offset = _first_index(Int, A.indexing)
    for i in 3:length(A.colptr)
        A.colptr[i] += A.colptr[i-1] - offset
    end
    resize!(A.rowval, A.colptr[end] - offset)
    resize!(A.nzval, A.colptr[end] - offset)
    return
end

final_touch(::MutableSparseMatrixCSC) = nothing

_variable(term::MOI.ScalarAffineTerm) = term.variable
_variable(term::MOI.VectorAffineTerm) = _variable(term.scalar_term)

function allocate_terms(
    A::MutableSparseMatrixCSC,
    index_map,
    func::Union{MOI.ScalarAffineFunction,MOI.VectorAffineFunction},
)
    for term in func.terms
        A.colptr[index_map[_variable(term)].value+1] += 1
    end
    return
end

_output_index(::MOI.ScalarAffineTerm) = 1
_output_index(term::MOI.VectorAffineTerm) = term.output_index

function load_terms(
    A::MutableSparseMatrixCSC,
    index_map,
    func::Union{MOI.ScalarAffineFunction,MOI.VectorAffineFunction},
    offset::Int,
)
    row_offset = _shift(offset, OneBasedIndexing(), A.indexing)
    zero_offset = 1 - _first_index(Int, A.indexing)
    for term in func.terms
        col = index_map[_variable(term)].value
        ptr = A.colptr[col] + A.nz_added[col] + zero_offset
        A.rowval[ptr] = row_offset + _output_index(term)
        A.nzval[ptr] = MOI.coefficient(term)
        A.nz_added[col] += 1
    end
    return
end

"""
    Base.convert(
        ::Type{SparseMatrixCSC{Tv,Ti}},
        A::MutableSparseMatrixCSC{Tv,Ti,I},
    ) where {Tv,Ti,I}

Converts `A` to a `SparseMatrixCSC`. Note that the field `A.nzval` is **not
copied** so if `A` is modified after the call of this function, it can still
affect the value returned. Moreover, if `I` is `OneBasedIndexing`, `colptr`
and `rowval` are not copied either, that is, the conversion is allocation-free.
"""
function Base.convert(
    ::Type{SparseArrays.SparseMatrixCSC{Tv,Ti}},
    A::MutableSparseMatrixCSC{Tv,Ti},
) where {Tv,Ti}
    return SparseArrays.SparseMatrixCSC{Tv,Ti}(
        A.m,
        A.n,
        _shift(A.colptr, A.indexing, OneBasedIndexing()),
        _shift(A.rowval, A.indexing, OneBasedIndexing()),
        A.nzval,
    )
end

function _first_in_column(
    A::MutableSparseMatrixCSC{Tv,Ti},
    row::Integer,
    col::Integer,
) where {Tv,Ti}
    range = SparseArrays.nzrange(A, col)
    row = _shift(row, OneBasedIndexing(), A.indexing)
    idx = searchsortedfirst(view(A.rowval, range), row)
    return get(range, idx, last(range) + 1)
end

function extract_function(
    A::MutableSparseMatrixCSC{T},
    row::Integer,
    constant::T,
) where {T}
    func = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], constant)
    for col in 1:A.n
        idx = _first_in_column(A, row, col)
        if idx > last(SparseArrays.nzrange(A, col))
            continue
        end
        r = _shift(A.rowval[idx], A.indexing, OneBasedIndexing())
        if r == row
            push!(
                func.terms,
                MOI.ScalarAffineTerm(A.nzval[idx], MOI.VariableIndex(col)),
            )
        end
    end
    return func
end

function extract_function(
    A::MutableSparseMatrixCSC{T},
    rows::UnitRange,
    constants::Vector{T},
) where {T}
    func = MOI.VectorAffineFunction(MOI.VectorAffineTerm{T}[], constants)
    if isempty(rows)
        return func
    end
    idx = [_first_in_column(A, first(rows), col) for col in 1:A.n]
    for output_index in eachindex(rows)
        for col in 1:A.n
            if idx[col] > last(SparseArrays.nzrange(A, col))
                continue
            end
            row = _shift(A.rowval[idx[col]], A.indexing, OneBasedIndexing())
            if row != rows[output_index]
                continue
            end
            push!(
                func.terms,
                MOI.VectorAffineTerm(
                    output_index,
                    MOI.ScalarAffineTerm(
                        A.nzval[idx[col]],
                        MOI.VariableIndex(col),
                    ),
                ),
            )
            idx[col] += 1
        end
    end
    return func
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

###
### Define data structures used by later tests.
###

struct UnknownScalarSet{T} <: MOI.AbstractScalarSet
    constant::T
end

MOI.constant(set::UnknownScalarSet) = set.constant

Base.copy(set::UnknownScalarSet) = UnknownScalarSet(copy(MOI.constant(set)))

MOIU.supports_shift_constant(::Type{<:UnknownScalarSet}) = true
function MOIU.shift_constant(set::UnknownScalarSet, offset)
    return UnknownScalarSet(MOI.constant(set) + offset)
end

struct UnknownVectorSet <: MOI.AbstractVectorSet end

abstract type BadModel{T} <: MOI.ModelLike end

function MOI.get(::BadModel, ::MOI.ListOfModelAttributesSet)
    return MOI.AbstractModelAttribute[]
end

MOI.get(::BadModel, ::MOI.ListOfVariableIndices) = [MOI.VariableIndex(1)]

function MOI.get(::BadModel, ::MOI.ListOfVariableAttributesSet)
    return MOI.AbstractVariableAttribute[]
end

function MOI.get(::BadModel, ::MOI.ListOfConstraintAttributesSet)
    return MOI.AbstractConstraintAttribute[]
end

function MOI.get(::BadModel{T}, ::MOI.ListOfConstraintTypesPresent) where {T}
    return [(MOI.VariableIndex, MOI.EqualTo{T})]
end

function MOI.get(::BadModel, ::MOI.ListOfConstraintIndices{F,S}) where {F,S}
    return [MOI.ConstraintIndex{F,S}(1)]
end

function MOI.get(
    ::BadModel{T},
    ::MOI.ConstraintFunction,
    ::MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{T}},
) where {T}
    return MOI.VariableIndex(1)
end

function MOI.get(
    ::BadModel{T},
    ::MOI.ConstraintSet,
    ::MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{T}},
) where {T}
    return MOI.EqualTo(T(0))
end

struct BadConstraintModel{T} <: BadModel{T}
    BadConstraintModel(T = Float64) = new{T}()
end

function MOI.get(
    ::BadConstraintModel{T},
    ::MOI.ListOfConstraintTypesPresent,
) where {T}
    return [
        (MOI.VariableIndex, MOI.EqualTo{T}),
        (MOI.VariableIndex, UnknownScalarSet{T}),
    ]
end

function MOI.get(
    ::BadModel,
    ::MOI.ConstraintFunction,
    ::MOI.ConstraintIndex{MOI.VariableIndex,<:UnknownScalarSet},
)
    return MOI.VariableIndex(1)
end

function MOI.get(
    ::BadModel,
    ::MOI.ConstraintSet,
    ::MOI.ConstraintIndex{MOI.VariableIndex,UnknownScalarSet{T}},
) where {T}
    return UnknownScalarSet(T(1))
end

struct UnknownModelAttribute <: MOI.AbstractModelAttribute end

struct BadModelAttributeModel{T} <: BadModel{T}
    BadModelAttributeModel(T = Float64) = new{T}()
end

MOI.get(src::BadModelAttributeModel, ::UnknownModelAttribute) = 0

function MOI.get(::BadModelAttributeModel, ::MOI.ListOfModelAttributesSet)
    return MOI.AbstractModelAttribute[UnknownModelAttribute()]
end

struct UnknownVariableAttribute <: MOI.AbstractVariableAttribute end

struct BadVariableAttributeModel{T} <: BadModel{T}
    BadVariableAttributeModel(T = Float64) = new{T}()
end

function MOI.get(
    ::BadVariableAttributeModel,
    ::UnknownVariableAttribute,
    ::MOI.VariableIndex,
)
    return 0
end

function MOI.get(::BadVariableAttributeModel, ::MOI.ListOfVariableAttributesSet)
    return MOI.AbstractVariableAttribute[UnknownVariableAttribute()]
end

struct UnknownConstraintAttribute <: MOI.AbstractConstraintAttribute end

struct BadConstraintAttributeModel{T} <: BadModel{T}
    BadConstraintAttributeModel(T = Float64) = new{T}()
end

function MOI.get(
    ::BadConstraintAttributeModel,
    ::UnknownConstraintAttribute,
    ::MOI.ConstraintIndex,
)
    return 0
end

function MOI.get(
    ::BadConstraintAttributeModel,
    ::MOI.ListOfConstraintAttributesSet,
)
    return MOI.AbstractConstraintAttribute[UnknownConstraintAttribute()]
end

###
### The actual tests
###

"""
    test_model_default_ObjectiveSense(model::MOI.ModelLike, ::Config)

Test that the default ObjectiveSense is FEASIBILITY_SENSE.
"""
function test_model_default_ObjectiveSense(model::MOI.ModelLike, ::Config)
    MOI.get(model, MOI.ObjectiveSense()) == MOI.FEASIBILITY_SENSE
    _test_attribute_value_type(model, MOI.ObjectiveSense())
    return
end

"""
    test_model_default_TerminationStatus(model::MOI.AbstractOptimizer, ::Config)

Test that the default TerminationStatus is OPTIMIZE_NOT_CALLED.
"""
function test_model_default_TerminationStatus(
    model::MOI.AbstractOptimizer,
    ::Config,
)
    MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
    _test_attribute_value_type(model, MOI.TerminationStatus())
    return
end

test_model_default_TerminationStatus(::MOI.ModelLike, ::Config) = nothing

"""
    test_model_default_PrimalStatus(model::MOI.AbstractOptimizer, ::Config)

Test that the default PrimalStatus is NO_SOLUTION.
"""
function test_model_default_PrimalStatus(model::MOI.AbstractOptimizer, ::Config)
    MOI.get(model, MOI.PrimalStatus()) == MOI.NO_SOLUTION
    _test_attribute_value_type(model, MOI.PrimalStatus())
    return
end

test_model_default_PrimalStatus(::MOI.ModelLike, ::Config) = nothing

"""
    test_model_default_DualStatus(model::MOI.AbstractOptimizer, ::Config)

Test that the default DualStatus is NO_SOLUTION.
"""
function test_model_default_DualStatus(model::MOI.AbstractOptimizer, ::Config)
    MOI.get(model, MOI.DualStatus()) == MOI.NO_SOLUTION
    _test_attribute_value_type(model, MOI.DualStatus())
    return
end

test_model_default_DualStatus(::MOI.ModelLike, ::Config) = nothing

"""
    test_model_VariableName(model::MOI.ModelLike, ::Config)

Test MOI.VariableName.
"""
function test_model_VariableName(model::MOI.ModelLike, ::Config)
    @requires MOI.supports(model, MOI.VariableName(), MOI.VariableIndex)
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.VariableName(), x[1], "x1")
    @test MOI.get(model, MOI.VariableIndex, "x1") == x[1]
    MOI.set(model, MOI.VariableName(), x[1], "x2")
    @test MOI.get(model, MOI.VariableIndex, "x1") === nothing
    @test MOI.get(model, MOI.VariableIndex, "x2") == x[1]
    MOI.set(model, MOI.VariableName(), x[2], "x1")
    @test MOI.get(model, MOI.VariableIndex, "x1") == x[2]
    MOI.set(model, MOI.VariableName(), x[1], "x1")
    @test_throws ErrorException MOI.get(model, MOI.VariableIndex, "x1")
    _test_attribute_value_type(model, MOI.VariableName(), x[1])
    return
end

"""
    test_model_VariableIndex_ConstraintName(
        model::MOI.ModelLike,
        ::Config,
    )

Test ConstraintName for VariableIndex constraints.
"""
function test_model_VariableIndex_ConstraintName(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test_throws(
        MOI.VariableIndexConstraintNameError(),
        MOI.set(model, MOI.ConstraintName(), c, "c1"),
    )
    return
end

"""
    test_model_ScalarAffineFunction_ConstraintName(
        model::MOI.ModelLike,
        ::Config,
    )

Test ConstraintName for ScalarAffineFunction constraints.
"""
function test_model_ScalarAffineFunction_ConstraintName(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    c1 = MOI.add_constraint(model, f, MOI.GreaterThan(T(0)))
    c2 = MOI.add_constraint(model, f, MOI.LessThan(T(1)))
    MOI.set(model, MOI.ConstraintName(), c1, "c1")
    @test MOI.get(model, MOI.ConstraintIndex, "c1") == c1
    MOI.set(model, MOI.ConstraintName(), c1, "c2")
    @test MOI.get(model, MOI.ConstraintIndex, "c1") === nothing
    @test MOI.get(model, MOI.ConstraintIndex, "c2") == c1
    MOI.set(model, MOI.ConstraintName(), c2, "c1")
    @test MOI.get(model, MOI.ConstraintIndex, "c1") == c2
    MOI.set(model, MOI.ConstraintName(), c1, "c1")
    @test_throws ErrorException MOI.get(model, MOI.ConstraintIndex, "c1")
    return
end

"""
    test_model_Name(model::MOI.ModelLike, ::Config)

Test the `MOI.Name` attribute.
"""
function test_model_Name(model::MOI.ModelLike, ::Config)
    @requires MOI.supports(model, MOI.Name())
    @test !(MOI.Name() in MOI.get(model, MOI.ListOfModelAttributesSet()))
    @test MOI.get(model, MOI.Name()) == ""
    MOI.set(model, MOI.Name(), "Name1")
    @test MOI.Name() in MOI.get(model, MOI.ListOfModelAttributesSet())
    @test MOI.get(model, MOI.Name()) == "Name1"
    MOI.set(model, MOI.Name(), "Name2")
    @test MOI.Name() in MOI.get(model, MOI.ListOfModelAttributesSet())
    @test MOI.get(model, MOI.Name()) == "Name2"
    _test_attribute_value_type(model, MOI.Name())
    return
end

"""
    test_model_VariableName_ConstraintName(
        model::MOI.ModelLike,
        config::Config,
    )

Test a variety of name attribute behavior.
"""
function test_model_Name_VariableName_ConstraintName(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_incremental_interface(model)
    @requires MOI.supports(model, MOI.VariableName(), MOI.VariableIndex)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    @test MOI.get(
        model,
        MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.LessThan{T}}(),
    ) == 0
    v = MOI.add_variables(model, 2)
    @test MOI.get(model, MOI.VariableName(), v[1]) == ""
    x, cx = MOI.add_constrained_variable(model, MOI.GreaterThan(T(0)))
    @test MOI.get(model, MOI.VariableName(), x) == ""
    y, cy = MOI.add_constrained_variables(model, MOI.Nonpositives(4))
    for yi in y
        @test MOI.get(model, MOI.VariableName(), yi) == ""
    end
    MOI.set(model, MOI.VariableName(), v[1], "")
    MOI.set(model, MOI.VariableName(), v[2], "") # Shouldn't error with duplicate empty name
    MOI.set(model, MOI.VariableName(), x, "")
    for yi in y
        MOI.set(model, MOI.VariableName(), yi, "")
    end
    MOI.set(model, MOI.VariableName(), v[1], "Var1")
    MOI.set(model, MOI.VariableName(), v[2], "Var1")
    # Lookup must fail when there are multiple variables with the same name.
    @test_throws Exception MOI.get(model, MOI.VariableIndex, "Var1")
    MOI.set(model, MOI.VariableName(), v[2], "Var2")
    @test MOI.get(model, MOI.VariableIndex, "Var1") == v[1]
    @test MOI.get(model, MOI.VariableIndex, "Var2") == v[2]
    @test MOI.get(model, MOI.VariableIndex, "Var3") === nothing
    MOI.set(model, MOI.VariableName(), x, "Var1")
    @test_throws Exception MOI.get(model, MOI.VariableIndex, "Var1")
    MOI.set(model, MOI.VariableName(), x, "Varx")
    @test MOI.get(model, MOI.VariableIndex, "Var1") == v[1]
    @test MOI.get(model, MOI.VariableIndex, "Var2") == v[2]
    @test MOI.get(model, MOI.VariableIndex, "Varx") == x
    @test MOI.get(model, MOI.VariableIndex, "Var3") === nothing
    vynames = ["VarX", "Var2", "Vary1", "Vary2", "Vary3", "Vary4"]
    MOI.set(model, MOI.VariableName(), [v; y], vynames)
    @test MOI.get(model, MOI.VariableName(), v) == vynames[1:2]
    @test MOI.get(model, MOI.VariableName(), y) == vynames[3:6]
    @test MOI.get(model, MOI.VariableName(), [v; y]) == vynames
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.LessThan{T},
    )
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), v), T(0)),
        MOI.LessThan(T(1)),
    )
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    c2 = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[-1, 1], v), T(0)),
        MOI.EqualTo(T(0)),
    )
    @requires MOI.supports(model, MOI.ConstraintName(), typeof(c))
    @requires MOI.supports(model, MOI.ConstraintName(), typeof(c2))
    @requires MOI.supports(model, MOI.ConstraintName(), typeof(cy))
    @test MOI.get(model, MOI.ConstraintName(), c) == ""
    @test MOI.get(model, MOI.ConstraintName(), c2) == ""
    @test MOI.get(model, MOI.ConstraintName(), cy) == ""
    MOI.set(model, MOI.ConstraintName(), c, "")
    MOI.set(model, MOI.ConstraintName(), c2, "") # Shouldn't error with duplicate empty name
    MOI.set(model, MOI.ConstraintName(), cy, "")
    MOI.set(model, MOI.ConstraintName(), c, "Con0")
    @test MOI.get(model, MOI.ConstraintName(), c) == "Con0"
    MOI.set(model, MOI.ConstraintName(), c2, "Con0")
    # Lookup must fail when multiple constraints have the same name.
    @test_throws Exception MOI.get(model, MOI.ConstraintIndex, "Con0")
    @test_throws Exception MOI.get(model, typeof(c), "Con0")
    MOI.set(model, MOI.ConstraintName(), [c], ["Con1"])
    @test MOI.get(model, MOI.ConstraintName(), [c]) == ["Con1"]
    @test MOI.get(
        model,
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
        "Con1",
    ) == c
    @test MOI.get(
        model,
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
        "Con1",
    ) === nothing
    @test MOI.get(
        model,
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.GreaterThan{T}},
        "Con1",
    ) === nothing
    @test MOI.get(
        model,
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.LessThan{T}},
        "Con2",
    ) === nothing
    @test MOI.get(model, MOI.ConstraintIndex, "Con1") == c
    @test MOI.get(model, MOI.ConstraintIndex, "Con2") === nothing
    MOI.set(model, MOI.ConstraintName(), [c2, cy], ["Con2", "Con2"])
    @test_throws Exception MOI.get(model, MOI.ConstraintIndex, "Con2")
    @test_throws Exception MOI.get(model, typeof(c2), "Con2")
    @test_throws Exception MOI.get(model, typeof(cy), "Con2")
    MOI.set(model, MOI.ConstraintName(), cy, "Con4")
    for (i, ca) in zip([1, 2, 4], [c, c2, cy])
        namea = "Con$i"
        @test MOI.get(model, MOI.ConstraintName(), ca) == namea
        @test MOI.get(model, typeof(ca), namea) == ca
        @test MOI.get(model, MOI.ConstraintIndex, namea) == ca
        for cb in [c, c2, cy]
            if ca === cb
                continue
            end
            nameb = MOI.get(model, MOI.ConstraintName(), cb)
            @test MOI.get(model, typeof(cb), namea) === nothing
            @test MOI.get(model, typeof(ca), nameb) === nothing
        end
    end
    if _supports(config, MOI.delete)
        MOI.delete(model, v[2])
        @test MOI.get(model, MOI.VariableIndex, "Var2") === nothing
        MOI.delete(model, c)
        @test MOI.get(model, typeof(c), "Con1") === nothing
        @test MOI.get(model, MOI.ConstraintIndex, "Con1") === nothing
        MOI.delete(model, x)
        @test MOI.get(model, MOI.VariableIndex, "Varx") === nothing
        @test MOI.get(model, MOI.ConstraintIndex, "Con3") === nothing
        @test MOI.get(model, typeof(c2), "Con2") === c2
        @test MOI.get(model, MOI.ConstraintIndex, "Con2") === c2
        MOI.delete(model, y)
        @test MOI.get(model, typeof(cy), "Con4") === nothing
        @test MOI.get(model, MOI.ConstraintIndex, "Con4") === nothing
        for i in 1:4
            @test MOI.get(model, MOI.VariableIndex, "Vary$i") === nothing
        end
        MOI.set(model, MOI.ConstraintName(), c2, "Con4")
        @test MOI.get(model, typeof(c2), "Con4") === c2
        @test MOI.get(model, MOI.ConstraintIndex, "Con4") === c2
    end
    return
end

"""
    test_model_duplicate_VariableName(
        model::MOI.ModelLike,
        config::Config,
    )

Test duplicate variable names.
"""
function test_model_duplicate_VariableName(model::MOI.ModelLike, config::Config)
    (x, y, z) = MOI.add_variables(model, 3)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.VariableName(), y, "x")
    MOI.set(model, MOI.VariableName(), z, "z")
    @test MOI.get(model, MOI.VariableIndex, "z") == z
    @test_throws ErrorException MOI.get(model, MOI.VariableIndex, "x")
    MOI.set(model, MOI.VariableName(), y, "y")
    @test MOI.get(model, MOI.VariableIndex, "x") == x
    @test MOI.get(model, MOI.VariableIndex, "y") == y
    MOI.set(model, MOI.VariableName(), z, "x")
    @test_throws ErrorException MOI.get(model, MOI.VariableIndex, "x")
    if _supports(config, MOI.delete)
        MOI.delete(model, x)
        @test MOI.get(model, MOI.VariableIndex, "x") == z
    end
    return
end

"""
    test_model_duplicate_ScalarAffineFunction_ConstraintName(
        model::MOI.ModelLike,
        config::Config,
    )

Test duplicate names in ScalarAffineFunction constraints.
"""
function test_model_duplicate_ScalarAffineFunction_ConstraintName(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variables(model, 3)
    fs = [
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), xi)], T(0)) for
        xi in x
    ]
    c = MOI.add_constraints(model, fs, MOI.GreaterThan(T(0)))
    MOI.set(model, MOI.ConstraintName(), c[1], "x")
    MOI.set(model, MOI.ConstraintName(), c[2], "x")
    MOI.set(model, MOI.ConstraintName(), c[3], "z")
    @test MOI.get(model, MOI.ConstraintIndex, "z") == c[3]
    @test_throws ErrorException MOI.get(model, MOI.ConstraintIndex, "x")
    MOI.set(model, MOI.ConstraintName(), c[2], "y")
    @test MOI.get(model, MOI.ConstraintIndex, "x") == c[1]
    @test MOI.get(model, MOI.ConstraintIndex, "y") == c[2]
    MOI.set(model, MOI.ConstraintName(), c[3], "x")
    @test_throws ErrorException MOI.get(model, MOI.ConstraintIndex, "x")
    if _supports(config, MOI.delete)
        MOI.delete(model, c[1])
        @test MOI.get(model, MOI.ConstraintIndex, "x") == c[3]
    end
    return
end

"""
    test_model_is_valid(model::MOI.ModelLike, config::Config{T}) where {T}

Test various parts of `MOI.is_valid`.

Taken from https://github.com/jump-dev/MathOptInterfaceUtilities.jl/issues/41
"""
function test_model_is_valid(model::MOI.ModelLike, config::Config{T}) where {T}
    @requires MOI.supports_incremental_interface(model)
    v = MOI.add_variables(model, 2)
    @test MOI.is_valid(model, v[1])
    @test MOI.is_valid(model, v[2])
    x = MOI.add_variable(model)
    @test MOI.is_valid(model, x)
    if _supports(config, MOI.delete)
        MOI.delete(model, x)
        @test !MOI.is_valid(model, x)
    end
    cf = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T(1), v), T(0))
    @requires MOI.supports_constraint(model, typeof(cf), MOI.LessThan{T})
    c = MOI.add_constraint(model, cf, MOI.LessThan(T(1)))
    @test MOI.is_valid(model, c)
    SAF = MOI.ScalarAffineFunction
    @test !MOI.is_valid(
        model,
        MOI.ConstraintIndex{SAF{Float32},MOI.LessThan{Float32}}(1),
    )
    @test !MOI.is_valid(
        model,
        MOI.ConstraintIndex{SAF{Float32},MOI.LessThan{T}}(1),
    )
    @test !MOI.is_valid(
        model,
        MOI.ConstraintIndex{SAF{T},MOI.LessThan{Float32}}(1),
    )
    VQF = MOI.VectorQuadraticFunction
    @test !MOI.is_valid(
        model,
        MOI.ConstraintIndex{VQF{T},MOI.SecondOrderCone}(1),
    )
    return
end

"""
    test_model_empty(model::MOI.ModelLike, ::Config)

Test `MOI.empty` and `MOI.is_empty!`.
"""
function test_model_empty(model::MOI.ModelLike, ::Config)
    @test MOI.is_empty(model)
    x = MOI.add_variable(model)
    @test !MOI.is_empty(model)
    MOI.empty!(model)
    @test MOI.is_empty(model)
    return
end

"""
    test_model_copy_to_UnsupportedConstraint(model::MOI.ModelLike, ::Config)

Test an error is thrown when a constraint is unsupported.

!!! note
    This function uses the two-argument `MOI.optimize!`. This ensures that we
    test three cases:
     * models implementing the two-argument method
     * models using the generic fallback and erroring on `copy_to`
     * models using the generic fallback and erroring on `optimize!`.
"""
function test_model_copy_to_UnsupportedConstraint(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.EqualTo{T})
    @test !MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        UnknownScalarSet{T},
    )
    @test_throws(
        MOI.UnsupportedConstraint,
        MOI.optimize!(model, BadConstraintModel()),
    )
    return
end

"""
    test_model_copy_to_UnsupportedAttribute(model::MOI.ModelLike, ::Config)

Test an error is thrown when an attribute is unsupported.

!!! note
    This function uses the two-argument `MOI.optimize!`. This ensures that we
    test three cases:
     * models implementing the two-argument method
     * models using the generic fallback and erroring on `copy_to`
     * models using the generic fallback and erroring on `optimize!`.
"""
function test_model_copy_to_UnsupportedAttribute(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.EqualTo{T})
    # ModelAttribute
    @test !MOI.supports(model, UnknownModelAttribute())
    @test_throws(
        MOI.UnsupportedAttribute,
        MOI.optimize!(model, BadModelAttributeModel(T)),
    )
    # VariableAttribute
    @test !MOI.supports(model, UnknownVariableAttribute(), MOI.VariableIndex)
    @test_throws(
        MOI.UnsupportedAttribute,
        MOI.optimize!(model, BadVariableAttributeModel(T)),
    )
    # ConstraintAttribute
    @test !MOI.supports(
        model,
        UnknownConstraintAttribute(),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{T}},
    )
    @test_throws(
        MOI.UnsupportedAttribute,
        MOI.optimize!(model, BadConstraintAttributeModel(T)),
    )
    return
end

function test_model_supports_constraint_VariableIndex_EqualTo(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.EqualTo{T})
    # Pick a "bad" coefficient type that should fail tests.
    @test !MOI.supports_constraint(model, MOI.VariableIndex, MOI.EqualTo{UInt8})
    # Scalar-in-vector
    @test !MOI.supports_constraint(model, MOI.VariableIndex, MOI.Zeros)
    return
end

function test_model_supports_constraint_ScalarAffineFunction_EqualTo(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    # Pick a "bad" coefficient type that should fail tests.
    @test !MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{UInt8},
        MOI.EqualTo{UInt8},
    )
    return
end

function test_model_supports_constraint_VectorOfVariables_Nonnegatives(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Nonnegatives,
    )
    # Pick a "bad" coefficient type that should fail tests.
    @test !MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        UnknownVectorSet,
    )
    @test !MOI.supports_constraint(model, MOI.VectorOfVariables, MOI.EqualTo{T})
    return
end

"""
    test_model_ordered_indices(model::MOI.ModelLike, ::Config{T}) where {T}

Test whether the model returns ListOfVariableIndices and ListOfConstraintIndices
sorted by creation time.
"""
function test_model_ordered_indices(model::MOI.ModelLike, ::Config{T}) where {T}
    @requires MOI.supports_incremental_interface(model)
    v1 = MOI.add_variable(model)
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [v1]
    v2 = MOI.add_variable(model)
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [v1, v2]
    MOI.delete(model, v1)
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [v2]
    v3 = MOI.add_variable(model)
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [v2, v3]
    v4 = MOI.add_variable(model)
    @test MOI.get(model, MOI.ListOfVariableIndices()) == [v2, v3, v4]
    # Note: there are too many combinations to test, so we're just going to
    # check VariableIndex-in-LessThan and hope it works for the rest
    c1 = MOI.add_constraint(model, v2, MOI.LessThan(T(1)))
    @test c1.value == v2.value
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.LessThan{T}}(),
    ) == [c1]
    c2 = MOI.add_constraint(model, v3, MOI.LessThan(T(2)))
    @test c2.value == v3.value
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.LessThan{T}}(),
    ) == [c1, c2]
    MOI.delete(model, c1)
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.LessThan{T}}(),
    ) == [c2]
    c3 = MOI.add_constraint(model, v4, MOI.LessThan(T(3)))
    @test c3.value == v4.value
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.LessThan{T}}(),
    ) == [c2, c3]
    return
end

"""
    test_model_ScalarFunctionConstantNotZero(
        model::MOI.ModelLike,
        config::Config,
    )

Test adding a linear constraint with a non-zero function constant.

This should either work, or error with `MOI.ScalarFunctionConstantNotZero` if
the model does not support it.

To skip this test, pass `MOI.ScalarFunctionConstantNotZero` to the `exclude`
argument of [`Config`](@ref).
"""
function test_model_ScalarFunctionConstantNotZero(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.ScalarFunctionConstantNotZero)
    @requires MOI.supports_constraint(
        model,
        MOI.ScalarAffineFunction{T},
        MOI.EqualTo{T},
    )
    function _error(S, value)
        F = MOI.ScalarAffineFunction{T}
        return MOI.ScalarFunctionConstantNotZero{T,F,S}(value)
    end
    try
        f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], T(1))
        c = MOI.add_constraint(model, f, MOI.EqualTo(T(2)))
        if _supports(config, MOI.ConstraintFunction)
            @test MOI.get(model, MOI.ConstraintFunction(), c) ≈ f
        end
    catch err
        @test err == _error(MOI.EqualTo{T}, T(1))
    end
    try
        f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], T(2))
        c = MOI.add_constraint(model, f, MOI.GreaterThan(T(1)))
        if _supports(config, MOI.ConstraintFunction)
            @test MOI.get(model, MOI.ConstraintFunction(), c) ≈ f
        end
    catch err
        @test err == _error(MOI.GreaterThan{T}, T(2))
    end
    return
end

"""
    test_model_LowerBoundAlreadySet(
        model::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Test that setting a lower-bound twice throws `LowerBoundAlreadySet`.
"""
function test_model_LowerBoundAlreadySet(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{T},
    )
    @requires _supports(config, MOI.delete)
    x = MOI.add_variable(model)
    lb = T(0)
    sets = [MOI.EqualTo(lb), MOI.Interval(lb, lb)]
    set2 = MOI.GreaterThan(lb)
    for set1 in sets
        if MOI.supports_constraint(model, MOI.VariableIndex, typeof(set1))
            ci = MOI.add_constraint(model, x, set1)
            err = MOI.LowerBoundAlreadySet{typeof(set1),typeof(set2)}(x)
            @test_throws err MOI.add_constraint(model, x, set2)
            MOI.delete(model, ci)
            ci = MOI.add_constraint(model, x, set2)
            err = MOI.LowerBoundAlreadySet{typeof(set2),typeof(set1)}(x)
            @test_throws err MOI.add_constraint(model, x, set1)
            MOI.delete(model, ci)
        end
    end
    return
end

"""
    test_model_UpperBoundAlreadySet(
        model::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Test that setting an upper-bound twice throws `UpperBoundAlreadySet`.
"""
function test_model_UpperBoundAlreadySet(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(model, MOI.VariableIndex, MOI.LessThan{T})
    @requires _supports(config, MOI.delete)
    x = MOI.add_variable(model)
    ub = T(0)
    sets = [MOI.EqualTo(ub), MOI.Interval(ub, ub)]
    set2 = MOI.LessThan(ub)
    for set1 in sets
        if MOI.supports_constraint(model, MOI.VariableIndex, typeof(set1))
            ci = MOI.add_constraint(model, x, set1)
            err = MOI.UpperBoundAlreadySet{typeof(set1),typeof(set2)}(x)
            @test_throws err MOI.add_constraint(model, x, set2)
            MOI.delete(model, ci)
            ci = MOI.add_constraint(model, x, set2)
            err = MOI.UpperBoundAlreadySet{typeof(set2),typeof(set1)}(x)
            @test_throws err MOI.add_constraint(model, x, set1)
            MOI.delete(model, ci)
        end
    end
    return
end

"""
    test_model_delete(model::MOI.ModelLike, config::Config{T}) where {T}

Test various operations to do with deleting variables and constraints.
"""
function test_model_delete(model::MOI.ModelLike, config::Config{T}) where {T}
    @requires _supports(config, MOI.delete)
    x = MOI.add_variable(model)
    cx = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    y = MOI.add_variables(model, 4)
    cy = MOI.add_constraint(model, y, MOI.Nonpositives(4))
    @test MOI.is_valid(model, x)
    @test MOI.is_valid(model, y[1])
    @test MOI.is_valid(model, y[2])
    @test MOI.is_valid(model, y[3])
    @test MOI.is_valid(model, y[4])
    @test MOI.is_valid(model, cx)
    @test MOI.is_valid(model, cy)
    @test MOI.get(model, MOI.ConstraintFunction(), cx) == x
    @test MOI.get(model, MOI.ConstraintSet(), cx) == MOI.GreaterThan(T(0))
    @test MOI.get(model, MOI.ConstraintFunction(), cy) ==
          MOI.VectorOfVariables(y)
    @test MOI.get(model, MOI.ConstraintSet(), cy) == MOI.Nonpositives(4)
    @test Set(MOI.get(model, MOI.ListOfConstraintTypesPresent())) == Set([
        (MOI.VariableIndex, MOI.GreaterThan{T}),
        (MOI.VectorOfVariables, MOI.Nonpositives),
    ])
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.GreaterThan{T}}(),
    ) == [cx]
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonpositives}(),
    ) == [cy]
    MOI.delete(model, y[3])
    @test MOI.is_valid(model, x)
    @test MOI.is_valid(model, y[1])
    @test MOI.is_valid(model, y[2])
    @test !MOI.is_valid(model, y[3])
    @test MOI.is_valid(model, y[4])
    @test MOI.is_valid(model, cx)
    @test MOI.is_valid(model, cy)
    @test MOI.get(model, MOI.ConstraintFunction(), cx) == x
    @test MOI.get(model, MOI.ConstraintSet(), cx) == MOI.GreaterThan(T(0))
    @test MOI.get(model, MOI.ConstraintFunction(), cy) ==
          MOI.VectorOfVariables(y[[1, 2, 4]])
    @test MOI.get(model, MOI.ConstraintSet(), cy) == MOI.Nonpositives(3)
    @test Set(MOI.get(model, MOI.ListOfConstraintTypesPresent())) == Set([
        (MOI.VariableIndex, MOI.GreaterThan{T}),
        (MOI.VectorOfVariables, MOI.Nonpositives),
    ])
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.GreaterThan{T}}(),
    ) == [cx]
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonpositives}(),
    ) == [cy]
    MOI.delete(model, y[1])
    @test MOI.is_valid(model, x)
    @test !MOI.is_valid(model, y[1])
    @test MOI.is_valid(model, y[2])
    @test !MOI.is_valid(model, y[3])
    @test MOI.is_valid(model, y[4])
    @test MOI.is_valid(model, cx)
    @test MOI.is_valid(model, cy)
    @test MOI.get(model, MOI.ConstraintFunction(), cx) == x
    @test MOI.get(model, MOI.ConstraintSet(), cx) == MOI.GreaterThan(T(0))
    @test MOI.get(model, MOI.ConstraintFunction(), cy) ==
          MOI.VectorOfVariables(y[[2, 4]])
    @test MOI.get(model, MOI.ConstraintSet(), cy) == MOI.Nonpositives(2)
    @test Set(MOI.get(model, MOI.ListOfConstraintTypesPresent())) == Set([
        (MOI.VariableIndex, MOI.GreaterThan{T}),
        (MOI.VectorOfVariables, MOI.Nonpositives),
    ])
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.GreaterThan{T}}(),
    ) == [cx]
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonpositives}(),
    ) == [cy]
    MOI.delete(model, x)
    @test !MOI.is_valid(model, x)
    @test !MOI.is_valid(model, y[1])
    @test MOI.is_valid(model, y[2])
    @test !MOI.is_valid(model, y[3])
    @test MOI.is_valid(model, y[4])
    @test !MOI.is_valid(model, cx)
    @test MOI.is_valid(model, cy)
    @test MOI.get(model, MOI.ConstraintFunction(), cy) ==
          MOI.VectorOfVariables(y[[2, 4]])
    @test MOI.get(model, MOI.ConstraintSet(), cy) == MOI.Nonpositives(2)
    @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) ==
          [(MOI.VectorOfVariables, MOI.Nonpositives)]
    @test isempty(
        MOI.get(
            model,
            MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ),
    )
    @test MOI.get(
        model,
        MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonpositives}(),
    ) == [cy]
    MOI.delete(model, y[[2, 4]])
    @test !MOI.is_valid(model, x)
    @test !MOI.is_valid(model, y[1])
    @test !MOI.is_valid(model, y[2])
    @test !MOI.is_valid(model, y[3])
    @test !MOI.is_valid(model, y[4])
    @test !MOI.is_valid(model, cx)
    @test !MOI.is_valid(model, cy)
    @test isempty(MOI.get(model, MOI.ListOfConstraintTypesPresent()))
    @test isempty(
        MOI.get(
            model,
            MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.GreaterThan{T}}(),
        ),
    )
    @test isempty(
        MOI.get(
            model,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.Nonpositives,
            }(),
        ),
    )
end

"""
    test_model_ListOfConstraintAttributesSet(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test issue #1429: ConstraintName should only be included in
`ListOfConstraintAttributesSet` if it actually is set.
"""
function test_model_ListOfConstraintAttributesSet(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports(
        model,
        MOI.ConstraintName(),
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
    )
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    c = MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0)),
        MOI.EqualTo(T(1)),
    )
    MOI.set(model, MOI.ConstraintName(), c, "c")
    @test MOI.get(
        model,
        MOI.ListOfConstraintAttributesSet{
            MOI.ScalarAffineFunction{T},
            MOI.EqualTo{T},
        }(),
    ) == [MOI.ConstraintName()]
    @test MOI.get(
        model,
        MOI.ListOfConstraintAttributesSet{
            MOI.VariableIndex,
            MOI.GreaterThan{T},
        }(),
    ) == []
    return
end

"""
    test_model_ModelFilter_AbstractModelAttribute(
        src::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Tests `Utilities.ModelFilter` of `AbstractModelAttribute`.
"""
function test_model_ModelFilter_AbstractModelAttribute(
    src::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports(src, MOI.Name())
    MOI.set(src, MOI.Name(), "src")
    dest = MOI.Utilities.Model{T}()
    MOI.copy_to(dest, MOI.Utilities.ModelFilter(src) do item
        return item != MOI.Name()
    end)
    @test MOI.get(dest, MOI.Name()) == ""
    return
end

"""
    test_model_ModelFilter_AbstractVariableAttribute(
        src::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Tests `Utilities.ModelFilter` of `AbstractVariableAttribute`.
"""
function test_model_ModelFilter_AbstractVariableAttribute(
    src::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports(src, MOI.VariableName(), MOI.VariableIndex)
    @requires MOI.supports(src, MOI.VariablePrimalStart(), MOI.VariableIndex)
    x = MOI.add_variable(src)
    MOI.set(src, MOI.VariableName(), x, "x")
    MOI.set(src, MOI.VariablePrimalStart(), x, T(1))
    dest = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}())
    index_map = MOI.copy_to(dest, MOI.Utilities.ModelFilter(src) do item
        return item != MOI.VariableName()
    end)
    @test MOI.get(dest, MOI.VariableName(), index_map[x]) == ""
    @test MOI.get(dest, MOI.VariablePrimalStart(), index_map[x]) == T(1)
    return
end

"""
    test_model_ModelFilter_AbstractConstraintAttribute(
        src::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Tests `Utilities.ModelFilter` of `AbstractConstraintAttribute`.
"""
function test_model_ModelFilter_AbstractConstraintAttribute(
    src::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires(
        MOI.supports(
            src,
            MOI.ConstraintName(),
            MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives},
        ),
    )
    @requires(
        MOI.supports(
            src,
            MOI.ConstraintDualStart(),
            MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives},
        ),
    )
    @requires(
        MOI.supports_constraint(src, MOI.VectorOfVariables, MOI.Nonnegatives),
    )
    x = MOI.add_variable(src)
    c = MOI.add_constraint(src, MOI.VectorOfVariables([x]), MOI.Nonnegatives(1))
    MOI.set(src, MOI.ConstraintName(), c, "c")
    MOI.set(src, MOI.ConstraintDualStart(), c, T[1])
    dest = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{T}())
    index_map = MOI.copy_to(dest, MOI.Utilities.ModelFilter(src) do item
        if item isa MOI.AbstractConstraintAttribute
            return item != MOI.ConstraintName()
        end
        return true
    end)
    @test MOI.get(dest, MOI.ConstraintName(), index_map[c]) == ""
    @test MOI.get(dest, MOI.ConstraintDualStart(), index_map[c]) == T[1]
    return
end

"""
    test_model_ModelFilter_ListOfConstraintIndices(
        src::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Tests `Utilities.ModelFilter` of `ListOfConstraintIndices`.
"""
function test_model_ModelFilter_ListOfConstraintIndices(
    src::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires(
        MOI.supports_constraint(src, MOI.VariableIndex, MOI.GreaterThan{T}),
    )
    x = MOI.add_variables(src, 4)
    MOI.add_constraint.(src, x, MOI.GreaterThan(T(0)))
    dest = MOI.Utilities.Model{T}()
    index_map = MOI.copy_to(dest, MOI.Utilities.ModelFilter(src) do item
        if item isa MOI.ConstraintIndex
            return isodd(item.value)
        end
        return true
    end)
    @test MOI.get(dest, MOI.NumberOfVariables()) == 4
    @test MOI.get(
        dest,
        MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}(),
    ) == 2
    for xi in x
        @test haskey(index_map, xi)
        ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{T}}(xi.value)
        @test haskey(index_map, ci) == isodd(xi.value)
    end
    return
end

"""
    test_model_ModelFilter_ListOfConstraintTypesPresent(
        src::MOI.ModelLike,
        ::Config{T},
    ) where {T}

Tests `Utilities.ModelFilter` of `ListOfConstraintTypesPresent`.
"""
function test_model_ModelFilter_ListOfConstraintTypesPresent(
    src::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires(
        MOI.supports_constraint(src, MOI.VariableIndex, MOI.GreaterThan{T}),
    )
    @requires(MOI.supports_constraint(src, MOI.VariableIndex, MOI.LessThan{T}))
    x = MOI.add_variables(src, 4)
    MOI.add_constraint.(src, x, MOI.GreaterThan(T(0)))
    MOI.add_constraint.(src, x, MOI.LessThan(T(1)))
    dest = MOI.Utilities.Model{T}()
    _ = MOI.copy_to(
        dest,
        MOI.Utilities.ModelFilter(src) do item
            if item isa Tuple{Type,Type}
                return item == (MOI.VariableIndex, MOI.LessThan{T})
            end
            return true
        end,
    )
    @test MOI.get(dest, MOI.NumberOfVariables()) == 4
    attr = MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}()
    @test MOI.get(dest, attr) == 0
    attr = MOI.NumberOfConstraints{MOI.VariableIndex,MOI.LessThan{T}}()
    @test MOI.get(dest, attr) == 4
    return
end

function test_model_ListOfVariablesWithAttributeSet(
    model::MOI.ModelLike,
    ::Config,
)
    attr = MOI.VariableName()
    @requires MOI.supports(model, attr, MOI.VariableIndex)
    x = MOI.add_variables(model, 2)
    MOI.set(model, attr, x[2], "y")
    @test x[2] in MOI.get(model, MOI.ListOfVariablesWithAttributeSet(attr))
    return
end

version_added(::typeof(test_model_ListOfVariablesWithAttributeSet)) = v"1.22.0"

function test_model_ListOfConstraintsWithAttributeSet(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F, S = MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}
    attr = MOI.ConstraintName()
    @requires MOI.supports(model, attr, MOI.ConstraintIndex{F,S})
    x = MOI.add_variables(model, 2)
    c = MOI.add_constraint.(model, one(T) .* x, MOI.GreaterThan(zero(T)))
    MOI.set(model, attr, c[2], "y")
    ret = MOI.get(model, MOI.ListOfConstraintsWithAttributeSet{F,S}(attr))
    @test c[2] in ret
    return
end

function version_added(::typeof(test_model_ListOfConstraintsWithAttributeSet))
    return v"1.22.0"
end

function test_model_show(model::MOI.ModelLike, ::Config{T}) where {T}
    # We don't enforce any particular output.
    @test sprint(show, model) isa String
    return
end

version_added(::typeof(test_model_show)) = v"1.31.0"

function test_model_add_constrained_variable_tuple(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    F = MOI.VariableIndex
    set = (MOI.GreaterThan(zero(T)), MOI.LessThan(one(T)))
    @requires MOI.supports_add_constrained_variable(model, typeof(set))
    x, (c_l, c_u) = MOI.add_constrained_variable(model, set)
    @test c_l == MOI.ConstraintIndex{F,MOI.GreaterThan{T}}(x.value)
    @test c_u == MOI.ConstraintIndex{F,MOI.LessThan{T}}(x.value)
    @test MOI.get(model, MOI.ConstraintFunction(), c_l) == x
    @test MOI.get(model, MOI.ConstraintSet(), c_l) == set[1]
    @test MOI.get(model, MOI.ConstraintFunction(), c_u) == x
    @test MOI.get(model, MOI.ConstraintSet(), c_u) == set[2]
    return
end

version_added(::typeof(test_model_add_constrained_variable_tuple)) = v"1.34.0"

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintHermitianToSymmetricPSD

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_dimension_2()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.HermitianToSymmetricPSDBridge,
        """
        variables: a, b, c
        [1.0 * a + 2.0 * b, 3.0 * c, 4.0 * b, 5.0 * a] in HermitianPositiveSemidefiniteConeTriangle(2)
        """,
        """
        variables: a, b, c
        [1.0 * a + 2.0 * b, 3.0 * c, 4.0 * b, 0.0, -5.0 * a, 1.0 * a + 2.0 * b, 5.0 * a, 0.0, 3.0 * c, 4.0 * b] in PositiveSemidefiniteConeTriangle(4)
        """,
    )
    return
end

function test_dimension_3()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.HermitianToSymmetricPSDBridge,
        """
        variables: x11, x12, x22, x13, x23, x33, y12, y13, y23
        [x11, x12, x22, x13, x23, x33, y12, y13, y23] in HermitianPositiveSemidefiniteConeTriangle(3)
        """,
        """
        variables: x11, x12, x22, x13, x23, x33, y12, y13, y23
        [x11, x12, x22, x13, x23, x33, 0, -1 * y12, -1 * y13, x11, y12, 0, -1 * y23, x12, x22, y13, y23, 0, x13, x23, x33] in PositiveSemidefiniteConeTriangle(6)
        """,
    )
    return
end

function test_dimension_4()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.HermitianToSymmetricPSDBridge,
        """
        variables: x11, x12, x22, x13, x23, x33, x14, x24, x34, x44, y12, y13, y23, y14, y24, y34
        [x11, x12, x22, x13, x23, x33, x14, x24, x34, x44, y12, y13, y23, y14, y24, y34] in HermitianPositiveSemidefiniteConeTriangle(4)
        """,
        """
        variables: x11, x12, x22, x13, x23, x33, x14, x24, x34, x44, y12, y13, y23, y14, y24, y34
        [x11, x12, x22, x13, x23, x33, x14, x24, x34, x44, 0, -1 * y12, -1 * y13, -1 * y14, x11, y12, 0, -1 * y23, -1 * y24, x12, x22, y13, y23, 0, -1 * y34, x13, x23, x33, y14, y24, y34, 0, x14, x24, x34, x44] in PositiveSemidefiniteConeTriangle(8)
        """,
    )
    return
end

end  # module

TestConstraintHermitianToSymmetricPSD.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    RSOCtoPSDBridge{T} <: Bridges.Variable.AbstractBridge

`RSOCtoPSDBridge` implements the following reformulation:

 * ``||x||_2^2 \\le 2tu`` where ``t, u \\ge 0`` into ``Y \\succeq 0``, with the
   substitution rule:
   ``Y = \\left[\\begin{array}{c c}t & x^\\top \\\\ x & 2u \\mathbf{I}\\end{array}\\right].``

Additional bounds are added to ensure the off-diagonals of the ``2uI`` submatrix
are `0`, and linear constraints are added to ensure the diagonal of ``2uI``
takes the same values.

As a special case, if ``|x|| = 0``, then `RSOCtoPSDBridge` reformulates into
``(t, u) \\in \\mathbb{R}_+``.

## Source node

`RSOCtoPSDBridge` supports:

 * [`MOI.VectorOfVariables`](@ref) in [`MOI.RotatedSecondOrderCone`](@ref)

## Target nodes

`RSOCtoPSDBridge` creates:

 * One variable node that depends on the input dimension:
   * [`MOI.VectorOfVariables`](@ref) in [`MOI.Nonnegatives`](@ref) if dimension
     is `1` or `2`
   * [`MOI.VectorOfVariables`](@ref) in
   [`MOI.PositiveSemidefiniteConeTriangle`](@ref) otherwise
 * The constraint node [`MOI.VariableIndex`](@ref) in [`MOI.EqualTo`](@ref)
 * The constant node [`MOI.ScalarAffineFunction`](@ref) in [`MOI.EqualTo`](@ref)
"""
struct RSOCtoPSDBridge{T} <: AbstractBridge
    variables::Vector{MOI.VariableIndex}
    psd::Union{
        MOI.ConstraintIndex{
            MOI.VectorOfVariables,
            MOI.PositiveSemidefiniteConeTriangle,
        },
        MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives},
    }
    off_diag::Vector{MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{T}}}
    diag::Vector{
        MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
    }
end

const RSOCtoPSD{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{RSOCtoPSDBridge{T},OT}

# This bridge destorys a lot of structure and adding PSD variables is almost
# always undesirable. We give this bridge a high cost so that it is used only if
# necessary.
MOI.Bridges.bridging_cost(::Type{<:RSOCtoPSDBridge}) = 10.0

function bridge_constrained_variable(
    ::Type{RSOCtoPSDBridge{T}},
    model::MOI.ModelLike,
    set::MOI.RotatedSecondOrderCone,
) where {T}
    off_diag = MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{T}}[]
    diag = MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}[]
    # A special case: if there are no `x` variables, then a
    # RotatedSecondOrderCone is equivalent to [t, u] >= 0.
    if set.dimension <= 2
        variables, psd = MOI.add_constrained_variables(
            model,
            MOI.Nonnegatives(set.dimension),
        )
        return RSOCtoPSDBridge{T}(variables, psd, off_diag, diag)
    end
    psd_set = MOI.PositiveSemidefiniteConeTriangle((set.dimension - 1))
    variables, psd = MOI.add_constrained_variables(model, psd_set)
    zero_set = MOI.EqualTo(zero(T))
    k = 0
    for col in 1:(set.dimension-1), row in 1:col
        k += 1
        if row == 1 || col <= 2
            continue  # These are free variables
        elseif col == row
            # X[2, 2] - X[i, i] == 0 for i = 3:N
            f = MOI.Utilities.operate(-, T, variables[3], variables[k])
            push!(diag, MOI.add_constraint(model, f, zero_set))
        else
            push!(off_diag, MOI.add_constraint(model, variables[k], zero_set))
        end
    end
    return RSOCtoPSDBridge{T}(variables, psd, off_diag, diag)
end

function supports_constrained_variable(
    ::Type{<:RSOCtoPSDBridge},
    ::Type{MOI.RotatedSecondOrderCone},
)
    return true
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:RSOCtoPSDBridge})
    return Tuple{Type}[
        (MOI.PositiveSemidefiniteConeTriangle,),
        (MOI.Nonnegatives,),
    ]
end

function MOI.Bridges.added_constraint_types(
    ::Type{RSOCtoPSDBridge{T}},
) where {T}
    return Tuple{Type,Type}[
        (MOI.VariableIndex, MOI.EqualTo{T}),
        (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}),
    ]
end

# Attributes, Bridge acting as a model
function MOI.get(bridge::RSOCtoPSDBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.variables)
end

function MOI.get(bridge::RSOCtoPSDBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.variables)
end

function MOI.get(
    bridge::RSOCtoPSDBridge,
    ::MOI.NumberOfConstraints{MOI.VectorOfVariables,S},
)::Int64 where {S<:Union{MOI.PositiveSemidefiniteConeTriangle,MOI.Nonnegatives}}
    if bridge.psd isa MOI.ConstraintIndex{MOI.VectorOfVariables,S}
        return 1
    end
    return 0
end

function MOI.get(
    bridge::RSOCtoPSDBridge,
    ::MOI.ListOfConstraintIndices{MOI.VectorOfVariables,S},
) where {S<:Union{MOI.PositiveSemidefiniteConeTriangle,MOI.Nonnegatives}}
    if bridge.psd isa MOI.ConstraintIndex{MOI.VectorOfVariables,S}
        return [bridge.psd]
    end
    return MOI.ConstraintIndex{MOI.VectorOfVariables,S}[]
end

function MOI.get(
    bridge::RSOCtoPSDBridge{T},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.EqualTo{T}},
)::Int64 where {T}
    return length(bridge.off_diag)
end

function MOI.get(
    bridge::RSOCtoPSDBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.EqualTo{T}},
) where {T}
    return copy(bridge.off_diag)
end

function MOI.get(
    bridge::RSOCtoPSDBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return length(bridge.diag)
end

function MOI.get(
    bridge::RSOCtoPSDBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return copy(bridge.diag)
end

# References
function MOI.delete(model::MOI.ModelLike, bridge::RSOCtoPSDBridge)
    for ci in bridge.diag
        MOI.delete(model, ci)
    end
    MOI.delete(model, bridge.variables)
    return
end

# Attributes, Bridge acting as a constraint

function MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, bridge::RSOCtoPSDBridge)
    CI = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives}
    if bridge.psd isa CI
        return MOI.RotatedSecondOrderCone(length(bridge.variables))
    end
    return MOI.RotatedSecondOrderCone(length(bridge.diag) + 3)
end

function _variable_map(bridge::RSOCtoPSDBridge, i::MOI.Bridges.IndexInVector)
    CI = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives}
    if bridge.psd isa CI
        return i.value
    elseif i.value == 1
        return 1
    elseif i.value == 2
        return 3
    else
        return MOI.Utilities.trimap(1, i.value - 1)
    end
end

function _variable(bridge::RSOCtoPSDBridge, i::MOI.Bridges.IndexInVector)
    return bridge.variables[_variable_map(bridge, i)]
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::RSOCtoPSDBridge,
)
    values = MOI.get(model, attr, bridge.psd)
    set = MOI.get(model, MOI.ConstraintSet(), bridge)
    n = MOI.dimension(set)
    primal = zeros(n)
    for i in 1:n
        primal[i] = values[_variable_map(bridge, MOI.Bridges.IndexInVector(i))]
    end
    if n >= 2
        primal[2] /= 2
    end
    return primal
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    bridge::RSOCtoPSDBridge,
)
    values = MOI.get(model, attr, bridge.psd)
    n = MOI.dimension(MOI.get(model, MOI.ConstraintSet(), bridge))
    dual = zeros(n)
    for i in 1:n
        dual[i] = values[_variable_map(bridge, MOI.Bridges.IndexInVector(i))]
    end
    for ci in bridge.diag
        dual[2] += MOI.get(model, attr, ci)
    end
    # For `i = 2`, we multiply by 2 because it is `2u`.
    # For `i > 2`, we multiply by 2 because to account for the difference
    # of scalar product `MOI.Utilities.set_dot`.
    for i in 2:length(dual)
        dual[i] *= 2
    end
    return dual
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    ::Type{<:RSOCtoPSDBridge},
)
    return MOI.supports(model, attr, MOI.VariableIndex)
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.VariablePrimal,MOI.VariablePrimalStart},
    bridge::RSOCtoPSDBridge,
    i::MOI.Bridges.IndexInVector,
)
    value = MOI.get(model, attr, _variable(bridge, i))
    if value !== nothing && i.value == 2
        return value / 2
    end
    return value
end

_u_start_values(::Nothing) = nothing, nothing
_u_start_values(value::T) where {T} = 2 * value, zero(T)

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    bridge::RSOCtoPSDBridge{T},
    value,
    i::MOI.Bridges.IndexInVector,
) where {T}
    if i.value != 2
        MOI.set(model, attr, _variable(bridge, i), value)
        return
    end
    diag_value, offdiag_value = _u_start_values(value)
    n = length(bridge.variables)
    for col in 2:MOI.Utilities.side_dimension_for_vectorized_dimension(n)
        for row in 2:col
            k = MOI.Utilities.trimap(row, col)
            v = row == col ? diag_value : offdiag_value
            MOI.set(model, attr, bridge.variables[k], v)
        end
    end
    return
end

function MOI.Bridges.bridged_function(
    bridge::RSOCtoPSDBridge{T},
    i::MOI.Bridges.IndexInVector,
) where {T}
    func = _variable(bridge, i)
    if i.value == 2
        return MOI.Utilities.operate(/, T, func, convert(T, 2))
    end
    return convert(MOI.ScalarAffineFunction{T}, func)
end

function unbridged_map(
    bridge::RSOCtoPSDBridge{T},
    vi::MOI.VariableIndex,
    i::MOI.Bridges.IndexInVector,
) where {T}
    if i.value == 2
        func = MOI.Utilities.operate(*, T, convert(T, 2), vi)
        return (_variable(bridge, i) => func,)
    end
    return (_variable(bridge, i) => convert(MOI.ScalarAffineFunction{T}, vi),)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableMap

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

struct VariableDummyBridge <: MOI.Bridges.Variable.AbstractBridge
    id::Int
end

function MOI.Bridges.Variable.unbridged_map(
    ::VariableDummyBridge,
    ::MOI.VariableIndex,
)
    return nothing
end

function test_empty()
    map = MOI.Bridges.Variable.Map()
    @test isempty(map)
    @test !MOI.Bridges.Variable.has_bridges(map)
    @test isempty(keys(map))
    return
end

"""
    test_map()

TODO(odow): this test is too intertwined. It should be refactored into something
simpler.
"""
function test_map()
    map = MOI.Bridges.Variable.Map()
    b1 = VariableDummyBridge(1)
    set1 = MOI.EqualTo(0.0)
    F1 = MOI.VariableIndex
    S1 = typeof(set1)
    v1, c1 = MOI.Bridges.Variable.add_key_for_bridge(map, () -> b1, set1)
    MOI.is_valid(map, c1)
    cannot_unbridge_err = MOI.GetAttributeNotAllowed(
        MOI.ConstraintFunction(),
        "Cannot unbridge function because some variables are bridged by variable" *
        " bridges that do not support reverse mapping, for example, `ZerosBridge`.",
    )
    @test v1.value == c1.value == -1
    @test MOI.Bridges.Variable.constraint(map, v1) == c1
    @test MOI.Bridges.Variable.length_of_vector_of_variables(map, v1) == 0
    @test haskey(map, v1)
    @test map[v1] == b1
    @test MOI.Bridges.Variable.constrained_set(map, v1) == S1
    @test MOI.Bridges.Variable.number_with_set(map, S1) == 1
    @test MOI.Bridges.Variable.constraints_with_set(map, S1) == [c1]
    @test MOI.Bridges.Variable.function_for(map, c1) == v1
    @test_throws cannot_unbridge_err MOI.Bridges.Variable.unbridged_function(
        map,
        MOI.VariableIndex(1),
    )

    @test MOI.Bridges.Variable.number_of_variables(map) == 1
    @test MOI.Bridges.Variable.list_of_constraint_types(map) == Set([(F1, S1)])
    @test length(map) == 1
    @test !isempty(map)
    @test MOI.Bridges.Variable.has_bridges(map)
    @test collect(keys(map)) == [v1]
    @test collect(values(map)) == [b1]

    b2 = VariableDummyBridge(2)
    set2 = MOI.Zeros(4)
    F2 = MOI.VectorOfVariables
    S2 = typeof(set2)
    v2, c2 = MOI.Bridges.Variable.add_keys_for_bridge(
        map,
        () -> b2,
        set2,
        ci -> true,
    )
    MOI.is_valid(map, c2)
    @test v2[1].value == -2
    @test c2.value == -1
    @test MOI.Bridges.Variable.has_keys(map, v2)
    @test !MOI.Bridges.Variable.has_keys(map, v2[4:-1:1])
    for i in 1:4
        @test MOI.Bridges.Variable.constraint(map, v2[i]) == c2
        @test haskey(map, v2[i])
        @test map[v2[i]] == b2
        @test MOI.Bridges.Variable.constrained_set(map, v2[i]) == S2
        @test MOI.Bridges.Variable.length_of_vector_of_variables(map, v2[i]) ==
              4
        @test MOI.Bridges.Variable.index_in_vector_of_variables(map, v2[i]) ==
              MOI.Bridges.IndexInVector(i)
    end
    @test MOI.Bridges.Variable.number_with_set(map, S2) == 1
    @test MOI.Bridges.Variable.constraints_with_set(map, S2) == [c2]
    @test MOI.Bridges.Variable.function_for(map, c2) ==
          MOI.VectorOfVariables(v2)
    @test_throws cannot_unbridge_err MOI.Bridges.Variable.unbridged_function(
        map,
        MOI.VariableIndex(1),
    )

    @test MOI.Bridges.Variable.number_of_variables(map) == 5
    @test MOI.Bridges.Variable.list_of_constraint_types(map) ==
          Set([(F1, S1), (F2, S2)])
    @test length(map) == 2
    @test !isempty(map)
    @test MOI.Bridges.Variable.has_bridges(map)
    @test collect(keys(map)) == [v1; v2]
    @test collect(values(map)) == [b1, b2]

    b3 = VariableDummyBridge(3)
    set3 = MOI.Zeros(0)
    v3, c3 = MOI.Bridges.Variable.add_keys_for_bridge(
        map,
        () -> b3,
        set3,
        ci -> true,
    )

    @test isempty(v3)
    @test c3.value == 0
    bridges = collect(values(map))
    @test sort([b.id for b in bridges]) == 1:2
    elements = sort(collect(map), by = el -> el.second.id)
    @test elements[1].first == v1
    @test elements[1].second == b1
    @test elements[2].first == v2[1]
    @test elements[2].second == b2

    delete!(map, v1)
    @test MOI.Bridges.Variable.number_of_variables(map) == 4
    @test length(map) == 1
    @test !isempty(map)
    @test MOI.Bridges.Variable.has_bridges(map)
    elements = collect(map)
    @test elements[1].first == v2[1]
    @test elements[1].second == b2
    @test MOI.Bridges.Variable.number_with_set(map, S1) == 0
    @test MOI.Bridges.Variable.number_with_set(map, S2) == 1
    @test isempty(MOI.Bridges.Variable.constraints_with_set(map, S1))
    @test MOI.Bridges.Variable.constraints_with_set(map, S2) == [c2]
    @test MOI.Bridges.Variable.list_of_constraint_types(map) == Set([(F2, S2)])
    @test collect(keys(map)) == v2
    @test collect(values(map)) == [b2]
    @test !haskey(map, v1)
    @test MOI.Bridges.Variable.has_keys(map, v2)

    rev_v2 = reverse(v2)
    err = ArgumentError(
        "`$rev_v2` is not a valid key vector as returned by `add_keys_for_bridge`.",
    )
    @test_throws err delete!(map, rev_v2)

    delete!(map, v2[3])
    left = [1, 2, 4]
    @test MOI.Bridges.Variable.number_of_variables(map) == 3
    @test length(map) == 1
    @test !isempty(map)
    @test MOI.Bridges.Variable.has_bridges(map)
    elements = collect(map)
    @test elements[1].first == v2[1]
    @test elements[1].second == b2
    @test MOI.Bridges.Variable.number_with_set(map, S1) == 0
    @test MOI.Bridges.Variable.number_with_set(map, S2) == 1
    @test isempty(MOI.Bridges.Variable.constraints_with_set(map, S1))
    @test MOI.Bridges.Variable.constraints_with_set(map, S2) == [c2]
    @test MOI.Bridges.Variable.list_of_constraint_types(map) == Set([(F2, S2)])
    @test collect(keys(map)) == v2[left]
    @test collect(values(map)) == [b2]
    @test !haskey(map, v1)
    @test !haskey(map, v2[3])
    @test !MOI.Bridges.Variable.has_keys(map, v2)
    @test MOI.Bridges.Variable.has_keys(map, v2[left])
    for (j, i) in enumerate(left)
        @test MOI.Bridges.Variable.constraint(map, v2[i]) == c2
        @test haskey(map, v2[i])
        @test map[v2[i]] == b2
        @test MOI.Bridges.Variable.constrained_set(map, v2[i]) == S2
        @test MOI.Bridges.Variable.length_of_vector_of_variables(map, v2[i]) ==
              3
        @test MOI.Bridges.Variable.index_in_vector_of_variables(map, v2[i]) ==
              MOI.Bridges.IndexInVector(j)
    end
    @test MOI.Bridges.Variable.function_for(map, c2) ==
          MOI.VectorOfVariables(v2[left])

    delete!(map, v2[1])
    left = [2, 4]
    @test MOI.Bridges.Variable.number_of_variables(map) == 2
    @test length(map) == 1
    @test !isempty(map)
    @test MOI.Bridges.Variable.has_bridges(map)
    elements = collect(map)
    @test elements[1].first == v2[1]
    @test elements[1].second == b2
    @test MOI.Bridges.Variable.number_with_set(map, S1) == 0
    @test MOI.Bridges.Variable.number_with_set(map, S2) == 1
    @test isempty(MOI.Bridges.Variable.constraints_with_set(map, S1))
    @test MOI.Bridges.Variable.constraints_with_set(map, S2) == [c2]
    @test MOI.Bridges.Variable.list_of_constraint_types(map) == Set([(F2, S2)])
    @test collect(keys(map)) == v2[left]
    @test collect(values(map)) == [b2]
    @test !haskey(map, v1)
    @test !haskey(map, v2[1])
    @test !haskey(map, v2[3])
    @test !MOI.Bridges.Variable.has_keys(map, v2)
    @test !MOI.Bridges.Variable.has_keys(map, v2[[2, 3, 4]])
    @test !MOI.Bridges.Variable.has_keys(map, v2[[1, 2, 4]])
    @test MOI.Bridges.Variable.has_keys(map, v2[left])
    for (j, i) in enumerate(left)
        @test MOI.Bridges.Variable.constraint(map, v2[i]) == c2
        @test haskey(map, v2[i])
        @test map[v2[i]] == b2
        @test MOI.Bridges.Variable.constrained_set(map, v2[i]) == S2
        @test MOI.Bridges.Variable.length_of_vector_of_variables(map, v2[i]) ==
              2
        @test MOI.Bridges.Variable.index_in_vector_of_variables(map, v2[i]) ==
              MOI.Bridges.IndexInVector(j)
    end
    @test MOI.Bridges.Variable.function_for(map, c2) ==
          MOI.VectorOfVariables(v2[left])

    delete!(map, v2[left])
    @test MOI.Bridges.Variable.number_of_variables(map) == 0
    @test length(map) == 0
    @test isempty(map)
    @test MOI.Bridges.Variable.has_bridges(map)
    @test isempty(collect(map))
    @test MOI.Bridges.Variable.number_with_set(map, S1) == 0
    @test MOI.Bridges.Variable.number_with_set(map, S2) == 0
    @test isempty(MOI.Bridges.Variable.constraints_with_set(map, S1))
    @test isempty(MOI.Bridges.Variable.constraints_with_set(map, S2))
    @test isempty(MOI.Bridges.Variable.list_of_constraint_types(map))
    @test isempty(keys(map))
    @test isempty(values(map))
    @test !haskey(map, v1)
    @test !MOI.Bridges.Variable.has_keys(map, v2)
    @test !MOI.Bridges.Variable.has_keys(map, v2[left])
    return
end

function test_EmptyMap()
    S1 = MOI.EqualTo{Float64}
    S2 = MOI.Zeros
    map = MOI.Bridges.Variable.EmptyMap()
    empty!(map)
    @test isempty(map)
    @test length(map) == 0
    @test isempty(keys(map))
    @test isempty(values(map))
    @test !MOI.Bridges.Variable.has_bridges(map)
    @test iszero(MOI.Bridges.Variable.number_of_variables(map))
    @test iszero(MOI.Bridges.Variable.number_with_set(map, S1))
    @test iszero(MOI.Bridges.Variable.number_with_set(map, S2))
    @test isempty(MOI.Bridges.Variable.constraints_with_set(map, S1))
    @test isempty(MOI.Bridges.Variable.constraints_with_set(map, S2))
    c1 = MOI.ConstraintIndex{MOI.VariableIndex,S1}(1)
    @test !MOI.is_valid(map, c1)
    c2 = MOI.ConstraintIndex{MOI.VectorOfVariables,S2}(1)
    @test !MOI.is_valid(map, c2)
    @test sprint(show, map) == ""
    return
end

function test_double_variable_bound()
    map = MOI.Bridges.Variable.Map()
    b1 = VariableDummyBridge(1)
    set1 = MOI.EqualTo(0.0)
    v1, c1 = MOI.Bridges.Variable.add_key_for_bridge(map, () -> b1, set1)
    MOI.is_valid(map, c1)
    MOI.add_constraint(map, v1, MOI.Integer())
    cint = MOI.ConstraintIndex{typeof(v1),MOI.Integer}(v1.value)
    MOI.delete(map, cint)
    set2 = MOI.LessThan(1.0)
    err = MOI.UpperBoundAlreadySet{typeof(set1),typeof(set2)}(v1)
    @test_throws err MOI.add_constraint(map, v1, set2)
    return
end

end  # module

TestVariableMap.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

include("Nonlinear.jl")
include("ReverseAD.jl")
include("SymbolicAD.jl")

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# This file contains the implementation of different methods for the
# `get_fallback` function. These methods can be used by solver wrappers as
# fallbacks for implementing the `get` method when the solver API does not
# provide the required result. For instance, if the solver does not provide the
# value of the constraints, the solver wrapper can write
# ```julia
# function MOI.get(model::Optimizer, attr::MOI.ConstraintPrimal,
#                  ci::MOI.ConstraintIndex)
#     return MOIU.get_fallback(model, attr, ci)
# end
# ```

"""
    is_ray(status::MOI.ResultStatusCode)

Returnn `true` if `status` is `INFEASIBILITY_CERTIFICATE` or
    `NEARLY_INFEASIBILITY_CERTIFICATE`.
"""
function is_ray(status::MOI.ResultStatusCode)
    return status == MOI.INFEASIBILITY_CERTIFICATE ||
           status == MOI.NEARLY_INFEASIBILITY_CERTIFICATE
end

# MOI.ObjectiveValue

"""
    get_fallback(model::MOI.ModelLike, ::MOI.ObjectiveValue)

Compute the objective function value using the `VariablePrimal` results and
the `ObjectiveFunction` value.
"""
function get_fallback(model::MOI.ModelLike, attr::MOI.ObjectiveValue)
    MOI.check_result_index_bounds(model, attr)
    F = MOI.get(model, MOI.ObjectiveFunctionType())
    f = MOI.get(model, MOI.ObjectiveFunction{F}())
    obj = eval_variables(model, f) do vi
        return MOI.get(model, MOI.VariablePrimal(attr.result_index), vi)
    end
    if is_ray(MOI.get(model, MOI.PrimalStatus()))
        # Dual infeasibility certificates do not include the primal
        # objective constant.
        obj -= MOI.constant(f, typeof(obj))
    end
    return obj
end

# MOI.DualObjectiveValue

"""
    get_fallback(
        model::MOI.ModelLike,
        ::MOI.DualObjectiveValue,
        ::Type{T},
    )::T where {T}

Compute the dual objective value of type `T` using the `ConstraintDual` results
and the `ConstraintFunction` and `ConstraintSet` values.

Note that the nonlinear part of the model is ignored.
"""
function get_fallback(
    model::MOI.ModelLike,
    attr::MOI.DualObjectiveValue,
    ::Type{T},
)::T where {T}
    MOI.check_result_index_bounds(model, attr)
    value = zero(T) # sum will not work if there are zero constraints
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        value += _dual_objective_value(model, F, S, T, attr.result_index)::T
    end
    if MOI.get(model, MOI.ObjectiveSense()) != MOI.MAX_SENSE
        value = -value
    end
    if !is_ray(MOI.get(model, MOI.DualStatus()))
        # The objective constant should not be present in rays
        F = MOI.get(model, MOI.ObjectiveFunctionType())
        f = MOI.get(model, MOI.ObjectiveFunction{F}())
        value += MOI.constant(f, T)
    end
    return value::T
end

function _dual_objective_value(
    model::MOI.ModelLike,
    ::Type{F},
    ::Type{S},
    ::Type{T},
    result_index::Integer,
)::T where {T,F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    value = zero(T)
    if F == variable_function_type(S) && !_variable_set_in_dual_objective(S)
        # Early return. This is a constraint like x in R_+, so no contribution
        # appears in the dual objective.
        return value
    end
    for ci in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        constant = MOI.constant(MOI.get(model, MOI.ConstraintFunction(), ci), T)
        set = MOI.get(model, MOI.ConstraintSet(), ci)
        dual = MOI.get(model, MOI.ConstraintDual(result_index), ci)
        value += _dual_objective_dot(constant, dual, set)
    end
    return value
end

_variable_set_in_dual_objective(::Type{<:MOI.AbstractSet}) = false

_variable_set_in_dual_objective(::Type{<:MOI.EqualTo}) = true

_variable_set_in_dual_objective(::Type{<:MOI.GreaterThan}) = true

_variable_set_in_dual_objective(::Type{<:MOI.LessThan}) = true

_variable_set_in_dual_objective(::Type{<:MOI.Interval}) = true

_variable_set_in_dual_objective(::Type{<:MOI.HyperRectangle}) = true

_dual_objective_dot(x, y, set) = set_dot(x, y, set)

_dual_objective_dot(x, y, set::MOI.EqualTo) = (x - set.value) * y

_dual_objective_dot(x, y, set::MOI.LessThan) = (x - set.upper) * y

_dual_objective_dot(x, y, set::MOI.GreaterThan) = (x - set.lower) * y

function _dual_objective_dot(x, y, set::MOI.Interval)
    if isfinite(set.lower) && (!isfinite(set.upper) || y > zero(y))
        return (x - set.lower) * y
    elseif isfinite(set.upper) && (!isfinite(set.lower) || y < zero(y))
        return (x - set.upper) * y
    end
    return x * y
end

function _dual_objective_dot(x, y, set::MOI.HyperRectangle)
    @assert length(x) == length(y) == MOI.dimension(set)
    ret = zero(eltype(x))
    for (xi, yi, li, ui) in zip(x, y, set.lower, set.upper)
        if isfinite(li) && (!isfinite(ui) || yi > zero(yi))
            ret += (xi - li) * yi
        elseif isfinite(ui) && (!isfinite(li) || yi < zero(yi))
            ret += (xi - ui) * yi
        else
            ret += xi * yi
        end
    end
    return ret
end

# MOI.ConstraintPrimal

"""
    get_fallback(
        model::MOI.ModelLike,
        ::MOI.ConstraintPrimal,
        constraint_index::MOI.ConstraintIndex,
    )

Compute the value of the function of the constraint of index `constraint_index`
using the `VariablePrimal` results and the `ConstraintFunction` values.
"""
function get_fallback(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    idx::MOI.ConstraintIndex,
)
    MOI.check_result_index_bounds(model, attr)
    # If there is an error getting ConstraintFunction, we instead want to
    # re-throw the attribute for ConstraintPrimal, not ConstraintFunction.
    f = MOI.get(model, MOI.ConstraintFunction(), idx)
    c = eval_variables(model, f) do vi
        return MOI.get(model, MOI.VariablePrimal(attr.result_index), vi)
    end
    if is_ray(MOI.get(model, MOI.PrimalStatus()))
        c -= MOI.constant(f, typeof(c))
    end
    return c
end

# MOI.ConstraintDual

# In the primal we have
#
#   min a_0' x + b_0
#       A_i  x + b_i in C_i for all i
#
# In the dual we have
#
#   max b_0 - sum b_i' y
#       a_0 - sum A_i* y_i = 0
#                      y_i in C_i* for all i
#
# where A_i* is the adjoint operator of the linear operator A_i. That is, A*
# is the linear operator such that
#
#   ⟨A x, y⟩_{C_i} = ⟨x, A* y⟩_Rn
#
# where
#
# * ⟨., .⟩_Rn is the standard scalar product over Rn: ⟨., .⟩_Rn and
# * ⟨., .⟩_{C_i} is the scalar product `set_dot` defined for the set C_i
#
# Suppose we want to get the constraint variable of a variable-wise constraint:
#
#   A_j x in C_j
#
# where A_j is zero except on a submatrix which is the identity.
#
# We have
#
#   A_j* y_j = a_0 - sum_(i != j) A_i* y_i
#
# Thus to get the dual y_j, we simply have to compute the right-hand side and
# then invert A_j*.
#
# To get the kth element of A_i* y_i we need to compute
#
#   ⟨e_k, A_i* y_i⟩_Rn = ⟨A_i e_k, y_i⟩_{C_i}.
#
# A_i e_k is computed using `_variable_coefficient` and then it is combined with
# the dual y_i with `set_dot`.
#
# Once A_j* y_j is obtained, we invert A_j* with `dot_coefficients`.

function _variable_coefficient(
    func::MOI.ScalarAffineFunction{T},
    vi::MOI.VariableIndex,
    value_fn::Any,
) where {T}
    coef = zero(T)
    for term in func.terms
        if term.variable == vi
            coef += term.coefficient
        end
    end
    return coef
end

function _variable_coefficient(
    func::MOI.VectorAffineFunction{T},
    vi::MOI.VariableIndex,
    value_fn::Any,
) where {T}
    coef = zeros(T, MOI.output_dimension(func))
    for term in func.terms
        if term.scalar_term.variable == vi
            coef[term.output_index] += term.scalar_term.coefficient
        end
    end
    return coef
end

function _variable_coefficient(
    func::MOI.ScalarQuadraticFunction{T},
    vi::MOI.VariableIndex,
    value_fn::F,
) where {T,F<:Function}
    coef = zero(T)
    # `vi`'th row of `Qx + a` where `func` is `x'Qx/2 + a'x + b`.
    for term in func.affine_terms
        if term.variable == vi
            coef += term.coefficient
        end
    end
    for term in func.quadratic_terms
        if term.variable_1 == vi
            coef += term.coefficient * value_fn(term.variable_2)
        elseif term.variable_2 == vi
            coef += term.coefficient * value_fn(term.variable_1)
        end
    end
    return coef
end

function _variable_coefficient(
    func::MOI.VectorQuadraticFunction{T},
    vi::MOI.VariableIndex,
    value_fn::F,
) where {T,F<:Function}
    coef = zeros(T, MOI.output_dimension(func))
    # `vi`'th row of `Qx + a` where `func` is `x'Qx/2 + a'x + b`.
    for aff_term in func.affine_terms
        if aff_term.scalar_term.variable == vi
            coef[aff_term.output_index] += aff_term.scalar_term.coefficient
        end
    end
    for q_term in func.quadratic_terms
        index, term = q_term.output_index, q_term.scalar_term
        if term.variable_1 == vi
            coef[index] += term.coefficient * value_fn(term.variable_2)
        elseif q_term.scalar_term.variable_2 == vi
            coef[index] += term.coefficient * value_fn(term.variable_1)
        end
    end
    return coef
end

function _variable_dual(
    ::Type{T},
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    vi::MOI.VariableIndex,
    ci::MOI.ConstraintIndex{
        <:Union{
            MOI.ScalarAffineFunction,
            MOI.ScalarQuadraticFunction,
            MOI.VectorAffineFunction,
            MOI.VectorQuadraticFunction,
        },
    },
) where {T}
    func = MOI.get(model, MOI.ConstraintFunction(), ci)
    set = MOI.get(model, MOI.ConstraintSet(), ci)
    primal = MOI.VariablePrimal(attr.result_index)
    coef = _variable_coefficient(func, vi, vi -> MOI.get(model, primal, vi))
    dual = MOI.get(model, attr, ci)
    return set_dot(coef, dual, set)
end

function _variable_dual(
    ::Type{T},
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex,
    vi::MOI.VariableIndex,
    ::Type{F},
    ::Type{S},
) where {T,F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    dual = zero(T)
    for constraint_index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        dual += _variable_dual(T, model, attr, vi, constraint_index)
    end
    return dual
end

function _variable_dual(
    ::Type{T},
    model::MOI.ModelLike,
    ::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex,
    vi::MOI.VariableIndex,
    ::Type{F},
    ::Type{S},
) where {T,F<:Union{MOI.VariableIndex,MOI.VectorOfVariables},S<:MOI.AbstractSet}
    for constraint_index in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        if constraint_index == ci
            continue
        end
        func = MOI.get(model, MOI.ConstraintFunction(), constraint_index)
        if (F == MOI.VariableIndex && func == vi) ||
           (F == MOI.VectorOfVariables && vi in func.variables)
            error(
                "Fallback getter for variable constraint dual does not",
                " support other variable-wise constraints on the variable.",
                " Please report this issue to the solver wrapper package.",
            )
        end
    end
    return zero(T)
end

function _variable_dual(
    ::Type{T},
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex,
    vi::MOI.VariableIndex,
) where {T}
    ray = is_ray(MOI.get(model, MOI.DualStatus()))
    dual = zero(T)
    if !ray
        sense = MOI.get(model, MOI.ObjectiveSense())
        # Dual definition for maximization problem corresponds to dual
        # definition for minimization problem with flipped objective in MOI
        sign = sense == MOI.MAX_SENSE ? T(-1) : T(1)
        F = MOI.get(model, MOI.ObjectiveFunctionType())
        obj_attr = MOI.ObjectiveFunction{F}()
        if F == MOI.VariableIndex
            if MOI.get(model, obj_attr) == vi
                dual += sign
            end
        elseif F <: MOI.ScalarAffineFunction
            f = MOI.get(model, obj_attr)
            dual += sign * _variable_coefficient(f, vi, nothing)
        elseif F <: MOI.ScalarQuadraticFunction
            f = MOI.get(model, obj_attr)
            primal_attr = MOI.VariablePrimal(attr.result_index)
            dual +=
                sign * _variable_coefficient(
                    f,
                    vi,
                    vi -> MOI.get(model, primal_attr, vi),
                )
        else
            error(
                "Fallback getter for variable constraint dual does not",
                " support objective function of type $F.",
                " Please report this issue to the solver wrapper package.",
            )
        end
    end
    for (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
        dual -= _variable_dual(T, model, attr, ci, vi, F, S)
    end
    return dual
end

function _variable_dual(
    ::Type{T},
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{MOI.VectorOfVariables},
    func::MOI.VectorOfVariables,
) where {T}
    dual = map(vi -> _variable_dual(T, model, attr, ci, vi), func.variables)
    set = MOI.get(model, MOI.ConstraintSet(), ci)
    return dot_coefficients(dual, set)
end

"""
    get_fallback(
        model::MOI.ModelLike,
        attr::MOI.ConstraintDual,
        ci::MOI.ConstraintIndex{Union{MOI.VariableIndex,MOI.VectorOfVariables}},
        ::Type{T} = Float64,
    ) where {T}

Compute the dual of the constraint of index `ci` using the `ConstraintDual` of
other constraints and the `ConstraintFunction` values.

Throws an error if some constraints are quadratic or if there is one another
`MOI.VariableIndex`-in-`S` or `MOI.VectorOfVariables`-in-`S` constraint with one
of the variables in the function of the constraint `ci`.
"""
function get_fallback(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    ci::MOI.ConstraintIndex{<:Union{MOI.VariableIndex,MOI.VectorOfVariables}},
    ::Type{T} = Float64,
) where {T}
    MOI.check_result_index_bounds(model, attr)
    f = MOI.get(model, MOI.ConstraintFunction(), ci)
    return _variable_dual(T, model, attr, ci, f)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintNormToPower

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_dimension_5()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NormToPowerBridge,
        """
        variables: t, x1, x2, x3, x4
        [t, x1, x2, x3, x4] in NormCone(4, 5)
        """,
        """
        variables: t, x1, x2, x3, x4, r1, r2, r3, r4
        [r1, t, x1] in PowerCone(0.25)
        [r2, t, x2] in PowerCone(0.25)
        [r3, t, x3] in PowerCone(0.25)
        [r4, t, x4] in PowerCone(0.25)
        r1 + r2 + r3 + r4 + -1.0 * t == 0.0
        """,
    )
    return
end

function test_runtests_dimension_4()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NormToPowerBridge,
        """
        variables: t, x1, x2, x3
        [t, 1.0 * x1, 2.0 * x2, x3] in NormCone(4, 4)
        """,
        """
        variables: t, x1, x2, x3, r1, r2, r3
        [r1, t, 1.0 * x1] in PowerCone(0.25)
        [r2, t, 2.0 * x2] in PowerCone(0.25)
        [r3, t, 1.0 * x3] in PowerCone(0.25)
        r1 + r2 + r3 + -1.0 * t == 0.0
        """,
    )
    return
end

function test_runtests_dimension_2()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NormToPowerBridge,
        """
        variables: t, x1
        [t, x1] in NormCone(2, 2)
        """,
        """
        variables: t, x1, r1
        [r1, t, x1] in PowerCone(0.5)
        r1 + -1.0 * t == 0.0
        """,
    )
    return
end

end  # module

TestConstraintNormToPower.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintRelativeEntropyToExponential

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_RelativeEntropy()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.RelativeEntropy{Float64}(mock)
    MOI.Test.test_basic_VectorOfVariables_RelativeEntropyCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_basic_VectorAffineFunction_RelativeEntropyCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    MOI.Test.test_basic_VectorQuadraticFunction_RelativeEntropyCone(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    entr1 = 2 * log(2)
    entr2 = 3 * log(3 / 5)
    var_primal = [entr1 + entr2, entr1, entr2]
    exps_duals = [[-1, log(0.5) - 1, 2], [-1, log(5 / 3) - 1, 0.6]]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [1.0],
            (MOI.VectorAffineFunction{Float64}, MOI.ExponentialCone) =>
                exps_duals,
        )

    MOI.Test.test_conic_RelativeEntropyCone(bridged_mock, config)
    var_names = ["u"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    greater = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.GreaterThan{Float64},
        }(),
    )
    exps = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.ExponentialCone,
        }(),
    )
    (y1, y2) = MOI.get(mock, MOI.ListOfVariableIndices())[2:3]
    MOI.set(mock, MOI.VariableName(), y1, "y1")
    MOI.set(mock, MOI.VariableName(), y2, "y2")
    @test length(greater) == 1
    MOI.set(mock, MOI.ConstraintName(), greater[1], "greater")
    @test length(exps) == 2
    MOI.set(mock, MOI.ConstraintName(), exps[1], "exps1")
    MOI.set(mock, MOI.ConstraintName(), exps[2], "exps2")

    s = """
    variables: u, y1, y2
    greater: u + -1.0y1 + -1.0y2 >= 0.0
    exps1: [-1.0y1, 2.0, 1.0] in ExponentialCone()
    exps2: [-1.0y2, 3.0, 5.0] in ExponentialCone()
    minobjective: u
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(
        mock,
        model,
        vcat(var_names, "y1", "y2"),
        ["greater", "exps1", "exps2"],
    )
    relentr = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.RelativeEntropyCone,
        }(),
    )
    @test length(relentr) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), relentr[1], "relentr")

    s = """
    variables: u
    relentr: [u, 1.0, 5.0, 2.0, 3.0] in RelativeEntropyCone(5)
    minobjective: u
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(bridged_mock, model, var_names, ["relentr"])
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.RelativeEntropyCone,
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value =
            (attr isa MOI.ConstraintPrimalStart) ?
            [entr1 + entr2 + 1, 1, 5, 2, 3] :
            [2, 2, 0.6, log(0.5) - 1, log(5 / 3) - 1]
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
        if attr isa MOI.ConstraintPrimalStart
            @test MOI.get(mock, MOI.VariablePrimalStart(), y1) == entr1
            @test MOI.get(mock, MOI.VariablePrimalStart(), y2) == entr2
            @test MOI.get(mock, attr, greater[1]) == 1
            @test MOI.get(mock, attr, exps[1]) == [-entr1, 2, 1]
            @test MOI.get(mock, attr, exps[2]) == [-entr2, 3, 5]
        else
            @test MOI.get(mock, attr, greater[1]) == 2
            for i in 1:2
                @test MOI.get(mock, attr, exps[i]) ==
                      [value[1], value[3+i], value[1+i]]
            end
        end
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.ExponentialCone, 0),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.RelativeEntropyBridge,
        """
        variables: u, v1, v2, w1, w2
        [u, v1, v2, w1, w2] in RelativeEntropyCone(5)
        """,
        """
        variables: u, v1, v2, w1, w2, y1, y2
        u + -1.0 * y1 + -1.0 * y2 >= 0.0
        [-1.0 * y1, w1, v1] in ExponentialCone()
        [-1.0 * y2, w2, v2] in ExponentialCone()
        """,
    )
    return
end

end  # module

TestConstraintRelativeEntropyToExponential.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# JuMP requires first and second-order symbolic derivatives for univariate
# functions. Calculus.jl is a package for computing them, and JuMP 1.0.0 used to
# dynamically compute them during precompilation. The benefit of this approach
# is that if the rules in Calculus are updated, then hey will automatically flow
# into JuMP. However, the Calculus package has not seen any development for two
# years, and JuMP uses only a very small part of the total package. Therefore,
# this script statically builds the list of univariate functions supported by
# JuMP and writes them to univariate_expressions.jl. This has the benefit of
# removing a dependency, and saves the recalculation of these derivatives by
# every user.
#
# If you want to rebuild this list of derivatives in future, you will need v0.5
# of Calculus: `import Pkg; Pkg.pkg"add Calculus@0.5"`.

import Calculus

function _differentiate(f)
    try
        return Calculus.simplify(Calculus.differentiate(f, :x))
    catch
        # For some functions the derivative is not defined.
        return nothing
    end
end

_to_expr(f) = f isa Real ? :(typeof(x)($f)) : f

open("univariate_expressions.jl", "w") do io
    println(
        io,
        """
#! format:off
#
# This file is machine generated by running univariate_expressions_generator.jl

const SYMBOLIC_UNIVARIATE_EXPRESSIONS = Tuple{Symbol,Expr,Any}[
    (:+, :(one(x)), :(zero(x))),
    (:-, :(-one(x)), :(zero(x))),
    (:abs, :(ifelse(x >= 0, one(x), -one(x))), :(zero(x))),
    (:sign, :(zero(x)), :(zero(x))),""",
    )
    for (op, deriv) in Calculus.symbolic_derivatives_1arg()
        f = Expr(:call, op, :x)
        ∇f = _differentiate(f)
        print(io, "    (:", op, ", :(", _to_expr(∇f), ")")
        println(io, ", :(", _to_expr(_differentiate(∇f)), ")),")
    end
    println(io, "]")
    println(io)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    NormToPowerBridge{T,F} <: Bridges.Constraint.AbstractBridge

`NormToPowerBridge` implements the following reformulation:

  * ``(t, x) \\in NormCone(p, 1+d)`` into ``(r_i, t, x_i) \\in PowerCone(1 / p)``
    for all ``i``, and ``\\sum\\limits_i r_i == t``.

For details, see Alizadeh, F., and Goldfarb, D. (2001). "Second-order cone
programming." Mathematical Programming, Series B, 95:3-51.

## Source node

`NormToPowerBridge` supports:

  * `F` in [`MOI.NormCone`](@ref)

## Target nodes

`NormToPowerBridge` creates:

  * `F` in [`MOI.PowerCone{T}`](@ref)
  * [`MOI.ScalarAffineFunction`](@ref) in [`MOI.EqualTo`](@ref)
"""
struct NormToPowerBridge{T,F} <: AbstractBridge
    power::Vector{MOI.ConstraintIndex{F,MOI.PowerCone{T}}}
    r::Vector{MOI.VariableIndex}
    equal::MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}
    set::MOI.NormCone
end

const NormToPower{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NormToPowerBridge{T},OT}

function bridge_constraint(
    ::Type{NormToPowerBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.NormCone,
) where {T,F}
    d = MOI.dimension(s)
    fi_s = MOI.Utilities.eachscalar(f)
    r = MOI.add_variables(model, d - 1)
    power_ci = MOI.ConstraintIndex{F,MOI.PowerCone{T}}[
        MOI.add_constraint(
            model,
            MOI.Utilities.operate(vcat, T, r[i], fi_s[1], fi_s[i+1]),
            MOI.PowerCone(T(1 / s.p)),
        ) for i in 1:length(r)
    ]
    f = zero(MOI.ScalarAffineFunction{T})
    for ri in r
        f = MOI.Utilities.operate!(+, T, f, ri)
    end
    f = MOI.Utilities.operate!(-, T, f, fi_s[1])
    equal_ci = MOI.add_constraint(model, f, MOI.EqualTo(zero(T)))
    return NormToPowerBridge{T,F}(power_ci, r, equal_ci, s)
end

function MOI.supports_constraint(
    ::Type{<:NormToPowerBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.NormCone},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:NormToPowerBridge},
)
    return Tuple{Type}[(MOI.Reals,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:NormToPowerBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[
        (F, MOI.PowerCone{T}),
        (MOI.ScalarAffineFunction{T}, MOI.EqualTo{T}),
    ]
end

function concrete_bridge_type(
    ::Type{<:NormToPowerBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.NormCone},
) where {T}
    return NormToPowerBridge{T,F}
end

function MOI.get(bridge::NormToPowerBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.r)
end

function MOI.get(bridge::NormToPowerBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.r)
end

function MOI.get(
    bridge::NormToPowerBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.PowerCone{T}},
)::Int64 where {T,F}
    return length(bridge.power)
end

function MOI.get(
    bridge::NormToPowerBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.PowerCone{T}},
) where {T,F}
    return copy(bridge.power)
end

function MOI.get(
    bridge::NormToPowerBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
)::Int64 where {T}
    return 1
end

function MOI.get(
    bridge::NormToPowerBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return [bridge.equal]
end

function MOI.delete(model::MOI.ModelLike, bridge::NormToPowerBridge)
    MOI.delete(model, bridge.power)
    MOI.delete(model, bridge.equal)
    MOI.delete(model, bridge.r)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::NormToPowerBridge{T,F},
) where {T,F}
    elements = MOI.Utilities.scalar_type(F)[]
    for ci in bridge.power
        f = MOI.get(model, MOI.ConstraintFunction(), ci)
        fi_s = MOI.Utilities.eachscalar(f)
        if isempty(elements)
            push!(elements, fi_s[2])
        end
        push!(elements, fi_s[3])
    end
    return MOI.Utilities.operate(vcat, T, elements...)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::NormToPowerBridge,
)
    return bridge.set
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Note: When adding a new set, also add it to Utilities.Model.

"""
    AbstractSet

Abstract supertype for set objects used to encode constraints.

## Required methods

For sets of type `S` with `isbitstype(S) == false`, you must implement:

 * `Base.copy(set::S)`
 * `Base.:(==)(x::S, y::S)`

Subtypes of `AbstractSet` such as [`AbstractScalarSet`](@ref) and
[`AbstractVectorSet`](@ref) may prescribe additional required methods.

## Optional methods

You may optionally implement:

 * [`dual_set`](@ref)
 * [`dual_set_type`](@ref)

## Note for developers

When creating a new set, the set struct must not contain any
[`VariableIndex`](@ref) or [`ConstraintIndex`](@ref) objects.
"""
abstract type AbstractSet end

function Base.copy(set::S) where {S<:AbstractSet}
    if isbitstype(S)
        return set
    end
    return error("Base.copy(::$S) is not implemented for this set.")
end

"""
    dimension(set::AbstractSet)

Return the [`output_dimension`](@ref) that an [`AbstractFunction`](@ref) should
have to be used with the set `set`.

## Example

```jldoctest
julia> MOI.dimension(MOI.Reals(4))
4

julia> MOI.dimension(MOI.LessThan(3.0))
1

julia> MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(2))
3
```
"""
function dimension end

"""
    dual_set(set::AbstractSet)

Return the dual set of `set`, that is the dual cone of the set. This follows the
definition of duality discussed in [Duality](@ref).

See [Dual cone](https://en.wikipedia.org/wiki/Dual_cone_and_polar_cone) for more
information.

If the dual cone is not defined it returns an error.

## Example

```jldoctest
julia> MOI.dual_set(MOI.Reals(4))
MathOptInterface.Zeros(4)

julia> MOI.dual_set(MOI.SecondOrderCone(5))
MathOptInterface.SecondOrderCone(5)

julia> MOI.dual_set(MOI.ExponentialCone())
MathOptInterface.DualExponentialCone()
```
"""
dual_set(set::AbstractSet) = error("Dual of $set is not implemented.")

"""
    dual_set_type(S::Type{<:AbstractSet})

Return the type of dual set of sets of type `S`, as returned by
[`dual_set`](@ref). If the dual cone is not defined it returns an error.

## Example

```jldoctest
julia> MOI.dual_set_type(MOI.Reals)
MathOptInterface.Zeros

julia> MOI.dual_set_type(MOI.SecondOrderCone)
MathOptInterface.SecondOrderCone

julia> MOI.dual_set_type(MOI.ExponentialCone)
MathOptInterface.DualExponentialCone
```
"""
function dual_set_type(S::Type{<:AbstractSet})
    return error("Dual type of $S is not implemented.")
end

"""
    AbstractScalarSet

Abstract supertype for subsets of ``\\mathbb{R}``.
"""
abstract type AbstractScalarSet <: AbstractSet end

Base.broadcastable(set::AbstractScalarSet) = Ref(set)

dimension(s::AbstractScalarSet) = 1

"""
    AbstractVectorSet

Abstract supertype for subsets of ``\\mathbb{R}^n`` for some ``n``.

## Required methods

All `AbstractVectorSet`s of type `S` must implement:

 * [`dimension`](@ref), unless the dimension is stored in the `set.dimension`
   field
 * [`Utilities.set_dot`](@ref), unless the dot product between two vectors in
   the set is equivalent to `LinearAlgebra.dot`.
"""
abstract type AbstractVectorSet <: AbstractSet end

dimension(s::AbstractVectorSet) = s.dimension

"""
    GreaterThan{T<:Real}(lower::T)

The set ``[lower, \\infty) \\subseteq \\mathbb{R}``.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.add_constraint(model, x, MOI.GreaterThan(0.0))
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.GreaterThan{Float64}}(1)
```
"""
struct GreaterThan{T<:Real} <: AbstractScalarSet
    lower::T
end

Base.:(==)(a::GreaterThan{T}, b::GreaterThan{T}) where {T} = a.lower == b.lower

"""
    LessThan{T<:Real}(upper::T)

The set ``(-\\infty, upper] \\subseteq \\mathbb{R}``.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.add_constraint(model, x, MOI.LessThan(2.0))
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.LessThan{Float64}}(1)
```
"""
struct LessThan{T<:Real} <: AbstractScalarSet
    upper::T
end

Base.:(==)(a::LessThan{T}, b::LessThan{T}) where {T} = a.upper == b.upper

"""
    EqualTo{T<:Number}(value::T)

The set containing the single point ``\\{value\\} \\subseteq \\mathbb{R}``.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.add_constraint(model, x, MOI.EqualTo(2.0))
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.EqualTo{Float64}}(1)
```
"""
struct EqualTo{T<:Number} <: AbstractScalarSet
    value::T
end

Base.:(==)(a::EqualTo{T}, b::EqualTo{T}) where {T} = a.value == b.value

"""
    Parameter{T<:Number}(value::T)

The set containing the single point ``\\{value\\} \\subseteq \\mathbb{R}``.

The `Parameter` set is conceptually similar to the [`EqualTo`](@ref) set, except
that a variable constrained to the `Parameter` set cannot have other constraints
added to it, and the `Parameter` set can never be deleted. Thus, solvers are
free to treat the variable as a constant, and they need not add it as a decision
variable to the model.

Because of this behavior, you must add parameters using [`add_constrained_variable`](@ref),
and solvers should declare [`supports_add_constrained_variable`](@ref) and not
[`supports_constraint`](@ref) for the `Parameter` set.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> p, ci = MOI.add_constrained_variable(model, MOI.Parameter(2.5))
(MOI.VariableIndex(1), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Parameter{Float64}}(1))

julia> MOI.set(model, MOI.ConstraintSet(), ci, MOI.Parameter(3.0))

julia> MOI.get(model, MOI.ConstraintSet(), ci)
MathOptInterface.Parameter{Float64}(3.0)
```
"""
struct Parameter{T<:Number} <: AbstractScalarSet
    value::T
end

Base.:(==)(a::Parameter{T}, b::Parameter{T}) where {T} = a.value == b.value

"""
    Interval{T<:Real}(lower::T, upper::T)

The interval ``[lower, upper] \\subseteq \\mathbb{R} \\cup \\{-\\infty, +\\infty\\}``.

If `lower` or `upper` is `-Inf` or `Inf`, respectively, the set is interpreted
as a one-sided interval.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.add_constraint(model, x, MOI.Interval(1.0, 2.0))
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}}(1)
```
"""
struct Interval{T<:Real} <: AbstractScalarSet
    lower::T
    upper::T
end

function Interval(lower::Real, upper::Real)
    return Interval(promote(lower, upper)...)
end

function Base.:(==)(a::Interval{T}, b::Interval{T}) where {T}
    return a.lower == b.lower && a.upper == b.upper
end

"""
    Interval(set::GreaterThan{<:AbstractFloat})
    Interval(set::LessThan{<:AbstractFloat})
    Interval(set::EqualTo{<:Real})
    Interval(set::Interval{<:Real})

Construct an interval set from the set `set`, assuming any missing bounds are
`typemin(T)` or `typemax(T)`.

## Example

```jldoctest
julia> MOI.Interval(MOI.GreaterThan(1.0))
MathOptInterface.Interval{Float64}(1.0, Inf)

julia> MOI.Interval(MOI.LessThan(2.5))
MathOptInterface.Interval{Float64}(-Inf, 2.5)

julia> MOI.Interval(MOI.EqualTo(3))
MathOptInterface.Interval{Int64}(3, 3)

julia> MOI.Interval(MOI.Interval(5, 6))
MathOptInterface.Interval{Int64}(5, 6)
```
"""
Interval(s::GreaterThan{<:AbstractFloat}) = Interval(s.lower, typemax(s.lower))
Interval(s::LessThan{<:AbstractFloat}) = Interval(typemin(s.upper), s.upper)
Interval(s::EqualTo{<:Real}) = Interval(s.value, s.value)
Interval(s::Interval) = s

"""
    Integer()

The set of integers, ``\\mathbb{Z}``.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.add_constraint(model, x, MOI.Integer())
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(1)
```
"""
struct Integer <: AbstractScalarSet end

"""
    ZeroOne()

The set ``\\{0, 1\\}``.

Variables belonging to the `ZeroOne` set are also known as "binary" variables.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.add_constraint(model, x, MOI.ZeroOne())
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(1)
```
"""
struct ZeroOne <: AbstractScalarSet end

"""
    Semicontinuous{T<:Real}(lower::T, upper::T)

The set ``\\{0\\} \\cup [lower, upper]``.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.add_constraint(model, x, MOI.Semicontinuous(2.0, 3.0))
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Semicontinuous{Float64}}(1)
```
"""
struct Semicontinuous{T<:Real} <: AbstractScalarSet
    lower::T
    upper::T
end

function Semicontinuous(lower::Real, upper::Real)
    return Semicontinuous(promote(lower, upper)...)
end

function Base.:(==)(a::Semicontinuous{T}, b::Semicontinuous{T}) where {T}
    return a.lower == b.lower && a.upper == b.upper
end

"""
    Semiinteger{T<:Real}(lower::T, upper::T)

The set ``\\{0\\} \\cup \\{lower, lower+1, \\ldots, upper-1, upper\\}``.

Note that if `lower` and `upper` are not equivalent to an integer, then the
solver may throw an error, or it may round up `lower` and round down `upper` to
the nearest integers.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.add_constraint(model, x, MOI.Semiinteger(2.0, 3.0))
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Semiinteger{Float64}}(1)
```
"""
struct Semiinteger{T<:Real} <: AbstractScalarSet
    lower::T
    upper::T
end

function Semiinteger(lower::Real, upper::Real)
    return Semiinteger(promote(lower, upper)...)
end

function Base.:(==)(a::Semiinteger{T}, b::Semiinteger{T}) where {T}
    return a.lower == b.lower && a.upper == b.upper
end

"""
    Reals(dimension::Int)

The set ``\\mathbb{R}^{dimension}`` (containing all points) of non-negative
dimension `dimension`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Reals(3))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Reals}(1)
```
"""
struct Reals <: AbstractVectorSet
    dimension::Int
    function Reals(dimension::Base.Integer)
        if !(dimension >= 0)
            throw(
                DimensionMismatch(
                    "Dimension of Reals must be >= 0, not $(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

dual_set(s::Reals) = Zeros(dimension(s))
dual_set_type(::Type{Reals}) = Zeros

"""
    Zeros(dimension::Int)

The set ``\\{ 0 \\}^{dimension}`` (containing only the origin) of non-negative
dimension `dimension`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Zeros(3))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Zeros}(1)
```
"""
struct Zeros <: AbstractVectorSet
    dimension::Int
    function Zeros(dimension::Base.Integer)
        if !(dimension >= 0)
            throw(
                DimensionMismatch(
                    "Dimension of Zeros must be >= 0, not $(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

dual_set(s::Zeros) = Reals(dimension(s))
dual_set_type(::Type{Zeros}) = Reals

"""
    Nonnegatives(dimension::Int)

The nonnegative orthant ``\\{ x \\in \\mathbb{R}^{dimension} : x \\ge 0 \\}`` of
non-negative dimension `dimension`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Nonnegatives(3))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Nonnegatives}(1)
```
"""
struct Nonnegatives <: AbstractVectorSet
    dimension::Int
    function Nonnegatives(dimension::Base.Integer)
        if !(dimension >= 0)
            throw(
                DimensionMismatch(
                    "Dimension of Nonnegatives must be >= 0, not $(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

dual_set(s::Nonnegatives) = copy(s)
dual_set_type(::Type{Nonnegatives}) = Nonnegatives

"""
    Nonpositives(dimension::Int)

The nonpositive orthant ``\\{ x \\in \\mathbb{R}^{dimension} : x \\le 0 \\}`` of
non-negative dimension `dimension`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Nonpositives(3))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Nonpositives}(1)
```
"""
struct Nonpositives <: AbstractVectorSet
    dimension::Int
    function Nonpositives(dimension::Base.Integer)
        if !(dimension >= 0)
            throw(
                DimensionMismatch(
                    "Dimension of Nonpositives must be >= 0, not $(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

dual_set(s::Nonpositives) = copy(s)
dual_set_type(::Type{Nonpositives}) = Nonpositives

"""
    NormInfinityCone(dimension::Int)

The ``\\ell_\\infty``-norm cone ``\\{ (t,x) \\in \\mathbb{R}^{dimension} : t \\ge \\lVert x \\rVert_\\infty = \\max_i \\lvert x_i \\rvert \\}``
of dimension `dimension`.

The `dimension` must be at least `1`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables([t; x]), MOI.NormInfinityCone(4))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.NormInfinityCone}(1)
```
"""
struct NormInfinityCone <: AbstractVectorSet
    dimension::Int
    function NormInfinityCone(dimension::Base.Integer)
        if !(dimension >= 1)
            throw(
                DimensionMismatch(
                    "Dimension of NormInfinityCone must be >= 1, not " *
                    "$(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

dual_set(s::NormInfinityCone) = NormOneCone(dimension(s))
dual_set_type(::Type{NormInfinityCone}) = NormOneCone

"""
    NormOneCone(dimension::Int)

The ``\\ell_1``-norm cone ``\\{ (t,x) \\in \\mathbb{R}^{dimension} : t \\ge \\lVert x \\rVert_1 = \\sum_i \\lvert x_i \\rvert \\}``
of dimension `dimension`.

The `dimension` must be at least `1`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables([t; x]), MOI.NormOneCone(4))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.NormOneCone}(1)
```
"""
struct NormOneCone <: AbstractVectorSet
    dimension::Int
    function NormOneCone(dimension::Base.Integer)
        if !(dimension >= 1)
            throw(
                DimensionMismatch(
                    "Dimension of NormOneCone must be >= 1, not $(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

dual_set(s::NormOneCone) = NormInfinityCone(dimension(s))
dual_set_type(::Type{NormOneCone}) = NormInfinityCone

"""
    SecondOrderCone(dimension::Int)

The second-order cone (or Lorenz cone or ``\\ell_2``-norm cone)
``\\{ (t,x) \\in \\mathbb{R}^{dimension} : t \\ge \\lVert x \\rVert_2 \\}`` of
dimension `dimension`.

The `dimension` must be at least `1`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables([t; x]), MOI.SecondOrderCone(4))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.SecondOrderCone}(1)
```
"""
struct SecondOrderCone <: AbstractVectorSet
    dimension::Int
    function SecondOrderCone(dimension::Base.Integer)
        if !(dimension >= 1)
            throw(
                DimensionMismatch(
                    "Dimension of SecondOrderCone must be >= 1, not " *
                    "$(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

dual_set(s::SecondOrderCone) = copy(s)
dual_set_type(::Type{SecondOrderCone}) = SecondOrderCone

"""
    RotatedSecondOrderCone(dimension::Int)

The rotated second-order cone ``\\{ (t,u,x) \\in \\mathbb{R}^{dimension} : 2tu \\ge \\lVert x \\rVert_2^2, t,u \\ge 0 \\}``
of dimension `dimension`.

The `dimension` must be at least `2`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> u = MOI.add_variable(model)
MOI.VariableIndex(2)

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables([t; u; x]),
           MOI.RotatedSecondOrderCone(5),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.RotatedSecondOrderCone}(1)
```
"""
struct RotatedSecondOrderCone <: AbstractVectorSet
    dimension::Int
    function RotatedSecondOrderCone(dimension::Base.Integer)
        if !(dimension >= 2)
            throw(
                DimensionMismatch(
                    "Dimension of RotatedSecondOrderCone must be >= 2, not " *
                    "$(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

dual_set(s::RotatedSecondOrderCone) = copy(s)
dual_set_type(::Type{RotatedSecondOrderCone}) = RotatedSecondOrderCone

"""
    NormCone(p::Float64, dimension::Int)

The ``\\ell_p``-norm cone ``\\{ (t,x) \\in \\mathbb{R}^{dimension} : t \\ge \\left(\\sum\\limits_i |x_i|^p\\right)^{\\frac{1}{p}} \\}``
of dimension `dimension`.

The `dimension` must be at least `1`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables([t; x]), MOI.NormCone(3, 4))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.NormCone}(1)
```
"""
struct NormCone <: AbstractVectorSet
    p::Float64
    dimension::Int

    function NormCone(p::Real, dimension::Base.Integer)
        if !(dimension >= 1)
            throw(
                DimensionMismatch(
                    "Dimension of NormCone must be >= 1, not " *
                    "$(dimension).",
                ),
            )
        elseif !(p >= 1)
            throw(ArgumentError("The p- argument to `NormCone` must be `>= 1`"))
        end
        return new(convert(Float64, p), dimension)
    end
end

NormCone(set::NormOneCone) = NormCone(1, set.dimension)
NormCone(set::SecondOrderCone) = NormCone(2, set.dimension)
NormCone(set::NormInfinityCone) = NormCone(Inf, set.dimension)

"""
    GeometricMeanCone(dimension::Int)

The geometric mean cone
``\\{ (t,x) \\in \\mathbb{R}^{n+1} : x \\ge 0, t \\le \\sqrt[n]{x_1 x_2 \\cdots x_n} \\}``,
where `dimension = n + 1 >= 2`.

## Duality note

The dual of the geometric mean cone is
``\\{ (u, v) \\in \\mathbb{R}^{n+1} : u \\le 0, v \\ge 0, -u \\le n \\sqrt[n]{\\prod_i v_i} \\}``,
where `dimension = n + 1 >= 2`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables([t; x]),
           MOI.GeometricMeanCone(4),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.GeometricMeanCone}(1)
```
"""
struct GeometricMeanCone <: AbstractVectorSet
    dimension::Int
    function GeometricMeanCone(dimension::Base.Integer)
        if !(dimension >= 2)
            throw(
                DimensionMismatch(
                    "Dimension of GeometricMeanCone must be >= 2, not " *
                    "$(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

"""
    ExponentialCone()

The 3-dimensional exponential cone ``\\{ (x,y,z) \\in \\mathbb{R}^3 : y \\exp (x/y) \\le z, y > 0 \\}``.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.ExponentialCone())
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.ExponentialCone}(1)
```
"""
struct ExponentialCone <: AbstractVectorSet end

dual_set(::ExponentialCone) = DualExponentialCone()
dual_set_type(::Type{ExponentialCone}) = DualExponentialCone

dimension(::ExponentialCone) = 3

"""
    DualExponentialCone()

The 3-dimensional dual exponential cone ``\\{ (u,v,w) \\in \\mathbb{R}^3 : -u \\exp (v/u) \\le \\exp(1) w, u < 0 \\}``.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.DualExponentialCone())
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.DualExponentialCone}(1)
```
"""
struct DualExponentialCone <: AbstractVectorSet end

dual_set(::DualExponentialCone) = ExponentialCone()
dual_set_type(::Type{DualExponentialCone}) = ExponentialCone

dimension(::DualExponentialCone) = 3

"""
    PowerCone{T<:Real}(exponent::T)

The 3-dimensional power cone ``\\{ (x,y,z) \\in \\mathbb{R}^3 : x^{exponent} y^{1-exponent} \\ge |z|, x \\ge 0, y \\ge 0 \\}``
with parameter `exponent`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.PowerCone(0.5))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.PowerCone{Float64}}(1)
```
"""
struct PowerCone{T<:Real} <: AbstractVectorSet
    exponent::T
end

dual_set(s::PowerCone{T}) where {T<:Real} = DualPowerCone{T}(s.exponent)
dual_set_type(::Type{PowerCone{T}}) where {T<:Real} = DualPowerCone{T}

dimension(::PowerCone) = 3

function Base.:(==)(x::PowerCone{T}, y::PowerCone{T}) where {T}
    return x.exponent == y.exponent
end

"""
    DualPowerCone{T<:Real}(exponent::T)

The 3-dimensional power cone ``\\{ (u,v,w) \\in \\mathbb{R}^3 : (\\frac{u}{exponent})^{exponent} (\\frac{v}{1-exponent})^{1-exponent} \\ge |w|, u \\ge 0, v \\ge 0 \\}``
with parameter `exponent`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.DualPowerCone(0.5))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.DualPowerCone{Float64}}(1)
```
"""
struct DualPowerCone{T<:Real} <: AbstractVectorSet
    exponent::T
end

dual_set(s::DualPowerCone{T}) where {T<:Real} = PowerCone{T}(s.exponent)
dual_set_type(::Type{DualPowerCone{T}}) where {T<:Real} = PowerCone{T}

dimension(::DualPowerCone) = 3

function Base.:(==)(x::DualPowerCone{T}, y::DualPowerCone{T}) where {T}
    return x.exponent == y.exponent
end

"""
    RelativeEntropyCone(dimension::Int)

The relative entropy cone
``\\{ (u, v, w) \\in \\mathbb{R}^{1+2n} : u \\ge \\sum_{i=1}^n w_i \\log(\\frac{w_i}{v_i}), v_i \\ge 0, w_i \\ge 0 \\}``,
where `dimension = 2n + 1 >= 1`.

## Duality note

The dual of the relative entropy cone is
``\\{ (u, v, w) \\in \\mathbb{R}^{1+2n} : \\forall i, w_i \\ge u (\\log (\\frac{u}{v_i}) - 1), v_i \\ge 0, u > 0 \\}``
of dimension `dimension```{}=2n+1``.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> u = MOI.add_variable(model);

julia> v = MOI.add_variables(model, 3);

julia> w = MOI.add_variables(model, 3);

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables([u; v; w]),
           MOI.RelativeEntropyCone(7),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.RelativeEntropyCone}(1)
```
"""
struct RelativeEntropyCone <: AbstractVectorSet
    dimension::Int
    function RelativeEntropyCone(dimension::Base.Integer)
        if !(dimension >= 1 && isodd(dimension))
            throw(
                DimensionMismatch(
                    "Dimension of RelativeEntropyCone must be an odd integer " *
                    ">= 1, not $(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

"""
    NormSpectralCone(row_dim::Int, column_dim::Int)

The epigraph of the matrix spectral norm (maximum singular value function)
``\\{ (t, X) \\in \\mathbb{R}^{1 + row_dim \\times column_dim} : t \\ge \\sigma_1(X) \\}``,
where ``\\sigma_i`` is the ``i``th singular value of the matrix ``X`` of
non-negative row dimension `row_dim` and column dimension `column_dim`.

The matrix X is vectorized by stacking the columns, matching the behavior of
Julia's `vec` function.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> X = reshape(MOI.add_variables(model, 6), 2, 3)
2×3 Matrix{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(2)  MOI.VariableIndex(4)  MOI.VariableIndex(6)
 MOI.VariableIndex(3)  MOI.VariableIndex(5)  MOI.VariableIndex(7)

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables([t; vec(X)]),
           MOI.NormSpectralCone(2, 3),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.NormSpectralCone}(1)
```
"""
struct NormSpectralCone <: AbstractVectorSet
    row_dim::Int
    column_dim::Int
    function NormSpectralCone(row_dim::Base.Integer, column_dim::Base.Integer)
        if !(row_dim >= 0 && column_dim >= 0)
            throw(
                DimensionMismatch(
                    "Dimensions of NormSpectralCone must be >= 0, not " *
                    "($(row_dim), $(column_dim)).",
                ),
            )
        end
        return new(row_dim, column_dim)
    end
end

dual_set(s::NormSpectralCone) = NormNuclearCone(s.row_dim, s.column_dim)
dual_set_type(::Type{NormSpectralCone}) = NormNuclearCone

dimension(s::NormSpectralCone) = 1 + s.row_dim * s.column_dim

"""
    NormNuclearCone(row_dim::Int, column_dim::Int)

The epigraph of the matrix nuclear norm (sum of singular values function)
``\\{ (t, X) \\in \\mathbb{R}^{1 + row_dim \\times column_dim} : t \\ge \\sum_i \\sigma_i(X) \\}``,
where ``\\sigma_i`` is the ``i``th singular value of the matrix ``X`` of
non-negative row dimension `row_dim` and column dimension `column_dim`.

The matrix X is vectorized by stacking the columns, matching the behavior of
Julia's `vec` function.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> X = reshape(MOI.add_variables(model, 6), 2, 3)
2×3 Matrix{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(2)  MOI.VariableIndex(4)  MOI.VariableIndex(6)
 MOI.VariableIndex(3)  MOI.VariableIndex(5)  MOI.VariableIndex(7)

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables([t; vec(X)]),
           MOI.NormNuclearCone(2, 3),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.NormNuclearCone}(1)
```
"""
struct NormNuclearCone <: AbstractVectorSet
    row_dim::Int
    column_dim::Int
    function NormNuclearCone(row_dim::Base.Integer, column_dim::Base.Integer)
        if !(row_dim >= 0 && column_dim >= 0)
            throw(
                DimensionMismatch(
                    "Dimension of NormNuclearCone must be >= 0, not " *
                    "($(row_dim), $(column_dim)).",
                ),
            )
        end
        return new(row_dim, column_dim)
    end
end

dual_set(s::NormNuclearCone) = NormSpectralCone(s.row_dim, s.column_dim)
dual_set_type(::Type{NormNuclearCone}) = NormSpectralCone

dimension(s::NormNuclearCone) = 1 + s.row_dim * s.column_dim

"""
    abstract type AbstractSymmetricMatrixSetTriangle <: AbstractVectorSet end

Abstract supertype for subsets of the (vectorized) cone of symmetric matrices,
with [`side_dimension`](@ref) rows and columns. The entries of the upper-right
triangular part of the matrix are given column by column (or equivalently, the
entries of the lower-left triangular part are given row by row). A vectorized
cone of [`dimension`](@ref) ``n`` corresponds to a square matrix with side
dimension ``\\sqrt{1/4 + 2 n} - 1/2``. (Because a ``d \\times d`` matrix has
``d(d + 1) / 2`` elements in the upper or lower triangle.)

## Example

The matrix
```math
\\begin{bmatrix}
  1 & 2 & 4\\\\
  2 & 3 & 5\\\\
  4 & 5 & 6
\\end{bmatrix}
```
has [`side_dimension`](@ref) 3 and vectorization ``(1, 2, 3, 4, 5, 6)``.

## Note

Two packed storage formats exist for symmetric matrices, the respective orders
of the entries are:
- upper triangular column by column (or lower triangular row by row);
- lower triangular column by column (or upper triangular row by row).

The advantage of the first format is the mapping between the `(i, j)` matrix
indices and the `k` index of the vectorized form. It is simpler and does not
depend on the side dimension of the matrix.
Indeed,
- the entry of matrix indices `(i, j)` has vectorized index
  `k = div((j - 1) * j, 2) + i` if ``i \\leq j`` and
  `k = div((i - 1) * i, 2) + j` if ``j \\leq i``;
- and the entry with vectorized index `k` has matrix indices
  `i = div(1 + isqrt(8k - 7), 2)` and `j = k - div((i - 1) * i, 2)` or
  `j = div(1 + isqrt(8k - 7), 2)` and `i = k - div((j - 1) * j, 2)`.

## Duality note

The scalar product for the symmetric matrix in its vectorized form is the sum of
the pairwise product of the diagonal entries plus twice the sum of the pairwise
product of the upper diagonal entries; see [p. 634, 1].
This has important consequence for duality.

Consider for example the following problem
([`PositiveSemidefiniteConeTriangle`](@ref) is a subtype of
[`AbstractSymmetricMatrixSetTriangle`](@ref))
```math
\\begin{align*}
    & \\max_{x \\in \\mathbb{R}} & x
    \\\\
    & \\;\\;\\text{s.t.} &
    (1, -x, 1) & \\in \\text{PositiveSemidefiniteConeTriangle}(2).
\\end{align*}
```
The dual is the following problem
```math
\\begin{align*}
    & \\min_{x \\in \\mathbb{R}^3} & y_1 + y_3
    \\\\
    & \\;\\;\\text{s.t.} & 2y_2 & = 1\\\\
    & & y & \\in \\text{PositiveSemidefiniteConeTriangle}(2).
\\end{align*}
```
Why do we use ``2y_2`` in the dual constraint instead of ``y_2`` ?
The reason is that ``2y_2`` is the scalar product between ``y`` and the symmetric
matrix whose vectorized form is ``(0, 1, 0)``. Indeed, with our modified scalar
products we have
```math
\\langle
(0, 1, 0),
(y_1, y_2, y_3)
\\rangle
=
\\mathrm{trace}
\\begin{pmatrix}
  0 & 1\\\\
  1 & 0
\\end{pmatrix}
\\begin{pmatrix}
  y_1 & y_2\\\\
  y_2 & y_3
\\end{pmatrix}
= 2y_2.
```

## References

[1] Boyd, S. and Vandenberghe, L.. *Convex optimization*. Cambridge university
    press, 2004.
"""
abstract type AbstractSymmetricMatrixSetTriangle <: AbstractVectorSet end

is_set_dot_scaled(::Type{<:AbstractSymmetricMatrixSetTriangle}) = true

function dimension(set::AbstractSymmetricMatrixSetTriangle)
    d = side_dimension(set)
    return div(d * (d + 1), 2)
end

"""
    abstract type AbstractSymmetricMatrixSetSquare <: AbstractVectorSet end

Abstract supertype for subsets of the (vectorized) cone of symmetric matrices,
with [`side_dimension`](@ref) rows and columns. The entries of the matrix are
given column by column (or equivalently, row by row). The matrix is both
constrained to be symmetric and to have its [`triangular_form`](@ref) belong
to the corresponding set. That is, if the functions in entries ``(i, j)`` and
``(j, i)`` are different, then a constraint will be added to make sure that the
entries are equal.

## Example

[`PositiveSemidefiniteConeSquare`](@ref) is a subtype of
[`AbstractSymmetricMatrixSetSquare`](@ref) and constraining the matrix
```math
\\begin{bmatrix}
  1 & -y\\\\
  -z & 0\\\\
\\end{bmatrix}
```
to be symmetric positive semidefinite can be achieved by constraining the vector
``(1, -z, -y, 0)`` (or ``(1, -y, -z, 0)``) to belong to the
`PositiveSemidefiniteConeSquare(2)`. It both constrains ``y = z`` and
``(1, -y, 0)`` (or ``(1, -z, 0)``) to be in
`PositiveSemidefiniteConeTriangle(2)`, since
`triangular_form(PositiveSemidefiniteConeSquare)` is
`PositiveSemidefiniteConeTriangle`.
"""
abstract type AbstractSymmetricMatrixSetSquare <: AbstractVectorSet end

dimension(set::AbstractSymmetricMatrixSetSquare) = side_dimension(set)^2

"""
    triangular_form(S::Type{<:AbstractSymmetricMatrixSetSquare})
    triangular_form(set::AbstractSymmetricMatrixSetSquare)

Return the [`AbstractSymmetricMatrixSetTriangle`](@ref) corresponding to the
vectorization of the upper triangular part of matrices in the
[`AbstractSymmetricMatrixSetSquare`](@ref) set.
"""
function triangular_form end

function triangular_form(set::AbstractSymmetricMatrixSetSquare)
    return triangular_form(typeof(set))(side_dimension(set))
end

"""
    PositiveSemidefiniteConeTriangle(side_dimension::Int) <: AbstractSymmetricMatrixSetTriangle

The (vectorized) cone of symmetric positive semidefinite matrices, with
non-negative `side_dimension` rows and columns.

See [`AbstractSymmetricMatrixSetTriangle`](@ref) for more details on the
vectorized form.
"""
struct PositiveSemidefiniteConeTriangle <: AbstractSymmetricMatrixSetTriangle
    side_dimension::Int
    function PositiveSemidefiniteConeTriangle(side_dimension::Base.Integer)
        if !(side_dimension >= 0)
            throw(
                DimensionMismatch(
                    "Side dimension of PositiveSemidefiniteConeTriangle must " *
                    "be >= 0, not $(side_dimension).",
                ),
            )
        end
        return new(side_dimension)
    end
end

dual_set(s::PositiveSemidefiniteConeTriangle) = copy(s)
function dual_set_type(::Type{PositiveSemidefiniteConeTriangle})
    return PositiveSemidefiniteConeTriangle
end

"""
    PositiveSemidefiniteConeSquare(side_dimension::Int) <: AbstractSymmetricMatrixSetSquare

The cone of symmetric positive semidefinite matrices, with non-negative side
length `side_dimension`.

See [`AbstractSymmetricMatrixSetSquare`](@ref) for more details on the
vectorized form.

The entries of the matrix are given column by column (or equivalently, row by
row).

The matrix is both constrained to be symmetric and to be positive semidefinite.
That is, if the functions in entries ``(i, j)`` and ``(j, i)`` are different,
then a constraint will be added to make sure that the entries are equal.

## Example

Constraining the matrix
```math
\\begin{bmatrix}
  1 & -y\\\\
  -z & 0\\\\
\\end{bmatrix}
```
to be symmetric positive semidefinite can be achieved by constraining the vector
``(1, -z, -y, 0)`` (or ``(1, -y, -z, 0)``) to belong to the
`PositiveSemidefiniteConeSquare(2)`.

It both constrains ``y = z`` and ``(1, -y, 0)`` (or ``(1, -z, 0)``) to be in
`PositiveSemidefiniteConeTriangle(2)`.
"""
struct PositiveSemidefiniteConeSquare <: AbstractSymmetricMatrixSetSquare
    side_dimension::Int
    function PositiveSemidefiniteConeSquare(side_dimension::Base.Integer)
        if !(side_dimension >= 0)
            throw(
                DimensionMismatch(
                    "Side dimension of PositiveSemidefiniteConeSquare must " *
                    "be >= 0, not $(side_dimension).",
                ),
            )
        end
        return new(side_dimension)
    end
end

function dual_set(::PositiveSemidefiniteConeSquare)
    return error(
        "Dual of `PositiveSemidefiniteConeSquare` is not defined in " *
        "MathOptInterface.\nFor more details see the comments in " *
        "`src/Bridges/Constraint/bridges/square.jl`.",
    )
end

function dual_set_type(::Type{PositiveSemidefiniteConeSquare})
    return error(
        "Dual of `PositiveSemidefiniteConeSquare` is not defined in " *
        "MathOptInterface.\nFor more details see the comments in " *
        "`src/Bridges/Constraint/bridges/square.jl`.",
    )
end

function triangular_form(::Type{PositiveSemidefiniteConeSquare})
    return PositiveSemidefiniteConeTriangle
end

"""
    HermitianPositiveSemidefiniteConeTriangle(side_dimension::Int) <: AbstractVectorSet

The (vectorized) cone of Hermitian positive semidefinite matrices, with
non-negative `side_dimension` rows and columns.

Becaue the matrix is Hermitian, the diagonal elements are real, and the
complex-valued lower triangular entries are obtained as the conjugate of
corresponding upper triangular entries.

## Vectorization format

The vectorized form starts with real part of the entries of the upper triangular
part of the matrix, given column by column as explained in
[`AbstractSymmetricMatrixSetSquare`](@ref).

It is then followed by the imaginary part of the off-diagonal entries of the
upper triangular part, also given column by column.

For example, the matrix
```math
\\begin{bmatrix}
  1 & 2 + 7im & 4 + 8im\\\\
  2 - 7im & 3 & 5 + 9im\\\\
  4 - 8im & 5 - 9im & 6
\\end{bmatrix}
```
has [`side_dimension`](@ref) 3 and is represented as the vector
``[1, 2, 3, 4, 5, 6, 7, 8, 9]``.
"""
struct HermitianPositiveSemidefiniteConeTriangle <: AbstractVectorSet
    side_dimension::Int
end

function dimension(set::HermitianPositiveSemidefiniteConeTriangle)
    real_nnz = div(set.side_dimension * (set.side_dimension + 1), 2)
    imag_nnz = div((set.side_dimension - 1) * set.side_dimension, 2)
    return real_nnz + imag_nnz
end

dual_set(set::HermitianPositiveSemidefiniteConeTriangle) = set

function dual_set_type(::Type{HermitianPositiveSemidefiniteConeTriangle})
    return HermitianPositiveSemidefiniteConeTriangle
end

"""
    side_dimension(
        set::Union{
            AbstractSymmetricMatrixSetTriangle,
            AbstractSymmetricMatrixSetSquare,
            HermitianPositiveSemidefiniteConeTriangle,
        },
    )

Side dimension of the matrices in `set`.

## Convention

By convention, the side dimension should be stored in the `side_dimension`
field. If this is not the case for a subtype of [`AbstractSymmetricMatrixSetTriangle`](@ref),
or [`AbstractSymmetricMatrixSetSquare`](@ref) you must implement this method.
"""
function side_dimension(
    set::Union{
        AbstractSymmetricMatrixSetTriangle,
        AbstractSymmetricMatrixSetSquare,
        HermitianPositiveSemidefiniteConeTriangle,
    },
)
    return set.side_dimension
end

"""
    LogDetConeTriangle(side_dimension::Int)

The log-determinant cone
``\\{ (t, u, X) \\in \\mathbb{R}^{2 + d(d+1)/2} : t \\le u \\log(\\det(X/u)), u > 0 \\}``,
where the matrix `X` is represented in the same symmetric packed format as in
the `PositiveSemidefiniteConeTriangle`.

The non-negative argument `side_dimension` is the side dimension of the matrix
`X`, that is, its number of rows or columns.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> X = MOI.add_variables(model, 3);

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables([t; X]),
           MOI.LogDetConeTriangle(2),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.LogDetConeTriangle}(1)
```
"""
struct LogDetConeTriangle <: AbstractVectorSet
    side_dimension::Int
    function LogDetConeTriangle(side_dimension::Base.Integer)
        if !(side_dimension >= 0)
            throw(
                DimensionMismatch(
                    "Side dimension of LogDetConeTriangle must be >= 0, not " *
                    "$(side_dimension).",
                ),
            )
        end
        return new(side_dimension)
    end
end

function dimension(s::LogDetConeTriangle)
    return 2 + div(s.side_dimension * (s.side_dimension + 1), 2)
end

"""
    LogDetConeSquare(side_dimension::Int)

The log-determinant cone
``\\{ (t, u, X) \\in \\mathbb{R}^{2 + d^2} : t \\le u \\log(\\det(X/u)), X \\text{ symmetric}, u > 0 \\}``,
where the matrix `X` is represented in the same format as in the
[`PositiveSemidefiniteConeSquare`](@ref).

Similarly to [`PositiveSemidefiniteConeSquare`](@ref), constraints are added to
ensure that `X` is symmetric.

The non-negative argument `side_dimension` is the side dimension of the matrix
`X`, that is, its number of rows or columns.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> X = reshape(MOI.add_variables(model, 4), 2, 2)
2×2 Matrix{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(2)  MOI.VariableIndex(4)
 MOI.VariableIndex(3)  MOI.VariableIndex(5)

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables([t; vec(X)]),
           MOI.LogDetConeSquare(2),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.LogDetConeSquare}(1)
```
"""
struct LogDetConeSquare <: AbstractVectorSet
    side_dimension::Int
    function LogDetConeSquare(side_dimension::Base.Integer)
        if !(side_dimension >= 0)
            throw(
                DimensionMismatch(
                    "Side dimension of LogDetConeSquare must be >= 0, not " *
                    "$(side_dimension).",
                ),
            )
        end
        return new(side_dimension)
    end
end

dimension(s::LogDetConeSquare) = 2 + s.side_dimension^2

side_dimension(s::LogDetConeSquare) = s.side_dimension

triangular_form(::Type{LogDetConeSquare}) = LogDetConeTriangle

triangular_form(set::LogDetConeSquare) = LogDetConeTriangle(set.side_dimension)

"""
    RootDetConeTriangle(side_dimension::Int)

The root-determinant cone
``\\{ (t, X) \\in \\mathbb{R}^{1 + d(d+1)/2} : t \\le \\det(X)^{1/d} \\}``,
where the matrix `X` is represented in the same symmetric packed format as in
the [`PositiveSemidefiniteConeTriangle`](@ref).

The non-negative argument `side_dimension` is the side dimension of the matrix
`X`, that is, its number of rows or columns.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> X = MOI.add_variables(model, 3);

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables([t; X]),
           MOI.RootDetConeTriangle(2),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.RootDetConeTriangle}(1)
```
"""
struct RootDetConeTriangle <: AbstractVectorSet
    side_dimension::Int
    function RootDetConeTriangle(side_dimension::Base.Integer)
        if !(side_dimension >= 0)
            throw(
                DimensionMismatch(
                    "Side dimension of RootDetConeTriangle must be >= 0, not " *
                    "$(side_dimension).",
                ),
            )
        end
        return new(side_dimension)
    end
end

function dimension(s::RootDetConeTriangle)
    return 1 + div(s.side_dimension * (s.side_dimension + 1), 2)
end

"""
    RootDetConeSquare(side_dimension::Int)

The root-determinant cone
``\\{ (t, X) \\in \\mathbb{R}^{1 + d^2} : t \\le \\det(X)^{1/d}, X \\text{ symmetric} \\}``,
where the matrix `X` is represented in the same format as
[`PositiveSemidefiniteConeSquare`](@ref).

Similarly to [`PositiveSemidefiniteConeSquare`](@ref), constraints are added to
ensure that `X` is symmetric.

The non-negative argument `side_dimension` is the side dimension of the matrix
`X`, that is, its number of rows or columns.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> t = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> X = reshape(MOI.add_variables(model, 4), 2, 2)
2×2 Matrix{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(2)  MOI.VariableIndex(4)
 MOI.VariableIndex(3)  MOI.VariableIndex(5)

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables([t; vec(X)]),
           MOI.RootDetConeSquare(2),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.RootDetConeSquare}(1)
```
"""
struct RootDetConeSquare <: AbstractVectorSet
    side_dimension::Int
    function RootDetConeSquare(side_dimension::Base.Integer)
        if !(side_dimension >= 0)
            throw(
                DimensionMismatch(
                    "Side dimension of RootDetConeSquare must be >= 0, not " *
                    "$(side_dimension).",
                ),
            )
        end
        return new(side_dimension)
    end
end

dimension(s::RootDetConeSquare) = 1 + s.side_dimension^2

side_dimension(s::RootDetConeSquare) = s.side_dimension

triangular_form(::Type{RootDetConeSquare}) = RootDetConeTriangle

function triangular_form(set::RootDetConeSquare)
    return RootDetConeTriangle(set.side_dimension)
end

"""
    is_set_dot_scaled(::Type{<:AbstractVectorFunction})

Return whether [`Utilities.set_dot(x, y)`](@ref Utilities.set_dot) is equivalent
to `x' * Diagonal(s) * y` for some scaling vector `s`. This scaling vector `s`
can be obtained with [`Utilities.SetDotScalingVector`](@ref).

!!! note
    For such sets `S`, we `Diagonal(s) * S` is [`MOI.Scaled(S)`](@ref Scaled).
    This linear relationship between the two sets allows briding between them
    with [`Bridges.Constraint.SetDotScalingBridge`](@ref) and
    [`Bridges.Constraint.SetDotInverseScalingBridge`](@ref). This scaling vector
    `s` is also used by Dualization.jl to compute the dual.
"""
is_set_dot_scaled(::Type{<:AbstractVectorSet}) = false

function is_set_dot_scaled(
    ::Type{
        <:Union{
            AbstractSymmetricMatrixSetTriangle,
            HermitianPositiveSemidefiniteConeTriangle,
            LogDetConeTriangle,
            RootDetConeTriangle,
        },
    },
)
    return true
end

"""
    struct Scaled{S<:AbstractVectorSet} <: AbstractVectorSet
        set::S
    end

Given a vector ``a \\in \\mathbb{R}^d`` and a `set` representing the set
``\\mathcal{S} \\in \\mathbb{R}^d`` such that [`Utilities.set_dot`](@ref) for
``x \\in \\mathcal{S}`` and ``y \\in \\mathcal{S}^*`` is
```math
\\sum_{i=1}^d a_i x_i y_i
```
the set `Scaled(set)` is defined as
```math
\\{ (\\sqrt{a_1} x_1, \\sqrt{a_2} x_2, \\ldots, \\sqrt{a_d} x_d) : x \\in S \\}
```

## Example

This can be used to scale a vector of numbers
```jldoctest scaling
julia> set = MOI.PositiveSemidefiniteConeTriangle(2)
MathOptInterface.PositiveSemidefiniteConeTriangle(2)

julia> a = MOI.Utilities.SetDotScalingVector{Float64}(set)
3-element MathOptInterface.Utilities.SetDotScalingVector{Float64, MathOptInterface.PositiveSemidefiniteConeTriangle}:
 1.0
 1.4142135623730951
 1.0

julia> using LinearAlgebra

julia> MOI.Utilities.operate(*, Float64, Diagonal(a), ones(3))
3-element Vector{Float64}:
 1.0
 1.4142135623730951
 1.0
```

It can be also used to scale a vector of function
```jldoctest scaling
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> func = MOI.VectorOfVariables(x)
┌                    ┐
│MOI.VariableIndex(1)│
│MOI.VariableIndex(2)│
│MOI.VariableIndex(3)│
└                    ┘

julia> set = MOI.PositiveSemidefiniteConeTriangle(2)
MathOptInterface.PositiveSemidefiniteConeTriangle(2)

julia> MOI.Utilities.operate(*, Float64, Diagonal(a), func)
┌                                             ┐
│0.0 + 1.0 MOI.VariableIndex(1)               │
│0.0 + 1.4142135623730951 MOI.VariableIndex(2)│
│0.0 + 1.0 MOI.VariableIndex(3)               │
└                                             ┘
```
"""
struct Scaled{S<:AbstractVectorSet} <: AbstractVectorSet
    set::S
end

dimension(s::Scaled) = dimension(s.set)

side_dimension(s::Scaled) = side_dimension(s.set)

dual_set(s::Scaled) = Scaled(dual_set(s.set))

dual_set_type(::Type{Scaled{S}}) where {S} = Scaled{dual_set_type(S)}

"""
    const ScaledPositiveSemidefiniteConeTriangle = Scaled{PositiveSemidefiniteConeTriangle}

The [`Scaled`](@ref) (vectorized) cone of symmetric positive semidefinite matrices, with
non-negative `side_dimension` rows and columns.

Compared to the [`PositiveSemidefiniteConeTriangle`](@ref), the off-diagonal
entries are scaled by `√2`. Thanks to this scaling, [`Utilities.set_dot`](@ref)
is the simply the sum of the pairwise product, while for
[`PositiveSemidefiniteConeTriangle`](@ref), the pairwise product additionally
have to be multiplied by `2`.

!!! note
    Using `MOI.ScaledPositiveSemidefiniteConeTriangle(d)` is deprecated, use
    `MOI.Scaled(MOI.PositiveSemidefiniteConeTriangle(d))`.
"""
const ScaledPositiveSemidefiniteConeTriangle =
    Scaled{PositiveSemidefiniteConeTriangle}

# TODO remove in MOI v2
function Scaled{PositiveSemidefiniteConeTriangle}(side_dimension::Int)
    return Scaled(PositiveSemidefiniteConeTriangle(side_dimension))
end

# TODO remove in MOI v2
function Base.getproperty(
    set::Scaled{PositiveSemidefiniteConeTriangle},
    f::Symbol,
)
    if f == :side_dimension
        return getproperty(getfield(set, :set), f)
    else
        @assert f == :set
        return getfield(set, f)
    end
end

"""
    SOS1{T<:Real}(weights::Vector{T})

The set corresponding to the Special Ordered Set (SOS) constraint of Type I.

Of the variables in the set, at most one can be nonzero.

The `weights` induce an ordering of the variables such that the *k*th element in
the set corresponds to the *k*th weight in `weights`. Solvers may use these
weights to improve the efficiency of the solution process, but the ordering does
not change the set of feasible solutions.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables(x),
           MOI.SOS1([1.0, 3.0, 2.5]),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.SOS1{Float64}}(1)
```
"""
struct SOS1{T<:Real} <: AbstractVectorSet
    weights::Vector{T}
end

dimension(set::SOS1) = length(set.weights)

Base.copy(set::SOS1{T}) where {T} = SOS1{T}(copy(set.weights))

Base.:(==)(a::SOS1{T}, b::SOS1{T}) where {T} = a.weights == b.weights

"""
    SOS2{T<:Real}(weights::Vector{T})

The set corresponding to the Special Ordered Set (SOS) constraint of Type II.

The `weights` induce an ordering of the variables such that the *k*th element in
the set corresponds to the *k*th weight in `weights`. Therefore, the weights
must be unique.

Of the variables in the set, at most two can be nonzero, and if two are nonzero,
they must be adjacent in the ordering of the set.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables(x),
           MOI.SOS2([1.0, 3.0, 2.5]),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.SOS2{Float64}}(1)
```
"""
struct SOS2{T<:Real} <: AbstractVectorSet
    weights::Vector{T}
end

dimension(set::SOS2) = length(set.weights)

Base.copy(set::SOS2{T}) where {T} = SOS2{T}(copy(set.weights))

Base.:(==)(a::SOS2{T}, b::SOS2{T}) where {T} = a.weights == b.weights

@_documented_enum(
    """
        ActivationCondition

    Activation condition for an indicator constraint.

    The enum value is used as first type parameter of `Indicator{A,S}`.
    """,
    ActivationCondition,
    """
    The indicator constraint holds when the binary variable is zero.
    """,
    ACTIVATE_ON_ZERO,
    """
    The indicator constraint holds when the binary variable is one.
    """,
    ACTIVATE_ON_ONE,
)

"""
    Indicator{ACTIVATE_ON_ZERO}(set::AbstractScalarSet)
    Indicator{ACTIVATE_ON_ONE}(set::AbstractScalarSet)

The set corresponding to an indicator constraint.

The type parameter must be an [`ActivationCondition`](@ref).

When the type parameter is [`ACTIVATE_ON_ZERO`](@ref), this means:

``\\{(y, x) \\in \\{0, 1\\} \\times \\mathbb{R} : y = 0 \\implies x \\in set\\}``

When the type parameter is [`ACTIVATE_ON_ONE`](@ref), this means:

``\\{(y, x) \\in \\{0, 1\\} \\times \\mathbb{R} : y = 1 \\implies x \\in set\\}``

## Notes

Most solvers expect that the first row of the function is interpretable as a
[`VariableIndex`](@ref) (for example, `1.0 * x + 0.0`), and that the variable is
constrained to the [`ZeroOne`](@ref) set. An error will be thrown if this is not
the case.

## Example

The constraint
``\\{(y, x) \\in \\{0, 1\\} \\times \\mathbb{R}^2 : y = 1 \\implies x_1 + x_2 \\leq 9 \\}``
is defined as
```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 2);

julia> y, _ = MOI.add_constrained_variable(model, MOI.ZeroOne());

julia> f = MOI.Utilities.vectorize([y, 1.0 * x[1] + 1.0 * x[2]])
┌                                                         ┐
│0.0 + 1.0 MOI.VariableIndex(3)                           │
│0.0 + 1.0 MOI.VariableIndex(1) + 1.0 MOI.VariableIndex(2)│
└                                                         ┘

julia> s = MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(9.0))
MathOptInterface.Indicator{MathOptInterface.ACTIVATE_ON_ONE, MathOptInterface.LessThan{Float64}}(MathOptInterface.LessThan{Float64}(9.0))

julia> MOI.add_constraint(model, f, s)
MathOptInterface.ConstraintIndex{MathOptInterface.VectorAffineFunction{Float64}, MathOptInterface.Indicator{MathOptInterface.ACTIVATE_ON_ONE, MathOptInterface.LessThan{Float64}}}(1)
```

The constraint
``\\{(y, x) \\in \\{0, 1\\} \\times \\mathbb{R} : y = 0 \\implies x = 0 \\}``
is defined as
```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> y, _ = MOI.add_constrained_variable(model, MOI.ZeroOne());

julia> f = MOI.VectorOfVariables([y, x]);

julia> s = MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.EqualTo(0.0))
MathOptInterface.Indicator{MathOptInterface.ACTIVATE_ON_ZERO, MathOptInterface.EqualTo{Float64}}(MathOptInterface.EqualTo{Float64}(0.0))

julia> MOI.add_constraint(model, f, s)
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Indicator{MathOptInterface.ACTIVATE_ON_ZERO, MathOptInterface.EqualTo{Float64}}}(1)
```
"""
struct Indicator{A,S<:AbstractScalarSet} <: AbstractVectorSet
    set::S

    function Indicator{ACTIVATE_ON_ONE}(set::S) where {S<:AbstractScalarSet}
        return new{ACTIVATE_ON_ONE,S}(set)
    end
    function Indicator{ACTIVATE_ON_ZERO}(set::S) where {S<:AbstractScalarSet}
        return new{ACTIVATE_ON_ZERO,S}(set)
    end
end

dimension(::Indicator) = 2

Base.copy(set::Indicator{A}) where {A} = Indicator{A}(copy(set.set))

Base.:(==)(a::Indicator{A,S}, b::Indicator{A,S}) where {A,S} = a.set == b.set

"""
    Complements(dimension::Base.Integer)

The set corresponding to a mixed complementarity constraint.

Complementarity constraints should be specified with an
[`AbstractVectorFunction`](@ref)-in-`Complements(dimension)` constraint.

The dimension of the vector-valued function `F` must be `dimension`. This
defines a complementarity constraint between the scalar function `F[i]` and the
variable in `F[i + dimension/2]`. Thus, `F[i + dimension/2]` must be
interpretable as a single variable `x_i` (for example, `1.0 * x + 0.0`), and
`dimension` must be even.

The mixed complementarity problem consists of finding `x_i` in the interval
`[lb, ub]` (that is, in the set `Interval(lb, ub)`), such that the following holds:

  1. `F_i(x) == 0` if `lb_i < x_i < ub_i`
  2. `F_i(x) >= 0` if `lb_i == x_i`
  3. `F_i(x) <= 0` if `x_i == ub_i`

Classically, the bounding set for `x_i` is `Interval(0, Inf)`, which recovers:
`0 <= F_i(x) ⟂ x_i >= 0`, where the `⟂` operator implies `F_i(x) * x_i = 0`.

## Example

The problem:

    x -in- Interval(-1, 1)
    [-4 * x - 3, x] -in- Complements(2)

defines the mixed complementarity problem where the following holds:

  1. `-4 * x - 3 == 0` if `-1 < x < 1`
  2. `-4 * x - 3 >= 0` if `x == -1`
  3. `-4 * x - 3 <= 0` if `x == 1`

There are three solutions:

  1. `x = -3/4` with `F(x) = 0`
  2. `x = -1` with `F(x) = 1`
  3. `x = 1` with `F(x) = -7`

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x, _ = MOI.add_constrained_variable(model, MOI.Interval(-1.0, 1.0));

julia> MOI.add_constraint(
            model,
            MOI.Utilities.vectorize([-4.0 * x - 3.0, x]),
            MOI.Complements(2),
        )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorAffineFunction{Float64}, MathOptInterface.Complements}(1)
```

The function `F` can also be defined in terms of single variables. For example,
the problem:

    [x_3, x_4] -in- Nonnegatives(2)
    [x_1, x_2, x_3, x_4] -in- Complements(4)

defines the complementarity problem where `0 <= x_1 ⟂ x_3 >= 0` and
`0 <= x_2 ⟂ x_4 >= 0`.

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 4);

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x[3:4]), MOI.Nonnegatives(2))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Nonnegatives}(1)

julia> MOI.add_constraint(
            model,
            MOI.VectorOfVariables(x),
            MOI.Complements(4),
        )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Complements}(1)
```
"""
struct Complements <: AbstractVectorSet
    dimension::Int
    function Complements(dimension::Base.Integer)
        if !(dimension >= 0 && iseven(dimension))
            throw(
                DimensionMismatch(
                    "Dimension of Complements must be even, not $(dimension).",
                ),
            )
        end
        return new(dimension)
    end
end

"""
    AllDifferent(dimension::Int)

The set ``\\{x \\in \\mathbb{Z}^{d}\\}`` such that no two elements in ``x`` take
the same value and `dimension = d`.

## Also known as

This constraint is called `all_different` in MiniZinc, and is sometimes also
called `distinct`.

## Example

To enforce `x[1] != x[2]` AND `x[1] != x[3]` AND `x[2] != x[3]`:

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.AllDifferent(3))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.AllDifferent}(1)
```
"""
struct AllDifferent <: AbstractVectorSet
    dimension::Int
    function AllDifferent(dimension::Base.Integer)
        if dimension < 0
            throw(DimensionMismatch("Dimension of AllDifferent must be >= 0."))
        end
        return new(dimension)
    end
end

"""
    BinPacking(c::T, w::Vector{T}) where {T}

The set ``\\{x \\in \\mathbb{Z}^d\\}`` where `d = length(w)`, such that each
item `i` in `1:d` of weight `w[i]` is put into bin `x[i]`, and the total weight
of each bin does not exceed `c`.

There are additional assumptions that the capacity, `c`, and the weights, `w`,
must all be non-negative.

The bin numbers depend on the bounds of `x`, so they may be something other than
the integers `1:d`.

## Also known as

This constraint is called `bin_packing` in MiniZinc.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> bins = MOI.add_variables(model, 5)
5-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)
 MOI.VariableIndex(4)
 MOI.VariableIndex(5)

julia> weights = Float64[1, 1, 2, 2, 3]
5-element Vector{Float64}:
 1.0
 1.0
 2.0
 2.0
 3.0

julia> MOI.add_constraint.(model, bins, MOI.Integer())
5-element Vector{MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}}:
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(1)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(2)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(3)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(4)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(5)

julia> MOI.add_constraint.(model, bins, MOI.Interval(4.0, 6.0))
5-element Vector{MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}}}:
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}}(1)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}}(2)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}}(3)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}}(4)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}}(5)

julia> MOI.add_constraint(model, MOI.VectorOfVariables(bins), MOI.BinPacking(3.0, weights))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.BinPacking{Float64}}(1)
```
"""
struct BinPacking{T} <: AbstractVectorSet
    capacity::T
    weights::Vector{T}
    function BinPacking(capacity::T, weights::Vector{T}) where {T}
        if capacity < zero(T)
            throw(DomainError(capacity, "capacity must be non-negative"))
        end
        if any(w -> w < zero(T), weights)
            throw(DomainError(weights, "weights must be non-negative"))
        end
        return new{T}(capacity, weights)
    end
end

dimension(set::BinPacking) = length(set.weights)

function Base.copy(set::BinPacking{T}) where {T}
    return BinPacking(set.capacity, copy(set.weights))
end

function Base.:(==)(x::BinPacking{T}, y::BinPacking{T}) where {T}
    return x.capacity == y.capacity && x.weights == y.weights
end

"""
    Circuit(dimension::Int)

The set ``\\{x \\in \\{1..d\\}^d\\}`` that constraints ``x`` to be a circuit,
such that ``x_i = j`` means that ``j`` is the successor of ``i``, and
`dimension = d`.

Graphs with multiple independent circuits, such as `[2, 1, 3]` and
`[2, 1, 4, 3]`, are not valid.

## Also known as

This constraint is called `circuit` in MiniZinc, and it is equivalent to forming
a (potentially sub-optimal) tour in the travelling salesperson problem.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Circuit(3))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Circuit}(1)
```
"""
struct Circuit <: AbstractVectorSet
    dimension::Int
    function Circuit(dimension::Base.Integer)
        if dimension < 0
            throw(DimensionMismatch("Dimension of Circuit must be >= 0."))
        end
        return new(dimension)
    end
end

"""
    CountAtLeast(n::Int, d::Vector{Int}, set::Set{Int})

The set ``\\{x \\in \\mathbb{Z}^{d_1 + d_2 + \\ldots d_N}\\}``, where `x` is
partitioned into `N` subsets (``\\{x_1,  \\ldots, x_{d_1}\\}``,
``\\{x_{d_1 + 1},  \\ldots, x_{d_1 + d_2}\\}`` and so on), and at least ``n``
elements of each subset take one of the values in `set`.

## Also known as

This constraint is called `at_least` in MiniZinc.

## Example

To ensure that `3` appears at least once in each of the subsets `{a, b}` and
`{b, c}`:

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> a, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(1), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(1))

julia> b, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(2), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(2))

julia> c, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(3), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(3))

julia> x, d, set = [a, b, b, c], [2, 2], [3]
(MathOptInterface.VariableIndex[MOI.VariableIndex(1), MOI.VariableIndex(2), MOI.VariableIndex(2), MOI.VariableIndex(3)], [2, 2], [3])

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.CountAtLeast(1, d, Set(set)))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.CountAtLeast}(1)
```
"""
struct CountAtLeast <: AbstractVectorSet
    n::Int
    partitions::Vector{Int}
    set::Set{Int}
    function CountAtLeast(
        n::Base.Integer,
        partitions::Vector{Int},
        set::Set{Int},
    )
        if any(p <= 0 for p in partitions)
            throw(DimensionMismatch("Invalid partition dimension."))
        end
        return new(n, partitions, set)
    end
end

dimension(s::CountAtLeast) = sum(s.partitions)

function Base.copy(set::CountAtLeast)
    return CountAtLeast(set.n, copy(set.partitions), copy(set.set))
end

function Base.:(==)(x::CountAtLeast, y::CountAtLeast)
    return x.n == y.n && x.partitions == y.partitions && x.set == y.set
end

"""
    CountBelongs(dimension::Int, set::Set{Int})

The set ``\\{(n, x) \\in \\mathbb{Z}^{1+d}\\}``, such that `n` elements of the
vector `x` take on of the values in `set` and `dimension = 1 + d`.

## Also known as

This constraint is called `among` by MiniZinc.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> n, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(1), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(1))

julia> x = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)
 MOI.VariableIndex(4)

julia> set = Set([3, 4, 5])
Set{Int64} with 3 elements:
  5
  4
  3

julia> MOI.add_constraint(model, MOI.VectorOfVariables([n; x]), MOI.CountBelongs(4, set))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.CountBelongs}(1)
```
"""
struct CountBelongs <: AbstractVectorSet
    dimension::Int
    set::Set{Int}
    function CountBelongs(dimension::Base.Integer, set::Set{Int})
        if dimension < 1
            throw(DimensionMismatch("Dimension of CountBelongs must be >= 1."))
        end
        return new(dimension, set)
    end
end

function Base.:(==)(x::CountBelongs, y::CountBelongs)
    return x.dimension == y.dimension && x.set == y.set
end

Base.copy(set::CountBelongs) = CountBelongs(set.dimension, copy(set.set))

"""
    CountDistinct(dimension::Int)

The set ``\\{(n, x) \\in \\mathbb{Z}^{1+d}\\}``, such that the number of distinct
values in `x` is `n` and `dimension = 1 + d`.

## Also known as

This constraint is called `nvalues` in MiniZinc.

## Example

To model:

 * if `n == 1`, then `x[1] == x[2] == x[3]`
 * if `n == 2`, then
    * `x[1] == x[2] != x[3]` or
    * `x[1] != x[2] == x[3]` or
    * `x[1] == x[3] != x[2]`
 * if `n == 3`, then `x[1] != x[2]`, `x[2] != x[3]` and `x[3] != x[1]`

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> n, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(1), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(1))

julia> x = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)
 MOI.VariableIndex(4)

julia> MOI.add_constraint(model, MOI.VectorOfVariables(vcat(n, x)), MOI.CountDistinct(4))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.CountDistinct}(1)
```

## Relationship to AllDifferent

When the first element is `d`, `CountDistinct` is equivalent to an
[`AllDifferent`](@ref) constraint.
"""
struct CountDistinct <: AbstractVectorSet
    dimension::Int
    function CountDistinct(dimension::Base.Integer)
        if dimension < 1
            throw(DimensionMismatch("Dimension of CountDistinct must be >= 1."))
        end
        return new(dimension)
    end
end

"""
    CountGreaterThan(dimension::Int)

The set ``\\{(c, y, x) \\in \\mathbb{Z}^{1+1+d}\\}``, such that `c` is strictly
greater than the number of occurences of `y` in `x` and `dimension = 1 + 1 + d`.

## Also known as

This constraint is called `count_gt` in MiniZinc.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> c, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(1), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(1))

julia> y, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(2), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(2))

julia> x = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(3)
 MOI.VariableIndex(4)
 MOI.VariableIndex(5)

julia> MOI.add_constraint(model, MOI.VectorOfVariables([c; y; x]), MOI.CountGreaterThan(5))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.CountGreaterThan}(1)
```
"""
struct CountGreaterThan <: AbstractVectorSet
    dimension::Int
    function CountGreaterThan(dimension::Base.Integer)
        if dimension < 2
            throw(
                DimensionMismatch(
                    "Dimension of CountGreaterThan must be >= 2.",
                ),
            )
        end
        return new(dimension)
    end
end

"""
    Cumulative(dimension::Int)

The set ``\\{(s, d, r, b) \\in \\mathbb{Z}^{3n+1}\\}``, representing the
`cumulative` global constraint, where
`n == length(s) == length(r) == length(b)` and `dimension = 3n + 1`.

`Cumulative` requires that a set of tasks given by start times ``s``, durations
``d``, and resource requirements ``r``, never requires more than the global
resource bound ``b`` at any one time.

## Also known as

This constraint is called `cumulative` in MiniZinc.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> s = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)

julia> d = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(4)
 MOI.VariableIndex(5)
 MOI.VariableIndex(6)

julia> r = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(7)
 MOI.VariableIndex(8)
 MOI.VariableIndex(9)

julia> b, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(10), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(10))

julia> MOI.add_constraint(model, MOI.VectorOfVariables([s; d; r; b]), MOI.Cumulative(10))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Cumulative}(1)
```
"""
struct Cumulative <: AbstractVectorSet
    dimension::Int
    function Cumulative(dimension::Base.Integer)
        if dimension < 1
            throw(DimensionMismatch("Dimension of Cumulative must be >= 1."))
        end
        return new(dimension)
    end
end

"""
    Path(from::Vector{Int}, to::Vector{Int})

Given a graph comprised of a set of nodes `1..N` and a set of arcs `1..E`
represented by an edge from node `from[i]` to node `to[i]`, `Path` constrains
the set
``(s, t, ns, es) \\in (1..N)\\times(1..E)\\times\\{0,1\\}^N\\times\\{0,1\\}^E``,
to form subgraph that is a path from node `s` to node `t`, where node `n` is in
the path if `ns[n]` is `1`, and edge `e` is in the path if `es[e]` is `1`.

The path must be acyclic, and it must traverse all nodes `n` for which `ns[n]`
is `1`, and all edges `e` for which `es[e]` is `1`.

## Also known as

This constraint is called `path` in MiniZinc.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> N, E = 4, 5
(4, 5)

julia> from = [1, 1, 2, 2, 3]
5-element Vector{Int64}:
 1
 1
 2
 2
 3

julia> to = [2, 3, 3, 4, 4]
5-element Vector{Int64}:
 2
 3
 3
 4
 4

julia> s, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(1), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(1))

julia> t, _ = MOI.add_constrained_variable(model, MOI.Integer())
(MOI.VariableIndex(2), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Integer}(2))

julia> ns = MOI.add_variables(model, N)
4-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(3)
 MOI.VariableIndex(4)
 MOI.VariableIndex(5)
 MOI.VariableIndex(6)

julia> MOI.add_constraint.(model, ns, MOI.ZeroOne())
4-element Vector{MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}}:
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(3)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(4)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(5)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(6)

julia> es = MOI.add_variables(model, E)
5-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(7)
 MOI.VariableIndex(8)
 MOI.VariableIndex(9)
 MOI.VariableIndex(10)
 MOI.VariableIndex(11)

julia> MOI.add_constraint.(model, es, MOI.ZeroOne())
5-element Vector{MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}}:
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(7)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(8)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(9)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(10)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(11)

julia> MOI.add_constraint(model, MOI.VectorOfVariables([s; t; ns; es]), MOI.Path(from, to))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Path}(1)
```
"""
struct Path <: AbstractVectorSet
    N::Int
    E::Int
    from::Vector{Int}
    to::Vector{Int}
    function Path(from::Vector{Int}, to::Vector{Int})
        @assert length(from) == length(to)
        E = length(from)
        N = max(maximum(from), maximum(to))
        return new(N, E, from, to)
    end
end

dimension(set::Path) = 2 + set.N + set.E

Base.copy(set::Path) = Path(copy(set.from), copy(set.to))

function Base.:(==)(x::Path, y::Path)
    return x.N == y.N && x.E == y.E && x.from == y.from && x.to == y.to
end

"""
    Table(table::Matrix{T}) where {T}

The set ``\\{x \\in \\mathbb{R}^d\\}`` where `d = size(table, 2)`, such that `x`
belongs to one row of `table`. That is, there exists some `j` in
`1:size(table, 1)`, such that `x[i] = table[j, i]` for all `i=1:size(table, 2)`.

## Also known as

This constraint is called `table` in MiniZinc.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3)
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)

julia> table = Float64[1 1 0; 0 1 1; 1 0 1; 1 1 1]
4×3 Matrix{Float64}:
 1.0  1.0  0.0
 0.0  1.0  1.0
 1.0  0.0  1.0
 1.0  1.0  1.0

julia> MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Table(table))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Table{Float64}}(1)
```
"""
struct Table{T} <: AbstractVectorSet
    table::Matrix{T}
end

dimension(set::Table) = size(set.table, 2)

Base.copy(set::Table) = Table(copy(set.table))

Base.:(==)(x::Table{T}, y::Table{T}) where {T} = x.table == y.table

"""
    HyperRectangle(lower::Vector{T}, upper::Vector{T}) where {T}

The set ``\\{x \\in \\bar{\\mathbb{R}}^d: x_i \\in [lower_i, upper_i] \\forall i=1,\\ldots,d\\}``.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3)
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)

julia> MOI.add_constraint(
           model,
           MOI.VectorOfVariables(x),
           MOI.HyperRectangle(zeros(3), ones(3)),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.HyperRectangle{Float64}}(1)
```
"""
struct HyperRectangle{T} <: AbstractVectorSet
    lower::Vector{T}
    upper::Vector{T}
    function HyperRectangle(lower::Vector{T}, upper::Vector{T}) where {T}
        l, u = length(lower), length(upper)
        if l != u
            throw(
                ArgumentError(
                    "length of lower (=$l) and upper (=$u) bounds must match.",
                ),
            )
        end
        return new{T}(lower, upper)
    end
end

dimension(set::HyperRectangle) = length(set.lower)

function Base.copy(set::HyperRectangle)
    return HyperRectangle(copy(set.lower), copy(set.upper))
end

function Base.:(==)(x::HyperRectangle{T}, y::HyperRectangle{T}) where {T}
    return x.lower == y.lower && x.upper == y.upper
end

"""
    Reified(set::AbstractSet)

The constraint ``[z; f(x)] \\in Reified(S)`` ensures that ``f(x) \\in S`` if and
only if ``z == 1``, where ``z \\in \\{0, 1\\}``.

```jldoctest
julia> model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}());

julia> z, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
(MOI.VariableIndex(1), MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(1))

julia> x = MOI.add_variable(model)
MOI.VariableIndex(2)

julia> MOI.add_constraint(
           model,
           MOI.Utilities.vectorize([z, 2.0 * x]),
           MOI.Reified(MOI.GreaterThan(1.0)),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorAffineFunction{Float64}, MathOptInterface.Reified{MathOptInterface.GreaterThan{Float64}}}(1)
```
"""
struct Reified{S<:AbstractSet} <: AbstractVectorSet
    set::S
end

dimension(s::Reified) = 1 + dimension(s.set)

Base.copy(s::Reified) = Reified(copy(s.set))

function Base.:(==)(x::Reified{S}, y::Reified{S}) where {S}
    return x.set == y.set
end

"""
    VectorNonlinearOracle(;
        dimension::Int,
        l::Vector{Float64},
        u::Vector{Float64},
        eval_f::Function,
        jacobian_structure::Vector{Tuple{Int,Int}},
        eval_jacobian::Function,
        hessian_lagrangian_structure::Vector{Tuple{Int,Int}} = Tuple{Int,Int}[],
        eval_hessian_lagrangian::Union{Nothing,Function} = nothing,
    ) <: AbstractVectorSet

The set:
```math
S = \\{x \\in \\mathbb{R}^{dimension}: l \\le f(x) \\le u\\}
```
where ``f`` is defined by the vectors `l` and `u`, and the callback oracles
`eval_f`, `eval_jacobian`, and `eval_hessian_lagrangian`.

## f

The `eval_f` function must have the signature
```julia
eval_f(ret::AbstractVector, x::AbstractVector)::Nothing
```
which fills ``f(x)`` into the dense vector `ret`.

## Jacobian

The `eval_jacobian` function must have the signature
```julia
eval_jacobian(ret::AbstractVector, x::AbstractVector)::Nothing
```
which fills the sparse Jacobian ``\\nabla f(x)`` into `ret`.

The one-indexed sparsity structure must be provided in the `jacobian_structure`
argument and it must be independent of the point ``x``.

`jacobian_structure` is not required to be sorted and it may contain duplicates,
in which case the solver will combine the corresponding non-zero values in `ret`
by adding them together.

## Hessian

The `eval_hessian_lagrangian` function is optional.

If `eval_hessian_lagrangian === nothing`, Ipopt will use a Hessian approximation
instead of the exact Hessian.

If `eval_hessian_lagrangian` is a function, it must have the signature
```julia
eval_hessian_lagrangian(
    ret::AbstractVector,
    x::AbstractVector,
    μ::AbstractVector,
)::Nothing
```
which fills the sparse Hessian of the Lagrangian ``\\sum \\mu_i \\nabla^2 f_i(x)``
into `ret`.

The one-indexed sparsity structure must be provided in the
`hessian_lagrangian_structure` argument and it must be independent of the point
``x``.

`hessian_lagrangian_structure` is not required to be sorted and it may contain
duplicates, in which case the solver will combine the corresponding non-zero
values in `ret` by adding them together.

Any mix of lower and upper-triangular indices is valid. Elements `(i, j)` and
`(j, i)`, if both present, are treated as duplicates.

## Example

To model the set:
```math
\\begin{aligned}
0 &\\le x^2                    & \\le 1 \\\\
0 &\\le y^2 + x \\cdot z^3 - w & \\le 0
\\end{aligned}
```
do
```jldoctest
julia> import MathOptInterface as MOI

julia> set = MOI.VectorNonlinearOracle(;
           dimension = 4,
           l = [0.0, 0.0],
           u = [1.0, 0.0],
           eval_f = (ret, x) -> begin
               ret[1] = x[2]^2
               ret[2] = x[3]^2 + x[2] * x[4]^3 - x[1]
               return
           end,
           jacobian_structure = [(1, 2), (2, 1), (2, 2), (2, 3), (2, 4)],
           eval_jacobian = (ret, x) -> begin
               ret[1] = 2.0 * x[2]
               ret[2] = -1.0
               ret[3] = x[4]^3
               ret[4] = 2.0 * x[3]
               ret[5] = 3.0 * x[2] * x[4]^2
               return
           end,
           hessian_lagrangian_structure = [(2, 2), (3, 3), (4, 4), (2, 4)],
           eval_hessian_lagrangian = (ret, x, u) -> begin
               ret[1] = 2.0 * u[1]
               ret[2] = 2.0 * u[2]
               ret[3] = 6.0 * x[4] * u[2]
               ret[4] = 3.0 * x[4]^2 * u[2]
               return
           end,
       );

julia> set
VectorNonlinearOracle{Float64}(;
    dimension = 4,
    l = [0.0, 0.0],
    u = [1.0, 0.0],
    ...,
)
```
"""
struct VectorNonlinearOracle{T} <: AbstractVectorSet
    input_dimension::Int
    output_dimension::Int
    l::Vector{T}
    u::Vector{T}
    eval_f::Function
    jacobian_structure::Vector{Tuple{Int,Int}}
    eval_jacobian::Function
    hessian_lagrangian_structure::Vector{Tuple{Int,Int}}
    eval_hessian_lagrangian::Union{Nothing,Function}

    function VectorNonlinearOracle(;
        dimension::Int,
        l::Vector{T},
        u::Vector{T},
        eval_f::Function,
        jacobian_structure::Vector{Tuple{Int,Int}},
        eval_jacobian::Function,
        # The hessian_lagrangian is optional.
        hessian_lagrangian_structure::Vector{Tuple{Int,Int}} = Tuple{Int,Int}[],
        eval_hessian_lagrangian::Union{Nothing,Function} = nothing,
    ) where {T}
        if length(l) != length(u)
            throw(DimensionMismatch())
        end
        return new{T}(
            dimension,
            length(l),
            l,
            u,
            eval_f,
            jacobian_structure,
            eval_jacobian,
            hessian_lagrangian_structure,
            eval_hessian_lagrangian,
        )
    end
end

dimension(s::VectorNonlinearOracle) = s.input_dimension

function Base.copy(s::VectorNonlinearOracle)
    return VectorNonlinearOracle(;
        dimension = s.input_dimension,
        l = copy(s.l),
        u = copy(s.u),
        eval_f = s.eval_f,
        jacobian_structure = copy(s.jacobian_structure),
        eval_jacobian = s.eval_jacobian,
        hessian_lagrangian_structure = copy(s.hessian_lagrangian_structure),
        eval_hessian_lagrangian = s.eval_hessian_lagrangian,
    )
end

function Base.:(==)(
    x::VectorNonlinearOracle{T},
    y::VectorNonlinearOracle{T},
) where {T}
    return x.input_dimension == y.input_dimension &&
           x.output_dimension == y.output_dimension &&
           x.l == y.l &&
           x.u == y.u &&
           x.eval_f == y.eval_f &&
           x.jacobian_structure == y.jacobian_structure &&
           x.eval_jacobian == y.eval_jacobian &&
           x.hessian_lagrangian_structure == y.hessian_lagrangian_structure &&
           x.eval_hessian_lagrangian == y.eval_hessian_lagrangian
end

function Base.show(io::IO, s::VectorNonlinearOracle{T}) where {T}
    println(io, "VectorNonlinearOracle{$T}(;")
    println(io, "    dimension = ", s.input_dimension, ",")
    println(io, "    l = ", s.l, ",")
    println(io, "    u = ", s.u, ",")
    println(io, "    ...,")
    print(io, ")")
    return
end

# TODO(odow): these are not necessarily isbits. They may not be safe to return
# without copying if the number is BigFloat, for example.
function Base.copy(
    set::Union{
        GreaterThan,
        LessThan,
        EqualTo,
        Parameter,
        Interval,
        Semicontinuous,
        Semiinteger,
        PowerCone,
        DualPowerCone,
    },
)
    return set
end

"""
    supports_dimension_update(S::Type{<:MOI.AbstractVectorSet})

Return a `Bool` indicating whether the elimination of any dimension of
`n`-dimensional sets of type `S` give an `n-1`-dimensional set `S`.
By default, this function returns `false` so it should only be implemented
for sets that supports dimension update.

For instance, `supports_dimension_update(MOI.Nonnegatives)` is `true` because
the elimination of any dimension of the `n`-dimensional nonnegative orthant
gives the `n-1`-dimensional nonnegative orthant. However
`supports_dimension_update(MOI.ExponentialCone)` is `false`.
"""
supports_dimension_update(::Type{<:AbstractVectorSet}) = false

supports_dimension_update(::Type{Reals}) = true
supports_dimension_update(::Type{Zeros}) = true
supports_dimension_update(::Type{Nonnegatives}) = true
supports_dimension_update(::Type{Nonpositives}) = true

"""
    update_dimension(s::AbstractVectorSet, new_dim::Int)

Returns a set with the dimension modified to `new_dim`.
"""
function update_dimension end

update_dimension(::Reals, new_dim::Int) = Reals(new_dim)
update_dimension(::Zeros, new_dim::Int) = Zeros(new_dim)
update_dimension(::Nonnegatives, new_dim::Int) = Nonnegatives(new_dim)
update_dimension(::Nonpositives, new_dim::Int) = Nonpositives(new_dim)

"""
    constant(set::Union{EqualTo,GreaterThan,LessThan,Parameter})

Returns the constant term of the set `set`.

## Example

```jldoctest
julia> MOI.constant(MOI.GreaterThan(1.0))
1.0

julia> MOI.constant(MOI.LessThan(2.5))
2.5

julia> MOI.constant(MOI.EqualTo(3))
3

julia> MOI.constant(MOI.Parameter(4.5))
4.5
```
"""
constant(s::EqualTo) = s.value
constant(s::GreaterThan) = s.lower
constant(s::LessThan) = s.upper
constant(s::Parameter) = s.value

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    FreeBridge{T} <: Bridges.Variable.AbstractBridge

`FreeBridge` implements the following reformulation:

* ``x \\in \\mathbb{R}`` into ``y, z \\ge 0`` with the substitution
  rule ``x = y - z``,

where `T` is the coefficient type of `y - z`.

## Source node

`FreeBridge` supports:

 * [`MOI.VectorOfVariables`](@ref) in [`MOI.Reals`](@ref)

## Target nodes

`FreeBridge` creates:

 * One variable node: [`MOI.VectorOfVariables`](@ref) in [`MOI.Nonnegatives`](@ref)
"""
struct FreeBridge{T} <: AbstractBridge
    variables::Vector{MOI.VariableIndex}
    constraint::MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives}
end

const Free{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{FreeBridge{T},OT}

function bridge_constrained_variable(
    ::Type{FreeBridge{T}},
    model::MOI.ModelLike,
    set::MOI.Reals,
) where {T}
    variables, constraint = MOI.add_constrained_variables(
        model,
        MOI.Nonnegatives(2 * MOI.dimension(set)),
    )
    return FreeBridge{T}(variables, constraint)
end

supports_constrained_variable(::Type{<:FreeBridge}, ::Type{MOI.Reals}) = true

function MOI.Bridges.added_constrained_variable_types(::Type{<:FreeBridge})
    return Tuple{Type}[(MOI.Nonnegatives,)]
end

function MOI.Bridges.added_constraint_types(::Type{FreeBridge{T}}) where {T}
    return Tuple{Type,Type}[]
end

# Attributes, Bridge acting as a model
function MOI.get(bridge::FreeBridge, ::MOI.NumberOfVariables)::Int64
    return length(bridge.variables)
end

function MOI.get(bridge::FreeBridge, ::MOI.ListOfVariableIndices)
    return copy(bridge.variables)
end

function MOI.get(
    ::FreeBridge,
    ::MOI.NumberOfConstraints{MOI.VectorOfVariables,MOI.Nonnegatives},
)::Int64
    return 1
end

function MOI.get(
    bridge::FreeBridge,
    ::MOI.ListOfConstraintIndices{MOI.VectorOfVariables,MOI.Nonnegatives},
)
    return [bridge.constraint]
end

# References
function MOI.delete(model::MOI.ModelLike, bridge::FreeBridge)
    MOI.delete(model, bridge.variables)
    return
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::FreeBridge,
    i::MOI.Bridges.IndexInVector,
)
    n = div(length(bridge.variables), 2)
    MOI.delete(model, bridge.variables[i.value])
    MOI.delete(model, bridge.variables[n+i.value])
    deleteat!(bridge.variables, [i.value, n + i.value])
    return
end

# Attributes, Bridge acting as a constraint

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::FreeBridge{T},
) where {T}
    n = div(length(bridge.variables), 2)
    primal = MOI.get(model, attr, bridge.constraint)
    return primal[1:n] - primal[n .+ (1:n)]
end

# The transformation is x_free = [I -I] * x
# so the transformation of the dual is
# y = [I; -I] * y_free
# that is
# y[1:n] = -y[n .+ (1:n)] = y_free
# We can therefore compute `y_free` from either of them, let's take `y[1:n]`.
function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    bridge::FreeBridge{T},
) where {T}
    n = div(length(bridge.variables), 2)
    return MOI.get(model, attr, bridge.constraint)[1:n]
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.VariablePrimal,MOI.VariablePrimalStart},
    bridge::FreeBridge{T},
    i::MOI.Bridges.IndexInVector,
) where {T}
    n = div(length(bridge.variables), 2)
    primal_pos = MOI.get(model, attr, bridge.variables[i.value])
    primal_neg = MOI.get(model, attr, bridge.variables[n+i.value])
    if primal_pos === nothing || primal_neg === nothing
        return nothing
    end
    return primal_pos - primal_neg
end

function MOI.Bridges.bridged_function(
    bridge::FreeBridge{T},
    i::MOI.Bridges.IndexInVector,
) where {T}
    n = div(length(bridge.variables), 2)
    y = bridge.variables[i.value]
    z = bridge.variables[n+i.value]
    return MOI.Utilities.operate(-, T, y, z)
end

# x_free has been replaced by x[i] - x[n + i].
# To undo it we replace x[i] by x_free and x[n + i] by 0.
function unbridged_map(
    bridge::FreeBridge{T},
    vi::MOI.VariableIndex,
    i::MOI.Bridges.IndexInVector,
) where {T}
    n = div(length(bridge.variables), 2)
    y = bridge.variables[i.value] => convert(MOI.ScalarAffineFunction{T}, vi)
    z = bridge.variables[n+i.value] => zero(MOI.ScalarAffineFunction{T})
    return y, z
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    ::Type{<:FreeBridge},
)
    return MOI.supports(model, attr, MOI.VariableIndex)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    bridge::FreeBridge,
    value,
    i::MOI.Bridges.IndexInVector,
)
    n = div(length(bridge.variables), 2)
    MOI.set(model, attr, bridge.variables[i.value], max(zero(value), value))
    MOI.set(model, attr, bridge.variables[n+i.value], -min(zero(value), value))
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    bridge::FreeBridge,
    ::Nothing,
    i::MOI.Bridges.IndexInVector,
)
    n = div(length(bridge.variables), 2)
    MOI.set(model, attr, bridge.variables[i.value], nothing)
    MOI.set(model, attr, bridge.variables[n+i.value], nothing)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestMockOptimizer

using Test
import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

# function test_optimizer_solve_no_result()
#     optimizer = MOIU.MockOptimizer(MOIU.Model{Float64}())

#     v1 = MOI.add_variable(optimizer)

#     # Load fake solution
#     MOI.set(optimizer, MOI.TerminationStatus(), MOI.INFEASIBLE)
#     MOI.optimize!(optimizer)
#     @test MOI.get(optimizer, MOI.TerminationStatus()) == MOI.INFEASIBLE

#     MOI.set(optimizer, MOI.ConflictStatus(), MOI.CONFLICT_FOUND)
#     MOI.compute_conflict!(optimizer)
#     @test MOI.get(optimizer, MOI.ConflictStatus()) == MOI.CONFLICT_FOUND
# end

function test_optimizer_solve_with_result()
    optimizer = MOIU.MockOptimizer(
        MOIU.Model{Float64}(),
        eval_objective_value = false,
        eval_variable_constraint_dual = false,
    )

    v = MOI.add_variables(optimizer, 2)
    c1 = MOI.add_constraint(optimizer, v[1], MOI.GreaterThan(1.0))
    soc = MOI.add_constraint(
        optimizer,
        MOI.VectorOfVariables(v),
        MOI.SecondOrderCone(2),
    )
    MOI.set(optimizer, MOI.ObjectiveFunction{MOI.VariableIndex}(), v[1])
    MOI.set(optimizer, MOI.ResultCount(), 1)
    @test_throws(
        ErrorException("No mock primal is set for variable `$(v[1])`."),
        MOI.get(optimizer, MOI.VariablePrimal(), v[1])
    )
    @test_throws(
        MOI.InvalidIndex(MOI.VariableIndex(-1)),
        MOI.get(optimizer, MOI.VariablePrimal(), MOI.VariableIndex(-1))
    )
    MOI.set(optimizer, MOI.ResultCount(), 0)
    err = MOI.ResultIndexBoundsError(MOI.VariablePrimal(1), 0)
    @test_throws err MOI.get(optimizer, MOI.VariablePrimal(), v[1])
    err = MOI.ResultIndexBoundsError(MOI.ConstraintDual(1), 0)
    @test_throws err MOI.get(optimizer, MOI.ConstraintDual(), c1)

    # Load fake solution
    # TODO: Provide a more compact API for this.
    MOI.set(optimizer, MOI.TerminationStatus(), MOI.OPTIMAL)
    MOI.set(optimizer, MOI.ObjectiveValue(), 1.0)
    MOI.set(optimizer, MOI.DualObjectiveValue(2), 2.0)
    MOI.set(optimizer, MOI.ResultCount(), 2)
    MOI.set(optimizer, MOI.PrimalStatus(), MOI.FEASIBLE_POINT)
    MOI.set(optimizer, MOI.DualStatus(2), MOI.FEASIBLE_POINT)
    MOI.set(optimizer, MOI.VariablePrimal(), v, [1.0, 2.0])
    MOI.set(optimizer, MOI.VariablePrimal(), v[1], 3.0)
    MOI.set(optimizer, MOI.ConstraintDual(2), c1, 5.9)
    MOI.set(optimizer, MOI.ConstraintDual(2), soc, [1.0, 2.0])

    MOI.optimize!(optimizer)
    @test MOI.get(optimizer, MOI.TerminationStatus()) == MOI.OPTIMAL
    @test MOI.get(optimizer, MOI.ResultCount()) == 2
    @test MOI.get(optimizer, MOI.ObjectiveValue()) == 1.0
    @test isnan(MOI.get(optimizer, MOI.ObjectiveValue(2)))
    optimizer.eval_objective_value = true
    @test MOI.get(optimizer, MOI.ObjectiveValue()) == 3.0
    @test_throws(
        ErrorException(
            "No mock primal is set for variable `$(v[1])` at result index `2`.",
        ),
        MOI.get(optimizer, MOI.ObjectiveValue(2))
    )
    @test_throws(
        ErrorException(
            "No mock dual is set for constraint `$c1` at result index `1`.",
        ),
        MOI.get(optimizer, MOI.DualObjectiveValue())
    )
    @test MOI.get(optimizer, MOI.DualObjectiveValue(2)) == 5.9
    @test MOI.get(optimizer, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(optimizer, MOI.DualStatus(2)) == MOI.FEASIBLE_POINT
    @test MOI.get(optimizer, MOI.VariablePrimal(), v) == [3.0, 2.0]
    @test MOI.get(optimizer, MOI.VariablePrimal(), v[1]) == 3.0
    @test_throws(
        ErrorException(
            "No mock primal is set for variable `$(v[1])` at result index `2`.",
        ),
        MOI.get(optimizer, MOI.VariablePrimal(2), v[1])
    )
    @test MOI.get(optimizer, MOI.ConstraintPrimal(), c1) == 3.0
    @test MOI.get(optimizer, MOI.ConstraintPrimal(), soc) == [3.0, 2.0]
    @test_throws(
        ErrorException(
            "No mock primal is set for variable `$(v[1])` at result index `2`.",
        ),
        MOI.get(optimizer, MOI.ConstraintPrimal(2), c1),
    )
    @test_throws(
        ErrorException(
            "No mock primal is set for variable `$(v[1])` at result index `2`.",
        ),
        MOI.get(optimizer, MOI.ConstraintPrimal(2), soc)
    )
    @test MOI.get(optimizer, MOI.ConstraintDual(2), c1) == 5.9
    @test MOI.get(optimizer, MOI.ConstraintDual(2), soc) == [1.0, 2.0]
    @test_throws(
        ErrorException(
            "No mock dual is set for constraint `$c1` at result index `1`.",
        ),
        MOI.get(optimizer, MOI.ConstraintDual(1), c1)
    )
end

function test_CanonicalConstraintFunction()
    mock = MOIU.MockOptimizer(MOIU.Model{Int}())
    fx, fy = MOI.add_variables(mock, 2)
    cx = MOI.add_constraint(mock, fx, MOI.LessThan(0))
    c = MOI.add_constraint(mock, 1fx + fy, MOI.LessThan(1))
    @test MOIU.is_canonical(MOI.get(mock, MOI.ConstraintFunction(), cx))
    @test MOIU.is_canonical(
        MOI.get(mock, MOI.CanonicalConstraintFunction(), cx),
    )
    @test !MOIU.is_canonical(MOI.get(mock, MOI.ConstraintFunction(), c))
    func = MOI.get(mock, MOI.CanonicalConstraintFunction(), c)
    @test MOIU.is_canonical(func)
    # Check that indices have been xored
    for term in func.terms
        @test MOI.is_valid(mock, term.variable)
    end
end

function test_conflict_access()
    mock = MOIU.MockOptimizer(MOIU.Model{Int}())
    fx, fy = MOI.add_variables(mock, 2)
    cx = MOI.add_constraint(mock, fx, MOI.LessThan(0))
    c = MOI.add_constraint(mock, 1fx + fy, MOI.LessThan(1))
    MOI.set(mock, MOI.ConstraintConflictStatus(), cx, MOI.NOT_IN_CONFLICT)
    MOI.set(mock, MOI.ConstraintConflictStatus(), c, MOI.IN_CONFLICT)
    MOI.set(mock, MOI.ConflictCount(), 1)
    MOI.compute_conflict!(mock)
    @test MOI.get(mock, MOI.ConstraintConflictStatus(), cx) ==
          MOI.NOT_IN_CONFLICT
    @test MOI.get(mock, MOI.ConstraintConflictStatus(), c) == MOI.IN_CONFLICT
end

function test_MockVariableAttribute()
    mock = MOIU.MockOptimizer(MOIU.Model{Int}())
    x = MOI.add_variable(mock)
    MOI.set(mock, MOI.Utilities.MockVariableAttribute(), x, 1)
    @test MOI.get(mock, MOI.Utilities.MockVariableAttribute(), x) == 1
    return
end

function test_MockConstraintAttribute()
    mock = MOIU.MockOptimizer(MOIU.Model{Int}())
    x = MOI.add_variable(mock)
    c = MOI.add_constraint(mock, x, MOI.LessThan(0))
    @test MOI.supports(mock, MOI.Utilities.MockConstraintAttribute(), typeof(c))
    MOI.set(mock, MOI.Utilities.MockConstraintAttribute(), c, 1)
    @test MOI.get(mock, MOI.Utilities.MockConstraintAttribute(), c) == 1
    return
end

function test_DualObjectiveValue()
    mock =
        MOIU.MockOptimizer(MOIU.Model{Int}(); eval_dual_objective_value = false)
    @test isnan(MOI.get(mock, MOI.DualObjectiveValue()))
    return
end

function test_add_con_allowed_false()
    model = MOI.Utilities.MockOptimizer(
        MOI.Utilities.Model{Float64}();
        add_con_allowed = false,
    )
    x = MOI.add_variable(model)
    @test_throws(
        MOI.AddConstraintNotAllowed,
        MOI.add_constraint(model, x, MOI.ZeroOne()),
    )
    @test_throws(
        MOI.AddConstraintNotAllowed,
        MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(1.0)),
    )
    return
end

function test_supports_names_false()
    model = MOI.Utilities.MockOptimizer(
        MOI.Utilities.Model{Float64}();
        supports_names = false,
    )
    @test_throws(
        MOI.UnsupportedAttribute{MOI.Name},
        MOI.set(model, MOI.Name(), "model"),
    )
    x = MOI.add_variable(model)
    @test_throws(
        MOI.UnsupportedAttribute{MOI.VariableName},
        MOI.set(model, MOI.VariableName(), x, "x"),
    )
    c = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(1.0))
    @test_throws(
        MOI.UnsupportedAttribute{MOI.ConstraintName},
        MOI.set(model, MOI.ConstraintName(), c, "c"),
    )
    return
end

function test_delete_allowed_false()
    model = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model.delete_allowed = false
    x = MOI.add_variable(model)
    @test_throws(MOI.DeleteNotAllowed{MOI.VariableIndex}, MOI.delete(model, x))
    @test_throws(
        MOI.DeleteNotAllowed{MOI.VariableIndex},
        MOI.delete(model, [x]),
    )
    return
end

function test_modify_not_allowed()
    model = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    config = MOI.Test.Config(
        exclude = Any[MOI.ScalarCoefficientChange, MOI.VectorConstantChange],
    )
    MOI.Test.runtests(
        model,
        config,
        include = [
            r"^test_linear_integration$",
            r"^test_linear_integration_modification$",
            r"^test_linear_VectorAffineFunction$",
        ],
    )
    return
end

function test_get_fallback_constraint_dual()
    model = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = MOI.VectorOfVariables(x)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(model, f, MOI.Nonnegatives(2))
    @test_throws(
        ErrorException(
            "Fallback getter for variable constraint dual does not support objective function of type $(MOI.VectorOfVariables). Please report this issue to the solver wrapper package.",
        ),
        MOI.Utilities.get_fallback(model, MOI.ConstraintDual(), c),
    )
    return
end

struct SetByOptimizeAttribute <: MOI.AbstractOptimizerAttribute end

MOI.is_set_by_optimize(::SetByOptimizeAttribute) = true

function test_is_set_by_optimize_optimizer_attribute()
    model = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    MOI.set(model, SetByOptimizeAttribute(), 1.23)
    @test MOI.get(model, SetByOptimizeAttribute()) == 1.23
    return
end

function test_empty_constructor()
    mock = MOI.Utilities.MockOptimizer(Int; supports_names = false)
    @test mock.supports_names == false
    @test isa(
        mock,
        MOI.Utilities.MockOptimizer{
            MOI.Utilities.UniversalFallback{MOI.Utilities.Model{Int}},
            Int,
        },
    )
    mock = MOI.Utilities.MockOptimizer()
    @test mock.supports_names
    @test isa(
        mock,
        MOI.Utilities.MockOptimizer{
            MOI.Utilities.UniversalFallback{MOI.Utilities.Model{Float64}},
            Float64,
        },
    )
    return
end

end  # module

TestMockOptimizer.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SetConversionBridge{T,S2,S1,F} <:
        MOI.Bridges.Constraint.SetMapBridge{T,S2,S1,F,F}

`SetConversionBridge` implements the following reformulations:

  * ``f(x) \\in S1`` into ``f(x) \\in S2``

In order to add this bridge, you need to create a bridge specific
for a given type `T` and set `S2`:
```julia
MOI.Bridges.add_bridge(model, MOI.Bridges.Constraint.SetConversionBridge{T,S2})
```
In order to define a bridge with `S2` specified but `T` unspecified, for example
for `JuMP.add_bridge`, you can use
```julia
const MyBridge{T,S1,F} = MOI.Bridges.Constraint.SetConversionBridge{T,S2,S1,F}
```

See also [`FunctionConversionBridge`](@ref).

## Source node

`SetConversionBridge` supports:

  * `F` in `S1`

## Target nodes

`SetConversionBridge` creates:

  * `F` in `S2`
"""
struct SetConversionBridge{T,S2,S1,F} <:
       MOI.Bridges.Constraint.SetMapBridge{T,S2,S1,F,F}
    constraint::MOI.ConstraintIndex{F,S2}
end

function MOI.supports_constraint(
    ::Type{SetConversionBridge{T,S2}},
    ::Type{F},
    ::Type{S1},
) where {T,F<:MOI.AbstractFunction,S1<:MOI.AbstractSet,S2}
    return isfinite(MOI.Bridges.Constraint.conversion_cost(S2, S1))
end

function MOI.Bridges.Constraint.concrete_bridge_type(
    ::Type{SetConversionBridge{T,S2}},
    ::Type{F},
    ::Type{S1},
) where {T,F<:MOI.AbstractFunction,S1<:MOI.AbstractSet,S2}
    return SetConversionBridge{T,S2,S1,F}
end

function MOI.Bridges.Constraint.conversion_cost(
    ::Type{<:MOI.AbstractSet},
    ::Type{<:MOI.AbstractSet},
)
    return Inf
end

function MOI.Bridges.bridging_cost(
    ::Type{<:SetConversionBridge{T,S2,S1}},
) where {T,S2,S1}
    return MOI.Bridges.Constraint.conversion_cost(S2, S1)
end

function MOI.Bridges.map_set(
    ::Type{<:SetConversionBridge{T,S2,S1}},
    set::S1,
) where {T,S2,S1}
    return convert(S2, set)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:SetConversionBridge{T,S2,S1}},
    set::S2,
) where {T,S2,S1}
    return convert(S1, set)
end

function MOI.Bridges.map_function(::Type{<:SetConversionBridge}, func)
    return func
end

function MOI.Bridges.inverse_map_function(::Type{<:SetConversionBridge}, func)
    return func
end

function MOI.Bridges.adjoint_map_function(::Type{<:SetConversionBridge}, func)
    return func
end

function MOI.Bridges.inverse_adjoint_map_function(
    ::Type{<:SetConversionBridge},
    func,
)
    return func
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSlack

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_scalar_slack()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.ScalarSlack{Float64}(mock)

    x = MOI.add_variable(bridged_mock)
    y = MOI.add_variable(bridged_mock)
    f = MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm{Float64}.([1.0, 2.0], [x, y]),
        0.0,
    )
    ci = MOI.add_constraint(bridged_mock, f, MOI.GreaterThan(0.0))
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈ f
    newf = MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm{Float64}.([2.0, 1.0], [x, y]),
        0.0,
    )
    MOI.set(bridged_mock, MOI.ConstraintFunction(), ci, newf)
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈ newf
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.GreaterThan(0.0)
    MOI.set(bridged_mock, MOI.ConstraintSet(), ci, MOI.GreaterThan(1.0))
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.GreaterThan(1.0)
    MOI.modify(bridged_mock, ci, MOI.ScalarConstantChange{Float64}(1.0))
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈
          MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm{Float64}.([2.0, 1.0], [x, y]),
        1.0,
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, 2.0)
        @test MOI.get(bridged_mock, attr, ci) == 2.0
        bridge = MOI.Bridges.bridge(bridged_mock, ci)
        if attr isa MOI.ConstraintPrimalStart
            @test MOI.get(mock, MOI.VariablePrimalStart(), bridge.slack) == 2.0
            @test MOI.get(mock, attr, bridge.equality) == 0.0
        else
            @test MOI.get(mock, attr, bridge.equality) == 2.0
        end
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.VariableIndex, MOI.GreaterThan{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}, 0),
        ),
    )
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_ScalarAffineFunction_GreaterThan",
            "test_basic_ScalarAffineFunction_LessThan",
            "test_basic_ScalarQuadraticFunction_GreaterThan",
            "test_basic_ScalarQuadraticFunction_LessThan",
        ],
    )
    MOI.empty!(bridged_mock)
    # There are extra variables due to the bridge
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1, 0, 1],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                    [MOI.NONBASIC],
            ],
            variable_basis_status = [
                MOI.BASIC,
                MOI.NONBASIC_AT_LOWER,
                MOI.NONBASIC_AT_UPPER,
            ],
        ),
    )
    config = MOI.Test.Config(
        exclude = Any[MOI.ConstraintDual, MOI.DualObjectiveValue],
    )
    MOI.Test.test_linear_integration_2(bridged_mock, config)
    c1 = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(c1) == 1
    @test MOI.get(bridged_mock, MOI.ConstraintBasisStatus(), c1[]) ==
          MOI.NONBASIC
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [1.0, 1.0, 2.0, 2.0]),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [0.5, 0.5, 1.0, 1.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [1, 0],
            (MOI.VariableIndex, MOI.GreaterThan{Float64}) => [1],
            (MOI.VariableIndex, MOI.LessThan{Float64}) => [0],
        ),
    )
    MOI.Test.test_linear_transform(bridged_mock, config)
    c1 = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.GreaterThan{Float64},
        }(),
    )
    @test length(c1) == 1
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), c1[]) ≈ 1.0
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), c1[]) ≈ 1.0
    c2 = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        }(),
    )
    @test length(c2) == 1
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), c2[]) ≈ 1.0
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), c2[]) ≈ 0.0
    loc = MOI.get(bridged_mock, MOI.ListOfConstraintTypesPresent())
    @test length(loc) == 2
    @test (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) in loc
    @test (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) in loc
    loc = MOI.get(mock, MOI.ListOfConstraintTypesPresent())
    @test length(loc) == 3
    @test (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) in loc
    @test (MOI.VariableIndex, MOI.LessThan{Float64}) in loc
    @test (MOI.VariableIndex, MOI.GreaterThan{Float64}) in loc
    for T in [Int, Float64], S in [MOI.GreaterThan{T}, MOI.GreaterThan{T}]
        for F in [MOI.ScalarAffineFunction{T}, MOI.ScalarQuadraticFunction{T}]
            @test MOI.Bridges.added_constraint_types(
                MOI.Bridges.Constraint.ScalarSlackBridge{T,F,S},
            ) == [(F, MOI.EqualTo{T})]
        end
    end
    return
end

function test_vector_slack()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.VectorSlack{Float64}(mock)

    x = MOI.add_variable(bridged_mock)
    y = MOI.add_variable(bridged_mock)
    f = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.([1.0, 2.0], [x, y])),
        [0.0],
    )
    ci = MOI.add_constraint(bridged_mock, f, MOI.Nonpositives(1))
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈ f
    newf = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.([2.0, 1.0], [x, y])),
        [0.0],
    )
    MOI.set(bridged_mock, MOI.ConstraintFunction(), ci, newf)
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈ newf
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.Nonpositives(1)
    MOI.modify(bridged_mock, ci, MOI.VectorConstantChange([1.0]))
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈
          MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.([2.0, 1.0], [x, y])),
        [1.0],
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, [2.0])
        @test MOI.get(bridged_mock, attr, ci) == [2.0]
        bridge = MOI.Bridges.bridge(bridged_mock, ci)
        if attr isa MOI.ConstraintPrimalStart
            @test MOI.get(mock, MOI.VariablePrimalStart(), bridge.slack) ==
                  [2.0]
            @test MOI.get(mock, attr, bridge.equality) == [0.0]
        else
            @test MOI.get(mock, attr, bridge.equality) == [2.0]
        end
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.VectorOfVariables, MOI.Nonpositives, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros, 0),
        ),
    )

    fp = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(
            [1, 2, 3],
            MOI.ScalarAffineTerm.([1.0, 2.0, 3.0], [x, y, y]),
        ),
        [0.0, 0.0, 0.0],
    )
    cp = MOI.add_constraint(bridged_mock, fp, MOI.PowerCone(0.1))
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), cp) == MOI.PowerCone(0.1)
    MOI.set(bridged_mock, MOI.ConstraintSet(), cp, MOI.PowerCone(0.2))
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), cp) == MOI.PowerCone(0.2)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorAffineFunction_Nonnegatives",
            "test_basic_VectorAffineFunction_Nonpositives",
            "test_basic_VectorQuadraticFunction_Nonnegatives",
            "test_basic_VectorQuadraticFunction_Nonpositives",
        ],
    )
    MOI.empty!(bridged_mock)
    # There are extra variables due to the bridge
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0, 0, 0, 0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100, 0, 100, 0]),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [100, -100, 100, -100],
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) =>
                [[1.0], [1.0]],
            (MOI.VectorOfVariables, MOI.Nonnegatives) => [[1.0]],
            (MOI.VectorOfVariables, MOI.Nonpositives) => [[1.0]],
        ),
    )
    MOI.Test.test_linear_VectorAffineFunction(bridged_mock, config)
    c1 = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Nonnegatives,
        }(),
    )
    @test length(c1) == 1
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), c1[]) ≈ [100.0]
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), c1[]) ≈ [1.0]
    c2 = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.Nonpositives,
        }(),
    )
    @test length(c2) == 1
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), c2[]) ≈ [-100.0]
    @test MOI.get(bridged_mock, MOI.ConstraintDual(), c2[]) ≈ [1.0]
    loc = MOI.get(bridged_mock, MOI.ListOfConstraintTypesPresent())
    @test length(loc) == 2
    @test (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) in loc
    @test (MOI.VectorAffineFunction{Float64}, MOI.Nonpositives) in loc
    loc = MOI.get(mock, MOI.ListOfConstraintTypesPresent())
    @test length(loc) == 3
    @test (MOI.VectorAffineFunction{Float64}, MOI.Zeros) in loc
    @test (MOI.VectorOfVariables, MOI.Nonnegatives) in loc
    @test (MOI.VectorOfVariables, MOI.Nonpositives) in loc
    for T in [Int, Float64], S in [MOI.Nonnegatives, MOI.Nonpositives]
        for F in [MOI.VectorAffineFunction{T}, MOI.VectorQuadraticFunction{T}]
            @test MOI.Bridges.added_constraint_types(
                MOI.Bridges.Constraint.VectorSlackBridge{T,F,S},
            ) == [(F, MOI.Zeros)]
        end
    end
    return
end

function test_basic_VectorNonlinearFunction()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.VectorSlack{Float64}(mock)
    MOI.Test.test_basic_VectorNonlinearFunction_Nonnegatives(
        bridged_mock,
        MOI.Test.Config(),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ScalarSlackBridge,
        """
        variables: x
        1.0 * x >= 2.0
        """,
        """
        variables: x, y
        1.0 * x + -1.0 * y == 0.0
        y >= 2.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ScalarSlackBridge,
        """
        variables: x
        1.0 * x <= 2.0
        """,
        """
        variables: x, y
        1.0 * x + -1.0 * y == 0.0
        y <= 2.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ScalarSlackBridge,
        """
        variables: x
        ScalarNonlinearFunction(log(x)) <= 2.0
        """,
        """
        variables: x, y
        ScalarNonlinearFunction(log(x) - y) == 0.0
        y <= 2.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ScalarSlackBridge,
        """
        variables: x
        1.0 * x in ZeroOne()
        """,
        """
        variables: x, y
        1.0 * x + -1.0 * y == 0.0
        y in ZeroOne()
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorSlackBridge,
        """
        variables: x
        [1.0 * x] in Nonnegatives(1)
        """,
        """
        variables: x, y
        [1.0 * x + -1.0 * y] in Zeros(1)
        [y] in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorSlackBridge,
        """
        variables: x
        [1.0 * x] in Nonpositives(1)
        """,
        """
        variables: x, y
        [1.0 * x + -1.0 * y] in Zeros(1)
        [y] in Nonpositives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorSlackBridge,
        """
        variables: x, t
        [1.0 * t, 2.0 * x] in SecondOrderCone(2)
        """,
        """
        variables: x, t, y, z
        [1.0 * t + -1.0 * y, 2.0 * x + -1.0 * z] in Zeros(2)
        [y, z] in SecondOrderCone(2)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorSlackBridge,
        """
        variables: x11, x12, x22
        [1.0 * x11, x12, 2.0 * x22] in PositiveSemidefiniteConeTriangle(2)
        """,
        """
        variables: x11, x12, x22, y11, y12, y22
        [1.0 * x11 + -1.0 * y11, x12 + -1.0 * y12, 2.0 * x22 + -1.0 * y22] in Zeros(3)
        [y11, y12, y22] in PositiveSemidefiniteConeTriangle(2)
        """,
    )
    return
end

function test_basis_status()
    inner = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Bridges.Constraint.ScalarSlack{Float64}(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.GreaterThan(1.0))
    y = MOI.get(inner, MOI.ListOfVariableIndices())
    MOI.set.(inner, MOI.VariableBasisStatus(), y, MOI.BASIC)
    @test MOI.get(model, MOI.ConstraintBasisStatus(), c) == MOI.BASIC
    d = MOI.add_constraint(model, 1.0 * x, MOI.Interval(1.0, 2.0))
    z = last(MOI.get(inner, MOI.ListOfVariableIndices()))
    MOI.set(inner, MOI.VariableBasisStatus(), z, MOI.SUPER_BASIC)
    @test MOI.get(model, MOI.ConstraintBasisStatus(), d) == MOI.SUPER_BASIC
    return
end

function test_internal_error()
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    BT = MOI.Bridges.Constraint.ScalarSlackBridge{Float64,F,S}
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    set = MOI.EqualTo(1.0)
    bridge = MOI.Bridges.Constraint.bridge_constraint(BT, model, 1.0 * x, set)
    @test_throws(
        ErrorException(
            "Internal error: this method should never be called because it " *
            "represents an invalid state. Please open an issue to report.",
        ),
        MOI.get(bridge, MOI.NumberOfConstraints{MOI.VariableIndex,S}()),
    )
    @test_throws(
        ErrorException(
            "Internal error: this method should never be called because it " *
            "represents an invalid state. Please open an issue to report.",
        ),
        MOI.get(bridge, MOI.ListOfConstraintIndices{MOI.VariableIndex,S}()),
    )
    return
end

end  # module

TestConstraintSlack.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    AbstractToIntervalBridge{T<:AbstractFloat,S,F}

An abstract type that simplifies the creation of other bridges.

!!! warning
    `T` must be a `AbstractFloat` type because otherwise `typemin` and `typemax`
    would either be not implemented (for example, `BigInt`), or would not give infinite
    value (for example, `Int`). For this reason, this bridge is only added to
    [`MOI.Bridges.full_bridge_optimizer`](@ref) when `T` is a subtype of
    `AbstractFloat`.
"""
abstract type AbstractToIntervalBridge{
    T<:AbstractFloat,
    S<:MOI.AbstractScalarSet,
    F<:MOI.AbstractScalarFunction,
} <: SetMapBridge{T,MOI.Interval{T},S,F,F} end

MOI.Bridges.map_function(::Type{<:AbstractToIntervalBridge}, f) = f

MOI.Bridges.inverse_map_function(::Type{<:AbstractToIntervalBridge}, f) = f

MOI.Bridges.adjoint_map_function(::Type{<:AbstractToIntervalBridge}, f) = f

function MOI.Bridges.inverse_adjoint_map_function(
    ::Type{<:AbstractToIntervalBridge},
    f,
)
    return f
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::AbstractToIntervalBridge,
    change::MOI.ScalarCoefficientChange,
)
    MOI.modify(model, bridge.constraint, change)
    return
end

"""
    GreaterToIntervalBridge{T,F} <: Bridges.Constraint.AbstractBridge

`GreaterToIntervalBridge` implements the following reformulations:

  * ``f(x) \\ge l`` into ``f(x) \\in [l, \\infty)``

## Source node

`GreaterToIntervalBridge` supports:

  * `F` in [`MOI.GreaterThan{T}`](@ref)

## Target nodes

`GreaterToIntervalBridge` creates:

  * `F` in [`MOI.Interval{T}`](@ref)
"""
struct GreaterToIntervalBridge{T,F<:MOI.AbstractScalarFunction} <:
       AbstractToIntervalBridge{T,MOI.GreaterThan{T},F}
    constraint::MOI.ConstraintIndex{F,MOI.Interval{T}}
end

const GreaterToInterval{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{GreaterToIntervalBridge{T},OT}

function MOI.Bridges.map_set(
    ::Type{<:GreaterToIntervalBridge},
    set::MOI.GreaterThan,
)
    return MOI.Interval(set.lower, typemax(set.lower))
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:GreaterToIntervalBridge},
    set::MOI.Interval,
)
    return MOI.GreaterThan(set.lower)
end

function concrete_bridge_type(
    ::Type{<:GreaterToIntervalBridge{T}},
    F::Type{<:MOI.AbstractScalarFunction},
    ::Type{MOI.GreaterThan{T}},
) where {T}
    return GreaterToIntervalBridge{T,F}
end

"""
    LessToIntervalBridge{T,F} <: Bridges.Constraint.AbstractBridge

`LessToIntervalBridge` implements the following reformulations:

  * ``f(x) \\le u`` into ``f(x) \\in (-\\infty, u]``

## Source node

`LessToIntervalBridge` supports:

  * `F` in [`MOI.LessThan{T}`](@ref)

## Target nodes

`LessToIntervalBridge` creates:

  * `F` in [`MOI.Interval{T}`](@ref)
"""
struct LessToIntervalBridge{T,F<:MOI.AbstractScalarFunction} <:
       AbstractToIntervalBridge{T,MOI.LessThan{T},F}
    constraint::MOI.ConstraintIndex{F,MOI.Interval{T}}
end

const LessToInterval{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{LessToIntervalBridge{T},OT}

function MOI.Bridges.map_set(::Type{<:LessToIntervalBridge}, set::MOI.LessThan)
    return MOI.Interval(typemin(set.upper), set.upper)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:LessToIntervalBridge},
    set::MOI.Interval,
)
    return MOI.LessThan(set.upper)
end

function concrete_bridge_type(
    ::Type{<:LessToIntervalBridge{T}},
    F::Type{<:MOI.AbstractScalarFunction},
    ::Type{MOI.LessThan{T}},
) where {T}
    return LessToIntervalBridge{T,F}
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Functions convertible to a ScalarAffineFunction
const ScalarAffineLike{T} =
    Union{T,MOI.VariableIndex,MOI.ScalarAffineFunction{T}}
# Functions convertible to a ScalarQuadraticFunction
const ScalarQuadraticLike{T} =
    Union{ScalarAffineLike{T},MOI.ScalarQuadraticFunction{T}}

# `ScalarLike` for which `T` is defined to avoid defining, for example,
# `+(::VariableIndex, ::Any)` which should rather be
# `+(::VariableIndex, ::Number)`.
const TypedScalarLike{T} =
    Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}}
# Used for overloading Base operator functions so `T` is not in the union to
# avoid overloading for example, `+(::Float64, ::Float64)`
const ScalarLike{T} = Union{MOI.VariableIndex,TypedScalarLike{T}}

# Functions convertible to a VectorAffineFunction
const VectorAffineLike{T} =
    Union{Vector{T},MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}
# Functions convertible to a VectorQuadraticFunction
const VectorQuadraticLike{T} =
    Union{VectorAffineLike{T},MOI.VectorQuadraticFunction{T}}

# `VectorLike` for which `T` is defined to avoid defining, for example,
# `+(::VectorOfVariables, ::Any)` which should rather be
# `+(::VectorOfVariables, ::Number)`.
const TypedVectorLike{T} =
    Union{MOI.VectorAffineFunction{T},MOI.VectorQuadraticFunction{T}}
# Used for overloading Base operator functions so `T` is not in the union to
# avoid overloading for example, `+(::Float64, ::Float64)`
const VectorLike{T} = Union{MOI.VectorOfVariables,TypedVectorLike{T}}

const TypedLike{T} = Union{TypedScalarLike{T},TypedVectorLike{T}}

const ObjectWithoutIndex = Union{
    AbstractString,
    Enum,
    Function,
    Nothing,
    Number,
    Symbol,
    Type,
    MOI.AbstractSet,
    MOI.AnyAttribute,
    MOI.ModelLike,
    MOI.NLPBlockData,
}

const ObjectOrTupleWithoutIndex =
    Union{ObjectWithoutIndex,Tuple{Vararg{ObjectWithoutIndex}}}

const ObjectOrTupleOrArrayWithoutIndex = Union{
    ObjectOrTupleWithoutIndex,
    AbstractArray{<:ObjectOrTupleWithoutIndex},
    AbstractArray{<:AbstractArray{<:ObjectOrTupleWithoutIndex}},
}

"""
    variable_function_type(::Type{<:MOI.AbstractSet})

Return the variable type associated with a set, that is, [`MOI.VariableIndex`](@ref)
for scalar sets and [`MOI.VectorOfVariables`](@ref) for vector sets.
"""
variable_function_type(::Type{<:MOI.AbstractScalarSet}) = MOI.VariableIndex

variable_function_type(::Type{<:MOI.AbstractVectorSet}) = MOI.VectorOfVariables

"""
    value_type(::Type{T}, ::Type{F}) where {T,F<:MOI.AbstractFunction}

Returns the output type that results if a function of type `F` is evaluated
using variables with numeric type `T`.

In other words, this is the return type for
`MOI.Utilities.eval_variables(value_fn::Function, model, f::F)` for a function
`value_fn(::MOI.VariableIndex)::T`.
"""
function value_type end

value_type(::Type{T}, ::Type{MOI.VariableIndex}) where {T} = T

function value_type(
    ::Type{T},
    ::Type{<:Union{MOI.ScalarAffineFunction{C},MOI.ScalarQuadraticFunction{C}}},
) where {C,T}
    return MA.promote_operation(*, C, T)
end

value_type(::Type{T}, ::Type{MOI.ScalarNonlinearFunction}) where {T} = T

function value_type(
    ::Type{T},
    ::Type{F},
) where {T,F<:MOI.AbstractVectorFunction}
    return Vector{value_type(T, scalar_type(F))}
end

"""
    eval_variables(value_fn::Function, f::MOI.AbstractFunction)

Returns the value of function `f` if each variable index `vi` is evaluated as
`value_fn(vi)`.

Note that `value_fn` must return a Number. See [`substitute_variables`](@ref)
for a similar function where `value_fn` returns an
[`MOI.AbstractScalarFunction`](@ref).

!!! warning
    The two-argument version of `eval_variables` is deprecated and may be
    removed in MOI v2.0.0. Use the three-argument method
    `eval_variables(::Function, ::MOI.ModelLike, ::MOI.AbstractFunction)`
    instead.
"""
function eval_variables end

function eval_variables(value_fn::Function, t::MOI.ScalarAffineTerm)
    return t.coefficient * value_fn(t.variable)
end

function eval_variables(value_fn::Function, t::MOI.ScalarQuadraticTerm)
    out = t.coefficient * value_fn(t.variable_1) * value_fn(t.variable_2)
    return t.variable_1 == t.variable_2 ? out / 2 : out
end

eval_variables(value_fn::Function, f::MOI.VariableIndex) = value_fn(f)

function eval_variables(value_fn::Function, f::MOI.ScalarAffineFunction)
    out = f.constant
    for t in f.terms
        out += eval_variables(value_fn, t)
    end
    return out
end

function eval_variables(value_fn::Function, f::MOI.ScalarQuadraticFunction)
    out = f.constant
    for a in f.affine_terms
        out += eval_variables(value_fn, a)
    end
    for q in f.quadratic_terms
        out += eval_variables(value_fn, q)
    end
    return out
end

function eval_variables(value_fn::Function, f::MOI.VectorOfVariables)
    return map(value_fn, f.variables)
end

function eval_variables(value_fn::Function, f::MOI.VectorAffineFunction)
    out = copy(f.constants)
    for t in f.terms
        out[t.output_index] += eval_variables(value_fn, t.scalar_term)
    end
    return out
end

function eval_variables(value_fn::Function, f::MOI.VectorQuadraticFunction)
    out = copy(f.constants)
    for t in f.affine_terms
        out[t.output_index] += eval_variables(value_fn, t.scalar_term)
    end
    for t in f.quadratic_terms
        out[t.output_index] += eval_variables(value_fn, t.scalar_term)
    end
    return out
end

"""
    eval_variables(
        value_fn::Function,
        model::MOI.ModelLike,
        f::MOI.AbstractFunction,
    )

Returns the value of function `f` if each variable index `vi` is evaluated as
`value_fn(vi)`.

Note that `value_fn` must return a Number. See [`substitute_variables`](@ref)
for a similar function where `value_fn` returns an
[`MOI.AbstractScalarFunction`](@ref).
"""
function eval_variables(
    value_fn::F,
    model::MOI.ModelLike,
    f::Union{MOI.AbstractFunction,Real,AbstractVector{<:Real}},
) where {F}
    return eval_variables(value_fn, f)
end

# The `eval_variables(::F, ::MOI.ModelLike, ::MOI.ScalarNonlinearFunction)`
# method is defined in the MOI.Nonlinear submodule.

function eval_variables(
    value_fn::F,
    model::MOI.ModelLike,
    f::MOI.VectorNonlinearFunction,
) where {F}
    return map(f.rows) do row
        return eval_variables(value_fn, model, row)
    end
end

"""
    map_indices(index_map::Function, attr::MOI.AnyAttribute, x::X)::X where {X}

Substitute any [`MOI.VariableIndex`](@ref) (resp. [`MOI.ConstraintIndex`](@ref))
in `x` by the [`MOI.VariableIndex`](@ref) (resp. [`MOI.ConstraintIndex`](@ref))
of the same type given by `index_map(x)`.

## When to implement this method for new types `X`

This function is used by implementations of [`MOI.copy_to`](@ref) on
constraint functions, attribute values and submittable values. If you define a
new attribute whose values `x::X` contain variable or constraint indices, you
must also implement this function.
"""
map_indices(f, ::MOI.AnyAttribute, x) = map_indices(f, x)

# RawOptimizerAttribute values are passed through un-changed.
map_indices(::Any, ::MOI.RawOptimizerAttribute, x) = x

"""
    map_indices(
        variable_map::AbstractDict{T,T},
        x::X,
    )::X where {T<:MOI.Index,X}

Shortcut for `map_indices(vi -> variable_map[vi], x)`.
"""
function map_indices(
    variable_map::AbstractDict{T,T},
    x::X,
)::X where {T<:MOI.Index,X}
    return map_indices(Base.Fix1(getindex, variable_map), x)
end

map_indices(::F, x::ObjectOrTupleOrArrayWithoutIndex) where {F<:Function} = x

function map_indices(index_map::F, vi::MOI.VariableIndex) where {F<:Function}
    return index_map(vi)
end

function map_indices(index_map::F, ci::MOI.ConstraintIndex) where {F<:Function}
    return index_map(ci)
end

function map_indices(index_map::F, x::AbstractArray) where {F<:Function}
    # @odow tried other alternatives here, like
    #     [map_indices(index_map, xi) for xi in x]
    # and
    #     map(Base.Fix1(map_indices, index_map), x)
    # but this was the fastest. The insight is that we know that map_indices
    # does not modify the element type of `x`.
    y = similar(x)
    for i in eachindex(x)
        y[i] = map_indices(index_map, x[i])
    end
    return y
end

function map_indices(index_map::F, t::MOI.ScalarAffineTerm) where {F<:Function}
    return MOI.ScalarAffineTerm(t.coefficient, index_map(t.variable))
end

function map_indices(
    index_map::F,
    t::MOI.ScalarQuadraticTerm,
) where {F<:Function}
    return MOI.ScalarQuadraticTerm(
        t.coefficient,
        index_map(t.variable_1),
        index_map(t.variable_2),
    )
end

function map_indices(index_map::F, t::MOI.VectorAffineTerm) where {F<:Function}
    return MOI.VectorAffineTerm(
        t.output_index,
        map_indices(index_map, t.scalar_term),
    )
end

function map_indices(
    index_map::F,
    t::MOI.VectorQuadraticTerm,
) where {F<:Function}
    return MOI.VectorQuadraticTerm(
        t.output_index,
        map_indices(index_map, t.scalar_term),
    )
end

function map_indices(
    index_map::F,
    f::MOI.ScalarAffineFunction,
) where {F<:Function}
    return MOI.ScalarAffineFunction(
        map_indices(index_map, f.terms),
        MOI.constant(f),
    )
end

function map_indices(
    index_map::F,
    f::MOI.ScalarQuadraticFunction,
) where {F<:Function}
    return MOI.ScalarQuadraticFunction(
        map_indices(index_map, f.quadratic_terms),
        map_indices(index_map, f.affine_terms),
        MOI.constant(f),
    )
end

function map_indices(index_map::F, f::MOI.VectorOfVariables) where {F<:Function}
    return MOI.VectorOfVariables(map_indices(index_map, f.variables))
end

function map_indices(
    index_map::F,
    f::MOI.VectorAffineFunction,
) where {F<:Function}
    return MOI.VectorAffineFunction(
        map_indices(index_map, f.terms),
        MOI.constant(f),
    )
end

function map_indices(
    index_map::F,
    f::MOI.VectorQuadraticFunction,
) where {F<:Function}
    return MOI.VectorQuadraticFunction(
        map_indices(index_map, f.quadratic_terms),
        map_indices(index_map, f.affine_terms),
        MOI.constant(f),
    )
end

function map_indices(
    index_map::F,
    f::MOI.ScalarNonlinearFunction,
) where {F<:Function}
    root = MOI.ScalarNonlinearFunction(f.head, similar(f.args))
    stack = Tuple{MOI.ScalarNonlinearFunction,Int,MOI.ScalarNonlinearFunction}[]
    for (i, fi) in enumerate(f.args)
        if fi isa MOI.ScalarNonlinearFunction
            push!(stack, (root, i, fi))
        else
            root.args[i] = MOI.Utilities.map_indices(index_map, fi)
        end
    end
    while !isempty(stack)
        parent, i, arg = pop!(stack)
        if arg isa MOI.ScalarNonlinearFunction
            child = MOI.ScalarNonlinearFunction(arg.head, similar(arg.args))
            for (j, argj) in enumerate(arg.args)
                if argj isa MOI.ScalarNonlinearFunction
                    push!(stack, (child, j, argj))
                else
                    child.args[j] = MOI.Utilities.map_indices(index_map, argj)
                end
            end
            parent.args[i] = child
        else
            parent.args[i] = MOI.Utilities.map_indices(index_map, arg)
        end
    end
    return root
end

function map_indices(
    index_map::F,
    f::MOI.VectorNonlinearFunction,
) where {F<:Function}
    return MOI.VectorNonlinearFunction(map_indices(index_map, f.rows))
end

map_indices(::F, change::MOI.ScalarConstantChange) where {F<:Function} = change

map_indices(::F, change::MOI.VectorConstantChange) where {F<:Function} = change

function map_indices(
    index_map::F,
    change::MOI.ScalarCoefficientChange,
) where {F<:Function}
    return MOI.ScalarCoefficientChange(
        index_map(change.variable),
        change.new_coefficient,
    )
end

function map_indices(
    index_map::F,
    change::MOI.ScalarQuadraticCoefficientChange,
) where {F<:Function}
    return MOI.ScalarQuadraticCoefficientChange(
        index_map(change.variable_1),
        index_map(change.variable_2),
        change.new_coefficient,
    )
end

function map_indices(
    index_map::F,
    change::MOI.MultirowChange,
) where {F<:Function}
    return MOI.MultirowChange(
        index_map(change.variable),
        change.new_coefficients,
    )
end

# For performance reason, we assume that the type of the function does not
# change in `substitute_variables`.

"""
    substitute_variables(variable_map::Function, x)

Substitute any [`MOI.VariableIndex`](@ref) in `x` by `variable_map(x)`. The
`variable_map` function returns either [`MOI.VariableIndex`](@ref) or
[`MOI.ScalarAffineFunction`](@ref), see [`eval_variables`](@ref) for a similar
function where `variable_map` returns a number.

This function is used by bridge optimizers on constraint functions, attribute
values and submittable values when at least one variable bridge is used hence it
needs to be implemented for custom types that are meant to be used as attribute
or submittable value.

!!! note
    When implementing a new method, don't use `substitute_variables(::Function`,
    because Julia will not specialize on it. Use instead
    `substitute_variables(::F, ...) where {F<:Function}`.
"""
function substitute_variables end

function substitute_variables(
    ::F,
    x::ObjectOrTupleOrArrayWithoutIndex,
) where {F<:Function}
    return x
end

function substitute_variables(
    variable_map::F,
    x::MOI.VariableIndex,
) where {F<:Function}
    f = variable_map(x)
    if f != x
        error("Cannot substitute `$x` as it is bridged into `$f`.")
    end
    return x
end

# This method is used when submitting `HeuristicSolution`.
function substitute_variables(
    variable_map::F,
    x::Vector{MOI.VariableIndex},
) where {F<:Function}
    return substitute_variables.(variable_map, x)
end

function substitute_variables(
    variable_map::F,
    term::MOI.ScalarAffineTerm{T},
) where {T,F<:Function}
    # We could have `T = Complex{Float64}` and `variable_map(term.variable)`
    # be a `MOI.ScalarAffineFunction{Float64}` with the Hermitian to PSD bridge.
    # We convert to `MOI.ScalarAffineFunction{T}` to avoid any issue.
    f = convert(MOI.ScalarAffineFunction{T}, variable_map(term.variable))
    return operate(*, T, term.coefficient, f)::MOI.ScalarAffineFunction{T}
end

function substitute_variables(
    variable_map::F,
    term::MOI.ScalarQuadraticTerm{T},
) where {T,F<:Function}
    # We could have `T = Complex{Float64}` and `variable_map(term.variable)`
    # be a `MOI.ScalarAffineFunction{Float64}` with the Hermitian to PSD bridge.
    # We convert to `MOI.ScalarAffineFunction{T}` to avoid any issue.
    f1 = convert(MOI.ScalarAffineFunction{T}, variable_map(term.variable_1))
    f2 = convert(MOI.ScalarAffineFunction{T}, variable_map(term.variable_2))
    f12 = operate(*, T, f1, f2)::MOI.ScalarQuadraticFunction{T}
    coef = term.coefficient
    # The quadratic terms are evaluated as x'Qx/2 so a diagonal term should
    # be divided by 2 while an off-diagonal term appears twice in the matrix
    # and is divided by 2 so it stays the same.
    if term.variable_1 == term.variable_2
        coef /= 2
    end
    return operate!(*, T, f12, coef)
end

function substitute_variables(
    variable_map::F,
    f::MOI.ScalarAffineFunction{T},
) where {T,F<:Function}
    g = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{T}[], MOI.constant(f))
    for term in f.terms
        # This works because substitute_variables actually returns a function,
        # not a term.
        g = operate!(+, T, g, substitute_variables(variable_map, term))
    end
    return g
end

function substitute_variables(
    variable_map::F,
    f::MOI.ScalarQuadraticFunction{T},
) where {T,F<:Function}
    g = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm{T}[],
        MOI.ScalarAffineTerm{T}[],
        MOI.constant(f),
    )
    for a_term in f.affine_terms
        g = operate!(+, T, g, substitute_variables(variable_map, a_term))
    end
    for q_term in f.quadratic_terms
        g = operate!(+, T, g, substitute_variables(variable_map, q_term))
    end
    return g
end

function substitute_variables(
    variable_map::F,
    f::MOI.ScalarNonlinearFunction,
) where {F<:Function}
    new_args = Any[]
    for arg in f.args
        if arg isa MOI.VariableIndex
            push!(new_args, variable_map(arg))
        else
            push!(new_args, substitute_variables(variable_map, arg))
        end
    end
    return MOI.ScalarNonlinearFunction(f.head, new_args)
end

function substitute_variables(
    variable_map::F,
    f::MOI.VectorAffineFunction{T},
) where {T,F<:Function}
    g = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm{T}[],
        copy(MOI.constant(f)),
    )
    for term in f.terms
        term_f = substitute_variables(variable_map, term.scalar_term)
        operate_output_index!(+, T, term.output_index, g, term_f)
    end
    return g
end

function substitute_variables(
    variable_map::F,
    f::MOI.VectorQuadraticFunction{T},
) where {T,F<:Function}
    g = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm{T}[],
        MOI.VectorAffineTerm{T}[],
        copy(MOI.constant(f)),
    )
    for term in f.affine_terms
        sub = substitute_variables(variable_map, term.scalar_term)
        operate_output_index!(+, T, term.output_index, g, sub)
    end
    for term in f.quadratic_terms
        sub = substitute_variables(variable_map, term.scalar_term)
        operate_output_index!(+, T, term.output_index, g, sub)
    end
    return g
end

function substitute_variables(
    variable_map::F,
    f::MOI.VectorNonlinearFunction,
) where {F<:Function}
    rows = [substitute_variables(variable_map, row) for row in f.rows]
    return MOI.VectorNonlinearFunction(rows)
end

"""
    scalar_type(F::Type{<:MOI.AbstractVectorFunction})

Type of functions obtained by indexing objects obtained by calling `eachscalar`
on functions of type `F`.
"""
function scalar_type end

scalar_type(::Type{<:AbstractVector{T}}) where {T} = T

scalar_type(::Type{MOI.VectorOfVariables}) = MOI.VariableIndex

function scalar_type(::Type{MOI.VectorAffineFunction{T}}) where {T}
    return MOI.ScalarAffineFunction{T}
end

function scalar_type(::Type{MOI.VectorQuadraticFunction{T}}) where {T}
    return MOI.ScalarQuadraticFunction{T}
end

scalar_type(::Type{MOI.VectorNonlinearFunction}) = MOI.ScalarNonlinearFunction

"""
    vector_type(::Type{<:MOI.AbstractScalarFunction})

Return the [`MOI.AbstractVectorFunction`](@ref) associated with the scalar type
`F`.
"""
function vector_type end

vector_type(::Type{T}) where {T} = Vector{T}

vector_type(::Type{MOI.VariableIndex}) = MOI.VectorOfVariables

function vector_type(::Type{MOI.ScalarAffineFunction{T}}) where {T}
    return MOI.VectorAffineFunction{T}
end

function vector_type(::Type{MOI.ScalarQuadraticFunction{T}}) where {T}
    return MOI.VectorQuadraticFunction{T}
end

function vector_type(::Type{MOI.ScalarNonlinearFunction})
    return MOI.VectorNonlinearFunction
end

"""
    ScalarFunctionIterator{F<:MOI.AbstractVectorFunction}

A type that allows iterating over the scalar-functions that comprise an
`AbstractVectorFunction`.
"""
struct ScalarFunctionIterator{F<:MOI.AbstractVectorFunction,C,S} <:
       AbstractVector{S}
    f::F
    # Cache that can be used to store a precomputed datastructure that allows
    # an efficient implementation of `getindex`.
    cache::C
    function ScalarFunctionIterator(f::MOI.AbstractVectorFunction, cache)
        return new{typeof(f),typeof(cache),scalar_type(typeof(f))}(f, cache)
    end
end

function ScalarFunctionIterator(func::MOI.AbstractVectorFunction)
    return ScalarFunctionIterator(func, scalar_iterator_cache(func))
end

Base.size(s::ScalarFunctionIterator) = (MOI.output_dimension(s.f),)

scalar_iterator_cache(::MOI.AbstractVectorFunction) = nothing

function output_index_iterator(terms::AbstractVector, output_dimension)
    start = zeros(Int, output_dimension)
    next = Vector{Int}(undef, length(terms))
    last = zeros(Int, output_dimension)
    for i in eachindex(terms)
        j = terms[i].output_index
        if iszero(last[j])
            start[j] = i
        else
            next[last[j]] = i
        end
        last[j] = i
    end
    for j in eachindex(last)
        if !iszero(last[j])
            next[last[j]] = 0
        end
    end
    return ChainedIterator(start, next)
end

struct ChainedIterator
    start::Vector{Int}
    next::Vector{Int}
end

struct ChainedIteratorAtIndex
    start::Int
    next::Vector{Int}
end

function ChainedIteratorAtIndex(it::ChainedIterator, index::Int)
    return ChainedIteratorAtIndex(it.start[index], it.next)
end

#TODO We could also precompute the length for each `output_index`,
# check that it's a win.
Base.IteratorSize(::ChainedIteratorAtIndex) = Base.SizeUnknown()

function Base.iterate(it::ChainedIteratorAtIndex, i = it.start)
    if iszero(i)
        return nothing
    end
    return i, it.next[i]
end

function ScalarFunctionIterator(f::MOI.VectorAffineFunction)
    return ScalarFunctionIterator(
        f,
        output_index_iterator(f.terms, MOI.output_dimension(f)),
    )
end

function ScalarFunctionIterator(f::MOI.VectorQuadraticFunction)
    return ScalarFunctionIterator(
        f,
        (
            output_index_iterator(f.quadratic_terms, MOI.output_dimension(f)),
            output_index_iterator(f.affine_terms, MOI.output_dimension(f)),
        ),
    )
end

"""
    eachscalar(f::MOI.AbstractVectorFunction)

Returns an iterator for the scalar components of the vector function.

See also [`scalarize`](@ref).
"""
eachscalar(f::MOI.AbstractVectorFunction) = ScalarFunctionIterator(f)

"""
    eachscalar(f::MOI.AbstractVector)

Returns an iterator for the scalar components of the vector.
"""
eachscalar(f::AbstractVector) = f

function Base.iterate(it::ScalarFunctionIterator, state = 1)
    if state > length(it)
        return nothing
    end
    return (it[state], state + 1)
end

function Base.length(it::ScalarFunctionIterator{<:MOI.AbstractVectorFunction})
    return MOI.output_dimension(it.f)
end

function Base.eltype(::ScalarFunctionIterator{MOI.VectorOfVariables})
    return MOI.VariableIndex
end

function Base.eltype(
    ::ScalarFunctionIterator{MOI.VectorAffineFunction{T}},
) where {T}
    return MOI.ScalarAffineFunction{T}
end

function Base.eltype(
    ::ScalarFunctionIterator{MOI.VectorQuadraticFunction{T}},
) where {T}
    return MOI.ScalarQuadraticFunction{T}
end

function Base.eltype(
    ::ScalarFunctionIterator{F},
) where {F<:MOI.AbstractVectorFunction}
    return scalar_type(F)
end

Base.lastindex(it::ScalarFunctionIterator) = length(it)

function Base.getindex(
    it::ScalarFunctionIterator{MOI.VectorOfVariables},
    output_index::Integer,
)
    return it.f.variables[output_index]
end

function Base.getindex(
    it::ScalarFunctionIterator{MOI.VectorOfVariables},
    output_indices::AbstractVector{<:Integer},
)
    return MOI.VectorOfVariables(it.f.variables[output_indices])
end

function Base.getindex(
    it::ScalarFunctionIterator{MOI.VectorAffineFunction{T}},
    output_index::Integer,
) where {T}
    return MOI.ScalarAffineFunction{T}(
        MOI.ScalarAffineTerm{T}[
            it.f.terms[i].scalar_term for
            i in ChainedIteratorAtIndex(it.cache, output_index)
        ],
        it.f.constants[output_index],
    )
end

function Base.getindex(
    it::ScalarFunctionIterator{MOI.VectorAffineFunction{T}},
    output_indices::AbstractVector{<:Integer},
) where {T}
    terms = MOI.VectorAffineTerm{T}[]
    for (i, output_index) in enumerate(output_indices)
        for j in ChainedIteratorAtIndex(it.cache, output_index)
            push!(terms, MOI.VectorAffineTerm(i, it.f.terms[j].scalar_term))
        end
    end
    return MOI.VectorAffineFunction(terms, it.f.constants[output_indices])
end

function Base.getindex(
    it::ScalarFunctionIterator{MOI.VectorQuadraticFunction{T}},
    output_index::Integer,
) where {T}
    return MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm{T}[
            it.f.quadratic_terms[i].scalar_term for
            i in ChainedIteratorAtIndex(it.cache[1], output_index)
        ],
        MOI.ScalarAffineTerm{T}[
            it.f.affine_terms[i].scalar_term for
            i in ChainedIteratorAtIndex(it.cache[2], output_index)
        ],
        it.f.constants[output_index],
    )
end

function Base.getindex(
    it::ScalarFunctionIterator{MOI.VectorQuadraticFunction{T}},
    output_indices::AbstractVector{<:Integer},
) where {T}
    vat = MOI.VectorAffineTerm{T}[]
    vqt = MOI.VectorQuadraticTerm{T}[]
    for (i, output_index) in enumerate(output_indices)
        for j in ChainedIteratorAtIndex(it.cache[2], output_index)
            push!(
                vat,
                MOI.VectorAffineTerm(i, it.f.affine_terms[j].scalar_term),
            )
        end
        for j in ChainedIteratorAtIndex(it.cache[1], output_index)
            push!(
                vqt,
                MOI.VectorQuadraticTerm(i, it.f.quadratic_terms[j].scalar_term),
            )
        end
    end
    return MOI.VectorQuadraticFunction(vqt, vat, it.f.constants[output_indices])
end

function Base.getindex(
    it::ScalarFunctionIterator{MOI.VectorNonlinearFunction},
    output_index::Integer,
)
    return it.f.rows[output_index]
end

function Base.getindex(
    it::ScalarFunctionIterator{MOI.VectorNonlinearFunction},
    output_index::AbstractVector{<:Integer},
)
    return MOI.VectorNonlinearFunction(it.f.rows[output_index])
end

"""
    zero_with_output_dimension(::Type{T}, output_dimension::Integer) where {T}

Create an instance of type `T` with the output dimension `output_dimension`.

This is mostly useful in Bridges, when code needs to be agnostic to the type of
vector-valued function that is passed in.
"""
function zero_with_output_dimension end

function zero_with_output_dimension(::Type{Vector{T}}, n::Integer) where {T}
    return zeros(T, n)
end

function zero_with_output_dimension(
    ::Type{MOI.VectorAffineFunction{T}},
    n::Integer,
) where {T}
    return MOI.VectorAffineFunction{T}(MOI.VectorAffineTerm{T}[], zeros(T, n))
end

function zero_with_output_dimension(
    ::Type{MOI.VectorQuadraticFunction{T}},
    n::Integer,
) where {T}
    return MOI.VectorQuadraticFunction{T}(
        MOI.VectorQuadraticTerm{T}[],
        MOI.VectorAffineTerm{T}[],
        zeros(T, n),
    )
end

"""
    unsafe_add(t1::MOI.ScalarAffineTerm, t2::MOI.ScalarAffineTerm)

Sums the coefficients of `t1` and `t2` and returns an output
`MOI.ScalarAffineTerm`. It is unsafe because it uses the `variable` of `t1` as
the `variable` of the output without checking that it is equal to that of `t2`.
"""
function unsafe_add(t1::MOI.ScalarAffineTerm, t2::MOI.ScalarAffineTerm)
    return MOI.ScalarAffineTerm(t1.coefficient + t2.coefficient, t1.variable)
end

"""
    unsafe_add(t1::MOI.ScalarQuadraticTerm, t2::MOI.ScalarQuadraticTerm)

Sums the coefficients of `t1` and `t2` and returns an output
`MOI.ScalarQuadraticTerm`. It is unsafe because it uses the `variable`'s
of `t1` as the `variable`'s of the output without checking that they are
the same (up to permutation) to those of `t2`.
"""
function unsafe_add(t1::MOI.ScalarQuadraticTerm, t2::MOI.ScalarQuadraticTerm)
    return MOI.ScalarQuadraticTerm(
        t1.coefficient + t2.coefficient,
        t1.variable_1,
        t1.variable_2,
    )
end

"""
    unsafe_add(t1::MOI.VectorAffineTerm, t2::MOI.VectorAffineTerm)

Sums the coefficients of `t1` and `t2` and returns an output
`MOI.VectorAffineTerm`. It is unsafe because it uses the `output_index` and
`variable` of `t1` as the `output_index` and `variable` of the output term
without checking that they are equal to those of `t2`.
"""
function unsafe_add(
    t1::T,
    t2::T,
) where {T<:Union{MOI.VectorAffineTerm,MOI.VectorQuadraticTerm}}
    scalar_term = unsafe_add(t1.scalar_term, t2.scalar_term)
    return T(t1.output_index, scalar_term)
end

# Generic fallback for items inside NonlinearFunctions like numbers.
is_canonical(::Any) = true

is_canonical(::MOI.AbstractFunction) = false

is_canonical(::Union{MOI.VariableIndex,MOI.VectorOfVariables}) = true

function is_canonical(f::MOI.ScalarNonlinearFunction)
    # Don't use recursion here. This gets called for all scalar nonlinear
    # constraints.
    stack = Any[arg for arg in f.args]
    while !isempty(stack)
        arg = pop!(stack)
        if arg isa MOI.ScalarNonlinearFunction
            for a in arg.args
                push!(stack, a)
            end
        else
            if !is_canonical(arg)
                return false
            end
        end
    end
    return true
end

"""
    is_canonical(f::Union{ScalarAffineFunction, VectorAffineFunction})

Returns a Bool indicating whether the function is in canonical form.
See [`canonical`](@ref).
"""
function is_canonical(
    f::Union{MOI.ScalarAffineFunction,MOI.VectorAffineFunction},
)
    return _is_strictly_sorted(f.terms)
end

"""
    is_canonical(f::Union{ScalarQuadraticFunction, VectorQuadraticFunction})

Returns a Bool indicating whether the function is in canonical form.
See [`canonical`](@ref).
"""
function is_canonical(
    f::Union{MOI.ScalarQuadraticFunction,MOI.VectorQuadraticFunction},
)
    return _is_strictly_sorted(f.affine_terms) &&
           _is_strictly_sorted(f.quadratic_terms)
end

is_canonical(f::MOI.VectorNonlinearFunction) = all(is_canonical, f.rows)

function _is_strictly_sorted(x::Vector)
    if isempty(x)
        return true
    end
    @inbounds current_x = x[1]
    if iszero(MOI.coefficient(current_x))
        return false
    end
    current_fx = MOI.term_indices(current_x)
    @inbounds for i in 2:length(x)
        next_x = x[i]
        if iszero(MOI.coefficient(next_x))
            return false
        end
        next_fx = MOI.term_indices(next_x)
        if next_fx <= current_fx
            return false
        end
        current_x, current_fx = next_x, next_fx
    end
    return true
end

"""
    canonical(f::MOI.AbstractFunction)

Returns the function in a canonical form, that is,

 * A term appear only once.
 * The coefficients are nonzero.
 * The terms appear in increasing order of variable where there the order of the
   variables is the order of their value.
 * For a `AbstractVectorFunction`, the terms are sorted in ascending order of
   output index.

The output of `canonical` can be assumed to be a copy of `f`, even for
`VectorOfVariables`.

## Example

```jldoctest
julia> x, y, z = MOI.VariableIndex.(1:3);

julia> f = MOI.ScalarAffineFunction(
           MOI.ScalarAffineTerm.(Float64[2, 1, 3, -2, -3], [y, x, z, x, z]),
           5.0,
       )
5.0 + 2.0 MOI.VariableIndex(2) + 1.0 MOI.VariableIndex(1) + 3.0 MOI.VariableIndex(3) - 2.0 MOI.VariableIndex(1) - 3.0 MOI.VariableIndex(3)

julia> MOI.Utilities.canonical(f)
5.0 - 1.0 MOI.VariableIndex(1) + 2.0 MOI.VariableIndex(2)
```
"""
function canonical(f::MOI.AbstractFunction)
    g = copy(f)
    if !is_canonical(g)
        canonicalize!(g)
    end
    return g
end

canonicalize!(f::Union{MOI.VectorOfVariables,MOI.VariableIndex}) = f

"""
    canonicalize!(f::Union{ScalarAffineFunction, VectorAffineFunction})

Convert a function to canonical form in-place, without allocating a copy to hold
the result. See [`canonical`](@ref).
"""
function canonicalize!(
    f::Union{MOI.ScalarAffineFunction,MOI.VectorAffineFunction},
)
    _sort_and_compress!(f.terms)
    return f
end

function canonicalize!(f::MOI.ScalarNonlinearFunction)
    for (i, arg) in enumerate(f.args)
        if !is_canonical(arg)
            f.args[i] = canonicalize!(arg)
        end
    end
    return f
end

function canonicalize!(f::MOI.VectorNonlinearFunction)
    for (i, fi) in enumerate(f.rows)
        f.rows[i] = canonicalize!(fi)
    end
    return f
end

"""
    canonicalize!(f::Union{ScalarQuadraticFunction, VectorQuadraticFunction})

Convert a function to canonical form in-place, without allocating a copy to hold
the result. See [`canonical`](@ref).
"""
function canonicalize!(
    f::Union{MOI.ScalarQuadraticFunction,MOI.VectorQuadraticFunction},
)
    _sort_and_compress!(f.affine_terms)
    _sort_and_compress!(f.quadratic_terms)
    return f
end

"""
    _sort_and_compress!(x::Vector)

Sort the vector `x` in-place using `by` as the function from elements to
comparable keys, then combine all entries for which `by(x[i]) == by(x[j])` using
the function `x[i] = combine(x[i], x[j])`, and remove any entries for which
`keep(x[i]) == false`. This may result in `x` being resized to a shorter length.
"""
function _sort_and_compress!(x::Vector)
    if length(x) == 0
        return
    end
    sort!(x, QuickSort, Base.Order.ord(isless, MOI.term_indices, false))
    i = 1
    @inbounds for j in 2:length(x)
        if MOI.term_indices(x[i]) == MOI.term_indices(x[j])
            x[i] = unsafe_add(x[i], x[j])
        elseif iszero(MOI.coefficient(x[i]))
            x[i] = x[j]
        else
            x[i+1] = x[j]
            i += 1
        end
    end
    if iszero(MOI.coefficient(x[i]))
        i -= 1
    end
    resize!(x, i)
    return
end

"""
    all_coefficients(p::Function, f::MOI.AbstractFunction)

Determine whether predicate `p` returns `true` for all coefficients of `f`,
returning `false` as soon as the first coefficient of `f` for which `p`
returns `false` is encountered (short-circuiting). Similar to `all`.
"""
function all_coefficients end

function all_coefficients(p::Function, f::MOI.ScalarAffineFunction)
    return p(f.constant) && all(t -> p(MOI.coefficient(t)), f.terms)
end

function all_coefficients(p::Function, f::MOI.ScalarQuadraticFunction)
    return p(f.constant) &&
           all(t -> p(MOI.coefficient(t)), f.affine_terms) &&
           all(t -> p(MOI.coefficient(t)), f.quadratic_terms)
end

"""
    isapprox_zero(f::MOI.AbstractFunction, tol)

Return a `Bool` indicating whether the function `f` is approximately zero using
`tol` as a tolerance.

## Important note

This function assumes that `f` does not contain any duplicate terms, you might
want to first call [`canonical`](@ref) if that is not guaranteed.

## Example

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([1, -1], [x, x]), 0)
(0) + (1) MOI.VariableIndex(1) - (1) MOI.VariableIndex(1)

julia> MOI.Utilities.isapprox_zero(f, 1e-8)
false

julia> MOI.Utilities.isapprox_zero(MOI.Utilities.canonical(f), 1e-8)
true
```
"""
function isapprox_zero end

isapprox_zero(α::AbstractFloat, tol) = -tol <= α <= tol

isapprox_zero(α::Union{Integer,Rational}, tol) = iszero(α)

function isapprox_zero(f::MOI.AbstractFunction, tol)
    return all_coefficients(α -> isapprox_zero(α, tol), f)
end

_is_constant(f::MOI.ScalarAffineFunction) = isempty(f.terms)

function _is_constant(f::MOI.ScalarQuadraticFunction)
    return isempty(f.affine_terms) && isempty(f.quadratic_terms)
end

Base.iszero(::MOI.VariableIndex) = false

function Base.iszero(
    f::Union{MOI.ScalarAffineFunction,MOI.ScalarQuadraticFunction},
)
    return iszero(MOI.constant(f)) && _is_constant(canonical(f))
end

Base.isone(::MOI.VariableIndex) = false

function Base.isone(
    f::Union{MOI.ScalarAffineFunction,MOI.ScalarQuadraticFunction},
)
    return isone(MOI.constant(f)) && _is_constant(canonical(f))
end

_keep_all(keep::Function, v::MOI.VariableIndex) = keep(v)

function _keep_all(keep::Function, t::MOI.ScalarAffineTerm)
    return keep(t.variable)
end

function _keep_all(keep::Function, t::MOI.ScalarQuadraticTerm)
    return keep(t.variable_1) && keep(t.variable_2)
end

function _keep_all(
    keep::Function,
    t::Union{MOI.VectorAffineTerm,MOI.VectorQuadraticTerm},
)
    return _keep_all(keep, t.scalar_term)
end

# Removes terms or variables in `vis_or_terms` that contains the variable of index `vi`
function _filter_variables(keep::Function, variables_or_terms::Vector)
    return filter(el -> _keep_all(keep, el), variables_or_terms)
end

"""
    filter_variables(keep::Function, f::AbstractFunction)

Return a new function `f` with the variable `vi` such that `!keep(vi)` removed.

WARNING: Don't define `filter_variables(::Function, ...)` because Julia will
not specialize on this. Define instead
`filter_variables(::F, ...) where {F<:Function}`.
"""
function filter_variables end

function filter_variables(keep::Function, f::MOI.VariableIndex)
    if !keep(f)
        error(
            "Cannot remove variable from a `VariableIndex` function of the",
            " same variable.",
        )
    end
    return f
end

function filter_variables(keep::Function, f::MOI.VectorOfVariables)
    return MOI.VectorOfVariables(_filter_variables(keep, f.variables))
end

function filter_variables(
    keep::Function,
    f::Union{MOI.ScalarAffineFunction,MOI.VectorAffineFunction},
)
    return typeof(f)(_filter_variables(keep, f.terms), MOI.constant(f))
end

function filter_variables(
    keep::Function,
    f::Union{MOI.ScalarQuadraticFunction,MOI.VectorQuadraticFunction},
)
    return typeof(f)(
        _filter_variables(keep, f.quadratic_terms),
        _filter_variables(keep, f.affine_terms),
        MOI.constant(f),
    )
end

function filter_variables(keep::Function, f::MOI.ScalarNonlinearFunction)
    args = Any[]
    first_arg_deleted = false
    for (i, arg) in enumerate(f.args)
        if arg isa MOI.VariableIndex
            if keep(arg)
                push!(args, arg)
            else
                if i == 1
                    first_arg_deleted = true
                end
                if !(f.head in (:+, :-, :*))
                    error("Unable to delete variable in `$(f.head) operation.")
                end
            end
        elseif arg isa Number
            push!(args, arg)
        else
            push!(args, filter_variables(keep, arg))
        end
    end
    if f.head == :-
        if first_arg_deleted
            # -(x, y...) has become -(y...), but it should be -(0, y...)
            pushfirst!(args, 0)
        elseif length(f.args) > 1 && length(args) == 1
            # -(x, y...) has become -(x), but it should be +(x)
            return f.args[1]
        end
    end
    return MOI.ScalarNonlinearFunction(f.head, args)
end

function filter_variables(keep::Function, f::MOI.VectorNonlinearFunction)
    return MOI.VectorNonlinearFunction(
        MOI.ScalarNonlinearFunction[
            filter_variables(keep, row) for row in f.rows
        ],
    )
end

"""
    remove_variable(f::AbstractFunction, vi::VariableIndex)

Return a new function `f` with the variable vi removed.
"""
function remove_variable(f::MOI.AbstractFunction, vi::MOI.VariableIndex)
    return filter_variables(v -> v != vi, f)
end

function remove_variable(
    f::MOI.AbstractFunction,
    vis::Vector{MOI.VariableIndex},
)
    # Create a `Set` to test membership in `vis` in O(1).
    set = Set(vis)
    return filter_variables(vi -> !(vi in set), f)
end

"""
    modify_function(f::AbstractFunction, change::AbstractFunctionModification)

Return a copy of the function `f`, modified according to `change`.
"""
function modify_function(
    f::MOI.AbstractFunction,
    change::MOI.AbstractFunctionModification,
)
    new_f = copy(f)
    modify_function!(new_f, change)
    return new_f
end

"""
    modify_function!(f::AbstractFunction, change::AbstractFunctionModification)

Modify the function `f` in-place, according to `change`.
"""
function modify_function!(
    f::MOI.ScalarAffineFunction,
    change::MOI.ScalarConstantChange,
)
    f.constant = change.new_constant
    return f
end

function modify_function!(
    f::MOI.VectorAffineFunction,
    change::MOI.VectorConstantChange,
)
    for (i, constant) in enumerate(change.new_constant)
        f.constants[i] = constant
    end
    return f
end

function modify_function!(
    f::MOI.ScalarQuadraticFunction,
    change::MOI.ScalarConstantChange,
)
    f.constant = change.new_constant
    return f
end

function modify_function!(
    f::MOI.VectorQuadraticFunction,
    change::MOI.VectorConstantChange,
)
    for (i, constant) in enumerate(change.new_constant)
        f.constants[i] = constant
    end
    return f
end

function _modify_coefficient(
    terms::Vector{MOI.ScalarAffineTerm{T}},
    variable::MOI.VariableIndex,
    new_coefficient::T,
) where {T}
    i = something(findfirst(t -> t.variable == variable, terms), 0)
    if iszero(i)  # The variable was not already in the function
        if !iszero(new_coefficient)
            push!(terms, MOI.ScalarAffineTerm(new_coefficient, variable))
        end
    else  # The variable was already in the function
        if iszero(new_coefficient)
            deleteat!(terms, i)
        else
            terms[i] = MOI.ScalarAffineTerm(new_coefficient, variable)
        end
        # To account for duplicates, we need to delete any other instances of
        # `variable` in `terms`.
        for j in length(terms):-1:(i+1)
            if terms[j].variable == variable
                deleteat!(terms, j)
            end
        end
    end
    return
end

function modify_function!(
    f::MOI.ScalarAffineFunction{T},
    change::MOI.ScalarCoefficientChange{T},
) where {T}
    _modify_coefficient(f.terms, change.variable, change.new_coefficient)
    return f
end

function modify_function!(
    f::MOI.ScalarQuadraticFunction{T},
    change::MOI.ScalarCoefficientChange{T},
) where {T}
    _modify_coefficient(f.affine_terms, change.variable, change.new_coefficient)
    return f
end

function modify_function!(
    f::MOI.ScalarQuadraticFunction{T},
    change::MOI.ScalarQuadraticCoefficientChange{T},
) where {T}
    indices = findall(f.quadratic_terms) do term
        x, y = term.variable_1, term.variable_2
        return (x == change.variable_1 && y == change.variable_2) ||
               (y == change.variable_1 && x == change.variable_2)
    end
    for j in reverse(indices)
        deleteat!(f.quadratic_terms, j)
    end
    term = MOI.ScalarQuadraticTerm(
        change.new_coefficient,
        change.variable_1,
        change.variable_2,
    )
    push!(f.quadratic_terms, term)
    return f
end

function _modify_coefficients(
    terms::Vector{MOI.VectorAffineTerm{T}},
    variable::MOI.VariableIndex,
    new_coefficients::Vector{Tuple{Int64,T}},
) where {T}
    coef_dict = Dict(k => v for (k, v) in new_coefficients)
    elements_to_delete = Int[]
    for (i, term) in enumerate(terms)
        if term.scalar_term.variable != variable
            continue
        end
        new_coef = Base.get(coef_dict, term.output_index, nothing)
        if new_coef === nothing
            continue
        elseif iszero(new_coef)
            push!(elements_to_delete, i)
        else
            terms[i] = MOI.VectorAffineTerm(
                term.output_index,
                MOI.ScalarAffineTerm(new_coef, variable),
            )
            # Set the coefficient to 0.0 so we don't add duplicates.
            coef_dict[term.output_index] = zero(T)
        end
    end
    deleteat!(terms, elements_to_delete)
    # Add elements that were not previously in `terms`.
    for (k, v) in coef_dict
        if iszero(v)
            continue
        end
        push!(terms, MOI.VectorAffineTerm(k, MOI.ScalarAffineTerm(v, variable)))
    end
    return
end

function modify_function!(
    f::MOI.VectorAffineFunction{T},
    change::MOI.MultirowChange{T},
) where {T}
    _modify_coefficients(f.terms, change.variable, change.new_coefficients)
    return f
end

function modify_function!(
    f::MOI.VectorQuadraticFunction{T},
    change::MOI.MultirowChange{T},
) where {T}
    _modify_coefficients(
        f.affine_terms,
        change.variable,
        change.new_coefficients,
    )
    return f
end

# Arithmetic

function map_terms!(
    op,
    func::Union{MOI.ScalarAffineFunction,MOI.VectorAffineFunction},
)
    map!(op, func.terms, func.terms)
    return
end

function map_terms!(
    op,
    func::Union{MOI.ScalarQuadraticFunction,MOI.VectorQuadraticFunction},
)
    map!(op, func.affine_terms, func.affine_terms)
    map!(op, func.quadratic_terms, func.quadratic_terms)
    return
end

### Base methods

_eltype(args::Tuple) = _eltype(first(args), Base.tail(args))
_eltype(::Tuple{}) = nothing
_eltype(::MOI.Utilities.TypedScalarLike{T}, tail) where {T} = T
_eltype(::MOI.VariableIndex, tail) = _eltype(tail)
_eltype(::MOI.Utilities.TypedVectorLike{T}, tail) where {T} = T
_eltype(::MOI.VectorOfVariables, tail) = _eltype(tail)

### Base.:+

function Base.:+(
    arg::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction,
        MOI.ScalarQuadraticFunction,
    },
    args::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction,
        MOI.ScalarQuadraticFunction,
    }...,
)
    T = _eltype(arg, args)
    if T === nothing
        error(
            "Unable to add VariableIndex together because no coefficient type " *
            "is specified. Instead of `x + y`, convert one of the terms to a " *
            "`ScalarAffineFunction` first by left-multiplying by `one(T)` where " *
            "`T` is the coefficient type For example: `1.0 * x + y`.",
        )
    end
    return operate(+, T, arg, args...)
end

function Base.:+(
    f::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    },
    g::T,
) where {T<:Number}
    return operate(+, T, f, g)
end

function Base.:+(
    f::T,
    g::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
    },
) where {T<:Number}
    return operate(+, T, f, g)
end

function Base.:+(
    arg::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction,
        MOI.VectorQuadraticFunction,
    },
    args::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction,
        MOI.VectorQuadraticFunction,
    }...,
)
    T = _eltype(arg, args)
    if T === nothing
        error(
            "Cannot add VectorOfVariables together without a coefficient " *
            "type. Convert one argument to a VectorAffineFunction first.",
        )
    end
    return operate(+, T, arg, args...)
end

function Base.:+(
    f::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::AbstractVector{T},
) where {T<:Number}
    return operate(+, T, f, g)
end

function Base.:+(
    f::AbstractVector{T},
    g::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return operate(+, T, f, g)
end

### Base.:-

function Base.:-(
    arg::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction,
        MOI.ScalarQuadraticFunction,
    },
    args::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction,
        MOI.ScalarQuadraticFunction,
    }...,
)
    T = _eltype(arg, args)
    if T === nothing
        error(
            "Unable to subtract VariableIndex together because no coefficient type " *
            "is specified. Instead of `x - y`, convert one of the terms to a " *
            "`ScalarAffineFunction` first by left-multiplying by `one(T)` where " *
            "`T` is the coefficient type For example: `1.0 * x - y`.",
        )
    end
    return operate(-, T, arg, args...)
end

function Base.:-(
    f::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::T,
) where {T<:Number}
    return operate(-, T, f, g)
end

function Base.:-(
    f::T,
    g::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return operate(-, T, f, g)
end

function Base.:-(
    arg::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction,
        MOI.VectorQuadraticFunction,
    },
    args::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction,
        MOI.VectorQuadraticFunction,
    }...,
)
    T = _eltype(arg, args)
    if T === nothing
        error(
            "Cannot subtract VectorOfVariables together without a coefficient " *
            "type. Convert one argument to a VectorAffineFunction first.",
        )
    end
    return operate(-, T, arg, args...)
end

function Base.:-(
    f::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::AbstractVector{T},
) where {T<:Number}
    return operate(-, T, f, g)
end

function Base.:-(
    f::AbstractVector{T},
    g::Union{
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return operate(-, T, f, g)
end

### Base.:*

Base.:*(f::MOI.AbstractFunction) = f

function Base.:*(f::ScalarLike, g::ScalarLike, args::ScalarLike...)
    T = _eltype(f, (g, args...))
    if T === nothing
        error(
            "Unable to multiply VariableIndex together because no coefficient " *
            "type is specified. Instead of `x * y`, convert one of the terms to a " *
            "`ScalarAffineFunction` first by left-multiplying by `one(T)` where " *
            "`T` is the coefficient type For example: `1.0 * x * y`.",
        )
    end
    return operate(*, T, f, g, args...)
end

function Base.:*(f::Union{MOI.VariableIndex,MOI.VectorOfVariables}, g::Number)
    return operate(*, typeof(g), f, g)
end

function Base.:*(
    f::Union{
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::T,
) where {T<:Number}
    return operate_coefficients(Base.Fix2(*, g), f)
end

function Base.:*(
    f::T,
    g::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
) where {T<:Number}
    return g * f
end

# Used by sparse matrix multiplication after
# https://github.com/JuliaLang/julia/pull/33205
function Base.:*(
    f::Union{
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::Bool,
) where {T<:Number}
    if g
        return MA.copy_if_mutable(f)
    else
        return zero(typeof(f))
    end
end

# These method are needed for multiplication between different number types. The
# most common case is when the number is a `Complex{T}`.

function Base.:*(
    f::Union{
        MOI.ScalarAffineFunction,
        MOI.ScalarQuadraticFunction,
        MOI.VectorAffineFunction,
        MOI.VectorQuadraticFunction,
    },
    g::Number,
)
    return operate_coefficients(Base.Fix2(*, g), f)
end

function Base.:*(
    f::Number,
    g::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction,
        MOI.ScalarQuadraticFunction,
        MOI.VectorOfVariables,
        MOI.VectorAffineFunction,
        MOI.VectorQuadraticFunction,
    },
)
    return g * f
end

### Base.:/

function Base.:/(
    f::Union{
        MOI.ScalarAffineFunction{T},
        MOI.ScalarQuadraticFunction{T},
        MOI.VectorAffineFunction{T},
        MOI.VectorQuadraticFunction{T},
    },
    g::T,
) where {T<:Number}
    return operate(/, T, f, g)
end

function Base.:/(f::Union{MOI.VariableIndex,MOI.VectorOfVariables}, g::Number)
    return operate(/, typeof(g), f, g)
end

### Base.:^

function Base.:^(func::MOI.ScalarAffineFunction{T}, p::Integer) where {T}
    if iszero(p)
        return one(MOI.ScalarQuadraticFunction{T})
    elseif isone(p)
        return convert(MOI.ScalarQuadraticFunction{T}, func)
    elseif p == 2
        return func * func
    else
        throw(ArgumentError("Cannot take $(typeof(func)) to the power $p."))
    end
end

function Base.:^(func::MOI.ScalarQuadraticFunction{T}, p::Integer) where {T}
    if iszero(p)
        return one(MOI.ScalarQuadraticFunction{T})
    elseif isone(p)
        return MA.mutable_copy(func)
    else
        throw(ArgumentError("Cannot take $(typeof(func)) to the power $p."))
    end
end

### LinearAlgebra

LinearAlgebra.dot(f::ScalarLike, g::ScalarLike) = f * g
LinearAlgebra.dot(α::T, func::TypedLike{T}) where {T<:Number} = α * func
LinearAlgebra.dot(func::TypedLike{T}, α::T) where {T<:Number} = func * α
LinearAlgebra.adjoint(f::ScalarLike) = f
LinearAlgebra.transpose(f::ScalarLike) = f
LinearAlgebra.symmetric_type(::Type{F}) where {F<:ScalarLike} = F
LinearAlgebra.symmetric(f::ScalarLike, ::Symbol) = f

#################### Concatenation of MOI functions: `vcat` ####################

"""
    fill_vector(
        vector::Vector,
        ::Type{T},
        fill_func::Function,
        dim_func::Function,
        funcs,
    ) where {T}

Fill the vector `vector` with
`fill_func(vector, vector_offset, output_offset, func)` for each function `func`
in `funcs` where `vector_offset` (resp. `output_offset`) is the sum of
`dim_func(T, func)` (resp. `output_dim(T, func)`) of previous functions of
`func`.

    fill_vector(
        vector::Vector,
        ::Type{T},
        vector_offset::Int,
        output_offset::Int,
        fill_func::Function,
        dim_func::Function,
        funcs...
    ) where {T}

Same than previous method but starting with possible nonzero `vector_offset` and
`output_offset`.
"""
function fill_vector(
    vector::Vector,
    ::Type{T},
    fill_func::F1,
    dim_func::F2,
    funcs,
) where {T,F1<:Function,F2<:Function}
    vector_offset = 0
    output_offset = 0
    for func in funcs
        fill_func(vector, vector_offset, output_offset, func)
        vector_offset += dim_func(T, func)
        output_offset += output_dim(T, func)
    end
    @assert length(vector) == vector_offset
    return
end

function fill_vector(
    vector::Vector,
    ::Type,
    vector_offset::Int,
    output_offset::Int,
    fill_func::F1,
    dim_func::F2,
) where {F1<:Function,F2<:Function}
    @assert length(vector) == vector_offset
    return
end

function fill_vector(
    vector::Vector,
    ::Type{T},
    vector_offset::Int,
    output_offset::Int,
    fill_func::F1,
    dim_func::F2,
    func,
    funcs...,
) where {T,F1<:Function,F2<:Function}
    fill_func(vector, vector_offset, output_offset, func)
    fill_vector(
        vector,
        T,
        vector_offset + dim_func(T, func),
        output_offset + output_dim(T, func),
        fill_func,
        dim_func,
        funcs...,
    )
    return
end

function fill_variables(
    variables::Vector{MOI.VariableIndex},
    offset::Int,
    output_offset::Int,
    func::MOI.VariableIndex,
)
    variables[offset+1] = func
    return
end

function fill_variables(
    variables::Vector{MOI.VariableIndex},
    offset::Int,
    ::Int,
    func::MOI.VectorOfVariables,
)
    variables[offset .+ (1:length(func.variables))] .= func.variables
    return
end

number_of_affine_terms(::Type{T}, ::Union{T,AbstractVector{T}}) where {T} = 0

number_of_affine_terms(::Type, ::MOI.VariableIndex) = 1

number_of_affine_terms(::Type, f::MOI.VectorOfVariables) = length(f.variables)

function number_of_affine_terms(
    ::Type{T},
    f::Union{MOI.ScalarAffineFunction{T},MOI.VectorAffineFunction{T}},
) where {T}
    return length(f.terms)
end

function number_of_affine_terms(
    ::Type{T},
    f::Union{MOI.ScalarQuadraticFunction{T},MOI.VectorQuadraticFunction{T}},
) where {T}
    return length(f.affine_terms)
end

function number_of_quadratic_terms(
    ::Type{T},
    ::Union{
        T,
        MOI.VariableIndex,
        MOI.VectorOfVariables,
        MOI.ScalarAffineFunction{T},
        AbstractVector{T},
        MOI.VectorAffineFunction{T},
    },
) where {T}
    return 0
end

function number_of_quadratic_terms(
    ::Type{T},
    f::Union{MOI.ScalarQuadraticFunction{T},MOI.VectorQuadraticFunction{T}},
) where {T}
    return length(f.quadratic_terms)
end

function offset_term(t::MOI.ScalarAffineTerm, offset::Int)
    return MOI.VectorAffineTerm(offset + 1, t)
end

function offset_term(t::MOI.VectorAffineTerm, offset::Int)
    return MOI.VectorAffineTerm(offset + t.output_index, t.scalar_term)
end

function offset_term(t::MOI.ScalarQuadraticTerm, offset::Int)
    return MOI.VectorQuadraticTerm(offset + 1, t)
end

function offset_term(t::MOI.VectorQuadraticTerm, offset::Int)
    return MOI.VectorQuadraticTerm(offset + t.output_index, t.scalar_term)
end

function fill_terms(
    ::Vector{MOI.VectorAffineTerm{T}},
    ::Int,
    ::Int,
    ::Union{T,AbstractVector{T}},
) where {T}
    return
end

function fill_terms(
    terms::Vector{MOI.VectorAffineTerm{T}},
    offset::Int,
    output_offset::Int,
    func::MOI.VariableIndex,
) where {T}
    terms[offset+1] =
        offset_term(MOI.ScalarAffineTerm(one(T), func), output_offset)
    return
end

function fill_terms(
    terms::Vector{MOI.VectorAffineTerm{T}},
    offset::Int,
    output_offset::Int,
    func::MOI.VectorOfVariables,
) where {T}
    n = number_of_affine_terms(T, func)
    terms[offset .+ (1:n)] .= MOI.VectorAffineTerm.(
        output_offset .+ (1:n),
        MOI.ScalarAffineTerm.(one(T), func.variables),
    )
    return
end

function fill_terms(
    terms::Vector{MOI.VectorAffineTerm{T}},
    offset::Int,
    output_offset::Int,
    func::Union{MOI.ScalarAffineFunction{T},MOI.VectorAffineFunction{T}},
) where {T}
    n = number_of_affine_terms(T, func)
    terms[offset .+ (1:n)] .= offset_term.(func.terms, output_offset)
    return
end

function fill_terms(
    terms::Vector{MOI.VectorAffineTerm{T}},
    offset::Int,
    output_offset::Int,
    func::Union{MOI.ScalarQuadraticFunction{T},MOI.VectorQuadraticFunction{T}},
) where {T}
    n = number_of_affine_terms(T, func)
    terms[offset .+ (1:n)] .= offset_term.(func.affine_terms, output_offset)
    return
end

function fill_terms(
    ::Vector{MOI.VectorQuadraticTerm{T}},
    ::Int,
    ::Int,
    ::Union{
        T,
        MOI.VariableIndex,
        AbstractVector{T},
        MOI.VectorOfVariables,
        MOI.ScalarAffineFunction{T},
        MOI.VectorAffineFunction{T},
    },
) where {T}
    return
end

function fill_terms(
    terms::Vector{MOI.VectorQuadraticTerm{T}},
    offset::Int,
    output_offset::Int,
    func::Union{MOI.ScalarQuadraticFunction{T},MOI.VectorQuadraticFunction{T}},
) where {T}
    n = number_of_quadratic_terms(T, func)
    terms[offset .+ (1:n)] .= offset_term.(func.quadratic_terms, output_offset)
    return
end

output_dim(::Type{T}, ::T) where {T} = 1

output_dim(::Type{T}, x::AbstractVector{T}) where {T} = length(x)

output_dim(::Type, func::MOI.AbstractFunction) = MOI.output_dimension(func)

function fill_constant(
    constant::Vector{T},
    offset::Int,
    ::Int,
    func::T,
) where {T}
    constant[offset+1] = func
    return
end

function fill_constant(
    constant::Vector{T},
    offset::Int,
    ::Int,
    func::AbstractVector{T},
) where {T}
    for (i, fi) in enumerate(func)
        constant[offset+i] = fi
    end
    return
end

function fill_constant(
    ::Vector{T},
    ::Int,
    ::Int,
    ::Union{MOI.VariableIndex,MOI.VectorOfVariables},
) where {T}
    return
end

function fill_constant(
    constant::Vector{T},
    offset::Int,
    ::Int,
    func::Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
) where {T}
    constant[offset+1] = func.constant
    return
end

function fill_constant(
    constant::Vector{T},
    offset::Int,
    ::Int,
    func::Union{MOI.VectorAffineFunction{T},MOI.VectorQuadraticFunction{T}},
) where {T}
    n = MOI.output_dimension(func)
    constant[offset .+ (1:n)] .= func.constants
    return
end

"""
    vectorize(x::AbstractVector{<:Number})

Returns `x`.
"""
vectorize(x::AbstractVector{<:Number}) = x

"""
    vectorize(x::AbstractVector{MOI.VariableIndex})

Returns the vector of scalar affine functions in the form of a
`MOI.VectorAffineFunction{T}`.
"""
function vectorize(x::AbstractVector{MOI.VariableIndex})
    # Explicitly construct the output vector here because don't know that `x`
    # has a `convert` method to `Vector`.
    y = Vector{MOI.VariableIndex}(undef, length(x))
    for (i, xi) in enumerate(x)
        y[i] = xi
    end
    return MOI.VectorOfVariables(y)
end

"""
    vectorize(funcs::AbstractVector{MOI.ScalarAffineFunction{T}}) where T

Returns the vector of scalar affine functions in the form of a
`MOI.VectorAffineFunction{T}`.
"""
function vectorize(funcs::AbstractVector{MOI.ScalarAffineFunction{T}}) where {T}
    nterms =
        mapreduce(func -> number_of_affine_terms(T, func), +, funcs, init = 0)
    out_dim = mapreduce(func -> output_dim(T, func), +, funcs, init = 0)
    terms = Vector{MOI.VectorAffineTerm{T}}(undef, nterms)
    constant = zeros(T, out_dim)
    fill_vector(terms, T, fill_terms, number_of_affine_terms, funcs)
    fill_vector(constant, T, fill_constant, output_dim, funcs)
    return MOI.VectorAffineFunction(terms, constant)
end

function MOI.VectorAffineFunction(
    funcs::AbstractVector{MOI.ScalarAffineFunction{T}},
) where {T}
    return vectorize(funcs)
end

"""
    vectorize(funcs::AbstractVector{MOI.ScalarQuadraticFunction{T}}) where T

Returns the vector of scalar quadratic functions in the form of a
`MOI.VectorQuadraticFunction{T}`.
"""
function vectorize(
    funcs::AbstractVector{MOI.ScalarQuadraticFunction{T}},
) where {T}
    num_affine_terms =
        mapreduce(func -> number_of_affine_terms(T, func), +, funcs, init = 0)
    num_quadratic_terms = mapreduce(
        func -> number_of_quadratic_terms(T, func),
        +,
        funcs,
        init = 0,
    )
    out_dim = mapreduce(func -> output_dim(T, func), +, funcs, init = 0)
    affine_terms = Vector{MOI.VectorAffineTerm{T}}(undef, num_affine_terms)
    quadratic_terms =
        Vector{MOI.VectorQuadraticTerm{T}}(undef, num_quadratic_terms)
    constant = zeros(T, out_dim)
    fill_vector(affine_terms, T, fill_terms, number_of_affine_terms, funcs)
    fill_vector(
        quadratic_terms,
        T,
        fill_terms,
        number_of_quadratic_terms,
        funcs,
    )
    fill_vector(constant, T, fill_constant, output_dim, funcs)
    return MOI.VectorQuadraticFunction(quadratic_terms, affine_terms, constant)
end

function MOI.VectorQuadraticFunction(
    funcs::AbstractVector{MOI.ScalarQuadraticFunction{T}},
) where {T}
    return vectorize(funcs)
end

function vectorize(x::AbstractVector{MOI.ScalarNonlinearFunction})
    # Explicitly construct the output vector here because don't know that `x`
    # has a `convert` method to `Vector`.
    y = Vector{MOI.ScalarNonlinearFunction}(undef, length(x))
    for (i, xi) in enumerate(x)
        y[i] = xi
    end
    return MOI.VectorNonlinearFunction(y)
end

scalarize(f::AbstractVector, ::Bool = false) = f

"""
    scalarize(func::MOI.VectorOfVariables, ignore_constants::Bool = false)

Returns a vector of scalar functions making up the vector function in the form
of a `Vector{MOI.SingleVariable}`.

See also [`eachscalar`](@ref).
"""
function scalarize(f::MOI.VectorOfVariables, ignore_constants::Bool = false)
    return f.variables
end

"""
    scalarize(func::MOI.VectorAffineFunction{T}, ignore_constants::Bool = false)

Returns a vector of scalar functions making up the vector function in the form
of a `Vector{MOI.ScalarAffineFunction{T}}`.

See also [`eachscalar`](@ref).
"""
function scalarize(
    f::MOI.VectorAffineFunction{T},
    ignore_constants::Bool = false,
) where {T}
    dimension = MOI.output_dimension(f)
    constants = ignore_constants ? zeros(T, dimension) : MOI.constant(f)
    counting = count_terms(dimension, f.terms)
    functions = MOI.ScalarAffineFunction{T}[
        MOI.ScalarAffineFunction{T}(MOI.ScalarAffineTerm{T}[], constants[i]) for i in 1:dimension
    ]
    for i in 1:dimension
        sizehint!(functions[i].terms, counting[i])
    end
    for term in f.terms
        push!(functions[term.output_index].terms, term.scalar_term)
    end
    return functions
end

"""
    scalarize(func::MOI.VectorQuadraticFunction{T}, ignore_constants::Bool = false)

Returns a vector of scalar functions making up the vector function in the form
of a `Vector{MOI.ScalarQuadraticFunction{T}}`.

See also [`eachscalar`](@ref).
"""
function scalarize(
    f::MOI.VectorQuadraticFunction{T},
    ignore_constants::Bool = false,
) where {T}
    dimension = MOI.output_dimension(f)
    constants = ignore_constants ? zeros(T, dimension) : MOI.constant(f)
    counting_scalars = count_terms(dimension, f.affine_terms)
    counting_quadratics = count_terms(dimension, f.quadratic_terms)
    functions = MOI.ScalarQuadraticFunction{T}[
        MOI.ScalarQuadraticFunction{T}(
            MOI.ScalarQuadraticTerm{T}[],
            MOI.ScalarAffineTerm{T}[],
            constants[i],
        ) for i in 1:dimension
    ]
    for i in 1:dimension
        sizehint!(functions[i].affine_terms, counting_scalars[i])
        sizehint!(functions[i].quadratic_terms, counting_quadratics[i])
    end
    for term in f.affine_terms
        push!(functions[term.output_index].affine_terms, term.scalar_term)
    end
    for term in f.quadratic_terms
        push!(functions[term.output_index].quadratic_terms, term.scalar_term)
    end
    return functions
end

function scalarize(
    f::MOI.VectorNonlinearFunction,
    ignore_constants::Bool = false,
)
    return f.rows
end

function count_terms(counting::Vector{<:Integer}, terms::Vector{T}) where {T}
    for term in terms
        counting[term.output_index] += 1
    end
    return
end

function count_terms(dimension::I, terms::Vector{T}) where {I,T}
    counting = zeros(I, dimension)
    count_terms(counting, terms)
    return counting
end

tol_default(T::Type{<:Union{Integer,Rational}}) = zero(T)

tol_default(T::Type{<:AbstractFloat}) = sqrt(eps(T))

convert_approx(::Type{T}, func::T; kws...) where {T} = func

convert_approx(::Type{F}, func::T; kws...) where {F,T} = convert(F, func)

function convert_approx(
    ::Type{MOI.VariableIndex},
    func::MOI.ScalarAffineFunction{T};
    tol = tol_default(T),
) where {T}
    f = canonical(func)
    i = findfirst(t -> isapprox(t.coefficient, one(T), atol = tol), f.terms)
    if abs(f.constant) > tol ||
       i === nothing ||
       any(j -> j != i && abs(f.terms[j].coefficient) > tol, eachindex(f.terms))
        throw(InexactError(:convert_approx, MOI.VariableIndex, func))
    end
    return f.terms[i].variable
end

function convert_approx(
    ::Type{MOI.VectorOfVariables},
    func::MOI.VectorAffineFunction{T};
    tol = tol_default(T),
) where {T}
    return MOI.VectorOfVariables([
        convert_approx(MOI.VariableIndex, f, tol = tol) for f in scalarize(func)
    ])
end

function Base.zero(F::Type{<:TypedScalarLike{T}}) where {T}
    return convert(F, zero(T))
end

function Base.one(F::Type{<:TypedScalarLike{T}}) where {T}
    return convert(F, one(T))
end

# !!! note
#     These two `promote_rules` are written explicitly instead of
#     `TypedScalarLike` in order to avoid a method invalidation.
function Base.promote_rule(
    F::Type{MOI.ScalarAffineFunction{T}},
    ::Type{T},
) where {T}
    return F
end

function Base.promote_rule(
    F::Type{MOI.ScalarQuadraticFunction{T}},
    ::Type{T},
) where {T}
    return F
end

function Base.promote_rule(
    F::Type{MOI.ScalarAffineFunction{T}},
    ::Type{MOI.VariableIndex},
) where {T}
    return F
end

function Base.promote_rule(
    F::Type{MOI.ScalarQuadraticFunction{T}},
    ::Type{MOI.VariableIndex},
) where {T}
    return F
end

function is_coefficient_type(
    ::Type{<:Union{MOI.VariableIndex,MOI.VectorOfVariables}},
    ::Type,
)
    return true
end

is_coefficient_type(::Type{<:TypedLike{T}}, ::Type{T}) where {T} = true

is_coefficient_type(::Type{<:TypedLike}, ::Type) = false

is_coefficient_type(::Type{<:MOI.ScalarNonlinearFunction}, ::Type) = true

is_coefficient_type(::Type{MOI.VectorNonlinearFunction}, ::Type) = true

similar_type(::Type{F}, ::Type{T}) where {F,T} = F

function similar_type(::Type{<:MOI.ScalarAffineFunction}, ::Type{T}) where {T}
    return MOI.ScalarAffineFunction{T}
end

function similar_type(
    ::Type{<:MOI.ScalarQuadraticFunction},
    ::Type{T},
) where {T}
    return MOI.ScalarQuadraticFunction{T}
end

function similar_type(::Type{<:MOI.VectorAffineFunction}, ::Type{T}) where {T}
    return MOI.VectorAffineFunction{T}
end

function similar_type(
    ::Type{<:MOI.VectorQuadraticFunction},
    ::Type{T},
) where {T}
    return MOI.VectorQuadraticFunction{T}
end

## Complex operations
# We assume MOI variables are real numbers.

function MA.promote_operation(
    op::Union{typeof(real),typeof(imag),typeof(conj)},
    F::Type{<:TypedLike{T}},
) where {T}
    return similar_type(F, MA.promote_operation(op, T))
end

Base.real(f::TypedLike) = operate_coefficients(real, f)

function MA.promote_operation(
    ::typeof(real),
    T::Type{<:Union{MOI.VariableIndex,MOI.VectorOfVariables}},
)
    return T
end

Base.real(f::Union{MOI.VariableIndex,MOI.VectorOfVariables}) = f

Base.imag(f::TypedLike) = operate_coefficients(imag, f)

Base.conj(f::TypedLike) = operate_coefficients(conj, f)

function MA.promote_operation(
    ::typeof(conj),
    T::Type{<:Union{MOI.VariableIndex,MOI.VectorOfVariables}},
)
    return T
end

Base.conj(f::Union{MOI.VariableIndex,MOI.VectorOfVariables}) = f

"""
    eval_term(value_fn::Function, t)

!!! warning
    This method is deprecated any may be removed in MathOptInterface v2.0. Use
    `eval_variables` instead.
"""
eval_term(value_fn::Function, t) = eval_variables(value_fn, t)

"""
    constant_vector(f)

!!! warning
    This method is deprecated and may be removed in MathOptInterface v2.0.
"""
function constant_vector(
    f::Union{MOI.ScalarAffineFunction,MOI.ScalarQuadraticFunction},
)
    return [f.constant]
end

function constant_vector(
    f::Union{MOI.VectorAffineFunction,MOI.VectorQuadraticFunction},
)
    return f.constants
end

"""
    is_complex(::Type{<:MOI.AbstractFunction})

Return `true` if the function type may return `<:Complex` values. It returns
`false` for real-valued functions.

This function defaults to returning a false negatives (`false`). If your new
function explicitly returns complex values, opt-in by defining a new method.

This function is mostly intended for use in the `MOI.Bridges` submodule to
identify when bridges are not applicable (because the function is
complex-valued).

## Example

```jldoctest
julia> MOI.Utilities.is_complex(MOI.VariableIndex)
false

julia> MOI.Utilities.is_complex(MOI.ScalarAffineFunction{Complex{Int}})
true

julia> MOI.Utilities.is_complex(MOI.ScalarNonlinearFunction)
false
```
"""
is_complex(::Type{<:MOI.AbstractFunction}) = false
is_complex(::Type{<:MOI.ScalarAffineFunction{<:Complex}}) = true
is_complex(::Type{<:MOI.VectorAffineFunction{<:Complex}}) = true
is_complex(::Type{<:MOI.ScalarQuadraticFunction{<:Complex}}) = true
is_complex(::Type{<:MOI.VectorQuadraticFunction{<:Complex}}) = true

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestSparseMatrix

import SparseArrays
using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

"""
    test_empty_size()

Julia 1.7 is going to outlaw constructing empty sparse matrices. Test that we
can still do so.
"""
function test_empty_size()
    A = MOI.Utilities.MutableSparseMatrixCSC{
        Float64,
        Int,
        MOI.Utilities.ZeroBasedIndexing,
    }()
    MOI.empty!(A)
    @test A.rowval == Int[]
    @test A.nzval == Float64[]
    @test A.colptr == Int[0]
end

function test_empty_large()
    A = MOI.Utilities.MutableSparseMatrixCSC{
        Float64,
        Int,
        MOI.Utilities.ZeroBasedIndexing,
    }()
    MOI.empty!(A)
    MOI.Utilities.add_column(A)
    MOI.Utilities.add_column(A)
    MOI.Utilities.set_number_of_rows(A, 5)
    B = convert(SparseArrays.SparseMatrixCSC{Float64,Int}, A)
    @test size(B) == (5, 2)
end

function test_VectorAffine_ZeroBased()
    A = MOI.Utilities.MutableSparseMatrixCSC{
        Float64,
        Int,
        MOI.Utilities.ZeroBasedIndexing,
    }()
    MOI.empty!(A)
    x = MOI.VariableIndex.(1:3)
    f = MOI.VectorAffineFunction(
        vcat(
            MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.(1.0, x)),
            MOI.VectorAffineTerm.(2, MOI.ScalarAffineTerm.([2.0, 3.0], x[2:3])),
        ),
        [0.5, 1.2],
    )

    index_map = MOI.Utilities.IndexMap()
    for i in 1:3
        MOI.Utilities.add_column(A)
        index_map[x[i]] = x[i]
    end
    MOI.Utilities.allocate_terms(A, index_map, f)
    MOI.Utilities.set_number_of_rows(A, 2)
    MOI.Utilities.load_terms(A, index_map, f, 0)
    MOI.Utilities.final_touch(A)
    B = convert(SparseArrays.SparseMatrixCSC{Float64,Int}, A)
    @test B == [1.0 1.0 1.0; 0.0 2.0 3.0]
    @test A.rowval == [0, 0, 1, 0, 1]
    @test A.nzval == [1.0, 1.0, 2.0, 1.0, 3.0]
    @test A.colptr == [0, 1, 3, 5]
    MOI.empty!(A)
    MOI.Utilities.add_column(A)
    C = convert(SparseArrays.SparseMatrixCSC{Float64,Int}, A)
    @test size(C) == (0, 1)
    return
end

function test_extract_function()
    A = MOI.Utilities.MutableSparseMatrixCSC{
        Float64,
        Int,
        MOI.Utilities.ZeroBasedIndexing,
    }()
    MOI.empty!(A)
    x = MOI.VariableIndex.(1:3)
    f = MOI.VectorAffineFunction(
        vcat(
            MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.(1.0, x)),
            MOI.VectorAffineTerm.(2, MOI.ScalarAffineTerm.([2.0, 3.0], x[2:3])),
        ),
        [0.5, 1.2],
    )

    index_map = MOI.Utilities.IndexMap()
    MOI.Utilities.add_columns(A, 3)
    for i in 1:3
        index_map[x[i]] = x[i]
    end
    MOI.Utilities.allocate_terms(A, index_map, f)
    MOI.Utilities.set_number_of_rows(A, 2)
    MOI.Utilities.load_terms(A, index_map, f, 0)
    MOI.Utilities.final_touch(A)
    row_1 = MOI.Utilities.extract_function(A, 1, 0.5)
    @test row_1 ≈ MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.5)
    @test MOI.Utilities.extract_function(A, 1:2, [0.5, 1.2]) ≈ f
    empty_f = MOI.Utilities.extract_function(A, 1:0, Float64[])
    @test empty_f ≈
          MOI.VectorAffineFunction(MOI.VectorAffineTerm{Float64}[], Float64[])
    r10 = MOI.Utilities.extract_function(A, 10, 0.5)
    @test r10 ≈ MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{Float64}[], 0.5)
    f1 = 0.6 + 1.0 * x[1] + 1.0 * x[2] + 1.0 * x[3]
    r10 = MOI.Utilities.extract_function(A, 0:1, [0.5, 0.6])
    @test r10 ≈ MOI.Utilities.vectorize([0.5, f1])
    return
end

function test_VectorAffine_OneBased()
    A = MOI.Utilities.MutableSparseMatrixCSC{
        Float64,
        Int,
        MOI.Utilities.OneBasedIndexing,
    }()
    MOI.empty!(A)
    x = MOI.VariableIndex.(1:3)
    f = MOI.VectorAffineFunction(
        vcat(
            MOI.VectorAffineTerm.(1, MOI.ScalarAffineTerm.(1.0, x)),
            MOI.VectorAffineTerm.(2, MOI.ScalarAffineTerm.([2.0, 3.0], x[2:3])),
        ),
        [0.5, 1.2],
    )

    index_map = MOI.Utilities.IndexMap()
    for i in 1:3
        MOI.Utilities.add_column(A)
        index_map[x[i]] = x[i]
    end
    MOI.Utilities.allocate_terms(A, index_map, f)
    MOI.Utilities.set_number_of_rows(A, 2)
    MOI.Utilities.load_terms(A, index_map, f, 0)
    MOI.Utilities.final_touch(A)
    B = convert(SparseArrays.SparseMatrixCSC{Float64,Int}, A)
    @test B == [1.0 1.0 1.0; 0.0 2.0 3.0]
    @test A.rowval == [1, 1, 2, 1, 2]
    @test A.nzval == [1.0, 1.0, 2.0, 1.0, 3.0]
    @test A.colptr == [1, 2, 4, 6]
    MOI.empty!(A)
    MOI.Utilities.add_column(A)
    C = convert(SparseArrays.SparseMatrixCSC{Float64,Int}, A)
    @test size(C) == (0, 1)
    return
end

function test_ScalarAffine_ZeroBased()
    A = MOI.Utilities.MutableSparseMatrixCSC{
        Float64,
        Int,
        MOI.Utilities.ZeroBasedIndexing,
    }()
    MOI.empty!(A)
    x = MOI.VariableIndex.(1:3)
    f1 = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.5)
    f2 =
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([2.0, 3.0], x[2:3]), 1.2)
    index_map = MOI.Utilities.IndexMap()
    for i in 1:3
        MOI.Utilities.add_column(A)
        index_map[x[i]] = x[i]
    end
    MOI.Utilities.allocate_terms(A, index_map, f1)
    MOI.Utilities.allocate_terms(A, index_map, f2)
    MOI.Utilities.set_number_of_rows(A, 2)
    MOI.Utilities.load_terms(A, index_map, f1, 0)
    MOI.Utilities.load_terms(A, index_map, f2, 1)
    MOI.Utilities.final_touch(A)
    B = convert(SparseArrays.SparseMatrixCSC{Float64,Int}, A)
    @test B == [1.0 1.0 1.0; 0.0 2.0 3.0]
    @test A.rowval == [0, 0, 1, 0, 1]
    @test A.nzval == [1.0, 1.0, 2.0, 1.0, 3.0]
    @test A.colptr == [0, 1, 3, 5]
    MOI.empty!(A)
    MOI.Utilities.add_column(A)
    C = convert(SparseArrays.SparseMatrixCSC{Float64,Int}, A)
    @test size(C) == (0, 1)
    return
end

function test_ScalarAffine_OneBased()
    A = MOI.Utilities.MutableSparseMatrixCSC{
        Float64,
        Int,
        MOI.Utilities.OneBasedIndexing,
    }()
    MOI.empty!(A)
    x = MOI.VariableIndex.(1:3)
    f1 = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(1.0, x), 0.5)
    f2 =
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([2.0, 3.0], x[2:3]), 1.2)
    index_map = MOI.Utilities.IndexMap()
    for i in 1:3
        MOI.Utilities.add_column(A)
        index_map[x[i]] = x[i]
    end
    MOI.Utilities.allocate_terms(A, index_map, f1)
    MOI.Utilities.allocate_terms(A, index_map, f2)
    MOI.Utilities.set_number_of_rows(A, 2)
    MOI.Utilities.load_terms(A, index_map, f1, 0)
    MOI.Utilities.load_terms(A, index_map, f2, 1)
    MOI.Utilities.final_touch(A)
    B = convert(SparseArrays.SparseMatrixCSC{Float64,Int}, A)
    @test B == [1.0 1.0 1.0; 0.0 2.0 3.0]
    @test A.rowval == [1, 1, 2, 1, 2]
    @test A.nzval == [1.0, 1.0, 2.0, 1.0, 3.0]
    @test A.colptr == [1, 2, 4, 6]
    MOI.empty!(A)
    MOI.Utilities.add_column(A)
    C = convert(SparseArrays.SparseMatrixCSC{Float64,Int}, A)
    @test size(C) == (0, 1)
    return
end

end

TestSparseMatrix.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    RSOCtoSOCBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`RSOCtoSOCBridge` implements the following reformulation:

  * ``||x||_2^2 \\le 2tu`` into
    ``||\\frac{t - u}{\\sqrt 2}, x||_2 \\le  \\frac{t + u}{\\sqrt 2}``

## Source node

`RSOCtoSOCBridge` supports:

  * `G` in [`MOI.RotatedSecondOrderCone`](@ref)

## Target node

`RSOCtoSOCBridge` creates:

  * `F` in [`MOI.SecondOrderCone`](@ref)
"""
struct RSOCtoSOCBridge{T,F,G} <:
       SetMapBridge{T,MOI.SecondOrderCone,MOI.RotatedSecondOrderCone,F,G}
    constraint::MOI.ConstraintIndex{F,MOI.SecondOrderCone}
end

const RSOC{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{RSOCtoSOCBridge{T},OT}

function concrete_bridge_type(
    ::Type{<:RSOCtoSOCBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.RotatedSecondOrderCone},
) where {T}
    S = MOI.Utilities.promote_operation(/, T, MOI.Utilities.scalar_type(G), T)
    Y = MOI.Utilities.promote_operation(-, T, S, S)
    Z = MOI.Utilities.promote_operation(+, T, S, S)
    F = MOI.Utilities.promote_operation(vcat, T, Z, Y, G)
    return RSOCtoSOCBridge{T,F,G}
end

function MOI.Bridges.map_set(
    ::Type{<:RSOCtoSOCBridge},
    set::MOI.RotatedSecondOrderCone,
)
    return MOI.SecondOrderCone(MOI.dimension(set))
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:RSOCtoSOCBridge},
    set::MOI.SecondOrderCone,
)
    return MOI.RotatedSecondOrderCone(MOI.dimension(set))
end

function MOI.Bridges.map_function(::Type{<:RSOCtoSOCBridge{T}}, func) where {T}
    scalars = MOI.Utilities.eachscalar(func)
    # We cannot construct MOI.RotatedSecondOrderCone(1)
    @assert length(scalars) >= 2
    t, u, x = scalars[1], scalars[2], scalars[3:end]
    ts = MOI.Utilities.operate!(/, T, t, sqrt(T(2)))
    us = MOI.Utilities.operate!(/, T, u, sqrt(T(2)))
    return MOI.Utilities.operate(vcat, T, ts + us, ts - us, x)
end

# The map is an involution
function MOI.Bridges.inverse_map_function(BT::Type{<:RSOCtoSOCBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is symmetric
function MOI.Bridges.adjoint_map_function(BT::Type{<:RSOCtoSOCBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is a symmetric involution
function MOI.Bridges.inverse_adjoint_map_function(
    BT::Type{<:RSOCtoSOCBridge},
    func,
)
    return MOI.Bridges.map_function(BT, func)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    test_variable_add_variable(model::MOI.ModelLike, config::Config)

Test adding a single variable.
"""
function test_variable_add_variable(model::MOI.ModelLike, ::Config)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    v = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    _test_attribute_value_type(model, MOI.NumberOfVariables())
    return
end

"""
    test_variable_add_variables(model::MOI.ModelLike, config::Config)

Test adding multiple variables.
"""
function test_variable_add_variables(model::MOI.ModelLike, ::Config)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    v = MOI.add_variables(model, 2)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    return
end

"""
    test_variable_delete(model::MOI.ModelLike, config::Config)

Tess adding, and then deleting, a single variable.
"""
function test_variable_delete(model::MOI.ModelLike, ::Config)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    v = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    MOI.delete(model, v)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    return
end

"""
    test_variable_delete_variables(model::MOI.ModelLike, config::Config)

Test adding, and then deleting, multiple variables.
"""
function test_variable_delete_variables(model::MOI.ModelLike, ::Config)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    v = MOI.add_variables(model, 2)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    MOI.delete(model, v)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    v = MOI.add_variables(model, 2)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    MOI.delete(model, v[1])
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    @test_throws MOI.InvalidIndex{MOI.VariableIndex} MOI.delete(model, v[1])
    try
        MOI.delete(model, v[1])
    catch err
        @test err.index == v[1]
    end
    @test !MOI.is_valid(model, v[1])
    @test MOI.is_valid(model, v[2])
    return
end

"""
    test_variable_delete_Nonnegatives(model::MOI.ModelLike, config::Config)

Test adding, and then deleting, nonnegative variables.
"""
function test_variable_delete_Nonnegatives(model::MOI.ModelLike, ::Config)
    @requires MOI.supports_add_constrained_variables(model, MOI.Nonnegatives)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    v, cv = MOI.add_constrained_variables(model, MOI.Nonnegatives(2))
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    MOI.delete(model, v)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    @test !MOI.is_valid(model, v[1])
    @test_throws MOI.InvalidIndex(v[1]) MOI.delete(model, v[1])
    @test !MOI.is_valid(model, v[2])
    @test_throws MOI.InvalidIndex(v[2]) MOI.delete(model, v[2])
    @test !MOI.is_valid(model, cv)
    v, cv = MOI.add_constrained_variables(model, MOI.Nonnegatives(1))
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    MOI.delete(model, v[1])
    @test !MOI.is_valid(model, v[1])
    @test_throws MOI.InvalidIndex(v[1]) MOI.delete(model, v[1])
    @test !MOI.is_valid(model, cv)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    return
end

"""
    test_variable_delete_Nonnegatives_row(model::MOI.ModelLike, ::Config)

Test adding, and then deleting one by one, nonnegative variables.
"""
function test_variable_delete_Nonnegatives_row(model::MOI.ModelLike, ::Config)
    @requires MOI.supports_add_constrained_variables(model, MOI.Nonnegatives)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    v, cv = MOI.add_constrained_variables(model, MOI.Nonnegatives(2))
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    MOI.delete(model, v[1])
    @test !MOI.is_valid(model, v[1])
    @test_throws MOI.InvalidIndex(v[1]) MOI.delete(model, v[1])
    @test MOI.is_valid(model, cv)
    @test MOI.is_valid(model, v[2])
    MOI.delete(model, v[2])
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    @test !MOI.is_valid(model, v[1])
    @test_throws MOI.InvalidIndex(v[1]) MOI.delete(model, v[1])
    @test !MOI.is_valid(model, v[2])
    @test_throws MOI.InvalidIndex(v[2]) MOI.delete(model, v[2])
    @test !MOI.is_valid(model, cv)
    return
end

"""
    test_variable_delete_SecondOrderCone(model::MOI.ModelLike, config::Config)

Test adding, and then deleting, second-order cone variables.
"""
function test_variable_delete_SecondOrderCone(model::MOI.ModelLike, ::Config)
    @requires MOI.supports_add_constrained_variables(model, MOI.SecondOrderCone)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    v, cv = MOI.add_constrained_variables(model, MOI.SecondOrderCone(3))
    @test MOI.get(model, MOI.NumberOfVariables()) == 3
    MOI.delete(model, v)
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    @test !MOI.is_valid(model, v[1])
    @test_throws MOI.InvalidIndex(v[1]) MOI.delete(model, v[1])
    @test !MOI.is_valid(model, v[2])
    @test_throws MOI.InvalidIndex(v[2]) MOI.delete(model, v[2])
    @test !MOI.is_valid(model, cv)
    v, cv = MOI.add_constrained_variables(model, MOI.SecondOrderCone(3))
    @test MOI.get(model, MOI.NumberOfVariables()) == 3
    @test_throws MOI.DeleteNotAllowed MOI.delete(model, v[1])
    return
end

"""
    test_variable_get_VariableIndex(model::MOI.ModelLike, config::Config)

Test getting variables by name.
"""
function test_variable_get_VariableIndex(model::MOI.ModelLike, ::Config)
    @requires MOI.supports(model, MOI.VariableName(), MOI.VariableIndex)
    variable = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), variable, "x")
    x = MOI.get(model, MOI.VariableIndex, "x")
    @test MOI.is_valid(model, x)
    @test MOI.get(model, MOI.VariableIndex, "y") === nothing
    return
end

"""
    test_variable_VariableName(model::MOI.ModelLike, config::Config)

Test getting and setting variable names.
"""
function test_variable_VariableName(model::MOI.ModelLike, ::Config)
    @requires MOI.supports(model, MOI.VariableName(), MOI.VariableIndex)
    v = MOI.add_variable(model)
    @test MOI.get(model, MOI.VariableName(), v) == ""
    MOI.set(model, MOI.VariableName(), v, "x")
    @test MOI.get(model, MOI.VariableName(), v) == "x"
    MOI.set(model, MOI.VariableName(), v, "y")
    @test MOI.get(model, MOI.VariableName(), v) == "y"
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    @test MOI.get(model, MOI.VariableName(), x) == "x"
    return
end

"""
    test_variable_solve_with_upperbound(model::MOI.ModelLike, config::Config)

Test setting the upper bound of a variable, confirm that it solves correctly.
"""
function test_variable_solve_with_upperbound(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    c1 = MOI.add_constraint(model, x, MOI.LessThan(T(1)))
    @test x.value == c1.value
    c2 = MOI.add_constraint(model, x, MOI.GreaterThan(T(0)))
    @test x.value == c2.value
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(0))
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    _test_model_solution(
        model,
        config;
        objective_value = T(2),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c1, T(1)), (c2, T(1))],
        constraint_dual = [(c1, T(-2)), (c2, T(0))],
    )
    return
end

function setup_test(
    ::typeof(test_variable_solve_with_upperbound),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.VariableIndex, MOI.LessThan{T}) => T[-2],
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[0],
        ),
    )
    model.eval_variable_constraint_dual = false
    return () -> model.eval_variable_constraint_dual = true
end

"""
    test_variable_solve_with_lowerbound(model::MOI.ModelLike, config::Config)

Test setting the lower bound of a variable, confirm that it solves correctly.
"""
function test_variable_solve_with_lowerbound(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    c1 = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    c2 = MOI.add_constraint(model, x, MOI.LessThan(T(2)))
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(0))
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    _test_model_solution(
        model,
        config;
        objective_value = T(2),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c1, T(1)), (c2, T(1))],
        constraint_dual = [(c1, T(2)), (c2, T(0))],
    )
    return
end

function setup_test(
    ::typeof(test_variable_solve_with_lowerbound),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
            (MOI.VariableIndex, MOI.GreaterThan{T}) => T[2],
            (MOI.VariableIndex, MOI.LessThan{T}) => T[0],
        ),
    )
    model.eval_variable_constraint_dual = false
    return () -> model.eval_variable_constraint_dual = true
end

"""
    test_variable_solve_Integer_with_lower_bound(
        model::MOI.ModelLike,
        config::Config,
    )

Test an integer variable with fractional lower bound.
"""
function test_variable_solve_Integer_with_lower_bound(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(T(3 // 2)))
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(0))
    MOI.add_constraint(model, x, MOI.Integer())
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    _test_model_solution(
        model,
        config;
        objective_value = T(4),
        variable_primal = [(x, T(2))],
    )
    return
end

function setup_test(
    ::typeof(test_variable_solve_Integer_with_lower_bound),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[2])),
    )
    return
end

"""
    test_variable_solve_Integer_with_upper_bound(
        model::MOI.ModelLike,
        config::Config,
    )

Test an integer variable with fractional upper bound.
"""
function test_variable_solve_Integer_with_upper_bound(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.LessThan(T(3 // 2)))
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(-2), x)], T(0))
    MOI.add_constraint(model, x, MOI.Integer())
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    _test_model_solution(
        model,
        config;
        objective_value = T(-2),
        variable_primal = [(x, T(1))],
    )
    return
end

function setup_test(
    ::typeof(test_variable_solve_Integer_with_upper_bound),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
    )
    return
end

"""
    test_variable_solve_ZeroOne_with_upper_bound(
        model::MOI.ModelLike,
        config::Config,
    )

Test a binary variable `<= 2`.
"""
function test_variable_solve_ZeroOne_with_upper_bound(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.LessThan(T(2)))
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(-2), x)], T(0))
    MOI.add_constraint(model, x, MOI.ZeroOne())
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    _test_model_solution(
        model,
        config;
        objective_value = T(-2),
        variable_primal = [(x, T(1))],
    )
    return
end

function setup_test(
    ::typeof(test_variable_solve_ZeroOne_with_upper_bound),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
    )
    return
end

"""
    test_variable_solve_ZeroOne_with_0_upper_bound(
        model::MOI.ModelLike,
        config::Config,
    )

Test a binary variable `<= 0`.
"""
function test_variable_solve_ZeroOne_with_0_upper_bound(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.LessThan(T(0)))
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    MOI.add_constraint(model, x, MOI.ZeroOne())
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    _test_model_solution(
        model,
        config;
        objective_value = T(0),
        variable_primal = [(x, T(0))],
    )
    return
end

function setup_test(
    ::typeof(test_variable_solve_ZeroOne_with_0_upper_bound),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[0])),
    )
    return
end

"""
    test_variable_solve_ZeroOne_with_1_lower_bound(
        model::MOI.ModelLike,
        config::Config,
    )

Test a binary variable `>= 1`.
"""
function test_variable_solve_ZeroOne_with_1_lower_bound(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    MOI.add_constraint(model, x, MOI.ZeroOne())
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
    )
    return
end

function setup_test(
    ::typeof(test_variable_solve_ZeroOne_with_1_lower_bound),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
    )
    return
end

function version_added(::typeof(test_variable_solve_ZeroOne_with_1_lower_bound))
    return v"1.5.0"
end

"""
    test_variable_solve_ZeroOne_with_bounds_then_delete(
        model::MOI.ModelLike,
        config::Config,
    )

Test `min: x >= 1, x in {0, 1}`, then delete the bound and check we get `x = 0`.
"""
function test_variable_solve_ZeroOne_with_bounds_then_delete(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.delete)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    MOI.add_constraint(model, x, MOI.ZeroOne())
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
    )
    MOI.delete(model, c)
    _test_model_solution(
        model,
        config;
        objective_value = T(0),
        variable_primal = [(x, T(0))],
    )
    return
end

function setup_test(
    ::typeof(test_variable_solve_ZeroOne_with_bounds_then_delete),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[0])),
    )
    return
end

function version_added(
    ::typeof(test_variable_solve_ZeroOne_with_bounds_then_delete),
)
    return v"1.5.0"
end

"""
    test_variable_VariablePrimalStart(model::MOI.ModelLike, ::Config)

Test VariablePrimalStart
"""
function test_model_VariablePrimalStart(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
    x = MOI.add_variable(model)
    @test MOI.get(model, MOI.VariablePrimalStart(), x) === nothing
    MOI.set(model, MOI.VariablePrimalStart(), x, T(1))
    @test MOI.get(model, MOI.VariablePrimalStart(), x) == T(1)
    MOI.set(model, MOI.VariablePrimalStart(), x, nothing)
    @test MOI.get(model, MOI.VariablePrimalStart(), x) === nothing
    return
end

"""
    test_add_constrained_variables(model::MOI.ModelLike, config::Config)

Test vector method of `add_constrained_variables`.
"""
function test_add_constrained_variables_vector(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports_add_constrained_variable(model, MOI.GreaterThan{T})
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    sets = [MOI.GreaterThan(zero(T)), MOI.GreaterThan(one(T))]
    v, cv = MOI.add_constrained_variables(model, sets)
    @test MOI.get(model, MOI.NumberOfVariables()) == 2
    @test length(v) == 2
    @test length(cv) == 2
    @test MOI.get(model, MOI.ConstraintSet(), cv[1]) == sets[1]
    @test MOI.get(model, MOI.ConstraintSet(), cv[2]) == sets[2]
    return
end

"""
    test_add_parameter(model::MOI.ModelLike, config::Config)

Test adding a variable in [`MOI.Parameter`](@ref).
"""
function test_add_parameter(model::MOI.ModelLike, ::Config{T}) where {T}
    @requires MOI.supports_add_constrained_variable(model, MOI.Parameter{T})
    @test MOI.get(model, MOI.NumberOfVariables()) == 0
    x, ci = MOI.add_constrained_variable(model, MOI.Parameter(one(T)))
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.Parameter(one(T))
    @test MOI.get(model, MOI.ConstraintFunction(), ci) == x
    F, S = MOI.VariableIndex, MOI.Parameter{T}
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    @test MOI.get(model, MOI.ListOfConstraintIndices{F,S}()) == [ci]
    MOI.set(model, MOI.ConstraintSet(), ci, MOI.Parameter(zero(T)))
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.Parameter(zero(T))
    return
end

version_added(::typeof(test_add_parameter)) = v"1.13.0"

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintExponentialConeToScalarNonlinearFunctionBridge

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ExponentialConeToScalarNonlinearFunctionBridge,
        """
        variables: x, y, z
        [x, y, z] in ExponentialCone()
        """,
        """
        variables: x, y, z
        ScalarNonlinearFunction(y * exp(x / y) - z) <= 0.0
        1.0 * y >= 0.0
        """,
    )
    return
end

function test_runtests_VectorAffineFunction()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ExponentialConeToScalarNonlinearFunctionBridge,
        """
        variables: x, y, z
        [1.0 * x, 2.0 * y, 3.0 * z + 1.0] in ExponentialCone()
        """,
        """
        variables: x, y, z
        ScalarNonlinearFunction(esc(2.0 * y) * exp(esc(1.0 * x) / esc(2.0 * y)) - esc(3.0 * z + 1.0)) <= 0.0
        2.0 * y >= 0.0
        """,
    )
    return
end

end  # module

TestConstraintExponentialConeToScalarNonlinearFunctionBridge.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

struct EmptyVector{T} <: AbstractVector{T} end

Base.size(::EmptyVector) = (0,)

Base.isempty(::EmptyVector) = true

Base.eltype(::EmptyVector{T}) where {T} = T

Base.iterate(::EmptyVector) = nothing

abstract type AbstractLazyMap{T} end

"""
    struct LazyMap{T,VT,F}
        f::F
        data::VT
    end

Iterator over the elements of `data` mapped by `f`.  This is similar to
[`Utilities.LazyMap`](@ref) except that `VT` should be a subtype of
`AbstractVector{T}` and `VectorLazyMap` is a subtype of `AbstractVector{T}` as
well.  Use [`Utilities.lazy_map`](@ref) to create a `VectorLazyMap` or `LazyMap`
depending on the type of `data`.
"""
struct LazyMap{T,VT,F}
    f::F
    data::VT
end

function LazyMap{T}(f, data) where {T}
    return LazyMap{T,typeof(data),typeof(f)}(f, data)
end

"""
    lazy_map(::Type{T}, f, data)

Return an [`Utilities.VectorLazyMap`](@ref) is an `AbstractVector` and a
[`Utilities.LazyMap`](@ref) otherwise.  These are similar to
`Base.Generator(f, data)` except that their `eltype` is fixed to `T`
while the `eltype` of `Base.Generator(f, data)` is `Any`.
"""
lazy_map(::Type{T}, f, data) where {T} = LazyMap{T}(f, data)

"""
    struct VectorLazyMap{T,VT<:AbstractVector{T},F} <: AbstractVector{T}
        f::F
        data::VT
    end

Iterator over the elements of `data` mapped by `f`. This is similar to
[`Utilities.LazyMap`](@ref) except that `VT` should be a subtype of
`AbstractVector{T}` and `VectorLazyMap` is a subtype of `AbstractVector{T}` as
well.  Use [`Utilities.lazy_map`](@ref) to create a `VectorLazyMap` or `LazyMap`
depending on the type of `data`.
"""
struct VectorLazyMap{T,VT<:AbstractVector,F} <: AbstractVector{T}
    f::F
    data::VT
end

function VectorLazyMap{T}(f, data) where {T}
    return VectorLazyMap{T,typeof(data),typeof(f)}(f, data)
end

function lazy_map(::Type{T}, f, data::AbstractVector) where {T}
    return VectorLazyMap{T}(f, data)
end

const AnyLazyMap{T} = Union{LazyMap{T},VectorLazyMap{T}}

Base.size(it::AnyLazyMap) = size(it.data)

Base.length(it::AnyLazyMap) = length(it.data)

function Base.iterate(it::AnyLazyMap, args...)
    elem_state = iterate(it.data, args...)
    if elem_state === nothing
        return
    else
        return it.f(elem_state[1]), elem_state[2]
    end
end

Base.IteratorSize(it::AnyLazyMap) = Base.IteratorSize(it.data)

Base.eltype(::AnyLazyMap{T}) where {T} = T

function Iterators.reverse(it::AnyLazyMap{T}) where {T}
    return lazy_map(T, it.f, Iterators.reverse(it.data))
end

function Base.getindex(it::AnyLazyMap, i)
    return it.f(getindex(it.data, i))
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# This file implements models similar to the SDPA format. It gives a good
# example because it does not support a lot of functions, hence the need for
# a lot of bridges.

MOI.Utilities.@model(
    StandardSDPAModel,
    (),
    (MOI.EqualTo,),
    (MOI.Nonnegatives, MOI.PositiveSemidefiniteConeTriangle),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (MOI.VectorOfVariables,),
    ()
)

function MOI.supports_constraint(
    ::StandardSDPAModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{
        <:Union{
            MOI.GreaterThan{T},
            MOI.LessThan{T},
            MOI.EqualTo{T},
            MOI.Interval{T},
            MOI.ZeroOne,
            MOI.Integer,
        },
    },
) where {T}
    return false
end

function MOI.supports_constraint(
    ::StandardSDPAModel{T},
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.Reals},
) where {T}
    return false
end

function MOI.supports_add_constrained_variables(
    ::StandardSDPAModel,
    ::Type{<:Union{MOI.Nonnegatives,MOI.PositiveSemidefiniteConeTriangle}},
)
    return true
end

function MOI.supports_add_constrained_variables(
    ::StandardSDPAModel,
    ::Type{MOI.Reals},
)
    return false
end

function MOI.supports(
    ::StandardSDPAModel{T},
    ::MOI.ObjectiveFunction{
        <:Union{
            MOI.VariableIndex,
            MOI.ScalarQuadraticFunction{T},
            MOI.ScalarNonlinearFunction,
            MOI.VectorOfVariables,
            MOI.VectorAffineFunction{T},
            MOI.VectorQuadraticFunction{T},
            MOI.VectorNonlinearFunction,
        },
    },
) where {T}
    return false
end

MOI.Utilities.@model(
    GeometricSDPAModel,
    (),
    (),
    (MOI.Zeros, MOI.Nonnegatives, MOI.PositiveSemidefiniteConeTriangle),
    (),
    (),
    (),
    (),
    (MOI.VectorAffineFunction,)
)

function MOI.supports_constraint(
    ::GeometricSDPAModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{
        <:Union{
            MOI.GreaterThan{T},
            MOI.LessThan{T},
            MOI.EqualTo{T},
            MOI.Interval{T},
            MOI.ZeroOne,
            MOI.Integer,
        },
    },
) where {T}
    return false
end

function MOI.supports(
    ::GeometricSDPAModel{T},
    ::MOI.ObjectiveFunction{
        <:Union{MOI.VariableIndex,MOI.ScalarQuadraticFunction{T}},
    },
) where {T}
    return false
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    normalize_and_add_constraint(
        model::MOI.ModelLike,
        func::MOI.AbstractScalarFunction,
        set::MOI.AbstractScalarSet;
        allow_modify_function::Bool = false,
    )

Adds the scalar constraint obtained by moving the constant term in `func` to the
set in `model`. If `allow_modify_function` is `true` then the function `func`
can be modified.
"""
function normalize_and_add_constraint(
    model::MOI.ModelLike,
    func::MOI.AbstractScalarFunction,
    set::MOI.AbstractScalarSet;
    allow_modify_function::Bool = false,
)
    return MOI.add_constraint(
        model,
        normalize_constant(
            func,
            set;
            allow_modify_function = allow_modify_function,
        )...,
    )
end

"""
    normalize_constant(
        func::MOI.AbstractScalarFunction,
        set::MOI.AbstractScalarSet;
        allow_modify_function::Bool = false,
    )

Return the `func`-in-`set` constraint in normalized form. That is, if `func` is
[`MOI.ScalarQuadraticFunction`](@ref) or [`MOI.ScalarAffineFunction`](@ref), the
constant is moved to the set. If `allow_modify_function` is `true` then the
function `func` can be modified.
"""
function normalize_constant(
    func::MOI.AbstractFunction,
    set::MOI.AbstractSet;
    allow_modify_function::Bool = false,
)
    return func, set
end

function normalize_constant(
    func::Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}},
    set::MOI.AbstractScalarSet;
    allow_modify_function::Bool = false,
) where {T}
    if supports_shift_constant(typeof(set))
        set = shift_constant(set, -func.constant)
        if !allow_modify_function
            func = copy(func)
        end
        func.constant = zero(T)
    end
    return func, set
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    output_dimension(f::AbstractFunction)

Return 1 if `f` is an [`AbstractScalarFunction`](@ref), or the number of output
components if `f` is an [`AbstractVectorFunction`](@ref).
"""
function output_dimension end

output_dimension(::AbstractScalarFunction) = 1

"""
    constant(f::AbstractFunction[, ::Type{T}]) where {T}

Returns the constant term of a scalar-valued function, or the constant vector of
a vector-valued function.

If `f` is untyped and `T` is provided, returns `zero(T)`.
"""
constant(f::AbstractFunction, ::Type{T}) where {T} = constant(f)

"""
    coefficient(t::ScalarAffineTerm)
    coefficient(t::ScalarQuadraticTerm)
    coefficient(t::VectorAffineTerm)
    coefficient(t::VectorQuadraticTerm)

Finds the coefficient stored in the term `t`.
"""
function coefficient end

"""
    term_indices(t::ScalarAffineTerm)
    term_indices(t::ScalarQuadraticTerm)
    term_indices(t::VectorAffineTerm)
    term_indices(t::VectorQuadraticTerm)

Returns the indices of the input term `t` as a tuple of `Int`s.

* For `t::ScalarAffineTerm`, this is a 1-tuple of the variable index.
* For `t::ScalarQuadraticTerm`, this is a 2-tuple of the variable indices
  in non-decreasing order.
* For `t::VectorAffineTerm`, this is a 2-tuple of the row/output and
  variable indices.
* For `t::VectorQuadraticTerm`, this is a 3-tuple of the row/output and
  variable indices in non-decreasing order.
"""
function term_indices end

"""
    term_pair(t::ScalarAffineTerm)
    term_pair(t::ScalarQuadraticTerm)
    term_pair(t::VectorAffineTerm)
    term_pair(t::VectorQuadraticTerm)

Returns the pair [`term_indices`](@ref) `=>` [`coefficient`](@ref) of the term.
"""
function term_pair end

# VariableIndex is defined in indextypes.jl

constant(::VariableIndex, ::Type{T}) where {T} = zero(T)

Base.copy(x::VariableIndex) = x

Base.isapprox(x::VariableIndex, y::VariableIndex; kwargs...) = x == y

"""
    ScalarAffineTerm{T}(coefficient::T, variable::VariableIndex) where {T}

Represents the scalar-valued term `coefficient * variable`.

## Example

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> MOI.ScalarAffineTerm(2.0, x)
MathOptInterface.ScalarAffineTerm{Float64}(2.0, MOI.VariableIndex(1))
```
"""
struct ScalarAffineTerm{T}
    coefficient::T
    variable::VariableIndex
end

coefficient(t::ScalarAffineTerm) = t.coefficient

term_indices(t::ScalarAffineTerm) = (t.variable.value,)

term_pair(t::ScalarAffineTerm) = term_indices(t) => coefficient(t)

# !!! developer note
#
#     ScalarAffineFunction is mutable because its `constant` field is likely of
#     an immutable type, while its `terms` field is of a mutable type, meaning
#     that creating a `ScalarAffineFunction` allocates, and it is desirable to
#     provide a zero-allocation option for working with ScalarAffineFunctions.
#
#     See https://github.com/jump-dev/MathOptInterface.jl/pull/343.

"""
    ScalarAffineFunction{T}(
        terms::Vector{ScalarAffineTerm{T}},
        constant::T,
    ) where {T}

Represents the scalar-valued affine function ``a^\\top x + b``, where:

 * ``a^\\top x`` is represented by the vector of [`ScalarAffineTerm`](@ref)s
 * ``b`` is a scalar `constant::T`

## Duplicates

Duplicate variable indices in `terms` are accepted, and the corresponding
coefficients are summed together.

## Example

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> terms = [MOI.ScalarAffineTerm(2.0, x), MOI.ScalarAffineTerm(3.0, x)]
2-element Vector{MathOptInterface.ScalarAffineTerm{Float64}}:
 MathOptInterface.ScalarAffineTerm{Float64}(2.0, MOI.VariableIndex(1))
 MathOptInterface.ScalarAffineTerm{Float64}(3.0, MOI.VariableIndex(1))

julia> f = MOI.ScalarAffineFunction(terms, 4.0)
4.0 + 2.0 MOI.VariableIndex(1) + 3.0 MOI.VariableIndex(1)
```
"""
mutable struct ScalarAffineFunction{T} <: AbstractScalarFunction
    terms::Vector{ScalarAffineTerm{T}}
    constant::T
end

constant(f::ScalarAffineFunction) = f.constant

function Base.copy(f::ScalarAffineFunction)
    return ScalarAffineFunction(copy(f.terms), copy(f.constant))
end

function ScalarAffineFunction{T}(x::VariableIndex) where {T}
    return ScalarAffineFunction([ScalarAffineTerm(one(T), x)], zero(T))
end

"""
    ScalarQuadraticTerm{T}(
        coefficient::T,
        variable_1::VariableIndex,
        variable_2::VariableIndex,
    ) where {T}

Represents the scalar-valued term ``c x_i x_j`` where ``c`` is `coefficient`,
``x_i`` is `variable_1` and ``x_j`` is `variable_2`.

## Example

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> MOI.ScalarQuadraticTerm(2.0, x, x)
MathOptInterface.ScalarQuadraticTerm{Float64}(2.0, MOI.VariableIndex(1), MOI.VariableIndex(1))
```
"""
struct ScalarQuadraticTerm{T}
    coefficient::T
    variable_1::VariableIndex
    variable_2::VariableIndex
end

coefficient(t::ScalarQuadraticTerm) = t.coefficient

function term_indices(t::ScalarQuadraticTerm)
    return minmax(t.variable_1.value, t.variable_2.value)
end

term_pair(t::ScalarQuadraticTerm) = term_indices(t) => coefficient(t)

# !!! developer note
#
#     ScalarQuadraticFunction is mutable because its `constant` field is likely
#     of an immutable type, while its `terms` field is of a mutable type,
#     meaning that creating a `ScalarQuadraticFunction` allocates, and it is
#     desirable to provide a zero-allocation option for working with
#     ScalarQuadraticFunctions.
#
#     See https://github.com/jump-dev/MathOptInterface.jl/pull/343.

"""
    ScalarQuadraticFunction{T}(
        quadratic_terms::Vector{ScalarQuadraticTerm{T}},
        affine_terms::Vector{ScalarAffineTerm{T}},
        constant::T,
    ) wher {T}

The scalar-valued quadratic function ``\\frac{1}{2}x^\\top Q x + a^\\top x + b``,
where:

 * ``Q`` is the symmetric matrix given by the vector of [`ScalarQuadraticTerm`](@ref)s
 * ``a^\\top x`` is a sparse vector given by the vector of [`ScalarAffineTerm`](@ref)s
 * ``b`` is the scalar `constant::T`.

## Duplicates

Duplicate indices in `quadratic_terms` or `affine_terms` are accepted, and the
corresponding coefficients are summed together.

In `quadratic_terms`, "mirrored" indices, `(q, r)` and `(r, q)` where `r` and
`q` are [`VariableIndex`](@ref)es, are considered duplicates; only one needs to
be specified.

## The 0.5 factor

Coupled with the interpretation of mirrored indices, the `0.5` factor in front
of the ``Q`` matrix is a common source of bugs.

As a rule, to represent ``a * x^2 + b * x * y``:

 * The coefficient ``a`` in front of squared variables (diagonal elements in
   ``Q``) must be doubled when creating a [`ScalarQuadraticTerm`](@ref)
 * The coefficient ``b`` in front of off-diagonal elements in ``Q`` should be
   left as ``b``, be cause the mirrored index ``b * y * x`` will be implicitly
   added.

## Example

To represent the function ``f(x, y) = 2 * x^2 + 3 * x * y + 4 * x + 5``, do:

```jldoctest
julia> x = MOI.VariableIndex(1);

julia> y = MOI.VariableIndex(2);

julia> constant = 5.0;

julia> affine_terms = [MOI.ScalarAffineTerm(4.0, x)];

julia> quadratic_terms = [
           MOI.ScalarQuadraticTerm(4.0, x, x),  # Note the changed coefficient
           MOI.ScalarQuadraticTerm(3.0, x, y),
       ]
2-element Vector{MathOptInterface.ScalarQuadraticTerm{Float64}}:
 MathOptInterface.ScalarQuadraticTerm{Float64}(4.0, MOI.VariableIndex(1), MOI.VariableIndex(1))
 MathOptInterface.ScalarQuadraticTerm{Float64}(3.0, MOI.VariableIndex(1), MOI.VariableIndex(2))

julia> f = MOI.ScalarQuadraticFunction(quadratic_terms, affine_terms, constant)
5.0 + 4.0 MOI.VariableIndex(1) + 2.0 MOI.VariableIndex(1)² + 3.0 MOI.VariableIndex(1)*MOI.VariableIndex(2)
```

"""
mutable struct ScalarQuadraticFunction{T} <: AbstractScalarFunction
    quadratic_terms::Vector{ScalarQuadraticTerm{T}}
    affine_terms::Vector{ScalarAffineTerm{T}}
    constant::T
end

constant(f::ScalarQuadraticFunction) = f.constant

function Base.copy(f::ScalarQuadraticFunction)
    return ScalarQuadraticFunction(
        copy(f.quadratic_terms),
        copy(f.affine_terms),
        copy(f.constant),
    )
end

"""
    ScalarNonlinearFunction(head::Symbol, args::Vector{Any})

The scalar-valued nonlinear function `head(args...)`, represented as a symbolic
expression tree, with the call operator `head` and ordered arguments in `args`.

## `head`

The `head::Symbol` must be an operator supported by the model.

The default list of supported univariate operators is given by:

 * [`Nonlinear.DEFAULT_UNIVARIATE_OPERATORS`](@ref)

and the default list of supported multivariate operators is given by:

 * [`Nonlinear.DEFAULT_MULTIVARIATE_OPERATORS`](@ref)

Additional operators can be registered by setting a [`UserDefinedFunction`](@ref)
attribute.

See the full list of operators supported by a [`ModelLike`](@ref) by querying
[`ListOfSupportedNonlinearOperators`](@ref).

## `args`

The vector `args` contains the arguments to the nonlinear function. If the
operator is univariate, it must contain one element. Otherwise, it may contain
multiple elements.

Each element must be one of the following:

 * A constant value of type `T<:Real`
 * A [`VariableIndex`](@ref)
 * A [`ScalarAffineFunction`](@ref)
 * A [`ScalarQuadraticFunction`](@ref)
 * A [`ScalarNonlinearFunction`](@ref)

## Unsupported operators

If the optimizer does not support `head`, an [`UnsupportedNonlinearOperator`](@ref)
error will be thrown.

There is no guarantee about when this error will be thrown; it may be thrown
when the function is first added to the model, or it may be thrown when
[`optimize!`](@ref) is called.

## Example

To represent the function ``f(x) = sin(x)^2``, do:

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> MOI.ScalarNonlinearFunction(
           :^,
           Any[MOI.ScalarNonlinearFunction(:sin, Any[x]), 2],
       )
^(sin(MOI.VariableIndex(1)), (2))
```
"""
struct ScalarNonlinearFunction <: AbstractScalarFunction
    head::Symbol
    args::Vector{Any}

    function ScalarNonlinearFunction(head::Symbol, args::AbstractVector)
        # TODO(odow): should we do this?
        # for arg in args
        #     if !(arg isa Real || arg isa AbstractScalarFunction)
        #         error("Unsupported object in nonlinear expression: $arg")
        #     end
        # end
        return new(head, convert(Vector{Any}, args))
    end
end

# copy() doesn't recursively copy the children, and deepcopy seems to have a
# performance problem for deeply nested structs.
function Base.copy(f::ScalarNonlinearFunction)
    stack, result_stack = Any[f], Any[]
    while !isempty(stack)
        arg = pop!(stack)
        if arg isa ScalarNonlinearFunction
            # We need some sort of hint so that the next time we see this on the
            # stack we evaluate it using the args in `result_stack`. One option
            # would be a custom type. Or we can just wrap in (,) and then check
            # for a Tuple, which isn't (curretly) a valid argument.
            push!(stack, (arg,))
            for child in arg.args
                push!(stack, child)
            end
        elseif arg isa Tuple{<:ScalarNonlinearFunction}
            result = only(arg)
            args = Any[pop!(result_stack) for i in 1:length(result.args)]
            push!(result_stack, ScalarNonlinearFunction(result.head, args))
        else
            push!(result_stack, copy(arg))
        end
    end
    return only(result_stack)
end

constant(f::ScalarNonlinearFunction, ::Type{T} = Float64) where {T} = zero(T)

"""
    UnsupportedNonlinearOperator(head::Symbol[, message::String]) <: UnsupportedError

An error thrown by optimizers if they do not support the operator `head` in a
[`ScalarNonlinearFunction`](@ref).

## Example

```jldoctest
julia> throw(MOI.UnsupportedNonlinearOperator(:black_box))
ERROR: MathOptInterface.UnsupportedNonlinearOperator: The nonlinear operator `:black_box` is not supported by the model.
Stacktrace:
[...]
```
"""
struct UnsupportedNonlinearOperator <: UnsupportedError
    head::Symbol
    message::String

    function UnsupportedNonlinearOperator(head::Symbol, message::String = "")
        return new(head, message)
    end
end

function element_name(err::UnsupportedNonlinearOperator)
    return "The nonlinear operator `:$(err.head)`"
end

"""
    abstract type AbstractVectorFunction <: AbstractFunction

Abstract supertype for vector-valued [`AbstractFunction`](@ref)s.

## Required methods

All subtypes of `AbstractVectorFunction` must implement:

 * [`output_dimension`](@ref)
"""
abstract type AbstractVectorFunction <: AbstractFunction end

"""
    VectorOfVariables(variables::Vector{VariableIndex}) <: AbstractVectorFunction

The vector-valued function `f(x) = variables`, where `variables` is a subset of
[`VariableIndex`](@ref)es in the model.

The list of `variables` may contain duplicates.

## Example

```jldoctest
julia> x = MOI.VariableIndex.(1:2)
2-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)

julia> f = MOI.VectorOfVariables([x[1], x[2], x[1]])
┌                    ┐
│MOI.VariableIndex(1)│
│MOI.VariableIndex(2)│
│MOI.VariableIndex(1)│
└                    ┘

julia> MOI.output_dimension(f)
3
```
"""
struct VectorOfVariables <: AbstractVectorFunction
    variables::Vector{VariableIndex}
end

output_dimension(f::VectorOfVariables) = length(f.variables)

function constant(f::VectorOfVariables, ::Type{T}) where {T}
    return zeros(T, output_dimension(f))
end

Base.copy(f::VectorOfVariables) = VectorOfVariables(copy(f.variables))

function Base.:(==)(f::VectorOfVariables, g::VectorOfVariables)
    return f.variables == g.variables
end

Base.isapprox(x::VectorOfVariables, y::VectorOfVariables; kwargs...) = x == y

"""
    VectorAffineTerm{T}(
        output_index::Int64,
        scalar_term::ScalarAffineTerm{T},
    ) where {T}

A `VectorAffineTerm` is a `scalar_term` that appears in the `output_index` row
of the vector-valued [`VectorAffineFunction`](@ref) or
[`VectorQuadraticFunction`](@ref).

## Example

```jldoctest
julia> x = MOI.VariableIndex(1);

julia> MOI.VectorAffineTerm(Int64(2), MOI.ScalarAffineTerm(3.0, x))
MathOptInterface.VectorAffineTerm{Float64}(2, MathOptInterface.ScalarAffineTerm{Float64}(3.0, MOI.VariableIndex(1)))
```
"""
struct VectorAffineTerm{T}
    output_index::Int64
    scalar_term::ScalarAffineTerm{T}
end

function VectorAffineTerm(
    output_index::Base.Integer,
    scalar_term::ScalarAffineTerm,
)
    return VectorAffineTerm(convert(Int64, output_index), scalar_term)
end

coefficient(t::VectorAffineTerm) = t.scalar_term.coefficient

function term_indices(t::VectorAffineTerm)
    return (t.output_index, term_indices(t.scalar_term)...)
end

term_pair(t::VectorAffineTerm) = term_indices(t) => coefficient(t)

"""
    VectorAffineFunction{T}(
        terms::Vector{VectorAffineTerm{T}},
        constants::Vector{T},
    ) where {T}

The vector-valued affine function ``A x + b``, where:

 * ``A x`` is the sparse matrix given by the vector of [`VectorAffineTerm`](@ref)s
 * ``b`` is the vector `constants`

## Duplicates

Duplicate indices in the ``A`` are accepted, and the corresponding coefficients
are summed together.

## Example

```jldoctest
julia> x = MOI.VariableIndex(1);

julia> terms = [
           MOI.VectorAffineTerm(Int64(1), MOI.ScalarAffineTerm(2.0, x)),
           MOI.VectorAffineTerm(Int64(2), MOI.ScalarAffineTerm(3.0, x)),
       ];

julia> f = MOI.VectorAffineFunction(terms, [4.0, 5.0])
┌                              ┐
│4.0 + 2.0 MOI.VariableIndex(1)│
│5.0 + 3.0 MOI.VariableIndex(1)│
└                              ┘

julia> MOI.output_dimension(f)
2
```
"""
struct VectorAffineFunction{T} <: AbstractVectorFunction
    terms::Vector{VectorAffineTerm{T}}
    constants::Vector{T}
end

output_dimension(f::VectorAffineFunction) = length(f.constants)

constant(f::VectorAffineFunction) = f.constants

function Base.copy(f::VectorAffineFunction)
    return VectorAffineFunction(copy(f.terms), copy(f.constants))
end

function VectorAffineFunction{T}(f::VectorOfVariables) where {T}
    terms = map(1:output_dimension(f)) do i
        return VectorAffineTerm(i, ScalarAffineTerm(one(T), f.variables[i]))
    end
    constants = zeros(T, output_dimension(f))::Vector{T}
    return VectorAffineFunction(terms, constants)
end

"""
    VectorQuadraticTerm{T}(
        output_index::Int64,
        scalar_term::ScalarQuadraticTerm{T},
    ) where {T}

A `VectorQuadraticTerm` is a [`ScalarQuadraticTerm`](@ref) `scalar_term` that
appears in the `output_index` row of the vector-valued
[`VectorQuadraticFunction`](@ref).

## Example

```jldoctest
julia> x = MOI.VariableIndex(1);

julia> MOI.VectorQuadraticTerm(Int64(2), MOI.ScalarQuadraticTerm(3.0, x, x))
MathOptInterface.VectorQuadraticTerm{Float64}(2, MathOptInterface.ScalarQuadraticTerm{Float64}(3.0, MOI.VariableIndex(1), MOI.VariableIndex(1)))
```
"""
struct VectorQuadraticTerm{T}
    output_index::Int64
    scalar_term::ScalarQuadraticTerm{T}
end

function VectorQuadraticTerm(
    output_index::Base.Integer,
    scalar_term::ScalarQuadraticTerm,
)
    return VectorQuadraticTerm(convert(Int64, output_index), scalar_term)
end

coefficient(t::VectorQuadraticTerm) = t.scalar_term.coefficient

function term_indices(t::VectorQuadraticTerm)
    return (t.output_index, term_indices(t.scalar_term)...)
end

term_pair(t::VectorQuadraticTerm) = term_indices(t) => coefficient(t)

"""
    VectorQuadraticFunction{T}(
        quadratic_terms::Vector{VectorQuadraticTerm{T}},
        affine_terms::Vector{VectorAffineTerm{T}},
        constants::Vector{T},
    ) where {T}

The vector-valued quadratic function with i`th` component ("output index")
defined as ``\\frac{1}{2}x^\\top Q_i x + a_i^\\top x + b_i``, where:

 * ``\\frac{1}{2}x^\\top Q_i x`` is the symmetric matrix given by the
   [`VectorQuadraticTerm`](@ref) elements in `quadratic_terms` with
   `output_index == i`
 * ``a_i^\\top x`` is the sparse vector given by the [`VectorAffineTerm`](@ref)
   elements in `affine_terms` with `output_index == i`
 * ``b_i`` is a scalar given by `constants[i]`

## Duplicates

Duplicate indices in `quadratic_terms` and `affine_terms` with the same
`output_index` are handled in the same manner as duplicates in
[`ScalarQuadraticFunction`](@ref).

## Example

```jldoctest
julia> x = MOI.VariableIndex(1);

julia> y = MOI.VariableIndex(2);

julia> constants = [4.0, 5.0];

julia> affine_terms = [
           MOI.VectorAffineTerm(Int64(1), MOI.ScalarAffineTerm(2.0, x)),
           MOI.VectorAffineTerm(Int64(2), MOI.ScalarAffineTerm(3.0, x)),
       ];

julia> quad_terms = [
        MOI.VectorQuadraticTerm(Int64(1), MOI.ScalarQuadraticTerm(2.0, x, x)),
        MOI.VectorQuadraticTerm(Int64(2), MOI.ScalarQuadraticTerm(3.0, x, y)),
           ];

julia> f = MOI.VectorQuadraticFunction(quad_terms, affine_terms, constants)
┌                                                                              ┐
│4.0 + 2.0 MOI.VariableIndex(1) + 1.0 MOI.VariableIndex(1)²                    │
│5.0 + 3.0 MOI.VariableIndex(1) + 3.0 MOI.VariableIndex(1)*MOI.VariableIndex(2)│
└                                                                              ┘

julia> MOI.output_dimension(f)
2
```
"""
struct VectorQuadraticFunction{T} <: AbstractVectorFunction
    quadratic_terms::Vector{VectorQuadraticTerm{T}}
    affine_terms::Vector{VectorAffineTerm{T}}
    constants::Vector{T}
end

output_dimension(f::VectorQuadraticFunction) = length(f.constants)

constant(f::VectorQuadraticFunction) = f.constants

function Base.copy(f::VectorQuadraticFunction)
    return VectorQuadraticFunction(
        copy(f.quadratic_terms),
        copy(f.affine_terms),
        copy(f.constants),
    )
end

"""
    VectorNonlinearFunction(args::Vector{ScalarNonlinearFunction})

The vector-valued nonlinear function composed of a vector of
[`ScalarNonlinearFunction`](@ref).

## `args`

The vector `args` contains the scalar elements of the nonlinear function. Each
element must be a [`ScalarNonlinearFunction`](@ref), but if you pass a
`Vector{Any}`, the elements can be automatically converted from one of the
following:

 * A constant value of type `T<:Real`
 * A [`VariableIndex`](@ref)
 * A [`ScalarAffineFunction`](@ref)
 * A [`ScalarQuadraticFunction`](@ref)
 * A [`ScalarNonlinearFunction`](@ref)

## Example

To represent the function ``f(x) = [sin(x)^2, x]``, do:

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> g = MOI.ScalarNonlinearFunction(
           :^,
           Any[MOI.ScalarNonlinearFunction(:sin, Any[x]), 2.0],
       )
^(sin(MOI.VariableIndex(1)), 2.0)

julia> MOI.VectorNonlinearFunction([g, x])
┌                                 ┐
│^(sin(MOI.VariableIndex(1)), 2.0)│
│+(MOI.VariableIndex(1))          │
└                                 ┘
```

Note the automatic conversion from `x` to `+(x)`.
"""
struct VectorNonlinearFunction <: AbstractVectorFunction
    rows::Vector{ScalarNonlinearFunction}
end

output_dimension(f::VectorNonlinearFunction) = length(f.rows)

function constant(f::VectorNonlinearFunction, ::Type{T}) where {T}
    return zeros(T, output_dimension(f))
end

Base.copy(f::VectorNonlinearFunction) = VectorNonlinearFunction(copy(f.rows))

function Base.:(==)(f::VectorNonlinearFunction, g::VectorNonlinearFunction)
    return f.rows == g.rows
end

function Base.isapprox(
    x::VectorNonlinearFunction,
    y::VectorNonlinearFunction;
    kwargs...,
)
    return all(isapprox(xi, yi; kwargs...) for (xi, yi) in zip(x.rows, y.rows))
end

# Function modifications

"""
    AbstractFunctionModification

An abstract supertype for structs which specify partial modifications to
functions, to be used for making small modifications instead of replacing the
functions entirely.
"""
abstract type AbstractFunctionModification end

"""
    ScalarConstantChange{T}(new_constant::T)

A struct used to request a change in the constant term of a scalar-valued
function.

Applicable to [`ScalarAffineFunction`](@ref) and [`ScalarQuadraticFunction`](@ref).
"""
struct ScalarConstantChange{T} <: AbstractFunctionModification
    new_constant::T
end

"""
    VectorConstantChange{T}(new_constant::Vector{T})

A struct used to request a change in the constant vector of a vector-valued
function.

Applicable to [`VectorAffineFunction`](@ref) and [`VectorQuadraticFunction`](@ref).
"""
struct VectorConstantChange{T} <: AbstractFunctionModification
    new_constant::Vector{T}
end

"""
    ScalarCoefficientChange{T}(variable::VariableIndex, new_coefficient::T)

A struct used to request a change in the linear coefficient of a single variable
in a scalar-valued function.

Applicable to [`ScalarAffineFunction`](@ref) and [`ScalarQuadraticFunction`](@ref).
"""
struct ScalarCoefficientChange{T} <: AbstractFunctionModification
    variable::VariableIndex
    new_coefficient::T
end

"""
    ScalarQuadraticCoefficientChange{T}(
        variable_1::VariableIndex,
        variable_2::VariableIndex,
        new_coefficient::T,
    )

A struct used to request a change in the quadratic coefficient of a
[`ScalarQuadraticFunction`](@ref).

## Scaling factors

A [`ScalarQuadraticFunction`](@ref) has an implicit `0.5` scaling factor in
front of the `Q` matrix. This modification applies to terms in the `Q` matrix.

If `variable_1 == variable_2`, this modification sets the corresponding diagonal
element of the `Q` matrix to `new_coefficient`.

If `variable_1 != variable_2`, this modification is equivalent to setting both
the corresponding upper- and lower-triangular elements of the `Q` matrix to
`new_coefficient`.

As a consequence:

 * to modify the term `x^2` to become `2x^2`, `new_coefficient` must be `4`
 * to modify the term `xy` to become `2xy`, `new_coefficient` must be `2`
"""
struct ScalarQuadraticCoefficientChange{T} <: AbstractFunctionModification
    variable_1::VariableIndex
    variable_2::VariableIndex
    new_coefficient::T
end

# !!! developer note
#     MultiRowChange is mutable because its `variable` field of an immutable
#     type, while `new_coefficients` is of a mutable type, meaning that creating
#     a `MultiRowChange` allocates, and it is desirable to provide a
#     zero-allocation option for working with MultiRowChanges.
#
#     See https://github.com/jump-dev/MathOptInterface.jl/pull/343.

"""
    MultirowChange{T}(
        variable::VariableIndex,
        new_coefficients::Vector{Tuple{Int64,T}},
    ) where {T}

A struct used to request a change in the linear coefficients of a single
variable in a vector-valued function.

New coefficients are specified by `(output_index, coefficient)` tuples.

Applicable to [`VectorAffineFunction`](@ref) and [`VectorQuadraticFunction`](@ref).
"""
mutable struct MultirowChange{T} <: AbstractFunctionModification
    variable::VariableIndex
    new_coefficients::Vector{Tuple{Int64,T}}
end

function MultirowChange(
    variable::VariableIndex,
    new_coefficients::Vector{Tuple{Ti,T}},
) where {Ti<:Base.Integer,T}
    return MultirowChange(
        variable,
        [(convert(Int64, i), j) for (i, j) in new_coefficients],
    )
end

# isapprox

# For affine and quadratic functions, terms are compressed in a dictionary using
# `_dicts` and then the dictionaries are compared with `dict_compare`
function dict_compare(d1::Dict, d2::Dict{<:Any,T}, compare::Function) where {T}
    for key in union(keys(d1), keys(d2))
        if !compare(Base.get(d1, key, zero(T)), Base.get(d2, key, zero(T)))
            return false
        end
    end
    return true
end

# Build a dictionary where the duplicate keys are summed
function sum_dict(kvs::Vector{Pair{K,V}}) where {K,V}
    d = Dict{K,V}()
    for (key, value) in kvs
        d[key] = value + Base.get(d, key, zero(V))
    end
    return d
end

function _dicts(f::Union{ScalarAffineFunction,VectorAffineFunction})
    return (sum_dict(term_pair.(f.terms)),)
end

function _dicts(f::Union{ScalarQuadraticFunction,VectorQuadraticFunction})
    return (
        sum_dict(term_pair.(f.quadratic_terms)),
        sum_dict(term_pair.(f.affine_terms)),
    )
end

function Base.isapprox(
    f::F,
    g::G;
    kwargs...,
) where {
    F<:Union{
        ScalarAffineFunction,
        ScalarQuadraticFunction,
        VectorAffineFunction,
        VectorQuadraticFunction,
    },
    G<:Union{
        ScalarAffineFunction,
        ScalarQuadraticFunction,
        VectorAffineFunction,
        VectorQuadraticFunction,
    },
}
    return isapprox(constant(f), constant(g); kwargs...) && all(
        dict_compare.(
            _dicts(f),
            _dicts(g),
            (α, β) -> isapprox(α, β; kwargs...),
        ),
    )
end

# This method is used by CBF in testing.
function Base.isapprox(f::VectorOfVariables, g::VectorAffineFunction; kwargs...)
    return isapprox(convert(typeof(g), f), g; kwargs...)
end

_is_approx(x, y; kwargs...) = isapprox(x, y; kwargs...)

function _is_approx(x::AbstractArray, y::AbstractArray; kwargs...)
    return size(x) == size(y) &&
           all(z -> _is_approx(z[1], z[2]; kwargs...), zip(x, y))
end

function Base.isapprox(
    f::ScalarNonlinearFunction,
    g::ScalarNonlinearFunction;
    kwargs...,
)
    if f.head != g.head || length(f.args) != length(g.args)
        return false
    end
    for (fi, gi) in zip(f.args, g.args)
        if !_is_approx(fi, gi; kwargs...)
            return false
        end
    end
    return true
end

###
### Base.convert
###

# VariableIndex

function Base.convert(::Type{VariableIndex}, f::ScalarAffineFunction)
    if !iszero(f.constant)
        throw(InexactError(:convert, VariableIndex, f))
    end
    scalar_term = nothing
    for term in f.terms
        if isone(term.coefficient) && scalar_term === nothing
            scalar_term = term
        elseif !iszero(term.coefficient)
            throw(InexactError(:convert, VariableIndex, f))
        end
    end
    if scalar_term === nothing
        throw(InexactError(:convert, VariableIndex, f))
    end
    return scalar_term.variable::VariableIndex
end

function Base.convert(
    ::Type{VariableIndex},
    f::ScalarQuadraticFunction{T},
) where {T}
    return convert(VariableIndex, convert(ScalarAffineFunction{T}, f))
end

# ScalarAffineFunction

function Base.convert(::Type{ScalarAffineFunction{T}}, α::T) where {T}
    return ScalarAffineFunction{T}(ScalarAffineTerm{T}[], α)
end

function Base.convert(
    ::Type{ScalarAffineFunction{T}},
    f::VariableIndex,
) where {T}
    return ScalarAffineFunction{T}(f)
end

function Base.convert(
    ::Type{ScalarAffineTerm{T}},
    t::ScalarAffineTerm,
) where {T}
    return ScalarAffineTerm{T}(t.coefficient, t.variable)
end

function Base.convert(
    ::Type{ScalarAffineFunction{T}},
    f::ScalarAffineFunction,
) where {T}
    return ScalarAffineFunction{T}(f.terms, f.constant)
end

function Base.convert(
    ::Type{ScalarAffineFunction{T}},
    f::ScalarQuadraticFunction{T},
) where {T}
    if !Base.isempty(f.quadratic_terms)
        throw(InexactError(:convert, ScalarAffineFunction{T}, f))
    end
    return ScalarAffineFunction{T}(f.affine_terms, f.constant)
end

_order(x::Real, y::VariableIndex) = (x, y)
_order(x::VariableIndex, y::Real) = (y, x)
_order(x, y) = nothing

function Base.convert(
    ::Type{ScalarAffineTerm{T}},
    f::ScalarNonlinearFunction,
) where {T}
    if f.head != :* || length(f.args) != 2
        throw(InexactError(:convert, ScalarAffineTerm, f))
    end
    ret = _order(f.args[1], f.args[2])
    if ret === nothing
        throw(InexactError(:convert, ScalarAffineTerm, f))
    end
    return ScalarAffineTerm(convert(T, ret[1]), ret[2])
end

function _add_to_function(
    f::ScalarAffineFunction{T},
    arg::Union{Real,VariableIndex,ScalarAffineFunction},
) where {T}
    return Utilities.operate!(+, T, f, arg)
end

function _add_to_function(
    f::ScalarAffineFunction{T},
    arg::ScalarNonlinearFunction,
) where {T}
    if arg.head == :* && length(arg.args) == 2
        push!(f.terms, convert(ScalarAffineTerm{T}, arg))
    else
        _add_to_function(f, convert(ScalarAffineFunction{T}, arg))
    end
    return f
end

_add_to_function(::ScalarAffineFunction, ::Any) = nothing

# This is a very rough-and-ready conversion function that only works for very
# basic expressions, such as those created by
# `convert(ScalarNonlinearFunction, f)`.
function Base.convert(
    ::Type{ScalarAffineFunction{T}},
    f::ScalarNonlinearFunction,
) where {T}
    if f.head == :* && length(f.args) == 2
        term = convert(ScalarAffineTerm{T}, f)
        return ScalarAffineFunction{T}([term], zero(T))
    end
    if f.head != :+
        throw(InexactError(:convert, ScalarAffineFunction{T}, f))
    end
    output = ScalarAffineFunction{T}(ScalarAffineTerm{T}[], zero(T))
    for arg in f.args
        output = _add_to_function(output, arg)
        if output === nothing
            throw(InexactError(:convert, ScalarAffineFunction{T}, f))
        end
    end
    return output
end

# ScalarQuadraticFunction

function Base.convert(::Type{ScalarQuadraticFunction{T}}, α::T) where {T}
    return ScalarQuadraticFunction{T}(
        ScalarQuadraticTerm{T}[],
        ScalarAffineTerm{T}[],
        α,
    )
end

function Base.convert(
    ::Type{ScalarQuadraticFunction{T}},
    f::VariableIndex,
) where {T}
    return convert(
        ScalarQuadraticFunction{T},
        convert(ScalarAffineFunction{T}, f),
    )
end

function Base.convert(
    ::Type{ScalarQuadraticFunction{T}},
    f::ScalarAffineFunction{T},
) where {T}
    return ScalarQuadraticFunction{T}(
        ScalarQuadraticTerm{T}[],
        f.terms,
        f.constant,
    )
end

function Base.convert(
    ::Type{ScalarQuadraticTerm{T}},
    f::ScalarQuadraticTerm,
) where {T}
    return ScalarQuadraticTerm{T}(f.coefficient, f.variable_1, f.variable_2)
end

function Base.convert(
    ::Type{ScalarQuadraticFunction{T}},
    f::ScalarQuadraticFunction,
) where {T}
    return ScalarQuadraticFunction{T}(
        f.quadratic_terms,
        f.affine_terms,
        f.constant,
    )
end

_order(x::Real, y::VariableIndex, z::VariableIndex) = (x, y, z)
_order(x::VariableIndex, y::Real, z::VariableIndex) = (y, x, z)
_order(x::VariableIndex, y::VariableIndex, z::Real) = (z, x, y)
_order(x, y, z) = nothing

function Base.convert(
    ::Type{ScalarQuadraticTerm{T}},
    f::ScalarNonlinearFunction,
) where {T}
    if f.head != :* || length(f.args) != 3
        throw(InexactError(:convert, ScalarQuadraticTerm, f))
    end
    ret = _order(f.args[1], f.args[2], f.args[3])
    if ret === nothing
        throw(InexactError(:convert, ScalarQuadraticTerm, f))
    end
    coef = convert(T, ret[1])
    if ret[2] == ret[3]
        coef *= 2
    end
    return ScalarQuadraticTerm(coef, ret[2], ret[3])
end

function _add_to_function(
    f::ScalarQuadraticFunction{T},
    arg::Union{Real,VariableIndex,ScalarAffineFunction,ScalarQuadraticFunction},
) where {T}
    return Utilities.operate!(+, T, f, arg)
end

function _add_to_function(
    f::ScalarQuadraticFunction{T},
    arg::ScalarNonlinearFunction,
) where {T}
    if arg.head == :* && length(arg.args) == 2
        push!(f.affine_terms, convert(ScalarAffineTerm{T}, arg))
    elseif arg.head == :* && length(arg.args) == 3
        push!(f.quadratic_terms, convert(ScalarQuadraticTerm{T}, arg))
    else
        _add_to_function(f, convert(ScalarQuadraticFunction{T}, arg))
    end
    return f
end

# This is a very rough-and-ready conversion function that only works for very
# basic expressions, such as those created by
# `convert(ScalarNonlinearFunction, f)`.
function Base.convert(
    ::Type{ScalarQuadraticFunction{T}},
    f::ScalarNonlinearFunction,
) where {T}
    if f.head == :*
        if length(f.args) == 2
            quad_terms = ScalarQuadraticTerm{T}[]
            affine_terms = [convert(ScalarAffineTerm{T}, f)]
            return ScalarQuadraticFunction{T}(quad_terms, affine_terms, zero(T))
        elseif length(f.args) == 3
            quad_terms = [convert(ScalarQuadraticTerm{T}, f)]
            affine_terms = ScalarAffineTerm{T}[]
            return ScalarQuadraticFunction{T}(quad_terms, affine_terms, zero(T))
        end
    elseif f.head == :^ && length(f.args) == 2 && f.args[2] == 2
        return convert(
            ScalarQuadraticFunction{T},
            ScalarNonlinearFunction(:*, Any[one(T), f.args[1], f.args[1]]),
        )
    end
    if f.head != :+
        throw(InexactError(:convert, ScalarQuadraticFunction{T}, f))
    end
    output = ScalarQuadraticFunction(
        ScalarQuadraticTerm{T}[],
        ScalarAffineTerm{T}[],
        zero(T),
    )
    for arg in f.args
        # Unlike ScalarAffineFunction, _add_to_function cannot return ::Nothing
        output = _add_to_function(output, arg)::ScalarQuadraticFunction{T}
    end
    return output
end

# ScalarNonlinearFunction

function Base.convert(::Type{ScalarNonlinearFunction}, x::Real)
    return ScalarNonlinearFunction(:+, Any[x])
end

function Base.convert(::Type{ScalarNonlinearFunction}, x::VariableIndex)
    return ScalarNonlinearFunction(:+, Any[x])
end

function Base.convert(::Type{ScalarNonlinearFunction}, term::ScalarAffineTerm)
    return ScalarNonlinearFunction(:*, Any[term.coefficient, term.variable])
end

function Base.convert(F::Type{ScalarNonlinearFunction}, f::ScalarAffineFunction)
    args = Any[convert(ScalarNonlinearFunction, term) for term in f.terms]
    if isempty(args) || !iszero(f.constant)
        push!(args, f.constant)
    end
    return ScalarNonlinearFunction(:+, args)
end

function Base.convert(
    ::Type{ScalarNonlinearFunction},
    term::ScalarQuadraticTerm,
)
    coef = term.coefficient
    if term.variable_1 == term.variable_2
        coef /= 2
    end
    return ScalarNonlinearFunction(
        :*,
        Any[coef, term.variable_1, term.variable_2],
    )
end

function Base.convert(
    F::Type{ScalarNonlinearFunction},
    f::ScalarQuadraticFunction,
)
    args = Any[convert(F, term) for term in f.quadratic_terms]
    for term in f.affine_terms
        push!(args, convert(F, term))
    end
    if isempty(args) || !iszero(f.constant)
        push!(args, f.constant)
    end
    return ScalarNonlinearFunction(:+, args)
end

# VectorOfVariables

function Base.convert(::Type{VectorOfVariables}, g::VariableIndex)
    return VectorOfVariables([g])
end

function Base.convert(::Type{VectorOfVariables}, f::VectorAffineFunction)
    variables = Vector{VariableIndex}(undef, length(f.constants))
    assigned = fill(false, length(variables))
    if any(!iszero, f.constants)
        throw(InexactError(:convert, VectorOfVariables, f))
    end
    for term in f.terms
        if assigned[term.output_index] || !isone(term.scalar_term.coefficient)
            throw(InexactError(:convert, VectorOfVariables, f))
        end
        x = convert(VariableIndex, term.scalar_term.variable)
        variables[term.output_index] = x
        assigned[term.output_index] = true
    end
    if !all(assigned)
        throw(InexactError(:convert, VectorOfVariables, f))
    end
    return VectorOfVariables(variables)
end

# VectorAffineFunction

function Base.convert(
    ::Type{VectorAffineFunction{T}},
    g::VariableIndex,
) where {T}
    return VectorAffineFunction{T}(
        [VectorAffineTerm(1, ScalarAffineTerm(one(T), g))],
        [zero(T)],
    )
end

function Base.convert(
    ::Type{VectorAffineFunction{T}},
    g::ScalarAffineFunction,
) where {T}
    return VectorAffineFunction{T}(
        VectorAffineTerm{T}[VectorAffineTerm(1, term) for term in g.terms],
        [g.constant],
    )
end

function Base.convert(
    ::Type{VectorAffineTerm{T}},
    f::VectorAffineTerm,
) where {T}
    return VectorAffineTerm{T}(f.output_index, f.scalar_term)
end

function Base.convert(
    ::Type{VectorAffineFunction{T}},
    f::VectorAffineFunction,
) where {T}
    return VectorAffineFunction{T}(f.terms, f.constants)
end

function Base.convert(
    ::Type{VectorAffineFunction{T}},
    f::VectorOfVariables,
) where {T}
    terms = VectorAffineTerm{T}[
        VectorAffineTerm{T}(i, ScalarAffineTerm{T}(one(T), x)) for
        (i, x) in enumerate(f.variables)
    ]
    return VectorAffineFunction{T}(terms, zeros(T, length(terms)))
end

function Base.convert(
    ::Type{VectorAffineFunction{T}},
    f::VectorQuadraticFunction{T},
) where {T}
    if any(!iszero(t.scalar_term.coefficient) for t in f.quadratic_terms)
        throw(InexactError(:convert, VectorAffineFunction{T}, f))
    end
    return VectorAffineFunction{T}(f.affine_terms, f.constants)
end

# VectorQuadraticFunction

function Base.convert(
    ::Type{VectorQuadraticFunction{T}},
    g::VariableIndex,
) where {T}
    return VectorQuadraticFunction{T}(
        VectorQuadraticTerm{T}[],
        [VectorAffineTerm(1, ScalarAffineTerm(one(T), g))],
        [zero(T)],
    )
end

function Base.convert(
    ::Type{VectorQuadraticFunction{T}},
    g::ScalarAffineFunction,
) where {T}
    return VectorQuadraticFunction{T}(
        VectorQuadraticTerm{T}[],
        VectorAffineTerm{T}[VectorAffineTerm(1, term) for term in g.terms],
        [g.constant],
    )
end

function Base.convert(
    ::Type{VectorQuadraticFunction{T}},
    g::ScalarQuadraticFunction,
) where {T}
    return VectorQuadraticFunction{T}(
        VectorQuadraticTerm{T}[
            VectorQuadraticTerm(1, term) for term in g.quadratic_terms
        ],
        VectorAffineTerm{T}[
            VectorAffineTerm(1, term) for term in g.affine_terms
        ],
        [g.constant],
    )
end

function Base.convert(
    ::Type{VectorQuadraticFunction{T}},
    f::VectorAffineFunction{T},
) where {T}
    return VectorQuadraticFunction{T}(
        VectorQuadraticTerm{T}[],
        f.terms,
        f.constants,
    )
end

function Base.convert(
    ::Type{VectorQuadraticTerm{T}},
    f::VectorQuadraticTerm,
) where {T}
    return VectorQuadraticTerm{T}(f.output_index, f.scalar_term)
end

function Base.convert(
    ::Type{VectorQuadraticFunction{T}},
    f::VectorQuadraticFunction,
) where {T}
    return VectorQuadraticFunction{T}(
        f.quadratic_terms,
        f.affine_terms,
        f.constants,
    )
end

for f in (
    :ScalarAffineTerm,
    :ScalarAffineFunction,
    :ScalarQuadraticTerm,
    :ScalarQuadraticFunction,
    :VectorAffineTerm,
    :VectorAffineFunction,
    :VectorQuadraticTerm,
    :VectorQuadraticFunction,
)
    @eval Base.convert(::Type{$f{T}}, x::$f{T}) where {T} = x
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintZeroOne

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_ZeroOne()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.ZeroOne{Float64}(mock)

    bridge_type = MOI.Bridges.Constraint.ZeroOneBridge{Float64}
    @test MOI.supports_constraint(bridge_type, MOI.VariableIndex, MOI.ZeroOne)
    @test MOI.Bridges.Constraint.concrete_bridge_type(
        bridge_type,
        MOI.VariableIndex,
        MOI.ZeroOne,
    ) == bridge_type
    MOI.Test.test_basic_VariableIndex_ZeroOne(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [1, 0, 0, 1, 1]),
    )
    MOI.Test.test_linear_integer_knapsack(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne}(),
        ),
    )
    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), ci) == 1
    _test_delete_bridge(
        bridged_mock,
        ci,
        5,
        (
            (MOI.VariableIndex, MOI.Integer, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.Interval{Float64}, 0),
        ),
        num_bridged = 5,
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 20.0)
            MOI.Utilities.mock_optimize!(mock, [4, 5, 1])
        end,
    )
    MOI.Test.test_linear_integer_integration(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [1.0; zeros(10)]),
    )
    MOI.Test.test_linear_integer_solve_twice(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne}(),
        ),
    )
    s = """
    variables: x, y
    y == 1.0
    x in ZeroOne()
    minobjective: x
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    sb = """
    variables: x, y
    y == 1.0
    x in Integer()
    c: 1.0 * x in Interval(0.0,1.0)
    minobjective: x
    """
    modelb = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(modelb, sb)
    MOI.empty!(bridged_mock)
    @test MOI.is_empty(bridged_mock)
    MOI.Utilities.loadfromstring!(bridged_mock, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        ["x", "y"],
        String[],
        [("y", MOI.EqualTo{Float64}(1.0)), ("x", MOI.ZeroOne())],
    )
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.Interval{Float64}
    ci = first(MOI.get(mock, MOI.ListOfConstraintIndices{F,S}()))
    MOI.set(mock, MOI.ConstraintName(), ci, "c")
    MOI.Test.util_test_models_equal(
        mock,
        modelb,
        ["x", "y"],
        String["c"],
        [("y", MOI.EqualTo{Float64}(1.0)), ("x", MOI.Integer())],
    )
    return
end

function test_double_bounds()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    # These tests run, but don't actually evaluate any `@test`s because of
    # the exclude on `MOI.optimize!`. However, we only really care that the
    # models build without error.
    MOI.Test.runtests(
        MOI.Bridges.Constraint.ZeroOne{Float64}(mock),
        MOI.Test.Config(exclude = Any[MOI.optimize!]);
        include = ["test_constraint_ZeroOne_", "test_variable_solve_ZeroOne_"],
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ZeroOneBridge,
        """
        variables: x
        x in ZeroOne()
        """,
        """
        variables: x
        x in Integer()
        1.0 * x in Interval(0.0, 1.0)
        """,
    )
    return
end

end  # module

TestConstraintZeroOne.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Coloring

include("IntDisjointSet.jl")
include("topological_sort.jl")

"""
    mutable struct IndexedSet
        nzidx::Vector{Int}
        empty::BitVector
        nnz::Int
    end

Represent the set `nzidx[1:nnz]` by additionally setting `empty[i]` to `false`
for each element `i` of the set for fast membership check.
"""
mutable struct IndexedSet
    nzidx::Vector{Int}
    empty::BitVector
    nnz::Int
end

IndexedSet(n::Integer) = IndexedSet(zeros(Int, n), trues(n), 0)

function Base.push!(v::IndexedSet, i::Integer)
    if v.empty[i]  # new index
        v.nzidx[v.nnz+=1] = i
        v.empty[i] = false
    end
    return
end

function Base.empty!(v::IndexedSet)
    for i in 1:v.nnz
        v.empty[v.nzidx[i]] = true
    end
    v.nnz = 0
    return v
end

# Returns the maximum index that the set can contain,
# not the cardinality of the set like `length(::Base.Set)`
Base.length(v::IndexedSet) = length(v.nzidx)

function Base.resize!(v::IndexedSet, n::Integer)
    if n > length(v)
        @assert v.nnz == 0 # only resize empty vector
        resize!(v.nzidx, n)
        resize!(v.empty, n)
        fill!(v.empty, true)
    end
    return
end

Base.collect(v::IndexedSet) = v.nzidx[1:v.nnz]

function Base.union!(v::IndexedSet, s)
    for x in s
        push!(v, x)
    end
    return
end

"""
    struct UndirectedGraph
        adjlist::Vector{Int}
        edgeindex::Vector{Int}
        offsets::Vector{Int}
        edges::Vector{Tuple{Int,Int}}
    end

Compact storage for an undirected graph. The number of nodes is given by
`length(offsets) - 1`. The edges of node `u` are given by `edges[e]` for
`e in edgeindex[offsets[u]:(offsets[u+1] - 1)]`. The neighbors are also
stored at `adjlist[offsets[u]:(offsets[u+1] - 1)]`.
"""
struct UndirectedGraph
    adjlist::Vector{Int}
    edgeindex::Vector{Int} # corresponding edge number, indexed as adjlist
    offsets::Vector{Int}
    edges::Vector{Tuple{Int,Int}}
end

_num_vertices(g::UndirectedGraph) = length(g.offsets) - 1

_num_edges(g::UndirectedGraph) = length(g.edges)

_num_neighbors(i::Int, g::UndirectedGraph) = g.offsets[i+1] - g.offsets[i]

_start_neighbors(i::Int, g::UndirectedGraph) = g.offsets[i]

function UndirectedGraph(I, J, nel)
    adjcount = zeros(Int, nel)
    n_edges = 0
    for k in eachindex(I)
        i = I[k]
        j = J[k]
        if i == j
            continue
        end
        n_edges += 1
        adjcount[i] += 1
        adjcount[j] += 1
    end
    offsets = Vector{Int}(undef, nel + 1)
    offsets[1] = 1
    for k in 1:nel
        offsets[k+1] = offsets[k] + adjcount[k]
    end
    fill!(adjcount, 0)
    edges = Vector{Tuple{Int,Int}}(undef, n_edges)
    adjlist = Vector{Int}(undef, offsets[nel+1] - 1)
    edgeindex = Vector{Int}(undef, length(adjlist))
    edge_count = 0
    for k in eachindex(I)
        i = I[k]
        j = J[k]
        if i == j
            continue
        end
        edge_count += 1
        adjlist[offsets[i]+adjcount[i]] = j
        edgeindex[offsets[i]+adjcount[i]] = edge_count
        adjcount[i] += 1
        adjlist[offsets[j]+adjcount[j]] = i
        edgeindex[offsets[j]+adjcount[j]] = edge_count
        adjcount[j] += 1
        edges[edge_count] = (i, j)
    end
    @assert edge_count == n_edges
    return UndirectedGraph(adjlist, edgeindex, offsets, edges)
end

struct _Edge
    index::Int
    source::Int
    target::Int
end

function _prevent_cycle(
    v,
    w,
    x,
    e_idx1,
    e_idx2,
    S,
    firstVisitToTree,
    forbiddenColors,
    color,
)
    er = _find_root!(S, e_idx2)
    @inbounds first = firstVisitToTree[er]
    p = first.source # but this depends on the order?
    q = first.target
    @inbounds if p != v
        firstVisitToTree[er] = _Edge(e_idx1, v, w)
    elseif q != w
        forbiddenColors[color[x]] = v
    end
    return
end

function _grow_star(v, w, e_idx, firstNeighbor, color, S)
    @inbounds e = firstNeighbor[color[w]]
    p = e.source
    @inbounds if p != v
        firstNeighbor[color[w]] = _Edge(e_idx, v, w)
    else
        root1 = _find_root!(S, e_idx)
        root2 = _find_root!(S, e.index)
        _root_union!(S, root1, root2)
    end
    return
end

"""
    acyclic_coloring(g::UndirectedGraph)

Implement the acyclic coloring algorithm of Gebremdehin, Tarafdar, Manne, and
Pothen, "New Acyclic and Star Coloring Algorithms with Application to Computing
Hessians." SIAM J. Sci. Comput. 2007.

Returns `Tuple{Vector{Int},Int}` giving the color index of each node in `g`, as
well as the total number of colors used.
"""
function acyclic_coloring(g::UndirectedGraph)
    if _num_edges(g) == 0
        return fill(1, _num_vertices(g)), 1
    end
    num_colors = 0
    forbiddenColors = Int[]
    firstNeighbor = _Edge[]
    firstVisitToTree = fill(_Edge(0, 0, 0), _num_edges(g))
    color = fill(0, _num_vertices(g))
    S = _IntDisjointSet(_num_edges(g))
    @inbounds for v in 1:_num_vertices(g)
        n_neighbor = _num_neighbors(v, g)
        start_neighbor = _start_neighbors(v, g)
        for k in 0:(n_neighbor-1)
            w = g.adjlist[start_neighbor+k]
            if color[w] == 0
                continue
            end
            forbiddenColors[color[w]] = v
        end
        for k in 0:(n_neighbor-1)
            w = g.adjlist[start_neighbor+k]
            e_idx = g.edgeindex[start_neighbor+k]
            if color[w] == 0
                continue
            end
            n_neighbor_w = _num_neighbors(w, g)
            start_neighbor_w = _start_neighbors(w, g)
            for k2 in 0:(n_neighbor_w-1)
                x = g.adjlist[start_neighbor_w+k2]
                e2_idx = g.edgeindex[start_neighbor_w+k2]
                if color[x] == 0
                    continue
                end
                if forbiddenColors[color[x]] != v
                    _prevent_cycle(
                        v,
                        w,
                        x,
                        e_idx,
                        e2_idx,
                        S,
                        firstVisitToTree,
                        forbiddenColors,
                        color,
                    )
                end
            end
        end
        # find feasible color
        found = false
        for k in 1:num_colors
            if forbiddenColors[k] != v
                color[v] = k
                found = true
                break
            end
        end
        if !found
            num_colors += 1
            push!(forbiddenColors, 0)
            push!(firstNeighbor, _Edge(0, 0, 0))
            color[v] = num_colors
        end
        for k in 0:(n_neighbor-1)
            w = g.adjlist[start_neighbor+k]
            e_idx = g.edgeindex[start_neighbor+k]
            if color[w] == 0
                continue
            end
            _grow_star(v, w, e_idx, firstNeighbor, color, S)
        end
        for k in 0:(n_neighbor-1)
            w = g.adjlist[start_neighbor+k]
            e_idx = g.edgeindex[start_neighbor+k]
            if color[w] == 0
                continue
            end
            n_neighbor_w = _num_neighbors(w, g)
            start_neighbor_w = _start_neighbors(w, g)
            for k2 in 0:(n_neighbor_w-1)
                x = g.adjlist[start_neighbor_w+k2]
                e2_idx = g.edgeindex[start_neighbor_w+k2]
                if color[x] == 0 || x == v
                    continue
                end
                if color[x] == color[v]
                    _union!(S, e_idx, e2_idx)
                end
            end
        end
    end
    return color, num_colors
end

struct RecoveryInfo
    vertexmap::Vector{Vector{Int}}
    postorder::Vector{Vector{Int}}
    parents::Vector{Vector{Int}}
    color::Vector{Int}
    num_colors::Int
    nnz::Int # number of off-diagonal nonzeros
    local_indices::Vector{Int} # map back to global indices
end

function RecoveryInfo()
    return RecoveryInfo(
        Vector{Vector{Int}}(undef, 0),
        Vector{Vector{Int}}(undef, 0),
        Vector{Vector{Int}}(undef, 0),
        Vector{Int}(undef, 0),
        0,
        0,
        Vector{Int}(undef, 0),
    )
end

function recovery_preprocess(
    g::UndirectedGraph,
    color,
    num_colors,
    local_indices,
)
    # represent two-color subgraph as:
    # list of vertices (with map to global indices)
    # adjacency list in a single vector (with list of offsets)
    # linear index of pair of colors
    twocolorindex = zeros(Int32, num_colors, num_colors)
    seen_twocolors = 0
    # count of edges in each subgraph
    edge_count = Int[]
    for k in eachindex(g.edges)
        u, v = g.edges[k]
        i = min(color[u], color[v])
        j = max(color[u], color[v])
        if twocolorindex[i, j] == 0
            seen_twocolors += 1
            twocolorindex[i, j] = seen_twocolors
            push!(edge_count, 0)
        end
        idx = twocolorindex[i, j]
        edge_count[idx] += 1
    end
    # edges sorted by twocolor subgraph
    sorted_edges = Vector{Vector{Tuple{Int,Int}}}(undef, seen_twocolors)
    for idx in 1:seen_twocolors
        sorted_edges[idx] = Tuple{Int,Int}[]
        sizehint!(sorted_edges[idx], edge_count[idx])
    end
    for k in eachindex(g.edges)
        u, v = g.edges[k]
        i = min(color[u], color[v])
        j = max(color[u], color[v])
        idx = twocolorindex[i, j]
        push!(sorted_edges[idx], (u, v))
    end
    # list of unique vertices in each twocolor subgraph
    vertexmap = Vector{Vector{Int}}(undef, seen_twocolors)
    postorder = Vector{Vector{Int}}(undef, seen_twocolors)
    parents = Vector{Vector{Int}}(undef, seen_twocolors)
    # temporary lookup map from global index to subgraph index
    revmap = zeros(Int, _num_vertices(g))
    adjcount = zeros(Int, _num_vertices(g))
    cmap = zeros(Int, 0) # shared storage for DFS
    for idx in 1:seen_twocolors
        my_edges = sorted_edges[idx]
        vlist = Int[]
        # build up the vertex list and adjacency count
        for k in eachindex(my_edges)
            u, v = my_edges[k]
            # seen these vertices yet?
            if revmap[u] == 0
                push!(vlist, u)
                revmap[u] = length(vlist)
                adjcount[u] = 0
            end
            if revmap[v] == 0
                push!(vlist, v)
                revmap[v] = length(vlist)
                adjcount[v] = 0
            end
            adjcount[u] += 1
            adjcount[v] += 1
        end
        # set up offsets for adjlist
        offset = Vector{Int}(undef, length(vlist) + 1)
        offset[1] = 1
        for k in eachindex(vlist)
            offset[k+1] = offset[k] + adjcount[vlist[k]]
            adjcount[vlist[k]] = 0
        end
        # adjlist for node u in twocolor idx starts at
        # vec[offset[u]]
        # u has global index vlist[u]
        vec = Vector{Int}(undef, offset[length(vlist)+1] - 1)
        # now fill in
        for k in eachindex(my_edges)
            u, v = my_edges[k]
            u_rev = revmap[u] # indices in the subgraph
            v_rev = revmap[v]
            vec[offset[u_rev]+adjcount[u]] = v_rev
            vec[offset[v_rev]+adjcount[v]] = u_rev
            adjcount[u] += 1
            adjcount[v] += 1
        end
        resize!(cmap, length(vlist))
        order, parent =
            reverse_topological_sort_by_dfs(vec, offset, length(vlist), cmap)
        for k in eachindex(vlist)
            revmap[vlist[k]] = 0  # clear for reuse
        end
        postorder[idx] = order
        parents[idx] = parent
        vertexmap[idx] = vlist
    end
    return RecoveryInfo(
        vertexmap,
        postorder,
        parents,
        color,
        num_colors,
        _num_edges(g),
        local_indices,
    )
end

_normalize(i, j) = (j > i) ? (j, i) : (i, j)

function _indirect_recover_structure(rinfo::RecoveryInfo)
    N = length(rinfo.color)
    I = zeros(Int, rinfo.nnz + N)
    J = zeros(Int, rinfo.nnz + N)
    k = 0
    for i in 1:N
        k += 1
        I[k] = J[k] = i
    end
    for t in eachindex(rinfo.postorder)
        vmap = rinfo.vertexmap[t]
        order = rinfo.postorder[t]
        parent = rinfo.parents[t]
        for z in eachindex(order)
            v = order[z]
            p = parent[v]
            if p == 0
                continue
            end
            k += 1
            I[k], J[k] = _normalize(vmap[v], vmap[p])
        end
    end
    @assert k == rinfo.nnz + N
    return I, J
end

"""
    hessian_color_preprocess(
        edgelist,
        num_total_var,
        seen_idx = IndexedSet(0),
    )

`edgelist` contains the nonzeros in the Hessian, *including* nonzeros on the
diagonal.
"""
function hessian_color_preprocess(
    edgelist,
    num_total_var,
    seen_idx = IndexedSet(0),
)
    resize!(seen_idx, num_total_var)
    I, J = Int[], Int[]
    for (i, j) in edgelist
        push!(seen_idx, i)
        push!(seen_idx, j)
        push!(I, i)
        push!(J, j)
    end
    local_indices = sort!(collect(seen_idx))
    empty!(seen_idx)
    global_to_local_idx = seen_idx.nzidx # steal for storage
    for k in eachindex(local_indices)
        global_to_local_idx[local_indices[k]] = k
    end
    # only do the coloring on the local indices
    for k in eachindex(I)
        I[k] = global_to_local_idx[I[k]]
        J[k] = global_to_local_idx[J[k]]
    end
    g = UndirectedGraph(I, J, length(local_indices))
    color, num_colors = acyclic_coloring(g)
    @assert length(color) == _num_vertices(g)
    rinfo = recovery_preprocess(g, color, num_colors, local_indices)
    I, J = _indirect_recover_structure(rinfo)
    # convert back to global indices
    for k in eachindex(I)
        I[k] = local_indices[I[k]]
        J[k] = local_indices[J[k]]
    end
    return I, J, rinfo
end

"""
    seed_matrix(rinfo::RecoveryInfo)

Allocate a seed matrix for the Coloring.
"""
function seed_matrix(rinfo::RecoveryInfo)
    return Matrix{Float64}(undef, length(rinfo.local_indices), rinfo.num_colors)
end

"""
    prepare_seed_matrix!(R, rinfo::RecoveryInfo)
"""
function prepare_seed_matrix!(R, rinfo::RecoveryInfo)
    N = length(rinfo.color)
    @assert N == size(R, 1) == length(rinfo.local_indices)
    @assert size(R, 2) == rinfo.num_colors
    fill!(R, 0.0)
    for i in 1:N
        R[i, rinfo.color[i]] = 1
    end
    return
end

"""
    recover_from_matmat!(
        V::AbstractVector{T},
        R::AbstractMatrix{T},
        rinfo::RecoveryInfo,
        stored_values::AbstractVector{T},
    ) where {T}

recover the hessian values from the hessian-matrix solution
stored_values is a temporary vector of length >= length(rinfo.local_indices)
"""
function recover_from_matmat!(
    V::AbstractVector{T},
    R::AbstractMatrix{T},
    rinfo::RecoveryInfo,
    stored_values::AbstractVector{T},
) where {T}
    N = length(rinfo.color) # number of local variables
    @assert length(V) == rinfo.nnz + N
    @assert length(stored_values) >= length(rinfo.local_indices)
    k = 0
    for i in 1:N
        k += 1
        V[k] = R[i, rinfo.color[i]]
    end
    for t in eachindex(rinfo.vertexmap)
        vmap = rinfo.vertexmap[t]
        order = rinfo.postorder[t]
        parent = rinfo.parents[t]
        for z in eachindex(order)
            @inbounds stored_values[z] = 0.0
        end
        @inbounds for z in eachindex(order)
            v = order[z]
            p = parent[v]
            if p == 0
                continue
            end
            i, j = vmap[v], vmap[p]
            value = R[i, rinfo.color[j]] - stored_values[v]
            stored_values[p] += value
            k += 1
            V[k] = value
        end
    end
    @assert k == rinfo.nnz + N
    return
end

end  # module

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SquareBridge{T,F,G,TT,ST} <: Bridges.Constraint.AbstractBridge

`SquareBridge` implements the following reformulations:

  * ``(t, u, X) \\in LogDetConeSquare`` into ``(t, u, Y) in LogDetConeTriangle``
  * ``(t, X) \\in RootDetConeSquare`` into ``(t, Y) in RootDetConeTriangle``
  * ``X \\in AbstractSymmetricMatrixSetSquare`` into
    ``Y in AbstractSymmetricMatrixSetTriangle``

where ``Y`` is the upper triangluar component of ``X``.

In addition, constraints are added as necessary to constrain the matrix ``X``
to be symmetric. For example, the constraint for the matrix:
```math
\\begin{pmatrix}
  1      & 1 + x & 2 - 3x\\\\
  1 +  x & 2 + x & 3 -  x\\\\
  2 - 3x & 2 + x &     2x
\\end{pmatrix}
```
can be broken down to the constraint of the symmetric matrix
```math
\\begin{pmatrix}
  1      & 1 + x & 2 - 3x\\\\
  \\cdot & 2 + x & 3 -  x\\\\
  \\cdot & \\cdot &    2x
\\end{pmatrix}
```
and the equality constraint between the off-diagonal entries (2, 3) and (3, 2)
``3 - x == 2 + x``. Note that no symmetrization constraint needs to be added
between the off-diagonal entries (1, 2) and (2, 1) or between (1, 3) and (3, 1)
because the expressions are the same.

## Source node

`SquareBridge` supports:

  * `F` in `ST`

## Target nodes

`SquareBridge` creates:

  * `F` in `TT`
  * `G` in [`MOI.EqualTo{T}`](@ref)
"""
struct SquareBridge{
    T,
    F<:MOI.AbstractVectorFunction,
    G<:MOI.AbstractScalarFunction,
    TT<:Union{
        MOI.LogDetConeTriangle,
        MOI.RootDetConeTriangle,
        MOI.AbstractSymmetricMatrixSetTriangle,
    },
    ST<:Union{
        MOI.LogDetConeSquare,
        MOI.RootDetConeSquare,
        MOI.AbstractSymmetricMatrixSetSquare,
    },
} <: AbstractBridge
    square_set::ST
    triangle::MOI.ConstraintIndex{F,TT}
    sym::Vector{Pair{Tuple{Int,Int},MOI.ConstraintIndex{G,MOI.EqualTo{T}}}}
end

const Square{T,OT<:MOI.ModelLike} = SingleBridgeOptimizer{SquareBridge{T},OT}

_square_offset(::MOI.AbstractSymmetricMatrixSetSquare) = Int[]
_square_offset(::MOI.RootDetConeSquare) = Int[1]
_square_offset(::MOI.LogDetConeSquare) = Int[1, 2]

function _constrain_off_diagonals(
    model::MOI.ModelLike,
    ::Type{T},
    ::Tuple{Int,Int},
    f_ij::F,
    f_ji::F,
) where {T,F<:MOI.ScalarNonlinearFunction}
    if isapprox(f_ij, f_ji)
        return nothing
    end
    return MOI.Utilities.normalize_and_add_constraint(
        model,
        MOI.ScalarNonlinearFunction(:-, Any[f_ij, f_ji]),
        MOI.EqualTo(zero(T));
        allow_modify_function = true,
    )
end

function _constrain_off_diagonals(
    model::MOI.ModelLike,
    ::Type{T},
    ij::Tuple{Int,Int},
    f_ij::F,
    f_ji::F,
) where {T,F}
    diff = MOI.Utilities.operate!(-, T, f_ij, f_ji)
    MOI.Utilities.canonicalize!(diff)
    # The value 1e-10 was decided in https://github.com/jump-dev/JuMP.jl/pull/976
    # This avoid generating symmetrization constraints when the
    # functions at entries (i, j) and (j, i) are almost identical
    if MOI.Utilities.isapprox_zero(diff, 1e-10)
        return nothing
    end
    if MOI.Utilities.isapprox_zero(diff, 1e-8)
        i, j = ij
        @warn(
            "The entries ($i, $j) and ($j, $i) of the matrix are " *
            "almost identical, but a constraint has been added " *
            "to ensure their equality because the largest " *
            "difference between the coefficients is smaller than " *
            "1e-8 but larger than 1e-10. This usually means that " *
            "there is a modeling error in your formulation.",
        )
    end
    return MOI.Utilities.normalize_and_add_constraint(
        model,
        diff,
        MOI.EqualTo(zero(T));
        allow_modify_function = true,
    )
end

function bridge_constraint(
    ::Type{SquareBridge{T,F,G,TT,ST}},
    model::MOI.ModelLike,
    f::F,
    s::ST,
) where {T,F,G,TT,ST}
    f_scalars = MOI.Utilities.eachscalar(f)
    sym = Pair{Tuple{Int,Int},MOI.ConstraintIndex{G,MOI.EqualTo{T}}}[]
    dim = MOI.side_dimension(s)
    upper_triangle_indices = _square_offset(s)
    offset = length(upper_triangle_indices)
    sizehint!(upper_triangle_indices, offset + div(dim * (dim + 1), 2))
    k = offset
    for j in 1:dim
        for i in 1:j
            k += 1
            push!(upper_triangle_indices, k)
            if i !== j
                # We constrain the entries (i, j) and (j, i) to be equal
                f_ij = f_scalars[offset+i+(j-1)*dim]
                f_ji = f_scalars[offset+j+(i-1)*dim]
                ci = _constrain_off_diagonals(model, T, (i, j), f_ij, f_ji)
                if ci !== nothing
                    push!(sym, (i, j) => ci)
                end
            end
        end
        k += dim - j
    end
    triangle = MOI.add_constraint(
        model,
        f_scalars[upper_triangle_indices],
        MOI.triangular_form(s),
    )
    return SquareBridge{T,F,G,TT,ST}(s, triangle, sym)
end

function MOI.supports_constraint(
    ::Type{SquareBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{
        <:Union{
            MOI.LogDetConeSquare,
            MOI.RootDetConeSquare,
            MOI.AbstractSymmetricMatrixSetSquare,
        },
    },
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(::Type{<:SquareBridge})
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{SquareBridge{T,F,G,TT,ST}},
) where {T,F,G,TT,ST}
    return Tuple{Type,Type}[(F, TT), (G, MOI.EqualTo{T})]
end

function concrete_bridge_type(
    ::Type{<:SquareBridge{T}},
    F::Type{<:MOI.AbstractVectorFunction},
    ST::Type{
        <:Union{
            MOI.LogDetConeSquare,
            MOI.RootDetConeSquare,
            MOI.AbstractSymmetricMatrixSetSquare,
        },
    },
) where {T}
    S = MOI.Utilities.scalar_type(F)
    G = MOI.Utilities.promote_operation(-, T, S, S)
    TT = MOI.triangular_form(ST)
    return SquareBridge{T,F,G,TT,ST}
end

function MOI.get(
    ::SquareBridge{T,F,G,TT},
    ::MOI.NumberOfConstraints{F,TT},
)::Int64 where {T,F,G,TT}
    return 1
end

function MOI.get(
    bridge::SquareBridge{T,F,G},
    ::MOI.NumberOfConstraints{G,MOI.EqualTo{T}},
)::Int64 where {T,F,G}
    return length(bridge.sym)
end

function MOI.get(
    bridge::SquareBridge{T,F,G,TT},
    ::MOI.ListOfConstraintIndices{F,TT},
) where {T,F,G,TT}
    return [bridge.triangle]
end

function MOI.get(
    bridge::SquareBridge{T,F,G},
    ::MOI.ListOfConstraintIndices{G,MOI.EqualTo{T}},
) where {T,F,G}
    return [ci for (_, ci) in bridge.sym]
end

function MOI.delete(model::MOI.ModelLike, bridge::SquareBridge)
    MOI.delete(model, bridge.triangle)
    for (_, ci) in bridge.sym
        MOI.delete(model, ci)
    end
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::SquareBridge{T},
) where {T}
    value = MOI.Utilities.eachscalar(MOI.get(model, attr, bridge.triangle))
    dim = MOI.side_dimension(bridge.square_set)
    offset = length(_square_offset(bridge.square_set))
    f = Vector{eltype(value)}(undef, offset + dim^2)
    for i in 1:offset
        f[i] = value[i]
    end
    k = offset
    for j in 1:dim, i in 1:j
        k += 1
        f[offset+i+(j-1)*dim] = f[offset+j+(i-1)*dim] = value[k]
    end
    for ((i, j), ci) in bridge.sym
        # diff is f_ij - f_ji = 0
        diff = MOI.get(model, MOI.ConstraintFunction(), ci)
        # f_ij - (fij - f_ji) = f_ji
        f_ji = MOI.Utilities.operate(-, T, f[offset+i+(j-1)*dim], diff)
        # But we need to account for the constant moved into the set
        rhs = MOI.constant(MOI.get(model, MOI.ConstraintSet(), ci))
        f_ji = MOI.Utilities.operate!(-, T, f_ji, rhs)
        f[offset+j+(i-1)*dim] = MOI.Utilities.convert_approx(eltype(f), f_ji)
    end
    return MOI.Utilities.vectorize(f)
end

function MOI.get(::MOI.ModelLike, ::MOI.ConstraintSet, bridge::SquareBridge)
    return bridge.square_set
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{SquareBridge{T,F,G,TT,ST}},
) where {T,F,G,TT,ST}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F,TT}) &
           MOI.supports(model, attr, MOI.ConstraintIndex{G,MOI.EqualTo{T}})
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::SquareBridge,
    ::Nothing,
)
    MOI.set(model, attr, bridge.triangle, nothing)
    for (_, ci) in bridge.sym
        MOI.set(model, attr, ci, nothing)
    end
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::SquareBridge{T},
) where {T}
    value = MOI.get(model, attr, bridge.triangle)
    if value === nothing
        return nothing
    end
    dim = MOI.side_dimension(bridge.square_set)
    offset = length(_square_offset(bridge.square_set))
    primal = Vector{eltype(value)}(undef, offset + dim^2)
    for i in 1:offset
        primal[i] = value[i]
    end
    k = offset
    for j in 1:dim, i in 1:j
        k += 1
        primal[offset+i+(j-1)*dim] = primal[offset+j+(i-1)*dim] = value[k]
    end
    for ((i, j), ci) in bridge.sym
        primal[offset+i+(j-1)*dim] += MOI.get(model, attr, ci)
    end
    return primal
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::SquareBridge,
    value,
)
    dim = MOI.side_dimension(bridge.square_set)
    offset = length(_square_offset(bridge.square_set))
    @assert length(value) == offset + dim^2
    primal = Vector{eltype(value)}(undef, offset + div(dim * (dim + 1), 2))
    for i in 1:offset
        primal[i] = value[i]
    end
    k = offset
    for j in 1:dim, i in 1:j
        k += 1
        primal[k] = value[offset+j+(i-1)*dim]
    end
    MOI.set(model, attr, bridge.triangle, primal)
    for ((i, j), ci) in bridge.sym
        f_ij, f_ji = value[offset+i+(j-1)*dim], value[offset+j+(i-1)*dim]
        MOI.set(model, attr, ci, f_ij - f_ji)
    end
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::SquareBridge,
)
    # The constraint dual of the triangular constraint.
    tri = MOI.get(model, attr, bridge.triangle)
    if tri === nothing
        return nothing
    end
    # Our output will be a dense square matrix.
    dim = MOI.side_dimension(bridge.square_set)
    offset = length(_square_offset(bridge.square_set))
    dual = Vector{eltype(tri)}(undef, offset + dim^2)
    # Start by converting the triangular dual to the square dual, assuming that
    # all elements are symmetrical.
    for i in 1:offset
        dual[i] = tri[i]
    end
    k = offset
    sym_index = 1
    for j in 1:dim, i in 1:j
        k += 1
        upper_index = offset + i + (j - 1) * dim
        lower_index = offset + j + (i - 1) * dim
        if i == j
            dual[upper_index] = tri[k]
        elseif sym_index <= length(bridge.sym) &&
               bridge.sym[sym_index].first == (i, j)
            # The PSD constraint uses only the upper triangular part. Therefore,
            # for KKT to hold for the user model, the dual given by the user
            # needs to be attributed to the upper triangular entry. For example,
            # suppose the constraint is
            #   [0 x; y 0] in PositiveSemidefiniteConeSquare(2).
            # If the dual is
            #   [λ1 λ3; λ2 λ4]
            # then we have `y λ2 + x λ3` in the Lagrangian.
            #
            # In the bridged model, the constraint is
            #   [0, x, 0] in PositiveSemidefiniteConeTriangle(2).
            #   [x - y] in Zeros(1)
            # If the dual is
            #   [η1, η2, η3] in PositiveSemidefiniteConeTriangle(2).
            #   [π] in Reals(1)
            # then we have `2x η2 + x * π - y * π` in the Lagrangian.
            #
            # To have the same Lagrangian value, we should set `λ3 = 2η2 + π`
            # and `λ2 = 0 - π`.
            π = MOI.get(model, attr, bridge.sym[sym_index].second)
            dual[upper_index] = 2tri[k] + π
            dual[lower_index] = -π
            sym_index += 1
        else
            # If there are no symmetry constraint, it means that the entries are
            # symbolically the same so we can consider we have the average
            # of the lower and upper triangular entries to the bridged model
            # in which case we can give the dual to both upper and triangular
            # entries.
            dual[upper_index] = dual[lower_index] = tri[k]
        end
    end
    return dual
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::SquareBridge,
    value,
)
    dim = MOI.side_dimension(bridge.square_set)
    offset = length(_square_offset(bridge.square_set))
    @assert length(value) == offset + dim^2
    dual = Vector{eltype(value)}(undef, offset + div(dim * (dim + 1), 2))
    for i in 1:offset
        dual[i] = value[i]
    end
    k = offset
    sym_index = 1
    for j in 1:dim, i in 1:j
        k += 1
        upper_index = offset + i + (j - 1) * dim
        lower_index = offset + j + (i - 1) * dim
        if i == j
            dual[k] = value[upper_index]
        elseif sym_index <= length(bridge.sym) &&
               bridge.sym[sym_index].first == (i, j)
            λ2, λ3 = value[lower_index], value[upper_index]
            π = -λ2
            MOI.set(model, attr, bridge.sym[sym_index].second, π)
            dual[k] = (λ3 - π) / 2  # η2
            sym_index += 1
        else
            dual[k] = (value[lower_index] + value[upper_index]) / 2
        end
    end
    MOI.set(model, attr, bridge.triangle, dual)
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::SquareBridge,
    ::Nothing,
)
    MOI.set(model, attr, bridge.triangle, nothing)
    for (_, ci) in bridge.sym
        MOI.set(model, attr, ci, nothing)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# This file is automatically created by the folowing script. Only re-run it if
# AMPL adds new opcodes (which is unlikely).
# ```julia
# using ASL_jll
# open("opcode.jl", "w") do io
#     filename = joinpath(ASL_jll.artifact_dir, "include", "opcode.hd")
#     for line in readlines(filename)
#         items = split(line, c -> c == '\t' || c == ' '; keepempty = false)
#         println(io, "const ", items[2], " = ", items[3])
#     end
# end
# ```

const OPPLUS = 0
const OPMINUS = 1
const OPMULT = 2
const OPDIV = 3
const OPREM = 4
const OPPOW = 5
const OPLESS = 6
const MINLIST = 11
const MAXLIST = 12
const FLOOR = 13
const CEIL = 14
const ABS = 15
const OPUMINUS = 16
const OPOR = 20
const OPAND = 21
const LT = 22
const LE = 23
const EQ = 24
const GE = 28
const GT = 29
const NE = 30
const OPNOT = 34
const OPIFnl = 35
const OP_tanh = 37
const OP_tan = 38
const OP_sqrt = 39
const OP_sinh = 40
const OP_sin = 41
const OP_log10 = 42
const OP_log = 43
const OP_exp = 44
const OP_cosh = 45
const OP_cos = 46
const OP_atanh = 47
const OP_atan2 = 48
const OP_atan = 49
const OP_asinh = 50
const OP_asin = 51
const OP_acosh = 52
const OP_acos = 53
const OPSUMLIST = 54
const OPintDIV = 55
const OPprecision = 56
const OPround = 57
const OPtrunc = 58
const OPCOUNT = 59
const OPNUMBEROF = 60
const OPNUMBEROFs = 61
const OPATLEAST = 62
const OPATMOST = 63
const OPPLTERM = 64
const OPIFSYM = 65
const OPEXACTLY = 66
const OPNOTATLEAST = 67
const OPNOTATMOST = 68
const OPNOTEXACTLY = 69
const ANDLIST = 70
const ORLIST = 71
const OPIMPELSE = 72
const OP_IFF = 73
const OPALLDIFF = 74
const OPSOMESAME = 75
const OP1POW = 76
const OP2POW = 77
const OPCPOW = 78
const OPFUNCALL = 79
const OPNUM = 80
const OPHOL = 81
const OPVARVAL = 82
const N_OPS = 83

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    NumberConversionBridge{T,F1,S1,F2,S2} <: Bridges.Constraint.AbstractBridge

`NumberConversionBridge` implements the following reformulation:

  * ``f1(x) \\in S1`` to ``f2(x) \\in S2``

where `f` and `S` are the same functional form, but differ in their coefficient
type.

## Source node

`NumberConversionBridge` supports:

  * `F1` in `S1`

## Target node

`NumberConversionBridge` creates:

  * `F2` in `S2`
"""
struct NumberConversionBridge{T,F1,S1,F2,S2} <: AbstractBridge
    constraint::MOI.ConstraintIndex{F2,S2}
end

const NumberConversion{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NumberConversionBridge{T},OT}

function concrete_bridge_type(
    ::Type{<:NumberConversionBridge{T}},
    ::Type{F1},
    ::Type{S1},
) where {T,F1<:MOI.AbstractFunction,S1<:MOI.AbstractSet}
    F2 = MOI.Utilities.similar_type(F1, T)
    S2 = MOI.Utilities.similar_type(S1, T)
    return NumberConversionBridge{T,F1,S1,F2,S2}
end

function bridge_constraint(
    ::Type{NumberConversionBridge{T,F1,S1,F2,S2}},
    model::MOI.ModelLike,
    f::F1,
    set::S1,
) where {T,F1,S1,F2,S2}
    ci = MOI.add_constraint(
        model,
        MOI.Utilities.convert_approx(F2, f),
        MOI.Utilities.convert_approx(S2, set),
    )
    return NumberConversionBridge{T,F1,S1,F2,S2}(ci)
end

function MOI.supports_constraint(
    ::Type{NumberConversionBridge{T}},
    ::Type{F1},
    ::Type{S1},
) where {T,F1<:MOI.AbstractFunction,S1<:MOI.AbstractSet}
    return F1 != MOI.Utilities.similar_type(F1, T) ||
           S1 != MOI.Utilities.similar_type(S1, T)
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:NumberConversionBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    A::Type{NumberConversionBridge{T,F1,S1,F2,S2}},
) where {T,F1,S1,F2,S2}
    return Tuple{Type,Type}[(F2, S2)]
end

function MOI.get(
    bridge::NumberConversionBridge{T,F1,S1,F2,S2},
    ::MOI.NumberOfConstraints{F2,S2},
)::Int64 where {T,F1,S1,F2,S2}
    return 1
end

function MOI.get(
    bridge::NumberConversionBridge{T,F1,S1,F2,S2},
    ::MOI.ListOfConstraintIndices{F2,S2},
) where {T,F1,S1,F2,S2}
    return [bridge.constraint]
end

function MOI.delete(model::MOI.ModelLike, bridge::NumberConversionBridge)
    MOI.delete(model, bridge.constraint)
    return
end

MOI.get(b::NumberConversionBridge, ::MOI.NumberOfVariables)::Int64 = 0

function MOI.get(b::NumberConversionBridge, ::MOI.ListOfVariableIndices)
    return MOI.VariableIndex[]
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::NumberConversionBridge{T,F1,S1,F2,S2},
) where {T,F1,S1,F2,S2}
    f = MOI.get(model, MOI.ConstraintFunction(), bridge.constraint)
    return MOI.Utilities.convert_approx(F1, f)
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::NumberConversionBridge{T,F1,S1,F2,S2},
) where {T,F1,S1,F2,S2}
    s = MOI.get(model, MOI.ConstraintSet(), bridge.constraint)
    return MOI.Utilities.convert_approx(S1, s)
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{NumberConversionBridge{T,F1,S1,F2,S2}},
) where {T,F1,S1,F2,S2}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F2,S2})
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{
        MOI.ConstraintPrimalStart,
        MOI.ConstraintDualStart,
        MOI.ConstraintPrimal,
        MOI.ConstraintDual,
    },
    bridge::NumberConversionBridge{T,F1,S1,F2,S2},
) where {T,F1,S1,F2,S2}
    ret = MOI.get(model, attr, bridge.constraint)
    if ret === nothing
        return nothing
    end
    return convert(MOI.Utilities.value_type(T, F1), ret)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::Union{
        MOI.ConstraintPrimalStart,
        MOI.ConstraintDualStart,
        MOI.ConstraintPrimal,
        MOI.ConstraintDual,
    },
    bridge::NumberConversionBridge{T,F1,S1,F2,S2},
    value,
) where {T,F1,S1,F2,S2}
    MOI.set(model, attr, bridge.constraint, value)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintHyperRectangle

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitHyperRectangleBridge,
        """
        variables: x, y, z
        [x, y, z] in HyperRectangle([-1.0, 2.0, 3.0], [1.1, 2.2, 3.3])
        """,
        """
        variables: x, y, z
        [1.0 * x + 1.0, 1.0 * y + -2.0, 1.0 * z + -3.0, 1.1 + -1.0 * x, 2.2 + -1.0 * y, 3.3 + -1.0 * z] in Nonnegatives(6)
        """,
    )
    return
end

function test_runtests_infinity_lower()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitHyperRectangleBridge,
        """
        variables: x, z
        [x, z] in HyperRectangle([-Inf, 3.0], [1.1, 3.3])
        """,
        """
        variables: x, z
        [1.0 * z + -3.0, 1.1 + -1.0 * x, 3.3 + -1.0 * z] in Nonnegatives(3)
        """;
        constraint_start = -1.2,
    )
    return
end

function test_runtests_infinity_upper()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitHyperRectangleBridge,
        """
        variables: y, z
        [y, z] in HyperRectangle([2.0, 3.0], [Inf, 3.3])
        """,
        """
        variables: y, z
        [1.0 * y + -2.0, 1.0 * z + -3.0, 3.3 + -1.0 * z] in Nonnegatives(3)
        """;
        constraint_start = 1.2,
    )
    return
end

function test_runtests_VectorAffineFunction()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitHyperRectangleBridge,
        """
        variables: x, y, z
        [1.0 * x, -2.0 * y, 3.0 * z] in HyperRectangle([-1.0, 2.0, 3.0], [1.1, 2.2, 3.3])
        """,
        """
        variables: x, y, z
        [1.0 * x + 1.0, -2.0 * y + -2.0, 3.0 * z + -3.0, 1.1 + -1.0 * x, 2.2 + 2.0 * y, 3.3 + -3.0 * z] in Nonnegatives(6)
        """,
    )
    return
end

function test_runtests_free_row()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitHyperRectangleBridge,
        """
        variables: x, z
        [x, z] in HyperRectangle([-Inf, 3.0], [Inf, 3.3])
        """,
        """
        variables: x, z
        [1.0 * z + -3.0, 3.3 + -1.0 * z] in Nonnegatives(2)
        """;
        constraint_start = 0.0,
    )
    return
end

function test_runtests_all_free_rows()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitHyperRectangleBridge,
        """
        variables: x
        [x] in HyperRectangle([-Inf], [Inf])
        """,
        """
        variables: x
        """,
    )
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.SplitHyperRectangle{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.Utilities.operate(vcat, Float64, 1.0 * x)
    c = MOI.add_constraint(model, f, MOI.HyperRectangle([-Inf], [Inf]))
    @test MOI.get(model, MOI.ConstraintDual(), c) == [0.0]
    @test_throws(
        MOI.GetAttributeNotAllowed{MOI.ConstraintPrimal},
        MOI.get(model, MOI.ConstraintPrimal(), c)
    )
    return
end

function test_basic_HyperRectangle()
    model = MOI.Bridges.Constraint.SplitHyperRectangle{Float64}(
        MOI.Utilities.Model{Float64}(),
    )
    config = MOI.Test.Config()
    MOI.empty!(model)
    MOI.Test.test_basic_VectorOfVariables_HyperRectangle(model, config)
    MOI.empty!(model)
    MOI.Test.test_basic_VectorAffineFunction_HyperRectangle(model, config)
    MOI.empty!(model)
    MOI.Test.test_basic_VectorQuadraticFunction_HyperRectangle(model, config)
    MOI.empty!(model)
    MOI.Test.test_basic_VectorNonlinearFunction_HyperRectangle(model, config)
    return
end

function test_runtests_VectorOfVariables_mix_of_signs()
    #     0 <= a <= 1       |        a >= 0
    #  -Inf <= b <= Inf     |        c >= 0
    #     0 <= c <= Inf     |   -1 + d >= 0
    #     1 <= d <= Inf     |    1 - a >= 0
    #  -Inf <= e <= 0       |      - e >= 0
    #  -Inf <= f <= Inf     |    1 - g >= 0
    #  -Inf <= g <= 1       |
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitHyperRectangleBridge,
        """
        variables: a, b, c, d, e, f, g
        [a, b, c, d, e, f, g] in HyperRectangle([0.0, -Inf, 0.0, 1.0, -Inf, -Inf, -Inf], [1.0, Inf, Inf, Inf, 0.0, Inf, 1.0])
        """,
        """
        variables: a, b, c, d, e, f, g
        [1.0 * a, 1.0 * c, 1.0 * d + -1.0, 1.0 + -1.0 * a, -1.0 * e, 1.0 + -1.0 * g] in Nonnegatives(6)
        """;
        constraint_start = [1.1, 0.0, 1.2, 1.3, -1.1, 0.0, -1.2],
    )
    return
end

end  # module

TestConstraintHyperRectangle.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestCopy

using Test

import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU
import MathOptInterface.Utilities.DoubleDicts

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

###
### Test helpers
###

abstract type AbstractDummyModel <: MOI.ModelLike end

function MOI.empty!(::AbstractDummyModel) end

function MOI.copy_to(dest::AbstractDummyModel, src::MOI.ModelLike)
    return MOIU.default_copy_to(dest, src)
end

MOI.supports(::AbstractDummyModel, ::MOI.ObjectiveSense) = true

function MOI.supports(
    ::AbstractDummyModel,
    ::MOI.ConstraintPrimalStart,
    ::Type{<:MOI.ConstraintIndex},
)
    return true
end

function MOI.supports_constraint(
    ::AbstractDummyModel,
    ::Type{MOI.VariableIndex},
    ::Type{MOI.EqualTo{Float64}},
)
    return true
end

function MOI.supports_constraint(
    ::AbstractDummyModel,
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.Zeros},
)
    return true
end

struct DummyModel <: AbstractDummyModel end

# Implements add_variable and add_constraint
struct DummyModelWithAdd <: AbstractDummyModel end

MOI.add_variable(::DummyModelWithAdd) = MOI.VariableIndex(0)

MOI.add_variables(::DummyModelWithAdd, n) = fill(MOI.VariableIndex(0), n)

function MOI.add_constraint(
    ::DummyModelWithAdd,
    ::MOI.VariableIndex,
    ::MOI.EqualTo{Float64},
)
    return MOI.ConstraintIndex{MOI.VariableIndex,MOI.EqualTo{Float64}}(0)
end

struct DummyEvaluator <: MOI.AbstractNLPEvaluator end

###
### The tests
###

function _test_identity_index_map(::Type{T}) where {T}
    model = MOI.Utilities.Model{T}()
    x, y = MOI.add_variables(model, 2)
    cx = MOI.add_constraint(model, x, MOI.EqualTo(one(T)))
    cy = MOI.add_constraint(model, y, MOI.EqualTo(zero(T)))
    c = MOI.add_constraint(model, one(T) * x + y, MOI.LessThan(zero(T)))
    index_map = MOI.Utilities.identity_index_map(model)
    @test x == index_map[x]
    @test y == index_map[y]
    @test cx == index_map[cx]
    @test cy == index_map[cy]
    @test c == index_map[c]
    return
end

function test_identity_index_map()
    _test_identity_index_map(Int)
    _test_identity_index_map(Float64)
    return
end

function test_IndexMap()
    map = MOIU.IndexMap()
    @test length(map) == 0
    @test occursin("Utilities.IndexMap()", sprint(show, map))
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    cx = MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(1)
    cy = MOI.ConstraintIndex{MOI.VariableIndex,MOI.Integer}(2)
    map = MOIU.IndexMap(Dict(x => y), DoubleDicts.IndexDoubleDict())
    map[cx] = cy
    @test length(map) == 2
    return
end

function test_AUTOMATIC()
    src = DummyModel()
    dest = DummyModel()
    @test_throws ErrorException MOIU.default_copy_to(dest, src)
    try
        @test_throws ErrorException MOIU.default_copy_to(dest, src)
    catch err
        @test sprint(showerror, err) ==
              "Model DummyModel does not support copy with names."
    end
end

"""
    test_issue_849()

Create variables in same ordering when NLPBlock is used (#849)
"""
function test_issue_849()
    model = MOIU.UniversalFallback(MOIU.Model{Float64}())
    a = MOI.add_variable(model)
    b, c = MOI.add_variables(model, 2)
    x, cx = MOI.add_constrained_variable(model, MOI.GreaterThan(0.0))
    y, cy = MOI.add_constrained_variables(model, MOI.Nonnegatives(1))
    nlp_data = MOI.NLPBlockData(
        [MOI.NLPBoundsPair(0.0, 1.0) for i in 1:5],
        DummyEvaluator(),
        false,
    )
    MOI.set(model, MOI.NLPBlock(), nlp_data)
    copy = MOIU.UniversalFallback(MOIU.Model{Float64}())
    index_map = MOIU.default_copy_to(copy, model)
    for vi in [a, b, c, x, y[1]]
        @test index_map[vi] == vi
    end
    for ci in [cx, cy]
        @test index_map[ci] == ci
    end
    return
end

###
### ConstrainedVariablesModel
###

"""
    ConstrainedVariablesModel

Model that distinguish variables created constrained
"""
struct ConstrainedVariablesModel <: MOI.ModelLike
    added_constrained::Vector{Bool}
end

MOI.empty!(model::ConstrainedVariablesModel) = empty!(model.added_constrained)

MOI.supports_incremental_interface(::ConstrainedVariablesModel) = true

function MOI.copy_to(
    dest::ConstrainedVariablesModel,
    src::MOI.ModelLike;
    kwargs...,
)
    return MOIU.default_copy_to(dest, src; kwargs...)
end

function MOI.add_variables(model::ConstrainedVariablesModel, n)
    m = length(model.added_constrained)
    for _ in 1:n
        push!(model.added_constrained, false)
    end
    return MOI.VariableIndex.(m .+ (1:n))
end

function MOI.add_constrained_variables(
    model::ConstrainedVariablesModel,
    set::MOI.AbstractVectorSet,
)
    m = length(model.added_constrained)
    for _ in 1:MOI.dimension(set)
        push!(model.added_constrained, true)
    end
    ci = MOI.ConstraintIndex{MOI.VectorOfVariables,typeof(set)}(m + 1)
    return MOI.VariableIndex.(m .+ (1:MOI.dimension(set))), ci
end

function MOI.add_constraint(
    ::ConstrainedVariablesModel,
    func::MOI.VectorOfVariables,
    set::MOI.AbstractVectorSet,
)
    return MOI.ConstraintIndex{typeof(func),typeof(set)}(
        func.variables[1].value,
    )
end

function test_ConstrainedVariablesModel()
    src = MOIU.Model{Int}()
    x = MOI.add_variables(src, 3)
    cx = MOI.add_constraint(src, [x[1], x[3], x[1], x[2]], MOI.Nonnegatives(4))
    y, cy = MOI.add_constrained_variables(src, MOI.Nonpositives(3))
    dest = ConstrainedVariablesModel(Bool[])
    idxmap = MOI.copy_to(dest, src)
    for vi in x
        @test !dest.added_constrained[idxmap[vi].value]
    end
    for vi in y
        @test dest.added_constrained[idxmap[vi].value]
    end
    return
end

###
### AbstractConstrainedVariablesModel
###

abstract type AbstractConstrainedVariablesModel <: MOI.ModelLike end

mutable struct OrderConstrainedVariablesModel <:
               AbstractConstrainedVariablesModel
    constraintIndices::Array{MOI.ConstraintIndex}
    inner::MOIU.Model{Float64}
    function OrderConstrainedVariablesModel()
        return new(MOI.ConstraintIndex[], MOIU.Model{Float64}())
    end
end
mutable struct ReverseOrderConstrainedVariablesModel <:
               AbstractConstrainedVariablesModel
    constraintIndices::Array{MOI.ConstraintIndex}
    inner::MOIU.Model{Float64}
    function ReverseOrderConstrainedVariablesModel()
        return new(MOI.ConstraintIndex[], MOIU.Model{Float64}())
    end
end

function MOI.add_variables(model::AbstractConstrainedVariablesModel, n)
    return MOI.add_variables(model.inner, n)
end

function MOI.add_variable(model::AbstractConstrainedVariablesModel)
    return MOI.add_variable(model.inner)
end

function MOI.add_constraint(
    model::AbstractConstrainedVariablesModel,
    f::MOI.AbstractFunction,
    s::MOI.AbstractSet,
)
    ci = MOI.add_constraint(model.inner, f, s)
    push!(model.constraintIndices, ci)
    return ci
end

function MOI.copy_to(
    dest::AbstractConstrainedVariablesModel,
    src::MOI.ModelLike;
    kwargs...,
)
    return MOIU.default_copy_to(dest, src; kwargs...)
end

MOI.supports_incremental_interface(::AbstractConstrainedVariablesModel) = true

function MOI.empty!(model::AbstractConstrainedVariablesModel)
    model.constraintIndices = MOI.ConstraintIndex[]
    MOI.empty!(model.inner)
    return
end

function MOI.supports_add_constrained_variables(
    ::OrderConstrainedVariablesModel,
    ::Type{MOI.Nonnegatives},
)
    return true
end

function MOI.supports_constraint(
    ::OrderConstrainedVariablesModel,
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.Nonnegatives},
)
    return true
end

function MOI.supports_add_constrained_variables(
    ::OrderConstrainedVariablesModel,
    ::Type{MOI.Nonpositives},
)
    return false
end

function MOI.supports_add_constrained_variables(
    ::ReverseOrderConstrainedVariablesModel,
    ::Type{MOI.Nonnegatives},
)
    return false
end

function MOI.supports_constraint(
    ::ReverseOrderConstrainedVariablesModel,
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.Nonnegatives},
)
    return false
end

function MOI.supports_add_constrained_variables(
    ::ReverseOrderConstrainedVariablesModel,
    ::Type{MOI.Nonpositives},
)
    return true
end

function MOI.supports_constraint(
    ::OrderConstrainedVariablesModel,
    ::Type{MOI.VectorAffineFunction{Float64}},
    ::Type{MOI.Nonnegatives},
)
    return true
end

function MOI.supports_constraint(
    ::ReverseOrderConstrainedVariablesModel,
    ::Type{MOI.VectorAffineFunction{Float64}},
    ::Type{MOI.Nonpositives},
)
    return true
end

function MOI.supports_constraint(
    ::OrderConstrainedVariablesModel,
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.GreaterThan},
)
    return true
end

function MOI.supports_add_constrained_variable(
    ::OrderConstrainedVariablesModel,
    ::Type{<:MOI.GreaterThan},
)
    return false
end

function MOI.supports_constraint(
    ::OrderConstrainedVariablesModel,
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.LessThan},
)
    return false
end

function MOI.supports_add_constrained_variable(
    ::OrderConstrainedVariablesModel,
    ::Type{<:MOI.LessThan},
)
    return true
end

function MOI.supports_constraint(
    ::ReverseOrderConstrainedVariablesModel,
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.GreaterThan},
)
    return false
end

function MOI.supports_add_constrained_variable(
    ::ReverseOrderConstrainedVariablesModel,
    ::Type{<:MOI.GreaterThan},
)
    return true
end

function MOI.supports_constraint(
    ::ReverseOrderConstrainedVariablesModel,
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.LessThan},
)
    return true
end

function MOI.supports_add_constrained_variable(
    ::ReverseOrderConstrainedVariablesModel,
    ::Type{<:MOI.LessThan},
)
    return false
end

"""
    test_create_variables_using_supports_add_constrained_variable()

From Issue #987
"""
function test_create_variables_using_supports_add_constrained_variable()
    # With vectors
    src = MOIU.Model{Float64}()
    a, c1 = MOI.add_constrained_variables(src, MOI.Nonpositives(3))
    c2 = MOI.add_constraint(src, a, MOI.Nonnegatives(3))

    dest = OrderConstrainedVariablesModel()
    index_map = MOI.copy_to(dest, src)
    @test typeof(c1) == typeof(dest.constraintIndices[2])
    @test typeof(c2) == typeof(dest.constraintIndices[1])

    dest = ReverseOrderConstrainedVariablesModel()
    index_map = MOI.copy_to(dest, src)
    @test typeof(c1) == typeof(dest.constraintIndices[1])
    @test typeof(c2) == typeof(dest.constraintIndices[2])

    b, cb = MOI.add_constrained_variables(src, MOI.Nonnegatives(2))
    c3 = MOI.add_constraint(src, b, MOI.Zeros(2))

    d, cd = MOI.add_constrained_variables(src, MOI.Zeros(2))
    c4 = MOI.add_constraint(src, d, MOI.Nonpositives(2))

    dest = OrderConstrainedVariablesModel()
    bridged_dest = MOI.Bridges.full_bridge_optimizer(dest, Float64)
    @test MOIU.sorted_variable_sets_by_cost(bridged_dest, src) ==
          Type[MOI.Nonnegatives, MOI.Zeros, MOI.Nonpositives]
    @test MOI.supports_add_constrained_variables(bridged_dest, MOI.Nonnegatives)
    @test MOI.get(bridged_dest, MOI.VariableBridgingCost{MOI.Nonnegatives}()) ==
          0.0
    @test MOI.supports_constraint(
        bridged_dest,
        MOI.VectorOfVariables,
        MOI.Nonnegatives,
    )
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VectorOfVariables,MOI.Nonnegatives}(),
    ) == 0.0
    @test MOI.supports_add_constrained_variables(bridged_dest, MOI.Nonpositives)
    @test MOI.get(bridged_dest, MOI.VariableBridgingCost{MOI.Nonpositives}()) ==
          1.0
    @test MOI.supports_constraint(
        bridged_dest,
        MOI.VectorOfVariables,
        MOI.Nonpositives,
    )
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VectorOfVariables,MOI.Nonpositives}(),
    ) == 1.0
    @test MOI.supports_add_constrained_variables(bridged_dest, MOI.Zeros)
    @test MOI.get(bridged_dest, MOI.VariableBridgingCost{MOI.Zeros}()) == 1.0
    @test MOI.supports_constraint(
        bridged_dest,
        MOI.VectorOfVariables,
        MOI.Zeros,
    )
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VectorOfVariables,MOI.Zeros}(),
    ) == 2.0
    index_map = MOI.copy_to(bridged_dest, src)
    @test length(dest.constraintIndices) == 6

    dest = ReverseOrderConstrainedVariablesModel()
    bridged_dest = MOI.Bridges.full_bridge_optimizer(dest, Float64)
    @test MOIU.sorted_variable_sets_by_cost(bridged_dest, src) ==
          Type[MOI.Nonpositives, MOI.Zeros, MOI.Nonnegatives]
    @test MOI.supports_add_constrained_variables(bridged_dest, MOI.Nonnegatives)
    @test MOI.get(bridged_dest, MOI.VariableBridgingCost{MOI.Nonnegatives}()) ==
          2.0
    @test MOI.supports_constraint(
        bridged_dest,
        MOI.VectorOfVariables,
        MOI.Nonnegatives,
    )
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VectorOfVariables,MOI.Nonnegatives}(),
    ) == 1.0
    @test MOI.supports_add_constrained_variables(bridged_dest, MOI.Nonpositives)
    @test MOI.get(bridged_dest, MOI.VariableBridgingCost{MOI.Nonpositives}()) ==
          0.0
    @test MOI.supports_constraint(
        bridged_dest,
        MOI.VectorOfVariables,
        MOI.Nonpositives,
    )
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VectorOfVariables,MOI.Nonpositives}(),
    ) == 1.0
    @test MOI.supports_add_constrained_variables(bridged_dest, MOI.Zeros)
    @test MOI.get(bridged_dest, MOI.VariableBridgingCost{MOI.Zeros}()) == 1.0
    @test MOI.supports_constraint(
        bridged_dest,
        MOI.VectorOfVariables,
        MOI.Zeros,
    )
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VectorOfVariables,MOI.Zeros}(),
    ) == 3.0
    index_map = MOI.copy_to(bridged_dest, src)
    @test length(dest.constraintIndices) == 6

    # With single variables
    src = MOIU.Model{Float64}()
    a, c1 = MOI.add_constrained_variable(src, MOI.GreaterThan{Float64}(5.0))
    c2 = MOI.add_constraint(src, a, MOI.LessThan{Float64}(1.0))

    dest = OrderConstrainedVariablesModel()
    index_map = MOI.copy_to(dest, src)
    @test typeof(c1) == typeof(dest.constraintIndices[2])
    @test typeof(c2) == typeof(dest.constraintIndices[1])

    dest = ReverseOrderConstrainedVariablesModel()
    index_map = MOI.copy_to(dest, src)
    @test typeof(c1) == typeof(dest.constraintIndices[1])
    @test typeof(c2) == typeof(dest.constraintIndices[2])

    dest = OrderConstrainedVariablesModel()
    bridged_dest = MOI.Bridges.full_bridge_optimizer(dest, Float64)
    @test MOI.get(
        bridged_dest,
        MOI.VariableBridgingCost{MOI.LessThan{Float64}}(),
    ) == 0.0
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VariableIndex,MOI.LessThan{Float64}}(),
    ) == 2.0
    @test MOI.get(
        bridged_dest,
        MOI.VariableBridgingCost{MOI.GreaterThan{Float64}}(),
    ) == 1.0
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VariableIndex,MOI.GreaterThan{Float64}}(),
    ) == 0.0
    index_map = MOI.copy_to(bridged_dest, src)
    @test typeof(c1) == typeof(dest.constraintIndices[2])
    @test typeof(c2) == typeof(dest.constraintIndices[1])

    dest = ReverseOrderConstrainedVariablesModel()
    bridged_dest = MOI.Bridges.full_bridge_optimizer(dest, Float64)
    @test MOI.get(
        bridged_dest,
        MOI.VariableBridgingCost{MOI.LessThan{Float64}}(),
    ) == 1.0
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VariableIndex,MOI.LessThan{Float64}}(),
    ) == 0.0
    @test MOI.get(
        bridged_dest,
        MOI.VariableBridgingCost{MOI.GreaterThan{Float64}}(),
    ) == 0.0
    @test MOI.get(
        bridged_dest,
        MOI.ConstraintBridgingCost{MOI.VariableIndex,MOI.GreaterThan{Float64}}(),
    ) == 2.0
    index_map = MOI.copy_to(bridged_dest, src)
    @test typeof(c1) == typeof(dest.constraintIndices[1])
    @test typeof(c2) == typeof(dest.constraintIndices[2])
end

function test_filtering_copy()
    # Create a basic model.
    src = MOIU.Model{Float64}()
    x = MOI.add_variable(src)
    c1 = MOI.add_constraint(src, x, MOI.LessThan{Float64}(1.0))
    c2 = MOI.add_constraint(src, x, MOI.GreaterThan{Float64}(0.0))

    # Filtering function: the default case where this function always returns
    # true is already well-tested by the above cases.
    # Only keep the constraint c1.
    f(::Any) = true
    f(cidx::MOI.ConstraintIndex) = cidx == c1

    # Perform the copy.
    dst = OrderConstrainedVariablesModel()
    index_map = MOI.copy_to(dst, MOI.Utilities.ModelFilter(f, src))

    @test typeof(c1) == typeof(dst.constraintIndices[1])
    @test length(dst.constraintIndices) == 1
    return
end

function test_filtering_copy_empty()
    src = MOI.Utilities.Model{Float64}()
    MOI.set(src, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    model = MOI.Utilities.ModelFilter(src) do item
        return item !== MOI.ObjectiveSense()
    end
    @test MOI.is_empty(model)
    MOI.add_variable(src)
    @test !MOI.is_empty(model)
    MOI.empty!(model)
    @test MOI.is_empty(model)
    MOI.set(src, MOI.Name(), "Model")
    @test !MOI.is_empty(model)
    return
end

function test_filtering_copy_AbstractModelAttribute()
    src = MOI.Utilities.Model{Float64}()
    MOI.set(src, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    dest = MOI.Utilities.Model{Float64}()
    filtered_src = MOI.Utilities.ModelFilter(src) do item
        if item isa MOI.AbstractModelAttribute
            return item != MOI.ObjectiveSense()
        end
        return true
    end
    @test MOI.is_empty(filtered_src)
    MOI.copy_to(dest, filtered_src)
    @test MOI.get(dest, MOI.ObjectiveSense()) == MOI.FEASIBILITY_SENSE
    return
end

function test_filtering_copy_AbstractVariableAttribute()
    src = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(src)
    MOI.set(src, MOI.VariableName(), x, "x")
    MOI.set(src, MOI.VariablePrimalStart(), x, 1.0)
    dest = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    filtered_src = MOI.Utilities.ModelFilter(src) do item
        if item isa MOI.AbstractVariableAttribute
            return item != MOI.VariableName()
        end
        return true
    end
    @test !MOI.is_empty(filtered_src)
    index_map = MOI.copy_to(dest, filtered_src)
    @test MOI.get(dest, MOI.VariableName(), index_map[x]) == ""
    @test MOI.get(dest, MOI.VariablePrimalStart(), index_map[x]) == 1.0
    return
end

function test_filtering_copy_AbstractConstraintAttribute()
    src = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(src)
    c = MOI.add_constraint(src, MOI.VectorOfVariables([x]), MOI.Nonnegatives(1))
    MOI.set(src, MOI.ConstraintName(), c, "c")
    MOI.set(src, MOI.ConstraintDualStart(), c, [1.0])
    dest = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    filtered_src = MOI.Utilities.ModelFilter(src) do item
        if item isa MOI.AbstractConstraintAttribute
            return item != MOI.ConstraintName()
        end
        return true
    end
    @test !MOI.is_empty(filtered_src)
    index_map = MOI.copy_to(dest, filtered_src)
    @test MOI.get(dest, MOI.ConstraintName(), index_map[c]) == ""
    @test MOI.get(dest, MOI.ConstraintDualStart(), index_map[c]) == [1.0]
    return
end

function test_filtering_copy_ListOfConstraintIndices()
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(src, 4)
    MOI.add_constraint.(src, x, MOI.GreaterThan(0.0))
    dest = MOI.Utilities.Model{Float64}()
    filtered_src = MOI.Utilities.ModelFilter(src) do item
        if item isa MOI.ConstraintIndex
            return isodd(item.value)
        end
        return true
    end
    @test !MOI.is_empty(filtered_src)
    index_map = MOI.copy_to(dest, filtered_src)
    @test MOI.get(dest, MOI.NumberOfVariables()) == 4
    @test MOI.get(
        dest,
        MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{Float64}}(),
    ) == 2
    @test MOI.get(
        filtered_src,
        MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{Float64}}(),
    ) == 2
    for xi in x
        @test haskey(index_map, xi)
        ci = MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}}(
            xi.value,
        )
        @test haskey(index_map, ci) == isodd(xi.value)
    end
    return
end

function test_filtering_copy_ListOfConstraintTypesPresent()
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(src, 4)
    MOI.add_constraint.(src, x, MOI.GreaterThan(0.0))
    MOI.add_constraint.(src, x, MOI.ZeroOne())
    dest = MOI.Utilities.Model{Float64}()
    index_map = MOI.copy_to(
        dest,
        MOI.Utilities.ModelFilter(src) do item
            if item isa Tuple{Type,Type}
                return item == (MOI.VariableIndex, MOI.ZeroOne)
            end
            return true
        end,
    )
    @test MOI.get(dest, MOI.NumberOfVariables()) == 4
    @test MOI.get(
        dest,
        MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{Float64}}(),
    ) == 0
    @test MOI.get(
        dest,
        MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne}(),
    ) == 4
    return
end

###
### BoundModel
###
mutable struct BoundModel <: MOI.ModelLike
    # Type of model that only supports ≤ bound constraints. In particular, it
    # does not support integrality constraints.
    inner::MOIU.Model{Float64}
    BoundModel() = new(MOIU.Model{Float64}())
end

MOI.add_variable(model::BoundModel) = MOI.add_variable(model.inner)

function MOI.add_constraint(
    model::BoundModel,
    f::MOI.AbstractFunction,
    s::MOI.LessThan{Float64},
)
    return MOI.add_constraint(model.inner, f, s)
end

function MOI.supports_constraint(
    ::BoundModel,
    ::Type{MOI.VariableIndex},
    ::MOI.LessThan{Float64},
)
    return true
end

MOI.supports_incremental_interface(::BoundModel) = true

function MOI.copy_to(dest::BoundModel, src::MOI.ModelLike; kwargs...)
    return MOIU.default_copy_to(dest, src; kwargs...)
end

MOI.empty!(model::BoundModel) = MOI.empty!(model.inner)

MOI.supports(::BoundModel, ::Type{MOI.NumberOfConstraints}) = true

function MOI.get(model::BoundModel, attr::MOI.NumberOfConstraints)
    return MOI.get(model.inner, attr)
end

function test_BoundModel_filtering_copy()
    # Create a basic model.
    src = MOIU.Model{Float64}()
    x = MOI.add_variable(src)
    c1 = MOI.add_constraint(src, x, MOI.LessThan{Float64}(10.0))
    c2 = MOI.add_constraint(src, x, MOI.Integer())

    # Filtering function: get rid of integrality constraint.
    f(::Any) = true
    f(::MOI.ConstraintIndex{F,MOI.Integer}) where {F} = false

    # Perform the unfiltered copy. This should throw an error (that is, the
    # implementation of BoundModel
    # should be correct).
    dst = BoundModel()
    @test_throws(
        MOI.UnsupportedConstraint{MOI.VariableIndex,MOI.Integer},
        MOI.copy_to(dst, src),
    )

    # Perform the filtered copy. This should not throw an error.
    dst = BoundModel()
    MOI.copy_to(dst, MOI.Utilities.ModelFilter(f, src))
    @test MOI.get(
        dst,
        MOI.NumberOfConstraints{MOI.VariableIndex,MOI.LessThan{Float64}}(),
    ) == 1
    @test MOI.get(
        dst,
        MOI.NumberOfConstraints{MOI.VariableIndex,MOI.Integer}(),
    ) == 0
end

# We create a `OnlyCopyConstraints` that don't implement `add_constraint` but
# implements `pass_nonvariable_constraints` to check that this is passed accross
# all layers without falling back to `pass_nonvariable_constraints_fallback`
# which calls `add_constraint`.

struct OnlyCopyConstraints{F,S} <: MOI.ModelLike
    constraints::MOIU.VectorOfConstraints{F,S}
    function OnlyCopyConstraints{F,S}() where {F,S}
        return new{F,S}(MOIU.VectorOfConstraints{F,S}())
    end
end

function MOI.Utilities._add_variable(::OnlyCopyConstraints) end

MOI.empty!(model::OnlyCopyConstraints) = MOI.empty!(model.constraints)

function MOI.supports_constraint(
    model::OnlyCopyConstraints,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    return MOI.supports_constraint(model.constraints, F, S)
end

function MOIU.pass_nonvariable_constraints(
    dest::OnlyCopyConstraints,
    src::MOI.ModelLike,
    idxmap::MOIU.IndexMap,
    constraint_types,
)
    return MOIU.pass_nonvariable_constraints(
        dest.constraints,
        src,
        idxmap,
        constraint_types,
    )
end

function _test_copy_of_constraints_passed_as_copy_accross_layers(
    ::Type{T},
) where {T}
    F = MOI.ScalarAffineFunction{T}
    S = MOI.EqualTo{T}
    S2 = MOI.GreaterThan{T}
    src = MOIU.Model{T}()
    x = MOI.add_variable(src)
    MOI.add_constraint(src, T(1) * x, MOI.EqualTo(T(1)))
    MOI.add_constraint(src, T(2) * x, MOI.EqualTo(T(2)))
    MOI.add_constraint(src, T(3) * x, MOI.GreaterThan(T(3)))
    MOI.add_constraint(src, T(4) * x, MOI.GreaterThan(T(4)))
    dest = MOIU.CachingOptimizer(
        MOI.Bridges.full_bridge_optimizer(
            MOIU.UniversalFallback(
                MOIU.GenericOptimizer{
                    T,
                    MOI.Utilities.ObjectiveContainer{T},
                    MOI.Utilities.VariablesContainer{T},
                    OnlyCopyConstraints{F,S},
                }(),
            ),
            T,
        ),
        MOIU.AUTOMATIC,
    )
    MOI.copy_to(dest, src)
    voc = dest.model_cache.model.model.constraints.constraints
    @test MOI.get(voc, MOI.NumberOfConstraints{F,S}()) == 2
    @test !haskey(dest.model_cache.model.constraints, (F, S))
    @test MOI.get(dest, MOI.NumberOfConstraints{F,S2}()) == 2
    @test haskey(dest.model_cache.model.constraints, (F, S2))
    return
end

function test_copy_of_constraints_passed_as_copy_accross_layers()
    _test_copy_of_constraints_passed_as_copy_accross_layers(Int)
    _test_copy_of_constraints_passed_as_copy_accross_layers(Float64)
    return
end

struct Optimizer1698_1 <: MOI.AbstractOptimizer end

function MOI.supports_constraint(
    ::Optimizer1698_1,
    ::Type{MOI.VariableIndex},
    ::Type{MOI.Integer},
)
    return true
end

function MOI.supports_constraint(
    ::Optimizer1698_1,
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{Float64}}},
    ::Type{<:Union{MOI.Nonnegatives,MOI.SecondOrderCone}},
)
    return true
end

function test_sorted_variable_sets_by_cost_1()
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(src)
    y = MOI.add_variables(src, 2)
    MOI.add_constraint(src, x, MOI.GreaterThan(1.0))
    MOI.add_constraint(src, x, MOI.Integer())
    MOI.add_constraint(src, y, MOI.SecondOrderCone(2))
    dest = MOI.Bridges.full_bridge_optimizer(Optimizer1698_1(), Float64)
    @test MOI.Utilities.sorted_variable_sets_by_cost(dest, src) ==
          [MOI.SecondOrderCone, MOI.Integer, MOI.GreaterThan{Float64}]
    return
end

struct Optimizer1698_2 <: MOI.AbstractOptimizer end

function MOI.supports_constraint(
    ::Optimizer1698_2,
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{Float64}}},
    ::Type{<:Union{MOI.Nonnegatives,MOI.Nonpositives}},
)
    return true
end

function test_sorted_variable_sets_by_cost_2()
    src = MOI.Utilities.Model{Float64}()
    MOI.add_constrained_variables(src, MOI.Nonnegatives(2))
    MOI.add_constrained_variables(src, MOI.Zeros(2))
    dest = MOI.Bridges.full_bridge_optimizer(Optimizer1698_2(), Float64)
    @test MOI.Utilities.sorted_variable_sets_by_cost(dest, src) ==
          [MOI.Nonnegatives, MOI.Zeros]
    return
end

function test_sorted_copy_to()
    src = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(src)
    f = MOI.ScalarNonlinearFunction(:sqr, Any[x])
    attr_1 = MOI.UserDefinedFunction(:sqr, 1)
    attr_2 = MOI.ObjectiveSense()
    attr_3 = MOI.ObjectiveFunction{typeof(f)}()
    attr_4 = MOI.Name()
    MOI.set(src, attr_4, "abc")
    MOI.set(src, attr_1, (sqrt,))
    MOI.set(src, attr_3, f)
    MOI.set(src, attr_2, MOI.MAX_SENSE)
    dest = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    index_map = MOI.copy_to(dest, src)
    @test MOI.get(dest, attr_1) == (sqrt,)
    @test MOI.get(dest, attr_2) == MOI.MAX_SENSE
    g = MOI.ScalarNonlinearFunction(:sqr, Any[index_map[x]])
    @test ≈(g, MOI.get(dest, attr_3))
    @test MOI.get(dest, attr_4) == "abc"
    return
end

function test_copy_to_empty_VectorOfVariables_constraint()
    src = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(src)
    F, S = MOI.VectorOfVariables, MOI.Zeros
    MOI.add_constraint(src, F([]), S(0))
    dest = MOI.Utilities.Model{Float64}()
    MOI.copy_to(dest, src)
    @test (F, S) in MOI.get(dest, MOI.ListOfConstraintTypesPresent())
    @test MOI.get(dest, MOI.NumberOfConstraints{F,S}()) == 1
    ci = only(MOI.get(dest, MOI.ListOfConstraintIndices{F,S}()))
    @test MOI.get(dest, MOI.ConstraintFunction(), ci) == F([])
    return
end

function test_copy_to_sorted_sets()
    src = MOI.Utilities.Model{Float64}()
    # Free variable to start
    x1 = MOI.add_variable(src)
    x2, _ = MOI.add_constrained_variables(src, MOI.SecondOrderCone(3))
    x3 = MOI.add_variables(src, 2)
    MOI.add_constraint(src, MOI.VectorOfVariables(x3), MOI.Nonnegatives(2))
    # A variable with multiple domain sets
    x4, _ = MOI.add_constrained_variable(src, MOI.GreaterThan(0.0))
    _ = MOI.add_constraint(src, x4, MOI.LessThan(0.0))
    # A split function. Not added as a variable
    MOI.add_constraint(
        src,
        MOI.VectorOfVariables([x1, x3[2]]),
        MOI.Nonpositives(2),
    )
    # Repeated set
    _, _ = MOI.add_constrained_variables(src, MOI.Nonnegatives(3))
    # An empty constraint
    MOI.add_constraint(src, MOI.VectorOfVariables([]), MOI.Zeros(0))
    # Two free variable to end
    _ = MOI.add_variables(src, 2)
    dest = MOI.Utilities.Model{Float64}()
    index_map = MOI.copy_to(dest, src)
    x_src = MOI.get(src, MOI.ListOfVariableIndices())
    x_dest = MOI.get(dest, MOI.ListOfVariableIndices())
    for (x, y) in zip(x_src, x_dest)
        @test index_map[x] == y
    end
    return
end

function test_deprecated_try_constrain_variables_scalar()
    src = MOI.Utilities.Model{Float64}()
    x, c_z = MOI.add_constrained_variable(src, MOI.ZeroOne())
    c = MOI.add_constraint(src, x, MOI.EqualTo(0.0))
    dest = MOI.Utilities.Model{Float64}()
    index_map = MOI.Utilities.IndexMap()
    not_added = MOI.Utilities._try_constrain_variables_on_creation(
        dest,
        src,
        index_map,
        MOI.ZeroOne,
    )
    @test isempty(not_added)
    not_added = MOI.Utilities._try_constrain_variables_on_creation(
        dest,
        src,
        index_map,
        MOI.EqualTo{Float64},
    )
    @test not_added == [c]
    @test MOI.is_valid(dest, index_map[x])
    @test MOI.is_valid(dest, index_map[c_z])
    @test_throws KeyError index_map[c]
    return
end

function test_deprecated_try_constrain_variables_vector()
    src = MOI.Utilities.Model{Float64}()
    x, c_z = MOI.add_constrained_variables(src, MOI.Nonnegatives(2))
    y = MOI.add_variable(src)
    c_duplicate = MOI.add_constraint(
        src,
        MOI.VectorOfVariables([x[1], x[1]]),
        MOI.Zeros(2),
    )
    c_already_added = MOI.add_constraint(
        src,
        MOI.VectorOfVariables([y, x[1]]),
        MOI.Nonpositives(2),
    )
    dest = MOI.Utilities.Model{Float64}()
    index_map = MOI.Utilities.IndexMap()
    not_added = MOI.Utilities._try_constrain_variables_on_creation(
        dest,
        src,
        index_map,
        MOI.Nonnegatives,
    )
    @test isempty(not_added)
    @test MOI.is_valid(dest, index_map[x[1]])
    @test MOI.is_valid(dest, index_map[x[2]])
    @test MOI.is_valid(dest, index_map[c_z])
    not_added = MOI.Utilities._try_constrain_variables_on_creation(
        dest,
        src,
        index_map,
        MOI.Zeros,
    )
    @test not_added == [c_duplicate]
    not_added = MOI.Utilities._try_constrain_variables_on_creation(
        dest,
        src,
        index_map,
        MOI.Nonpositives,
    )
    @test not_added == [c_already_added]
    return
end

function test_deprecated_copy_free_variables()
    src = MOI.Utilities.Model{Float64}()
    x, c_z = MOI.add_constrained_variable(src, MOI.ZeroOne())
    y = MOI.add_variable(src)
    dest = MOI.Utilities.Model{Float64}()
    index_map = MOI.Utilities.IndexMap()
    not_added = MOI.Utilities._try_constrain_variables_on_creation(
        dest,
        src,
        index_map,
        MOI.ZeroOne,
    )
    MOI.Utilities._copy_free_variables(dest, index_map, [x, y])
    @test MOI.is_valid(dest, index_map[x])
    @test MOI.is_valid(dest, index_map[y])
    MOI.Utilities._copy_free_variables(dest, index_map, [x, y])
    @test MOI.is_valid(dest, index_map[x])
    @test MOI.is_valid(dest, index_map[y])
    return
end

function test_index_map()
    src = MOI.Utilities.Model{Float64}()
    x, c_z = MOI.add_constrained_variable(src, MOI.ZeroOne())
    dest = MOI.Utilities.Model{Float64}()
    index_map = MOI.copy_to(dest, src)
    @test collect(keys(index_map)) == Any[x, c_z]
    delete!(index_map, x)
    @test collect(keys(index_map)) == Any[c_z]
    delete!(index_map, c_z)
    @test collect(keys(index_map)) == Any[]
    return
end

function test_copy_names_unsupported()
    src = MOI.Utilities.Model{Float64}()
    MOI.set(src, MOI.Name(), "Abc")
    x = MOI.add_variable(src)
    MOI.set(src, MOI.VariableName(), x, "x")
    c = MOI.add_constraint(src, 1.0 * x, MOI.LessThan(1.0))
    MOI.set(src, MOI.ConstraintName(), c, "c")
    dest = MOI.Utilities.MockOptimizer(
        MOI.Utilities.Model{Float64}();
        supports_names = false,
    )
    index_map = MOI.copy_to(dest, src)
    @test MOI.get(dest, MOI.VariableName(), index_map[x]) == ""
    return
end

end  # module

TestCopy.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSetDotScaling

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_scaling()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SetDotScalingBridge,
        """
        variables: x, y, z
        [x, 1.0 * y, z] in PositiveSemidefiniteConeTriangle(2)
        """,
        """
        variables: x, y, z
        [x, √2 * y, z] in ScaledPositiveSemidefiniteConeTriangle(2)
        """,
    )
    return
end

function test_scaling_vector_of_variables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SetDotScalingBridge,
        """
        variables: x, y, z
        [x, y, z] in PositiveSemidefiniteConeTriangle(2)
        """,
        """
        variables: x, y, z
        [x, √2 * y, z] in ScaledPositiveSemidefiniteConeTriangle(2)
        """,
    )
    return
end

function test_scaling_quadratic()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SetDotScalingBridge,
        """
        variables: x, y, z
        [x, 1.0 * y * y + 1.0 * y + 3.0, z] in PositiveSemidefiniteConeTriangle(2)
        """,
        """
        variables: x, y, z
        [x, √2 * y * y + √2 * y + 4.242640687119286, z] in ScaledPositiveSemidefiniteConeTriangle(2)
        """,
    )
    return
end

function test_inverse_scaling()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SetDotInverseScalingBridge,
        """
        variables: x, y, z
        [x, √2 * y, z] in ScaledPositiveSemidefiniteConeTriangle(2)
        """,
        """
        variables: x, y, z
        [x, 1.0 * y, z] in PositiveSemidefiniteConeTriangle(2)
        """,
    )
    return
end

function test_inverse_scaling_vector_of_variables()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SetDotInverseScalingBridge,
        """
        variables: x, y, z
        [x, y, z] in ScaledPositiveSemidefiniteConeTriangle(2)
        """,
        """
        variables: x, y, z
        [x, 0.7071067811865475 * y, z] in PositiveSemidefiniteConeTriangle(2)
        """,
    )
    return
end

function test_inverse_scaling_quadratic()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SetDotInverseScalingBridge,
        """
        variables: x, y, z
        [x, √2 * y * y, z] in ScaledPositiveSemidefiniteConeTriangle(2)
        """,
        """
        variables: x, y, z
        [x, 1.0 * y * y, z] in PositiveSemidefiniteConeTriangle(2)
        """,
    )
    return
end

function test_scaling_complex()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SetDotScalingBridge,
        model -> begin
            x, y, z = MOI.add_variables(model, 3)
            MOI.add_constraint(
                model,
                MOI.Utilities.vectorize([
                    (1.0 + 0im) * x,
                    (1.0 * im) * y,
                    (1.0 + 0im) * z,
                ]),
                MOI.PositiveSemidefiniteConeTriangle(2),
            )
        end,
        model -> begin
            x, y, z = MOI.add_variables(model, 3)
            MOI.add_constraint(
                model,
                MOI.Utilities.vectorize([
                    (1.0 + 0im) * x,
                    (√2 * im) * y,
                    (1.0 + 0im) * z,
                ]),
                MOI.ScaledPositiveSemidefiniteConeTriangle(2),
            )
        end,
        eltype = ComplexF64,
        model_eltype = Float64,
        constraint_start = 1.2 * im,
    )
    return
end

function test_set_dot_scaling_constraint_dual_start()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.SetDotScaling{Float64}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.PositiveSemidefiniteConeTriangle(2),
    )
    MOI.set(model, MOI.ConstraintDualStart(), c, [1.0, 1.0, 1.0])
    @test MOI.get(model, MOI.ConstraintDualStart(), c) ≈ [1.0, 1.0, 1.0]
    F = MOI.VectorAffineFunction{Float64}
    S = MOI.Scaled{MOI.PositiveSemidefiniteConeTriangle}
    d = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())[1]
    @test MOI.get(inner, MOI.ConstraintDualStart(), d) ≈ [1.0, √2, 1.0]
    return
end

function test_set_dot_inverse_scaling_constraint_dual_start()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.SetDotInverseScaling{Float64}(inner)
    x = MOI.add_variables(model, 3)
    c = MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.ScaledPositiveSemidefiniteConeTriangle(2),
    )
    MOI.set(model, MOI.ConstraintDualStart(), c, [1.0, 1.0, 1.0])
    @test MOI.get(model, MOI.ConstraintDualStart(), c) ≈ [1.0, 1.0, 1.0]
    F = MOI.VectorAffineFunction{Float64}
    S = MOI.PositiveSemidefiniteConeTriangle
    d = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())[1]
    @test MOI.get(inner, MOI.ConstraintDualStart(), d) ≈ [1.0, 1 / √2, 1.0]
    return
end

end  # module

TestConstraintSetDotScaling.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestUniversalFallback

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

###
### Utilities for running the tests
###

struct UnknownOptimizerAttribute <: MOI.AbstractOptimizerAttribute end

# A few objective/constraint types are supported to test both the fallback and the
# delegation to the internal model
MOI.Utilities.@model(
    ModelForUniversalFallback,
    (),
    (MOI.LessThan,),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
)

function MOI.supports(
    ::ModelForUniversalFallback{T},
    ::MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::ModelForUniversalFallback{T},
    ::Type{MOI.VariableIndex},
    ::Type{
        <:Union{
            MOI.EqualTo{T},
            MOI.GreaterThan{T},
            MOI.Interval{T},
            MOI.Integer,
            MOI.ZeroOne,
        },
    },
) where {T}
    return false
end

###
### The tests
###

function test_MOI_Test()
    inner = ModelForUniversalFallback{Float64}()
    model = MOI.Utilities.UniversalFallback(inner)
    MOI.Test.runtests(
        model,
        MOI.Test.Config(exclude = Any[MOI.optimize!]),
        exclude = String[
            # UniversalFallback fails all these tests because it supports
            # everything
            "test_attribute_",
            "test_model_supports_constraint_",
            "test_model_copy_to_Unsupported",
            # Bugs in UniversalFallback
            "test_model_LowerBoundAlreadySet",
            "test_model_UpperBoundAlreadySet",
            "test_add_parameter",
        ],
    )
    return
end

function _test_Optimizer_Model_attributes(
    uf::MOI.Utilities.UniversalFallback,
    model::MOI.ModelLike,
    attr::Union{MOI.AbstractOptimizerAttribute,MOI.AbstractModelAttribute},
    list::Union{MOI.ListOfOptimizerAttributesSet,MOI.ListOfModelAttributesSet},
)
    @test !MOI.supports(model, attr)
    @test MOI.supports(uf, attr)
    @test isempty(MOI.get(uf, list))
    MOI.set(uf, attr, 0)
    @test MOI.get(uf, attr) == 0
    @test MOI.get(uf, list) == [attr]
    MOI.set(uf, attr, nothing)
    @test isempty(MOI.get(uf, list))
    MOI.set(uf, attr, 0)
    return
end

function _test_Variable_Constraint_attributes(
    uf::MOI.Utilities.UniversalFallback,
    model::MOI.ModelLike,
    attr::Union{MOI.AbstractVariableAttribute,MOI.AbstractConstraintAttribute},
    listattr::Union{
        MOI.ListOfVariableAttributesSet,
        MOI.ListOfConstraintAttributesSet,
    },
    I::Type{<:MOI.Index},
    addfun,
    x,
    y,
    z,
)
    @test !MOI.supports(model, attr, I)
    @test MOI.supports(uf, attr, I)
    @test isempty(MOI.get(uf, listattr))
    MOI.set(uf, attr, [x, y], [2, 0])
    @test MOI.get(uf, listattr) == [attr]
    MOI.set(uf, attr, x, nothing)
    MOI.set(uf, attr, y, nothing)
    @test isempty(MOI.get(uf, listattr))
    MOI.set(uf, attr, [x, y], [2, 0])
    @test MOI.get(uf, attr, z) === nothing
    @test !MOI.is_empty(uf)
    @test MOI.get(uf, listattr) == [attr]
    MOI.set(uf, attr, z, 5)
    @test MOI.get(uf, attr, y) == 0
    @test MOI.get(uf, attr, [z, x]) == [5, 2]
    @test MOI.get(uf, listattr) == [attr]
    u = addfun(uf)
    @test MOI.get(uf, attr, u) === nothing
    @test MOI.get(uf, listattr) == [attr]
    MOI.set(uf, attr, u, 8)
    @test MOI.get(uf, listattr) == [attr]
    w = addfun(uf)
    @test MOI.get(uf, listattr) == [attr]
    @test MOI.get(uf, attr, w) === nothing
    @test MOI.is_valid(uf, u)
    MOI.delete(uf, u)
    @test !MOI.is_valid(uf, u)
    @test_throws MOI.InvalidIndex{typeof(u)} MOI.delete(uf, u)
    @test MOI.get(uf, listattr) == [attr]
    MOI.set(uf, attr, [w, z], [9, 4])
    @test MOI.get(uf, listattr) == [attr]
    @test MOI.get(uf, attr, w) == 9
    @test MOI.get(uf, attr, x) == 2
    @test MOI.get(uf, attr, z) == 4
    @test MOI.get(uf, attr, y) == 0
    return
end

function test_optimizer_attributes()
    model = ModelForUniversalFallback{Float64}()
    uf = MOI.Utilities.UniversalFallback(model)
    _test_Optimizer_Model_attributes(
        uf,
        model,
        UnknownOptimizerAttribute(),
        MOI.ListOfOptimizerAttributesSet(),
    )
    return
end

function test_model_attributes()
    model = ModelForUniversalFallback{Float64}()
    uf = MOI.Utilities.UniversalFallback(model)
    _test_Optimizer_Model_attributes(
        uf,
        model,
        MOI.Test.UnknownModelAttribute(),
        MOI.ListOfModelAttributesSet(),
    )
    # Test that emptying the uf get's rid of the model attributes
    @test !MOI.is_empty(uf)
    MOI.empty!(uf)
    @test MOI.is_empty(uf)
    return
end

function test_variable_attributes()
    model = ModelForUniversalFallback{Float64}()
    uf = MOI.Utilities.UniversalFallback(model)
    _test_Variable_Constraint_attributes(
        uf,
        model,
        MOI.Test.UnknownVariableAttribute(),
        MOI.ListOfVariableAttributesSet(),
        MOI.VariableIndex,
        MOI.add_variable,
        MOI.add_variables(uf, 3)...,
    )
    return
end

function test_supported_objective_attributes()
    model = ModelForUniversalFallback{Float64}()
    uf = MOI.Utilities.UniversalFallback(model)
    x, y = MOI.add_variables(uf, 2)
    attr = MOI.ObjectiveFunction{MOI.VariableIndex}()
    @test MOI.supports(model, attr)
    MOI.set(uf, attr, x)
    @test MOI.get(uf, attr) ≈ x
    MOI.set(uf, attr, y)
    @test MOI.get(uf, attr) ≈ y
    return
end

function test_unsupported_objective_attributes()
    model = ModelForUniversalFallback{Float64}()
    uf = MOI.Utilities.UniversalFallback(model)
    x, y = MOI.add_variables(uf, 2)
    attr = MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}()
    @test !MOI.supports(model, attr)
    @test MOI.supports(uf, attr)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0)
    MOI.set(uf, attr, f)
    @test MOI.get(uf, attr) ≈ f
    MOI.modify(uf, attr, MOI.ScalarCoefficientChange(y, 1.0))
    new_obj = MOI.ScalarAffineFunction(
        [MOI.ScalarAffineTerm(1.0, x), MOI.ScalarAffineTerm(1.0, y)],
        0.0,
    )
    @test MOI.get(uf, attr) ≈ new_obj
    @test attr in MOI.get(uf, MOI.ListOfModelAttributesSet())
    @test MOI.get(uf, MOI.ObjectiveFunctionType()) ==
          MOI.ScalarAffineFunction{Float64}
    return
end

function test_supported_constraint_attributes()
    model = ModelForUniversalFallback{Float64}()
    uf = MOI.Utilities.UniversalFallback(model)
    x, y, z = MOI.add_variables(uf, 3)
    function _add_constraint(uf, x::MOI.VariableIndex, ub::Float64)
        return MOI.add_constraint(
            uf,
            MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
            MOI.LessThan(ub),
        )
    end
    cx = _add_constraint(uf, x, 0.0)
    cy = _add_constraint(uf, y, 1.0)
    cz = _add_constraint(uf, z, 2.0)
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}
    _test_Variable_Constraint_attributes(
        uf,
        model,
        MOI.Test.UnknownConstraintAttribute(),
        MOI.ListOfConstraintAttributesSet{F,S}(),
        MOI.ConstraintIndex{F,S},
        uf -> _add_constraint(uf, x, 0.0),
        cx,
        cy,
        cz,
    )
    fy = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, y)], 0.0)
    MOI.set(uf, MOI.ConstraintFunction(), cx, fy)
    @test MOI.get(uf, MOI.ConstraintFunction(), cx) ≈ fy
    @test MOI.get(uf, MOI.CanonicalConstraintFunction(), cx) ≈ fy
    @test MOI.Utilities.is_canonical(
        MOI.get(uf, MOI.CanonicalConstraintFunction(), cx),
    )
    @test MOI.supports(uf, MOI.ConstraintName(), typeof(cx))
    MOI.set(uf, MOI.ConstraintName(), cx, "LessThan")
    @test MOI.get(uf, MOI.ConstraintName(), cx) == "LessThan"
    @test MOI.get(uf, typeof(cx), "LessThan") == cx
    MOI.delete(uf, cx)
    @test MOI.get(uf, typeof(cx), "LessThan") === nothing
    return
end

function test_unsupported_constraint_attributes()
    model = ModelForUniversalFallback{Float64}()
    uf = MOI.Utilities.UniversalFallback(model)
    x, y, z = MOI.add_variables(uf, 3)
    function _add_constraint(uf, x::MOI.VariableIndex, ub::Float64)
        return MOI.add_constraint(
            uf,
            MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
            MOI.EqualTo(ub),
        )
    end
    cx = _add_constraint(uf, x, 0.0)
    cy = _add_constraint(uf, y, 1.0)
    cz = _add_constraint(uf, z, 2.0)
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    _test_Variable_Constraint_attributes(
        uf,
        model,
        MOI.Test.UnknownConstraintAttribute(),
        MOI.ListOfConstraintAttributesSet{F,S}(),
        MOI.ConstraintIndex{F,S},
        uf -> _add_constraint(uf, x, 0.0),
        cx,
        cy,
        cz,
    )
    fy = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, y)], 0.0)
    MOI.set(uf, MOI.ConstraintFunction(), cx, fy)
    @test MOI.get(uf, MOI.ConstraintFunction(), cx) ≈ fy
    @test MOI.get(uf, MOI.CanonicalConstraintFunction(), cx) ≈ fy
    @test MOI.Utilities.is_canonical(
        MOI.get(uf, MOI.CanonicalConstraintFunction(), cx),
    )
    @test MOI.supports(uf, MOI.ConstraintName(), typeof(cx))
    MOI.set(uf, MOI.ConstraintName(), cx, "EqualTo")
    @test MOI.get(uf, MOI.ConstraintName(), cx) == "EqualTo"
    @test MOI.get(uf, typeof(cx), "EqualTo") == cx
    MOI.delete(uf, cx)
    @test MOI.get(uf, typeof(cx), "EqualTo") === nothing
    return
end

function test_duplicate_names()
    model = ModelForUniversalFallback{Float64}()
    uf = MOI.Utilities.UniversalFallback(model)
    x = MOI.add_variable(uf)
    # These are both intercepted by the fallback.
    f = MOI.ScalarAffineFunction{Float64}([MOI.ScalarAffineTerm(1.0, x)], 0.0)
    x_eq = MOI.add_constraint(uf, f, MOI.EqualTo(1.0))
    x_gt = MOI.add_constraint(uf, f, MOI.GreaterThan(1.0))
    MOI.set(uf, MOI.ConstraintName(), x_eq, "a name")
    MOI.set(uf, MOI.ConstraintName(), x_gt, "a name")
    @test_throws Exception MOI.get(
        uf,
        MOI.ConstraintIndex{
            MOI.ScalarAffineFunction{Float64},
            MOI.EqualTo{Float64},
        },
        "a name",
    )
    @test_throws Exception MOI.get(uf, MOI.ConstraintIndex, "a name")
    return
end

function test_deterministic_constraint_ordering()
    model = ModelForUniversalFallback{Float64}()
    uf = MOI.Utilities.UniversalFallback(model)
    set1 = MOI.EqualTo(1.0)
    set2 = MOI.GreaterThan(1.0)
    F = MOI.ScalarAffineFunction{Float64}
    for sets in [[set1, set2], [set2, set1]]
        model = ModelForUniversalFallback{Float64}()
        uf = MOI.Utilities.UniversalFallback(model)
        x = MOI.add_variable(uf)
        y = MOI.add_variable(uf)
        fx = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0)
        fy = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, y)], 0.0)
        MOI.add_constraint(uf, fx, sets[1])
        MOI.add_constraint(uf, fx, sets[2])
        MOI.add_constraint(uf, fy, sets[1])
        MOI.add_constraint(uf, fy, sets[2])
        # check that the constraint types are in the order they were added in
        @test MOI.get(uf, MOI.ListOfConstraintTypesPresent()) ==
              [(F, typeof(sets[1])), (F, typeof(sets[2]))]
        # check that the constraints given the constraint type are in the order
        # they were added in
        for set in sets
            @test MOI.get(uf, MOI.ListOfConstraintIndices{F,typeof(set)}()) == [
                MOI.ConstraintIndex{F,typeof(set)}(1),
                MOI.ConstraintIndex{F,typeof(set)}(2),
            ]
        end
    end
    return
end

function test_missing_attribute()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    @test MOI.get(model, MOI.Test.UnknownModelAttribute()) === nothing
    @test MOI.get(model, MOI.TimeLimitSec()) === nothing
    @test MOI.get(model, MOI.ObjectiveLimit()) === nothing
    return
end

function test_throw_unsupported_model_attribute()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    attr = MOI.Test.UnknownModelAttribute()
    MOI.set(model, attr, 1)
    err = MOI.UnsupportedAttribute(attr)
    @test_throws err MOI.Utilities.throw_unsupported(model)
    MOI.Utilities.throw_unsupported(
        model,
        excluded_attributes = MOI.AnyAttribute[attr],
    )
    return
end

function test_throw_unsupported_variable_attribute()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    attr = MOI.Test.UnknownVariableAttribute()
    MOI.set(model, attr, x, 1)
    err = MOI.UnsupportedAttribute(attr)
    @test_throws err MOI.Utilities.throw_unsupported(model)
    MOI.Utilities.throw_unsupported(
        model,
        excluded_attributes = MOI.AnyAttribute[attr],
    )
    return
end

function test_throw_unsupported_constraint_attribute()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.EqualTo(1.0))
    attr = MOI.Test.UnknownConstraintAttribute()
    MOI.set(model, attr, c, 1)
    err = MOI.UnsupportedAttribute(attr)
    @test_throws err MOI.Utilities.throw_unsupported(model)
    MOI.Utilities.throw_unsupported(
        model,
        excluded_attributes = MOI.AnyAttribute[attr],
    )
    return
end

function test_throw_unsupported_variable_constraint()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    set = MOI.Test.UnknownScalarSet(1.0)
    c = MOI.add_constraint(model, x, set)
    @test_throws(
        MOI.UnsupportedConstraint{typeof(x),typeof(set)}(),
        MOI.Utilities.throw_unsupported(model),
    )
    MOI.delete(model, c)
    @test MOI.Utilities.throw_unsupported(model) === nothing
    return
end

function test_throw_unsupported_affine_constraint()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variable(model)
    func = 2.0x
    set = MOI.Test.UnknownScalarSet(1.0)
    c = MOI.add_constraint(model, func, set)
    @test_throws(
        MOI.UnsupportedConstraint{typeof(func),typeof(set)}(),
        MOI.Utilities.throw_unsupported(model),
    )
    MOI.delete(model, c)
    @test MOI.Utilities.throw_unsupported(model) === nothing
    return
end

function test_ListOfVariablesWithAttributeSet()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.VariableName(), x[1], "x")
    # Passed through to Model with no special support
    attr = MOI.ListOfVariablesWithAttributeSet(MOI.VariableName())
    @test MOI.get(model, attr) == x
    # Handled by UniversalFallback
    attr = MOI.ListOfVariablesWithAttributeSet(MOI.VariablePrimalStart())
    # no attributes set
    @test MOI.get(model, attr) == MOI.VariableIndex[]
    # one attribute set
    MOI.set(model, MOI.VariablePrimalStart(), x[2], 1.0)
    @test MOI.get(model, attr) == [x[2]]
    return
end

function test_ListOfConstraintsWithAttributeSet()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    x = MOI.add_variables(model, 2)
    c = MOI.add_constraint.(model, 1.0 * x, MOI.EqualTo(1.0))
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    MOI.set(model, MOI.ConstraintName(), c[1], "c")
    # Passed through to Model with no special support
    attr = MOI.ListOfConstraintsWithAttributeSet{F,S}(MOI.ConstraintName())
    @test MOI.get(model, attr) == c
    # Handled by UniversalFallback
    attr =
        MOI.ListOfConstraintsWithAttributeSet{F,S}(MOI.ConstraintPrimalStart())
    # no attributes set
    @test MOI.get(model, attr) == MOI.ConstraintIndex{F,S}[]
    # one attribute set
    MOI.set(model, MOI.ConstraintPrimalStart(), c[2], 1.0)
    @test MOI.get(model, attr) == [c[2]]
    return
end

function test_delete_ci_attribute()
    model =
        MOI.Utilities.UniversalFallback(ModelForUniversalFallback{Float64}())
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.VectorOfVariables([x]),
        MOI.Nonnegatives(1),
    )
    MOI.set(model, MOI.ConstraintPrimalStart(), c, [1.0])
    @test model.conattr[MOI.ConstraintPrimalStart()][c] == [1.0]
    MOI.delete(model, x)
    @test !haskey(model.conattr[MOI.ConstraintPrimalStart()], c)
    # Vector
    model =
        MOI.Utilities.UniversalFallback(ModelForUniversalFallback{Float64}())
    x = MOI.add_variable(model)
    c = MOI.add_constraint(
        model,
        MOI.VectorOfVariables([x]),
        MOI.Nonnegatives(1),
    )
    MOI.set(model, MOI.ConstraintPrimalStart(), c, [1.0])
    @test model.conattr[MOI.ConstraintPrimalStart()][c] == [1.0]
    MOI.delete(model, [x])
    @test !haskey(model.conattr[MOI.ConstraintPrimalStart()], c)
    return
end

function test_set_inner_constraint_attribute()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Utilities.UniversalFallback(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    MOI.set(model, MOI.ConstraintPrimalStart(), c, 1.0)
    @test MOI.get(model, MOI.ConstraintPrimalStart(), c) == 1.0
    return
end

end  # module

TestUniversalFallback.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

const INFINITY = Inf
const INVALID_NODE_INDEX = -1

abstract type AbstractNode end

"""
    VariableNode(index::Int)

A node in [`Graph`](@ref) representing a variable constrained on creation.
"""
struct VariableNode <: AbstractNode
    index::Int
end

"""
    ConstraintNode(index::Int)

A node in [`Graph`](@ref) representing a constraint.
"""
struct ConstraintNode <: AbstractNode
    index::Int
end

"""
    ObjectiveNode(index::Int)

A node in [`Graph`](@ref) representing an objective function.
"""
struct ObjectiveNode <: AbstractNode
    index::Int
end

abstract type AbstractEdge end

"""
    Edge(
        bridge_index::Int,
        added_variables::Vector{VariableNode},
        added_constraints::Vector{ConstraintNode},
        cost::Float64 = 1.0,
    )

Return a new datastructure representing an edge in [`Graph`](@ref) that starts
at a [`VariableNode`](@ref) or a [`ConstraintNode`](@ref).
"""
struct Edge <: AbstractEdge
    bridge_index::Int
    added_variables::Vector{VariableNode}
    added_constraints::Vector{ConstraintNode}
    cost::Float64
    # TODO remove in MOI v2
    function Edge(
        bridge_index::Int,
        added_variables::Vector{VariableNode},
        added_constraints::Vector{ConstraintNode},
        cost::Float64 = 1.0,
    )
        return new(bridge_index, added_variables, added_constraints, cost)
    end
end

"""
    ObjectiveEdge(
        bridge_index::Int,
        added_variables::Vector{VariableNode},
        added_constraints::Vector{ConstraintNode},
    )

Return a new datastructure representing an edge in [`Graph`](@ref) that starts
at an [`ObjectiveNode`](@ref).
"""
struct ObjectiveEdge <: AbstractEdge
    bridge_index::Int
    added_variables::Vector{VariableNode}
    added_constraints::Vector{ConstraintNode}
    added_objective::ObjectiveNode
    cost::Float64
    # TODO remove in MOI v2
    function ObjectiveEdge(
        bridge_index::Int,
        added_variables::Vector{VariableNode},
        added_constraints::Vector{ConstraintNode},
        added_objective::ObjectiveNode,
        cost::Float64 = 1.0,
    )
        return new(
            bridge_index,
            added_variables,
            added_constraints,
            added_objective,
            cost,
        )
    end
end

"""
    Graph()

A type-stable datastructure for computing the shortest hyperpath problem.

## Nodes

There are three types of nodes in the graph:

  * [`VariableNode`](@ref)
  * [`ConstraintNode`](@ref)
  * [`ObjectiveNode`](@ref)

Add nodes to the graph using [`add_node`](@ref).

## Edges

There are two types of edges in the graph:

  * [`Edge`](@ref)
  * [`ObjectiveEdge`](@ref)

Add edges to the graph using [`add_edge`](@ref).

For the ability to add a variable constrained  on creation as a free variable
followed by a constraint, use [`set_variable_constraint_node`](@ref).

## Optimal hyper-edges

Use [`bridge_index`](@ref) to compute the minimum-cost bridge leaving a node.

Note that [`bridge_index`](@ref) lazy runs a Bellman-Ford algorithm to compute
the set of minimum cost edges. Thus, the first call to [`bridge_index`](@ref)
after adding new nodes or edges will take longer than subsequent calls.
"""
mutable struct Graph
    variable_edges::Vector{Vector{Edge}}
    variable_constraint_node::Vector{ConstraintNode}
    variable_constraint_cost::Vector{Int}
    # variable node index -> Sum of costs of bridges that need to be used
    variable_dist::Vector{Float64}
    # variable node index -> Index of bridge to be used
    variable_best::Vector{Int}
    variable_last_correct::Int
    constraint_edges::Vector{Vector{Edge}}
    # constraint node index -> Sum of costs of bridges that need to be used
    constraint_dist::Vector{Float64}
    # constraint node index -> Index of bridge to be used
    constraint_best::Vector{Int}
    constraint_last_correct::Int
    objective_edges::Vector{Vector{ObjectiveEdge}}
    # objective node index -> Sum of costs of bridges that need to be used
    objective_dist::Vector{Float64}
    # objective node index -> Index of bridge to be used
    objective_best::Vector{Int}
    objective_last_correct::Int

    function Graph()
        return new(
            Vector{Edge}[],
            ConstraintNode[],
            Int[],
            Float64[],
            Int[],
            0,
            Vector{Edge}[],
            Float64[],
            Int[],
            0,
            Vector{ObjectiveEdge}[],
            Float64[],
            Int[],
            0,
        )
    end
end

function Base.show(io::IO, graph::Graph)
    print(io, "Bridge graph with ")
    print(io, length(graph.variable_best), " variable nodes, ")
    print(io, length(graph.constraint_best), " constraint nodes and ")
    print(io, length(graph.objective_best), " objective nodes.")
    return
end

# After `add_bridge(b, BT)`, some constrained variables `(S,)` in
# `keys(b.variable_best)` or constraints `(F, S)` in `keys(b.constraint_best)`
# or `(F,)` in `keys(b.objective_best)` may be bridged
# with less bridges than `b.variable_dist[(S,)]`,
# `b.constraint_dist[(F, S)]` or `b.objective_dist[(F,)]` using `BT`.
# We could either recompute the distance from every node or clear the
# dictionary so that the distance is computed lazily at the next `supports_constraint`
# call. We prefer clearing the dictionaries so as this is called for each
# bridge added and recomputing the distance for each bridge would be a wase
# if several bridges are added consecutively.
function Base.empty!(graph::Graph)
    empty!(graph.variable_edges)
    empty!(graph.variable_constraint_node)
    empty!(graph.variable_constraint_cost)
    empty!(graph.variable_dist)
    empty!(graph.variable_best)
    graph.variable_last_correct = 0
    empty!(graph.constraint_edges)
    empty!(graph.constraint_dist)
    empty!(graph.constraint_best)
    graph.constraint_last_correct = 0
    empty!(graph.objective_edges)
    empty!(graph.objective_dist)
    empty!(graph.objective_best)
    graph.objective_last_correct = 0
    return
end

"""
    add_edge(graph::Graph, node::VariableNode, edge::Edge)::Nothing
    add_edge(graph::Graph, node::ConstraintNode, edge::Edge)::Nothing
    add_edge(graph::Graph, node::ObjectiveNode, edge::ObjectiveEdge)::Nothing

Add `edge` to `graph`, where `edge` starts at `node` and connects to the nodes
defined in `edge`.
"""
function add_edge(graph::Graph, node::VariableNode, edge::Edge)
    push!(graph.variable_edges[node.index], edge)
    return
end

function add_edge(graph::Graph, node::ConstraintNode, edge::Edge)
    push!(graph.constraint_edges[node.index], edge)
    return
end

function add_edge(graph::Graph, node::ObjectiveNode, edge::ObjectiveEdge)
    push!(graph.objective_edges[node.index], edge)
    return
end

"""
    add_node(graph::Graph, ::Type{VariableNode})::VariableNode
    add_node(graph::Graph, ::Type{ConstraintNode})::ConstraintNode
    add_node(graph::Graph, ::Type{ObjectiveNode})::ObjectiveNode

Add a new node to `graph`.
"""
function add_node(graph::Graph, ::Type{VariableNode})
    push!(graph.variable_edges, Edge[])
    # Use an invalid index so that the code errors instead return something
    # incorrect in case `set_variable_constraint_node` is not called.
    push!(graph.variable_constraint_node, ConstraintNode(INVALID_NODE_INDEX))
    push!(graph.variable_constraint_cost, 0)
    push!(graph.variable_dist, INFINITY)
    push!(graph.variable_best, 0)
    return VariableNode(length(graph.variable_best))
end

function add_node(graph::Graph, ::Type{ConstraintNode})
    push!(graph.constraint_edges, Edge[])
    push!(graph.constraint_dist, INFINITY)
    push!(graph.constraint_best, 0)
    return ConstraintNode(length(graph.constraint_best))
end

function add_node(graph::Graph, ::Type{ObjectiveNode})
    push!(graph.objective_edges, ObjectiveEdge[])
    push!(graph.objective_dist, INFINITY)
    push!(graph.objective_best, 0)
    return ObjectiveNode(length(graph.objective_best))
end

"""
    set_variable_constraint_node(
        graph::Graph,
        variable_node::VariableNode,
        constraint_node::ConstraintNode,
        cost::Int,
    )

As an alternative to `variable_node`, add a virtual edge to `graph` that
represents adding a free variable, followed by a constraint of type
`constraint_node`, with bridging cost `cost`.

## Why is this needed?

Variables can either be added as a variable constrained on creation, or as a
free variable which then has a constraint added to it.
"""
function set_variable_constraint_node(
    graph::Graph,
    variable_node::VariableNode,
    constraint_node::ConstraintNode,
    cost::Int,
)
    graph.variable_constraint_node[variable_node.index] = constraint_node
    graph.variable_constraint_cost[variable_node.index] = cost
    return
end

function bridging_cost(graph::Graph, node::AbstractNode)
    _compute_bellman_ford(graph)
    return _dist(graph, node)
end

"""
    bridge_index(graph::Graph, node::VariableNode)::Int
    bridge_index(graph::Graph, node::ConstraintNode)::Int
    bridge_index(graph::Graph, node::ObjectiveNode)::Int

Return the optimal index of the bridge to chose from `node`.
"""
function bridge_index(graph::Graph, node::VariableNode)
    _compute_bellman_ford(graph)
    return graph.variable_best[node.index]
end

function bridge_index(graph::Graph, node::ConstraintNode)
    _compute_bellman_ford(graph)
    return graph.constraint_best[node.index]
end

function bridge_index(graph::Graph, node::ObjectiveNode)
    _compute_bellman_ford(graph)
    return graph.objective_best[node.index]
end

"""
    is_variable_edge_best(graph::Graph, node::VariableNode)::Bool

Return a `Bool` indicating whether `node` should be added as a variable
constrained on creation, or as a free variable followed by a constraint.
"""
function is_variable_edge_best(graph::Graph, node::VariableNode)
    _compute_bellman_ford(graph)
    return graph.variable_dist[node.index] == _dist(graph, node)
end

function _updated_dist(
    graph::Graph,
    current::Float64,
    edges::Vector{<:AbstractEdge},
)
    bridge_index = 0
    for edge in edges
        dist = _dist(graph, edge)
        if dist == INFINITY
            continue
        end
        dist += edge.cost
        if dist < current
            current = dist
            bridge_index = edge.bridge_index
        end
    end
    return current, bridge_index
end

function _compute_bellman_ford(graph::Graph)
    # Has a distance changed in the last iteration?
    changed = true
    while changed
        changed = false
        for i in (graph.variable_last_correct+1):length(graph.variable_best)
            dist, best = _updated_dist(
                graph,
                graph.variable_dist[i],
                graph.variable_edges[i],
            )
            if !iszero(best)
                graph.variable_dist[i] = dist
                graph.variable_best[i] = best
                changed = true
            end
        end
        for i in (graph.constraint_last_correct+1):length(graph.constraint_best)
            dist, best = _updated_dist(
                graph,
                graph.constraint_dist[i],
                graph.constraint_edges[i],
            )
            if !iszero(best)
                graph.constraint_dist[i] = dist
                graph.constraint_best[i] = best
                changed = true
            end
        end
        for i in (graph.objective_last_correct+1):length(graph.objective_best)
            dist, best = _updated_dist(
                graph,
                graph.objective_dist[i],
                graph.objective_edges[i],
            )
            if !iszero(best)
                graph.objective_dist[i] = dist
                graph.objective_best[i] = best
                changed = true
            end
        end
    end
    graph.variable_last_correct = length(graph.variable_best)
    graph.constraint_last_correct = length(graph.constraint_best)
    graph.objective_last_correct = length(graph.objective_best)
    return
end

function _dist(graph::Graph, node::VariableNode)
    if iszero(node.index)
        return 0
    end
    # This is the cost of adding a constrained variable
    dist_as_variable = graph.variable_dist[node.index]
    # This is the cost of adding the constraint, if we were to add it.
    dist_as_constraint = INFINITY
    # If free variables are bridged but the functionize bridge was not
    # added, constraint_node is `ConstraintNode(INVALID_NODE_INDEX)`.
    constraint_node = graph.variable_constraint_node[node.index]
    if constraint_node.index != INVALID_NODE_INDEX
        dist_as_constraint = _dist(graph, constraint_node)
        if dist_as_constraint != INFINITY
            dist_as_constraint += graph.variable_constraint_cost[node.index]
        end
    end
    if dist_as_constraint == INFINITY
        return dist_as_variable
    elseif dist_as_variable == INFINITY
        return dist_as_constraint
    end
    return min(dist_as_variable, dist_as_constraint)
end

function _dist(graph::Graph, node::ConstraintNode)
    return iszero(node.index) ? 0 : graph.constraint_dist[node.index]
end

function _dist(graph::Graph, node::ObjectiveNode)
    return iszero(node.index) ? 0 : graph.objective_dist[node.index]
end

function _dist(graph::Graph, nodes::Vector{<:AbstractNode})
    dist = 0
    for node in nodes
        d = _dist(graph, node)
        if d == INFINITY
            return INFINITY
        end
        dist += d
    end
    return dist
end

function _dist(graph::Graph, edge::Edge)
    dist_var = _dist(graph, edge.added_variables)
    if dist_var == INFINITY
        return INFINITY
    end
    dist_con = _dist(graph, edge.added_constraints)
    if dist_con == INFINITY
        return INFINITY
    end
    return dist_var + dist_con
end

function _dist(graph::Graph, edge::ObjectiveEdge)
    dist_obj = _dist(graph, edge.added_objective)
    if dist_obj == INFINITY
        return INFINITY
    end
    dist_var = _dist(graph, edge.added_variables)
    if dist_var == INFINITY
        return INFINITY
    end
    dist_con = _dist(graph, edge.added_constraints)
    if dist_con == INFINITY
        return INFINITY
    end
    return dist_obj + dist_var + dist_con
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

using BenchmarkTools
import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

# Model similar to SDPA format, it gives a good example because it does not
# support a lot hence need a lot of bridges
MOIU.@model(
    SDPAModel,
    (),
    (MOI.EqualTo,),
    (MOI.Nonnegatives, MOI.PositiveSemidefiniteConeTriangle),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (MOI.VectorOfVariables,),
    ()
)
function MOI.supports_constraint(
    ::SDPAModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.GreaterThan{T}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::SDPAModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.LessThan{T}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::SDPAModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.EqualTo{T}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::SDPAModel{T},
    ::Type{MOI.VariableIndex},
    ::Type{MOI.Interval{T}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::SDPAModel,
    ::Type{MOI.VectorOfVariables},
    ::Type{MOI.Reals},
)
    return false
end

function MOI.supports(
    ::SDPAModel{T},
    ::MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}},
) where {T}
    return false
end
MOI.supports(::SDPAModel, ::MOI.ObjectiveFunction{MOI.VariableIndex}) = false

function interval_constraint()
    model = SDPAModel{Float64}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, Float64)
    F = MOI.ScalarAffineFunction{Float64}
    S = MOI.Interval{Float64}
    MOI.Bridges.bridge_index(bridged, F, S)
    display(@benchmark begin
        MOI.Bridges._reset_bridge_graph($bridged)
        MOI.Bridges.node($bridged, $F, $S)
    end)
    return display(@benchmark begin
        MOI.Bridges._reset_bridge_graph($bridged)
        MOI.Bridges.bridge_index($bridged, $F, $S)
    end)
end

interval_constraint()

function quadratic_objective()
    model = SDPAModel{Float64}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, Float64)
    F = MOI.ScalarQuadraticFunction{Float64}
    MOI.Bridges.bridge_index(bridged, F)
    display(@benchmark begin
        MOI.Bridges._reset_bridge_graph($bridged)
        MOI.Bridges.node($bridged, $F)
    end)
    return display(@benchmark begin
        MOI.Bridges._reset_bridge_graph($bridged)
        MOI.Bridges.bridge_index($bridged, $F)
    end)
end

display(quadratic_objective())

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestVariableContainer

using Test
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_empty()
    a = MOI.Utilities.VariablesContainer([0x0000, 0x0000], [1, 2], [3, 4])
    MOI.empty!(a)
    @test MOI.is_empty(a)
    return
end

function test_resize()
    a = MOI.Utilities.VariablesContainer([0x0000, 0x0000], [1, 2], [3, 4])
    @test length(a.set_mask) == 2
    @test length(a.lower) == 2
    @test length(a.upper) == 2
    resize!(a, 4)
    @test length(a.set_mask) == 4
    @test length(a.lower) == 4
    @test length(a.upper) == 4
    return
end

function test_add_variable()
    a = MOI.Utilities.VariablesContainer{Int}()
    MOI.add_variable(a)
    @test a == MOI.Utilities.VariablesContainer{Int}([0x0000], [0], [0])
    a = MOI.Utilities.VariablesContainer{Float64}()
    MOI.add_variable(a)
    @test a ==
          MOI.Utilities.VariablesContainer{Float64}([0x0000], [-Inf], [Inf])
    return
end

function test__flag_to_set_type()
    T = Int
    @test_throws AssertionError MOI.Utilities._flag_to_set_type(0x0011, T)
    @test MOI.Utilities._flag_to_set_type(0x0010, T) == MOI.Integer
    @test MOI.Utilities._flag_to_set_type(0x0020, T) == MOI.ZeroOne
    return
end

function test_add_constraint()
    a = MOI.Utilities.VariablesContainer{Int}()
    x = MOI.add_variable(a)
    @test a == MOI.Utilities.VariablesContainer{Int}([0x0000], Int[0], Int[0])
    MOI.add_constraint(a, x, MOI.GreaterThan(3))
    @test a == MOI.Utilities.VariablesContainer{Int}([0x0002], [3], [0])
    MOI.add_constraint(a, x, MOI.LessThan(4))
    @test a == MOI.Utilities.VariablesContainer{Int}([0x0006], [3], [4])
    return
end

function test_add_constraint_LowerBoundAlreadySet()
    a = MOI.Utilities.VariablesContainer{Int}()
    x = MOI.add_variable(a)
    MOI.add_constraint(a, x, MOI.GreaterThan(3))
    @test_throws(
        MOI.LowerBoundAlreadySet{MOI.GreaterThan{Int},MOI.GreaterThan{Int}},
        MOI.add_constraint(a, x, MOI.GreaterThan(3)),
    )
    return
end

function test_add_constraint_UpperBoundAlreadySet()
    a = MOI.Utilities.VariablesContainer{Int}()
    x = MOI.add_variable(a)
    MOI.add_constraint(a, x, MOI.LessThan(3))
    @test_throws(
        MOI.UpperBoundAlreadySet{MOI.LessThan{Int},MOI.LessThan{Int}},
        MOI.add_constraint(a, x, MOI.LessThan(3)),
    )
    return
end

function test_delete_constraint_LessThan()
    a = MOI.Utilities.VariablesContainer{Int}()
    x = MOI.add_variable(a)
    c = MOI.add_constraint(a, x, MOI.LessThan(3))
    @test MOI.is_valid(a, c)
    MOI.delete(a, c)
    @test !MOI.is_valid(a, c)
    ci = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Zeros}(1)
    @test !MOI.is_valid(a, ci)
    return
end

function test_delete_variable()
    a = MOI.Utilities.VariablesContainer{Int}()
    x = MOI.add_variable(a)
    @test a == MOI.Utilities.VariablesContainer{Int}([0x0000], Int[0], Int[0])
    c = MOI.add_constraint(a, x, MOI.LessThan(3))
    MOI.delete(a, x)
    @test a == MOI.Utilities.VariablesContainer{Int}([0x8000], Int[0], Int[3])
    return
end

function test_delete_constraint_GreaterThan()
    a = MOI.Utilities.VariablesContainer{Int}()
    x = MOI.add_variable(a)
    c = MOI.add_constraint(a, x, MOI.GreaterThan(3))
    @test MOI.is_valid(a, c)
    MOI.delete(a, c)
    @test !MOI.is_valid(a, c)
    return
end

function test_set_ConstraintSet()
    a = MOI.Utilities.VariablesContainer{Int}()
    x = MOI.add_variable(a)
    @test a == MOI.Utilities.VariablesContainer{Int}([0x0000], Int[0], Int[0])
    c = MOI.add_constraint(a, x, MOI.GreaterThan(3))
    @test a == MOI.Utilities.VariablesContainer{Int}([0x0002], Int[3], Int[0])
    MOI.set(a, MOI.ConstraintSet(), c, MOI.GreaterThan(2))
    @test a == MOI.Utilities.VariablesContainer{Int}([0x0002], Int[2], Int[0])
    return
end

function test_NumberOfConstraints()
    b = MOI.Utilities.VariablesContainer(
        [0x0008, 0x0002, 0x0004, 0x0006],
        [1.0, 3.0, -Inf, -1.0],
        [2.0, Inf, 4.0, 1.0],
    )
    get(S) = MOI.get(b, MOI.NumberOfConstraints{MOI.VariableIndex,S}())
    @test get(MOI.ZeroOne) == 0
    @test get(MOI.GreaterThan{Float64}) == 2
    @test get(MOI.LessThan{Float64}) == 2
    @test get(MOI.Interval{Float64}) == 1
    return
end

function test_ListOfConstraintTypesPresent()
    b = MOI.Utilities.VariablesContainer(
        [0x0008, 0x0002, 0x0004, 0x0006],
        [1.0, 3.0, -Inf, -1.0],
        [2.0, Inf, 4.0, 1.0],
    )
    @test MOI.get(b, MOI.ListOfConstraintTypesPresent()) == [
        (MOI.VariableIndex, MOI.GreaterThan{Float64}),
        (MOI.VariableIndex, MOI.LessThan{Float64}),
        (MOI.VariableIndex, MOI.Interval{Float64}),
    ]
    return
end

function test_ListOfConstraintIndices()
    b = MOI.Utilities.VariablesContainer{Float64}(
        [0x0008, 0x0002, 0x0004, 0x0006],
        [1.0, 3.0, -Inf, -1.0],
        [2.0, Inf, 4.0, 1.0],
    )
    get(S) = MOI.get(b, MOI.ListOfConstraintIndices{MOI.VariableIndex,S}())
    @test get(MOI.ZeroOne) == []
    @test get(MOI.GreaterThan{Float64}) == [
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}}(2),
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}}(4),
    ]
    @test get(MOI.LessThan{Float64}) ==
          MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}}.([3, 4])
    @test get(MOI.Interval{Float64}) ==
          [MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Float64}}(1)]
    return
end

###
### Hyperrectangle
###

function test_Hyperrectangle_equal()
    a = MOI.Utilities.Hyperrectangle([1, 2], [3, 4])
    b = MOI.Utilities.Hyperrectangle([1.0, 2.0], [3.0, 4.0])
    c = MOI.Utilities.Hyperrectangle([1.0, 3.0], [3.0, 4.0])
    d = MOI.Utilities.Hyperrectangle([1.0, 2.0], [3.0, 5.0])
    @test a == a
    @test a == b
    @test a != c
    @test a != d
    return
end

function test_Hyperrectangle_empty()
    a = MOI.Utilities.Hyperrectangle([1, 2], [3, 4])
    empty!(a)
    @test a.lower == Int[]
    @test a.upper == Int[]
    return
end

function test_Hyperrectangle_resize()
    a = MOI.Utilities.Hyperrectangle([1, 2], [3, 4])
    @test length(a.lower) == 2
    @test length(a.upper) == 2
    resize!(a, 4)
    @test length(a.lower) == 4
    @test length(a.upper) == 4
    return
end

function test_load_constants()
    a = MOI.Utilities.Hyperrectangle([-Inf, -Inf, -Inf], [Inf, Inf, Inf])
    MOI.Utilities.load_constants(a, 0, MOI.Interval(1.0, 2.0))
    MOI.Utilities.load_constants(a, 1, MOI.GreaterThan(3.0))
    MOI.Utilities.load_constants(a, 2, MOI.LessThan(4.0))
    @test a == MOI.Utilities.Hyperrectangle([1.0, 3.0, -Inf], [2.0, Inf, 4.0])
    return
end

function test_function_constants()
    a = MOI.Utilities.Hyperrectangle([-Inf, -Inf, -Inf], [Inf, Inf, Inf])
    MOI.Utilities.function_constants(a, 0) == 0.0
    return
end

function test_set_from_constants()
    a = MOI.Utilities.Hyperrectangle([1.0, 3.0, -Inf], [2.0, Inf, 4.0])
    @test MOI.Utilities.set_from_constants(a, MOI.Interval{Float64}, 1) ==
          MOI.Interval(1.0, 2.0)
    @test MOI.Utilities.set_from_constants(a, MOI.GreaterThan{Float64}, 2) ==
          MOI.GreaterThan(3.0)
    @test MOI.Utilities.set_from_constants(a, MOI.LessThan{Float64}, 3) ==
          MOI.LessThan(4.0)
    @test MOI.Utilities.set_from_constants(a, MOI.ZeroOne, 2) == MOI.ZeroOne()
    return
end

function _test_bound_vectors(::Type{T}, nolb, noub) where {T}
    variable_bounds = MOI.Utilities.VariablesContainer{T}()
    @test variable_bounds.lower == T[]
    @test variable_bounds.upper == T[]
    x = MOI.add_variable(variable_bounds)
    @test variable_bounds.lower == [nolb]
    @test variable_bounds.upper == [noub]
    ux = MOI.add_constraint(variable_bounds, x, MOI.LessThan(T(1)))
    @test variable_bounds.lower == [nolb]
    @test variable_bounds.upper == [T(1)]
    y = MOI.add_variable(variable_bounds)
    @test variable_bounds.lower == [nolb, nolb]
    @test variable_bounds.upper == [T(1), noub]
    cy = MOI.add_constraint(variable_bounds, y, MOI.Interval(T(2), T(3)))
    @test variable_bounds.lower == [nolb, T(2)]
    @test variable_bounds.upper == [T(1), T(3)]
    lx = MOI.add_constraint(variable_bounds, x, MOI.GreaterThan(T(0)))
    @test variable_bounds.lower == [T(0), T(2)]
    @test variable_bounds.upper == [T(1), T(3)]
    MOI.delete(variable_bounds, lx)
    @test variable_bounds.lower == [nolb, T(2)]
    @test variable_bounds.upper == [T(1), T(3)]
    MOI.delete(variable_bounds, ux)
    @test variable_bounds.lower == [nolb, T(2)]
    @test variable_bounds.upper == [noub, T(3)]
    cx = MOI.add_constraint(variable_bounds, x, MOI.Semicontinuous(T(3), T(4)))
    @test variable_bounds.lower == [T(3), T(2)]
    @test variable_bounds.upper == [T(4), T(3)]
    MOI.delete(variable_bounds, cy)
    @test variable_bounds.lower == [T(3), nolb]
    @test variable_bounds.upper == [T(4), noub]
    sy = MOI.add_constraint(variable_bounds, y, MOI.Semiinteger(T(-2), T(-1)))
    @test variable_bounds.lower == [T(3), T(-2)]
    @test variable_bounds.upper == [T(4), T(-1)]
    MOI.delete(variable_bounds, sy)
    @test variable_bounds.lower == [T(3), nolb]
    @test variable_bounds.upper == [T(4), noub]
    ey = MOI.add_constraint(variable_bounds, y, MOI.EqualTo(T(-3)))
    @test variable_bounds.lower == [T(3), T(-3)]
    @test variable_bounds.upper == [T(4), T(-3)]
    MOI.delete(variable_bounds, ey)
    @test variable_bounds.lower == [T(3), nolb]
    @test variable_bounds.upper == [T(4), noub]
    MOI.delete(variable_bounds, cx)
    @test variable_bounds.lower == [nolb, nolb]
    @test variable_bounds.upper == [noub, noub]
end

function test_bound_vectors()
    _test_bound_vectors(Int, 0, 0)
    _test_bound_vectors(Float64, -Inf, Inf)
    return
end

function test_ListOfConstraintTypesPresent_2()
    for set in (
        MOI.EqualTo(1.0),
        MOI.GreaterThan(1.0),
        MOI.LessThan(1.0),
        MOI.Interval(1.0, 2.0),
        MOI.Semicontinuous(1.0, 2.0),
        MOI.Semiinteger(1.0, 2.0),
        MOI.Integer(),
        MOI.ZeroOne(),
    )
        model = MOI.Utilities.VariablesContainer{Float64}()
        x = MOI.add_variable(model)
        MOI.add_constraint(model, x, set)
        @test MOI.get(model, MOI.ListOfConstraintTypesPresent()) ==
              [(MOI.VariableIndex, typeof(set))]
    end
    return
end

function test_LowerBoundAlreadySet()
    for set in (
        MOI.EqualTo(1),
        MOI.GreaterThan(1),
        MOI.Interval(1, 3),
        MOI.Parameter(1),
        MOI.Semicontinuous(1, 3),
        MOI.Semiinteger(1, 3),
    )
        model = MOI.Utilities.VariablesContainer{Int}()
        x = MOI.add_variable(model)
        c = MOI.add_constraint(model, x, set)
        @test_throws(
            MOI.LowerBoundAlreadySet,
            MOI.add_constraint(model, x, MOI.EqualTo(2)),
        )
    end
    return
end

function test_UnsupportedConstraint()
    model = MOI.Utilities.VariablesContainer{Int}()
    x = [MOI.add_variable(model) for _ in 1:3]
    f = MOI.VectorOfVariables(x)
    @test_throws(
        MOI.UnsupportedConstraint{MOI.VectorOfVariables,MOI.ExponentialCone},
        MOI.add_constraint(model, f, MOI.ExponentialCone()),
    )
    return
end

end  # module

TestVariableContainer.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    HermitianToSymmetricPSDBridge{T} <: Bridges.Variable.AbstractBridge

`HermitianToSymmetricPSDBridge` implements the following reformulation:

  * Hermitian positive semidefinite `n x n` complex matrix to a symmetric
    positive semidefinite `2n x 2n` real matrix satisfying equality constraints
    described below.

## Source node

`HermitianToSymmetricPSDBridge` supports:

  * [`MOI.VectorOfVariables`](@ref) in
    [`MOI.HermitianPositiveSemidefiniteConeTriangle`](@ref)

## Target node

`HermitianToSymmetricPSDBridge` creates:

  * [`MOI.VectorOfVariables`](@ref) in [`MOI.PositiveSemidefiniteConeTriangle`](@ref)
  * [`MOI.ScalarAffineFunction{T}`](@ref) in [`MOI.EqualTo{T}`](@ref)

## Reformulation

The reformulation is best described by example.

The Hermitian matrix:
```math
\\begin{bmatrix}
  x_{11}            & x_{12} + y_{12}im & x_{13} + y_{13}im\\\\
  x_{12} - y_{12}im & x_{22}            & x_{23} + y_{23}im\\\\
  x_{13} - y_{13}im & x_{23} - y_{23}im & x_{33}
\\end{bmatrix}
```
is positive semidefinite if and only if the symmetric matrix:
```math
\\begin{bmatrix}
    x_{11} & x_{12} & x_{13} & 0       & y_{12}  & y_{13} \\\\
           & x_{22} & x_{23} & -y_{12} & 0       & y_{23} \\\\
           &        & x_{33} & -y_{13} & -y_{23} & 0      \\\\
           &        &        & x_{11}  & x_{12}  & x_{13} \\\\
           &        &        &         & x_{22}  & x_{23} \\\\
           &        &        &         &         & x_{33}
\\end{bmatrix}
```
is positive semidefinite.

The bridge achieves this reformulation by adding a new set of variables in
`MOI.PositiveSemidefiniteConeTriangle(6)`, and then adding three groups of
equality constraints to:

 * constrain the two `x` blocks to be equal
 * force the diagonal of the `y` blocks to be `0`
 * force the lower triangular of the `y` block to be the negative of the upper
   triangle.
"""
mutable struct HermitianToSymmetricPSDBridge{T} <: AbstractBridge
    variables::Vector{MOI.VariableIndex}
    psd::MOI.ConstraintIndex{
        MOI.VectorOfVariables,
        MOI.PositiveSemidefiniteConeTriangle,
    }
    n::Int
    ceq::Vector{MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}}
    imag_diag_start_set::Bool
end

const HermitianToSymmetricPSD{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{HermitianToSymmetricPSDBridge{T},OT}

function bridge_constrained_variable(
    ::Type{HermitianToSymmetricPSDBridge{T}},
    model::MOI.ModelLike,
    set::MOI.HermitianPositiveSemidefiniteConeTriangle,
) where {T}
    n = set.side_dimension
    variables, psd_ci = MOI.add_constrained_variables(
        model,
        MOI.PositiveSemidefiniteConeTriangle(2n),
    )
    ceq = MOI.ConstraintIndex{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}}[]
    k11 = 0
    k12 = k22 = MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(n))
    for j in 1:n
        k22 += n
        for i in 1:j
            k11 += 1
            k12 += 1
            k22 += 1
            f_x = MOI.Utilities.operate(-, T, variables[k11], variables[k22])
            push!(ceq, MOI.add_constraint(model, f_x, MOI.EqualTo(zero(T))))
            if i == j  # y_{ii} = 0
                f_0 = convert(MOI.ScalarAffineFunction{T}, variables[k12])
                push!(ceq, MOI.add_constraint(model, f_0, MOI.EqualTo(zero(T))))
            else       # y_{ij} = -y_{ji}
                k21 = MOI.Utilities.trimap(j, n + i)
                f_y =
                    MOI.Utilities.operate(+, T, variables[k21], variables[k12])
                push!(ceq, MOI.add_constraint(model, f_y, MOI.EqualTo(zero(T))))
            end
        end
        k12 += n
    end
    return HermitianToSymmetricPSDBridge(variables, psd_ci, n, ceq, false)
end

function supports_constrained_variable(
    ::Type{<:HermitianToSymmetricPSDBridge},
    ::Type{MOI.HermitianPositiveSemidefiniteConeTriangle},
)
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:HermitianToSymmetricPSDBridge},
)
    return Tuple{Type}[(MOI.PositiveSemidefiniteConeTriangle,)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{HermitianToSymmetricPSDBridge{T}},
) where {T}
    return Tuple{Type,Type}[(MOI.ScalarAffineFunction{T}, MOI.EqualTo{T})]
end

function MOI.get(bridge::HermitianToSymmetricPSDBridge, ::MOI.NumberOfVariables)
    return length(bridge.variables)
end

function MOI.get(
    bridge::HermitianToSymmetricPSDBridge,
    ::MOI.ListOfVariableIndices,
)
    return copy(bridge.variables)
end

function MOI.get(
    ::HermitianToSymmetricPSDBridge,
    ::MOI.NumberOfConstraints{
        MOI.VectorOfVariables,
        MOI.PositiveSemidefiniteConeTriangle,
    },
)::Int64
    return 1
end

function MOI.get(
    bridge::HermitianToSymmetricPSDBridge,
    ::MOI.ListOfConstraintIndices{
        MOI.VectorOfVariables,
        MOI.PositiveSemidefiniteConeTriangle,
    },
)
    return [bridge.psd]
end

function MOI.get(
    bridge::HermitianToSymmetricPSDBridge{T},
    ::MOI.NumberOfConstraints{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return length(bridge.ceq)
end

function MOI.get(
    bridge::HermitianToSymmetricPSDBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{T},MOI.EqualTo{T}},
) where {T}
    return copy(bridge.ceq)
end

function MOI.delete(model::MOI.ModelLike, bridge::HermitianToSymmetricPSDBridge)
    MOI.delete(model, bridge.ceq)
    MOI.delete(model, bridge.variables)
    return
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::HermitianToSymmetricPSDBridge,
)
    return MOI.HermitianPositiveSemidefiniteConeTriangle(bridge.n)
end

function _variable_map(idx::MOI.Bridges.IndexInVector, n)
    N = MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(n))
    if idx.value <= N
        return idx.value
    end
    i, j = MOI.Utilities.inverse_trimap(idx.value - N)
    d = MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(j))
    return N + j * n + d + i
end

function _variable(
    bridge::HermitianToSymmetricPSDBridge,
    i::MOI.Bridges.IndexInVector,
)
    return bridge.variables[_variable_map(i, bridge.n)]
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimal,
    bridge::HermitianToSymmetricPSDBridge{T},
) where {T}
    values = MOI.get(model, attr, bridge.psd)
    M = MOI.dimension(MOI.get(model, MOI.ConstraintSet(), bridge))
    n = bridge.n
    return [values[_variable_map(MOI.Bridges.IndexInVector(i), n)] for i in 1:M]
end

# We don't need to take into account the equality constraints. We just need to
# sum up (with appropriate +/-) each dual variable associated with the original
# x or y element.
# The reason for this is as follows:
# Suppose for simplicity that the elements of a `2n x 2n` matrix are ordered as:
# ```
# \\ 1 |\\ 2
#  \\  | 3
#   \\ |4_\\
#    \\  5
#     \\
#      \\
# ```
# Let `H = HermitianToSymmetricPSDBridge(n)`,
# `S = PositiveSemidefiniteConeTriangle(2n)` and `ceq` be the linear space of
# `2n x 2n` symmetric matrices such that the block `1` and `5` are equal, `2` and `4` are opposite and `3` is zero.
# We consider the cone `P = S ∩ ceq`.
# We have `P = A * H` where
# ```
#     [I  0]
#     [0  I]
# A = [0  0]
#     [0 -I]
#     [I  0]
# ```
# Therefore, `H* = A* * P*` where
# ```
#      [I 0 0  0 I]
# A* = [0 I 0 -I 0]
# ```
# Moreover, as `(S ∩ T)* = S* + T*` for cones `S` and `T`, we have
# ```
# P* = S* + ceq*
# ```
# the dual vector of `P*` is the dual vector of `S*` for which we add in the corresponding
# entries the dual of the three constraints, multiplied by the coefficients for the `EqualTo` constraints.
# Note that these contributions cancel out when we multiply them by `A*`:
# A* * (S* + ceq*) = A* * S*
# so we can just ignore them.
function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDual,
    bridge::HermitianToSymmetricPSDBridge{T},
) where {T}
    dual = MOI.get(model, attr, bridge.psd)
    M = MOI.dimension(MOI.get(model, MOI.ConstraintSet(), bridge))
    result = zeros(T, M)
    n = bridge.n
    N = MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(n))
    k11, k12, k22 = 0, N, N
    k21 = MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(2n)) + 1
    k = 0
    for j in 1:n
        k21 -= n + 1 - j
        k22 += n
        for i in 1:j
            k11 += 1
            k12 += 1
            k21 -= 1
            k22 += 1
            result[k11] += dual[k11] + dual[k22]
            if i != j
                k += 1
                result[N+k] += dual[k12] - dual[k21]
            end
        end
        k12 += n
        k21 -= n - j
    end
    return result
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.VariablePrimal,MOI.VariablePrimalStart},
    bridge::HermitianToSymmetricPSDBridge{T},
    i::MOI.Bridges.IndexInVector,
) where {T}
    return MOI.get(model, attr, _variable(bridge, i))
end

function MOI.Bridges.bridged_function(
    bridge::HermitianToSymmetricPSDBridge{T},
    i::MOI.Bridges.IndexInVector,
) where {T}
    return convert(MOI.ScalarAffineFunction{T}, _variable(bridge, i))
end

function unbridged_map(
    bridge::HermitianToSymmetricPSDBridge{T},
    vi::MOI.VariableIndex,
    i::MOI.Bridges.IndexInVector,
) where {T}
    return (_variable(bridge, i) => convert(MOI.ScalarAffineFunction{T}, vi),)
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    ::Type{<:HermitianToSymmetricPSDBridge},
)
    return MOI.supports(model, attr, MOI.VariableIndex)
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.VariablePrimalStart,
    bridge::HermitianToSymmetricPSDBridge,
    value,
    index::MOI.Bridges.IndexInVector,
)
    d = MOI.dimension(MOI.PositiveSemidefiniteConeTriangle(bridge.n))
    if index.value > d  # Imaginary part
        i, j = MOI.Utilities.inverse_trimap(index.value - d)
        j += 1  # Increment `j` by `1` to account for the zero diagonal
        k12 = MOI.Utilities.trimap(i, bridge.n + j)
        MOI.set(model, attr, bridge.variables[k12], value)
        k21 = MOI.Utilities.trimap(j, bridge.n + i)
        minus_value = value === nothing ? nothing : -value
        MOI.set(model, attr, bridge.variables[k21], minus_value)
    else  # Real part
        i, j = MOI.Utilities.inverse_trimap(index.value)
        k11 = MOI.Utilities.trimap(i, j)
        MOI.set(model, attr, bridge.variables[k11], value)
        k22 = MOI.Utilities.trimap(bridge.n + i, bridge.n + j)
        MOI.set(model, attr, bridge.variables[k22], value)
    end
    # The variables on the imaginary diagonal have a value 0, and they cannot be
    # referenced by the user. So if we are setting the VariablePrimalStart for
    # some components, assume that we also want to set it for the imaginary
    # diagonal (so that every variable has a primal start). But we should do
    # this once and only once, so cache whether we have in the
    # `imag_diag_start_set` field.
    if value === nothing && bridge.imag_diag_start_set
        bridge.imag_diag_start_set = false
        for i in 1:bridge.n
            k = MOI.Utilities.trimap(i, bridge.n + i)
            MOI.set(model, attr, bridge.variables[k], nothing)
        end
    elseif value !== nothing && !bridge.imag_diag_start_set
        bridge.imag_diag_start_set = true
        for i in 1:bridge.n
            k = MOI.Utilities.trimap(i, bridge.n + i)
            MOI.set(model, attr, bridge.variables[k], zero(value))
        end
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type StructOfConstraints <: MOI.ModelLike end

A struct storing a subfields other structs storing constraints of different
types.

See [`Utilities.@struct_of_constraints_by_function_types`](@ref)
and [`Utilities.@struct_of_constraints_by_set_types`](@ref).
"""
abstract type StructOfConstraints <: MOI.ModelLike end

function _add_variable(model::StructOfConstraints)
    model.num_variables += 1
    return broadcastcall(_add_variable, model)
end

function _add_variables(model::StructOfConstraints, n)
    model.num_variables += n
    return broadcastcall(Base.Fix2(_add_variables, n), model)
end

function final_touch(::Nothing, index_map) end

function final_touch(model::StructOfConstraints, index_map)
    broadcastcall(Base.Fix2(final_touch, index_map), model)
    return
end

function _throw_if_cannot_delete(model::StructOfConstraints, vis, fast_in_vis)
    broadcastcall(model) do constrs
        if constrs !== nothing
            _throw_if_cannot_delete(constrs, vis, fast_in_vis)
        end
        return
    end
    return
end

function _deleted_constraints(
    callback::Function,
    model::StructOfConstraints,
    vi,
)
    broadcastcall(model) do constrs
        if constrs !== nothing
            _deleted_constraints(callback, constrs, vi)
        end
        return
    end
    return
end

function MOI.add_constraint(
    model::StructOfConstraints,
    func::F,
    set::S,
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    if !MOI.supports_constraint(model, F, S)
        throw(MOI.UnsupportedConstraint{F,S}())
    end
    return MOI.add_constraint(constraints(model, F, S), func, set)
end

function constraints(
    model::StructOfConstraints,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    if !MOI.supports_constraint(model, F, S)
        throw(MOI.InvalidIndex(ci))
    end
    return constraints(model, F, S)
end

function MOI.get(
    model::StructOfConstraints,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    ci::MOI.ConstraintIndex,
)
    return MOI.get(constraints(model, ci), attr, ci)
end

function MOI.delete(model::StructOfConstraints, ci::MOI.ConstraintIndex)
    MOI.delete(constraints(model, ci), ci)
    return
end

function MOI.is_valid(
    model::StructOfConstraints,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    if !MOI.supports_constraint(model, F, S)
        return false
    end
    return MOI.is_valid(constraints(model, ci), ci)
end

function MOI.modify(
    model::StructOfConstraints,
    ci::MOI.ConstraintIndex,
    change::MOI.AbstractFunctionModification,
)
    MOI.modify(constraints(model, ci), ci, change)
    return
end

function MOI.set(
    model::StructOfConstraints,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    ci::MOI.ConstraintIndex,
    func_or_set,
)
    MOI.set(constraints(model, ci), attr, ci, func_or_set)
    return
end

function MOI.get(
    model::StructOfConstraints,
    attr::MOI.ListOfConstraintTypesPresent,
)
    return broadcastvcat(model) do constrs
        if constrs === nothing
            return Tuple{Type,Type}[]
        end
        return MOI.get(constrs, attr)
    end
end

function MOI.get(
    model::StructOfConstraints,
    attr::MOI.NumberOfConstraints{F,S},
)::Int64 where {F,S}
    if !MOI.supports_constraint(model, F, S)
        return 0
    end
    return MOI.get(constraints(model, F, S), attr)
end

function MOI.get(
    model::StructOfConstraints,
    attr::MOI.ListOfConstraintIndices{F,S},
) where {F,S}
    if !MOI.supports_constraint(model, F, S)
        return MOI.ConstraintIndex{F,S}[]
    end
    return MOI.get(constraints(model, F, S), attr)
end

function MOI.is_empty(model::StructOfConstraints)
    ret = mapreduce_constraints(&, model, true) do constrs
        return constrs === nothing || MOI.is_empty(constrs)
    end
    return something(ret, true)
end

function MOI.empty!(model::StructOfConstraints)
    model.num_variables = 0
    broadcastcall(model) do constrs
        if constrs !== nothing
            MOI.empty!(constrs)
        end
        return
    end
    return
end

# Can be used to access constraints of a model
"""
    broadcastcall(f::Function, model::StructOfConstraints)

Calls `f(contrs)` for every field in `model`.
"""
function broadcastcall end

"""
    broadcastvcat(f::Function, model::StructOfConstraints)

Calls `f(contrs)` for every field in `model` and `vcat`s the results.
"""
function broadcastvcat end

"""
    mapreduce_constraints(
        f::Function,
        op::Function,
        model::StructOfConstraints,
        init,
    )

Call `mapreduce` on every field of `model` given an initial value `init`. Each
element in the map is computed as `f(x)` and the elements are reduced using
`op`.
"""
function mapreduce_constraints end

# Macro code

abstract type SymbolFS end

struct SymbolFun <: SymbolFS
    s::Union{Symbol,Expr}
    typed::Bool
end

struct SymbolSet <: SymbolFS
    s::Union{Symbol,Expr}
    typed::Bool
end

_typed(s::SymbolFS) = s.typed ? Expr(:curly, esc(s.s), esc(:T)) : esc(s.s)

function _field(s::SymbolFS)
    return Symbol(replace(lowercase(string(s.s)), "." => "_"))
end

# Represents a union of function or set types
struct _UnionSymbolFS{S<:SymbolFS}
    s::Vector{S}
end

function _typed(s::_UnionSymbolFS)
    tt = _typed.(s.s)
    return Expr(:curly, :Union, tt...)
end

_field(s::_UnionSymbolFS) = _field(s.s[1])

function _mapreduce_field(s::Union{SymbolFS,_UnionSymbolFS})
    return :(cur = op(cur, f(model.$(_field(s)))))
end

_callfield(f, s::Union{SymbolFS,_UnionSymbolFS}) = :($f(model.$(_field(s))))

function _parse_expr(::Type{S}, expr::Symbol) where {S<:SymbolFS}
    return S(expr, false)
end

function _parse_expr(::Type{S}, expr::Expr) where {S<:SymbolFS}
    if Meta.isexpr(expr, :curly)
        @assert length(expr.args) >= 1
        if expr.args[1] == :Union
            # `Union{:A, :B}` parses as
            # `Expr(:curly, :Union, :A, :B)`
            @assert length(expr.args) >= 3
            return _UnionSymbolFS{S}(_parse_expr.(S, expr.args[2:end]))
        else
            # Typed set, for example, `MOI.EqualTo{T}` parses as:
            # `Expr(:curly, :(MOI.EqualTo), :T)`
            @assert length(expr.args) == 2
            @assert expr.args[2] == :T
            return S(expr.args[1], true)
        end
    else
        return S(expr, false)
    end
end

"""
    struct_of_constraint_code(struct_name, types, field_types = nothing)

Given a vector of `n` `Union{SymbolFun,_UnionSymbolFS{SymbolFun}}` or
`Union{SymbolSet,_UnionSymbolFS{SymbolSet}}` in `types`, defines a subtype of
`StructOfConstraints` of name `name` and which type parameters
`{T, F1, F2, ..., Fn}` if `field_types` is `nothing` and
a `{T}` otherwise.
It contains `n` field where the `i`th field has type `Ci` if `field_types` is
`nothing` and type `field_types[i]` otherwise.
If `types` is vector of `Union{SymbolFun,_UnionSymbolFS{SymbolFun}}` (resp.
`Union{SymbolSet,_UnionSymbolFS{SymbolSet}}`) then the constraints of that
function (resp. set) type are stored in the corresponding field.

This function is used by the macros [`@model`](@ref),
[`@struct_of_constraints_by_function_types`](@ref) and
[`@struct_of_constraints_by_set_types`](@ref).
"""
function struct_of_constraint_code(struct_name, types, field_types = nothing)
    T = esc(:T)
    typed_struct = :($(struct_name){$T})
    type_parametrized = field_types === nothing
    if type_parametrized
        field_types = Symbol[Symbol("C$i") for i in eachindex(types)]
        append!(typed_struct.args, field_types)
    end
    code = quote
        mutable struct $typed_struct <: StructOfConstraints
            num_variables::Int64
        end

        function $MOI.Utilities.broadcastcall(f::Function, model::$struct_name)
            $(Expr(:block, _callfield.(Ref(:f), types)...))
            return
        end

        function $MOI.Utilities.broadcastvcat(f::Function, model::$struct_name)
            return vcat($(_callfield.(Ref(:f), types)...))
        end

        function $MOI.Utilities.mapreduce_constraints(
            f::Function,
            op::Function,
            model::$struct_name,
            cur,
        )
            return $(Expr(:block, _mapreduce_field.(types)...))
        end
    end

    for (t, field_type) in zip(types, field_types)
        field = _field(t)
        push!(code.args[2].args[3].args, :($field::Union{Nothing,$field_type}))
        fun = t isa SymbolFun ? _typed(t) : :(MOI.AbstractFunction)
        set = t isa SymbolFun ? :(MOI.AbstractSet) : _typed(t)
        constraints_code = :(
            function $MOI.Utilities.constraints(
                model::$typed_struct,
                ::Type{<:$fun},
                ::Type{<:$set},
            ) where {$T}
                if model.$field === nothing
                    model.$field = $(field_type)()
                    $MOI.Utilities._add_variables(
                        model.$field,
                        model.num_variables,
                    )
                end
                return something(model.$field)
            end
        )
        if type_parametrized
            append!(constraints_code.args[1].args, field_types)
        end
        push!(code.args, constraints_code)
    end
    if !isempty(types)
        is_func = any(types) do t
            return t isa Union{SymbolFun,_UnionSymbolFS{SymbolFun}}
        end
        is_set = any(types) do t
            return t isa Union{SymbolSet,_UnionSymbolFS{SymbolSet}}
        end
        @assert xor(is_func, is_set)
        if is_func
            SuperF = :(Union{$(_typed.(types)...)})
        else
            SuperF = :(MOI.AbstractFunction)
        end
        if is_set
            SuperS = :(Union{$(_typed.(types)...)})
        else
            SuperS = :(MOI.AbstractSet)
        end
        push!(
            code.args,
            :(
                function $MOI.supports_constraint(
                    model::$struct_name{$T},
                    ::Type{F},
                    ::Type{S},
                ) where {$T,F<:$SuperF,S<:$SuperS}
                    return $MOI.supports_constraint(
                        constraints(model, F, S),
                        F,
                        S,
                    )
                end
            ),
        )
    end
    # Here we make an internal constructor for our type. It needs to be an
    # internal constructor to avoid someone trying to provide
    # `typed_struct(args...)` which will throw an error about `T not defined`.
    nothings = fill(nothing, length(field_types))
    constructor_code = :(function $typed_struct() where {$T}
        return new{$T}(0, $(nothings...))
    end)
    if type_parametrized
        # A bit confusing: we need to add the extra type parameters to `{T}`.
        # Here's the `where {T}`
        append!(constructor_code.args[1].args, field_types)
        # And here's the `new{T}`
        append!(
            constructor_code.args[2].args[end].args[1].args[1].args,
            field_types,
        )
    end
    # Here's where we put the inner constructor.
    push!(code.args[2].args[3].args, constructor_code)
    return code
end

"""
    Utilities.@struct_of_constraints_by_function_types(name, func_types...)

Given a vector of `n` function types `(F1, F2,..., Fn)` in `func_types`, defines
a subtype of `StructOfConstraints` of name `name` and which type parameters
`{T, C1, C2, ..., Cn}`.
It contains `n` field where the `i`th field has type `Ci` and stores the
constraints of function type `Fi`.

The expression `Fi` can also be a union in which case any constraint for which
the function type is in the union is stored in the field with type `Ci`.
"""
macro struct_of_constraints_by_function_types(name, func_types...)
    funcs = _parse_expr.(SymbolFun, func_types)
    return struct_of_constraint_code(esc(name), funcs)
end

"""
    Utilities.@struct_of_constraints_by_set_types(name, func_types...)

Given a vector of `n` set types `(S1, S2,..., Sn)` in `func_types`, defines
a subtype of `StructOfConstraints` of name `name` and which type parameters
`{T, C1, C2, ..., Cn}`.
It contains `n` field where the `i`th field has type `Ci` and stores the
constraints of set type `Si`.
The expression `Si` can also be a union in which case any constraint for which
the set type is in the union is stored in the field with type `Ci`.
This can be useful if `Ci` is a [`MatrixOfConstraints`](@ref) in order to
concatenate the coefficients of constraints of several different set types in
the same matrix.
"""
macro struct_of_constraints_by_set_types(name, set_types...)
    sets = _parse_expr.(SymbolSet, set_types)
    return struct_of_constraint_code(esc(name), sets)
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SplitHyperRectangleBridge{T,G,F} <: Bridges.Constraint.AbstractBridge

`SplitHyperRectangleBridge` implements the following reformulation:

  * ``f(x) \\in \\textsf{HyperRectangle}(l, u)`` to
    ``[f(x) - l; u - f(x)] \\in \\mathbb{R}_+``.

## Source node

`SplitHyperRectangleBridge` supports:

  * `F` in [`MOI.HyperRectangle`](@ref)

## Target nodes

`SplitHyperRectangleBridge` creates:

  * `G` in [`MOI.Nonnegatives`](@ref)
"""
mutable struct SplitHyperRectangleBridge{T,G,F} <: AbstractBridge
    ci::Union{Nothing,MOI.ConstraintIndex{G,MOI.Nonnegatives}}
    set::MOI.HyperRectangle{T}
    free_rows::F
    free_primal_start::Union{Nothing,Vector{T}}
    free_dual_start::Union{Nothing,Vector{T}}

    function SplitHyperRectangleBridge{T,G,F}(
        ci::Union{Nothing,MOI.ConstraintIndex{G,MOI.Nonnegatives}},
        set::MOI.HyperRectangle{T},
        free_rows::F,
    ) where {T,G,F}
        return new{T,G,F}(ci, set, free_rows, nothing, nothing)
    end
end

const SplitHyperRectangle{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SplitHyperRectangleBridge{T},OT}

function bridge_constraint(
    ::Type{SplitHyperRectangleBridge{T,G,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.HyperRectangle,
) where {T,G,F}
    N = MOI.dimension(s)
    g_vec = Vector{MOI.Utilities.scalar_type(G)}(undef, 2 * MOI.dimension(s))
    rows_to_keep = fill(true, length(g_vec))
    free_rows = Int[]
    scalars = MOI.Utilities.eachscalar(f)
    for (i, fi) in enumerate(scalars)
        if !isfinite(s.lower[i])
            rows_to_keep[i] = false
            # It doesn't really matter what goes here. We're going to drop it
            # when we vectorize the function
            g_vec[i] = fi
        elseif iszero(s.lower[i])
            g_vec[i] = fi
        else
            g_vec[i] = MOI.Utilities.operate(-, T, fi, s.lower[i])
        end
        if !isfinite(s.upper[i])
            rows_to_keep[N+i] = false
            g_vec[N+i] = fi
        elseif iszero(s.upper[i])
            g_vec[N+i] = MOI.Utilities.operate(-, T, fi)
        else
            g_vec[N+i] = MOI.Utilities.operate(-, T, s.upper[i], fi)
        end
        if !isfinite(s.lower[i]) && !isfinite(s.upper[i])
            push!(free_rows, i)
        end
    end
    if length(free_rows) == N
        return SplitHyperRectangleBridge{T,G,F}(nothing, s, f)
    end
    g = MOI.Utilities.vectorize(g_vec[rows_to_keep])
    ci = MOI.add_constraint(model, g, MOI.Nonnegatives(MOI.output_dimension(g)))
    return SplitHyperRectangleBridge{T,G,F}(ci, s, scalars[free_rows])
end

function MOI.supports_constraint(
    ::Type{<:SplitHyperRectangleBridge{T}},
    ::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.HyperRectangle{T}},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:SplitHyperRectangleBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{<:SplitHyperRectangleBridge{T,G}},
) where {T,G}
    return Tuple{Type,Type}[(G, MOI.Nonnegatives),]
end

function concrete_bridge_type(
    ::Type{<:SplitHyperRectangleBridge{T}},
    ::Type{F},
    ::Type{MOI.HyperRectangle{T}},
) where {T,F<:MOI.AbstractVectorFunction}
    G = MOI.Utilities.promote_operation(-, T, F, Vector{T})
    return SplitHyperRectangleBridge{T,G,F}
end

function MOI.get(
    model::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::SplitHyperRectangleBridge{T,G,F},
) where {T,G,F}
    if bridge.ci === nothing
        return bridge.free_rows
    end
    f = MOI.get(model, MOI.ConstraintFunction(), bridge.ci)
    f_s = MOI.Utilities.eachscalar(f)
    func = Vector{eltype(f_s)}(undef, MOI.dimension(bridge.set))
    free_s = MOI.Utilities.eachscalar(bridge.free_rows)
    n_free_rows, n_f_rows, upper_bound_rows = 0, 0, Int[]
    for (row, (l, u)) in enumerate(zip(bridge.set.lower, bridge.set.upper))
        if !isfinite(l) && !isfinite(u)
            n_free_rows += 1
            func[row] = free_s[n_free_rows]
        elseif iszero(l)
            n_f_rows += 1
            func[row] = f_s[n_f_rows]
        elseif isfinite(l)
            n_f_rows += 1
            func[row] = MOI.Utilities.operate(+, T, f_s[n_f_rows], l)
        else
            @assert isfinite(u)
            # This row exists only as u - f, but we don't know where it starts
            # yet because we need to count all the `f - l` rows first.
            push!(upper_bound_rows, row)
        end
    end
    for (row, (l, u)) in enumerate(zip(bridge.set.lower, bridge.set.upper))
        if !isfinite(u)
            continue
        end
        n_f_rows += 1
        if !(row in upper_bound_rows)
            continue
        end
        func[row] = if iszero(bridge.set.upper[row])
            MOI.Utilities.operate(-, T, f_s[n_f_rows])
        else
            MOI.Utilities.operate(-, T, bridge.set.upper[row], f_s[n_f_rows])
        end
    end
    return MOI.Utilities.convert_approx(F, MOI.Utilities.vectorize(func))
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::SplitHyperRectangleBridge,
)
    return bridge.set
end

function MOI.delete(model::MOI.ModelLike, bridge::SplitHyperRectangleBridge)
    if bridge.ci !== nothing
        MOI.delete(model, bridge.ci)
    end
    return
end

function MOI.get(
    bridge::SplitHyperRectangleBridge{T,G},
    ::MOI.NumberOfConstraints{G,MOI.Nonnegatives},
)::Int64 where {T,G}
    return ifelse(bridge.ci === nothing, 0, 1)
end

function MOI.get(
    bridge::SplitHyperRectangleBridge{T,G,F},
    ::MOI.ListOfConstraintIndices{G,MOI.Nonnegatives},
) where {T,G,F}
    ret = MOI.ConstraintIndex{G,MOI.Nonnegatives}[]
    if bridge.ci !== nothing
        push!(ret, bridge.ci)
    end
    return ret
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{<:SplitHyperRectangleBridge{T,G}},
) where {T,G}
    return MOI.supports(model, attr, MOI.ConstraintIndex{G,MOI.Nonnegatives})
end

_get_free_start(bridge, ::MOI.ConstraintDualStart) = bridge.free_dual_start

function _set_free_start(bridge, ::MOI.ConstraintDualStart, value)
    bridge.free_dual_start = value
    return
end

_get_free_start(bridge, ::MOI.ConstraintPrimalStart) = bridge.free_primal_start

function _set_free_start(bridge, ::MOI.ConstraintPrimalStart, value)
    bridge.free_primal_start = value
    return
end

# This is a punned overload. We use Union{MOI.ConstraintDual,MOI.ConstraintDualStart}
# in MOI.get, so this hits the ConstraintDual branch. Since no constraints are
# ever added, we just assuem that the dual is `0.0` (this is feasible because)
# the set is really `f(x) in Reals()`, so the dual set is `Zeros()`
function _get_free_start(
    bridge::SplitHyperRectangleBridge{T},
    ::MOI.ConstraintDual,
) where {T}
    return zeros(T, MOI.dimension(bridge.set))
end

# The same cannot be said for ConstraintPrimal because we have no mechanism for
# evaluating the primal of the free rows. Throw an error instead.
function _get_free_start(
    ::SplitHyperRectangleBridge,
    attr::MOI.ConstraintPrimal,
)
    return throw(MOI.GetAttributeNotAllowed(attr))
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintPrimalStart,
    bridge::SplitHyperRectangleBridge{T},
    value::AbstractVector{T},
) where {T}
    if bridge.ci === nothing
        return _set_free_start(bridge, attr, value)
    end
    new_values = vcat(
        T[v - l for (v, l) in zip(value, bridge.set.lower) if isfinite(l)],
        T[u - v for (v, u) in zip(value, bridge.set.upper) if isfinite(u)],
    )
    MOI.set(model, attr, bridge.ci, new_values)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimal,MOI.ConstraintPrimalStart},
    bridge::SplitHyperRectangleBridge{T},
) where {T}
    if bridge.ci === nothing
        return _get_free_start(bridge, attr)
    end
    values = MOI.get(model, attr, bridge.ci)
    if values === nothing
        return nothing
    end
    ret = zeros(T, MOI.dimension(bridge.set))
    row = 0
    for (i, l) in enumerate(bridge.set.lower)
        if isfinite(l)
            row += 1
            ret[i] = l + values[row]
        end
    end
    for (i, u) in enumerate(bridge.set.upper)
        if isfinite(u)
            row += 1
            ret[i] = u - values[row]
        end
    end
    return ret
end

function MOI.set(
    model::MOI.ModelLike,
    attr::MOI.ConstraintDualStart,
    bridge::SplitHyperRectangleBridge{T},
    values::AbstractVector{T},
) where {T}
    if bridge.ci === nothing
        return _set_free_start(bridge, attr, values)
    end
    set = bridge.set
    new_values = vcat(
        T[max(T(0), v) for (v, l) in zip(values, set.lower) if isfinite(l)],
        T[max(T(0), -v) for (v, u) in zip(values, set.upper) if isfinite(u)],
    )
    MOI.set(model, attr, bridge.ci, new_values)
    return
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintDual,MOI.ConstraintDualStart},
    bridge::SplitHyperRectangleBridge{T},
) where {T}
    if bridge.ci === nothing
        return _get_free_start(bridge, attr)
    end
    values = MOI.get(model, attr, bridge.ci)
    if values === nothing
        return nothing
    end
    ret = zeros(T, MOI.dimension(bridge.set))
    row = 0
    for (i, l) in enumerate(bridge.set.lower)
        if isfinite(l)
            row += 1
            ret[i] += values[row]
        end
    end
    for (i, u) in enumerate(bridge.set.upper)
        if isfinite(u)
            row += 1
            ret[i] -= values[row]
        end
    end
    return ret
end

function MOI.set(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    bridge::SplitHyperRectangleBridge{T},
    ::Nothing,
) where {T}
    if bridge.ci === nothing
        return _set_free_start(bridge, attr, nothing)
    end
    MOI.set(model, attr, bridge.ci, nothing)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    struct OptimizerWithAttributes
        optimizer_constructor
        params::Vector{Pair{AbstractOptimizerAttribute,<:Any}}
    end

Object grouping an optimizer constructor and a list of optimizer attributes.
Instances are created with [`instantiate`](@ref).
"""
struct OptimizerWithAttributes
    # Function that takes zero arguments and returns a new optimizer.
    # The type of the function could be
    # * `Function`: a function, or
    # * `Type`: a type, or
    # * `UnionAll`: a type with missing parameters.
    optimizer_constructor::Any
    params::Vector{Pair{AbstractOptimizerAttribute,Any}}
end

_to_param(param::Pair{<:AbstractOptimizerAttribute}) = param

function _to_param(param::Pair{String})
    return RawOptimizerAttribute(param.first) => param.second
end

function _to_param(param::Pair)
    return error(
        "Expected an optimizer attribute or a string, got `$(param.first)` which is a `$(typeof(param.first))`.",
    )
end

"""
    OptimizerWithAttributes(optimizer_constructor, params::Pair...)

Create an [`OptimizerWithAttributes`](@ref) with the parameters `params`.
"""
function OptimizerWithAttributes(
    optimizer_constructor,
    args::Vararg{Pair,N},
) where {N}
    if !applicable(optimizer_constructor)
        error(_INSTANTIATE_NOT_CALLABLE_MESSAGE)
    end
    params =
        Pair{AbstractOptimizerAttribute,Any}[_to_param(arg) for arg in args]
    return OptimizerWithAttributes(optimizer_constructor, params)
end

function get(opt::OptimizerWithAttributes, attr::AbstractOptimizerAttribute)
    for (param, value) in opt.params
        if param == attr
            return value
        end
    end
    return nothing
end

function set(
    opt::OptimizerWithAttributes,
    attr::AbstractOptimizerAttribute,
    value,
)
    for (i, (param, _)) in enumerate(opt.params)
        if param == attr
            opt.params[i] = attr => value
            return
        end
    end
    push!(opt.params, attr => value)
    return
end

const _INSTANTIATE_NOT_CALLABLE_MESSAGE =
    "The provided `optimizer_constructor` is invalid. It must be callable with zero " *
    "arguments. For example, \"Ipopt.Optimizer\" or " *
    "\"() -> ECOS.Optimizer()\". It should not be an instantiated optimizer " *
    "like \"Ipopt.Optimizer()\" or \"ECOS.Optimizer()\". " *
    "(Note the difference in parentheses!)"

"""
    _instantiate_and_check(optimizer_constructor)

Create an instance of optimizer by calling `optimizer_constructor`.
Then check that the type returned is an empty [`ModelLike`](@ref).
"""
function _instantiate_and_check((@nospecialize optimizer_constructor))
    if !applicable(optimizer_constructor)
        error(_INSTANTIATE_NOT_CALLABLE_MESSAGE)
    end
    optimizer = optimizer_constructor()
    if !isa(optimizer, ModelLike)
        error(
            "The provided `optimizer_constructor` returned an object of type " *
            "$(typeof(optimizer)). Expected a " *
            "MathOptInterface.ModelLike.",
        )
    end
    if !is_empty(optimizer)
        error(
            "The provided `optimizer_constructor` returned a non-empty optimizer.",
        )
    end
    return optimizer
end

"""
    _instantiate_and_check(optimizer_constructor::OptimizerWithAttributes)

Create an instance of optimizer represented by [`OptimizerWithAttributes`](@ref).
Then check that the type returned is an empty [`AbstractOptimizer`](@ref).
"""
function _instantiate_and_check(optimizer_constructor::OptimizerWithAttributes)
    optimizer =
        _instantiate_and_check(optimizer_constructor.optimizer_constructor)
    for param in optimizer_constructor.params
        set(optimizer, param.first, param.second)
    end
    return optimizer
end

"""
    instantiate(
        optimizer_constructor,
        with_cache_type::Union{Nothing,Type} = nothing,
        with_bridge_type::Union{Nothing,Type} = nothing,
    )

Create an instance of an optimizer by either:

 * calling `optimizer_constructor.optimizer_constructor()` and setting the
   parameters in `optimizer_constructor.params` if `optimizer_constructor` is a
   [`OptimizerWithAttributes`](@ref)
*  calling `optimizer_constructor()` if `optimizer_constructor` is callable.

## with_cache_type

If `with_cache_type` is not `nothing`, then the optimizer is wrapped in a
[`Utilities.CachingOptimizer`](@ref) to store a cache of the model. This is most
useful if the optimizer you are constructing does not support the incremental
interface (see [`supports_incremental_interface`](@ref)).

## with_bridge_type

If `with_bridge_type` is not `nothing`, the optimizer is wrapped in a
[`Bridges.full_bridge_optimizer`](@ref), enabling all the bridges defined in
the MOI.Bridges submodule with coefficient type `with_bridge_type`.

In addition, if the optimizer created by `optimizer_constructor` does not
support the incremental interface (see [`supports_incremental_interface`](@ref)),
then, irrespective of `with_cache_type`, the optimizer is wrapped in a
[`Utilities.CachingOptimizer`](@ref) to store a cache of the bridged model.

If `with_cache_type` and `with_bridge_type` are both not `nothing`, then they
must be the same type.
"""
function instantiate(
    (@nospecialize optimizer_constructor);
    with_bridge_type::Union{Nothing,Type} = nothing,
    with_cache_type::Union{Nothing,Type} = nothing,
)
    if with_bridge_type !== nothing && with_cache_type !== nothing
        if with_bridge_type != with_cache_type
            error(
                "If both provided, `with_bridge_type` and `with_cache_type` " *
                "must be the same type. Got " *
                "`with_bridge_type = $with_bridge_type` and " *
                "`with_cache_type = $with_cache_type`",
            )
        end
    end
    optimizer = _instantiate_and_check(optimizer_constructor)
    if with_bridge_type === nothing
        if with_cache_type === nothing
            return optimizer
        end
        cache = default_cache(optimizer, with_cache_type)
        return Utilities.CachingOptimizer(cache, optimizer)
    else
        if with_cache_type !== nothing ||
           !supports_incremental_interface(optimizer)
            cache = default_cache(optimizer, with_bridge_type)
            optimizer = Utilities.CachingOptimizer(cache, optimizer)
        end
        return Bridges.full_bridge_optimizer(optimizer, with_bridge_type)
    end
end

"""
    default_cache(optimizer::ModelLike, ::Type{T}) where {T}

Return a new instance of the default model type to be used as cache for
`optimizer` in a [`Utilities.CachingOptimizer`](@ref) for holding constraints
of coefficient type `T`. By default, this returns
`Utilities.UniversalFallback(Utilities.Model{T}())`. If copying from a instance
of a given model type is faster for `optimizer` then a new method returning
an instance of this model type should be defined.
"""
function default_cache(::ModelLike, ::Type{T}) where {T}
    return Utilities.UniversalFallback(Utilities.Model{T}())
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestPrint

using Test

import MathOptInterface as MOI
import MathOptInterface.Utilities as MOIU

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

const LATEX = MIME("text/latex")
const PLAIN = MIME("text/plain")
const IN = Sys.iswindows() ? "in" : "∈"

# Windows fun
function _string_compare(a, b)
    @test replace(a, "\r\n" => "\n") == replace(b, "\r\n" => "\n")
    return
end

function test_nonname_variable()
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    @test MOIU._to_string(PLAIN, model, x) == "v[1]"
    @test MOIU._to_string(LATEX, model, x) == "v_{1}"
end

function test_numbers()
    options =
        MOIU._PrintOptions(MIME("text/plain"); simplify_coefficients = true)
    @test MOIU._to_string(options, 1.0, "x"; is_first = true) == "x"
    @test MOIU._to_string(options, 1.0, "x"; is_first = false) == " + x"
    @test MOIU._to_string(options, -1.0, "x"; is_first = true) == "-x"
    @test MOIU._to_string(options, -1.0, "x"; is_first = false) == " - x"
    @test MOIU._to_string(options, 1.2, "x"; is_first = true) == "1.2 x"
    @test MOIU._to_string(options, 1.2, "x"; is_first = false) == " + 1.2 x"
    @test MOIU._to_string(options, -1.2, "x"; is_first = true) == "-1.2 x"
    @test MOIU._to_string(options, -1.2, "x"; is_first = false) == " - 1.2 x"

    options =
        MOIU._PrintOptions(MIME("text/plain"); simplify_coefficients = false)
    @test MOIU._to_string(options, 1.0, "x"; is_first = true) == "1.0 x"
    @test MOIU._to_string(options, 1.0, "x"; is_first = false) == " + 1.0 x"
    @test MOIU._to_string(options, -1.0, "x"; is_first = true) == "-1.0 x"
    @test MOIU._to_string(options, -1.0, "x"; is_first = false) == " - 1.0 x"
    @test MOIU._to_string(options, 1.2, "x"; is_first = true) == "1.2 x"
    @test MOIU._to_string(options, 1.2, "x"; is_first = false) == " + 1.2 x"
    @test MOIU._to_string(options, -1.2, "x"; is_first = true) == "-1.2 x"
    @test MOIU._to_string(options, -1.2, "x"; is_first = false) == " - 1.2 x"
end

function test_complex_numbers()
    x = 1.0 + 1.0im
    options =
        MOIU._PrintOptions(MIME("text/plain"); simplify_coefficients = true)
    @test MOIU._to_string(options, x, "x"; is_first = true) == "(1.0 + 1.0im) x"
    @test MOIU._to_string(options, x, "x"; is_first = false) ==
          " + (1.0 + 1.0im) x"
    @test MOIU._to_string(options, -x, "x"; is_first = true) ==
          "(-1.0 - 1.0im) x"
    @test MOIU._to_string(options, -x, "x"; is_first = false) ==
          " + (-1.0 - 1.0im) x"
    return
end

function test_rational_numbers()
    x = 1 // 2
    options =
        MOIU._PrintOptions(MIME("text/plain"); simplify_coefficients = true)
    @test MOIU._to_string(options, x, "x"; is_first = true) == "(1//2) x"
    @test MOIU._to_string(options, x, "x"; is_first = false) == " + (1//2) x"
    @test MOIU._to_string(options, -x, "x"; is_first = true) == "-(1//2) x"
    @test MOIU._to_string(options, -x, "x"; is_first = false) == " - (1//2) x"
    return
end

function test_variable()
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    for (name, latex_name) in
        [("x", "x"), ("x_y", "x\\_y"), ("x^2", "x\\^2"), ("x[a,b]", "x_{a,b}")]
        MOI.set(model, MOI.VariableName(), x, name)
        @test MOIU._to_string(PLAIN, model, x) == name
        @test MOIU._to_string(LATEX, model, x) == latex_name
    end
end

function test_ScalarAffineTerm()
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    @test MOIU._to_string(
        PLAIN,
        model,
        MOI.ScalarAffineTerm(-1.2, x);
        is_first = false,
    ) == " - 1.2 x"
    @test MOIU._to_string(
        LATEX,
        model,
        MOI.ScalarAffineTerm(1.2, x);
        is_first = false,
    ) == " + 1.2 x"
end

function test_ScalarAffineFunction()
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    f = MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.([-1.2, 1.3], [x, x]),
        1.4,
    )
    @test MOIU._to_string(PLAIN, model, f) == "1.4 - 1.2 x + 1.3 x"
    @test MOIU._to_string(LATEX, model, f) == "1.4 - 1.2 x + 1.3 x"
end

function test_ScalarAffineFunction_complex()
    model = MOI.Utilities.UniversalFallback(MOIU.Model{Float64}())
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    f = (1.0 + 1.0im)x
    s = MOI.EqualTo(1.0 + 1.0im)
    @test MOIU._to_string(PLAIN, model, f) == "(0.0 + 0.0im) + (1.0 + 1.0im) x"
    @test MOIU._to_string(LATEX, model, f) == "(0.0 + 0.0im) + (1.0 + 1.0im) x"
end

function test_ScalarQuadraticTerm()
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.VariableName(), y, "y")
    term = MOI.ScalarQuadraticTerm(-1.2, x, x)
    @test MOIU._to_string(PLAIN, model, term; is_first = false) == " - 0.6 x²"
    @test MOIU._to_string(LATEX, model, term; is_first = false) == " - 0.6 x^2"
    term = MOI.ScalarQuadraticTerm(1.2, x, y)
    @test MOIU._to_string(PLAIN, model, term; is_first = false) == " + 1.2 x*y"
    @test MOIU._to_string(LATEX, model, term; is_first = false) ==
          " + 1.2 x\\times y"
end

function test_ScalarQuadraticFunction()
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.VariableName(), y, "y")
    f = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.([0.5, 0.6], [x, x], [x, y]),
        MOI.ScalarAffineTerm.([-1.2, 1.3], [x, x]),
        1.4,
    )
    @test MOIU._to_string(PLAIN, model, f) ==
          "1.4 - 1.2 x + 1.3 x + 0.25 x² + 0.6 x*y"
    @test MOIU._to_string(LATEX, model, f) ==
          "1.4 - 1.2 x + 1.3 x + 0.25 x^2 + 0.6 x\\times y"
end

function test_VectorOfVariables()
    model = MOIU.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    MOI.set(model, MOI.VariableName(), y, "y")
    f = MOI.VectorOfVariables([x, y])
    @test MOIU._to_string(PLAIN, model, f) == "┌ ┐\n│x│\n│y│\n└ ┘"
    @test MOIU._to_string(LATEX, model, f) ==
          "\\begin{bmatrix}\nx\\\\\ny\\end{bmatrix}"
end

function test_LessThan()
    s = MOI.LessThan(1.2)
    @test MOIU._to_string(PLAIN, s) == "<= 1.2"
    @test MOIU._to_string(LATEX, s) == "\\le 1.2"
end

function test_GreaterThan()
    s = MOI.GreaterThan(1.2)
    @test MOIU._to_string(PLAIN, s) == ">= 1.2"
    @test MOIU._to_string(LATEX, s) == "\\ge 1.2"
end

function test_EqualTo()
    s = MOI.EqualTo(1.2)
    @test MOIU._to_string(PLAIN, s) == "== 1.2"
    @test MOIU._to_string(LATEX, s) == "= 1.2"
end

function test_Interval()
    s = MOI.Interval(1.2, 1.3)
    @test MOIU._to_string(PLAIN, s) == "$(IN) [1.2, 1.3]"
    @test MOIU._to_string(LATEX, s) == "\\in [1.2, 1.3]"
end

function test_ZeroOne()
    s = MOI.ZeroOne()
    @test MOIU._to_string(PLAIN, s) == "$(IN) {0, 1}"
    @test MOIU._to_string(LATEX, s) == "\\in \\{0, 1\\}"
end

function test_Integer()
    s = MOI.Integer()
    @test MOIU._to_string(PLAIN, s) == "$(IN) ℤ"
    @test MOIU._to_string(LATEX, s) == "\\in \\mathbb{Z}"
end

function test_ExponentialCone()
    s = MOI.ExponentialCone()
    @test MOIU._to_string(PLAIN, s) == "$(IN) ExponentialCone()"
    @test MOIU._to_string(LATEX, s) == "\\in \\text{ExponentialCone()}"
end

function test_feasibility()
    model = MOIU.Model{Float64}()
    @test sprint(print, model) == "Feasibility\n\nSubject to:\n"
    _string_compare(
        sprint(print, MOIU.latex_formulation(model)),
        raw"""
        $$ \begin{aligned}
        \text{feasibility}\\
        \text{Subject to}\\
        \end{aligned} $$""",
    )
    return
end

function test_min()
    model = MOIU.Model{Float64}()
    MOIU.loadfromstring!(model, "variables: x\nminobjective: x")
    @test sprint(print, model) == """
    Minimize VariableIndex:
     x

    Subject to:
    """
    _string_compare(
        sprint(print, MOIU.latex_formulation(model)),
        raw"""
        $$ \begin{aligned}
        \min\quad & x \\
        \text{Subject to}\\
        \end{aligned} $$""",
    )
    return
end

function test_max()
    model = MOIU.Model{Float64}()
    MOIU.loadfromstring!(model, "variables: x\nmaxobjective: x")
    @test sprint(print, model) == """
    Maximize VariableIndex:
     x

    Subject to:
    """
    _string_compare(
        sprint(print, MOIU.latex_formulation(model)),
        raw"""
        $$ \begin{aligned}
        \max\quad & x \\
        \text{Subject to}\\
        \end{aligned} $$""",
    )
    return
end

function test_model()
    model = MOIU.Model{Float64}()
    MOIU.loadfromstring!(
        model,
        """
        variables: x, y, z
        minobjective: x + 2 + 3.1*y + -1.2*z
        c1: x >= 0.1
        c2: y in ZeroOne()
        c2: z in Integer()
        c3: [x, y] in SecondOrderCone(2)
        c4a: [1, x, y] in SecondOrderCone(2)
        c4b: [1.0 * x * x, y, 1] in ExponentialCone()
        c4c: [1, 1.0 * x * x, y] in ExponentialCone()
        c2: x in ZeroOne()
        c5: 2.0 * x * x + y + -1 * z <= 1.0
        c6: x + x >= 1.0
        c7: x + x in Interval(1.0, 2.0)
        c8: x + -1 * y == 0.0
        """,
    )
    @test sprint(print, model) == """
    Minimize ScalarAffineFunction{Float64}:
     2.0 + 1.0 x + 3.1 y - 1.2 z

    Subject to:

    ScalarAffineFunction{Float64}-in-EqualTo{Float64}
     0.0 + 1.0 x - 1.0 y == 0.0  (c8)

    ScalarAffineFunction{Float64}-in-GreaterThan{Float64}
     0.0 + 2.0 x >= 1.0  (c6)

    ScalarAffineFunction{Float64}-in-Interval{Float64}
     0.0 + 2.0 x $(IN) [1.0, 2.0]  (c7)

    ScalarQuadraticFunction{Float64}-in-LessThan{Float64}
     0.0 + 1.0 y - 1.0 z + 2.0 x² <= 1.0  (c5)

    VectorOfVariables-in-SecondOrderCone
     ┌ ┐
     │x│
     │y│
     └ ┘ $(IN) SecondOrderCone(2)  (c3)

    VectorAffineFunction{Float64}-in-SecondOrderCone
     ┌           ┐
     │1.0        │
     │0.0 + 1.0 x│
     │0.0 + 1.0 y│
     └           ┘ $(IN) SecondOrderCone(2)  (c4a)

    VectorQuadraticFunction{Float64}-in-ExponentialCone
     ┌            ┐
     │0.0 + 1.0 x²│
     │0.0 + 1.0 y │
     │1.0         │
     └            ┘ $(IN) ExponentialCone()  (c4b)
     ┌            ┐
     │1.0         │
     │0.0 + 1.0 x²│
     │0.0 + 1.0 y │
     └            ┘ $(IN) ExponentialCone()  (c4c)

    VariableIndex-in-GreaterThan{Float64}
     x >= 0.1

    VariableIndex-in-Integer
     z $(IN) ℤ

    VariableIndex-in-ZeroOne
     x $(IN) {0, 1}
     y $(IN) {0, 1}
    """
end

function test_latex()
    model = MOIU.Model{Float64}()
    MOIU.loadfromstring!(
        model,
        """
        variables: x, y, z
        minobjective: x + 2 + 3.1*y + -1.2*z
        c1: x >= 0.1
        c2: y in ZeroOne()
        c2: z in Integer()
        c3: [x, y] in SecondOrderCone(2)
        c4: [1, x, y] in SecondOrderCone(2)
        c4: [1.0 * x * x, y, 1] in ExponentialCone()
        c4: [1, 1.0 * x * x, y] in ExponentialCone()
        c2: x in ZeroOne()
        c5: 2.0 * x * x + y + -1 * z <= 1.0
        c5: x + x >= 1.0
        c5: x + x in Interval(1.0, 2.0)
        c5: x + -1 * y == 0.0
        """,
    )
    _string_compare(
        sprint(
            io -> show(io, MIME("text/latex"), MOIU.latex_formulation(model)),
        ),
        raw"""
        $$ \begin{aligned}
        \min\quad & 2.0 + 1.0 x + 3.1 y - 1.2 z \\
        \text{Subject to}\\
         & \text{ScalarAffineFunction\{Float64\}-in-EqualTo\{Float64\}} \\
         & 0.0 + 1.0 x - 1.0 y = 0.0 \\
         & \text{ScalarAffineFunction\{Float64\}-in-GreaterThan\{Float64\}} \\
         & 0.0 + 2.0 x \ge 1.0 \\
         & \text{ScalarAffineFunction\{Float64\}-in-Interval\{Float64\}} \\
         & 0.0 + 2.0 x \in [1.0, 2.0] \\
         & \text{ScalarQuadraticFunction\{Float64\}-in-LessThan\{Float64\}} \\
         & 0.0 + 1.0 y - 1.0 z + 2.0 x^2 \le 1.0 \\
         & \text{VectorOfVariables-in-SecondOrderCone} \\
         & \begin{bmatrix}
        x\\
        y\end{bmatrix} \in \text{SecondOrderCone(2)} \\
         & \text{VectorAffineFunction\{Float64\}-in-SecondOrderCone} \\
         & \begin{bmatrix}
        1.0\\
        0.0 + 1.0 x\\
        0.0 + 1.0 y\end{bmatrix} \in \text{SecondOrderCone(2)} \\
         & \text{VectorQuadraticFunction\{Float64\}-in-ExponentialCone} \\
         & \begin{bmatrix}
        0.0 + 1.0 x^2\\
        0.0 + 1.0 y\\
        1.0\end{bmatrix} \in \text{ExponentialCone()} \\
         & \begin{bmatrix}
        1.0\\
        0.0 + 1.0 x^2\\
        0.0 + 1.0 y\end{bmatrix} \in \text{ExponentialCone()} \\
         & \text{VariableIndex-in-GreaterThan\{Float64\}} \\
         & x \ge 0.1 \\
         & \text{VariableIndex-in-Integer} \\
         & z \in \mathbb{Z} \\
         & \text{VariableIndex-in-ZeroOne} \\
         & x \in \{0, 1\} \\
         & y \in \{0, 1\} \\
        \end{aligned} $$""",
    )
    return
end

function test_latex_simplified()
    model = MOIU.Model{Float64}()
    MOIU.loadfromstring!(
        model,
        """
        variables: x, y, z
        minobjective: x + 2 + 3.1*y + -1.2*z
        c1: x >= 0.1
        c2: y in ZeroOne()
        c2: z in Integer()
        c3: [x, y] in SecondOrderCone(2)
        c4: [1, x, y] in SecondOrderCone(2)
        c4: [1.0 * x * x, y, 1] in ExponentialCone()
        c4: [1, 1.0 * x * x, y] in ExponentialCone()
        c2: x in ZeroOne()
        c5: 2.0 * x * x + y + -1 * z <= 1.0
        c5: x + x >= 1.0
        c5: x + x in Interval(1.0, 2.0)
        c5: x + -1 * y == 0.0
        """,
    )
    model_string = sprint() do io
        return MOIU._print_model(
            io,
            MOIU._PrintOptions(
                MIME("text/latex");
                simplify_coefficients = true,
                print_types = false,
            ),
            model,
        )
    end
    _string_compare(
        model_string,
        raw"""
        $$ \begin{aligned}
        \min\quad & 2 + x + 3.1 y - 1.2 z \\
        \text{Subject to}\\
         & x - y = 0 \\
         & 2 x \ge 1 \\
         & 2 x \in [1, 2] \\
         & y - z + 2 x^2 \le 1 \\
         & \begin{bmatrix}
        x\\
        y\end{bmatrix} \in \text{SecondOrderCone(2)} \\
         & \begin{bmatrix}
        1\\
        x\\
        y\end{bmatrix} \in \text{SecondOrderCone(2)} \\
         & \begin{bmatrix}
        x^2\\
        y\\
        1\end{bmatrix} \in \text{ExponentialCone()} \\
         & \begin{bmatrix}
        1\\
        x^2\\
        y\end{bmatrix} \in \text{ExponentialCone()} \\
         & x \ge 0.1 \\
         & z \in \mathbb{Z} \\
         & x \in \{0, 1\} \\
         & y \in \{0, 1\} \\
        \end{aligned} $$""",
    )
    return
end

function test_plain_simplified()
    model = MOIU.Model{Float64}()
    MOIU.loadfromstring!(
        model,
        """
        variables: x, y, z
        minobjective: x + -2 + 3.1*y + -1.2*z
        c1: x >= 0.1
        c2: y in ZeroOne()
        c2: z in Integer()
        c3: [x, y] in SecondOrderCone(2)
        c4a: [1, x, y] in SecondOrderCone(2)
        c4b: [1.0 * x * x, y, 1] in ExponentialCone()
        [1, 1.0 * x * x, y] in ExponentialCone()
        c2: x in ZeroOne()
        c5: 2.0 * x * x + y + -1 * z <= 1.0
        c6: x + x >= 1.0
        c7: x + x in Interval(1.0, 2.0)
        c8: x + -1 * y == 0.0
        """,
    )
    model_string = sprint() do io
        return MOIU._print_model(
            io,
            MOIU._PrintOptions(
                MIME("text/plain");
                simplify_coefficients = true,
                print_types = false,
            ),
            model,
        )
    end
    @test model_string == """
    Minimize: -2 + x + 3.1 y - 1.2 z

    Subject to:
     x - y == 0  (c8)
     2 x >= 1  (c6)
     2 x $(IN) [1, 2]  (c7)
     y - z + 2 x² <= 1  (c5)
     ┌ ┐
     │x│
     │y│
     └ ┘ $(IN) SecondOrderCone(2)  (c3)
     ┌ ┐
     │1│
     │x│
     │y│
     └ ┘ $(IN) SecondOrderCone(2)  (c4a)
     ┌  ┐
     │x²│
     │y │
     │1 │
     └  ┘ $(IN) ExponentialCone()  (c4b)
     ┌  ┐
     │1 │
     │x²│
     │y │
     └  ┘ $(IN) ExponentialCone()
     x >= 0.1
     z $(IN) ℤ
     x $(IN) {0, 1}
     y $(IN) {0, 1}
    """
end

function test_nlp()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    v = MOI.add_variables(model, 4)
    l = [1.1, 1.2, 1.3, 1.4]
    u = [5.1, 5.2, 5.3, 5.4]
    MOI.add_constraint.(model, v, MOI.GreaterThan.(l))
    MOI.add_constraint.(model, v, MOI.LessThan.(u))
    for i in 1:4
        MOI.set(model, MOI.VariableName(), v[i], "x[$i]")
    end
    lb, ub = [25.0, 40.0], [Inf, 40.0]
    evaluator = MOI.Test.HS071(true)
    block_data = MOI.NLPBlockData(MOI.NLPBoundsPair.(lb, ub), evaluator, true)
    MOI.set(model, MOI.NLPBlock(), block_data)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test sprint(print, model) == """
    Minimize Nonlinear:
     x[1] * x[4] * (x[1] + x[2] + x[3]) + x[3]

    Subject to:

    VariableIndex-in-GreaterThan{Float64}
     x[1] >= 1.1
     x[2] >= 1.2
     x[3] >= 1.3
     x[4] >= 1.4

    VariableIndex-in-LessThan{Float64}
     x[1] <= 5.1
     x[2] <= 5.2
     x[3] <= 5.3
     x[4] <= 5.4

    Nonlinear
     x[1] * x[2] * x[3] * x[4] >= 25.0
     x[1] ^ 2 + x[2] ^ 2 + x[3] ^ 2 + x[4] ^ 2 == 40.0
    """
    _string_compare(
        sprint(print, MOIU.latex_formulation(model)),
        raw"""
        $$ \begin{aligned}
        \min\quad & x_{1} \times x_{4} \times (x_{1} + x_{2} + x_{3}) + x_{3} \\
        \text{Subject to}\\
         & \text{VariableIndex-in-GreaterThan\{Float64\}} \\
         & x_{1} \ge 1.1 \\
         & x_{2} \ge 1.2 \\
         & x_{3} \ge 1.3 \\
         & x_{4} \ge 1.4 \\
         & \text{VariableIndex-in-LessThan\{Float64\}} \\
         & x_{1} \le 5.1 \\
         & x_{2} \le 5.2 \\
         & x_{3} \le 5.3 \\
         & x_{4} \le 5.4 \\
         & \text{Nonlinear} \\
         & x_{1} \times x_{2} \times x_{3} \times x_{4} \ge 25.0 \\
         & x_{1} ^ 2 + x_{2} ^ 2 + x_{3} ^ 2 + x_{4} ^ 2 = 40.0 \\
        \end{aligned} $$""",
    )
    return
end

function test_nlp_no_objective()
    model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    v = MOI.add_variables(model, 4)
    for i in 1:4
        MOI.set(model, MOI.VariableName(), v[i], "x[$i]")
    end
    lb, ub = [25.0, 40.0], [Inf, 40.0]
    evaluator = MOI.Test.HS071(true)
    block_data = MOI.NLPBlockData(MOI.NLPBoundsPair.(lb, ub), evaluator, false)
    MOI.set(model, MOI.NLPBlock(), block_data)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), v[1])
    @test sprint(print, model) == """
    Minimize VariableIndex:
     x[1]

    Subject to:

    Nonlinear
     x[1] * x[2] * x[3] * x[4] >= 25.0
     x[1] ^ 2 + x[2] ^ 2 + x[3] ^ 2 + x[4] ^ 2 == 40.0
    """
    _string_compare(
        sprint(print, MOIU.latex_formulation(model)),
        raw"""
        $$ \begin{aligned}
        \min\quad & x_{1} \\
        \text{Subject to}\\
         & \text{Nonlinear} \\
         & x_{1} \times x_{2} \times x_{3} \times x_{4} \ge 25.0 \\
         & x_{1} ^ 2 + x_{2} ^ 2 + x_{3} ^ 2 + x_{4} ^ 2 = 40.0 \\
        \end{aligned} $$""",
    )
    return
end

function test_print_with_acronym()
    @test sprint(MOIU.print_with_acronym, "MathOptInterface") == "MOI"
    @test sprint(
        MOIU.print_with_acronym,
        "MathOptInterface.MathOptInterface",
    ) == "MOI.MOI"
    @test sprint(
        MOIU.print_with_acronym,
        "MathOptInterface.Utilities.MathOptInterface",
    ) == "MOIU.MOI"
    @test sprint(MOIU.print_with_acronym, "MathOptInterfaceXXBridges") ==
          "MOIXXBridges"
    @test sprint(MOIU.print_with_acronym, "MathOptInterface.BridgesXX") ==
          "MOIBXX"
    @test sprint(MOIU.print_with_acronym, "MathOptInterface.Test.x") == "MOIT.x"
    @test sprint(MOIU.print_with_acronym, "MathOptInterface.x.Test") ==
          "MOI.x.Test"
    @test sprint(MOIU.print_with_acronym, "MathOptInterface.Utilities.Test") ==
          "MOIU.Test"
    @test sprint(MOIU.print_with_acronym, "MathOptInterface.Utilities.Test") ==
          "MOIU.Test"
    return
end

function test_default_printing()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    aff = 2.0 * x + 1.0
    for mime in (MIME("text/plain"), MIME("text/latex"))
        model = MOI.Utilities._NoVariableNameModel{typeof(mime)}()
        options = MOI.Utilities._PrintOptions(mime)
        for f in (
            x,
            2.0 * x + 1.0,
            2.0 * x + 1.0 + 1.0 * x * y + 2.0 * x * x,
            MOI.Utilities.vectorize([x, y]),
            MOI.Utilities.vectorize([x, 2 // 3 * y + 1 // 4]),
        )
            result = MOI.Utilities._to_string(options, model, f)
            @test sprint(show, mime, f) == result
        end
    end
    @test sprint(show, MIME("text/plain"), x) == "MOI.VariableIndex(1)"
    @test sprint(show, MIME("text/latex"), x) == "v_{1}"
    for f in (x, aff)
        @test sprint(show, f) == sprint(show, MIME("text/plain"), f)
    end
    return
end

function test_scalar_nonlinear_function_print()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariableName(), x, "x")
    f = MOI.ScalarNonlinearFunction(:+, Any[x, 2.0])
    options = MOI.Utilities._PrintOptions(MIME("text/plain"))
    @test MOI.Utilities._to_string(options, model, f) == "+(x, 2.0)"
    return
end

struct TestShow2505 <: MOI.ModelLike end

function test_show_2505()
    model = TestShow2505()
    @test sprint(show, model) == """
    $(typeof(model))
    ├ ObjectiveSense: unknown
    ├ ObjectiveFunctionType: unknown
    ├ NumberOfVariables: unknown
    └ NumberOfConstraints: unknown"""
    return
end

function test_print_model_to_stdout()
    model = MOI.Utilities.Model{Float64}()
    dir = mktempdir()
    d = MOI.Utilities._get_ijulia_latex_display()
    # d is only not nothing if IJulia is running.
    if d === nothing
        open(joinpath(dir, "stdout.log"), "w") do io
            redirect_stdout(io) do
                print(model)
                return
            end
            return
        end
        @test read(joinpath(dir, "stdout.log"), String) ==
              "Feasibility\n\nSubject to:\n"
    end
    io = IOBuffer()
    d = Base.Multimedia.TextDisplay(io)
    @test Base.Multimedia.displayable(d, "text/latex")
    print(model; _latex_display = d)
    seekstart(io)
    prefix = VERSION < v"1.7" ? "" : "\n"
    @test read(io, String) ==
          "\$\$ \\begin{aligned}\n\\text{feasibility}\\\\\n\\text{Subject to}\\\\\n\\end{aligned} \$\$$(prefix)"
    return
end

function test_print_constraint_name_unsupported()
    model = MOI.Utilities.MockOptimizer(
        MOI.Utilities.Model{Float64}();
        supports_names = false,
    )
    x = MOI.add_variable(model)
    MOI.add_constraint(model, 1.0 * x, MOI.LessThan(1.0))
    @test occursin("0.0 + 1.0 v[$(x.value)] <= 1.0", sprint(print, model))
    return
end

end

TestPrint.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module CBF

import ..FileFormats
import MathOptInterface as MOI

MOI.Utilities.@model(
    Model,
    (MOI.Integer,),
    (),
    (
        MOI.Reals,
        MOI.Zeros,
        MOI.Nonnegatives,
        MOI.Nonpositives,
        MOI.SecondOrderCone,
        MOI.RotatedSecondOrderCone,
        MOI.PositiveSemidefiniteConeTriangle,
        MOI.ExponentialCone,
        MOI.DualExponentialCone,
    ),
    (MOI.PowerCone, MOI.DualPowerCone),
    (),
    (),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction,)
)

function MOI.supports_constraint(
    ::Model{T},
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.Utilities.SUPPORTED_VARIABLE_SCALAR_SETS{T}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::Model,
    ::Type{MOI.VariableIndex},
    ::Type{MOI.Integer},
)
    return true
end

MOI.supports(::Model, ::MOI.ObjectiveFunction) = false

function MOI.supports(
    ::Model{T},
    ::MOI.ObjectiveFunction{
        <:Union{MOI.VariableIndex,MOI.ScalarAffineFunction{T}},
    },
) where {T}
    return true
end

"""
    Model()

Create an empty instance of `FileFormats.CBF.Model`.
"""
Model(; kwargs...) = Model{Float64}()

Base.summary(io::IO, ::Model) = print(io, "MOI.FileFormats.CBF.Model")

include("read.jl")
include("write.jl")

end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    CountAtLeastToCountBelongsBridge{T,F} <: Bridges.Constraint.AbstractBridge

`CountAtLeastToCountBelongsBridge` implements the following reformulation:

  * ``x \\in \\textsf{CountAtLeast}(n, d, \\mathcal{S})`` to
    ``(n_i, x_{d_i}) \\in \\textsf{CountBelongs}(1+d, \\mathcal{S})``
    and ``n_i \\ge n`` for all ``i``.

## Source node

`CountAtLeastToCountBelongsBridge` supports:

  * `F` in [`MOI.CountAtLeast`](@ref)

where `F` is [`MOI.VectorOfVariables`](@ref) or
[`MOI.VectorAffineFunction{T}`](@ref).

## Target nodes

`CountAtLeastToCountBelongsBridge` creates:

  * `F` in [`MOI.CountBelongs`](@ref)
  * [`MOI.VariableIndex`](@ref) in [`MOI.GreaterThan{T}`](@ref)
"""
mutable struct CountAtLeastToCountBelongsBridge{
    T,
    F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
} <: AbstractBridge
    f::F
    s::MOI.CountAtLeast
    variables::Vector{MOI.VariableIndex}
    ci::Vector{MOI.ConstraintIndex{F,MOI.CountBelongs}}
    # We need an explicit inner constructor to avoid the unbound type parameter
    # T (it doesn't appear in the fields).
    function CountAtLeastToCountBelongsBridge{T}(
        f::Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}},
        s::MOI.CountAtLeast,
    ) where {T}
        return new{T,typeof(f)}(
            f,
            s,
            MOI.VariableIndex[],
            MOI.ConstraintIndex{typeof(f),MOI.CountBelongs}[],
        )
    end
end

const CountAtLeastToCountBelongs{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{CountAtLeastToCountBelongsBridge{T},OT}

function bridge_constraint(
    ::Type{CountAtLeastToCountBelongsBridge{T,F}},
    model::MOI.ModelLike,
    f::F,
    s::MOI.CountAtLeast,
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    x = collect(MOI.Utilities.eachscalar(f))
    bridge = CountAtLeastToCountBelongsBridge{T}(f, s)
    offset = 0
    for p in s.partitions
        indices = offset .+ (1:p)
        y, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(T(s.n)))
        push!(bridge.variables, y)
        ci = MOI.add_constraint(
            model,
            MOI.Utilities.operate(vcat, T, y, x[indices]...),
            MOI.CountBelongs(1 + p, s.set),
        )
        push!(bridge.ci, ci)
        offset += p
    end
    return bridge
end

function MOI.supports_constraint(
    ::Type{<:CountAtLeastToCountBelongsBridge{T}},
    ::Type{<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}},
    ::Type{MOI.CountAtLeast},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:CountAtLeastToCountBelongsBridge{T}},
) where {T}
    return Tuple{Type}[(MOI.GreaterThan{T},)]
end

function MOI.Bridges.added_constraint_types(
    ::Type{CountAtLeastToCountBelongsBridge{T,F}},
) where {T,F}
    return Tuple{Type,Type}[(F, MOI.CountBelongs)]
end

function concrete_bridge_type(
    ::Type{<:CountAtLeastToCountBelongsBridge{T}},
    ::Type{F},
    ::Type{MOI.CountAtLeast},
) where {T,F<:Union{MOI.VectorOfVariables,MOI.VectorAffineFunction{T}}}
    return CountAtLeastToCountBelongsBridge{T,F}
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintFunction,
    bridge::CountAtLeastToCountBelongsBridge,
)
    return copy(bridge.f)
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::CountAtLeastToCountBelongsBridge,
)
    return bridge.s
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::CountAtLeastToCountBelongsBridge,
)
    for ci in bridge.ci
        MOI.delete(model, ci)
    end
    for x in bridge.variables
        MOI.delete(model, x)
    end
    return
end

function MOI.get(
    bridge::CountAtLeastToCountBelongsBridge,
    ::MOI.NumberOfVariables,
)::Int64
    return length(bridge.variables)
end

function MOI.get(
    bridge::CountAtLeastToCountBelongsBridge,
    ::MOI.ListOfVariableIndices,
)::Vector{MOI.VariableIndex}
    return copy(bridge.variables)
end

function MOI.get(
    bridge::CountAtLeastToCountBelongsBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.CountBelongs},
)::Int64 where {T,F}
    return length(bridge.ci)
end

function MOI.get(
    bridge::CountAtLeastToCountBelongsBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.CountBelongs},
) where {T,F}
    return copy(bridge.ci)
end

function MOI.get(
    bridge::CountAtLeastToCountBelongsBridge{T},
    ::MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}},
)::Int64 where {T}
    return length(bridge.variables)
end

function MOI.get(
    bridge::CountAtLeastToCountBelongsBridge{T},
    ::MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.GreaterThan{T}},
) where {T}
    return [
        MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{T}}(x.value) for
        x in bridge.variables
    ]
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    SplitComplexZerosBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`SplitComplexZerosBridge` implements the following reformulation:

  * ``f(x) \\in \\{0\\}^n`` into ``\\text{Re}(f(x)) \\in \\{0\\}^n`` and
    ``\\text{Im}(f(x)) \\in \\{0\\}^n``

## Source node

`SplitComplexZerosBridge` supports:

  * `G` in [`MOI.Zeros`](@ref)

where `G` is a function with `Complex` coefficients.

## Target nodes

`SplitComplexZerosBridge` creates:

  * `F` in [`MOI.Zeros`](@ref)

where `F` is the type of the real/imaginary part of `G`.
"""
struct SplitComplexZerosBridge{
    T,
    F<:MOI.Utilities.TypedLike{T},
    G<:MOI.Utilities.TypedLike{Complex{T}},
} <: AbstractBridge
    dimension::Int
    constraint::MOI.ConstraintIndex{F,MOI.Zeros}
    real_indices::Vector{Int}
    imag_indices::Vector{Int}
end

const SplitComplexZeros{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{SplitComplexZerosBridge{T},OT}

function _nonzero_indices(func::MOI.AbstractVectorFunction)
    return [
        i for (i, scalar_func) in enumerate(MOI.Utilities.scalarize(func)) if
        !iszero(scalar_func)
    ]
end

function bridge_constraint(
    ::Type{SplitComplexZerosBridge{T,F,G}},
    model::MOI.ModelLike,
    f::G,
    set::MOI.Zeros,
) where {T,F,G}
    real_part = real(f)
    imag_part = MOI.Utilities.operate(imag, T, f)
    real_indices = _nonzero_indices(real_part)
    imag_indices = _nonzero_indices(imag_part)
    func = MOI.Utilities.operate(
        vcat,
        T,
        MOI.Utilities.eachscalar(real_part)[real_indices],
        MOI.Utilities.eachscalar(imag_part)[imag_indices],
    )
    constraint = MOI.add_constraint(
        model,
        func,
        MOI.Zeros(length(real_indices) + length(imag_indices)),
    )
    return SplitComplexZerosBridge{T,F,G}(
        MOI.dimension(set),
        constraint,
        real_indices,
        imag_indices,
    )
end

# We don't support `MOI.VectorOfVariables` as it would be a self-loop in the
# bridge graph
function MOI.supports_constraint(
    ::Type{<:SplitComplexZerosBridge{T}},
    ::Type{<:MOI.Utilities.TypedLike{Complex{T}}},
    ::Type{MOI.Zeros},
) where {T}
    return true
end

function MOI.Bridges.added_constrained_variable_types(
    ::Type{<:SplitComplexZerosBridge},
)
    return Tuple{Type}[]
end

function MOI.Bridges.added_constraint_types(
    ::Type{SplitComplexZerosBridge{T,F,G}},
) where {T,F,G}
    return Tuple{Type,Type}[(F, MOI.Zeros)]
end

function concrete_bridge_type(
    ::Type{<:SplitComplexZerosBridge{T}},
    G::Type{<:MOI.Utilities.TypedLike},
    ::Type{MOI.Zeros},
) where {T}
    F = MA.promote_operation(imag, G)
    return SplitComplexZerosBridge{T,F,G}
end

function MOI.get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::SplitComplexZerosBridge{T,F,G},
) where {T,F,G}
    g = MOI.Utilities.zero_with_output_dimension(G, bridge.dimension)
    f = MOI.get(model, attr, bridge.constraint)
    S = MOI.Utilities.scalar_type(G)
    for (f_i, g_i) in enumerate(bridge.real_indices)
        complex_f = convert(S, MOI.Utilities.eachscalar(f)[f_i])
        MOI.Utilities.operate_output_index!(+, Complex{T}, g_i, g, complex_f)
    end
    for (f_i, g_i) in enumerate(bridge.imag_indices)
        scalar = MOI.Utilities.eachscalar(f)[length(bridge.real_indices)+f_i]
        complex_f = im * scalar
        MOI.Utilities.operate_output_index!(+, Complex{T}, g_i, g, complex_f)
    end
    return g
end

function MOI.get(
    ::MOI.ModelLike,
    ::MOI.ConstraintSet,
    bridge::SplitComplexZerosBridge,
)
    return MOI.Zeros(bridge.dimension)
end

function MOI.get(
    ::SplitComplexZerosBridge{T,F},
    ::MOI.NumberOfConstraints{F,MOI.Zeros},
)::Int64 where {T,F}
    return 1
end

function MOI.get(
    bridge::SplitComplexZerosBridge{T,F},
    ::MOI.ListOfConstraintIndices{F,MOI.Zeros},
) where {T,F}
    return [bridge.constraint]
end

function MOI.delete(model::MOI.ModelLike, bridge::SplitComplexZerosBridge)
    MOI.delete(model, bridge.constraint)
    return
end

function MOI.supports(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    ::Type{<:SplitComplexZerosBridge{T,F}},
) where {T,F}
    return MOI.supports(model, attr, MOI.ConstraintIndex{F,MOI.Zeros})
end

function MOI.get(
    model::MOI.ModelLike,
    attr::Union{
        MOI.ConstraintPrimal,
        MOI.ConstraintPrimalStart,
        MOI.ConstraintDual,
        MOI.ConstraintDualStart,
    },
    bridge::SplitComplexZerosBridge,
)
    values = MOI.get(model, attr, bridge.constraint)
    if values === nothing
        return nothing
    end
    output = zeros(Complex{eltype(values)}, bridge.dimension)
    for (i, idx) in enumerate(bridge.real_indices)
        output[idx] = values[i]
    end
    for (i, idx) in enumerate(bridge.imag_indices)
        output[idx] += values[length(bridge.real_indices)+i] * im
    end
    return output
end

function MOI.set(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    bridge::SplitComplexZerosBridge{T},
    value,
) where {T}
    input = Vector{T}(
        undef,
        length(bridge.real_indices) + length(bridge.imag_indices),
    )
    for (i, idx) in enumerate(bridge.real_indices)
        input[i] = real(value[idx])
    end
    for (i, idx) in enumerate(bridge.imag_indices)
        input[length(bridge.real_indices)+i] = imag(value[idx])
    end
    MOI.set(model, attr, bridge.constraint, input)
    return
end

function MOI.set(
    model::MOI.ModelLike,
    attr::Union{MOI.ConstraintPrimalStart,MOI.ConstraintDualStart},
    bridge::SplitComplexZerosBridge{T},
    ::Nothing,
) where {T}
    MOI.set(model, attr, bridge.constraint, nothing)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    HS071(
        enable_hessian::Bool,
        enable_hessian_vector_product::Bool = false,
    )

An [`MOI.AbstractNLPEvaluator`](@ref) for the problem:

```math
\\begin{aligned}
\\text{min}       \\ & x_1 * x_4 * (x_1 + x_2 + x_3) + x_3 \\\\
\\text{subject to}\\ & x_1 * x_2 * x_3 * x_4 \\ge 25 \\\\
                     & x_1^2 + x_2^2 + x_3^2 + x_4^2 = 40 \\\\
                     & 1 \\le x_1, x_2, x_3, x_4 \\le 5
\\end{aligned}
```

The optimal solution is `[1.000, 4.743, 3.821, 1.379]`.
"""
struct HS071 <: MOI.AbstractNLPEvaluator
    enable_hessian::Bool
    enable_hessian_vector_product::Bool
    function HS071(
        enable_hessian::Bool,
        enable_hessian_vector_product::Bool = false,
    )
        return new(enable_hessian, enable_hessian_vector_product)
    end
end

function MOI.initialize(d::HS071, requested_features::Vector{Symbol})
    for feat in requested_features
        if !(feat in MOI.features_available(d))
            error("Unsupported feature $feat")
        end
    end
    return
end

function MOI.features_available(d::HS071)
    features = [:Grad, :Jac, :JacVec, :ExprGraph]
    if d.enable_hessian
        push!(features, :Hess)
    end
    if d.enable_hessian_vector_product
        return push!(features, :HessVec)
    end
    return features
end

function MOI.objective_expr(::HS071)
    return :(
        x[$(MOI.VariableIndex(1))] *
        x[$(MOI.VariableIndex(4))] *
        (
            x[$(MOI.VariableIndex(1))] +
            x[$(MOI.VariableIndex(2))] +
            x[$(MOI.VariableIndex(3))]
        ) + x[$(MOI.VariableIndex(3))]
    )
end

function MOI.constraint_expr(::HS071, i::Int)
    if i == 1
        return :(
            x[$(MOI.VariableIndex(1))] *
            x[$(MOI.VariableIndex(2))] *
            x[$(MOI.VariableIndex(3))] *
            x[$(MOI.VariableIndex(4))] >= 25.0
        )
    elseif i == 2
        return :(
            x[$(MOI.VariableIndex(1))]^2 +
            x[$(MOI.VariableIndex(2))]^2 +
            x[$(MOI.VariableIndex(3))]^2 +
            x[$(MOI.VariableIndex(4))]^2 == 40.0
        )
    else
        error("Out of bounds constraint.")
    end
end

MOI.eval_objective(::HS071, x) = x[1] * x[4] * (x[1] + x[2] + x[3]) + x[3]

function MOI.eval_constraint(::HS071, g, x)
    g[1] = x[1] * x[2] * x[3] * x[4]
    g[2] = x[1]^2 + x[2]^2 + x[3]^2 + x[4]^2
    return
end

function MOI.eval_objective_gradient(::HS071, grad_f, x)
    grad_f[1] = x[1] * x[4] + x[4] * (x[1] + x[2] + x[3])
    grad_f[2] = x[1] * x[4]
    grad_f[3] = x[1] * x[4] + 1
    grad_f[4] = x[1] * (x[1] + x[2] + x[3])
    return
end

function MOI.constraint_gradient_structure(::HS071, ::Int)
    return [1, 2, 3, 4]
end

function MOI.eval_constraint_gradient(::HS071, ∇g, x, i)
    @assert 1 <= i <= 2
    if i == 1
        ∇g[1] = x[2] * x[3] * x[4]  # 1,1
        ∇g[2] = x[1] * x[3] * x[4]  # 1,2
        ∇g[3] = x[1] * x[2] * x[4]  # 1,3
        ∇g[4] = x[1] * x[2] * x[3]  # 1,4
    else
        ∇g[1] = 2 * x[1]  # 2,1
        ∇g[2] = 2 * x[2]  # 2,2
        ∇g[3] = 2 * x[3]  # 2,3
        ∇g[4] = 2 * x[4]  # 2,4
    end
    return
end

function MOI.jacobian_structure(::HS071)
    return Tuple{Int64,Int64}[
        (1, 1),
        (1, 2),
        (1, 3),
        (1, 4),
        (2, 1),
        (2, 2),
        (2, 3),
        (2, 4),
    ]
end

function MOI.eval_constraint_jacobian(::HS071, J, x)
    # Constraint (row) 1
    J[1] = x[2] * x[3] * x[4]  # 1,1
    J[2] = x[1] * x[3] * x[4]  # 1,2
    J[3] = x[1] * x[2] * x[4]  # 1,3
    J[4] = x[1] * x[2] * x[3]  # 1,4
    # Constraint (row) 2
    J[5] = 2 * x[1]  # 2,1
    J[6] = 2 * x[2]  # 2,2
    J[7] = 2 * x[3]  # 2,3
    J[8] = 2 * x[4]  # 2,4
    return
end

function MOI.eval_constraint_jacobian_product(d::HS071, y, x, w)
    y .= zero(eltype(y))
    indices = MOI.jacobian_structure(d)
    J = zeros(length(indices))
    MOI.eval_constraint_jacobian(d, J, x)
    for ((i, j), val) in zip(indices, J)
        y[i] += val * w[j]
    end
    return
end

function MOI.eval_constraint_jacobian_transpose_product(::HS071, y, x, w)
    y[1] = (x[2] * x[3] * x[4]) * w[1] + (2 * x[1]) * w[2]
    y[2] = (x[1] * x[3] * x[4]) * w[1] + (2 * x[2]) * w[2]
    y[3] = (x[1] * x[2] * x[4]) * w[1] + (2 * x[3]) * w[2]
    y[4] = (x[1] * x[2] * x[3]) * w[1] + (2 * x[4]) * w[2]
    return
end

function MOI.hessian_objective_structure(d::HS071)
    return [(1, 1), (2, 1), (3, 1), (4, 1), (4, 2), (4, 3)]
end

function MOI.eval_hessian_objective(d::HS071, H, x)
    @assert d.enable_hessian
    H[1] = 2 * x[4]                 # 1,1
    H[2] = x[4]                     # 2,1
    H[3] = x[4]                     # 3,1
    H[4] = 2 * x[1] + x[2] + x[3]   # 4,1
    H[5] = x[1]                     # 4,2
    H[6] = x[1]                     # 4,3
    return
end

function MOI.hessian_constraint_structure(d::HS071, i::Int)
    @assert 1 <= i <= 2
    if i == 1
        return [(2, 1), (3, 1), (3, 2), (4, 1), (4, 2), (4, 3)]
    else
        return [(1, 1), (2, 2), (3, 3), (4, 4)]
    end
end

function MOI.eval_hessian_constraint(d::HS071, H, x, i)
    @assert d.enable_hessian
    if i == 1
        H[1] = x[3] * x[4]  # 2,1
        H[2] = x[2] * x[4]  # 3,1
        H[3] = x[1] * x[4]  # 3,2
        H[4] = x[2] * x[3]  # 4,1
        H[5] = x[1] * x[3]  # 4,2
        H[6] = x[1] * x[2]  # 4,3
    else
        H[1] = 2.0  # 1,1
        H[2] = 2.0  # 2,2
        H[3] = 2.0  # 3,3
        H[4] = 2.0  # 4,4
    end
    return
end

function MOI.hessian_lagrangian_structure(d::HS071)
    @assert d.enable_hessian
    return Tuple{Int64,Int64}[
        (1, 1),
        (2, 1),
        (2, 2),
        (3, 1),
        (3, 2),
        (3, 3),
        (4, 1),
        (4, 2),
        (4, 3),
        (4, 4),
    ]
end

function MOI.eval_hessian_lagrangian(d::HS071, H, x, σ, μ)
    @assert d.enable_hessian
    # Again, only lower left triangle
    # Objective
    H[1] = σ * (2 * x[4])               # 1,1
    H[2] = σ * (x[4])               # 2,1
    H[3] = 0                          # 2,2
    H[4] = σ * (x[4])               # 3,1
    H[5] = 0                          # 3,2
    H[6] = 0                          # 3,3
    H[7] = σ * (2 * x[1] + x[2] + x[3])  # 4,1
    H[8] = σ * (x[1])               # 4,2
    H[9] = σ * (x[1])               # 4,3
    H[10] = 0                         # 4,4
    # First constraint
    H[2] += μ[1] * (x[3] * x[4])  # 2,1
    H[4] += μ[1] * (x[2] * x[4])  # 3,1
    H[5] += μ[1] * (x[1] * x[4])  # 3,2
    H[7] += μ[1] * (x[2] * x[3])  # 4,1
    H[8] += μ[1] * (x[1] * x[3])  # 4,2
    H[9] += μ[1] * (x[1] * x[2])  # 4,3
    # Second constraint
    H[1] += μ[2] * 2  # 1,1
    H[3] += μ[2] * 2  # 2,2
    H[6] += μ[2] * 2  # 3,3
    H[10] += μ[2] * 2 # 4,4
    return
end

function MOI.eval_hessian_lagrangian_product(d::HS071, h, x, v, σ, μ)
    @assert d.enable_hessian_vector_product
    # Objective
    h[1] =
        2.0 * x[4] * v[1] +
        x[4] * v[2] +
        x[4] * v[3] +
        (2.0 * x[1] + x[2] + x[3]) * v[4]
    h[2] = x[4] * v[1] + x[1] * v[4]
    h[3] = x[4] * v[1] + x[1] * v[4]
    h[4] = (2.0 * x[1] + x[2] + x[3]) * v[1] + x[1] * v[2] + x[1] * v[3]
    h .*= σ
    # First constraint
    h[1] +=
        μ[1] * (x[3] * x[4] * v[2] + x[2] * x[4] * v[3] + x[2] * x[3] * v[4])
    h[2] +=
        μ[1] * (x[3] * x[4] * v[1] + x[1] * x[4] * v[3] + x[1] * x[3] * v[4])
    h[3] +=
        μ[1] * (x[2] * x[4] * v[1] + x[1] * x[4] * v[2] + x[1] * x[2] * v[4])
    h[4] +=
        μ[1] * (x[2] * x[3] * v[1] + x[1] * x[3] * v[2] + x[1] * x[2] * v[3])
    # Second constraint
    h[1] += μ[2] * 2.0 * v[1]
    h[2] += μ[2] * 2.0 * v[2]
    h[3] += μ[2] * 2.0 * v[3]
    h[4] += μ[2] * 2.0 * v[4]
    return
end

"""
    FeasibilitySenseEvaluator(enable_hessian::Bool)

An AbstractNLPEvaluator for the problem:
```
Test for FEASIBILITY_SENSE.
Find x satisfying x^2 == 1.
```
"""
struct FeasibilitySenseEvaluator <: MOI.AbstractNLPEvaluator
    enable_hessian::Bool
end

function MOI.initialize(
    d::FeasibilitySenseEvaluator,
    requested_features::Vector{Symbol},
)
    for feat in requested_features
        if !(feat in MOI.features_available(d))
            error("Unsupported feature $feat")
            # TODO: implement Jac-vec and Hess-vec products
            # for solvers that need them
        end
    end
    return
end

function MOI.features_available(d::FeasibilitySenseEvaluator)
    if d.enable_hessian
        return [:Grad, :Jac, :Hess, :ExprGraph]
    else
        return [:Grad, :Jac, :ExprGraph]
    end
end

MOI.objective_expr(::FeasibilitySenseEvaluator) = :()

function MOI.constraint_expr(::FeasibilitySenseEvaluator, i::Int)
    @assert i == 1
    return :(x[$(MOI.VariableIndex(1))]^2.0 == 1.0)
end

MOI.eval_objective(d::FeasibilitySenseEvaluator, x) = 0.0

function MOI.eval_constraint(::FeasibilitySenseEvaluator, g, x)
    g[1] = x[1]^2
    return
end

function MOI.eval_objective_gradient(::FeasibilitySenseEvaluator, grad_f, x)
    grad_f[1] = 0.0
    return
end

function MOI.jacobian_structure(::FeasibilitySenseEvaluator)
    return Tuple{Int64,Int64}[(1, 1)]
end

function MOI.hessian_lagrangian_structure(d::FeasibilitySenseEvaluator)
    @assert d.enable_hessian
    return Tuple{Int64,Int64}[(1, 1)]
end

function MOI.eval_constraint_jacobian(::FeasibilitySenseEvaluator, J, x)
    J[1] = 2 * x[1]
    return
end

function MOI.eval_hessian_lagrangian(d::FeasibilitySenseEvaluator, H, x, σ, μ)
    @assert d.enable_hessian
    H[1] = 2 * μ[1] # 1,1
    return
end

function _test_HS071(
    model::MOI.ModelLike,
    config::Config{T},
    evaluator::HS071,
) where {T}
    @requires T == Float64
    @requires MOI.supports(model, MOI.NLPBlock())
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.LessThan{Float64},
    )
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{Float64},
    )
    @requires MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
    lb = [25.0, 40.0]
    ub = [Inf, 40.0]
    block_data = MOI.NLPBlockData(MOI.NLPBoundsPair.(lb, ub), evaluator, true)
    v = MOI.add_variables(model, 4)
    @test MOI.get(model, MOI.NumberOfVariables()) == 4
    l = [1.0, 1.0, 1.0, 1.0]
    u = [5.0, 5.0, 5.0, 5.0]
    start = [1, 5, 5, 1]
    for i in 1:4
        cub = MOI.add_constraint(model, v[i], MOI.LessThan(u[i]))
        # We test this after the creation of every `VariableIndex` constraint
        # to ensure a good coverage of corner cases.
        @test cub.value == v[i].value
        clb = MOI.add_constraint(model, v[i], MOI.GreaterThan(l[i]))
        @test clb.value == v[i].value
        MOI.set(model, MOI.VariablePrimalStart(), v[i], start[i])
    end
    MOI.set(model, MOI.NLPBlock(), block_data)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test MOI.get(model, MOI.ResultCount()) >= 1
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test isapprox(
        MOI.get(model, MOI.ObjectiveValue()),
        17.014017145179164,
        config,
    )
    @test isapprox(
        MOI.get(model, MOI.VariablePrimal(), v),
        [1.0, 4.7429996418092970, 3.8211499817883077, 1.3794082897556983],
        config,
    )
    # TODO: Duals? Maybe better to test on a convex instance.
    return
end

"""
    test_nonlinear_hs071(model::MOI.ModelLike, config::Config)

Test the nonlinear HS071 problem.
"""
function test_nonlinear_hs071(model::MOI.ModelLike, config::Config)
    _test_HS071(model, config, HS071(true))
    return
end

function setup_test(
    ::typeof(test_nonlinear_hs071),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    config.optimal_status = MOI.LOCALLY_SOLVED
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                [
                    1.0,
                    4.7429996418092970,
                    3.8211499817883077,
                    1.379408289755698,
                ],
            )
            MOI.set(mock, MOI.ObjectiveValue(), 17.014017145179164)
        end,
    )
    flag = model.eval_objective_value
    model.eval_objective_value = false
    return () -> model.eval_objective_value = flag
end

"""
    test_nonlinear_hs071_no_hessian(model::MOI.ModelLike, config::Config)

Test the nonlinear HS071 problem without hessians.
"""
function test_nonlinear_hs071_no_hessian(model, config::Config)
    _test_HS071(model, config, HS071(false))
    return
end

function setup_test(
    ::typeof(test_nonlinear_hs071_no_hessian),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    config.optimal_status = MOI.LOCALLY_SOLVED
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                [
                    1.0,
                    4.7429996418092970,
                    3.8211499817883077,
                    1.379408289755698,
                ],
            )
            MOI.set(mock, MOI.ObjectiveValue(), 17.014017145179164)
        end,
    )
    flag = model.eval_objective_value
    model.eval_objective_value = false
    return () -> model.eval_objective_value = flag
end

"""
    test_nonlinear_hs071_hessian_vector_product(
        model::MOI.ModelLike,
        config::Config,
    )

Test the nonlinear HS071 problem with a hessian vector product.
"""
function test_nonlinear_hs071_hessian_vector_product(model, config)
    _test_HS071(model, config, HS071(false, true))
    return
end

function setup_test(
    ::typeof(test_nonlinear_hs071_hessian_vector_product),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    config.optimal_status = MOI.LOCALLY_SOLVED
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                [
                    1.0,
                    4.7429996418092970,
                    3.8211499817883077,
                    1.379408289755698,
                ],
            )
            MOI.set(mock, MOI.ObjectiveValue(), 17.014017145179164)
        end,
    )
    flag = model.eval_objective_value
    model.eval_objective_value = false
    return () -> model.eval_objective_value = flag
end

"""
    test_nonlinear_hs071_NLPBlockDual(model::MOI.ModelLike, config::Config)

Test NLPBlockDual.
"""
function test_nonlinear_hs071_NLPBlockDual(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires MOI.supports(model, MOI.NLPBlock())
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
    @requires _supports(config, MOI.NLPBlockDual)
    n_variables = 4
    v = MOI.add_variables(model, n_variables)
    l = [1.1, 1.2, 1.3, 1.4]
    u = [5.1, 5.2, 5.3, 5.4]
    start = [2.1, 2.2, 2.3, 2.4]
    cl = MOI.add_constraint.(model, v, MOI.GreaterThan.(l))
    cu = MOI.add_constraint.(model, v, MOI.LessThan.(u))
    MOI.set.(model, MOI.VariablePrimalStart(), v, start)
    lb, ub = [25.0, 40.0], [Inf, 40.0]
    evaluator = HS071(true)
    block_data = MOI.NLPBlockData(MOI.NLPBoundsPair.(lb, ub), evaluator, true)
    MOI.set(model, MOI.NLPBlock(), block_data)

    for sense in [MOI.MIN_SENSE, MOI.MAX_SENSE]
        MOI.set(model, MOI.ObjectiveSense(), sense)
        MOI.optimize!(model)
        # Get primal solution
        x = MOI.get(model, MOI.VariablePrimal(), v)
        # Get dual solution
        con_dual = MOI.get(model, MOI.NLPBlockDual())
        var_dual_lb = MOI.get(model, MOI.ConstraintDual(), cl)
        var_dual_ub = MOI.get(model, MOI.ConstraintDual(), cu)

        # Evaluate ∇f(x)
        g = zeros(n_variables)
        MOI.eval_objective_gradient(evaluator, g, x)
        # Evaluate ∑ μᵢ * ∇cᵢ(x)
        jtv = zeros(n_variables)
        MOI.eval_constraint_jacobian_transpose_product(
            evaluator,
            jtv,
            x,
            con_dual,
        )

        # Test that (x, μ, νl, νᵤ) satisfies stationarity condition
        # σ ∇f(x) - ∑ μᵢ * ∇cᵢ(x) - νₗ - νᵤ = 0
        σ = (sense == MOI.MAX_SENSE) ? -1.0 : 1.0
        @test isapprox(σ .* g, jtv .+ var_dual_ub .+ var_dual_lb, config)
    end
    return
end

function setup_test(
    ::typeof(test_nonlinear_hs071_NLPBlockDual),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    config.optimal_status = MOI.LOCALLY_SOLVED
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                [1.1, 1.5735520521364397, 2.6746837915674373, 5.4],
                (MOI.VariableIndex, MOI.GreaterThan{Float64}) =>
                    [28.590703804861093, 0.0, 0.0, 0.0],
                (MOI.VariableIndex, MOI.LessThan{Float64}) =>
                    [0.0, 0.0, 0.0, -5.582550550234756],
            )
            MOI.set(mock, MOI.NLPBlockDual(), [0.178761800, 0.985000823])
        end,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                [
                    4.567633003532132,
                    1.6613736769916652,
                    1.7612041983937636,
                    3.6434497419346723,
                ],
                (MOI.VariableIndex, MOI.GreaterThan{Float64}) =>
                    [0.0, 0.0, 0.0, 0.0],
                (MOI.VariableIndex, MOI.LessThan{Float64}) =>
                    [0.0, 0.0, 0.0, 0.0],
            )
            MOI.set(mock, MOI.NLPBlockDual(), [0.0, -5.008488315])
        end,
    )
    model.eval_variable_constraint_dual = false
    return () -> model.eval_variable_constraint_dual = true
end

"""
    test_nonlinear_objective_and_moi_objective_test(
        model::MOI.ModelLike,
        config::Config,
    )

Test that nonlinear objectives take precedence over MOI.ObjectiveFunction.
"""
function test_nonlinear_objective_and_moi_objective_test(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires MOI.supports(model, MOI.NLPBlock())
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
    lb = [1.0]
    ub = [1.0]
    block_data = MOI.NLPBlockData(
        MOI.NLPBoundsPair.(lb, ub),
        FeasibilitySenseEvaluator(true),
        true,
    )
    x = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    # Avoid starting at zero because it's a critical point.
    MOI.set(model, MOI.VariablePrimalStart(), x, 1.5)
    MOI.set(model, MOI.NLPBlock(), block_data)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f_x = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0)
    # This objective function should be ignored.
    MOI.set(model, MOI.ObjectiveFunction{typeof(f_x)}(), f_x)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test MOI.get(model, MOI.ResultCount()) >= 1
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test isapprox(MOI.get(model, MOI.ObjectiveValue()), 0.0, config)
    xv = MOI.get(model, MOI.VariablePrimal(), x)
    @test isapprox(abs(xv), 1.0, config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_objective_and_moi_objective_test),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    config.optimal_status = MOI.LOCALLY_SOLVED
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(mock, config.optimal_status, [-1.0]),
            MOI.set(mock, MOI.ObjectiveValue(), 0.0)
        end,
    )
    flag = model.eval_objective_value
    model.eval_objective_value = false
    return () -> model.eval_objective_value = flag
end

"""
    test_nonlinear_objective(model::MOI.ModelLike, config::Config)

Test a nonlinear objective only.
"""
function test_nonlinear_objective(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires MOI.supports(model, MOI.NLPBlock())
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
    lb = [1.0]
    ub = [1.0]
    block_data = MOI.NLPBlockData(
        MOI.NLPBoundsPair.(lb, ub),
        FeasibilitySenseEvaluator(true),
        true,
    )
    x = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    # Avoid starting at zero because it's a critical point.
    MOI.set(model, MOI.VariablePrimalStart(), x, 1.5)
    MOI.set(model, MOI.NLPBlock(), block_data)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test MOI.get(model, MOI.ResultCount()) >= 1
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test isapprox(MOI.get(model, MOI.ObjectiveValue()), 0.0, config)
    xv = MOI.get(model, MOI.VariablePrimal(), x)
    @test isapprox(abs(xv), 1.0, config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_objective),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    config.optimal_status = MOI.LOCALLY_SOLVED
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(mock, config.optimal_status, [-1.0]),
            MOI.set(mock, MOI.ObjectiveValue(), 0.0)
        end,
    )
    flag = model.eval_objective_value
    model.eval_objective_value = false
    return () -> model.eval_objective_value = flag
end

"""
    test_nonlinear_without_objective(model::MOI.ModelLike, config::Config)

Test a nonlinear problem without an objective.
"""
function test_nonlinear_without_objective(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires MOI.supports(model, MOI.NLPBlock())
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
    lb = [1.0]
    ub = [1.0]
    block_data = MOI.NLPBlockData(
        MOI.NLPBoundsPair.(lb, ub),
        FeasibilitySenseEvaluator(true),
        false,
    )
    x = MOI.add_variable(model)
    @test MOI.get(model, MOI.NumberOfVariables()) == 1
    # Avoid starting at zero because it's a critical point.
    MOI.set(model, MOI.VariablePrimalStart(), x, 1.5)
    MOI.set(model, MOI.NLPBlock(), block_data)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test MOI.get(model, MOI.ResultCount()) >= 1
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test isapprox(MOI.get(model, MOI.ObjectiveValue()), 0.0, config)
    xv = MOI.get(model, MOI.VariablePrimal(), x)
    @test isapprox(abs(xv), 1.0, config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_without_objective),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    config.optimal_status = MOI.LOCALLY_SOLVED
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(mock, config.optimal_status, [-1.0]),
            MOI.set(mock, MOI.ObjectiveValue(), 0.0)
        end,
    )
    flag = model.eval_objective_value
    model.eval_objective_value = false
    return () -> model.eval_objective_value = flag
end

"""
    test_nonlinear_mixed_complementarity(model::MOI.ModelLike, config::Config)

Test the solution of the linear mixed-complementarity problem:
`F(x) complements x`, where `F(x) = M * x .+ q` and `0 <= x <= 10`.
"""
function test_nonlinear_mixed_complementarity(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorAffineFunction{T},
        MOI.Complements,
    )
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variables(model, 4)
    MOI.add_constraint.(model, x, MOI.Interval(T(0), T(10)))
    MOI.set.(model, MOI.VariablePrimalStart(), x, T(0))
    M = T[0 0 -1 -1; 0 0 1 -2; 1 -1 2 -2; 1 2 -2 4]
    q = T[2; 2; -2; -6]
    terms = MOI.VectorAffineTerm{T}[]
    for i in 1:4
        term = MOI.ScalarAffineTerm(T(1), x[i])
        push!(terms, MOI.VectorAffineTerm(4 + i, term))
        for j in 1:4
            if iszero(M[i, j])
                continue
            end
            term = MOI.ScalarAffineTerm(M[i, j], x[j])
            push!(terms, MOI.VectorAffineTerm(i, term))
        end
    end
    MOI.add_constraint(
        model,
        MOI.VectorAffineFunction(terms, T[q; 0; 0; 0; 0]),
        MOI.Complements(8),
    )
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    x_val = MOI.get.(model, MOI.VariablePrimal(), x)
    @test isapprox(x_val, T[14//5, 0, 4//5, 6//5], config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_mixed_complementarity),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    config.optimal_status = MOI.LOCALLY_SOLVED
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[14//5, 0, 4//5, 6//5],
        ),
    )
    return
end

"""
    test_nonlinear_qp_complementarity_constraint(
        model::MOI.ModelLike,
        config::Config,
    )

Test the solution of the quadratic program with complementarity constraints:

```
    min  (x0 - 5)^2 +(2 x1 + 1)^2
    s.t.  -1.5 x0 + 2 x1 + x2 - 0.5 x3 + x4 = 2
        x2 complements(3 x0 - x1 - 3)
        x3 complements(-x0 + 0.5 x1 + 4)
        x4 complements(-x0 - x1 + 7)
        x0, x1, x2, x3, x4 >= 0

```
which rewrites, with auxiliary variables

```
    min  (x0 - 5)^2 +(2 x1 + 1)^2
    s.t.  -1.5 x0 + 2 x1 + x2 - 0.5 x3 + x4 = 2  (cf1)
        3 x0 - x1 - 3 - x5 = 0                 (cf2)
        -x0 + 0.5 x1 + 4 - x6 = 0              (cf3)
        -x0 - x1 + 7 - x7 = 0                  (cf4)
        x2 complements x5
        x3 complements x6
        x4 complements x7
        x0, x1, x2, x3, x4, x5, x6, x7 >= 0

```
"""
function test_nonlinear_qp_complementarity_constraint(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Complements,
    )
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variables(model, 8)
    MOI.set.(model, MOI.VariablePrimalStart(), x, T(0))
    MOI.add_constraint.(model, x, MOI.GreaterThan(T(0)))
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{Float64}}(),
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.(T[2, 8], x[1:2], x[1:2]),
            MOI.ScalarAffineTerm.(T[-10, 4], x[[1, 2]]),
            T(26),
        ),
    )
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[-3//2, 2, 1, 1//2, 1], x[1:5]),
            T(0),
        ),
        MOI.EqualTo(T(2)),
    )
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[3, -1, -1], x[[1, 2, 6]]),
            T(0),
        ),
        MOI.EqualTo(T(3)),
    )
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T[-1, 1//2, -1], x[[1, 2, 7]]),
            T(0),
        ),
        MOI.EqualTo(T(-4)),
    )
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(T(-1), x[[1, 2, 8]]),
            T(0),
        ),
        MOI.EqualTo(T(-7)),
    )
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables([x[3], x[4], x[5], x[6], x[7], x[8]]),
        MOI.Complements(6),
    )
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMIZE_NOT_CALLED
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    x_val = MOI.get.(model, MOI.VariablePrimal(), x)
    @test isapprox(x_val, T[1, 0, 7//2, 0, 0, 0, 3, 6], config)
    @test isapprox(MOI.get(model, MOI.ObjectiveValue()), T(17), config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_qp_complementarity_constraint),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    config.optimal_status = MOI.LOCALLY_SOLVED
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                T[1, 0, 7//2, 0, 0, 0, 3, 6],
            )
            MOI.set(mock, MOI.ObjectiveValue(), T(17))
        end,
    )
    return
end

"""
    test_nonlinear_HS071_internal(::MOI.ModelLike, ::Config)

A test for the correctness of the HS071 evaluator.

This is mainly for the internal purpose of checking their correctness as
written. External solvers can exclude this test without consequence.
"""
function test_nonlinear_HS071_internal(::MOI.ModelLike, ::Config)
    d = HS071(true, true)
    @test MOI.objective_expr(d) == :(
        x[$(MOI.VariableIndex(1))] *
        x[$(MOI.VariableIndex(4))] *
        (
            x[$(MOI.VariableIndex(1))] +
            x[$(MOI.VariableIndex(2))] +
            x[$(MOI.VariableIndex(3))]
        ) + x[$(MOI.VariableIndex(3))]
    )
    @test MOI.constraint_expr(d, 1) == :(
        x[$(MOI.VariableIndex(1))] *
        x[$(MOI.VariableIndex(2))] *
        x[$(MOI.VariableIndex(3))] *
        x[$(MOI.VariableIndex(4))] >= 25.0
    )
    @test MOI.constraint_expr(d, 2) == :(
        x[$(MOI.VariableIndex(1))]^2 +
        x[$(MOI.VariableIndex(2))]^2 +
        x[$(MOI.VariableIndex(3))]^2 +
        x[$(MOI.VariableIndex(4))]^2 == 40.0
    )
    @test_throws ErrorException MOI.constraint_expr(d, 3)
    MOI.initialize(d, [:Grad, :Jac, :ExprGraph, :Hess, :HessVec])
    @test :HessVec in MOI.features_available(d)
    x = ones(4)
    # f(x)
    @test MOI.eval_objective(d, x) == 4.0
    # g(x)
    g = zeros(2)
    MOI.eval_constraint(d, g, x)
    @test g == [1.0, 4.0]
    # f'(x)
    ∇f = fill(NaN, length(x))
    MOI.eval_objective_gradient(d, ∇f, x)
    @test ∇f == [4.0, 1.0, 2.0, 3.0]
    # Jacobian
    Js = MOI.jacobian_structure(d)
    J = fill(NaN, length(Js))
    MOI.eval_constraint_jacobian(d, J, x)
    @test J == [1, 1, 1, 1, 2, 2, 2, 2]
    # Hessian-Lagrangian
    Hs = MOI.hessian_lagrangian_structure(d)
    H = fill(NaN, length(Hs))
    MOI.eval_hessian_lagrangian(d, H, x, 1.0, [1.0, 1.0])
    @test H == [4, 2, 2, 2, 1, 2, 5, 2, 2, 2]
    # Hessian-Lagrangian-product
    Hv = fill(NaN, length(x))
    v = [1.0, 1.1, 1.2, 1.3]
    MOI.eval_hessian_lagrangian_product(d, Hv, x, v, 1.0, [1.0, 1.0])
    @test Hv == [15.1, 8.0, 8.1, 12.2]
    return
end

"""
    test_nonlinear_Feasibility_internal(::MOI.ModelLike, ::Config)

A test for the correctness of the FeasibilitySenseEvaluator evaluator.

This is mainly for the internal purpose of checking their correctness as
written. External solvers can exclude this test without consequence.
"""
function test_nonlinear_Feasibility_internal(::MOI.ModelLike, ::Config)
    d = FeasibilitySenseEvaluator(true)
    @test MOI.objective_expr(d) == :()
    @test MOI.constraint_expr(d, 1) == :(x[$(MOI.VariableIndex(1))]^2.0 == 1.0)
    @test_throws AssertionError MOI.constraint_expr(d, 2)
    MOI.initialize(d, [:Grad, :Jac, :ExprGraph, :Hess])
    @test :Hess in MOI.features_available(d)
    x = [1.5]
    # f(x)
    @test MOI.eval_objective(d, x) == 0.0
    # g(x)
    g = zeros(1)
    MOI.eval_constraint(d, g, x)
    @test g == [1.5^2]
    # f'(x)
    ∇f = fill(NaN, length(x))
    MOI.eval_objective_gradient(d, ∇f, x)
    @test ∇f == [0.0]
    # Jacobian
    Js = MOI.jacobian_structure(d)
    J = fill(NaN, length(Js))
    MOI.eval_constraint_jacobian(d, J, x)
    @test J == [3.0]
    # Hessian-Lagrangian
    Hs = MOI.hessian_lagrangian_structure(d)
    H = fill(NaN, length(Hs))
    MOI.eval_hessian_lagrangian(d, H, x, 1.0, [1.1])
    @test H == [2.2]
    return
end

"""
    InvalidEvaluator()

An AbstractNLPEvaluator for the problem: `min NaN`, where `eval_objective`
returns a `NaN`.

Solvers should return a `TerminationStatus` of `MOI.INVALID_MODEL`.
"""
struct InvalidEvaluator <: MOI.AbstractNLPEvaluator end

function MOI.initialize(d::InvalidEvaluator, requested_features::Vector{Symbol})
    for feat in requested_features
        @assert feat in MOI.features_available(d)
    end
    return
end

function MOI.features_available(::InvalidEvaluator)
    return [:Grad, :ExprGraph]
end

MOI.objective_expr(::InvalidEvaluator) = :(+($NaN))

MOI.eval_objective(::InvalidEvaluator, x) = NaN

function MOI.eval_objective_gradient(::InvalidEvaluator, grad_f, x)
    grad_f[1] = NaN
    return
end

"""
    test_nonlinear_InvalidEvaluator_internal(::MOI.ModelLike, ::Config)

A test for the correctness of the InvalidEvaluator evaluator.

This is mainly for the internal purpose of checking their correctness as
written. External solvers can exclude this test without consequence.
"""
function test_nonlinear_InvalidEvaluator_internal(::MOI.ModelLike, ::Config)
    d = InvalidEvaluator()
    @test MOI.objective_expr(d) == :(+($NaN))
    MOI.initialize(d, [:Grad, :ExprGraph])
    x = [1.5]
    # f(x)
    @test isnan(MOI.eval_objective(d, x))
    # f'(x)
    ∇f = fill(NaN, length(x))
    MOI.eval_objective_gradient(d, ∇f, x)
    @test isnan(∇f[1])
    return
end

"""
    test_nonlinear_invalid(model::MOI.ModelLike, config::Config)

Test that a nonlinear model returns the TerminationStatus `INVALID_MODEL` if a
NaN is detected in a function evaluation.
"""
function test_nonlinear_invalid(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires MOI.supports(model, MOI.NLPBlock())
    @requires _supports(config, MOI.optimize!)
    MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(
        model,
        MOI.NLPBlock(),
        MOI.NLPBlockData(MOI.NLPBoundsPair[], InvalidEvaluator(), true),
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.INVALID_MODEL
    return
end

function setup_test(
    ::typeof(test_nonlinear_invalid),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(mock, MOI.INVALID_MODEL, [NaN]),
    )
    return
end

function test_nonlinear_expression_hs071(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    @requires MOI.supports_constraint(model, F, MOI.GreaterThan{Float64})
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: w, x, y, z
minobjective: ScalarNonlinearFunction(w * z * (w + x + y) + y)
c2: ScalarNonlinearFunction(w * x * y * z) >= 25.0
c3: ScalarNonlinearFunction(w^2 + x^2 + y^2 + z^2) == 40.0
w in Interval(1.0, 5.0)
x in Interval(1.0, 5.0)
y in Interval(1.0, 5.0)
z in Interval(1.0, 5.0)
""",
    )
    x = MOI.get(model, MOI.ListOfVariableIndices())
    MOI.set.(model, MOI.VariablePrimalStart(), x, [1.0, 5.0, 5.0, 1.0])
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(
        MOI.get.(model, MOI.VariablePrimal(), x),
        [1.0, 4.742999, 3.821150, 1.379408],
        config,
    )
    return
end

function setup_test(
    ::typeof(test_nonlinear_expression_hs071),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                [1.0, 4.742999, 3.821150, 1.379408],
            )
        end,
    )
    return
end

version_added(::typeof(test_nonlinear_expression_hs071)) = v"1.17.0"

function test_nonlinear_expression_hs071_epigraph(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    @requires MOI.supports_constraint(model, F, MOI.GreaterThan{Float64})
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: t, w, x, y, z
minobjective: t
c1: ScalarNonlinearFunction(t - (w * z * (w + x + y) + y)) >= 0.0
c2: ScalarNonlinearFunction(w * x * y * z) >= 25.0
c3: ScalarNonlinearFunction(w^2 + x^2 + y^2 + z^2) == 40.0
w in Interval(1.0, 5.0)
x in Interval(1.0, 5.0)
y in Interval(1.0, 5.0)
z in Interval(1.0, 5.0)
""",
    )
    x = MOI.get(model, MOI.ListOfVariableIndices())
    MOI.set.(model, MOI.VariablePrimalStart(), x, [16.0, 1.0, 5.0, 5.0, 1.0])
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(
        MOI.get.(model, MOI.VariablePrimal(), x),
        [17.014013643792, 1.0, 4.742999, 3.821150, 1.379408],
        config,
    )
    return
end

function setup_test(
    ::typeof(test_nonlinear_expression_hs071_epigraph),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                [17.014013643792, 1.0, 4.742999, 3.821150, 1.379408],
            )
        end,
    )
    return
end

version_added(::typeof(test_nonlinear_expression_hs071_epigraph)) = v"1.17.0"

function test_nonlinear_expression_hs109(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    @requires MOI.supports_constraint(model, F, MOI.GreaterThan{Float64})
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x1, x2, x3, x4, x5, x6, x7, x8, x9
minobjective: ScalarNonlinearFunction(3 * x1 + 1e-6 * x1^3 + 2 * x2 + 0.522074e-6 * x2^3)
x1 >= 0.0
x2 >= 0.0
x3 in Interval(-0.55, 0.55)
x4 in Interval(-0.55, 0.55)
x5 in Interval(196.0, 252.0)
x6 in Interval(196.0, 252.0)
x7 in Interval(196.0, 252.0)
x8 in Interval(-400.0, 800.0)
x9 in Interval(-400.0, 800.0)
c1: ScalarNonlinearFunction(x4 - x3 + 0.55) >= 0.0
c2: ScalarNonlinearFunction(x3 - x4 + 0.55) >= 0.0
c3: ScalarNonlinearFunction(2250000 - x1^2 - x8^2) >= 0.0
c4: ScalarNonlinearFunction(2250000 - x2^2 - x9^2) >= 0.0
c5: ScalarNonlinearFunction(x5 * x6 * sin(-x3 - 0.25) + x5 * x7 * sin(-x4 - 0.25) + 2 * 0.24740395925452294 * x5^2 - 50.176 * x1 + 400 * 50.176) == 0.0
c6: ScalarNonlinearFunction(x5 * x6 * sin(x3 - 0.25) + x6 * x7 * sin(x3 - x4 - 0.25) + 2 * 0.24740395925452294 * x6^2 - 50.176 * x2 + 400 * 50.176) == 0.0
c7: ScalarNonlinearFunction(x5 * x7 * sin(x4 - 0.25) + x6 * x7 * sin(x4 - x3 - 0.25) + 2 * 0.24740395925452294 * x7^2 + 881.779 * 50.176) == 0.0
c8: ScalarNonlinearFunction(50.176 * x8 + x5 * x6 * cos(-x3 - 0.25) + x5 * x7 * cos(-x4 - 0.25) - 200 * 50.176 - 2 * 0.9689124217106447 * x5^2 + 0.7533e-3 * 50.176 * x5^2) == 0.0
c9: ScalarNonlinearFunction(50.176 * x9 + x5 * x6 * cos(x3 - 0.25) + x6 * x7 * cos(x3 - x4 - 0.25) - 2 * 0.9689124217106447 * x6^2 + 0.7533e-3 * 50.176 * x6^2 - 200 * 50.176) == 0.0
c10: ScalarNonlinearFunction(x5 * x7 * cos(x4 - 0.25) + x6 * x7 * cos(x4 - x3 - 0.25) - 2 * 0.9689124217106447 * x7^2 + 22.938 * 50.176 + 0.7533e-3 * 50.176 * x7^2) == 0.0
""",
    )
    x = MOI.get(model, MOI.ListOfVariableIndices())
    MOI.set.(model, MOI.VariablePrimalStart(), x, 0.0)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), 5326.851310161077, config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_expression_hs109),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    flag = model.eval_objective_value
    model.eval_objective_value = false
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                MOI.FEASIBLE_POINT,
            )
            MOI.set(mock, MOI.ObjectiveValue(), 5326.851310161077)
        end,
    )
    return () -> model.eval_objective_value = flag
end

version_added(::typeof(test_nonlinear_expression_hs109)) = v"1.17.0"

function test_nonlinear_expression_hs110(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    f = "log(x1 - 2)^2 + log(10 - x1)^2"
    for i in 2:10
        f *= " + log(x$i - 2)^2 + log(10 - x$i)^2"
    end
    f *= " - (x1 * x2 * x3 * x4 * x5 * x6 * x7 * x8 * x9 * x10)^0.2"
    MOI.Utilities.loadfromstring!(
        model,
        """
        variables: x1, x2, x3, x4, x5, x6, x7, x8, x9, x10
        minobjective: ScalarNonlinearFunction($f)
        x1 in Interval(2.001, 9.999)
        x2 in Interval(2.001, 9.999)
        x3 in Interval(2.001, 9.999)
        x4 in Interval(2.001, 9.999)
        x5 in Interval(2.001, 9.999)
        x6 in Interval(2.001, 9.999)
        x7 in Interval(2.001, 9.999)
        x8 in Interval(2.001, 9.999)
        x9 in Interval(2.001, 9.999)
        x10 in Interval(2.001, 9.999)
        """,
    )
    x = MOI.get(model, MOI.ListOfVariableIndices())
    MOI.set.(model, MOI.VariablePrimalStart(), x, 9.0)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), -45.77846971, config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_expression_hs110),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    flag = model.eval_objective_value
    model.eval_objective_value = false
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                MOI.FEASIBLE_POINT,
            )
            MOI.set(mock, MOI.ObjectiveValue(), -45.77846971)
        end,
    )
    return () -> model.eval_objective_value = flag
end

version_added(::typeof(test_nonlinear_expression_hs110)) = v"1.17.0"

function test_nonlinear_expression_quartic(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x
minobjective: ScalarNonlinearFunction(x^4)
x >= -1.0
""",
    )
    x = MOI.get(model, MOI.ListOfVariableIndices())
    MOI.set.(model, MOI.VariablePrimalStart(), x, [-0.5])
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), 0.0, config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_expression_quartic),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    flag = model.eval_objective_value
    model.eval_objective_value = false
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                MOI.FEASIBLE_POINT,
            )
            MOI.set(mock, MOI.ObjectiveValue(), 0.0)
        end,
    )
    return () -> model.eval_objective_value = flag
end

version_added(::typeof(test_nonlinear_expression_quartic)) = v"1.17.0"

function test_nonlinear_expression_overrides_objective(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.GreaterThan(0.0))
    MOI.add_constraint(model, 1.0 * x[1] + 2.0 * x[2], MOI.LessThan(1.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = MOI.ScalarNonlinearFunction(:+, Any[x[1], x[2]])
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get.(model, MOI.VariablePrimal(), x), [1.0, 0.0], config)
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), 1.0, config)
    f = 2.0 * x[1] + x[2]
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get.(model, MOI.VariablePrimal(), x), [1.0, 0.0], config)
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), 2.0, config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_expression_overrides_objective),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    flag = model.eval_objective_value
    model.eval_objective_value = false
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(mock, config.optimal_status, [1.0, 0.0])
            MOI.set(mock, MOI.ObjectiveValue(), 1.0)
        end,
        (mock) -> begin
            MOI.Utilities.mock_optimize!(mock, config.optimal_status, [1.0, 0.0])
            MOI.set(mock, MOI.ObjectiveValue(), 2.0)
        end,
    )
    return () -> model.eval_objective_value = flag
end

function version_added(::typeof(test_nonlinear_expression_overrides_objective))
    return v"1.17.0"
end

function test_nonlinear_expression_univariate_function(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    @requires MOI.supports(model, MOI.UserDefinedFunction(:my_square, 1))
    my_square(x) = (x - 1)^2
    MOI.set(model, MOI.UserDefinedFunction(:my_square, 1), (my_square,))
    x = MOI.add_variable(model)
    obj = MOI.ScalarNonlinearFunction(:my_square, Any[x])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(1), config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_expression_univariate_function),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(mock, config.optimal_status, [1]),
    )
    return
end

function version_added(::typeof(test_nonlinear_expression_univariate_function))
    return v"1.17.0"
end

function test_nonlinear_expression_multivariate_function(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    @requires MOI.supports(model, MOI.UserDefinedFunction(:my_square, 2))
    f(x, y) = (x - 1)^2 + (y - 2)^2
    function ∇f(g, x, y)
        g[1] = 2 * (x - 1)
        g[2] = 2 * (y - 2)
        return
    end
    g = zeros(2)
    ∇f(g, 2.0, 3.0)
    @test g == [2.0, 2.0]
    MOI.set(model, MOI.UserDefinedFunction(:my_square, 2), (f, ∇f))
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    obj = MOI.ScalarNonlinearFunction(:my_square, Any[x, y])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(obj)}(), obj)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(1), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y), T(2), config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_expression_multivariate_function),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            [1.0, 2.0],
        ),
    )
    return
end

function version_added(
    ::typeof(test_nonlinear_expression_multivariate_function),
)
    return v"1.17.0"
end

"""
    test_nonlinear_duals(model::MOI.ModelLike, config::MOI.Test.Config)

Tests dual solutions with `ScalarNonlinearFunction`. We use a linear program
so that the duals are easy to compute.
"""
function test_nonlinear_duals(model::MOI.ModelLike, config::Config{T}) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports(model, MOI.ObjectiveFunction{F}())
    MOI.Utilities.loadfromstring!(
        model,
        """
variables: x, y, z, r3, r4, r5, r6
minobjective: ScalarNonlinearFunction(-((x + y) / 2.0 + 3.0) / 3.0 - z - r3)
x >= 0.0
y <= 5.0
z in Interval(2.0, 4.0)
r3 in Interval(0.0, 3.0)
r4 in Interval(0.0, 4.0)
r5 in Interval(0.0, 5.0)
r6 in Interval(0.0, 6.0)
cons1: ScalarNonlinearFunction(x + y) >= 2.0
cons2: ScalarNonlinearFunction(r3 + r4 + r5 + x / 2) <= 1.0
cons3: ScalarNonlinearFunction(7.0 * y + - (z + r6 / 1.9)) <= 0.0
""",
    )
    x = MOI.get(model, MOI.ListOfVariableIndices())
    MOI.optimize!(model)
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    @test ≈(
        MOI.get(model, MOI.VariablePrimal(), x),
        [0.9774436, 1.0225564, 4.0, 0.5112782, 0.0, 0.0, 6.0],
        config,
    )
    cons1 = MOI.get(model, MOI.ConstraintIndex, "cons1")
    cons2 = MOI.get(model, MOI.ConstraintIndex, "cons2")
    cons3 = MOI.get(model, MOI.ConstraintIndex, "cons3")
    LB = MOI.ConstraintIndex{MOI.VariableIndex,MOI.GreaterThan{Float64}}
    UB = MOI.ConstraintIndex{MOI.VariableIndex,MOI.LessThan{Float64}}
    IV = MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{Float64}}
    @test ≈(MOI.get(model, MOI.ConstraintDual(), cons1), 1 / 3, config)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), cons2), -1, config)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), cons3), -0.0714286, config)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), LB(x[1].value)), 0.0, config)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), UB(x[2].value)), 0.0, config)
    @test ≈(
        MOI.get(model, MOI.ConstraintDual(), [IV(xi.value) for xi in x[3:end]]),
        [-1.0714286, 0.0, 1.0, 1.0, -0.03759398],
        config,
    )
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), -5.8446115, config)
    f = MOI.get(model, MOI.ObjectiveFunction{F}())
    MOI.set(
        model,
        MOI.ObjectiveFunction{F}(),
        MOI.ScalarNonlinearFunction(:-, Any[f]),
    )
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.PrimalStatus()) == MOI.FEASIBLE_POINT
    @test MOI.get(model, MOI.DualStatus()) == MOI.FEASIBLE_POINT
    @test ≈(
        MOI.get(model, MOI.VariablePrimal(), x),
        [0.9774436, 1.0225564, 4.0, 0.5112782, 0.0, 0.0, 6.0],
        config,
    )
    @test ≈(MOI.get(model, MOI.ConstraintDual(), cons1), 1 / 3, config)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), cons2), -1, config)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), cons3), -0.0714286, config)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), LB(x[1].value)), 0.0, config)
    @test ≈(MOI.get(model, MOI.ConstraintDual(), UB(x[2].value)), 0.0, config)
    @test ≈(
        MOI.get(model, MOI.ConstraintDual(), [IV(xi.value) for xi in x[3:end]]),
        [-1.0714286, 0.0, 1.0, 1.0, -0.03759398],
        config,
    )
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), 5.8446115, config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_duals),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                [0.9774436, 1.0225564, 4.0, 0.5112782, 0.0, 0.0, 6.0],
                (MOI.ScalarNonlinearFunction, MOI.GreaterThan{T}) => T[1/3],
                (MOI.ScalarNonlinearFunction, MOI.LessThan{T}) =>
                    T[-1, -0.0714286],
                (MOI.VariableIndex, MOI.GreaterThan{T}) => [0.0],
                (MOI.VariableIndex, MOI.LessThan{T}) => [0.0],
                (MOI.VariableIndex, MOI.Interval{T}) =>
                    [-1.0714286, 0.0, 1.0, 1.0, -0.03759398],
            )
            MOI.set(mock, MOI.ObjectiveValue(), -5.8446115)
        end,
        mock -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                [0.9774436, 1.0225564, 4.0, 0.5112782, 0.0, 0.0, 6.0],
                (MOI.ScalarNonlinearFunction, MOI.GreaterThan{T}) => T[1/3],
                (MOI.ScalarNonlinearFunction, MOI.LessThan{T}) =>
                    T[-1, -0.0714286],
                (MOI.VariableIndex, MOI.GreaterThan{T}) => [0.0],
                (MOI.VariableIndex, MOI.LessThan{T}) => [0.0],
                (MOI.VariableIndex, MOI.Interval{T}) =>
                    [-1.0714286, 0.0, 1.0, 1.0, -0.03759398],
            )
            MOI.set(mock, MOI.ObjectiveValue(), 5.8446115)
        end,
    )
    flag = model.eval_variable_constraint_dual
    obj_flag = model.eval_objective_value
    model.eval_variable_constraint_dual = false
    model.eval_objective_value = false
    return () -> begin
        model.eval_variable_constraint_dual = flag
        model.eval_objective_value = obj_flag
    end
end

version_added(::typeof(test_nonlinear_duals)) = v"1.17.0"

function test_nonlinear_vector_complements(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires T == Float64
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports_constraint(model, F, MOI.Complements)
    x = MOI.add_variables(model, 4)
    MOI.add_constraint.(model, x, MOI.Interval(T(0), T(10)))
    MOI.set.(model, MOI.VariablePrimalStart(), x, T(1))
    # f = [
    #     -1 * x3^2 + -1 * x4 + 2.0
    #     x3^3 + -1.0 * 2x4^2 + 2.0
    #     x1^5 + -1.0 * x2 + 2.0 * x3 + -2.0 * x4 + -2.0
    #     x1 + 2.0 * x2^3 + -2.0 * x3 + 4.0 * x4 + -6.0
    #     x...
    # ]
    f = MOI.VectorNonlinearFunction([
        MOI.ScalarNonlinearFunction(
            :+,
            Any[
                MOI.ScalarNonlinearFunction(:*, Any[-T(1), x[3], x[3]]),
                MOI.ScalarNonlinearFunction(:*, Any[-T(1), x[4]]),
                T(2),
            ],
        ),
        MOI.ScalarNonlinearFunction(
            :+,
            Any[
                MOI.ScalarNonlinearFunction(:^, Any[x[3], 3]),
                MOI.ScalarNonlinearFunction(:*, Any[-T(2), x[4], x[4]]),
                T(2),
            ],
        ),
        MOI.ScalarNonlinearFunction(
            :+,
            Any[
                MOI.ScalarNonlinearFunction(:^, Any[x[1], 5]),
                MOI.ScalarAffineFunction{T}(
                    MOI.ScalarAffineTerm.(T[-1, 2, -2], x[2:4]),
                    -T(2),
                ),
            ],
        ),
        MOI.ScalarNonlinearFunction(
            :+,
            Any[
                MOI.ScalarNonlinearFunction(:*, Any[T(2), x[2], x[2], x[2]]),
                MOI.ScalarAffineFunction{T}(
                    MOI.ScalarAffineTerm.(T[1, -2, 4], [x[1], x[3], x[4]]),
                    -T(6),
                ),
            ],
        ),
        x[1],
        x[2],
        x[3],
        x[4],
    ])
    MOI.add_constraint(model, f, MOI.Complements(8))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(
        MOI.get.(model, MOI.VariablePrimal(), x),
        T[1.2847523, 0.9729165, 0.9093762, 1.1730350],
        config,
    )
    return
end

function setup_test(
    ::typeof(test_nonlinear_vector_complements),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    if T != Float64
        return  # Skip for non-Float64 solvers
    end
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[1.2847523, 0.9729165, 0.9093762, 1.1730350],
        ),
    )
    return
end

version_added(::typeof(test_nonlinear_vector_complements)) = v"1.19.0"

function test_nonlinear_with_scalar_quadratic_function_with_off_diag(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    F = MOI.ScalarNonlinearFunction
    @requires MOI.supports_constraint(model, F, MOI.EqualTo{T})
    test_cases = [(1, 2, true), (1, 3, false), (2, 3, true), (2, 4, false)]
    for (a, b, status) in test_cases
        MOI.empty!(model)
        x, _ = MOI.add_constrained_variable(model, MOI.EqualTo(T(2)))
        MOI.set(model, MOI.VariablePrimalStart(), x, T(2))
        y, _ = MOI.add_constrained_variable(model, MOI.EqualTo(T(3)))
        MOI.set(model, MOI.VariablePrimalStart(), y, T(3))
        g = T(a) * x * y
        @test g isa MOI.ScalarQuadraticFunction{T}
        f = MOI.ScalarNonlinearFunction(:sqrt, Any[g])
        MOI.add_constraint(model, f, MOI.GreaterThan(T(b)))
        MOI.optimize!(model)
        term_status = MOI.get(model, MOI.TerminationStatus())
        @test (term_status == config.optimal_status) == status
    end
    return
end

function setup_test(
    ::typeof(test_nonlinear_with_scalar_quadratic_function_with_off_diag),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock ->
            MOI.Utilities.mock_optimize!(mock, config.optimal_status, T[2, 3]),
        mock -> MOI.Utilities.mock_optimize!(mock, config.infeasible_status),
        mock ->
            MOI.Utilities.mock_optimize!(mock, config.optimal_status, T[2, 3]),
        mock -> MOI.Utilities.mock_optimize!(mock, config.infeasible_status),
    )
    return
end

function version_added(
    ::typeof(test_nonlinear_with_scalar_quadratic_function_with_off_diag),
)
    return v"1.35.0"
end

function test_nonlinear_constraint_log(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    F, S = MOI.ScalarNonlinearFunction, MOI.GreaterThan{T}
    @requires MOI.supports_constraint(model, F, S)
    x = MOI.add_variable(model)
    t = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.LessThan(T(2)))
    MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    MOI.set(model, MOI.VariablePrimalStart(), x, T(1))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = 1.0 * t
    # max t
    #  x <= 2
    #  log(x) >= t
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    g = MOI.ScalarNonlinearFunction(
        :-,
        Any[MOI.ScalarNonlinearFunction(:log, Any[x]), t],
    )
    c = MOI.add_constraint(model, g, MOI.GreaterThan(T(0)))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    x_val = MOI.get(model, MOI.VariablePrimal(), x)
    t_val = MOI.get(model, MOI.VariablePrimal(), t)
    @test ≈(x_val, T(2), config)
    @test ≈(t_val, log(x_val), config)
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), t_val, config)
    @test (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
    @test c in MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
    return
end

function setup_test(
    ::typeof(test_nonlinear_constraint_log),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[2, log(T(2))],
        ),
    )
    return
end

version_added(::typeof(test_nonlinear_constraint_log)) = v"1.35.0"

function test_nonlinear_constraint_uminus(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    F, S = MOI.ScalarNonlinearFunction, MOI.GreaterThan{T}
    @requires MOI.supports_constraint(model, F, S)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    g = MOI.ScalarNonlinearFunction(:-, Any[x])
    MOI.add_constraint(model, g, MOI.GreaterThan(T(-2)))
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), T(2), config)
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(2), config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_constraint_uminus),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(mock, config.optimal_status, T[2]),
    )
    return
end

version_added(::typeof(test_nonlinear_constraint_uminus)) = v"1.35.0"

function test_nonlinear_constraint_scalar_affine_function(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    F, S = MOI.ScalarNonlinearFunction, MOI.LessThan{T}
    @requires MOI.supports_constraint(model, F, S)
    x1, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(zero(T)))
    x2, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(zero(T)))
    x3, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(zero(T)))
    x4, _ = MOI.add_constrained_variable(model, MOI.GreaterThan(zero(T)))
    f = T(1) * x1 + T(2) * x2 + T(3) * x3
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    h = T(1) * x1 + T(2) * x2 + T(3) * x3 + T(4) * x4
    g = MOI.ScalarNonlinearFunction(:+, Any[h])
    MOI.add_constraint(model, g, MOI.LessThan(T(6)))
    MOI.optimize!(model)
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), T(6), config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_constraint_scalar_affine_function),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[1, 1, 1, 0],
        ),
    )
    return
end

function version_added(
    ::typeof(test_nonlinear_constraint_scalar_affine_function),
)
    return v"1.35.0"
end

function test_nonlinear_quadratic_1(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    F, S = MOI.ScalarNonlinearFunction, MOI.LessThan{T}
    @requires MOI.supports_constraint(model, F, S)
    # max x + y
    # s.t sqrt(*(x, x) + *(y, y)) <= 1
    # x, y >= 0
    #
    # -> x = y = 1/sqrt(2)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariablePrimalStart(), x, T(1))
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariablePrimalStart(), y, T(1))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x + T(1) * y
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    f1 = MOI.ScalarNonlinearFunction(:*, Any[x, x])
    f2 = MOI.ScalarNonlinearFunction(:*, Any[y, y])
    f3 = MOI.ScalarNonlinearFunction(:+, Any[f1, f2])
    g = MOI.ScalarNonlinearFunction(:sqrt, Any[f3])
    c = MOI.add_constraint(model, g, MOI.LessThan(T(1)))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), 2 / sqrt(2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), 1 / sqrt(2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y), 1 / sqrt(2), config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_quadratic_1),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[1/sqrt(2), 1/sqrt(2)],
        ),
    )
    return
end

version_added(::typeof(test_nonlinear_quadratic_1)) = v"1.35.0"

function test_nonlinear_quadratic_2(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    F, S = MOI.ScalarNonlinearFunction, MOI.LessThan{T}
    @requires MOI.supports_constraint(model, F, S)
    # Present products as ScalarAffineTerms nested in ScalarNonlinearFunctions
    # max x + y
    # s.t sqrt(*(x, x) + *(y, y)) <= 1
    # x, y >= 0
    #
    # -> x = y = 1/sqrt(2)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariablePrimalStart(), x, T(1))
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariablePrimalStart(), y, T(1))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x + T(1) * y
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    f1 = MOI.ScalarNonlinearFunction(:*, Any[T(1)*x, x])
    f2 = MOI.ScalarNonlinearFunction(:*, Any[T(1)*y, y])
    f3 = MOI.ScalarNonlinearFunction(:+, Any[f1, f2])
    g = MOI.ScalarNonlinearFunction(:sqrt, Any[f3])
    c = MOI.add_constraint(model, g, MOI.LessThan(T(1)))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), 2 / sqrt(2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), 1 / sqrt(2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y), 1 / sqrt(2), config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_quadratic_2),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[1/sqrt(2), 1/sqrt(2)],
        ),
    )
    return
end

version_added(::typeof(test_nonlinear_quadratic_2)) = v"1.35.0"

function test_nonlinear_quadratic_3(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    F, S = MOI.ScalarNonlinearFunction, MOI.LessThan{T}
    @requires MOI.supports_constraint(model, F, S)
    # Present products as ScalarQuadraticFunctions (complete with 2x factor ...)
    # max x + y
    # s.t sqrt(*(x, x) + *(y, y)) <= 1
    # x, y >= 0
    #
    # -> x = y = 1/sqrt(2)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariablePrimalStart(), x, T(1))
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariablePrimalStart(), y, T(1))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x + T(1) * y
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    f1 = T(1) * x * x
    f2 = T(1) * y * y
    f3 = MOI.ScalarNonlinearFunction(:+, Any[f1, f2])
    g = MOI.ScalarNonlinearFunction(:sqrt, Any[f3])
    c = MOI.add_constraint(model, g, MOI.LessThan(T(1)))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), 2 / sqrt(2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), 1 / sqrt(2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y), 1 / sqrt(2), config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_quadratic_3),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[1/sqrt(2), 1/sqrt(2)],
        ),
    )
    return
end

version_added(::typeof(test_nonlinear_quadratic_3)) = v"1.35.0"

function test_nonlinear_quadratic_4(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    F, S = MOI.ScalarNonlinearFunction, MOI.LessThan{T}
    @requires MOI.supports_constraint(model, F, S)
    # max x + y
    # s.t sqrt(^(x, 2) + ^(y, 2)) <= 1  # Use NL POW(2) operator
    # x, y >= 0
    #
    # -> x = y = 1/sqrt(2)
    x = MOI.add_variable(model)
    MOI.set(model, MOI.VariablePrimalStart(), x, T(1))
    y = MOI.add_variable(model)
    MOI.set(model, MOI.VariablePrimalStart(), y, T(1))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = T(1) * x + T(1) * y
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    f1 = MOI.ScalarNonlinearFunction(:^, Any[x, 2])
    f2 = MOI.ScalarNonlinearFunction(:^, Any[y, 2])
    f3 = MOI.ScalarNonlinearFunction(:+, Any[f1, f2])
    g = MOI.ScalarNonlinearFunction(:sqrt, Any[f3])
    c = MOI.add_constraint(model, g, MOI.LessThan(T(1)))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test ≈(MOI.get(model, MOI.ObjectiveValue()), 2 / sqrt(2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), x), 1 / sqrt(2), config)
    @test ≈(MOI.get(model, MOI.VariablePrimal(), y), 1 / sqrt(2), config)
    return
end

function setup_test(
    ::typeof(test_nonlinear_quadratic_4),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[1/sqrt(2), 1/sqrt(2)],
        ),
    )
    return
end

version_added(::typeof(test_nonlinear_quadratic_4)) = v"1.35.0"

function test_vector_nonlinear_oracle(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.VectorNonlinearOracle{T},
    )
    set = MOI.VectorNonlinearOracle(;
        dimension = 5,
        l = T[0, 0],
        u = T[0, 0],
        eval_f = (ret, x) -> begin
            @test length(ret) == 2
            @test length(x) == 5
            ret[1] = x[1]^2 - x[4]
            ret[2] = x[2]^2 + x[3]^3 - x[5]
            return
        end,
        jacobian_structure = [(1, 1), (2, 2), (2, 3), (1, 4), (2, 5)],
        eval_jacobian = (ret, x) -> begin
            @test length(ret) == 5
            @test length(x) == 5
            ret[1] = T(2) * x[1]
            ret[2] = T(2) * x[2]
            ret[3] = T(3) * x[3]^2
            ret[4] = -T(1)
            ret[5] = -T(1)
            return
        end,
        hessian_lagrangian_structure = [(1, 1), (2, 2), (3, 3)],
        eval_hessian_lagrangian = (ret, x, u) -> begin
            @test length(ret) == 3
            @test length(x) == 5
            @test length(u) == 2
            ret[1] = T(2) * u[1]
            ret[2] = T(2) * u[2]
            ret[3] = T(6) * x[3] * u[2]
            return
        end,
    )
    @test MOI.dimension(set) == 5
    x = T[1, 2, 3, 4, 5]
    ret = T[0, 0]
    set.eval_f(ret, x)
    @test ret == T[-3, 26]
    ret = T[0, 0, 0, 0, 0]
    set.eval_jacobian(ret, x)
    @test ret == T[2, 4, 27, -1, -1]
    ret = T[0, 0, 0]
    set.eval_hessian_lagrangian(ret, x, T[2, 3])
    @test ret == T[4, 6, 54]
    x, y = MOI.add_variables(model, 3), MOI.add_variables(model, 2)
    MOI.add_constraints.(model, x, MOI.EqualTo.(T(1):T(3)))
    c = MOI.add_constraint(model, MOI.VectorOfVariables([x; y]), set)
    MOI.optimize!(model)
    x_v = MOI.get.(model, MOI.VariablePrimal(), x)
    y_v = MOI.get.(model, MOI.VariablePrimal(), y)
    @test ≈(y_v, [x_v[1]^2, x_v[2]^2 + x_v[3]^3], config)
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), [x_v; y_v], config)
    if _supports(config, MOI.ConstraintDual)
        @test ≈(MOI.get(model, MOI.ConstraintDual(), c), zeros(T, 5), config)
    end
    return
end

function setup_test(
    ::typeof(test_vector_nonlinear_oracle),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[1, 2, 3, 1, 31],
            (MOI.VectorOfVariables, MOI.VectorNonlinearOracle{T}) =>
                [zeros(T, 5)],
        ),
    )
    model.eval_variable_constraint_dual = false
    return () -> model.eval_variable_constraint_dual = true
end

version_added(::typeof(test_vector_nonlinear_oracle)) = v"1.46.0"

function test_vector_nonlinear_oracle_no_hessian(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.VectorNonlinearOracle{T},
    )
    set = MOI.VectorNonlinearOracle(;
        dimension = 5,
        l = T[0, 0],
        u = T[0, 0],
        eval_f = (ret, x) -> begin
            ret[1] = x[1]^2 - x[4]
            ret[2] = x[2]^2 + x[3]^3 - x[5]
            return
        end,
        jacobian_structure = [(1, 1), (2, 2), (2, 3), (1, 4), (2, 5)],
        eval_jacobian = (ret, x) -> begin
            ret[1] = T(2) * x[1]
            ret[2] = T(2) * x[2]
            ret[3] = T(3) * x[3]^2
            ret[4] = -T(1)
            ret[5] = -T(1)
            return
        end,
    )
    @test MOI.dimension(set) == 5
    x = T[1, 2, 3, 4, 5]
    ret = T[0, 0]
    set.eval_f(ret, x)
    @test ret == T[-3, 26]
    ret = T[0, 0, 0, 0, 0]
    set.eval_jacobian(ret, x)
    @test ret == T[2, 4, 27, -1, -1]
    @test isempty(set.hessian_lagrangian_structure)
    @test set.eval_hessian_lagrangian === nothing
    x, y = MOI.add_variables(model, 3), MOI.add_variables(model, 2)
    MOI.add_constraints.(model, x, MOI.EqualTo.(T(1):T(3)))
    c = MOI.add_constraint(model, MOI.VectorOfVariables([x; y]), set)
    MOI.optimize!(model)
    x_v = MOI.get.(model, MOI.VariablePrimal(), x)
    y_v = MOI.get.(model, MOI.VariablePrimal(), y)
    @test ≈(y_v, [x_v[1]^2, x_v[2]^2 + x_v[3]^3], config)
    @test ≈(MOI.get(model, MOI.ConstraintPrimal(), c), [x_v; y_v], config)
    if _supports(config, MOI.ConstraintDual)
        @test ≈(MOI.get(model, MOI.ConstraintDual(), c), zeros(T, 5), config)
    end
    return
end

function setup_test(
    ::typeof(test_vector_nonlinear_oracle_no_hessian),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> MOI.Utilities.mock_optimize!(
            mock,
            config.optimal_status,
            T[1, 2, 3, 1, 31],
            (MOI.VectorOfVariables, MOI.VectorNonlinearOracle{T}) =>
                [zeros(T, 5)],
        ),
    )
    model.eval_variable_constraint_dual = false
    return () -> model.eval_variable_constraint_dual = true
end

version_added(::typeof(test_vector_nonlinear_oracle_no_hessian)) = v"1.46.0"

function test_VectorNonlinearOracle_LagrangeMultipliers_MAX_SENSE(
    model::MOI.ModelLike,
    config::MOI.Test.Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    @requires _supports(config, MOI.LagrangeMultiplier)
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.VectorNonlinearOracle{T},
    )
    set = MOI.VectorNonlinearOracle(;
        dimension = 2,
        l = T[typemin(T)],
        u = T[1],
        eval_f = (ret, x) -> (ret[1] = x[1]^2 + x[2]^2),
        jacobian_structure = [(1, 1), (1, 2)],
        eval_jacobian = (ret, x) -> ret .= T(2) .* x,
        hessian_lagrangian_structure = [(1, 1), (2, 2)],
        eval_hessian_lagrangian = (ret, x, u) -> ret .= T(2) .* u[1],
    )
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = one(T) * x[1] + one(T) * x[2]
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(model, MOI.VectorOfVariables(x), set)
    y = T(1) / sqrt(T(2))
    CI = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.VectorNonlinearOracle{T}}
    if MOI.supports(model, MOI.LagrangeMultiplierStart(), CI)
        MOI.set(model, MOI.LagrangeMultiplierStart(), c, T[-y])
    end
    MOI.optimize!(model)
    @test isapprox(MOI.get(model, MOI.VariablePrimal(), x), [y, y], config)
    @test isapprox(MOI.get(model, MOI.ConstraintDual(), c), T[-1, -1], config)
    @test isapprox(MOI.get(model, MOI.LagrangeMultiplier(), c), T[-y])
    # Test `set` just for code coverage
    x = T[1, 2]
    ret = T[0]
    set.eval_f(ret, x)
    @test ret == T[5]
    ret = T[0, 0]
    set.eval_jacobian(ret, x)
    @test ret == T[2, 4]
    set.eval_hessian_lagrangian(ret, x, T[-1])
    @test ret == [-2, -2]
    return
end

function setup_test(
    ::typeof(test_VectorNonlinearOracle_LagrangeMultipliers_MAX_SENSE),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    F, S = MOI.VectorOfVariables, MOI.VectorNonlinearOracle{T}
    y = T(1) / sqrt(T(2))
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                T[y, y],
                (F, S) => [T[-1, -1]],
            )
            ci = only(MOI.get(mock, MOI.ListOfConstraintIndices{F,S}()))
            MOI.set(mock, MOI.LagrangeMultiplier(), ci, T[-y])
        end,
    )
    model.eval_variable_constraint_dual = false
    return () -> model.eval_variable_constraint_dual = true
end

function version_added(
    ::typeof(test_VectorNonlinearOracle_LagrangeMultipliers_MAX_SENSE),
)
    return v"1.48.0"
end

function test_VectorNonlinearOracle_LagrangeMultipliers_MIN_SENSE(
    model::MOI.ModelLike,
    config::MOI.Test.Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    @requires _supports(config, MOI.ConstraintDual)
    @requires _supports(config, MOI.LagrangeMultiplier)
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.VectorNonlinearOracle{T},
    )
    set = MOI.VectorNonlinearOracle(;
        dimension = 2,
        l = T[-1],
        u = T[typemax(T)],
        eval_f = (ret, x) -> (ret[1] = -x[1]^2 - x[2]^2),
        jacobian_structure = [(1, 1), (1, 2)],
        eval_jacobian = (ret, x) -> ret .= -T(2) .* x,
        hessian_lagrangian_structure = [(1, 1), (2, 2)],
        eval_hessian_lagrangian = (ret, x, u) -> ret .= -T(2) .* u[1],
    )
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = one(T) * x[1] + one(T) * x[2]
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    c = MOI.add_constraint(model, MOI.VectorOfVariables(x), set)
    y = T(1) / sqrt(T(2))
    CI = MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.VectorNonlinearOracle{T}}
    if MOI.supports(model, MOI.LagrangeMultiplierStart(), CI)
        MOI.set(model, MOI.LagrangeMultiplierStart(), c, T[y])
    end
    MOI.optimize!(model)
    @test isapprox(MOI.get(model, MOI.VariablePrimal(), x), [-y, -y], config)
    @test isapprox(MOI.get(model, MOI.ConstraintDual(), c), T[1, 1], config)
    @test isapprox(MOI.get(model, MOI.LagrangeMultiplier(), c), T[y])
    # Test `set` just for code coverage
    x = T[1, 2]
    ret = T[0]
    set.eval_f(ret, x)
    @test ret == T[-5]
    ret = T[0, 0]
    set.eval_jacobian(ret, x)
    @test ret == T[-2, -4]
    set.eval_hessian_lagrangian(ret, x, T[-1])
    @test ret == [2, 2]
    return
end

function setup_test(
    ::typeof(test_VectorNonlinearOracle_LagrangeMultipliers_MIN_SENSE),
    model::MOIU.MockOptimizer,
    config::Config{T},
) where {T}
    F, S = MOI.VectorOfVariables, MOI.VectorNonlinearOracle{T}
    y = T(1) / sqrt(T(2))
    MOI.Utilities.set_mock_optimize!(
        model,
        mock -> begin
            MOI.Utilities.mock_optimize!(
                mock,
                config.optimal_status,
                T[-y, -y],
                (F, S) => [T[1, 1]],
            )
            ci = only(MOI.get(mock, MOI.ListOfConstraintIndices{F,S}()))
            MOI.set(mock, MOI.LagrangeMultiplier(), ci, T[y])
        end,
    )
    model.eval_variable_constraint_dual = false
    return () -> model.eval_variable_constraint_dual = true
end

function version_added(
    ::typeof(test_VectorNonlinearOracle_LagrangeMultipliers_MIN_SENSE),
)
    return v"1.48.0"
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestUtilitiesConstraints

using Test
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_normalize_and_add_constrant_VariableIndex()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    ci = MOI.Utilities.normalize_and_add_constraint(
        model,
        x,
        MOI.EqualTo(1.0),
        allow_modify_function = false,
    )
    @test MOI.get(model, MOI.ConstraintFunction(), ci) == x
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.EqualTo(1.0)
    return
end

function test_normalize_and_add_constrant_ScalarAffineFunction()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 2.0)
    int = MOI.Utilities.normalize_and_add_constraint(model, f, MOI.Integer())
    @test f.constant == 2.0
    @test MOI.get(model, MOI.ConstraintFunction(), int) ≈ f
    @test MOI.get(model, MOI.ConstraintSet(), int) == MOI.Integer()
    g = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0)
    ci = MOI.Utilities.normalize_and_add_constraint(model, f, MOI.EqualTo(3.0))
    @test f.constant == 2.0
    @test MOI.get(model, MOI.ConstraintFunction(), ci) ≈ g
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.EqualTo(1.0)
    ci = MOI.Utilities.normalize_and_add_constraint(
        model,
        f,
        MOI.Interval(-1.0, 1.0),
        allow_modify_function = true,
    )
    @test f.constant == 0.0
    @test MOI.get(model, MOI.ConstraintFunction(), ci) ≈ g
    @test MOI.get(model, MOI.ConstraintSet(), ci) == MOI.Interval(-3.0, -1.0)
    return
end

end  # module

TestUtilitiesConstraints.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestModelRuntests

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_MOI_Test()
    MOI.Test.runtests(
        MOI.Utilities.Model{Float64}(),
        MOI.Test.Config(exclude = Any[MOI.optimize!,]),
    )
    return
end

end  # module

TestModelRuntests.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Test with a bridge for which the map is defined on the bridge value and not
# the bridge type
module TestSetMapBridge

using Test

import MathOptInterface as MOI

@enum(ErrType, NONE, NOT_INVERTIBLE, OTHER)

# Constraints `[f[2], f[1]]` if `swap` and otherwise `f` to `Nonnegatives`
struct SwapSet <: MOI.AbstractVectorSet
    swap::Bool
    err::ErrType
end

MOI.dimension(::SwapSet) = 2

struct VariableSwapBridge{T} <:
       MOI.Bridges.Variable.SetMapBridge{T,MOI.Nonnegatives,SwapSet}
    variables::MOI.Vector{MOI.VariableIndex}
    constraint::MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives}
    set::SwapSet
end

function MOI.Bridges.Variable.bridge_constrained_variable(
    ::Type{VariableSwapBridge{T}},
    model::MOI.ModelLike,
    set::SwapSet,
) where {T}
    variables, constraint =
        MOI.add_constrained_variables(model, MOI.Nonnegatives(2))
    return VariableSwapBridge{T}(variables, constraint, set)
end

MOI.Bridges.map_set(bridge::VariableSwapBridge, ::MOI.Nonnegatives) = bridge.set

function MOI.Bridges.inverse_map_set(bridge::VariableSwapBridge, set::SwapSet)
    if set.swap != bridge.set.swap
        error("Cannot change swap set")
    end
    return MOI.Nonnegatives(2)
end

function MOI.Bridges.map_function(
    bridge::VariableSwapBridge,
    func,
    i::MOI.Bridges.IndexInVector,
)
    return MOI.Bridges.map_function(bridge, func)[i.value]
end

# Workaround until https://github.com/jump-dev/MathOptInterface.jl/issues/2117 is fixed
MOI.Bridges.inverse_map_function(::VariableSwapBridge, a) = a

struct ConstraintSwapBridge{T} <: MOI.Bridges.Constraint.SetMapBridge{
    T,
    MOI.Nonnegatives,
    SwapSet,
    MOI.VectorOfVariables,
    MOI.VectorOfVariables,
}
    constraint::MOI.ConstraintIndex{MOI.VectorOfVariables,MOI.Nonnegatives}
    set::SwapSet
end

function MOI.Bridges.Constraint.bridge_constraint(
    ::Type{ConstraintSwapBridge{T}},
    model::MOI.ModelLike,
    func::MOI.VectorOfVariables,
    set::SwapSet,
) where {T}
    ci = MOI.add_constraint(
        model,
        MOI.VectorOfVariables(swap(func.variables, set.swap)),
        MOI.Nonnegatives(2),
    )
    return ConstraintSwapBridge{T}(ci, set)
end

function MOI.Bridges.map_set(bridge::ConstraintSwapBridge, set::SwapSet)
    if set.swap != bridge.set.swap
        error("Cannot change swap set")
    end
    return MOI.Nonnegatives(2)
end

function MOI.Bridges.inverse_map_set(
    bridge::ConstraintSwapBridge,
    ::MOI.Nonnegatives,
)
    return bridge.set
end

# Otherwise, it fails Bridges.runtests for `NOT_INVERTIBLE`
function MOI.supports(
    ::MOI.ModelLike,
    ::MOI.ConstraintDualStart,
    ::Type{<:ConstraintSwapBridge},
)
    return false
end

const SwapBridge{T} = Union{VariableSwapBridge{T},ConstraintSwapBridge{T}}

function MOI.Bridges.map_function(bridge::SwapBridge, func)
    return swap(func, bridge.set.swap)
end

function MOI.Bridges.inverse_map_function(bridge::SwapBridge, func)
    if bridge.set.err == NONE
        return swap(func, bridge.set.swap)
    elseif bridge.set.err == NOT_INVERTIBLE
        throw(MOI.Bridges.MapNotInvertible("no luck"))
    else
        error()
    end
end

function MOI.Bridges.adjoint_map_function(bridge::SwapBridge, func)
    return swap(func, bridge.set.swap)
end

function MOI.Bridges.inverse_adjoint_map_function(bridge::SwapBridge, func)
    if bridge.set.err == NONE
        return swap(func, bridge.set.swap)
    elseif bridge.set.err == NOT_INVERTIBLE
        throw(MOI.Bridges.MapNotInvertible("no luck"))
    else
        error()
    end
end

swap(x, swap::Bool) = swap ? [x[2], x[1]] : x

function swap(f::MOI.VectorOfVariables, do_swap::Bool)
    return MOI.VectorOfVariables(swap(f.variables, do_swap))
end

function test_other_error()
    model = MOI.Bridges.Constraint.SingleBridgeOptimizer{
        ConstraintSwapBridge{Float64},
    }(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    x = MOI.add_variables(model, 2)
    func = MOI.VectorOfVariables(x)
    ci = MOI.add_constraint(model, func, SwapSet(true, OTHER))
    @test_throws(
        ErrorException(""),
        MOI.get(model, MOI.ConstraintFunction(), ci),
    )
    MOI.set(model, MOI.ConstraintPrimalStart(), ci, ones(2))
    @test_throws(
        ErrorException(""),
        MOI.get(model, MOI.ConstraintPrimalStart(), ci),
    )
    @test_throws(
        ErrorException(""),
        MOI.set(model, MOI.ConstraintDualStart(), ci, ones(2)),
    )
    return
end

function test_constraint_not_invertible()
    model = MOI.Bridges.Constraint.SingleBridgeOptimizer{
        ConstraintSwapBridge{Float64},
    }(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    x = MOI.add_variables(model, 2)
    func = MOI.VectorOfVariables(x)
    ci = MOI.add_constraint(model, func, SwapSet(true, NOT_INVERTIBLE))
    @test_throws(
        ErrorException("Cannot change swap set"),
        MOI.set(model, MOI.ConstraintSet(), ci, SwapSet(false, NOT_INVERTIBLE)),
    )
    @test_throws(
        MOI.GetAttributeNotAllowed(
            MOI.ConstraintFunction(),
            "Cannot get `MathOptInterface.ConstraintFunction()` as the constraint is reformulated through a linear transformation that is not invertible. no luck",
        ),
        MOI.get(model, MOI.ConstraintFunction(), ci),
    )
    MOI.set(model, MOI.ConstraintPrimalStart(), ci, ones(2))
    @test_throws(
        MOI.GetAttributeNotAllowed(
            MOI.ConstraintPrimalStart(),
            "Cannot get `MathOptInterface.ConstraintPrimalStart()` as the constraint is reformulated through a linear transformation that is not invertible. no luck",
        ),
        MOI.get(model, MOI.ConstraintPrimalStart(), ci),
    )
    @test_throws(
        MOI.SetAttributeNotAllowed(
            MOI.ConstraintDualStart(),
            "Cannot get `MathOptInterface.ConstraintDualStart()` as the constraint is reformulated through a linear transformation that is not invertible. no luck",
        ),
        MOI.set(model, MOI.ConstraintDualStart(), ci, ones(2)),
    )
    return
end

function test_runtests()
    for do_swap in [false, true]
        MOI.Bridges.runtests(
            ConstraintSwapBridge,
            model -> begin
                x = MOI.add_variables(model, 2)
                func = MOI.VectorOfVariables(x)
                set = SwapSet(do_swap, NONE)
                MOI.add_constraint(model, func, set)
            end,
            model -> begin
                x = MOI.add_variables(model, 2)
                func = MOI.VectorOfVariables(swap(x, do_swap))
                set = MOI.Nonnegatives(2)
                MOI.add_constraint(model, func, set)
            end,
        )
        MOI.Bridges.runtests(
            ConstraintSwapBridge,
            model -> begin
                x = MOI.add_variables(model, 2)
                func = MOI.VectorOfVariables(x)
                set = SwapSet(do_swap, NOT_INVERTIBLE)
                MOI.add_constraint(model, func, set)
            end,
            model -> begin
                x = MOI.add_variables(model, 2)
                func = MOI.VectorOfVariables(swap(x, do_swap))
                set = MOI.Nonnegatives(2)
                MOI.add_constraint(model, func, set)
            end,
            cannot_unbridge = true,
        )
        MOI.Bridges.runtests(
            VariableSwapBridge,
            model -> begin
                set = SwapSet(do_swap, NONE)
                x = MOI.add_constrained_variables(model, set)
            end,
            model -> begin
                set = MOI.Nonnegatives(2)
                x = MOI.add_constrained_variables(model, set)
            end,
        )
    end
    return
end

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

end  # module

TestSetMapBridge.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    struct ModifyConstraintNotAllowed{F<:AbstractFunction, S<:AbstractSet,
                                      C<:AbstractFunctionModification} <: NotAllowedError
        constraint_index::ConstraintIndex{F, S}
        change::C
        message::String
    end

An error indicating that the constraint modification `change` cannot be applied
to the constraint of index `ci`.
"""
struct ModifyConstraintNotAllowed{
    F<:AbstractFunction,
    S<:AbstractSet,
    C<:AbstractFunctionModification,
} <: NotAllowedError
    constraint_index::ConstraintIndex{F,S}
    change::C
    message::String
end

function ModifyConstraintNotAllowed(
    ci::ConstraintIndex{F,S},
    change::AbstractFunctionModification,
    message = "",
) where {F<:AbstractFunction,S<:AbstractSet}
    return ModifyConstraintNotAllowed{F,S,typeof(change)}(ci, change, message)
end

function throw_modify_not_allowed(ci::ConstraintIndex, args...)
    return throw(ModifyConstraintNotAllowed(ci, args...))
end

function operation_name(err::ModifyConstraintNotAllowed{F,S}) where {F,S}
    return "Modifying the constraints $(err.constraint_index) with $(err.change)"
end

"""
    struct ModifyObjectiveNotAllowed{C<:AbstractFunctionModification} <: NotAllowedError
        change::C
        message::String
    end

An error indicating that the objective modification `change` cannot be applied
to the objective.
"""
struct ModifyObjectiveNotAllowed{C<:AbstractFunctionModification} <:
       NotAllowedError
    change::C
    message::String
end

function ModifyObjectiveNotAllowed(change::AbstractFunctionModification)
    return ModifyObjectiveNotAllowed(change, "")
end

function throw_modify_not_allowed(::ObjectiveFunction, args...)
    return throw(ModifyObjectiveNotAllowed(args...))
end

function operation_name(err::ModifyObjectiveNotAllowed)
    return "Modifying the objective function with $(err.change)"
end

"""
    modify(
        model::ModelLike,
        ci::ConstraintIndex,
        change::AbstractFunctionModification,
    )

Apply the modification specified by `change` to the function of constraint `ci`.

An [`ModifyConstraintNotAllowed`](@ref) error is thrown if modifying
constraints is not supported by the model `model`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> ci = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(1.0));

julia> MOI.modify(model, ci, MOI.ScalarConstantChange(10.0))

julia> print(model)
Feasibility

Subject to:

ScalarAffineFunction{Float64}-in-EqualTo{Float64}
 10.0 + 1.0 v[1] == 1.0
```
"""
function modify(
    model::ModelLike,
    ci::ConstraintIndex,
    change::AbstractFunctionModification,
)
    return throw_modify_not_allowed(ci, change)
end

"""
    modify(
        model::ModelLike,
        cis::AbstractVector{<:ConstraintIndex},
        changes::AbstractVector{<:AbstractFunctionModification},
    )

Apply multiple modifications specified by `changes` to the functions of constraints `cis`.

A [`ModifyConstraintNotAllowed`](@ref) error is thrown if modifying
constraints is not supported by `model`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 2);

julia> ci = MOI.add_constraint.(model, 1.0 .* x, MOI.EqualTo(1.0));

julia> MOI.modify(model, ci, MOI.ScalarCoefficientChange.(x, [2.0, 0.5]))

julia> print(model)
Feasibility

Subject to:

ScalarAffineFunction{Float64}-in-EqualTo{Float64}
 0.0 + 2.0 v[1] == 1.0
 0.0 + 0.5 v[2] == 1.0
```
"""
function modify(
    model::ModelLike,
    cis::AbstractVector{<:ConstraintIndex},
    changes::AbstractVector{<:AbstractFunctionModification},
)
    @assert length(cis) == length(changes)
    for (ci, change) in zip(cis, changes)
        modify(model, ci, change)
    end
    return
end

"""
    modify(model::ModelLike, ::ObjectiveFunction, change::AbstractFunctionModification)

Apply the modification specified by `change` to the objective function of
`model`. To change the function completely, call `set` instead.

An [`ModifyObjectiveNotAllowed`](@ref) error is thrown if modifying
objectives is not supported by the model `model`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)

julia> f = 1.0 * x;

julia> attr = MOI.ObjectiveFunction{typeof(f)}()
MathOptInterface.ObjectiveFunction{MathOptInterface.ScalarAffineFunction{Float64}}()

julia> MOI.set(model, attr, f)

julia> MOI.modify(model, attr, MOI.ScalarConstantChange(10.0))

julia> print(model)
Minimize ScalarAffineFunction{Float64}:
 10.0 + 1.0 v[1]

Subject to:
```
"""
function modify(
    model::ModelLike,
    attr::ObjectiveFunction,
    change::AbstractFunctionModification,
)
    return throw_modify_not_allowed(attr, change)
end

"""
    modify(
        model::ModelLike,
        attr::ObjectiveFunction,
        changes::AbstractVector{<:AbstractFunctionModification},
    )

Apply multiple modifications specified by `changes` to the functions of constraints `cis`.

A [`ModifyObjectiveNotAllowed`](@ref) error is thrown if modifying
objective coefficients is not supported by `model`.

## Example

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 2);

julia> MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)

julia> f = 1.0 * x[1] + 1.0 * x[2];

julia> attr = MOI.ObjectiveFunction{typeof(f)}()
MathOptInterface.ObjectiveFunction{MathOptInterface.ScalarAffineFunction{Float64}}()

julia> MOI.set(model, attr, f)

julia> MOI.modify(model, attr, MOI.ScalarCoefficientChange.(x, [2.0, 0.5]))

julia> print(model)
Minimize ScalarAffineFunction{Float64}:
 0.0 + 2.0 v[1] + 0.5 v[2]

Subject to:
```
"""
function modify(
    model::ModelLike,
    attr::ObjectiveFunction,
    changes::AbstractVector{<:AbstractFunctionModification},
)
    for change in changes
        modify(model, attr, change)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintIndicatorToMILP

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests_VectorOfVariables_ON_ONE()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, y] in Indicator{ACTIVATE_ON_ONE}(LessThan(2.0))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        1.0 * y + 1.0 * a <= 2.0
        1.0 * x + -1.0 * a <= 1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, y] in Indicator{ACTIVATE_ON_ONE}(LessThan(4.0))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        1.0 * y + 1.0 * a <= 4.0
        -1.0 * a <= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, y] in Indicator{ACTIVATE_ON_ONE}(GreaterThan(1.5))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        1.0 * y + 1.0 * a >= 1.5
        0.5 * x + 1.0 * a <= 0.5
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, y] in Indicator{ACTIVATE_ON_ONE}(EqualTo(1.25))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        1.0 * y + 1.0 * a == 1.25
        0.25 * x + 1.0 * a <= 0.25
        1.75 * x + -1.0 * a <= 1.75
        """,
    )
    return
end

function test_runtests_VectorOfVariables_ON_ZERO()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, y] in Indicator{ACTIVATE_ON_ZERO}(LessThan(2.0))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        1.0 * y + 1.0 * a <= 2.0
        -1.0 * x + -1.0 * a <= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, y] in Indicator{ACTIVATE_ON_ZERO}(LessThan(4.0))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        1.0 * y + 1.0 * a <= 4.0
        -1.0 * a <= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, y] in Indicator{ACTIVATE_ON_ZERO}(GreaterThan(1.5))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        1.0 * y + 1.0 * a >= 1.5
        1.0 * a + -0.5 * x <= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, y] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(1.25))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        1.0 * y + 1.0 * a == 1.25
        -0.25 * x + 1.0 * a <= 0.0
        -1.75 * x + -1.0 * a <= 0.0
        """,
    )
    return
end

function test_runtests_VectorAffineFunction_ON_ZERO()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, 2.0 * y + 1.0] in Indicator{ACTIVATE_ON_ZERO}(LessThan(2.0))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        2.0 * y + 1.0 * a <= 1.0
        -5.0 * x + -1.0 * a <= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, 2.0 * y + 1.0] in Indicator{ACTIVATE_ON_ZERO}(LessThan(4.0))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        2.0 * y + 1.0 * a <= 3.0
        -3.0 * x + -1.0 * a <= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, 2.0 * y + 1.0] in Indicator{ACTIVATE_ON_ZERO}(GreaterThan(1.5))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        2.0 * y + 1.0 * a >= 0.5
        1.0 * a <= 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.IndicatorToMILPBridge,
        """
        variables: x, y
        [x, 0.5 * y + 0.25] in Indicator{ACTIVATE_ON_ZERO}(EqualTo(1.25))
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        """,
        """
        variables: x, y, a
        x in ZeroOne()
        y in Interval(1.0, 3.0)
        0.5 * y + 1.0 * a == 1.0
        -0.5 * x + 1.0 * a <= 0.0
        -0.5 * x + -1.0 * a <= 0.0
        """,
    )
    return
end

function test_resolve_with_modified()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.IndicatorToMILP{Int}(inner)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint(model, x[1], MOI.ZeroOne())
    c = MOI.add_constraint(model, x[2], MOI.Interval(1, 2))
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.GreaterThan(2)),
    )
    @test MOI.get(inner, MOI.NumberOfVariables()) == 2
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 3
    MOI.set(model, MOI.ConstraintSet(), c, MOI.Interval(3, 4))
    MOI.Bridges.final_touch(model)
    @test MOI.get(inner, MOI.NumberOfVariables()) == 3
    return
end

function test_runtests_error_variable()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.IndicatorToMILP{Int}(inner)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint(model, x[1], MOI.ZeroOne())
    c = MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.GreaterThan(2)),
    )
    BT = typeof(model.map[c])
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,MOI.VariableIndex},
        MOI.Bridges.final_touch(model),
    )
    return
end

function test_runtests_error_affine()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.IndicatorToMILP{Int}(inner)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint(model, x[1], MOI.ZeroOne())
    c = MOI.add_constraint(
        model,
        MOI.Utilities.operate(vcat, Int, x[1], 2 * x[2]),
        MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.GreaterThan(2)),
    )
    BT = typeof(model.map[c])
    F = MOI.ScalarAffineFunction{Int}
    @test_throws(
        MOI.Bridges.BridgeRequiresFiniteDomainError{BT,F},
        MOI.Bridges.final_touch(model),
    )
    return
end

function test_delete_before_final_touch()
    model = MOI.Bridges.Constraint.IndicatorToMILP{Float64}(
        MOI.Utilities.Model{Float64}(),
    )
    x = MOI.add_variables(model, 2)
    MOI.add_constraint(model, x[1], MOI.ZeroOne())
    c = MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.GreaterThan(2.0)),
    )
    MOI.delete(model, c)
    @test !MOI.is_valid(model, c)
    return
end

function test_runtests_error_not_binary()
    inner = MOI.Utilities.Model{Int}()
    model = MOI.Bridges.Constraint.IndicatorToMILP{Int}(inner)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint(model, x[2], MOI.Interval(0, 4))
    set = MOI.Indicator{MOI.ACTIVATE_ON_ZERO}(MOI.GreaterThan(2))
    c = MOI.add_constraint(model, MOI.VectorOfVariables(x), set)
    @test_throws(
        MOI.AddConstraintNotAllowed{MOI.VectorOfVariables,typeof(set)}(
            "Unable to reformulate indicator constraint to a MILP. The indicator variable must be binary.",
        ),
        MOI.Bridges.final_touch(model),
    )
    return
end

MOI.Utilities.@model(
    Model2867,
    (),
    (MOI.EqualTo, MOI.LessThan),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
)

function MOI.supports_constraint(
    model::Model2867,
    ::Type{MOI.VariableIndex},
    ::Type{<:Union{MOI.Integer,MOI.ZeroOne}},
)
    return get(model.ext, :supports, false)
end

function test_issue_2867()
    model = MOI.instantiate(Model2867{Float64}; with_bridge_type = Float64)
    @test !MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.EqualTo{Float64}},
    )
    model = MOI.instantiate(Model2867{Float64}; with_bridge_type = Float64)
    model.model.ext[:supports] = true
    @test MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.EqualTo{Float64}},
    )
    return
end

end  # module

TestConstraintIndicatorToMILP.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintVectorize

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_ScalarFunctionConstantNotZero()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.Vectorize{Float64}(mock)
    config = MOI.Test.Config()
    MOI.Test.test_model_ScalarFunctionConstantNotZero(bridged_mock, config)
    return
end

function test_basic()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.Vectorize{Float64}(mock)
    config = MOI.Test.Config()
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_$(F)_$(S)" for
            F in ["VariableIndex", "ScalarAffineFunction"] for
            S in ["EqualTo", "GreaterThan", "LessThan"]
        ],
    )
    return
end

function test_linear_integration()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.Vectorize{Float64}(mock)
    config = MOI.Test.Config(exclude = Any[MOI.ConstraintBasisStatus])
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1, 0],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonpositives) => [[-1]],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [[0], [1]],
        ),
    )
    MOI.Test.test_linear_integration_2(bridged_mock, config)
    return
end

function test_linear_LessThan_and_GreaterThan()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.Vectorize{Float64}(mock)
    config = MOI.Test.Config()
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0, 0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100, 0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100, -100]),
    )
    return MOI.Test.test_linear_LessThan_and_GreaterThan(bridged_mock, config)
end

function test_linear_integration_modification()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.Vectorize{Float64}(mock)
    config = MOI.Test.Config()
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [4 / 3, 4 / 3]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [2, 0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [4, 0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [2]),
    )
    MOI.Test.test_linear_integration_modification(bridged_mock, config)
    return
end

function test_linear_modify_GreaterThan_and_LessThan_constraints()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.Vectorize{Float64}(mock)
    config = MOI.Test.Config()
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [0, 0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100, 0]),
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.Utilities.mock_optimize!(mock, [100, -100]),
    )
    MOI.Test.test_linear_modify_GreaterThan_and_LessThan_constraints(
        bridged_mock,
        config,
    )
    return
end

function test_linear_integration_delete_variables()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.Vectorize{Float64}(mock)
    config = MOI.Test.Config(exclude = Any[MOI.ConstraintBasisStatus])
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [0, 1 / 2, 1],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonpositives) =>
                [[-1], [-2]],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [[2], [0], [0]],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonpositives) => [[-1]],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) => [[0]],
        ),
    )
    # test_linear_integration_delete_variables has double variable bounds for
    # the z variable
    mock.eval_variable_constraint_dual = false
    MOI.Test.test_linear_integration_delete_variables(bridged_mock, config)
    return
end

function test_conic_PositiveSemidefiniteConeTriangle_VectorOfVariables()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.Vectorize{Float64}(mock)
    config = MOI.Test.Config()
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            ones(3),
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) => [[2]],
        )
    MOI.Test.test_conic_PositiveSemidefiniteConeTriangle_VectorOfVariables(
        bridged_mock,
        config,
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.EqualTo{Float64},
            }(),
        ),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, 2.0)
        @test MOI.get(bridged_mock, attr, ci) == 2.0
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        ((MOI.VectorAffineFunction{Float64}, MOI.Zeros, 0),),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorizeBridge,
        """
        variables: x
        x >= 2.0
        """,
        """
        variables: x
        [-2.0 + 1.0 * x] in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorizeBridge,
        """
        variables: x
        x <= -2.0
        """,
        """
        variables: x
        [2.0 + 1.0 * x] in Nonpositives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorizeBridge,
        """
        variables: x
        x == 1.1
        """,
        """
        variables: x
        [-1.1 + 1.0 * x] in Zeros(1)
        """,
    )
    return
end

MOI.Utilities.@model(
    Model2179,
    (),
    (MOI.GreaterThan, MOI.LessThan),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
)

function test_unsupported_ScalarNonlinearFunction()
    model = MOI.instantiate(Model2179{Float64}; with_bridge_type = Float64)
    MOI.supports_constraint(
        model,
        MOI.ScalarNonlinearFunction,
        MOI.GreaterThan{Float64},
    )
    return
end

function test_VectorNonlinearFunction()
    # We can't use the standard runtests because ScalarNonlinearFunction does
    # not preserve f(x) ≈ (f(x) - g(x)) + g(x)
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.Vectorize{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    c = MOI.add_constraint(model, f, MOI.EqualTo(1.0))
    F, S = MOI.VectorNonlinearFunction, MOI.Zeros
    indices = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())
    @test length(indices) == 1
    inner_variables = MOI.get(inner, MOI.ListOfVariableIndices())
    @test length(inner_variables) == 1
    y = inner_variables[1]
    g = MOI.ScalarNonlinearFunction(
        :-,
        Any[MOI.ScalarNonlinearFunction(:log, Any[x]), 1.0],
    )
    @test ≈(
        MOI.get(inner, MOI.ConstraintFunction(), indices[1]),
        MOI.VectorNonlinearFunction(Any[g]),
    )
    return
end

function test_constraint_primal_ray()
    inner = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Bridges.Constraint.Vectorize{Float64}(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(3.0))
    MOI.set(inner, MOI.PrimalStatus(), MOI.INFEASIBILITY_CERTIFICATE)
    y = only(MOI.get(inner, MOI.ListOfVariableIndices()))
    MOI.set(inner, MOI.VariablePrimal(), y, 1.23)
    @test MOI.get(model, MOI.ConstraintPrimal(), c) == 1.23
    MOI.set(inner, MOI.PrimalStatus(), MOI.FEASIBLE_POINT)
    @test MOI.get(model, MOI.ConstraintPrimal(), c) == 1.23
    return
end

end  # module

TestConstraintVectorize.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    abstract type AbstractBridge <: MOI.Bridges.AbstractType

Subtype of [`MOI.Bridges.AbstractBridge`](@ref) for constraint bridges.

In addition to the required implementation described in
[`MOI.Bridges.AbstractBridge`](@ref), subtypes of `AbstractBridge` must
additionally implement:

 * [`MOI.supports_constraint(::Type{<:AbstractBridge}, ::Type{<:MOI.AbstractFunction}, ::Type{<:MOI.AbstractSet})`](@ref)
 * [`concrete_bridge_type`](@ref)
 * [`bridge_constraint`](@ref)
"""
abstract type AbstractBridge <: MOI.Bridges.AbstractBridge end

"""
    MOI.supports_constraint(
        BT::Type{<:AbstractBridge},
        F::Type{<:MOI.AbstractFunction},
        S::Type{<:MOI.AbstractSet},
    )::Bool

Return a `Bool` indicating whether the bridges of type `BT` support bridging
`F`-in-`S` constraints.

## Implementation notes

 * This method depends only on the type of the inputs, not the runtime values.
 * There is a default fallback, so you need only implement this method for
   constraint types that the bridge implements.
"""
function MOI.supports_constraint(
    @nospecialize(BT::Type{<:AbstractBridge}),
    @nospecialize(F::Type{<:MOI.AbstractFunction}),
    @nospecialize(S::Type{<:MOI.AbstractSet}),
)
    return false
end

"""
    concrete_bridge_type(
        BT::Type{<:AbstractBridge},
        F::Type{<:MOI.AbstractFunction},
        S::Type{<:MOI.AbstractSet}
    )::Type

Return the concrete type of the bridge supporting `F`-in-`S` constraints.

This function can only be called if `MOI.supports_constraint(BT, F, S)` is
`true`.

## Example

The [`SplitIntervalBridge`](@ref) bridges a [`MOI.VariableIndex`](@ref)-in-[`MOI.Interval`](@ref)
constraint into a [`MOI.VariableIndex`](@ref)-in-[`MOI.GreaterThan`](@ref) and a
[`MOI.VariableIndex`](@ref)-in-[`MOI.LessThan`](@ref) constraint.

```jldoctest
julia> MOI.Bridges.Constraint.concrete_bridge_type(
           MOI.Bridges.Constraint.SplitIntervalBridge{Float64},
           MOI.VariableIndex,
           MOI.Interval{Float64},
       )
MathOptInterface.Bridges.Constraint.SplitIntervalBridge{Float64, MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}, MathOptInterface.GreaterThan{Float64}, MathOptInterface.LessThan{Float64}}
```
"""
function concrete_bridge_type(
    ::Type{BT},
    ::Type{<:MOI.AbstractFunction},
    ::Type{<:MOI.AbstractSet},
) where {BT}
    return BT
end

function concrete_bridge_type(
    b::MOI.Bridges.AbstractBridgeOptimizer,
    F::Type{<:MOI.AbstractFunction},
    S::Type{<:MOI.AbstractSet},
)
    return concrete_bridge_type(MOI.Bridges.bridge_type(b, F, S), F, S)
end

"""
    bridge_constraint(
        BT::Type{<:AbstractBridge},
        model::MOI.ModelLike,
        func::AbstractFunction,
        set::MOI.AbstractSet,
    )::BT

Bridge the constraint `func`-in-`set` using bridge `BT` to `model` and returns
a bridge object of type `BT`.

## Implementation notes

 * The bridge type `BT` should be a concrete type, that is, all the type
   parameters of the bridge must be set.
"""
function bridge_constraint end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSemiToBinary

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_SemiToBinary()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.SemiToBinary{Float64}(mock)
    bridge_type = MOI.Bridges.Constraint.SemiToBinaryBridge{
        Float64,
        MOI.Semiinteger{Float64},
    }
    @test MOI.supports_constraint(
        bridge_type,
        MOI.VariableIndex,
        MOI.Semiinteger{Float64},
    )
    @test MOI.Bridges.Constraint.concrete_bridge_type(
        bridge_type,
        MOI.VariableIndex,
        MOI.Semiinteger{Float64},
    ) == bridge_type
    @test MOI.supports(bridged_mock, MOI.ConstraintPrimalStart(), bridge_type)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VariableIndex_Semiinteger",
            "test_basic_VariableIndex_Semicontinuous",
        ],
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 0.0)
            MOI.Utilities.mock_optimize!(mock, [0.0, 0.0, 0.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 2.0)
            MOI.Utilities.mock_optimize!(mock, [2.0, 1.0, 1.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 2.0)
            MOI.Utilities.mock_optimize!(mock, [2.0, 2.0, 1.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 2.5)
            MOI.Utilities.mock_optimize!(mock, [2.5, 2.5, 1.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 3.0)
            MOI.Utilities.mock_optimize!(mock, [3.0, 3.0, 1.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.set(mock, MOI.TerminationStatus(), MOI.INFEASIBLE),
    )
    MOI.Test.test_linear_Semicontinuous_integration(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VariableIndex,
                MOI.Semicontinuous{Float64},
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.VariableIndex, MOI.EqualTo{Float64}, 1),
            (MOI.VariableIndex, MOI.ZeroOne, 0),
            (MOI.VariableIndex, MOI.Integer, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 1),
        ),
    )
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 0.0)
            MOI.Utilities.mock_optimize!(mock, [0.0, 0.0, 0.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 2.0)
            MOI.Utilities.mock_optimize!(mock, [2.0, 1.0, 1.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 2.0)
            MOI.Utilities.mock_optimize!(mock, [2.0, 2.0, 1.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 3.0)
            MOI.Utilities.mock_optimize!(mock, [3.0, 2.5, 1.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) -> begin
            MOI.set(mock, MOI.ObjectiveBound(), 3.0)
            MOI.Utilities.mock_optimize!(mock, [3.0, 3.0, 1.0])
        end,
        (mock::MOI.Utilities.MockOptimizer) ->
            MOI.set(mock, MOI.TerminationStatus(), MOI.INFEASIBLE),
    )
    MOI.Test.test_linear_Semiinteger_integration(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VariableIndex,
                MOI.Semiinteger{Float64},
            }(),
        ),
    )

    @test MOI.get(bridged_mock, MOI.ConstraintPrimal(), ci) == 3
    new_set = MOI.Semiinteger{Float64}(19.0, 20.0)
    MOI.set(bridged_mock, MOI.ConstraintSet(), ci, new_set)
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == new_set
    for attr in [MOI.ConstraintPrimalStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        value = 2.0
        MOI.set(bridged_mock, attr, ci, value)
        @test MOI.get(bridged_mock, attr, ci) ≈ value
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.VariableIndex, MOI.EqualTo{Float64}, 1),
            (MOI.VariableIndex, MOI.ZeroOne, 0),
            (MOI.VariableIndex, MOI.Integer, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 1),
        ),
    )
    s = """
    variables: x, y
    y == 4.0
    x in Semiinteger(2.0, 3.0)
    minobjective: x
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    sb = """
    variables: x, y, z
    y == 4.0
    z in ZeroOne()
    x in Integer()
    clo: x + -2.0z >= 0.0
    cup: x + -3.0z <= 0.0
    minobjective: x
    """
    modelb = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(modelb, sb)
    MOI.empty!(bridged_mock)
    @test MOI.is_empty(bridged_mock)
    MOI.Utilities.loadfromstring!(bridged_mock, s)
    MOI.Test.util_test_models_equal(
        bridged_mock,
        model,
        ["x", "y"],
        String[],
        [
            ("x", MOI.Semiinteger{Float64}(2.0, 3.0)),
            ("y", MOI.EqualTo{Float64}(4.0)),
        ],
    )
    # setting names on mock
    ci = first(
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.ZeroOne}(),
        ),
    )
    z = MOI.VariableIndex(ci.value)
    MOI.set(mock, MOI.VariableName(), z, "z")
    ci = first(
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.Integer}(),
        ),
    )
    ci = first(
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.GreaterThan{Float64},
            }(),
        ),
    )
    MOI.set(mock, MOI.ConstraintName(), ci, "clo")
    ci = first(
        MOI.get(
            mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.LessThan{Float64},
            }(),
        ),
    )
    MOI.set(mock, MOI.ConstraintName(), ci, "cup")
    MOI.Test.util_test_models_equal(
        mock,
        modelb,
        ["x", "y", "z"],
        ["clo", "cup"],
        [
            ("x", MOI.Integer()),
            ("y", MOI.EqualTo{Float64}(4.0)),
            ("z", MOI.ZeroOne()),
        ],
    )
    return
end

"""
Test an error is thrown if a bound is added _after_ the semi-xxx constraint.

Note that this means the error is thrown from `Bridges.final_touch`.
"""
function test_bounds_already_set_final_touch()
    for set in [MOI.GreaterThan(0.0), MOI.EqualTo(1.4), MOI.Interval(0.0, 2.0)]
        model = MOI.Utilities.Model{Float64}()
        bridged = MOI.Bridges.Constraint.SemiToBinary{Float64}(model)
        x = MOI.add_variable(bridged)
        semi_set = MOI.Semicontinuous(1.0, 2.0)
        MOI.add_constraint(bridged, x, semi_set)
        MOI.add_constraint(bridged, x, set)
        @test_throws(
            MOI.LowerBoundAlreadySet{typeof(semi_set),typeof(set)}(x),
            MOI.Bridges.final_touch(bridged),
        )
    end
    for set in [MOI.LessThan(2.0)]
        model = MOI.Utilities.Model{Float64}()
        bridged = MOI.Bridges.Constraint.SemiToBinary{Float64}(model)
        x = MOI.add_variable(bridged)
        semi_set = MOI.Semicontinuous(1.0, 2.0)
        MOI.add_constraint(bridged, x, semi_set)
        MOI.add_constraint(bridged, x, set)
        @test_throws(
            MOI.UpperBoundAlreadySet{typeof(semi_set),typeof(set)}(x),
            MOI.Bridges.final_touch(bridged),
        )
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SemiToBinaryBridge,
        """
        variables: x
        x in Semicontinuous(1.5, 2.5)
        """,
        """
        variables: x, z
        x + -2.5 * z <= 0.0
        x + -1.5 * z >= 0.0
        z in ZeroOne()
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SemiToBinaryBridge,
        """
        variables: x
        x in Semiinteger(2.0, 3.0)
        """,
        """
        variables: x, z
        x + -3.0 * z <= 0.0
        x + -2.0 * z >= 0.0
        z in ZeroOne()
        x in Integer()
        """,
    )
    return
end

end  # module

TestConstraintSemiToBinary.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSplitInterval

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_split_basic()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    T = Float64
    bridged_mock = MOI.Bridges.Constraint.SplitInterval{T}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_$(F)_$(S)" for F in [
                "VariableIndex",
                "ScalarAffineFunction",
                "ScalarQuadraticFunction",
            ] for S in ["Interval", "EqualTo"]
        ],
    )
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_$(F)_Zeros" for F in [
                "VectorOfVariables",
                "VectorAffineFunction",
                "VectorQuadraticFunction",
            ]
        ],
    )
    return
end

function test_linear_integration_Interval()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.SplitInterval{Float64}(mock)
    config = MOI.Test.Config()
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [5.0, 5.0],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) => [MOI.BASIC],
                (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) => [MOI.NONBASIC],
            ],
            variable_basis_status = [MOI.BASIC, MOI.BASIC],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [0],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [2.5, 2.5],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) => [MOI.NONBASIC],
                (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) => [MOI.BASIC],
            ],
            variable_basis_status = [MOI.BASIC, MOI.BASIC],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [1],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [0],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 1.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [1],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [0],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) => [MOI.NONBASIC],
                (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) => [MOI.BASIC],
            ],
            variable_basis_status = [MOI.BASIC, MOI.BASIC],
        ),
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [6.0, 6.0],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) => [MOI.BASIC],
                (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) => [MOI.NONBASIC],
            ],
            variable_basis_status = [MOI.BASIC, MOI.BASIC],
        ),
    )
    MOI.Test.test_linear_integration_Interval(bridged_mock, config)
    MOI.empty!(bridged_mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [0.0, 0.0],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [0],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) => [MOI.BASIC],
                (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) => [MOI.BASIC],
            ],
            variable_basis_status = [
                MOI.NONBASIC_AT_LOWER,
                MOI.NONBASIC_AT_LOWER,
            ],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [0],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [0],
        ),
    )
    MOI.Test.test_linear_Interval_inactive(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{Float64},
                MOI.Interval{Float64},
            }(),
        ),
    )
    vis = MOI.get(bridged_mock, MOI.ListOfVariableIndices())
    newf =
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([1.0, -1.0], vis), 0.0)
    MOI.set(bridged_mock, MOI.ConstraintFunction(), ci, newf)
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈ newf

    MOI.modify(bridged_mock, ci, MOI.ScalarCoefficientChange(vis[2], 1.0))
    modified_f =
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(ones(2), vis), 0.0)
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈ modified_f
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, 2.0)
        @test MOI.get(bridged_mock, attr, ci) == 2.0
        bridge = MOI.Bridges.bridge(bridged_mock, ci)
        if attr isa MOI.ConstraintPrimalStart
            @test MOI.get(bridged_mock, attr, bridge.lower) == 2.0
            @test MOI.get(bridged_mock, attr, bridge.upper) == 2.0
        else
            @test MOI.get(bridged_mock, attr, bridge.lower) == 2.0
            @test MOI.get(bridged_mock, attr, bridge.upper) == 0.0
        end
        MOI.set(bridged_mock, attr, ci, -2.0)
        @test MOI.get(bridged_mock, attr, ci) == -2.0
        if attr isa MOI.ConstraintPrimalStart
            @test MOI.get(bridged_mock, attr, bridge.lower) == -2.0
            @test MOI.get(bridged_mock, attr, bridge.upper) == -2.0
        else
            @test MOI.get(bridged_mock, attr, bridge.lower) == 0.0
            @test MOI.get(bridged_mock, attr, bridge.upper) == -2.0
        end
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}, 0),
        ),
    )
    return
end

function _test_linear_FEASIBILITY_SENSE(T)
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.SplitInterval{T}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [one(T), one(T)],
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}) =>
                zeros(T, 2),
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}) => zeros(T, 1),
        ),
    )
    MOI.Test.test_linear_FEASIBILITY_SENSE(bridged_mock, MOI.Test.Config(T))
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.ScalarAffineFunction{T},
                MOI.EqualTo{T},
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        (
            (MOI.ScalarAffineFunction{T}, MOI.GreaterThan{T}, 1),
            (MOI.ScalarAffineFunction{T}, MOI.LessThan{T}, 0),
        ),
    )
    return
end

function test_linear_FEASIBILITY_SENSE()
    _test_linear_FEASIBILITY_SENSE(Float64)
    _test_linear_FEASIBILITY_SENSE(Int)
    return
end

function test_conic_linear_VectorOfVariables()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.SplitInterval{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 0.0, 2.0],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [[0.0, 0.0]],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonpositives) =>
                [[-3, -1]],
        )
    MOI.Test.test_conic_linear_VectorOfVariables(bridged_mock, config)
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.Zeros,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        (
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 0),
            (MOI.VectorAffineFunction{Float64}, MOI.Nonpositives, 0),
        ),
    )
    return
end

function _test_interval(
    mock,
    bridged_mock,
    set::MOI.Interval{T},
    ci::MOI.ConstraintIndex{MOI.VariableIndex,MOI.Interval{T}},
) where {T}
    haslb = set.lower != typemin(T)
    hasub = set.upper != typemax(T)
    @test MOI.Bridges.is_bridged(bridged_mock, ci)
    bridge = MOI.Bridges.bridge(bridged_mock, ci)
    if haslb
        @test bridge.lower !== nothing
        MOI.set(mock, MOI.ConstraintBasisStatus(), bridge.lower, MOI.BASIC)
    else
        @test bridge.lower === nothing
    end
    if hasub
        @test bridge.upper !== nothing
        MOI.set(mock, MOI.ConstraintBasisStatus(), bridge.upper, MOI.BASIC)
    else
        @test bridge.upper === nothing
    end
    @test set == MOI.get(bridged_mock, MOI.ConstraintSet(), ci)
    attr = MOI.NumberOfConstraints{MOI.VariableIndex,MOI.GreaterThan{T}}()
    @test 0 == MOI.get(bridged_mock, attr)
    @test (haslb ? 1 : 0) == MOI.get(mock, attr)
    attr = MOI.NumberOfConstraints{MOI.VariableIndex,MOI.LessThan{T}}()
    @test 0 == MOI.get(bridged_mock, attr)
    @test (hasub ? 1 : 0) == MOI.get(mock, attr)
    attr = MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.GreaterThan{T}}()
    @test isempty(MOI.get(bridged_mock, attr))
    @test (haslb ? 1 : 0) == length(MOI.get(mock, attr))
    attr = MOI.ListOfConstraintIndices{MOI.VariableIndex,MOI.LessThan{T}}()
    @test isempty(MOI.get(bridged_mock, attr))
    @test (hasub ? 1 : 0) == length(MOI.get(mock, attr))
    if haslb || hasub
        @test one(T) == MOI.get(bridged_mock, MOI.ConstraintPrimal(), ci)
        @test MOI.BASIC ==
              MOI.get(bridged_mock, MOI.ConstraintBasisStatus(), ci)
        for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
            MOI.set(bridged_mock, attr, ci, T(2))
            @test T(2) == MOI.get(bridged_mock, attr, ci)
        end
    else
        for attr in [
            MOI.ConstraintPrimal(),
            MOI.ConstraintPrimalStart(),
            MOI.ConstraintBasisStatus(),
        ]
            err = MOI.GetAttributeNotAllowed{typeof(attr)}
            @test_throws err MOI.get(bridged_mock, attr, ci)
        end
        @test zero(T) == MOI.get(bridged_mock, MOI.ConstraintDualStart(), ci)
    end
    @test zero(T) == MOI.get(bridged_mock, MOI.ConstraintDual(), ci)
end

function test_infinite_bounds(::Type{T} = Float64) where {T<:AbstractFloat}
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.SplitInterval{T}(mock)
    x = MOI.add_variable(bridged_mock)
    MOI.set(mock, MOI.VariablePrimal(), x, one(T))
    set = MOI.Interval(typemin(T), one(T))
    ci = MOI.add_constraint(bridged_mock, x, set)
    _test_interval(mock, bridged_mock, set, ci)
    set = MOI.Interval(zero(T), typemax(T))
    MOI.set(bridged_mock, MOI.ConstraintSet(), ci, set)
    _test_interval(mock, bridged_mock, set, ci)
    set = MOI.Interval(typemin(T), typemax(T))
    MOI.set(bridged_mock, MOI.ConstraintSet(), ci, set)
    _test_interval(mock, bridged_mock, set, ci)
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        (
            (MOI.VariableIndex, MOI.GreaterThan{T}, 0),
            (MOI.VariableIndex, MOI.LessThan{T}, 0),
        ),
    )
    ci = MOI.add_constraint(bridged_mock, x, set)
    _test_interval(mock, bridged_mock, set, ci)
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        (
            (MOI.VariableIndex, MOI.GreaterThan{T}, 0),
            (MOI.VariableIndex, MOI.LessThan{T}, 0),
        ),
    )
    set = MOI.Interval(zero(T), typemax(T))
    ci = MOI.add_constraint(bridged_mock, x, set)
    return _test_interval(mock, bridged_mock, set, ci)
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x
        x in Interval(1.0, 2.0)
        """,
        """
        variables: x
        x >= 1.0
        x <= 2.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x
        3.0 * x in Interval(1.0, 2.0)
        """,
        """
        variables: x
        3.0 * x >= 1.0
        3.0 * x <= 2.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x
        x in Interval(1.0, Inf)
        """,
        """
        variables: x
        x >= 1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x
        x in Interval(-Inf, 2.0)
        """,
        """
        variables: x
        x <= 2.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x
        x in Interval(1 // 2, 3 // 2)
        """,
        """
        variables: x
        x in GreaterThan(1 // 2)
        x in LessThan(3 // 2)
        """,
        eltype = Rational{Int},
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x
        x in Interval(1 // 2, 1 // 0)
        """,
        """
        variables: x
        x in GreaterThan(1 // 2)
        """,
        eltype = Rational{Int},
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x
        x in Interval(-1 // 0, 1 // 2)
        """,
        """
        variables: x
        x in LessThan(1 // 2)
        """,
        eltype = Rational{Int},
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x
        ScalarNonlinearFunction(log(x)) in Interval(1.0, 2.0)
        """,
        """
        variables: x
        ScalarNonlinearFunction(log(x)) >= 1.0
        ScalarNonlinearFunction(log(x)) <= 2.0
        """,
    )
    return
end

function test_runtests_vector()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x
        [x] in Zeros(1)
        """,
        """
        variables: x
        [x] in Nonnegatives(1)
        [x] in Nonpositives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SplitIntervalBridge,
        """
        variables: x, y
        [1.0 * x + 2.0, x + y] in Zeros(2)
        """,
        """
        variables: x, y
        [1.0 * x + 2.0, x + y] in Nonnegatives(2)
        [1.0 * x + 2.0, x + y] in Nonpositives(2)
        """,
    )
    return
end

function test_get_function()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.SplitInterval{Float64}(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.Interval(-Inf, Inf))
    @test MOI.get(model, MOI.ConstraintFunction(), c) ≈ 1.0 * x
    return
end

function test_modify_set()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.SplitInterval{Float64}(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, 1.0 * x, MOI.Interval(-Inf, Inf))
    for set in [
        MOI.Interval(-Inf, Inf),
        MOI.Interval(1.0, 2.0),
        MOI.Interval(2.0, 3.0),
        MOI.Interval(-Inf, Inf),
    ]
        MOI.set(model, MOI.ConstraintSet(), c, set)
        @test MOI.get(model, MOI.ConstraintSet(), c) == set
        @test MOI.get(model, MOI.ConstraintFunction(), c) ≈ 1.0 * x
    end
    return
end

end  # module

TestConstraintSplitInterval.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestObjectiveContainer

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_ObjectiveSense()
    o = MOI.Utilities.ObjectiveContainer{Float16}()
    @test MOI.get(o, MOI.ListOfModelAttributesSet()) == []
    @test MOI.supports(o, MOI.ObjectiveSense())
    for val in (MOI.MIN_SENSE, MOI.MAX_SENSE, MOI.FEASIBILITY_SENSE)
        MOI.set(o, MOI.ObjectiveSense(), val)
        @test MOI.get(o, MOI.ObjectiveSense()) == val
    end
    return
end

function test_FEASIBILITY_SENSE_clears_objective()
    o = MOI.Utilities.ObjectiveContainer{Float16}()
    x = MOI.VariableIndex(1234)
    MOI.set(o, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    @test MOI.get(o, MOI.ObjectiveFunction{MOI.VariableIndex}()) ≈ x
    MOI.set(o, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    @test !MOI.is_empty(o)
    @test o.is_function_set == false
    return
end

function _test_basic_objective(F, T)
    o = MOI.Utilities.ObjectiveContainer{T}()
    @test MOI.is_empty(o)
    @test MOI.supports(o, MOI.ObjectiveFunction{F}())
    x = MOI.VariableIndex(1234)
    f = convert(F, x)
    MOI.set(o, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(o, MOI.ObjectiveFunctionType()) == F
    @test !MOI.is_empty(o)
    @test MOI.get(o, MOI.ListOfModelAttributesSet()) ==
          Any[MOI.ObjectiveFunction{F}()]
    MOI.empty!(o)
    @test MOI.is_empty(o)
    return
end

function test_basic_objective()
    _test_basic_objective(MOI.VariableIndex, Float32)
    _test_basic_objective(MOI.ScalarAffineFunction{Float32}, Float32)
    _test_basic_objective(MOI.ScalarQuadraticFunction{Float32}, Float32)
    return
end

function test_delete_VariableIndex()
    o = MOI.Utilities.ObjectiveContainer{Float16}()
    x = MOI.VariableIndex(1234)
    MOI.set(o, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.delete(o, x)
    @test MOI.is_empty(o)
    return
end

function test_delete_ScalarAffineFunction()
    o = MOI.Utilities.ObjectiveContainer{Float16}()
    x = MOI.VariableIndex(1234)
    f = convert(MOI.ScalarAffineFunction{Float16}, x)
    MOI.set(o, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.delete(o, x)
    @test MOI.get(o, MOI.ObjectiveFunctionType()) == typeof(f)
    @test !(MOI.get(o, MOI.ObjectiveFunction{typeof(f)}()) ≈ f)
    return
end

function test_delete_ScalarQuadraticFunction()
    o = MOI.Utilities.ObjectiveContainer{Float16}()
    x = MOI.VariableIndex(1234)
    f = convert(MOI.ScalarQuadraticFunction{Float16}, x)
    MOI.set(o, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.delete(o, x)
    @test MOI.get(o, MOI.ObjectiveFunctionType()) == typeof(f)
    @test !(MOI.get(o, MOI.ObjectiveFunction{typeof(f)}()) ≈ f)
    return
end

function test_delete_VariableIndex_plural()
    o = MOI.Utilities.ObjectiveContainer{Float16}()
    x = MOI.VariableIndex(1234)
    MOI.set(o, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.delete(o, [x])
    @test MOI.is_empty(o)
    return
end

function test_delete_ScalarAffineFunction_plural()
    o = MOI.Utilities.ObjectiveContainer{Float16}()
    x = MOI.VariableIndex(1234)
    f = convert(MOI.ScalarAffineFunction{Float16}, x)
    MOI.set(o, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.delete(o, [x])
    @test MOI.get(o, MOI.ObjectiveFunctionType()) == typeof(f)
    @test !(MOI.get(o, MOI.ObjectiveFunction{typeof(f)}()) ≈ f)
    return
end

function test_delete_ScalarQuadraticFunction_plural()
    o = MOI.Utilities.ObjectiveContainer{Float16}()
    x = MOI.VariableIndex(1234)
    f = convert(MOI.ScalarQuadraticFunction{Float16}, x)
    MOI.set(o, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.delete(o, [x])
    @test MOI.get(o, MOI.ObjectiveFunctionType()) == typeof(f)
    @test !(MOI.get(o, MOI.ObjectiveFunction{typeof(f)}()) ≈ f)
    return
end

function test_modify_ScalarNonlinearFunction()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    attr = MOI.ObjectiveFunction{typeof(f)}()
    MOI.set(model, attr, f)
    @test_throws(
        MOI.ModifyObjectiveNotAllowed,
        MOI.modify(model, attr, MOI.ScalarConstantChange(3.0)),
    )
    return
end

function test_delete_variable_ScalarNonlinearFunction()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    attr = MOI.ObjectiveFunction{typeof(f)}()
    MOI.set(model, attr, f)
    @test_throws MOI.DeleteNotAllowed MOI.delete(model, x)
    return
end

function test_delete_variables_ScalarNonlinearFunction()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    attr = MOI.ObjectiveFunction{typeof(f)}()
    MOI.set(model, attr, f)
    @test_throws MOI.DeleteNotAllowed MOI.delete(model, [x])
    return
end

function test_modify_VariableIndex()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    attr = MOI.ObjectiveFunction{typeof(x)}()
    MOI.set(model, attr, x)
    @test_throws(
        MOI.ModifyObjectiveNotAllowed,
        MOI.modify(model, attr, MOI.ScalarConstantChange(3.0)),
    )
    return
end

function test_modify_VectorOfVariables()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    f = MOI.VectorOfVariables(x)
    attr = MOI.ObjectiveFunction{typeof(f)}()
    MOI.set(model, attr, f)
    @test_throws(
        MOI.ModifyObjectiveNotAllowed,
        MOI.modify(model, attr, MOI.VectorConstantChange([3.0, 4.0])),
    )
    return
end

end  # module

TestObjectiveContainer.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestProductOfSets

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

MOI.Utilities.@mix_of_scalar_sets(
    _ScalarSets,
    MOI.EqualTo{T},
    MOI.GreaterThan{T},
    MOI.LessThan{T},
    MOI.Interval{T},
)

function test_scalar_set_index()
    sets = _ScalarSets{Float64}()
    @test MOI.Utilities.set_index(sets, MOI.EqualTo{Float64}) == 1
    @test MOI.Utilities.set_index(sets, MOI.GreaterThan{Float64}) == 2
    @test MOI.Utilities.set_index(sets, MOI.Interval{Float64}) == 4
    @test MOI.Utilities.set_index(sets, MOI.LessThan{Float64}) == 3
    @test MOI.Utilities.set_index(sets, MOI.ZeroOne) === nothing
end

function test_scalar_set_types()
    sets = _ScalarSets{Float64}()
    @test MOI.Utilities.set_types(sets) == [
        MOI.EqualTo{Float64},
        MOI.GreaterThan{Float64},
        MOI.LessThan{Float64},
        MOI.Interval{Float64},
    ]
end

function test_scalar_basic()
    sets = _ScalarSets{Float64}()
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    ci = MOI.ConstraintIndex{F,S}(12345)
    @test !MOI.is_valid(sets, ci)
    i = MOI.Utilities.set_index(sets, MOI.EqualTo{Float64})
    ci_value = MOI.Utilities.add_set(sets, i)
    ci = MOI.ConstraintIndex{F,S}(ci_value)
    @test MOI.is_valid(sets, ci)
    @test MOI.Utilities.rows(sets, ci) == ci.value
    ci = MOI.ConstraintIndex{F,MOI.ZeroOne}(1)
    @test !MOI.is_valid(sets, ci)
    return
end

function test_scalar_dimension()
    sets = _ScalarSets{Float64}()
    @test MOI.dimension(sets) == 0
    MOI.Utilities.add_set(sets, 1)
    @test MOI.dimension(sets) == 1
    MOI.Utilities.add_set(sets, 1)
    @test MOI.dimension(sets) == 2
    MOI.Utilities.add_set(sets, 2)
    @test MOI.dimension(sets) == 3
end

function test_scalar_empty()
    sets = _ScalarSets{Float64}()
    @test MOI.is_empty(sets)
    MOI.Utilities.add_set(sets, 1)
    @test !MOI.is_empty(sets)
    MOI.empty!(sets)
    @test MOI.is_empty(sets)
end

function test_scalar_ConstraintTypesPresent()
    sets = _ScalarSets{Float64}()
    @test MOI.get(sets, MOI.ListOfConstraintTypesPresent()) == []
    MOI.Utilities.add_set(sets, 1)
    @test MOI.get(sets, MOI.ListOfConstraintTypesPresent()) ==
          [(MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64})]
end

function test_scalar_NumberOfConstraints()
    sets = _ScalarSets{Float64}()
    MOI.Utilities.add_set(sets, 1)
    MOI.Utilities.add_set(sets, 1)
    MOI.Utilities.add_set(sets, 2)
    MOI.Utilities.final_touch(sets)
    @test MOI.get(
        sets,
        MOI.NumberOfConstraints{MOI.VariableIndex,MOI.ZeroOne}(),
    ) == 0
    for (x, S) in zip([2, 1, 0, 0], MOI.Utilities.set_types(sets))
        @test MOI.get(
            sets,
            MOI.NumberOfConstraints{MOI.ScalarAffineFunction{Float64},S}(),
        ) == x
    end
    return
end

function test_scalar_ListOfConstraintIndices()
    sets = _ScalarSets{Float64}()
    MOI.Utilities.add_set(sets, 2)
    MOI.Utilities.add_set(sets, 4)
    MOI.Utilities.add_set(sets, 1)
    for (x, S) in zip([[3], [1], [], [2]], MOI.Utilities.set_types(sets))
        ci = MOI.get(
            sets,
            MOI.ListOfConstraintIndices{MOI.ScalarAffineFunction{Float64},S}(),
        )
        @test ci == MOI.ConstraintIndex{MOI.ScalarAffineFunction{Float64},S}.(x)
    end
    return
end

MOI.Utilities.@product_of_sets(
    _VectorSets,
    MOI.Nonpositives,
    MOI.Nonnegatives,
    MOI.EqualTo{T},
)

function test_vector_set_index()
    sets = _VectorSets{Float64}()
    @test MOI.Utilities.set_index(sets, MOI.Nonpositives) == 1
    @test MOI.Utilities.set_index(sets, MOI.Nonnegatives) == 2
    @test MOI.Utilities.set_index(sets, MOI.EqualTo{Float64}) == 3
    @test MOI.Utilities.set_index(sets, MOI.LessThan{Float64}) === nothing
end

function test_vector_set_types()
    sets = _VectorSets{Float64}()
    @test MOI.Utilities.set_types(sets) ==
          [MOI.Nonpositives, MOI.Nonnegatives, MOI.EqualTo{Float64}]
end

function test_vector_basic()
    sets = _VectorSets{Float64}()
    nonneg_i = MOI.Utilities.add_set(
        sets,
        MOI.Utilities.set_index(sets, MOI.Nonnegatives),
        2,
    )
    equalto_i = MOI.Utilities.add_set(
        sets,
        MOI.Utilities.set_index(sets, MOI.EqualTo{Float64}),
    )
    MOI.Utilities.final_touch(sets)
    VAF = MOI.VectorAffineFunction{Float64}
    @test !MOI.is_valid(sets, MOI.ConstraintIndex{VAF,MOI.Nonnegatives}(12345))
    nonneg_ci = MOI.ConstraintIndex{VAF,MOI.Nonnegatives}(nonneg_i)
    @test MOI.is_valid(sets, nonneg_ci)
    @test MOI.Utilities.rows(sets, nonneg_ci) == 1:2
    SAF = MOI.ScalarAffineFunction{Float64}
    equalto_ci = MOI.ConstraintIndex{SAF,MOI.EqualTo{Float64}}(equalto_i)
    @test MOI.is_valid(sets, equalto_ci)
    @test MOI.Utilities.rows(sets, equalto_ci) == 3
    @test MOI.Utilities.num_rows(sets, MOI.Nonnegatives) == 2
    @test MOI.Utilities.num_rows(sets, MOI.EqualTo{Float64}) == 1
    @test MOI.Utilities.num_rows(sets, MOI.Nonpositives) == 0
end

function test_vector_dimension()
    sets = _VectorSets{Float64}()
    MOI.Utilities.final_touch(sets)
    @test MOI.dimension(sets) == 0

    sets = _VectorSets{Float64}()
    MOI.Utilities.add_set(sets, 1, 1)
    MOI.Utilities.final_touch(sets)
    @test MOI.dimension(sets) == 1

    sets = _VectorSets{Float64}()
    MOI.Utilities.add_set(sets, 1, 1)
    MOI.Utilities.add_set(sets, 1, 2)
    MOI.Utilities.final_touch(sets)
    @test MOI.dimension(sets) == 3

    sets = _VectorSets{Float64}()
    MOI.Utilities.add_set(sets, 1, 1)
    MOI.Utilities.add_set(sets, 1, 2)
    MOI.Utilities.add_set(sets, 2, 3)
    MOI.Utilities.final_touch(sets)
    @test MOI.dimension(sets) == 6

    sets = _VectorSets{Float64}()
    MOI.Utilities.add_set(sets, 1, 1)
    MOI.Utilities.add_set(sets, 1, 2)
    MOI.Utilities.add_set(sets, 2, 3)
    MOI.Utilities.add_set(sets, 3)
    MOI.Utilities.final_touch(sets)
    @test MOI.dimension(sets) == 7
end

function test_vector_empty()
    sets = _VectorSets{Float64}()
    @test MOI.is_empty(sets)
    MOI.Utilities.add_set(sets, 1, 1)
    @test !MOI.is_empty(sets)
    MOI.empty!(sets)
    @test MOI.is_empty(sets)
end

function test_vector_ConstraintTypesPresent()
    sets = _VectorSets{Float64}()
    MOI.Utilities.final_touch(sets)
    @test MOI.get(sets, MOI.ListOfConstraintTypesPresent()) == []
    sets = _VectorSets{Float64}()
    MOI.Utilities.add_set(sets, 1, 1)
    MOI.Utilities.add_set(sets, 3)
    MOI.Utilities.final_touch(sets)
    @test MOI.get(sets, MOI.ListOfConstraintTypesPresent()) == [
        (MOI.VectorAffineFunction{Float64}, MOI.Nonpositives),
        (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}),
    ]
end

function test_vector_NumberOfConstraints()
    sets = _VectorSets{Float64}()
    MOI.Utilities.add_set(sets, 1, 2)
    MOI.Utilities.add_set(sets, 1, 2)
    MOI.Utilities.add_set(sets, 2, 2)
    MOI.Utilities.add_set(sets, 3)
    MOI.Utilities.final_touch(sets)
    @test MOI.get(
        sets,
        MOI.NumberOfConstraints{MOI.VectorAffineFunction{Float64},MOI.Zeros}(),
    ) == 0
    for (x, S) in zip([2, 1], MOI.Utilities.set_types(sets)[1:2])
        @test MOI.get(
            sets,
            MOI.NumberOfConstraints{MOI.VectorAffineFunction{Float64},S}(),
        ) == x
    end
    @test MOI.get(
        sets,
        MOI.NumberOfConstraints{
            MOI.ScalarAffineFunction{Float64},
            MOI.EqualTo{Float64},
        }(),
    ) == 1
    return
end

function test_vector_ListOfConstraintIndices()
    sets = _VectorSets{Float64}()
    MOI.Utilities.add_set(sets, 2, 2)
    MOI.Utilities.add_set(sets, 1, 4)
    MOI.Utilities.add_set(sets, 2, 3)
    MOI.Utilities.add_set(sets, 3)
    MOI.Utilities.final_touch(sets)
    VAF = MOI.VectorAffineFunction{Float64}
    @test MOI.get(sets, MOI.ListOfConstraintIndices{VAF,MOI.Zeros}()) ==
          MOI.ConstraintIndex{VAF,MOI.Zeros}[]
    for (x, S) in zip([[1], [1, 3]], MOI.Utilities.set_types(sets)[1:2])
        ci = MOI.get(sets, MOI.ListOfConstraintIndices{VAF,S}())
        @test ci == MOI.ConstraintIndex{VAF,S}.(x)
    end
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    @test MOI.get(sets, MOI.ListOfConstraintIndices{F,S}()) ==
          [MOI.ConstraintIndex{F,S}(1)]
    return
end

"""
    test_vector_ListOfConstraintIndices2()

Test a more complicated sequence of dimensions to check the `_UnevenIterator`
works appropriately.
"""
function test_vector_ListOfConstraintIndices2()
    sets = _VectorSets{Float64}()
    MOI.Utilities.add_set(sets, 2, 2)
    MOI.Utilities.add_set(sets, 2, 3)
    MOI.Utilities.add_set(sets, 2, 2)
    MOI.Utilities.add_set(sets, 2, 4)
    MOI.Utilities.final_touch(sets)
    S = MOI.Utilities.set_types(sets)[2]
    VAF = MOI.VectorAffineFunction{Float64}
    indices = MOI.get(sets, MOI.ListOfConstraintIndices{VAF,S}())
    @test indices == MOI.ConstraintIndex{VAF,S}.([1, 3, 6, 8])
end

end

TestProductOfSets.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    test_objective_ObjectiveSense_MAX_SENSE(
        model::MOI.ModelLike,
        config::Config,
    )

Test setting objective sense to MAX_SENSE.
"""
function test_objective_ObjectiveSense_MAX_SENSE(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports(model, MOI.ObjectiveSense())
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MAX_SENSE
    return
end

"""
    test_objective_ObjectiveSense_MIN_SENSE(
        model::MOI.ModelLike,
        config::Config,
    )

Test setting objective sense to MIN_SENSE.
"""
function test_objective_ObjectiveSense_MIN_SENSE(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports(model, MOI.ObjectiveSense())
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.MIN_SENSE
    return
end

"""
    test_objective_ObjectiveSense_FEASIBILITY_SENSE(
        model::MOI.ModelLike,
        config::Config,
    )

Test setting objective sense to FEASIBILITY_SENSE.
"""
function test_objective_ObjectiveSense_FEASIBILITY_SENSE(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    @requires MOI.supports(model, MOI.ObjectiveSense())
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    @test MOI.get(model, MOI.ObjectiveSense()) == MOI.FEASIBILITY_SENSE
end

"""
    test_objective_FEASIBILITY_SENSE_clears_objective(
        model::MOI.ModelLike,
        config::Config,
    )

Test setting objective sense to FEASIBILITY_SENSE  clears previous objective.
"""
function test_objective_FEASIBILITY_SENSE_clears_objective(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(1), x)], T(0))
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    @test isapprox(MOI.get(model, MOI.ObjectiveValue()), T(1), config)
    MOI.set(model, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    MOI.optimize!(model)
    @test isapprox(MOI.get(model, MOI.ObjectiveValue()), T(0), config)
    return
end

function setup_test(
    ::typeof(test_objective_FEASIBILITY_SENSE_clears_objective),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) ->
            MOIU.mock_optimize!(mock, MOI.OPTIMAL, (MOI.FEASIBLE_POINT, T[1])),
    )
    return
end

"""
    test_objective_get_ObjectiveFunction_ScalarAffineFunction(
        model::MOI.ModelLike,
        config::Config,
    )

Test get objective function.
"""
function test_objective_get_ObjectiveFunction_ScalarAffineFunction(
    model::MOI.ModelLike,
    ::Config{T},
) where {T}
    obj_attr = MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}()
    @requires MOI.supports(model, obj_attr)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(1))
    MOI.set(model, obj_attr, f)
    @test_throws(
        InexactError,
        MOI.get(model, MOI.ObjectiveFunction{MOI.VariableIndex}()),
    )
    obj_fun = MOI.get(model, obj_attr)
    @test obj_fun ≈ f
    quad_obj_fun =
        MOI.get(model, MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}())
    @test convert(MOI.ScalarAffineFunction{T}, quad_obj_fun) ≈ f
    _test_attribute_value_type(model, MOI.ObjectiveFunctionType())
    _test_attribute_value_type(model, obj_attr)
    return
end

"""
    test_objective_ObjectiveFunction_constant(
        model::MOI.ModelLike,
        config::Config,
    )

Test constant in linear objective,  if `config.solve=true` confirm that it
solves correctly, and if `config.duals=true`, check that the duals are computed
correctly.
"""
function test_objective_ObjectiveFunction_constant(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    obj_attr = MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}()
    @requires MOI.supports(model, obj_attr)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(2), x)], T(1))
    MOI.set(model, obj_attr, f)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    _test_model_solution(
        model,
        config;
        objective_value = T(3),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(2))],
    )
    return
end

function setup_test(
    ::typeof(test_objective_ObjectiveFunction_constant),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
        ),
    )
    return
end

"""
    test_objective_ObjectiveFunction_blank(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test blank linear objective,  if `config.solve=true` confirm that it
solves correctly, and if `config.duals=true`, check that the duals are computed
correctly.
"""
function test_objective_ObjectiveFunction_blank(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires _supports(config, MOI.optimize!)
    obj_attr = MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}()
    @requires MOI.supports(model, obj_attr)
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(T(0), x)], T(0))
    MOI.set(model, obj_attr, f)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) == config.optimal_status
    @test isapprox(MOI.get(model, MOI.ObjectiveValue()), T(0), config)
    return
end

function setup_test(
    ::typeof(test_objective_ObjectiveFunction_blank),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[6//5]),
            MOI.FEASIBLE_POINT,
        ),
    )
    return
end

"""
    test_objective_ObjectiveFunction_VariableIndex(
        model::MOI.ModelLike,
        config::Config,
    )

Test VariableIndex objective,  if `config.solve=true` confirm that it
solves correctly, and if `config.duals=true`, check that the duals are computed
correctly.
"""
function test_objective_ObjectiveFunction_VariableIndex(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports(model, MOI.ObjectiveFunction{MOI.VariableIndex}())
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    _test_attribute_value_type(model, MOI.ObjectiveFunctionType())
    _test_attribute_value_type(
        model,
        MOI.ObjectiveFunction{MOI.VariableIndex}(),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(1),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(1))],
    )
    return
end

function setup_test(
    ::typeof(test_objective_ObjectiveFunction_VariableIndex),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
        ),
    )
    return
end

"""
    test_objective_qp_ObjectiveFunction_edge_cases(
        model::MOI.ModelLike,
        config::Config,
    )

Test various edge cases relating to quadratic programs (that is, with a quadratic
objective function).

If `config.solve=true` confirm that it solves correctly.
"""
function test_objective_qp_ObjectiveFunction_edge_cases(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    obj_attr = MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}()
    @requires MOI.supports(model, obj_attr)
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    vc1 = MOI.add_constraint(model, x[1], MOI.GreaterThan(T(1)))
    @test vc1.value == x[1].value
    vc2 = MOI.add_constraint(model, x[2], MOI.GreaterThan(T(2)))
    @test vc2.value == x[2].value
    # Basic model
    # min x^2 + y^2 | x>=1, y>=2
    MOI.set(
        model,
        obj_attr,
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.(T(2), x, x),  # quad
            MOI.ScalarAffineTerm{T}[],  # affine terms
            T(0),  # constant
        ),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(5),
        variable_primal = [(x[1], T(1)), (x[2], T(2))],
    )
    # Duplicate linear terms
    # min x + x + x^2 + y^2 | x>=1, y>=2
    MOI.set(
        model,
        obj_attr,
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.(T(2), x, x),  # quad
            MOI.ScalarAffineTerm.(T(1), [x[1], x[1]]),  # affine terms
            T(0),  # constant
        ),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(7),
        variable_primal = [(x[1], T(1)), (x[2], T(2))],
    )
    # Duplicate diagonal terms
    # min x^2 + x^2 | x>=1, y>=2
    MOI.set(
        model,
        obj_attr,
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.(T(2), [x[1], x[1]], [x[1], x[1]]),  # quad
            MOI.ScalarAffineTerm{T}[],  # affine terms
            T(0),  # constant
        ),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(2),
        variable_primal = [(x[1], T(1))],
    )
    # Duplicate off-diagonal terms" begin
    # min x^2 + 0.25x*y + 0.25y*x + 0.5x*y + y^2 | x>=1, y>=2
    MOI.set(
        model,
        obj_attr,
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.(
                T[2, 1//4, 1//4, 1//2, 2],
                [x[1], x[1], x[2], x[1], x[2]],
                [x[1], x[2], x[1], x[2], x[2]],
            ),  # quad
            MOI.ScalarAffineTerm{T}[],  # affine terms
            T(0),  # constant
        ),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(7),
        variable_primal = [(x[1], T(1)), (x[2], T(2))],
    )
    return
end

function setup_test(
    ::typeof(test_objective_qp_ObjectiveFunction_edge_cases),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 2]),
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 2]),
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 2]),
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 2]),
        ),
    )
    return
end

"""
    test_objective_qp_ObjectiveFunction_zero_ofdiag(
        model::MOI.ModelLike,
        config::Config,
    )

Test quadratic program with a zero off-diagonal term.

If `config.solve=true` confirm that it solves correctly.
"""
function test_objective_qp_ObjectiveFunction_zero_ofdiag(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    obj_attr = MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}()
    @requires MOI.supports(model, obj_attr)
    x = MOI.add_variables(model, 2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    vc1 = MOI.add_constraint(model, x[1], MOI.GreaterThan(T(1)))
    @test vc1.value == x[1].value
    vc2 = MOI.add_constraint(model, x[2], MOI.GreaterThan(T(2)))
    @test vc2.value == x[2].value
    MOI.set(
        model,
        obj_attr,
        MOI.ScalarQuadraticFunction(
            MOI.ScalarQuadraticTerm.(
                T[2, 0, 2],
                [x[1], x[1], x[2]],
                [x[1], x[2], x[2]],
            ),  # quad
            MOI.ScalarAffineTerm{T}[],  # affine terms
            T(0),  # constant
        ),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(5),
        variable_primal = [(x[1], T(1)), (x[2], T(2))],
    )
    return
end

function setup_test(
    ::typeof(test_objective_qp_ObjectiveFunction_zero_ofdiag),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 2]),
        ),
    )
    return
end

"""
    test_objective_ObjectiveFunction_duplicate_terms(
        model::MOI.ModelLike,
        config::Config,
    )

Test duplicate terms in linear objective, if `config.solve=true` confirm that it
solves correctly.
"""
function test_objective_ObjectiveFunction_duplicate_terms(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(T(1)))
    @test c.value == x.value
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}(),
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(T[2, 1], x), T(0)),
    )
    _test_model_solution(
        model,
        config;
        objective_value = T(3),
        variable_primal = [(x, T(1))],
        constraint_primal = [(c, T(1))],
        constraint_dual = [(c, T(3))],
    )
    return
end

function setup_test(
    ::typeof(test_objective_ObjectiveFunction_duplicate_terms),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1]),
            MOI.FEASIBLE_POINT,
        ),
    )
    return
end

"""
    test_objective_set_via_modify(
        model::MOI.ModelLike,
        config::Config{T},
    ) where {T}

Test that a ScalarAffineFunction can be set via modification without setting an
objective prior.
"""
function test_objective_set_via_modify(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    attr = MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}()
    @requires MOI.supports(model, attr)
    @requires _supports(config, MOI.modify)
    @requires _supports(config, MOI.ScalarCoefficientChange)
    @requires _supports(config, MOI.ListOfModelAttributesSet)
    @test MOI.get(model, MOI.ListOfModelAttributesSet()) == []
    x = MOI.add_variable(model)
    MOI.modify(model, attr, MOI.ScalarCoefficientChange(x, T(1)))
    @test MOI.get(model, MOI.ListOfModelAttributesSet()) == [attr]
    return
end

function test_objective_ObjectiveSense_in_ListOfModelAttributesSet(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    attr = MOI.ObjectiveSense()
    @requires MOI.supports(model, attr)
    @requires _supports(config, MOI.ListOfModelAttributesSet)
    @test (attr in MOI.get(model, MOI.ListOfModelAttributesSet())) == false
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    @test (attr in MOI.get(model, MOI.ListOfModelAttributesSet())) == true
    return
end

function version_added(
    ::typeof(test_objective_ObjectiveSense_in_ListOfModelAttributesSet),
)
    return v"1.12.0"
end

function test_objective_VariableIndex_in_ListOfModelAttributesSet(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    attr = MOI.ObjectiveFunction{MOI.VariableIndex}()
    @requires MOI.supports(model, attr)
    @requires _supports(config, MOI.ListOfModelAttributesSet)
    @test (attr in MOI.get(model, MOI.ListOfModelAttributesSet())) == false
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    x = MOI.add_variable(model)
    MOI.set(model, attr, x)
    @test (attr in MOI.get(model, MOI.ListOfModelAttributesSet())) == true
    return
end

function version_added(
    ::typeof(test_objective_VariableIndex_in_ListOfModelAttributesSet),
)
    return v"1.12.0"
end

function test_objective_ScalarAffineFunction_in_ListOfModelAttributesSet(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    attr = MOI.ObjectiveFunction{MOI.ScalarAffineFunction{T}}()
    @requires MOI.supports(model, attr)
    @requires _supports(config, MOI.ListOfModelAttributesSet)
    @test (attr in MOI.get(model, MOI.ListOfModelAttributesSet())) == false
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    x = MOI.add_variable(model)
    MOI.set(model, attr, one(T) * x + one(T))
    @test (attr in MOI.get(model, MOI.ListOfModelAttributesSet())) == true
    return
end

function version_added(
    ::typeof(test_objective_ScalarAffineFunction_in_ListOfModelAttributesSet),
)
    return v"1.12.0"
end

function test_objective_ScalarQuadraticFunction_in_ListOfModelAttributesSet(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    attr = MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}}()
    @requires MOI.supports(model, attr)
    @requires _supports(config, MOI.ListOfModelAttributesSet)
    @test (attr in MOI.get(model, MOI.ListOfModelAttributesSet())) == false
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    x = MOI.add_variable(model)
    MOI.set(model, attr, one(T) * x * x + one(T))
    @test (attr in MOI.get(model, MOI.ListOfModelAttributesSet())) == true
    return
end

function version_added(
    ::typeof(
        test_objective_ScalarQuadraticFunction_in_ListOfModelAttributesSet,
    ),
)
    return v"1.12.0"
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintFunctionize

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_scalar_functionize()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.ScalarFunctionize{Float64}(mock)
    x = MOI.add_variable(bridged_mock)
    y = MOI.add_variable(bridged_mock)
    ci = MOI.add_constraint(bridged_mock, x, MOI.GreaterThan(0.0))
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈ x
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.GreaterThan(0.0)
    MOI.set(bridged_mock, MOI.ConstraintSet(), ci, MOI.GreaterThan(1.0))
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.GreaterThan(1.0)
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        ((MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),),
    )
    MOI.Test.runtests(
        bridged_mock,
        MOI.Test.Config(),
        include = [
            "test_basic_VariableIndex_GreaterThan",
            "test_basic_VariableIndex_LessThan",
        ],
    )
    for T in [Int, Float64], S in [MOI.GreaterThan{T}, MOI.LessThan{T}]
        @test MOI.Bridges.added_constraint_types(
            MOI.Bridges.Constraint.ScalarFunctionizeBridge{T,S},
        ) == [(MOI.ScalarAffineFunction{T}, S)]
    end
    return
end

function test_scalar_functionize_linear2()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.ScalarFunctionize{Float64}(mock)
    MOI.Utilities.set_mock_optimize!(
        mock,
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1, 0],
            (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) =>
                [-1],
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [0, 1],
            constraint_basis_status = [
                (MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64}) => [MOI.NONBASIC],
                (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) => [MOI.BASIC, MOI.NONBASIC],
            ],
            variable_basis_status = [MOI.BASIC, MOI.NONBASIC_AT_LOWER],
        ),
    )
    MOI.Test.test_linear_integration_2(
        bridged_mock,
        MOI.Test.Config(
            exclude = Any[MOI.VariableBasisStatus, MOI.ConstraintBasisStatus],
        ),
    )
    cis = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VariableIndex,
            MOI.GreaterThan{Float64},
        }(),
    )
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        for ci in cis
            @test MOI.supports(bridged_mock, attr, typeof(ci))
            MOI.set(bridged_mock, attr, ci, 2.0)
            @test MOI.get(bridged_mock, attr, ci) == 2.0
        end
    end
    ci = cis[1]
    attr = MOI.Test.UnknownConstraintAttribute()
    BT = MOI.Bridges.Constraint.ScalarFunctionizeBridge{
        Float64,
        MOI.GreaterThan{Float64},
    }
    function _unsupported_attribute(attr, f)
        return MOI.UnsupportedAttribute(
            attr,
            "Bridge of type `$(BT)` does not support $(f)ting the attribute " *
            "`$attr` because `MOIB.Constraint.invariant_under_function_conversion($attr)` returns `false`.",
        )
    end
    @test_throws(
        _unsupported_attribute(attr, "set"),
        MOI.set(bridged_mock, attr, ci, 1.0),
    )
    @test_throws(
        _unsupported_attribute(attr, "get"),
        MOI.get(bridged_mock, attr, ci),
    )
    for (i, ci) in enumerate(cis)
        _test_delete_bridge(
            bridged_mock,
            ci,
            2,
            ((MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),),
            num_bridged = 3 - i,
        )
    end
    return
end

function test_vector_functionize()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.VectorFunctionize{Float64}(mock)
    x = MOI.add_variable(bridged_mock)
    y = MOI.add_variable(bridged_mock)
    z = MOI.add_variable(bridged_mock)
    v1 = MOI.VectorOfVariables([x, y, z])
    v2 = MOI.VectorOfVariables([x, y, y])
    ci = MOI.add_constraint(bridged_mock, v1, MOI.PowerCone(0.1))
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈ v1
    MOI.set(bridged_mock, MOI.ConstraintFunction(), ci, v2)
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) ≈ v2
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.PowerCone(0.1)
    MOI.set(bridged_mock, MOI.ConstraintSet(), ci, MOI.PowerCone(0.2))
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.PowerCone(0.2)
    _test_delete_bridge(
        bridged_mock,
        ci,
        3,
        ((MOI.VectorAffineFunction{Float64}, MOI.PowerCone{Float64}, 0),),
    )

    MOI.Test.runtests(
        bridged_mock,
        MOI.Test.Config(),
        include = [
            "test_basic_VectorOfVariables_Nonnegatives",
            "test_basic_VectorOfVariables_Nonpositives",
        ],
    )
    for T in [Int, Float64], S in [MOI.Nonnegatives, MOI.Nonpositives]
        @test MOI.Bridges.added_constraint_types(
            MOI.Bridges.Constraint.VectorFunctionizeBridge{T,S},
        ) == [(MOI.VectorAffineFunction{T}, S)]
    end
    return
end

function test_vector_functionize_lin1v()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    bridged_mock = MOI.Bridges.Constraint.VectorFunctionize{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [1.0, 0.0, 2.0],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [[0, 2, 0]],
            (MOI.VectorAffineFunction{Float64}, MOI.Zeros) => [[-3, -1]],
        )
    MOI.Test.test_conic_linear_VectorOfVariables(
        bridged_mock,
        MOI.Test.Config(),
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorOfVariables,
                MOI.Nonnegatives,
            }(),
        ),
    )
    func = MOI.get(bridged_mock, MOI.ConstraintFunction(), ci)
    MOI.delete(bridged_mock, func.variables[2])
    new_func = MOI.VectorOfVariables(func.variables[[1, 3]])
    @test MOI.get(bridged_mock, MOI.ConstraintFunction(), ci) == new_func
    @test MOI.get(bridged_mock, MOI.ConstraintSet(), ci) == MOI.Nonnegatives(2)
    for attr in [MOI.ConstraintPrimalStart(), MOI.ConstraintDualStart()]
        @test MOI.supports(bridged_mock, attr, typeof(ci))
        MOI.set(bridged_mock, attr, ci, [1.0, 2.0])
        @test MOI.get(bridged_mock, attr, ci) == [1.0, 2.0]
    end
    _test_delete_bridge(
        bridged_mock,
        ci,
        2,
        ((MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives, 0),),
    )
    return
end

function test_unsupported_attribute_issue_1758()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.ScalarFunctionize{Float64}(inner)
    MOI.Test.test_model_copy_to_UnsupportedAttribute(model, MOI.Test.Config())
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ScalarFunctionizeBridge,
        """
        variables: x
        x >= 1.0
        """,
        """
        variables: x
        1.0 * x >= 1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ScalarFunctionizeBridge,
        """
        variables: x
        x <= 1.0
        """,
        """
        variables: x
        1.0 * x <= 1.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ScalarFunctionizeBridge,
        """
        variables: x
        x in ZeroOne()
        """,
        """
        variables: x
        1.0 * x in ZeroOne()
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorFunctionizeBridge,
        """
        variables: x
        [x] in Nonnegatives(1)
        """,
        """
        variables: x
        [1.0 * x] in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorFunctionizeBridge,
        """
        variables: x
        [x] in Nonpositives(1)
        """,
        """
        variables: x
        [1.0 * x] in Nonpositives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.VectorFunctionizeBridge,
        """
        variables: t, x
        [t, x] in SecondOrderCone(2)
        """,
        """
        variables: t, x
        [1.0 * t, 1.0 * x] in SecondOrderCone(2)
        """,
    )
    return
end

function test_FunctionConversionBridge()
    # ScalarAffineFunction -> ScalarQuadraticFunction
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ToScalarQuadraticBridge,
        """
        variables: x
        1.0 * x in ZeroOne()
        """,
        """
        variables: x
        0.0 * x * x + 1.0 * x in ZeroOne()
        """,
    )
    # ScalarQuadraticFunction -> ScalarNonlinearFunction
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ToScalarNonlinearBridge,
        """
        variables: x, y
        1.0 * x * x + 2.0 * x * y + 3.0 * y + 4.0 >= 1.0
        """,
        """
        variables: x, y
        ScalarNonlinearFunction(1.0 * x * x + 2.0 * x * y + 3.0 * y + 4.0) >= 1.0
        """,
    )
    # VectorAffineFunction -> VectorQuadraticFunction
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.ToVectorQuadraticBridge,
        """
        variables: t, x
        [1.0 * t, 1.0 * x] in SecondOrderCone(2)
        """,
        """
        variables: t, x
        [0.0 * t * t + 1.0 * t, 0.0 * t * t + 1.0 * x] in SecondOrderCone(2)
        """,
    )
    return
end

function test_canonical_constraint_function()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.ScalarFunctionize{Float64}(inner)
    x = MOI.add_variable(model)
    ci = MOI.add_constraint(model, x, MOI.GreaterThan(0.0))
    @test MOI.get(model, MOI.CanonicalConstraintFunction(), ci) ≈ x
    return
end

function test_first_bridge()
    inner = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.ScalarFunctionize{Float64}(inner)
    x = MOI.add_variable(model)
    ci = MOI.add_constraint(model, x, MOI.GreaterThan(0.0))
    b = MOI.get(model, MOI.Bridges.FirstBridge(), ci)
    @test b isa MOI.Bridges.Constraint.ScalarFunctionizeBridge
    return
end

function test_approx_convert(T = Float64)
    inner = MOI.Utilities.Model{T}()
    # `SOCtoRSOC` will rotate the function so there will be small
    # rounding errors when getting the `ConstraintFunction`
    # and we test that it's ignored
    soc = MOI.Bridges.Constraint.SOCR{T}(inner)
    model = MOI.Bridges.Constraint.VectorFunctionize{T}(soc)
    config = MOI.Test.Config(T)
    MOI.Test.test_basic_VectorOfVariables_SecondOrderCone(model, config)
    return
end

function test_supports_ScalarNonlinearFunction()
    for T in (Int, Float64)
        model = MOI.instantiate(MOI.Utilities.Model{T}; with_bridge_type = T)
        for (F, flag) in [
            MOI.ScalarNonlinearFunction => true,
            MOI.ScalarAffineFunction{Float64} => (T == Float64),
            MOI.ScalarAffineFunction{Int} => (T == Int),
        ]
            @test MOI.supports_constraint(model, F, MOI.EqualTo{T}) == flag
        end
    end
    return
end

function test_issue_2838()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Constraint.ScalarFunctionize{Float64}(inner)
    x = MOI.add_variable(model)
    c = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}
    ci = only(MOI.get(inner, MOI.ListOfConstraintIndices{F,S}()))
    for ret in (MOI.NOT_IN_CONFLICT, MOI.IN_CONFLICT, MOI.MAYBE_IN_CONFLICT)
        MOI.set(inner, MOI.ConflictCount(), 1)
        MOI.set(inner, MOI.ConstraintConflictStatus(), ci, ret)
        MOI.compute_conflict!(model)
        @test MOI.get(model, MOI.ConstraintConflictStatus(), c) == ret
    end
    return
end

end  # module

TestConstraintFunctionize.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestBridgesDebug

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

# This model is chosen because it has a number of properties that need bridging.

MOI.Utilities.@model(
    Model,
    (),
    (),
    (MOI.Reals, MOI.Zeros, MOI.Nonnegatives, MOI.RotatedSecondOrderCone),
    (),
    (),
    (),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction,)
)

function MOI.supports_constraint(
    ::Model{T},
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.Utilities.SUPPORTED_VARIABLE_SCALAR_SETS{T}},
) where {T}
    return false
end

MOI.supports(::Model, ::MOI.ObjectiveFunction{MOI.VariableIndex}) = false

function MOI.supports(
    ::Model{T},
    ::MOI.ObjectiveFunction{MOI.ScalarQuadraticFunction{T}},
) where {T}
    return false
end

MOI.supports_add_constrained_variables(::Model, ::Type{MOI.Reals}) = false

MOI.supports_add_constrained_variables(::Model, ::Type{MOI.Nonnegatives}) = true

function test_print_active_bridges()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    xs, _ = MOI.add_constrained_variables(model, MOI.Nonpositives(2))
    x = xs[1]
    MOI.add_constraint.(model, 1.0 * x, MOI.Interval(1.0, 2.0))
    MOI.add_constraint.(model, 1.0 * x, MOI.EqualTo(1.4))
    MOI.add_constraint.(model, 1.0 * x * x, MOI.LessThan(2.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = 1.0 * x * x
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    content = """
 * Unsupported objective: MOI.ScalarQuadraticFunction{Float64}
 |  bridged by:
 |   MOIB.Objective.SlackBridge{Float64, MOI.ScalarQuadraticFunction{Float64}, MOI.ScalarQuadraticFunction{Float64}}
 |  may introduce:
 |   * Unsupported objective: MOI.VariableIndex
 |   |  bridged by:
 |   |   MOIB.Objective.FunctionConversionBridge{Float64, MOI.ScalarAffineFunction{Float64}, MOI.VariableIndex}
 |   |  may introduce:
 |   |   * Supported objective: MOI.ScalarAffineFunction{Float64}
 |   * Unsupported constraint: MOI.ScalarQuadraticFunction{Float64}-in-MOI.GreaterThan{Float64}
 |   |  bridged by:
 |   |   MOIB.Constraint.QuadtoSOCBridge{Float64}
 |   |  may introduce:
 |   |   * Supported constraint: MOI.VectorAffineFunction{Float64}-in-MOI.RotatedSecondOrderCone
 |   * Unsupported constraint: MOI.ScalarQuadraticFunction{Float64}-in-MOI.LessThan{Float64}
 |   |  bridged by:
 |   |   MOIB.Constraint.QuadtoSOCBridge{Float64}
 |   |  may introduce:
 |   |   * Supported constraint: MOI.VectorAffineFunction{Float64}-in-MOI.RotatedSecondOrderCone
 |   * Unsupported variable: MOI.Reals
 |   |  bridged by:
 |   |    MOIB.Variable.FreeBridge{Float64}
 |   |  may introduce:
 |   |   * Supported variable: MOI.Nonnegatives
 * Unsupported constraint: MOI.ScalarAffineFunction{Float64}-in-MOI.EqualTo{Float64}
 |  bridged by:
 |   MOIB.Constraint.VectorizeBridge{Float64, MOI.VectorAffineFunction{Float64}, MOI.Zeros, MOI.ScalarAffineFunction{Float64}}
 |  may introduce:
 |   * Supported constraint: MOI.VectorAffineFunction{Float64}-in-MOI.Zeros
 * Unsupported constraint: MOI.ScalarAffineFunction{Float64}-in-MOI.Interval{Float64}
 |  bridged by:
 |   MOIB.Constraint.IntervalToHyperRectangleBridge{Float64, MOI.VectorAffineFunction{Float64}, MOI.ScalarAffineFunction{Float64}}
 |  may introduce:
 |   * Unsupported constraint: MOI.VectorAffineFunction{Float64}-in-MOI.HyperRectangle{Float64}
 |   |  bridged by:
 |   |   MOIB.Constraint.SplitHyperRectangleBridge{Float64, MOI.VectorAffineFunction{Float64}, MOI.VectorAffineFunction{Float64}}
 |   |  may introduce:
 |   |   * Supported constraint: MOI.VectorAffineFunction{Float64}-in-MOI.Nonnegatives
 * Unsupported constraint: MOI.ScalarQuadraticFunction{Float64}-in-MOI.LessThan{Float64}
 |  bridged by:
 |   MOIB.Constraint.QuadtoSOCBridge{Float64}
 |  may introduce:
 |   * Supported constraint: MOI.VectorAffineFunction{Float64}-in-MOI.RotatedSecondOrderCone
 * Unsupported variable: MOI.Nonpositives
 |  bridged by:
 |    MOIB.Variable.NonposToNonnegBridge{Float64}
 |  may introduce:
 |   * Supported variable: MOI.Nonnegatives
"""
    # Prints to stdout, but just check it doesn't error.
    mktemp() do _, io
        redirect_stdout(io) do
            return MOI.Bridges.print_active_bridges(model)
        end
        seekstart(io)
        @test read(io, String) == content
        return
    end
    @test sprint(MOI.Bridges.print_active_bridges, model) == content
    return
end

MOI.Utilities.@model(
    ParameterModel,
    (),
    (MOI.EqualTo,),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
)

function MOI.supports_constraint(
    ::ParameterModel,
    ::Type{MOI.VariableIndex},
    ::Type{<:MOI.Parameter},
)
    return false
end

function test_print_active_bridges_parameter()
    inner = ParameterModel{Float64}()
    model = MOI.Bridges.full_bridge_optimizer(inner, Float64)
    p, _ = MOI.add_constrained_variable(model, MOI.Parameter(2.5))
    @test sprint(MOI.Bridges.print_active_bridges, model) === """
 * Supported objective: MOI.ScalarAffineFunction{Float64}
 * Unsupported variable: MOI.Parameter{Float64}
 |  bridged by:
 |    MOIB.Variable.ParameterToEqualToBridge{Float64}
 |  may introduce:
 |   * Supported variable: MOI.EqualTo{Float64}
"""
    return
end

function test_print_active_bridges_objective_supported()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    F = MOI.ScalarAffineFunction{Float64}
    @test sprint(MOI.Bridges.print_active_bridges, model, F) === """
           * Supported objective: MOI.ScalarAffineFunction{Float64}
          """
    return
end

function test_print_active_bridges_objective_bridged()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    @test sprint(MOI.Bridges.print_active_bridges, model, MOI.VariableIndex) ===
          """
           * Unsupported objective: MOI.VariableIndex
           |  bridged by:
           |   MOIB.Objective.FunctionConversionBridge{Float64, MOI.ScalarAffineFunction{Float64}, MOI.VariableIndex}
           |  may introduce:
           |   * Supported objective: MOI.ScalarAffineFunction{Float64}
          """
    return
end

function test_print_active_bridges_objective_unsupported()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    F = MOI.ScalarAffineFunction{Int}
    @test_throws(
        MOI.UnsupportedAttribute{MOI.ObjectiveFunction{F}},
        MOI.Bridges.print_active_bridges(model, F),
    )
    return
end

function test_print_active_bridges_constraint_supported()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    F = MOI.VectorAffineFunction{Float64}
    S = MOI.Nonnegatives
    @test sprint(MOI.Bridges.print_active_bridges, model, F, S) === """
           * Supported constraint: MOI.VectorAffineFunction{Float64}-in-MOI.Nonnegatives
          """
    return
end

function test_print_active_bridges_constraint_bridged()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    F = MOI.VectorAffineFunction{Float64}
    S = MOI.Nonpositives
    content = """
     * Unsupported constraint: MOI.VectorAffineFunction{Float64}-in-MOI.Nonpositives
     |  bridged by:
     |   MOIB.Constraint.NonposToNonnegBridge{Float64, MOI.VectorAffineFunction{Float64}, MOI.VectorAffineFunction{Float64}}
     |  may introduce:
     |   * Supported constraint: MOI.VectorAffineFunction{Float64}-in-MOI.Nonnegatives
    """
    @test sprint(MOI.Bridges.print_active_bridges, model, F, S) === content
    return
end

function test_print_active_bridges_constraint_unsupported()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    F = MOI.ScalarAffineFunction{Int}
    S = MOI.ZeroOne
    @test_throws(
        MOI.UnsupportedConstraint{F,S},
        MOI.Bridges.print_active_bridges(model, F, S),
    )
    return
end

function test_print_active_bridges_variable_supported()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    S = MOI.Nonnegatives
    @test sprint(MOI.Bridges.print_active_bridges, model, S) === """
           * Supported variable: MOI.Nonnegatives
          """
    return
end

function test_print_active_bridges_variable_bridged()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    S = MOI.Reals
    content = """
     * Unsupported variable: MOI.Reals
     |  bridged by:
     |    MOIB.Variable.FreeBridge{Float64}
     |  may introduce:
     |   * Supported variable: MOI.Nonnegatives
    """
    @test sprint(MOI.Bridges.print_active_bridges, model, S) === content
    return
end

function test_print_active_bridges_variable_unsupported()
    model = MOI.Bridges.full_bridge_optimizer(Model{Float64}(), Float64)
    @test_throws(
        MOI.UnsupportedConstraint{MOI.VariableIndex,MOI.ZeroOne},
        MOI.Bridges.print_active_bridges(model, MOI.ZeroOne),
    )
    @test_throws(
        MOI.UnsupportedConstraint{MOI.VectorOfVariables,MOI.ExponentialCone},
        MOI.Bridges.print_active_bridges(model, MOI.ExponentialCone),
    )
    return
end

MOI.Utilities.@model(
    ConstraintModel,
    (MOI.ZeroOne, MOI.Integer),
    (MOI.GreaterThan, MOI.LessThan, MOI.EqualTo),
    (),
    (),
    (),
    (MOI.ScalarAffineFunction,),
    (),
    ()
)

function test_print_active_bridges_variable_bridged_with_constraint()
    model =
        MOI.Bridges.full_bridge_optimizer(ConstraintModel{Float64}(), Float64)
    content = """
     * Unsupported variable: MOI.AllDifferent
     |  adding as constraint:
     |   * Supported variable: MOI.Reals
     |   * Unsupported constraint: MOI.VectorOfVariables-in-MOI.AllDifferent
     |   |  bridged by:
     |   |   MOIB.Constraint.AllDifferentToCountDistinctBridge{Float64, MOI.VectorOfVariables}
     |   |  may introduce:
     |   |   * Unsupported constraint: MOI.VectorOfVariables-in-MOI.CountDistinct
     |   |   |  bridged by:
     |   |   |   MOIB.Constraint.CountDistinctToMILPBridge{Float64, MOI.VectorOfVariables}
     |   |   |  may introduce:
     |   |   |   * Supported constraint: MOI.ScalarAffineFunction{Float64}-in-MOI.EqualTo{Float64}
     |   |   |   * Supported constraint: MOI.ScalarAffineFunction{Float64}-in-MOI.LessThan{Float64}
     |   |   |   * Supported variable: MOI.ZeroOne
     |   |   * Supported variable: MOI.EqualTo{Float64}
    """
    S = MOI.AllDifferent
    @test sprint(MOI.Bridges.print_active_bridges, model, S) === content
    return
end

function test_print_graph_stdout()
    model = MOI.Utilities.Model{Float64}()
    bridged = MOI.Bridges.full_bridge_optimizer(model, Float64)
    dir = mktempdir()
    filename = joinpath(dir, "tmp.out")
    open(filename, "w") do io
        redirect_stdout(io) do
            MOI.Bridges.print_graph(bridged)
            return
        end
        return
    end
    @test read(filename, String) ==
          "Bridge graph with 0 variable nodes, 0 constraint nodes and 0 objective nodes.\n"
    return
end

end

TestBridgesDebug.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module MPS

import ..FileFormats
import MathOptInterface as MOI
import OrderedCollections: OrderedDict

const IndicatorLessThanTrue{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{T}}

const IndicatorGreaterThanTrue{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.GreaterThan{T}}

const IndicatorEqualToTrue{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.EqualTo{T}}

const IndicatorLessThanFalse{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.LessThan{T}}

const IndicatorGreaterThanFalse{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.GreaterThan{T}}

const IndicatorEqualToFalse{T} =
    MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.EqualTo{T}}

MOI.Utilities.@model(
    Model,
    (MOI.ZeroOne, MOI.Integer),
    (MOI.EqualTo, MOI.GreaterThan, MOI.LessThan, MOI.Interval),
    (),
    (
        MOI.SOS1,
        MOI.SOS2,
        IndicatorLessThanTrue,
        IndicatorLessThanFalse,
        IndicatorGreaterThanTrue,
        IndicatorGreaterThanFalse,
        IndicatorEqualToTrue,
        IndicatorEqualToFalse,
    ),
    (),
    (MOI.ScalarAffineFunction, MOI.ScalarQuadraticFunction),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction,)
)

function MOI.supports_constraint(
    ::Model{T},
    ::Type{MOI.VectorAffineFunction{T}},
    ::Type{<:Union{MOI.SOS1{T},MOI.SOS2{T}}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::Model,
    ::Type{MOI.VariableIndex},
    ::Type{<:Union{MOI.Parameter,MOI.Semicontinuous,MOI.Semiinteger}},
)
    return false
end

function MOI.supports_constraint(
    ::Model{T},
    ::Type{MOI.VectorOfVariables},
    ::Type{
        <:Union{
            IndicatorLessThanTrue{T},
            IndicatorLessThanFalse{T},
            IndicatorGreaterThanTrue{T},
            IndicatorGreaterThanFalse{T},
            IndicatorEqualToTrue{T},
            IndicatorEqualToFalse{T},
        },
    },
) where {T}
    return false
end

MOI.supports(::Model, ::MOI.ObjectiveFunction) = false

function MOI.supports(
    ::Model{T},
    ::MOI.ObjectiveFunction{
        <:Union{
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{T},
            MOI.ScalarQuadraticFunction{T},
        },
    },
) where {T}
    return true
end

@enum(
    QuadraticFormat,
    kQuadraticFormatCPLEX,
    kQuadraticFormatGurobi,
    kQuadraticFormatMosek,
)

struct Options
    warn::Bool
    objsense::Bool
    generic_names::Bool
    quadratic_format::QuadraticFormat
end

function get_options(m::Model)::Options
    return get(
        m.ext,
        :MPS_OPTIONS,
        Options(false, false, false, kQuadraticFormatGurobi),
    )
end

"""
    Model(;
        warn::Bool = false,
        print_objsense::Bool = false,
        generic_names::Bool = false,
        quadratic_format::QuadraticFormat = kQuadraticFormatGurobi,
        coefficient_type::Type{T} = Float64,
    ) where {T}

Create an empty instance of FileFormats.MPS.Model.

Keyword arguments are:

 - `warn::Bool=false`: print a warning when variables or constraints are renamed.

 - `print_objsense::Bool=false`: print the OBJSENSE section when writing

 - `generic_names::Bool=false`: strip all names in the model and replace them
   with the generic names `C\$i` and `R\$i` for the i'th column and row
   respectively.

 - `quadratic_format::QuadraticFormat = kQuadraticFormatGurobi`: specify the
   solver-specific extension used when writing the quadratic components of the
   model. Options are `kQuadraticFormatGurobi`, `kQuadraticFormatCPLEX`, and
   `kQuadraticFormatMosek`.

 - `coefficient_type::Type{T}=Float64`: the supported type to use when reading
   and writing files.
"""
function Model(;
    warn::Bool = false,
    print_objsense::Bool = false,
    generic_names::Bool = false,
    quadratic_format::QuadraticFormat = kQuadraticFormatGurobi,
    coefficient_type::Type{T} = Float64,
) where {T}
    model = Model{T}()
    model.ext[:MPS_OPTIONS] =
        Options(warn, print_objsense, generic_names, quadratic_format)
    return model
end

Base.summary(io::IO, ::Model) = print(io, "MOI.FileFormats.MPS.Model")

@enum(VType, VTYPE_CONTINUOUS, VTYPE_INTEGER, VTYPE_BINARY)

include("read.jl")
include("write.jl")

import PrecompileTools

PrecompileTools.@setup_workload begin
    PrecompileTools.@compile_workload begin
        let
            model = Model()
            x = MOI.add_variables(model, 4)
            for i in 1:4
                MOI.set(model, MOI.VariableName(), x[i], "x[$i]")
            end
            MOI.add_constraint(model, x[1], MOI.LessThan(1.0))
            MOI.add_constraint(model, x[2], MOI.GreaterThan(1.0))
            MOI.add_constraint(model, x[3], MOI.EqualTo(1.2))
            MOI.add_constraint(model, x[4], MOI.Interval(-1.0, 100.0))
            MOI.add_constraint(model, x[1], MOI.ZeroOne())
            MOI.add_constraint(model, x[2], MOI.Integer())
            MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
            f = 1.0 * x[1] + 2.0 * x[2] + 3.0
            MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
            MOI.add_constraint(model, 1.5 * x[1], MOI.LessThan(1.0))
            MOI.add_constraint(model, 1.5 * x[2], MOI.GreaterThan(1.0))
            MOI.add_constraint(model, 1.5 * x[3], MOI.EqualTo(1.2))
            MOI.add_constraint(model, 1.5 * x[4], MOI.Interval(-1.0, 100.0))
            io = IOBuffer()
            write(io, model)
        end
    end
end

# Originally removed by #2421, but this constant was used by extensions like
# BilevelJuMP so I'm re-adding to maintain backwards compatibility.
const SET_TYPES = (
    (MOI.LessThan{Float64}, "L"),
    (MOI.GreaterThan{Float64}, "G"),
    (MOI.EqualTo{Float64}, "E"),
    (MOI.Interval{Float64}, "L"),
)

end  # module MPS

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    test_cpsat_AllDifferent(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-AllDifferent constraint.
"""
function test_cpsat_AllDifferent(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.AllDifferent,
    )
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    y = [MOI.add_constrained_variable(model, MOI.Integer()) for _ in 1:3]
    x = first.(y)
    MOI.add_constraint.(model, x, MOI.Interval(zero(T), T(2)))
    MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.AllDifferent(3))
    MOI.optimize!(model)
    x_val = MOI.get.(model, MOI.VariablePrimal(), x)
    @test abs(x_val[1] - x_val[2]) > 0.5
    @test abs(x_val[1] - x_val[3]) > 0.5
    @test abs(x_val[2] - x_val[3]) > 0.5
    return
end

function setup_test(
    ::typeof(test_cpsat_AllDifferent),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[0, 1, 2]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_AllDifferent)) = v"1.4.0"

"""
    test_cpsat_ReifiedAllDifferent(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-Reified{AllDifferent} constraint.
"""
function test_cpsat_ReifiedAllDifferent(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Reified{MOI.AllDifferent},
    )
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    z, _ = MOI.add_constrained_variable(model, MOI.ZeroOne())
    y = [MOI.add_constrained_variable(model, MOI.Integer()) for _ in 1:3]
    x = first.(y)
    MOI.add_constraint.(model, x, MOI.Interval(zero(T), T(2)))
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables([z; x]),
        MOI.Reified(MOI.AllDifferent(3)),
    )
    c = MOI.add_constraint(model, z, MOI.EqualTo(T(1)))
    MOI.optimize!(model)
    x_val = MOI.get.(model, MOI.VariablePrimal(), x)
    @test abs(x_val[1] - x_val[2]) > 0.5
    @test abs(x_val[1] - x_val[3]) > 0.5
    @test abs(x_val[2] - x_val[3]) > 0.5
    MOI.set(model, MOI.ConstraintSet(), c, MOI.EqualTo(T(0)))
    MOI.optimize!(model)
    x_val = MOI.get.(model, MOI.VariablePrimal(), x)
    @test abs(x_val[1] - x_val[2]) < 0.5 ||
          abs(x_val[1] - x_val[3]) < 0.5 ||
          abs(x_val[2] - x_val[3]) < 0.5
    return
end

function setup_test(
    ::typeof(test_cpsat_ReifiedAllDifferent),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 0, 1, 2]),
        ),
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[0, 0, 1, 1]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_ReifiedAllDifferent)) = v"1.8.0"

"""
    test_cpsat_CountDistinct(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-CountDistinct constraint.
"""
function test_cpsat_CountDistinct(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.CountDistinct,
    )
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    y = [MOI.add_constrained_variable(model, MOI.Integer()) for _ in 1:4]
    x = first.(y)
    MOI.add_constraint.(model, x, MOI.Interval(T(0), T(4)))
    MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.CountDistinct(4))
    MOI.optimize!(model)
    x_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), x))
    @test length(unique(x_val[2:end])) == x_val[1]
    return
end

function setup_test(
    ::typeof(test_cpsat_CountDistinct),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2, 0, 1, 0]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_CountDistinct)) = v"1.4.0"

"""
    test_cpsat_CountBelongs(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-CountBelongs constraint.
"""
function test_cpsat_CountBelongs(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.CountBelongs,
    )
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    y = [MOI.add_constrained_variable(model, MOI.Integer()) for _ in 1:4]
    x = first.(y)
    MOI.add_constraint.(model, x, MOI.Interval(T(0), T(4)))
    set = Set([3, 4])
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(x),
        MOI.CountBelongs(4, set),
    )
    MOI.optimize!(model)
    x_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), x))
    @test x_val[1] == sum(x_val[i] in set for i in 2:length(x))
    return
end

function setup_test(
    ::typeof(test_cpsat_CountBelongs),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2, 3, 4, 0]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_CountBelongs)) = v"1.4.0"

"""
    test_cpsat_CountAtLeast(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-CountAtLeast constraint.
"""
function test_cpsat_CountAtLeast(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.CountAtLeast,
    )
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    x, _ = MOI.add_constrained_variable(model, MOI.Integer())
    y, _ = MOI.add_constrained_variable(model, MOI.Integer())
    z, _ = MOI.add_constrained_variable(model, MOI.Integer())
    MOI.add_constraint.(model, [x, y, z], MOI.Interval(T(0), T(3)))
    variables = [x, y, y, z]
    partitions = [2, 2]
    set = Set([3])
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(variables),
        MOI.CountAtLeast(1, partitions, set),
    )
    MOI.optimize!(model)
    x_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), [x, y, z]))
    @test x_val[1] == 3 || x_val[2] == 3
    @test x_val[2] == 3 || x_val[3] == 3
    return
end

function setup_test(
    ::typeof(test_cpsat_CountAtLeast),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[0, 3, 0]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_CountAtLeast)) = v"1.4.0"

"""
    test_cpsat_CountGreaterThan(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-CountGreaterThan constraint.
"""
function test_cpsat_CountGreaterThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.CountGreaterThan,
    )
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    c, _ = MOI.add_constrained_variable(model, MOI.Integer())
    y, _ = MOI.add_constrained_variable(model, MOI.Integer())
    x = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
    MOI.add_constraint(model, c, MOI.Interval(T(0), T(6)))
    MOI.add_constraint.(model, x, MOI.Interval(T(0), T(4)))
    MOI.add_constraint(model, y, MOI.Interval(T(0), T(4)))
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables([c; y; x]),
        MOI.CountGreaterThan(5),
    )
    MOI.optimize!(model)
    c_val = round(Int, MOI.get(model, MOI.VariablePrimal(), c))
    y_val = round(Int, MOI.get(model, MOI.VariablePrimal(), y))
    x_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), x))
    @test c_val > sum(x_val[i] == y_val for i in 1:length(x))
    return
end

function setup_test(
    ::typeof(test_cpsat_CountGreaterThan),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[2, 4, 0, 4, 0]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_CountGreaterThan)) = v"1.4.0"

"""
    test_cpsat_BinPacking(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-BinPacking constraint.
"""
function test_cpsat_BinPacking(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.BinPacking{T},
    )
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    N = 5
    bins = MOI.add_variables(model, N)
    weights = T[1, 1, 2, 2, 3]
    MOI.add_constraint.(model, bins, MOI.Integer())
    MOI.add_constraint.(model, bins, MOI.Interval(T(1), T(3)))
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables(bins),
        MOI.BinPacking(T(3), weights),
    )
    MOI.optimize!(model)
    x_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), bins))
    sol = zeros(3)
    for i in 1:N
        sol[x_val[i]] += weights[i]
    end
    @test all(sol .<= 3)
    return
end

function setup_test(
    ::typeof(test_cpsat_BinPacking),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 2, 1, 2, 3]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_BinPacking)) = v"1.4.0"

"""
    test_cpsat_Cumulative(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-Cumulative constraint.
"""
function test_cpsat_Cumulative(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Cumulative,
    )
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    s = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
    MOI.add_constraint.(model, s, MOI.Interval(T(0), T(3)))
    d = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
    MOI.add_constraint.(model, d, MOI.EqualTo(T(2)))
    r = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
    MOI.add_constraint.(model, r, MOI.EqualTo.(T[3, 2, 1]))
    b, _ = MOI.add_constrained_variable(model, MOI.Integer())
    MOI.add_constraint.(model, b, MOI.EqualTo(T(5)))
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables([s; d; r; b]),
        MOI.Cumulative(10),
    )
    MOI.optimize!(model)
    s_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), s))
    d_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), d))
    r_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), r))
    b_val = round(Int, MOI.get(model, MOI.VariablePrimal(), b))
    times = zeros(1 + maximum(s_val) + maximum(d_val))
    for i in 1:3
        for j in 0:(d_val[i]-1)
            t = s_val[i] + j
            times[t+1] += r_val[i]
        end
    end
    @test all(times .<= b_val)
    return
end

function setup_test(
    ::typeof(test_cpsat_Cumulative),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[0, 1, 2, 2, 2, 2, 3, 2, 1, 5]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_Cumulative)) = v"1.4.0"

"""
    test_cpsat_Table(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-Table constraint.
"""
function test_cpsat_Table(model::MOI.ModelLike, config::Config{T}) where {T}
    @requires MOI.supports_constraint(
        model,
        MOI.VectorOfVariables,
        MOI.Table{T},
    )
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    x = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
    table = T[1 1 0; 0 1 1]
    MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Table(table))
    MOI.optimize!(model)
    x_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), x))
    @test x_val == [1, 1, 0] || x_val == [0, 1, 1]
    return
end

function setup_test(
    ::typeof(test_cpsat_Table),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 1, 0]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_Table)) = v"1.4.0"

"""
    test_cpsat_Circuit(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-Circuit constraint.
"""
function test_cpsat_Circuit(model::MOI.ModelLike, config::Config{T}) where {T}
    @requires MOI.supports_constraint(model, MOI.VectorOfVariables, MOI.Circuit)
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    x = [MOI.add_constrained_variable(model, MOI.Integer())[1] for _ in 1:3]
    MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Circuit(3))
    MOI.optimize!(model)
    x_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), x))
    @test x_val == [3, 1, 2] || x_val == [2, 3, 1]
    return
end

function setup_test(
    ::typeof(test_cpsat_Circuit),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[3, 1, 2]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_Circuit)) = v"1.4.0"

"""
    test_cpsat_Path(model::MOI.ModelLike, config::Config)

Add a VectorOfVariables-in-Path constraint.
"""
function test_cpsat_Path(model::MOI.ModelLike, config::Config{T}) where {T}
    @requires MOI.supports_constraint(model, MOI.VectorOfVariables, MOI.Path)
    @requires MOI.supports_add_constrained_variable(model, MOI.Integer)
    @requires _supports(config, MOI.optimize!)
    from = [1, 1, 2, 2, 3]
    to = [2, 3, 3, 4, 4]
    N, E = 4, 5
    s, _ = MOI.add_constrained_variable(model, MOI.Integer())
    t, _ = MOI.add_constrained_variable(model, MOI.Integer())
    ns = MOI.add_variables(model, N)
    MOI.add_constraint.(model, ns, MOI.ZeroOne())
    es = MOI.add_variables(model, E)
    MOI.add_constraint.(model, es, MOI.ZeroOne())
    MOI.add_constraint(
        model,
        MOI.VectorOfVariables([s; t; ns; es]),
        MOI.Path(from, to),
    )
    MOI.optimize!(model)
    s_val = round(Int, MOI.get(model, MOI.VariablePrimal(), s))
    @test 1 <= s_val <= 4
    t_val = round(Int, MOI.get(model, MOI.VariablePrimal(), t))
    @test 1 <= t_val <= 4
    ns_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), ns))
    es_val = round.(Int, MOI.get.(model, MOI.VariablePrimal(), es))
    # The graph is un-directed, so check the number of edges at each node.
    edges = Vector{Int}[[1, 2], [1, 3, 4], [2, 3, 5], [4, 5]]
    has_edges = s_val == t_val ? 0 : 1
    # source and sink: must have one edge (if s != t), otherwise 0
    @test sum(es_val[o] for o in edges[s_val]; init = 0) == has_edges
    @test sum(es_val[o] for o in edges[t_val]; init = 0) == has_edges
    for i in 1:4
        if i != s_val && i != t_val
            # other nodes: must have two edges if node is in subgraph, else 0.
            @test sum(es_val[o] for o in edges[i]; init = 0) == 2 * ns_val[i]
        end
    end
    return
end

function setup_test(
    ::typeof(test_cpsat_Path),
    model::MOIU.MockOptimizer,
    ::Config{T},
) where {T}
    MOIU.set_mock_optimize!(
        model,
        (mock::MOIU.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, T[1, 4, 1, 1, 0, 1, 1, 0, 0, 1, 0]),
        ),
    )
    return
end

version_added(::typeof(test_cpsat_Path)) = v"1.4.0"

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

function _function(
    ::Any,
    ::Type{MOI.VariableIndex},
    x::Vector{MOI.VariableIndex},
)
    return x[1]
end

function _function(
    ::Any,
    ::Type{MOI.VectorOfVariables},
    x::Vector{MOI.VariableIndex},
)
    return MOI.VectorOfVariables(x)
end

function _function(
    ::Type{T},
    ::Type{MOI.ScalarAffineFunction},
    x::Vector{MOI.VariableIndex},
) where {T}
    return MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(one(T), x), zero(T))
end

function _function(
    ::Type{T},
    ::Type{MOI.ScalarQuadraticFunction},
    x::Vector{MOI.VariableIndex},
) where {T}
    return MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.(one(T), x, x),
        MOI.ScalarAffineTerm.(one(T), x),
        zero(T),
    )
end

function _function(
    ::Type{T},
    ::Type{MOI.VectorAffineFunction},
    x::Vector{MOI.VariableIndex},
) where {T}
    return MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(1:length(x), MOI.ScalarAffineTerm.(one(T), x)),
        zeros(T, length(x)),
    )
end

function _function(
    ::Type{T},
    ::Type{MOI.VectorQuadraticFunction},
    x::Vector{MOI.VariableIndex},
) where {T}
    return MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            1:length(x),
            MOI.ScalarQuadraticTerm.(one(T), x, x),
        ),
        MOI.VectorAffineTerm.(1:length(x), MOI.ScalarAffineTerm.(one(T), x)),
        zeros(T, length(x)),
    )
end

function _function(
    ::Type{T},
    ::Type{MOI.ScalarNonlinearFunction},
    x::Vector{MOI.VariableIndex},
) where {T}
    return MOI.ScalarNonlinearFunction(
        :+,
        Any[MOI.ScalarNonlinearFunction(:^, Any[xi, 2]) for xi in x],
    )
end

function _function(
    ::Type{T},
    ::Type{MOI.VectorNonlinearFunction},
    x::Vector{MOI.VariableIndex},
) where {T}
    f = _function(T, MOI.ScalarNonlinearFunction, x)
    # The length of the function should be equal to the length of `x`
    # so we drop `x[1]`
    return MOI.VectorNonlinearFunction([f; x[2:end]])
end

# Default fallback.
_set(::Any, ::Type{S}) where {S} = _set(S)

_set(::Type{T}, ::Type{MOI.LessThan}) where {T} = MOI.LessThan(one(T))
_set(::Type{T}, ::Type{MOI.GreaterThan}) where {T} = MOI.GreaterThan(one(T))
_set(::Type{T}, ::Type{MOI.EqualTo}) where {T} = MOI.EqualTo(one(T))
_set(::Type{T}, ::Type{MOI.Interval}) where {T} = MOI.Interval(zero(T), one(T))
_set(::Type{MOI.ZeroOne}) = MOI.ZeroOne()
_set(::Type{MOI.Integer}) = MOI.Integer()
function _set(::Type{T}, ::Type{MOI.Semicontinuous}) where {T}
    return MOI.Semicontinuous(zero(T), one(T))
end

function _set(::Type{T}, ::Type{MOI.Semiinteger}) where {T}
    return MOI.Semiinteger(zero(T), one(T))
end
_set(::Type{T}, ::Type{MOI.SOS1}) where {T} = MOI.SOS1(convert.(T, 1:2))
_set(::Type{T}, ::Type{MOI.SOS2}) where {T} = MOI.SOS2(convert.(T, 1:2))
_set(::Type{MOI.Zeros}) = MOI.Zeros(2)
_set(::Type{MOI.Nonpositives}) = MOI.Nonpositives(2)
_set(::Type{MOI.Nonnegatives}) = MOI.Nonnegatives(2)
_set(::Type{MOI.NormInfinityCone}) = MOI.NormInfinityCone(3)
_set(::Type{MOI.NormOneCone}) = MOI.NormOneCone(3)
_set(::Type{MOI.NormCone}) = MOI.NormCone(4.0, 3)
_set(::Type{MOI.SecondOrderCone}) = MOI.SecondOrderCone(3)
_set(::Type{MOI.RotatedSecondOrderCone}) = MOI.RotatedSecondOrderCone(3)
_set(::Type{MOI.GeometricMeanCone}) = MOI.GeometricMeanCone(3)
_set(::Type{MOI.ExponentialCone}) = MOI.ExponentialCone()
_set(::Type{MOI.DualExponentialCone}) = MOI.DualExponentialCone()
_set(::Type{MOI.PowerCone}) = MOI.PowerCone(0.5)
_set(::Type{MOI.DualPowerCone}) = MOI.DualPowerCone(0.5)
_set(::Type{MOI.RelativeEntropyCone}) = MOI.RelativeEntropyCone(3)
_set(::Type{MOI.NormSpectralCone}) = MOI.NormSpectralCone(2, 3)
_set(::Type{MOI.NormNuclearCone}) = MOI.NormNuclearCone(2, 3)
function _set(::Type{MOI.PositiveSemidefiniteConeTriangle})
    return MOI.PositiveSemidefiniteConeTriangle(3)
end

function _set(::Type{MOI.PositiveSemidefiniteConeSquare})
    return MOI.PositiveSemidefiniteConeSquare(3)
end

function _set(::Type{MOI.HermitianPositiveSemidefiniteConeTriangle})
    return MOI.HermitianPositiveSemidefiniteConeTriangle(3)
end

function _set(::Type{MOI.Scaled{MOI.PositiveSemidefiniteConeTriangle}})
    return MOI.Scaled{MOI.PositiveSemidefiniteConeTriangle}(3)
end
_set(::Type{MOI.LogDetConeTriangle}) = MOI.LogDetConeTriangle(3)
_set(::Type{MOI.LogDetConeSquare}) = MOI.LogDetConeSquare(3)
_set(::Type{MOI.RootDetConeTriangle}) = MOI.RootDetConeTriangle(3)
_set(::Type{MOI.RootDetConeSquare}) = MOI.RootDetConeSquare(3)
_set(::Type{MOI.Complements}) = MOI.Complements(2)
_set(::Type{MOI.AllDifferent}) = MOI.AllDifferent(3)
_set(::Type{MOI.CountDistinct}) = MOI.CountDistinct(4)
_set(::Type{MOI.CountBelongs}) = MOI.CountBelongs(4, Set([3, 4]))
_set(::Type{MOI.CountAtLeast}) = MOI.CountAtLeast(1, [2, 2], Set([3]))
_set(::Type{MOI.CountGreaterThan}) = MOI.CountGreaterThan(5)
_set(::Type{MOI.Circuit}) = MOI.Circuit(3)
_set(::Type{MOI.Cumulative}) = MOI.Cumulative(7)
_set(::Type{MOI.Path}) = MOI.Path([1, 1, 2, 2, 3], [2, 3, 3, 4, 4])

function _set(::Type{T}, ::Type{MOI.BinPacking}) where {T}
    return MOI.BinPacking(T(2), T[1, 2])
end

function _set(::Type{T}, ::Type{MOI.Table}) where {T}
    return MOI.Table(T[0 1 1; 1 0 1; 1 1 0])
end

function _set(
    ::Type{MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{T}}},
) where {T}
    return MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.LessThan(convert(T, 3)))
end

function _set(
    ::Type{MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.GreaterThan{T}}},
) where {T}
    return MOI.Indicator{MOI.ACTIVATE_ON_ONE}(MOI.GreaterThan(convert(T, 3)))
end

function _set(::Type{T}, ::Type{MOI.HyperRectangle}) where {T}
    return MOI.HyperRectangle(zeros(T, 3), ones(T, 3))
end

function _set(::Type{T}, ::Type{MOI.VectorNonlinearOracle}) where {T}
    set = MOI.VectorNonlinearOracle(;
        dimension = 4,
        l = T[0, 0],
        u = T[1, 0],
        eval_f = (ret, x) -> begin
            ret[1] = x[2]^2
            ret[2] = x[3]^2 + x[4]^3 - x[1]
            return
        end,
        jacobian_structure = [(1, 2), (2, 1), (2, 3), (2, 4)],
        eval_jacobian = (ret, x) -> begin
            ret[1] = T(2) * x[2]
            ret[2] = -T(1)
            ret[3] = T(2) * x[3]
            ret[4] = T(3) * x[4]^2
            return
        end,
    )
    @assert MOI.dimension(set) == 4
    x, ret_f, ret_J = T[1, 2, 3, 4], T[0, 0], T[0, 0, 0, 0]
    set.eval_f(ret_f, x)
    set.eval_jacobian(ret_J, x)
    return set
end

function _test_function_modification(
    model::MOI.ModelLike,
    config::Config{T},
    c::MOI.ConstraintIndex{F},
    f::F,
) where {T,F<:Union{MOI.ScalarAffineFunction{T},MOI.ScalarQuadraticFunction{T}}}
    MOI.Utilities.modify_function!(f, MOI.ScalarConstantChange(f.constant + 1))
    g = MOI.get(model, MOI.ConstraintFunction(), c)
    @test !≈(f.constant, g.constant, config)
    return
end

function _test_function_modification(
    model::MOI.ModelLike,
    config::Config{T},
    c::MOI.ConstraintIndex{F},
    f::F,
) where {T,F<:Union{MOI.VectorAffineFunction{T},MOI.VectorQuadraticFunction{T}}}
    new_constants = f.constants .+ one(T)
    MOI.Utilities.modify_function!(f, MOI.VectorConstantChange(new_constants))
    g = MOI.get(model, MOI.ConstraintFunction(), c)
    @test !≈(f.constants, g.constants, config)
    return
end

function _test_function_modification(
    ::MOI.ModelLike,
    ::Config{T},
    c::MOI.ConstraintIndex{F},
    ::F,
) where {T,F<:MOI.AbstractFunction}
    return
end

function _basic_constraint_test_helper(
    model::MOI.ModelLike,
    config::Config{T},
    ::Type{UntypedF},
    ::Type{UntypedS},
    add_variables_fn::Function = MOI.add_variables,
) where {T,UntypedF,UntypedS}
    set = _set(T, UntypedS)
    N = MOI.dimension(set)
    x = add_variables_fn(model, N)
    constraint_function = _function(T, UntypedF, x)
    @assert MOI.output_dimension(constraint_function) == N
    F, S = typeof(constraint_function), typeof(set)
    ###
    ### Test MOI.supports_constraint
    ###
    @requires MOI.supports_constraint(model, F, S)
    ###
    ### Test MOI.NumberOfConstraints
    ###
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 0
    c = MOI.add_constraint(model, constraint_function, set)
    @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 1
    _test_attribute_value_type(model, MOI.NumberOfConstraints{F,S}())
    ###
    ### Test MOI.ListOfConstraintIndices
    ###
    c_indices = MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
    @test c_indices == [c]
    ###
    ### Test MOI.ListOfConstraintTypesPresent
    ###
    @test (F, S) in MOI.get(model, MOI.ListOfConstraintTypesPresent())
    ###
    ### Test MOI.is_valid
    ###
    @test MOI.is_valid(model, c)
    # We could improve this test by checking these are `== true` instead of
    # `isa Bool`, but there is a bug in `LazyBridgeOptimizer`. See
    # MathOptInterface.jl#2696 for details. At the very least, this test checks
    # that they do not error, and hopefully helps hit some code paths.
    @test !MOI.is_valid(model, typeof(c)(c.value + 1)) isa Bool
    @test !MOI.is_valid(model, typeof(c)(c.value - 1)) isa Bool
    @test !MOI.is_valid(model, typeof(c)(c.value + 12345))
    ###
    ### Test MOI.ConstraintName
    ###
    if _supports(config, MOI.ConstraintName)
        if F == MOI.VariableIndex
            @test_throws(
                MOI.VariableIndexConstraintNameError(),
                MOI.supports(model, MOI.ConstraintName(), typeof(c)),
            )
            @test_throws(
                MOI.VariableIndexConstraintNameError(),
                MOI.set(model, MOI.ConstraintName(), c, "c"),
            )
        else
            @test MOI.get(model, MOI.ConstraintName(), c) == ""
            @test MOI.supports(model, MOI.ConstraintName(), typeof(c))
            MOI.set(model, MOI.ConstraintName(), c, "c")
            @test MOI.get(model, MOI.ConstraintName(), c) == "c"
            _test_attribute_value_type(model, MOI.ConstraintName(), c)
        end
    end
    ###
    ### Test MOI.ConstraintFunction
    ###
    function _isapprox_simplified(f, g, config)
        return isapprox(
            MOI.Nonlinear.SymbolicAD.simplify(f),
            MOI.Nonlinear.SymbolicAD.simplify(g),
            config,
        )
    end
    if _supports(config, MOI.ConstraintFunction)
        # Don't compare directly, because `f` might not be canonicalized.
        f = MOI.get(model, MOI.ConstraintFunction(), c)
        @test _isapprox_simplified(f, constraint_function, config)
        cf = MOI.get(model, MOI.CanonicalConstraintFunction(), c)
        @test _isapprox_simplified(cf, constraint_function, config)
        _test_attribute_value_type(model, MOI.ConstraintFunction(), c)
        _test_attribute_value_type(model, MOI.CanonicalConstraintFunction(), c)
        _test_function_modification(model, config, c, f)
    end
    ###
    ### Test MOI.ConstraintSet
    ###
    if _supports(config, MOI.ConstraintSet)
        @test MOI.get(model, MOI.ConstraintSet(), c) == set
        _test_attribute_value_type(model, MOI.ConstraintSet(), c)
    end
    ###
    ### Test MOI.add_constraints
    ###
    if F != MOI.VariableIndex && F != MOI.VectorOfVariables
        # We can't add multiple variable constraints as these are
        # interpreted as bounds etc.
        MOI.add_constraints(
            model,
            [constraint_function, constraint_function],
            [set, set],
        )
        @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) == 3
        @test length(MOI.get(model, MOI.ListOfConstraintIndices{F,S}())) == 3
        c_indices = MOI.get(model, MOI.ListOfConstraintIndices{F,S}())
        @test all(MOI.is_valid.(model, c_indices))
    end
    ###
    ### Test MOI.delete
    ###
    if _supports(config, MOI.delete)
        MOI.delete(model, c_indices[1])
        @test MOI.get(model, MOI.NumberOfConstraints{F,S}()) ==
              length(c_indices) - 1
        @test !MOI.is_valid(model, c_indices[1])
        @test_throws(
            MOI.InvalidIndex(c_indices[1]),
            MOI.delete(model, c_indices[1]),
        )
        if _supports(config, MOI.ConstraintFunction)
            @test_throws(
                MOI.InvalidIndex(c_indices[1]),
                MOI.get(model, MOI.ConstraintFunction(), c_indices[1]),
            )
        end
        if _supports(config, MOI.ConstraintSet)
            @test_throws(
                MOI.InvalidIndex(c_indices[1]),
                MOI.get(model, MOI.ConstraintSet(), c_indices[1]),
            )
        end
    end
    return
end

for s in [
    :GreaterThan,
    :LessThan,
    :EqualTo,
    :Interval,
    :Integer,
    :ZeroOne,
    :Semicontinuous,
    :Semiinteger,
    :SOS1,
    :SOS2,
    :Zeros,
    :Nonpositives,
    :Nonnegatives,
    :NormInfinityCone,
    :NormOneCone,
    :NormCone,
    :SecondOrderCone,
    :RotatedSecondOrderCone,
    :GeometricMeanCone,
    :ExponentialCone,
    :DualExponentialCone,
    :PowerCone,
    :DualPowerCone,
    :RelativeEntropyCone,
    :NormSpectralCone,
    :NormNuclearCone,
    :PositiveSemidefiniteConeSquare,
    :PositiveSemidefiniteConeTriangle,
    :HermitianPositiveSemidefiniteConeTriangle,
    :ScaledPositiveSemidefiniteConeTriangle,
    :LogDetConeTriangle,
    :LogDetConeSquare,
    :RootDetConeTriangle,
    :RootDetConeSquare,
    :Complements,
    :AllDifferent,
    :CountDistinct,
    :CountBelongs,
    :CountAtLeast,
    :CountGreaterThan,
    :BinPacking,
    :Circuit,
    :Cumulative,
    :Table,
    :Path,
    :HyperRectangle,
    :VectorNonlinearOracle,
]
    S = getfield(MOI, s)
    functions = if S <: MOI.AbstractScalarSet
        (
            :VariableIndex,
            :ScalarAffineFunction,
            :ScalarQuadraticFunction,
            :ScalarNonlinearFunction,
        )
    else
        (
            :VectorOfVariables,
            :VectorAffineFunction,
            :VectorQuadraticFunction,
            :VectorNonlinearFunction,
        )
    end
    for f in functions
        func = Symbol("test_basic_$(f)_$(s)")
        F = getfield(MOI, f)
        @eval begin
            function $(func)(model::MOI.ModelLike, config::Config)
                _basic_constraint_test_helper(model, config, $F, $S)
                return
            end
        end
    end
end

function test_basic_VectorAffineFunction_Indicator_LessThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    function add_variables_fn(model, N)
        x = MOI.add_variables(model, N)
        MOI.add_constraint(model, x[1], MOI.ZeroOne())
        return x
    end
    _basic_constraint_test_helper(
        model,
        config,
        MOI.VectorAffineFunction,
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{T}},
        add_variables_fn,
    )
    return
end

function test_basic_VectorAffineFunction_Indicator_GreaterThan(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    function add_variables_fn(model, N)
        x = MOI.add_variables(model, N)
        MOI.add_constraint(model, x[1], MOI.ZeroOne())
        return x
    end
    _basic_constraint_test_helper(
        model,
        config,
        MOI.VectorAffineFunction,
        MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.GreaterThan{T}},
        add_variables_fn,
    )
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    FlipSignBridge{T,S1,S2,F,G}

An abstract type that simplifies the creation of other bridges.
"""
abstract type FlipSignBridge{
    T,
    S1<:MOI.AbstractSet,
    S2<:MOI.AbstractSet,
    F<:MOI.AbstractFunction,
    G<:MOI.AbstractFunction,
} <: SetMapBridge{T,S2,S1,F,G} end

function MOI.Bridges.map_function(::Type{<:FlipSignBridge{T}}, func) where {T}
    return MOI.Utilities.operate(-, T, func)
end

# The map is an involution
function MOI.Bridges.inverse_map_function(BT::Type{<:FlipSignBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is symmetric
function MOI.Bridges.adjoint_map_function(BT::Type{<:FlipSignBridge}, func)
    return MOI.Bridges.map_function(BT, func)
end

# The map is a symmetric involution
function MOI.Bridges.inverse_adjoint_map_function(
    BT::Type{<:FlipSignBridge},
    func,
)
    return MOI.Bridges.map_function(BT, func)
end

function MOI.delete(
    model::MOI.ModelLike,
    bridge::FlipSignBridge,
    i::MOI.Bridges.IndexInVector,
)
    func = MOI.get(model, MOI.ConstraintFunction(), bridge.constraint)
    idx = setdiff(1:MOI.output_dimension(func), i.value)
    new_func = MOI.Utilities.eachscalar(func)[idx]
    set = MOI.get(model, MOI.ConstraintSet(), bridge.constraint)
    new_set = MOI.update_dimension(set, MOI.dimension(set) - 1)
    MOI.delete(model, bridge.constraint)
    bridge.constraint = MOI.add_constraint(model, new_func, new_set)
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::FlipSignBridge,
    change::MOI.ScalarCoefficientChange,
)
    MOI.modify(
        model,
        bridge.constraint,
        MOI.ScalarCoefficientChange(change.variable, -change.new_coefficient),
    )
    return
end

function MOI.modify(
    model::MOI.ModelLike,
    bridge::FlipSignBridge,
    change::MOI.MultirowChange{T},
) where {T}
    new_coefficients = Tuple{Int64,T}[
        (index, -coef) for (index, coef) in change.new_coefficients
    ]
    MOI.modify(
        model,
        bridge.constraint,
        MOI.MultirowChange(change.variable, new_coefficients),
    )
    return
end

"""
    GreaterToLessBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`GreaterToLessBridge` implements the following reformulation:

  * ``f(x) \\ge l`` into ``-f(x) \\le -l``

## Source node

`GreaterToLessBridge` supports:

  * `G` in [`MOI.GreaterThan{T}`](@ref)

## Target nodes

`GreaterToLessBridge` creates:

  * `F` in [`MOI.LessThan{T}`](@ref)
"""
struct GreaterToLessBridge{
    T,
    F<:MOI.AbstractScalarFunction,
    G<:MOI.AbstractScalarFunction,
} <: FlipSignBridge{T,MOI.GreaterThan{T},MOI.LessThan{T},F,G}
    constraint::MOI.ConstraintIndex{F,MOI.LessThan{T}}
end

const GreaterToLess{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{GreaterToLessBridge{T},OT}

function MOI.Bridges.map_set(
    ::Type{<:GreaterToLessBridge},
    set::MOI.GreaterThan,
)
    return MOI.LessThan(-set.lower)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:GreaterToLessBridge},
    set::MOI.LessThan,
)
    return MOI.GreaterThan(-set.upper)
end

function concrete_bridge_type(
    ::Type{<:GreaterToLessBridge{T}},
    G::Type{<:MOI.AbstractScalarFunction},
    ::Type{MOI.GreaterThan{T}},
) where {T}
    F = MOI.Utilities.promote_operation(-, T, G)
    return GreaterToLessBridge{T,F,G}
end

"""
    LessToGreaterBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`LessToGreaterBridge` implements the following reformulation:

* ``f(x) \\le u`` into ``-f(x) \\ge -u``

## Source node

`LessToGreaterBridge` supports:

* `G` in [`MOI.LessThan{T}`](@ref)

## Target nodes

`LessToGreaterBridge` creates:

* `F` in [`MOI.GreaterThan{T}`](@ref)
"""
struct LessToGreaterBridge{
    T,
    F<:MOI.AbstractScalarFunction,
    G<:MOI.AbstractScalarFunction,
} <: FlipSignBridge{T,MOI.LessThan{T},MOI.GreaterThan{T},F,G}
    constraint::MOI.ConstraintIndex{F,MOI.GreaterThan{T}}
end

const LessToGreater{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{LessToGreaterBridge{T},OT}

function MOI.Bridges.map_set(::Type{<:LessToGreaterBridge}, set::MOI.LessThan)
    return MOI.GreaterThan(-set.upper)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:LessToGreaterBridge},
    set::MOI.GreaterThan,
)
    return MOI.LessThan(-set.lower)
end

function concrete_bridge_type(
    ::Type{<:LessToGreaterBridge{T}},
    G::Type{<:MOI.AbstractScalarFunction},
    ::Type{MOI.LessThan{T}},
) where {T}
    F = MOI.Utilities.promote_operation(-, T, G)
    return LessToGreaterBridge{T,F,G}
end

"""
    NonnegToNonposBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`NonnegToNonposBridge` implements the following reformulation:

  * ``f(x) \\in \\mathbb{R}_+`` into ``-f(x) \\in \\mathbb{R}_-``

## Source node

`NonnegToNonposBridge` supports:

  * `G` in [`MOI.Nonnegatives`](@ref)

## Target nodes

`NonnegToNonposBridge` creates:

  * `F` in [`MOI.Nonpositives`](@ref)
"""
mutable struct NonnegToNonposBridge{
    T,
    F<:MOI.AbstractVectorFunction,
    G<:MOI.AbstractVectorFunction,
} <: FlipSignBridge{T,MOI.Nonnegatives,MOI.Nonpositives,F,G}
    constraint::MOI.ConstraintIndex{F,MOI.Nonpositives}
end

const NonnegToNonpos{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NonnegToNonposBridge{T},OT}

function MOI.Bridges.map_set(
    ::Type{<:NonnegToNonposBridge},
    set::MOI.Nonnegatives,
)
    return MOI.Nonpositives(set.dimension)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:NonnegToNonposBridge},
    set::MOI.Nonpositives,
)
    return MOI.Nonnegatives(set.dimension)
end

function concrete_bridge_type(
    ::Type{<:NonnegToNonposBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.Nonnegatives},
) where {T}
    F = MOI.Utilities.promote_operation(-, T, G)
    return NonnegToNonposBridge{T,F,G}
end

"""
    NonposToNonnegBridge{T,F,G} <: Bridges.Constraint.AbstractBridge

`NonposToNonnegBridge` implements the following reformulation:

  * ``f(x) \\in \\mathbb{R}_-`` into ``-f(x) \\in \\mathbb{R}_+``

## Source node

`NonposToNonnegBridge` supports:

  * `G` in [`MOI.Nonpositives`](@ref)

## Target nodes

`NonposToNonnegBridge` creates:

  * `F` in [`MOI.Nonnegatives`](@ref)
"""
mutable struct NonposToNonnegBridge{
    T,
    F<:MOI.AbstractVectorFunction,
    G<:MOI.AbstractVectorFunction,
} <: FlipSignBridge{T,MOI.Nonpositives,MOI.Nonnegatives,F,G}
    constraint::MOI.ConstraintIndex{F,MOI.Nonnegatives}
end

const NonposToNonneg{T,OT<:MOI.ModelLike} =
    SingleBridgeOptimizer{NonposToNonnegBridge{T},OT}

function MOI.Bridges.map_set(
    ::Type{<:NonposToNonnegBridge},
    set::MOI.Nonpositives,
)
    return MOI.Nonnegatives(set.dimension)
end

function MOI.Bridges.inverse_map_set(
    ::Type{<:NonposToNonnegBridge},
    set::MOI.Nonnegatives,
)
    return MOI.Nonpositives(set.dimension)
end

function concrete_bridge_type(
    ::Type{<:NonposToNonnegBridge{T}},
    G::Type{<:MOI.AbstractVectorFunction},
    ::Type{MOI.Nonpositives},
) where {T}
    F = MOI.Utilities.promote_operation(-, T, G)
    return NonposToNonnegBridge{T,F,G}
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

using Test

import MathOptInterface as MOI

@test isempty(Test.detect_ambiguities(MOI; recursive = true))

for file in readdir(@__DIR__)
    if file in ["issue980.jl", "dummy.jl", "hygiene.jl", "runtests.jl"]
        continue
    elseif !endswith(file, ".jl")
        continue
    end
    @testset "$(file)" begin
        include(file)
    end
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

## Storage of constraints
#
# All `F`-in-`S` constraints are stored in a vector of `ConstraintEntry{F, S}`.
# The index in this vector of a constraint of index
# `ci::MOI.ConstraintIndex{F, S}` is given by `model.constrmap[ci.value]`. The
# advantage of this representation is that it does not require any dictionary
# hence it never needs to compute a hash.
#
# It may seem redundant to store the constraint index `ci` as well as the
# function and sets in the tuple but it is used to efficiently implement the
# getter for `MOI.ListOfConstraintIndices{F, S}`. It is also used to implement
# `MOI.delete`. Indeed, when a constraint is deleted, it is removed from the
# vector hence the index in the vector of all the functions that were stored
# after must be decreased by one. As the constraint index is stored in the
# vector, it readily gives the entries of `model.constrmap` that need to be
# updated.

"""
    mutable struct VectorOfConstraints{
        F<:MOI.AbstractFunction,
        S<:MOI.AbstractSet,
    } <: MOI.ModelLike
        constraints::CleverDicts.CleverDict{
            MOI.ConstraintIndex{F,S},
            Tuple{F,S},
            typeof(CleverDicts.key_to_index),
            typeof(CleverDicts.index_to_key),
        }
    end

A struct storing `F`-in-`S` constraints as a mapping between the constraint
indices to the corresponding tuple of function and set.
"""
mutable struct VectorOfConstraints{
    F<:MOI.AbstractFunction,
    S<:MOI.AbstractSet,
} <: MOI.ModelLike
    constraints::CleverDicts.CleverDict{
        MOI.ConstraintIndex{F,S},
        Tuple{F,S},
        typeof(CleverDicts.key_to_index),
        typeof(CleverDicts.index_to_key),
    }

    function VectorOfConstraints{F,S}() where {F,S}
        return new{F,S}(
            CleverDicts.CleverDict{MOI.ConstraintIndex{F,S},Tuple{F,S}}(),
        )
    end
end

MOI.is_empty(v::VectorOfConstraints) = isempty(v.constraints)
MOI.empty!(v::VectorOfConstraints) = empty!(v.constraints)

function MOI.supports_constraint(
    ::VectorOfConstraints{F,S},
    ::Type{F},
    ::Type{S},
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    return true
end

function MOI.add_constraint(
    v::VectorOfConstraints{F,S},
    func::F,
    set::S,
) where {F<:MOI.AbstractFunction,S<:MOI.AbstractSet}
    # We canonicalize the constraint so that solvers can avoid having to
    # canonicalize it most of the time (they can check if they need to with
    # `is_canonical`.
    # Note that the canonicalization is not guaranteed if for instance
    # `modify` is called and adds a new term.
    # See https://github.com/jump-dev/MathOptInterface.jl/pull/1118
    return CleverDicts.add_item(v.constraints, (canonical(func), copy(set)))
end

function MOI.is_valid(
    v::VectorOfConstraints{F,S},
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    return haskey(v.constraints, ci)
end

function MOI.delete(
    v::VectorOfConstraints{F,S},
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    MOI.throw_if_not_valid(v, ci)
    delete!(v.constraints, ci)
    return
end

function MOI.get(
    v::VectorOfConstraints{F,S},
    ::MOI.ConstraintFunction,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    MOI.throw_if_not_valid(v, ci)
    f, _ = v.constraints[ci]::Tuple{F,S}
    return copy(f)
end

function MOI.get(
    v::VectorOfConstraints{F,S},
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{F,S},
) where {F,S}
    MOI.throw_if_not_valid(v, ci)
    _, s = v.constraints[ci]::Tuple{F,S}
    return s
end

function MOI.set(
    v::VectorOfConstraints{F,S},
    ::MOI.ConstraintFunction,
    ci::MOI.ConstraintIndex{F,S},
    func::F,
) where {F,S}
    MOI.throw_if_not_valid(v, ci)
    _, s = v.constraints[ci]::Tuple{F,S}
    v.constraints[ci] = (func, s)
    return
end

function MOI.set(
    v::VectorOfConstraints{F,S},
    ::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{F,S},
    set::S,
) where {F,S}
    MOI.throw_if_not_valid(v, ci)
    f, _ = v.constraints[ci]::Tuple{F,S}
    v.constraints[ci] = (f, set)
    return
end

function MOI.get(
    v::VectorOfConstraints{F,S},
    ::MOI.ListOfConstraintTypesPresent,
)::Vector{Tuple{Type,Type}} where {F,S}
    return isempty(v.constraints) ? [] : [(F, S)]
end

function MOI.get(
    v::VectorOfConstraints{F,S},
    ::MOI.NumberOfConstraints{F,S},
)::Int64 where {F,S}
    return length(v.constraints)
end

function MOI.get(
    v::VectorOfConstraints{F,S},
    ::MOI.ListOfConstraintIndices{F,S},
) where {F,S}
    return collect(keys(v.constraints))
end

function MOI.get(
    ::VectorOfConstraints{F,S},
    ::MOI.ListOfConstraintAttributesSet{F,S},
) where {F,S}
    return MOI.AbstractConstraintAttribute[]
end

function MOI.modify(
    v::VectorOfConstraints{F,S},
    ci::MOI.ConstraintIndex{F,S},
    change::MOI.AbstractFunctionModification,
) where {F,S}
    func, set = v.constraints[ci]::Tuple{F,S}
    v.constraints[ci] = (modify_function!(func, change), set)
    return
end

function _add_variable(::VectorOfConstraints) end

function _add_variables(::VectorOfConstraints, ::Int64) end

# Deletion of variables in vector of variables

"""
    remove_variable(
        f::MOI.AbstractFunction,
        s::MOI.AbstractSet,
        vi::MOI.VariableIndex,
    )

Return a tuple `(g, t)` representing the constraint `f`-in-`s` with the
variable `vi` removed. That is, the terms containing the variable `vi` in the
function `f` are removed and the dimension of the set `s` is updated if
needed (for example, when `f` is a `VectorOfVariables` with `vi` being one of the
variables).
"""
remove_variable(f, s, vi::MOI.VariableIndex) = remove_variable(f, vi), s

function remove_variable(f::MOI.VectorOfVariables, s, vi::MOI.VariableIndex)
    g = remove_variable(f, vi)
    if length(g.variables) != length(f.variables)
        return g, MOI.update_dimension(s, length(g.variables))
    end
    return g, s
end

function _remove_variable(v::VectorOfConstraints, vi::MOI.VariableIndex)
    CleverDicts.map_values!(v.constraints) do (f, s)
        return remove_variable(f, s, vi)
    end
    return
end

function filter_variables(keep::F, f, s) where {F<:Function}
    return filter_variables(keep, f), s
end

function filter_variables(
    keep::F,
    f::MOI.VectorOfVariables,
    s,
) where {F<:Function}
    g = filter_variables(keep, f)
    if length(g.variables) != length(f.variables)
        return g, MOI.update_dimension(s, length(g.variables))
    end
    return g, s
end

function _filter_variables(keep::Function, v::VectorOfConstraints)
    CleverDicts.map_values!(v.constraints) do (f, s)
        return filter_variables(keep, f, s)
    end
    return
end

function throw_delete_variable_in_vov(vi::MOI.VariableIndex)
    message = string(
        "Cannot delete variable as it is constrained with other",
        " variables in a `MOI.VectorOfVariables`.",
    )
    return throw(MOI.DeleteNotAllowed(vi, message))
end

# Nothing to do as it's not `VectorOfVariables` constraints
_throw_if_cannot_delete(::VectorOfConstraints, vis, fast_in_vis) = nothing

_fast_in(vi1::MOI.VariableIndex, vi2::MOI.VariableIndex) = vi1 == vi2
_fast_in(vi::MOI.VariableIndex, vis::Set{MOI.VariableIndex}) = vi in vis

function _throw_if_cannot_delete(
    v::VectorOfConstraints{MOI.VectorOfVariables,S},
    vis,
    fast_in_vis,
) where {S<:MOI.AbstractVectorSet}
    if MOI.supports_dimension_update(S) || MOI.is_empty(v)
        return
    end
    for fs in values(v.constraints)
        f = fs[1]::MOI.VectorOfVariables
        if length(f.variables) > 1 && f.variables != vis
            for vi in f.variables
                if _fast_in(vi, fast_in_vis)
                    # If `supports_dimension_update(S)` then the variable
                    # will be removed in `_filter_variables`.
                    throw_delete_variable_in_vov(vi)
                end
            end
        end
    end
    return
end

function _delete_variables(
    ::Function,
    ::VectorOfConstraints,
    ::Vector{MOI.VariableIndex},
)
    return  # Nothing to do as it's not `VectorOfVariables` constraints
end

function _delete_variables(
    callback::Function,
    v::VectorOfConstraints{MOI.VectorOfVariables,<:MOI.AbstractVectorSet},
    vis::Vector{MOI.VariableIndex},
)
    filter!(v.constraints) do p
        f = p.second[1]
        del = if length(f.variables) == 1
            first(f.variables) in vis
        else
            vis == f.variables
        end
        if del
            callback(p.first)
        end
        return !del
    end
    return
end

function _deleted_constraints(
    callback::Function,
    v::VectorOfConstraints,
    vi::MOI.VariableIndex,
)
    _delete_variables(callback, v, [vi])
    _remove_variable(v, vi)
    return
end

function _deleted_constraints(
    callback::Function,
    v::VectorOfConstraints,
    vis::Vector{MOI.VariableIndex},
)
    _delete_variables(callback, v, vis)
    removed = Set(vis)
    _filter_variables(vi -> !(vi in removed), v)
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module ReverseAD

import ForwardDiff
import MathOptInterface as MOI
import ..Nonlinear
import SparseArrays

# Override basic math functions to return NaN instead of throwing errors.
# This is what NLP solvers expect, and sometimes the results aren't needed
# anyway, because the code may compute derivatives wrt constants.
import NaNMath:
    sin,
    cos,
    tan,
    asin,
    acos,
    acosh,
    atanh,
    log,
    log2,
    log10,
    lgamma,
    log1p,
    pow,
    sqrt

include("Coloring/Coloring.jl")
include("graph_tools.jl")
include("types.jl")
include("utils.jl")

include("reverse_mode.jl")
include("forward_over_reverse.jl")
include("mathoptinterface_api.jl")

end  # module

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestFunctions

using Test
import MathOptInterface as MOI

"""
    test_isbits()

Test isbit-ness of VariableIndex and terms.

It is important that these struct remain isbits as otherwise, the performance of
the corresponding function will be deteriored. These tests explicit this design
choice and makes sure that it remains the case.
"""
function test_isbits()
    x = @inferred MOI.VariableIndex(1)
    @test isbits(x)
    at = @inferred MOI.ScalarAffineTerm(1.0, x)
    @test isbits(at)
    @test isbits(@inferred MOI.VectorAffineTerm(1, at))
    qt = @inferred MOI.ScalarQuadraticTerm(1.0, x, x)
    @test isbits(qt)
    @test isbits(@inferred MOI.VectorQuadraticTerm(1, qt))
end

function test_functions_broadcast()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    function sum_indices(sv1::MOI.VariableIndex, sv2::MOI.VariableIndex)
        return sv1.value + sv2.value
    end
    @test sum_indices.(x, [y, z]) == [3, 4]
end

function test_functions_copy_VectorOfVariables()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    f = MOI.VectorOfVariables([x, y])
    f_copy = copy(f)
    f_copy.variables[2] = z
    @test f.variables[2] == y
end

function test_functions_convert_to_variable_index()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    for f in (
        1.0 * x,
        1.0 * x + 0.0,
        1.0 * x + 0.0 * y + 0.0,
        0.0 * y + 1.0 * x + 0.0,
    )
        @test convert(MOI.VariableIndex, f) === x
    end
    for f in (
        1.0 * x + 0.5,
        0.5 * x + 0.0,
        1.0 * x + 1.0 * y + 0.0,
        MOI.ScalarAffineFunction(MOI.ScalarAffineTerm{Float64}[], 0.0),
    )
        @test_throws InexactError convert(MOI.VariableIndex, f)
    end
    return
end

function test_functions_convert_VariableIndex()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f_vov = convert(MOI.VectorOfVariables, x)
    @test f_vov ≈ MOI.VectorOfVariables([x])
    f_vaf = convert(MOI.VectorAffineFunction{Float64}, x)
    @test f_vaf ≈ MOI.VectorAffineFunction(
        [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x))],
        [0.0],
    )
    f_vqf = convert(MOI.VectorQuadraticFunction{Float64}, x)
    @test f_vqf ≈ MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm{Float64}[],
        [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x))],
        [0.0],
    )
end

function test_functions_convert_ScalarAffineFunction()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(2.0, x)], 1.0)
    @test_throws(MethodError, convert(MOI.VectorOfVariables, f))
    f_vaf = convert(MOI.VectorAffineFunction{Float64}, f)
    @test f_vaf ≈ MOI.VectorAffineFunction(
        [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2.0, x))],
        [1.0],
    )
    f_vqf = convert(MOI.VectorQuadraticFunction{Float64}, f)
    @test f_vqf ≈ MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm{Float64}[],
        [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2.0, x))],
        [1.0],
    )
end

function test_functions_convert_ScalarQuadraticFunction()
    model = MOI.Utilities.Model{Float64}()
    x = MOI.add_variable(model)
    f = MOI.ScalarQuadraticFunction(
        [MOI.ScalarQuadraticTerm(3.0, x, x)],
        [MOI.ScalarAffineTerm(2.0, x)],
        1.0,
    )
    @test_throws(MethodError, convert(MOI.VectorOfVariables, f))
    @test_throws(MethodError, convert(MOI.VectorAffineFunction{Float64}, f))
    f_vqf = convert(MOI.VectorQuadraticFunction{Float64}, f)
    @test f_vqf ≈ MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm{Float64}[MOI.VectorQuadraticTerm(
            1,
            MOI.ScalarQuadraticTerm(3.0, x, x),
        )],
        [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(2.0, x))],
        [1.0],
    )
end

function test_isapprox_VectorOfVariables()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    @test MOI.VectorOfVariables([x, y]) == MOI.VectorOfVariables([x, y])
    @test MOI.VectorOfVariables([y, x]) != MOI.VectorOfVariables([x, y])
    @test MOI.VectorOfVariables([x, x]) != MOI.VectorOfVariables([x])
    @test MOI.VectorOfVariables([x]) != MOI.VectorOfVariables([y])
    return
end

function test_isapprox_ScalarAffineFunction()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    @test MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([1, 1], [x, z]), 1) ≈
          MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.([1.0, 1e-7, 1.0], [x, y, z]),
        1.0,
    ) atol = 1e-6
    @test MOI.ScalarAffineFunction(
        MOI.ScalarAffineTerm.([1.0, 1e-7], [x, y]),
        1.0,
    ) ≈ MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1, x)], 1) atol = 1e-6
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.([2, 4], [x, y]), 6)
    g = deepcopy(f)
    @test g ≈ f
    @test f ≈ g
    f.terms[2] = MOI.ScalarAffineTerm(3, y)
    @test !(g ≈ f)
    @test !(f ≈ g)
    return
end

function test_isapprox_VectorAffineFunction()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f = MOI.VectorAffineFunction(
        MOI.VectorAffineTerm.(
            [1, 1, 2],
            MOI.ScalarAffineTerm.([2, 4, 3], [x, y, y]),
        ),
        [6, 8],
    )
    g = deepcopy(f)
    @test f ≈ g
    f.terms[3] = MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(9, y))
    @test !(f ≈ g)
    @test !(g ≈ f)
    push!(f.terms, MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(-6, y)))
    @test f ≈ g
    @test g ≈ f
    return
end

function test_isapprox_ScalarQuadraticFunction()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    f = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm.([1, 2, 3], [x, y, x], [x, y, y]),
        [MOI.ScalarAffineTerm(3, x)],
        8,
    )
    g = deepcopy(f)
    @test f ≈ g
    push!(f.affine_terms, MOI.ScalarAffineTerm(2, y))
    @test !(f ≈ g)
    g = deepcopy(f)
    push!(f.quadratic_terms, MOI.ScalarQuadraticTerm(2, y, x))
    @test !(f ≈ g)
    @test !(g ≈ f)
    push!(f.quadratic_terms, MOI.ScalarQuadraticTerm(-2, y, x))
    @test f ≈ g
    @test g ≈ f
    return
end

function test_isapprox_VectorQuadraticFunction()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    z = MOI.VariableIndex(3)
    f = MOI.VectorQuadraticFunction(
        MOI.VectorQuadraticTerm.(
            [1, 1, 2],
            MOI.ScalarQuadraticTerm.([1, 2, 3], [x, y, x], [x, y, y]),
        ),
        MOI.VectorAffineTerm.(
            [1, 2, 1],
            MOI.ScalarAffineTerm.([3, 1, 1], [x, x, y]),
        ),
        [10, 11, 12],
    )
    g = deepcopy(f)
    @test f ≈ g
    @test g ≈ f
    f.affine_terms[1] = MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(4, x))
    @test !(f ≈ g)
    @test !(g ≈ f)
    push!(g.affine_terms, MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(-3, x)))
    push!(g.affine_terms, MOI.VectorAffineTerm(3, MOI.ScalarAffineTerm(4, x)))
    @test f ≈ g
    @test g ≈ f
    f.quadratic_terms[1] =
        MOI.VectorQuadraticTerm(3, MOI.ScalarQuadraticTerm(1, x, x))
    @test !(f ≈ g)
    @test !(g ≈ f)
    return
end

function test_isapprox_issue_1483()
    x = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm{Float16}[],
        MOI.ScalarAffineTerm{Float16}[],
        Float16(0.0),
    )
    y = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm{Float16}[],
        MOI.ScalarAffineTerm{Float16}[MOI.ScalarAffineTerm(
            Float16(1.0),
            MOI.VariableIndex(1234),
        )],
        Float16(0.0),
    )
    z = MOI.ScalarQuadraticFunction(
        MOI.ScalarQuadraticTerm{Float16}[],
        MOI.ScalarAffineTerm{Float16}[],
        Float16(0.0),
    )
    @test !(x ≈ y)
    @test !(y ≈ x)
    @test x ≈ z
    @test z ≈ x
    @test !(y ≈ z)
    @test !(z ≈ y)
    return
end

function test_convert_vectorofvariables()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f = MOI.VectorOfVariables([x, y])
    g = MOI.Utilities.operate(vcat, Float64, 1.0 * x, 1.0 * y)
    @test convert(MOI.VectorOfVariables, g) == f
    for g in (
        MOI.Utilities.operate(vcat, Float64, 1.2 * x, 1.0 * y),
        MOI.Utilities.operate(vcat, Float64, 1.0 * y, 1.2 * x),
        MOI.Utilities.operate(vcat, Float64, 1.0 * x, 0.0),
        MOI.Utilities.operate(vcat, Float64, 0.0, 1.0 * x),
        MOI.Utilities.operate(vcat, Float64, 1.0 * x, 1.0 * y + 1.0),
        MOI.Utilities.operate(vcat, Float64, 1.0 * x + 1.0, 1.0 * y),
    )
        @test_throws InexactError convert(MOI.VectorOfVariables, g)
    end
    return
end

function test_ScalarNonlinearFunction_constant()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    @test MOI.constant(f, Float64) === Float64(0)
    @test MOI.constant(f, Int32) === Int32(0)
    return
end

function test_ScalarNonlinearFunction_isapprox()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    g = MOI.ScalarNonlinearFunction(:+, Any[f, 0.0])
    h = MOI.ScalarNonlinearFunction(:+, Any[f, 1.0])
    @test f ≈ f
    @test !(f ≈ g)
    @test !(g ≈ h)
    return
end

function test_convert_ScalarNonlinearFunction_ScalarAffineTerm()
    x = MOI.VariableIndex(1)
    f = MOI.ScalarAffineTerm(1.0, x)
    g = MOI.ScalarNonlinearFunction(:*, Any[1.0, x])
    h = MOI.ScalarNonlinearFunction(:*, Any[x, 1.0])
    @test convert(MOI.ScalarNonlinearFunction, f) ≈ g
    @test convert(MOI.ScalarAffineTerm{Float64}, g) == f
    @test convert(MOI.ScalarAffineTerm{Float64}, h) == f
    f = MOI.ScalarAffineTerm(1, x)
    g = MOI.ScalarNonlinearFunction(:*, Any[1, x])
    h = MOI.ScalarNonlinearFunction(:*, Any[x, 1])
    @test convert(MOI.ScalarNonlinearFunction, f) ≈ g
    @test convert(MOI.ScalarAffineTerm{Int}, h) == f
    for f_error in (
        MOI.ScalarNonlinearFunction(:*, Any[1.0, x, 2.0]),
        MOI.ScalarNonlinearFunction(:+, Any[1.0, x]),
        MOI.ScalarNonlinearFunction(:*, Any[x, x]),
    )
        @test_throws(
            InexactError,
            convert(MOI.ScalarAffineTerm{Float64}, f_error),
        )
    end
    return
end

function test_convert_ScalarNonlinearFunction_ScalarAffineFunction()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    for f in (
        1.0 * x,
        1.0 * x + 2.0,
        1.0 * x + 1.0 * x + 2.0,
        1.0 * x + 2.0 * y + 2.0,
        2.0 * y + 2.0 + 2.0 * x,
    )
        g = convert(MOI.ScalarNonlinearFunction, f)
        @test convert(MOI.ScalarAffineFunction{Float64}, g) ≈ f
    end
    f_add = MOI.ScalarNonlinearFunction(:+, Any[1.0, x])
    for (f, g) in (
        MOI.ScalarNonlinearFunction(:*, Any[1.0, x]) => 1.0 * x,
        MOI.ScalarNonlinearFunction(:+, Any[1.0, x]) => 1.0 + x,
        MOI.ScalarNonlinearFunction(:+, Any[f_add, f_add]) => 2.0 + 2.0 * x,
    )
        @test convert(MOI.ScalarAffineFunction{Float64}, f) ≈ g
    end
    for f_error in (
        MOI.ScalarNonlinearFunction(:/, Any[1.0, x]),
        MOI.ScalarNonlinearFunction(:+, Any[1.0, 1.0*x*x]),
    )
        @test_throws(
            InexactError,
            convert(MOI.ScalarAffineFunction{Float64}, f_error),
        )
    end
    return
end

function test_convert_ScalarNonlinearFunction_zero()
    affine_terms = MOI.ScalarAffineTerm{Float64}[]
    quad_terms = MOI.ScalarQuadraticTerm{Float64}[]
    for f in (
        MOI.ScalarAffineFunction(affine_terms, 0.0),
        MOI.ScalarQuadraticFunction(quad_terms, affine_terms, 0.0),
    )
        g = convert(MOI.ScalarNonlinearFunction, f)
        @test g.head == :+
        @test g.args == Any[0.0]
    end
    return
end

function test_convert_ScalarNonlinearFunction_ScalarQuadraticTerm()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    f = MOI.ScalarQuadraticTerm(1, x, y)
    g = MOI.ScalarNonlinearFunction(:*, Any[1, x, y])
    h = MOI.ScalarNonlinearFunction(:*, Any[x, 1, y])
    i = MOI.ScalarNonlinearFunction(:*, Any[x, y, 1])
    @test convert(MOI.ScalarNonlinearFunction, f) ≈ g
    @test convert(MOI.ScalarQuadraticTerm{Int}, g) == f
    @test convert(MOI.ScalarQuadraticTerm{Int}, h) == f
    @test convert(MOI.ScalarQuadraticTerm{Int}, i) == f
    f = MOI.ScalarQuadraticTerm(2.0, x, x)
    g = MOI.ScalarNonlinearFunction(:*, Any[1.0, x, x])
    h = MOI.ScalarNonlinearFunction(:*, Any[x, 1.0, x])
    i = MOI.ScalarNonlinearFunction(:*, Any[x, x, 1.0])
    @test convert(MOI.ScalarNonlinearFunction, f) ≈ g
    @test convert(MOI.ScalarQuadraticTerm{Float64}, g) == f
    @test convert(MOI.ScalarQuadraticTerm{Float64}, h) == f
    @test convert(MOI.ScalarQuadraticTerm{Float64}, i) == f
    for f_error in (
        MOI.ScalarNonlinearFunction(:*, Any[1.0, x, 2.0]),
        MOI.ScalarNonlinearFunction(:+, Any[1.0, x, x]),
        MOI.ScalarNonlinearFunction(:*, Any[x, x]),
    )
        @test_throws(
            InexactError,
            convert(MOI.ScalarQuadraticTerm{Float64}, f_error),
        )
    end
    return
end

function test_convert_ScalarNonlinearFunction_ScalarQuadraticFunction()
    x = MOI.VariableIndex(1)
    y = MOI.VariableIndex(2)
    for f in (
        1.0 * x * x,
        1.0 * x * x + 2.0,
        1.0 * x * x + 1.0 * x * y + 2.0,
        1.0 * x + 2.0 * y * y + 2.0,
        2.0 * y + 2.0 + 2.0 * x * x,
    )
        g = convert(MOI.ScalarNonlinearFunction, f)
        @test convert(MOI.ScalarQuadraticFunction{Float64}, g) ≈ f
    end
    f_add = MOI.ScalarNonlinearFunction(:+, Any[1.0, x])
    for (f, g) in (
        MOI.ScalarNonlinearFunction(:*, Any[1.0, x]) => 0.0 * x * x + 1.0 * x,
        MOI.ScalarNonlinearFunction(:*, Any[x, 1.0, x]) => 1.0 * x * x,
        MOI.ScalarNonlinearFunction(:+, Any[1.0, x]) => 0.0 * x * x + 1.0 + x,
        MOI.ScalarNonlinearFunction(:+, Any[f_add, f_add]) =>
            0.0 * x * x + 2.0 + 2.0 * x,
        MOI.ScalarNonlinearFunction(:^, Any[x, 2]) => 1.0 * x * x,
    )
        @test convert(MOI.ScalarQuadraticFunction{Float64}, f) ≈ g
    end
    for f_error in (MOI.ScalarNonlinearFunction(:/, Any[1.0, x]),)
        @test_throws(
            InexactError,
            convert(MOI.ScalarQuadraticFunction{Float64}, f_error),
        )
    end
    return
end

function test_convert_VectorQuadraticFunction_VectorAffineFunction()
    x = MOI.VariableIndex(1)
    quadratic = MOI.VectorQuadraticTerm{Float64}[]
    affine = [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x))]
    constants = [2.0]
    f = MOI.VectorQuadraticFunction(quadratic, affine, constants)
    g = MOI.VectorAffineFunction(affine, constants)
    @test convert(MOI.VectorAffineFunction{Float64}, f) ≈ g
    push!(
        quadratic,
        MOI.VectorQuadraticTerm(1, MOI.ScalarQuadraticTerm(1.0, x, x)),
    )
    @test_throws InexactError convert(MOI.VectorAffineFunction{Float64}, f)
    return
end

function test_convert_VectorAffineFunction_VectorQuadraticFunction()
    x = MOI.VariableIndex(1)
    quadratic = MOI.VectorQuadraticTerm{Float64}[]
    affine = [MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x))]
    constants = [2.0]
    f = MOI.VectorAffineFunction(affine, constants)
    g = MOI.VectorQuadraticFunction(quadratic, affine, constants)
    @test convert(MOI.VectorQuadraticFunction{Float64}, f) ≈ g
    return
end

function test_copy_ScalarNonlinearFunction()
    N = 10_000
    x = MOI.VariableIndex.(1:N)
    f1 = MOI.ScalarNonlinearFunction(:^, Any[x[1], 1])
    for i in 2:N
        g = MOI.ScalarNonlinearFunction(:^, Any[x[i], 1])
        f1 = MOI.ScalarNonlinearFunction(:+, Any[f1, g])
    end
    f2 = MOI.ScalarNonlinearFunction(:^, Any[x[1], 1])
    for i in 2:N
        g = MOI.ScalarNonlinearFunction(:^, Any[x[i], 1])
        f2 = MOI.ScalarNonlinearFunction(:+, Any[f2, g])
    end
    f_copy = copy(f1)
    @test ≈(f_copy, f2)
    f1.args[2].args[2] = 2.0  # x[1]^1 --> x[1]^2
    @test !isapprox(f_copy, f1)
    @test isapprox(f_copy, f2)
    return
end

function test_copy_ScalarNonlinearFunction_with_arg()
    N = 10_000
    x = MOI.VariableIndex.(1:N)
    f1 = 1.0 * x[1] + 1.0
    for i in 2:N
        g = f1 = Float64(i) * x[i] + Float64(i)
        f1 = MOI.ScalarNonlinearFunction(:+, Any[f1, g])
    end
    f2 = 1.0 * x[1] + 1.0
    for i in 2:N
        g = f2 = Float64(i) * x[i] + Float64(i)
        f2 = MOI.ScalarNonlinearFunction(:+, Any[f2, g])
    end
    f_copy = copy(f1)
    @test ≈(f_copy, f2)
    f1.args[2].constant += 1
    @test !isapprox(f_copy, f1)
    @test isapprox(f_copy, f2)
    return
end

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$name", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
end

end

TestFunctions.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    mutable struct FreeVariables <: MOI.ModelLike
        n::Int64
        FreeVariables() = new(0)
    end

A struct for storing free variables that can be used as the `variables` field
of [`GenericModel`](@ref) or [`GenericModel`](@ref). It represents a model
that does not support any constraint nor objective function.

## Example

The following model type represents a conic model in geometric form. As opposed
to [`VariablesContainer`](@ref), `FreeVariables` does not support constraint
bounds so they are bridged into an affine constraint in the
[`MOI.Nonnegatives`](@ref) cone as expected for the geometric
conic form.
```jldocstest
julia> MOI.Utilities.@product_of_sets(
    Cones,
    MOI.Zeros,
    MOI.Nonnegatives,
    MOI.SecondOrderCone,
    MOI.PositiveSemidefiniteConeTriangle,
);

julia> const ConicModel{T} = MOI.Utilities.GenericOptimizer{
    T,
    MOI.Utilities.ObjectiveContainer{T},
    MOI.Utilities.FreeVariables,
    MOI.Utilities.MatrixOfConstraints{
        T,
        MOI.Utilities.MutableSparseMatrixCSC{
            T,
            Int,
            MOI.Utilities.OneBasedIndexing,
        },
        Vector{T},
        Cones{T},
    },
};

julia> model = MOI.instantiate(ConicModel{Float64}, with_bridge_type=Float64);

julia> x = MOI.add_variable(model)
MathOptInterface.VariableIndex(1)

julia> c = MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.GreaterThan{Float64}}(1)

julia> MOI.Bridges.is_bridged(model, c)
true

julia> bridge = MOI.Bridges.bridge(model, c)
MathOptInterface.Bridges.Constraint.VectorizeBridge{Float64, MathOptInterface.VectorAffineFunction{Float64}, MathOptInterface.Nonnegatives, MathOptInterface.VariableIndex}(MathOptInterface.ConstraintIndex{MathOptInterface.VectorAffineFunction{Float64}, MathOptInterface.Nonnegatives}(1), 1.0)

julia> bridge.vector_constraint
MathOptInterface.ConstraintIndex{MathOptInterface.VectorAffineFunction{Float64}, MathOptInterface.Nonnegatives}(1)

julia> MOI.Bridges.is_bridged(model, bridge.vector_constraint)
false
```
"""
mutable struct FreeVariables <: MOI.ModelLike
    n::Int64
    FreeVariables() = new(0)
end

function MOI.empty!(model::FreeVariables)
    model.n = 0
    return
end

MOI.is_empty(model::FreeVariables) = iszero(model.n)

function MOI.add_variable(model::FreeVariables)
    model.n += 1
    return MOI.VariableIndex(model.n)
end

function MOI.get(model::FreeVariables, ::MOI.ListOfVariableIndices)
    return MOI.VariableIndex[MOI.VariableIndex(i) for i in 1:model.n]
end

function MOI.is_valid(model::FreeVariables, vi::MOI.VariableIndex)
    return 1 <= vi.value <= model.n
end

MOI.get(model::FreeVariables, ::MOI.NumberOfVariables) = model.n

function MOI.get(model::FreeVariables, ::MOI.ListOfConstraintTypesPresent)
    return Tuple{Type,Type}[]
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# This file contains default implementations for the `MOI.copy_to` function that
# can be used by a model.

include("copy/index_map.jl")

_sort_priority(::MOI.UserDefinedFunction) = 0.0
_sort_priority(::MOI.ObjectiveSense) = 10.0
_sort_priority(::MOI.ObjectiveFunction) = 20.0
_sort_priority(::MOI.AbstractModelAttribute) = 30.0

"""
    pass_attributes(
        dest::MOI.ModelLike,
        src::MOI.ModelLike,
        index_map,
    )

Pass the model attributes from the model `src` to the model `dest`.
"""
function pass_attributes(dest::MOI.ModelLike, src::MOI.ModelLike, index_map)
    attrs = MOI.get(src, MOI.ListOfModelAttributesSet())
    # We need to deal with the UserDefinedFunctions first, so that they are in
    # the model before we deal with the objective function or the constraints.
    # We also need `ObjectiveSense` to be set before `ObjectiveFunction`.
    sort!(attrs; by = _sort_priority)
    for attr in attrs
        if !MOI.supports(dest, attr)
            if attr == MOI.Name()
                continue  # Skipping names is okay.
            end
        end
        _pass_attribute(dest, src, index_map, attr)
    end
    return
end

function _pass_attribute(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map,
    attr::MOI.AbstractModelAttribute,
)
    value = MOI.get(src, attr)
    if value !== nothing
        MOI.set(dest, attr, map_indices(index_map, attr, value))
    end
    return
end

"""
    pass_attributes(
        dest::MOI.ModelLike,
        src::MOI.ModelLike,
        index_map,
        vis_src::Vector{MOI.VariableIndex},
    )

Pass the variable attributes from the model `src` to the model `dest`.
"""
function pass_attributes(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map,
    vis_src::Vector{MOI.VariableIndex},
)
    for attr in MOI.get(src, MOI.ListOfVariableAttributesSet())
        if !MOI.supports(dest, attr, MOI.VariableIndex)
            if attr == MOI.VariableName() || attr == MOI.VariablePrimalStart()
                continue  # Skipping names and start values is okay.
            end
        end
        _pass_attribute(dest, src, index_map, vis_src, attr)
    end
    return
end

function _pass_attribute(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map,
    vis_src::Vector{MOI.VariableIndex},
    attr::MOI.AbstractVariableAttribute,
)
    for x in vis_src
        value = MOI.get(src, attr, x)
        if value !== nothing
            MOI.set(
                dest,
                attr,
                index_map[x],
                map_indices(index_map, attr, value),
            )
        end
    end
    return
end

"""
    pass_attributes(
        dest::MOI.ModelLike,
        src::MOI.ModelLike,
        index_map,
        cis_src::Vector{MOI.ConstraintIndex{F,S}},
    ) where {F,S}

Pass the constraint attributes of `F`-in-`S` constraints from the model `src` to
the model `dest`.
"""
function pass_attributes(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map,
    cis_src::Vector{MOI.ConstraintIndex{F,S}},
) where {F,S}
    for attr in MOI.get(src, MOI.ListOfConstraintAttributesSet{F,S}())
        if !MOI.supports(dest, attr, MOI.ConstraintIndex{F,S})
            if (
                attr == MOI.ConstraintName() ||
                attr == MOI.ConstraintPrimalStart() ||
                attr == MOI.ConstraintDualStart()
            )
                continue  # Skipping names and start values is okay.
            end
        end
        _pass_attribute(dest, src, index_map, cis_src, attr)
    end
    return
end

function _pass_attribute(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map,
    cis_src::Vector{MOI.ConstraintIndex{F,S}},
    attr::MOI.AbstractConstraintAttribute,
) where {F,S}
    for ci in cis_src
        value = MOI.get(src, attr, ci)
        if value !== nothing
            MOI.set(
                dest,
                attr,
                index_map[ci],
                map_indices(index_map, attr, value),
            )
        end
    end
    return
end

"""
    _copy_constraints(
        dest::MOI.ModelLike,
        src::MOI.ModelLike,
        index_map,
        index_map_FS,
        cis_src::Vector{<:MOI.ConstraintIndex},
    )

Copy the constraints `cis_src` from the model `src` to the model `dest` and fill
`index_map` accordingly. Note that the attributes are not copied; call
[`pass_attributes`] to copy the constraint attributes.
"""
function _copy_constraints(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map,
    index_map_FS,
    cis_src::Vector{<:MOI.ConstraintIndex},
)
    for ci in cis_src
        f = MOI.get(src, MOI.ConstraintFunction(), ci)
        s = MOI.get(src, MOI.ConstraintSet(), ci)
        index_map_FS[ci] =
            MOI.add_constraint(dest, map_indices(index_map, f), s)
    end
    return
end

function _copy_constraints(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map,
    cis_src::Vector{MOI.ConstraintIndex{F,S}},
) where {F,S}
    return _copy_constraints(dest, src, index_map, index_map[F, S], cis_src)
end

function pass_nonvariable_constraints_fallback(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map::IndexMap,
    constraint_types,
)
    for (F, S) in constraint_types
        cis_src = MOI.get(src, MOI.ListOfConstraintIndices{F,S}())
        _copy_constraints(dest, src, index_map, cis_src)
    end
    return
end

"""
    pass_nonvariable_constraints(
        dest::MOI.ModelLike,
        src::MOI.ModelLike,
        index_map::IndexMap,
        constraint_types,
    )

For all tuples `(F, S)` in `constraint_types`, copy all constraints of type
`F`-in-`S` from `src` to `dest` mapping the variables indices with `index_map`.

The default implementation calls `pass_nonvariable_constraints_fallback`.
A method can be implemented to use a specialized copy for a given type of
`dest`.
"""
function pass_nonvariable_constraints(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map::IndexMap,
    constraint_types,
)
    pass_nonvariable_constraints_fallback(
        dest,
        src,
        index_map,
        constraint_types,
    )
    return
end

function _pass_constraints(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map::IndexMap,
    variable_constraints_not_added::Vector,
)
    for cis in variable_constraints_not_added
        _copy_constraints(dest, src, index_map, cis)
    end
    all_constraint_types = MOI.get(src, MOI.ListOfConstraintTypesPresent())
    nonvariable_constraint_types = filter(all_constraint_types) do (F, S)
        return !_is_variable_function(F)
    end
    pass_nonvariable_constraints(
        dest,
        src,
        index_map,
        nonvariable_constraint_types,
    )
    for (F, S) in all_constraint_types
        pass_attributes(
            dest,
            src,
            index_map,
            MOI.get(src, MOI.ListOfConstraintIndices{F,S}()),
        )
    end
    return
end

_is_variable_function(::Type{MOI.VariableIndex}) = true
_is_variable_function(::Type{MOI.VectorOfVariables}) = true
_is_variable_function(::Any) = false

function _cost_of_bridging(
    dest::MOI.ModelLike,
    ::Type{S},
) where {S<:MOI.AbstractScalarSet}
    x = MOI.get(dest, MOI.VariableBridgingCost{S}())
    y = MOI.get(dest, MOI.ConstraintBridgingCost{MOI.VariableIndex,S}())
    return !iszero(x), x - y, true
end

function _cost_of_bridging(
    dest::MOI.ModelLike,
    ::Type{S},
) where {S<:MOI.AbstractVectorSet}
    x = MOI.get(dest, MOI.VariableBridgingCost{S}())
    y = MOI.get(dest, MOI.ConstraintBridgingCost{MOI.VectorOfVariables,S}())
    return !iszero(x), x - y, false
end

"""
    sorted_variable_sets_by_cost(dest::MOI.ModelLike, src::MOI.ModelLike)

Return a `Vector{Type}` of the set types corresponding to `VariableIndex` and
`VectorOfVariables` constraints in the order in which they should be added.

## How the order is computed

The sorting happens in the `_cost_of_bridging` function and has three main
considerations:

1. First add sets for which the `VariableBridgingCost` is `0`. This ensures that
   we minimize the number of variable bridges that get added.
2. Then add sets for which the VariableBridgingCost is smaller than the
   `ConstraintBridgingCost` so they can get added with
   `add_constrained_variable(s)`.
3. Finally, break any remaining ties in favor of `AbstractVectorSet`s. This
   ensures we attempt to add large blocks of variables (for example, such as PSD
   matrices) before we add things like variable bounds.

## Why the order is important

The order is important because some solvers require variables to be added in
particular order, and the order can also impact the bridging decisions.

We favor adding first variables that won't use variables bridges because then
the variable constraints on the same variable can still be added as
`VariableIndex` or `VectorOfVariables` constraints.

If a variable does need variable bridges and is part of another variable
constraint, then the other variable constraint will be force-bridged into affine
constraints, so there is a hidden cost in terms of number of additional number
of bridges that will need to be used.

In fact, if the order does matter (in the sense that changing the order of the
vector returned by this function leads to a different formulation), it means the
variable is in at least one other variable constraint. Thus, in a sense we
could do `x - y + sign(x)`` but `!iszero(x), x - y` is fine.

## Example

A key example is Pajarito. It supports `VariableIndex`-in-`Integer` and
`VectorAffine`-in-`Nonnegatives`. If the user writes:
```julia
@variable(model, x >= 1, Int)
```
then we need to add two variable-related constraints:
 * `VariableIndex`-in-`Integer`
 * `VariableIndex`-in-`GreaterThan`
The first is natively supported and the variable and constraint bridging cost is
0. The second must be bridged to  `VectorAffineFunction`-in-`Nonnegatives` via
`x - 1 in Nonnegatives(1)`, and the variable and constraint bridging cost is
`1` in both cases.

If the order is `[Integer, GreaterThan]`, then we add `x ∈ Integer` and
`x - 1 in Nonnegatives`. Both are natively supported and it only requires a
single constraint bridge.

If the order is `[GreaterThan, Integer]`, then we add a new variable constrained
to `y ∈ Nonnegatives` and end up with an expression from the variable bridge of
`x = y + 1`. Then when we add the Integer constraint, we get `y + 1 in Integer`,
which is not natively supported. Therefore, we need to add `y + 1 - z ∈ Zeros`
and `z ∈ Integer`. Oops. This cost an extra variable, a variable bridge of
`x = y + 1`and a `Zeros` constraint.

Unfortunately, we don't have a good way of computing the updated costs for other
constraints if a variable bridge is chosen.
"""
function sorted_variable_sets_by_cost(dest::MOI.ModelLike, src::MOI.ModelLike)
    constraint_types = MOI.get(src, MOI.ListOfConstraintTypesPresent())
    sets = Type[S for (F, S) in constraint_types if _is_variable_function(F)]
    sort!(sets; by = S::Type -> _cost_of_bridging(dest, S))
    return sets
end

"""
    function final_touch(model::MOI.ModelLike, index_map) end

This is called at the end of [`default_copy_to`](@ref) to inform the model that
the copy is finished. This allows `model` to perform thats that should be done
only once all the model information is gathered.
"""
function final_touch(::MOI.ModelLike, index_map) end

"""
    default_copy_to(dest::MOI.ModelLike, src::MOI.ModelLike)

A default implementation of `MOI.copy_to(dest, src)` for models that implement
the incremental interface, that is, [`MOI.supports_incremental_interface`](@ref)
returns `true`.
"""
function default_copy_to(dest::MOI.ModelLike, src::MOI.ModelLike)
    if !MOI.supports_incremental_interface(dest)
        error("Model $(typeof(dest)) does not support copy_to.")
    end
    MOI.empty!(dest)
    index_map, vis_src, constraints_not_added =
        _copy_variables_with_set(dest, src)
    # Copy variable attributes
    pass_attributes(dest, src, index_map, vis_src)
    # Copy model attributes
    pass_attributes(dest, src, index_map)
    # Copy constraints
    _pass_constraints(dest, src, index_map, constraints_not_added)
    final_touch(dest, index_map)
    return index_map
end

struct _CopyVariablesWithSetCache
    variable_to_column::Dict{MOI.VariableIndex,Int}
    constraints_not_added::Vector{Any}
    variables_with_domain::Set{MOI.VariableIndex}
    variable_cones::Vector{Tuple{Vector{MOI.VariableIndex},Any}}
    function _CopyVariablesWithSetCache()
        return new(
            Dict{MOI.VariableIndex,Int}(),
            Any[],
            Set{MOI.VariableIndex}(),
            Tuple{Vector{MOI.VariableIndex},Any}[],
        )
    end
end

function _build_copy_variables_with_set_cache(
    src::MOI.ModelLike,
    cache::_CopyVariablesWithSetCache,
    ::Type{S},
) where {S<:MOI.AbstractScalarSet}
    F = MOI.VariableIndex
    indices = MOI.ConstraintIndex{F,S}[]
    for ci in MOI.get(src, MOI.ListOfConstraintIndices{F,S}())
        x = MOI.get(src, MOI.ConstraintFunction(), ci)
        if x in cache.variables_with_domain
            # `x` is already assigned to a domain. Add this constraint via
            # `add_constraint`.
            push!(indices, ci)
        else
            # `x` is not assigned to a domain. Choose to add this constraint via
            # `x, ci = add_constraint_variable(model, set)`
            push!(cache.variables_with_domain, x)
            push!(cache.variable_cones, ([x], ci))
        end
    end
    if !isempty(indices)
        # If indices is not empty, then we have some constraints to add.
        push!(cache.constraints_not_added, indices)
    end
    return
end

# This function is a heuristic that checks whether `f` should be added via
# `MOI.add_constrained_variables`.
function _is_variable_cone(
    cache::_CopyVariablesWithSetCache,
    f::MOI.VectorOfVariables,
)
    if isempty(f.variables)
        # If the dimension is `0`, `f` cannot be added via
        # `add_constrained_variables`
        return false
    end
    offset = cache.variable_to_column[f.variables[1]] - 1
    for (i, xi) in enumerate(f.variables)
        if xi in cache.variables_with_domain
            # The function contains at least one element that is already
            # assigned to a domain. We can't add `f` via
            # `add_constrained_variables`
            return false
        elseif cache.variable_to_column[xi] != offset + i
            # The variables in the function are not contiguous in their column
            # ordering. In theory, we could add `f` via `add_constrained_variables`,
            # but this would introduce a permutation so we choose not to.
            return false
        end
    end
    return true
end

function _build_copy_variables_with_set_cache(
    src::MOI.ModelLike,
    cache::_CopyVariablesWithSetCache,
    ::Type{S},
) where {S<:MOI.AbstractVectorSet}
    F = MOI.VectorOfVariables
    indices = MOI.ConstraintIndex{F,S}[]
    for ci in MOI.get(src, MOI.ListOfConstraintIndices{F,S}())
        f = MOI.get(src, MOI.ConstraintFunction(), ci)
        if _is_variable_cone(cache, f)
            for fi in f.variables
                # We need to assign each variable in `f` to a domain
                push!(cache.variables_with_domain, fi)
            end
            # And we need to add the variables via `add_constrained_variables`.
            push!(cache.variable_cones, (f.variables, ci))
        else
            # Not a variable cone, so add via `add_constraint`.
            push!(indices, ci)
        end
    end
    if !isempty(indices)
        # If indices is not empty, then we have some constraints to add.
        push!(cache.constraints_not_added, indices)
    end
    return
end

function _add_variable_with_domain(
    dest,
    src,
    index_map,
    f,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet},
)
    set = MOI.get(src, MOI.ConstraintSet(), ci)
    dest_x, dest_ci = MOI.add_constrained_variable(dest, set)
    index_map[only(f)] = dest_x
    index_map[ci] = dest_ci
    return
end

function _add_variable_with_domain(
    dest,
    src,
    index_map,
    f,
    ci::MOI.ConstraintIndex{MOI.VectorOfVariables,<:MOI.AbstractVectorSet},
)
    set = MOI.get(src, MOI.ConstraintSet(), ci)
    dest_x, dest_ci = MOI.add_constrained_variables(dest, set)
    for (fi, xi) in zip(f, dest_x)
        index_map[fi] = xi
    end
    index_map[ci] = dest_ci
    return
end

function _copy_variables_with_set(dest, src)
    index_map = IndexMap()
    vis_src = MOI.get(src, MOI.ListOfVariableIndices())
    cache = _CopyVariablesWithSetCache()
    for (i, v) in enumerate(vis_src)
        cache.variable_to_column[v] = i
    end
    for S in sorted_variable_sets_by_cost(dest, src)
        _build_copy_variables_with_set_cache(src, cache, S)
    end
    column(x::MOI.VariableIndex) = cache.variable_to_column[x]
    start_column(x) = column(first(x[1]))
    current_column = 0
    sort!(cache.variable_cones; by = start_column)
    for (f, ci) in cache.variable_cones
        offset = column(first(f)) - current_column - 1
        if offset > 0
            dest_x = MOI.add_variables(dest, offset)
            for i in 1:offset
                index_map[vis_src[current_column+i]] = dest_x[i]
            end
        end
        _add_variable_with_domain(dest, src, index_map, f, ci)
        current_column = column(last(f))
    end
    offset = length(cache.variable_to_column) - current_column
    if offset > 0
        dest_x = MOI.add_variables(dest, offset)
        for i in 1:offset
            index_map[vis_src[current_column+i]] = dest_x[i]
        end
    end
    return index_map, vis_src, cache.constraints_not_added
end

"""
    ModelFilter(filter::Function, model::MOI.ModelLike)

A layer to filter out various components of `model`.

The filter function takes a single argument, which is each element from the list
returned by the attributes below. It returns `true` if the element should be
visible in the filtered model and `false` otherwise.

The components that are filtered are:

 * Entire constraint types via:
   * `MOI.ListOfConstraintTypesPresent`
 * Individual constraints via:
   * `MOI.ListOfConstraintIndices{F,S}`
 * Specific attributes via:
   * `MOI.ListOfModelAttributesSet`
   * `MOI.ListOfConstraintAttributesSet`
   * `MOI.ListOfVariableAttributesSet`

!!! warning
    The list of attributes filtered may change in a future release. You should
    write functions that are generic and not limited to the five types listed
    above. Thus, you should probably define a fallback `filter(::Any) = true`.

See below for examples of how this works.

!!! note
    This layer has a limited scope. It is intended by be used in conjunction
    with `MOI.copy_to`.

## Example: copy model excluding integer constraints

Use the `do` syntax to provide a single function.

```julia
filtered_src = MOI.Utilities.ModelFilter(src) do item
    return item != (MOI.VariableIndex, MOI.Integer)
end
MOI.copy_to(dest, filtered_src)
```

## Example: copy model excluding names

Use type dispatch to simplify the implementation:

```julia
my_filter(::Any) = true  # Note the generic fallback
my_filter(::MOI.VariableName) = false
my_filter(::MOI.ConstraintName) = false
filtered_src = MOI.Utilities.ModelFilter(my_filter, src)
MOI.copy_to(dest, filtered_src)
```

## Example: copy irreducible infeasible subsystem

```julia
my_filter(::Any) = true  # Note the generic fallback
function my_filter(ci::MOI.ConstraintIndex)
    status = MOI.get(dest, MOI.ConstraintConflictStatus(), ci)
    return status != MOI.NOT_IN_CONFLICT
end
filtered_src = MOI.Utilities.ModelFilter(my_filter, src)
MOI.copy_to(dest, filtered_src)
```
"""
struct ModelFilter{T,F} <: MOI.ModelLike
    inner::T
    filter::F
    function ModelFilter(filter::Function, model::MOI.ModelLike)
        return new{typeof(model),typeof(filter)}(model, filter)
    end
end

function MOI.get(
    model::ModelFilter,
    attr::Union{
        MOI.ListOfConstraintAttributesSet,
        MOI.ListOfConstraintIndices,
        MOI.ListOfConstraintTypesPresent,
        MOI.ListOfModelAttributesSet,
        MOI.ListOfVariableAttributesSet,
    },
)
    return filter(model.filter, MOI.get(model.inner, attr))
end

function MOI.get(model::ModelFilter, attr::MOI.AbstractModelAttribute)
    return MOI.get(model.inner, attr)
end

# !!! warning
#     Slow implementations, but we need to report the number of constraints in
#     the filtered model, not in the `.inner`.

function MOI.get(model::ModelFilter, ::MOI.NumberOfConstraints{F,S}) where {F,S}
    return length(MOI.get(model, MOI.ListOfConstraintIndices{F,S}()))
end

# These just forward the attributes into the inner model.

function MOI.get(
    model::ModelFilter,
    attr::MOI.AbstractVariableAttribute,
    x::MOI.VariableIndex,
)
    return MOI.get(model.inner, attr, x)
end

function MOI.get(
    model::ModelFilter,
    attr::MOI.AbstractConstraintAttribute,
    ci::MOI.ConstraintIndex,
)
    return MOI.get(model.inner, attr, ci)
end

# !!! warning
#     This is a slow implementation. But we need to check if we filtered
#     everything.
function MOI.is_empty(model::ModelFilter)
    if MOI.is_empty(model.inner)
        return true
    elseif MOI.get(model.inner, MOI.NumberOfVariables()) > 0
        return false
    elseif length(MOI.get(model, MOI.ListOfModelAttributesSet())) > 0
        return false
    end
    return true
end

MOI.empty!(model::ModelFilter) = MOI.empty!(model.inner)

###
### These methods are deprecated, but unfortunately, they are used by a number
### of downstream packages and JuMP extensions.
###

function _try_constrain_variables_on_creation(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map::IndexMap,
    ::Type{S},
) where {S<:MOI.AbstractVectorSet}
    not_added = MOI.ConstraintIndex{MOI.VectorOfVariables,S}[]
    for ci_src in
        MOI.get(src, MOI.ListOfConstraintIndices{MOI.VectorOfVariables,S}())
        f_src = MOI.get(src, MOI.ConstraintFunction(), ci_src)
        if !allunique(f_src.variables)
            # Can't add it because there are duplicate variables
            push!(not_added, ci_src)
        elseif any(vi -> haskey(index_map, vi), f_src.variables)
            # Can't add it because it contains a variable previously added
            push!(not_added, ci_src)
        else
            set = MOI.get(src, MOI.ConstraintSet(), ci_src)::S
            vis_dest, ci_dest = MOI.add_constrained_variables(dest, set)
            index_map[ci_src] = ci_dest
            for (vi_src, vi_dest) in zip(f_src.variables, vis_dest)
                index_map[vi_src] = vi_dest
            end
        end
    end
    return not_added
end

function _try_constrain_variables_on_creation(
    dest::MOI.ModelLike,
    src::MOI.ModelLike,
    index_map::IndexMap,
    ::Type{S},
) where {S<:MOI.AbstractScalarSet}
    not_added = MOI.ConstraintIndex{MOI.VariableIndex,S}[]
    for ci_src in
        MOI.get(src, MOI.ListOfConstraintIndices{MOI.VariableIndex,S}())
        f_src = MOI.get(src, MOI.ConstraintFunction(), ci_src)
        if haskey(index_map, f_src)
            # Can't add it because it contains a variable previously added
            push!(not_added, ci_src)
        else
            set = MOI.get(src, MOI.ConstraintSet(), ci_src)::S
            vi_dest, ci_dest = MOI.add_constrained_variable(dest, set)
            index_map[ci_src] = ci_dest
            index_map[f_src] = vi_dest
        end
    end
    return not_added
end

function _copy_free_variables(dest::MOI.ModelLike, index_map::IndexMap, vis_src)
    if length(vis_src) == length(index_map.var_map)
        return  # All variables already added
    end
    x = MOI.add_variables(dest, length(vis_src) - length(index_map.var_map))
    i = 1
    for vi in vis_src
        if !haskey(index_map, vi)
            index_map[vi] = x[i]
            i += 1
        end
    end
    @assert i == length(x) + 1
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

function _test_num_constraints(bridged_mock, F, S, n)
    @test MOI.get(bridged_mock, MOI.NumberOfConstraints{F,S}()) == n
    @test length(MOI.get(bridged_mock, MOI.ListOfConstraintIndices{F,S}())) == n
    ret = (F, S) in MOI.get(bridged_mock, MOI.ListOfConstraintTypesPresent())
    @test ret == !iszero(n)
    return
end

function _warn_incomplete_list_num_constraints(BT, list_num_constraints)
    for (S,) in MOI.Bridges.added_constrained_variable_types(BT)
        if S == MOI.Reals
            continue
        end
        F = MOI.Utilities.variable_function_type(S)
        if !any(c -> c[1] == F && c[2] == S, list_num_constraints)
            error(
                "Bridges of type $BT add constrained variable in $S but " *
                "their number is not tested.",
            )
        end
    end
    for (F, S) in MOI.Bridges.added_constraint_types(BT)
        if !any(c -> c[1] == F && c[2] == S, list_num_constraints)
            error(
                "Bridges of type $BT add $F-in-$S constraints but their " *
                "number is not tested.",
            )
        end
    end
    return
end

"""
    _test_delete_bridge(
        m::MOI.Bridges.AbstractBridgeOptimizer,
        ci::MOI.ConstraintIndex{F, S},
        nvars::Int,
        list_num_constraints::Tuple;
        used_bridges = 1,
        num_bridged = 1,
    ) where {F, S}

Test deletion of the constraint `ci` in model `m`.

* The number of variables added in `m` is `nvars` (ignoring the variables added
  by the bridges).
* For each `(Fi, Si, n)` in `list_num_constraints`, the number of `Fi`-in-`Si`
  constraints added to `m` is `n` (ignoring the constraints added by the
  bridges). All constraint types added by the bridge bridging `ci` should appear
  in `list_num_constraints`. Otherwise a error is thrown to ensure good test
  coverage.
* The number of bridges that will be deleted when deleted `ci` is
  `used_bridges`.
* The number of `F`-in-`S` constraints is `num_bridged`.
"""
function _test_delete_bridge(
    m::MOI.Bridges.AbstractBridgeOptimizer,
    ci::MOI.ConstraintIndex{F,S},
    nvars::Int,
    list_num_constraints::Tuple;
    used_bridges = 1,
    num_bridged = 1,
) where {F,S}
    _warn_incomplete_list_num_constraints(
        typeof(MOI.Bridges.bridge(m, ci)),
        list_num_constraints,
    )
    function num_bridges()
        return count(bridge -> true, values(MOI.Bridges.Constraint.bridges(m)))
    end
    start_num_bridges = num_bridges()
    @test MOI.get(m, MOI.NumberOfVariables()) == nvars
    @test length(MOI.get(m, MOI.ListOfVariableIndices())) == nvars
    _test_num_constraints(m, F, S, num_bridged)
    for num_constraints in list_num_constraints
        _test_num_constraints(m, num_constraints...)
    end
    @test MOI.is_valid(m, ci)
    MOI.delete(m, ci)
    @test_throws MOI.InvalidIndex(ci) MOI.delete(m, ci)
    @test !MOI.is_valid(m, ci)
    @test num_bridges() == start_num_bridges - used_bridges
    _test_num_constraints(m, F, S, num_bridged - 1)
    # As the bridge has been removed, if the constraints it has created were not
    # removed, it wouldn't be there to decrease this counter anymore.
    @test MOI.get(m, MOI.NumberOfVariables()) == nvars
    @test length(MOI.get(m, MOI.ListOfVariableIndices())) == nvars
    for num_constraints in list_num_constraints
        _test_num_constraints(m, num_constraints...)
    end
    return
end

# Test deletion of variable bridge used for variable `vi`
function _test_delete_bridged_variable(
    m::MOI.Bridges.AbstractBridgeOptimizer,
    vi::MOI.VariableIndex,
    S::Type,
    nvars::Int,
    list_num_constraints::Tuple;
    used_bridges = 1,
    num_bridged = 1,
    used_constraints = 1,
)
    _warn_incomplete_list_num_constraints(
        typeof(MOI.Bridges.bridge(m, vi)),
        list_num_constraints,
    )
    function num_bridges()
        return count(bridge -> true, values(MOI.Bridges.Variable.bridges(m)))
    end
    start_num_bridges = num_bridges()
    @test MOI.get(m, MOI.NumberOfVariables()) == nvars
    @test length(MOI.get(m, MOI.ListOfVariableIndices())) == nvars
    if S != MOI.Reals
        F =
            S <: MOI.AbstractScalarSet ? MOI.VariableIndex :
            MOI.VectorOfVariables
        _test_num_constraints(m, F, S, num_bridged)
    end
    for num_constraints in list_num_constraints
        _test_num_constraints(m, num_constraints...)
    end
    @test MOI.is_valid(m, vi)
    MOI.delete(m, vi)
    @test_throws MOI.InvalidIndex(vi) MOI.delete(m, vi)
    @test !MOI.is_valid(m, vi)
    @test num_bridges() == start_num_bridges - used_bridges
    if S != MOI.Reals
        _test_num_constraints(m, F, S, num_bridged - used_constraints)
    end
    @test MOI.get(m, MOI.NumberOfVariables()) == nvars - 1
    @test length(MOI.get(m, MOI.ListOfVariableIndices())) == nvars - 1
    for num_constraints in list_num_constraints
        _test_num_constraints(m, num_constraints...)
    end
    return
end

# Test deletion of variable bridge used for vector of variables `vis`
function _test_delete_bridged_variables(
    m::MOI.Bridges.AbstractBridgeOptimizer,
    vis::Vector{MOI.VariableIndex},
    S::Type,
    nvars::Int,
    list_num_constraints::Tuple;
    used_bridges = 1,
    num_bridged = 1,
)
    _warn_incomplete_list_num_constraints(
        typeof(MOI.Bridges.bridge(m, vis[1])),
        list_num_constraints,
    )
    function num_bridges()
        return count(bridge -> true, values(MOI.Bridges.Variable.bridges(m)))
    end
    start_num_bridges = num_bridges()
    @test MOI.get(m, MOI.NumberOfVariables()) == nvars
    @test length(MOI.get(m, MOI.ListOfVariableIndices())) == nvars
    if S != MOI.Reals
        F =
            S <: MOI.AbstractScalarSet ? MOI.VariableIndex :
            MOI.VectorOfVariables
        _test_num_constraints(m, F, S, num_bridged)
    end
    for num_constraints in list_num_constraints
        _test_num_constraints(m, num_constraints...)
    end
    @test all(vi -> MOI.is_valid(m, vi), vis)
    MOI.delete(m, vis)
    @test_throws MOI.InvalidIndex(vis[1]) MOI.delete(m, vis)
    @test all(vi -> !MOI.is_valid(m, vi), vis)
    @test num_bridges() == start_num_bridges - used_bridges
    if S != MOI.Reals
        _test_num_constraints(m, F, S, num_bridged - 1)
    end
    @test MOI.get(m, MOI.NumberOfVariables()) == nvars - length(vis)
    @test length(MOI.get(m, MOI.ListOfVariableIndices())) == nvars - length(vis)
    for num_constraints in list_num_constraints
        _test_num_constraints(m, num_constraints...)
    end
    return
end

function _test_delete_objective(
    m::MOI.Bridges.AbstractBridgeOptimizer,
    nvars::Int,
    list_num_constraints::Tuple;
    used_bridges = 1,
)
    _warn_incomplete_list_num_constraints(
        typeof(
            MOI.Bridges.Objective.root_bridge(MOI.Bridges.Objective.bridges(m)),
        ),
        list_num_constraints,
    )
    function num_bridges()
        return length(MOI.Bridges.Objective.bridges(m))
    end
    start_num_bridges = num_bridges()
    @test MOI.get(m, MOI.NumberOfVariables()) == nvars
    @test length(MOI.get(m, MOI.ListOfVariableIndices())) == nvars
    for num_constraints in list_num_constraints
        _test_num_constraints(m, num_constraints...)
    end
    MOI.set(m, MOI.ObjectiveSense(), MOI.FEASIBILITY_SENSE)
    @test MOI.get(m, MOI.ObjectiveSense()) == MOI.FEASIBILITY_SENSE
    @test num_bridges() == start_num_bridges - used_bridges
    @test MOI.get(m, MOI.NumberOfVariables()) == nvars
    @test length(MOI.get(m, MOI.ListOfVariableIndices())) == nvars
    for num_constraints in list_num_constraints
        _test_num_constraints(m, num_constraints...)
    end
    return
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

### ============================================================================
### Opcodes, and their AMPL <-> Julia conversions.
### ============================================================================

include("opcode.jl")

"""
    _JULIA_TO_AMPL

This dictionary is manualy curated, based on the list of opcodes in `opcode.jl`.

The goal is to map Julia functions to their AMPL opcode equivalent.

Sometimes, there is ambiguity, such as the `:+`, which Julia uses for unary,
binary, and n-ary addition, while AMPL doesn't support unary addition, uses
OPPLUS for binary, and OPSUMLIST for n-ary. In these cases, introduce a
different symbol to disambiguate them in the context of this dictionary, and add
logic to `_process_expr!` to rewrite the Julia expression.

Commented out lines are opcodes supported by AMPL that don't have a clear Julia
equivalent. If you can think of one, feel free to add it. But then go and make
similar changes to `_AMPL_TO_JULIA` and `_NARY_OPCODES`.
"""
const _JULIA_TO_AMPL = Dict{Symbol,Int}(
    :+ => OPPLUS,  # binary-plus
    :- => OPMINUS,
    :* => OPMULT,
    :/ => OPDIV,
    :rem => OPREM,
    :^ => OPPOW,
    # OPLESS = 6
    :min => MINLIST,  # n-ary
    :max => MAXLIST,  # n-ary
    # FLOOR = 13
    # CEIL = 14
    :abs => ABS,
    :neg => OPUMINUS,
    :|| => OPOR,
    :&& => OPAND,
    :(<) => LT,
    :(<=) => LE,
    :(==) => EQ,
    :(>=) => GE,
    :(>) => GT,
    :(!=) => NE,
    :(!) => OPNOT,
    :ifelse => OPIFnl,
    :tanh => OP_tanh,
    :tan => OP_tan,
    :sqrt => OP_sqrt,
    :sinh => OP_sinh,
    :sin => OP_sin,
    :log10 => OP_log10,
    :log => OP_log,
    :exp => OP_exp,
    :cosh => OP_cosh,
    :cos => OP_cos,
    :atanh => OP_atanh,
    # Because :atan is also a univariate operator, this is special cased in
    # process_expr!.
    # :atan = OP_atan2,
    :atan => OP_atan,
    :asinh => OP_asinh,
    :asin => OP_asin,
    :acosh => OP_acosh,
    :acos => OP_acos,
    :sum => OPSUMLIST,  # n-ary plus
    # OPintDIV = 55
    # OPprecision = 56
    # OPround = 57
    # OPtrunc = 58
    # OPCOUNT = 59
    # OPNUMBEROF = 60
    # OPNUMBEROFs = 61
    # OPATLEAST = 62
    # OPATMOST = 63
    # OPPLTERM = 64
    # OPIFSYM = 65
    # OPEXACTLY = 66
    # OPNOTATLEAST = 67
    # OPNOTATMOST = 68
    # OPNOTEXACTLY = 69
    # ANDLIST = 70
    # ORLIST = 71
    # OPIMPELSE = 72
    # OP_IFF = 73
    # OPALLDIFF = 74
    # OPSOMESAME = 75
    # OP1POW = 76
    # OP2POW = 77
    # OPCPOW = 78
    # OPFUNCALL = 79
    # OPNUM = 80
    # OPHOL = 81
    # OPVARVAL = 82
    # N_OPS = 83
)

"""
    _AMPL_TO_JULIA

This dictionary is manualy curated, based on the list of supported opcodes
`_JULIA_TO_AMPL`.

The goal is to map AMPL opcodes to their Julia equivalents. In addition, we need
to know the arity of each opcode.

If the opcode is an n-ary function, use `-1`.
"""
const _AMPL_TO_JULIA = Dict{Int,Tuple{Int,Function}}(
    OPPLUS => (2, +),
    OPMINUS => (2, -),
    OPMULT => (2, *),
    OPDIV => (2, /),
    OPREM => (2, rem),
    OPPOW => (2, ^),
    # OPLESS = 6
    MINLIST => (-1, minimum),
    MAXLIST => (-1, maximum),
    # FLOOR = 13
    # CEIL = 14
    ABS => (1, abs),
    OPUMINUS => (1, -),
    OPOR => (2, |),
    OPAND => (2, &),
    LT => (2, <),
    LE => (2, <=),
    EQ => (2, ==),
    GE => (2, >=),
    GT => (2, >),
    NE => (2, !=),
    OPNOT => (1, !),
    OPIFnl => (3, ifelse),
    OP_tanh => (1, tanh),
    OP_tan => (1, tan),
    OP_sqrt => (1, sqrt),
    OP_sinh => (1, sinh),
    OP_sin => (1, sin),
    OP_log10 => (1, log10),
    OP_log => (1, log),
    OP_exp => (1, exp),
    OP_cosh => (1, cosh),
    OP_cos => (1, cos),
    OP_atanh => (1, atanh),
    OP_atan2 => (2, atan),
    OP_atan => (1, atan),
    OP_asinh => (1, asinh),
    OP_asin => (1, asin),
    OP_acosh => (1, acosh),
    OP_acos => (1, acos),
    OPSUMLIST => (-1, sum),
    # OPintDIV = 55
    # OPprecision = 56
    # OPround = 57
    # OPtrunc = 58
    # OPCOUNT = 59
    # OPNUMBEROF = 60
    # OPNUMBEROFs = 61
    # OPATLEAST = 62
    # OPATMOST = 63
    # OPPLTERM = 64
    # OPIFSYM = 65
    # OPEXACTLY = 66
    # OPNOTATLEAST = 67
    # OPNOTATMOST = 68
    # OPNOTEXACTLY = 69
    # ANDLIST = 70
    # ORLIST = 71
    # OPIMPELSE = 72
    # OP_IFF = 73
    # OPALLDIFF = 74
    # OPSOMESAME = 75
    # OP1POW = 76
    # OP2POW = 77
    # OPCPOW = 78
    # OPFUNCALL = 79
    # OPNUM = 80
    # OPHOL = 81
    # OPVARVAL = 82
    # N_OPS = 83
)

"""
    _NARY_OPCODES

A manually curated list of n-ary opcodes, taken from Table 8 of "Writing .nl
files."

Not all of these are implemented. See `_REV_OPCODES` for more detail.
"""
const _NARY_OPCODES = Set([
    MINLIST,
    MAXLIST,
    OPSUMLIST,
    OPCOUNT,
    OPNUMBEROF,
    OPNUMBEROFs,
    ANDLIST,
    ORLIST,
    OPALLDIFF,
])

"""
    _UNARY_SPECIAL_CASES

This dictionary defines a set of unary functions that are special-cased. They
don't exist in the NL file format, but they may be called from Julia, and
they can easily be converted into NL-compatible expressions.

If you have a new unary-function that you want to support, add it here.
"""
const _UNARY_SPECIAL_CASES = Dict{Symbol,Function}(
    :cbrt => (x) -> :($x^(1 / 3)),
    :abs2 => (x) -> :($x^2),
    :inv => (x) -> :(1 / $x),
    :log2 => (x) -> :(log($x) / log(2)),
    :log1p => (x) -> :(log(1 + $x)),
    :exp2 => (x) -> :(2^$x),
    :expm1 => (x) -> :(exp($x) - 1),
    :sec => (x) -> :(1 / cos($x)),
    :csc => (x) -> :(1 / sin($x)),
    :cot => (x) -> :(1 / tan($x)),
    :asec => (x) -> :(acos(1 / $x)),
    :acsc => (x) -> :(asin(1 / $x)),
    :acot => (x) -> :(pi / 2 - atan($x)),
    :sind => (x) -> :(sin(pi / 180 * $x)),
    :cosd => (x) -> :(cos(pi / 180 * $x)),
    :tand => (x) -> :(tan(pi / 180 * $x)),
    :secd => (x) -> :(1 / cos(pi / 180 * $x)),
    :cscd => (x) -> :(1 / sin(pi / 180 * $x)),
    :cotd => (x) -> :(1 / tan(pi / 180 * $x)),
    :asind => (x) -> :(asin($x) * 180 / pi),
    :acosd => (x) -> :(acos($x) * 180 / pi),
    :atand => (x) -> :(atan($x) * 180 / pi),
    :asecd => (x) -> :(acos(1 / $x) * 180 / pi),
    :acscd => (x) -> :(asin(1 / $x) * 180 / pi),
    :acotd => (x) -> :((pi / 2 - atan($x)) * 180 / pi),
    :sech => (x) -> :(1 / cosh($x)),
    :csch => (x) -> :(1 / sinh($x)),
    :coth => (x) -> :(1 / tanh($x)),
    :asech => (x) -> :(acosh(1 / $x)),
    :acsch => (x) -> :(asinh(1 / $x)),
    :acoth => (x) -> :(atanh(1 / $x)),
    :sign => (x) -> :(ifelse($x >= 0, 1, -1)),
)

"""
    _BINARY_SPECIAL_CASES

This dictionary defines a set of binary functions that are special-cased. They
don't exist in the NL file format, but they may be called from Julia, and
they can easily be converted into NL-compatible expressions.

If you have a new binary-function that you want to support, add it here.
"""
const _BINARY_SPECIAL_CASES = Dict{Symbol,Function}(:\ => (x, y) -> :($y / $x))

### ============================================================================
### Nonlinear expressions
### ============================================================================

# TODO(odow): This type isn't great. We should experiment with something that is
# type-stable, like
#
# @enum(_NLType, _INTEGER, _DOUBLE, _VARIABLE)
# struct _NLTerm
#     type::_NLType
#     data::Int64
# end
# _NLTerm(x::Int) = _NLTerm(_INTEGER, x)
# _NLTerm(x::Float64) = _NLTerm(_DOUBLE, reinterpret(Int64, x))
# _NLTerm(x::MOI.VariableIndex) = _NLTerm(_VARIABLE, x.value)
# function _value(x::_NLTerm)
#     if x.type == _INTEGER
#         return x.data
#     elseif x.type == _DOUBLE
#         return reinterpret(Float64, x.data)
#     else
#         @assert x.type == _VARIABLE
#         return MOI.VariableIndex(x.data)
#     end
# end

const _NLTerm = Union{Int,Float64,MOI.VariableIndex}

struct _NLExpr
    is_linear::Bool
    nonlinear_terms::Vector{_NLTerm}
    linear_terms::Dict{MOI.VariableIndex,Float64}
    constant::Float64
end

function Base.:(==)(x::_NLExpr, y::_NLExpr)
    return x.is_linear == y.is_linear &&
           x.nonlinear_terms == y.nonlinear_terms &&
           x.linear_terms == y.linear_terms &&
           x.constant == y.constant
end

_NLExpr(x::MOI.VariableIndex) = _NLExpr(true, _NLTerm[], Dict(x => 1.0), 0.0)

function _add_or_set(dict, key, value)
    if haskey(dict, key)
        dict[key] += value
    else
        dict[key] = value
    end
    return
end

function _NLExpr(x::MOI.ScalarAffineFunction)
    linear = Dict{MOI.VariableIndex,Float64}()
    for (i, term) in enumerate(x.terms)
        _add_or_set(linear, term.variable, term.coefficient)
    end
    return _NLExpr(true, _NLTerm[], linear, x.constant)
end

function _NLExpr(x::MOI.ScalarQuadraticFunction)
    linear = Dict{MOI.VariableIndex,Float64}()
    for (i, term) in enumerate(x.affine_terms)
        _add_or_set(linear, term.variable, term.coefficient)
    end
    terms = _NLTerm[]
    N = length(x.quadratic_terms)
    if N == 0 || N == 1
        # If there are 0 or 1 terms, no need for an addition node.
    elseif N == 2
        # If there are two terms, use binary addition.
        push!(terms, OPPLUS)
    elseif N > 2
        # If there are more, use n-ary addition.
        push!(terms, OPSUMLIST)
        push!(terms, N)
    end
    for term in x.quadratic_terms
        coefficient = term.coefficient
        # MOI defines quadratic as 1/2 x' Q x :(
        if term.variable_1 == term.variable_2
            coefficient *= 0.5
        end
        # Optimization: no need for the OPMULT if the coefficient is 1.
        if !isone(coefficient)
            push!(terms, OPMULT)
            push!(terms, coefficient)
        end
        push!(terms, OPMULT)
        push!(terms, term.variable_1)
        push!(terms, term.variable_2)
        # For the Jacobian sparsity patterns, we need to add a linear term, even
        # if the variable only appears nonlinearly.
        _add_or_set(linear, term.variable_1, 0.0)
        _add_or_set(linear, term.variable_2, 0.0)
    end
    return _NLExpr(false, terms, linear, x.constant)
end

function _NLExpr(expr::MOI.ScalarNonlinearFunction)
    nlexpr = _NLExpr(false, _NLTerm[], Dict{MOI.VariableIndex,Float64}(), 0.0)
    _process_expr!(nlexpr, expr)
    return nlexpr
end

function _NLExpr(expr::Expr)
    nlexpr = _NLExpr(false, _NLTerm[], Dict{MOI.VariableIndex,Float64}(), 0.0)
    _process_expr!(nlexpr, expr)
    return nlexpr
end

function _process_expr!(expr::_NLExpr, arg::Real)
    return push!(expr.nonlinear_terms, Float64(arg))
end

# Assume the symbol is a numeric constant like `pi`.
_process_expr!(expr::_NLExpr, arg::Symbol) = _process_expr!(expr, eval(arg))

function _process_expr!(expr::_NLExpr, arg::MOI.VariableIndex)
    _add_or_set(expr.linear_terms, arg, 0.0)
    return push!(expr.nonlinear_terms, arg)
end

# TODO(odow): these functions use recursion. For large models,
# this may exceed the stack. At some point, we may have to rewrite this to not
# use recursion.
function _process_expr!(expr::_NLExpr, arg::Expr)
    if arg.head == :call
        if length(arg.args) == 2
            f = get(_UNARY_SPECIAL_CASES, arg.args[1], nothing)
            if f !== nothing
                return _process_expr!(expr, f(arg.args[2]))
            end
        elseif length(arg.args) == 3
            f = get(_BINARY_SPECIAL_CASES, arg.args[1], nothing)
            if f !== nothing
                return _process_expr!(expr, f(arg.args[2], arg.args[3]))
            end
        end
        return _process_expr!(expr, arg.args)
    elseif arg.head == :ref
        return _process_expr!(expr, arg.args[2])
    elseif arg == :()
        return  # Some evalators return a null objective of `:()`.
    end
    return error("Unsupported expression: $(arg)")
end

function _process_expr!(
    expr::_NLExpr,
    arg::Union{MOI.ScalarAffineFunction,MOI.ScalarQuadraticFunction},
)
    # This method gets called recursively from the arguments to
    # ScalarNonlinearFunction, so we cannot add the linear parts to
    # `expr.linear_terms`.
    f = convert(MOI.ScalarNonlinearFunction, arg)
    _process_expr!(expr, f)
    return
end

function _process_expr!(expr::_NLExpr, arg::MOI.ScalarNonlinearFunction)
    if length(arg.args) == 1
        f = get(_UNARY_SPECIAL_CASES, arg.head, nothing)
        if f !== nothing
            return _process_expr!(expr, f(arg.args[1]))
        end
    elseif length(arg.args) == 2
        f = get(_BINARY_SPECIAL_CASES, arg.head, nothing)
        if f !== nothing
            return _process_expr!(expr, f(arg.args[1], arg.args[2]))
        end
    end
    return _process_expr!(expr, vcat(arg.head, arg.args))
end

function _process_expr!(expr::_NLExpr, args::Vector{Any})
    op = first(args)
    N = length(args) - 1
    # Before processing the arguments, do some re-writing.
    if op == :+
        if N == 1  # +x, so we can just drop the op and process the args.
            return _process_expr!(expr, args[2])
        elseif N > 2  # nary-addition
            op = :sum
        end
    elseif op == :- && N == 1
        op = :neg
    elseif op == :* && N > 2  # nary-multiplication.
        # NL doesn't define an nary multiplication operator, so we need to
        # rewrite our expression as a sequence of chained binary operators.
        while N > 2
            # Combine last term with previous to form a binary * expression
            arg = pop!(args)
            args[end] = Expr(:call, :*, args[end], arg)
            N = length(args) - 1
        end
    elseif op == :* && N == 1
        # unary multiplication: we can drop the op and process the args.
        return _process_expr!(expr, args[2])
    end
    # Now convert the Julia expression into an _NLExpr.
    opcode = get(_JULIA_TO_AMPL, op, nothing)
    if opcode === nothing
        throw(MOI.UnsupportedNonlinearOperator(op))
    end
    if op == :atan && N == 2
        # Special case binary use of atan, because Julia uses method overloading
        # instead of having an explicit atan2 function.
        opcode = OP_atan2
    end
    push!(expr.nonlinear_terms, opcode)
    if opcode in _NARY_OPCODES
        push!(expr.nonlinear_terms, N)
    end
    for i in 1:N
        _process_expr!(expr, args[i+1])
    end
    return
end

### ============================================================================
### Evaluate nonlinear expressions
### ============================================================================

function _evaluate(expr::_NLExpr, x::Dict{MOI.VariableIndex,Float64})
    y = expr.constant
    for (v, c) in expr.linear_terms
        y += c * x[v]
    end
    if length(expr.nonlinear_terms) > 0
        ret, n = _evaluate(expr.nonlinear_terms[1], expr.nonlinear_terms, x, 1)
        @assert n == length(expr.nonlinear_terms) + 1
        y += ret
    end
    return y
end

function _evaluate(
    head::MOI.VariableIndex,
    ::Vector{_NLTerm},
    x::Dict{MOI.VariableIndex,Float64},
    head_i::Int,
)::Tuple{Float64,Int}
    return x[head], head_i + 1
end

function _evaluate(
    head::Float64,
    ::Vector{_NLTerm},
    ::Dict{MOI.VariableIndex,Float64},
    head_i::Int,
)::Tuple{Float64,Int}
    return head, head_i + 1
end

function _evaluate(
    head::Int,
    terms::Vector{_NLTerm},
    x::Dict{MOI.VariableIndex,Float64},
    head_i::Int,
)::Tuple{Float64,Int}
    N, f = _AMPL_TO_JULIA[head]
    is_nary = (N == -1)
    head_i += 1
    if is_nary
        N = terms[head_i]::Int
        head_i += 1
    end
    args = Vector{Float64}(undef, N)
    for n in 1:N
        args[n], head_i = _evaluate(terms[head_i], terms, x, head_i)
    end
    # A few special cases to work-around domain issues and other mistakes.
    if f === ifelse
        # ifelse requires ::Bool as the first argument, not ::Float64.
        @assert N == 3
        return ifelse(Bool(args[1]), args[2], args[3]), head_i
    elseif f === ^
        return NaNMath.pow(args...), head_i
    elseif f === log
        return NaNMath.log(args...), head_i
    end
    return is_nary ? f(args) : f(args...), head_i
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestObjectiveVectorSlack

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.VectorSlackBridge,
        """
        variables: x
        minobjective: [1.1 * x + 2.2]
        """,
        """
        variables: x, y
        minobjective: [y]
        [1.0 * y + -1.1 * x + -2.2] in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.VectorSlackBridge,
        """
        variables: x
        maxobjective: [1.1 * x + 2.2]
        """,
        """
        variables: x, y
        maxobjective: [y]
        [-1.0 * y + 1.1 * x + 2.2] in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.VectorSlackBridge,
        """
        variables: x
        minobjective: [1.1 * x + 2.2, -1.0 * x]
        """,
        """
        variables: x, y, z
        minobjective: [y, z]
        [1.0 * y + -1.1 * x + -2.2, 1.0 * z + 1.0 * x] in Nonnegatives(2)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.VectorSlackBridge,
        """
        variables: x
        maxobjective: [1.1 * x + 2.2, -1.0 * x]
        """,
        """
        variables: x, y, z
        maxobjective: [y, z]
        [-1.0 * y + 1.1 * x + 2.2, -1.0 * z + -1.0 * x] in Nonnegatives(2)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.VectorSlackBridge,
        """
        variables: x
        maxobjective: [1.0 * x, -1.1 * x]
        """,
        """
        variables: x, y
        maxobjective: [x, y]
        [-1.0 * y + -1.1 * x] in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.VectorSlackBridge,
        """
        variables: x
        minobjective: [-1.1 * x, 1.0 * x]
        """,
        """
        variables: x, y
        minobjective: [y, x]
        [1.0 * y + 1.1 * x] in Nonnegatives(1)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Objective.VectorSlackBridge,
        """
        variables: x
        maxobjective: [x]
        """,
        """
        variables: x
        maxobjective: [x]
        """,
    )
    return
end

function test_objective_sense_before_function()
    inner = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Bridges.Objective.VectorSlack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.Utilities.operate(vcat, Float64, 1.0 * x, 1.0 * x)
    attr = MOI.ObjectiveFunction{typeof(f)}()
    @test_throws(
        MOI.SetAttributeNotAllowed(
            attr,
            "Set `MOI.ObjectiveSense` before `MOI.ObjectiveFunction` when " *
            "using `MOI.Bridges.Objective.VectorSlackBridge`.",
        ),
        MOI.set(model, attr, f),
    )
    return
end

function test_objective_function_value()
    for sense in ("min", "max")
        inner = MOI.Utilities.MockOptimizer(
            MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        )
        model = MOI.Bridges.Objective.VectorSlack{Float64}(inner)
        MOI.Utilities.loadfromstring!(
            model,
            """
            variables: x
            $(sense)objective: [1.1 * x + 2.2, -1.0 * x]
            """,
        )
        MOI.Utilities.set_mock_optimize!(
            inner,
            mock -> MOI.Utilities.mock_optimize!(mock, [3.0, 5.6, -3.0]),
        )
        MOI.optimize!(model)
        # Test that we get 5.5 here, not 5.6 as set for the slack variable. This
        # ensures we return the value of the f(x) objective, not the `y` slack.
        @test MOI.get(model, MOI.ObjectiveValue()) ≈ [5.5, -3.0]
    end
    return
end

function test_modify_vector_constant_change()
    inner = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    model = MOI.Bridges.Objective.VectorSlack{Float64}(inner)
    x = MOI.add_variable(model)
    f = MOI.Utilities.operate(vcat, Float64, -1.1 * x, 1.0 * x)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    attr = MOI.ObjectiveFunction{typeof(f)}()
    MOI.set(model, attr, f)
    @test MOI.get(model, attr) ≈ f
    @test_throws(
        MOI.ModifyObjectiveNotAllowed,
        MOI.modify(model, attr, MOI.VectorConstantChange([1.0, 2.0])),
    )
    return
end

function test_SlackBridge_ObjectiveFunctionValue_2()
    inner = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    model = MOI.Bridges.Objective.VectorSlack{Float64}(inner)
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(1.0))
    f = MOI.Utilities.operate(vcat, Float64, 1.1 * x - 1.2)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.Utilities.set_mock_optimize!(
        inner,
        mock -> begin
            MOI.set(mock, MOI.ResultCount(), 2)
            MOI.set(mock, MOI.TerminationStatus(), MOI.OPTIMAL)
            MOI.set(mock, MOI.PrimalStatus(1), MOI.FEASIBLE_POINT)
            MOI.set(mock, MOI.PrimalStatus(2), MOI.FEASIBLE_POINT)
            y = MOI.get(mock, MOI.ListOfVariableIndices())
            MOI.set.(mock, MOI.VariablePrimal(1), y, [1.0, -0.1])
            MOI.set.(mock, MOI.VariablePrimal(2), y, [2.0, 1.0])
        end,
    )
    MOI.optimize!(model)
    @test MOI.get(model, MOI.ObjectiveValue(1)) ≈ [-0.1]
    @test MOI.get(model, MOI.VariablePrimal(1), x) ≈ 1.0
    @test MOI.get(model, MOI.ObjectiveValue(2)) ≈ [1.0]
    @test MOI.get(model, MOI.VariablePrimal(2), x) ≈ 2.0
    return
end

end  # module

TestObjectiveVectorSlack.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module Utilities

import LinearAlgebra
import MathOptInterface as MOI
import MutableArithmetics as MA
import OrderedCollections: OrderedDict
import SparseArrays

function print_with_acronym(io::IO, s::AbstractString)
    return print(io, replace_acronym(s))
end

function replace_acronym(s::AbstractString)
    s = replace(s, "MathOptInterface.Utilities" => "MOIU")
    s = replace(s, "MathOptInterface.Bridges" => "MOIB")
    s = replace(s, "MathOptInterface.Test" => "MOIT")
    s = replace(s, "MathOptInterface" => "MOI")
    return s
end

"""
    _reverse_dict(src::AbstractDict)

Reverse dictionary `src` so that values of the new dictionary are keys of `src`
and vice-versa. Also the values of `src` are assumed to be unique.

    _reverse_dict(dest::AbstractDict, src::AbstractDict)

Reverse dictionary so that values of `src` are key of `dest` and vice-versa.
`dest` must be empty. Also the values of `src` are assumed to be unique.
"""
function _reverse_dict end

include("CleverDicts.jl")
include("DoubleDicts.jl")

include("functions.jl")
include("mutable_arithmetics.jl")
include("sets.jl")
include("constraints.jl")
include("copy.jl")
include("results.jl")
include("variables.jl")

include("promote_operation.jl")
include("operate.jl")

include("objective_container.jl")
include("variables_container.jl")
include("free_variables.jl")
include("vector_of_constraints.jl")
include("struct_of_constraints.jl")
include("model.jl")
include("sparse_matrix.jl")
include("product_of_sets.jl")
include("matrix_of_constraints.jl")
include("parser.jl")
include("mockoptimizer.jl")
include("cachingoptimizer.jl")
include("universalfallback.jl")
include("print.jl")
include("penalty_relaxation.jl")
include("lazy_iterators.jl")
include("set_dot.jl")

include("distance_to_set.jl")

end # module

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Variables

"""
    struct AddVariableNotAllowed <: NotAllowedError
        message::String # Human-friendly explanation why the attribute cannot be set
    end

An error indicating that variables cannot be added to the model.
"""
struct AddVariableNotAllowed <: NotAllowedError
    message::String # Human-friendly explanation why the attribute cannot be set
end

AddVariableNotAllowed() = AddVariableNotAllowed("")

operation_name(::AddVariableNotAllowed) = "Adding variables"

"""
    add_variables(model::ModelLike, n::Int)::Vector{VariableIndex}

Add `n` scalar variables to the model, returning a vector of variable indices.

An [`AddVariableNotAllowed`](@ref) error is thrown if adding variables cannot be
done in the current state of the model `model`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> MOI.add_variables(model, 2)
2-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)
```
"""
function add_variables(model::ModelLike, n)
    return VariableIndex[add_variable(model) for _ in 1:n]
end

"""
    add_variable(model::ModelLike)::VariableIndex

Add a scalar variable to the model, returning a variable index.

A [`AddVariableNotAllowed`](@ref) error is thrown if adding variables cannot be
done in the current state of the model `model`.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)
```
"""
add_variable(model::ModelLike) = throw(AddVariableNotAllowed())

"""
    supports_add_constrained_variable(
        model::ModelLike,
        S::Type{<:AbstractScalarSet}
    )::Bool

Return a `Bool` indicating whether `model` supports constraining a variable
to belong to a set of type `S` either on creation of the variable with
[`add_constrained_variable`](@ref) or after the variable is created with
[`add_constraint`](@ref).

By default, this function falls back to
`supports_add_constrained_variables(model, Reals) &&
supports_constraint(model, MOI.VariableIndex, S)` which is the correct
definition for most models.

## Example

Suppose that a solver supports only two kind of variables: binary variables
and continuous variables with a lower bound. If the solver decides not to
support `VariableIndex`-in-`Binary` and `VariableIndex`-in-`GreaterThan`
constraints, it only has to implement `add_constrained_variable` for these
two sets which prevents the user to add both a binary constraint and a
lower bound on the same variable. Moreover, if the user adds a
`VariableIndex`-in-`GreaterThan` constraint, implementing this interface (that is,
`supports_add_constrained_variables`) enables the constraint to be transparently
bridged into a supported constraint.
"""
function supports_add_constrained_variable(
    model::ModelLike,
    S::Type{<:AbstractScalarSet},
)
    return supports_add_constrained_variables(model, Reals) &&
           supports_constraint(model, VariableIndex, S)
end

"""
    add_constrained_variable(
        model::ModelLike,
        set::AbstractScalarSet
    )::Tuple{MOI.VariableIndex,
             MOI.ConstraintIndex{MOI.VariableIndex, typeof(set)}}

Add to `model` a scalar variable constrained to belong to `set`, returning the
index of the variable created and the index of the constraint constraining the
variable to belong to `set`.

By default, this function falls back to creating a free variable with
[`add_variable`](@ref) and then constraining it to belong to `set` with
[`add_constraint`](@ref).
"""
function add_constrained_variable(model::ModelLike, set::AbstractScalarSet)
    variable = add_variable(model)
    constraint = add_constraint(model, variable, set)
    return variable, constraint
end

"""
    add_constrained_variable(
        model::ModelLike,
        set::Tuple{<:GreaterThan,<:LessThan},
    )

A special-case method to add a scalar variable with a lower and upper bound.

This method should be implemented by optimizers which have native support for
adding a variable with bounds and which cannot performantly modify the variable
bounds after creation.

## Example

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> set = (MOI.GreaterThan(1.0), MOI.LessThan(2.0));

julia> x, (c_l, c_u) = MOI.add_constrained_variable(model, set);

julia> c_l
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.GreaterThan{Float64}}(1)

julia> c_u
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.LessThan{Float64}}(1)

julia> print(model)
Feasibility

Subject to:

VariableIndex-in-GreaterThan{Float64}
 v[1] >= 1.0

VariableIndex-in-LessThan{Float64}
 v[1] <= 2.0
```
"""
function add_constrained_variable(
    model::ModelLike,
    set::Tuple{<:GreaterThan,<:LessThan},
)
    set_1, set_2 = set
    x, c_1 = add_constrained_variable(model, set_1)
    c_2 = add_constraint(model, x, set_2)
    return x, (c_1, c_2)
end

function supports_add_constrained_variable(
    model::ModelLike,
    ::Type{Tuple{L,U}},
) where {L<:GreaterThan,U<:LessThan}
    return supports_add_constrained_variable(model, L) &&
           supports_constraint(model, VariableIndex, U)
end

"""
    supports_add_constrained_variables(
        model::ModelLike,
        S::Type{<:AbstractVectorSet}
    )::Bool

Return a `Bool` indicating whether `model` supports constraining a vector of
variables to belong to a set of type `S` either on creation of the vector of
variables with [`add_constrained_variables`](@ref) or after the variable is
created with [`add_constraint`](@ref).

By default, if `S` is `Reals` then this function returns `true` and otherwise,
it falls back to `supports_add_constrained_variables(model, Reals) &&
supports_constraint(model, MOI.VectorOfVariables, S)` which is the correct
definition for most models.

## Example

In the standard conic form (see [Duality](@ref)), the variables are grouped into
several cones and the constraints are affine equality constraints.
If `Reals` is not one of the cones supported by the solvers then it needs
to implement `supports_add_constrained_variables(::Optimizer, ::Type{Reals}) = false`
as free variables are not supported.
The solvers should then implement
`supports_add_constrained_variables(::Optimizer, ::Type{<:SupportedCones}) = true`
where `SupportedCones` is the union of all cone types that are supported;
it does not have to implement the method
`supports_constraint(::Type{VectorOfVariables}, Type{<:SupportedCones})`
as it should return `false` and it's the default.
This prevents the user to constrain the same variable in two different cones.
When a `VectorOfVariables`-in-`S` is added, the variables of the vector
have already been created so they already belong to given cones.
If bridges are enabled, the constraint will therefore be bridged by adding slack
variables in `S` and equality constraints ensuring that the slack variables are
equal to the corresponding variables of the given constraint function.

Note that there may also be sets for which
`!supports_add_constrained_variables(model, S)` and
`supports_constraint(model, MOI.VectorOfVariables, S)`.
For instance, suppose a solver supports positive semidefinite variable
constraints and two types of variables: binary variables and nonnegative
variables. Then the solver should support adding
`VectorOfVariables`-in-`PositiveSemidefiniteConeTriangle` constraints, but it
should not support creating variables constrained to belong to the
`PositiveSemidefiniteConeTriangle` because the variables in
`PositiveSemidefiniteConeTriangle` should first be created as either binary or
non-negative.
"""
function supports_add_constrained_variables(
    model::ModelLike,
    S::Type{<:AbstractVectorSet},
)
    return supports_add_constrained_variables(model, Reals) &&
           supports_constraint(model, VectorOfVariables, S)
end
supports_add_constrained_variables(::ModelLike, ::Type{Reals}) = true

"""
    add_constrained_variables(
        model::ModelLike,
        sets::AbstractVector{<:AbstractScalarSet}
    )::Tuple{
        Vector{MOI.VariableIndex},
        Vector{MOI.ConstraintIndex{MOI.VariableIndex,eltype(sets)}},
    }

Add to `model` scalar variables constrained to belong to `sets`, returning the
indices of the variables created and the indices of the constraints constraining
the variables to belong to each set in `sets`. That is, if it returns `variables`
and `constraints`, `constraints[i]` is the index of the constraint constraining
`variable[i]` to belong to `sets[i]`.

By default, this function falls back to calling
[`add_constrained_variable`](@ref) on each set.
"""
function add_constrained_variables(
    model::ModelLike,
    sets::AbstractVector{<:AbstractScalarSet},
)
    variables = Vector{VariableIndex}(undef, length(sets))
    constraints =
        Vector{ConstraintIndex{VariableIndex,eltype(sets)}}(undef, length(sets))
    for (i, set) in enumerate(sets)
        variables[i], constraints[i] = add_constrained_variable(model, set)
    end
    return variables, constraints
end

"""
    add_constrained_variables(
        model::ModelLike,
        set::AbstractVectorSet,
    )::Tuple{
        Vector{MOI.VariableIndex},
        MOI.ConstraintIndex{MOI.VectorOfVariables,typeof(set)},
    }

Add to `model` a vector of variables constrained to belong to `set`, returning
the indices of the variables created and the index of the constraint
constraining the vector of variables to belong to `set`.

By default, this function falls back to creating free variables with
[`add_variables`](@ref) and then constraining it to belong to `set` with
[`add_constraint`](@ref).
"""
function add_constrained_variables(model::ModelLike, set::AbstractVectorSet)
    variables = add_variables(model, dimension(set))
    constraint = add_constraint(model, VectorOfVariables(variables), set)
    return variables, constraint
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintNormSpectral

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_NormSpectral()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.NormSpectral{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariables_NormSpectralCone",
            "test_basic_VectorAffineFunction_NormSpectralCone",
            "test_basic_VectorQuadraticFunction_NormSpectralCone",
        ],
    )
    MOI.empty!(bridged_mock)
    inv6 = inv(6)
    rt3 = sqrt(3)
    invrt12 = inv(2 * rt3)
    psd_dual = [
        inv6,
        -invrt12,
        inv6,
        invrt12,
        -invrt12,
        inv6,
        0,
        0,
        0,
        0,
        -invrt12,
        invrt12,
        -invrt12,
        0,
        0.5,
    ]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [rt3],
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [psd_dual],
        )
    MOI.Test.test_conic_NormSpectralCone(bridged_mock, config)
    var_names = ["t"]
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    psd = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.PositiveSemidefiniteConeTriangle,
        }(),
    )
    @test length(psd) == 1
    MOI.set(mock, MOI.ConstraintName(), psd[1], "psd")

    s = """
    variables: t
    psd: [t, 0.0, t, 0.0, 0.0, t, 1.0, 1.0, 0.0, t, 1.0, -1.0, 1.0, 0.0, t] in PositiveSemidefiniteConeTriangle(5)
    minobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(mock, model, var_names, ["psd"])
    spec = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.NormSpectralCone,
        }(),
    )
    @test length(spec) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), spec[1], "spec")

    s = """
    variables: t
    spec: [t, 1.0, 1.0, 1.0, -1.0, 0.0, 1.0] in NormSpectralCone(2, 3)
    minobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(bridged_mock, model, var_names, ["spec"])
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.NormSpectralCone,
            }(),
        ),
    )
    attr = MOI.ConstraintPrimalStart()
    @test MOI.supports(bridged_mock, attr, typeof(ci))
    value = Float64[4, 1, 1, 1, -1, 0, 1]
    MOI.set(bridged_mock, attr, ci, value)
    @test MOI.get(bridged_mock, attr, ci) ≈ value
    @test MOI.get(mock, attr, psd[1]) ==
          Float64[4, 0, 4, 0, 0, 4, 1, 1, 0, 4, 1, -1, 1, 0, 4]
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        ((
            MOI.VectorAffineFunction{Float64},
            MOI.PositiveSemidefiniteConeTriangle,
            0,
        ),),
    )
    return
end

function test_NormNuclear()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
    )
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.NormNuclear{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariables_NormNuclearCone",
            "test_basic_VectorAffineFunction_NormNuclearCone",
            "test_basic_VectorQuadraticFunction_NormNuclearCone",
        ],
    )
    MOI.empty!(bridged_mock)
    rt2 = sqrt(2)
    rt3 = sqrt(3)
    invrt2 = inv(rt2)
    invrt3 = inv(rt3)
    var_primal = [
        rt2 + rt3,
        invrt2 + invrt3,
        invrt2 - invrt3,
        invrt2 + invrt3,
        invrt3,
        -invrt3,
        invrt3,
        rt2,
        0,
        rt3,
    ]
    invrt8 = inv(sqrt(8))
    invrt12 = inv(sqrt(12))
    psd_dual = [
        0.5,
        0,
        0.5,
        0,
        0,
        0.5,
        -invrt8,
        -invrt8,
        0,
        invrt8,
        -invrt12,
        invrt12,
        -invrt12,
        0,
        0.5,
    ]
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            var_primal,
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}) =>
                [1.0],
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [psd_dual],
        )
    MOI.Test.test_conic_NormNuclearCone(bridged_mock, config)
    greater = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.ScalarAffineFunction{Float64},
            MOI.GreaterThan{Float64},
        }(),
    )
    psd = MOI.get(
        mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.PositiveSemidefiniteConeTriangle,
        }(),
    )
    var_names =
        ["t", "U11", "U12", "U22", "U31", "U32", "U33", "V11", "V12", "V22"]
    MOI.set(
        mock,
        MOI.VariableName(),
        MOI.get(mock, MOI.ListOfVariableIndices()),
        var_names,
    )
    @test length(greater) == 1
    MOI.set(mock, MOI.ConstraintName(), greater[1], "greater")
    @test length(psd) == 1
    MOI.set(mock, MOI.ConstraintName(), psd[1], "psd")

    s = """
    variables: t, U11, U12, U22, U31, U32, U33, V11, V12, V22
    greater: t + -0.5U11 + -0.5U22 + -0.5U33 + -0.5V11 + -0.5V22 >= 0.0
    psd: [U11, U12, U22, U31, U32, U33, 1.0, 1.0, 0.0, V11, 1.0, -1.0, 1.0, V12, V22] in PositiveSemidefiniteConeTriangle(5)
    minobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(mock, model, var_names, ["greater", "psd"])
    MOI.set(
        bridged_mock,
        MOI.VariableName(),
        MOI.get(bridged_mock, MOI.ListOfVariableIndices()),
        ["t"],
    )
    nuc = MOI.get(
        bridged_mock,
        MOI.ListOfConstraintIndices{
            MOI.VectorAffineFunction{Float64},
            MOI.NormNuclearCone,
        }(),
    )
    @test length(nuc) == 1
    MOI.set(bridged_mock, MOI.ConstraintName(), nuc[1], "nuc")

    s = """
    variables: t
    nuc: [t, 1.0, 1.0, 1.0, -1.0, 0.0, 1.0] in NormNuclearCone(2, 3)
    minobjective: t
    """
    model = MOI.Utilities.Model{Float64}()
    MOI.Utilities.loadfromstring!(model, s)
    MOI.Test.util_test_models_equal(bridged_mock, model, ["t"], ["nuc"])
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.NormNuclearCone,
            }(),
        ),
    )
    attr = MOI.ConstraintDualStart()
    @test MOI.supports(bridged_mock, attr, typeof(ci))
    value = Float64[4, 1, 1, 1, -1, 0, 1]
    MOI.set(bridged_mock, attr, ci, value)
    @test MOI.get(bridged_mock, attr, ci) ≈ value
    @test MOI.get(mock, attr, greater[1]) == 4
    @test MOI.get(mock, attr, psd[1]) ==
          Float64[4, 0, 4, 0, 0, 4, 0.5, 0.5, 0, 4, 0.5, -0.5, 0.5, 0, 4]
    _test_delete_bridge(
        bridged_mock,
        ci,
        1,
        (
            (MOI.ScalarAffineFunction{Float64}, MOI.GreaterThan{Float64}, 0),
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
                0,
            ),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NormSpectralBridge,
        """
        variables: t, x11, x12, x21, x22
        [t, x11, x21, x12, x22] in NormSpectralCone(2, 2)
        """,
        """
        variables: t, x11, x12, x21, x22
        [t, 0, t, x11, x12, t, x21, x22, 0, t] in PositiveSemidefiniteConeTriangle(4)
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.NormNuclearBridge,
        """
        variables: t, x11, x12, x21, x22
        [t, x11, x21, x12, x22] in NormNuclearCone(2, 2)
        """,
        """
        variables: t, x11, x12, x21, x22, u1, u2, u3, v1, v2, v3
        t + -0.5 * u1 + -0.5 * u3 + -0.5 * v1 + -0.5 * v3 >= 0.0
        [u1, u2, u3, x11, x12, v1, x21, x22, v2, v3] in PositiveSemidefiniteConeTriangle(4)
        """,
    )
    return
end

end  # module

TestConstraintNormSpectral.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module LP

import ..FileFormats
import MathOptInterface as MOI

const _ILT1{T} = MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.LessThan{T}}
const _IGT1{T} = MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.GreaterThan{T}}
const _IET1{T} = MOI.Indicator{MOI.ACTIVATE_ON_ONE,MOI.EqualTo{T}}
const _ILT0{T} = MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.LessThan{T}}
const _IGT0{T} = MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.GreaterThan{T}}
const _IET0{T} = MOI.Indicator{MOI.ACTIVATE_ON_ZERO,MOI.EqualTo{T}}

MOI.Utilities.@model(
    Model,
    (MOI.ZeroOne, MOI.Integer),
    (MOI.EqualTo, MOI.GreaterThan, MOI.LessThan, MOI.Interval),
    (),
    (MOI.SOS1, MOI.SOS2, _ILT1, _IET1, _IGT1, _ILT0, _IGT0, _IET0),
    (),
    (MOI.ScalarQuadraticFunction, MOI.ScalarAffineFunction),
    (MOI.VectorOfVariables,),
    (MOI.VectorAffineFunction,)
)

function MOI.supports_constraint(
    ::Model,
    ::Type{MOI.VariableIndex},
    ::Type{<:Union{MOI.Parameter,MOI.Semicontinuous,MOI.Semiinteger}},
)
    return false
end

function MOI.supports_constraint(
    ::Model{T},
    ::Type{MOI.VectorAffineFunction{T}},
    ::Type{MOI.SOS1{T}},
) where {T}
    return false
end

function MOI.supports_constraint(
    ::Model{T},
    ::Type{MOI.VectorAffineFunction{T}},
    ::Type{MOI.SOS2{T}},
) where {T}
    return false
end

MOI.supports(::Model, ::MOI.ObjectiveFunction) = false

function MOI.supports(
    ::Model{T},
    ::MOI.ObjectiveFunction{
        <:Union{
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{T},
            MOI.ScalarQuadraticFunction{T},
        },
    },
) where {T}
    return true
end

struct Options
    maximum_length::Int
    warn::Bool
end

function get_options(m::Model)
    default_options = Options(255, false)
    return get(m.ext, :LP_OPTIONS, default_options)
end

"""
    Model(;
        maximum_length::Int = 255,
        warn::Bool = false,
        coefficient_type::Type{T} = Float64,
    ) where {T}

Create an empty instance of FileFormats.LP.Model.

Keyword arguments are:

 - `maximum_length::Int=255`: the maximum length for the name of a variable.
   lp_solve 5.0 allows only 16 characters, while CPLEX 12.5+ allow 255.

 - `warn::Bool=false`: print a warning when variables or constraints are renamed.

 - `coefficient_type::Type{T} = Float64`: the supported type to use when reading
   and writing files.
"""
function Model(;
    maximum_length::Int = 255,
    warn::Bool = false,
    coefficient_type::Type{T} = Float64,
) where {T}
    model = Model{T}()
    options = Options(maximum_length, warn)
    model.ext[:LP_OPTIONS] = options
    return model
end

Base.summary(io::IO, ::Model) = print(io, "MOI.FileFormats.LP.Model")

include("read.jl")
include("write.jl")

end  # module LP

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

"""
    parse_expression(data::Model, input)::Expression

Parse `input` into a [`Expression`](@ref).
"""
function parse_expression(data::Model, input)
    expr = Expression()
    parse_expression(data, expr, input, -1)
    return expr
end

"""
    parse_expression(
        data::Model,
        expr::Expression,
        input::Any,
        parent_index::Int,
    )::Expression

Parse `input` into a [`Expression`](@ref), and add it to `expr` as a
child of `expr.nodes[parent_index]`. Existing subexpressions and parameters are
stored in `data`.

You can extend parsing support to new types of objects by overloading this
method with a different type on `input::Any`.
"""
function parse_expression(::Model, ::Expression, x::Any, ::Int)
    return error(
        "Unexpected object $x of type $(typeof(x)) in nonlinear expression.",
    )
end

function parse_expression(
    data::Model,
    expr::Expression,
    x::MOI.ScalarNonlinearFunction,
    parent_index::Int,
)
    stack = Tuple{Int,Any}[(parent_index, x)]
    while !isempty(stack)
        parent_node, arg = pop!(stack)
        if arg isa MOI.ScalarNonlinearFunction
            _parse_without_recursion_inner(stack, data, expr, arg, parent_node)
        else
            # We can use recursion here, because ScalarNonlinearFunction only
            # occur in other ScalarNonlinearFunction.
            parse_expression(data, expr, arg, parent_node)
        end
    end
    return
end

function _get_node_type(data, x)
    id = get(data.operators.univariate_operator_to_id, x.head, nothing)
    if length(x.args) == 1 && id !== nothing
        return id, MOI.Nonlinear.NODE_CALL_UNIVARIATE
    end
    id = get(data.operators.multivariate_operator_to_id, x.head, nothing)
    if id !== nothing
        return id, MOI.Nonlinear.NODE_CALL_MULTIVARIATE
    end
    id = get(data.operators.comparison_operator_to_id, x.head, nothing)
    if id !== nothing
        return id, MOI.Nonlinear.NODE_COMPARISON
    end
    id = get(data.operators.logic_operator_to_id, x.head, nothing)
    if id !== nothing
        return id, MOI.Nonlinear.NODE_LOGIC
    end
    return throw(MOI.UnsupportedNonlinearOperator(x.head))
end

function _parse_without_recursion_inner(stack, data, expr, x, parent)
    id, node_type = _get_node_type(data, x)
    push!(expr.nodes, Node(node_type, id, parent))
    parent = length(expr.nodes)
    # Args need to be pushed onto the stack in reverse because the stack is a
    # first-in last-out datastructure.
    for arg in reverse(x.args)
        push!(stack, (parent, arg))
    end
    return
end

function parse_expression(
    data::Model,
    expr::Expression,
    x::Expr,
    parent_index::Int,
)
    stack = Tuple{Int,Any}[]
    push!(stack, (parent_index, x))
    while !isempty(stack)
        parent, item = pop!(stack)
        if item isa Expr
            _parse_expression(stack, data, expr, item, parent)
        else
            parse_expression(data, expr, item, parent)
        end
    end
    return
end

function _parse_expression(stack, data, expr, x, parent_index)
    if Meta.isexpr(x, :call)
        if length(x.args) == 2 && !Meta.isexpr(x.args[2], :...)
            _parse_univariate_expression(stack, data, expr, x, parent_index)
        else
            # The call is either n-ary, or it is a splat, in which case we
            # cannot tell just yet whether the expression is unary or nary.
            # Punt to multivariate and try to recover later.
            _parse_multivariate_expression(stack, data, expr, x, parent_index)
        end
    elseif Meta.isexpr(x, :comparison)
        _parse_comparison_expression(stack, data, expr, x, parent_index)
    elseif Meta.isexpr(x, :...)
        _parse_splat_expression(stack, data, expr, x, parent_index)
    elseif Meta.isexpr(x, :&&) || Meta.isexpr(x, :||)
        _parse_logic_expression(stack, data, expr, x, parent_index)
    else
        error("Unsupported expression: $x")
    end
end

function _parse_splat_expression(stack, data, expr, x, parent_index)
    @assert Meta.isexpr(x, :...) && length(x.args) == 1
    if parent_index == -1
        error(
            "Unsupported use of the splatting operator. This is only " *
            "supported in the arguments of a function call.",
        )
    elseif x.args[1] isa Expr
        error(
            "Unsupported use of the splatting operator. JuMP supports " *
            "splatting only symbols. For example, `x...` is ok, but " *
            "`(x + 1)...`, `[x; y]...` and `g(f(y)...)` are not.",
        )
    end
    for arg in Iterators.Reverse(x.args[1])
        push!(stack, (parent_index, arg))
    end
    return
end

function _parse_univariate_expression(
    stack::Vector{Tuple{Int,Any}},
    data::Model,
    expr::Expression,
    x::Expr,
    parent_index::Int,
)
    @assert Meta.isexpr(x, :call, 2)
    id = get(data.operators.univariate_operator_to_id, x.args[1], nothing)
    if id === nothing
        # It may also be a multivariate operator like * with one argument.
        if haskey(data.operators.multivariate_operator_to_id, x.args[1])
            _parse_multivariate_expression(stack, data, expr, x, parent_index)
            return
        end
        throw(MOI.UnsupportedNonlinearOperator(x.args[1]))
    end
    push!(expr.nodes, Node(NODE_CALL_UNIVARIATE, id, parent_index))
    push!(stack, (length(expr.nodes), x.args[2]))
    return
end

function _parse_multivariate_expression(
    stack::Vector{Tuple{Int,Any}},
    data::Model,
    expr::Expression,
    x::Expr,
    parent_index::Int,
)
    @assert Meta.isexpr(x, :call)
    id = get(data.operators.multivariate_operator_to_id, x.args[1], nothing)
    if id === nothing
        if haskey(data.operators.univariate_operator_to_id, x.args[1])
            # It may also be a unary variate operator with splatting.
            _parse_univariate_expression(stack, data, expr, x, parent_index)
        elseif x.args[1] in data.operators.comparison_operators
            # Or it may be a binary (in)equality operator.
            _parse_inequality_expression(stack, data, expr, x, parent_index)
        else
            throw(MOI.UnsupportedNonlinearOperator(x.args[1]))
        end
        return
    end
    push!(expr.nodes, Node(NODE_CALL_MULTIVARIATE, id, parent_index))
    for i in length(x.args):-1:2
        push!(stack, (length(expr.nodes), x.args[i]))
    end
    return
end

# This function parses single inequalities like `a <= b`. It's not to be
# confused with `_parse_comparison_expression`, which handles things like
# `a <= b <= c`.
function _parse_inequality_expression(
    stack::Vector{Tuple{Int,Any}},
    data::Model,
    expr::Expression,
    x::Expr,
    parent_index::Int,
)
    operator_id = data.operators.comparison_operator_to_id[x.args[1]]
    push!(expr.nodes, Node(NODE_COMPARISON, operator_id, parent_index))
    for i in length(x.args):-1:2
        push!(stack, (length(expr.nodes), x.args[i]))
    end
    return
end

# This function parses double inequalities like `a <= b <= c`. It's not to be
# confused with `_parse_inequality_expression`, which handles things like
# `a <= b`.
function _parse_comparison_expression(
    stack::Vector{Tuple{Int,Any}},
    data::Model,
    expr::Expression,
    x::Expr,
    parent_index::Int,
)
    for k in 2:2:(length(x.args)-1)
        @assert x.args[k] == x.args[2] # don't handle a <= b >= c
    end
    operator_id = data.operators.comparison_operator_to_id[x.args[2]]
    push!(expr.nodes, Node(NODE_COMPARISON, operator_id, parent_index))
    for i in length(x.args):-2:1
        push!(stack, (length(expr.nodes), x.args[i]))
    end
    return
end

function _parse_logic_expression(
    stack::Vector{Tuple{Int,Any}},
    data::Model,
    expr::Expression,
    x::Expr,
    parent_index::Int,
)
    id = data.operators.logic_operator_to_id[x.head]
    push!(expr.nodes, Node(NODE_LOGIC, id, parent_index))
    parent_var = length(expr.nodes)
    push!(stack, (parent_var, x.args[2]))
    push!(stack, (parent_var, x.args[1]))
    return
end

function parse_expression(
    ::Model,
    expr::Expression,
    x::MOI.VariableIndex,
    parent_index::Int,
)
    push!(expr.nodes, Node(NODE_MOI_VARIABLE, x.value, parent_index))
    return
end

function parse_expression(
    data::Model,
    expr::Expression,
    f::MOI.ScalarAffineFunction,
    parent_index::Int,
)
    if isempty(f.terms)
        parse_expression(data, expr, f.constant, parent_index)
        return
    elseif iszero(f.constant) && length(f.terms) == 1
        # Expression of for `a * x`
        parse_expression(data, expr, only(f.terms), parent_index)
        return
    end
    id_plus = data.operators.multivariate_operator_to_id[:+]
    push!(expr.nodes, Node(NODE_CALL_MULTIVARIATE, id_plus, parent_index))
    new_parent = length(expr.nodes)
    for term in f.terms
        parse_expression(data, expr, term, new_parent)
    end
    if !iszero(f.constant)
        parse_expression(data, expr, f.constant, new_parent)
    end
    return
end

function parse_expression(
    data::Model,
    expr::Expression,
    f::MOI.ScalarQuadraticFunction,
    parent_index::Int,
)
    if isempty(f.quadratic_terms) && isempty(f.affine_terms)
        parse_expression(data, expr, f.constant, parent_index)
        return
    elseif iszero(f.constant)
        if length(f.quadratic_terms) == 1 && isempty(f.affine_terms)
            parse_expression(data, expr, only(f.quadratic_terms), parent_index)
            return
        elseif isempty(f.quadratic_terms) && length(f.affine_terms) == 1
            parse_expression(data, expr, only(f.affine_terms), parent_index)
            return
        end
    end
    id_plus = data.operators.multivariate_operator_to_id[:+]
    push!(expr.nodes, Node(NODE_CALL_MULTIVARIATE, id_plus, parent_index))
    new_parent = length(expr.nodes)
    for term in f.quadratic_terms
        parse_expression(data, expr, term, new_parent)
    end
    for term in f.affine_terms
        parse_expression(data, expr, term, new_parent)
    end
    if !iszero(f.constant)
        parse_expression(data, expr, f.constant, new_parent)
    end
    return
end

function parse_expression(
    data::Model,
    expr::Expression,
    x::MOI.ScalarAffineTerm,
    parent_index::Int,
)
    if isone(x.coefficient)
        parse_expression(data, expr, x.variable, parent_index)
    else
        id_mul = data.operators.multivariate_operator_to_id[:*]
        push!(expr.nodes, Node(NODE_CALL_MULTIVARIATE, id_mul, parent_index))
        mul_parent = length(expr.nodes)
        parse_expression(data, expr, x.coefficient, mul_parent)
        parse_expression(data, expr, x.variable, mul_parent)
    end
    return
end

function parse_expression(
    data::Model,
    expr::Expression,
    x::MOI.ScalarQuadraticTerm,
    parent_index::Int,
)
    # There are four cases:
    #   (1): 1 * x * x  -->  ^(x, 2)
    #   (2): a * x * x  -->  *(a, ^(x, 2))
    #   (3): a * x * y  -->  *(a, x, y)
    #   (4): 1 * x * y  -->  *(x, y)
    if x.variable_1 == x.variable_2
        # Case (1): 1 * x * x  -->  ^(x, 2)
        # Case (2): a * x * x  -->  *(a, ^(x, 2))
        coef = x.coefficient / 2
        parent = parent_index
        if !isone(coef)
            id = data.operators.multivariate_operator_to_id[:*]
            push!(expr.nodes, Node(NODE_CALL_MULTIVARIATE, id, parent_index))
            parent = length(expr.nodes)
            parse_expression(data, expr, coef, parent)
            parent
        end
        id = data.operators.multivariate_operator_to_id[:^]
        push!(expr.nodes, Node(NODE_CALL_MULTIVARIATE, id, parent))
        pow_parent = length(expr.nodes)
        parse_expression(data, expr, x.variable_1, pow_parent)
        parse_expression(data, expr, 2, pow_parent)
    else
        # Case (3): a * x * y  -->  *(a, x, y)
        # Case (4): 1 * x * y  -->  *(x, y)
        id_mul = data.operators.multivariate_operator_to_id[:*]
        push!(expr.nodes, Node(NODE_CALL_MULTIVARIATE, id_mul, parent_index))
        mul_parent = length(expr.nodes)
        if !isone(x.coefficient)
            parse_expression(data, expr, x.coefficient, mul_parent)
        end
        parse_expression(data, expr, x.variable_1, mul_parent)
        parse_expression(data, expr, x.variable_2, mul_parent)
    end
    return
end

function parse_expression(::Model, expr::Expression, x::Real, parent_index::Int)
    push!(expr.values, convert(Float64, x)::Float64)
    push!(expr.nodes, Node(NODE_VALUE, length(expr.values), parent_index))
    return
end

function parse_expression(
    ::Model,
    expr::Expression,
    x::ParameterIndex,
    parent_index::Int,
)
    push!(expr.nodes, Node(NODE_PARAMETER, x.value, parent_index))
    return
end

function parse_expression(
    ::Model,
    expr::Expression,
    x::ExpressionIndex,
    parent_index::Int,
)
    push!(expr.nodes, Node(NODE_SUBEXPRESSION, x.value, parent_index))
    return
end

function parse_expression(
    ::Model,
    expr::Expression,
    x::AbstractArray,
    parent_index::Int,
)
    return error(
        "Unexpected array $x in nonlinear expression. Nonlinear expressions " *
        "may contain only scalar expressions.",
    )
end

"""
    convert_to_expr(data::Model, expr::Expression)

Convert the [`Expression`](@ref) `expr` into a Julia `Expr`.

 * subexpressions are represented by a [`ExpressionIndex`](@ref) object.
 * parameters are represented by a [`ParameterIndex`](@ref) object.
 * variables are represented by an [`MOI.VariableIndex`](@ref) object.
"""
function convert_to_expr(model::Model, expr::Expression)
    tree = Any[]
    for node in expr.nodes
        node_expr = if node.type == NODE_CALL_UNIVARIATE
            Expr(:call, model.operators.univariate_operators[node.index])
        elseif node.type == NODE_CALL_MULTIVARIATE
            Expr(:call, model.operators.multivariate_operators[node.index])
        elseif node.type == NODE_COMPARISON
            Expr(:call, model.operators.comparison_operators[node.index])
        elseif node.type == NODE_LOGIC
            Expr(model.operators.logic_operators[node.index])
        elseif node.type == NODE_MOI_VARIABLE
            MOI.VariableIndex(node.index)
        elseif node.type == NODE_PARAMETER
            ParameterIndex(node.index)
        elseif node.type == NODE_SUBEXPRESSION
            ExpressionIndex(node.index)
        else
            @assert node.type == NODE_VALUE
            expr.values[node.index]
        end
        if 1 <= node.parent <= length(tree)
            push!(tree[node.parent].args, node_expr)
        end
        push!(tree, node_expr)
    end
    return _replace_comparison(tree[1])
end

# TODO(odow): NODE_COMPARISON is a bit of a pain to deal with...
_replace_comparison(expr) = expr

function _replace_comparison(expr::Expr)
    if Meta.isexpr(expr, :call, 4) && expr.args[1] in (:<=, :>=, :(==), :<, :>)
        return Expr(
            :comparison,
            expr.args[2],
            expr.args[1],
            expr.args[3],
            expr.args[1],
            expr.args[4],
        )
    end
    for i in 1:length(expr.args)
        expr.args[i] = _replace_comparison(expr.args[i])
    end
    return expr
end

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestConstraintSquare

using Test

import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

include("../utilities.jl")

function test_Square()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    config = MOI.Test.Config()
    bridged_mock = MOI.Bridges.Constraint.Square{Float64}(mock)
    MOI.Test.runtests(
        bridged_mock,
        config,
        include = [
            "test_basic_VectorOfVariables_PositiveSemidefiniteConeSquare",
            "test_basic_VectorAffineFunction_PositiveSemidefiniteConeSquare",
            "test_basic_VectorQuadraticFunction_PositiveSemidefiniteConeSquare",
        ],
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            ones(4),
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [2, 2],
        )
    MOI.Test.test_conic_PositiveSemidefiniteConeSquare_VectorOfVariables(
        bridged_mock,
        config,
    )
    MOI.empty!(bridged_mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            ones(4),
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [[1, -1, 1]],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [2, 2],
        )
    MOI.Test.test_conic_PositiveSemidefiniteConeSquare_VectorAffineFunction(
        bridged_mock,
        config,
    )
    ci = first(
        MOI.get(
            bridged_mock,
            MOI.ListOfConstraintIndices{
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeSquare,
            }(),
        ),
    )
    _test_delete_bridge(
        bridged_mock,
        ci,
        4,
        (
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
                0,
            ),
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}, 1),
        ),
    )
    return
end

function test_runtests()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SquareBridge,
        """
        variables: x11, x21, x12, x22
        [x11, x21, x12, x22] in PositiveSemidefiniteConeSquare(2)
        """,
        """
        variables: x11, x21, x12, x22
        [x11, x12, x22] in PositiveSemidefiniteConeTriangle(2)
        x12 + -1.0 * x21 == 0.0
        """,
    )
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SquareBridge,
        """
        variables: x11, x12, x22
        [x11, x12, x12, x22] in PositiveSemidefiniteConeSquare(2)
        """,
        """
        variables: x11, x12, x22
        [x11, x12, x22] in PositiveSemidefiniteConeTriangle(2)
        """,
    )
    return
end

function test_symmetric_square()
    mock = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}())
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            ones(5),
            (
                MOI.VectorAffineFunction{Float64},
                MOI.PositiveSemidefiniteConeTriangle,
            ) => [[0.0, 0.0, 1.0, 0.0, 1.0, 1.0]],
        )
    model = MOI.Bridges.Constraint.Square{Float64}(mock)
    x = MOI.add_variables(model, 2)
    MOI.add_constraint.(model, x, MOI.GreaterThan(0.0))
    X = MOI.add_variables(model, 3)
    y = [1.0, x[1], x[2], x[1], X[1], X[2], x[2], X[2], X[3]]
    g = MOI.Utilities.operate(vcat, Float64, 1.0 * y...)
    c = MOI.add_constraint(model, g, MOI.PositiveSemidefiniteConeSquare(3))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = sum(1.0 * x) + sum(1.0 * X) + X[2]
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.optimize!(model)
    dual = MOI.get(model, MOI.ConstraintDual(), c)
    @test reshape(dual, 3, 3) == Float64[0 0 0; 0 1 1; 0 1 1]
    return
end

function test_runtests_symmetric_logdet()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SquareBridge,
        """
        variables: t, u, x11, x21, x22
        [t, u, x11, x21, x21, x22] in LogDetConeSquare(2)
        """,
        """
        variables: t, u, x11, x21, x22
        [t, u, x11, x21, x22] in LogDetConeTriangle(2)
        """,
    )
    return
end

function test_runtests_non_symmetric_logdet()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SquareBridge,
        """
        variables: t, u, x11, x12, x21, x22
        [t, u, x11, x21, x12, x22] in LogDetConeSquare(2)
        """,
        """
        variables: t, u, x11, x12, x21, x22
        [t, u, x11, x12, x22] in LogDetConeTriangle(2)
        1.0 * x12 + -1.0 * x21 == 0.0
        """,
    )
    return
end

function test_runtests_symmetric_rootdet()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SquareBridge,
        """
        variables: t, x11, x21, x22
        [t, x11, x21, x21, x22] in RootDetConeSquare(2)
        """,
        """
        variables: t, x11, x21, x22
        [t, x11, x21, x22] in RootDetConeTriangle(2)
        """,
    )
    return
end

function test_runtests_non_symmetric_rootdet()
    MOI.Bridges.runtests(
        MOI.Bridges.Constraint.SquareBridge,
        """
        variables: t, x11, x12, x21, x22
        [t, x11, x21, x12, x22] in RootDetConeSquare(2)
        """,
        """
        variables: t, x11, x12, x21, x22
        [t, x11, x12, x22] in RootDetConeTriangle(2)
        x12 + -1.0 * x21 == 0.0
        """,
    )
    return
end

function test_conic_LogDetConeSquare_VectorOfVariables()
    mock = MOI.Utilities.MockOptimizer(
        MOI.Utilities.Model{Float64}();
        eval_variable_constraint_dual = false,
    )
    model = MOI.Bridges.Constraint.Square{Float64}(mock)
    mock.optimize! =
        (mock::MOI.Utilities.MockOptimizer) -> MOI.Utilities.mock_optimize!(
            mock,
            [0.0, 1.0, 0.0, 0.0, 1.0, 1.0],
            (MOI.VariableIndex, MOI.EqualTo{Float64}) => [2.0],
            (MOI.VectorAffineFunction{Float64}, MOI.Nonnegatives) =>
                [[1.0, 1.0]],
            (MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}) =>
                [0.0],
            (MOI.VectorOfVariables, MOI.LogDetConeTriangle) =>
                [Float64[-1, -2, 1, 0, 1]],
        )
    config = MOI.Test.Config()
    MOI.Test.test_conic_LogDetConeSquare_VectorOfVariables(model, config)
    return
end

function test_square_warning()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.Square{Float64}(inner)
    x = 1.0 * MOI.add_variable(model)
    f = MOI.Utilities.operate(vcat, Float64, x, x + 1e-9, x, x)
    @test_logs(
        (:warn,),
        MOI.add_constraint(model, f, MOI.PositiveSemidefiniteConeSquare(2)),
    )
    return
end

function test_VectorNonlinearFunction_symmetric()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.Square{Float64}(inner)
    x = MOI.add_variables(model, 3)
    fis = Any[MOI.ScalarNonlinearFunction(:log, Any[x[i]]) for i in 1:3]
    f = MOI.VectorNonlinearFunction(Any[fis[1], fis[2], fis[2], fis[3]])
    c = MOI.add_constraint(model, f, MOI.PositiveSemidefiniteConeSquare(2))
    F, S = MOI.VectorNonlinearFunction, MOI.PositiveSemidefiniteConeTriangle
    indices = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())
    @test length(indices) == 1
    g = MOI.get(inner, MOI.ConstraintFunction(), indices[1])
    y = MOI.get(inner, MOI.ListOfVariableIndices())
    gis = Any[MOI.ScalarNonlinearFunction(:log, Any[y[i]]) for i in 1:3]
    @test g ≈ MOI.VectorNonlinearFunction(gis)
    return
end

function test_VectorNonlinearFunction_nonsymmetric()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.Square{Float64}(inner)
    x = MOI.add_variables(model, 4)
    fis = Any[MOI.ScalarNonlinearFunction(:log, Any[x[i]]) for i in 1:4]
    f = MOI.VectorNonlinearFunction(fis)
    c = MOI.add_constraint(model, f, MOI.PositiveSemidefiniteConeSquare(2))
    F, S = MOI.VectorNonlinearFunction, MOI.PositiveSemidefiniteConeTriangle
    indices = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())
    @test length(indices) == 1
    g = MOI.get(inner, MOI.ConstraintFunction(), indices[1])
    y = MOI.get(inner, MOI.ListOfVariableIndices())
    gis = Any[MOI.ScalarNonlinearFunction(:log, Any[y[i]]) for i in 1:4]
    @test g ≈ MOI.VectorNonlinearFunction(gis[[1, 3, 4]])
    F, S = MOI.ScalarNonlinearFunction, MOI.EqualTo{Float64}
    indices = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())
    @test length(indices) == 1
    g = MOI.get(inner, MOI.ConstraintFunction(), indices[1])
    @test g ≈ MOI.ScalarNonlinearFunction(:-, Any[gis[3], gis[2]])
    return
end

function test_VectorNonlinearFunction_mixed_type()
    inner = MOI.Utilities.Model{Float64}()
    model = MOI.Bridges.Constraint.Square{Float64}(inner)
    x = MOI.add_variables(model, 4)
    fis = vcat(
        Any[MOI.ScalarNonlinearFunction(:log, Any[x[i]]) for i in 1:2],
        1.0 * x[3] + 2.0,
        x[4],
    )
    f = MOI.VectorNonlinearFunction(fis)
    c = MOI.add_constraint(model, f, MOI.PositiveSemidefiniteConeSquare(2))
    F, S = MOI.VectorNonlinearFunction, MOI.PositiveSemidefiniteConeTriangle
    indices = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())
    @test length(indices) == 1
    g = MOI.get(inner, MOI.ConstraintFunction(), indices[1])
    y = MOI.get(inner, MOI.ListOfVariableIndices())
    gis = vcat(
        Any[MOI.ScalarNonlinearFunction(:log, Any[y[i]]) for i in 1:2],
        1.0 * y[3] + 2.0,
        y[4],
    )
    @test g ≈ MOI.VectorNonlinearFunction(gis[[1, 3, 4]])
    F, S = MOI.ScalarNonlinearFunction, MOI.EqualTo{Float64}
    indices = MOI.get(inner, MOI.ListOfConstraintIndices{F,S}())
    @test length(indices) == 1
    @test ≈(
        MOI.get(inner, MOI.ConstraintFunction(), indices[1]),
        MOI.ScalarNonlinearFunction(
            :-,
            Any[convert(MOI.ScalarNonlinearFunction, gis[3]), gis[2]],
        ),
    )
    return
end

end  # module

TestConstraintSquare.runtests()

# Copyright (c) 2017: Miles Lubin and contributors
# Copyright (c) 2017: Google Inc.
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

# Scalar product. Any vector set defined that does not use the standard scalar
# product between vectors of ``R^n`` should redefine `set_dot` and
# `dot_coefficients`.

"""
    set_dot(x::AbstractVector, y::AbstractVector, set::AbstractVectorSet)

Return the scalar product between a vector `x` of the set `set` and a vector
`y` of the dual of the set `s`.
"""
function set_dot(x::AbstractVector, y::AbstractVector, ::MOI.AbstractVectorSet)
    return LinearAlgebra.dot(x, y)
end

"""
    set_dot(x, y, set::AbstractScalarSet)

Return the scalar product between a number `x` of the set `set` and a number
`y` of the dual of the set `s`.
"""
set_dot(x, y, ::MOI.AbstractScalarSet) = LinearAlgebra.dot(x, y)

function triangle_dot(
    x::AbstractVector{S},
    y::AbstractVector{T},
    dim::Int,
    offset::Int,
) where {S,T}
    U = MA.promote_operation(MA.add_mul, S, T)
    result = zero(U)
    k = offset
    for i in 1:dim
        for j in 1:i
            k += 1
            if i == j
                result = MA.add_mul!!(result, x[k], y[k])
            else
                result = MA.add_mul!!(result, 2, x[k], y[k])
            end
        end
    end
    return result
end

function set_dot(
    x::AbstractVector,
    y::AbstractVector,
    set::MOI.AbstractSymmetricMatrixSetTriangle,
)
    return triangle_dot(x, y, MOI.side_dimension(set), 0)
end

function set_dot(
    x::AbstractVector,
    y::AbstractVector,
    set::MOI.HermitianPositiveSemidefiniteConeTriangle,
)
    sym = MOI.PositiveSemidefiniteConeTriangle(set.side_dimension)
    I = Base.OneTo(MOI.dimension(sym))
    result = set_dot(view(x, I), view(y, I), sym)
    for k in (MOI.dimension(sym)+1):MOI.dimension(set)
        result = MA.add_mul!!(result, 2, x[k], y[k])
    end
    return result
end

function set_dot(
    x::AbstractVector,
    y::AbstractVector,
    set::MOI.RootDetConeTriangle,
)
    return x[1] * y[1] + triangle_dot(x, y, set.side_dimension, 1)
end

function set_dot(
    x::AbstractVector,
    y::AbstractVector,
    set::MOI.LogDetConeTriangle,
)
    return x[1] * y[1] + x[2] * y[2] + triangle_dot(x, y, set.side_dimension, 2)
end

"""
    dot_coefficients(a::AbstractVector, set::AbstractVectorSet)

Return the vector `b` such that for all vector `x` of the set `set`,
`set_dot(b, x, set)` is equal to `dot(a, x)`.
"""
function dot_coefficients(a::AbstractVector, ::MOI.AbstractVectorSet)
    return a
end

function triangle_coefficients!(
    b::AbstractVector{T},
    dim::Int,
    offset::Int,
) where {T}
    k = offset
    for i in 1:dim
        for j in 1:i
            k += 1
            if i != j
                b[k] /= 2
            end
        end
    end
end

function dot_coefficients(
    a::AbstractVector,
    set::MOI.AbstractSymmetricMatrixSetTriangle,
)
    b = copy(a)
    triangle_coefficients!(b, MOI.side_dimension(set), 0)
    return b
end

function dot_coefficients(
    a::AbstractVector,
    set::MOI.HermitianPositiveSemidefiniteConeTriangle,
)
    sym = MOI.PositiveSemidefiniteConeTriangle(set.side_dimension)
    b = dot_coefficients(a, sym)
    for k in (MOI.dimension(sym)+1):MOI.dimension(set)
        b[k] /= 2
    end
    return b
end

function dot_coefficients(a::AbstractVector, set::MOI.RootDetConeTriangle)
    b = copy(a)
    triangle_coefficients!(b, set.side_dimension, 1)
    return b
end

function dot_coefficients(a::AbstractVector, set::MOI.LogDetConeTriangle)
    b = copy(a)
    triangle_coefficients!(b, set.side_dimension, 2)
    return b
end

# For `SetDotScalingVector`, we would like to compute the dot product
# of canonical vectors in O(1) instead of O(n)
# See https://github.com/jump-dev/Dualization.jl/pull/135

"""
    struct ZeroVector{T} <: AbstractVector{T}
        n::Int
    end

Vector of length `n` with only zero elements.
"""
struct ZeroVector{T} <: AbstractVector{T}
    n::Int
end

Base.eltype(::Type{ZeroVector{T}}) where {T} = T

Base.length(v::ZeroVector) = v.n

Base.size(v::ZeroVector) = (v.n,)

function Base.getindex(::ZeroVector{T}, ::Integer) where {T}
    return zero(T)
end

"""
    struct CanonicalVector{T} <: AbstractVector{T}
        index::Int
        n::Int
    end

Vector of length `n` with only zero elements except at index `index` where
the element is one.
"""
struct CanonicalVector{T} <: AbstractVector{T}
    index::Int
    n::Int
end

Base.eltype(::Type{CanonicalVector{T}}) where {T} = T

Base.length(v::CanonicalVector) = v.n

Base.size(v::CanonicalVector) = (v.n,)

function Base.getindex(v::CanonicalVector{T}, i::Integer) where {T}
    return convert(T, i == v.index)
end

function Base.view(v::CanonicalVector{T}, I::AbstractUnitRange) where {T}
    if v.index in I
        return CanonicalVector{T}(v.index - first(I) + 1, length(I))
    else
        return ZeroVector{T}(length(I))
    end
end

# This is much faster than the default implementation that goes
# through all entries even if only one is nonzero.
function LinearAlgebra.dot(
    x::CanonicalVector{T},
    y::CanonicalVector{T},
) where {T}
    return convert(T, x.index == y.index)
end

function triangle_dot(
    x::CanonicalVector{T},
    y::CanonicalVector{T},
    ::Int,
    offset::Int,
) where {T}
    if x.index != y.index || x.index <= offset
        return zero(T)
    elseif is_diagonal_vectorized_index(x.index - offset)
        return one(T)
    else
        return T(2)
    end
end

function _set_dot(i::Integer, s::MOI.AbstractVectorSet, T::Type)
    vec = CanonicalVector{T}(i, MOI.dimension(s))
    return set_dot(vec, vec, s)
end

function _set_dot(::Integer, ::MOI.AbstractScalarSet, T::Type)
    return one(T)
end

"""
    struct SetDotScalingVector{T,S<:MOI.AbstractSet} <: AbstractVector{T}
        set::S
        len::Int
    end

Vector `s` of scaling for the entries of the vectorized form of
a vector `x` in `set` and `y` in `MOI.dual_set(set)` such that
`MOI.Utilities.set_dot(x, y) = LinearAlgebra.dot(s .* x, s .* y)`.

## Example

Combined with `LinearAlgebra`, this vector can be used to scale
a [`MOI.AbstractVectorFunction`](@ref).

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 3);

julia> func = MOI.VectorOfVariables(x)
┌                    ┐
│MOI.VariableIndex(1)│
│MOI.VariableIndex(2)│
│MOI.VariableIndex(3)│
└                    ┘

julia> set = MOI.PositiveSemidefiniteConeTriangle(2)
MathOptInterface.PositiveSemidefiniteConeTriangle(2)

julia> MOI.add_constraint(model, func, MOI.Scaled(set))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Scaled{MathOptInterface.PositiveSemidefiniteConeTriangle}}(1)

julia> a = MOI.Utilities.SetDotScalingVector{Float64}(set)
3-element MathOptInterface.Utilities.SetDotScalingVector{Float64, MathOptInterface.PositiveSemidefiniteConeTriangle}:
 1.0
 1.4142135623730951
 1.0

julia> using LinearAlgebra

julia> MOI.Utilities.operate(*, Float64, Diagonal(a), func)
┌                                             ┐
│0.0 + 1.0 MOI.VariableIndex(1)               │
│0.0 + 1.4142135623730951 MOI.VariableIndex(2)│
│0.0 + 1.0 MOI.VariableIndex(3)               │
└                                             ┘

julia> MOI.Utilities.operate(*, Float64, Diagonal(a), ones(3))
3-element Vector{Float64}:
 1.0
 1.4142135623730951
 1.0
```
"""
struct SetDotScalingVector{T,S<:MOI.AbstractSet} <: AbstractVector{T}
    set::S
end

function SetDotScalingVector{T}(s::MOI.AbstractSet) where {T}
    return SetDotScalingVector{T,typeof(s)}(s)
end

function Base.getindex(s::SetDotScalingVector{T}, i::Base.Integer) where {T}
    return sqrt(_set_dot(i, s.set, T))
end

Base.size(x::SetDotScalingVector) = (MOI.dimension(x.set),)

function symmetric_matrix_scaling_vector(::Type{T}, n) where {T}
    d = side_dimension_for_vectorized_dimension(n)
    set = MOI.PositiveSemidefiniteConeTriangle(d)
    return SetDotScalingVector{T}(set)
end

function symmetric_matrix_inverse_scaling_vector(::Type{T}, n) where {T}
    return lazy_map(T, inv, symmetric_matrix_scaling_vector(T, n))
end

"""
    struct SymmetricMatrixScalingVector{T} <: AbstractVector{T}
        no_scaling::T
        scaling::T
        len::Int
    end

Vector of scaling for the entries of the vectorized form of
a symmetric matrix. The values `no_scaling` and `scaling`
are stored in the `struct` to avoid creating a new one for each entry.

!!! warning
    This type is deprecated, use `SetDotScalingVector` instead.
"""
struct SymmetricMatrixScalingVector{T} <: AbstractVector{T}
    scaling::T
    no_scaling::T
    len::Int
end

function SymmetricMatrixScalingVector{T}(scaling::T, len::Int) where {T}
    return SymmetricMatrixScalingVector{T}(scaling, one(T), len)
end

function Base.getindex(s::SymmetricMatrixScalingVector, i::Base.Integer)
    if is_diagonal_vectorized_index(i)
        return s.no_scaling
    else
        return s.scaling
    end
end

Base.size(x::SymmetricMatrixScalingVector) = (x.len,)

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Callbacks

```@docs
AbstractCallback
AbstractSubmittable
submit
```

## Attributes

```@docs
CallbackNodeStatus
CallbackVariablePrimal
CallbackNodeStatusCode
CALLBACK_NODE_STATUS_INTEGER
CALLBACK_NODE_STATUS_FRACTIONAL
CALLBACK_NODE_STATUS_UNKNOWN
```

## Lazy constraints

```@docs
LazyConstraintCallback
LazyConstraint
```

## User cuts

```@docs
UserCutCallback
UserCut
```

## Heuristic solutions

```@docs
HeuristicCallback
HeuristicSolution
HeuristicSolutionStatus
HEURISTIC_SOLUTION_ACCEPTED
HEURISTIC_SOLUTION_REJECTED
HEURISTIC_SOLUTION_UNKNOWN
```

# Checklists

The purpose of this page is to collate a series of checklists for commonly
performed changes to the source code of MathOptInterface.

In each case, copy the checklist into the description of the pull request.

## Making a release

Use this checklist when making a release of the MathOptInterface repository.

```
## Basic

 - [ ] `version` field of `Project.toml` has been updated
       - If a breaking change, increment the MAJOR field and reset others to 0
       - If adding new features, increment the MINOR field and reset PATCH to 0
       - If adding bug fixes or documentation changes, increment the PATCH field

## Documentation

 - [ ] Add a new entry to `docs/src/changelog.md`, following existing style

## Tests

 - [ ] The `solver-tests.yml` GitHub action does not have unexpected failures.
       To run the action, go to:
       https://github.com/jump-dev/MathOptInterface.jl/actions/workflows/solver-tests.yml
       and click "Run workflow"
 - [ ] If new tests were added, ensure that `MOI.Test.version_added` is implemented.
```

## Adding a new set

Use this checklist when adding a new set to the MathOptInterface repository.

```
## Basic

 - [ ] Add a new `AbstractScalarSet` or `AbstractVectorSet` to `src/sets.jl`
 - [ ] If `isbitstype(S) == false`, implement `Base.copy(set::S)`
 - [ ] If `isbitstype(S) == false`, implement `Base.:(==)(x::S, y::S)`
 - [ ] If an `AbstractVectorSet`, implement `dimension(set::S)`, unless the
       dimension is given by `set.dimension`.
 - [ ] Ensure the set does not contain references to any variables or constraints

## Utilities

 - [ ] If an `AbstractVectorSet`, implement `Utilities.set_dot`,
       unless the dot product between two vectors in the set is equivalent to
       `LinearAlgebra.dot`
 - [ ] If an `AbstractVectorSet`, implement `Utilities.set_with_dimension` in
       `src/Utilities/matrix_of_constraints.jl`
 - [ ] Add the set to the `@model` macro at the bottom of `src/Utilities.model.jl`

## Documentation

 - [ ] Add a docstring, which gives the mathematical definition of the set,
       along with an `## Example` block containing a `jldoctest`
 - [ ] Add the docstring to `docs/src/reference/standard_form.md`
 - [ ] Add the set to the relevant table in `docs/src/manual/standard_form.md`

## Tests

 - [ ] Define a new `_set(::Type{S})` method in `src/Test/test_basic_constraint.jl`
       and add the name of the set to the list at the bottom of that files
 - [ ] If the set has any checks in its constructor, add tests to `test/sets.jl`

## MathOptFormat

 - [ ] Open an issue at `https://github.com/jump-dev/MathOptFormat` to add
       support for the new set {{ replace with link to the issue }}

## Optional

 - [ ] Implement `dual_set(::S)` and `dual_set_type(::Type{S})`
 - [ ] Add new tests to the `Test` submodule exercising your new set
 - [ ] Add new bridges to convert your set into more commonly used sets
```

## Adding a new bridge

Use this checklist when adding a new bridge to the MathOptInterface repository.

The steps are mostly the same, but locations depend on whether the bridge is a
`Constraint`, `Objective`, or `Variable` bridge. In each case below, replace
`XXX` with the appropriate type of bridge.

```
## Basic

 - [ ] Create a new file in `src/Bridges/XXX/bridges` named after the type of
       the bridge
 - [ ] Define the bridge, following existing examples. The name of the bridge
       struct must end in `Bridge`
 - [ ] Check if your bridge can be a subtype of [`MOI.Bridges.Constraint.SetMapBridge`](@ref)
 - [ ] Define a new `const` that is a `SingleBridgeOptimizer` wrapping the
       new bridge. The name of the const must be the name of the bridge, less
       the `Bridge` suffix
 - [ ] If the bridge should be enabled by default, add the bridge to
       `add_all_bridges` at the bottom of `src/Bridges/XXX/XXX.jl`

## Tests

 - [ ] Create a new file in the appropriate subdirectory of `tests/Bridges/XXX`
       named after the type of the bridge
 - [ ] Use `MOI.Bridges.runtests` to test various inputs and outputs of the
       bridge
 - [ ] If, after opening the pull request to add the bridge, some lines are not
       covered by the tests, add additional bridge-specific tests to cover the
       untested lines.

## Documentation

 - [ ] Add a docstring which uses the same template as existing bridges.

## Final touch

If the bridge depends on run-time values of other variables and constraints in
the model:

 - [ ] Implement `MOI.Utilities.needs_final_touch(::Bridge)`
 - [ ] Implement `MOI.Utilities.final_touch(::Bridge, ::MOI.ModelLike)`
 - [ ] Ensure that `final_touch` can be called multiple times in a row
```

## Updating MathOptFormat

Use this checklist when updating the version of MathOptFormat.

```
## Basic

 - [ ] The file at `src/FileFormats/MOF/mof.schema.json` is updated
 - [ ] The constant `_SUPPORTED_VERSIONS` is updated in
       `src/FileFormats/MOF/MOF.jl`

## New sets

 - [ ] New sets are added to the `@model` in `src/FileFormats/MOF/MOF.jl`
 - [ ] New sets are added to the `@enum` in `src/FileFormats/MOF/read.jl`
 - [ ] `set_to_moi` is defined for each set in `src/FileFormats/MOF/read.jl`
 - [ ] `head_name` is defined for each set in `src/FileFormats/MOF/write.jl`
 - [ ] A new unit test calling `_test_model_equality` is aded to
       `test/FileFormats/MOF/MOF.jl`

## Tests

 - [ ] The version field in `test/FileFormats/MOF/nlp.mof.json` is updated

## Documentation

 - [ ] The version fields are updated in `docs/src/submodules/FileFormats/overview.md`
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Manipulating expressions

This guide highlights a syntactically appealing way to build expressions at the
MOI level, but also to look at their contents. It may be especially useful
when writing models or bridge code.

## Creating functions

This section details the ways to create functions with MathOptInterface.

### Creating scalar affine functions

The simplest scalar function is simply a variable:

```jldoctest expr; setup=:(model = MOI.Utilities.CachingOptimizer(MOI.Utilities.Model{Float64}(), MOI.Utilities.AUTOMATIC); )
julia> x = MOI.add_variable(model) # Create the variable x
MOI.VariableIndex(1)
```

This type of function is extremely simple; to express more complex functions,
other types must be used. For instance, a [`ScalarAffineFunction`](@ref) is a
sum of linear terms (a factor times a variable) and a constant. Such an object
can be built using the standard constructor:

```jldoctest expr
julia> f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1, x)], 2) # x + 2
(2) + (1) MOI.VariableIndex(1)
```

However, you can also use operators to build the same scalar function:

```jldoctest expr
julia> f = x + 2
(2) + (1) MOI.VariableIndex(1)
```

### Creating scalar quadratic functions

Scalar quadratic functions are stored in [`ScalarQuadraticFunction`](@ref)
objects, in a way that is highly similar to scalar affine functions. You can
obtain a quadratic function as a product of affine functions:

```jldoctest expr
julia> 1 * x * x
(0) + 1.0 MOI.VariableIndex(1)²

julia> f * f  # (x + 2)²
(4) + (2) MOI.VariableIndex(1) + (2) MOI.VariableIndex(1) + 1.0 MOI.VariableIndex(1)²

julia> f^2  # (x + 2)² too
(4) + (2) MOI.VariableIndex(1) + (2) MOI.VariableIndex(1) + 1.0 MOI.VariableIndex(1)²
```

### Creating vector functions

A vector function is a function with several values, irrespective of the number
of input variables. Similarly to scalar functions, there are three main types
of vector functions: [`VectorOfVariables`](@ref),
[`VectorAffineFunction`](@ref), and [`VectorQuadraticFunction`](@ref).

The easiest way to create a vector function is to stack several scalar
functions using [`Utilities.vectorize`](@ref). It takes a vector as input,
and the generated vector function (of the most appropriate type) has each
dimension corresponding to a dimension of the vector.

```jldoctest expr
julia> g = MOI.Utilities.vectorize([f, 2 * f])
┌                              ┐
│(2) + (1) MOI.VariableIndex(1)│
│(4) + (2) MOI.VariableIndex(1)│
└                              ┘
```

!!! warning
    [`Utilities.vectorize`](@ref) only takes a vector of similar scalar
    functions: you cannot mix [`VariableIndex`](@ref) and
    [`ScalarAffineFunction`](@ref), for instance. In practice, it means that
    `Utilities.vectorize([x, f])` does not work; you should rather use
    `Utilities.vectorize([1 * x, f])` instead to only have
    [`ScalarAffineFunction`](@ref) objects.

## Canonicalizing functions

In more advanced use cases, you might need to ensure that a function is
"canonical." Functions are stored as an array of terms, but there is no check
that these terms are redundant: a [`ScalarAffineFunction`](@ref) object might
have two terms with the same variable, like `x + x + 1`. These terms could be
merged without changing the semantics of the function: `2x + 1`.

Working with these objects might be cumbersome. Canonicalization helps maintain
redundancy to zero.

[`Utilities.is_canonical`](@ref) checks whether a function is already in its
canonical form:

```jldoctest expr
julia> MOI.Utilities.is_canonical(f + f) # (x + 2) + (x + 2) is stored as x + x + 4
false
```

[`Utilities.canonical`](@ref) returns the equivalent canonical version of the
function:

```jldoctest expr
julia> MOI.Utilities.canonical(f + f) # Returns 2x + 4
(4) + (2) MOI.VariableIndex(1)
```

## Exploring functions

At some point, you might need to dig into a function, for instance to map it
into solver constructs.

### Vector functions

[`Utilities.scalarize`](@ref) returns a vector of scalar functions from a
vector function:

```jldoctest expr
julia> MOI.Utilities.scalarize(g) # Returns a vector [f, 2 * f].
2-element Vector{MathOptInterface.ScalarAffineFunction{Int64}}:
 (2) + (1) MOI.VariableIndex(1)
 (4) + (2) MOI.VariableIndex(1)
```

!!! note
    [`Utilities.eachscalar`](@ref) returns an iterator on the dimensions, which
    serves the same purpose as [`Utilities.scalarize`](@ref).

[`output_dimension`](@ref) returns the number of dimensions of the
output of a function:

```jldoctest expr
julia> MOI.output_dimension(g)
2
```

# Motivation

MathOptInterface (MOI) is a replacement for
[MathProgBase](https://github.com/JuliaOpt/MathProgBase.jl),
the first-generation abstraction layer for mathematical optimization previously
used by
[JuMP](https://github.com/jump-dev/JuMP.jl) and
[Convex.jl](https://github.com/jump-dev/Convex.jl).

To address a number of limitations of MathProgBase, MOI is designed to:

- Be simple and extensible
  * unifying linear, quadratic, and conic optimization,
  * seamlessly facilitating extensions to essentially arbitrary constraints and
    functions (for example, indicator constraints, complementarity constraints,
    and piecewise-linear functions)
- Be fast
   * by allowing access to a solver's in-memory representation of a problem
     without writing intermediate files (when possible)
   * by using multiple dispatch and avoiding requiring containers of
     non-concrete types
- Allow a solver to return multiple results (for example, a pool of solutions)
- Allow a solver to return extra arbitrary information via attributes (for
  example, variable- and constraint-wise membership in an irreducible
  inconsistent subset for infeasibility analysis)
- Provide a greatly expanded set of status codes explaining what happened during
  the optimization procedure
- Enable a solver to more precisely specify which problem classes it supports
- Enable both primal and dual warm starts
- Enable adding and removing both variables and constraints by indices that are
  not required to be consecutive
- Enable any modification that the solver supports to an existing model
- Avoid requiring the solver wrapper to store an additional copy of the problem
  data

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Models

## Attribute interface

```@docs
is_set_by_optimize
is_copyable
get
get!
set
supports
attribute_value_type
```

## Model interface

```@docs
ModelLike
is_empty
empty!
write_to_file
read_from_file
supports_incremental_interface
copy_to
IndexMap
```

## Model attributes

```@docs
AbstractModelAttribute
Name
ObjectiveFunction
ObjectiveFunctionType
ObjectiveSense
OptimizationSense
MIN_SENSE
MAX_SENSE
FEASIBILITY_SENSE
NumberOfVariables
ListOfVariableIndices
ListOfConstraintTypesPresent
NumberOfConstraints
ListOfConstraintIndices
ListOfOptimizerAttributesSet
ListOfModelAttributesSet
ListOfVariableAttributesSet
ListOfVariablesWithAttributeSet
ListOfConstraintAttributesSet
ListOfConstraintsWithAttributeSet
UserDefinedFunction
ListOfSupportedNonlinearOperators
```

## Optimizer interface

```@docs
AbstractOptimizer
OptimizerWithAttributes
optimize!
optimize!(::ModelLike, ::ModelLike)
instantiate
default_cache
```

## Optimizer attributes

```@docs
AbstractOptimizerAttribute
SolverName
SolverVersion
Silent
TimeLimitSec
ObjectiveLimit
SolutionLimit
NodeLimit
RawOptimizerAttribute
NumberOfThreads
RawSolver
AbsoluteGapTolerance
RelativeGapTolerance
AutomaticDifferentiationBackend
```

List of attributes useful for optimizers

```@docs
TerminationStatus
TerminationStatusCode
OPTIMIZE_NOT_CALLED
OPTIMAL
INFEASIBLE
DUAL_INFEASIBLE
LOCALLY_SOLVED
LOCALLY_INFEASIBLE
INFEASIBLE_OR_UNBOUNDED
ALMOST_OPTIMAL
ALMOST_INFEASIBLE
ALMOST_DUAL_INFEASIBLE
ALMOST_LOCALLY_SOLVED
ITERATION_LIMIT
TIME_LIMIT
NODE_LIMIT
SOLUTION_LIMIT
MEMORY_LIMIT
OBJECTIVE_LIMIT
NORM_LIMIT
OTHER_LIMIT
SLOW_PROGRESS
NUMERICAL_ERROR
INVALID_MODEL
INVALID_OPTION
INTERRUPTED
OTHER_ERROR
PrimalStatus
DualStatus
RawStatusString
ResultCount
ObjectiveValue
DualObjectiveValue
ObjectiveBound
RelativeGap
SolveTimeSec
SimplexIterations
BarrierIterations
NodeCount
```

### ResultStatusCode

```@docs
ResultStatusCode
NO_SOLUTION
FEASIBLE_POINT
NEARLY_FEASIBLE_POINT
INFEASIBLE_POINT
INFEASIBILITY_CERTIFICATE
NEARLY_INFEASIBILITY_CERTIFICATE
REDUCTION_CERTIFICATE
NEARLY_REDUCTION_CERTIFICATE
UNKNOWN_RESULT_STATUS
OTHER_RESULT_STATUS
```

### Conflict Status

```@docs
compute_conflict!
ConflictStatus
ConflictStatusCode
COMPUTE_CONFLICT_NOT_CALLED
NO_CONFLICT_EXISTS
NO_CONFLICT_FOUND
CONFLICT_FOUND
ConflictCount
ConstraintConflictStatus
ConflictParticipationStatusCode
NOT_IN_CONFLICT
IN_CONFLICT
MAYBE_IN_CONFLICT
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Errors

When an MOI call fails on a model, precise errors should be thrown when possible
instead of simply calling `error` with a message. The docstrings for the
respective methods describe the errors that the implementation should throw in
certain situations. This error-reporting system allows code to distinguish
between internal errors (that should be shown to the user) and unsupported
operations which may have automatic workarounds.

When an invalid index is used in an MOI call, an [`InvalidIndex`](@ref) is
thrown:
```@docs
InvalidIndex
```

When an invalid result index is used to retrieve an attribute, a
[`ResultIndexBoundsError`](@ref) is thrown:
```@docs
ResultIndexBoundsError
check_result_index_bounds
```

As discussed in [JuMP mapping](@ref), for scalar constraint with a nonzero
function constant, a [`ScalarFunctionConstantNotZero`](@ref) exception may be
thrown:
```@docs
ScalarFunctionConstantNotZero
```

Some [`VariableIndex`](@ref) constraints cannot be combined on the same
variable:
```@docs
LowerBoundAlreadySet
UpperBoundAlreadySet
```

As discussed in [`AbstractCallback`](@ref), trying to [`get`](@ref) attributes
inside a callback may throw:
```@docs
OptimizeInProgress
```

Trying to submit the wrong type of [`AbstractSubmittable`](@ref) inside an
[`AbstractCallback`](@ref) (for example, a [`UserCut`](@ref) inside a
[`LazyConstraintCallback`](@ref)) will throw:
```@docs
InvalidCallbackUsage
```

The rest of the errors defined in MOI fall in two categories represented by the
following two abstract types:
```@docs
UnsupportedError
NotAllowedError
```

The different [`UnsupportedError`](@ref) and [`NotAllowedError`](@ref) are the
following errors:
```@docs
UnsupportedAttribute
GetAttributeNotAllowed
SetAttributeNotAllowed
AddVariableNotAllowed
UnsupportedConstraint
AddConstraintNotAllowed
ModifyConstraintNotAllowed
ModifyObjectiveNotAllowed
DeleteNotAllowed
UnsupportedSubmittable
SubmitNotAllowed
UnsupportedNonlinearOperator
```

Note that setting the [`ConstraintFunction`](@ref) of a [`VariableIndex`](@ref)
constraint is not allowed:
```@docs
SettingVariableIndexNotAllowed
```

# [Contributing](@id contributing_to_mathoptinterface)

This document explains how to contribute code to MathOptInterface.

## Obtain the source code

The easiest way to obtain the source code for MathOptInterface is to run:
```julia
julia> import Pkg

julia> Pkg.dev("MathOptInterface")
```
This will download the MathOptInterface Git repository to `~/.julia/dev/MathOptInterface`.
If you're on Windows, this will be `C:\\Users\\<my_name>\\.julia\\dev\\MathOptInterface`.

Alternatively, you can use `git` to clone the source to a directory of your
choosing:
```
$ cd /some/local/path
$ git clone https://github.com/jump-dev/MathOptInterface.jl.git
```

## Make changes

Code development in MathOptInterface follows typical git development practices.

First, go to [https://github.com/jump-dev/MathOptInterface.jl](https://github.com/jump-dev/MathOptInterface.jl)
and click the "Fork" button in the top-right corner. This will create a copy of
MathOptInterface under your GitHub account.

Then, tell your local git about your new fork:
```
export GITHUB_ACCOUNT="odow"  # Replace with your name
cd ~/.julia/dev/MathOptInterface
git remote add ${GITHUB_ACCOUNT} https://github.com/${GITHUB_ACCOUNT}/MathOptInterface.jl.git
```

Before making changes to the source, ensure that you have the latest copy, and
checkout a new branch:
```
git checkout master
git pull
git checkout -b my_new_branch
```

Now you can make changes by editing the local source code. See [Running the tests](@ref)
for how to check if your code passes the tests.

Once you have finished making changes, make a commit and push your branch to
GitHub:
```
git add .
git commit -m "A message describing what you changed"
git push -u $GITHUB_ACCOUNT my_new_branch
```
Finally, go to [https://github.com/jump-dev/MathOptInterface.jl](https://github.com/jump-dev/MathOptInterface.jl)
and follow the instructions that pop up to open a pull request.

## Running the tests

There are lot of tests in MathOptInterface. Running them in their entirety can
take a long time.

The easiest way to run the tests is to run:
```julia
julia> import Pkg

julia> Pkg.test("MathOptInterface")
```
The downside to the approach is that it will run all of the tests, and it will
recompile MathOptInterface from scratch, even if you have made very trivial
changes to the source code.

A faster approach is to use [Revise.jl](https://github.com/timholy/Revise.jl).

First, install Revise in your global package environment:
```
$ julia

julia> import Pkg

julia> Pkg.add("Revise")
```

Then, `cd` to the source code of MathOptInterface, and start Julia with the
project set to `.` (for `~/.julia/dev/MathOptInterface/Project.toml`):
```
$ cd ~/.julia/dev/MathOptInterface
$ julia --project=.
```

To run the tests, load Revise, and then include the relevant test file. For
example:
```julia
julia> using Revise

julia> include("test/Nonlinear/runtests.jl")

julia> # make changes to `src/Nonlinear`

julia> include("test/Nonlinear/runtests.jl")
```
You can also run other tests such as `test/Bridges/Constraint/runtests.jl`, or
any individual file, such as `test/Utilities/distance_to_set.jl`.

There is one complication: `JSONSchema` is a test-time dependency that is not
present in the default project. If you want to run `test/FileFormats/MOF/MOF.jl`,
you will first need to install the package (`Pkg.test("MathOptInterface")` does
this automatically):
```julia
julia> import Pkg; Pkg.add("JSONSchema")
```
If you have installed JSONSchema, you can also run all the tests with
`include("test/runtests.jl")`.

Finally, running the tests locally is best practice, but it is not required.
When you open a pull request, our automated CI will run all of the tests and
highlight any failing tests that need to be fixed.

A comment from `@odow`: when I'm working on a feature, I make local changes,
run the most relevant test file with `include`, and then open a PR. If the
change caused a test to fail in some other part of the codebase, I then
`include` the file with the failing test locally to debug my follow-up changes.

## Building the documentation

Building the documentation follows a similar practice with Revise. First, `cd`
to the source code of MathOptInterface, but this time, start Julia with
`--project=docs`.
```
$ cd ~/.julia/dev/MathOptInterface

$ julia --project=docs
```

Then, ensure that MathOptInterface (in our current directory) has been added as
a development dependency:
```julia
julia> import Pkg; Pkg.dev(".")
[...lines omitted...]
```
Finally, load `Revise` and then build the docs:
```julia
julia> using Revise

julia> include("docs/make.jl")
```
If you make changes to the docs or to the Julia source code (for example, the
docstrings), you can re-run `include` to quickly rebuild the docs.

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Standard form problem

MathOptInterface represents optimization problems in the standard form:
```math
\begin{align}
    & \min_{x \in \mathbb{R}^n} & f_0(x)
    \\
    & \;\;\text{s.t.} & f_i(x) & \in \mathcal{S}_i & i = 1 \ldots m
\end{align}
```
where:
* the functions ``f_0, f_1, \ldots, f_m`` are specified by
  [`AbstractFunction`](@ref) objects
* the sets ``\mathcal{S}_1, \ldots, \mathcal{S}_m`` are specified by
  [`AbstractSet`](@ref) objects

An important design consideration is that the sets are independent of the
decision variables.

!!! tip
    For more information on this standard form, read [our paper](https://arxiv.org/abs/2002.03447).

MOI defines some commonly used functions and sets, but the interface is
extensible to other sets recognized by the solver.

## Functions

The function types implemented in MathOptInterface.jl are:

| Function         | Description |
| :--------------- | :---------- |
| [`VariableIndex`](@ref) | ``x_j``, the projection onto a single coordinate defined by a variable index ``j``. |
| [`VectorOfVariables`](@ref) | The projection onto multiple coordinates (that is, extracting a sub-vector). |
| [`ScalarAffineFunction`](@ref) | ``a^T x + b``, where ``a`` is a vector and ``b`` scalar. |
| [`ScalarNonlinearFunction`](@ref) | ``f(x)``, where ``f`` is a nonlinear function. |
| [`VectorAffineFunction`](@ref) | ``A x + b``, where ``A`` is a matrix and ``b`` is a vector. |
| [`ScalarQuadraticFunction`](@ref) | ``\frac{1}{2} x^T Q x + a^T x + b``, where ``Q`` is a symmetric matrix, ``a`` is a vector, and ``b`` is a constant. |
| [`VectorQuadraticFunction`](@ref) | A vector of scalar-valued quadratic functions. |
| [`VectorNonlinearFunction`](@ref) | ``f(x)``, where ``f`` is a vector-valued nonlinear function. |

## One-dimensional sets

The one-dimensional set types implemented in MathOptInterface.jl are:

| Set                                                            | Description                            |
| :------------------------------------------------------------- | :------------------------------------- |
| [`LessThan(u)`](@ref MathOptInterface.LessThan)                | ``(-\infty, u]``                       |
| [`GreaterThan(l)`](@ref MathOptInterface.GreaterThan)          | ``[l, \infty)``                        |
| [`EqualTo(v)`](@ref MathOptInterface.GreaterThan)              | ``\{v\}``                              |
| [`Interval(l, u)`](@ref MathOptInterface.Interval)             | ``[l, u]``                             |
| [`Integer()`](@ref MathOptInterface.Integer)                   | ``\mathbb{Z}``                         |
| [`ZeroOne()`](@ref MathOptInterface.ZeroOne)                   | ``\{ 0, 1 \}``                         |
| [`Semicontinuous(l, u)`](@ref MathOptInterface.Semicontinuous) | ``\{ 0\} \cup [l, u]``                 |
| [`Semiinteger(l, u)`](@ref MathOptInterface.Semiinteger)       | ``\{ 0\} \cup \{l,l+1,\ldots,u-1,u\}`` |

## Vector cones

The vector-valued set types implemented in MathOptInterface.jl are:

| Set                                                                   | Description |
| :---------------------------------------------------------------------| :---------- |
| [`Reals(d)`](@ref MathOptInterface.Reals)                             | ``\mathbb{R}^{d}`` |
| [`Zeros(d)`](@ref MathOptInterface.Zeros)                             | ``0^{d}`` |
| [`Nonnegatives(d)`](@ref MathOptInterface.Nonnegatives)               | ``\{ x \in \mathbb{R}^{d} : x \ge 0 \}`` |
| [`Nonpositives(d)`](@ref MathOptInterface.Nonpositives)               | ``\{ x \in \mathbb{R}^{d} : x \le 0 \}`` |
| [`SecondOrderCone(d)`](@ref MathOptInterface.SecondOrderCone)         | ``\{ (t,x) \in \mathbb{R}^{d} : t \ge \lVert x \rVert_2 \}`` |
| [`RotatedSecondOrderCone(d)`](@ref MathOptInterface.RotatedSecondOrderCone) | ``\{ (t,u,x) \in \mathbb{R}^{d} : 2tu \ge \lVert x \rVert_2^2, t \ge 0,u \ge 0 \}`` |
| [`ExponentialCone()`](@ref MathOptInterface.ExponentialCone)          | ``\{ (x,y,z) \in \mathbb{R}^3 : y \exp (x/y) \le z, y > 0 \}`` |
| [`DualExponentialCone()`](@ref MathOptInterface.DualExponentialCone)  | ``\{ (u,v,w) \in \mathbb{R}^3 : -u \exp (v/u) \le \exp(1) w, u < 0 \}`` |
| [`GeometricMeanCone(d)`](@ref MathOptInterface.GeometricMeanCone)     | ``\{ (t,x) \in \mathbb{R}^{1+n} : x \ge 0, t \le \sqrt[n]{x_1 x_2 \cdots x_n} \}`` where ``n`` is ``d - 1`` |
| [`PowerCone(α)`](@ref MathOptInterface.PowerCone)                     | ``\{ (x,y,z) \in \mathbb{R}^3 : x^{\alpha} y^{1-\alpha} \ge \|z\|, x \ge 0,y \ge 0 \}`` |
| [`DualPowerCone(α)`](@ref MathOptInterface.DualPowerCone)             | ``\{ (u,v,w) \in \mathbb{R}^3 : \left(\frac{u}{\alpha}\right)^{\alpha}\left(\frac{v}{1-\alpha}\right)^{1-\alpha} \ge \|w\|, u,v \ge 0 \}`` |
| [`NormOneCone(d)`](@ref MathOptInterface.NormOneCone)                 | ``\{ (t,x) \in \mathbb{R}^{d} : t \ge \sum_i \lvert x_i \rvert \}`` |
| [`NormInfinityCone(d)`](@ref MathOptInterface.NormInfinityCone)       | ``\{ (t,x) \in \mathbb{R}^{d} : t \ge \max_i \lvert x_i \rvert \}`` |
| [`RelativeEntropyCone(d)`](@ref MathOptInterface.RelativeEntropyCone) | ``\{ (u, v, w) \in \mathbb{R}^{d} : u \ge \sum_i w_i \log (\frac{w_i}{v_i}), v_i \ge 0, w_i \ge 0 \}`` |
| [`HyperRectangle(l, u)`](@ref MathOptInterface.HyperRectangle)        | ``\{x \in \bar{\mathbb{R}}^d: x_i \in [l_i, u_i] \forall i=1,\ldots,d\}`` |
| [`NormCone(p, d)`](@ref MathOptInterface.NormCone)       | ``\{ (t,x) \in \mathbb{R}^{d} : t \ge \left(\sum\limits_i \lvert x_i \rvert^p\right)^{\frac{1}{p}} \}`` |
| [`VectorNonlinearOracle`](@ref MathOptInterface.VectorNonlinearOracle)| ``\{x \in \mathbb{R}^{dimension}: l \le f(x) \le u \}`` |

## Matrix cones

The matrix-valued set types implemented in MathOptInterface.jl are:

| Set              | Description |
| :--------------- | :----------- |
| [`RootDetConeTriangle(d)`](@ref MathOptInterface.RootDetConeTriangle) | ``\{ (t,X) \in \mathbb{R}^{1+d(1+d)/2} : t \le \det(X)^{1/d}, X \mbox{ is the upper triangle of a PSD matrix} \}`` |
| [`RootDetConeSquare(d)`](@ref MathOptInterface.RootDetConeSquare)     | ``\{ (t,X) \in \mathbb{R}^{1+d^2} : t \le \det(X)^{1/d}, X \mbox{ is a PSD matrix} \}`` |
| [`PositiveSemidefiniteConeTriangle(d)`](@ref MathOptInterface.PositiveSemidefiniteConeTriangle) | ``\{ X \in \mathbb{R}^{d(d+1)/2} : X \mbox{ is the upper triangle of a PSD matrix} \}`` |
| [`PositiveSemidefiniteConeSquare(d)`](@ref MathOptInterface.PositiveSemidefiniteConeSquare) | ``\{ X \in \mathbb{R}^{d^2} : X \mbox{ is a PSD matrix} \}`` |
| [`LogDetConeTriangle(d)`](@ref MathOptInterface.LogDetConeTriangle)   | ``\{ (t,u,X) \in \mathbb{R}^{2+d(1+d)/2} : t \le u\log(\det(X/u)), X \mbox{ is the upper triangle of a PSD matrix}, u > 0  \}`` |
| [`LogDetConeSquare(d)`](@ref MathOptInterface.LogDetConeSquare)       | ``\{ (t,u,X) \in \mathbb{R}^{2+d^2} : t \le u \log(\det(X/u)), X \mbox{ is a PSD matrix}, u > 0 \}`` |
| [`NormSpectralCone(r, c)`](@ref MathOptInterface.NormSpectralCone)    | ``\{ (t, X) \in \mathbb{R}^{1 + r \times c} : t \ge \sigma_1(X), X \mbox{ is a } r\times c\mbox{ matrix} \}``
| [`NormNuclearCone(r, c)`](@ref MathOptInterface.NormNuclearCone)      | ``\{ (t, X) \in \mathbb{R}^{1 + r \times c} : t \ge \sum_i \sigma_i(X), X \mbox{ is a } r\times c\mbox{ matrix} \}`` |
| [`HermitianPositiveSemidefiniteConeTriangle(d)`](@ref MathOptInterface.HermitianPositiveSemidefiniteConeTriangle) | The cone of Hermitian positive semidefinite matrices, with
`side_dimension` rows and columns. |
| [`Scaled(S)`](@ref MathOptInterface.Scaled) | The set `S` scaled so that [`Utilities.set_dot`](@ref MathOptInterface.Utilities.set_dot) corresponds to `LinearAlgebra.dot` |

Some of these cones can take two forms: `XXXConeTriangle` and `XXXConeSquare`.

In `XXXConeTriangle` sets, the matrix is assumed to be symmetric, and the
elements are provided by a vector, in which the entries of the upper-right
triangular part of the matrix are given column by column (or equivalently, the
entries of the lower-left triangular part are given row by row).

In `XXXConeSquare` sets, the entries of the matrix are given column by column
(or equivalently, row by row), and the matrix is constrained to be symmetric. As
an example, given a 2-by-2 matrix of variables `X` and a one-dimensional
variable `t`, we can specify a root-det constraint as
`[t, X11, X12, X22] ∈ RootDetConeTriangle` or
`[t, X11, X12, X21, X22] ∈ RootDetConeSquare`.

We provide both forms to enable flexibility for solvers who may natively support
one or the other. Transformations between `XXXConeTriangle` and `XXXConeSquare`
are handled by bridges, which removes the chance of conversion mistakes by users
or solver developers.

## Multi-dimensional sets with combinatorial structure

Other sets are vector-valued, with a particular combinatorial structure. Read
their docstrings for more information on how to interpret them.

| Set                        | Description |
| :------------------------- | :---------- |
| [`SOS1`](@ref)             | A Special Ordered Set (SOS) of Type I |
| [`SOS2`](@ref)             | A Special Ordered Set (SOS) of Type II |
| [`Indicator`](@ref)        | A set to specify an indicator constraint |
| [`Complements`](@ref)      | A set to specify a mixed complementarity constraint |
| [`AllDifferent`](@ref)     | The `all_different` global constraint |
| [`BinPacking`](@ref)       | The `bin_packing` global constraint |
| [`Circuit`](@ref)          | The `circuit` global constraint |
| [`CountAtLeast`](@ref)     | The `at_least` global constraint |
| [`CountBelongs`](@ref)     | The `nvalue` global constraint |
| [`CountDistinct`](@ref)    | The `distinct` global constraint |
| [`CountGreaterThan`](@ref) | The `count_gt` global constraint |
| [`Cumulative`](@ref)       | The `cumulative` global constraint |
| [`Path`](@ref)             | The `path` global constraint |
| [`Table`](@ref)            | The `table` global constraint |

# Transitioning from MathProgBase

MathOptInterface is a replacement for [MathProgBase.jl](https://github.com/JuliaOpt/MathProgBase.jl).
However, it is not a direct replacement.

## Transitioning a solver interface

MathOptInterface is more extensive than MathProgBase which may make its
implementation seem daunting at first.
There are however numerous utilities in MathOptInterface that
the simplify implementation process.

For more information, read [Implementing a solver interface](@ref).

## Transitioning the high-level functions

MathOptInterface doesn't provide replacements for the high-level interfaces in
MathProgBase. We recommend you use [JuMP](https://github.com/jump-dev/JuMP.jl)
as a modeling interface instead.

!!! tip
    If you haven't used JuMP before, start with the tutorial
    [Getting started with JuMP](https://jump.dev/JuMP.jl/stable/tutorials/getting_started/getting_started_with_JuMP/)

### `linprog`

Here is one way of transitioning from `linprog`:

```julia
using JuMP

function linprog(c, A, sense, b, l, u, solver)
    N = length(c)
    model = Model(solver)
    @variable(model, l[i] <= x[i=1:N] <= u[i])
    @objective(model, Min, c' * x)
    eq_rows, ge_rows, le_rows = sense .== '=', sense .== '>', sense .== '<'
    @constraint(model, A[eq_rows, :] * x .== b[eq_rows])
    @constraint(model, A[ge_rows, :] * x .>= b[ge_rows])
    @constraint(model, A[le_rows, :] * x .<= b[le_rows])
    optimize!(model)
    return (
        status = termination_status(model),
        objval = objective_value(model),
        sol = value.(x)
    )
end
```

### `mixintprog`

Here is one way of transitioning from `mixintprog`:

```julia
using JuMP

function mixintprog(c, A, rowlb, rowub, vartypes, lb, ub, solver)
    N = length(c)
    model = Model(solver)
    @variable(model, lb[i] <= x[i=1:N] <= ub[i])
    for i in 1:N
        if vartypes[i] == :Bin
            set_binary(x[i])
        elseif vartypes[i] == :Int
            set_integer(x[i])
        end
    end
    @objective(model, Min, c' * x)
    @constraint(model, rowlb .<= A * x .<= rowub)
    optimize!(model)
    return (
        status = termination_status(model),
        objval = objective_value(model),
        sol = value.(x)
    )
end
```

### `quadprog`

Here is one way of transitioning from `quadprog`:

```julia
using JuMP

function quadprog(c, Q, A, rowlb, rowub, lb, ub, solver)
    N = length(c)
    model = Model(solver)
    @variable(model, lb[i] <= x[i=1:N] <= ub[i])
    @objective(model, Min, c' * x + 0.5 * x' * Q * x)
    @constraint(model, rowlb .<= A * x .<= rowub)
    optimize!(model)
    return (
        status = termination_status(model),
        objval = objective_value(model),
        sol = value.(x)
    )
end
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# [Constraints](@id constraints_ref)

## Types

```@docs
ConstraintIndex
```

## Functions

```@docs
is_valid(::ModelLike,::ConstraintIndex)
add_constraint
add_constraints
transform
supports_constraint
```

## Attributes

```@docs
AbstractConstraintAttribute
ConstraintName
ConstraintPrimalStart
ConstraintDualStart
ConstraintPrimal
ConstraintDual
ConstraintBasisStatus
ConstraintFunction
CanonicalConstraintFunction
ConstraintSet
BasisStatusCode
BASIC
NONBASIC
NONBASIC_AT_LOWER
NONBASIC_AT_UPPER
SUPER_BASIC
LagrangeMultiplier
LagrangeMultiplierStart
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Implementing a solver interface

This guide outlines the basic steps to implement an interface to
MathOptInterface for a new solver.

!!! danger
    Implementing an interface to MathOptInterface for a new solver is a lot of
    work. Before starting, we recommend that you join the
    [Developer chatroom](https://jump.dev/chatroom/) and explain a
    little bit about the solver you are wrapping. If you have questions that are
    not answered by this guide, please ask them in the [Developer chatroom](https://jump.dev/chatroom/)
    so we can improve this guide.

## A note on the API

The API of MathOptInterface is large and varied. In order to support the
diversity of solvers and use-cases, we make heavy use of
[duck-typing](https://en.wikipedia.org/wiki/Duck_typing). That is, solvers are
not expected to implement the full API, nor is there a well-defined minimal
subset of what must be implemented. Instead, you should implement the API as
necessary to make the solver function as you require.

The main reason for using duck-typing is that solvers work in different ways and
target different use-cases.

For example:

 * Some solvers support incremental problem construction, support modification
   after a solve, and have native support for things like variable names.
 * Other solvers are "one-shot" solvers that require all of the problem data to
   construct and solve the problem in a single function call. They do not
   support modification or things like variable names.
 * Other "solvers" are not solvers at all, but things like file readers. These
   may only support functions like [`read_from_file`](@ref), and may not even
   support the ability to add variables or constraints directly.
 * Finally, some "solvers" are layers which take a problem as input, transform
   it according to some rules, and pass the transformed problem to an inner
   solver.

## Preliminaries

Before starting on your wrapper, you should do some background research and make
the solver accessible via Julia.

### Decide if MathOptInterface is right for you

The first step in writing a wrapper is to decide whether implementing an
interface is the right thing to do.

MathOptInterface is an abstraction layer for unifying _constrained_ mathematical
optimization solvers. If your solver doesn't fit in the category, for example,
it implements a derivative-free algorithm for unconstrained objective functions,
MathOptInterface may not be the right tool for the job.

!!! tip
    If you're not sure whether you should write an interface, ask in the
    [Developer chatroom](https://jump.dev/chatroom/).

### Find a similar solver already wrapped

The next step is to find (if possible) a similar solver that is already wrapped.
Although not strictly necessary, this will be a good place to look for
inspiration when implementing your wrapper.

The [JuMP documentation](https://jump.dev/JuMP.jl/stable/installation/#Supported-solvers)
has a good list of solvers, along with the problem classes they support.

!!! tip
    If you're not sure which solver is most similar, ask in the
    [Developer chatroom](https://jump.dev/chatroom/).

### Create a low-level interface

Before writing a MathOptInterface wrapper, you first need to be able to call the
solver from Julia.

#### Wrapping solvers written in Julia

If your solver is written in Julia, there's nothing to do here. Go to the next
section.

#### Wrapping solvers written in C

Julia is well suited to wrapping solvers written in C.

!!! info
    This is _not_ true for C++. If you have a solver written in C++, first write
    a C interface, then wrap the C interface.

Before writing a MathOptInterface wrapper, there are a few extra steps.

##### Create a JLL

If the C code is publicly available under an open source license, create a
JLL package via [Yggdrasil](https://github.com/JuliaPackaging/Yggdrasil). The
easiest way to do this is to copy an existing solver. Good examples to follow
are the [COIN-OR solvers](https://github.com/JuliaPackaging/Yggdrasil/tree/master/C/Coin-OR).

!!! warning
    Building the solver via Yggdrasil is non-trivial. Please ask the
    [Developer chatroom](https://jump.dev/chatroom/) for help.

If the code is commercial or not publicly available, the user will need to
manually install the solver. See [Gurobi.jl](https://github.com/jump-dev/Gurobi.jl)
or [CPLEX.jl](https://github.com/jump-dev/CPLEX.jl) for examples of how to
structure this.

##### [Use Clang.jl to wrap the C API](@id implement_clang)

The next step is to use [Clang.jl](https://github.com/JuliaInterop/Clang.jl) to
automatically wrap the C API. The easiest way to do this is to follow an
example. Good examples to follow are
[Cbc.jl](https://github.com/jump-dev/Cbc.jl/blob/master/scripts/clang.jl) and
[HiGHS.jl](https://github.com/jump-dev/HiGHS.jl/blob/master/gen/gen.jl).

Sometimes, you will need to make manual modifications to the resulting files.

#### Solvers written in other languages

Ask the [Developer chatroom](https://jump.dev/chatroom/) for advice.
You may be able to use one of the [JuliaInterop](https://github.com/JuliaInterop)
packages to call out to the solver.

For example, [SeDuMi.jl](https://github.com/jump-dev/SeDuMi.jl) uses
[MATLAB.jl](https://github.com/JuliaInterop/MATLAB.jl) to call the SeDuMi solver
written in MATLAB.

## Structuring the package

Structure your wrapper as a Julia package. Consult the
[Julia documentation](https://pkgdocs.julialang.org/v1/creating-packages/)
if you haven't done this before.

MOI solver interfaces may be in the same package as the solver itself (either
the C wrapper if the solver is accessible through C, or the Julia code if the
solver is written in Julia, for example), or in a separate package which depends
on the solver package.

!!! note
    The JuMP [core contributors](https://jump.dev/pages/governance/#core-contributors)
    request that you do not use "JuMP" in the name of your package without prior
    consent.

Your package should have the following structure:
```
/.github
    /workflows
        ci.yml
        format_check.yml
        TagBot.yml
/gen
    gen.jl  # Code to wrap the C API
/src
    NewSolver.jl
    /gen
        libnewsolver_api.jl
        libnewsolver_common.jl
    /MOI_wrapper
        MOI_wrapper.jl
        other_files.jl
/test
    runtests.jl
    /MOI_wrapper
        MOI_wrapper.jl
.gitignore
.JuliaFormatter.toml
README.md
LICENSE.md
Project.toml
```

 * The `/.github` folder contains the scripts for GitHub actions. The easiest
   way to write these is to copy the ones from an existing solver.
 * The `/gen` and `/src/gen` folders are only needed if you are wrapping a
   [solver written in C](@ref implement_clang).
 * The `/src/MOI_wrapper` folder contains the Julia code for the MOI wrapper.
 * The `/test` folder contains code for testing your package. See
   [Setup tests](@ref) for more information.
 * The `.JuliaFormatter.toml` and `.github/workflows/format_check.yml` enforce
   code formatting using [JuliaFormatter.jl](https://github.com/domluna/JuliaFormatter.jl).
   Check existing solvers or JuMP.jl for details.

### Documentation

Your package must include documentation explaining how to use the package. The
easiest approach is to include documentation in your `README.md`. A more
involved option is to use [Documenter.jl](https://github.com/JuliaDocs/Documenter.jl).

Examples of packages with README-based documentation include:
 * [Cbc.jl](https://github.com/jump-dev/Cbc.jl)
 * [HiGHS.jl](https://github.com/jump-dev/HiGHS.jl)
 * [SCS.jl](https://github.com/jump-dev/SCS.jl)

Examples of packages with Documenter-based documentation include:
 * [Alpine.jl](https://github.com/lanl-ansi/Alpine.jl)
 * [COSMO.jl](https://github.com/oxfordcontrol/COSMO.jl)
 * [Juniper.jl](https://github.com/lanl-ansi/Juniper.jl)

### Setup tests

The best way to implement an interface to MathOptInterface is via
[test-driven development](https://en.wikipedia.org/wiki/Test-driven_development).

The [`MOI.Test` submodule](@ref test_module) contains a large test suite to help
check that you have implemented things correctly.

Follow the guide [How to test a solver](@ref) to set up the tests for your
package.

!!! tip
    Run the tests frequently when developing. However, at the start there is
    going to be a lot of errors. Start by excluding large classes of tests
    (for example, `exclude = ["test_basic_", "test_model_"]`, implement any
    missing methods until the tests pass, then remove an exclusion and repeat.

## Initial code

By this point, you should have a package setup with tests, formatting, and
access to the underlying solver. Now it's time to start writing the wrapper.

### The `Optimizer` object

The first object to create is a subtype of [`AbstractOptimizer`](@ref). This
type is going to store everything related to the problem.

By convention, these optimizers should not be exported and should be named
`PackageName.Optimizer`.

```julia
import MathOptInterface as MOI

struct Optimizer <: MOI.AbstractOptimizer
    # Fields go here
end
```

#### Optimizer objects for C solvers

!!! warning
    This section is important if you wrap a solver written in C.

Wrapping a solver written in C will require the use of pointers, and for you to
manually free the solver's memory when the `Optimizer` is garbage collected by
Julia.

**Never pass a pointer directly to a Julia `ccall` function.**

Instead, store the pointer as a field in your `Optimizer`, and implement
`Base.cconvert` and `Base.unsafe_convert`. Then you can pass `Optimizer` to any
`ccall` function that expects the pointer.

In addition, make sure you implement a `finalizer` for each model you create.

If `newsolver_createProblem()` is the low-level function that creates the
problem pointer in C, and `newsolver_freeProblem(::Ptr{Cvoid})` is the low-level
function that frees memory associated with the pointer, your `Optimizer()`
function should look like this:
```julia
struct Optimizer <: MOI.AbstractOptimizer
    ptr::Ptr{Cvoid}

    function Optimizer()
        ptr = newsolver_createProblem()
        model = Optimizer(ptr)
        finalizer(model) do m
            newsolver_freeProblem(m)
            return
        end
        return model
    end
end

Base.cconvert(::Type{Ptr{Cvoid}}, model::Optimizer) = model
Base.unsafe_convert(::Type{Ptr{Cvoid}}, model::Optimizer) = model.ptr
```

### Implement methods for `Optimizer`

All `Optimizer`s must implement the following methods:

 * [`empty!`](@ref)
 * [`is_empty`](@ref)

Other methods, detailed below, are optional or depend on how you implement the
interface.

!!! tip
    For this and all future methods, read the docstrings to understand what each
    method does, what it expects as input, and what it produces as output. If it
    isn't clear, let us know and we will improve the docstrings.
    It is also very helpful to look at an existing wrapper for a similar solver.

You should also implement `Base.summary(::IO, ::Optimizer)` to print a nice
string when someone shows your model. For example
```julia
function Base.summary(io::IO, model::Optimizer)
    return print(io, "NewSolver with the pointer $(model.ptr)")
end
```

### Implement attributes

MathOptInterface uses attributes to manage different aspects of the problem.

For each attribute
 * [`get`](@ref) gets the current value of the attribute
 * [`set`](@ref) sets a new value of the attribute. Not all attributes can be
   set. For example, the user can't modify the [`SolverName`](@ref).
 * [`supports`](@ref) returns a `Bool` indicating whether the solver supports the
   attribute.

!!! info
    Use [`attribute_value_type`](@ref) to check the value expected by a given
    attribute. You should make sure that your [`get`](@ref) function correctly
    infers to this type (or a subtype of it).

Each column in the table indicates whether you need to implement the particular
method for each attribute.

| Attribute              | [`get`](@ref) | [`set`](@ref) | [`supports`](@ref) |
| ---------------------- | --------------| ------------- | ------------------ |
| [`SolverName`](@ref)   | Yes           | No            | No                 |
| [`SolverVersion`](@ref) | Yes          | No            | No                 |
| [`RawSolver`](@ref)    | Yes           | No            | No                 |
| [`Name`](@ref)         | Yes           | Yes           | Yes                |
| [`Silent`](@ref)       | Yes           | Yes           | Yes                |
| [`TimeLimitSec`](@ref) | Yes           | Yes           | Yes                |
| [`ObjectiveLimit`](@ref) | Yes         | Yes           | Yes                |
| [`SolutionLimit`](@ref) | Yes          | Yes           | Yes                |
| [`NodeLimit`](@ref)     | Yes          | Yes           | Yes                |
| [`RawOptimizerAttribute`](@ref) | Yes  | Yes           | Yes                |
| [`NumberOfThreads`](@ref) | Yes        | Yes           | Yes                |
| [`AbsoluteGapTolerance`](@ref) | Yes   | Yes           | Yes                |
| [`RelativeGapTolerance`](@ref) | Yes   | Yes           | Yes                |

For example:
```julia
function MOI.get(model::Optimizer, ::MOI.Silent)
    return # true if MOI.Silent is set
end

function MOI.set(model::Optimizer, ::MOI.Silent, v::Bool)
    if v
        # Set a parameter to turn off printing
    else
        # Restore the default printing
    end
    return
end

MOI.supports(::Optimizer, ::MOI.Silent) = true
```
### Define `supports_constraint`

The next step is to define which constraints and objective functions you plan to
support.

For each function-set constraint pair, define [`supports_constraint`](@ref):
```julia
function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VariableIndex},
    ::Type{MOI.ZeroOne},
)
    return true
end
```
To make this easier, you may want to use `Union`s:
```julia
function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VariableIndex},
    ::Type{<:Union{MOI.LessThan,MOI.GreaterThan,MOI.EqualTo}},
)
    return true
end
```

!!! tip
    Only support a constraint if your solver has native support for it.

## The big decision: incremental modification?

Now you need to decide whether to support incremental modification or not.

Incremental modification means that the user can add variables and constraints
one-by-one without needing to rebuild the entire problem, and they can modify
the problem data after an [`optimize!`](@ref) call. Supporting incremental
modification means implementing functions like [`add_variable`](@ref) and
[`add_constraint`](@ref).

The alternative is to accept the problem data in a single [`optimize!`](@ref) or
[`copy_to`](@ref) function call. Because these functions see all of the data at
once, it can typically call a more efficient function to load data into the
underlying solver.

Good examples of solvers supporting incremental modification are MILP solvers
like [GLPK.jl](https://github.com/jump-dev/GLPK.jl) and
[Gurobi.jl](https://github.com/jump-dev/Gurobi.jl). Examples of non-incremental
solvers are [AmplNLWriter.jl](https://github.com/jump-dev/AmplNLWriter.jl) and
[SCS.jl](https://github.com/jump-dev/SCS.jl)

It is possible for a solver to implement both approaches, but you should
probably start with one for simplicity.

!!! tip
    Only support incremental modification if your solver has native support for
    it.

In general, supporting incremental modification is more work, and it usually
requires some extra book-keeping. However, it provides a more efficient
interface to the solver if the problem is going to be resolved multiple times
with small modifications. Moreover, once you've implemented incremental
modification, it's usually not much extra work to add a [`copy_to`](@ref)
interface. The converse is not true.

!!! tip
    If this is your first time writing an interface, start with the one-shot
    [`optimize!`](@ref).

### The non-incremental interface

There are two ways to implement the non-incremental interface. The first uses a
two-argument version of [`optimize!`](@ref), the second implements [`copy_to`](@ref)
followed by the one-argument version of [`optimize!`](@ref).

If your solver does not support modification, and requires all data to solve the
problem in a single function call, you should implement the "one-shot" [`optimize!`](@ref).

 * [`optimize!(::ModelLike, ::ModelLike)`](@ref)

If your solver separates data loading and the actual optimization into separate
steps, implement the [`copy_to`](@ref) interface.

 * [`copy_to(::ModelLike, ::ModelLike)`](@ref)
 * [`optimize!(::ModelLike)`](@ref)

### The incremental interface

!!! warning
    Writing this interface is a lot of work. The easiest way is to consult the
    source code of a similar solver.

To implement the incremental interface, implement the following functions:

* [`add_variable`](@ref)
* [`add_variables`](@ref)
* [`add_constraint`](@ref)
* [`add_constraints`](@ref)
* [`is_valid`](@ref)
* [`delete`](@ref)
* [`optimize!(::ModelLike)`](@ref)

!!! info
    Solvers do not have to support `AbstractScalarFunction` in
    `GreaterThan`, `LessThan`, `EqualTo`, or `Interval` with a nonzero constant
    in the function. Throw [`ScalarFunctionConstantNotZero`](@ref) if the
    function constant is not zero.

In addition, you should implement the following model attributes:

| Attribute              | [`get`](@ref) | [`set`](@ref) | [`supports`](@ref) |
| ---------------------- | --------------| ------------- | ------------------ |
| [`ListOfModelAttributesSet`](@ref) | Yes           | No            | No     |
| [`ObjectiveFunctionType`](@ref)    | Yes           | No            | No     |
| [`ObjectiveFunction`](@ref)        | Yes           | Yes           | Yes    |
| [`ObjectiveSense`](@ref)           | Yes           | Yes           | Yes    |
| [`Name`](@ref)                     | Yes           | Yes           | Yes    |

Variable-related attributes:

| Attribute              | [`get`](@ref) | [`set`](@ref) | [`supports`](@ref) |
| ---------------------- | --------------| ------------- | ------------------ |
| [`ListOfVariableAttributesSet`](@ref)  | Yes           | No            | No |
| [`ListOfVariablesWithAttributeSet`](@ref)  | Yes       | No            | No |
| [`NumberOfVariables`](@ref)            | Yes           | No            | No |
| [`ListOfVariableIndices`](@ref)        | Yes           | No            | No |

Constraint-related attributes:

| Attribute              | [`get`](@ref) | [`set`](@ref) | [`supports`](@ref) |
| ---------------------- | --------------| ------------- | ------------------ |
| [`ListOfConstraintAttributesSet`](@ref) | Yes          | No            | No |
| [`ListOfConstraintsWithAttributeSet`](@ref)  | Yes     | No            | No |
| [`NumberOfConstraints`](@ref)           | Yes          | No            | No |
| [`ListOfConstraintTypesPresent`](@ref)  | Yes          | No            | No |
| [`ConstraintFunction`](@ref)            | Yes          | Yes           | No |
| [`ConstraintSet`](@ref)                 | Yes          | Yes           | No |

#### Modifications

If your solver supports modifying data in-place, implement [`modify`](@ref) for
the following `AbstractModification`s:

* [`ScalarConstantChange`](@ref)
* [`ScalarCoefficientChange`](@ref)
* [`ScalarQuadraticCoefficientChange`](@ref)
* [`VectorConstantChange`](@ref)
* [`MultirowChange`](@ref)

#### Variables constrained on creation

Some solvers require variables be associated with a set _when they are created_.
This conflicts with the incremental modification approach, since you cannot
first add a free variable and then constrain it to the set.

If this is the case, implement:

* [`add_constrained_variable`](@ref)
* [`add_constrained_variables`](@ref)
* [`supports_add_constrained_variables`](@ref)

By default, MathOptInterface assumes solvers support free variables. If your
solver does not support free variables, define:
```julia
MOI.supports_add_constrained_variables(::Optimizer, ::Type{Reals}) = false
```

### Incremental and `copy_to`

If you implement the incremental interface, you have the option of also
implementing [`copy_to`](@ref).

If you don't want to implement [`copy_to`](@ref), for example, because the
solver has no API for building the problem in a single function call, define the
following fallback:
```julia
MOI.supports_incremental_interface(::Optimizer) = true

function MOI.copy_to(dest::Optimizer, src::MOI.ModelLike)
    return MOI.Utilities.default_copy_to(dest, src)
end
```

## [Names](@id implement_names)

Regardless of which interface you implement, you have the option of implementing
the `Name` attribute for variables and constraints:

| Attribute              | [`get`](@ref) | [`set`](@ref) | [`supports`](@ref) |
| ---------------------- | --------------| ------------- | ------------------ |
| [`VariableName`](@ref)   | Yes         | Yes           | Yes                |
| [`ConstraintName`](@ref) | Yes         | Yes           | Yes                |

If you implement names, you must also implement the following three methods:

```julia
function MOI.get(model::Optimizer, ::Type{MOI.VariableIndex}, name::String)
    return # The variable named `name`.
end

function MOI.get(model::Optimizer, ::Type{MOI.ConstraintIndex}, name::String)
    return # The constraint any type named `name`.
end

function MOI.get(
    model::Optimizer,
    ::Type{MOI.ConstraintIndex{F,S}},
    name::String,
) where {F,S}
    return # The constraint of type F-in-S named `name`.
end
```

These methods have the following rules:

* If there is no variable or constraint with the name, return `nothing`
* If there is a single variable or constraint with that name, return the
  variable or constraint
* If there are multiple variables or constraints with the name, throw an error.

!!! warning
    You should _not_ implement [`ConstraintName`](@ref) for
    [`VariableIndex`](@ref) constraints. If you implement [`ConstraintName`](@ref)
    for other constraints, you can add the following two methods to disable
    [`ConstraintName`](@ref) for [`VariableIndex`](@ref) constraints.
    ```julia
    function MOI.supports(
        ::Optimizer,
        ::MOI.ConstraintName,
        ::Type{<:MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet}},
    )
        return throw(MOI.VariableIndexConstraintNameError())
    end
    function MOI.set(
        ::Optimizer,
        ::MOI.ConstraintName,
        ::MOI.ConstraintIndex{MOI.VariableIndex,<:MOI.AbstractScalarSet},
        ::String,
    )
        return throw(MOI.VariableIndexConstraintNameError())
    end
    ```

## Solutions

Implement [`optimize!`](@ref) to solve the model:

* [`optimize!`](@ref)

All `Optimizer`s must implement the following attributes:

* [`DualStatus`](@ref)
* [`PrimalStatus`](@ref)
* [`RawStatusString`](@ref)
* [`ResultCount`](@ref)
* [`TerminationStatus`](@ref)

!!! info
    You only need to implement [`get`](@ref) for solution attributes. Don't
    implement [`set`](@ref) or [`supports`](@ref).

!!! note
    Solver wrappers should document how the low-level statuses map to the MOI
    statuses. Statuses like `NEARLY_FEASIBLE_POINT` and `INFEASIBLE_POINT`, are
    designed to be used when the solver explicitly indicates that relaxed
    tolerances are satisfied or the returned point is infeasible, respectively.

You should also implement the following attributes:

* [`ObjectiveValue`](@ref)
* [`SolveTimeSec`](@ref)
* [`VariablePrimal`](@ref)

!!! tip
    Attributes like [`VariablePrimal`](@ref) and [`ObjectiveValue`](@ref) are
    indexed by the result count. Use
    `MOI.check_result_index_bounds(model, attr)` to throw an error if the
    attribute is not available.

If your solver returns dual solutions, implement:

* [`ConstraintDual`](@ref)
* [`DualObjectiveValue`](@ref)

For integer solvers, implement:

* [`ObjectiveBound`](@ref)
* [`RelativeGap`](@ref)

If applicable, implement:

* [`SimplexIterations`](@ref)
* [`BarrierIterations`](@ref)
* [`NodeCount`](@ref)

If your solver uses the Simplex method, implement:

* [`ConstraintBasisStatus`](@ref)

If your solver accepts primal or dual warm-starts, implement:

* [`VariablePrimalStart`](@ref)
* [`ConstraintDualStart`](@ref)

## Other tips

Here are some other points to be aware of when writing your wrapper.

### Unsupported constraints at runtime

In some cases, your solver may support a particular type of constraint (for
example, quadratic constraints), but only if the data meets some condition (for
example, it is convex).

In this case, declare that you `support` the constraint, and throw
[`AddConstraintNotAllowed`](@ref).

### Dealing with multiple variable bounds

MathOptInterface uses [`VariableIndex`](@ref) constraints to represent variable
bounds. Defining multiple variable bounds on a single variable is not allowed.

Throw [`LowerBoundAlreadySet`](@ref) or [`UpperBoundAlreadySet`](@ref) if the
user adds a constraint that results in multiple bounds.

Only throw if the constraints conflict. It is okay to add
[`VariableIndex`](@ref)-in-[`GreaterThan`](@ref) and then
[`VariableIndex`](@ref)-in-[`LessThan`](@ref), but not
[`VariableIndex`](@ref)-in-[`Interval`](@ref) and then
[`VariableIndex`](@ref)-in-[`LessThan`](@ref),

### Expect duplicate coefficients

Solvers must expect that functions such as [`ScalarAffineFunction`](@ref) and
[`VectorQuadraticFunction`](@ref) may contain duplicate coefficients.

For example,
`ScalarAffineFunction([ScalarAffineTerm(x, 1), ScalarAffineTerm(x, 1)], 0.0)`.

Use [`Utilities.canonical`](@ref) to return a new function with the duplicate
coefficients aggregated together.

### Don't modify user-data

All data passed to the solver must be copied immediately to internal data
structures. Solvers may not modify any input vectors and must assume that
input vectors will not be modified by users in the future.

This applies, for example, to the `terms` vector in
[`ScalarAffineFunction`](@ref). Vectors returned to the user, for example, via
[`ObjectiveFunction`](@ref) or
[`ConstraintFunction`](@ref) attributes, must not be modified by the solver
afterwards. The in-place version of [`get!`](@ref) can be used by users to avoid
extra copies in this case.

### Column Generation

There is no special interface for column generation. If the solver has a special
API for setting coefficients in existing constraints when adding a new variable,
it is possible to queue modifications and new variables and then call the
solver's API once all of the new coefficients are known.

### Solver-specific attributes

You don't need to restrict yourself to the attributes defined in the
MathOptInterface.jl package.

Solver-specific attributes should be specified by creating an appropriate
subtype of [`AbstractModelAttribute`](@ref), [`AbstractOptimizerAttribute`](@ref),
[`AbstractVariableAttribute`](@ref), or [`AbstractConstraintAttribute`](@ref).

For example, Gurobi.jl adds attributes for multiobjective optimization by
[defining](https://github.com/jump-dev/Gurobi.jl/blob/d9cebe4ec05a102df8917ff2602e6c38abdac090/src/MOI_multi_objective.jl#L1-L15):
```julia
struct NumberOfObjectives <: MOI.AbstractModelAttribute end

function MOI.set(model::Optimizer, ::NumberOfObjectives, n::Integer)
    # Code to set NumberOfObjectives
    return
end

function MOI.get(model::Optimizer, ::NumberOfObjectives)
    n = # Code to get NumberOfObjectives
    return n
end
```

Then, the user can write:
```julia
model = Gurobi.Optimizer()
MOI.set(model, Gurobi.NumberofObjectives(), 3)
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Models

The most significant part of MOI is the definition of the **model API** that is
used to specify an instance of an optimization problem (for example, by adding
variables and constraints). Objects that implement the model API must inherit
from the [`ModelLike`](@ref) abstract type.

Notably missing from the model API is the method to solve an optimization
problem. `ModelLike` objects may store an instance (for example, in memory or
backed by a file format) without being linked to a particular solver. In
addition to the model API, MOI defines [`AbstractOptimizer`](@ref) and provides
methods to solve the model and interact with solutions. See the
[Solutions](@ref manual_solutions) section for more details.

!!! info
    Throughout the rest of the manual, `model` is used as a generic `ModelLike`,
    and `optimizer` is used as a generic `AbstractOptimizer`.

!!! tip
    MOI does not export functions, but for brevity we often omit qualifying
    names with the MOI module. Best practice is to have
    ```julia
    import MathOptInterface as MOI
    ```
    and prefix all MOI methods with `MOI.` in user code. If a name is also
    available in base Julia, we always explicitly use the module prefix, for
    example, with `MOI.get`.

## Attributes

Attributes are properties of the model that can be queried and modified. These
include constants such as the number of variables in a model [`NumberOfVariables`](@ref)),
and properties of variables and constraints such as the name of a variable
([`VariableName`](@ref)).

There are four types of attributes:

 * Model attributes (subtypes of [`AbstractModelAttribute`](@ref)) refer to
   properties of a model.
 * Optimizer attributes (subtypes of [`AbstractOptimizerAttribute`](@ref)) refer
   to properties of an optimizer.
 * Constraint attributes (subtypes of [`AbstractConstraintAttribute`](@ref))
   refer to properties of an individual constraint.
 * Variable attributes (subtypes of [`AbstractVariableAttribute`](@ref)) refer
   to properties of an individual variable.

Some attributes are values that can be queried by the user but not modified,
while other attributes can be modified by the user.

All interactions with attributes occur through the [`get`](@ref) and [`set`](@ref)
functions.

Consult the docstrings of each attribute for information on what it represents.

## ModelLike API

The following attributes are available:

 * [`ListOfConstraintAttributesSet`](@ref)
 * [`ListOfConstraintIndices`](@ref)
 * [`ListOfConstraintTypesPresent`](@ref)
 * [`ListOfConstraintsWithAttributeSet`](@ref)
 * [`ListOfModelAttributesSet`](@ref)
 * [`ListOfVariableAttributesSet`](@ref)
 * [`ListOfVariableIndices`](@ref)
 * [`ListOfVariablesWithAttributeSet`](@ref)
 * [`NumberOfConstraints`](@ref)
 * [`NumberOfVariables`](@ref)
 * [`Name`](@ref)
 * [`ObjectiveFunction`](@ref)
 * [`ObjectiveFunctionType`](@ref)
 * [`ObjectiveSense`](@ref)

## AbstractOptimizer API

The following attributes are available:

 * [`DualStatus`](@ref)
 * [`PrimalStatus`](@ref)
 * [`RawStatusString`](@ref)
 * [`ResultCount`](@ref)
 * [`TerminationStatus`](@ref)
 * [`BarrierIterations`](@ref)
 * [`DualObjectiveValue`](@ref)
 * [`NodeCount`](@ref)
 * [`NumberOfThreads`](@ref)
 * [`ObjectiveBound`](@ref)
 * [`ObjectiveValue`](@ref)
 * [`RelativeGap`](@ref)
 * [`RawOptimizerAttribute`](@ref)
 * [`RawSolver`](@ref)
 * [`Silent`](@ref)
 * [`SimplexIterations`](@ref)
 * [`SolverName`](@ref)
 * [`SolverVersion`](@ref)
 * [`SolveTimeSec`](@ref)
 * [`TimeLimitSec`](@ref)
 * [`ObjectiveLimit`](@ref)
 * [`SolutionLimit`](@ref)
 * [`NodeLimit`](@ref)
 * [`AutomaticDifferentiationBackend`](@ref)

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Naming conventions

MOI follows several conventions for naming functions and structures. These
should also be followed by packages extending MOI.

## Sets

Sets encode the structure of constraints. Their names should follow the
following conventions:

* Abstract types in the set hierarchy should begin with `Abstract` and end in
  `Set`, for example, [`AbstractScalarSet`](@ref), [`AbstractVectorSet`](@ref).
* Vector-valued conic sets should end with `Cone`, for example,
  [`NormInfinityCone`](@ref), [`SecondOrderCone`](@ref).
* Vector-valued Cartesian products should be plural and not end in `Cone`,
  for example, [`Nonnegatives`](@ref), not `NonnegativeCone`.
* Matrix-valued conic sets should provide two representations: `ConeSquare` and
  `ConeTriangle`, for example, [`RootDetConeTriangle`](@ref) and
  [`RootDetConeSquare`](@ref). See [Matrix cones](@ref) for more details.
* Scalar sets should be singular, not plural, for example, [`Integer`](@ref),
  not `Integers`.
* As much as possible, the names should follow established conventions in the
  domain where this set is used: for instance, convex sets should have names
  close to those of [CVX](https://web.cvxr.com/cvx/doc/), and
  constraint-programming sets should follow
  [MiniZinc](https://www.minizinc.org/doc-latest/en/)'s constraints.

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Duality

Conic duality is the starting point for MOI's duality conventions. When all
functions are affine (or coordinate projections), and all constraint sets are
closed convex cones, the model may be called a conic optimization problem.

For a minimization problem in geometric conic form, the primal is:
```math
\begin{align}
& \min_{x \in \mathbb{R}^n} & a_0^T x + b_0
\\
& \;\;\text{s.t.} & A_i x + b_i & \in \mathcal{C}_i & i = 1 \ldots m
\end{align}
```
and the dual is a maximization problem in standard conic form:
```math
\begin{align}
& \max_{y_1, \ldots, y_m} & -\sum_{i=1}^m b_i^T y_i + b_0
\\
& \;\;\text{s.t.} & a_0 - \sum_{i=1}^m A_i^T y_i & = 0
\\
& & y_i & \in \mathcal{C}_i^* & i = 1 \ldots m
\end{align}
```
where each ``\mathcal{C}_i`` is a closed convex cone and ``\mathcal{C}_i^*`` is
its dual cone.

For a maximization problem in geometric conic form, the primal is:
```math
\begin{align}
& \max_{x \in \mathbb{R}^n} & a_0^T x + b_0
\\
& \;\;\text{s.t.} & A_i x + b_i & \in \mathcal{C}_i & i = 1 \ldots m
\end{align}
```
and the dual is a minimization problem in standard conic form:
```math
\begin{align}
& \min_{y_1, \ldots, y_m} & \sum_{i=1}^m b_i^T y_i + b_0
\\
& \;\;\text{s.t.} & a_0 + \sum_{i=1}^m A_i^T y_i & = 0
\\
& & y_i & \in \mathcal{C}_i^* & i = 1 \ldots m
\end{align}
```

A linear inequality constraint ``a^T x + b \ge c`` is equivalent to
``a^T x + b - c \in \mathbb{R}_+``, and ``a^T x + b \le c`` is equivalent to
``a^T x + b - c \in \mathbb{R}_-``. Variable-wise constraints are affine
constraints with the appropriate identity mapping in place of ``A_i``.

For the special case of minimization LPs, the MOI primal form can be stated as:
```math
\begin{align}
& \min_{x \in \mathbb{R}^n} & a_0^T x &+ b_0
\\
& \;\;\text{s.t.}
&A_1 x & \ge b_1\\
&& A_2 x & \le b_2\\
&& A_3 x & = b_3
\end{align}
```

By applying the stated transformations to conic form, taking the dual, and
transforming back into linear inequality form, one obtains the following dual:
```math
\begin{align}
& \max_{y_1,y_2,y_3} & b_1^Ty_1 + b_2^Ty_2 + b_3^Ty_3 &+ b_0
\\
& \;\;\text{s.t.}
&A_1^Ty_1 + A_2^Ty_2 + A_3^Ty_3 & = a_0\\
&& y_1 &\ge 0\\
&& y_2 &\le 0
\end{align}
```

For maximization LPs, the MOI primal form can be stated as:
```math
\begin{align}
& \max_{x \in \mathbb{R}^n} & a_0^T x &+ b_0
\\
& \;\;\text{s.t.}
&A_1 x & \ge b_1\\
&& A_2 x & \le b_2\\
&& A_3 x & = b_3
\end{align}
```
and similarly, the dual is:
```math
\begin{align}
& \min_{y_1,y_2,y_3} & -b_1^Ty_1 - b_2^Ty_2 - b_3^Ty_3 &+ b_0
\\
& \;\;\text{s.t.}
&A_1^Ty_1 + A_2^Ty_2 + A_3^Ty_3 & = -a_0\\
&& y_1 &\ge 0\\
&& y_2 &\le 0
\end{align}
```

!!! warning
    For the LP case, the signs of the feasible dual variables depend only on the
    sense of the corresponding primal inequality and not on the objective sense.

## Duality and scalar product

The scalar product is different from the canonical one for the sets
[`PositiveSemidefiniteConeTriangle`](@ref), [`LogDetConeTriangle`](@ref),
[`RootDetConeTriangle`](@ref).

If the set ``C_i`` of the section [Duality](@ref) is one of these three cones,
then the rows of the matrix ``A_i`` corresponding to off-diagonal entries are
twice the value of the `coefficients` field in the [`VectorAffineFunction`](@ref)
for the corresponding rows. See [`PositiveSemidefiniteConeTriangle`](@ref) for
details.

## Dual for problems with quadratic functions

### Quadratic Programs (QPs)

For quadratic programs with only affine conic constraints,
```math
\begin{align*}
& \min_{x \in \mathbb{R}^n} & \frac{1}{2}x^TQ_0x + a_0^T x + b_0
\\
& \;\;\text{s.t.} & A_i x + b_i & \in \mathcal{C}_i & i = 1 \ldots m.
\end{align*}
```
with cones ``\mathcal{C}_i \subseteq \mathbb{R}^{m_i}`` for ``i = 1, \ldots, m``, consider the Lagrangian function
```math
L(x, y) = \frac{1}{2}x^TQ_0x + a_0^T x + b_0 - \sum_{i = 1}^m y_i^T (A_i x + b_i).
```
Let ``z(y)`` denote ``\sum_{i = 1}^m A_i^T y_i - a_0``, the Lagrangian can be rewritten as
```math
L(x, y) = \frac{1}{2}{x}^TQ_0x - z(y)^T x + b_0 - \sum_{i = 1}^m y_i^T b_i.
```

The condition ``\nabla_x L(x, y) = 0`` gives
```math
0 = \nabla_x L(x, y) = Q_0x + a_0 - \sum_{i = 1}^m y_i^T b_i
```
which gives ``Q_0x = z(y)``.
This allows to obtain that
```math
\min_{x \in \mathbb{R}^n} L(x, y) = -\frac{1}{2}x^TQ_0x + b_0 - \sum_{i = 1}^m y_i^T b_i
```
so the dual problem is
```math
\max_{y_i \in \mathcal{C}_i^*} \min_{x \in \mathbb{R}^n} -\frac{1}{2}x^TQ_0x + b_0 - \sum_{i = 1}^m y_i^T b_i.
```
If ``Q_0`` is invertible, we have ``x = Q_0^{-1}z(y)`` hence
```math
\min_{x \in \mathbb{R}^n} L(x, y) = -\frac{1}{2}z(y)^TQ_0^{-1}z(y) + b_0 - \sum_{i = 1}^m y_i^T b_i
```
so the dual problem is
```math
\max_{y_i \in \mathcal{C}_i^*} -\frac{1}{2}z(y)^TQ_0^{-1}z(y) + b_0 - \sum_{i = 1}^m y_i^T b_i.
```

### Quadratically Constrained Quadratic Programs (QCQPs)

Given a problem with both quadratic function and quadratic objectives:
```math
\begin{align*}
& \min_{x \in \mathbb{R}^n} & \frac{1}{2}x^TQ_0x + a_0^T x + b_0
\\
& \;\;\text{s.t.} & \frac{1}{2}x^TQ_ix + a_i^T x + b_i & \in \mathcal{C}_i & i = 1 \ldots m.
\end{align*}
```
with cones ``\mathcal{C}_i \subseteq \mathbb{R}`` for ``i = 1 \ldots m``, consider the Lagrangian function
```math
L(x, y) = \frac{1}{2}x^TQ_0x + a_0^T x + b_0 - \sum_{i = 1}^m y_i (\frac{1}{2}x^TQ_ix + a_i^T x + b_i)
```
A pair of primal-dual variables $(x^\star, y^\star)$ is optimal if
* ``x^\star`` is a minimizer of
  ```math
  \min_{x \in \mathbb{R}^n} L(x, y^\star).
  ```
  That is,
  ```math
  0 = \nabla_x L(x, y^\star) = Q_0x + a_0 - \sum_{i = 1}^m y_i^\star (Q_ix + a_i).
  ```
* and ``y^\star`` is a maximizer of
  ```math
  \max_{y_i \in \mathcal{C}_i^*} L(x^\star, y).
  ```
  That is, for all ``i = 1, \ldots, m``, ``\frac{1}{2}x^TQ_ix + a_i^T x + b_i``
  is either zero or in the
  [normal cone](https://en.wikipedia.org/wiki/Normal_cone) of
  ``\mathcal{C}_i^*`` at ``y^\star``. For instance, if ``\mathcal{C}_i`` is
  ``\{ z \in \mathbb{R} : z \le 0 \}``, this means that if
  ``\frac{1}{2}x^TQ_ix + a_i^T x + b_i`` is nonzero at ``x^\star`` then
  ``y_i^\star = 0``. This is the classical complementary slackness condition.

If ``\mathcal{C}_i`` is a vector set, the discussion remains valid with
``y_i(\frac{1}{2}x^TQ_ix + a_i^T x + b_i)`` replaced with the scalar product
between ``y_i`` and the vector of scalar-valued quadratic functions.

## Dual for square semidefinite matrices

The set [`PositiveSemidefiniteConeTriangle`](@ref) is a self-dual. That is,
querying [`ConstraintDual`](@ref) of a [`PositiveSemidefiniteConeTriangle`](@ref)
constraint returns a vector that is itself a member of
[`PositiveSemidefiniteConeTriangle`](@ref).

However, the dual of [`PositiveSemidefiniteConeSquare`](@ref) is not so straight
forward. This section explains the duality convention we use, and how it is
derived.

!!! info
    If you have a [`PositiveSemidefiniteConeSquare`](@ref) constraint, the
    result matrix ``A`` from [`ConstraintDual`](@ref) is not positive
    semidefinite. However, ``A + A^\top`` is positive semidefinite.

Let ``\mathcal{S}_+`` be the cone of symmetric semidefinite matrices in
the ``\frac{n(n+1)}{2}`` dimensional space of symmetric ``\mathbb{R}^{n \times n}``
matrices. That is, ``\mathcal{S}_+`` is the set [`PositiveSemidefiniteConeTriangle`](@ref).
It is well known that ``\mathcal{S}_+`` is a self-dual proper cone.

Let ``\mathcal{P}_+`` be the cone of symmetric semidefinite matrices in
the ``n^2`` dimensional space of ``\mathbb{R}^{n \times n}`` matrices. That is
``\mathcal{P}_+`` is the set [`PositiveSemidefiniteConeSquare`](@ref).

In addition, let ``\mathcal{D}_+`` be the cone of matrices ``A`` such that
``A+A^\top \in \mathcal{P}_+``.

``\mathcal{P}_+`` is not proper because it is not solid (it is not ``n^2``
dimensional), so it is not necessarily true that ``\mathcal{P}_+^{**} = \mathcal{P}_+``.

However, this _is_ the case, because we will show that ``\mathcal{P}_+^{*} = \mathcal{D}_+``
and ``\mathcal{D}_+^{*} = \mathcal{P}_+``.

First, let us see why ``\mathcal{P}_+^{*} = \mathcal{D}_+``.

If ``B`` is symmetric, then
```math
\langle A,B \rangle = \langle A^\top, B^\top \rangle = \langle A^\top, B\rangle
```
so
```math
2\langle A, B \rangle = \langle A, B \rangle + \langle A^\top, B \rangle = \langle A + A^\top , B \rangle.
```
Therefore, ``\langle A,B\rangle \ge 0`` for all ``B \in \mathcal{P}_+`` if and only if
``\langle A+A^\top,B\rangle \ge 0`` for all ``B \in \mathcal{P}_+``. Since ``A+A^\top`` is
symmetric, and we know that ``\mathcal{S}_+`` is self-dual, we have shown that
``\mathcal{P}_+^{*}`` is the set of matrices ``A`` such that
``A+A^\top \in \mathcal{P}_+``.

Second, let us see why ``\mathcal{D}_+^{*} = \mathcal{P}_+``.

Since ``A \in \mathcal{D}_+`` implies that ``A^\top \in \mathcal{D}_+``,
``B \in \mathcal{D}_+^{*}`` means that ``\langle A+A^\top,B\rangle \ge 0``
for all ``A \in \mathcal{D}_+``, and hence ``B \in \\mathcal{P}_+``.

To see why it should be symmetric, simply notice that if ``B_{i,j} < B_{j,i}``,
then ``\langle A,B\rangle`` can be made arbitrarily small by setting
``A_{i,j} = A_{i,j} + s`` and ``A_{j,i} = A_{j,i} - s``, with ``s`` arbitrarily
large, and ``A`` stays in ``\mathcal{D}_+`` because ``A+A^\top`` does not
change.

Typically, the primal/dual pair for semidefinite programs is presented as:
```math
\begin{align}
       \min & \langle C, X \rangle \\
\text{s.t.} \;\; & \langle A_k, X\rangle = b_k \forall k \\
            & X                     \in \mathcal{S}_+
\end{align}
```
with the dual
```math
\begin{align}
       \max & \sum_k b_k y_k \\
\text{s.t.} \;\; & C - \sum A_k y_k \in \mathcal{S}_+
\end{align}
```

If we allow ``A_k`` to be non-symmetric, we should instead use:
```math
\begin{align}
       \min & \langle C, X \rangle \\
\text{s.t.} \;\; & \langle A_k, X\rangle = b_k \forall k \\
            & X                     \in \mathcal{D}_+
\end{align}
```
with the dual
```math
\begin{align}
       \max & \sum b_k y_k \\
\text{s.t.} \;\; & C - \sum A_k y_k \in \mathcal{P}_+
\end{align}
```

This is implemented as:
```math
\begin{align}
       \min & \langle C,   Z \rangle + \langle C - C^\top, S \rangle \\
\text{s.t.} \;\; & \langle A_k, Z \rangle + \langle A_k - A_k^\top, S \rangle = b_k \forall k \\
            & Z \in \mathcal{S}_+
\end{align}
```
with the dual
```math
\begin{align}
       \max & \sum b_k y_k \\
\text{s.t.} \;\; & C+C^\top - \sum (A_k+A_k^\top) y_k \in \mathcal{S}_+ \\
            & C-C^\top - \sum(A_k-A_k^\top) y_k = 0
\end{align}
```
and we recover ``Z = X + X^\top``.

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Modifications

```@docs
modify
AbstractFunctionModification
ScalarConstantChange
VectorConstantChange
ScalarCoefficientChange
ScalarQuadraticCoefficientChange
MultirowChange
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Problem modification

In addition to adding and deleting constraints and variables, MathOptInterface
supports modifying, in-place, coefficients in the constraints and the objective
function of a model.

These modifications can be grouped into two categories:
 * modifications which replace the set of function of a constraint with a new
   set or function
 * modifications which change, in-place, a component of a function

!!! warning
    Some `ModelLike` objects do not support problem modification.

## Modify the set of a constraint

Use [`set`](@ref) and [`ConstraintSet`](@ref) to modify the set of a constraint
by replacing it with a new instance of the same type.

```jldoctest modify_set; setup=:(model = MOI.Utilities.Model{Float64}(); x = MOI.add_variable(model))
julia> c = MOI.add_constraint(
           model,
           MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
           MOI.EqualTo(1.0),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.ScalarAffineFunction{Float64}, MathOptInterface.EqualTo{Float64}}(1)

julia> MOI.set(model, MOI.ConstraintSet(), c, MOI.EqualTo(2.0));

julia> MOI.get(model, MOI.ConstraintSet(), c) == MOI.EqualTo(2.0)
true
```


However, the following will fail as the new set is of a different type to the
original set:
```julia
julia> MOI.set(model, MOI.ConstraintSet(), c, MOI.GreaterThan(2.0))
ERROR: [...]
```

### Special cases: set transforms

If our constraint is an affine inequality, then this corresponds to modifying
the right-hand side of a constraint in linear programming.

In some special cases, solvers may support efficiently changing the set of a
constraint (for example, from [`LessThan`](@ref) to [`GreaterThan`](@ref)). For
these cases, MathOptInterface provides the [`transform`](@ref) method.

The [`transform`](@ref) function returns a new constraint index, and the old
constraint index (that is, `c`) is no longer valid.

```jldoctest transform_set; setup=:(model = MOI.Utilities.Model{Float64}(); x = MOI.add_variable(model))
julia> c = MOI.add_constraint(
           model,
           MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
           MOI.LessThan(1.0),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.ScalarAffineFunction{Float64}, MathOptInterface.LessThan{Float64}}(1)

julia> new_c = MOI.transform(model, c, MOI.GreaterThan(2.0));

julia> MOI.is_valid(model, c)
false

julia> MOI.is_valid(model, new_c)
true
```

!!! note
    [`transform`](@ref) cannot be called with a set of the same type. Use
    [`set`](@ref) instead.

## Modify the function of a constraint

Use [`set`](@ref) and [`ConstraintFunction`](@ref) to modify the function of a
constraint by replacing it with a new instance of the same type.

```jldoctest modify_function; setup=:(model = MOI.Utilities.Model{Float64}(); x = MOI.add_variable(model))
julia> c = MOI.add_constraint(
           model,
           MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
           MOI.EqualTo(1.0),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.ScalarAffineFunction{Float64}, MathOptInterface.EqualTo{Float64}}(1)

julia> new_f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(2.0, x)], 1.0);

julia> MOI.set(model, MOI.ConstraintFunction(), c, new_f);

julia> MOI.get(model, MOI.ConstraintFunction(), c) ≈ new_f
true
```

However, the following will fail as the new function is of a different type to
the original function:
```julia
julia> MOI.set(model, MOI.ConstraintFunction(), c, x)
ERROR: [...]
```

## Modify constant term in a scalar function

Use [`modify`](@ref) and [`ScalarConstantChange`](@ref) to modify the constant
term in a [`ScalarAffineFunction`](@ref) or [`ScalarQuadraticFunction`](@ref).

```jldoctest scalar_constant_change; setup=:(model = MOI.Utilities.Model{Float64}(); x = MOI.add_variable(model))
julia> c = MOI.add_constraint(
           model,
           MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
           MOI.EqualTo(1.0),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.ScalarAffineFunction{Float64}, MathOptInterface.EqualTo{Float64}}(1)

julia> MOI.modify(model, c, MOI.ScalarConstantChange(1.0));

julia> new_f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 1.0);

julia> MOI.get(model, MOI.ConstraintFunction(), c) ≈ new_f
true
```

[`ScalarConstantChange`](@ref) can also be used to modify the objective
function by passing an instance of [`ObjectiveFunction`](@ref):

```jldoctest scalar_constant_change
julia> MOI.set(
           model,
           MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
           new_f,
       );

julia> MOI.modify(
           model,
           MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
           MOI.ScalarConstantChange(-1.0)
       );

julia> MOI.get(
           model,
           MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
       ) ≈ MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], -1.0)
true
```

## Modify constant terms in a vector function

Use [`modify`](@ref) and [`VectorConstantChange`](@ref) to modify the constant
vector in a [`VectorAffineFunction`](@ref) or [`VectorQuadraticFunction`](@ref).

```jldoctest vector_constant_change; setup=:(model = MOI.Utilities.Model{Float64}(); x = MOI.add_variable(model))
julia> c = MOI.add_constraint(
           model,
           MOI.VectorAffineFunction([
                   MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x)),
                   MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(2.0, x)),
               ],
               [0.0, 0.0],
           ),
           MOI.Nonnegatives(2),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorAffineFunction{Float64}, MathOptInterface.Nonnegatives}(1)

julia> MOI.modify(model, c, MOI.VectorConstantChange([3.0, 4.0]));

julia> new_f = MOI.VectorAffineFunction(
           [
        MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x)),
        MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(2.0, x)),
           ],
           [3.0, 4.0],
       );

julia> MOI.get(model, MOI.ConstraintFunction(), c) ≈ new_f
true
```

## Modify affine coefficients in a scalar function

Use [`modify`](@ref) and [`ScalarCoefficientChange`](@ref) to modify the affine
coefficient of a [`ScalarAffineFunction`](@ref) or [`ScalarQuadraticFunction`](@ref).

```jldoctest scalar_coefficient_change; setup=:(model = MOI.Utilities.Model{Float64}(); x = MOI.add_variable(model))
julia> c = MOI.add_constraint(
           model,
           MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(1.0, x)], 0.0),
           MOI.EqualTo(1.0),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.ScalarAffineFunction{Float64}, MathOptInterface.EqualTo{Float64}}(1)

julia> MOI.modify(model, c, MOI.ScalarCoefficientChange(x, 2.0));

julia> new_f = MOI.ScalarAffineFunction([MOI.ScalarAffineTerm(2.0, x)], 0.0);

julia> MOI.get(model, MOI.ConstraintFunction(), c) ≈ new_f
true
```

[`ScalarCoefficientChange`](@ref) can also be used to modify the objective
function by passing an instance of [`ObjectiveFunction`](@ref).

## Modify quadratic coefficients in a scalar function

Use [`modify`](@ref) and [`ScalarQuadraticCoefficientChange`](@ref) to modify
the quadratic coefficient of a [`ScalarQuadraticFunction`](@ref).

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variables(model, 2);

julia> c = MOI.add_constraint(
           model,
           1.0 * x[1] * x[1] + 2.0 * x[1] * x[2],
           MOI.EqualTo(1.0),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.ScalarQuadraticFunction{Float64}, MathOptInterface.EqualTo{Float64}}(1)

julia> MOI.modify(
           model,
           c,
           MOI.ScalarQuadraticCoefficientChange(x[1], x[1], 3.0),
       );

julia> MOI.modify(
           model,
           c,
           MOI.ScalarQuadraticCoefficientChange(x[1], x[2], 4.0),
       );

julia> new_f = 1.5 * x[1] * x[1] + 4.0 * x[1] * x[2];

julia> MOI.get(model, MOI.ConstraintFunction(), c) ≈ new_f
true
```

[`ScalarQuadraticCoefficientChange`](@ref) can also be used to modify the
objective function by passing an instance of [`ObjectiveFunction`](@ref).

## Modify affine coefficients in a vector function

Use [`modify`](@ref) and [`MultirowChange`](@ref) to modify a vector of affine
coefficients in a [`VectorAffineFunction`](@ref) or a [`VectorQuadraticFunction`](@ref).

```jldoctest multirow_change; setup=:(model = MOI.Utilities.Model{Float64}(); x = MOI.add_variable(model))
julia> c = MOI.add_constraint(
           model,
           MOI.VectorAffineFunction([
                   MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(1.0, x)),
                   MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(2.0, x)),
               ],
               [0.0, 0.0],
           ),
           MOI.Nonnegatives(2),
       )
MathOptInterface.ConstraintIndex{MathOptInterface.VectorAffineFunction{Float64}, MathOptInterface.Nonnegatives}(1)

julia> MOI.modify(model, c, MOI.MultirowChange(x, [(1, 3.0), (2, 4.0)]));

julia> new_f = MOI.VectorAffineFunction(
           [
        MOI.VectorAffineTerm(1, MOI.ScalarAffineTerm(3.0, x)),
        MOI.VectorAffineTerm(2, MOI.ScalarAffineTerm(4.0, x)),
           ],
           [0.0, 0.0],
       );

julia> MOI.get(model, MOI.ConstraintFunction(), c) ≈ new_f
true
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Standard form

## Functions

```@docs
AbstractFunction
output_dimension
constant
```

## Scalar functions

```@docs
AbstractScalarFunction
VariableIndex
ScalarAffineTerm
ScalarAffineFunction
ScalarQuadraticTerm
ScalarQuadraticFunction
ScalarNonlinearFunction
```

## Vector functions

```@docs
AbstractVectorFunction
VectorOfVariables
VectorAffineTerm
VectorAffineFunction
VectorQuadraticTerm
VectorQuadraticFunction
VectorNonlinearFunction
```

## Sets

```@docs
AbstractSet
AbstractScalarSet
AbstractVectorSet
```

### Utilities

```@docs
dimension
dual_set
dual_set_type
constant(s::EqualTo)
supports_dimension_update
update_dimension
```

## Scalar sets

List of recognized scalar sets.
```@docs
GreaterThan
LessThan
EqualTo
Interval
Integer
ZeroOne
Semicontinuous
Semiinteger
Parameter
```

## Vector sets

List of recognized vector sets.
```@docs
Reals
Zeros
Nonnegatives
Nonpositives
NormInfinityCone
NormOneCone
NormCone
SecondOrderCone
RotatedSecondOrderCone
GeometricMeanCone
ExponentialCone
DualExponentialCone
PowerCone
DualPowerCone
RelativeEntropyCone
NormSpectralCone
NormNuclearCone
SOS1
SOS2
Indicator
ActivationCondition
ACTIVATE_ON_ZERO
ACTIVATE_ON_ONE
Complements
HyperRectangle
Scaled
VectorNonlinearOracle
```

## Constraint programming sets

```@docs
AllDifferent
BinPacking
Circuit
CountAtLeast
CountBelongs
CountDistinct
CountGreaterThan
Cumulative
Path
Reified
Table
```

## Matrix sets

Matrix sets are vectorized to be subtypes of [`AbstractVectorSet`](@ref).

For sets of symmetric matrices, storing both the
`(i, j)` and `(j, i)` elements is redundant. Use the
[`AbstractSymmetricMatrixSetTriangle`](@ref) set to represent only the
vectorization of the upper triangular part of the matrix.

When the matrix of expressions constrained to be in the set is not symmetric,
and hence additional constraints are needed to force the equality of the
`(i, j)` and `(j, i)` elements, use the
[`AbstractSymmetricMatrixSetSquare`](@ref) set.

The [`Bridges.Constraint.SquareBridge`](@ref) can transform a set from the
square form to the [`triangular_form`](@ref) by adding appropriate constraints
if the `(i, j)` and `(j, i)` expressions are different.

```@docs
AbstractSymmetricMatrixSetTriangle
AbstractSymmetricMatrixSetSquare
side_dimension
triangular_form
```

List of recognized matrix sets.
```@docs
PositiveSemidefiniteConeTriangle
PositiveSemidefiniteConeSquare
HermitianPositiveSemidefiniteConeTriangle
LogDetConeTriangle
LogDetConeSquare
RootDetConeTriangle
RootDetConeSquare
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Implementing a constraint bridge

This guide outlines the basic steps to create a new bridge from a constraint
expressed in the formalism `Function`-in-`Set`.

## Preliminaries

First, decide on the set you want to bridge. Then, study its properties: the
most important one is whether the set is scalar or vector, which impacts the
dimensionality of the functions that can be used with the set.

* A scalar function only has one dimension. MOI defines three types of scalar
  functions: a variable ([`VariableIndex`](@ref)), an affine function
  ([`ScalarAffineFunction`](@ref)), or a quadratic function
  ([`ScalarQuadraticFunction`](@ref)).
* A vector function has several dimensions (at least one). MOI defines three
  types of vector functions: several variables ([`VectorOfVariables`](@ref)),
  an affine function ([`VectorAffineFunction`](@ref)), or a quadratic function
  ([`VectorQuadraticFunction`](@ref)). The main difference with scalar functions
  is that the order of dimensions can be very important: for instance, in an
  indicator constraint ([`Indicator`](@ref)), the first dimension indicates
  whether the constraint about the second dimension is active.

To explain how to implement a bridge, we present the example of
[`Bridges.Constraint.FlipSignBridge`](@ref). This bridge maps `<=`
([`LessThan`](@ref)) constraints to `>=` ([`GreaterThan`](@ref)) constraints.
This corresponds to reversing the sign of the inequality. We focus on scalar
affine functions (we disregard the cases of a single variable or of quadratic
functions). This example is a simplified version of the code included
in MOI.

## Four mandatory parts in a constraint bridge

The first part of a constraint bridge is a new concrete subtype of
[`Bridges.Constraint.AbstractBridge`](@ref). This type must have fields to
store all the new variables and constraints that the bridge will add.
Typically, these types are parametrized by the type of the coefficients in the
model.

Then, three sets of functions must be defined:

1. [`Bridges.Constraint.bridge_constraint`](@ref): this function implements the
   bridge and creates the required variables and constraints.
2. [`supports_constraint`](@ref): these functions must return `true` when the
   combination of function and set is supported by the bridge. By default, the
   base implementation always returns `false` and the bridge does not have to
   provide this implementation.
3. [`Bridges.added_constrained_variable_types`](@ref) and
   [`Bridges.added_constraint_types`](@ref): these functions return the types
   of variables and constraints that this bridge adds. They are used to compute
   the set of other bridges that are required to use the one you are defining,
   if need be.

More functions can be implemented, for instance to retrieve properties from the
bridge or deleting a bridged constraint.

### 1. Structure for the bridge

A typical `struct` behind a bridge depends on the type of the coefficients that
are used for the model (typically `Float64`, but coefficients might also be
integers or complex numbers).

This structure must hold a reference to all the variables and the constraints
that are created as part of the bridge.

The type of this structure is used throughout MOI as an identifier for the
bridge. It is passed as argument to most functions related to bridges.

The best practice is to have the name of this type end with `Bridge`.

In our example, the bridge maps any
`ScalarAffineFunction{T}`-in-`LessThan{T}` constraint to a single
`ScalarAffineFunction{T}`-in-`GreaterThan{T}` constraint. The affine function
has coefficients of type `T`. The bridge is parametrized with `T`, so that the
constraint that the bridge creates also has coefficients of type `T`.

```julia
struct SignBridge{T<:Number} <: Bridges.Constraint.AbstractBridge
    constraint::ConstraintIndex{ScalarAffineFunction{T}, GreaterThan{T}}
end
```

### 2. Bridge creation

The function [`Bridges.Constraint.bridge_constraint`](@ref) is called whenever
the bridge is instantiated for a specific model, with the given function
and set. The arguments to `bridge_constraint` are similar to
[`add_constraint`](@ref), with the exception of the first argument: it is the
`Type` of the struct defined in the first step (for our example,
`Type{SignBridge{T}}`).

`bridge_constraint` returns an instance of the struct defined in the first step.
the first step.

In our example, the bridge constraint could be defined as:

```julia
function Bridges.Constraint.bridge_constraint(
    ::Type{SignBridge{T}}, # Bridge to use.
    model::ModelLike, # Model to which the constraint is being added.
    f::ScalarAffineFunction{T}, # Function to rewrite.
    s::LessThan{T}, # Set to rewrite.
) where {T}
    # Create the variables and constraints required for the bridge.
    con = add_constraint(model, -f, GreaterThan(-s.upper))

    # Return an instance of the bridge type with a reference to all the
    # variables and constraints that were created in this function.
    return SignBridge(con)
end
```

### 3. Supported constraint types

The function [`supports_constraint`](@ref) determines whether the bridge type
supports a given combination of function and set.

This function must closely match `bridge_constraint`, because it will not be
called if `supports_constraint` returns `false`.

```julia
function supports_constraint(
    ::Type{SignBridge{T}}, # Bridge to use.
    ::Type{ScalarAffineFunction{T}}, # Function to rewrite.
    ::Type{LessThan{T}}, # Set to rewrite.
) where {T}
    # Do some computation to ensure that the constraint is supported.
    # Typically, you can directly return true.
    return true
end
```

### 4. Metadata about the bridge

To determine whether a bridge can be used, MOI uses a shortest-path algorithm
that uses the variable types and the constraints that the bridge can create.
This information is communicated from the bridge to MOI using the functions
[`Bridges.added_constrained_variable_types`](@ref) and
[`Bridges.added_constraint_types`](@ref). Both return lists of tuples:
either a list of 1-tuples containing the variable types (typically, `ZeroOne`
or `Integer`) or a list of 2-tuples contained the functions and sets (like
`ScalarAffineFunction{T}`-`GreaterThan`).

For our example, the bridge does not create any constrained variables, and
only `ScalarAffineFunction{T}`-in-`GreaterThan{T}` constraints:

```julia
function Bridges.added_constrained_variable_types(::Type{SignBridge{T}}) where {T}
    # The bridge does not create variables, return an empty list of tuples:
    return Tuple{Type}[]
end

function Bridges.added_constraint_types(::Type{SignBridge{T}}) where {T}
    return Tuple{Type,Type}[
        # One element per F-in-S the bridge creates.
        (ScalarAffineFunction{T}, GreaterThan{T}),
    ]
end
```

A bridge that creates binary variables would rather have this definition of
`added_constrained_variable_types`:

```julia
function Bridges.added_constrained_variable_types(::Type{SomeBridge{T}}) where {T}
    # The bridge only creates binary variables:
    return Tuple{Type}[(ZeroOne,)]
end
```

!!! warning
    If you declare the creation of constrained variables in
    `added_constrained_variable_types`, the corresponding constraint type
    `VariableIndex` must not be indicated in `added_constraint_types`.
    This would restrict the use of the bridge to solvers that can add such a
    constraint after the variable is created.

    More concretely, *if* you declare in `added_constrained_variable_types` that
    your bridge creates binary variables (`ZeroOne`), *and if* you never add such
    a constraint afterward (you do not call
    `add_constraint(model, var, ZeroOne())`), then you must
    *not* list `(VariableIndex, ZeroOne)` in `added_constraint_types`.

Typically, the function [`Bridges.Constraint.concrete_bridge_type`](@ref) does
not have to be defined for most bridges.

## Bridge registration

For a bridge to be used by MOI, it must be known by MOI.

### `SingleBridgeOptimizer`

The first way to do so is to create a single-bridge optimizer. This type of
optimizer wraps another optimizer and adds the possibility to use only one
bridge. It is especially useful when unit testing bridges.

It is common practice to use the same name as the type defined for the bridge
(`SignBridge`, in our example) without the suffix `Bridge`.

```julia
const Sign{T,OT<: ModelLike} =
    SingleBridgeOptimizer{SignBridge{T}, OT}
```

In the context of unit tests, this bridge is used in conjunction with a
[`Utilities.MockOptimizer`](@ref):

```julia
mock = Utilities.MockOptimizer(
    Utilities.UniversalFallback(Utilities.Model{Float64}()),
)
bridged_mock = Sign{Float64}(mock)
```

### New bridge for a `LazyBridgeOptimizer`

Typical user-facing models for MOI are based on
[`Bridges.LazyBridgeOptimizer`](@ref). For instance, this type of model is
returned by [`Bridges.full_bridge_optimizer`](@ref). These models can be
added more bridges by using [`Bridges.add_bridge`](@ref):

```julia
inner_optimizer = Utilities.Model{Float64}()
optimizer = Bridges.full_bridge_optimizer(inner_optimizer, Float64)
Bridges.add_bridge(optimizer, SignBridge{Float64})
```

## Bridge improvements

### Attribute retrieval

Like models, bridges have attributes that can be retrieved using [`get`](@ref)
and [`set`](@ref). The most important ones are the number of variables and
constraints, but also the lists of variables and constraints.

In our example, we only have one constraint and only have to implement the
[`NumberOfConstraints`](@ref) and [`ListOfConstraintIndices`](@ref) attributes:

```julia
function get(
    ::SignBridge{T},
    ::NumberOfConstraints{
        ScalarAffineFunction{T},
        GreaterThan{T},
    },
) where {T}
    return 1
end

function get(
    bridge::SignBridge{T},
    ::ListOfConstraintIndices{
        ScalarAffineFunction{T},
        GreaterThan{T},
    },
) where {T}
    return [bridge.constraint]
end
```

You must implement one such pair of functions for each type of constraint the
bridge adds to the model.

!!! warning
    Avoid returning a list from the bridge object without copying it. Users
    must be able to change the contents of the returned list without altering
    the bridge object.

For variables, the situation is simpler. If your bridge creates new variables,
you must implement the [`NumberOfVariables`](@ref) and
[`ListOfVariableIndices`](@ref) attributes. However, these attributes do not have
parameters, unlike their constraint counterparts. Only two functions suffice:

```julia
function get(
    ::SignBridge{T},
    ::NumberOfVariables,
) where {T}
    return 0
end

function get(
    ::SignBridge{T},
    ::ListOfVariableIndices,
) where {T}
    return VariableIndex[]
end
```

In order for the user to be able to access the function and set of the original
constraint, the bridge needs to implement getters for the
[`ConstraintFunction`](@ref) and [`ConstraintSet`](@ref)
attributes:

```julia
function get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintFunction,
    bridge::SignBridge,
)
    return -MOI.get(model, attr, bridge.constraint)
end

function get(
    model::MOI.ModelLike,
    attr::MOI.ConstraintSet,
    bridge::SignBridge,
)
    set = MOI.get(model, attr, bridge.constraint)
    return MOI.LessThan(-set.lower)
end
```

!!! warning
    Alternatively, one could store the original function and set in `SignBridge`
    during [`Bridges.Constraint.bridge_constraint`](@ref) to make these getters
    simpler and more efficient. On the other hand, this will increase the memory
    footprint of the bridges as the garbage collector won't be able to delete
    that object. The convention is to not store the function in the bridge
    and not care too much about the efficiency of these getters. If the user
    needs efficient getters for [`ConstraintFunction`](@ref) then they should
    use a [`Utilities.CachingOptimizer`](@ref).

### Model modifications

To avoid copying the model when the user request to change a constraint, MOI
provides [`modify`](@ref). Bridges can also implement this API to allow
certain changes, such as coefficient changes.

In our case, a modification of a coefficient in the original constraint
(for example, replacing the value of the coefficient of a variable in the affine
function) must be transmitted to the constraint created by the bridge,
but with a sign change.

```julia
function modify(
    model::ModelLike,
    bridge::SignBridge,
    change::ScalarCoefficientChange,
)
    modify(
        model,
        bridge.constraint,
        ScalarCoefficientChange(change.variable, -change.new_coefficient),
    )
    return
end
```

### Bridge deletion

When a bridge is deleted, the constraints it added must be deleted too.

```julia
function delete(model::ModelLike, bridge::SignBridge)
    delete(model, bridge.constraint)
    return
end
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Infeasibility certificates

When given a conic problem that is infeasible or unbounded, some solvers can
produce a certificate of infeasibility. This page explains what a certificate of
infeasibility is, and the related conventions that MathOptInterface adopts.

## Conic duality

MathOptInterface uses conic duality to define infeasibility certificates. A full
explanation is given in the section [Duality](@ref), but here is a brief
overview.

### Minimization problems

For a minimization problem in geometric conic form, the primal is:
```math
\begin{align}
& \min_{x \in \mathbb{R}^n} & a_0^\top x + b_0
\\
& \;\;\text{s.t.} & A_i x + b_i & \in \mathcal{C}_i & i = 1 \ldots m,
\end{align}
```
and the dual is a maximization problem in standard conic form:
```math
\begin{align}
& \max_{y_1, \ldots, y_m} & -\sum_{i=1}^m b_i^\top y_i + b_0
\\
& \;\;\text{s.t.} & a_0 - \sum_{i=1}^m A_i^\top y_i & = 0
\\
& & y_i & \in \mathcal{C}_i^* & i = 1 \ldots m,
\end{align}
```
where each ``\mathcal{C}_i`` is a closed convex cone and ``\mathcal{C}_i^*`` is
its dual cone.

### Maximization problems

For a maximization problem in geometric conic form, the primal is:
```math
\begin{align}
& \max_{x \in \mathbb{R}^n} & a_0^\top x + b_0
\\
& \;\;\text{s.t.} & A_i x + b_i & \in \mathcal{C}_i & i = 1 \ldots m,
\end{align}
```
and the dual is a minimization problem in standard conic form:
```math
\begin{align}
& \min_{y_1, \ldots, y_m} & \sum_{i=1}^m b_i^\top y_i + b_0
\\
& \;\;\text{s.t.} & a_0 + \sum_{i=1}^m A_i^\top y_i & = 0
\\
& & y_i & \in \mathcal{C}_i^* & i = 1 \ldots m.
\end{align}
```

## Unbounded problems

A problem is unbounded if and only if:
 1. there exists a feasible primal solution
 2. the dual is infeasible.

A feasible primal solution—if one exists—can be obtained by setting
[`ObjectiveSense`](@ref) to `FEASIBILITY_SENSE` before optimizing. Therefore,
most solvers stop after they prove the dual is infeasible via a certificate
of dual infeasibility, but _before_ they have found a feasible primal solution.
This is also the reason that MathOptInterface defines the `DUAL_INFEASIBLE`
status instead of `UNBOUNDED`.

A certificate of dual infeasibility is an improving ray of the primal problem.
That is, there exists some vector ``d`` such that for all ``\eta > 0``:
```math
A_i (x + \eta d) + b_i \in \mathcal{C}_i,\ \ i = 1 \ldots m,
```
and (for minimization problems):
```math
a_0^\top (x + \eta d) + b_0 < a_0^\top x + b_0,
```
for any feasible point ``x``. The latter simplifies to ``a_0^\top d < 0``. For
maximization problems, the inequality is reversed, so that ``a_0^\top d > 0``.

If the solver has found a certificate of dual infeasibility:

 * [`TerminationStatus`](@ref) must be `DUAL_INFEASIBLE`
 * [`PrimalStatus`](@ref) must be `INFEASIBILITY_CERTIFICATE`
 * [`VariablePrimal`](@ref) must be the corresponding value of ``d``
 * [`ConstraintPrimal`](@ref) must be the corresponding value of ``A_i d``
 * [`ObjectiveValue`](@ref) must be the value ``a_0^\top d``. Note that this is
   the value of the objective function at `d`, ignoring the constant `b_0`.

!!! note
    The choice of whether to scale the ray ``d`` to have magnitude `1` is left
    to the solver.

## Infeasible problems

A certificate of primal infeasibility is an improving ray of the dual problem.
However, because infeasibility is independent of the objective function, we
first homogenize the primal problem by removing its objective.

For a minimization problem, a dual improving ray is some vector ``d`` such that
for all ``\eta > 0``:
```math
\begin{align}
-\sum_{i=1}^m A_i^\top (y_i + \eta d_i) & = 0 \\
(y_i + \eta d_i) & \in \mathcal{C}_i^* & i = 1 \ldots m,
\end{align}
```
and:
```math
-\sum_{i=1}^m b_i^\top (y_i + \eta d_i) > -\sum_{i=1}^m b_i^\top y_i,
```
for any feasible dual solution ``y``. The latter simplifies to
``-\sum_{i=1}^m b_i^\top d_i > 0``. For a maximization problem, the inequality
is ``\sum_{i=1}^m b_i^\top d_i < 0``. (Note that these are the same inequality,
modulo a `-` sign.)

If the solver has found a certificate of primal infeasibility:

 * [`TerminationStatus`](@ref) must be `INFEASIBLE`
 * [`DualStatus`](@ref) must be `INFEASIBILITY_CERTIFICATE`
 * [`ConstraintDual`](@ref) must be the corresponding value of ``d``
 * [`DualObjectiveValue`](@ref) must be the value
   ``-\sum_{i=1}^m b_i^\top d_i`` for minimization problems and
   ``\sum_{i=1}^m b_i^\top d_i`` for maximization problems.

!!! note
    The choice of whether to scale the ray ``d`` to have magnitude `1` is left
    to the solver.

### Infeasibility certificates of variable bounds

Many linear solvers (for example, Gurobi) do not provide explicit access to the
primal infeasibility certificate of a variable bound. However, given a set of
linear constraints:
```math
\begin{align}
l_A \le A x \le u_A \\
l_x \le x \le u_x,
\end{align}
```
the primal certificate of the variable bounds can be computed using the primal
certificate associated with the affine constraints, ``d``. (Note that ``d`` will
have one element for each row of the ``A`` matrix, and that some or all of the
elements in the vectors ``l_A`` and ``u_A`` may be ``\pm \infty``. If both
``l_A`` and ``u_A`` are finite for some row, the corresponding element in ``d`
 must be `0`.)

Given ``d``, compute ``\bar{d} = d^\top A``. If the bound is finite, a
certificate for the lower variable bound of ``x_i`` is ``\max\{\bar{d}_i, 0\}``,
and a certificate for the upper variable bound is ``\min\{\bar{d}_i, 0\}``.

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# [Solutions](@id manual_solutions)

## Solving and retrieving the results

Once an optimizer is loaded with the objective function and all of the
constraints, we can ask the solver to solve the model by calling
[`optimize!`](@ref).
```julia
MOI.optimize!(optimizer)
```

## Why did the solver stop?

The optimization procedure may stop for a number of reasons. The
[`TerminationStatus`](@ref) attribute of the optimizer returns a
[`TerminationStatusCode`](@ref) object which explains why the solver stopped.

The termination statuses distinguish between proofs of optimality,
infeasibility, local convergence, limits, and termination because of something
unexpected like invalid problem data or failure to converge.

A typical usage of the [`TerminationStatus`](@ref) attribute is as follows:
```julia
status = MOI.get(optimizer, TerminationStatus())
if status == MOI.OPTIMAL
    # Ok, we solved the problem!
else
    # Handle other cases.
end
```

After checking the [`TerminationStatus`](@ref), check
[`ResultCount`](@ref). This attribute returns the number of results that the
solver has available to return. *A result is defined as a primal-dual pair,
but either the primal or the dual may be missing from the result.* While the
`OPTIMAL` termination status normally implies that at least one result is
available, other statuses do not. For example, in the case of infeasibility, a
solver may return no result or a proof of infeasibility. The [`ResultCount`](@ref)
attribute distinguishes between these two cases.

## Primal solutions

Use the [`PrimalStatus`](@ref) optimizer attribute to return a
[`ResultStatusCode`](@ref) describing the status of the primal solution.

Common returns are described below in the [Common status situations](@ref)
section.

Query the primal solution using the [`VariablePrimal`](@ref) and
[`ConstraintPrimal`](@ref) attributes.

Query the objective function value using the [`ObjectiveValue`](@ref) attribute.

## Dual solutions

!!! warning
    See [Duality](@ref) for a discussion of the MOI conventions for primal-dual
    pairs and certificates.

Use the [`DualStatus`](@ref) optimizer attribute to return a
[`ResultStatusCode`](@ref) describing the status of the dual solution.

Query the dual solution using the [`ConstraintDual`](@ref) attribute.

Query the dual objective function value using the [`DualObjectiveValue`](@ref)
attribute.

## Common status situations

The sections below describe how to interpret typical or interesting status cases
for three common classes of solvers. The example cases are illustrative, not
comprehensive. Solver wrappers may provide additional information on
how the solver's statuses map to MOI statuses.

!!! info
    `*` in the tables indicate that multiple different values are possible.

### Primal-dual convex solver

Linear programming and conic optimization solvers fall into this category.

| What happened?                          | `TerminationStatus` | `ResultCount` | `PrimalStatus`              | `DualStatus`                |
| --------------------------------------- | --------------------- | ----------- | --------------------------- | --------------------------- |
| Proved optimality                       | `OPTIMAL`             | 1           | `FEASIBLE_POINT`            | `FEASIBLE_POINT`            |
| Proved infeasible                       | `INFEASIBLE`          | 1           | `NO_SOLUTION`               | `INFEASIBILITY_CERTIFICATE` |
| Optimal within relaxed tolerances       | `ALMOST_OPTIMAL`      | 1           | `FEASIBLE_POINT`            | `FEASIBLE_POINT`            |
| Optimal within relaxed tolerances       | `ALMOST_OPTIMAL`      | 1           | `ALMOST_FEASIBLE_POINT`     | `ALMOST_FEASIBLE_POINT`     |
| Detected an unbounded ray of the primal | `DUAL_INFEASIBLE`     | 1           | `INFEASIBILITY_CERTIFICATE` | `NO_SOLUTION`               |
| Stall                                   | `SLOW_PROGRESS`       | 1           | *                           | *                           |

### Global branch-and-bound solvers

Mixed-integer programming solvers fall into this category.

| What happened?                                   | `TerminationStatus`       | `ResultCount` | `PrimalStatus`     | `DualStatus`  |
| ------------------------------------------------ | ------------------------- | ------------- | ------------------ | ------------- |
| Proved optimality                                | `OPTIMAL`                 | 1             | `FEASIBLE_POINT`   | `NO_SOLUTION` |
| Presolve detected infeasibility or unboundedness | `INFEASIBLE_OR_UNBOUNDED` | 0             | `NO_SOLUTION`      | `NO_SOLUTION` |
| Proved infeasibility                             | `INFEASIBLE`              | 0             | `NO_SOLUTION`      | `NO_SOLUTION` |
| Timed out (no solution)                          | `TIME_LIMIT`              | 0             | `NO_SOLUTION`      | `NO_SOLUTION` |
| Timed out (with a solution)                      | `TIME_LIMIT`              | 1             | `FEASIBLE_POINT`   | `NO_SOLUTION` |
| `CPXMIP_OPTIMAL_INFEAS`                          | `ALMOST_OPTIMAL`          | 1             | `INFEASIBLE_POINT` | `NO_SOLUTION` |

!!! info
    [`CPXMIP_OPTIMAL_INFEAS`](https://www.ibm.com/docs/en/icos/22.1.1?topic=api-cpxmip-optimal-infeas)
    is a CPLEX status that indicates that a preprocessed problem was solved to
    optimality, but the solver was unable to recover a feasible solution to the
    original problem. Handling this status was one of the motivating drivers
    behind the design of MOI.

### Local search solvers

Nonlinear programming solvers fall into this category. It also includes
non-global tree search solvers like
[Juniper](https://github.com/lanl-ansi/Juniper.jl).

| What happened?                                         | `TerminationStatus`             | `ResultCount` | `PrimalStatus`   | `DualStatus`   |
| ------------------------------------------------------ | --------------------------------- | --------------- | ------------------ | ---------------- |
| Converged to a stationary point                        | `LOCALLY_SOLVED`                  | 1               | `FEASIBLE_POINT`   | `FEASIBLE_POINT` |
| Completed a non-global tree search (with a solution)   | `LOCALLY_SOLVED`                  | 1               | `FEASIBLE_POINT`   | `FEASIBLE_POINT` |
| Converged to an infeasible point                       | `LOCALLY_INFEASIBLE`              | 1               | `INFEASIBLE_POINT` | *                |
| Completed a non-global tree search (no solution found) | `LOCALLY_INFEASIBLE`              | 0               | `NO_SOLUTION`      | `NO_SOLUTION`    |
| Iteration limit                                        | `ITERATION_LIMIT`                 | 1               | *                  | *                |
| Diverging iterates                                     | `NORM_LIMIT` or `OBJECTIVE_LIMIT` | 1               | *                  | *                |

## Querying solution attributes

Some solvers will not implement every solution attribute. Therefore, a call like
`MOI.get(model, MOI.SolveTimeSec())` may throw an [`UnsupportedAttribute`](@ref)
error.

If you need to write code that is agnostic to the solver (for example, you are
writing a library that an end-user passes their choice of solver to), you can
work-around this problem using a `try-catch`:
```julia
function get_solve_time(model)
    try
        return MOI.get(model, MOI.SolveTimeSec())
    catch err
        if err isa MOI.UnsupportedAttribute
            return NaN  # Solver doesn't support. Return a placeholder value.
        end
        rethrow(err)  # Something else went wrong. Rethrow the error
    end
end
```

If, _after careful profiling_, you find that the `try-catch` is taking a
significant portion of your runtime, you can improve performance by caching the
result of the `try-catch`:
```julia
mutable struct CachedSolveTime{M}
    model::M
    supports_solve_time::Bool
    CachedSolveTime(model::M) where {M} = new(model, true)
end

function get_solve_time(model::CachedSolveTime)
    if !model.supports_solve_time
        return NaN
    end
    try
        return MOI.get(model, MOI.SolveTimeSec())
    catch err
        if err isa MOI.UnsupportedAttribute
            model.supports_solve_time = false
            return NaN
        end
        rethrow(err)  # Something else went wrong. Rethrow the error
    end
end
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Constraints

## Add a constraint

Use [`add_constraint`](@ref) to add a single constraint.

```jldoctest constraints; setup=:(model = MOI.Utilities.Model{Float64}(); x = MOI.add_variables(model, 2))
julia> c = MOI.add_constraint(model, MOI.VectorOfVariables(x), MOI.Nonnegatives(2))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorOfVariables, MathOptInterface.Nonnegatives}(1)
```

[`add_constraint`](@ref) returns a [`ConstraintIndex`](@ref) type, which is used
to refer to the added constraint in other calls.

Check if a [`ConstraintIndex`](@ref) is valid using [`is_valid`](@ref).

```jldoctest constraints
julia> MOI.is_valid(model, c)
true
```

Use [`add_constraints`](@ref) to add a number of constraints of the same type.

```jldoctest; setup=:(model = MOI.Utilities.Model{Float64}(); x = MOI.add_variables(model, 2))
julia> c = MOI.add_constraints(
           model,
           [x[1], x[2]],
           [MOI.GreaterThan(0.0), MOI.GreaterThan(1.0)]
       )
2-element Vector{MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.GreaterThan{Float64}}}:
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.GreaterThan{Float64}}(1)
 MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.GreaterThan{Float64}}(2)
```
This time, a vector of [`ConstraintIndex`](@ref) are returned.

Use [`supports_constraint`](@ref) to check if the model supports adding a
constraint type.
```jldoctest; setup=:(model = MOI.Utilities.Model{Float64}())
julia> MOI.supports_constraint(
           model,
           MOI.VariableIndex,
           MOI.GreaterThan{Float64},
       )
true
```

## Delete a constraint

Use [`delete`](@ref) to delete a constraint.

```jldoctest constraints
julia> MOI.delete(model, c)

julia> MOI.is_valid(model, c)
false
```

## Constraint attributes

The following attributes are available for constraints:

* [`ConstraintName`](@ref)
* [`ConstraintPrimalStart`](@ref)
* [`ConstraintDualStart`](@ref)
* [`ConstraintPrimal`](@ref)
* [`ConstraintDual`](@ref)
* [`ConstraintBasisStatus`](@ref)
* [`ConstraintFunction`](@ref)
* [`CanonicalConstraintFunction`](@ref)
* [`ConstraintSet`](@ref)

Get and set these attributes using [`get`](@ref) and [`set`](@ref).

```jldoctest constraints
julia> MOI.set(model, MOI.ConstraintName(), c, "con_c")

julia> MOI.get(model, MOI.ConstraintName(), c)
"con_c"
```

## Constraints by function-set pairs

Below is a list of common constraint types and how they are represented
as function-set pairs in MOI. In the notation below, ``x`` is a vector of
decision variables, ``x_i`` is a scalar decision variable, ``\alpha, \beta`` are
scalar constants, ``a, b`` are constant vectors, `A` is a constant matrix and
``\mathbb{R}_+`` (resp. ``\mathbb{R}_-``) is the set of non-negative (resp.
non-positive) real numbers.

### Linear constraints

| Mathematical Constraint       | MOI Function                 | MOI Set        |
|-------------------------------|------------------------------|----------------|
| ``a^Tx \le \beta``            | `ScalarAffineFunction`       | `LessThan`     |
| ``a^Tx \ge \alpha``           | `ScalarAffineFunction`       | `GreaterThan`  |
| ``a^Tx = \beta``              | `ScalarAffineFunction`       | `EqualTo`      |
| ``\alpha \le a^Tx \le \beta`` | `ScalarAffineFunction`       | `Interval`     |
| ``x_i \le \beta``             | `VariableIndex`              | `LessThan`     |
| ``x_i \ge \alpha``            | `VariableIndex`              | `GreaterThan`  |
| ``x_i = \beta``               | `VariableIndex`              | `EqualTo`      |
| ``\alpha \le x_i \le \beta``  | `VariableIndex`              | `Interval`     |
| ``Ax + b \in \mathbb{R}_+^n`` | `VectorAffineFunction`       | `Nonnegatives` |
| ``Ax + b \in \mathbb{R}_-^n`` | `VectorAffineFunction`       | `Nonpositives` |
| ``Ax + b = 0``                | `VectorAffineFunction`       | `Zeros`        |

By convention, solvers are not expected to support nonzero constant terms in the
[`ScalarAffineFunction`](@ref)s the first four rows of the preceding table
because they are redundant with the parameters of the sets. For example, encode
``2x + 1 \le 2`` as ``2x \le 1``.

Constraints with [`VariableIndex`](@ref) in [`LessThan`](@ref), [`GreaterThan`](@ref),
[`EqualTo`](@ref), or [`Interval`](@ref) sets have a natural interpretation as
variable bounds. As such, it is typically not natural to impose multiple lower-
or upper-bounds on the same variable, and the solver interfaces will throw
respectively [`LowerBoundAlreadySet`](@ref) or [`UpperBoundAlreadySet`](@ref).

Moreover, adding two [`VariableIndex`](@ref) constraints on the same variable
with the same set is impossible because they share the same index as it is the
index of the variable, see [`ConstraintIndex`](@ref).

It is natural, however, to impose upper- and lower-bounds separately as two
different constraints on a single variable. The difference between imposing
bounds by using a single [`Interval`](@ref) constraint and by using separate
[`LessThan`](@ref) and [`GreaterThan`](@ref) constraints is that the latter will
allow the solver to return separate dual multipliers for the two bounds, while
the former will allow the solver to return only a single dual for the interval
constraint.

### Conic constraints

| Mathematical Constraint                                       | MOI Function                 | MOI Set                            |
|---------------------------------------------------------------|------------------------------|------------------------------------|
| ``\lVert Ax + b\rVert_2 \le c^Tx + d``                        | `VectorAffineFunction`       | `SecondOrderCone`                  |
| ``y \ge \lVert x \rVert_2``                                   | `VectorOfVariables`          | `SecondOrderCone`                  |
| ``2yz \ge \lVert x \rVert_2^2, y,z \ge 0``                    | `VectorOfVariables`          | `RotatedSecondOrderCone`           |
| ``(a_1^Tx + b_1,a_2^Tx + b_2,a_3^Tx + b_3) \in \mathcal{E}``  | `VectorAffineFunction`       | `ExponentialCone`                  |
| ``A(x) \in \mathcal{S}_+``                                    | `VectorAffineFunction`       | `PositiveSemidefiniteConeTriangle` |
| ``B(x) \in \mathcal{S}_+``                                    | `VectorAffineFunction`       | `PositiveSemidefiniteConeSquare`   |
| ``x \in \mathcal{S}_+``                                       | `VectorOfVariables`          | `PositiveSemidefiniteConeTriangle` |
| ``x \in \mathcal{S}_+``                                       | `VectorOfVariables`          | `PositiveSemidefiniteConeSquare`   |

where ``\mathcal{E}`` is the exponential cone (see [`ExponentialCone`](@ref)),
``\mathcal{S}_+`` is the set of positive semidefinite symmetric matrices,
``A`` is an affine map that outputs symmetric matrices and
``B`` is an affine map that outputs square matrices.

### Quadratic constraints

| Mathematical Constraint       | MOI Function                 | MOI Set                       |
|-------------------------------|------------------------------|-------------------------------|
| ``\frac{1}{2}x^TQx + a^Tx + b \ge 0``    | `ScalarQuadraticFunction`    | `GreaterThan`                 |
| ``\frac{1}{2}x^TQx + a^Tx + b \le 0``    | `ScalarQuadraticFunction`    | `LessThan`                    |
| ``\frac{1}{2}x^TQx + a^Tx + b = 0``      | `ScalarQuadraticFunction`    | `EqualTo`                     |
| Bilinear matrix inequality    | `VectorQuadraticFunction`    | `PositiveSemidefiniteCone...` |

!!! note
    For more details on the internal format of the quadratic functions see
    [`ScalarQuadraticFunction`](@ref) or [`VectorQuadraticFunction`](@ref).

### Discrete and logical constraints

| Mathematical Constraint                                                                    | MOI Function           | MOI Set                            |
|--------------------------------------------------------------------------------------------|------------------------|------------------------------------|
| ``x_i \in \mathbb{Z}``                                                                     | `VariableIndex`        | `Integer`                          |
| ``x_i \in \{0,1\}``                                                                        | `VariableIndex`        | `ZeroOne`                          |
| ``x_i \in \{0\} \cup [l,u]``                                                               | `VariableIndex`        | `Semicontinuous`                   |
| ``x_i \in \{0\} \cup \{l,l+1,\ldots,u-1,u\}``                                              | `VariableIndex`        | `Semiinteger`                      |
| At most one component of ``x`` can be nonzero                                              | `VectorOfVariables`    | `SOS1`                             |
| At most two components of ``x`` can be nonzero, and if so they must be adjacent components | `VectorOfVariables`    | `SOS2`                             |
| ``y = 1 \implies a^T x \in S``                                                             | `VectorAffineFunction` | `Indicator`                        |

## JuMP mapping

The following bullet points show examples of how JuMP constraints are translated
into MOI function-set pairs:

 - `@constraint(m, 2x + y <= 10)` becomes `ScalarAffineFunction`-in-`LessThan`
 - `@constraint(m, 2x + y >= 10)` becomes `ScalarAffineFunction`-in-`GreaterThan`
 - `@constraint(m, 2x + y == 10)` becomes `ScalarAffineFunction`-in-`EqualTo`
 - `@constraint(m, 0 <= 2x + y <= 10)` becomes `ScalarAffineFunction`-in-`Interval`
 - `@constraint(m, 2x + y in ArbitrarySet())` becomes
   `ScalarAffineFunction`-in-`ArbitrarySet`.

Variable bounds are handled in a similar fashion:

 - `@variable(m, x <= 1)` becomes `VariableIndex`-in-`LessThan`
 - `@variable(m, x >= 1)` becomes `VariableIndex`-in-`GreaterThan`

One notable difference is that a variable with an upper and lower bound is
translated into two constraints, rather than an interval, that is:

 - `@variable(m, 0 <= x <= 1)` becomes `VariableIndex`-in-`LessThan` *and*
    `VariableIndex`-in-`GreaterThan`.

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Solving a problem using MathOptInterface

In this tutorial we demonstrate how to use MathOptInterface to solve the
binary-constrained knapsack problem:
```math
\begin{aligned}
\max \; & c^\top x       \\
s.t. \; & w^\top x \le C \\
        & x_i \in \{0,1\},\quad \forall i=1,\ldots,n
\end{aligned}
```

## Required packages

Load the MathOptInterface module and define the shorthand `MOI`:
```julia
import MathOptInterface as MOI
```

As an optimizer, we choose GLPK:
```julia
using GLPK
optimizer = GLPK.Optimizer()
```

## Define the data

We first define the constants of the problem:
```jldoctest knapsack; setup = :(optimizer = MOI.Utilities.MockOptimizer(MOI.Utilities.Model{Float64}()); MOI.Utilities.set_mock_optimize!(optimizer, mock -> MOI.Utilities.mock_optimize!(mock, ones(3))))
julia> c = [1.0, 2.0, 3.0]
3-element Vector{Float64}:
 1.0
 2.0
 3.0

julia> w = [0.3, 0.5, 1.0]
3-element Vector{Float64}:
 0.3
 0.5
 1.0

julia> C = 3.2
3.2
```

## Add the variables

```jldoctest knapsack
julia> x = MOI.add_variables(optimizer, length(c));
```

## [Set the objective](@id set_objective_example)

```jldoctest knapsack
julia> MOI.set(
           optimizer,
           MOI.ObjectiveFunction{MOI.ScalarAffineFunction{Float64}}(),
           MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(c, x), 0.0),
       );

julia> MOI.set(optimizer, MOI.ObjectiveSense(), MOI.MAX_SENSE)
```

!!! tip
    `MOI.ScalarAffineTerm.(c, x)` is a shortcut for
    `[MOI.ScalarAffineTerm(c[i], x[i]) for i = 1:3]`. This is Julia's broadcast
    syntax in action, and is used quite often throughout MOI.

## Add the constraints

We add the knapsack constraint and integrality constraints:
```jldoctest knapsack
julia> MOI.add_constraint(
           optimizer,
           MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(w, x), 0.0),
           MOI.LessThan(C),
       );
```

Add integrality constraints:
```jldoctest knapsack
julia> for x_i in x
           MOI.add_constraint(optimizer, x_i, MOI.ZeroOne())
       end
```

## Optimize the model

```jldoctest knapsack
julia> MOI.optimize!(optimizer)
```

## Understand why the solver stopped

The first thing to check after optimization is why the solver stopped, for
example, did it stop because of a time limit or did it stop because it found the
optimal solution?
```jldoctest knapsack
julia> MOI.get(optimizer, MOI.TerminationStatus())
OPTIMAL::TerminationStatusCode = 1
```
Looks like we found an optimal solution.

## Understand what solution was returned


```jldoctest knapsack
julia> MOI.get(optimizer, MOI.ResultCount())
1

julia> MOI.get(optimizer, MOI.PrimalStatus())
FEASIBLE_POINT::ResultStatusCode = 1

julia> MOI.get(optimizer, MOI.DualStatus())
NO_SOLUTION::ResultStatusCode = 0
```

## Query the objective

What is its objective value?
```jldoctest knapsack
julia> MOI.get(optimizer, MOI.ObjectiveValue())
6.0
```

## Query the primal solution

And what is the value of the variables `x`?
```jldoctest knapsack
julia> MOI.get(optimizer, MOI.VariablePrimal(), x)
3-element Vector{Float64}:
 1.0
 1.0
 1.0
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Variables

## Functions

```@docs
add_variable
add_variables
add_constrained_variable
add_constrained_variables
supports_add_constrained_variable
supports_add_constrained_variables
is_valid(::ModelLike,::VariableIndex)
delete(::ModelLike, ::VariableIndex)
delete(::ModelLike, ::Vector{VariableIndex})
```

## Attributes

```@docs
AbstractVariableAttribute
VariableName
VariablePrimalStart
VariablePrimal
VariableBasisStatus
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Nonlinear programming

## Types
```@docs
AbstractNLPEvaluator
NLPBoundsPair
NLPBlockData
```

## Attributes

```@docs
NLPBlock
NLPBlockDual
NLPBlockDualStart
```

## Functions

```@docs
initialize
features_available
eval_objective
eval_constraint
eval_objective_gradient
jacobian_structure
eval_constraint_gradient
constraint_gradient_structure
eval_constraint_jacobian
eval_constraint_jacobian_product
eval_constraint_jacobian_transpose_product
hessian_lagrangian_structure
hessian_objective_structure
hessian_constraint_structure
eval_hessian_objective
eval_hessian_constraint
eval_hessian_lagrangian
eval_hessian_lagrangian_product
objective_expr
constraint_expr
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Variables

## Add a variable

Use [`add_variable`](@ref) to add a single variable.

```jldoctest variables; setup=:(model = MOI.Utilities.Model{Float64}(); )
julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)
```
[`add_variable`](@ref) returns a [`VariableIndex`](@ref) type, which is used to
refer to the added variable in other calls.

Check if a [`VariableIndex`](@ref) is valid using [`is_valid`](@ref).
```jldoctest variables
julia> MOI.is_valid(model, x)
true
```

Use [`add_variables`](@ref) to add a number of variables.
```jldoctest variables
julia> y = MOI.add_variables(model, 2)
2-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)
```

!!! warning
    The integer does not necessarily correspond to the column inside an
    optimizer.

## Delete a variable

Delete a variable using [`delete`](@ref).

```jldoctest variables
julia> MOI.delete(model, x)

julia> MOI.is_valid(model, x)
false
```

!!! warning
    Not all `ModelLike` models support deleting variables. A
    [`DeleteNotAllowed`](@ref) error is thrown if this is not supported.

## Variable attributes

The following attributes are available for variables:

* [`VariableName`](@ref)
* [`VariablePrimalStart`](@ref)
* [`VariablePrimal`](@ref)

Get and set these attributes using [`get`](@ref) and [`set`](@ref).

```jldoctest variables
julia> MOI.set(model, MOI.VariableName(), x, "var_x")

julia> MOI.get(model, MOI.VariableName(), x)
"var_x"
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Defining a new set

The easiest way to extend the behavior of MathOptInterface is to design a new
set. The purpose of this tutorial is to explain how to define a new set and some
of the associated nuances.

Defining a new function is an order of magnitude (if not two) harder than
defining a new set. Don't consider it as an option unless you have already tried
to support your behavior as a set.

As a motivation for this tutorial, we consider the _LinMax_ constraint type,
which appears often in constraint programming:
```math
t = \max(f_1(x), f_2(x), \ldots, f_N(x))
```

The first step to design a new set for MathOptInterface is to define the
mathematical relationship you want to model as a _function-in-set_ $f(x) \in S$.

Your initial thought for representing the _LinMax_ constraint in MathOptInterface
may be to represent it as:
```math
F(x) \in LinMax(t)
```
where $F(x)$ is the vector-valued function created by concatenating the $f_i$
functions. This formulation violates a basic rule of MathOptInterface:

!!! rule
    Sets cannot contain references to decision variables or other constraints.

Instead, we could model the _LinMax_ constraint as:
```math
[t, f_1(x), f_2(x), \ldots, f_N(x)] \in LinMax(N+1)
```

In the language of MathOptInterface, this is a [`AbstractVectorFunction`](@ref)
in the `LinMax` set of dimension $N+1$. The type of the function depends on the
types of the component scalar functions, with a special convention that the
first element in the function is interpretable as a [`VariableIndex`](@ref)
`t`.

Now `LinMax` can be trivially defined as a new [`AbstractVectorSet`](@ref):
```jldoctest define_new_set
julia> import MathOptInterface as MOI

julia> struct LinMax <: MOI.AbstractVectorSet
           dimension::Int
       end
```
and it can immediately be used in MathOptInterface:
```jldoctest define_new_set
julia> model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}());

julia> t = MOI.VariableIndex(1);

julia> x = MOI.VariableIndex.(2:3);

julia> F = 1.0 .* x .+ 2.0;

julia> g = MOI.Utilities.operate(vcat, Float64, t, F...);

julia> MOI.add_constraint(model, g, LinMax(3))
MathOptInterface.ConstraintIndex{MathOptInterface.VectorAffineFunction{Float64}, LinMax}(1)

julia> print(model)
Feasibility

Subject to:

VectorAffineFunction{Float64}-in-LinMax
 ┌              ┐
 │0.0 + 1.0 v[1]│
 │2.0 + 1.0 v[2]│
 │2.0 + 1.0 v[3]│
 └              ┘ ∈ LinMax(3)
```

# Introduction

Welcome to the documentation for MathOptInterface.

!!! note
    This documentation is also available in PDF format:
    [MathOptInterface.pdf](MathOptInterface.pdf).

## What is MathOptInterface?

[MathOptInterface.jl](https://github.com/jump-dev/MathOptInterface.jl) (MOI) is
an abstraction layer designed to provide a unified interface to mathematical
optimization solvers so that users do not need to understand multiple
solver-specific APIs.

!!! tip
    This documentation is aimed at developers writing software interfaces to
    solvers and modeling languages using the MathOptInterface API. If you are a
    user interested in solving optimization problems, we encourage you instead
    to use MOI through a higher-level modeling interface like
    [JuMP](https://github.com/jump-dev/JuMP.jl) or
    [Convex.jl](https://github.com/jump-dev/Convex.jl).

## How the documentation is structured

Having a high-level overview of how this documentation is structured will help
you know where to look for certain things.

* The **Tutorials** section contains articles on how to use and implement the
  MathOptInteraface API. Look here if you want to write a model in MOI, or write
  an interface to a new solver.
* The **Manual** contains short code-snippets that explain how to use the MOI
  API. Look here for more details on particular areas of MOI.
* The **Background** section contains articles on the theory
  behind MathOptInterface. Look here if you want to understand _why_, rather
  than _how_.
* The **API Reference** contains a complete list of functions and types that
  comprise the MOI API. Look here if you want to know how to use (or implement)
  a particular function.
* The **Submodules** section contains stand-alone documentation for each of the
  submodules within MOI. These submodules are not required to interface a solver
  with MOI, but they make the job much easier.

## Citing MathOptInterface

If you find MathOptInterface useful in your work, we kindly request that you
cite the following paper:
```bibtex
@article{legat2021mathoptinterface,
    title={{MathOptInterface}: a data structure for mathematical optimization problems},
    author={Legat, Beno{\^\i}t and Dowson, Oscar and Garcia, Joaquim Dias and Lubin, Miles},
    journal={INFORMS Journal on Computing},
    year={2021},
    doi={10.1287/ijoc.2021.1067},
    publisher={INFORMS}
}
```
A preprint of this paper is [freely available](https://arxiv.org/abs/2002.03447).

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Latency

MathOptInterface suffers the "time-to-first-solve" problem of start-up latency.

This hurts both the user- and developer-experience of MathOptInterface. In the
first case, because simple models have a multi-second delay before solving, and
in the latter, because our tests take so long to run.

This page contains some advice on profiling and fixing latency-related problems
in the MathOptInterface.jl repository.

## Background

Before reading this part of the documentation, you should familiarize yourself
with the reasons for latency in Julia and how to fix them.

 * Read the blogposts on julialang.org on [precompilation](https://julialang.org/blog/2021/01/precompile_tutorial/)
   and [SnoopCompile](https://julialang.org/blog/2021/01/snoopi_deep/)
 * Read the [SnoopCompile](https://juliadebug.github.io/SnoopCompile.jl/stable/)
   documentation.
 * Watch Tim Holy's [talk at JuliaCon 2021](https://www.youtube.com/watch?v=rVBgrWYKLHY)
 * Watch the [package development workshop at JuliaCon 2021](https://www.youtube.com/watch?v=wXRMwJdEjX4)

## Causes

There are three main causes of latency in MathOptInterface:

 1. A large number of types
 2. Lack of method ownership
 3. Type-instability in the bridge layer

### A large number of types

Julia is very good at specializing method calls based on the input type. Each
specialization has a compilation cost, but the benefit of faster run-time
performance.

The best-case scenario is for a method to be called a large number of times with
a single set of argument types. The worst-case scenario is for a method to be
called a single time for a large set of argument types.

Because of MathOptInterface's _function-in-set_ formulation, we fall into the
worst-case situation.

This is a fundamental limitation of Julia, so there isn't much we can do about
it. However, if we can precompile MathOptInterface, much of the cost can be
shifted from start-up latency to the time it takes to precompile a package on
installation.

However, there are two things which make MathOptInterface hard to precompile.

### Lack of method ownership

Lack of method ownership happens when a call is made using a mix of structs and
methods from different modules. Because of this, no single module "owns" the
method that is being dispatched, and so it cannot be precompiled.

!!! tip
    This is a slightly simplified explanation. Read the [precompilation tutorial](https://julialang.org/blog/2021/01/precompile_tutorial/)
    for a more in-depth discussion on back-edges.

Unfortunately, the design of MOI means that this is a frequent occurrence: we
have a bunch of types in `MOI.Utilities` that wrap types defined in external
packages (for example, the `Optimizer`s), which implement methods of functions
defined in `MOI` (for example, `add_variable`, `add_constraint`).

Here's a simple example of method-ownership in practice:
```julia
module MyMOI
struct Wrapper{T}
    inner::T
end
optimize!(x::Wrapper) = optimize!(x.inner)
end  # MyMOI

module MyOptimizer
using ..MyMOI
struct Optimizer end
MyMOI.optimize!(x::Optimizer) = 1
end  # MyOptimizer

using SnoopCompile
model = MyMOI.Wrapper(MyOptimizer.Optimizer())

julia> tinf = @snoopi_deep MyMOI.optimize!(model)
InferenceTimingNode: 0.008256/0.008543 on InferenceFrameInfo for Core.Compiler.Timings.ROOT() with 1 direct children
```
The result is that there was one method that required type inference. If we
visualize `tinf`:
```julia
using ProfileView
ProfileView.view(flamegraph(tinf))
```
we see a flamegraph with a large red-bar indicating that the method
`MyMOI.optimize(MyMOI.Wrapper{MyOptimizer.Optimizer})` cannot be precompiled.

To fix this, we need to designate a module to "own" that method (that is, create
a back-edge). The easiest way to do this is for `MyOptimizer` to call
`MyMOI.optimize(MyMOI.Wrapper{MyOptimizer.Optimizer})` during
`using MyOptimizer`. Let's see that in practice:
```julia
module MyMOI
struct Wrapper{T}
    inner::T
end
optimize(x::Wrapper) = optimize(x.inner)
end  # MyMOI

module MyOptimizer
using ..MyMOI
struct Optimizer end
MyMOI.optimize(x::Optimizer) = 1
# The syntax of this let-while loop is very particular:
#  * `let ... end` keeps everything local to avoid polluting the MyOptimizer
#    namespace
#  * `while true ... break end` runs the code once, and forces Julia to compile
#    the inner loop, rather than interpret it.
let
    while true
        model = MyMOI.Wrapper(Optimizer())
        MyMOI.optimize(model)
        break
    end
end
end  # MyOptimizer

using SnoopCompile
model = MyMOI.Wrapper(MyOptimizer.Optimizer())

julia> tinf = @snoopi_deep MyMOI.optimize(model)
InferenceTimingNode: 0.006822/0.006822 on InferenceFrameInfo for Core.Compiler.Timings.ROOT() with 0 direct children
```
There are now `0` direct children that required type inference because the
method was already stored in `MyOptimizer`!

Unfortunately, this trick only works if the call-chain is fully inferrable. If
there are breaks (due to type instability), then the benefit of doing this is
reduced. And unfortunately for us, the design of MathOptInterface has a lot of
type instabilities.

### Type instability in the bridge layer

Most of MathOptInterface is pretty good at ensuring type-stability. However, a
key component is not type stable, and that is the bridging layer.

In particular, the bridging layer defines [`Bridges.LazyBridgeOptimizer`](@ref),
which has fields like:
```julia
struct LazyBridgeOptimizer
    constraint_bridge_types::Vector{Any}
    constraint_node::Dict{Tuple{Type,Type},ConstraintNode}
    constraint_types::Vector{Tuple{Type,Type}}
end
```
This is because the `LazyBridgeOptimizer` needs to be able to deal with any
_function-in-set_ type passed to it, and we also allow users to pass additional
bridges that they defined in external packages.

So to recap, MathOptInterface suffers package latency because:

 1. there are a large number of types and functions
 2. and these are split between multiple modules, including external packages
 3. and there are type-instabilities like those in the bridging layer.

## Resolutions

There are no magic solutions to reduce latency.
[Issue #1313](https://github.com/jump-dev/MathOptInterface.jl/issues/1313)
tracks progress on reducing latency in MathOptInterface.

A useful script is the following (replace GLPK as needed):
```julia
import GLPK
import MathOptInterface as MOI

function example_diet(optimizer, bridge)
    category_data = [
        1800.0 2200.0;
          91.0    Inf;
           0.0   65.0;
           0.0 1779.0
    ]
    cost = [2.49, 2.89, 1.50, 1.89, 2.09, 1.99, 2.49, 0.89, 1.59]
    food_data = [
        410 24 26 730;
        420 32 10 1190;
        560 20 32 1800;
        380  4 19 270;
        320 12 10 930;
        320 15 12 820;
        320 31 12 1230;
        100  8 2.5 125;
        330  8 10 180
    ]
    bridge_model = if bridge
        MOI.instantiate(optimizer; with_bridge_type=Float64)
    else
        MOI.instantiate(optimizer)
    end
    model = MOI.Utilities.CachingOptimizer(
        MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}()),
        MOI.Utilities.AUTOMATIC,
    )
    MOI.Utilities.reset_optimizer(model, bridge_model)
    MOI.set(model, MOI.Silent(), true)
    nutrition = MOI.add_variables(model, size(category_data, 1))
    for (i, v) in enumerate(nutrition)
        MOI.add_constraint(model, v, MOI.GreaterThan(category_data[i, 1]))
        MOI.add_constraint(model, v, MOI.LessThan(category_data[i, 2]))
    end
    buy = MOI.add_variables(model, size(food_data, 1))
    MOI.add_constraint.(model, buy, MOI.GreaterThan(0.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    f = MOI.ScalarAffineFunction(MOI.ScalarAffineTerm.(cost, buy), 0.0)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    for (j, n) in enumerate(nutrition)
        f = MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(food_data[:, j], buy),
            0.0,
        )
        push!(f.terms, MOI.ScalarAffineTerm(-1.0, n))
        MOI.add_constraint(model, f, MOI.EqualTo(0.0))
    end
    MOI.optimize!(model)
    term_status = MOI.get(model, MOI.TerminationStatus())
    @assert term_status == MOI.OPTIMAL
    MOI.add_constraint(
        model,
        MOI.ScalarAffineFunction(
            MOI.ScalarAffineTerm.(1.0, [buy[end-1], buy[end]]),
            0.0,
        ),
        MOI.LessThan(6.0),
    )
    MOI.optimize!(model)
    @assert MOI.get(model, MOI.TerminationStatus()) == MOI.INFEASIBLE
    return
end

if length(ARGS) > 0
    bridge = get(ARGS, 2, "") != "--no-bridge"
    println("Running: $(ARGS[1]) $(get(ARGS, 2, ""))")
    @time example_diet(GLPK.Optimizer, bridge)
    @time example_diet(GLPK.Optimizer, bridge)
    exit(0)
end
```

You can create a flame-graph via
```julia
using SnoopCompile
tinf = @snoopi_deep example_diet(GLPK.Optimizer, true)
using ProfileView
ProfileView.view(flamegraph(tinf))
```

Here's how things looked in mid-August 2021:
![flamegraph](../assets/latency.png)

There are a few opportunities for improvement (non-red flames, particularly on
the right). But the main problem is a large red (non-precompilable due to method
ownership) flame.

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# The Bridges submodule

The `Bridges` module simplifies the process of converting models between
equivalent formulations.

!!! tip
    [Read our paper](https://arxiv.org/abs/2002.03447) for more details on how
    bridges are implemented.

## Why bridges?

A constraint can often be written in a number of equivalent formulations. For
example, the constraint ``l \le a^\top x \le u``
([`ScalarAffineFunction`](@ref)-in-[`Interval`](@ref)) could be re-formulated as
two constraints: ``a^\top x \ge l`` ([`ScalarAffineFunction`](@ref)-in-[`GreaterThan`](@ref))
and ``a^\top x \le u`` (`ScalarAffineFunction`-in-`LessThan`). An alternative
re-formulation is to add a dummy variable `y` with the constraints ``l \le y \le u``
([`VariableIndex`](@ref)-in-[`Interval`](@ref)) and ``a^\top x - y = 0``
([`ScalarAffineFunction`](@ref)-in-[`EqualTo`](@ref)).

To avoid each solver having to code these transformations manually,
MathOptInterface provides *bridges*.

A bridge is a small transformation from one constraint type to another
(potentially collection of) constraint type.

Because these bridges are included in MathOptInterface, they can be re-used by
any optimizer. Some bridges also implement constraint modifications and
constraint primal and dual translations.

Several bridges can be used in combination to transform a single constraint
into a form that the solver may understand. Choosing the bridges to use
takes the form of finding a shortest path in the hyper-graph of bridges. The
methodology is detailed in [the MOI paper](https://arxiv.org/abs/2002.03447).

## The three types of bridges

There are three types of bridges in MathOptInterface:
1. Constraint bridges
2. Variable bridges
3. Objective bridges

### Constraint bridges

Constraint bridges convert constraints formulated by the user into an equivalent
form supported by the solver. Constraint bridges are subtypes of
[`Bridges.Constraint.AbstractBridge`](@ref).

The equivalent formulation may add constraints (and possibly also variables) in
the underlying model.

In particular, constraint bridges can focus on rewriting the function of a
constraint, and do not change the set. Function bridges are subtypes of
[`Bridges.Constraint.AbstractFunctionConversionBridge`](@ref).

Read the [list of implemented constraint bridges](@ref constraint_bridges_ref)
for more details on the types of transformations that are available.
Function bridges are [`Bridges.Constraint.ScalarFunctionizeBridge`](@ref) and
[`Bridges.Constraint.VectorFunctionizeBridge`](@ref).

### [Variable bridges](@id variable_bridges)

Variable bridges convert variables added by the user, either free with
[`add_variable`](@ref)/[`add_variables`](@ref), or constrained with
[`add_constrained_variable`](@ref)/[`add_constrained_variables`](@ref),
into an equivalent form supported by the solver. Variable bridges are
subtypes of [`Bridges.Variable.AbstractBridge`](@ref).

The equivalent formulation may add constraints (and possibly also variables) in
the underlying model.

Read the [list of implemented variable bridges](@ref variable_bridges_ref) for
more details on the types of transformations that are available.

### Objective bridges

Objective bridges convert the [`ObjectiveFunction`](@ref) set by the user into
an equivalent form supported by the solver. Objective bridges are
subtypes of [`Bridges.Objective.AbstractBridge`](@ref).

The equivalent formulation may add constraints (and possibly also variables) in
the underlying model.

Read the [list of implemented objective bridges](@ref objective_bridges_ref) for
more details on the types of transformations that are available.

## Bridges.`full_bridge_optimizer`

!!! tip
    Unless you have an advanced use-case, this is probably the only function you
    need to care about.

To enable the full power of MathOptInterface's bridges, wrap an `optimizer`
in a [`Bridges.full_bridge_optimizer`](@ref).

```jldoctest
julia> inner_optimizer = MOI.Utilities.Model{Float64}()
MOIU.Model{Float64}
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0

julia> optimizer = MOI.Bridges.full_bridge_optimizer(inner_optimizer, Float64)
MOIB.LazyBridgeOptimizer{MOIU.Model{Float64}}
├ Variable bridges: none
├ Constraint bridges: none
├ Objective bridges: none
└ model: MOIU.Model{Float64}
  ├ ObjectiveSense: FEASIBILITY_SENSE
  ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
  ├ NumberOfVariables: 0
  └ NumberOfConstraints: 0
```

Now, use `optimizer` as normal, and bridging will happen lazily behind the
scenes. By lazily, we mean that bridging will happen if and only if the
constraint is not supported by the `inner_optimizer`.

!!! info
    Most bridges are added by default in [`Bridges.full_bridge_optimizer`](@ref).
    However, for technical reasons, some bridges are not added by default. Three
    examples include [`Bridges.Constraint.SOCtoPSDBridge`](@ref),
    [`Bridges.Constraint.SOCtoNonConvexQuadBridge`](@ref) and
    [`Bridges.Constraint.RSOCtoNonConvexQuadBridge`](@ref). See the docs of
    those bridges for more information.

## Add a single bridge

If you don't want to use [`Bridges.full_bridge_optimizer`](@ref), you can wrap
an optimizer in a single bridge.

However, this will force the constraint to be bridged, even if the
`inner_optimizer` supports it.

```jldoctest
julia> inner_optimizer = MOI.Utilities.Model{Float64}();

julia> optimizer = MOI.Bridges.Constraint.SplitInterval{Float64}(inner_optimizer);

julia> x = MOI.add_variable(optimizer)
MOI.VariableIndex(1)

julia> MOI.add_constraint(optimizer, x, MOI.Interval(0.0, 1.0))
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}}(1)

julia> MOI.get(optimizer, MOI.ListOfConstraintTypesPresent())
1-element Vector{Tuple{Type, Type}}:
 (MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64})

julia> MOI.get(inner_optimizer, MOI.ListOfConstraintTypesPresent())
2-element Vector{Tuple{Type, Type}}:
 (MathOptInterface.VariableIndex, MathOptInterface.GreaterThan{Float64})
 (MathOptInterface.VariableIndex, MathOptInterface.LessThan{Float64})
```

## Bridges.LazyBridgeOptimizer

If you don't want to use [`Bridges.full_bridge_optimizer`](@ref), but you need
more than a single bridge (or you want the bridging to happen lazily), you can
manually construct a [`Bridges.LazyBridgeOptimizer`](@ref).

First, wrap an inner optimizer:
```jldoctest lazy_bridge_optimizer
julia> inner_optimizer = MOI.Utilities.Model{Float64}()
MOIU.Model{Float64}
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0

julia> optimizer = MOI.Bridges.LazyBridgeOptimizer(inner_optimizer)
MOIB.LazyBridgeOptimizer{MOIU.Model{Float64}}
├ Variable bridges: none
├ Constraint bridges: none
├ Objective bridges: none
└ model: MOIU.Model{Float64}
  ├ ObjectiveSense: FEASIBILITY_SENSE
  ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
  ├ NumberOfVariables: 0
  └ NumberOfConstraints: 0
```

Then use [`Bridges.add_bridge`](@ref) to add individual bridges:
```jldoctest lazy_bridge_optimizer
julia> MOI.Bridges.add_bridge(optimizer, MOI.Bridges.Constraint.SplitIntervalBridge{Float64})

julia> MOI.Bridges.add_bridge(optimizer, MOI.Bridges.Objective.FunctionizeBridge{Float64})
```

Now the constraints will be bridged only if needed:
```jldoctest lazy_bridge_optimizer
julia> x = MOI.add_variable(optimizer)
MOI.VariableIndex(1)

julia> MOI.add_constraint(optimizer, x, MOI.Interval(0.0, 1.0))
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64}}(1)

julia> MOI.get(optimizer, MOI.ListOfConstraintTypesPresent())
1-element Vector{Tuple{Type, Type}}:
 (MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64})

julia> MOI.get(inner_optimizer, MOI.ListOfConstraintTypesPresent())
1-element Vector{Tuple{Type, Type}}:
 (MathOptInterface.VariableIndex, MathOptInterface.Interval{Float64})
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

## Benchmarks

Functions to help benchmark the performance of solver wrappers. See
[The Benchmarks submodule](@ref) for more details.

```@docs
Benchmarks.suite
Benchmarks.create_baseline
Benchmarks.compare_against_baseline
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Bridges

## AbstractBridge API

```@docs
Bridges.AbstractBridge
Bridges.added_constrained_variable_types
Bridges.added_constraint_types
get(::Bridges.AbstractBridge, ::NumberOfVariables)
get(::Bridges.AbstractBridge, ::ListOfVariableIndices)
get(::Bridges.AbstractBridge, ::NumberOfConstraints)
get(::Bridges.AbstractBridge, ::ListOfConstraintIndices)
Bridges.needs_final_touch
Bridges.final_touch
Bridges.bridging_cost
Bridges.runtests
```

## Constraint bridge API

```@docs
Bridges.Constraint.AbstractBridge
Bridges.Constraint.SingleBridgeOptimizer
supports_constraint(::Type{<:Bridges.Constraint.AbstractBridge}, ::Type{<:AbstractFunction}, ::Type{<:AbstractSet})
Bridges.Constraint.concrete_bridge_type
Bridges.Constraint.bridge_constraint
Bridges.Constraint.add_all_bridges
Bridges.Constraint.conversion_cost
```

## Objective bridge API

```@docs
Bridges.Objective.AbstractBridge
Bridges.Objective.SingleBridgeOptimizer
Bridges.Objective.supports_objective_function
Bridges.set_objective_function_type
Bridges.Objective.concrete_bridge_type
Bridges.Objective.bridge_objective
Bridges.Objective.add_all_bridges
```

## [Variable bridge API](@id ref_variable_bridges)

```@docs
Bridges.Variable.AbstractBridge
Bridges.Variable.SingleBridgeOptimizer
Bridges.Variable.supports_constrained_variable
Bridges.Variable.concrete_bridge_type
Bridges.Variable.bridge_constrained_variable
Bridges.Variable.add_all_bridges
Bridges.Variable.unbridged_map
```

## AbstractBridgeOptimizer API

```@docs
Bridges.AbstractBridgeOptimizer
Bridges.bridged_variable_function
Bridges.unbridged_variable_function
Bridges.bridged_function
Bridges.supports_constraint_bridges
Bridges.recursive_model
Bridges.FirstBridge
```

## LazyBridgeOptimizer API

```@docs
Bridges.LazyBridgeOptimizer
Bridges.full_bridge_optimizer
Bridges.ListOfNonstandardBridges
Bridges.add_bridge
Bridges.remove_bridge
Bridges.has_bridge
Bridges.print_active_bridges
Bridges.print_graph
Bridges.debug_supports_constraint
Bridges.debug_supports
```

## [SetMap API](@id constraint_set_map)

```@docs
Bridges.MapNotInvertible
Bridges.map_set
Bridges.inverse_map_set
Bridges.map_function
Bridges.inverse_map_function
Bridges.adjoint_map_function
Bridges.inverse_adjoint_map_function
```

## Bridging graph API

```@docs
Bridges.Graph
Bridges.VariableNode
Bridges.ConstraintNode
Bridges.ObjectiveNode
Bridges.Edge
Bridges.ObjectiveEdge
Bridges.add_node
Bridges.add_edge
Bridges.set_variable_constraint_node
Bridges.bridge_index
Bridges.is_variable_edge_best
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# The Utilities submodule

The Utilities submodule provides a variety of functions and datastructures for
managing `MOI.ModelLike` objects.

## [Utilities.Model](@id overview_utilities_model)

[`Utilities.Model`](@ref) provides an implementation of a [`ModelLike`](@ref)
that efficiently supports all functions and sets defined within MOI. However,
given the extensibility of MOI, this might not cover all use cases.

Create a model as follows:
```jldoctest
julia> model = MOI.Utilities.Model{Float64}()
MOIU.Model{Float64}
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

## [Utilities.UniversalFallback](@id overview_utilities_universal_fallback)

[`Utilities.UniversalFallback`](@ref) is a layer that sits on top of any
[`ModelLike`](@ref) and provides non-specialized (slower) fallbacks for
constraints and attributes that the underlying [`ModelLike`](@ref) does not
support.

For example, [`Utilities.Model`](@ref) doesn't support some variable attributes
like [`VariablePrimalStart`](@ref), so JuMP uses a combination of Universal
fallback and [`Utilities.Model`](@ref) as a generic problem cache:
```jldoctest
julia> model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
MOIU.UniversalFallback{MOIU.Model{Float64}}
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

!!! warning
    Adding a UniversalFallback means that your `model` will now support all
    constraints, even if the inner-model does not. This can lead to unexpected
    behavior.

## [Utilities.@model](@id overview_model_macro)

For advanced use cases that need efficient support for functions and sets
defined outside of MOI (but still known at compile time), we provide the
[`Utilities.@model`](@ref) macro.

The `@model` macro takes a name (for a new type, which must not exist yet),
eight tuples specifying the types of constraints that are supported, and then a
`Bool` indicating the type is a subtype of `MOI.AbstractOptimizer` (if
`true`) or `MOI.ModelLike` (if `false`).

The eight tuples are in the following order:
 1. Un-typed scalar sets, for example, [`Integer`](@ref)
 2. Typed scalar sets, for example, [`LessThan`](@ref)
 3. Un-typed vector sets, for example, [`Nonnegatives`](@ref)
 4. Typed vector sets, for example, [`PowerCone`](@ref)
 5. Un-typed scalar functions, for example, [`VariableIndex`](@ref)
 6. Typed scalar functions, for example, [`ScalarAffineFunction`](@ref)
 7. Un-typed vector functions, for example, [`VectorOfVariables`](@ref)
 8. Typed vector functions, for example, [`VectorAffineFunction`](@ref)

The tuples can contain more than one element. Typed-sets must be specified
without their type parameter, for example, `MOI.LessThan`, not
`MOI.LessThan{Float64}`.

Here is an example:
```jldoctest
julia> MOI.Utilities.@model(
           MyNewModel,
           (MOI.Integer,),                  # Un-typed scalar sets
           (MOI.GreaterThan,),              # Typed scalar sets
           (MOI.Nonnegatives,),             # Un-typed vector sets
           (MOI.PowerCone,),                # Typed vector sets
           (MOI.VariableIndex,),            # Un-typed scalar functions
           (MOI.ScalarAffineFunction,),     # Typed scalar functions
           (MOI.VectorOfVariables,),        # Un-typed vector functions
           (MOI.VectorAffineFunction,),     # Typed vector functions
           true,                            # <:MOI.AbstractOptimizer?
       )
MathOptInterface.Utilities.GenericOptimizer{T, MathOptInterface.Utilities.ObjectiveContainer{T}, MathOptInterface.Utilities.VariablesContainer{T}, MyNewModelFunctionConstraints{T}} where T

julia> model = MyNewModel{Float64}()
MOIU.GenericOptimizer{Float64, MOIU.ObjectiveContainer{Float64}, MOIU.VariablesContainer{Float64}, MyNewModelFunctionConstraints{Float64}}
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

!!! warning
    `MyNewModel` supports every `VariableIndex`-in-Set constraint, as well as
    [`VariableIndex`](@ref), [`ScalarAffineFunction`](@ref), and
    [`ScalarQuadraticFunction`](@ref) objective functions. Implement
    `MOI.supports` as needed to forbid constraint and objective function
    combinations.

As another example, [PATHSolver](https://github.com/chkwon/PATHSolver.jl), which
only supports [`VectorAffineFunction`](@ref)-in-[`Complements`](@ref)
defines its optimizer as:
```jldoctest pathoptimizer
julia> MOI.Utilities.@model(
           PathOptimizer,
           (),  # Scalar sets
           (),  # Typed scalar sets
           (MOI.Complements,),  # Vector sets
           (),  # Typed vector sets
           (),  # Scalar functions
           (),  # Typed scalar functions
           (),  # Vector functions
           (MOI.VectorAffineFunction,),  # Typed vector functions
           true,  # is_optimizer
       )
MathOptInterface.Utilities.GenericOptimizer{T, MathOptInterface.Utilities.ObjectiveContainer{T}, MathOptInterface.Utilities.VariablesContainer{T}, MathOptInterface.Utilities.VectorOfConstraints{MathOptInterface.VectorAffineFunction{T}, MathOptInterface.Complements}} where T
```
However, `PathOptimizer` does not support some `VariableIndex`-in-Set
constraints, so we must explicitly define:
```jldoctest pathoptimizer
julia> function MOI.supports_constraint(
           ::PathOptimizer,
           ::Type{MOI.VariableIndex},
           ::Type{Union{<:MOI.Semiinteger,MOI.Semicontinuous,MOI.ZeroOne,MOI.Integer}}
       )
           return false
       end
```

Finally, PATH doesn't support an objective function, so we need to add:
```jldoctest pathoptimizer
julia> MOI.supports(::PathOptimizer, ::MOI.ObjectiveFunction) = false
```

!!! warning
    This macro creates a new type, so it must be called from the top-level of a
    module, for example, it cannot be called from inside a function.

## Utilities.CachingOptimizer

A [`Utilities.CachingOptimizer`] is an MOI layer that abstracts the difference
between solvers that support incremental modification (for example, they support
adding variables one-by-one), and solvers that require the entire problem in a
single API call (for example, they only accept the `A`, `b` and `c` matrices of
a linear program).

It has two parts:
 1. A cache, where the model can be built and modified incrementally
 2. An optimizer, which is used to solve the problem

```jldoctest pathoptimizer
julia> model = MOI.Utilities.CachingOptimizer(
           MOI.Utilities.Model{Float64}(),
           PathOptimizer{Float64}(),
       )
MOIU.CachingOptimizer
├ state: EMPTY_OPTIMIZER
├ mode: AUTOMATIC
├ model_cache: MOIU.Model{Float64}
│ ├ ObjectiveSense: FEASIBILITY_SENSE
│ ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
│ ├ NumberOfVariables: 0
│ └ NumberOfConstraints: 0
└ optimizer: MOIU.GenericOptimizer{Float64, MOIU.ObjectiveContainer{Float64}, MOIU.VariablesContainer{Float64}, MOIU.VectorOfConstraints{MOI.VectorAffineFunction{Float64}, MOI.Complements}}
  ├ ObjectiveSense: FEASIBILITY_SENSE
  ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
  ├ NumberOfVariables: 0
  └ NumberOfConstraints: 0
```

A [`Utilities.CachingOptimizer`](@ref) may be in one of three possible states:

* `NO_OPTIMIZER`: The CachingOptimizer does not have any optimizer.
* `EMPTY_OPTIMIZER`: The CachingOptimizer has an empty optimizer, and it is not
  synchronized with the cached model. Modifications are forwarded to the cache,
  but _not_ to the optimizer.
* `ATTACHED_OPTIMIZER`: The CachingOptimizer has an optimizer, and it is
  synchronized with the cached model. Modifications are forwarded to the
  optimizer. If the optimizer does not support modifications, and error will be
  thrown.

Use [`Utilities.attach_optimizer`](@ref) to go from `EMPTY_OPTIMIZER` to
`ATTACHED_OPTIMIZER`:
```jldoctest pathoptimizer
julia> MOI.Utilities.attach_optimizer(model)

julia> MOI.Utilities.state(model)
ATTACHED_OPTIMIZER::CachingOptimizerState = 2
```

!!! info
    You must be in `ATTACHED_OPTIMIZER` to use [`optimize!`](@ref).

Use [`Utilities.reset_optimizer`](@ref) to go from `ATTACHED_OPTIMIZER` to
`EMPTY_OPTIMIZER`:
```jldoctest pathoptimizer
julia> MOI.Utilities.reset_optimizer(model)

julia> MOI.Utilities.state(model)
EMPTY_OPTIMIZER::CachingOptimizerState = 1
```

!!! info
    Calling `MOI.empty!(model)` also resets the state to `EMPTY_OPTIMIZER`.
    So after emptying a model, the modification will only be applied to the
    cache.

Use [`Utilities.drop_optimizer`](@ref) to go from any state to `NO_OPTIMIZER`:
```jldoctest pathoptimizer
julia> MOI.Utilities.drop_optimizer(model)

julia> MOI.Utilities.state(model)
NO_OPTIMIZER::CachingOptimizerState = 0

julia> model
MOIU.CachingOptimizer
├ state: NO_OPTIMIZER
├ mode: AUTOMATIC
├ model_cache: MOIU.Model{Float64}
│ ├ ObjectiveSense: FEASIBILITY_SENSE
│ ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
│ ├ NumberOfVariables: 0
│ └ NumberOfConstraints: 0
└ optimizer: nothing
```

Pass an empty optimizer to [`Utilities.reset_optimizer`](@ref) to go from
`NO_OPTIMIZER` to `EMPTY_OPTIMIZER`:
```jldoctest pathoptimizer
julia> MOI.Utilities.reset_optimizer(model, PathOptimizer{Float64}())

julia> MOI.Utilities.state(model)
EMPTY_OPTIMIZER::CachingOptimizerState = 1

julia> model
MOIU.CachingOptimizer
├ state: EMPTY_OPTIMIZER
├ mode: AUTOMATIC
├ model_cache: MOIU.Model{Float64}
│ ├ ObjectiveSense: FEASIBILITY_SENSE
│ ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
│ ├ NumberOfVariables: 0
│ └ NumberOfConstraints: 0
└ optimizer: MOIU.GenericOptimizer{Float64, MOIU.ObjectiveContainer{Float64}, MOIU.VariablesContainer{Float64}, MOIU.VectorOfConstraints{MOI.VectorAffineFunction{Float64}, MOI.Complements}}
  ├ ObjectiveSense: FEASIBILITY_SENSE
  ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
  ├ NumberOfVariables: 0
  └ NumberOfConstraints: 0
```

Deciding when to attach and reset the optimizer is tedious, and you will often
write code like this:
```julia
try
    # modification
catch
    MOI.Utilities.reset_optimizer(model)
    # Re-try modification
end
```

To make this easier, [`Utilities.CachingOptimizer`](@ref) has two modes of
operation:

* `AUTOMATIC`: The `CachingOptimizer` changes its state when necessary.
  Attempting to add a constraint or perform a modification not supported by the
  optimizer results in a drop to `EMPTY_OPTIMIZER` mode.
* `MANUAL`: The user must change the state of the `CachingOptimizer`. Attempting
  to perform an operation in the incorrect state results in an error.

By default, `AUTOMATIC` mode is chosen. However, you can create a
`CachingOptimizer` in `MANUAL` mode as follows:
```jldoctest pathoptimizer
julia> model = MOI.Utilities.CachingOptimizer(
           MOI.Utilities.Model{Float64}(),
           MOI.Utilities.MANUAL,
       )
MOIU.CachingOptimizer
├ state: NO_OPTIMIZER
├ mode: MANUAL
├ model_cache: MOIU.Model{Float64}
│ ├ ObjectiveSense: FEASIBILITY_SENSE
│ ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
│ ├ NumberOfVariables: 0
│ └ NumberOfConstraints: 0
└ optimizer: nothing

julia> MOI.Utilities.reset_optimizer(model, PathOptimizer{Float64}())

julia> model
MOIU.CachingOptimizer
├ state: EMPTY_OPTIMIZER
├ mode: MANUAL
├ model_cache: MOIU.Model{Float64}
│ ├ ObjectiveSense: FEASIBILITY_SENSE
│ ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
│ ├ NumberOfVariables: 0
│ └ NumberOfConstraints: 0
└ optimizer: MOIU.GenericOptimizer{Float64, MOIU.ObjectiveContainer{Float64}, MOIU.VariablesContainer{Float64}, MOIU.VectorOfConstraints{MOI.VectorAffineFunction{Float64}, MOI.Complements}}
  ├ ObjectiveSense: FEASIBILITY_SENSE
  ├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
  ├ NumberOfVariables: 0
  └ NumberOfConstraints: 0
```

## Printing

Use `print` to print the formulation of the model.
```jldoctest utilities_print
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model)
MOI.VariableIndex(1)

julia> MOI.set(model, MOI.VariableName(), x, "x_var")

julia> MOI.add_constraint(model, x, MOI.ZeroOne())
MathOptInterface.ConstraintIndex{MathOptInterface.VariableIndex, MathOptInterface.ZeroOne}(1)

julia> MOI.set(model, MOI.ObjectiveFunction{typeof(x)}(), x)

julia> MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)

julia> print(model)
Maximize VariableIndex:
 x_var

Subject to:

VariableIndex-in-ZeroOne
 x_var ∈ {0, 1}
```

Use [`Utilities.latex_formulation`](@ref) to display the model in LaTeX form:
```jldoctest utilities_print
julia> MOI.Utilities.latex_formulation(model)
$$ \begin{aligned}
\max\quad & x\_var \\
\text{Subject to}\\
 & \text{VariableIndex-in-ZeroOne} \\
 & x\_var \in \{0, 1\} \\
\end{aligned} $$
```

!!! tip
    In IJulia, calling `print` or ending a cell with
    [`Utilities.latex_formulation`](@ref) will render the model in LaTeX.

## Utilities.PenaltyRelaxation

Pass [`Utilities.PenaltyRelaxation`](@ref) to [`modify`](@ref) to relax the
problem by adding penalized slack variables to the constraints. This is helpful
when debugging sources of infeasible models.

```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> MOI.set(model, MOI.VariableName(), x, "x")

julia> c = MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0));

julia> map = MOI.modify(model, MOI.Utilities.PenaltyRelaxation(Dict(c => 2.0)));

julia> print(model)
Minimize ScalarAffineFunction{Float64}:
 0.0 + 2.0 v[2]

Subject to:

ScalarAffineFunction{Float64}-in-LessThan{Float64}
 0.0 + 1.0 x - 1.0 v[2] <= 2.0

VariableIndex-in-GreaterThan{Float64}
 v[2] >= 0.0

julia> map[c]
0.0 + 1.0 MOI.VariableIndex(2)
```

You can also modify a single constraint using [`Utilities.ScalarPenaltyRelaxation`](@ref):
```jldoctest
julia> model = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(model);

julia> MOI.set(model, MOI.VariableName(), x, "x")

julia> c = MOI.add_constraint(model, 1.0 * x, MOI.LessThan(2.0));

julia> f = MOI.modify(model, c, MOI.Utilities.ScalarPenaltyRelaxation(2.0));

julia> print(model)
Minimize ScalarAffineFunction{Float64}:
 0.0 + 2.0 v[2]

Subject to:

ScalarAffineFunction{Float64}-in-LessThan{Float64}
 0.0 + 1.0 x - 1.0 v[2] <= 2.0

VariableIndex-in-GreaterThan{Float64}
 v[2] >= 0.0

julia> f
0.0 + 1.0 MOI.VariableIndex(2)
```

## Utilities.MatrixOfConstraints

The constraints of [`Utilities.Model`](@ref) are stored as a vector of tuples
of function and set in a [`Utilities.VectorOfConstraints`](@ref).

Other representations can be used by parameterizing the type
[`Utilities.GenericModel`](@ref) (resp. [`Utilities.GenericOptimizer`](@ref)).

For example, if all non-`VariableIndex` constraints are affine, the coefficients
of all the constraints can be stored in a single sparse matrix using
[`Utilities.MatrixOfConstraints`](@ref).

The constraints storage can even be customized up to a point where it exactly
matches the storage of the solver of interest, in which case [`copy_to`](@ref)
can be implemented for the solver by calling [`copy_to`](@ref) to this custom
model.

For example, [Clp.jl](https://github.com/jump-dev/Clp.jl) defines the following
model:
```jldoctest matrixofconstraints
julia> MOI.Utilities.@product_of_sets(
           SupportedSets,
           MOI.EqualTo{T},
           MOI.LessThan{T},
           MOI.GreaterThan{T},
           MOI.Interval{T},
       );

julia> const OptimizerCache = MOI.Utilities.GenericModel{
           Float64,
           MOI.Utilities.ObjectiveContainer{Float64},
           MOI.Utilities.VariablesContainer{Float64},
           MOI.Utilities.MatrixOfConstraints{
               Float64,
               MOI.Utilities.MutableSparseMatrixCSC{
                   # The data type of the coefficients
                   Float64,
                   # The data type of the variable indices
                   Cint,
                   # Can also be MOI.Utilities.OneBasedIndexing
                   MOI.Utilities.ZeroBasedIndexing,
               },
               MOI.Utilities.Hyperrectangle{Float64},
               SupportedSets{Float64},
           },
       };
```
Given the input model:
```jldoctest matrixofconstraints
julia> src = MOI.Utilities.Model{Float64}();

julia> MOI.Utilities.loadfromstring!(
           src,
           """
           variables: x, y, z
           maxobjective: x + 2.0 * y + -3.1 * z
           x + y <= 1.0
           2.0 * y >= 3.0
           -4.0 * x + z == 5.0
           x in Interval(0.0, 1.0)
           y <= 10.0
           z == 5.0
           """,
       )
```

We can construct a new cached model and copy `src` to it:
```jldoctest matrixofconstraints
julia> dest = OptimizerCache();

julia> index_map = MOI.copy_to(dest, src);
```

From `dest`, we can access the `A` matrix in sparse matrix form:
```jldoctest matrixofconstraints
julia> A = dest.constraints.coefficients;

julia> A.n
3

julia> A.m
3

julia> A.colptr
4-element Vector{Int32}:
 0
 2
 4
 5

julia> A.rowval
5-element Vector{Int32}:
 0
 1
 1
 2
 0

julia> A.nzval
5-element Vector{Float64}:
 -4.0
  1.0
  1.0
  2.0
  1.0
```
The lower and upper row bounds:
```jldoctest matrixofconstraints
julia> row_bounds = dest.constraints.constants;

julia> row_bounds.lower
3-element Vector{Float64}:
   5.0
 -Inf
   3.0

julia> row_bounds.upper
3-element Vector{Float64}:
  5.0
  1.0
 Inf
```
The lower and upper variable bounds:
```jldoctest matrixofconstraints
julia> dest.variables.lower
3-element Vector{Float64}:
   0.0
 -Inf
   5.0

julia> dest.variables.upper
3-element Vector{Float64}:
  1.0
 10.0
  5.0
```
Because of larger variations between solvers, the objective can be queried using
the standard MOI methods:
```jldoctest matrixofconstraints
julia> MOI.get(dest, MOI.ObjectiveSense())
MAX_SENSE::OptimizationSense = 1

julia> F = MOI.get(dest, MOI.ObjectiveFunctionType())
MathOptInterface.ScalarAffineFunction{Float64}

julia> F = MOI.get(dest, MOI.ObjectiveFunction{F}())
0.0 + 1.0 MOI.VariableIndex(1) + 2.0 MOI.VariableIndex(2) - 3.1 MOI.VariableIndex(3)
```

Thus, Clp.jl implements [`copy_to`](@ref) methods similar to the following:
```julia
# This method copies from the cache to the `Clp.Optimizer` object.
function MOI.copy_to(dest::Optimizer, src::OptimizerCache)
    @assert MOI.is_empty(dest)
    A = src.constraints.coefficients
    row_bounds = src.constraints.constants
    Clp_loadProblem(
        dest,
        A.n,
        A.m,
        A.colptr,
        A.rowval,
        A.nzval,
        src.lower_bound,
        src.upper_bound,
        # (...) objective vector (omitted),
        row_bounds.lower,
        row_bounds.upper,
    )
    return MOI.Utilities.identity_index_map(src)
end

# This method copies from an arbitrary model to the optimizer, by the
# intermediate `OptimizerCache` representation.
function MOI.copy_to(dest::Optimizer, src::MOI.ModelLike)
    cache = OptimizerCache()
    index_map = MOI.copy_to(cache, src)
    MOI.copy_to(dest, cache)
    return index_map
end

# This is a special method that gets called in some cases when `OptimizerCache`
# is used as the backing data structure in a `MOI.Utilities.CachingOptimizer`.
# It is needed for performance, but not correctness.
function MOI.copy_to(
    dest::Optimizer,
    src::MOI.Utilities.UniversalFallback{OptimizerCache},
)
    MOI.Utilities.throw_unsupported(src)
    return MOI.copy_to(dest, src.model)
end
```

!!! tip
    For other examples of [`Utilities.MatrixOfConstraints`](@ref), see:
     * [Cbc.jl](https://github.com/jump-dev/Cbc.jl)
     * [ECOS.jl](https://github.com/jump-dev/ECOS.jl)
     * [SCS.jl](https://github.com/jump-dev/SCS.jl)

## ModelFilter

Utilities provides [`Utilities.ModelFilter`](@ref) as a useful tool to copy a
subset of a model. For example, given an infeasible model, we can copy the
irreducible infeasible subsystem (for models implementing
[`ConstraintConflictStatus`](@ref)) as follows:
```julia
my_filter(::Any) = true
function my_filter(ci::MOI.ConstraintIndex)
    status = MOI.get(dest, MOI.ConstraintConflictStatus(), ci)
    return status != MOI.NOT_IN_CONFLICT
end
filtered_src = MOI.Utilities.ModelFilter(my_filter, src)
index_map = MOI.copy_to(dest, filtered_src)
```

## Fallbacks

The value of some attributes can be inferred from the value of other
attributes.

For example, the value of [`ObjectiveValue`](@ref) can be computed using
[`ObjectiveFunction`](@ref) and [`VariablePrimal`](@ref).

When a solver gives direct access to an attribute, it is better to return this
value. However, if this is not the case, [`Utilities.get_fallback`](@ref) can be
used instead. For example:
```julia
function MOI.get(model::Optimizer, attr::MOI.ObjectiveFunction)
    return MOI.Utilities.get_fallback(model, attr)
end
```

## DoubleDicts

When writing MOI interfaces, we often need to handle situations in which we map
[`ConstraintIndex`](@ref)s to different values. For example, to a string
for [`ConstraintName`](@ref).

One option is to use a dictionary like `Dict{MOI.ConstraintIndex,String}`.
However, this incurs a performance cost because the key is not a concrete type.

The DoubleDicts submodule helps this situation by providing two types main
types [`Utilities.DoubleDicts.DoubleDict`](@ref) and
[`Utilities.DoubleDicts.IndexDoubleDict`](@ref). These types act like normal
dictionaries, but internally they use more efficient dictionaries specialized to
the type of the function-set pair.

The most common usage of a `DoubleDict` is in the `index_map` returned by
[`copy_to`](@ref). Performance can be improved, by using a function barrier.
That is, instead of code like:
```julia
index_map = MOI.copy_to(dest, src)
for (F, S) in MOI.get(src, MOI.ListOfConstraintTypesPresent())
    for ci in MOI.get(src, MOI.ListOfConstraintIndices{F,S}())
        dest_ci = index_map[ci]
        # ...
    end
end
```
use instead:
```julia
function function_barrier(
    dest,
    src,
    index_map::MOI.Utilities.DoubleDicts.IndexDoubleDictInner{F,S},
) where {F,S}
    for ci in MOI.get(src, MOI.ListOfConstraintIndices{F,S}())
        dest_ci = index_map[ci]
        # ...
    end
    return
end

index_map = MOI.copy_to(dest, src)
for (F, S) in MOI.get(src, MOI.ListOfConstraintTypesPresent())
    function_barrier(dest, src, index_map[F, S])
end
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# [The Test submodule](@id test_module)

The `Test` submodule provides tools to help solvers implement unit tests in
order to ensure they implement the MathOptInterface API correctly, and to check
for solver-correctness.

We use a centralized repository of tests, so that if we find a bug in one
solver, instead of adding a test to that particular repository, we add it here
so that all solvers can benefit.

## How to test a solver

The skeleton below can be used for the wrapper test file of a solver named
`FooBar`.

```julia
# ============================ /test/MOI_wrapper.jl ============================
module TestFooBar

import FooBar
using Test

import MathOptInterface as MOI

const OPTIMIZER = MOI.instantiate(
    MOI.OptimizerWithAttributes(FooBar.Optimizer, MOI.Silent() => true),
)

const BRIDGED = MOI.instantiate(
    MOI.OptimizerWithAttributes(FooBar.Optimizer, MOI.Silent() => true),
    with_bridge_type = Float64,
)

# See the docstring of MOI.Test.Config for other arguments.
const CONFIG = MOI.Test.Config(
    # Modify tolerances as necessary.
    atol = 1e-6,
    rtol = 1e-6,
    # Use MOI.LOCALLY_SOLVED for local solvers.
    optimal_status = MOI.OPTIMAL,
    # Pass attributes or MOI functions to `exclude` to skip tests that
    # rely on this functionality.
    exclude = Any[MOI.VariableName, MOI.delete],
)

"""
    runtests()

This function runs all functions in the this Module starting with `test_`.
"""
function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
end

"""
    test_runtests()

This function runs all the tests in MathOptInterface.Test.

Pass arguments to `exclude` to skip tests for functionality that is not
implemented or that your solver doesn't support.
"""
function test_runtests()
    MOI.Test.runtests(
        BRIDGED,
        CONFIG,
        exclude = [
            "test_attribute_NumberOfThreads",
            "test_quadratic_",
        ],
        # This argument is useful to prevent tests from failing on future
        # releases of MOI that add new tests. Don't let this number get too far
        # behind the current MOI release though. You should periodically check
        # for new tests to fix bugs and implement new features.
        exclude_tests_after = v"0.10.5",
    )
    return
end

"""
    test_SolverName()

You can also write new tests for solver-specific functionality. Write each new
test as a function with a name beginning with `test_`.
"""
function test_SolverName()
    @test MOI.get(FooBar.Optimizer(), MOI.SolverName()) == "FooBar"
    return
end

end # module TestFooBar

# This line at tne end of the file runs all the tests!
TestFooBar.runtests()
```

Then modify your `runtests.jl` file to include the `MOI_wrapper.jl` file:
```julia
# ============================ /test/runtests.jl ============================

using Test

@testset "MOI" begin
    include("test/MOI_wrapper.jl")
end
```

!!! info
    The optimizer `BRIDGED` constructed with [`instantiate`](@ref)
    automatically bridges constraints that are not supported by `OPTIMIZER`
    using the bridges listed in [Bridges](@ref). It is recommended for an
    implementation of MOI to only support constraints that are natively
    supported by the solver and let bridges transform the constraint to the
    appropriate form. For this reason it is expected that tests may not pass if
    `OPTIMIZER` is used instead of `BRIDGED`.

## How to debug a failing test

When writing a solver, it's likely that you will initially fail many tests.
Some failures will be bugs, but other failures you may choose to exclude.

There are two ways to exclude tests:

 - Exclude tests whose names contain a string using:
   ```julia
   MOI.Test.runtests(
       model,
       config;
       exclude = String["test_to_exclude", "test_conic_"],
   )
   ```
   This will exclude tests whose name contains either of the two strings
   provided.

 - Exclude tests which rely on specific functionality using:
   ```julia
   MOI.Test.Config(exclude = Any[MOI.VariableName, MOI.optimize!])
   ```
   This will exclude tests which use the `MOI.VariableName` attribute,
   or which call `MOI.optimize!`.

Each test that fails can be independently called as:
```julia
model = FooBar.Optimizer()
config = MOI.Test.Config()
MOI.empty!(model)
MOI.Test.test_category_name_that_failed(model, config)
```

You can look-up the source code of the test that failed by searching for it
in the `src/Test/test_category.jl` file.

!!! tip
    Each test function also has a docstring that explains what the test is
    for. Use `? MOI.Test.test_category_name_that_failed` from the REPL to
    read it.

Periodically, you should re-run excluded tests to see if they now pass. The
easiest way to do this is to swap the `exclude` keyword argument of `runtests`
to `include`. For example:
```julia
MOI.Test.runtests(
    model,
    config;
    exclude = String["test_to_exclude", "test_conic_"],
)
```
becomes
```julia
MOI.Test.runtests(
    model,
    config;
    include = String["test_to_exclude", "test_conic_"],
)
```

## How to add a test

To detect bugs in solvers, we add new tests to `MOI.Test`.

As an example, ECOS errored calling [`optimize!`](@ref) twice in a row. (See
[ECOS.jl PR #72](https://github.com/jump-dev/ECOS.jl/pull/72).) We could add a
test to ECOS.jl, but that would only stop us from re-introducing the bug to
ECOS.jl in the future, but it would not catch other solvers in the ecosystem
with the same bug. Instead, if we add a test to `MOI.Test`, then all solvers
will also check that they handle a double optimize call.

For this test, we care about correctness, rather than performance. therefore, we
don't expect solvers to efficiently decide that they have already solved the
problem, only that calling [`optimize!`](@ref) twice doesn't throw an error or
give the wrong answer.

**Step 1**

Install the `MathOptInterface` julia package in [`dev` mode](https://pkgdocs.julialang.org/v1/managing-packages/#developing-1):
```julia
julia> ]
(@v1.6) pkg> dev MathOptInterface
```

**Step 2**

From here on, proceed with making the following changes in the
`~/.julia/dev/MathOptInterface` folder (or equivalent `dev` path on your
machine).

**Step 3**

Since the double-optimize error involves solving an optimization problem,
add a new test to [src/Test/test_solve.jl](https://github.com/jump-dev/MathOptInterface.jl/blob/master/src/Test/test_solve.jl):
```julia
"""
    test_unit_optimize!_twice(model::MOI.ModelLike, config::Config)

Test that calling `MOI.optimize!` twice does not error.

This problem was first detected in ECOS.jl PR#72:
https://github.com/jump-dev/ECOS.jl/pull/72
"""
function test_unit_optimize!_twice(
    model::MOI.ModelLike,
    config::Config{T},
) where {T}
    # Use the `@requires` macro to check conditions that the test function
    # requires to run. Models failing this `@requires` check will silently skip
    # the test.
    @requires MOI.supports_constraint(
        model,
        MOI.VariableIndex,
        MOI.GreaterThan{Float64},
    )
    @requires _supports(config, MOI.optimize!)
    # If needed, you can test that the model is empty at the start of the test.
    # You can assume that this will be the case for tests run via `runtests`.
    # User's calling tests individually need to call `MOI.empty!` themselves.
    @test MOI.is_empty(model)
    # Create a simple model. Try to make this as simple as possible so that the
    # majority of solvers can run the test.
    x = MOI.add_variable(model)
    MOI.add_constraint(model, x, MOI.GreaterThan(one(T)))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(
        model,
        MOI.ObjectiveFunction{MOI.VariableIndex}(),
        x,
    )
    # The main component of the test: does calling `optimize!` twice error?
    MOI.optimize!(model)
    MOI.optimize!(model)
    # Check we have a solution.
    @test MOI.get(model, MOI.TerminationStatus()) == MOI.OPTIMAL
    # There is a three-argument version of `Base.isapprox` for checking
    # approximate equality based on the tolerances defined in `config`:
    @test isapprox(MOI.get(model, MOI.VariablePrimal(), x), one(T), config)
    # For code-style, these tests should always `return` `nothing`.
    return
end
```

!!! info
    Make sure the function is agnostic to the number type `T`; don't assume it
    is a `Float64` capable solver.

We also need to write a test for the test. Place this function immediately below
the test you just wrote in the same file:
```julia
function setup_test(
    ::typeof(test_unit_optimize!_twice),
    model::MOI.Utilities.MockOptimizer,
    ::Config,
)
    MOI.Utilities.set_mock_optimize!(
        model,
        (mock::MOI.Utilities.MockOptimizer) -> MOIU.mock_optimize!(
            mock,
            MOI.OPTIMAL,
            (MOI.FEASIBLE_POINT, [1.0]),
        ),
    )
    return
end
```

Finally, you also need to implement [`Test.version_added`](@ref). If we added
this test when the latest released version of MOI was `v0.10.5`, define:
```julia
version_added(::typeof(test_unit_optimize!_twice)) = v"0.10.6"
```

**Step 6**

Commit the changes to git from `~/.julia/dev/MathOptInterface` and
submit the PR for review.

!!! tip
    If you need help writing a test, [open an issue on GitHub](https://github.com/jump-dev/MathOptInterface.jl/issues/new),
    or ask the [Developer Chatroom](https://jump.dev/chatroom/).

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# The FileFormats submodule

The `FileFormats` module provides functions for reading and writing MOI
models using [`write_to_file`](@ref) and [`read_from_file`](@ref).

## Supported file types

You must read and write files to a [`FileFormats.Model`](@ref) object. Specific
the file-type by passing a [`FileFormats.FileFormat`](@ref) enum. For example:

### The Conic Benchmark Format

```jldoctest
julia> model = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_CBF)
MOI.FileFormats.CBF.Model
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

### The LP file format

```jldoctest
julia> model = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_LP)
MOI.FileFormats.LP.Model
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

### The MathOptFormat file format

```jldoctest
julia> model = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_MOF)
MOI.FileFormats.MOF.Model
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

### The MPS file format

```jldoctest
julia> model = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_MPS)
MOI.FileFormats.MPS.Model
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

### The NL file format

```jldoctest
julia> model = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_NL)
MOI.FileFormats.NL.Model
├ ObjectiveSense: unknown
├ ObjectiveFunctionType: unknown
├ NumberOfVariables: unknown
└ NumberOfConstraints: unknown
```

### The REW file format

```jldoctest
julia> model = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_REW)
MOI.FileFormats.MPS.Model
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

Note that the REW format is identical to the MPS file format, except that all
names are replaced with generic identifiers.

### The SDPA file format

```jldoctest
julia> model = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_SDPA)
MOI.FileFormats.SDPA.Model
├ ObjectiveSense: FEASIBILITY_SENSE
├ ObjectiveFunctionType: MOI.ScalarAffineFunction{Float64}
├ NumberOfVariables: 0
└ NumberOfConstraints: 0
```

## Write to file

To write a model `src` to a [MathOptFormat file](https://jump.dev/MathOptFormat/),
use:
```jldoctest fileformats
julia> src = MOI.Utilities.Model{Float64}();

julia> MOI.add_variable(src);

julia> dest = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_MOF);

julia> MOI.copy_to(dest, src)
MathOptInterface.Utilities.IndexMap with 1 entry:
  MOI.VariableIndex(1) => MOI.VariableIndex(1)

julia> MOI.write_to_file(dest, "file.mof.json")

julia> print(read("file.mof.json", String))
{"name":"MathOptFormat Model","version":{"major":1,"minor":7},"variables":[{"name":"x1"}],"objective":{"sense":"feasibility"},"constraints":[]}
```

## Read from file

To read a MathOptFormat file, use:
```jldoctest fileformats
julia> dest = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_MOF);

julia> MOI.read_from_file(dest, "file.mof.json")

julia> MOI.get(dest, MOI.ListOfVariableIndices())
1-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)

julia> rm("file.mof.json")  # Clean up after ourselves.
```

## Detecting the file-type automatically

Instead of the `format` keyword, you can also use the `filename` keyword
argument to [`FileFormats.Model`](@ref). This will attempt to automatically
guess the format from the file extension. For example:

```jldoctest fileformats
julia> src = MOI.Utilities.Model{Float64}();

julia> dest = MOI.FileFormats.Model(filename = "file.cbf.gz");

julia> MOI.copy_to(dest, src)
MathOptInterface.Utilities.IndexMap()

julia> MOI.write_to_file(dest, "file.cbf.gz")

julia> src_2 = MOI.FileFormats.Model(filename = "file.cbf.gz");

julia> MOI.read_from_file(src_2, "file.cbf.gz")

julia> rm("file.cbf.gz")  # Clean up after ourselves.
```
Note how the compression format (GZip) is also automatically detected from the
filename.

## Unsupported constraints

In some cases `src` may contain constraints that are not supported by the file
format (for example, the CBF format supports integer variables but not binary).
If so, copy `src` to a bridged model using [`Bridges.full_bridge_optimizer`](@ref):
```jldoctest
julia> src = MOI.Utilities.Model{Float64}();

julia> x = MOI.add_variable(src);

julia> MOI.add_constraint(src, x, MOI.ZeroOne());

julia> dest = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_CBF);

julia> bridged = MOI.Bridges.full_bridge_optimizer(dest, Float64);

julia> MOI.copy_to(bridged, src);

julia> MOI.write_to_file(dest, "my_model.cbf")

julia> rm("my_model.cbf")  # Clean up after ourselves.
```
!!! note
    Even after bridging, it may still not be possible to write the model to file
    because of unsupported constraints (for example, PSD variables in the LP
    file format).

## Read and write to `io`

In addition to [`write_to_file`](@ref) and [`read_from_file`](@ref), you can
read and write directly from `IO` streams using `Base.write` and `Base.read!`:
```jldoctest
julia> src = MOI.Utilities.Model{Float64}();

julia> dest = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_MPS);

julia> MOI.copy_to(dest, src)
MathOptInterface.Utilities.IndexMap()

julia> io = IOBuffer();

julia> write(io, dest)

julia> seekstart(io);

julia> src_2 = MOI.FileFormats.Model(format = MOI.FileFormats.FORMAT_MPS);

julia> read!(io, src_2);
```

## ScalarNonlinearFunction

By default, reading a `.nl` or `.mof.json` that contains nonlinear expressions
will create an [`NLPBlock`](@ref).

To instead read nonlinear expressions as [`ScalarNonlinearFunction`](@ref),
pass the `use_nlp_block = false` keyword argument to the `Model` constructor:

```jldoctest
julia> model = MOI.FileFormats.Model(;
           format = MOI.FileFormats.FORMAT_MOF,
           use_nlp_block = false,
       );

julia> model = MOI.FileFormats.Model(;
           format = MOI.FileFormats.FORMAT_NL,
           use_nlp_block = false,
       );
```

## Validating MOF files

MathOptFormat files are governed by a schema. Use [JSONSchema.jl](https://github.com/fredo-dedup/JSONSchema.jl)
to check if a `.mof.json` file satisfies the schema.

First, construct the schema object as follows:
```jldoctest schema_mof
julia> import JSON, JSONSchema

julia> schema = JSONSchema.Schema(JSON.parsefile(MOI.FileFormats.MOF.SCHEMA_PATH))
A JSONSchema
```

Then, check if a model file is valid using `isvalid`:
```jldoctest schema_mof
julia> good_model = JSON.parse("""
       {
         "version": {
           "major": 1,
           "minor": 5
         },
         "variables": [{"name": "x"}],
         "objective": {"sense": "feasibility"},
         "constraints": []
       }
       """);

julia> isvalid(schema, good_model)
true
```

If we construct an invalid file, for example by mis-typing `name` as `NaMe`, the
validation fails:
```jldoctest schema_mof
julia> bad_model = JSON.parse("""
       {
         "version": {
           "major": 1,
           "minor": 5
         },
         "variables": [{"NaMe": "x"}],
         "objective": {"sense": "feasibility"},
         "constraints": []
       }
       """);

julia> isvalid(schema, bad_model)
false
```

Use `JSONSchema.validate` to obtain more insight into why the validation failed:
```jldoctest schema_mof
julia> JSONSchema.validate(schema, bad_model)
Validation failed:
path:         [variables][1]
instance:     JSON.Object{String, Any}("NaMe" => "x")
schema key:   required
schema value: Any["name"]
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

## [Utilities.Model](@id reference_utilities_model)

```@docs
Utilities.Model
```

## [Utilities.UniversalFallback](@id reference_utilities_universal_fallback)

```@docs
Utilities.UniversalFallback
```

## [Utilities.@model](@id reference_model_macro)

```@docs
Utilities.@model
Utilities.GenericModel
Utilities.GenericOptimizer
```

### `.objective`

```@docs
Utilities.ObjectiveContainer
```

### `.variables`

```@docs
Utilities.VariablesContainer
Utilities.FreeVariables
```

### `.constraints`

```@docs
Utilities.VectorOfConstraints
Utilities.StructOfConstraints
Utilities.@struct_of_constraints_by_function_types
Utilities.@struct_of_constraints_by_set_types
Utilities.struct_of_constraint_code
```

## Caching optimizer

```@docs
Utilities.CachingOptimizer
Utilities.CachingOptimizerState
Utilities.NO_OPTIMIZER
Utilities.EMPTY_OPTIMIZER
Utilities.ATTACHED_OPTIMIZER
Utilities.state
Utilities.CachingOptimizerMode
Utilities.AUTOMATIC
Utilities.MANUAL
Utilities.mode
Utilities.attach_optimizer
Utilities.reset_optimizer
Utilities.drop_optimizer
```

## Mock optimizer

```@docs
Utilities.MockOptimizer
```

## Printing

```@docs
Utilities.latex_formulation
```

## Copy utilities

```@docs
Utilities.default_copy_to
Utilities.IndexMap
Utilities.identity_index_map
Utilities.ModelFilter
Utilities.loadfromstring!
```

## Penalty relaxation

```@docs
Utilities.PenaltyRelaxation
Utilities.ScalarPenaltyRelaxation
```

## MatrixOfConstraints

```@docs
Utilities.MatrixOfConstraints
```

### `.coefficients`

```@docs
Utilities.add_column
Utilities.allocate_terms
Utilities.set_number_of_rows
Utilities.load_terms
Utilities.final_touch
Utilities.extract_function
```

```@docs
Utilities.MutableSparseMatrixCSC
Utilities.AbstractIndexing
Utilities.ZeroBasedIndexing
Utilities.OneBasedIndexing
```

### `.constants`

```@docs
Utilities.load_constants
Utilities.function_constants
Utilities.set_from_constants
Utilities.modify_constants
```

```@docs
Utilities.Hyperrectangle
```

### `.sets`

```@docs
Utilities.set_index
Utilities.set_types
Utilities.add_set
Utilities.rows
Utilities.num_rows
Utilities.set_with_dimension
```

```@docs
Utilities.ProductOfSets
Utilities.MixOfScalarSets
Utilities.@mix_of_scalar_sets
Utilities.OrderedProductOfSets
Utilities.@product_of_sets
```

## Fallbacks

```@docs
Utilities.get_fallback
```

## Function utilities

The following utilities are available for functions:

```@docs
Utilities.eval_variables
Utilities.map_indices
Utilities.substitute_variables
Utilities.filter_variables
Utilities.remove_variable
Utilities.all_coefficients
Utilities.unsafe_add
Utilities.isapprox_zero
Utilities.modify_function
Utilities.zero_with_output_dimension
```

The following functions can be used to canonicalize a function:

```@docs
Utilities.is_canonical
Utilities.canonical
Utilities.canonicalize!
```

The following functions can be used to manipulate functions with basic algebra:

```@docs
Utilities.scalar_type
Utilities.scalarize
Utilities.eachscalar
Utilities.promote_operation
Utilities.operate
Utilities.operate!
Utilities.operate_output_index!
Utilities.vectorize
```

## Constraint utilities

The following utilities are available for moving the function constant to the
set for scalar constraints:

```@docs
Utilities.shift_constant
Utilities.supports_shift_constant
Utilities.normalize_and_add_constraint
Utilities.normalize_constant
```

The following utility identifies those constraints imposing bounds on a given
variable, and returns those bound values:
```@docs
Utilities.get_bounds
```

The following utilities are useful when working with symmetric matrix cones.
```@docs
Utilities.is_diagonal_vectorized_index
Utilities.side_dimension_for_vectorized_dimension
```

## Set utilities

The following utilities are available for sets:

```@docs
Utilities.AbstractDistance
Utilities.ProjectionUpperBoundDistance
Utilities.distance_to_set
Utilities.set_dot
```

## DoubleDicts

```@docs
Utilities.DoubleDicts.DoubleDict
Utilities.DoubleDicts.DoubleDictInner
Utilities.DoubleDicts.IndexDoubleDict
Utilities.DoubleDicts.IndexDoubleDictInner
Utilities.DoubleDicts.outer_keys
Utilities.DoubleDicts.nonempty_outer_keys
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

## File Formats

Functions to help read and write MOI models to/from various file formats. See
[The FileFormats submodule](@ref) for more details.

```@docs
FileFormats.Model
FileFormats.FileFormat
FileFormats.FORMAT_AUTOMATIC
FileFormats.FORMAT_CBF
FileFormats.CBF.Model
FileFormats.FORMAT_LP
FileFormats.LP.Model
FileFormats.FORMAT_MOF
FileFormats.MOF.Model
FileFormats.FORMAT_MPS
FileFormats.MPS.Model
FileFormats.FORMAT_NL
FileFormats.NL.Model
FileFormats.FORMAT_REW
FileFormats.FORMAT_SDPA
FileFormats.SDPA.Model
```

## Other helpers

```@docs
FileFormats.NL.SolFileResults
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# [The Test submodule](@id test_reference)

Functions to help test implementations of MOI. See
[The Test submodule](@ref test_module) for more details.

```@docs
Test.Config
Test.runtests
Test.setup_test
Test.version_added
Test.@requires
Test.RequirementUnmet
Test.HS071
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# List of bridges

This section describes the [`Bridges.AbstractBridge`](@ref)s that are
implemented in MathOptInterface.

## [Constraint bridges](@id constraint_bridges_ref)

These bridges are subtypes of [`Bridges.Constraint.AbstractBridge`](@ref).

```@autodocs
Modules = [Bridges.Constraint]
Filter = t -> begin
    M = MathOptInterface.Bridges.Constraint
    return t isa Type && t != M.AbstractBridge && t <: M.AbstractBridge
end
```

## [Objective bridges](@id objective_bridges_ref)

These bridges are subtypes of [`Bridges.Objective.AbstractBridge`](@ref).

```@autodocs
Modules = [Bridges.Objective]
Filter = t -> begin
    M = MathOptInterface.Bridges.Objective
    return t isa Type && t != M.AbstractBridge && t <: M.AbstractBridge
end
```

## [Variable bridges](@id variable_bridges_ref)

These bridges are subtypes of [`Bridges.Variable.AbstractBridge`](@ref).

```@autodocs
Modules = [Bridges.Variable]
Filter = t -> begin
    M = MathOptInterface.Bridges.Variable
    return t isa Type && t != M.AbstractBridge && t <: M.AbstractBridge
end
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# [Nonlinear Modeling](@id NonlinearAPI)

More information can be found in the [Nonlinear](@ref nonlinear_developers)
section of the manual.

```@docs
Nonlinear.Model
```

## [Expressions](@id nonlinear_api_expressions)

```@docs
Nonlinear.ExpressionIndex
Nonlinear.add_expression
```

## [Parameters](@id nonlinear_api_parameters)

```@docs
Nonlinear.ParameterIndex
Nonlinear.add_parameter
```

## [Objectives](@id nonlinear_api_objectives)

```@docs
Nonlinear.set_objective
```

## [Constraints](@id nonlinear_api_constraints)

```@docs
Nonlinear.ConstraintIndex
Nonlinear.add_constraint
Nonlinear.delete
```

## [User-defined operators](@id nonlinear_api_operators)

```@docs
Nonlinear.OperatorRegistry
Nonlinear.DEFAULT_UNIVARIATE_OPERATORS
Nonlinear.DEFAULT_MULTIVARIATE_OPERATORS
Nonlinear.register_operator
Nonlinear.register_operator_if_needed
Nonlinear.assert_registered
Nonlinear.check_return_type
Nonlinear.eval_univariate_function
Nonlinear.eval_univariate_gradient
Nonlinear.eval_univariate_function_and_gradient
Nonlinear.eval_univariate_hessian
Nonlinear.eval_multivariate_function
Nonlinear.eval_multivariate_gradient
Nonlinear.eval_multivariate_hessian
Nonlinear.eval_logic_function
Nonlinear.eval_comparison_function
```

## Automatic-differentiation backends

```@docs
Nonlinear.Evaluator
Nonlinear.AbstractAutomaticDifferentiation
Nonlinear.ExprGraphOnly
Nonlinear.SparseReverseMode
Nonlinear.SymbolicMode
```

## Data-structure

```@docs
Nonlinear.Node
Nonlinear.NodeType
Nonlinear.Expression
Nonlinear.Constraint
Nonlinear.adjacency_matrix
Nonlinear.parse_expression
Nonlinear.convert_to_expr
Nonlinear.ordinal_index
```

## SymbolicAD

```@docs
Nonlinear.SymbolicAD.simplify
Nonlinear.SymbolicAD.simplify!
Nonlinear.SymbolicAD.variables
Nonlinear.SymbolicAD.derivative
Nonlinear.SymbolicAD.gradient_and_hessian
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# The `Benchmarks` submodule

To aid the development of efficient solver wrappers, MathOptInterface provides
a suite of benchmarks in the `MOI.Benchmarks` submodule.

!!! warning
    To use this submodule you must first install and load
    [BenchmarkTools.jl](https://github.com/juliaci/benchmarktools.jl).
    ```julia
    import Pkg
    Pkg.add("BenchmarkTools")
    import BenchmarkTools
    ```

## Benchmarking a solver wrapper

Benchmarking a wrapper follows a two-step process.

First, prior to making changes, create a baseline for the benchmark results on a
given benchmark suite as follows:

```julia
# You must load BenchmarkTools.jl to enable MOI.Benchmarks
import BenchmarkTools
# Replace `SolverPackage` with your choice of solver
using SolverPackage
import MathOptInterface as MOI

suite = MOI.Benchmarks.suite() do
    SolverPackage.Optimizer()
end

MOI.Benchmarks.create_baseline(
    suite, "current"; directory = "/tmp", verbose = true
)
```
Use the `exclude` argument to [`Benchmarks.suite`](@ref) to
exclude benchmarks that the solver doesn't support.

Second, after making changes to the package, re-run the benchmark suite and
compare to the prior saved results:

```julia
import BenchmarkTools
using SolverPackage
import MathOptInterface as MOI

suite = MOI.Benchmarks.suite() do
    SolverPackage.Optimizer()
end

MOI.Benchmarks.compare_against_baseline(
    suite, "current"; directory = "/tmp", verbose = true
)
```

This comparison will create a report detailing improvements and regressions.

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# SymbolicAD

The `Nonlinear.SymbolicAD` submodule contains data structures and functions for
working with the symbolic derivatives of a nonlinear optimization problem. This
page explains the API and describes the rationale behind its design.

## Background

The code in `SymbolicAD` is inspired by Hassan Hijazi's work on
[coin-or/gravity](https://github.com/coin-or/Gravity), a high-performance
algebraic modeling language in C++.

Hassan made the following observations:

 * For large scale models, symbolic differentiation is slower than other
   automatic differentiation techniques, such as the reverse mode algorithm
   implemented in `MOI.Nonlinear.ReverseAD`.
 * However, most large-scale nonlinear programs have a lot of structure.
 * Gravity asks the user to provide structure in the form of
   _template constraints_, where the user gives the symbolic form of the
   constraint as well as a set of data to convert from a symbolic form to the
   numerical form.
 * Instead of differentiating each constraint in its numerical form, we can
   compute one symbolic derivative of the constraint in symbolic form, and then
   plug in the data in to get the numerical derivative of each function.
 * As a final step, if users don't provide the structure, we can still infer it
   --perhaps with less accuracy--by comparing the expression tree of each
   constraint.

The symbolic differentiation approach of Gravity works well when the problem is
large with few unique constraints. For example, a model like:
```julia
model = Model()
@variable(model, 0 <= x[1:10_000] <= 1)
@constraint(model, [i=1:10_000], sin(x[i]) <= 1)
@objective(model, Max, sum(x))
```
is ideal, because although the Jacobian matrix has 10,000 rows, we can compute
the derivative of `sin(x[i])` as `cos(x[i])`, and then fill in the Jacobian by
evaluating the derivative function instead of having to differentiation 10,000
expressions.

The symbolic differentiation approach of Gravity works poorly if there are a
large number of unique constraints in the model (which would require a lot of
expressions to be symbolically differentiated), or if the nonlinear functions
contain a large number of nonlinear terms (which would make the symbolic
derivative expensive to compute).

`SymbolicAD` started life as [MathOptSymbolicAD.jl](https://github.com/lanl-ansi/MathOptSymbolicAD.jl),
development of which began in early 2022. This initial version of `SymbolicAD`
used the `Symbolics.jl` package to compute the symbolic derivatives. In 2025, we
rewrote MathOptSymbolicAD.jl to remove the dependence on `Symbolics.jl`, and,
since the rewrite depended only on MathOptInterface, we added it to
`MOI.Nonlinear` as a new submodule.

For more details on `MathOptSymbolicAD.jl`, see Oscar's [JuMP-dev 2022 talk](https://www.youtube.com/watch?v=d_X3gj3Iz-k),
although note that the syntax has changed since the original recording.

## Use SymbolicAD with JuMP

To use `SymbolicAD` with JuMP, set the [`AutomaticDifferentiationBackend`](@ref)
attribute to [`Nonlinear.SymbolicMode`](@ref):

```julia
using JuMP, Ipopt
model = Model(Ipopt.Optimizer)
set_attribute(
    model,
    MOI.AutomaticDifferentiationBackend(),
    MOI.Nonlinear.SymbolicMode(),
)
@variable(model, x[1:2])
@objective(model, Min, (1 - x[1])^2 + 100 * (x[2] - x[1]^2)^2)
optimize!(model)
```

To revert back to the default sparse reverse mode algorithm, set the
[`AutomaticDifferentiationBackend`](@ref) attribute to
[`Nonlinear.SparseReverseMode`](@ref).

## `simplify`

Use [`Nonlinear.SymbolicAD.simplify`](@ref) to simplify nonlinear expressions.
The simplification algorithm performs simple rewrites such as lifting nested
summations:

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> f = MOI.ScalarNonlinearFunction(
           :+,
           Any[MOI.ScalarNonlinearFunction(:+, Any[1.0, x]), 2.0 * x + 3.0],
       )
+(+(1.0, MOI.VariableIndex(1)), 3.0 + 2.0 MOI.VariableIndex(1))

julia> MOI.Nonlinear.SymbolicAD.simplify(f)
4.0 + 3.0 MOI.VariableIndex(1)
```

and trivial identities such as ``x^1 = x``:

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> f = MOI.ScalarNonlinearFunction(:^, Any[x, 1])
^(MOI.VariableIndex(1), (1))

julia> MOI.Nonlinear.SymbolicAD.simplify(f)
MOI.VariableIndex(1)
```

The list of rewrites that will be made is intentionally limited to keep the
codebase simple. `Nonlinear.SymbolicAD` is not a substitute for a Computer
Algebraic System (CAS). For example, we do not detect the relationship
``sin(x)^2+cos(x)^2=1``:

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> sin_x = MOI.ScalarNonlinearFunction(:sin, Any[x])
sin(MOI.VariableIndex(1))

julia> cos_x = MOI.ScalarNonlinearFunction(:cos, Any[x])
cos(MOI.VariableIndex(1))

julia> f = MOI.ScalarNonlinearFunction(
           :+,
           Any[
               MOI.ScalarNonlinearFunction(:^, Any[sin_x, 2]),
               MOI.ScalarNonlinearFunction(:^, Any[cos_x, 2]),
           ],
       )
+(^(sin(MOI.VariableIndex(1)), (2)), ^(cos(MOI.VariableIndex(1)), (2)))

julia> MOI.Nonlinear.SymbolicAD.simplify(f)
+(^(sin(MOI.VariableIndex(1)), (2)), ^(cos(MOI.VariableIndex(1)), (2)))
```

In addition to [`Nonlinear.SymbolicAD.simplify`](@ref), there is an in-place
version [`Nonlinear.SymbolicAD.simplify!`](@ref) that may make changes to the
existing function.

## `variables`

Use [`Nonlinear.SymbolicAD.variables`](@ref) to return a sorted list of the
variables that appear in the function:

```jldoctest
julia> x = MOI.VariableIndex.(1:3)
3-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)
 MOI.VariableIndex(3)

julia> f = MOI.ScalarNonlinearFunction(:atan, Any[x[3], 2.0 * x[1]])
atan(MOI.VariableIndex(3), 0.0 + 2.0 MOI.VariableIndex(1))

julia> MOI.Nonlinear.SymbolicAD.variables(f)
2-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(3)
```

## `derivative`

Use [`Nonlinear.SymbolicAD.derivative`](@ref) to compute the symbolic derivative
of a function with respect to a decision variable:

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> f = MOI.ScalarNonlinearFunction(:sin, Any[x])
sin(MOI.VariableIndex(1))

julia> MOI.Nonlinear.SymbolicAD.derivative(f, x)
cos(MOI.VariableIndex(1))
```

Note that the resultant expression can often be simplified. Thus, in most cases
you should call [`Nonlinear.SymbolicAD.simplify`](@ref) on the expression before
using it in other places:

```jldoctest
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> f = MOI.ScalarNonlinearFunction(:sin, Any[x + 1.0])
sin(1.0 + 1.0 MOI.VariableIndex(1))

julia> df_dx = MOI.Nonlinear.SymbolicAD.derivative(f, x)
*(cos(1.0 + 1.0 MOI.VariableIndex(1)), 1.0)

julia> MOI.Nonlinear.SymbolicAD.simplify!(df_dx)
cos(1.0 + 1.0 MOI.VariableIndex(1))
```

## `gradient_and_hessian`

In some cases, you may want to compute the gradient and (sparse) Hessian matrix
of a function. One way to achieve this is by recursively calling
[`Nonlinear.SymbolicAD.derivative`](@ref) on the result of [`Nonlinear.SymbolicAD.derivative`](@ref)
for each variable in the list of [`Nonlinear.SymbolicAD.variables`](@ref). But,
to simplify the process, you should use [`Nonlinear.SymbolicAD.gradient_and_hessian`](@ref):

```jldoctest
julia> x = MOI.VariableIndex.(1:2);

julia> f = MOI.ScalarNonlinearFunction(:sin, Any[1.0 * x[1] + 2.0 * x[2]])
sin(0.0 + 1.0 MOI.VariableIndex(1) + 2.0 MOI.VariableIndex(2))

julia> y, ∇f, H, ∇²f = MOI.Nonlinear.SymbolicAD.gradient_and_hessian(f);

julia> y
2-element Vector{MathOptInterface.VariableIndex}:
 MOI.VariableIndex(1)
 MOI.VariableIndex(2)

julia> ∇f
2-element Vector{Any}:
 cos(0.0 + 1.0 MOI.VariableIndex(1) + 2.0 MOI.VariableIndex(2))
 *(cos(0.0 + 1.0 MOI.VariableIndex(1) + 2.0 MOI.VariableIndex(2)), 2.0)

julia> H
3-element Vector{Tuple{Int64, Int64}}:
 (1, 1)
 (1, 2)
 (2, 2)

julia> ∇²f
3-element Vector{Any}:
 -(sin(0.0 + 1.0 MOI.VariableIndex(1) + 2.0 MOI.VariableIndex(2)))
 *(-(sin(0.0 + 1.0 MOI.VariableIndex(1) + 2.0 MOI.VariableIndex(2))), 2.0)
 *(-(sin(0.0 + 1.0 MOI.VariableIndex(1) + 2.0 MOI.VariableIndex(2))), 4.0)
```

where:

 * `y` is the list of variables that appear in `f`
 * `∇f` is the first partial derivatives of `f` with respect to each variable in
   `y`
 * `H` and `∇²f` form a sparse Hessian matrix, were `H` is the `(row, column)`
   index of each element, and the corresponding element in `∇²f` is the second
   partial derivative of `f` with respect to `y[row]` and `y[column]`.

Unlike [`Nonlinear.SymbolicAD.derivative`](@ref), the gradient and Hessian
expressions have already been simplified; you do not need to call
[`Nonlinear.SymbolicAD.simplify`](@ref).

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# Implementing a bridge

The easiest way to implement a bridge is to follow an existing example. There
are three locations of bridges in the source code:

 * Constraint bridges are stored in `src/Bridges/Constraint/bridges`
 * Objective bridges are stored in `src/Bridges/Objective/bridges`
 * Variable bridges are stored in `src/Bridges/Variable/bridges`

The [Implementing a constraint bridge](@ref) tutorial has a more detailed guide
on what is required to implement a bridge.

When opening a pull request that adds a new bridge, use the checklist
[Adding a new bridge](@ref).

If you need help or advice, please contact the [Developer Chatroom](https://jump.dev/chatroom/).

## SetMap bridges

For constraint and variable bridges, a common reformulation is that ``f(x) \in F``
is reformulated to ``g(x) \in G``. In this case, no additional variables and
constraints are added, and the bridge needs only a way to map between the
functions `f` and `g` and the sets `F` and `G`.

To implementation a bridge of this form, subtype the abstract type
[`Bridges.Constraint.SetMapBridge`](@ref) or
[`Bridges.Variable.SetMapBridge`](@ref) and implement the API described in the
docstring of each type.

## `final_touch`

Some bridges require information from other parts of the model. One set of
examples are the various combinatorial `ToMILP` bridges, such as
[`Bridges.Constraint.SOS1ToMILPBridge`](@ref), which require knowledge of the
variable bounds.

Bridges requiring information from other parts of the model should implement
[`Bridges.final_touch`](@ref) and [`Bridges.needs_final_touch`](@ref).

During the bridge's construction, store the function and set and make no changes
to the underlying model. Then, in [`Bridges.final_touch`](@ref), query the
additional information and add the reformulated problem to the `model`.

When implementing, you must consider that:

 * [`Bridges.final_touch`](@ref) may be called multiple times, so that your
   reformulation should be applied only if necessary. Sometimes the additional
   data will be the same, and sometimes it may be different.
 * We do not currently support `final_touch` bridges that introduce constraints
   which also require a `final_touch` bridge. Therefore, you should implement
   `final_touch` only if necessary, and we recommend that you contact the
   [Developer Chatroom](https://jump.dev/chatroom/) for advice before doing so.

## Testing

Use the [`Bridges.runtests`](@ref) function to test a bridge. It takes three
arguments: the type of the bridge, the input model as a string, and the output
model as a string.

Here is an example:
```jldoctest; filter=[r"[0-9.]+s", r"\s+Time"]
julia> MOI.Bridges.runtests(
           MOI.Bridges.Constraint.GreaterToLessBridge,
           """
           variables: x
           x >= 1.0
           """,
           """
           variables: x
           -1.0 * x <= -1.0
           """,
       )
Test Summary:    | Pass  Total  Time
Bridges.runtests |   29     29  0.0s
```

There are a number of other useful keyword arguments.

 * `eltype` can be used to specify the element type of the model (and bridge).
   It defaults to `Float64`.
 * `variable_start` and `constraint_start` are used as the values to set the
   [`VariablePrimalStart`](@ref) and [`ConstraintPrimalStart`](@ref) attributes
   to. They default to `1.2`. If you use a different `eltype`, you must set
   appropriate starting values of the same type. The default `1.2` was chosen to
   minimize the risk that the starting point is undefined, which could happen
   for common situations like `0.0` and `1.0`. The tests associated with the
   starting values do not necessarily check for correctness, only that they can
   be `set` and `get` to produce the same result.
 * `print_inner_model` can be used to print the reformulated output model from
   the bridge. This is especially helpful during debugging to see what the
   bridge is doing, and to spot mistakes. It defaults to `false`.

Here is an example:

```jldoctest; filter=[r"[0-9.]+s", r"\s+Time"]
julia> MOI.Bridges.runtests(
           MOI.Bridges.Constraint.GreaterToLessBridge,
           """
           variables: x
           x >= 1
           """,
           """
           variables: x
           ::Int: -1 * x <= -1
           """;
           eltype = Int,
           print_inner_model = true,
           variable_start = 2,
           constraint_start = 2,
       )
Feasibility

Subject to:

ScalarAffineFunction{Int64}-in-LessThan{Int64}
 (0) - (1) x <= (-1)
Test Summary:    | Pass  Total  Time
Bridges.runtests |   29     29  0.0s
```

```@meta
CurrentModule = MathOptInterface
DocTestSetup = quote
    import MathOptInterface as MOI
end
DocTestFilters = [r"MathOptInterface|MOI"]
```

# [Nonlinear](@id nonlinear_developers)

The `Nonlinear` submodule contains data structures and functions for
working with a nonlinear optimization problem in the form of an expression
graph. This page explains the API and describes the rationale behind its design.

## Standard form

[Nonlinear programs (NLPs)](https://en.wikipedia.org/wiki/Nonlinear_programming)
are a class of optimization problems in which some of the constraints or the
objective function are nonlinear:
```math
\begin{align}
    \min_{x \in \mathbb{R}^n} & f_0(x) \\
    \;\;\text{s.t.} & l_j \le f_j(x) \le u_j & j = 1 \ldots m
\end{align}
```
There may be additional constraints, as well as things like variable bounds
and integrality restrictions, but we do not consider them here because they are
best dealt with by other components of MathOptInterface.

## API overview

The core element of the `Nonlinear` submodule is
[`Nonlinear.Model`](@ref):
```jldoctest nonlinear_developer
julia> const Nonlinear = MOI.Nonlinear;

julia> model = Nonlinear.Model()
A Nonlinear.Model with:
 0 objectives
 0 parameters
 0 expressions
 0 constraints
```
[`Nonlinear.Model`](@ref) is a mutable struct that stores all of the
nonlinear information added to the model.

### Decision variables

Decision variables are represented by [`VariableIndex`](@ref)es. The user is
responsible for creating these using `MOI.VariableIndex(i)`, where `i` is the
column associated with the variable.

### [Expressions](@id Nonlinear_Expressions)

The input data structure is a Julia `Expr`. The input expressions can
incorporate [`VariableIndex`](@ref)es, but these must be interpolated into
the expression with `$`:
```jldoctest nonlinear_developer
julia> x = MOI.VariableIndex(1)
MOI.VariableIndex(1)

julia> input = :(1 + sin($x)^2)
:(1 + sin(MathOptInterface.VariableIndex(1)) ^ 2)
```
There are a number of restrictions on the input `Expr`:
 * It cannot contain macros
 * It cannot contain broadcasting
 * It cannot contain splatting (except in limited situations)
 * It cannot contain linear algebra, such as matrix-vector products
 * It cannot contain generator expressions, including `sum(i for i in S)`

Given an input expression, add an expression using
[`Nonlinear.add_expression`](@ref):
```jldoctest nonlinear_developer
julia> expr = Nonlinear.add_expression(model, input)
MathOptInterface.Nonlinear.ExpressionIndex(1)
```
The return value, `expr`, is a [`Nonlinear.ExpressionIndex`](@ref) that can
then be interpolated into other input expressions.

Looking  again at `model`, we see:
```jldoctest nonlinear_developer
julia> model
A Nonlinear.Model with:
 0 objectives
 0 parameters
 1 expression
 0 constraints
```

### [Parameters](@id Nonlinear_Parameters)

In addition to constant literals like `1` or `1.23`, you can create parameters.
Parameters are placeholders whose values can change before passing the
expression to the solver. Create a parameter using
[`Nonlinear.add_parameter`](@ref), which accepts a default value:
```jldoctest nonlinear_developer
julia> p = Nonlinear.add_parameter(model, 1.23)
MathOptInterface.Nonlinear.ParameterIndex(1)
```
The return value, `p`, is a [`Nonlinear.ParameterIndex`](@ref) that can then be
interpolated into other input expressions.

Looking  again at `model`, we see:
```jldoctest nonlinear_developer
julia> model
A Nonlinear.Model with:
 0 objectives
 1 parameter
 1 expression
 0 constraints
```

Update a parameter as follows:
```jldoctest nonlinear_developer
julia> model[p]
1.23

julia> model[p] = 4.56
4.56

julia> model[p]
4.56
```

### [Objectives](@id Nonlinear_Objectives)

Set a nonlinear objective using [`Nonlinear.set_objective`](@ref):
```jldoctest nonlinear_developer
julia> Nonlinear.set_objective(model, :($p + $expr + $x))

julia> model
A Nonlinear.Model with:
 1 objective
 1 parameter
 1 expression
 0 constraints
```

Clear a nonlinear objective by passing `nothing`:
```jldoctest nonlinear_developer
julia> Nonlinear.set_objective(model, nothing)

julia> model
A Nonlinear.Model with:
 0 objectives
 1 parameter
 1 expression
 0 constraints
```

But we'll re-add the objective for later:
```jldoctest nonlinear_developer
julia> Nonlinear.set_objective(model, :($p + $expr + $x));
```

### [Constraints](@id Nonlinear_Constraints)

Add a constraint using [`Nonlinear.add_constraint`](@ref):
```jldoctest nonlinear_developer
julia> c = Nonlinear.add_constraint(model, :(1 + sqrt($x)), MOI.LessThan(2.0))
MathOptInterface.Nonlinear.ConstraintIndex(1)

julia> model
A Nonlinear.Model with:
 1 objective
 1 parameter
 1 expression
 1 constraint
```
The return value, `c`, is a [`Nonlinear.ConstraintIndex`](@ref) that is a unique
identifier for the constraint. Interval constraints are also supported:
```jldoctest nonlinear_developer
julia> c2 = Nonlinear.add_constraint(model, :(1 + sqrt($x)), MOI.Interval(-1.0, 2.0))
MathOptInterface.Nonlinear.ConstraintIndex(2)

julia> model
A Nonlinear.Model with:
 1 objective
 1 parameter
 1 expression
 2 constraints
```

Delete a constraint using [`Nonlinear.delete`](@ref):
```jldoctest nonlinear_developer
julia> Nonlinear.delete(model, c2)

julia> model
A Nonlinear.Model with:
 1 objective
 1 parameter
 1 expression
 1 constraint
```

### User-defined operators

By default, `Nonlinear` supports a wide range of univariate and multivariate
operators. However, you can also define your own operators by _registering_
them.

#### Univariate operators

Register a univariate user-defined operator using
[`Nonlinear.register_operator`](@ref):
```jldoctest nonlinear_developer
julia> f(x) = 1 + sin(x)^2
f (generic function with 1 method)

julia> Nonlinear.register_operator(model, :my_f, 1, f)
```
Now, you can use `:my_f` in expressions:
```jldoctest nonlinear_developer
julia> new_expr = Nonlinear.add_expression(model, :(my_f($x + 1)))
MathOptInterface.Nonlinear.ExpressionIndex(2)
```
By default, `Nonlinear` will compute first- and second-derivatives of the
registered operator using [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl).
Override this by passing functions which compute the respective derivative:
```jldoctest nonlinear_developer
julia> f′(x) = 2 * sin(x) * cos(x)
f′ (generic function with 1 method)

julia> Nonlinear.register_operator(model, :my_f2, 1, f, f′)
```
or
```jldoctest nonlinear_developer
julia> f′′(x) = 2 * (cos(x)^2 - sin(x)^2)
f′′ (generic function with 1 method)

julia> Nonlinear.register_operator(model, :my_f3, 1, f, f′, f′′)
```

#### Multivariate operators

Register a multivariate user-defined operator using
[`Nonlinear.register_operator`](@ref):
```jldoctest nonlinear_developer
julia> g(x...) = x[1]^2 + x[1] * x[2] + x[2]^2
g (generic function with 1 method)

julia> Nonlinear.register_operator(model, :my_g, 2, g)
```
Now, you can use `:my_g` in expressions:
```jldoctest nonlinear_developer
julia> new_expr = Nonlinear.add_expression(model, :(my_g($x + 1, $x)))
MathOptInterface.Nonlinear.ExpressionIndex(3)
```
By default, `Nonlinear` will compute the gradient of the registered
operator using [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl).
(Hessian information is not supported.) Override this by passing a function to
compute the gradient:
```jldoctest nonlinear_developer
julia> function ∇g(ret, x...)
           ret[1] = 2 * x[1] + x[2]
           ret[2] = x[1] + 2 * x[2]
           return
       end
∇g (generic function with 1 method)

julia> Nonlinear.register_operator(model, :my_g2, 2, g, ∇g)
```

### [MathOptInterface](@id Nonlinear_MOI_interface)

MathOptInterface communicates the nonlinear portion of an optimization problem
to solvers using concrete subtypes of [`AbstractNLPEvaluator`](@ref), which
implement the [Nonlinear programming](@ref) API.

Create an [`AbstractNLPEvaluator`](@ref) from [`Nonlinear.Model`](@ref) using
[`Nonlinear.Evaluator`](@ref).

[`Nonlinear.Evaluator`](@ref) requires an
[`Nonlinear.AbstractAutomaticDifferentiation`](@ref) backend and an ordered list
of the variables that are included in the model.

There following backends are available to choose from within MOI, although other
packages may add more options by sub-typing
[`Nonlinear.AbstractAutomaticDifferentiation`](@ref):
 * [`Nonlinear.ExprGraphOnly`](@ref)
 * [`Nonlinear.SparseReverseMode`](@ref).

```jldoctest nonlinear_developer
julia> evaluator = Nonlinear.Evaluator(model, Nonlinear.ExprGraphOnly(), [x])
Nonlinear.Evaluator with available features:
  * :ExprGraph
```
The functions of the [Nonlinear programming](@ref) API implemented by
[`Nonlinear.Evaluator`](@ref) depends upon the chosen
[`Nonlinear.AbstractAutomaticDifferentiation`](@ref) backend.

The `:ExprGraph` feature means we can call [`objective_expr`](@ref) and
[`constraint_expr`](@ref) to retrieve the expression graph of the problem.
However, we cannot call gradient terms such as
[`eval_objective_gradient`](@ref) because [`Nonlinear.ExprGraphOnly`](@ref) does
not have the capability to differentiate a nonlinear expression.

If, instead, we pass [`Nonlinear.SparseReverseMode`](@ref), then we get access
to `:Grad`, the gradient of the objective function, `:Jac`, the Jacobian matrix
of the constraints, `:JacVec`, the ability to compute Jacobian-vector products,
and `:ExprGraph`.
```jldoctest nonlinear_developer
julia> evaluator = Nonlinear.Evaluator(
           model,
           Nonlinear.SparseReverseMode(),
           [x],
       )
Nonlinear.Evaluator with available features:
  * :Grad
  * :Jac
  * :JacVec
  * :ExprGraph
```

However, before using the evaluator, we need to call [`initialize`](@ref):
```jldoctest nonlinear_developer
julia> MOI.initialize(evaluator, [:Grad, :Jac, :JacVec, :ExprGraph])
```

Now we can call methods like [`eval_objective`](@ref):
```jldoctest nonlinear_developer
julia> x = [1.0]
1-element Vector{Float64}:
 1.0

julia> MOI.eval_objective(evaluator, x)
7.268073418273571
```
and [`eval_objective_gradient`](@ref):
```jldoctest nonlinear_developer
julia> grad = [0.0]
1-element Vector{Float64}:
 0.0

julia> MOI.eval_objective_gradient(evaluator, grad, x)

julia> grad
1-element Vector{Float64}:
 1.909297426825682
```

Instead of passing [`Nonlinear.Evaluator`](@ref) directly to solvers,
solvers query the [`NLPBlock`](@ref) attribute, which returns an
[`NLPBlockData`](@ref). This object wraps an [`Nonlinear.Evaluator`](@ref) and
includes other information such as constraint bounds and whether the evaluator
has a nonlinear objective. Create and set [`NLPBlockData`](@ref) as follows:
```jldoctest nonlinear_developer
julia> block = MOI.NLPBlockData(evaluator);

julia> model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}());

julia> MOI.set(model, MOI.NLPBlock(), block);
```
!!! warning
    Only call [`NLPBlockData`](@ref) once you have finished modifying the
    problem in `model`.

Putting everything together, you can create a nonlinear optimization problem in
MathOptInterface as follows:
```@example
import MathOptInterface as MOI

function build_model(
    model::MOI.ModelLike;
    backend::MOI.Nonlinear.AbstractAutomaticDifferentiation,
)
    x = MOI.add_variable(model)
    y = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    nl_model = MOI.Nonlinear.Model()
    MOI.Nonlinear.set_objective(nl_model, :($x^2 + $y^2))
    evaluator = MOI.Nonlinear.Evaluator(nl_model, backend, [x, y])
    MOI.set(model, MOI.NLPBlock(), MOI.NLPBlockData(evaluator))
    return
end

# Replace `model` and `backend` with your optimizer and backend of choice.
model = MOI.Utilities.UniversalFallback(MOI.Utilities.Model{Float64}())
build_model(model; backend = MOI.Nonlinear.SparseReverseMode())
```

## Expression-graph representation

[`Nonlinear.Model`](@ref) stores nonlinear expressions in
[`Nonlinear.Expression`](@ref)s. This section explains the design of
the expression graph data structure in [`Nonlinear.Expression`](@ref).

Given a nonlinear function like `f(x) = sin(x)^2 + x`, a conceptual aid for
thinking about the graph representation of the expression is to convert it into
[Polish prefix notation](https://en.wikipedia.org/wiki/Polish_notation):
```
f(x, y) = (+ (^ (sin x) 2) x)
```
This format identifies each operator (function), as well as a list of arguments.
Operators can be univariate, like `sin`, or multivariate, like `+`.

A common way of representing Polish prefix notation in code is as follows:
```jldoctest expr_graph
julia> x = MOI.VariableIndex(1);

julia> struct ExprNode
           op::Symbol
           children::Vector{Union{ExprNode,Float64,MOI.VariableIndex}}
       end

julia> expr = ExprNode(:+, [ExprNode(:^, [ExprNode(:sin, [x]), 2.0]), x]);
```

This data structure follows our Polish prefix notation very closely, and we can
easily identify the arguments to an operator. However, it has a significant
draw-back: each node in the graph requires a `Vector`, which is heap-allocated
and tracked by Julia's garbage collector (GC). For large models, we can expect
to have millions of nodes in the expression graph, so this overhead quickly
becomes prohibitive for computation.

An alternative is to record the expression as a linear tape:
```jldoctest expr_graph
julia> expr = Any[:+, 2, :^, 2, :sin, 1, x, 2.0, x]
9-element Vector{Any}:
  :+
 2
  :^
 2
  :sin
 1
  MOI.VariableIndex(1)
 2.0
  MOI.VariableIndex(1)
```
The `Int` after each operator `Symbol` specifies the number of arguments.

This data-structure is a single vector, which resolves our problem with the GC,
but each element is the abstract type, `Any`, and so any operations on it will
lead to slower dynamic dispatch. It's also hard to identify the children of each
operation without reading the entire tape.

To summarize, representing expression graphs in Julia has the following
challenges:
 * Nodes in the expression graph should not contain a heap-allocated object
 * All data-structures should be concretely typed
 * It should be easy to identify the children of a node

### Sketch of the design in Nonlinear

`Nonlinear` overcomes these problems by decomposing the data structure into a
number of different concrete-typed vectors.

First, we create vectors of the supported uni- and multivariate operators.
```jldoctest expr_graph
julia> const UNIVARIATE_OPERATORS = [:sin];

julia> const MULTIVARIATE_OPERATORS = [:+, :^];
```
In practice, there are many more supported operations than the ones listed here.

Second, we create an enum to represent the different types of nodes present in
the expression graph:
```jldoctest expr_graph
julia> @enum(
           NodeType,
           NODE_CALL_MULTIVARIATE,
           NODE_CALL_UNIVARIATE,
           NODE_VARIABLE,
           NODE_VALUE,
       )
```
In practice, there are node types other than the ones listed here.

Third, we create two concretely typed structs as follows:
```jldoctest expr_graph
julia> struct Node
           type::NodeType
           parent::Int
           index::Int
       end

julia> struct Expression
           nodes::Vector{Node}
           values::Vector{Float64}
       end
```

For each node `node` in the `.nodes` field, if `node.type` is:

 * `NODE_CALL_MULTIVARIATE`, we look up
   `MULTIVARIATE_OPERATORS[node.index]` to retrieve the operator
 * `NODE_CALL_UNIVARIATE`, we look up
   `UNIVARIATE_OPERATORS[node.index]` to retrieve the operator
 * `NODE_VARIABLE`, we create `MOI.VariableIndex(node.index)`
 * `NODE_VALUE`, we look up `values[node.index]`

The `.parent` field of each node is the integer index of the parent node in
`.nodes`. For the first node, the parent is `-1` by convention.

Therefore, we can represent our function as:
```jldoctest expr_graph
julia> expr = Expression(
           [
               Node(NODE_CALL_MULTIVARIATE, -1, 1),
               Node(NODE_CALL_MULTIVARIATE, 1, 2),
               Node(NODE_CALL_UNIVARIATE, 2, 1),
               Node(NODE_VARIABLE, 3, 1),
               Node(NODE_VALUE, 2, 1),
               Node(NODE_VARIABLE, 1, 1),
           ],
           [2.0],
       );
```

The ordering of the nodes in the tape must satisfy two rules:

 * The children of a node must appear after the parent. This means that the tape
   is ordered topologically, so that a reverse pass of the nodes evaluates all
   children nodes before their parent
 * The arguments for a `CALL` node are ordered in the tape based on the order in
   which they appear in the function call.

#### Design goals

This is less readable than the other options, but does this data structure meet
our design goals?

Instead of a heap-allocated object for each node, we only have two `Vector`s for
each expression, `nodes` and `values`, as well as two constant vectors for the
`OPERATORS`. In addition, all fields are concretely typed, and there are no
`Union` or `Any` types.

For our third goal, it is not easy to identify the children of a node, but it is
easy to identify the _parent_ of any node. Therefore, we can use
[`Nonlinear.adjacency_matrix`](@ref) to compute a sparse matrix that maps
parents to their children.

### The design in practice

In practice, `Node` and `Expression` are exactly [`Nonlinear.Node`](@ref)
and [`Nonlinear.Expression`](@ref). However, [`Nonlinear.NodeType`](@ref)
has more fields to account for comparison operators such as `:>=` and `:<=`,
logic operators such as `:&&` and `:||`, nonlinear parameters, and nested
subexpressions.

Moreover, instead of storing the operators as global constants, they are stored
in [`Nonlinear.OperatorRegistry`](@ref), and it also stores a vector of logic
operators and a vector of comparison operators. In addition to
[`Nonlinear.DEFAULT_UNIVARIATE_OPERATORS`](@ref) and
[`Nonlinear.DEFAULT_MULTIVARIATE_OPERATORS`](@ref), you can register
user-defined functions using [`Nonlinear.register_operator`](@ref).

[`Nonlinear.Model`](@ref) is a struct that stores the
[`Nonlinear.OperatorRegistry`](@ref), as well as a list of parameters and
subexpressions in the model.

## ReverseAD

`Nonlinear.ReverseAD` is a submodule for computing derivatives of a nonlinear
optimization problem using sparse reverse-mode automatic differentiation (AD).

This section does not attempt to explain how sparse reverse-mode AD works, but
instead explains why MOI contains its own implementation, and highlights
notable differences from similar packages.

!!! warning
    Don't use the API in `ReverseAD` to compute derivatives. Instead, create a
    [`Nonlinear.Evaluator`](@ref) object with [`Nonlinear.SparseReverseMode`](@ref)
    as the backend, and then query the MOI API methods.

### Design goals

The JuliaDiff organization maintains a [list of packages](https://juliadiff.org)
for doing AD in Julia. At last count, there were at least ten packages——not
including `ReverseAD`——for reverse-mode AD in Julia. `ReverseAD` exists because
it has a different set of design goals.

 * **Goal: handle scale and sparsity.**
   The types of nonlinear optimization problems that MOI represents can be large
   scale (10^5 or more functions across 10^5 or more variables) with very sparse
   derivatives. The ability to compute a sparse Hessian matrix is essential. To
   the best of our knowledge, `ReverseAD` is the only reverse-mode AD system in
   Julia that handles sparsity by default.
 * **Goal: limit the scope to improve robustness.**
   Most other AD packages accept arbitrary Julia functions as input and then
   trace an expression graph using operator overloading. This means they must
   deal (or detect and ignore) with control flow, I/O, and other vagaries of
   Julia. In contrast, `ReverseAD` only accepts functions in the form of
   [`Nonlinear.Expression`](@ref), which greatly limits the range of syntax that
   it must deal with. By reducing the scope of what we accept as input to
   functions relevant for mathematical optimization, we can provide a simpler
   implementation with various performance optimizations.
 * **Goal: provide outputs which match what solvers expect.**
   Other AD packages focus on differentiating individual Julia functions. In
   contrast, `ReverseAD` has a very specific use-case: to generate outputs
   needed by the MOI nonlinear API. This means it needs to efficiently compute
   sparse Hessians, and it needs subexpression handling to avoid recomputing
   subexpressions that are shared between functions.

### History

`ReverseAD` started life as [ReverseDiffSparse.jl](https://github.com/mlubin/ReverseDiffSparse.jl),
development of which began in early 2014(!). This was well before the other
AD packages started development. Because we had a well-tested, working AD in JuMP,
there was less motivation to contribute to and explore other AD packages. The
lack of historical interaction also meant that other packages were not optimized
for the types of problems that JuMP is built for (that is, large-scale sparse
problems). When we first created MathOptInterface, we kept the AD in JuMP to
simplify the transition, and post-poned the development of a first-class
nonlinear interface in MathOptInterface.

Prior to the introduction of `Nonlinear`, JuMP's nonlinear implementation was a
confusing mix of functions and types spread across the code base and in the
private `_Derivatives` submodule. This made it hard to swap the AD system for
another. The main motivation for refactoring JuMP to create the `Nonlinear`
submodule in MathOptInterface was to abstract the interface between JuMP and the
AD system, allowing us to swap-in and test new AD systems in the future.

# The LP file format

The purpose of this page is to document the LP file format, and the various
differences that occur between solvers.

## Resources

There are a bunch of different descriptions of the LP file format on the
internet.

 * [CPLEX](https://www.ibm.com/docs/en/icos/22.1.0?topic=cplex-lp-file-format-algebraic-representation)
 * [FICO](https://www.fico.com/fico-xpress-optimization/docs/dms2021-01/solver/optimizer/HTML/chapter10_sec_section102.html)
 * [Gurobi](https://docs.gurobi.com/projects/optimizer/en/current/reference/fileformats/modelformats.html#lp-format)
 * [lpsolve](https://lpsolve.sourceforge.net/5.5/CPLEX-format.htm)
 * [Mosek](https://docs.mosek.com/11.0/capi/lp-format.html)
 * [QSopt](https://www.math.uwaterloo.ca/~bico/qsopt/hlp/ff_lp_format.htm)

## Grammar

This section gives the grammar of an LP file as we implement it. This grammar
may be different to that of particular solvers.

The syntax rules for the grammar are:

 * `<name>`: the name of a symbol in the grammar
 * `A :== B`: A is equivalent to B
 * `A | B`: either A or B
 * `i""`: case insensitive string
 * `[A]`: A is optional
 * `(A)*`: there are 0 or more repeats of A
 * `(A)+`: there is at least one or more repeats of A

In addition to the grammar, there are the following rules:

 * Comments begin with `\`, and run until the next `\n` character
 * Whitespace is ignored
 * Newlines are ignored, except where explicitly described

```
<lp-file> :==
    <keyword-objective>\n
    [<section-objective>\n]
    <keyword-constraints>\n
    (<constraint>)*
    [<keyword-bounds>\n (<bound-expression>)+]
    [<keyword-general>\n (<identifier>)+]
    [<keyword-binary>\n (<identifier>)+]
    [<keyword-sos>\n (<constraint-sos>)+]
    [<keyword-end>]

<keyword-objective> :==
    i"min" | i"minimum" | i"minimize" | i"minimise"
  | i"max" | i"maximum" | i"maximize" | i"maximise"

<keyword-constraints> :==
    (i"subject to" | i"st" | i"st." | i"s.t." | i"such that")[":"]

<keyword-bounds> :== i"bound" | i"bounds"

<keyword-general> :== i"gen" | i"general" | i"generals"

<keyword-binary> :== i"bin" | i"binary" | i"binaries"

<keyword-sos> :== i"sos"

<keyword-end> :== i"end"

<digit> :== "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9"

<char> :== a-z | A-Z | !"#$%&()/,;?@_'`|~

<identifier> :== <char> (<char> | <digit> | ".")*

<number> :==
    "+" <number>
  | "-" <number>
  | <digit>+[.(<digit>)*][("e" | "E")("+" | "-")(<digit>)+]
  | i"inf"
  | i"infinity"

<quadratic-term> :==
    "+" <quadratic-term>
  | "-" <quadratic-term>
  | [<number> ["*"]] <identifier> "^" "2"
  | [<number> ["*"]] <identifier> "*" <identifier>

<quadratic-expression> :==
    "[" <quadratic-term> (("+" | "-") <quadratic-term>)* "]" ["/" "2"]

<term> :==
    "+" <term>
  | "-" <term>
  | <identifier>
  | <number>
  | <number> <identifier>
  | <number> "*" <identifier>
  | <quadratic-expression>

<expression> :== <term> (("+" | "-") <term>)*

<name> :== [<identifier>":"]

<objective> :== <name> [<expression>]

<inequality> :== "<" | "<=" | "=<" | ">" | ">=" | "=>" | "=" | "=="

<set-suffix> := <inequality> <number>

<set-prefix> := <number> <inequality>

<constraint-indicator> :== <identifier> "=" (0 | 1) "->" <expression> <set-suffix>

<constraint-sos> :==
    "S1::" (<identifier>":"<number>)+\n
  | "S2::" (<identifier>":"<number>)+\n

<constraint> :==
    <name> <expression> <set-suffix>
  | <name> <constraint-indicator>
  | <name> <sos-constraint>

<bound-expression> :==
    <identifier> i"free"
  | <identifier> <set-suffix>
  | <set-prefix> <identifier>
  | <set-prefix> <identifier> <set-suffix>
```

## Differences

There are many differences in how solvers parse an LP file.

### The "integer" section

Consider the section:
```
integers
x
```
Gurobi will interpret this as `x in MOI.Integer()`. FICO Xpress will interpret
this as `x in MOI.ZeroOne()`.

FICO document this behavior, but they're an outlier.

**We choose to interpret `integers` as `MOI.Integer()`.**

### Whether variables can have the same name as a keyword

Consider the file
```
min
st
st
st >= 0
end
```
or even the horrific
```
min st st st >= 0 end
```
Gurobi will complain up front that the keyword `st` appears twice, whereas
Xpress will read the file as equivalent to :
```
minimize
x
subject to
x >= 0
end
```

**We choose to allow variables to be named as keywords, and we use context to
disambiguate.**

### Whitespace

Consider the file
```
minimize
  2x
end
```

Gurobi will interpret this as a single variable with the name `2x`, where as
Xpress will interpret this as the expression `2 * x`.

Gurobi document this behavior, saying that they require whitespace around all
tokens, but they're an outlier.

**We choose to allow juxtaposed tokens without whitespace.**

### Identifiers

In general, an identifier may contain the letters a-z, A-Z, the digits 0-9, and
the characters ```!"#\$%&()/,.;?@_'`|~```.

Additional solvers put additional restrictions:

 * In (all?) solvers except Gurobi, the identifier must not start with a digit
   or a `.` (in Gurobi, identifiers must be separated by whitespace)
 * Identifiers in Mosek and lpsolve may not start with the letter e or E
 * Keywords must not be used as names in Gurobi or Mosek, but they may in Xpress
 * Many solvers _actually_ support reading any UTF-8 string as the identifier,
   but they will normalize to the legal letters on write

**We choose to allow any valid UTF-8 names.**
